#ifndef AVHRR_H
#define AVHRR_H


#define MAX_SCAN_ANGLE  0.966643624  /* Maximum scan angle (radians)	     */

#define SAT_TAN_ANGLE   1.080948479  /* Angle from the satellite to the line */
				     /* tangent to the earth		     */

#define MAX_EC_ANGLE    0.489847847  /* Maximum earth central angle to the   */
				     /* satellite angle tangent to the earth */

#define VEL_ANGLE	1.570796327  /* Approx angle between velocity vector */
				     /* and position vector		     */

#define GAC_SAMPLE_SLOPE 211.7636714 /* GAC pixels per radian (LAC)	     */
#define LAC_SAMPLE_SLOPE 1058.818357 /* LAC pixels per radian (LAC)	     */

#define SAT_VELOCITY	6.6	     /* Satellite groud velocity (KM/Seconds)*/
#define SAT_ALTITUDE	850.0	     /* Approx. satellite altitude (KM)	     */
#define MOYAW		0.000233874  /* Yaw due to motion of satellite (rads)*/

#define LAC_PER_SEC	6.0	     /* Number of LAC lines per second	     */
#define GAC_PER_SEC	2.0	     /* Number of GAC lines per second	     */
#define GAC_SUB_SAMP	5.0	     /* GAC subsampled factor		     */

#define LAC_SAMPS	2048	     /* Number of LAC samples in a line	     */
#define GAC_SAMPS	409	     /* Number of GAC samples in a line	     */

#define LAC_NADIR	1024.5	     /* LAC nadir sample		     */
#define GAC_NADIR	205.0	     /* GAC nadir sample		     */

#define NCHANS		5	     /* Number of channels in an image	     */
#define NBYTES		2	     /* Number of bytes per sample	     */

#define SEC_PER_DAY	86400	     /* Seconds Per Day			     */
#define MIL_PER_DAY	86400000     /* Milliseconds Per Day		     */
#define MIL_PER_HOUR	3600000	     /* Milliseconds Per Hour		     */
#define MIL_PER_MIN	60000	     /* Milliseconds Per Hour		     */
#define MIL_PER_SEC	1000	     /* Milliseconds Per Second		     */

#define LAC		1	     /* Local Area Coverage image type	     */
#define GAC		2	     /* Global Area Coverage image type	     */
#define HRPT		3	     /* High Resolution Picture Transmission */

#define DESCENDING	-1	     /* Descending pass direction	     */
#define ASCENDING	 1	     /* Ascending pass direction	     */

#define	DAY		 1	     /* Day pass indicator		     */
#define NIGHT		-1	     /* Night pass indicator		     */

#endif
