#!/bin/csh -f
#
# FUNCTION: get_num.csh
#
# PURPOSE:  Get current number of images received, increment this
#           number by one, and return the number as 3 digits.
#
#
# Programmer       Date   Modifications
# ---------------  -----  ------------------------------------------------------
# J.Fenno          12/92  Development
# J.Fenno          12/92  Changed so that the directory containing the file
#                         nimages is passed as an argument.
#
#


#--------------------------------------------------------
# Retrieve the number of images already received from LSU
#--------------------------------------------------------
set filename = $1/nimages
set num = `cat $filename`


#-----------------------------------------------------------------
# Add 1 to this number and if it is greater than 999 reset it to 1
#-----------------------------------------------------------------
@ num += 1
if ($num > 999) then
    @ num = 1
endif


#---------------------------------------------
# Store the new number in the appropriate file
#---------------------------------------------
echo $num > $filename


#--------------------------------------
# Return the number as a 3 digit number
#--------------------------------------
if ($num < 10) then
    echo "00$num"
else if ($num < 100) then
    echo "0$num"
else
    echo $num
endif
