#!/bin/sh
#
#  This script will ftp 'put' a binary file to a remote system.
#
#  USAGE: ftp_put.sh <user> <passwd> <remotesystem> <directory> <filename>
#
#  where   <user>         is the user id
#	   <passwd>       is the user's password
#          <remotesystem> is the remote system to ftp to.
#	   <directory>    is the name of the directory to put it in.
#	   <filename>     is the name of the file to try to ftp.
#
#
user=$1
passwd=$2
remotesys=$3
directory=$4
filename=$5

# find the name NOAA wants.
noaaname=`dd if=$filename bs=1 skip=22 count=42`
cp $filename $noaaname

echo "open ${remotesys}
      user ${user} ${passwd}
      type binary
      prompt
      cd ${directory}
      mput "${noaaname}"
      bye" | ftp -n -v 2>&1 | grep -i "TRANSFER COMPLETE" > /dev/null
if test $? -ne 0
then
   echo "Transfer failed:  mput ${filename}"
   rm $noaaname
   exit 1
else
   echo "Transfer completed:  mput ${filename}"
   rm $noaaname
   exit 0
fi

