#!/usr/local/bin/perl
#
#This script is used to clean old releases out of the release directories
#

# set the number of days a file is allowed to remain in the release directory
$days = 7;

# set the list of directories to clean up
@dirs = ($ENV{'LASBASE'}, $ENV{'LASLOCAL'}, $ENV{'LASCONTRIB'},
         $ENV{'ADAPSBASE'}, $ENV{'ADAPSLOCAL'}, $ENV{'ADAPSCONTRIB'},
	 $ENV{'ADAPSTABLES'}, $ENV{'LASTABLES'});

# process each of the directories 
foreach (@dirs)
{
    # look in the release directory
    $release_dir = $_ . "/release";

    # for each directory, make sure the directory is outdated
    foreach $dir (<$release_dir/*>)
    {
        
        # determine if all the files in the directory are old
        $old = 1;
        foreach  $file (<$dir/*>)
        {
            if ((-M $file) <= $days)
            {
                $old = 0;
                last;
            }
        }

        if ($old)
        {
            system ("rm -r $dir");
        }
    }
}
