#!/bin/csh
#
# Function: lasdir_setup.csh
#
# Purpose:  Setup the directory structures required to build, release, and
#           run LAS, ADAPS, and AIRCRAFT.  This includes; the includes,
#           libraries, documentation, and run directories.
#
# SOURCE
mkdir -p src

# ADAPS INCLUDE/LIB
mkdir -p build/adaps/include/old
mkdir -p build/adaps/include/release
mkdir -p build/adaps/lib/old
mkdir -p build/adaps/lib/release

# AIRCRAFT INCLUDE/LIB
mkdir -p build/aircraft/include/old
mkdir -p build/aircraft/include/release
mkdir -p build/aircraft/lib/old
mkdir -p build/aircraft/lib/release

# CONTRIB INCLUDE/LIB
mkdir -p build/contrib/include
mkdir -p build/contrib/lib

# LAS INCLUDE/LIB
mkdir -p build/las/include/old
mkdir -p build/las/include/release
mkdir -p build/las/lib/release
mkdir -p build/las/lib/old

# NETWORK TAPE Directory
mkdir -p build/enet/include

# LAS/ADAPS ENVIRONMENT
mkdir -p env/adaps/assign
mkdir -p env/adaps/logfiles
mkdir -p env/adaps/tables
mkdir -p env/las/assign
mkdir -p env/las/logfiles
mkdir -p env/las/tables

# AIRCRAFT RUN
mkdir -p run/aircraft/base/old
mkdir -p run/aircraft/base/release
mkdir -p run/aircraft/contrib/old
mkdir -p run/aircraft/contrib/release
mkdir -p run/aircraft/local/old
mkdir -p run/aircraft/local/release

# ADAPS RUN
mkdir -p run/adaps/base/old
mkdir -p run/adaps/base/release
mkdir -p run/adaps/contrib/old
mkdir -p run/adaps/contrib/release
mkdir -p run/adaps/local/old
mkdir -p run/adaps/local/release

# LAS/ADAPS BIN (LASTOOLS)
mkdir -p run/bin

# LAS RUN
mkdir -p run/las/base/old
mkdir -p run/las/base/release
mkdir -p run/las/contrib/old
mkdir -p run/las/contrib/release
mkdir -p run/las/local/old
mkdir -p run/las/local/release
mkdir -p run/las/ditto/old
mkdir -p run/las/ditto/release
mkdir -p run/las/ditty

# DOCUMENTATION
mkdir -p run/las/doc/manager
mkdir -p run/las/doc/overview/geomreg
mkdir -p run/las/doc/overview/gif
mkdir -p run/las/doc/overview/lasover
mkdir -p run/las/doc/programmer/includes/FORTRAN_INCLUDES
mkdir -p run/las/doc/programmer/supports/alias
mkdir -p run/las/doc/programmer/supports/ddr
mkdir -p run/las/doc/programmer/supports/dltf
mkdir -p run/las/doc/programmer/supports/error
mkdir -p run/las/doc/programmer/supports/filenm
mkdir -p run/las/doc/programmer/supports/georeg
mkdir -p run/las/doc/programmer/supports/gofio
mkdir -p run/las/doc/programmer/supports/imageio
mkdir -p run/las/doc/programmer/supports/lablserv
mkdir -p run/las/doc/programmer/supports/labltabl
mkdir -p run/las/doc/programmer/supports/math
mkdir -p run/las/doc/programmer/supports/pixman
mkdir -p run/las/doc/programmer/supports/statio
mkdir -p run/las/doc/programmer/supports/tapeio
mkdir -p run/las/doc/programmer/supports/unixdisk
mkdir -p run/las/doc/programmer/supports/utility
mkdir -p run/las/doc/tiepts
mkdir -p run/las/doc/user/local
mkdir -p run/las/doc/xid
mkdir -p run/las/doc/adaps/config
mkdir -p run/las/doc/adaps/manager
mkdir -p run/las/doc/adaps/navigation
mkdir -p run/las/doc/adaps/operations
mkdir -p run/las/doc/adaps/overview
mkdir -p run/las/doc/adaps/programmer/includes
mkdir -p run/las/doc/adaps/programmer/supports/acqio
mkdir -p run/las/doc/adaps/programmer/supports/adaps
mkdir -p run/las/doc/adaps/programmer/supports/archio
mkdir -p run/las/doc/adaps/programmer/supports/geolib
mkdir -p run/las/doc/adaps/programmer/supports/model
mkdir -p run/las/doc/adaps/programmer/supports/products
mkdir -p run/las/doc/adaps/programmer/supports/queue
mkdir -p run/las/doc/adaps/programmer/supports/util
mkdir -p run/las/doc/adaps/stitch
mkdir -p run/las/doc/adaps/user/local
mkdir -p run/las/doc/adaps/xsched

# DDP RUN
mkdir -p run/las/ddp

# AVHRR OPERATIONAL DIRECTORIES
mkdir -p avhrr/acquire
mkdir -p avhrr/archive/esa/sfl
mkdir -p avhrr/archive/forms
mkdir -p avhrr/archive/prodgen
mkdir -p avhrr/archive/sfl/km1
mkdir -p avhrr/archive/sfl/sfl
mkdir -p avhrr/browse/archive
mkdir -p avhrr/browse/back
mkdir -p avhrr/dbdata/old
mkdir -p avhrr/dbtemp
mkdir -p avhrr/error/prodgen
mkdir -p avhrr/fax
mkdir -p avhrr/images
mkdir -p avhrr/ingest
mkdir -p avhrr/log
mkdir -p avhrr/micro/cd
mkdir -p avhrr/micro/tape
mkdir -p avhrr/orbit/error
mkdir -p avhrr/orbit/esaerr
mkdir -p avhrr/orbit/esameta
mkdir -p avhrr/orbit/esaorb
mkdir -p avhrr/orbit/lndetect
mkdir -p avhrr/orbit/orbits
mkdir -p avhrr/orbit/process
mkdir -p avhrr/prod

# PROTECTIONS
chmod 777 env/las/logfiles
chmod 777 env/adaps/logfiles
chmod 777 env/adaps/tables
chmod 770 run/adaps/base/old
chmod 770 run/adaps/base/release
chmod 770 run/adaps/contrib/old
chmod 770 run/adaps/contrib/release
chmod 770 run/adaps/local/old
chmod 770 run/adaps/local/release
chmod 770 run/las/base/old
chmod 770 run/las/base/release
chmod 770 run/las/contrib/old
chmod 770 run/las/contrib/release
chmod 770 run/las/local/old
chmod 770 run/las/local/release
chmod 777 run/las/ditty
