#ifndef ELLIPSOID_H
#define ELLIPSOID_H


/* clark 1866  */
#define REQUA 6378206.4		/* Radius of the earth at equator    */
#define RPOLE 6356583.8		/* Radius of the earth at pole	     */
#define F (1.0 / 294.9786982)		/* Flattening of the earth	     */

/* wgs 72 */
/* #define REQUA 6378135.0		   Radius of the earth at equator    */
/* #define RPOLE 6356750.5		   Radius of the earth at pole	     */
/* #define F (1.0 / 298.2597209)	   Flattening of the earth	     */

/* GEM 6 */
/* #define REQUA 6378144.0		   Radius of the earth at equator    */
/* #define RPOLE 6356755.0		   Radius of the earth at equator    */
/* #define F (1.0 / 298.1973912)	   Flattening of the earth	     */

#define RPSQR (RPOLE*RPOLE)		/* RPOLE squared   */
#define RESQR (REQUA*REQUA)		/* REQUA squared   */
#define EE (2.0 * F - F * F)
#define Q (1.0 - EE) 

#endif
