/* Include file used for orbital stitching software */

#include "archio.h"


/* Information from one line of the orbital stitch */
/* list needed to accomplish orbital stitching.	   */

struct TAPESTR
    {
    char tapeid[7];	/* tape id	*/
    char sceneid[17];	/* scene id	*/
    char srclnk[7];	/* source link	*/
    char stoptm[7];	/* stop time HHMMSS */
    char locflg;	/* location flag */
    char lndflg;	/* line detect flag */
    char orbflg;	/* stitch flag	*/
    };


/* Information from one line of the orbital stitch */
/* list needed to determine GOODES projection	   */
/* regions.					   */

struct ONELN
    {
    long satnum;	/* satellite number	*/
    long year;		/* acquire year		*/
    long month;		/* acquire month	*/
    long day;		/* acquire day		*/
    long shour;		/* starting hour	*/
    long smin;		/* starting minute	*/
    long ssec;		/* starting second	*/
    long sfrac;		/* starting frac second	*/
    long dtype;		/* data type LAC(1) GAC(2) HRPT(3)	*/
    long nlines;	/* number of lines	*/
    long start_sec;	/* start time in seconds */
    long end_sec;	/* end time in seconds	*/
    };


#define LINELEN 54	/* Orbital stitch list line length */

#define MAX_PASS 20	/* Maximum scenes per half orbit   */

#define E_FEND 	 2	/* EOF return status */

#ifndef SEEK_CUR
#define SEEK_CUR 1	/* File seek definition */
#endif

