
#include "las.h"
#include "desc.h"
#include "alias.h"

#ifdef unix
/*  Fortran bridge routine for unix  */
#ifdef _IBMR2
#define getalias_ getalias
#endif
int getalias_
(
    char *instring,
    char *outstring,
    long in_len,
    long out_len
)
{
char *in_ptr;
char *out_ptr;
long status;

in_ptr = squeeze(instring,in_len);
out_ptr = squeeze(outstring,out_len);

status = c_getalias(in_ptr,out_ptr);

free(in_ptr);
free(out_ptr);

return(status);
}
#endif

#ifdef vms
/*  Fortran bridge routine for the VAX  */
int getalias
(
    struct DESC *instring,
    struct DESC *outstring
)
{
char *in_ptr;
char *out_ptr;
long nonfatal = 1;
long status;

in_ptr = squeeze(instring->addr,instring->length);
out_ptr = squeeze(outstring->addr,outstring->length);

status = c_getalias(in_ptr,out_ptr);

if (free(in_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","getalias-free",&nonfatal);

if (free(out_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","getalias-free",&nonfatal);

return(status);
}
#endif
