#ifndef DISKIO_H
#define DISKIO_H

/* Return status values from disk handling routines */
#define DISK_GONE        -3    /* File does not exist                */
#define DISK_EXISTS      -2          /* File exists                       */
#define DISK_NOSPACE     -4          /* No space for file                 */
#define MAXPATH          50          /* Maximum number of paths           */

/* NOTE:  should be able to delete these since UNIX_DISK should no longer 
          be used, but have to check all applications first */
#ifdef sparc
#define UNIX_DISK                    /* Define unix disk                  */
#endif
#ifdef sgi
#define UNIX_DISK                    /* Define unix disk                  */
#endif


int c_dkcopy
(
    const char *from,                /* I: Current file name              */
    const char *to,                  /* I: New file name                  */
    char directories[][CMLEN]        /* I/O: List of dest. directories    */
);

int c_dkcre
(
    char directories[][CMLEN],       /* I/O: Array of directories for space*/
    const char *filename,            /* I: Name of file to be created     */
    long long filesize,              /* I: Size of file to be created     */
    int wait                         /* I: Wait > 0, wait for space       */
                                     /*    wait = 0,do not wait for space */
);

int c_dkdel
(
    const char *filename             /* I: Name of file to be deleted     */
);

int c_dkfree
(
    const char *path                 /* I: Pathname to unreserve space for*/
);

int c_dkmove
(
    const char *from,                /* I: Name of file to be moved       */
    const char *to,                  /* I: Name of output file            */
    char directories[][CMLEN]        /* I/O: List of dest. directories    */
);

int c_dkresv
(
    const char *path,                /* I: Pathname to reserve space for  */
    long long size                   /* I: Size of file to reserve space  */
);

long long c_dkrspac
(
    const char *path                 /* I: Pathname to determine free sp. */
);

#endif
