#!/bin/csh
#
# FUNCTION:	diffl1b.csh
#
# PURPOSE:	Unix 'diff' two Level-1b files, all but the first 32 bytes will
#		be compared.  This header part of the file is not 'diff'ed
#		because it contains a julian creation date.


#--------------------
# Check the arguments
#--------------------
if ($#argv != 2) then
    echo 'usage: diffl1b.csh file1 file2'
    echo ''
    exit 1
endif


#-----------------------
# Assign variable names
#-----------------------
set infile1=$1
set infile2=$2
set outfile1 = infile1.tmp


#----------------------------------------------
# Create file with all but the first 32 bytes
#----------------------------------------------
dd if=$infile1 of=$outfile1 bs=32 skip=1


#------------------------------------------------------------
# Diff this file with the 2nd file (less the first 32 bytes)
#------------------------------------------------------------
dd if=$infile2 bs=32 skip=1 | grep $outfile1


#--------------------------
# Delete the temporary file
#--------------------------
rm $outfile1


exit 0

