
#ifndef PROCESSEXECUTION_H
#define PROCESSEXECUTION_H

/* System Includes */

/* Qt Includes */
#include "qwidget.h"
#include "qstringlist.h"
#include "qprocess.h"

/* Local Includes */

class ProcessExecution : public QWidget
{
    Q_OBJECT

    public:

        ProcessExecution(QWidget * parent = 0,
                         const char * name = 0,
                         WFlags f = 0);

        ~ProcessExecution();

        bool execute(QString & cmd,
                     bool wait = true);

        QStringList getStdout();
        QStringList getStderr();

    protected:

    private:

        QString unEnvCmd(QString & cmd);

        QProcess * myProcess;
        QStringList myStdout;
        QStringList myStderr;

    private slots:

        void readFromStdoutSlot();
        void readFromStderrSlot();
};

#endif /* PROCESSEXECUTION_H */

// Here is an example of it's usage
#if 0

void OUIMainWindow::executePlugin(const QString & cmd)
{
    ProcessExecution pe(this);
    QString command = cmd;

    if(!pe.execute(command, false))
    {
        // Grab the errors.
        QStringList::iterator itr;
        QStringList errorList = pe.getStderr();
        QString errors("");
        for(itr = errorList.begin(); itr != errorList.end(); ++itr)
        {
            errors += "\n" + (*itr);
        }

        QString msg = tr("Failed to execute plugin.\n") +
                      command + "\n" + errors;
        QMessageBox::critical(this, "OUI - " + tr("Error"), msg);
    }
}


#endif
