/*******************************************************************************
FUNCTION:	SET_UP_IMAGES

PURPOSE:	Set up the input and output images
*******************************************************************************/
#include "anginterp.h"

/*
  The following variables are global for image I/O
*/
extern struct FDESC *fdout;	/* image file descriptors used for image I/O  */

int set_up_images
(
    char *hosout,	/* IN - output host file name                         */
    long window[],	/* IN - window of input image                         */
    long totbnd,	/* IN - number of bands in OUT                        */
    long odtype		/* IN - data type of OUT                              */
)
{
long access   = IWRITE,		/* image access                               */
     fatal    = -1,		/* fatal error flag                           */
     maxlines = MAXLINES,	/* maximum number of lines to read at a time  */
     one      = 1;		/* constant 1 (SL,SS) for OUT                 */

static	long	opt[3]={0,0,0}; /* optional parameter array for EOPENR	      */

/*
  Open the output image as same size as input.
*/
if (c_eopenr(&fdout,hosout,&totbnd,&one,&one,&window[NL],
    &window[NS],&access,&odtype,opt,&maxlines) != E_SUCC)
    c_errmsg("Fatal error encountered","anginterp-fatal",&fatal);

return(E_SUCC);
}
