#ifndef ANSISTACK_GET_H
#define ANSISTACK_GET_H


#include "ansistack.h"

/* Prototypes */

long getpar
(
    struct PARBLK *vblock,      /* IN  - TAE parameter block                  */
    char *command,              /* OUT - Command being run (gen,avhrr,mssx)   */
    char *infile,               /* OUT - Input file specification             */
    long *min_mbytes,           /* OUT - Min megabytes to stack to tape       */
    long *max_mbytes,           /* OUT - Max megabytes to stack to tape       */
    long *mbytes,               /* OUT - Megabytes already stacked to tape    */
    char *ttype,                /* OUT - Tape type (4mm, 8mm, 3480, 9-track..)*/
    long *nassoc,               /* OUT - Number of associated files in aftype */
    char aftype[][CMLEN],       /* OUT - Extensions for each associated file  */
    char *stopfile,             /* OUT - Host file name of the stop file      */
    char *stackdir,             /* OUT - Host file name of the stack directory*/
    char *errdir,               /* OUT - Error directory                      */
    char *tapelist              /* OUT - Host file name of tmp tape list file */
);

int check_tape_names
    (
    struct FILEGROUP **group_ptr,       /* IN - Ptr to a file group           */
    long q                              /* IN - Queue of tape names           */
    );

int read_tape_names
(
    char *infile,       /* IN  - File containing file names copied to tape    */
    long q              /* OUT - Queue containing file names copied to tape   */
);

int select_groups
(
    char *ttype,                /* IN  - Type of tape (4mm,8mm,3480,9-track..)*/
    long min_mbytes,            /* IN  - Min megabytes to stack to the tape   */
    long max_mbytes,            /* IN  - Max megabytes to stack to the tape   */
    long mbytes,                /* IN  - Mbytes already stacked to tape       */
    long q_eligible,            /* IN  - Queue of eligible file groups        */
    long q_stack                /* OUT - Queue of file groups to be stacked   */
);

#endif

