#ifndef ANSISTACK_WRT_H
#define ANSISTACK_WRT_H


#include "ansistack.h"
#include "model.h"

long getpar
    (
    struct PARBLK *vblock,	/* IN  - TAE parameter block                  */
    char *command,		/* OUT - Command be run (gen, avhrr, mssx)    */
    char *infile,		/* OUT - File specification for input files   */
    char *srcdir,		/* OUT - Source dir where file where located  */
    char *stackdir,		/* OUT - Temporary stacking directory         */
    char *dstdir,		/* OUT - Destination directory for all files  */
    char *errdir,		/* OUT - Dir where files go after errors      */
    long *nassoc,		/* OUT - Number of associated files           */
    char aftype[][CMLEN],	/* OUT - Associated file extensions           */
    long record_size[],		/* OUT - Record size for each file            */
    long block_size[],		/* OUT - Block size for each file             */
    short *delete_flag,		/* OUT - Flag for deleting/moving files       */
    int *mbytes,		/* OUT - Mbytes already stacked to tape       */
    char *drive,		/* OUT - Tape drive where tape is mounted     */
    char *ttype,		/* OUT - Type of tape that is mounted         */
    char *tapeid,		/* OUT - ID number of the mounted tape        */
    char *sumfile,		/* OUT - Name of the tape summary file        */
    short *stop_flag,		/* OUT - Flag indicating no files to stack    */
    char *tapelist,		/* OUT - File to hold tape name of all files  */
    char *logfile,		/* OUT - Log file                             */
    int *ngroups,		/* OUT - Num of groups already written to tape*/
    int *nfiles,		/* OUT - Num of files already written to tape */
    long *nmonths,		/* OUT - Num of months to retain the tape     */
    char tape_buf[][SMALLSTR],	/* OUT - Info for creating tape labels        */
    long *print_flag,		/* OUT - Flag to print tape labels or not     */
    char acctnum[],		/* OUT - Account number			      */
    char ordernum[],		/* OUT - Order number			      */
    char unitnum[],		/* OUT - Unit number			      */
    long *outform,		/* OUT - Output format			      */
    char rundir[],		/* OUT - Run directory			      */
    char prodsum[] 		/* OUT - Product summary flag		      */
    );

int delete_queue
(
    long q              /* IN - Queue containing the file groups              */
);

int move_group
(
    struct FILEGROUP *ptr,      /* IN - Ptr to a file group structure         */
    char *newdir                /* IN - Directory where files should be moved */
);

int rename_group
(
    struct FILEGROUP *ptr       /* IN - Ptr to a file group structure         */
);

int rename_queue
(
    long q,             /* IN - Queue containing the file groups              */
    char *errdir,       /* IN - Error directory                               */
    long outform        /* Output format                                      */
);

int stack_group
(
    struct FILEGROUP *ptr,/* IN - Ptr to a file group                        */
    long record_size[], /* IN  - Record size for each file in the group       */
    long block_size[],  /* IN  - Block size for each file in the group        */
    char drive[],       /* IN  - Tape drive                                   */
    char ttype[],       /* IN  - Tape type (4mm, 8lo, 8hi, 3480, 3490,9-track)*/
    char tapeid[],      /* IN  - Tape identification number                   */
    char tapelist[],    /* IN  - Name of file containing file names           */
    char logfile[],     /* IN  - Name of file containing file names           */
    long nfiles,        /* IN  - Number of files already stacked to tape      */
    char acctnum[],     /* IN  - Account number                               */
    char ordernum[],    /* IN  - Order number                                 */
    char unitnum[],     /* IN  - Unit number                                  */
    long outform,       /* IN  - Output format 0=Level 0, 1=Level 1B          */
    char rundir[],      /* IN  - Run directory                                */
    char prodsum[]      /* IN  - Product summary flag                         */
);

int tape_label
(
    char buffer[][SMALLSTR],    /* IN - Buffer containing tape label info     */
    long nmonths,               /* IN - Number of months to retain the tape   */
    long ngroups,               /* IN - Number of file groups on the tape     */
    long printflg               /* IN - Flag for printing tape labels         */
);

int tape_summary
(
    struct FILEGROUP *ptr,      /* IN - Ptr to a FILEGROUP structure          */
    char *tapeid,               /* IN - Tape ID                               */
    char *ttype,                /* IN - Type of tape                          */
    char *drive,                /* IN - Tape drive                            */
    char *summary,              /* IN - File name of file to create           */
    long ngroups,               /* IN - Total number of file groups on tape   */
    long outform                /* IN - Output format 0=Level 0, 1=Level 1B   */
);

void wrtprdsum
(
char    acctnum[10],            /* account number                       */
char    ttype[5],               /* tape type                            */
char    archnam[CMLEN],         /* input archive image host file name   */
char    ordernum[14],           /* order number                         */
char    unitnum[5]              /* unit number                          */
);

void suminfo
(
char    out[CMLEN],     /* output file names                    */
char    acctnum[10],    /* account number                       */
char    ordernum[14],   /* order number                         */
char    unitnum[5],     /* unit number                          */
char    sceneid[30],    /* input scene id                       */
char    prodesc[18],    /* product description                  */
float   rgwin[4],       /* original window in lat/long form     */
char    density[5],     /* tape density                         */
struct MODEL *model     /* Model and orbital information        */
);

int prepimg
(
float   rgwin[4],               /* original window                      */
struct MODEL *model             /* Model and orbital information        */
);

void dosummary
(
    char    *out,               /* output file name                     */
    char    *acctnum,           /* account number                       */
    char    *ordernum,          /* order number                         */
    char    *unitnum,           /* unit number                          */
    char    *cdate,             /* current date                         */
    char    *sceneid,           /* scene identifier                     */
    long    orbit,              /* orbit number                         */
    char    *acqdate,           /* acquisition date                     */
    char    *acqtime,           /* acquisition time                     */
    char    *prodesc,           /* product description                  */
    char    *satid,             /* satellite name                       */
    char    *source,            /* sensor data type (HRPT)              */
    float   uplat,              /* upper left latitude                  */
    float   uplong,             /* upper left longitude                 */
    float   lolat,              /* lower right latitude                 */
    float   lolong,             /* lower right longitude                */
    float   beglat,             /* beginning latitude of output file    */
    float   endlat,             /* ending latitude of output file       */
    float   beglong,            /* beginning longitude of output file   */
    float   endlong,            /* ending longitude of output file      */
    long    nl,                 /* number of lines in output file       */
    long    ns,                 /* number of samples in output file     */
    char    *density            /* tape density (6250, 1600)            */
);

#endif

