/*******************************************************************************
FUNCTION:	compare_tape_names

PURPOSE:	Given a pointer to two FILEGROUP structures compare the two
		structures based upon the first TPNAMELEN characters of their
		tape names.  If any of the tape names are the same then return
		0.  If all of the tape names are different then return the
		result from strncmp() on the first tape name in each structure.


Version  Date   Programmer       Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    12/93  J.Fenno          Development


PROJECT: ADAPS
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "ansistack.h"


long compare_tape_names
(
    void *ptr1,		/* IN - Ptr to a FILEGROUP structure                  */
    void *ptr2 		/* IN - Ptr to a FILEGROUP structure                  */
)

{
long i;			/* Loop control                                       */
long j;                 /* Loop control                                       */

struct FILEGROUP *p1;	/* Ptr to a FILEGROUP structure                       */
struct FILEGROUP *p2;	/* Ptr to a FILEGROUP structure                       */


/* Reassign the given void ptrs
-------------------------------*/
p1 = (struct FILEGROUP *)ptr1;
p2 = (struct FILEGROUP *)ptr2;


/* If any of the tape names are the same then consider the two groups equal
   and return a zero.  If none of the tape names are the same then return the
   comparison of the first tape name from each group.
-----------------------------------------------------------------------------*/
for (i = 0; i < p1->nfiles; i++)
    for (j = 0; j < p2->nfiles; j++)
	if (strncmp(p1->tapenames[i], p2->tapenames[j], TPNAMELEN) == 0)
	    return(0);
return(strncmp(p1->tapenames[0], p2->tapenames[0], TPNAMELEN));
}
