/*******************************************************************************
FUNCTION:	delete_queue

PURPOSE:	Delete all of the file groups in a queue.

		Return E_SUCC if successful, E_FAIL if not.


Version  Date   Programmer       Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    12/93  J.Fenno          Development


PROJECT: ADAPS
*******************************************************************************/
#include <stdio.h>
#include <math.h>
#include "las.h"
#include "queue.h"
#include "ansistack.h"


int delete_queue
(
    long q 		/* IN - Queue containing the file groups              */
)

{
char filename[CMLEN];	/* File name for file to be deleted                   */

long i;			/* Loop control                                       */

struct FILEGROUP *ptr;	/* Ptr to a file group                                */


/* If the queue is empty then just return
-----------------------------------------*/
if (c_qsize(q) < 1)
    return(E_SUCC);


/* Get the first file group in the queue
----------------------------------------*/
c_qfirst(q, (void **)&ptr);


/* Remove all of the file groups
--------------------------------*/
do  {
    for (i = 0; i < ptr->nfiles; i++)
	{
	if (ptr->nameflag == DISKNAME)
	    sprintf(filename, "%s%s", ptr->dir, ptr->disknames[i]);
	else
	    sprintf(filename, "%s%s", ptr->dir, ptr->tapenames[i]);
	remove(filename);
	}
    c_qnext(q, (void **)&ptr);
    } while (ptr != NULL);

return(E_SUCC);
}
