/*******************************************************************************
FUNCTION:	move_group

PURPOSE:	Move all of the files in a group from one directory to the
		other.


Version  Date   Programmer       Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    12/93  J.Fenno          Development


PROJECT: ADAPS
*******************************************************************************/
#include <stdio.h>
#include <math.h>
#include "las.h"
#include "ansistack.h"


int move_group
(
    struct FILEGROUP *ptr,	/* IN - Ptr to a file group structure         */
    char *newdir 		/* IN - Directory where files should be moved */
)

{
char newname[CMLEN];	/* Complete new name of a file                        */
char oldname[CMLEN];	/* Complete old name of a file                        */

long i;			/* Loop control                                       */
long j;			/* Loop control                                       */
long nonfatal = 1;	/* Nonfatal error flag                                */


/* Move each file from one directory to the other
-------------------------------------------------*/
for (i = 0; i < ptr->nfiles; i++)
    {
    /* Create the old and new file names
    ------------------------------------*/
    if (ptr->nameflag == DISKNAME)
	{
	sprintf(oldname, "%s%s", ptr->dir, ptr->disknames[i]);
	sprintf(newname, "%s%s", newdir,   ptr->disknames[i]);
	}
    else
	{
	sprintf(oldname, "%s%s", ptr->dir, ptr->tapenames[i]);
	sprintf(newname, "%s%s", newdir,   ptr->tapenames[i]);
	}


    /* Rename the file
    ------------------*/
    if (rename(oldname, newname))
	{
	c_errmsg("Error renaming file group", "ansistack-rename", &nonfatal);
	for (j = 0; j < i; j++)
	    {
	    if (ptr->nameflag == DISKNAME)
		{
		sprintf(oldname, "%s%s", ptr->dir, ptr->disknames[i]);
		sprintf(newname, "%s%s", newdir,   ptr->disknames[i]);
		}
	    else
		{
		sprintf(oldname, "%s%s", ptr->dir, ptr->tapenames[i]);
		sprintf(newname, "%s%s", newdir,   ptr->tapenames[i]);
		}
	    rename(newname, oldname);
	    }
	return(E_FAIL);
	}
    }


/* Save the new directory in the structure
------------------------------------------*/
strcpy(ptr->dir, newdir);


return(E_SUCC);
}
