/*******************************************************************************
FUNCTION:	print_group

PURPOSE:	Given a pointer to a FILEGROUP structure print the contents of
		the structure to the terminal.


Version  Date   Programmer       Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    12/93  J.Fenno          Development


PROJECT: ADAPS
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "ansistack.h"


int print_group
(
    void *ptr 		/* IN - Ptr to a FILEGROUP structure                  */
)

{
long i;                 /* Loop control                                       */

struct FILEGROUP *p;	/* Ptr to a FILEGROUP structure                       */


/* Reassign the given void ptr
------------------------------*/
p = (struct FILEGROUP *)ptr;


/* If any of the tape names are the same then consider the two groups equal
   and return a zero.  If none of the tape names are the same then return the
   comparison of the first tape name from each group.
-----------------------------------------------------------------------------*/
printf("\n");
printf("      DIR: %s   NFILES: %d   MBYTES: %d\n",p->dir,p->nfiles,p->mbytes);
for (i = 0; i < p->nfiles; i++)
    printf("      TPNAME: %s   DSKNAME: %s\n",
	p->tapenames[i], p->disknames[i]);
return(E_SUCC);
}
