/*******************************************************************************
FUNCTION:	tape_label

PURPOSE:	Create a tape label


Version  Date   Programmer       Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    12/93  J.Fenno          Development


PROJECT: ADAPS
*******************************************************************************/
#include <stdio.h>
#include <time.h>
#include "las.h"
#include "tapeio.h"
#include "ansistack.h"



int tape_label
(
    char buffer[][SMALLSTR],	/* IN - Buffer containing tape label info     */
    long nmonths,		/* IN - Number of months to retain the tape   */
    long ngroups,		/* IN - Number of file groups on the tape     */
    long printflg 		/* IN - Flag for printing tape labels         */
)

{
char *ptr;		/* Ptr to a character within a string                 */
char *ptrs[TPFIELDS];	/* Array of ptrs for calling c_tapelabel()            */
char str1[CMLEN];	/* Temporary working string                           */
char str2[CMLEN];	/* Temporary working string                           */
char lasname[CMLEN];	/* LAS name of the file containing the tape label     */

long i;			/* Loop control                                       */
long nonfatal = 1;	/* Nonfatal error flag                                */


/* If the print flag is not set, simply return
----------------------------------------------*/
if (!printflg)
    {
    c_errmsg("Tape label will not be printed", " ", &nonfatal);
    return(E_SUCC);
    }


/* Search through the description replacing the first occurance of
   '?' with the number of file groups that were stacked to the tape
-------------------------------------------------------------------*/
ptr = strchr(buffer[2], '?');
if (ptr != NULL)
    {
    *(ptr++) = '\0';
    strcpy(str1, buffer[2]);
    sprintf(str2, "%1d%s", ngroups, ptr);
    strcat(str1, str2);
    if (strlen(str1) > SMALLSTR) str1[SMALLSTR-1] = '\0';
    strcpy(buffer[2], str1);
    }


/* Set an array of pointers to the buffer
-----------------------------------------*/
for (i = 0; i < TPFIELDS; i++)
    ptrs[i] = buffer[i];


/* Call the label printing support
----------------------------------*/
c_tapelabel(ptrs, nmonths, printflg, TRUE, lasname);
c_errmsg("Tape label printed", " ", &nonfatal);

return(E_SUCC);
}
