        program mktbwv 
********
******** makes table to index ozone transmittance by o3 amount (atm-cm),
********         solar and satellite zenith angles (degrees)
********
******** modified version of o3taba to (1) index by solar zentih angle as 
******** well as satellite view zenith angles.
********
        implicit none
        character*80    ofile(2)
        real    uw,uo3,asol,avis,phiv,xps
        real    ths(12),thv(12),phi(18),z1(5)
        real    pi,d2r,pi100
        real    rapp
        real     stwava, tgasm, raysc  
 
c        real     03fl(),ao3(),bo3(),e0mus,v,e0(2) 
c       integer m,EON        
c       character*80    ofile(2) 
        integer i,j,n,p 

        
c        data    e0      /1629.2, 1052.8/
c Uncomment one set of water vapor file names -- one line only
c       data ofile /'watvap_n14_ch1_oh0.lutf','watvap_n14_ch2_oh0.lutf'/
c        data ofile /'watvap_n16_ch1_oh0.lutf','watvap_n16_ch2_oh0.lutf'/
c      data ofile /'watvap_n17_ch1_oh0.lutf','watvap_n17_ch2_oh0.lutf'/
c       data ofile /'wv_decoupled_ch1.dat','wv_decoupled_ch2.dat'/        
c       data ofile/'watvap_n17ch1_oh0nn.lutf','watvap_n17ch2_oh0nn.lutf'/   
       data ofile /'watvap_n18_ch1_oh0.lutf','watvap_n18_ch2_oh0.lutf'/
        data    ths
     +       /0.,15.,30.,40.,50.,58.,64.,69.,73.,76.,78.,80./
        data    thv
     +       /0.,10.,20.,30.,40.,46.,51.,56.,60.,64.,67.,70./
        data    phi
     +     /0.,11.,23.,37.,53.,67.,79.,90.,100.,110.,120.,130.,
     +          140.,150.,160.,168.,174.,180./
        data    z1
     +          /0.0, 0.5, 1.1, 1.8, 2.6/
 
      open (unit = 8, file = ofile(1))
       open (unit = 9, file = ofile(2))

       do 7783 n=1,2        
c        do 7783 n = 2,2 

c        open (unit = 12+n, file =ofile(n))             

        pi = acos(-1.0)
        d2r = pi/180.
        pi100 = pi*100.
        phiv = 0.0
        uo3=0.0
        uw=0.0
         asol = 0.0
         xps = 0.0
          rapp=-2.0 
          avis=0.0

         do 7782  p=1,60  
         uw=0.1*p  
 
        do 7784 i = 1,12    
           asol = ths(i)
 
  10      do 7785 j = 1,12  
            avis = thv(j)

            rapp=-2.0 
c      The purpose is to create water vapor lut tables here with the 
c    ozone and aerosols etc set to zero.
c      This also allows us to set the rapp variable in 6s (or ssss) to  
c    whatever value is convenient.  That is, 

        uo3 =0.0

c  do not need a loop for radiance or reflectance, ie don't need to
c  vary rapp (whatever it is representing).  We also make the further
c   assumption that o3 transmittance will be relatively insensitive to height
c  based on the assumptions in 6s, the location of most of the ozone, and
c  our experiences with 6s.

      call ssss(n,phiv,uo3,uw,asol,avis,xps,rapp,stwava,tgasm,raysc) 

c      print *,'n,asol,avis,uw,stwava=', 
c     +n,asol,avis,uw,stwava 

       write (7+n, '(f12.8,i2,2f6.1,f7.3)')stwava,n,asol,avis,uw
c        write (12+n,'(2f6.1,f6.3,3f12.8)')
c     +    asol,avis,uw,stwava,tgasm,raysc  

c         
c      
c    write (9,'(f6.3,2i3,2f6.1,f12.8)')
c     +    uw,i,j,asol,avis,stwava
c 

 7785   continue
 7784   continue
 7782   continue
        close (unit = 12+n)
 7783   continue

c        close (unit =  8)
                 
        stop
       END 
 
      subroutine ssss(n,phiv,uo3,uw,asol,avis,xps,rapp,stwava,tgasm,
     +raysc) 

c**********************************************************************c
c       ********************************************************       c
c       *           second simulation of satellite signal      *       c
c       *                 in the solar spectrum                *       c
c       *           ... (6s) ....... (6s) ...... (6s) ...      *       c
c       *                        version  4.1                  *       c
c       *                                                      *       c
c       *  this code predicts the satellite signal from 0.25   *       c
c       *  to 4.0 microns assuming cloudless atmosphere.       *       c
c       *  the main atmospheric effects (gaseous absorption    *       c
c       *  by water vapor,carbon dioxyde,oxygen and ozone;     *       c
c       *  scattering by molecules and aerosols) are taken     *       c
c       *  into account. non-uniform surfaces may be           *       c
c       *  considered,as well as bidirectional reflectances    *       c
c       *            as boundary conditions                    *       c
c       *                                                      *       c
c       *   the following input parameters are needed          *       c
c       *         geometrical conditions                       *       c
c       *         atmospheric model for gaseous components     *       c
c       *         aerosol model (type and concentration)       *       c
c       *         spectral condition                           *       c
c       *         ground reflectance (type and spectral var.)  *       c
c       *   at each step, you can either select some proposed  *       c
c       *  standard conditions (for example,spectral bands of  *       c
c       *  satellite for spectral conditions) or define your   *       c
c       *  own conditions(in the example,you have to define    *       c
c       *  the assumed spectral response).                     *       c
c       *                                                      *       c
c       *   more details are given at each data input step     *       c
c       *                                                      *       c
c**********************************************************************c
c       *                limits of validity                    *       c
c       *                                                      *       c
c       *   geometrical parameters    no limitations           *       c
c       *                                                      *       c
c       *   atmospheric model         no limitations           *       c
c       *                                                      *       c
c       *   aerosol model             the visibility must be   *       c
c       *                             better than 5.0km        *       c
c       *                             for smaller values       *       c
c       *                             calculations might be    *       c
c       *                             no more valid.           *       c
c       *                                                      *       c
c       *   spectral conditions       the gaseous transmittance*       c
c       *                             and the scattering func  *       c
c       *                             tions are valid from 0.25*       c
c       *                             to 4.0 micron. but the   *       c
c       *                             treatment of interaction *       c
c       *                             between absorption and   *       c
c       *                             scattering is correct for*       c
c       *                             not too large absorption *       c
c       *                             if you want to compute   *       c
c       *                             signal within absorption *       c
c       *                             bands,this interaction   *       c
c       *                             ought to be reconsidered *       c
c       *                                                      *       c
c       *   ground reflectance (type) you can consider a patchy*       c
c       *                             structure:that is a circu*       c
c       *                             lar target of radius rad *       c
c       *                             and of reflectance roc,  *       c
c       *                             within an environnement  *       c
c       *                             of reflectance roe.      *       c
c       *                                                      *       c
c       *   ground reflectance (type continued): for uniform   *       c
c       *                             surface conditions only, *       c
c       *                             you may consider directio*       c
c       *                             nal reflectance as bounda*       c
c       *                             ry conditions.           *       c
c       *                             some analytical model are*       c
c       *                             proposed, the user can   *       c
c       *                             specify his own values.  *       c
c       *                             the code assumes that the*       c
c       *                             brdf is spectrally inde- *       c
c       *                             pendent                  *       c
c       *                                                      *       c
c       *   ground reflectance (spectral variation) four typi  *       c
c       *                             cal reflectances are pro *       c
c       *                             posed, defined within    *       c
c       *                             given spectral range.    *       c
c       *                             this range differs accor *       c
c       *                             ding to the selected case*       c
c       *                             the reflectance is set to*       c
c       *                             0 outside this range,due *       c
c       *                             to the deficiency of data*       c
c       *                             user must verify these   *       c
c       *                             limits. that is obviously*       c
c       *                             irrelevant for brdf      *       c
c**********************************************************************c
c  for considering brdf<we have to compute the downward radiance in thec
c  whole hemisphere.to perform such computions, we selected the success
C ive orders of scattering method. that method requires numerical 
c integration over angles and optical depth. the integration method is 
c the gauss method, mu is the number of angles nmu+1, nmu is settled to 
c 24. the accuracy of the computations is obviously depending on the nmu 
c value. this value can be easily changed as a parameter as well as the
c nt value which is the number of layers for performing the vertical 
c integration. the downward radiance is computed for nmu values of the 
c zenith angle and np values of the azimuth angle. the integration of the 
c product of the radiance by the brdf is so performed over the nmu*np 
c values. np is settled to 13, that value can be also changed. mu2 is 
c equal to 2 times nmu. xlmus is the downward radiance, xf the downward 
c irradiance, rm and gb the angles and the weights for the gauss 
c integration over the zenith, rp  and gp respectively for the azimuth 
c integration.                     
c***********************************************************************
c 
c     parameter(nt_p=13,mu_p=13,mu2_p=24,np_p=13)
      parameter(nt_p=26,mu_p=25,mu2_p=48,np_p=49)
      dimension anglem(mu2_p),weightm(mu2_p),
     s   rm(-mu_p:mu_p),gb(-mu_p:mu_p),rp(np_p),gp(np_p)
      dimension  xlmus(-mu_p:mu_p,np_p),xlmuv(-mu_p:mu_p,np_p)
      dimension angmu(10),angphi(13),brdfints(-mu_p:mu_p,np_p)
     s    ,brdfdats(10,13),
     s    brdfintv(-mu_p:mu_p,np_p),brdfdatv(10,13),robar(1501),
     s    robarp(1501),robard(1501),xlm1(-mu_p:mu_p,np_p),
     s    xlm2(-mu_p:mu_p,np_p)
        real y,acr
        real anglem,weightm,rm,gb,accu2,accu3
        real rp,gp,xlmus,xlmuv,angmu,angphi,brdfints,brdfdats
        real brdfintv,brdfdatv,robar,robarp,robard,xlm1,xlm2
        real c,wldisc,ani,anr,aini,ainr,rocl,roel,zpl,ppl,tpl,whpl
        real wopl,xacc,phasel,pdgs,cgaus,pha,betal,s,wlinf,wlsup,delta
        real sigma,z,p,t,wh,wo,ext,ome,gasym,phase,roatm,dtdir
        real dtdif,utdir,utdif,sphal,wldis,trayl,traypl,pi,pi2,step
        real asol,phi0,avis,phiv,tu,xlon,xlat,xlonan,hna,dsol,campm
        real phi,phirad,xmus,xmuv,xmup,xmud,adif,uw,uo3,taer55
        real taer,v,xps,uwus,uo3us,xpp,taer55p,puw,puo3,puwus
        real puo3us,wl,wlmoy,tamoy,tamoyp,pizmoy,pizmoyp,trmoy
        real trmoyp,fr,rad,spalt
        real albbrdf,par1,par2,par3,par4,robar1,xnorm1,rob,xnor,rodir
        real rdown,rdir,robar2,xnorm2,ro,roc,roe,rapp,rocave,roeave
        real seb,sbor,swl,sb,refet,refet1,refet2,refet3,alumet
        real tgasm,rog,dgasm,ugasm,sdwava,sdozon,sddica,sdoxyg
        real sdniox,sdmoca,sdmeth,suwava,suozon,sudica,suoxyg
        real suniox,sumoca,sumeth,stwava,stozon,stdica,stoxyg,stniox
        real stmoca,stmeth,sodray,sodaer,sodtot,fophsr,fophsa,sroray
        real sroaer,srotot,ssdaer,sdtotr,sdtota,sdtott,sutotr,sutota
        real sutott,sasr,sasa,sast,dtozon,dtdica,dtoxyg
        real dtniox,dtmeth,dtmoca,utozon,utdica,utoxyg,utniox
        real utmeth,utmoca,attwava,ttozon,ttdica,ttoxyg,ttniox
        real ttmeth,ttmoca,dtwava,utwava,ttwava,coef,romix,rorayl
        real roaero,phaa,phar,tsca,tray,trayp,taerp,dtott,utott
        real astot,asray,asaer,utotr,utota,dtotr,dtota,dgtot,tgtot
        real tgp1,tgp2
        real ugtot,edifr,edifa,tdird,tdiru,tdifd,tdifu,fra
        real fae,avr,romeas1,romeas2,romeas3,alumeas,sodrayp
        real ratm1,ratm2,ratm3,rsurf
        real sodaerp,sodtotp,tdir,tdif,etn,esn,es,ea0n,ea0,ee0n
        real ee0,tmdir,tmdif,xla0n,xla0,xltn,xlt,xlen,xle,pizera
        real fophst,pizerr,pizert,xrad,xa,xb,xc
        real sha,sham
        real  raysc
        integer nt,mu,mu2,np,k,iwr,mum1,idatmp
        integer j,iread,l,igeom,month,jday,nc,nl,idatm,iaer,iaerp,n
        integer iwave,iinf,isup,ik,i,inhomo,idirec,ibrdf,igroun
        integer igrou1,igrou2,isort
c***********************************************************************
c                             return to 6s
c***********************************************************************
      dimension c(4),wldisc(10),ani(2,3),anr(2,3),aini(2,3),ainr(2,3)
      dimension rocl(1501),roel(1501)
      real rn,ri,x1,x2,x3,cij,rsunph,nrsunph,rmax,rmin
      integer icp,irsunph,i1,i2
      character etiq1(8)*60,nsat(67)*17,atmid(7)*51,reflec(8)*71
      character FILE*80,FILE2*80
 
      logical ier
      common/sixs_ier/iwr,ier
      common /mie_in/ rmax,rmin,icp,rn(10,4),ri(10,4),x1(4),x2(4),
     s x3(4),cij(4),irsunph,rsunph(50),nrsunph(50)
c***********************************************************************
c     for considering pixel and sensor  altitude
c***********************************************************************
      real pps,palt,ftray
      common /sixs_planesim/zpl(34),ppl(34),tpl(34),whpl(34),wopl(34)
      common /sixs_test/xacc
c***********************************************************************
c     for considering brdf
c***********************************************************************
      common /sixs_sos/phasel(10,83),cgaus(83),pdgs(83)
      common /sixs_trunc/pha(83),betal(0:80)
      real optics(3),struct(4)
      integer options(5)
      integer pild,pihs
      real pxLt,pc,pRl,pTl,pRs
      real pws,phi_wind,xsal,pcl,paw
      real uli,eei,thmi,sli,cabi,cwi,vaii,rnci,rsl1i
c***********************************************************************
c                             return to 6s
c***********************************************************************
      common /sixs_ffu/s(1501),wlinf,wlsup
      common /sixs_del/ delta,sigma
      common /sixs_atm/z(34),p(34),t(34),wh(34),wo(34)
      common /sixs_aer/ext(10),ome(10),gasym(10),phase(10)
      common /sixs_disc/ roatm(3,10),dtdir(3,10),dtdif(3,10),
     s utdir(3,10),utdif(3,10),sphal(3,10),wldis(10),trayl(10),
     s traypl(10)
 
 
c***********************************************************************
c   angmu and angphi are the angles were the brdf is measured. these val
cues  c
c   can be changed as soon as they are well distributed over the whole s
cpace c
c   before the gauss integration, these values are interpolated to the g
causs c
c   angles                                                              
     c
c***********************************************************************
*****c
      data angmu /85.0,80.0,70.0,60.0,50.0,40.0,30.0,20.0,10.0,0.00/
C     data angmu /0.0,10.0,20.0,30.0,40.0,50.0,60.0,70.0,80.0,85.0/
      data angphi/0.00,30.0,60.0,90.0,120.0,150.0,180.0,
     s          210.0,240.0,270.0,300.0,330.0,360.0/
 
c***********************************************************************
c                             return to 6s
c***********************************************************************
      data wldisc /0.400,0.488,0.515,0.550,0.633,
     s             0.694,0.860,1.536,2.250,3.750/
 
      data etiq1/
     s '(1h*,22x,34h user defined conditions          ,t79,1h*)',
     s '(1h*,22x,24h meteosat observation   ,t79,1h*)          ',
     s '(1h*,22x,25h goes east observation   ,t79,1h*)         ',
     s '(1h*,22x,25h goes west observation   ,t79,1h*)         ',
     s '(1h*,22x,30h avhrr (AM noaa) observation  ,t79,1h*)    ',
     s '(1h*,22x,30h avhrr (PM noaa) observation  ,t79,1h*)    ',
     s '(1h*,22x,24h h.r.v.   observation   ,t79,1h*)          ',
     s '(1h*,22x,24h t.m.     observation   ,t79,1h*)          '/
 
       data nsat/
     s ' constant        ',' user s          ',
     s ' meteosat        ',' goes east       ',' goes west       ',
     s ' avhrr 1 (noaa6) ',' avhrr 2 (noaa6) ',
     s ' avhrr 1 (noaa7) ',' avhrr 2 (noaa7) ',
     s ' avhrr 1 (noaa8) ',' avhrr 2 (noaa8) ',
     s ' avhrr 1 (noaa9) ',' avhrr 2 (noaa9) ',
     s ' avhrr 1 (noaa10)',' avhrr 2 (noaa10)',
     s ' avhrr 1 (noaa11)',' avhrr 2 (noaa11)',
     s ' hrv1 1          ',' hrv1 2          ',' hrv1 3          ',
     s ' hrv1 pan        ',
     s ' hrv2 1          ',' hrv2 2          ',' hrv2 3          ',
     s ' hrv2 pan        ',
     s '  tm  1          ','  tm  2          ','  tm  3          ',
     s '  tm  4          ','  tm  5          ','  tm  7          ',
     s '  mss 4          ','  mss 5          ',
     s '  mss 6          ','  mss 7          ',
     s '  mas 1          ','  mas 2          ','  mas 3          ',
     s '  mas 4          ','  mas 5          ','  mas 6          ',
     s '  mas 7          ','  modis 1        ','  modis 2        ',
     s '  modis 3        ','  modis 4        ','  modis 5        ',
     s '  modis 6        ','  modis 7        ',
     s ' avhrr 1 (noaa12)',' avhrr 2 (noaa12)',
     s ' avhrr 1 (noaa14)',' avhrr 2 (noaa14)',
     s ' polder 1        ',' polder 2        ',
     s ' polder 3        ',' polder 4        ',' polder 6        ',
     s ' polder 6        ',' polder 7        ',' polder 8        ',
     s ' avhrr 1 (NOAA16)',' avhrr 2 (NOAA16)',
     s ' avhrr 1 (NOAA17)',' avhrr 2 (NOAA17)', 
     s ' avhrr 1 (NOAA18)',' avhrr 2 (NOAA18)'/ 
      data atmid /
     s 'no absorption computed                             ',
     s 'tropical            (uh2o=4.12g/cm2,uo3=.247cm-atm)',
     s 'midlatitude summer  (uh2o=2.93g/cm2,uo3=.319cm-atm)',
     s 'midlatitude winter  (uh2o=.853g/cm2,uo3=.395cm-atm)',
     s 'subarctic  summer   (uh2o=2.10g/cm2,uo3=.480cm-atm)',
     s 'subarctic  winter   (uh2o=.419g/cm2,uo3=.480cm-atm)',
     s 'us  standard 1962   (uh2o=1.42g/cm2,uo3=.344cm-atm)'/
 
      data  reflec /
     & '(1h*,12x,39h user defined spectral reflectance     ,f6.3,t79
     & ,1h*) ',
     & '(1h*,12x,27h monochromatic reflectance ,f6.3,t79,1h*)',
     & '(1h*,12x,39h constant reflectance over the spectra ,f6.3,t79
     & ,1h*) ',
     & '(1h*,12x,39h spectral vegetation ground reflectance,f6.3,t79
     & ,1h*) ',
     & '(1h*,12x,39h spectral clear water reflectance      ,f6.3,t79
     & ,1h*) ',
     & '(1h*,12x,39h spectral dry sand ground reflectance  ,f6.3,t79
     & ,1h*) ',
     & '(1h*,12x,39h spectral lake water reflectance       ,f6.3,t79
     & ,1h*) ',
     & '(1h*,12x,39h spectral volcanic debris reflectance  ,f6.3,t79
     & ,1h*) '/

      FILE='  '
      FILE2='  '

c***********************************************************************
c   Parameters  initialization
c***********************************************************************
      nt=nt_p
      mu=mu_p
      mu2=mu2_p
      np=np_p
      iwr=6
      ier=.FALSE.
      iinf=1
      isup=1501
c***********************************************************************
c  preliminary computations for gauss integration
c***********************************************************************
      pi=acos(-1.)
      pi2=2*pi
      accu2=1.E-03
      accu3=1.E-07
      do k=1,13
       angphi(k)=angphi(k)*pi/180.
      enddo
      do k=1,10
       angmu(k)=cos(angmu(k)*pi/180.)
      enddo
      call gauss(-1.,1.,anglem,weightm,mu2)
      call gauss(0.,pi2,rp,gp,np)
      mum1=mu-1
      do 581 j=-mum1,-1
       k=mu+j
       rm(-j-mu)=anglem(k)
       gb(-j-mu)=weightm(k)
  581 continue
      do 582 j=1,mum1
       k=mum1+j
       rm(mu-j)=anglem(k)
       gb(mu-j)=weightm(k)
  582 continue
      gb(-mu)=0.
      gb(0)=0.
      gb(mu)=0.

c constant values
      sigma=0.056032
      delta=0.0279
      xacc=1.e-06
      iread=5
      step=0.0025
      do 1111 l=1,10
       wldis(l)=wldisc(l)
 1111 continue
c**********************************************************************c
c       igeom               geometrical conditions                     c
c               --------------------------------------                 c
c                                                                      c
c                                                                      c
c   you choose your own conditions; igeom=0                            c
c         0     enter solar zenith angle   (in degrees )               c
c                     solar azimuth angle        "                     c
c                     satellite zenith angle     "                     c
c                     satellite azimuth angle    "                     c
c                     month                                            c
c                     day of the month                                 c
c                                                                      c
c   or you select one of the following satellite conditions:igeom=1to7 c
c         1       meteosat observation                                 c
c                 enter month,day,decimal hour (universal time-hh.ddd) c
c                       n. of column,n. of line.(full scale 5000*2500) c
c                                                                      c
c         2       goes east observation                                c
c                 enter month,day,decimal hour (universal time-hh.ddd) c
c                      n. of column,n. of line.(full scale 17000*12000)c
c                                                                      c
c         3       goes west observation                                c
c                 enter month,day,decimal hour (universal time-hh.ddd) c
c                      n. of column,n. of line.(full scale 17000*12000)c
c                                                                      c
c         4       avhrr ( PM noaa )                                    c
c                 enter month,day,decimal hour (universal time-hh.ddd) c
c                       n. of column(1-2048),xlonan,hna                c
c                       give long.(xlonan) and overpass hour (hna) at  c
c                       the ascendant node at equator                  c
c                                                                      c
c         5       avhrr ( AM noaa )                                    c
c                 enter month,day,decimal hour (universal time-hh.ddd) c
c                       n. of column(1-2048),xlonan,hna                c
c                       give long.(xlonan) and overpass hour (hna) at  c
c                       the ascendant node at equator                  c
c                                                                      c
c         6       hrv   ( spot )    * enter month,day,hh.ddd,long.,lat.c
c                                                                      c
c         7       tm    ( landsat ) * enter month,day,hh.ddd,long.,lat.c
c                                                                      c
c                                                                      c
c     note:       for hrv and tm experiments long. and lat. are the    c
c                 coordinates of the scene center.                     c
c                 lat. must be > 0 for north lat., < 0 for south lat.  c
c                 long. must be > 0 for east long., <0 for west long.  c
c                                                                      c
c                 solar and viewing positions are computed             c
c                                                                      c
c**********************************************************************c
c      read(iread,*) igeom
       igeom=0
c      goto(1001,1002,1003,1004,1005,1006,1007),igeom
c   igeom=0.....
c      read(iread,*) asol,phi0,avis,phiv,month,jday

        month=4
        jday=4
        phi0=0.0
         
      goto 22
c
c 1001 read(iread,*) month,jday,tu,nc,nl
c      call posmto(month,jday,tu,nc,nl,
c     1            asol,phi0,avis,phiv,xlon,xlat)
c      goto 22
c 1002 read(iread,*) month,jday,tu,nc,nl
c      call posge(month,jday,tu,nc,nl,
c     1           asol,phi0,avis,phiv,xlon,xlat)
c      goto 22
c 1003 read(iread,*) month,jday,tu,nc,nl
c      call posgw(month,jday,tu,nc,nl,
c     1           asol,phi0,avis,phiv,xlon,xlat)
c      goto 22
c 1004 read(iread,*) month,jday,tu,nc,xlonan,hna
c      campm=1.0
c      call posnoa(month,jday,tu,nc,xlonan,hna,campm,
c     1            asol,phi0,avis,phiv,xlon,xlat)
c      goto 22
c 1005 read(iread,*) month,jday,tu,nc,xlonan,hna
c      campm=-1.0
c      call posnoa(month,jday,tu,nc,xlonan,hna,campm,
c     1            asol,phi0,avis,phiv,xlon,xlat)
c      goto 22
c 1006 read(iread,*) month,jday,tu,xlon,xlat
c      call posspo(month,jday,tu,xlon,xlat,
c     a            asol,phi0,avis,phiv)
c      goto 22
c 1007 read(iread,*) month,jday,tu,xlon,xlat
c      call poslan(month,jday,tu,xlon,xlat,
c     s            asol,phi0,avis,phiv)
   22 continue
      if(ier) stop
      dsol=1.
      call varsol(jday,month,dsol)
 
c**********************************************************************c
      phi=abs(phiv-phi0)
      phirad=(phi0-phiv)*pi/180.
      if (phirad.lt.0.) phirad=phirad+2.*pi
      if (phirad.gt.(2.*pi)) phirad=phirad-2.*pi
      xmus=cos(asol*pi/180.)
      xmuv=cos(avis*pi/180.)
      xmup=cos(phirad)
      xmud=-xmus*xmuv-sqrt(1.-xmus*xmus)*sqrt(1.-xmuv*xmuv)*xmup
c test vermote bug
      if (xmud.gt.1.) xmud=1.
      if (xmud.lt.-1.) xmud=-1.
      adif=acos(xmud)*180./pi
 
c      read(iread,*) idatm
        idatm=8
c       idatm=6
c      if(idatm.eq.0) go to 5
c      if(idatm.eq.8) read(iread,*) uw,uo3

         uo3=0.0

c      if(idatm.ne.7) go to 6
c      do 7 k=1,34
c       read(iread,*) z(k),p(k),t(k),wh(k),wo(k)
c    7 continue
c       go to 5
c    6 if(idatm.eq.1)  call tropic
c      if(idatm.eq.2)  call midsum
c      if(idatm.eq.3)  call midwin
c      if(idatm.eq.4)  call subsum
c      if(idatm.eq.5)  call subwin
c      if(idatm.eq.6)  call us62
c     we have to define an atmosphere to compute rayleigh optical depth

c     5 if(idatm.eq.0.or.idatm.eq.8) call us62
        call us62
c**********************************************************************c
c      rmin=0.
c      rmax=0.
      icp=1
c      do i=1,4
c       x1(i)=0.0
c       x2(i)=0.0
c       x3(i)=0.0
c       do l=1,10
c       rn(l,i)=0.0
c        ri(l,i)=0.0
c       enddo
c      enddo
c      do i=1,50
c       rsunph(i)=0.
c       nrsunph(i)=0.
c      enddo
      cij(1)=1.00
 
c      read(iread,*) iaer

         iaer=0
         
c      if(iaer.eq.4) read(iread,*) (c(n),n=1,4)
      goto(49,40,41,42,49,49,49,49,43,44,45,46,47),iaer+1
 
   40 c(1)=0.70
c      c(2)=0.29
c      c(3)=0.00
c      c(4)=0.01
      go to 49
   41 c(1)=0.00
c      c(2)=0.05
c      c(3)=0.95
c      c(4)=0.00
      go to 49
   42 c(1)=0.17
c      c(2)=0.61
c      c(3)=0.00
c      c(4)=0.22
      go to 49
   43 read(iread,*) rmin,rmax,icp
c      do i=1,icp
c       read(5,*)x1(i),x2(i),cij(i)
c       read(5,*)(rn(l,i),l=1,10)
c       read(5,*)(ri(l,i),l=1,10)
c      enddo
      go to 49
   44 read(iread,*) rmin,rmax
c     read(iread,*) x1(1),x2(1),x3(1)
c      read(5,*)(rn(l,1),l=1,10)
c      read(5,*)(ri(l,1),l=1,10)
      go to 49
   45 read(iread,*) rmin,rmax
c      read(iread,*) x1(1)
c      read(5,*)(rn(l,1),l=1,10)
c      read(5,*)(ri(l,1),l=1,10)
      go to 49
   46 read(5,*)irsunph
c     do i=1,irsunph
c       read(5,*)rsunph(i),nrsunph(i)
c       nrsunph(i)=nrsunph(i)/(rsunph(i)**4.)/alog(10.0)
c      enddo
c      rmin=rsunph(1)
c      rmax=rsunph(irsunph)+1e-07
c      read(5,*)(rn(l,1),l=1,10)
c      read(5,*)(ri(l,1),l=1,10)
      go to 49
   47 read(5,'(A80)')FILE2
c      i2=index(FILE2,' ')-1
c      go to 49

   49 continue
c      if (iaer.ge.8.and.iaer.le.11)then
c       read(5,*)iaerp
c       if (iaerp.eq.1)read(5,'(A80)')FILE
c       i1=index(FILE,' ')-1
c       FILE2=FILE(1:I1)//'.mie'
c       i2=index(FILE2,' ')-1
c      endif
      
      call aeroso(iaer,c,xmud,wldis,FILE2)
 
c**********************************************************************c
      taer55=0.
      taer=0.
c      read(iread,*) v
       v=-1.0
      if(v) 71,10,11
   10 read(iread,*) taer55
      v=exp(-log(taer55/2.7628)/0.79902)
      goto 71
   11 call oda550(iaer,v,taer55)
   71 continue
c**********************************************************************c
c       read(iread,*) xps
        xps=-1.*xps      
       if (xps.ge.0.) then
        xps=0.
        uwus=1.424
        uo3us=0.344

       else
        if (idatm.ne.8) then
         call pressure(uw,uo3,xps)
        else
         call pressure(uwus,uo3us,xps)
        endif
       endif
c**********************************************************************c
c        read(iread,*) xpp
         xpp=1000.
c        xpp=-xpp
        if (xpp.le.0.0) then
c          ground measurement option        
           palt=0.
           pps=p(1)
           idatmp=0
           taer55p=0.
           puw=0.
           puoz=0.
           go to 990
        endif
         if (xpp.ge.100.) then
c              satellite case of equivalent        
              palt=1000.
              pps=0.
              taer55p=taer55
              ftray=1.
              idatmp=4
         else
c             "real" plane case       
              read(iread,*) puw,puo3
              if (puw.lt.0.) then
                 call presplane(puw,puo3,xpp,ftray)
                 idatmp=2
                 if (idatm.eq.8) then
                    puwus=puw
                    puo3us=puo3
                    puw=puw*uw/uwus
                    puo3=puo3*uo3/uo3us
                    idatmp=8
                 endif
              else
                 call presplane(puwus,puo3us,xpp,ftray)
                 idatmp=8
              endif
              if(ier) stop
              palt=zpl(34)-z(1)
              pps=ppl(34)
              read(iread,*) taer55p
         if ((taer55p.lt.0.).or.((taer55-taer55p).lt.accu2)) then
c a scale heigh of 2km is assumed in case no value is given for taer55p
           taer55p=taer55*(1.-exp(-palt/2.))
            else
C compute effective scale heigh
               sham=exp(-palt/4.)
               sha=1.-(taer55p/taer55)
               if (sha.ge.sham) then
                  taer55p=taer55*(1.-exp(-palt/4.))
               else
                  sha=-palt/log(sha)
                  taer55p=taer55*(1.-exp(-palt/sha))
               endif
            endif
         endif

c        51  1st band of avhrr(noaa14 ( 0.500-1.110;.5500-.8000 )                  c
c        52  2nd      "               ( 0.680-1.100;.6800-1.075 )                  c
c        62  1st band of avhrr NOAA16 (0.4-3.4;0.5737-0.6974)
c        63  2nd band of AVHRR NOAA16 (0.4-6.4;0.6913-1.0251)
c        64  1st band of avhrr NOAA17 (0.400-3.4;)
c        65  2nd band of AVHRR NOAA17 (0.400-6.4;)
c 

 990   do 38 l=iinf,isup
       s(l)=1.
   38 continue
c      read(iread,*) iwave
c       iwave=51 should correspond to N14 Ch1 in AVHRR.f
c       iwave=62 should correspond to N16 Ch1 in AVHRR.f
c
c Uncomment one, and only one, of the following iwave assignments
c      NOAA 14
c         iwave=n+50
c      NOAA 17
c       iwave=n+63
C  NOAA 16
c       iwave=n+61
c      NOAA 18
        iwave=n+65
c
      if (iwave.eq.-2) goto 1600
      if (iwave) 16,17,18
   16 read(iread,*) wl
      wlinf=wl
      wlsup=wl
      go to 19
   17 read(iread,*) wlinf,wlsup
      go to 19
 1600 read(iread,*) wlinf,wlsup
      go to 19
   18 goto (110,111,112,112,114,114,114,114,114,114,114,114
     s      ,114,114,114,114,118,118,118,118,118,118,118,118
     s     ,121,121,121,121,121,121,127,127,127,127
     s     ,128,128,128,128,128,128,128,129,129,129,129,129
     s     ,129,129,130,130,130,130,131
     s     ,131,131,131,131,131,131,131,131,132,132,132,132
     s     ,132,132),iwave
  110 read(iread,*) wlinf,wlsup
      iinf=(wlinf-.25)/0.0025+1.5
      isup=(wlsup-.25)/0.0025+1.5
      do 1113 ik=iinf,isup
       s(ik)=0.
 1113 continue
      read(iread,*) (s(i),i=iinf,isup)
      goto 20
  111 call meteo
      go to 19
  112 call goes(iwave-2)
      go to 19
  114 call avhrr(iwave-4)
      go to 19
  118 call hrv(iwave-16)
      go to 19
  121 call tm(iwave-24)
      go to 19
  127 call mss(iwave-30)
      goto 19
  128 call mas(iwave-34)
      goto 19
  129 call modis(iwave-41)
      goto 19
  130 call avhrr(iwave-36)
      goto 19
  131 call polder(iwave-52)
  132 call avhrr(iwave-45)
c     print *,'iwave,nsat=',iwave,nsat
   19 iinf=(wlinf-.25)/0.0025+1.5
      isup=(wlsup-.25)/0.0025+1.5
   20 continue
 
      if(iwave.ne.-1) then
        call equivwl(iinf,isup,step,wlmoy)
      else
        wlmoy=wl
      endif
      call discom (idatmp,iaer,xmus,xmuv,phi
     a            ,taer55,taer55p,palt,
     a           phirad,nt,mu,np,rm,gb,rp
     s         ,ftray,xlm1,xlm2)
      if(iaer.ne.0) then
        call specinterp(wlmoy,taer55,taer55p,
     s     tamoy,tamoyp,pizmoy,pizmoyp)
      endif
      call odrayl(wlmoy,
     s                   trmoy)
      trmoyp=trmoy*ftray
      if (idatmp.eq.4) then
          trmoyp=trmoy
          tamoyp=tamoy
      endif
      if (idatmp.eq.0) then
         trmoyp=0.
         tamoyp=0.
      endif
c                                                                      c
c                            ****tree****                              c
c                                                                      c
c                               inhomo                                 c
c                             /          \                             c
c                            /            \                            c
c                           /              \                           c
c                          /                \                          c
c                 ------- 0 -------       -----1 -----                 c
c                        /               /   \       \                 c
c                    idirec             /     \       \                c
c                    /  \              /       \       \               c
c                   /    \            /         \       \              c
c                  /      \       igrou1       igrou2    rad           c
c                 0        1        roc          roe     f(r)          c
c                /          \                                          c
c               /            \                                         c
c           igroun          ibrdf                                      c
c        (roc = roe)        (roc)                                      c
c                           (robar)                                    c
c                           (robarp)                                   c
c                           (robard)                                   c
c                                                                      c
c**********************************************************************c
                                                                        
      fr=0.
      rad=0.
      do 1116 ik=iinf,isup
        rocl(ik)=0.
        roel(ik)=0.
 1116 continue
 
c**********************************************************************c
c     uniform or non-uniform surface conditions                        c
c**********************************************************************c
c      read(iread,*) inhomo
      inhomo=0
      if(inhomo) 30,30,31
   30   idirec=0
c  30  read(iread,*) idirec
      if(idirec)21,21,25
 
c**********************************************************************c
c     uniform conditions with brdf conditions                          c
c**********************************************************************c
c call os to compute downward radiation field for robar
  25   rm(-mu)=-xmuv
      rm(mu)=xmuv
      rm(0)=-xmus
      spalt=1000.
      call os(tamoy,trmoy,pizmoy,tamoyp,trmoyp,spalt,
     s               phirad,nt,mu,np,rm,gb,rp,
     s                     xlmus)
c call os to compute downward radiation field for robarp
      if (idatmp.ne.0) then
        rm(-mu)=-xmus
        rm(mu)=xmus
        rm(0)=-xmuv
        call os(tamoyp,trmoyp,pizmoy,tamoyp,trmoyp,spalt,
     s               phirad,nt,mu,np,rm,gb,rp,
     s                     xlmuv)
      endif

c      read(iread,*) ibrdf
c*********************************************************************c
      if(ibrdf)23,23,24
c**********************************************************************c
c     brdf from in-situ measurements                                   c
c**********************************************************************c
  23  do 900 k=1,13
        read(iread,*) (brdfdats(10-j+1,k),j=1,10)
  900 continue
      do 901 k=1,13
        read(iread,*) (brdfdatv(10-j+1,k),j=1,10)
  901 continue
      read(iread,*) albbrdf
      read(iread,*) rodir
      rm(-mu)=phirad
      rm(mu)=xmuv
      rm(0)=xmus
      call brdfgrid(mu,np,rm,rp,brdfdats,angmu,angphi,
     s                 brdfints)
      rm(-mu)=2.*pi-phirad
      rm(mu)=xmus
      rm(0)=xmuv
      call brdfgrid(mu,np,rm,rp,brdfdatv,angmu,angphi,
     s                 brdfintv)
       brdfints(mu,1)=rodir
      go to 69
c**********************************************************************c
c     brdf from hapke's model                                          c
c**********************************************************************c
  24  if(ibrdf.eq.1) then
        read(iread,*) par1,par2,par3,par4
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call hapkbrdf(par1,par2,par3,par4,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call hapkbrdf(par1,par2,par3,par4,mu,np,rm,rp,
     s           brdfintv)
        call hapkalbe(par1,par2,par3,par4,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from verstraete et al's model                               c
c**********************************************************************c
      if(ibrdf.eq.2) then
        read(iread,*) (options(i),i=3,5)
        options(1)=1
        options(2)=1
        read(iread,*) (struct(i),i=1,4)
        read(iread,*) (optics(i),i=1,3)
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call versbrdf(options,optics,struct,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call versbrdf(options,optics,struct,mu,np,rm,rp,
     s           brdfintv)
        call versalbe(options,optics,struct,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from Roujean et al's model                                  c
c**********************************************************************c
      if(ibrdf.eq.3) then
        read(iread,*) par1,par2,par3
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call roujbrdf(par1,par2,par3,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call roujbrdf(par1,par2,par3,mu,np,rm,rp,
     s           brdfintv)
        call roujalbe(par1,par2,par3,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from walthall et al's model
c**********************************************************************c
      if(ibrdf.eq.4) then
        read(iread,*) par1,par2,par3,par4
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call waltbrdf(par1,par2,par3,par4,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call waltbrdf(par1,par2,par3,par4,mu,np,rm,rp,
     s           brdfintv)
        call waltalbe(par1,par2,par3,par4,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from minnaert's model                                       c
c**********************************************************************c
      if(ibrdf.eq.5) then
        read(iread,*) par1,par2
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call minnbrdf(par1,par2,mu,np,rm,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call minnbrdf(par1,par2,mu,np,rm,
     s           brdfintv)
        call minnalbe(par1,par2,
     s       albbrdf)
        go to 69
      endif
 
c**********************************************************************c
c     brdf from ocean condition
c**********************************************************************c
      if(ibrdf.eq.6) then
        read(iread,*) pws,phi_wind,xsal,pcl
        if (xsal.lt.0.001)xsal=34.3
        paw=phi0-phi_wind
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call oceabrdf(pws,paw,xsal,pcl,wlmoy,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call oceabrdf(pws,paw,xsal,pcl,wlmoy,mu,np,rm,rp,
     s           brdfintv)
        call oceaalbe(pws,paw,xsal,pcl,wlmoy,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from Iaquinta and Pinty model
c**********************************************************************c
      if(ibrdf.eq.7) then
        read(iread,*) pild,pihs
        read(iread,*) pxLt,pc
        read(iread,*) pRl,pTl,pRs
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call iapibrdf(pild,pxlt,prl,ptl,prs,pihs,pc,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call iapibrdf(pild,pxlt,prl,ptl,prs,pihs,pc,mu,np,rm,rp,
     s           brdfintv)
        call iapialbe(pild,pxlt,prl,ptl,prs,pihs,pc,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from Rahman model                
c**********************************************************************c
      if(ibrdf.eq.8) then
        read(iread,*) par1,par2,par3
        rm(-mu)=phirad
        rm(mu)=xmuv
        rm(0)=xmus
        call rahmbrdf(par1,par2,par3,mu,np,rm,rp,
     s           brdfints)
        rm(-mu)=2.*pi-phirad
        rm(mu)=xmus
        rm(0)=xmuv
        call rahmbrdf(par1,par2,par3,mu,np,rm,rp,
     s           brdfintv)
        call rahmalbe(par1,par2,par3,
     s       albbrdf)
        go to 69
      endif
c**********************************************************************c
c     brdf from kuusk's msrm model                                     c
c**********************************************************************c
      if(ibrdf.eq.9) then
         read(iread,*) uli,eei,thmi,sli
         read(iread,*) cabi,cwi,vaii,rnci,rsl1i
         rm(-mu)=phirad
         rm(mu)=xmuv
         rm(0)=xmus
         call akbrdf(eei,thmi,uli,sli,rsl1i,wlmoy,rnci,cabi,cwi,vaii
     &            ,mu,np,rm,rp,brdfints)
         rm(-mu)=2.*pi-phirad
         rm(mu)=xmus
         rm(0)=xmuv
         call akbrdf(eei,thmi,uli,sli,rsl1i,wlmoy,rnci,cabi,cwi,vaii
     &            ,mu,np,rm,rp,brdfintv)
c
         call akalbe
*    & (eei,thmi,uli,sli,rsl1i,wlmoy,rnci,cabi,cwi,vaii,albbrdf)
     & (albbrdf)
         go to 69
      endif
c
   69 continue
c**********************************************************************c
      robar1=0.
      xnorm1=0.
      do 83 j=1,np
        rob=0.
        xnor=0.
        do 84 k=1,mu-1
          rdown=xlmus(-k,j)
          rdir=brdfintv(k,j)
          rob=rob+rdown*rdir*rm(k)*gb(k)
          xnor=xnor+rdown*rm(k)*gb(k)
   84   continue
        robar1=robar1+rob*gp(j)
        xnorm1=xnorm1+xnor*gp(j)
   83 continue
c**********************************************************************c
      robar2=0.
      xnorm2=0.
      do 85 j=1,np
        rob=0.
        xnor=0.
        do 86 k=1,mu-1
          rdown=xlmuv(-k,j)
          rdir=brdfints(k,j)
          rob=rob+rdown*rdir*rm(k)*gb(k)
          xnor=xnor+rdown*rm(k)*gb(k)
   86   continue
        robar2=robar2+rob*gp(j)
        xnorm2=xnorm2+xnor*gp(j)
   85 continue
 
      do 335 l=iinf,isup
        rocl(l)=brdfints(mu,1)
        roel(l)=brdfints(mu,1)
        robar(l)=robar1/xnorm1
        if (idatmp.ne.0) then
          robarp(l)=robar2/xnorm2
        else
          robarp(l)=0.
          xnorm2=1.
          robar2=0.
        endif
        robard(l)=albbrdf
  335 continue
      go to 34
c**********************************************************************c
c     uniform surface with lambertian conditions                       c
c**********************************************************************c
c  21  read(iread,*) igroun
  21   igroun=0
      if(igroun) 29,32,33
  29  read(iread,*) (rocl(i),i=iinf,isup)
      goto 36
  32   if (iwave .eq. 51) then
         seb=154.901 
         sb=0.0961191  
        ro=pi*rapp*sb/xmus/seb
      endif
       if (iwave .eq. 52) then
         seb=250.546 
         sb=0.243512 
        ro=pi*rapp*sb/xmus/seb
      endif 
c       print *, 'ro=',ro
c  32  read(iread,*) ro
      do 35 l=iinf,isup
        rocl(l)=ro
   35 continue
      goto 36
  33  if(igroun.eq.1) call vegeta(rocl)
      if(igroun.eq.2) call clearw(rocl)
      if(igroun.eq.3) call sand  (rocl)
      if(igroun.eq.4) call lakew (rocl)
   36 do 39 l=iinf,isup
        roel(l)=rocl(l)
   39 continue
      go to 34
c**********************************************************************c
c     non-uniform conditions with lambertian conditions                c
c**********************************************************************c
 31   read(iread,*) igrou1,igrou2,rad
      if(igrou1) 59,60,63
  59  read(iread,*) (rocl(i),i=iinf,isup)
      goto 61
  60  read(iread,*) roc
      do 64 l=iinf,isup
        rocl(l)=roc
  64  continue
      go to 61
  63  if(igrou1.eq.1) call vegeta(rocl)
      if(igrou1.eq.2) call clearw(rocl)
      if(igrou1.eq.3) call sand  (rocl)
      if(igrou1.eq.4) call lakew (rocl)
   61 if(igrou2) 66,62,65
  66  read(iread,*) (roel(i),i=iinf,isup)
      goto 34
  62  read(iread,*) roe
      do 67 l=iinf,isup
        roel(l)=roe
   67 continue
      go to 34
  65  if(igrou2.eq.1) call vegeta(roel)
      if(igrou2.eq.2) call clearw(roel)
      if(igrou2.eq.3) call sand  (roel)
      if(igrou2.eq.4) call lakew (roel)
   34 continue
c**********************************************************************c
 
c      read(iread,*) rapp
 
c**********************************************************************c
c                     print of initial conditions                      c
c                                                                      c
c**********************************************************************c
c ---- geometrical conditions ----
c      write(iwr, 98)
c      write(iwr, etiq1(igeom+1))
c      if(igeom.eq.0) then
c        write(iwr, 1401)
c        write(iwr, 103)month,jday
c      endif
c      if(igeom.ne.0) write(iwr, 101)month,jday,tu,xlat,xlon
c      write(iwr, 102)asol,phi0
c      write(iwr, 1110)avis,phiv,adif,phi
c --- atmospheric model ----
c      write(iwr, 1119)
c      if(idatm-7)226,227,228
c  228 write(iwr, 1281)uw,uo3
c      goto 219
c  227 write(iwr, 1272)
c      do 229 i=1,34
c        write(iwr, 1271)z(i),p(i),t(i),wh(i),wo(i)
c  229 continue
c      goto 219
c  226 write(iwr, 1261)atmid(idatm+1)
c --- aerosols model (type) ----
c 219  if (iaer.lt.4) then
c        goto(230,231,232,233),iaer+1
c      else
c        if (iaer.ge.5.and.iaer.le.7) goto(234,235,236),iaer-4
c        if (iaer.eq.4)write(iwr,133)(c(i),i=1,4)
c        if (iaer.eq.8)then
c          write(iwr,134)icp
c          do i=1,icp
c            write(iwr,135)x1(i),x2(i),cij(i)
c          enddo
c        endif
c        if (iaer.eq.9)write(iwr,136)x1(1),x2(1),x3(1)
c        if (iaer.eq.10)write(iwr,137)x1(1)
c        if (iaer.eq.11)write(iwr, 132)' Sun Photometer'
c        if (iaer.eq.12)write(iwr,138)FILE2(1:i2)
c       if (iaerp.eq.1)write(iwr,139)FILE2(1:i2)
c        goto 249
c      endif
c  234 write(iwr, 132)'       Desertic'
c      goto 249
c  235 write(iwr, 132)'          Smoke'
c      goto 249
c  236 write(iwr, 132)'  Stratospheric'
c      goto 249
c  233 write(iwr, 132)'          Urban'
c      go to 249
c  232 write(iwr, 132)'       Maritime'
c      goto 249
c  231 write(iwr, 132)'    Continental'
c      goto 249
c  230 write(iwr, 1301)
c  249 continue
c --- aerosol model (concentration) ----
c      if(iaer.eq.0) write(iwr, 1401)
c      if(iaer.eq.0) goto 1112
c     if(abs(v).le.xacc) write(iwr, 140)taer55
c      if(abs(v).gt.xacc) write(iwr, 141)v,taer55
c --- spectral condition ----
c 1112 write(iwr, 148)
c      if(iwave.eq.-2) write(iwr, 1510) nsat(1),wlinf,wlsup
c      if(iwave.eq.-1) write(iwr, 149) wl
c      if(iwave.ge.0) write(iwr, 1510) nsat(iwave+1), wlinf,wlsup
c --- ground reflectance (type and spectral variation) ----
       if(idirec.eq.0) then
        rocave=0.
        roeave=0.
        seb=0.
 
        do 264 i=iinf,isup
          sbor=s(i)
          if(i.eq.iinf.or.i.eq.isup) sbor=sbor*0.5
          wl=.25+(i-1)*step
          call solirr(wl,swl)
          swl=swl*dsol
          rocave=rocave+rocl(i)*sbor*swl*step
          roeave=roeave+roel(i)*sbor*swl*step
          seb=seb+sbor*swl*step
  264   continue
        rocave=rocave/seb
        roeave=roeave/seb
        isort=0
        ro=rocave
c         ro=pi*rapp*sb/xmus/seb 
        if(inhomo.eq.0) goto 260
c        write(iwr, 169)rad
        igroun=igrou1
        ro=rocave
c        write(iwr, 170)
        goto 261
 
  262   igroun=igrou2
        ro=roeave
c        write(iwr, 171)
        goto 261
  260   go to 158 
c  260   write(iwr, 168)
c  261   if (igroun.gt.0)write(iwr, reflec(igroun+3))ro
  261      if (igroun.gt.0)goto 158
c        if(igroun.eq.-1) write(iwr, reflec(1))ro
        if(igroun.eq.-1) goto 158
c        if(iwave.eq.-1)  write(iwr, reflec(2))ro
c        if(iwave.ne.-1)  write(iwr, reflec(3))ro
 158    isort=isort+1
        if(inhomo.eq.0) goto 999
        if(isort.eq.2) goto 999
        goto 262
      else
c        write(iwr, 168)
      endif
        if(idirec.eq.1) then
         goto(2000,2001,2002,2003,2004,2005,2006,2007,2008,2010)
     *    ,(ibrdf+1)
 2000     goto 2009
c 2000    write(iwr, 190)
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2001    goto 2009
c 2001    write(iwr, 191)par1,par2,par3,par4
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2002    goto 2009
c 2002    write(iwr, 192)optics(1),struct(1),struct(2)
c         if (options(5).eq.0) write(iwr, 200)
c         if (options(5).eq.1) write(iwr, 201)
c         if (options(3).eq.0) write(iwr, 197)struct(3),struct(4)
c         if (options(3).eq.1) write(iwr, 198)struct(3)
c         if (options(3).eq.2) write(iwr, 199)struct(3)
c         if (options(4).eq.0) write(iwr, 202)
c         if (options(4).eq.1) write(iwr, 203)optics(2)
c         if (options(4).eq.2) write(iwr, 204)optics(2),optics(3)
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2003    goto 2009
c 2003    write(iwr, 193)par1,par2,par3
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2004    goto 2009
c 2004    write(iwr, 194)par1,par2,par3,par4
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2005    goto 2009
c 2005    write(iwr, 195)par1,par2
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2006    goto 2009
c 2006    write(iwr, 196)pws,phi_wind,xsal,pcl
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2007        goto 2009
c 2007    write(iwr, 205) pRl,pTl,pRs,PxLt
c         if (pihs.eq.0) then
c           write(iwr,207)' no hot spot       '
c         else)
c           write(iwr,208)' hot spot parameter',pc
c         endif
c         if (pild.eq.1) write(iwr,209) ' planophile leaf distr.' 
c         if (pild.eq.2) write(iwr,209) ' erectophile leaf distr.'
c         if (pild.eq.3) write(iwr,209) ' plagiophile leaf distr.'
c         if (pild.eq.4) write(iwr,209) ' extremophile leaf distr.'
c         if (pild.eq.5) write(iwr,209) ' uniform leaf distr.'
c         write(iwr, 187)
c     *brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
 2008    goto 2009
c 2008    write(iwr, 206) par1,par2,par3
 2010    goto 2009
c 2010    write(iwr, 210)uli,eei,thmi,sli,cabi,cwi,vaii,rnci,rsl1i
c         write(iwr, 187)
c     *   brdfints(mu,1),robar1/xnorm1,robar2/xnorm2,albbrdf
c         goto 2009
c 2009   endif
 2009   endif

c --- pressure at ground level (174) and altitude (175) ----
  999  goto 998 
c  999 write(iwr, 173)
c      write(iwr, 174)p(1)
c      write(iwr, 175)xps
c      if (xps.gt.0.) write(iwr, 176)uw,uo3
 
c --- plane simulation output if selected ----
c      if (palt.lt.1000.) then
c       write(iwr, 178)
c       write(iwr, 179)pps
c       write(iwr, 180)zpl(34)
c       write(iwr, 181)
c       write(iwr, 182)puo3
c       write(iwr, 183)puw
c       write(iwr, 184)taer55p
c      endif
 
c ---- atmospheric correction  ----
c      if (rapp.gt.-1.) then
c       write(iwr, 177)
c       if (rapp.lt.0.) then
c        write(iwr, 185)-rapp
c       else
c        write(iwr, 186)rapp
c       endif
c      endif
c      write(iwr, 172)
c**********************************************************************c
c                     start of computations                            c
c**********************************************************************c

c ---- initilialization
998   sb=0.
      seb=0.
      refet=0.
      refet1=0.
      refet2=0.
      refet3=0.
      alumet=0.
      tgasm=0.
      rog=0.
      dgasm=0.
      ugasm=0.
      sdwava=0.
      sdozon=0.
      sddica=0.
      sdoxyg=0.
      sdniox=0.
      sdmoca=0.
      sdmeth=0.
      suwava=0.
      suozon=0.
      sudica=0.
      suoxyg=0.
      suniox=0.
      sumoca=0.
      sumeth=0.
      stwava=0.
      stozon=0.
      stdica=0.
      stoxyg=0.
      stniox=0.
      stmoca=0.
      stmeth=0.
      sodray=0.
      sodrayp=0.
      sodaer=0.
      sodaerp=0.
      sodtot=0.
      sodtotp=0.
      fophsr=0.
      fophsa=0.
      sroray=0.
      sroaer=0.
      srotot=0.
      ssdaer=0.
      sdtotr=0.
      sdtota=0.
      sdtott=0.
      sutotr=0.
      sutota=0.
      sutott=0.
      sasr=0.
      sasa=0.
      sast=0.
      do 52 i=1,2
        do 53 j=1,3
          ani(i,j)=0.
          aini(i,j)=0.
          anr(i,j)=0.
          ainr(i,j)=0.
   53   continue
   52 continue

c ---- spectral loop ----
c      if (iwave.eq.-2) write(iwr,1500)
      do 51 l=iinf,isup
        sbor=s(l)
        if(l.eq.iinf.or.l.eq.isup) sbor=sbor*0.5
        if(iwave.eq.-1) sbor=1.0/step
        roc=rocl(l)
        roe=roel(l)
        wl=.25+(l-1)*step
c
        call abstra(idatm,wl,xmus,xmuv,uw/2.,uo3,uwus,uo3us,
     a             idatmp,puw/2.,puo3,puwus,puo3us,
     a      dtwava,dtozon,dtdica,dtoxyg,dtniox,dtmeth,dtmoca,
     a      utwava,utozon,utdica,utoxyg,utniox,utmeth,utmoca,
     a      attwava,ttozon,ttdica,ttoxyg,ttniox,ttmeth,ttmoca )
        call abstra(idatm,wl,xmus,xmuv,uw,uo3,uwus,uo3us,
     a             idatmp,puw,puo3,puwus,puo3us,
     a      dtwava,dtozon,dtdica,dtoxyg,dtniox,dtmeth,dtmoca,
     a      utwava,utozon,utdica,utoxyg,utniox,utmeth,utmoca,
     a      ttwava,ttozon,ttdica,ttoxyg,ttniox,ttmeth,ttmoca )
        if (dtwava.lt.accu3) dtwava=0.
        if (dtozon.lt.accu3) dtozon=0.
        if (dtdica.lt.accu3) dtdica=0.
        if (dtniox.lt.accu3) dtniox=0.
        if (dtmeth.lt.accu3) dtmeth=0.
        if (dtmoca.lt.accu3) dtmeth=0.
        if (utwava.lt.accu3) utwava=0.
        if (utozon.lt.accu3) utozon=0.
        if (utdica.lt.accu3) utdica=0.
        if (utniox.lt.accu3) utniox=0.
        if (utmeth.lt.accu3) utmeth=0.
        if (utmoca.lt.accu3) utmeth=0.
        if (ttwava.lt.accu3) ttwava=0.
        if (ttozon.lt.accu3) ttozon=0.
        if (ttdica.lt.accu3) ttdica=0.
        if (ttniox.lt.accu3) ttniox=0.
        if (ttmeth.lt.accu3) ttmeth=0.
        if (ttmoca.lt.accu3) ttmeth=0.
c
        call solirr(wl,swl)
        swl=swl*dsol
        coef=sbor*step*swl

        call interp (iaer,idatmp,wl,taer55,taer55p,xmud,
     s             romix,rorayl,roaero,phaa,phar,tsca,
     s             tray,trayp,taer,taerp,dtott,utott,
     s             astot,asray,asaer,
     s             utotr,utota,dtotr,dtota)
       If (iaer .eq.0) then
          astot=asray
          dtott=dtotr
          utott=utotr
       endif
        dgtot=dtwava*dtozon*dtdica*dtoxyg*dtniox*dtmeth*dtmoca
        tgtot=ttwava*ttozon*ttdica*ttoxyg*ttniox*ttmeth*ttmoca
        ugtot=utwava*utozon*utdica*utoxyg*utniox*utmeth*utmoca
        tgp1=ttozon*ttdica*ttoxyg*ttniox*ttmeth*ttmoca
        tgp2=attwava*ttozon*ttdica*ttoxyg*ttniox*ttmeth*ttmoca
        edifr=utotr-exp(-trayp/xmuv)
        edifa=utota-exp(-taerp/xmuv)
        if (idirec.eq.1) then
          tdird=exp(-(trayp+taerp)/xmus)
          tdiru=exp(-(trayp+taerp)/xmuv)
          tdifd=dtott-tdird
          tdifu=utott-tdiru
          rsurf=roc*tdird*tdiru+
     s          robar(l)*tdifd*tdiru+robarp(l)*tdifu*tdird+
     s          robard(l)*tdifd*tdifu+
     S   (tdifd+tdird)*(tdifu+tdiru)*astot*robard(l)*robard(l)
     s          /(1.-astot*robard(l))
        avr=robard(l)
        else
          call enviro(edifr,edifa,rad,palt,xmuv,
     s               fra,fae,fr)
          avr=roc*fr+(1.-fr)*roe
          rsurf=roc*dtott*exp(-(trayp+taerp)/xmuv)/(1.-avr*astot)
     s       +avr*dtott*(utott-exp(-(trayp+taerp)/xmuv))/(1.-avr*astot)
        endif
        ratm1=(romix-rorayl)*tgtot+rorayl*tgp1
        ratm3=romix*tgp1
        ratm2=(romix-rorayl)*tgp2+rorayl*tgp1
c      print *,'ratm1,ratm2,ratm3,tgp1,romix=',ratm1,ratm2,ratm3,tgp1,romix
        romeas1=ratm1+rsurf*tgtot
        romeas2=ratm2+rsurf*tgtot
        romeas3=ratm3+rsurf*tgtot
C    computing integrated values over the spectral band
c        if (iwave.eq.-2) then
c          write(iwr,1501) wl,tgtot,dtott,utott,astot,ratm2,swl,step,
c     s            sbor,dsol,romeas2
c        endif
c      print *,'astot/sutott/sdtott,sast=',astot,sutott,sdtott,sast 
        alumeas=xmus*swl*romeas2/pi
        fophsa=fophsa+phaa*coef
        fophsr=fophsr+phar*coef
        sasr=sasr+asray*coef
        sasa=sasa+asaer*coef
        sast=sast+astot*coef
        sroray=sroray+rorayl*coef
        sroaer=sroaer+roaero*coef
        sodray=sodray+tray*coef
        sodaer=sodaer+taer*coef
        sodrayp=sodrayp+trayp*coef
        sodaerp=sodaerp+taerp*coef
        ssdaer=ssdaer+tsca*coef
        sodtot=sodtot+(taer+tray)*coef
        sodtotp=sodtotp+(taerp+trayp)*coef
        srotot=srotot+(romix)*coef
        rog=rog+roc*coef
        refet=refet+romeas2*coef
        refet1=refet1+romeas1*coef
        refet2=refet2+romeas2*coef
        refet3=refet3+romeas3*coef
        alumet=alumet+alumeas*sbor*step
        tgasm=tgasm+tgtot*coef
        dgasm=dgasm+dgtot*coef
        ugasm=ugasm+ugtot*coef
        sdwava=sdwava+dtwava*coef
        sdozon=sdozon+dtozon*coef
        sddica=sddica+dtdica*coef
        sdoxyg=sdoxyg+dtoxyg*coef
        sdniox=sdniox+dtniox*coef
        sdmeth=sdmeth+dtmeth*coef
        sdmoca=sdmoca+dtmoca*coef
        suwava=suwava+utwava*coef
        suozon=suozon+utozon*coef
        sudica=sudica+utdica*coef
        suoxyg=suoxyg+utoxyg*coef
        suniox=suniox+utniox*coef
        sumeth=sumeth+utmeth*coef
        sumoca=sumoca+utmoca*coef
        stwava=stwava+ttwava*coef
        stozon=stozon+ttozon*coef
        stdica=stdica+ttdica*coef
        stoxyg=stoxyg+ttoxyg*coef
        stniox=stniox+ttniox*coef
        stmeth=stmeth+ttmeth*coef
        stmoca=stmoca+ttmoca*coef
        sdtotr=sdtotr+dtotr*coef
        sdtota=sdtota+dtota*coef
        sdtott=sdtott+dtott*coef
        sutotr=sutotr+utotr*coef
        sutota=sutota+utota*coef
        sutott=sutott+utott*coef
        sb=sb+sbor*step
        seb=seb+coef

c    output at the ground level.
        tdir=exp(-(tray+taer)/xmus)
        tdif=dtott-tdir
        etn=dtott*dgtot/(1.-avr*astot)
        esn=tdir*dgtot
        es=tdir*dgtot*xmus*swl
        ea0n=tdif*dgtot
        ea0=tdif*dgtot*xmus*swl
        ee0n=dgtot*avr*astot*dtott/(1.-avr*astot)
        ee0=xmus*swl*dgtot*avr*astot*dtott/(1.-avr*astot)
        if (etn.gt.accu3) then
           ani(1,1)=esn/etn
           ani(1,2)=ea0n/etn
           ani(1,3)=ee0n/etn
        else
           ani(1,1)=0.
           ani(1,2)=0.
           ani(1,3)=0.
        endif
        ani(2,1)=es
        ani(2,2)=ea0
        ani(2,3)=ee0
        do 955 j=1,3
          aini(1,j)=aini(1,j)+ani(1,j)*coef
          aini(2,j)=aini(2,j)+ani(2,j)*sbor*step
  955   continue
 
c    output at satellite level
        tmdir=exp(-(tray+taer)/xmuv)
        tmdif=utott-tmdir
        xla0n=ratm2
        xla0=xla0n*xmus*swl/pi
        xltn=roc*dtott*tmdir*tgtot/(1.-avr*astot)
        xlt=xltn*xmus*swl/pi
        xlen=avr*dtott*tmdif*tgtot/(1.-avr*astot)
        xle=xlen*xmus*swl/pi
        anr(1,1)=xla0n
        anr(1,2)=xlen
        anr(1,3)=xltn
        anr(2,1)=xla0
        anr(2,2)=xle
        anr(2,3)=xlt
        do 56 j=1,3
          ainr(1,j)=ainr(1,j)+anr(1,j)*coef
          ainr(2,j)=ainr(2,j)+anr(2,j)*sbor*step
   56   continue
   51 continue
 
c ---- integrated values of apparent reflectance, radiance          ----
 
c ---- and gaseous transmittances (total,downward,separately gases) ----
      refet=refet/seb
      refet1=refet1/seb
      refet2=refet2/seb
      refet3=refet3/seb
      tgasm=tgasm/seb
      dgasm=dgasm/seb
      ugasm=ugasm/seb
      sasa=sasa/seb
      sasr=sasr/seb
      sast=sast/seb
      sdniox=sdniox/seb
      sdmoca=sdmoca/seb
      sdmeth=sdmeth/seb
      sdwava=sdwava/seb
      sdozon=sdozon/seb
      sddica=sddica/seb
      suniox=suniox/seb
      sumoca=sumoca/seb
      sumeth=sumeth/seb
      suwava=suwava/seb
      suozon=suozon/seb
      sudica=sudica/seb
      suoxyg=suoxyg/seb
      sdoxyg=sdoxyg/seb
      stniox=stniox/seb
      stmoca=stmoca/seb
      stmeth=stmeth/seb
      stwava=stwava/seb
      stozon=stozon/seb
      stdica=stdica/seb
      stoxyg=stoxyg/seb
      sdtotr=sdtotr/seb
      sdtota=sdtota/seb
      sdtott=sdtott/seb
      sutotr=sutotr/seb
      sutota=sutota/seb
      sutott=sutott/seb
      rog=rog/seb
      sroray=sroray/seb
      sroaer=sroaer/seb
      srotot=srotot/seb
      alumet=alumet/sb
      pizera=0.0
      if(iaer.ne.0) pizera=ssdaer/sodaer
      sodray=sodray/seb
      sodaer=sodaer/seb
      sodtot=sodtot/seb
      sodrayp=sodrayp/seb
      sodaerp=sodaerp/seb
      sodtotp=sodtotp/seb
      fophsa=fophsa/seb
      fophsr=fophsr/seb
 
      do 57 j=1,3
        aini(1,j)=aini(1,j)/seb
        ainr(1,j)=ainr(1,j)/seb
        aini(2,j)=aini(2,j)/sb
        ainr(2,j)=ainr(2,j)/sb
   57 continue
 
c**********************************************************************c
c                       print of final results                         c
c**********************************************************************c
c 160  write(iwr, 430 )refet,alumet,tgasm
c      write(iwr, 431 )refet1,refet2,refet3
c      if(inhomo.ne.0) then
c        write(iwr, 432)(aini(1,j),j=1,3),'environment','target',
c     s          (ainr(1,j),j=1,3)
c        write(iwr, 434)(aini(2,j),j=1,3),'environment','target',
c     s         (ainr(2,j),j=1,3)
c      endif
c      if(inhomo.eq.0) then
c        write(iwr, 432)(aini(1,j),j=1,3),'background ','pixel ',
c     s         (ainr(1,j),j=1,3)
c        write(iwr, 434)(aini(2,j),j=1,3),'background ','pixel ',
c     s         (ainr(2,j),j=1,3)
c      endif
c      if (iwave.eq.-1)then
c        write(iwr, 436)seb
c      else
c        write(iwr, 437)sb,seb
c      endif

c**********************************************************************c
c                    print of complementary results                    c
c**********************************************************************c
c      write(iwr, 929)
c      write(iwr, 930)
c      write(iwr, 931)'global gas. trans. :',dgasm,ugasm,tgasm
c      write(iwr, 931)'water   "     "    :',sdwava,suwava,stwava
c      write(iwr, 931)'ozone   "     "    :',sdozon,suozon,stozon
c      write(iwr, 931)'co2     "     "    :',sddica,sudica,stdica
c      write(iwr, 931)'oxyg    "     "    :',sdoxyg,suoxyg,stoxyg
c      write(iwr, 931)'no2     "     "    :',sdniox,suniox,stniox
c      write(iwr, 931)'ch4     "     "    :',sdmeth,sumeth,stmeth
c      write(iwr, 931)'co      "     "    :',sdmoca,sumoca,stmoca
c      write(iwr, 1401)
c      write(iwr, 1401)
c 
c      write(iwr, 931)'rayl.  sca. trans. :',sdtotr,sutotr,sutotr*sdtotr
         raysc=sutotr*sdtotr
c      write(iwr, 931)'aeros. sca.   "    :',sdtota,sutota,sutota*sdtota
c      write(iwr, 931)'total  sca.   "    :',sdtott,sutott,sutott*sdtott
c      write(iwr, 1401)
c      write(iwr, 1401)
c      write(iwr, 939)
c      write(iwr, 931)'spherical albedo   :',sasr,sasa,sast
c      write(iwr, 931)'optical depth total:',sodray,sodaer,sodtot
c      write(iwr, 931)'optical depth plane:',sodrayp,sodaerp,sodtotp
c      write(iwr, 931)'reflectance        :',sroray,sroaer,srotot
c 
       fophst=(sodray*fophsr+sodaer*fophsa)/(sodray+sodaer)
c      write(iwr, 931)'phase function     :',fophsr,fophsa,fophst
c 
      pizerr=1.
      pizert=(pizerr*sodray+pizera*sodaer)/(sodray+sodaer)
c      write(iwr, 931)'sing. scat. albedo :',pizerr,pizera,pizert
c      write(iwr, 1401)
c      write(iwr, 1402)
c**********************************************************************c
c                    atmospheric correction                            c
c**********************************************************************c
        if (rapp.ge.-1.) then
          if (rapp.ge.0.) then
            xrad=rapp
            rapp=pi*xrad*sb/xmus/seb
           else
            rapp=-rapp
            xrad=xmus*seb*(rapp)/pi/sb
           endif
         rog=rapp/tgasm
         rog=(rog-ainr(1,1)/tgasm)/sutott/sdtott
         rog=rog/(1.+rog*sast)
         xa=pi*sb/xmus/seb/tgasm/sutott/sdtott
c         xb=srotot/sutott/sdtott/tgasm
         xb=sroray/sutott/sdtott/tgasm
         xc=sast
c          write(iwr, 940)
c          write(iwr, 941)rapp
c          write(iwr, 942)xrad
c          write(iwr, 943)rog
c          write(iwr, 944)xa,xb,xc

         y=(xa*xrad)-xb  
         acr=y/(1.+xc*y)


        endif
        
        RETURN
        
        END
c**********************************************************************c
c                   output editing formats                             c
c**********************************************************************c
c   98 format(/////,1h*,30(1h*),16h 6s version 4.1 ,30(1h*),t79
c     s       ,1h*,/,1h*,t79,1h*,/,
c     s       1h*,22x,34h geometrical conditions identity  ,t79,1h*,/,
c     s       1h*,22x,34h -------------------------------  ,t79,1h*)
c  101 format(1h*,15x,7h month:,i3,7h day : ,i3,
c     s                 16h universal time:,f6.2,
c     s                 10h (hh.dd)  ,t79,1h*,/,
c     s   1h*, 15x,10hlatitude: ,f7.2,5h deg ,6x,
c     s                 12h longitude: ,f7.2,5h deg ,t79,1h*)
c  102 format(1h*,2x,22h solar zenith angle:  ,f6.2,5h deg ,
c     s     29h solar azimuthal angle:      ,f6.2,5h deg ,t79,1h*)
c  103 format(1h*,2x,7h month:,i3,7h day : ,i3,t79,1h*)
c 1110 format(1h*,2x,22h view zenith angle:   ,f6.2,5h deg ,
c     s       29h view azimuthal angle:       ,f6.2,5h deg ,
c     s      t79,1h*,/,
c     s       1h*,2x,22h scattering angle:    ,f6.2,5h deg ,
c     s           29h azimuthal angle difference: ,f6.2,5h deg ,
c     s      t79,1h*)
c 1119 format(1h*,t79,1h*,/,
c     s       1h*,22x,31h atmospheric model description ,t79,1h*,/,
c     s       1h*,22x,31h ----------------------------- ,t79,1h*)
c 1261 format(1h*,10x,30h atmospheric model identity : ,t79,1h*,/,
c     s       1h*,15x,a51,t79,1h*)
c 1272 format(1h*,30h atmospheric model identity : ,t79,1h*,/,
c     s       1h*,12x,33h user defined atmospheric model  ,t79,1h*,/,
c     s       1h*,12x,11h*altitude  ,11h*pressure  ,
c     s           11h*temp.     ,11h*h2o dens. ,11h*o3 dens.  ,t79,1h*)
c 1271 format(1h*,12x,5e11.4,t79,1h*)
c 1281 format(1h*,10x,31h atmospheric model identity :  ,t79,1h*,
c     s     /,1h*,12x,35h user defined water content : uh2o=,f6.3,
c     s                  7h g/cm2 ,t79,1h*,
c     s     /,1h*,12x,35h user defined ozone content : uo3 =,f6.3,
c     s                  7h cm-atm,t79,1h*)
c 1301 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s     1h*,15x,24h no aerosols computed   ,t79,1h*)
c  132 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s     1h*,15x,a15,15h aerosols model,t79,1h*)
c  133 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s     1h*,15x,29h user defined aerosols model ,t79,1h*,/,
c     s  1h*,26x,f6.3,15h % of dust-like,t79,1h*,/,
c     s  1h*,26x,f6.3,19h % of water-soluble,t79,1h*,/,
c     s  1h*,26x,f6.3,13h % of oceanic,t79,1h*,/,
c     s  1h*,26x,f6.3,10h % of soot,t79,1h*)
c  134 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s  1h*,15x,29h user defined aerosols model ,t79,1h*,/,
c     s  1h*,15x,6husing ,i1,32h Log-normal size-distribution(s),t79,
c     s  1h*,/,1h*,15x,42hMean radius  Stand. Dev.  Percent. dencity,
c     s  t79,1h*)
c  135 format(1h*,T41,f6.4,T55,f5.3,T69,e8.3,T79,1h*)
c  136 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s  1h*,15x,29h user defined aerosols model ,t79,1h*,/,
c     s  1h*,15x,40husing a Modified Gamma size-distribution,t79,1h*,/,
c     s  1h*,19x,33hAlpha         b             Gamma,t79,1h*,/,
c     s  1h*,T20,f6.3,T31,f6.3,T47,f6.3,T79,1h*)
c  137 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s  1h*,15x,29h user defined aerosols model ,t79,1h*,/,
c     s  1h*,15x,47husing a Power law size-distribution with alpha=,
c     s  f3.1,T79,1h*)
c  138 format(1h*,10x,25h aerosols type identity :,t79,1h*,/,
c     s  1h*,15x,29h user defined aerosols model ,t79,1h*,/,
c     s  1h*,15x,25husing data from the file:,T79,1h*,/,
c     s  1h*,T25,A30,T79,1h*)
c  139 format(1h*,15x,29h results saved into the file:,T79,1h*,/,
c     s  1h*,T25,A30,T79,1h*)
c  140 format(1h*,10x,29h optical condition identity :,t79,1h*,/,
c     s       1h*,15x,31h user def. opt. thick. at 550nm :,f7.4,
c     s       t79,1h*,/,1h*,t79,1h*)
c  141 format(1h*,10x,29h optical condition identity :,t79,1h*,/,
c     s       1h*,15x,13h visibility :,f6.2,4h km ,
c     s                 20h opt. thick. 550nm :,f7.4,t79,1h*,/,
c     s                  1h*,t79,1h*)
c  148 format(1h*,22x,21h spectral condition  ,t79,1h*,/,1h*,
c     s             22x,21h ------------------  ,t79,1h*)
c  149 format(1h*,12x,34h monochromatic calculation at wl :,
c     s                              f6.3,8h micron ,t79,1h*)
c 1510 format(1h*,10x,a17,t79,1h*,/,
c     s 1h*,15x,26hvalue of filter function :,t79,1h*,/,1h*,
c     s 15x,8h wl inf=,f6.3,4h mic,2x,8h wl sup=,f6.3,4h mic,t79,1h*)
c  168 format(1h*,t79,1h*,/,1h*,22x,14h target type  ,t79,1h*,/,1h*,
c     s                         22x,14h -----------  ,t79,1h*,/,1h*,
c     s                         10x,20h homogeneous ground ,t79,1h*)
c  169 format(1h*,t79,1h*,/,1h*,22x,14h target type  ,t79,1h*,/,1h*,
c     s                         22x,14h -----------  ,t79,1h*,/,1h*,
c     s    10x,41h inhomogeneous ground , radius of target ,f6.3,
c     s         5h km  ,t79,1h*)
c  170 format(1h*,15x,22h target reflectance : ,t79,1h*)
c  171 format(1h*,15x,29h environmental reflectance : ,t79,1h*)
c  172 format(1h*,t79,1h*,/,79(1h*),///)
c  173 format(1h*,t79,1h*,/,
c     s       1h*,22x,30h target elevation description ,t79,1h*,/,
c     s       1h*,22x,30h ---------------------------- ,t79,1h*)
c  174 format(1h*,10x,22h ground pressure  [mb]    ,1x,f7.2,1x,t79,1h*)
c  175 format(1h*,10x,22h ground altitude  [km]    ,f6.3,1x,t79,1h*)
c  176 format(1h*,15x,34h gaseous content at target level: ,t79,1h*,
c     s     /,1h*,15x,6h uh2o=,f6.3,7h g/cm2 ,
c     s           5x,6h  uo3=,f6.3,7h cm-atm,t79,1h*)
c  177 format(1h*,t79,1h*,/,
c     s       1h*,23x,34h atmospheric correction activated ,t79,1h*,/,
c     s       1h*,23x,34h -------------------------------- ,t79,1h*)
c  185 format(1h*,10x,30h input apparent reflectance : , f6.3,t79,1h*)
c  186 format(1h*,10x,39h input measured radiance [w/m2/sr/mic] ,
c     s       f7.3,t79,1h*)

c  187 format(1h*,t79,1h*,/,
c     s       1h*,15x,34h brdf selected                    ,t79,1h*,/,
c     s 1h*,15x,40h     rodir    robar    ropbar    albedo ,t79,1h*,/,
c     s       1h*,15x,4(f9.4,1x),t79,1h*)
c  190 format(1h*,15x,31h brdf from in-situ measurements,t79,1h*)
c  191 format(1h*,15x,23h Hapke's model selected,t79,1h*
c     s       /,1h*,16x,3hom:,f5.3,1x,3haf:,f5.3,1x,3hs0:,f5.3,1x,
c     s       2hh:,f5.3,t79,1h*)
c  192 format(1h*,15x,38h Pinty and Verstraete's model selected,t79,1h*
c     s       /,1h*,16x,3hom:,f5.3,1x,5hrad :,f5.3,1x,6hlad  :,f5.3,1x,
c     s        t79,1h*)
c  193 format(1h*,15x,32h Roujean et al.'s model selected,t79,1h*
c     s       /,1h*,16x,3hk0:,f5.3,1x,3hk1:,f5.3,1x,3hk2:,f5.3,
c     s       t79,1h*)
c  194 format(1h*,15x,33h Walthall et al.'s model selected,t79,1h*
c     s       /,1h*,16x,2ha:,f5.3,1x,3hap:,f5.3,1x,2hb:,f5.3,1x,
c     s       3hom:,f5.3,t79,1h*)
c  195 format(1h*,15x,26h Minnaert's model selected,t79,1h*
c     s       /,1h*,16x,5hpar1:,f5.3,1x,5hpar2:,f5.3,t79,1h*)
c  196 format(1h*,15x,21h ocean model selected,t79,1h*
c     s       /,1h*,16x,18hwind speed [m/s] :,f5.1,
c     s             2x,27hazimuth of the wind [deg] :,f8.2,t79,1h*
c     s       /,1h*,16x,16hsalinity [ppt] :,f5.1,
c     s             4x,23hpigment conc. [mg/m3] :,f6.2,t79,1h*)
c  197 format(1h*,15x,41h given kappa1 and kappa2:                ,t79,
c     s    1h*,/,1h*,20x,5hkpa1:,f5.3,1x,5hkpa2:,f5.3,t79,1h*)
c  198 format(1h*,15x,41h Goudrian's parametrization of kappa :   ,t79,
c     s   1h*,/,1h*,20x,6h ksil:,f5.3,1x,t79,1h*)
c  199 format(1h*,15x,41h modified Goudrian's parametrization :   ,t79,
c     s   1h*,/,1h*,20x,6h ksil:,f5.3,1x,t79,1h*)
c  200 format(1h*,15x,40h single scattering only              :  ,t79,
c     s   1h*)
c  201 format(1h*,15x,40h multiple scattering (Dickinson et al)  ,t79,
c     s   1h*)
c  202 format(1h*,15x,40h isotropic phase function            :  ,t79,
c     s   1h*)
c  203 format(1h*,15x,40h Heyney-Greenstein's phase function  :  ,t79,
c     s   1h*,/,1h*,20x,6hassym:,f5.3,1x,t79,1h*)
c  204 format(1h*,15x,40h Legendre polynomial phase function  :  ,t79,
c     s   1h*,/,1h*,20x,6hbeta1:,f5.3,1x,6hbeta2:,f5.3,t79,1h*)
c  205 format(1h*,15x,40h Iaquinta and Pinty BRDF model selected ,t79,
c     s       1h*,/,1h*,16x,3hRl:,f5.3,1x,3hTl:,f5.3,1x,3hRs:,f5.3,1x
c     s       ,1x,4hLAl:,f5.3,t79,1h*)
c  206 format(1h*,15x,30h Rahman et al. model selected ,t79,
c     s       1h*,/,1h*,16x,4hRho0:,f6.3,1x,2haf:,f6.3,1x,3hxk:,f6.3,1x
c     s       ,t79,1h*)
c  207 format(1h*,15x,A19,t79,1h*)
c  208 format(1h*,15x,A19,1x,f5.2,t79,1h*)
c  209 format(1h*,15x,A31,t79,1h*)
c  210 format(1h*,2x,40h Kuusk BRDF model,                      ,t79,1h*,
c     s       /,1h*,12x,4hLAI:,f5.3,2x,4heps:,f6.4,2x,4hthm:,f4.1
c     s       ,1x,3hsl:,f4.2,t79,1h*,
c     s       /,1h*,12x,4hcAB:,f6.2,1x,3hcW:,f5.3,1x,2hN:,f5.3,1x,3hcn:
c     s       ,f4.2,1x,5hrsl1:,f5.3,t79,1h*)
c
c pressure at ground level (174) and altitude (175)
c  178 format(1h*,t79,1h*,/,
c     s       1h*,22x,30h plane simulation description ,t79,1h*,/,
c     s       1h*,22x,30h ---------------------------- ,t79,1h*)
c  179 format(1h*,10x,31h plane  pressure          [mb] ,f7.2,1x,t79,1h*)
c  180 format(1h*,10x,31h plane  altitude absolute [km] ,f6.3,1x,t79,1h*)
c  181 format(1h*,15x,37h atmosphere under plane description: ,t79,1h*)
c  182 format(1h*,15x,26h ozone content            ,f6.3,1x,t79,1h*)
c  183 format(1h*,15x,26h h2o   content            ,f6.3,1x,t79,1h*)
c  184 format(1h*,15x,26haerosol opt. thick. 550nm ,f6.3,1x,t79,1h*)
c 
c  430 format(79(1h*),/,1h*,t79,1h*,/,
c     s       1h*,24x,27h integrated values of  :   ,t79,1h*,/,
c     s       1h*,24x,27h --------------------      ,t79,1h*,/,
c     s       1h*,6x,22h apparent reflectance ,f7.4,3x,
c     s                 26h appar. rad.(w/m2/sr/mic) ,f10.3,1x,t79,1h*,/,
c     s       1h*,18x,30h total gaseous transmittance  ,f5.3,
c     s  t79,1h*,/,1h*,t79,1h*,/,79(1h*))
c  431 format(1h*,t79,1h*,/,
c     s       1h*,24x,27h coupling aerosol -wv  :   ,t79,1h*,/,
c     s       1h*,24x,27h --------------------      ,t79,1h*,/,
c     s       1h*,10x,20h wv above aerosol : ,f7.3,4x,
c     s               25h wv mixed with aerosol : ,f7.3,1x,t79,1h*,/,
c     s       1h*,22x,20h wv under aerosol : ,f7.3,t79,1h*)
c  432 format(1h*,t79,1h*,/,1h*,
c     s        24x,32h int. normalized  values  of  : ,t79,1h*,/,1h*,
c     s        24x,32h ---------------------------    ,t79,1h*,/,1h*,
c     s             22x,31h% of irradiance at ground level,
c     s  t79,1h*,/,1h*,5x,17h% of direct  irr.,
c     s                    4x,17h% of diffuse irr.,
c     s                    4x,17h% of enviro. irr ,t79,1h*,/,
c     s             1h*,3(10x,f10.3),t79,1h*,/,
c     s 1h*,22x,31h reflectance at satellite level  ,t79,1h*,/,
c     s                1h*,5x,17hatm. intrin. ref.,
c     s                    3x,a11,5h ref.,
c     s                    2x,a6,12h reflectance,t79,1h*,/,
c     s             1h*,3(10x,f10.3),t79,1h*,/,1h*,t79,1h*)
c  436 format(1h*,t79,1h*,/,1h*,22x,24hsol. spect (in w/m2/mic),t79,1h*,
c     s/,1h*,30x,f10.3,t79,1h*,/,1h*,t79,1h*,/,79(1h*))
c  437 format(1h*,t79,1h*,/,1h*,10x,29hint. funct filter (in mic)
c     s               ,10x,26h int. sol. spect (in w/m2),t79,1h*,/,
c     s1h*,10x,f12.7,30x,f10.3,t79,1h*,/,1h*,t79,1h*,/,79(1h*))
c  434 format(1h*,24x,24h int. absolute values of,t79,
c     s 1h*,/,1h*,24x,24h -----------------------               ,
c     s  t79,1h*,/,1h*,22x,33hirr. at ground level (w/m2/mic)  ,
c     s  t79,1h*,/,1h*, 5x,17hdirect solar irr.,
c     s             4x,17hatm. diffuse irr.,
c     s             4x,17henvironment  irr ,t79,1h*,/,
c     s             1h*,3(10x,f10.3),t79,1h*,/,
c     s        1h*,22x,33hrad at satel. level (w/m2/sr/mic),t79,1h*,/,
c     s                1h*,5x,17hatm. intrin. rad.,
c     s                    4x,a11,5h rad.,
c     s                    4x,a6,9h radiance,t79,1h*,/,
c     s             1h*,3(10x,f10.3),t79,1h*,/,1h*,t79,1h*)
c  929 format(1h ,////)
c  930 format(79(1h*),/,1h*,t79,1h*,/,
c     s       1h*,t27,27h integrated values of  :   ,t79,1h*,/,
c     s       1h*,t27,27h --------------------      ,t79,1h*,/,
c     s       1h*,t79,1h*,/,
c     s       1h*,t30,10h downward ,t45,10h  upward  ,
c     s            t60,10h   total  ,t79,1h*)
c  931 format(1h*,6x,a20,t32,f7.5,t47,f7.5,t62,f7.5,t79,1h*)
c  939 format(1h*,t79,1h*,/,1h*,
c     s             t30,10h rayleigh ,t45,10h aerosols ,
c     s            t60,10h   total  ,t79,1h*,/,1h*,t79,1h*)
c  940 format(79(1h*),/,/,/,/,79(1h*),/
c     s       1h*,23x,31h atmospheric correction result ,t79,1h*,/,
c     s       1h*,23x,31h ----------------------------- ,t79,1h*)
c  941 format(1h*,6x,40h input apparent reflectance            :, 
c     s           1x, f8.3, t79,1h*)
c  942 format(1h*,6x,40h measured radiance [w/m2/sr/mic]       :, 
c     s           1x, f8.3, t79,1h*)
c  943 format(1h*,6x,40h atmospherically corrected reflectance :,
c     s           1x, f8.3, t79,1h*)
c  944 format(1h*,6x,40h coefficients xa xb xc                 :, 
c     s           1x, 3(f8.5,1x),t79,1h*,/,1h*,6x,
c     s           ' y=xa*(measured radiance)-xb;  acr=y/(1.+xc*y)',
c     s               t79,1h*,/,79(1h*))
c 1401 format(1h*,t79,1h*)
c 1402 format(1h*,t79,1h*,/,79(1h*))
c 1500 format(1h*,1x,42hwave   total  total  total  total  atm.   ,
c     s           33hswl    step   sbor   dsol   toar ,t79,1h*,/,
c     s  1h*,1x,42h       gas    scat   scat   spheri intr   ,t79,1h*,/,
c     s  1h*,1x,42h       trans  down   up     albedo refl   ,t79,1h*)
c 1501 format(1h*,6(F6.4,1X),F6.1,1X,4(F6.4,1X),t79,1h*)
c
c       return
c       end
