/******************************************************************************
NAME:		OPENDB

PURPOSE:	Open the temporary data base file or append to the daily
                data base file.

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "worgen.h"
#include "tae.h"

void opendb
(
   FILE	**fp,		/* File pointer to the data base file */
   char	*sceneid,	/* Scene id */
   char	*tstamp,	/* Time stamp */
   long   	*dbflag,	/* Data base flag */
   char	*filnam 	/* Name of the databse file */
)

{
char	disk[CMLEN];	/* Disk location of the database files */

long	nonfatal = 1,	/* Non fatal error code */
	fatal = -1,	/* Fatal error code */
	i;		/* Looping variable */

/* Get the location of the update file
--------------------------------------*/
if (*dbflag)
    strcpy (disk,getenv("ADAPSDB"));
else
    strcpy (disk,getenv("ADAPSDBTMP"));

if (disk == NULL)
    {
    c_errmsg("Error getting the database directory environment name",
	     "avhrrdb-getenv",&nonfatal);
    c_errmsg("Fatal error encountered","avhrrdb-fatal",&fatal);
    }

/* Build the file name
----------------------*/
#ifdef vms
    sprintf (filnam, "%s%s_%s.db", disk, sceneid, tstamp);
#else 
    sprintf (filnam, "%s/%s_%s.db", disk, sceneid, tstamp);
#endif

/* Open the database file
-------------------------*/
for(i = 0; i < 5; i++)
    {
    *fp = fopen(filnam,"w");
    if (*fp == NULL)
	sleep(5);
    else
	break;
    }

/* Check to see if it got opened
--------------------------------*/
if (*fp == NULL)
   {
   c_errmsg("Error opening database file","avhrrdb-open",&nonfatal);
   c_errmsg("Fatal error encountered","avhrrdb-fatal",&fatal); 
   }

return;
}
