#ifndef AVHRRIN_H
#define AVHRRIN_H

/* convert_rev.c */
int convert_rev
(
    char *hosout,              /* Host file name of output image             */
    char (*outfiles)[CMLEN],   /* Array of output file names                 */
    long *adesc,               /* AVHRR archive descriptor                   */
    long bands[],              /* Band specifications for each input image   */
    long *mmflg,               /* Min max tracking flag                      */
    long *n_outfiles,          /* Number of output files created             */
    long *nbands,              /* Number of bands per input image            */
    long window[],             /* Window specifications for each input image */
    double maxval[],           /* Max pixel value array                      */
    double minval[]            /* Min pixel value array                      */
);
/* convert_seq.c */
int convert_seq
(
    char *hosout,              /* Host file name of output image             */
    char (*outfiles)[CMLEN],   /* Array of output file names                 */
    long *adesc,               /* AVHRR archive descriptor                   */
    long bands[],              /* Band specifications for each input image   */
    long *mmflg,               /* Min max tracking flag                      */
    long *n_outfiles,          /* Number of output files created             */
    long *nbands,              /* Number of bands per input image            */
    long window[],             /* Window specifications for each input image */
    double maxval[],           /* Max pixel value array                      */
    double minval[]            /* Min pixel value array                      */
);
/* setup.c */
int setup
(
    struct PARBLK *vblock,      /* Pointer to TAE parameter block             */
    struct MODEL *model,        /* AVHRR model structure                      */
    char *comment,              /* Tape mounting comment                      */
    char *hosin,                /* Host file names of input image             */
    char *hosout,               /* Host file name of output image             */
    char outfiles[][CMLEN],     /* List of output files                       */
    char *taeout,               /* TAE file name of output image              */
    long bands[],               /* Band specifications for each input image   */
    long *mmflg,                /* Min/Max flag for LAS images                */
    long *msgtim,               /* Elapsed time between display messages      */
    long *n_outfiles,           /* Number of output files                     */
    long *nbands,               /* Number of bands per input image            */
    long *tpunit,               /* Tape unit for reading images from tape     */
    long window[]               /* Window specifications for each input image */
);
/* upassoc.c */
int upassoc
(
    char *image,                /* Host file name of output image             */
    char outfiles[][CMLEN],     /* List of output files                       */
    long *n_outfiles,           /* Number of output files                     */
    long window[],              /* Window for the AVHRR archive image         */
    struct DROPPED *drop,       /* Dropped line data structure                */
    struct MODEL   *model,      /* AVHRR model information                    */
    long bands[]                /* Band specifications for each input image   */
);

#endif

