#ifndef AVHRRSTACK__H
#define AVHRRSTACK__H

void getpar_sc
(
   struct PARBLK *vblock,       /* IN - TAE parameter block                 */
   char *sumfile,               /* OUT - Host name of the tape summary file */
   long *first,                 /* OUT - The first scene to read            */
   long *maxscenes              /* OUT - The maximum number of scenes       */
);

long getpar_sh
(
    struct PARBLK *vblock,      /* IN  - TAE parameter block                  */
    char *tapeid,               /* OUT - ID of tape for which to print a form */
    char *printer,              /* OUT - Printer where forms should be sent   */
    char *adapsarc,             /* OUT - ADAPSARC environment variable        */
    char *logfile,              /* OUT - Host name of the log file            */
    char *sumfile,              /* OUT - Host name of the tape summary file   */
    long *tplabel,              /* OUT - Flag indicating to print tape label  */
    long *print,                /* OUT - Flag to print form and tape label    */
    char *outform,              /* OUT - Output format                        */
    char address[5][27],        /* OUT - Output shipping address              */
    char ordernum[],            /* OUT - Order number                         */
    char instruct[9][30],       /* OUT - Special instructions                 */
    char *procopt               /* OUT - Which format to print the tape label */
);

void taeland
(
   struct PARBLK *vblock, /* IN - TAE parameter block                       */
   long queue,            /* IN - Queue of AVHRR images stacked to the tape */
   long first,            /* IN - The first scene to read                   */
   long maxscenes         /* IN - The maximum number of scenes to return    */
);

int print_form
(
    long queue,                 /* IN  - Queue of AVHRR image names           */
    char *adapsarc,             /* IN  - The ADAPSARC directory               */
    char *tapeid,               /* IN  - Identification number of the tape    */
    char *printer,              /* IN  - Printer to print the forms on        */
    char *logfile,              /* IN  - Log file for processing messages     */
    long print,                 /* IN  - Flag for printing files or not       */
    long maxfiles,              /* IN  - Max number of output files           */
    char instruct[9][30],       /* IN  - Special instructions to print        */
    char address[5][27],        /* IN  - Address to ship to                   */
    char fnames[][CMLEN],       /* OUT - LAS names of files if not printed    */
    long *nfiles                /* OUT - Number of file names in fnames[]     */
);

void print_header
(
    FILE *fp,           /* IN - Output file                                   */
    char *tapeid,       /* IN - ID of tape the form is being created for      */
    char address[5][27] /* IN - Shipping address                              */
);

void print_footer
(
    FILE *fp,                   /* IN - Output file                           */
    char instruct[9][30]        /* IN  - Special instructions to print        */
);

int read_summary
(
    char *function,     /* IN  - Name of the calling function                 */
    char *sumfile,      /* IN  - Host file name of the tape summary file      */
    char *tapeid,       /* OUT - ID of the tape in the summary file           */
    char *system,       /* OUT - System on which the tape was created         */
    char *drive,        /* OUT - Tape drive on which the tape was created     */
    char *groups,       /* OUT - The number of file groups stored on the tape */
    long *queue         /* OUT - Queue of file groups on the tape             */
);

int update_dbase
(
    long *queue,        /* IN - Queue of file groups on the tape              */
    char *tapeid,       /* IN - ID of tape the file groups were stacked to    */
    char *logfile       /* IN - Host file name of the log file                */
);

long update_single
(
    char *adapsdbtmp,   /* IN - ADAPSDBTMP directory                          */
    char *adapsdb,      /* IN - ADAPSDB directory                             */
    char *tapeid,       /* IN - ID of the tape the image was stacked to       */
    char *root          /* IN - Root file name of the image                   */
);


#endif
