#ifndef BROWSE_H
#define BROWSE_H

#include "model.h"


struct  LINE
        {
        char    version;
        char    header[114];
        } ;

void getpar
(
    struct PARBLK *vblock,	/* parameter block	             	*/
    struct MODEL *model,	/* Model and orbital information	*/
    char hosin[][CMLEN], 	/* image file HOST name    	     	*/
    char *sceneid,		/* image file scene id			*/
    char oname[][CMLEN],	/* output file name(s)         		*/
    long (*bands)[MAXBND+1],	/* band numbers specified	     	*/
    long *nbands,		/* number of bands in input image    	*/
    long *idtype,		/* input data type		     	*/
    long *totbnd,		/* total number of bands specified   	*/
    long (*window)[4],		/* window specification		     	*/
    long *lskip, 		/* number lines to skip to subsample 	*/
    long *sskip,		/* number samples to skip to subsample	*/
    long *mline,		/* image master line			*/
    long *msamp,		/* image master sample			*/
    long *outlines,		/* number of lines after subsampling    */
    long *outsamps,		/* number of samples after subsampling  */
    long *nmrout,		/* number of output files            	*/
    long *msgtim		/* seconds between processing messages 	*/
);

void outbr
(
    struct PARBLK *vblock,      /* TAE parameter block                  */
    char *hosin,                /* host name of input image             */
    char oname[][CMLEN],        /* output file names                    */
    long *nmrout,               /* number of output files               */
    long window[],              /* window specifier                     */
    long outlines,              /* number of lines after subsampling    */
    long outsamps,              /* number of samples after subsampling  */
    long bands[],               /* band numbers specified               */
    long nbands,                /* number of bands                      */
    long *idtype,               /* input data type                      */
    long *msgtim,               /* message time counter                 */
    long *lskip,                /* number of lines to skip to           */
    long *sskip,                /* number samples to skip to subsample  */
    struct LINE *brw_line       /* header record for output file        */
);

void rad2min
(
    double latlon,		/* lat or long value to convert (radians)*/
    long *totmin 		/* total minutes 			*/
);

void setup_head
(
    struct MODEL *model,	/* Model and orbital information	*/
    struct LINE *brw_line,	/* header for the output browse file 	*/
    long bands[],		/* band numbers specified 		*/
    long nbnd,			/* number of bands 			*/
    long window[],		/* window of the input image		*/
    long mline,			/* master image line			*/
    long msamp,			/* master image sample			*/
    long outlines,		/* number of output lines		*/
    char *sceneid		/* sceneid of the LAS image 		*/
);

#endif
