/*******************************************************************************
FUNCTION:	RAD2MIN

PURPOSE:	Convert a latitude or longitude in radians to total minutes

Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  1.0    08/90  D.Hollaren       Modified version of VMSOUT
  5.0    03/92  E.Cihak/         LAS-5.0 version for ADAPS
                T.Rockvam

PROJECT:	ADAPS
*******************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "constants.h"

void rad2min
(
    double latlon,		/* lat or long value to convert (radians)*/
    long *totmin 		/* total minutes 			*/
)
{
long	deg,			/* degrees 				*/
	mins;    		/* minutes 				*/

double	ddegrees,		/* decimal degrees			*/
	left;			/* fractional part of latlon		*/

/*
  Convert to degrees
*/
ddegrees = latlon * DEG_PER_RAD;

/*
  Extract the degrees
*/
deg = (long)ddegrees;

/*
  Take the amount left and extract the minutes
*/
left = ddegrees - (double)deg;
mins = (long)(fabs(left) * 60);

/*
  Convert degrees and minutes to total minutes
*/
if (deg >= 0)
   *totmin = deg * 60 + mins;
else
   *totmin = deg * 60 - mins;

return;
}
