/****************************************************************************
NAME:		GETPAR

PURPOSE:	Get user entered parameters from the TAE parameter block

*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "model.h"
#include "archio.h"

int getpar
(
struct PARBLK	*vblock,   /* TAE variable block			    */
char		*subcmd,   /* Subcommand used to run application            */
struct MODEL	*model,    /* Model and orbital information		    */
struct DDR	*ddr 	   /* AVHRR LAS Data Descriptor record		    */
)
{
struct VARIABLE *var;	   /* Pointer to a TAE variable in vblock	    */

long	access = IREAD,	   /* File access indicatori		            */
	zero = 0,          /* Constant zero				    */
	status;		   /* Status variable				    */

char	host_img[CMLEN];   /* Host input image name			    */

/*
  Get the subcommand the application was run with
*/
var = p_find(vblock,"_SUBCMD");
strcpy(subcmd,SVAL(*var,0));

/*
  Get the input image
*/
status = c_getnam(vblock,"IN",&zero,host_img,"img",&access);
if (status != E_SUCC)
    return(E_FAIL);

/*
  Retreive the model information from the associated AVHRR DDR file
*/
status = c_getaddr(host_img,model);
if (status != E_SUCC)
    return(E_FAIL);

status = c_getddr(host_img,ddr);
if (status != E_SUCC)
    return(E_FAIL);

return(E_SUCC);
}
