/******************************************************************************
FUNCTION:	GETPAR

PURPOSE:	Get the input parameters

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
  1.0      06/99    D.Lloyd		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under TAE

PROJECT:        ADAPS

ALGORITHM REFERENCES:   NONE

*******************************************************************************/
#include <string.h>
#include "las.h"
#include "util.h"
#include "creatmf.h"


int getpar
(
struct PARBLK *vblock,		/* Input parameter block		*/
char    infile[IMAX][CMLEN],	/* Input file names			*/
char	*outfile,		/* Output file name			*/
long	*count			/* number of input files		*/
)

{
char	dir[CMLEN];		/* input file directory			*/

long	access;			/* file	access 				*/
long	element = 0;		/* input parameter element number	*/
long	i;			/* loop control variable		*/
long	status;			/* function return status		*/

struct	VARIABLE *var;		/* pointer to a TAE variable		*/


/* get the input file directory name
------------------------------------*/
var = p_find( vblock, "INDIR" );
strcpy( dir, SVAL(*var,0) );


/* Get the list of input file names, since we had to pass
the directory name and root names separately we will let
the call to get_buf decide if the input files exist.
---------------------------------------------------------*/
access = IREAD;
var = p_find( vblock, "IN" );
*count = var->v_count-1;	/* first get the count		*/
for ( i = 0; i <= *count; i++ )	/* now build each input name	*/
    {
    strcpy( infile[i], dir );
    strcat( infile[i], SVAL( *var, i ));
    strcat( infile[i], ".img" );
    }


/* Get the output file name and make sure it doesn't exist
----------------------------------------------------------*/
access = IWRITE;
status = c_getnam( vblock, "OUT", &element, outfile, "img", &access );
if (status != E_SUCC)
    return E_FAIL;


return E_SUCC;
}
