/*****************************************************************************
NAME:		GENADDR 

PURPOSE:	Generate the addr for OUT

******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "labserv.h"
#include "adaps.h"
#include "archio.h"
#include "dcw2ras.h"

void genaddr
(
char hosout[CMLEN], 		/* output host file image name		*/
struct  MODEL   *model       	/* AVHRR model information		*/
)
{
char 	addr_name[CMLEN];	/* output host name of addr file	*/

long	status,			/* return status			*/
	nonfatal = 1;		/* nonfatal error code			*/

/*
  Generate a file name for the AVHRR DDR
*/
c_lsmknm(hosout,"addr",addr_name);

/*
  Save the archive header and ephemeris to the AVHRR DDR
*/
status = c_putaddr(addr_name,model);
if (status != E_SUCC)
   c_errmsg("Error creating ADDR file for OUT","dcw2ras-outaddr",&nonfatal);

return;
}
