/*****************************************************************************
NAME:		SORTSCAN 

PURPOSE:	Sort the scan file 

******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "desc.h"
#include "dcw2ras.h"

void sortscan
(
struct PARBLK *vblock 		/* TAE parameter block			*/
)
{
extern char tfiles[3][CMLEN];	/* output temporary host file names	*/
extern long numout;		/* number of temp host files		*/

#ifdef vms
struct DESC infile;
struct DESC outfile;
long ncol = 2;			/* number of columns to sort */
#endif

long non_fatal = 1;		/* for nonfatal error messages  */
long result;			/* result of system sorts	*/

char command[CMLEN];		/* command string for unix system sort */ 
char datapath[CMLEN];		/* user defined data path		*/

/*
  Create the output file name
*/
strcpy(tfiles[numout],"dcw2ras_sort");
c_creat_name(tfiles[numout],"txt");
numout++;

c_errmsg("Sorting the scan file"," ",&non_fatal);

/*
  Sort the scan file.  This file will be sorted based on the line number,
  priority, starting and ending pixel location 
*/
#ifdef vms
infile.addr = &tfiles[numout-2];
outfile.addr = &tfiles[numout-1];
infile.length = strlen(tfiles[numout-2]);
outfile.length = strlen(tfiles[numout-1]);

prmsrt(&infile,&outfile,&ncol,&result);
if (result != 1)
   {
   c_errmsg("System file sort failed","dcw2ras-system",&non_fatal);
   c_clean(vblock,"dcw2ras",tfiles,&numout);
   }
#endif

#ifdef unix
/*
  set up command string
*/
if (getenv("DATAPATH") != NULL)
   {
   /* strcpy(datapath,getenv("DATAPATH")); */
   if (find_path(datapath) != E_SUCC)    /* find the best path from DATAPATH */
	{
   	c_errmsg("System file sort failed","dcw2ras-system",&non_fatal);
   	c_clean(vblock,"dcw2ras",(const char (*)[256])tfiles,&numout); 
	}
   sprintf(command,"sort -u %s -o %s -T %s",
	tfiles[numout-2],tfiles[numout-1],datapath);
   }
else
   sprintf(command,"sort -u %s -o %s",
	tfiles[numout-2],tfiles[numout-1]);

result = system(command);
if (result != E_SUCC)
   {
   c_errmsg("System file sort failed","dcw2ras-system",&non_fatal);
   c_clean(vblock,"dcw2ras",(const char (*)[256])tfiles,&numout); 
   }
#endif

/*
  Delete the unsorted scan file
*/
c_delfil(tfiles[numout-2]);
strcpy(tfiles[numout-2],tfiles[numout-1]);
numout--;

return;
}
