/******************************************************************************
NAME:		GET_ADDR_PAR

PURPOSE:	Retrieves Avhrr Data Descriptor parameter information

ALGORITHM

ALGORITHM REFERENCES	none
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "dspaddr.h"

void get_addr_par
(
struct PARBLK	*vblock,	/* TAE parameter block			*/
char		*hosin,		/* Input host file name			*/
long		*fopt,		/* Output to file option		*/
char		*prtfil,	/* Temporary print file name		*/
char		*outfil 	/* List of output files created		*/
)
{ 
long	status,                 /* Return value                         */
	topt,			/* Output to terminal option		*/
	lopt,			/* Output to line printer option	*/
	zero = 0,		/* Constant of zero			*/
	fatal = -1,             /* Fatal error code                     */
	access = IREAD;		/* Access type to read the ADDR		*/

/*
  Get the input name
*/
status = c_getnam(vblock,"IN",&zero,hosin,"addr",&access);
if (status != E_SUCC)
    c_errmsg("Fatal error encountered","dspaddr-fatal",&fatal);

/*
  Get print option and open output file, if necessary 
*/
strcpy(prtfil,"dspaddr");
status = c_setprt(vblock,(int *)&topt,(int *)fopt,(int *)&lopt,prtfil,outfil);
if (status != E_SUCC)
    c_errmsg("Fatal error encountered","dspaddr-fatal",&fatal);

return;
}
