/******************************************************************************
NAME:		WRITE_REPORT

PURPOSE:	Write a formatted output report of the AVHRR
		Minor Frame Format data.

PROGRAM HISTORY:

VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  5.0	 T. Baltzer    01/93	Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:

******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "labserv.h"
#include "vll.h"
#include "adaps.h"
#include "archio.h"
#include "dspmnr.h"

int write_report
(
char	*hosmnr,	/* Input minor frame file name			*/
long	*minfd,		/* Label services minor frame file descriptor	*/
FILE 	*fp,		/* File pointer to print file			*/
long	sl,		/* Starting line of image to display		*/
long	nl,		/* Number of lines to display			*/
char	listopt[][4] 	/* List of options to report			*/
)
{

char	char_buf[1],		/* Buffer for label services calls	*/
	linekey[KEYL];		/* Line number key for minor frame file	*/
char    dtype[4];

long	char_nbytes,		/* Number of bytes in char buffer	*/
	line,			/* Line counter				*/
	minor_nbytes = MNR_WORDS*sizeof(short),	/* # of bytes in minor frame */
	nonfatal = 1,		/* Non-fatal error status		*/
	status,			/* return status value			*/
	zero = 0;		/* Constant of zero			*/

short   min_frm[MNR_WORDS];	/* Buffer to read minor frame data into */


/*
  Read the Minor Frame Format
*/
for (line = sl; line < sl + nl; line++)
    {
    sprintf(linekey,"%d",line);
    char_nbytes = 1;
    strcpy(dtype,"I2");
    status = c_lsread (minfd,linekey,&char_nbytes,&minor_nbytes,char_buf,
                      (char *)min_frm,dtype);
    if (status != E_SUCC)
        {
        c_errmsg("Error reading minor frame file","dspmnr-lsread",&nonfatal);
        c_lsclos(minfd,hosmnr,&zero);
	return(E_FAIL);
        }
    write_line(line,min_frm,hosmnr,fp,listopt);
    }

return(E_SUCC);
}
