/*******************************************************************************
FUNCTION:	editahdr

PURPOSE:   	Modify specified fields in the AVHRR archive image header file.

Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  0.1    04/96  T. Baltzer       Original development

PROJECT:	ADAPS 
*******************************************************************************/
#include "editahdr.h"
#include "util.h"
#include "util2.h"



/* Global variables to allow easy calling of the error handling routine
------------------------------------------------------------------------------*/

struct PARBLK vblock;	/* TAE parameter block                                */

main()
{
char infile[CMLEN];	/* Host name of the input image                       */
char ceosid[CMLEN];	/* CEOS ID to be used to replace the existing one     */

long nfiles = 0;	/* Number of files created by this function           */
long status;		/* Function return status                             */
long std_out;		/* LUN to standard output                             */

struct DROPPED drop;	/* AVHRR dropped line structure                       */
struct MODEL model;	/* AVHRR model structure                              */


/* Initialize LAS
-----------------*/
c_inlas(&vblock, &std_out);


/* Get the parameters
---------------------*/
getpar(infile, ceosid);


/* Get the header for the input image
-------------------------------------*/
status = c_getahdr(infile, &model, &drop);
if (status != E_SUCC)
    c_lasmsg(TRUE,"editahdr-fatal","Fatal error encountered");


/* Modify the model structure with the new CEOS ID
---------------------------------------------------*/
strcpy(model.station,ceosid);


/* Replace the header file of the image
--------------------------------------------*/
status = c_putahdr(infile, &model, &drop);
if (status != E_SUCC)
    c_lasmsg(TRUE,"editahdr-fatal","Fatal error encountered");


/* Output completion message 
----------------------------*/
c_complt("EDITAHDR", (char (*)[256])"", &nfiles);

return E_SUCC;
}
