
#include <stdio.h>
#include "las.h"
#include "tapeio.h"

main(argc, argv)

int  argc;
char *argv[];
{
char   drive_density[CMLEN];
char   drive_name[CMLEN];
struct TAPEDESC tape_drive;

/* Make sure there is one argument
----------------------------------*/
if (argc != 2)
   {
   fprintf(stdout, "usage: %s <tape_drive>\n", argv[0]);
   fprintf(stdout, "\n");
   fprintf(stdout, "       Return the device name, type of tape, and ");
   fprintf(stdout, "density of <tape_drive>.\n");
   fprintf(stdout, "\n");
   exit(1);
   }
strcpy(drive_density, "0");
strcpy(drive_name, argv[1]);


/* Call the LAS support tprdconf to read the
   configuration file.  Send 0 as the density.
---------------------------------------------*/
if(tprdconf(&tape_drive, drive_name, drive_density, TREAD) != TAPE_SUCC)
   {
   fprintf(stderr, "get_device: Error reading tape configuration file\n");
   exit(1);
   }
printf("%s %s %s\n", tape_drive.name, tape_drive.dtype, tape_drive.density);
exit(0);
}
