/*******************************************************************************
NAME:    GET_KEY

PURPOSE: Parse the input file name for the key, year, and CEOS ID.

Version	 Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  5.0	 D.Hollaren       03/92	 Development
  5.1    J.Fenno          11/92  Replaced call to c_complt with z_exit
  5.2	 D.Hollaren       01/93	 Rewrote to call c_splitname.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
*******************************************************************************/
#include <stdio.h>
#include "las.h"

main()
{
struct PARBLK	vblock;		/* TAE variable block			     */

long	access   = IUPDATE,     /* File access flag                          */
	element  = 0,           /* Retrieve the zero'th element of INFILE    */
	fatal    = -1,          /* Fatal error flag                          */
	status,			/* Return status variable		     */
	std_out;		/* Standard output			     */

char    hostname[CMLEN],        /* Input file name                           */
        root[CMLEN],            /* Root portion of the input file name       */
        ext[CMLEN],             /* Extension portion of the input file name  */
        dir[CMLEN],             /* Directory portion of the input file name  */
	key[17],		/* Key from the input file name		     */
	year[3],		/* Year from the input file name	     */
	ceosid[4],		/* Station id				     */
	*svec[1];		/* Array of pointers for output to TAE	     */


/*
  Initalize las
*/
c_inlas(&vblock, &std_out);


/*
  Get the input file name
*/
status = c_getnam(&vblock, "INFILE", &element, hostname, "arch", &access);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered", "getkey-fatal", &fatal);


/*
  Split the file name
*/
c_splitname(hostname, dir, root, ext);


strncpy(key, root, 16);
key[16] = '\0';

strncpy(year, &key[8], 2);
year[2] = '\0';

strncpy(ceosid, ext, 3);
ceosid[3] = '\0';

/*
  Send the KEY to the variable block
*/
svec[0] = key;
q_string(&vblock, "KEY", 1, svec, P_UPDATE);

/*
  Send the YEAR to the variable block
*/
svec[0] = year;
q_string(&vblock, "YEAR", 1, svec, P_UPDATE);

/*
  Send the CEOS ID to the variable block
*/
svec[0] = ceosid;
q_string(&vblock, "CEOSID", 1, svec, P_UPDATE);

/*
  Send the varible block to TAE
*/
q_out(&vblock);

/*
  Display a completion message
*/
z_exit(1, "GETKEY completed successfully");
}
