/*******************************************************************************
FUNCTION:	evalreg

PURPOSE:	Evalute a lat/log to determine which of the 12 regions
		of the earth it lies within.
			 
Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  1.0    01/94  T. Baltzer	 Initial development
				

PROJECT:	ADAPS
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "archio.h"


int evalreg
(
double reg[12][4],		/* Region min/max lat/long values	      */
double lat,			/* Latitude in question			      */
double lng,			/* Longitude in question		      */
long regflg[]			/* Region flag, 0 = not found, 1 = found      */
)

{

long i;				/* Counter				      */


for (i = 0; i < 12; i++)
   {
   if ((lat >= reg[i][0]) && (lat <= reg[i][1]) &&
       (lng >= reg[i][2]) && (lng <= reg[i][3]))
      {
      regflg[i] = TRUE;
      break;
      }
   }

return E_SUCC;
}
