#define MAX_LINES    38880	/* Max number of lines in an acquired image  */

#define MAX_JDAY       366	/* Max number of days in a year		     */

#define MAX_LGAPS      360	/* Max number of lines in a gap (1 minute)   */
#define	MAX_BAD		 6	/* Max number of bad lines errors (1 second) */
#define	CONSEC		 3	/* Number of consecutive time codes for sync */

#define	BAD_DAY		-2	/* Bad day found error return status	     */
#define NEW_DAY		 2	/* New day found error return status	     */

#define NEW_TIME	 3	/* New time found for time correction        */
#define MISSING_TIME	 4	/* Missing lines found			     */
#define NONE_MISSED	 5	/* Skip over zero filled lines 		     */

#define MAX_MISSING	1000	/* Maximum total number of missing lines     */

#ifndef INGEST_H
#define INGEST_H
#include "las.h"
#include "model.h"
#include "acqio.h"

/* check_date.c */
/* Line       23 */
int check_date(
	long	*jday, 
	long	*jold, 
	long	*milsec, 
	double	*milold
);

/* check_time.c */
/* Line       26 */
int check_time(
	long	*acq_fd, 
	long	*dtype, 
	long	*milsec, 
	long	*milold, 
	long	*missing, 
	long	*decline
);

/* fill_missing.c */
/* Line       25 */
int fill_missing(
	long *arc_fd, 
	struct DROPPED	*drop, 
	long	*missing, 
	short	*zerobuf
);

/* find_satid.c */
/* Line       26 */
int find_satid(
	long satidx_buf[MAX_BAD], 
	long *satidx
);

/* first_rec.c */
/* Line       34 */
int first_rec(
	long *acq_fd, 
	struct SATPASS *pass
);
/* Line      405 */
int get_next_rec(
	long	*acq_fd, 
	long	jday[], 
	long	milsec[], 
	long	*satidx
);

/* fix_lines.c */
/* Line       26 */
int fix_lines(
	long	*acq_fd, 
	int	tip_fd, 
	long	*arc_fd, 
	long	*dtype, 
	long	*missing, 
	double	*milold
);

/* getpar.c */
/* Line       23 */
int getpar (
	struct PARBLK	*vblock, 
	char	*hosin, 
	char	*hosout, 
	char	*tmpfil, 
	char	*tmptip, 
	long	*genfil, 
	long	*year, 
	char	*station, 
	long	*dtype, 
	long	*msgtim
);

/* process.c */
/* Line       28 */
int process (
	long	*acq_fd, 
	long	*arc_fd, 
	int	tip_fd, 
	struct SATPASS	*pass, 
	struct MODEL	*model, 
	struct DROPPED	*drop, 
	long	*msgtim
);

/* size.c */
/* Line       16 */
int size (
	char *hostname, 
	long *nlines,
	long *acq_fd
);
#endif
