/*******************************************************************************
FUNCTION:	size

PURPOSE:	Determine the size of the acquired image and issue a message on
		how many lines we can expect.

Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  1.0    06/93  J.Fenno          Development

PROJECT:	ADAPS
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "ingest.h"
#include "util.h"
#include "adapssup.h"

int size
(
char	*hostname,		/* Host file name of the acquired image */
long	*nlines,		/* Number of expected lines		*/
long	*acq_fd			/* acquisition information structure	*/
)
{
char   str[CMLEN];		/* Temporary string variable		*/
char   hostptr[1][CMLEN];

double sizes[1];		/* Size of the image			*/

long nonfatal = 1;		/* Nonfatal error flag			*/

struct ACQDESC *acq;    /* Pointer to the acquisition input structure	*/

acq = (struct ACQDESC *)*acq_fd;

/* Get the size of the acquired image
-------------------------------------*/
strcpy( hostptr[0], hostname );
c_getsizes(hostptr, 1, sizes);


/* Determine the approximate number of lines in the acquire image
-----------------------------------------------------------------*/
*nlines = (long)sizes[0] / acq->byte_line;
if (acq->rec_line > 0)
    *nlines *= acq->rec_line;
else
    *nlines /= acq->rec_line * -1;


/* Report the number of expected lines
--------------------------------------*/
sprintf(str, "Expecting approximately %d lines", *nlines);
c_errmsg(str, " ", &nonfatal);
return(E_SUCC);
}
