/******************************************************************************
FUNCTION:	PUT_DROP

PURPOSE:	Write a dropped line of LAC/GAC data to the AVHRR archive
		file format.


Version	Date	Programmer	Modifications
-------	-----	--------------	-----------------------------------------------
  1.0	01/92	T.Baltzer	Development
  1.1	05/93	J.Fenno		Modified to use the new AVHRR model and the
				new archio supports.
  2.0	11/97	D.Lloyd		Eliminated global out_fd, removed call to
				clean_up(), and added return values.
				Part of major rewrite of INGEST1B.

PROJECT:	ADAPS
******************************************************************************/
#include "ingest1b.h"


extern long curent;		/* current processing line		*/


int put_drop
(
long	*out_fd,		/* IN: File descriptor to output image	*/
struct	MODEL *model,		/* IN: AVHRR model information		*/
short	*outbuf			/* OUT: Output buffer			*/
)
{
long	i;			/* Looping variable			*/
long	outshort;		/* number of shorts in output buffer	*/


/*
  Determine the size of the output buffer
-----------------------------------------*/
if ( model->dtype == GAC )
   outshort = MNR_WORDS + GAC_WORDS;
else
   outshort = MNR_WORDS + LAC_WORDS;

/*
  Zero-fill the entire line (prefix and data area)
--------------------------------------------------*/
for ( i = 0; i < outshort; i++ )
   outbuf[i] = 0;

/*
  Write a line to the output file
---------------------------------*/
if ( c_arcwrite( out_fd, &outbuf[0], &outbuf[MNR_WORDS] ) != E_SUCC )
   return E_FAIL;
curent++;

return E_SUCC;

}
