/*****************************************************************************
NAME:   		     CLOSEFILE

PURPOSE    Close all output images

PROGRAM HISTORY:
VERSION  PROGRAMMER  DATE   CODE/CONT  REASON
=======  ==========  =====  =========  =========================================
  5.1    J Fenno     09/91  EDC        Created to reduce duplicate code and to
				       handle the multiple files that may be
				       open.
  5.2    T. Baltzer  11/91  EDC        Make mods to use in LINEDROP application
                                        (came from SEGMREPR application).


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS
   CLOSEFILE must be run under TAE as part of SEGMREPR.

PROJECT:               LAS

ALGORITHM:

ALGORITHM REFERENCES:
******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "segmrepr.h"

/* image file descriptors used for image I/O 
--------------------------------------------*/
extern int  fdesc[];

FUNCTION closefile(num_images)

   long num_images;             /* The number of images in fdesc to close     */

{
long  image;		        /* Iterate through the images in fdesc        */
long  nonfatal = 1;             /* Nonfatal error flag                        */

for (image = 0; image < num_images; image++)
   {
   if (c_eclose(&fdesc[image]) != E_SUCC)
      c_errmsg("Nonfatal error encountered", "linedrop-warn", &nonfatal);
   }
return (E_SUCC);
}
