/***************************************************************************
NAME      		  DELETE_BLK

PURPOSE: Delete a bad data block structure from the linked list

PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS

PROJECT   	         ADAPS		                

LANGUAGE		  C	

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "linedrop.h"


FUNCTION delete_blk(blk_ptr)

   struct BAD_BLK **blk_ptr;		/* ptr to block to delete */

{
long    nonfatal = 1;                   /* nonfatal error status          */
struct BAD_BLK *temp;			/* temporary pointer		  */

temp = *blk_ptr;

if (*blk_ptr)
   {
   if (alph_blk == *blk_ptr)
      {
      alph_blk = (*blk_ptr)->next;
      if (alph_blk)
         alph_blk->prior = NULL;
      else
         beta_blk = NULL;
      }
   else
      {
      (*blk_ptr)->prior->next = (*blk_ptr)->next;
      if (*blk_ptr != beta_blk)
         (*blk_ptr)->next->prior = (*blk_ptr)->prior;
      else
         beta_blk = (*blk_ptr)->prior;
      }
   *blk_ptr = (*blk_ptr)->next;	/* return pointing to next block in list */
   free(temp);      /* return memory to system */
   }
else
   {
   c_errmsg("Error deleting null structure","linedrop-del",&nonfatal);
   return(E_FAIL);
   }

return(E_SUCC);
}
