
/***************************************************************************
NAME      		  DELETE_SEG

PURPOSE: Delete a bad data segment structure from the linked list

PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS

PROJECT   	         ADAPS		                

LANGUAGE		  C	

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "linedrop.h"


FUNCTION delete_seg(info)

   struct BAD_SEG *info;		/* ptr to block to delete */

{
long    nonfatal = 1;                   /* nonfatal error status          */
struct BAD_SEG *temp;			/* temporary pointer		  */

temp = info;

if (info)
   {
   if (alph_seg == info)
      {
      alph_seg = info->next;
      if (alph_seg)
         alph_seg->prior = NULL;
      else
         beta_seg = NULL;
      }
   else
      {
      info->prior->next = info->next;
      if (info != beta_seg)
         info->next->prior = info->prior;
      else
         beta_seg = info->prior;
      }
   free(temp); 	/* return memory to system */
   }
else
   {
   c_errmsg("Error deleting null structure","linedrop-del",&nonfatal);
   return(E_FAIL);
   }

return(E_SUCC);
}
