/***************************************************************************
NAME      		  INSERT_BLK

PURPOSE: Insert a bad data block structure into the linked list

PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS

PROJECT   	         ADAPS		                

LANGUAGE		  C	

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "linedrop.h"


FUNCTION insert_blk(ptr,sl,ss,endl,ends)

struct BAD_BLK **ptr;		/* pointer to new element to insert  */
long sl;			/* starting line of bad block		*/
long ss;			/* starting sample of bad block		*/
long endl;			/* ending line of bad block		*/
long ends;			/* ending sample of bad block		*/

{
long	nonfatal = 1;			/* nonfatal error status	  */
struct BAD_BLK *newptr;


newptr = (struct BAD_BLK *) malloc( sizeof(*newptr));
if (newptr == NULL)
   {
   c_errmsg("Error allocating dynamic memory","linedrop-alloc",&nonfatal);
   return(E_FAIL);
   }

if (beta_blk == NULL)		/* very first element in list */
   {
   newptr->next = NULL;
   newptr->prior = NULL;
   beta_blk = newptr;
   alph_blk = newptr;
   (*ptr) = newptr;
   }
else
   {
   if (*ptr)
      {
      if ((*ptr)->prior)
         {
         (*ptr)->prior->next = newptr;
         newptr->next= (*ptr);
         newptr->prior = (*ptr)->prior;
         (*ptr)->prior = newptr;
         }
      else
         {
         newptr->next = (*ptr);	    /* new first element in list */
         newptr->prior = NULL;
         (*ptr)->prior = newptr;
         alph_blk = newptr;
         }
      }
   else
      {
      newptr->next = NULL;		/* put on end of list */
      newptr->prior = beta_blk;
      beta_blk->next = newptr;
      beta_blk = newptr;
      (*ptr) = newptr;
      }
   }

newptr->start_line = sl;
newptr->start_samp = ss;
newptr->end_line = endl;
newptr->end_samp = ends;

return(E_SUCC);
}
