/***************************************************************************
NAME      		  INSERT_SEG

PURPOSE: Insert a bad data segment structure into the linked list

PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS

PROJECT   	         ADAPS		                

LANGUAGE		  C	

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "linedrop.h"


FUNCTION insert_seg(start_smpl,newptr)

long	start_smpl;			/* starting sample of new segment */
struct BAD_SEG **newptr;			/* pointer to new element */

{
long	nonfatal = 1;			/* nonfatal error status	  */
struct BAD_SEG *old, *p;		/* termporary pointers		  */


*newptr = (struct BAD_SEG *) malloc( sizeof(**newptr));
if (*newptr == NULL)
   {
   c_errmsg("Error allocating dynamic memory","linedrop-alloc",&nonfatal);
   return(E_FAIL);
   }

if (beta_seg == NULL)		/* very first element in list */
   {
   (*newptr)->next = NULL;
   (*newptr)->prior = NULL;
   (*newptr)->start_samp = start_smpl;
   beta_seg = *newptr;
   alph_seg = *newptr;
   return(E_SUCC);
   }

p = alph_seg;	/* start at top of list */
old = NULL;
while(p)
   {
   if (start_smpl > p->start_samp)	/* order in sequence of starting sample */
      {
      old = p;
      p = p->next;
      }
   else
      {
      if (p->prior)
         {
         p->prior->next = *newptr;
         (*newptr)->next= p;
         (*newptr)->prior = p->prior;
         (*newptr)->start_samp = start_smpl;
         p->prior = *newptr;
         }
      else
         {
         (*newptr)->next = p;	    /* new first element in list */
         (*newptr)->prior = NULL;
         (*newptr)->start_samp = start_smpl;
         p->prior = *newptr;
         alph_seg = *newptr;
         }
      return(E_SUCC);
      }
   }
old->next = *newptr;	/* put on end of list */
(*newptr)->next = NULL;
(*newptr)->prior = old;
(*newptr)->start_samp = start_smpl;
beta_seg = *newptr;

return(E_SUCC);
}

