/* header file used for the LINEDROP application */

#define TERM 0
#define PFILE 1
#define LP 2

struct BAD_SEG
    {
    long start_samp;                    /* Bad segment starting sample        */
    long end_samp;                      /* Bad segment ending sample          */
    long length;                        /* Length of bad segment              */
    struct BAD_SEG *next;               /* front pointer                      */
    struct BAD_SEG *prior;              /* back pointer                       */
    };

struct BAD_BLK
    {
    long start_line;                    /* Bad block starting line          */
    long start_samp;                    /* Bad block starting sample        */
    long end_line;                      /* Bad block ending line            */
    long end_samp;                      /* Bad block ending sample          */
    struct BAD_BLK *next;               /* front pointer                    */
    struct BAD_BLK *prior;              /* back pointer                     */
    };

struct FIX_BLK
    {
    struct PARBLK *vblock;       /*  TAE parameter block                       */
    char hostname[1][CMLEN];     /* host name of image to be repaired          */
    char minmax[4];              /* min/max flag                               */
    long bands[1][1];  		 /* band to be processed                       */
    long msgtim;                 /* elapsed time between display messages      */
    long dtype;                  /* data type of images to be repaired         */
    long size;                   /* number of bytes required for this dtype    */
    long window[1][4];		 /* window specification of input images       */
    FILE *out_fd;		 /* ascii output file descriptor	       */
    };

extern struct BAD_SEG *alph_seg;        /* first element in segment list */
extern struct BAD_SEG *beta_seg;        /* last element in segment list */

extern struct BAD_BLK *alph_blk;        /* first element in block list */
extern struct BAD_BLK *beta_blk;        /* last element in block list */

extern struct FIX_BLK fix;        	/* data required to fix the image */

