/***************************************************************************
NAME      		  SPLIT_BLK

PURPOSE: Split a bad data block structure into two bad data block structures.
         The new structure is inserted prior to the existing one.

PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS

PROJECT   	         ADAPS		                

LANGUAGE		  C	

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "linedrop.h"


FUNCTION split_blk(ptr,cur_line,ends)

struct BAD_BLK **ptr;		/* input: pointer to the block to split     */
				/* output: input pointer incremented by one */
long cur_line;			/* current line in image being processed    */
long ends;			/* ending sample of the bad data segment    */
				/* (point at which to split the block)	    */

{


/* Insert the new block.  Update the existing block that was split.  */

if ( insert_blk(ptr,(*ptr)->start_line,(*ptr)->start_samp,cur_line,ends) == E_FAIL )
   return(E_FAIL);
(*ptr)->start_samp = ends + 1;


return(E_SUCC);
}
