/***************************************************************************
NAME      		  SPLIT_PRT

PURPOSE: Split and report a bad data block structure.  The left-most part of
         a bad data block has completed, the right-most part of the same
         bad data block continues.  Report the left-most part of the data 
         block as being completed, reduce the size of the remaining bad data
         block accordingly.
           No inserting or deleting within the block structure linked list
         need occur.


PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS

PROJECT   	         ADAPS		                

LANGUAGE		  C	

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "linedrop.h"


FUNCTION split_rpt(ptr,ss,line)

struct BAD_BLK *ptr;		/* pointer to the block to split     */

long ss;			/* starting sample of the reduced new data block */
long line;			/* line of image currently being processed */

{

/* report the left-most portion of the block as being completed */

fix_blk(ptr->start_line,ptr->start_samp,line-1,ss-1);

/* Show the remaining portion of the block as having been reduced.  The */
/* starting line remains the same.  The ending sample remains the same. */
/* The ending line is yet undetermined.					*/

ptr->start_samp = ss;

return;
}
