/*******************************************************************************
NAME:		GETPAR

PURPOSE:	Retreive the user specified input parameters

*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "llrange.h"

int getpar
(
struct	PARBLK	*vblock,	/* TAE parameter block			     */
struct  DDR	*ddr,		/* DDR information			     */
char	hosin[][CMLEN],		/* input host image name		     */
char    *proj 			/* projection type (satellite or rectified)  */
)
{
struct VARIABLE	*var;		/* TAE variable structure		     */

long	nmrimg,			/* number of input images specified	     */
	totbnd,			/* total number of bands		     */
	same_window,		/* flag indicating if images hav same window */
	qflag[1][2],		/* flag indicating if subwindows specified   */
	fatal = -1,		/* fatal error code			     */
	zero = 0,		/* constant of zero			     */
	one = 1,		/* constant of one			     */
	status,			/* status return code			     */
	window[1][4],   	/* window specification for input/output image*/
        bands[1][MAXBND+1],     /* band number to be processed               */
        nbands[1];      	/* number of bands per input image           */

char	taein[1][CMLEN];  	/* input TAE image name                      */

/*
  Get the input image name
*/
status = c_getin(vblock,"IN",&zero,taein,hosin,&nmrimg,window,bands,nbands,
		 &totbnd,&one,&same_window,qflag);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered","llrange-fatal",&fatal);

/*
  Get the DDR information
*/
status = c_getddr((const char *)hosin,ddr);

/*
  Get the projection type
*/
var = p_find(vblock,"PROJ");
strcpy(proj,SVAL(*var,0));

return E_SUCC;
}
