#ifndef LLRANGE_H
#define LLRANGE_H

#define NULZONE 62      /* GCTP constant signifying null zone   	*/
#define DEGREES 4       /* Degrees                              	*/
#define SAT_PERIOD 102

#ifndef MIN
#define MIN(a,b)  ((a) < (b) ? (a) : (b))
#endif
#ifndef MIN3
#define MIN3(a,b,c) (min(a,b) < c) ? min(a,b) : (c)
#endif
#ifndef MAX3
#define MAX3(a,b,c) (max(a,b) > c) ? max(a,b) : (c)
#endif
#ifndef MIN4
#define MIN4(a,b,c,d) (MIN(a,b) < MIN(c,d) ? MIN(a,b) : MIN(c,d))
#endif
#ifndef MAX4
#define MAX4(a,b,c,d) (LASMAX(a,b) > LASMAX(c,d) ? LASMAX(a,b) : LASMAX(c,d))
#endif

int getpar
(
struct  PARBLK  *vblock,        /* TAE parameter block */
struct  DDR     *ddr,           /* DDR information */
char    hosin[][CMLEN],         /* input host image name */
char    *proj                   /* projection type (satellite or rectified) */
);

int projminmax
(
struct  DDR     *ddr,           /* DDR information                      */

float   *minlat,                /* minumum latitude in the image        */
float   *minlon,                /* minumum longitude in the image       */
float   *maxlat,                /* maximum latitude in the image        */
float   *maxlon                 /* maximum longitude in the image       */
);

int satminmax
(
char    *hosin,         /* input host file name                         */

float   *minlat,        /* minimum latitude of the pass                 */
float   *minlon,        /* minimum longitude of the pass                */
float   *maxlat,        /* maximum latitude of the pass                 */
float   *maxlon         /* maximum longitude of the pass                */
);

int search_sides
(
struct DDR *ddr,        /* image DDR information                        */
long    *ddr_units,     /* input units                                  */
long    *geo_code,      /* geographic projection code                   */
long    *geo_zone,      /* geographic projection zone                   */
long    *geo_units,     /* geographic projection units                  */
double  geo_parms[],    /* geographic projection parameters             */
double  *minlat,        /* minimum latitude of the pass                 */
double  *minlon,        /* minimum longitude of the pass                */
double  *maxlat,        /* maximum latitude of the pass                 */
double  *maxlon         /* maximum longitude of the pass                */
);

#include "model.h"
void findpolecross
(
    long *maxline,              /* line number of maximum lat           */
    long *minline,              /* line number of minimum lat           */
    struct MODEL *model         /* Model and orbital information        */
);



#endif
