/*******************************************************************************
FUNCTION:	errout

PURPOSE:   	Close all of the opened files, free all dynamically allocated
		memory, and call c_clean() to delete any necessary disk files
		and issue the fatal error message.

*******************************************************************************/
#include "lndetect.h"


/* Global variables defined in main program
-------------------------------------------*/
extern char infile[];
extern char outfile[];
extern char outhost[2][CMLEN];
extern char outlas[2][CMLEN];
extern long nfiles;
extern struct BUFFER bbuffer;
extern struct PARBLK vblock;


FUNCTION errout ()

{
long i;			/* Loop control                                       */


/* Free all dynamically allocated memory
----------------------------------------*/
free_buf();


/* Close the archive images
---------------------------*/
if (bbuffer.indesc != NULL)
    c_arclose(infile,&bbuffer.indesc);
if (bbuffer.outdesc != NULL)
    c_arclose(outfile,&bbuffer.outdesc);


/* Delete the output files according to $DELFLG and issue a fatal error message
------------------------------------------------------------------------------*/
c_clean(&vblock, "lndetect", outhost, &nfiles);
}
