/*******************************************************************************
FUNCTION:	flush_buf

PURPOSE:   	Write the last HALFLINES from the line detection buffer to the
		output image.

*******************************************************************************/
#include "lndetect.h"

extern long bands_all[]; /* All bands in an AVHRR archive image               */


FUNCTION flush_buf (line, buffer)

    long line;			/* IN - First line to be flushed              */
    struct BUFFER *buffer;	/* IN - Buffer for line detection             */
{
char str[CMLEN];	/* Temporary string                                   */

double mean;		/* Mean pixel value for a line                        */
double variance;	/* Variance in pixel values for a line                */

long fill     = TRUE;	/* Fill flag for c_bip2bil()                          */
long i;			/* Loop control                                       */
long nonfatal =  1;	/* Nonfatal error flag                                */
long status;		/* Function return status                             */

short *img;		/* Ptr to buffer of image data                        */
short *mnr;		/* Ptr to buffer of Minor Frame data                  */



/* For each line from line to buffer->nl
----------------------------------------*/
for (i = line; i <= buffer->nl; i++)
    {
    /* Get a pointer to the current line in the line detection buffer
    -----------------------------------------------------------------*/
    get_line(i, 1, buffer, &mnr, &img, &mean, &variance);


    /* Convert the current line from BIL to BIP.  Use the temporary buffer
       space allocated in the line detection buffer to aviod allocating and
       deallocating memory for each line.
    -----------------------------------------------------------------------*/
    c_bil2bip(img, buffer->bip, &buffer->ns, bands_all, &fill);


    /* Write the line to the output image
    -------------------------------------*/
    status = c_arcwrite(&buffer->outdesc, mnr, buffer->bip);
    if (status != E_SUCC)
	errout();
    }

return(E_SUCC);
}
