/*******************************************************************************
NAME:    LOCKFIL

PURPOSE: Lock a file if it isn't already locked

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  5.0	 D.Hollaren       03/92  Development
  5.1    J.Fenno          11/92  Replaced call to c_complt with z_exit

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
*******************************************************************************/
#include <stdio.h>
#include "las.h"

#define LOCKED	1

main()
{
struct PARBLK	vblock;		/* TAE parameter block			     */
struct VARIABLE *p_find(),	/* Function to retreive a TAE variable	     */
		*val;		/* Pointer to TAE variable with vblock	     */

long	std_out,		/* LUN to standard output		     */
	zero = 0,		/* Constant of zero			     */
	one = 1,		/* Constant of one			     */
	nonfatal = 1,		/* Nonfatal error flag			     */
	fatal = -1,		/* Fatal error flag			     */
	access = IUPDATE,	/* File access type			     */
	status;			/* Return status			     */

char	hosin[1][CMLEN],	/* Input host file name			     */
	lockflg[9],		/* Lock flag indicator			     */
	*svec[1];		/* Array of text pointers to send params     */

/*
  Initialization
*/
c_inlas(&vblock,&std_out);

/*
  Retrieve input avhrr archive file name
*/
status = c_getnam(&vblock,"INFILE",&zero,hosin[0],"img",&access);
if (status != E_SUCC)
    c_errmsg("Fatal error encountered","lockfil-fatal1",&fatal);

/*
  Get the subcommand that the routine was run with
*/
val = p_find(&vblock,"_SUBCMD");

if (strcmp(SVAL(*val,0),"LOCK") == 0)
    {
    status = c_lockfil(hosin[0],&one);
    if (status == LOCKED)
	strcpy(lockflg,"LOCKED");
    else if  (status != E_SUCC)
	c_errmsg("Fatal error encountered","lockfil-fatal2",&fatal);
    else
	strcpy(lockflg,"SUCCESS");

    /*
      Write the lock flag to the TAE parameter block
    */
    svec[0] = lockflg;
    status = q_string(&vblock,"LOCKFLG",1,svec,P_UPDATE);
    if (status != SUCCESS)
	{
	c_errmsg("Error returning the TAE parameter block",
		 "lockfil-vblock",&nonfatal);
	c_errmsg("Fatal error encountered","lockfil-fatal3",&fatal);
	}

    /*
      Write the parameter block to TAE
    */
    status = q_out(&vblock);
    if (status != SUCCESS)
	{
	c_errmsg("Error returning the TAE parameter block","lockfil-vblock",
		 &nonfatal);
	c_errmsg("Fatal error encountered","lockfil-fatal4",&fatal);
	}
    }
else
    {
    status = c_lockfil(hosin[0],&zero);
    if (status != E_SUCC)
	c_errmsg("Fatal error encountered","lockfil-fatal5",&fatal);
    }

/*
  Write a completion message 
*/
z_exit(1, "LOCKFIL completed successfully");
}
