/*******************************************************************************
NAME:           DROP_DEL

PURPOSE:        Delete a line from the given dropped line structure
		This function assumes the specified line is in fact 
		in the structure

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    ------          ------
  2.0           8/92    T. Rockvam     	Original Development

*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "archio.h"

FUNCTION drop_del(line,drop)

long	line;				/* dropped line 		*/

struct DROPPED *drop;			/* dropped line structure	*/
{
long 	gap,				/* gap counter			*/
	i;				/* loop counter			*/

/*
  Find the gap the dropped line is in
*/
for (gap = 0; gap < drop->ngaps; gap++)
    {
    if ((line >= drop->lmissed[gap]) &&
	(line < drop->lmissed[gap] + drop->nmissed[gap]))
	{
	/*
	  Found gap the line is in
    	*/
	break;
	}
    }

/*
  If this is the first or last line of the gap, ok
*/
if (line == drop->lmissed[gap])
    {
    /* first line of the gap */
    if (drop->nmissed[gap] > 1)
	{
	/* take one line out of the gap */
        drop->lmissed[gap] += 1;
        drop->nmissed[gap] -= 1;
	}
    else
	{
	/* remove this entire gap from the list */
	for (i = gap+1; i < drop->ngaps; i++)
	    {
	    drop->lmissed[i-1] = drop->lmissed[i];
	    drop->nmissed[i-1] = drop->nmissed[i];
	    }
	drop->ngaps -= 1;
	}
    }
else if (line == (drop->lmissed[gap] + drop->nmissed[gap] - 1))
    {
    /* take the last line out of the gap */
    drop->nmissed[gap] -= 1;
    }
else
    {
    /* a line in the middle in the gap */
    /* split this gap into two gaps */
    drop->lmissed[drop->ngaps] = line + 1;
    drop->nmissed[drop->ngaps] = drop->lmissed[gap]+drop->nmissed[gap]-line-1; 
    drop->nmissed[gap] = line - drop->lmissed[gap];
    drop->ngaps += 1;
    }

return;
}
