/*******************************************************************************
NAME:           DROP_SORT

PURPOSE:        Sort the dropped line structure by starting line in the gap

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    ------          ------
  2.0           8/92    T. Rockvam     	Original Development

*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "archio.h"

FUNCTION drop_sort(drop)

struct DROPPED *drop;			/* dropped line structure	*/
{
long	i,j,				/* loop counters		*/
	hold;				/* temp var for swapping	*/

/*
  Sort the input files by their start times
*/
for (i = 1; i < drop->ngaps; i++)
    {
    for (j = 1; j <= drop->ngaps-1; j++)
	{
        if (drop->lmissed[j-1] > drop->lmissed[j])
            {
            hold = drop->lmissed[j-1];
            drop->lmissed[j-1] = drop->lmissed[j];
            drop->lmissed[j] = hold;

            hold = drop->nmissed[j-1];
            drop->nmissed[j-1] = drop->nmissed[j];
            drop->nmissed[j] = hold;
            }
	}
    }

return;
}
