/*******************************************************************************
NAME:           IS_DROPPED

PURPOSE:        Given a dropped line structure, tell if the given line 
		number is a dropped line

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    ------          ------
  2.0           9/92    T. Rockvam     	Original Development

*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "archio.h"

FUNCTION is_dropped(line,drop)

long	line;				/* line number of interest 	*/

struct DROPPED *drop;			/* dropped line structure	*/
{
long 	i,				/* loop counter			*/
	drop_flg;			/* flag indicating dropped or no*/

drop_flg = FALSE;
for (i = 0; i < drop->ngaps; i++)
    {
    if ((line >= drop->lmissed[i]) &&
	(line < drop->lmissed[i] + drop->nmissed[i]))
	{
	/*
	  Found dropped line in output image
	  Find corresponding input image line
    	*/
	drop_flg = TRUE;
	break;
	}
    }

return(drop_flg);
}
