/*******************************************************************************
NAME:           KEY_COMPARE

PURPOSE:        Compare the start time of each element and return a flag 
		indicating before, same, or after

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    ------          ------
  2.0           8/92    D. Hollaren     Original Development

ALGORITHM REFERENCE:
  "C, A Reference Manual, Third Edition," by S. Harbison and G. Steele, p. 361.
*******************************************************************************/
#include "las.h"
#include "adaps.h"
#include "makorb.h"

int key_compare(e1,e2)
char *e1, *e2;
{
    long v1 = ((struct ORBIT *)e1)->start_mil;
    long v2 = ((struct ORBIT *)e2)->start_mil;
    return((v1 < v2) ? -1 : ((v1 > v2) ? 1 : 0));
}
