/*************************************************************************
FUNCTION:	MK1BTM

PURPOSE:	make a level 1-b time code from time and date info

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 1.0                                    Original development
 5.0	   12/91    T. Rockvam		LAS 5.0 conversion

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under TAE

PROJECT		ADAPS

ALGORITHM REFERENCES
                NOAA Polar Orbiter Data User's Guide
                  K. Kidwell, NOAA
                  Section 2 Level 1B Data Base

*************************************************************************/
#include <stdio.h>
#include "las.h"

void mk1btm
(
    short time[4],		/* four 16-bit words containing 4 10-bit words
			   	   of raw time				      */
    unsigned char *year,	/* byte of last two digits of year in binary  */
    unsigned char *code		/* resulting 6-byte timecode		      */
)

{
short	*date;			/* 2 bytes for date			      */
long	*msec;			/* 4 bytes for time in milliseconds	      */

date = (short *)(&code[0]);
msec = (long *)(&code[2]);

*date = (*year << 9) + ((time[0] & 01776) >> 1);
*msec = time[1] & 0177;
*msec = (*msec << 10) + (time[2] & 01777);
*msec = (*msec << 10) + (time[3] & 01777);

return;
}
