/******************************************************************************
FUNCTION:	PREPIMG

PURPOSE:	Open image and prepare for reading

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 1.0                                    Original development
 5.0 	   12/91    T. Rockvam		Conversion to LAS 5.0
 6.0	   02/98    D. Lloyd		Eliminated window set up code. It's
					now done by c_windpar().

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under TAE

PROJECT		ADAPS

ALGORITHM REFERENCES

*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "archio.h"


int prepimg
(
    char archnam[CMLEN], 	/* input image host file name           */
    long *archfd,		/* archive image file descriptor	*/
    struct MODEL *model		/* Model and orbital information	*/
)
{
long	access = IREAD,		/* archive image file access		*/
	long_window[4],		/* long version of window		*/
	status,			/* general function status		*/
	tpunit = 0;		/* always read archive from disk	*/


/* Define a long version of the window which encompasses the	*/
/* entire image.  The entire image will consequently be opened. */
/* Seeking within the file will then be relative to the entire	*/
/* image.							*/
long_window[SL] = long_window[SS] = 1;
long_window[NL] = model->nlines;
long_window[NS] = model->nsamples;

/*
  Open archive image data
*/
model->sat_view = TRUE;         /* read archive as satellite acquired it*/
status = c_arcopnrd(archnam,&access,long_window,model,&tpunit,archfd);
if (status != E_SUCC)
    return(E_FAIL);

return(E_SUCC);
}
