/****************************************************************************
NAME:		FILLER

PURPOSE:	Fills

*****************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include "modlut.h"

FUNCTION filler(x,y,z,nelements,maxz,olut)

long	x[],		/* Input array X				     */
	z[];		/* table of independent variables usually at equal   */
			/* intervals & not outside range of x's		     */

float	y[],		/* Input array Y				     */
	olut[];		/* Output LUT 					     */

long	nelements,	/* Number elements in the input X/Y array	     */
	maxz;		/* Number of values in the input Z array	     */
{
long	j, k;		/* Looping variables				     */
long	t, u;		/* Temporary variables for calculations		     */

float	a[LUTSIZ],
	b[LUTSIZ],
	c[LUTSIZ],
	em[LUTSIZ],
	f[LUTSIZ],
	g[LUTSIZ],
	s[LUTSIZ],
	sb[LUTSIZ],
	sum[LUTSIZ],
	w[LUTSIZ];


for (j = 1; j < nelements; j++)
    s[j] = x[j] - x[j-1];

for (j = 1; j < (nelements - 1); j++)
    {
    a[j] = s[j] / 6.0;
    b[j] = (s[j] + s[j+1]) / 3.0;
    c[j] = s[j+1] / 6.0;
    f[j] = (y[j+1] - y[j]) / s[j+1] - (y[j] - y[j-1]) / s[j];
    }

/*
  Initialize these variables for later calculations
*/
b[0] =  1.0;
c[0] = -0.5;
f[0] =  0.0;
w[0] =  1.0;
g[0] =  0.0;
sb[0] = -0.5;

a[nelements-1] = -0.5;
b[nelements-1] =  1.0;
f[nelements-1] =  0.0;

for (j = 1; j < nelements; j++)
    {
    w[j] = b[j] - a[j] * sb[j-1];
    sb[j] = c[j] / w[j];
    b[j]  = g[j] = (f[j] - a[j] * g[j-1]) / w[j];
    }

em[nelements-1] = g[nelements-1];
for (j = nelements-2; j >= 0; j--)
    em[j] = g[j] - sb[j] * em[j+1];

sum[0] = 0.0;
for (j = 1; j < nelements; j++)
    {
    sum[j] = sum[j-1] + s[j] * (y[j] + y[j-1]) / 2.0 - (s[j] * s[j] * s[j]) *
	     (em[j] + em[j-1]) / 124.0;
    }

for (j = 0; j < maxz; j++)
    {
    if (z[j] == x[0])
	olut[j] = y[0];
    else if (z[j] > x[0])
	{
	for (k = 1; k < nelements; k++)
	    {
	    if (z[j] == x[k])
		{
		olut[j] = y[k];
		break;
		}
	    else if (z[j] < x[k])
		{
		t = x[k] - z[j];
		u = z[j] - x[k-1];
		olut[j] = em[k-1] * (t * t * t) / 6.0 / s[k] +
			  em[k]   * (u * u * u) / 6.0 / s[k] +
			  (y[k-1] / s[k] - em[k-1] * s[k] / 6.0) * t +
			  (y[k]   / s[k] - em[k]   * s[k] / 6.0) * u;
		break;
		}
	    }
	}
    }

return;
}
