/****************************************************************************
NAME:		PUNT

PURPOSE:	Combine the calibration, control, and enhancement lookup
		tables.
*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "modlut.h"

FUNCTION punt(callut,conlut,enlut,comlut)

float	callut[],	/* Calibration LUT				     */
	conlut[],	/* Control LUT					     */
	enlut[];	/* Enhancement LUT				     */

long	comlut[];	/* Combined LUT					     */
{
long	i, j,		/* Looping variables				     */
	lut[LUTSIZ];	/* Holds LUT values for combining LUTs		     */

double	temp,		/* Temp variable to hold LUT differences	     */
	diff;		/* Check for limit on difference in LUTs	     */

for (j = 0; j < LUTSIZ; j++)
    {
    diff = 100.0;

    for (i = 0; i < LUTSIZ; i++)
	{
	temp = fabs((double)(conlut[j] - callut[i]));
	if (diff > temp)
	    {
	    diff = temp;
	    lut[j] = i;
	    }
	}
    }

/*
  Now combine enhancement
*/
for (i = 0; i < LUTSIZ; i++)
    comlut[i] = lut[(long)(enlut[i] + 0.5)];

return;
}
