/*****************************************************************************
NAME: 			GETPAR

PURPOSE:		Retrieve ORBEDIT parameter information

ALGORITHM:

ALGORITHM REFERENCES
*****************************************************************************/
#include <stdio.h>
#include "tae.h"
#include "worgen.h"
#include "adaps.h"


FUNCTION getpar(vblock,filnam,sceneid,locflg,lndflg,orbflg) 

   struct PARBLK   *vblock;	/* TAE parameter block	*/
   char   filnam[];		/* Name of input file	*/
   char   sceneid[];		/* Scene id		*/
   char   locflg[];		/* Scene location flag 	*/
   char   lndflg[];		/* Line detect flag	*/
   char   orbflg[];		/* Stitched orbit flag	*/

{

long   access,			/* Type of access for getnam call	*/
       element = 0,		/* Element number for getnam call	*/
       nonfatal = 1,		/* Nonfatal error status		*/
       size,			/* length of string			*/
       status;			/* Function return value		*/

struct VARIABLE *p_find();      /* function to find a TAE variable      */
struct VARIABLE *var;           /* pointer to a TAE variable            */


/* Get the name of the file to read and make
   sure the file exists with write permission
--------------------------------------------*/
access = IUPDATE;
status = c_getnam(vblock,"INFILE",&element,filnam,"",&access);
if (status != E_SUCC)
   return(status);


/* Get the scene id to edit the status thereof
------------------------------------------------*/
var = p_find(vblock,"SCENEID");
strcpy(sceneid,SVAL(*var,0));
size = strlen(sceneid);
c_up2low(sceneid,&size);


/* Get the status flags
---------------------------------*/
var = p_find(vblock,"LOCFLG");
if (var->v_count == 0)
   strcpy(locflg,"");
else
   strcpy(locflg,SVAL(*var,0));

var = p_find(vblock,"LNDFLG");
if (var->v_count == 0)
   strcpy(lndflg,"");
else
   strcpy(lndflg,SVAL(*var,0));

var = p_find(vblock,"ORBFLG");
if (var->v_count == 0)
   strcpy(orbflg,"");
else
   strcpy(orbflg,SVAL(*var,0));

/*
  Error if no flag modications were requested
*/
if ((strcmp(locflg,"") == 0) &&
    (strcmp(lndflg,"") == 0) &&
    (strcmp(orbflg,"") == 0))
   {
   c_errmsg("No flag modifications requested","orbedit-flre",&nonfatal);
   return(E_FAIL);
   }

return(E_SUCC); 
}
