/*****************************************************************************
NAME:			GEN_RPT

PURPOSE:  Determine whether to generate an output report or not depending
	  on what the user specified.


PROGRAM HISTORY:
Version     Date     Author             Description
-------     ----     ------             --------------
 5.0        03/92    T. Baltzer		Original development
 5.1        01/95    J. Fenno           Added code for NOAA-14 (23455)
 5.2	    06/98    D. Lloyd		Added code for NOAA-15 (25338)
 5.3        09/00    D. Lloyd           Added code for NOAA-16 (26536)
 5.4        04/02    D. Lloyd           Added code for NOAA-17 (27453)
 5.5        07/09    K.Vanumamalai      Added code for NOAA-19 (33591)

PROJECT:       ADAPS

ALGORITHM:     See in-line documentation

ALGORITHM REFERENCES:      none
******************************************************************************/
#include <stdio.h>
#include <sys/file.h>
#include "worgen.h"
#include "navspasur.h"

int gen_rpt
(
long   navid,		/* Navspasur satellite id */
long   numsat[] 	/* Satellite numbers to print out */
)
{
long   i;			 /* counter */

switch (navid)
   {
   case 15427:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 9)
		  return(E_SUCC);
		  }
	       break;
   case 16969:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 10)
		  return(E_SUCC);
		  }
	       break;
   case 19531:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 11)
		  return(E_SUCC);
		  }
	       break;
   case 21263:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 12)
		  return(E_SUCC);
		  }
	       break;
   case 23455:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 14)
		  return(E_SUCC);
		  }
	       break;
   case 25338:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 15)
		  return(E_SUCC);
		  }
	       break;
   case 26536:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 16)
		  return(E_SUCC);
		  }
	       break;
   case 27453:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 17)
		  return(E_SUCC);
		  }
	       break;
   case 28654:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 18)
		  return(E_SUCC);
		  }
	       break;

   case 33591:
               for (i = 0; i < TOTSAT; i++)
                  {
                  if (numsat[i] == 19)
                  return(E_SUCC);
                  }
               break;


   case 29499:
	       for (i = 0; i < TOTSAT; i++)
		  {
		  if (numsat[i] == 2)
		  return(E_SUCC);
		  }
	       break;
   default:
	       break;
   }

return(E_FAIL);
}
