/****************************************************************************
NAME:		GET_TBUS_PAR

PURPOSE:	Get the tbus input parameters

ALGORITHM REFERENCES:
*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "worgen.h"
#include "util.h"
#include "tbus.h"

#define TERM   0
#define LP     1
#define FIL    2

void get_tbus_par
(
struct  PARBLK  *vblock,        /* Parameter block                      */
char	*tbus,			/* TBUS input file name			*/
char    satname[][4],		/* Satellite numbers to process		*/
long	*satcnt,		/* Number of satellite IDs to process	*/
FILE	**prt_fd,		/* Print file descriptor		*/
char    *prtfile,		/* Temporary print file name		*/
char    *ofiles,		/* List of output files created		*/
long    *ocount 		/* Number of output files created	*/
)

{
struct  VARIABLE *nam;          /* Pointer to the parameter in the
                                           parameter block              */
long   	i,              	/* Looping index                        */
	zero = 0,		/* which input parameter element	*/
	access = 0,		/* read only access to file		*/
	fatal = -1,		/* Fatal error code			*/
	nonfatal = 1,		/* Nonfatal error code			*/
	print[3],		/* Print options			*/
	status;			/* Return status			*/

/* Get name of input file
   ---------------------- */
status = c_getnam(vblock,"INFILE",&zero,tbus,"bus",&access); 
if (status != E_SUCC)
    c_errmsg("Fatal error encountered","tbus-fatal",&fatal);

/* Get satellite IDs
   ----------------- */
nam = p_find (vblock,"SATID");
*satcnt = nam->v_count;
for (i = 0; i < *satcnt; i++)
    strcpy(satname[i],SVAL(*nam,i));

strcpy(prtfile,"tbus");
status = c_setprt(vblock,(int *)&print[TERM],(int *)&print[FIL],
            (int *)&print[LP],prtfile,ofiles);
if (status != E_SUCC)
    c_clean(vblock,"TBUS",(const char (*)[CMLEN])prtfile,&zero);

if (print[FIL])
    *ocount += 1;

if (print[TERM] || print[FIL] || print[LP])
    {
    *prt_fd = fopen(prtfile,"w");
    if (*prt_fd == NULL)
	{
	c_errmsg("Error opening output print file","tbus-open",&nonfatal);
	c_clean(vblock,"TBUS",(const char (*)[CMLEN])prtfile,&zero);
	}
    }
else
    *prt_fd = NULL;

}
