#ifndef NAVSPASUR_H
#define NAVSPASUR_H

#include "las.h"
#include "model.h"

#define   TOTSAT      10

int calc_navsp 
(
char    line1[],        /* Navspasur line of data to process            */
FILE    **print_file    /* File descriptor of the output print file     */
);

void get_nsp_par
(
struct PARBLK   *vblock,        /* TAE parameter block                  */
char            line1[],        /* navspasur line of information        */
FILE            **print_file,   /* File descriptor of output file       */
char            out[1][CMLEN],  /* List of output files                 */
long            *out_cnt,       /* Number of output files               */
char            fileutil_file[] /* Temporary file for fileutil */
);

int gen_rpt
(
long   navid,           /* Navspasur satellite id */
long   numsat[]         /* Satellite numbers to print out */
);

int put_navsp 
(
char   *line1, /* Line read from input file */
FILE   **print_file,       /* File descriptor of the output print file */
long   numsat[]            /* Satellite numbers to print out */
);

void timeoflight
(
double  *truea1,        /* true anomally                                */
double  *truea2,        /* true anomally                                */
struct MODEL    *model, /* Model and orbital information                */
double  *tof            /* time of flight                               */
);





#endif
