#ifndef NORAD_H
#define NORAD_H

#include "las.h"

void get_nrd_par
(
struct PARBLK   *vblock,        /* TAE parameter block                  */
char            *satid,         /* Satellite id number                  */
long            *epyr,          /* Epoch Year                           */
long            *epdy,          /* Epoch Day                            */
double          *epfd,          /* Epoch Fractional Day                 */
double          *inclin,        /* Inclination                          */
double          *rtasc,         /* Right Ascension of the Ascending Node*/
double          *ecc,           /* Eccentricity                         */
double          *argper,        /* Argument of Perigee                  */
double          *meanan,        /* Mean Anomaly                         */
double          *meanm,         /* Mean Motion                          */
FILE            **print_file,   /* File descriptor of output file       */
char            out[1][CMLEN],  /* List of output files                 */
long            *out_cnt        /* Number of output files               */
);

void put_norad
(
char   satid[],            /* Satellite id number */
long   epyr,               /* Epoch year */
long   epdy,               /* Epoch day */
double epfd,               /* Epoch fractional day */
double inclin,             /* Inclination angle */
double rtasc,              /* Right ascension of the ascending node */
double ecc,                /* Eccentricity */
double argper,             /* Argument of perigee */
double meanan,             /* Mean anomaly */
double meanm,              /* Mean motion */
FILE   **print_file        /* File descriptor of the output print file */
);


#endif
