/************************************************************************
FUNCTION:	DATESTRING

PURPOSE:	Convert an integer date in the form of YYYYJJJ into a
		character string of the form MM/DD/YY.


PROGRAM HISTORY:
Version Date    Author          Modification
_______ _____   _____________   ___________________
  1.0   10/98   D.Lloyd         Initial Development
  1.1   02/00   D.Lloyd		Minor Y2K printf format change

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under Unix

PROJECT         ADAPS

$Log: datestring.c,v $
Revision 1.5  2002/08/02 18:11:10  dlloyd
Cleaned up compiler warnings: long arguments to printf and missing headers.

Revision 1.4  2002/08/02 14:17:41  dlloyd
Modified the header file to only include headers for its prototypes.
Added necessary include in each .c file.
Moved external declaration from .h to .c file.
Added the Log directive.

*************************************************************************/
#include "worgen.h"
#include "util.h"
#include "schedcnflt.h"



int datestring(

    long date,			/* IN: integer date in form of YYYYJJJ	*/
    char *datestr		/* OUT: converted date "MM/DD/YY"	*/
)
{
long	day;			/* day					*/
long	jday;			/* julian day				*/
long	mon;			/* month				*/
long	year;			/* year					*/


/* Get gregorian month/day */
jday = date % 1000;
year = date / 1000;
c_julgre( &year, &jday, &mon, &day );

/* Convert to a string */
year %= 100;
/* change year format string -- Y2K */
sprintf( datestr, "%02ld/%02ld/%02ld", mon, day, year );

return E_SUCC;
}
