/************************************************************************
FUNCTION:	get_date

PURPOSE:	Convert a character string date in the form MM/DD/YY
		into an integer YYYYJJJ.


PROGRAM HISTORY:
Version Date    Author          Modification
_______ _____   _____________   ___________________
  1.0   10/98   D.Lloyd         Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under Unix

PROJECT         ADAPS

$Log: get_date.c,v $
Revision 1.5  2002/08/02 18:17:11  dlloyd
Added include of string.h

Revision 1.4  2002/08/02 18:13:59  dlloyd
Corrected an error in reading the header lines from the autogen report, it
was reading one less line in one place and one too many in another.  CR 6560

Revision 1.3  2002/08/02 14:17:41  dlloyd
Modified the header file to only include headers for its prototypes.
Added necessary include in each .c file.
Moved external declaration from .h to .c file.
Added the Log directive.

*************************************************************************/
#include <string.h>
#include "util.h"
#include "schedcnflt.h"

long get_date(

    char *cdate			/* IN: character date as MM/DD/YY	*/
)
{
char	str[9];			/* local copy of char date		*/

long	day;			/* extracted day			*/
long	jdate;			/* julian day				*/
long	mon;			/* extracted month			*/
long	year;			/* extracted year			*/


/* Make a local copy of the date and replace '\' with ' '
and convert the char values to integer values.
---------------------------------------------------------*/
strcpy( str, cdate );
str[2] = str[5] = ' ';
sscanf( str, "%ld %ld %ld", &mon, &day, &year );

/* Convert to year to 4-digits and get a julian day
---------------------------------------------------*/
year = c_4digityr( year );
c_grejul( &year, &mon, &day, &jdate );

/* Combine the year and jday into a single value
------------------------------------------------*/
jdate += year * 1000;

return jdate;
}
