/************************************************************************
FUNCTION:	GET_TIME

PURPOSE:	Convert a character string time of the form HH:MM:SS
		into an integer seconds since midnight.


PROGRAM HISTORY:
Version Date    Author          Modification
_______ _____   _____________   ___________________
  1.0   10/98   D.Lloyd         Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under Unix

PROJECT         ADAPS

$Log: get_time.c,v $
Revision 1.5  2002/08/02 18:17:11  dlloyd
Added include of string.h

Revision 1.4  2002/08/02 18:11:10  dlloyd
Cleaned up compiler warnings: long arguments to printf and missing headers.

Revision 1.3  2002/08/02 14:17:41  dlloyd
Modified the header file to only include headers for its prototypes.
Added necessary include in each .c file.
Moved external declaration from .h to .c file.
Added the Log directive.

*************************************************************************/
#include <string.h>
#include "schedcnflt.h"

long get_time(

    char *ctime			/* IN: character string as HH:MM:SS	*/
)
{
char	str[9];			/* local copy of char ctime		*/

long	hr;			/* extracted hour			*/
long	min;			/* extracted minute			*/
long	sec;			/* extracted seconds			*/
long	time;			/* extracted time in seconds		*/


/* Make a local copy of the time, replace the ':' with ' ',
and convert to integers
-----------------------------------------------------------*/
strcpy( str, ctime );
str[2] = str[5] = ' ';
sscanf( str, "%ld %ld %ld", &hr, &min, &sec );

/* calculate total seconds since midnight
-----------------------------------------*/
time = 0;
time += hr * SEC_PER_HR;
time += min * SEC_PER_MIN;
time += sec;

return time;
}
