/************************************************************************
FUNCTION:	PRINT_FOOTER

PURPOSE:	Print a footer to the report file.


PROGRAM HISTORY:
Version Date    Author          Modification
_______ _____   _____________   ___________________
  1.0   10/98   D.Lloyd         Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under Unix

PROJECT         ADAPS

$Log: print_footer.c,v $
Revision 1.5  2002/08/08 15:59:37  dlloyd
Modified the report so that the 16-digit sceneid is used in place of the
satellite and orbit number and shortened the line width by 4.

Revision 1.4  2002/08/02 18:11:10  dlloyd
Cleaned up compiler warnings: long arguments to printf and missing headers.

Revision 1.3  2002/08/02 14:17:41  dlloyd
Modified the header file to only include headers for its prototypes.
Added necessary include in each .c file.
Moved external declaration from .h to .c file.
Added the Log directive.

*************************************************************************/
#include <string.h>
#include "worgen.h"
#include "schedcnflt.h"



int print_footer(

    FILE	*ouf,		/* IN: output file descriptor		*/
    struct PASS	**passlist	/* IN: pointer to pass list		*/
)
{
char	edate[9];		/* end date				*/
char	sdate[9];		/* start date				*/

struct	PASS	*curr;		/* pointer to current pass		*/


/* determine starting and ending dates
--------------------------------------*/
curr = *passlist;
strncpy( sdate, &curr->line[17], 8 );
sdate[8] = 0;
while ( curr->next != NULL )
    curr = curr->next;
strncpy( edate, &curr->line[41], 8 );
edate[8] = 0;

/* print the footer
-------------------*/
fprintf( ouf, "\n\nThis report covers the period %s through %s\n",
		sdate, edate );

return E_SUCC;
}

