/************************************************************************
FUNCTION:	PRINT_HEADER

PURPOSE:	Print a header to the report file.


PROGRAM HISTORY:
Version Date    Author          Modification
_______ _____   _____________   ___________________
  1.0   10/98   D.Lloyd         Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under Unix

PROJECT         ADAPS

$Log: print_header.c,v $
Revision 1.4  2002/08/08 15:59:37  dlloyd
Modified the report so that the 16-digit sceneid is used in place of the
satellite and orbit number and shortened the line width by 4.

Revision 1.3  2002/08/02 14:17:41  dlloyd
Modified the header file to only include headers for its prototypes.
Added necessary include in each .c file.
Moved external declaration from .h to .c file.
Added the Log directive.

*************************************************************************/
#include "worgen.h"
#include "schedcnflt.h"

int print_header(

    FILE	*ouf,		/* IN: output file descriptor		*/
    struct tm	*lctm		/* IN: pointer to local time structure	*/
)
{
static	char	*month[12] = { "Jan","Feb","Mar","Apr","May","Jun","Jul",
				"Aug","Sep","Oct","Nov","Dec" };
static	char	*wday[7] = { "Sun","Mon","Tue","Wed","Thu","Fri","Sat" };


fprintf( ouf, " %s. %s %d %d", wday[lctm->tm_wday], month[lctm->tm_mon],
		lctm->tm_mday, lctm->tm_year+1900 );
fprintf( ouf, "                 EROS Data Center \n" );
fprintf( ouf, " Time %02d:%02d               Sioux Falls, South Dakota  57198\n", lctm->tm_hour, lctm->tm_min );
fprintf( ouf, "                    AVHRR Data Acquisition and Processing System\n" );
fprintf( ouf, "                     Automatic Pass Acquisition Conflict Report\n\n\n" );
fprintf( ouf, "                 Start       Start       End         End       Pass\n" );
fprintf( ouf, "Scene ID         Date        Time        Date        Time      Length\n" );
fprintf( ouf, "________________ ________    ________    ________    ________  _____\n\n" );

return E_SUCC;
}
