/************************************************************************
FUNCTION:	TIMESTRING

PURPOSE:	Change an integer time value in seconds since midnight
		into a character string HH:MM:SS.


PROGRAM HISTORY:
Version Date    Author          Modification
_______ _____   _____________   ___________________
  1.0   10/98   D.Lloyd         Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under Unix

PROJECT         ADAPS

$Log: timestring.c,v $
Revision 1.4  2002/08/02 18:20:23  dlloyd
Added long modifier to printf

Revision 1.3  2002/08/02 14:17:42  dlloyd
Modified the header file to only include headers for its prototypes.
Added necessary include in each .c file.
Moved external declaration from .h to .c file.
Added the Log directive.

*************************************************************************/
#include "worgen.h"
#include "schedcnflt.h"



int timestring(

    long	tsec,		/* IN: seconds since midnight		*/
    char	*timestr	/* OUT: string representation of input	*/
)
{
long	hr;			/* calculated hour			*/
long	min;			/* calculated minute			*/
long	sec;			/* calculated seconds			*/


sec = tsec;
hr = sec / SEC_PER_HR;
sec -= hr * SEC_PER_HR;

min = sec / SEC_PER_MIN;
sec -= min * SEC_PER_MIN;

sprintf( timestr, "%02ld:%02ld:%02ld", hr, min, sec );


return E_SUCC;
}
