/******************************************************************************
FUNCTION:	CHECKDAY

PURPOSE:	Validate the date entered by the user

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "worgen.h"
#include "savparms.h"

int checkday
(
long	date[]			/* date (month, day, year)		*/
)
{
long	nonfatal = 1;		/* nonfatal error code			*/
static long days[12] =  {31,28,31,30,31,30,31,31,30,31,30,31};
static long ldays[12] = {31,29,31,30,31,30,31,31,30,31,30,31};

/*
  Check to make sure the month is valid
*/
if ((date[0] < 1) || (date[0] > 12))
    {
    c_errmsg("Invalid month specified","savparms-month",&nonfatal);
    return(E_FAIL);
    }

/*
  Set up the year as a 4-digit year
*/
/*
  DLLOYD Y2K 
-------------*/
date[2] = c_4digityr( date[2] );

/*
  Check to make sure the year is valid
*/
if (date[2] < 1986)
    {
    c_errmsg("Invalid year specified","savparms-year",&nonfatal);
    return(E_FAIL);
    }

/*
  Check to make sure the day is valid
*/
if (c_isleap(&date[2]))
    {
    if ((date[1] < 1) || (date[1] > ldays[date[0]-1]))
        {
        c_errmsg("Invalid day of month specified","savparms-day",&nonfatal);
        return(E_FAIL);
        }
    }
else
    {
    if ((date[1] < 1) || (date[1] > days[date[0]-1]))
        {
        c_errmsg("Invalid day of month specified","savparms-day",&nonfatal);
        return(E_FAIL);
        }
    }

return(E_SUCC);
}
