/******************************************************************************
FUNCTION:	CHECKTIM

PURPOSE: 	Validate the first element (hours) of the time parameters.

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include "tae.h"
#include "worgen.h"
#include "savparms.h"

int checktim
(
long	time[]			/* time (hour, min, sec)		*/
)
{
long	nonfatal = 1;		/* nonfatal error code			*/

/*
  The PDF accepts time as a three-value parameter as (hour, min, sec).  The 
  parameter declaration requires values between 0 and 59 so that the terminal 
  monitor validates the minutes and seconds.  This procedure verifies that the 
  value for the hour is between 0 and 23.
*/
if (time[0] > 23)
    {
    c_errmsg("Invalid hour specified","savparms-hour",&nonfatal);
    return(E_FAIL);
    }

return(E_SUCC);
}
