/******************************************************************************
FUNCTION:	DELETE_SID

PURPOSE:	Deletes a record from the master schedule using the scene-id.

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
  1.0      12/86     P. Mumford         Initial development
  5.0      01/89     D. Hollaren        Conversion to LAS-5.0
  5.1      07/92     T. Rockvam         Separated delete functions into separate
					files

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "worgen.h"
#include "schedit.h"

void delete_sid
(
struct	SCHED	*schrec			/* Record information for delete*/
)
{
extern long	nrecs;			/* Number of master records	*/
extern struct SCHED *master[MAXRECS];	/* Master schedule addresses	*/

struct SCHED	*recptr;		/* Pointer to master schedule	*/

long	rec,				/* Record counter		*/
	dflag;				/* Delete flag			*/

dflag = FALSE;

/*
  Search the list of records in ascending order for the specified scene-id
*/
for (rec = 0; rec < nrecs; rec++)
    {
    recptr = *(master + rec);
    if (strcasecmp(recptr->scene_id,schrec->scene_id) == 0)
	{
	dflag = TRUE;
	break;
	}
    }

/*
  If a scene-id match was found remove the record
*/
if (dflag)
    {
    /*
      Decrement the number of master records
    */
    nrecs--;

    /*
      Move the remaining records up
    */
    for ( ; rec < nrecs; rec++)
	*(master + rec) = *(master + rec + 1);

    printf("[informational] Record with scene ID %s was deleted\n",
	schrec->scene_id);
    }
else
    {
    printf("[schedit-noscene] Record with scene ID %s not found\n",
	schrec->scene_id);
    }

return;
}
