/******************************************************************************
FUNCTION:	MAKESECS

PURPOSE:	Compute the total number of seconds in the date and time

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "worgen.h"
#include "savparms.h"

int makesecs
(
long	date[],			/* date (month, day, year)		*/
long	time[],			/* time (hour, min, sec)		*/
long	*totsecs		/* total seconds			*/
)
{
long	jday;			/* julian day				*/
long	yr;
long 	totdays;

/*
  The number of seconds is used both to validate that the beginning
  and end of the acquisition are reasonably close and to write to the
  temporary file. 
*/
c_grejul(&date[2],&date[0],&date[1],&jday);

totdays = 0;
for (yr = 1986; yr < date[2]; yr++)
    {
    if (c_isleap(&yr))
        totdays += 366;
    else
	totdays += 365;
    if (yr == 100) yr = 0;
    }
totdays += jday;

*totsecs = (totdays - 1) * 86400 + time[0] * 3600 + time[1] * 60 + time[2];

return(E_SUCC);
}
