#ifndef SAVEPARMS_H
#define SAVEPARMS_H

#include "tae.h"

/* checkday.c */
/* Line       11 */
int checkday
(
long	date[]	/* date (month, day, year)              */
);

/* checktim.c */
/* Line       11 */
int checktim
(
long	time[]	/* time (hour, min, sec)                */
);

/* getpar.c */
/* Line       11 */
int getpar
(
struct  PARBLK	*vblock,	/* TAE variable block           */ 
char	*schedfile, 		/* schedule update file         */
char	*subcmd, 		/* subcommand                   */
char	*satid, 		/* satellite id                 */
char	*acqstat, 		/* acquisition status           */
char	*prodflag, 		/* product order flag           */
char	*station, 		/* station code                 */
char	*upstation, 		/* stations to update code      */
char	*dtype, 		/* data type                    */
char	*sceneid, 		/* scene id                     */
long	*orbit, 		/* orbit number                 */
long	*a_start_tsec, 		/* acq total seconds start time */
long	*a_stop_tsec, 		/* acq total seconds stop time  */
long	*p_start_tsec, 		/* pass total seconds start time*/
long	*p_stop_tsec, 		/* pass total seconds stop time */
long	*opcode, 		/* operation code               */
long	*hdtrfile		/* HDTR tape file number        */
);

/* makesecs.c */
/* Line       11 */
int makesecs
(
long	date[], 		/* date (month, day, year)              */
long	time[], 		/* time (hour, min, sec)                */
long	*totsecs		/* total seconds                        */
);

/* wrt_tmpfile.c */
/* Line       11 */
void wrt_tmpfile
(
char	*subcmd, 	/* subcommand selected                  */
char	*schedfile, 	/* name of schedule update file         */
char	*sceneid, 	/* scene id                             */
char	*satid, 	/* satellite id (N10, N11, N12)         */
long    a_start_sec, 	/* acq total second start time          */
long    a_stop_sec, 	/* acq total second stop time           */
long    p_start_sec, 	/* pass total second start time         */
long    p_stop_sec, 	/* pass total second stop time          */
long    opcode, 	/* operation code                       */
char	*acqstat, 	/* acquisition status (D,T,B,P,M,N)     */
long    hdtrfile, 	/* HDTR tape file number                */
char	*prodflag, 	/* product flag                         */
char	*station, 	/* station (E, F, W,)                   */
char	*upstation, 	/* station to update (E, F, W, all)     */
char	*dtype, 	/* data type (HRPT, LAC_, GAC_)         */
long    orbit		/* orbit number                         */
);

#endif
