/*
  Master schedule size and maximum number of records
*/
#define MAXRECS	6000

/*
  Daylight savings time flag
  0 = no DST	1 = DST
  used to list the schedule (list_sched.d)
*/
#define DAYSAV 0

/*
  Structure of the master record
*/
struct	SCHED
	{
	char	scene_id[17];
	char	satid[4];
	long	lstart;
	long	lstop;
	long	rstart;
	long	rstop;
	long	opmode;
	char	stat[2];
	long	tfile;
	char	pflag[2];
	char	dnflag[2];
	char	station[2];
	char	atype[5];
	char	orbit[6];
	};

/*
  Defines for status of a master record
*/
#define DISK	'D'
#define TAPE	'T'
#define BOTH	'B'
#define PENDING	'P'
#define MISSED	'M'
#define NONE	'N'

/*
  Defines for acquire operations
*/
#define TAPEtoDISK	5
#define NOOPFIVE	15

/*
  Formats needed to read the master schedule, and temp files for adding,
  modifing, deleting and reporting.
*/
#define SCHEDULE_FORMAT	"%s %s %d %d %d %d %d %s %02d %s %s %s %s %s\n"
#define INSERT_FORMAT	"%s %s %d %d %d %d %d %s %d %s %s %s %s\n"
#define MODIFY_FORMAT	"%d %d %s %d %s %d %s %s %s %s"
#define MODSTA_FORMAT	"%d %d %s %s %d %s %d %s %s %s %s"
#define MODSID_FORMAT	"%s %s %d %s %d %s %s %s %s"
#define DELETE_FORMAT	"%d %d"
#define DELSID_FORMAT	"%s"
#define LINE_FORMAT \
"%s%s  %s  %s   %s  %s  %s  %s  %s  %s  %s  %d  %s  %s   %s    %s\n"

/*
  Report format defines
*/
#define TAB	"      "
#define INDENT	"                                          "

/*
  Size of report page
*/
#define	PAGE_SIZE	 50

/*
  Help on how to use SCHEDIT
*/
#define USAGE_ERROR \
"Usage: \tschedit -[af | df | ds | mf | ma | ms | rb | rl] [file | \"--\"]\n"


/*
  Misc defines
*/
#define STOP	0
#define START	1

