#ifndef SCHEDIT_H
#define SCHEDIT_H

#include "sched.h"

/* consec.c */
/* Line       20 */
void consec
(
long	*totsecs, 	/* Total seconds from 1986              */
long	*year, 		/* Year of totsecs                      */
long	*jday, 		/* Julian day of totsecs                */
long	*month, 	/* Month of totsecs                     */
long	*day, 		/* Day of totsecs                       */
long	*hours, 	/* Hour of totsecs                      */
long	*minutes, 	/* Minutes of totsecs                   */
long	*seconds	/* Seconds of totsecs                   */
);

/* delete.c */
/* Line       20 */
void delete_rec
(
struct	SCHED	*schrec		/* Record information for delete*/
);

/* delete_sid.c */
/* Line       20 */
void delete_sid
(
struct	SCHED	*schrec		/* Record information for delete*/
);

/* find.c */
/* Line       19 */
int find_loc
(
long	rectime, 		/* Time to find                         */
long	dirflag			/* Direction to search schedule in      */
);

/* get_sched.c */
/* Line       21 */
int get_sched
(
FILE	**mfp,			/* File pointer for master schedule file*/
char    *operation		/* operation to perform			*/
);

/* insert.c */
/* Line       22 */
int insert_rec
(
struct	SCHED	*schrec		/* Record information to add    */
);

/* list_sched.c */
/* Line       23 */
int list_sched
(
char	*filename, 		/* Report file name                     */
long	sform			/* Report format (long or short)        */
);

/* modify.c */
/* Line       18 */
void modify_rec
(
struct	SCHED	*schrec		/* Record information for modify*/
);

/* modify_sid.c */
/* Line       17 */
void modify_sid
(
struct	SCHED	*schrec		/* Record information for modify*/
);

/* modify_sta.c */
/* Line       18 */
void modify_sta
(
struct	SCHED	*schrec, 	/* Record information for modify*/
char	*key			/* Which stations to update     */
);

/* put_sched.c */
/* Line       18 */
int put_sched
(
FILE    *mfp			/* File pointer for master schedule file*/
);

/* setdn.c */
/* Line       21 */
int setdn
(
char	*satid, 	/* Satellite id (e.g. N11)              */
long	start, 		/* Start time in total seconds          */
long	stop, 		/* Stop time in total seconds           */
char	*dnflag, 	/* Day/Night flag                       */
char	*atype		/* Acquisition data type                */
);

/* write_foot.c */
/* Line       19 */
void write_foot
(
FILE	*report, 	/* Report file pointer                  */
long	*line		/* Line counter for paging              */
);

/* write_head.c */
/* Line       19 */
void write_head
(
FILE	*report, 	/* Report file pointer                  */
long	*line, 		/* Line counter for page writing        */
long	*otype		/* Header type (tape or other)          */
);

/* write_line.c */
/* Line       24 */
void write_line
(
FILE	*report, 	/* Report file pointer                  */
long	*line, 		/* Line number counter                  */
struct SCHED *schrec, 	/* Pointer to schedule record           */
long	*loffset, 	/* Total seconds from local to GMT      */
long	*otype		/* Header type (tape or other)          */
);

#endif
