/******************************************************************************
FUNCTION:	WRITE_HEAD

PURPOSE:	Write the header information at the top of the report

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
  1.0      12/86     P. Mumford         Initial development
  5.0      01/89     D. Hollaren        Conversion to LAS-5.0
  5.1      07/92     T. Rockvam         Split into separate file

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "worgen.h"
#include "schedit.h"

void write_head
(
FILE	*report,		/* Report file pointer			*/
long	*line,			/* Line counter for page writing	*/
long	*otype			/* Header type (tape or other)		*/
)
{
/*
  If at the end of the page write the footer
*/
if ((*line + 7) > PAGE_SIZE)
    {
    write_foot(report,line);
    fprintf(report,"\f");
    *line = 0;
    }

if (*otype)
    fprintf(report,"\n\n%s%s%s\n\n",TAB,INDENT," OTHER PASSES TO RECEIVE");
else
    fprintf(report,"\n\n%s%s%s\n\n",TAB,INDENT,"PASSES RECEIVED TO TAPE");

fprintf(report,"%s%s%s%s\n",TAB,"     Scene        Sat  Orbit           Local",
	"                Acquisition          Station    Data           Tape",
	"  Prod");

fprintf(report,"%s%s%s%s\n",TAB,"      Id          Id   Number     Date      ",
	"Time      Date     Start      Stop     Id       Type  Op Stat  File",
	"  Flag D/N");

fprintf(report,"%s%s%s%s\n",TAB,"----------------  ---  ------  ",
	"------------------  ----------------------------  -------    ----  ",
	"-- ----  ----  ---- ---");

*line += 7;

return;
}
