/****************************************************************************
NAME:		GETPAR

PURPOSE:	Retrieve parameter information

ALGORITHM(FLOW): 	See in line documentation

ALGORITHM REFERENCES:	None
****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"

FUNCTION getpar(vblock,addr_model,lutnum,tstamp)

struct PARBLK	*vblock;     	/* TAE parameter block */
struct MODEL	*addr_model; 	/* Avhrr model info    */
 
char 	*lutnum,	        /* Look up table number */
	*tstamp;		/* Time that the browse was generated */

{
struct VARIABLE	*p_find();	/* Function to get a TAE variable */
struct VARIABLE *var;		/* Pointer to a TAE variable in vblock */

char	hosin[1][CMLEN];	/* Input host filename */

long	access = IREAD;         /* Access for which hosin is opened */
long	element = 0;		/* Constant zero */
long	fatal = -1;		/* Fatal error code */
long	nonfatal = 0;		/* Non-Fatal error code */
long	bhour,bmin,bsec;	/* Browse time */

/* Get host filename 
--------------------*/
if (c_getnam(vblock, "IN", &element, hosin, "img", &access) != E_SUCC)
    c_errmsg("Fatal error encountered", "setannot-fatal", &fatal);

/* Call getaddr to get avhrr header 
-----------------------------------*/
if (c_getaddr(hosin[0],addr_model) != E_SUCC)
    c_errmsg ("Fatal error encountered", "setannot-fatal", &fatal);

/* Retrieve browse time stamp
-----------------------------*/
var = p_find(vblock,"TSTAMP");
strcpy(tstamp,SVAL(*var,0));
if (strlen(tstamp) < 6)
    {
    c_errmsg("Invalid time stamp","setannot-time",&nonfatal);
    c_errmsg("Fatal error encountered","setannot-fatal",&fatal);
    }

sscanf(tstamp,"%2d%2d%2d",&bhour,&bmin,&bsec);
if ((bhour > 24) || (bmin > 60) || (bsec > 60) ||
    (bhour < 0)  || (bmin < 0)  || (bsec < 0))
    {
    c_errmsg("Invalid time stamp","setannot-time",&nonfatal);
    c_errmsg ("Fatal error encountered", "setannot-fatal", &fatal);
    }

/* Retrieve the LUT number
--------------------------*/
var = p_find(vblock, "LUTNUM");
strcpy(lutnum, SVAL(*var,0));

return;
}
