/*****************************************************************************
NAME: 			GETPAR

PURPOSE:		Retrieve SUBREGIONS parameter information

ALGORITHM:

ALGORITHM REFERENCES:	none.
*****************************************************************************/
#include <stdio.h>
#include "tae.h"
#include "worgen.h"
#include "adaps.h"


FUNCTION getpar(vblock,infile,outfile,usrreg,orbflg) 

   struct PARBLK   *vblock;	/* TAE parameter block	*/
   char   infile[];		/* Name of input file	*/
   char   outfile[];		/* Name of output file	*/
   long   usrreg[];		/* User specified regions */
   long   *orbflg;		/* Orbit print flag	*/

{


long   faccess,			/* Type of access for getnam call	*/
       element = 0,		/* Element number for getnam call	*/
       fatal = -1,		/* Fatal error status			*/
       i,			/* Counter				*/
       status;			/* Function return value		*/

struct VARIABLE *p_find();      /* function to find a TAE variable      */
struct VARIABLE *var;           /* pointer to a TAE variable            */


/* Get the name of the file to read and make
   sure the file exists with read permission
--------------------------------------------*/
faccess = IREAD;
status = c_getnam(vblock,"INFILE",&element,infile,"",&faccess);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered","subregions-fatal",&fatal);


/* Get the name of the output file and make sure it
   doesn't already exist
---------------------------------------------------*/
faccess = IWRITE;
status = c_getnam(vblock,"OUTFILE",&element,outfile,"",&faccess);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered","subregions-fatal",&fatal);


/* Get the regions specification
---------------------------------*/
for (i = 0; i < 12; i++)
   usrreg[i] = FALSE;
var = p_find(vblock,"REGIONS");
for (i = 0; i < var->v_count; i++)
   usrreg[IVAL(*var, i) - 1] = TRUE;
      

/* Get the orbital print flag parameter
----------------------------------------*/
var = p_find(vblock,"ORBFLG");
if ((strcmp(SVAL(*var, 0),"YES") == 0))
    *orbflg = TRUE;
else
    *orbflg = FALSE;


}
