/******************************************************************************
NAME:   			LINE_INFO 

PURPOSE:    Get information from one line of an orbital stitch list data file.

PROGRAM HISTORY:
VERSION	   PROGRAMMER	   DATE		REASON
-------	   ----------      ----		------
  1.0	   T. Baltzer	   02/94	Original Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:			ADAPS

ALGORITHM:
   See in-line documentation.

   ALGORITHM REFERENCES:		none
******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "stitch.h"             /* Orbital stitch include file         */


FUNCTION line_info(infp,linebuf)

FILE *infp;			/* LUT file pointer			*/
char linebuf[CMLEN+1];		/* Buffer containing line of data	*/

{


/* Read a line, if NULL is returned,
   assume the EOF has been encountered. Don't
   print an error message.
   If the line of interest is a blank line, get
   the next line.
--------------------------------------------------*/
for (;;)
   {
   if ( fgets(linebuf,CMLEN+1,infp) == NULL)
      return(E_FEND);
   if (strcmp(linebuf,"\n") != 0)
      break;
   }


return(E_SUCC);
}
