/******************************************************************************
NAME:   			READHEADER 

PURPOSE:    Open the input file and read past the header line

PROGRAM HISTORY:
VERSION	   PROGRAMMER	   DATE		REASON
-------	   ----------      ----		---------
  1.0	   T. Baltzer	   02/94	Original Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:			ADAPS

ALGORITHM:
   See in-line documentation.

   ALGORITHM REFERENCES:		none
******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "stitch.h"             /* Orbital stitch include file         */


FUNCTION readheader(infile,linebuf,infp)

   char infile[CMLEN];		/* Half orbit file name			*/
   char linebuf[];		/* Buffer containing line of data	*/
   FILE **infp;			/* LUT file pointer                     */

{

long fatal = -1;		/* Fatal error status			*/
long nonfatal = 1;		/* non-fatal error message		*/


FILE *fopen();			/* File open routine                    */


/* Open the input file
-----------------------*/
*infp = fopen(infile,"r");
if (*infp == NULL)
   {
   c_errmsg("Error opening input file","subregions-open",&nonfatal);
   c_errmsg("Fatal error encountered","subregions-fatal",&fatal);
   }

/* Read the header information
-------------------------------*/
for ( ; ; )
   {
   if ( fgets(linebuf,CMLEN+1,*infp) == NULL)
      {
      c_errmsg("Error reading header in input file","subregions-head",&nonfatal);
      c_errmsg("Fatal error encountered","subregions-fatal",&fatal);
      }

   /* If its the header line, then quit
   -------------------------------------*/
   if ( strncmp(&linebuf[0],"tapeid",6) == 0 )
      break;
   }

}
