#ifndef TAPEL1B_H
#define TAPEL1B_H

#include "model.h"

void finish
(
struct  PARBLK  *vblock,        /* parameter block                      */
char    *drive,                 /* drive name                           */
long    *nvols,                 /* number of volumes used               */
long    tplun,                  /* tape unit number                     */
FILE    *in_fd,                 /* input image file descriptor          */
long    *kbyteswritten,         /* number of bytes written to tape      */
char    sceneid[],              /* Scene id                             */
char    lasout[],               /* LAS output name of summary file      */
long    tae                     /* flag: called from tae land           */
);


void getargv
(
long    argc,                   /* count of arguments in argv[]         */
char    *argv[],                /* array of arguments                   */
char    *comment,               /* tape mount comment(s)                */
char    *infile,                /* input file name                      */
char    *acctnum,               /* account number                       */
char    *ordernum,              /* order number                         */
char    *unitnum,               /* unit number                          */
char    *prodesc,               /* product description                  */
char    *drive,                 /* drive tape is mounted on             */
char    *ttype,                 /* tape type                            */
long    *nvols,                 /* volume number in this set            */
long    *mvolflg,               /* flag: TRUE allows multiple volumes   */
char    *density,               /* tape density                         */
long    *maxbytes               /* max allowable kbytes for tape write  */
);


void getpar
( 
struct  PARBLK  *vblock,        /* input parameter block                */
char    *infile,                /* input image host file name           */
char    comment[CMLEN],         /* tape mount comment                   */
char    acctnum[10],            /* account number                       */
char    ordernum[14],           /* order number                         */
char    unitnum[5],             /* unit number                          */
char    prodesc[18],            /* product description                  */
char    *drive,                 /* drive name                           */
long    *mvol,                  /* multiple tape volume flag            */
long    *nvols,                 /* number of volumes used               */
char    *density,               /* tape density                         */
char    *ttype,                 /* tape type                            */
long    *msgtim,                /* time between processing messages     */
long    *max_bytes,             /* maximum bytes allowed for tape       */
long    *kbyteswritten          /* number of bytes written to tape      */
);


int process
(
long    *tplun,                 /* IN: output tape lun                  */
FILE    *in_fd,                 /* IN: input image file descriptor      */
long    recsiz,                 /* IN: Level 1b record size             */
long    msgtim,                 /* IN: time for processing message      */
struct  MODEL   *model,         /* IN: Model and orbital information    */
long    max_bytes,              /* IN: max bytes to write to tape       */
long    *kbyteswritten,         /* IN/OUT: bytes written to tape        */
long    *tape                   /* IN/OUT: tape open flag               */
);

#endif
