/***********************************************************************
NAME: totdirsz 

PURPOSE: Get the cumulative file size of all files in a directory.


PROGRAM HISTORY
Version   Date    Programmer        Code  Reason
-------   ----    -------------     ----- ------
  1.0     04/95   K.Lowell            C   Initial Development
  2.0	  10/95   T.Baltzer	      Modified to only return total bytes
				      in the directory
  2.1	  11/95   T.Baltzer	      Make fname 1999 instead of 999 big

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS
  Must be run under UNIX and TAE

PROJECT: LAS

************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include "math.h"
#include "las.h"
#include "string.h"

main()

{
DIR *dirp;
struct dirent *direntp;

FILE *ptr;			/* File pointer           */

struct PARBLK vblk;		/* TAE parameter block    */

long totsize=0;		/* Size of all order files */
long fatal = -1;		/* Fatal error flag	  */
long std_out;			/* standard out		  */
long status;			/* Status indicator       */
long ii;			/* Counter for loops	  */
long one = 1;
long zero = 0;
long tmpsize;			/* Tmp file size hold     */


char fname[1999][CMLEN];	/* file name       */
char callstr[CMLEN];            /* Dir path structure     */
char outlist[CMLEN];		/* output list		  */
char indir[CMLEN];		/* Input directory		  */
char progname[CMLEN];		/* Program name		  */


/* Initialize TAE parameter block
-----------------------------------*/
c_inlas(&vblk,&std_out);

/* Get the variables from the TAE variable block
--------------------------------------------------*/
if ((getpar(&vblk,indir)) != E_SUCC)
  c_errmsg("Fatal error encountered","totdirsz-fatal",&fatal);

/* Get the names of all files in the specified directory
----------------------------------------------------------*/
dirp = opendir(indir);
if (dirp == NULL)
  c_errmsg("Error opening directory","totdirsz-fatal",&fatal);
ii = 0;
while ((direntp = readdir (dirp)) !=NULL)
  {
  if ((strcmp(direntp->d_name,".")!=0) && (strcmp(direntp->d_name,"..")!=0))
    {
    sprintf(fname[ii],"%s",direntp->d_name);

    tmpsize = 0;
    strcpy(callstr,"wc -c ");
    strcat(callstr,indir);
    strcat(callstr,"/");
    strcat(callstr,fname[ii]);
    strcat(callstr, " > tmpfile");
    system(callstr);
    if ((ptr = fopen("tmpfile","r")) != NULL)
      {
      fscanf(ptr,"%d",&tmpsize);
      fclose(ptr);
      wait(&status);
      }
    totsize += tmpsize;
    unlink("tmpfile");

    ii = ii + 1;
    }
  }
closedir (dirp);

/* Write  parameters required back to TAE
-----------------------------------------------*/
status = q_intg(&vblk,"TOTSIZE",one,&totsize,P_UPDATE);
q_out(&vblk);

strcpy(progname,"totdirsz");
c_complt(progname,outlist,&zero);
}

