/******************************************************************************
FUNCTION:	GETPAR

PURPOSE:	Get the input parameters

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
  1.0      02/99    D.Lloyd		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Run under TAE

PROJECT:        ADAPS

ALGORITHM REFERENCES:   NONE

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "tovsin.h"


int getpar
(
    struct PARBLK *vblock,/* Input parameter block			*/
    char    *infile,	/* Input file name				*/
    char    *outfile	/* Output file name				*/
)

{
long	access;		/* file	access 					*/
long	status;		/* function return status			*/
long	zero = 0;	/* constant of zero				*/


/* Get the input file name and make sure it exists
--------------------------------------------------*/
access = IREAD;
status = c_getnam( vblock, "INFILE", &zero, infile, "bin", &access );
if (status != E_SUCC)
    return E_FAIL;


/* Get the output file name and make sure it doesn't exist
----------------------------------------------------------*/
access = IWRITE;
status = c_getnam( vblock, "OUTFILE", &zero, outfile, "trn", &access );
if (status != E_SUCC)
    return E_FAIL;


return E_SUCC;
}
