/****************************************************************************

FUNCTION:	PROCESS_VBN

PURPOSE:	Copy the file data in a virtual block record to the data
		file on disk.  If a more sophisticated format of VMS
		BACKUP tape is recieved and record types other then
		fixed-length are used, this will need to be enhanced.

ALGORITHM REFERENCES:

****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "readcpa.h"

int process_vbn
(
    unsigned char *ptr,	/* Pointer to the buffer where data resides	*/
    char *filename,	/* Name of file to create/update on disk	*/
    int16 recsize	/* Size of the record data within the VBN	*/
)
{
    FILE *ofp;		/* File entity to create and/or update		*/

    /* Open the specified output file.
       -------------------------------*/
    ofp = fopen(filename, "ab");
    if (!ofp)
	{
	close_tape();
	c_lasmsg(TRUE, "readcpa-diskwrite", "Error writing output file %s",
		 filename);
	}

    /* Write the data to the output file.  Currently, this is trivial, 
       but if a more complex form of VBN is encountered, this will
       need to be changed.
       --------------------------------------------------------------*/
    if (fwrite(ptr, 1, recsize, ofp) != recsize)
	{
        close_tape();
	c_lasmsg(TRUE, "readcpa-diskwrite", "Error writing output file %s",
		 filename);

	}

    fclose(ofp);
    return 0;
}
