/*****************************************************************************
FUNCTION:	GET_HDR

PURPOSE:	This procedure checks the current 512 record for a good
		header and returns the results.

Version  Date	Programmer	Modifications
-------  -----	---------------	---------------------------------------------
  1.0    06/97	R.Dilley	Initial development
  2.0	 05/98	D.Lloyd		Modifications for LAS coding standard

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under TAE

PROJECT:	ADAPS
*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "tarex.h"



enum stats get_hdr
(
char	tar_buffer[RECORDS][RECORD_SIZE],	/* current tar buffer	*/
long	*cur_rec,		/* current record			*/
long	*size			/* size of valid file			*/
)

{
long	i;			/* loop control variable		*/
long	status;			/* function return status		*/
union	record	*rcd;		/* tar record union			*/


for ( i = *cur_rec; i < RECORDS; i++ )
    {
    rcd = (union record *) &tar_buffer[i][0];
    sscanf( rcd->header.size, "%o", size );
    *cur_rec = i;
    if ( *size > 0 )
        {
	status = check_sum( rcd );
	if ( status == HEADER_SUCCESS )
	    return HEADER_SUCCESS;
	}
    }

return HEADER_FAILURE;
}
