/*****************************************************************************
FUNCTION:	WRT_BUF

PURPOSE:	Write tar records to output file from tar buffer.

Version  Date	Programmer	Modifications
-------  -----	---------------	---------------------------------------------
  1.0    06/97	R.Dilley	Initial development
  2.0	 05/98	D.Lloyd		Mods for LAS coding standards

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under TAE

PROJECT:	ADAPS
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "tarex.h"



int wrt_buf 
(
FILE	*ouf,		/* output file descriptor			*/
char	*tar_buf,	/* tar buffer					*/
long	cur_rec,	/* first record to write			*/
long	records,	/* number of records to write			*/
long	extra_bytes	/* number of bytes to write from last record	*/
)

{
long	fresult;	/* return status from fread()			*/
long	out_bytes;	/* number of bytes to write			*/
long	start_pos;	/* starting position in output buffer		*/

out_bytes = ( records - 1 ) * RECORD_SIZE + extra_bytes;
start_pos = cur_rec * RECORD_SIZE;
fresult = (long)fwrite( &tar_buf[start_pos], 1, out_bytes, ouf );
if ( fresult < out_bytes )
    return E_FAIL;
return E_SUCC;
}
