/*****************************************************************************
NAME:		SORTSCAN 

PURPOSE:	Sort the scan file 

******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "desc.h"

FUNCTION sortscan(vblock)

struct PARBLK *vblock;		/* TAE parameter block			*/
{
extern char tfiles[3][CMLEN];	/* output temporary host file names	*/
extern long numout;		/* number of temp host files		*/

long non_fatal = 1;		/* for nonfatal error messages  */
long result;			/* result of system sorts	*/

char command[CMLEN];		/* command string for unix system sort */ 
char datapath[CMLEN];		/* user defined data path		*/
char *getenv();

/*
  Create the output file name
*/
sprintf(tfiles[numout],"wdb2ras_sort_%d.txt",getpid());
numout++;

c_errmsg("Sorting the scan file"," ",&non_fatal);

/*
  Sort the scan file.  This file will be sorted based on the line number,
  priority, starting and ending pixel location 
*/
if (getenv("DATAPATH") != NULL)
   {
   find_path(datapath);	/* find the best path from DATAPATH */
   sprintf(command,"sort -n %s -o %s -T %s",
	tfiles[numout-2],tfiles[numout-1],datapath);
   }
else
   sprintf(command,"sort -n %s -o %s",
	tfiles[numout-2],tfiles[numout-1]);

result = system(command);
if (result != E_SUCC)
   {
   c_errmsg("System file sort failed","wdb2ras-system",&non_fatal);
   c_clean(vblock,"wdb2ras",tfiles,&numout); 
   }

/*
  Delete the unsorted scan file
*/
c_delfil(tfiles[numout-2]);
strcpy(tfiles[numout-2],tfiles[numout-1]);
numout--;

return;
}
