/*******************************************************************************

FUNCTION:	CLEAN_UP

PURPOSE:	A fatal error was encountered, so clean up everything and
		terminate execution.

Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  1.0    11/97  T.Baltzer        Development


PROJECT:	ADAPS
*******************************************************************************/
#include "las.h"
#include "tapeio.h"
#include "diskio.h"
#include "util.h"
#include "localprotos.h"

void clean_up
(
struct PARBLK *vblock,	/* Variable block			*/
FILE *in_fd,		/* File descriptor to input image	*/
FILE *out_fd,		/* File descriptor to output image	*/
long tape,		/* Tape file flag  (T = open F = closed)*/
long tun,		/* Tape unit number			*/
const char outnam[2][CMLEN],	/* Output files needed to be cleaned up */
long outcnt		/* Output file count			*/
)
{
long mode = HANDLE;		/* Tape I/O handles errors		*/
long rewopt = REWOFFL;		/* Rewind off line option		*/
long eofopt = 1;		/* Number of output tape marks		*/

/*
  Close the tape
*/
if (tape)
    c_tpclos(&tun,&mode,&rewopt,&eofopt);

/*
  Close the output image files
*/
if ( out_fd )
    fclose(out_fd);


/*
  Close the input image file
*/
if ( in_fd )
    fclose(in_fd);


/*
  Free the reserved space on the disk
*/
c_dkfree(outnam[0]);

/*
  Clean up any files, print fatal error, don't return execution
*/
c_clean(vblock,"window1b",outnam,&outcnt);
}
