/****************************************************************************
NAME:		WRTASCII

PURPOSE:	Write a line buffer out to the specified file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    12/93	Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
*****************************************************************************/
#include <stdio.h>
#include <time.h>
#include "worgen.h"

main(argc,argv)

int argc;                       /* number of arguments                  */
char *argv[];                   /* argument: directory to check         */

{
FILE	*fp;			/* file pointer to the file		*/

long	nonfatal = 1,		/* nonfatal error code			*/
	fatal = -1,		/* fatal error code			*/
	status;			/* return status variable		*/

char	filename[CMLEN],	/* file name				*/
	buffer[CMLEN];		/* file message				*/


/*
  Check for sufficient arguments
*/
if (argc < 3)
    {
    c_errmsg("wrtascii <filename> <text>","wrtascii-usage",&nonfatal);
    c_errmsg("Fatal error encountered","wrtascii-fatal",&fatal);
    }

/*
  Set up file name
  user must specify LAS-format path and root name
*/
c_cmhost(argv[1],filename);

/*
  Set up the buffer
*/
buffer[0] = '\0';
strcat(buffer,argv[2]);
strcat(buffer,"\n");

/*
  Write out to the file
*/
status = wrtbuf(filename,buffer);
if (status != E_SUCC)
    c_errmsg("Fatal error encountered","wrtascii-fatal",&fatal);

exit(0);
}
