/****************************************************************************
NAME:		WRITE_LOG

PURPOSE:	Write a record out to the specified log file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 D. Hollaren   06/87	Original Development
  5.0	 D. Hollaren   04/92	Conversion to LAS5.0
  5.1    J. Fenno      11/92    Moved the write_log executable from ADAPSBIN to
                                wherever wrtlog is released.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
*****************************************************************************/
#include <stdio.h>
#include <time.h>
#include "worgen.h"

main(argc,argv)

int argc;                       /* number of arguments                  */
char *argv[];                   /* argument: directory to check         */

{
FILE	*fp;			/* file pointer to the log file		*/

long	nonfatal = 1,		/* nonfatal error code			*/
	fatal = -1,		/* fatal error code			*/
	i,			/* loop counter				*/
	status;			/* return status variable		*/

char	logfile[CMLEN],		/* log file name			*/
	message[CMLEN];		/* log file message			*/


/*
  Check for sufficient arguments
*/
if (argc < 5)
    c_lasmsg(TRUE, "wrtlog-usage", "write_log <logfile> <key> <code> <text>");

/*
  Set up log file name
  user must specify LAS-format path and root name; we add .log extension
*/
c_cmhost(argv[1],logfile);
strcat(logfile,".log");

/*
  Set up the message
  calling this from a PDF makes each word in the message 
  a separate argument so we must string them together
*/
message[0] = '\0';
for (i = 4; i < argc; i++)
    {
    strcat(message,argv[i]);
    strcat(message," ");
    }

/*
  Write out to the log file
*/
status = c_wrtlog(logfile,argv[2],argv[3],message);
if (status != E_SUCC)
    c_lasmsg(TRUE, "wrtlog-fatal", "Fatal error encountered");

exit(0);
}
