#include <stdio.h>

#define GEO 0
#define NORTH 1
#define SOUTH -1

void ps_border(fd,projflg,dlat,dlong,scale,mid_x,mid_y)

FILE 	*fd;
long 	projflg,
     	mid_x,
	mid_y;
long	dlat,dlong;
float 	scale;
{	
long x,y;

/*
  Save the current (unclipped) graphics state
*/
fprintf(fd,"gsave\n");

/*
  First the border is drawn (stroke),
  then it is clipped (clip)
*/
if (projflg != GEO)	/* draw a circular (polar) border */
    {
    /*
      scale is the radius of the circle
    */
    fprintf(fd,"%d %d %3.1f 0 360 arc\n",mid_x,mid_y,scale);
    fprintf(fd,"closepath\n");
    fprintf(fd,"stroke\n");
    fprintf(fd,"%d %d %3.1f 0 360 arc\n",mid_x,mid_y,scale);
    fprintf(fd,"closepath\n");
    fprintf(fd,"clip\n");
    }
else 	/* draw a rectangular border */
    {
    /*
      Move to the upper left corner of the box
    */
    x = mid_x - (scale * dlong / 2); y = mid_y + (scale * dlat / 2);
    fprintf(fd,"%d %d moveto\n",x,y);
    x = dlong * scale;
    fprintf(fd,"%d 0 rlineto\n",x);
    y = -dlat * scale;
    fprintf(fd,"0 %d rlineto\n",y);
    x = -dlong * scale;
    fprintf(fd,"%d 0 rlineto\n",x);
    y = dlat * scale;
    fprintf(fd,"0 %d rlineto\n",y);
    fprintf(fd,"closepath\n");
    fprintf(fd,"stroke\n");
    x = mid_x - (scale * dlong / 2); y = mid_y + (scale * dlat / 2);
    fprintf(fd,"%d %d moveto\n",x,y);
    x = dlong * scale;
    fprintf(fd,"%d 0 rlineto\n",x);
    y = -dlat * scale;
    fprintf(fd,"0 %d rlineto\n",y);
    x = -dlong * scale;
    fprintf(fd,"%d 0 rlineto\n",x);
    y = dlat * scale;
    fprintf(fd,"0 %d rlineto\n",y);
    fprintf(fd,"closepath\n");
    fprintf(fd,"clip\n");
    }

}
