#include <stdio.h>
#include <math.h>
#include "adaps.h"
#define GEO 0
#define NORTH 1
#define SOUTH -1

void ps_circle(fd,projcode,scale,mid_x,mid_y,
		northlat,southlat,westlong,eastlong,crossflg)

FILE	*fd;

float	scale;

long	projcode,
	mid_x,mid_y,
	northlat,southlat,westlong,eastlong,
	crossflg;
{	
double  thislat,
        thislng;
double  rsat = 6378.0+870.0;            /* REQUA + SAT_ALTITUDE * 1000 */
double  re = 6378.0;                    /* REQUA */
double  ran;
double  phi;
double  deltalong;
double  angle;
double temp1,temp2;
long	temp;
long    midlat,
        midlong;
long	x1,x2,y1,y2;
long	i;

/*
  Only draw the circle on normal passes
*/
if (projcode != GEO)
    return;

/* 2-degree circle */
ran = PIE - (92*RAD_PER_DEG + asin(sin(92*RAD_PER_DEG)*re/rsat));
thislat = 43.74 * RAD_PER_DEG;
thislng = -96.63 * RAD_PER_DEG;

midlat = (northlat + southlat) / 2;

/*if (((eastlong - westlong) > 180) && ((eastlong - westlong) != 360))*/
if (crossflg)
    { /* cross I.D.L.; flip west & east */
    temp = eastlong;
    /* eastlong = 360 + westlong; */
    eastlong = westlong;
    westlong = temp;
    thislng = (-96.63 + 360.0) * RAD_PER_DEG;
    }
midlong = (eastlong + westlong) / 2;

/*
  Draw a circle around the target
*/
angle = 0.0;
phi = acos(sin(thislat) * cos(ran) + cos(thislat) * sin(ran) * cos(angle));
deltalong = asin(sin(ran) * sin(angle) / sin(phi));
x1 = mid_x + ((thislng+deltalong)*DEG_PER_RAD - midlong) * scale;
y1 = mid_y + ((PIE/2.0 - phi)*DEG_PER_RAD - midlat) * scale;
fprintf(fd,"1 setlinewidth\n");
fprintf(fd,"%d %d moveto\n",x1,y1);

for (i = 1; i <= 180; i++)
    {
    angle = i * RAD_PER_DEG * 2.0;
    phi = acos(sin(thislat) * cos(ran) + cos(thislat) * sin(ran) * cos(angle)); 
    deltalong = asin(sin(ran) * sin(angle) / sin(phi));
    x2 = mid_x + ((thislng+deltalong)*DEG_PER_RAD - midlong) * scale;
    y2 = mid_y + ((PIE/2.0 - phi)*DEG_PER_RAD - midlat) * scale;
    fprintf(fd,"%d %d lineto\n",x2,y2);
    }

fprintf(fd,"stroke\n");
fprintf(fd,"0.1 setlinewidth\n");

}
