#include <stdio.h>
#include "adaps.h"

#define GEO 0
#define NORTH 1
#define SOUTH -1

void ps_header(fd,projcode,scale,mid_x,mid_y,dlat,dlong,satid,orbit,dayn,
		sjday,smonth,sday,syear,shour,smin,ssec,
		ejday,emonth,eday,eyear,ehour,emin,esec,eqxing)
FILE *fd;
float	scale;
long	projcode;
long	mid_x,mid_y,dlat,dlong;
long	satid,
	orbit,
	dayn,
	sjday,
	smonth, sday, syear,
	shour, smin, ssec,
	ejday,
	emonth, eday, eyear,
	ehour, emin, esec;
double	eqxing;
{	
long	x,y;

/* landscape mode */
fprintf(fd,"-90 rotate\n");
fprintf(fd,"-792 0 translate\n");

/* set up font */
fprintf(fd,"/Times-Roman findfont\n");
fprintf(fd,"10 scalefont\n");
fprintf(fd,"setfont\n");

/* move to just above the border */
if (projcode == GEO)
    {
    x = mid_x - (scale * dlong / 2);
    y = mid_y + (scale * dlat / 2);
    }
else
    {
    /* scale is the radius of the circle */
    x = mid_x - scale;
    y = mid_y + scale;
    }
fprintf(fd,"%d %d moveto\n",x,y+14);
fprintf(fd,"(EROS Data Center) show\n");

fprintf(fd,"%d %d moveto\n",x+150,y+14);
fprintf(fd,"(Orbit: %05d) show\n",orbit);

fprintf(fd,"%d %d moveto\n",x+250,y+14);
if (dayn == DAY)
    fprintf(fd,"(DAY) show\n");
else
    fprintf(fd,"(NIGHT) show\n");

fprintf(fd,"%d %d moveto\n",x+300,y+14);
fprintf(fd,"(Start time: %03d %02d/%02d/%02d   %02d:%02d:%02d) show\n",
  sjday,smonth,sday,syear,shour,smin,ssec);



fprintf(fd,"%d %d moveto\n",x,y+2);
fprintf(fd,"( AVHRR/NOAA-%02d) show\n",satid);

fprintf(fd,"%d %d moveto\n",x+150,y+2);
fprintf(fd,"(EqCr: %06.2lf) show\n",eqxing*DEG_PER_RAD);

fprintf(fd,"%d %d moveto\n",x+300,y+2);
fprintf(fd,"(Stop time:  %03d %02d/%02d/%02d   %02d:%02d:%02d) show\n",
  ejday,emonth,eday,eyear,ehour,emin,esec);

fprintf(fd,"stroke\n");

/*
  Set up for thin lines
*/
fprintf(fd,"0.1 setlinewidth\n");
}
