#include <stdio.h>
#include <math.h>
#include "adaps.h"
#define GEO 0
#define NORTH 1
#define SOUTH -1

void ps_latlong(fd,projcode,scale,mid_x,mid_y,dlat,dlong,northlat,southlat,
		westlong,eastlong,crossflg)

FILE *fd;

float 	scale;

long	projcode,
	mid_x,mid_y,
	dlat,dlong,
	northlat,southlat,
	westlong,eastlong,
	crossflg;
{	
long 	i;		/* looping variable 	*/
long	midlat,
	midlong,
	temp;
long 	x1,x2,
	y1,y2;
double	lat,
	lng1,lng2;

/* 
  Set up dashed line
*/
fprintf(fd,"[2 2] 0 setdash\n");

midlat = (northlat + southlat) / 2;
/* if (((eastlong - westlong) > 180) && ((eastlong - westlong) != 360)) */
if (crossflg)
    { /* cross I.D.L.; flip west & east */
    temp = eastlong;
    /* eastlong = 360 + westlong; */
    eastlong = westlong;
    westlong = temp;
    }
midlong = (eastlong + westlong) / 2;

if (projcode != GEO)
    {
    /* 
      Go around half the circle, drawing radii as 
      longitude from equator to equator  (lat 0.0)
	x1 = scale * (cos(lat) * sin(lng)) + mid_x;
	y1 = scale * (sin(HALFPIE) * cos(lat) * cos(lng)) + mid_y;
    */
    for (i = 0; i < 180; i += 10)
	{
	lng1 = i * RAD_PER_DEG;
	x1 = scale * sin(lng1) + mid_x;
	y1 = scale * sin(HALFPIE) * cos(lng1) + mid_y;
	lng2 = (180 + i) * RAD_PER_DEG;
	x2 = scale * sin(lng2) + mid_x;
	y2 = scale * sin(HALFPIE) * cos(lng2) + mid_y;
	fprintf(fd,"%d %d moveto\n",x1,y1);
	fprintf(fd,"%d %d lineto\n",x2,y2);
	fprintf(fd,"stroke\n");
	}

    /*
      Draw concentric circles at the center for latitude
    */
    x1 = scale * cos(HALFPIE) * sin(HALFPIE) + mid_x;
    if (projcode == NORTH)
	{
    	for (i = 0; i < 90; i+= 10)
	    {
	    lat = i * RAD_PER_DEG;
    	    x2 = scale * cos(lat) * sin(HALFPIE) + mid_x;
    	    fprintf(fd,"%d %d %d 0 360 arc\n",mid_x,mid_y,x2-x1);
	    fprintf(fd,"stroke\n");
	    }
	}
    else
	{
    	for (i = -10; i > -90; i-= 10)
	    {
	    lat = i * RAD_PER_DEG;
    	    x2 = scale * cos(lat) * sin(HALFPIE) + mid_x;
    	    fprintf(fd,"%d %d %d 0 360 arc\n",mid_x,mid_y,x2-x1);
	    }
	}
    }
else
    {
    /*
      Draw latitude lines
    */
    x1 = mid_x - dlong * scale / 2;
    x2 = mid_x + dlong * scale / 2;

    y1 = mid_y + (southlat - midlat) * scale;
    fprintf(fd,"%d %d moveto\n",x1-20,y1-5);
    fprintf(fd,"(%d) show\n",southlat);

    for (i = southlat+10; i < northlat; i+=10)
    	{
	/*y1 = mid_y - (dlat * scale /2) + ((i - southlat) * scale);*/
	y1 = mid_y + (i - midlat) * scale;
	fprintf(fd,"%d %d moveto\n",x1-20,y1-5);
	fprintf(fd,"(%d) show\n",i);
	fprintf(fd,"%d %d moveto\n",x1,y1);
	fprintf(fd,"%d %d lineto\n",x2,y1);
	fprintf(fd,"stroke\n");
	}

    y1 = mid_y + (northlat - midlat) * scale;
    fprintf(fd,"%d %d moveto\n",x1-20,y1-5);
    fprintf(fd,"(%d) show\n",northlat);

    /*
      Draw longitude lines
    */
    y1 = mid_y - dlat * scale / 2;
    y2 = mid_y + dlat * scale / 2;

    x1 = mid_x + (westlong - midlong) * scale;
    fprintf(fd,"%d %d moveto\n",x1-10,y1-10);
    fprintf(fd,"(%d) show\n",westlong);

    for (i = westlong+10; i < eastlong; i+=10)
    	{
	x1 = mid_x + (i - midlong) * scale;
	fprintf(fd,"%d %d moveto\n",x1-10,y1-10);
	if (i <= 180)
	    fprintf(fd,"(%d) show\n",i);
	else
	    fprintf(fd,"(%d) show\n",i - 360);
	fprintf(fd,"%d %d moveto\n",x1,y1);
	fprintf(fd,"%d %d lineto\n",x1,y2);
	fprintf(fd,"stroke\n");
	}

    x1 = mid_x + (eastlong - midlong) * scale;
    fprintf(fd,"%d %d moveto\n",x1-10,y1-10);
    if (eastlong <= 180)
	fprintf(fd,"(%d) show\n",eastlong);
    else
	fprintf(fd,"(%d) show\n",eastlong - 360);
    }

/*
  Set back to solid line
*/
fprintf(fd,"[] 0 setdash\n");
}
