#include <stdio.h>
#include <math.h>
#include "adaps.h"
#define GEO 0
#define NORTH 1
#define SOUTH -1

void ps_lines(fd,projcode,scale,mid_x,mid_y,northlat,southlat,
		westlong,eastlong,crossflg)
FILE *fd;

float 	scale;

long	projcode,
	mid_x,mid_y,
	northlat,southlat,
	westlong,eastlong,
	crossflg;
{	
FILE 	*fp_rel;	/* file pointer to ".REL" file		             */
FILE 	*fp_seq;	/* file pointer to ".SEQ" file		             */
long	rank[2];	/* indicating the entire file			     */
/*long	crossflg = 0;   /* indicates crossing the Int'l Date Line	     */
long	total_pts;	/* total number of remaining points in the segment   */
long	midlat,midlong;
float   minlat,        	/* minimum latitude of area of interest              */
        minlon,        	/* minimum longitude of area of interest             */
        maxlat,        	/* maximum latitude of area of interest              */
	maxlon;        	/* maximum longitude of area of interest             */
float	pnts[100];	/* points in the line                                */
float	x1, y1;		/* line/sample in line segment     		     */
long	i,		/* looping index				     */
	last_lat,	/* latitude of last point			     */
	last_lng,	/* longitude of last point			     */
	mainstat = 1,	/* status to continue looping			     */
	num_pts,	/* number of points from current segment to process  */
    	pntint = 5,	/* go every 10 points (small area - must have detail)*/
    	pt_num,		/* current point number in the segment		     */
	pts_in_seg,	/* number of points in this segment		     */
	start,		/* starting point				     */
	status;		/* return status variable			     */

fprintf(fd,"0.0 setgray\n");

/*
  Open the WDB files-the support will find the correct WDBII directory
*/
status = c_wdbopen("rboundry",&fp_seq,&fp_rel);
if (status != 0)
    return;

/*
  Set up
crossflg = 0;
*/
rank[0] = 1; 	rank[1] = 0;
maxlat = northlat; 	
minlat = southlat; 	
minlon = westlong-360.0; 	
maxlon = eastlong;
midlat  = (northlat + southlat) / 2;
/* if (((eastlong - westlong) > 180) && ((eastlong - westlong) != 360) &&  */
/* if (crossflg)
    {
    westlong = 360 + westlong;
    crossflg = 1;
    } */
midlong = (eastlong + westlong) / 2;
while (mainstat != 0)
    {
    /*
      Position the ".REL" file pointer to the starting record of the segment
    */
    mainstat = c_wdbseq(fp_seq,rank,crossflg,&minlat,&minlon,&maxlat,&maxlon,
	 &total_pts,fp_rel);
    if (mainstat == 0)
	continue;

    /*
      Save the total number of points in this segment
      and figure out the indices of the last point
    */
    pts_in_seg = total_pts;
    last_lat = ((pts_in_seg - 1) % 50) * 2;
    last_lng = ((pts_in_seg - 1) % 50) * 2 + 1;

    /*
      Read the points to be processed (Maximum of 50 at a time).
    */
    status = c_wdbrel(fp_rel,&total_pts,&num_pts,pnts);
    if (status == -1)
        return;

    /*
      Calculate the y/x for the starting point of the line segment
    */
    if (projcode != GEO)
        {
        y1 = -scale * sin(HALFPIE) * cos(pnts[0]*RAD_PER_DEG) * 
	     cos(pnts[1]*RAD_PER_DEG) + mid_y;
        x1 = projcode * scale * (cos(pnts[0]*RAD_PER_DEG) * 
	     sin(pnts[1]*RAD_PER_DEG)) + mid_x;
        }
    else
        {
	if ((crossflg) && (pnts[1] < 0.0)) pnts[1] += 360.0;
        y1 = (pnts[0] - (float)midlat) * scale + (float)mid_y;
        x1 = (pnts[1] - (float)midlong) * scale + (float)mid_x;
        }
    fprintf(fd,"%4.1f %4.1f moveto\n",x1,y1);

    /*
      Set the start to indicate the start of a new line segment
    */
    start = 2 * pntint;
    pt_num = 1;

    /*
      Process all the points of the line segment
    */
    while (status != -2)
        {
        /*
          Process the points of the line segments
        */
        for (i = start; i < (num_pts * 2); i += 2*pntint, pt_num += pntint)
            {
            /*
	      Convert the latitude/longitude of this segment's endpoint to a y/x
	    */
    	    if (projcode != GEO)
                {
        	y1 = -scale * (sin(HALFPIE) * cos(pnts[i]*RAD_PER_DEG) * 
	     	    cos(pnts[i+1]*RAD_PER_DEG)) + mid_y;
        	x1 = projcode * scale * (cos(pnts[i]*RAD_PER_DEG) * 
		    sin(pnts[i+1]*RAD_PER_DEG)) + mid_x;
                }
            else
                {
		if ((crossflg) && (pnts[i+1] < 0.0))  pnts[i+1] += 360.0;
    	        y1 = (pnts[i] - (float)midlat) * scale + (float)mid_y;
    	        x1 = (pnts[i+1] - (float)midlong) * scale + (float)mid_x;
	        }
    	    fprintf(fd,"%4.1f %4.1f lineto\n",x1,y1);
	    }

        /*
          Read the next set of  points
        */
        status = c_wdbrel(fp_rel,&total_pts,&num_pts,pnts);
        if (status == -1)
	    return;

        /*
          Reset start to indicate continuation of the segment into the next set
        */
        start = 0;
        }

    /*
      Find out if we still need to process the last point
    */
    if (pt_num < pts_in_seg)
        {
        /*
          Convert the latitude/longitude of the last point to a y/x
        */
    	if (projcode != GEO)
            {
            y1 = -scale * (sin(HALFPIE) * cos(pnts[last_lat]*RAD_PER_DEG) * 
	     	    cos(pnts[last_lng]*RAD_PER_DEG)) + mid_y;
            x1 = projcode * scale * (cos(pnts[last_lat]*RAD_PER_DEG) * 
		    sin(pnts[last_lng]*RAD_PER_DEG)) + mid_x;
            }
        else
            {
	    if ((crossflg) && (pnts[last_lng] < 0.0)) pnts[last_lng] += 360.0;
    	    y1 = (pnts[last_lat] - (float)midlat) * scale + (float)mid_y;
    	    x1 = (pnts[last_lng] - (float)midlong) * scale + (float)mid_x;
	    }
    	fprintf(fd,"%4.1f %4.1f lineto\n",x1,y1);
        }

    /*
      Draw the line
    */
    fprintf(fd,"stroke\n");
    }

/*
  Close the WDB files
*/
c_wdbclose(fp_seq,fp_rel);
}
