/******************************************************************************
FUNCTION:	CHECKDAY

PURPOSE:	Validate the date entered by the user

PROGRAM HISTORY:
Version    Date     Author      Change Request
-------    -----    ---------   --------------
1.0        4/87     Hollaren
2.0        6/89     LaVergne    
5.0        10/92    T.Rockvam   Updated to LAS 5.0
                                moved from a PDF proc to a C function
5.1	   07/98    D.Lloyd	Modified for Y2K compliance
*******************************************************************************/
#include <stdio.h>

int checkday(date)

long	date[];			/* date (month, day, year)		*/
{
static long days[12] =  {31,28,31,30,31,30,31,31,30,31,30,31};
static long ldays[12] = {31,29,31,30,31,30,31,31,30,31,30,31};

/*
  Check to make sure the month is valid
*/
if ((date[0] < 1) || (date[0] > 12))
    return(-1);

/*
  Check to make sure the year is valid
*/
/*
  DLLOYD Y2K -- and make it 2-digits
-------------------------------------*/
if ( c_4digityr( date[2] ) < 1986 )
    return(-1);
date[2] %= 100;

/*
  Check to make sure the day is valid
*/
if (c_isleap(&date[2]))
    {
    if ((date[1] < 1) || (date[1] > ldays[date[0]-1]))
        return(-1);
    }
else
    {
    if ((date[1] < 1) || (date[1] > days[date[0]-1]))
        return(-1);
    }

return(0);
}
