/******************************************************************************
FUNCTION:	callb_edit

PURPOSE:	callbacks for user data entry editing
		check_date:	allow only [0-9] and '/'
		check_time:	allow only [0-9] and ':'
		check_mins:	allow only [0-9]

PROGRAM HISTORY:
Version Date    Author		Change Request
------- -----   ---------	--------------
1.0	01/93	T.Rockvam	Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
 Must be run on a system that supports the X Windows environment

PROJECT		ADAPS
*******************************************************************************/
#include "xplot.h"

void check_date(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{	
long 	i;

/*
  Modify Verify callback for a date XmText field. Only allows 
  numbers and '/' to be entered. Rings bell and disallows entry otherwise.
*/
XmTextVerifyCallbackStruct *theVerifyCB;
XmTextBlock textBlock; 			/* the text to be inserted */

theVerifyCB = (XmTextVerifyCallbackStruct *) call;
textBlock = theVerifyCB->text;

for (i=0;i<textBlock->length;i++)
    if (((textBlock->ptr[i] < '0') || (textBlock->ptr[i] > '9')) && 
	 (textBlock->ptr[i] != '/') && (textBlock->ptr[i] != ' '))
	{
	theVerifyCB->doit = False;
	}
}

void check_time(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{	
long 	i;

/*
  Modify Verify callback for a time XmText field. Only allows 
  numbers and ':' to be entered. Rings bell and disallows entry otherwise.
*/
XmTextVerifyCallbackStruct *theVerifyCB;
XmTextBlock textBlock; 			/* the text to be inserted */

theVerifyCB = (XmTextVerifyCallbackStruct *) call;
textBlock = theVerifyCB->text;

for (i=0; i<textBlock->length; i++)
    {
    if (((textBlock->ptr[i] < '0') || (textBlock->ptr[i] > '9')) && 
	 (textBlock->ptr[i] != ':') && (textBlock->ptr[i] != ' '))
	{
	theVerifyCB->doit = False;
	}
    }
}

void check_mins(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{	
/*
  Modify Verify callback for number of minutes XmText field. Only allows 
  numbers to be entered. Rings bell and disallows entry otherwise.
*/
long 	i;
XmTextVerifyCallbackStruct *theVerifyCB;
XmTextBlock textBlock; 			/* the text to be inserted */

theVerifyCB = (XmTextVerifyCallbackStruct *) call;
textBlock = theVerifyCB->text;

for (i=0; i<textBlock->length; i++)
    {
    if (((textBlock->ptr[i] < '0') || (textBlock->ptr[i] > '9')) &&
	(textBlock->ptr[i] != '-'))
	{
	theVerifyCB->doit = False;
	}
    }
}
