/***************************************************************************

AH18100507173509 N18 686684109 686684739 686684109 686684739 1 P 99 . E HRPT
12244

***************************************************************************/
#include <stdio.h>
#include <string.h>

#define DELTA 60  /* One minute */
#define SHORT 420 /* Seven minutes */
#define LONG  780 /* Thirteen minutes */

int main( int argc, char *argv[] )
{
    char curr_buf[150];
    char prev_buf[150];
    long curr_start, curr_end;
    long prev_start, prev_end;
    int  prev_id, curr_id;
    int  priority = 17;
    int  conflict = 0;
    FILE *inf;
    FILE *ouf;
    char sid[18];

    if ( argc != 3 )
    {
        printf( "\nUsage: %s <input file> <output file>\n\n", argv[0] );
        return 1;
    }

    inf = fopen( argv[1], "r" );
    ouf = fopen( argv[2], "w" );
    if ( !inf || !ouf )
    {
        printf( "\nUnable to open input or output file\n\n" );
        return 1;
    }

    fgets( prev_buf, 150, inf );
    while ( fgets( curr_buf, 150, inf ) != NULL )
    {
        /* Extract the start and end times from the two buffers */
        sscanf( prev_buf, "%s %*s %ld %ld", sid, &prev_start, &prev_end );
        if ( strncmp( sid, "AH19", 4 ) == 0 )
            prev_id = priority;
        else
            prev_id = 0;
        sscanf( curr_buf, "%*s %*s %ld %ld", &curr_start, &curr_end );

        /* Assuming the input file is sorted */
        /* If the previous ID is a priority -- non-issue */
        if ( prev_id == priority )
            ; /* no op */
        else
        {
            /* See if it's a conflict */
            if ( prev_end + DELTA > curr_start )
            {
                /* Make it non-EROS */
                prev_buf[70] = 'W';
                conflict++;
            }
        }

        /* If there is overlap or the end of the previous is within
        the DELTA see if there is anything we can do to keep both */
        if ( prev_end + DELTA > curr_start )
        {
            int  adjust_curr = 0;
            int  adjust_prev = 0;
            long priority_dur;
            long non_pri_dir;
            /* Determine the actual difference */
            long diff = prev_end - curr_start;

            /* Find the duration of the passes */
            if ( prev_id == priority )
            {
                priority_dur = prev_end - prev_start;
                non_pri_dir = curr_end - curr_start;
            }
            else
            {
                non_pri_dir = prev_end - prev_start;
                priority_dur = curr_end - curr_start;
            }

            /* If the difference is positive or zero there is actual overlap
            if negative they are within the DELTA but not overlapping */
            if ( diff >= 0 )
            {
                /* For small differences adjust the start or end time
                of the non-priority pass, unless that pass is short */
                if ( diff <= DELTA && non_pri_dir > SHORT )
                {
                    if ( prev_id == priority )
                    {
                        /* Adjust start time */
                        curr_start += 2 * DELTA;
                        adjust_curr = 1;
                    }
                    else
                    {
                        prev_end -= 2 * DELTA;
                        adjust_prev = 1;
                    }
                }
                /* If the difference is small and the priority pass is
                long, adjust the start or end time of the priority pass */
                else if ( diff <= DELTA && priority_dur > LONG )
                {
                    if ( prev_id == priority )
                    {
                        prev_end -= 2 * DELTA;
                        adjust_prev = 1;
                    }
                    else
                    {
                        curr_start += 2 * DELTA;
                        adjust_curr = 1;
                    }
                }
                /* Otherwise set the non-priority pass as non-EROS */
                else
                {
                    if ( prev_id == 0 )
                    {
                        prev_buf[70] = 'W';
                        conflict++;
                    }
                    else
                    {
                        curr_buf[70] = 'W';
                        conflict++;
                    }
                        
                }
                        
            }
            else
            {
            }

        }  /* END if prev_end ... */

        /* Write the previous buffer out */
        fprintf( ouf, "%s", prev_buf );

        /* Copy current buffer to previous */
        strcpy( prev_buf, curr_buf );


    }  /* END while */

    /* Last buffer needs to be output */
    fprintf( ouf, "%s", curr_buf );

    if ( conflict )
        printf( "Found %d conflicts\n", conflict );

    fclose( inf );
    fclose( ouf );

    return 0;
}  /* END main */
