/******************************************************************************
FUNCTION:	conv_pts

PURPOSE:	convert lat/long points to projection coordinates

PROGRAM HISTORY:
Version    Date     Author	Change Request
-------    -----    ---------	--------------
 5.0	   12/92    T.Rockvam   Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT		ADAPS XPlot

ALGORITHM REFERENCES
    Map Projections--A Working Manual  by John P. Snyder
*******************************************************************************/
#include <math.h>
#include "adaps.h"

void conv_pts(scale,mid_x,mid_y,lat,lng,proj_x,proj_y)

float 	scale,			/* scale of the drawing area 	*/
	mid_x,			/* middle of width of drawing area */
	mid_y;			/* middle of width of drawing area */
double	lat,			/* input latitude (radians)	*/
	lng;			/* input longitude (radians)    */
int	*proj_x,		/* output projection coord x	*/
	*proj_y;		/* output projection coord y	*/
{
/* Miller cylindrical */
/* *proj_x = (int)(scale * lng + mid_x);*/
/* *proj_y = (int)(-scale * log(tan(PIE/4.0 + 0.4 * lat)) / 0.8 + mid_y);*/
/* -----------------------------------------------------------------------*/

/* Mercator */
/* if (lat == HALFPIE) */
/*    lat -= 0.1; */
/* else if (lat == -HALFPIE) */
/*    lat += 0.1; */
/* *proj_x = (int)(scale * lng + mid_x); */
/* *proj_y = (int)(-scale * log(tan(PIE/4.0 + 0.5 * lat)) + mid_y); */
/* -----------------------------------------------------------------------*/

/* Plate Carree */
*proj_x = (int)(lng*DEG_PER_RAD * scale + mid_x);
*proj_y = (int)(-lat*DEG_PER_RAD * scale + mid_y);
/* -----------------------------------------------------------------------*/
}
