#include "xplot.h"

/*
  Global callbacks
*/
extern void call_autogen();
extern void cancel_auto();
extern void check_date();
extern void check_time();

/* misc modules */
extern void update_times();
extern void load_help();

Widget create_autogen_dialog(parent,satellite,numsats)

Widget parent;	/* mainWindow */
long	satellite[],
	numsats;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    XmString	xmstr[5];
  static char return_translation[] = "<Key>Return: activate() next-tab-group()";
    XtTranslations translations;
    char *defSat;
    long i;
    long defaultSat = 0;
    char title[10];

    Widget	autogenForm;
    Widget 	menuShell;
    Widget 	pulldownMenu;
    Widget	autoSatBox;
    Widget	autoSatLabel;
    Widget	autoSatFrame;
    Widget	opModeLabel;
    Widget      maxDistLabel;
    Widget	startLabel;
    Widget	staDateLabel;
    Widget	staTimeLabel;
    Widget	stopLabel;
    Widget	stoDateLabel;
    Widget	stoTimeLabel;
    Widget	minTimeLabel;
    Widget	varTimeLabel;
    Widget	targetLabel;
    Widget	targLatLabel;
    Widget	targLongLabel;
    Widget	autogenTitle;
    Widget	autoTitleSep;
    Widget	autoAcceptButton;
    Widget	autoCancelButton;
    Widget	autoHelpButton;
    Widget	autoBaseSep;
    Widget      autoFnameLabel;
    Widget      autoOptFrame;
    Widget      autoOptBox;
    Widget      temp;

/*
  Set up translations to apply to Text widgets
*/
translations = XtParseTranslationTable(return_translation);

/*
  Create the autogen dialog
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 10); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, 10); argcnt++;
    autogenFrame = XtCreateWidget("autogenFrame", xmFrameWidgetClass,
                parent, args, argcnt);
    retval = autogenFrame;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNautoUnmanage, False); argcnt++;
    autogenForm = XtCreateWidget("autogenForm", xmFormWidgetClass,
		autogenFrame, args, argcnt);
    XtManageChild(autogenForm);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
	"AUTOGEN - Automatic EDC HRPT schedule generation", 
	XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    autogenTitle = XtCreateWidget("autogenTitle", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(autogenTitle);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autogenTitle); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    autoTitleSep = XtCreateWidget("autoTitleSep", xmSeparatorWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(autoTitleSep);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoTitleSep); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 20); argcnt++;
    autoSatFrame = XtCreateWidget("autoSatFrame", xmFrameWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(autoSatFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Target", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoTitleSep); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, autoSatFrame); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    targetLabel = XtCreateWidget("targetLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(targetLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment,XmATTACH_OPPOSITE_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoSatFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, targetLabel); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    targLatText = XtCreateWidget("targLatText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(targLatText);
    XtOverrideTranslations(targLatText,translations);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"lat", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, targLatText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, targLatText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    targLatLabel = XtCreateWidget("targLatLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(targLatLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, targLatText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, targLatText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    targLongText = XtCreateWidget("targLongText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(targLongText);
    XtOverrideTranslations(targLongText,translations);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"long", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, targLongText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, targLongText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    targLongLabel = XtCreateWidget("targLongLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(targLongLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, targLongText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt],XmNrightAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, autoSatFrame); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    staDateText = XtCreateWidget("staDateText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(staDateText);
    XtAddCallback(staDateText, XmNmodifyVerifyCallback, check_date, (caddr_t)0);
    XtOverrideTranslations(staDateText,translations);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, staDateText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, staDateText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    staTimeText = XtCreateWidget("staTimeText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(staTimeText);
    XtOverrideTranslations(staTimeText,translations);
    XtAddCallback(staTimeText,XmNmodifyVerifyCallback, check_time, (caddr_t)0);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Time", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, staTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, staTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    staTimeLabel = XtCreateWidget("staTimeLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(staTimeLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Date", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, staDateText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, staDateText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    staDateLabel = XtCreateWidget("staDateLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(staDateLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Start", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, staDateLabel); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, -5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment,XmATTACH_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, staDateLabel); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    startLabel = XtCreateWidget("startLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(startLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, staDateText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    stoDateText = XtCreateWidget("stoDateText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(stoDateText);
    XtOverrideTranslations(stoDateText,translations);
    XtAddCallback(stoDateText, XmNmodifyVerifyCallback, check_date, (caddr_t)0);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, stoDateText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, stoDateText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    stoTimeText = XtCreateWidget("stoTimeText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(stoTimeText);
    XtOverrideTranslations(stoTimeText,translations);
    XtAddCallback(stoTimeText,XmNmodifyVerifyCallback, check_time, (caddr_t)0);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Date", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, stoDateText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, stoDateText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    stoDateLabel = XtCreateWidget("stoDateLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(stoDateLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Time", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, stoTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, stoTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    stoTimeLabel = XtCreateWidget("stoTimeLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(stoTimeLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Stop", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, stoDateLabel); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, -5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment,XmATTACH_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, stoDateLabel); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    stopLabel = XtCreateWidget("stopLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(stopLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
	"Maximum distance from target", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, staTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    maxDistLabel = XtCreateWidget("maxDistLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(maxDistLabel);

    argcnt = 0;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, maxDistLabel); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, maxDistLabel); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    maxDistText = XtCreateWidget("maxDistText",xmTextWidgetClass, 
		autogenForm,args,argcnt);
    XtManageChild(maxDistText);
    XtOverrideTranslations(maxDistText,translations);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, maxDistText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, maxDistText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    minTimeText = XtCreateWidget("minTimeText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(minTimeText);
    XtOverrideTranslations(minTimeText,translations);
    XtAddCallback(minTimeText,XmNmodifyVerifyCallback, check_time, (caddr_t)0);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Minimum pass duration", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, minTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, minTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    minTimeLabel = XtCreateWidget("minTimeLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(minTimeLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, minTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, minTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 100); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    varTimeText = XtCreateWidget("varTimeText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(varTimeText);
    XtOverrideTranslations(varTimeText,translations);
    XtAddCallback(varTimeText,XmNmodifyVerifyCallback, check_time, (caddr_t)0);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
	"Variance time about target", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, varTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, varTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    varTimeLabel = XtCreateWidget("varTimeLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(varTimeLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, varTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, varTimeText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    opModeText = XtCreateWidget("opModeText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(opModeText);
    XtOverrideTranslations(opModeText,translations);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Operation mode", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, opModeText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, opModeText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    opModeLabel = XtCreateWidget("opModeLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(opModeLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, opModeText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, opModeText); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 220); argcnt++;
    XtSetArg(args[argcnt], XmNeditMode, XmSINGLE_LINE_EDIT); argcnt++;
    autoFnameText = XtCreateWidget("autoFnameText", xmTextWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(autoFnameText);
    XtOverrideTranslations(autoFnameText,translations);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Output file name:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
   XtSetArg(args[argcnt],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, autoFnameText); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, autoFnameText); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    autoFnameLabel = XtCreateWidget("autoFnameLabel", xmLabelWidgetClass,
		autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(autoFnameLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoFnameText); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_POSITION);argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 30); argcnt++;
    autoOptFrame = XtCreateWidget("autoOptFrame", xmFrameWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(autoOptFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, False); argcnt++;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 200); argcnt++;
    autoOptBox = XtCreateWidget("autoOptBox", xmRowColumnWidgetClass,
		autoOptFrame, args, argcnt);
    XtManageChild(autoOptBox);

    /* review scheduled */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    autoRSButton = XtCreateWidget("autoRSButton", xmToggleButtonWidgetClass,
		autoOptBox, args, argcnt);
    XtManageChild(autoRSButton);

    /* review non-scheduled */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 31); argcnt++;
    autoRNButton = XtCreateWidget("autoRNButton", xmToggleButtonWidgetClass,
		autoOptBox, args, argcnt);
    XtManageChild(autoRNButton);

    /* review both */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 59); argcnt++;
    autoRBButton = XtCreateWidget("autoRBButton", xmToggleButtonWidgetClass,
		autoOptBox, args, argcnt);
    XtManageChild(autoRBButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoOptFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    autoBaseSep = XtCreateWidget("autoBaseSep", xmSeparatorWidgetClass,
		autogenForm, args, argcnt);
    XtManageChild(autoBaseSep);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Accept", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoBaseSep); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    autoAcceptButton = XtCreateWidget("autoAcceptButton",
		xmPushButtonWidgetClass, autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(autoAcceptButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Cancel", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoBaseSep); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 43); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    autoCancelButton = XtCreateWidget("autoCancelButton",
		xmPushButtonWidgetClass, autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(autoCancelButton,XmNactivateCallback, cancel_auto,
	(caddr_t)autogenFrame);
    XtManageChild(autoCancelButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Help", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, autoBaseSep); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 76); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    autoHelpButton = XtCreateWidget("autoHelpButton",
		xmPushButtonWidgetClass, autogenForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(autoHelpButton,XmNactivateCallback, load_help,
	(caddr_t)"xautogen.html");
    XtManageChild(autoHelpButton);

/* create the option menu for satellites */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    menuShell = XtCreatePopupShell("menuShell", xmMenuShellWidgetClass,
                autoSatFrame, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    pulldownMenu = XtCreateWidget("pulldownMenu", xmRowColumnWidgetClass,
                menuShell, args, argcnt);

    /*
      labelString is default satellite in resource file
    */
    XtVaGetValues(pulldownMenu,XmNlabelString,&xmstr[0],NULL);
    XmStringGetLtoR(xmstr[0],XmSTRING_DEFAULT_CHARSET,&defSat);
    if (defSat != NULL)
	{
    	sscanf(defSat,"%d",&defaultSat);
    	XtFree(defSat);
	}
    XmStringFree(xmstr[0]);

    for (i = 0; i < numsats; i++)
        {
        sprintf(title,"NOAA-%02d",satellite[i]);
        argcnt = 0;
        XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                title, XmSTRING_DEFAULT_CHARSET))); argcnt++;
        strcat(title,"a");
        temp = XtCreateManagedWidget(title, xmPushButtonWidgetClass,
                pulldownMenu, args, argcnt);
    	XtAddCallback(temp, XmNarmCallback, update_times,(caddr_t)satellite[i]);
        XmStringFree(xmstr[0]);
    	if (satellite[i] == defaultSat)
	    {
	    XtVaSetValues(pulldownMenu,XmNmenuHistory,temp,NULL);
	    update_times(temp,(caddr_t)satellite[i],NULL);
	    }
        }

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Satellite", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldownMenu); argcnt++;
    autoSatBox = XtCreateWidget("autoSatBox", xmRowColumnWidgetClass,
		autoSatFrame, args, argcnt);
    XtManageChild(autoSatBox);

    XtAddCallback(autoAcceptButton,XmNactivateCallback,call_autogen,
	(caddr_t)autoSatBox);

return(retval);
}
