#include "xplot.h"
  
/*
  Global Widget functions
*/
extern Widget create_msg_dialog();
extern Widget create_menu_system();
extern Widget create_info_area();
extern Widget create_main_work_area();
extern Widget create_new_pass_dialog();
extern Widget create_recorder_dialog();
extern Widget create_autogen_dialog();

/*
  Global callbacks
*/
void cancel_help();

/*
 * CALLBACK PROCEDURE DECLARATIONS
 */
/* misc modules */
extern void quit();

/* mainWindow */
Widget create_panels(parent,satellite,numsats)

Widget  parent;		/* MainShell */
long	satellite[],
	numsats;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    XmString	xmstr[5];
    Widget	mainWindow;
    Widget	newPassDialogShell;
    Widget	errorDialogShell;
    Widget      helpDialogShell;
    Widget      recorderDialogShell;
    Widget      autogenDialog;
    Widget	menuBar;
    Widget	mainForm;

/*
  Main window
*/
    XmRegisterConverters();
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    mainWindow = XtCreateWidget("mainWindow", xmMainWindowWidgetClass,
		parent, args, argcnt);
    retval = mainWindow;

/*
  Create Dialog for reporting errors
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "XPlot Error"); argcnt++;
    XtSetArg(args[argcnt], XmNx, 314); argcnt++;
    XtSetArg(args[argcnt], XmNy, 264); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 224); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 111); argcnt++;
    XtSetArg(args[argcnt], XmNminWidth, 220); argcnt++;
    XtSetArg(args[argcnt], XmNminHeight, 110); argcnt++;
    errorDialogShell = XtCreatePopupShell("errorDialogShell",
		xmDialogShellWidgetClass, parent, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNdialogType, XmDIALOG_ERROR); argcnt++;
    XtSetArg(args[argcnt], XmNx, 314); argcnt++;
    XtSetArg(args[argcnt], XmNy, 264); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 224); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 111); argcnt++;
    XtSetArg(args[argcnt], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL); 
	argcnt++;
    errorBox = XtCreateWidget("errorBox", xmMessageBoxWidgetClass,
		errorDialogShell, args, argcnt);
    
    /* un-manage the "Help" and "Cancel" buttons */
    XtUnmanageChild(XmMessageBoxGetChild(errorBox,XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(errorBox,XmDIALOG_CANCEL_BUTTON));

/*
  Set up the main menu bar
*/
    menuBar = create_menu_system(mainWindow);

/*
  Set up the processing message dialog
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "Processing"); argcnt++;
    XtSetArg(args[argcnt], XmNx, 317); argcnt++;
    XtSetArg(args[argcnt], XmNy, 211); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 240); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 110); argcnt++;
    procMsgShell = XtCreatePopupShell("procMsgShell",
                transientShellWidgetClass, parent, args, argcnt);

    procMsgBox = create_msg_dialog(procMsgShell);

/*
  Dialog for creating new passes to schedule
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "New pass"); argcnt++;
    XtSetArg(args[argcnt], XmNminWidth, 400); argcnt++;
    XtSetArg(args[argcnt], XmNminHeight, 190); argcnt++;
    XtSetArg(args[argcnt], XmNx, 373); argcnt++;
    XtSetArg(args[argcnt], XmNy, 197); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 400); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 190); argcnt++;
    newPassDialogShell = XtCreatePopupShell("newPassDialogShell",
                xmDialogShellWidgetClass, parent, args, argcnt);

    newPassFrame = create_new_pass_dialog(newPassDialogShell,satellite,numsats);

/*
  Dialog for automatic recorder scheduling
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "Recorder Schedule"); argcnt++;
    XtSetArg(args[argcnt], XmNx, 100); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 318); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 300); argcnt++;
    XtSetArg(args[argcnt], XmNminWidth, 310); argcnt++;
    XtSetArg(args[argcnt], XmNminHeight, 300); argcnt++;
    recorderDialogShell = XtCreatePopupShell("recorderDialogShell",
                xmDialogShellWidgetClass, parent, args, argcnt);

    recorderFrame=create_recorder_dialog(recorderDialogShell,satellite,numsats);

/*
  Dialog for running autogen
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "Autogen"); argcnt++;
    XtSetArg(args[argcnt], XmNminWidth, 455); argcnt++;
    XtSetArg(args[argcnt], XmNminHeight, 560); argcnt++;
    XtSetArg(args[argcnt], XmNx, 332); argcnt++;
    XtSetArg(args[argcnt], XmNy, 76); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 455); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 560); argcnt++;
    autogenDialog = XtCreatePopupShell("autogenDialog",
                xmDialogShellWidgetClass, parent, args, argcnt);

    autogenFrame=create_autogen_dialog(autogenDialog,satellite,numsats);

/*
  Set up the form for the main working window
*/
    mainForm = create_main_work_area(mainWindow);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_NONE); argcnt++;
    XtSetValues(mainForm, args, argcnt);

    return(retval);
}
