#include "xplot.h"

/*
 * CALLBACK PROCEDURE DECLARATIONS
 */
extern void load_rec_sch();
extern void add_rec_criteria();
extern void modify_rec_criteria();
extern void delete_rec_criteria();

Widget create_criteria_dialog(parent,satellite,numsats,dtypes)	

Widget 	parent;
long    satellite[],
        numsats,
	dtypes;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    XmString	xmstr[5];
    Widget 	retval;
    Widget	criDialogShell;
    Widget	criFrame;
    Widget	criWorkArea;
    Widget	optionFrame;
    Widget	satFrame;
    Widget	satBox;
    Widget	dtypeFrame;
    Widget	dtypeBox;
    Widget	stationFrame;
    Widget	stationBox;
    Widget	dirFrame;
    Widget	dirBox;
    Widget	criAcceptButton;
    Widget	criDoneButton;
    char title[4];
    long i;

/*
  Dialog for recorder criteria
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "Recorder Criteria"); argcnt++;
    XtSetArg(args[argcnt], XmNx, 500); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 318); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 300); argcnt++;
    criDialogShell = XtCreatePopupShell("criDialogShell",
		xmDialogShellWidgetClass, parent, args, argcnt);

/*
  Create area for criteria
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 10); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, 10); argcnt++;
    criFrame = XtCreateWidget("criFrame", 
	xmFrameWidgetClass, criDialogShell, args, argcnt);
    retval = criFrame;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    criWorkArea = XtCreateWidget("criWorkArea", 
	xmFormWidgetClass, criFrame, args, argcnt);
    XtManageChild(criWorkArea);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    optionFrame = XtCreateWidget("optionFrame", xmFrameWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(optionFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlistVisibleItemCount, 3); argcnt++;
    XtSetArg(args[argcnt], XmNokLabelString, (xmstr[0]=XmStringCreateLtoR(
                "Modify", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNcancelLabelString, (xmstr[1]=XmStringCreateLtoR(
                "Delete",    XmSTRING_DEFAULT_CHARSET))); argcnt++;
    optionSelectionBox = XtCreateWidget("optionSelectionBox",
                xmSelectionBoxWidgetClass, optionFrame, args, argcnt);
    XtManageChild(optionSelectionBox);
    XtAddCallback(optionSelectionBox, XmNcancelCallback, delete_rec_criteria, 
	(caddr_t)0);
    XmStringFree(xmstr[0]);
    XmStringFree(xmstr[1]);

    /* un-manage the "Help" button */
    XtUnmanageChild(XmSelectionBoxGetChild(optionSelectionBox,
					   XmDIALOG_HELP_BUTTON));

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, optionFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    satFrame = XtCreateWidget("satFrame", xmFrameWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(satFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 49); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 87); argcnt++;
    satBox = XtCreateWidget("satBox", xmRowColumnWidgetClass, satFrame,
                args, argcnt);
    XtManageChild(satBox);

    /* add the callback for modifying criteria */
    XtAddCallback(optionSelectionBox, XmNokCallback, modify_rec_criteria, 
	(caddr_t)satBox);

    for (i = 0; i < numsats; i++)
	{
        sprintf(title,"N%02d",satellite[i]);
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                title, XmSTRING_DEFAULT_CHARSET))); argcnt++;
        strcat(title,"r");
    	XtCreateManagedWidget(title,xmToggleButtonWidgetClass,
                satBox, args, argcnt);
    	XmStringFree(xmstr[0]);
	}

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, optionFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, satFrame); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    dtypeFrame = XtCreateWidget("dtypeFrame", xmFrameWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(dtypeFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 56); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 87); argcnt++;
    dtypeBox = XtCreateWidget("dtypeBox", xmRowColumnWidgetClass,
                dtypeFrame, args, argcnt);
    XtManageChild(dtypeBox);

    recHRPTButton = NULL;
    recLACButton = NULL;
    recGACButton = NULL;
    if ((dtypes / 100) == 1)            /* HRPT */
	{
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "HRPT", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	recHRPTButton = XtCreateWidget("recHRPTButton", 
	    	xmToggleButtonWidgetClass, dtypeBox, args, argcnt);
    	XmStringFree(xmstr[0]);
    	XtManageChild(recHRPTButton);
	}

    if (((dtypes / 10) % 10) == 1)      /* LAC */
	{
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "LAC", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	recLACButton = XtCreateWidget("recLACButton", xmToggleButtonWidgetClass,
                dtypeBox, args, argcnt);
    	XmStringFree(xmstr[0]);
    	XtManageChild(recLACButton);
	}

    if ((dtypes % 10) == 1)             /* GAC */
	{
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "GAC", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	recGACButton = XtCreateWidget("recGACButton", xmToggleButtonWidgetClass,
                dtypeBox, args, argcnt);
    	XmStringFree(xmstr[0]);
    	XtManageChild(recGACButton);
	}

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, optionFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, dtypeFrame); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    stationFrame = XtCreateWidget("stationFrame", xmFrameWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(stationFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 73); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 59); argcnt++;
    stationBox = XtCreateWidget("stationBox", xmRowColumnWidgetClass,
                stationFrame, args, argcnt);
    XtManageChild(stationBox);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Wallops", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    recWIButton = XtCreateWidget("recWIButton", xmToggleButtonWidgetClass,
                stationBox, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(recWIButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Gilmore", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 31); argcnt++;
    recGCButton = XtCreateWidget("recGCButton", xmToggleButtonWidgetClass,
                stationBox, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(recGCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, optionFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, stationFrame); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    dirFrame = XtCreateWidget("dirFrame", xmFrameWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(dirFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 91); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 59); argcnt++;
    dirBox = XtCreateWidget("dirBox", xmRowColumnWidgetClass,
                dirFrame, args, argcnt);
    XtManageChild(dirBox);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Ascending", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    recASCButton = XtCreateWidget("recASCButton", xmToggleButtonWidgetClass,
                dirBox, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(recASCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Descending", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 31); argcnt++;
    recDESCButton = XtCreateWidget("recDESCButton", xmToggleButtonWidgetClass,
                dirBox, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(recDESCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, stationFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    criAcceptButton =XtCreateWidget("criAcceptButton",xmPushButtonWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(criAcceptButton);

    XtAddCallback(criAcceptButton, XmNactivateCallback, add_rec_criteria, 
		  (caddr_t)satBox);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, criAcceptButton); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 40); argcnt++;
    criDoneButton =XtCreateWidget("criDoneButton",xmPushButtonWidgetClass,
                criWorkArea, args, argcnt);
    XtManageChild(criDoneButton);

    /* send the dtypeBox so we know which dtypes were chosen */
    XtVaSetValues(optionSelectionBox,XmNuserData,(XtPointer)dtypeBox,NULL);
    XtAddCallback(criDoneButton, XmNactivateCallback, load_rec_sch, 
		  (caddr_t)optionSelectionBox);

return(retval);
}
