/*
 * REQUIRED MOTIF INCLUDE FILES
 */
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Form.h>
#include <Xm/Text.h>
#include <Xm/ScrolledW.h>

/*
  Global Widget IDs
*/
extern Widget      helpText;

/*
 * CALLBACK PROCEDURE DECLARATIONS
 */
extern void load_help();
extern void cancel_help();

/* autogenForm */
Widget create_help_dialog(parent)

Widget parent;  /* helpDialogShell */
{
    Arg         args[512];
    Cardinal    argcnt;
    Widget      retval;
    Widget 	helpForm;
    XmString    xmstr[5];

    Widget      helpWindow;
    Widget      helpCancelButton;
    Widget      infoButton;
    Widget      autoButton;
    Widget      schedButton;
    Widget      newButton;
    Widget      revButton;
    Widget      plotButton;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNautoUnmanage, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 517); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 237); argcnt++;
    helpForm = XtCreateWidget("helpForm", xmFormWidgetClass, parent,
		args, argcnt);

    retval = helpForm;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Info", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 1); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    infoButton = XtCreateWidget("infoButton", xmPushButtonWidgetClass, 
	helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(infoButton);
    XtAddCallback(infoButton,XmNactivateCallback,load_help,(caddr_t)"I");

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Schedule", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 14); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    schedButton = XtCreateWidget("schedButton",
		xmPushButtonWidgetClass, helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(schedButton);
    XtAddCallback(schedButton,XmNactivateCallback,load_help,(caddr_t)"S");

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"New Pass", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 28); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    newButton = XtCreateWidget("newButton",
		xmPushButtonWidgetClass, helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(newButton);
    XtAddCallback(newButton,XmNactivateCallback,load_help,(caddr_t)"N");

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Review", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 43); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    revButton = XtCreateWidget("revButton",
		xmPushButtonWidgetClass, helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(revButton);
    XtAddCallback(revButton,XmNactivateCallback,load_help,(caddr_t)"R");

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Autogen", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 57); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    autoButton = XtCreateWidget("autoButton",
		xmPushButtonWidgetClass, helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(autoButton);
    XtAddCallback(autoButton,XmNactivateCallback,load_help,(caddr_t)"A");

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Plot", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 71); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    plotButton = XtCreateWidget("plotButton",
		xmPushButtonWidgetClass, helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(plotButton);
    XtAddCallback(plotButton,XmNactivateCallback,load_help,(caddr_t)"P");

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Cancel", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 85); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 70); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    helpCancelButton = XtCreateWidget("helpCancelButton",
		xmPushButtonWidgetClass, helpForm, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(helpCancelButton);
    XtAddCallback(helpCancelButton,XmNactivateCallback,cancel_help,(caddr_t)0);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, helpCancelButton); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAUTOMATIC); argcnt++;
    helpWindow = XtCreateWidget("helpWindow", xmScrolledWindowWidgetClass,
		helpForm, args, argcnt);
    XtManageChild(helpWindow);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 500); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 200); argcnt++;
    helpText = XtCreateWidget("helpText", xmTextWidgetClass, helpWindow,
		args, argcnt);
    XtManageChild(helpText);

return(retval);
}
