#include "xplot.h"

/*
 * CALLBACK PROCEDURE DECLARATIONS
 */
/* scheduling modules */
extern void add_to_sched();
extern void drop_pass();

/* plotting modules */
extern void get_new_pass_info();
extern void plot_next();
extern void plot_pass();

/* mainForm */
Widget create_main_work_area(parent)

Widget parent;  /* mainWindow */
{
    Arg         args[512];
    Cardinal    argcnt;
    Boolean     argok;
    Widget      retval;
    Widget	mainForm;
    XmString    xmstr[5];

    Widget	drawFrame;
    Widget	sceneFrame;
    Widget	infoFrame;
    Widget 	sceneList;
    Widget 	poleDialog;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 31); argcnt++;
    mainForm = XtCreateWidget("mainForm", xmFormWidgetClass,
		parent, args, argcnt);
    XtManageChild(mainForm);

    retval = mainForm;

/*
  Scene selection area
  This selection box has two "modes" based on what buttons are managed:
   normal mode: "Schedule" and "Delete", for new scenes to be reviewed
   review mode: "Next" and "Delete", for already scheduled scenes to be reviewed
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNshadowType, XmSHADOW_OUT); argcnt++;
    sceneFrame = XtCreateWidget("sceneFrame", xmFrameWidgetClass,
		mainForm, args, argcnt);
    XtManageChild(sceneFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNautoUnmanage, False); argcnt++;
    XtSetArg(args[argcnt], XmNokLabelString, (xmstr[0]=XmStringCreateLtoR(
		"Schedule", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNcancelLabelString, (xmstr[1]=XmStringCreateLtoR(
		"Next",    XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNhelpLabelString, (xmstr[2]=XmStringCreateLtoR(
		"Delete",  XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmustMatch, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 248); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 233); argcnt++;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_NONE); argcnt++;
    sceneBox = XtCreateWidget("sceneBox", xmSelectionBoxWidgetClass,
		sceneFrame, args, argcnt);
    XmStringFree(xmstr[0]); 
    XmStringFree(xmstr[1]);
    XmStringFree(xmstr[2]);
    XtAddCallback(sceneBox, XmNhelpCallback, drop_pass, (caddr_t)0);
    XtAddCallback(sceneBox, XmNcancelCallback, plot_next, (caddr_t)0);
    XtAddCallback(sceneBox, XmNnoMatchCallback, get_new_pass_info, (caddr_t)0);
    XtAddCallback(sceneBox, XmNokCallback, add_to_sched, (caddr_t)0);
    XtManageChild(sceneBox);

    /* un-manage the "Next" button (start in normal mode) */
    sceneList = XmSelectionBoxGetChild(sceneBox,XmDIALOG_CANCEL_BUTTON);
    XtUnmanageChild(sceneList);

    /* set up a callback for selecting from the list */
    sceneList = XmSelectionBoxGetChild(sceneBox,XmDIALOG_LIST);
    XtAddCallback(sceneList, XmNbrowseSelectionCallback, plot_pass, (caddr_t)0);

/*
  Scene plotting area
  attach left,right,and bottom with offset of 10 to show a margin in the form
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, sceneFrame); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNshadowType, XmSHADOW_IN); argcnt++;
    drawFrame = XtCreateWidget("drawFrame", xmFrameWidgetClass,
		mainForm, args, argcnt);
    XtManageChild(drawFrame);

    /* drawing area which will contain the world & plots of passes */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 800); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 400); argcnt++;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_NONE); argcnt++;
    drawingArea = XtCreateWidget("drawingArea", xmDrawingAreaWidgetClass,
		drawFrame, args, argcnt);
    XtManageChild(drawingArea);
    /*XtAddCallback(drawingArea, XmNexposeCallback, plot_pass, (caddr_t)0);*/

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 297); argcnt++;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    poleFrame = XtCreateWidget("poleFrame", xmFrameWidgetClass,
                mainForm, args, argcnt);
    /* don't manage yet */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 213); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 213); argcnt++;
    poleDrawingArea = XtCreateWidget("poleDrawingArea",xmDrawingAreaWidgetClass,
                poleFrame, args, argcnt);
    XtManageChild(poleDrawingArea);

/*
  Set up a label for selected passes below the drawing area
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
        "S C H E D U L E D", XmSTRING_DEFAULT_CHARSET))); argcnt++;    
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, drawFrame); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 300); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    scheduledLabel = XtCreateWidget("scheduledLabel", xmLabelWidgetClass,
                mainForm, args, argcnt);
    XmStringFree(xmstr[0]);

/*
  Scene information area
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, drawFrame); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNshadowType, XmSHADOW_OUT); argcnt++;
    infoFrame = XtCreateWidget("infoFrame", xmFrameWidgetClass,
		mainForm, args, argcnt);
    XtManageChild(infoFrame);

    create_info_area(infoFrame);

return(retval);
}
