#include "xplot.h"

/*
 * CALLBACK PROCEDURE DECLARATIONS
 */
/* help modules */
extern void load_help();

/* misc modules */
extern void quit();

/* plotting modules */
extern void dump_window();
extern void review_all();
extern void get_new_pass_info();

/* file loading modules */
extern void get_autogen_info();
extern void get_recorder_file();

/* menuBar */
Widget create_menu_system(parent)

Widget parent;  /* mainWindow */
{
    Arg         args[512];
    Cardinal    argcnt;
    Boolean     argok;
    Widget      retval;
    Widget	menuBar;
    XmString    xmstr[5];

    Widget	fileMenuShell;
    Widget	fileMenu;
    Widget	autoButton;
    Widget	recButton;
    Widget	dumpButton;
    Widget	reviewButton;
    Widget	newButton;
    Widget	exitButton;
    Widget	fileButton;
    Widget	helpMenuShell;
    Widget	helpMenu;
    Widget	autoHelpButton;
    Widget	infoHelpButton;
    Widget	newHelpButton;
    Widget	recHelpButton;
    Widget	revHelpButton;
    Widget	plotHelpButton;
    Widget	helpButton;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_BAR); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 822); argcnt++;
    menuBar = XtCreateWidget("menuBar", xmRowColumnWidgetClass,
		parent, args, argcnt);
    XtManageChild(menuBar);

    retval = menuBar;

/*
  Set up the options under the File menu
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    fileMenuShell = XtCreatePopupShell("fileMenuShell",
		xmMenuShellWidgetClass, menuBar, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 58); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 50); argcnt++;
    fileMenu = XtCreateWidget("fileMenu", xmRowColumnWidgetClass,
		fileMenuShell, args, argcnt);

    argcnt = 0;
    autoButton = XtCreateWidget("autoButton", xmPushButtonWidgetClass,
		fileMenu, args, argcnt);
    XtAddCallback(autoButton, XmNactivateCallback, get_autogen_info, 
	(caddr_t)"auto");
    XtManageChild(autoButton);

    argcnt = 0;
    recButton = XtCreateWidget("recButton", xmPushButtonWidgetClass,
		fileMenu, args, argcnt);
    XtAddCallback(recButton, XmNactivateCallback, get_recorder_file, 
	(caddr_t)"sched");
    XtManageChild(recButton);

    argcnt = 0;
    newButton = XtCreateWidget("newButton", xmPushButtonWidgetClass,
		fileMenu, args, argcnt);
    XtAddCallback(newButton,XmNactivateCallback, get_new_pass_info, (caddr_t)0);
    XtManageChild(newButton);

    argcnt = 0;
    reviewButton = XtCreateWidget("reviewButton", xmPushButtonWidgetClass,
		fileMenu, args, argcnt);
    XtAddCallback(reviewButton, XmNactivateCallback, review_all, (caddr_t)0);
    XtManageChild(reviewButton);

    argcnt = 0;
    dumpButton = XtCreateWidget("dumpButton", xmPushButtonWidgetClass,
		fileMenu, args, argcnt);
    XtAddCallback(dumpButton, XmNactivateCallback, dump_window, (caddr_t)0);
    XtManageChild(dumpButton);

    argcnt = 0;
    exitButton = XtCreateWidget("exitButton", xmPushButtonWidgetClass,
		fileMenu, args, argcnt);
    XtAddCallback(exitButton, XmNactivateCallback, quit, (caddr_t)0);
    XtManageChild(exitButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"File", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'F'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Ctrl<Key>F"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, (xmstr[1]=XmStringCreateLtoR(
                "Ctrl+F", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, fileMenu); argcnt++;
    fileButton = XtCreateWidget("fileButton", xmCascadeButtonWidgetClass,
		menuBar, args, argcnt);
    XmStringFree(xmstr[0]);
    XmStringFree(xmstr[1]);
    XtManageChild(fileButton);

/*
  Set up the options under the Help menu
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    helpMenuShell = XtCreatePopupShell("helpMenuShell",
		xmMenuShellWidgetClass, menuBar, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 96); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 50); argcnt++;
    helpMenu = XtCreateWidget("helpMenu", xmRowColumnWidgetClass,
		helpMenuShell, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"About XPLOT", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'X'); argcnt++;
    infoHelpButton = XtCreateWidget("infoHelpButton", xmPushButtonWidgetClass,
		helpMenu, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(infoHelpButton, XmNactivateCallback, load_help, (caddr_t)0);
    XtManageChild(infoHelpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Autogen", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'A'); argcnt++;
    autoHelpButton = XtCreateWidget("autoHelpButton", xmPushButtonWidgetClass,
		helpMenu, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(autoHelpButton, XmNactivateCallback, load_help, 
	(caddr_t)"xautogen.html");
    XtManageChild(autoHelpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Recorder Schedule",XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'S'); argcnt++;
    recHelpButton = XtCreateWidget("recHelpButton", xmPushButtonWidgetClass,
		helpMenu, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(recHelpButton, XmNactivateCallback, load_help, 
	(caddr_t)"xdomsat.html");
    XtManageChild(recHelpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
	"Creating New Passes",XmSTRING_DEFAULT_CHARSET)));argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'N'); argcnt++;
    newHelpButton = XtCreateWidget("newHelpButton", xmPushButtonWidgetClass,
		helpMenu, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(newHelpButton, XmNactivateCallback, load_help, 
	(caddr_t)"xnewpass.html");
    XtManageChild(newHelpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Reviewing", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'R'); argcnt++;
    revHelpButton = XtCreateWidget("revHelpButton", xmPushButtonWidgetClass,
		helpMenu, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(revHelpButton, XmNactivateCallback, load_help, 
	(caddr_t)"xplot.html#REVIEW");
    XtManageChild(revHelpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Plotting", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'P'); argcnt++;
    plotHelpButton = XtCreateWidget("plotHelpButton", xmPushButtonWidgetClass,
		helpMenu, args, argcnt);
    XmStringFree(xmstr[0]);
    XtAddCallback(plotHelpButton, XmNactivateCallback, load_help, 
	(caddr_t)"xplot.html#DUMP");
    XtManageChild(plotHelpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Help", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNmnemonic, 'H'); argcnt++;
    XtSetArg(args[argcnt], XmNaccelerator, "Ctrl<Key>H"); argcnt++;
    XtSetArg(args[argcnt], XmNacceleratorText, (xmstr[1]=XmStringCreateLtoR(
                "Ctrl+H", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, helpMenu); argcnt++;
    helpButton = XtCreateWidget("helpButton", xmCascadeButtonWidgetClass,
		menuBar, args, argcnt);
    XmStringFree(xmstr[0]);
    XmStringFree(xmstr[1]);
    XtManageChild(helpButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNmenuHelpWidget, helpButton); argcnt++;
    XtSetValues(menuBar, args, argcnt);

return(retval);
}
