#include "xplot.h"

/*
 * CALLBACK PROCEDURE DECLARATIONS
 */
extern void get_recorder_criteria();

Widget create_sat_dialog(parent,satellite,numsats,dtypes)	

Widget 	parent;
long    satellite[],	/* satellites in the schedule file 	*/
        numsats,	/* # of satellites in the schedule file */
	dtypes;		/* HRPT LAC GAC	data types		*/
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    XmString	xmstr[5];
    Widget 	retval;
    Widget	satDialogShell;
    Widget	satWorkFrame;
    Widget	satWorkArea;
    Widget	satSubTitle;
    Widget	satFrame;
    Widget	satBox;
    Widget	dtypeFrame;
    Widget	dtypeBox;
    Widget	satAcceptButton;
    WidgetList	try;
    char title[4];
    long i;
    long numdtypes = 0;

/*
  Dialog for recorder criteria
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtitle, "Schedule Contains:"); argcnt++;
    XtSetArg(args[argcnt], XmNx, 500); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 318); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 300); argcnt++;
    satDialogShell = XtCreatePopupShell("satDialogShell",
		xmDialogShellWidgetClass, parent, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 10); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, 10); argcnt++;
    satWorkFrame = XtCreateWidget("satWorkFrame", 
	xmFrameWidgetClass, satDialogShell, args, argcnt);

    retval = satWorkFrame;

/*
  Create area for satellite options
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    satWorkArea = XtCreateWidget("satWorkArea", 
	xmFormWidgetClass, satWorkFrame, args, argcnt);
    XtManageChild(satWorkArea);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
	"Please select satellites and\ndata types to work with:", 
	XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    satSubTitle = XtCreateWidget("satSubTitle", xmLabelWidgetClass,
		satWorkArea, args, argcnt);
    XmStringFree(xmstr[0]);
    XtManageChild(satSubTitle);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, satSubTitle); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 10); argcnt++;
    satFrame = XtCreateWidget("satFrame", xmFrameWidgetClass,
                satWorkArea, args, argcnt);
    XtManageChild(satFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 49); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 87); argcnt++;
    satBox = XtCreateWidget("satBox", xmRowColumnWidgetClass, satFrame,
                args, argcnt);
    XtManageChild(satBox);

    for (i = 0; i < numsats; i++)
	{
        sprintf(title,"N%02d",satellite[i]);
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                title, XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	XtCreateManagedWidget(title,xmToggleButtonWidgetClass,
                satBox, args, argcnt);
    	XmStringFree(xmstr[0]);
	}

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, satSubTitle); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNrightPosition, 90); argcnt++;
    dtypeFrame = XtCreateWidget("dtypeFrame", xmFrameWidgetClass,
                satWorkArea, args, argcnt);
    XtManageChild(dtypeFrame);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNradioBehavior, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 2); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 49); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 87); argcnt++;
    dtypeBox = XtCreateWidget("dtypeBox", xmRowColumnWidgetClass, dtypeFrame,
                args, argcnt);
    XtManageChild(dtypeBox);

    if ((dtypes / 100) == 1)  		/* HRPT */
	{
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "HRPT", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	XtCreateManagedWidget("HRPT",xmToggleButtonWidgetClass,
                dtypeBox, args, argcnt);
    	XmStringFree(xmstr[0]);
	numdtypes += 1;
	}
    if (((dtypes / 10) % 10) == 1)  	/* LAC */
	{
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "LAC", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	XtCreateManagedWidget("LAC",xmToggleButtonWidgetClass,
                dtypeBox, args, argcnt);
    	XmStringFree(xmstr[0]);
	numdtypes += 1;
	}
    if ((dtypes % 10) == 1)  		/* GAC */
	{
    	argcnt = 0;
    	XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "GAC", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    	XtCreateManagedWidget("GAC",xmToggleButtonWidgetClass,
                dtypeBox, args, argcnt);
    	XmStringFree(xmstr[0]);
	numdtypes += 1;
	}

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    if (numsats >= numdtypes)	/* attach to the bigger box */
        { XtSetArg(args[argcnt], XmNtopWidget, satFrame); argcnt++; }
    else
        { XtSetArg(args[argcnt], XmNtopWidget, dtypeFrame); argcnt++; }
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,XmATTACH_POSITION);argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 40); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    satAcceptButton =XtCreateWidget("satAcceptButton",xmPushButtonWidgetClass,
                satWorkArea, args, argcnt);
    XtManageChild(satAcceptButton);

    /* need to send both satBox and dtypeBox to the callback */
    /* put the dtypeBox widget id in the satBox userData */
    XtVaSetValues(satBox,XmNuserData,(XtPointer)dtypeBox,NULL);
    XtAddCallback(satAcceptButton, XmNactivateCallback, get_recorder_criteria, 
		  (caddr_t)satBox);

return(retval);
}
