/******************************************************************************
FUNCTION:	dom_header

PURPOSE:	Print header information to the output report file

PROGRAM HISTORY:
Version    Date     Author	Change Request
-------    -----    ---------	--------------
  5.0      10/92    T.Rockvam	Original development

*******************************************************************************/
#include <stdio.h>
#include "adaps.h"

void dom_header(report,lincnt)

FILE	*report;		/* file descriptor for autosched report */
long	*lincnt;		/* report line count			*/
{
static long 	pgnum = 0;	/* page number				*/

/*
  Check the line count to determine if the report should continue on a new page
*/
if ((*lincnt == 0) || (*lincnt >= 58))
    fprintf(report,"\f");

/*
  Add the standard EDC header
*/
pgnum += 1;
sheadc(report,"EROS Data Center","Sioux Falls, South Dakota 57198",pgnum,
	"DOMSAT","AVHRR Data Acquisition and Processing System",
	"Domsat Acquisition Schedule");

/*
  Tell the user the satellite name and ID
*/
fprintf(report,"\n Schedule of passes to be acquired for domsat\n\n");

/*
  Write out the headings
*/
fprintf(report,"   Scene           Sat   Orbit              Acquisition                      Pass              Station     Data     \n");
fprintf(report,"    Id             Id    Number    Date       Start     Stop      Date      Start      Stop      Id        Type   Op\n");
fprintf(report,"________________   ___   _____   ____________________________   ____________________________   _________   ____   __\n\n");

*lincnt = 12;

return;
}
