/******************************************************************************
FUNCTION:	DRAW_CIRCLE

PURPOSE: 	This function is designed to draw the coverage circle	    

PROGRAM HISTORY:
Version    Date     Author	Change Request
-------    -----    ---------	--------------
1.0	   1/93     T.Rockvam	Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT		ADAPS XPlot

ALGORITHM REFERENCES
*******************************************************************************/
#include "xplot.h"

void draw_circle(the_display,the_GC,work_pix,targlat,targlon,mid_x,mid_y)

Display	*the_display;
GC	the_GC;
Pixmap	work_pix;
float	targlat,
	targlon;
float	mid_x,
	mid_y;
{
int	x1,		/* Screen x location.				*/
	x2,		/* Screen x location.				*/
	y1,		/* Screen y location.				*/
	y2;		/* Screen y location.				*/

long 	i;

double	thislat,
	thislng;
double	rsat = 6378.0+870.0;		/* REQUA + SAT_ALTITUDE * 1000 */
double	re = 6378.0;			/* REQUA */
double	ran;
double	phi;
double	dlong;
double	angle;
void conv_pts();

/* 0-degree circle */
ran = acos(re / rsat);
/* 2-degree circle */
ran = PIE - (92*RAD_PER_DEG + asin(sin(92*RAD_PER_DEG)*re/rsat));
thislat = targlat * RAD_PER_DEG;
thislng = targlon * RAD_PER_DEG;

/*
  Draw a circle around the target
*/
angle = 0.0;
phi = acos(sin(thislat) * cos(ran) + cos(thislat) * sin(ran) * cos(angle));
dlong = asin(sin(ran) * sin(angle) / sin(phi));
conv_pts(scale,mid_x,mid_y,PIE/2.0-phi,thislng+dlong,&x1,&y1);

for (i = 1; i <= 180; i++)
    {
    angle = i * RAD_PER_DEG * 2.0;
    phi = acos(sin(thislat) * cos(ran) + cos(thislat) * sin(ran) * cos(angle));
    dlong = asin(sin(ran) * sin(angle) / sin(phi));

    conv_pts(scale,mid_x,mid_y,HALFPIE-phi,thislng+dlong,&x2,&y2);
    XDrawLine(the_display,work_pix,the_GC,x1,y1,x2,y2);
    x1 = x2;
    y1 = y2;
    }

/*
  Draw the target in also
*/
conv_pts(scale,mid_x,mid_y,thislat,thislng,&x1,&y1);
XDrawPoint(the_display,work_pix,the_GC,x1,y1);

return;
}
