#include <stdio.h>
#include <Xm/Xm.h>

forcedialog(w)
Widget	w;
{
Widget		diashell, topshell;
Window		diawindow, topwindow;
Display		*dpy;
XWindowAttributes	
		xwa;
XEvent		event;
XtAppContext 	cxt;

/*
  Locate the shell we are interested in.  In a particular instance, you
  may know these shells already.
*/
for (diashell = w; !XtIsShell(diashell); diashell = XtParent(diashell));

/*
  Locate its primary window's shell (which may be the same).
*/
for (topshell = diashell; !XtIsTopLevelShell(topshell); 
    topshell = XtParent(topshell));

if (XtIsRealized(diashell) && XtIsRealized(topshell))
    {
    dpy = XtDisplay(topshell);
    diawindow = XtWindow(diashell);
    topwindow = XtWindow(topshell);
    cxt = XtWidgetToApplicationContext(diashell);

    /*
      Wait for the dialog to be mapped.
    */
    while (XGetWindowAttributes(dpy, diawindow, &xwa), xwa.map_state != 
	IsViewable)
        {
	/*
    	  If the primary is (or becomes) unviewable or unmapped, it's probably
    	  iconified and nothing will happen.
	*/
        if (XGetWindowAttributes(dpy, topwindow, &xwa), xwa.map_state != 
	    IsViewable)
	    break;
	/*
     	  At this stage, we are guaranteed there will be an event of some kind.
	*/
	XtAppNextEvent(cxt, &event);
	XtDispatchEvent(&event);
        }
    }

/*
  The next XSync() will get an expose event if the dialog was unmapped.
*/
XmUpdateDisplay(topshell);
}
