/******************************************************************************
FUNCTION:	isdir

PURPOSE:	Determine if the input file is a directory name

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
           ??/??    ????		Original development
  5.0      04/88    D. Hollaren		Added prolog; change include spec to las
					return E_SUCC/E_FAIL
  5.1      09/89    B. Davis		Changed unix half to disregard sockets,
					make the check for dirs more stringent.
*******************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

int isdir(path)
char *path;			/* directory/file path/name		*/
{
struct stat buf;	/* structure for receiving file info	*/
int rslt;

rslt = stat(path,&buf);
if (rslt < 0)
    return(0);

#ifdef aiws
    if ((buf.st_mode & 0140000) == (0140000))
#else
    if ((buf.st_mode & S_IFSOCK) == (S_IFSOCK))
#endif
	return(0);
    else if ((buf.st_mode & S_IFDIR) == (S_IFDIR))
	return(1);
    else
	return(0);
}
