#define _xplot_h
#include "xplot.h"

/*
 * DEFINE SECTION 
 */
#define APP_NAME "xPlot"
#define APP_CLASS "XPlot"

/* MAIN PROGRAM */
main(argc, argv)
int argc;
char **argv;
{
Arg 	args[256];
Cardinal argcnt;
XtAppContext context;
long 	nonfatal = 1;
long 	status = 0;
char 	sat_table[100];
char	satname[8],satid[4],satltr[2];
long	satno;
FILE 	*sat_fd;

#include "fallbacks.h"

void set_up_background();
void set_up_pole_pixmaps();
void plot_pass();
void help_reset();

/*
  Make sure we can find ephem info on the satellites
*/
if (getenv("ADAPSTABLES") == NULL)
    {
    c_errmsg("Error retrieving value of ADAPSTABLES","xplot-find",&nonfatal);
    exit(-1);
    }
else
    {
    /*
      Read in id's of available satellites
    */
    sprintf(sat_table,"%s/satellite.ids",getenv("ADAPSTABLES"));
    sat_fd = fopen(sat_table,"r");
    if (sat_fd == NULL)
    	{
    	c_errmsg("Error retrieving satellite table","xplot-find",&nonfatal);
    	exit(-1);
    	}
    status = fscanf(sat_fd, "%d %s %s %d %s", &all_satellite[all_numsats],satname,satid,&satno,satltr);
    while (status != EOF)
	{
	all_numsats++;
	if (all_numsats >= MAXSATS) break;
	status = fscanf(sat_fd, "%d %s %s %d %s", &all_satellite[all_numsats],satname,satid,&satno,satltr);
    	}
    fclose(sat_fd);
    }
if (all_numsats == 0)
    {
    c_errmsg("No valid satellites found","xplot-find",&nonfatal);
    exit(-1);
    }

XtToolkitInitialize();
context = XtCreateApplicationContext();
XtAppSetFallbackResources(context,fallbacks);

display = XtOpenDisplay(context, 0, APP_NAME, APP_CLASS,
#ifndef XtSpecificationRelease
        0, 0, (Cardinal*)&argc, argv);
#else
#if XtSpecificationRelease == 4
        0, 0, (Cardinal*)&argc, argv);
#else
        0, 0, &argc, argv);
#endif
#endif

if (display == NULL)
    {
    XtWarning("cannot open display");
    exit(1);
    }
XmRegisterConverters();

/*
  Set up the main window areas
*/
/*
 * The applicationShell is created as an unrealized parent for multiple 
 * topLevelShells.  The topLevelShells are created as popup children of the 
 * applicationShell.  This is a recommendation of Paul Asente & Ralph Swick 
 * in _X_Window_System_Toolkit_ p. 677.
 */
argcnt = 0;
XtSetArg(args[argcnt], XmNx, 0); argcnt++;
XtSetArg(args[argcnt], XmNy, 0); argcnt++;
XtSetArg(args[argcnt], XmNmappedWhenManaged, True); argcnt++;
AppShell = XtAppCreateShell(APP_NAME,APP_CLASS,
           applicationShellWidgetClass, display, args, argcnt);

argcnt = 0;
XtSetArg(args[argcnt], XmNallowShellResize, False); argcnt++;
XtSetArg(args[argcnt], XmNtitle, "XPlot"); argcnt++;
XtSetArg(args[argcnt], XmNx, 59); argcnt++;
XtSetArg(args[argcnt], XmNy, 118); argcnt++;
MainShell = XtCreatePopupShell("XPlot", 
           topLevelShellWidgetClass,AppShell,args,argcnt);

MainWindow = create_panels(MainShell,all_satellite,all_numsats);
XtManageChild(MainWindow);
XtPopup(MainShell, XtGrabNone);

/*
  Set up the background of the drawingArea
*/
set_up_background(display,drawingArea);
set_up_pole_pixmaps(display,drawingArea);

/*
  Set up the 2 queues for keeping track of scenes
*/
qtemp = c_qcreate("fifo","dups");
qkeep = c_qcreate("fifo","nodups");


/*
  Set up signals for help processes
*/
signal(SIGCLD,help_reset);
help_pid = -1;
help_fork = FALSE;

/*
  Add an event handler for redrawing on 
  expose events for drawingArea
*/
XtAddEventHandler(drawingArea,ExposureMask,False,plot_pass,NULL);

/*
  Commence main processing loop
*/
XtAppMainLoop(context);
}
