/******************************************************************************
FUNCTION:       NORMAL_BUTTONS

PURPOSE:        Set the sceneBox buttons back to "normal" mode
*******************************************************************************/
#include "xplot.h"

#define  SCHEDULE_BUTTON XmDIALOG_OK_BUTTON
#define  NEXT_BUTTON XmDIALOG_CANCEL_BUTTON


void normal_buttons ()
{
/*
  Set the buttons back to normal mode if needed
*/
if (XtIsManaged(XmSelectionBoxGetChild(sceneBox,NEXT_BUTTON)))
    {
    /*
      Always unmanage first, then manage to avoid growing the sceneBox, which
      might occur if a large font doesn't allow 3 buttons across
    */
    XtUnmanageChild(XmSelectionBoxGetChild(sceneBox,NEXT_BUTTON));
    XtManageChild(XmSelectionBoxGetChild(sceneBox,SCHEDULE_BUTTON));

    /*
      Set the focus to the "Schedule" button to avoid accidental deletions
    */
    XmProcessTraversal(XmSelectionBoxGetChild(sceneBox,SCHEDULE_BUTTON),
        XmTRAVERSE_CURRENT);
    }

return;
}

