/******************************************************************************
FUNCTION:       PLOT_POS

PURPOSE:        Plot the item in the given position in the sceneList
		if there are no more scenes, do some cleanup
*******************************************************************************/
#include "xplot.h"

extern void normal_buttons();
extern void clear_info_area();

void plot_pos(pos)

long	pos;		/* position of the scene to select	*/
{
Widget 	sceneList;
XmString xstring;

long	count;

/*
  Get the id of the list
*/
sceneList = XmSelectionBoxGetChild(sceneBox,XmDIALOG_LIST);

/*
  Highlight & plot the given item in the list
*/
XtVaGetValues(sceneList,XmNitemCount,&count,NULL);
if (count > 0)
    {
    /* Selecting a list item triggers the browseSelectionCallback, plot_pass */
    if (count >= pos)
        XmListSelectPos(sceneList,pos,True);
    else
        XmListSelectPos(sceneList,count,True);
    }
else
    {
    /* Hide the pole view if previously showing */
    XtUnmanageChild(poleFrame);

    /* Hide the schedule status label */
    XtUnmanageChild(scheduledLabel);

    /* Clear out the main drawing area */
    XClearWindow(display,XtWindow(drawingArea));

    /* Set the buttons back to normal mode */
    normal_buttons();

    /* Clear out the information area */
    clear_info_area();

    /* Clear out the sceneid in the sceneBox text field */
    xstring = XmStringCreateLtoR("",XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(sceneBox,XmNtextString,xstring,NULL);
    XmStringFree(xstring);
    }

return;
}

