/***************************************************************************
NAME      		  QINSERT

PURPOSE: Insert a structure into the linked list

PROGRAM HISTORY
PROGRAMMER	  DATE		REASON
----------	  ----		------
T. Baltzer	Oct. 1991	Original development
T. Rockvam	Dec. 1992	Incorporated into XPlot

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS
 Must be run on a system that supports the X Windows environment

PROJECT   	         ADAPS		                
******************************************************************************/
#include <stdio.h>
#include "scenes.h"

void qinsert(q,scene,compare)

long	q;

struct SCENEINFO *scene;	/* pointer to new element to create & insert*/

long	(compare)();
{
char 	*malloc();		/* system allocation routine	  	*/
struct SCENEINFO *newscene;	/* new structure			*/

newscene = (struct SCENEINFO *)malloc(sizeof(*newscene));
if (newscene == NULL)
    return;

/* 
  Fill in the new structure
*/
strcpy(newscene->sceneid,scene->sceneid);
newscene->where    = scene->where;
newscene->acqstart = scene->acqstart;
newscene->acqstop  = scene->acqstop;
newscene->passtart = scene->passtart;
newscene->passtop  = scene->passtop;
newscene->dtype    = scene->dtype;
newscene->orbit    = scene->orbit;
newscene->station  = scene->station;
newscene->opcode   = scene->opcode;
newscene->status   = scene->status;
newscene->hdtrfile = scene->hdtrfile;
newscene->prodflag = scene->prodflag;

/*
  Add the new structure to the queue
*/
c_qinsert(q,newscene,compare);

return;
}
