/******************************************************************************
FUNCTION:	SAVSCHED

PURPOSE:	Write the temporary file used to update the schedule

PROGRAM HISTORY:
Version    Date     Author      Change Request
-------    -----    ---------   --------------
1.0        4/87     Hollaren
2.0        6/89     LaVergne    updated to receive the output file names as
                                parameters so their version numbers are already
                                known.  This eliminates problems in batch.
5.0        10/92    T.Rockvam   Updated to LAS 5.0
*******************************************************************************/
#include "xplot.h"

FUNCTION savsched(sched,scene_found)

FILE	*sched;			/* schedule update file			*/

struct SCENEINFO *scene_found;	/* struct of info about one scene	*/
{
char	station,
	dtype[5];
/*
  Write a record for the pass
*/

if (scene_found->station == WALLOPS)
    station = 'W';
else if (scene_found->station == FAIRBANKS)
    station = 'F';
else
    station = 'E';

if (scene_found->dtype == GAC)
    strcpy(dtype,"GAC_");
else if (scene_found->dtype == LAC)
    strcpy(dtype,"LAC_");
else
    strcpy(dtype,"HRPT");

fprintf(sched,
    "%16.16s %c%c%c %09d %09d %09d %09d %1d %c %02d %c %c %4.4s %05d\n", 
    scene_found->sceneid,'N',scene_found->sceneid[2],scene_found->sceneid[3],
    scene_found->acqstart,scene_found->acqstop,scene_found->passtart,
    scene_found->passtop,scene_found->opcode,scene_found->status,
    scene_found->hdtrfile,scene_found->prodflag,station,dtype,
    scene_found->orbit);

return;
}
