/******************************************************************************
FUNCTION:	set_up_pole_pixmaps

PURPOSE:	set up the WDBII outline of the world in the drawing area

PROGRAM HISTORY:
Version		Date	Author		Change Request
-------    	-----	------		--------------
 1.0	   	11/92	T.Rockvam	Conversion to LAS-5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
 Must be run on a system that supports the X Windows environment

PROJECT		ADAPS

ALGORITHM REFERENCES	Xlib Referenc Manual, O'Reilly & Assoc.
*******************************************************************************/
#include "xplot.h"
#include "NorthPole.h"
#include "SouthPole.h"

void set_up_pole_pixmaps(the_display,drawingArea)

Display *the_display;		/* the display		*/
Widget  drawingArea;		/* the drawing area	*/
{
Window the_window;
int the_screen;

/*
  Find out the size of the drawing area we are working with 
  Use the window of drawingArea because poleDrawingArea isn't 
  visible at this time
*/
the_screen  = DefaultScreen(the_display);
the_window = XtWindow(drawingArea);

/*
  Open and initialize both pixmaps
*/
northPole = XCreatePixmapFromBitmapData(the_display,the_window,NorthPole_bits,
    NorthPole_width,NorthPole_height,BlackPixel(the_display,the_screen),
    WhitePixel(the_display,the_screen),DefaultDepth(the_display,the_screen));

southPole = XCreatePixmapFromBitmapData(the_display,the_window,SouthPole_bits,
    SouthPole_width,SouthPole_height,BlackPixel(the_display,the_screen),
    WhitePixel(the_display,the_screen),DefaultDepth(the_display,the_screen));
}
