/*
 * REQUIRED MOTIF INCLUDE FILES
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/wait.h>
#include <math.h>
#include <X11/Xlib.h>           /* the X library */
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <Xm/Xm.h>
#include <Xm/BulletinB.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/DrawingA.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/MainW.h>
#include <Xm/MenuShell.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/ScrolledW.h>
#include <Xm/SelectioB.h>
#include <Xm/Separator.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>



/*
 * USER SUPPLIED INCLUDE FILES
 */
#include "worgen.h"
#include "adaps.h"
#include "scenes.h"

#ifdef _xplot_h
/*
 * GLOBAL WIDGET VARIABLES
 */
Widget create_panels();
Widget AppShell;        /* The Main Application Shell */
Widget MainShell;
Widget MainWindow;

/* popups */
Widget newPassFrame;
Widget autogenFrame;
Widget recorderFrame;
Widget errorBox;
Widget procMsgBox;
Widget criteriaFrame;
Widget satFrame;

/* new pass widgets */
Widget nDateText;
Widget nTimeText;
Widget nLengthText;
Widget nSatBox;
Widget nDtypeBox;

/* autogen widgets */
Widget targLatText;
Widget targLongText;
Widget staDateText;
Widget staTimeText;
Widget stoDateText;
Widget stoTimeText;
Widget minTimeText;
Widget varTimeText;
Widget opModeText;
Widget maxDistText;
Widget autoFnameText;
Widget autoRSButton;
Widget autoRNButton;
Widget autoRBButton;

/* processing message widgets */
Widget procMsgShell;
Widget procMsgText;

/* recorder scheduling criteria buttons */
Widget optionSelectionBox;
Widget fileSelectionBox;
Widget recHRPTButton;
Widget recLACButton;
Widget recGACButton;
Widget recWIButton;
Widget recGCButton;
Widget recASCButton;
Widget recDESCButton;

/* info area widgets */
Widget satText;
Widget dtypeText;
Widget dateText;
Widget timeText;
Widget orbitText;
Widget stationText;
/* miscellaneous */
Widget sceneBox;
Widget drawingArea;
Widget poleFrame;
Widget poleDrawingArea;
Widget scheduledLabel;

Pixmap	northPole;
Pixmap  southPole;
Pixmap  world_pix;

Display *display;

float scale;             	/* scaling for drawing in the drawingArea */
float mid_x;             	/* scaling for drawing in the drawingArea */
float mid_y;             	/* scaling for drawing in the drawingArea */

GC the_GC;			/* the graphics context */

long all_numsats = 0,
     all_satellite[MAXSATS];
long chosen_numsats = 0,
     chosen_satellite[MAXSATS];

long qtemp;			/* queue id of temp list of scenes */
long qkeep;			/* queue id of list of kept scenes */

long help_fork;      		/* has a process been forked? */
pid_t help_pid;       		/* process ID of help process */

#else

extern Widget create_panels();
extern Widget AppShell;
extern Widget MainShell;
extern Widget MainWindow;
extern Widget newPassFrame;
extern Widget autogenFrame;
extern Widget recorderFrame;
extern Widget errorBox;
extern Widget procMsgBox;
extern Widget criteriaFrame;
extern Widget satFrame;
extern Widget nDateText;
extern Widget nTimeText;
extern Widget nLengthText;
extern Widget nSatBox;
extern Widget nDtypeBox;
extern Widget targLatText;
extern Widget targLongText;
extern Widget staDateText;
extern Widget staTimeText;
extern Widget stoDateText;
extern Widget stoTimeText;
extern Widget minTimeText;
extern Widget varTimeText;
extern Widget opModeText;
extern Widget maxDistText;
extern Widget autoFnameText;
extern Widget autoRSButton;
extern Widget autoRNButton;
extern Widget autoRBButton;
extern Widget procMsgShell;
extern Widget procMsgText;
extern Widget optionSelectionBox;
extern Widget fileSelectionBox;
extern Widget recHRPTButton;
extern Widget recLACButton;
extern Widget recGACButton;
extern Widget recWIButton;
extern Widget recGCButton;
extern Widget recASCButton;
extern Widget recDESCButton;
extern Widget satText;
extern Widget dtypeText;
extern Widget dateText;
extern Widget timeText;
extern Widget orbitText;
extern Widget stationText;
extern Widget sceneBox;
extern Widget drawingArea;
extern Widget poleFrame;
extern Widget poleDrawingArea;
extern Widget scheduledLabel;

extern Pixmap  northPole;
extern Pixmap  southPole;
extern Pixmap  world_pix;

extern Display *display;

extern float scale;
extern float mid_x;
extern float mid_y;

extern GC the_GC;

extern long all_numsats,
     all_satellite[MAXSATS];
extern long chosen_numsats,
     chosen_satellite[MAXSATS];
extern long qtemp;
extern long qkeep;
extern long help_fork;
extern pid_t help_pid;
#endif
