.SUFFIXES: .pdf .html


#----------------------------------------------------------------------------
# Set up the compiler options.  Define INC to be the include files that are
# part of this application only.  Do not list include files from ADAPSINCLUDE
# or LASINCLUDE.
#----------------------------------------------------------------------------
OPTS    = $(CFLAGS) -I$(LASINCLUDE) -I$(ADAPSINCLUDE) -I$(TAEINC)
INC	= avhrrin.h


#-------------------------------------------------------
# Define the executable(s), the pdf(s), and the html(s).
#-------------------------------------------------------
EXECS   = avhrrin
HTMLS	= avhrrin.html
PDFS    = $(HTMLS:.html=.pdf)


#---------------------------------------------------------
# Define the source code object files for each executable.
#---------------------------------------------------------
SRC	= \
	avhrrin.c \
	convert_rev.c \
	convert_seq.c \
	upassoc.c \
	setup.c

OBJ	= $(SRC:.c=.o)


#--------------------------------------------------------
# Standard list of object libraries.  Delete those that
# are not necessary and add additional ones if necessary.
#--------------------------------------------------------
OBJLIB  = \
	$(LASLIB)/las.a \
	$(LASLIB)/geolib.a \
	$(LASLIB)/statio.a \
	$(LASLIB)/world.a \
        $(ADAPSLIB)/archio.a \
        $(ADAPSLIB)/adaps.a \
        $(ADAPSLIB)/model.a \
        $(ADAPSLIB)/util.a \
	$(LASLIB)/tae.a \
	$(TAELIB)/clib.a \
	$(TAELIB)/lib.a


#------------------------------------------------------------------------------
# Targets for each executable.  You should have two targets for each executable
# that is created.  One to create the executable and one to load it into the
# CenterLine debugger.
#------------------------------------------------------------------------------
all: $(EXECS) $(HTMLS)

avhrrin: $(OBJ) $(OBJLIB) $(INC)
	$(CC) $(OPTS) -o avhrrin $(OBJ) $(OBJLIB) $(TRLIB)

xcenter:
	#load $(OPTS) $(SRC) $(OBJLIB) $(INC) $(TRLIB)
	#link


#--------------------------------------------------
# Target to distribute the executable(s) and pdf(s)
#--------------------------------------------------
las: $(EXECS)
	cp $(PDFS) $(DSTDIR)
	mv $(EXECS) $(DSTDIR)


#-----------------------------------------------------------------------------
# Rules for compiling the object files.  If you have multiple groups of object
# files, add one dependency of the form "$(OBJS): $(INC)" for each group of
# object files.
#-----------------------------------------------------------------------------
$(OBJ): $(INC)

.c.o:
	$(CC) $(OPTS) -c $<


#------------------------------
# Make all of the documentation
#------------------------------
doc: $(HTMLS)
	mv $(HTMLS) $(DSTDIR)

.pdf.html:
	pdfhtml $*


#--------------------------------------
# Clean up objects and other misc files
#--------------------------------------
clean:
	/bin/rm -f $(EXECS) $(HTMLS) *.o *.a core make.log
