#ifndef ADAPSGEO_H
#define ADAPSGEO_H


/* Prototype functions to be called by any ADAPS support routine or module    */

int c_copygrid
(
    struct GRID *ingrid,  /* IN  - A grid structure with all fields set       */
    struct GRID *outgrid  /* OUT - A copy of the input grid                   */
);

int c_freegrid
(
    struct GRID *grid   /* IN/OUT - Grid to have it's memory freed            */
);

int c_geo2ls
(
    double *ullat,   /* IN - Latitude of a known pixel in the image           */
    double *ullon,   /* IN - Longitude of a known pixel in the image          */
    double *pdistx,  /* IN - Pixel distance in the sample direction (Degrees) */
    double *pdisty,  /* IN - Pixel distance in the line direction   (Degrees) */
    double *pixlat,  /* IN - Latitude of the desired pixel                    */
    double *pixlon,  /* IN - Longitude of the desired pixel                   */
    long *pixline,   /* OUT - Line offset to desired pixel from known pixel   */
    long *pixsamp    /* OUT - Sample offset to desired pixel from known pixel */
);

int c_prtgrid
(
    char *hostname,     /* IN - Host name of the file to contain the grid     */
    struct GRID *grid   /* IN - Grid structure to write to a file             */
);

int c_readgrid
(
    char *hostname,     /* IN  - Host file name of the grid file to read      */
    struct GRID *grid   /* OUT - Grid structure to read from the file         */
);

int c_wrtgrid
(
    struct GRID *grid   /* IN - Grid structure to write to a file             */
);

int c_zerogrid
(
    struct GRID *grid   /* IN/OUT - Grid to be initialized                    */
);

#endif

