#ifndef BROUWDEF_H
#define BROUWDEF_H


/* constants for the brouwcorrect routine
C***********************************************************                    
C*  REF. '' BROUWER-LYDDANE ORBIT GENERATOR ROUTINE ''     *                    
C*                 (X-553W-70-223)                                              
C*              BY E.A. GALBREATH 1970                     *                    
C***********************************************************/


#define GM 398603.20
#define BJ2 0.10826517E-2
#define BJ3 -0.25450306E-5
#define BJ4 -0.16714987E-5
#define BJ5 -0.20672093E-6
#define F 0.3352329869259135E-2
#define RE 1.0
#define F3D8 3.0/8.0
#define F1D2 1.0/2.0
#define F3D2 3.0/2.0
#define F1D4 1.0/4.0
#define F5D4 5.0/4.0
#define F1D8 1.0/8.0
#define F5D12 5.0/12.0
#define F1D16 1.0/16.0
#define F15D16 15.0/16.0
#define F5D24 5.0/24.0
#define F3D32 3.0/32.0
#define F15D32 15.0/32.0
#define F5D64 5.0/64.0
#define F35384 35.0/384.0
#define F35576 35.0/576.0
#define F35D52 35.0/1152.0
#define F1D3 1.0/3.0
#define F5D16 5.0/16.0
#define BK2   F1D2*(BJ2*RE*RE)
#define BK3  -(BJ3*RE*RE*RE)
#define BK4  -(F3D8*(BJ4*RE*RE*RE*RE))
#define BK5  -(BJ5*RE*RE*RE*RE*RE)

#endif
