/******************************************************************************
NAME:           C_ACQCLOSE

PURPOSE:        Close an acquired image that was opened with C_ACQOPEN

PROGRAM HISTORY:
VERSION  AUTHOR        DATE     REASON
-------  ------        -----    -----------------------------
  5.0    D. Hollaren   02/92    Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include "worgen.h"
#include "tae.h"
#include "acqio.h"

int c_acqclose
(
    long *fdesc         /* File descriptor to the acquire image         */
)
{
struct ACQDESC *acq;    /* Pointer to the acquire structure             */

long    status,         /* Return status from the close                 */
        nonfatal = 1;   /* Non-fatal error code                         */

/*
  Set the acquire structure to the file descriptor address
*/
acq = (struct ACQDESC *) *fdesc;

/*
  Close the file
*/
status = close(acq->fd);
if (status < 0)
    {
    c_errmsg("Error closing the acquire file","acqclose-close",&nonfatal);
    return(E_FAIL);
    }

return(E_SUCC);
}
