/******************************************************************************
NAME:           TIPOPEN

PURPOSE:        Open an output file for TIP data

PROGRAM HISTORY:
VERSION  AUTHOR        DATE     REASON
-------  ------        -----    -----------------------------
  5.0    D. Hollaren   02/92    Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <fcntl.h>
#include <stdio.h>
#include "worgen.h"
#include "tae.h"
#include "acqio.h"

int c_tipopen
(
    int *fd,            /* File descriptor to the TIP file      */
    char *file,         /* File name of the TIP file            */
    long *access        /* Type of access to the file           */
)
{
long    flag,           /* Access flag for open                 */
        nonfatal = 1;   /* Non-fatal error code                 */

/*
  Setup the type of access to open the file with
*/
if (*access == IREAD)
    flag = O_RDONLY;
else if (*access == IWRITE)
    flag = (O_WRONLY | O_CREAT);
else
    flag = (O_RDWR | O_CREAT);

*fd = open(file,flag,0775);

if (*fd < 0)
    {
    c_errmsg("Error opening the tip file","tipopen-open",&nonfatal);
    return(E_FAIL);
    }

return(E_SUCC);
}
