/*******************************************************************************
NAME:		C_CVDMS

PURPOSE:	Convert a latitude or longitude value in total degrees to
		degrees, minutes, and seconds.

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		CODE/CONT   REASON
-------		----	------		---------   ------
  5.0		3/91	D. Hollaren	   CSB      Conversion to LAS5.0

ALGORITHM DESCRIPTION:

ALGORITHM REFERENCE:
*******************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include <math.h>
#ifdef vms
#include <stdlib.h>
#endif

void c_cvtdms
(
    double *latlon,	/* Latitude or longitude of value to convert */
    long *deg,          /* Degrees */
    long *mins,		/* Minutes */
    long *sec		/* Seconds */
)
{
double	left,		/* Value left */
	temp;		/* Temporary storage value */

/* Extract the degrees
----------------------*/
*deg = (long)*latlon;

/* Take the amount left and extract the minutes
-----------------------------------------------*/
left = *latlon - (double)*deg;
temp = fabs(left) * 60;
*mins = (long)(temp);

/* Take the amount left and extract the seconds 
-----------------------------------------------*/
left = temp - (double)*mins;
*sec = (long)(left * 60);

return;
}
 
