/***************************************************************************
NAME:			GETSCENE

PURPOSE:	Build the scene id of the LAS input image

ALGORITHM:	see in line documentation
****************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include "avhrr.h"
#include "model.h"

void c_getscene
(
    struct MODEL *model,	/* Model and orbital information	*/
    char *sceneid		/* Scene id				*/
)
{
char	type[2];		/* Type of data (GAC, LAC, HRPT)	*/

if (model->dtype == GAC)
    type[0] = 'g';
else if (model->dtype == LAC)
    type[0] = 'l';
else
    type[0] = 'h';

/* Build the sceneid
--------------------*/
sprintf(sceneid,"a%c%02d%02d%02d%02d%02d%02d%02d", type[0], model->satnum,
	model->month,model->day,model->year,model->shour,model->smin,
	model->ssec);
return;
}
 
