/*******************************************************************************
FUNCTION: c_getsizes

PURPOSE:  Given a list of file names and the number of files, return the size
	  of each file in bytes.

PROGRAM HISTORY:

Version  Date   Author           Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    05/92  J.Fenno          Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
         Run under TAE

PROJECT: ADAPS

*******************************************************************************/
#include <stdio.h>
#include "worgen.h"
#ifndef SEEK_END    /* Not defined on PowerNode */
#define SEEK_END 2
#endif

void c_getsizes
(
    char file_names[][CMLEN],	/* Full path specification of files   */
    long nfiles,		/* Number of files in file_names      */
    double file_sizes[]       	/* Size in bytes of each file         */
)
{
long   i;                    /* Loop control                                  */

double size;                 /* Size in bytes of the current file             */

FILE   *file_ptr;            /* File ptr used for opening each file           */


for (i = 0; i < nfiles; i++)
   {
   /* Open each file specified
   ---------------------------*/
   file_ptr = fopen(file_names[i], "r");
   if (file_ptr == NULL)
      file_sizes[i] = -1;
   else
      {
      /* Seek 0 bytes from the end of the file
      ----------------------------------------*/
      fseek(file_ptr, 0, SEEK_END);
      size = ftell(file_ptr);
      fclose(file_ptr);
      if (size < 0)
	 file_sizes[i] = -1;
      else
	 file_sizes[i] = size;
      }
   }
}
 
