/*******************************************************************************
Purpose:
    This routine frees all WVS line data structures.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  1.0           06/94   T. Rockvam        CSB       Similar to dcw_free
 
PROJECT:  LAS
*******************************************************************************/
#include "las.h"
#include "wvs.h"

int c_wvsfree
(
    struct WVS_VECTOR *wvs_vector  /* WVS coverage structure to be freed */
)
{
long	i;			/* loop counter */

/*
  Free points for each line
*/
for (i = 0; i < wvs_vector->numlines; i++)
    free(wvs_vector->line[i].pts);

/*
  Free line structures
*/
free(wvs_vector->line);
wvs_vector->line = NULL;

return(E_SUCC);
}
