/******************************************************************************
NAME:		C_HDROPEN

PURPOSE: 	Open the associated archive HEADER file with the
                specified file access

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  5.0	 D. Hollaren   02/92	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/file.h>
#include <stdio.h>
#include "worgen.h"
#include "tae.h"

int c_hdropen
(
int	*fd,		/* File descriptor to acquire image	*/
char	*file,		/* Acquisition file name		*/
long	*access 	/* Type of file access			*/
)
{
long	flag,		/* Access flag for open			*/
	nonfatal = 1;	/* Non-fatal error code			*/

/*
  Setup the type of access to open the file with
*/
if (*access == IREAD)
    flag = O_RDONLY;
else if (*access == IWRITE)
    flag = (O_WRONLY | O_CREAT);
else
    flag = (O_RDWR | O_CREAT);

*fd = open(file,flag,0664);

if (*fd < 0)
    {   
    c_errmsg("Error opening the associated archive header file",
	     "hdropen-open",&nonfatal);
    return(E_FAIL);
    }

return(E_SUCC);
}
 
