/*******************************************************************************
FUNCTION: c_freegrid

PURPOSE:  Free all of the dynamically allocated memory from a geometric mapping
	  grid structure.  See grid.h for details on a grid.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          03/92  Development

PROJECT:  ADAPS
*******************************************************************************/
#include "las.h"
#include "grid.h"


int c_freegrid
(
    struct GRID *grid   /* IN/OUT - Grid to have it's memory freed            */
)
{
long i;                 /* Loop control                                       */

if (grid->coeffs != NULL)
   {
   free(grid->coeffs);
   grid->coeffs = NULL;
   }
if (grid->out_lines != NULL)
   {
   free(grid->out_lines);
   grid->out_lines = NULL;
   }
if (grid->out_samps != NULL)
   {
   free(grid->out_samps);
   grid->out_samps = NULL;
   }
for (i = 0; i < grid->nvalues; i++)
   {
   free(grid->values[i]);
   grid->values[i] = NULL;
   }
return(E_SUCC);
}
