/*******************************************************************************
FUNCTION:	c_zerogrid

PURPOSE:	Initialize all of the memory in a geometric mapping grid
		structure.  This is NOT setting any of the fields to valid
		values but is simply setting them to zero to ensure there are
		no uninitialized memory accesses.  See grid.h for details on a
		grid.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          08/95  Development

PROJECT:  ADAPS
*******************************************************************************/
#include "las.h"
#include "grid.h"


int c_zerogrid
(
    struct GRID *grid   /* IN/OUT - Grid to be initialized                    */
)
{
long i;                 /* Loop control                                       */

strcpy(grid->gridname, "");
for (i=0; i<MAXGRIDVALS; i++)
    strcpy(grid->labels[i], "");
strcpy(grid->model, "");
strcpy(grid->units, "");

for (i=0; i<32; i++)
    grid->act_grid_err[i] = 0.0;
for (i=0; i<2; i++)
    grid->ave_fit_err[i] = 0.0;
for (i=0; i<2; i++)
    grid->ave_grid_err[i] = 0.0;
grid->coeffs = NULL;
for (i=0; i<8; i++)
    grid->corners[i] = 0.0;
grid->grid_tol = 0.0;
for (i=0; i<2; i++)
    grid->max_fit_err[i] = 0.0;
for (i=0; i<2; i++)
    grid->max_grid_err[i] = 0.0;
for (i=0; i<2; i++)
    grid->pdist[i] = 0.0;
for (i=0; i<15; i++)
    grid->projprms[i] = 0.0;
grid->rms_fit_err = 0.0;
grid->rms_grid_err = 0.0;

grid->code = 0;
grid->datum = 0;
grid->dtype = 0;
grid->fiterr_valid = 0;
grid->griderr_valid = 0;
grid->lines = 0;
grid->ncoeff = 0;
grid->ncols = 0;
grid->nrows = 0;
grid->nvalues = 0;
grid->out_lines = NULL;
grid->out_samps = NULL;
grid->proj_valid = 0;
grid->samples = 0;
grid->satnum = 0;
grid->zone = 0;
for (i=0; i<MAXGRIDVALS; i++)
    grid->values[i] = NULL;

return(E_SUCC);
}
