/*******************************************************************************
FUNCTION:	L1B_LOAD_CHAN

PURPOSE:	Check the channels to be read.
		Data acquired from the header records is considered.

Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  1.0    10/97  T.Baltzer        Development

PROJECT:	ADAPS
*******************************************************************************/
#include "las.h"
#include "adaps.h"
#include "level1bio.h"



void l1b_load_chan
(
    long *totchdsh,	/* Total number of bands according to the DSH         */
    struct MODEL *model /* AVHRR model information			      */
)

{

long	i; 		/* counter				*/


/* 
  If no TBM header record was in the file, then one is not sure
  which channels are in the file.  So: If totchdsh equals MOSTBND
  then all five bands are in the file.  Update the model accordingly.
  If totchdsh is less than MOSTBND, do not set the channels in the
  model, only the number of channels (we don't know which ones).
*/
   if (*totchdsh == MOSTBND)
      {
      c_lasmsg(FALSE,"c_l1bsup-notbma","NO TBM header record");
      c_lasmsg(FALSE,"c_l1bsup-notbma","All %d channels assumed to be present",
	       *totchdsh);
      for (i = 0; i < MOSTBND; i++)
	 {
	 model->chans[i] = i+1;
	 }
      model->nchans = MOSTBND;
      }
   else
      {
      c_lasmsg(FALSE,"c_l1bsup-notbmb","NO TBM header record");
      c_lasmsg(FALSE,"c_l1bsup-notbmb","%d channels assumed to be present",
	       *totchdsh);
      for (i = 0; i < MOSTBND; i++)
         {
	 model->chans[i] = FALSE;
         }
      model->nchans = *totchdsh;
      }


return;
}
