.SUFFIXES: .pdf .html


#----------------------------------------------------------------------------
# Set up the compiler options.  Define INC to be the include files that are
# part of this application only.  Do not list include files from ADAPSINCLUDE
# or LASINCLUDE.
#----------------------------------------------------------------------------
OPTS    = $(CFLAGS) -I$(ADAPSINCLUDE) -I$(LASINCLUDE) -I$(TAEINC)
INC	= 


#-------------------------------------------------------
# Define the executable(s), the pdf(s), and the html(s).
#-------------------------------------------------------
EXECS   = test
HTMLS	= test.html
PDFS    = $(HTMLS:.html=.pdf) test_.pdf


#---------------------------------------------------------
# Define the source code object files for each executable.
#---------------------------------------------------------
SRC	= \
	getpar.c \
	test.c
OBJ	= $(SRC:.c=.o)


#--------------------------------------------------------
# Standard list of object libraries.  Delete those that
# are not necessary and add additional ones if necessary.
#--------------------------------------------------------
OBJLIB  = \
	$(ADAPSLIB)/l1bio.a \
	$(ADAPSLIB)/adaps.a \
	$(ADAPSLIB)/archio.a \
	$(ADAPSLIB)/acqio.a \
	$(ADAPSLIB)/model.a \
	$(ADAPSLIB)/util.a \
	$(TPLIB) \
	$(LASLIB)/las.a \
	$(LASLIB)/world.a \
	$(LASLIB)/tae.a \
	$(TAELIB)/clib.a \
	$(TAELIB)/lib.a


#------------------------------------------------------------------------------
# Targets for each executable.  You should have two targets for each executable
# that is created.  One to create the executable and one to load it into the
# CenterLine debugger.
#------------------------------------------------------------------------------
all: $(EXECS) $(HTMLS)

test: $(OBJ) $(OBJLIB) $(INC)
	$(CC) $(OPTS) -o test $(OBJ) $(OBJLIB) $(TRLIB) -lm

xcenter:
	#load $(OPTS) $(SRC) $(OBJLIB) $(INC) $(TRLIB) -lm
	#link
codecenter_obj:
	#load $(OPTS) $(OBJECTS) $(OBJLIB) $(TRLIB) -lm #link

codecenter_src:
	#load $(OPTS) $(SOURCE) $(OBJLIB) $(TRLIB) -lm #link



#--------------------------------------------------
# Target to distribute the executable(s) and pdf(s)
#--------------------------------------------------
las: $(EXECS)
	cp $(PDFS) $(DSTDIR)
	mv $(EXECS) $(DSTDIR)


#-----------------------------------------------------------------------------
# Rules for compiling the object files.  If you have multiple groups of object
# files, add one dependency of the form "$(OBJS): $(INC)" for each group of
# object files.
#-----------------------------------------------------------------------------
$(OBJ): $(INC)

.c.o:
	$(CC) $(OPTS) -c $<


#------------------------------
# Make all of the documentation
#------------------------------
doc: $(HTMLS)
	mv $(HTMLS) $(DSTDIR)

.pdf.html:
	pdfhtml $*


#--------------------------------------
# Clean up objects and other misc files
#--------------------------------------
clean:
	/bin/rm -f $(EXECS) $(HTMLS) core make.log
	/bin/rm -f *.o *.a
