/****************************************************************************
NAME:		ANGLEBETWN

PURPOSE:	Calculate the angle between two vectors


PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

******************************************************************************/
#include <math.h>
#include "worgen.h"
#include "vector.h"
#include "model.h"
#include "local_protos.h"

void anglebetwn
(
    struct MVECTOR *vec1,	/* Input vector one			     */
    struct MVECTOR *vec2,	/* Input vector two			     */
    double *angle		/* Angle between the specified vectors	     */
)

{
/*
  Calculate the angle between the specified vectors
*/
*angle = acos(dot(vec1,vec2) / (norm(vec1) * norm(vec2)));

return;
}
 
