/****************************************************************************
NAME:		CALCDTIME

PURPOSE:	Calculate the delta time past the center of pass

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "constants.h"

void calcdtime
(
    double *dma,		/* Delta mean anomaly		     */
    double *mdot1,		/* Mean motion before center	     */
    double *mdot2,		/* Mean motion after center	     */
    double *dtime		/* Delta time			     */
)
{
if (*dtime <= 0.0)
    *dtime = *dma / *mdot1;
else
    *dtime = *dma / *mdot2;

return;
}
 
