/****************************************************************************
NAME:		CALCLINE

PURPOSE:	Calculate line location

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "constants.h"
#include "avhrr.h"

void calcline
(
    double *Time,	/* Time to calculate the line at 	     */
    double *offline,	/* Window offset			     */
    double *midline,	/* Line at the middle the of pass	     */
    long *dtype,	/* Type of data (HRPT, LAC, GAC)	     */
    long *zdot,		/* Direction of the pass (-1) Asc (1) Desc   */
    double *line	/* Calculated line			     */
)
{

if (*dtype == GAC)
    *line = *offline + *midline + (-*zdot * *Time) * GAC_PER_SEC;
else
    *line = *offline + *midline + (-*zdot * *Time) * LAC_PER_SEC;

return;
}
 
