/****************************************************************************
NAME:		CALCPITCH

PURPOSE:	Calculate pitch angle as a function of time

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"

void calcpitch
(
    double *Time,		/* Time to calculate the pitch at	    */
    double pitch_coefs[],	/* Pitch coefficients			    */
    double *pitch		/* Pitch at the specified time		    */
)
{
/*
  Use the coefficients to calculate a pitch for the specified time
*/
*pitch = pitch_coefs[0] + 
         pitch_coefs[1] * *Time + 
         pitch_coefs[2] * *Time * *Time + 
         pitch_coefs[3] * *Time * *Time * *Time +
         pitch_coefs[4] * *Time * *Time * *Time * *Time;

return;
} 
 
