/****************************************************************************
NAME:		CALCROLL

PURPOSE:	Calculate roll angle as a function of time


PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"

void calcroll
(
    double *Time,		/* Time to calculate the roll for	    */
    double roll_coefs[],	/* Roll coefficients			    */
    double *roll		/* Roll at the specified time		    */
)
{
/*
  Use the coefficients to calculate a roll
*/
*roll = roll_coefs[0] + 
	roll_coefs[1] * *Time + 
	roll_coefs[2] * *Time * *Time + 
	roll_coefs[3] * *Time * *Time * *Time +
	roll_coefs[4] * *Time * *Time * *Time * *Time;

return;
} 
 
