/****************************************************************************
NAME:		CALCYAW

PURPOSE:	Calculate the yaw as a function of time

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "avhrr.h"

void calcyaw
(
    double *Time,	/* Time to calculate the yaw at			     */
    double yaw_coefs[],	/* Coefficients for yaw calculations		     */
    double *yaw		/* Yaw at the specified time			     */
)
{
/*
  Use the coefficients to calculate the yaw at the specified time
*/
*yaw =  MOYAW + yaw_coefs[0] + 
		yaw_coefs[1] * *Time + 
		yaw_coefs[2] * *Time * *Time + 
		yaw_coefs[3] * *Time * *Time * *Time +
		yaw_coefs[4] * *Time * *Time * *Time * *Time;

return;
} 
 
