/****************************************************************************
NAME:		CROSS

PURPOSE:	Cross product of two vectors


PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include "worgen.h"
#include "vector.h"

void cross
(
    struct MVECTOR *vec1,	/* Input vector one			     */
    struct MVECTOR *vec2,	/* Input vector two			     */
    struct MVECTOR *vec3	/* Output vector cross product		     */
)
{

vec3->x = vec1->y * vec2->z - vec1->z * vec2->y; 
vec3->y = vec1->z * vec2->x - vec1->x * vec2->z;
vec3->z = vec1->x * vec2->y - vec1->y * vec2->x;
      
return;
}
 
