/****************************************************************************
NAME:		DKEPLR

PURPOSE:	Find the true anomaly given the mean anomaly

PROGRAM HISTORY:
VERSION         PROGRAMMER           DATE       COMMENTS
-------         ----------           ----       --------
 2.0            C. Wivell            2/91	Original development

COMPUTER SOFTWARE OR HARDWARE LIMITATIONS:

PROJECT:             ADAPS

ALGORITHM DESCRIPTION:

ALGORITHM REFERENCES:

******************************************************************************/
#include <math.h>
#include "worgen.h"
#include "constants.h"

void dkeplr
(
    double m,		/* Mean anomaly			*/
    double e,		/* Eccentricity			*/
    double *ea		/* True anomaly			*/
)
{
double	gea,
	ep;

/*
  Solve kepler's equation
*/
gea = m;
do
    {
    *ea = m + e * sin(gea);
    ep = e * cos(gea) - 1.0;
    gea = gea + (gea - *ea) / ep;
    }
    while (fabs(*ea - gea) >= 0.000001);

*ea = fmod(gea,PIE2);

return;
}
 
