/****************************************************************************
NAME:		FINDLOS

PURPOSE:	Find the Line of sight vector

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "vector.h"
#include "model.h"
#include "local_protos.h"

void findlos
(
    struct ATTITUDE *att,/* Attitude correction vectors information  */
    double *scan_angle,	 /* Scan angle				     */
    struct MVECTOR *losv /* Line of sight vector		     */
)
{
double	maglos = 1.0;	 /* Magnitude of the unit LOS			     */

/*
  Calculate the new vector in the same plane as the position of the
  satellite and angular momentum
*/
newvec(&att->posvec,&att->angvec,0,scan_angle,&maglos,losv);

return;
}
 
