/****************************************************************************
NAME:		FINDSAMPLE

PURPOSE:	Find the sample location


PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "avhrr.h"
#include "constants.h"

void findsample
(
    double scan_angle,	/* Scan angle to the sample			     */
    double offsample,	/* Window sample offset				     */
    long dtype,		/* Type of data (HRPT, LAC, or GAC)		     */
    long zdot,		/* Direction of the pass (-1) Asc (1) Desc	     */
    double *sample	/* Output sample				     */
)
{

/*
  Calculate the sample
*/
if (dtype == GAC)
    *sample = scan_angle * -zdot * GAC_SAMPLE_SLOPE + offsample + GAC_NADIR;
else
    *sample = scan_angle * -zdot * LAC_SAMPLE_SLOPE + offsample + LAC_NADIR;

return;
}
 
