/****************************************************************************
NAME:		FINDSCANANGLE

PURPOSE:	Find the scan angle


PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "avhrr.h"
#include "constants.h"

void findscanangle
(
    double *sample,	/* Input sample					     */
    double *offsample,	/* Window sample offset				     */
    long *dtype,	/* Type of data (HRPT, LAC, or GAC)		     */
    long *zdot,		/* Direction of the pass (-1) Asc (1) Desc	     */
    double *scan_angle	/* Output scan angle for the sample		     */
)
{

/*
  Calculate the scan angle at the given sample
*/
if (*dtype == GAC)
    *scan_angle = -*zdot * (*sample - *offsample - GAC_NADIR)/GAC_SAMPLE_SLOPE;
else
    *scan_angle = -*zdot * (*sample - *offsample - LAC_NADIR)/LAC_SAMPLE_SLOPE;

if (*sample < -118)
    *scan_angle -= .0005;

if (*sample > 2166)
    *scan_angle += .0005;

return;
}
 
