/****************************************************************************
NAME:		FINDTIME

PURPOSE:	Find the time for a given line


PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "avhrr.h"

void findtime
(
    double *line,	/* Line to calculate time for			     */
    double *offline,	/* Offset line for windowing			     */
    double *midline,	/* line at middle of the pass			     */
    long *dtype,	/* Type of data (GAC, LAC, or HRPT)		     */
    long *zdot,		/* Direction of the pass at the center		     */
    double *Time	/* Time of the specified line			     */
)
{

if (*dtype == GAC)
    *Time = (*line - *offline - *midline) / (GAC_PER_SEC * -*zdot);
else
    *Time = (*line - *offline - *midline) / (LAC_PER_SEC * -*zdot);

return;
}
 
