/****************************************************************************
NAME:		GREATCIRCLE

PURPOSE:	Calculate the great circle earth central angle between
		to points on the surface of the earth.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"

void greatcircle
(
    double *lat1, 	/* Latitude  of first point  (rads)     */
    double *long1,	/* Longitude of first point  (rads)     */
    double *lat2, 	/* Latitude  of second point (rads)     */
    double *long2,	/* Longitude of second point (rads)     */
    double *eca 	/* Earth Centeral Angle	     (rads)     */
)
{

*eca = acos(sin(*lat1) * sin(*lat2) + cos(*lat1) * cos(*lat2) *
	    cos(*long2 - *long1));

return;
}
 
