/****************************************************************************
NAME:		SPH2CART

PURPOSE:	Convert spherical coordinates to cartesian coordinates

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  3.0    C. Wivell     11/92	Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include <math.h>
#include "worgen.h"
#include "vector.h"

void sph2cart
(
    double *latp,	/* Latitude					     */
    double *longp,	/* Longitude					     */
    double *radius,	/* Distance from the origin to the point	     */
    struct MVECTOR *vec	/* Vector containing the cartesian coordinates	     */
)
{
double	rcoslt;		/* Radius times cosine of the latitude constant      */

/*
  Calculate a constant to speed up calculations
*/
rcoslt = *radius * cos(*latp);

/*
  Calculate the cartesian coordinates for the vector
*/
vec->x = rcoslt * cos(*longp);
vec->y = rcoslt * sin(*longp);
vec->z = *radius * sin(*latp);

return;
}
 
