/*******************************************************************************
FUNCTION: c_qdestroy()

PURPOSE:  Given the number of a queue, free all of the space allocated for this
	  queue.  Return 0 if successful, otherwise -1.


Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          08/92  Development

*******************************************************************************/
#include <stdlib.h>
#include "queue.h"

extern struct QNODE *queue[MAXQUEUES];   /* Ptr to dummy header of all Q's    */
extern struct QNODE *last_pos[MAXQUEUES];/* Ptr to last accessed position     */
extern short qduplicates[MAXQUEUES];     /* Flags indicating if Qs allow dups */
extern short qorder[MAXQUEUES];          /* Flags indicating Q orders         */
extern long  nobjects[MAXQUEUES];        /* Number of objects in the queues   */
extern long  nqueues;                    /* Number of current Q's in use      */

long c_qdestroy
(
    long q              /* IN - Number of the queue to be destroyed           */
)
{
struct QNODE *qptr;     /* Ptr to a new qnode                                 */


/* Ensure q points to something
-------------------------------*/
if ((nqueues < 1) || (nobjects[q] == -1))
   return(-1);


/* Walk through the queue freeing all nodes and objects
-------------------------------------------------------*/
qptr = queue[q]->next;
while (qptr != queue[q])
   {
   free(qptr->obj);
   qptr = qptr->next;
   free(qptr->prev);
   }
free(qptr); /* frees the dummy header */


/* Reset all of the globals for this queue
------------------------------------------*/
queue[q]    = NULL;
last_pos[q] = NULL;
nobjects[q] = -1;
nqueues--;
return(0);
}
 
