/*******************************************************************************
FUNCTION: c_qfirst()

PURPOSE:  Given the number of a queue and a pointer to a pointer, return a
	  pointer to the first object in the queue.  If the queue is not empty
	  then return a pointer to the first object in the queue and 0.  If the
	  queue is empty then return NULL and 0, otherwise return NULL and -1 to
	  indicate an error.


Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          08/92  Development

*******************************************************************************/
#include "queue.h"

extern struct QNODE *queue[MAXQUEUES];   /* Ptr to dummy header of all Q's    */
extern struct QNODE *last_pos[MAXQUEUES];/* Ptr to last accessed position     */
extern short qduplicates[MAXQUEUES];     /* Flags indicating if Qs allow dups */
extern short qorder[MAXQUEUES];          /* Flags indicating Q orders         */
extern long  nobjects[MAXQUEUES];        /* Number of objects in the queues   */
extern long  nqueues;                    /* Number of current Q's in use      */

long c_qfirst
(
    long q,             /* IN  - Number of the queue to retrieve from         */
    void **ptr          /* OUT - Ptr to the first object in the queue         */
)
{
/* Initialize ptr
-----------------*/
*ptr = NULL;


/* Ensure q points to something
-------------------------------*/
if ((nqueues < 1) || (nobjects[q] == -1))
   return(-1);


/* If the queue is empty return 0
---------------------------------*/
if (nobjects[q] == 0)
   return(0);


/* Return the first object in the queue
---------------------------------------*/
last_pos[q] = queue[q]->next;
*ptr        = queue[q]->next->obj;
return(0);
}
 
