/*******************************************************************************
FUNCTION: c_qposition()

PURPOSE:  Given the number of a queue return a pointer to the object in the
	  specified position.  Return a pointer to the object in the specified
	  position and 0 or NULL and -1 if the specified position does not
	  exist.


Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          08/92  Development

*******************************************************************************/
#include "queue.h"

extern struct QNODE *queue[MAXQUEUES];   /* Ptr to dummy header of all Q's    */
extern struct QNODE *last_pos[MAXQUEUES];/* Ptr to last accessed position     */
extern short qduplicates[MAXQUEUES];     /* Flags indicating if Qs allow dups */
extern short qorder[MAXQUEUES];          /* Flags indicating Q orders         */
extern long  nobjects[MAXQUEUES];        /* Number of objects in the queues   */
extern long  nqueues;                    /* Number of current Q's in use      */

long c_qposition
(
    long q,             /* IN  - Number of the queue                          */
    long pos,           /* IN  - Position of interest                         */
    void **ptr          /* OUT - Ptr to the next object in the queue          */
)
{
/* Initialize ptr
-----------------*/
*ptr = NULL;


/* Ensure q points to something and there are the specified number of positions
------------------------------------------------------------------------------*/
if ((nqueues < 1) || (nobjects[q] < pos) || (pos == 0))
   return(-1);


/* Advance along the queue to the specified position
----------------------------------------------------*/
last_pos[q] = queue[q];
while (pos--)
   last_pos[q] = last_pos[q]->next;


/* Return a ptr to the specified object
---------------------------------------*/
*ptr = last_pos[q]->obj;
return(0);
}
 
