/*******************************************************************************
FUNCTION: c_qprint()

PURPOSE:  Given the number of a queue and a function to print one object, print
	  print every element in the queue.  Return 0 if successful, -1
	  otherwise.


Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          08/92  Development

*******************************************************************************/
#include "queue.h"

extern struct QNODE *queue[MAXQUEUES];   /* Ptr to dummy header of all Q's    */
extern struct QNODE *last_pos[MAXQUEUES];/* Ptr to last accessed position     */
extern short qduplicates[MAXQUEUES];     /* Flags indicating if Qs allow dups */
extern short qorder[MAXQUEUES];          /* Flags indicating Q orders         */
extern long  nobjects[MAXQUEUES];        /* Number of objects in the queues   */
extern long  nqueues;                    /* Number of current Q's in use      */

long c_qprint
(
    long q,		    /* IN - Number of the queue to print              */
    void (print_obj)()      /* IN - Function to print an object in the queue  */
)
{
long i;                 /* Counter                                            */
struct QNODE *qptr;     /* Temporary ptr to a queue node                      */


/* Ensure q points to something
-------------------------------*/
if ((nqueues < 1) || (nobjects[q] == -1))
   return(-1);


/* Print a message
------------------*/
if (nobjects[q] == 0)
   printf("\nQueue is empty\n");
else if (nobjects[q] == 1)
   printf("\nQueue contains 1 object:\n");
else
   printf("\nQueue contains %1d objects:\n", nobjects[q]);


/* Walk through the queue
-------------------------*/
i = 1;
qptr = queue[q]->next;
while (qptr != queue[q])
   {
   printf("   Node %6d:", i++);
   print_obj(qptr->obj);
   qptr = qptr->next;
   }
return(0);
}
 
