/*******************************************************************************
NAME:		C_CVTIME

PURPOSE:	Convert a time in total seconds to hours, minutes,
		seconds and fractional seconds.

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		CODE/CONT   REASON
-------		----	------		---------   ------
  2.0		2/91	D. Hollaren	   CSB      Conversion to LAS5.0

ALGORITHM DESCRIPTION:

ALGORITHM REFERENCE:
*******************************************************************************/
#include "worgen.h"
#include "avhrr.h"
#include "adapsutil.h"

void c_cvtime
(
    long *tsec,		/* Total seconds		*/
    long *hour,		/* Hours			*/
    long *min,		/* Minutes			*/
    long *sec		/* Seconds			*/
)
{

*tsec = *hour * 3600 + *min * 60 + *sec;

return;
}

/*******************************************************************************
NAME:		C_CVTSEC

PURPOSE:	Convert a time in total seconds to
		hours, minutes, and seconds

*******************************************************************************/
void c_cvtsec
(
    long *tsec,		/* Total seconds		*/
    long *hour,		/* Hours			*/
    long *min,		/* Minutes			*/
    long *sec,		/* Seconds			*/
    long *fsec		/* Fractional seconds		*/
)
{

*hour = *tsec / 3600;
*min =  (*tsec % 3600) / 60;
*sec = *tsec % 60;


return;
}

/*******************************************************************************
NAME:		C_CVTMIL

PURPOSE:	Convert a time in total seconds to
		hours, minutes, and seconds
*******************************************************************************/

void c_cvtmil
(
    long *milsec,	/* Total milliseconds		*/
    long *hour,		/* Hours			*/
    long *min,		/* Minutes			*/
    long *sec,		/* Seconds			*/
    long *fsec		/* Fractional seconds		*/
)
{

*hour = *milsec / MIL_PER_HOUR;
*min = (*milsec % MIL_PER_HOUR) / MIL_PER_MIN;
*sec = (*milsec % MIL_PER_MIN) / MIL_PER_SEC;
*fsec = *milsec % MIL_PER_SEC;

return;
}
 
