
static void byt_byt
(
    unsigned char *in,		/* Input buffer				*/
    unsigned char *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void byt_wrd
(
    unsigned char *in,		/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void byt_uwrd
(
    unsigned char *in,		/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void byt_lng
(
    unsigned char *in,		/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void byt_ulng
(
    unsigned char *in,		/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void byt_flt
(
    unsigned char *in,		/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void byt_dbl
(
    unsigned char *in,		/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void wrd_byt
(
    short *in,			/* Input buffer				*/
    unsigned char *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void wrd_wrd
(
    short *in,			/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void wrd_uwrd
(
    short *in,			/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void wrd_lng
(
    short *in,			/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void wrd_ulng
(
    short *in,			/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void wrd_flt
(
    short *in,			/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void wrd_dbl
(
    short *in,			/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void uwrd_byt
(
    unsigned short *in,		/* Input buffer				*/
    unsigned char *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void uwrd_wrd
(
    unsigned short *in,		/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void uwrd_uwrd
(
    unsigned short *in,		/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void uwrd_lng
(
    unsigned short *in,		/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void uwrd_ulng
(
    unsigned short *in,		/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void uwrd_flt
(
    unsigned short *in,		/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void uwrd_dbl
(
    unsigned short *in,		/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void lng_byt
(
    long *in,			/* Input buffer				*/
    unsigned char *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void lng_wrd
(
    long *in,			/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void lng_uwrd
(
    long *in,			/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void lng_lng
(
    long *in,			/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void lng_ulng
(
    long *in,			/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void lng_flt
(
    long *in,			/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void lng_dbl
(
    long *in,			/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void ulng_byt
(
    unsigned long *in,		/* Input buffer				*/
    unsigned char *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void ulng_wrd
(
    unsigned long *in,		/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void ulng_uwrd
(
    unsigned long *in,		/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void ulng_lng
(
    unsigned long *in,		/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void ulng_ulng
(
    unsigned long *in,		/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void ulng_flt
(
    unsigned long *in,		/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void ulng_dbl
(
    unsigned long *in,		/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void flt_byt
(
    float *in,			/* Input buffer				*/
    unsigned char *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void flt_wrd
(
    float *in,			/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void flt_uwrd
(
    float *in,			/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void flt_lng
(
    float *in,			/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void flt_ulng
(
    float *in,			/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void flt_flt
(
    float *in,			/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void flt_dbl
(
    float *in,			/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void dbl_byt
(
    double *in,			/* Input buffer			*/
    unsigned char *out,		/* Output buffer		*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void dbl_wrd
(
    double *in,			/* Input buffer				*/
    short *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void dbl_uwrd
(
    double *in,			/* Input buffer				*/
    unsigned short *out,	/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void dbl_lng
(
    double *in,			/* Input buffer				*/
    long *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void dbl_ulng
(
    double *in,			/* Input buffer				*/
    unsigned long *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset,		/* Output scale and offset values	*/
    double rnd			/* Rounding value			*/
);

static void dbl_flt
(
    double *in,			/* Input buffer				*/
    float *out,			/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    long *flag,			/* Bounds status flag			*/
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

static void dbl_dbl
(
    double *in,			/* Input buffer				*/
    double *out,		/* Output buffer			*/
    long ns,			/* Number of sample in the buffers      */
    double iscale,
    double ioffset,		/* Input scale and offset values	*/
    double oscale,
    double ooffset		/* Output scale and offset values	*/
);

