/*****************************************************************************
NAME		LS2LL

PURPOSE		Calculate projection coordinates of given line/sample
		coordinates

VERSION    PROGRAMMER	   DATE
-------    ----------      ----
  2.0	   D. Hollaren	   11/93		Original development

*****************************************************************************/
#include "las.h"
#include "correct.h"

FUNCTION ls2ll(proj,line,samp,lat,lng)

struct PROJ *proj;	/* Projection information		*/

long	line,		/* Input line 				*/
	samp;		/* Input sample				*/

double	*lat,		/* Latitude				*/
	*lng;		/* Longitude 				*/
{
long	status,		/* Return status			*/
	fatal = -1;	/* Fatal error flag			*/

double	projx,          /* X projection coordinate.             */
        projy;          /* Y projection coordinate.             */

/*
  Calculate the projection coordinates
*/
projy = proj->coefs[0] * line + proj->coefs[1] * samp + proj->coefs[2];
projx = proj->coefs[3] * line + proj->coefs[4] * samp + proj->coefs[5];

/*
  Calculate the output latitude/longitude from the projection coordinates
*/
status = c_trans(&proj->inproj,&proj->inunit, &proj->oproj,&proj->ounit,
		&projx,&projy,lng,lat);
return(status);
}
