
/* copy2.h:  proc header file */ 
#include "image.h"  /* for data structures, function prototypes */ 





/* data structure for most user parms, other parms are acquired in openrin() */ 
   struct UPARMS 
   {
      char  hostouti[CMLEN], /* host name of output image */ 
            hostlog [CMLEN], /* host name for logfile */ 
	    inimage[10*140], /* name of input image;  10 for count=1:10, 132(+8) 
	                        for type=(string 132) and some spaces between
				values for in */ 
           *scalopt,         /* scale option used to process avhrr data */ 
	    taeouti [CMLEN], /* tae name of output image */ 
           *taelog;          /* tae name for logfile */ 
      float maskval[50];     /* mask values to apply to image, count_mask()
                                assumes this is a float */ 
      long cband,            /* image band to check for too much masked data */
	   makelog,          /* flag, is a value specified for parm logfile */ 
	   maxmask,          /* max percentage of masked data */ 
	   nmasks;           /* number of values in maskval[] */ 
   }; 





/* global vars, must be global for las image IO.  If this list of images is 
   changed, revise errclean() in image.c to close and delete the appropriate 
   images in cases of fatal errors */ 
#ifdef GLOBALVARS
   struct lasinimage  inimage;  /* input image */ 
   struct lasoutimage outimage; /* output image */ 
   struct PARBLK pblock;        /* tae parameter block */ 
#else 
   extern struct lasinimage  inimage;  
   extern struct lasoutimage outimage; 
   extern struct PARBLK pblock; 
#endif 





/* global vars, declared global for convenience */ 
#ifdef GLOBALVARS
   char message[CMLEN],  /* error message, parm to c_errmsg()*/
        procname[30],    /* name of las proc */ 
        procfatal[40],   /* name of las proc and "-fatal" */
        procwarn[40];    /* name of las proc and "-warn" */
   long fatal= -1,       /* fatal error, parm to c_errmsg() */ 
        go_on=  1;       /* warning message, informational, parm to c_errmsg()*/
#else 
   extern char message[CMLEN], procname[30], procfatal[40], procwarn[40];
   extern long fatal, go_on; 
#endif 





/*function prototypes. ifdef allows for compilers that don't allow prototypes*/
#ifdef __DGUX__
   /* copy2.c takes care of copy2.c */ 
   /* image.h takes care of image.c */ 
   /* process.c */ 
      double copy_image (struct UPARMS *uparms, struct lasinimage  *ini, 
	     struct lasoutimage *outi); 
      long count_mask (struct UPARMS *uparms, struct lasoutimage *outi); 
#else 
   /* process.c */ 
      double copy_image (); 
      long count_mask (); 
#endif  




