
/* process.c:  functions to process the images */ 
#include "copy2.h" /* proc header file */ 





/* FUNCTION:  create disk image, using random IO, return the total number of 
   mask pixels in one image band */ 
double copy_image (uparms, ini, outi)
   struct UPARMS *uparms;      /* input:  user parms.  needed for cband,
					  maskval, nmasks */ 
   struct lasinimage  *ini;    /* input:  specs for input image */ 
   struct lasoutimage *outi;   /* input:  specs for output image */ 
{
/* declare vars */ 
   double totmask = 0.0;       /* total number of mask pixels.  declared double 
				  not long to prevent overflowing data type */
   long band,                  /* for loop index:  image band */ 
        line,                  /* for loop index:  image line */ 
        messform=ONECAT,       /* output message format, arg to c_startm() */ 
        msgtim;                /* tae global $msgtim */ 
   struct VARIABLE *tparm;     /* points to a tae parm in pblock */ 
   extern long curcat,         /* current category, for processing message */ 
	       curent;         /* current entity, for processing message */ 
/* initialize and start processing line message */ 
   tparm = p_find (&pblock, "$msgtim");    
   msgtim = IVAL(*tparm, 0); 
   c_inittm (procname, "Processed", "line", "bands", "", &outi->nl,
    &outi->totalbands, &msgtim, &messform); 
   c_startm (); 
/* process image */ 
   for (curcat=1, band=0; band<outi->totalbands; band++, curcat++)
      for (curent=line=0; line<outi->nl; line++, curent++)   
      {
      /* read data */ 
	 rread (line, band, ini); 
      /* copy/convert data */ 
	 convertr (ini, outi);  
      /* update count of mask pixels */ 
	 if (band == uparms->cband)
	    totmask += (double) count_mask (uparms, outi); 
      /* update minmax data */ 
	 minmaxr (band, outi); 
      /* write data */ 
	 rwrite (line, band, outi); 
      }
c_stoptm(); 
return (totmask); 
}







/* FUNCTION:  return the number of mask pixels in a line of data */ 
long count_mask (uparms, outi)
   struct UPARMS *uparms;     /* input:  user parms, needed for maskval, 
					 nmasks */ 
   struct lasoutimage *outi;  /* input:  structure of image descriptors */ 
{
/* declare vars */ 
   float pixval;          /* the value of a pixel */ 
   long dataval,          /* for loop index, data value */ 
        nmask,            /* output:  # of mask pixels in one line of data */
	sample;           /* for loop index:  image sample */ 
   unsigned char *outbuf; /* points to a pixel in outi->buffer */ 
/* process */ 
   for (nmask=sample=0, outbuf=outi->buffer;  sample<outi->ns;  sample++,
   outbuf+= outi->dsizeproc)
   {
   /* get pixel value */ 
      switch (outi->dtypeproc)
      {
	 case EBYTE: pixval = *          outbuf;  break;
	 case EWORD: pixval = *(short *) outbuf;  break;
	 case ELONG: pixval = *(long  *) outbuf;  break;
	 case EREAL: pixval = *(float *) outbuf;  break;
	 default:  c_errmsg("Program error:  unknown image data type.", 
		   procfatal, &fatal);
      }
   /* optionally increment nmask */ 
      for (dataval=0; dataval<uparms->nmasks; dataval++)
	 if (uparms->maskval[dataval] == pixval)
	    nmask++;
   }
return (nmask); 
}



