
/* delscene.h:  proc header file */ 
#include "image.h"  /* for data structures, function prototypes */ 





/* a data structure for user parms */ 
   struct UPARMS
   {
      long dateband,    /* image band with date indices */ 
	   dateup,      /* flag, should the date band be updated */ 
	   dcount,      /* number of values in dvalue[] */ 
	   maskval,     /* mask value to assign to image */ 
	   sepdate,     /* flag, is there a separate date band image */ 
	   sepup,       /* flag, T if (sepdate && dateup) */ 
	   dvalue[50];  /* values of date band to delete from image */ 
   }; 





/* global vars, must be global for las image IO */ 
#ifdef GLOBALVARS
   struct lasinimage compimg,  /* input composite image */ 
                     dateimg;  /* input date image */ 
   struct PARBLK pblock;       /* tae parameter block */ 
#else 
   extern struct lasinimage compimg, dateimg;  
   extern struct PARBLK pblock; 
#endif 





/* global vars, declared global for convenience */ 
#ifdef GLOBALVARS
   char message[CMLEN],  /* error message, parm to c_errmsg()*/
        procname[30],    /* name of las proc */ 
        procfatal[40],   /* name of las proc and "-fatal" */
        procwarn[40];    /* name of las proc and "-warn" */
   long fatal= -1,       /* fatal error, parm to c_errmsg() */ 
        go_on=  1;       /* warning message, informational, parm to c_errmsg()*/
#else 
   extern char message[CMLEN], procname[30], procfatal[40], procwarn[40];
   extern long fatal, go_on; 
#endif 





/*function prototypes. ifdef allows for compilers that don't allow prototypes*/
#ifdef LANGUAGE_C
   /* delscene.c */ 
      void main (void); 
   /* getpar.c */ 
      void get_parms (struct UPARMS *uparms);
      void check_overflow (long maskval, char *imagename, long dtype); 
   /* image.h takes care of image.c */ 
   /* process.c */ 
      void process_image (struct lasinimage *compimg, struct lasinimage 
	   *dateimg, struct UPARMS *uparms); 
      void change_pix (long sample, long datetype, struct lasinimage *compimg,
	   struct UPARMS *uparms, unsigned char *datebuf); 
      void finish_images (struct lasinimage *ini, long compimg, long dateup, 
	   long dateband); 
#else 
   /* delscene.c */ 
      void main ();
   /* getpar.c */ 
      void get_parms ();
      void check_overflow ();
      void finish_images (); 
   /* image.h takes care of image.c */ 
   /* process.c */ 
      void process_image ();
      void change_pix ();
#endif 

