
/******************************************************************************
NAME:     histogram()
PURPOSE:  histogram indate image, only TRUE and FALSE are needed for histogram
          values
******************************************************************************/

#include "gacosdates.h"  // application header file 



FUNCTION void histogram (
         struct PARBLK *pblock,           // TAE parameters, needed for $msgtim
					  // and INDATE
         short wasUsed[NAREAS][BYTEVALS]) // output histogram 
{
// declare variables 
   long areanum,  // loop index:  study area 
	bv,       // loop index:  brightness value 
	linenum,  // loop index:  image line 
	msgtim,   // $msgtim 
	sampnum;  // loop index:  image sample 

   long 
	messform=ONECAT, // output message format, parameter to c_inittm()  
	nareas=NAREAS;   // number of study areas, parameter to c_inittm() 

   unsigned char *inbuf;   // location of image pixel in indate->buffer  
   extern long curcat,     // current category, for processing message  
	       curent;     // current   entity, for processing message  
   struct INIMAGE indate;  // input image to histogram 

// get $msgtim 
   struct VARIABLE *tparm;  // points to a TAE parameter 
   tparm = p_find (pblock, "$msgtim");
   msgtim = IVAL (*tparm,0); 

// initialize wasUsed to FALSE 
   for (areanum=0;  areanum<NAREAS;  areanum++)
      for (bv=0;  bv<BYTEMAX;  bv++)
	 wasUsed[areanum][bv] = FALSE; 

// process image;  loop for all areas, lines, and samples 
   for (areanum=0, curcat=1;  areanum<NAREAS;  areanum++, curcat++)
   {
      // select window to be processed 
	 open_inimage (pblock, areanum, &indate); 

      // reset processing message 
	 c_inittm ("GACOSDATES", "Histogrammed", "line", "study area", "", 
	          datebandi.nl+areanum, &nareas, &msgtim, &messform);
	 c_startm (); 

      // loop for all lines in study area 
	 for (linenum=0, curent=1;  linenum<datebandi.nl[areanum];  
	 linenum++, curent++)
	 {
	 // read a line of image data 
	    read_bsq2 (linenum, areanum, &indate); 

	 // update histogram with data on this image line 
	    for (sampnum=0,inbuf=indate.buffer;   sampnum<datebandi.ns[areanum];
	    sampnum++, inbuf+= indate.dsizeap)
	       wasUsed[areanum][ *inbuf ] = TRUE; 
	 } 

      // close image files 
	 close_inimage (&indate);  
	 c_stoptm(); 
   } 
}

