#!/bin/sh
#verify the short term logs generated by GACOSDATES 

#make output directory
   rm -rf logs_out2 ; mkdir logs_out2 

#make list of logs
   loglist=`cd logs_in ; ls -1`

#loop for all logs
   for logfile in $loglist
   do
      #process files through nawk
      cat logs_in/$logfile | nawk '

      #read the inlog to get scene id and date indes 
      BEGIN {
	 for (line=0;  getline < "logs_ol/1992p20.inlog" == 1;  line++)
	    if (line>3) 
	       dateindex[$1] = $2     #array[scene] = date index
      }

      #copy the header 
      NR < 6 { print ; next } 

      #copy records with date index of -1 
      $3 == -1 { print ; next } 

      #copy records for composites 
      $3 == "not-a" { print ; next } 
      $3 == "N/A"   { print ; next } 

      #change date index for remaining records, use printf from LAS>DATELOG
      { 
	 $3 = dateindex[$4] 
	 printf "%-9s",    $1   #pername 
	 printf "%-8s",    $2   #sarea   
	 printf "%4d   ",  $3   #dateind 
	 printf "%-18s",   $4   #sceneid 
	 printf "%-18s",   $5   #sysdate 
	 printf "%-16s",   $6   #pstatus 
	 printf "%-8s",    $7   #tapeid  
	 if (NF == 8)
            printf "%-28s", $8  #swstring);
         else # NF==11
	 {
	    printf "%6d ",    $8   #swindow->value[index]);
	    printf "%6d ",    $9   #swindow->value[index]);
	    printf "%6d ",    $10  #swindow->value[index]);
	    printf "%6d ",    $11  #swindow->value[index]);
	 }
	 printf "\n"
      }

      ' > logs_out2/$logfile

   done

#compare results from this script and those from GACOSDATES  
   echo diff should show line numbers and nothing else 
   diff logs_out* | grep -v overwritten | grep -v '^diff'
   exit 0 

