#!/bin/sh
#put two scenes in each short term log 

#check user parameters
   if [ $# != 2 ] 
   then
      echo Usage:  twoscenes.sh namebase pername
      echo namebase is the base of the names for the directories created
      echo pername  is the compositing period name 
      exit 1 
   fi
   namebase=$1"_"
   pername=$2 

#initialize value for sceneid
   sceneid=10

#add scenes to the short term logs 
   for sarea in s01 s02 s03 s04 s06 s07 s08 s10 s12   #study areas 
   do
      logname=$namebase"in"/$sarea"_"$pername.log

      nawk -v pername=$pername -v sarea=$sarea -v sceneid=$sceneid '
      BEGIN {
	 scene1 =   sceneid "_4567890123456"
	 scene2 = ++sceneid "_4567890123456"
	 printf "%-9s%-8s%4d   %-18s\n", pername, sarea, 10, scene1
	 printf "%-9s%-8s%4d   %-18s\n", pername, sarea, 11, scene2
      }' >> $logname

      sceneid=`expr $sceneid + 2` 
   done 

#completion
   echo twoscenes.sh added two scenes to each short term log 
   exit 0 
