#!/bin/sh 
#create some big image files to test paxsites

#check input args
   if [ $# != 1 ] 
   then
      echo usage:  makebig.csh total_size_of_all_output_files_in_Mbytes
      echo makebig.csh makes big image files to test paxsites 
      exit 1
   fi
   mbytes=$1

#set working directory
   rm -rf log2 site2
   mkdir       site2
   cd          site2 

#create image files for study areas 2
   for namebase in scene1 scene2 scene3 scene4 scene5 
   do 
      for extension in img ddr his extra ext
      do 
	 filename=$namebase"_mag106ea."$extension

	 nawk '
	 END {
	    #25 files are created, so n mbytes needed by this file = 1/25th of 
	    #total
	    mbytes /= 25      
	    bytes = mbytes * 1000000 #nbytes in this file
	    lines = bytes / 75       #roughly 75 chars per line
	 
	    for (linenum=0; linenum<lines;  linenum++) {
	       printf "this is line %d of file %s ", linenum, filename
	       printf "that I created to test paxsites.\n"
	    }
	 }' filename=$filename mbytes=$mbytes /dev/null > $filename 

	 echo created site2/$filename 
      done 
   done

#user message
   echo Script makebig.csh has completed 
