
/******************************************************************************
NAME:     savefiles.c 
PURPOSE:  program main()
	  SAVEFILES makes a reference subdir and saves a file to a this subdir 

PROGRAM HISTORY
-------------------------------------------------------------------------------
Date      Programmer       Changes
--------  ---------------  ----------------------------------------------------
Jan 1994  David Zokaites   Original development for $DCONTRIB (ddps contrib),
                           application was later released to $LASDITTY. 
Feb 1994  David Zokaites   Changed parm PROT to parms FILEPROT and DIRPROT. 
Oct 1995  David Zokaites   Updated users guide;  null terminated directory list
                           passed to c_dkcopy();  released to $ADAPSCONTRIB
******************************************************************************/


 
#define GLOBALVARS     /* defined only in this file, flags savefiles.h */ 

#include "savefiles.h" /* proc header file */ 
#include "util.h"
#include <string.h>    /* for call to strcpy() */ 





void main () 
{
/* declare variables */ 
   /* input tae parms */ 
      long dirprot,           /* dir protections */ 
	   fileprot;          /* file protections */ 
      struct nparm infile,    /* input files */ 
		   outfile,   /* output file names */ 
		   refdir;    /* reference directory */ 
      struct sparm lastsub,   /* name for last subdirs */ 
		   subname;   /* name forr most subdirs */ 
   /* processing variables */ 
      char outnames[1][CMLEN];/* null list of output files for c_complt() */ 
      char dirname[FILEN],    /* name of a dir to create */ 
	   lastdir[FILEN],    /* dir name including lastsub */ 
	   totname[FILEN];    /* combined dir and file name */ 
      long lastl,             /* for loop index, last subdir level */ 
	   slevel,            /* loop index, subdir level */ 
	   zero=0;            /* value of zero */ 
/* initialize variables */ 
   /* enter las */ 
      begin_las ("savefiles");
   /* set output */
      output.dircount = output.ovcount = output.newcount = 0;
   /* get value of tae parms */ 
      get_prot ("DIRPROT",  &dirprot);  
      get_prot ("FILEPROT", &fileprot); 
      /* iread=file must exist, iupdate=no check on file existence */ 
      name_parm   ("INFILE", FALSE, IREAD,   &infile);   
      name_parm   ("OUTFILE", TRUE,  IUPDATE, &outfile); 
      name_parm   ("REFDIR",  FALSE, IUPDATE, &refdir);  
      string_parm ("LASTSUB", &lastsub); 
      string_parm ("SUBNAME", &subname); 
   /* check count of input parms */ 
      if (infile.count != outfile.count || infile.count != lastsub.count)
	 c_errmsg (
	 "Parms INFILE, OUTFILE, LASTSUB do not have the same number of values."
	 , procfatal, &fatal); 
/* copy files */ 
   /* create refdir if it does not exist */
      make_dir (refdir.value[0], dirprot); 
   /* make most subdirs if they do not exist */ 
      strcpy (dirname, refdir.value[0]); 
      for (slevel=0; slevel<subname.count; slevel++)
      {
	 /* add this subdir to dirname */ 
	    strcat (dirname, "/");
	    strcat (dirname, subname.value[slevel]); 
	 /* create subdir if it does not exist */ 
	    make_dir (dirname, dirprot); 
      }
   /* copy files */ 
      for (lastl=0; lastl<lastsub.count; lastl++) 
      {
	 /* make dir name */ 
	    sprintf (lastdir, "%s/%s", dirname, lastsub.value[lastl] ); 
	 /* make dir if it does not exist */ 
	    make_dir (lastdir, dirprot); 
	 /* copy files */ 
	    sprintf (totname, "%s/%s", lastdir, outfile.value[lastl]); 
	    copy_file (infile.value[lastl], totname, lastdir, fileprot); 
      }
/* end program */ 
   write_output(infile.count,    infile.value,    "input files are"); 
   write_output(output.dircount, output.dirnames, "created directories");
   write_output(output.ovcount,  output.ovfiles,  "overwrote files"); 
   write_output(output.newcount, output.newfiles, "created files"); 
   c_complt (procname, outnames, &zero); 
} 



