
/* savefiles.h:  proc header file */ 
#include "las.h"    /* for las and tae */ 
#define FILEN   300 /* max length of a file name, and of sprintf format to make
		       a file name */ 
#define PVALUES  10 /* PVALUES >= max count for all parms */ 





/* data structures */ 
   /* a structure to keep track of output names */ 
      struct OUTPUT
      {
	 char dirnames[PVALUES*2][FILEN], /* names of dirs created */ 
	      ovfiles [PVALUES*2][FILEN], /* names of files overwritten */
	      newfiles[PVALUES*2][FILEN]; /* names of new files created */
	 long dircount,                   /* number of dirs made */ 
	      ovcount,                    /* number of files overwritten */
	      newcount;                   /* number of new files created */ 
      }; 
   /* structure for file name parm with multiple values */ 
      struct nparm
      {
	 long count;                  /* number of values for this parm */ 
	 char value[PVALUES][FILEN];  /* parm values */ 
      };
   /* string parms */ 
      struct sparm
      {
	 long count;            /* number of values for this parm */ 
	 char *value[PVALUES];  /* parm values */ 
      };




/* global vars, declared global for convenience */ 
#ifdef GLOBALVARS
   struct OUTPUT output; /* names and number of output files and dirs */  
   struct PARBLK pblock; /* tae parameter block */ 
   char message[CMLEN],  /* error message string, parm to c_errmsg()*/
        procname[30],    /* name of las proc */ 
        procfatal[40],   /* name of las proc and "-fatal" */
        procwarn[40];    /* name of las proc and "-warn" */
   long fatal= -1,       /* fatal error, parm to c_errmsg() */ 
        go_on=  1;       /* warning message, informational, parm to c_errmsg()*/
#else
   extern struct OUTPUT output; 
   extern struct PARBLK pblock;
   extern char message[CMLEN], procname[30], procfatal[40], procwarn[40];
   extern long fatal, go_on;
#endif 





/* savefiles.c */ 
    void main (void); 
/* functions.c */ 
void begin_las
(
   char *proc             /* input:  name of las proc */
);

void get_prot
(
   char *parmname,  /* input:   get prot for this parm */
   long *prot       /* output:  dir or file protection */
);

void name_parm
(
   char *parmname,         /* input:  name of parameter */
   long lastpart,          /* input:  flag, return only last part of file name,
                                      not the whole path */
   long access,            /* input:  access mode for c_getnam() */
   struct nparm *parmval   /* output: parm values */
);

void string_parm
(
   char *parmname,         /* input:  name of parameter */
   struct sparm *parmval   /* output: parm values */
);

void strlower
(
   char *string
);

void make_dir
(
   char *dirname,  /* input:  name of dir to create */
   long dirprot    /* input:  protection for the new dir */
);

void copy_file
(
   char *infile,   /* input:  unix name of input file, incl path */
   char *outfile,  /* input:  unix name of output file, incl path */
   char *outdir,   /* input:  unix name for output dir */
   long fileprot   /* input:  protection for output file */
);

void write_output
(
   long nfiles,       /* input: number of files created */
   char outnames[PVALUES*2][FILEN],
                      /* input: names of files created */
   char *action       /* input: action described as in "created files" */
);


