/* akdamap.c  calculates map of percentage
of current period average NDVI
            It produces a map that has
clouds overlaid from the NDVI image
            It does not use previous
periods DA values
            It assumes the watermask has
already been applied to the NDVI image
            It supercedes all other
versions of the departure from average
program
            That means all programs with
"cummap" in their name.
   Programmer: Bob Burgan
   Last Modified: 3/17/97 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main()
{
   char    avend[80],curnd[80],cldcda[80];
   double  curndvi,cda,meannd;
   FILE    *innd,*inave,*cloudycda;
   int     i,row,icda,col,imeannd;
   int     status = -1;

/* Open input and output files */
   puts("Enter average NDVI map name: ");
   scanf("%s", avend);
   if((inave = fopen(avend,"rb")) == NULL)
   {
       printf("Can't open file %s", avend); 
       exit(status);
   }

   puts("Enter NDVI map name: ");
   scanf("%s", curnd);
   if((innd = fopen(curnd,"rb")) == NULL)
   {
       printf("Can't open file %s", curnd); 
       fclose(inave);
       exit(status);
   }

/* Construct output file name */
   strcpy(cldcda,"akda");
   for(i=4; i<11; i++)cldcda[i]=curnd[i];
   cldcda[11]='\0';

/* Open Departure from Average output file
*/
   if((cloudycda = fopen(cldcda,"wb")) ==
NULL)
   {
       printf("Can't open file %s",
cldcda); 
       fclose(inave);
       fclose(innd);
       exit(status);
   }


/* Calculate and write out new DA map file
*/

   for(row=1; row < 1993; row++)
   {
      printf("line %d\r", row);
      for(col=1; col < 2513; col++)
      {
      meannd = (double)getc(inave);
      imeannd = (int)meannd;
      curndvi = (double)getc(innd);
       
/* Allow for greenup in snow covered areas
of meannd map */
      if(imeannd == 0 && (int)curndvi >=
100)
        {
        meannd=100.;
        imeannd=100;
        }

/* Calculate AKDA value */
      if(imeannd > 0)
        {
        cda = (curndvi-100.) /
(meannd-100.) * 100.;
        icda = (int)cda; 
        if(icda > 250) icda = 250;
        }

/* Set pixel value to water (255) if water
pixel in meannd image */
/*      if(imeannd == 254)icda=255; */

/* Add clouds for AKDA map if they exist in
current ndvi image */
      if((int)curndvi <= 100) icda=0;

/* Set pixel value to water (255) if water
pixel in meannd image - AGAIN */
          if((int)curndvi == 255)icda=255;

/* Write final cloudy and snowy AKDA map */
        putc(icda, cloudycda); 

      }  /* End for col loop */
   }     /* End for row loop */

/* Close files */
   fclose(inave);
   fclose(innd);
   fclose(cloudycda);

/* Tell user a Departure from Average map
was created */
   printf("\nA Departure from Average map was created and is in a file named %s\n",cldcda);
}

