
/* This program was written by Bob Burgan (USFS) and Jeff Eidenshink in 1996.
The purpose of the program is to calculate the departure from average greenness
for the conterminous U.S.  The input requires a "mean" ndvi image for each time
period, in this case weekly, and an ndvi image for the same weekly period. */


/* damap.c calculates a map of percentage of current period NDVI
           It produces a map that has clouds overlaid from the NDVI image
           It does not use previous period DA values
           It assumes the watermask has already been applied to the mean nd image */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void main()
{
   char avend[80], curnd[80], cldcda[80];
   double curndvi, cda, meannd;
   int i, status = -1, row, icda, col, imeannd;
   FILE *innd, *inave, *cloudycda;

/* Open input and output files */
   puts("Enter average NDVI map name: ");
   scanf("%s", avend);
   if((inave = fopen(avend,"rb")) == NULL)
   {
      printf("Can't open file %s", avend);
      exit(status);
   }

   puts("Enter NDVI map name: ");
   scanf("%s", curnd);
   if((innd = fopen(curnd,"rb")) == NULL)
   {
      printf("Can't open file %s", curnd);
      fclose(inave);
      exit(status);
   }

   puts("Enter DA file name: ");
   scanf("%s", cldcda);
   if((cloudycda = fopen(cldcda,"wb")) == NULL)
   {
      printf("Can't open files %s", cldcda);
      fclose(inave);
      fclose(innd);
      exit(status);
   }

/* Calculate and write out new DA map file */
   for(row=1; row < 2890; row++)
   {
   printf("row %d\r", row);
   for(col=1; col< 4588; col++)
   {
   meannd = (double)getc(inave);
   imeannd = (int)meannd;
   curndvi = (double)getc(innd);

/* Show average greenness if mean nd indicates snow and current nd doesn't */
   if(imeannd == 0 && (int)curndvi >= 100)
   {
      icda = 100;
   }
/* Else calculate DA value */
   else
   {
     cda = (curndvi-100.) / (meannd-100.) * 100.;
     icda = (int)cda;
     if(icda > 250) icda = 250;
   }

/* Add clouds for DA map if they exist in current ndvi image */
   if((int)curndvi < 100) icda=0;

/* Set pixel value to water (255) if water pixel in meannd image */
   if (imeannd == 255)icda=255;

/* Write final cloudy and snow DA map */
   putc(icda, cloudycda);
   }  /* End for col loop */
   }  /* End for row loop */

/* Close files */
   fclose(inave);
   fclose(innd);
   fclose(cloudycda);

/* Tell user a Departure from Average map was created */
   printf("\nA Departure from Average map was created and is in a file named %s\n",cldcda);
}



