#ifndef ACQUIRE_H
#define ACQUIRE_H

/* Defines
----------*/
#ifndef FALSE
#define FALSE     0
#endif
#ifndef TRUE
#define TRUE      (!FALSE)
#endif
#define FAIL      -1
#define SUCCESS   0
#define MAXTRIES  5		/* maximum number of command tries	*/
#define STRLEN    256		/* standard length of strings		*/
#define BUFLEN    22016		/* length of a full avhrr data line	*/
#define TSTAMP    36		/* length of the time stamp header	*/
#define MINOR     TSTAMP	/* where the minor frame starts in buf	*/
#define MINORSIZE 206		/* minor frame size			*/
#define PREVIDEO  1500		/* number of bytes before video data	*/
#define VIDEOSIZE 20480		/* size of the video data		*/
#define POSTVIDEO 36		/* number of bytes to write after video	*/
#define SFLHEADER 512		/* size of the standard SFL header	*/
/* where the video starts in buf	*/
#define VIDEO     (TSTAMP+MINORSIZE)
/* largest value of zero data to fill	*/
#define ALLZERO   (PREVIDEO-MINORSIZE)




/* Function prototypes
----------------------*/
void sighandler
    (
    int signal_number           /* IN - signal number of the interrupt	*/
    );

void parse_args
    (
    char *argv[],		/*  IN - argument array			*/
    char *IPaddress,		/* OUT - frame sync address		*/
    int  *port_num,		/* OUT - port number of frame sync	*/
    char *image_file_name,	/* OUT - output image file name		*/
    char *misc_file_name,	/* OUT - miscellaneous output file name	*/
    char *tstamp_file_name,	/* OUT - time stamp output file name	*/
    char *lock_file_name	/* OUT - lock file name			*/
    );

void write_log
    (
    int  flag,                  /* IN - TRUE/FALSE fatality flag        */
                                /*      TRUE = issue fatal error message*/
    char *key,                  /* IN - error/message key               */
    char *code,                 /* IN - error/message code              */
    char *msg                   /* IN - message string                  */
    );

int create_socket
    (
    char *IPaddress,            /* IP address to make connection to     */
    int   port_number           /* port number to make connection to    */
    );

int configure_framesync
    (
    int socket_fd               /* IN - socket file descriptor          */
    );

int send_command
    (
    int   socket_fd,            /* IN - socket file descriptor          */
    char *message               /* IN - 225W command message string     */
    );

void check_status
    (
    int socket_fd,              /* IN - socket file descriptor          */
    char *commands[7]           /* OUT - list of commands		*/
    );
#endif
