/*************************************************************************
FUNCTION:	configure_framesync

PURPOSE:	Configure the framesyc to receive HRPT, NOAA KLM data.

INPUT:		socket file descriptor

OUTPUT:		commands sent to socket

RETURNS:	none

PROJECT:	ADAPS, AVHRR Acquisition System

$Log: configure_framesync.c,v $
Revision 1.1  2002/05/20 13:23:25  dlloyd
Initial checkin of files

*************************************************************************/
#include <string.h>
#include "acquire.h"


int configure_framesync
    (
    int socket_fd		/* IN - socket file descriptor		*/
    )
    {
    int num_tries;
    char *commands[] = {"     ","     ","     ","     ","     ","     ",NULL};
    char **command = (char **)commands;

    check_status( socket_fd, commands );

    while ( *command != NULL )
        {
	for ( num_tries = 0; num_tries < MAXTRIES; num_tries++ )
	    {
	    if ( send_command( socket_fd, *command ) == SUCCESS )
	        break;
	    else
		write_log(FALSE,"configure_framesync","send-err",*command);
	    }  /* END for */

        if ( num_tries > MAXTRIES )
	    {
	    /* Then the command failed and we must exit
	    -------------------------------------------*/
	    write_log(TRUE,"configure_framesync","send-err",*command);
	    return FAIL;
	    }  /* END if */

	command++;
	}  /* END while */

    return SUCCESS;
    }  /* END configure_framesync */
