#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/stat.h>
#include <string.h>

/* Forward definitions of local functions
-----------------------------------------*/
void sighandler( int );
int send_command( char *message );
void swapbuf( char *buf, int buflen );

/* These variables are declared global so that the signal
handler can close them when the exit signal is received
---------------------------------------------------------*/
FILE   *ouf, *ouf1, *ouf2;
int    sk;

#define BUFLEN    1048575
#define VIDEOSIZ  20520
#define HEADER    36
#define PREVIDEO  1500
#define POSTVIDEO 36
#define ALLZERO   (PREVIDEO-206)


int main( int argc, char *argv[] )
{
unsigned char allzero[ALLZERO] = {'\0'};
int    start;
int    bytes_read;
struct sockaddr_in skaddr;
struct hostent     *hp;
unsigned char      buf[BUFLEN];
long   n;
int    i;
char   IPaddress[256];
char   portnum[120];
int    msglen;
int    *bufptr = (int *)buf;
int    process_id;
char   time_stamp_file[256];
char   *c;

signal( SIGHUP, sighandler );
process_id = getpid();
printf("Process ID: %d\n", process_id);
printf("Send:\nkill -HUP %d\nto stop this process.\n", process_id);
ouf = fopen("stopacquire.csh","w");
fprintf(ouf,"#!/bin/csh\nkill -HUP %d\n",process_id);
chmod("stopacquire.csh",S_IRUSR|S_IWUSR|S_IXUSR);
fclose( ouf );

/* check for command line parameters, use them if specified
if ( argc == 3 )
    {
    strcpy( IPaddress, argv[1] );
    strcpy( portnum, argv[2] );
    }
else
    {
    printf("Usage: client <server name> <server port>\n");
    strcpy( IPaddress, "edcavhrr-fs" );
    strcpy( portnum, "1024" );
    printf("Using: %s %s %s\n", argv[0], IPaddress, portnum );
    }
-----------------------------------------------------------*/

/* open the output file
-----------------------*/
ouf = fopen( argv[4], "w" );
if ( !ouf )
    {
    printf("\nUnable to open output file: %s\n\n", argv[4]);
    exit(1);
    }
fwrite(allzero,sizeof(unsigned char),512,ouf);
strcpy( time_stamp_file, argv[4] );
c = strchr( time_stamp_file, '.' );
*c = '\0';
strcat( time_stamp_file, ".tstamp");
ouf1 = fopen( time_stamp_file, "w" );
if ( !ouf1 )
    {
    printf("\nUnable to open output file: %s\n\n", time_stamp_file);
    exit(1);
    }
ouf2 = fopen( "miscout.sfl", "w" );
if ( !ouf2 )
    {
    printf("\nUnable to open output file\n\n");
    exit(1);
    }

/* create a socket
------------------*/
if (( sk = socket( PF_INET, SOCK_STREAM, 0 )) < 0 )
    {
    printf("Problem creating socket\n");
    exit(1);
    }

skaddr.sin_family = AF_INET;
if (( hp = gethostbyname( IPaddress )) != 0 )
    memcpy( &skaddr.sin_addr.s_addr, hp->h_addr, hp->h_length );
else
    {
    if ( inet_aton( IPaddress, &skaddr.sin_addr ) == 0 )
        {
	printf("Invalid IP address: %s\n",IPaddress);
	exit(1);
	}
    }
skaddr.sin_port = htons(atoi(portnum));

/* establish the connection
---------------------------*/
if ( connect( sk, (struct sockaddr *) &skaddr, sizeof( skaddr )) < 0  )
    {
    printf("Problem connecting socket\n");
    exit(1);
    }

while ( send_command( "FTP 7" ) == 1 )
    printf("Error setting data type HRPT\n");
while ( send_command( "COD N" ) == 1 )
    printf("Error setting data input code\n");
while ( send_command( "CRT 0" ) == 1 )
    printf("Error setting input clock rate\n");
while ( send_command( "DTP 1" ) == 1 )
    printf("Error setting data type KLM\n");
while ( send_command( "VID E" ) == 1 )
    printf("Error setting video enable\n");
while ( send_command( "TSP E" ) == 1 )
    printf("Error setting time enable\n");

/* now read from the port until the server is done
The while > 0 does not terminate there is a signal
handler that closes the output files and exits.
--------------------------------------------------*/
i = 0;
start = msglen = bytes_read = 0;
n = 1;

while ( n > 0 )
    {
    n = read( sk, buf, 4 );
    if ( n == 0 )
        printf( "nothing to read\n" );
    msglen = *bufptr;

    n = 0;
    while ( n < msglen )
        {
	n += read( sk, &buf[n], msglen );
	}
    
    if ( strcmp( &buf[1], "Video" ) == 0 )
        {
	fwrite( buf, sizeof(unsigned char), HEADER, ouf1 );
	fwrite( &buf[HEADER], sizeof(unsigned char), 206, ouf );
	fwrite( allzero, sizeof(unsigned char), ALLZERO, ouf );
	fwrite( &buf[HEADER+206],sizeof(unsigned char),msglen-206-HEADER, ouf );
	fwrite( allzero, sizeof(unsigned char), POSTVIDEO, ouf );
	}
    else
	fwrite( buf, sizeof(unsigned char), msglen, ouf2 );
    }


close( sk );
fclose(ouf);
fclose(ouf1);
fclose(ouf2);
return 0;
}  /* END main */

void sighandler
(
int signo
)
{
if ( signo == SIGHUP )
    {
    printf("\nReceived SIGHUP %d\n\n", signo );
    fclose( ouf );
    fclose(ouf1);
    fclose( ouf2 );
    close( sk );
    exit(0);
    }
else
    return;
}  /* END sighandler */


/****************************************************************************
FUNCTION:	SEND_COMMAND

PURPOSE:	Send and verify a command to the socket connection with
		the 225W frame synchronizer.

INPUT:		message: the command string to send.  See 225W operation
			 manual section 4.7.3 for valid commands.

OUTPUT:		no return parameters modified
		message is sent to socket

RETURNS:	success = 0
		failure = 1

REFERENCES:	Model 225W Frame Synchronizer Operation Manual, document
		    number 640-225005, GDP Space Systems, undated.
		HRPT Video Installation Guide For the Frame Synchronizer
		    Model 225W, document number M225W-VIDEO-IG-1.00.00, GDP
		    Space Systems, April 8, 2002
****************************************************************************/
int send_command
(
char *message			/* 225W command message string		*/
)
{
char msg[150];			/* message sent to the socket		*/
char readbuf[150];		/* response from the socket		*/

int  buf_len;			/* length of response			*/
int *bufptr = (int *)readbuf;	/* pointer to the response buffer	*/
int  msg_len;			/* length of message			*/
int *msgptr = (int *)msg;	/* pointer to the message buffer	*/
int  num_read;			/* number of bytes read from socket	*/
int  num_write;			/* number of bytes written to socket	*/

/* Create the command message.  The first four bytes
are the message length excluding the 4-byte header.
----------------------------------------------------*/
sprintf( msg, "0000:%s;", message );
msg_len = strlen( msg );
*msgptr = msg_len - 4;

/* send the command
-------------------*/
num_write = write( sk, msg, msg_len );
if ( num_write != msg_len )
    return 1;

/* read the 4-byte command response message length 
--------------------------------------------------*/
num_read = read( sk, readbuf, 4 );
if ( num_read != 4 )
    return 1;
buf_len = *bufptr;

/* read the command response.  The first two bytes
indicate the block type and comand status respectively.
as follows:
    block type byte 1
        0000 = 0 = data block
	0001 = 1 = data quality block
	0010 = 2 = command response block
	0011 = 3 = status reply block
    comand status byte 2
        bit 0 = command executed
	        0 = executed
		1 = error
	bit 1 = CRC check
		0 = CRC passed
		1 = CRC failed
	bit 2 = local/remote selection
		0 = local
		1 = remote

The remainder of the command response is identical to
the command message if all went well or a '?' is not.
-------------------------------------------------------*/
num_read = read( sk, readbuf, buf_len );
if ( num_read != buf_len )
    return 1;
readbuf[buf_len] = '\0';

/* check that all went well
??? should  make this a more complete check
---------------------------*/
if ( strcmp( &msg[4], &readbuf[2] ) == 0 )
    return 0;
else
    return 1;
}  /* END send_command */

