#!/bin/csh -f
#
# Start the shoacqu process.  If any previous shoacqu processes are running
# they are killed prior to starting another instance.  The file
# $ADAPSTABLES/acquman_port_number is used to obtain the port that acquman is
# expecting to connect to shoacqu with.
#
# Usage: start_shoacqu.csh
#
# $Log: start_shoacqu.csh,v $
# Revision 1.2  2007/09/14 18:27:13  adaps
# Added -f to #!/bin/csh to prevent sourcing the .cshrc file.  Was causing
# some errors that didn't make sense.
#
# Revision 1.1  2003/04/23 12:12:18  dlloyd
# Initial checking of miscellaneous scripts.
#
#===========================================================================

# Get the current time
set now = `date +"%D  %T"`

# find the process id of shoacqu
set shoacqu_pid = " "
set sho = `ps -e -o pid -o ucomm | grep shoacqu`
@ i = ${#sho}
@ j = 0
while ( $i > 1 )
    if ( $sho[$i] == "shoacqu" ) then
        @ i--
	@ j++
	set shoacqu_pid = "$shoacqu_pid $sho[$i]"
	@ i--
    else
        @ i = $i - 2
    endif
end

# If shoacqu processes were found, Kill them
if ( $j > 0 ) then
    foreach proc_id ( $shoacqu_pid )
        kill -9 $proc_id
    end
endif

# Get the acquman port number
if ( -e $ADAPSTABLES/acquman_port_number ) then
    set portnum = `cat $ADAPSTABLES/acquman_port_number`
else
    echo "Unable to find ACQUMAN port number, restart ACQUMAN"
    exit 1
endif

shoacqu -port $portnum &

exit 0
