/*************************************************************************
FUNCTION:       acu_control

PURPOSE:        Set the mode of the antenna control unit to either auto
                or stow.

INPUT:          command: AUTO or STOW

OUTPUT:         character string to serial port containing ACU command

RETURNS:        0 on SUCCESS
                -1 on FAILURE

*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "acquman.h"

#define BUFLEN 1024


int acu_control
(
    int cmd,    		/* IN - ACU command: TRACK or STOW	*/
    int sat
)
{
    char stow_cmd[BUFLEN];
    char start_cmd[BUFLEN];


    if ( cmd == STOW )
    {
        sprintf( stow_cmd, "%s/stow_antenna", getenv( "LASTOOLS" ));
        system( stow_cmd );
        return 0;
    }

    /* Based on value sent, set command string
    -----------------------------------------*/
    switch ( sat )
    {
        case 2  :
            //strcpy( satellite, "METOP A" );
            break;
        case 17  :
            //strcpy( satellite, "NOAA 17" );
            sprintf( start_cmd, "%s/start_acu 17", getenv( "LASTOOLS" ));
            break;
        case 18  :
            //strcpy( satellite, "NOAA 18" );
            sprintf( start_cmd, "%s/start_acu 18", getenv( "LASTOOLS" ));
            break;
        case 19  :
            sprintf( start_cmd, "%s/start_acu 19", getenv( "LASTOOLS" ));
            break;
    }
    system( start_cmd );

    return 0;
}  /* END acu_control */
