/*************************************************************************
FUNCTION:	check_for_stop

PURPOSE:	Check for the existence of a stop file and, if one exists
		remove it and return TRUE.

INPUT:		ADAPSTABLES environment variable

OUTPUT:		none

RETURNS:	TRUE if stop file exists
		FALSE if stop file doesn't exist

PROJECT:	ADAPS, AVHRR Acquisition System

*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "acquman.h"


int check_for_stop
    (
    const char *adapstables	/* IN - ADAPSTABLES environment variable*/
    )
    {
    char stopfile_name[STRINGLEN];/* full stop file name		*/


    /* Build the stop file name
    ---------------------------*/
    strcpy( stopfile_name, adapstables );
    strcat( stopfile_name, "/acquman_daemon.stop" );


    /* If the file exists, the remove will be
    successful which means the user is asking
    ACQUMAN to stop.
    -----------------------------------------*/
    if ( remove( stopfile_name ) == 0 )
	{
	write_log(FALSE,"check_for_stop","stopfile","Acquman terminated");
        return TRUE;
	}
    
    return FALSE;
    }  /* END check_for_stop */
