/*************************************************************************
FUNCTION:	get_environment

PURPOSE:	Retrieve the values of environment variables.

INPUT:		none

OUTPUT:		ADAPSTABLES environment variable
		ADAPSING environment variable
		Incoming data directory
		ADAPSERR environment variable

RETURNS:	0 on success
		-1 on failure

PROJECT:        ADAPS, AVHRR Acquisition System

*************************************************************************/
#include <stdlib.h>
#include <string.h>
#include "acquman.h"

int get_environment
    (
    char *adapstables,          /* OUT - ADAPSTABLES environment var    */
    char *adapsing,             /* OUT - ADAPSING environment variable  */
    char *adapsacq,             /* OUT - Incoming data directory        */
    char *adapserr              /* OUT - ADAPSERR environment variable  */
    )
    {
    char *variable_ptr;		/* pointer to environment string	*/

    /* get ADAPSTABLES
    ------------------*/
    variable_ptr = getenv( "ADAPSTABLES" );
    if ( variable_ptr == NULL )
        {
	write_log(FALSE,"get_environment","getenv",
	    "Error retrieving ADAPSTABLES");
	return -1;
	}
    strcpy( adapstables, variable_ptr );

    /* Get ADAPSING
    ---------------*/
    variable_ptr = getenv( "ADAPSING" );
    if ( variable_ptr == NULL )
        {
	write_log(FALSE,"get_environment","getenv","Error retrieving ADAPSING");
	return -1;
	}
    strcpy( adapsing, variable_ptr );

    /* Get INCOMING
    ---------------*/
    variable_ptr = getenv( "INCOMING" );
    if ( variable_ptr == NULL )
        {
	write_log(FALSE,"get_environment","getenv","Error retrieving INCOMING");
	return -1;
	}
    strcpy( adapsacq, variable_ptr );

    /* Get ADAPSERR
    ---------------*/
    variable_ptr = getenv( "ADAPSERR" );
    if ( variable_ptr == NULL )
        {
	write_log(FALSE,"get_environment","getenv","Error retrieving ADAPSERR");
	return -1;
	}
    strcpy( adapserr, variable_ptr );
    
    return 0;
    }  /* END get_environment */
