/*******************************************************************************
FUNCTION: get_file_size

PURPOSE:  Given a file name, return the size of the file in bytes.

PROGRAM HISTORY:

Version  Date   Author           Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    04/01  T.Baltzer	 modified from c_getsizes()


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
         Run under TAE

PROJECT: ADAPS

*******************************************************************************/
#include <stdio.h>
#include "acquman.h"

void get_file_size
(
    char file_name[CMLEN],	/* Full path specification of files   */
    long *file_size       	/* Size in bytes of each file         */
)
{

FILE   *file_ptr;            /* File ptr used for opening each file           */


/* Open the file specified
---------------------------*/
file_ptr = fopen(file_name, "r");
if (file_ptr == NULL)
   *file_size = -1;
else
   {
   /* Seek 0 bytes from the end of the file
   ----------------------------------------*/
   fseek(file_ptr, 0, SEEK_END);
   *file_size = ftell(file_ptr);
   fclose(file_ptr);
   if (*file_size < 0)  *file_size = -1;
   }
}
 
