/****************************************************************************
FUNCTION:       save_port

PURPOSE:        Save the port number in a known location

INPUT:          ADAPSTABLES environment variable
		port number

OUTPUT:         none

RETURNS:        none

PROJECT:	ADAPS, AVHRR Acquisition System

*************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include "acquman.h"


void save_port
    (
    const char *adapstables,    /* IN - ADAPSTABLES environment variable*/
    int port_number	/* IN - port number to save			*/
    )
    {
    FILE *port_file;		/* file descriptor for port number	*/

    char port_file_name[STRINGLEN];/* file name in which to save port	*/


    /* Build the file name and open the file
    ----------------------------------------*/
    sprintf( port_file_name, "%s/acquman_port_number", adapstables );
    port_file = fopen( port_file_name, "w" );
    if ( !port_file )
        return;


    /* Save the port number
    -----------------------*/
    fprintf( port_file, "%d", port_number );

    fclose( port_file );
    }  /* END save_port */
