/****************************************************************************
FUNCTION:	start_callback

PURPOSE:	Initiate the reception of a live acquisition.


Version	Date	Programmer	Modifications
-------	-------	---------------	--------------------------------------------
  1.0	03/01	T. Baltzer	Initial development

PROJECT:	ADAPS
****************************************************************************/
#include <stdlib.h>
#include <Xm/Xm.h>
#include "acquman.h"

extern int sd;			/* Socket descriptor	*/
extern char sceneid[17];	/* 16 char scene identifier */
extern char dnflag[2];		/* Day / night flag (D/N)   */


void start_callback
    (
    XtPointer client_data,
    XtIntervalId *time_id
    )

    {

    char tmpbuf[100];	/* Temporary data buffer	*/
    char msgbuf[100];	/* Message buffer		*/


    /* Notify the receiver to record at the appropriate frequency
    --------------------------------------------------------------*/


    /* Notify the SHOACQU child to start displaying the acquisition
    ----------------------------------------------------------------*/
    sprintf( tmpbuf, "-f %s.sfl -dn %s", sceneid, dnflag );
    sprintf( msgbuf, "%03d%s", strlen(tmpbuf), tmpbuf);
    printf("Sending ???: %s\n",msgbuf);
    write( sd, msgbuf, strlen(msgbuf));


    /* Fork a ACQUIRE child to record the acquisition
    ------------------------------------------------------*/


    /* Set an alarm to terminate the acquisition reception
    ------------------------------------------------------*/
    set_stop_alarm( );


    /* write a log file and exit
    ----------------------------*/
    write_log( FALSE, "start_callback", "info",
        "ACQUMAN initiated live acquisition" );

    }  /* END start_callback */
