/***************************************************************************
FUNCTION:	get_toplevel_shell

PURPOSE:	Climb to the top of the widget tree and return the top
		level shell

INPUTS:		calling widget data

OUTPUTS:	none

RETURNS:	Widget - top level shell widget

Version	Date	Programmer	Modifications
-------	-------	---------------	--------------------------------------------
  1.0	08/00	D.Lloyd		Initial development (from ADAPSMONITOR)

PROJECT:	ADAPS
****************************************************************************/
#include <stdio.h>
#include "acquman.h"


Widget get_toplevel_shell
    (
    Widget w			/* IN - calling widget value            */
    )
    {
    while( w && !XtIsTopLevelShell( w ))
        w = XtParent( w );
    
    return w;
    }  /* END get_toplevel_shell */

