/******************************************************************************
FUNCTION:	write_error

PURPOSE:	Write a message to the standard log file for acquman.
		Write the message to a pop up window.
		
INPUT:	        TRUE/FALSE fatality flag          
		error/message key			
		error/message code		
		message string                    

OUTPUT:         None

RETURNS:	None

Version	Date	Programmer	Modifications
-------	-------	---------------	--------------------------------------------
  1.0	04/01	T. Baltzer	Initial development

PROJECT:	ADAPS
******************************************************************************/
#include "acquman.h"

extern Widget toplevel;		/* the top level shell widget		*/

void write_error
    (
    int    flag,                /* IN - TRUE/FALSE fatality flag	*/
    				/*      TRUE = issue fatal error message*/
    char   *key,                /* IN - error/message key		*/
    char   *code,		/* IN - error/message code		*/
    char   *msg                 /* IN - message string			*/
    )
    {

    /* Write the message to the log
    ----------------------------------*/
    write_log(flag, key, code, msg);


    /* Display the message in a pop up window
    --------------------------------------------*/
    post_dialog( toplevel, msg, "Acknowledge" );


    }  /* END write_error */
