/*****************************************************************************
NAME:                   CURRTIME

PURPOSE:                Determine the current time in "schedule" time format.

*****************************************************************************/
#include <stdio.h>
#include <time.h>
#include "las.h"
#include "readmsch.h"


void currtime(

	long *ctime 		/* Current time in master schedule format */
)

{

long	day;			/* Current day				*/
long	hour;			/* Current hour				*/
long	jdate;			/* Current julian date			*/
long	minute;			/* Current minute			*/
long	month;			/* Current month			*/
long    now;                    /* time now                             */
long	second;			/* Current second			*/
long	tmptime;		/* Temporary time			*/
long    year;                   /* year                                 */


struct tm *curtime;             /* current time                         */


/*
  Get the current date and time (GMT)
-------------------------------------*/
now = time(NULL);
curtime = gmtime(&now);

/*
  Get the fields out of the system structure now because
  they could change in the call to c_4digityr() !!
--------------------------------------------------------*/
month = curtime->tm_mon + 1;
day = curtime->tm_mday;
hour = curtime->tm_hour;
minute = curtime->tm_min;
second = curtime->tm_sec;


/*
  Make year a 4-digit year
--------------------------------------*/
year = c_4digityr(curtime->tm_year);


/*
  Convert to a julian date
--------------------------------------*/
c_grejul(&year,&month,&day,&jdate);


/*
  Convert year back to a 2-digit year
--------------------------------------*/
year = year % 100;


/*
  Convert the current time to the master schedule time format
---------------------------------------------------------------------*/
JULTIM_TO_TOTSECS(second,minute,hour,jdate,year,tmptime);

*ctime = tmptime;

return;
}
