/*****************************************************************************
NAME:                   PASTTIME

PURPOSE:                Determine if a given scene in the schedule
			passes the specified time constraint.

*****************************************************************************/
#include <stdio.h>
#include <time.h>
#include "las.h"
#include "readmsch.h"


int pasttime(

	char inputline[],		/* Line from Master schedule file */
	long timespec 			/* Specified time constraint	  */
)

{

long	ctime;			/* Current time in "schedule" format	*/
long	comptime;		/* Adjusted time to compare to		*/
long	startime;		/* Local start time of scene in schedule*/

char	tmpbuf[10];		/* Temporary buffer			*/


/*
  Get the current date and time in "master schedule" format.
-------------------------------------------------------------*/
currtime(&ctime);


/*
  Now subtract the specified time to the current time to get the
  "compare time".  This time will be used to compare against
  the acquistion time in the schedule.
-------------------------------------------------------------*/
comptime = ctime - timespec;


/*
  Now get the acquistion start time for the scene from
  out of the schedule.
-------------------------------------------------------------*/
strncpy(tmpbuf,&inputline[41],9);
tmpbuf[9] = '\0';
sscanf(tmpbuf,"%ld",&startime);


/*
  If the acquistion start time from the schedule is
  less than the computed compare time, return TRUE;
  otherwise, return FALSE.
-------------------------------------------------------------*/
if (startime < comptime)
    return(TRUE);
else
    return(FALSE);

}
