#ifndef READMSCH_H
#define READMSCH_H

struct TIMESTR
    {
    long TIME_ACQUIRE;     /* Time (in seconds from current time) to	  */
			   /* wait before trying to download a scene from */
			   /* the NOAA server.				  */

    long TIME_MISSED;      /* Time (in seconds from current time) to	  */
			   /* wait before marking a scene in the schedule */
			   /* as being missed.				  */

    long TIME_DELETE;      /* Time (in seconds from current time) to	  */
			   /* wait before deleting a scene from the	  */
			   /* master schedule.				  */
    };

#define	START_OF_TIME	1986

#define JULTIM_TO_TOTSECS(scs,mns,hrs,dys,yr,optm) \
                    (optm) = (scs) + 60*(mns) + 3600*(hrs) + 86400*((dys)-1) + \
                        86400*(int)(.25+365.25*(float) \
                            ((yr) - (START_OF_TIME%100) + \
                            (((yr)<(START_OF_TIME%100))?100:0)))


/* Let the prototypes begin */

int check_audit(

        char inputline[],               /* Buffer of line of data       */
        char ceosids[3][4],             /* Ceos id's to consider        */
        long nceosids,                  /* # id's specified in ceosids  */
        char statflg[],                 /* Status flag of scene         */
        char sceneid[],                 /* Sceneid of scene             */
        struct TIMESTR *timestr         /* Time structure               */
);

int check_downl(

        char inputline[],               /* Data record from master sch  */
        char noaaid[CMLEN],             /* NOAA sceneid syntax string   */
        char sceneid[CMLEN],            /* Sceneid of pending scene     */
        struct TIMESTR *timestr         /* Time structure               */
);

void currtime(

        long *ctime             /* Current time in master schedule format */
);

int getinfo(

        char filnam[],                  /* Master schedule file name    */
        long *linenum,                  /* Starting line number in sched*/
        char ceosids[3][4],             /* CEOS id's to consider        */
        long nceosids,                  /* Number of id's in ceosids    */
        struct TIMESTR *timestr,        /* Time structure               */
        char noaaid[],                  /* NOAA scene id syntax         */
        char statflg[],                 /* Status flag                  */
        char sceneid[],                 /* Sceneid of pending scene     */
        char subcmd[]                   /* Sub-command                  */
);

int getpar(

        struct  PARBLK *vblock,         /* TAE parameter block           */
        char    subcmd[],               /* Sub-command                   */
        long    *linenum,               /* Line number to be returned    */
        char    filnam[],               /* Name of input file            */
        char    ceosids[3][4],          /* Array of ceos id's to consider*/
        long    *nceosids,              /* Number of ceos id's in ceosids*/
        struct TIMESTR *timestr         /* Time structure                */
);

int pasttime(

        char inputline[],               /* Line from Master schedule file */
        long timespec                   /* Specified time constraint      */
);

void taeland(

        struct PARBLK *vblock,  /* TAE parameter block                  */
        char subcmd[],          /* Sub-command                          */
        char noaaid[],          /* NOAA scene id syntax                 */
        char statflg[],         /* Status flag                          */
        char sceneid[],         /* Sceneid of pending scene             */
        long *linenum           /* Number of scenes pending             */
);


#endif
