/******************************************************************************
NAME:		TAELAND
 
PURPOSE:        Send relevant scene information back to TAE land.

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
 1.0       06/99    T. Baltzer          initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
                Run under TAE

PROJECT                 ADAPS

*******************************************************************************/
#include <stdio.h>              /* C standard I/O include file         */
#include "las.h"                /* LAS include                         */


void taeland(

	struct PARBLK *vblock,	/* TAE parameter block                  */
	char subcmd[],		/* Sub-command				*/
	char noaaid[],		/* NOAA scene id syntax			*/
	char statflg[],		/* Status flag of scene			*/
	char sceneid[],		/* Sceneid of pending scene		*/
	long *linenum 		/* Line number at which to start processing */
)

{

char *sptr[1];			/* pointer array for updating vblock    */
char tmpflgstr[4];		/* Temporary YES/NO flag string		*/

long i;                         /* counter                              */
long int_arr[1];		/* Integer array			*/


/* Output the string values to the variable block
--------------------------------------------------*/
if (*linenum)
    {
    strcpy(tmpflgstr,"YES");

    int_arr[0] = *linenum;
    if (q_intg(vblock,"LINENUM",1,int_arr,P_UPDATE) != SUCCESS)
	c_lasmsg(TRUE,"readmsch-rparm","Error returning parameter to TAE");

    if (strcmp(subcmd,"DOWNL") == 0)
	{
	sptr[0] = noaaid;
	if (q_string(vblock,"OUTFILE",1,sptr,P_UPDATE) != SUCCESS)
	    c_lasmsg(TRUE,"readmsch-rparm","Error returning parameter to TAE");
	}
    else
	{
	sptr[0] = statflg;
	if (q_string(vblock,"STATFLG",1,sptr,P_UPDATE) != SUCCESS)
	    c_lasmsg(TRUE,"readmsch-rparm","Error returning parameter to TAE");
	}

    sptr[0] = sceneid;
    if (q_string(vblock,"SCENE",1,sptr,P_UPDATE) != SUCCESS)
	c_lasmsg(TRUE,"readmsch-rparm","Error returning parameter to TAE");
    }
else
    {
    strcpy(tmpflgstr,"NO");
    }

sptr[0] = tmpflgstr;
if (q_string(vblock,"FOUNDFLG",1,sptr,P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE,"readmsch-rparm","Error returning parameter to TAE");


if (q_out(vblock) != SUCCESS)
    c_lasmsg(TRUE,"readmsch-rparm","Error returning parameter to TAE");

return;
}
