/******************************************************************************
FUNCTION:	CONSEC

PURPOSE:	Converts the total seconds from 1986 to year, month, day, hour,
		minute, and seconds.

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
  1.0      12/86     P. Mumford         Initial development
  5.0      10/92     T. Rockvam        	Conversion to LAS-5.0

ALGORITHM REFERENCES	none
*******************************************************************************/
#include "worgen.h"
#include "util2.h"
#include "autogen.h"


#define START_OF_TIME	1986
#define YEAR_OFFSET	1

void consec
(
    long        *totsecs,	/* Total seconds from 1986              */
    long        *year,		/* Year of totsecs                      */
    long        *jday,		/* Julian day of totsecs                */
    long        *month,		/* Month of totsecs                     */
    long        *day,		/* Day of totsecs                       */
    long        *hours,		/* Hour of totsecs                      */
    long        *minutes,	/* Minutes of totsecs                   */
    long        *seconds	/* Seconds of totsecs                   */
)
{
long	yr_size;		/* Number of days in the year		*/

int     flag = TRUE;		/* loop control variable		*/

/*
  Get number of minutes & seconds left over in totsecs
*/
*seconds = *totsecs;
*minutes = *seconds / 60;
*seconds %= 60;

/*
  Get number of hours & minutes left over
*/
*hours = *minutes / 60;
*minutes %= 60;

/*
  Get number of days & hours left over
*/
*jday = *hours / 24;
*hours %= 24;
*year = START_OF_TIME;

/*
  Add 1 to jday to count the target date
*/
*jday += 1;
while (flag)
    {
    if (c_isleap(year))
	yr_size = 366;
    else
	yr_size = 365;
    if (*jday <= yr_size)
	break;
    *jday -= yr_size;
    *year += 1;
    }

/*
  Find the month and day
*/
c_julgre(year,jday,month,day);

return;
}
