/******************************************************************************
FUNCTION:	MAKESECS

PURPOSE:	Compute the total number of seconds in the date and time
  		The number of seconds is used to write to the temporary 
		schedule file.

PROGRAM HISTORY:
Version    Date     Author      	Change Request
-------    -----    ---------   	--------------
  1.0      12/86     P. Mumford         Initial development
  5.0      10/92     T. Rockvam         Conversion to LAS-5.0
*******************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include "util2.h"
#include "autogen.h"



void makesecs
(
    long        date[],		/* date (month, day, year)              */
    long        time[],		/* time (hour, min, sec)                */
    long        *totsecs	/* total seconds                        */
)
{
long	jday;			/* julian day				*/
long	yr;			/* looping year				*/
long 	totdays;		/* total days from 1/1/1986		*/

/*
  Find number of days at given date
*/
c_grejul(&date[2],&date[0],&date[1],&jday);

/*
  Add up all days from beginning of time (1/1/1986) to now
  input year must be 4 digits
*/
totdays = 0;
for (yr = 1986; yr < date[2]; yr++)
    {
    if (c_isleap(&yr))
        totdays += 366;
    else
	totdays += 365;
    }
totdays += jday;

/*
  Add up the total seconds
*/
*totsecs = (totdays - 1) * 86400 + time[0] * 3600 + time[1] * 60 + time[2];

return;
}
