/******************************************************************************
FUNCTION:	SAVSCHED

PURPOSE:	Write the temporary file used to update the schedule

PROGRAM HISTORY:
Version    Date     Author      Change Request
-------    -----    ---------   --------------
1.0        4/87     Hollaren
2.0        6/89     LaVergne    updated to receive the output file names as
                                parameters so their version numbers are already
                                known.  This eliminates problems in batch.
5.0        10/92    T.Rockvam   Updated to LAS 5.0
*******************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include "autogen.h"


void savsched
(
    FILE        *sched,		/* schedule update file                 */
    char	*sceneid,	/* scene id                             */
    long        satid,		/* satellite number (10, 11, 12)        */
    long        start_sec,	/* acq total second start time          */
    long        stop_sec,	/* acq total second stop time           */
    long        opcode,		/* operation code                       */
    long        orbit		/* orbit number                         */
)
{
/*
  Write a record for the pass
*/
fprintf(sched, 
	"%16.16s %c%02d %09d %09d %09d %09d %1d %c %02d %c %c %4.4s %05d\n",
	 sceneid,'N',satid,start_sec,stop_sec,start_sec,stop_sec,
	 opcode,'P',99,'.','E',"HRPT",orbit);

return;
}
