#include <math.h>
#include "las.h"
#include "adaps.h"
#include "autogen.h"

extern float circle[NUMPNT][2];		/* pairs of long/lat	*/

void set_circle
(
    float       targlat,
    float       targlon
)
/****************************************************************************
 *									    *
 *	Purpose:  This function is designed to set up the coverage circle   *
 *		  about the given target				    *
 *									    *
 ****************************************************************************/
{
long 	i;

double	thislat,
	thislng;
double	rsat = 6378.0+870.0;		/* REQUA + SAT_ALTITUDE * 1000 */
double	re = 6378.0;			/* REQUA */
double	ran;
double	phi;
double	dlong;
double	angle;
double  deg_per_time;

ran = acos(re / rsat);
ran = PIE - (92*RAD_PER_DEG + asin(sin(92*RAD_PER_DEG)*re/rsat));

thislat = targlat * RAD_PER_DEG;
thislng = targlon * RAD_PER_DEG;
deg_per_time = 360.0 / NUMPNT;

for (i = 0; i < NUMPNT; i++)
    {
    angle = i * deg_per_time * RAD_PER_DEG;
    phi = acos(sin(thislat) * cos(ran) + cos(thislat) * sin(ran) * cos(angle));
    dlong = asin(sin(ran) * sin(angle) / sin(phi));
    circle[i][0] = (thislng + dlong) * DEG_PER_RAD;
    circle[i][1] = (HALFPIE - phi) * DEG_PER_RAD;
    }

return;
}
