/*****************************************************************************
NAME:		CALC_MAP_COEFS

PURPOSE:  Calculates mapping coefficients in the form:

    input = c[0] + (c[1]*outsamp) + (c[2]*outline) + (c[3]*outline*outsamp)
*****************************************************************************/
#include "worgen.h"

FUNCTION calc_map_coefs(tl,tr,bl,br,dx,dy,c)

double tl,tr,bl,br;	/* corners of input grid cell */
long dx,dy;		/* size of output grid cell */
double *c;		/* mapping coefficients */
{
c[0] = tl;
c[1] = (tr - tl) / dx;
c[2] = (bl - tl) / dy;
c[3] = (br - tr - bl + tl) / (dx * dy);
}
