#!/bin/csh
#
# check_conflict.csh
#
# $Log: check_conflict.csh,v $
# Revision 1.3  2003/09/29 12:29:29  dlloyd
# Made popup window full width of screen to make it visible even if shoacqu
# window is set to "always on top".
#
# Revision 1.2  2003/04/25 19:30:26  dlloyd
# changed executable name
#
# Revision 1.1  2003/04/25 18:15:45  dlloyd
# Initial checkin of module
#
#---------------------------------------------------------------------------

if ( ! $?DISPLAY ) then
    #setenv DISPLAY edclxw6.cr.usgs.gov:0.0
    setenv DISPLAY :0
endif

set now = `date +"%D %T"`
set ofile   = "$ADAPSTABLES/check_conflict.txt"
set logfile = "$ADAPSLOG/check_conflict.log"
set report  = "$ADAPSTABLES/schedcnflt.prt"

# If another instance is running quit
#------------------------------------
if ( -e $ADAPSTABLES/check_conflict.lock ) then
    echo "$now Already running, goodbye" >> $logfile
    exit 0
else
    echo "$now Locked" > $ADAPSTABLES/check_conflict.lock
endif

set return_stat = 10
while ( $return_stat > 0 )

    $LASTOOLS/check_conflict $report $ofile
    set return_stat = $status
    set now = `date +"%D %T"`

    if ( $return_stat == 5 ) then
	set process = `ps -e -o pid -o ucomm | grep chk_conf.tcl`
	set procid = `echo $process | awk '{print $1}'`
	if ( $procid > 0 ) then
	    echo "$now killing $procid" >> $logfile
	    kill -9 $procid
	endif
	echo "$now Issuing conflict warning 5" >> $logfile
	$LASTOOLS/chk_conf.tcl -geom 120x10+0+290 green &

    else if ( $return_stat == 3 ) then
	set process = `ps -e -o pid -o ucomm | grep chk_conf.tcl`
	set procid = `echo $process | awk '{print $1}'`
	if ( $procid > 0 ) then
	    echo "$now killing $procid" >> $logfile
	    kill -9 $procid
	endif
	echo "$now Issuing conflict warning 3" >> $logfile
	$LASTOOLS/chk_conf.tcl -geom 120x10+0+290 yellow &

    else if ( $return_stat == 1 ) then
	set process = `ps -e -o pid -o ucomm | grep chk_conf.tcl`
	set procid = `echo $process | awk '{print $1}'`
	if ( $procid > 0 ) then
	    echo "$now killing $procid" >> $logfile
	    kill -9 $procid
	endif
	echo "$now Issuing conflict warning 1" >> $logfile
	$LASTOOLS/chk_conf.tcl -geom 120x10+0+290 red &

    else if ( $return_stat ) then
	echo "$now error from check_conf" >> $logfile
	exit 1
    endif
    sleep 1
end

set process = `ps -e -o pid -o ucomm | grep chk_conf.tcl`
set procid = `echo $process | awk '{print $1}'`
if ( $procid > 0 ) then
    echo "$now killing $procid" >> $logfile
    kill -9 $procid
endif

if ( -e $ofile ) then
    rm -f $ofile
endif
rm -f $ADAPSTABLES/check_conflict.lock
touch $logfile
exit 0
