/*****************************************************************************
FUNTION:	getpar

PURPOSE:	Get input parameters from the TAE parameter block.

Version  Date	Programmer		Modifications
-------  -----  ----------------------  -------------------------------------
  1.0    09/97	D.Lloyd			Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS
	Run under TAE

PROJECT:	ADAPS
*****************************************************************************/
#include "las.h"


FUNCTION getpar( vblock, infile, logfile, sceneid )

struct PARBLK *vblock;		/* variable block			*/

char *infile;			/* input file name			*/
char *logfile;			/* log file name			*/
char *sceneid;			/* scene identification			*/
{
long  access;			/* file accesss flag			*/
long  element = 0;		/* element number for getnam		*/
long  status;			/* function return status		*/

struct VARIABLE *p_find();      /* function to find a TAE variable      */
struct VARIABLE *val;           /* pointer to a TAE variable            */

/*
  Get the input file name
*/
access = IREAD;
status = c_getnam( vblock, "INFILE", &element, infile, "arch", &access );
if ( status != E_SUCC )
    return E_FAIL;


/*
  Extract just the sceneid
*/
val = p_find( vblock, "INFILE" );
strcpy( sceneid, SVAL( *val, 0 ));


/*
  Get log file name
*/
access = IUPDATE;
c_getnam( vblock, "LOGFILE", &element, logfile, "log", &access );
if ( status != E_SUCC )
    return E_FAIL;


return E_SUCC;

}  /* END getpar */
