      SUBROUTINE ASEBCD (INSTR, OUTSTR)                                 
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- ASEBCD                                                        
C                                                                       
C   LANGUAGE- VSFORT      TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 04/18/89   PROGRAMMER- MOJGAN SYLVA (SMSRC)   
C   VERSION- 1.1    DATE- 11/18/92   PROGRAMMER- DEBBIE CARR (SMSRC)    
C                                                                       
C   FUNCTION-*$ED23MS* CONVERTS ASCII INSTRS TO EBCDIC.                 
C                      (ORIGINAL NAME, AECONV)                          
C                                                                       
C      VERSION 1.1 - ADAPTED FOR CLAVR PROCESSING.                      
C                                                                       
C   PARAMETERS-                                                         
C      VARIABLE                TYPE I/O FUNCTION                        
C      --------                ---- --- --------                        
C                                                                       
C   LOCAL KEY-                                                          
C      VARIABLE                TYPE     FUNCTION                        
C      --------                ----     --------                        
C                                                                       
C   FILES-                                                              
C      DSN OR DESCRIPTIVE TITLE  I/O UNIT FUNCTIONAL DESCRIPTION        
C      ------------------------  --- ---- ----------------------        
C                                                                       
C   SUBPROGRAMS CALLED-                                                 
C                                                                       
C                                                                       
C   COMMENTS-                                                           
C                                                                       
C   COMMON AREAS-                                                       
C                                                                       
C   BLOCK DATAS-                                                        
C********************************************************************** 
C                                                                       
C                                                                       
C                                                                       
       INTEGER*4    STRLEN, ASCII                                       
       CHARACTER    INSTR, OUTSTR                                       
       CHARACTER*1  CTABLE(0:255), EBCDIC                               
C                                                                       
       DATA  STRLEN /122/                                               
C                                                                       
C == INITIALIZE TRANSLATION TABLE ===================================== 
C CTABLE IS A TRANSLATE TABLE FOR THE CHARACTERS.  NOTE THAT BY         
C CHANGING CTABLE, ONE CAN CHANGE THE TRANSLATION FUNCTION.             
C                                                                       
       DATA CTABLE /                                                    
     * $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F, 
     * $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F, 
     * $40,$5A,$7F,$7B,$5B,$6C,$50,$7D,$4D,$5D,$5C,$4E,$6B,$60,$4B,$61, 
     * $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$7A,$5E,$4C,$7E,$6E,$6F, 
     * $7C,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$D1,$D2,$D3,$D4,$D5,$D6, 
     * $D7,$D8,$D9,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$AD,$E0,$BD,$5F,$6D, 
     * $79,$81,$82,$83,$84,$85,$86,$87,$88,$89,$91,$92,$93,$94,$95,$96, 
     * $97,$98,$99,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$C0,$4F,$D0,$A1,$7F, 
     * $80,$81,$82,$83,$84,$85,$86,$87,$88,$08,$8A,$8B,$8C,$8D,$8E,$8F, 
     * $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F, 
     * $A0,$A1,$A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF, 
     * $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF, 
     * $C0,$C1,$C2,$C3,$C4,$C5,$C6,$C7,$C8,$C9,$CA,$CB,$CC,$CD,$CE,$CF, 
     * $D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF, 
     * $E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,$EA,$EB,$EC,$ED,$EE,$EF, 
     * $F0,$F1,$F2,$F3,$F4,$F5,$F6,$F7,$F8,$F9,$FA,$FB,$FC,$FD,$FE,$FF  
     *             /                                                    
C                                                                       
C                                                                       
C                                                                       
C == CONVERT ========================================================== 
C FOR EACH CHARACTER IN INSTR TO BE CONVERTED, LOOK UP THE IN CTABLE    
C FOR THE CORRESPONDING TRANSLATED CHARACTER.  REPLACE THE INPUT        
C CHARACTER WITH ITS TRANSLATED VALUE, AND GO TO NEXT CHARACTER.        
C                                                                       
       DO 10 I=1,STRLEN                                                 
C                                                                       
         ASCII=ICHAR(INSTR(I:I))                                        
         EBCDIC=CTABLE(ASCII)                                           
         OUTSTR(I:I)=EBCDIC                                             
C                                                                       
 10    CONTINUE                                                         
C                                                                       
C                                                                       
       RETURN                                                           
       END                                                              
