      SUBROUTINE ATTRIB (IREC)                                          
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- ATTRIB                                                        
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 02/04/93   PROGRAMMER- DEBBIE CARR (SMSRC)    
C                                                                       
C                                                                       
C   FUNCTION-                                                           
C                                                                       
C      DETERMINES MISCELLANEOUS ATTRIBUTES OF THE DATA.                 
C                                                                       
C                                                                       
C   LOCAL PARAMETERS-                                                   
C                                                                       
C      VARIABLE                TYPE  FUNCTION                           
C      --------                ----  --------                           
C      FINLIN (35)             C*1   A FINAL MESSAGE OUTPUT LINE        
C                                                                       
C                                                                       
C                                                                       
C   COMMON AREAS- INCLAV (CONSTANTS), TYPDAT, GEOG                      
C                                                                       
C                                                                       
C   CALLED BY-  CLAVRORB                                                
C                                                                       
C                                                                       
C   SUBPROGRAMS CALLED-                                                 
C                                                                       
C                                                                       
C   RESTRICTIONS-                                                       
C                                                                       
C                                                                       
C   COMMENTS-                                                           
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...LINK IN PARAMETER CONSTANTS AND COMMON AREAS.                       
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/typdat.f"                                                  
      INCLUDE "inc/geog.f"                                                    
      INCLUDE "inc/angle.f"                                                   
      INCLUDE "inc/atmisc.f"                                                  
      INCLUDE "inc/qcflgs.f"                                                  

ccc	luo 9/28/95
	include "inc/adstore.f"

C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...DECLARE VARIABLES.                                                  
C                                                                       

ccc luo      INTEGER*4  ADLAST, ADMASK, IREC,                                  
      INTEGER*4  ADMASK, IREC,                                  
     1           CCHECK, CTAG, L1, L2, L3, L4                           
C                                                                       

ccc luo      REAL*4     NADLST, NADLS2                                         

C                                                                       
      LOGICAL*4  FIRST                                                  
C                                                                       
C                                                                       
      DATA  ADMASK /$0001/, FIRST /.TRUE./                              
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C                                                                       
      IF (GAC) THEN                                                     
C                                                                       
        ILAT = INT(100.0*SPLAT(205))                                    
C                                                                       
C...STORE NADIR LATITUDE AND LONGITUDE.                                 
C                                                                       
        NADLAT(IREC) = FLOAT(ILAT)/100.0                                
        NADLON(IREC) = SPLON(205)                                       
C                                                                       
      ELSE                       
C                                !  /* LAC DATA */                      
C                                                                       
        NADLAT(IREC) = SPLAT(IPBEG + (IPEND-IPBEG)/2)                   
        NADLON(IREC) = SPLON(IPBEG + (IPEND-IPBEG)/2)                   
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
C...IF PROCESSING THE FIRST BLOCK, INITIALIZE VARIABLES AND 
C   DETERMINE WHETHER THE PAIR OF SCANS ARE ASCENDING OR                
C   DESCENDING BASED ON THE 1B QUALITY FLAG.                            
C                                                                       
      IF (FIRST) THEN
C                                                                       
        ADFLAG(1) = IAND( ISHFT(IQUAL(1),-9),ADMASK)                    
        ADFLAG(2) = IAND( ISHFT(IQUAL(2),-9),ADMASK)                    
C                                                                       
        ADLAST = ADFLAG(2)                                              
C                                                                       
        NADLST = NADLAT(IREC)                                           
        NADLS2 = NADLAT(IREC)                                           
C                                                                       
CCC     WRITE (6, 1010) NADLAT(IREC), ADFLAG(1), ADFLAG(2)              
C                                                                       
        FIRST = .FALSE.                                                 
C                                                                       
      ELSE                                                              
C                                                                       
        IF (NADLAT(IREC) .LT. NADLST .AND.                              
     1      NADLAT(IREC) .LT. NADLS2) THEN                              
              ADFLAG(IREC) = 1          
                                
        ELSE IF(NADLAT(IREC) .GT. NADLST .AND.                          
     1          NADLAT(IREC) .GT. NADLS2) THEN
              ADFLAG(IREC) = 0
        ELSE
              ADFLAG(IREC) = ADLAST 
        END IF 
C                                                                       
      END IF
C 
       IF (ADLAST.NE.ADFLAG(IREC)) THEN  
c           WRITE(6,1000) ADFLAG(IREC),ADLAST,                  
c     1                NADLAT(IREC),NADLST
        ADLAST = ADFLAG(IREC)
        END IF
C
      NADLS2 = NADLST 
      NADLST = NADLAT(IREC)
C
C
C...SET FLAGS FOR INDIVIDUAL PIXELS.................................... 
C                                                                       
C     DAY   ==> 0          SEA  ==> 0         NO COAST ==> 0            
C     NIGHT ==> 1          LAND ==> 1            COAST ==> 1            
C                                                                       
C                                                                       
C.......DAY / NIGHT FLAGS.............................................. 
C                                                                       
      DO 10 IPIX = 1, NPIXLS                                            
C                                                                       
         IF (SOLZ(IPIX) .GT. DAYLIM) THEN                               
           DAYNIT (IPIX, IREC) = 1                                      
         ELSE                                                           
           DAYNIT (IPIX, IREC) = 0                                      
         ENDIF                                                          
C                                                                       
   10 CONTINUE                                                          
C                                                                       
C                                                                       
C.......LAND / SEA FLAGS............................................... 
C                                                                       
      CALL GHRLST(IREC)                                                 
C                                                                       
C                                                                       
C.......COAST TAGS..................................................... 
C       (DETERMINED ONLY IF PROCESSING 2ND SCAN IN PAIR)                
C                                                                       
      IF (IREC .EQ. 2) THEN                                             
C                                                                       
        DO 20 IPIX = 1, NPIXLS-1, 2                                     
C                                                                       
          L1 = LSBUF(IPIX,1)                                            
          L2 = LSBUF(IPIX,2)                                            
          L3 = LSBUF(IPIX+1,1)                                          
          L4 = LSBUF(IPIX+1,2)                                          
C                                                                       
          CCHECK = L1 + L2 + L3 + L4                                    
C                                                                       
          IF ((CCHECK .EQ. 0) .OR. (CCHECK .EQ. 4)) THEN                
            CTAG = 0                                                    
          ELSE                                                          
            CTAG = 1                                                    
          END IF                                                        
C                                                                       
          COASTG(IPIX,1)   = CTAG                                       
          COASTG(IPIX,2)   = CTAG                                       
          COASTG(IPIX+1,1) = CTAG                                       
          COASTG(IPIX+1,2) = CTAG                                       
C                                                                       
   20   CONTINUE                                                        
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (3X,'  ADFLAG =', I2,', ADLAST =', I4,                     
     1        ' NADLAT =', F8.2,', NADLAST =', F8.2)                    
C                                                                       
 1010 FORMAT (/, 2X, 'SUBROUTINE ATTRIB:  1ST SCAN PAIR AFTER SYNC, ',  
     1        'NADLAT =', F6.2,'  ADFLAG1 =', I2, '  ADFLAG2 =', I2)    
C                                                                       
      END                                                               
