      SUBROUTINE AVHEDR (HEADER)                                        
C****************************************************************       
C                                                                       
C      FUNCTION: THIS SUBROUTINE WILL UNPACK THE AVHRR GAC AND          
C                LAC 1B HEADER RECORDS.                                 
C                                                                       
C      INPUTS:                                                          
C       HEADER - AVHRR UNPACKED DATA                                    
C                                                                       
C                                                                       
C     CALLED FROM:                                                      
C       MAIN                                                            
C                                                                       
C     SUBROUTINES CALLED:                                               
C       NONE                                                            
C                                                                       
C******************************************************************     
C                                                                       
C                                                                       
      INCLUDE "inc/ohed1c.f"                                                  
C                                                                       
C                                                                       
      CHARACTER*7   PROCID                                              
      CHARACTER*13  NOISE(0:1), DSOURC(0:3), TAPDIR(0:1), DMODE(0:1)    
C                                                                       
      INTEGER*4 HEADER(*), IBTEMP(2), STAT1, STAT2, STAT3, STAT4        
C                                                                       
C                                                                       
      EQUIVALENCE (IBTEMP, PROCID)                                      
C                                                                       
C                                                                       
      DATA  MASK7/$0000007F/,MASK4/$0000000F/,MASK9/$000001FF/          
C                                                                       
      DATA  NOISE / 'NORMAL DATA  ', 'P/N DATA     ' /                  
      DATA  DSOURC/ 'UNUSED/UNKNWN', 'GILMORE CREEK',                   
     1              'WALLOPS ISLND', 'SOCC         ' /                  
      DATA  TAPDIR/ 'REV- TIME DEC', 'FWD- TIME INC' /                  
      DATA  DMODE / 'TEST DATA    ', 'FLIGHT DATA  ' /                  
C                                                                       
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
C                                                                       
C... UNPACK SPACECRAFT ID.                                              
C                                                                       
      NSAT = ISHFT(HEADER(1),-24)                                       
C                                                                       
      IF (NSAT.LT.1 .OR. NSAT.GT.8) NSAT = 0                            
C                                                                       
C                                                                       
C... STORE CRAFT TITLE IN COMMON AREA.                                  
C                                                                       
      CRAFT = SPC(NSAT)                                                 
C                                                                       
C                                                                       
C... UNPACK PROCESSING BLOCK ID (ORBIT NUMBER).                         
C                                                                       
      IBTEMP(1) = HEADER( 5)                                            
      IBTEMP(2) = HEADER( 6)                                            
C                                                                       
C... CONVERT PROCESSING BLOCK ID TO INTEGER/ORBIT NUMBER.               
C                                                                       
      ORBNUM = 0                                                        
C                                                                       
      DO 10 I = 1, 7                                                    
C       write(6,*)  PROCID(I:I),(ICHAR(PROCID(I:I)))
C       ORBNUM = ( ORBNUM + ( (ICHAR(PROCID(I:I)) - 240) * 10**(7-I) ) )
        ORBNUM = ( ORBNUM + ( (ICHAR(PROCID(I:I)) -  48) * 10**(7-I) ) )
C       write(6,*)  ORBNUM 
   10 CONTINUE                                                          
C     WRITE(*,*)' ORBIT NUMBER:', ORBNUM
C                                                                       
C                                                                       
C... UNPACK DATA TYPE.                                                  
C                                                                       
      IDUM   = ISHFT( HEADER(1), 8 )                                    
      DATYPE = ISHFT( IDUM, -28 )                                       
      IF ( (DATYPE .LT. 1) .OR. (DATYPE .GT. 3) )                       
     1     CALL EMESG (5, 'AVHEDR', 'OK')                               
C                                                                       
C                                                                       
C... UNPACK START TIME OF ORBIT (YEAR AND DAY OF YEAR).                 
C                                                                       
      IDUM   = ISHFT(HEADER(1),-9)                                      
      OSYEAR = IAND(MASK7,IDUM)                                         
      OSDAY  = IAND(MASK9,HEADER(1))                                    
      OSDATE = OSYEAR * 1000 + OSDAY                                    
C                                                                       
C                                                                       
C... UNPACK START TIME OF ORBIT (MILLISECONDS), THEN CONVERT TO         
C    HOUR AND MINUTES.                                                  
C                                                                       
      OSSEC  = HEADER(2)                                                
      RSHOUR = OSSEC / 3600000.0                                        
      OSHOUR = INT(RSHOUR)                                              
      OSMINS = INT( (RSHOUR - OSHOUR) * 60.0 )                          
      OSTIME = OSHOUR * 100 + OSMINS                                    
C                                                                       
C                                                                       
C... UNPACK END TIME OF ORBIT (YEAR AND DAY OF YEAR).                   
C                                                                       
      IDUM   = ISHFT(HEADER(3),-9)                                      
      OEYEAR = IAND(MASK7,IDUM)                                         
      OEDAY  = IAND(MASK9,HEADER(3))                                    
      OEDATE = OEYEAR * 1000 + OEDAY                                    
C                                                                       
C                                                                       
C... UNPACK END TIME OF ORBIT (MILLISECONDS), THEN CONVERT TO           
C    HOUR AND MINUTES.                                                  
C                                                                       
      OESEC  = HEADER(4)                                                
      REHOUR = OESEC / 3600000.0                                        
      OEHOUR = INT(REHOUR)                                              
      OEMINS = INT( (REHOUR - OEHOUR) * 60.0 )                          
      OETIME = OEHOUR * 100 + OEMINS                                    
C                                                                       
C                                                                       
C... UNPACK RAMP / AUTO CALIBRATION PARAMETERS.                         
C                                                                       
      RMPCAL = ISHFT( ISHFT( HEADER(6), 27), -27)                       
C                                                                       
C                                                                       
C... UNPACK NUMBER OF SCANLINES IN THIS ORBIT.                          
C                                                                       
      NUMSCN = ISHFT(HEADER(3),-16)                                     
C                                                                       
C                                                                       
C... UNPACK NUMBER OF DATA GAPS IN THIS ORBIT.                          
C                                                                       
      NUMGAP = ISHFT(HEADER(7),-16)                                     
C                                                                       
C                                                                       
C... UNPACK DATA AQUISITION AND CONTROL SYSTEM (DACS) QUAL. INDICATORS: 
C                                                                       
C    "NOSYNC" ==> # INPUT DATA FRAMES WITHOUT SYNC ERRORS               
C    "PARERR" ==> # TIP PARITY ERRORS                                   
C    "AUXSYC" ==> # AUXILIARY SYNC ERRORS                               
C                                                                       
      NOSYNC = ISHFT( ISHFT(HEADER(7),16), -16)                         
      PARERR = ISHFT(HEADER(8),-16)                                     
      AUXSYC = ISHFT( ISHFT(HEADER(8),16), -16)                         
C                                                                       
C                                                                       
C... UNPACK CALIBRATION PARAMETER ID.                                   
C                                                                       
      IDCALP = ISHFT(HEADER(9),-16)                                     
C                                                                       
C                                                                       
C... UNPACK DACS STATUS INFORMATION:                                    
C                                                                       
C    BIT 1    ==>  PSEUDO NOISE (P/N) FLAG                              
C                    0 = NORMAL DATA                                    
C                    1 = P/N DATA                                       
C    BITS 2-3 ==>  DATA SOURCE ("GRDSTA")                               
C                    0 = (UNUSED)                                       
C                    1 = GILMORE CREEK, AK                              
C                    2 = WALLOPS ISLAND, VA                             
C                    3 = SOCC                                           
C    BIT 4 ==>     TAPE DIRECTION                                       
C                    0 = REVERSE (TIME DECREMENTING)                    
C                    1 = FORWARD (TIME INCREMENTING)                    
C    BIT 5 ==>     DATA MODE                                            
C                    0 = TEST DATA                                      
C                    1 = FLIGHT DATA                                    
C    BITS 6-8 ==>  SPARE                                                
C                                                                       
      DACSTA = ISHFT( ISHFT(HEADER(9),16), -24)                         
C                                                                       
      STAT1 = ISHFT(DACSTA,-7)                                          
      STAT2 = ISHFT(ISHFT(DACSTA,25),-30)                               
      STAT3 = ISHFT(ISHFT(DACSTA,27),-31)                               
      STAT4 = ISHFT(ISHFT(DACSTA,28),-31)                               
C                                                                       
      GRDSTA = STAT2                                                    
C                                                                       
C     WRITE (6,*)                                                       
C     WRITE (6,*)                                                       
C     WRITE (6,*) ' DACS STATUS INFORMATION'                            
C     WRITE (6,*) ' -------------------------------------------'        
C     WRITE (6,*) ' PSEUDO NOISE FLAG ==>  ', NOISE(STAT1)              
C     WRITE (6,*) ' DATA SOURCE       ==>  ', DSOURC(STAT2)             
C     WRITE (6,*) ' TAPE DIRECTION    ==>  ', TAPDIR(STAT3)             
C     WRITE (6,*) ' DATA MODE         ==>  ', DMODE(STAT4)              
C                                                                       
C     WRITE(6,6003) SPC(NSAT),CDATYP(DATYPE)                            
C     WRITE(6,6004) OSYEAR,OSDAY,OSSEC                                 
C     WRITE(6,6005) OEYEAR,OEDAY,OESEC                                  
C     WRITE(6,6006) NUMSCN,NUMGAP                                       
      WRITE(6,6000) ORBNUM,SPC(NSAT),NUMSCN,NUMGAP,
     1 OSYEAR,OSDAY,OSHOUR, OSMINS,OEYEAR,OEDAY,OEHOUR,OEMINS  
C                                                                       
 1000 FORMAT(I4)                                                        
 6001 FORMAT(' SPACECRAFT ID (NSAT) ==> ',I2)                           
 6003 FORMAT(/, ' CRAFT = ',A8,' DATA TYPE = ',A4)                      
 6004 FORMAT(/, ' START YEAR = ',I10,' DAY = ',I10,' TIME = ',I10)      
 6005 FORMAT(   ' END YEAR   = ',I10,' DAY = ',I10,' TIME = ',I10)      
 6006 FORMAT(/, ' NUMBER OF SCANS = ',I10,' NUMBER OF GAPS = ',I10)     
 6000 FORMAT(1X,'ORBIT #  CRAFT ID  # OF SCANS # OF GAPS ',
     1          'START YR/DAY/ TIME  END YR/DAY/ TIME',/,
     2   1X,I7,2X,A8,3X,I9,1X,I9,7X,I2,'/',I3.3,'/',I2.2,':',I2.2 
     3                          ,6X,I2,'/',I3.3,'/',I2.2,':',I2.2) 
C                                                                       
      RETURN                                                            
      END                                                               
