       SUBROUTINE C3AR (P,RS,PF,TH,CO)                                  
C********************************************************************** 
C                                                                       
C       FUNCTION - CHANNEL 3 ALBEDO RESTORAL TEST. THIS TEST            
C        WILL TAKE THE PIXEL ARRAYS THAT HAVE FAILED THE RGCT           
C        OR RUT (CLOUD/MIXED) AND DETERMINE IF THE PIXELS SHOULD        
C        BE RESTORED TO CLEAR PIXELS                                    
C                                                                       
C       INPUT:                                                          
C        PIX   -   CHANNEL 3 ALBEDO                                     
C        TH    -   LAND/OCEAN THRESHOLDS                                
C        PF    -   PREVIOUS CLEAR/CLOUD/MIXED FLAG                      
C                                                                       
C       OUTPUT:                                                         
C        RS    -   RESTORAL FLAG. 0=RESTORED,1 OR 2=NOT RESTORED        
C                 (I.E. REMAINS CLOUDY OR MIXED)                        
C        CO    -   CLEAR/CLOUD FLAG                                     
C                                                                       
C********************************************************************** 
C                                                                       
       INCLUDE "inc/baddat.f"                                                 
C                                                                       
C                                                                       
       REAL P(4,6), PIX(4), TH, T3(4)                                   
C                                                                       
       INTEGER*4 RS,PF                                                  
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
       ICT=0                                                            
C                                                                       
C                                                                       
C......LOAD CHANNEL 3 ALBEDOS AND CHANNEL 3 TEMPERATURES INTO ARRAYS.   
C                                                                       
       DO 2 I = 1,4                                                     
C                                                                       
         PIX(I) = P(I,3)                                                
         T3(I)  = P(I,4)                                                
C                                                                       
    2 CONTINUE                                                          
C                                                                       
C......IF CHANNEL 3 TEMPERATURE IS BAD THEN SKIP THE TEST.              
C      (RSKPCC = 999.0)                                                 
C                                                                       
       DO 3 I = 1,4                                                     
C                                                                       
CCCCCCC                                                                 
C       IF ( (T3(I) .LT. 100.0) .OR. (T3(I) .GT. 370.0) ) THEN          
C         WRITE (6,*) '  && C3AT, BAD CH3T = ', T3(I),                  
C    1      '  RSKPCC = ', RSKPCC                                       
C       END IF                                                          
CCCCCCC                                                                 
         IF (T3(I) .EQ. RSKPCC ) THEN                                   
           TSTSKP (2,4) = TSTSKP(2,4) + 1                               
           GO TO 30                                                     
         END IF                                                         
C                                                                       
    3 CONTINUE                                                          
C                                                                       
C                                                                       
C...ACCUMULATE NUMBER OF TIMES CHANNEL 3 ALBEDO IS LESS THAN THRESHOLD  
C                                                                       
       DO 10 I=1,4                                                      
         IF(PIX(I).LT.TH) THEN                                          
            ICT = ICT + 1                                               
         ENDIF                                                          
 10    CONTINUE                                                         
C                                                                       
C...ALL FOUR PIXELS MUST BE LESS THAN THRESHOLD FOR ARRAY TO BE         
C...RESTORED TO CLEAR                                                   
C                                                                       
       IF(ICT.LT.4) GO TO 30                                            
       RS=0                                                             
       PF=0                                                             
      DO 20 I = 1, 4                                                    
         CO(I) = 0                                                      
   20 CONTINUE                                                          
       GO TO 40                                                         
C                                                                       
   30  CONTINUE                                                         
       RS=PF                                                            
C                                                                       
   40  CONTINUE                                                         
C                                                                       
       RETURN                                                           
       END                                                              
