       SUBROUTINE C3AT(P, PF, TH, CO)                                   
C********************************************************************** 
C                                                                       
C       FUNCTION - CHANNEL 3 ALBEDO TEST                                
C                                                                       
C       INPUT:                                                          
C        PIX  -  CHANNEL 3 ALBEDO PIXEL ARRAY                           
C        TH   -  LAND/OCEAN THRESHOLD                                   
C                                                                       
C       OUTPUT:                                                         
C        PF   -  CLEAR/CLOUD/MIXED FLAG                                 
C        CO   -  CLEAR/CLOUD FLAG                                       
C                                                                       
C********************************************************************** 
C                                                                       
       INCLUDE "inc/baddat.f"                                                 
C                                                                       
C                                                                       
       REAL*4  P(4,6), PIX(4), TH, T3(4), T5(4)                         
       INTEGER*4 PF                                                     
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
      ICT=0                                                             
C                                                                       
C                                                                       
C                                                                       
C.....LOAD CHANNEL 3 ALBEDOS, CHANNEL 3 TEMPERATURES, AND CHANNEL 5     
C     TEMPERATURES INTO ARRAYS                                          
C                                                                       
      DO 2 I = 1,4                                                      
C                                                                       
          PIX(I) = P(I,3)                                               
          T3(I)  = P(I,4)                                               
          T5(I)  = P(I,6)                                               
C                                                                       
    2 CONTINUE                                                          
C                                                                       
C...INSPECT CHANNEL 5 TEMPERATURE.  IF SATURATED (I.E., T5 > 315)       
C   SKIP THE CHANNEL 3 ALBEDO TEST.  ALSO, IF CHANNEL 3 TEMPERATURE     
C   IS BAD SKIP THE CHANNEL 3 ALBEDO TEST. (RSKPCC = 999.0)             
C                                                                       
C                                                                       
      DO 4 I = 1,4                                                      
C                                                                       
        IF (T3(I) .EQ. RSKPCC) THEN                                     
          TSTSKP(3,4) = TSTSKP(3,4) + 1                                 
          GO TO 20                                                      
        END IF                                                          
C                                                                       
        IF (T5(I) .GT. 315) THEN                                        
          TSTSKP(3,6) = TSTSKP(3,6) + 1                                 
          GO TO 20                                                      
        END IF                                                          
C                                                                       
    4 CONTINUE                                                          
C                                                                       
C                                                                       
C                                                                       
C...ACCUMULATE THE NUMBER OF TIMES THAT CHANNEL 3 ALBEDO IS GREATER     
C...THAN THE THRESHOLD                                                  
C                                                                       
      DO 10 I=1,4                                                       
         IF(PIX(I).GT.TH) THEN                                          
            ICT = ICT + 1                                               
            CO(I) = 1                                                   
         ELSE                                                           
            CO(I) = 0                                                   
         ENDIF                                                          
 10   CONTINUE                                                          
C                                                                       
 20   CONTINUE                                                          
C                                                                       
      IF(ICT.EQ.4) PF=1                                                 
      IF(ICT.EQ.0) PF=0                                                 
      IF(ICT.GT.0.AND.ICT.LT.4) PF=2                                    
C                                                                       
      RETURN                                                            
      END                                                               
