       SUBROUTINE CIRT(P,PF,CO)                                         
C********************************************************************** 
C                                                                       
C                                                                       
C      FUNCTION - (CHANNEL 3 - MINUS - CHANNEL 5) OVER CHANNEL 5 TEST   
C                                                                       
C      INPUTS:                                                          
C       PIX3  - CHANNEL 3 TEMPERATURE                                   
C       PIX4  - CHANNEL 4 TEMPERATURE                                   
C       PIX5  - CHANNEL 5 TEMPERATURE                                   
C                                                                       
C      OUTPUTS:                                                         
C       CO    - CLEAR/CLOUDY FLAG                                       
C       PF    - PASS/FAIL FLAG 0=CLEAR, 1=CLOUDY, 2=MIXED               
C                                                                       
C***********************************************************************
C                                                                       
      INCLUDE "inc/nitlu.f"                                                   
      INCLUDE "inc/baddat.f"                                                  
C                                                                       
C                                                                       
      REAL*4    P(4,6), PIX3(4), PIX4(4), PIX5(4)                       
C                                                                       
      INTEGER*4 PF, T4                                                  
      INTEGER*2 CO(4)                                                   
C                                                                       
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
      ICT = 0                                                           
C                                                                       
C                                                                       
C.....LOAD CHANNEL 3,4,5 TEMPERATURES INTO ARRAYS                       
C                                                                       
      DO 2 I = 1,4                                                      
C                                                                       
        PIX3(I) = P(I,4)                                                
        PIX4(I) = P(I,5)                                                
        PIX5(I) = P(I,6)                                                
C                                                                       
    2 CONTINUE                                                          
C                                                                       
C                                                                       
C.....INSPECT CHANNEL 5 TEMPERATURES.  IF SATURATED, THEN SKIP          
C     THE ULST TEST.  ALSO, IF CHANNEL 3 TEMPERATURE IS BAD, THEN       
C     SKIP TEST. (RSKPCC = 999.0)                                       
C                                                                       
      DO 3 I = 1,4                                                      
C                                                                       
         IF (PIX3(I) .EQ. RSKPCC) THEN                                  
           TSTSKP (1,4) = TSTSKP (1,4) + 1                              
           GO TO 20                                                     
         END IF                                                         
C                                                                       
         IF (PIX5(I) .GT. 310.0) THEN                                   
C                                                                       
           CO(1) = 0                                                    
           CO(2) = 0                                                    
           CO(3) = 0                                                    
           CO(4) = 0                                                    
C                                                                       
           TSTSKP (1,6) = TSTSKP (1,6) + 1                              
           GO TO 20                                                     
C                                                                       
         ENDIF                                                          
C                                                                       
    3 CONTINUE                                                          
C                                                                       
C                                                                       
C***********************************************************************
C                                                                       
      DO 10 I = 1,4                                                     
C                                                                       
C...TEST EACH PIXEL TO SEE IF IT'S CHANNEL 5 VALUE HAS SATURATED        
C                                                                       
CCCC     IF (PIX5(I).GT.310.0) THEN                                     
CCCC        CO(I) = 0                                                   
CCCC        GO TO 10                                                    
CCCC     ENDIF                                                          
C                                                                       
         T4 = NINT(PIX4(I))                                             
         IF (T4.GT.320) THEN                                            
            T4 = 320                                                    
         ELSE IF (T4.LT.200) THEN                                       
            T4 = 200                                                    
         ENDIF                                                          
C                                                                       
C...TEST FOR NUMBER OF TIMES THE CHANNEL 3-5/5 VALUE EXCEEDS THE THRES. 
C                                                                       
         DIF = (PIX3(I)-PIX5(I))/PIX5(I)                                
         IF(DIF.GT.CIRTLU(T4)) THEN                                     
            ICT = ICT + 1                                               
            CO(I) = 1                                                   
          ELSE                                                          
            CO(I) = 0                                                   
         ENDIF                                                          
   10 CONTINUE                                                          
C                                                                       
   20 CONTINUE                                                          
      IF(ICT.EQ.4) PF=1                                                 
      IF(ICT.EQ.0) PF=0                                                 
      IF(ICT.GT.0.AND.ICT.LT.4) PF=2                                    
  999 RETURN                                                            
      END                                                               
