      SUBROUTINE FMFT(PIX4, PIX5, LSTAG, PF, CO)                        
C********************************************************************** 
C                                                                       
C      FUNCTION - CHANNEL 4 - MINUS - CHANNEL 5 TEST.                   
C                                                                       
C      CHANGES FOR CLAVR ALGORITHM VERSION A.3H:                        
C      ---------------------------------------------------------------- 
C      (1)  LAND/SEA TAG NOW PASSED INTO SUBROUTINE SO THAT THE         
C           SOFTWARE CAN DETERMINE IF THRESHOLD LIMITS FOR LAND         
C           AREAS OR OCEANS SHOULD BE UTILIZED FOR THE 2X2 ARRAY        
C           DURING THE TEST OF THE CH4 - CH5 TEMPERATURE DIFFERENCE.    
C                                                                       
C      INPUTS:                                                          
C       PIX4    - CHANNEL 4 TEMPERATURE                                 
C       PIX5    - CHANNEL 5 TEMPERATURE                                 
C       LSTAG   - LAND/SEA TAG                                          
C                                                                       
C      OUTPUTS:                                                         
C       PF      - PASS/FAIL (0=CLEAR,1=CLOUDY,2=MIXED) FLAG             
C       CO      - CLEAR/CLOUD FLAG                                      
C                                                                       
C********************************************************************** 
C                                                                       
      REAL PIX4(4),PIX5(4)                                              
      INTEGER*4 PF, T4, LSTAG                                           
      INTEGER*2 CO(4)                                                   
C                                                                       
      INCLUDE "inc/daylu.f"                                                   
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
      ICT=0                                                             
      DO 10 I=1,4                                                       
C                                                                       
C...TEST IF CHANNEL 5 TEMPERATURE IS SATURATED                          
C                                                                       
         IF (PIX5(I).GT.315.0) THEN                                     
            CO(I) = 0                                                   
            GO TO 10                                                    
         ENDIF                                                          
C                                                                       
         T4 = NINT(PIX4(I))                                             
         IF (T4.GT.320) THEN                                            
            T4 = 320                                                    
         ELSE IF (T4.LT.200) THEN                                       
            T4 = 200                                                    
         ENDIF                                                          
C                                                                       
C...TEST FOR NUMBER OF TIMES THE CHANNEL 4-5 DIFFERENCE EXCEED THE THSH 
C                                                                       
         DIF=PIX4(I)-PIX5(I)                                            
C                                                                       
         IF (LSTAG .EQ. 1) THEN                                         
           DLIMIT = FMFLND(T4)                                          
         ELSE                                                           
           DLIMIT = FMFOCN(T4)                                          
         END IF                                                         
C                                                                       
         IF (DIF .GT. DLIMIT) THEN                                      
            ICT = ICT + 1                                               
            CO(I) = 1                                                   
         ELSE                                                           
            CO(I) = 0                                                   
         ENDIF                                                          
C                                                                       
   10 CONTINUE                                                          
C                                                                       
      IF(ICT.EQ.4) PF=1                                                 
      IF(ICT.EQ.0) PF=0                                                 
      IF(ICT.GT.0.AND.ICT.LT.4) PF=2                                    
C                                                                       
  999 RETURN                                                            
      END                                                               
