C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
C   VERSION-1.0  -  05/18/93  -  CID PRADERAS(SMSRC)  -  COMMON/BADDAT/ 
C                                                                       
C                                                                       
C   PURPOSE - THIS COMMON AREA STORES COUNTERS OF THE NUMBER            
C             OF PIXELS WITH BAD DATA, AND THE MIN AND MAX OF THE       
C             FOLLOWING PARAMATERS:                                     
C                                                                       
C             1) LATITUDES                                              
C             2) LONGITUDES                                             
C             3) SOLAR ZENITH ANGLES                                    
C             4) SATELLITE ZENITH ANGLES                                
C             5) RELATIVE AZIMUTH ANGLES                                
C                                                                       
C             6) CHANNEL 1 - ALBEDO                                     
C             7) CHANNEL 2 - ALBEDO                                     
C             8) CHANNEL 3 - ALBEDO                                     
C             9) CHANNEL 3 - TEMPERATURE                                
C            10) CHANNEL 4 - TEMPERATURE                                
C            11) CHANNEL 5 - TEMPERATURE                                
C                                                                       
C             ALSO, SOME VARIABLES ARE USED AS FLAGS, STORED            
C             IN ARRAYS, TO INDICATE THE OCCURRENCE OF BAD              
C             DATA.                                                     
C                                                                       
C                                                                       
C   USED BY - CLAVRORB, C3AT,C3AR,ULST,CIRT,ALBTMP,TMS3,CHKRNG,         
C             RFLAGS,REPCLV                                             
C                                                                       
C                                                                       
      INTEGER*4  BDLAT,BDLON                                            
      INTEGER*4  BDSZN,BDRLZ,BDSTZ                                      
      INTEGER*4  BDCH1A,BDCH2A,BDCH3A                                   
      INTEGER*4  BDCH3T,BDCH4T,BDCH5T                                   
      INTEGER*4  TOTBSL                                                 
      INTEGER*4  SZNMIN,SZNMAX                                          
      INTEGER*4  RLZMIN,RLZMAX,STZMIN,STZMAX                            
      INTEGER*4  CHMIN(6),CHMAX(6)                                      
C                                                                       
      INTEGER*4  SKP2X2, TSTSKP(10,6)                                   
C                                                                       
      REAL*4     LATMIN,LATMAX,LONMIN,LONMAX                            
C                                                                       
      REAL*4     RSKPCC                                                 
C                                                                       
      COMMON /BADDAT/ BDLAT,BDLON,                                      
     1                BDSZN,BDRLZ,BDSTZ,                                
     2                BDCH1A,BDCH2A,BDCH3A,                             
     3                BDCH3T,BDCH4T,BDCH5T,                             
     4                TOTBSL,                                           
     5                SZNMIN,SZNMAX,RLZMIN,RLZMAX,STZMIN,STZMAX,        
     6                CHMIN,CHMAX,                                      
     8                SKP2X2, TSTSKP,                                   
     9                LATMIN,LATMAX,LONMIN,LONMAX,                      
     A                RSKPCC                                            
C                                                                       
C                                                                       
C                                                                       
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      BDLAT                   I*4  LATITUDE COUNTER                    
C      BDLON                   I*4  LONGITUDE COUNTER                   
C                                                                       
C      BDSZN                   I*4  SOLAR ZENITH ANGLE COUNTER          
C      BDRLZ                   I*4  RELATIVE AZIMUTH COUNTER            
C      BDSTZ                   I*4  SATELLITE ZENITH ANGLE COUNTER      
C                                                                       
C      BDCH1A                  I*4  CHANNEL 1 ALBEDO COUNTER            
C      BDCH2A                  I*4  CHANNEL 2 ALBEDO COUNTER            
C      BDCH3A                  I*4  CHANNEL 3 ALBEDO COUNTER            
C      BDCH3T                  I*4  CHANNEL 3 TEMPERATURE COUNTER       
C      BDCH4T                  I*4  CHANNEL 4 TEMPERATURE COUNTER       
C      BDCH5T                  I*4  CHANNEL 5 TEMPERATURE COUNTER       
C      TOTBSL                  I*4  TOTAL NUMBER OF BAD SCANLINES       
C                                                                       
C      SZNMIN                  I*4  MINIMUM SOLAR ZENITH ANGLE (COSINE) 
C      SZNMAX                  I*4  MAXIMUM SOLAR ZENITH ANGLE (COSINE) 
C      RLZMIN                  I*4  MINIMUM RELATIVE AZIMUTH            
C      RLZMAX                  I*4  MAXIMUM RELATIVE AZIMUTH            
C      STZMIN                  I*4  MINIMUM AZIMUTH ANGLE               
C      STZMAX                  I*4  MAXIMUM AZIMUTH ANGLE               
C      LATMIN                  R*4  MINIMUM LATITUDE                    
C      LATMAX                  R*4  MAXIMUM LATITUDE                    
C      LONMIN                  R*4  MINIMUM LONGITUDE                   
C      LONMAX                  R*4  MAXIMUM LONGITUDE                   
C      CHMIN                   I*4  ARRAY OF MINIMUM CHANNEL VALUES     
C      CHMAX                   I*4  ARRAY OF MAXIMUM CHANNEL VALUES     
C      SKP2X2                  I*4  FLAG TO INDICATE THAT THE 2X2       
C                                   ARRAY (CLOUD CODE) TESTS WILL BE    
C                                   SKIPPED (= 9990)                    
C      RSKPCC                  R*4  FLAG TO INDICATE THAT THE 2X2       
C                                   ARRAY (CLOUD CODE) TESTS WILL BE    
C                                   SKIPPED (= 999.0)                   
C      TSTSKP                  I*4  ARRAY USED FOR TALLYING THE # OF    
C                                   TIMES A PARTICULAR CLAVR TEST IS    
C                                   SKIPPED DUE TO POOR QUALITY OF THE  
C                                   CH1, 2, 3 ALBEDOS, OR CH3, 4, 5     
C                                   TEMPERATURES                        
C                                                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
