      BLOCK DATA BCLAV                                                 
C***********************************************************************
C                                                                       
C                                                                       
C  CLAVR ALGORITHM VERSION A.3H MODIFICATIONS                           
C  ---------------------------------------------------------------------
C                                                                       
C  (1)  DAYTIME OCEAN THRESHOLD FOR TGCT (CHANNEL 4) TEST (THRO(10))    
C       CHANGED FROM 268.0 TO 271.0.                                    
C                                                                       
C  (2)  NEW FMFT (CHANNEL 4 - CHANNEL 5 TEMPERATURE) THRESHOLDS         
C       ADDED WHICH INCLUDE THE EFFECTS OF LAND.  THE ORIGINAL          
C       THRESHOLD VS. CHANNEL 4 TEMPERATURE RELATION WAS DEVELOPED      
C       USING DATA IN PREDONMENENTLY MARINE AREAS.  WHEN APPLIED        
C       OVER DESERT AREAS, THE THRESHOLDS WERE INADEQUATE; THEREFORE,   
C       TWO SETS OF THRESHOLDS WILL NOW BE USED:  ONE SET FOR LAND,     
C       THE OTHER FOR OCEANS.                                           
C                                                                       
C  (3)  C3AT:  THRESHOLD (THRL(5)) CHANGED FROM 3 PERCENT TO 6 PERCENT, 
C       SINCE, OVER LAND AREAS, THE 2X2 PIXEL ARRAYS DETERMINED TO BE   
C       CLOUDY BY THE C3AT WITH A THRESHOLD OF 3 PERCENT WERE REALLY    
C       CLEAR AND THE TGCR COULD NOT RESTORE THE ARRAYS TO CLEAR        
C       IF THERE WAS A CHANNEL 4 TEMPERATURE LESS THAN 293 K.           
C                                                                       
C                                                                       
C...RETRIEVE COMMON AREAS                                               
C                                                                       
      INCLUDE "inc/dthres.f"                                                  
      INCLUDE "inc/nthres.f"                                                  
      INCLUDE "inc/spcnst.f"                                                  
      INCLUDE "inc/daylu.f"                                                   
      INCLUDE "inc/nitlu.f"                                                   
      INCLUDE "inc/ohed1c.f"                                                  
      INCLUDE "inc/clvunt.f"                                                  
      INCLUDE "inc/kounts.f"                                                  
C                                                                       
      INCLUDE "inc/ranges.f"                                                  
      INCLUDE "inc/baddat.f"                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
C                                                                       
C...CONSTANTS FOR PLANCK RADIATION EQUATION                             
C                                                                       
      DATA C1/1.1910659E-05/, C2/ 1.438833/                             
C                                                                       
C                                                                       
C...THRL   DAY TIME LAND THRESHOLDS      + AS OF 5/21/90  +             
C...THRO   DAY TIME OCEAN THRESHOLDS                                    
C...THRLN  NIGHT TIME LAND THRESHOLDS                                   
C...THRON  NIGHT TIME OCEAN THRESHOLDS  
c...DATA THRO FOR RGCT CHANGED FROM 20 TO 30 FOR P1.X1/X3
c                                
C                                                                       
C               RGCT  RUT C3AR RRCT C3AT  TUR  TGCR  FMFT  TUT  TGCT    
C               ----  ---  ---  ---  ---  ---  -----  ---  ---  -----   
      DATA THRL/44.0, 9.0, 3.0, 0.9, 6.0, 1.0, 293.0, 4.0, 3.0, 249.0/  
      DATA THRO/30.0, 0.3, 3.0, 0.9, 3.0, 0.5, 283.0, 4.0, 0.5, 271.0/  
C                                                                       
C                TGCT   TUT  ULST CIRT                                  
C                ----- ----  ---- ----                                  
      DATA THRLN/249.0, 3.0, 3.0, 0.01/                                 
      DATA THRON/271.0, 0.5, 1.0, 0.01/                                 
C                                                                       
C                                                                       
C                                                                       
C...FMFT THRESHOLD LOOK UP TABLES (200-320K) FOR LAND AND OCEAN         
C                                                                       
      DATA FMFLND/ 0.00,                                                
     1    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     2    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     3    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     4    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     5    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     6    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     7    0.01, 0.03, 0.05, 0.08, 0.11, 0.14, 0.18, 0.23, 0.28, 0.34,   
     8    0.41, 0.48, 0.57, 0.66, 0.76, 0.87, 1.00, 1.13, 1.27, 1.42,   
     9    1.59, 1.76, 1.94, 2.14, 2.34, 2.55, 2.77, 3.00, 3.24, 3.48,   
     A    3.73, 3.99, 4.26, 4.52, 4.80, 5.08, 5.35, 5.64, 5.92, 6.20,   
     B    6.48, 6.76, 7.03, 7.30, 7.80, 7.80, 7.80, 7.80, 7.80, 7.80,   
     C    7.80, 7.80, 7.80, 7.80, 7.80, 7.80, 7.80, 7.80, 7.80, 7.80/   
C                                                                       
      DATA FMFOCN/ 0.00,                                                
     1    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     2    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     3    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     4    0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,   
     5    0.01, 0.03, 0.05, 0.07, 0.09, 0.11, 0.13, 0.14, 0.16, 0.17,   
     6    0.18, 0.19, 0.19, 0.20, 0.20, 0.20, 0.21, 0.21, 0.22, 0.23,   
     7    0.24, 0.25, 0.27, 0.30, 0.33, 0.36, 0.41, 0.45, 0.51, 0.58,   
     8    0.65, 0.73, 0.82, 0.92, 1.01, 1.15, 1.27, 1.40, 1.54, 1.69,   
     9    1.84, 1.99, 2.15, 2.31, 2.46, 2.62, 2.77, 2.93, 3.08, 3.24,   
     A    3.39, 3.55, 3.70, 3.86, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00,   
     B    4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00,   
     C    4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00, 4.00/   
C                                                                       
C                                                                       
C...ULST THRESHOLD LOOK UP TABLE (200-320K)                             
C                                                                       
      DATA ULSTLU/ 0.079,                                               
     > 0.081,0.084,0.087,0.090,0.093,0.097,0.100,0.104,0.107,0.111,     
     > 0.115,0.119,0.123,0.127,0.132,0.136,0.141,0.146,0.151,0.156,     
     > 0.162,0.168,0.173,0.179,0.186,0.192,0.199,0.206,0.213,0.220,     
     > 0.228,0.236,0.244,0.253,0.262,0.271,0.280,0.290,0.300,0.310,     
     > 0.321,0.332,0.344,0.356,0.368,0.381,0.395,0.408,0.422,0.437,     
     > 0.452,0.468,0.484,0.501,0.519,0.537,0.556,0.575,0.595,0.616,     
     > 0.637,0.659,0.682,0.706,0.731,0.756,0.782,0.810,0.838,0.867,     
     > 0.897,0.928,0.961,0.994,1.029,1.064,1.101,1.140,1.179,1.220,     
     > 1.263,1.307,1.352,1.399,1.448,1.499,1.551,1.605,1.661,1.718,     
     > 1.778,1.840,1.904,1.970,2.039,2.110,2.183,2.259,2.338,2.419,     
     > 2.503,2.590,2.680,2.774,2.870,2.970,3.073,3.180,3.291,3.406,     
     > 3.524,3.647,3.773,3.905,4.041,4.181,4.327,4.477,4.633,4.794/     
C                                                                       
C...CIRT THRESHOLD LOOK UP TABLE (200-320K)                             
C                                                                       
      DATA CIRTLU/ 0.00,                                                
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,      
     > 0.00, 0.00, 0.00, 0.0009,0.0027,0.0044,0.0062,0.0080,0.0098,     
     > 0.0115,0.0133,0.0151,0.0169,0.0186,0.0204,0.0222,0.0240,         
     > 0.0257,0.0275,0.0293,0.0311,0.0328,0.033,0.033,0.033,0.033,      
     > 0.033,0.033,0.033,0.033,0.033,0.033,0.033,0.033,0.033,0.033,     
     > 0.033,0.033,0.033,0.033,0.033,0.033,0.033,0.033,0.033,0.033,     
     > 0.033,0.033,0.033,0.033/                                         
C                                                                       
C                                                                       
C...SATELLITE PARAMETERS.                                               
C                                                                       
      DATA SPC/'tiros-n ','noaa-11 ','noaa-11 ','noaa-14 ','noaa-7  ',  
     1         'noaa-12 ','noaa-11 ','noaa-9  ','tiros-n '/                
C                                                                       
      DATA CDATYP/'LAC ','GAC ','HRPT'/                                 
C                                                                       
C                                                                       
C...INPUT/OUTPUT UNIT NUMBERS.                                          
C                                                                       
C   CLAVR 1C DATABASE     ==>   UNIT1C                                  
C   AVHRR 1B INPUT FILE   ==>   UNIT1B                                  
C   AVHRR 1B PRIME FILE   ==>   UNITBP                                  
C   MONITORING FILE       ==>   UNITMF
C   SGI IMAGE DATA FILE   ==>   IUIMAG                                  
C   SGI PREVIEW FILE      ==>   IUPREV                                  
C   SGI/PC "FOOTER" FILE  ==>   IUFOOT                                  
C   LAND/SEA TAG DATABASE ==>   LFILE                                   
C   SPACECRAFT                                                          
C   CONSTANTS FILE        ==>   UNSPCN                                  
C   CHANNEL 4 NONLINEAR                                                 
C   CORRECTION FILE       ==>   UNNL4                                   
C   CHANNEL 5 NONLINEAR                                                 
C   CORRECTION FILE       ==>   UNNL5                                   
C                                                                       
      DATA  UNIT1C /30/, UNIT1B /10/, UNITBP /31/, UNITMF /15/,
     1      IUIMAG /36/, IUPREV /37/, IUFOOT /38/, LFILE /60/,          
     2      UNSPCN /88/, UNNL4  /40/, UNNL5  /41/                       
C                                                                       
C                                                                       
C ..................................................................... 
C                                                                       
C...INITIALIZE ITEMS FOR TALLYING CLEAR/CLOUDY/MIXED SAMPLES AND        
C   ALGORITHM PATH STATS.                                               
C                                                                       
      DATA  CCLASS /'CLEAR ', 'CLOUDY', 'MIXED '/                       
C                                                                       
      DATA  TOTCCM /4 * 0/                                              
C                                                                       
C ............................................... DAYTIME PARMS ....... 
C                                                                       
      DATA  NUMDAY /270 * 0/                                            
C                                                                       
      DATA  (DNAME (J), J = 1, 15)     / 'RGCT                    ',    
     2                                   'RUT                     ',    
     3                                   'RRCT                    ',    
     4                                   'C3AT                    ',    
     5                                   'TUT                     ',    
     6                                   'FMFT                    ',    
     7                                   'TGCT                    ',    
     8                                   'RGCT    C3AR    TUT     ',    
     9                                   'RGCT    C3AR    FMFT    ',    
     A                                   'RGCT    C3AR    TGCT    ',    
     B                                   'RGCT    TGCR    TUT     ',    
     C                                   'RGCT    TGCR    FMFT    ',    
     D                                   'RGCT    TGCR    TGCT    ',    
     E                                   'RGCT    TUR     FMFT    ',    
     F                                   'RGCT    TUR     TGCT    '/    
C                                                                       
      DATA  (DNAME (J), J =16, 31)     / 'RUT     C3AR    TUT     ',    
     2                                   'RUT     C3AR    FMFT    ',    
     3                                   'RUT     C3AR    TGCT    ',    
     4                                   'RUT     TGCR    TUT     ',    
     5                                   'RUT     TGCR    FMFT    ',    
     6                                   'RUT     TGCR    TGCT    ',    
     7                                   'RUT     TUR     FMFT    ',    
     8                                   'RUT     TUR     TGCT    ',    
     9                                   'RRCT    C3AR    TUT     ',    
     A                                   'RRCT    C3AR    FMFT    ',    
     B                                   'RRCT    C3AR    TGCT    ',    
     C                                   'RRCT    TGCR    TUT     ',    
     D                                   'RRCT    TGCR    FMFT    ',    
     E                                   'RRCT    TGCR    TGCT    ',    
     F                                   'RRCT    TUR     FMFT    ',    
     G                                   'RRCT    TUR     TGCT    '/    
C                                                                       
      DATA  (DNAME (J), J =32, MAXTST) / 'C3AT    TGCR    TUT     ',    
     2                                   'C3AT    TGCR    FMFT    ',    
     3                                   'C3AT    TGCR    TGCT    ',    
     4                                   'C3AT    TUR     FMFT    ',    
     5                                   'C3AT    TUR     TGCT    ',    
     6                                   '123456789012345678901234',    
     7                                   '123456789012345678901234',    
     8                                   '123456789012345678901234',    
     9                                   '123456789012345678901234',    
     A                                   '123456789012345678901234',    
     B                                   '123456789012345678901234',    
     C                                   '123456789012345678901234',    
     D                                   '123456789012345678901234',    
     E                                   '123456789012345678901234'/    
C                                                                       
C                                                                       
      DATA  (DCODE ( 1, J), J = 1, 3)  /00, 01, 17/  
C                                                    ! CLR, CLD, MIX    
      DATA  (DCODE ( 2, J), J = 1, 3)  /00, 00, 19/                     
      DATA  (DCODE ( 3, J), J = 1, 3)  /00, 04, 20/                     
      DATA  (DCODE ( 4, J), J = 1, 3)  /00, 05, 21/                     
      DATA  (DCODE ( 5, J), J = 1, 3)  /00, 00, 23/                     
      DATA  (DCODE ( 6, J), J = 1, 3)  /12, 06, 22/                     
      DATA  (DCODE ( 7, J), J = 1, 3)  /12, 08, 24/                     
      DATA  (DCODE ( 8, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE ( 9, J), J = 1, 3)  /28, 09, 25/                     
      DATA  (DCODE (10, J), J = 1, 3)  /28, 11, 27/                     
      DATA  (DCODE (11, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE (12, J), J = 1, 3)  /13, 09, 25/                     
      DATA  (DCODE (13, J), J = 1, 3)  /13, 11, 27/                     
      DATA  (DCODE (14, J), J = 1, 3)  /13, 09, 25/                     
      DATA  (DCODE (15, J), J = 1, 3)  /13, 11, 27/                     
      DATA  (DCODE (16, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE (17, J), J = 1, 3)  /29, 09, 25/                     
      DATA  (DCODE (18, J), J = 1, 3)  /29, 11, 27/                     
      DATA  (DCODE (19, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE (20, J), J = 1, 3)  /14, 09, 25/                     
      DATA  (DCODE (21, J), J = 1, 3)  /14, 11, 27/                     
      DATA  (DCODE (22, J), J = 1, 3)  /14, 09, 25/                     
      DATA  (DCODE (23, J), J = 1, 3)  /14, 11, 27/                     
      DATA  (DCODE (24, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE (25, J), J = 1, 3)  /31, 09, 25/                     
      DATA  (DCODE (26, J), J = 1, 3)  /31, 11, 27/                     
      DATA  (DCODE (27, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE (28, J), J = 1, 3)  /15, 09, 25/                     
      DATA  (DCODE (29, J), J = 1, 3)  /15, 11, 27/                     
      DATA  (DCODE (30, J), J = 1, 3)  /15, 09, 25/                     
      DATA  (DCODE (31, J), J = 1, 3)  /15, 11, 27/                     
      DATA  (DCODE (32, J), J = 1, 3)  /00, 00, 26/                     
      DATA  (DCODE (33, J), J = 1, 3)  /30, 09, 25/                     
      DATA  (DCODE (34, J), J = 1, 3)  /30, 11, 27/                     
      DATA  (DCODE (35, J), J = 1, 3)  /16, 09, 25/                     
      DATA  (DCODE (36, J), J = 1, 3)  /16, 11, 27/                     
      DATA  (DCODE (37, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (38, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (39, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (40, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (41, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (42, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (43, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (44, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (DCODE (45, J), J = 1, 3)  /00, 00, 00/                     
C                                                                       
C                                                                       
C ............................................... NIGHTTIME PARMS ..... 
C                                                                       
      DATA  NUMNIT /270 * 0/                                            
C                                                                       
      DATA  (NNAME (J), J = 1, 15)     / 'TGCT                    ',    
     2                                   'TUT                     ',    
     3                                   'ULST                    ',    
     4                                   'FMFT                    ',    
     5                                   'CIRT                    ',    
     6                                   'TGCT    FMFR    TUT     ',    
     7                                   'TGCT    FMFR    ULST    ',    
     8                                   'TGCT    FMFR    CIRT    ',    
     9                                   '123456789012345678901234',    
     A                                   '123456789012345678901234',    
     B                                   '123456789012345678901234',    
     C                                   '123456789012345678901234',    
     D                                   '123456789012345678901234',    
     E                                   '123456789012345678901234',    
     F                                   '123456789012345678901234'/    
C                                                                       
C                                                                       
      DATA  (NCODE ( 1, J), J = 1, 3)  /00, 01, 17/                     
      DATA  (NCODE ( 2, J), J = 1, 3)  /12, 00, 18/                     
      DATA  (NCODE ( 3, J), J = 1, 3)  /00, 08, 24/                     
      DATA  (NCODE ( 4, J), J = 1, 3)  /12, 09, 25/                     
      DATA  (NCODE ( 5, J), J = 1, 3)  /12, 10, 26/                     
      DATA  (NCODE ( 6, J), J = 1, 3)  /63, 00, 93/                     
      DATA  (NCODE ( 7, J), J = 1, 3)  /65, 85, 95/                     
      DATA  (NCODE ( 8, J), J = 1, 3)  /66, 86, 96/                     
      DATA  (NCODE ( 9, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (NCODE (10, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (NCODE (11, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (NCODE (12, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (NCODE (13, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (NCODE (14, J), J = 1, 3)  /00, 00, 00/                     
      DATA  (NCODE (15, J), J = 1, 3)  /00, 00, 00/                     
C                                                                       
C.....LOWER AND UPPER LIMITS FOR LATITUTDES AND LONGITUDES              
C                                                                       
      DATA  LWLAT/-90.0/,     UPLAT/90.0/                               
      DATA  LWLON/-180.0/,    UPLON/180.0/                              
C                                                                       
C.....LOWER AND UPPER LIMITS FOR SOLAR ZENITH ANGLES, RELATIVE          
C     AZIMUTH ANGLES, AND SATELLITE ZENITH ANGLES                       
C                                                                       
      DATA  LWSZN/-214/,      LWSZN1/-1000/, UPSZN/1000/                
      DATA  LWRLZ/0/,         UPRLZ/1800/                               
      DATA  LWSTZ/0/,         UPSTZ/700/                                
C                                                                       
C.....LOWER AND UPPER LIMITS FOR ALBEDO/TEMPERATURES VALUES             
C                                                                       
      DATA  LWCH1A/0.0/,        UPCH1A/102.3/                           
      DATA  LWCH2A/0.0/,        UPCH2A/102.3/                           
      DATA  LWCH3A/0.0/,        UPCH3A/100.0/                           
C                                                                       
      DATA  LWCH3T/170.0/,      UPCH3T/370.0/                           
      DATA  LWCH4T/170.0/,      UPCH4T/370.0/                           
      DATA  LWCH5T/170.0/,      UPCH5T/370.0/                           
C                                                                       
C.....VALUES NEEDED TO INITIAL PROCESSING ARRAYS IN INARRY              
C                                                                       
      DATA  INLAT/0.0/,       INLON/0.0/                                
      DATA  INCH1A/0.0/,      INCH2A/0.0/,    INCH3A/0.0/               
      DATA  INCH3T/170.0/,    INCH4T/170.0/,  INCH5T/170.0/             
      DATA  INSZN/1.0/,       INRLZ/0/,       INSTZ/0/                  
C                                                                       
C.....REPLACEMENT VALUES TO BE WRITTEN TO THE 1C WHEN VALUES            
C     ARE OUT OF LIMIT.                                                 
C                                                                       
      DATA  SZN1C/-214/,      STZ1C/1023/,   RLZ1C/2047/                
C                                                                       
      DATA  LWLATC/-90.0/,    UPLATC/90.0/                              
      DATA  LWLONC/-180.0/,   UPLONC/180.0/                             
C                                                                       
      DATA  CH11C1/0.0/,        CH11C2/102.3/                           
      DATA  CH21C1/0.0/,        CH21C2/102.3/                           
      DATA  CH31C1/0.0/,        CH31C2/100.0/                           
C                                                                       
      DATA  CH3T1C/374.7/,     CH4T1C/170.0/,  CH5T1C/170.0/            
C                                                                       
C                                                                       
C.....INITIALIZE COUNTERS FOR BAD DATA                                  
C                                                                       
      DATA  BDLAT/0/,         BDLON/0/                                  
      DATA  BDSZN/0/,         BDRLZ/0/,      BDSTZ/0/                   
      DATA  BDCH1A/0/,        BDCH2A/0/,     BDCH3A/0/                  
      DATA  BDCH3T/0/,        BDCH4T/0/,     BDCH5T/0/                  
      DATA  TOTBSL/0/                                                   
C                                                                       
C.....INITIALIZE VALUES USED FOR FINDING MAXIMUM AND MINIMUM            
C     VALUES IN SUBROUTINE MINMAX.                                      
C                                                                       
      DATA  SZNMIN/1000/,     SZNMAX/-214/                              
      DATA  RLZMIN/1800/,     RLZMAX/0/                                 
      DATA  STZMIN/700/,      STZMAX/0/                                 
      DATA  LATMIN/90.0/,     LATMAX/-90.0/                             
      DATA  LONMIN/180.0/,    LONMAX/-180.0/                            
      DATA  CHMIN/1023,1023,1000,3700,3700,3700/                        
      DATA  CHMAX/0,0,0,1700,1700,1700/                                 
C                                                                       
      DATA  SKP2X2/9990/,     RSKPCC/999.0/                             
C                                                                       
C                                                                       
      DATA  TSTSKP /60 * 0/                                             
C                                                                       
C                                                                       
C                                                                       
      END                           







                                    
