C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
C   VERSION-1.0  -  10/15/91  -  DEBBIE CARR (SMSRC)  -  COMMON /HK1C/  
C                                                                       
C                                                                       
C   PURPOSE - STORAGE OF LEVEL 1C DATA SET HOUSEKEEPING RECORD INFO.    
C                                                                       
C                                                                       
C     1C DATA SET HOUSEKEEPING RECORD DESCRIPTION (ALL WORDS, I*4)      
C                                                                       
C     WORD     DESCRIPTION                               VARIABLE NAME  
C     ----     -----------                               -------------  
C     1        TOTAL NUMBER OF RECORDS IN FILE           C1TOT          
C     2        TOTAL NUMBER OF ORBITS STORED IN FILE     C1ORBS         
C     3        SATELLITE ID                              C1SAT          
C     4        FIRST RECORD WRITTEN BY CLAVRORB          LC1BEG         
C     5        LAST RECORD WRITTEN BY CLAVRORB           LC1END         
C     6        INDEX # OF LAST ORBIT WRITTEN BY CLAVRORB LC1IDX         
C     7        FIRST RECORD READ BY CAMAPPER             LCAMB          
C     8        LAST RECORD READ BY CAMAPPER              LCAME          
C     9        INDEX # OF LAST ORBIT READ BY CAMAPPER    LCAMID         
C     10       LAST RECORD ARCHIVED TO TAPE/CARTRIDGE    LSTARC         
C     11       STARTING 1C RECORD # FOR ORBIT #1         INXREX(1,1)    
C     12       ENDING 1C RECORD # FOR ORBIT #1           INXREX(1,2)    
C     13       STARTING 1C RECORD # FOR ORBIT #2         INXREX(2,1)    
C     14       ENDING 1C RECORD # FOR ORBIT #2           INXREX(2,2)    
C     M        STARTING 1C RECORD # FOR ORBIT #(MAXORB)  INXREX(M,1)    
C                ( WHERE M = 10 + 2*(MAXORB-1) +1 )                     
C     M+1      ENDING 1C RECORD # FOR ORBIT #(MAXORB)    INXREX(M+1,2)  
C                ( WHERE M+1 = 10 + 2*(MAXORB-1) +2 )                   
C     M+2      SOLAR FILTERED IRRADIANCE (CHANNEL 1)     SOLIRR(1)      
C     M+3      SOLAR FILTERED IRRADIANCE (CHANNEL 2)     SOLIRR(2)      
C     M+4      SOLAR FILTERED IRRADIANCE (CHANNEL 3)     SOLIRR(3)      
C     M+5      EQUIVALENT WIDTH (CHANNEL 1)              EWIDTH(1)      
C     M+6      EQUIVALENT WIDTH (CHANNEL 2)              EWIDTH(2)      
C     M+7      EQUIVALENT WIDTH (CHANNEL 3)              EWIDTH(3)      
C     M+8..??  RADIANCE/TEMPERATURE CONVERSION TABLE     ??             
C     ??..EOB  SPARE (FILL, -1)                          (N/A)          
C                                                                       
C                                                                       
C   USED BY- MAIN CLAVRORB, SUBROUTINES R1CHK, W1CDAT, W1CHK            
C                                                                       
C                                                                       
      INTEGER*4  C1TOT,  C1ORBS, C1SAT,                                 
     1           LC1BEG, LC1END, LC1IDX,   LCAMB,     LCAME,    LCAMID, 
     2           LSTARC, INXREX(MAXORB,2), SOLIRR(3), EWIDTH(3)         
C                                                                       
      COMMON /HK1C/ C1TOT,  C1ORBS, C1SAT,  LC1BEG, LC1END,             
     1              LC1IDX, LCAMB,  LCAME,  LCAMID, LSTARC, INXREX,     
     2              SOLIRR, EWIDTH                                      
C                                                                       
C                                                                       
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      C1TOT                   I*4  TOTAL # RECORDS IN THE 1C FILE      
C                                                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
