C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
C   VERSION-1.1  -  10/07/93  -  DEBBIE CARR 'SMSRC.f'  -  INCLUDE/INCLAV/
C                                                                       
C                                                                       
C   PURPOSE - STORAGE OF PARAMETER STATEMENTS FOR CONSTANTS             
C                                                                       
C   USED BY - MAIN CLAVRORB, SUBROUTINES AVHFDC, CLAVRM, DOWNLD,        
C             LACQC, R1CHK, TMS3, VICOMP, WBPDAT, WBPHED, CHKRNG,       
C             W1CDAT, W1CHED, W1CHK, SOLCMP, ALBTMP, ATTRIB             
C                                                                       
C                                                                       
      INTEGER*4  BGACPX, EGACPX, MAXGPX, NGIMPX, GRECS,                 
     1           BLACPX, ELACPX, MAXLPX, NLIMPX, LRECS,                 
     2           G1BRCL, L1BRCL, G1BWDS, L1BWDS, MAXANC
C                                                                       
      REAL*4     DAYLIM, ALBLIM                                         
      INTEGER*2  CDAYLM, CALBLM                                         
C                                                                       
      REAL*8     RD2DEG, DEG2RD                                         
C                                                                       
C                                                                       
      PARAMETER (BGACPX = 1,    EGACPX = 409)                           
      PARAMETER (BLACPX = 1,    ELACPX = 2048)                          
      PARAMETER (MAXGPX = 409,  MAXLPX = 2048)                          
      PARAMETER (NGIMPX = 409,  NLIMPX = 2048)                           
      PARAMETER (GRECS  = 2,    LRECS  = 1)                             
      PARAMETER (G1BRCL = 6440, L1BRCL = 14800)                       
      PARAMETER (MAXANC = 51)
C                                                                       
CMZ     PARAMETER (G1BWDS = G1BRCL/2/4)                                   
      PARAMETER (G1BWDS = 805 )
      PARAMETER (L1BWDS = L1BRCL/1/4)                                   
C                                                                       
      PARAMETER (DAYLIM = 84.30, ALBLIM = 89.50)                        
      PARAMETER (CDAYLM = 99,    CALBLM = 9)                            
C                                                                       
      PARAMETER (RD2DEG = 57.29577951)                                
      PARAMETER (DEG2RD = 0.017453293)                                
C                                                                       
C                                                                       
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      BGACPX                  I*4  NUMBER OF BEGINNING PIXEL IN        
C                                   GAC SCANLINE                        
C      EGACPX                  I*4  NUMBER OF ENDING PIXEL IN           
C                                   GAC SCANLINE                        
C      BLACPX                  I*4  NUMBER OF BEGINNING PIXEL IN        
C                                   LAC SCANLINE                        
C      ELACPX                  I*4  NUMBER OF ENDING PIXEL IN           
C                                   LAC SCANLINE                        
C      MAXGPX                  I*4  MAXIMUM NUMBER OF GAC PIXELS        
C                                   PER SCANLINE                        
C      MAXLPX                  I*4  MAXIMUM NUMBER OF LAC PIXELS        
C                                   PER SCANLINE                        
C      NGIMPX                  I*4  NUMBER OF PIXELS FOR GAC            
C                                   PC/VICOM IMAGES                     
C      NLIMPX                  I*4  NUMBER OF PIXELS FOR LAC            
C                                   PC/VICOM IMAGES                     
C      GRECS                   I*4  NUMBER OF GAC SCANLINES PER         
C                                   PHYSICAL 1B RECORD                  
C      LRECS                   I*4  NUMBER OF LAC SCANLINES PER         
C                                   PHYSICAL 1B RECORD                  
C      G1BRCL                  I*4  LOGICAL RECORD LENGTH OF            
C                                   GAC 1B FILE                         
C      L1BRCL                  I*4  LOGICAL RECORD LENGTH OF            
C                                   LAC 1B FILE MULTIPLIED BY 2         
C                                   (SINCE IT TAKES 2 LAC LOGICAL       
C                                   RECORDS TO MAKE UP 1 SCANLINE)      
C      G1BWDS                  I*4  NUMBER OF 4-BYTE (I*4) WORDS        
C                                   PER GAC SCANLINE (LRECL / 2         
C                                   SCANLINES PER LRECL / 4 BYTES       
C                                   PER WORD = # WORDS PER SCANLINE)    
C      L1BWDS                  I*4  NUMBER OF 4-BYTE (I*4) WORDS        
C                                   PER LAC SCANLINE (LRECL / 1         
C                                   SCANLINE PER LRECL / 4 BYTES        
C                                   PER WORD = # WORDS PER SCANLINE)
C      MAXANC                  I*4  MAXIMUM NUMBER OF ANGLE ANCHOR POINTS    
C      RD2DEG                  R*8  CONVERSION CNST, RADIANS TO DEGREES 
C      DEG2RD                  R*8  CONVERSION CNST, DEGREES TO RADIANS 
C      DAYLIM                  R*4  SOLAR ZENITH ANGLE LIMIT FOR        
C                                   DEFINING DAYTIME SCENES             
C                                   (S.Z.A. < = 84.3 IS "DAYTIME")      
C      CDAYLM                  I*2  SAME AS "DAYLIM" BUT USED WHEN      
C                                   NEEDING TO EVALUATE COS(S.Z.A.)*1000
C      ALBLIM                  R*4  SOLAR ZENITH ANGLE LIMIT FOR        
C                                   COMPUTING ALBEDOS (SLIGHTLY HIGHER  
C                                   THAN DAYTIME LIMIT; BASICALLY       
C                                   DEFINES CUTOFF BETWEEN NIGHT AND    
C                                   "TWILIGHT"                          
C      CALBLM                  I*2  SAME AS "ALBLIM" BUT USED WHEN      
C                                   NEEDING TO EVALUATE COS(S.Z.A.)*1000
C                                                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
