C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
C   VERSION-1.0  -  02/20/93  -  DEBBIE CARR (SMSRC)  -  COMMON/JCLCOM/ 
C                                                                       
C                                                                       
C   PURPOSE - STORES JCL INPUT PARAMETERS AND PARAMETERS DERRIVED FROM  
C             THE JCL INPUTS.                                           
C                                                                       
C   USED BY - SUBROUTINES CLAVIN, OPEN1B, WBPHED, FOOTER,               
C             OPEN1C, W1CHED, W1CDAT, R1CHK, MAIN PROGRAMS              
C             CLAVRORB AND CAMAPPER, AND UTILITY PROGRAM CHECK1C        
C                                                                       
C                                                                       
      INTEGER*4  ONOFF, IDJCL, JCLDOY, TAPDSK, ORBIT, IBSTRT, IBEND,    
     1           IDBEG, IDEND, NTAPES, NDISKS, IMAP,                    
     2           ITPFIL(8)                                              
C                                                                       
      LOGICAL*4  DUMPRN, BPRIME, MAKPCI, MAKSTI, DISK1C, TAPE1C,        
     1           ORBRUN, DAYRUN, WEIGHT                                 
C                                                                       
C                                                                       
      COMMON /JCLCOM/ ONOFF,  IDJCL,  JCLDOY, TAPDSK, ORBIT,            
     1                IBSTRT, IBEND,  IDBEG,  IDEND,                    
     2                NTAPES, NDISKS, IMAP,   ITPFIL,                   
     3                DUMPRN, BPRIME, MAKPCI, MAKSTI,                   
     4                DISK1C, TAPE1C, ORBRUN, DAYRUN, WEIGHT            
C                                                                       
C                                                                       
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      ONOFF                   I*4  OFFLINE (0) OR ONLINE(1) RUN FLAG   
C      IDJCL                   I*4  JCL-SPECIFIED SATELLITE ID          
C      JCLDOY                  I*4  DAY OF YEAR TO PROCESS (OFFLINE)    
C      TAPDSK                  I*4  FLAG INDICATING WHETHER AVHRR 1B    
C                                   INPUT FILE IS ON DISK (1) OR        
C                                   SDSD ARCHIVE TAPE (0)               
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      ORBIT                   I*4  OPT. TO PROCESS ENTIRE ORBIT (1=YES)
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      IBSTRT                  I*4  STARTING 1B SCANLINE TO PROCESS     
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      IBEND                   I*4  ENDING 1B SCANLINE TO PROCESS       
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      IDBEG                   I*4  STARTING SCANLINE TO DUMP (PRINT)   
C      IDEND                   I*4  ENDING SCANLINE TO DUMP (PRINT)     
C      DUMPRN                  L*4  TRUE = PRODUCE DIAGNOSTIC DUMP      
C      BPRIME                  L*4  TRUE = CREATE 1B PRIME FILE         
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      MAKPCI                  L*4  TRUE = CREATE PC/IMG. FILES         
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      MAKSTI                  L*4  TRUE = CREATE SGI/IMG. FILES        
C                                   (CLOUD CLASSIFICATION PROG. ONLY)   
C      DISK1C                  L*4  TRUE = READ/WRITE 1C FILE ON DISK   
C      TAPE1C                  L*4  TRUE = READ/WRITE 1C FILE ON TAPE   
C      ORBRUN                  L*4  TRUE = ORBITAL CLOUD MAPPING RUN    
C      DAYRUN                  L*4  TRUE = DAILY CLOUD MAPPING RUN      
C      WEIGHT                  L*4  TRUE = COMPUTE WEIGHTED AVERAGE     
C                                   OF CLOUD AMOUNT                     
C      NTAPES                  I*4  # TAPES 1C DATA RESIDES ON          
C      ITPFIL                  I*4  # LABELS/FILES ON EACH 1C TAPE      
C      NDISKS                  I*4  # DISK FILES 1C DATA RESIDES ON     
C      IMAP                    I*4  OPTION TO PRODUCE GLOBAL COVERAGE   
C                                   MAPS FOR MEAN CLOUD AMOUNT          
C                                                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
