C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C   VERSION-1.0  -  08/09/95  -  Doug Love(SMART)  -  COMMON/NEWCON/
C
C
C   PURPOSE - THIS COMMON AREA STORES NEW SPACECRAFT-DEPENDANT CONSTANTS
C             USED IN THE CLAVRORB ORBITAL PROCESSING ROUTINES
C
C   USED BY - CLAVRORB, ALBTMP, TMS3, AVHFDC, INSPCN, PRINTCON
C
C
      REAL*4    SRP(2, 4:5), CNU(3:5), TIN(3:5), TSL(3:5),
     *          QA(3:5), QB(3:5), QC(3:5), RSP(3:5)
      REAL*4    CH1W, CH2W, CH1F, CH2F, CH3WNO, CH3WLN, CH3SIN
      REAL*4    CH3RWN, CH3RWL, SRP4(2), SRP5(2)
C
      INTEGER*4 IYRDYS(2), IYRDYE(2), NZSRPS, IDEGF, IRLINF
C
C
C
      COMMON /NEWCON/ SRP, CNU, TIN, TSL, QA, QB, QC, RSP,
     *                CH1W, CH2W, CH1F, CH2F, CH3WNO, CH3WLN, CH3SIN,
     *                CH3RWN, CH3RWL, SRP4, SRP5,
     *                IYRDYS, IYRDYE, NZSRPS, IDEGF, IRLINF
C
C      VARIABLE               TYPE  FUNCTION
C      --------               ----  --------
C
C      CH1W                    R*4   Equivalent Widths for Ch. 1
C      CH2W                    R*4   Equivalent Widths for Ch. 2
C      CH1F                    R*4   Solar Irrad (F's) for Ch. 1
C      CH2F                    R*4   Solar Irrad (F's) for Ch. 2
C      CH3WNO                  R*4   Ch. 3 W's in WNO
C      CH3WLN                  R*4   Ch. 3 W's in WLN
C      CH3SIN                  R*4   Ch. 3 Solar Spectral Irrad.
C      CH3RWN                  R*4   Ch. 3 Reflective Eff. Wave No.
C      CH3RWL                  R*4   Ch. 3 Reflective Eff. Wave Ln.
C      NZSRPS                  I*4   pairs of non-0 space radiances
C      IYRDYS(2)               I*4   start yearday of non-0 space rads.
C      IYRDYE(2)               I*4   end yearday of non-0 space rads.
C      SRP   (2, 4:5)          R*4   Ch.4 & 5 space rad. prime values
C      IRDEGF                  I*4   0 = no Degradation Correction
C      CNU   (3:5)             R*4   Centroid Wave Numbers for Chs. 3-5
C      TIN   (3:5)             R*4   T Intercept values for Chs. 3-5
C      TSL   (3:5)             R*4   T Slope values for Chs. 3-5
C      IRLINF                  I*4   1 = need to recompute RLIN
C      QA    (3:5)             R*4   Quad. Coeffs. for nonlin rad corrs.
C      QB    (3:5)             R*4   Quad. Coeffs. for nonlin rad corrs.
C      QC    (3:5)             R*4   Quad. Coeffs. for nonlin rad corrs.
C      RSP   (3:5)             R*4   Radiance from Space for Chs. 3-5
C
C
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
