C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
C   VERSION-1.0  -  03/01/93  -  DEBBIE CARR (SMSRC)  -  COMMON/QCFLGS/ 
C                                                                       
C                                                                       
C   PURPOSE - STORES SCAN QUALITY INFORMATION AND COUNTERS FOR          
C             THE NUMBER OF QC FLAG VIOLATIONS THROUGHOUT THE ORBIT.    
C                                                                       
C     AVHRR QUALITY FLAG BYTES:                                         
C     ------------------------                                          
C                                                                       
C     BYTE #   BIT #   DEFINITION                                       
C                                                                       
C       1        1     FATAL FLAG -- DO NOT USE DATA FOR PRODUCTS       
C                2     TIME SEQUENCE ERROR                              
C                3     DATA GAP -- PRECEDING THE CURRENT FRAME          
C                4     DATA JITTER (RESYNC OCCURRED ON THIS FRAME)      
C                5     INSUFFICIENT DATA FOR CALIBRATION                
C                6     NO EARTH LOCATION                                
C                7     ASCENDING(0) / DESCENDING(1) FLAG                
C                8     PSEUDO NOISE, DATA NOT USED FOR CALIBRATION      
C                                                                       
C       2        1     BIT SYNC STATUS -- DROP LOCK DURING FRAME        
C                2     SYNC ERROR                                       
C                3     FRAME SYNC LOCK                                  
C                4     FLYWHEELING DURING FRAME                         
C                5     BIT SLIPPAGE DURING FRAME                        
C                6-7   SPARE                                            
C                8     NEW CLAVR EDIT FLAG (1 = BAD DATA / SKIP SCAN)   
C                                                                       
C     REFER TO THE NOAA POLAR ORBITER USER'S GUIDE FOR MORE             
C     INFORMATION ON THESE AVHRR SCAN QUALITY FLAGS.                    
C                                                                       
C                                                                       
C   USED BY - SUBROUTINES ATTRIB, AVHFDC AND PROGRAM CLAVRORB           
C                                                                       
C                                                                       
      INTEGER*4  IQUAL(2), QFLAG(16)                                    
C                                                                       
      LOGICAL*4  FLAGQ                                                  
C                                                                       
C                                                                       
      COMMON /QCFLGS/ IQUAL, QFLAG, FLAGQ                               
C                                                                       
C                                                                       
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      IQUAL (2)               I*4  QUALITY FLAG BYTES FROM GAC 1B      
C      QFLAG (16)              I*4  TOTALS FOR QC FAILURES              
C      FLAGQ                   I*4  GENERAL FLAG INDICATING POOR        
C                                   SCAN QUALITY                        
C                                                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
