C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
C   VERSION-1.0  -  09/02/93  -  CID PRADERAS(SMSRC)  -  COMMON/SPCNST/ 
C                                                                       
C                                                                       
C   PURPOSE - THIS COMMON AREA STORES SPACECRAFT DEPENDANT CONSTANTS    
C             USED THROUGHOUT THE CLAVRORB ORBITAL PROCESSING ROUTINE.  
C             THE FOLLOWING INFORMATION IS STORED:                      
C                                                                       
C                  - AVHRR CALIBRATION CONSTANTS                        
C                  - NON-LINEAR TEMPERATURE CORRECTION TABLES FOR       
C                    AVHRR CHANNELS 4 AND 5                             
C                  - 5TH ORDER COEFFICIENTS FOR EACH PRT COUNT TO       
C                    TEMPERATURE CONVERSION                             
C                                                                       
C                                                                       
C                                                                       
C   USED BY - CLAVRORB, ALBTMP, TMS3, AVHFDC, INSPCN                    
C                                                                       
C                                                                       
C                                                                       
      REAL*4      WAVENO(3,3), C1, C2, TLIM1, TLIM2, BOUND(2,3)         
C                                                                       
      REAL*4      CORCT4(10:20,205:320), CORCT5(10:20,205:320)          
C                                                                       
      REAL*4      ACOEF(0:4,4)                                          
C                                                                       
      REAL*4      B1, B2, B3, B4                                        
C                                                                       
      REAL*4      A, B, C, D                                            
C                                                                       
      REAL*4      S3PI, CNUO, GAMLIM(5)                                            
C                                                                       
      REAL*4      X(2), Y(2), O(2)                                      
C                                                                       
      INTEGER*4   SPCNID, D0, Z                                         
C                                                                       
      INTEGER*4   NL4ID, NL5ID                                          
C                                                                       
C                                                                       
C                                                                       
      COMMON /SPCNST/WAVENO, C1, C2, TLIM1, TLIM2, BOUND,               
     1               CORCT4, CORCT5,                                    
     2               ACOEF,                                             
     3               B1, B2, B3, B4,                                    
     4               A, B, C, D,                                        
     5               S3PI, CNUO, GAMLIM, X, Y, O,                               
     6               SPCNID,D0,Z,NL4ID,NL5ID                            
C                                                                       
C                                                                       
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C                                                                       
C      WAVENO (3,3)            R*4   I   WAVE NUMBER VALUES FOR         
C                                        COMPUTING TEMPERATURES         
C                                        (TEMP RANGE INDEX, CHAN)       
C      C1                      R*4   I   CONSTANT FOR PLANCK            
C                                        RADIATION EQUATION             
C      C2                      R*4   I   CONSTANT FOR PLANCK            
C                                        RADIATION EQUATION             
C      TLIM1                   R*4   I   LOWER LIMIT FOR MIDDLE         
C                                        TEMPERATURE RANGE              
C      TLIM2                   R*4   I   UPPER LIMIT FOR MIDDLE         
C                                        TEMPERATURE RANGE              
C      BOUND (2,3)             R*4   I   ARRAY OF LIMITS OF ENERGY      
C                                        FOR EACH TEMPERATURE RANGE     
C                                        FOR EACH CHANNEL               
C                                        (UPPER/LOWER LIMIT INDEX,      
C                                         CHANNEL, TEMP RANGE INDEX)    
C                                                                       
C      CORCT4 (10:20,205:320)  R*4  I/O  ARRAY OF NON-LINEARITY         
C                                        CORRECTIONS FOR AVHRR          
C                                        CHANNEL 4 TEMPERATURES         
C                                        (READ FROM DISK DATA SET)      
C      CORCT5 (10:20,205:320)  R*4  I/O  ARRAY OF NON-LINEARITY         
C                                        CORRECTIONS FOR AVHRR          
C                                        CHANNEL 5 TEMPERATURES         
C                                        (READ FROM DISK DATA SET)      
C                                                                       
C      ACOEF (0:4,4)           R*4   I   5TH ORDER COEFFICIENTS FOR     
C                                        EACH PRT COUNT TO TEMPERATURE  
C                                        CONVERSION                     
C                                        (CHAN, PRT INDEX)              
C      SPCNID                  I*4   I   SPACECRAFT ID OBTAINED FROM    
C                                        SPACECRAFT CONSTANTS FILE      
C      GAMLIM (5)              R*4   I   GAMMA ANGLE LIMITS FOR 5 CLAVR 
C                                        TESTS (USED IN DISCRIMINATING  
C                                        SPECULAR REFLECTION FROM       
C                                        CLOUDS.  LIMITS ARE S/C        
C                                        DEPENDENT DUE TO SLIP OF       
C                                        NOAA ORBITS OVER TIME)         
C                                        SPACECRAFT CONSTANTS FILE      
C      X(2), Y(2), O(2)        R*4       COEFFICIENTS FOR CALCULATING   
C                                        CHANNEL 1 & 2 ALBEDO           
C      Z                       I*4       COEFFICIENT FOR CALCULATING    
C                                        CHANNEL 1 & 2 ALBEDO           
C                                                                       
C                                                                       
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
C                                                                       
