      FUNCTION JD(I,J,K)                                                
C***********************************************************************
C                                                                       
C   NAME- JD                                                            
C                                                                       
C   LANGUAGE- FORTHXP     TYPE- FUNCTION                                
C                                                                       
C   VERSION- 1.0    DATE- 0B/0C/0D   PROGRAMMER- TAYLOR,E.T. S11213     
C            1.1          10/24/78               WALTER,D.L. S11213     
C                                                                       
C   FUNCTION-                                                           
C           COMPUTES THE JULIAN DAY CORRESPONDING TO A GIVEN            
C           CALENDAR DATE.                                              
C                                                                       
C   INPUT FILES-                                                        
C              NONE                                                     
C                                                                       
C   INPUT PARAMETERS-                                                   
C     VARIABLES     TYPE   DESCRIPTION                                  
C     ---------     ----   -----------                                  
C     I             I*4    YEAR  (E.G.,1970)                            
C     J             I*4    MONTH (1-12)                                 
C     K             I*4    DAY OF MONTH                                 
C                                                                       
C   OUTPUT FILES-                                                       
C               NONE                                                    
C                                                                       
C   OUTPUT PARAMETERS-                                                  
C     VARIABLES     TYPE   DESCRIPTION                                  
C     ---------     ----   -----------                                  
C     JD            1*4    JULIAN DAY  (NUMBER OF DAYS FROM JAN 1,4713  
C                          BC)                                          
C                                                                       
C   KEY LOCAL PARAMETERS-                                               
C                                                                       
C   SUBPROGRAMS CALLED-                                                 
C                                                                       
C   EXIT STATES-                                                        
C                                                                       
C   RESTRICTIONS-                                                       
C                                                                       
C   COMMENTS-                                                           
C           FOR TIME CONVERSIONS INVOLVING DAY OF YEAR, SET MONTH =1,   
C           AND DAY = DAY OF YEAR.                                      
C                                                                       
C        MODIFIED 10/24/78 TO CONFORM CODE TO NESS STANDARDS. DLW.      
C                                                                       
C***********************************************************************
C                                                                       
      L=(J-14)/12                                                       
      N = I + 4800 + L                                                  
      JD=K-32075+1461*(N)/4+367*(J-2-L*12)/12-3*((I+4900+L)/100)/4      
C                                                                       
      RETURN                                                            
      END                                                               
