      SUBROUTINE OPEN1B (TBMHED, CGACHD, IBTAPE)                        
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- OPEN1B                                                        
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 02/04/93   PROGRAMMER- DEBBIE CARR (SMSRC)    
C                                                                       
C                                                                       
C   FUNCTION-                                                           
C                                                                       
C      OPENS AVHRR 1B FILES ON DISK AND TAPE, AND CALLS A SUBORDINATE   
C      ROUTINE TO UNPACK THE 1B HEADER INFORMATION.  FOR TAPE FILES     
C      RECEIVED FROM SDSD, THE TBM HEADER IS ALSO READ/UNPACKED.        
C      FINALLY, BASED ON THE SAT ID STORED IN THE 1B HEADER, A          
C      SPACECRAFT INDEX VALUE IS ASSIGNED FOR DETERMINING S/C           
C      DEPENDENT CONSTANTS (SUCH AS WHICH NON-LINEAR CORRECTION         
C      FILE TO READ FROM).                                              
C                                                                       
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C                                                                       
C      VARIABLE          I/O   TYPE  FUNCTION                           
C      --------          ---   ----  --------                           
C                                                                       
C                                                                       
C                                                                       
C   LOCAL PARAMETERS-                                                   
C                                                                       
C      VARIABLE                TYPE  FUNCTION                           
C      --------                ----  --------                           
C      FINLIN (35)             C*1   A FINAL MESSAGE OUTPUT LINE        
C                                                                       
C                                                                       
C                                                                       
C   COMMON AREAS- PARM1C & INCLAV (CONSTANTS), CLVUNT, TYPDAT, OHED1C   
C                                                                       
C                                                                       
C   CALLED BY-  CLAVRORB                                                
C                                                                       
C                                                                       
C   SUBPROGRAMS CALLED- AVHEDR                                          
C                                                                       
C                                                                       
C   RESTRICTIONS-                                                       
C                                                                       
C                                                                       
C   COMMENTS-                                                           
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...LINK IN CONSTANT PARAMETERS AND COMMON VARIABLES.                   
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/parm1c.f"                                                  
      INCLUDE "inc/clvunt.f"                                                 
      INCLUDE "inc/typdat.f"                                                  
      INCLUDE "inc/ohed1c.f"                                                 
C                                                                       
CCCCC INCLUDE 'inc/jclcom.f'                                                  
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...VARIABLE DECLARATIONS                                               
C                                                                       
      CHARACTER*1  TBMHED(122), TBMEBC(122),                            
     1             CGACHD(G1BRCL), CTEMP(G1BRCL)                        
C                                                                       
      INTEGER*4  IGACHD(G1BRCL), LACHED(1850), DUMMY(1850)              
      CHARACTER*40 b1name
C                                                                       
C                                                                       
      EQUIVALENCE (CTEMP(1), IGACHD(1))                                 
C                                                                       
C                                                                       
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C 
c
c.....READ THE FILE NAMES FROM THE INPT FILE
C
      READ(5,111) b1name
C     write(6,111) b1name  
                                  
      IF (IBTAPE .EQ. 0) THEN                                           
C                                                                       
C ..... OPEN 1B TAPE FILE.                                              
C                                                                       
C       OPEN (UNIT=UNIT1B, ACCESS='SEQUENTIAL',                         
C    1        FORM='UNFORMATTED', ERR=10)                               
        OPEN (UNIT=UNIT1B, FILE=b1name,            
     1        STATUS='OLD', ACCESS='SEQUENTIAL',ERR=10, 
     1        FORM='UNFORMATTED')                    
C                                                                       
C       WRITE(6, 1000) UNIT1B, 'TAPE'                                   
C                                                                       
C                                                                       
C ..... READ TBM HEADER RECORD.                                         
C                                                                       
C       WRITE(6, 1010)                                                  
C                                                                       
        READ (UNIT=UNIT1B, END=20, ERR=30) TBMHED                       
C                                                                       
        CALL ASEBCD (TBMHED, TBMEBC)                                    
C       WRITE(6, 1020) (TBMEBC(IC), IC = 31, 117)                       
C                                                                       
C                                                                       
      ELSE                                                              
C                                                                       
C ..... OPEN DISK FILE.  *** MAY BE CHANGED TO DIRECT ACCESS LATER ***  
C                                                                       
         IF (GAC) THEN                                                     
            OPEN (UNIT=UNIT1B, FILE=b1name,            
     1           STATUS='OLD', ACCESS='DIRECT', ERR=10, 
     1           FORM='UNFORMATTED',RECL=1610)
C
C 1/13/99 -- WCOLLINS CHANGE TO OPEN LAC FILES CORRECTLY
C
         ELSE
            OPEN (UNIT=UNIT1B, FILE=b1name,            
     1           STATUS='OLD', ACCESS='DIRECT', ERR=10, 
     1           FORM='UNFORMATTED',RECL=1850)
         ENDIF
C                                                                       
C       WRITE(6, 1000) UNIT1B, 'DISK'                                   
C                                                                       
C       WRITE(6, 1030)                                                  
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
C  READ, THEN UNPACK 1B DATA HEADER.                                    
C                                                                       
      IF (GAC) THEN                                                     
C                                                                       
        READ (UNIT=UNIT1B, END=20, ERR=30) CTEMP                        
C                                                                       
C ....... EQUATE GAC HEADER CHARACTER VARIABLE TO "CTEMP" FOR RETURN TO 
C         MAIN PROGRAM.                                                 
C                                                                       
        DO 5 I = 1, G1BRCL                                              
          CGACHD(I) = CTEMP(I)                                          
    5   CONTINUE                                                        
C                                                                       
C ....... CALL SUBROUTINE TO UNPACK HEADER INFORMATION.                 
C                                                                       
        CALL AVHEDR (IGACHD)                                            
C                                                                       
      ELSE                                                              
C                                                                       
        READ (UNIT=UNIT1B,END=20,ERR=30) LACHED                         
        READ (UNIT=UNIT1B,END=20,ERR=30) DUMMY                          
C                                                                       
        CALL AVHEDR (LACHED)                                            
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
C...CHECK VALUE OF SATELLITE ID,  ADJUST TO FIND INDEX FOR PROPER SAT   
C                                                                       
      IF (NSAT.EQ.0) THEN                                               
        CALL EMESG (16, 'OPEN1B', 'FATAL')                              
C     ELSE                                                              
C       WRITE (6, 1050) NSAT                                            
      END IF                                                            
C                                                                       
      GO TO 40                                                          
C                                                                       
C                                                                       
   10 CONTINUE                    
C                                 !  /* OPEN FOR 1B FILE FAILED */      
      CALL EMESG (13, 'OPEN1B', 'FATAL')                                
C                                                                       
   20 CONTINUE                    
C                                 !  /* UNEXPECTED END OF FILE */       
      CALL EMESG (14, 'OPEN1B', 'FATAL')                                
C                                                                       
   30 CONTINUE                    
C                                 !  /* HEADER RECORD READ ERROR */     
      CALL EMESG (2, 'OPEN1B', 'FATAL')                                 
C                                                                       
C                                                                       
   40 CONTINUE                                                          
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
C                                                                       
 1000 FORMAT ('  SUBROUTINE OPEN1B:  SUCCESSFUL OPEN OF',               
     1 ' AVHRR 1B FILE (UNIT ', I2, ') ON ', A4)                        
C                                                                       
 1010 FORMAT (    '                      READING TBM HEADER...')        
C                                                                       
 1020 FORMAT (    '                      TBM HEADER ==> ', 67A1, 20I1)  
C                                                                       
 1030 FORMAT (/,  '                      DISK DATA -- NO TBM HEADER')   
C                                                                       
 1050 FORMAT (/,  '  SATELLITE ID ==> ', I2)       
 111  format(a40)                     
C                                                                       
      END                                                               
