      SUBROUTINE OPEN1C (PROGRM, DISK, HOUSE, BEG1C)
C
C**********************************************************************
C
C   NAME- OPEN1C
C
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE
C
C   VERSION- 1.0    DATE- 02/02/93   PROGRAMMER- DEBBIE CARR (SMSRC)
C
C
C   FUNCTION-
C
C      OPENS CLAVR 1C FILES ON DISK AND TAPE.  FOR DISK FILES,
C      A SUBROUTINE IS CALLED TO READ/UNPACK HOUSEKEEPING INFORMATION.
C      ALSO FOR DISK FILES, THE BEGINNING RECORD NUMBER TO ACCESS
C      FOR THE PARTICULAR APPLICATION PROGRAM IS DETERMINED.
C
C
C   LOCAL PARAMETERS-
C
C      VARIABLE                TYPE  FUNCTION
C      --------                ----  --------
C      FINLIN (35)             C*1   A FINAL MESSAGE OUTPUT LINE
C
C
C
C   COMMON AREAS- PARM1C & INCLAV (CONSTANTS), CLVUNT, TYPDAT,
C                 HK1C, OHED1C
C
C
C   CALLED BY-  CLAVRORB
C
C
C   SUBPROGRAMS CALLED- R1CHK
C
C
C   RESTRICTIONS-
C
C
C   COMMENTS-
C
C
C***********************************************************************
C***********************************************************************
C
C
C...LINK IN CONSTANT PARAMETERS AND COMMON VARIABLES.
C

      INCLUDE "inc/ohed1c.f"
      INCLUDE "inc/inclav.f"
      INCLUDE "inc/parm1c.f"
      INCLUDE "inc/clvunt.f"
      INCLUDE "inc/typdat.f"
      INCLUDE "inc/hk1c.f"
      
C
C
C***********************************************************************
C***********************************************************************
C
C
C...VARIABLE DECLARATIONS
C
      CHARACTER*1 dot
      CHARACTER*2 suffix
      CHARACTER*8  PROGRM
      CHARACTER*40  c1name
C
      INTEGER*4  LREC1C, HOUSE(*), BEG1C, LAST1
C
      LOGICAL*4  DISK
C
      data dot/'.'/,suffix/'1c'/
      CHARACTER*2  SATIDS(7)
      DATA         SATIDS / '11', '  ', '14', '07', '12', '  ', '09'/

      integer ios
C
C***********************************************************************
C***********************************************************************
C
C
      BEG1C = 0
      LAST1 = 0
cry
cry.....make a 1c filename that reflects orbit number, date, start time
cry.....and end time nov 25, 94
cry
Cdl     Make it 7 digits for orbits after 999999
Cdl
      IF (orbnum .LE. 999999) THEN
         write (c1name,1060) satids(nsat), dot, osdate, dot,
     *                       ostime, dot, oetime, dot, suffix
 1060    format("noaa-",a2,a1,i5.5,a1,i4.4,a1,i4.4,a1,a2)
      ELSE
         write (c1name,1070) satids(nsat), dot, osdate, dot,
     *                       ostime, dot, oetime, dot, suffix
 1070    format("noaa-",a2,a1,i5.5,a1,i4.4,a1,i4.4,a1,a2)
      END IF
C
      write(6,1020)c1name
 1020 format(1x,'OUTPUT 1C FILE NAME ==> ',a40)
C
C
C ... DETERMINE RECORD LENGTH (BLOCKSIZE) OF 1C FILE BASED ON DATA TYPE.
C
      IF (GAC) THEN
        LREC1C = G1CWDS
      ELSE
        LREC1C = L1CWDS
      END IF
C
C
      IF (DISK) THEN
C
C ..... OPEN 1C DISK FILE.
C
        OPEN (UNIT=UNIT1C, FILE=c1name,
     1         STATUS='new',ACCESS='direct', RECL=LREC1C,
     1        FORM='UNFORMATTED', ERR=10 )
c
C        OPEN (UNIT=UNIT1C, ACCESS='DIRECT', RECL=LREC1C,
C     1        STATUS='OLD', FORM='UNFORMATTED', ERR=10)
C
C       WRITE(6,1000) UNIT1C, 'DISK', LREC1C
C
C
C ..... READ HOUSEKEEPING RECORD.
C
        CALL R1CHK (UNIT1C, DISK, HOUSE)
C
C
C ..... ASSIGN SPECIAL PARAMETERS FOR THE CLAVRORB & CAMAPPER PROGRAMS.
C
        IF ( (PROGRM .EQ. 'CLAVRORB') .OR.
     1       (PROGRM .EQ. 'CAMAPPER') ) THEN
C
C ..... DETERMINE FIRST 1C RECORD TO ACCESS (READ OR WRITE) FOR THIS
C       ORBIT.  (THE FIRST RECORD WILL BE THE ORBIT HEADER RECORD.)
C
          IF (PROGRM .EQ. 'CLAVRORB') THEN
            LAST1 = LC1END
            IDXORB = LC1IDX
          ELSE IF (PROGRM .EQ. 'CAMAPPER') THEN
            LAST1 = LCAME
            IDXORB = LCAMID
          END IF
C
C ..... DETERMINE BEGINNING RECORD NUMBER TO PROCESS.
C
          IF (LAST1 .EQ. -1) THEN
            BEG1C = -1
          ELSE
            BEG1C = LAST1 + 1
            IF (BEG1C .GT. C1TOT) BEG1C = 2
            IF (BEG1C .LT. 2) BEG1C = 2
          END IF
C
C ..... DETERMINE NEW 1C FILE INDEX NUMBER.
C
          IF (IDXORB .LE. 0) THEN
            NEWIDX = 1
          ELSE
            NEWIDX = IDXORB + 1
            IF (NEWIDX .GT. C1ORBS) NEWIDX = 1
          END IF
C
        END IF
C
C
      ELSE
C
C ..... OPEN TAPE FILE.
C
        OPEN (UNIT=UNIT1C, FILE=c1name,
     1        ACCESS='SEQUENTIAL',
     1        STATUS='NEW', FORM='UNFORMATTED', ERR=10,
     $        IOSTAT=IOS)
C        OPEN (UNIT=UNIT1C, ACCESS='SEQUENTIAL',
C     1        STATUS='NEW', FORM='UNFORMATTED', ERR=10)
C
C       WRITE(6,1000) UNIT1C, 'TAPE', LREC1C
C
      END IF
C
C
      GO TO 20
C
C
   10 CONTINUE
C                                 !  /* OPEN FOR 1C FILE FAILED */
      CALL EMESG (17, 'OPEN1C', 'FATAL')
C
C
   20 CONTINUE
C
C
      RETURN
C
 1000 FORMAT (//, '  ** SUBROUTINE OPEN1C:  SUCCESSFUL OPEN OF',
     1            ' CLAVR 1C FILE (UNIT ', I2, ') ON ', A4,
     2            ', RECORD LENGTH ==>  ', I5, ' **')
C
      END
