      SUBROUTINE PRINTCON
C***********************************************************************
C   NAME- PRINTCON
C
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE
C
C   VERSION- 1.0    DATE- 08/29/95   PROGRAMMER- Doug Love     (SMART)
C
C   FUNCTION- THIS SUBROUTINE PRINTS THE SPACECRAFT-DEPENDANT CONSTANTS
C             READ IN BY INSPCN VERSION 2
C
C   CALLED BY- CLAVRORB
C
C   COMMON AREAS- SPCNST, OHED1C, NEWCON
C
C*******************************************************************
C
C.....LINK IN COMMON AREAS
C
      INCLUDE "inc/ohed1c.f"
      INCLUDE "inc/spcnst.f"
      INCLUDE "inc/newcon.f"
C
      CHARACTER*2  SATIDS(7)
      DATA         SATIDS / '11', '  ', '14', '07', '12', '  ', '09'/
C
C.....WRITE OPENING MESSAGE
C
      WRITE(6,1000) NSAT, SATIDS(NSAT), SPCNID, SATIDS(SPCNID)
 1000 FORMAT (/, 10X, ' **** SPACECRAFT CONSTANTS: ****', /, 10X,
     1        ' Input Satellite ID:', I5, ' = NOAA', A2, /, 10X,
     2        ' Constant File SPCNID:', I3, ' = NOAA', A2, /)
C
C.....WRITE ARRAY OF LIMITS OF ENERGY ( INTO BOUND(2,3) )
C
      DO 10 I=1,3
         WRITE (6, 1010) I+2, BOUND(1,I), BOUND(2,I)
 1010    FORMAT (' Ch. ', I1, ' Rad. Bounds: ', 15X, 2F10.5)
   10 CONTINUE
C
C.....WRITE ( WAVENO(3,3) ) --
C
      WRITE (6, 1020) CH1W, CH2W
 1020 FORMAT (' Equiv. Widths (W) for Chs. 1 & 2: ', 2F10.5)
      WRITE (6, 1030) CH1F, CH2F
 1030 FORMAT (' Solar Irrad (F', "'", 's) for Chs. 1 & 2: ', 2F10.5)
      WRITE (6, 1040) CH3WNO, CH3WLN
 1040 FORMAT (' Ch. 3 Ws in WNO & WLN (Solar):    ', 2F10.5)
      WRITE (6, 1050) CH3SIN
 1050 FORMAT (' Ch. 3 Solar Spectral Irrad.:      ', F10.5)
      WRITE (6, 1060) CH3RWN, CH3RWL
 1060 FORMAT (' Ch. 3 Eff. WNO & WLN (Solar):  ', F10.2, F13.5)
C
C.....WRITE NO. PERIODS, NONZERO SRP START/END DATES, SRP PARAMETERS
C
      WRITE (6, 1070) NZSRPS
 1070 FORMAT (/, ' No. of nonzero SRP periods:', 6X, I5)
      IF (NZSRPS .GT. 0) THEN
         DO I = 1, NZSRPS
            WRITE (6, 1080) I, IYRDYS(I), IYRDYE(I)
 1080       FORMAT (' Per. ', I1, ' Start and End dates: ', 2I8)
            WRITE (6, 1090) I, SRP(I, 4), SRP(I, 5)
 1090       FORMAT (' Per. ', I1, ' Ch. 4 and 5 SRP values: ', 2F8.3)
         END DO
      END IF
      WRITE (6, 1099)
 1099 FORMAT (1X)
C
      DO 20 I=1,3
         WRITE (6, 1100) I+2, WAVENO(1,I), WAVENO(2,I), WAVENO(3,I)
 1100    FORMAT (' Central Wavenos, Ch. ', I1, ': ',  3F10.3)
   20 CONTINUE
C
C.....WRITE 5TH ORDER COEFFICIENTS FOR EACH PRT COUNT TO TEMPERATURE
C     CONVERSION
C
      WRITE (6, 1110)
 1110 FORMAT (/, ' Polynomial Coeffs for converting 4 PRT counts to',
     1        ' temperatures:', /, ' PRT:   Coef. 0:   Coef. 1:',
     2        '       Coef. 3:   Coef. 4:   Coef. 5:')
      DO 30 I=1,4
         WRITE (6, 1120) I, ACOEF(0,I), ACOEF(1,I),
     1                      ACOEF(2,I), ACOEF(3,I), ACOEF(4,I)
 1120    FORMAT (I5, 2F11.6, E15.6, 2F11.6)
   30 CONTINUE
C
C.....WRITE COEFFICIENTS FOR 4TH DEGREE POLYNOMIAL ( B1, B2, B3, B4 )
C
      WRITE (6, 1130) B1, B2, B3, B4
 1130 FORMAT (/, ' PRT Temp. Weighting Coefficients: ', 8X, 4F8.3)
C
C.....WRITE VARIABLES A, B, C, D, S3PI, CNUO
C
      WRITE (6, 1140) A, B, C, D
 1140 FORMAT (' CRT Temp. Weighting Coefficients: ', 8X, 4F8.3)
      WRITE (6, 1150) S3PI
 1150 FORMAT (' Ch. 3 Solar Spectral Irrad. / Pi: ', 12X, F9.3)
      WRITE (6, 1160) CNUO
 1160 FORMAT (' Central Wave No. for Ch. 3 Alb. over Ocean:   ', F8.2)
      WRITE (6, 1099)
C
      DO 40 I=1,2
         WRITE (6, 1170) I, X(I), Y(I), O(I)
 1170    FORMAT (' Ch. ', I1, ' X, Y, Offset Albedo params: ', 9X,
     1           F9.4, F9.6, F9.2)
  40  CONTINUE
      WRITE (6, 1099)
C
      WRITE (6, 1180) D0, Z
 1180 FORMAT (' Julian Launch Day from 1900 & Ref. Day Adjust (Z):',
     1        8X, 2I6)
C
C.....WRITE GAMMA ANGLE LIMITS.
C
      WRITE (6, 1190) (GAMLIM(I), I = 1, 5)
 1190 FORMAT (' Gamma Angle Limits:                    ', 5F6.1)
C
C  READ THE NEW COEFFICIENTS IN THE CONSTANTS FILE THAT
C  REPLACE THE ABOVE CH4 AND CH5 TABLES:
C
      WRITE (6, 1200) IDEGF
 1200 FORMAT (/, ' Flag: 0 = no degradation corrs. for Chs. 1&2:  ', I5)
      DO I = 3, 5
         WRITE (6, 1210) I, CNU(I), TIN(I), TSL(I)
 1210    FORMAT (' Ch. ' I1, ' Centroid WNO, T Intercept & Slope:    ',
     1           F8.3, F9.5, F9.6)
      END DO
C
      WRITE (6, 1220) IRLINF
 1220 FORMAT (/, ' Flag: 1 indicates need to compute RLIN: ', I5, /,
     1        ' Ch.:  Quadratic Coefficients for nonlinear',
     2        ' radiance corrections:')
      DO I = 3, 5
         WRITE (6, 1230) I, QA(I), QB(I), QC(I)
 1230    FORMAT (I5, F8.5, F10.7, F8.4)
      END DO
C
      WRITE (6, 1240) RSP
 1240 FORMAT (/, ' Radiances from Space (RSP) for Chs 3-5:  ', 3F10.4)
C
      WRITE(6,1299)
 1299 FORMAT (/, ' **** END OF SUBROUTINE PRINTCON ****', //)
C
      RETURN
      END
