      SUBROUTINE R1CHK (C1UNIT, DISK, HOUSE)                            
C***********************************************************************
C                                                                       
C  THIS SUBROUTINE READS THE CLAVR HOUSEKEEPING RECORD                  
C  FROM THE 1C DISK FILE.                                               
C                                                                       
C                                                                       
C... INCLUDE 1C FILE AND GENERAL GAC/LAC CONSTANTS.                     
C                                                                       
      INCLUDE "inc/parm1c.f"                                                 
      INCLUDE "inc/inclav.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE 1C HOUSEKEEPING RECORD COMMON.                             
C                                                                       
      INCLUDE "inc/hk1c.f"                                                    
C                                                                       
C                                                                       
C... INCLUDE DATA TYPE-DEPENDENT VARIABLES.                             
C                                                                       
      INCLUDE "inc/typdat.f"                                                   
C                                                                       
C                                                                       
C                                                                       
C... DECLARE  L O C A L  VARIABLES.                                     
C                                                                       
      LOGICAL*4  DISK                                                   
C                                                                       
      INTEGER*4  C1UNIT, HOUSE(*), GHOUSE(G1CWDS), LHOUSE(L1CWDS)       
C                                                                       
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
C                                                                       
C... DETERMINE CORRECT BUFFER SIZE BASED ON DATA TYPE.                  
C                                                                       
      IF (GAC) THEN                                                     
        LWORDS = G1CWDS                                                 
      ELSE                                                              
        LWORDS = L1CWDS                                                 
      END IF                                                            
C                                                                       
C                                                                       
C... READ THE HOUSEKEEPING RECORD FROM THE 1C FILE.                     
C                                                                       
      IF (DISK) THEN                                                    
C                                                                       
        IF (GAC) THEN                                                   
          READ (C1UNIT, REC = 1, ERR=20) GHOUSE                         
        ELSE                                                            
          READ (C1UNIT, REC = 1, ERR=20) LHOUSE                         
        END IF                                                          
C                                                                       
      ELSE                                                              
C                                                                       
        IF (GAC) THEN                                                   
          READ (C1UNIT, ERR=20) GHOUSE                                  
        ELSE                                                            
          READ (C1UNIT, ERR=20) LHOUSE                                  
        END IF                                                          
C                                                                       
      END IF                                                            
C                                                                       
C... STORE THE APPROPRIATE BUFFER IN THE OUTPUT HOUSEKEEPING REC ARRAY. 
C                                                                       
      IF (GAC) THEN                                                     
C                                                                       
        DO 30 I = 1, G1CWDS                                             
          HOUSE(I) = GHOUSE(I)                                          
   30   CONTINUE                                                        
C                                                                       
      ELSE                                                              
C                                                                       
        DO 38 I = 1, L1CWDS                                             
          HOUSE(I) = LHOUSE(I)                                          
   38   CONTINUE                                                        
C                                                                       
      END IF  
      GOTO 39                                                          
C                 !  /* SKIP HK REC READ ERROR MESSAGE */               
C                                                                       
C                                                                       
C... HOUSEKEEPING RECORD READ ERROR.                                    
C                                                                       
   20 CONTINUE   
      HOUSE(1) = 7500                                                 
      HOUSE(2) = 1                                               
      HOUSE(3) = 1                                                 
      HOUSE(4) = -1                                                 
      HOUSE(5) = -1                                                
      HOUSE(6) = 1                                                
      HOUSE(7) = 0                                                
      HOUSE(8) = 0                                             
      HOUSE(9) = 0                                             
      HOUSE(10)= -1   
      GOTO 39                                          
CMZ      CALL EMESG (19, 'R1CHK', 'FATAL')                                 
C                                                                       
C                                                                       
C                                                                       
C... UNPACK EACH WORD OF THE HOUSEKEEPING RECORD.                       
C                                                                       
   39 CONTINUE                                                        
      C1TOT  = HOUSE(1)                                                 
      C1ORBS = HOUSE(2)                                                 
      C1SAT  = HOUSE(3)                                                 
      LC1BEG = HOUSE(4)                                                 
      LC1END = HOUSE(5)                                                 
      LC1IDX = HOUSE(6)                                                 
      LCAMB  = HOUSE(7)                                                 
      LCAME  = HOUSE(8)                                                 
      LCAMID = HOUSE(9)                                                 
      LSTARC = HOUSE(10)                                                
C                                                                       
      DO 40 I = 1, C1ORBS                                               
        INX = 10 + 2*(I-1)                                              
        INXREX(I,1) = HOUSE(INX+1)                                      
        INXREX(I,2) = HOUSE(INX+2)                                      
   40 CONTINUE                                                          
C                                                                       
C                                                                       
C... PRINT THE INFORMATION IN THE 1C HOUSEKEEPING RECORD.               
C                                                                       
C     WRITE (6, 1000) (HOUSE(I), I = 1, 10)                             
C     WRITE (6, 1010) (HOUSE(I), I = 11, 20)   
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (//,                                                       
     1 ' * ----------------------------------------------- *', /,       
     2 '   CLAVR LEVEL 1C DATA BASE:  HOUSEKEEPING RECORD   ', /,       
     3 ' * ----------------------------------------------- *', /,       
     4 '   ( 1) TOTAL # RECORDS IN FILE.....', I6, /,                   
     5 '   ( 2) # ORBITS IN FILE............', I6, /,                   
     6 '   ( 3) SATELLITE ID................', I6, /,                   
     7 '   ( 4) 1ST RECORD  - CLOUD CLASS...', I6, /,                   
     8 '   ( 5) LAST RECORD - CLOUD CLASS...', I6, /,                   
     9 '   ( 6) ORB INDEX   - CLOUD CLASS...', I6, /,                   
     A '   ( 7) 1ST RECORD  - CLOUD AMT.....', I6, /,                   
     B '   ( 8) LAST RECORD - CLOUD AMT.....', I6, /,                   
     C '   ( 9) ORB INDEX   - CLOUD AMT.....', I6, /,                   
     D '   (10) LAST RECORD ARCHIVED........', I6)                      
 1010 FORMAT (                                                          
     1 '   (11) ORBIT 1 - 1ST RECORD........', I6, /,                   
     2 '   (12) ORBIT 1 - LAST RECORD.......', I6, /,                   
     3 '   (13) ORBIT 2 - 1ST RECORD........', I6, /,                   
     4 '   (14) ORBIT 2 - LAST RECORD.......', I6, /,                   
     5 '   (15) ORBIT 3 - 1ST RECORD........', I6, /,                   
     6 '   (16) ORBIT 3 - LAST RECORD.......', I6, /,                   
     7 '   (17) ORBIT 4 - 1ST RECORD........', I6, /,                   
     8 '   (18) ORBIT 4 - LAST RECORD.......', I6, /,                   
     9 '   (19) ORBIT 5 - 1ST RECORD........', I6, /,                   
     A '   (20) ORBIT 5 - LAST RECORD.......', I6, /,                   
     B ' * ----------------------------------------------- *', /)       
C                                                                       
      END                                                               
