      SUBROUTINE REPCLV(N1CREX)                                         
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- REPCLV                                                        
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 02/04/93   PROGRAMMER- DEBBIE CARR (SMSRC)    
C   VERSION- 1.0    DATE- 01/26/94   MINZE V CHIEN (SMSRC) MONITORING FILE
C                                                                       
C                                                                       
C   FUNCTION-                                                           
C                                                                       
C      GENERATES STATISTICAL OUTPUT FOR CLAVR CLOUD CLASSIFICATION.     
C                                                                       
C                                                                       
C   LOCAL PARAMETERS-                                                   
C                                                                       
C      VARIABLE                TYPE  FUNCTION                           
C      --------                ----  --------                           
C      FINLIN (35)             C*1   A FINAL MESSAGE OUTPUT LINE        
C                                                                       
C                                                                       
C                                                                       
C   COMMON AREAS- INCLAV (CONSTANTS), TYPDAT                            
C                                                                       
C                                                                       
C   CALLED BY-  CLAVRORB                                                
C                                                                       
C                                                                       
C   SUBPROGRAMS CALLED-                                                 
C                                                                       
C                                                                       
C   RESTRICTIONS-                                                       
C                                                                       
C                                                                       
C   COMMENTS-                                                           
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...LINK IN COMMON AREAS.                                               
C                                                                       
      INCLUDE "inc/kounts.f"                                                  
      INCLUDE "inc/clvunt.f"                                                  
      INCLUDE "inc/qcflgs.f"                                                 
      INCLUDE "inc/baddat.f"  
      INCLUDE "inc/typdat.f"
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...DECLARE LOCAL PARAMETERS.                                           
C                                                                       
      INTEGER*4     MAXCOD                                              
C                                                                       
      PARAMETER     (MAXCOD = 100)                                      
C                                                                       
C                                                                       
C...DECLARE VARIABLES.                                                  
C                                                                       
      CHARACTER*5   TEST(10)                                            
      CHARACTER*21  CHDESC(6)                                           
      CHARACTER*53  QCHART(1:16)                                        
C                                                                       
      LOGICAL*4     FIRST                                               
C                                                                       
      INTEGER*4     TOTDAY(0:MAXLST), DAYCLR(0:MAXLST),                 
     1              DAYCLD(0:MAXLST), DAYMIX(0:MAXLST),                 
     2              TOTNIT(0:MAXLST), NITCLR(0:MAXLST),                 
     3              NITCLD(0:MAXLST), NITMIX(0:MAXLST),                 
     4              TOTBAD, JSUM(1:MAXCOD)                              
C                                                                       
C                                                                       
      DATA  TEST / 'CIRT ',                                             
     1             'C3AR ',                                             
     2             'C3AT ',                                             
     3             'ULST ',                                             
     4             '     ',                                             
     5             '     ',                                             
     6             '     ',                                             
     7             '     ',                                             
     8             '     ',                                             
     9             '*ALL*'/                                             
C                                                                       
      DATA CHDESC/ 'CHANNEL 1 ALBEDO     ',                             
     1             'CHANNEL 2 ALBEDO     ',                             
     2             'CHANNEL 3 ALBEDO     ',                             
     3             'CHANNEL 3 TEMPERATURE',                             
     4             'CHANNEL 4 TEMPERATURE',                             
     5             'CHANNEL 5 TEMPERATURE'/                             
C                                                                       
      DATA  QCHART /                                                    
     1 '   1      1     FATAL FLAG -- DONT USE FOR PRODUCTS  ',         
     2 '          2     TIME SEQUENCE ERROR                  ',         
     3 '          3     DATA GAP -- PRECEDING CURRENT FRAME  ',         
     4 '          4     DATA JITTER (FRAME RESYNC OCCURRED)  ',         
     5 '          5     INSUFFICIENT DATA FOR CALIBRATION    ',         
     6 '          6     NO EARTH LOCATION                    ',         
     7 '          7     ASCEND (0) / DESCEND (1) FLAG--N/A   ',         
     8 '          8     PSEUDO NOISE, DATA NOT USED FOR CALIB',         
     9 '   2      1     BIT SYNC STATUS -- DROP LOCK ON FRAME',         
     A '          2     SYNC ERROR                           ',         
     B '          3     FRAME SYNC LOCK                      ',         
     C '          4     FLYWHEELING DURING FRAME             ',         
     D '          5     BIT SLIPPAGE DURING FRAME            ',         
     E '          6     SPARE                                ',         
     F '          7     SPARE                                ',         
     G '          8     CLAVR EDIT FLAG                      '/         
C                                                                       
      DATA  TOTDAY /2*0/, DAYCLR /2*0/, DAYCLD /2*0/, DAYMIX /2*0/,     
     1      TOTNIT /2*0/, NITCLR /2*0/, NITCLD /2*0/, NITMIX /2*0/,     
     2      JSUM /MAXCOD * 0/                                           
C                                                                       
      DATA  FIRST /.TRUE./                                              
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...PRINT 1B QUALITY BYTE STATISTICS.                                   
C                                                                       
C     WRITE (6,1050) (QCHART(I), QFLAG(I), I = 1, 16)                   
C     WRITE (UNITMF,1050) (QCHART(I), QFLAG(I), I = 1, 16)                   
C                                                                       
C                                                                       
C...PRINT STATISTICS ON BAD DATA.                                       
C                                                                       
      TOTBAD = BDLAT + BDLON + BDSZN + BDRLZ + BDSTZ +                  
     1         BDCH1A + BDCH2A + BDCH3A +                               
     2         BDCH3T + BDCH4T + BDCH5T                                 
C                                                                       
C     WRITE (6,1080) BDLAT,BDLON,BDSZN,BDRLZ,BDSTZ,                     
C    1               BDCH1A,BDCH2A,BDCH3A,                              
C    2               BDCH3T,BDCH4T,BDCH5T,                              
C    3               TOTBAD,TOTBSL                                      
C     WRITE (UNITMF,1080) BDLAT,BDLON,BDSZN,BDRLZ,BDSTZ,                     
C    1               BDCH1A,BDCH2A,BDCH3A,                              
C    2               BDCH3T,BDCH4T,BDCH5T,                              
C    3               TOTBAD,TOTBSL                                      
C                                                                       
C                                                                       
C*********************************************************************  
CC..PRINT MIN AND MAX FOR CHANNEL VALUES, ANGLE VALUES, AND             
CC  LATITUDE AND LONGITUDE VALUES                                       
CC                                                                      
CC                                                                      
CC..CONVERT INTEGER VALUES TO DECIMAL VALUES FOR PRINTING PURPOSES.     
CC                                                                      
CC    DO 5 I=1,6                                                        
CC                                                                      
CC      RCHMIN(I) = CHMIN(I)/10.0                                       
CC                                                                      
CC  5 CONTINUE                                                          
CC                                                                      
CC    RRLZMN = RLZMIN/10.0                                              
CC    RRLZMX = RLZMAX/10.0                                              
CC    RSTZMN = STZMIN/10.0                                              
CC    RSTZMX = STZMAX/10.0                                              
CC    RSZNMN = SZNMIN/1000.0                                            
CC    RSZNMX = SZNMAX/1000.0                                            
CC                                                                      
CC                                                                      
CC    WRITE (6,1090) (RCHMIN(I),RCHMAX(I), I = 1,6),                    
CC   1                RSZNMN,RSZNMX,RRLZMN,RRLZMX,                      
CC   2                RSTZMN,RSTZMX,LATMIN,LATMAX,                      
CC   3                LONMIN,LONMAX                                     
CC                                                                      
C*********************************************************************  
C                                                                       
C                                                                       
C...PRINT CHART SUMMARIZING THE # 2X2 ARRAYS BYPASSED BY INDIVIDUAL     
C   CLAVR TESTS DUE TO BAD CHANNEL DATA.                                
C                                                                       
C     WRITE (6,1100)                                                    
C                                                                       
C     DO 25 ITEST = 1, 10                                               
C                                                                       
C       IF (TEST(ITEST) .EQ. '     ') GO TO 25                          
C                                                                       
C       DO 24 ICHAN = 1, 6                                              
C                                                                       
C         IF (ICHAN .EQ. 1) THEN                                        
C           WRITE (6,1110) TEST(ITEST),                                 
C    1                     CHDESC(ICHAN), TSTSKP(ITEST,ICHAN)           
C         ELSE                                                          
C           WRITE (6, 1120) CHDESC(ICHAN), TSTSKP(ITEST,ICHAN)          
C         END IF                                                        
C                                                                       
C  24   CONTINUE                                                        
C                                                                       
C  25 CONTINUE                                                          
C                                                                       
C                                                                       
C...PRINT DAYTIME AND NIGHTTIME TEST SUMMARY CHARTS FOLLOWED BY         
C   THE TOTAL NUMBER OF CLEAR, CLOUDY, AND MIXED PIXELS FOR THIS ORBIT. 
C                                                                       
      DO 30 I = 1, MAXTST                                               
C                                                                       
        DO 20 K = 0, MAXLST                                             
C                                                                       
          DAYCLR(K) = DAYCLR(K) + NUMDAY(I,1,K)                         
          DAYCLD(K) = DAYCLD(K) + NUMDAY(I,2,K)                         
          DAYMIX(K) = DAYMIX(K) + NUMDAY(I,3,K)                         
C                                                                       
          NITCLR(K) = NITCLR(K) + NUMNIT(I,1,K)                         
          NITCLD(K) = NITCLD(K) + NUMNIT(I,2,K)                         
          NITMIX(K) = NITMIX(K) + NUMNIT(I,3,K)                         
C                                                                       
          DO 10 J = 1, MAXCLS                                           
            TOTDAY(K) = TOTDAY(K) + NUMDAY(I,J,K)                       
            TOTNIT(K) = TOTNIT(K) + NUMNIT(I,J,K)                       
   10     CONTINUE                                                      
C                                                                       
   20   CONTINUE                                                        
C                                                                       
   30 CONTINUE                                                          
C                                                                       
C                                                                       
C... PRINT STATS FOR DAYTIME ALGORITHM PATH.                            
C                                                                       
C     WRITE (6, 1000) 'DAYTIME ALGORITHM PATH'                          
C     WRITE (UNITMF, '(//A/)') ' DAYTIME ALGORITHM PATH'                          
C                                                                       
      DO 50 I = 1, MAXTST                                               
C                                                                       
        IF (DNAME(I)(1:5) .EQ. '12345') GO TO 60                        
C                                                                       
        DO 40 J = 1, MAXCLS                                             
C                                                                       
          ICC = DCODE(I,J)                                              
          ICTOT = NUMDAY(I,J,0) + NUMDAY(I,J,1)                         
          IF (ICC .NE. 0) JSUM(ICC) = JSUM(ICC) + ICTOT                 
C                                                                       
C         WRITE (6, 1010) DNAME(I), ICC, CCLASS(J),                     
C    1     NUMDAY(I,J,0), NUMDAY(I,J,1), ICTOT                          
C                                                                       
   40   CONTINUE                                                        
C                                                                       
C       WRITE (6, 1060)                                                 
   50 CONTINUE                                                          
C                                                                       
   60 CONTINUE                                                          
C                                                                       
C     WRITE (6, 1070) (DAYCLR(I), I = 0, MAXLST), (DAYCLR(0)+DAYCLR(1)),
C    1                (DAYCLD(I), I = 0, MAXLST), (DAYCLD(0)+DAYCLD(1)),
C    2                (DAYMIX(I), I = 0, MAXLST), (DAYMIX(0)+DAYMIX(1)),
C    2                (TOTDAY(I), I = 0, MAXLST), (TOTDAY(0)+TOTDAY(1)) 
C     WRITE (UNITMF, 1070) 
C    .                (DAYCLR(I), I = 0, MAXLST), (DAYCLR(0)+DAYCLR(1)),
C    1                (DAYCLD(I), I = 0, MAXLST), (DAYCLD(0)+DAYCLD(1)),
C    2                (DAYMIX(I), I = 0, MAXLST), (DAYMIX(0)+DAYMIX(1)),
C    2                (TOTDAY(I), I = 0, MAXLST), (TOTDAY(0)+TOTDAY(1)) 
C                                                                       
C                                                                       
C... PRINT STATS FOR NIGHTTIME ALGORITHM PATH.                          
C                                                                       
C     WRITE (6, 1000) 'NIGHTTIME ALGORITHM PATH'                        
C     WRITE (UNITMF, '(//A/)') ' NIGHTTIME ALGORITHM PATH'                          
C                                                                       
      DO 80 I = 1, MAXTST                                               
C                                                                       
        IF (NNAME(I)(1:5) .EQ. '12345') GO TO 90                        
C                                                                       
        DO 70 J = 1, MAXCLS                                             
C                                                                       
          ICC = NCODE(I,J)                                              
          ICTOT = NUMNIT(I,J,0) + NUMNIT(I,J,1)                         
          IF (ICC .NE. 0) JSUM(ICC) = JSUM(ICC) + ICTOT                 
C                                                                       
C         WRITE (6, 1010) NNAME(I), ICC, CCLASS(J),                     
C    1     NUMNIT(I,J,0), NUMNIT(I,J,1), ICTOT                          
C                                                                       
   70   CONTINUE                                                        
C                                                                       
C       WRITE (6, 1060)                                                 
   80 CONTINUE                                                          
C                                                                       
   90 CONTINUE                                                          
C                                                                       
C     WRITE (6, 1070) (NITCLR(I), I = 0, MAXLST), (NITCLR(0)+NITCLR(1)),
C    1                (NITCLD(I), I = 0, MAXLST), (NITCLD(0)+NITCLD(1)),
C    2                (NITMIX(I), I = 0, MAXLST), (NITMIX(0)+NITMIX(1)),
C    3                (TOTNIT(I), I = 0, MAXLST), (TOTNIT(0)+TOTNIT(1)) 
C     WRITE (UNITMF, 1070) 
C    .                (NITCLR(I), I = 0, MAXLST), (NITCLR(0)+NITCLR(1)),
C    1                (NITCLD(I), I = 0, MAXLST), (NITCLD(0)+NITCLD(1)),
C    2                (NITMIX(I), I = 0, MAXLST), (NITMIX(0)+NITMIX(1)),
C    3                (TOTNIT(I), I = 0, MAXLST), (TOTNIT(0)+TOTNIT(1)) 
C                                                                       
C                                                                       
C...PRINT OUT TOTAL NUMBER OF CLEAR, CLOUDY, MIXED PIXELS.              
C                                                                       
      ITOTAL = 0                                                        
C                                                                       
      DO 100 I = 0, MAXCLS                                              
        ITOTAL = ITOTAL + TOTCCM(I)                                     
  100 CONTINUE                                                          
C                                                                       
C     WRITE (6, 1040) (TOTCCM(I), I = 0, MAXCLS), ITOTAL                
C     WRITE (UNITMF, 1040) (TOTCCM(I), I = 0, MAXCLS), ITOTAL                
C                                                                       
C                                                                       
C...PRINT OUT THE NUMBER OF SAMPLES FOR EACH CLOUD CODE.                
C                                                                       
C     WRITE (6, 1130)                                                   
C                                                                       
      DO 200 I = 1, MAXCOD                                              
        IF (JSUM(I) .LE. 0) GO TO 200                                   
        ISUMPX = (JSUM(I) * 4)                                          
C       WRITE (6, 1140) I, ISUMPX, JSUM(I)                              
  200 CONTINUE                                                          
      FRAPIX = (ITOTAL - TOTCCM(0))
      TOTPIX = ITOTAL
      FRAPIX =(FRAPIX/TOTPIX)*100.0
      NUMSCN = ITOTAL*4/(NPIXLS - MOD(NPIXLS,2))
      FRASCN = NUMSCN - QFLAG(16)
      FRASCN = (FRASCN/NUMSCN) * 100.0
      IF (FRASCN .LT. 0.0) FRASCN = 0.0
      IF (FRAPIX .LT. 0.0) FRAPIX = 0.0
      WRITE(6,2000) (ITOTAL-TOTCCM(0)),ITOTAL,FRAPIX,
     1              QFLAG(16),NUMSCN,FRASCN,N1CREX+2
 2000 FORMAT(1X,'GOOD 2X2 ARR  TOTAL ARR  % OF GOOD ARR',
     1'  BAD SCANS TOTAL SCANS  % OF GOOD SCANS  # 1C RECORDS',/,
     2 1X,I12,I11,8X,F7.2,2X,I9,2X,I10,9X,F7.2,5X,I6,/,1x,103('*'))
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (1H1, 1X, 125('*'), /,                                     
     1  2X, A25, 5X, 'CC', 5X, 'CCM   ', 12X,'# OCEAN ARRAYS',          
     2 12X, ' # LAND ARRAYS',12X, '   TOTAL # 2X2', /, 2X, 125('*'), /) 
C                                                                       
 1010 FORMAT (2X, A25, 5X, I2, 5X, A6, 3(12X, I14))                     
C                                                                       
 1020 FORMAT(9X,A4, 3I15)                                               
C                                                                       
 1040 FORMAT(5(/),' 2X2 ORBITAL SUMMARY:   # NO DECISION   ==>', I10,   
     1        4X, ' (INCLUDES BAD SCANS & INDIV. 2X2S SKIPPED)',        
     2         /, '                        # CLEAR         ==>', I10,   
     3         /, '                        # CLOUDY        ==>', I10,   
     4         /, '                        # MIXED         ==>', I10,   
     5         /, '                        ', 28('-'),                  
     6         /, '                        2X2 GRAND TOTAL ==>', I10,//)
C                                                                       
 1050 FORMAT (///, ' AVHRR QUALITY FLAG BYTES:', //,                    
     1 ' BYTE #  BIT #  DEFINITION                          # FAILED',/,
     2 ' -----------------------------------------------------------',/,
     3  16(A53,I7,/), /)                                                
C                                                                       
 1060 FORMAT (2X, 125('-'))                                             
C                                                                       
 1070 FORMAT (49X, '# CLEAR  OCEAN:', I7, 5X, '# CLEAR  LAND:',I7,      
     1         4X, '# CLEAR  TOTAL:', I7, /,                            
     2        49X, '# CLOUDY OCEAN:', I7, 5X, '# CLOUDY LAND:',I7,      
     3         4X, '# CLOUDY TOTAL:', I7, /,                            
     4        49X, '# MIXED  OCEAN:', I7, 5X, '# MIXED  LAND:',I7,      
     5         4X, '# MIXED  TOTAL:', I7, /, 2X, 125('-'), /,           
     6        49X, 'TOTAL OCEAN:   ', I7, 5X, 'TOTAL LAND:   ',I7,      
     7         4X, 'TOTAL # 2X2:   ', I7, /)                            
C                                                                       
 1080 FORMAT (/,/,/,/,1X,'QC STATISTICS                 # OF BAD',      
     1        ' PIXELS',/,                                              
     2        1X, 45('-'),/,/,                                          
     3        1X, '# BAD LATITUDES:                   ',I9,/,           
     4        1X, '# BAD LONGITUDES:                  ',I9,/,           
     5        1X, '# BAD SOLAR ZENITH ANGLES:         ',I9,/,           
     6        1X, '# BAD RELATIVE AZIMUTH ANGLES:     ',I9,/,           
     7        1X, '# BAD SATELLITE ZENITH ANGLES:     ',I9,/,           
     8        1X, '# BAD CHANNEL 1 ALBEDOS:           ',I9,/,           
     9        1X, '# BAD CHANNEL 2 ALBEDOS:           ',I9,/,           
     A        1X, '# BAD CHANNEL 3 ALBEDOS:           ',I9,/,           
     B        1X, '# BAD CHANNEL 3 TEMPERATURES:      ',I9,/,           
     C        1X, '# BAD CHANNEL 4 TEMPERATURES:      ',I9,/,           
     D        1X, '# BAD CHANNEL 5 TEMPERATURES:      ',I9,/,/,         
     E        1X, 'TOTAL NUMBER OF BAD DATA VALUES:   ',I9,/,/,         
     F        1X, 'TOTAL NUMBER OF SCANLINES          ',/,              
     G        1X, '  CONTAINING BAD DATA:             ',I9,/,/)         
C                                                                       
 1090 FORMAT (/,/,/,/,                                                  
     1       1X,'MINIMUM AND MAXIMUM VALUES:    ',//,                   
     2       1X,'CHANNEL 1 ALBEDO MIN         = ',F10.2,/,              
     3       1X,'CHANNEL 1 ALBEDO MAX         = ',F10.2,/,              
     4       1X,'CHANNEL 2 ALBEDO MIN         = ',F10.2,/,              
     5       1X,'CHANNEL 2 ALBEDO MAX         = ',F10.2,/,              
     6       1X,'CHANNEL 3 ALBEDO MIN         = ',F10.2,/,              
     7       1X,'CHANNEL 3 ALBEDO MAX         = ',F10.2,/,              
     8       1X,'CHANNEL 3 TEMPERATURE MIN    = ',F10.2,/,              
     9       1X,'CHANNEL 3 TEMPERATURE MAX    = ',F10.2,/,              
     A       1X,'CHANNEL 4 TEMPERATURE MIN    = ',F10.2,/,              
     B       1X,'CHANNEL 4 TEMPERATURE MAX    = ',F10.2,/,              
     C       1X,'CHANNEL 5 TEMPERATURE MIN    = ',F10.2,/,              
     D       1X,'CHANNEL 5 TEMPERATURE MAX    = ',F10.2,/,              
     E       1X,'COS(SOLAR ZENITH ANGLE MIN)  = ',F10.2,/,              
     F       1X,'COS(SOLAR ZENITH ANGLE MAX)  = ',F10.2,/,              
     G       1X,'RELATIVE ZENITH ANGLE MIN    = ',F10.2,/,              
     H       1X,'RELATIVE ZENITH ANGLE MAX    = ',F10.2,/,              
     I       1X,'SATELLITE ZENITH ANGLE MIN   = ',F10.2,/,              
     J       1X,'SATELLITE ZENITH ANGLE MAX   = ',F10.2,/,              
     K       1X,'LATITUDE MIN                 = ',F10.2,/,              
     L       1X,'LATITUDE MAX                 = ',F10.2,/,              
     M       1X,'LONGITUDE MIN                = ',F10.2,/,              
     N       1X,'LONGITUDE MAX                = ',F10.2,/,/,/)          
C                                                                       
 1100 FORMAT (////, 1X, 'SUMMARY OF 2X2 ARRAYS BYPASSED BY INDIVIDUAL', 
     1        ' CLAVR TESTS DUE TO BAD DATA:', /, 1X, 81('-'), ///,     
     2        1X, 'CLAVR TEST', 20X, 'PARM. VIOLATION', 20X,            
     3        '# 2X2 OCCURENCES', /,                                    
     4        1X, '----------', 20X, '---------------', 20X,            
     5        '----------------')                                       
C                                                                       
 1110 FORMAT (/, 1X, A5, 25X, A21, 20X, I10)                            
C                                                                       
 1120 FORMAT (31X, A21, 20X, I10)                                       
C                                                                       
 1130 FORMAT (1H1, /, ' BREAKDOWN OF CLOUD CODES PROCESSED:', //,       
     1 ' CLOUD CODE     # PIXEL SAMPLES', 7X,                           
     2 ' # 2X2 ARRAYS', /,                                              
     3 ' ------------------------------------',                         
     4 '--------------------', /)                                       
C                                                                       
 1140 FORMAT (1X, I10, 10X, I10, 10X, I10)                              
CC140 FORMAT (1X, I10, 11X, A6, 10X, I10, 10X, F10.2)                   
C                                                                       
C                                                                       
      END                                                               
