      SUBROUTINE RFLAGS (CH,ANGLES)                                     
C***********************************************************************
C   NAME- RFLAGS                                                        
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 06/18/93   PROGRAMMER- CID PRADERAS  (SMSRC)  
C                                                                       
C   FUNCTION- THIS SUBROUTINE REPLACES FLAGGED VALUES IN THE ARRAYS CH  
C             AND ANGLES TO VALID 1C VALUES.                            
C                                                                       
C                                                                       
C                                                                       
C   FILES-                                                              
C     NONE                                                              
C                                                                       
C   LOCAL PARAMETERS-                                                   
C     VARIABLE            TYPE  FUNCTION                                
C     --------            ----  ----------------------------------      
C     CH                  I*2    ARRAY OF CHANNEL VALUES                
C     ANGLES              I*2    ARRAY WHICH CONTAINS SOLAR ZENITH,     
C                                RELATIVE AZIMUTH AND SATELLITE ZENITH  
C                                ANGLES                                 
C                                                                       
C                                                                       
C   CALLED BY- W1CDAT                                                   
C                                                                       
C   SUBPROGRAMS CALLED- NONE                                            
C                                                                       
C   COMMON AREAS- INCLAV,TYPDAT,RANGES,BADDAT                           
C                                                                       
C*******************************************************************    
C                                                                       
      INCLUDE "inc/inclav.f"                                                   
      INCLUDE "inc/typdat.f"                                                   
      INCLUDE "inc/ranges.f"                                                 
      INCLUDE "inc/baddat.f"                                                   
C                                                                       
      REAL*4         CH(MAXLPX,6,2)                                     
C                                                                       
      INTEGER*2      ANGLES(MAXLPX,2,3)                                 
C                                                                       
C                                                                       
C                                                                       
C.....REPLACE FLAGGED VALUES IN ARRAYS ANGLE AND CH TO VALID 1C VALUES. 
C     (THE VALUES WERE PREVIOUSLY FLAGGED IN CHKRNG OR ALBTMP)          
C                                                                       
      DO 20 IREC = 1,2                                                  
C                                                                       
        DO 10 I = 1,NPIXLS                                              
C                                                                       
          IF ( ANGLES(I,IREC,1) .EQ. SKP2X2 )                           
     1         ANGLES(I,IREC,1) = SZN1C                                 
C                                                                       
          IF ( CH(I,1,IREC) .EQ. RSKPCC ) CH(I,1,IREC) = CH11C1         
          IF ( CH(I,2,IREC) .EQ. RSKPCC ) CH(I,2,IREC) = CH21C1         
          IF ( CH(I,3,IREC) .EQ. RSKPCC ) CH(I,3,IREC) = CH31C1         
C                                                                       
          IF ( CH(I,4,IREC) .EQ. RSKPCC ) CH(I,4,IREC) = CH3T1C         
C                                                                       
          IF ( CH(I,5,IREC) .EQ. RSKPCC ) CH(I,5,IREC) = CH4T1C         
          IF ( CH(I,6,IREC) .EQ. RSKPCC ) CH(I,6,IREC) = CH5T1C         
C                                                                       
C                                                                       
   10   CONTINUE                                                        
C                                                                       
C                                                                       
   20 CONTINUE                                                          
C                                                                       
C                                                                       
C                                                                       
      RETURN                                                            
      END                                                               
