       SUBROUTINE RGCT(PIX,PF,TH,CO)                                    
C********************************************************************** 
C                                                                       
C      FUNCTION: PERFORMS REFLECTANCE GROSS CLOUD TEST OVER             
C       LAND OR OCEAN SURFACES.                                         
C                                                                       
C      INPUT:                                                           
C       PIX     -     CHANNEL 1 OR CHANNEL 2 ALBEDO                     
C       TH      -     LAND/OCEAN THRESHOLD                              
C       CO      -     CLEAR/CLOUD FLAG                                  
C                                                                       
C      OUTPUT:                                                          
C       PF      -     CLEAR/CLOUD/MIXED FLAG: 0=CLEAR;1=CLOUDY;         
C                    2=MIXED                                            
C********************************************************************** 
C                                                                       
       REAL PIX(4), TH                                                  
       INTEGER*4 PF                                                     
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
       ICT=0                                                            
C                                                                       
C...ACCUMULATE NUMBER OF TIME ALBEDO VALUE IS GREATER THAN THRESHOLD    
C                                                                       
       DO 10 I=1,4                                                      
         IF(PIX(I).GT.TH) THEN                                          
            ICT = ICT + 1                                               
            CO(I) = 1                                                   
         ELSE                                                           
            CO(I) = 0                                                   
         ENDIF                                                          
 10    CONTINUE                                                         
C                                                                       
C...ASSIGN CLEAR/CLOUDY/MIXED FLAGS                                     
C                                                                       
       IF(ICT.EQ.0) PF=0                                                
       IF(ICT.GT.0.AND.ICT.LT.4) PF=2                                   
       IF(ICT.EQ.4) PF=1                                                
C                                                                       
       RETURN                                                           
       END                                                              
