       SUBROUTINE RRCT(PIX1,PIX2,PF,CO)                                 
C********************************************************************** 
C                                                                       
C      FUNCTION - REFLECTANCE RATIO TEST (CHANNEL2/CHANNEL 1)           
C                                                                       
C      INPUT:                                                           
C       PIX1  -  CHANNEL 1 PIXEL ARRAY                                  
C       PIX2  -  CHANNEL 2 PIXEL ARRAY                                  
C                                                                       
C      OUTPUT:                                                          
C       PF    -  CLEAR/CLOUD/MIXED FLAG.0=CLEAR,1=CLOUD,                
C               2=MIXED.                                                
C       CO    -  CLEAR/CLOUD FLAG                                       
C                                                                       
C********************************************************************** 
C                                                                       
       REAL PIX1(4),PIX2(4),RAT(4)                                      
       INTEGER*4 PF                                                     
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
       TH1=0.9                                                          
       TH2=1.1                                                          
C                                                                       
C...DETERMINE RATIOS OF CHANNEL 2 TO CHANNEL 1 FOR NONE ZERO VALUES     
C                                                                       
       DO 10 I=1,4                                                      
         IF(PIX1(I).EQ.0.0) GO TO 11                                    
         RAT(I)=PIX2(I)/PIX1(I)                                         
         GO TO 10                                                       
 11      RAT(I)=1.0                                                     
 10    CONTINUE                                                         
C                                                                       
C...ACCUMULATE NUMBER OF TIMES THAT THE RATIO IS IN BETWEEN THE         
C...THRESHOLDS                                                          
C                                                                       
       ICT=0                                                            
       DO 20 J=1,4                                                      
         IF(RAT(J).GT.TH1.AND.RAT(J).LT.TH2) THEN                       
            ICT = ICT + 1                                               
            CO(J) = 1                                                   
         ELSE                                                           
            CO(J) = 0                                                   
         ENDIF                                                          
 20    CONTINUE                                                         
C                                                                       
       IF(ICT.EQ.4) PF=1                                                
       IF(ICT.EQ.0) PF=0                                                
       IF(ICT.GT.0.AND.ICT.LT.4) PF=2                                   
C                                                                       
       RETURN                                                           
       END                                                              
