       SUBROUTINE RUT(PIX,PF,TH,CO)                                     
C********************************************************************** 
C                                                                       
C       FUNCTION - REFLECTANCE UNIFORMITY TEST FOR LAND                 
C        OR OCEAN SURFACES (DAYTIME)                                    
C                                                                       
C      INPUT:                                                           
C       PIX   -   CHANNEL 1 OR CHANNEL 2 ALBEDO                         
C       TH    -   LAND/OCEAN THRESHOLDS                                 
C                                                                       
C      OUTPUT:                                                          
C       PF    -   CLEAR/CLOUD MIXED FLAG. 0=CLEAR,1=CLOUD,              
C                2=MIXED                                                
C       CO    -   CLEAR/CLOUD FLAG                                      
C                                                                       
C********************************************************************** 
C                                                                       
       REAL*4 MAX,MIN,PIX(4), TH                                        
       INTEGER*4 PF                                                     
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
C...SET MIN AND MAX VALUES TO FIRST PIXEL                               
C                                                                       
       MIN=PIX(1)                                                       
       MAX=MIN                                                          
C                                                                       
C...TEST FOR MAX/MIN VALUE OF OTHER 3                                   
C                                                                       
       DO 20 IP=2,4                                                     
         IF(PIX(IP).GT.MAX) MAX=PIX(IP)                                 
         IF(PIX(IP).LT.MIN) MIN=PIX(IP)                                 
 20    CONTINUE                                                         
C                                                                       
C...TEST IF MAX/MIN DIFFERENCE IS GREATER THAN THRESHOLD                
C                                                                       
       IF((MAX-MIN).GT.TH) GO TO 999                                    
       PF=0                                                             
       DO 30 JP = 1, 4                                                  
          CO(JP) = 0                                                    
  30   CONTINUE                                                         
       GO TO 998                                                        
C                                                                       
 999   PF=2                                                             
       CO(1) = 1                                                        
       CO(2) = 0                                                        
       CO(3) = 0                                                        
       CO(4) = 1                                                        
 998   CONTINUE                                                         
       RETURN                                                           
       END                                                              
