      FUNCTION  SETDCC (LST2X2)                                         
C********************************************************************** 
C                                                                       
C    FUNCTION - THIS ROUTINE WILL RETURN A CLOUD CODE (COLOR CODE)      
C               VALUE BASED ON THE LAST DIRECT CLAVR TEST EXECUTED,     
C               THE PATH THROUGH THE ALGORITHM FLOWCHART (DIRECT OR     
C               RESTORAL, AND THE FINAL CLEAR/CLOUDY/MIXED DECISION     
C               REACHED BY THE CLAVR ALGORITHM.                         
C                                                                       
C               ***** D A Y T I M E  V E R S I O N *****                
C                                                                       
C                                                                       
C                  1 : RED       :O/L: CLOUDY RGCT > C3AR               
C                  2 : RED       :O  : CLOUDY RGCT > TUR (T4)           
C                  4 : GREEN     :O/L: CLOUDY RRCT > TUR                
C                  5 : YELLOW    :O/L: CLOUDY C3AT > TUR                
C                  6 : PINK      :O/L: CLOUDY FMFT                      
C                  7 : LT PURPLE :O/L: CLOUDY TUT                       
C                  8 : LT BLUE   :O/L: CLOUDY TGCT                      
C                  9 : PINK      :O/L: CLOUDY ICE FMFT                  
C                 11 : LT BLUE   :  L: CLOUDY ICE TGCT                  
C                                                                       
C                 12 : BLACK     :O/L: CLEAR                            
C                 13 : WHITE     :O/L: CLEAR RGCT                       
C                 14 : GREY      :O/L: CLEAR RUT                        
C                 15 : OLIVE     :O/L: CLEAR RRCT                       
C                 16 : DK PURPLE :O/L: CLEAR C3AT                       
C                                                                       
C                 17 : RED       :O/L: MIXED RGCT > C3AR                
C                 18 : RED       :O  : MIXED RGCT > TUR (T4)            
C                 19 : BLUE      :O/L: MIXED RUT  > TUR                 
C                 20 : GREEN     :O/L: MIXED RRCT > TUR                 
C                 21 : YELLOW    :O/L: MIXED C3AT > TUR                 
C                 22 : PINK      :O/L: MIXED FMFT                       
C                 23 : LT PURPLE :O/L: MIXED TUT                        
C                 24 : LT BLUE   :O/L: MIXED TGCT                       
C                 25 : PINK      :O/L: MIXED ICE FMFT                   
C                 26 : LT PURPLE :O/L: MIXED ICE TUT                    
C                 27 : LT BLUE   :  L: MIXED ICE TGCT                   
C                                                                       
C                 28 : WHITE     :O/L: CLEAR ICE RGCT                   
C                 29 : GREY      :O/L: CLEAR ICE RUT                    
C                 30 : DK PURPLE :  L: CLEAR C3AT > TGCR                
C                 31 : OLIVE     :  L: CLEAR RRCT > TGCR                
C                                                                       
C                                                                       
C*********************************************************************  
C                                                                       
      INCLUDE "inc/kounts.f"                                                  
C                                                                       
      INCLUDE "inc/apath.f"                                                   
C                                                                       
C                                                                       
      CHARACTER*24  COMBO                                               
C                                                                       
      INTEGER*2     SETDCC                                              
C                                                                       
      INTEGER*4     LST2X2                                              
C                                                                       
      LOGICAL*4     NOERR                                               
C                                                                       
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
C                                                                       
      NOERR = .TRUE.                                                    
C                                                                       
      COMBO = '                        '                                
C                                                                       
      COMBO ( 1: 8) = OTEST (1:8)                                       
      COMBO ( 9:16) = RTEST (1:8)                                       
      COMBO (17:24) = LTEST (1:8)                                       
C                                                                       
C                                                                       
C...SEARCH FOR A MATCH BETWEEN THE "PATH" (ORIGINAL TEST, RESTORAL      
C   TEST, AND LAST TEST) SENT TO THIS FUNCTION AND THE LIST OF          
C   ACCEPTABLE PATHS FOR WHICH CLOUD CODE VALUES ARE ASSIGNED.          
C                                                                       
      IDXNAM = 1                                                        
C                                                                       
      DO WHILE (COMBO .NE. DNAME(IDXNAM))                               
C                                                                       
        IDXNAM = IDXNAM + 1                                             
C                                                                       
        IF (IDXNAM .GT. MAXTST) THEN                                    
C         WRITE (6, 1000) COMBO, DNAME(16)                              
          CALL EMESG (20, 'SETDCC', 'OK')                               
          NOERR = .FALSE.                                               
          GO TO 10                                                      
        END IF                                                          
C                                                                       
      END DO                                                            
C                                                                       
C                                                                       
C...SEARCH FOR A MATCH BETWEEN THE CLEAR/CLOUDY/MIXED DESIGNATION       
C   SENT TO THIS FUNCTION AND THE LIST OF ACCEPTABLE DESIGNATIONS       
C   WHICH ARE USED IN CONJUNCTION WITH THE ALGORITH PATH TO             
C   DETERMINE THE PROPER CLOUD CODE TO RETURN FROM THIS FUNCTION.       
C                                                                       
      IDXCOD = 1                                                        
C                                                                       
      DO WHILE (RESULT .NE. CCLASS(IDXCOD))                             
C                                                                       
        IDXCOD = IDXCOD + 1                                             
C                                                                       
        IF (IDXCOD .GT. MAXCLS) THEN                                    
          CALL EMESG (21, 'SETDCC', 'OK')                               
          NOERR = .FALSE.                                               
          GO TO 10                                                      
        END IF                                                          
C                                                                       
      END DO                                                            
C                                                                       
C                                                                       
   10 CONTINUE                                                          
C                                                                       
C                                                                       
C...SET VALUE OF CLOUD CODE TO RETURN TO CALLING PROGRAM, AND INCREMENT 
C   THE COUNTER FOR THE NUMBER OF 2X2 ARRAYS PROCESSED FOR THE          
C   PARTICULAR ALGORITHM PATH AND CLEAR/CLOUDY/MIXED OUTCOME.           
C                                                                       
      IF (NOERR) THEN                                                   
        SETDCC = DCODE (IDXNAM, IDXCOD)                                 
        NUMDAY (IDXNAM, IDXCOD, LST2X2) =                               
     1  NUMDAY (IDXNAM, IDXCOD, LST2X2) + 1                             
        TOTCCM (IDXCOD) = TOTCCM (IDXCOD) + 1                           
      ELSE                                                              
        SETDCC = 0                                                      
        TOTCCM (0) = TOTCCM (0) + 1                                     
      END IF                                                            
C                                                                       
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (//, 2X, '*** FAILURE IN SUBROUTINE SETDCC:  ',            
     1                'NO MATCH FOR TEST COMBINATION - ', A24, //,      
     2            2X, '                      DNAME16 - ', A24, //)      
C                                                                       
      END                                                               
