      SUBROUTINE SOLARR (DLAT, DLON, NANGS, STIME)                      
C********************************************************************** 
C                                                                       
C                                                                       
C********************************************************************** 
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/typdat.f"                                                  
      INCLUDE "inc/angle.f"                                                   
      INCLUDE "inc/solprm.f"                                                  
C                                                                       
C                                                                       
      LOGICAL*4  FIRST                                                  
C                                                                       
      REAL*4  DLAT(*), DLON(*),  STIME                           
C                                                                       
      REAL*8  DDLAT, DDLON,  SOLLON,  GMT, GSEC              
C                                                                       
      DATA  FIRST /.TRUE./                                              
C                                                                       
C------------------------------------------------------------------     
C                                                                       
C                                                                       
      GSEC = STIME                                                      
      GMT = (GSEC + 5.0D0)/36000.0D0                                    
C                                                                       
      SOLLON = (12.0D0 - (GMT+EQTR))*15.0D0                             
C                                                                       
      IF (FIRST) THEN                                                   
C       WRITE(6,980) SOLLON                                             
        FIRST = .FALSE.                                                 
      END IF                                                            
C                                                                       
      SOLLON = DEG2RD * SOLLON                                          
C                                                                       
C                                                                       
      DO 10 I = 1, MAXANC                                                   
C                                                                       
C...LAT/LON VALUES TO RADIANS.                                          
C                                                                       
        DDLAT = DLAT(I) * DEG2RD                                        
        DDLON = DLON(I) * DEG2RD                                        
C                                                                       
C                                                                       
        COSZX(I) = DSIN(SOLDEC) * DSIN(DDLAT) + DCOS(SOLDEC) *          
     1             DCOS(DDLAT)  * DCOS(DDLON-SOLLON)                    
C                                                                       
   10 CONTINUE                                                          
C                                                                       
C                                                                       
C...INTERPOLATE BETWEEN THE 51 ANCHOR POINTS TO EXTEND THE              
C   SOLAR ZENITH ANGLE VALUES ACROSS THE ENTIRE SCANLINE.               
C                                                                       
      IFACTR = INT(FACTOR)                                              
C                                                                       
      DO 20 IPIX = 1, NPIXLS                                            
C                                                                       
        IXP = (IPIX - PXFIX1)/IFACTR + 1                                
        IF (IXP .GE. NANGS) IXP = NANGS - 1                             
        DELX = IPIX - ((IXP - 1)*IFACTR + PXFIX1)                       
C                                                                       
        COSSZA(IPIX) = (COSZX(IXP+1) - COSZX(IXP)) /                    
     1                  FACTOR*DELX + COSZX(IXP)                        
C                                                                       
        SOLZ(IPIX) = ACOS(COSSZA(IPIX)) * RD2DEG                        
C                                                                       
CCCC    SOLT(IPIX)=10*((SOLZT(IXP+1)-SOLZT(IXP))/FACTOR*DELX+SOLZT(IXP))
C                                                                       
   20 CONTINUE                                                          
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
  980 FORMAT(5X,'SOLAR LONGITUDE = ', F10.4,/)                          
C                                                                       
      END                                                               
