      SUBROUTINE SOLCMP (SED,DDAY0)                                           
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- SOLCMP                                                        
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 02/04/93   PROGRAMMER- DEBBIE CARR (SMSRC)    
C                                                                       
C                                                                       
C   FUNCTION-                                                           
C                                                                       
C      CONTROLS CALCULATION OF SOLAR PARAMETERS.                        
C                                                                       
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C                                                                       
C      VARIABLE          I/O   TYPE  FUNCTION                           
C      --------          ---   ----  --------                           
C      SED                O    I*4   SUN-EARTH DISTANCE RATIO           
C                                                                       
C                                                                       
C                                                                       
C   LOCAL PARAMETERS-                                                   
C                                                                       
C      VARIABLE                TYPE  FUNCTION                           
C      --------                ----  --------                           
C      FINLIN (35)             C*1   A FINAL MESSAGE OUTPUT LINE        
C                                                                       
C                                                                       
C                                                                       
C   COMMON AREAS- OHED1C, INCLAV                                        
C                                                                       
C                                                                       
C   CALLED BY-  CLAVRORB                                                
C                                                                       
C                                                                       
C   SUBPROGRAMS CALLED- JD, SOLLOC                                      
C                                                                       
C                                                                       
C   RESTRICTIONS-                                                       
C                                                                       
C                                                                       
C   COMMENTS-                                                           
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...LINK IN CONSTANT PARAMETERS AND COMMON VARIABLES.                   
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/typdat.f"                                                  
      INCLUDE "inc/ohed1c.f"                                                  
      INCLUDE "inc/solprm.f"                                                  
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...VARIABLE DECLARATIONS                                               
C                                                                       
C                                                                       
      INTEGER*4  ISW, DDAY0                                                    
C                                                                       
      REAL*8     SED, TIME, DYJ, GMT, GMTDAY                            
C                                                                       
C                                                                       
      DATA  ISW /1/                                                     
C                                                                       
C                                                                       
C***********************************************************************
C***********************************************************************
C                                                                       
C                                                                       
C...DETERMINE TIME PARAMETERS.                                          
C                                                                       
      IF (GAC) THEN                                                     
        TIME = OSSEC                                                    
      ELSE                                                              
        TIME = OSSEC + 5.0D0                                            
      END IF                                                            
C                                                                       
      DYJ = JD(1900+OEYEAR, 1, OEDAY)                                   
      GMT = TIME/3600000.0D0                                            
      GMTDAY = OEDAY + GMT/24.0D0                                       
      DYJ = DYJ + GMT/24.0D0                                            
C                                                                       
C                                                                       
C...CALL SUBROUTINE TO COMPUTE SUN-EARTH DISTANCE RATIO AND             
C   EQUATION OF TIME.                                                   
C                                                                       
      CALL SOLLOC(DYJ, ISW, SED,DDAY0)                                        
C                                                                       
C                                                                       
C...SQUARE THE SUN-EARTH DISTANCE RATIO FOR LATER USE IN                
C   COMPUTING ALBEDOS.                                                  
C                                                                       
      SEDSQ = SED*SED                                                   
C                                                                       
C                                                                       
C     WRITE (6, 1000) GMTDAY, (1900+OEYEAR), DYJ                        
C     WRITE (6, 1010) SED, SOLDEC*RD2DEG, EQTR                          
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
C                                                                       
 1000 FORMAT (//, '  +-------------------------------------------+', /, 
     1            '  +  D A T A  T I M E  I N F O R M A T I O N  +', /, 
     1            '  +         (FROM SUBROUTINE SOLCMP)          +', /, 
     2            '  +-------------------------------------------+', /, 
     3         /, '          GMT DAY ==> ', F10.4, /,                   
     4            '             YEAR ==> ', I10, /,                     
     5            '          JUL DAY ==> ', F10.1, /)                   
C                                                                       
 1010 FORMAT (/,  '     EARTH-SUN DISTANCE RATIO = ', F10.5, /,         
     1            '     SOLAR DECLINATION (DEG.) = ', F10.5, /,         
     2            '     SOLAR EQUATION OF TIME   = ', F10.5)            
C                                                                       
C                                                                       
      END                                                               
