      SUBROUTINE TF (T4, T5, LST, CO)                                   
C********************************************************************** 
C                                                                       
C     SUBPROGRAM: TF (TUT, FMFT)                                        
C                                                                       
C     PURPOSE: IN THE DAYTIME PASS1 OCEAN ALGORITHM, A PIXEL FAILING    
C              EITHER THE RGCT OR RUT TESTS AND PASSING THE ICE TESTS,  
C              PROCEEDS TO BE TESTED BY THE LAND'S TUT AND FMFT TESTS.  
C                                                                       
C     CHANGES FOR CLAVR ALGORITHM VERSION A.3H                          
C     ----------------------------------------------------------------- 
C     (1)  LAND/SEA TAG NOW ACCEPTED INTO THIS ROUTINE VIA ARGUMENT     
C          LIST AND PASSED TO SUBROUTINE FMFT SINCE TERRAIN-            
C          DEPENDENT (LAND VS. OCEAN) THRESHOLDS ARE NOW BEING USED     
C          IN THE CH4 - CH5 TEST.                                       
C                                                                       
C                                                                       
C     PROGRAMMER CRAIG S. LONG (SSAI)                                   
C                                                                       
C     DATE: FEBRUARY, 1990                                              
C                                                                       
C     INPUTS:                                                           
C             TEST     I*4    FLAG TELLING WHICH CLOUD TEST THIS        
C                             SUBROUTINE IS ENTERED FROM                
C                             1 = RGCT                                  
C                             2 = RUT                                   
C                             3 = RRCT                                  
C                             4 = C3AT                                  
C                                                                       
C             T4       R*4    CHANNEL 4 TEMPERATURES OF 2X2 ARRAY       
C             T5       R*4    CHANNEL 5 TEMPERATURES OF 2X2 ARRAY       
C                                                                       
C     OUTPUTS:                                                          
C             CC       I*2    CLOUD CODE                                
C             CO       I*2    CLEAR/CLOUD FLAG                          
C                                                                       
C********************************************************************** 
C                                                                       
C                                                                       
      INCLUDE "inc/apath.f"                                                   
C                                                                       
C                                                                       
      CHARACTER*6  CCLASS(0:2)                                          
C                                                                       
      INTEGER*2  CO(4)                                                  
C                                                                       
      INTEGER*4  PF                                                     
C                                                                       
      REAL*4     T4(4), T5(4), THR9                                     
C                                                                       
C                                                                       
      DATA  CCLASS /'CLEAR ', 'CLOUDY', 'MIXED '/                       
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
C...TUT                                                                 
C                                                                       
      THR9 = 3.0                                                        
      CALL TUT(T4, PF, THR9, CO)                                        
      LTEST = 'TUT   '                                                  
C                                                                       
C...TUT: CLEAR                                                          
C                                                                       
      IF (PF.EQ.0) THEN                                                 
C                                                                       
C...TUT: FMFT: CLEAR/WHITE(RGCT), GREY(RUT)                             
C...TUT: FMFT: CLOUDY/PINK                                              
C                                                                       
         CALL FMFT(T4, T5, LST, PF, CO)                                 
         LTEST = 'FMFT  '                                               
C                                                                       
      ENDIF                                                             
C                                                                       
C                                                                       
      RESULT = CCLASS(PF)                                               
C                                                                       
C                                                                       
      RETURN                                                            
      END                                                               
