      SUBROUTINE TFT (T4, T5, THR10, LST, ALAT, CO)                     
C********************************************************************** 
C                                                                       
C     PROGRAM: TFT (TUT, FMFT, TGCT)                                    
C                                                                       
C     PURPOSE: IN THE DAYTIME PASS1 LAND ALGORITHM, PIXELS FAILING      
C              EITHER THE RGCT, RUT, RRCT AND C3AT(TGCR) TESTS,         
C              PROCEEDS TO BE TESTED BY THE TUT, FMFT AND TGCT TESTS.   
C                                                                       
C              ** CALLED FOR 2X2'S THAT PASS THE C3AR RESTORAL **       
C                                                                       
C                                                                       
C     PROGRAMMER CRAIG S. LONG (SSAI)                                   
C                                                                       
C     DATE: FEBRUARY, 1990                                              
C                                                                       
C     INPUTS:                                                           
C             TEST     I*4    FLAG TELLING WHICH CLOUD TEST THIS        
C                             SUBROUTINE IS ENTERED FROM                
C                             1 = RGCT                                  
C                             2 = RUT                                   
C                             3 = RRCT                                  
C                             4 = C3AT                                  
C                                                                       
C             T4       R*4    CHANNEL 4 TEMPERATURES OF 2X2 ARRAY       
C             T5       R*4    CHANNEL 5 TEMPERATURES OF 2X2 ARRAY       
C             THR10    R*4    THRESHOLD FLAG FOR TGCT TEST              
C             LST      I*4    LAND/SEA TAG                              
C             ALAT     R*4    MEAN LATITUDE OF 2X2 ARRAY                
C                                                                       
C     OUTPUTS:                                                          
C             CC       I*2    CLOUD CODE                                
C             CO       I*2    CLEAR/CLOUD FLAG                          
C                                                                       
C********************************************************************** 
C                                                                       
C                                                                       
      INCLUDE "inc/apath.f"                                                   
C                                                                       
C                                                                       
      CHARACTER*6  CCLASS(0:2)                                          
C                                                                       
      INTEGER*2  CO(4)                                                  
C                                                                       
      INTEGER*4  LST, PF                                                
C                                                                       
      REAL*4  T4(4), T5(4), THR9, THR10, ALAT                           
C                                                                       
C                                                                       
      DATA CCLASS /'CLEAR ', 'CLOUDY', 'MIXED '/                        
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
C...TUT                                                                 
      THR9 = 3.0                                                        
      CALL TUT(T4, PF, THR9, CO)                                        
      LTEST = 'TUT   '                                                  
C                                                                       
C...TUT: CLEAR                                                          
      IF (PF.EQ.0) THEN                                                 
         CALL FT(T4, T5, THR10, LST, ALAT, CO)                          
C                                                                       
C...TUT: CLD/LT PURPLE                                                  
      ELSE                                                              
         RESULT = CCLASS(PF)                                            
      ENDIF                                                             
C                                                                       
      RETURN                                                            
      END                                                               
