      SUBROUTINE TGCR(PIX,RS,PF,TH,CO)                                  
C********************************************************************** 
C                                                                       
C       FUNCTION - THERMAL GROSS RESTORAL TEST. THIS TEST               
C        WILL TAKE THE PIXEL ARRAYS THAT HAVE FAILED THE RRCT           
C        OR NOT RESTORED BY TUR AND DETERMINE IF THE PIXELS SHOULD      
C        BE RESTORED TO CLEAR PIXELS. THIS TEST IS MAINLY INTENDED      
C        TO BE USED TO RESTORE DESERT SCENES TO CLEAR.                  
C                                                                       
C       INPUT:                                                          
C        PIX   -   CHANNEL 4 TEMPERATURE                                
C        PF    -   PREVIOUS CLEAR/CLOUD/MIXED FLAG                      
C                                                                       
C       OUTPUT:                                                         
C        RS    -   RESTORAL FLAG. 0=RESTORED,1 OR 2=NOT RESTORED        
C                 (I.E. REMAINS CLOUDY OR MIXED)                        
C        CO    -   CLEAR/CLOUD  FLAG                                    
C                                                                       
C********************************************************************** 
C                                                                       
      REAL PIX(4)                                                       
      INTEGER*4 RS,PF                                                   
      INTEGER*2 CO(4)                                                   
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
      ICT=0                                                             
C                                                                       
C...ACCUMULATE NUMBER OF TIMES THE CHANNEL 4 TEMP EXCEED THE THRESHOLD  
C                                                                       
      DO 10 I=1,4                                                       
         IF(PIX(I).GT.TH) ICT=ICT+1                                     
   10 CONTINUE                                                          
C                                                                       
      IF(ICT.LT.4) GO TO 999                                            
      RS=0                                                              
      PF=0                                                              
      DO 20 I = 1, 4                                                    
         CO(I) = 0                                                      
   20 CONTINUE                                                          
      GO TO 998                                                         
C                                                                       
  999 RS=PF                                                             
  998 CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                               
