      SUBROUTINE TGCT(PIX,PF,TH,CO)                                     
C********************************************************************** 
C                                                                       
C      FUNCTION - THERMAL GROSS CLOUD TEST (CHANNEL 4)                  
C                                                                       
C      INPUT:                                                           
C       PIX   -   CHANNEL 4 PIXEL ARRAY                                 
C       TH    -   LAND/OCEAN THRESHOLDS                                 
C                                                                       
C      OUTPUT:                                                          
C       PF    -   CLEAR/CLOUD/MIXED FLAG. 0=CLEAR,1=CLOUD,              
C                2=MIXED                                                
C       CO    -   CLEAR/CLOUD FLAG                                      
C                                                                       
C********************************************************************** 
C                                                                       
       REAL PIX(4)                                                      
       INTEGER*4 PF                                                     
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------  
C                                                                       
       ICT=0                                                            
C                                                                       
C...ACCUMULATE NUMBER OF TIMES CHANNEL 4 TEMP IS LESS THAN THRESHOLD    
C                                                                       
       DO 10 I=1,4                                                      
          IF(PIX(I).LT.TH) THEN                                         
             ICT = ICT + 1                                              
             CO(I) = 1                                                  
          ELSE                                                          
             CO(I) = 0                                                  
          ENDIF                                                         
 10    CONTINUE                                                         
       IF(ICT.EQ.4) PF=1                                                
       IF(ICT.EQ.0) PF=0                                                
       IF(ICT.GT.0.AND.ICT.LT.4) PF=2                                   
C                                                                       
       RETURN                                                           
       END                                                              
