       SUBROUTINE TUT(PIX,PF,TH,CO)                                     
C********************************************************************** 
C                                                                       
C      FUNCTION - THERMAL UNIFORMITY TEST (CHANNEL 4)                   
C                                                                       
C      INPUT:                                                           
C       PIX    -   CHANNEL 4 PIXEL ARRAY                                
C       TH     -   LAND/OCEAN THRESHOLDS                                
C                                                                       
C      OUTPUT:                                                          
C       PF     -   CLEAR/MIXED FLAG. 0=CLEAR,2=MIXED                    
C       CO     -   CLEAR/CLOUD FLAG                                     
C                                                                       
C********************************************************************** 
C                                                                       
       REAL PIX(4)                                                      
       INTEGER*4 PF                                                     
       REAL*4 MAX,MIN                                                   
       INTEGER*2 CO(4)                                                  
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
      PF = 0                                                            
C                                                                       
      MIN = PIX(1)                                                      
      MAX = MIN                                                         
      DO 20 I = 2,4                                                     
C                                                                       
C...TEST IF CHANNEL 4 TEMPERATURE IS SATURATED                          
C                                                                       
         IF (PIX(I).GT.320.0) THEN                                      
            PF = 0                                                      
            DO 10 J = 1, 4                                              
               CO(J) = 0                                                
   10       CONTINUE                                                    
            GO TO 999                                                   
         ENDIF                                                          
C                                                                       
         IF(PIX(I).GT.MAX) MAX = PIX(I)                                 
         IF(PIX(I).LT.MIN) MIN = PIX(I)                                 
   20 CONTINUE                                                          
C                                                                       
C...TEST IF MAX-MIN DIFFERENCE EXCEEDS THE THRESHOLD                    
C                                                                       
      IF ((MAX-MIN).GT.TH) THEN                                         
         PF = 2                                                         
         CO(1) = 1                                                      
         CO(2) = 0                                                      
         CO(3) = 0                                                      
         CO(4) = 1                                                      
      ELSE                                                              
         DO 30 I = 1, 4                                                 
            CO(I) = 0                                                   
   30    CONTINUE                                                       
      ENDIF                                                             
C                                                                       
  999 RETURN                                                            
      END                                                               
