       SUBROUTINE ULST (P,PF,TH,CO)                                     
C********************************************************************** 
C      NEW                                                              
C                                                                       
C     FUNCTION - UNIFORM LOW STRATUS TEST                               
C                                                                       
C     INPUT:                                                            
C      PIX3  -   CHANNEL 3 PIXEL ARRAY                                  
C      PIX4  -   CHANNEL 4 PIXEL ARRAY                                  
C      PIX5  -   CHANNEL 5 PIXEL ARRAY                                  
C      TH    -   CONSTANT ADDED TO EXPONENTIAL THRESHOLD                
C                                                                       
C     OUTPUT:                                                           
C      PF    -   CLEAR/CLOUD/MIXED FLAG. 0=CLEAR,1=CLOUD,2=MIXED        
C      CO    -   CLEAR/CLOUD FLAG                                       
C                                                                       
C********************************************************************** 
C                                                                       
C                                                                       
      INCLUDE "inc/nitlu.f"                                                   
      INCLUDE "inc/baddat.f"                                                  
C                                                                       
      INTEGER*2  CO(4)                                                  
C                                                                       
      INTEGER*4  PF, T4                                                 
C                                                                       
      REAL*4     P(4,6),PIX3(4),PIX4(4),PIX5(4)                         
C                                                                       
C                                                                       
C--------------------------------------------------------------------   
C                                                                       
      ICT=0                                                             
C                                                                       
C                                                                       
C.....LOAD CHANNEL 3,4,5 TEMPERATUES INTO ARRAYS.                       
C                                                                       
      DO 2 I = 1,4                                                      
C                                                                       
        PIX3(I) = P(I,4)                                                
        PIX4(I) = P(I,5)                                                
        PIX5(I) = P(I,6)                                                
C                                                                       
    2 CONTINUE                                                          
C                                                                       
C                                                                       
C.....INSPECT CHANNEL 5 TEMPERATURES.  IF SATURATED, THEN SKIP THE      
C     ULST TEST.  ALSO, IF CHANNEL 3 TEMPERATURE IS BAD, THEN SKIP      
C     THE TEST. (RSKPCC = 999.0)                                        
C                                                                       
C                                                                       
      DO 3 I = 1,4                                                      
C                                                                       
CCCCCCC                                                                 
C       IF ( (PIX3(I) .LT. 100.0) .OR. (PIX3(I) .GT. 370.0) ) THEN      
C         WRITE (6,*) '  && C3AT, BAD CH3T = ', PIX3(I),                
C    1      '  RSKPCC = ', RSKPCC                                       
C       END IF                                                          
CCCCCCC                                                                 
        IF (PIX3(I) .EQ. RSKPCC) THEN                                   
          TSTSKP (4,4) = TSTSKP(4,4) + 1                                
          GO TO 20                                                      
        END IF                                                          
C                                                                       
        IF (PIX5(I).GT.320.0) THEN                                      
C                                                                       
          CO(1) = 0                                                     
          CO(2) = 0                                                     
          CO(3) = 0                                                     
          CO(4) = 0                                                     
C                                                                       
          TSTSKP (4,6) = TSTSKP(4,6) + 1                                
          GO TO 20                                                      
C                                                                       
        ENDIF                                                           
C                                                                       
    3 CONTINUE                                                          
C                                                                       
C***********************************************************************
C                                                                       
      DO 10 I=1,4                                                       
C                                                                       
         T4 = NINT(PIX4(I))                                             
         IF (T4.GT.320) THEN                                            
            T4 = 320                                                    
         ELSE IF (T4.LT.200) THEN                                       
            T4 = 200                                                    
         ENDIF                                                          
C                                                                       
C...TEST FOR NUMBER OF TIMES THE T3-T5 DIF IS LESS THAN THE THRESHOLD   
C                                                                       
         IF((PIX3(I)-PIX5(I)).LT.(ULSTLU(T4)-TH)) THEN                  
            ICT = ICT + 1                                               
            CO(I) = 1                                                   
         ELSE                                                           
            CO(I) = 0                                                   
         ENDIF                                                          
   10 CONTINUE                                                          
C                                                                       
   20 CONTINUE                                                          
C                                                                       
      IF (ICT.EQ.0) THEN                                                
         PF = 0                                                         
      ELSE IF (ICT.EQ.4) THEN                                           
         PF = 1                                                         
      ELSE                                                              
         PF = 2                                                         
      ENDIF                                                             
C                                                                       
  999 RETURN                                                            
      END                                                               
