      SUBROUTINE W1CDAT (DISK, C1REC, SCANUM, CLRCLD,                   
     1                   CLDCOD, CH, ANGLES, I4LOC2, N1CREX)            
C********************************************************************** 
C                                                                       
C                                                                       
C  THIS SUBROUTINE BUILDS THE CLAVR DATA BUFFER FOR                     
C  OUTPUT TO THE 1C DISK/TAPE FILE(S).  DURING THE                      
C  BUILD PROCESS, ONLY THE LAC BUFFER IS FILLED                         
C  (DUE TO ITS LARGER CAPACITY).  IF GAC DATA IS                        
C  BEING PROCESSED, THE GAC BUFFER IS EQUATED TO                        
C  THE LAC BUFFER ONCE IT HAS BEEN COMPLETELY                           
C  FILLED.  ONLY ONE BUFFER IS OUTPUT TO THE 1C                         
C  FILE, DEPENDING ON THE TYPE OF AVHRR DATA BEING                      
C  PROCESSED.                                                           
C                                                                       
C                                                                       
C... INCLUDE CONSTANT PARAMETERS.                                       
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/parm1c.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE DATA TYPE-DEPENDENT VARIABLES.                             
C                                                                       
      INCLUDE "inc/typdat.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE MISC. COMMON AREAS.                                        
C                                                                       
      INCLUDE "inc/clvunt.f"                                                  
      INCLUDE "inc/hk1c.f"                                                    
      INCLUDE "inc/atmisc.f"                                               
      INCLUDE "inc/qcflgs.f"                                                 
      INCLUDE "inc/ranges.f"                                                 
C                                                                       
CCCC  INCLUDE 'inc/jclcom.f'                                                  
C                                                                       
C                                                                       
C... L O C A L  P A R A M E T E R  DEFINITIONS .........................
C                                                                       
      INTEGER*4  G1CSCN, L1CSCN                                 
C                                                                       
      PARAMETER  (G1CSCN = G1CWDS/2)                                    
      PARAMETER  (L1CSCN = L1CWDS/2)                                    
C.......................................................................
C                                                                       
C                                                                       
      INTEGER*2  CLRCLD(MAXLPX,2), CLDCOD(MAXLPX,2),                    
     2           ANGLES(MAXLPX,2,3)                                     
C                                                                       
      INTEGER*4  G1CREC(G1CSCN,2), L1CREC(L1CSCN,2), I4LOC2(MAXANC,2),  
     1           ISOLZ(MAXANC,2), ISATZ(MAXANC,2), IRELZ(MAXANC,2),     
     2           ICH1A, ICH2A, ICH3A, ICH3T, ICH4T, ICH5T, ICWORD,      
     3           N1CREX, C1REC, SCANUM(2)                               
C                                                                       
      LOGICAL*4  DISK                                                   
C                                                                       
      REAL*4     CH(MAXLPX,6,2)             
C                                                                       
      DATA  G1CREC / G1CWDS * 0 /, L1CREC / L1CWDS * 0 /                
C                                                                       
      DATA  ISOLZ  / MAXANC * 0, MAXANC * 0 /                           
      DATA  ISATZ  / MAXANC * 0, MAXANC * 0 /                           
      DATA  IRELZ  / MAXANC * 0, MAXANC * 0 /                           
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
C... REPLACE FLAGGED VALUES IN THE ARRAYS CH AND ANGLES                 
C    TO VALID 1C VALUES.                                                
C                                                                       
      CALL RFLAGS (CH, ANGLES)                                          
C                                                                       
C                                                                       
C... INITIALIZE THE 1C DATA RECORD BUFFERS.                             
C                                                                       
C     DO 15 I = 1, L1CSCN                                               
C       L1CREC(I,1) = 0                                                 
C       L1CREC(I,2) = 0                                                 
C       IF ( I .GT. G1CSCN ) GOTO 15                                    
C       G1CREC(I,1) = 0                                                 
C       G1CREC(I,2) = 0                                                 
C  15 CONTINUE                                                          
C                                                                       
C                                                                       
C... INCREMENT 1C RECORD NUMBER.                 
C                       
      C1REC = C1REC + 1                                                 
      IF (C1REC .GT. C1TOT) C1REC = 2
C                                                                       
C                                                                       
C... EXTRACT THE SOLAR ZENITH, SATELLITE ZENITH, AND RELATIVE AZIMUTH   
C    ANGLES FOR EACH ANCHOR POINT FROM THE "ANGLES" ARRAY.  NOTE        
C    THAT BOTH GAC AND LAC DATA TYPES ARE LIMITTED TO "MAXANC"          
C    ANCHOR POINTS, BEGINNING AT PIXEL 5 AND INCREMENTING BY            
C    8 PIXELS EACH TIME.                                                
C                                                                       
      IANCHR = 0                                                        
C                                                                       
      IFACTR = INT(FACTOR)  
      DO 10 IPIXEL = PXFIX1, (MAXANC*IFACTR), IFACTR
C                                                                       
        IANCHR = IANCHR + 1                                             
C                                                                       
        DO 5 IREC = 1, 2                                                
C                                                                       
C......CONVERT SOLAR ZENITH ANGLE FROM RADIANS TO DEGREES AND SCALE.    
C                                                                       
          ISOLZ(IANCHR,IREC) =                                          
     1      10 * (ACOS(ANGLES(IPIXEL,IREC,1)/1000.0)) * RD2DEG          
C                                                                       
          ISATZ(IANCHR,IREC) = ANGLES(IPIXEL,IREC,2)                    
          IRELZ(IANCHR,IREC) = ANGLES(IPIXEL,IREC,3)                    
C                                                                       
C                                                                       
    5   CONTINUE                                                        
C                                                                       
   10 CONTINUE                                                          
C                                                                       
C                                                                       
C... BUILD LEVEL 1C DATA RECORD.                                        
C                                                                       
C                                                                       
      DO 100 IREC = 1, 2                                                
C                                                                       
C                                                                       
C... INITIALIZE THE COUNTER FOR THE 1C DATA BUFFER I*4 WORD INDEX.      
C                                                                       
         ICWORD = 1                                                     
C                                                                       
C                                                                       
C... STORE SCANLINE NUMBER AND QUALITY FLAGS.                           
C                                                                       
         ISCAN = INT (SCANUM(IREC))                                     
C                                                                       
         L1CREC(ICWORD,IREC) = ISHFT(ISCAN,16) + IQUAL(IREC)            
C                                                                       
C                                                                       
C... STORE THE LATITUDES AND LONGITUDES FOR EACH ANCHOR POINT.          
C                                                                       
         DO 20 IANCHR = 1, MAXANC                                       
           ICWORD = ICWORD + 1                                          
           L1CREC(ICWORD,IREC) = I4LOC2(IANCHR,IREC)                    
   20    CONTINUE                                                       
C                                                                       
C                                                                       
C... STORE THE SOLAR ZENITH, SATELLITE ZENITH, AND RELATIVE AZIMUTH     
C    ANGLES FOR EACH ANCHOR POINT.                                      
C                                                                       
         DO 22 IANCHR = 1, MAXANC                                       
C                                                                       
           ICWORD = ICWORD + 1                                          
C                                                                       
           L1CREC(ICWORD,IREC) = ( ISHFT ( ISOLZ(IANCHR,IREC), 21 ) +   
     1                             ISHFT ( ISATZ(IANCHR,IREC), 11 ) +   
     2                                     IRELZ(IANCHR,IREC)       )   
C                                                                       
   22    CONTINUE                                                       
C                                                                       
C                                                                       
C... FOR EACH PIXEL, EXTRACT/SHIFT THE INFORMATION TO BE STORED IN THE  
C    1C DATA RECORD.                                                    
C                                                                       
         DO 30 IPIX = 1, (IPEND-IPBEG+1)                                
C                                                                       
            ICO = CLRCLD(IPIX,IREC)                                     
            ICO = ISHFT(ICO,28)                                         
C                                                                       
            IDN = DAYNIT(IPIX,IREC)                                     
            IDN = ISHFT(IDN,27)                                         
C                                                                       
            IAD = ADFLAG(IREC)                                          
            IAD = ISHFT(IAD,26)                                         
C                                                                       
            IWL = LSBUF(IPIX,IREC)                                      
            IWL = ISHFT(IWL,25)                                         
C                                                                       
            ICT  = COASTG(IPIX,IREC)                                    
            ICT  = ISHFT(ICT,24)                                        
C                                                                       
            ICC = CLDCOD(IPIX,IREC)                                     
            ICC = ISHFT(ICC,16)                                         
C                                                                       
C... SCALE THEN STORE THE TEMPERATURES FOR CHANNELS 3, 4, AND 5         
C    IN I*4 BUFFERS.                                                    
C                                                                       
            ICH3T = INT ((CH(IPIX,4,IREC) - LWCH3T) * 10.0)             
            ICH4T = INT ((CH(IPIX,5,IREC) - LWCH4T) * 10.0)             
            ICH5T = INT ((CH(IPIX,6,IREC) - LWCH5T) * 10.0)             
C                                                                       
C... STORE THE ALBEDOS FOR CHANNELS 1, 2, AND 3 IN I*4 BUFFERS.         
C                                                                       
            ICH1A = INT (CH(IPIX,1,IREC) * 10.0)                        
            ICH2A = INT (CH(IPIX,2,IREC) * 10.0)                        
            ICH3A = INT (CH(IPIX,3,IREC) * 10.0)                        
C                                                                       
C                                                                       
C... FILL 1ST WORD FOR THIS PIXEL ......................................
C                                                                       
C 1ST WORD ==>  CLEAR/OVERCAST FLAG               (BIT  28)             
C               DAY/NIGHT FLAG                    (BIT  27)             
C               ASCENDING/DESCENDING FLAG         (BIT  26)             
C               WATER/LAND FLAG                   (BIT  25)             
C               COAST TAG                         (BIT  24)             
C               CLOUD DETERMINATION (COLOR) CODE  (BITS 16 THRU 23)     
C               (SPARE)                           (BITS 11 THRU 15)     
C               CHANNEL 3 TEMPERATURE             (BITS 00 THRU 10)     
C                                                                       
C 1ST WORD                                                              
C ===================================================================== 
C .... BYTE 1 ... * .... BYTE 2 ... * .... BYTE 3 ... * .... BYTE 4 ... 
C 3 3 2 2 2 2 2 2 * 2 2 2 2 1 1 1 1 * 1 1 1 1 1 1 0 0 * 0 0 0 0 0 0 0 0 
C 1 0 9 8 7 6 5 4 * 3 2 1 0 9 8 7 6 * 5 4 3 2 1 0 9 8 * 7 6 5 4 3 2 1 0 
C --------------------------------------------------------------------- 
C / / / C D A W C * C O L O R . . . * / / / / / C H A * N N E L . 3 . . 
C / / / O N D L T * C O D E . . . . * / / / / / T E M * P E R A T U R E 
C ===================================================================== 
C                                                                       
            ICWORD = ICWORD + 1                                         
C                                                                       
            L1CREC(ICWORD,IREC) = ( ICO+IDN+IAD+IWL+ICT+ICC+ICH3T )     
C                                                                       
C                                                                       
C... FILL 2ND WORD FOR THIS PIXEL ......................................
C                                                                       
C 2ND WORD ==>  CHANNEL 4 TEMPERATURE  (BITS 16 THRU 26)                
C               CHANNEL 5 TEMPERATURE  (BITS 00 THRU 10)                
C                                                                       
C 2ND WORD                                                              
C ===================================================================== 
C .... BYTE 1 ... * .... BYTE 2 ... * .... BYTE 3 ... * .... BYTE 4 ... 
C 3 3 2 2 2 2 2 2 * 2 2 2 2 1 1 1 1 * 1 1 1 1 1 1 0 0 * 0 0 0 0 0 0 0 0 
C 1 0 9 8 7 6 5 4 * 3 2 1 0 9 8 7 6 * 5 4 3 2 1 0 9 8 * 7 6 5 4 3 2 1 0 
C --------------------------------------------------------------------- 
C / / / / / C H A * N N E L . 4 . . * / / / / / C H A * N N E L . 5 . . 
C / / / / / T E M * P E R A T U R E * / / / / / T E M * P E R A T U R E 
C ===================================================================== 
C                                                                       
            ICWORD = ICWORD + 1                                         
C                                                                       
            L1CREC(ICWORD,IREC) = ( ISHFT(ICH4T,16) + ICH5T )           
C                                                                       
C                                                                       
C... FILL 3RD WORD FOR THIS PIXEL ......................................
C                                                                       
C 3RD WORD ==>  CHANNEL 1 ALBEDO  (BITS 20 THRU 29)                     
C               CHANNEL 2 ALBEDO  (BITS 10 THRU 19)                     
C               CHANNEL 3 ALBEDO  (BITS 00 THRU 09)                     
C                                                                       
C 3RD WORD                                                              
C ===================================================================== 
C .... BYTE 1 ... * .... BYTE 2 ... * .... BYTE 3 ... * .... BYTE 4 ... 
C 3 3 2 2 2 2 2 2 * 2 2 2 2 1 1 1 1 * 1 1 1 1 1 1 0 0 * 0 0 0 0 0 0 0 0 
C 1 0 9 8 7 6 5 4 * 3 2 1 0 9 8 7 6 * 5 4 3 2 1 0 9 8 * 7 6 5 4 3 2 1 0 
C --------------------------------------------------------------------- 
C / / C H A N N E * L . 1 . C H A N * N E L . 2 . C H * A N N E L . 3 . 
C / / A L B E D O * . . . . A L B E * D O . . . . A L * B E D O . . . . 
C ===================================================================== 
C                                                                       
            ICWORD = ICWORD + 1                                         
C                                                                       
            L1CREC(ICWORD,IREC) = ( ISHFT(ICH1A,20) +                   
     1                              ISHFT(ICH2A,10) + ICH3A )           
C                                                                       
C                                                                       
C... GO ON TO NEXT PIXEL.                                               
C                                                                       
   30    CONTINUE                                                       
C                                                                       
C                                                                       
C... GO ON TO NEXT RECORD (SCANLINE).                                   
C                                                                       
  100 CONTINUE                                                          
C                                                                       
C                                                                       
C... IF PROCESSING GAC DATA, EQUATE GAC BUFFER TO LAC BUFFER.           
C    THE NUMBER OF WORDS IN THE OUTPUT BUFFER IS EQUAL TO               
C    1 (SCANLINE # / QC FLAGS) + 51 ("MAXANC" EARTH LOCATION WORDS) +   
C    51 (SOL/SAT/REL AZ ANGLE WORDS) + 3 WORDS FOR EACH PIXEL           
C    (COLOR CODE, FLAGS, TEMPS, ALBEDOS).                               
C                                                                       
      IF (GAC) THEN                                                     
C                                                                       
        DO 120 IREC = 1, 2                                              
C                                                                       
          LSTWRD = (1 + MAXANC + MAXANC + (3 * (IPEND-IPBEG+1)) )       
C                                                                       
          DO 110 IFILL = 1, LSTWRD                                      
            G1CREC(IFILL, IREC) = L1CREC(IFILL, IREC)                   
  110     CONTINUE                                                      
C                                                                       
  120   CONTINUE                                                        
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
C... WRITE 1C BLOCK (PHYSICAL RECORD, 2 SCANLINES) TO THE OUTPUT UNIT.  
C                                                                       
      IF (DISK) THEN                                                    
C                                                                       
        IF (GAC) THEN                                                   
          WRITE (UNIT1C, REC = C1REC) G1CREC                            
        ELSE                                                            
          WRITE (UNIT1C, REC = C1REC) L1CREC                            
        END IF                                                          
C                                                                       
C                                                                       
C... INCREMENT THE NUMBER OF 1C BLOCKS WRITTEN TO THE DISK FILE.        
C                                                                       
        N1CREX = N1CREX + 1                                             
C                                                                       
C                                                                       
C... ELSE WRITE TO TAPE FILE.                                           
C                                                                       
      ELSE                                                              
C                                                                       
        IF (GAC) THEN                                                   
          WRITE (UNIT1C) G1CREC                                         
        ELSE                                                            
          WRITE (UNIT1C) L1CREC                                         
        END IF                                                          
C                                                                       
C                                                                       
C... INCREMENT THE NUMBER OF 1C BLOCKS WRITTEN TO THE TAPE FILE.        
C                                                                       
        N1CREX = N1CREX + 1                                             
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
      RETURN                                                            
 1000 FORMAT (1H1, /,                                                   
     1         2X, 55('='), /,                                          
     2         1X, ' DUMP OF  1C  O U T P U T  P A R A M E T E R S',/,  
     3         2X, 55('='), //)                                         
 1010 FORMAT  (1X, ' ANCHOR POINT ==> ', I2, '  LAT = ', F7.2,          
     1             '  LON = ', F7.2)                                    
 1020 FORMAT (//,2X, 55('-'), /,                                        
     1        1X,' SCAN  QC INDICAT  PIX  CO  DN  LS  AD  CC  ',        
     2           'SAT Z  REL Z', /,                                     
     3        2X, 55('-'), /)                                           
 1030 FORMAT (1X, I5, 2X, I10, 2X, I3, 5(2X,I2), 2X, I5, 2X, I5)        
      END                                                               
