      SUBROUTINE W1CHED (DISK, BEG1C, ESD)                              
C***********************************************************************
C                                                                       
C  THIS SUBROUTINE BUILDS THE CLAVR ORBIT HEADER RECORD                 
C  FOR OUTPUT TO 1C DISK/TAPE FILE(S).  DURING THE                      
C  BUILD PROCESS, ONLY THE LAC BUFFER IS FILLED                         
C  (DUE TO ITS LARGER CAPACITY).  IF GAC DATA IS                        
C  BEING PROCESSED, THE GAC BUFFER IS EQUATED TO                        
C  THE LAC BUFFER ONCE IT HAS BEEN COMPLETELY                           
C  FILLED.  ONLY ONE BUFFER IS OUTPUT TO THE 1C                         
C  FILE, DEPENDING ON THE TYPE OF AVHRR DATA BEING                      
C  PROCESSED.  THIS BUFFER CONTAINS INFORMATION THAT                    
C  IS ORBIT-SPECIFIC.                                                   
C                                                                       
C                                                                       
C... INCLUDE 1C FILE AND GENERAL GAC/LAC CONSTANTS.                     
C                                                                       
      INCLUDE "inc/parm1c.f"                                                  
      INCLUDE "inc/inclav.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE 1C ORBIT HEADER RECORD COMMON.                             
C                                                                       
      INCLUDE "inc/ohed1c.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE MISC. COMMON AREAS.                                        
C                                                                       
      INCLUDE "inc/typdat.f"                                                  
      INCLUDE "inc/clvunt.f"                                                  
C                                                                       
CCCC  INCLUDE "inc/jclcom.f'                                                  
C                                                                       
C                                                                       
C... DECLARE LOCAL VARIABLES.                                           
C                                                                       
      INTEGER*4  BEG1C,                                 
     1           G1CHED(G1CWDS), L1CHED(L1CWDS)                         
C                                                                       
      LOGICAL*4  DISK                                                   
C                                                                       
      REAL*8  ESD                                                       
CMZ     REAL*4  ESD                                                       
C                                                                       
C                                                                       
      DATA  G1CHED / G1CWDS * 0 /, L1CHED / L1CWDS * 0 /                
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
C                                                                       
C... W3LIB SUBROUTINE W3FQ02 TO DETERMINE GMT FOR END OF                
C    CLAVR PROCESSING.                                                  
                                                                       
C                                                                       
C... SCALE EARTH-SUN DISTANCE RATIO BY 1000 AND STORE IN INTEGER FORMAT.
C                                                                       
      C1ESD = INT(ESD * 1000.0)                                         
C                                                                       
C                                                                       
C... FILL 1C ORBIT HEADER BUFFER.                                       
C                                                                       
      L1CHED (1)  = NEWIDX                                              
      L1CHED (2)  = NSAT                                                
      L1CHED (3)  = ORBNUM                                              
      L1CHED (4)  = DATYPE                                              
      L1CHED (5)  = GRDSTA                                              
      L1CHED (6)  = RMPCAL                                              
      L1CHED (7)  = NOSYNC                                              
      L1CHED (8)  = PARERR                                              
      L1CHED (9)  = AUXSYC                                              
      L1CHED (10) = IDCALP                                              
      L1CHED (11) = DACSTA                                              
      L1CHED (12) = OSDATE                                              
      L1CHED (13) = OSTIME                                              
      L1CHED (14) = OEDATE                                              
      L1CHED (15) = OETIME                                              
      L1CHED (16) = PDATE                                               
      L1CHED (17) = PSTIME                                              
      L1CHED (18) = PETIME                                              
      L1CHED (19) = NUMSCN                                              
      L1CHED (20) = NUMGAP                                              
      L1CHED (21) = C1ESD                                               
C                                                                       
C                                                                       
C... FILL UNUSED WORDS OF BUFFER WITH -1'S.                             
C                                                                       
      DO 10 I = 22, L1CWDS, 1                                           
        L1CHED (I) = -1                                                 
   10 CONTINUE                                                          
C                                                                       
C                                                                       
C... IF PROCESSING GAC DATA, EQUATE GAC BUFFER TO LAC BUFFER, THEN      
C    WRITE THE APPROPRIATE HEADER/BUFFER TO THE 1C FILE.                
C                                                                       
      IF (GAC) THEN                                                     
C                                                                       
        DO 20 I = 1, G1CWDS                                             
          G1CHED(I) = L1CHED(I)                                         
   20   CONTINUE                                                        
C                                                                       
        IF (DISK) THEN                                                  
          WRITE (UNIT1C, REC = BEG1C) G1CHED                            
C         WRITE (6,1000) 'GAC', 'DISK'                                  
C                                                                       
        ELSE                                                            
          WRITE (UNIT1C) G1CHED                                         
C         WRITE (6,1000) 'GAC', 'TAPE'                                  
        END IF                                                          
C                                                                       
      ELSE                                                              
C                                                                       
        IF (DISK) THEN                                                  
          WRITE (UNIT1C, REC = BEG1C) L1CHED                            
C         WRITE (6,1000) 'LAC', 'DISK'                                  
        ELSE                                                            
          WRITE (UNIT1C) L1CHED                                         
C         WRITE (6,1000) 'LAC', 'TAPE'                                  
C                                                                       
        END IF                                                          
C                                                                       
      END IF                                                            

C     WRITE (UNITMF,1010)  ORBNUM, NSAT                                      
C     WRITE (UNITMF,1020)  NEWIDX                                            
C     WRITE (UNITMF,1030)  DATYPE                                            
C     WRITE (UNITMF,1040)  GRDSTA                                            
C     WRITE (UNITMF,1050)  RMPCAL                                            
C     WRITE (UNITMF,1060)  NOSYNC                                            
C     WRITE (UNITMF,1070)  PARERR                                            
C     WRITE (UNITMF,1080)  AUXSYC                                            
C     WRITE (UNITMF,1090)  IDCALP                                            
C     WRITE (UNITMF,1100)  DACSTA                                            
C     WRITE (UNITMF,1110)  OSYEAR,OSDAY                                      
C     WRITE (UNITMF,1120)  OSHOUR,OSMINS                                     
C     WRITE (UNITMF,1130)  OEYEAR,OEDAY                                      
C     WRITE (UNITMF,1140)  OEHOUR,OEMINS                                     
C     WRITE (UNITMF,1150)  PDATE                                             
C     WRITE (UNITMF,1160)  PSTIME                                            
C     WRITE (UNITMF,1170)  PETIME                                            
C     WRITE (UNITMF,1180)  NUMSCN                                            
C     WRITE (UNITMF,1190)  NUMGAP                                            
C     WRITE (UNITMF,1200)  C1ESD                                             

C     WRITE (6,1010)  ORBNUM, NSAT                                      
C     WRITE (6,1020)  NEWIDX                                            
C     WRITE (6,1030)  DATYPE                                            
C     WRITE (6,1040)  GRDSTA                                            
C     WRITE (6,1050)  RMPCAL                                            
C     WRITE (6,1060)  NOSYNC                                            
C     WRITE (6,1070)  PARERR                                            
C     WRITE (6,1080)  AUXSYC                                            
C     WRITE (6,1090)  IDCALP                                            
C     WRITE (6,1100)  DACSTA                                            
C     WRITE (6,1110)  OSYEAR,OSDAY                                      
C     WRITE (6,1120)  OSHOUR,OSMINS                                     
C     WRITE (6,1130)  OEYEAR,OEDAY                                      
C     WRITE (6,1140)  OEHOUR,OEMINS                                     
C     WRITE (6,1150)  PDATE                                             
C     WRITE (6,1160)  PSTIME                                            
C     WRITE (6,1170)  PETIME                                            
C     WRITE (6,1180)  NUMSCN                                            
C     WRITE (6,1190)  NUMGAP                                            
C     WRITE (6,1200)  C1ESD                                             
C 
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (/,' ++ SUBROUTINE W1CHED:  ORBIT HEADER RECORD SUCCESS',  
     1        'FULLY WRITTEN TO ', A3, ' 1C ', A4, ' FILE ++', /)       
C                                                                       
 1010 FORMAT(//,' * ----------------------------------------------- *', 
     1        /,'   ORBIT NUMBER:  ', I11, '       SAT ID:', I4     ,   
     1        /,' * ----------------------------------------------- *') 
 1020 FORMAT(' * 1C ORBIT INDEX............', I14)                      
 1030 FORMAT(' * DATA TYPE.................', I14)                      
 1040 FORMAT(' * GROUND STATION............', I14)                      
 1050 FORMAT(' * AUTO CALIBRATION..........', I14)                      
 1060 FORMAT(' * # SCANS W/O SYNC ERRORS...', I14)                      
 1070 FORMAT(' * # PARITY ERRORS...........', I14)                      
 1080 FORMAT(' * # AUX SYNC ERRORS.........', I14)                      
 1090 FORMAT(' * CALIBRATION PARM ID.......', I14)                      
 1100 FORMAT(' * DACS STATUS...............', I14)                      
 1110 FORMAT(' * ORBIT START DATE..........', I10,'/',I3)               
 1120 FORMAT(' * ORBIT START TIME..........', I10,':',I3)               
 1130 FORMAT(' * ORBIT END DATE............', I10,'/',I3)               
 1140 FORMAT(' * ORBIT END TIME............', I10,':',I3)               
 1150 FORMAT(' * PROCESSING DATE...........', I14)                      
 1160 FORMAT(' * PROCESSING START TIME.....', I14)                      
 1170 FORMAT(' * PROCESSING END TIME.......', I14)                      
 1180 FORMAT(' * SCANLINES.................', I14)                      
 1190 FORMAT(' * DATA GAPS.................', I14)                      
 1200 FORMAT(' * EARTH-SUN DISTANCE RATIO..', I14,/,                    
     1       ' * ----------------------------------------------- *',//) 
C                                                                       
      END                                                               
