      SUBROUTINE W1CHK (PROGRM, BEG1C, END1C, HOUSE)                    
C***********************************************************************
C                                                                       
C  THIS SUBROUTINE BUILDS THE CLAVR HOUSEKEEPING RECORD                 
C  FOR OUTPUT TO 1C DISK/TAPE FILE(S).  DURING THE                      
C  BUILD PROCESS, ONLY THE LAC BUFFER IS FILLED                         
C  (DUE TO ITS LARGER CAPACITY).  IF GAC DATA IS                        
C  BEING PROCESSED, THE GAC BUFFER IS EQUATED TO                        
C  THE LAC BUFFER ONCE IT HAS BEEN COMPLETELY                           
C  FILLED.  ONLY ONE BUFFER IS OUTPUT TO THE 1C                         
C  FILE, DEPENDING ON THE TYPE OF AVHRR DATA BEING                      
C  PROCESSED.                                                           
C                                                                       
C                                                                       
C... INCLUDE 1C FILE AND GENERAL GAC/LAC CONSTANTS.                     
C                                                                       
      INCLUDE "inc/parm1c.f"                                                  
      INCLUDE "inc/inclav.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE 1C HOUSEKEEPING AND ORBIT HEADER RECORD COMMONS.           
C                                                                       
      INCLUDE "inc/hk1c.f"                                                   
      INCLUDE "inc/ohed1c.f"                                                  
C                                                                       
C                                                                       
C... INCLUDE DATA TYPE-DEPENDENT VARIABLES.                             
C                                                                       
      INCLUDE "inc/typdat.f"                                                  
C                                                                       
      INCLUDE "inc/clvunt.f"                                                   
C                                                                       
C                                                                       
C... DECLARE LOCAL VARIABLES.                                           
C                                                                       
      CHARACTER*8    PROGRM                                             
C                                                                       
C                                                                       
      INTEGER*4  GHOUSE(G1CWDS), LHOUSE(L1CWDS), HOUSE(*), BEG1C, END1C 
C                                                                       
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
C                                                                       
C... WRITE OUT VALUES OF SELECTED PARAMETERS.                           
C                                                                       
C     WRITE (6, 1000) PROGRM, UNIT1C, BEG1C, END1C, NEWIDX, LSTARC      
C                                                                       
C                                                                       
C... UPDATE HOUSEKEEPING RECORD BUFFER.                                 
C                                                                       
      IF (PROGRM .EQ. 'CLAVRORB') THEN                                  
C                                                                       
        HOUSE(4) = BEG1C                                                
        HOUSE(5) = END1C                                                
        HOUSE(6) = NEWIDX                                               
C                                                                       
        HOUSE(10+2*(NEWIDX-1)+1) = BEG1C                                
        HOUSE(10+2*(NEWIDX-1)+2) = END1C 
C 
CRY ...  The following changes are made so that first word in the
CRY ...  housekeeping record shows the total number of records 
CRY ...  in the file                               
C                                                                                                                                              
         HOUSE(1) = END1C
C 
CRY.............end of changes
C
      ELSE IF (PROGRM .EQ. 'CAMAPPER') THEN                             
C                                                                       
        HOUSE(7) = BEG1C                                                
        HOUSE(8) = END1C                                                
        HOUSE(9) = NEWIDX                                               
C                                                                       
C...... TEST TO ENSURE THAT MAPPING PROGRAM IS IN SYNC WITH CLAVRORB.   
C                                                                       
        IF (END1C .NE. LC1END)  CALL EMESG (56, 'W1CHK   ', 'OK')       
        IF (NEWIDX .NE. LC1IDX) CALL EMESG (55, 'W1CHK   ', 'OK')       
C                                                                       
C                                                                       
      ELSE IF (PROGRM .EQ. 'CRT1CSUB') THEN                             
C                                                                       
        HOUSE(10) = LSTARC                                              
C                                                                       
      ELSE                                                              
C                                                                       
        CALL EMESG (23, 'W1CHK   ', 'FATAL')                            
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
C... COPY THE HOUSEKEEPING BUFFER TO THE APPROPRIATE ARRAY, THEN WRITE  
C    TO THE 1C DATABASE.                                                
C                                                                       
      IF (GAC) THEN                                                     
C                                                                       
        DO 10 I = 1, G1CWDS                                             
          GHOUSE(I) = HOUSE(I)                                          
   10   CONTINUE                                                        
C                                                                       
        WRITE (UNIT1C, REC = 1) GHOUSE                                  
C                                                                       
      ELSE                                                              
C                                                                       
        DO 20 I = 1, L1CWDS                                             
          LHOUSE(I) = HOUSE(I)                                          
   20   CONTINUE                                                        
C                                                                       
        WRITE (UNIT1C, REC = 1) LHOUSE                                  
C                                                                       
      END IF                                                            
C                                                                       
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (///, 1X, 'SUBROUTINE ===>  W1CHK',                        
     1          /, 1X, '-------------------------------------------',   
     2          /, 1X, 'CALLED FROM PROGRAM     (PROGRM) : ', A8,       
     3          /, 1X, 'UNIT NO. FOR 1C FILE    (UNIT1C) : ', I8,       
     4          /, 1X, 'BEGINNING 1C RECORD     (BEG1C)  : ', I8,       
     5          /, 1X, 'ENDING 1C RECORD        (END1C)  : ', I8,       
     6          /, 1X, '1C INDEX FOR THIS ORBIT (NEWIDX) : ', I8,       
     7          /, 1X, 'LAST 1C RECORD ARCHIVED (LSTARC) : ', I8, /)    
C                                                                       
      END                                                               
