      SUBROUTINE WBPDAT (DATREC, CLDCOD, NBPREX)                        
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- WBPDAT                         EXPIRES- 12/31/99              
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- MAIN                                    
C                                                                       
C   VERSION- 1.0    DATE- ??/??/??   PROGRAMMER- C. LONG     (SSAI)     
C   VERSION- 1.1    DATE- 09/12/91   PROGRAMMER- DEBBIE CARR (SMSRC)    
C   VERSION- 1.2    DATE- 12/17/91   PROGRAMMER- DEBBIE CARR (SMSRC)    
C                                                                       
C   FUNCTION-*$EK10DC* PACKS CLAVR CLEAR/OVERCAST/MIXED/NO DECISION     
C       (CCM) FLAG INTO THE 1B DATA RECORD BUFFER, THEN OUTPUTS THE     
C       BUFFER TO THE 1B PRIME FILE.  THE 1B PRIME IS AN EXACT          
C       DUPLICATE OF THE ORIGINAL LEVEL 1B FILE, WITH THE EXCEPTION     
C       OF THE ADDITIONAL CLAVR CLOUD FLAG.  THE CCM FLAG OCCUPIES      
C       2 BITS FOR EACH PIXEL IN THE 1B PRIME FILE AND IS SET           
C       ACCORDING TO THE FOLLOWING KEY:                                 
C                                                                       
C                         0 ==> NO DECISION                             
C                         1 ==> CLEAR                                   
C                         2 ==> CLOUDY                                  
C                         3 ==> MIXED                                   
C                                                                       
C       REFER TO THE CLAVR PROGRAM AND INTERFACE CONTROL DOCUMENTS      
C       FOR FURTHER INFORMATION ON HOW/WHERE THE CCM FLAGS ARE          
C       STORED IN THE GAC 1B PRIME DATA SET.                            
C                                                                       
C       VERSION- 1.2 - CORRECTED ASSIGNMENT OF CCM FLAG SO THAT         
C         COLOR CODES OF ZERO ARE ASSIGNED CCM FLAGS OF ZERO            
C         (PREVIOUSLY, THESE WERE BEING INTERPRETED AS CLOUDY,          
C         CCM FLAG ==> 2).                                              
C                                                                       
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C      VARIABLE         I/O   TYPE   FUNCTION                           
C      --------         ---   ----   --------                           
C      DATREC           I/O   I*4    1B DATA RECORD BUFFER              
C       (G1BWDS,2)                   (DIMENSIONED BY WORD #, RECORD #)  
C      CLDCOD            I    I*2    CLAVR CLOUD CODE (COLOR CODE) ARRAY
C       (MAXLPX,2)                   (DIMENSIONED BY PIXEL, RECORD #)   
C      NBPREX           I/O   I*4    NUMBER OF DATA RECORDS WRITTEN TO  
C                                    THE 1B PRIME FILE                  
C                                    (STORED IN COMMON AREA)            
C                                                                       
C   LOCAL PARAMETERS-                                                   
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      CCM (409)              I*4   CLEAR/CLOUDY/MIXED/NO DECISION      
C                                   FLAG ARRAY (DIMENSIONED BY PIXEL)   
C                                                                       
C                                                                       
C   FILES-                                                              
C      DSN OR DESCRIPTIVE TITLE    I/O  UNIT  FUNCTIONAL DESCRIPTION    
C      --------------------------  ---  ----  ----------------------    
C      <GAC 1B PRIME FILE>          O  UNITBP GAC 1B PRIME FILE         
C                                                                       
C                                                                       
C   SUBPROGRAMS CALLED- (NONE)                                          
C                                                                       
C   RESTRICTIONS- 1B PRIME FILES WILL ONLY BE CREATED IF PROCESSING     
C      GAC DATA AND THE USER SETS THE PROPER OPTION/FLAG 'ON' IN        
C      THE JCL/FT05F001 CARD IMAGE INPUT DATA RECORD.                   
C                                                                       
C   COMMENTS- SINCE CLOUD CODE DETERMINATIONS ARE MADE ON 2X2 PIXEL     
C      ARRAYS AND THE GAC SCANLINE HAS AN ODD NUMBER OF PIXELS (409)    
C      NO CLOUD CODE IS COMPUTED FOR THE LAST PIXEL; HENSE, A           
C      'NO DECISION' CODE (0) IS ASSIGNED TO THIS PIXEL.  SINCE         
C      ZEROES ORIGINALLY FILL THE BIT POSITIONS WHERE THE CLOUD         
C      CODE IS TO BE STORED IN THE 1B PRIME DATA RECORD, IT IS NOT      
C      NECESSARY TO STORE THE 'NO DECISION / 0' CODE FOR THE LAST       
C      PIXEL-- THE LOOPS IN THIS SUBROUTINE MERELY ACCOMODATE           
C      THE FIRST 408 PIXELS.                                            
C                                                                       
C   COMMON AREAS- (NONE)                                                
C                                                                       
C   CONSTANT PARAMETERS - INCLAV                                        
C                                                                       
C********************************************************************** 
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/clvunt.f"                                                  
C                                                                       
C********************************************************************** 
C                                                                       
C                                                                       
C... LOCAL VARIABLE DECLARATIONS.                                       
C                                                                       
C                                                                       
      INTEGER*2  CLDCOD(MAXLPX,2)                                       
C                                                                       
      INTEGER*4  DATREC(G1BWDS,2), CCM(409), IREC, PIXGRP, PIXEL,       
     1           PIXIDX, NBPREX                                   
C                                                                       
      DO 300 IREC = 1, 2                                                
C                                                                       
         DO 200 PIXGRP = 1, 136                                         
C                                                                       
            DO 100 PIXEL = 1, 3                                         
C                                                                       
               PIXIDX = (PIXGRP-1)*3 + PIXEL                            
C                                                                       
               IF ( (CLDCOD(PIXIDX,IREC) .GE. 1) .AND.                  
     1              (CLDCOD(PIXIDX,IREC) .LE. 11) ) THEN                
C                                                                       
                 CCM(PIXIDX) = 2                                        
C                                                                       
               ELSE IF ( (CLDCOD(PIXIDX,IREC) .GE. 17) .AND.            
     1                   (CLDCOD(PIXIDX,IREC) .LE. 27) ) THEN           
C                                                                       
                 CCM(PIXIDX) = 3                                        
C                                                                       
               ELSE IF ( ( (CLDCOD(PIXIDX,IREC) .GE. 12) .AND.          
     1                     (CLDCOD(PIXIDX,IREC) .LE. 16) ) .OR.         
     2                   ( (CLDCOD(PIXIDX,IREC) .GE. 28) .AND.          
     3                     (CLDCOD(PIXIDX,IREC) .LE. 31) ) ) THEN       
C                                                                       
                 CCM(PIXIDX) = 1                                        
C                                                                       
               ELSE                                                     
                 CCM(PIXIDX) = 0                                        
               ENDIF                                                    
C                                                                       
  100       CONTINUE                                                    
C                                                                       
            IP1 = (PIXGRP-1)*3 + 1                                      
            IP2 = IP1 + 1                                               
            IP3 = IP2 + 1                                               
            IWD = (PIXGRP-1)*5 + 112                                    
C                                                                       
            DATREC(IWD+1,IREC) = DATREC(IWD+1,IREC) + ISHFT(CCM(IP1),30)
            DATREC(IWD+2,IREC) = DATREC(IWD+2,IREC) + ISHFT(CCM(IP2),30)
            DATREC(IWD+4,IREC) = DATREC(IWD+4,IREC) + ISHFT(CCM(IP3),30)
C                                                                       
  200    CONTINUE                                                       
C                                                                       
  300 CONTINUE                                                          
C                                                                       
C                                                                       
C...WRITE 1B' DATA RECORD WITH CLEAR/CLOUDY/MIXED FLAG TO 1B' FILE.     
C                                                                       
      WRITE (UNITBP) DATREC                                             
C                                                                       
C                                                                       
C...INCREASE TALLY FOR NUMBER OF DATA RECORDS WRITTEN TO THE 1B' FILE.  
C                                                                       
      NBPREX = NBPREX + 1                                               
C                                                                       
C                                                                       
      RETURN                                                            
      END                                                               
