      SUBROUTINE WBPHED (TBMHED, GACHED, IBTAPE)                        
C                                                                       
C********************************************************************** 
C                                                                       
C   NAME- WBPHED                         EXPIRES- 12/31/99              
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- MAIN                                    
C                                                                       
C   VERSION- 1.0    DATE- ??/??/??   PROGRAMMER- C. LONG     (SSAI)     
C   VERSION- 1.1    DATE- 09/12/91   PROGRAMMER- DEBBIE CARR (SMSRC)    
C                                                                       
C   FUNCTION-*$EK10DC* WRITES THE TBM (IF READING FROM TAPE) AND        
C       GAC 1B HEADER RECORDS TO THE CLAVR 1B PRIME OUTPUT FILE.        
C       THE 1B PRIME IS AN EXACT DUPLICATE OF THE ORIGINAL              
C       LEVEL 1B FILE, WITH THE EXCEPTION OF AN ADDITIONAL              
C       CLAVR CLOUD FLAG.                                               
C                                                                       
C                                                                       
C   CALLING SEQUENCE PARAMETERS-                                        
C      VARIABLE         I/O   TYPE   FUNCTION                           
C      --------         ---   ----   --------                           
C      TBMHED (122)     I/O   C*1    TBM HEADER RECORD (TAPE FILES ONLY)
C      GACHED (G1BRCL)  I/O   C*1    GAC HEADER RECORD (TAPE AND DISK)  
C                                                                       
C   LOCAL PARAMETERS-                                                   
C      VARIABLE               TYPE  FUNCTION                            
C      --------               ----  --------                            
C      (NONE)                                                           
C                                                                       
C                                                                       
C   FILES-                                                              
C      DSN OR DESCRIPTIVE TITLE    I/O  UNIT  FUNCTIONAL DESCRIPTION    
C      --------------------------  ---  ----  ----------------------    
C      <GAC 1B PRIME FILE>          O  UNITBP GAC 1B PRIME FILE         
C                                                                       
C                                                                       
C   SUBPROGRAMS CALLED- (NONE)                                          
C                                                                       
C   RESTRICTIONS- 1B PRIME FILES WILL ONLY BE CREATED IF PROCESSING     
C      GAC DATA AND THE USER SETS THE PROPER OPTION/FLAG 'ON' IN        
C      THE JCL/FT05F001 CARD IMAGE INPUT DATA RECORD.                   
C                                                                       
C   COMMENTS- IF PROCESSING DISK GAC DATA SETS, NO TBM HEADER           
C      RECORD WILL BE WRITTEN TO THE 1B PRIME FILE.                     
C                                                                       
C   COMMON AREAS- (NONE)                                                
C                                                                       
C   CONSTANT PARAMETERS- INCLAV                                         
C                                                                       
C********************************************************************** 
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/clvunt.f"                                                  
C                                                                       
CCCC  INCLUDE 'inc/jclcom.f'                                                  
C                                                                       
C********************************************************************** 
C                                                                       
C                                                                       
C... LOCAL VARIABLE DECLARATIONS.                                       
C                                                                       
      CHARACTER*1  TBMHED (122), GACHED (G1BRCL)                        
C                                                                       
C                                                                       
C                                                                       
C---------------------------------------------------------------------- 
C                                                                       
C                                                                       
C... ECHO CALLING PARAMETERS.                                           
C                                                                       
      WRITE (6, 1000) UNITBP, IBTAPE                                    
C                                                                       
C                                                                       
C... IF THE INPUT 1B FILE CONTAINED A TBM HEADER, WRITE IT TO THE       
C    OUTPUT 1B' FILE.                                                   
C                                                                       
      IF (IBTAPE .EQ. 0)                                                
     1  WRITE (UNITBP) TBMHED                                           
C                                                                       
C                                                                       
C... WRITE THE HEADER RECORD TO THE 1B' FILE.                           
C                                                                       
      WRITE (UNITBP) GACHED                                             
C                                                                       
C                                                                       
C... PRINT OUT THE NUMBER OF HEADERS WRITTEN.                           
C                                                                       
      WRITE (6, 1010) 2-IBTAPE, UNITBP                                  
C                                                                       
C                                                                       
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT (///,2X,                                                   
     1  '  SUBROUTINE:  WBPHED', /, 2X,                                 
     2  '  ------------------------------------------------', /, 2X,    
     3  '  UNITBP ==>  ', I4, /, 2X,                                    
     4  '  IBTAPE ==>  ', I4, /, 2X)                                    
 1010 FORMAT (//, 2X, '+++ ', I2, ' HEADER FILE(S) WRITTEN TO 1B',      
     1        ' PRIME DATA SET, UNIT = ', I2, ' +++', //)               
C                                                                       
      END                                                               
