      SUBROUTINE WRLIMS                                                 
C                                                                       
C***********************************************************************
C                                                                       
C   NAME- WRLIMS                                                        
C                                                                       
C   LANGUAGE- VS FORTRAN  TYPE- SUBROUTINE                              
C                                                                       
C   VERSION- 1.0    DATE- 10/05/93   PROGRAMMER- BING ZHANG  (SMSRC)    
C                                                                       
C   FUNCTION- THIS SUBROUTINE PRINTS OUT THE QC LIMITS                  
C             (IN DEGREES) FOR COMPUTED PARAMETERS.                     
C                                                                       
C   FILES-                                                              
C     NONE                                                              
C                                                                       
C   LOCAL PARAMETERS-                                                   
C     VARIABLE           TYPE  FUNCTION                                 
C     --------           ----  -----------------------------------      
C       SZ1              R*4    LOWER LIMIT FOR COS(SZA)(UNSCALED)      
C       SZ2              R*4    UPPER LIMIT FOR COS(SZA)(UNSCALED)      
C                                                                       
C       SZNLOW           R*4    ARRCOSINE OF SZ1 CONVERTED TO           
C                              DEGREES                                  
C       SZNHIG           R*4    ARRCOSINE OF SZ2 CONVERTED TO           
C                              DEGREES                                  
C                                                                       
C                                                                       
C   CALLED BY- CLAVRORB                                                 
C                                                                       
C   SUBPROGRAMS CALLED-(NONE)                                           
C                                                                       
C   RESTRICTIONS- THE SOLAR ZENITH ANGLE VALUES INPUT TO THIS           
C                SUBROUTINE ARE ACTUALLY COS(SZA)*1000; THE QC          
C                LIMITS FOR THE SOLAR ZENITH ANGLE ARE,                 
C                THEREFORE, EXPRESSED IN THE SAME WAY.                  
C                                                                       
C   COMMON AREAS- INCLAV,RANGES                                         
C                                                                       
C*******************************************************************    
C                                                                       
      INCLUDE "inc/inclav.f"                                                  
      INCLUDE "inc/ranges.f"                                                  
C                                                                       
C                                                                       
      REAL*4               SZNLOW,SZNHIG,SZ1,SZ2                        
C                                                                       
C..                                                                     
      SZ1 = LWSZN/1000.0                                                
C                                                                       
      SZ2 = UPSZN/1000.0                                                
C                                                                       
      SZNLOW = ACOS(SZ1) * RD2DEG                                       
      SZNHIG = ACOS(SZ2) * RD2DEG                                       
C                                                                       
C.. PRINT HEAD LINES ...                                                
C                                                                       
C     WRITE(6,1000)                                                     
C     WRITE(6,1010)                                                     
C     WRITE(6,1020)                                                     
C     WRITE(6,1030)                                                     
C     WRITE(6,1020)                                                     
C                                                                       
C.. PRINT SOLAR ZENITH ANGLE ..                                         
C                                                                       
C     WRITE(6,1040) SZNHIG, SZNLOW                                      
C                                                                       
C.. PRINT SATELLITE ZENITH ANGLE ..                                     
C                                                                       
C     WRITE(6,1050) LWSTZ/10.0, UPSTZ/10.0                              
C                                                                       
C.. PRINT RELATIVE ZENITH ANGLE ..                                      
C                                                                       
C     WRITE(6,1060) LWRLZ/10.0, UPRLZ/10.0                              
C                                                                       
C.. PRINT ALBEDOS ..                                                    
C                                                                       
C     WRITE(6,1070) LWCH1A, UPCH1A                                      
C     WRITE(6,1080) LWCH2A, UPCH2A                                      
C     WRITE(6,1090) LWCH3A, UPCH3A                                      
C                                                                       
C.. PRINT TEMPERATURES ..                                               
C                                                                       
C     WRITE(6,1100) LWCH3T, UPCH3T                                      
C     WRITE(6,1110) LWCH4T, UPCH4T                                      
C     WRITE(6,1120) LWCH5T, UPCH5T                                      
C                                                                       
C     WRITE(6,1130)                                                     
C     WRITE(6,1140)                                                     
C                                                                       
      RETURN                                                            
C                                                                       
 1000 FORMAT(//,1X,'==============================================',    
     1         '================')                                      
C                                                                       
 1010 FORMAT(1X,'    QC LIMITS (IN DEGREES) FOR COMPUTED PARAMETERS')   
 1020 FORMAT(1X,' --------------------------------------------------',  
     1         '----------')                                            
C                                                                       
 1030 FORMAT(1X,'      PARAMETER            LOWER-LIMIT    ',           
     1         ' UPPER-LIMIT        ')                                  
C                                                                       
 1040 FORMAT(1X,'   SOLAR ZENITH ANGLES',5X,F9.1,6X,F9.1)               
 1050 FORMAT(1X,'   SATELLITE ZENITH ANGLES',1X,F9.1,6X,F9.1)           
 1060 FORMAT(1X,'   RELATIVE ZENITH ANGLES',2X,F9.1,6X,F9.1)            
C                                                                       
 1070 FORMAT(/,1X,'   CHANNEL 1 ALBEDOS',7X,F9.1,6X,F9.1)               
 1080 FORMAT(1X,'   CHANNEL 2 ALBEDOS',7X,F9.1,6X,F9.1)                 
 1090 FORMAT(1X,'   CHANNEL 3 ALBEDOS',7X,F9.1,6X,F9.1)                 
C                                                                       
 1100 FORMAT(/,1X,'   CHANNEL 3 TEMPERTURE',4X,F9.1,6X,F9.1)            
 1110 FORMAT(1X,'   CHANNEL 4 TEMPERTURE',4X,F9.1,6X,F9.1)              
 1120 FORMAT(1X,'   CHANNEL 5 TEMPERTURE',4X,F9.1,6X,F9.1)              
C                                                                       
 1130 FORMAT(1X,'==============================================',       
     1         '================')                                      
 1140 FORMAT(/)                                                         
C                                                                       
C                                                                       
      END                                                               
