! $Id: avhrr_mod.f90,v 1.1 2003/05/20 16:26:42 dlloyd Exp $
!-------------------------------------------------------------------------
! AVHRR ROUTINES
!
! troubles - for non-klm data, when this optimized, some arrays are
!   staying in memory (num_cells_spole from equal_area_grid.f90)
!-------------------------------------------------------------------------
module AVHRR_ROUTINES
 use CONSTANTS
 use NUMERICAL_ROUTINES
 implicit none
 private
 public:: unpack_avhrr_header_record,unpack_avhrr_data_record, &
          lagrangian_anchor_interp,linear_anchor_interp,COMPUTE_ANGLE_ANCHORS, &
          unpack_avhrr_header_record_klm,unpack_avhrr_data_record_klm, &
          i4word_to_string,DEFINE_1B_DATA, &
          READ_AVHRR_INSTR_CONSTANTS,READ_AVHRR_ALGO_CONSTANTS, &
          COASTWATCH_SST,&
          COMPUTE_LAND_SURFACE_TEMP,COMPUTE_ICE_SURFACE_TEMP,&
          COMPUTE_GLINTZEN,REF_CAL,THERM_CAL,CH3B_ALB, &
          CREATE_PIXEL_ARRAYS,DESTROY_PIXEL_ARRAYS, &
          COMPUTE_PIXEL_ARRAYS,  &
          COMPUTE_NEW_THERM_CAL_COEF,COMPUTE_NEW_THERM_CAL_COEF_KLM,&
          OPEN_DIAG_FILES,WRITE_TO_DIAG_FILES,CLOSE_DIAG_FILES, &
          COMPUTE_MONTH

 private:: make_i4word,make_i2word


!----- variables read in from instrument constant files
 real (kind=real4), save, public:: a_3b,b_3b,d_3b,a_4,b_4,d_4,a_5,b_5,d_5, &
                      nu_3b,a1_3b,a2_3b,nu_4,a1_4,a2_4,nu_5,a1_5,a2_5, &
                      c1,c2,space_rad_3b,space_rad_4,space_rad_5
 real(kind=real4), dimension(0:4,4),private,save:: prt_coef
 real(kind=real4), dimension(4),private,save:: prt_weight
 real(kind=real4),save,public:: ch1_gain_low_0,ch1_gain_high_0,ch2_gain_low_0,&
                ch2_gain_high_0,ch3a_gain_low_0,ch3a_gain_high_0, &
                ch1_degrad_low,ch2_degrad_low,ch3a_degrad_low, &
                ch1_degrad_high,ch2_degrad_high,ch3a_degrad_high, &
                ch1_dark_count,ch2_dark_count,ch3a_dark_count, &
                ch1_switch_count,ch2_switch_count, &
                ch3a_switch_count

 
 real(kind=real4),save,public:: launch_date

 real(kind=real4),save,public:: A0,B0,C0,b1_day_mask,b2_day_mask,b3_day_mask,b4_day_mask

 real(kind=real4),save,public:: solar_3b,solar_3b_nu,ew_3b
 character(len=7),save,public:: sat_name


!-------- variable read in from algorithm constant file
 real(kind=real4),save,public:: b1_day,b2_day,b3_day,b4_day, &
                      b1_night,b2_night,b3_night,b4_night

 real(kind=real4),save,public:: a_ist_art_low,b_ist_art_low,c_ist_art_low,d_ist_art_low,&
                    a_ist_art_mid,b_ist_art_mid,c_ist_art_mid,d_ist_art_mid,&
                    a_ist_art_hi,b_ist_art_hi,c_ist_art_hi,d_ist_art_hi

 real(kind=real4),save,public:: a_ist_ant_low,b_ist_ant_low,c_ist_ant_low,d_ist_ant_low,&
                    a_ist_ant_mid,b_ist_ant_mid,c_ist_ant_mid,d_ist_ant_mid,&
                    a_ist_ant_hi,b_ist_ant_hi,c_ist_ant_hi,d_ist_ant_hi

 real(kind=real4),save,public:: a_lst_low,b_lst_low,c_lst_low,d_lst_low,e_lst_low,&
                    a_lst_mid,b_lst_mid,c_lst_mid,d_lst_mid,e_lst_mid,&
                    a_lst_hi,b_lst_hi,c_lst_hi,d_lst_hi,e_lst_hi


!------- pixel array declarations
  integer (kind=int1), dimension(:), allocatable, public:: buffer

  integer (kind=int1), dimension(2), public:: fatal,ascend,q_flag,ch3a_on,resync, &
                                              clavr_status_1b,clavr_status
  integer (kind=int2), dimension(2), public:: scan_number,year,day
  integer (kind=int4), dimension(2), public:: time

  real (kind=real4), dimension(:,:), allocatable,save,public::solzen_anchor,lat_anchor, &
                     lon_anchor,satzen_anchor,relaz_anchor,glintzen_anchor

  real (kind=real4), dimension(3,2), public:: vis_slope_1,vis_slope_2,vis_intercept_1, &
                                     vis_intercept_2,vis_intersection
  real (kind=real4), dimension(3:5,2), public,save:: ir_coef_1_1b,ir_coef_2_1b,ir_coef_3_1b
  real (kind=real4), dimension(3:5,2), public,save:: ir_linear_slope_1b,ir_linear_intercept_1b
  real (kind=real4), dimension(3:5,2), public,save:: ir_linear_slope_new,ir_linear_intercept_new
  real (kind=real4), dimension(5,2), public:: slope,intercept
  integer(kind=int2), dimension(5,10), private:: space_count
  integer(kind=int2), dimension(3:5,10),private:: blackbody_count
  integer(kind=int2), dimension(103),private:: telemetry_word
  integer(kind=int1), public, save:: iprt=0, jcal = 0
  integer(kind=int4), parameter, private:: ncal = 10 
  integer(kind=int2), private, save:: sum_prt
  real(kind=real4), private:: mean_prt,Nbb_3b,Nbb_4,Nbb_5
  real(kind=real4), dimension(ncal), private:: T_prt
  logical, public, save:: valid_new_therm_cal,spinup_new_therm_cal
  real(kind=real4), dimension(ncal),private,save:: space_count_1,space_count_2, &
                                space_count_3,space_count_4,space_count_5
  real(kind=real4), dimension(ncal),private,save:: bb_count_3,bb_count_4,bb_count_5

  real(kind=real4), public, save:: mean_space_count_1=0.0,mean_space_count_2=0.0, &
                                    mean_space_count_3=0.0,mean_space_count_4=0.0, &
                                    mean_space_count_5=0.0
  real(kind=real4), public, save:: mean_T_prt=0.0
  real(kind=real4), public, save::mean_bb_count_3=0.0,mean_bb_count_4=0.0, &
                                  mean_bb_count_5=0.0
  real(kind=real4), private, parameter:: beta=0.50

  integer (kind=int2), dimension(:,:,:), allocatable, public:: chan_counts

  real (kind=real4), dimension(:,:), allocatable, public:: alb1,alb2,alb3a,alb3b, &
                                               alb3b_mask,linear_rad, &
                                               rad3b,rad4,rad5,rad3b_ems,bt3b, &
                                               bt4,bt5,solzen,lat,lon,glintzen, &
                                               satzen,relaz,seczen,ems3b,T0,zsfc, &
                                               coszen,cossolzen,sst_clim
  real (kind=real4), dimension(:,:), allocatable, public:: sst_mask,sst,ndvi,nddi,ndsi,ist,lst, &
                                                           ems4,ems5,bt45,bt3b4,alb21,alb3a1, &
                                                           bt3b5
  integer(kind=int1), dimension(:,:), allocatable, public:: land_mask,desert,desert3b,snow_input,sfc_type

  integer (kind=int1), dimension(:,:,:), allocatable, public, save:: data_mask,mask
  integer (kind=int1),dimension(:,:),allocatable, public, save:: cld_mask_1b,cld_mask,  &
                     cld_type, data_bit, mask_byte_1,mask_byte_2,mask_byte_3
 contains

!----------------------------------------------------------------------
! DEFINE_1B_DATA - based on the gac and klm flags, this routine defines
!                  the parameters necessary to read in the header and
!                  data records from the various 1B data types. This allows
!                  defines quantities to allow the clavr cloud mask to be
!                  written into the klm 1b files. 
!
! input
!      gac - T if gac, F if hrpt or lac
!      klm - T if NOAA-klm, F if NOAA-J or earlier
! output
!      num_pix - the number of pixels per scanline
!      rec_length - the number of bytes per record of the 1b file
!      irec_header - the number of records used for the header
!      rec_per_two_scans - number of records needed to comprise two scanlines
!      nword_clavr_start - byte number of first clavr byte on 1b
!      nword_clavr - number of bytes used for clavr cloud mask on 1b
!-------------------------------------------------------------------------------
 subroutine DEFINE_1B_DATA(gac,klm,num_pix,rec_length,irec_header, &
                      rec_per_two_scans,nword_clavr_start,nword_clavr)

  logical, intent(in):: gac, klm
  integer(kind=int2), intent(out):: num_pix
  integer(kind=int4), intent(out):: rec_per_two_scans, nword_clavr, &
                                    nword_clavr_start, irec_header, &
                                    rec_length
  if (gac .eqv. .true.) then
      num_pix = 409              !number of pixels per scan line
      if (klm .eqv. .true.) then
       rec_length  = 4608
       irec_header = 1
       rec_per_two_scans = 2
       nword_clavr_start = 4049
       nword_clavr = 2*52
      else
       rec_length  = 6440
       irec_header = 1
       rec_per_two_scans = 1
       nword_clavr_start = 4049
       nword_clavr = 2*52
      endif
   else
      if (klm .eqv. .true.) then
       num_pix = 2048
       irec_header = 1
       rec_per_two_scans = 2
       rec_length = 15872
       nword_clavr_start = 14977
       nword_clavr = 2*256
     else
      num_pix = 2048
      irec_header = 2
      rec_per_two_scans = 4
      rec_length = 7400
      nword_clavr_start = 14977
      nword_clavr = 2*256
      endif
   endif



 end subroutine DEFINE_1B_DATA

!----------------------------------------------------------------------------
subroutine CREATE_PIXEL_ARRAYS(num_pix,rec_per_two_scans,rec_length,num_anchors)
  integer(kind=int2), intent(in):: num_pix
  integer(kind=int4), intent(in):: rec_per_two_scans, rec_length, num_anchors


   allocate(buffer(rec_per_two_scans*rec_length))


  allocate(alb1(num_pix,2),alb2(num_pix,2),alb3a(num_pix,2),alb3b(num_pix,3), &
      linear_rad(num_pix,2),rad3b(num_pix,2),rad4(num_pix,2),rad5(num_pix,2), &
      rad3b_ems(num_pix,2),bt3b(num_pix,2),bt4(num_pix,2),bt5(num_pix,2),&
      solzen(num_pix,2),lat(num_pix,2),lon(num_pix,2),glintzen(num_pix,2), &
      land_mask(num_pix,2),satzen(num_pix,2),relaz(num_pix,2),ems3b(num_pix,2),&
      T0(num_pix,2),alb3b_mask(num_pix,2), &
      desert(num_pix,2),desert3b(num_pix,2), &
      snow_input(num_pix,2),sfc_type(num_pix,2), &
      zsfc(num_pix,2),sst_clim(num_pix,2), &
      seczen(num_pix,2),coszen(num_pix,2),cossolzen(num_pix,2))

  allocate(chan_counts(5,num_pix,2))

  allocate(cld_mask_1b(num_pix,2),cld_mask(num_pix,2),cld_type(num_pix,2), &
           mask_byte_1(num_pix,2),mask_byte_2(num_pix,2),mask_byte_3(num_pix,2), &
           data_bit(num_pix,2),mask(24,num_pix,2),data_mask(8,num_pix,2))

  allocate(sst_mask(num_pix,2),sst(num_pix,2),ndvi(num_pix,2),nddi(num_pix,2), &
           ist(num_pix,2),lst(num_pix,2),ems4(num_pix,2),ems5(num_pix,2), &
           bt45(num_pix,2),bt3b4(num_pix,2),bt3b5(num_pix,2), &
           alb21(num_pix,2),alb3a1(num_pix,2),ndsi(num_pix,2))


   allocate(solzen_anchor(num_anchors,2),lat_anchor(num_anchors,2), &
            lon_anchor(num_anchors,2),satzen_anchor(num_anchors,2), &
            relaz_anchor(num_anchors,2),glintzen_anchor(num_anchors,2))
  alb1 = 0.0
   alb2 = 0.0
   alb3a = 0.0
   alb3b = 0.0
   rad3b = 0.0
   rad3b_ems = 0.0
   ems3b = 0.0
   bt3b = 0.0
   rad4 = 0.0
   bt4 = 0.0
   rad5 = 0.0
   bt5 = 0.0
   lat = 0.0
   lon = 0.0
   cld_mask_1b = 0
   cld_mask = 0
   clavr_status_1b = 0
   clavr_status = 0
   cld_type = 0
   desert = 0
   desert3b = 0
   sfc_type = 0
   land_mask = 0
   zsfc = 0.0
   sst_clim = 0.0
   lat_anchor = 0.0
   lon_anchor = 0.0
   solzen_anchor = 0.0
   satzen_anchor = 0.0
   relaz_anchor = 0.0
   glintzen_anchor = 0.0
   solzen = 0.0
   satzen = 0.0
   relaz = 0.0
   mask_byte_1 = 0
   mask_byte_2 = 0
   mask_byte_3 = 0
   data_bit = 0
   mask = 0
   data_mask = 0
   sst_mask = 0.0
   sst = 0.0
   ndvi = 0.0
   nddi = 0.0
   ndsi = 0.0
   ist = 0.0
   lst = 0.0
   ems4 = 0.0
   ems5 = 0.0
   snow_input = 0
   bt45 = 0.0
   bt3b4 = 0.0
   bt3b5 = 0.0
   alb21 = 0.0
   alb3a1 = 0.0  

  chan_counts = 0
  buffer = 0

end subroutine CREATE_PIXEL_ARRAYS

!------------------------------------------------------------------------------
subroutine DESTROY_PIXEL_ARRAYS()

  deallocate(buffer,chan_counts,cld_mask_1b,cld_mask,cld_type, &
             mask_byte_1,mask_byte_2,mask_byte_3,data_bit,mask,data_mask)
  deallocate(alb1,alb2,alb3a,alb3b,alb3b_mask,linear_rad,rad3b,rad4,rad5)
  deallocate(land_mask,desert,desert3b,rad3b_ems,bt3b,&
             bt4,bt5,solzen,lat,lon,glintzen,satzen,relaz,seczen, &
             coszen,cossolzen,ems3b,T0)
  deallocate(snow_input,sfc_type,zsfc,sst_clim)
  deallocate(sst,ndvi,nddi,ndsi,ist,lst,ems4,ems5)
  deallocate(lat_anchor,lon_anchor,solzen_anchor,satzen_anchor,relaz_anchor,glintzen_anchor)
  deallocate(sst_mask,alb21,alb3a1,bt45,bt3b4,bt3b5)


end subroutine DESTROY_PIXEL_ARRAYS



!-----------------------------------------------------------
! REFLECTANCE CALIBRATION ROUTINE
!
! comments given for channel 1 only but apply to channel 2,3a
!
! input
!   time_since_launch - the time in years since the launch
!
!  output
!   none - only through common memory
!
! internal parameters
!  ch1_gain_low - calibration slope or gain in low count region
!                  with degradation accounted for
!  ch1_gain_high - calibration slope or gain in high count region
!                  with degradation accounted for
!  alb1_switch - the albedo at count = count1_switch
!
! arrays used from common memory
!  chan_counts(1,:,:) - two scanlines of channel 1 counts
!
! arrays modified in common memory
!  alb1 - channel 1 albedo for scanline pair, not this is
!         not corrected for sun-earth distance or for solar zenith angle
!
!  variables used from common memory
!   ch1_gain_low_0 - calibration slope or gain in low count region at launch
!   ch1_gain_high_0 - calibration slope or gain in high count region at launch
!   ch1_switch_count - count separating low from high count region
!   ch1_dark_count - the dark count
!
! Revision History
! Coded January 2003 - A. Heidinger
!-----------------------------------------------------------
 subroutine REF_CAL(time_since_launch)


 real(kind=real4), intent(in):: time_since_launch

! integer(kind=int2), dimension(:), intent(in):: count1,count2,count3a
! real(kind=real4), dimension(:), intent(out):: alb1,alb2,alb3a

  real(kind=real4):: ch1_gain_low,ch1_gain_high,ch2_gain_low,ch2_gain_high, &
                    ch3a_gain_low,ch3a_gain_high,alb1_switch,alb2_switch,alb3a_switch

!--- adjust gains to account for degradation
   ch1_gain_low = ch1_gain_low_0 * (1.0 + ch1_degrad_low * time_since_launch/100.0)
   ch1_gain_high = ch2_gain_high_0 * (1.0 + ch1_degrad_high * time_since_launch/100.0)
   ch2_gain_low = ch2_gain_low_0 * (1.0 + ch2_degrad_low * time_since_launch/100.0)
   ch2_gain_high = ch2_gain_high_0 * (1.0 + ch2_degrad_high * time_since_launch/100.0)
   ch3a_gain_low = ch3a_gain_low_0 * (1.0 + ch3a_degrad_low * time_since_launch/100.0)
   ch3a_gain_high = ch3a_gain_high_0 * (1.0 + ch3a_degrad_high * time_since_launch/100.0)


!---- compute reflectances at switch count
 alb1_switch = ch1_gain_low * (ch1_switch_count - ch1_dark_count)
 alb2_switch = ch2_gain_low * (ch2_switch_count - ch2_dark_count)
 alb3a_switch = ch3a_gain_low * (ch3a_switch_count - ch3a_dark_count)

!--- channel 1
 where (chan_counts(1,:,:) <= ch1_switch_count)
    alb1 = ch1_gain_low*(chan_counts(1,:,:) - ch1_dark_count) 
 elsewhere
    alb1 = alb1_switch + ch1_gain_high*(chan_counts(1,:,:) - ch1_switch_count) 
 end where

!--- channel 2
 where (chan_counts(2,:,:) <= ch2_switch_count)
    alb2 = ch2_gain_low*(chan_counts(2,:,:) - ch2_dark_count) 
 elsewhere
    alb2 = alb2_switch + ch2_gain_high*(chan_counts(2,:,:) - ch2_switch_count) 
 end where

!--- channel 3a
 where (chan_counts(3,:,:) <= ch3a_switch_count)
    alb3a = ch3a_gain_low*(chan_counts(3,:,:) - ch3a_dark_count) 
 elsewhere
    alb3a = alb3a_switch + ch3a_gain_high*(chan_counts(3,:,:) - ch3a_switch_count) 
 end where
  
  
 end subroutine REF_CAL

!-----------------------------------------------------------
! THERMAL CALIBRATION
!
! input
!    therm_cal_1b - use 1b cal. coefficients (true)
!    klm - logical flag set to true if this klm data
!    ch3a_on - integer flag set to 0 if ch3a is off
!    count3 - vector of channel 3 counts
!    count4 - vector of channel 4 counts
!    count5 - vector of channel 5 counts
!    d_coef - the "d" coefficient as illustrated in klm-POD
!    a_coef - the "a" coefficient as illustrated in klm-POD
!    b_coef - the "b" coefficient as illustrated in klm-POD
!    linear_slope - slope in linear radiance computation
!    linear_intercept - intercept in linear radiance computation
!
! output 
!   rad3b, rad4, rad5 - vector of channel radiance in mW/m^2/str/cm^-1
!   bt3b, bt4, bt5 - vector of brightness temperature in K
!
! Used from Common Memory
!    nu_3b, a_3b, b_3b - radiance to temperature conversion parameters
!                        (see klm-PODUG for example)
!    nu_4, a_4, b_4 - radiance to temperature conversion parameters
!    nu_5, a_5, b_5 - radiance to temperature conversion parameters
!
! Some Notes
! 1- pre-klm data is first converted to a radiance assuming a linear calibration
!    then the non-linear adjustment is made
! 2- Does not incorporate the correct procedure for data
!    before NOAA-14.  Need to review original CLAVR-1 for this.
! 3 - klm data, the non-linear correction is added to the linear radiance 
!     but for non-klm data is the non-linear correction is additive (see pods)
!     this is reflected in the difference is the pre-klm and klm coefs.
!
! Revision History
!  Coded January 2003 - A. Heidinger
!        February 2003 - added therm_cal_1b argument and new calibration
!
!
!---------------------------------------------------------------------------
subroutine THERM_CAL(therm_cal_1b,klm,ch3a_on)

  logical,intent(in):: klm, therm_cal_1b
  integer(kind=int1), dimension(:), intent(in):: ch3a_on
  integer(kind=int4):: j,n

  n = size(rad4,2)


  do j = 1, n


!----  convert counts to radiance
 if (therm_cal_1b .eqv. .true.) then
    if (klm .eqv. .true.) then

     if (ch3a_on(j) == 0) then
       rad3b(:,j) = ir_coef_1_1b(3,j) + ir_coef_2_1b(3,j)*chan_counts(3,:,j) + ir_coef_3_1b(3,j)*chan_counts(3,:,j)**2
     endif
     rad4(:,j) = ir_coef_1_1b(4,j) + ir_coef_2_1b(4,j)*chan_counts(4,:,j) + ir_coef_3_1b(4,j)*chan_counts(4,:,j)**2
     rad5(:,j) = ir_coef_1_1b(5,j) + ir_coef_2_1b(5,j)*chan_counts(5,:,j) + ir_coef_3_1b(5,j)*chan_counts(5,:,j)**2

    else

     linear_rad(:,j) = ir_linear_slope_1b(3,j)*chan_counts(3,:,j) + ir_linear_intercept_1b(3,j)
     rad3b(:,j) = a_3b*linear_rad(:,j) + b_3b*linear_rad(:,j)**2 + d_3b

     linear_rad(:,j) = ir_linear_slope_1b(4,j)*chan_counts(4,:,j) + ir_linear_intercept_1b(4,j)
     rad4(:,j) = a_4*linear_rad(:,j) + b_4*linear_rad(:,j)**2 + d_4

     linear_rad(:,j) = ir_linear_slope_1b(5,j)*chan_counts(5,:,j) + ir_linear_intercept_1b(5,j)
     rad5(:,j) = a_5*linear_rad(:,j) + b_5*linear_rad(:,j)**2 + d_5

    endif
 else
    if (klm .eqv. .true.) then

     if (ch3a_on(j) == 0) then
       linear_rad(:,j) = ir_linear_slope_new(3,j)*chan_counts(3,:,j) + ir_linear_intercept_new(3,j)
       rad3b(:,j) = a_3b*linear_rad(:,j) + b_3b*linear_rad(:,j)**2 + d_3b
       rad3b(:,j) = linear_rad(:,j) + rad3b(:,j)
     endif

     linear_rad(:,j) = ir_linear_slope_new(4,j)*chan_counts(4,:,j) + ir_linear_intercept_new(4,j)
     rad4(:,j) = a_4*linear_rad(:,j) + b_4*linear_rad(:,j)**2 + d_4
     rad4(:,j) = linear_rad(:,j) + rad4(:,j)

     linear_rad(:,j) = ir_linear_slope_new(5,j)*chan_counts(5,:,j) + ir_linear_intercept_new(5,j)
     rad5(:,j) = a_5*linear_rad(:,j) + b_5*linear_rad(:,j)**2 + d_5
     rad5(:,j) = linear_rad(:,j) + rad5(:,j)

    else

     linear_rad(:,j) = ir_linear_slope_new(3,j)*chan_counts(3,:,j) + ir_linear_intercept_new(3,j)
     rad3b(:,j) = a_3b*linear_rad(:,j) + b_3b*linear_rad(:,j)**2 + d_3b

     linear_rad(:,j) = ir_linear_slope_new(4,j)*chan_counts(4,:,j) + ir_linear_intercept_new(4,j)
     rad4(:,j) = a_4*linear_rad(:,j) + b_4*linear_rad(:,j)**2 + d_4

     linear_rad(:,j) = ir_linear_slope_new(5,j)*chan_counts(5,:,j) + ir_linear_intercept_new(5,j)
     rad5(:,j) = a_5*linear_rad(:,j) + b_5*linear_rad(:,j)**2 + d_5

    endif
 endif

!---- convert radiance to brightness temperature

!--- channel 3b 
    where(rad3b(:,j) > 0.0 .and. ch3a_on(j) == 0)
       bt3b(:,j) = a1_3b + a2_3b * ((c2*nu_3b) / log( 1.0 + (c1*(nu_3b**3))/rad3b(:,j)))
    elsewhere
       rad3b(:,j) = missing_value_real4
       bt3b(:,j) = missing_value_real4
    endwhere  

    where(rad4(:,j) > 0.0)
       bt4(:,j) = a1_4 + a2_4 * ((c2*nu_4) / log( 1.0 + (c1*(nu_4**3))/rad4(:,j)))
    elsewhere
       rad4(:,j) = missing_value_real4
       bt4(:,j) = missing_value_real4
    endwhere  

    where(rad5(:,j) > 0.0)
       bt5(:,j) = a1_5 + a2_5 * ((c2*nu_5) / log( 1.0 + (c1*(nu_5**3))/rad5(:,j)))
    elsewhere
       rad5(:,j) = missing_value_real4
       bt5(:,j) = missing_value_real4
    endwhere  

  enddo


end subroutine THERM_CAL

!--------------------------------------------------------------------------
! compute parameters needed to derive new thermal calibration
! coefficients using a method similar to that described in the
! PODUG for HPRT users.  
!
! The methodology is 
!  average all space, blackbody counts and PRT's rom one scan together
!  average all quantities together for ncal scanlines
!  every ncal scanlines, update a running mean of all these values
!  the running mean is defined as
!   new_running_mean = (1-beta)*old_running_mean + new_value 
!
!  experimentaion has shown ncal = 10 and beta = 1/5 result in smooth curves
!  the variation 1b slope and intercept is approximated with ncal=5, beta = 1.0
!  unsure if smoother is better (TBD).
!
! Author: Andrew Heidinger
! Date: February 2003
!
! Revision - added check for missing space and blackbody counts - noticed
!           this occured for D95001 - D95005 data for NOAA-14
!
!--------------------------------------------------------------------------
subroutine COMPUTE_NEW_THERM_CAL_COEF()

 integer:: ii,iword,scans_per_record,ibyte,j,ipix,ichan
 integer(kind=int2):: byte_offset
 integer(kind=int4):: i4word

 scans_per_record = 2
 byte_offset = size(buffer) / 2
 valid_new_therm_cal = .true.

 do ii = 1,scans_per_record

!-----------------------------------------------------------------------
! unpack telemetry words
!-----------------------------------------------------------------------
    iword = 1
    do ibyte = 309+(ii-1)*byte_offset,448+(ii-1)*byte_offset,4
      i4word = make_i4word(buffer(ibyte:ibyte+3),0)
      do j = 1,3
       telemetry_word(iword) = i4word / (1024**(3-j))
       i4word = i4word - telemetry_word(iword)*(1024**(3-j))
       iword = iword + 1
       if (iword > 103) then
        exit
       endif
      enddo
       if (iword > 103) then
        exit
       endif
    enddo

!--- prt readings
    sum_prt = telemetry_word(18)+telemetry_word(19)+telemetry_word(20)

    iprt = iprt + 1
!---- check for reset of PRTs
    if (sum_prt < 50) then
     iprt = 0
    endif

!--------------------------------------------------
! test to see if any coefficients can be made
!--------------------------------------------------
    if ((iprt == 0) .and. (mean_T_prt <= 0.0)) then
        valid_new_therm_cal = .false.
        return 
    endif

!---- check to see if out of cycle
    if (iprt > 4) then
      print* ,"error in prt"
      valid_new_therm_cal = .false.
    endif

!--- the internal target data
    ichan = 3
    ipix = 1
    do iword = 23,52,1
       blackbody_count(ichan, ipix) = telemetry_word(iword)
       ichan = ichan + 1
       if (ichan > 5) then
          ichan = 3
          ipix = ipix + 1
       endif
     enddo

!---space data
    ichan = 1
    ipix = 1
    do iword = 53,102,1
       space_count(ichan, ipix) = telemetry_word(iword)
       ichan = ichan + 1
       if (ichan > 5) then
          ichan = 1
          ipix = ipix + 1
       endif
     enddo

   if ((minval(space_count(3:5,:)) < 50) .or. (minval(blackbody_count(3:5,:)) < 50)) then
       print *,"errors in space and/or black body counts", minval(space_count(3:5,:)), minval(blackbody_count(3:5,:))
       return
   endif

!----- assume a valid calibration can be made
    jcal = jcal + 1

!--- compute blackbody temperature if valid PRT reading
    if ((iprt > 0) .and. (iprt <= 4)) then
       mean_prt = sum_prt/3.0
       T_prt(jcal) = prt_coef(0,iprt) + prt_coef(1,iprt)*mean_prt + &
               prt_coef(2,iprt)*mean_prt**2 + &
               prt_coef(3,iprt)*mean_prt**3 + &
               prt_coef(4,iprt)*mean_prt**4
    endif

!--- if no PRT reading, fill in with mean value
    if ((iprt == 0) .and. (mean_T_prt > 0.0)) then
       T_prt(jcal) = mean_T_prt
    endif

!--- if out of cycle, use old mean value
    if (iprt > 4) then
       T_prt(jcal) = mean_T_prt
    endif

!--- average space and bb counts for this scan
    if (jcal > 0) then
       space_count_1(jcal) = sum(space_count(1,:))/10.0
       space_count_2(jcal) = sum(space_count(2,:))/10.0
       space_count_3(jcal) = sum(space_count(3,:))/10.0
       space_count_4(jcal) = sum(space_count(4,:))/10.0
       space_count_5(jcal) = sum(space_count(5,:))/10.0

       bb_count_3(jcal) = sum(blackbody_count(3,:))/10.0
       bb_count_4(jcal) = sum(blackbody_count(4,:))/10.0
       bb_count_5(jcal) = sum(blackbody_count(5,:))/10.0

    endif

!-------------------------------------------------------------------
! compute running means of space, blackbody and prt temps
!-------------------------------------------------------------------

!--- if initial spinup period, sum all to get mean

    if (spinup_new_therm_cal .eqv. .true.) then

      if (jcal > 0) then
       mean_T_prt = sum(T_prt(1:jcal))/jcal
       mean_space_count_1 = sum(space_count_1(1:jcal))/jcal
       mean_space_count_2 = sum(space_count_2(1:jcal))/jcal
       mean_space_count_3 = sum(space_count_3(1:jcal))/jcal
       mean_space_count_4 = sum(space_count_4(1:jcal))/jcal
       mean_space_count_5 = sum(space_count_5(1:jcal))/jcal
       mean_bb_count_3 = sum(bb_count_3(1:jcal))/jcal
       mean_bb_count_4 = sum(bb_count_4(1:jcal))/jcal
       mean_bb_count_5 = sum(bb_count_5(1:jcal))/jcal
      else
       mean_T_prt = missing_value_real4
       mean_space_count_1 = missing_value_real4
       mean_space_count_2 = missing_value_real4
       mean_space_count_3 = missing_value_real4
       mean_space_count_4 = missing_value_real4
       mean_space_count_5 = missing_value_real4
       mean_bb_count_3 = missing_value_real4
       mean_bb_count_4 = missing_value_real4
       mean_bb_count_5 = missing_value_real4
       valid_new_therm_cal = .false.
      endif

      if (jcal == ncal) then
        spinup_new_therm_cal = .false.
        jcal = 0
        T_prt = 0
        space_count_1 = 0.0
        space_count_2 = 0.0
        space_count_3 = 0.0
        space_count_4 = 0.0
        space_count_5 = 0.0
        bb_count_3 = 0.0
        bb_count_4 = 0.0
        bb_count_5 = 0.0
      endif

    else

      if (jcal == ncal) then
       mean_T_prt = (1.0-beta)*mean_T_prt + beta*(sum(T_prt)/ncal)
       mean_space_count_1 = (1.0-beta)*mean_space_count_1 + beta*(sum(space_count_1)/ncal)
       mean_space_count_2 = (1.0-beta)*mean_space_count_2 + beta*(sum(space_count_2)/ncal)
       mean_space_count_3 = (1.0-beta)*mean_space_count_3 + beta*(sum(space_count_3)/ncal)
       mean_space_count_4 = (1.0-beta)*mean_space_count_4 + beta*(sum(space_count_4)/ncal)
       mean_space_count_5 = (1.0-beta)*mean_space_count_5 + beta*(sum(space_count_5)/ncal)
       mean_bb_count_3 = (1.0-beta)*mean_bb_count_3 + beta*(sum(bb_count_3)/ncal)
       mean_bb_count_4 = (1.0-beta)*mean_bb_count_4 + beta*(sum(bb_count_4)/ncal)
       mean_bb_count_5 = (1.0-beta)*mean_bb_count_5 + beta*(sum(bb_count_5)/ncal)
!      write(unit=79,fmt=*) scan_number(ii), mean_T_prt, sum(T_prt)/jcal,T_prt(jcal),iprt, jcal
!      write(unit=80,fmt=*) scan_number(ii), mean_bb_count_4, sum(bb_count_4)/jcal,bb_count_4(jcal),iprt, jcal
       jcal = 0
       T_prt = 0.0
       space_count_1 = 0.0
       space_count_2 = 0.0
       space_count_3 = 0.0
       space_count_4 = 0.0
       space_count_5 = 0.0
       bb_count_3 = 0.0
       bb_count_4 = 0.0
       bb_count_5 = 0.0
      endif
!     if (jcal > 0) then
!      write(unit=79,fmt=*) scan_number(ii), mean_T_prt, sum(T_prt)/jcal,T_prt(jcal),iprt, jcal
!     endif
    endif


!--- compute  new linear calibration coefficients
    if (valid_new_therm_cal .eqv. .true.) then

       Nbb_3b = c1*(nu_3b**3)/(exp((c2*nu_3b)/((mean_T_prt-a1_3b)/a2_3b))-1.0)
       Nbb_4 = c1*(nu_4**3)/(exp((c2*nu_4)/((mean_T_prt-a1_4)/a2_4))-1.0)
       Nbb_5 = c1*(nu_5**3)/(exp((c2*nu_5)/((mean_T_prt-a1_5)/a2_5))-1.0)

       ir_linear_slope_new(3,ii) = (space_rad_3b - Nbb_3b) / &
                                  (mean_space_count_3 - mean_bb_count_3)

       ir_linear_intercept_new(3,ii) = space_rad_3b - &
                  ir_linear_slope_new(3,ii)*mean_space_count_3

       ir_linear_slope_new(4,ii) = (space_rad_4 - Nbb_4) / &
                                  (mean_space_count_4 - mean_bb_count_4)

       ir_linear_intercept_new(4,ii) = space_rad_4 - &
                  ir_linear_slope_new(4,ii)*mean_space_count_4

       ir_linear_slope_new(5,ii) = (space_rad_5 - Nbb_5) / &
                                  (mean_space_count_5 - mean_bb_count_5)

       ir_linear_intercept_new(5,ii) = space_rad_5 - &
                  ir_linear_slope_new(5,ii)*mean_space_count_5

     else
        valid_new_therm_cal = .false.
   endif

end do   !scans_per_record

end subroutine COMPUTE_NEW_THERM_CAL_COEF
!------------------------------------------------------------------------
subroutine COMPUTE_NEW_THERM_CAL_COEF_KLM()

 integer:: ii,scans_per_record,ibyte,j
 integer(kind=int2):: byte_offset

 scans_per_record = 2
 byte_offset = size(buffer) / 2
 valid_new_therm_cal = .true.

 scans_per_record_loop: do ii = 1, scans_per_record

!-----------------------------------------------------------------------
! unpack telemetry words
!-----------------------------------------------------------------------

!------ prt readings
    sum_prt = 0
    ibyte = 1091 + (ii-1)*byte_offset
    sum_prt = make_i2word(buffer(ibyte:ibyte+1),1) +  &
              make_i2word(buffer(ibyte+2:ibyte+3),1) + &
              make_i2word(buffer(ibyte+4:ibyte+5),1)

    iprt = iprt + 1

!---- check for reset of PRTs
    if (sum_prt < 50) then
     iprt = 0
    endif
!--------------------------------------------------
! test to see if any coefficients can be made
!--------------------------------------------------
    if ((iprt == 0) .and. (mean_T_prt <= 0.0)) then
        valid_new_therm_cal = .false.
        return
    endif


!---- check to see if out of cycle
    if (iprt > 4) then
      print* ,"error in prt"
      valid_new_therm_cal = .false.
    endif

!---- unpack target view
  do j = 1,10
   blackbody_count(3,j) = make_i2word(buffer(1101+6*(j-1)+(ii-1)*byte_offset:1102+6*(j-1)+(ii-1)*byte_offset),1)
   blackbody_count(4,j) = make_i2word(buffer(1103+6*(j-1)+(ii-1)*byte_offset:1104+6*(j-1)+(ii-1)*byte_offset),1)
   blackbody_count(5,j)  = make_i2word(buffer(1105+6*(j-1)+(ii-1)*byte_offset:1106+6*(j-1)+(ii-1)*byte_offset),1)
  enddo

!---- unpack space view
  do j = 1,10
   space_count(1,j)  = make_i2word(buffer(1161+10*(j-1)+(ii-1)*byte_offset:1162+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(2,j) = make_i2word(buffer(1163+10*(j-1)+(ii-1)*byte_offset:1164+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(3,j) = make_i2word(buffer(1165+10*(j-1)+(ii-1)*byte_offset:1166+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(4,j) = make_i2word(buffer(1167+10*(j-1)+(ii-1)*byte_offset:1168+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(5,j)  = make_i2word(buffer(1169+10*(j-1)+(ii-1)*byte_offset:1170+10*(j-1)+(ii-1)*byte_offset),1)
  enddo

!---- check for bad space or blackbody counts
   if ((minval(space_count(4:5,:)) < 50) .or. (minval(blackbody_count(4:5,:)) < 50)) then
       print *,"errors in space and/or black body counts"
       return
   endif

!----- assume a valid calibration can be made
    jcal = jcal + 1


!--- compute blackbody temperature if valid PRT reading
    if ((iprt > 0) .and. (valid_new_therm_cal .eqv. .true.)) then
       mean_prt = sum_prt/3.0
       T_prt(jcal) = prt_coef(0,iprt) + prt_coef(1,iprt)*mean_prt + &
               prt_coef(2,iprt)*mean_prt**2 + &
               prt_coef(3,iprt)*mean_prt**3 + &
               prt_coef(4,iprt)*mean_prt**4
    endif

!--- if no PRT reading, fill in with mean value
    if ((iprt == 0) .and. (valid_new_therm_cal .eqv. .true.)) then
       T_prt(jcal) = mean_T_prt
    endif

!--- average space and bb counts for this scan
    if (jcal > 0) then
       space_count_1(jcal) = sum(space_count(1,:))/10.0
       space_count_2(jcal) = sum(space_count(2,:))/10.0
       space_count_3(jcal) = sum(space_count(3,:))/10.0
       space_count_4(jcal) = sum(space_count(4,:))/10.0
       space_count_5(jcal) = sum(space_count(5,:))/10.0

       bb_count_3(jcal) = sum(blackbody_count(3,:))/10.0
       bb_count_4(jcal) = sum(blackbody_count(4,:))/10.0
       bb_count_5(jcal) = sum(blackbody_count(5,:))/10.0
    endif

!-------------------------------------------------------------------
! compute running means of space, blackbody and prt temps
!-------------------------------------------------------------------

!--- if initial spinup period, sum all to get mean

    if (spinup_new_therm_cal .eqv. .true.) then

      if (jcal > 0) then
       mean_T_prt = sum(T_prt(1:jcal))/jcal
       mean_space_count_1 = sum(space_count_1(1:jcal))/jcal
       mean_space_count_2 = sum(space_count_2(1:jcal))/jcal
       mean_space_count_3 = sum(space_count_3(1:jcal))/jcal
       mean_space_count_4 = sum(space_count_4(1:jcal))/jcal
       mean_space_count_5 = sum(space_count_5(1:jcal))/jcal
       mean_bb_count_3 = sum(bb_count_3(1:jcal))/jcal
       mean_bb_count_4 = sum(bb_count_4(1:jcal))/jcal
       mean_bb_count_5 = sum(bb_count_5(1:jcal))/jcal
      else
       mean_T_prt = missing_value_real4
       mean_space_count_1 = missing_value_real4
       mean_space_count_2 = missing_value_real4
       mean_space_count_3 = missing_value_real4
       mean_space_count_4 = missing_value_real4
       mean_space_count_5 = missing_value_real4
       mean_bb_count_3 = missing_value_real4
       mean_bb_count_4 = missing_value_real4
       mean_bb_count_5 = missing_value_real4
       valid_new_therm_cal = .false.
      endif

      if (jcal == ncal) then
        spinup_new_therm_cal = .false.
        jcal = 0
        T_prt = 0.0
        space_count_1 = 0.0
        space_count_2 = 0.0
        space_count_3 = 0.0
        space_count_4 = 0.0
        space_count_5 = 0.0
        bb_count_3 = 0.0
        bb_count_4 = 0.0
        bb_count_5 = 0.0
        print *, "spin up finished"
      endif

    else

      if (jcal == ncal) then
       mean_T_prt = (1.0-beta)*mean_T_prt + beta*(sum(T_prt)/ncal)
       mean_space_count_1 = (1.0-beta)*mean_space_count_1 + beta*(sum(space_count_1)/ncal)
       mean_space_count_2 = (1.0-beta)*mean_space_count_2 + beta*(sum(space_count_2)/ncal)
       mean_space_count_3 = (1.0-beta)*mean_space_count_3 + beta*(sum(space_count_3)/ncal)
       mean_space_count_4 = (1.0-beta)*mean_space_count_4 + beta*(sum(space_count_4)/ncal)
       mean_space_count_5 = (1.0-beta)*mean_space_count_5 + beta*(sum(space_count_5)/ncal)
       mean_bb_count_3 = (1.0-beta)*mean_bb_count_3 + beta*(sum(bb_count_3)/ncal)
       mean_bb_count_4 = (1.0-beta)*mean_bb_count_4 + beta*(sum(bb_count_4)/ncal)
       mean_bb_count_5 = (1.0-beta)*mean_bb_count_5 + beta*(sum(bb_count_5)/ncal)
 
!      write(unit=79,fmt=*) scan_number(ii), mean_T_prt, sum(T_prt)/jcal,T_prt(jcal),iprt, jcal
!      write(unit=80,fmt=*) scan_number(ii), mean_bb_count_4, sum(bb_count_4)/jcal,bb_count_4(jcal),iprt, jcal
       jcal = 0
       T_prt = 0.0
       space_count_1 = 0.0
       space_count_2 = 0.0
       space_count_3 = 0.0
       space_count_4 = 0.0
       space_count_5 = 0.0
       bb_count_3 = 0.0
       bb_count_4 = 0.0
       bb_count_5 = 0.0
      endif
 
!     if (jcal > 0) then
!     write(unit=79,fmt=*) scan_number(ii), mean_T_prt, sum(T_prt)/jcal, T_prt(jcal),iprt, jcal
!      write(unit=80,fmt=*) scan_number(ii), mean_bb_count_4, sum(bb_count_4)/jcal,bb_count_4(jcal),iprt, jcal
!     write(unit=6,fmt=*) scan_number(ii), mean_T_prt, sum(T_prt)/jcal, T_prt(jcal),iprt, jcal
!      write(unit=6,fmt=*) scan_number(ii), mean_bb_count_4, sum(bb_count_4)/jcal,bb_count_4(jcal),iprt, jcal
!     endif

    endif


    if (valid_new_therm_cal .eqv. .true.) then

!--- blackbody radiance
       Nbb_3b = c1*(nu_3b**3)/(exp((c2*nu_3b)/((mean_T_prt-a1_3b)/a2_3b))-1.0)
       Nbb_4 = c1*(nu_4**3)/(exp((c2*nu_4)/((mean_T_prt-a1_4)/a2_4))-1.0)
       Nbb_5 = c1*(nu_5**3)/(exp((c2*nu_5)/((mean_T_prt-a1_5)/a2_5))-1.0)

!--- compute new linear slopes
       if (ch3a_on(ii) == 0) then
        ir_linear_slope_new(3,ii) = (space_rad_3b - Nbb_3b) / &
                                  (mean_space_count_3 - mean_bb_count_3)
        ir_linear_intercept_new(3,ii) = space_rad_3b - &
                  ir_linear_slope_new(3,ii)*mean_space_count_3
       endif


       ir_linear_slope_new(4,ii) = (space_rad_4 - Nbb_4) / &
                                  (mean_space_count_4 - mean_bb_count_4)
       ir_linear_intercept_new(4,ii) = space_rad_4 - &
                  ir_linear_slope_new(4,ii)*mean_space_count_4

       ir_linear_slope_new(5,ii) = (space_rad_5 - Nbb_5) / &
                                  (mean_space_count_5 - mean_bb_count_5)
       ir_linear_intercept_new(5,ii) = space_rad_5 - &
                  ir_linear_slope_new(5,ii)*mean_space_count_5

!**************
!     print *, "ch4 slope, int = ", Nbb_4, space_rad_4, ir_linear_slope_new(4,ii),   &
!                                   ir_linear_intercept_new(4,ii)
!     print *, "ch5 slope, int = ", Nbb_5, space_rad_5, ir_linear_slope_new(5,ii),   &
!                                   ir_linear_intercept_new(5,ii)
!***************

     else
        valid_new_therm_cal = .false.
     endif

 end do scans_per_record_loop

end subroutine COMPUTE_NEW_THERM_CAL_COEF_KLM

!--------------------------------------------------------------------------
! COMPUTE_PIXEL_ARRAYS
!
! compute quantities needed for other routines, (ie cloud mask)
!
! input - none
!
! output - only into shared memory
!   seczen - secant of zenith angle
!   sst_mask - an sst used for cloud masking only
!   bt45 - brightness temperature difference between bt4 and bt5 
!   bt3b4 - brightness temperature difference between bt3b and bt4 
!   alb21 - ratio of alb2 / alb1
!   alb3a1 - ratio of alb3a / alb1
!   ndvi - (alb2  - alb1)/(alb2 + alb1)
!   nddi - (alb3a - alb1)/(alb3a - alb1) - ndvi
!   ndsi - (alb1 - alb3a)/(alb3a + alb1) 
!--------------------------------------------------------------------------
 subroutine COMPUTE_PIXEL_ARRAYS()

   integer(kind=int4):: j

 
   coszen = cos(satzen*dtor)

   seczen = 1.0 / coszen

   cossolzen = cos(solzen*dtor)

   sst_mask = b1_day_mask*bt4 + b2_day_mask*(bt4-bt5) +  &
            b3_day_mask*(bt4-bt5)*(seczen-1.0) - b4_day_mask + 273.15



   bt45 = bt4 - bt5

   alb21 = missing_value_real4
   where (alb1 > 0)
     alb21 = alb2 / alb1
   endwhere


   ndvi = missing_value_real4
   where((solzen < 89.5) .and. (alb1+alb2 > 0.0))
    ndvi  = (alb2 - alb1)/(alb2+alb1)
   endwhere

!--- ch3a/3b specific
   nddi = missing_value_real4
   ndsi = missing_value_real4
   bt3b4 = missing_value_real4
   bt3b5 = missing_value_real4
   alb3a1 = missing_value_real4
   do j = 1,2
    if (ch3a_on(j) == 0) then
     bt3b4(:,j) = bt3b(:,j) - bt4(:,j)
     bt3b5(:,j) = bt3b(:,j) - bt5(:,j)
    endif
    if (ch3a_on(j) == 1) then
     where(solzen(:,j) < 89.5 .and. ndvi(:,j) /= missing_value_real4)
      nddi(:,j) = (alb3a(:,j)-alb1(:,j))/(alb3a(:,j)+alb1(:,j)) - ndvi(:,j)
      ndsi(:,j) = (alb1(:,j)-alb3a(:,j))/(alb3a(:,j)+alb1(:,j))
      alb3a1(:,j) = alb3a(:,j)/alb1(:,j)
     endwhere
    endif
   enddo

 end subroutine COMPUTE_PIXEL_ARRAYS

!----------------------------------------------------------------------
! Compute Channel3b albedo
!
! input
!    ch3a_on - 0 if ch3b is on, 1 if ch3a is on
!    A0,B0,C0 - parameters to compute ch3b emission brightness temp.
!    sun_earth_distance - sun-earth distance factor
!    rad3b - vector of ch3b radiance (mW/m^2/str/cm^1)
!    bt4 - vector of ch4 brightness temp. (K)
!    bt5 - vector of ch5 brightness temp. (K)
!    solzen - vector of solar zenith angles (degrees)
!
!  output (passed through shared memory)
!    alb3b_mask - ch3b albedo computed using CLAVR-1 formulation
!    alb3b - ch3b albedo computed using standard ch4 based method
!    ems3b - ch3b emissivity computed using standrad ch3 based method
!
!  internal
!    T0 - ch3b emission brightness temp.
!    rad3b_ems - ch3b emission radiance (mW/m^2/str/cm^-1)
!
! Revision History
!   January 2003 - A. Heidinger
!-----------------------------------------------------------------------
subroutine CH3B_ALB(A0,B0,C0,sun_earth_distance)
  real(kind=real4), intent(in):: A0,B0,C0,sun_earth_distance
  integer:: j 
  
  do j = 1,2 
!---- compute channel 3b albedo
    if (ch3a_on(j) == 0) then

      where(bt45(:,j) > 1.0)
        T0(:,j) = A0 + B0*bt4(:,j) + C0*bt45(:,j)
      elsewhere
       T0(:,j) = bt4(:,j)
      end where

      where(bt4(:,j) > 0.00)
       rad3b_ems(:,j) = c1*(nu_3b**3)/(exp((c2*nu_3b)/ &
                              ((T0(:,j)-a1_3b)/a2_3b))-1.0)
       ems3b(:,j) = rad3b(:,j) / rad3b_ems(:,j)
      elsewhere
       rad3b_ems(:,j) = 0.00
       ems3b(:,j) = 0.0
      end where

      where ((solzen(:,j)<90.0).and.(rad3b_ems(:,j)>0.0).and.(rad3b(:,j)>0.0))
         alb3b(:,j) = 100.0*pi*(rad3b(:,j)-rad3b_ems(:,j)) /  &
               ((solar_3b_nu*cossolzen(:,j))/(sun_earth_distance**2) - &
                  pi*rad3b_ems(:,j) )
         alb3b_mask(:,j) =  100.0*pi*(rad3b(:,j) - rad3b_ems(:,j))/ &
                  ((solar_3b_nu*cossolzen(:,j))/(sun_earth_distance**2))

      end where
      where ((solzen(:,j)>=90.0).and.(ems3b(:,j)>0.0))
         alb3b(:,j) = 100.0*(1.0-ems3b(:,j))
         alb3b_mask(:,j) = 100.0*(1.0-ems3b(:,j))
      end where

    else
      rad3b_ems(:,j) = missing_value_real4
      alb3b(:,j) = missing_value_real4
      ems3b(:,j) = missing_value_real4
    endif

   end do

end subroutine CH3B_ALB

!-----------------------------------------------------------
! routine to compute ice surface temperature
! taken from Key et al (1997)
!------------------------------------------------------------
subroutine COMPUTE_ICE_SURFACE_TEMP()

 ist = missing_value_real4

if (lat(26,1) > 0.0) then
!-- compute assuming mid range coefficients
 ist = a_ist_art_mid + b_ist_art_mid * bt4  + c_ist_art_mid*(bt4-bt5) + &
       d_ist_art_mid * (bt4 - bt5) * (seczen -1)

!--- refine using correct coefficients
 where (ist < 240.0)
   ist = a_ist_art_low + b_ist_art_low * bt4  + c_ist_art_low*(bt4-bt5) + &
       d_ist_art_low * (bt4 - bt5) * (seczen -1)
 end where
 where (ist > 260.0)
   ist = a_ist_art_hi + b_ist_art_hi * bt4  + c_ist_art_hi*(bt4-bt5) + &
       d_ist_art_hi * (bt4 - bt5) * (seczen -1)
 end where
else
!-- compute assuming mid range coefficients
 ist = a_ist_ant_mid + b_ist_ant_mid * bt4  + c_ist_ant_mid*(bt4-bt5) + &
       d_ist_ant_mid * (bt4 - bt5) * (seczen -1)

!--- refine using correct coefficients
 where (ist < 240.0)
   ist = a_ist_ant_low + b_ist_ant_low * bt4  + c_ist_ant_low*(bt4-bt5) + &
       d_ist_ant_low * (bt4 - bt5) * (seczen -1)
 end where
 where(ist > 260.0)
   ist = a_ist_ant_hi + b_ist_ant_hi * bt4  + c_ist_ant_hi*(bt4-bt5) + &
       d_ist_ant_hi * (bt4 - bt5) * (seczen -1)
 end where
endif

end subroutine COMPUTE_ICE_SURFACE_TEMP
!-----------------------------------------------------------
! routine to compute ice-free land surface temperature
! taken from Key et al (1997)
!------------------------------------------------------------
subroutine COMPUTE_LAND_SURFACE_TEMP()

 lst = missing_value_real4

!----- until a surface emissivity algorithm exists
 ems4 = 0.98
 ems5 = 0.98

!-- compute assuming mid range coefficients
 lst = a_lst_mid + b_lst_mid * bt4  + c_lst_mid*bt5 + &
       d_lst_mid *ems4 + e_lst_mid*ems5

!--- refine using correct coefficients
 where (lst < 240.0)
   lst = a_lst_low + b_lst_low * bt4  + c_lst_low*bt5 + &
         d_lst_low*ems4 + e_lst_low*ems5
 end where
 where (lst > 260.0)
   lst = a_lst_hi + b_lst_hi*bt4  + c_lst_hi*bt5 + &
         d_lst_hi*ems4 + e_lst_hi*ems5
 end where

end subroutine COMPUTE_LAND_SURFACE_TEMP

!---------------------------------------------------------------
! routine to compute SST
! output:
! sst  - sea surface temperature in (K)
! input:
! ch3a_on
! bt3b
!---------------------------------------------------------------
 subroutine COASTWATCH_SST()

  integer:: j

  sst = missing_value_real4

  do j = 1,2
    if (ch3a_on(j) == 0) then
     where(solzen(:,j) < 87.0)
      sst(:,j) = b1_day*bt4(:,j) + b2_day*(bt45(:,j)) +  &
               b3_day*(bt45(:,j))*(seczen(:,j)-1.0) - b4_day + 273.15
     elsewhere
      sst(:,j) = b1_night*bt4(:,j) + b2_night*(bt45(:,j)) +  &
               b3_night*(bt45(:,j))*(seczen(:,j)-1.0) - b4_night + 273.15
     endwhere
    else
      sst(:,j) = b1_day*bt4(:,j) + b2_day*(bt45(:,j)) +  &
               b3_day*(bt45(:,j))*(seczen(:,j)-1.0) - b4_day + 273.15
    endif
  enddo

end subroutine COASTWATCH_SST
!----------------------------------------------------------------
! read the avhrr constants into memory
!-----------------------------------------------------------------
subroutine READ_AVHRR_INSTR_CONSTANTS(instr_const_file)
 character(len=*), intent(in):: instr_const_file
  print *,"PROCESS_AVHRR unit 7 read"
  print *,"const file = ", trim(instr_const_file)
  open(unit=7,file=trim(instr_const_file),status="old",position="rewind",action="read")
  read(unit=7,fmt="(a3)") sat_name
  read(unit=7,fmt=*) solar_3b
  read(unit=7,fmt=*) ew_3b
  read(unit=7,fmt=*) a_3b, b_3b, d_3b, space_rad_3b
  read(unit=7,fmt=*) a_4, b_4, d_4, space_rad_4
  read(unit=7,fmt=*) a_5, b_5, d_5, space_rad_5
  read(unit=7,fmt=*) nu_3b
  read(unit=7,fmt=*) a1_3b
  read(unit=7,fmt=*) a2_3b
  read(unit=7,fmt=*) nu_4
  read(unit=7,fmt=*) a1_4
  read(unit=7,fmt=*) a2_4
  read(unit=7,fmt=*) nu_5
  read(unit=7,fmt=*) a1_5
  read(unit=7,fmt=*) a2_5
  read(unit=7,fmt=*) A0
  read(unit=7,fmt=*) B0
  read(unit=7,fmt=*) C0
  read(unit=7,fmt=*) ch1_dark_count
  read(unit=7,fmt=*) ch2_dark_count
  read(unit=7,fmt=*) ch3a_dark_count
  read(unit=7,fmt=*) ch1_gain_low_0,ch1_degrad_low
  read(unit=7,fmt=*) ch1_gain_high_0,ch1_degrad_high
  read(unit=7,fmt=*) ch2_gain_low_0,ch2_degrad_low
  read(unit=7,fmt=*) ch2_gain_high_0,ch2_degrad_high
  read(unit=7,fmt=*) ch3a_gain_low_0,ch3a_degrad_low
  read(unit=7,fmt=*) ch3a_gain_high_0,ch3a_degrad_high
  read(unit=7,fmt=*) launch_date
  read(unit=7,fmt=*) ch1_switch_count
  read(unit=7,fmt=*) ch2_switch_count
  read(unit=7,fmt=*) ch3a_switch_count
  read(unit=7,fmt=*) prt_coef(:,1)
  read(unit=7,fmt=*) prt_coef(:,2)
  read(unit=7,fmt=*) prt_coef(:,3)
  read(unit=7,fmt=*) prt_coef(:,4)
  read(unit=7,fmt=*) prt_weight(:)
  read(unit=7,fmt=*) b1_day_mask,b2_day_mask,b3_day_mask,b4_day_mask
  close(unit=7)

!------ define plank constants here as well
  c1 = 1.191062e-5
  c2 = 1.4387863

!-- convert solar flux in channel 3b to mean with units mW/m^2/cm^-1
  solar_3b_nu = 1000.0 * solar_3b / ew_3b

end subroutine READ_AVHRR_INSTR_CONSTANTS
!----------------------------------------------------------------
! read the avhrr algorithm constants into memory
!-----------------------------------------------------------------
subroutine READ_AVHRR_ALGO_CONSTANTS(algo_const_file)
 character(len=*), intent(in):: algo_const_file
  print *,"PROCESS_AVHRR unit 7 read"
  print *,"algorithm const file = ", trim(algo_const_file)
  open(unit=7,file=trim(algo_const_file),status="old",position="rewind",action="read")
  read(unit=7,fmt=*) b1_day,b2_day,b3_day,b4_day
  read(unit=7,fmt=*) b1_night,b2_night,b3_night,b4_night
  read(unit=7,fmt=*) a_ist_art_low,b_ist_art_low,c_ist_art_low,d_ist_art_low
  read(unit=7,fmt=*) a_ist_art_mid,b_ist_art_mid,c_ist_art_mid,d_ist_art_mid
  read(unit=7,fmt=*) a_ist_art_hi,b_ist_art_hi,c_ist_art_hi,d_ist_art_hi
  read(unit=7,fmt=*) a_ist_ant_low,b_ist_ant_low,c_ist_ant_low,d_ist_ant_low
  read(unit=7,fmt=*) a_ist_ant_mid,b_ist_ant_mid,c_ist_ant_mid,d_ist_ant_mid
  read(unit=7,fmt=*) a_ist_ant_hi,b_ist_ant_hi,c_ist_ant_hi,d_ist_ant_hi
  read(unit=7,fmt=*) a_lst_low,b_lst_low,c_lst_low,d_lst_low,e_lst_low
  read(unit=7,fmt=*) a_lst_mid,b_lst_mid,c_lst_mid,d_lst_mid,e_lst_mid
  read(unit=7,fmt=*) a_lst_hi,b_lst_hi,c_lst_hi,d_lst_hi,e_lst_hi
  close(unit=7)
end subroutine READ_AVHRR_ALGO_CONSTANTS

!--------------------------------------------
! compute the month
!---------------------------------------------
 function COMPUTE_MONTH(jday) result(month)
   integer(kind=int2), intent(in):: jday
   integer(kind=int2):: month



   month = 0
   if (jday < 32) then
     month = 1
   elseif (jday < 61) then
     month = 2
   elseif (jday < 91) then
     month = 3
   elseif (jday < 121) then
     month = 4 
   elseif (jday < 152) then
     month = 5 
   elseif (jday < 182) then
     month = 6 
   elseif (jday < 213) then
     month = 7 
   elseif (jday < 244) then
     month = 8 
   elseif (jday < 274) then
     month = 9 
   elseif (jday < 305) then
     month = 10 
   elseif (jday < 335) then
     month = 11 
   else
     month = 12
   endif

 end function COMPUTE_MONTH
  
!-----------------------------------------------------------------
! functions to convert 1 byte integers into 2 or 4 byte integers
! if the integeris signed (isign = 0) then the first byte
! remains signed
!---------------------------------------------------------------- 
 function make_i2word(byte1,isign) result(i2word)
  integer(kind=int1), intent(in), dimension(:):: byte1
  integer, intent(in):: isign
  integer(kind=int2):: i2word
  integer(kind=int2), dimension(size(byte1)):: byte2
  integer:: i
   byte2 = byte1
   if ((byte2(1) < 0) .and. (isign == 0)) then
     byte2(1) = byte2(1) + 256
   endif
   do i = 2,size(byte2)
    if ((byte2(i) < 0)) then
     byte2(i) = byte2(i) + 256
    end if
   end do
   i2word = byte2(1)*256 + byte2(2)
 end function make_i2word

 function make_i4word(byte1,isign) result(i4word)
  integer(kind=int1), intent(in), dimension(:):: byte1
  integer, intent(in):: isign
  integer(kind=int4):: i4word
  integer(kind=int2), dimension(size(byte1)):: byte2
  integer:: i
   byte2 = byte1
   if ((byte2(1) < 0) .and. (isign == 0)) then
     byte2(1) = byte2(1) + 256
   endif
   do i = 2,size(byte2)
    if ((byte2(i) < 0)) then
     byte2(i) = byte2(i) + 256
    end if
   end do
   i4word = byte2(1)*(256**3) + byte2(2)*(256**2) + byte2(3)*256 +  byte2(4)
 end function make_i4word


 function i4word_to_string(i4word,n) result(char_word)
    integer(kind=int4), intent(in):: i4word
    integer, intent(in):: n
    character(len=n):: char_word
    integer(kind=int4):: i4temp
    integer:: i

    i4temp = i4word
    char_word = ""
    do i = 1,n
     char_word(i:i) = char(i4temp/(10**(n-i))+48)
     i4temp = i4temp - 10**(n-i)*(i4temp / (10**(n-i)))
    enddo
 end function i4word_to_string

!------------------------------------------------------------------------------
! NOAA 15+ unpack avhrr header record - routine should work for lac and gac
!------------------------------------------------------------------------------
subroutine unpack_avhrr_header_record_klm(sc_id,data_type,start_year,&
              start_day,start_time,num_scans,end_year,end_day,end_time, &
              tip_parity,aux_sync,ramp_auto_cal,proc_block_id)

   integer(kind=int2), intent(out):: sc_id,data_type,start_year,start_day, &
                                     end_year,end_day,num_scans, &
                                     tip_parity,aux_sync,ramp_auto_cal
   integer(kind=int4), intent(out):: start_time,end_time
   character(len=*), intent(out):: proc_block_id
   integer:: i


   sc_id = buffer(73)*256 + buffer(74)
   data_type = buffer(77)*256 + buffer(78)
   do i = 1,len(proc_block_id)
    proc_block_id(i:i) =  char(buffer(66+(i-1)))
   end do 

!----------------------------------------------------------------------
! unpack starting time
!----------------------------------------------------------------------
      start_year = make_i2word(buffer(85:86),0)
      start_day = make_i2word(buffer(87:88),0)
      start_time = make_i4word(buffer(89:92),0)
   
!----------------------------------------------------------------------
! unpack  number of scan lines
!----------------------------------------------------------------------
      num_scans = make_i2word(buffer(131:132),0)

!----------------------------------------------------------------------
! unpack end time
!----------------------------------------------------------------------
      end_year = make_i2word(buffer(97:98),0)
      end_day = make_i2word(buffer(99:100),0)
      end_time = make_i4word(buffer(101:104),0)

!----------------------------------------------------------------------
! unpack quality indicators
!-----------------------------------------------------------------------
      tip_parity = make_i2word(buffer(139:140),0)
      aux_sync = make_i2word(buffer(141:142),0)
      ramp_auto_cal =  make_i2word(buffer(187:188),0)

 end subroutine unpack_avhrr_header_record_klm
!------------------------------------------------------------------------------
! unpack avhrr header record - routine should work for lac and gac
!------------------------------------------------------------------------------
subroutine unpack_avhrr_header_record(sc_id,data_type,start_year,&
              start_day,start_time,num_scans,end_year,end_day,end_time, &
              tip_parity,aux_sync,ramp_auto_cal,proc_block_id)

   integer(kind=int2), intent(out):: sc_id,data_type,start_year,start_day, &
                                     end_year,end_day,num_scans, &
                                     tip_parity,aux_sync,ramp_auto_cal
   integer(kind=int4), intent(out):: start_time,end_time
   character(len=*), intent(out):: proc_block_id
   integer(kind=int4):: i4word
   integer(kind=int2), dimension(4):: data_byte
   integer:: i
     

   sc_id = buffer(1)
   data_type = ishft(buffer(2),-4)

   tip_parity = 0
   aux_sync = 0
   ramp_auto_cal = 0

!----------------------------------------------------------------------
! unpack starting time
!----------------------------------------------------------------------
      data_byte(1) = buffer(3)
      data_byte(2) = buffer(4)
      where (data_byte < 0)
         data_byte = data_byte + 256
      end where
      i4word =  data_byte(1)*256 + data_byte(2)
      start_year = i4word / (2**9)
      start_day = i4word - start_year * (2**9)

      i4word = make_i4word(buffer(5:8),0)
      start_time = i4word - ((i4word/2**27)*(2**27))

!---------------------------------------------------------------------
! unpack processing block id
!---------------------------------------------------------------------
   do i = 1,len(proc_block_id)
    proc_block_id(i:i) =  char(buffer(17+(i-1)))
   end do 
       
!----------------------------------------------------------------------
! unpack  number of scan lines
!----------------------------------------------------------------------
      num_scans = make_i2word(buffer(9:10),0)

!----------------------------------------------------------------------
! unpack end time
!----------------------------------------------------------------------
      data_byte(1) = buffer(11)
      data_byte(2) = buffer(12)
      where (data_byte < 0)
         data_byte = data_byte + 256
      end where
      i4word =  data_byte(1)*256 + data_byte(2)
      end_year = i4word / (2**9)
      end_day = i4word - start_year * (2**9)

      i4word = make_i4word(buffer(13:16),0)
      end_time = i4word - ((i4word/2**27)*(2**27))

!----------------------------------------------------------------------
! unpack quality indicators
!-----------------------------------------------------------------------
!     tip_parity = make_i2word(buffer(139:140),0)
!     aux_sync = make_i2word(buffer(141:142),0)
!     ramp_auto_cal =  make_i2word(buffer(187:188),0)

 end subroutine unpack_avhrr_header_record

!-------------------------------------------------------------------------------
! to use for gac data:
!  1. set gac to true
!  2. read the AVHRR 1B data records directly into buffer
!
! to use for lac data:
!  1. set gac to false
!  2. combine the two  data-records from the AVHRR 1B file  into buffer
!-------------------------------------------------------------------------------
 subroutine unpack_avhrr_data_record(gac,scan_number,resync,fatal,ascend, &
                                     year,day,time,num_loc)
   logical, intent(in):: gac
   integer(kind=int1), dimension(:), intent(out)::fatal,ascend,resync
   integer(kind=int2), dimension(:), intent(out)::scan_number,year,day
   integer(kind=int4), dimension(:), intent(out)::time
   integer(kind=int2), intent(out):: num_loc

   integer(kind=int2), dimension(4):: data_byte
   integer(kind=int2):: i2word
   integer(kind=int4):: i4word
   integer(kind=int2):: byte_offset,num_data_bytes,scans_per_record,num_chan, &
                        num_pix
   integer:: ichan, ipix, j, ibyte, ii

!-------------------------------------------------------------------------------
! set parameters for gac or lac processing
!-------------------------------------------------------------------------------
   if (gac .eqv. .true.) then
      byte_offset = size(buffer) / 2
      num_data_bytes = 2728
      scans_per_record = 2
      num_pix = 3*(num_data_bytes/4)/5
    else
      byte_offset =  size(buffer) / 2
      num_data_bytes = 6952 + 6704
      scans_per_record = 2
      num_pix = 3*(num_data_bytes/4)/5
   endif
   num_chan = size(chan_counts,1)

!---------------------------------------------------------------
! loop through scanlines on each data-record
!---------------------------------------------------------------
 do ii = 1,scans_per_record

!----------------------------------------------------------------
! unpack scan line number
!----------------------------------------------------------------
      scan_number(ii) = make_i2word(buffer(1+(ii-1)*byte_offset:2+(ii-1)*byte_offset),0)
!     write(unit=6,fmt="(b8)") buffer(1)
!     write(unit=6,fmt="(b8)") buffer(2)

!----------------------------------------------------------------------
! unpack time code
!----------------------------------------------------------------------
!     i2word = make_i2word(buffer(3+(ii-1)*byte_offset:4+(ii-1)*byte_offset),0)
!     year(ii) = i2word / (2**9)
!     day(ii) = i2word - year(ii) * (2**9)

      data_byte(1) = buffer(3+(ii-1)*byte_offset)
      data_byte(2) = buffer(4+(ii-1)*byte_offset)
      where (data_byte < 0)
         data_byte = data_byte + 256
      end where
      i4word =  data_byte(1)*256 + data_byte(2)
      year(ii) = i4word / (2**9)
      day(ii) = i4word - year(ii) * (2**9)

      i4word = make_i4word(buffer(5+(ii-1)*byte_offset:8+(ii-1)*byte_offset),0)
      time(ii) = i4word - ((i4word/2**27)*(2**27))
!----------------------------------------------------------------------
! unpack quality indicators - not done fully
!----------------------------------------------------------------------
   i2word = buffer(9+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   fatal(ii) = ishft(i2word, -7)

   i2word = buffer(9+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   ascend(ii) = ishft(ishft(i2word, 6),-7)


!--- this might be wrong
   i2word = buffer(10+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   resync(ii) = ishft(ishft(i2word, 0),-7)
   
!----------------------------------------------------------------------
! unpack calibration coefficients
!----------------------------------------------------------------------
    ichan = 1
    do ibyte = 13+(ii-1)*byte_offset,52+(ii-1)*byte_offset,8
     slope(ichan,ii) = make_i4word(buffer(ibyte:ibyte+3),1) / (2.0**30)
     intercept(ichan,ii) = make_i4word(buffer(ibyte+4:ibyte+7),1) / (2.0**22)
     ichan = ichan + 1
    enddo

!----------------------------------------------
! mimic noaa klm type calibration coefficients
!----------------------------------------------
    vis_slope_1(1,ii) = slope(1,ii)   !high gain is same as low gain
    vis_slope_1(2,ii) = slope(2,ii)   !high gain is same as low gain
    vis_slope_1(3,ii) = 0.0           !no channel 3a
    vis_slope_2(:,ii) = vis_slope_1(:,ii)   !high gain is same as low gain
    vis_intercept_2(:,ii) = vis_intercept_1(:,ii)   !high gain intercept same as low
    vis_intersection(:,ii) = 1024     !these values are ignored

    ir_linear_slope_1b(3,ii) = slope(3,ii)
    ir_linear_slope_1b(4,ii) = slope(4,ii)
    ir_linear_slope_1b(5,ii) = slope(5,ii)

    ir_linear_intercept_1b(3,ii) = intercept(3,ii)
    ir_linear_intercept_1b(4,ii) = intercept(4,ii)
    ir_linear_intercept_1b(5,ii) = intercept(5,ii)


!----------------------------------------------------------------------
! unpack geolocation coefficients
!----------------------------------------------------------------------
    num_loc = buffer(53+(ii-1)*byte_offset)

!----------------------------------------------------------------------
! unpack solar zenith angle data - treating as unsigned integer
!----------------------------------------------------------------------
      do ibyte = 54+(ii-1)*byte_offset,104+(ii-1)*byte_offset
        j = ibyte - (53 + (ii-1)*byte_offset)
        solzen_anchor(j,ii) = buffer(ibyte) / 2.0
      enddo
!----------------------------------------------------------------------
! unpack earth location
!----------------------------------------------------------------------
      j = 1
      do ibyte = 105+(ii-1)*byte_offset,308+(ii-1)*byte_offset,4
        lat_anchor(j,ii) = make_i2word(buffer(ibyte:ibyte+1),1) / 128.0
        lon_anchor(j,ii) = make_i2word(buffer(ibyte+2:ibyte+3),1) / 128.0
        j = j + 1
      enddo

!-- make sure longitudes are correct ( ?? check this)
      where (lon_anchor > 180)
         lon_anchor = lon_anchor - 360.0
      end where

!----------------------------------------------------------------------
! unpack channel  data
!----------------------------------------------------------------------
   ichan = 1
   ipix = 1

   do ibyte = 449+(ii-1)*byte_offset,448+num_data_bytes+(ii-1)*byte_offset,4
      i4word = make_i4word(buffer(ibyte:ibyte+3),0)
      do j = 1,3
       if (ipix > num_pix) then
            exit
       endif

       chan_counts(ichan,ipix,ii) = i4word/ (1024**(3-j))

       i4word = i4word - chan_counts(ichan,ipix,ii)*(1024**(3-j))

       ichan = ichan + 1
        if (ichan > num_chan) then
          ichan = 1
          ipix = ipix + 1
 !        if (ipix > num_pix) then
 !           exit
 !        endif
        endif
      enddo
      if (ipix > num_pix) then
            exit
       endif

     enddo
   enddo

  end subroutine unpack_avhrr_data_record

!---------------------------------------------------------------------
! COMPUTE THE GLINT ZENITH ANGLE
!
! input
!  solzen - vector of solar zenith angle (degrees)
!  satzen - vector of satellite view zenith angle (degrees)
!  relaz - vector of relative azimuth angle (degrees)
!
! output
!  glintzen - vector of glint zenith angle (degrees)
!
! revision history:
!    january 2003 - coded by A. Heidinger
!---------------------------------------------------------------------
  subroutine COMPUTE_GLINTZEN(solzen,satzen,relaz,glintzen)
   real(kind=real4), dimension(:), intent(in):: solzen,satzen,relaz
   real(kind=real4), dimension(:), intent(out):: glintzen

!--- compute the cosine of the glint zenith angle
   glintzen = cos(solzen*dtor)*cos(satzen*dtor) +    &
              sin(solzen*dtor)*sin(satzen*dtor)*cos(relaz*dtor)

!--- constrain it to fall within expected bounds
   glintzen = max(-1.0,min(glintzen,1.0))

!--- convert to angle (degrees)
   glintzen = acos(glintzen) / dtor


  end subroutine COMPUTE_GLINTZEN
!---------------------------------------------------------------------
! ANCHOR INTERPOLATION ROUTINES
!---------------------------------------------------------------------
! anchor - the set of anchor points
! temp_anchor - the set of anchor points modified for dateline if necessary
! xa - position of an anchor in pix space (for gac 1-409)
! ia - index of an anchor point (1-51)
! ipix - index of a pixel point (1-409 or 2048)
! num_start - pixel location of first anchor point
! num_skip - number of pixels between anchor points
! num_anchor - number of anchor points (always 51)
! num_pix - number of pixels in scan
! x - pixel position for which y(ipix) is computed
! m - number of points in lagranian interp (order is 2m+1)
!---------------------------------------------------------------------
 subroutine LAGRANGIAN_ANCHOR_INTERP(anchor,y)
   real (kind=ipre), dimension(:), intent(in):: anchor
   real (kind=ipre), dimension(:), intent(out):: y
   real(kind=ipre), dimension(size(anchor)):: temp_anchor
   real (kind=ipre):: x,L,xa_i,xa_j
   integer:: m,i,j,ia,ia1,ia2,ipix,num_anchor, &
             num_pix,num_skip,num_start
   logical:: discon

   m = 2    !2 means 5 point interp

   num_anchor = size(anchor,1)  !should be 51

   num_pix = size(y,1)    !depends on lac or gac(409)

   num_skip = num_pix / num_anchor    !number of pixels between anchors
   num_start = (num_pix - num_skip*(num_anchor-1))/2 + 1 !pixel number for first
                                                         !anchor point

!--- initialize
   y = 0.0
   temp_anchor = anchor

!-------- check for a discontinuity (ie. crossing dateline)
    discon = .false.
    if ((minval(temp_anchor) < -175.0).and.(maxval(temp_anchor) > 175.0)) then 
     discon = .true. 
     where (temp_anchor < 0.0)
        temp_anchor =  temp_anchor + 360.0
     endwhere
    endif

!-- perform 2m+1 point Lagrangian interpolation
      do ipix = 1, num_pix
         ia = (ipix - num_start)/num_skip + 1
         ia1 =  min(num_anchor,max(1,ia-m))
         ia2 =  max(1,min(num_anchor,ia+m))

         x = ipix

         do i = ia1,ia2
           L = 1.0
           xa_i = (i-1)*(num_skip) + num_start
           do j = ia1,ia2
           xa_j = (j-1)*(num_skip) + num_start
            if (i /= j) then
              L = L * (x - xa_j)/(xa_i-xa_j)
            endif
          enddo
          y(ipix) = y(ipix) + L*temp_anchor(i)
         enddo

      enddo

!----- account for discontinuity if there was one
  if (discon .eqv. .true.) then
   where(y > 180.0)
    y = y - 360.0
   endwhere
  endif

 end subroutine LAGRANGIAN_ANCHOR_INTERP

!---------------------------------------------------------------------
! linear interpolation routine
!---------------------------------------------------------------------
 subroutine linear_anchor_interp(anchor,y)
   real (kind=ipre), dimension(:), intent(in):: anchor
   real (kind=ipre), dimension(:), intent(out):: y
   real (kind=ipre), dimension(size(anchor)):: temp_anchor
   real (kind=ipre):: x,xa1,xa2
   integer:: ia1,ia2,ipix,num_anchor,num_pix,num_skip,num_start
   logical:: discon

   num_anchor = size(anchor)  !should be 51
   num_pix = size(y)    !depends on lac or gac(409)
   num_skip = num_pix / num_anchor
   num_start = (num_pix - num_skip*(num_anchor-1))/2 + 1

!--- initialize
     y = 0.0
     temp_anchor = anchor

!-------- check for a discontinuity (ie. crossing dateline)
    discon = .false.
    if ((minval(temp_anchor) < -175.0).and.(maxval(temp_anchor) > 175.0)) then 
     discon = .true. 
     where( temp_anchor < 0.0)
        temp_anchor =  temp_anchor + 360.0
     endwhere
    endif

!-----------------------------------------------------------
      do ipix = 1, num_pix
         ia1 = max(1,min(num_anchor-1,(ipix - num_start)/num_skip + 1))
         ia2 = ia1 + 1

         xa1 = (ia1-1)*(num_skip) + num_start
         xa2 = (ia2-1)*(num_skip) + num_start

         x = ipix

         y(ipix) = (x-xa1)*(temp_anchor(ia2)-temp_anchor(ia1))/(xa2-xa1) +  &
                   temp_anchor(ia1)

      enddo

!----- account for discontinuity if there was one
  if (discon .eqv. .true.) then
   where (y > 180.0)
    y = y - 360.0
   endwhere
  endif

  end subroutine linear_anchor_interp

!-------------------------------------------------------------------------------
! COMPUTE_ANGLE_ANCHORS
!
! input
!   jday -  Julian Day
!   time - time of day
!   lon - vector of longitude (degrees)
!   lat - vector of latitude (degrees)
!
! output
!   satzen - vector of satellite view zenith angles (degrees)
!   solzen - vector of solar zenith angles (degrees)
!   relaz - vector of relative azimuth angles
! 
! Revision History
!   Jan 2003 - Coded A. Heidinger (Based on CLAVR-1 code)   
!
! note - relaz is the relative azimuth defined as this
!   relaz = 180 means the sun is behind you (backscatter)
!   relaz = 0 mean the sun is infront of you (forward scatter)
!   this is convention used in noaa-klm relaz but not in clavr-1
!-------------------------------------------------------------------------------
   subroutine COMPUTE_ANGLE_ANCHORS(jday,time,lon,lat,satzen,solzen,relaz)
     integer(kind=int2), intent(in):: jday
     integer(kind=int4), intent(in):: time
     real(kind=ipre), dimension(:), intent(in):: lon, lat
     real(kind=ipre), dimension(:), intent(out):: satzen, solzen, relaz
     integer:: i,n,jday4
     real(kind=real4):: frac_time,solaz,lat_center,lon_center,solzen_center
     real(kind=real8):: cosgeo,psix,geox,numor,denom,cos_solzen


      frac_time = time / (60.0*60.0*1000.0)
      n = size(lon)
     jday4 = jday

!-------------------------------------------------
! solar zenith angle
!-------------------------------------------------
      do i = 1, n
       call POSSOL(jday4,frac_time,lon(i),lat(i),solzen(i),solaz)
      enddo

!---- relative azimuth and satellite zenith angle
      do i = 1,n
       lat_center = lat(26)
       lon_center = lon(26)
       solzen_center = solzen(26)
       cosgeo = cos(lat(i)*dtor)*cos(lat_center*dtor)*cos((lon(i)-lon_center)*dtor) + &
                sin(lat(i)*dtor)*sin(lat_center*dtor)
       cosgeo = max(-1.0_real8,min(1.0_real8,cosgeo))
       geox = acos(cosgeo)
       cos_solzen = cos(solzen(i)*dtor)
       numor= cosgeo*cos_solzen - cos(solzen_center*dtor)
       denom = sin(geox)* sqrt(1.0-cos_solzen**2)
       if (denom == 0.0) then
            psix = 1.0
       else
            psix = numor/denom
       endif
       psix = max(-1.0_real8,min(1.0_real8,psix))
       relaz(i) = acos(psix)/dtor
       satzen(i) = geox/dtor + abs(26-i)*2.16512

      enddo

 end subroutine COMPUTE_ANGLE_ANCHORS

!-------------------------------------------------------------------------------
! to use for gac data:
!  1. set gac to true
!  2. read the AVHRR 1B data records directly into buffer
!
! to use for lac data:
!  1. set gac to false
!  2. combine the two  data-records from the AVHRR 1B file  into buffer
!-------------------------------------------------------------------------------
 subroutine unpack_avhrr_data_record_klm(gac,scan_number, &
                                     ch3a_on, resync, fatal, ascend, &
                                     year,day,time,num_loc)
   logical, intent(in):: gac
   integer(kind=int1), dimension(:), intent(out)::fatal,ascend,ch3a_on,resync
   integer(kind=int2), dimension(:), intent(out)::scan_number,year,day
   integer(kind=int4), dimension(:), intent(out)::time

   integer(kind=int2), intent(out):: num_loc

   integer(kind=int4):: i4word
   integer(kind=int2):: byte_offset,num_data_bytes,scans_per_record,num_chan, &
                        num_pix,i2word,num_clavr_bytes,num_digtel_bytes,num_house_bytes, &
                        start_pixel,end_pixel
   integer:: ichan, ipix, i,j, ibyte,ii,iword,start_word,end_word,word_clavr_start
   integer(kind=int1):: onebyte


!-------------------------------------------------------------------------------
! set parameters for gac or lac processing
!-------------------------------------------------------------------------------
   if (gac .eqv. .true.) then
      byte_offset = size(buffer) / 2
!     num_data_bytes = 2728
      num_data_bytes = 4000 - 1265 + 1
      num_digtel_bytes =  4016 - 4001 + 1
      num_house_bytes =  4048 - 4017 + 1
      num_clavr_bytes = 4160 - 4049 + 1
      scans_per_record = 2
      num_pix = 3*((num_data_bytes-8)/4)/5
    else
      byte_offset =  size(buffer) / 2
!     num_data_bytes = 6952 + 6704
      num_data_bytes = 14928 - 1265
      num_digtel_bytes = 14944 - 14929
      num_house_bytes = 14976 - 14971
      num_clavr_bytes = 15496 - 14977
      scans_per_record = 2
      num_pix = 3*((num_data_bytes-8)/4)/5
   endif
   num_chan = size(chan_counts,1)

   valid_new_therm_cal = .true.
!---------------------------------------------------------------
! loop through scanlines on each data-record
!---------------------------------------------------------------
 scans_per_record_loop: do ii = 1,scans_per_record

!----------------------------------------------------------------
! unpack scan line number
!----------------------------------------------------------------
      scan_number(ii) = make_i2word(buffer(1+(ii-1)*byte_offset:2+(ii-1)*byte_offset),0)
!----------------------------------------------------------------------
! unpack time code
!----------------------------------------------------------------------
      year(ii) = make_i2word(buffer(3+(ii-1)*byte_offset:4+(ii-1)*byte_offset),0)
      day(ii) = make_i2word(buffer(5+(ii-1)*byte_offset:6+(ii-1)*byte_offset),0)
      time(ii) = make_i4word(buffer(9+(ii-1)*byte_offset:12+(ii-1)*byte_offset),0)
!----------------------------------------------------------------------
! unpack quality indicators - not done fully
!----------------------------------------------------------------------
   i2word  = buffer(25+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   fatal(ii) = ishft(i2word, -7)

   i2word  = buffer(13+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   ascend(ii) = ishft( i2word, -7)

   i2word  = buffer(14+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   ch3a_on(ii) = ishft(ishft(i2word, 6),-6)

   i2word  = buffer(28+(ii-1)*byte_offset)
   if (i2word < 0) then
      i2word = i2word + 256
   end if
   resync(ii) = ishft(ishft(i2word, 6),-7)

!---------------------------------------------------------------------
! unpack space view
!---------------------------------------------------------------------
  do j = 1,10
   space_count(1,j)  = make_i2word(buffer(1161+10*(j-1)+(ii-1)*byte_offset:1162+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(2,j) = make_i2word(buffer(1163+10*(j-1)+(ii-1)*byte_offset:1164+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(3,j) = make_i2word(buffer(1165+10*(j-1)+(ii-1)*byte_offset:1166+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(4,j) = make_i2word(buffer(1167+10*(j-1)+(ii-1)*byte_offset:1168+10*(j-1)+(ii-1)*byte_offset),1)
   space_count(5,j)  = make_i2word(buffer(1169+10*(j-1)+(ii-1)*byte_offset:1170+10*(j-1)+(ii-1)*byte_offset),1)
  enddo
  


!----------------------------------------------------------------------
! unpack calibration coefficients
!----------------------------------------------------------------------
  do ichan = 1, 3


    vis_slope_1(ichan,ii) = make_i4word(buffer(49+(ichan-1)*60+(ii-1)*byte_offset: &
                                                    52+(ichan-1)*60+(ii-1)*byte_offset),1) / (10.0**7)

    vis_intercept_1(ichan,ii) = make_i4word(buffer(53+(ichan-1)*60+(ii-1)*byte_offset: &
                                                    56+(ichan-1)*60+(ii-1)*byte_offset),1) / (10.0**6)

    vis_slope_2(ichan,ii) = make_i4word(buffer(57+(ichan-1)*60+(ii-1)*byte_offset: &
                                                    60+(ichan-1)*60+(ii-1)*byte_offset),1) / (10.0**7)


    vis_intercept_2(ichan,ii) = make_i4word(buffer(61+(ichan-1)*60+(ii-1)*byte_offset: &
                                                    64+(ichan-1)*60+(ii-1)*byte_offset),1) / (10.0**6)

    vis_intersection(ichan,ii) = make_i4word(buffer(65+(ichan-1)*60+(ii-1)*byte_offset: &
                                                    68+(ichan-1)*60+(ii-1)*byte_offset),1)
 enddo

 do ichan = 1,3
    ir_coef_1_1b(ichan+2,ii) = make_i4word(buffer(229+(ichan-1)*24+(ii-1)*byte_offset: &
                          232+(ichan-1)*24+(ii-1)*byte_offset),1)/(10.0**6)
    ir_coef_2_1b(ichan+2,ii) = make_i4word(buffer(233+(ichan-1)*24+(ii-1)*byte_offset: &
                          236+(ichan-1)*24+(ii-1)*byte_offset),1) / (10.0**6)
    ir_coef_3_1b(ichan+2,ii) = make_i4word(buffer(237+(ichan-1)*24+(ii-1)*byte_offset: &
                          240+(ichan-1)*24+(ii-1)*byte_offset),1) / (10.0**6)
 enddo

!----------------------------------------------------------------------
! unpack calibration coefficients
!----------------------------------------------------------------------
!   num_loc = buffer(53+(ii-1)*byte_offset)
    num_loc = 51

!----------------------------------------------------------------------
! unpack angle data
!----------------------------------------------------------------------
      do j = 1, 51
        ibyte = 329 + (j-1)*6 + (ii-1)*byte_offset
        solzen_anchor(j,ii) = make_i2word(buffer(ibyte:ibyte+1),1)/(10.0**2)
        satzen_anchor(j,ii) = make_i2word(buffer(ibyte+2:ibyte+3),1)/(10.0**2)
        relaz_anchor(j,ii) = make_i2word(buffer(ibyte+4:ibyte+5),1)/(10.0**2)
      enddo
!----------------------------------------------------------------------
! unpack earth location
!----------------------------------------------------------------------
      j = 1
      do j = 1,51
        ibyte = 641 + (j-1)*8 + (ii-1)*byte_offset
        lat_anchor(j,ii) = make_i4word(buffer(ibyte:ibyte+3),1)/(10.0**4)
        lon_anchor(j,ii) = make_i4word(buffer(ibyte+4:ibyte+7),1)/(10.0**4)
      enddo

!-- make sure longitudes are correct ( ?? check this)
      where (lon_anchor > 180)
         lon_anchor = lon_anchor - 360.0
      end where

!----------------------------------------------------------------------
! unpack channel  data
!----------------------------------------------------------------------
   ichan = 1
   ipix = 1

   do ibyte = 1265+(ii-1)*byte_offset,1264+num_data_bytes+(ii-1)*byte_offset,4
      i4word = make_i4word(buffer(ibyte:ibyte+3),0)

      do j = 1,3
       if (ipix > num_pix) then
           exit
       endif
       chan_counts(ichan,ipix,ii) = i4word/ (1024**(3-j))
       i4word = i4word - chan_counts(ichan,ipix,ii)*(1024**(3-j))
       ichan = ichan + 1
        if (ichan > num_chan) then
          ichan = 1
          ipix = ipix + 1
!         if (ipix > num_pix) then
!            exit
!         endif
        endif
      enddo
      if (ipix > num_pix) then
            exit
      endif
   enddo

!-------------------------------------------------------------------------
! read in cloud mask 
!-----------------------------------------------------------------------
    ipix = 0
    word_clavr_start = 1264 + num_data_bytes + num_digtel_bytes + num_house_bytes + 1
 
!------ clavr status flag
    onebyte = buffer(word_clavr_start + 3 + byte_offset*(ii-1))
    clavr_status_1b(ii) = ishft(ishft(onebyte,7),-7)

!--- cloud mask
    start_word = word_clavr_start + 8 + byte_offset*(ii-1)
    end_word = start_word + num_clavr_bytes

    do iword = start_word, end_word
      onebyte = buffer(iword)
      ipix = 1
      start_pixel = (iword - start_word)*4 + 1
      end_pixel = min(num_pix, start_pixel+3_int2)

      do ipix = start_pixel, end_pixel
         if (ipix > num_pix) then
           exit
         endif
         i = (ipix - start_pixel) + 1
         cld_mask_1b(ipix,ii) = ishft(ishft(onebyte,2*(i-1)),-6)
      enddo
    enddo
!   print *, "range in cld_mask_1b = ", minval(cld_mask_1b(:,ii)),maxval(cld_mask_1b(:,ii))

!--------------------------------------

  end do scans_per_record_loop

  end subroutine unpack_avhrr_data_record_klm

!---------------------------------------------------------------------
subroutine OPEN_DIAG_FILES(num_pix)
    integer(kind=int2), intent(in):: num_pix

  open(unit=16,file="lat.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=17,file="lon.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=18,file="alb1.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=19,file="alb2.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=20,file="alb3a.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=21,file="alb3b.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=22,file="bt3b.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=23,file="bt4.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=24,file="bt5.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=25,file="satzen.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=26,file="solzen.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=27,file="relaz.dat",status="replace",form="unformatted", &
              access="direct",recl=4*num_pix,action="write")
  open(unit=28,file="glintzen.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=30,file="ems3b.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")

  open(unit=31,file="counts.dat",status="replace",form="unformatted", &
               access="direct",recl=2*num_pix,action="write")

  open(unit=32,file="mask1b.dat",status="replace",form="unformatted", &
               access="direct",recl=1*num_pix,action="write")

  open(unit=33,file="mask.dat",status="replace",form="unformatted", &
               access="direct",recl=1*num_pix,action="write")

  open(unit=34,file="rgct.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=35,file="tgct.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=36,file="rrct.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=37,file="ulst.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=38,file="fmft.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=39,file="cirt.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=40,file="tmft.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=41,file="land.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=45,file="win1_res.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=46,file="dynwin1.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=50,file="zsfc.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=51,file="sst_clim.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=55,file="sst_test.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=56,file="c3at.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=57,file="type.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=58,file="tut_ucld.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=59,file="coast.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=60,file="rut_clr.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=61,file="tut_clr.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=62,file="rut_cld.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=63,file="tut_cld.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=64,file="snow.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=65,file="snow_pot.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=66,file="glint1.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=67,file="sfc_type.dat",status="replace",form="unformatted", &
               recl=1*num_pix,access="direct",action="write")
  open(unit=71,file="sst.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")
  open(unit=72,file="ndvi.dat",status="replace",form="unformatted", &
               access="direct",recl=4*num_pix,action="write")


 end subroutine OPEN_DIAG_FILES
!-----------------------------------------------------------------------
 subroutine WRITE_TO_DIAG_FILES(j_output)
  integer(kind=int4), intent(inout):: j_output
  integer:: j

!---------- diagnostic output
   do j = 1,2
      write(unit=16,rec=j_output) lat(:,j)
      write(unit=17,rec=j_output) lon(:,j)
      write(unit=18,rec=j_output) alb1(:,j)
      write(unit=19,rec=j_output) alb2(:,j)
      write(unit=20,rec=j_output) alb3a(:,j)
      write(unit=21,rec=j_output) alb3b_mask(:,j)
      write(unit=22,rec=j_output) bt3b(:,j)
      write(unit=23,rec=j_output) bt4(:,j)
      write(unit=24,rec=j_output) bt5(:,j)
      write(unit=25,rec=j_output) satzen(:,j)
      write(unit=26,rec=j_output) solzen(:,j)
      write(unit=27,rec=j_output) relaz(:,j)
      write(unit=28,rec=j_output) glintzen(:,j)

      write(unit=30,rec=j_output) ems3b(:,j)
      write(unit=31,rec=j_output) chan_counts(4,:,j)
      write(unit=32,rec=j_output) cld_mask_1b(:,j)
      write(unit=33,rec=j_output) cld_mask(:,j)
      write(unit=34,rec=j_output) mask(1,:,j)
      write(unit=35,rec=j_output) mask(4,:,j)
      write(unit=36,rec=j_output) mask(2,:,j)
      write(unit=37,rec=j_output) mask(5,:,j)
      write(unit=38,rec=j_output) mask(7,:,j)
      write(unit=39,rec=j_output) mask(6,:,j)
      write(unit=40,rec=j_output) mask(8,:,j)
      write(unit=41,rec=j_output) data_mask(6,:,j)
      write(unit=45,rec=j_output) mask(16,:,j)
      write(unit=46,rec=j_output) mask(15,:,j)
      write(unit=50,rec=j_output) zsfc(:,j)
      write(unit=51,rec=j_output) sst_clim(:,j)
      write(unit=55,rec=j_output) mask(9,:,j)
      write(unit=56,rec=j_output) mask(3,:,j)
      write(unit=57,rec=j_output) cld_type(:,j)
      write(unit=58,rec=j_output) mask(13,:,j)
      write(unit=59,rec=j_output) data_mask(4,:,j)
      write(unit=60,rec=j_output) mask(17,:,j)
      write(unit=61,rec=j_output) mask(18,:,j)
      write(unit=62,rec=j_output) mask(19,:,j)
      write(unit=63,rec=j_output) mask(20,:,j)
      write(unit=64,rec=j_output) mask(23,:,j)
      write(unit=65,rec=j_output) data_mask(7,:,j)
      write(unit=66,rec=j_output) mask(21,:,j)
      write(unit=67,rec=j_output) sfc_type(:,j)
      write(unit=71,rec=j_output) sst_mask(:,j)
      write(unit=72,rec=j_output) ndvi(:,j)
     j_output = j_output + 1
   end do

 end subroutine WRITE_TO_DIAG_FILES


 subroutine CLOSE_DIAG_FILES()

     close(unit=16)
     close(unit=17)
     close(unit=18)
     close(unit=19)
     close(unit=20)
     close(unit=21)
     close(unit=22)
     close(unit=23)
     close(unit=24)
     close(unit=25)
     close(unit=26)
     close(unit=27)
     close(unit=28)

     close(unit=30)
     close(unit=31)
     close(unit=32)
     close(unit=33)
     close(unit=34)
     close(unit=35)
     close(unit=36)
     close(unit=37)
     close(unit=38)
     close(unit=39)
     close(unit=40)
     close(unit=41)

     close(unit=45)
     close(unit=46)

     close(unit=50)
     close(unit=51)
     close(unit=55)
     close(unit=56)
     close(unit=57)
     close(unit=58)
     close(unit=59)
     close(unit=60)
     close(unit=61)
     close(unit=62)
     close(unit=63)
     close(unit=64)
     close(unit=65)
     close(unit=66)
     close(unit=67)

     close(unit=71)
     close(unit=72)

 end subroutine CLOSE_DIAG_FILES

end module AVHRR_ROUTINES
