/*******************************************************************************
NAME:		GET_COMPOSITE_OUT

PURPOSE:	Get the user specified output composite image names

PROGRAM HISTORY:

VERSION    PROGRAMMER      DATE         CODE/CONT       REASON
-------    ----------      ----         ---------       ------
  1.0      T.Baltzer      11/99           CSC           Original Development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   COMPATM must be run under TAE.

PROJECT:                        ADAPS

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"	
#include "util.h"	
#include "adaps.h"	
#include "compatm.h"


void get_composite_out
(
    struct PARBLK *vblock,	/* IN:  Pointer to TAE parameter block	     */
    int which_band,		/* IN:  Which band has been specified	     */
    char parmname[],		/* IN:  Parameter name of image		     */
    int numbnd,			/* IN:  Number of bands in parmname	     */
    int nlines,			/* IN:  Number of lines in image	     */
    int nsamples,		/* IN:  Number of samples in image	     */
    struct MYFD myfd[],		/* OUT: File information		     */
    char hostname[] 		/* OUT: Host file name			     */
)

{

char hosout[NUM_IN_IMG][CMLEN],	/* Host image file name			     */
     taeout[NUM_IN_IMG][CMLEN];	/* TAE image file names			     */

int	band_index,		/* Band index (zero relative)		     */
	i;			/* Counter				     */


/* Compute the band index (zero relative) for the band being processed
-----------------------------------------------------------------------*/
band_index = which_band - 1;


/*  Load fields within the file descriptor structure
---------------------------------------------------------*/
if (c_getout(vblock, parmname, taeout, hosout) == E_FAIL)
    c_lasmsg(TRUE,"compatm-fatal","Fatal error encountered");

myfd[band_index].nlines = nlines;
myfd[band_index].nsamples = nsamples;
myfd[band_index].nbands = numbnd;
for (i = 0; i < myfd[band_index].nbands; i++)
    myfd[band_index].bands[i] = i + 1;

strcpy(hostname,hosout[0]);

}

