/*******************************************************************************
NAME:		SET_UP

PURPOSE:	Open tie points files

*******************************************************************************/
#include <stdio.h>
#include <math.h>
#include "las.h"
#include "geompak.h"
#include "dcwchips.h"

FUNCTION set_up(proj,ddr,tpsfile,mtpfile,tps_desc,mtp_desc)

struct  DDR	*ddr;		/* ddr for the image			*/

char	*proj,			/* projection flag			*/
	*tpsfile,		/* name of input tps file		*/
	*mtpfile;		/* name of outpout tps file		*/

int	**tps_desc,		/* intput tps file descriptor		*/
	**mtp_desc;		/* outpout mtp file descriptor		*/
{
struct  TPSHEAD tps_hdr;        /* tps file header                      */
struct 	MTPHEAD mtp_hdr;        /* merged tie point header record 	*/

long    access,         	/* file access mode                     */
	i,			/* looping variable			*/
	nonfatal = 1,		/* non-fatal error flag 		*/
	ptyp;             	/* type of record                       */


/*
  Open the input tps file
*/
ptyp    = TPS; 
access  = IREAD;
if (c_ptopen(tps_desc,tpsfile,&ptyp,&access,&tps_hdr) != E_SUCC)
    {
    c_errmsg("Error opening input tie point file","dcwchips-open",&nonfatal);
    return(E_FAIL);
    }

/*
  Initialize mtp header records
*/
for (i = 0; i < 8; i++)
    mtp_hdr.corners[i] = tps_hdr.corners[i];
mtp_hdr.pdist[0] = tps_hdr.pdist[0];
mtp_hdr.pdist[1] = tps_hdr.pdist[1];
for (i = 0; i < 15; i++)
    mtp_hdr.projprms[i] = tps_hdr.projprms[i];
mtp_hdr.proj_valid = tps_hdr.proj_valid;
mtp_hdr.code = tps_hdr.code;
mtp_hdr.zone = tps_hdr.zone;
mtp_hdr.datum = tps_hdr.datum;
strcpy(mtp_hdr.chip_mode, "CHIP-TEM");
strcpy(mtp_hdr.units, tps_hdr.units);
strcpy(mtp_hdr.sea_name, "");
strcpy(mtp_hdr.ref_name, tps_hdr.name);

/*
  Open the output mtp file
*/
ptyp = MTP; 
access = IWRITE;
if (c_ptopen(mtp_desc,mtpfile,&ptyp,&access,&mtp_hdr) != E_SUCC)
    {
    c_errmsg("Error opening output merged tie point file","dcwchips-open",
		&nonfatal);
    return(E_FAIL);
    }

return(E_SUCC);
}
