#!/bin/csh
#
# FUNCTION: cwd.csh
#
# PURPOSE:  Create a temporary pdf that will return the current working
#           directory.
#
#
# Programmer       Date   Modifications
# ---------------  -----  ------------------------------------------------------
# J.Fenno          06/93  Development
#
# R.Dilley         03/97  Removed reference to READEAF and moved source to 
#                         the ESAMETAIN module.


#----------------------------
# Create a temporary pdf name
#----------------------------
onintr -
set tmpfile = cwd.pdf
if (-e $tmpfile) then
    set noglob
    echo "[cwd-exists] The file cwd;pdf already exists"
    exit -1
    endif

#---------------
# Create the pdf
#---------------
cat << EOPDF > $tmpfile
!.HEADER LAS
PROCEDURE CWD HELP=*

PARM DIR TYPE=NAME

body
let dir = "`pwd`"
ush rm $tmpfile
end-proc
.TITLE
Return the current working directory.
.HELP
Return the current working directory.
.LEVEL1
.VAR DIR
Directory
.LEVEL2
.VAR DIR
Directory.  The current working directory is returned in through
this TAE name parameter.
.END
EOPDF


#------------------------
# Exit with a good status
#------------------------
exit 0
