#include<stdio.h>
#include<math.h>

noaa14Tfix(
    double Tbad, 
    double cwn ,
    int    band,
    double *T)

{
    double A3 = 1.00359   ;    /* Band 3 correction polynomial coefficients */
    double B3 = 0.0       ;
    double C3 = -0.0031   ;

    double A4 = 0.92378   ;    /* Band 4 correction polynomial coefficients */
    double B4 = 0.0003822 ;
    double C4 = 3.72      ;

    double A5 = 0.96194   ;    /* Band 5 correction polynomial coefficients */
    double B5 = 0.0001742 ;
    double C5 = 2.00      ;

    double coef[3][3]     ;    /* Correction polynomial coef[iband][order] */

    double Tm, Tp, Tlin   ;
    double Rlin           ;
    double R              ;

    int  iband          ;



    coef[0][0] = C3 ;
    coef[0][1] = A3 ;
    coef[0][2] = B3 ;

    coef[1][0] = C4 ;
    coef[1][1] = A4 ;
    coef[1][2] = B4 ;

    coef[2][0] = C5 ;
    coef[2][1] = A5 ;
    coef[2][2] = B5 ;

    iband = band - 3 ;


/* Back out 'linear' temperature from misapplication on 
   nonlinearity polynomial
   --------------------------------------------------------------*/
       if(coef[iband][2] == 0.0)   /* If linear (band 3)         */
       {
          Tlin = -(coef[iband][0]-Tbad)/coef[iband][1] ; 
       }
       else                        /* else it must be quadratic  */
       {
          quadratic(coef[iband][2], coef[iband][1], 
                    coef[iband][0]-Tbad, &Tm, &Tp) ;
          Tlin = (Tp >= Tm) ? Tp:Tm ;
       }



/* Use Planck Equation to get 'linear' radiance from temperature
   --------------------------------------------------------------*/ 
       planck_cwn(Tlin,cwn, &Rlin) ;



/* Apply nonlinear correction polynomial to 'linear' radiance to
   get actual radiance
   --------------------------------------------------------------*/
       poly(coef[iband], Rlin, 2, &R);



/* Use inverse of Planck equation to get the corrected temperature
   from radiance
   --------------------------------------------------------------*/
       if (R < 0.0)
	  *T = 0.0;
       else
          planckinv_cwn(R, cwn, T) ; 
  
}
