/*******************************************************************************
FUNCTION:	print_stats

PURPOSE:   	Print the statistics about which lines have been dropped.

*******************************************************************************/
#include "gapexp.h"


FUNCTION print_stats (drop, model)

    struct DROPPED *drop;       /* IN     - AVHRR dropped line structure      */
    struct MODEL *model;        /* IN     - AVHRR model structure             */

{
char str[CMLEN];	/* Temporary string                                   */


long i;			/* Loop control                                       */
long nonfatal = 1;	/* Nonfatal error flag                                */


/* Write the drop line information
--------------------------------------------------------*/
c_errmsg(" ", " ", &nonfatal);
sprintf(str,"       DROPPED LINE INFORMATION");
c_errmsg(str, " ", &nonfatal);
c_errmsg(" ", " ", &nonfatal);

sprintf(str,"    Gaps: %5d  Total Missed:  %4d",drop->ngaps, model->totmiss);
c_errmsg(str, " ", &nonfatal);
c_errmsg(" ", " ", &nonfatal);

/*
  Convert the location and number of the dropped lines
*/
for (i = 0; i < drop->ngaps; i++)
    {
    sprintf(str,"    Line: %5d  # Missed: %5d",drop->lmissed[i],
            drop->nmissed[i]);
    c_errmsg(str, " ", &nonfatal);
    }
c_errmsg(" ", " ", &nonfatal);

return(E_SUCC);
}
