/*****************************************************************************
NAME: 			GETPAR

PURPOSE:		Retrieve LISTEDIT parameter information

ALGORITHM:

ALGORITHM REFERENCES
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "tae.h"
#include "worgen.h"
#include "util.h"
#include "adaps.h"
#include "listedit.h"


int getpar
   (
   struct PARBLK   *vblock,	/* TAE parameter block	*/
   char   subcmd[],		/* Subcommand used	*/
   char   filnam[],		/* Name of input file	*/
   char   sceneid[],		/* Scene id		*/
   char   tstamp[],		/* Time stamp		*/
   char   tapeid[],		/* Tape id		*/
   char   pflag[]		/* Processing flag	*/
   )

{

long   access,			/* Type of access for getnam call	*/
       element = 0,		/* Element number for getnam call	*/
       length,			/* Length specification			*/
       one = 1,			/* Value of one				*/
       size,			/* length of string			*/
       status;			/* Function return value		*/

struct VARIABLE *var;           /* pointer to a TAE variable            */


/* Get the subcommand
--------------------- */
c_getstr (vblock,"_SUBCMD",&one,&length,subcmd);


/* Get the name of the file and make sure it exists with proper permissions
---------------------------------------------------------------------------*/
if (strcmp(subcmd,"UPDATE") == 0)
   access = IUPDATE;
else
   access = IREAD;
status = c_getnam(vblock,"INFILE",&element,filnam,"",&access);
if (status != E_SUCC)
   return(status);


/* Get the parameters required specifically for UPDATE subcommand
---------------------------------------------------------------------*/
if (strcmp(subcmd,"UPDATE") == 0)
   {
   /* Get the scene id to edit the status thereof
   ------------------------------------------------*/
   var = p_find(vblock,"SCENEID");
   strcpy(sceneid,SVAL(*var,0));
   size = (long)strlen(sceneid);
   c_up2low(sceneid,&size);


   /* Get the time stamp to edit the status thereof
   ------------------------------------------------*/
   var = p_find(vblock,"TSTAMP");
   strcpy(tstamp,SVAL(*var,0));


   /* Get the status flag
   ---------------------------------*/
   var = p_find(vblock,"PFLAG");
   strcpy(pflag,SVAL(*var,0));
   }


/* Get the parameters required specifically for the FETCH subcommand
---------------------------------------------------------------------*/
if (strcmp(subcmd,"FETCH") == 0)
   {
   /* Get the tape id 
   --------------------------------*/
   var = p_find(vblock,"TAPEID");
   if ( var->v_count == 0 )
      tapeid[0] = 0;
   else
      strcpy(tapeid,SVAL(*var,0));
   size = (long)strlen(tapeid);
   c_up2low(tapeid,&size);
   /* Get the scene id to edit the status thereof
   ------------------------------------------------*/
   var = p_find(vblock,"SCENEID");
   if ( var->v_count == 0 )
      sceneid[0] = 0;
   else
      strcpy(sceneid,SVAL(*var,0));
   size = (long)strlen(sceneid);
   c_up2low(sceneid,&size);
   }


return(E_SUCC); 
}
