#ifndef LISTEDIT_H
#define LISTEDIT_H

#define BLINELEN 32	/* Number of char in browse list */

#define E_FEND   2      /* EOF return status */

#define MAX_PASS 20	/* Most scenes on one tape */

#ifndef SEEK_CUR
#define SEEK_CUR 1      /* File seek definition */
#endif

/* Function prototypes
----------------------*/
int getpar
    (
    struct PARBLK   *vblock,     /* TAE parameter block  */
    char   subcmd[],             /* Subcommand used      */
    char   filnam[],             /* Name of input file   */
    char   sceneid[],            /* Scene id             */
    char   tstamp[],             /* Time stamp           */
    char   tapeid[],             /* Tape id              */
    char   pflag[]               /* Processing flag      */
    );

int loc_line
(
FILE *infp,                     /* LUT file pointer                     */
char sceneid[],                 /* User input scene ID                  */
char tstamp[],                  /* User input time stamp                */
char pflag[],                   /* Processing flag                      */
char linebuf[BLINELEN+2]        /* Buffer containing line of data       */
);

int loc_scene
(
struct PARBLK   *vblock,     /* TAE parameter block                     */
FILE *infp,                     /* LUT file pointer                     */
char tapeid[],                  /* Tape id                              */
char linebuf[BLINELEN+2]        /* Buffer containing line of data       */
);

int loc_tapeid
( 
struct  PARBLK  *vblock,        /* TAE parameter block                  */
FILE    *infp,                  /* LUT file pointer                     */
char    linebuf[BLINELEN+2]     /* Buffer containing line of data       */
);

int loc_tstamp
(
struct PARBLK   *vblock,     /* TAE parameter block                     */
FILE *infp,                     /* LUT file pointer                     */
char sceneid[],                 /* Tape id                              */
char linebuf[BLINELEN+2]        /* Buffer containing line of data       */
);

int processit
(
   struct PARBLK   *vblock,     /* TAE parameter block                  */
   char subcmd [],              /* Sub command                          */
   char filnam[],               /* Half orbit file name                 */
   char inscene[],              /* User input scene ID                  */
   char instamp[],              /* User input time stamp                */
   char tapeid[],               /* Tape id                              */
   char pflag[],                /* Processing flag                      */
   FILE **infp                  /* Input file pointer                   */
);

int taeland
(
   struct PARBLK *vblock,       /* TAE parameter block                  */
   long nscenes,                /* number of passes on the tape         */
   char xsceneid[][17],         /* scene identifier                     */
   char xtstamp[][7]            /* time stamp                           */
);

void wrt_flg
(
   FILE *infp,                  /* Input file pointer                   */
   char pflag[]                 /* Processing flag Y=processed N=not    */
);



#endif
