/******************************************************************************
FUNCTION:	WRT_FLG

PURPOSE:	Write the user specified flag to the file.  This function
		assumes the file pointer is at the end of the desired line.

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 1.0       02/97    T. Baltzer		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
		Run under TAE

PROJECT			ADAPS

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>		/* C standard I/O include file         */
#include <time.h>               /* C standard TIME include file        */
#include "las.h"		/* LAS include			       */
#include "listedit.h"		/* Local include		       */


void wrt_flg
(
   FILE *infp,			/* Input file pointer			*/
   char pflag[]			/* Processing flag Y=processed N=not	*/
)
{

long fatal = -1;		/* Fatal error status			*/
long nonfatal = 1;		/* Non-fatal error status		*/
long status;			/* Return status			*/


/*
  Position the file pointer to the "flags" position on the line
*/
status = fseek(infp,-2,SEEK_CUR);
if (status != E_SUCC)
   {
   fclose(infp);
   c_errmsg("Error seeking in the file","listedit-seek",&nonfatal);
   c_errmsg("Fatal error encountered","listedit-fatal",&fatal);
   }


/*
  Write the new flag status to the line of the file.
*/
status = fputs(pflag,infp);
if (status == EOF)
   {
   fclose(infp);
   c_errmsg("Error writing to the file","listedit-writ",&nonfatal);
   c_errmsg("Fatal error encountered","listedit-fatal",&fatal);
   }

}
