/*******************************************************************************
NAME:		GET_COMPOSITE_INFO

PURPOSE:	Get the information for the user specified images in
		composite space.

PROGRAM HISTORY:

VERSION    PROGRAMMER      DATE         REASON
-------    ----------      ----         ------
  1.0      T.Baltzer      04/00         Original Development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   MULLI must be run under TAE.

PROJECT:                        ADAPS


*******************************************************************************/
#include <stdio.h>
#include "las.h"	
#include "adaps.h"	
#include "mulli.h"


void get_composite_info
(
    struct PARBLK *vblock,	/* IN:  pointer to TAE parameter block        */
    struct FILEINFO fileinfo[],	/* OUT: File information		      */
    char hosin[MAXIMG][CMLEN],	/* OUT: Host names of input images	      */
    char hosout[][CMLEN]	/* OUT: Host name of output image	      */
)

{

/* Retrieve and parse the 'IN' image specification 
-----------------------------------------------------*/
get_composite_in(vblock,IN_BAND,"IN",2,fileinfo,hosin[0]);

/* Retrieve and parse date band image specification 
---------------------------------------------------*/
get_composite_in(vblock,DATE_BAND,"DATEBAND",1,fileinfo,hosin[1]);

/* Retrieve and parse the output image specification 
-------------------------------------------------------*/
get_composite_out(vblock,OUT_BAND,"OUT",2,fileinfo[0].nlines,
		  fileinfo[0].nsamples,fileinfo,hosout[0]);

}
