
/* Include file for MULLIINFO */

#ifndef MULLIINFO_H
#define MULLIINFO_H


#define MAXPERIOD 2	/* Maximum number of periods to specify		    */
#define MAXSCENE 300	/* Maximum number of scenes included in a composite */

#define HEADER_LINES_SHORT 4	/* Number of header lines in 'short' log file */
#define HEADER_LINES_LONG  5	/* Number of header lines in 'long' log file  */

#define SHORT_FORMAT 0	/* 'Short' format log file	*/
#define LONG_FORMAT  1	/* 'Long' format log file	*/

/* Prototypes */

int process_long
(
    char linebuf[CMLEN+1],      /* IN:  Buffer containing line of data     */
    int sceneptlist[],          /* IN/OUT:  List of scene pointers         */
    char sceneidlist[][17],     /* IN/OUT:  List of scene id's in composite*/
    int *ndays,                 /* IN/OUT: Number of days in date list     */
    char periods[][CMLEN],      /* IN:  Periods used in the composite      */
    int nperiods                /* IN:  Number of periods in 'periods'     */
);

int process_short
(
    char linebuf[CMLEN+1],      /* IN:  Buffer containing line of data     */
    int sceneptlist[],          /* IN/OUT:  List of scene pointers         */
    char sceneidlist[][17],     /* IN/OUT:  List of scene id's in composite*/
    int *ndays                  /* IN/OUT: Number of days in date list     */
);

void taeland
(
    struct PARBLK *vblock,      /* IN: TAE parameter block              */
    int sceneptlist[],          /* IN: scene list of pointers           */
    char sceneidlist[][17],     /* IN: scene id listing                 */
    int *ndays                  /* IN: number of days in sceneidlist    */
);

#endif

