/******************************************************************************
FUNCTION:       TAELAND
 
PURPOSE:        Send information back to TAE land.

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
 1.0       04/00    T. Baltzer          Stole from REATMO

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
                Run under TAE

PROJECT                 ADAPS

ALGORITHM REFERENCES    none
*******************************************************************************/
#include <stdio.h>              /* C standard I/O include file		*/
#include <time.h>               /* C standard TIME include file		*/
#include "las.h"                /* LAS include				*/
#include "mulliinfo.h"         /* Local include			*/


void taeland
(
    struct PARBLK *vblock,	/* IN: TAE parameter block		*/
    int sceneptlist[],		/* IN: scene list of pointers		*/
    char sceneidlist[][17],	/* IN: scene id listing			*/
    int *ndays 			/* IN: number of days in sceneidlist	*/
)

{

char *sptr[MAXSCENE];           /* pointer array for updating vblock    */

int i;                         /* counter                              */


/* Output the string values to the variable block
--------------------------------------------------*/
for (i = 0; i < MAXSCENE; i++)
    sptr[i] = sceneidlist[i];

if (q_string(vblock,"SCENEIDLIST",*ndays,sptr,P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE,"mullii-rparm",
	     "Error returning parameter SCENEIDLIST to TAE");


/* Output the integer values to the variable block.
---------------------------------------------------*/
if (q_intg(vblock,"NDAYS",1,ndays,P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE,"mullii-rparm","Error returning parameter NDAYS to TAE");

if (q_intg(vblock,"SCENEPTLIST",MAXSCENE,sceneptlist,P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE,"mullii-rparm",
	     "Error returning parameter SCENEPTLIST to TAE");

if (q_out(vblock) != SUCCESS)
    c_lasmsg(TRUE,"mullii-rparm","Error returning parameter to TAE");

}
