/******************************************************************************
NAME:   			UPDATE_BDR 

PURPOSE:    Update the band DDR's

PROGRAM HISTORY:

VERSION    PROGRAMMER      DATE         REASON
-------    ----------      ----         ------
  1.0      T.Baltzer      04/00         Original Development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   MULLI must be run under TAE.

PROJECT:                        ADAPS

******************************************************************************/

#include <string.h>
#include "las.h"
#include "util.h"

int update_bdr
(
    char hosout[][CMLEN] 	/* IN: host name of output image	     */
)

{

struct BDDR bddr;		/* Band data descriptor record		     */
struct BDDR bddr2;		/* Band data descriptor record		     */
struct DDR ddr;			/* Data descriptor record		     */

long    one = 1,		/* constant 				     */
	two = 2;		/* constant				     */


/* NOTE:  The geometry information from the input image is updated in the    */
/*	  function pre_process which is why it isn't done here.  CR 4645     */


/* Get the DDR info for the output image
----------------------------------------------*/
if ( c_getddr( hosout[0], &ddr ) != E_SUCC )
   return(E_FAIL);

/* Get the BDDR info for the output image,
   and add the data source field.
----------------------------------------------*/
if ( c_getbdr( hosout[0], &bddr, &one ) != E_SUCC )
   return(E_FAIL);
strcpy(bddr.source,"Remove illum correction, ch 1");

if ( c_getbdr( hosout[0], &bddr2, &two ) != E_SUCC )
   return(E_FAIL);
strcpy(bddr2.source,"Remove illum correction, ch 2");

/* Save the DDR info for the output image
----------------------------------------------*/
if ( c_putddr( hosout[0], &ddr ) != E_SUCC )
   return(E_FAIL);

/* Save the BDDR info for the output image
-----------------------------------------------*/
if ( c_putbdr( hosout[0], &bddr ) != E_SUCC )
   return(E_FAIL);

if ( c_putbdr( hosout[0], &bddr2 ) != E_SUCC )
   return(E_FAIL);


return(E_SUCC);
}
