/***************************************************************************
FUNCTION:	heapsort

PURPOSE: 	This program sorts an array into numerical ascending order.

ALGORITHM REFERENCES
   page 247 of NUMERICAL RECIPES IN C.
***************************************************************************/
void heapsort(
	long n,
	double ra[],
	double key[] 
)

{
long 	l,	/* array counters & indices	*/
	j,
	ir,
	i;
double 	rra,	/* temp array holder for ra 	*/
	rrb;	/* temp array holder for key 	*/

l = n/2;
ir = n - 1;
for (;;) 
    {
    if (l > 0)
	{
	l = l - 1;
	rra = ra[l];
	rrb = key[l];
	}
    else
	{
	rra = ra[ir];
	rrb = key[ir];
	ra[ir] = ra[0];
	key[ir] = key[0];
	ir = ir - 1;
	if (ir == 0)
            {
            ra[0] = rra;
            key[0] = rrb;
            return;
            }
	}
    i = l;
    j = l * 2 + 1;
    while (j <= ir)
	{
	if (j < ir && ra[j] < ra[j+1]) ++j;
	if (rra < ra[j])
            {
            ra[i] = ra[j];
            key[i] = key[j];
	    i = j;
            j += i + 1;
            }
	else 
	    j = ir + 1;
	}
    ra[i] = rra;
    key[i] = rrb;
    }
}
