/*****************************************************************************
NAME: 			GETPAR

PURPOSE:		Retrieve GET_SEEN parameter information

ALGORITHM:

ALGORITHM REFERENCES:	none.
*****************************************************************************/
#include <stdio.h>
#include "tae.h"
#include "worgen.h"
#include "adaps.h"


FUNCTION getpar(vblock,filnam,strscene,endscene,tapeid,dest) 

   struct PARBLK   *vblock;	/* TAE parameter block	*/
   char   filnam[];		/* Name of input file	*/
   char   strscene[];		/* Starting scene id	*/
   char   endscene[];		/* Ending scene id	*/
   char   tapeid[];		/* Tape id of interest  */
   char   dest[];		/* Destination		*/

{

long   access = IREAD,		/* Type of access for getnam call	*/
       element = 0,		/* Element number for getnam call	*/
       fatal = -1,		/* Fatal error status			*/
       size,			/* length of string			*/
       status;			/* Function return value		*/


struct VARIABLE *p_find();      /* function to find a TAE variable      */
struct VARIABLE *var;           /* pointer to a TAE variable            */



/* Get the name of the file to read
-----------------------------------*/
status = c_getnam(vblock,"INFILE",&element,filnam,"",&access);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered", "get_seen-fatal", &fatal);


/* Get the tape id
--------------------------*/
var = p_find(vblock,"TAPEID");
strcpy(tapeid,SVAL(*var,0));
size = strlen(tapeid);
c_up2low(tapeid,&size);


/* Get the starting scene id, if specified
-------------------------------------------*/
var = p_find(vblock,"STRSCENE");
if (var->v_count == 0)
   {
   strcpy(strscene,"");
   }
else
   {
   strcpy(strscene,SVAL(*var,0));
   size = strlen(strscene);
   c_up2low(strscene,&size);
   }


/* Get the ending scene id, if specified
-------------------------------------------*/
var = p_find(vblock,"ENDSCENE");
if (var->v_count == 0)
   {
   strcpy(endscene,"");
   }
else
   {
   strcpy(endscene,SVAL(*var,0));
   size = strlen(endscene);
   c_up2low(endscene,&size);
   }


/* Get the destination of the data
------------------------------------*/
var = p_find(vblock,"DEST");
strcpy(dest,SVAL(*var,0));
size = strlen(dest);
c_up2low(dest,&size);


return; 
}
