/******************************************************************************
NAME:		INIT_INPUT 

PURPOSE:    Initialize the input orbital stitch file.

PROGRAM HISTORY:
VERSION	   PROGRAMMER	   DATE		CODE/CONT	REASON
-------	   ----------      ----		---------	------
  1.0	   T. Baltzer	   07/93	  CSB		Original Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:			ADAPS

ALGORITHM:
   See in-line documentation.

   ALGORITHM REFERENCES:		none
******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "stitch.h"		/* Orbital stitch include file		*/

FUNCTION init_input(filnam,infp)

   char filnam[];		/* Half orbit file name			*/
   FILE **infp;			/* File pointer				*/

{

char linebuf[CMLEN+1];		/* Buffer containing line of data	*/

long fatal = -1;		/* Fatal error message			*/
long nonfatal = 1;		/* Nonfatal error message		*/

FILE *fopen();			/* LUT file pointer                     */


/* Open the input file
-----------------------*/
*infp = fopen(filnam,"r");
if (*infp == NULL)
   {
   c_errmsg("Error opening input file","get_seen-open",&nonfatal);
   c_errmsg("Fatal error encountered","get_seen-fatal",&fatal);
   }


/* Read past the header information
------------------------------------*/
for (;;)
   {
   if ( fgets(linebuf,CMLEN+1,*infp) == NULL)
      {
      c_errmsg("Error reading line from input file","get_seen-read",&nonfatal);
      c_errmsg("Fatal error encountered","get_seen-fatal",&fatal);
      }
   if ( strncmp(&linebuf[0],"tapeid",6) == 0 )
      break;
   }

return;
}
