/******************************************************************************
FUNCTION:	TAELAND

PURPOSE:	Send a list of scenes back to TAE land.

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 1.0       11/93    T. Baltzer		initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
		Run under TAE

PROJECT			ADAPS

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>		/* C standard I/O include file         */
#include <time.h>               /* C standard TIME include file        */
#include "las.h"		/* LAS include			       */
#include "stitch.h"             /* Orbital stitch include file         */


FUNCTION taeland(vblock,nscenes,sceneid)

   struct PARBLK *vblock;	/* TAE parameter block			*/
   long nscenes[];		/* number of passes on the tape		*/
   char sceneid[][17];		/* scene identifier			*/

{

char *sptr[20];		        /* pointer array for updating vblock    */

long i;				/* counter				*/
long fatal = -1;		/* Fatal error status			*/
long nonfatal = 1;		/* Non-fatal error status		*/


/*
  Output the string values to the variable block
*/

for (i = 0; i < nscenes[0]; i++)
   sptr[i] = sceneid[i];
if (q_string(vblock,"SCENEID",nscenes[0],sptr,P_UPDATE) != SUCCESS)
   {
   c_errmsg("Error returning parameter to TAE","get_seen-rparm",&nonfatal);
   c_errmsg("Fatal error encountered","get_seen-fatal",&fatal);
   }


/*
  Output the integer values to the variable block
*/
if (q_intg(vblock,"NSCENES",1,nscenes,P_UPDATE) != SUCCESS)
   {
   c_errmsg("Error returning parameter to TAE","get_seen-rparm",&nonfatal);
   c_errmsg("Fatal error encountered","get_seen-fatal",&fatal);
   }

if (q_out(vblock) != SUCCESS)
   {
   c_errmsg("Error returning parameter to TAE","get_seen-rparm",&nonfatal);
   c_errmsg("Fatal error encountered","get_seen-fatal",&fatal);
   }

return;
}
