/******************************************************************************
NAME:                           CALCTIME 

PURPOSE:    Calculate the time in seconds from some character buffer data

PROGRAM HISTORY:
VERSION    PROGRAMMER      DATE         CODE/CONT       REASON
-------    ----------      ----         ---------       ------
  1.0      T. Baltzer      01/93          CSB           Original Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:                        ADAPS

ALGORITHM:
   See in-line documentation.

   ALGORITHM REFERENCES:                none
******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "adaps.h"


FUNCTION calctime(buffer,t_in_sec)

   char buffer[];               /* Character buffer of HHMMSS           */
   long *t_in_sec;              /* return time in seconds               */

{

long    hour;           /* time in hours        */
long    minute;         /* time in minutes      */
long    sec;            /* time in seconds      */

char    smlbuf[3];      /* small buffer         */

strncpy(smlbuf,&buffer[0],2);
smlbuf[2] = '\0';
if (smlbuf[1] == ' ')  smlbuf[1] = '0';
if ( sscanf(smlbuf,"%d",&hour) == E_FAIL )
    {
    c_lasmsg(FALSE,"halforb-conv","Error converting line buffer data");
    c_lasmsg(FALSE,"halforb-fatal","Fatal error encountered");
    return(E_FAIL);
    }

strncpy(smlbuf,&buffer[2],2);
smlbuf[2] = '\0';
if ( sscanf(smlbuf,"%d",&minute) == E_FAIL )
    {
    c_lasmsg(FALSE,"halforb-conv","Error converting line buffer data");
    c_lasmsg(FALSE,"halforb-fatal","Fatal error encountered");
    return(E_FAIL);
    }

strncpy(smlbuf,&buffer[4],2);
smlbuf[2] = '\0';
if ( sscanf(smlbuf,"%d",&sec) == E_FAIL )
    {
    c_lasmsg(FALSE,"halforb-conv","Error converting line buffer data");
    c_lasmsg(FALSE,"halforb-fatal","Fatal error encountered");
    return(E_FAIL);
    }

*t_in_sec = (((hour * 60) + minute) * 60) + sec;

return(E_SUCC);
}
