/*******************************************************************************
NAME:           CHECK_DUP

PURPOSE:        Check for duplicate scenes in list.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    ------          ------
  1.0           7/93    T. Baltzer      Original Development

*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"

FUNCTION check_dup(tapeid,sceneid,locate,srclnk,lndflgs,orbflgs,nscenes)
char tapeid[][7];               /* tape identifier                      */
char sceneid[][17];             /* scene identifier                     */
char locate[][5];               /* location: disk, silo, tape, unkw     */
char srclnk[][7];               /* data base source link                */
char lndflgs[];                 /* line detect flags                    */
char orbflgs[];                 /* orbital stitch flags                 */
long nscenes[];                 /* number of passes in the orbit        */

{
long i,j;                       /* counter                              */

for (i = 1; i < nscenes[0]; i++)
    {
    if (strcmp(sceneid[i],sceneid[i-1]) == 0)
        {
        for (j = i; j < nscenes[0] - 1; j++)
            {
            strcpy(sceneid[j],sceneid[j+1]);
            strcpy(tapeid[j],tapeid[j+1]);
            strcpy(locate[j],locate[j+1]);
            strcpy(srclnk[j],srclnk[j+1]);
            lndflgs[j] = lndflgs[j+1];
            orbflgs[j] = orbflgs[j+1];
            }
        nscenes[0]--;
        i--;
        c_lasmsg(FALSE,"halforb-dup","Duplicate scene specified");
        }
    }
return;
}
