/*******************************************************************************
NAME:           CHECK_NOT

PURPOSE:        Check to make certain the scene exists on disk, silo, or tape.
                If it doesn't, delete it from the list.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    ------          ------
  1.0           8/93    T. Baltzer      Original Development

*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "adaps.h"

FUNCTION check_not(tapeid,sceneid,locate,srclnk,lndflgs,orbflgs,nscenes,logfile)
char tapeid[][7];               /* tape identifier                      */
char sceneid[][17];             /* scene identifier                     */
char locate[][5];               /* location: disk, silo, tape, unkw     */
char srclnk[][7];               /* data base source link                */
char lndflgs[];                 /* line detect flags                    */
char orbflgs[];                 /* orbital stitch flags                 */
long nscenes[];                 /* number of passes in the orbit        */
char logfile[];                 /* Name of log file                     */

{
long i,j;                       /* counter                              */

char msg[ERRLEN];               /* Error message                        */


for (i = 0; i < nscenes[0]; i++)
    {
    if (strcmp(locate[i],"UNKW") == 0)
        {
        sprintf(msg,"Scene %s location unknown",sceneid[i]);
        c_lasmsg(FALSE,"halforb-unkw",msg);
        c_lasmsg(FALSE,"halforb-warn","Nonfatal error encountered");
        c_wrtlog(logfile,sceneid[i],"halforb-unkw",msg);
        for (j = i; j < nscenes[0]-1; j++)
            {
            strcpy(sceneid[j],sceneid[j+1]);
            strcpy(tapeid[j],tapeid[j+1]);
            strcpy(locate[j],locate[j+1]);
            strcpy(srclnk[j],srclnk[j+1]);
            lndflgs[j] = lndflgs[j+1];
            orbflgs[j] = orbflgs[j+1];
            }
        nscenes[0]--;
        i--;
        }
    }
return;
}
