/******************************************************************************
FUNCTION:       EOF2TAE

PURPOSE:        Send end of file flag = TRUE back to tae land.

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
 1.0       01/93    T. Baltzer          initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
                Run under TAE

PROJECT                 ADAPS

ALGORITHM REFERENCES    none
*******************************************************************************/
#include <stdio.h>              /* C standard I/O include file         */
#include <time.h>               /* C standard TIME include file        */
#include "las.h"                /* LAS include                         */

FUNCTION eof2tae(vblock,doneflg)

   struct PARBLK *vblock;       /* TAE parameter block                  */
   long doneflg[];              /* Done processing flag                 */

{
long eofflg = 1;                /* TRUE end of file flag                */


/* Output the TRUE eof flag value to the variable block
----------------------------------------------------------*/
if (q_intg(vblock,"EOFFLG",1,&eofflg,P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE,"halforb-rparm","Error returning parameter to TAE");


/* Output the done flag value of 0 (NOT done) if a half orbit of data
   was found that was not yet processed.
---------------------------------------------------------*/
if (doneflg[0] == 0)
    {
    if (q_intg(vblock,"DONEFLG",1,&doneflg,P_UPDATE) != SUCCESS)
        c_lasmsg(TRUE,"halforb-rparm","Error returning parameter to TAE");
    }


if (q_out(vblock) != SUCCESS)
    c_lasmsg(TRUE,"halforb-rparm","Error returning parameter to TAE");

return;
}
