/******************************************************************************
NAME:                           SCENE_LOC 

PURPOSE:    Get the location of a scene.

PROGRAM HISTORY:
VERSION    PROGRAMMER      DATE         CODE/CONT       REASON
-------    ----------      ----         ---------       ------
  1.0      T. Baltzer      08/93          CSB           Original Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:                        ADAPS

ALGORITHM:
   See in-line documentation.

   ALGORITHM REFERENCES:                none
******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "adaps.h"
#include "stitch.h"             /* Orbital stitch include file         */


FUNCTION scene_loc(oneline,location)

struct TAPESTR *oneline;/* Structure with one line of info      */
long *location;         /* Location of scene                    */
                        /*   0 = undetermined                   */
                        /*   1 = on disk                        */
                        /*   2 = on the silo                    */
                        /*   3 = apparently on tape             */

{

if (oneline->locflg == 'S')
    *location = 2;
else if (oneline->locflg == 'D')
    *location = 1;
else if ((oneline->locflg == ' ') &&
    (strcmp(oneline->tapeid,"      ") != 0))
    *location = 3;
else
    *location = 0;

return;
}
