/*******************************************************************************
NAME:		GET_COMPOSITE_OUT

PURPOSE:	Get the user specified output composite image names

PROGRAM HISTORY:

VERSION    PROGRAMMER      DATE         REASON
-------    ----------      ----         ------
  1.0      T.Baltzer      04/00         Original Development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   REANGLE must be run under TAE.

PROJECT:                        ADAPS

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"	
#include "util.h"	
#include "adaps.h"	
#include "reangle.h"


void get_composite_out
(
    struct PARBLK *vblock,	/* IN:  Pointer to TAE parameter block	     */
    int which_band,		/* IN:  Which band has been specified	     */
    char parmname[],		/* IN:  Parameter name of image		     */
    int numbnd,			/* IN:  Number of bands in parmname	     */
    int nlines,			/* IN:  Number of lines in image	     */
    int nsamples,		/* IN:  Number of samples in image	     */
    struct FILEINFO fileinfo[],	/* OUT: File information		     */
    char hostname[] 		/* OUT: Host file name			     */
)

{

char hosout[1][CMLEN],		/* Host image file name			     */
     taeout[NUM_IN_IMG][CMLEN];	/* TAE image file names			     */

int	zero_rel_band,		/* Band index (zero relative)		     */
	i;			/* Counter				     */

long	zero = 0;		/* Constant				     */

/* Compute the band index (zero relative) for the band being processed
-----------------------------------------------------------------------*/
zero_rel_band = which_band - 1;


/*  Load fields within the file descriptor structure
---------------------------------------------------------*/
if (c_getout(vblock, parmname, taeout, hosout) == E_FAIL)
    c_clean(vblock,"reangle","",&zero);

fileinfo[zero_rel_band].nlines = nlines;
fileinfo[zero_rel_band].nsamples = nsamples;
fileinfo[zero_rel_band].nbands = numbnd;
for (i = 0; i < fileinfo[zero_rel_band].nbands; i++)
    fileinfo[zero_rel_band].bands[i] = i + 1;

strcpy(hostname,hosout[0]);

}

