/*******************************************************************************
NAME:		GETPAR

PURPOSE:	Get the user specified parameters

PROGRAM HISTORY:

VERSION    PROGRAMMER      DATE         REASON
-------    ----------      ----         ------
  1.0      T.Baltzer      04/00         Original Development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   REANGLE must be run under TAE.

PROJECT:                        ADAPS

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"	
#include "adaps.h"	
#include "reangle.h"


void getpar
(
    struct PARBLK *vblock,		/* IN: pointer to TAE parameter block */
    struct FILEINFO fileinfo[],		/* OUT: File information 	      */
    char hosin[MAXIMG][CMLEN],		/* OUT: Host names of input images    */
    char hosout[][CMLEN],		/* OUT: Host name of output image     */
    int sceneptlist[MAXSCENE],		/* OUT: Scene list pointers	      */
    char sceneidlist[MAXSCENE][17],	/* OUT: Scene listing	      	      */
    int *nsceneidlist,			/* OUT: Number in sceneidlist	      */
    long *msgtim,			/* OUT: time between display messages */
    char mmflag[] 			/* OUT: min max flag buffer           */
)

{
struct VARIABLE	*val;		/* pointer to a TAE variable within v-block  */

int i;				/* Counter */


/* Get the composite images
-----------------------------*/
get_composite_info(vblock, fileinfo, hosin, hosout);


/* Get the 'scene' pointer list and 'sceneidlist' list
-------------------------------------------------------*/
val = p_find(vblock,"SCENEIDLIST");
for (i = 0; i < val->v_count; i++)
   strcpy(sceneidlist[i],SVAL(*val,i));
*nsceneidlist = val->v_count;

val = p_find(vblock,"SCENEPTLIST");
for (i = 0; i < val->v_count; i++)
    sceneptlist[i] = IVAL(*val,i);


/* Retrieve LAS globals
-----------------------*/
val = p_find(vblock,"$msgtim");
*msgtim = IVAL(*val,0);

val = p_find(vblock,"$minmax");
strcpy(mmflag,SVAL(*val,0));

}
