
/* Include file for REATMOINFO */

#ifndef REATMOINFO_H
#define REATMOINFO_H


#define MAXDAYS 20	/* Maximum number of days included in a composite */
#define MAXSCOMP 300	/* Maximum number of scenes included in a composite */
#define MAXPERIOD 2	/* Maximum number of periods included in a composite */

#define HEADER_LINES_SHORT 4	/* Number of header lines in 'short' log file */
#define HEADER_LINES_LONG  5	/* Number of header lines in 'long' log file  */

#define SHORT_FORMAT 0	/* 'Short' format log file	*/
#define LONG_FORMAT  1	/* 'Long' format log file	*/

/* Prototypes */

int process_long
(
    char linebuf[CMLEN+1],      /* INPUT:  Buffer containing line of data     */
    char datelist[][7],         /* INPUT:  List of dates in composite         */
    int *ndays,                 /* IN/OUTPUT: Number of days in date list     */
    int scenelist[],            /* IN/OUTPUT:List of scenes used in composite */
    char periods[][CMLEN],      /* INPUT:  Periods used in the composite      */
    int nperiods                /* INPUT:  Number of periods in 'periods'     */
);

int process_short
(
    char linebuf[CMLEN+1],      /* INPUT:  Buffer containing line of data     */
    char datelist[][7],         /* INPUT:  List of dates in composite         */
    int *ndays,                 /* IN/OUTPUT: Number of days in date list     */
    int scenelist[]             /* IN/OUTPUT:List of scenes used in composite */
);

void taeland
(
    struct PARBLK *vblock,      /* INPUT: TAE parameter block           */
    char datelist[][7],         /* INPUT: date listing                  */
    int scenelist[],            /* INPUT: scene list                    */
    char ozonelist[][3],        /* INPUT: ozone date listing            */
    int *ndays,                 /* INPUT: number of days in datelist    */
    int *nmonths,               /* INPUT: number of months in ozonelist */     
    int *satnum                 /* INPUT: Satellite number (14 = noaa-14)*/    
);

#endif

