/* This is a dippy little driver program for shoacqu.  It starts an instance
of shoacqu then waits for the user to hit the return key.  Each time the
user hits the return key a message is sent to shoacqu.  These are
alternating "display" and "show next time" messages.  The input files and 
times are hard coded but this could easily be modified to handle user
input.  It worked very well for development
*****************************************************************************/
#include <stdio.h>      /* standard C i/o facilities */
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>     /* Unix System Calls */
#include <sys/types.h>  /* system data type definitions */
#include <sys/socket.h> /* socket specific definitions */
#include <netinet/in.h> /* INET constants and stuff */
#include <arpa/inet.h>  /* IP address conversion stuff */


int main(int argc, char *argv[])
{
int ld,sd;
struct sockaddr_in skaddr;
struct sockaddr_in from;
int addrlen,length;
pid_t shoacqu;
int status;
char buff[100];
char msg[100];
char portarg[25];
int n;
char c;


if ((ld = socket( PF_INET, SOCK_STREAM, 0 )) < 0)
    {
    perror("Problem creating socket\n");
    exit(1);
    }

skaddr.sin_family = AF_INET;
skaddr.sin_addr.s_addr = htonl(INADDR_ANY);
skaddr.sin_port = htons(0);

if (bind(ld, (struct sockaddr *) &skaddr, sizeof(skaddr))<0)
    {
    perror("Problem binding\n");
    exit(0);
    }

length = sizeof( skaddr );
if (getsockname(ld, (struct sockaddr *) &skaddr, &length)<0)
    {
    perror("Error getsockname\n");
    exit(1);
    }

printf("The Server passive socket port number is %d\n",ntohs(skaddr.sin_port));

/* fork the child with the port number
-------------------------------------*/
sprintf( portarg, "%d", ntohs(skaddr.sin_port));
printf("%s: Starting shoacqu\n", argv[0]);
if (( shoacqu = fork()) < 0 )
    {
    perror("Error forking shoacqu\n");
    exit(1);
    }
else if ( shoacqu == 0 )
    {
    if (( execlp( "shoacqu", "shoacqu",
            "-port", portarg,
	    "-next", "10:45:30 am",
	    NULL )) < 0 )
        {
	perror("unable to execute shoacqu\n");
	return -1;
	}
    }

/* listen for shoacqu's connection
----------------------------------*/
if ( listen( ld, 5 ) < 0 )
    {
    perror("Error calling listen\n");
    exit(1);
    }

if ( (sd = accept( ld, (struct sockaddr*) &from, &addrlen)) < 0)
    {
    perror("Problem with accept call\n");
    exit(1);
    }
printf("Got a connection - processing...\n");
length = sizeof( skaddr );
if (getsockname(sd, (struct sockaddr *) &skaddr, &length)<0)
    {
    perror("Error getsockname\n");
    exit(1);
    }


/* now send a series of messages to shoacqu
-------------------------------------------*/
scanf("%c", &c);
sprintf( msg, "-file ../ah17082502183528.sf2 -dnflag d -rgb 2 2 1" );
printf("Sending: %s\nHit enter for next time\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-next 01:34:14 pm" );
printf("Sending: %s\nHit enter for next display\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-file ../ah17082502183528.sf2 -dnflag n -rgb 3 3 3 -stop 11:22:33 pm" );
printf("Sending: %s\nHit enter for next time\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-next 01:34:14 pm" );
printf("Sending: %s\nHit enter for next display\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-file ../ah17082502183528.sf2 -dnflag n -rgb 3 4 4 -stop 11:22:33 pm" );
printf("Sending: %s\nHit enter for next time\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-next 01:34:14 pm" );
printf("Sending: %s\nHit enter for next display\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-file ../ah17082502183528.sf2 -dnflag n -rgb 3 3 5 -stop 11:22:33 pm" );
printf("Sending: %s\nHit enter for next time\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-next 01:34:14 pm" );
printf("Sending: %s\nHit enter for next display\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-file ../ah17082502183528.sf2 -dnflag n -rgb 3 5 5 -stop 11:22:33 pm" );
printf("Sending: %s\nHit enter for next time\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-next 02:15:14 pm" );
printf("Sending: %s\nHit enter for next display\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-file ../ah17082502183528.sf2 -dnflag d -rgb 2 1 2 -stop 11:22:33 pm" );
printf("Sending: %s\nHit enter for next time\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));

scanf("%c", &c);
sprintf( msg, "-next 03:05:14 pm" );
printf("Sending: %s\nHit enter to quit\n",msg);
sprintf( buff, "%03d%s", strlen(msg), msg);
write( sd, buff, strlen(buff));


scanf("%c", &c);
kill( shoacqu, SIGKILL );
return 0;
}
