/*******************************************************************************
FUNCTION:	get_next_time

PURPOSE:	To read from the socket and get the next scene start time

INPUT:		socket descriptor

OUTPUT:		next scene start time

RETURNS:	none

PROJECT:	ADAPS, AVHRR Acquisition System

$Log: get_next_time.c,v $
Revision 1.1  2001/04/04 16:09:00  dlloyd
Initial checkin of shoacqu

*******************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include "shoacqu.h"


void get_next_time
    (
    int sock_fd			/* IN - socket descriptor		*/
    )
    {
    char buf[9];		/* buffer for the socket read		*/
    char msg[STRLEN];		/* log message				*/
    char str[STRLEN];		/* temporary string			*/

    int  msglength;             /* message length expected from parent  */
    int n;			/* number of bytes read from the socket	*/

    Widget w = getlabelw();	/* the text label widget for the display*/

    XmString text;		/* text to display in the label		*/


    /* Read the first 3 bytes of the message.  This contains
    the ASCII representation of the message length to expect
    and convert the string to an integer.
    --------------------------------------------------------*/
    if ( sock_fd != 0 )
	{
	n = 0;
	while ( n < 3 )
	    n += read( sock_fd, &buf[n], 3 );
	buf[n] = '\0';
	sscanf( buf, "%d", &msglength );

	/* get the start time from the socket, we are expecting
	a time as: "HH:MM Xm", make sure the string is null 
	terminated for the sprintf
	------------------------------------------------------*/
	n = 0;
	while ( n < msglength )
	    n += read( sock_fd, &buf[n], msglength );
	buf[n] = '\0';
	sprintf( str, "Next acquisition at %s", buf );
	sprintf( msg, "Acquman sent: %s", buf );
	write_log( FALSE, "get_next_time", "msg", msg );
	}
    else
	{
        sprintf( str, "No socket connection" );
	write_log( TRUE, "get_next_time", "error",
	    "Attempt to read from socket with no connection" );
	}
    text = XmStringCreateLocalized( str );

    /* Display the message by setting the widget resource
    -----------------------------------------------------*/
    XtVaSetValues( w, XmNlabelString, text, NULL );
    XmStringFree( text );
    }  /* END get_next_time */
