#ifndef SILO_H
#define SILO_H


/* Function prototypes
----------------------*/

int directory 
(
    struct PARBLK *vblock,/* IN - TAE parameter block                         */
    char *infile,       /* IN - UCFM file to get the location for             */
    long lockflg,       /* IN - Flag to ignore locked files                   */
    long maxfiles       /* IN - Maximum number of files to return             */
);

int get_location 
(
    char *infile,       /* IN  - UCFM file to get the location for            */
    long waitflg,       /* IN  - Flag to wait until the status becomes disk   */
    char *target,       /* OUT - Name of file the returned location is for    */
    char *location      /* OUT - Location of the file (disk, tape)            */
);

int getpar 
(
    struct PARBLK *vblock,      /* TAE parameter block                        */
    char subcmd[],              /* SILO subcommand                            */
    char infile[][CMLEN],       /* Input file specification                   */
    char outdir[],              /* Output directory specification             */
    char cache[],               /* Cache flag value                           */
    char link[],                /* Symbol link to create                      */
    long *lockflg,              /* Flag for ignoring locked files             */
    long *maxfiles,             /* Maximum number of files to return          */
    long *nfiles                /* Number of input files                      */
);

int siloname
(
char *infile            /* IN/OUT file name to convert                  */
);

int wildcard
(
    char infile[]               /* Input file specification                   */
);


#endif
