/* Convert a date time definition to seconds since Jan 1, 1986
Adapted from vax code.
===========================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include "timecorr.h"

#define BEGINNING_OF_TIME 1986

#define MIN_SECONDS     60
#define HOUR_SECONDS    (MIN_SECONDS * MIN_SECONDS)
#define DAY_SECONDS     (24 * HOUR_SECONDS)
#define LEAP_YR_SECONDS (366 * DAY_SECONDS)
#define YR_SECONDS      (365 * DAY_SECONDS)

long makeseconds( char *root_filename )
{

int month, day, year, hour, minute, second;
long seconds;
int yr, mn, dy;
int days_per[] = {0,31,28,31,30,31,30,31,31,30,31,30,31};
int days_per_leap[] = {0,31,29,31,30,31,30,31,31,30,31,30,31};

sscanf( &root_filename[4], "%02d%02d%02d%02d%02d%02d", &month, &day,
    &year, &hour, &minute, &second );

/* This test will break in year 2051, but entire 
algorithm will break before then -- when long
value is exceeded */
if ( year > 50 )
    year += 1900;
else
    year += 2000;

seconds = 0;
for ( yr = BEGINNING_OF_TIME; yr < year; yr++ )
    {
    if ( yr % 4 == 0 )
        seconds += LEAP_YR_SECONDS;
    else
        seconds += YR_SECONDS;
    }

for ( mn = 1; mn < month; mn++ )
    {
    if ( year % 4 == 0 )
        seconds += days_per_leap[mn] * DAY_SECONDS;
    else
        seconds += days_per[mn] * DAY_SECONDS;
    }

for ( dy = 1; dy < day; dy++ )
    seconds += DAY_SECONDS;

seconds += hour * HOUR_SECONDS;
seconds += minute * MIN_SECONDS;
seconds += second;

return seconds;
}
