#!/bin/csh -f
#
# FUNCTION: delmsch.csh
#
# PURPOSE:  Delete all but the most recent NO_TO_SAVE master schedule backup
#	    copies.  These copies reside in ADAPSTABLES, and have the file
#	    name syntax of "master.sch_NNNNNNNNNNNN", where NNNNNNNNNNNN is
#	    a 12-character numerical time stamp.
#	    This script is part of the UPDATESCH module.
#
#
# Programmer       Date   Modifications
# ---------------  -----  ------------------------------------------------------
# T.Baltzer        08/99  Development
#
#

#---------------------------------------------
# Define the number of backup copies to keep
#---------------------------------------------
set NO_TO_SAVE = 7


#----------------------------
# cd to the correct directory
#----------------------------
cd $ADAPSTABLES


#-----------------------------------------------------------
# Match all files of the form "master.sch_NNNNNNNNNNNN".
# Delete all but the most recent N copies.
#-----------------------------------------------------------
unset noglob
set files = `ls -lt master.sch_[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9] | awk '{print $9}'`
set noglob

set counter = 0
foreach file ($files)

    @ counter += 1
    if ($counter > $NO_TO_SAVE) then
	rm -f $file	
    endif

end

#--------------------------
# Successful return
#--------------------------
exit 0

