#!/bin/sh
#
# FUNCTION: mv_ephemeris.sh
#
# PURPOSE: Move daily ephemeris data into a unique file name, make a
#          backup copy of the data, and remove backup copies of the ephemeris
#          data that are more than 8 days old.
#          This script is called by opsavhrr from cron on the production
#          ADAPS system.
#
# CALLING SYNTAX:
#
#          mv_ephemeris.sh
#
#
# Programmer       Date   Modifications
# ---------------  -----  ------------------------------------------------------
# T. Baltzer       10/00  Put under CVS management
#
#
cd /sgs20/km1/opsavhrr
# Take care of the new style ephemeris files
for x in `ls s4941?????*`
do
    cp $x savefm/.
done

day="`date +%m%d`"
for i in `ls s494????`
   do
      cp $i savefm/${i}_${day}.nav
      mv $i ${i}_${day}.nav
   done
/bin/find savefm -mtime +8 -exec rm {} \;

