#include	"acquman.h"
int get_offset( int now );
/*
==========================================================================
==									==
==			ACQUISITION MANAGER				==
==									==
==									==
==========================================================================
*/
/*
==========================================================
==							==
==	MACRO to enhance code readability		==
==							==
==========================================================
*/
#define	ABORT(string)					\
	{						\
	wo.stat[0] = MISSED;				\
	LOGENTRY"ACQUMAN>>%s\n",string);		\
	LOGENTRY"ACQUMAN>>record = ");			\
	LOGENTRY SCHEDULE_FORMAT,wo.scene_id,wo.satid,	\
		wo.lstart,wo.lstop,			\
		wo.rstart,wo.rstop,			\
		wo.opcode,wo.stat,wo.tfile,		\
		wo.pflag,wo.dnflag,wo.station,		\
		wo.atype,wo.orbit);			\
	LOGENTRY "\n");					\
	markstat(wo);					\
	mbx_buffer[0]=ACQUIRE_SAYS_GO;			\
	mbx_status = sys$qio(0,mbx_chan,IO$_WRITEVBLK,&mbx_iosb,0,0, \
		mbx_buffer,1,0,0,0,0);			\
	if (!(mbx_status & 1 ))				\
		LOGENTRY"ACQUMAN>>Error %d writing mailbox\n", mbx_status); \
	droplog(wo.scene_id,"ACQUIRE-FAIL",		\
		"ACQUISITION UNSUCCESSFULLY COMPLETED", \
		proclog_name);				\
	goto	CONTINUE;				\
	}
/*======================================================*/
#define MBX_BUFSZ 512
#define MBX_BUFQUO 10000
#define ACQUIRE_SAYS_GO 1
#define ACQUIRE_SAYS_STOP 2

/* Peritek stuff */
union
	{
	unsigned char sysa[1024];
	struct
		{
		unsigned char filler1[300];
		int lines_scrolled;
		unsigned char filler2[720];
		} fields;
	} per;
short quicklook_flag;
union
	{
	struct
		{
		char	r[1];
		char	g[1];
		char	b[1];
		} rgb;
	short scroll;
	} stash_scroll;
char prev_text[33] = "";

main()
{
int	offset = 0;
int	i, records, now, millisec, mode, disk_bad_flag=0, numsat, do_text;
int	next;				/* seconds till next pass */
int inttime;
char am_pm[3];
struct tm *tmptr;
char	text[33];			/* Peritek text */
struct	SCHED	wo;			/* WORK ORDER: one schedule record*/
char	STATAB[4] = {MISSED,DISK,TAPE,BOTH};
enum	READWRITE	lastact = PLAYBACK;
char	buffer[80+1];
int	yr, day, hour, min, sec, tick;
int	mbx_chan,mbx_status;
$DESCRIPTOR(mbx_logical,"WALLOPS_MBX");
struct
{
	short status;
	short count;
	int devdep;
} mbx_iosb;

char mbx_buffer[MBX_BUFSZ];

/************** Following lines used in checking QUICKLOOK logical ************/
unsigned char acmode[1] = '\2';

$DESCRIPTOR(logical, "QUICKLOOK");
$DESCRIPTOR(lnm_table, "LNM$SYSTEM_TABLE");
char	equiv[25];
int	equiv_len;

struct {
	unsigned short	s_buffer_length;
	unsigned short	s_item_code;
	char		*s_buffer_address;
	short		*s_return_length_address;

	int	end;
	} trnlnm_itmlst = {25 , 2, &equiv, &equiv_len, 0};


int	trnlnm_status;

/******************************************************************************/
LOGFILE = fopen(LOGNAME,"w");

trnlnm_status = SYS$TRNLNM(0, &lnm_table, &logical, acmode, &trnlnm_itmlst);
equiv[equiv_len] = '\0';
quicklook_flag = 0;
if ((trnlnm_status == 1) && (strncmp(equiv,"TRUE",4) == 0))
	{
	quicklook_flag = 1;
	/* Initialize peritek once */
	sysint(per.sysa,1);
	vckint(0,0,0,0,0);
	gcntl(0,1);
	for (i = 0; i < 256; i++)		/* Define color map bbggrrrr */
		cmap(0, i,
			 (i & 0xf0)+(i>>4),
	 		((i & 0x0f) * 17),
	 		((i & 0x0f) * 17));
	setpl(0);				/* Select primary plane */
	clearall();
	/* NOTE: The following line is required to be between Peritek's routines
   	   and our usgs routines, otherwise the system will crash! */
	setpl(0);				/* req to prevent crash */
	do_text = 1;
	LOGENTRY BANNER_QUICKLOOK
	}
    else
	{
	quicklook_flag = 0;
	do_text = 0;
	LOGENTRY BANNER
	}

LOGENTRY"ACQUISITION MANAGER PACKAGE Y2K Compliant:	RELEASE DATE = 08/02/1999\n");
LOGENTRY"Leap year patch:	RELEASE DATE = 01/09/2001\n");
LOGENTRY"New delta algorithm:	RELEASE DATE = 10/18/2001\n");
LOGENTRY"NOAA 17 support:	RELEASE DATE = 06/24/2002\n");

nbstime(&day,&hour,&min,&sec,&tick);
LOGENTRY"!			DATA QUALITY REPORT\n");
LOGENTRY"!		BEGINNING:	%03d,%02d:%02d:%02d\n",
					 day,hour,min, sec);

mbx_status = sys$assign(&mbx_logical,&mbx_chan,0,0);
if (!(mbx_status & 1 ))
	LOGENTRY"ACQUMAN>>Error %d opening mailbox\n", mbx_status); 

BEGINNING:
while(OK == getinstr(&wo))
	{
	if (strcmp(wo.satid,"N09") == 0)
		numsat = 1;
	  else if (strcmp(wo.satid,"N10") == 0)
		numsat = 2;
	  else if (strcmp(wo.satid,"N11") == 0)
		numsat = 3;
	  else if (strcmp(wo.satid,"N12") == 0)
		numsat = 4;
	  /* NOAA 13 is doing space research..... */
	  else if (strcmp(wo.satid,"N14") == 0)
		numsat = 5;
	  else if (strcmp(wo.satid,"N15") == 0)
		numsat = 6;
	  else if (strcmp(wo.satid,"N16") == 0)
		numsat = 7;
	  else if (strcmp(wo.satid,"N17") == 0)
		numsat = 8;

	if((wo.opcode&0x0c)==0)		/* request is for a live acquisition */
		{
		nbsecond(&now);
		offset = get_offset( now );
#ifdef	DEBUG
	LOGENTRY"ACQUMAN> Calculated NBS offset is %d seconds\n",offset);
#endif	DEBUG
		if(now > wo.lstop)ABORT("scheduled acquisition missed");
		if (do_text == 1)
			{
			next = wo.lstart - now;
			if (next <= 0)
			    {
			    quicklook_text("  Next acquisition pending....");
			    prev_text[0] = 0;		/* so it displays */
			    }
			  else
			    {
			    make_julian(offset+wo.lstart,&yr,&day,&hour,&min,&sec);
			    if (hour < 12)
				strcpy(am_pm,"AM");
			      else
				{
				strcpy(am_pm,"PM");
				if (hour > 12)
					hour -= 12;
				}
			    sprintf(text,"  Next acquisition at %2d:%02d %s",
				hour,min,am_pm);
			    quicklook_text(text);
			    }
			/* do_text = 0; */
			}
		if((wo.lstart - NEARA - now) > PERIODAEMON)goto HIBERNATE;
		}

	if((wo.opcode&0x06)==6)ABORT("invalid op. code");

/* The following entry point is used when this is a DISH->DISK pass but the
   disk is full.  When we come here, wo.opcode has been modified to indicate
   DISH->TAPE */
DISK_PROBLEM:
	mode = wo.opcode;

LOGENTRY"!\n! SCENE ID: %s\n",wo.scene_id);
make_julian(wo.lstart,&yr,&day,&hour,&min,&sec);
LOGENTRY"!	SCHEDULED START TIME:	%03d:%02d:%02d:%02d\n",
					day, hour, min, sec);
make_julian(wo.lstop,&yr,&day,&hour,&min,&sec);
LOGENTRY"!	SCHEDULED STOP TIME:	%03d:%02d:%02d:%02d\n",
					day, hour, min, sec);

	if((wo.opcode&0x07)==1)
		{
		droplog(wo.scene_id,"ACQUIRE-START",
				"DISH to DISK transfer initiated",proclog_name);
		LOGENTRY"!	DATA SOURCE:		ANTENNA\n");
		LOGENTRY"!	DATA DESTINATION:	IMAGE DISK\n");
		}
	else if((wo.opcode&0x07)==2)
		{
		droplog(wo.scene_id,"ACQUIRE-START",
				"DISH to TAPE transfer initiated",proclog_name);
		LOGENTRY"!	DATA SOURCE:		ANTENNA\n");
		LOGENTRY"!	DATA DESTINATION:	HIGH DENSITY TAPE\n");
		}
	else if((wo.opcode&0x07)==3)
		{
		droplog(wo.scene_id,"ACQUIRE-START",
				"DISH to BOTH transfer initiated",proclog_name);
		LOGENTRY"!	DATA SOURCE:		ANTENNA\n");
		LOGENTRY"!	DATA DESTINATION:	HIGH DENSITY TAPE\n");
		LOGENTRY"!	DATA DESTINATION:	IMAGE DISK\n");
		}
	else if((wo.opcode&0x07)==5)
		{
		droplog(wo.scene_id,"ACQUIRE-START",
				"TAPE to DISK transfer initiated",proclog_name);
		LOGENTRY"!	DATA SOURCE:		HIGH DENSITY TAPE\n");
		LOGENTRY"!	DATA DESTINATION:	IMAGE DISK\n");
		}

	if((wo.opcode&0x0f)==SOFTPATGEN)
		{
		if(OK != acquire(&mode,numsat,wo.lstart,wo.lstop,
		wo.scene_id,wo.station))ABORT("TESTtoDISK transfer error!\n");
		goto	FINISH;
		}

	if((wo.opcode&0x08)==0)		/* not synthetic data	*/
		{
		if((wo.opcode&0x04)==0)	/* data from the receiver */
			{
			if(OK != scanacu(numsat))
				ABORT("acquisition never scheduled by ACU");
			nbsecond(&now);
#ifdef	DEBUG
	LOGENTRY"ACQUMAN> sleep for %d seconds\n",wo.lstart-NEARR-now);
#endif	DEBUG
			if(wo.lstart>(NEARR+now))
				{
				fclose(LOGFILE);
				sleep(wo.lstart-NEARR-now);
				LOGFILE = fopen(LOGNAME,"a");
				nbsecond(&now);
				}
			/* Ask Wallops inhale to cease */
			mbx_buffer[0]=ACQUIRE_SAYS_STOP;
			mbx_status = sys$qio(0,mbx_chan,IO$_WRITEVBLK,
				&mbx_iosb,0,0,mbx_buffer,1,0,0,0,0);
			if (!(mbx_status & 1 ))
				LOGENTRY"ACQUMAN>>Error %d writing mailbox\n",
				mbx_status); 
			sleep(5);
			/* Avoid pipeline setup if we are forcing pass to tape - save time */
			if(disk_bad_flag == 1)
				disk_bad_flag = 0;
			    else if(OK != setupipe(wo.opcode,numsat))
				ABORT("unable to initialize data pipeline");
			}
		else	{		/* data from the HDT	*/
			/* Ask Wallops inhale to cease */
			mbx_buffer[0]=ACQUIRE_SAYS_STOP;
			mbx_status = sys$qio(0,mbx_chan,IO$_WRITEVBLK,
				&mbx_iosb,0,0,mbx_buffer,1,0,0,0,0);
			if (!(mbx_status & 1 ))
				LOGENTRY"ACQUMAN>>Error %d writing mailbox\n",
				mbx_status); 
			if (do_text == 1)
			    {
			    quicklook_text("  Next acquisition pending....");
			    prev_text[0] = 0;		/* so it displays */
			    }
			sleep(3);
			/* Avoid pipeline setup if we are forcing pass to tape - save time */
			if(disk_bad_flag == 1)
				disk_bad_flag = 0;
			    else if(OK != setupipe(wo.opcode,numsat))
				ABORT("unable to initialize data pipeline");
			lastact = PLAYBACK;
			if(OK != searchdt(wo.lstart,wo.tfile))
				ABORT("scene not found on HDT");
			}
		}

	if( (wo.opcode&0x06) != 0 )	/*HDT will be used*/
		{
		if((wo.opcode&0x02)==2)	/* writing scene to HDT */
			{
/******************	if(lastact == PLAYBACK)mountape(0);
******************/	lastact = RECORD;
			}
		if(OK != startape(&wo.tfile,(wo.opcode>>2)&0x01))
			ABORT("error starting HDTRecorder");
		sprintf(buffer,"HDTR file number is %d",wo.tfile);
		droplog(wo.scene_id,"ACQUIRE",buffer,proclog_name);
		}
	if((wo.opcode&0x01)==1)
		{
		if(OK != acquire(&mode,numsat,
				wo.lstart,wo.lstop,wo.scene_id,wo.station))
		    {
		    if((wo.opcode&0x06)!=0)
			mode &= 0xfe;
		      else
			{
			LOGENTRY"ACQUMAN>>DISHtoDISK transfer error!\n");
			LOGENTRY"ACQUMAN>>Attempting DISHtoTAPE!\n");
			wo.opcode &= 0xfe;	/* Turn off DISK bit */
			wo.opcode |= 0x02;	/* Turn on TAPE bit */
			disk_bad_flag = 1;	/* So we don't setup pipeline */
			goto DISK_PROBLEM;
			}
		    }
		}
	if( (wo.opcode&0x06) != 0 )
		{
		if((wo.opcode&0x04)==0)	/* not a playback */
			{
			if (do_text == 1)
			    {
			    quicklook_text("  Next acquisition unavailable");
			    prev_text[0] = 0;		/* so it displays */
			    }
			nbsecond(&now);
			LOGENTRY"ACQUMAN> sleep for %d seconds\n",
				wo.lstop-now);
			fclose(LOGFILE);
			if(wo.lstop>now)sleep(wo.lstop-now);
			LOGFILE = fopen(LOGNAME,"a");
			}
		if(OK != stoptape(wo.tfile,wo.opcode))
			ABORT("HDTR error after recording pass");
		}
	if((wo.opcode&0x04)==0)acumode(OFF);		/* park the dish */
FINISH:
	/* Tell Wallops inhale to continue */
	mbx_buffer[0]=ACQUIRE_SAYS_GO;
	mbx_status = sys$qio(0,mbx_chan,IO$_WRITEVBLK,&mbx_iosb,0,0,
		mbx_buffer,1,0,0,0,0);
	if (!(mbx_status & 1 ))
		LOGENTRY"ACQUMAN>>Error %d writing mailbox\n", mbx_status); 

	wo.stat[0] = STATAB[mode&0x03];
	markstat(wo);					/*set schedule flag*/
	if (quicklook_flag == 1)
		do_text = 1;
	droplog(wo.scene_id,"ACQUIRE-DONE",
		"acquisition successfully completed",proclog_name);
CONTINUE:;
	}
HIBERNATE:;
#ifdef	FOROPS
LOGENTRY"ACQUMAN> sleep %d seconds and then start over\n\n",PERIODAEMON);
#endif	FOROPS
fclose(LOGFILE);
sleep(PERIODAEMON);
LOGFILE = fopen(LOGNAME,"a");
goto BEGINNING;
}
