/*========================================================================
==									==
==	ACQUMAN.H  This is the include file that is used by all parts	==
==			of the ACQUISITION MANAGEMENT PACKAGE.		==
==									==
========================================================================*/

/*========================================================================
==			OTHER FILES TO BE INCLUDED			==
========================================================================*/
#include	<time.h>
#include	<prvdef.h>
#include	<desc.h>
#include	<descrip.h>
#include	<opcdef.h>
#include	<rmsdef.h>
#include	<iodef.h>
#include	<dvidef.h>
#include	<sjcdef.h>
#include	<jbcmsgdef.h>
#include	<stdio.h>
#include	<ssdef.h>
#include	<jpidef.h>
#include	"adaps_inc:sched.h"
#include	<stdlib.h>
/*========================================================================
==		Process FLOW and REPORTING control flags		==
========================================================================*/
/* #define SINGLESTEP	  	/* interactive work order entry */
/* #define SUSPEND 		/* SUSPEND COMPETING PROCESSES */
#define FOROPS  		/* print stuff for operators to look at*/
#define DEBUG   		/* print asundry FLOW DOCUMENTING statements*/
#define	PERIODAEMON	60*10

#define LOGNAME 		"adapstables:eros.log"
/* #define LOGNAME "SYS$OUTPUT"	/*name of file for DEBUG output and errors */

FILE	*LOGFILE;		/* stream pointer of file LOGNAME */
#define	LOGENTRY fprintf(LOGFILE,

#define	BANNER		 "RELEASED ACQUIRE DAEMON WITHOUT QUICKLOOK DISPLAY.\n");
#define	BANNER_QUICKLOOK "RELEASED ACQUIRE DAEMON WITH QUICKLOOK DISPLAY.\n");
char proclog_name[] = "adapstables:EROS.PROCLOG";
/*========================================================================
==									==
========================================================================*/
#define EFTIM	4
#define EFCLK	8
#define EFPIP	12
#define EFDAT	16
#define EFFIL	20
#define	EFTTY	24

#define	EFMTIM	(EFTIM<<1)
#define	EFMDAT	(EFDAT<<1)

/*========================================================================
==      Offset to be added to local time year if clock is set back      ==
========================================================================*/
#define YEAR_OFFSET      0	/* make 28 if clock set to 1971	*/


/*========================================================================
==	Fairchild 760 buffered-interface-board control definitions	==
========================================================================*/
#define	IO$_RESET	IO$_SPACERECORD
#define	IO$_RCYCLIC	1
#define IO$_RREGISTER	2
#define	IO$_WREGISTER	5
#define	IO$_WDISCRETE	6

/*========================================================================
==	PIPELINE CONTROL BUS MODULE ADDRESSES AND PARAMETERS		==
========================================================================*/
#define	BITSYNC	0	/* module address for the model 726 Bit-Synch.	*/
#define	AXBSYNC	2	/* module address for the model 720 Bit-Synch.	*/
#define	FRAMSNC	1	/* module address for the Frame-Synchronizer.	*/

/* #define BIT_SYNCH_726	/* Un-comment to switch to 726 bit synch */

/* char	LIVBITRAT[8] = "6.654e5";
/* char	PBCKBTRAT[8] = "1.331e6"; /* true high speed bit rate for 720 */
/* char	PBCKBTRAT[8] = "1.325e6"; /* kludged high speed rate for 726 */

char	LIVBITRAT[8] = "6.623e5"; /* Live low speed rate for 726 */
char	PBCKBTRAT[8] = "6.623e5"; /* Tape low speed rate for 726 */
char	LIVBITAUX[8] = "6.654e5"; /* Live low speed rate for 720 */
char	PBCKBTAUX[8] = "6.654e5"; /* Tape low speed rate for 720 */

/*========================================================================
==	RS-232 PERIFERAL CONTROL PORT CONFIGURATION PARAMETERS		==
========================================================================*/
#define	ACURS232	"acu_port"	/*logical name of serial I/O port  */
#define	HDTRS232	"hdt_port"	/*logical name of serial I/O port  */
#define RCVRS232	"rcv_port"	/*logical name of serial I/O port  */
#define	TTYMEOUT	5		/*time-out for serial I/O in sec.  */

/*========================================================================
==	HIGH DENSITY TAPE RECORDER/READER  control parameters.		==
========================================================================*/
#define	FILESIZE	2500		/*feet of tape in one logical file */
#define	FILONTRK	3		/*number of files on one HDT track */
#define	SSPDWRIT	"CS30"		/*30ips; SET SPEED for record ops */
#define SSPDREAD	"CS30"		/*30ips; SET speed for read ops   */
/* #define SSPDREAD	"CS60"		/*60ips; SET speed for read ops   */

#define	EXTRASPACE	50		/*feet of tape for overshoot	  */
enum	READWRITE	{RECORD, PLAYBACK};

/*========================================================================
==	SATELITE CLOCK CORRECTION databases and control parameters	==
========================================================================*/
char	*SATIMERR[9] = {"",	"adapstables:SATIMERR.N09" , 
				"adapstables:SATIMERR.N10" ,
				"adapstables:SATIMERR.N11" ,
				"adapstables:SATIMERR.N12" ,
				"adapstables:SATIMERR.N14" ,
				"adapstables:SATIMERR.N15" ,
				"adapstables:SATIMERR.N16" ,
				"adapstables:SATIMERR.N17" };
char	*SATIME1K[9] = {"",	"adapstables:NOAA09.TIMCOR" , 
				"adapstables:NOAA10.TIMCOR" ,
				"adapstables:NOAA11.TIMCOR" ,
				"adapstables:NOAA12.TIMCOR" ,
				"adapstables:NOAA14.TIMCOR" ,
				"adapstables:NOAA15.TIMCOR" ,
				"adapstables:NOAA16.TIMCOR" ,
				"adapstables:NOAA17.TIMCOR" };
#define	SAMPLES	15	/* records to average for a new entry in database*/
#define	MAXELE	20	/* MAXIMUM no. of datapoints in the error databases. */
#define	ORDER	1	/* the order of the regression to be performed */
#define	PROPDLAY 167

/*========================================================================
==			    HRPT DATA BUFFERS				==
========================================================================*/
#define NUMBUF	4		/* number of buffers used in cyclic reads  */
#define	WORDCNT	11090		/* number of 16-bit words in 1 minor frame */
#define	BYTECNT	WORDCNT*2	/* number of bytes in one HRPT minor frame */
#define	TOTSIZ	44*256		/* number of bytes in a frame that on disk */

/* The following line ensures that hrptbuff is quadword aligned, so that the
BCDRIVER may use buffered data path to speed throughput. */
int	_align( QUADWORD ) align_filler[2];

short	hrptbuff[NUMBUF][TOTSIZ];		  /* NOTE 44 * 256 = 11264 */

/*========================================================================
==	PARAMETERS TO "acumode" to select/deselect PROG. AUTO		==
========================================================================*/
#define	ON	1
#define	OFF	0
/*========================================================================
==	Stuff that used to be in scheduledefs.h				==
========================================================================*/
struct	MONTHDAY
	{
	char	month, day;
	};
#include	"monthday.table"
#define	GETSCHREC(stream,rp) \
		fscanf(stream, SCHEDULE_FORMAT, &((rp)->scene_id), \
			&((rp)->satid), &((rp)->lstart), &((rp)->lstop), \
			&((rp)->rstart), &((rp)->rstop), \
			&((rp)->opcode), &((rp)->stat), &((rp)->tfile), \
			&((rp)->pflag), &((rp)->dnflag), &((rp)->station), \
			&((rp)->atype), &((rp)->orbit))

#define	PUTSCHREC(stream,rp) \
		fprintf(stream, SCHEDULE_FORMAT, (rp)->scene_id, (rp)->satid, \
			(rp)->lstart, (rp)->lstop, (rp)->rstart, (rp)->rstop, \
			(rp)->opcode, (rp)->stat, (rp)->tfile, (rp)->pflag, \
			(rp)->dnflag, (rp)->station, (rp)->atype, \
			(rp)->orbit)

#define	START_OF_TIME	1986

#define	JULGRE(yr,jdy,mnth,dy) \
	if ( (0!=(yr)%4) || ( (0==(yr)%100) && (0!=(yr)%400) ) ) \
	     { (mnth) = (REG+jdy-1)->month, (dy) = (REG+jdy-1)->day; } \
	else { (mnth) = (LEAP+jdy-1)->month, (dy) = (LEAP+jdy-1)->day; }

#define	JULTIM_TO_TOTSECS(scs,mns,hrs,dys,yr,optm) \
	            (optm) = (scs) + 60*(mns) + 3600*(hrs) + 86400*((dys)-1) + \
	                86400*(int)(.25+365.25*(float) \
	                    ((yr) - (START_OF_TIME%100) + \
	                    (((yr)<(START_OF_TIME%100))?100:0)))

#define	TRUE	1
#define	FALSE	0
#define	OK	(SS$_NORMAL)
#define	NOTOK	(SS$_ABORT)

#define	NEARR	30
#define	NEARA	600


/***************************************
Added for CR 5258
***************************************/
#define STDDEV_THRESH   1.0     /* stdev must be <= to this value       */
#define MIN_MEAN_COUNT  5       /* must have at least this number of    */
                                /* values in the mean to be used        */
#define MAXDELTADIFF    10      /* the difference between the measured  */
                                /* and calculated time differences must */
                                /* be no larger than this number of ms  */
                                /* to use the calculated difference     */
#define MEAN_ERROR      -9999   /* must be a large negative number so   */
                                /* as not to be confused with an actual */
                                /* time difference                      */
#define SATIME1K_THRESH	50      /* if the difference between measured	*/
                                /* and calculated deltas is greater than*/
                                /* this, restart the error time series	*/
