#include	"acquman.h"

#define	ETX	0x03
#define	ACK	0x06
#define	NAK	0x15
#define	LENGTH	160

short	line, ttopen();

acumode(onoff)
int	onoff;
{
char	outbuf[LENGTH];
int	i, count, quad[2], fails;

struct DESC opdesc;

struct outline {
	char msgtype[1];
	char msgtarg[3];
	int  msgnum;
	char comment[128];
}opline;

fails = 0;
opline.msgtype[0] = 3;
opline.msgtarg[0] = 1;
opline.msgtarg[1] = 0;
opline.msgtarg[2] = 0;
opline.msgnum = 0;
sprintf(opline.comment,"\007\007\007 %s \n\n",
 "**** ACQUIRE cannot control ACU.  Please check ACU and/or restart now! ****");
opline.comment[127]='\0';
opdesc.addr = &opline;
opdesc.length = strlen(opline.comment) + 5;

SENDIT:
line = ttopen(ACURS232);
sendch(line,&(0x05),1);
if (OK != getans(outbuf))
	{
	ttclos(line);
	fails++;			/* got halfass answer */
	if (fails <= 5)			/* re-try up to 5 times */
		{
		sleep(5);
		goto SENDIT;
		}
	LOGENTRY"ACUMODE>>Couldn't clear ACU interface after 5 tries\n");
	sys$sndopr(&opdesc,0);
	return(NOTOK);
	}
if(outbuf[0]==NAK)
	{
	LOGENTRY"\nACUMODE>>OPEN or INIT. FAILURE\n");
	ttclos(line);
	return(NOTOK);
	}
if(onoff == ON)	sndcmd("P00W6161R2");	/* Put in auto to track next pass */
else		sndcmd("P00W3030R2");	/* Park it */

if(OK != getans(outbuf))
	{
	ttclos(line);
	fails++;			/* got halfass answer */
	if (fails <= 5)			/* re-try up to 5 times */
		{
		sleep(5);
		goto SENDIT;
		}
	LOGENTRY"ACUMODE>>Couldn't set ACU mode after 5 tries\n");
	sys$sndopr(&opdesc,0);
	return(NOTOK);
	}

LOGENTRY"ACUMODE>ACU MODE RESPONSE: %s\n",outbuf);

ttclos(line);

if(OK!=halfass(outbuf))
	{
	fails++;			/* got halfass answer */
	if (fails <= 5)			/* re-try up to 5 times */
		{
		sleep(5);
		goto SENDIT;
		}
	LOGENTRY"ACUMODE>>Couldn't set mode on ACU after 5 tries\n");
	sys$sndopr(&opdesc,0);
	return(NOTOK);
	}


if(outbuf[0] != outbuf[1])
	{
	LOGENTRY"ACUMODE>>READBACK MISMATCH ERROR:%02x %02x\n",
							outbuf[0], outbuf[1]);
	return(NOTOK);
	}
if(onoff == ON)	{if(outbuf[0] == 0x61)return(OK);}
else		{if(outbuf[0] == 0x30)return(OK);}

LOGENTRY"ACUMODE>>UNEXPECTED READBACK: %02x %02x\n",outbuf[0], outbuf[1]);
return(NOTOK);
}

askacu(nextsat,tilthen)
int	*nextsat, *tilthen;
{
char	outbuf[LENGTH];

line = ttopen(ACURS232);

sendch(line,&(0x05),1);getans(outbuf);if(outbuf[0]==NAK)
	{
	LOGENTRY"ASKACU>>OPEN or INIT. FAILURE\n");
	ttclos(line);
	return(NOTOK);
	}
sndcmd("p6erc");getans(outbuf);halfass(outbuf);

#ifdef	DEBUG
LOGENTRY"ASKACU>ACU STATUS DISPLAY: %s\n",outbuf);
#endif	DEBUG

if((outbuf[2] == ':')&&(outbuf[5] == ':')&&(outbuf[8] == ':'))
	{
	*tilthen = 3600*(10*(outbuf[3]&0x0f)+(outbuf[4]&0x0f))
		   +60*	(10*(outbuf[6]&0x0f)+(outbuf[7]&0x0f))
		   +	(10*(outbuf[9]&0x0f)+(outbuf[10]&0x0f));
	*nextsat = outbuf[1]&0x0f;
#ifdef	DEBUG
	LOGENTRY"ASKACU>will track sat. #%d in %d seconds\n",*nextsat,*tilthen);
#endif	DEBUG
	}
else if((outbuf[0]=='T')&&(outbuf[1]=='R')&&(outbuf[2]=='A')&&(outbuf[3]=='C')
      &&(outbuf[4]=='K')&&(outbuf[5]=='I')&&(outbuf[6]=='N')&&(outbuf[7]=='G'))
	{
	*tilthen = 0;
	*nextsat = outbuf[9];
#ifdef	DEBUG
	LOGENTRY"ASKACU>is tracking sat. #%d \n",*nextsat);
#endif	DEBUG
	}
else	{
	LOGENTRY"ASKACU>>can't tell what is happening\n");
	*tilthen = 0;
	*nextsat = 0;
	}
ttclos(line);
return(OK);
}

telacu()
/*
this routine tells the ACU to abort the current
acquisition from its internal schedule.
*/
{
char	outbuf[LENGTH];

line = ttopen(ACURS232);

sendch(line,&(0x05),1);getans(outbuf);if(outbuf[0]==NAK)
	{
	LOGENTRY"TELACU>>OPEN or INIT. FAILURE\n");
	ttclos(line);
	return(NOTOK);
	}
sndcmd("p6dw11p6cwf0");getans(outbuf);
sleep(1);
return(OK);
}

halfass(string)
unsigned char	string[];
{
int	i, j;

for(i=0;string[i]!=00;i++)
	{
	string[i]&=0x7f;
	if(string[i]>='a')string[i] -= ('a'-'A');
	if(string[i]>='A')string[i] -= ('A'-('9'+1));
	if((string[i] < '0')||(string[i] > ('9'+6)))
		{
		LOGENTRY"HALFASS>>NON-NUMERIC CHARACTER IN STRING\n");
		return(NOTOK);
		}
	string[i]&=0x0f;
	}
if((i&0x01)!=0)
	{
	LOGENTRY"HALFASS>>odd number of characters in string: %d\n",i);
	return(NOTOK);
	}
if(i>=LENGTH)
	{
	LOGENTRY"HALFASS>>wandered off end of string after %d\n",i);
	return(NOTOK);
	}
j = i/2;
for(i=0;i<j;i++)string[i] = (string[2*i]<<4) | string[2*i+1];string[i] = 0x00;
return(OK);
}

sndcmd(inbuf)
char	inbuf[];
{
int	i;
char	echo;

for(i=0;(inbuf[i]!='\n')&&(inbuf[i]!=00);i++)
	{
/* #ifdef	DEBUG
	LOGENTRY"SNDCMD>send %x",inbuf[i]);
#endif	DEBUG /* */
	sendch(line,&inbuf[i],1);
	readch(line,&inbuf[i],1);
/* #ifdef	DEBUG
	LOGENTRY"	get echo %x\n",inbuf[i]);
#endif	DEBUG /* */
	}
echo = '\r';
/* #ifdef	DEBUG
	LOGENTRY"SNDCMD>send %x",echo);
#endif	DEBUG /* */
sendch(line,&echo,1);
readch(line,&echo,1);
/* #ifdef	DEBUG
	LOGENTRY"	get echo %x\n",echo);
#endif	DEBUG /* */
}

getans(outbuf)
char	outbuf[];
{
int	i;
i=0;
do	{
	if (OK != readch(line,&outbuf[i],1))
		{
		LOGENTRY"GETANS>>Error reading ACU line\n");
		return(NOTOK);
		}
	outbuf[i]&=0x7f;
/* #ifdef	DEBUG
	LOGENTRY"GETANS> %d	%x\n",i,outbuf[i]);
#endif	DEBUG	/**/
	if(outbuf[i] == NAK)
		{
		LOGENTRY"GETANS>>ACU PROTOCOL ERROR:<NAK> RECEIVED FROM ACU\n");
		return(NOTOK);
		}
	if((outbuf[i]==ETX)||(outbuf[i]>=0x20))i++;
	}while	((outbuf[i-1]!=ETX)&&(i<=LENGTH));

#ifdef DEBUG
LOGENTRY"GETANS> %d characters received from ACU\n",i-1);
#endif	DEBUG	/**/ 

if((i>=LENGTH)||(i<1))
	{
	LOGENTRY"GETANS>>ACU protocol violation!?\n");
	return(NOTOK);
	}
outbuf[i-1] = 0;
return(OK);
}
