*******************************************************************************
C	SUBROUTINE LOGWRT
C
C	PURPOSE:
C	Open the log file, Write a log record, and then Close the log file.
C
*******************************************************************************
	INTEGER FUNCTION LOGWRT(ID,CODE,TEXT,LOGNAME)

	IMPLICIT NONE

	CHARACTER	id*16,		! Scene ID
     .			code*16,	! Operation code
     .			text*60,	! Description text
     .			logname*60,	! Logfile name
     .			sceneid*16,	! Scene ID
     .			opcode*16,	! Operation code
     .			descrip*60,	! Description text
     .			blank*60,	! A bunch of blanks
     .			idate*9,	! Current date
     .			itime*8		! Current time

	INTEGER		t
	INTEGER		status		! Status return value

	INTEGER		lun/1/		! Log file output LUN

	blank='                                                         '

	t = index(id,char(0)) - 1
	if (t .le. 0) then
	    sceneid = id
	else
	    sceneid = id(1:t) // blank(1:16-t)
	end if

	t = index(code,char(0)) - 1
	if (t .le. 0) then
	    opcode = code
	else
	    opcode = code(1:t) // blank(1:16-t)
	end if

	t = index(text,char(0)) - 1
	if (t .le. 0) then
	    descrip = text
	else
	    descrip = text(1:t) // blank(1:60-t)
	end if

C Get the current date and time
	call date(idate)
	call time(itime)

C Open a data file for the log file
	OPEN(LUN,file=logname,access='APPEND',
     .	     status='UNKNOWN',err=90,iostat=STATUS)

	status = 1

C Write the record text string to the log file.
	WRITE(LUN,100) SCENEID, IDATE, ITIME, OPCODE, DESCRIP

C Close the log file.
	CLOSE(LUN)

 90	logwrt = status

 100	FORMAT (1x,a16,3x,a9,3x,a8,3x,a16,3x,a60)

	return
	end
