#include	"acquman.h"

/*========================================================================
==									==
==	Following are the several subroutines that do specific details	==
==	of the acquisition-managment task.				==
==									==
========================================================================*/


nbstime(days,hours,minutes,seconds,ticks)
int	*days, *hours, *minutes, *seconds, *ticks;
/*
This simply checks the National Bureau of Standards time.
*/
{
int	i, j, clock_loop=0;
int	funct;
int	sys$assign(), sys$qiow();
short	isb[4], ischan, timecode[4], temp[4];
$DESCRIPTOR(desc,"_ISA0");

j = sys$assign (&desc,&ischan,0,0);
if(j&0x01==0)
	{
	LOGENTRY"NBSTIME>> ERROR ATTACHING TO THE DSS-11\n");
	return(NOTOK);
	}

READCLOCK:;
clock_loop++;
if (clock_loop >= 10)
	{
	sys$dassgn(ischan);
	return(NOTOK);
	}
/*funct = IO$_READVBLK | IO$M_INTERRUPT;*/
funct = IO$_READVBLK;
j = sys$qiow(EFCLK,ischan,funct,isb,0,0,timecode,0,0,0,0,0);
if(j&0x01==0)
	{
	LOGENTRY"NBSTIME> ERROR INITIATING A READ FROM THE DSS-11\n");
	LOGENTRY"NBSTIME> return status = %d\n",j);
	sys$dassgn(ischan);
	return(NOTOK);
	}
else if(isb[0]&0x01 == 0)
	{
	LOGENTRY"NBSTIME> ERROR READING FROM THE DSS-11\n");
	LOGENTRY"NBSTIME> IOSB[0] = %d\n",isb[0]);
	sys$dassgn(ischan);
	return(NOTOK);
	}

/* ifdef	DEBUG
	LOGENTRY"NBSTIME> timestamp = 0X %04x %04x %04x %04x\n",
	timecode[3]&0xffff,timecode[2]&0xffff,
	timecode[1]&0xffff,timecode[0]&0xffff);
endif	DEBUG	/* */

if((timecode[1]&0x0001)!=0)
	{
	LOGENTRY"NBSTIME> INVALID CLOCK READ: try again\n");
	goto READCLOCK;
	}

sys$dassgn(ischan);

*days	= 100 * (0x03 & (timecode[2] >> 14))
	+ 10  * (0x0f & (timecode[2] >> 10))
	+	(0x0f & (timecode[2] >> 06));

*hours	= 10 *	(0x03 & (timecode[2] >> 04))
	+	(0x0f & (timecode[2] >> 00));

*minutes = 10 *	(0x07 & (timecode[1] >> 13))
	+	(0x0f & (timecode[1] >> 09));

*seconds = 10 *	(0x07 & (timecode[1] >> 06))
	+	(0x0f & (timecode[1] >> 02));

*ticks	= 100 *	(0x0f & (timecode[0] >> 12))
	+ 10  *	(0x0f & (timecode[0] >> 08))
	+	(0x0f & (timecode[0] >> 04));
return(OK);
}

outpipe(outbuf,words,channel)
short	outbuf[];
int	words, channel;
{
int	i, j, k=0;
int	sys$assign(), sys$qiow();
short	isb[4], bcchan, inbuf[8];
int	b[4];
$DESCRIPTOR(desc,"_BCB0");

j = sys$assign (&desc,&bcchan,0,0);
if(j&0x01==0)
	{
	LOGENTRY"OUTPIPE>>ERROR ATTACHING TO THE DEVICE\n");
	j = sys$dassgn(bcchan);
	return(NOTOK);
	}
 
for(k=0;k<5;k++)
	{
	j = sys$qiow(EFPIP,bcchan,IO$_RESET,isb,0,0,0,0,0,0,0,0);
	if ((j&0x01==0) || (isb[0] != SS$_NORMAL))
	    {
	    LOGENTRY"OUTPIPE>>ERROR %d,%d INITIALIZING THE PIPE\n",j,isb[0]);
	    if (k >= 4)
		{
		j = sys$dassgn(bcchan);
		return(NOTOK);
		}
	      else
		{
		sleep(2);
		continue;
		}
	    }
	break;
	}

for(i=0;i<words;i++)
	{
	if (outbuf[i] == 0)
		{
#ifdef	DEBUG
		LOGENTRY"OUTPIPE> %d: %04x Skipped null command\n",i,outbuf[i]);
#endif	DEBUG
		continue;
		}
#ifdef	DEBUG
	LOGENTRY"OUTPIPE> %d: %04x\n",i,outbuf[i]);
#endif	DEBUG
	j = sys$qiow(EFPIP,bcchan,IO$_WREGISTER,isb,0,0,&outbuf[i],2,0,0,0,0);
	if((!(j&0x01))	/* || (isb[0] != SS$_NORMAL)*/	)
		{
		LOGENTRY"OUTPIPE>>ERROR WRITING TO THE DEVICE\n");
		LOGENTRY"OUTPIPE>>RETURN STATUS = %d\n",j);
		LOGENTRY"OUTPIPE>>I/O STATUS BLOCK = %d %d %d %d\n",
						isb[0],isb[1],isb[2],isb[3]);
		j = sys$dassgn(bcchan);
		return(NOTOK);
		}

	j = sys$qiow(EFPIP,bcchan,IO$_RREGISTER,isb,0,0,&inbuf,0,0,0,0,0);
	if((!(j&0x01)))
		{
		printf("INPIPE>>ERROR READING FROM THE DEVICE\n");
		printf("INPIPE>>RETURN STATUS = %d\n",j);
		printf("INPIPE>>I/O STATUS BLOCK = %d %d %d %d\n",
					isb[0],isb[1],isb[2],isb[3]);
		j = sys$dassgn(bcchan);
		return(NOTOK);
		}
#ifdef	DEBUG
	LOGENTRY"INPIPE>  %d: %04x\n",i,inbuf[5]);
#endif	DEBUG

/*sleep(1);/*because of persistant ringing on the DOR bus */
	}

for(i=0;i<4;i++)
	{
	if((channel&(1<<i))==0)	b[i] = 1;
	else			b[i] = 2;
	}
j = sys$qiow(EFPIP,bcchan,IO$_WDISCRETE,isb,0,0,0,b[0],b[1],b[2],b[3],0);
if(j&0x01==0)
	{
	j = sys$dassgn(bcchan);
	return(NOTOK);
	}
    else
	{
	j = sys$dassgn(bcchan);
	return(OK);
	}
}

findtime(second)
int	*second;
{
int	i, millisec, stat;
short	isb[4], isb2[4], bcchan;
int	consecerr;

consecerr = 11;
GETRECORD:
	if(consecerr >= 10)
		{
		consecerr = 0;
		if(OK != startio(&bcchan,isb))return(NOTOK);
		}
	fflush(LOGFILE);
	stat = sys$waitfr(EFDAT);
	if(stat != SS$_NORMAL)
		{
		LOGENTRY"FINDTIME>> ERROR WAITING FOR EVENT FLAG\n");
		stat = sys$cancel(bcchan);
		stat = sys$dassgn(bcchan);
		return(NOTOK);
		}
	stat = sys$clref(EFDAT);
	if((stat&0x01)!=SS$_NORMAL)
		{
		LOGENTRY"FINDTIME>> ERROR CLEARING EVENT FLAG\n");
		stat = sys$cancel(bcchan);
		stat = sys$dassgn(bcchan);
		return(NOTOK);
		}
	if(isb[0] != SS$_NORMAL)
		{
		LOGENTRY"FINDTIME>> cyclic read error\n");
		LOGENTRY"FINDTIME>> I/O status = %d\n",isb[0]);
		stat = sys$cancel(bcchan);
		stat = sys$dassgn(bcchan);
		return(NOTOK);
		}
	i = (isb[2] - 1) % NUMBUF;
	if(	((hrptbuff[i][11089]&0x4000)!=0)
	      ||((hrptbuff[i][11089]&0x00f0)>=0x0080)
	      || (hrptbuff[i][0]!=0x0284)||(hrptbuff[i][1]!=0x016f)||
		 (hrptbuff[i][2]!=0x035c)||(hrptbuff[i][3]!=0x019d)||
		 (hrptbuff[i][4]!=0x020f)||(hrptbuff[i][5]!=0x0095)
	  )	{
		LOGENTRY"FINDTIME>>	iosb[2] = $%x\n",isb[2]);
		LOGENTRY"FINDTIME>>	$%x $%x $%x $%x $%x $%x ... $%x\n",
			hrptbuff[i][0], hrptbuff[i][1], hrptbuff[i][2],
			hrptbuff[i][3], hrptbuff[i][4], hrptbuff[i][5],
			hrptbuff[i][11089]);
		consecerr++;
		goto GETRECORD;
		}


millisec= hrptbuff[i][11] + (hrptbuff[i][10]<<10) 
	+ ((hrptbuff[i][9]&0x007f)<<20);
*second = (millisec / 1000) + (((hrptbuff[i][8] >> 1)-1) * 3600 * 24);

stat = sys$cancel(bcchan);
stat = sys$dassgn(bcchan);
return(OK);
}

spinto(file)
int	file;
{
short	ttopen();
int	destfoot, currfoot;
int	chan, lastop;
char	buffer[16];

destfoot = FILESIZE * (file%10);
if (destfoot>7500)return(NOTOK);

#ifdef	DEBUG
LOGENTRY"SPINTO>DESTINATION FILE IS %d AT FOOT COUNTER %d\n",file,destfoot);
#endif	DEBUG

chan = ttopen(HDTRS232);
commtape(chan,"CMSTP");		/* This causes tape to be loaded */
sleep(3);			/* Allow time for load to complete */
commtape(chan,"CS30");
lastop = 0;

LOOP:
commtape(chan,"FTUSE");
resptape(chan,buffer);
if(1 != sscanf(buffer,"%d",&currfoot)) goto LOOP;
/*
ifdef	DEBUG
LOGENTRY"SPINTO>CURRENT FOOT COUNTER IS %d\n",currfoot);
endif	DEBUG
*/
     if((destfoot-currfoot)>300)
	{
	if(lastop == 1)goto LOOP;
	lastop = 1;
	commtape(chan,"CMFWD");
	commtape(chan,"CMFST");
	goto LOOP;
	}
else if((destfoot-currfoot)< -300)
	{
	if(lastop == 2)goto LOOP;
	lastop = 2;
	commtape(chan,"CMREV");
	commtape(chan,"CMFST");
	goto LOOP;
	}
else if((destfoot-currfoot)>5)
	{
	if(lastop == 3)goto LOOP;
	lastop = 3;
	commtape(chan,"CS30");
	commtape(chan,"CMFWD");
	goto LOOP;
	}
else if((destfoot-currfoot)< -5)
	{
	if(lastop == 4)goto LOOP;
	lastop = 4;
	commtape(chan,"CS30");
	commtape(chan,"CMREV");
	goto LOOP;
	}
else 	commtape(chan,"CMSTP");

commtape(chan,"CS30");
commtape(chan,"TROFAL");

sprintf(buffer,"CHA%d",file/10);
commtape(chan,buffer);
sprintf(buffer,"TRON%02d",file/10);
commtape(chan,buffer);

sprintf(buffer,"CHB%d",(file+70)/10);
commtape(chan,buffer);
sprintf(buffer,"TRON%02d",(file+70)/10);
commtape(chan,buffer);

ttclos(chan);
return(OK);
}

commtape(chan,command)
int	chan;
char	command[];
{
int	len, stat, i;
char	buffer[16];

SENDMESS:
len=sprintf(buffer,"%s\n",command);
if(OK != sendch(chan,buffer,len))return(NOTOK);
GETECHO:
sleep(1);
for	(
	stat=resptape(chan,buffer);
	0!=strncmp(command,buffer,len-1);
	stat=resptape(chan,buffer)
	)if(stat!=OK)
		{
		LOGENTRY"COMMTAPE>bad return status from RESPTAPE\n");
		LOGENTRY"COMMTAPE>command sent was %s\n",command);
		goto SENDMESS;
		}
return(OK);
}

resptape(chan,response)
int	chan;
char	response[];
{
int	i, stat;

for	(
	stat = readch(chan,&response[i=0],1),response[i]&=0x7f;
	response[i] != 0x0a;
	stat = readch(chan,&response[++i],1),response[i]&=0x7f
	)
	{
	if(stat != OK)	return(NOTOK);
	}
if(stat != OK)	return(NOTOK);
else		return(OK);
}

commrcvr(chan,command)
int	chan;
char	command[];
{
int	len, stat, i;
char	buffer[16];

len=sprintf(buffer,"%s\n",command);
if(OK != sendch(chan,buffer,len))
	return(NOTOK);
sleep(1);
for(i=0;i<16;buffer[i++]='\0');
stat=resprcvr(chan,buffer);
return(stat);
}

resprcvr(chan,response)
int	chan;
char	response[];
{
int	i, stat;
short	iosb[4];

for	(i=0,response[0] = 0,
stat = sys$qiow(EFTTY,chan,IO$_READLBLK|IO$M_NOECHO|IO$M_TIMED,iosb,0,0,
			&response[i],1,2,0,0,0,0),response[i]&=0x7f;

	(stat == SS$_NORMAL) && (iosb[0] == SS$_NORMAL) && (i < 16);

i++,
stat = sys$qiow(EFTTY,chan,IO$_READLBLK|IO$M_NOECHO|IO$M_TIMED,iosb,0,0,
			&response[i],1,2,0,0,0,0),response[i]&=0x7f
	);
if (response[0] != 0)
	return(OK);
    else
	return(NOTOK);
}

short ttopen(name)
	char *name;
	{
	char tempname[80];
	int fd;
	int line;
	register int status;
	struct dsc$descriptor dev_name;

	dev_name.dsc$w_length = strlen(name);
	dev_name.dsc$a_pointer = name;
	dev_name.dsc$b_class = DSC$K_CLASS_S;
	dev_name.dsc$b_dtype = DSC$K_DTYPE_T;

	status = sys$assign(&dev_name,&line,0,0,0);
	if (status != SS$_NORMAL)
		LOGENTRY"TTOPEN>>ERROR=%d\n",status);
	return(line);
}

int	readch(line,buf,sz)
int	line;
char	*buf;
int	sz;
{
int	stat;
short	iosb[4];

stat = sys$qiow(EFTTY,line,IO$_READLBLK|IO$M_NOECHO|IO$M_TIMED,iosb,0,0,
				buf,sz,TTYMEOUT,0,0,0,0);
if(stat != SS$_NORMAL)
	{
	LOGENTRY"READCH> error reading character: stat = %d\n",stat);
	return(NOTOK);
	}
if(iosb[0] != SS$_NORMAL)
	{
	LOGENTRY"READCH> error reading character: IOSB[0] = %d\n",iosb[0]);
/***
/***THIS IS A TEMPORARY PATCH TO FORCE AN ABORT
/***SO THAT ACQUIRE WILL BE RESTARTED
/***/
/***	if(iosb[0] == 556)lib$stop(556);
/***/
	return(NOTOK);
	}
return(OK);
}

sendch(line,buf,sz)
int	line;
char	*buf;
int	sz;
{
int	stat;
short	iosb[4];

stat = sys$qiow(EFTTY,line,IO$_WRITELBLK | IO$M_NOECHO,iosb,0,0,buf,sz,
							TTYMEOUT,0,0,0,0);
if(stat != SS$_NORMAL)
	{
	LOGENTRY"SENDCH> error sending character: stat = %d\n",stat);
	return(NOTOK);
	}
if(iosb[0] != SS$_NORMAL)
	{
	LOGENTRY"SENDCH> error sending character: IOSB[0] = %d\n",iosb[0]);
	return(NOTOK);
	}
return(OK);
}

ttclos(line)
int	line;
{
int	stat;

stat = sys$dassgn(line);
if(stat != SS$_NORMAL)
	{
	LOGENTRY"TTCLOS> ERROR CLOSING TTY LINE >= %d\n",stat);
	return(NOTOK);
	}
return(OK);
}
