/*******************************************************************************
*	Quicklook_text writes a text message on the bottom of the Peritek
*  display by rasterizing text into the primary buffer.
*******************************************************************************/
#define VIDCHUNK	128
#include "acquman.h"

quicklook_text(text)
char *text[];
{
int counter, i, peritek_line, scroll;
extern union
	{
	unsigned char sysa[1024];
	struct
		{
		unsigned char filler1[300];
		int lines_scrolled;
		unsigned char filler2[720];
		} fields;
	} per;
extern short quicklook_flag;
extern char prev_text[33];
unsigned char raster[1024];

	if (quicklook_flag != 1)		/* are we supposed to ? */
		return(1);
	if (strcmp(prev_text,text) == 0)	/* once is enough */
		return(1);
	strcpy(prev_text,text);
	setpl(0);				/* Select alpha plane */

	/* calculate where to place text, allowing for scrolling */
	scroll = per.fields.lines_scrolled;
	scroll %= 1024;
	if (scroll < 0)
		{
		peritek_line = abs(63 - scroll);
		peritek_line %= 1024;
		}
	    else if (scroll == 0)
		peritek_line = 61;
	    else
		{
		peritek_line = abs(63 + (1024 - scroll));
		peritek_line %= 1024;
		}
	LOGENTRY"QUICKLOOK_TEXT> lines_scrolled = %d  peritek_line = %d\n",
		per.fields.lines_scrolled,peritek_line);

	/* If ONIMAGE is not defined, then write a few black background
	   lines to avoid bleeding */
#ifndef ONIMAGE
	for (i=0;i<1024;raster[i]=0,i++);

	for (counter=0;counter<4;counter++)
		{
		for (i=0;i<1024;i+=VIDCHUNK)
			wrmm(0, peritek_line, i, &raster[i], VIDCHUNK);
		peritek_line--;
		if (peritek_line == -1)
			peritek_line = 1023;
		}
#endif

	/* Call the font rasterization routine and peritek write routine for
	   every line to be used for the message */
	for (counter=0;counter<60;counter++)
		{
		/* If ONIMAGE is set, then we want to preserve the background */
#ifdef ONIMAGE
		for (i=0;i<1024;i+=VIDCHUNK)
			rdmm(0, peritek_line, i, &raster[i], VIDCHUNK);
#else
		for (i=0;i<1024;raster[i]=0,i++);
#endif
		font2(text,counter,1,raster);
		for (i=0;i<1024;i+=VIDCHUNK)
			wrmm(0, peritek_line, i, &raster[i], VIDCHUNK);
		peritek_line--;
		if (peritek_line == -1)
			peritek_line = 1023;
		}
	return(1);
}
