/*========================================================================
==			OTHER FILES TO BE INCLUDED			==
========================================================================*/
#include	<time.h>
#include	<prvdef.h>
#include	<desc.h>
#include	<opcdef.h>
#include	<rmsdef.h>
#include	<iodef.h>
#include	<dvidef.h>
#include	<sjcdef.h>
#include	<jbcmsgdef.h>
#include	<jpidef.h>
#include	<rms.h>
#include	<descrip.h>
#include	<fibdef.h>
#include	<atrdef.h>
#include	<file.h>
#include	<ssdef.h>
#include	<stdio.h>
#include	<errno.h>
#include	"sched.h"
#include	<stdlib.h>
/*========================================================================
==									==
========================================================================*/
#define EFTIM	4
#define EFPIP	12
#define EFDAT	16
#define EFFIL	20

#define	EFMTIM	(EFTIM<<1)
#define	EFMDAT	(EFDAT<<1)

/*========================================================================
==	Offset to be added to local time year when clock set back       ==
========================================================================*/
#define	YEAR_OFFSET	0


/*========================================================================
==	Fairchild 760 buffered-interface-board control definitions	==
========================================================================*/
#define	IO$_RESET	IO$_SPACERECORD
#define	IO$_RCYCLIC	1
#define IO$_RREGISTER	2
#define	IO$_WREGISTER	5
#define	IO$_WDISCRETE	6

/*========================================================================
==	PIPELINE CONTROL BUS MODULE ADDRESSES AND PARAMETERS		==
========================================================================*/
#define	FRAMSNC	1	/* module address for the Frame-Synchronizer.	*/
/*========================================================================
==			    HRPT DATA BUFFERS				==
========================================================================*/
#define NUMBUF	4		/* number of buffers used in cyclic reads  */
#define	HRPT_WORDCNT 11090	/* number of 16-bit words in 1 minor frame */
#define	HRPT_BYTECNT HRPT_WORDCNT*2 /* number of bytes in one HRPT minor frame */
#define	TOTSIZ	44*256		/* number of words in a rotational buffer  */

/* The following line ensures that cycbuff is quadword aligned, so that the
BCDRIVER may use buffered data path to speed throughput. */
int	_align( QUADWORD ) align_filler[2];

short	cycbuff[NUMBUF][TOTSIZ];		  /* NOTE 44 * 256 = 11264 */

int	framesiz[3] = {22180, 22180, 19962};	/* Size of rec to read */
int	bufsiz[3] =   {22016, 22016, 19968};	/* Size of rec to write */

#define	TRUE	1
#define	FALSE	0
#define	OK	(SS$_NORMAL)
#define	NOTOK	(SS$_ABORT)

/*========================================================================
==	Stuff that used to be in scheduledefs.h				==
========================================================================*/
struct	MONTHDAY
	{
	char	month, day;
	};
#include	"monthday.table"
#define	GETSCHREC(stream,rp) \
		fscanf(stream, SCHEDULE_FORMAT, &((rp)->scene_id), \
			&((rp)->satid), &((rp)->lstart), &((rp)->lstop), \
			&((rp)->rstart), &((rp)->rstop), \
			&((rp)->opcode), &((rp)->stat), &((rp)->tfile), \
			&((rp)->pflag), &((rp)->dnflag), &((rp)->station), \
			&((rp)->atype), &((rp)->orbit))

#define	PUTSCHREC(stream,rp) \
		fprintf(stream, SCHEDULE_FORMAT, (rp)->scene_id, (rp)->satid, \
			(rp)->lstart, (rp)->lstop, (rp)->rstart, (rp)->rstop, \
			(rp)->opcode, (rp)->stat, (rp)->tfile, (rp)->pflag, \
			(rp)->dnflag, (rp)->station, (rp)->atype, \
			(rp)->orbit)

#define	START_OF_TIME	1986

#define	MAKE_JULIAN(totsecs,year,day,hours,minutes,seconds) \
		(seconds) = (totsecs); \
		(minutes) = (seconds) / 60;	(seconds) %= 60; \
		(hours) = (minutes) / 60;	(minutes) %= 60; \
		(day) = (hours) / 24;	(hours) %= 24; \
		(year) = day / 365; \
		(day) = (day)%365 + 1 - (year)/4; \
		(year) += START_OF_TIME; \
                if (day <= 0) { (year)--; (day) += 365 + !((year)%4); }

#define	JULGRE(yr,jdy,mnth,dy) \
	if ( (0!=(yr)%4) || ( (0==(yr)%100) && (0!=(yr)%400) ) ) \
	     { (mnth) = (REG+jdy-1)->month, (dy) = (REG+jdy-1)->day; } \
	else { (mnth) = (LEAP+jdy-1)->month, (dy) = (LEAP+jdy-1)->day; }

#define	JULTIM_TO_TOTSECS(scs,mns,hrs,dys,yr,optm) \
	            (optm) = (scs) + 60*(mns) + 3600*(hrs) + 86400*((dys)-1) + \
	                86400*(int)(.25+365.25*(float) \
	                    ((yr) - (START_OF_TIME%100) + \
	                    (((yr)<(START_OF_TIME%100))?100:0)))
