$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!	LOCALCOPY.COM - This procedure copies recently acquired images from
$! the acquisition disk to a directory on another disk, and then finally
$! renames the file into the outgoing directory where netcopy will see it.  Two
$! copies of this procedure are running, one services EDC and Wallops while
$! the other services Gilmore.  The associated acquisition programs will
$! suspend this process during acquisitions in order to avoid head contention.
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$	set noverify
$       setacc 42630
$	setuser :==$sys$priv:setuser
$	myname = "''p1'"
$	set proc/name='myname' 
$	setuser 'myname'
$	iam = 1
$	if myname .eqs. "INGEST2" then iam = 2
$!	purge/keep=4 sys$manager:ingest'iam'.log
$	out :== write sys$output
$       gosub get_pids
$       gosub get_vote
$       if vote .eq. 0 then goto no_suspend
$       if vote .eq. 1 then goto one_suspend
$       set proc/suspend
$one_suspend:
$       set proc/suspend
$no_suspend:
$	if iam .eq. 1 then local_dir = "hrpt1:[images]"
$	if iam .eq. 2 then local_dir = "hrpt2:[images]"
$	remote_dir = "arch1:[tmp]"
$	outgoing_dir = "arch1:[outgoing]"
$	interval = "00:00:10.00"
$	message_save = f$environment ("MESSAGE")  ! Used to re-enable err msgs
$	true = 1
$	false = 0
$	set def sys$sysdevice:[nosuchdir]
$	set def 'local_dir'
$
$main_loop:
$	on error then goto error_handler
$	gosub send_images
$	wait 'interval'
$	goto main_loop
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!		Look for outgoing images
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$send_images:
$	file_spec = f$search("*.*;*",1)
$	if file_spec .eqs. "" then return
$	timestamp = f$extract(12,08,f$time()) - ":" - ":"
$	file_name = f$parse(file_spec,,,"NAME") + f$parse(file_spec,,,"TYPE")
$	new_name = f$parse(file_spec,,,"NAME") + "_" -
	  + timestamp + f$parse(file_spec,,,"TYPE")
$	on error then goto send_err
$	copy/log 'file_name' 'remote_dir''new_name'
$	rename 'remote_dir''new_name' 'outgoing_dir'
$	del/log 'file_spec'
$	goto send_images
$send_err:
$	on severe then exit
$	wait 00:00:01.00		! To avoid busy error loop
$	goto send_images
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$get_pids:
$! NOTE - the risk here is that if we use "" as the pid for a f$getjpi call,
$!        it will return info about our process so it must be checked...
$!
$       acquire_pid = ""
$       wallops_pid = ""
$       gilmore_pid = ""
$       context = ""
$get_pids_loop:
$       pid = f$pid(context)
$       if pid .eqs. "" then return
$       name = ""
$       name = f$getjpi(pid,"PRCNAM")
$       if name .eqs. "ACQUIRE" then acquire_pid = pid
$       if name .eqs. "INHALE_WALLOPS" then wallops_pid = pid
$       if name .eqs. "INHALE_GILMORE" then gilmore_pid = pid
$       goto get_pids_loop
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$get_vote:
$       vote = 0
$       if ((acquire_pid .nes. "") .and. -
          (f$getjpi(acquire_pid,"PRIB") .nes. "4")) then vote = vote + 1
$       if ((wallops_pid .nes. "") .and. -
          (f$getjpi(wallops_pid,"PRIB") .nes. "4")) then vote = vote + 1
$       if ((gilmore_pid .nes. "") .and. -
          (f$getjpi(gilmore_pid,"PRIB") .nes. "4")) then vote = vote + 1
$	if vote .ne. 3 then return
$	wait 00:00:30.0
$	goto get_vote
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!		Error handler				       !
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$error_handler:
$	err_count = err_count + 1
$	if err_count .eq. 1000 then exit
$	goto main_loop
