$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!	NETCOPY.COM  - This command procedure looks for completed acquisitions
$! and copies them to EDCSGS4.  In order to avoid conflicts, the file is
$! copied with a T prepended to the name - the remote software won't touch it
$! util we rename it to remove the T.
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$	set noverify
$!	purge/keep=4 sys$manager:netcopy.log
$	setacc 42630
$       setuser :==$sys$priv:setuser
$	setuser netcopy
$	set proc/name=netcopy
$	out :== write sys$output
$       gosub get_pids
$       gosub get_vote
$       if vote .eq. 0 then goto no_suspend
$       if vote .eq. 1 then goto one_suspend
$       set proc/suspend
$one_suspend:
$       set proc/suspend
$no_suspend:
$	local_dir = "arch1:[outgoing]"
$	done_dir = "arch1:[done]"
$	remote_dir = "/sgs4/km1/adaps/acquire"
$	cor_dir = "adapstables:"
$	rem_cor_dir = "/sgs4/pkg/software/env/adaps/tables"
$	set command sys$priv:file
$	interval = "00:00:10.00"
$	message_save = f$environment ("MESSAGE")  ! Used to re-enable err msgs
$	true = 1
$	false = 0
$	set def 'local_dir'
$
$main_loop:
$	on error then goto error_handler
$	gosub send_images
$	wait 'interval'
$	goto main_loop
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!		Look for outgoing images
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$send_images:
$	file_spec = f$search("*.*;*",1)
$	if file_spec .eqs. "" then return
$	file_name = f$parse(file_spec,,,"NAME") + f$parse(file_spec,,,"TYPE")
$	file_name = f$edit(file_name,"LOWERCASE")
$	on severe then goto send_err
$	file/type=fixed/rec=512 'file_name'
$sh time
$	rcp/user=root/novms/exact/log=time -
	'file_name' "sgs4e::''remote_dir'/T''file_name'"
$	remfile = "''remote_dir'/''file_name'"
$	tmpfile = "''remote_dir'/T''file_name'"
$	rsh/user=root sgs4e -
 "chown opsavhrr ''tmpfile' ; chgrp avhrrgrp ''tmpfile' ; chmod 644 ''tmpfile'"
$	rsh/user=root sgs4e -
	"mv ''tmpfile' ''remfile'"
$	del/log 'file_spec'
$!	ren/log 'file_spec' 'done_dir'
$	if f$parse(file_spec,,,"TYPE") .nes. ".SFL" then goto cleanup
$	timecor = "noaa" + f$extract(2,2,file_name) + ".timcor"
$	rcp/user=root/novms/exact/log=time -
	'cor_dir''timecor' "sgs4e::''rem_cor_dir'/T''timecor'"
$	remfile = "''rem_cor_dir'/''timecor'"
$	tmpfile = "''rem_cor_dir'/T''timecor'"
$	rsh/user=root sgs4e -
 "chown opsavhrr ''tmpfile' ; chgrp avhrrgrp ''tmpfile' ; chmod 644 ''tmpfile'"
$	rsh/user=root sgs4e -
	"mv ''tmpfile' ''remfile'"
$cleanup:
$	goto send_images
$send_err:
$	on severe then exit
$	wait 00:00:01.00		! To avoid busy error loop
$	goto send_images
$get_pids:
$! NOTE - the risk here is that if we use "" as the pid for a f$getjpi call,
$!        it will return info about our process so it must be checked...
$!
$       acquire_pid = ""
$       wallops_pid = ""
$       gilmore_pid = ""
$       context = ""
$get_pids_loop:
$       pid = f$pid(context)
$       if pid .eqs. "" then return
$       name = ""
$       name = f$getjpi(pid,"PRCNAM")
$       if name .eqs. "ACQUIRE" then acquire_pid = pid
$       if name .eqs. "INHALE_WALLOPS" then wallops_pid = pid
$       if name .eqs. "INHALE_GILMORE" then gilmore_pid = pid
$       goto get_pids_loop
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$get_vote:
$       vote = 0
$       if ((acquire_pid .nes. "") .and. -
          (f$getjpi(acquire_pid,"PRIB") .nes. "4")) then vote = vote + 1
$       if ((wallops_pid .nes. "") .and. -
          (f$getjpi(wallops_pid,"PRIB") .nes. "4")) then vote = vote + 1
$       if ((gilmore_pid .nes. "") .and. -
          (f$getjpi(gilmore_pid,"PRIB") .nes. "4")) then vote = vote + 1
$       if vote .ne. 3 then return
$       wait 00:00:30.0
$       goto get_vote
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!		Error handler				       !
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$error_handler:
$	err_count = err_count + 1
$	if err_count .eq. 1000 then exit
$	goto main_loop
