$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!	Resumer.com - corrects problems with too many queued suspends on
$! the INGEST1, INGEST2 and NETCOPY processes.  If acquire or inhale are
$! deleted while acquiring or if ingest (localcopy) or netcopy are manually
$! suspended or started when no acquistions are in progress, then resumer will
$! resume the process the next time no acquisitions are occuring.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$	set noverify
$       setacc 42630
$	set proc/name=resumer 
$	out :== write sys$output
$	interval = "00:01:00.00"
$	wait 00:02:00.00
$
$main_loop:
$	on error then goto error_handler
$	gosub get_pids
$	gosub check_daemons
$	wait 'interval'
$	goto main_loop
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!	Check the daemons	
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$check_daemons:
$	if ingest1_pid .eqs. "" then goto check_ingest2
$	state = ""
$	state = f$getjpi(ingest1_pid,"STATE")
$	gosub get_vote
$	if vote .ne. 3 then return
$	if (state .eqs. "SUSP") .or. (state .eqs. "SUSPO")
$	    then
$		set proc/id='ingest1_pid'/resume
$		sh sys
$		out "Resumed INGEST1 ''ingest1_pid' ''f$time()'"
$	    endif
$check_ingest2:
$	if ingest2_pid .eqs. "" then goto check_netcopy
$	state = ""
$	state = f$getjpi(ingest2_pid,"STATE")
$	gosub get_vote
$	if vote .ne. 3 then return
$	if (state .eqs. "SUSP") .or. (state .eqs. "SUSPO")
$	    then
$		set proc/id='ingest2_pid'/resume
$		sh sys
$		out "Resumed INGEST2 ''ingest2_pid' ''f$time()'"
$	    endif
$check_netcopy:
$	if netcopy_pid .eqs. "" then return
$	state = ""
$	state = f$getjpi(netcopy_pid,"STATE")
$	gosub get_vote
$	if vote .ne. 3 then return
$	if (state .eqs. "SUSP") .or. (state .eqs. "SUSPO")
$	    then
$		set proc/id='netcopy_pid'/resume
$		sh sys
$		out "Resumed NETCOPY ''netcopy_pid' ''f$time()'"
$	    endif
$	return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$get_pids:
$! NOTE - the risk here is that if we use "" as the pid for a f$getjpi call,
$!	  it will return info about our process so it must be checked...
$!
$	ingest1_pid = ""
$	ingest2_pid = ""
$	netcopy_pid = ""
$	acquire_pid = ""
$	wallops_pid = ""
$	gilmore_pid = ""
$	context = ""
$get_pids_loop:
$	pid = f$pid(context)
$	if pid .eqs. "" then return
$	name = ""
$	name = f$getjpi(pid,"PRCNAM")
$	if name .eqs. "INGEST1" then ingest1_pid = pid
$	if name .eqs. "INGEST2" then ingest2_pid = pid
$	if name .eqs. "NETCOPY" then netcopy_pid = pid
$	if name .eqs. "ACQUIRE" then acquire_pid = pid
$	if name .eqs. "INHALE_WALLOPS" then wallops_pid = pid
$	if name .eqs. "INHALE_GILMORE" then gilmore_pid = pid
$	goto get_pids_loop
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$get_vote:
$	vote = 0
$	if ((acquire_pid .eqs. "") .or. (wallops_pid .eqs. "") .or. -
	    (gilmore_pid .eqs. "")) then return
$	if f$getjpi(acquire_pid,"PRIB") .eqs. "4" then vote = vote + 1
$	if f$getjpi(wallops_pid,"PRIB") .eqs. "4" then vote = vote + 1
$	if f$getjpi(gilmore_pid,"PRIB") .eqs. "4" then vote = vote + 1
$	return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!		Error handler				       
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$error_handler:
$!	err_count = err_count + 1
$!	if err_count .eq. 1000 then exit
$	out "Error timestamp ''f$time()'"
$	wait 00:00:15.00
$	gosub get_pids
$	goto main_loop
