#include "ansicp.h"
#include "worgen.h"
#include "tapeio.h"


FUNCTION cpmountvol (prog,volid,tape,msg,rewind,fstopen,autovolid,rwmode)
char	*prog;				/* calling program		   */
int	*tape;				/* file desc (struct TAPEDESC)	   */
char 	*volid;				/* desired volume identifier	   */
char 	*msg;				/* msg to operator		   */
int	rewind;				/* rewind flag			   */
long	fstopen;			/* first open? 1=yes 0=no	   */
long	autovolid;			/* get the volume id from the tape */
                                        /* 1=yes 0=no                      */
int	rwmode;				/* read/write mode                 */

{
   char drive[256];
   char 	the_volume[8];			/* actual volume identifier	   */
   char	tempstr[10];			/* temporary character string	   */
   int	indx;				/* loop counter			   */
   int	rslt;				/* rslt of get_label call	   */
   char	*malloc(), *strcat(), *strcpy(), *strntrm();
   int errcnt;
   
   
   if (!autovolid)
     while (strlen(volid) == 0)		/* get tape number		*/
     {
	fprintf (stderr,"%s: %s",prog,msg);
	gets (volid);
	strupr (volid, volid);
     }
   
   while (drive_name == NULL)
   {
      if (!autovolid)
	fprintf (stderr,"%s: enter tape drive name for tape %s: ",prog,volid);
      else
	fprintf (stderr,"%s: enter tape drive name for tape: ",prog);
      drive_name = drive;
      gets (drive_name);
   }
   
   if (fstopen)
     *tape = open_the_tape (1,O_RDONLY);
   else
     *tape = reopen_tape (1,O_RDONLY);
   
   errcnt = 0;
   
   while ( !(rslt = get_label (*tape,(char *)&vol1,"VOL",1,ANSI_TRUE)) ||
	  (!autovolid && strncmp (vol1.volume_ident,volid,strlen(volid))) )
   {
      close_tape (*tape,NOREW);
      rewind_tape (*tape,ANSI_FALSE);
      
      if (!rslt)				/* get_label error	*/
      {
	 fprintf (stderr,
		  "[%s-mountvol] Drive %s: Tape Label Error \n",prog,
		  drive_name);
	 fprintf (stderr,
		  "[%s-mountvol] Verify that this is an ANSI labelled tape\n",
		  prog);
	 
	    
	 if(autovolid && errcnt == 10)
	 {
	    close_tape (*tape,REWOFFL);
	    fprintf(stderr,"[%s-fatal]  Fatal error encountered.\n",prog);

	    exit(1);
	 }
	 errcnt++;
	 sleep (5);
      }
      else					/* volume id mismatch	*/
      {
	 strntrm (the_volume,vol1.volume_ident,sizeof(vol1.volume_ident));
	 fprintf (stderr,"[%s-mountvol]: Requested Volume: %s,  found: %s\n",
		  prog,volid,the_volume);
      }
      
      if (!autovolid)
	*volid = 0;
      while (strlen(volid) == 0)	/* try again for tape number	*/
      {
	 fprintf (stderr,"%s: %s",prog,msg);
	 gets (volid);
	 strupr (volid, volid);
      }
      if (fstopen)
	*tape = open_the_tape (1,O_RDONLY);
      else
	*tape = reopen_tape (1,O_RDONLY);
   }
   
   if(autovolid)
     strntrm(volid,vol1.volume_ident,sizeof(vol1.volume_ident));
     
   
   if(rwmode == O_RDONLY)
   {
      rewind_tape(*tape,1);
   } 
   else 
   {
      close_tape(*tape,REWIND);
      *tape = reopen_tape (1,rwmode);
   }
   
}
