#include		<ctype.h>
#include		<stdio.h>
#ifdef vms
#include		<file.h>
#else
#include		<sys/file.h>
#endif
#include		<time.h>
#ifdef sun
#include <fcntl.h>
#endif

#include		"worgen.h"
#include		"header.h"		/* header label layout	*/
#include		"trailer.h"		/* trailer label layout	*/
#include		"volume.h"		/* volume label layout	*/

#define	BOOL		int			/* boolean pseudo-type	*/
#define	BUFSZ		64000			/* tape buffer size	*/
#define	EOT		2			/* End-of-tape exit status */
#define ANSI_FALSE	(0)			/* boolean value for false */
#define	FUNCTION				/* noise word for functions */
#define	IGNORE		void			/* ignore return value	*/
#define LABELSZ		80			/* size of all labels	*/
#define	MIN(a,b)	((a) < (b)) ? (a) : (b)	/* macro for minimum	*/
#define	NOT_OK		(-1)			/* bad exit status	*/
#define	OK		(0)			/* good exit status	*/
#define	ANSI_TRUE	(-1)			/* boolean value for true */
#define	VOID					/* function that does	*/
						/* not return a value	*/
#define	BOF		1			/* processing headers	*/
#define	DATA		2			/* processing data	*/
#define	EOFF		3			/* reelswitch after EOF	*/

#ifdef	GLOBALS
#define	DECLARE				/* global definition		*/
#else
#define	DECLARE		extern		/* global declaration		*/
#endif

DECLARE unsigned char	buf[BUFSZ];	/* tape I/O buffer		*/
DECLARE BOOL		eof;		/* end-of-file flag		*/
DECLARE EOF1		eof1;		/* end-of-file label #1		*/
DECLARE EOF2		eof2;		/* end-of-file label #2		*/
DECLARE BOOL		eot;		/* end-of-tape flag		*/
DECLARE BOOL		eov;		/* end-of-volume flag		*/
DECLARE EOV1		eov1;		/* end-of-file label #1		*/
DECLARE EOV2		eov2;		/* end-of-file label #2		*/
DECLARE HDR1		hdr1;		/* header label #1		*/
DECLARE HDR2		hdr2;		/* header label #2		*/
DECLARE	HDRN		hdrn;		/* header label #n		*/
DECLARE UHLA		uhla;		/* user defined header label	*/
DECLARE UTLA		utla;		/* user defined trailer label	*/
DECLARE UVLN		uvln;		/* user defined volume label	*/
DECLARE VOL1		vol1;		/* volume label #1		*/

DECLARE	BOOL	checkvol;	/* 1=specific tape,0=any tape on drive	*/
DECLARE BOOL	labelled;	/* generate labelled tape		*/
DECLARE	BOOL	ndcdb;		/* if true, stop at end of tape		*/
DECLARE	BOOL	newpg;		/* start new page? y/n			*/
DECLARE	BOOL	splitfile;	/* split files across volumes y/n	*/
DECLARE	BOOL	text;		/* (for ansiin) reading text file? y/n	*/
DECLARE	char	*density;	/* tape density (bpi)			*/
DECLARE	char	*drive_name;	/* tape drive name			*/
DECLARE	char	comment[CMLEN];	/* user request tape, tape drive name	*/
DECLARE	int	lflag;		/* list: 0=short, 1=medium, 2=long	*/
DECLARE	int	nfiles;		/* total #files to copy to tape		*/
DECLARE int	tape_bpi;	/* tape bpi 				*/
DECLARE	int	tfiles;		/* # files written to current tape	*/
DECLARE	float	irgsize;	/* inter-record gap size, (inches)	*/
DECLARE	float	tlen;		/* length of tape, (inches)		*/
DECLARE	float	twrit;		/* length written to tape, (inches)	*/
#undef	DECLARE
