#include <stdlib.h>
#include <string.h>
#include <time.h>
#define	GLOBALS
#include		"ansicp.h"
#undef	GLOBALS
#include        "worgen.h"
#include        "tapeio.h"



int paranoid = 1;

main (argc,argv)
int	argc;
char	**argv;
{
   int	args;			/* arguments used in parsing	        */
   int 	blk_count;		/* # of blocks in file section	        */
   int	files = 0;		/* number of files input        	*/
   int	intape;			/* input file desc (struct TAPEDESC)	*/
   int	outtape;		/* output file desc (struct TAPEDESC)	*/
   int	tot_blocks = 0;		/* total # blocks in file        	*/
   int	tot_recs = 0;		/* total # records in file        	*/
   int  status = 0;

   char *indrive = NULL;
   char *involid;
   char *outdrive = NULL;
   char *outvolid;
   char	tempstr[256];		/* temporary character string        	*/
   char	*volume_ident;		/* desired volume identifier        	*/
   char timestr[80], month[5];
   char dircmd[512];
   
   long autovolid = 0;
   long blksize = 0;
   long mapper = 0;
   long ansidir = 0;
   long report_stat = 0;
   
   char *intmpfile;
   char *outtmpfile;
   char *intmpdir;
   char *outtmpdir;
   FILE *tmpfp;
   int c;
   char buffer[CMLEN];


#ifdef unix
#ifdef sun
   /* I have no idea if this is correct, but it builds */
   setvbuf(stdout, buffer , _IOLBF,  CMLEN);
#else
   setlinebuf(stdout);
#endif
#endif
   
   text = 0;
   volume_ident = (char *)malloc(8); *volume_ident = 0;
   involid = (char *)malloc(8); *involid = 0;
   outvolid = (char *)malloc(8); *outvolid = 0;

   checkvol = 1;
   lflag = 0;

   getpar(argc,argv,&indrive,&outdrive,involid,outvolid,&blksize,&autovolid,
	  &mapper,&report_stat,&ansidir);
   
   
   if(logflg)
   {
      strcpy(tempstr,logdir);
      strcat(tempstr,"/ansicp.log");
      TimeStrings(timestr,month);
      strcat(tempstr,month);
      if((logfile = fopen(tempstr,"a")) == NULL)
      {
	 fprintf(stderr,"[ansi-fopen]Unable to open log file.\n");
	 fprintf(stderr,"[ansi-fatal]Fatal error encountered.\n");
	 exit(1);
      }
      close(fileno(stderr));
      dup(fileno(logfile));

      fprintf(logfile,"============ ANSICP =============\n %s",timestr);
      fflush(logfile);
   }
      
   drive_name = indrive;
   density = "";
   
   cpmountvol("ANSICP",involid,&intape,"enter tape id for input tape: ",1,0,
	    autovolid, O_RDONLY);

   drive_name = outdrive;
   density = "";
   
   cpmountvol("ANSICP",outvolid,&outtape,"enter tape id for output tape: ",1,0,
	    autovolid,O_WRONLY);

   if(mapper)
   {
      intmpfile = tempnam(NULL,"ansicp");
      if(intmpfile != NULL)
      {
	 if((inmapfile = fopen(intmpfile,"w+")) == NULL)
	 {
	    fprintf(stderr,"[ansi-fopen]Unable to open mapper file.\n");
	    fprintf(stderr,"[ansi-nofatal]Nonfatal error encountered.\n");
	    mapper = 0;
	 }
	 else
	   fprintf(inmapfile,"====== Mapper for Volume %s ======\n\n",involid);
      
	 
	 outtmpfile = tempnam(NULL,"ansicp");
	 if(outtmpfile == NULL || (outmapfile = fopen(outtmpfile,"w+")) == NULL)
	 {
	    fprintf(stderr,"[ansi-fopen]Unable to open mapper file.\n");
	    fprintf(stderr,"[ansi-nofatal]Nonfatal error encountered.\n");
	    mapper = 0;
	 }
	 else
	   fprintf(outmapfile,"====== Mapper for Volume %s ======\n\n",outvolid);  
      }
      else
      {
	 fprintf(stderr,"[ansi-fopen]Unable to open mapper file.\n");
	 fprintf(stderr,"[ansi-nofatal]Nonfatal error encountered.\n");
	 mapper = 0;
      }
   }
   
   if(ansidir)
   {
      intmpdir = tempnam(NULL,"ansicp");
      if(intmpdir != NULL)
      {
	 if((indirfile = fopen(intmpdir,"w+")) == NULL)
	 {
	    fprintf(stderr,"[ansi-fopen]Unable to open ANSIDIR file.\n");
	    fprintf(stderr,"[ansi-nofatal]Nonfatal error encountered.\n");
	    ansidir = 0;
	 }
	 
	 if(!paranoid)
	 {
	    outtmpdir = tempnam(NULL,"ansicp");
	    if(outtmpdir == NULL || (outdirfile = fopen(outtmpdir,"w+")) 
	       == NULL)
	    {
	       fprintf(stderr,"[ansi-fopen]Unable to open ANSIDIR file.\n");
	       fprintf(stderr,"[ansi-nofatal]Nonfatal error encountered.\n");
	       ansidir = 0;
	    }
	 }
	 
      }
      else
      {
	 fprintf(stderr,"[ansi-fopen]Unable to open ANSIDIR file.\n");
	 fprintf(stderr,"[ansi-nofatal]Nonfatal error encountered.\n");
	 ansidir = 0;
      }
      lflag = 2;
      
   }

   cp_tape(intape,outtape,involid,outvolid,blksize,mapper,ansidir);

   if(mapper)
   {
      fflush(inmapfile); rewind(inmapfile);
      fflush(outmapfile); rewind(outmapfile);
      
      strcpy(tempstr,logdir);
      sprintf(&tempstr[strlen(logdir)],"/%s.map",involid);
      if(NULL != (tmpfp = fopen(tempstr,"w")))
      {
	 while(EOF != (c = fgetc(inmapfile)))
	   fputc(c,tmpfp);
	 fclose(inmapfile);
	 fclose(tmpfp);
      }
      strcpy(tempstr,logdir);
      sprintf(&tempstr[strlen(logdir)],"/%s.map",outvolid);

      if(NULL != (tmpfp = fopen(tempstr,"w")))
      {
	 while(EOF != (c = fgetc(outmapfile)))
	   fputc(c,tmpfp);
	 fclose(outmapfile);
	 fclose(tmpfp);
      }
      unlink(intmpfile);
      unlink(outtmpfile);
   }

   if(ansidir)
   {
      fflush(indirfile); rewind(indirfile);
      
      strcpy(tempstr,logdir);
      sprintf(&tempstr[strlen(logdir)],"/%s.ansidir",involid);
      if(NULL != (tmpfp = fopen(tempstr,"w")))
      {
	 while(EOF != (c = fgetc(indirfile)))
	   fputc(c,tmpfp);
	 fclose(indirfile);
	 fclose(tmpfp);
      }
      strcpy(tempstr,logdir);
      sprintf(&tempstr[strlen(logdir)],"/%s.ansidir",outvolid);

      if(paranoid)
      {
	 close_tape(outtape,REWIND);
	 strcpy(dircmd,"ansidir -Tli ");
	 strcat(dircmd,outdrive);
	 strcat(dircmd," > ");
	 strcat(dircmd,tempstr);
	 unlink(tempstr);
	 fprintf(stderr,"ansidir:");

	 if( 0 != (status = system(dircmd)))
	 {
	    fprintf(stderr,"Error creating tape listing\n");
	    fflush(stderr);
	    
	 }
	 
	 drive_name = outdrive;
	 density = "";
	 outtape = reopen_tape(1,O_RDONLY);
      }
      else
      {
         fflush(outdirfile); rewind(outdirfile);
	 if(NULL != (tmpfp = fopen(tempstr,"w")))
	 {
	    while(EOF != (c = fgetc(outdirfile)))
	      fputc(c,tmpfp);
	    fclose(outdirfile);
	    fclose(tmpfp);
	 }
	 unlink(outtmpdir);
      }
      
      unlink(intmpdir);
   }

#ifdef DEBUG
   close_tape(intape,REWIND);
   close_tape(outtape,REWIND);
#else
   close_tape(intape,REWOFFL);
   close_tape(outtape,REWOFFL);
#endif

   if(report_stat && status == 0 )
     fprintf(stderr,"Volume %s copied to volume %s successfully\n",involid,
             outvolid);
   fflush(stderr);	
   
   exit(status);
}

getpar(argc,argv,indrive,outdrive,involid,outvolid,blksize,autovol,mapper,
       report,ansidir)
int argc;
char *argv[];
char **indrive;
char **outdrive;
char involid[];
char outvolid[];
long *blksize;
long *autovol;
long *mapper;
long *report;
long *ansidir;

/****************************************************************************
 
 NAME: GETPAR
 
 get the parameters from the command line.

 ****************************************************************************/
{
   extern char *optarg;
   extern int optind;
   int c;
   int errflg = 0;
   int args;
   
   logflg = 0;
   strcpy(logdir,".");
   
   for (argc--, argv++; argc && **argv == '-'; argc -= args, argv += args)
   {
      args = 1;
      for ((*argv)++; **argv; (*argv)++)
	switch (**argv)
	{
	 case 'a':
	   *autovol = 1;
	   break;
	 case 'b':
	   *blksize = atoi(*(argv + args++));
	   break;
	 case 'D':
	   *ansidir = 1;
	   break;
	 case 'd':
	   strncpy(logdir,*(argv + args++),255);
	   logdir[255] = 0;
	   break;
	 case 'l':
	   logflg = 1;
	   break;
	 case 'm':
	   *mapper = 1;
	   break;
	 case 'P':
	   paranoid = 0;
	   break;
	 case 's':
	   *report = 1;
	   break;
	 case 'T':
	   *indrive = strdup(*(argv + args++));
	   break;
	 case 't':
	   *outdrive = strdup(*(argv + args++));
	   break;
	 case 'V':
	   strncpy(involid,*(argv + args++),7);
	   involid[7] = 0;
/*
	   strupr (involid,involid);
	   */
	   break;
	 case 'v':
	   strncpy(outvolid,*(argv + args++),7);
	   outvolid[7] = 0;
/*
	   strupr (outvolid,outvolid);
	   */
	   break;
	 default:
	   fprintf(stderr,
	    "usage:\nansicp [-TtVvbdalms][indrive][outdrive][involid][outvolid][blksize][directory]\n");
	   exit (1);
	}
   }
}


#include <time.h>
TimeStrings(timestr,month)
char timestr[],month[];
{
   struct tm *ts;
   time_t tval;

   tval = time(NULL);
   ts = localtime(&tval);
   strcpy(timestr,ctime(&tval));

   sprintf(month,"%02d%02d", ts->tm_year, ts->tm_mon + 1);
}
