#define	GLOBALS
#include		"ansi.h"
#undef	GLOBALS
#include        "worgen.h"
#include        "tapeio.h"

#define	USAGE		"usage: ansiin -[Tvlmt] [drive] [volid] [file] [file] ...\n"

static BOOL no_wild_cards ();
static BOOL search ();
static BOOL match ();
static BOOL valid ();
char	*strntrm();

static char	fsname[10];		/* name of file set		*/
static char	savefsname[10];		/* saved name of file set	*/
static char	pathname[20];		/* pathname of tape file	*/
static char	savename[20];		/* saved pathname of tape file	*/
static int	seq = 0;		/* current file sequence number	*/
static int	saveseq = 0;		/* saved file sequence number	*/
static int	sect = 0;		/* current file section number	*/
static int	savesect = 0;		/* saved file section number	*/

main (argc,argv)
int	argc;
char	**argv;
{
int	args;				/* arguments used in parsing	*/
int 	blk_count;			/* # of blocks in file section	*/
int	cont = ANSI_FALSE;		/* file continued next reel T/F	*/
int	copyfile = ANSI_FALSE;		/* copy file? T/F		*/
int	disk;				/* disk file descriptor		*/
int	files = 0;			/* number of files input	*/
int	maxfiles;			/* maximum # files to copy	*/
int	rec_count;			/* # of records in file section	*/
int	tape;				/* file desc (struct TAPEDESC)	*/
char	tempstr[10];			/* temporary character string	*/
int	tot_blocks = 0;			/* total # blocks in file	*/
int	tot_recs = 0;			/* total # records in file	*/
char	*volume_ident;			/* desired volume identifier	*/
char	*malloc(), *strcpy();
char buffer[CMLEN];


#ifdef unix
#ifdef sun
   /* I have no idea if this is correct, but it builds */
   setvbuf(stdout, buffer , _IOLBF,  CMLEN);
#else
   setlinebuf(stdout);
#endif
#endif


text = 0;
volume_ident = malloc(8); *volume_ident = 0;
pathname[0] = 0; savename[0] = 0;
density = "";
drive_name = NULL;
checkvol = 1;
lflag = 0;

for (argc--, argv++; argc && **argv == '-'; argc -= args, argv += args)
    {
    args = 1;
    for ((*argv)++; **argv; (*argv)++)
	switch (**argv)
	    {
	    case 'T':
	                drive_name = *(argv + args++);
			break;
	    case 'l':
			lflag = 2;
			break;
	    case 'm':
			lflag = 1;
			break;
	    case 't':
			text = 1;
			break;
	    case 'v':
			volume_ident = *(argv + args++);
			strupr (volume_ident,volume_ident);
			break;
	    default:
			fprintf (stderr,USAGE);
			exit (NOT_OK);
	    }
    }

mountvol ("ANSIIN",volume_ident,&tape,"enter tape id for first volume: ",1,0);

maxfiles = no_wild_cards (argc,argv) ? argc : 1000000;
maxfiles = (argc == 0) ? 1000000 : maxfiles;
for (files = 0; files < maxfiles; )
{
if (!get_header (tape))
    break;

if (cont || search (argv,pathname))
    {
    if (cont)
	if (!valid())
	    {
	    fprintf (stderr,"ANSIIN: do you want to try another tape? (y/n) ");
	    gets (tempstr);
	    if (tempstr[0] == 'y' || tempstr[0] == 'Y')
		{
		reelswitch ("ANSIIN",&tape,0,0);
		continue;
		}
	    else
		exit (NOT_OK);
	    }
    copyfile = ANSI_TRUE;
    /* if (!eov) */
        {
	if (!cont)
	    disk = open_disk (pathname,O_CREAT | O_WRONLY,0666);
	get_file (tape,disk,&rec_count,&blk_count);
	tot_recs   += rec_count;
	tot_blocks += blk_count;
	}
    /* else
	fsf_tape (tape,1);	*/			/* skip empty file */
    }
else
    {
    copyfile = ANSI_FALSE;
    fsf_tape (tape,1);				/* skip file	*/
    }
get_trailer (tape);
if (!strncmp (eof1.label_id,"EOF",3))		/* EOF	*/
    {
    if (copyfile)
	{
       	close (disk);
	savename[0] = 0;
	cont = ANSI_FALSE;
	print_file (tot_recs,tot_blocks);
	check_eof (blk_count);
	rec_count  = 0; blk_count  = 0;
	tot_recs   = 0; tot_blocks = 0;
	files++;
	}
    }
else if (!strncmp(eof1.label_id,"EOV1",4))		/* EOV	*/
    {
    if (copyfile)
	{
	cont = ANSI_TRUE;
	check_eof (blk_count);
	rec_count = 0;
	blk_count = 0;
	strcpy (savename,pathname);
	strcpy (savefsname,fsname);
	saveseq  = antoi(hdr1.info.file_seq_no,4);
	savesect = antoi(hdr1.info.file_sect_no,4);
	}
    reelswitch ("ANSIIN",&tape,0,0);
    }
else
    fprintf (stderr,"ansiin: unrecognized label: %s\n",eof1.label_id);
}
printf ("\n%d files copied from tape\n",files);
close_tape (tape,NOREW);
rewind_tape (99,ANSI_FALSE);
exit (OK);
}

static FUNCTION BOOL no_wild_cards (patterns,pattern)
register int	patterns;
register char	**pattern;
{
for (; patterns; patterns--, pattern++)
	if (strpbrk (*pattern,"*?"))
		return (ANSI_FALSE);
return (ANSI_TRUE);
}

static FUNCTION BOOL search (patterns,filename)
register char   **patterns;
register char	*filename;
{
strntrm (filename,hdr1.info.file_ident,17);  strlwr (filename,filename);
strntrm (fsname,hdr1.info.file_set_ident,6); strlwr (fsname,fsname);
if (!*patterns)
	return (ANSI_TRUE);
for (; *patterns; patterns++)
	if (match (*patterns,filename))
		return (ANSI_TRUE);
return (ANSI_FALSE);
}

static FUNCTION BOOL match (inpp,filename)
char		*inpp;
register char	*filename;
{
char tmpbuf[100];
char *pattern;
strlwr (tmpbuf,inpp);
pattern = tmpbuf;
for (; *pattern; pattern++, filename++)
    switch (*pattern)
	{
	case '*':
		if (*++pattern == '\0')
			return (ANSI_TRUE);
		for (; (*filename!='\0') && (*filename != *pattern); filename++)
			;
		if (*filename == '\0')
			return (ANSI_FALSE);
		break;
	case '?':
		if (*filename == '\0')
			return (ANSI_FALSE);
		break;
	default :
		if (*pattern != *filename)
			return (ANSI_FALSE);
		break;
	}
return ((*filename == '\0') ? ANSI_TRUE : ANSI_FALSE);
}

static FUNCTION BOOL valid ()
{
strntrm (pathname,hdr1.info.file_ident,17);  strlwr (pathname,pathname);
strntrm (fsname,hdr1.info.file_set_ident,6); strlwr (fsname,fsname);
seq  = antoi(hdr1.info.file_seq_no,4);
sect = antoi(hdr1.info.file_sect_no,4);
if (strcmp(pathname,savename) || strcmp(fsname,savefsname) ||
   (seq != saveseq) || (sect != savesect+1))
    {
    fprintf (stderr,"ANSIIN: continuation file problem\n\n");
    fprintf (stderr,"ANSIIN: expected: tape set %-6s\n",savefsname);
    fprintf (stderr,"ANSIIN:           file %-20s  seq %d  section %d\n\n",
		savename,saveseq,savesect+1);
    fprintf (stderr,"ANSIIN: found:    tape set %-6s\n",fsname);
    fprintf (stderr,"ANSIIN:           file %-20s  seq %d  section %d\n\n",
		pathname,seq,sect);
    return (ANSI_FALSE);
    }
return (ANSI_TRUE);
}
