/*******************************************************************************
FUNCTION: C_splitname

PURPOSE:  Split a file specification into a directory, a root file name and an
          extension.  The last character of the directory path will be either
	  a '/' or ']'.

PROGRAM HISTORY:

Version  Date   Author           Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    07/92  J.Fenno          Development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
         Run under TAE

PROJECT: ADAPS

*******************************************************************************/
#include <stdio.h>              /* Needed for standard i/o                    */
#include "worgen.h"

#ifdef vms
#define HOST_DIR_BEG '['
#define HOST_DIR_END ']'
#else
#define HOST_DIR_BEG '/'
#define HOST_DIR_END '/'
#endif


extern char *strrchr();         /* Locate last occurrance of a character      */
extern char *strchr();          /* Locate first occurrance of a character     */
extern char *strcpy();          /* Copy a string                              */


int c_splitname (filespec, directory, root, extension)

   char filespec[CMLEN];   /* IN  - File specification                 */
   char directory[CMLEN];  /* OUT - Directory portion of filespec      */
   char root[CMLEN];       /* OUT - Root portion of the file name      */
   char extension[CMLEN];  /* OUT - Extension portion of the file name */
{
char file_name[CMLEN];     /* Local copy of filespec                   */
char *ptr;                 /* String pointer                           */
char *ptr2;                /* String pointer                           */


/* Make a local copy of filespec so it is not destroyed
-------------------------------------------------------*/
strcpy(file_name, filespec);

#ifdef vms

   /* Check for a directory path
   -----------------------------*/
   ptr = (char *)strchr(file_name, HOST_DIR_BEG);
   if (ptr != NULL)
      {
      strcpy(directory, file_name);
      ptr = (char *)strrchr(directory, HOST_DIR_END);
      ptr++;
      strcpy(file_name, ptr);
      *ptr = '\0';
      }
   else
      strcpy(directory, "");

#else
   
   /* Check for a directory path
   -----------------------------*/
   ptr  = (char *)strchr (file_name, HOST_DIR_BEG);
   ptr2 = (char *)strrchr(file_name, HOST_DIR_END);
   if ((ptr != NULL) && (ptr != ptr2))        /* watch out for /filename */
      {
      strcpy(directory, file_name);
      ptr = (char *)strrchr(directory, HOST_DIR_END);
      ptr++;
      strcpy(file_name, ptr);
      *ptr = '\0';
      }
   else
      strcpy(directory, "");

#endif


/* Check for a file extension
-----------------------------*/
ptr = (char *)strrchr(file_name, '.');
if (ptr != NULL)
   {
   *(ptr++) = '\0';
   strcpy(root, file_name);
   strcpy(extension, ptr);
   }
else
   {
   strcpy(root, file_name);
   strcpy(extension, "");
   }
}
