#include "worgen.h"
#include "tapeio.h"
#include "ansicp.h"
#include <string.h>


long incnt = 0;
long intotal = 0;
long inbytes = 0;
long infcnt = 0;
   
long outcnt = 0;
long outtotal = 0;
long outbytes = 0;
long outfcnt = 0;

HDR1 out_hdr1;		/* header label #1		*/
HDR2 out_hdr2;		/* header label #2		*/
VOL1 out_vol1;		/* volume label #1		*/
VOL1 in_vol1;		/* volume label #1		*/


cp_tape(indrive,outdrive,invol,outvol,blk_size,mapper,ansidir)
long indrive;
long outdrive;
char *invol;
char *outvol;
long blk_size;
long mapper;
long ansidir;
{
   HDR1 *h1;
   EOF1 *ef1;
   EOV1 *ev1;

   HDR2 *h2;
   EOF2 *ef2;
   EOV2 *ev2;

   VOL1 *vptr;


   char rec_format;
   
   long blkcount;
   long oldblkcount;
   long reccount;
   
   long blksz;
   long bytes_read;
   long bytes_written;
   long maxblksz;
   long recsz;
   long reformat = 0;
   long status;
   extern int paranoid;
   


   long count = 0;

   char filename[20];

   maxblksz = ((struct TAPEDESC *) (outdrive))->maxbyte;

   fprintf(stderr,"Volume: %s\n",invol);
   
   if ( blk_size != 0 )
   {
      if(blk_size <= maxblksz)
	maxblksz = blk_size;
      else
      {
	 fprintf(stderr, "[ansicp-blocksize] Block size %d bytes is too big for output device.  Using default block size.\n");
      }
      
      
   }
   
   
   while (ANSI_TRUE)
   {
      /* read header records 
       ---------------------*/
      
      blksz = BUFSZ;
      
      while((bytes_read = read_tape(indrive,buf,BUFSZ)) > 0)
      {
	 if(mapper)
	   domap (inmapfile, bytes_read,&inbytes,&infcnt,&incnt,&intotal);
	 
	 if(!strncmp("VOL",(char *)buf,3) && buf[3] == '1') /* volume record */
	 {
	    vptr = (VOL1 *) buf;

	    if(ansidir)
            {
	       memcopy(&vol1,vptr,sizeof(VOL1));
	       memcopy(&in_vol1,vptr,sizeof(VOL1));
	    }
	    

	    strncpy((char *)vptr->volume_ident,outvol,
		    MIN(sizeof(vptr->volume_ident),strlen(outvol)));

	    if(ansidir)
	      memcopy(&out_vol1,vptr,sizeof(VOL1));
	    
	 }
	 else if (!strncmp("HDR",(char *)buf,3))
	 {
	    if(buf[3] == '1')
	    {
	       h1 = (HDR1 *) buf;
	       
	       if(ansidir)
		 memcopy(&hdr1,h1,sizeof(HDR1));
	       strncpy ((char *)h1->info.file_set_ident,outvol,
			MIN(sizeof(h1->info.file_set_ident),strlen(outvol)));
	       strntrm (filename,h1->info.file_ident,
			sizeof(h1->info.file_ident));
	       if(ansidir)
		 memcopy(&out_hdr1,h1,sizeof(HDR1));
	    }
	    else if (buf[3] == '2')
	    {
	       h2 = (HDR2 *) buf;
	       
	       if(ansidir)
		 memcopy(&hdr2,h2,sizeof(HDR2));
	       blksz = antoi(h2->info.blk_length,
			     sizeof(h2->info.blk_length));
	       recsz = antoi(h2->info.rec_length,
			     sizeof(h2->info.rec_length));
	       rec_format = h2->info.rec_format;


	       if(blksz > maxblksz || blk_size != 0 )
	       {
		  blksz = maxblksz / recsz;
		  if(blksz == 0)
		  {
		     fprintf(stderr,
			     "[ansicp-blocksize] Output blocksize is smaller than input record.\n");
		     fprintf(stderr,"[ansicp-fatal] Fatal error encountered.\n");
		     fprintf(stderr,"[ansicp-fatal] Aborting tape copy!\n");
		     fflush(stderr);
			
		     close_tape(outdrive,REWOFFL);
		     close_tape(indrive,REWOFFL);
		     exit(1);
		  }

		  blksz *= recsz;

		  strncod(h2->info.blk_length,blksz,
			  sizeof(h2->info.blk_length));
		  
		  reformat = 1;
	       }
	       else 
		 reformat = 0;

	       if(ansidir)
		 memcopy(&out_hdr2,h2,sizeof(HDR2));
	    }
	 }
	 bytes_written = write_tape(outdrive,buf,bytes_read);
	 if(mapper)
	   domap (outmapfile, bytes_written,&outbytes,&outfcnt,&outcnt,
		  &outtotal);
      }

      write_eof(outdrive);

      if (bytes_read < 0)
	if ( bytes_read != TAPE_EOT && bytes_read != TAPE_EOV && 
	    bytes_read != TAPE_EOF)
	{
	   fprintf(stderr,"[ansicp-fatal] Aborting tape copy!\n");
	   fflush(stderr);
	   close_tape(outdrive,REWOFFL);
	   close_tape(indrive,REWOFFL);
	   exit(1);
	}
	 
      if(mapper)
      {
	 domap (inmapfile, bytes_read,&inbytes,&infcnt,&incnt,&intotal);
	 domap (outmapfile, bytes_read,&outbytes,&outfcnt,&outcnt,
		&outtotal);
      }
      


      if(bytes_read == TAPE_EOV || bytes_read == TAPE_EOT)
	return;
      
      /* copy the file from one tape to another, reformatting if necessary
	 -----------------------------------------------------------------*/

      blkcount = 0;
      reccount = 0;
      
      while((bytes_read = read_tape(indrive,buf,BUFSZ)) > 0)
      {
	 if(mapper)
	   domap (inmapfile, bytes_read,&inbytes,&infcnt,&incnt,&intotal);
	 
	 if(reformat)
	   reformat_block(outdrive,buf,blksz,recsz,bytes_read,rec_format,
			  &blkcount,&reccount,mapper);
	 else
	 {
	    bytes_written = write_tape(outdrive,buf,bytes_read);
	    if(mapper)
	      domap (outmapfile, bytes_written,&outbytes,&outfcnt,&outcnt,
		     &outtotal);
	   if(ansidir)
	     scan_block(buf,blksz,recsz,bytes_read,rec_format, &blkcount,
			&reccount);
	    blkcount++;
	 }
      }

      if(reformat)
	reformat_block(outdrive,buf,blksz,recsz,bytes_read,rec_format,
		       &blkcount,&reccount,mapper);
      
      write_eof(outdrive);

      if (bytes_read < 0)
	if ( bytes_read != TAPE_EOT && bytes_read != TAPE_EOV && 
	    bytes_read != TAPE_EOF)
	{
	   fprintf(stderr,"[ansicp-fatal] Aborting tape copy!\n");
	   fflush(stderr);
	   close_tape(outdrive,REWOFFL);
	   close_tape(indrive,REWOFFL);
	   exit(1);
	}

      if(mapper)
      {
	 domap (inmapfile, bytes_read,&inbytes,&infcnt,&incnt,&intotal);
	 domap (outmapfile, bytes_read,&outbytes,&outfcnt,&outcnt,
		&outtotal);
      }

      
      if(bytes_read == TAPE_EOV || bytes_read == TAPE_EOT)
	return;

      /* output the trailer records 
	 --------------------------*/

      while((bytes_read = read_tape(indrive,buf,BUFSZ)) > 0)
      {
	 if(mapper)
	   domap (inmapfile, bytes_read,&inbytes,&infcnt,&incnt,&intotal);
	 
	 if (!strncmp("EOF",(char *)buf,3))
	 {
	    if(buf[3] == '1')
	    {
	       ef1 = (EOF1 *) buf;
	       
	       if(ansidir)
		 oldblkcount = antoi(ef1->info.blk_count,6);
		  
	       strncpy ((char *)ef1->info.file_set_ident,outvol,
			MIN(sizeof(ef1->info.file_set_ident),strlen(outvol)));
	       strncod(ef1->info.blk_count,blkcount,
		       sizeof(ef1->info.blk_count));
	    }
	    else if (buf[3] == '2' && reformat)
	    {
	       ef2 = (EOF2 *) buf;
	       
	       strncod(ef2->info.blk_length,blksz,
		       sizeof(ef2->info.blk_length));
	    }
	 }
	 if (!strncmp("EOV",(char *)buf,3))
	 {
	    if(buf[3] == '1')
	    {
	       ev1 = (EOV1 *) buf;
	       
	       if(ansidir)
		 oldblkcount = antoi(ev1->info.blk_count,6);

	       strncpy ((char *)ev1->info.file_set_ident,outvol,
			MIN(sizeof(ev1->info.file_set_ident),strlen(outvol)));
	       strncod(ev1->info.blk_count,blkcount,
		       sizeof(ev1->info.blk_count));
	    }
	    else if (buf[3] == '2' && reformat)
	    {
	       ev2 = (EOV2 *) buf;
	       
	       strncod(ev2->info.blk_length,blksz,
		       sizeof(ev2->info.blk_length));
	    }
	 }
	 bytes_written = write_tape(outdrive,buf,bytes_read);
	 if(mapper)
	   domap (outmapfile, bytes_written,&outbytes,&outfcnt,&outcnt,
		  &outtotal);
      }
      
      write_eof(outdrive);

      if (bytes_read < 0)
	if ( bytes_read != TAPE_EOT && bytes_read != TAPE_EOV && 
	    bytes_read != TAPE_EOF)
	{
	   fprintf(stderr,"[ansicp-fatal] Aborting tape copy!\n");
	   fflush(stderr);
	   close_tape(outdrive,REWOFFL);
	   close_tape(indrive,REWOFFL);
	   exit(1);
	}

      if(mapper)
      {
	 domap (inmapfile, bytes_read,&inbytes,&infcnt,&incnt,&intotal);
	 domap (outmapfile, bytes_read,&outbytes,&outfcnt,&outcnt,
		&outtotal);
      }

      fprintf(stderr,"File %s copied to volume %s.\n",filename,outvol);
      fflush(stderr);

      if(ansidir)
      {
	 fprint_file(indirfile,reccount,oldblkcount,count);
	 if(!paranoid)
	 {
	    memcopy(&vol1,&out_vol1,sizeof(VOL1));
	    memcopy(&hdr1,&out_hdr1,sizeof(HDR1));
	    memcopy(&hdr2,&out_hdr2,sizeof(HDR2));
	    fprint_file(outdirfile,reccount,blkcount,count);
	    memcopy(&vol1,&in_vol1,sizeof(VOL1));
	 }
      }
      
      count++;
      
      if(bytes_read == TAPE_EOV || bytes_read == TAPE_EOT)
      {
	 fprintf(stderr,"%d files copied.\n",count);
         if(ansidir)
         {	
            fprintf(indirfile,"%d files on tape\n",count);
	    if(!paranoid)
              fprintf(outdirfile,"%d files on tape\n",count);
         }
	 return;
      }
      
   }
}
