#include        "worgen.h"
#include        "tapeio.h"
#include	"ansi.h"
static VOID get_utls();
static VOID get_eof();
static VOID get_eov();

static FUNCTION VOID get_eof(fd)
int	fd;			/* tape file desc (struct TAPEDESC)	*/
	{
	if (get_label(fd,(char *)&eof2,"EOF",2,ANSI_TRUE))
	    get_utls(fd);
	return;
	}

static FUNCTION VOID get_eov(fd)
int	fd;			/* tape file desc (struct TAPEDESC)	*/
	{
	if (get_label(fd,(char *)&eov2,"EOV",2,ANSI_TRUE))
	    get_utls(fd);
	return;
	}

FUNCTION BOOL get_header(fd)
int	fd;			/* tape file desc (struct TAPEDESC)	*/
{
int	indx;
char	*strcpy();
char	*strncpy();

eof = ANSI_FALSE;

if (eov || eot)
    return (ANSI_FALSE);

if (!strncmp ((char *)&uvln,"HDR1",4))			/* uvln = HDR1	*/
    {
    strncpy ((char *)&hdr1,(char *)&uvln,LABELSZ);
    strnupr ((char *)&hdr1,(char *)&hdr1,LABELSZ);
    strcpy  ((char *)&uvln,"\000");
    }
else
    if (!get_label (fd,(char *)&hdr1,"HDR",1,ANSI_TRUE))
	return (ANSI_FALSE);

if (!get_label (fd,(char *)&hdr2,"HDR",2,ANSI_TRUE))
    return (ANSI_FALSE);

switch (hdr2.info.rec_format)
    {
    case 'D':
    case 'F':
    case 'S':
	    break;
    default:
	    fprintf (stderr,"(get_header) Invalid record format: {%c}\n",
			hdr2.info.rec_format);
	    exit (NOT_OK);
    }

for (indx = 3; indx < 10; indx++)
    if (!get_label(fd,(char *)&hdrn,"HDR",indx,ANSI_FALSE))
	break;

if (!strncmp ((char *)&hdrn,"UHL",3))
    for (;;)
	if (!get_label (fd,(char *)&uhla,"UHL",0,ANSI_FALSE))
	    break;

if (eov)
    /* 2 consecutive tapemarks indicate an empty data file -	*/
    /* get trailer records (EOFs or EOVs) next.			*/
    return (ANSI_TRUE);

if (!eof)
    {
    fprintf (stderr,"(get_header) Tape-mark required after File-Headers\n");
    exit (NOT_OK);
    }
return (ANSI_TRUE);
}

FUNCTION BOOL get_label (fd,label,label_id,label_no,strict)
int	fd;				/* file desc (struct TAPEDESC)	*/
char	*label;				/* address for desired label	*/
char	*label_id;			/* expected label->label_id	*/
int	label_no;			/* expected label->label_no	*/
int	strict;				/* strict error checking	*/
{
int	bufsz;
char 	*strcpy();

strcpy (label,"XXX9");
if ((bufsz = read_tape (fd,label,LABELSZ)) != LABELSZ)
    {
    if (bufsz <= 0)
	{
	eof = ANSI_TRUE;
	if (bufsz == TAPE_EOV) eov = ANSI_TRUE;
	if (bufsz == TAPE_EOT) eot = ANSI_TRUE;
	return (ANSI_FALSE);
	}
    if (strict)
	{
	fprintf (stderr,"(get_label) Tape label %s%d size error. ",
		label_id,label_no);
	fprintf (stderr,"Expected 80, Got %d\n",bufsz);
	}
    return (ANSI_FALSE);
    }
else
    {
    eof = ANSI_FALSE;
    eov = ANSI_FALSE;
    eot = ANSI_FALSE;
    }
if (strlen(label_id) &&
    strncmp((char *)label,(char *)label_id,strlen(label_id)))
    {
    if (strict)
	{
	fprintf (stderr,"(get_label) Tape Label-Id Error ");
	fprintf (stderr,"Expected %s Got %3.3s\n",label_id,label);
	}
    return (ANSI_FALSE);
    }
else if (label_no && label[3] != '0' + label_no)
    {
    if (strict)
	{
	fprintf (stderr,"(get_label) Tape Label-Number Error ");
	fprintf (stderr,"Expected %d Got %4.4s\n",label_no,label);
	}
    return (ANSI_FALSE);
    }
strnupr (label,label,LABELSZ);
return (ANSI_TRUE);
}

FUNCTION VOID get_trailer(fd)
int	fd;			/* tape file desc (struct TAPEDESC)	*/
{
char *strcnpy();

eof = ANSI_FALSE;
if (get_label(fd,(char *)&eof1,"EOF",1,ANSI_FALSE))
    get_eof(fd);
else if (!strncmp((char *)eof1.label_id,"EOV1",4))
    {
    strncpy((char *)&eov1,(char *)&eof1,LABELSZ);
    get_eov(fd);
    }
if (!eof)
    {
    fprintf (stderr,"(get_trailer) Tape-mark required after File-Trailers\n");
    exit(NOT_OK);
    }
return;
}

static FUNCTION VOID get_utls(fd)
int	fd;			/* tape file desc (struct TAPEDESC)	*/
	{
	for (;;)
		if (!get_label(fd,(char *)&utla,"UTL",0,ANSI_FALSE))
			break;
	return;
	}
