#include	"ansi.h"

FUNCTION int get_file (tape,disk,rec_count,blk_count)
int	tape;				/* file desc (struct TAPEDESC)	*/
int	disk;				/* disk file descriptor		*/
int	*rec_count;			/* record count			*/
int	*blk_count;			/* block count			*/
{
int		blk_size;		/* size of current block	*/
int		recsz;			/* record size			*/
int		spanning;		/* spanning indicator		*/
int		blk_len;		/* block length in header	*/
int		rec_len;		/* record length in header	*/
int		rmndr;			/* remaining part of blk (F)	*/
int		write_sz;		/* actual length of disk write	*/
unsigned char	*ptr;			/* record pointer		*/
char		recszbuf[5];		/* buffer for record size field	*/
char		*strncpy();

#define	HANDLE_ERR							\
	{								\
	if (write_sz == -1)						\
	    perror ("get_file");					\
	else								\
	    fprintf (stderr,"(get_file) short transfer I/O error\n");	\
	exit (-1);							\
	}

blk_len = antoi (hdr2.info.blk_length,sizeof(hdr2.info.blk_length));
rec_len = antoi (hdr2.info.rec_length,sizeof(hdr2.info.rec_length));

switch (hdr2.info.rec_format)
{
case 'D':
    for (*blk_count = 0, *rec_count = 0;
	(blk_size = read_tape (tape,buf,BUFSZ)) > 0; (*blk_count)++)
	{
	if (blk_size > blk_len)
	    {
	    fprintf (stderr,"(get_file) Blocksize %d exceeded\n",blk_len);
	    fprintf (stderr,"(get_file) Blocksize read = %d\n",blk_size);
	    }
	for (ptr= &buf[0]; ptr != &buf[blk_size]; ptr+=recsz,(*rec_count)++)
	    {
	    if (strncmp(ptr,"^^^^",4))		/* if not pad chars,	*/
		{				/* write record		*/
		strncpy (recszbuf,ptr,4);
		recsz = atoi (recszbuf);
		if (disk != -1)
		    {
		    if ((write_sz = write (disk,(char *)ptr+4,recsz-4)) != recsz-4)
		        {
		        printf ("(get_file) disk = %d, recsz = %d, write_sz = %d\n",
			        disk,recsz,write_sz);
		        printf ("(get_file) ptr = %40.40s\n",ptr);
		        HANDLE_ERR;
		        }
		    }
		if (text)			/* append carriage return */
		    {
		    if (disk != -1)
			{
		        if ((write_sz = write (disk,"\n",1)) != 1)
			    HANDLE_ERR;
			}
		    }
		}
	    else		/* pad chars found; go on to next block	*/
		break;
	    }
	}
    break;

case 'F':
    for (*blk_count = 0, *rec_count = 0;
	(blk_size = read_tape (tape,buf,BUFSZ)) > 0; (*blk_count)++)
	{
	if (blk_size > blk_len)
	    {
	    fprintf (stderr,"(get_file) Blocksize %d exceeded\n",blk_len);
	    fprintf (stderr,"(get_file) Blocksize read = %d\n",blk_size);
	    }
	for (ptr = &buf[0], rmndr = blk_size; ptr != &buf[blk_size];
	     ptr += rec_len, (*rec_count)++, rmndr -= rec_len)
	    {
	    if (rmndr < rec_len)
		{	/* it's too short to be a valid record. is it pad? */
		if (bufncmp (ptr,'^',rmndr))		/* it's not pad */
		    {
		    fprintf (stderr,"(get_file) short record:  ");
		    fprintf (stderr,"expected %d, found %d\n",rec_len,rmndr);
		    exit (-1);
		    }
		else		/* pad chars found; go on to next block	*/
		    break;
		}
	    else if (bufncmp(ptr,'^',rec_len))		/* write record	*/
		{
		if (disk != -1)
		    {
	            if ((write_sz = write (disk,(char *)ptr,rec_len)) != rec_len)
		        HANDLE_ERR;
		    if (text)			/* append carriage return */
		        if ((write_sz = write (disk,"\n",1)) != 1)
			    HANDLE_ERR;
		    }
		}
	    else		/* pad chars found; go on to next block	*/
		break;
	    }
	}
    break;

case 'S':
    for (*blk_count = 0, *rec_count = 0;
	(blk_size = read_tape (tape,buf,BUFSZ)) > 0; (*blk_count)++)
	{
	if (blk_size > blk_len)
	    {
	    fprintf (stderr,"(get_file) Blocksize %d exceeded\n",blk_len);
	    fprintf (stderr,"(get_file) Blocksize read = %d\n",blk_size);
	    }
	for (ptr = &buf[0]; ptr != &buf[blk_size]; ptr += recsz, *(rec_count)++)
	    {
	    if (strncmp(ptr,"^^^^^",5))		/* if not pad chars,	*/
		{				/* write record		*/
		strncpy (recszbuf,ptr,1);
		spanning = atoi (recszbuf);
		(*rec_count) += (spanning == 0 || spanning == 3) ? 1 : 0;
		strncpy (recszbuf,ptr+1,4);
		recsz = atoi (recszbuf);
		if (disk != -1)
		    {
		    if ((write_sz = write (disk,(char *)ptr+5,recsz-5)) != recsz-5)
		        HANDLE_ERR;
		    if (text)			/* append carriage return */
		        if (spanning == 0 || spanning == 3)
			    if ((write_sz = write (disk,"\n",1)) != 1)
			        HANDLE_ERR;
		    }
		}
	    else		/* pad chars found; go on to next block	*/
		break;
	    }
	}
    break;

default:
    break;
    }
}
