/*
 *	ANSI X3.27-1978  American National Standard Magnetic
 *		Tape Labels and File Structure for Information Interchange
 *			pp 13-18
 */

/*
 *	Label #1 Generic Information
 */
typedef struct
	{
	char	file_ident[17];		/* file identifier */
	char	file_set_ident[6];	/* file-set identifier */
	char	file_sect_no[4];	/* file section number */
	char	file_seq_no[4];		/* file sequence number */
	char	gener_no[4];		/* generation number */
	char	gener_ver_no[2];	/* generation version number */
	char	create_date[6];		/* creation date " yyddd" */
	char	expire_date[6];		/* expiration date " yyddd" */
	char	accessability;		/* accessability */
	char	blk_count[6];		/* block count */
	char	system_code[13];	/* system code */
	char	hdr1_spaces[7];		/* spaces */
	} INFO1;
/*
 *	Label #2 Generic Information
 */
typedef struct
	{
	char	rec_format;		/* "F" - fixed length */
					/* "D" - variable length */
					/* "S" - spanned */
	char	blk_length[5];		/* block length in characters */
	char	rec_length[5];		/* record length in characters */
	char	hdr2_spaces1[35];	/* spaces */
	char	buffer_offset_length[2];/* buffer-offset length */
	char	hdr2_spaces2[28];	/* spaces */
	} INFO2;
/*
 *	File-Header #1 Layout
 */
typedef struct
	{
	char	label_id[3];		/* "HDR" */
	char	label_no;		/* "1" */
	INFO1	info;
	} HDR1;
/*
 *	File-Header #2 Layout
 */
typedef struct
	{
	char	label_id[3];		/* "HDR" */
	char	label_no;		/* "2" */
	INFO2	info;
	} HDR2;
/*
 *	File-Header #n Layout
 */
typedef struct
	{
	char	label_id[3];		/* "HDR" */
	char	label_no;		/* "3", "4", ... "9" */
	char	hdrn_data[76];		/* reserved for system use */
	} HDRN;
/*
 *	User Header Labels
 */
typedef struct
	{
	char	label_id[3];		/* "UHL" */
	char	label_no;		/* "a" character */
	char	uhla_data[76];		/* reserved for user application */
	} UHLA;
