#include "ansi.h"
#include "worgen.h"
#include "tapeio.h"


FUNCTION mountvol (prog,volid,tape,msg,rewind,fstopen)
char	*prog;				/* calling program		*/
int	*tape;				/* file desc (struct TAPEDESC)	*/
char 	*volid;				/* desired volume identifier	*/
char 	*msg;				/* msg to operator		*/
int	rewind;				/* rewind flag			*/
long	fstopen;			/* first open? 1=yes 0=no	*/

{
static char drive[256];
char 	the_volume[8];			/* actual volume identifier	*/
char	tempstr[10];			/* temporary character string	*/
int	indx;				/* loop counter			*/
int	rslt;				/* rslt of get_label call	*/
int	ansidir=0, ansiin=0, ansiout=0, ulout=0;
char	*malloc(), *strcat(), *strcpy(), *strntrm();

if (strcmp(prog,"ANSIDIR") == 0) 	ansidir = 1;
else if (strcmp(prog,"ANSIIN") == 0)	ansiin  = 1;
else if (strcmp(prog,"ANSIOUT") == 0)	ansiout = 1;
else if (strcmp(prog,"ULOUT") == 0)	ulout   = 1;

if ((ulout) || (ansidir && strcmp(volid," ") == 0))
    checkvol = 0;					/* ignore label	*/

if (checkvol)
    while (strlen(volid) == 0)		/* get tape number		*/
	{
	fprintf (stderr,"%s: %s",prog,msg);
	gets (volid);
	strupr (volid, volid);
	}

while (drive_name == NULL)
    {
    if (ulout)
	fprintf (stderr,"%s: enter tape drive name for %s\n",prog,msg);
    else if (checkvol)
	fprintf (stderr,"%s: enter tape drive name for tape %s: ",prog,volid);
    else
	fprintf (stderr,"%s: enter tape drive name for tape: ",prog,volid);
    drive_name = drive;
    gets (drive_name);
    }

if ((ansiout || ulout) && splitfile)
    while (tlen == 0.0)
    {	
    if (ansiout)
	fprintf (stderr,"%s: enter length of tape %s (feet): ",prog,volid);
    else  /* ulout */
	fprintf (stderr,"%s: enter length of unlabelled tape (feet): ",prog);
    gets (tempstr);
    tlen = (float)(atoi (tempstr)) * (12.0 * .95);
    }

if (fstopen)
   *tape = open_the_tape (1,O_RDONLY);
else
   *tape = reopen_tape (1,O_RDONLY);

if (!ulout)
{
while ( !(rslt = get_label (*tape,(char *)&vol1,"VOL",1,ANSI_TRUE)) ||
    (checkvol && strncmp (vol1.volume_ident,volid,strlen(volid))) )
    {
    print_volume ();
    close_tape (*tape,NOREW);
    rewind_tape (*tape,ANSI_FALSE);

    if (!rslt)					/* get_label error	*/
      {
      fprintf (stderr,"(mountvol) Drive %s: Tape Label Error \n",drive_name);
      fprintf (stderr,"(mountvol) Verify that this is an ANSI labelled tape\n");
      sleep (5);
      }
    else					/* volume id mismatch	*/
	{
	strntrm (the_volume,vol1.volume_ident,sizeof(vol1.volume_ident));
	fprintf (stderr,"(mountvol) %s: Requested Volume: %s,  found: %s\n",
		prog,volid,the_volume);
	}

    if (checkvol)
	*volid = 0;
    while (strlen(volid) == 0)		/* try again for tape number	*/
	{
	fprintf (stderr,"%s: %s",prog,msg);
	gets (volid);
	strupr (volid, volid);
	}
    if (fstopen)
       *tape = open_the_tape (1,O_RDONLY);
    else
       *tape = reopen_tape (1,O_RDONLY);
    }
}

if (ansiout || ulout)
    {
    close_tape (*tape,NOREW);
    *tape = reopen_tape (rewind,O_RDWR);
    }
else if (ansiin || ansidir)
    {
    for (indx = 1; indx < 10; indx++)
	if (!get_label (*tape,(char *)&uvln,"UVL",indx,ANSI_FALSE))
	    break;
    print_volume ();
    }
}

FUNCTION a_mountvol (prog,volid,tape,msg,rewind)
char	*prog;				/* calling program		*/
int	*tape;				/* file desc (struct TAPEDESC)	*/
char 	*volid;				/* desired volume identifier	*/
char 	*msg;				/* msg to operator		*/
int	rewind;				/* rewind flag			*/

{
static char drive[256];
char	tempstr[10];			/* temporary character string	*/
int	ansiout=0, ulout=0;

if (strcmp(prog,"ANSIOUT") == 0)	
    ansiout = 1;
else
    {
    fprintf(stderr,"%s: program cannot call a_mountvol\n",prog);
    return;
    }

while (drive_name == NULL)
    {
    if (ulout)
	fprintf (stderr,"%s: enter tape drive name for %s\n",prog,msg);
    else if (checkvol)
	fprintf (stderr,"%s: enter tape drive name for tape %s: ",prog,volid);
    else
	fprintf (stderr,"%s: enter tape drive name for tape: ",prog,volid);
    drive_name = drive;
    gets (drive_name);
    }

if ((ansiout || ulout) && splitfile)
    while (tlen == 0.0)
    {	
    if (ansiout)
	fprintf (stderr,"%s: enter length of tape %s (feet): ",prog,volid);
    else  /* ulout */
	fprintf (stderr,"%s: enter length of unlabelled tape (feet): ",prog);
    gets (tempstr);
    tlen = (float)(atoi (tempstr)) * (12.0 * .95);
    }

*tape = reopen_tape (rewind,O_RDWR);
return;
}
