#include		"ansi.h"

FUNCTION VOID print_file(rec_count,blk_count)
int	rec_count;			/* file record count		*/
int	blk_count;			/* file block count		*/
{
   static int c = 0;
   int status;

   status = fprint_file(stdout,rec_count,blk_count,c);
   c++;
   return(status);
}

FUNCTION VOID fprint_file(fp,rec_count,blk_count,count)
FILE *fp;
int	rec_count;			/* file record count		*/
int	blk_count;			/* file block count		*/
int count;
{
char tempname[20];

if (newpg)
    {
    count = 0;
    newpg = 0;
    }

if (lflag == 2)						/* Long list	*/
/*
System: xxxxxxxxxx  Drive: x  Owner: xxxxxxxxxxxxxx  File Set: xxxxxx

Volume File Sect Filename          Creat Expir Fmt Recsz Blksz Records Blocks 
====== ==== ==== ================= ===== ===== === ===== ===== ======= ======
xxxxxx nnnn nnnn xxxxxxxxxxxxxxxxx nnnnn nnnnn  x  nnnnn nnnnn nnnnnn  nnnnnn
*/
 {
 if (count++ == 0)
  {
  fprintf(fp,
   "\fSystem: %-10.10s  Drive: %-10.10s  Owner: %-14.14s  File Set: %-6.6s\n\n",
      hdr1.info.system_code, drive_name, vol1.owner_ident, 
	  vol1.volume_ident);
  fprintf (fp,"Volume File Sect Filename          ");
  fprintf (fp,"Creat Expir Fmt Recsz Blksz Records Blocks\n");
  fprintf (fp,"====== ==== ==== ================= ");
  fprintf (fp,"===== ===== === ===== ===== ======= ======\n");
  }
 fprintf (fp,"%-6.6s %4d %4d %-17.17s %5.5s %5.5s  %c  %5d %5d %7d %6d\n",
	vol1.volume_ident, antoi(hdr1.info.file_seq_no,4),
	antoi(hdr1.info.file_sect_no,4), hdr1.info.file_ident,
	&hdr1.info.create_date[1], &hdr1.info.expire_date[1],
	(hdr2.info.rec_format), antoi(hdr2.info.rec_length,5),
	antoi(hdr2.info.blk_length,5), rec_count, blk_count
	);
 }
else if (lflag == 1)					/* Medium List	*/
/*
System: xxxxxxxxxx  Drive: x  Owner: xxxxxxxxxxxxxx  File Set: xxxxxx

Volume File Sect Filename          Creat Expir Fmt Recsz Blksz
====== ==== ==== ================= ===== ===== === ===== =====
xxxxxx nnnn nnnn xxxxxxxxxxxxxxxxx nnnnn nnnnn  x  nnnnn nnnnn
*/
 {
 if (count++ == 0)
  {
  fprintf(fp,
   "\fSystem: %-10.10s  Drive: %-10.10s  Owner: %-14.14s  File Set: %-6.6s\n\n",
      hdr1.info.system_code, drive_name, vol1.owner_ident, 
	  vol1.volume_ident);
  
  fprintf (fp,"Volume File Sect Filename          ");
  fprintf (fp,"Creat Expir Fmt Recsz Blksz\n");
  fprintf (fp,"====== ==== ==== ================= ");
  fprintf (fp,"===== ===== === ===== =====\n");
  }
 fprintf (fp,"%-6.6s %4d %4d %-17.17s %5.5s %5.5s  %c  %5d %5d\n",
	vol1.volume_ident, antoi(hdr1.info.file_seq_no,4),
	antoi(hdr1.info.file_sect_no,4), hdr1.info.file_ident,
	&hdr1.info.create_date[1], &hdr1.info.expire_date[1],
	(hdr2.info.rec_format), antoi(hdr2.info.rec_length,5),
	antoi(hdr2.info.blk_length,5)
	);
 }
else							/* Short list	*/
 {
 /* always low case name when printed. actually only ansiin should	*/
 /* should print lowcase;  ansiout and ansidir should be UPCASE.	*/
 /* this would muck up ndcdb and make Darla mad at me.			*/

 strnlwr (tempname, hdr1.info.file_ident,17);
 fprintf (fp,"%-17.17s ",tempname);
 if (++count % (isatty(1) ? 4 : 1) == 0)
    fprintf(fp,"\n");
 }
fflush(fp);
return;
}
FUNCTION VOID print_volume()
{
if (vol1.label_version != LABEL_VERSION)
    fprintf (stderr,"Volume Label Version Error {%c}\n\n", vol1.label_version);
fprintf (stderr,"Volume: %-6.6s, Owner: %-14.14s\n",
	vol1.volume_ident,vol1.owner_ident);
return;
}

FUNCTION VOID print_ul (filename,recsz,blksz,rec_count,blk_count)
char	*filename;			/* name of file			*/
int	recsz;				/* record size			*/
int	blksz;				/* block size			*/
int	rec_count;			/* file record count		*/
int	blk_count;			/* file block count		*/
{
static int count = 0;
char tempname[20];
char	hostname[13];			/* hostname		*/

gethostname (hostname,13);
strupr (hostname,hostname);

if (newpg)
    {
    count = 0;
    newpg = 0;
    }

if (lflag == 2)						/* Long list	*/
/*
System: xxxxxx    Drive: x

Filename          Recsz Blksz Records Blocks 
================= ===== ===== ======= ======
xxxxxxxxxxxxxxxxx nnnnn nnnnn nnnnnnn nnnnnn
*/
    {
    if (count++ == 0)
      {
      printf ("\fSystem: %s    Drive: %-10.10s\n\n",hostname,drive_name);
      printf ("Filename          Recsz Blksz Records Blocks\n");
      printf ("================= ===== ===== ======= ======\n");
      }
    printf ("%-17.17s %5d %5d %7d %6d\n",
	filename,recsz,blksz,rec_count,blk_count);
    }
else if (lflag == 1)					/* Medium List	*/
/*
System: xxxxxxxxx Drive: x

Filename          Recsz Blksz
================= ===== =====
xxxxxxxxxxxxxxxxx nnnnn nnnnn
*/
    {
    if (count++ == 0)
      {
      printf ("\fSystem: %s    Drive: %-10.10s\n\n",hostname,drive_name);
      printf ("Filename          Recsz Blksz \n");
      printf ("================= ===== ===== \n");
      }
    printf ("%-17.17s %5d %5d\n",filename,recsz,blksz);
    }
else							/* Short list	*/
    {
    /* always low case name when printed. actually only ansiin should	*/
    /* should print lowcase;  ansiout and ansidir should be UPCASE.	*/
    /* this would muck up ndcdb and make Darla mad at me.		*/

    strnlwr (tempname,filename,17);
    printf ("%-17.17s ",tempname);
    if (++count % (isatty(1) ? 4 : 1) == 0)
	printf("\n");
    }
return;
}
