#include        "worgen.h"
#include        "tapeio.h"
#include	"ansi.h"

FUNCTION VOID init_labels (volume_ident,owner_ident)
char	*volume_ident;			/* volume identifier	*/
char	*owner_ident;			/* owner identifier	*/
{
char		hostname[13];		/* hostname		*/
char		tmbuf[4];
long		clock;
long		time();
struct tm	*tm;
struct tm	*localtime();
char		*strncpy();

/***   Initialize VOL1 Label   ***/

make_label ((char *) &vol1,sizeof(vol1),"VOL1");
strncpy ((char *)vol1.volume_ident,volume_ident,
	MIN(sizeof(vol1.volume_ident),strlen(volume_ident)));
strncpy ((char *)vol1.owner_ident,owner_ident,
	MIN(sizeof(vol1.owner_ident),strlen(owner_ident)));
vol1.label_version = LABEL_VERSION;

/***   Initialize HDR1 Label   ***/

gethostname (hostname,13);
strupr (hostname,hostname);
make_label ((char *) &hdr1,sizeof(hdr1),"HDR1");
strncpy ((char *)hdr1.info.file_set_ident,(char *)vol1.volume_ident,
	sizeof(hdr1.info.file_set_ident));
strnset (hdr1.info.gener_no,'0',sizeof(hdr1.info.gener_no));
strnset (hdr1.info.gener_ver_no,'0',sizeof(hdr1.info.gener_ver_no));
clock = time (0);
tm = localtime(&clock);
sprintf (tmbuf,"%3d",tm->tm_year);
strncpy ((char *)hdr1.info.create_date,(char *)tmbuf,3);
sprintf (tmbuf,"%03d",tm->tm_yday+1);
strncpy ((char *)&hdr1.info.create_date[3],(char *)tmbuf,3);
strnset (&hdr1.info.expire_date[1],'0',sizeof(hdr1.info.expire_date)-1);
strnset (hdr1.info.blk_count,'0',sizeof(hdr1.info.blk_count));
strncpy ((char *)hdr1.info.system_code,hostname,
	MIN(sizeof(hdr1.info.system_code)-1,strlen(hostname)));

/***   Initialize HDR2 Label   ***/

make_label ((char *) &hdr2,sizeof(hdr2),"HDR2");
strnset (hdr2.info.buffer_offset_length,'0',
	sizeof(hdr2.info.buffer_offset_length));

/***   Initialize EOF1, EOF2 Labels   ***/

make_label ((char *) &eof1,sizeof(eof1),"EOF1");
make_label ((char *) &eof2,sizeof(eof2),"EOF2");

/***   Initialize EOV1, EOV2 Labels   ***/

make_label ((char *) &eov1,sizeof(eov1),"EOV1");
make_label ((char *) &eov2,sizeof(eov2),"EOV2");
}

FUNCTION VOID update_labels (volume_ident,where)
char	*volume_ident;			/* volume identifier	*/
int	where;				/* where on tape	*/
{
int		file_sect_no;
char		tmbuf[4];
long		clock;
long		time();
struct tm	*tm;
struct tm	*localtime();

strncpy ((char *)vol1.volume_ident,volume_ident,
	MIN(sizeof(vol1.volume_ident),strlen(volume_ident)));

if (where != EOFF)
    {
    file_sect_no = antoi (hdr1.info.file_sect_no,4) + 1;
    strncod (hdr1.info.file_sect_no,(long)file_sect_no,
	     sizeof(hdr1.info.file_sect_no));
    }
clock = time (0);
tm = localtime(&clock);
sprintf (tmbuf,"%3d",tm->tm_year);
strncpy ((char *)hdr1.info.create_date,(char *)tmbuf,3);
sprintf (tmbuf,"%03d",tm->tm_yday+1);
strncpy ((char *)&hdr1.info.create_date[3],(char *)tmbuf,3);
strncpy ((char *)&eof1.info,(char *)&hdr1.info,sizeof(eof1.info));
strncpy ((char *)&eov1.info,(char *)&hdr1.info,sizeof(eov1.info));
}

FUNCTION VOID load_labels (file_ident,file_sect_no,file_seq_no,rec_format,
			   rec_length,blk_length)
char	*file_ident;			/* file identifier	*/
int	file_sect_no;			/* file section number	*/
int	file_seq_no;			/* file sequence number	*/
char	rec_format;			/* record format	*/
int	rec_length;			/* record length	*/
int	blk_length;			/* block length		*/
{

/***   Load HDR1 label   ***/

strnset (hdr1.info.file_ident,' ',sizeof(hdr1.info.file_ident));
strncpy ((char *)hdr1.info.file_ident,file_ident,
	MIN(sizeof(hdr1.info.file_ident),strlen(file_ident)) );
strncod (hdr1.info.file_sect_no,(long)file_sect_no,
	sizeof(hdr1.info.file_sect_no));
strncod (hdr1.info.file_seq_no,(long)file_seq_no,sizeof(hdr1.info.file_seq_no));
strnupr ((char *)&hdr1,(char *)&hdr1,LABELSZ);

/***   Load HDR2 label   ***/

hdr2.info.rec_format = rec_format;
strncod (hdr2.info.blk_length,(long)blk_length,sizeof(hdr2.info.blk_length));
strncod (hdr2.info.rec_length,(long)rec_length,sizeof(hdr2.info.rec_length));
strnupr ((char *)&hdr2,(char *)&hdr2,LABELSZ);

/***   Load EOF1 and EOV1 Labels   ***/

strncpy ((char *)&eof1.info,(char *)&hdr1.info,sizeof(eof1.info));
strncpy ((char *)&eov1.info,(char *)&hdr1.info,sizeof(eov1.info));

/***   Load EOF2 and EOV2 Labels   ***/

strncpy ((char *)&eof2.info,(char *)&hdr2.info,sizeof(eof2.info));
strncpy ((char *)&eov2.info,(char *)&hdr2.info,sizeof(eov2.info));

return;
}

FUNCTION VOID put_volume (fd)
int	fd;				/* file desc (struct TAPEDESC)	*/
{
float	inches;				/* length of write		*/
int	status;				/* put_label return status	*/

twrit = 0.0;
status = put_label (fd,(char *) &vol1,sizeof(vol1),&inches,0);
if (status == EOT)
    {
    fprintf (stderr,"EOT encountered while writing volume label\n");
    exit (status);
    }
twrit += inches;
return;
}

FUNCTION put_headers (fd)
int	*fd;				/* file desc (struct TAPEDESC)	*/
{
float	inches;				/* length of this write		*/
int	status;				/* put_label return status	*/

status = put_label (*fd,(char *) &hdr1,sizeof(hdr1),&inches,3);
if (status == EOT)
    return (status);
twrit += inches;
status = put_label (*fd,(char *) &hdr2,sizeof(hdr2),&inches,3);
if (status == EOT)
    return (status);
twrit += inches;
if (twrit >= tlen)
    if (splitfile)
	{
	status = reelswitch ("ANSIOUT",fd,0,BOF);
	if (status == EOT)
	    return (EOT);
	}
return (OK);
}

FUNCTION put_eofs (fd,blk_count)
int	fd;				/* file desc (struct TAPEDESC)	*/
int	blk_count;			/* block count			*/
{
float	inches;				/* length of the write		*/
int	status;				/* put_label return status	*/

strncod (eof1.info.blk_count,(long)blk_count,sizeof(eof1.info.blk_count));
status = put_label (fd,(char *) &eof1,sizeof(eof1),&inches,5);
if (status == EOT)
    return (status);
twrit += inches;
status = put_label (fd,(char *) &eof2,sizeof(eof2),&inches,5);
if (status == EOT)
    return (status);
twrit += inches;
return (OK);
}

FUNCTION put_eovs (fd,blk_count)
int	fd;				/* file desc (struct TAPEDESC)	*/
int	blk_count;			/* block count			*/
{
float	inches;				/* length of write		*/
int	status;				/* put_label return status	*/

strncod (eov1.info.blk_count,(long)blk_count,sizeof(eov1.info.blk_count));
status = put_label (fd,(char *) &eov1,sizeof(eov1),&inches,5);
if (status == EOT)
    return (status);
status = put_label (fd,(char *) &eov2,sizeof(eov2),&inches,5);
if (status == EOT)
    return (status);
return (OK);
}

FUNCTION VOID make_label (label,labelsz,label_info)
char	*label;			/* address of desired label	*/
int	labelsz;		/* size of label		*/
char	*label_info;		/* desired label information	*/
{
strnset (label,' ',labelsz);
strncpy (label,label_info,MIN(sizeof(label),strlen(label_info)));
return;
}

FUNCTION BOOL put_label (fd,label,labelsz,inches,bsf_count)
int	fd;			/* file desc (struct TAPEDESC)	*/
char	*label;			/* label address		*/
int	labelsz;		/* size of the label		*/
float	*inches;		/* length of this write		*/
int	bsf_count;		/* back space file count for EOT*/
{
int	status;			/* put_label return status	*/

strnupr    (label,label,LABELSZ);
status = write_tape(fd,(unsigned char*)label,labelsz);
if (status == TAPE_EOT)
    {
    /* fprintf(stderr,"put_label: EOT detected on %4.4s\n",label); */
    bsf_tape(fd,bsf_count);
    return (EOT);
    }
*inches = (float)labelsz/(float)tape_bpi + irgsize;	/* bytes/bpi+irgsz*/
return (OK);
}

/**************************************************************************/
/***   strncod creates a right-justified zero-filled string (the	***/
/***   character representation of integer srce) of size sz in dest.	***/
/***   e.g.:  if dest = "----------", src=123, sz=5,			***/
/***   resulting dest = "00123-----"					***/
/**************************************************************************/

FUNCTION VOID strncod (dest,srce,sz)
register char	*dest;		/* destination pointer	*/
register long	srce;		/* value to encode	*/
register int	sz;		/* number of characters to encode */
{
strnset (dest,'0',sz);
for (dest += sz - 1; sz--; srce /= 10)
	*dest-- = srce % 10 + '0';
return;
}

/**************************************************************************/
/***   strnset fills dest with sz occurrances of the character in src   ***/
/**************************************************************************/

FUNCTION VOID strnset (dest,srce,sz)
register char	*dest;		/* destination pointer */
register char	srce;		/* source data */
register int	sz;		/* number of characters to set */
{
for (; sz--; *dest++ = srce)
	;
return;
}
