#include        "worgen.h"
#include        "tapeio.h"
#include	"ansi.h"

FUNCTION int write_D_tape(prog,tape,disk,reccnt,blkcnt,file,reclen,blklen)
char	*prog;				/* calling program		*/
int	*tape;				/* file desc (struct TAPEDESC)	*/
int	disk;				/* disk file descriptor		*/
int	*reccnt;			/* record count			*/
int	*blkcnt;			/* block count			*/
int	file;				/* current file number		*/
int	reclen;				/* user specified record length	*/
int	blklen;				/* user specified block length	*/	
{
unsigned char	*blk_ptr;		/* block pointer		*/
int		blk_size;		/* size of current block	*/
FILE		*fdisk;			/* stream ptr for disk		*/
char		*record;		/* address of record buffer	*/
int		rec_size;		/* size of current record	*/
int		endtape=ANSI_FALSE;	/* end of tape?  t/f		*/
int		status=OK;		/* return status		*/
float		inches;			/* length of write		*/
char		*malloc(), *strcpy(), *fgets_disk();

if ((fdisk = fdopen(disk,"r")) == NULL)
    {
    perror ("fdopen");
    exit (NOT_OK);
    }
record = malloc((unsigned)(reclen + 1));

*blkcnt = 0;
*reccnt = 0;
for (blk_ptr = buf, blk_size = 0, rec_size = 0;
	fgets_disk (fdisk,record,(int)reclen);
	    blk_ptr += rec_size, blk_size += rec_size, (*reccnt)++)
    {
    if (endtape)
	{
	if (lflag != 0)
	    print_file (*reccnt,*blkcnt);
	status = reelswitch (prog,tape,*blkcnt,DATA);
	if (status == EOT)
	    goto WRAPUP;
	write_eof (*tape);
	endtape = ANSI_FALSE;
	(*blkcnt) = 0;
	(*reccnt) = 0;
	}
    rec_size = strlen (record) - 1 + 4;
    if (rec_size > blklen)
	{
	fprintf (stderr,"(write_D_tape) Record size of %d ",rec_size);
	fprintf (stderr,"exceeds block length of %d\n",blklen);
	exit (NOT_OK);
	}
    if (blk_size + rec_size > blklen)
	{
	(*blkcnt)++;
	status = write_tape (*tape,buf,blk_size);
	if (status == TAPE_EOT)
	    {
	    status = EOT;
	    goto WRAPUP;
	    }
	inches = (float)blk_size/(float)tape_bpi + irgsize;
	twrit += inches;
	if (twrit >= tlen)
	    if (splitfile)
		endtape = ANSI_TRUE;
	blk_ptr = buf;
	blk_size = 0;
	}
    sprintf ((char *)blk_ptr,"%04d",rec_size);
    strcpy  ((char *)blk_ptr + 4,record);
    }					/* end for loop	*/

if (blk_size)
    {
    (*blkcnt)++;
    status = write_tape (*tape,buf,blk_size);
    if (status == TAPE_EOT)
	{
	status = EOT;
	goto WRAPUP;
	}
    inches = (float)blk_size/(float)tape_bpi + irgsize;
    twrit += inches;
    if (twrit >= tlen)
	if (splitfile)
	    endtape = ANSI_TRUE;
    }

if (endtape)
    if (file < nfiles)
	{
	status = reelswitch (prog,tape,*blkcnt,DATA);
	if (status == EOT)
	    goto WRAPUP;
	write_eof (*tape);
	(*blkcnt) = 0;
	(*reccnt) = 0;
	}
WRAPUP:
free (record);
fclose (fdisk);
if (status == EOT)
    bsf_tape (*tape,(labelled ? 1 : 0) + 3);
if (endtape)
    if (lflag != 0)
	print_file (*reccnt,*blkcnt);
return (status);
}

FUNCTION int write_F_tape(prog,tape,disk,reccnt,blkcnt,file,reclen,blklen)
char	*prog;				/* calling program		*/
int	*tape;				/* file desc (struct TAPEDESC)	*/
int	disk;				/* disk file descriptor		*/
int	*reccnt;			/* record count			*/
int	*blkcnt;			/* block count			*/
int	file;				/* current file number		*/
int	reclen;				/* user specified record length	*/
int	blklen;				/* user specified block length	*/
{
int	blk_size;
int	endtape=ANSI_FALSE;		/* end of tape? t/f		*/
float	inches;				/* length of write		*/
int	status=OK;			/* return status		*/
int	ulout=0;			/* program is ulout T/F		*/

if (strcmp(prog,"ULOUT")==0)
    ulout = ANSI_TRUE;

*blkcnt = 0;
*reccnt = 0;
for (  ; (blk_size = read_disk(disk,(char *)buf,(int)blklen));
      (*reccnt) += blk_size / reclen)
    {
    if (endtape)
	{
	if (lflag != 0)
	    print_file (*reccnt,*blkcnt);
	status = reelswitch (prog,tape,*blkcnt,DATA);
	if (status == EOT)
	    {
	    bsf_tape (*tape, (labelled ? 1 : 0) + 3);
	    return (EOT);
	    }
	if (ulout)
	    twrit = 0.0;
	else
	    {
	    write_eof (*tape);
	    (*blkcnt) = 0;
	    (*reccnt) = 0;
	    }
	endtape = ANSI_FALSE;
	}
    if (blk_size % reclen != 0)
	{
	fprintf (stderr,"(write_F_tape) Block size %d ",blk_size);
	fprintf (stderr,"is not a multiple of the record length %d\n",reclen);
	return(NOT_OK); 
	}
    (*blkcnt)++;
    status = write_tape (*tape,buf,blk_size);
    if (status == TAPE_EOT)
	{
	bsf_tape (*tape, (labelled ? 1 : 0) + 3);
	return (EOT);
	}
    inches = (float)blk_size/(float)tape_bpi + irgsize;
    twrit += inches;
    if (twrit >= tlen)
	if (splitfile)
	    endtape = ANSI_TRUE;
    }

if (endtape)
    if (file < nfiles)
	{
	status = reelswitch (prog,tape,*blkcnt,DATA);
	if (status == EOT)
	    {
	    bsf_tape (*tape, (labelled ? 1 : 0) + 3);
	    return (EOT);
	    }
	write_eof (*tape);
	(*blkcnt) = 0;
	(*reccnt) = 0;
	}

return (OK);
}
