#include <ctype.h>
#include "ansi.h"

FUNCTION strupr(dest,srce)	/* upcase string	*/
register char	*dest;		/* destination pointer */
register char	*srce;		/* source pointer */
	{
	for (; *dest = *srce++; dest++)
		*dest = islower(*dest) ? toupper(*dest) : *dest;
	return;
	}


FUNCTION strnupr(dest,srce,sz)	/* upcase string, max sz chars	*/
register char	*dest;		/* destination pointer */
register char	*srce;		/* source pointer */
register int	sz;		/* number of characters to upcase */
	{
	for (; sz-- && (*dest = *srce++); dest++)
		*dest = islower(*dest) ? toupper(*dest) : *dest;
	return;
	}


FUNCTION strlwr(dest,srce)	/* downcase a string	*/
register char	*dest;		/* destination pointer */
register char	*srce;		/* source pointer */
	{
	for (; *dest = *srce++; dest++)
		*dest = isupper(*dest) ? tolower(*dest) : *dest;
	return;
	}


FUNCTION strnlwr(dest,srce,sz)	/* downcase a string, max sz chars	*/
register char	*dest;		/* destination pointer */
register char	*srce;		/* source pointer */
register int	sz;		/* number of characters to lowercase */
	{
	for (; sz-- && (*dest = *srce++); dest++)
		*dest = isupper(*dest) ? tolower(*dest) : *dest;
	return;
	}


FUNCTION char *strtrm(dest,srce)	/* copy srce to dest;		*/
register char	*dest;			/* null-terminate dest when	*/
register char	*srce;			/* first blank is encountered	*/
	{
	char	*orig;

	orig = dest;
	for (; *dest++ = (*srce == ' ' ? '\0' : *srce); srce++)
		;
	return(orig);
	}


FUNCTION char *strntrm(dest,srce,sz)	/* copy srce to dest, max sz chars */
register char	*dest;			/* null-terminate dest when	*/
register char	*srce;			/* first blank is encountered	*/
register int	sz;
	{
	char	*orig;

	orig = dest;
	for (; sz-- && (*dest++ = (*srce == ' ' ? '\0' : *srce)); srce++)
		;
	if (sz == -1)
		*dest = '\0';
	return(orig);
	}

FUNCTION char *memcopy(dst,src,sz)	/* copy sz chars from src to dst */
register char	*dst;	
register char	*src;
register int	sz;
	{
	char	*orig;

	orig = dst;
	for (; sz-- ;src++)
		*dst++ = *src;
	return(orig);
	}


/***  compare the first sz characters of buf to the character c.	***/
/***  return ANSI_TRUE if any differences are found, otherwise return ANSI_FALSE	***/

FUNCTION BOOL bufncmp (buf,c,sz)
unsigned char *buf;			/* buffer to check		  */
char c;					/* character to compare		  */
int  sz;				/* # characters of buf to compare */
{
int j;					/* loop counter			  */

for (j=0; j<sz; j++)
    if (buf[j] != c)
	return (ANSI_TRUE);

return (ANSI_FALSE);
}
