/******************************************************************************
FUNCTION:	BLDALIAS

PURPOSE:	Returns the name of the user's alias file.

PROGRAM HISTORY:

Version    Date     Author           Change Request
-------    -----    -------------    --------------
  1.0      10/86    C. Greenhagen    New Development
  1.1      12/87    B. Ailts         Use raw 'C' types
  5.0      04/88    D. Hollaren      changed include spec to las

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	None.

PROJECT			LAS

ALGORITHM 
Get user default directory and append the ALIAS LIST file.

ALGORITHM REFERENCES	none
*******************************************************************************/

#include <string.h>
#include <stdio.h>
#include <math.h>

#ifdef vms
#include <file.h>
#else
#include <sys/types.h>
#include <sys/file.h>
#endif

#include "las.h"
#include "alias.h"

/**
 * bldalias:
 * @aliasfile: O: name of user's alias file
 *
 * Creates the name of the user's alias file.
 *
 */
void bldalias
(
    char *aliasfile			/* name of user's alias file	*/
)
{
char dir[256];				/* user's default directory	*/

#ifdef vms
int len;				/* string length 		*/
#endif
    
getmydef(dir);				/* build alias file name */

#ifdef vms
    len = strlen (dir);
    strncpy (aliasfile,dir,len-1);
    aliasfile[len-1] = 0;
    strcat  (aliasfile,".CM]ALIAS.LIST");
#else
    strcpy (aliasfile,dir);
    strcat  (aliasfile,"/cm/alias.list");
#endif

}
