#!/usr/local/bin/perl -w
#
# This script is used to verify that a CVS sticky tag is associated with each
# file in the present directory and all subdirectories.

checkout_dir(".");

exit 0;

# checkout_dir verifies that each subdirectory contains a CVS/Tags file.
#    inputs: directory name to check
#    returns: nothing
sub checkout_dir
{
    my $dir = $_[0];

    # Change into the directory.
    chdir $dir || die "Error changing to directory $dir: $!\n";

    # Check for existence of the CVS/Tags file.
    if ((-e "CVS") && (! -e "CVS/Tag"))
    {
        die "No sticky tag for $dir\n";
    }

    # Recursively parse the directories found in this directory to verify
    # a sticky tag is applied in all subdirectories.
    foreach my $recurse_dir (<*>)
    {
        # Recursively process all directories except the CVS directory.
        if ((-d $recurse_dir) && ($recurse_dir !~ /^CVS$/))
        {
            # Recursively check the next directory.
            checkout_dir($recurse_dir);

            # Change back to the current directory.
            chdir ".." || die "Error changing to directory $dir: $!\n";
        }
    }
}

