#include "ditbrowse.h"

extern "C"
{
#include <stdarg.h>
}



Log::Log (void)
{
/*
 * This software is calling the Report() function prior to initializing the
 * log.  Assume some default values for errors that may occur during the tape
 * mounting process.
 */
strcpy(this->logfile, "./ditbrowse.log");
strcpy(this->tapeid, "??????");
strcpy(this->keyroot, "ditbrowse");
}


void Log::InitLog (
    char *dir,		// IN - Directory location for the log file
    char *id,		// IN - ID of the tape being processed
    char *root		// IN - Root for all error keys
    )
{
sprintf(logfile, "%s/%s/ditbrowse.log", dir, id);
strcpy(this->tapeid, id);
strcpy(this->keyroot, root);
}


void Log::Report (
    long flag,		// IN - Fatal error flag
    char *key,		// IN - Message key [keyroot-key]
    char *fmt,		// IN - Format string for the message
    ...			// IN - Variable arguments as needed for fmt
    )
{
va_list ap;

char msg[CMLEN];
char tempkey[CMLEN];

extern class Tape      tape;

/*
 * Extract the variable number of arguments and create the message to be logged
 */
va_start(ap, fmt);
vsprintf(msg, fmt, ap);
va_end(ap);


/*
 * Create the message key
 */
sprintf(tempkey, "%s-%s", keyroot, key);


/*
 * Write the message to the log, close the tape if this is a fatal error, and
 * write the message to the terminal.
 */
c_wrtlog(logfile, tapeid, tempkey, msg);
if (flag)
    tape.close();
c_lasmsg(flag, tempkey, msg);
}
