
/*******************************************************************************
NAME:     lasp.h 
PURPOSE:  prototypes of las support functions.  must be included after las.h

FILE HISTORY
--------------------------------------------------------------------------------
  Date       Programmer                          Changes 
---------  ---------------  ----------------------------------------------------
 Aug 1994  David Zokaites   original development
 Jan 1995  David Zokaites   revised as html files were updated
 Apr 1995  David Zokaites   prototyped some tae supports 
 Jul 1995  David Zokaites   added prototype of c_lasmsg 
*******************************************************************************/






/* prototype tae support functions that I use, ifdef allows for K&R compilers */
   struct VARIABLE *p_find (struct PARBLK *vptr, char name[]); 
   int q_intg (struct PARBLK *vptr, char name[], int count, int intg[], 
       int mode); 
   int q_out (struct PARBLK *vptr); 
   int q_real (struct PARBLK *vptr, char name[], int count, double real[], 
       int mode); 
   int q_string (struct PARBLK *vptr, char name[], int count, char *vector[],
       int mode); 





/* protoytpes of most las support functions which have a html file via makep.csh
   and makep.c;  I deleted prototypes of dltf, georeg, labltabl functions as 
   they require additional include files and I don't use these functions anyway.
   */
   /* alias */
      int c_getalias (char *instring, char *outstring);
   /* ddr */
      void c_calcor (double *sl, double *ss, double *nl, double *ns,
      struct DDR *ddr, double *upleft, double *upright, double *loleft,
      double *loright);
      int c_comsys (char *hname, long *flag);
      int c_getbdf (struct BDDR *bddr, long *key, unsigned char *value);
      int c_getbdr (char *hname, struct BDDR *bddr, long *band);
      int c_getddf (struct DDR *ddr, long *key, unsigned char *value);
      int c_getddr (char *hname, struct DDR *ddr);
      void c_intbdr (struct BDDR *bddr);
      void c_intddr (struct DDR *ddr);
      int c_lused (char *hname);
      int c_minmax (char hname[][CMLEN], long *nimg, long window[][4],
      long bands[][MAXBND + 1], long *nbands, double *minval,
      double *maxval);
      int c_putbdf (struct BDDR *bddr, long *key, unsigned char *value);
      int c_putbdr (char *hname, struct BDDR *bddr);
      int c_putddf (struct DDR *ddr, long *key, unsigned char *value);
      int c_putddr (char *hname, struct DDR *ddr);
      int c_rotcor (double proj_coord[8], long image_coord[8],
      double window[4], double window_proj_coord[8]);
      int c_rtcoef (double proj_coord[8], long image_coord[8],
      double coef[6], long *flag);
      int c_rtiddr (struct DDR *inddr, long *rot);
      int c_svmnmx (char *hname, long *totbnd, double minval[],
      double maxval[], char *m_flag);
      int c_upddr (struct PARBLK *parblk, char host_in[][CMLEN],
      char *host_out, long *nmrimg, long window[][4],
      long bands[][MAXBND +1], long nbands[], double *line_inc,
      double *samp_inc, long *out_nbands, long *cflag);
   /* error */
      void c_errmsg (char *message, char *key, long *vrity);
   /* filenm */
      int c_cmhost (char *lname, char *hname);
      int c_cmtae (char *hname, char *lname);
   /* imageio */
      unsigned char * c_ealloc (int *fdarray, long *buffersz);
      int c_eclose (int *fdesc);
      int c_egclse (int *gdesc);
      int c_egroup (int *fdarray, int *gdesc, unsigned char *buffer,
      long *buffersz);
      int c_eopenr (int *fdesc, char *fname, long *nbands, long *sl,
      long *ss, long *nl, long *ns, long *acc, long *dtype, long opt[],
      long *nline);
      int c_eopens (int *fdesc, char *fname, long bands[], long *sl,
      long *ss, long *nl, long *ns, long offset[], long *acc,
      long *dtype, long *nbuf, long opt[]);
      int c_eread (int *fdesc, long *eband, long *eline,
      unsigned char *euserbuf, long *nl_blk);
      int c_estep (int *gdesc);
      int c_ewrite (int *fdesc, long *eband, long *eline,
      unsigned char *euserbuf, long *nl_blk);
      int get_buf (unsigned char *buffer, long *nlbuf, long *nsbuf,
      long *nlav, long *nsav, long *sli, long *ssi, long *nli,
      long *nsi, long *nlb, long *nsb, long *slcb, long *sscb,
      long *nextflg, long *band, long *fill, int *fdesc, char *host,
      long *dtype);
      int put_buf (unsigned char *buffer, long *nlbuf, long *nsbuf,
      long *nlav, long *nsav, long *slbuf, long *ssbuf, long *nlti,
      long *nsti, long *nextflg, long *band, long *bands, int *fdesc,
      char *host, long *dtype, long *wtype);
      void qrdecomp (double *matrix, long n_row, long n_col, double *work,
      long flag);
      void qrsolve (double *matrix, long n_row, long n_col, double *work,
      double *result, long flag);
   /* lablserv */
      int c_lsclos (long *fd, char *hostname, long *action);
      int c_lsdel (long *fd, char *key);
      void c_lsmknm (char *inname, char *ext, char *outname);
      int c_lsopen (long *fd, char *hostname, long *access);
      int c_lread_bil (long *fd, char *key, long *clen, long *dlen, char *cbuf,
      unsigned char *dbuf, char *dtype);
      int c_lsrepl (long *fd, char *key, long *clen, long *dlen, char *cbuf,
      unsigned char *dbuf, char *dtype);
      int c_lsrew (long *fd);
      int c_lsstat (char *hostname, long *mode);
      int c_lswrit (long *fd, char *key, long *clen, long *dlen, char *cbuf,
      unsigned char *dbuf, char *dtype);
   /* math */
      void c_qrdecomp (double *matrix, long n_row, long n_col, double *work,
      long flag);
      void c_qrsolve (double *matrix, long n_row, long n_col, double *work,
      double *result, long flag);
      double c_c_randnm (long *seed);
   /* pixman */
      int c_pxadd (long *ns, unsigned char *in1, unsigned char *in2,
      unsigned char *out, float *scale1, float *scale2, float *offset,
      long *dtype);
      int c_pxbtan (unsigned char *in, unsigned char *map,
      unsigned char *out, long *ns, long *dtype);
      int c_pxbtor (unsigned char *in, unsigned char *map,
      unsigned char *out, long *ns, long *dtype);
      int c_pxbxor (unsigned char *in, unsigned char *map,
      unsigned char *out, long *ns, long *dtype);
      int c_pxcomp (long *in, long *out, long *ns, long *dtype);
      int c_pxconv (long *ftyp, long *totyp, unsigned char *frombuf,
      unsigned char *tobuf, long *size);
      void c_pxcopy (unsigned char *frombuf, unsigned char *tobuf,
      long *dtype, long *ns);
      int c_pxdiv (long *ns, unsigned char *in1, unsigned char *in2,
      unsigned char *out, float *scale, float *offset, long *dtype,
      long *errval);
      int c_pxe10 (long *in, double *out, long *ns, long *dtype);
      int c_pxe255 (unsigned char *in, double *out, long *ns, long *dtype);
      int c_pxe32k (short *in, double *out, long *ns, long *dtype);
      void c_pxfill (unsigned char *tobuf, long *dtype, long *ns,
      unsigned char *fillval);
      int c_pxhiss (long *ns, unsigned char *buf, long *dtype, long *hist,
      long *count, long *skip);
      int c_pxhist (long *ns, unsigned char *buf, long *dtype, long *hist,
      long *count);
      int c_pxindr (long *in, long *val, long *ns, long *index, long *dtype);
      int c_pxinx (long *in, long *val, long *ns, long *index, long *dtype);
      int c_pxinxd (long *in, long *val, long *ns, long *index, long *dtype);
      int c_pxinxr (long *in, long *val, long *ns, long *index, long *dtype);
      int c_pxl10 (long *in, double *out, long *ns, long *dtype);
      int c_pxl255 (unsigned char *in, double *out, long *ns, long *dtype);
      int c_pxland (long *in, long *out, long *map, long *ns, long *dtype);
      int c_pxline (long *in, long *out, long *ns, long *dtype,
      float *scale, float *offset);
      int c_pxlkup (long *in, long *out, long *ns, long *dtype, long *lut,
      long *luttype);
      int c_pxlor (long *in, long *out, long *map, long *ns, long *dtype);
      int c_pxlxor (long *in, long *out, long *map, long *ns, long *dtype);
      int c_pxmax (unsigned char *in, unsigned char *map,
      unsigned char *out, long *ns, long *dtype);
      int c_pxmin (unsigned char *in, unsigned char *map,
      unsigned char *out, long *ns, long *dtype);
      int c_pxmnmx (unsigned char *in, long *ns, double *min, double *max,
      long *dtype);
      int c_pxmul (long *ns, unsigned char *in1, unsigned char *in2,
      unsigned char *out, float *scale, float *offset, long *dtype);
      void c_pxsamp (long *ns, long *dtype, long *inc, unsigned char *buf);
      int c_pxsub (long *ns, unsigned char *in1, unsigned char *in2,
      unsigned char *out, float *scale1, float *scale2, float *offset,
      long *dtype);
      int c_pxswap (unsigned char *buf, long *nentity, long *size);
      int c_pxsys (long *insys, long *outsys, unsigned char *buf,
      long *dtype, long *size, unsigned char *under,
      unsigned char *over, long *flag);
   /* statio */
      int c_stclse (long *fd);
      int c_stdldt (long *fd, char *data_type, long *ic, long *is);
      int c_stdlnd (long *fd, long *ic, long *is);
      int c_stfdcl (long *fd, char *class_name, long *ic);
      int c_stfdsi (long *fd, char *class_name, char *site_name,
      long *ic, long *is);
      int c_stget (long *fd, char *data_type, long *ic, long *is,
      long shape[9], unsigned char *buf);
      int c_stnode (long *fd, char *data_type, long shape[9], long *ic,
      long *is, long *id);
      int c_stopen (long *fd, char *hos, long *access, long *nclass);
      long c_stput (long *fd, char *data_type, long *ic, long *is,
      long shape[9], unsigned char *buf);
   /* tapeio */
      int c_tpbsf (long *unit, long *count, long *mode);
      int c_tpbsr (long *unit, long *count, long *mode);
      int c_tpclos (long *unit, long *mode, long *rewopt, long *eofopt);
      int c_tpfsf (long *unit, long *count, long *mode);
      int c_tpfsr (long *unit, long *count, long *mode);
      int c_tplblpr (char *printer);
      int c_tplsrd (long *unit, char *key, long *clen, long *dlen,
      char *cbuf, unsigned char *dbuf, char *dtype);
      int c_tplswr (long *unit, char *key, long *clen, long *dlen,
      char *cbuf, unsigned char *dbuf, char *dtype);
      int c_tpopen (long *unit, long *skip, long *mode, long *opt1,
      char *dens, long *inout, char *message, char *tapeid);
      int c_tpread (long *unit, unsigned char *buffer, long *bufsz,
      long *mode);
      int c_tpreop (long *unit, long *skip, long *mode, long *opt1,
      char *dens, long *inout, char *drivename);
      int c_tprew (long *unit, long *mode, long *opt1);
      int c_tpweof (long *unit, long *count, long *mode);
      int c_tpwrit (long *unit, unsigned char *buffer, long *bufsz,
      long *mode);
   /* unixdisk */
      int c_dkcopy (char *from, char *to, char directories[][CMLEN]);
      extern long c_dkcre (char directories[][CMLEN], char *filename, 
      long filesize, int wait);
      extern long c_dkdel (char *filename);
      int c_dkfree (char *path);
      int c_dkmove (char *from, char *to, char directories[][CMLEN]);
      int c_dkrspac (char *path);
   /* utility */
      void c_asc2eb (char *buf, long *nbytes);
      int c_bitand (int *in1, int *in2);
      int c_bitor (int *in1, int *in2);
      int c_bitxor (int *in1, int *in2);
      void c_clean (struct PARBLK *vblock, char *name, char hout[][CMLEN],
       long *count);
      void c_complt (char *name, char out [][CMLEN], long *count);
      void c_delfil (char *hname);
      void c_eb2asc (char *buf, long *nbytes);
      int c_getcnt (struct PARBLK *block, char *param, long *count);
      int c_getin (struct PARBLK *block, char *param, long *element,
      char tnames[][CMLEN], char hnames[][CMLEN], long *nmrimg,
      long (*window)[4], long (*bands)[MAXBND+1], long *nbands,
      long *totbnd, long *imglimit, long *same_window, long (*qflag)[2]);
      int c_getnam (struct PARBLK *block, char *param, long *element,
      char *hname, char *ext, long *access);
      int c_getout (struct PARBLK *block, char *param, char *tname,
      char *hname);
      int c_getsys (char *cursys);
      int c_gettyp (char hname[][CMLEN], long *nmrimg, long *dtype);
      int c_hstout (struct PARBLK *vblock, char *hosout,
      char hosin[][CMLEN], long *numin, char *text);
      void c_index (char *string1, char *string2, long *pos);
      void c_inittm (char *subject, char *verb, char *entity,
       char *category, char *text, long *max_entity, long *max_category,
       long *msgtim, long *flag);
      void c_inlas (struct PARBLK *vblock, long *stdlun);
      int c_inmnmx (long *dtype, long *totbnd, double *minval,
      double *maxval);
      void c_low2up (char *buf, long *nbytes);
      int c_mkimg (char *inname, char *append, char *tname, char *hname,
      long *flag);
      int c_mknam (char *filename, char *hname, char *ext, long *access);
      void c_pterm (char *buf, long *flag);
      double c_randnm (long *seed);
      int c_setprt (struct PARBLK *vblock, long *term, long *file, long lp,
      char *prtfile, char *filename);
      char squeeze (char *buf, long length);
      void c_startm (void);
      void c_stoptm (void);
      int c_sysset (char *csys, long *nsys, long *sysflg);
      void c_up2low (char *buf, long *nbytes);
   /* utility with variable arguments.  change the following prototype to */
   /* void c_lasmsg (...);  if this file is included in c_lasmsg.c        */ 
      void c_lasmsg (long abortflag, char *messagekey, char *format, ...);

    int c_wrtlog(char *logfile, char *key, char *code, char *text);
