#!/bin/csh

foreach sat (noaa11 noaa12 noaa14)
    mkdir $sat
    chgrp avhrr $sat
    chmod 775 $sat
    chmod g+s $sat

    if ($sat == "noaa11") then
	set years = (year1988 year1989 year1990 year1991 year1992 year1993 \
	    year1994)
    else if ($sat == "noaa12") then
	set years = (year1991 year1992 year1993 year1994 year1995 year1996)
    else if ($sat == "noaa14") then
	set years = (year1995 year1996)
    else
	echo "unknown satellite"
	exit 1
    endif

    foreach year ($years)
	mkdir $sat/$year
	chgrp avhrr $sat/$year
	chmod 775 $sat/$year
	chmod g+s $sat/$year

	foreach month (month01 month02 month03 month04 month05 month06 month07 month08 month09 month10 month11 month12)
	    echo "$sat"
	    echo "    $year"
	    echo "        $month"
	    mkdir $sat/$year/$month
	    chgrp avhrr $sat/$year/$month
	    chmod 775 $sat/$year/$month
	    chmod g+s $sat/$year/$month

	    switch ($month)
		case month01:
		case month03:
		case month05:
		case month07:
		case month08:
		case month10:
		case month12:
		    set max = 31
		    breaksw
		
		case month02:
		    switch ($year)
			case year1988:
			case year1992:
			case year1996:
			case year2000:
			    set max = 29
			    breaksw

			default:
			    set max = 28
			breaksw
		    endsw
		    breaksw
		
		default:
		    set max = 30
		    breaksw
	    endsw

	    set day = 0
	    while ($day < $max)
		@ day += 1
		if ($day < 10) then
		    set d = "day0$day"
		else
		    set d = "day$day"
		endif

		echo "            $d"
		mkdir $sat/$year/$month/$d
		chgrp avhrr $sat/$year/$month/$d
		chmod 775 $sat/$year/$month/$d
		chmod g+s $sat/$year/$month/$d
	    end
	end
    end
end
