#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#if defined(sgi) || defined(DGUX)
#include        <sys/statfs.h>
#else
#include        <sys/vfs.h>
#endif
#include "las.h"

FUNCTION dirspace(dstdir)

char 	*dstdir;		/* destination dir to search for space  */

{
#ifdef sun
struct statvfs   statfsp;        /* file system statistics       	*/
#else
struct statfs   statfsp;        /* file system statistics       	*/
#endif
struct stat     statp;        	/* file statistics       		*/

double 	num_free;		/* number of free bytes			*/
double  dbltmp1,dbltmp2;


double	reserved;		/* number of reserved bytes		*/
long	len;			/* length of directory name		*/

char buf[80];

long one = 1;
double c_dkrspac();
double space;
/*
  Get host directory name
*/
len = strlen(dstdir);
if (dstdir[len-1] == '/')
    dstdir[len-1] = '\0';

/*
  Try to access the directory   
*/
if (stat(dstdir,&statp) == -1)
    return(E_FAIL);

/*
  Check if it really is a directory
*/
if (!(statp.st_mode & S_IFDIR))
    return(E_FAIL);

/*
  Get the file status information to determine the space avaliable	
*/
#if defined(sgi) || defined(DGUX)
    if (statfs(dstdir,&statfsp,sizeof(struct statfs),0) == -1)
#else
#ifdef sun
    if (statvfs(dstdir,&statfsp) == -1)
#else
    if (statfs(dstdir,&statfsp) == -1)
#endif
#endif
    return(E_FAIL);

/*
  Calculate the amount of available space				
*/
#ifdef sgi
        dbltmp1 = (double)(statfsp.f_bfree);
        dbltmp2 = (double)(statfsp.f_bsize);
        num_free = dbltmp1 * dbltmp2;
#else
       num_free = (double) statfsp.f_bavail * statfsp.f_bsize;
#endif

/*
  Subtract the amount of space that is software reserved		
*/
if ((reserved = c_dkrspac(dstdir)) == E_FAIL)
    return(E_FAIL);

space = num_free - reserved;

sprintf(buf,"Reserved LAS routines: %f\n",reserved);
c_errmsg(buf,"informational",&one);

sprintf(buf,"Available disk space: %f\n",space);
c_errmsg(buf,"informational",&one);

return(E_SUCC);
}
