#!/bin/csh -f
#test host2las and las2host 

#set path to include source code directory 
   set path = (.. $path) 

/bin/echo '\n*** 2 errors as there are no input names ***'
   host2las
   /bin/echo 
   las2host

/bin/echo '\n*** ~ is input ***'
   host2las ~
   las2host ~

/bin/echo '\n*** quoted ~ is input ***'
   host2las '~'
   las2host '~'

/bin/echo '\n*** inputs are a b.c d;e f_g ***'
   set verbose
   host2las    a b.c 'd;e' f_g
   las2host -1 a b.c 'd;e' f_g
   unset verbose 

/bin/echo '\n*** current dir is input ***'
   set noglob #prevent problems with [] and file name expansion 
   host2las $cwd
   set lasname = `host2las $cwd`
   las2host $lasname 
   unset noglob 

/bin/echo '\n*** bad input names ***'
   set verbose 
   host2las ' [ / '
   las2host ' [ / '
   unset verbose

/bin/echo '\n*** four reasonable input names with -1 flag ***'
   set verbose 
   host2las -1 .   file.name   ~/good.name   another.goody 
   las2host -1 '[zokaites.lasrun]'   '[.las]ok;ext'   another.good   last.one
   unset verbose 

/bin/echo '\n*** check status codes, 3 error codes first, then 3 ok codes ***'
   host2las           >& /dev/null;  echo $status 
   host2las ~nouser   >& /dev/null;  echo $status 
   las2host           >& /dev/null;  echo $status 
   host2las ~zokaites >& /dev/null;  echo $status 
   host2las a b c     >& /dev/null;  echo $status 
   las2host a b c     >& /dev/null;  echo $status 
