#include "lfind.h"



/*******************************************************************************
FUNCITON: cmd_usage

PURPOSE:  Print the usage message and error out.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          03/93  Development

PROJECT:  ADAPS
*******************************************************************************/
static int cmd_usage ()
{
printf("usage: lfind cmd <command>\n");
exit(1);
}




/*******************************************************************************
FUNCITON: cmd

PURPOSE:  Search the user's path looking for the specified command.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          03/93  Development

PROJECT:  ADAPS
*******************************************************************************/
int cmd (argc, argv)
    int argc;
    char *argv[];
{
char dir[1000];		/* Directory within the user's path                   */
char command[1000];	/* User specified command                             */

int status;
int notfound = TRUE;
int i;

FILE *fp;


/* Check the arguments
----------------------*/
if (argc < 1)
    cmd_usage();


/* Check for each command
-------------------------*/
for (i = 0; i < argc; i++)
    {
    /* Open a pipe to get the user's path
    -------------------------------------*/
    fp = popen("/bin/echo $PATH | tr ':' ' ' ", "r");
    if (fp == NULL)
	{
	printf("error opening pipe\n");
	exit(1);
	}


    /* For each directory in the user's path check for the specified command
    ------------------------------------------------------------------------*/
    while (fscanf(fp, "%s", dir) == 1)
	{
	sprintf(command, "%s/%s", dir, argv[i]);


	/* Commands must have exist and have execute permission
	-------------------------------------------------------*/
	if ((access(command, EXISTS) == 0) && (access(command, EXECUTE) == 0))
	    {
	    printf("%s\n", command);
	    notfound = FALSE;
	    }
	}


    /* Close the pipe and return
    ----------------------------*/
    pclose(fp);
    wait(status);
    }


/*
  If any of the commands were found exit with a good status
*/
exit(notfound);
}
