#include "lfind.h"
#define MAXDIRS 3



/*******************************************************************************
FUNCITON: inc_usage

PURPOSE:  Print the usage message and error out.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          03/93  Development

PROJECT:  ADAPS
*******************************************************************************/
static int inc_usage (dirs)
    char dirs[MAXDIRS][256];
{
int i;			/* Loop control                                       */
printf("usage: lfind inc <file>\n");
printf("\n");
printf("       Search for the specified file in the following directories.\n");
printf("       The .h extension may be omitted.\n");
printf("\n");
for (i = 0; i < MAXDIRS; i++)
    printf("           %s\n", dirs[i]);
exit(1);
}




/*******************************************************************************
FUNCITON: inc

PURPOSE:  Search the user's path looking for the specified command.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          03/93  Development

PROJECT:  ADAPS
*******************************************************************************/
int inc (argc, argv)
    int argc;
    char *argv[];
{
char dirs[MAXDIRS][256];	/* Directories to search through              */
char path[256];			/* File path                                  */
char *ptr;			/* Ptr to a character string                  */

int i;				/* Loop control                               */


/* Get each of the possible directories
---------------------------------------*/
ptr = getenv("ADAPSINCLUDE");
if (ptr == NULL)
    {
    printf("Error retrieving ADAPSINCLUDE\n");
    exit(1);
    }
strcpy(dirs[0], ptr);

ptr = getenv("LASINCLUDE");
if (ptr == NULL)
    {
    printf("Error retrieving LASINCLUDE\n");
    exit(1);
    }
strcpy(dirs[1], ptr);

ptr = getenv("NETINCLUDE");
if (ptr == NULL)
    {
    printf("Error retrieving NETINCLUDE\n");
    exit(1);
    }
strcpy(dirs[2], ptr);


/* Check the arguments
----------------------*/
if (argc != 1)
    inc_usage(dirs);


/* For each of the include directories, check for the specified include file
----------------------------------------------------------------------------*/
for (i = 0; i < MAXDIRS; i++)
    {
    sprintf(path, "%s/%s", dirs[i], argv[0]);
    if (access(path, EXISTS) == 0)
	printf("%s\n", dirs[i]);

    sprintf(path, "%s/%s.h", dirs[i], argv[0]);
    if (access(path, EXISTS) == 0)
	printf("%s\n", dirs[i]);
    }

return(0);
}
