#include "lfind.h"


/*******************************************************************************
FUNCITON: usage

PURPOSE:  Print the usage message and error out.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          03/93  Development
  1.1    D.Etrheim        05/97  Released to $LASTOOLS

PROJECT:  ADAPS
*******************************************************************************/
static int usage ()
{
printf("usage: lfind <option>\n");
printf("\n");
printf("       cmd  = Find an executable command in $PATH\n");
printf("       inc  = Find an include file\n");
printf("       pdf  = Find a pdf file\n");
printf("       sup  = Find a support function\n");
exit(1);
}



/*******************************************************************************
FUNCITON: lfind

PURPOSE:  Find different programs, include files, etc.

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          10/93  Development

PROJECT:  ADAPS
*******************************************************************************/
main(argc, argv)
   int  argc;
   char *argv[];
{

/* Check the arguments
----------------------*/
if (argc < 2)
    usage();


/* Call the appropriate function to process the specified command
-----------------------------------------------------------------*/
if (strcmp(argv[1], "cmd") == 0)
    cmd(argc-2, &argv[2]);
else if (strcmp(argv[1], "inc") == 0)
    inc(argc-2, &argv[2]);
else if (strcmp(argv[1], "pdf") == 0)
    pdf(argc-2, &argv[2]);
else if (strcmp(argv[1], "sup") == 0)
    exit(sup(argc-2, &argv[2]));
else
    usage();

exit(0);
}
