/* $Author: fenno $ */
/* $Date: 1994/12/23 15:19:47 $ */
/* $Revision: 1.2 $ */

/* $Log: newlines.c,v $
/* Revision 1.2  1994/12/23 15:19:47  fenno
/* Added RCS keywords to the source code file.
/*
*/

#include <stdio.h>

#define TMPFILE "_tmp_newlines_file_"


int usage()
{
printf("\n");
printf("usage: newlines [<nth>] <file> [<file>]\n");
printf("\n");
printf("       Newlines will add a newline character after every <nth>\n");
printf("       characters in the specified files.  <nth> must be a dash\n");
printf("       followed by some positive number (-10, -80, etc.).  The\n");
printf("       default is -80.\n");
printf("\n");
exit(1);
}


main (argc, argv)
   int argc;
   char *argv[];
{
FILE *infile;
FILE *outfile;

char str[256];

long argument =  1;
long chars    = 80;
long i;
long j;
int  ch;


if ((argc < 2) || ((argv[1][0] == '-') && (argc < 3)))
   usage();


if (argv[1][0] == '-')
   {
   if (sscanf(argv[1], "-%d", &chars) != 1)
      usage();
   argument = 2;
   }


for (i = argument; i < argc; i++)
   {
   /* Rename the input file to the temporary name
   ----------------------------------------------*/
   if (rename(argv[i], TMPFILE))
      {
      printf("Error renaming %s\n", argv[i]);
      exit(1);
      }

   /* Open the temporary file for reading
   --------------------------------------*/
   infile = fopen(TMPFILE, "r");
   if (infile == NULL)
      {
      rename(TMPFILE, argv[i]);
      printf("Error opening %s\n", argv[i]);
      exit(1);
      }

   /* Open the output file for writing
   -----------------------------------*/
   outfile = fopen(argv[i], "w");
   if (outfile == NULL)
      {
      rename(TMPFILE, argv[i]);
      printf("Error opening %s\n", str);
      exit(1);
      }

   /* Add newline characters after every 80th character
   ----------------------------------------------------*/
   j = 0;
   while ((ch = fgetc(infile)) != EOF)
      {
      j++;
      if (j > chars)
	 {
	 fprintf(outfile, "\n%c", ch);
	 j = 1;
	 }
      else
	 fprintf(outfile, "%c", ch);
      }
   fprintf(outfile, "\n");

   /* Close both files
   -------------------*/
   fclose(infile);
   fclose(outfile);
   remove(TMPFILE);
   }

exit(0);
}
