#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "las.h"
#include "util.h"
#include "pdfhtml.h"
#include "local_protos.h"

long nxt_rec
(
FILE    *ifp,                   /* Input file pointer  (to PDF)              */
char    *string,                /* Return the read string                    */
char    *key                    /* Key portion of the string                 */
)
{
long    status = E_READ,        /* Status of the read                        */
        len;                    /* Length of the string                      */

char    *ptr1,                  /* Pointer to the plus or minus in the string*/
        *ptr2;

long    i,
        new_line;

/*
  Process the lines
*/
while (status == E_READ)
    {
    /*
      Read a line from the file
    */
    if (fgets(string,82,ifp) == NULL)
        {
        status = E_EOF;
        continue;
        }

    /*
      Extract the key word
    */
    if (sscanf(string,"%s",key) == EOF)
        strcpy(key,"");

    /*
      Upper case the key
    */
    len = (long)strlen(key);
    c_low2up(key,&len);

    /*
      If PARM line has more than 80 characters make the user
      reformat the line.
    */
    if (( strncmp(key, "PARM", 4) == 0 ) && strlen(string) == 81 )
        if ( !strchr( string, '\n' ))
            {
            printf( "ERROR -- Line length greater than 80\n" );
            printf( "Reformat line: %s\n", string );
            status = E_FAIL;
            break;
            }

    /*
      Process some of the keys that can occur anywhere in the document
    */
    if ((strncmp(key,".PAGE",5) == 0) ||
        (strncmp(key,"!.PAGE",6) == 0) ||
        (strncmp(key,"!.BLANK",7) == 0) ||
        (strncmp(key,"!.PAGESUB",9) == 0) ||
        (strncmp(key,"!.DYNAMIC",9) == 0))
        {
        /*
          Ignore these keys
        */
        continue;
        }
    else if (strncmp(key,"!.GOBBLE",8) == 0)
        {
        /*
          Read the next line and ignore it
        */
        if ((fgets(string,82,ifp)) == NULL)
            {
            printf("Premature End Of File encountered\n");
            status = E_EOF;
            }
        }
    else
        {
        /*
          Check for a continuation mark (plus or minus) for the line
        */
        while (((ptr1 = strrchr(string,'+')) || (ptr1 = strrchr(string,'-'))) &&
                (status != E_EOF))
            {
            /*
              Replace the plus with a space
            */
            if (strlen(ptr1) <= 3)
                {
                if (*ptr1 == '+')
                    {
                    *ptr1 = '\n';
                    ptr1++;

                    /*
                      Read the next line from the file
                    */
                    if (fgets(ptr1,82,ifp) == NULL)
                        status = E_EOF;
                    }
                else
                    {
                    ptr2 = ptr1;
                    ptr2--;
                    if (*ptr2 == '-')
                        break;
                    else
                        ptr2++;

                    /*
                      Read the next line from the file
                    */
                    if (fgets(ptr1,82,ifp) == NULL)
                        status = E_EOF;

                    while (isspace((int)*ptr2))
                        ptr2++;

                    if (ptr2 != ptr1)
                        {
                        new_line = TRUE;
                        len = (long)strlen(ptr2);
                        for (i = 0; i < len; i++)
                            {
                            if (isspace((int)*ptr2) && new_line)
                                {
                                *ptr1 = '\n';
                                new_line = FALSE;
                                }
                            else
                                *ptr1 = *ptr2;

                            ptr1++;
                            ptr2++;
                            }

                        *ptr1 = '\0';
                        ptr1++;
                        }
                    }
                }
            else
                break;
            }

        /*
          If not at the end of file set the status to success
        */
        if (status != E_EOF)
            status = E_SUCC;
        }
    }

return(status);
}
