#include <stdio.h>
#include <string.h>
#include "stdlib.h"
#include "las.h"
#include "pdfhtml.h"
#include "local_protos.h"

#define FALSE   0
#define TRUE    1

int main
(
    int argc,
    char **argv
)
{
FILE    *ifp;
FILE    *ofp;

char    ifile[256];
char    ofile[256];

if (argc != 2)
    {
    printf("USAGE: pdfhtml [file]\n");
    exit(-1);
    }

/*
  Create the input file name
*/
strcpy(ifile,argv[1]);
strcat(ifile,".pdf");

/*
  Create the output file name
*/
strcpy(ofile,argv[1]);
strcat(ofile,".html");
    
/*
  Open the input file for read
*/
ifp = fopen(ifile,"r");
if (ifp == NULL)
    {
    printf("Error opening the input file\n");
    exit(-1);
    }

/*
  Open the output file
*/
ofp = fopen(ofile,"w");
if (ofp == NULL)
    {
    printf("Error opening the output file\n");
    exit(-1);
    }

/*
   The first pass extracts the function name, help, and paramters
   The if statement was added to prevent pass_two from repeating
   error messages found in pass_one
*/
if ( pass_one(ifp,ofp) != E_SUCC )
    exit(-1);

/*
  Rewind the input file pointer for the next pass
*/
rewind(ifp);

/*
  The second pass extracts the examples, error messages, and user notes
*/
pass_two(ifp,ofp);

/*
  Close the input and output files
*/
fclose(ifp);
fclose(ofp);
return(EXIT_SUCCESS);
}
