#include <stdio.h>
#include <string.h>
#include "pdfhtml.h"
#include "local_protos.h"

void special
(
    char *istr,          /* Input string to check for special characters */
    char *ostr          /* Key portion of the string                    */
)
{
char    *iptr;          /* Pointer to the input string                  */
char    *optr;          /* Pointer to the output temp string            */

long    i;              /* Looping variable                             */

/*
  Check the input string to determine if it contains any of the
  special charcters that have to be replaced by an escape mechanism
*/
if ((strchr(istr,'<') == NULL) && (strchr(istr,'>') == NULL) &&
    (strchr(istr,'&') == NULL))
    {
    /*
      No special characters - Write the string to the HTML file
    */
    strcpy(ostr,istr);
    }
else
    {
    /*
      Found at least one special character - Set up pointer to copy
      the input string to the output string and replace the special
      characters with the escape sequences
    */
    iptr = istr;
    optr = ostr;
 
    for (i = 0; i < strlen(istr); i++)
        {
        if (*iptr =='<')
            {
            /*
              Replace the less than sign with "&lt" escape sequence
            */
            *optr = '&';
            optr++;
            *optr = 'l';
            optr++;
            *optr = 't';
            optr++;
            *optr = ';';
            optr++;
            iptr++;
            }
        else if (*iptr =='>')
            {
            /*
              Replace the greater than sign with "&gt" escape sequence
            */
            *optr = '&';
            optr++;
            *optr = 'g';
            optr++;
            *optr = 't';
            optr++;
            *optr = ';';
            optr++;
            iptr++;
            }
        else if (*iptr =='&')
            {
            /*
              Replace the amper sign with "&amp" escape sequence
            */
            *optr = '&';
            optr++;
            *optr = 'a';
            optr++;
            *optr = 'm';
            optr++;
            *optr = 'p';
            optr++;
            *optr = ';';
            optr++;
            iptr++;
            }
        else
            {
            /*
              Not a special character - copy as is to the out temp string
            */
            *optr = *iptr;
            optr++;
            iptr++;
            }
        }

    *optr ='\0';
    }

return;
}
