#include <stdio.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "pdfhtml.h"
#include "local_protos.h"

long wrt_list
(
FILE    *ifp,                   /* Input file pointer  (to PDF)              */
FILE    *ofp,                   /* Output file pointer  (to HTML)            */
char    *string,                /* Input string to write                     */
char    *key                    /* Key portion of the string                 */
)
{
char    temp[STR_SIZ];          /* Special character replacement string      */

long    len,
        status = E_SUCC,
        endlist = FALSE;

/*
  Start of the list area
*/
fputs("<P>\n<PRE>\n",ofp);

while ((!endlist) && (status == E_SUCC))
    {
    /*
      Read a line from the file
    */
    if (fgets(string,82,ifp) == NULL)
        {
        status = E_EOF;
        continue;
        }

    /*
      Extract the key word
    */
    if (sscanf(string,"%s",key) == EOF)
        strcpy(key,"");

    /*
      Upper case the key
    */
    len = (long)strlen(key);
    c_low2up(key,&len);

    /*
      Process some of the keys that can occur anyware in the document
    */
    if ((strncmp(key,".PAGE",5) == 0) || (strncmp(key,"!.PAGE",6) == 0) ||
        (strncmp(key,"!.BLANK",7) == 0) || (strncmp(key,"!.PAGESUB",9) == 0))
        {
        /*
          Ignore these keys
        */
        }
    else if (strncmp(key,"!.GOBBLE",8) == 0)
        {
        /*
          Read the next line and ignore it
        */
        if ((fgets(string,82,ifp)) == NULL)
            {
            printf("Premature End Of File encountered\n");
            status = E_EOF;
            }
        }
    else if (strncmp(key,"!.FIG",5) == 0)
        {
        status = wrt_fig(ifp,ofp,string,key);
        if (status != E_SUCC)
            break;
        }
    else if ((strncmp(key,"!.LEND",6) == 0) ||
             (strncmp(key,"!.KENDLIST",10) == 0) ||
             (strncmp(key,"!.KENDTEXT",10) == 0))
        {
        fputs("</PRE>\n",ofp);
        endlist = TRUE;
        }
    else
        {
        /*
          Replace any special HTML characters before writing to the HTML file
        */
        special(string,temp);

        /*
          Write the temp string to the HTML file
        */
        fputs(temp,ofp);
        }
    }

return(status);
}
