#include <stdio.h>
#include <string.h>
#include "pdfhtml.h"
#include "local_protos.h"

void wrt_rec
(
    FILE *ofp,                  /* Output file pointer  (to HTML)            */
    char *string,               /* Input string to write                     */
    char *key                   /* Key portion of the string                 */
)
{
char    temp[STR_SIZ];          /* Special character replacement string      */

/*
  Process some of the keys that can occur anywhere in the document
*/
if ((strncmp(key,".PAGE",5) == 0) || (strncmp(key,"!.PAGE",6) == 0) ||
    (strncmp(key,"!.BLANK",7) == 0) || (strncmp(key,"!.PAGESUB",9) == 0))
    {
    /*
      Ignore these keys
    */
    }
else if ((strncmp(key,"!.LINE",6) == 0) || (strcmp(string,"\n") == 0))
    {
    fputs("<P>\n",ofp);
    }
else if ((strncmp(key,"!",1) == 0))
    {
    /*
      If the first charcter is "!", it is assumed to be the begining of
      a TAE comment.  Ignore the TAE comment.
    */
    }
else
    {
    /*
      Replace any special HTML characters before writing to the HTML file
    */
    special(string,temp);

    /*
      Write the temp string to the HTML file
    */
    fputs(temp,ofp);
    }

return;
}
