#!/bin/csh -f
#
# FUNCTION:     postcommit.csh
#
# PURPOSE:      Execute the desired commands after a module is committed to the
#		CVS repository.  CVS will execute the command from within the
#		working directory and passes the repository location as the
#		only argument.  This function is normally executed by specifying
#		it with the -i option in the "CVSROOT/modules" file.
#
#
# Programmer       Date   Modifications
# ---------------  -----  ------------------------------------------------------
# J.Fenno          05/94  Development
# D.Zokaites       12/96  Selected owner/group based on location in repository


#-----------------
# Set up the shell
#-----------------
onintr ABORT


#------------------------------------------------------------
# Set the owner and group based on location in the repository
#------------------------------------------------------------
set dirname=`echo $1 | awk -F/ '{print $6}'`
echo $dirname
if ($dirname == "ddp") then
   set owner="ddps"
   set group="ddp"
else
   set owner="release"
   set group="software"
endif


#----------------------------------------------------------------
# Change group/owner of all files to release/software or ddps/ddp
#----------------------------------------------------------------
$EDCSOFT/run/bin/chowner.csh $owner $group $1 


#------------------
# Exit successfully
#------------------
exit 0





ABORT:
    echo "postcommit.csh: user aborted"
    exit 1
