#!/bin/sh
#checkgeo.sh by David Zokaites September 1996 
#check lasgeolib supports xxxfor and xxxinv





#a shell function to include a prototype for this function in the source file 
   #prototoype must be included just after the last "#include" statement 
add_ptype ()
{

#find line number of last "#include" 
   lastinc=`
   nawk '
      BEGIN       { lastinc = 0   }
      /^#include/ { lastinc = NR  } 
      END         { print lastinc }
   ' $file.c `

#copy the source file up to the last "#include"
   head -$lastinc $file.c > $file.new.c 

#make prototype for this source file 
   nawk -v file=$file '
      BEGIN {
	 print "/* FUNCTION PROTOTYPE */"  #print a C comment 
	 print "int", file, "(double lon, double lat, double *x, double *y);"
	 print "int", file, "(double x, double y, double *lon, double *lat);"
	 print 
      } 
   ' $file.c >> $file.new.c 

   #add the rest of the source file
      lastinc=`expr $lastinc + 1`
      tail +$lastinc $file.c >> $file.new.c 
}







#effective start of script
   refdir=`pwd`              #save current directory location for output files
   echo > $refdir/checkgeo.log   #initialize output log file
   cd las/lasgeolib              #the files are here 

#loop for all files 
   for file in `ls -1 *for.c *inv.c | grep -v new.c` 
   do
      #remove .c extension from file variable
	 file=`echo $file | sed -e 's/.c$//' `
      #user message
	 echo Checking las/lasgeolib/$file.new.c 
	 echo Checking las/lasgeolib/$file.new.c >> $refdir/checkgeo.log 
      #add a prototype to the file 
	 add_ptype 
      #compile file with prototype checking 
	 cc -prototypes -c $file.new.c -o $file.o \
	  -I$ADAPSINCLUDE -I$LASINCLUDE -I$TINC   \
	  2>> $refdir/checkgeo.log 
      #delete object file
	 rm $file.o 2> /dev/null 
   done 

#completion message
   echo 
   echo checkgeo.sh completed and created output:
   echo '  checkgeo.log:      compilation/processing log'
   echo '  Be sure to check this log for errors!' 
   echo execute the following commands to delete intermediates
   echo '  rm las/lasgeolib/*.new.c' 
   echo '  rm -r las/lasgeolib'

   exit 0 
