#!/bin/csh -f
#prepare.csh:  prepare for checking function prototypes
#   by David Zokaites September 1996 
#   check out all baseline adaps and las support libraries
#   get a copy of adapsp.h and lasp.h 

#make directories
   mkdir adaps las

#checkout adaps
   cd adaps 
   cvs co acqio
   cvs co archio
   cvs co model
   cvs co queue
   cvs co adapssup
   cvs co adapsgeolib
   cvs co products
   cvs co adapsutil
   cd .. 

#checkout las
   cd las 
   cvs co alias
   cvs co cm
   cvs co dcw
   cvs co ddr
   cvs co disk
   cvs co dittosup
   cvs co dltf
   cvs co lasgeolib
   cvs co gof
   cvs co header
   cvs co imageio
   cvs co labserv
   cvs co ltsup
   cvs co mathsup
   cvs co notae
   cvs co pixman
   cvs co statio
   cvs co lastae
   cvs co tapeio
   cvs co tm
   cvs co lasutil
   cvs co lasutil2
   cd .. 

#release all libraries
   foreach lib (adaps/* las/*)
      cd $lib
      cvs release
      cd ../..
   end 

#get a copy of adapsp.h and lasp.h
   cp $ADAPSINCLUDE/adapsp.h . 
   cp $LASINCLUDE/lasp.h . 
   echo Before running check.sh, 
   echo ' ' strip initial comments and const keyword from adapsp.h and lasp.h 
   echo ' ' use of const keyword has not been enabled for LAS 

#completion message
   echo prepare.csh has checked out all ADAPS and LAS supports 
   exit 0 
