/*******************************************************************************
FUNCTION: RP

PROGRAM HISTORY:

PROGRAMMER       DATE   REASON
---------------  -----  --------------------------------------------------------
K.Gacke          ???    Development
J.Fenno          03/92  Made tapeid a required parameter.

*******************************************************************************/
#include <sys/types.h>
#include <sys/socket.h>
#include <time.h>

#define FUNCTION
#define FATAL   -1
#define WARNING -2

#define errhd(key, sev, msg, p1, p2)\
{\
errhrt(key, sev, msg, p1, p2);\
if (sev == FATAL)\
exit(FATAL);\
}

main(argc, argv)
	int argc;
	char *argv[];
{
	int stat, loop, i;
	struct sockaddr sckta;
	int size;
	int sd;
	long nparm;
	char buf[100];

	if (argc < 4)
		errhd("RP_USAGE", FATAL, "syntax is  rp job# tape_drv tape_id",
			&nparm, &nparm);

	sd = socket(AF_UNIX, SOCK_STREAM, 0);
	if (sd < 0)
		errhd("RP_SOCK", FATAL, "unable to create socket",&nparm,
			&nparm);

	sckta.sa_family = AF_UNIX;
	sprintf (sckta.sa_data, "/tmp/rp%s", argv[1]);
	while (strlen(sckta.sa_data) < 13) /*  fix for 4.1c BSD */
	{
		strcat(sckta.sa_data, "Z");
	}
	size = sizeof(sckta.sa_family) + strlen(sckta.sa_data);
	stat = connect(sd, &sckta, size);
	if (stat < 0)
		{
		perror("rp");
		errhd ("RP_CONNECT", FATAL, "No such job# %s", argv[1], &nparm);
		}
	sprintf(buf,"%s %s",argv[2],argv[3]);

	stat = send(sd, buf, strlen(buf), 0);
	if (stat < 0)
		{
		perror("rp");
		errhd ("RP_SEND", FATAL, "Can't send to job# %s", argv[1],
			 &nparm);
		}
	stat = close(sd);
}
FUNCTION errhrt (key, severity, fmt, arg1, arg2)
	
	char *key;
	long severity;
	char *fmt;
	long *arg1, *arg2;
{

	long		time(),my_time;
	struct tm	*tm_ptr;


	my_time=time(0);
	tm_ptr=localtime(&my_time);
	
	printf("%2d/%02d/%02d %02d:%02d:%02d "
		,tm_ptr->tm_mon+1,tm_ptr->tm_mday,tm_ptr->tm_year
		,tm_ptr->tm_hour,tm_ptr->tm_min,tm_ptr->tm_sec);
	printf("%s ",key);
	printf(fmt, arg1, *arg2);
	printf("\n");

}
