/****************************************************************************/
/*   PROGRAM NAME  : ct_interface.h                                         */
/*   AUTHOR        : g e nostrand                                           */
/*   DATE          : july 14, 1993                                          */
/*   LOCATION      : DSRC PRINCETON, NJ                                     */
/*                                                                          */
/*   PROGRAM DESCRIPTION:                                                   */
/*   PROGRAM MODIFICATIONS:                                                 */
/****************************************************************************/

#define SIZEBREAKPTBOX  8

#define MAXSTRETCHES	100

typedef void            (*P_FUNC)();
typedef char            *P_CHAR;

/*  Define special stretch list slots to track current and previous values 
    to allow for UNDO/REDO style operations	
*/

#define CURRENT 	0
#define PREVIOUS 	1
#define LINEAR 		2
#define FIRSTSTRETCH 	3

typedef struct _XID_STRETCHLIST {
   long 	 flags;
   long          index;
   long          *from;
   long          *to;
} XID_STRETCHLIST, *XID_STRETCHLISTPTR;

#define STRETCHSAT	BLUE+1
#define STRETCHALL	STRETCHSAT+1
typedef struct _XID_COLORSTRETCH {
  XID_STRETCHLIST	color[4];
} XID_COLORSTRETCH, *XID_COLORSTRETCHPTR;

typedef struct _XID_COLORTOOL {
   Window        	window;
   GC 		 	gc;
   XID_STRETCHLIST 	adjust;
   int           	x;
   int           	y;
   int			lastx;
   int			lasty;
   unsigned long	adjusted_hist[256];
   unsigned long	cum_histo[256];
   unsigned long	map[256];
   unsigned int  	width;
   unsigned int  	height;
   unsigned long 	linecolor;
   unsigned long 	foreground;
   unsigned long 	background;
} XID_COLORTOOL, *XID_COLORTOOLPTR;

#ifdef DECLARECT
XID_COLORTOOLPTR       	CT_Color;
XID_COLORTOOL        	red, green, blue, allrgb, satrgb;
XID_COLORTOOLPTR	CT_Colors[5] = { &red, &green, &blue, &satrgb, &allrgb };

Widget			*CT_ColorWidget [5] = {
			&ct_stretch_color_red,
			&ct_stretch_color_green,
			&ct_stretch_color_blue,
			&ct_stretch_color_sat,
			&ct_stretch_color_all
			};
#else
extern XID_COLORTOOLPTR       	CT_Color;
extern XID_COLORTOOL        	red, green, blue, allrgb, satrgb;
extern XID_COLORTOOLPTR	CT_Colors[5] ;

extern Widget			*CT_ColorWidget [5] ;
#endif
