/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 2.5.
 *
 */
#include <Xm/Xm.h>

float	HistMean = 128.0;
float	HistStDev = 64.0;
int	HistPoints = 10;

#define HISTAUTO 1
#define HISTAPPLY 2

int	HistMode = HISTAUTO;

#include "xid.h"
#include "ct_interface.h"

/*
 * histNormal.c 1.2 Date created 6/4/93 Date used    7/20/93
 */
static char     sccsData[] = "@(#)histNormal.c 1.2 6/4/93 DSRC_SCQC";

#define MAIN

#include "scqcdec.h"
#include <math.h>

#ifdef TESTING
usage(prog)
	char           *prog;
{
	static char    *helpmsg[] = {
		"Function: Histogram Normalization of RGB image\n",
		"Options:\n",
		"	[-r mean stdev]	 red plane normal density curve\n",
		"	[-g mean stdev]	 green plane normal density curve\n",
		"	[-b mean stdev]	 blue plane normal density curve\n",
		NULL
	};
	char          **p = helpmsg;

	fprintf(stderr, "Usage: %s {Options} [file]\n", prog);
	while (*p)
		(void) fputs(*p++, stderr);
	exit(-1);
}

float           mean[3] = {128., 128., 128};
float           stdev[3] = {40., 40., 40.};

main(argc, argv)
	char          **argv;
	int             argc;
{
	BIMAGE         *colorimg;
	LNIP_HEADER     lniphdr;
	char           *c, *prog = argv[0];
	char            filename[256];
	char           *imgFilename;
	int             i;


	while (--argc > 0 && (*++argv)[0] == '-')
		for (c = argv[0] + 1; *c != '\0'; c++)
			switch (*c) {
			case 'r':
				--argc;
				mean[0] = atof(*++argv);
				--argc;
				stdev[0] = atof(*++argv);
				break;
			case 'g':
				--argc;
				mean[1] = atof(*++argv);
				--argc;
				stdev[1] = atof(*++argv);
				break;
			case 'b':
				--argc;
				mean[2] = atof(*++argv);
				--argc;
				stdev[2] = atof(*++argv);
				break;
			case 'v':
				verbose++;
				break;
			case 'h':
				usage(prog);
				break;
			}
	if (argc == 0) {
		colorimg = read_lasbimgstr(stdin, &lniphdr);
		if (lniphdr.depth != 3)
			die("read_bseqstr: depth = %d, expect 3\n", lniphdr.depth);
	} else if (argc == 1) {
		imgFilename = argv[--argc];
		colorimg = read_lasbimage(imgFilename, &lniphdr);
		if (lniphdr.depth != 3)
			die("read_bimgseq: depth = %d, expect 3\n", lniphdr.depth);
	} else
		usage(argv[0]);

	for (i = 0; i < 3; i++)
		histNormalizeImg(colorimg[i], mean[i], stdev[i]);

	/* write out files */

	/* as UBYTE */
	write_lasbimgstr(stdout, colorimg, lniphdr);



}
#endif /* TESTING */
float
gaussint(x)
	float           x;
{
	float           result;

	result = ((float) erf((double) x) + 1.) / 2.;
	return result;

}
#ifdef TESTING
histNormalizeImg(img, mean, stdev)
	BIMAGE          img;
	float           mean, stdev;
#else
histNormalizeImg(histptr, mean, stdev, from, to, index)
	long		*histptr;
	float           mean, stdev;
	int		*from, *to, *index;
#endif /* TESTING */
{
	int             i;
	int             norm[256], p[256], lut[256], compose();

	normalDensity(norm, 256, mean, stdev);
	makeInverse(norm, 256);

#ifdef  TESTING
	histogram(p, img);
#else
	/*  Histogram already performed in xid */
	for (i=0; i< 256; i++)
	    p[i] = histptr[i];
#endif
	integrateAndScale(p, 256, 256);

	compose(lut, norm, p, 256);
#ifdef TESTING
	applyLut(lut, img);
#else
	estimatePWL(lut, from, to, index);
#endif


}
integrateAndScale(arr, n, hmax)
	int            *arr, n, hmax;
{
	int             i;

	for (i = 1; i < n; i++)
		arr[i] = arr[i] + arr[i - 1];

	bytscl(arr, hmax);

}
#ifdef TESTING
applyLut(lut, img)
	int            *lut;
	BIMAGE          img;
{
	int             i, j;

	for (j = 0; j < img.h; j++)
		for (i = 0; i < img.w; i++)
			img.ptr[j][i] = lut[img.ptr[j][i]];

}
normInverse(arr, p, img)
	int            *arr, *p;
	BIMAGE          img;
{
	int             i, j;

	for (j = 0; j < img.h; j++)
		for (i = 0; i < img.w; i++)
			img.ptr[j][i] = arr[p[img.ptr[j][i]]];

}
histogram(p, img)
	int            *p;
	BIMAGE          img;
{
	int             i, j;

	for (i = 0; i < 256; i++)
		p[i] = 0;

	for (j = 0; j < img.h; j++)
		for (i = 0; i < img.w; i++)
			p[img.ptr[j][i]]++;

}
#endif /* TESTING */

fbytscl(arr, n)
	float          *arr;
	int             n;
{
	int             i;
	float           hmax = arr[0], hmin = arr[0];
	float           scale;

	for (i = 0; i < n; i++) {
		hmax = MAX(arr[i], hmax);
		hmin = MIN(arr[i], hmin);
	}

	scale = ((hmax - hmin) > 0. ? (255. / (hmax - hmin)) : 1.);

	for (i = 0; i < n; i++) {
		arr[i] = (((float) arr[i] - hmin) * scale);

	}
}
bytscl(arr, n)
	int            *arr;
	int             n;
{
	int             i;
	int             hmax = arr[0], hmin = arr[0];
	float           scale;

	for (i = 0; i < n; i++) {
		hmax = MAX(arr[i], hmax);
		hmin = MIN(arr[i], hmin);
	}

	scale = ((hmax - hmin) > 0. ? (255. / (hmax - hmin)) : 1.);

	for (i = 0; i < n; i++) {
		double tdouble;

		tdouble = (((float) arr[i] - hmin) * scale);
		tdouble = rint (tdouble);
		arr[i] = (int) tdouble;
	}
}
normalDensity(norm, n, mean, stdev)
	int            *norm;
	int             n;
	float           mean, stdev;
{
	int             i;
	float          *fnorm, gaussint();

	fnorm = (float *) malloc(n * sizeof(float));

	for (i = 0; i < 256; i++)
		fnorm[i] = gaussint(((float) i - mean) / stdev);

	fbytscl(fnorm, 256);
	for (i = 0; i < 256; i++)
	{
	    double tdouble;

	    tdouble = (double) fnorm[i];
	    norm[i] = (int) tdouble;
	}

}
makeInverse(arr, n)
	int            *arr;
	int             n;
{
	int             hmax;
	int             i, *ident, *inverse, *identity();

	hmax = arr[0];
	for (i = 0; i < n; i++)
		hmax = MAX(arr[i], hmax);

	ident = identity(hmax);

	inverse = (int *) malloc(n * sizeof(int));
	for (i = 0; i < n; i++)
		inverse[i] = 0;

	for (i = 0; i < hmax; i++)
		inverse[arr[i]] = i;

	/* fill in the zeros */
	inverse[0] = 0;
	for (i = 1; i < n - 1; i++) {
		if (inverse[i] < inverse[i - 1])
			inverse[i] = inverse[i - 1];
		arr[i] = inverse[i];
	}
}
int            *
identity(n)
	int             n;
{
	int             i, *ident;
	ident = (int *) malloc(n * sizeof(int));

	for (i = 0; i < n; i++)
		ident[i] = i;
	return ident;
}
compose(c, a, b, n)
	int            *c, *a, *b, n;
{
	int             i ;


	for (i = 0; i < n; i++)
		c[i] = a[b[i]];

}

/******************************************************************************/
/*
    estimatePWL - estimate the piece-wise linear breakpoints which would
    produce the lut specified. 
*/
/******************************************************************************/
estimatePWL(lut, from, to, index)
int *lut;
int	*from;
int	*to;
int	*index;
{
    int i, j;
    float slope, lastslope;
    int	 inc [256], breakpt[256], points;
    float newpointmargin;
    int 	stepinc;

    if (*index == 0) *index = 1;
    stepinc = *index;
    newpointmargin = .05 * stepinc;
    *index = 0;
    from[*index] = 0;
    to[*index] = lut[0];
    lastslope = (lut[stepinc] - lut[0]) / (float) stepinc;
    i = stepinc;
    /*
    printf("Slope at %d, %d = %f\n", i, lut[i], lastslope);
    */
    for (i=(2*stepinc); i< 256; i+=stepinc)
    {
	slope = (lut[i] - lut[i-stepinc]) / (float) stepinc;
	if (ABS(lastslope - slope) > newpointmargin)
	{
	    if (from[*index] != (i-stepinc))
	    {
		(*index)++;
		from[*index] = i-stepinc;
		to[*index] = lut[i-stepinc];
		/*
		printf("Transition point at %d, %d \n", i-stepinc, lut[i-stepinc]);
		*/
	    }

	    (*index)++;
	    from[*index] = i;
	    to[*index] = lut[i];
	    /*
	    printf("New point at %d, %d slope = %f\n", i, lut[i], slope);
	    */
	    lastslope = slope;
	}
	/*
	else
	    printf("Slope at %d, %d = %f\n", i, lut[i], slope);
	*/
    }
    (*index)++;
    from[*index] = 255;
    to [*index] = lut[255];
}

void 
ct_normalize ()
{

    long bnd;
    unsigned long *histptr;

    ct_drawline( CT_Color->window,
	    CT_Color->gc,
	    CT_Color->adjust.from,
	    CT_Color->adjust.to,
	    CT_Color->adjust.index,
	    CT_Color->background, SIZEBREAKPTBOX);

    if (CT_Color->adjust.flags & MAP_RED) 
	bnd =xid_view.rgbplanes[0];
    if (CT_Color->adjust.flags & MAP_GREEN) 
	bnd =xid_view.rgbplanes[1];
    if (CT_Color->adjust.flags & MAP_BLUE) 
	bnd =xid_view.rgbplanes[2];

    /*  Get the histogram adjusted for the piecewise linear mapping	*/
    if (CT_Color->adjust.flags & MAP_ALL) 
    {
	int	p, i;
	unsigned long	*adjusted_hist, *map;

	for (i=0;i<256;i++) CT_Color->adjusted_hist[i] = 0;
	for (p=0; p<3; p++)
	{
	    /*  Calculate the adjusted histogram for each color */
	    bnd =xid_view.rgbplanes[p];
	    histptr = (unsigned long *)xid_planes[bnd-1].histogram;
	    /*
	    map = CT_Colors[p]->map;
	    adjusted_hist = CT_Colors[p]->adjusted_hist;
	    ct_calc_adjusted_hist (histptr, map, adjusted_hist);
	    */

	    /*  Sum each colors histogram values in ALL color	*/
	    for (i=0;i<256;i++) CT_Color->adjusted_hist[i] += histptr[i];

	}
	/* Find the maximum value of the histogram for autoscaling the y axis*/
	histptr = CT_Color->adjusted_hist;
    }
    else
	histptr = (unsigned long *)xid_planes[bnd-1].histogram;

    CT_Color->adjust.index = HistPoints;
    histNormalizeImg (histptr, HistMean, HistStDev,
	CT_Color->adjust.from, CT_Color->adjust.to, &CT_Color->adjust.index);

    ct_drawline( CT_Color->window,
	    CT_Color->gc,
	    CT_Color->adjust.from,
	    CT_Color->adjust.to,
	    CT_Color->adjust.index,
		CT_Color->linecolor, SIZEBREAKPTBOX);
	
    ct_apply (CT_Color);
    ct_histo_draw (CT_Color);
    ct_new_curr_stretch();

    if (ct_cmap_mainwindow && XtIsManaged (ct_cmap_mainwindow))
    {
       xcmap_draw_colors();
    }
}

/* ARGSUSED */
void
#ifdef _NO_PROTO
histmod_apply(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
#else
histmod_apply(Widget w, XtPointer client, XtPointer call)
#endif
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;

    ct_normalize ();

}
/* ARGSUSED */
void
#ifdef _NO_PROTO
histmod_dismiss(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
#else
histmod_dismiss(Widget w, XtPointer client, XtPointer call)
#endif
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;

	ct_popup_histnorm (ct_normalize_button, client, call);
}

/* ARGSUSED */
void
#ifdef _NO_PROTO
histmod_mode(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
#else
histmod_mode(Widget w, XtPointer client, XtPointer call)
#endif
{
        XmToggleButtonCallbackStruct *toggle=
			(XmToggleButtonCallbackStruct*)call;

    if (toggle->set)
	if (strcmp((char *)client, "Automatic") == 0)
	    HistMode = HISTAUTO;
	else
	    HistMode = HISTAPPLY;
}

/* ARGSUSED */
void
#ifdef _NO_PROTO
histmod_slider(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
#else
histmod_slider(Widget w, XtPointer client, XtPointer call)
#endif
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;

	if (*(char *)client == 'M')
	{
	    int	mean;
	    XmScaleGetValue (hist_mean_slider, &mean);
	    HistMean = (float) mean;
	}
	else
	if (*(char *)client == 'S')
	{
	    int stdev;
	    XmScaleGetValue (hist_std_dev_slider, &stdev);
	    HistStDev = (float) stdev;
	}
	else
	if (*(char *)client == 'P')
	{
	    XmScaleGetValue (hist_points_slider, &HistPoints);
	}

	if (HistMode == HISTAUTO)
	   ct_normalize ();
}


/* ARGSUSED */
void
#ifdef _NO_PROTO
histmod_change_slider(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
#else
histmod_change_slider(Widget w, XtPointer client, XtPointer call)
#endif
{
	XmAnyCallbackStruct *acs=(XmAnyCallbackStruct*)call;

	histmod_slider(w, client, call);
}

