/*
 *  This is the creation routine for the power spectrum panel.  It was 
 *  generated *  using the ICS builderXcessory (BX).
 *
 *  By L.Huewe, USGS/EROS Data Center, 5/93.
 *    - X Image Display, v2.0.
 *
 */
#include "xid.h"
#include "pixmaps.h"

Widget
Createpower_form(parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    XmString	xmstr[32];
    long	plane_idx;		/* Memory plane index.		      */
    char	points[10];		/* Number of points default string.   */
    Dimension   shadow,border,hilight,width,height;

/*
    Create the main form widget.
*/
    XtInitializeWidgetClass(xmFormWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 860); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 450); argcnt++;
    power_form = XtCreateWidget("power_form",
		xmFormWidgetClass,
		parent,
		args,
		argcnt);
    retval = power_form;

/*
    Add an event handler for exposure events.
*/
    XtAddEventHandler(power_form,ExposureMask,FALSE,power_expose,NULL);

/*
    Find the memory plane index of the displayed image.
*/
    plane_idx = xid_view.rgbplanes[RED] - 1;

    xid_power.per_npts = (long)(nearest_power2(xid_planes[plane_idx].dspwin[NS])
        / 2.0);
    sprintf(points,"%d",xid_power.per_npts);

/*
    Create the periodogram number of points text field.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNvalue, points); argcnt++;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 58); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    power_ppoints_text = XtCreateWidget("power_ppoints_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_ppoints_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_ppoints_text);

/*
    Create the periodogram ending frequency text field.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, ".5"); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 58); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    power_pend_text = XtCreateWidget("power_pend_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_pend_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_pend_text);

/*
    Create the periodogram starting frequency text field.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 12); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 58); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    power_pstart_text = XtCreateWidget("power_pstart_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_pstart_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_pstart_text);

/*
    Create a separator.
*/
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 394); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    power_separator = XtCreateWidget("power_separator",
		xmSeparatorWidgetClass,
		power_form,
		args,
		argcnt);
    XtManageChild(power_separator);

/*
    Create the periodogram toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Periodogram", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 30); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 118); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    power_periodogram_button = XtCreateWidget("power_periodogram_button",
		xmToggleButtonWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_periodogram_button, XmNvalueChangedCallback, power_periodogram, (XtPointer)0);
    XtManageChild(power_periodogram_button);

/*
    Create the maximum entropy toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Maximum Entropy", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 45); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 30); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 152); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    power_entropy_button = XtCreateWidget("power_entropy_button",
		xmToggleButtonWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_entropy_button, XmNvalueChangedCallback, power_entropy, (XtPointer)0);
    XtManageChild(power_entropy_button);

/*
    Create the maximum entropy order text field.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNvalue, "25"); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 90); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    power_order_text = XtCreateWidget("power_order_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_order_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_order_text);
    xid_power.order = 25;

/*
    Create the maximum entropy order label.
*/
    XtInitializeWidgetClass(xmLabelWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Order:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 200); argcnt++;
    power_order = XtCreateWidget("power_order",
		xmLabelWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(power_order);

/*
    Calculate the default number of maximum entropy points. 
*/
    xid_power.ent_npts = (long)(xid_planes[plane_idx].dspwin[NS] / 2.0);
    sprintf(points,"%d",xid_power.ent_npts);

/*
    Calculate the maximum entropy number of points.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNvalue, points); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    power_epoints_text = XtCreateWidget("power_epoints_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_epoints_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_epoints_text);

/*
    Create the number of points label.
*/
    XtInitializeWidgetClass(xmLabelWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Number of Points:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 160); argcnt++;
    power_points = XtCreateWidget("power_points",
		xmLabelWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(power_points);

/*
    Create the maximum entropy ending frequency text fied.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNvalue, ".5"); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 25); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    power_eend_text = XtCreateWidget("power_eend_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_eend_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_eend_text);
    xid_power.end_freq = 0.5;

/*
    Create the maximum entropy starting frequency text field.
*/
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, 3); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 12); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 18); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_entropy_button); argcnt++;
    power_estart_text = XtCreateWidget("power_estart_text",
		xmTextFieldWidgetClass,
		power_form,
		args,
		argcnt);

    XtAddCallback(power_estart_text, XmNactivateCallback, power_text, (XtPointer)0);
    XtManageChild(power_estart_text);
    xid_power.start_freq = 0.0;

/*
    Create the ending frequencey label.
*/
    XtInitializeWidgetClass(xmLabelWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"End Frequency:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 120); argcnt++;
    power_endfreq = XtCreateWidget("power_endfreq",
		xmLabelWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(power_endfreq);

/*
    Create the starting frequency label.
*/
    XtInitializeWidgetClass(xmLabelWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Start Frequency:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 80); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_entropy_button); argcnt++;
    power_startfreq = XtCreateWidget("power_startfreq",
		xmLabelWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(power_startfreq);

/*
    Create the "Power Spectrum" label.
*/
    XtInitializeWidgetClass(xmLabelWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Power Spectrum ", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, 69); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNx, 624); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    power_label = XtCreateWidget("power_label",
		xmLabelWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(power_label);

/*
    Create the help button.
*/
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelType, 1); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap,
	XPM_PIXMAP(parent, helpxbm_width,helpxbm_height,
	helpxbm_ncolors, helpxbm_chars_per_pixel, helpxbm_colors, 
	helpxbm_pixels)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 878); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 31); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 31); argcnt++;
    power_help_button = XtCreateWidget("power_help_button",
		xmPushButtonWidgetClass,
		power_form,
		args,
		argcnt);
    XtAddCallback(power_help_button, XmNactivateCallback, help_update, 
	(caddr_t)"power.html");
    XtManageChild(power_help_button);

/*
    Create the "Dismiss" button.
*/
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginLeft, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginRight, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginTop, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginBottom, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Dismiss", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 812); argcnt++;
    XtSetArg(args[argcnt], XmNy, 384); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 83); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 29); argcnt++;
    power_dismiss_button = XtCreateWidget("power_dismiss_button",
		xmPushButtonWidgetClass,
		power_form,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_dismiss_button, XmNactivateCallback, power_destroy, (XtPointer)0);
    XtManageChild(power_dismiss_button);

/*
    Create the "Continuous/Discrete" radio box.
*/
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 73); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_separator); argcnt++;
    power_cd_radiobox = XtCreateWidget("power_cd_radiobox",
		xmRowColumnWidgetClass,
		power_form,
		args,
		argcnt);
    XtManageChild(power_cd_radiobox);

/*
    Create the "Automatic/Manual" radio box.
*/
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 108); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 73); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_separator); argcnt++;
    power_am_radiobox = XtCreateWidget("power_am_radiobox",
		xmRowColumnWidgetClass,
		power_form,
		args,
		argcnt);
    XtManageChild(power_am_radiobox);

/*
    Create the X/Y/Z radio box.
*/
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 138); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 143); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_separator); argcnt++;
    power_dir_radiobox = XtCreateWidget("power_dir_radiobox",
		xmRowColumnWidgetClass,
		power_form,
		args,
		argcnt);
    XtManageChild(power_dir_radiobox);

/*
    Create the power spectrum scrolled window.
*/
    XtInitializeWidgetClass(xmScrolledWindowWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAUTOMATIC); argcnt++;
    XtSetArg(args[argcnt], XmNscrollBarDisplayPolicy, XmSTATIC); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 391); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, POWER_SCROLLW); argcnt++;
    XtSetArg(args[argcnt], XmNheight, POWER_SCROLLH); argcnt++;
    power_scrollwin = XtCreateWidget("power_scrollwin",
		xmScrolledWindowWidgetClass,
		power_form,
		args,
		argcnt);

    XtSetArg(args[0],XmNhorizontalScrollBar,&power_hor_scrollbar);
    XtSetArg(args[1],XmNverticalScrollBar,&power_vert_scrollbar);
    XtGetValues(power_scrollwin,args,2);
    XtManageChild(power_scrollwin);

    XtAddCallback(power_hor_scrollbar, XmNdragCallback, power_expose,
        (caddr_t)0);
    XtAddCallback(power_hor_scrollbar, XmNvalueChangedCallback,
        power_expose, (caddr_t)0);
    XtAddCallback(power_vert_scrollbar, XmNdragCallback, power_expose,
        (caddr_t)0);
    XtAddCallback(power_vert_scrollbar, XmNvalueChangedCallback,
        power_expose, (caddr_t)0);

/*
    Create the power spectrum bulletinboard.
*/
    XtInitializeWidgetClass(xmBulletinBoardWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_ANY); argcnt++;
    XtSetArg(args[argcnt], XmNnoResize, False); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 512); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 512); argcnt++;
    power_scrollwin_bulletinboard = XtCreateWidget("power_scrollwin_bulletinboard",
		xmBulletinBoardWidgetClass,
		power_scrollwin,
		args,
		argcnt);
    XtManageChild(power_scrollwin_bulletinboard);

/*
    Create the "X" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"X", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    power_x_button = XtCreateWidget("power_x_button",
		xmToggleButtonWidgetClass,
		power_dir_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_x_button, XmNarmCallback, power_dir, (XtPointer)"X");
    XtManageChild(power_x_button);

/*
    Create the "Y" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Y", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    power_y_button = XtCreateWidget("power_y_button",
		xmToggleButtonWidgetClass,
		power_dir_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_y_button, XmNarmCallback, power_dir, (XtPointer)"Y");
    XtManageChild(power_y_button);

/*
    Create the "Z" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Z", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    power_z_button = XtCreateWidget("power_z_button",
		xmToggleButtonWidgetClass,
		power_dir_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_z_button, XmNarmCallback, power_dir, (XtPointer)"Z");
    XtManageChild(power_z_button);

/*
    Create the "User" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNsensitive, False); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"User-selected", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    power_user_button = XtCreateWidget("power_user_button",
		xmToggleButtonWidgetClass,
		power_dir_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_user_button, XmNarmCallback, power_dir, (XtPointer)"US");
    XtManageChild(power_user_button);

/*
    Set form attachments.
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_dir_radiobox, args, argcnt);

/*
    Create the "Automatic" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Automatic", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    power_auto_button = XtCreateWidget("power_auto_button",
		xmToggleButtonWidgetClass,
		power_am_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_auto_button, XmNarmCallback, power_am, (XtPointer)"A");
    XtManageChild(power_auto_button);

/*
    Create the "Manual" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Manual", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    power_man_button = XtCreateWidget("power_man_button",
		xmToggleButtonWidgetClass,
		power_am_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_man_button, XmNarmCallback, power_am, (XtPointer)"M");
    XtManageChild(power_man_button);

/*
    Set form attachments.
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_dir_radiobox); argcnt++;
    XtSetValues(power_am_radiobox, args, argcnt);

/*
    Create the "Continuous" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Continuous", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    power_cont_button = XtCreateWidget("power_cont_button",
		xmToggleButtonWidgetClass,
		power_cd_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_cont_button, XmNarmCallback, power_cd, (XtPointer)"C");
    XtManageChild(power_cont_button);

/*
    Create the "Discrete" toggle button.
*/
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginHeight, 0); argcnt++;
    XtSetArg(args[argcnt], XmNselectColor, CONVERT(parent,"black", "Pixel", 0, &argok)); if(argok) argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
		"Discrete", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    power_dis_button = XtCreateWidget("power_dis_button",
		xmToggleButtonWidgetClass,
		power_cd_radiobox,
		args,
		argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(power_dis_button, XmNarmCallback, power_cd, (XtPointer)"D");
    XtManageChild(power_dis_button);

/*
    Set form attachments.
*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_am_radiobox); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_dir_radiobox); argcnt++;
    XtSetValues(power_cd_radiobox, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_startfreq, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_startfreq); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_endfreq, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 18); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_startfreq); argcnt++;
    XtSetValues(power_estart_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_estart_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 25); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_endfreq); argcnt++;
    XtSetValues(power_eend_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_endfreq); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_points, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_eend_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_points); argcnt++;
    XtSetValues(power_epoints_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 20); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_points); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_order, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_epoints_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 90); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_order); argcnt++;
    XtSetValues(power_order_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 45); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_entropy_button, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_entropy_button); argcnt++;
    XtSetValues(power_periodogram_button, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_order_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_scrollwin); argcnt++;
    XtSetValues(power_separator, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 12); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_periodogram_button); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 58); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_estart_text); argcnt++;
    XtSetValues(power_pstart_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_pstart_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 58); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_eend_text); argcnt++;
    XtSetValues(power_pend_text, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 6); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, power_pend_text); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 58); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, power_epoints_text); argcnt++;
    XtSetValues(power_ppoints_text, args, argcnt);

/*
    Retrieve the width, shadow thickness, border width, and highlight thickness
    of the vertical scrollbar.  This information is used to calculate the 
    appropriate size of the scrolled window.
*/
    XtSetArg(args[0],XmNwidth,&width);
    XtSetArg(args[1],XmNshadowThickness,&shadow);
    XtSetArg(args[2],XmNborderWidth,&border);
    XtSetArg(args[3],XmNhighlightThickness,&hilight);
    XtGetValues(power_vert_scrollbar,args,4);
    xid_power.view_xoffset = width + border * 2 + shadow * 2 + hilight * 2;

/*
    Retrieve the height, shadow thickness, border width, and highlight thickness
    of the horizontal scrollbar.  This information is used to calculate the 
    appropriate size of the scrolled window.
*/
    XtSetArg(args[0],XmNheight,&height);
    XtSetArg(args[1],XmNshadowThickness,&shadow);
    XtSetArg(args[2],XmNborderWidth,&border);
    XtSetArg(args[3],XmNhighlightThickness,&hilight);
    XtGetValues(power_hor_scrollbar,args,4);
    xid_power.view_yoffset = height + border * 2 + shadow * 2 + hilight * 2;

/*
    Retrieve the shadow thickness and  border width of the scrolled window.
    This information is used to calculate the appropriate size of the scrolled 
    window.
*/
    XtSetArg(args[0],XmNshadowThickness,&shadow);
    XtSetArg(args[1],XmNborderWidth,&border);
    XtGetValues(power_scrollwin,args,2);
    xid_power.view_xoffset += (shadow * 2 + border * 2);
    xid_power.view_yoffset += (shadow * 2 + border * 2);

/*
    Retrieve the shadow thickness and  border width of the bulletinboard
    contained within the scrolled window.  This information is used to 
    calculate the appropriate size of the scrolled window.
*/
    XtSetArg(args[0],XmNshadowThickness,&shadow);
    XtSetArg(args[1],XmNborderWidth,&border);
    XtGetValues(power_scrollwin_bulletinboard,args,2);
    xid_power.view_xoffset += (shadow * 2 + border * 2);
    xid_power.view_yoffset += (shadow * 2 + border * 2);

    return( retval );
}
