#include "xid.h"

forcedialog(w)
Widget	w;

/*******************************************************************************
Purpose:
    This routine forces the specified dialog (usually a processing dialog) to 
    be displayed and updated. 

By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
*******************************************************************************/

{
Widget		diashell, topshell;	/* Dialog shell and top level shell.  */
Window		diawindow, topwindow;	/* Dialog window and top level window.*/
Display		*dpy;			/* Current display.		      */
XWindowAttributes	
		xwa;			/* Window attributes.		      */
XEvent		event;			/* Event structure.		      */
XtAppContext 	cxt;			/* Application context.		      */

/*
    Locate the shell we are interested in.  In a particular instance, you
    may know these shells already.
*/
for (diashell = w; !XtIsShell(diashell); diashell = XtParent(diashell));

/*
    Locate its primary window's shell (which may be the same).
*/
for (topshell = diashell; !XtIsTopLevelShell(topshell); 
    topshell = XtParent(topshell));

if (XtIsRealized(diashell) && XtIsRealized(topshell))
    {
    dpy = XtDisplay(topshell);
    diawindow = XtWindow(diashell);
    topwindow = XtWindow(topshell);
    cxt = XtWidgetToApplicationContext(diashell);

/*
    Wait for the dialog to be mapped.
*/
    while (XGetWindowAttributes(dpy, diawindow, &xwa), xwa.map_state != 
	IsViewable)
        {
/*
    If the primary is (or becomes) unviewable or unmapped, it's probably
    iconified and nothing will happen.
*/
        if (XGetWindowAttributes(dpy, topwindow, &xwa), xwa.map_state != 
	    IsViewable)
	    break;
/*
    At this stage, we are guaranteed there will be an event of some kind.
*/
	XtAppNextEvent(cxt, &event);
	XtDispatchEvent(&event);
        }
    }
/*
    The next XSync() will get an expose event if the dialog was unmapped.
*/
    XmUpdateDisplay(topshell);
}
