#include "xid.h"

void xid_message(str)
char		*str;		/* Message string (I).			      */

/*******************************************************************************
Purpose:
    This routine displays the given string in a message panel.

By J. Hemmer, USGS/EROS Data Center, 2/92

Algorithm Description:
*******************************************************************************/

{
static Widget message;		/* Widget ID of message box.		      */
Arg          args[10];       	/* Variable used to set widget resources.     */
long         argcnt;		/* Number of values set in args array.        */
XmString     xmstr;		/* Motif format string.			      */

/*
    If the message panel is already active, simply replace the message string.
*/
if (xid.message)
    {
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmessageString,
	   (xmstr=XmStringCreateLtoR(str,
	   XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetValues(message,args,1);
    XmStringFree(xmstr);
    }
else
    {
/*
    Create the message box with the appropriate message.
*/
    argcnt = 0;
    XtSetArg(args[argcnt],XtNvisual,xid.visual_info[0].visual); argcnt++;
    XtSetArg(args[argcnt],XtNcolormap,xid.colormap); argcnt++;
    XtSetArg(args[argcnt], XmNmessageString,
	   (xmstr=XmStringCreateLtoR(str,
	   XmSTRING_DEFAULT_CHARSET))); argcnt++;

    message = XmCreateMessageDialog(Shell_MainMenu,
	      "XID Message",
	      args, argcnt);

    XtAddCallback(message, XmNokCallback, xid_msgcancel, (caddr_t)0);
    XmStringFree(xmstr);

/*
    Don't display the help and cancel buttons.
*/
    XtUnmanageChild(XmMessageBoxGetChild(message, XmDIALOG_HELP_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(message, XmDIALOG_CANCEL_BUTTON));
    XtManageChild(message);

/*
    Set a flag indicating the message panel is active.
*/
    xid.message = TRUE;
    }
/*
    Sound the bell to alert the user to the message.
*/
XBell(xid.display, 0);
}

void xid_msgcancel(w, client, call)
Widget       w;
caddr_t      client;
caddr_t      call;

/*******************************************************************************
Purpose:
    This routine removes and destroys the message panel.

By J. Hemmer, USGS/EROS Data Center, 2/92

Algorithm Description:
*******************************************************************************/

{
/*
    Destroy the widget.
*/
XtDestroyWidget(w);

/*
    Set a flag indicating the message panel is no longer active.
*/
xid.message = FALSE;
}
