#include "xid.h"
#include "../xid_widgets/Context.h"

void
xid_contextadd(context_num)
long	context_num;		/* Number of the XID context to add.  (I)
					0 - Image context (no manual cursor)  
					1 - Image context (manual cursor)
					2 - Graphics Select context
					3 - Graphics Edit context (line, poly,
					    rect)
					4 - Graphics Move/Delete Edit context
					5 - Graphics Add Edit context	      
					6 - Image/Profile context (manual)
					7 - Fill context		      */
/*******************************************************************************
Purpose:
    This routine sets up the appropriate structures and calls the routines
    necessary to add the specified context.

By L. Huewe, USGS/EROS Data Center, 1/93

Modified by L. Huewe, USGS/EROS Data Center, 3/94
    - Added support for the manual profile context.

Algorithm Description:
*******************************************************************************/
{
Context mouse_context;		/* Mouse context structure.		      */

switch (context_num)
    {
    case 0:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_IMAGE]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Full Resolution");
	strcpy(mouse_context.element_names[1],"Zoom");
	strcpy(mouse_context.element_names[2],"No Function");
	strcpy(mouse_context.element_names[3],"Increase Zoom");
	strcpy(mouse_context.element_names[4],"Decrease Zoom");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 5;
	mouse_context.event_handler = FALSE;
	mouse_context.nonmaskable = FALSE;
	(mouse_context.element_handlers)[0] = fullres_button;
	(mouse_context.element_handlers)[1] = zoom_button;
	(mouse_context.element_handlers)[2] = xid_noop;
	(mouse_context.element_handlers)[3] = zoom_arrows;
	(mouse_context.element_handlers)[4] = zoom_arrows;
	mouse_context.client_data[0] = NULL; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.client_data[3] = (XtPointer)"UP";
	mouse_context.client_data[4] = (XtPointer)"DN";
	mouse_context.num_widget_ids = 2;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;
    case 1:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_IMAGE2]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Full Resolution");
	strcpy(mouse_context.element_names[1],"Zoom");
	strcpy(mouse_context.element_names[2],"Update Cursor");
	strcpy(mouse_context.element_names[3],"Increase Zoom");
	strcpy(mouse_context.element_names[4],"Decrease Zoom");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 5;
	mouse_context.event_handler = FALSE;
	mouse_context.nonmaskable = FALSE;
	(mouse_context.element_handlers)[0] = fullres_button;
	(mouse_context.element_handlers)[1] = zoom_button;
	(mouse_context.element_handlers)[2] = cursor_track;
	(mouse_context.element_handlers)[3] = zoom_arrows;
	(mouse_context.element_handlers)[4] = zoom_arrows;
	mouse_context.client_data[0] = NULL; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.client_data[3] = (XtPointer)"UP";
	mouse_context.client_data[4] = (XtPointer)"DN";
	mouse_context.num_widget_ids = 3;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	mouse_context.event_widgets[2] = zoom_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;
    case 2:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_GRSEL]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Select");
	strcpy(mouse_context.element_names[1],"Delete");
	strcpy(mouse_context.element_names[2],"End/Close");
	strcpy(mouse_context.element_names[3],"Cancel");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 4;
	mouse_context.event_handler = TRUE;
	mouse_context.nonmaskable = FALSE;
	mouse_context.event_mask = ButtonReleaseMask;
	(mouse_context.element_handlers)[0] = graphics_select; 
	(mouse_context.element_handlers)[1] = NULL; 
	(mouse_context.element_handlers)[2] = NULL; 
	(mouse_context.element_handlers)[3] = graphics_select; 
	mouse_context.client_data[0] = (XtPointer)123; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.client_data[3] = (XtPointer)4; 
	mouse_context.num_widget_ids = 3;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	mouse_context.event_widgets[2] = zoom_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;
    case 3:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_GREDIT]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Select Element");
	strcpy(mouse_context.element_names[1],"Select Vertice");
	strcpy(mouse_context.element_names[2],"Move Label");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 3;
	mouse_context.event_handler = FALSE;
	mouse_context.nonmaskable = FALSE;
	(mouse_context.element_handlers)[0] = graphics_editfind; 
	(mouse_context.element_handlers)[1] = graphics_vertfind; 
	(mouse_context.element_handlers)[2] = graphics_editfind; 
	mouse_context.client_data[0] = NULL; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.num_widget_ids = 3;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	mouse_context.event_widgets[2] = zoom_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;
    case 4:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_GRMVDEL]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Select");
	strcpy(mouse_context.element_names[1],"Cancel");
	strcpy(mouse_context.element_names[2],"No Function");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 3;
	mouse_context.event_handler = TRUE;
	mouse_context.nonmaskable = FALSE;
	mouse_context.event_mask = ButtonReleaseMask;
	(mouse_context.element_handlers)[0] = graphics_editselect; 
	(mouse_context.element_handlers)[1] = NULL; 
	(mouse_context.element_handlers)[2] = NULL; 
	mouse_context.client_data[0] = NULL; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.num_widget_ids = 3;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	mouse_context.event_widgets[2] = zoom_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;
    case 5:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_GRADD]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Select");
	strcpy(mouse_context.element_names[1],"Delete");
	strcpy(mouse_context.element_names[2],"End/Close");
	strcpy(mouse_context.element_names[3],"Cancel");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 4;
	mouse_context.event_handler = TRUE;
	mouse_context.nonmaskable = FALSE;
	mouse_context.event_mask = ButtonReleaseMask;
	(mouse_context.element_handlers)[0] = graphics_editadd; 
	(mouse_context.element_handlers)[1] = NULL; 
	(mouse_context.element_handlers)[2] = NULL; 
	(mouse_context.element_handlers)[3] = graphics_editadd; 
	mouse_context.client_data[0] = (XtPointer)123; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.client_data[3] = (XtPointer)4; 
	mouse_context.num_widget_ids = 3;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	mouse_context.event_widgets[2] = zoom_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;

    case 6:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_PROFILE]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Full Resolution");
	strcpy(mouse_context.element_names[1],"Zoom");
	strcpy(mouse_context.element_names[2],"Update Profile");
	strcpy(mouse_context.element_names[3],"Increase Zoom");
	strcpy(mouse_context.element_names[4],"Decrease Zoom");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 5;
	mouse_context.event_handler = FALSE;
	mouse_context.nonmaskable = FALSE;
	(mouse_context.element_handlers)[0] = fullres_button;
	(mouse_context.element_handlers)[1] = zoom_button;
	(mouse_context.element_handlers)[2] = profile_draw;
	(mouse_context.element_handlers)[3] = zoom_arrows;
	(mouse_context.element_handlers)[4] = zoom_arrows;
	mouse_context.client_data[0] = NULL; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.client_data[3] = (XtPointer)"UP";
	mouse_context.client_data[4] = (XtPointer)"DN";
	mouse_context.num_widget_ids = 1;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;

    case 7:
/*
    Set the context name.
*/
	strcpy(mouse_context.context_name,context_names[CON_FILL]);
/*
    Set the strings defining the function of the mouse buttons.
*/
	strcpy(mouse_context.element_names[0],"Select Poly");
	strcpy(mouse_context.element_names[1],"Unselect Poly");
	strcpy(mouse_context.element_names[2],"Unselect All");
/*
    Set the event handlers/callbacks along with client data and widget IDs.
*/
	mouse_context.num_elements = 3;
	mouse_context.event_handler = FALSE;
	mouse_context.nonmaskable = FALSE;
	(mouse_context.element_handlers)[0] = fill_select; 
	(mouse_context.element_handlers)[1] = fill_unselect; 
	(mouse_context.element_handlers)[2] = fill_unselect_all; 
	mouse_context.client_data[0] = NULL; 
	mouse_context.client_data[1] = NULL; 
	mouse_context.client_data[2] = NULL; 
	mouse_context.num_widget_ids = 3;
	mouse_context.event_widgets[0] = main_image_bulletinboard;
	mouse_context.event_widgets[1] = fullres_win_bulletinboard;
	mouse_context.event_widgets[2] = zoom_win_bulletinboard;
	(mouse_context.activate_callback) = NULL;
	mouse_context.active_client_data = NULL;
/*
    Add the context.
*/
	XeContextAdd((XeContextWidget)context_mouse,mouse_context);
	break;
    }
}

void
xid_contextdel(context_num)
long	context_num;		/* Number of the XID context to add.  (I)
					0 - Image context (no manual cursor)
					1 - Image context (manual cursor)
					2 - Graphics Select context
					3 - Graphics Edit context (line, poly
					    rect)
					4 - Graphics Move/Delete context
					5 - Graphics Add context
					6 - Image/Profile context (manual)
					7 - Fill context		      */
/*******************************************************************************
Purpose:
    This routine removes the specified context. 

By L. Huewe, USGS/EROS Data Center, 1/93

Modified by L. Huewe, USGS/EROS Data Center, 3/94
    - Added support for the manual profile context.

Algorithm Description:
*******************************************************************************/
{
switch (context_num)
    {
    case 0:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_IMAGE]);
	break;
    case 1:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_IMAGE2]);
	break;
    case 2:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_GRSEL]);
	break;
    case 3:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_GREDIT]);
	break;
    case 4:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_GRMVDEL]);
	break;
    case 5:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_GRADD]);
	break;
    case 6:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_PROFILE]);
	break;
    case 7:
	XeContextRemove((XeContextWidget)context_mouse,
	    context_names[CON_FILL]);
	break;
    }
}
