#include "xid.h"

graphics_rubberband(w,xcursor,ycursor,plane_idx)
Widget  w;				/* Widget ID.  (I)	   	      */

int	plane_idx,     			/* Index to the currently viewed 
					   image.                             */
	xcursor,			/* X cursor position.  (I)	      */
	ycursor;			/* Y cursor position.  (I)	      */

/*******************************************************************************
Purpose:
	This routine draws the appropriate rubber-band line or rectangle
	based on the graphics mode the user is currently in.
 								
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
*******************************************************************************/
{
float           xfil,           /* X file coordinate.                         */
                yfil;           /* Y file coordinate.                         */
 
long		height,         /* Rectangle height.                          */
                nl,             /* Number of lines in zoomed image.           */
                ns,             /* Number of samples in zoomed image.         */
		width,          /* Rectangle width.                           */
		win;            /* Window event was triggered from.           */

if ((xid_graphics.flags & GR_ACTIVE) && (xid_graphics.flags & GR_LABEL)) 
    {
/*
    Erase the previous rubber-band rectangle.
*/
    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	JoinMiter);
    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
    XSetFunction(xid.display,xid_graphics.gc,GXxor);
    if ((xid_label.x != -1) && (xid_label.y != -1))
	XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,xid_label.x,
	    xid_label.y,xid_label.width,xid_label.height);

/*
    Set the new rectangle (in window coordinates).
*/
        xid_label.x = xcursor;
        xid_label.y = ycursor;

/*
    Draw the new rubber-band rectangle.
*/
    if (xid_label.x != -1)
	XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,xid_label.x,
	    xid_label.y,xid_label.width,xid_label.height);
    }
/*
    If the graphics window is active, determine whether or not to draw a 
    "rubber-banded" line.
*/
else if ((xid_graphics.flags & GR_ACTIVE) && (xid_graphics.flags & GR_SELECT)) 
    {
/*
    Determine which window is currently active.
*/
    if (w == main_image_bulletinboard)
	win = 0;
    else if (w == fullres_win_bulletinboard)
	win = 1;
    else if (w == zoom_win_bulletinboard)
	win = 2;

    if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	{
/*
    Erase the previous rubber-band line.
*/
	XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	    JoinMiter);
	XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	XSetFunction(xid.display,xid_graphics.gc,GXxor);
	if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		selectx,xid_graphics.selecty,xid_graphics.prevx,xid_graphics.
		prevy);
/*
    Set the last selected point (in window coordinates) if it is not currently
    set, based on the window the pointer is in. 
*/
	if ((w == main_image_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    xid_file2win(plane_idx,0,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);

	if ((w == fullres_win_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    {
	    xid_file2win(plane_idx,1,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);
/*
    Make sure this point is within the bounds of the full resolution window.
*/
	    if ((xid_graphics.selectx < 0) || (xid_graphics.selecty < 0))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    if ((xid_graphics.selectx > xid_fullres[0].dspwin[NS]) || 
		(xid_graphics.selecty > xid_fullres[0].dspwin[NL]))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    }

	if ((w == zoom_win_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    {
	    xid_file2win(plane_idx,2,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);
/*
    Make sure this point is within the bounds of the zoom window.
*/
	    if ((xid_graphics.selectx < 0) || (xid_graphics.selecty < 0))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    nl = xid_zoom.parms.factor * xid_zoom.parms.in_lines;
	    ns = xid_zoom.parms.factor * xid_zoom.parms.in_samps;
	    if ((xid_graphics.selectx > ns) || (xid_graphics.selecty > nl))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    }

/*
    Draw the new rubber band line.
*/
	if (xid_graphics.selectx != -1)
	    {
	    if (w != zoom_win_bulletinboard)
		{
		XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		    selectx,xid_graphics.selecty,xcursor,ycursor);
		xid_graphics.prevx = xcursor;
		xid_graphics.prevy = ycursor;
		}
	    else
		{
		xid_win2file(plane_idx,2,xcursor,ycursor,&xfil,&yfil);
		xid_file2win(plane_idx,2,xfil,yfil,&xid_graphics.prevx,
		    &xid_graphics.prevy);
		XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		    selectx,xid_graphics.selecty,xid_graphics.prevx,
		    xid_graphics.prevy);
		}
	    }
	}
    else if (xid_graphics.type == RECT)
	{
/*
    Erase the previous rubber-band rectangle.
*/
	XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	    JoinMiter);
	XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	XSetFunction(xid.display,xid_graphics.gc,GXxor);
	if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	    {
	    width = xid_graphics.prevx - xid_graphics.selectx;
	    height = xid_graphics.prevy - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
	        XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		    xid_graphics.selectx,xid_graphics.selecty,width,height);
	    }
/*
    Set the last selected point (in window coordinates) if it is not currently
    set, based on the window the pointer is in. 
*/
	if ((w == main_image_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    xid_file2win(plane_idx,0,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);

	if ((w == fullres_win_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    {
	    xid_file2win(plane_idx,1,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);
/*
    Make sure this point is within the bounds of the full resolution window.
*/
	    if ((xid_graphics.selectx < 0) || (xid_graphics.selecty < 0))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    if ((xid_graphics.selectx > xid_fullres[0].dspwin[NS]) || 
		(xid_graphics.selecty > xid_fullres[0].dspwin[NL]))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    }

	if ((w == zoom_win_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    {
	    xid_file2win(plane_idx,2,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);
/*
    Make sure this point is within the bounds of the zoom window.
*/
	    if ((xid_graphics.selectx < 0) && (xid_graphics.selecty < 0))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    nl = xid_zoom.parms.factor * xid_zoom.parms.in_lines;
	    ns = xid_zoom.parms.factor * xid_zoom.parms.in_samps;
	    if ((xid_graphics.selectx > ns) || (xid_graphics.selecty > nl))
		xid_graphics.selectx = xid_graphics.selecty = -1;
	    }

/*
    Draw the new rubber band rectangle.
*/
	if (xid_graphics.selectx != -1)
	    {
	    width = xcursor - xid_graphics.selectx;
	    height = ycursor - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
		{
		XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		    xid_graphics.selectx,xid_graphics.selecty,width,height);
		xid_graphics.prevx = xcursor;
		xid_graphics.prevy = ycursor;
		}
	    else
		xid_graphics.prevx = xid_graphics.prevy = -1;
	    }
	}
    }
else if ((xid_graphics.flags & GR_ACTIVE) && (xid_graphics.flags & GR_EDIT) &&
    (xid_editgraph.flags & GR_MOVE)) 
    {
/*
    Determine the currently active window.
*/
    if (w == main_image_bulletinboard)
	win = 0;
    else if (w == fullres_win_bulletinboard)
	win = 1;
    else if (w == zoom_win_bulletinboard)
	win = 2;

    if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	{
/*
    Erase the previous rubber-band lines.
*/
	XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	    JoinMiter);
	XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	XSetFunction(xid.display,xid_graphics.gc,GXxor);
	if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
	    (xid_editgraph.vert != -1))
	    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
		prevx,xid_editgraph.prevy,xid_editgraph.newx,xid_editgraph.
		newy);
	if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) && 
	    (xid_editgraph.vert != -1))
	    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
		nextx,xid_editgraph.nexty,xid_editgraph.newx,xid_editgraph.
		newy);
/*
    Set the next and previous points (in window coordinates) if they are not 
    currently set, based on the window the pointer is in. 
*/
	if ((w == main_image_bulletinboard) && (xid_editgraph.prevx == -1))
	    xid_file2win(plane_idx,0,xid_editgraph.fxprev,xid_editgraph.fyprev,
		&xid_editgraph.prevx,&xid_editgraph.prevy);
	if ((w == main_image_bulletinboard) && (xid_editgraph.nextx == -1))
	    xid_file2win(plane_idx,0,xid_editgraph.fxnext,xid_editgraph.fynext,
		&xid_editgraph.nextx,&xid_editgraph.nexty);
	if ((w == fullres_win_bulletinboard) && (xid_editgraph.prevx == -1))
	    {
	    xid_file2win(plane_idx,1,xid_editgraph.fxprev,xid_editgraph.fyprev,
		&xid_editgraph.prevx,&xid_editgraph.prevy);
	    }
	if ((w == fullres_win_bulletinboard) && (xid_editgraph.nextx == -1))
	    {
	    xid_file2win(plane_idx,1,xid_editgraph.fxnext,xid_editgraph.fynext,
		&xid_editgraph.nextx,&xid_editgraph.nexty);
	    }
	if ((w == zoom_win_bulletinboard) && (xid_editgraph.prevx == -1))
	    {
	    xid_file2win(plane_idx,2,xid_editgraph.fxprev,xid_editgraph.fyprev,
		&xid_editgraph.prevx,&xid_editgraph.prevy);
	    }
	if ((w == zoom_win_bulletinboard) && (xid_editgraph.nextx == -1))
	    {
	    xid_file2win(plane_idx,2,xid_editgraph.fxnext,xid_editgraph.fynext,
		&xid_editgraph.nextx,&xid_editgraph.nexty);
	    }
/*
    Draw the new rubber band lines.
*/
	if (xid_editgraph.vert != -1)
	    {
	    xid_editgraph.newx = xcursor;
    	    xid_editgraph.newy = ycursor;
	    if (w != zoom_win_bulletinboard)
		{
		if ((xid_editgraph.prevx != -1) && (xid_editgraph.prevy != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.prevx,xid_editgraph.prevy,xid_editgraph.
			newx,xid_editgraph.newy);
		if ((xid_editgraph.nextx != -1) && (xid_editgraph.nexty != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.nextx,xid_editgraph.nexty,xid_editgraph.
			newx,xid_editgraph.newy);
		}
	    else
		{
		xid_win2file(plane_idx,2,xid_editgraph.newx,xid_editgraph.newy,
		    &xfil,&yfil);
		xid_file2win(plane_idx,2,xfil,yfil,&xid_editgraph.newx,
		    &xid_editgraph.newy);
		if ((xid_editgraph.prevx != -1) && (xid_editgraph.prevy != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.prevx,xid_editgraph.prevy,xid_editgraph.
			newx,xid_editgraph.newy);
		if ((xid_editgraph.nextx != -1) && (xid_editgraph.nexty != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.nextx,xid_editgraph.nexty,xid_editgraph.
			newx,xid_editgraph.newy);
		}
	    }
	}
/*
    For points, there are no rubber-band lines to draw. However, make sure
    the current cursor position is set.
*/
    else if (xid_graphics.type == POINT)
	{
	if (xid_editgraph.vert != -1)
	    {
	    xid_editgraph.newx = xcursor;
    	    xid_editgraph.newy = ycursor;
	    }
	}
    else if (xid_graphics.type == RECT)
	{
/*
    Erase the previous rubber-band rectangle.
*/
	XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	    JoinMiter);
	XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	XSetFunction(xid.display,xid_graphics.gc,GXxor);
	if ((xid_editgraph.new_ulx != -1) && (xid_editgraph.new_uly != -1) && 
	    (xid_editgraph.width != -1) && (xid_editgraph.height != -1))
	    {
	    XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		xid_editgraph.new_ulx,xid_editgraph.new_uly,xid_editgraph.width,
		xid_editgraph.height);
	    }
/*
    Set the last selected point (in window coordinates) if it is not currently
    set, based on the window the pointer is in. 
*/
	if ((w == main_image_bulletinboard) && (xid_editgraph.new_ulx == -1))
	    xid_file2win(plane_idx,0,xid_editgraph.ulx,xid_editgraph.
		uly,&xid_editgraph.new_ulx,&xid_editgraph.new_uly);
	if ((w == main_image_bulletinboard) && (xid_editgraph.prevx == -1))
	    xid_file2win(plane_idx,0,xid_editgraph.fxprev,xid_editgraph.
		fyprev,&xid_editgraph.prevx,&xid_editgraph.prevy);
	if ((w == main_image_bulletinboard) && (xid_editgraph.nextx == -1))
	    xid_file2win(plane_idx,0,xid_editgraph.fxnext,xid_editgraph.
		fynext,&xid_editgraph.nextx,&xid_editgraph.nexty);

	if ((w == fullres_win_bulletinboard) && (xid_editgraph.new_ulx == -1))
	    xid_file2win(plane_idx,1,xid_editgraph.ulx,xid_editgraph.
		uly,&xid_editgraph.new_ulx,&xid_editgraph.new_uly);
	if ((w == fullres_win_bulletinboard) && (xid_editgraph.prevx == -1))
	    xid_file2win(plane_idx,1,xid_editgraph.fxprev,xid_editgraph.
		fyprev,&xid_editgraph.prevx,&xid_editgraph.prevy);
	if ((w == fullres_win_bulletinboard) && (xid_editgraph.nextx == -1))
	    xid_file2win(plane_idx,1,xid_editgraph.fxnext,xid_editgraph.
		fynext,&xid_editgraph.nextx,&xid_editgraph.nexty);

	if ((w == zoom_win_bulletinboard) && (xid_editgraph.new_ulx == -1))
	    xid_file2win(plane_idx,2,xid_editgraph.ulx,xid_editgraph.
		uly,&xid_editgraph.new_ulx,&xid_editgraph.new_uly);
	if ((w == zoom_win_bulletinboard) && (xid_editgraph.prevx == -1))
	    xid_file2win(plane_idx,2,xid_editgraph.fxprev,xid_editgraph.
		fyprev,&xid_editgraph.prevx,&xid_editgraph.prevy);
	if ((w == zoom_win_bulletinboard) && (xid_editgraph.nextx == -1))
	    xid_file2win(plane_idx,2,xid_editgraph.fxnext,xid_editgraph.
		fynext,&xid_editgraph.nextx,&xid_editgraph.nexty);

/*
    Draw the new rubber band rectangle.
*/
	if (xid_editgraph.new_ulx != -1)
	    {
	    switch (xid_editgraph.vert)
		{
		case 0:
		    xid_editgraph.new_ulx = xcursor;
		    xid_editgraph.new_uly = ycursor;
		    xid_editgraph.width = xid_editgraph.nextx - xcursor;
		    xid_editgraph.height = xid_editgraph.prevy - ycursor;
		    break;
		case 1:
		    xid_editgraph.new_ulx = xid_editgraph.prevx;
		    xid_editgraph.new_uly = ycursor;
		    xid_editgraph.width = xcursor - xid_editgraph.prevx;
		    xid_editgraph.height = xid_editgraph.nexty - ycursor; 
		    break;
		case 2:
		    xid_file2win(plane_idx,win,xid_editgraph.ulx,xid_editgraph.
			uly,&xid_editgraph.new_ulx,&xid_editgraph.new_uly);
		    xid_editgraph.width = xcursor - xid_editgraph.new_ulx;
		    xid_editgraph.height = ycursor - xid_editgraph.new_uly;
		    break;
		case 3:
		    xid_editgraph.new_ulx = xcursor; 
		    xid_editgraph.new_uly = xid_editgraph.nexty;
		    xid_editgraph.width = xid_editgraph.prevx - xcursor;
		    xid_editgraph.height = ycursor - xid_editgraph.nexty;
		    break;
		}
	    if ((xid_editgraph.width > 0) && (xid_editgraph.height > 0))
		{
		XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		    xid_editgraph.new_ulx,xid_editgraph.new_uly,
		    xid_editgraph.width,xid_editgraph.height);
		xid_editgraph.newx = xcursor;
		xid_editgraph.newy = ycursor;
		}
	    else
		xid_editgraph.new_ulx = xid_editgraph.new_uly = -1;
	    }
	}
    }
else if ((xid_graphics.flags & GR_ACTIVE) && (xid_graphics.flags & GR_EDIT)
    && (xid_editgraph.flags & GR_ADD)) 
    {
/*
    Determine the currently active window.
*/
    if (w == main_image_bulletinboard)
	win = 0;
    else if (w == fullres_win_bulletinboard)
	win = 1;
    else if (w == zoom_win_bulletinboard)
	win = 2;

    if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	{
/*
    Erase the previous rubber-band line.
*/
	XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	    JoinMiter);
	XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	XSetFunction(xid.display,xid_graphics.gc,GXxor);
        if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
            (xid_editgraph.vert != -1))
            XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
                prevx,xid_editgraph.prevy,xid_editgraph.newx,xid_editgraph.
                newy);
       if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) &&
            (xid_editgraph.vert != -1))
            XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
                nextx,xid_editgraph.nexty,xid_editgraph.newx,xid_editgraph.
                newy);
/*
    Set the last selected point (in window coordinates) if it is not currently
    set, based on the window the pointer is in. 
*/
	if ((w == main_image_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    xid_file2win(plane_idx,0,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);

	if ((w == fullres_win_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    xid_file2win(plane_idx,1,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);

	if ((w == zoom_win_bulletinboard) && (xid_graphics.temp_num > 0) &&
	    (xid_graphics.selectx == -1))
	    xid_file2win(plane_idx,2,(float)xid_graphics.cur->x,
		(float)xid_graphics.cur->y,&xid_graphics.selectx,
		&xid_graphics.selecty);

/*
    Set the next and previous points (in window coordinates) if they are not
    currently set, based on the window the pointer is in.
*/
	if ((w == main_image_bulletinboard) && (xid_editgraph.prevx == -1))
	    xid_file2win(plane_idx,0,xid_editgraph.fxprev,xid_editgraph.fyprev,
		&xid_editgraph.prevx,&xid_editgraph.prevy);
        if ((w == main_image_bulletinboard) && (xid_editgraph.nextx == -1))
            xid_file2win(plane_idx,0,xid_editgraph.fxnext,xid_editgraph.fynext,
                &xid_editgraph.nextx,&xid_editgraph.nexty);
	if ((w == fullres_win_bulletinboard) && (xid_editgraph.prevx == -1))
	    xid_file2win(plane_idx,1,xid_editgraph.fxprev,xid_editgraph.fyprev,
		&xid_editgraph.prevx,&xid_editgraph.prevy);
        if ((w == fullres_win_bulletinboard) && (xid_editgraph.nextx == -1))
            xid_file2win(plane_idx,1,xid_editgraph.fxnext,xid_editgraph.fynext,
                &xid_editgraph.nextx,&xid_editgraph.nexty);
        if ((w == zoom_win_bulletinboard) && (xid_editgraph.prevx == -1))
            xid_file2win(plane_idx,2,xid_editgraph.fxprev,xid_editgraph.fyprev,
                &xid_editgraph.prevx,&xid_editgraph.prevy);
        if ((w == zoom_win_bulletinboard) && (xid_editgraph.nextx == -1))
            xid_file2win(plane_idx,2,xid_editgraph.fxnext,xid_editgraph.fynext,
                &xid_editgraph.nextx,&xid_editgraph.nexty);
/*
    Draw the new rubber band lines.
*/
	if (xid_editgraph.vert != -1)
	    {
	    xid_editgraph.newx = xid_graphics.prevx = xcursor;
    	    xid_editgraph.newy = xid_graphics.prevy = ycursor;
	    if (w != zoom_win_bulletinboard)
		{
		if ((xid_editgraph.prevx != -1) && (xid_editgraph.prevy != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.prevx,xid_editgraph.prevy,xid_editgraph.
			newx,xid_editgraph.newy);
		if ((xid_editgraph.nextx != -1) && (xid_editgraph.nexty != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.nextx,xid_editgraph.nexty,xid_editgraph.
			newx,xid_editgraph.newy);
		}
	    else
		{
		xid_win2file(plane_idx,2,xid_editgraph.newx,xid_editgraph.newy,
		    &xfil,&yfil);
		xid_file2win(plane_idx,2,xfil,yfil,&xid_editgraph.newx,
		    &xid_editgraph.newy);
		if ((xid_editgraph.prevx != -1) && (xid_editgraph.prevy != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.prevx,xid_editgraph.prevy,xid_editgraph.
			newx,xid_editgraph.newy);
		if ((xid_editgraph.nextx != -1) && (xid_editgraph.nexty != -1))
		    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
			xid_editgraph.nextx,xid_editgraph.nexty,xid_editgraph.
			newx,xid_editgraph.newy);
		}
	    }
	}
    }
}

graphics_updateatt(element_idx)
int	element_idx;     		/* Graphics element index attribute 
					   values are to be read from.	      */

/*******************************************************************************
Purpose:
	This routine reads the GOF header record and updates the "Set 
	Attributes" panel.
 								
By L. Huewe, USGS/EROS Data Center, 11/92

Algorithm Description:
*******************************************************************************/
{
union   GOF     header;         /* Header record structure.                   */

	long	i,		/* Looping index.			      */
		nbytes,         /* Number of bytes actually read.             */
                next,           /* Number of bytes to next record.            */
                status,         /* Status indicator.                          */
                type = HDR;     /* Type of GOF record to read.
                                   created.                                   */

/*
    Reset the file pointer to the beginning of the file.
*/
    lseek (xid_graphics.fd,0,0);

/*
    Read the header record from the GOF.
*/
    status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&type,&header);
    if (status != E_SUCC)
	{
	xid_message("Error reading GOF");
	return;
	}
/*
    Read the attribute names from the header record.
*/
    for (i=0; i < MAXATT; i++)
	if (header.hdrec.mask[i] != 0)
	    XmTextSetString(setatt_att_text[i],xid_element[element_idx].
		attributes[i]);
}

graphics_realloc()
/*******************************************************************************
Purpose:
	This routine allocates more space for storing graphics elements.  
	Storage is allocated for MAXELEMENT graphics elements at a time.
 								
By L. Huewe, USGS/EROS Data Center, 2/93

Algorithm Description:
*******************************************************************************/
{
long	i,j,				/* Loopint variables.		      */
	num_bytes;			/* Number of bytes to allocate.       */

/*
    Increase the maximum number of graphics elements.
*/
xid_graphics.max_element += MAXELEMENT;

/*
    Allocate new space for graphics elements.
*/
num_bytes = xid_graphics.max_element * sizeof(struct GRAPH);
xid_element = (struct GRAPH *)realloc(xid_element,num_bytes);
if (xid_element == NULL)
    {
    xid_message("Insufficient memory available");
    return(XID_F);
    }
/*
    Initialize new element fields.
*/
for (i=xid_graphics.current; i < xid_graphics.max_element; i++)
    {
    xid_element[i].type = NO_TYPE;
    xid_element[i].offset = xid_element[i].writeflg = xid_element[i].color =
        xid_element[i].font = 0;
    xid_element[i].x = xid_element[i].y = -1;
    xid_element[i].labelx = xid_element[i].labely = -1;
    xid_element[i].upleft[0] = xid_element[i].upleft[1] = 0.0;
    xid_element[i].loright[0] = xid_element[i].loright[1] = 0.0;
    for (j=0; j < MAXATT; j++)
        strcpy(xid_element[i].attributes[j],"");
    strcpy(xid_element[i].label,"");
    xid_element[i].graph_ptr = NULL;
    }
return(XID_S);
}
