/*****************************************************************************
FUNCTION:	4DIGITYR

PURPOSE:	Convert a 2/3-digit year to 4 digits

Version  Date	Programmer	Modifications
-------  -----	---------------	---------------------------------------------
  1.0    07/98	D.Lloyd		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under TAE

PROJECT:	LAS
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "util.h"


void main
(void)
{
struct	PARBLK	vblock;		/* pointer to TAE parameter block	*/
long	std_out;		/* LUN to standard output		*/
struct	VARIABLE *var;		/* pointer to TAE variable in vblock	*/
long	year;			/* local year variable			*/
long	status;			/* function return status		*/


/*
  Initialize LAS
-----------------*/
c_inlas( &vblock, &std_out );


/*
  Get the input year
--------------------*/
var = p_find( &vblock, "INYEAR" );
year = IVAL( *var, 0 );

/*
  Convert the year
------------------*/
year = c_4digityr( year );

/*
  Return the year
------------------*/
status = q_intg( &vblock, "OUTYEAR", 1,(int *) &year, P_UPDATE );
if ( status != SUCCESS )
  c_lasmsg( TRUE, "4digityr-update", "Error updating variable block" );
status = q_out( &vblock );
if ( status != SUCCESS )
    c_lasmsg( TRUE, "4digityr-update", "Error updating variable block" );

/*
  Exit without standard completion message
-------------------------------------------*/
z_exit( 1, "" );

}
