#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block            */
    char taein[][CMLEN],	/* pointer to input TAE file descriptor      */
    char hosin[][CMLEN],	/* pointer to input host file descriptor     */
    char taeout[][CMLEN],       /* pointer to output TAE file descriptor     */
    char hosout[][CMLEN],       /* pointer to output host file descriptor    */
    long *nmrimg,		/* number of input images                    */
    long (*window)[4],		/* window specifications for each input image*/
    long (*bands)[MAXBND+1],	/* band specifications for each input image  */
    long *nbands,		/* number of bands per input image           */
    long *totbnd,		/* total number of bands to be processed     */
    long *odtype,		/* output data type                          */
    long *msgtim,		/* elapsed time between display messages     */
    char *minmax		/* min max flag buffer                       */
);

void process
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block            */
    char hosin[][CMLEN],        /* pointer to input host file descriptor     */
    char hosout[CMLEN],		/* pointer to output host file descriptor    */
    long *nmrimg,		/* number of input images                    */
    long (*window)[4],		/* window specification of input images      */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long *totbnd,		/* total number of bands to be processed     */
    long odtype,		/* data type of output image                 */
    long msgtim,		/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);

#endif
