/******************************************************************************
NAME:	ADD2STAT

PURPOSE: Combines some or all of the classes contained in one
         statistics file with those of a different statistics file.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          2-Jun-83  K. Mcgee
   2          4-Oct-88  K. A. Narayanan    
   3          6-Feb-89  K. A. Narayanan    conversion to 5.0
   4         28-AUG-92  D. Etrheim	   Cleanup of global include file.  
					   Check status of c_getnam in getpar.c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:
   Call GETPAR to get parameters
   Call COPY_BASE to copy base statistics file to output
   Call ADD_PICK to pick selected classes from pick stats file
   and add to output stats file

*****************************************************************************
*/
#include <stdio.h>

#include "las.h"
#include "statio.h"
#include "util.h"
#include "protos.h"

/* Globals */
struct PARBLK block;                 /* TAE parameter block        */

FILE *	fd_pick;
FILE *	fd_base;
FILE *	fd_out;

void main
(void)
{
long	numclass_pick,          /* no. classes in pick stats file    */
	numclass_out,           /* no. classes in output stats file  */
	numclass_req;           /* no. classes to be picked          */

char	hos_stout[1][CMLEN],/* output stats file host name       */
	hos_stpick[CMLEN],      /* pick stats file host name         */
	hos_stbase[CMLEN],      /* base stats file host name         */
	las_stout[1][CMLEN],    /* output stats file las name        */
	runtype[12];            /* batch/interactive indicator       */
long    one = 1;

/*
get tae parameters
------------------
*/
getpar(hos_stbase, hos_stpick, las_stout[0], hos_stout[0], &numclass_req, runtype);

/*
copy base stats file to output stats file
-----------------------------------------
*/
copy_base (hos_stbase, hos_stpick, hos_stout[0], &numclass_req, &numclass_pick, 
         &numclass_out);

/*
add selected classes from pick file to output stats file
--------------------------------------------------------
*/
add_pick (hos_stout, &numclass_req, numclass_pick, 
          &numclass_out, runtype);

/*
issue completion message
------------------------
*/
c_complt ("ADD2STAT", las_stout, &one); 
}
