#include <string.h>
#include "add2stat.h"
#include "util.h"
#include "protos.h"


void getpar
(
    char hos_stbase[],        /* base file host name              */
    char hos_stpick[],        /* pick file host name              */
    char las_stout[],         /* output file image las name       */
    char hos_stout[],         /* output file host name            */
    long *num_classes,
    char runtype[]
)
/*
***************************************************************************

NAME: GETPAR

PURPOSE: Get parameters

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   2.0         23-nov-88   k. a. narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:
   Initialize las
   Get globals

***************************************************************************
*/
{
struct  VARIABLE *var;              /* pointer to a variable in TAE block */

long	access,
	stat,
	std_out;                    /* logical unit for standard output   */

long    fatal_err = -1;
long    zero = 0;

/*
initialize program 
------------------
*/
c_inlas (&block, &std_out); 

/*
get input base statistics file & statistics file
from which classes are to be selected
------------------------------------------------
*/
access = IREAD;
stat = c_getnam (&block, "BASESTAT", &zero, hos_stbase, "stat", &access);
if (stat != E_SUCC)
   c_errmsg ("Fatal error encountered", "add2stat-fatal", &fatal_err);
stat = c_getnam (&block, "PICKSTAT", &zero, hos_stpick, "stat", &access);
if (stat != E_SUCC)
   c_errmsg ("Fatal error encountered", "add2stat-fatal", &fatal_err);

/*
get output statistics file
--------------------------
*/
access = IWRITE;
stat = c_getnam (&block, "OUTSTAT", &zero, hos_stout, "stat", &access);
if (stat != E_SUCC)
   c_errmsg ("Error getting output statistics file name", "add2stat-outstat",
             &fatal_err);
strcpy(las_stout, hos_stout);
/*
get # of classes
----------------
*/
var = p_find (&block, "NCLASS");
*num_classes = IVAL (*var, 0);

var = p_find (&block, "$RUNTYPE");
strcpy (runtype, SVAL(*var, 0));
/*
abort if batch process and not processing all classes
-----------------------------------------------------
*/
if (runtype[0] == 'B'  &&  *num_classes !=  0)
   c_errmsg ("ADD2STAT cannot be run in batch with nonzero NCLASS", 
             "add2stat-batch", &fatal_err);
}
