#ifndef PROTOS_H
#define PROTOS_H

void applylut
(
    char hosin[][CMLEN],	/* input image host name		*/
    char hosout[],	/* output image host name		*/
    long num_inbands,	/* no. bands				*/
    long band_num[],	/* band numbers				*/
    long wind[],		/* image window				*/
    float lookup[][256]	/* lookup table radiance values		*/
);

void filspec
(
    char hosin[][CMLEN],      /* input image host name              */
    char hosout[][CMLEN],     /* output image host name             */
    long *num_bands,          /* number of bands in each input image*/
    long band_num[][MAXBND+1],/* band numbers                       */
    long wind[][4]            /* input image windows                */
);

void getlut
(
    float lookup[][256],	/* look up table with radiance values	*/
    long dark[],		/* dark values specified by the user	*/
    double sunang,		/* sun angle				*/
    long sat_code,	/* satellite identification code	*/
    long num_bands,	/* no. bands in input image		*/
    long band_num[]	/* band numbers				*/
);

void getpar
(
    char hosin[][CMLEN],      /* input image host names           */
    char lasout[][CMLEN],     /* output image las name            */
    char hosout[][CMLEN],     /* output image host name           */
    long image_band_num[][MAXBND+1], /* image band numbers               */
    long *num_inbands,        /* number of input image bands      */
    long wind[][4],             /* input image window               */
    long *satellite_code,     /* satellite identification         */
    float *sunang,             /* sun angle                        */
    long dark[]              /* dark values                      */
);

#endif

