
/******************************************************************************
NAME:    ANNOCHK
PURPOSE: program main()
	 Checks program parameters

ALGORITHM DESCRIPTION:
   Call GETPAR to check parameters from TAE
******************************************************************************/

#include "las.h"    /* las header file */ 
#define GLOBALVARS  /* defined only for main(), flags iovars.h */ 
#include "iovars.h" /* declare variables for image IO */ 
#include "annotate.h"

void main
(void) 
{
float	bgrey;			/* background grey value	  */
float	cgrey[MAX_ANNOTATIONS]; /* character grey value           */

long	first = TRUE;           /* controls checking parameters   */
static long	image_band_num[MAXIMG][MAXBND + 1]; 
	                        /* band numbers in each input image*/
long	nlout;			/* output no. lines               */
long	nsout;			/* output no. samples per line 	  */
static long	num_image_bands[MAXIMG];/* number of bands in each input image*/
long	num_inimages;           /* number of input images         */
long	num_strings;		/* no. annotation strings         */
long	scale[MAX_ANNOTATIONS];	/* scale factors for strings      */
long	sl[MAX_ANNOTATIONS];	/* line positions for text strings*/
long	sp[MAX_ANNOTATIONS];	/* pixel positions for strings    */
long	textlen[MAX_ANNOTATIONS];      /* lengths of text strings */
long    use_bgrey;              /* flag, use bgrey? = T or F      */ 
long    cellwide;               /* width of each font character   */
long    cellhigh;               /* heigth of each font character  */

char	direct[MAX_ANNOTATIONS][5];    /* direction for strings	  */
static char	lasin[MAXIMG][CMLEN];  /* input images host names */
static char	hosin[MAXIMG][CMLEN];  /* input images host names */
char	subcmd[10];		/* subcommand			  */
char    font[6];                /* font specified by user         */
static char text[MAX_ANNOTATIONS][264];	/* annotation text strings*/

/* check input parameters
-------------------------*/
getpar (first, lasin, hosin, &num_inimages, num_image_bands, image_band_num, 
       &nlout, &nsout, sp, sl, scale, direct, &use_bgrey, &bgrey, cgrey, 
       text, textlen, &num_strings, subcmd, font, &cellwide, &cellhigh);
}





