#ifndef ANNOTATE_H
#define ANNOTATE_H
#define MAX_ANNOTATIONS 20

#include "ccell.h"

long bit
(
    unsigned int word,      	/* I: source word	       */
    int pos 			/* I: position of bit to check */
);

void filspec
(
    char hosin[][CMLEN],      /* I: input image host names             */
    long num_inimages,        /* I: number of input images             */
    long *nlout,              /* I: no. lines in image                 */
    long *nsout,              /* I: no. samples/line in image          */
    long *image_type	      /* O: image data type                    */
);

void genchr
(
    float iobuf[],        	/* I/O : output line 			*/
    long *vcnt, 	        /* I: current line count on the picture */
    struct CCELL *ccell,  	/* I: input info on the character cell  */
    char chrbuf[],        	/* I: character(s) to be expanded       */
    char font[],
    long cellwide,
    long cellhigh
);

void getpar
(
    long first,                     /* I: controls parameter checking         */
    char lasin[][CMLEN],            /* O: input image las names               */
    char hosin[][CMLEN],            /* O: images host names                   */
    long *num_inimages,             /* O: number of input images              */
    long num_image_bands[],         /* O: number of bands in each input image */
    long image_band_num[][MAXBND + 1], /* O: band numbers in each input image */
    long *nlout,                    /* O: output no. lines                    */
    long *nsout,                    /* O: output no. samples per line         */
    long sp[],                      /* O: annotation pixel positions          */
    long sl[],                      /* O: annotation line positions           */
    long scale[],                   /* O: scale factors for strings           */
    char direct[][5],               /* O: direction for annotation            */
    long *use_bgrey,                /* O: flag, use bgrey 	              */
    float *bgrey,                   /* O: background grey value               */
    float cgrey[],                  /* O: character grey value                */
    char text[][264],               /* O: annotation text                     */
    long textlen[],                 /* O: lengths of strings                  */
    long *num_strings,              /* O: no. strings                         */
    char subcmd[],                  /* O: subcommand to execute               */
    char font[],                    /* O: size of font specified by user      */
    long *cellwide,                 /* O: width of each font character        */
    long *cellhigh                  /* O: heigth of each font character       */
);

void put_string
(
    long sp[],			/* I: pixel positions for strings       */
    long sl[],			/* I: line positions for strings	*/
    long textlen[],		/* I: lengths of annotation strings     */
    long scale[],		/* I: scale factors for strings	        */
    long use_bgrey,      	/* I: flag, use bgrey? = T or F	        */
    double bgrey,		/* I: background grey level	        */
    float fgrey[],		/* I: character grey level		*/
    char direction[][5], 	/* I: annotation direction 	        */
    char string[][264],		/* I: annotation strings		*/
    long *num_strings,		/* I: no. annotation strings        	*/
    long num_inimages,		/* I: no. input images		        */
    long num_image_bands[], 	/* I: no. bands in images	        */
    long image_band_num[][MAXBND+1], /* I: image band numbers           */
    long *nsout,		/* I: no. samples/line 		        */
    long *image_type,		/* I: image data type		        */
    char font[],                /* I: size of font specified by user    */
    long cellwide,              /* I: width of each font character      */
    long cellhigh               /* I: heigth of each font character     */
);
#endif
