
/******************************************************************************
NAME:	  bit()
FUNCTION: picks a bit value in a given long word

ALGORITHM: check for valid bit range
           perform bitwise and with POSth bit of WORD
           return TRUE if bit is on, else return FALSE 
******************************************************************************/

#include "las.h"
#include "annotate.h"

long bit
(
    unsigned int word,          /* I: source word	       */
    int pos 			/* I: position of bit to check */
)

{
/* check if out of range.  condition was never met for this application */ 
   if (pos>32 || pos<1) 
      c_lasmsg (TRUE, "annotate-range", 
      "Program error:  exceeded bit range(1-32) value"); 

/* pick up byte value which includes desired bit */
   if ((1 << (pos - 1)) & word)
      return (TRUE);
   else
      return(FALSE);
}
