
/*******************************************************************************
NAME:     ccell.h 
PURPOSE:  definitions for character cells  
*******************************************************************************/

/* data structure that describes the character cell.  This structure replaces
   and extends what used to be a long array named tab or tb for table.  I was
   not able to determine what all table entries were for */ 
struct CCELL
   {
   long horizontal,  /* flag, if T, text will be horizontal, else vertical, 
			did not exist in table[] */ 
        nchars,      /* # of chars   in  this annotation string, was table[6] */
	nlines,      /* # of lines   for this annotation string, was table[2] */
	nsamps,      /* # of samples for this annotation string, was table[3] */
	sample,      /* sample on this image line,               was table[1] */
	table0,      /* unknown use,                             was table[0] */
	table7,      /* unknown use,                             was table[7] */
	table8,      /* unknown use,                             was table[8] */
	table9,      /* unknown use,                             was table[9] */
	use_back;    /* flag. if T, overwrite character background, did not 
			exist in table[] */ 
  float background,  /* background pixel value,                  was table[4] */
	foreground;  /* foreground pixel value,                  was table[5] */
  };


