
/***************************************************************************
NAME:    filspec()
PURPOSE: Set up file specifications
***************************************************************************/

#include "las.h"    /* las header file */ 
#include "iovars.h" /* declare variables for image IO */
#include "annotate.h"

void filspec
(
    char hosin[][CMLEN],      /* I: input image host names             */
    long num_inimages,        /* I: number of input images             */
    long *nlout,              /* I: no. lines in image                 */
    long *nsout,              /* I: no. samples/line in image          */
    long *image_type	      /* O: image data type                    */
)
{

/* declare variables */ 
   struct DDR ddr;
   long	access,  	      /* file access type */
	dtype=0,	      /* data type to open images as */ 
	n, nb, 
	opt[3];

/* open image files for random update access */
   nb = 0;
   access = IUPDATE;
   opt [0] = 0;
   opt [1] = NO_COMPRES;
   opt [2] = 0;
   if (c_getddr (hosin[0], &ddr) != E_SUCC)
      c_lasmsg (TRUE, "annotate-fatal", "Fatal error encountered"); 
   *image_type = ddr.dtype;

   for (n = 0; n < num_inimages; n++)
      if (c_eopenr ((struct FDESC **)&fdesc[n], hosin[n], &nb, &one, &one,
                     nlout, nsout, &access, &dtype, opt, &one) != E_SUCC )
	 c_lasmsg (TRUE, "annotate-fatal", "Fatal error encountered"); 
}
