#ifndef ARC2LAS_H
#define ARC2LAS_H

/******************************************************************************
Purpose: Function prototypes for the ARC2LAS module

Note: las.h MUST precede this include file!!!
      ---------------------------------------
*******************************************************************************/

int bit2byte
(
  char *gridbil,          /* I: Input BIL image                 */
  char *hostout,          /* I: Output LAS image                */
  long nbands,            /* I: Number of bands                 */
  long nbits,             /* I: Number of bits                  */
  long ns,                /* I: number of samples               */
  long nl,                /* I: number of lines                 */
  long msgtim,            /* I: Message processing time         */
  long bandbytes          /* I: Bytes per band                  */
);

void coordinates
(
  double xdim,            /* I: Cell size in the x dimension           */
  double ydim,            /* I: Cell size in the y dimension           */
  double b_rotation,      /* I: Rotation term to compute x'            */
  double d_rotation,      /* I: Rotation term to compute y'            */
  double ulxmap,          /* I: x coordinate for the upper left cell   */
  double ulymap,          /* I: y coordinate for the upper right cell  */
  struct DDR *ddr         /* O: DDR structure                          */
);

void getpar
(
  struct PARBLK *vblk,    /* I: TAE parameter block               */
  char out[CMLEN],        /* O: Input arguments                   */
  long *msgtim,           /* O: Message processing time           */
  long *ep3flag,          /* O: Arc 8.3/NO8.3 flag                */
  char *workspace,        /* O: Directory holding ARC information */
  char *geo_type,         /* O: geo dataset type                  */
  char *ingrid,           /* O: Name of the ARC image             */
  int *dtype,             /* O: LAS data type                     */
  int *nbands             /* O: number of bands in image          */
);

int getpath
(
  char *InfoFilePath,
  char *Item,
  char *stkpath
);

int lng2tae
(
  long data[],            /* I  - array of longs to transfer     */
  long skipf,             /* I  - skip factor                    */
  long num_longs,         /* I  - number of elements             */
  char varname[],         /* I  - tae name of variable           */
  long *result            /* O  - value of parameter             */
);

int proj2ddr
(
  struct DDR *ddr,        /* O: DDR structure to fill              */
  long ep3flag,           /* I: 8.3 naming flag                    */
  char *workspace,        /* I: Directory holding ARC information  */
  char *ingrid            /* I: Input ARC image                    */
);

void sep_shift
(
  unsigned char process[],
  unsigned char choutput[],
  long numprocess
);

void strip_num
(
  char *input,            /* I: Input string                               */
  char *return_val,       /* O: String to be returned                      */
  long *index             /* I/O: Current location of processing in input  */
);

#endif
