/* @(#)lci.c    1.0 4/3/93 */
/******************************************************************************
Program Name: getpath 

Purpose:      Get an INFO character string from a file.

Remarks:      This program uses lnfolib subroutines to access
              info files.

              The process is to:
                 see if the info file exists
                 open the file
                 see if the info item exists
                 get the defination of the info item
                 make sure the item is of type character
                 read a record
                 decode the record
                 closing the file
         write the record to an intermediate file
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "infolib/infolib.h"
#include "las.h"
#include "arc2las.h"

int getpath
(
  char *InfoFilePath,
  char *Item,
  char *stkpath
)
{
    InfoFile *FilePtr;
    InfoItemDef *ItemPtr;
    char RetString[4096];
    double RetDouble;
    long rec;
    char *p;

    /* check for error conditions
       if error print message and exit
       -------------------------------*/
    if (!InfoFileExists(InfoFilePath))
    {
        printf("\n   Info File %s does not exist.\n\n", InfoFilePath);
        return( -1 );
    }

    if ((FilePtr = InfoOpenFile(InfoFilePath,InfoWRITE )) == (InfoFile *) NULL)
    {
        printf("\n   Cannot open File %s with rw access.\n\n", InfoFilePath);
        return( -1 );
    }

    if (!InfoItemExists(FilePtr,Item))
    {
        printf("\n   Item %s does not exist.\n\n", Item);
        return( -1 );
    }

    if ((ItemPtr = InfoGetItemDef(FilePtr,Item)) == (InfoItemDef *) NULL)
    {
        printf("\n   Cannot get Item Defination for %s.\n\n",Item);
        return( -1 );
    }

    if (ItemPtr->ItemType != INFO_CHARACTER_TYPE)
    {
        printf("\n   Item %s is not Character.\n\n", Item);
        return( -1 );
    }

    printf("   Number of Records is %d\n", FilePtr->NumberRecords);

    rec = 1;
    if (!InfoReadRecord(FilePtr,rec))
    {
        printf("\n   Error Reading record %ld.\n\n", rec);
        return( -1 );
    }

    if (!InfoDecode(FilePtr,ItemPtr,RetString,&RetDouble))
    {
        printf("\n   Error Decoding record %ld.\n\n", rec);
        return( -1 );
    }

    p = strtok(RetString," ");
    p = strtok(NULL,"");
    if (p)
        sprintf(stkpath,"%s\n",p);

    strcpy(stkpath,RetString);
    fprintf(stdout,"%s\n",RetString);

    if (!InfoCloseFile(FilePtr))
    {
        printf("\n   Error Closing File %s.\n\n", InfoFilePath);
        return( -1 );
    }

    printf("INFOLIB  Successful Completion\n");

    return(E_SUCC);
}
