#!/usr/bin/perl
# This perl script will retrieve the names of the grids that compose the
# stack, converting each grid to a BIL binary file using gridfloat.

$workspace = $ARGV[0];
$instk = $ARGV[1];
$nbands = $ARGV[2];
$hostroot = $ARGV[3];
$stkfile = $workspace . "/" . $instk . "/stk.adf";
$oldstkfile = $workspace . "/" . $instk . "/" . $instk . ".stk"; 

open(FILE, "<$stkfile") || open(FILE, "<$oldstkfile") ||
   die "cannot open stack file for read";
$i = 0;
while(<FILE>) {
    @grids = split(/\s+/);
    foreach $grid (@grids) {
        # There are a bunch of funny elements in the grid name string
        # that are in the ARC stk file (like ^@) that mess up the match
        # so get rid of these by keeping only the elements of the string
        # that are a letter, number, or the underscore.
        $grid =~ s/\W+//g;

        $bilnum = $i + 1;
        $grid_name = $workspace . "/" . $grid;
        $cur_hostbil = $hostroot . "_$bilnum.bil";
        system "arc 'gridfloat $grid_name $cur_hostbil'";
        $i++; # keep track of number of layers (bands)

        # Due to trailing spaces that might confuse things, drop out when
        # we've retrieved the names of all the grids that compose the stack.
        if($i == $nbands) {last};
    }
}
close(FILE);

exit;
