#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *parb,			/* parameter block structure */
    char *hosin,				/* host input file name descriptor */
    char hosout[][CMLEN],			/* host output file name descriptor */
    long *incol_cnt,			/* input column count */
    char *atrname[],			/* attribute name for each output col */
    long *dtype,				/* input data type for each column */
    char *desc[],				/* descrption for each output column */
    long *incol,				/* input columns needed */
    long *nrow,				/* number of rows needed */
    char lttype[][CMLEN],			/* labeled table type */
    char ltdesc[][CMLEN],			/* labeled table descrption */
    long *ncol,				/* number of total columns */
    long *filenum,				/* file numbers to place columns in */
    long *totfiles,				/* total number of output files	*/
    long *srow,				/* starting row			*/
    long *tiecol,				/* column to place in all files	*/
    long *odtype                           /* output dtype of each col in lt */
);

void labtabop
(
    struct TAB_DEF *tab,		/* table descriptor */
    long *incol_cnt,		/* number of output columns needed */
    char hosout[][CMLEN],		/* host output file name */
    long *odtype,			/* data type of each output column */
    char *desc[],			/* attribute descrptions of each column */
    char *atrname[],		/* attribute names of each column */
    char lttype[][CMLEN],		/* type of labeled table */
    char ltdesc[][CMLEN],		/* descrption of labeled table */
    long *filenum,			/* file number to place each column */
    long *totfiles,			/* total number of files		*/
    long *tiecol,			/* no. of column to be placed in every file */
    long *incol			/* column numbers needed		*/
);

int readrow
(

    FILE *fp,			/* file pointer				*/
    union DATA *data,		/* data buffer */
    long *ncol,			/* number of columns */
    long *dtype,			/* data type of column			*/
    long *incol,			/* columns needed			*/
    long *odtype                   /* output dtype of each col in lt */
);

void setvec
(
    struct TAB_DEF *tab,		/* table descriptor */
    long coln,			/* current column			*/
    long *odtype,			/* data type of each output column */
    char *desc[],			/* attribute descrptions of each column */
    char *atrname[],		/* attribute names of each column */
    long filen,			/* current file number			*/
    char *sep			/* field seperator */
);

void writerow
(
    struct TAB_DEF *tab,			/* output labeled table descriptor */
    long *incol,				/* output columns needed */
    long *incol_cnt,			/* number of output columns needed */
    long *odtype,				/* output dtype of columns needed */
    union DATA *data,			/* data buffer */
    long *filenum,				/* file number of column	*/
    long *totfiles,				/* total number of files	*/
    long *tiecol,				/* column to be placed in all files */
    long *row				/* current row			*/
);

void writevec
(
    struct VECTOR *ptr[],		/* pointer to current vector */
    long *incol,			/* output columns needed */
    long *odtype,			/* odtype of columns needed */
    union DATA *data,		/* data buffer */
    long filen,			/* current file number		*/
    long coln			/* current column number	*/
);

#endif

