/******************************************************************************

NAME:	READROW

FUNCTION:  READROW reads a row from the input ASCII file

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM (FLOW):
Based on the data type of the input column
   Read the value in that column

******************************************************************************/
#include <stdio.h>
#include <string.h>

#include "las.h"
#include "ltable.h"
#include "asc2tab.h"
#include "protos.h"

int readrow
(

    FILE *fp,			/* file pointer				*/
    union DATA *data,		/* data buffer */
    long *ncol,			/* number of columns */
    long *dtype,			/* data type of column			*/
    long *incol,			/* columns needed			*/
    long *odtype                   /* output dtype of each col in lt */
)
   
{ /* readrow */

long i;				/* counter -- current column */
long j;				/* counter -- current data type needed	*/
long status=0;			/*  status of called functions		*/
int ltemp;
short stemp;
char ctemp[MAX_FIELD_LEN];
float rtemp;
double dtemp;

/*  Read each column of the input file 
--------------------------------------*/
j = 0;
for (i = 0; i < *ncol; i++)
   {
   switch (*(dtype + j))
      { /* switch based on dtype */ 
      case (C): 
             if (i == incol[j])
                {
                switch (*(odtype + j))
                   { /* switch based on odtype */ 
                   case (C):
                      status = fscanf(fp,"%s%*1c",data[i].chr);
                      break;
                   case (I1):
                      status = fscanf(fp,"%s%*1c",ctemp);
                      sscanf(ctemp,"%c",&data[i].byte);
                      break;
                   case (I2):
                      status = fscanf(fp,"%s%*1c",ctemp);
                      data[i].i2 = atoi(ctemp);
                      break;
                   case (I4):
                      status = fscanf(fp,"%s%*1c",ctemp);
                      data[i].i4 = atol(ctemp);
                      break;
                   case (R4):
                      status = fscanf(fp,"%s%*1c",ctemp);
                      data[i].r4 = (float) atof(ctemp);
                      break;
                   case (R8):
                      status = fscanf(fp,"%s%*1c",ctemp);
                      data[i].r8 = atof(ctemp);
                      break;
                   }
                }
             else
                status = fscanf(fp,"%s%*1c",data[i].chr);
                break;
      case (I1): 
                if (i == incol[j])
                   {
                   switch (*(odtype + j))
                      { /* switch based on odtype */ 
                      case (C):
                         status = fscanf(fp,"%c%*1c",data[i].chr);
                         break;
                      case (I1):
                         status = fscanf(fp,"%c%*1c",&data[i].byte);
                         break;
                      case (I2):
                         status = fscanf(fp,"%c%*1c",ctemp);
                         data[i].i2 = atoi(ctemp);
                         break;
                      case (I4):
                         status = fscanf(fp,"%c%*1c",ctemp);
                         data[i].i4 = atol(ctemp);
                         break;
                      case (R4):
                         status = fscanf(fp,"%c%*1c",ctemp);
                         sscanf(ctemp,"%f%*1c",&rtemp);
                         data[i].r4 = rtemp;
                         break;
                      case (R8):
                         status = fscanf(fp,"%c%*1c",ctemp);
                         sscanf(ctemp,"%lf%*1c",&dtemp);
                         data[i].r8 = dtemp;
                         break;
                      }
                   }
		else
                   status = fscanf(fp,"%s%*1c",data[i].chr);
                break;
      case (I2): 
                if (i == incol[j])
                   {
                   switch (*(odtype + j))
                      { /* switch based on odtype */
                      case (C): 
                          status = fscanf(fp,"%hd%*1c",&stemp);
                          sprintf(ctemp,"%d",stemp);
                          strcpy(data[i].chr,ctemp);
                          break;
                      case (I1):
                          status = fscanf(fp,"%hd%*1c",&stemp);
                          sprintf(ctemp,"%d",stemp);
                          sscanf(ctemp,"%c",&data[i].byte);
                          break;
                      case (I2):
                          status = fscanf(fp,"%hd%*1c",&data[i].i2);
                          break;
                      case (I4):
                          status = fscanf(fp,"%hd%*1c",&stemp);
                          data[i].i4 = (long) stemp;
                          break;
                      case (R4): 
                          status = fscanf(fp,"%hd%*1c",&stemp);
                          data[i].r4 = (float) stemp;
                          break;
                      case (R8): 
                          status = fscanf(fp,"%hd%*1c",&stemp);
                          data[i].r8 = (double) stemp;
                          break;
                      }
                   } 
		else
                   status = fscanf(fp,"%s%*1c",data[i].chr);
                break;
      case (I4): 
                if (i == incol[j])
                   {
                   switch (*(odtype + j))
                      { /* switch based on odtype */
                      case (C): 
                          status = fscanf(fp,"%d%*1c",&ltemp);
                          sprintf(ctemp,"%d",ltemp);
                          strcpy(data[i].chr,ctemp);
                          break;
                      case (I1):
                          status = fscanf(fp,"%d%*1c",&ltemp);
                          sprintf(ctemp,"%d",ltemp);
                          sscanf(ctemp,"%c",&data[i].byte);
                          break;
                      case (I2):
                          status = fscanf(fp,"%d%*1c",&ltemp);
                          data[i].i2 = (short) ltemp;
                          break;
                      case (I4):
                          status = fscanf(fp,"%d%*1c",&data[i].i4);
                          break;
                      case (R4): 
                          status = fscanf(fp,"%d%*1c",&ltemp);
                          data[i].r4 = (float) ltemp;
                          break;
                      case (R8): 
                          status = fscanf(fp,"%d%*1c",&ltemp);
                          data[i].r8 = (double)ltemp;
                          break;
                      }
                   }
		else
                   status = fscanf(fp,"%s%*1c",data[i].chr);
                break;
      case (R4): 
                if (i == incol[j])
                   {
                   switch (*(odtype + j))
                      { /* switch based on odtype */
                      case (C): 
                          status = fscanf(fp,"%f%*1c",&rtemp);
                          sprintf(ctemp,"%f",rtemp);
                          strcpy(data[i].chr,ctemp);
                          break;
                      case (I1):
                          status = fscanf(fp,"%f%*1c",&rtemp);
                          sprintf(ctemp,"%f",rtemp);
                          sscanf(ctemp,"%c",&data[i].byte);
                          break;
                      case (I2):
                          status = fscanf(fp,"%f%*1c",&rtemp);
                          data[i].i2 = (short) rtemp;
                          break;
                      case (I4):
                          status = fscanf(fp,"%f%*1c",&rtemp);
                          data[i].i4 = (long) rtemp;
                          break;
                      case (R4): 
                          status = fscanf(fp,"%f%*1c",&data[i].r4);
                          break;
                      case (R8): 
                          status = fscanf(fp,"%f%*1c",&rtemp);
                          data[i].r8 = (double) rtemp;
                          break;
                      }
                   }
		else
                   status = fscanf(fp,"%s%*1c",data[i].chr);
                break;
      case (R8): 
                if (i == incol[j])
                   {
                   switch (*(odtype + j))
                      { /* switch based on odtype */
                      case (C): 
                          status = fscanf(fp,"%lf%*1c",&dtemp);
                          sprintf(ctemp,"%lf",dtemp);
                          strcpy(data[i].chr,ctemp);
                          break;
                      case (I1):
                          status = fscanf(fp,"%lf%*1c",&dtemp);
                          sprintf(ctemp,"%lf",dtemp);
                          sscanf(ctemp,"%c",&data[i].byte);
                          break;
                      case (I2):
                          status = fscanf(fp,"%lf%*1c",&dtemp);
                          data[i].i2 = (short) dtemp;
                          break;
                      case (I4):
                          status = fscanf(fp,"%lf%*1c",&dtemp);
                          data[i].i4 = (long) dtemp;
                          break;
                      case (R4): 
                          status = fscanf(fp,"%lf%*1c",&dtemp);
                          data[i].r4 = (float) dtemp;
                          break;
                      case (R8): 
                          status = fscanf(fp,"%lf%*1c",&data[i].r8);
                          break;
                      }
                   }
		else
                   status = fscanf(fp,"%s%*1c",data[i].chr);
                break;
      } /* case dtype */

      /*  switch data types when current column == needed column
      ----------------------------------------------------------*/
      if (i == incol[j])
         j++;

      if (status == EOF)
         break;
   }
return(status);
} /* readrow */
