/******************************************************************************

NAME:	SETVEC

FUNCTION:  SETVEC sets the vector data needed for each column

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM (FLOW):
Write each vector field according to the data type of input column.

******************************************************************************/
#include "las.h"
#include "ltable.h"
#include "asc2tab.h"
#include "protos.h"

void setvec
(
    struct TAB_DEF *tab,		/* table descriptor */
    long coln,			/* current column			*/
    long *odtype,			/* data type of each output column */
    char *desc[],			/* attribute descrptions of each column */
    char *atrname[],		/* attribute names of each column */
    long filen,			/* current file number			*/
    char *sep			/* field seperator */
)

{ /* setvec */

/*  Write each vector field according to the data type of input column.
-----------------------------------------------------------------------*/
switch (*(odtype+coln))
   {
   case (0):put_vector(&tab[filen],atrname[coln],C,desc[coln],1,
		       MAX_FIELD_LEN,sep[coln]);
            break;
   case (1):put_vector(&tab[filen],atrname[coln],I1,desc[coln],1,1,sep[coln]);
            break;
   case (2):put_vector(&tab[filen],atrname[coln],I2,desc[coln],1,1,sep[coln]);
            break;
   case (3):put_vector(&tab[filen],atrname[coln],I4,desc[coln],1,1,sep[coln]);
            break;
   case (4):put_vector(&tab[filen],atrname[coln],R4,desc[coln],1,1,sep[coln]);
            break;
   case (5):put_vector(&tab[filen],atrname[coln],R8,desc[coln],1,1,sep[coln]);
            break;
   } /* switch odtype */

return;
} /* setvec */
