/******************************************************************************

NAME:	WRITEVEC

FUNCTION:  WRITEVEC writes the column data to the correct vector of the
	   output labeled table file

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM (FLOW):
Based on data type
   Write the column value to the correct vector of the labled table file

******************************************************************************/
#include <string.h>
#include "las.h"
#include "ltable.h"
#include "asc2tab.h"
#include "protos.h"

void writevec
(
    struct VECTOR *ptr[],		/* pointer to current vector */
    long *incol,			/* output columns needed */
    long *odtype,			/* odtype of columns needed */
    union DATA *data,		/* data buffer */
    long filen,			/* current file number		*/
    long coln			/* current column number	*/
)

{ /* writerow */

struct MATRIX size;		/* matrix size */

long fatal = -1;		/* fatal error code			*/
long nonfatal = 1;		/* nonfatal error code			*/

/* Initialize needed variables
------------------------------*/
size.ncol = 1;	
size.nrow = 1;

/* write each column according the the data type of each column
---------------------------------------------------------------*/
switch (*(odtype+coln))
   { /* switch odtype */ 
   case (C): 
      size.ncol = (long) strlen(data[*(incol + coln)].chr);
      strcpy(ptr[filen]->ptr.c,data[*(incol + coln)].chr);
      break;
   case (I1): 
	if (data[*(incol + coln)].byte > 127)
	   {
	   c_errmsg("Value too large for specified data type",
		   "asc2tab-value",&nonfatal);
	   c_errmsg("Fatal error encountered","asc2tab-fatal",&fatal);
	   }
   	put_matrix(ptr[filen],I1,&size,&data[*(incol + coln)].byte);
               break;
   case (I2): 
	if (data[*(incol + coln)].i2 > 32767)
	   {
	   c_errmsg("Value too large for specified data type",
		   "asc2tab-value",&nonfatal);
	   c_errmsg("Fatal error encountered","asc2tab-fatal",&fatal);
	   }
   	put_matrix(ptr[filen],I2,&size,(unsigned char *) &data[*(incol + coln)].i2);
               break;
   case (I4): 
   	put_matrix(ptr[filen],I4,&size,(unsigned char *) &data[*(incol + coln)].i4);
               break;
   case (R4): 
   	put_matrix(ptr[filen],R4,&size,(unsigned char *) &data[*(incol + coln)].r4);
        break;
   case (R8): 
   	put_matrix(ptr[filen],R8,&size,(unsigned char *) &data[*(incol + coln)].r8);
        break;
   } /* case odtype */

return;
} /* writevec */
