/******************************************************************************
NAME:        SIGNAL_CLEANUP

PURPOSE:     Signal handler to call the cleanup_files routine.

RETURN VALUE:
Type = void

PROGRAM HISTORY:
$Log: signal_cleanup.c,v $
Revision 1.7  2001/11/28 21:06:40  shimitz
Implemented changes from peer review and testing. This is formally the
initial released version of the module. CR 2841

Revision 1.6.2.1  2001/11/21 19:52:49  shimitz
Reformatted the files according to the programming standard. Also modified
get_par to retrieve and verify the INFILE and OUT parameters. Made some other
minor changes requested by the user during acceptance testing.

Revision 1.6  2001/06/22 16:21:49  shimitz
Made changes suggested in code peer review session.


PROJECT:     LAS

NOTES:
  1) For the signal handler, this must be a void function.  Thus if any
     errors occur in this routine, they will not be checked or returned.
  2) This function cannot have any parameters, since it is passed from the
     main routine to the signal handler.
******************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include "las.h"
#include "ascii2ddr.h"

/* Define the global variables that are used by the cleanup routine
-------------------------------------------------------------------*/
extern char g_outfile[CMLEN];   /* Output binary DDR filename in host format */

void signal_cleanup ()
{
    /* Cleanup the files that have been created
       ----------------------------------------*/
    cleanup_files(g_outfile);

    exit(EXIT_FAILURE);
}
