#ifndef ASTERHDF2LAS_H
#define ASTERHDF2LAS_H

#define NUMBANDS 15        /* Maximum number of bands a ASTER HDF file 
                              will have */
#define NUMFILES NUMBANDS  /* Maximum number of output files that can be 
                              requested */

#define  HDF_FAIL -1       /* HDF defines SUCCESS 0 and FAIL -1.  There is a
                              conflict with the TAE and HDF include files
                              concerning FAIL. For HDF, hdf.h defines FAIL 
                              as -1.  In TAE, taeconf.inp defines FAIL as 0.  
                              Therefore, instead of using FAIL, HDF_FAIL was
                              defined */

#define DEFAULT_ZONE 62    /* Zone code for TM, LAMCC, PS, EQRECT and SOM 
                              projections                                    */

#define WGS84 317          /* The datum for all ASTER HDF images is WGS84    */

#define NUM_COORDINATES 8  /* the total number of coordinates                */

#define L1A 0              /* Level 1A product                               */
#define L1B 1              /* Level 1B product                               */
#define L2 2               /* Level 2 product                                */
#define L3 3               /* Level 2 DEM product                            */ 

#endif
