#ifndef GET_CORNER_COORDINATES_H
#define GET_CORNER_COORDINATES_H

#include "PGS_SMF.h"

void get_corner_coordinates
(
    PGSt_integer fileid,        /* I: File id for the file containing
                                      parameter data                         */ 
    int projection_code,        /* I: Projection of the scene TM,LAMCC,PS,
                                      EQRECT,SOM, UTM or GEO                 */
    int product_level,          /* I: Level 1A=L1A Level 1B=L1B Level 2=L2
                                      Level 3 DEM=L3                         */
    long *zone,                 /* O: Zone code needed for UTM projection    */
    double corner_coordinates[],/* O: Corner coordinates in lat/lon for 
                                      Level 1A and DEM. They are in y/x meters
                                      for rest of products                   */
    int ddr_valids[],           /* O: Flag indicating if corner coordinates
                                      field is valid or not (VALID or INVAL) */
    double projection_values[]  /* I/O: Input angle values in radians output
                                        in degrees/minutes/seconds for all 
                                        projections except geographic        */
);

#endif
