#ifndef GET_METADATA_H
#define GET_METADATA_H 

#include "mfhdf.h"
#include "las.h"

int get_metadata
(
    int32 sd_id,              /* I: SD interface identifier                  */
    char infile[],            /* I: Input HDF filename                       */
    char outfiles[][CMLEN],   /* I/O: Output LAS filename(s)                 */
    int num_outs,             /* I/O: Count of outfiles                      */
    char bands[][3],          /* I/O: Bands to be processed                  */
    int num_bands,            /* I/O: Count of bands                         */
    int band_groupings[],     /* I/O: The grouping of bands. Each band group
                                      represents one output LAS image        */
    int *num_band_groupings,  /* I/O: Count of band_groupings                */
    int process_all_bands,    /* I: Flag indicating if all bands in file
                                    should be processed (process all = TRUE
                                    else FALSE)                              */
    int32 sds_index[],        /* I/O: Index of data set                      */
    int *product_level,       /* O: Values can be Level 1A=L1A, Level 1B=L1B
                                    Level 2 =L2 or Level 3 =L3               */
    int ddr_valids[],           /* O: Flags indicating if fields in the DDR
                                    are valid or not (VALIS oe INVAL)        */
    char *acquisition_date,   /* O: Capture date                             */
    char *acquisition_time,   /* O: Capture time                             */
    double corner_coordinates[],/* O: Corner coordinates in either degrees
                                      or meters                              */
    double projection_values[],/* O: Projection parameters                   */
    int *projection_code,     /* O: Either GEO, TM, LAMCC, PS, EQRECT or SOM */
    int32 data_set_index_num[], /* O: Index number of the data set           */
    int projection_distance[],/* O: Resolution of each band(15,30or90 meters)*/
    char projection_units[],  /* O: Projection units (degrees or meters)     */
    char *instrument_name,    /* O: Type of sensor                           */
    int dtype[],              /* O: Data types for each band                 */
    int nl[],                 /* O: Array of total number of lines           */
    int ns[],                 /* O: Array of total number of samples         */
    char kinetic_temp[],      /* O: Flag indicating if product is Kinetic
                                    Temperature                              */
    char intermediate_files[][CMLEN], /* O: Path and file names of the
                                           temporary files                   */
    char subdirectory[],      /* O: Name of the subdirectory which stores
                                    the intermediate files                   */
    long *zone                /* O: Zone code needed for UTM projection      */
);


#endif
