/******************************************************************************
NAME:           sort_bands_in_band_groupings

PURPOSE:        This function sorts bands within the bands group.

RETURN VALUE:
Type = void

PROGRAM HISTORY:

PROJECT:        LAS
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "asterhdf2las.h"
#include "asterhdf2las_protos.h"

void sort_bands_in_band_groupings
(
    char bands[][3],          /* I/O: Adjusted band values that have 
                                      been sorted                            */
    int band_groupings[],     /* I: Band grouping values                     */
    int num_bands,            /* I: Count of adjusted bands                  */
    int num_band_groupings    /* I: Count of adjusted band groupings         */
)
{
    int bands_times_10[NUMBANDS]; /* Array of bands with int values times 10 */
    int temp;                 /* Temporary int value                         */
    int bands_times_10_index; /* Indexing variable used for bands_times_10   */
    int bg_index;             /* Indexing variable used for band groupings   */
    int first_band_in_group=0;/* Index used to point to first band in band
                                 grouping                                    */
    int index;                /* Indexing variable used for looping          */
    int index2;               /* Looping variable                            */

    /* Set 3N and 3B to 30 and 35 and multiply the rest of the bands by 10
       so it is easier to sort
    ---------------------------------------------------------------------*/
    for (index = 0; index < num_bands; index++)
    {
        if (strcmp (bands[index],"3N") == 0)
            bands_times_10[index] = 30;
        else if (strcmp (bands[index], "3B") == 0)
            bands_times_10[index] = 35;
        else
            bands_times_10[index] = (atof(bands[index]) * 10);
    }

    /* Loop through each count of band groupings
    -------------------------------------------*/
    /*bands_times_10_index points to the position in the bands_times_10 array*/
    bands_times_10_index = 0;

    for (bg_index = 0; bg_index < num_band_groupings; bg_index++)
    {
        index = 1;
        /* Loop through the current band groupings set and sort the bands.  
        If band groupings value = 1 then no sorting is required. Increment
        first_band_in_group by 1 which will be added to bands_times_10_index 
        ------------------------------------------------------------------*/
        if (band_groupings[bg_index] == 1)
           /*first_band_in_group is the index that
           points to the first band of the band
           groupings. ie band_groupings[0]=2 band_groupings[1]=3 then
           1st_band_in_group will first point to
           bands_times_10[0] then point to bands_times_10[2]*/

           first_band_in_group ++; 
        else
        {
          /* index2 is used to loop through each band grouping*/
          for(index2 = 0; index2 < band_groupings[bg_index]; index2++)
          {  
            bands_times_10_index = index2 + first_band_in_group;
            index = index2+1;
            while (index < band_groupings[bg_index])
            {
                if (bands_times_10[bands_times_10_index + 1] 
                     < bands_times_10[index2+first_band_in_group])
                {
                    temp = bands_times_10[bands_times_10_index + 1];
                    bands_times_10[bands_times_10_index + 1] 
                     = bands_times_10[index2+first_band_in_group];
                    bands_times_10[index2+first_band_in_group] = temp;
                }
                index ++;
                bands_times_10_index ++;
            }
          }
        }
        first_band_in_group = bands_times_10_index + 1;
    }

    /* Now that bands_times_10 array has been sorted, copy it back to 
       bands array and change 30 and 35 to 3N and 3B
    ---------------------------------------------------------------------*/
    for (index = 0; index < num_bands; index++)
    {
        if (bands_times_10[index] == 30)
            strcpy(bands[index], "3N");
        else if (bands_times_10[index] == 35)
            strcpy(bands[index], "3B");
        else
        {
            bands_times_10[index] = bands_times_10[index] / 10; 
            sprintf(bands[index], "%02ld", bands_times_10[index]);
        } 
    }
}
