#ifndef PROTOS_H
#define PROTOS_H

int editpts
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    long degree,			/* Degree of polynomial to use 		*/
    double tolval,			/* Tolerance value (convergence check)  */
    long *pltflg,            	/* plot flag                            */
    char *plotfile,          	/* plot filename                        */
    FILE *fptr,			/* Print file pointer			*/
    long *msgtim,			/* message time				*/
    float *minrms          	/* Minimum rms value to complete autofit*/
);

int fit
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    long npts_used,			/* Current number of points used 	*/
    long degree,			/* Degree of polynomial used 		*/
    double *rmse,			/* Root Mean Squared Error 		*/
    double *minerr,			/* minimum error			*/
    double *maxerr,			/* maximum error			*/
    long plot,			/* Flag--write plot file? 		*/
    char *plotfile			/* plot file name			*/
);

int get_tie_points
(
    char *name,			/* Name of the Tie Point Location file */
    struct TPLHEAD *header,		/* Tie Point Location header record */
    struct TPLDATA **data,		/* Tie Point Location data records */
    long *npts			/* Number of tie point data records read */
);

int getpar
(
    struct PARBLK *vblk,	/* TAE variable block 				*/
    char *tpl,		/* Input tie point location file name 		*/
    char *outtpl,		/* Output tie point location file name 		*/
    long *degree,		/* Degree of polynomial 			*/
    float *tolval,		/* Tolerance value 				*/
    long *pltflg,           /* plot flag                                    */
    char *plotfile,         /* plot filename                                */
    long print[],		/* print option                          	*/
    char *prtfile,          /* print file name                              */
    char *filename,         /* print file name                              */
    long *msgtim,		/* message time					*/
    float *minrms          /* Minimum rms value to complete autofit 	*/
);

int put_tie_points
(
    char *intpl,			/* Name of the Tie Point Location file */
    struct TPLHEAD *header,		/* Tie Point Location header record */
    struct TPLDATA *data,		/* Tie Point Location data records */
    long npts			/* Number of tie point data records read */
);

#endif

