/****************************************************************************
NAME:				put_tie_points

PURPOSE:  Writes edited tie points to a new disk file

****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "geompak.h"
#include "protos.h"

int put_tie_points
(
    char *intpl,			/* Name of the Tie Point Location file */
    struct TPLHEAD *header,		/* Tie Point Location header record */
    struct TPLDATA *data,		/* Tie Point Location data records */
    long npts			/* Number of tie point data records read */
)
{
struct PTDESC *desc;			/* File descriptor for tie pt file */
long acc;			/* File access flag */
long count;			/* Loop counter */
long ptyp;			/* Type of tie point data/header record */

/* Open the tie point location file 
  --------------------------------*/
ptyp = TPL; 
acc = IWRITE;
if (c_ptopen(&desc, intpl, &ptyp, &acc, (long *) header) != E_SUCC) 
   return(E_FAIL);

/* Write out the tie point location data records
  -------------------------------------------*/
for (count = 0; count < npts; count++)
   if (c_ptio(&desc, (long *) &(data[count])) != E_SUCC) 
      return(E_FAIL);

/* Close the Tie Point Location file
  ---------------------------------*/
c_ptclse(&desc);
return(E_SUCC);
}
