#include "bayes.h"

void dyn_alloc
(
    long num_inbands,    /* number of input image bands    */
    long nclass,		/* number of classes */
    float *mean[],	/* means pointers */
    double *covinv[]      /* inverse covariance matrix pointers */
)
/* *********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for mean vectors and covariance matrices 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/17/88  K. A. Narayanan
  2.0         08/31/88  B. Allam

********************************************************************* */
{
long	buf_size, c_size,  /* size of matrices */
        i, n, m;

/* allocate storage for mean vectors and covariance matrices 
----------------------------------------- */
buf_size = (long) (nclass * num_inbands * num_inbands * sizeof(double));
c_size = (long) (nclass * num_inbands * sizeof (float));

if ((covinv_matrix = (double *) malloc( buf_size)) == NULL ||
    (mean_matrix = (float *) malloc( c_size)) == NULL) {
    iso_err ("!Error allocating dynamic memory", "bayes-alloc");
   }
/*
set up pointers for mean vectors and covariance matrices 
---------------------------------------- */
for (i = 0, n = 0, m = 0; i < nclass; i++, n += num_inbands * num_inbands, 
		m += num_inbands)
   {
   mean[i] = &mean_matrix[m];
   covinv[i] = &covinv_matrix[n];
   }
}
