#include "bayes.h"
#include "util.h"


/*****************************************************************************
 *
 * NAME		iso_err
 *
 * PURPOSE	To display an error message and exit BAYES if it is fatal.
 *		The first character of the error message determines whether
 *		or not the error is fatal.
 *
 * PROGRAM HISTORY
 *
 * Version	Programmer		Date		Reason
 * -------	----------		----		------
 *		Eric Ivancich / SAR	13-Aug-87	C conversion
 *      	Bani Allam              8-Aug-88        Retrocode
 *   5.0   	D. VanderZee            6-Apr-90        Added fatal error 
 *							without message  
 *
 * PARAMETERS
 *
 *	Name		Type		I/O	Description
 *	----		----		---	-----------
 *	*message	char		I	Error message and severity
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *	None
 *
 * RETURN VALUES
 *
 *	None
 *
 *****************************************************************************/
void iso_err
(
    char *message,
    char *key
)
{
long one = 1;
    
    
    switch (*message++)  {
		case '?' :
		     	c_errmsg (message, key, &one);
		     	break;
		case '!' : {
   	 		c_errmsg (message, key, &one);
                        if (gdesc > 0) c_egclse(&gdesc);
                        if (sdesc[1] > 0) c_stclse(&sdesc[1]);
                        c_clean (&vblock, "bayes", out, &num_files);
		     	break;
                        }
		case '$' : {
                        if (gdesc > 0) c_egclse(&gdesc);
                        if (sdesc[1] > 0) c_stclse(&sdesc[1]);
                        c_clean (&vblock, "bayes", out, &num_files);
			}
 	}
}
