#include "canal.h"
#include "protos.h"

void dyn_alloc
(
    long num_inbands,       /* number of input image bands    */
    float *p[],            /* pointers to covariance matrix  */
    float *w[],
    float *a[]        /* pointers to eigen vectors      */
)

/*
*********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for covariance matrices and eigen vectors

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/17/88  K. A. Narayanan

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

*********************************************************************
*/
{
long	buf_size,                  /* size of matrices       */
        i, n;

/*
allocate storage for covariance matrices and eigen vectors
----------------------------------------------------------
*/
buf_size = (long) ( num_inbands * num_inbands * sizeof (float) );

if ((p_matrix = (float *) malloc( buf_size)) == NULL ||
   (w_matrix = (float *) malloc( buf_size)) == NULL ||
   (a_matrix = (float *) malloc( buf_size)) == NULL )
   c_errmsg( "Error allocating dynamic memory", "canal-alloc", &fatal_err);

/*
set up pointers for covariance matrices and eigen vectors
---------------------------------------------------------
*/
for (i = 0, n = 0; i < num_inbands; i++, n += num_inbands)
   {
   p[i] = &p_matrix[n];
   w[i] = &w_matrix[n];
   a[i] = &a_matrix[n];
   }
}
