#include "canal.h"
#include "protos.h"

void stat_copy
(
    FILE *fd_in,               /* input statistics file            */
    FILE *fd_out,              /* output statistics file           */
    long nclass              /* number of classes                */
)
/*
*******************************************************************
NAME: STAT_COPY

PURPOSE: Copies input statistics file to output and closes input file

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  2.0         08/17/88  K. A. Narayanan   Conversion to 5.0
  1.0         02/25/83  K. A. Narayanan

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

*******************************************************************
*/
{
long	class_index, site_index;
long	ns;
long	shape[9];
long	zero = 0;

/*
loop through all nodes (class level first)
------------------------------------------
*/
for (class_index = 0; class_index <= nclass; class_index++)
   {
   site_index = 0;
   donode (class_index, site_index, fd_in, fd_out);
   if (class_index  !=  0) 
      {
      ns = 0;
      c_stget (&fd_in, "NSITES", &class_index, &zero, shape,
                   (unsigned char *) &ns); 
      if (ns  !=  0) 

/*
         and then the site level
         -----------------------
*/
         for (site_index = 1; site_index <= ns; site_index++)
            donode (class_index, site_index, fd_in, fd_out);
      }  
   }  
/*
close input file
----------------
*/
c_stclse (&fd_in);

}
