#ifndef _CIB2LASOUT_H
#define _CIB2LASOUT_H
#include"cibframe.h" /* for CIBCoverage defn. */
#include"las.h"      /* for PARBLK defn.      */

typedef struct column
{
    int framesamples;       /* number of samples from this column to output */
    int endingsample;       /* last sample in frame to output               */
    int startsample;        /* first sample in frame to output              */
} COLUMN;

int calc_corners
(
    const struct CIBCoverage * corner, /* I: Upper left corner of CIB image */
    const INPARAMS *input_parmas,      /* I: SL SS NL NS for output image   */
    struct CIBCoverage * image         /* I/O: Corners of output image      */
);

int cib2lasout
(
    struct PARBLK *vblk,       /* I: TAE parameter block                    */
    FRAMEFILE ** list,         /* I: List of Frame Files                    */
    INPARAMS * input_params,   /* I: Input Parameters                       */
    const CIB_DATA *d,         /* I: Input Dimensions                       */
    char hosout[][CMLEN],      /* I: host name of output file               */
    const char *device         /* I:  device (remote drive                  */
);

void getminmax
(
    const long numsamples,     /* I: number of samples in line              */
    const unsigned char *line, /* I: Line to find min/max value from        */
    unsigned char *minpixel,   /* I/O: current min pixel, set 
                                       to new min pixel upon exit           */
    unsigned char *maxpixel    /* I/O: current max pixel, set to 
                                       new max pixel upon exit              */
);       

#endif
