#ifndef _LOCATE_FRAME_H
#define _LOCATE_FRAME_H

#include"cib2las.h"

/* return value when the specified resolution is one that is 
   unsupported  currently on 5 and ten meter resolutions are
   supported                                                                */

#define UNSUPPORTED_RES -2 

/* Data Series codes from MIL-STD-2411-1 
   Section 5.1.4 pg. 9 I1 = 10 meter, I2 = 5 meter 
---------------------------------------------------*/
#define TEN_METER 1
#define FIVE_METER 2

/* Locate a frame file within its zone based on the frame
   files encoded name
---------------------------------------------------------*/
   
int locate_frame 
(
   char zone,             /* I: CIB zone of requested image                 */
   int tilenum[MAXTILES], /* I: boundary rectangles to ingest               */
   FRAMEFILE *ff          /* I/O:  frame file record to update              */
);

/* returns a value for a frame file name character as defined in
   MIL-PRF-89041 APPENDIX Section A.3.6 page 45
-----------------------------------------------------------------*/
int get_val
(
    char ch      /* I: character to get value of                            */
);

/* get number of columns in the CIB zone specified for resolution specified
---------------------------------------------------------------------------*/
long get_columns
(
    char zone,   /* I:  zone frame file contained in                        */
    int res      /* I:  resolution of frame file e.g. 5m, 10m etc.          */
);

/* get number of rows in the CIB zone specified for resolution specified
------------------------------------------------------------------------*/
long get_rows
(
    char zone,   /* I:  zone frame file contained in                        */
    int res      /* I:  resolution of frame file e.g. 5m, 10m etc.          */
);
#endif
