#ifndef UPDATE_DDR_H
#define UPDATE_DDR_H

#include"las.h"      /* for DDR def.        */
#include"cib2las.h"  /* for Corner def.     */
#include"cibframe.h" /* for CIBCoverage def */

/* #defines used to access projection coefficients in ddr structure
--------------------------------------------------------------------*/
#define SMAJOR 0          
#define SMINOR 1
#define CENTMER 4
#define TRUESCALE 5
#define FE 6
#define FN 7

int update_ddr
(
    char *fname,              /* I: filename for image file                 */
    INPARAMS *s,              /* I: paramaters ss,ns,sl,nl, etc.            */
    struct CIBCoverage *out,  /* I: corner coordinates,lat,long,res etc.    */ 
    unsigned char *minval,    /* I: minvalue in band if flag set            */
    unsigned char *maxval,    /* I: maxvalue in band if flag set            */ 
    int minmax_flg,           /* I: value of global minmax flag             */
    char *datasource,         /* I: image datasource                        */
    char cibzone,             /* I: CIB zone of image                       */
    char units                /* I: output units, 1 = degrees, 0 = meters   */
);

int get_truescalelat
(
    char zone,             /* I: alphanumeric value representing CIB 
                                 zone containing the image                  */
    double *truescalelat   /* O: Latitude of true scale                     */
);

#endif
