#include <stdio.h>
#include "las.h"
#include "util.h"
#include "protos.h"

/******************************************************************************

NAME:  GENPIC

FUNCTION:   Generate picture as directed in picture description table.

PROGRAM HISTORY:
  Version	Date       Author       	Request
  -------	----	   ------            	-------
   1.0        3-Feb-82    J. Hwang/SASC
   2.0        8-Jan-88    M. Mazzella SAR/GSFC  Convert to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM:

   Intialize and enable the processing message utility.
   For number of lines in the output image
      Call LINGEN to generate a line of the classmap display
      Call PUTIMG to create the red, green, or blue components of that line
         (if required) and to write the resulting lines out.
   End-For

******************************************************************************/

void genpic
(
    long window[],		/* Output image window */
    long msgtim,		/* Time between timed processing messages */
    long *gry			/* Lines to contain grey scale on image	*/
)
{
#include "externs.h"
#include "classmap.h"


extern long	curent;		/* Current line number for display message */

long	i,			/* Loop counter	*/
	msg_flg = 3;		/* Display flag for the processing mesage */

/*
Initialize and enable the processing message facility.
------------------------------------------------------
*/
curent = 1;
c_inittm ("CLASSMAP", "Processed", "line", "", "", &window[2], &zero, &msgtim,
           &msg_flg);

c_startm();

/*
For number of lines in the output image:
Call LINGEN to generate a line of the classmap display
Call PUTIMG to create the red, green, or blue components of that line
(if required) and to write the resulting lines out.
-------------------------------------------------------------------------
*/
for  (i = tb[0]; i <= tb[0] + tb[2] - 1; ++i)
   {
   lingen (i, tb[6]);/* class, clschr);*/
   putimg (i, gry);
   curent++;
   }

/*
Disable the processing message facility.
------------------------------------------------------
*/
c_stoptm();
}
