#include <stdio.h>
#include "las.h"
#include "protos.h"
/******************************************************************************

NAME: PACK

FUNCTION:   Deletes blanks in input string and gets the length of that string.

PROGRAM HISTORY:
  Version	Date       Author  		   Request
  -------	----	   ------        	   -------
   1.0        19-Feb-82    J. Hwang, SASC
   2.0         8-Feb-88    M. Mazzella SAR/GSFC    Convert to C
   3.0        20-Dec-90    K. Donaldson            Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM:

   For all characters in the word, 
      Pick up non blank character only.
      Shift the charcters over the blanks.
   End-For
   Put null at the end of string.

******************************************************************************/

void pack
(
    char *string,	/* Input string	*/
    long *length	/* Length of string */
)
{

long	i,		/* Loop counter */
	len;		/* Temporary length holder */

len = (long)strlen(string);
*length = 0;

/*
For all characters in the word, pick up non blank character only.
Shift the charcters over the blanks.
-------------------------------------------------------------------
*/
for (i = 0; i < len; i++)
   {
   if (string[i] != ' ') 
      {
      string[*length] = string[i];
      *length = *length + 1;
      }
   }

/*
Put null at the end of string.
------------------------------
*/
string[ *length ] = '\0';
}
