#ifndef PROTOS_H
#define PROTOS_H

void arange
(
    long window[],	/* user defined window to be applied to input image */
    long trnc,		/* truncation flag: 1 - truncate: select output image*/
    long imgsiz[]	/* input image size */
);

long int bit 
(
    unsigned char word,         /*  source word  */
    unsigned char pos           /*  position of bit desired  */
);

void genano
(
    char indltf[],              /* Dltf (lookup table file) name */
    char dltfentry[],           /* Dltf entry */
    char usrano[],              /* User defined annotation */
    char clschr[][8],           /* Class names */
    unsigned char class[],      /* Color numbers for classes */
    long gry[2],                /* Line numbers of grey scale on image */
    char fname[],               /* Facility name to be printed on image */
    long usrcol_flg             /* Flag for user specified colors      */
);

int genchr
(
    long vcnt,		/* Current line count on the picture */
    long tab[],		/* Square description  */
    char chrs[]		/* Character(s) to be expanded */
);

void genpic
(
    long window[],	/* Output image window */
    long msgtim,	/* Time between timed processing messages */
    long *gry		/* Lines to contain grey scale on image	*/
);

int gensqr
(
    long vcnt,		/* Line number of the image */
    long *tab		/* Array of data about the square */
);

int gentik
(
    long vcnt,		/* Vertical line count */
    long tab[]		/* Array containing tick information */
);

int getimg
(
    long vcnt,		/* Vertical line count */
    long tab[]		/* Information about image line */
);

void getinf
(
    char hosin[],		/* Host name of input image		*/
    long windin[4],		/* Input image window			*/
    long bands[MAXIMG],		/* Input image bands			*/
    long num_img_bands[][MAXBND+1],  /* Band numbers for each image */
    struct DDR *ddr,		/* Input ddr				*/
    char usrano[],		/* User defined anotation		*/
    char taeout[],		/* Tae name of output image		*/
    char hosout[],		/* Host name of output image		*/
    char clschr[][8],		/* Class names				*/
    unsigned char class[],        /* Array of user defined classes	*/
    char fname[],		/* Facility name			*/
    long *msgtim,		/* Time for the processing message      */
    long imgsiz[],		/* Output image size			*/
    char dltfentr[],		/* User specified dltfentry		*/
    char indltf[],		/* User specified dltf name		*/
    long *usrcol_flg,		/* Flag for user specified colors       */
    long *numcls,		/* Number of input classes		*/
    long *ns			/* number of samples in image           */
);

void getpar
(
    char hosin[],               /*  Input host file name                */
    long windin[4],             /*  Input image window                  */
    long window[][4],           /*  Initial multi-band input window     */
    long bands[MAXIMG],         /*  Input image bands                   */
    long (*num_img_bands)[MAXBND+1],  /* Band numbers for each image     */
    struct DDR *ddr,            /*  Input image ddr                     */
    char usrano[],              /*  User defined annotation             */
    char taeout[],              /*  Output tae name                     */
    char hosout[],              /*  Output host file name               */
    long *trnc,                 /*  Image truncation flag               */
    char clschr[][8],           /*  Class descriptions                  */
    unsigned char class[],      /*  user defined class numbers          */
    char facility_name[],       /*  Facility name                       */
    long *msgtim,               /*  Time for processing message         */
    char indltf[],              /*  User specified dltf name            */
    char dltfentr[],            /*  User specified dltf option          */
    long *usrcol_flg,           /*  Flag for user specified colors      */
    long *numcls                /*  Number of classes specified         */
);

long int idx
(
    long    a,          /* Number of pixels in the image */
    long    b,          /* Number of lines in the image */
    long    tbl[],      /* Table of values */
    long    tsize,      /* Table size */
    long    jump,       /* Number of values between each one checked */
    long    eq          /* Equivalence flag */
); 

void initc
(void);

void intsct
(
    long a[],		/* First input window and an output window for the */
    long b[],		/* Second input window */
    long abssiz		/* True if absolute size comparison desired */
);

void lingen
( 
    long vcnt,		/* Current line count */
    long tbsize 	/* Number of rectangular description in the table */
);

void magtbl
(
    long ntimes
);

void opnimg
(
    char *hosin,        /* Input file host name */
    char *taeout,       /* Output file tae name */
    struct DDR *ddr,    /* Input image ddr */
    long num_img_bands[MAXIMG][MAXBND+1], /* Input image band numbers */
    long window[],      /* Input image window specifications */
    long *offset,       /* Offsets into image i/o buffers */
    char *hosout,       /* Output file host name */
    long windout[]      /* Output image window specifications */
);

void pack
(
    char *string,       /* Input string */
    long *length        /* Length of string */
);

void putimg
(
    long vcnt,          /* Vertical line count          */
    long gry[]          /* Grey scale lines             */
);

void varchr
(
    long vcnt,          /* Vertical line count                  */
    long *seq           /* Index into character array           */

);
#endif
