#include <stdio.h>
#include "las.h"
#include "protos.h"
/******************************************************************************

NAME:  VARCHR


FUNCTION:    Generate delayed character(s).

PROGRAM HISTORY:
  Version	Date       Author      	          Request
  -------	----	   ------                 -------
   1.0      19-Feb-82     J. Hwang, SASC
   2.0       8-Jan-88     M. Mazzella SAR/GSFC   Convert to C
   3.0      20-Dec-90     K. Donaldson           Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM:

   For all square descriptions
      If the current line belongs to the current square vertical range then
         call GENCHR to generate character(s)
      End-If
   End-For

******************************************************************************/

void varchr
(
    long vcnt,		/* Vertical line count			*/
    long *seq		/* Index into character array		*/
)
{
char	colchr[10];	/* Color characters                     */

long	i,		/*  Loop counter			*/
	l,		/*  Index into table			*/
	rcnt;		/*  Temporary storage slot		*/

#include "externs.h"

strcpy(colchr,"R   G   B");

/*
For all square descriptions:
if the current line belongs to the current square vertical range then
call GENCHR to generate character(s)
----------------------------------------------------------------------
*/
for (i = 0; i < tb[6]; ++i)
   {
   l = i * 10 - 1;
   if (!((vcnt < tb[l + 1]) || (vcnt > tb[l + 1] + tb[3 + l] - 1)))
      {
      if (tb[10 + l] == -2)     
         {
         rcnt = tb[l + 9];
         genchr (vcnt, &tb[1+l], &colchr[(*seq - 1) * 3]);
         tb[l + 9] = rcnt + (*seq / 3);
         }  
      }  
   }  
}
