/******************************************************************
FUNCTION: bandlineread

PURPOSE: Read a line of the specified image
*****************************************************************/
#include "las.h"
#include "cluster.h"

int bandlineread
(
    struct RDESC rdesc[],
    long curl,
    long nmrimg,
    long bandnum,
    unsigned char *bandbuf,
    long numsamp
)

{
long ii = 0;
long bandnumX=0;
long inimage[MAXIMG];
long inbnd[MAXIMG];
long bndrd;
long one=1;
long image;
long fatal = -1;

/* Build arrays for proper image and band selection.
(ie.  if using bands 2,3,4 from image 1 and bands
3,4 from image 2. Bandnum 5 is band 4 from image
2. */

for (image=0;image<nmrimg;image++)
  {
  for (ii=0;ii<rdesc[image].nbands;ii++)
    {
    inimage[bandnumX]=image;
    inbnd[bandnumX]=rdesc[image].bands[ii];
    bandnumX++;
    }
  }

/* Select desired image and band from arrays */

bandnumX = bandnum - 1;
image=inimage[bandnumX];
bndrd=inbnd[bandnumX];

if(c_eread(&rdesc[image].fd,&bndrd,&curl,bandbuf,&one) != numsamp)
  {
  c_errmsg("Error reading image file","cluster-read",&fatal);
  }

return(E_SUCC);
}
