/*******************************************************************************
NAME:		CLOSE_LAS 

PURPOSE:	Close all the LAS files

*******************************************************************************/
#include "las.h"
#include "cluster.h"

int close_las
(
    struct RDESC rdesc[],	/* File descriptors to the images	     */
    long nmrimg		/* Number of input images                    */
)
{
long image;			/* loop index counting the images	     */
long nonfatal = 1;		/* Non-fatal error message status            */

/*
  Close the image files
*/
for (image = 0; image < nmrimg; image++)
 {
 if (rdesc[image].fd > 0)
   {
   if (c_eclose(&rdesc[image].fd) != E_SUCC)
     {
     c_errmsg("Error closing the image file","close_las-close",&nonfatal);
     c_errmsg("Nonfatal error encountered","close_las-nonfatal",&nonfatal);
     }
   }
 }

return(E_SUCC);
}

