
/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: construct.h
 >>>>            Author: 
 >>>> Date Last Updated: Thu Nov  7 15:26:21 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _construct_h_
#define _construct_h_

/*  #include "vinclude.h" */



/****************************************************************
*
*                    construct Argument Structure
*
****************************************************************/

typedef struct _construct  {

/*
 *  input image (Required infile)
 */
char	*i_file;	/* input image FILENAME */
long	 i_flag;	/* input image FLAG */

/*
 *  output containing constructed codebook (Required outfile)
 */
char	*o_file;	/* output containing constructed codebook FILENAME */
long	 o_flag;	/* output containing constructed codebook FLAG */

/*
 *  file showing algorithm execution (Required outfile)
 */
char	*h_file;	/* file showing algorithm execution FILENAME */
long	 h_flag;	/* file showing algorithm execution FLAG */

/*
 *  the number of clusters (Optional integer)
 */
long	 n_int; 	/* the number of clusters INT */
long	 n_flag;	/* the number of clusters FLAG */

/*
 *  number of algorithm iterations (Optional integer)
 */
long	 it_int; 	/* number of algorithm iterations INT */
long	 it_flag;	/* number of algorithm iterations FLAG */

/*
 *  maximum amount of excess memory to allocate (Optional integer)
 */
long	 max_int; 	/* maximum amount of excess memory to allocate INT */
long	 max_flag;	/* maximum amount of excess memory to allocate FLAG */

/*
 *  use logarithm instead of raw data (Optional logical)
 */
long	 log_logic;	/* use logarithm instead of raw data LOGIC */
long	 log_flag;  	/* use logarithm instead of raw data FLAG */

}  construct_struct;

#endif
