/*******************************************************************************
NAME:		OPEN_LAS 

PURPOSE:	Open all the LAS files
*******************************************************************************/
#include "las.h"
#include "cluster.h"


int open_las
(
    struct RDESC rdesc[],		/* File descriptors to the images	     */
    long window[],		/* Window to open input images with	     */
    long nmrimg			/* number of input images                    */
)

{
long	image,			/* loop index counting the images	     */
	status,			/* function return status code               */
	opt[3],			/* type conversion option upon writing image */
	one = 1,		/* value of one				     */
	fatal = -1,		/* fatal error flag			     */
	nonfatal = 1;		/* Non-fatal error message status            */

/*
  Set the output conversion values (only used for write access)
*/
opt[0] = opt[1] = opt[2] = 0;

/*
  Open the input image(s)
*/
for (image = 0; image < nmrimg; image++)
    {
    if (rdesc[image].fd == NULL)
	{
	status = c_eopenr(&rdesc[image].fd, rdesc[image].host[0],
	    &rdesc[image].nbands, &window[SL], &window[SS], &window[NL],
	    &window[NS], &rdesc[image].access, &rdesc[image].dtype, opt, &one);
	if (status != E_SUCC)
	    {
	    c_errmsg("Error opening the input image","open_las-open",&nonfatal);
	    c_errmsg("Fatal error encountered","open_las-fatal",&fatal);
	    }
	}
    }


return(E_SUCC);
}

