/********************************************************
NAME: PUT2LT

PURPOSE:  To write cluster means and covariance matrices
          to a labeled table.

**********************************************************/

#include <stdio.h>
#include "las.h"
#include "cluster.h"

int put2lt
(
    long numbands,
    long numclust,
    float **outlut,
    float ***covar,
    long *pxcnt
)

{
float *ptr;
float *ptr2;
float *hold;

FILE *fstat;		/* output stat file pointer    	*/

long fatal = -1;	/* fatal message              */
long nonfatal = 1;      /* nonfatal error flag        */
long kk,ii,jj,mm;       /* count indicator */

char meanstr[CMLEN][2000];   /* CLuster means string */
char covstr[CMLEN][2000];     /* Covariance string    */
char tmpstr[2000];         /* temp hold string     */




if ((fstat = fopen("outstat2.lt","w+")) == NULL)
  {
  c_errmsg("Error opening output labeled table file","cluster-open",&fatal);
  }

ptr = *outlut;

fprintf(fstat,"%s",";\n");
fprintf(fstat,"%s","\"COVAR\",\"\";\n");
fprintf(fstat,"%s","\"INDEX\",\"I4\",\"unique index number\",1,1\n");
fprintf(fstat,"%s","\"LEVEL\",\"C\",\"\",1,6\n");
fprintf(fstat,"%s","\"NBANDS\",\"I4\",\"\",1,1\n");
fprintf(fstat,"%s","\"CLASS\",\"C\",\"\",1,100\n");
fprintf(fstat,"%s","\"SITE\",\"C\",\"\",1,100\n");
fprintf(fstat,"%s","\"NPOINTS\",\"I4\",\"\",1,1\n");
fprintf(fstat,"%s%d\n","\"MEAN\",\"R8\",\"\",1,",numbands);
fprintf(fstat,"%s,%d,%d%s","\"COVAR\",\"R8\",\"\"",numbands,numbands,";\n");


strcpy(tmpstr,"");
for (ii = 0; ii < numclust; ii++)
  {
  strcpy(meanstr[ii],"");
  }

mm = 0;
for (ii = 0; ii < numclust; ii++)
  {
  for (jj = 0; jj < numbands; jj++)
    {
    sprintf(tmpstr,"%f",ptr[mm]);
    strcat(meanstr[ii],tmpstr);
    strcat(meanstr[ii],",");
    mm++;
    strcpy(tmpstr,"");
    }
  }

hold = malloc(sizeof(float)*numclust*numbands*numbands);
ptr2=hold;
for (ii=0; ii < numclust; ii++)
  {
  for (jj=0; jj< numbands; jj++)
     {
     for ( kk=0; kk<numbands;kk++)
       {
       ptr2[(ii*numbands*numbands)+(jj*numbands)+kk] = covar[ii][jj][kk];
       }
     }
   }





for (ii = 0; ii < numclust ; ii++)
  {
  for (jj = 0; jj < numbands; jj++)
    {
    for (kk = 0; kk < numbands; kk++)
      { 
      if (ptr2[(ii*numbands*numbands)+(jj*numbands)+kk] !=
         ptr2[(ii*numbands*numbands)+(kk*numbands)+jj])
        {
        ptr2[(ii*numbands*numbands)+(kk*numbands)+jj] =
	    ptr2[(ii*numbands*numbands)+(jj*numbands)+kk];
        }
      sprintf(tmpstr,"%f",ptr2[(ii*numbands*numbands)+(jj*numbands)+kk]);
      strcat(covstr[ii],tmpstr);
      if (((jj + 1) == numbands) && ((kk+1) == numbands))
        {
        strcat(covstr[ii],";\n");
        }
      else
        {
        strcat(covstr[ii],",");
        }
      }
    }
  }
for (jj = 0; jj < numclust; jj++)
  {
  if ( jj <= 8)
    {
    kk = jj + 1;
    fprintf(fstat,"%d,%s,%d,%s%d%s,%d,%s%s",kk,"\"CLASS\"",numbands,"\"CLUST0",            kk,"\",\"\"",pxcnt[jj],meanstr[jj],covstr[jj]);
    }
  else
    {
    kk = jj + 1;
    fprintf(fstat,"%d,%s,%d,%s%d%s,%d,%s%s",kk,"\"CLASS\"",numbands,"\"CLUST",
            kk,"\",\"\"",pxcnt[jj],meanstr[jj],covstr[jj]);
    }
  }

if (fclose(fstat) != NULL)
  {
  c_errmsg("Error closing outstat file","cluster-nonfatal",&nonfatal);
  }
free(hold);
return(E_SUCC);
}
