/************************************************************
NAME: SORT3

PURPOSE: Sort a NxM matrix.  Part of the CONSTRUCT program.

************************************************************/

#include <stdio.h>
#include "cluster.h"

void bsort3
(
    float **means,		/* The mean vectors indexed [ cluster ] [ i ] */
    long dim,		/* Size of the vectors */
    long numclust,		/* The number of clusters */
    float *sort_vals	/* The values to sort on */
)

{
	long i ;
	long sflag = 0 ;
	
	while ( sflag != 1 ) {
		sflag = 1;
		for ( i = 1 ; i < numclust ; i++ ) {
			if ( compareb ( sort_vals, means, dim, i-1, i ) == 1 ) {
				swap ( sort_vals, means, i-1, i, dim ) ;
				sflag = 0 ;
			}
		}
	}

}

int compareb
(
    float *sort_vals,
    float **means,
    long dim,
    long i1,
    long i2
)

{
	long i;
	long r;
	float s1;
	float s2;

	r = 0;
	for(i=0,s1=0,s2=0;i<dim;i++) {
		s1 += means[i1][i];
		s2 += means[i2][i];
	}

	if( sort_vals [i1] > sort_vals [i2] ) r = 1;
	if( ( sort_vals [i1] == sort_vals [i2] ) && (s1 > s2) ) r = 1;

	return (r);
}

void swap
(
    float *sort_vals,
    float **means,
    long i1,
    long i2,
    long dim
)

{
	long i;
	float tmp;

	tmp = sort_vals [i1];
	sort_vals [i1] = sort_vals [i2];
	sort_vals [i2] = tmp;

	for( i = 0 ; i < dim ; i++ ) {
		tmp = means[i1][i];
		means[i1][i] = means[i2][i];
		means[i2][i] = tmp;
	}

}
