/*******************************************************
NAME: TIMER

PURPOSE: Returns current user and system use in floating 
         points seconds.  Part of the CONSTRUCT program.

********************************************************/

#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>

#ifdef sun
#define UNITS CLK_TCK
#include <sys/times.h>
#include <limits.h>
struct tms tbuf;
#else
struct rusage ruse;
#endif
#include "cluster.h"

long timer(void)
{
  long time;

#ifdef sun
  times (&tbuf);
  time = tbuf.tms_utime + tbuf.tms_stime;

#else

  getrusage(RUSAGE_SELF, &ruse);
  time = ruse.ru_utime.tv_sec + ruse.ru_stime.tv_sec;
  return(time);
#endif
   

}

