/*******************************************************************************
PROGRAM:  CMEXIST

PURPOSE:  To check for the existence of a file or directory.

Version  Programmer     Date    Modifications
-------  ----------     -----   -------------
  7.0    T.Wolbrink     09/95   Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: ADAPS/LAS

ALGORITHM REFERENCES:
*******************************************************************************/
#include <stdio.h>
#include "las.h"

main()
{
long stdlun;                /* Standard output                              */
char hostname[CMLEN];       /* Host file name                               */
struct PARBLK vblock;       /* TAE parameter block                          */
struct VARIABLE *p_find();  /* Function to retrieve TAE variable            */
struct VARIABLE *val;       /* Pointer to TAE variable with vblock          */

/* Initialize LAS
------------------*/
c_inlas(&vblock, &stdlun);

/* Get FILENAME
-----------------*/
val = p_find(&vblock, "FILENAME");
strcpy (hostname, SVAL(*val,0));

/* Check for the existence of the file
-------------------------------------*/
if (access(hostname,0) != 0)
    c_lasmsg(TRUE,"cmexist-noexist", "\"%s\" does not exist", hostname);

z_exit(1, "CMEXIST completed successfully");
}
