/*******************************************************************************
NAME:    CMLAS

PURPOSE: Convert a host file name to a LAS name

Version  Programmer       Date   Modifications
-------  ---------------  -----  -----------------------------------------------
  2.0    D.Hollaren       06/91  Development
  2.1    J.Fenno          07/92  Changed error messages
  2.2    J.Fenno          11/92  Replaced call to c_complt with z_exit

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS/LAS

ALGORITHM REFERENCES:
*******************************************************************************/
#include <stdio.h>
#include <time.h>
#include "las.h"

main()
{
long fatal    = -1;		/* Fatal error code                           */
long nonfatal =  1;		/* Non-fatal error code                       */
long stdlun;			/* Standard output                            */

char hostname[CMLEN];		/* Host file name                             */
char *str_array[1];		/* Array of text pointers to send params      */

struct PARBLK vblock;		/* TAE parameter block                        */
struct VARIABLE *p_find();	/* Function to retrieve a TAE variable        */
struct VARIABLE *val;		/* Pointer to TAE variable with vblock        */


/* Initialize LAS
-----------------*/
c_inlas(&vblock, &stdlun);


/* Get the file name and ensure it is all lowercase
---------------------------------------------------*/
val = p_find(&vblock, "INFILE");
strcpy(hostname, SVAL(*val,0));


/* Write the file name to the TAE parameter block
-------------------------------------------------*/
str_array[0] = hostname;
if (q_string(&vblock, "OUTFILE", 1, str_array, P_UPDATE) != SUCCESS)
    {
    c_errmsg("Error writing LAS name to vblock", "cmlas-qstring", &nonfatal);
    c_errmsg("Fatal error encountered", "cmlas-fatal", &fatal);
    }


/* Send the parameter block to TAE
-----------------------------------*/
if (q_out(&vblock) != SUCCESS)
    {
    c_errmsg("Error returning LAS file name", "cmlas-vblock", &nonfatal);
    c_errmsg("Fatal error encountered", "cmlas-fatal", &fatal);
    }


/* Display a completion message
-------------------------------*/
z_exit(1, "CMLAS completed successfully");
}
