/*******************************************************************************
FUNCTION:  get_assoc

PURPOSE:   Retrieves the associated files pertaining to an image file.

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	   get_assoc must be run under TAE.

PROJECT			LAS

ALGORITHM REFERENCES	none
*******************************************************************************/

#include <stdio.h>

#ifdef vms
#include <file.h>
#else
#include <sys/file.h>
#endif

#include "las.h"
#include "protos.h"

int cmlist_get_assoc
(
    char *tmpnam,		/*pointer to name for temp file passed to fileutil */
    char *host,			/* pointer to host image name		      */
    char (*assoc_array)[CMLEN],	/*pointer to array for files assoc with img*/
    long *nassoc			/* pointer to number of associated files      */
)

{

long start;			/* value of one to pass to dirlist	      */
short status;			/* return status of calls		      */

char *ptr;			/* pointer to step through name by characters */
char temp[CMLEN];		/* temp host name for parsing		      */

	start = 1;
	strcpy(temp, host);

/* change from .img to .* */
	ptr = (char *)strrchr(temp,'.');
	ptr++;
	*ptr = '*';
	ptr++;
	*ptr = '\0';

	status = dirlist(tmpnam, temp, assoc_array, nassoc, MAXFILES, start);
	if (status != E_SUCC)
	   return(E_FAIL);
	else
	   return(E_SUCC);
}
