/*******************************************************************************
FUNCTION:  getimage

PURPOSE:   Retreives image file information from the ddr file.   

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	   getimage must be run under TAE.

PROJECT			LAS

ALGORITHM REFERENCES	none
*******************************************************************************/

#include <stdio.h>

#ifdef vms
#include <file.h>
#else
#include <sys/file.h>
#endif

#include "las.h"
#include "protos.h"

int getimage
(
    char *hostnm,			/* pointer to image host name		      */
    char *ssize,			/* pointer to image size		      */
    char *snbands,			/* pointer to number of image bands	      */
    char *sdtype			/* pointer to image data type		      */
)

{
struct DDR ddr;			/* structure for receiving ddr record	      */

long one = 1;			/* value of one				      */
long status;			/* return status code			      */


status = c_getddr(hostnm, &ddr);

if (status < E_SUCC)
{
	c_errmsg("Error reading DDR file of image file ","cmlist-warn",&one);
	c_errmsg(hostnm," ",&one);
	strcpy(ssize , "BAD DDR");
	strcpy(snbands , "BAD DDR");
	strcpy(sdtype , "BAD DDR");
}
else
{
	sprintf(ssize,"(%d,%d)",ddr.nl, ddr.ns);
	sprintf(snbands,"%d  ",ddr.nbands);
	switch(ddr.dtype)
	{	
		case EBYTE:
			strcpy(sdtype,"BYTE  ");
			break;
		case EWORD:
			strcpy(sdtype,"I*2   ");
			break;
		case ELONG:
			strcpy(sdtype,"I*4   ");
			break;
		case EREAL:
			strcpy(sdtype,"REAL  ");
			break;
	}
}
return(E_SUCC);
}
