/*****************************************************************************
FUNCTION:  isimage

PURPOSE:   Checks to see if the current file is an image or associated
           file by statusing the existence of a img file with the same
           root name.

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
           isimage must be run under TAE.

PROJECT                 LAS

ALGORITHM REFERENCES    none
*****************************************************************************/

#include <stdio.h>

#ifdef vms
#include <file.h>
#else
#include <sys/file.h>
#endif

#include "las.h"
#include "labserv.h"
#include "protos.h"

int isimage
(
    char *filename            /* pointer to file name                       */
)

{
long status;                  /* return status code                         */
long zero = 0;                /* value of zero                              */

char *inptr;                  /* pointer to step through name by characters */
char hnm[CMLEN];              /* host image name without extension          */
char imgnm[CMLEN];            /* image name without extension               */

inptr = (char *)strrchr(filename, '.');
if (inptr != 0)
   {
   inptr++;
   if ((strcmp(inptr,"img") == 0) || (strcmp(inptr,"IMG") == 0))
      return(TRUE);
   }
else
      return(FALSE);

/* The following code is the remnant of allowing image file names to have   */
/* non-default (img) extensions and yet still be listed by catalog manager. */
/* The retrieval and/or listing of offline files prohibit this.             */
strcpy(imgnm, filename);
if (*imgnm != '\0')
   {
   if ((inptr = (char *)strrchr(imgnm, '.')) != NULL)
      inptr = '\0';
   strcat(imgnm,".img");
   status = c_lsstat(hnm,&zero);
   if (status != E_SUCC)
      return(FALSE);
   else
      return(TRUE);
   }

return(FALSE);
}
