/*******************************************************************************
FUNCTION:  isimgfl

PURPOSE:   Checks to see if the current file is an image file by checking the
	   file extension against img.  Wild card specifications will only pick
	   up image and associated file arrays if the image file has the 
	   default img extension.  Non-default, user-specified image file name 
	   extensions are not picked up by wild cards, but rather must be 
	   picked up by naming them explicityly.  Refer to the document Review 
	   of LAS 5.0 Catalog Manager.

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	   isimgfl must be run under TAE.

PROJECT			LAS

ALGORITHM REFERENCES	none
*******************************************************************************/

#include <stdio.h>

#ifdef vms
#include <file.h>
#else
#include <sys/file.h>
#endif

#include "las.h"
#include "protos.h"

int isimgfl
(
    char *hnam			/* pointer to host file name		      */
)
{
char *ptr;			/* local character pointer		      */

ptr = (char *)strrchr(hnam,HOST_EXT);
ptr++;
if ((strcmp(ptr,"img") != 0) && (strcmp(ptr,"IMG") != 0))
   return(FALSE);
else
   return(TRUE);
}
