/*****************************************************************************
FUNCTION:  long_attrib

PURPOSE:   Selects file names and formats output according to long option.

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
           long_attrib must be run under TAE.

PROJECT                 LAS

ALGORITHM REFERENCES    none
*****************************************************************************/

#include <stdio.h>
#include <sys/file.h>
#include "las.h"
#include "protos.h"

#define totfil curent         /* processing message counter                 */

#define FIRST_IMG  1          /* flags for breaking printing of file groups */
#define SAME_ASSOC 2          /* with blank lines                           */
#define LAST_ASSOC 3
#define NON_IMG    4
#define HEADER     5
int long_attrib
(

    char *tmpnam,             /* pointer to name of tmp file for fileutil   */
    char *filename,           /* pointer to file name                       */
    long nfiles,              /* number of files for current dircetory      */
    long start,               /* counter for number of files                */
    FILE *fp,                 /* file pointer for temp file sent to fileutil*/
    char (*file_array)[CMLEN], /* pointer to array of input file list       */
    long *assoc,              /* pointer to flag to include assoc files     */
    char (*assoc_array)[CMLEN], /* pointer to array of assoc files          */
    long *gbl_nfiles,         /* pointer to counter for parameter nfiles    */
    long *totfil_set,         /* flag for adjusting by 1 cause curent init 1*/
    long *prev_file           /* flg for format if prev file was assoc w img*/
)

{

long first = FALSE;           /* flag for printing image info for assoc fils*/
long header_done = FALSE;     /* flag signifying headers have been written  */
long i;                       /* loop counter                               */
long is_image;                /* flag for image file or not                 */
long is_imgfl;                /* flag for image file or not                 */
long j;                       /* loop counter                               */
long nassoc;                  /* number of associated files for an image    */
long second_header = FALSE;   /* flag for writing of second header          */
short status;                 /* return status of calls                     */

char credate[100];            /* creation date of current file              */
char dir[CMLEN];              /* directory of current file                  */
char hostdsc[CMLEN];          /* host file name                             */
char imgnam[CMLEN];           /* host image file name within assoc_array    */
char pfile[CMLEN];            /* host file name for print file              */
char *ptr;                    /* pointer to step through name by characters */
char save_root[CMLEN];        /* prev root name to check against current    */
char sdtype[20];              /* data type of image                         */
char snbands[20];             /* number of bands of image                   */
char ssize[20];               /* size of image                              */
char root[CMLEN];             /* name minus extension                       */
char wd[CMLEN];               /* current working directory name             */

extern long curent;           /* processing message file counter            */

                              /* macro to print files names with all attribs*/
#define LONG_PRINT()\
{\
ptr = (char *)strrchr(hostdsc, '/');\
ptr++;\
strcpy(pfile, " ");\
strcpy(pfile, ptr);\
if (is_image)\
   {\
   if ((*prev_file == LAST_ASSOC) || (*prev_file == NON_IMG))\
      fprintf(fp,"\n");\
   }\
else\
   {\
   if (*prev_file == LAST_ASSOC)\
      fprintf(fp,"\n");\
   }\
if (first)\
   {\
   fprintf(fp,"%-39.39s\n", pfile);\
   fprintf(fp,"   %-13.13s :  %s\n","NL,NS",ssize);\
   fprintf(fp,"   %-13.13s :  %s\n","Nbands",snbands);\
   fprintf(fp,"   %-13.13s :  %s\n","Data Type",sdtype);\
   fprintf(fp,"   %-13.13s :  %s\n","Creation Date",credate);\
   fprintf(fp,"   %-13.13s :  %s\n","Host Name",hostdsc);\
   }\
else\
   {\
   fprintf(fp,"%-39.39s\n", pfile);\
   fprintf(fp,"   %-13.13s :  %s\n","Creation Date",credate);\
   fprintf(fp,"   %-13.12s :  %s\n","Host Name",hostdsc);\
   }\
}


if ((start == 1) && (!header_done))
        {
        strcpy(dir, filename);
        ptr = (char *)strrchr(dir, '/');
        if (ptr != 0)
                {
                ptr++;
                *ptr = '\0';
                }
        else
                {
                getcwd(wd,CMLEN);
                status = cmtaedir(wd, dir);
                if (status != E_SUCC)
                   return(E_FAIL);
                ptr = (char *)strrchr(dir, '/');
                if (ptr != 0)
                        {
                        ptr++;
                        *ptr = '\0';
                        }
                }
                fprintf(fp,"\n%s\n",dir);
                header_done = TRUE; 
                
        }
if (*gbl_nfiles == 0)
        fprintf(fp,"\n### NO FILES MATCHED ###\n");

for(i = 0; i < nfiles; i++)
        {
        if (*totfil_set)                      /* increment curent           */
           totfil++;
        else
           *totfil_set = TRUE;

        strcpy(hostdsc,file_array[i]);

        strcpy(root, hostdsc);                   /* check for new root name */
        if ((ptr = strrchr(root, '.')) != NULL)
            *(ptr+1) = '\0';
        if ((strcmp(root,save_root) != 0) || (!(*assoc)))
                {
                strcpy(save_root,root);
                                   /* get the directory name for first file */
                if (i == 0 && start == 1 && !second_header)
                        {
                        fprintf(fp,"\nFile Name\n---------\n");
                        second_header = TRUE;
                        *prev_file = HEADER;
                        }

                                              /* check if it is an image,   */
                                              /* set flags for print format */
                strcpy(ssize , " ");
                strcpy(snbands , " ");
                strcpy(sdtype , " ");
                is_image = isimage(hostdsc);
                if (is_image)
                     {
                     status = cmlist_get_assoc(tmpnam,hostdsc,assoc_array,
                                               &nassoc);
                     if (status != E_SUCC)
                        return(E_FAIL);
                     is_imgfl = FALSE;
                     first = TRUE;
                     j = 0;
                     while ((j < nassoc) && (!is_imgfl))
                           {
                           strcpy(hostdsc,assoc_array[j]);
                           is_imgfl = isimgfl(hostdsc);
                           if (is_imgfl)
                              {
                              status = getimage(hostdsc,ssize,snbands,sdtype);
                              if (status != E_SUCC)
                                 return(E_FAIL);
                              getcredate(hostdsc, credate);
                              LONG_PRINT()        /* print image file first */
                              *prev_file = FIRST_IMG;
                              first = FALSE;
                              strcpy(imgnam,hostdsc);
                              }
                           j++;
                           }
                     for (j = 0; j < nassoc; j++)
                           {
                           strcpy(hostdsc,assoc_array[j]);
                           if (strcmp(hostdsc,imgnam) != 0)
                              {
                              getcredate(hostdsc, credate);
                              LONG_PRINT()        /* print associated files */
                              *prev_file = SAME_ASSOC;
                              }
                           }
                     *prev_file = LAST_ASSOC;
                     }
                else
                        {
                        getcredate(hostdsc, credate);
                        LONG_PRINT()     /* print non image-associated file */
                        *prev_file = NON_IMG;
                        }
                }
                
        }
return(E_SUCC);
}
