/*****************************************************************************
FUNCTION:  no_attrib_all

PURPOSE:   Selects file names and formats output according to no option.  This 
           function is called only if all files are requested.  No image file 
           checking is done, thereby speeding up the processing of this, the 
           smallest amount of output.

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
           no_attrib_all must be run under TAE.

PROJECT                 LAS

ALGORITHM REFERENCES    none
*****************************************************************************/

#include <stdio.h>
#include <sys/file.h>
#include "las.h"
#include "protos.h"

#define totfil curent

int no_attrib_all
(

    char *filename,           /* pointer to file name                       */
    long nfiles,              /* number of files for current dircetory      */
    long start,               /* counter for number of files                */
    FILE *fp,                 /* file pointer for temp file sent to fileutil*/
    char (*file_array)[CMLEN], /* pointer to array for input file list      */
    long *gbl_nfiles,         /* pointer to counter for parameter nfiles    */
    long *totfil_set          /* pointer to flag for adjusting curent-init 1*/
)
{

long header_done = FALSE;     /* flag signifying headers have been written  */
long i;                       /* loop counter                               */

char dir[CMLEN];              /* directory of current file                  */
char hostdsc[CMLEN];          /* host file name                             */
char pfile[CMLEN];            /* host file name for print file              */
char *ptr;                    /* pointer to step through name by characters */
char wd[CMLEN];               /* current working directory name             */

extern long curent;           /* processing message file counter            */

                              /* macro to print with no attributes          */
#define NO_PRINT_ALL()\
{\
ptr = (char *)strrchr(hostdsc, '/');\
ptr++;\
strcpy(pfile, ptr);\
fprintf(fp,"%s\n", pfile);\
}
if ((start == 1) && (!header_done))
        {
        strcpy(dir, filename);
        ptr = (char *)strrchr(dir, '/');
        if (ptr != 0)
                {
                ptr++;
                *ptr = '\0';
                }
        else
                {
                getcwd(wd,CMLEN);
                if (cmtaedir(wd, dir) != E_SUCC)
                   return(E_FAIL);
                ptr = (char *)strrchr(dir, '/');
                if (ptr != 0)
                        {
                        ptr++;
                        *ptr = '\0';
                        }
                }
        fprintf(fp,"\n%s\n",dir);
        header_done = TRUE; 
        }
if (*gbl_nfiles == 0)
        fprintf(fp,"\n### NO FILES MATCHED ###\n");

for(i = 0; i < nfiles; i++)
        {
        if (*totfil_set)                      /* increment curent           */
           totfil++;
        else
           *totfil_set = TRUE;

        strcpy(hostdsc,file_array[i]);

        NO_PRINT_ALL()
        }
return(E_SUCC);
}
