/*****************************************************************************
FUNCTION:  no_attrib

PURPOSE:   Selects file names and formats output according to no option.  This
           function is called if only image and their associated files are 
           requested (*).

PROGRAM HISTORY:
Version  Date   Author         Change Request
-------  -----  -------------  --------------
  ???    ??/??  ???????        Original development
  5.3    10/91  J.Fenno        Added header and run through Saber-C.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
           no_attrib must be run under TAE.

PROJECT                 LAS

ALGORITHM REFERENCES    none
*****************************************************************************/

#include <stdio.h>
#include <sys/file.h>
#include "las.h"
#include "protos.h"

#define totfil curent         /* processing message counter                 */
int no_attrib
(

    char *tmpnam,             /* pointer to tmp file name passed to fileutil*/
    char *filename,           /* pointer to file name                       */
    long nfiles,              /* number of files for current dircetory      */
    long start,               /* counter for number of files                */
    FILE *fp,                 /* file pointer for temp file sent to fileutil*/
    char (*file_array)[CMLEN], /* pointer to array of input file list       */
    char (*assoc_array)[CMLEN], /* pointer to array of assoc files          */
    long *gbl_nfiles,         /* pointer to counter for parameter nfiles    */
    long *totfil_set,         /* flag for adjusting by 1 cause curent init 1*/
    long *prev_img            /* flg for format if prev file was assoc w img*/
)

{

long header_done = FALSE;     /* flag signifying headers have been written  */
long i;                       /* loop counter                               */
long imgfl_found;             /* flag,img file found in array of assoc files*/
long is_image;                /* flag for image file or not                 */
long is_imgfl;                /* flag for image file or not                 */
long j;                       /* loop counter                               */
long nassoc;                  /* number of associated files for an image    */
long second_header = FALSE;   /* flag for writing of second header          */
short status;                 /* return status of calls                     */

char dir[CMLEN];              /* directory of current file                  */
char hostdsc[CMLEN];          /* host file name                             */
char hostnam[CMLEN];          /* host file name                             */
char pfile[CMLEN];            /* host file name for print file              */
char *ptr;                    /* pointer to step through name by characters */
char save_root[CMLEN];        /* prev root name to check against current    */
char root[CMLEN];             /* name minus extension                       */
char wd[CMLEN];               /* current working directory name             */

extern long curent;           /* processing message file counter            */

                              /* macro to print with no attributes          */
#define NO_PRINT()\
{\
ptr = (char *)strrchr(hostdsc, '/');\
ptr++;\
if (((is_image) && (!*prev_img)) || ((!is_image) && (*prev_img)))\
   fprintf(fp,"\n");\
strcpy(pfile, ptr);\
fprintf(fp,"%s\n", pfile);\
}
if ((start == 1) && (!header_done))
        {
        strcpy(dir, filename);
        ptr = (char *)strrchr(dir, '/');
        if (ptr != 0)
                {
                ptr++;
                *ptr = '\0';
                }
        else
                {
                getcwd(wd,CMLEN);
                status = cmtaedir(wd, dir);
                if (status != E_SUCC)
                   return(E_FAIL);
                ptr = (char *)strrchr(dir, '/');
                if (ptr != 0)
                        {
                        ptr++;
                        *ptr = '\0';
                        }
                }
        fprintf(fp,"\n%s\n",dir);
        header_done = TRUE; 
        }
if (*gbl_nfiles == 0)
        fprintf(fp,"\n### NO FILES MATCHED ###\n");

for(i = 0; i < nfiles; i++)
        {
        if (*totfil_set)                      /* increment curent           */
           totfil++;
        else
           *totfil_set = TRUE;

        strcpy(hostdsc,file_array[i]);

                                           /* compare to prev img root name */
        strcpy(root, hostdsc);
        if ((ptr = strrchr(root, '.')) == NULL)
           return E_FAIL;
        *ptr = '\0';
        if (strcmp(root,save_root) != 0)      
                {
                strcpy(save_root,root);

                                   /* get the directory name for first file */
                if (i == 0 && start == 1 && !second_header)
                        {
                        fprintf(fp,"\nFile Name\n---------\n");
                        second_header = TRUE;
                        }
                                              /* check if it is an image,   */
                                              /* set flags for print format */
                is_image = isimage(hostdsc);
                if (is_image)
                        {
                        status = cmlist_get_assoc(tmpnam,hostdsc,assoc_array,
                                                  &nassoc);
                        if (status != E_SUCC)
                           return(E_FAIL);
                        j = 0;
                        imgfl_found = FALSE;
                        is_imgfl = FALSE;
                        for (j = 0;j < nassoc; j++)
                           {
                           strcpy(hostnam,assoc_array[j]);
                         /* if image file has not been found in assoc_array */
                           if (!imgfl_found)
                              is_imgfl = isimgfl(hostnam);
                           if (is_imgfl)
                              {
                              strcpy(hostdsc, hostnam);
                              NO_PRINT()                /* print image file */
                              imgfl_found = TRUE;
                              is_imgfl = FALSE;
                              *prev_img = TRUE;
                              }
                           else
                              {
                              strcpy(hostdsc, hostnam);
                              NO_PRINT()           /* print associated file */
                              *prev_img = TRUE;
                              }
                           }
                        *prev_img = FALSE;
                        }
                else
                        {
                        NO_PRINT()       /* print non image-associated file */
                        *prev_img = FALSE;
                        }
                }
        }
return(E_SUCC);
}
