/******************************************************************************

FUNCTION:	VALIDATE

PURPOSE:	checks the input directory name for validity
   		the directory name must be enclosed in brackets []
   		the directory name must begin with an alphanumeric character,
     			".", or "-."
   		no wildcard characters are permitted	

FATAL ERROR CONDITIONS:	Specification error occurrs when:

ALGORITHM(flow)
  check for
     beginning and ending bracket
     beginning ., -, or alphanumeric character
     wild card characters
  if any of above conditions exist
     call errmsg and return E_FAIL

******************************************************************************/


#include <stdio.h>
#include <ctype.h>
#include "las.h"

#ifdef vms
#include <file.h>
#else
#include <sys/file.h>
#endif

#include "protos.h"

void validate
(
    char *tstring					/* contains dir name	*/
)
{
long  col;					/* position of colon for
						   device specification */
long len;					/* length of tstring	*/
long fatal = 0;					/* value of zero	*/
long one = 1;					/* value of one 	*/

len = (long) strlen (tstring);
col = len;

#ifdef vms
col = strcspn(tstring,":");
#endif

if (col != len)			/* Handle VMS device. */
   {
   if ((tstring[col+1] != '[')  || (tstring[len-1] != ']')  ||
       (!isalnum(tstring[col+2])) || (tstring[col+2] == '.')
          || (tstring[col+2] == '-') || (strcspn (tstring,"*?") != len))
         {
         c_errmsg ("Specification error","cmset-name",&one);
         c_errmsg ("Fatal error encountered","cmset-fatal",&fatal);
         }
   }
}
