/******************************************************************************

PROGRAM:	CMSHOW

PURPOSE:	SHOWS current working directory TAE name

FATAL ERROR CONDITIONS:	
			Error retrieving tae directory name

PROGRAM HISTORY:
  Version       Date        Author           Code/Contr       Change Request
  -------       ----        ------           ----------       --------------
   1.0		10/86       T. Butzer		CSB	      New Development
   5.0	        09/88       B. Davis	        CSB	      Conversion to 5.0
   5.1           9/89       P. Pease            GSFC          Move all system 
                                                              include files to
                                                              before any las 
                                                              includes.
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	MUST BE RUN UNDER TAE 

ALGORITHM(flow)
  call inlas to intialize tae
  call getwd to get host name of current directory
  call cmtaedir to get tae naem of current dirctory
  use c_errmsg to display to the standard output
  call complt to terminate

******************************************************************************/

#include <stdio.h>

#ifdef vms
#include <file.h>
#else
#include <sys/file.h>
#endif

#include "las.h"
#include "util.h"

void main()
{
struct	PARBLK	vblock;			/* tae parameter block		     */

long fatal = 0;				/* value of zero		     */
long one = 1;				/* value of one			     */
long numout;				/* number of output files for complt */
long status;				/* return status of support calls    */
long stdlun;				/* logical unit # of standard output */

char dir[CMLEN]; 			/* host directory name		     */
char msg[CMLEN]; 			/* display message    		     */
char outdsc[1][CMLEN];			/* output file name		     */
char pname[CMLEN];			/* program name			     */
char taedir[CMLEN];			/* tae directory name		     */
/*****************************************************************************/

	c_inlas(&vblock, &stdlun);
#if defined (aiws) || (sun)
	getcwd(dir,CMLEN);
#else
	getwd(dir);
#endif
	status = cmtaedir(dir,taedir);
	if (status != E_SUCC)
           c_errmsg("Fatal error encountered","cmshow-fatal",&fatal);

        sprintf (msg,"Current working directory:");

	c_errmsg(msg," ",&one);

        sprintf (msg,"%s\n",taedir);

	c_errmsg(msg," ",&one);

	strcpy(pname,"CMSHOW");

	numout = 0;

	c_complt(pname,outdsc,&numout);	
}

