/*******************************************************************************
PROGRAM:  CMSTATUS

PURPOSE:  Determine if a file or directory exists or not.

Version  Programmer     Date    Modifications
-------  ----------     -----   -------------
  1.0    T.Ratliff      07/98   Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: ADAPS/LAS

ALGORITHM REFERENCES:
*******************************************************************************/
#include <stdio.h>
#include "las.h"

main()
{
  long stdlun;                /* Standard output                        */
  long status;                /* Return status of a function            */
  char *str_ptr[1];           /* Pointer to a string for q_string       */
  char str_status[5];         /* YES/NO status                          */
  char hostname[CMLEN];       /* Host file name                         */
  char taename[CMLEN];        /* TAE file name                          */
  struct PARBLK vblock;       /* TAE parameter block                    */
  struct VARIABLE *p_find();  /* Function to retrieve TAE variable      */
  struct VARIABLE *val;       /* Pointer to TAE variable with vblock    */

  /* Initialize LAS
  -----------------*/
  c_inlas(&vblock, &stdlun);

  /* Get INFILE
  -------------*/
  val = p_find(&vblock, "INFILE");
  strcpy(taename, SVAL(*val,0));
  c_cmhost(taename,hostname);

  /* Check for the existence of the file
     or directory
  --------------------------------------*/
  if (access(hostname,0) == 0)
    sprintf(str_status,"YES");
  else
    sprintf(str_status,"NO");

  str_ptr[0] = str_status;
  status = q_string(&vblock,"STATUS",1,str_ptr,P_UPDATE);
  status = q_out(&vblock);

  z_exit(1, "CMSTATUS completed successfully");
}
