/******************************************************************************

PROGRAM:   		COMBINE

PURPOSE:   To copy columns from either data files or LT files into data files
	   or LT files.

PROGRAM HISTORY:
 mode Version   Date        Author           Code/Contr       Change Request
  -------       ----        ------           ----------       --------------
   5.0		 2/92	    T. Mittan		CSB         Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
    COMBINE must be run under TAE. 


PROJECT	       	LAS		                

******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"	
#include "ltable.h"
#include "combine.h"
#include "desc.h"
#include "util.h"
#include "protos.h"

int main
(void)
{
struct	PARBLK		vblock;		 /* Parameter block		     */

static	char		artnames1[20][CMLEN]; /* attribute names of LT file  */
static	char		artnames2[2][CMLEN]; /* attribute names of LT file   */
static	char 		inlt1[CMLEN];    /* first input LT name              */
static	char 		inlt2[CMLEN];    /* second LT name	             */
static	char 		indat1[CMLEN];   /* first input file name            */
static	char 		indat2[CMLEN];   /* second input file name           */
static	char	        keyname[CMLEN];  /* attribute name of first LT keycol*/
static	char 		outfile[1][CMLEN];  /* output file name                 */
static	char 		outlt[1][CMLEN];    /* output LT name  	             */
static	char 		outtyp[10];      /* output type		             */
 
	long		append_flg = FALSE; /* append flag		     */
        long		fatal = -1;	 /* fatal error constant	     */
	long		incol;	         /* input column		     */
	long		incol_count;	 /* number of input atrnames	     */
	long 		key_col_lt;      /* key value	 	             */
	long 		key_col_dat;     /* key value	 	             */
	long		ltflg = FALSE;	 /* labeled table flag		     */
	long		main_ltflg = FALSE; /* labeled table flag	     */
	long		msgtim;		 /* message time		     */
	long		one = 1;   	 /* Constant one		     */
	long		outcol;		 /* output column		     */
	long		width_1[41];	 /* column widths		     */
	long		width_2[41];	 /* column widths		     */

	double		out_width;	 /* output format width		     */


/* Get user specified parameters 
------------------------------*/
if (getpar(&vblock,inlt1,inlt2,indat1,indat2,outfile[0],&incol,
	         &key_col_dat,&key_col_lt,&outcol,outtyp,&ltflg,width_1,
	         width_2,&out_width,artnames1,artnames2,&append_flg,
		     &main_ltflg,&incol_count,outlt[0],keyname,&msgtim) != E_SUCC)
            c_errmsg("Fatal error encountered","combine-fatal",&fatal);
           

/* Copy input columns to output file
----------------------------------*/
if (!main_ltflg)
   {
   if ( proces(inlt1,indat1,indat2,outfile[0],&incol,&key_col_dat,
	              &key_col_lt,&outcol,outtyp,&ltflg,width_1,width_2, 
			      &out_width,artnames1,&append_flg,&msgtim) != E_SUCC)
            {
            c_clean(&vblock,"combine",outfile,&one);
            c_errmsg("Fatal error encountered","combine-fatal",&fatal);
            }
   }
else
   {
   if (ltproces(inlt1,inlt2,outlt[0],&outcol,artnames1,artnames2,
	   	         &incol_count,keyname,&msgtim) != E_SUCC)
            {
            c_clean(&vblock,"combine",outlt,&one);
            c_errmsg("Fatal error encountered","combine-fatal",&fatal);
            }
   }

/* Output completion message 
--------------------------*/
if (!main_ltflg)
   c_complt("COMBINE",outfile,&one);
else
   c_complt("COMBINE",outlt,&one);

  return EXIT_SUCCESS;
}  /* End of main */
