#ifndef PROTOS_H
#define PROTOS_H

int getpar
(
    struct PARBLK *vblock,        /* Parameter block	             */
    char inlt1[],        /* first input LT  name	     	     */
    char inlt2[],        /* second input LT  name	     */
    char indat1[],       /* first input file name	     */
    char indat2[],       /* second input file name	     */
    char outfile[],      /* output file name  		     */
    long *incol,         /* input column	           	     */
    long *key_col_dat,	/* search key			     */
    long *key_col_lt,	/* search key			     */
    long *outcol,        /* output column		     */
    char outtyp[],	/* output type			     */
    long *ltflg,		/* lt flag			     */
    long *width_1,	/* column widths		     */
    long *width_2,	/* column withs			     */
    double *out_width,	/* output format width		     */
    char atrnames1[][CMLEN],/* first LT attribute names       */
    char atrnames2[][CMLEN],/* second LT attribute names      */
    long *append_flg,	/* append flag			     */
    long *main_ltflg,	/* lt flag			     */
    long *incol_count,   /* number of input lt atrnames       */
    char outlt[],        /* output LT name  		     */
    char key_name[],     /* first LT keycol attribute name    */
    long *msgtim        /* message time			     */
);

void labtabop
(
    struct TAB_DEF *out_tab,	/* table descriptor 			*/
    struct TAB_DEF *tab,		/* table descriptor 			*/
    long *incol_cnt,		/* number of output columns needed 	*/
    char *hosout,			/* host output file name 		*/
    struct VECTOR *ptr[],		/* ptr to current table position	*/
    char atrname[][CMLEN],		/* attribute names of each column 	*/
    long *outcol,			/* output column			*/
    char *desc,			/* outcol LT descriptor			*/
    long *dtype			/* outcol data type			*/
);

int ltfind
(
    char *inlt,			/* LT name				*/
    char atrname[][CMLEN],		/* names of the specified attributes 	*/
    char lt1_buf[][80],		/* keycol array				*/
    char lt2_buf[][80],		/* incol array				*/
    long *count,			/* number of rows in LT file		*/
    char *desc,			/* Lt description of incol		*/
    long *dtype			/* data type of incol			*/
);

int ltproces
(
    char *inlt1,      	        /* input lt name	             */
    char *inlt2,      	        /* input lt name	             */
    char *outlt,			/* output ltfile		     */
    long *outcol,			/* output column		     */
    char artnames1[][CMLEN],        /* LT attribute names		     */
    char artnames2[][CMLEN],        /* LT attribute names		     */
    long *incol_count,		/* number of input atrnames	     */
    char *key_name,			/* KEYCOL attribute name             */
    long *msgtim
);

int proces
(
    char *inlt1,      	        /* input lt name	             */
    char *indat1,	   	        /* first input data name	     */
    char *indat2,	   	        /* secondinput data name	     */
    char *outfile,   	        /* output name	        	     */
    long *incol,			/* input column			     */
    long *key_col_dat,              /* key column of first data column   */
    long *key_col_lt,               /* key column of second data column  */
    long *outcol,			/* output column		     */
    char *outtyp,   	        /* data type of output column	     */
    long *ltflg,			/* input lt file flag		     */
    long *width_1,			/* widths of columns of first in file */
    long *width_2,			/* widths of columns of second in file*/
    double *out_width,		/* format of output column	     */
    char artnames1[][CMLEN],        /* LT attribute names		     */
    long *append_flg,		/* input lt file flag		     */
    long *msgtim			/* message time			     */
);

void setvec
(
    struct TAB_DEF *tab,		/* table descriptor 			*/
    long coln,			/* current column			*/
    struct VECTOR **ptr,		/* pointer to current table position	*/
    char atrname[][CMLEN],		/* attribute names of each column 	*/
    char *sep,			/* field seperator 			*/
    long *outcol,			/* output column			*/
    char *desc,			/* attribute descrptions of output column */
    long *dtype			/* outcol data type			*/
);

void writevec
(
    struct TAB_DEF *tab,		/* output labeled table descriptor */
    struct VECTOR *ptr[],		/* pointer to current vector */
    long *outcol,			/* output columns needed */
    long *dtype,			/* dtype of columns needed */
    union DATA *data,		/* data buffer */
    long *totcount
);


#endif


