/******************************************************************************

NAME:	SETVEC

FUNCTION:  SETVEC sets the vector data needed for each column

PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    1           3/92      T. Mittan     original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM (FLOW):
Write each vector field according to the data type of input column.

******************************************************************************/
#include "las.h"
#include "ltable.h"
#include "combine.h"
#include "protos.h"

void setvec
(
    struct TAB_DEF *tab,		/* table descriptor 			*/
    long coln,			/* current column			*/
    struct VECTOR **ptr,		/* pointer to current table position	*/
    char atrname[][CMLEN],		/* attribute names of each column 	*/
    char *sep,			/* field seperator 			*/
    long *outcol,			/* output column			*/
    char *desc,			/* attribute descrptions of output column */
    long *dtype			/* outcol data type			*/
)

{ 

if (coln < (*outcol - 1))
   {
   /*  Write each vector field according to the data type of input column.
   ---------------------------------------------------------------------*/
   switch (ptr[coln]->dtype)
     {
     case (0):put_vector(tab,ptr[coln]->label,C,ptr[coln]->desc,1,
   		       MAX_FIELD_LEN,sep[coln]);
              break;
     case (1):put_vector(tab,ptr[coln]->label,I1,ptr[coln]->desc,1,1,sep[coln]);
              break;
     case (2):put_vector(tab,ptr[coln]->label,I2,ptr[coln]->desc,1,1,sep[coln]);
              break;
     case (3):put_vector(tab,ptr[coln]->label,I4,ptr[coln]->desc,1,1,sep[coln]);
              break;
     case (4):put_vector(tab,ptr[coln]->label,R4,ptr[coln]->desc,1,1,sep[coln]);
              break;
     case (5):put_vector(tab,ptr[coln]->label,R8,ptr[coln]->desc,1,1,sep[coln]);
              break;
     } 
   }
else
if (coln == (*outcol - 1))
   {
   switch (*dtype)
      {
      case (0):put_vector(tab,atrname[1],C,desc,1,MAX_FIELD_LEN,sep[coln]);
               break;
      case (1):put_vector(tab,atrname[1],I1,desc,1,1,sep[coln]);
               break;
      case (2):put_vector(tab,atrname[1],I2,desc,1,1,sep[coln]);
               break;
      case (3):put_vector(tab,atrname[1],I4,desc,1,1,sep[coln]);
               break;
      case (4):put_vector(tab,atrname[1],R4,desc,1,1,sep[coln]);
               break;
      case (5):put_vector(tab,atrname[1],R8,desc,1,1,sep[coln]);
               break;
      } 
   }
else
   {
   switch (ptr[coln - 1]->dtype)
     {
     case (0):put_vector(tab,ptr[coln - 1]->label,C,ptr[coln - 1]->desc,1,
   		       MAX_FIELD_LEN,sep[coln]);
              break;
     case (1):put_vector(tab,ptr[coln - 1]->label,I1,ptr[coln - 1]->desc,1,1,
			sep[coln]);
              break;
     case (2):put_vector(tab,ptr[coln - 1]->label,I2,ptr[coln - 1]->desc,1,1,
			sep[coln]);
              break;
     case (3):put_vector(tab,ptr[coln - 1]->label,I4,ptr[coln - 1]->desc,1,1,
			sep[coln]);
              break;
     case (4):put_vector(tab,ptr[coln - 1]->label,R4,ptr[coln - 1]->desc,1,1,
			sep[coln]);
              break;
     case (5):put_vector(tab,ptr[coln - 1]->label,R8,ptr[coln - 1]->desc,1,1,
			sep[coln]);
              break;
     } 
   }
return;
} 
