/******************************************************************************

NAME:	WRITEVEC

FUNCTION:  WRITEVEC writes the column data to the correct vector of the
	   output labeled table file

PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    5.0		3/92	   T.Mittan	Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM (FLOW):
Based on data type
   Write the column value to the correct vector of the labled table file

******************************************************************************/
#include <string.h>
#include "las.h"
#include "ltable.h"
#include "combine.h"
#include "protos.h"

void writevec
(
    struct TAB_DEF *tab,		/* output labeled table descriptor */
    struct VECTOR *ptr[],		/* pointer to current vector */
    long *outcol,			/* output columns needed */
    long *dtype,			/* dtype of columns needed */
    union DATA *data,		/* data buffer */
    long *totcount
)

{ /* writerow */

struct MATRIX size;		/* matrix size */
struct VECTOR *out_ptr;	        /* pointer to current vector */

long coln;			/* current column number	*/

/* Initialize needed variables
------------------------------*/
size.ncol = 1;	
size.nrow = 1;

out_ptr = tab->vector;
/* write each column according the the data type of each column
---------------------------------------------------------------*/
for (coln = 0; coln <= *totcount; coln++)
  {
  if (coln < (*outcol - 1))
    {
    switch (ptr[coln]->dtype)
       {  
       case (C): 
          size.ncol = (long) strlen(data[coln].chr);
          strcpy(out_ptr->ptr.c,data[coln].chr);
          break;
       case (I1): 
     	  put_matrix(out_ptr,I1,&size,(unsigned char *) &data[coln].byte);
               break;
       case (I2): 
   	  put_matrix(out_ptr,I2,&size,(unsigned char *) &data[coln].i2);
               break;
       case (I4): 
     	  put_matrix(out_ptr,I4,&size,(unsigned char *) &data[coln].i4);
               break;
       case (R4): 
   	  put_matrix(out_ptr,R4,&size,(unsigned char *) &data[coln].r4);
          break;
       case (R8): 
   	  put_matrix(out_ptr,R8,&size,(unsigned char *) &data[coln].r8);
          break;
       } /* case dtype */
     }
  else
  if (coln == (*outcol - 1))
    {
    switch (*dtype)
       {  
       case (C): 
          size.ncol = (long) strlen(data[*totcount + 1].chr);
          strcpy(out_ptr->ptr.c,data[*totcount + 1].chr);
          break;
       case (I1): 
     	  put_matrix(out_ptr,I1,&size,
                      (unsigned char *) &data[*totcount + 1].byte);
               break;
       case (I2): 
   	  put_matrix(out_ptr,I2,&size,(unsigned char *) &data[*totcount + 1].i2);
               break;
       case (I4): 
     	  put_matrix(out_ptr,I4,&size,(unsigned char *)&data[*totcount + 1].i4);
               break;
       case (R4): 
   	  put_matrix(out_ptr,R4,&size,(unsigned char *) &data[*totcount + 1].r4);
          break;
       case (R8): 
   	  put_matrix(out_ptr,R8,&size,(unsigned char *) &data[*totcount + 1].r8);
          break;
       } /* case dtype */
     }
  else
    {
    switch (ptr[coln - 1]->dtype)
       {  
       case (C): 
          size.ncol = (long) strlen(data[coln - 1].chr);
          strcpy(out_ptr->ptr.c,data[coln - 1].chr);
          break;
       case (I1): 
     	  put_matrix(out_ptr,I1,&size,(unsigned char *) &data[coln - 1].byte);
               break;
       case (I2): 
   	  put_matrix(out_ptr,I2,&size,(unsigned char *) &data[coln - 1].i2);
               break;
       case (I4): 
     	  put_matrix(out_ptr,I4,&size,(unsigned char *) &data[coln - 1].i4);
               break;
       case (R4): 
   	  put_matrix(out_ptr,R4,&size,(unsigned char *) &data[coln - 1].r4);
          break;
       case (R8): 
   	  put_matrix(out_ptr,R8,&size,(unsigned char *) &data[coln - 1].r8);
          break;
       } /* case dtype */
     }
   out_ptr = out_ptr->next;
   }
put_record(tab);

return;
} 
