#include "complex.h"
#include "util.h"
#include "protos.h"

void comcalc
(
    long wind[][4],		/* first image window */
    long nmrimg,			/* no. of images in first image */
    long msgtim			/* message interval */
)
{
/************************************************************************

NAME: COMCALC

FUNCTION:
   Calculates output values from two input images.

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    4.0	      04-OCT-91   T. ROCKVAM        Removed wind2 and nmrimg2 parameters
    3.0       29-DEC-89   B. ALLAM, STX
    2.0       13-NOV-84   K. NARAYANAN SCN 20-363
    1.0       17-SEP-84   B. DEALY
************************************************************************/

long     flag;
float	 rrtemp1, rrtemp2;	/* temporary arrays */
long	 n, i, j, img, ib;	/* counter variables */

/*
set up processing message
*/
flag = GEN2;
c_inittm ("COMPLEX", "Processed", "line", "", "", &wind[0][NL], &zero, &msgtim,
          &flag);
curent = 1;
c_startm ();

/*
for each image
*/
for (img = 0; img < nmrimg; img++)
  {
  curent = 1;
  for (i=1; i <= wind[img][NL];i++)
    {
    c_estep (&gdescout);
    c_estep (&gdesc);
    c_estep (&gdesc2);
    for (ib = 0; ib < nbands[img]; ib++)
      {

/*
      interleaving for each line in these images
*/
      n=0; 
      for (j=1; j < wind[img][NS]*2;j+= 2)
        {
 
/*
        here we have to do the transformation for the output
        load inputs into temporay arrays rrtemp1 and rrtemp2
*/
        rrtemp1=inbuf[ipoint[ib]+n];
        rrtemp2=inbuf2[ipoint2[ib]+n];
        outbuf[opoint[ib]+j]=rrtemp2;
        outbuf[opoint[ib]+j-1]=rrtemp1;
        n=n+1;
        } /* do */
      } /* do */
    curent++;
    }
  c_estep (&gdescout);
  }
c_stoptm();
}
