#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "protos.h"

extern long    curcat;                        /* message utility         */
extern long    curent;                        /* parameters for processing */

struct PARBLK block;
struct DDR ddr;
long    bands[MAXIMG][MAXBND+1];
long    bands2[MAXIMG][MAXBND+1];
long    nbands[MAXIMG];
long    nbands2[MAXIMG];
struct FDESC *    fdesc[MAXIMG];                 /* input file descriptors  */
struct FDESC *    fdesc2[MAXIMG];                 /* input file descriptors  */
struct FDESC *    fdescout[2];                   /* output file descriptor  */
float   *inbuf;                         /* image input buffer      */
float   *inbuf2;                        /* image input buffer      */
float   *outbuf;                        /* image output buffer     */
struct GDESC *    gdesc;                         /* group descriptor        */
struct GDESC *    gdesc2;                         /* group descriptor        */
struct GDESC *    gdescout;
long    ipoint[MAXIMG*MAXBND+1];
long    ipoint2[MAXIMG*MAXBND+1];
long    opoint[MAXBND];
char    out[MAXIMG][CMLEN];
long    num_files;


int main
(void) /* complex */
{

/***********************************************************************

NAME: COMPLEX 

FUNCTION: Combines two input images on a pixel by pixel basis to
          form a complex output image

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    5.0	      21-SEP-92	  T. Mittan	    Modified include file to eliminate
					    warnings on link
    4.0	      04-OCT-91   T. ROCKVAM 	    Changes completion msg to use las
					    image names
    3.0       29-DEC-89   B. ALLAM, STX
    2.0       13-NOV-84   K. NARAYANAN SCN 20-363
    1.0       17-SEP-84   B. DEALY

************************************************************************/

char	hosin[MAXIMG][CMLEN],	/* Buffer for input host names */
 	hosin2[MAXIMG][CMLEN],	/* Buffer for input host names */
	lasin[MAXIMG][CMLEN],	/* Buffer for input las names */
	lasin2[MAXIMG][CMLEN],	/* Buffer for input las names */
	hosout[1][CMLEN], 		/* Buffer for output host names */
	lasout[1][CMLEN]; 		/* Buffer for output las names */
static
long	wind[MAXIMG][4], 	/* window specifications */
	wind2[MAXIMG][4], 	/* window specifications */
	nmrimg, 		/* Number of input images */
	nmrimg2, 		/* Number of input images */
        mnmx,			/* min/max value */
        std_out, 		/* flag parameter */
	totbnd, 		/* total no. of bands */
	totbnd2, 		/* total no. of bands */
        msgtim;			/* Time processing message time interval      */
static
double	omin[MAXBND], omax[MAXBND]; /* min and max values */

/*
Initialize LAS
--------------
*/
num_files = 0;
c_inlas (&block, &std_out); 

/*
Get input and ouput parameters
------------------------------
*/
getparms (lasin, lasin2, hosin, hosin2, hosout, lasout, &nmrimg, &nmrimg2,
          &totbnd, &totbnd2, &mnmx, &msgtim, wind, 
          wind2);

/*
Setup input and output file specifications
------------------------------------------
*/
filspec (hosin, hosin2, hosout[0], wind, wind2, nmrimg, nmrimg2,
         totbnd);

/*
Do the job
----------
*/
comcalc (wind, nmrimg, msgtim);

/*
update output file histories 
----------------------------
*/
c_hstout(&block, hosout[0], hosin, &nmrimg, " ");

/* 
write min and max values for output image
-----------------------------------------
*/
if (mnmx)
  {
  c_minmax (hosin, &nmrimg, wind, bands, nbands, omin, omax);
  c_svmnmx (hosout[0], &totbnd, omin, omax, "YES");
  }
/*
completion messages
-------------------
*/
c_egclse(&gdesc);
c_egclse(&gdesc2);
c_egclse(&gdescout);
c_complt("COMPLEX", out, &num_files);

return EXIT_SUCCESS;

}
