#include "las.h"
#include "util.h"
#include "compol.h"
#include "protos.h"

void comcalc
(
    long wind[][4],		/* window for first image */
    long nmrimg,			/* no. of images in first image */
    long msgtim,			/* message interval */
    long nbands[],
    long ipoint[],
    long ipoint2[],
    long opoint[]
)
{
/*

NAME: COMCALC

FUNCTION:
   Calculates output values from two input images.

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    3.0       29-DEC-89   B. ALLAM, STX
    2.0       13-NOV-84   K. NARAYANAN 
    1.0       01-JUN-84   B. DEALY
*/
float	 rad2;
long     flag;
float	 rrtemp1, rrtemp2;	/* temporary arrays */
long	 n, i, j, img, ib;	/* counter variables */
long     zero = 0;

/*
  set up processing message
*/
flag = GEN2;
c_inittm ("COMPOL", "Processed", "line", "", "", &wind[0][NL], &zero, &msgtim,
          &flag);
curent = 1;
c_startm ();

/*
for each image
*/
for (img = 0; img < nmrimg; img++)
  {
  curent = 1;
  for (i=1; i <= wind[img][NL];i++)
    {
    c_estep (&gdescout);
    c_estep (&gdesc);
    c_estep (&gdesc2);
    for (ib = 0; ib < nbands[img]; ib++)
      {
      n=0; 

/*
   interleaving for each line in these images
*/
      for (j=1; j < wind[img][NS]*2;j+= 2)
        {

/*
  here we have to do the transformation for the output

  load inputs into temporay arrays rrtemp1 and rrtemp2

*/
        rrtemp1 = inbuf[ipoint[ib]+n];
        rrtemp2 = inbuf2[ipoint2[ib]+n];

/*
  convert temp2 to radians and put in rad2

*/
        rad2=rrtemp2;

/*
   use rad2 and temp1 as per the equation

*/
        rrtemp2=rrtemp1 * (sin(rad2));
        rrtemp1=rrtemp1 * (cos(rad2)); 

/*
  now put the finished numbers in the output image

*/
        outbuf[opoint[ib]+j]=rrtemp2;
        outbuf[opoint[ib]+j-1]=rrtemp1;
        n=n+1;
        } /* do */
      }
    curent++;
    } 
  c_estep (&gdescout);
  } /* do */
c_stoptm();
}
