
int cal_lin_smp
(
    char *hostin,       /* I: input host file names                          */
    long *total_cnt,    /* I: total number of input images                   */
    long *in_count,     /* I: number of logical input images                 */
    long *numimg,       /* I: number of images per logical image             */
    long window[][4],   /* I: window specifications of input images          */
    float *projtol,     /* I: projection coordinate tolerance                */
    long *ulcoors_flag, /* I: upper left coor. parm flag                     */
    long *outsize_flag, /* I: output size parm. flag                         */
    double *ulcoors,    /* I/O: upper left coordinates of output             */
    double *outsize,    /* I/O: output size of output image                  */
    long *sl,           /* I: starting line of input in the output space     */
    long *ss,           /* I: starting samp of input in the output space     */
    long *nl,           /* I/O: number of lines in the output space          */
    long *ns            /* I/O: number of samples in the output space        */
);

int composite_image
(
    char hostin[][CMLEN],  /* I: Host file names of the input images          */
    char hostout[],        /* I: Host file name of the output image           */
    long band_to_compare,  /* I: # of the band to be compared (zero indexed)  */
    long bands[][MAXBND+1],/* I: The numbers of the bands to use for ea image */
    long group_number,     /* I: #of image grp to be composited (zero indexed)*/
    long images_in_group[],/* I: Number of images in each image group         */
    long in_window[][4],   /* I: Window specification for each input image    */
    long last_flag,        /* I: Use the last image or first image for ties   */
    long max_flag,         /* I: Use the max pixel value or the min value     */
    long msgtime,          /* I: Number of seconds between processing messages*/
    long nbands[],         /* I: Number of bands in each input image          */
    long odtype,           /* I: Output data type                             */
    long out_window[][4],  /* I:Window specification for ea output image group*/
    long size,             /* I: Number of bytes for the output data type     */
    long totbnd,       /* I: # of bands to composite (not including last band)*/
    long update_mode,      /* I: Flag for updating the first input image      */
    long ident_band        /* I: Flag for including identifier band in image  */
);

int get_dtype
(
    char hostin[][CMLEN],  /* I: Pointer to input host file names            */
    long *dtype,           /* O: Data type of the output image                */
    long num_images,       /* I: Number of input images                       */
    long *size,            /* O: Num of bytes required to store the data type */
    long update_mode       /* I: Flag to modify the first input image         */
);

int getpar
(
    struct PARBLK *vblock, /* I: pointer to TAE block                         */
    char hostin[][CMLEN],  /* O: host file names of input images              */
    char *hostout,         /* O: host file name of output image               */
    char *minmax,          /* O: flag to calculate min & max values for DDR   */
    char *taeout,          /* O: TAE file name of output image                */
    long *auto_subcommand, /* O: Flag indicating if auto subcommand was used  */
    long *band_to_compare, /* O: band to be compared among all images         */
    long bands[][MAXBND+1],/* O: band specification                           */
    long images_in_group[],/* O: number of images in each image group         */
    long in_window[][4],   /* O: input window specification for each image    */
    long *last_flag,       /* O: flag to use last image on ties,else the first*/
    long *max_flag,        /* O: flag to use the max pixel value, else the min*/
    long *msgtim,          /* O: elapsed time between display messages        */
    long *nbands,          /* O: number of bands for each input image         */
    long *nl,              /* O: number of lines in the output image          */
    long *ns,              /* O: number of samples in the output image        */
    long *num_img_groups,  /* O: number of image groups                       */
    long *num_images,      /* O: number of input images                       */
    long out_window[][4],  /* O:output window specification for ea image group*/
    long *totbnd,          /* O: number of bands in each input image to be
			         composited.  In update mode image 1 will
			         contain (totbnd + 1) bands.                  */
    long *update_mode,     /* O: flag for updating the first input image      */
    long *ident_band       /* O: flag for including identifier band in image  */
);

int init_output
(
    char hostin[][CMLEN],  /* I: Host file names of the input images          */
    char hostout[],        /* I: Host file name of the output image           */
    long bands[][MAXBND+1],/* I: The numbers of the bands to use for ea image */
    long images_in_group[],/* I: Number of images in each image group         */
    long in_window[][4],   /* I: Input window specification for ea input image*/
    long max_flag,         /* I: Flag to find max pixel value, else the min   */
    long msgtime,          /* I: Num of seconds between processing messages   */
    long nbands[],         /* I: Number of bands in each input image          */
    long nl,               /* I: Number of lines in the output image          */
    long ns,               /* I: Number of samples in the output image        */
    long odtype,           /* I: Output data type                             */
    long out_window[][4],  /* I:Output window specification for ea image group*/
    long size,             /* I: Num of bytes needed for the output data type */
    long totbnd,           /* I: total number of bands in each input image    */
    long update_mode,      /* I: Flag for updating the first input image      */
    int ident_band	   /* I: Flag to include identifier band in image     */ 
);

int open_image
(
    char hostnames[][CMLEN],/*I: Host file names of the images to be opened   */
    long bands[][MAXBND+1],/* I: The numbers of the bands to use for ea image */
    long *buffer_size,     /* I: Size of the buffer allocated by c_ealloc     */
    long group_number,     /* I: # of image group to be opened (zero indexed) */
    long images_in_group[],/* I: Number of images in each image group         */
    long input_file,       /* I: Flag to open either input or output image(s) */
    long nbands[],         /* I: Number of bands in each input image          */
    long odtype,           /* I: Output data type                             */
    long window[][4],      /* I: Window specification for each input image    */
    unsigned char **buffer /* I: Buffer allocated by c_ealloc for reading     */
);
