#include "comsep.h"
#include "util.h"
#include "protos.h"

void comcalc
(
    long wind[][4],		/* processing window */
    long nmrimg,			/* no. of images */
    long msgtim			/* message interval */
)
{

/*************************************************************************

NAME: COMCALC 

FUNCTION:
   Calculates output values from an input transform image.

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    3.0       29-DEC-89   B. ALLAM, STX
    2.0       09-NOV-84   B. DEALY
    1.0       18-SEP-84   B. DEALY
***************************************************************************/
long 	flag;
long    i, img, n, j, ib;	/* counter variables */
float   a1, a2;			/* temporary variables */

/*
set up processing message
*/
flag = GEN2;
c_inittm ("COMSEP", "Processed", "line", "", "", &wind[0][NL], &zero, &msgtim,
          &flag);
curent = 1;
c_startm ();

/*
for each image
*/
for (img = 0; img < nmrimg; img++)
  {
  curent = 1;
  for (i=1; i <= wind[0][NL]; i++)
    {
    c_estep(&gdesc);
    c_estep(&gdescout);
    c_estep(&gdescout1);
    for (ib = 0; ib < nbands[img]; ib++)
      {

/*
      interleaving for each line in these images
*/
      n=0; 
      for (j=1; j < wind[0][NS]; j += 2)
        {

/*
        here we have to do the transformation for the output
        perform calcs
*/
        a1 = inbuf[ipoint[ib]+j-1];
        a2 = inbuf[ipoint[ib]+j];
        outbuf[opoint[ib]+n] = a1;
        outbuf1[opoint1[ib]+n] = a2;
        n=n+1;
        } /* do */
      } /* do */
    curent++;
    }
  c_estep (&gdescout);
  c_estep (&gdescout1);
  }
c_stoptm ();
}
