#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "protos.h"

extern long    curcat;                 /* message utility         	*/
extern long    curent;                 /* parameters for processing 	*/

struct PARBLK block;
struct DDR ddr;
long    bands[MAXIMG][MAXBND+1];
long    nbands[MAXIMG];
struct FDESC *    fdesc[MAXIMG];              /* input file descriptors  	*/
struct FDESC *    fdescout[2];                /* output file descriptor  	*/
struct FDESC *    fdescout1[2];               /* output file descriptor  	*/
float   *inbuf;                        /* image input buffer      	*/
float   *outbuf;                       /* image output buffer     	*/
float   *outbuf1;                      /* image output buffer     	*/
struct GDESC *    gdesc;               /* group descriptor        	*/
struct GDESC *    gdescout;
struct GDESC *    gdescout1;
long    ipoint[MAXIMG*MAXBND+1];
long    opoint[MAXBND];
long    opoint1[MAXBND];
char    out[MAXIMG][CMLEN];
long    count;

int main
(void) /* comsep */
{

/**********************************************************************

NAME: COMSEP 

FUNCTION:
    Separates an input image on a pixel by pixel basis to 
    form two output images.

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    4.0	      21-SEP-92	  T. Mittan	    Modified include file to remove
					    warnings on link
    3.0       29-DEC-89   B. ALLAM, STX
    2.0       09-NOV-84   B. DEALY
    1.0       18-SEP-84   B. DEALY

***********************************************************************/

char	hosin[MAXIMG][CMLEN],	/* Buffer for input host names */
	hosout[2][CMLEN];	/* Buffer for output host names */
long	wind[MAXIMG][4], 	/* window specifications */
	nmrimg, 		/* Number of input images */
        mnmx,			/* min/max value */
        std_out, 		/* flag parameter */
	totbnd, 		/* total no. of bands */
        msgtim;			/* Time processing message time interval      */
double	omin[MAXBND], omax[MAXBND]; /* min and max values */

/*
Initialize LAS
--------------
*/
count = 0;
c_inlas (&block, &std_out); 

/*
Get input and ouput parameters
------------------------------
*/
getpar (hosin, hosout, wind, &nmrimg, &totbnd, &mnmx, &msgtim);

/*
setup input and output file specifications
------------------------------------------
*/
filspec (hosin, hosout, wind, nmrimg, totbnd);

/*
do the job
----------
*/
comcalc (wind, nmrimg, msgtim);

/*
 update output file histories 
 ----------------------------
*/
c_hstout(&block, hosout[0], hosin, &nmrimg, " ");
c_hstout(&block, hosout[1], hosin, &nmrimg, " ");

/* 
write min and max values for output image
-----------------------------------------
*/
if (mnmx)
  {
  c_minmax (hosin, &nmrimg, wind, bands, nbands, omin, omax);
  c_svmnmx (hosout[0], &totbnd, omin, omax, "YES");
  c_svmnmx (hosout[1], &totbnd, omin, omax, "YES");
  }
/*
 completion messages
 -------------------
*/
c_egclse (&gdesc);
c_egclse (&gdescout);
c_egclse (&gdescout1);
c_complt("COMSEP", out, &count);

return EXIT_SUCCESS;

}
