#ifndef CONCAT_H
#define CONCAT_H

/* averopt.c */
void averopt
(
  long *laver,              /* O: Left average array */
  long out_window[][4],     /* I: Window in output image */
  long *limage              /* I: Current image number */
);

/* cal_lin_smp.c */
void cal_lin_smp
(
  char *hostin,              /* I: Input host file names */
  long *total_cnt,           /* I: Total number of input images */
  long *in_count,            /* I: Number of logical input images */
  long *numimg,              /* I: Number of images per logical image */
  long window[][4],          /* I: Window specs of input images */
  float *projtol,            /* I: Projection coordinate tolerence */
  long *ulcoors_flag,        /* I: Upper left coor. parm flag */
  long *outsize_flag,        /* I: Output size parm. flag */
  double *ulcoors,           /* O: Upper left coords of output */
  double *outsize,           /* O: Output size of output image */
  long *sl,                  /* O: Starting line in output space */
  long *ss,                  /* O: Starting sample in output space */
  long *nl,                  /* O: Number of lines in output space */
  long *ns,                  /* O: Number of samples in output space */
  long out_window[][4]       /* O: Output window specs */
);

/* concat.c */
void main
(
  void
);

/* getpar.c */
void getpar
(
  struct PARBLK *vblk,        /* I: TAE parameter block */
  char *hostin,               /* O: Host file names */
  long *in_count,             /* O: Number of input images */
  long window[][4],           /* O: Input window specifications */
  long bands[][MAXBND+1],     /* O: Band specifications */
  long *num_out_bands,        /* O: Number of output bands */
  long nbands[],              /* O: Number of bands in each image */
  long numimg[],              /* O: Number of images in each IN element */
  long *index,                /* O: Total number of images specified */
  char *taeout,               /* O: Output TAE file name */
  char *hostout,              /* O: Output host file name */
  long *msgtim,               /* O: Time between display messages */
  char *minmax,               /* O: MinMax flag buffer */
  long sl[],                  /* O: Starting line locations */
  long ss[],                  /* O: Starting sample locations */
  long *nl,                   /* O: Number of lines */
  long *ns,                   /* O: Number of samples */
  char option[][7],           /* O: Option values */
  float maskval[][2],         /* O: Mask values */
  long *update,               /* O: Output image flag */
  long out_window[][4]        /* O: Output window spcification */
);

/* mnmx.c */
void mnmx
(
  struct PARBLK *vblk,     /* I: TAE parameter block */
  char *hostout,           /* I: Output host file name */
  long *nl,                /* I: Number of lines */
  long *ns,                /* I: Number of samples */
  long *dtype,             /* I: Data type of output image */
  long *totbnd,            /* I: Number of bands in output image */
  double bmin[],           /* O: BYTE minimum intensity for each band */
  double bmax[],           /* O: BYTE maximum intensity for each band */
  long *msgtim,            /* I: Time between display messages */
  long *update             /* I: Update flag */
);

/* overlay_img.c */
int overlay_img
(
  struct PARBLK *vblk,        /* I: TAE parameter block */
  char *hostin,               /* I: Input host file name */
  long nmrimg,                /* I: Number of images in current spec */
  long wind[][4],             /* I/O: Window specification */
  long bands[][MAXBND+1],     /* I: Band specification */
  long nbands[],              /* I: Number of bands in each image */
  long *sl,                   /* I: Starting line */
  long *ss,                   /* I: Starting sample */
  float	*mask,                /* I: Mask value */
  char *hostout,              /* I: Output host file name */
  long *dtype,                /* I: Data type of output image */
  long *totbnd,               /* I: Number of bands in output image */
  long *nl,                   /* I: Number of lines in output image */
  long *ns,                   /* I: Number of samples in output image */
  long replace,               /* I: Replace option for overlap condition */
  long leave,                 /* I: Leave option for overlap condition */
  long aver,                  /* I: Averag option for overlap condition */
  long *msgtim,               /* I: Time between messages */
  long *update,               /* I: Update flag */
  long *laver                 /* I: Left average array */
);

/* pad.c */
void pad
(
  struct PARBLK *vblk,      /* I: TAE parameter block */
  char *hostout,            /* I: Output host file name */
  long *nl,                 /* I: Number of lines in output image */
  long *ns,                 /* I: Number of samples in output image */
  long *totbnd,             /* I: Number of bands in output image */
  long *dtype,              /* I: Data type of output image */
  float *mask,              /* I: Mask value */
  long *msgtim              /* I: Display message delay */
);

/* set_dtype.c */
void set_dtype
(
  char *hostin,             /* I: Input host file name */
  long image_count,         /* I: Number of input images */
  long *out_dtype,          /* O: Data type of output image */
  float maskval[][2],       /* I: Mask value */
  long *in_count            /* I: Number of mask values */
);

#endif
