#include "conj.h"
#include "util.h"
#include "protos.h"

void getpar
(
    char hosin[MAXIMG][CMLEN],	/* Buffer for input host names */
    char lasin[MAXIMG][CMLEN],	/* Buffer for input las names */
    char lasout[][CMLEN],		/* Buffer for output las names */
    char hosout[][CMLEN],		/* Buffer for output host names */
    long window[MAXIMG][4], 	/* window specifications */
    long *totbnd,		/* Total no. of bands */
    long *mnmx,			/* min/max value */
    long *msgtim,		/* Time processing message time interval      */
    long *nmrimg 		/* Number of input images */
)
{
/*

NAME: GETPAR

FUNCTION:
   to receive the initial input parameters.

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    3.0       30-OCT-89   B. ALLAM, STX
    2.0       29-MAR-84   S. KONDAL, SAR
    1.0       13-DEC-83   J. BAY, SASC
*/
long 	status,
     	imglim,			/* max no. of images */
        intype,			/* input image type */
     	qflag[MAXIMG][2],
     	same;			/* Flag indicating if images have same window */

char    minmax[3];		/* min/max option */
struct VARIABLE *var;

static long zero = 0;
static long fatal_err = -1;

imglim = MAXIMG;
/*
 get input file information

*/
status = c_getin (&block, "IN", &zero, lasin, hosin, nmrimg, window, bands,
                  nbands, totbnd, &imglim, &same, qflag);

if (status != E_SUCC)
  c_errmsg ("Unable to retrieve input image parameter", "CONJ-in", &fatal_err);
c_gettyp (hosin, nmrimg, &intype); 
if (intype != EREAL)
  c_errmsg("Input file must be of type REAL", "CONJ-type", &fatal_err);

/*
 get output file information

*/
status = c_getout (&block, "OUT", lasout, hosout); 
if (status != E_SUCC) 
  c_errmsg ("Unable to retrieve output image", "CONJ-out", &fatal_err);
/*
get global values specified by the user.
---------------------------------------
*/
var = p_find (&block, "$MSGTIM");
*msgtim = IVAL (*var, 0);
var = p_find  (&block, "$MINMAX"); /*** NEWLAS call ***/
strcpy(minmax, SVAL(*var,0));
if (minmax[0] == 'Y' || minmax[0] == 'y') *mnmx = TRUE;
else *mnmx = FALSE;
}
