#include"conj.h"
#include "util.h"
#include "pixman.h"
#include"protos.h"

void process
(
    long wind[][4],		/* processing image window */
    long msgtim,			/* message interval */
    long nmrimg			/* no. of images */
)
{
/*

NAME: PROCESS

FUNCTION:
  Negate imaginary half of each complex pair
  

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    4.0       06-FEB-90   B. ALLAM, STX     Changed no. of pixels copied
    3.0       30-OCT-89   B. ALLAM, STX
    2.0       29-MAR-84   S. KONDAL, SAR
    1.0       13-DEC-83   J. BAY, SASC
*/
static long zero = 0;

long 	npix, 		/* no. of pixels */
        flag, 		/* message format */
        type;		/* data type */
long 	img, iln, ib, ipt; /* pointer variables */
/*
  set up processing message
*/
flag = GEN2;
c_inittm ("CONJ", "Processed", "line", "", "", &wind[0][NL], &zero, &msgtim,
          &flag);
curent = 1;
c_startm ();
type = EREAL;

/*
for each image
*/
for (img = 0; img < nmrimg; img++)
  {
/*
 step through each line of image window

*/
  npix = wind[img][NS];
  for (iln = 1; iln <= wind[img][NL]; iln++)
    {
/*

 read a line from each input image and get buffer space for output line(s)

*/
    c_estep (&gdescout);
    c_estep (&gdesc);

/*
 step through each individual image

*/
    for (ib = 0; ib < nbands[img]; ib++)
      {


/*
 copy input to output line

*/
      c_pxcopy (&inbuf[ipoint[ib]], &outbuf[opoint[ib]], &type, &npix);

/*
 negate imaginary half of each complex pair

*/
      for (ipt = opoint[ib]+1; ipt < opoint[ib]+npix; ipt += 2)
        outbuf[ipt] = -outbuf[ipt];
      }  /* do */
    curent++;
    }  /* do */
  }
/*
 force out last line
*/

c_estep (&gdescout);
c_stoptm();
c_egclse (&gdesc);
c_egclse (&gdescout);
}
