#include "contable.h"
#include "protos.h"

void dyn_alloc
(
    long *contab[],           /* pointers to contingency table */
    float *expec[]            /* pointers to expected values   */
)
/*
*********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for contingency table and expected values

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/05/88  K. A. Narayanan

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

*********************************************************************
*/
{
long	buf_size,                  /* size of matrices       */
        i, n;

long fatal_err = -1;               /* fatal error flag       */

/*
allocate storage for covariance matrices and eigen vectors
----------------------------------------------------------
*/
buf_size = 256 * 256 * sizeof (float);

if ((expec_table = (float *) malloc( buf_size)) == NULL ||
   (contingency_table= (long *) malloc( buf_size)) == NULL)
   c_errmsg( "Error allocating dynamic memory", "contable-alloc", &fatal_err);

/*
set up pointers for covariance matrices and eigen vectors
---------------------------------------------------------
*/
for (i = 0, n = 0; i < 256; i++, n += 256)
   {
   expec[i] = &expec_table[n];
   contab[i] = &contingency_table[n];
   }
}
