#include "contable.h"
#include "util.h"
#include "protos.h"

void filspec
(
    char hos[][CMLEN],   /* input images host names    */
    long image_band_num[][MAXBND + 1], /* band numbers */
    long wind[][4]      /* input image window         */
)
/*
*****************************************************************

NAME: FILESPEC                         

PURPOSE: Sets up input images for image i/o

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    2          8/04/88    K. Narayanan
    1          9/16/83    C. Gurney/
   		          K. Narayanan
    3         10/20/92	  S. Nelson	      Changed error messages.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
   Call C_GETDDR to get data type of images
   If data not byte issue error message and abort
   Call E_OPENS to open input images
   Call E_GROUP to group both image bands

*****************************************************************
*/
{
struct	DDR	ddr;

long	access;
long	bufsiz;
long	n;
long	stat;
long	type;
long    zero = 0;  /* Constant of zero */

/*
check that the images are byte
------------------------------
*/
for (n = 0; n < 2; n++)
   {
   c_getddr (hos[0], &ddr);
   if (ddr.dtype != EBYTE) 
      {
      if (fd) fclose (fd);
      c_abort (&block, "Image is not a byte image", "contable-type",
               "contable", out_files, &num_outfiles);
      }
   }
/*
set up image i/o
----------------
*/
access = IREAD;
type = EBYTE;
for (n = 0; n < 2; n++)
   {
   stat = c_eopens( &fdesc[n], hos[n], image_band_num[n], &wind[n][SL], 
                   &wind[n][SS], &wind[n][NL], &wind[n][NS], &ipoint[n], 
                   &access, &type, &zero, &zero);
   if (stat != E_SUCC )
      {
      if (fd) fclose (fd);
      c_abort (&block, "Error opening input images", "contable-open", 
               "contable", out_files, &num_outfiles);
      }
   }  

fdesc[n] = 0;

/*
set up group containing input and output bands
----------------------------------------------
*/
if ((iobuf = (unsigned char *) c_ealloc(fdesc, &bufsiz)) == NULL)
   {
   if (fd) fclose (fd);
   c_abort (&block, "Error allocating dynamic memory", "canal-alloc", 
            "contable", out_files, &num_outfiles);
   }
c_egroup (fdesc, &gdesc, iobuf, &bufsiz);
}
