#ifndef PROTOS_H
#define PROTOS_H

void dyn_alloc
(
    long *contab[],           /* pointers to contingency table */
    float *expec[]            /* pointers to expected values   */
);

void dyn_free
(void);

void filspec
(
    char hos[][CMLEN],   /* input images host names    */
    long image_band_num[][MAXBND + 1], /* band numbers */
    long wind[][4]      /* input image window         */
);

void getpar
(
    char las_in[][CMLEN],     /* input image las names            */
    char hos_in[][CMLEN],     /* input image host names           */
    char print_filename[],    /* print output file name           */
    long image_band_num[][MAXBND + 1], /* band numbers in each    */
    long wind[][4],           /* input image windows              */
    char expect_flag[]       /* expectation parameter            */
);

void output
(
    long *contab[],            /* contingency values                 */
    float *expec[],             /* expected values                    */
    long sum1[256],            /* row sums in table                  */
    long sum2[256],            /* column sums in table               */
    char las_in[][CMLEN],      /* input images las_in names          */
    char expect_flag[],        /* expectation flag                   */
    long colind[256],          /* number of non-zero columns         */
    long rowind[256],          /* number of non-zero rows            */
    long nc,                   /* column indices                     */
    long nr                   /* row indices                        */
);

void tabcalc
(
    long *npix,                /* # pixels in image                  */
    long wind[][4],            /* image window                       */
    long *contab[],            /* contingency values                 */
    float *expec[],             /* expected values                    */
    long sum1[256],            /* row sums in table                  */
    long sum2[256],            /* column sums in table               */
    long colind[256],          /* number of non-zero columns         */
    long rowind[256],          /* number of non-zero rows            */
    long *nc,                  /* column indices                     */
    long *nr                  /* row indices                        */
);

#endif

