#ifndef PROTOS_H
#define PROTOS_H

void apply_cor
(
    struct PARBLK *vblock, /* TAE parameter block			  */
    double lindis,             /* nominal scale of input inter-line distance */
    double pixdis,	     /* nominal scale of input inter-pixel distance*/
    double mir[],             /* MSS mirror model coefficients		   */
    double nomalt,	     /* nominal spacecraft altitude		   */
    double nomwid,	     /* nominal input image width		   */
    float boff[],            /* MSS band-to-band offsets                   */
    float sdelay[][7],      /* MSS sampling delay constants               */
    double erthrot,            /* Earth rotation parameter		   */
    long linlen[],          /* acutal line lengths			   */
    long nomlen,            /* nominal line length     		   */
    long msgtim, 	     /* elapsed time between display messages      */
    char minmax[],          /* min max flag				   */
    long bands[][MAXBND+1], /* band specification			   */
    long btot,	             /* total number of output image bands         */
    char method[],          /* resampling method		           */
    char hosin[][CMLEN],	/* pointer to input host file descriptor	*/
    char hosout[][CMLEN],   /* pointer to output host file descriptor	*/
    long bckgnd,            /* background fill value 		  	   */
    double alpha,              /* cubic convolution alpha parameter	   */
    long maxlim,            /* maximum interpolation value     	   */
    long minlim,            /* minimum interpolation value		   */
    char *tabhos    	/* pointer to table host file descriptor	*/
);

void get_info
(
    double *lindis,	    /* nominal scale of input inter-line distance         */
    double *pixdis,     /* nominal scale of input inter-pixel distance        */
    double mir[],      /* MSS mirror model coefficients  	  	            */
    double *nomalt,	    /* nominal spacecraft altitude                        */
    double *nomwid,	    /* nominal input image width		            */
    float boff[],     /* adjusted array of band-to-band offsets               */
    float sdelay[][7], /* ajusted array of MSS sampling delay constants       */
    float *erthrot,    /* earth rotation parameter                            */
    long linlen[],     /* actual line lengths			             */
    long *nomlen,       /* nominal line length      		    	     */
    char *corhos,      /* pointer to correction file host name descriptor */
    double *lat        /* scene center latitude				     */
);

void getpar
(
    struct PARBLK *vblock,       /* pointer to TAE parameter block            */
    char taein[][CMLEN],        /* pointer to input TAE file descriptor      */
    char hosin[][CMLEN],	/* pointer to input host file descriptor     */
    char taeout[][CMLEN],   /* pointer to output TAE file descriptor     */
    char hosout[][CMLEN],   /* pointer to output host file descriptor    */
    long bands[][MAXBND+1],	/* band specification 			     */
    long *btot,		        /* total number of output image bands	     */
    long *msgtim,		/* elapsed time between display messages     */
    char *minmax,		/* min max flag buffer                       */
    char *method,		/* resampling method		             */
    long *bckgnd,                /* background fill value	             */
    float *alpha,               /* cubic convolution alpha parameter         */
    long *maxlim,               /* maximum interpolation value		     */
    long *minlim,                /* minimum interpolation value		     */
    char *tabhos, 	        /* pointer to user-defined table file desc.  */
    char *corhos               /* pointer to corrections file descriptor    */
);

void make_table
(
    float table[],		/* resampling weight table	        */
    long *tabsiz,		        /* size of resampling table	        */
    char method[],		/* method of resampling	                */
    double alpha,			/* tension parameter for parametric cubic
            				   convolution resampling 	        */
    char *tabhos  		/* pointer to table file descriptor     */
);

#endif

