/******************************************************************************

NAME:	bit

FUNCTION:
    picks a bit value in a given long word


PROGRAM HISTORY:
  Version	Date       Author      	       Request
  -------	----	   ------              -------
   1.0        30-nov-81  j.  hwang,  sasc
   2.0        7-jan-88   m.  mazzella, SAR/GSF Conversion to C


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM (FLOW):
      check  for valid bit range
      perform bitwise and with POSth bit of WORD
      return

******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "tiepts.h"

long bit
(
long word,         		/*  I: source word  */
unsigned char pos           	/*  I: position of bit desired  */
)

{
long none = -1;
/*
  check if out of range
*/

/* This condition never met for this application
if ((pos > 32) || (pos < 1)) 
   {
   c_errmsg("Exceeded  bit range(1-32) value", "corrview-range", &none);
   } */

/*
  pick up byte value which includes desired bit
*/

if ((1 << (pos - 1)) & word)
   return (TRUE);
else
   return(FALSE);
}
