#include "covar.h"
#include "protos.h"

void filspec
(
    char hosnm[][CMLEN],   /* image host names                    */
    long *nimages,         /* number of images                    */
    long num_image_bands[],/* number of bands in each image       */
    long bands[][MAXBND+1],/* image bands                         */
    long *np,              /* number of pixels per line           */
    long *nl,              /* number of lines in image            */
    long wind[][4]        /* image windows                       */
)

/************************************************************************
NAME: FILSPEC

PURPOSE: sets up file specifications

PROGRAM HISTORY:
  Version	Date       Author	   Request
  -------	----	   ------          -------
    2.0          7/88      K. A. Narayanan conversion to LAS Version 5.0
    1.0         12/82      K. A. Narayanan 

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:
   Call C_EOPENS to open input images as REAL images
   Call C_EGROUP to group them

*************************************************************************/
{
long	bufsiz;                  /* size of image i/o buffer            */

long	access = IREAD;          /* input image file access type        */
long	band;                    /* index                               */
long	istat;                   /* error return status                 */
long	n;                       /* loop index                          */
long	type = EREAL;            /* input image data type               */
long	zero = 0;

/*
open input image files--convert data to r*4
-------------------------------------------
*/
band = 0;
for (n = 0; n < *nimages; n++)
   {
   istat = c_eopens(&fdesc[n], hosnm[n], bands[n], &wind[n][SL], &wind[n][SS],
                  nl, np, &ipoint[band], &access, &type, &zero, &zero);
   if (istat != E_SUCC )
      c_errmsg ("Error opening input image", "covar-open", &fatal_err);

   band += num_image_bands[n];
   }  
fdesc[n] = 0;

/*
set up file group containing input bands
----------------------------------------
*/
if ((buf = (unsigned char *) c_ealloc(fdesc, &bufsiz)) == NULL)
   c_errmsg ("Error allocating dynamic memory", "covar-alloc", &fatal_err);

if (c_egroup (fdesc, &gdesc, buf, &bufsiz) != E_SUCC)
   c_errmsg ("Error grouping image bands", "covar-group", &fatal_err);

}
