#ifndef PROTOS_H
#define PROTOS_H

void filspec
(
    char hosnm[][CMLEN],   /* image host names                    */
    long *nimages,         /* number of images                    */
    long num_image_bands[],/* number of bands in each image       */
    long bands[][MAXBND+1],/* image bands                         */
    long *np,              /* number of pixels per line           */
    long *nl,              /* number of lines in image            */
    long wind[][4]        /* image windows                       */
);

void getpar
(
    char las_stat[],         /* stats file las name               */
    char hosst[],            /* stats file host name descriptor   */
    char hosnm[][CMLEN],     /* image host name descriptor        */
    long *nimages,           /* number of images specified        */
    long *num_image_bands,   /* number of bands in each image     */
    long bands[MAXIMG][MAXBND + 1],  /* image bands               */
    long *num_inbands,       /* total number of image bands       */
    long wind[][4],          /* image windows                     */
    long *npin,              /* number of pixels in window        */
    long *nlin,              /* number of lines in image window   */
    long *msgtim            /* time between messages             */
);

void nstat
(
    char hosst[][CMLEN],           /* stats file host name descriptor */
    long *nbands,           /* number of bands in input image  */
    long *np,               /* number of pixels/line in image  */
    long *nl,               /* number of lines in image        */
    long *msgtim           /* interval between messages       */
);

void output
(
    char hosst[][CMLEN],                  /* stats file host name      */
    double cov[],                    /* covariance matrix         */
    double smean[],                  /* mean vector               */
    long *nbands                  /* number of bands in image  */
);

#endif

