/*****************************************************************************
NAME: GETDATUM

PURPOSE:  Expands a datum code to the datum name

PROGRAM HISTORY:

Version  Date  Programmer       Code  Reason
-------  ----- ----------       ----  ------
 1.0     12/97 B.Olson           C    Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS
*****************************************************************************/
#include "protos.h"

void getdatum
(
    long *datum_code,          /* Datum code                 */
    char *string               /* Output string for datum    */
)

{
    switch (*datum_code)
    {
        case 0: sprintf(string,"Clarke 1866\n");break;
        case 1: sprintf(string,"Clarke 1880\n");break;
        case 2: sprintf(string,"Bessel\n");break;
        case 3: sprintf(string,"International 1967\n");break;
        case 4: sprintf(string,"International 1909\n");break;
        case 5: sprintf(string,"WGS 72\n");break;
        case 6: sprintf(string,"Everest\n");break;
        case 7: sprintf(string,"WGS 66\n");break;
        case 8: sprintf(string,"GRS 1980\n");break;
        case 9: sprintf(string,"Airy\n");break;
        case 10: sprintf(string,"Modified Everest\n");break;
        case 11: sprintf(string,"Modified Airy\n");break;
        case 12: sprintf(string,"WGS 84\n");break;
        case 13: sprintf(string,"Southeast Asia\n");break;
        case 14: sprintf(string,"Australian National\n");break;
        case 15: sprintf(string,"Krassovsky\n");break;
        case 16: sprintf(string,"Hough\n");break;
        case 17: sprintf(string,"Mercury 1960\n");break;
        case 18: sprintf(string,"Modified Mercury 1968\n");break;
        case 19: sprintf(string,"Sphere of Radius 6370997 meters\n");break;
        default: sprintf(string,"User Defined\n");break;
    }
}
