/*****************************************************************************
NAME: D2DMS

PURPOSE:  Converts a packed degree-minute-second number to degrees, 
          minutes, and seconds.

PROGRAM HISTORY:

Version  Date  Programmer       Code  Reason
-------  ----- ----------       ----  ------
 1.0     12/97 B.Olson           C    Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS
*****************************************************************************/
#include "protos.h"

void pdms2dms
(
    double *pdms,                      /* Packed degrees-minutes-seconds */
    long *degree,                      /* Degrees                        */
    long *minute,                      /* Minutes                        */
    double *sec                       /* Seconds                        */
)
{
    double temp;
    *degree = (long) (*pdms/1000000);
    temp = (*pdms - (*degree * 1000000));
    if (temp < 0)
        temp *= -1;
    *minute = (long) temp / 1000;
    *sec = temp - (*minute * 1000);
}
