/*****************************************************************************
NAME: PRINTOUT

PURPOSE:  Sends the line to the appropriate location, based on the print flags

PROGRAM HISTORY:

Version  Date  Programmer       Code  Reason
-------  ----- ----------       ----  ------
 1.0     12/97 B.Olson           C    Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS
*****************************************************************************/

#include <stdio.h>
#include "protos.h"

#define TERM 0
#define PFILE 1
#define LP 2

void printout
(
    char *tempstr,                   /* information to be output             */
    long print[3],                   /* output destination                   */
    FILE *fp                         /* file pointer to print file           */
)

{
    /* Send the information to the display
       ----------------------------------- */
    if (print[TERM])
        printf("%s",tempstr);

    /* Send the information to a file to be processed later
       ---------------------------------------------------- */
    if ((print[PFILE]) || (print[LP]))
        fprintf(fp,"%s",tempstr);
}

