#ifndef PROTOS_H
#define PROTOS_H

#include "las.h"

void calcdist
(
    double *y1,
   double *x1,
   double *y2,
   double *x2,
   double *dist
);

void getdatum
(
    long *datum_code,           /* Datum code                 */
    char *string               /* Output string for datum    */
);

void getproj
(
    long *proj_code,          /* Projection code               */
    char *string,             /* Output Projection name        */
    double proj_coef[15]     /* Projection coefficients       */
);

void getprojparm
(
    long *proj_code,                 /* Projection code from DDR             */
    long *zone_code,                 /* Zone code from DDR                   */
    char *string,                    /* Formatted data to be sent back       */
    double proj_coef[15],            /* Projection coefficients from DDR     */
    long print[3],                   /* output destination                   */
    FILE *fp                         /* file pointer to print file           */
);

void pdms2dms
(
    double *pdms,                      /* Packed degrees-minutes-seconds */
    long *degree,                      /* Degrees                        */
    long *minute,                      /* Minutes                        */
    double *sec                        /* Seconds                        */
);

void printout
(
    char *tempstr,                   /* information to be output             */
    long print[3],                   /* output destination                   */
    FILE *fp                         /* file pointer to print file           */
);

#endif
