#ifndef PROTOS_H
#define PROTOS_H

int filter
(
    unsigned char *topbuf,  /* line at the top of the filter swath  */
    unsigned char *inbuf,   /* current line, middle of filter swath */
    unsigned char *botbuf,  /* line at bottom of the filter swath   */
    float tolrn,            /* tolerance value for rejection        */
    long nl,                /* number of lines to be processed      */
    long ns,                /* number samples per line to process   */
    long vertwidth,         /* lines in a swath (band) width        */
    long in_line,           /* current input line number            */
    unsigned char *outbuf  /* output buffer for corrected data     */
);

void init_filter
(
    long ns
);

void end_filter
(void);

void init_get_line
(void);

void get_line
(
    long bndin,	   /* Current band of input image          */
    long nl,             /* Number of lines in input image       */
    long ns,             /* Number of samples in each line       */
    long height,         /* Height of filter window (swath)      */
    unsigned char *buf,  /* Pointer to image data buffer         */
    long *top,           /* Pointer to line at top of swath      */
    long *in,            /* Pointer to line at center of swath   */
    long *bottom,        /* Pointer to line at bottom of swath   */
    struct FDESC * infd[2],         /* Input image file descriptor          */
    struct FDESC * outfd[2]        /* Output image file descriptor         */
);

void getpar
(
   struct PARBLK *parblk,  /* TAE parameter block structure    */
   char hosin[][CMLEN],    /* array of host input image names  */ 
   char taeout[][CMLEN],   /* TAE name of output image     */
   char hosout[][CMLEN],   /* host name of output image        */
   long *totbnd,           /* total bands in specification     */
   long bands[][MAXBND+1], /* specified bands for each image */
   long *nbands,           /* number of bands for each image   */
   long *nl,               /* number of lines in each image    */
   long *ns,               /* number of samples in each image  */
   long window[MAXIMG][4], /* specified window for input image */
   long *nmrimg,           /* number of input images       */
   float *tol,             /* tolerance value for filter       */
   long *height,           /* height of filter kernel      */ 
   long *msgtim,           /* time between processing messages */
   long *minmax            /* flag for minimum/maximum values  */
);

#endif
