/*****************************************************************************
NAME:				GETPAR

ALGORITHM:
	Initialize TAE and LAS processing.
	Get the value of the INFILE parameter.
	Get the value of the DLTFENTR parameter.
	Return.

*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "worgen.h"
#include "statio.h"
#include "util.h"
#include "protos.h"

void getpar
(
    char *dltfnam,		/* DLTF entry name.			*/
    char hostnm[CMLEN]		/* host output file name descriptor	*/
)
{
struct VARIABLE	 *inp;		/* Pointer to a variable in the parameter
				   block.				*/

struct	PARBLK	 vblock;	/* TAE parameter block.			*/

long	access;			/* flag for getnam			*/
long	fatal = -1;		/* fatal error flag			*/
long	status;			/* flag for status			*/
long	std_out;		/* Standard output device.		*/
long	zero = 0;		/* flag for value zero			*/

/* Initialize TAE and LAS processing.					*/

c_inlas(&vblock,&std_out);

/* Get the value of the INFILE parameter from the parameter block.
  ---------------------------------------------------------------*/
access = IREAD;
status = c_getnam(&vblock,"INFILE",&zero, hostnm, "dltf", &access);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered","deldltf-fatal",&fatal);

/* Get the value of the DLTFENTR parameter from the parameter block.
  -----------------------------------------------------------------*/
inp = p_find(&vblock,"DLTFENTR");

   strcpy(dltfnam,SVAL(*inp,0));

return;
}
