#ifndef PROTOS_H
#define PROTOS_H

void ediesc
(
    long img,			/* current image                              */
    long in_band,		/* input band number for eread                */
    long rfile,			/* flags which file should be read            */
    long out_band,		/* output band for ewrite                     */
    double bxbar,		/* band mean                                  */
    double xbar[16], 		/* detector mean                              */
    float sratio[16],		/* stdev sensors / stdev band                 */
    long tot_inbands		/* total number of bands                      */
);

void filspec
(
    char (*hosin)[CMLEN],    /* input image host names                        */
    char hosout1[],          /* output image host name                        */
    char hosout2[],          /* output image2 host name                       */
    char taeout1[],	     /* output image tae name			      */
    char taeout2[],	     /* output image2 tae name			      */
    long num_inimages,       /* number of input images                        */
    long num_image_bands[][MAXBND + 1], /* band numbers in each input image   */
    long (*out1_img_bands)[MAXBND + 1], /* band numbers for the 1st output img*/
    long (*out2_img_bands)[MAXBND + 1], /* band numbers for the 1st output img*/
    long bands_per_image[],  /* number of bands for each image                */
    long *bands,             /* number of output image bands                  */
    long output_bands[]	     /* output image bands                            */
);

void getpar
(
    char hosin[][CMLEN],   	/* input image host names                     */
    char hosout1[][CMLEN], 	/* first output image host names              */
    char hosout2[][CMLEN], 	/* second output image host names             */
    char taeout1[],             /* first output image tae names               */
    char taeout2[],             /* second output image tae names              */
    long *data_type,		/* data type of input and output images       */
    long *num_inimg,		/* number of input images                     */
    long (*num_img_band)[MAXBND+1], /* stores band numbers for each image     */
    long *bands_per_image,	/* number of bands per image                  */
    long *tot_inband,		/* total number of bands to be processed      */
    long img_limit,		/* maximum number of images                   */
    long *same_wnd,		/* same window size? 1=Y, 0=N                 */
    long img_flag[MAXIMG][2],	/* image/band options                         */
    long print[],		/* print option (TERM, LP, FIL)               */
    char print_file[],		/* output file                                */
    long *num_samps             /* total number of samples in image           */
);

void prompt
(
    double xbar[],		/* old sensor mean                            */
    double xbarn[],		/* user supplied sensor mean                  */
    double stdev[],		/* sensor standard deviation                  */
    float sratio[],		/* stdev of sensor / stdev of band            */
    float change[]		/* type of change: 1 - no change              */
);

void rndtbl
(
    unsigned char array[1025][10]	/* round off table                    */
);

void smooth
(
    long img,			/* current image being processed              */
    long in_band,		/* input band for eread                       */
    long rfile,			/* flags which file needs to be read          */
    long out_band,		/* output band for ewrite                     */
    long tot_inbands		/* total number of bands                      */
);

void statis
(
    long img,			/* current image being processed              */
    long in_band,		/* band number for eread                      */
    long rfile,			/* flags which file should be read            */
    float sratio[],		/* stdev sensors / stdev band                 */
    double *bxbar, 		/* band mean                                  */
    double xbar[], 		/* sensors mean                               */
    double stdev[],		/* sensor's standard deviation                */
    long print[],		/* print options (TERM, LP, FIL)              */
    long istat,			/* type of statistic to be printed            */
    long tot_inbands,		/* total number of bands                      */
    long num_samps		/* total number of samples in the image       */
);

void usersc
(
    long img,			/* current image being processed              */
    long in_band,		/* band number for eread                      */
    long out_band,		/* output band for ewrite                     */
    double xbar[],		/* sensor's mean                              */
    double stdev[],		/* sensor's standard deviation                */
    long tot_inbands		/* total number of bands                      */
);

#endif
