#include "destripe.h"
#include "protos.h"

void rndtbl
(
    unsigned char array[1025][10]	/* round off table                    */
)

/*
*****************************************************************************

NAME:	RNDTBL

PURPOSE: Randomly generated table used for bernstein's statistical approach.  
         A floating point number that has a digit after the decimal point of 1 
         will be rounded up 10% of the time, 2 will be rounded up 20% of the 
         time etc.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1         23-Nov-84    S. Kendal/SAR
   2         09-Mar-89    K. Kunska/STX      conversion to 5.0    

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

*****************************************************************************
*/

{
/*
Load the first row with 10% one's.
------------------------------------
*/
array[10][1] = 1;
array[73][1] = 1;
array[74][1] = 1;
array[75][1] = 1;
array[82][1] = 1;
array[85][1] = 1;
array[106][1] = 1;
array[169][1] = 1;
array[170][1] = 1;
array[171][1] = 1;
array[173][1] = 1;
array[188][1] = 1;
array[199][1] = 1;
array[205][1] = 1;
array[231][1] = 1;
array[234][1] = 1;
array[256][1] = 1;
array[262][1] = 1;
array[290][1] = 1;
array[312][1] = 1;
array[313][1] = 1;
array[326][1] = 1;
array[344][1] = 1;
array[345][1] = 1;
array[346][1] = 1;
array[353][1] = 1;
array[361][1] = 1;
array[371][1] = 1;
array[372][1] = 1;
array[379][1] = 1;
array[389][1] = 1;
array[391][1] = 1;
array[403][1] = 1;
array[413][1] = 1;
array[422][1] = 1;
array[431][1] = 1;
array[440][1] = 1;
array[441][1] = 1;
array[446][1] = 1;
array[454][1] = 1;
array[460][1] = 1;
array[465][1] = 1;
array[468][1] = 1;
array[471][1] = 1;
array[472][1] = 1;
array[474][1] = 1;
array[483][1] = 1;
array[485][1] = 1;
array[490][1] = 1;
array[508][1] = 1;
array[509][1] = 1;
array[513][1] = 1;
array[530][1] = 1;
array[546][1] = 1;
array[557][1] = 1;
array[579][1] = 1;
array[583][1] = 1;
array[586][1] = 1;
array[594][1] = 1;
array[614][1] = 1;
array[615][1] = 1;
array[626][1] = 1;
array[631][1] = 1;
array[640][1] = 1;
array[655][1] = 1;
array[669][1] = 1;
array[673][1] = 1;
array[721][1] = 1;
array[727][1] = 1;
array[729][1] = 1;
array[760][1] = 1;
array[773][1] = 1;
array[794][1] = 1;
array[817][1] = 1;
array[829][1] = 1;
array[830][1] = 1;
array[842][1] = 1;
array[844][1] = 1;
array[852][1] = 1;
array[864][1] = 1;
array[866][1] = 1;
array[868][1] = 1;
array[877][1] = 1;
array[882][1] = 1;
array[884][1] = 1;
array[895][1] = 1;
array[902][1] = 1;
array[903][1] = 1;
array[909][1] = 1;
array[912][1] = 1;
array[922][1] = 1;
array[933][1] = 1;
array[944][1] = 1;
array[952][1] = 1;
array[970][1] = 1;
array[971][1] = 1;
array[990][1] = 1;
array[993][1] = 1;
array[996][1] = 1;
array[1012][1] = 1;
array[1017][1] = 1;
array[1022][1] = 1;

/*
Load the second row with 20% one's.
--------------------------------------
*/
array[1][2] = 1;
array[4][2] = 1;
array[7][2] = 1;
array[22][2] = 1;
array[29][2] = 1;
array[33][2] = 1;
array[35][2] = 1;
array[37][2] = 1;
array[39][2] = 1;
array[41][2] = 1;
array[58][2] = 1;
array[63][2] = 1;
array[72][2] = 1;
array[73][2] = 1;
array[74][2] = 1;
array[85][2] = 1;
array[97][2] = 1;
array[102][2] = 1;
array[103][2] = 1;
array[111][2] = 1;
array[115][2] = 1;
array[122][2] = 1;
array[124][2] = 1;
array[135][2] = 1;
array[138][2] = 1;
array[155][2] = 1;
array[159][2] = 1;
array[161][2] = 1;
array[168][2] = 1;
array[170][2] = 1;
array[172][2] = 1;
array[173][2] = 1;
array[178][2] = 1;
array[181][2] = 1;
array[188][2] = 1;
array[192][2] = 1;
array[193][2] = 1;
array[202][2] = 1;
array[204][2] = 1;
array[207][2] = 1;
array[208][2] = 1;
array[229][2] = 1;
array[233][2] = 1;
array[245][2] = 1;
array[257][2] = 1;
array[261][2] = 1;
array[263][2] = 1;
array[264][2] = 1;
array[270][2] = 1;
array[273][2] = 1;
array[275][2] = 1;
array[276][2] = 1;
array[284][2] = 1;
array[293][2] = 1;
array[295][2] = 1;
array[296][2] = 1;
array[303][2] = 1;
array[308][2] = 1;
array[309][2] = 1;
array[312][2] = 1;
array[320][2] = 1;
array[331][2] = 1;
array[335][2] = 1;
array[340][2] = 1;
array[345][2] = 1;
array[355][2] = 1;
array[357][2] = 1;
array[361][2] = 1;
array[363][2] = 1;
array[365][2] = 1;
array[366][2] = 1;
array[367][2] = 1;
array[385][2] = 1;
array[387][2] = 1;
array[388][2] = 1;
array[390][2] = 1;
array[391][2] = 1;
array[392][2] = 1;
array[397][2] = 1;
array[398][2] = 1;
array[400][2] = 1;
array[402][2] = 1;
array[431][2] = 1;
array[442][2] = 1;
array[447][2] = 1;
array[458][2] = 1;
array[469][2] = 1;
array[471][2] = 1;
array[478][2] = 1;
array[481][2] = 1;
array[483][2] = 1;
array[489][2] = 1;
array[490][2] = 1;
array[492][2] = 1;
array[499][2] = 1;
array[504][2] = 1;
array[512][2] = 1;
array[518][2] = 1;
array[520][2] = 1;
array[523][2] = 1;
array[524][2] = 1;
array[525][2] = 1;
array[530][2] = 1;
array[532][2] = 1;
array[542][2] = 1;
array[544][2] = 1;
array[555][2] = 1;
array[557][2] = 1;
array[558][2] = 1;
array[560][2] = 1;
array[566][2] = 1;
array[569][2] = 1;
array[573][2] = 1;
array[581][2] = 1;
array[582][2] = 1;
array[585][2] = 1;
array[595][2] = 1;
array[596][2] = 1;
array[597][2] = 1;
array[599][2] = 1;
array[605][2] = 1;
array[606][2] = 1;
array[607][2] = 1;
array[613][2] = 1;
array[628][2] = 1;
array[637][2] = 1;
array[646][2] = 1;
array[653][2] = 1;
array[654][2] = 1;
array[663][2] = 1;
array[664][2] = 1;
array[670][2] = 1;
array[671][2] = 1;
array[680][2] = 1;
array[688][2] = 1;
array[694][2] = 1;
array[700][2] = 1;
array[716][2] = 1;
array[717][2] = 1;
array[718][2] = 1;
array[721][2] = 1;
array[730][2] = 1;
array[742][2] = 1;
array[744][2] = 1;
array[749][2] = 1;
array[755][2] = 1;
array[763][2] = 1;
array[764][2] = 1;
array[774][2] = 1;
array[779][2] = 1;
array[780][2] = 1;
array[782][2] = 1;
array[787][2] = 1;
array[791][2] = 1;
array[796][2] = 1;
array[803][2] = 1;
array[806][2] = 1;
array[811][2] = 1;
array[816][2] = 1;
array[818][2] = 1;
array[819][2] = 1;
array[820][2] = 1;
array[825][2] = 1;
array[837][2] = 1;
array[843][2] = 1;
array[850][2] = 1;
array[854][2] = 1;
array[857][2] = 1;
array[859][2] = 1;
array[863][2] = 1;
array[870][2] = 1;
array[874][2] = 1;
array[875][2] = 1;
array[876][2] = 1;
array[883][2] = 1;
array[886][2] = 1;
array[898][2] = 1;
array[911][2] = 1;
array[914][2] = 1;
array[917][2] = 1;
array[921][2] = 1;
array[922][2] = 1;
array[924][2] = 1;
array[931][2] = 1;
array[936][2] = 1;
array[938][2] = 1;
array[948][2] = 1;
array[950][2] = 1;
array[956][2] = 1;
array[960][2] = 1;
array[962][2] = 1;
array[971][2] = 1;
array[973][2] = 1;
array[977][2] = 1;
array[978][2] = 1;
array[979][2] = 1;
array[981][2] = 1;
array[988][2] = 1;
array[995][2] = 1;
array[1001][2] = 1;
array[1002][2] = 1;
array[1006][2] = 1;
array[1012][2] = 1;
array[1016][2] = 1;
array[1019][2] = 1;

/*
Load the third row with 30% one's.
-------------------------------------
*/
array[1][3] = 1; 
array[3][3] = 1; 
array[4][3] = 1; 
array[8][3] = 1; 
array[13][3] = 1; 
array[14][3] = 1; 
array[16][3] = 1; 
array[19][3] = 1; 
array[25][3] = 1; 
array[29][3] = 1; 
array[30][3] = 1; 
array[33][3] = 1; 
array[39][3] = 1; 
array[41][3] = 1; 
array[44][3] = 1; 
array[45][3] = 1; 
array[48][3] = 1; 
array[49][3] = 1; 
array[53][3] = 1; 
array[58][3] = 1; 
array[59][3] = 1; 
array[61][3] = 1; 
array[62][3] = 1; 
array[63][3] = 1; 
array[64][3] = 1; 
array[66][3] = 1; 
array[73][3] = 1; 
array[74][3] = 1; 
array[75][3] = 1; 
array[76][3] = 1; 
array[80][3] = 1; 
array[84][3] = 1; 
array[85][3] = 1; 
array[86][3] = 1; 
array[99][3] = 1; 
array[100][3] = 1; 
array[104][3] = 1; 
array[107][3] = 1; 
array[112][3] = 1; 
array[116][3] = 1; 
array[117][3] = 1; 
array[119][3] = 1; 
array[121][3] = 1; 
array[126][3] = 1; 
array[128][3] = 1; 
array[134][3] = 1; 
array[135][3] = 1; 
array[139][3] = 1; 
array[142][3] = 1; 
array[145][3] = 1; 
array[146][3] = 1; 
array[147][3] = 1; 
array[151][3] = 1; 
array[153][3] = 1; 
array[154][3] = 1; 
array[156][3] = 1; 
array[159][3] = 1; 
array[167][3] = 1; 
array[172][3] = 1; 
array[178][3] = 1; 
array[181][3] = 1; 
array[183][3] = 1; 
array[188][3] = 1; 
array[192][3] = 1; 
array[195][3] = 1; 
array[197][3] = 1; 
array[202][3] = 1; 
array[208][3] = 1; 
array[212][3] = 1; 
array[215][3] = 1; 
array[220][3] = 1; 
array[221][3] = 1; 
array[223][3] = 1; 
array[224][3] = 1; 
array[228][3] = 1; 
array[235][3] = 1; 
array[236][3] = 1; 
array[238][3] = 1; 
array[242][3] = 1; 
array[247][3] = 1; 
array[251][3] = 1; 
array[252][3] = 1; 
array[262][3] = 1; 
array[264][3] = 1; 
array[265][3] = 1; 
array[266][3] = 1; 
array[268][3] = 1; 
array[278][3] = 1; 
array[283][3] = 1; 
array[285][3] = 1; 
array[288][3] = 1; 
array[290][3] = 1; 
array[295][3] = 1; 
array[296][3] = 1; 
array[299][3] = 1; 
array[309][3] = 1; 
array[312][3] = 1; 
array[315][3] = 1; 
array[320][3] = 1; 
array[321][3] = 1; 
array[324][3] = 1; 
array[326][3] = 1; 
array[328][3] = 1; 
array[330][3] = 1; 
array[331][3] = 1; 
array[332][3] = 1; 
array[334][3] = 1; 
array[338][3] = 1; 
array[339][3] = 1; 
array[342][3] = 1; 
array[344][3] = 1; 
array[345][3] = 1; 
array[346][3] = 1; 
array[350][3] = 1; 
array[353][3] = 1; 
array[354][3] = 1; 
array[355][3] = 1; 
array[357][3] = 1; 
array[359][3] = 1; 
array[361][3] = 1; 
array[363][3] = 1; 
array[365][3] = 1; 
array[369][3] = 1; 
array[370][3] = 1; 
array[375][3] = 1; 
array[377][3] = 1; 
array[383][3] = 1; 
array[384][3] = 1; 
array[385][3] = 1; 
array[386][3] = 1; 
array[393][3] = 1; 
array[394][3] = 1; 
array[397][3] = 1; 
array[398][3] = 1; 
array[402][3] = 1; 
array[403][3] = 1; 
array[409][3] = 1; 
array[415][3] = 1; 
array[417][3] = 1; 
array[420][3] = 1; 
array[425][3] = 1; 
array[428][3] = 1; 
array[429][3] = 1; 
array[432][3] = 1; 
array[436][3] = 1; 
array[440][3] = 1; 
array[443][3] = 1; 
array[447][3] = 1; 
array[453][3] = 1; 
array[454][3] = 1; 
array[455][3] = 1; 
array[458][3] = 1; 
array[460][3] = 1; 
array[465][3] = 1; 
array[467][3] = 1; 
array[498][3] = 1; 
array[499][3] = 1; 
array[501][3] = 1; 
array[502][3] = 1; 
array[503][3] = 1; 
array[505][3] = 1; 
array[506][3] = 1; 
array[508][3] = 1; 
array[515][3] = 1; 
array[519][3] = 1; 
array[523][3] = 1; 
array[525][3] = 1; 
array[536][3] = 1; 
array[539][3] = 1; 
array[543][3] = 1; 
array[549][3] = 1; 
array[558][3] = 1; 
array[567][3] = 1; 
array[568][3] = 1; 
array[575][3] = 1; 
array[578][3] = 1; 
array[588][3] = 1; 
array[589][3] = 1; 
array[595][3] = 1; 
array[606][3] = 1; 
array[612][3] = 1; 
array[616][3] = 1; 
array[618][3] = 1; 
array[620][3] = 1; 
array[628][3] = 1; 
array[630][3] = 1; 
array[633][3] = 1; 
array[634][3] = 1; 
array[635][3] = 1; 
array[638][3] = 1; 
array[646][3] = 1; 
array[650][3] = 1; 
array[652][3] = 1; 
array[653][3] = 1; 
array[657][3] = 1; 
array[658][3] = 1; 
array[660][3] = 1; 
array[661][3] = 1; 
array[663][3] = 1; 
array[664][3] = 1; 
array[668][3] = 1; 
array[673][3] = 1; 
array[675][3] = 1; 
array[677][3] = 1; 
array[680][3] = 1; 
array[687][3] = 1; 
array[690][3] = 1; 
array[691][3] = 1; 
array[695][3] = 1; 
array[696][3] = 1; 
array[698][3] = 1; 
array[701][3] = 1; 
array[702][3] = 1; 
array[710][3] = 1; 
array[712][3] = 1; 
array[714][3] = 1; 
array[719][3] = 1; 
array[724][3] = 1; 
array[728][3] = 1; 
array[731][3] = 1; 
array[733][3] = 1; 
array[735][3] = 1; 
array[742][3] = 1; 
array[743][3] = 1; 
array[745][3] = 1; 
array[751][3] = 1; 
array[752][3] = 1; 
array[754][3] = 1; 
array[758][3] = 1; 
array[760][3] = 1; 
array[762][3] = 1; 
array[763][3] = 1; 
array[766][3] = 1; 
array[767][3] = 1; 
array[768][3] = 1; 
array[771][3] = 1; 
array[775][3] = 1; 
array[778][3] = 1; 
array[780][3] = 1; 
array[783][3] = 1; 
array[786][3] = 1; 
array[789][3] = 1; 
array[792][3] = 1; 
array[796][3] = 1; 
array[797][3] = 1; 
array[800][3] = 1; 
array[804][3] = 1; 
array[807][3] = 1; 
array[814][3] = 1; 
array[817][3] = 1; 
array[818][3] = 1; 
array[823][3] = 1; 
array[826][3] = 1; 
array[839][3] = 1; 
array[845][3] = 1; 
array[846][3] = 1; 
array[849][3] = 1; 
array[853][3] = 1; 
array[856][3] = 1; 
array[859][3] = 1; 
array[861][3] = 1; 
array[864][3] = 1; 
array[876][3] = 1; 
array[877][3] = 1; 
array[879][3] = 1; 
array[887][3] = 1; 
array[903][3] = 1; 
array[906][3] = 1; 
array[908][3] = 1; 
array[911][3] = 1; 
array[914][3] = 1; 
array[915][3] = 1; 
array[917][3] = 1; 
array[918][3] = 1; 
array[919][3] = 1; 
array[922][3] = 1; 
array[923][3] = 1; 
array[926][3] = 1; 
array[929][3] = 1; 
array[930][3] = 1; 
array[933][3] = 1; 
array[934][3] = 1; 
array[946][3] = 1; 
array[948][3] = 1; 
array[950][3] = 1; 
array[951][3] = 1; 
array[952][3] = 1; 
array[954][3] = 1; 
array[958][3] = 1; 
array[960][3] = 1; 
array[965][3] = 1; 
array[968][3] = 1; 
array[969][3] = 1; 
array[973][3] = 1; 
array[977][3] = 1; 
array[980][3] = 1; 
array[984][3] = 1; 
array[985][3] = 1; 
array[993][3] = 1; 
array[995][3] = 1; 
array[996][3] = 1; 
array[998][3] = 1; 
array[999][3] = 1; 
array[1005][3] = 1; 
array[1012][3] = 1; 
array[1020][3] = 1; 
array[1024][3] = 1; 

/*
Load the fourth row with 40% one's.
--------------------------------------
*/
array[3][4] = 1; 
array[5][4] = 1; 
array[11][4] = 1; 
array[13][4] = 1; 
array[16][4] = 1; 
array[17][4] = 1; 
array[20][4] = 1; 
array[23][4] = 1; 
array[24][4] = 1; 
array[30][4] = 1; 
array[31][4] = 1; 
array[32][4] = 1; 
array[35][4] = 1; 
array[38][4] = 1; 
array[42][4] = 1; 
array[44][4] = 1; 
array[45][4] = 1; 
array[46][4] = 1; 
array[48][4] = 1; 
array[49][4] = 1; 
array[50][4] = 1; 
array[54][4] = 1; 
array[55][4] = 1; 
array[57][4] = 1; 
array[61][4] = 1; 
array[62][4] = 1; 
array[64][4] = 1; 
array[65][4] = 1; 
array[66][4] = 1; 
array[68][4] = 1; 
array[72][4] = 1; 
array[75][4] = 1; 
array[76][4] = 1; 
array[77][4] = 1; 
array[78][4] = 1; 
array[81][4] = 1; 
array[83][4] = 1; 
array[86][4] = 1; 
array[88][4] = 1; 
array[89][4] = 1; 
array[90][4] = 1; 
array[95][4] = 1; 
array[100][4] = 1; 
array[104][4] = 1; 
array[106][4] = 1; 
array[108][4] = 1; 
array[112][4] = 1; 
array[114][4] = 1; 
array[116][4] = 1; 
array[121][4] = 1; 
array[123][4] = 1; 
array[124][4] = 1; 
array[126][4] = 1; 
array[127][4] = 1; 
array[128][4] = 1; 
array[129][4] = 1; 
array[133][4] = 1; 
array[137][4] = 1; 
array[138][4] = 1; 
array[139][4] = 1; 
array[143][4] = 1; 
array[145][4] = 1; 
array[152][4] = 1; 
array[155][4] = 1; 
array[156][4] = 1; 
array[157][4] = 1; 
array[161][4] = 1; 
array[168][4] = 1; 
array[169][4] = 1; 
array[171][4] = 1; 
array[172][4] = 1; 
array[174][4] = 1; 
array[175][4] = 1; 
array[178][4] = 1; 
array[180][4] = 1; 
array[181][4] = 1; 
array[186][4] = 1; 
array[188][4] = 1; 
array[189][4] = 1; 
array[190][4] = 1; 
array[192][4] = 1; 
array[194][4] = 1; 
array[198][4] = 1; 
array[200][4] = 1; 
array[205][4] = 1; 
array[206][4] = 1; 
array[217][4] = 1; 
array[219][4] = 1; 
array[221][4] = 1; 
array[226][4] = 1; 
array[229][4] = 1; 
array[232][4] = 1; 
array[233][4] = 1; 
array[238][4] = 1; 
array[239][4] = 1; 
array[243][4] = 1; 
array[246][4] = 1; 
array[253][4] = 1; 
array[256][4] = 1; 
array[257][4] = 1; 
array[258][4] = 1; 
array[260][4] = 1; 
array[261][4] = 1; 
array[262][4] = 1; 
array[263][4] = 1; 
array[268][4] = 1; 
array[269][4] = 1; 
array[270][4] = 1; 
array[272][4] = 1; 
array[274][4] = 1; 
array[275][4] = 1; 
array[276][4] = 1; 
array[280][4] = 1; 
array[283][4] = 1; 
array[284][4] = 1; 
array[285][4] = 1; 
array[286][4] = 1; 
array[287][4] = 1; 
array[290][4] = 1; 
array[294][4] = 1; 
array[298][4] = 1; 
array[299][4] = 1; 
array[300][4] = 1; 
array[306][4] = 1; 
array[307][4] = 1; 
array[308][4] = 1; 
array[309][4] = 1; 
array[314][4] = 1; 
array[315][4] = 1; 
array[318][4] = 1; 
array[325][4] = 1; 
array[331][4] = 1; 
array[335][4] = 1; 
array[340][4] = 1; 
array[342][4] = 1; 
array[344][4] = 1; 
array[347][4] = 1; 
array[348][4] = 1; 
array[350][4] = 1; 
array[353][4] = 1; 
array[356][4] = 1; 
array[357][4] = 1; 
array[362][4] = 1; 
array[364][4] = 1; 
array[367][4] = 1; 
array[368][4] = 1; 
array[369][4] = 1; 
array[370][4] = 1; 
array[374][4] = 1; 
array[378][4] = 1; 
array[379][4] = 1; 
array[380][4] = 1; 
array[386][4] = 1; 
array[387][4] = 1; 
array[389][4] = 1; 
array[396][4] = 1; 
array[397][4] = 1; 
array[401][4] = 1; 
array[402][4] = 1; 
array[404][4] = 1; 
array[406][4] = 1; 
array[407][4] = 1; 
array[409][4] = 1; 
array[410][4] = 1; 
array[411][4] = 1; 
array[413][4] = 1; 
array[415][4] = 1; 
array[417][4] = 1; 
array[418][4] = 1; 
array[423][4] = 1; 
array[428][4] = 1; 
array[432][4] = 1; 
array[433][4] = 1; 
array[436][4] = 1; 
array[437][4] = 1; 
array[438][4] = 1; 
array[443][4] = 1; 
array[446][4] = 1; 
array[447][4] = 1; 
array[450][4] = 1; 
array[458][4] = 1; 
array[459][4] = 1; 
array[463][4] = 1; 
array[467][4] = 1; 
array[469][4] = 1; 
array[472][4] = 1; 
array[477][4] = 1; 
array[479][4] = 1; 
array[480][4] = 1; 
array[481][4] = 1; 
array[490][4] = 1; 
array[491][4] = 1; 
array[492][4] = 1; 
array[493][4] = 1; 
array[498][4] = 1; 
array[499][4] = 1; 
array[501][4] = 1; 
array[502][4] = 1; 
array[508][4] = 1; 
array[509][4] = 1; 
array[516][4] = 1; 
array[518][4] = 1; 
array[521][4] = 1; 
array[525][4] = 1; 
array[530][4] = 1; 
array[531][4] = 1; 
array[536][4] = 1; 
array[541][4] = 1; 
array[542][4] = 1;
array[543][4] = 1; 
array[545][4] = 1; 
array[547][4] = 1; 
array[552][4] = 1; 
array[554][4] = 1; 
array[556][4] = 1; 
array[560][4] = 1; 
array[562][4] = 1; 
array[565][4] = 1; 
array[567][4] = 1; 
array[568][4] = 1; 
array[572][4] = 1; 
array[574][4] = 1; 
array[578][4] = 1; 
array[581][4] = 1; 
array[583][4] = 1; 
array[586][4] = 1; 
array[589][4] = 1; 
array[590][4] = 1; 
array[595][4] = 1; 
array[599][4] = 1; 
array[605][4] = 1; 
array[609][4] = 1; 
array[611][4] = 1; 
array[616][4] = 1; 
array[618][4] = 1; 
array[620][4] = 1; 
array[624][4] = 1; 
array[626][4] = 1; 
array[629][4] = 1; 
array[630][4] = 1; 
array[631][4] = 1; 
array[632][4] = 1; 
array[635][4] = 1; 
array[637][4] = 1; 
array[638][4] = 1; 
array[640][4] = 1; 
array[641][4] = 1; 
array[642][4] = 1; 
array[643][4] = 1; 
array[646][4] = 1; 
array[648][4] = 1; 
array[651][4] = 1; 
array[655][4] = 1; 
array[658][4] = 1; 
array[660][4] = 1; 
array[662][4] = 1; 
array[664][4] = 1; 
array[665][4] = 1; 
array[666][4] = 1; 
array[667][4] = 1; 
array[670][4] = 1; 
array[671][4] = 1; 
array[674][4] = 1; 
array[677][4] = 1; 
array[678][4] = 1; 
array[681][4] = 1; 
array[684][4] = 1; 
array[685][4] = 1; 
array[689][4] = 1; 
array[691][4] = 1; 
array[693][4] = 1; 
array[695][4] = 1; 
array[696][4] = 1; 
array[704][4] = 1; 
array[708][4] = 1; 
array[709][4] = 1; 
array[710][4] = 1; 
array[712][4] = 1; 
array[717][4] = 1; 
array[718][4] = 1; 
array[719][4] = 1; 
array[724][4] = 1; 
array[725][4] = 1; 
array[728][4] = 1; 
array[729][4] = 1; 
array[730][4] = 1; 
array[731][4] = 1; 
array[732][4] = 1; 
array[735][4] = 1; 
array[738][4] = 1; 
array[739][4] = 1; 
array[740][4] = 1; 
array[741][4] = 1; 
array[742][4] = 1; 
array[746][4] = 1; 
array[747][4] = 1; 
array[748][4] = 1; 
array[749][4] = 1; 
array[751][4] = 1; 
array[752][4] = 1; 
array[754][4] = 1; 
array[758][4] = 1; 
array[763][4] = 1; 
array[764][4] = 1; 
array[767][4] = 1; 
array[768][4] = 1; 
array[774][4] = 1; 
array[775][4] = 1; 
array[776][4] = 1; 
array[777][4] = 1; 
array[779][4] = 1; 
array[780][4] = 1; 
array[781][4] = 1; 
array[784][4] = 1; 
array[789][4] = 1; 
array[793][4] = 1; 
array[794][4] = 1; 
array[797][4] = 1; 
array[799][4] = 1; 
array[800][4] = 1; 
array[803][4] = 1; 
array[808][4] = 1; 
array[809][4] = 1; 
array[810][4] = 1; 
array[813][4] = 1; 
array[815][4] = 1; 
array[819][4] = 1; 
array[821][4] = 1; 
array[823][4] = 1; 
array[829][4] = 1; 
array[831][4] = 1; 
array[832][4] = 1; 
array[833][4] = 1; 
array[834][4] = 1; 
array[835][4] = 1; 
array[837][4] = 1; 
array[838][4] = 1; 
array[839][4] = 1; 
array[842][4] = 1; 
array[844][4] = 1; 
array[846][4] = 1; 
array[849][4] = 1; 
array[851][4] = 1; 
array[852][4] = 1; 
array[854][4] = 1; 
array[855][4] = 1; 
array[859][4] = 1; 
array[865][4] = 1; 
array[867][4] = 1; 
array[868][4] = 1; 
array[869][4] = 1; 
array[872][4] = 1; 
array[875][4] = 1; 
array[878][4] = 1; 
array[880][4] = 1; 
array[881][4] = 1; 
array[882][4] = 1; 
array[883][4] = 1; 
array[884][4] = 1; 
array[885][4] = 1; 
array[887][4] = 1; 
array[888][4] = 1; 
array[890][4] = 1; 
array[894][4] = 1; 
array[905][4] = 1; 
array[907][4] = 1; 
array[908][4] = 1; 
array[912][4] = 1; 
array[914][4] = 1; 
array[919][4] = 1; 
array[924][4] = 1; 
array[925][4] = 1; 
array[926][4] = 1; 
array[928][4] = 1; 
array[931][4] = 1; 
array[935][4] = 1; 
array[938][4] = 1; 
array[939][4] = 1; 
array[942][4] = 1; 
array[948][4] = 1; 
array[952][4] = 1; 
array[955][4] = 1; 
array[956][4] = 1; 
array[958][4] = 1; 
array[960][4] = 1; 
array[961][4] = 1; 
array[963][4] = 1; 
array[969][4] = 1; 
array[974][4] = 1; 
array[975][4] = 1; 
array[976][4] = 1; 
array[978][4] = 1; 
array[979][4] = 1; 
array[981][4] = 1; 
array[982][4] = 1; 
array[983][4] = 1; 
array[985][4] = 1; 
array[986][4] = 1; 
array[991][4] = 1; 
array[993][4] = 1; 
array[997][4] = 1; 
array[1000][4] = 1; 
array[1004][4] = 1; 
array[1005][4] = 1; 
array[1012][4] = 1; 
array[1014][4] = 1; 
array[1020][4] = 1; 
array[1021][4] = 1; 
array[1023][4] = 1; 
array[1024][4] = 1; 

/*
Load the fifth row with 50% one's.
-------------------------------------
*/
array[2][5] = 1; 
array[5][5] = 1; 
array[6][5] = 1; 
array[7][5] = 1; 
array[9][5] = 1; 
array[12][5] = 1; 
array[19][5] = 1; 
array[20][5] = 1; 
array[21][5] = 1; 
array[23][5] = 1; 
array[24][5] = 1; 
array[27][5] = 1; 
array[39][5] = 1; 
array[40][5] = 1; 
array[45][5] = 1; 
array[46][5] = 1; 
array[47][5] = 1; 
array[50][5] = 1; 
array[51][5] = 1; 
array[54][5] = 1; 
array[57][5] = 1; 
array[59][5] = 1; 
array[60][5] = 1; 
array[61][5] = 1; 
array[64][5] = 1; 
array[66][5] = 1; 
array[69][5] = 1; 
array[72][5] = 1; 
array[75][5] = 1; 
array[77][5] = 1; 
array[80][5] = 1; 
array[81][5] = 1; 
array[83][5] = 1; 
array[84][5] = 1; 
array[86][5] = 1; 
array[87][5] = 1; 
array[88][5] = 1; 
array[91][5] = 1; 
array[94][5] = 1; 
array[95][5] = 1; 
array[96][5] = 1; 
array[101][5] = 1; 
array[102][5] = 1; 
array[103][5] = 1; 
array[104][5] = 1; 
array[105][5] = 1; 
array[106][5] = 1; 
array[107][5] = 1; 
array[113][5] = 1; 
array[116][5] = 1; 
array[118][5] = 1; 
array[119][5] = 1; 
array[122][5] = 1; 
array[125][5] = 1; 
array[126][5] = 1; 
array[127][5] = 1; 
array[128][5] = 1; 
array[129][5] = 1; 
array[132][5] = 1; 
array[134][5] = 1; 
array[135][5] = 1; 
array[137][5] = 1; 
array[138][5] = 1; 
array[140][5] = 1; 
array[141][5] = 1; 
array[143][5] = 1; 
array[144][5] = 1; 
array[146][5] = 1; 
array[149][5] = 1; 
array[150][5] = 1; 
array[152][5] = 1; 
array[154][5] = 1; 
array[155][5] = 1; 
array[160][5] = 1; 
array[162][5] = 1; 
array[163][5] = 1; 
array[165][5] = 1; 
array[166][5] = 1; 
array[167][5] = 1; 
array[168][5] = 1; 
array[169][5] = 1; 
array[170][5] = 1; 
array[173][5] = 1; 
array[176][5] = 1; 
array[179][5] = 1; 
array[180][5] = 1; 
array[182][5] = 1; 
array[183][5] = 1; 
array[185][5] = 1; 
array[186][5] = 1; 
array[187][5] = 1; 
array[189][5] = 1; 
array[190][5] = 1; 
array[195][5] = 1; 
array[196][5] = 1; 
array[197][5] = 1; 
array[203][5] = 1; 
array[205][5] = 1; 
array[207][5] = 1; 
array[208][5] = 1; 
array[211][5] = 1; 
array[213][5] = 1; 
array[223][5] = 1; 
array[225][5] = 1; 
array[226][5] = 1; 
array[227][5] = 1; 
array[230][5] = 1; 
array[232][5] = 1; 
array[233][5] = 1; 
array[234][5] = 1; 
array[237][5] = 1; 
array[240][5] = 1; 
array[241][5] = 1; 
array[245][5] = 1; 
array[246][5] = 1; 
array[247][5] = 1; 
array[255][5] = 1; 
array[260][5] = 1; 
array[262][5] = 1; 
array[265][5] = 1; 
array[266][5] = 1; 
array[267][5] = 1; 
array[272][5] = 1; 
array[274][5] = 1; 
array[275][5] = 1; 
array[276][5] = 1; 
array[278][5] = 1; 
array[279][5] = 1; 
array[280][5] = 1; 
array[281][5] = 1; 
array[282][5] = 1; 
array[283][5] = 1; 
array[285][5] = 1; 
array[286][5] = 1; 
array[294][5] = 1; 
array[295][5] = 1; 
array[296][5] = 1; 
array[298][5] = 1; 
array[299][5] = 1; 
array[300][5] = 1; 
array[301][5] = 1; 
array[303][5] = 1; 
array[305][5] = 1; 
array[306][5] = 1; 
array[307][5] = 1; 
array[310][5] = 1; 
array[311][5] = 1; 
array[312][5] = 1; 
array[314][5] = 1; 
array[317][5] = 1; 
array[318][5] = 1; 
array[319][5] = 1; 
array[320][5] = 1; 
array[321][5] = 1; 
array[322][5] = 1; 
array[325][5] = 1; 
array[326][5] = 1; 
array[332][5] = 1; 
array[333][5] = 1; 
array[334][5] = 1; 
array[335][5] = 1; 
array[337][5] = 1; 
array[338][5] = 1; 
array[339][5] = 1; 
array[341][5] = 1; 
array[342][5] = 1; 
array[347][5] = 1; 
array[351][5] = 1; 
array[354][5] = 1; 
array[355][5] = 1; 
array[356][5] = 1; 
array[357][5] = 1; 
array[363][5] = 1; 
array[366][5] = 1; 
array[367][5] = 1; 
array[370][5] = 1; 
array[371][5] = 1; 
array[372][5] = 1; 
array[373][5] = 1; 
array[374][5] = 1; 
array[375][5] = 1; 
array[376][5] = 1; 
array[377][5] = 1; 
array[380][5] = 1; 
array[382][5] = 1; 
array[383][5] = 1; 
array[384][5] = 1; 
array[385][5] = 1; 
array[386][5] = 1; 
array[389][5] = 1; 
array[390][5] = 1; 
array[393][5] = 1; 
array[397][5] = 1; 
array[400][5] = 1; 
array[401][5] = 1; 
array[402][5] = 1; 
array[403][5] = 1; 
array[406][5] = 1; 
array[407][5] = 1; 
array[408][5] = 1; 
array[409][5] = 1; 
array[411][5] = 1; 
array[412][5] = 1; 
array[414][5] = 1; 
array[416][5] = 1; 
array[417][5] = 1; 
array[423][5] = 1; 
array[425][5] = 1; 
array[426][5] = 1; 
array[429][5] = 1; 
array[430][5] = 1; 
array[432][5] = 1; 
array[434][5] = 1; 
array[435][5] = 1; 
array[436][5] = 1; 
array[438][5] = 1; 
array[439][5] = 1; 
array[440][5] = 1; 
array[441][5] = 1; 
array[442][5] = 1; 
array[443][5] = 1; 
array[444][5] = 1; 
array[446][5] = 1; 
array[447][5] = 1; 
array[449][5] = 1; 
array[450][5] = 1; 
array[455][5] = 1; 
array[456][5] = 1; 
array[457][5] = 1; 
array[458][5] = 1; 
array[459][5] = 1; 
array[460][5] = 1; 
array[462][5] = 1; 
array[464][5] = 1; 
array[466][5] = 1; 
array[467][5] = 1; 
array[472][5] = 1; 
array[476][5] = 1; 
array[477][5] = 1; 
array[482][5] = 1; 
array[483][5] = 1; 
array[484][5] = 1; 
array[485][5] = 1; 
array[488][5] = 1; 
array[490][5] = 1; 
array[493][5] = 1; 
array[495][5] = 1; 
array[498][5] = 1; 
array[499][5] = 1; 
array[502][5] = 1; 
array[503][5] = 1; 
array[504][5] = 1; 
array[507][5] = 1; 
array[509][5] = 1; 
array[510][5] = 1; 
array[511][5] = 1; 
array[514][5] = 1; 
array[516][5] = 1; 
array[517][5] = 1; 
array[518][5] = 1; 
array[519][5] = 1; 
array[520][5] = 1; 
array[522][5] = 1; 
array[529][5] = 1; 
array[533][5] = 1; 
array[537][5] = 1; 
array[538][5] = 1; 
array[543][5] = 1; 
array[545][5] = 1; 
array[546][5] = 1; 
array[548][5] = 1; 
array[549][5] = 1; 
array[551][5] = 1; 
array[555][5] = 1; 
array[556][5] = 1; 
array[558][5] = 1; 
array[561][5] = 1; 
array[562][5] = 1; 
array[563][5] = 1; 
array[566][5] = 1; 
array[567][5] = 1; 
array[569][5] = 1; 
array[571][5] = 1; 
array[575][5] = 1; 
array[576][5] = 1; 
array[578][5] = 1; 
array[580][5] = 1; 
array[583][5] = 1; 
array[584][5] = 1; 
array[585][5] = 1; 
array[586][5] = 1; 
array[587][5] = 1; 
array[588][5] = 1; 
array[591][5] = 1; 
array[593][5] = 1; 
array[595][5] = 1; 
array[596][5] = 1; 
array[599][5] = 1; 
array[601][5] = 1; 
array[603][5] = 1; 
array[605][5] = 1; 
array[608][5] = 1; 
array[610][5] = 1; 
array[612][5] = 1; 
array[613][5] = 1; 
array[615][5] = 1; 
array[617][5] = 1; 
array[619][5] = 1; 
array[621][5] = 1; 
array[622][5] = 1; 
array[625][5] = 1; 
array[626][5] = 1; 
array[630][5] = 1; 
array[632][5] = 1; 
array[633][5] = 1; 
array[635][5] = 1; 
array[641][5] = 1; 
array[642][5] = 1; 
array[643][5] = 1; 
array[645][5] = 1; 
array[648][5] = 1; 
array[649][5] = 1; 
array[650][5] = 1; 
array[652][5] = 1; 
array[655][5] = 1; 
array[656][5] = 1; 
array[658][5] = 1; 
array[661][5] = 1; 
array[663][5] = 1; 
array[664][5] = 1; 
array[667][5] = 1; 
array[669][5] = 1; 
array[670][5] = 1; 
array[673][5] = 1; 
array[675][5] = 1; 
array[676][5] = 1; 
array[677][5] = 1; 
array[678][5] = 1; 
array[686][5] = 1; 
array[687][5] = 1; 
array[688][5] = 1; 
array[690][5] = 1; 
array[691][5] = 1; 
array[692][5] = 1; 
array[693][5] = 1; 
array[695][5] = 1; 
array[697][5] = 1; 
array[698][5] = 1; 
array[699][5] = 1; 
array[705][5] = 1; 
array[708][5] = 1; 
array[709][5] = 1; 
array[710][5] = 1; 
array[711][5] = 1; 
array[714][5] = 1; 
array[715][5] = 1; 
array[718][5] = 1; 
array[722][5] = 1; 
array[726][5] = 1; 
array[727][5] = 1; 
array[729][5] = 1; 
array[731][5] = 1; 
array[732][5] = 1; 
array[735][5] = 1; 
array[737][5] = 1; 
array[739][5] = 1; 
array[741][5] = 1; 
array[743][5] = 1; 
array[746][5] = 1; 
array[748][5] = 1; 
array[749][5] = 1; 
array[750][5] = 1; 
array[753][5] = 1; 
array[755][5] = 1; 
array[758][5] = 1; 
array[759][5] = 1; 
array[760][5] = 1; 
array[764][5] = 1; 
array[766][5] = 1; 
array[767][5] = 1; 
array[771][5] = 1; 
array[772][5] = 1; 
array[775][5] = 1; 
array[778][5] = 1; 
array[781][5] = 1; 
array[782][5] = 1; 
array[783][5] = 1; 
array[785][5] = 1; 
array[786][5] = 1; 
array[788][5] = 1; 
array[800][5] = 1; 
array[802][5] = 1; 
array[804][5] = 1; 
array[806][5] = 1; 
array[808][5] = 1; 
array[812][5] = 1; 
array[814][5] = 1; 
array[818][5] = 1; 
array[820][5] = 1; 
array[822][5] = 1; 
array[823][5] = 1; 
array[826][5] = 1; 
array[828][5] = 1; 
array[829][5] = 1; 
array[830][5] = 1; 
array[832][5] = 1; 
array[833][5] = 1; 
array[835][5] = 1; 
array[837][5] = 1; 
array[838][5] = 1; 
array[841][5] = 1; 
array[843][5] = 1; 
array[844][5] = 1; 
array[845][5] = 1; 
array[847][5] = 1; 
array[851][5] = 1; 
array[852][5] = 1; 
array[857][5] = 1; 
array[859][5] = 1; 
array[863][5] = 1; 
array[864][5] = 1; 
array[867][5] = 1; 
array[871][5] = 1; 
array[872][5] = 1; 
array[875][5] = 1; 
array[876][5] = 1; 
array[877][5] = 1; 
array[879][5] = 1; 
array[881][5] = 1; 
array[883][5] = 1; 
array[884][5] = 1; 
array[885][5] = 1; 
array[886][5] = 1; 
array[887][5] = 1; 
array[888][5] = 1; 
array[889][5] = 1; 
array[890][5] = 1; 
array[891][5] = 1; 
array[893][5] = 1; 
array[897][5] = 1; 
array[898][5] = 1; 
array[899][5] = 1; 
array[900][5] = 1; 
array[901][5] = 1; 
array[902][5] = 1; 
array[904][5] = 1; 
array[906][5] = 1; 
array[909][5] = 1; 
array[910][5] = 1; 
array[913][5] = 1; 
array[915][5] = 1; 
array[916][5] = 1; 
array[918][5] = 1; 
array[919][5] = 1; 
array[920][5] = 1; 
array[921][5] = 1; 
array[923][5] = 1; 
array[924][5] = 1; 
array[925][5] = 1; 
array[926][5] = 1; 
array[929][5] = 1; 
array[931][5] = 1; 
array[933][5] = 1; 
array[934][5] = 1; 
array[935][5] = 1; 
array[939][5] = 1; 
array[941][5] = 1; 
array[942][5] = 1; 
array[943][5] = 1; 
array[944][5] = 1; 
array[945][5] = 1; 
array[947][5] = 1; 
array[948][5] = 1; 
array[949][5] = 1; 
array[950][5] = 1; 
array[951][5] = 1; 
array[956][5] = 1; 
array[958][5] = 1; 
array[959][5] = 1; 
array[961][5] = 1; 
array[962][5] = 1; 
array[964][5] = 1; 
array[966][5] = 1; 
array[968][5] = 1; 
array[969][5] = 1; 
array[970][5] = 1; 
array[973][5] = 1; 
array[974][5] = 1; 
array[975][5] = 1; 
array[978][5] = 1; 
array[981][5] = 1; 
array[982][5] = 1; 
array[985][5] = 1; 
array[987][5] = 1; 
array[990][5] = 1; 
array[992][5] = 1; 
array[993][5] = 1; 
array[994][5] = 1; 
array[995][5] = 1; 
array[996][5] = 1; 
array[1001][5] = 1; 
array[1004][5] = 1; 
array[1006][5] = 1; 
array[1007][5] = 1; 
array[1008][5] = 1; 
array[1010][5] = 1; 
array[1014][5] = 1; 
array[1016][5] = 1; 
array[1020][5] = 1; 
array[1021][5] = 1; 
array[1022][5] = 1; 
array[1024][5] = 1; 

/*
Load the sixth row with 40% zero's.
--------------------------------------
*/
array[3][6] = 0; 
array[4][6] = 0; 
array[5][6] = 0; 
array[8][6] = 0; 
array[10][6] = 0; 
array[13][6] = 0; 
array[15][6] = 0; 
array[20][6] = 0; 
array[24][6] = 0; 
array[26][6] = 0; 
array[31][6] = 0; 
array[34][6] = 0; 
array[36][6] = 0; 
array[38][6] = 0; 
array[40][6] = 0; 
array[41][6] = 0; 
array[42][6] = 0; 
array[43][6] = 0; 
array[44][6] = 0; 
array[46][6] = 0; 
array[49][6] = 0; 
array[50][6] = 0; 
array[52][6] = 0; 
array[55][6] = 0; 
array[56][6] = 0; 
array[58][6] = 0; 
array[60][6] = 0; 
array[62][6] = 0; 
array[68][6] = 0; 
array[71][6] = 0; 
array[73][6] = 0; 
array[74][6] = 0; 
array[78][6] = 0; 
array[81][6] = 0; 
array[82][6] = 0; 
array[83][6] = 0; 
array[84][6] = 0; 
array[85][6] = 0; 
array[93][6] = 0; 
array[95][6] = 0; 
array[96][6] = 0; 
array[98][6] = 0; 
array[99][6] = 0; 
array[103][6] = 0; 
array[104][6] = 0; 
array[105][6] = 0; 
array[107][6] = 0; 
array[108][6] = 0; 
array[109][6] = 0; 
array[117][6] = 0; 
array[118][6] = 0; 
array[123][6] = 0; 
array[126][6] = 0; 
array[130][6] = 0; 
array[131][6] = 0; 
array[134][6] = 0; 
array[137][6] = 0; 
array[138][6] = 0; 
array[144][6] = 0; 
array[145][6] = 0; 
array[147][6] = 0; 
array[149][6] = 0; 
array[152][6] = 0; 
array[153][6] = 0; 
array[155][6] = 0; 
array[162][6] = 0; 
array[164][6] = 0; 
array[166][6] = 0; 
array[173][6] = 0; 
array[174][6] = 0; 
array[176][6] = 0; 
array[178][6] = 0; 
array[179][6] = 0; 
array[181][6] = 0; 
array[182][6] = 0; 
array[183][6] = 0; 
array[184][6] = 0; 
array[185][6] = 0; 
array[189][6] = 0; 
array[193][6] = 0; 
array[194][6] = 0; 
array[195][6] = 0; 
array[196][6] = 0; 
array[197][6] = 0; 
array[198][6] = 0; 
array[200][6] = 0; 
array[202][6] = 0; 
array[203][6] = 0; 
array[206][6] = 0; 
array[208][6] = 0; 
array[213][6] = 0; 
array[215][6] = 0; 
array[217][6] = 0; 
array[220][6] = 0; 
array[221][6] = 0; 
array[222][6] = 0; 
array[223][6] = 0; 
array[224][6] = 0; 
array[227][6] = 0; 
array[233][6] = 0; 
array[235][6] = 0; 
array[237][6] = 0; 
array[241][6] = 0; 
array[244][6] = 0; 
array[245][6] = 0; 
array[246][6] = 0; 
array[251][6] = 0; 
array[252][6] = 0; 
array[256][6] = 0; 
array[257][6] = 0; 
array[258][6] = 0; 
array[259][6] = 0; 
array[261][6] = 0; 
array[262][6] = 0; 
array[263][6] = 0; 
array[268][6] = 0; 
array[271][6] = 0; 
array[272][6] = 0; 
array[274][6] = 0; 
array[275][6] = 0; 
array[276][6] = 0; 
array[282][6] = 0; 
array[284][6] = 0; 
array[285][6] = 0; 
array[286][6] = 0; 
array[287][6] = 0; 
array[288][6] = 0; 
array[289][6] = 0; 
array[290][6] = 0; 
array[294][6] = 0; 
array[295][6] = 0; 
array[301][6] = 0; 
array[303][6] = 0; 
array[304][6] = 0; 
array[306][6] = 0; 
array[309][6] = 0; 
array[312][6] = 0; 
array[313][6] = 0; 
array[315][6] = 0; 
array[318][6] = 0; 
array[319][6] = 0; 
array[320][6] = 0; 
array[322][6] = 0; 
array[326][6] = 0; 
array[327][6] = 0; 
array[328][6] = 0; 
array[335][6] = 0; 
array[340][6] = 0; 
array[342][6] = 0; 
array[348][6] = 0; 
array[349][6] = 0; 
array[352][6] = 0; 
array[353][6] = 0; 
array[355][6] = 0; 
array[358][6] = 0; 
array[368][6] = 0; 
array[371][6] = 0; 
array[372][6] = 0; 
array[377][6] = 0; 
array[379][6] = 0; 
array[382][6] = 0; 
array[387][6] = 0; 
array[389][6] = 0; 
array[393][6] = 0; 
array[394][6] = 0; 
array[395][6] = 0; 
array[398][6] = 0; 
array[401][6] = 0; 
array[403][6] = 0; 
array[405][6] = 0; 
array[407][6] = 0; 
array[412][6] = 0; 
array[413][6] = 0; 
array[417][6] = 0; 
array[422][6] = 0; 
array[426][6] = 0; 
array[429][6] = 0; 
array[433][6] = 0; 
array[440][6] = 0; 
array[443][6] = 0; 
array[444][6] = 0; 
array[447][6] = 0; 
array[448][6] = 0; 
array[450][6] = 0; 
array[453][6] = 0; 
array[455][6] = 0; 
array[457][6] = 0; 
array[463][6] = 0; 
array[467][6] = 0; 
array[468][6] = 0; 
array[475][6] = 0; 
array[476][6] = 0; 
array[477][6] = 0; 
array[478][6] = 0; 
array[482][6] = 0; 
array[484][6] = 0; 
array[485][6] = 0; 
array[486][6] = 0; 
array[490][6] = 0; 
array[491][6] = 0; 
array[493][6] = 0; 
array[498][6] = 0; 
array[500][6] = 0; 
array[503][6] = 0; 
array[505][6] = 0; 
array[506][6] = 0; 
array[508][6] = 0; 
array[509][6] = 0; 
array[510][6] = 0; 
array[511][6] = 0; 
array[516][6] = 0; 
array[520][6] = 0; 
array[521][6] = 0; 
array[522][6] = 0; 
array[526][6] = 0; 
array[530][6] = 0; 
array[531][6] = 0;
array[532][6] = 0; 
array[533][6] = 0; 
array[536][6] = 0; 
array[537][6] = 0; 
array[538][6] = 0; 
array[539][6] = 0; 
array[541][6] = 0; 
array[546][6] = 0; 
array[551][6] = 0; 
array[557][6] = 0; 
array[559][6] = 0; 
array[560][6] = 0; 
array[561][6] = 0; 
array[562][6] = 0; 
array[566][6] = 0; 
array[568][6] = 0; 
array[571][6] = 0; 
array[572][6] = 0; 
array[573][6] = 0; 
array[576][6] = 0; 
array[580][6] = 0; 
array[583][6] = 0; 
array[590][6] = 0; 
array[592][6] = 0; 
array[594][6] = 0; 
array[596][6] = 0; 
array[599][6] = 0; 
array[600][6] = 0; 
array[606][6] = 0; 
array[608][6] = 0; 
array[609][6] = 0; 
array[610][6] = 0; 
array[612][6] = 0; 
array[614][6] = 0; 
array[619][6] = 0; 
array[620][6] = 0; 
array[621][6] = 0; 
array[623][6] = 0; 
array[627][6] = 0; 
array[633][6] = 0; 
array[635][6] = 0; 
array[636][6] = 0; 
array[638][6] = 0; 
array[639][6] = 0; 
array[640][6] = 0;
array[642][6] = 0;
array[643][6] = 0; 
array[644][6] = 0;
array[645][6] = 0;
array[646][6] = 0;
array[647][6] = 0; 
array[649][6] = 0; 
array[650][6] = 0; 
array[651][6] = 0; 
array[652][6] = 0; 
array[660][6] = 0; 
array[661][6] = 0; 
array[670][6] = 0; 
array[672][6] = 0; 
array[673][6] = 0; 
array[677][6] = 0; 
array[684][6] = 0; 
array[686][6] = 0; 
array[688][6] = 0; 
array[695][6] = 0; 
array[696][6] = 0; 
array[698][6] = 0; 
array[700][6] = 0; 
array[702][6] = 0; 
array[707][6] = 0; 
array[708][6] = 0; 
array[711][6] = 0; 
array[718][6] = 0; 
array[723][6] = 0; 
array[728][6] = 0; 
array[733][6] = 0; 
array[737][6] = 0; 
array[738][6] = 0; 
array[739][6] = 0; 
array[741][6] = 0; 
array[742][6] = 0; 
array[745][6] = 0; 
array[753][6] = 0; 
array[755][6] = 0; 
array[758][6] = 0; 
array[761][6] = 0; 
array[762][6] = 0; 
array[764][6] = 0; 
array[771][6] = 0; 
array[773][6] = 0; 
array[774][6] = 0; 
array[778][6] = 0; 
array[780][6] = 0; 
array[781][6] = 0; 
array[785][6] = 0; 
array[790][6] = 0; 
array[793][6] = 0; 
array[794][6] = 0; 
array[799][6] = 0; 
array[803][6] = 0; 
array[807][6] = 0; 
array[814][6] = 0; 
array[817][6] = 0; 
array[818][6] = 0; 
array[819][6] = 0; 
array[821][6] = 0; 
array[822][6] = 0; 
array[823][6] = 0; 
array[824][6] = 0; 
array[827][6] = 0; 
array[830][6] = 0; 
array[832][6] = 0; 
array[833][6] = 0; 
array[834][6] = 0; 
array[839][6] = 0; 
array[842][6] = 0; 
array[843][6] = 0; 
array[845][6] = 0; 
array[848][6] = 0; 
array[850][6] = 0; 
array[853][6] = 0; 
array[854][6] = 0; 
array[857][6] = 0; 
array[858][6] = 0; 
array[859][6] = 0; 
array[863][6] = 0; 
array[864][6] = 0; 
array[865][6] = 0; 
array[867][6] = 0; 
array[868][6] = 0; 
array[870][6] = 0; 
array[874][6] = 0; 
array[878][6] = 0; 
array[880][6] = 0; 
array[882][6] = 0; 
array[883][6] = 0; 
array[884][6] = 0; 
array[885][6] = 0; 
array[887][6] = 0; 
array[892][6] = 0; 
array[894][6] = 0; 
array[895][6] = 0; 
array[898][6] = 0; 
array[899][6] = 0; 
array[900][6] = 0; 
array[903][6] = 0; 
array[904][6] = 0; 
array[908][6] = 0; 
array[910][6] = 0; 
array[911][6] = 0; 
array[912][6] = 0; 
array[913][6] = 0; 
array[916][6] = 0; 
array[918][6] = 0; 
array[919][6] = 0; 
array[920][6] = 0; 
array[922][6] = 0; 
array[928][6] = 0; 
array[932][6] = 0; 
array[933][6] = 0; 
array[936][6] = 0; 
array[937][6] = 0; 
array[938][6] = 0; 
array[946][6] = 0; 
array[947][6] = 0; 
array[949][6] = 0; 
array[953][6] = 0; 
array[954][6] = 0; 
array[955][6] = 0; 
array[960][6] = 0; 
array[963][6] = 0; 
array[965][6] = 0; 
array[966][6] = 0; 
array[971][6] = 0; 
array[977][6] = 0; 
array[980][6] = 0; 
array[982][6] = 0; 
array[983][6] = 0; 
array[984][6] = 0; 
array[985][6] = 0; 
array[987][6] = 0; 
array[990][6] = 0; 
array[995][6] = 0; 
array[996][6] = 0; 
array[999][6] = 0; 
array[1006][6] = 0; 
array[1010][6] = 0; 
array[1012][6] = 0; 
array[1015][6] = 0; 
array[1020][6] = 0; 
array[1021][6] = 0; 
array[1022][6] = 0; 
array[1024][6] = 0; 

/*
Load the seventh row with 30% zero's.
----------------------------------------
*/
array[7][7] = 0; 
array[9][7] = 0; 
array[11][7] = 0; 
array[12][7] = 0; 
array[13][7] = 0; 
array[15][7] = 0; 
array[19][7] = 0; 
array[23][7] = 0; 
array[24][7] = 0; 
array[28][7] = 0; 
array[31][7] = 0; 
array[35][7] = 0; 
array[38][7] = 0; 
array[39][7] = 0; 
array[40][7] = 0; 
array[41][7] = 0; 
array[44][7] = 0; 
array[52][7] = 0; 
array[58][7] = 0; 
array[62][7] = 0; 
array[72][7] = 0; 
array[81][7] = 0; 
array[84][7] = 0; 
array[86][7] = 0; 
array[88][7] = 0; 
array[89][7] = 0; 
array[93][7] = 0; 
array[95][7] = 0; 
array[101][7] = 0; 
array[104][7] = 0; 
array[111][7] = 0; 
array[114][7] = 0; 
array[115][7] = 0; 
array[117][7] = 0; 
array[118][7] = 0; 
array[122][7] = 0; 
array[125][7] = 0; 
array[131][7] = 0; 
array[132][7] = 0; 
array[134][7] = 0; 
array[135][7] = 0; 
array[137][7] = 0; 
array[138][7] = 0; 
array[142][7] = 0; 
array[143][7] = 0; 
array[149][7] = 0; 
array[150][7] = 0; 
array[151][7] = 0; 
array[155][7] = 0; 
array[158][7] = 0; 
array[162][7] = 0; 
array[163][7] = 0; 
array[165][7] = 0; 
array[174][7] = 0; 
array[176][7] = 0; 
array[178][7] = 0; 
array[179][7] = 0; 
array[181][7] = 0; 
array[196][7] = 0; 
array[198][7] = 0; 
array[200][7] = 0; 
array[201][7] = 0; 
array[205][7] = 0; 
array[206][7] = 0; 
array[210][7] = 0; 
array[211][7] = 0; 
array[212][7] = 0; 
array[213][7] = 0; 
array[215][7] = 0; 
array[223][7] = 0; 
array[224][7] = 0; 
array[225][7] = 0; 
array[226][7] = 0; 
array[228][7] = 0; 
array[232][7] = 0; 
array[236][7] = 0; 
array[239][7] = 0; 
array[240][7] = 0; 
array[241][7] = 0; 
array[253][7] = 0; 
array[254][7] = 0; 
array[264][7] = 0; 
array[265][7] = 0; 
array[270][7] = 0; 
array[275][7] = 0; 
array[286][7] = 0; 
array[290][7] = 0; 
array[294][7] = 0; 
array[301][7] = 0; 
array[302][7] = 0; 
array[303][7] = 0; 
array[307][7] = 0; 
array[308][7] = 0; 
array[309][7] = 0; 
array[312][7] = 0; 
array[320][7] = 0; 
array[324][7] = 0; 
array[325][7] = 0; 
array[327][7] = 0; 
array[330][7] = 0; 
array[332][7] = 0; 
array[335][7] = 0; 
array[336][7] = 0; 
array[338][7] = 0; 
array[339][7] = 0; 
array[345][7] = 0; 
array[347][7] = 0; 
array[350][7] = 0; 
array[351][7] = 0; 
array[352][7] = 0; 
array[375][7] = 0; 
array[376][7] = 0; 
array[384][7] = 0; 
array[389][7] = 0; 
array[394][7] = 0; 
array[400][7] = 0; 
array[401][7] = 0; 
array[402][7] = 0; 
array[403][7] = 0; 
array[405][7] = 0; 
array[408][7] = 0; 
array[409][7] = 0; 
array[411][7] = 0; 
array[414][7] = 0; 
array[416][7] = 0; 
array[420][7] = 0; 
array[422][7] = 0; 
array[427][7] = 0; 
array[429][7] = 0; 
array[430][7] = 0; 
array[431][7] = 0; 
array[438][7] = 0; 
array[439][7] = 0; 
array[441][7] = 0; 
array[446][7] = 0; 
array[447][7] = 0; 
array[450][7] = 0; 
array[451][7] = 0; 
array[457][7] = 0; 
array[461][7] = 0; 
array[463][7] = 0; 
array[465][7] = 0; 
array[472][7] = 0; 
array[474][7] = 0; 
array[476][7] = 0; 
array[485][7] = 0; 
array[493][7] = 0; 
array[496][7] = 0; 
array[501][7] = 0; 
array[502][7] = 0; 
array[504][7] = 0; 
array[508][7] = 0; 
array[509][7] = 0; 
array[518][7] = 0; 
array[519][7] = 0; 
array[522][7] = 0; 
array[526][7] = 0; 
array[529][7] = 0; 
array[531][7] = 0; 
array[533][7] = 0; 
array[536][7] = 0; 
array[539][7] = 0; 
array[542][7] = 0; 
array[547][7] = 0; 
array[549][7] = 0; 
array[550][7] = 0; 
array[554][7] = 0; 
array[556][7] = 0; 
array[571][7] = 0; 
array[573][7] = 0; 
array[577][7] = 0; 
array[579][7] = 0; 
array[583][7] = 0; 
array[584][7] = 0; 
array[589][7] = 0; 
array[590][7] = 0; 
array[591][7] = 0; 
array[600][7] = 0; 
array[606][7] = 0; 
array[607][7] = 0; 
array[608][7] = 0; 
array[609][7] = 0; 
array[611][7] = 0; 
array[615][7] = 0; 
array[624][7] = 0; 
array[636][7] = 0; 
array[637][7] = 0; 
array[639][7] = 0; 
array[642][7] = 0; 
array[643][7] = 0; 
array[645][7] = 0; 
array[649][7] = 0; 
array[650][7] = 0; 
array[654][7] = 0; 
array[656][7] = 0; 
array[657][7] = 0; 
array[664][7] = 0; 
array[665][7] = 0; 
array[667][7] = 0; 
array[675][7] = 0; 
array[676][7] = 0; 
array[681][7] = 0; 
array[686][7] = 0; 
array[689][7] = 0; 
array[693][7] = 0; 
array[695][7] = 0; 
array[698][7] = 0; 
array[706][7] = 0; 
array[707][7] = 0; 
array[708][7] = 0; 
array[715][7] = 0; 
array[718][7] = 0; 
array[723][7] = 0; 
array[724][7] = 0; 
array[738][7] = 0; 
array[746][7] = 0; 
array[747][7] = 0; 
array[750][7] = 0; 
array[756][7] = 0; 
array[759][7] = 0; 
array[760][7] = 0; 
array[761][7] = 0; 
array[763][7] = 0; 
array[764][7] = 0; 
array[765][7] = 0; 
array[767][7] = 0; 
array[768][7] = 0; 
array[776][7] = 0; 
array[778][7] = 0; 
array[786][7] = 0; 
array[789][7] = 0; 
array[790][7] = 0; 
array[795][7] = 0; 
array[798][7] = 0; 
array[804][7] = 0; 
array[806][7] = 0; 
array[809][7] = 0; 
array[810][7] = 0; 
array[813][7] = 0; 
array[816][7] = 0; 
array[818][7] = 0; 
array[819][7] = 0; 
array[822][7] = 0; 
array[823][7] = 0; 
array[824][7] = 0; 
array[827][7] = 0; 
array[830][7] = 0; 
array[832][7] = 0; 
array[835][7] = 0; 
array[836][7] = 0; 
array[838][7] = 0; 
array[839][7] = 0; 
array[846][7] = 0; 
array[853][7] = 0; 
array[854][7] = 0; 
array[856][7] = 0; 
array[861][7] = 0; 
array[862][7] = 0; 
array[869][7] = 0; 
array[870][7] = 0; 
array[872][7] = 0; 
array[873][7] = 0;
array[875][7] = 0;
array[877][7] = 0; 
array[890][7] = 0;
array[892][7] = 0; 
array[896][7] = 0; 
array[899][7] = 0; 
array[902][7] = 0; 
array[903][7] = 0; 
array[911][7] = 0; 
array[917][7] = 0; 
array[921][7] = 0; 
array[926][7] = 0; 
array[930][7] = 0; 
array[931][7] = 0; 
array[932][7] = 0; 
array[934][7] = 0; 
array[936][7] = 0; 
array[937][7] = 0; 
array[939][7] = 0; 
array[941][7] = 0; 
array[948][7] = 0; 
array[951][7] = 0; 
array[953][7] = 0; 
array[959][7] = 0; 
array[960][7] = 0; 
array[963][7] = 0; 
array[966][7] = 0; 
array[970][7] = 0; 
array[971][7] = 0; 
array[972][7] = 0; 
array[975][7] = 0; 
array[977][7] = 0; 
array[979][7] = 0; 
array[988][7] = 0; 
array[991][7] = 0; 
array[997][7] = 0; 
array[1000][7] = 0; 
array[1001][7] = 0; 
array[1002][7] = 0; 
array[1008][7] = 0; 
array[1011][7] = 0; 
array[1014][7] = 0; 
array[1016][7] = 0; 
array[1019][7] = 0; 
array[1023][7] = 0; 

/*
Load the eighth row with 20% zero's.
---------------------------------------
*/
array[10][8] = 0; 
array[25][8] = 0; 
array[27][8] = 0; 
array[29][8] = 0; 
array[30][8] = 0; 
array[35][8] = 0; 
array[37][8] = 0; 
array[39][8] = 0; 
array[40][8] = 0; 
array[45][8] = 0; 
array[46][8] = 0; 
array[53][8] = 0; 
array[67][8] = 0; 
array[75][8] = 0; 
array[93][8] = 0; 
array[96][8] = 0; 
array[101][8] = 0; 
array[102][8] = 0; 
array[106][8] = 0; 
array[107][8] = 0; 
array[111][8] = 0; 
array[124][8] = 0; 
array[127][8] = 0; 
array[131][8] = 0; 
array[139][8] = 0; 
array[165][8] = 0; 
array[169][8] = 0; 
array[178][8] = 0; 
array[182][8] = 0; 
array[186][8] = 0; 
array[190][8] = 0; 
array[192][8] = 0; 
array[207][8] = 0; 
array[208][8] = 0; 
array[213][8] = 0; 
array[221][8] = 0; 
array[225][8] = 0; 
array[226][8] = 0; 
array[230][8] = 0; 
array[233][8] = 0; 
array[234][8] = 0; 
array[236][8] = 0; 
array[237][8] = 0; 
array[240][8] = 0; 
array[249][8] = 0; 
array[252][8] = 0; 
array[255][8] = 0; 
array[260][8] = 0; 
array[262][8] = 0; 
array[271][8] = 0; 
array[272][8] = 0; 
array[273][8] = 0; 
array[279][8] = 0; 
array[289][8] = 0; 
array[291][8] = 0; 
array[315][8] = 0; 
array[321][8] = 0; 
array[324][8] = 0; 
array[332][8] = 0; 
array[333][8] = 0; 
array[340][8] = 0; 
array[354][8] = 0; 
array[359][8] = 0; 
array[364][8] = 0; 
array[366][8] = 0; 
array[368][8] = 0; 
array[369][8] = 0; 
array[373][8] = 0; 
array[392][8] = 0; 
array[394][8] = 0; 
array[407][8] = 0; 
array[414][8] = 0; 
array[415][8] = 0; 
array[416][8] = 0; 
array[425][8] = 0; 
array[439][8] = 0; 
array[447][8] = 0; 
array[458][8] = 0; 
array[460][8] = 0; 
array[461][8] = 0; 
array[467][8] = 0; 
array[479][8] = 0; 
array[488][8] = 0; 
array[489][8] = 0; 
array[491][8] = 0; 
array[492][8] = 0; 
array[493][8] = 0; 
array[499][8] = 0; 
array[500][8] = 0; 
array[510][8] = 0; 
array[515][8] = 0; 
array[517][8] = 0; 
array[518][8] = 0; 
array[520][8] = 0; 
array[522][8] = 0; 
array[525][8] = 0; 
array[529][8] = 0; 
array[530][8] = 0; 
array[532][8] = 0; 
array[533][8] = 0; 
array[538][8] = 0; 
array[539][8] = 0; 
array[550][8] = 0; 
array[551][8] = 0; 
array[556][8] = 0; 
array[558][8] = 0; 
array[559][8] = 0; 
array[560][8] = 0; 
array[561][8] = 0; 
array[562][8] = 0; 
array[565][8] = 0; 
array[566][8] = 0; 
array[567][8] = 0; 
array[575][8] = 0; 
array[576][8] = 0; 
array[580][8] = 0; 
array[584][8] = 0; 
array[586][8] = 0; 
array[592][8] = 0; 
array[599][8] = 0; 
array[601][8] = 0; 
array[609][8] = 0; 
array[620][8] = 0; 
array[626][8] = 0; 
array[629][8] = 0; 
array[632][8] = 0; 
array[635][8] = 0; 
array[638][8] = 0; 
array[640][8] = 0; 
array[643][8] = 0; 
array[650][8] = 0; 
array[658][8] = 0; 
array[659][8] = 0; 
array[661][8] = 0; 
array[663][8] = 0; 
array[676][8] = 0; 
array[677][8] = 0; 
array[686][8] = 0; 
array[689][8] = 0; 
array[707][8] = 0; 
array[709][8] = 0; 
array[710][8] = 0; 
array[712][8] = 0; 
array[725][8] = 0; 
array[726][8] = 0; 
array[730][8] = 0; 
array[733][8] = 0; 
array[737][8] = 0; 
array[741][8] = 0; 
array[745][8] = 0; 
array[746][8] = 0; 
array[759][8] = 0; 
array[768][8] = 0; 
array[771][8] = 0; 
array[776][8] = 0; 
array[777][8] = 0; 
array[778][8] = 0; 
array[792][8] = 0; 
array[800][8] = 0; 
array[807][8] = 0; 
array[817][8] = 0; 
array[822][8] = 0; 
array[829][8] = 0; 
array[833][8] = 0; 
array[834][8] = 0; 
array[836][8] = 0; 
array[837][8] = 0; 
array[838][8] = 0; 
array[852][8] = 0; 
array[854][8] = 0; 
array[858][8] = 0; 
array[862][8] = 0; 
array[868][8] = 0; 
array[870][8] = 0; 
array[898][8] = 0; 
array[899][8] = 0; 
array[917][8] = 0; 
array[922][8] = 0; 
array[923][8] = 0; 
array[937][8] = 0; 
array[942][8] = 0; 
array[943][8] = 0; 
array[945][8] = 0; 
array[946][8] = 0; 
array[947][8] = 0; 
array[958][8] = 0; 
array[960][8] = 0; 
array[964][8] = 0; 
array[965][8] = 0; 
array[966][8] = 0; 
array[968][8] = 0; 
array[976][8] = 0; 
array[981][8] = 0; 
array[987][8] = 0; 
array[988][8] = 0; 
array[995][8] = 0; 
array[998][8] = 0; 
array[1002][8] = 0; 
array[1004][8] = 0; 
array[1005][8] = 0; 
array[1008][8] = 0; 
array[1012][8] = 0; 
array[1019][8] = 0; 
array[1022][8] = 0; 
array[1024][8] = 0; 

/*
Load the ninth row with 10% zero's.
--------------------------------------
*/
array[2][9] = 0; 
array[38][9] = 0; 
array[46][9] = 0; 
array[47][9] = 0; 
array[70][9] = 0; 
array[71][9] = 0; 
array[84][9] = 0; 
array[95][9] = 0; 
array[99][9] = 0; 
array[106][9] = 0; 
array[108][9] = 0; 
array[112][9] = 0; 
array[115][9] = 0; 
array[157][9] = 0; 
array[160][9] = 0; 
array[167][9] = 0; 
array[175][9] = 0; 
array[187][9] = 0; 
array[191][9] = 0; 
array[203][9] = 0; 
array[210][9] = 0; 
array[246][9] = 0; 
array[257][9] = 0; 
array[270][9] = 0; 
array[273][9] = 0; 
array[287][9] = 0; 
array[312][9] = 0; 
array[320][9] = 0; 
array[363][9] = 0; 
array[367][9] = 0; 
array[377][9] = 0; 
array[382][9] = 0; 
array[396][9] = 0; 
array[399][9] = 0; 
array[447][9] = 0; 
array[456][9] = 0; 
array[459][9] = 0; 
array[463][9] = 0; 
array[479][9] = 0; 
array[487][9] = 0; 
array[505][9] = 0; 
array[524][9] = 0; 
array[532][9] = 0; 
array[541][9] = 0; 
array[559][9] = 0; 
array[560][9] = 0; 
array[587][9] = 0; 
array[619][9] = 0; 
array[620][9] = 0; 
array[633][9] = 0; 
array[636][9] = 0; 
array[642][9] = 0; 
array[643][9] = 0; 
array[655][9] = 0; 
array[667][9] = 0; 
array[668][9] = 0; 
array[675][9] = 0; 
array[682][9] = 0; 
array[689][9] = 0; 
array[696][9] = 0; 
array[705][9] = 0; 
array[733][9] = 0; 
array[740][9] = 0; 
array[743][9] = 0; 
array[745][9] = 0; 
array[753][9] = 0; 
array[767][9] = 0; 
array[772][9] = 0; 
array[786][9] = 0; 
array[798][9] = 0; 
array[804][9] = 0; 
array[812][9] = 0; 
array[823][9] = 0; 
array[824][9] = 0; 
array[837][9] = 0; 
array[839][9] = 0; 
array[858][9] = 0; 
array[863][9] = 0; 
array[869][9] = 0; 
array[883][9] = 0; 
array[886][9] = 0; 
array[887][9] = 0; 
array[890][9] = 0; 
array[892][9] = 0; 
array[907][9] = 0; 
array[937][9] = 0; 
array[945][9] = 0; 
array[964][9] = 0; 
array[966][9] = 0; 
array[967][9] = 0; 
array[971][9] = 0; 
array[974][9] = 0; 
array[982][9] = 0; 
array[986][9] = 0; 
array[990][9] = 0; 
array[991][9] = 0; 
array[1000][9] = 0; 
array[1001][9] = 0; 
array[1009][9] = 0; 
array[1014][9] = 0; 
array[1019][9] = 0; 
array[1020][9] = 0; 
}

