#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block            */
    char taein1[][CMLEN],	/* pointer to input TAE file descriptor      */
    char hosin1[][CMLEN],	/* pointer to input host file descriptor     */
    long *nmrimg1,		/* number of input images                    */
    long (*window1)[4],		/* window specifications for each input image*/
    long (*bands1)[MAXBND+1],	/* band specifications for each input image  */
    long nbands1[],		/* number of bands per input image	     */
    long *totbnd1,		/* total number of bands to be processed     */
    char taein2[][CMLEN],	/* pointer to input TAE file descriptor      */
    char hosin2[][CMLEN],	/* pointer to input host file descriptor     */
    long *nmrimg2,		/* number of input images                    */
    long (*window2)[4],		/* window specifications for each input image*/
    long (*bands2)[MAXBND+1],	/* band specifications for each input image  */
    long nbands2[],		/* number of bands per input image	     */
    long *totbnd2,		/* total number of bands to be processed     */
    long *msgtim,		/* elapsed time between display messages     */
    long *term,			/* flag for output to terminal 		     */
    long *fyle,			/* flag for output to file		     */
    long *lnpr,			/* flag for output to line printer	     */
    char *filnm,			/* output filename for FILE option           */
    char *outfil, 		/* pointer to output host file name          */
    char *typ,			/* type of comparison			     */
    float *tolval,		/* tolarence value			     */
    char *listopt		/* type of listing to produce		     */
);

void proces
(
    struct PARBLK *vblock,	/* TAE parameter block			     */
    char taein1[][CMLEN],       /* TAE file name                             */
    char hosin1[][CMLEN],	/* pointer to input host file descriptor     */
    long nmrimg1,		/* number of input images                    */
    long (*window1)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands1,		/* number of bands per input image           */
    long totbnd1,		/* total number of bands to be processed     */
    char taein2[][CMLEN],        /* TAE file name                             */
    char hosin2[][CMLEN],	/* pointer to input host file descriptor     */
    long nmrimg2,		/* number of input images                    */
    long (*window2)[4],		/* window specification of input images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands2,		/* number of bands per input image           */
    long msgtim,			/* elapsed time between display messages     */
    long term,			/* flag for output to terminal               */
    long fyle,			/* flag for output to file                   */
    long lnpr,			/* flag for output to line printer           */
    char filnm[][CMLEN],     /* output filename for FILE option           */
    long *nfiles,  		/* number of output files		     */
    char *typ,			/* type of differencing   		     */
    double tolval,                /* tolerance value                           */
    char *listopt		/* type of listing to produce		     */
);

#endif
