#ifndef PROTOS_H
#define PROTOS_H

void calc
(
    long *numsets,	/* no. feature sets		*/
    long nclass,		/* no. classes			*/
    double *covar[],	/* covariance matrices		*/
    float *mean[],	/* mean vectors			*/
    float *divg,		/* divergences			*/
    char dvgtype[]	/* type of divergence		*/
);

void compute
(
    long nband,		/* no. bands			*/
    long nc,		/* no. classes processed	*/
    int feat,
    char clname[][STNAME], /* class names		*/
    double *covar[],	/* covariance matrices		*/
    float *mean[],	/* mean vectors			*/
    char div_type[],	/* type of divergence		*/
    long print[]	/* print option			*/
);

void g_errmsg
(
    char message[],    /* error message                         */
    char key[]        /* message key                           */
);

void getpar
(
    char hos_stat[],          /* stats file host name             */
    long *num_classes,        /* number of classes to be used     */
    long print[],	     /* print option                     */
    char print_file[CMLEN],   /* print file name                  */
    long *feat,		     /* number of features		 */
    char dvgtype[]
);

void output
(
    char clname[][STNAME], /* class names		*/
    float *div,		/* divergence			*/
    char div_type[],	/* type of divergence		*/
    long nc,		/* no. classes			*/
    long fset[],		/* bands in feature set		*/
    long set,		/* set no.			*/
    long numsets,	/* no. feature sets		*/
    long print[]	/* print option			*/
);

void stats
(
    char hosnm[],	/* stats file host name			*/
    long feat,		/* no. features requested		*/
    long *nc,		/* no. classes processed		*/
    long *num_bands,	/* no. bands 				*/
    double *covar[],	/* covariance matrices			*/
    float *mean[],	/* mean vectors				*/
    char clname[][STNAME] /* class names			*/
);

#endif
