#ifndef DOQ2LAS_H
#define DOQ2LAS_H


/* getpar.c */
int getpar
(
  struct PARBLK *parblk,         /* I: TAE parameter block */
  char *doqname,                 /* O: Input DOQ file name */
  char *out,                     /* O: Output host image name */
  char *tname,                   /* O: Output TAE image name */
  char *datum,                   /* O: Datum type ("NAD27" or "NAD83") */
  char *proj,                    /* O: Projection type */
  long *msgtim                   /* O: Delay time between display messages */
);

/* inbil.c */
void inbil
(
  struct PARBLK *vblock,         /* I: TAE parameter block */
  char *hosout,                  /* I: Host name of output image */
  long nl,                       /* I: Number of lines */
  long ns,                       /* I: Number of samples */
  long nbands,                   /* I: Number of bands */
  long nheader,                  /* I: Number of header bytes */
  char ioname[][CMLEN],          /* I: Array of input image names */
  long odtype,                   /* I: Output data type */
  long msgtim,                   /* I: Message delay time */
  char *minmax,                  /* O: Min/Max flag */
  long dflag                     /* I: DDR flag option */
);

/* stripdoqbip.c */
void stripdoqbip
(
  char *infile,                  /* I: Input DOQ file */
  char *outfile,                 /* I: Output LAS image file */
  long *ns,                      /* I: Number of samples */
  long *nl,                      /* I: Number of lines */
  long *nb,                      /* I: Number of bands */
  long *hb                       /* I: Header bytes */
);

#endif
