#ifndef PROTOS_H
#define PROTOS_H

int dspanc
(
    char *hname,			/* filename				*/
    long *acdsk,			/* ancillary flag			*/
    FILE *fptr			/* file pointer				*/
);

int dspedips
(
    char *hname,			/* filename				*/
    long *hdsk,			/* header flag				*/
    long *tdsk,			/* trailer flag				*/
    long *andsk,			/* annotation flag			*/
    FILE *fptr			/* file pointer				*/
);

int dspjsc
(
    char *hname,			/* filename				*/
    char *prtfile,			/* print file name			*/
    long *uhdsk,			/* universal header flag		*/
    long *lhdsk,			/* landsat header flag			*/
    long *acdsk,			/* ancillary file flag			*/
    long *nl			/* line number of ancillary file	*/
);

int dsplead
(
    char *hname,			/* filename				*/
    FILE *fptr			/* output file pointer			*/
);

int dspltwg
(
    char *hname,			/* filename				*/
    FILE *fptr,			/* output file pointer			*/
    long *vdf_flag,		/* Volume directory flag		*/
    long *lead_flag,		/* Leader file flag			*/
    long *trai_flag,		/* Trailer file flag			*/
    long *supp_flag,		/* Supplemental file flag		*/
    long *idr_flag,		/* Image data record flag		*/
    long *line_num		/* line number for image data to be printed*/
);

int dspsiat
(
    char *name,            	/* TAE name of input image              */
    char *prtfile          	/* print file name                      */
);

int dspsupp
(
    char *hname,			/* filename				*/
    FILE *fptr			/* output file pointer			*/
);

int dspsupp1
(
    FILE *fptr,			/* output file pointer			*/
    FILE *fin,			/* input file pointer			*/
    long *num_house,		/* number of TM housekeeping records    */
    long *lth_house,
    long *num_eph,
    long *lth_eph
);

int dsptips
(
    char *hname,            /* TAE name of input image                    	*/
    char *prtfile,          /* print file name                            	*/
    long *hdsk,		/* header file flag			 	*/
    long *tdsk,		/* trailer file flag			 	*/
    long *andsk		/* annotation file flag			 	*/
);

int dsthdr
(
    char *hname,		/* TAE name of input image	     */
    char *prtfile		/* print file name                   */
);

void getpar
(
    char *hname,		/* TAE name of input image		      	*/
    char *prtfile,		/* print file name                            	*/
    long *hdsk,		/* header flag					*/
    long *tdsk,		/* trailer flag					*/
    long *andsk,		/* annotation flag				*/
    long *acdsk,		/* ancillary flag				*/
    long *uhdsk,		/* universal header flag			*/
    long *lhdsk,		/* LANDSAT header flag				*/
    long *vdsk,		/* volume directory file flag			*/
    long *ldsk,		/* leader file flag				*/
    long *sdsk,		/* supplemental file flag			*/
    long *idsk,		/* image data records flag			*/
    char *filename,		/* print file name				*/
    char *option,		/* used to determine which subcommand was used	*/
    long *nl,		/* line number of ancillary file of		*/
    long *print		/* output destination                         	*/
);

#endif

