/******************************************************************************
NAME:   REM_BLANKS

PURPOSE:
        REM_BLANKS returns the input character with all white space removed.
        This includes leading, trailing and internal white sapce.

PROGRAM HISTORY:
        By L. Huewe, USGS/EROS Data Center, 8/90

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
                Run under TAE

PROJECT:        LAS

ALGORITHM:
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "ctype.h"
#include "protos.h"

char *rem_blanks
(
    char *str,
    long *len
)
{
long fatal = -1;
register char *newstr, *ptr, *newptr;

newstr = (char *)malloc(*len+1);
if (newstr == NULL)
    c_errmsg("Error allocating dynamic memory","dspddr-alloc",&fatal);
/*
   Copy all non-blank characters from the input string to the output string.
*/
for (newptr = newstr, ptr = str; ((ptr < str + *len) && (*ptr != '\0')); ptr++)
    {
    if (isspace( (int) *ptr) == 0)
        {
        *newptr = *ptr;
        newptr++;
        }
    }
*(newptr) = '\0';
return(newstr);
}

