/******************************************************************************
PROGRAM:                   PRINTPARMS

PURPOSE:        Prints a title based on the subcommand chosen, the active
                record list name and/or the image name. 

*******************************************************************************/

#include <string.h>
#include "las.h"
#include "gof.h"
#include "protos.h"

int printparms
(
    char *image,      /* Name of the displayed image (if known) (I) */
    FILE *lfp         /* Pointer to output file (I) */
)
{
    long num;              /* Number of characters preceding the ";" */
    char noext[CMLEN];     /* Temporary variable to contain the input
                              image name with no extension */


    strcpy (noext,image);
    num = (long) strcspn(noext,";");
    if (num != strlen(noext))
        noext[num] = '\0';
    if (strlen(image) < 46)
        fprintf(lfp,"\nListing of the GOF %s.\n",noext);
    else
    {
        fprintf(lfp,"\nListing of the GOF %50s\n",noext);
        fprintf(lfp,"%s.\n",&noext[50]);
    }
    return(E_SUCC);
}
