/****************************************************************************
NAME:				in_list

PURPOSE:  Checks point id to see if it is in the list

ALGORITHM DESCRIPTION:
	Check the static point id array to see if the current id is there
	If there, return TRUE
	Otherwise, Return FALSE
*****************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include "geompak.h"
#include "protos.h"

#define TRUE 1
#define FALSE 0

static char list[10][20];	/* List of tie points to report */
static int count = 0;		/* Point id count */

int in_list
(
    char *id			/* Tie point identifier */
)
{
long i;				/* Loop counter */

for (i = 0; i < count; i++)
   if (strcmp(&(list[i][0]), id) == 0) return(TRUE);
return(FALSE);
}
/****************************************************************************
NAME:				add_to_list

PURPOSE:  Adds a tie point to the list

ALGORITHM DESCRIPTION:
	Put the current point id in the point id array
	Increment the counter
	Return 
*****************************************************************************/
void add_to_list
(
    char *pt_id			/* Tie point identifier */
)
{
strcpy(&(list[count][0]), pt_id);
count++;
return;
}
