/****************************************************************************
NAME:				list_map

PURPOSE:  Stores map ids in array--no duplicates are stored

ALGORITHM DESCRIPTION:
	Check the static map id array to see if the current id is there
	If there, return 
	Put the current map id in the map id array
	Increment the counter
	Return 
*****************************************************************************/
#include <stdio.h>
#include "worgen.h"
#include "geompak.h"
#include "protos.h"

#define MAX_MAP_ID 1024		/* Maxinum number of map ids*/

static char id[MAX_MAP_ID][20];	/* All map id's entered so far */
static int count = 0;		/* Point id count */

void list_map
(
    char *map			/* Map identifier */
)
{
long i;				/* Loop counter */
long fatal = -1;
long one = 1;

for (i = 0; i < count; i++)
   if (strcmp(&(id[i][0]), map) == 0) return;
strcpy(&(id[count][0]), map);
count++;
if (count > MAX_MAP_ID)
   {
   c_errmsg("Error: Too many map id's","dsptie-mapid",&one);
   c_errmsg("Fatal error encountered","dsptie-fatal",&fatal);
   }
return;
}

/****************************************************************************
NAME:				get_map

PURPOSE:  Gets a mapid out of the static storage array & returns it

ALGORITHM DESCRIPTION:
	If there are no more mapid's in the file, return an empty string
	Else, put the current map id in the map id array
	Increment the counter
	Return 
*****************************************************************************/

void get_map
(
    char *mapid			/* Map identifier (output) */
)
{
static long i = 0;		/* Map id number returned */

if (i > count) strcpy(mapid,"");
else
   {
   strcpy(mapid, &(id[i][0]));
   i++;
   }
return;
}
