#ifndef PROTOS_H
#define PROTOS_H

int getpar
(
    struct PARBLK *vblock,       /* pointer to TAE parameter block            */
    char taein[][CMLEN],         /* TAE file names of input images            */
    char hosin[][CMLEN],         /* host file names of input images           */
    char taeout[][CMLEN],        /* TAE file name of output image             */
    char hosout[][CMLEN],        /* host file name of output image            */
    long *nmrimg,                /* number of input images                    */
    long (*window)[4],           /* window specifications for each input image*/
    long (*bands)[MAXBND+1],     /* band specifications for each input image  */
    long *nbands,                /* number of bands per input image           */
    long *totbnd,                /* total number of bands to be processed     */
    long *odtype,                /* output data type                          */
    long *msgtim,                /* elapsed time between display messages     */
    long *threshold,             /* Upper edge limit                          */
    float *efract,               /* Fraction of pixels classified as edges    */
    long *pixval 		/* Edge pixel value                          */
);

int proces
(
    struct PARBLK *vblock,	/* TAE parameter block			     */
    char hosin[][CMLEN],	/* host names of input images		     */
    char hosout[][CMLEN],	/* host name of output image		     */
    long nmrimg,		/* number of input images                    */
    long (*window)[4],		/* window specification of input images      */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long totbnd,		/* total number of bands to be processed     */
    long odtype,		/* data type of output image                 */
    long threshold,		/* Upper edge limit			     */
    double efract,               /* fraction of pixels classifed as edges     */
    long pixval,		/* Edge pixel value			     */
    long msgtim		/* elapsed time between display messages     */
);

#endif
