#ifndef PROTOS_H
#define PROTOS_H

int updateddr_
(
    char *hname,		/* Host file name			*/
    long window[],		/* Input window				*/
    long *totbnd,		/* Total number of bands to process	*/
    long *linc,		/* Line increment factor		*/
    long *sinc,		/* Sample increment factor		*/
    char *stype,		/* sensor type (MSS or RBV)		*/
    char *direction,	/* Direction of satellite "D" or "A"	*/
    long *path,		/* WRS path				*/
    long *row,		/* WRS row				*/
    double wrsll[],		/* WRS center latitude/longitude	*/
    double wrsls[],		/* WRS center line/sample		*/
    double *angle,		/* Image orientation angle		*/
    char *edate,		/* Date of exposure			*/
    char *projec,		/* Projection type			*/
    char *scene,		/* Scene id (contains time of exposure) */
    long *ddrvflag,		/* DDR validity flag			*/
    long *corect,		/* MSS corrected data flag		*/
    long hname_len,		/* Length of the Host file name		*/
    long stype_len,		/* Length of the Host file name		*/
    long direc_len,		/* Length of the Host file name		*/
    long edate_len,		/* Length of the Host file name		*/
    long proj_len,		/* Length of the Host file name		*/
    long scene_len		/* Length of the Host file name		*/
);

#ifdef _IBMR2
int updateddr
(
    char *hname,		/* Host file name			*/
    long window[],		/* Input window				*/
    long *totbnd,		/* Total number of bands to process	*/
    long *linc,		/* Line increment factor		*/
    long *sinc,		/* Sample increment factor		*/
    char *stype,		/* sensor type (MSS or RBV)		*/
    char *direction,	/* Direction of satellite "D" or "A"	*/
    long *path,		/* WRS path				*/
    long *row,		/* WRS row				*/
    double wrsll[],		/* WRS center latitude/longitude	*/
    double wrsls[],		/* WRS center line/sample		*/
    double *angle,		/* Image orientation angle		*/
    char *edate,		/* Date of exposure			*/
    char *projec,		/* Projection type			*/
    char *scene,		/* Scene id (contains time of exposure) */
    long *ddrvflag,		/* DDR validity flag			*/
    long *corect,		/* MSS corrected data flag		*/
    long hname_len,		/* Length of the Host file name		*/
    long stype_len,		/* Length of the Host file name		*/
    long direc_len,		/* Length of the Host file name		*/
    long edate_len,		/* Length of the Host file name		*/
    long proj_len,		/* Length of the Host file name		*/
    long scene_len		/* Length of the Host file name		*/
);
#endif

#ifdef vms
int updateddr
(
    struct DESC *hname,	/* Host file name			*/
    long window[],		/* Input window				*/
    long *totbnd,		/* Total number of bands to process	*/
    long *linc,		/* Line increment factor		*/
    long *sinc,		/* Sample increment factor		*/
    struct DESC *stype,	/* sensor type (MSS or RBV)		*/
    struct DESC *direction,	/* Direction of satellite "D" or "A"	*/
    long *path,		/* WRS path				*/
    long *row,		/* WRS row				*/
    double wrsll[],		/* WRS center latitude/longitude	*/
    double wrsls[],		/* WRS center line/sample		*/
    double *angle,		/* Image orientation angle		*/
    struct DESC *edate,	/* Date of exposure			*/
    struct DESC *projec,	/* Projection type			*/
    struct DESC *scene,	/* Scene id (contains time of exposure) */
    long *ddrvflag,		/* DDR validity flag			*/
    long *corect		/* MSS corrected data flag		*/
);
#endif

#ifdef unix
int wrscll_
(
    char *nomll,
    double *wrsll,
    long nomll_len
);
#endif

#ifdef vms
int wrscll_
(
    struct DESC *nomll,
    double *wrsll
);
#endif

short decode_
(
    unsigned char *first,
    unsigned char *second
);

short decode
(
    unsigned char *first,
    unsigned char *second
);

void tcomp_
(
    long *num,      /*value*/
    long *dtype 	/*data type */
);

void tcomp
(
    long *num,     /*value*/
    long *dtype   /*data type*/
);

int update_ddr
(
    char *hname,		/* Host file name			*/
    long window[],		/* Input window				*/
    long *totbnd,		/* Total number of bands to process	*/
    long *linc,		/* Line increment factor		*/
    long *sinc,		/* Sample increment factor		*/
    char *stype,		/* sensor type (MSS or RBV)		*/
    char *direction,	/* Direction of satellite "D" or "A"	*/
    long *path,		/* WRS path				*/
    long *row,		/* WRS row				*/
    double wrsll[],		/* WRS center latitude/longitude	*/
    double wrsls[],		/* WRS center line/sample		*/
    char *edate,		/* Date of exposure			*/
    char *projec,		/* Projection type			*/
    char *scene,		/* Scene id (contains time of exposure) */
    long *ddrvflag		/* DDR validity flag			*/
);

int wrscll
(
    char *nomll,
    double *wrsll
);

#endif
