/* Tcomp takes the two's complement of a negative value.
   It was written for use with the PowerNode version of EDIPSIN. */

#include <stdio.h>
#include "las.h"
#include "protos.h"

#define EDUBBLE 8

/*UNIX FORTRAN bridge routine */
void tcomp_
(
    long *num,      /*value*/
    long *dtype 	/*data type */
)

{
        tcomp(num,dtype);
}

void tcomp
(
    long *num,     /*value*/
    long *dtype   /*data type*/
)
{
	long *tmp;      

 	if (*num & 0x80000000)          /*check if negative value*/
	    {
	    *num = (~*num + 1);        /*two's complement*/
            *num = *num | 0x80000000; /*preserve high bit*/
            if (*dtype == EDUBBLE)     
		{	  	     /* for real*8 */
		tmp = num + 1;      
		*tmp = (~*tmp + 1);
		}
            }
} /*tcomp*/
