
C     ******************************************************************
C     PURPOSE:  BTCPY copies bytes of an integer into a character buffer
C
C     ARGUMENTS:
C     Name             Description
C     ----	       -----------
C     int	       the integer value
C     chr	       the starting address of the character buffer
C     length 	       length or number of bytes
C
C     INTERNAL VARIABLES:
C     Name	       Description
C     ----	       -----------
C     locali           the integer value
C     index	       loop index
C
C	Algorithm:  BTCPY converts an integer to a character.
C
C     ******************************************************************
      subroutine btcpy( int, chr, length )

      integer*4	int,length
      character*1 chr(length)

      integer locali,index

      locali = int
      do 100 index=length,1,-1
	 if( locali .gt. 0 ) then
	    if( locali .lt. 256 ) then
	       chr(index) = char(locali)
	    else
	       chr(index) = char( mod(locali,256) )
	    end if
	    locali = locali / 256
	 else
	    chr(index) = char(0)
	 end if
  100 continue

      return
      end
