
C     ******************************************************************
C     PURPOSE: FCLEAN is used to clean up after a fatal error is 
C   	       encountered during processing. 
C
C     ARGUMENTS:
C     Name	       Description
C     ----	       -----------
C     unit             logical unit number of the tape drive
C
C     INTERNAL VARIABLES:
C     Name             Description
C     ----	       -----------
C     status           function return status code
C     tpclos	       tapeio function to close a tape device
C
C     ALGORITHM:  
C                Close the tape 
C                Send fatal error message to standard output
C                Terminate processing
C                   
C		    
C     ******************************************************************
      subroutine fclean(unit)

	include 'tapeio.fin'

      integer*4 
     .  	     status,
     .		     tpclos,
     .		     unit

C     Close the tape device
C     ---------------------
      status = tpclos(unit,HANDLE,TRWOFL,3)
      
C     Print a fatal error message and terminate processing
C     ----------------------------------------------------
      call errmsg
     +   ('Fatal error encountered--Output tape is not valid',
     +    'edipsout-fatal',-1)
  
      return
      end
