/****************************************************************************
NAME:				ABORT

PURPOSE:  Handles all fatal error conditions & exits gracefully

VERSION		DATE	AUTHOR
-------		----	------	
  1.0		9/92	D. Steinwand

****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "geompak.h"
#include "protos.h"

#define DIFFNPTS	201
#define NOTSAME		202

void l_abort
(
    long status			/* Error condition flag 		*/
)
{
long pass = 1;			/* Do not abort processing 		*/
long fatal = -1;		/* Abort processing 			*/

switch(status)
   {
   case NO_SPACE:
	c_errmsg("Unable to allocate dynamic memory","editcorr-alloc",&pass);
	break;
   case NOTSAME:
	c_errmsg("TPL files are not similar","editcorr-notsame",&pass);
        break;
   case DIFFNPTS:
	c_errmsg("Unequal number of points in TPL files","editcorr-npts",&pass);
        break;
   }
c_errmsg("Fatal error encountered","editcorr-fatal",&fatal);
}
