#ifndef PROTOS_H
#define PROTOS_H

void l_abort
(
    long status			/* Error condition flag 		*/
);

int backmatch
(
    struct TPLDATA *tie_data1,	/* Tie Point Location data records 	*/
    struct TPLDATA *tie_data2,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    double tolval			/* Tolerance value 			*/
);

int compare_tpl
(
    struct TPLDATA *tie_data1,	/* Tie Point Location data records 	*/
    struct TPLDATA *tie_data2,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    double tolval			/* Tolerance value 			*/
);

int distance
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    double tolval			/* Sigma value--for corr peak edits 	*/
);

int get_tie_points
(
    char *name,			/* Name of the Tie Point Location file */
    struct TPLHEAD *header,		/* Tie Point Location header record */
    struct TPLDATA **data,		/* Tie Point Location data records */
    long *npts			/* Number of tie point data records read */
);

int getpar
(
    struct PARBLK *vblk,	/* TAE variable block 				*/
    long *subcmd,		/* Subcommand used 				*/
    char *t1,		/* Input tie point location file name 		*/
    char *t2,		/* Input tie point location file name (2nd) 	*/
    char *out_tpl,		/* Output tie point location file name 		*/
    long *degree,		/* Degree of polynomial 			*/
    float *maxres,		/* Maximum allowable residual 			*/
    float *sigval,		/* Sigma value--for corr peak edits 		*/
    float *tolval,		/* Tolerance value--for comp. & backmatching 	*/
    long *pltflg,		/* plot flag					*/
    char *plotfile,		/* plot filename				*/
    long *actflag          /* active flag                                  */
);

int maximum
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    long degree,			/* Degree of polynomial to use 		*/
    double maxres,			/* Maximum allowable residual 		*/
    long plot,			/* plot flag				*/
    char *plotfile			/* plot filename			*/
);

int maxfit
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	  */
    long npts,			/* Number of points in TPL file 	  */
    long npts_used,			/* Current number of points used 	  */
    long degree,			/* Degree of polynomial used 		  */
    double *residual,		/* Residual error                         */
    long plot,			/* Flag--write plot file? 		  */
    char *plotfile			/* plot filename			  */
);

int median
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    long degree,			/* Degree of polynomial to use 		*/
    double maxres,			/* Maximum allowable residual 		*/
    long plot,			/* plot flag				*/
    char *plotfile			/* plot filename			*/
);

int medfit
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	  */
    long npts,			/* Number of points in TPL file 	  */
    long npts_used,			/* Current number of points used 	  */
    long degree,			/* Degree of polynomial used 		  */
    double *med,			/* Median error                           */
    double *maxres,			/* Maximum residual error                 */
    long plot,			/* Flag--write plot file? 		  */
    char *plotfile			/* plot filename			  */
);

double find_median
(
    double *residual,
    long npts
);

int model
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    long degree,			/* Degree of polynomial to use 		*/
    double maxres,			/* Maximum allowable residual 		*/
    long plot,			/* plot flag				*/
    char *plotfile,			/* plot filename			*/
    long actflag                   /* active flag                          */
);

int modfit
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    long npts_used,			/* Current number of points used 	*/
    long degree,			/* Degree of polynomial used 		*/
    double *rmse,			/* Root Mean Squared Error 		*/
    long plot,			/* Flag--write plot file? 		*/
    char *plotfile,			/* plot filename			*/
    long actflag                      /* active flag                          */
);

int peaks
(
    struct TPLDATA *tie_data,	/* Tie Point Location data records 	*/
    long npts,			/* Number of points in TPL file 	*/
    double sigval			/* Sigma value--for corr peak edits 	*/
);

int put_tie_points
(
    char *name,			/* Name of the Tie Point Location file 	*/
    struct TPLHEAD *header,		/* Tie Point Location header record 	*/
    struct TPLDATA *data,		/* Tie Point Location data records 	*/
    long npts			/* Number of tie point data records read*/
);

#endif
