/****************************************************************************
NAME:				PUT_TIE_POINTS

PURPOSE:  Writes edited tie points to a new disk file

VERSION		DATE	AUTHOR
-------		----	------	
  1.0		9/92	D. Steinwand

****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "geompak.h"
#include "protos.h"

int put_tie_points
(
    char *name,			/* Name of the Tie Point Location file 	*/
    struct TPLHEAD *header,		/* Tie Point Location header record 	*/
    struct TPLDATA *data,		/* Tie Point Location data records 	*/
    long npts			/* Number of tie point data records read*/
)
{
struct PTDESC *desc;/* File descriptor for tie pt file 	*/
long ptyp;			/* Type of tie point data/header record */
long acc;			/* File access flag 			*/
long count;			/* Loop counter 			*/

/* Open the tie point location file 
  --------------------------------*/
ptyp = TPL; acc = IWRITE;
if (c_ptopen(&desc, name, &ptyp, &acc, header) != E_SUCC) return(E_FAIL);

/* Write out the tie point location data records
  -------------------------------------------*/
for (count = 0; count < npts; count++)
   if (c_ptio(&desc, &(data[count])) != E_SUCC) return(E_FAIL);

/* Close the Tie Point Location file
  ---------------------------------*/
if (c_ptclse(&desc) != E_SUCC) return(E_FAIL);
return(E_SUCC);
}
