/******************************************************************************
NAME: WRITEDDR

PURPOSE: To write out the DDR information to a file 

PROGRAM HISTORY:
Version Date       Author       Request
------- ----       ------       -------
1.0     10/87      B.Ailts      Initial development
1.1     07/88      B.Ailts      LAS 5.0 standards

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
     Run under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION: 
  The band indepenent ddr information is 
  written to the ddr file (records 1 + 2)
  The band depenent ddr information is written to the ddr file(record 3+).
******************************************************************************/
#include "las.h"
#include "editddr.h"

int writeddr
(
  char *hostddr,                   /* I: Host ddr file name */
  struct DDR *ddr,                 /* I: Integer portion of ddr */
  struct BDDR *bddr                /* I: BDDR for each band */
)
{
  long i;                          /* Counter--current band */
  long status;                     /* Status of write functions */

  /* Write the band indepenant fields
  -----------------------------------*/
  status = c_putddr(hostddr,ddr);
  if (status != E_SUCC)
    return(status);

  /* Write the band dependant fields for each band
  ------------------------------------------------*/
  for (i = 0; i < ddr->nbands; i++)
  {
   status = c_putbdr(hostddr,&bddr[i]);
   if (status != E_SUCC)
     return(status);
  }

  return(E_SUCC);
}
