/******************************************************************************

NAME:	DISQUIT

FUNCTION: DISQUIT is used to display the follow up question when quitting.

PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    1.0         05/89      D.Etrheim    initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

ALGORITHM REFERENCES:
The follow up question is displayed
The the answer is retrieved
If 'no'
   Control is return to the calling routine
If 'yes' 
   The command line is cleared
   The cursor is positioned in the correct spot for the completion message.
******************************************************************************/
#include <string.h>
#include "las.h"
#include "geompak.h"
#include "protos.h"

void disquit
(
    char *ans,				/* answer pointer		*/
    long *line				/* number of lines on the terminal */
)

{  /* disquit  */

long term;				/* terminator used for answer	*/

char blank60[61];			/* buffer for a blank line	*/
char ques[80];				/* buffer for the question	*/

/*  Initialize variables
------------------------*/
strcpy(ques,"Are you sure you want to end the session? (Y)es, (N)o");
strcpy(blank60,"                                                           ");

/*  Output question
-------------------*/
t_output(*line - 1,2,blank60);
t_output(*line,2,ques);

/*  Wait for reply
------------------*/
t_input(*line,56,ans,&term);
if (term == P_OVER)
   t_output(*line - 2,2,"[editgrid-input] Input is larger than buffer size");

/*  If answer is yes blank out command line and position cursor
---------------------------------------------------------------*/
if ((strncmp(ans,"y",1) == 0) || (strncmp(ans,"Y",1) ==0))
   {
   strncpy(ans,"q",1);
   t_output(*line - 1,2,blank60);
   t_output(*line,2,blank60);
   t_pos(*line,1);
   }

return;
} /* disquit */
