/******************************************************************************

NAME:	DSTCOEF

FUNCTION: DSTCOEF is used to display the  transformation coefficients
          of the grid file to the terminal.

PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    1.0         5/89       D.Etrheim	initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:
Initialize the constants and clear the correct part of the terminal
If POLYNOMIAL method
   the polynomials are output to the terminal based on the number of the 
   coefficients

******************************************************************************/
#include <string.h>
#include "las.h"
#include "geompak.h"
#include "protos.h"

void dstcoef
(
    struct GEOGRID *grid			/*  Geometric mapping grid	*/
)

{  /* dstcoef */

char line[81];				/*  buffer of output line 	*/
char term[15][20];			/*  Character constants 	*/ 
char blank75[76];			/*  buffer to blank line        */
long i;					/*  loop index 			*/

/*  Initialize the terms of the polynomial constant
----------------------------------------------------*/
strcpy(&(term[0][0]),"Constant");
strcpy(&(term[1][0]),"X");
strcpy(&(term[2][0]),"Y");
strcpy(&(term[3][0]),"X**2");
strcpy(&(term[4][0]),"XY");
strcpy(&(term[5][0]),"Y**2");
strcpy(&(term[6][0]),"X**3");
strcpy(&(term[7][0]),"(X**2)Y");
strcpy(&(term[8][0]),"X(Y**2)");
strcpy(&(term[9][0]),"Y**3");
strcpy(&(term[10][0]),"X**4");
strcpy(&(term[11][0]),"(X**3)Y");
strcpy(&(term[12][0]),"(X**2)(Y**2)");
strcpy(&(term[13][0]),"X(Y**3)");
strcpy(&(term[14][0]),"Y**4");

strcpy(blank75,
"                                                                          ");

/* clear screen where transformation coefficients are printed 
-------------------------------------------------------------*/
for (i = 0; i < 16; i ++)
   t_output(5 + i,2,blank75);
                         
if (strncmp(grid->model,"POLYNOMIAL",10) == 0)
   {
   sprintf(line,"First Polynomial: %27s Second Polynomial:"," ");
   t_output(5,2,line);
   for (i = 0; i < grid->ncoeff; i++)
      {
      if (i < 10) 
         sprintf(line," a%d: %20.12e     %s   %*s  b%d: %20.12e",i,
                 grid->coeffs[i],&(term[i][0]),(13 - strlen(&term[i][0])),
                 " ",i,grid->coeffs[i + grid->ncoeff]);
      else
         sprintf(line,"a%d: %20.12e     %s   %*s b%d: %20.12e",i,
                 grid->coeffs[i],&(term[i][0]),(13 - strlen(&term[i][0])),
                 " ",i,grid->coeffs[i + grid->ncoeff]);
      t_output(6+i,4,line);
      }
   }
return;
}  /* dstcoef */
