#ifndef PROTOS_H
#define PROTOS_H

int check
(
    struct GEOGRID *grid,			/* Geometric mapping package */
    long *line				/* number of lines on terminal*/
);

void disquit
(
    char *ans,				/* answer pointer		*/
    long *line				/* number of lines on the terminal */
);

void dspcom
(
    struct GEOGRID *grid,			/*  Geometric mapping grid	*/
    char *hosin,				/*  input TAE grid file name	*/
    char *hosout,				/*  output host grid file name	*/
    long *write_flag,			/*  write flag			*/
    long *exist_flag			/*  flag for file existence	*/
);

void dstcoef
(
    struct GEOGRID *grid			/*  Geometric mapping grid	*/
);

void dstimg
(
    char *taein,				/*  input TAE grid name	*/
    struct GEOGRID *grid,			/*  Geometric mapping grid	*/
    long *flag				/*  flag for paging		*/
);

void pntval
(
    long input,			/*  input valid code			*/
    char str[16]			/*  output valid string			*/
);

int clrgrd
(
    struct GEOGRID *grid			/* geometric mapping grid	*/
);

void edtbat
(
    struct PARBLK *parblk,		/* pointer to TAE parameter block	*/
    struct GEOGRID *grid,		/* Geometric mapping grid 		*/
    char *hosout,			/* input grid file host name		*/
    long *exist_flag		/* flag if file exists or not		*/
);

int valid
(
    char *val_str		/*  input valid string				*/
);

void edtgrid
(
    char *edans_buf,			/* pointer to edit command code	*/
    long *line,				/* number of lines on the screen*/
    struct GEOGRID *grid,			/* Geometric mapping grid	*/
    long *edit_flag			/* edit flag			*/
);

int start_of_line
(
    long *line,				/*  number of lines on the terminal*/
    char **eqptr,				/*  agridess of the str. right of = */
    char *string				/*  agridess of command string	*/
);

void validate
(
    char *eqptr,				/* point to command string	*/
    char *echo,				/* pointer to output string	*/
    long *vld,				/* pointer to valid code	*/
    long *line				/* number of lines on terminal	*/
);

void edtint
(
    long *lines				/*  number of lines on terminal	*/
);

void getpar
(
    struct PARBLK *parb,			/*  TAE parameter block		*/
    char *hosin,				/*  Input TAE name		*/
    char *hosout,				/*  output grid file name	*/
    char *subcmd,				/*  subcommand parameter	*/
    long *exist_flag			/*  flag for file existence	*/
);

void gridhelp
(
    char ans[],	  			/* input help code		*/
    long *line				/* number of lines in the terminal */
);

#endif
