/*
---------------------------------------------------------------------------

   Name- Checkname

   Language- C     

   Version- 7.0   Date-  6-OCT-89  Programmer- F. Irani    New Module

   Function- Check syntax for the names of (new) classes and sites.

---------------------------------------------------------------------------
*/


#include "editstat.h"

int checkname
(
    char csname[]		/* Class or site name to check */
)

{

long	ii,			/*  char loop counter			*/
	valid;			/*  name validity flag			*/

valid = TRUE;

if (len > STNAME) 
  	{
  	sprintf(estring,
  	"[editstat-namelen] Name too long. %4d characters maximum.", STNAME);
  	t_output (t_lines - 2, 1, estring);
  	valid = FALSE;
  	return(valid);
  	}

/*
Check for valid naming convention (blanks and tabs).
----------------------------------------------------*/
if (es_index(csname, " ") >= 0 || es_index(csname, "	") >= 0 )
  	{
  	t_output(t_lines-2,1,"[editstat-blank] Blanks are not allowed in name");
  	valid = FALSE;
  	return(valid);
  	}
  
/*	
Allow a name of "0" (zero). Calling routine must handle it.
-----------------------------------------------------------*/
if ( isdigit(csname[0]) )
  	{
  	if (strncmp(csname, "0", len) != 0)
  		{
  		t_output(t_lines - 2, 1, 
  		"[editstat-firstchar] First character of name must not be numeric");
  		valid = FALSE;
  		return(valid);
  		}
  	}
  
for (ii = 0; ii < len; ++ii)
  	{
  	/*
  	The only special characters allowed are asterisk and underscore.
  	----------------------------------------------------------------*/
  	if ( isdigit(csname[ii]) || isalpha(csname[ii]) ||
	     csname[ii] == '_'   || csname[ii] == '*')
		{
		continue;
		}
	else
		{
		t_output(t_lines - 2, 1,
		"[editstat-char] Invalid character found.  Use alphanumeric characters only.");
  		valid = FALSE;
  		return(valid);
		}
  	}
  
return(valid);

}
