#include "editstat.h"

/********************************************************************
     FUNCTION check_page(oldpage,newpage,delpage,pdim,maxdim,row,col,
               sizer,sizec)
   NAME- CHECK_PAGE                     

   Language- C

   Version- 1.0    Date- 20-Jun-83  Programmer- R. J. Tighe
   Version- 1.0    Date- 10-Oct-89  Programmer- F. M. Irani/STX

   Function- Determines if a page clear is needed before displaying
        the next page. Also returns the size of the next page and the
        matrix indices of the upper left corner matrix element.

   Comments- Called by dispcovr.  Used by both es_editcovr and 
   es_editcor via a call to newcovr which calls dispcovr.

************************************************************************/


void check_page
(
    long *oldpage,
    long *newpage,
    long *delpage,
    long *pdim,
    long *maxdim,
    long *row,
    long *col,
    long *sizer,
    long *sizec
)

{

long	col1,
	col2,
	iq,
	ir1,
	row1,
	row2,
	size1, 
	size2;

/* Determine size of display for new page.
------------------------------------------*/
iq = (*newpage - 1) / *delpage;
ir1 = *newpage - *delpage * iq;
*row = iq * (*pdim) + 1;
*col = (ir1 - 1) * (*pdim) + 1;
row2 = *row + (*pdim) - 1;

if (row2 > *maxdim) 
	row2 = *maxdim;

*sizer = row2 - *row + 1;
col2 = *col + (*pdim) - 1;

if (col2 > *maxdim) 
	col2 = *maxdim;

*sizec = col2 - *col + 1;

if (*oldpage != *newpage) 
	{
	/*
	Determine size of display for old page.
	---------------------------------------*/
	iq = (*oldpage - 1) / *delpage;
	ir1 = *oldpage - *delpage * iq;
	row1 = iq * (*pdim) + 1;
	col1 = (ir1 - 1) * (*pdim) + 1;
	row2 = row1 + (*pdim) - 1;

	if (row2 > *maxdim) 
		row2 = *maxdim;

	size1 = row2 - row1 + 1;
	col2 = col1 + (*pdim) - 1;

	if (col2 > *maxdim) 
		col2 = *maxdim;

	size2 = col2 - col1 + 1;

	/* If oldpage not same size as newpage, clear the page before write.
	--------------------------------------------------------------------*/
	if (*sizer != size1  ||  *sizec != size2) 
		t_lclear(6, 20);
	}
return;
}
