#include "editstat.h"
#include "msg.h"

/*
      FUNCTION comthm(newclass, combcls)

**********************************************************************

   name- comthm                         expires- 1/1/99

   language- C

   version- 1.0    date-  30-jun-83  programmer- s. ross, sasc
   revision 2      date   30-may-86  programmer  n. deodhar/sar, #202
   version- 2.0    date   10-Oct-89  programmer  f. irani/stx

                   this code was borrowed from combcls to be included
                   in editstat.  comthm.cmt was revision 3 dated 29-jul-83
                   and modified to enable inclusion in editstat

   function- comthm moves an origination  class into a
             destination class

------------------------------------------------------------------------
*/

void comthm
(
    char newclass[],	/* Name of new class to hold the combined classes */
    char combcls[]	/* Name of class to be combined			  */
)


{

long status;    /* Status flag for function calls */
long zero = 0;  /* General programmer usage       */

long	buf[5000];		/* Buffer to hold statistics data	*/	

char	data_type[STNAME],	/* Data types of statistics 		*/
	oldsite[STNAME+1]; 	/* Old site names 			*/

long	dc,  			/* dummy class index 			*/
	ds,  			/* dummy site index 			*/
	dshape[9],		/* Dummy shape vector 			*/
	oldns,			/* Number of sites in destination class */
	ns,			/* number of sites in destination class */
	oc,			/* old class index 			*/
	os,			/* old site index 			*/
	shape[9],		/* Shape vector for site transfer 	*/
	valid;  		/* Valid site name indicator 		*/

dshape[0] = EBYTE;
dshape[1] = 1;

/*
Store the new class name at a new node in the file.
---------------------------------------------------*/
shape[0] = EBYTE;
shape[1] = 1;
shape[2] = (long) strlen(newclass);

/*
Find the index of the destination class -- if it exists.
--------------------------------------------------------*/
status  = c_stfdcl (&inlun, newclass, &ic);
if ( status  != E_SUCC) 
	{
	/*
	Class does not yet exist.  Create a new class.
	----------------------------------------------*/
	ic = nclass+1;
	if (ic > MAXCLS)
		{
	        t_lclear (t_lines - 2, 1);
		t_output (t_lines - 2, 1,
"[editstat-maximum] Unable to add more classes. Maximum of MAXCLS has been reached");
	        return;
		}
	status = c_stput (&inlun, "NAME", &ic, &zero, shape, newclass);
	}

/*
Determine number of sites in destination class.
-----------------------------------------------*/
status  = c_stget (&inlun, "NSITES", &ic, &zero, dshape, &ns);

/*
Get class index for class to be combined.
-----------------------------------------*/
status  = c_stfdcl (&inlun, combcls, &oc);

/*
Get number of sites in old class.
---------------------------------*/
status  = c_stget (&inlun, "NSITES", &oc, &zero, dshape, &oldns);

/*
We are moving one site at a time.
---------------------------------*/
os = 0;

/*
Do until no sites left in old class.
------------------------------------*/
for (;;) 
     {
     ++os;

     /*
     Get old site name.  Break if no more sites for this class.
     ----------------------------------------------------------*/
     status  = c_stget (&inlun, "NAME", &oc, &os, dshape, oldsite);
     if ( status  == E_NOSI)
	break;

     oldsite[dshape[2]] = '\0';

     for (;;)
        {
	t_output (t_lines - 2, 1, "WORKING");

	/* Prompt the user for new site names if duplicates are found.
	--------------------------------------------------------------*/
	status  = c_stfdsi (&inlun, newclass, oldsite, &dc,  &ds);
	if ( status  != E_SUCC)
		break;
	else
		{
		label();
		combheader(newclass, combcls);
		listsit(newclass);

                t_lclear (t_lines - 3, 1);
                t_lclear (t_lines - 2, 1);
          	sprintf(estring, "[editstat-siteused] The site name %s from class %s", 
			oldsite, combcls);
                t_output (t_lines - 3, 1, estring);

                sprintf(estring, "[editstat-siteused] is already used in class %s", newclass);
                t_output (t_lines - 2, 1, estring);
                sprintf(estring, "Enter a new name for this site:");
		for (;;)
			{
			prompt(ostring);
			if (strncmp(ostring, "0", len) == 0)
			   {
			   valid = FALSE;
			   t_lclear(t_lines - 2, 1);
			   t_output(t_lines - 2, 1,
			   "[editstat-invalchar] Invalid character specified");
			   break;
			   }

			if (es_index(ostring, "*") >= 0)
			   {
			   valid = FALSE;
			   t_lclear(t_lines - 2, 1);
			   t_output(t_lines - 2, 1,
			   "[editstat-invalchar] Invalid character specified");
			   break;
			   }

			valid = checkname(ostring);
			if (valid)
				strcpy(oldsite, ostring);
			break;
			}
                if (!valid)
			continue;

		/*
		Clear screen of site names.
		---------------------------*/
		label();
		combheader(newclass, combcls);

		}  /* if duplicate name was found prompt for new name.	*/
        }  /* Check for and rename a duplicate site name. */

     t_lclear (t_lines - 2, 1); /* Clear WORKING notice */

     /*
     Move this site into new class.
     ------------------------------*/
     ++ns;
     dshape[2] = (long) strlen(oldsite);
     status  = c_stput (&inlun, "NAME", &ic, &ns, dshape, oldsite);

     /*
     Copy all old site data nodes to new nodes in the new site.
     ----------------------------------------------------------*/
     id = 1;
     for (;;) 
        {
	status  = c_stnode (&inlun, &oc, &os, &id, data_type, dshape);
	if ( status  == E_NODT)
		break;
	status  = c_stget (&inlun, data_type, &oc, &os, dshape, buf);
	if (strncmp(data_type, "NAME", dshape[2]) !=  0)
		status  = c_stput (&inlun, data_type, &ic, &ns, 
			      dshape, buf);
	++id;
        } /* For all data in node. */

     /*
     Site has been merged to new class.  Update NSITES for destination class.
     ------------------------------------------------------------------------*/
     dshape[0] = EBYTE;
     dshape[1] = 1;
     status  = c_stput (&inlun, "NSITES", &ic, &zero, dshape, &ns);
     if (status != E_DTNEW && status != E_DTOLD)
	c_sterr(status,t_lines - 2);

     /*
     Delete old site.
     ----------------*/
     status  = c_stdlnd(&inlun, &oc, &os);

     /*
     Old site was deleted. Current sites indicies are no longer valid. Reset.
     ------------------------------------------------------------------------*/
     os = 0;

     } /* For each site to be combined.*/

/*
Delete old class.
-----------------*/
status  = c_stdlnd(&inlun, &oc, &zero);
if (status != E_SUCC)
	c_sterr(status,t_lines - 2);
else
     {
     sprintf(estring, "[informational] Class %s Merged", combcls);
     t_lclear(t_lines - 2, 1);
     t_output(t_lines - 2, 1, estring);
     }

return;

}
