#include "editstat.h"

/*
     subroutine covar_init(matrix,shape,quit)

**********************************************************************

   name- covar_init                     expires- 12/31/99

   language- C

   version- 1.0    date- 20-jun-83  programmer- R. J. Tighe
   version- 2.0    date- 10-Oct-89  programmer- F. M. Irani

   function- prompts the user for the dimension of a new covariance
        matrix. creates a zero-filled covariance matrix.

   comments- called by es_editcovr.

******************************************************************************/


void covar_init
(
    double **matrix,
    long shape[]
)

{

long inf_err = 1;     /* Information flag for c_errmsg  */
long fatal_err = -1;  /* Fatal error flag for c_errmsg  */

long	maxnum, 
	mindex;

quit = FALSE;
back = FALSE;

/* Prompt for dimension of new covariance matrix.
-------------------------------------------------*/
t_lclear (t_lines - 2, 1);
t_output (t_lines - 2, 1, "New covariance matrix being created.");

for (;;)
  {
  sprintf(estring,
  "Enter X where (X*X) is the size of the new covariance matrix or Back.");
  prompt(ostring);
  if (back)
	return;

   if (sscanf(ostring, "%ld", &maxnum) != 1)
     continue;

   if (maxnum < 1 || maxnum > MAXBND ) 
     {
     t_output (t_lines - 2, 1, "[editstat-invsize]  Invalid size for covariance matrix");
     continue;
     }
  else
     {
     /*
     Shape[2] is size of stored lower half of triangular matrix.
     -----------------------------------------------------------*/
     shape[2] = (maxnum * (maxnum + 1)) / 2;
     if ( (*matrix = (double *) malloc (shape[2] * sizeof (double))) == NULL)
     	      {
              c_errmsg ("Error allocating dynamic memory", "editstat-alloc",
                        &inf_err);
              c_errmsg("Fatal error encountered","editstat-fatal",
     	         &fatal_err);
     	      }
     
     for (mindex = 0; mindex < shape[2]; ++mindex)
     	 (*matrix)[mindex] = 0.0;
     
     quit = FALSE;
     }
  break;
  }

return;

}
