#include "editstat.h"

/*
     FUNCTION dispcovr(oldpage,newpage,matrix,maxdim,pdim,delpage,es_node)
---------------------------------------------------------------------------
   name- dispcovr                       expires- 12/31/99

   language- C

   Version- 1.0    date- 20-jun-83  programmer- r. j. tighe
   Version- 1.1    date- 29-may-86  programmer- n. deodhar/sar, #129
   Version- 2.0    date- 10-Oct-89  programmer- F. M. Irani/Stx

   function- produces a matrix display page

   comments- called by newcovr.

--------------------------------------------------------------------------*/


void dispcovr
(
    long *oldpage,		/* Control for printing pages		*/
    long *newpage,		/* Control for printing pages		*/
    double *matrix,		/* Matrix data to be displayed		*/
    long *maxdim,		/* Maximum dimension for matrix		*/
    long *pdim,			/* Page dimension			*/
    long *delpage,		/* Used to figure page			*/
    char es_node[]		/* Node for which matrix is displayed	*/
)
{

long i;  /* General purpose array index */
long j;  /* General purpose array index */

long	baser = 6, 		/* Base row				*/
	col,			/* Column				*/
	colnum,			/* Column number			*/
	ival,			/* Index value into matrix		*/
	jval,			/* Index value into matrix		*/
	kval,			/* Index value into matrix		*/
	new_baser,		/* New base row 			*/
	newdispr,		/* New display row 			*/
	row,			/* Current row number			*/
	rownum,			/* Current row number to display	*/
	sizer, 			/* Size of rows				*/
	sizec;			/* Size of columns			*/

/* Put matrix name size and page number at top.
-----------------------------------------------*/
if (es_index(command, "EDITCOV") < 0)
	sprintf(estring, "Correlation matrix for: %s", es_node);
else
	sprintf(estring, "Covariance matrix for: %s", es_node);

t_output (2, 1, estring);

sprintf(estring, "Size = %3d X %3d", *maxdim, *maxdim);
t_output (3, 1, estring);

sprintf(estring, "PAGE %ld", *newpage);
t_output (3, 65, estring);

/*
Check to see if page clear is needed.
-------------------------------------*/
check_page (oldpage, newpage, delpage, pdim, maxdim, 
	    &row, &col, &sizer, &sizec);

/*
Set up base line and column for display.
----------------------------------------*/
new_baser = baser + (*pdim - sizer);

/* Write column headers to screen.
----------------------------------*/
sprintf(estring,"      ");
for (i = 1; i <= sizec; ++i)
   {
   colnum = (col + i) - 1;
   sprintf(ostring,"%13d  ", colnum);
   strcat(estring, ostring);
   }
t_output (6, 1, estring);

/* Write row numbers and data to screen.
----------------------------------------*/
newdispr = new_baser;
for (i = 1; i <= sizer; ++i)
   {
   newdispr = newdispr + 2;
   rownum = (row + i) - 1;
   sprintf(estring,"%4d  ", rownum);
   t_output (newdispr, 1 , estring);
   ostring[0] = '\0';
   for (j = 1; j <= sizec; ++j)
      {
      colnum = (col + j) - 1;
      if (rownum > colnum)
      	ival = rownum;
      else
	ival = colnum;
      if (rownum < colnum)
      	jval = rownum;
      else
	jval = colnum;

      kval = ((ival * (ival - 1)) / 2) + jval; 
      sprintf(ostring,"%13e  " , matrix[kval-1]);
      strcat(estring, ostring);
      }
   t_output (newdispr, 1, estring);

   }
return;
}
