
#include "editstat.h"

/*
**********************************************************************

   name- disphist                       expires- 12/31/99

   language- C

   version- 1.0    date- 14-jun-83  programmer- l. urquhart
   version- 2.0    date- 10-Oct-89  programmer- F. Irani

   function- displays 128 values of the histogram

   parameters-
      variable                type i/o function
      --------                ---- --- --------
      page                    i*4  i   page no.
      hist(128)               i*4  i   array of histogram values

   comments- Called by newhist

**********************************************************************

*/


void disphist
(
    long *page,		/* Histogram display page number (0 or 1) */
    long hist[],		/* Histogram array values		  */
    char es_node[]	/* Name of image, class or site level	*/
)

{

long i;  /* General purpose array index */
long j;  /* General purpose array index */
long k;  /* General purpose array index */
long l;  /* General purpose array index */

long	first_elem;


/* Display page no.
-------------------*/
t_lclear (1, 1);
t_lclear (2, 1);
sprintf(estring, "Histogram for: %s", es_node);
t_output (1, 1, estring);
if (*page < 3)
	sprintf(estring, "PAGE %4d+", *page + 1);
else
	sprintf(estring, "PAGE %4d.", *page + 1);

t_lclear (2, 65);
t_output (2, 65, estring);

/* Display 64 histogram values.
-------------------------------*/
first_elem = (*page) * 64;

for (i = 0; i < 4; ++i)
	{
	k = i * 20;
	if (k == 0)
		k = 1;
	t_output(3, k, " bin#      sum      ");
	}

for (i = 0; i < 4; ++i)
	{
	k = i * 20;
	if (k == 0)
		k = 1;
	t_output(4, k, " ----      ---      ");
	}

for (i = 0; i < 64; ++i)
	{
	j = (i%(t_lines - 8)) + 5;
	k = ((long)(i / 16)) * 20;
	if (k == 0)
		k = 1;
        l = i + first_elem;
	sprintf(estring, " %3ld %10ld", l, hist[i]);
	t_output( j, k, estring);
	}

return;

}
