#include "editstat.h"

/*
**********************************************************************

   name- dispmean                      

   language- C

   version- 1.0    date- 14-jun-83  programmer- l. urquhart
   version- 1.1    date- 29-may-86  programmer- n. deodhar/sar, #129

   function- displays the mean vector

   comments- called by newmean

**********************************************************************

*/
void dispmean
(
    double mean[],		/* mean vector data			*/
    long size,		/* Size of Vector			*/
    long index,		/* Index into vector			*/
    char es_node[]	/* image/class/site level of vector being displayed */
)

{

long i;  /* General purpose array index  */
long k;  /* General purpose array index  */

char	catstr[81];

long 	iend;

k = 0;

/* Display heading.
-------------------*/
sprintf(estring, "Mean vector for: %s", es_node);
t_output (2, 1, estring);
sprintf(estring, "Number of bands = %4d", size);
t_output (3, 1, estring);

t_output (5, 8, "ELEMENT                    VALUE");
t_output (6, 8, "-------                    -----");

/* For each mean value.
-----------------------*/
if (size < index+14)
   	iend = size;
else
   	iend = index + 14;

for (i = index-1; i < index+14; ++i)
   {
   ++k;
   if (i < iend) 
        {
   	/*
   	Convert i (element no.) to estring.
   	-----------------------------------*/
   	sprintf(estring, "   %3d", i+1);

        /* Convert to estring.
        ----------------------*/
   	sprintf(catstr, "             %e", mean[i]);

   	/* Concatenate estring and display.
   	-----------------------------------*/
        strcat(estring, catstr);
        t_output (6+k, 10, estring);
        }
   else
      	t_output (6+k, 1, " ");
   }  /* do */

return;

}
