#include "editstat.h"

/*
**********************************************************************

   name- disppoly                       

   language- C

   version- 1.0    date- 29-jun-83  programmer- k. s. mcgee
   version- 2.0    date- 10-Oct-89  programmer- F. M. Irani

   function- displays point#, pixel# and line# associated with
             specified site
	
**********************************************************************

*/

void disppoly
(
    long shape[], 		/* Length of polygon to display		*/
    long array[2][MAXPTS],	/* Polygon values to be displayed	*/
    long *npages		/* Number of pages to display polygon 	*/
)

{

long i;  /* General purpose array index  */
long k;  /* General purpose array index  */

long	col,		/* Column number for display			*/
	first,		/* First display value				*/
	maxpage,	/* Number of pages to display entire vector	*/
	ncols,		/* Number of colums needd to display		*/
	start, 		/* Start display value				*/
	stop, 		/* stop display value				*/
	tcols;		/* Total columns for display			*/

/*
# columns.
----------*/
tcols = shape[2]/15;
if ((shape[2] - (tcols*15)) !=  0) 
	++tcols;

maxpage = shape[2]/30;
if ((shape[2] - (maxpage * 30))  !=  0)
	++maxpage;

if (*npages  !=  maxpage) 
	ncols = 2;
else if ( (tcols % 2)  ==  0) 
	ncols = 2;
else
	ncols = 1;

first = (*npages - 1) * 30;

/* Display page no.
-------------------*/
if (listem)
  label();
sprintf(estring, "PAGE     %ld", *npages);
t_output (1, 1, estring);
sprintf(estring, "Editing Class:%s, Site:%s", class, site);
t_output (2, 1, estring);

/*
Display pt, pixel and line number.
----------------------------------*/
if (ncols  ==  1) 
	{
	t_output (3, 1, "    POINT#        ROW     COLUMN");
	t_output (4, 1, "    ------ ---------- ---------- ");
	}
else
	{
        t_output (3, 1, 
        "    POINT#       ROW      COLUMN     POINT#        ROW     COLUMN");
	t_output (4, 1, 
        "    ------ ---------- ----------     ------ ---------- ---------- ");
	}

stop = first + 30;
if (stop  >  shape[2]) 
	stop = shape[2];

start = first;
for (i = start; i < stop; ++i)
	{
	/* Get proper length for pt, pixel, and line numbers.
	-----------------------------------------------------*/
	sprintf (estring,"    %6d %10d %10d", i+1, array[1][i], array[0][i]);

	/* Display.
	-----------*/
	if (i  >  first + 14)
		col = 34;
	else
		col = 1;

	k = i%(t_lines - 9);
	t_output ((k + 5), col, estring);
	}

return;

}
