#include "editstat.h"

/*
*****************************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for covariance matrices 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/13/91  T. Rockvam	Dynamically allocate global variables
					 so as not to run out of stack space

*****************************************************************************
*/
void dyn_alloc
(void)

{
long str_size,
     fatal_err = -1;

/*
Allocate storage for global variables. 
-------------------------------------------------
*/

str_size = (STNAME + 1) * sizeof (char);

if ((class = (char *) malloc (str_size)) == NULL ||
    (hos = (char *) malloc (str_size)) == NULL ||
    (las = (char *) malloc (str_size)) == NULL ||
    (ostring = (char *) malloc (str_size)) == NULL ||
    (site = (char *) malloc (str_size)) == NULL ||
    (prtfile = (char *) malloc (str_size)) == NULL ||
    (ohos = (char *) malloc (str_size)) == NULL ||
    (estring = (char *) malloc (ESTRSZ * sizeof (char))) == NULL ||
    (sortlist = (long *) malloc ((MAXCLS + 1) * sizeof (long))) == NULL)
c_errmsg ("Error allocating dynamic memory", "EDITSTAT-fatal", &fatal_err);

}
