/*-------------------------------------------------------------------------
     FUNCTION es_copy


   name- es_copy                   

   Language- C

   VERSION	DATE		PROGRAMMER	ACTION
   ---------------------------------------------------
   VERSION- 1.0    DATE- 20-JUN-83  PROGRAMMER- G.MCCONAUGHY(SASC)
   REVISION 1      DATE  16 JUN 84  PROGRAMMER  B. DEALY SAR 20-221
   VERSION- 2.0    DATE-  7-JAN-89  PROGRAMMER- F. IRANI STX LAS V5.0 Port
   
   3.0    	JAN-90  	B. AILTS  	Use parameters instead of 
						interactive prompts for bands 
						and class names

   FUNCTION- ES_COPY COPIES AND REDUCES A STATISTICS FILE

   Exit states: On quit by user

-------------------------------------------------------------------------*/

#include "editstat.h"

void es_copy
(
    long nincls,			/* no of classes to be copied		*/
    char cpy_cls[MAXCLS][STNAME],	/* names of classes to be copied	*/
    long blist[MAXBND],		/* band no to be copied			*/
    long num			/* Index into bands to be copied	*/
)

{

long i;            /* General purpose array index    */
long zero = 0;     /* General programmer usage       */
long inf_err = -1; /* Information flag for c_errmsg  */

long    scls,			/* Search class: Class being checked.   */
	ns,			/* Number of sites in a class		*/
	shape[9];		/* Shape vector for c_stget		*/

short cpy_flg;			/*  flag that indicates whether to copy */

/*
Get list of bands to delete, if any.			
------------------------------------*/
quit = FALSE;

/*
Initialize sort array for consecutive copy.
-------------------------------------------*/
for (scls = 0; scls <= nclass; ++scls)
	sortlist[scls] = scls;

/*
Arrange class indicies in desired order.
----------------------------------------*/
if (sort)
	getsort(sortlist);

if (quit)
	return;

/*
Loop through all nodes.
-----------------------*/
is = ocls = 0;
for (scls = 0; scls <= nclass; ++scls)
   {
   ic = sortlist[scls];
   /*
   Handle image level statistics if any.
   -------------------------------------*/
   if (!ic)
        {
   	esc_donode (blist, num);    /* image and class levels */
        if (nincls == -1)
       		return;
	else
		continue;
        }
   if (ic && copy && (nincls >= 1))
      {

      /*
      Check to be sure the class was specified by the user to be copied.
      ------------------------------------------------------------------*/
      c_stget (&inlun, "NAME", &ic, &zero, shape, ostring);
      ostring[shape[2]] = '\0';
      len = (long) strlen(ostring);
      cpy_flg = FALSE;
      for (i =0; i < nincls; ++i)
         {
         if (strncmp(ostring,cpy_cls[i],len) == 0)
            {
	    ++ocls;
            cpy_flg = TRUE;
            break;
            } /*  if ostring == cpy_cls[i]  */
         }  /*  for i = 0 to nincls  */
      }  /*  if copy  */
   else if (copy && (nincls == -1))
      cpy_flg = FALSE;
   else
      {
      ++ocls;
      cpy_flg = TRUE;
      }

   if (cpy_flg)
      {
      esc_donode (blist, num);    /* class levels */
      if (ic) 
         {
         ns = 0;
         c_stget(&inlun, "NSITES", &ic, &zero, shape, &ns);
   
         /*
	 Handle site nodes.
         ------------------*/
         if (ns) 
            	    {
	            for (is = 1; is <= ns; ++is)
		         esc_donode (blist, num);
	            is = 0;
            	    }
         }  
      }
   }  

if (ocls < nincls)
   c_errmsg ("Not all user-specified classes were copied","informational",
	  &inf_err);

return; 
}
