#include "editstat.h"

/*
     subroutine es_dropcls
**********************************************************************

   name- dropcls                        

   language- C

   version- 1.0    date- 30-jun-83  programmer- s. ross, sasc
   version- 2.0    date- 10-OCT-89  programmer- F. Irani, STX
 
                   This code was borrowed from dropcls to be included
                   in editstat.

   function- dropcls deletes a designated class from a statistics file

**********************************************************************

*/
void es_dropcls
(void)

{

long i;          /* General purpose array index    */
long status;     /* Status flag for function calls */
long one = 1;    /* General programmer usage       */
long zero = 0;   /* General programmer usage       */

char	star1[STNAME+1],	/* Prefix search string		*/
	star2[STNAME+1];	/* Postfix search string 	*/

long 	delcnt,			/* delete index			*/
	found,			/* designated class was found	*/
	lineno,			/* display line number		*/
   	match,			/* match name flag		*/
	shape[9];		/* Shape vector for class name  */

listem = TRUE;
/* Prompt user for Class to delete.
-----------------------------------*/
for (;;)
	{
	status = getcs(1);
	if (quit) 
		return;
	i = es_index(class, "*");
	if (i < 0 && status == E_NOCL)
		{
		c_sterr(status,t_lines - 2);
		continue;
		}
	else if (i < 0)
		{
  		sprintf(estring,
  		"Class %s will be deleted. OK? [YES/NO]", class);
   		prompt(ostring);

		if (strncmp(ostring, "YES", len) != 0)
			continue;

		status = c_stdlnd (&inlun, &ic, &zero);
		if (status != E_SUCC)
			{
	   		c_sterr(status,t_lines - 2);
	   		continue;
			}
  		else
  			{
			--nclass;
			listem = TRUE;
  			continue;
  			}
  		}
	len = (long) strlen(class);
  	if (strncmp(class, "*", len) == 0)
  		{
  		sprintf(estring,
  		"All classes will be deleted. OK? [YES/NO]");
   		prompt(ostring);
		if (strncmp(ostring, "YES", len) == 0)
			{

			status = E_SUCC;
			t_lclear(t_lines - 2, 1);
  			t_output(t_lines - 2, 1, "Deleting all class statistics");
  			while (status != E_NOCL)
  			  {
			  /*
			  For each delete delete one (the first) 
			  class until no more classes are found in the file.
			  --------------------------------------------------*/
  			  status = c_stdlnd (&inlun, &one, &zero);
  			  if (status != E_SUCC && status != E_NOCL)
  			  	{
  				c_sterr(status,t_lines - 2);
  				continue;
  			  	} 
  			  else if (status == E_SUCC)
			  	{
  				--nclass;
			  	}
			  }   /* while deleting all classes */
		  	t_output(t_lines - 2, 1, "All classes deleted.");
			listem = TRUE;
		  	continue;
			}  
  		else
			/* User decided not to delete all classes.
			------------------------------------------*/
	  		continue;

		} /* If star exists and length = 1 delete all classes. 	*/

	/*
	Star exists with other characters (Star delete).
	------------------------------------------------*/
	star1[0] = '\0';
	star2[0] = '\0';
	if (i == len - 1)
		{

		/*
		Star is at end of name. Match this prefix.
		-------------------------------------------*/
		strcpy(star1, class);
		star1[i] = '\0';
		}
	else if (i == 0)

		/*
		Star is at beginning of name. Match this postfix.
		-------------------------------------------------*/
		strcpy(star2, &class[i+1]);
	else
		{
		/* Star is somewhere in middle of name. Match both.
		---------------------------------------------------*/
		strcpy(star1, class);
		star1[i] = '\0';
		strcpy(star2, &class[i+1]);
		}

	found = FALSE;
	label();
	delcnt = -1;

	/* Loop through all classes. Find any matches.
	----------------------------------------------*/
	for (ic = 1; ic <= nclass; ++ic)
		{

	  	/* Get class name.
	  	------------------*/
	  	status = c_stget(&inlun, "NAME", &ic, &zero, shape, class);
	  	class[shape[2]] = '\0';
    			
	  	match = FALSE;
  
	    	if (star2[0] == '\0')
	    		{
	    		/* Match prefix.
	    		----------------*/
	  		len = (long) strlen(star1);
	     		if ( strncmp(class, star1, len) == 0) 
	  		    	match = found = TRUE;
	    		}
	    	else if (star1[0] == '\0')
	      		{
	  		/* Match postfix.
	  		-----------------*/
	    		len =  (long) strlen(class);
	  		len -= strlen(star2);
	  		if ( strcmp(star2, &class[len]) == 0)
	  		    	match = found = TRUE;
	    		}
	    	else
	    		{
	    		/* Match prefix.
	    		----------------*/	
	  		len = (long) strlen(star1);
	     		if ( strncmp(class, star1, len) == 0) 
	    			{
				/* Match postfix.
	    			-----------------*/
	  			len = (long) strlen(class);
	  			len -= strlen(star2);
	    			if (strcmp(star2, &class[len]) == 0) 
		  		  	match = found = TRUE;
	    			}
	    		}
	  
	    	if (match)
	  		{
	  		/* This ic is a match.  Add it to the delete array.
	  		---------------------------------------------------*/
	  		++delcnt;
	  		sortlist[delcnt] = ic;
	
	  		/* Write it to screen.
	  		----------------------*/
			lineno = (delcnt % 16);
			t_output (lineno + 4, 1, class);
			if (lineno == t_lines - 9)
				{
				label();
				}
	  		}
		}  /* For all classes */

	if (!found)
		{
	    	/* If no match was ever found with star.
	  	----------------------------------------*/
	  	t_lclear(t_lines - 2, 1);
	  	t_output(t_lines - 2, 1, "No match. Try again.");
	  	continue;
		}

	/*
	Allow user opportunity to abort delete if desired.
	--------------------------------------------------*/
	sprintf(estring, 
	"Do you wish to delete ALL of these classes? [YES/NO]");
	prompt(ostring);
	
	/* Continue on anything other than YES.
	---------------------------------------*/
	if (strncmp( ostring, "YES", len) != 0)
		continue;
	
	/*
	To delete a series of classes must delete highest numbered class
	first because each call to c_stdlnd updates/reduces file's nclass.
	------------------------------------------------------------------*/
	t_lclear (t_lines - 2, 1);
	for ( i = delcnt; i >= 0; --i)
		{
	    t_output (t_lines - 2, 1, "WORKING");
	
	    /* End matching begin deleting.
  	    -------------------------------*/
	    status = c_stdlnd (&inlun, &sortlist[i], &zero);
	    if (status != E_SUCC)
	    	{
	    	status = c_stget(&inlun, "NAME", 
				 &sortlist[i], &zero, shape, class);
	      	sprintf(estring, "Trouble deleting class %s.", class);
	      	t_output (t_lines - 3, 1, estring);
	    	c_sterr(status,t_lines - 2);
	    	continue;
	    	}
	    else
	    	/*
	    	Successful delete.
	    	------------------*/
	      	--nclass;
	
	    t_lclear (t_lines - 2, 1); /* Clear "WORKING" message */
	
	  	}  /* Star in name string (Star delete). 	*/  
	}  /* Do until quit on class name. 	*/

}
