#include "editstat.h"
#include "util.h"


/*
**********************************************************************

   name- edithist                       

   language- C

   version- 1.0    date- 14-jun-83  programmer- l. urquhart
   version- 2.0    date- 10-Oct	    programmer- F. Irani

**********************************************************************

*/


void es_edithist
(void)

{

long i;        /* General purpose array index    */
long status;   /* Status flag for function calls */
long zero = 0; /* General programmer usage       */

char	es_node[STNAME+1],	/* Name of data node (for display)	*/
	hname[STNAME+1],	/* Histogram name specification		*/
	histnode[STNAME+1];	/* Histogram node name for comparisons 	*/

long	exists,			/* Flag that specified histogram exists */
	hist[258],
	hshape[9],		/* Shape buffer for histogram		*/
	lineno,			/* Terminal line number for t_output	*/
	full,		/* Full histogram flag: Includes min and max values */
	save,			/* Flag to save changes			*/
	shape[9];		/* General or dummy NAME shape buffer	*/

double scale;

hshape[0]= ELONG;
hshape[1]= 1;
hshape[2]= 258;

listem = TRUE;
/* Do until Quit.
-----------------*/
for(;;)
  {
  /* Prompt user for Image level, class and/or site name to process.
  ------------------------------------------------------------------*/
  for (;;)
    {
    status = getcs(0);
    if (quit) 
  	return;

    if (es_index(class, "*") >= 0)
        {
  	t_lclear(t_lines - 2, 1);
  	t_output(t_lines - 2, 1,
	"[editstat-invalchar]  Invalid character specified");
	continue;
        }


    if (status != E_SUCC)
        {
  	c_sterr(status,t_lines - 3);
	if (status == E_NOCL)
		{
		t_lclear(t_lines - 2, 1);
		t_output(t_lines - 2, 1, 
		"Use the command NEWCLASS to create a new class.");
		t_output(t_lines, 1, "Enter <CR> to continue.");
	  	t_read (estring, &tae_term);
		}
	if (status == E_NOSI)
		{
		t_lclear(t_lines - 2, 1);
		t_output(t_lines - 2, 1, 
		"Use the command EDITSITE to create a new site.");
		t_output(t_lines, 1, "Enter <CR> to continue.");
	  	t_read (estring, &tae_term);
		}
	listem = TRUE;
	continue;
        }

    /* GETCS puts name of class, site or "0" (image level) into ostring.
    --------------------------------------------------------------------*/
    if (strcmp(ostring, "0") == 0 )
        {
    	if (ic)
		{
		status = c_stget(&inlun, "NAME", &ic, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
		sprintf(es_node, "Class level of class:%s", ostring);
		}
	else 
 		strcpy(es_node, "Image level");
        }
    else
	strcpy(es_node, ostring);
  
    /*
    Intialize histogram data.
    -------------------------*/
    for (i = 0; i < 258; ++i)
         hist[i]=0;
  
    exists = FALSE;
  
    /*
    Prompt user for histogram name to process.
    ------------------------------------------*/
    for (;;)
        {
  	label();
  	full = FALSE;
  	status = E_SUCC;
  	lineno = 0;
  	t_output(lineno+4, 1, "Existing Histograms:");
  
  	for (id = 1; status != E_NODT; ++id)
  		{
  	   	status = c_stnode (&inlun, &ic, &is, &id, histnode, shape);
  		if (strncmp(histnode, "HIST", 4) == 0 && status != E_NODT)
  			{
  			++lineno;
  			exists = TRUE;
  			t_lclear (lineno + 4, 1);
  			t_output (lineno + 4, 1, histnode);
  			if (lineno == t_lines - 9)
  				{
  				sprintf(estring,"Enter Select, Quit or Next");
				prompt(ostring);
  				len = (long) strlen(ostring);
  				if (len > 0)
  					{
  					if (strncmp(ostring, "SELECT", len)
                                            == 0)
 					   break;
  					}
                                /* Rest lineno and clear current list */
                                lineno=0;
                                for(i = 5; i < (t_lines-4); i++)
                                   t_lclear(i, 1);
  				}
  			}
  		if (quit || back)
  			return;
  		}
  	if (exists)
  	    sprintf(estring, "Enter name of histogram to edit or Back.");
  	else
  	    sprintf(estring,
       "No histograms found. Enter a name (e.g. HIST001, HISTxxx) or Back.");
  
  	prompt(hname);
	if (back)
	    {
	    listem = TRUE;
	    break;
	    }

  	status = c_stget (&inlun, hname, &ic, &is, hshape, hist);
  	if (status == E_SUCC)
  		break;
  
  	if (status == E_NODT) 
  		{
  		t_output (t_lines - 2, 1, "New histogram being created");
  		break;
  		}
  
  	else
  		{
  		c_sterr(status,t_lines - 2);	
  		continue;
  		}
  
      }
  if (back)
	continue;
  
  if (hshape[2] == 258) 
     {
     full = TRUE;
     svmin = hist[256];
     svmax = hist[257];
     if (svmin < 0.0  ||  svmax > 255.0)
        {
  	scale = ((svmax-svmin)/255.0);
  	sprintf(estring, "Min= %12.6e     Max= %12.63e     Scale= %12.6e",
  		svmin, svmax, scale);
        }
     }
  
  /*
  Get new histogram data.
  -----------------------*/
  save = FALSE;
  save = newhist(hist, es_node);
  listem = TRUE;
  if (back)
	continue;
  
  /*
  Put new data in stat file if indicated.
  ---------------------------------------*/
  if (save) 
     {
  
     if (!full) 
        {
        /*
        Determine size of histogram.
        ----------------------------*/
        for (i = 255; hist[i] == 0 && i >= 0; --i);
        hshape[2] = i+1;
        }
     else
        hshape[2] = 258;
  
     /*
     Replace histrogram data.
     ------------------------*/
     status = c_stput(&inlun, hname, &ic, &is, hshape, hist);
     if (status != E_DTOLD && status != E_DTNEW)
        {
  	c_sterr(status,t_lines - 2);	
     	continue;
        }
  
     /*
     Update "id" to current number of items in node.
     -----------------------------------------------*/
     status = E_SUCC;
     for (id = 1; status != E_NODT; ++id)
        {
     	status = c_stnode (&inlun, &ic, &is, &id, histnode, shape);
  	   if (status != E_NODT && status != E_SUCC)
  		c_sterr(status,t_lines - 2);	
        }
     }	/*	If save		*/
    }
  }	/* Do until quit	*/
   
}
