#include "editstat.h"

/*
**********************************************************************

   name- editmean                     

   language- C

   version- 1.0    date- 14-jun-83  programmer- l. urquhart
   version- 2.0    date- 10-Oct     programmer- F. Irani

**********************************************************************

*/

void es_editmean
(void)

{

long i;        /* General purpose array index    */
long status;   /* Status flag for function calls */
long zero = 0; /* General programer usage        */

char    es_node[STNAME + 1];	/* Name of node (for display) 		*/

double	mean[MAXBND],		/* Mean vector being edited		*/
	new_val;		/* new value for an element		*/

long    shape[9],		/* shape vector				*/
	size, 			/* Number of elements in vector		*/
	save;			/* Flag to save edited vector		*/

shape[0] = EDOUBLE;
shape[1] = 1;
shape[2] = MAXBND;

listem = TRUE;
/*
Prompt user for Image level, class and/or site name to process.
---------------------------------------------------------------*/
for (;;)
  {
  for (i = 0; i < 256; mean[i++] = 0);
  status = getcs(0);
  if (quit) 
  	return;
  if (back)
	continue;

  if (es_index(class, "*") >= 0)
  	{
	t_lclear(t_lines - 2, 1);
	t_output(t_lines - 2, 1,
	"[editstat-invalchar]  Invalid character specified");
	continue;
  	}

  if (status != E_SUCC)
  	{
	c_sterr(status,t_lines - 3);
	if (status == E_NOCL)
		{
		t_lclear(t_lines - 2, 1);
		t_output(t_lines - 2, 1, 
		"Use the command NEWCLASS to create a new class.");
		listem = FALSE;
		}
	if (status == E_NOSI)
		{
		t_lclear(t_lines - 2, 1);
		t_output(t_lines - 2, 1, 
		"Use the command EDITSITE to create a new site.");
		t_output(t_lines, 1, "Enter <CR> to continue.");
		t_read (estring, &tae_term);
		listem = TRUE;
		}
	continue;
  	}

  /*
  GETCS puts name of class, site or "0" (image level) into ostring.
  -----------------------------------------------------------------*/
  if (strcmp(ostring, "0") == 0 )
  	{
    	if (ic)
		{
		status = c_stget(&inlun, "NAME", &ic, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
		sprintf(es_node, "Class level of class:%s", ostring);
		}
	else 
 		strcpy(es_node, "Image level");
  	}
  else
	strcpy(es_node, ostring);


  /* 
  Get mean vector.
  ----------------*/
  status = c_stget (&inlun, "MEAN_VECTOR", &ic, &is, shape, mean);

  /* Class, site or data type not found, but no I/O error.
  --------------------------------------------------------*/
  if (status == E_GNLIO)
     {
     c_sterr(status,t_lines - 2);
     return;
     }
  else if (status != E_SUCC)
     {
     /*
     Creating new vector: Prompt for size of vector.
     -----------------------------------------------*/
     t_lclear (t_lines - 3, 1);
     t_lclear (t_lines - 2, 1);
     t_output(t_lines - 3, 1, "No Mean Vector Found.");
     t_output (t_lines - 2, 1, "New vector being created");
     for (;;)  /* Do until good reply */
        {
  	sprintf(estring, "Enter size of new mean vector or Back:");
  	prompt(ostring);
  	if (back)
		break;

  	/* Convert to integer.
  	----------------------*/
  	if ( sscanf(ostring, "%lf", &new_val) != 1)
  	   {
  	   t_output (t_lines - 2, 1, 
                     "[editstat-invalchar]  Invalid character specified");
  	   continue;
  	   }
	size = (long) new_val;	
	if (size > MAXBND || size < 1) 
	   {
	   sprintf(estring,"[editstat-invsize] Invalid size for MEAN_VECTOR");
	   t_output (t_lines - 2, 1, estring);
	   continue;
	   }
	else
	   {
	   shape[2] = size;
	   break;
	   }
        }  /* for (;;) get new vector size*/
     if (back)
	{
	listem = TRUE;
	continue;
	}
     }

  /* Get new mean vector data.
  ----------------------------*/
  t_lclear (t_lines - 2, 22);
  shape[0] = EDOUBLE;
  shape[1] = 1;
  save = newmean (mean, shape[2], es_node);
  if (quit)
	return;  
  listem = TRUE;
  if (back)
	continue;

  /* Put new data in stat file if indicated.
  ------------------------------------------*/
  if (save) 
  	status = c_stput (&inlun, "MEAN_VECTOR", &ic, &is, shape, mean); 

  }	/* Do forever */

}
