#include "editstat.h"
#include "msg.h"

/***********************************************************************
      FUNCTION editsite


   name- editsite                          

   language- C

   version- 1.0    date- 29-jun-83  programmer- k. s. mcgee
   version- 2.0    date- 1-=Oct     programmer- F. M. Irani

   function- replaces the site vertices of a given site within a given
             class.  allows user to create a new site if specifed site
             is not found within class specified.

********************************************************************** */


void es_editsite
(void)

{
 
long i;              /* General purpose array index    */
long status;         /* Status flag for function calls */
long fatal_err = -1; /* Fatal error flag for c_errmsg  */
long zero = 0;       /* General programmer usage       */

long  	ns,			/* Number of sites from stget 		*/
  	save = FALSE,		/* Save flag from chgsite		*/
  	*nshape,		/* Site NAME and NSITES shape vector 	*/
  	*pshape = NULL, /* Polygon data shape vector 		*/
  	*pbuf = NULL;	/* Buffer for polygon data		*/

/*
Dynamically allocate storage for integer vectors.
-------------------------------------------------*/
if ((nshape = (long *) malloc (9 * sizeof (long))) == NULL ||
    (pshape = (long *) malloc (9 * sizeof (long))) == NULL ||
    (pbuf = (long *) malloc (MAXPTS*2 * sizeof (long))) == NULL)
c_errmsg ("Error allocating dynamic memory", "EDITSTAT-editsite", &fatal_err);

/* Initialize shape buf to zero.
--------------------------------*/
pshape[0] = ELONG;
pshape[1] = 2;
pshape[2] = 0;
pshape[3] = 2;

/* Initialize temp buf to zero.
-------------------------------*/
for (i=0; i < MAXPTS*2; pbuf[i++] = 0);
	
listem = TRUE;
/* Get class,site indices:
Do forever or until QUIT or valid Class/Site specification.
-----------------------------------------------------------*/
for (;;)
  {
  /*
  Initialize temp buf to zero.
  ----------------------------*/
  pshape[2] = 0;
  status = getcs(2);
  if (quit) 
	{
	free(nshape);
    	free(pshape);
    	free(pbuf);
  	return;
	}

  if (es_index(class, "*") >= 0)
  	{
	t_lclear(t_lines - 2, 1);
	t_output(t_lines - 2, 1, "[editstat-invalchar]  Invalid character specified");
	listem = FALSE;
	continue;
  	}

  if (es_index(site, "*") >= 0)
  	{
	t_lclear(t_lines - 2, 1);
	t_output(t_lines - 2, 1, "[editstat-invalchar]  Invalid character specified");
	t_output(t_lines, 1, "Enter <CR> to continue.");
	t_read (estring, &tae_term);
	listem = TRUE;
	continue;
  	}


  /* Must have a valid class name to edit a site.
  -----------------------------------------------*/
  if (status == E_NOCL)
  	{
	t_lclear(t_lines - 3, 1);
	t_lclear(t_lines - 2, 1);
	notfnd("Class");
	t_output(t_lines - 2, 1, "Use the command NEWCLASS to create a new class.");
	listem = FALSE;
	continue;
  	}

  /* GETCS places site name into ostring.
  ---------------------------------------*/
  strcpy(site, ostring);
	

  if (status  !=  E_SUCC)
      {
      pshape[2] = 1;
      pbuf[0] = pbuf[1] = 0;
      save = chgsite (pshape, pbuf);
      if (quit)
	{
	free(nshape);
    	free(pshape);
    	free(pbuf);
	return;
	}
      listem = TRUE;
      if (back)
	continue;
      if (save) 
        {
        nshape[0] = ELONG;
        nshape[1] = 1;

        /* Create new site.
        -------------------*/
        status = c_stget (&inlun, "NSITES", &ic, &zero, nshape, &ns);
        if (status != E_SUCC)
	  {
	  c_sterr(status,t_lines - 2);
	  }

        is = ns + 1;
        nshape[2] = (long) strlen(site);
        status  = c_stput (&inlun, "NAME", &ic, &is, nshape, site);
        if (status  !=  E_DTNEW && status != E_NOSI)
          {
	  c_sterr(status,t_lines - 2);
          continue;
          }

        status = c_stput (&inlun, "POLYGON", &ic, &is, pshape, pbuf);
        if (status  !=  E_DTNEW) 
          {
	  c_sterr(status,t_lines - 2);
          continue;
          }
        }
        }
    else  /* Polygon already existed  */
      {
      status = c_stget (&inlun, "POLYGON", &ic, &is, pshape, pbuf);
      if (status  !=  E_SUCC)
        c_sterr(status,t_lines - 2);
      save = chgsite (pshape, pbuf);
      if (quit)
	  {
	  free(nshape);
    	  free(pshape);
    	  free(pbuf);
	  return;
	  }
      listem = TRUE;
      if (back)
	  continue;
      if (save) 
          {
          status = c_stput (&inlun, "POLYGON", &ic, &is, pshape, pbuf);
          if (status  != E_DTOLD) 
            c_sterr(status,t_lines - 2);
          }
      }  			/* if successful site  */
  } /* Do forever */

}
