#include <stdio.h>
#include <ctype.h>
#include "las.h"
#include "statio.h"

/* ------------------------------------------------------------ */
/* ---------	Constant and macro definitions 	   ------------ */
#define MAXPTS 5000
#define TERM 0
#define LP   1
#define FIL  2

#define wait()    t_output ( t_lines - 1,81, "\n");\
		  t_output ( t_lines - 1, 1, "Enter <CR> to continue:");\
  		  t_read (estring, &tae_term);\
                  t_lclear(t_lines - 3, 1);\
		  t_lclear(t_lines - 2, 1);\
		  t_lclear(t_lines - 1, 1);\
		  t_lclear(t_lines, 1);

#define label()    t_clear();\
		   t_output ( 1, 60, "COMMAND");\
		   t_output ( 1, 68,  command);

#define prompt(A) for (;;)\
  		  {\
		    quit = FALSE;\
		    back = FALSE;\
		    if (listem)\
  		        t_lclear( t_lines - 2, 1);\
		    listem = FALSE;\
  		    t_lclear( t_lines - 1, 1);\
  		    t_output( t_lines - 1, 1, estring);\
  		    t_lclear (t_lines, 1);\
  		    t_input (t_lines, 1, A, &tae_term);\
		    len = (long) strlen(A);\
  		    if (len == 0)\
  		    	continue;\
		    for (pr_i = 0; pr_i < len; pr_i++)\
		    {\
			if (isalpha(A[pr_i]))\
			   if (islower(A[pr_i]))\
				A[pr_i] = toupper(A[pr_i]);\
		    }\
		    if (strncmp(A, "QUIT", len) == 0)\
			quit = TRUE;\
		    if (strncmp(A, "BACK", len) == 0)\
			back = TRUE;\
		    if (strncmp(A, "LIST", len) == 0)\
			listem = TRUE;\
                    t_lclear (t_lines - 3, 1);\
		    t_lclear (t_lines - 2, 1);\
		    t_lclear (t_lines - 1, 1);\
		    t_lclear (t_lines, 1);\
  		    break;\
  		  }

/*
es_txtout initializes quit to FALSE,
Returns to menu on user entered "Quit"
--------------------------------------					*/
#define listline(X) 		quit = es_txtout(X, pflags, printer);	\
				if (quit) 				\
				{					\
					strcpy (command, "NONE"); 	\
					return;				\
				}

/*----------------------------------------------------------------------*/
/*	GENERAL USAGE VARIABLES:					*/
GLOBAL  char prog_name[] = "EDITSTAT";  /* program name */

GLOBAL	struct PARBLK block;     /* Editstat parameter block 	*/

GLOBAL char 
		*class,		/* Input hostfile statfile name	*/
		command[25],	/* Name of command performed 	*/
		*estring,	/* Used for prompt, etc.	*/
		*hos,		/* Input hostfile statfile name	*/
		*las,		/* Input LAS name statfile name */
		*ostring,	/* Used for prompt, etc.	*/
		*site,		/* Input hostfile statfile name	*/
		subcmd[8];		/* Subcommand name		*/

GLOBAL double 	svmin, 	/* Minimum histogram bin vlaue	*/
		svmax;	/* Maximum histogram bin vlaue	*/

GLOBAL long 
	es_nbands,		/* Number of bands found in mean vector */
	histfla,		/* Copy polygons only flag	*/
	len,			/*  character string lengths	*/
	listem,			/* Flag to list classes/sites   */
	mmflg,			/* Max and min are in histogram (flag)	*/
	pr_i,			/* Loop index for macros (e.g. prompt)  */
	quit,			/* General quit flag 			*/
	back;			/* General quit flag 			*/
	
GLOBAL int
    t_cols,			/* TAE terminal initialization parm.	*/
	t_lines;		/* TAE terminal initialization parm.	*/
	
GLOBAL int tae_term;		/*  Return value for t_ calls	*/

/* 	Specialized global variables for specific options:
	--------------------------------------------------	*/

  /* Statio:
     -------							*/
GLOBAL long 
	ic,			/* class index for statio	*/	
	is,			/* site index for statio	*/
	id,			/* node index for statio	*/
	nclass;         	/* Number of classes in file	*/

GLOBAL FILE
    *inlun;         /* Sfin unit no. */

  /* ESLIST:
     -------							*/
GLOBAL FILE *printer;	/* FPUTS pointer to output file */

GLOBAL   char 
	*prtfile,	/* Name of file output by ESLIST 	*/
  	usrfile[1][CMLEN],	/* User specified file for output 	*/
  	print[3][STNAME+1],	/* Output listing specifications  	*/
  	*prt[4];		/* Pointers to strings for block output */
  	
GLOBAL   long 
	listit[1],		/* Flag to EDITSTAT.PDF to run fileutil */
  	pflags[3];		/* Destination flags for c_textout 	*/
  
  /* ESCOPY:
     -------								*/
GLOBAL   long 
	copy,			/* Copy subcommand flag			*/
	inopen,			/* Input unit status flag.		*/
	outopen,		/* Output unit status flag.		*/
	pcop;			/* flag to copy polygons only (ESCOPY)  */

GLOBAL FILE *outlun; /* Sfout unit #                */


GLOBAL   char 
	*ohos, 			/* output hostfile name		*/
	 olas[1][CMLEN];		/* output las name		*/

  /* ESSORT:
     -------								*/
GLOBAL   char 
	direction[10];		/* Sort direction parameter		*/

GLOBAL   long 
	ocls,	/* Index to output class 			      */
	sdir,	/* SORT direction flag (0=descending / 1=ascending)   */
	sband,	/* Sort on mean value of this band		      */
	sort,	/* -SORT subcommand flag	*/
  	*sortlist;   /* Sort class indicies:
				 MAXCLS+1: +1 is for image level 
				 also used in DROPCLS 			*/
