#include "editstat.h"
#include "msg.h"

/*
     subroutine es_movesite

**********************************************************************

   name- movesite                       

   language- 

   version- 2.0             date- 30-Oct-89  programmer- F. Irani. STX
   version- 1.0             date- 30-jun-83  programmer- s. ross, sasc

**********************************************************************


*/

#define   moveheader(A, B, C, D)\
	  if (A[0] != '\0')\
          	{\
  		sprintf(estring, "Old Class/Site: %s/%s", A, B);\
		t_lclear(2, 1);\
		t_output(2, 1, estring);\
	  	}\
	  if (C[0] != '\0')\
	  	{\
		sprintf(estring, "New Class/Site: %s/%s", C, D);\
		t_lclear(3, 1);\
		t_output(3, 1, estring);\
	  	}

void es_movesite
(void)

{

long i;        /* General purpose array index    */
long status;   /* Status flag for function calls */
long zero = 0; /* General programmer usage       */

char	oldclass[STNAME+1], 
	oldsite[STNAME+1], 
	newclass[STNAME+1], 
	newsite[STNAME+1];

long	ns,			/* Number of sites per class 	*/
	shape[9];

oldclass[0] = '\0'; 
newclass[0] = '\0'; 
oldsite[0]  = '\0'; 
newsite[0]  = '\0';

/*
Do until user quits on either old or new class specifications.
--------------------------------------------------------------*/
for (;;)
  {

  listem = TRUE;	

  /*
  Get valid old Class specifications or quit.
  -------------------------------------------*/
  for (;;)
    {
  
    /*
    List classes.
    -------------*/
    if (listem)
    	{
	label();
	moveheader(oldclass, oldsite, newclass, newsite)
  	listcls();
  	if (quit)
  		return;
    	}
  
    /* Prompt for and read class name.
    ----------------------------------*/
    listem = FALSE;
    QPROMPT("Enter class name of origin",oldclass);
    if (quit)
    	return;
  
    if (strncmp(oldclass, "0", len) == 0)
    	{
	oldclass[0] = '\0';
	continue;
    	}

    if (strncmp(oldclass, "*", len) == 0)
    	{
	oldclass[0] = '\0';
	continue;
    	}

    if (strncmp(oldclass, "LIST", len) == 0)
    	{
        oldclass[0] = '\0';
  	listem = TRUE;
  	continue;
    	}
  
    /*
    Check that new names are in file.
    ---------------------------------*/
    status = c_stfdcl(&inlun, oldclass, &ic);
    if (status != E_SUCC)
    	  {
	  status = E_NOCL;
	  for (i =1; i <= nclass; ++i)
	  	{
		/*
		If can't find as specified, try for short form.
		-----------------------------------------------*/
		status = c_stget (&inlun, "NAME", &i, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
	  	status = E_NOCL;
  		if (es_index(ostring, oldclass) == 0)
			{
			status = E_SUCC;
			strcpy(oldclass, ostring);
			ic = i;
			break;
			}
	  	}
	  if (status != E_SUCC)
  	  	{
		notfnd("Class of origin name");
		listem = FALSE;
	        t_pos (t_lines, 1);
	        oldclass[0] = '\0';
	        continue;
          	}
    	  }    

    /* 
    Have valid class. Get Valid site or go back to classes.
    -------------------------------------------------------*/
    label();
    moveheader(oldclass, oldsite, newclass, newsite)
    listem = TRUE;

    /*
    Get number of sites in class.
    -----------------------------*/
    status = c_stget(&inlun, "NSITES", &ic, &zero, shape, &ns);
    if (status != E_SUCC)
    	{
	c_sterr(status,t_lines - 2);
    	}

    if (ns == 0)
    	{
	t_lclear(t_lines - 2, 1);
	sprintf(estring, "No sites found in class %s.", oldclass);
	t_output(t_lines - 2, 1, estring);
	t_output(t_lines, 1, "Enter <CR> to continue.");
	t_read (estring, &tae_term);
        oldclass[0] = '\0';
	back = TRUE;
	continue;
    	}

    for (;;)
      {
      /*
      List sites from appropriate class.
      ----------------------------------*/
      if (listem)
        {
	label();
      	moveheader(oldclass, oldsite, newclass, newsite)
        status = listsit(oldclass);
        if (status == E_FAIL)
        	continue;
        }

  
      /* Get old site name from User.
      -------------------------------*/
      listem = FALSE;
      BPROMPT("Enter the site name to move",oldsite);
      if (back)
        {
	listem = TRUE;
        oldclass[0]  = '\0';
        oldsite[0]  = '\0';
  	break;
        }
  
      if (strncmp(oldsite, "0", len) == 0)
	continue;

      if (strncmp(oldsite, "*", len) == 0)
	continue;

      if (strncmp(oldsite, "LIST", len) == 0)
        {
        oldsite[0]  = '\0';
  	listem = TRUE;
  	continue;
        }

      /*
      Check that names are in file.
      -----------------------------*/
      status = c_stfdsi (&inlun, oldclass, oldsite, &ic, &is);
      if (status != E_SUCC)
          {
	  for (i = 1; i <= ns; ++i)
	  	{
		/*
		If can't find as specified, try for short form.
		-----------------------------------------------*/
		status = c_stget (&inlun, "NAME", &ic, &i, shape, ostring);
		ostring[shape[2]] = '\0';
	  	status = E_NOSI;
  		if (es_index(ostring, oldsite) == 0)
			{
			status = E_SUCC;
			strcpy(oldsite, ostring);
			is = i;
			break;
			}
	  	}
	  if (status != E_SUCC)
	    	  {
		  c_sterr(status,t_lines - 2);
		  oldsite[0]  = '\0';
		  listem = FALSE;
		  continue;
	  	  }
          }    

      break;

      }	/* Get old site loop */

    if (!back)
    	break;

    } /* Get old Class loop */
  
  newclass[0] = '\0';
  newsite[0]  = '\0';

  /* Have old class/site. Get new Class/Site or go back to old class loop.
  ------------------------------------------------------------------------*/
  listem = TRUE;
  for (;;)
    {
    sprintf(estring, "Enter New Site name, List, or Back.");

    if (listem)
        {
        /* List classes.
        ----------------*/
	label();
        moveheader(oldclass, oldsite, newclass, newsite)
        listcls();
        }
    /* Prompt for and read class name.
    ----------------------------------*/
    BPROMPT("Enter destination class name",newclass);
    if (back)
        {
	listem = TRUE;
	newclass[0] = '\0';
	newsite[0] = '\0';
	oldclass[0] = '\0';
	oldsite[0] = '\0';
    	break;
        }

    if (strncmp(newclass, "0", len) == 0)
	continue;

    if (strncmp(newclass, "LIST", len) == 0)
        {
        newclass[0]  = '\0';
  	listem = TRUE;
  	continue;
        }

    /* Check that new class name is in file.
    ----------------------------------------*/
    status = c_stfdcl(&inlun, newclass, &ic);
    if (status != E_SUCC)
          {
	  for (i =1; i <= nclass; ++i)
	  	{
		/*
		If can't find as specified, try for short form.
		-----------------------------------------------*/
		status = c_stget (&inlun, "NAME", &i, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
	  	status = E_NOCL;
  		if (es_index(ostring, newclass) == 0)
			{
			status = E_SUCC;
			strcpy(newclass, ostring);
			ic = i;
			break;
			}
	  	}
	  if (status != E_SUCC)
  	  	{
       		notfnd("Destination class");
       		newclass[0] = '\0';
		listem = FALSE;
       		t_pos (t_lines, 1);
       		continue;
          	}
          }    

    moveheader(oldclass, oldsite, newclass, newsite)

    /* Have a valid new class name.  Get number of sites in class.
    --------------------------------------------------------------*/
    status = c_stget(&inlun, "NSITES", &ic, &zero, shape, &ns);
    if (ns == 0)
    	{
	t_lclear(t_lines - 2, 1);
	sprintf(estring, "No sites found in class %s.", newclass);
	t_output(t_lines - 2, 1, estring);
	back = TRUE;
    	}

    /*
    Have new class name.  Get new site name or go back to new classes.
    ------------------------------------------------------------------*/
    listem = TRUE;
    for (;;)
    	{
    	if (listem)
    	    {
            /* List sites from appropriate class.
            -------------------------------------*/
	    label();
            moveheader(oldclass, oldsite, newclass, newsite)
            status = listsit(newclass);
            if (status == E_FAIL)
    	        {
		newclass[0] = '\0';
    		back = TRUE;
        	break;
    	        }
    	    }

        /* Get site name from User.
        ---------------------------*/
    	listem = FALSE;
        BPROMPT("Enter a new name for this site",newsite);
        if (back)
    		{
    		newsite[0] = '\0';
    		listem = TRUE;
        	break;
    		}

        if (strncmp(newsite, "0", len) == 0)
		continue;

        if (es_index(newsite, "*") >= 0)
		{
		t_lclear(t_lines - 2, 1);
		t_output(t_lines - 2, 1,
		"[editstat-invalchar]  Invalid character specified");
		continue;
		}

        if (strncmp(newsite, "LIST", len) == 0)
    		{
    		newsite[0] = '\0';
    		listem = TRUE;
    		continue;
    		}

        /* Check that new site names are not duplicates.
        ------------------------------------------------*/
        status = c_stfdsi (&inlun, newclass, newsite, &ic, &is);
        if (status == E_SUCC)
           {
        sprintf(estring,"The site name %s from class %s is ",newsite,oldclass );
           t_output (t_lines - 3, 1,estring);
           sprintf(estring,"already used in class %s",newclass);
           t_output (t_lines - 2, 1,estring);
    	   newsite[0] = '\0';
           t_pos (t_lines, 1);
    	   listem = FALSE;
           continue;
           }
	else
		{
		/* Valid class site destination given.
		--------------------------------------*/
        	moveheader(oldclass, oldsite, newclass, newsite)
		break;
		}
    	}  /* Get new site name or go back to new classes. */

    if (back)
        {
	newclass[0] = '\0';
	newsite[0] = '\0';
	continue;
        }

    label();
    moveheader(oldclass, oldsite, newclass, newsite)

    for (;;)
    	    {
	    sprintf(estring, "Move site? [YES/NO]");
	    prompt(ostring);

	    if (strncmp(ostring, "YES", len) == 0)
		break;

	    if (strncmp(ostring, "NO", len) == 0)
	        {
	    	newsite[0] = '\0';
	    	newclass[0] = '\0';
	    	listem = TRUE;
		back = TRUE;
	    	break;
	        }

            }

    if (!back)
	break;
  
    } /* Get new Class/Site or go back to old class loop. */

  /* 
  User decided not to move to this class.
  ---------------------------------------*/
  if (back)
  	{
	newclass[0] = '\0';
	newsite[0] = '\0';
    	continue;
  	}

  /*
  Now do the work.
  ----------------*/
  move (oldclass, oldsite, newclass, newsite);

  /* Display results.
  -------------------*/
  moveheader(oldclass, oldsite, newclass, newsite)
  status = listsit(newclass);

  /* Reset for next move.
  -----------------------*/
  oldclass[0] = '\0';
  oldsite[0]  = '\0';
  newclass[0] = '\0';
  newsite[0]  = '\0';


  } /* Get old/new and new class/site specifications or Back.*/
  

}
