#include "editstat.h"
#include "msg.h"

/*
     FUNCTION es_newclass

******************************************************************************

   name- es_newclass                       	

   language- C

   version- 2.0    date-  10-Oct-89 programmer- F. Irani, STX
   version- 1.0    date-  3-dec-84  programmer- b. dealy

   function- newclass is called by editstat to add a new class to the
        stats file.

******************************************************************************


*/
void es_newclass
(void)

{

long status;      /* Status flag for function calls  */
long zero = 0;    /* General programmer usage        */

long 	shape[9],	/* name shape vector	      	*/
	valid;		/* Valid name flag 		*/
 
shape[0] = EBYTE;
shape[1] = 1;
listem = TRUE;

label();

/*
Do forever or until QUIT or valid Class/Site specification.
-----------------------------------------------------------*/
for (;;)
  {

  /*
  List classes.
  -------------*/
  if (listem)
  	{
	listcls();
	if (quit)
		return;
  	}

  /* Prompt for and read class name.
  ----------------------------------*/
  listem = FALSE;
  QPROMPT("Enter new class name",class);

  /* Repeat until user quits or is done creating classes.
  -------------------------------------------------------*/
  if (quit)
	return;

  if (strncmp(class, "LIST", len) == 0)
  	{
	ic = 0;
	class[0] = '\0';
	listem = TRUE;
	continue;
  	}

  /*
  Check naming syntax.
  --------------------*/
  valid = checkname(class);

  /*
  Disallow the two special cases permitted by checkname.
  ------------------------------------------------------*/
  if (strncmp(class, "0", len) == 0)
  	{
	ic = 0;
	t_output(t_lines - 2, 1,
	"[editstat-firstchar]  First character of name must not be numeric");
	valid = FALSE;
  	}

  if (strncmp(class, "*", len) == 0)
	continue;

  if (es_index(class, "*") >= 0)
  	{
	t_output(t_lines - 2, 1, "[editstat-char]  Invalid character found.  Use alphanumeric characters only");
	valid = FALSE;
  	}

  if (!valid)
	continue;

  /*
  Check that new name will not cause duplication in output file.
  --------------------------------------------------------------*/
  status = c_stfdcl (&inlun, class, &ic);
  if (status == E_SUCC)
     {
     t_output (t_lines - 2, 1, "[editstat-name]  Class name already exists.");
     listem = FALSE;
     continue;
     }
  
  shape[2] = (long) strlen(class);
  ++nclass;
  status = c_stput (&inlun, "NAME", &nclass, &zero, shape, class);
  if (status == E_GNLIO || status >= E_INVCL)
  	{
    	c_sterr(status,t_lines - 2);
    	continue;
  	}

  listem = TRUE;
  }  /* Do until quit */

}
