#include "editstat.h"
#include "msg.h"
/*
     FUNCTION es_rencls

**********************************************************************

   name- rencls                         

   language- C

   version- 2.0    date- 30-Oct-89  programmer- F. Irani, STX
   version- 1.0    date- 30-jun-83  programmer- s. ross, sasc
 
   function- rencls renames one class in a given statistics file

**********************************************************************

*/

void es_rencls
(void)

{

long i;        /* General purpose array index    */
long status;   /* Status flag for function calls */
long zero = 0; /* General programmer usage       */


char	oldname[STNAME+1],	/* Original class name */
	newname[STNAME+1];	/* new name for class  */

long	shape[9],		/* Shape vector        */
  	valid;			/* Valid name flag     */

listem = TRUE;

label();

/* Do forever or until QUIT or valid old Class specification.
-------------------------------------------------------------*/
for (;;)
  {

  newname[0] = '\0';
  oldname[0] = '\0';
  
  /* List classes.
  ----------------*/
  if (listem)
    {
    listcls();
    if (quit)
	return;
    }

  /* Prompt for and read class name.
  ----------------------------------*/
  listem = FALSE;
  QPROMPT("Enter class to change",oldname);
  if (quit)
	return;

  if (strncmp(oldname, "0", len) == 0)
      continue;

  if (strncmp(oldname, "LIST", len) == 0)
  	{
	listem = TRUE;
	continue;
  	}

  /* Try to get class name as specified.
  --------------------------------------*/
  status = c_stfdcl (&inlun, oldname, &ic);
  if (status != E_SUCC)
  	  {
	  for (i =1; i <= nclass; ++i)
	  	{
		/* If can't find as specified, try for short form.
		--------------------------------------------------*/
		status = c_stget (&inlun, "NAME", &i, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
	  	status = E_NOCL;
  		if (es_index(ostring, oldname) == 0)
			{
			status = E_SUCC;
			strcpy(oldname, ostring);
			ic = i;
			break;
			}
	  	}
	  if (status != E_SUCC)
  	  	{
		newname[0] = '\0';
		c_sterr(status,t_lines - 2);
		continue;
          	}
  	  }    

  /* Valid old class name was entered.
  ------------------------------------*/
  sprintf(estring, "Old class name: %s", oldname);
  t_lclear(2, 1);
  t_output(2, 1, estring);
  sprintf(estring, "New class name: %s", newname);
  t_lclear(3, 1);
  t_output(3, 1, estring);

  /* Do forever or until QUIT or valid new Class specification.
  -------------------------------------------------------------*/
  listem = FALSE;
  for (;;)
    {
    newname[0] = '\0';
    if (listem)
    	{
        /* List classes.
        ----------------*/
        listcls();
 	sprintf(estring, "Old class name: %s", oldname);
  	t_lclear(2, 1);
  	t_output(2, 1, estring);
    	sprintf(estring, "New class name: %s", newname);
    	t_lclear(3, 1);
    	t_output(3, 1, estring);
    	if (quit)
    		return;
    	}

    /* Prompt for and read class name.
    ----------------------------------*/
    listem = FALSE;
    BPROMPT("Enter a new name for this class",newname);
    if (back)
        {
	oldname[0] = '\0';
	newname[0] = '\0';
  	sprintf(estring, "Old class name: %s", oldname);
  	t_lclear(2, 1);
  	t_output(2, 1, estring);
    	sprintf(estring, "New class name: %s", newname);
    	t_lclear(3, 1);
    	t_output(3, 1, estring);
	listem = TRUE;
  	break;
        }

    valid = checkname(newname);
    if (!valid)
    	continue;

    if (strncmp(newname, "0", len) == 0)
  	continue;

    if (es_index(newname, "*") >= 0)
        {
	t_lclear(t_lines - 2, 1);
	t_output(t_lines - 2, 1,
	"[editstat-invalchar]  Invalid character specified");
	continue;
        }

    if (strncmp(newname, "LIST", len) == 0)
        {
	listem = TRUE;
	continue;
        }

    sprintf(estring, "Old class name: %s", oldname);
    t_lclear(2, 1);
    t_output(2, 1, estring);
    sprintf(estring, "New class name: %s", newname);
    t_lclear(3, 1);
    t_output(3, 1, estring);

    /* Check new name doesn't already exist.
    ----------------------------------------*/
    for (i = 1; i <= nclass; ++i)
    	  {
          status = c_stget (&inlun, "NAME", &i, &zero, shape, oldname);
	  oldname[shape[2]] = '\0';
          if (strcmp(oldname, newname) == 0)
    	  	{
		status = -999;
    		t_output (t_lines - 2, 1,
		"[edistat-class]  Class name already exists.");
    		newname[0] = '\0';
    		sprintf(estring, "New class name: %s", newname);
    		t_lclear(3, 1);
    		t_output(3, 1, estring);
    	        break;
          	}
    	  }

    /* Break if new name does not exist already.
    --------------------------------------------*/
    if (status != -999)
    	break;
    else
	newname[0] = '\0';

    }

  if (back)
	continue;

  /* Replace the old class name with the new class name.
  ------------------------------------------------------*/
  shape[0] = EBYTE;
  shape[1] = 1;
  shape[2] = (long) strlen(newname);
  status = c_stput(&inlun, "NAME", &ic, &zero, shape, newname);
  if (status != E_DTOLD)
	c_sterr(status,t_lines - 2);

  listem = TRUE;

  }

}
