#include "editstat.h"
#include "msg.h"

/*
     FUNCTION es_rensite

**********************************************************************

   name- rensite                        

   language- C

   version- 1.0    date- 16-jun-83  programmer- F. Irani
   version- 1.0    date- 16-jun-83  programmer- s.ross/sasc

   function- rensite renames one site in a given statistics file

**********************************************************************


*/
void es_rensite
(void)

{

long i;         /* General purpose array index    */
long status;    /* Status flag for function calls */
long zero = 0;  /* General Programmer usage       */

char		newname[STNAME+1],	/* New name for site		*/
		oldname[STNAME+1];	/* Site name to be changed 	*/

long		dc,			/* Dummy class index for check	*/
	  	ds,			/* Dummy site index for check	*/
    		ns,			/* Number of sites in a class   */
	  	valid,			/* Valid name flag		*/
	  	shape[9];		/* Shape vector for new name	*/

shape[0] = EBYTE;
shape[1] = 1;
label();

/*
Do until return on quit.
------------------------*/
for (;;)
  {
  listem = TRUE;
  oldname[0] = '\0';
  newname[0] = '\0';
  class[0] = '\0';

  /*
  Do forever or until QUIT. (Get an Old Class site pair.)
  -------------------------------------------------------*/
  for (;;)
    {
  
    if (listem)
      {
      /*
      List classes.
      -------------*/
      listcls();
      if (quit)
		return;
      sprintf(estring, "Old Class/Site: %s/%s", class, oldname);
      t_lclear(2, 1);
      t_output(2, 1, estring);
      if (newname[0] != '\0')	
        {
	sprintf(estring, "New Site Name: %s", newname);
	t_lclear(3, 1);
	t_output(3, 1, estring);
        }
      }
  
    /* Prompt for and read class name.
    ----------------------------------*/
    listem = FALSE;
    QPROMPT("Enter a class name",class);
    if (quit)
    	return;
    if (strncmp(class, "LIST", len) == 0)
        {
	class[0] = '\0';
    	listem = TRUE;
    	continue;
        }

    /* Try to get class name as specified.
    --------------------------------------*/
    status = c_stfdcl (&inlun, class, &ic);
    if (status != E_SUCC)
          {
	  status = E_NOCL;
	  for (i =1; i <= nclass; ++i)
	  	{
		/* If can't find as specified, try for short form.
		--------------------------------------------------*/
		status = c_stget (&inlun, "NAME", &i, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
	  	status = E_NOCL;
  		if (es_index(ostring, class) == 0)
			{
			status = E_SUCC;
			strcpy(class, ostring);
			ic = i;
			break;
			}
	  	}
	  if (status != E_SUCC)
  	  	{
		t_output(3,1,"error 1");
  		class[0] = '\0';
  		c_sterr(status,t_lines - 2);
          	listem = TRUE;
	  	continue;
          	}
          }    

    /* Determine no. of sites.
    --------------------------*/
    status = c_stget(&inlun, "NSITES", &ic, &zero, shape, &ns);
    if (ns == 0)
    		{
		t_lclear(t_lines - 2, 1);
    		sprintf(estring, "No sites found in class %s.", class);
		t_output(t_lines - 2, 1, estring);
		listem = TRUE;
		class[0] = '\0';
		oldname[0] = '\0';
    		continue;
    		}

    /* Valid Class was specified.
    -----------------------------*/
    break;

    }
  
  listem = TRUE;
  
  /*
  Do forever or until Back or valid old site name specification.
  --------------------------------------------------------------*/
  for (;;)
    {
    if (listem)
    	  {
  	  label();
  
  	  /*
  	  List sites.
  	  -----------*/
	  if (class[0] != '\0')	
	  	{
		sprintf(estring, "Old Class/Site: %s/%s", class, oldname);
		t_lclear(2, 1);
  	  	t_output(2, 1, estring);
	  	}
  	
	  sprintf(estring, "New Site Name: %s", newname);
  	  t_lclear(3, 1);
  	  t_output(3, 1, estring);

  	  listsit(class);
  	  if (quit)
	  	{
		class[0] = '\0';
		oldname[0] = '\0';
		newname[0] = '\0';
  	    	return;
	  	}
    	  }
  
    /*
    Prompt for and read site name.
    ------------------------------*/
    listem = FALSE;
    newname[0] = '\0';
    BPROMPT("Enter site name to be changed",oldname);
    if (back)
        {
	oldname[0] = '\0';
	class[0] = '\0';
    	listem = TRUE;
        sprintf(estring, "Old Class/Site: %s/%s", class, oldname);
        t_lclear(2, 1);
        t_output(2, 1, estring);
	sprintf(estring, "New Site Name: %s", newname);
	t_lclear(3, 1);
	t_output(3, 1, estring);
    	break;
        }

    if (strncmp(oldname, "0", len) == 0)
	continue;

    if (strncmp(oldname, "LIST", len) == 0)
        {
	oldname[0] = '\0';
        /* newname[0] = '\0'; */
    	listem = TRUE;
  	continue;
        }

    /*
    Now have old Class/Site specifications:  Retrieve indicies.
    -----------------------------------------------------------*/
    status = c_stfdsi (&inlun, class, oldname, &ic, &is);
    if (status != E_SUCC)
    	  {
    	  /*
    	  Determine no. of sites.
    	  -----------------------*/
    	  status = c_stget(&inlun, "NSITES", &ic, &zero, shape, &ns);
    	  if (ns == 0)
       	  	{
    		t_lclear(t_lines - 2, 1);
    		sprintf(estring, "No sites found in class %s.", class);
		t_output(t_lines - 2, 1, estring);
		back = TRUE;
		class[0] = '\0';
		oldname[0] = '\0';
    		break;
    	  	}

	  /*
	  If can't find as specified, try for abbreviation.
	  -------------------------------------------------*/
	  for (i=1; i <= ns; ++i)
	  	{
		status = c_stget (&inlun, "NAME", &ic, &i, shape, ostring);
		ostring[shape[2]] = '\0';
		status = E_NOSI;
		if (es_index(ostring, oldname) == 0)
			{
			strcpy(oldname, ostring);
			is = i;
    			status = E_SUCC;
    			break;
			}
	  	}

	  /* Site not found.
	  ------------------*/
    	  if (status != E_SUCC)
    	  	{
    		c_sterr(status,t_lines - 2);
		listem = FALSE;
        	oldname[0] = '\0';
  		continue;
    	  	}
    	  }

    if (class[0] != '\0')	
    	{
	sprintf(estring, "Old Class/Site: %s/%s", class, oldname);
	t_lclear(2, 1);
	t_output(2, 1, estring);
    	}

  	sprintf(estring, "New Site Name: %s", newname);
    	t_lclear(3, 1);
   	t_output(3, 1, estring);

    listem = FALSE;
  
    /*
    Do forever or until QUIT or valid new site name specification.
    --------------------------------------------------------------*/
    for (;;)
      {
      if (listem)
          {
  	  label();
  	  /* List classes.
  	  ----------------*/
  	  listsit(class);
  	  if (quit)
	  	{
		newname[0] = '\0';
		oldname[0] = '\0';
		listem = TRUE;
  	    	return;
	  	}

	  if (class[0] != '\0')	
          	{
  	  	sprintf(estring, "Old Class/Site: %s/%s", class, oldname);
		t_lclear(2, 1);
		t_output(2, 1, estring);
	  	}
	  sprintf(estring, "New Site Name: %s", newname);
	  t_lclear(3, 1);
	  t_output(3, 1, estring);
          }
  
      /* Prompt for and read class name.
      ----------------------------------*/
      listem = FALSE;
      BPROMPT("Enter a new site name",newname);
      if (back)
        {
	oldname[0] = '\0';
	newname[0] = '\0';
	listem = TRUE;
      	break;
        }

      if (strncmp(newname, "LIST", len) == 0)
        {
	newname[0] = '\0';
      	listem = TRUE;
    	continue;
        }

      /* Check new name doesn't already exist.
      ----------------------------------------*/
      status = c_stfdsi (&inlun, class, newname, &dc, &ds);
      if (status == E_SUCC)
      		{
    		t_output (t_lines - 2, 1,
		"[edistat-name]  Site name already exists.");
  		newname[0] = '\0';
		listem = FALSE;
    		continue;
      		}

      if (strncmp(newname, "0", len) == 0)
		continue;

      if (es_index(newname, "*") >= 0)
      		{
		t_output(t_lines - 2, 1,
		"[editstat-char]  Invalid character found.  Use alphanumeric characters only");
		valid = FALSE;
		continue;
      		}

      valid = checkname(newname);
      if (valid)
      		{
		sprintf(estring, "New Site Name: %s", newname);
		t_lclear(3, 1);
		t_output(3, 1, estring);
		break;
      		}

      }
  
    if (back)
	continue;

    /*
    Replace the old site name with the new site name.
    -------------------------------------------------*/
    shape[2] = len;
  
    status = c_stput (&inlun, "NAME", &ic, &is, shape, newname);

    if (status != E_DTOLD)
        {
	t_output(4,1,"error 2");
	c_sterr(status,t_lines - 2);
	break;
        }

    listem = TRUE;
  
    }

  }

}
