#include <stdio.h>
#include "las.h"
#include "desc.h"
#include "protos.h"
#define TERM 0
#define LP   1
#define FIL  2

/* 
---------------------------------------------------------------------------
MODIFICATION				DATE		PROGRAMMER
------------				----		----------
Call the new version of PTERM. 		1/12/88 	F.Irani/STX
Renamed es_txtout for exclusive use 
by EDITSTAT				7/25/89		F.Irani/STX
Call the editstat specific version 
of PTERM (es_pterm) to avoid ending 
processing at user specified quit.	7/25/89		F.Irani/STX
---------------------------------------------------------------------------- */

int es_txtout
(
    char buf[],			/* Text to be written out                     */
    long print[],		/* Print options (FILE, LP, TERM)             */
    FILE *fp			/* File descriptor for print FILE or LP       */
)
				/* if fp == 0 then no file open               */
{

long	quit,
	zero = 0;		/* zero to be passed to be passed to es_pterm */

/* 
Initialize quit per call
------------------------	*/
quit = FALSE;
if (((print[LP]) || (print[FIL])) && fp != NULL)
   fprintf (fp, "%s\n", buf);
if (print[TERM])
   quit = es_pterm (buf, &zero);

return(quit);

}

/*-------------------------------------------------------------*/
#ifdef vms
/*
This is the VMS FORTRAN bridge.
-------------------------------*/
int esout
(
    struct DESC *d_buf,
    long print[],
    FILE *fp
)
{

long quit;
return (quit = es_txtout (d_buf->addr, print, fp));

}
#endif
/*-------------------------------------------------------------*/
#ifdef unix
/*
This is the Unix FORTRAN bridge.
--------------------------------*/
int esout_
(
    char buf[],
    long print[],
    FILE *fp
)
{
return (es_txtout (buf, print, fp));
}
#endif
