#include "editstat.h"
#include "msg.h"

/*
     FUNCTION esc_copy(data_type,ic,is,shape)

   NAME- ESC_COPY                        

   LANGUAGE- C				TYPE- FUNCTION

   VERSION- 2.0    DATE-  10-Oct    PROGRAMMER- F. IRANI(STX)-LAS V5.0
   VERSION- 1.0    DATE- 20-JUN-83  PROGRAMMER- G.MCCONAUGHY(SASC)

   FUNCTION- ESC_COPY COPIES STATISTICS FROM ONE STATISTICS FILE TO
        ANOTHER, WITH NO ALTERATION

**********************************************************************

*/

int esc_copy
(
    char data_type[],
    long shape[]
)

{

long status;           /* Status flag for function calls */  
long fatal_err = -1;   /* Fatal error flag for c_errmsg  */
long inf_err = 1;      /* Information flag for c_errmsg  */

double  *copybuf,
	smallbuf[MAXBND];

long 	allocated,
	size;


allocated = FALSE;

/*
Allocate space for buffers larger than MAXBND+2 (arbitrary programmer choice).
(Histograms may be size 258. MAXBND+2 will avoid allocation to copy histograms.)
------------------------------------------------------------------------------*/
if (shape[2] <= MAXBND+2)
	copybuf = smallbuf;
else
	{
	size = shape[2];

	if (shape[0] == EBYTE)
		size *= sizeof (char);
	else if (shape[0] == EWORD)
		size *= sizeof (short);
	else if (shape[0] == ELONG)
		size *= sizeof (long);
	else if (shape[0] == EREAL)
		size *= sizeof (float);
	else if (shape[0] == EDOUBLE)
		size *= sizeof (double);
	else if (shape[0] == ECOMP)
		size *= 2 * sizeof (float);
	else if (shape[0] == EDCOMP)
		size *= 2 * sizeof (double);
	else 
		{
		sprintf(estring, "Invalid Shape Vector in %s.", data_type);
		c_errmsg(estring, "editstat-shape", &inf_err);
		status = E_FAIL;
		return(status);
		}

	if ( (copybuf = (double *) malloc (size) ) == NULL )
		{
		c_errmsg ("Error allocating dynamic memory",
			  "editstat-alloc", &inf_err);
		status = E_FAIL;
		return(status);
		}
	else
		allocated = TRUE;
	}

/* Point to input stats file and get data.
------------------------------------------*/
status = c_stget (&inlun, data_type, &ic, &is, shape, copybuf);
if (status != E_SUCC) 
   {
   erread("stats file");
   }
else
   	{
	if ( strcmp(data_type,"NAME") == 0)
	   	{
		/* Copybuf is of type double: 
		Set last element to zero to prevent access violation 
		in c_stput and copy to string buffer for proper display.
		--------------------------------------------------------*/
		copybuf[shape[2]] = 0;
		strcpy(ostring, (char *) copybuf);
		ostring[shape[2]] = '\0';
		sprintf(estring, "Copying %s", ostring);
		c_errmsg(estring,"informational",&inf_err);
	   	}
	status = c_stput (&outlun, data_type, &ocls, &is, shape, copybuf);
	if ((status > E_NOSI) && (status != E_DTNEW))
	   {
 	   erwrite("stats file");
	   }
	}

/* If space was allocated free it for this call.
------------------------------------------------*/
if (allocated)
   free(copybuf);

return(status);

}
