#include "editstat.h"

/*
     FUNCTION esc_donode(blist,num)

**********************************************************************

   name- esc_donode                       

   language- C

   version- 1.0    date- 20-jun-83  programmer- g.mcconaughy(sasc)
   revision 1.0    date- 8-nov-84   programmer- b.dealy/s.ross scn#20-357
   version- 1.0    date- 10-Oct-89  programmer- F.Irani STX

   function- esc_donode gets all data types associated with a
        particular node and calls the appropriate function that
        processes that data type

**********************************************************************

*/
void esc_donode
(
    long blist[],
    long num
)

{

long status;      /* Status flag for function calls */
long inf_err = 1; /* Information flag for c_errmsg  */

char	data_type[STNAME+1];

long	hcount,
	shape[9];

/*
Loop over stat node, processing each data type.
-----------------------------------------------*/
hcount = 0;
id = 1;
status = TRUE;
while (status != E_NODT)
   {
   data_type[0] = '\0';
   status = c_stnode (&inlun, &ic, &is, &id, data_type, shape);
   ++id;

   /* If data exists.
   ------------------*/
   if (status  ==  E_SUCC) 
      {
      if (pcop)
         {
	 if ( (strncmp(data_type,  "POLY", 4)   != 0) &&
	      (strncmp(data_type,  "NAME", 4)   != 0) &&
	      (strncmp(data_type,  "NPOINT", 6) != 0) )
	 continue;
         }
      if ((strcmp(data_type,"NAME") != 0 &&
           strncmp(data_type,"HIST", 4) != 0))
         {
         sprintf(estring, "Copying %s", data_type);
         c_errmsg(estring,"informational",&inf_err);
         }

      if ((num != 0) && (strncmp(data_type,  "MEAN", 4) == 0))
         status =  esc_mean (data_type, shape, blist, num);

      else if ((num != 0) && (strncmp(data_type, "COVAR", 5) == 0) )
         status = esc_covar (data_type, shape, blist, num);

      else if ((num != 0) && (strncmp(data_type, "CORRE", 5) == 0)  )
         status = esc_corre (data_type, shape, blist, num);

      else if ((num != 0) && (strncmp(data_type, "HIST", 4) == 0) )
         {
         ++hcount;
         status = esc_histo (data_type, shape, blist, num, hcount);
         }
      else
         /*  Data exists but is either a data type that doesn't need 
             reducing or the user just wants to copy and not reduce.
         -----------------------------------------------------------*/
         status = esc_copy (data_type, shape);
      }		/* if status  ==  E_SUCC */
      }     /* do while status  */

return; 
}
