#include "editstat.h"

/*
-------------------------------------------------------------------------
     FUNCTION get_bands


   name- get_bands                   

   Language- C

   VERSION- 1.0    DATE- 20-JUN-83  PROGRAMMER- G.MCCONAUGHY(SASC)
   REVISION 1      DATE  16 JUN 84  PROGRAMMER  B. DEALY SAR 20-221
   VERSION- 2.0    DATE-  7-JAN-89  PROGRAMMER- F. IRANI STX LAS V5.0 Port

   FUNCTION- get_bands retrieves the bands the need to be COPied 

------------------------------------------------------------------------- */


void get_bands
(
    long blist[MAXBND],		/* List of bands to be copied */
    long *num			/* Index into bands to be deleted	*/
)
{

long i;              /* General purpose array index    */
long j;              /* General purpose array index    */
long k;              /* General purpose array index    */
long status;         /* Status flag for function calls */
long fatal_err = -1; /* Fatal error flag for c_errmsg  */
long inf_err = 1;    /* Information flag for c_errmsg  */
long zero = 0;       /* General programmer usage       */
long one = 1;        /* General programmer usage       */


struct  VARIABLE *var;

char	data_type[STNAME+1];	/* data_type buffer from stget		*/

double	mean[MAXBND];		/* Mean vector buffer for sort		*/

long	dupe = FALSE,		/* Duplicate class entered flag		*/
	shape[9];		/* Shape vector for c_stget		*/


ostring[0] = '\0';
var = p_find(&block,"BANDS");
*num = var->v_count;
if (*num > 0)
   {
   for (i = 0; i < *num; i++)
      blist[i] = IVAL(*var,i);

   strcpy(data_type, "MEAN_VECTOR");

/*
Get number of bands from class 1 mean vector.
---------------------------------------------*/
   status = c_stget( &inlun, data_type, &one, &zero, shape, mean);
   if (status == E_SUCC)
      {
      es_nbands = shape[2];
      }
   else if (status == E_NOCL)
      {
/*
If no mean vector for class one try for image level vector.
-----------------------------------------------------------*/
      status = c_stget(&inlun, data_type, &zero, &zero, 
		       shape, mean);
      if (status == E_SUCC)
         {
         es_nbands = shape[2];
         }
      else if (status == E_NODT)
         {
         c_errmsg("There are no bands to reduce","editstat-warning",&inf_err);
         }
      else
         {
         c_sterr(status,t_lines - 2);
	 c_errmsg("Fatal error encountered","editstat-fatal",&fatal_err);
         }
      }
   else
      {
      c_errmsg("No MEAN_VECTOR found in first class.","editstat-mean",&inf_err);
      c_errmsg("Fatal error encountered","editstat-fatal",&fatal_err);
      }
   
/*
Check for valid bands.
----------------------*/
   for ( j = 0 ; j < *num; j++)
      {
      if (blist[j] > es_nbands)
         {
         sprintf(estring, "Band specified (%d) is greater than %d", 
                 blist[j],es_nbands);
         c_errmsg(estring,"editstat-bands",&inf_err);
         c_errmsg("Fatal error encountered","editstat-fatal",&fatal_err);
         }
    
      dupe = FALSE;
      
/*
Check for duplicate bands.
--------------------------*/
      for (k = 0; k < *num; ++k)
         {
         if ((blist[j] == blist[k]) && (j != k)) 
            {
            dupe = TRUE;
            break;
            }
         }
   
      if (dupe)
         {
         c_errmsg("Same band was specified twice","editstat-same",&inf_err);
         c_errmsg("Fatal error encountered","editstat-fatal",&fatal_err);
         }
   
      }
   }
return;
}  /*  get_bands  */
