#include "editstat.h"
#include "msg.h"
/*---------------------------------------------------------------------------

   Name- getcs 

   Language- C     

   Version- 1.0   Date-  6-OCT-89  Programmer- F. Irani     (V5.0 Conversion)

   Function: Allows user to select a class and/or site name from the file.

---------------------------------------------------------------------------
*/

int getcs
(
    long level     /* Highest level of search allowed:
			=0: prompt for image, class or site,
			=1: prompt for  class or site,
			=2: prompt for  site.			*/
)

{

long i;        /* General purpose array index    */
long status;   /* Status flag for function calls */
long zero = 0; /* General programmer usage       */


long 	ns,		/* Number of sites in a class			*/
	shape[9],	/* Shape vector for classes and sites 		*/
	nshape[9],	/* Dummy shape vector to get number of sites 	*/
  	valid;		/* Valid name entered flag			*/

/*
Initialize flags.
-----------------*/
quit = FALSE;

/*
Do forever or until Quit or valid Class/Site specification.
-----------------------------------------------------------*/
for (;;)
  {

  if (listem)
   	  {
	  /*
	  List classes.
	  -------------*/
	  label();
	  listcls();
 	  if (nclass == 0)
		{
	        notfnd("Classes");
		}
	  if (quit)
		return(E_FAIL);
  	  }

  /*
  Prompt for and read class name.
  -------------------------------*/
  listem = FALSE;
  if (level)
     {
     QPROMPT("Enter class name",class);
     }
  else
     {
     sprintf(estring,"Enter Class name, 0 for image level, List or Quit.");
     prompt(class);
     }
  
  if (quit)
	return(E_FAIL);

  if (listem)
	continue;

  valid = checkname(class);
  if (!valid)
	continue;
  
  /*
  Image, class or site level requested. If level > zero, image level ignored.
  ---------------------------------------------------------------------------*/
  if ( strncmp(class, "0", len) == 0 && level < 2 )
  	{
	if (level)
		continue;
	strcpy(ostring, class);
  	status = E_SUCC;
	ic = is = 0;
	return(status);
  	}
  
  if ( strncmp(class, "0", len) == 0 && level == 2 )
	continue;

  if ( es_index(class, "*") >= 0 && level == 2 )
  	{
	t_lclear(t_lines - 2, 1);
	t_output(t_lines - 2, 1,
	"[editstat-invalchar]  Invalid character specified");
	continue;
  	}

  if ( strncmp(class, "*", len) == 0 && level < 2 )
  	{
	strcpy(ostring, class);
	status = E_SUCC;
	ic = 0;
	return(status);
  	}
  

  /*
  Try to get class name as specified.
  -----------------------------------*/
  status = c_stfdcl (&inlun, class, &ic);
  if (status != E_SUCC)
  	  {
	  status = E_NOCL;
	  for (i =1; i <= nclass; ++i)
	  	{
		/*
		If can't find as specified, try for short form.
		-----------------------------------------------*/
		status = c_stget (&inlun, "NAME", &i, &zero, shape, ostring);
		ostring[shape[2]] = '\0';
  		if (es_index(ostring, class) == 0)
			{
			status = E_SUCC;
			strcpy(class, ostring);
			ic = i;
			break;
			}
		else
	  		status = E_NOCL;
	  	}
	  if (status != E_SUCC)
		return(status);
  	  }

  strcpy(ostring, class);	

  /*
  Return with class name if level = 1.
  ------------------------------------*/
  if (level == 1)
	return(status);

  listem = TRUE;

  /*
  Determine no. of sites.
  -----------------------*/
  status = c_stget(&inlun, "NSITES", &ic, &zero, nshape, &ns);
  if (ns == 0)
  	{
	/* If no sites are in the class allow user to choose class level.
	-----------------------------------------------------------------*/
	sprintf(estring, "No sites found in class %s.", class);
	back = TRUE;
  	}

  /* Do until good site name or back.
  -----------------------------------*/
  for (;;)
  	  {
  	  if (listem)
	    {
	    /*
	    List sites from appropriate class.
	    ----------------------------------*/
	    label();
	    status = listsit(class);
	    if (quit)
	  	return(E_FAIL);
	    }

	  listem = FALSE;
	  if (level < 2)
             {
	     if (status)
	         sprintf(estring,
  	              "Enter Site name, 0 for class level, List or Back.");
	     else
	         sprintf(estring,
  	              "Enter 0 for class level, List or Back.");
	     prompt(site);
             }
	  else
             {
	     sprintf(estring,
  	              "Enter site name, List or Back.");
	     prompt(site);
             }


	  /*
	  Either quit or good site name.
	  ------------------------------*/
	  if (listem)
		continue;

	  if (back)
  	      {
  	      listem = TRUE;
	      break;
  	      }

  	  /*
  	  If level = 2 insist on a site name. No Class level.
  	  ---------------------------------------------------*/
  	  if (strncmp(site, "0", len) == 0)
  	  	{
	  	if (level == 2)
  			continue;
  		else
  			{
			strcpy(ostring, site);	
  			is = 0;
  			return(E_SUCC);
  			}
  	  	}

	  /*
	  Check for valid naming convention.
	  ----------------------------------*/
    	  valid = checkname(site);
     	  if (!valid)
  	       continue;

  	  /*
	  Try to get site name as specified.
	  ----------------------------------*/
	  status = c_stfdsi (&inlun, class, site, &ic, &is);
	  if (status != E_SUCC)
	  	  {
		  /*
		  If can't find as specified, try for abbreviation.
		  -------------------------------------------------*/
	 	  for (i=1; i <= ns; ++i)
		        {
			status = c_stget (&inlun, "NAME", &ic, &i,
				 shape, ostring);
			ostring[shape[2]] = '\0';
			if (es_index(ostring, site) == 0)
  				{
  				strcpy(site, ostring);
  				is = i;
  				return(E_SUCC);
  				}
  		        }

		  /*
		  Site not found. Caller may wish to create new site.
		  ---------------------------------------------------*/
		  strcpy(ostring, site);	
		  return(E_NOSI);
  	          }
	  else
	  	{
		strcpy(ostring, site);	
	  	return(E_SUCC);
	  	}

  	  } 	/* Get site name as specified.  */

  }  /* Do until good class/site name(s) entered */

}
