#include "editstat.h"
#include "util.h"
#include "msg.h"

/*
**********************************************************************

   name- listsit                        

   language- C		

   version- 2.0    date- 30-Oct-89  programmer- F. Irani, STX
   version- 1.0    date- 24-jun-83  programmer- L. Urquhart,SASC

   Function- Lists the names of the sites in the selected class.

**********************************************************************
*/


int listsit
(
    char listclass[]	/* Class name -- not a local variable  */
)

{

long zero = 0;  /* General programmer usage       */
long one  = 1;  /* General programmer usage       */
long status;    /* Status flag for function calls */

char	nbuf[CMLEN+1]; 	/* Local class name buffer		*/

long	cls,		/* Local Class index 			*/
	lineno,		/* Terminal screen line no. for display	*/
	ns, 		/* Number of sites in class		*/
	site,		/* Local site index			*/
	shape[9];	/* Shape vector for c_stget		*/

quit = FALSE;

/*
Get class index.
----------------*/
if  ( (strncmp(listclass, "0", len) == 0) ||
      (strncmp(listclass, "*", len) == 0))
  	return(one);

status = c_stfdcl (&inlun, listclass, &cls); 

if (status != E_SUCC) 
   {
   t_output(5,1,"Error in listsit");
   notfnd("Class");
   return(zero);
   }

/*
Determine no. of sites.
-----------------------*/
status = c_stget(&inlun, "NSITES", &cls, &zero, shape, &ns); 

if (ns == 0)
	{
	notfnd("Sites");
	return(zero);
	}

/* Display heading.
-------------------*/

sprintf(estring, "------ Sites found in class %s  ------", listclass);
t_output (5, 1, estring);

/* Loop through all sites.
--------------------------*/
for (site = 1; site <= ns; ++site)
	{
	/* Get site name.
	-----------------*/
	status = c_stget (&inlun, "NAME", &cls, &site, shape, nbuf);
	nbuf[shape[2]] = '\0';

	lineno = (site % (t_lines - 9));
	t_lclear (lineno + 5, 1);
	t_output (lineno + 5, 1, nbuf);
	if ((lineno == t_lines - 10) && (site < ns))
		{
		sprintf(estring,"Enter Select, Quit or return");
  		t_lclear(t_lines - 1, 1);
  		t_output(t_lines - 1, 1, estring);
  		t_lclear (t_lines, 1);
  		t_input (t_lines, 1, ostring, &tae_term);
		len = (long) strlen(ostring);
	        c_low2up(ostring,&len);
		if (len > 0)
			{
			if (strncmp(ostring, "QUIT", len) == 0)
				{
				ostring[0] = '\0';
				quit = TRUE;
				return(zero);
				}
			else if (strncmp(ostring, "SELECT", len) == 0)
				{
				ostring[0] = '\0';
				return(one);
				}
			}
                if (site < ns)
			label();
		}
	}

return(one);

}
