#include "editstat.h"

/*
  FUNCTION move (oldclass, oldsite, newclass, newsite)

**********************************************************************

   name- move                                 
   language- C

   version- 2.0    date- 30-Oct-89  programmer- F. Irani, STX
   version- 1.0    date- 30-jun-83  programmer- s. ross, sasc

********************************************************************** */


void move
(
    char oldclass[],	/* Old class location 	*/
    char oldsite[],	/* Old site  location 	*/
    char newclass[],	/* New class location 	*/
    char newsite[]	/* New site  location 	*/
)

{

long i;               /* General purpose array index    */
long status;          /* Status flag for function calls */
long fatal_err = -1;  /* Fatal error flag for c_errmsg  */
long zero = 0;        /* General programmer usage       */


long	*buf = NULL;			/*  Site data buffer.	*/

char	data_type[STNAME],	/* Data name buffer	*/
	hold[STNAME+1];		/* Name Comparison buffer	*/

long	ind,			/* Temp class/site index 	*/
  	*nshape,		/* Name buffer shape vector	*/
	*shape = NULL,  /* Data shape buffer		*/
  	nis,			/* site index			*/
  	nic,			/* site index			*/
	nsites;			/* Number of sites in class	*/

t_lclear(t_lines - 2, 1);
t_output(t_lines - 2, 1, "WORKING...");

/*
Dynamically allocate storage for integer vectors.
-------------------------------------------------*/
if ((nshape = (long *) malloc (9 * sizeof (long))) == NULL ||
    (shape = (long *) malloc (9 * sizeof (long))) == NULL ||
    (buf = (long *) malloc (MAXPTS*2 * sizeof (long))) == NULL)
c_errmsg ("Error allocating dynamic memory", "EDITSTAT-move", &fatal_err);

/* Initialize shape vectors.
----------------------------*/
nshape[0] = shape[0] = EBYTE;
nshape[1] = shape[1] = 1;
for (i = 2; i < 9; ++i)
  	nshape[i] = shape[i] = 0;  

/* Save new site name and length.
---------------------------------*/
strcpy( hold, newsite);

/*
Get Origin class/site indices (errors were checked in movesite).
----------------------------------------------------------------*/
status = c_stfdsi (&inlun, oldclass, oldsite, &ic, &is);

/*
Get Destination class/site indices.
-----------------------------------*/
status = c_stfdsi (&inlun, newclass, newsite, &nic, &nis);

/*
Determine number of sites.
--------------------------*/
status = c_stget (&inlun, "NSITES", &nic, &zero, shape, &nsites);
nis = nsites + 1;

/*
Move data over into new location.
---------------------------------*/
id = 1;
status = E_SUCC;
while(status != E_NODT)
   {
   status = c_stnode (&inlun, &ic, &is, &id, data_type, shape);
   if (status == E_SUCC)
      {
      if (strcmp(data_type, "NAME") != 0)
           {
	   status = c_stget (&inlun, data_type,  &ic,  &is, shape, buf);
	   status = c_stput (&inlun, data_type, &nic, &nis, shape, buf);
           }
      }
   ++id;
   t_output(t_lines - 2, 11, ".");
   t_output(t_lines - 2, 12, ".");
   t_output(t_lines - 2, 13, ".");
   }

nshape[2] = (long) strlen(hold);
status = c_stput (&inlun, "NAME", &nic, &nis, nshape, hold);

/* Delete old site.
-------------------*/
status = c_stdlnd (&inlun, &ic, &is);

/* Delete statistics for both classes (except name).
----------------------------------------------------*/
ind = ic;
for (;;)
  {
  status = E_SUCC;
  id = 1;
  while( status != E_NODT)
     {
     status = c_stnode (&inlun, &ind, &zero, &id, data_type, shape);
     if (status == E_SUCC)
        {
        if (strncmp(data_type, "NAME",5) != 0)
  	   {
           status = c_stdldt (&inlun, data_type, &ind, &zero);
  	   if (status != E_SUCC)
  		c_sterr(status,t_lines - 2);
  	   }
        }
     t_output(t_lines - 2, 14, ".");
     t_output(t_lines - 2, 15, ".");
     t_output(t_lines - 2, 16, ".");
     ++id;
     }
  if (ind != nic)
     {
     ind = nic;
     continue;
     }
  else
  	break;
  }
t_output(t_lines - 1, 1, "Site moved.");
t_output(t_lines, 1, "Enter <CR> to continue.");
t_read (estring, &tae_term);
t_lclear(t_lines - 2, 1);
free (nshape); 
free (shape);
free (buf);
return;

}
