#include "editstat.h"


/*
**********************************************************************

   name- newmean                        

   language- C

   version- 2.0    date- 30-Oct-89  programmer- F. Irani
   version- 1.0    date- 14-jun-83  programmer- l. urquhart

   function- displays mean vector and prompts user for changes

**********************************************************************

*/

int newmean
(
    double mean[],		/* Mean vector data 	*/
    long size,		/* Vector length	*/
    char es_node[]	/* Node name 		*/
)

{


double	new;		/* New vector value	*/

long	elem, 		/* element number	*/
	pgindex = 1,	/* Page index */
	save;		/* User wants to save flag */

long i;         /* array index */

save = FALSE;

/*
Display mean vector.
--------------------*/
for (;;)
  {

  if (pgindex > size) 
  	pgindex = 1;

  label();
  dispmean (mean, size, pgindex, es_node);

  /* Prompt for element to be changed.
  ------------------------------------*/
  for (;;)
    {
    sprintf(estring,
    "Enter element to change, Back, Save, or Page[element no.]:");

    /* Read user entry.
    -------------------*/
    prompt(ostring);
    if (back)
    	{
	save = FALSE;
	return(save);
    	}

    /* If P[age] entered page the display.
    --------------------------------------*/
    if (es_index(ostring, "P") == 0)
    	{
    	/* Check if paging to a particular element.
    	-------------------------------------------*/
	for (i = 0; i < len; ++i)
        	{
		if (ostring[i] >= '0' && ostring[i] <= '9')
			break;
		}

	if ( (i < len) && 
	     (sscanf(&ostring[i], "%ld", &pgindex) == 1) )
		{
		if (pgindex > size) 
	    		pgindex = size;
		if (pgindex < 1)  
		    	pgindex = 1;

	  	label();
	  	dispmean (mean, size, pgindex, es_node);
	    	continue;
		}
	else if (i == len)
		{
		pgindex += 15;
		if (pgindex > size) 
	    		pgindex = 1;
	  	label();
	  	dispmean (mean, size, pgindex, es_node);
	    	continue;
		}
    	}

    if (strncmp(ostring, "SAVE", len) == 0) 
    	{
    	save = TRUE;
    	return(save); 
    	}

    /* Convert to integer.
    ----------------------*/
    if (sscanf(ostring, "%ld", &elem) != 1)
    	continue;
    if ((elem > size) || (elem < 1))
    	{
    	t_lclear (t_lines - 2, 1);
    	t_output (t_lines - 2, 1,
	"[editstat-number] Invalid mean vector element number");
    	continue;
    	}  
    if (elem != pgindex)
    	{
	pgindex = elem;
	label();
	dispmean (mean, size, pgindex, es_node);
    	}

    break;
    }
  for (;;)
    {

    /* Prompt for new value.
    ------------------------*/
    sprintf(estring, "Enter new value or Back to abort this element change.");

    /* Read new value.
    ------------------*/
    prompt(ostring);

    if (back)
	break;

    /* Convert to real value.
    -------------------------*/
    if (sscanf(ostring, "%lf", &new) != 1) 
	{
    	t_lclear (t_lines - 2, 1);
    	t_output (t_lines - 2, 1,
	"[editstat-invnum] Invalid numeric format");
    	continue;
	}
    break;
    }
  if (back)
	continue;

  /*
  Change value.
  -------------*/
  mean[elem-1] = new;
  pgindex = elem;
  /*
  Re-display vector.
  ------------------*/
  }

}
