#include "editstat.h"
/*
---------------------------------------------------------------------------

   Name- c_sterr

   Language- C     

   Version- 1.0   Date-  6-OCT-89  Programmer- F. Irani     (V5.0 Conversion)

   Function: Prints a statio return status error message

---------------------------------------------------------------------------
*/


void c_sterr
(
    long status,	/* Statio call return value to report on */
    long line
)
{


  if (pflags[TERM])
     {
     t_lclear(line, 1);
     switch (status)
        {
	case   E_FAIL:          
		t_output(line, 1,"[editstat-error]  Unsuccessful operation");
		break;
	case   E_GNLIO:
		t_output(line, 1,"[editstat-statio]  General I/O error");
		break;
	case   E_NOCL:
		t_output(line, 1,"[editstat-notfnd]  Class not found");
		break;
	case   E_NOSI:
		t_output(line, 1,"[editstat-notfnd]  Site not found");
		break;
	case   E_NODT:
		t_output(line, 1,"[editstat-nodtype]  Data-type not found");
		break;
	case   E_NOCLN:
		t_output(line, 1,"[editstat-notfnd]  Class name not found");
		break;
	case   E_NOSIN:
		t_output(line, 1,"[editstat-notfnd]  Site name not found");
		break;
	case   E_OPNEW:
		t_output(line, 1,"[informational]  New file created - no old file");
		break;
	case   E_DTOLD:
		t_output(line, 1,"[informational]  Old data replaced");
		break;
	case   E_INVCL:
		t_output(line, 1,"[editstat-invalclass]  Class not found/invalid");
		break;
	case   E_INVSI:
		t_output(line, 1,"[editstat-invalsite]  Site not found/invalid");
		break;
	case   E_INVDT:
		t_output(line, 1,"[editstat-invaldtype]  Error in data_type.");
		break;
	case   E_INVNM:
		t_output(line, 1,"[editstat-longname]  Class or site name too long");
		break;
        }
   }
     
     return;
}
