/******************************************************************************

  NAME:	DATA_TPS	

  FUNCTION: Display the contents of the data records of a TPS file to the 
            terminal.

  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	EDITTIE must be run under TAE

  PROJECT:	LAS

  ALGORITHM DESCRIPTION:
  Each output line string is formated with the information provided by the
  input arguments
  Each of the line strings is then output to the terminal.

  ALGORITHM REFERENCES: None.

******************************************************************************/
#include "las.h"
#include "geompak.h"
#include "protos.h"

void data_tps
(
    struct TPSDATA *data,			/*  TPS data record		*/
    long *curent				/*  record to display		*/
)

{  /* data_tps */

char line[81];				/*  buffer of output line 	*/

/*  Clear the terminal
----------------------*/
t_clear();

/*  format each line of output
------------------------------*/
sprintf(line,"Point Id: %s",data[*curent].pt_id);
t_output(1,2,line);

sprintf(line,"Tie point Coordinates: %16.5f   %16.5f",
        data[*curent].coord[0],data[*curent].coord[1]);
t_output(3,2,line);

sprintf(line,"Image Coordinates:     %16.5f   %16.5f",
        data[*curent].image_coord[0],data[*curent].image_coord[1]);
t_output(5,2,line);

sprintf(line,"Elevation of Point: %16.5f",data[*curent].elevation);
t_output(7,2,line);

sprintf(line,"Scale Factor:       %16.5f",data[*curent].zoom_factor);
t_output(9,2,line);

sprintf(line,"Chip Size:        %d     %d",
        data[*curent].chip_size[0],data[*curent].chip_size[1]);
t_output(11,2,line);

sprintf(line,"Search Offsets:   %d     %d",
        data[*curent].offsets[0],data[*curent].offsets[1]);
t_output(13,2,line);

sprintf(line,"Chip Image name: %-60.60s",data[*curent].chip_name);
t_output(15,2,line);

}  /* data_tps */
