/******************************************************************************

  NAME:	DISQUIT

  FUNCTION: Display the follow up question when quitting.

  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	EDITTIE must be run under TAE

  PROJECT:	LAS

  ALGORITHM DESCRIPTION:
  The follow up question is displayed
  The the answer is retrieved
  If 'no'
     Control is returned to the calling routine
  If 'yes' 
     The command line is cleared
     The cursor is positioned in the correct spot for the completion message

  ALGORITHM REFERENCES: None.

******************************************************************************/
#include "las.h"
#include "protos.h"

void disquit
(
    char *ans,				/* answer pointer		*/
    long *line				/* number of lines on the terminal */
)

{  /* disquit  */

long term;				/* terminator used for answer	*/

char blank70[71];			/* buffer for a blank line	*/
char ques[80];				/* buffer for the question	*/

/*  Initialize variables
------------------------*/
strcpy(ques,"Are you sure you want to end the session? (Y)es, (N)o");
strcpy(blank70,
"                                                                      ");

/*  Output question
-------------------*/
t_output(*line - 1,2,blank70);
t_output(*line,2,ques);

/*  Wait for reply
------------------*/
t_input(*line,56,ans,&term);
if (term == P_OVER)
   t_output(*line - 2,2,"[edittie-input] Input is larger than buffer size");

/*  If answer is yes blank out command line and position cursor
---------------------------------------------------------------*/
if ((strncmp(ans,"y",1) == 0) || (strncmp(ans,"Y",1) ==0))
   {
   strcpy(ans,"q");
   t_output(*line - 1,2,blank70);
   t_output(*line,2,blank70);
   t_pos(*line,1);
   }

} /* disquit */
