#ifndef PROTOS_H
#define PROTOS_H

#include "geompak.h"  

int bat_mtp
(
    struct PARBLK *vblock,  /*  TAE variable block          */
    char hosin[][CMLEN],    /*  input host MTP file names   */
    char *hosout,           /*  output host MTP file name   */
    long *combin,           /*  combin two input files      */
    long *new_file,         /*  TRUE if no input files      */
    char *subcmd            /*  subcommand                  */
);

int bat_tpl
(
    struct PARBLK *vblock,  /*  TAE variable block          */
    char hosin[][CMLEN],    /*  input host TPL file names   */
    char *hosout,           /*  output host TPL file name   */
    long *combin,           /*  combin two input files      */
    long *new_file,         /*  TRUE if no input files      */
    char *subcmd            /*  subcommand                  */
);

int bat_tps
(
    struct PARBLK *vblock,  /*  TAE variable block          */
    char hosin[][CMLEN],    /*  input host TPS file names   */
    char *hosout,           /*  output host TPS file name   */
    long *combin,           /*  combin two input files      */
    long *new_file,         /*  TRUE if no input files      */
    char *subcmd            /*  subcommand                  */
);

void data_mtp
(
    struct MTPDATA *data,   /*  MTP data record             */
    long *curent            /*  record to display           */
);

void data_tpl
(
    struct TPLDATA *data,   /*  TPL data record             */
    long *curent            /*  record to display           */
);

void data_tps
(
    struct TPSDATA *data,   /*  TPS data record             */
    long *curent            /*  record to display           */
);

void disquit
(
    char *ans,              /* answer pointer               */
    long *line              /* number of lines on the terminal */
);

int dsp_mtp
(
    char hosin[][CMLEN],    /*  input host MTP file names   */
    char *hosout,           /*  output host MTP file name   */
    long *combin,           /*  combin two input files      */
    long *write_flag,       /*  write flag                  */
    long *new_file,         /*  TRUE if no input files      */
    char *subcmd            /*  subcommand                  */
);

int dsp_tpl
(
    char hosin[][CMLEN],    /*  input host TPL file names   */
    char *hosout,           /*  output host TPL file name   */
    long *combin,           /*  combin two input files      */
    long *write_flag,       /*  write flag                  */
    long *new_file,         /*  TRUE if no input files      */
    char *subcmd            /*  subcommand                  */
);

int dsp_tps
(
    char hosin[][CMLEN],    /*  input host TPS file names   */
    char *hosout,           /*  output host TPS file name   */
    long *combin,           /*  combin two input files      */
    long *write_flag,       /*  write flag                  */
    long *new_file,         /*  TRUE if no input files      */
    char *subcmd            /*  subcommand                  */
);

void edt_mtp
(
    struct MTPHEAD *head,   /* MTP header record            */
    struct MTPDATA *data,   /* MTP data records             */
    char *edans_buf,        /* pointer to edit command code */
    long *line,             /* number of lines on the screen*/
    long *curent,           /* curent data record           */
    long *edit_flag         /* edit flag                    */
);

void edt_tpl
(
    struct TPLHEAD *head,   /* TPL header record            */
    struct TPLDATA *data,   /* TPL data records             */
    char *edans_buf,        /* pointer to edit command code */
    long *line,             /* number of lines on the screen*/
    long *curent,           /* curent data record           */
    long *edit_flag         /* edit flag                    */
);

void edt_tps
(
    struct TPSHEAD *head,   /* TPS header record            */
    struct TPSDATA *data,   /* TPS data records             */
    char *edans_buf,        /* pointer to edit command code */
    long *line,             /* number of lines on the screen*/
    long *curent,           /* curent data record           */
    long *edit_flag         /* edit flag                    */
);

void edtint
(
    long *lines             /*  number of lines on terminal */
);

int getpar
(
    struct PARBLK *vblock,  /* TAE variable block   */
    char *subcmd,           /* Subcommand           */
    char *hosout,           /* Output host file name*/
    char hosin[][CMLEN],    /* Input host file names*/
    char *type,             /* Type of tie point file*/
    double *mindist,        /* Minimum separation to allow*/
    long *combin,           /* Combine two input files*/
    long *new_file          /* Flag if creating a new file*/
);

void head_mtp
(
    char *taeout,           /*  output TAE mtp file  name   */
    struct MTPHEAD *head    /*  MTP header record           */
);

void head_tpl
(
    char *taeout,           /*  output TAE tpl name         */
    struct TPLHEAD *head,   /*  TPL header record           */
    long *page_flag         /*  flag to determine header page */
);

void head_tps
(
    char *taeout,           /*  output TAE tps name         */
    struct TPSHEAD *head    /*  TPS header record           */
);

int load_mtp
(
    char hosin[][CMLEN],    /* Input host file names*/
    long *combin,           /* combine two input files*/
    long *new_file,         /* flag if creating a new file*/
    long *line,             /* lines on the terminal*/
    char *subcmd,           /* subcommand           */
    struct MTPHEAD *head1,  /* MTP header record    */
    struct MTPDATA *data,   /* MTP data record      */
    long *count,            /* count of data records */
    long *maxtie            /* maximum number of points */
);

int load_tpl
(
    char hosin[][CMLEN],    /* Input host file names*/
    long *combin,           /* combine two input files*/
    long *new_file,         /* flag if creating a new file*/
    long *line,             /* lines on the terminal*/
    char *subcmd,           /* subcommand           */
    struct TPLHEAD *head1,  /* TPL header record    */
    struct TPLDATA **data,  /* TPL data record      */
    long *count,            /* count of data records */
    long *maxtie            /*  maximum amount space allacated */
);

int load_tps
(
    char hosin[][CMLEN],    /* Input host file names*/
    long *combin,           /* combine two input files*/
    long *new_file,         /* flag if creating a new file*/
    long *line,             /* lines on the terminal*/
    char *subcmd,           /* subcommand           */
    struct TPSHEAD *head1,  /* TPS header record    */
    struct TPSDATA **data,  /* TPS data record      */
    long *count,            /* count of data records */
    long *maxtie            /* maximum space allocated */
);

int rmdups
(
    struct PARBLK *vblock,
    char hosin[][CMLEN],    /*  input host TPL file names    */
    char *hosout,           /*  output host TPL file name    */
    long *combin,           /*  combine two input files      */
    long *new_file,         /*  TRUE if no input files       */
    double *mindist,        /*  minimum distance between points */
    char *subcmd,           /*  subcommand                   */
    char *prtfile           /*  output print file            */
);

void tiehelp
(
    char *ans,              /* input help code              */
    long *line              /* number of lines in the terminal */
);

void renmpt
(
    char *pt_id,            /* point id                     */
    long *line              /* number of lines on terminal  */
);

void pntval
(
    long input,             /*  input valid code                    */
    char str[16]            /*  output valid string                 */
);

int start_of_line
(
    long *line,             /*  number of lines on the terminal*/
    char **eqptr,           /*  aheadess of the str. right of = */
    char *string            /*  aheadess of command string  */
);

void validate
(
    char *eqptr,            /* point to command string      */
    char *echo,             /* pointer to output string     */
    long *vld,              /* pointer to valid code        */
    long *line              /* number of lines on terminal  */
);

void actflg
(
    long *active,           /* active flag  */
    char *line              /* output line  */
);

void clrtps
(
    struct TPSHEAD *head    /* TPS header record */
);

void clrtpl
(
    struct TPLHEAD *head    /* TPL header record */
);

void clrmtp
(
    struct MTPHEAD *head    /* MTP header record */
);

#endif
