#ifndef PROTOS_H
#define PROTOS_H

#define max_images 14
#define max_trans 14

void getparm
(
    char ihos[MAXIMG][CMLEN],              /*input images host names */
    char olas[1][CMLEN],                       /*output image LAS names */
    char ohos[1][CMLEN],                     /*output image host names */
    long *num_images,                      /*no. of input images    */
    long *nbands,                          /*no. of bands in each input image*/
    long (*bands)[MAXBND + 1],             /*band no's in each input image */
    long *totbnd,                          /*total no. of input image bands */
    long (*wind)[4],                       /*input image windows    */
    float factor[max_trans][max_images],    /* band weight vector */
    float scale[max_trans][2],              /* scales and offsets */
    long *nrep                            /*no. of transformations */
);

void initio
(
    char hosin[][CMLEN],          /*input image host name descriptors */
    char hosout[],                /*output image host name descriptor */
    long *nrep,                        /*no. of transformations        */
    long nimages,                     /*no. of input images           */
    long nbands[],                    /*no. of bands in each input    */
    long image_band_num[][MAXBND +1], /*band numbers in each          */
    long wind[][4]                   /*input image windows           */
);

void tform
(
    long num_inbands,                   /* total no. of input image bands */
    long *nrep,                          /* no. of transformations       */
    float factor[][max_images],          /* band weight vector           */
    float scale[][2],                    /* scales and offsets           */
    long wind[][4],                     /* image window                  */
    double minval[MAXBND+1], /* array of min values  */
    double maxval[MAXBND+1] /* array of max values  */
);

void iso_err
(
    char *message,
    char *key
);

#endif
