#include "factor.h"
#include "util.h"


/*****************************************************************************
 *
 * NAME		iso_err
 *
 * PURPOSE	To display an error message and exit FACTOR if it is fatal.
 *		The first character of the error message determines whether
 *		or not the error is fatal.
 *
 * PROGRAM HISTORY
 *
 *	Programmer		Date		Reason
 *	----------		----		------
 *	Eric Ivancich / SAR	13-Aug-87	C conversion
 *      Bani Allam              8-Aug-88        Retrocode
 *
 * PARAMETERS
 *
 *	Name		Type		I/O	Description
 *	----		----		---	-----------
 *	*message	char		I	Error message and severity
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *	None
 *
 * RETURN VALUES
 *
 *	None
 *
 *****************************************************************************/
void iso_err
(
    char *message,
    char *key
)
{
    long inf_err = 1;
    
    switch (*message++)  {
		case '?' :
		     	c_errmsg (message, key, &inf_err);
		     	break;
		case '!' : {
   	 		c_errmsg (message, key, &inf_err);
                        if (gdesc > 0) c_egclse(&gdesc);
                        c_clean (&block, "FACTOR", out, &num_files);
                        }
 	}
}
