/******************************************************************************
FUNCTION:	GETDAT

PURPOSE:	Retrieve the current date and time

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
  1.0      01/86    K. Zanter		initial development
  5.0      06/88    D. Hollaren		changed declaration to raw C types

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	None.

PROJECT			LAS

ALGORITHM 
  Get the local time from the system
  Get the hours and minutes from the local time
  Determine the day of the week
     Copy the string for the day of the week
  Determine the month
     Copy the string for the month
  Get the day and year from the local time

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <time.h>
#include "las.h"
#include "protos.h"

void getdate_and_time
(
    char *wday,		/* current weekday				*/
    char *mon,		/* current month				*/
    long *day,		/* current day , 1 - 31				*/
    long *yr,		/* current year 				*/
    long *hour,		/* current hour of 24 hour clock		*/
    long *minute		/* current minute of 24 hour clock		*/
)
{
        struct tm *tm_ptr;	
	long my_time;

/*
  Get the local time
*/
  	my_time = time(0);
        tm_ptr = localtime(&my_time);

/*
  Get the hours and minutes from the local time
*/
        *hour = tm_ptr->tm_hour;
        *minute = tm_ptr->tm_min;

/*
  Determine the day of the week
*/
        switch (tm_ptr->tm_wday)
        {
               case 0 : strcpy(wday,"Sun. ");
   	                break;
 	       case 1 : strcpy(wday,"Mon. ");
 	                break;
	       case 2 : strcpy(wday,"Tue. ");
 	                break;
	       case 3 : strcpy(wday,"Wed. ");
 	                break;
	       case 4 : strcpy(wday,"Thu. ");
	                break;
	       case 5 : strcpy(wday,"Fri. ");
	                break;
	       case 6 : strcpy(wday,"Sat. ");
	                break;
        }

/*
  Determine the month
*/
        switch (tm_ptr->tm_mon)
	{
               case 0 : strcpy(mon,"Jan ");
			break;
	       case 1 : strcpy(mon,"Feb ");
			break;
  	       case 2 : strcpy(mon,"Mar ");
			break;
	       case 3 : strcpy(mon,"Apr ");
			break;
	       case 4 : strcpy(mon,"May ");
			break;
 	       case 5 : strcpy(mon,"Jun ");
			break;
	       case 6 : strcpy(mon,"Jul ");
			break;
	       case 7 : strcpy(mon,"Aug ");
			break;
	       case 8 : strcpy(mon,"Sep ");
			break;
	       case 9 : strcpy(mon,"Oct ");
			break;
	      case 10 : strcpy(mon,"Nov ");
			break;
	      case 11 : strcpy(mon,"Dec ");
			break;
        }

/*
  Get the day and year from the local time
*/
        *day = tm_ptr->tm_mday;
        *yr = tm_ptr->tm_year + 1900;
}
