#include "film.h"
#include "util.h"
#include "protos.h"

void genpic
(
    char hos_in[][CMLEN],   /* Input images host names      */
    char hos_out[],         /* Output image host name       */
    long *num_inimages,     /* Number input images          */
    long *num_outbands,     /* Number output bands          */
    long film_type,         /* Film type                    */
    long imgsiz[]          /* Image size                   */
)


/*
*****************************************************************************

NAME:	GENPIC

PURPOSE: Generate out put image

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          5-May-82    J. Hwang, SASC
   2         14-Jun-88    K. A. Narayanan    
   3          3-Jan-89    K. A. Narayanan    Conversion to 5.0
   4         19-Nov-90    K. Kunska          Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Initialize and enable processing message utility.
   Call LINGEN to generate a line.
   Call WRIMG to write the line to output.
   Stop processing message, 
   Close files, 
   Free memory.
   Output image history.

*****************************************************************************
*/
{
long	i;				/* Loop counter */

static	long	msg_flag = GEN2;	/* Processing message utility flag */


/*
Initialize and enable processing message utility.
--------------------------------------------------
*/
c_inittm ("FILM", "Processed", "line", "bands", " ", &tb[2],
          num_outbands, &msgtim, &msg_flag);
curent = 1;
c_startm();

/*
Generate output image.
-----------------------
*/
for (i = tb[0]; i <= tb[0]+tb[2]-1; i++, curent++)
   {
   lingen (i, tb[6]);
   wrimg (i, *num_outbands, film_type, imgsiz);
   }

/*
Stop processing message, close files, and free memory.
-------------------------------------------------------
*/
c_stoptm ();

c_egclse (&gdescin);
c_egclse (&gdescout);

free (inbuf);
free (outbuf);

/*
Output image history.
----------------------
*/
c_hstout( &block, hos_out, hos_in, num_inimages, " "); 

}
