#include <stdio.h>
#include "las.h"
#include "pixman.h"
#include "protos.h"

/******************************************************************************

NAME:  GENSQR

FUNCTION:

PROGRAM HISTORY:
  Version	Date       Author      	         Request
  -------	----	   ------                -------
   1.0        22-Feb-82  J. Hwang, SASC
   2.0         8-Jan-88  M. Mazzella, SAR/GSFC   Convert to c
   3.0        20-Mar-89  K. Narayanan, STX       Index to workbuf became < 0
   4.0        19-Nov-90  K. Kunska               Added comments; fixed gray
                                                 level scale on the output img

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	new LAS

ALGORITHM (FLOW):

   If current line count is not in the range of square description then
      return
   End if
   Fill work buffer with grey scale desired in picture description table.
   Return

******************************************************************************/

int gensqr
(
    long vcnt,		/* Line number of image		*/
    long *tab		/* Array of data about square 	*/
)

{

long	status = E_SUCC,	/* Return status             */
	type;			/* Data type of output image */

unsigned char	fillval;

extern unsigned char workbuf[]; /* Buffer to store data      */


/*
If current line count is not in the range of square description then return.
----------------------------------------------------------------------------
*/
if ((vcnt < tab[0]) || (vcnt > (tab[0] + tab[2] - 1))) 
   return(status);

/*
Fill work buffer with grey scale desired in picture description table.
------------------------------------------------------------------------
*/
type = EBYTE;
fillval = (unsigned char)tab[4];
c_pxfill(&workbuf[tab[1]], &type, &tab[3], &fillval); 

return(status);
}
