#ifndef PROTOS_H
#define PROTOS_H

void annot
(
    long film_type,            /* Film type                 */
    char fname[],              /* Facility name             */
    char hos_in[],             /* Input image host name     */
    char dpfin[],              /* Dltf name                 */
    char dpfentry[]           /* Dltf entry                */
);

void arange
(
    long window[],	/* User defined window to be applied to input image */
    long trnc,		/* 1: Truncate: select the largest output image size */
    long imgsiz[]	/* I/O input image size as an input, output image */
);

long bit
(
    unsigned char	word,		/*  Source word  */
    unsigned char   pos		/*  Position of bit desired  */
);

void filspec
(
    char hosin[][CMLEN],			/* Input image host names */
    char hosout[],			/* Output image host name */
    char lasout[],			/* Output image las name */
    long *num_inimages,			/* Number of input images */
    long num_image_bands[],		/* Number of bands in each input image*/
    long image_band_num[][MAXBND + 1],	/* Band numbers in each input image */
    long *num_outbands,			/* Number of output image bands */
    long wind[][4],			/* Input image windows */
    long truncate,			/* Truncate/fill option */
    long imgsiz[]			/* Output image size */
);

int genchr
(
    long vcnt,		/* Current line count on the picture */
    long tab[],		/* Square description  */
    char chrs[]		/* Character(s) to be expanded */
);

void genpic
(
    char hos_in[][CMLEN],   /* Input images host names      */
    char hos_out[],         /* Output image host name       */
    long *num_inimages,     /* Number input images          */
    long *num_outbands,     /* Number output bands          */
    long film_type,         /* Film type                    */
    long imgsiz[]          /* Image size                   */
);

int gensqr
(
    long vcnt,		/* Line number of image		*/
    long *tab		/* Array of data about square 	*/
);

int gentik
(
    long vcnt,		/* Vertical line count		*/
    long tab[]		/* Array containing tick info	*/
);

void getpar
(
    char hosin[][CMLEN],		/* Input image host name               */
    char lasout[][CMLEN],		/* Output image las name               */
    char hosout[][CMLEN],		/* Output image host name              */
    long *num_inimages,		/* Number of input images              */
    long num_image_bands[],	/* Number of bands in each input image */
    long image_band_num[][MAXBND + 1], /* Band numbers in each input image */
    long *num_inbands,		/* Total number of input image bands   */
    long *num_outbands,		/* Number of output image bands        */
    long wind[][4],		/* Input image windows                 */
    long *truncate,		/* Truncation/fill option              */
    long *film_type,		/* Film type                           */
    char facility_name[],	/* Facility address                    */
    char dpfin[],		/* DLTF                                */
    char dpfentry[]		/* LUT entry in DLTF                   */
);

long idx
(
    long	a,		/* Number of pixels in an image */
	long    b,		/* Number of lines in an image  */
    long    tbl[],  /* Table of values      */
    long    tsize,  /* Table size           */
    long    jump,   /* Number of values between each one checked    */ 
    long    eq      /* Equivalence flag     */
);

void initf(void);

void intsct
(
    long a[],		/* Input window a, output intersection of a and b */
    long b[],		/* Input window b				  */
    long abssiz		/* True if absolute size comparison desired	  */
);

void lingen
(
    long vcnt,			/* Output image line number      */
    long tbsize			/* Picure description table size */
);

void magtbl
(
    long ntimes		/* Number of times to magmify the table  */
);

void rdimg
(
    long vcnt,			/* Current line counter */
    long tb[], 			/* Square description */
    long findex			/* File index */
);

void vchar
(
    long vcnt,		/* Current line number */
    long seq		/* Band number */
);

void wrimg
(
    long vcnt,			/* Current line number          */
    long num_outbands,		/* Number output bands          */
    long film_type,		/* Film type                    */
    long imgsiz[]		/* Output image size            */
);

#endif
