#include "film.h"
#include "util.h"
#include "protos.h"

/*
*****************************************************************************

NAME:	RDIMG

PURPOSE: Reads a line of input image

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          5-May-82    J. Hwang, SASC
   2          4-Apr-89    K. A. Narayanan    Conversion to 5.0
   3         19-Nov-90    K. Kunska          Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM:

   Read the input image.
   Copy image values into the work buffer.

*****************************************************************************
*/

void rdimg
(
    long vcnt,			/* Current line counter */
    long tb[], 			/* Square description */
    long findex			/* File index */
)
{

static char    *prog_name = "FILM";    /* program name            */

long	i,			/* Loop counter */
	status;			/* Return status */

extern unsigned char workbuf[]; /* Work buffer */

/*
Read the input image.
Copy image values into the work buffer.
---------------------------------------
*/
if ((vcnt < tb[0]) || (vcnt > tb[0]+tb[2]-1)) return;
if (findex == 0) 
   {
   status = c_estep (&gdescin);
   if (status != E_SUCC)
      c_abort (&block, "Error reading input image", "film-inread",
               prog_name, clean_files, &num_outfiles);
   }
for (i = 0; i < tb[3]; i++)
   workbuf[i+tb[1]] = inbuf[ipoint[findex]+i];
}
