#include <string.h>
#include "film.h"
#include "protos.h"

/*
*****************************************************************************

NAME:	VCHAR

PURPOSE: Generate delayed character(s)


PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          5-May-82    J. Hwang, SASC
   2          3-Jan-89    K. A. Narayanan    Conversion to 5.0
   3         19-Nov-90    K. Kunska          Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   For number of square descriptions
      If line number belongs to current square vertical range 
         If square type is -2
            Call GENCHR to generate character(s)

*****************************************************************************
*/
void vchar
(
    long vcnt,		/* Current line number */
    long seq		/* Band number */
)
{
char	colchr[9];	/* Color annotation */

long	i, l, 		/* Loop counters and array indices */
	rcnt;		/* Value from picture description table */

strncpy (colchr, "R   G   B",9);	

/*
For number of square descriptions:
If line number belongs to current square vertical range and if square 
type is -2, then call GENCHR to generate character(s)
----------------------------------------------------------------------
*/
for (i = 0; i < tb[6]; i++)
   {
   l = i * 10;
   if ((vcnt < tb[l]) || (vcnt > tb[l]+tb[2+l]-1)) continue;
   if (tb[9+l] == -2)     /*  character varies depending */
                          /*  on the color(r,g,b)      */
      {
      rcnt = tb[l+8];
      colchr[seq*3+seq] = chrbuf[tb[l+7]+seq-1];
      genchr (vcnt, &tb[l], &colchr[seq*3]);    
      tb[l+8] = rcnt+((seq+1)/3);
      }  
   }
}
