/*
*************************************************************************
NAME: aloc_buf

PURPOSE: allocate memory for a 'lines' by 'samps' buffer.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1           11/89   T. Baltzer   


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: LAS

*****************************************************************
	arguments:
	name		description
	----		-----------
	 lines		number of lines in the buffer
	 samps		number of samples in the buffer
	 dtype		the data type of the buffer
	 buff		pointer to buffer

************************************************************************
*/
#define NULL 0
#include "worgen.h"
#include "protos.h"

void * aloc_buf
(
    long lines,
    long samps,
    long dtype
)
{
long inf_err = 1;		/* error status flag */
char * buff = NULL;

/* NOTE: don't bother type casting the pointer 'buff'.  Upon calling    */
/*       aloc_buf(), the user can map this pointer into the appropriate */
/*       pointer type.  Just make sure that the correct number of bytes */
/*       are allocated.							*/


switch (dtype)
   {
   case EREAL:  buff = malloc(lines*samps*4);  break;
   case ELONG:  buff = malloc(lines*samps*4);  break;
   case EWORD:  buff = malloc(lines*samps*2);  break;
   case EBYTE:  buff = malloc(lines*samps);    break;
   }

if (buff == NULL)
    {
    c_errmsg("Error allocating dynamic memory.","filter-alloc",&inf_err);
    c_errmsg("Fatal error encountered","filter-fatal",&inf_err);
    return(NULL);       /* error return status */
    }

return buff;    /* successful return status */

}             /* end of aloc_buf()    */

