/*
*************************************************************************
NAME: extr_wrd

PURPOSE: update the arrays storing the extreme (min/max) values of the
	 SHORT (I*2) image (one array element per band)

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1	        01/90   T. Baltzer


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Must be run under TAE.

PROJECT: LAS

************************************************************************
	arguments:
	name		description
	----		-----------
	obuff		output buffer (input)
	nsobuf		number or samples in obuff (input)
	nlavo		number of lines of valid data in obuff (input)
	nsavo		number of samples of valid data in obuff (input)
	oband		output band number (input)
	maxbnd		array of maximum values (input/output)
	minbnd		array of minimum values (input/output)

************************************************************************
*/

#include <stdio.h>
#include "protos.h"

void extr_wrd
(
    short *obuff,
    long nsobuf,
    long nlavo,
    long nsavo,
    long oband,
    double maxbnd[],
    double minbnd[]
)

{

long	i,j;		/* counters */
short	*addr;		/* address */
short	*tmpa;		/* temporary address */
long	obandi;		/* output band index */

obandi = oband - 1;

tmpa = obuff;
for (i = 0; i < nlavo; i++)
   {
   addr = tmpa;
   tmpa += nsobuf;
   for (j = 0; j < nsavo; j++)
      {
      if ( (double) *addr < minbnd[obandi])
         minbnd[obandi] = (double) *addr;
      if ( (double) *addr > maxbnd[obandi])
         maxbnd[obandi] = (double) *addr;
      addr++;
      }
   }


}    /* end of extr_wrd()   */
