/*
************************************************************************
NAME: movew_d

PURPOSE: Move the kernel down one pixel and update the histogram
	 array (word, I*2 data).

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1           02/90   T. Baltzer   


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: LAS

ALGORITHM DESCRIPTION:

*****************************************************************
	arguments:
	name		description
	----		-----------
	oradd		address of origon of kernel (input/output)
	nlk		number of rows in the kernel (input)
	nsk		number of samples in the kernel (input)
	nsbuf		number of samples in input buffer (input)
	histgm		histogram array (input/output)

************************************************************************
*/
#include "las.h"
#include "protos.h"

int movew_d
(
    short **oradd,
    long nlk,
    long nsk,
    long nsbuf,
    long *histgm
)
{

short 	*addadd;	/* add address */
short 	*subadd;	/* subtract address */
long	i;			/* counter */

subadd = *oradd;
addadd = subadd + (nlk * nsbuf);
histgm[*subadd]--;
histgm[*addadd]++;

for (i = 1; i < nsk; i++)
   {
   subadd++;
   addadd++;
   histgm[*subadd]--;
   histgm[*addadd]++;
   }

*oradd += nsbuf;

return(E_SUCC);

}   /* end of movew_d()   */
