#ifndef PROTOS_H
#define PROTOS_H

#include "las.h"
#include "filt.h"

void * aloc_buf
(
    long lines,
    long samps,
    long dtype
);

int app_byt
(
    unsigned char *buffer,
    unsigned char *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    struct FSTR *fstr,
    double lowval,
    double highval,
    long out_flag[3]
);

int app_wrd
(
    short *buffer,
    short *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    struct FSTR *fstr,
    double lowval,
    double highval,
    long out_flag[3]
);

int clos_img
(
    struct FDESC **fdesc
);

int err_sbuf
(
    long nli,
    long nsi,
    long nlk,
    long nsk,
    long nlb,
    long nsb,
    long dtype,
    long maxram
);

void extr_byt
(
    unsigned char *obuff,
    long nsobuf,
    long nlavo,
    long nsavo,
    long oband,
    double maxbnd[],
    double minbnd[]
);

void extr_wrd
(
    short *obuff,
    long nsobuf,
    long nlavo,
    long nsavo,
    long oband,
    double maxbnd[],
    double minbnd[]
);

int filtold
(
    char hosin[MAXIMG][CMLEN],
    char taeout[][CMLEN],
    char hosout[][CMLEN],
    long totbnd,
    long bands[MAXIMG][MAXBND+1],
    long nbands[MAXIMG],
    long nl,
    long ns,
    long window[MAXIMG][4],
    long nmrimg,
    double thrperc,
    struct FSTR *fstr,
    long otype,
    double lowval,
    double highval,
    long out_flag[3]
);

int free_buf
(
    void *buff
);

void getpar
(
    char hosin[][CMLEN],
   char taeout[][CMLEN],
   char hosout[][CMLEN],
   long *totbnd,
   long bands[][MAXBND+1],
   long nbands[],
   long *nl,
   long *ns,
   long window[][4],
   long *nmrimg,
   char subcmd[],
   long *ksamps,
   long *klines,
   float *xfrc,
   float *xadb,
   float *xmlt,
   float *low,
   float *high,
   float *thresh,
   long *otype,
   float *norm,
   long *invld,
   long *dtype,
   float *tolrn,
   float *lowval,
   float *highval,
   long out_flag[3]
);

int high_byt
(
    unsigned char *buffer,
    unsigned char *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk,
    long invld,
    double thresh,
    double minval,
    double maxval,
    double scalf,
    double offset,
    double addback,
    long minpix,
    double lowval,
    double highval,
    long out_flag[3]
);

int high_wrd
(
    short *buffer,
    short *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk,
    long invld,
    double thresh,
    double minval,
    double maxval,
    double scalf,
    double offset,
    double addback,
    long minpix,
    double lowval,
    double highval,
    long out_flag[3]
);

int ilow_byt
(
    unsigned char *buffer,
    unsigned char *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk,
    double thresh,
    double minval,
    double maxval,
    double scalf
);

int ilow_wrd
(
    short *buffer,
    short *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk,
    double thresh,
    double minval,
    double maxval,
    double scalf
);

void initio
(
    char host[],
   long window[],
   long *intype,
   long *curimg
);

int med_byt
(
    unsigned char *buffer,
    unsigned char *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk
);

int med_wrd
(
    short *buffer,
    short *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk
);

int move_d
(
    unsigned char **oradd,
    long nlk,
    long nsk,
    long nsbuf,
    long *histgm
);

int move_r
(
    unsigned char **oradd,
    long nlk,
    long nsk,
    long nsbuf,
    long *histgm
);

int move_u
(
    unsigned char **oradd,
    long nlk,
    long nsk,
    long nsbuf,
    long *histgm
);

int movew_d
(
    short **oradd,
    long nlk,
    long nsk,
    long nsbuf,
    long *histgm
);

int movew_r
(
    short **oradd,
    long nsk,
    long nsbuf,
    long *histgm
);

int movew_u
(
    short **oradd,
    long nlk,
    long nsk,
    long nsbuf,
    long *histgm
);

int prehi
(
    char hosout[][CMLEN],
    long xhalf,
    long yhalf,
    long *ns,
    long *curimg,
    long *curbnd,
    double high,
    double low,
    float *kersum,
    long *valsum
);

int prelo
(
    char hosout[][CMLEN],
    long xhalf,
    long yhalf,
    long *ns,
    long *curimg,
    long *curbnd,
    float *kersum
);

int pro_byt
(
    long nmrimg,
    long window[MAXIMG][4],
    long bands[MAXIMG][MAXBND+1],
    long nbands[MAXIMG],
    long totbnd,
    char hosin[MAXIMG][CMLEN],
    char hosout[CMLEN],
    long otype,
    long min_max,
    double maxbnd[MAXBND+1],
    double minbnd[MAXBND+1],
    struct FSTR *fstr,
    double lowval,
    double highval,
    long out_flag[3]
);

int pro_wrd
(
    long nmrimg,
    long window[MAXIMG][4],
    long bands[MAXIMG][MAXBND+1],
    long nbands[MAXIMG],
    long totbnd,
    char hosin[MAXIMG][CMLEN],
    char hosout[CMLEN],
    long otype,
    long min_max,
    double maxbnd[MAXBND+1],
    double minbnd[MAXBND+1],
    struct FSTR *fstr,
    double lowval,
    double highval,
    long out_flag[3]
);

void set
(
    long k,
   long *l,
   long ns
);

int set_h_byt
(
    double minval,
    double maxval,
    double thresh,
    long *histgm,
    double tmp1,
    double tmp2,
    double scalf,
    long invld,
    long minpix,
    unsigned char *iadd,
    unsigned char *oadd,
    double lowval,
    double highval,
    long out_flag[3]
);

int set_h_wrd
(
    double minval,
    double maxval,
    double thresh,
    long *histgm,
    double tmp1,
    double tmp2,
    double scalf,
    long invld,
    long minpix,
    short *iadd,
    short *oadd,
    double lowval,
    double highval,
    long out_flag[3]
);

int set_i_byt
(
    double minval,
    double maxval,
    double thresh,
    long *histgm,
    double scalf,
    unsigned char *iadd,
    unsigned char *oadd
);

int set_i_wrd
(
    double minval,
    double maxval,
    double thresh,
    long *histgm,
    double scalf,
    short *iadd,
    short *oadd
);

int set_med
(
    long *histgm,
    long mid,
    unsigned char *oadd
);

int set_medw
(
    long *histgm,
    long mid,
    short *oadd
);

int set_v_byt
(
    double minval,
    double maxval,
    double thresh,
    long *histgm,
    double scalf,
    long invld,
    unsigned char *iadd,
    unsigned char *oadd
);

int set_v_wrd
(
    double minval,
    double maxval,
    double thresh,
    long *histgm,
    double scalf,
    long invld,
    short *iadd,
    short *oadd
);

int size_bnd
(
    long *nlk,
    long *nsk,
    long *nlb,
    long *nsb
);

int size_buf
(
    long *nli,
    long *nsi,
    long *nlk,
    long *nsk,
    long *nlb,
    long *nsb,
    long *dtype,
    long *maxram,
    long *nlib,
    long *nsib,
    long *nlob,
    long *nsob
);

int slddp
(
    char hosout[][CMLEN],
    long nl,
    long *ns,
    long *curimg,
    long *curbnd,
    long *bndout,
    long xhalf,
    long yhalf,
    long ksamps,
    float *kersum,
    double minval[],
    double maxval[],
    double tolrn
);

int sldhi
(
    char hosout[][CMLEN],
    long nl,
    long *ns,
    long *curimg,
    long *curbnd,
    long *bndout,
    long xhalf,
    long yhalf,
    long ksamps,
    double high,
    double low,
    long frac,
    float *kersum,
    long *valsum,
    long invld,
    double xadb,
    double xmlt,
    long xmin,
    double norm,
    double minval[],
    double maxval[],
    double lowval,
    double highval,
    long out_flag[3]
);

int sldil
(
    char hosout[][CMLEN],
    long nl,
    long *ns,
    long *curimg,
    long *curbnd,
    long *bndout,
    long xhalf,
    long yhalf,
    long ksamps,
    double high,
    double low,
    long frac,
    float *kersum,
    long *valsum,
    double xmlt,
    long xmin,
    double minval[],
    double maxval[] 
);

int sldlo
(
    char hosout[][CMLEN],
    long nl,
    long *ns,
    long *curimg,
    long *curbnd,
    long *bndout,
    long xhalf,
    long yhalf,
    long ksamps,
    float *kersum,
    double minval[],
    double maxval[]
);

int sldvl
(
    char hosout[][CMLEN],
    long nl,
    long *ns,
    long *curimg,
    long *curbnd,
    long *bndout,
    long xhalf,
    long yhalf,
    long ksamps,
    double high,
    double low,
    long frac,
    float *kersum,
    long *valsum,
    long invld,
    double xmlt,
    long xmin,
    double minval[],
    double maxval[] 
);

int vlow_byt
(
    unsigned char *buffer,
    unsigned char *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk,
    long invld,
    double thresh,
    double minval,
    double maxval,
    double scalf
);

int vlow_wrd
(
    short *buffer,
    short *obuff,
    long *histgm,
    long numh,
    long nsbuf,
    long nlav,
    long nsav,
    long nlb,
    long nsb,
    long nlk,
    long nsk,
    long invld,
    double thresh,
    double minval,
    double maxval,
    double scalf
);

#endif
