/*
************************************************************************
NAME: set_med

PURPOSE: Set the MEDIAN filter value of one pixel

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1           02/90   T. Baltzer   


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: LAS

ALGORITHM DESCRIPTION:

*****************************************************************
	arguments:
	name		description
	----		-----------
	histgm		histogram array (input)
	mid		middle pixel (input)
	oadd		output address (output)

************************************************************************
*/
#include "las.h"
#include "protos.h"

int set_med
(
    long *histgm,
    long mid,
    unsigned char *oadd
)
{

long	k;		/* counter */
long	cntr;		/* summation counter */

      for (cntr = 0, k = 0;   ; k++)
	 {
	 cntr += histgm[k];
	 if (cntr >= mid)  break;
	 }
      *oadd = (unsigned char)(k);

return(E_SUCC);

}    /*  end of set_med()  */
