/*
************************************************************************
NAME: set_medw

PURPOSE: Set the MEDIAN filter value of one pixel (word, I*2 data)

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1           02/90   T. Baltzer   
    2		08/92	D. Etrheim	     Change typecast from unsigned char
					     to short
 


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: LAS

ALGORITHM DESCRIPTION:

*****************************************************************
	arguments:
	name		description
	----		-----------
	histgm		histogram array (input)
	mid		middle pixel (input)
	oadd		output address (output)

************************************************************************
*/
#include "las.h"
#include "protos.h"

int set_medw
(
    long *histgm,
    long mid,
    short *oadd
)
{

long	k;		/* counter */
long	cntr;		/* summation counter */

      for (cntr = 0, k = 0;   ; k++)
	 {
	 cntr += histgm[k];
	 if (cntr >= mid)  break;
	 }
      *oadd = (short)(k);

return(E_SUCC);

}    /*  end of set_medw()  */
