/*
*************************************************************************
NAME: size_bnd

PURPOSE: determines the dimension of the the horizontal and vertical
boundary area surrounding the data.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1           11/89   T. Baltzer   


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: LAS

ALGORITHM DESCRIPTION:
	The amount of horizontal and vertical boundary area surrounding
	the data is a function of the size of the kernal:

		boundary = (kernal size - 1) / 2


*****************************************************************
	arguments:
	name		description
	----		-----------
	 nlk		number of lines in the kernal (input)
	 nsk		number of samples in the kernal (input)
	 nlb		number of lines in the boundary (output)
	 nsb		number of samples in the boundary (output)

************************************************************************
*/

#include "worgen.h"
#include "protos.h"

int size_bnd
(
    long *nlk,
    long *nsk,
    long *nlb,
    long *nsb
)
{

long	non_fatal = 1;  /* non-fatal error status */

if (*nlk < 1 || *nsk < 1)
   {
   c_errmsg("Invalid kernel size","filter-kernel",&non_fatal);
   c_errmsg("Fatal error encountered","filter-fatal",&non_fatal);
   return(E_FAIL);
   }

*nlb = (*nlk - 1) / 2;
*nsb = (*nsk - 1) / 2;

return(E_SUCC);

}

