#ifndef PROTOS_H
#define PROTOS_H

int clenup
(
    struct PARBLK *vblock,	/* variable block 			      */
    long *nmrimg,		/* number of input images to close	      */
    char hosout[][CMLEN],		/* pointer to output host file name           */
    char *subcmd,		/* T. A. E. subcommand-perform which flip type*/
    unsigned char **in92buf,	/* input image I/O buffer                     */
    unsigned char **out92buf,	/* output image I/O buffer                    */
    long err			/* code for fatal error or not		      */
);

int getpar
(
    struct PARBLK *vblock,	/* variable block 			     */
    char *subcmd,			/* T.A.E. subcommand */
    long *rot,			/* rotation for updating ddr cornerpoints     */
    char taein[][CMLEN],		/* pointer to input TAE file array           */
    char hosin[][CMLEN],		/* pointer to input host file array          */
    char taeout[][CMLEN],		/* pointer to output TAE file array          */
    char hosout[][CMLEN],		/* pointer to output host file array         */
    long *nmrimg,			/* number of input images 		     */
    long window[][4],		/* window specifications for input image     */
    long bands[][MAXBND+1],/* band specifications for each input image  */
    long *nbands,			/* number of bands per input image           */
    long *totbnd,			/* total number of bands to be processed     */
    long *msgtim,			/* elapsed time between display messages     */
    char mnmx[]			/* min max flag        		     	     */
);

int initio
(
    char *subcmd,		/* T. A. E. subcommand-perform which flip type*/
    char hosin[][CMLEN],		/* pointer to input host file array           */
    char *hosout,		/* pointer to output host file array          */
    long *nmrimg,		/* pointer to number of input images from IN  */
    long window[][4],		/* window specification of input images       */
    long *totbnd,		/* total number of bands to be processed      */
    long *imgln,			/* storage for number of lines in output img  */
    long *imgsmp,		/* storage for number of samples, output img  */
    long *nl,			/* number of image lines                      */
    long *ns,			/* number of image samples                    */
    long *nl2sav,		/*number of input lines to read & save per buf*/
    long *ns2sav,		/* number of input samples to read & save/ln  */
    long *size,       		/* number of bytes per pixel                  */
    long *dtype,			/* data type of images                        */
    long *bufflg,		/* flag to indicate io buffering is needed    */
    unsigned char **in92buf,     	/* input image I/O buffer                     */
    unsigned char **out92buf     	/* output image I/O buffer                    */
);

int proces
(
    char *subcmd,		/* T. A. E. subcommand-perform which flip type*/
    long *nmrimg,		/* pointer to number of input images specified*/
    long *nbands,		/* number of bands per input image            */
    long *nl,			/* number of image lines                      */
    long *ns,			/* number of image samples                    */
    long *nl2sav,		/* number of input lines to read & save / buf */
    long *ns2sav,		/* number of input samples to read & save /ln */
    long *sabfct,		/* counter for stepping through 1K samples    */
    long *size,       		/* number of bytes per pixel                  */
    long *dtype,			/* data type of images                        */
    unsigned char *inbuf,		/* input image line I/O buffer                */
    unsigned char *outbuf,		/* output image line I/O buffer               */
    unsigned char *in92buf,     	/* input image I/O buffer                     */
    unsigned char *out92buf,     	/* output image I/O buffer                    */
    char *hosout,		/* pointer to output host file name           */
    long *totbnd,		/* pointer to total number of output bands    */
    long bands[][MAXBND+1]  /* array of bands for input image         */
);

#endif
