/****************************************************************************
NAME: GETPAR

PURPOSE: Gets the user-specified parameters and tae globals for check_res.

PROGRAM HISTORY:

Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  ---------------------------------------
    7.2  06/99  G.Schmidt        EDC   Updated to support Fast-L7A.
         10/01  A.Weissenberger  EDC   CR 5057. Formatting and removed
                                       redundant c_lasmsg calls.
                                       
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
    Must be run under TAE.

PROJECT: LAS

ALGORITHM DESCRIPTION:

NOTES:

****************************************************************************/

#include <string.h>
#include "las.h"
#include "fstfmtin.h"

void crgetpar (
    struct PARBLK *vblk,     /* I: pointer to initial TAE parameter block  */
    char bands[][6],         /* O: array of bands to search for in this file*/
    int *nbands)             /* O: number of bands in bands array           */

{
    struct VARIABLE *var;    /* ptr to a variable in the vblk             */
    int i;                   /* loop variable                             */

    /* Retrieve the bands
       ---------------------*/
    var = p_find(vblk, "BANDS");

    *nbands = var->v_count;
    for (i = 0; i < *nbands; i++)
        strcpy(bands[i],SVAL(*var,i));
}
