/****************************************************************************

NAME: datecon

PURPOSE: Date conversion routine:  yyyymmdd  to  dd-mmm-yy

PROGRAM HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  ---------------------------------------
         10/01  A.Weissenberger        CR 5057. Formatting.
         
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: LAS

ALGORITHM DESCRIPTION:

NOTES:
NO error checking is performed.  The variable 'date' must be
at least 10 characters long.
****************************************************************************/

#include <stdio.h>
#include <string.h>
#include "las.h"
#include "fhdr.h"
#include "util.h"
#include "fstfmtin.h"

SETMONTHDEF(monthdef);

void datecon (
    char date[])       /* input  - a date in the form yyyymmdd  (19910101)
                          output - a date in the form dd-mmm-yy (01-jan-91) */

{
    char indate[10];
    long monthndx=0;
    char tempstr[3];
    long templong;

    strncpy(indate, date, 9);   /* save input date */
    date[2] = '-';
    date[6] = '-';

    date[0] = indate[6];     /* day field */
    date[1] = indate[7];

    date[7] = indate[2];     /* year field */
    date[8] = indate[3];

    tempstr[0]=indate[4];
    tempstr[1]=indate[5];
    tempstr[2]='\0';

    while((monthndx<MONTHCOUNT)
          &&(strcmp(monthdef[monthndx].monthnum,tempstr)))
	monthndx++;
    if (monthndx != MONTHCOUNT)
    {
	strncpy(&date[3],monthdef[monthndx].monthname,3);
	templong = 3;
	c_up2low(&date[3],&templong);
    }
    date[9] = '\0';  /* string terminator */
}
