/*****************************************************************************
NAME: GETPAR

PURPOSE: Gets the user-specified parameters and tae globals for srch_dir

PROGRAM HISTORY:

Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  ---------------------------------------
    7.2  05/99  G.Schmidt        EDC   Updated to support Fast-L7A.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
    Must be run under TAE.

PROJECT: LAS

ALGORITHM DESCRIPTION:

NOTES:

*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include "las.h"
#include "fhdr.h"
#include "fstfmtin.h"

void sdgetpar (
    struct PARBLK *vblk,      /* I: pointer to initial TAE parameter block   */
    char *srchfile,           /* O: string to be searched for                */
    char bands[][6],          /* O: array of bands to search for in this file*/
    int *nbands)              /* O: number of bands in bands array           */

{
    struct VARIABLE *var;      /* ptr to a variable in the vblk              */
    int i;                     /* loop variable                              */

    /* Get the search file
       ----------------------*/
    var = p_find(vblk, "SRCHFILE");
    strcpy(srchfile, SVAL(*var, 0));

    /* Retrieve the bands
       ---------------------*/
    var = p_find(vblk, "BANDS");

    *nbands = var->v_count;
    for (i = 0; i < *nbands; i++)
        strcpy(bands[i],SVAL(*var,i));
}
