/*****************************************************************************

NAME: STR2INT

PURPOSE: To convert the input string to an integer value.

PROGRAM HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  ---------------------------------------
    7.2  09/99  G.Schmidt        EDC   Initial development
         10/01  A.Weissenberger  EDC   CR 5057 Formatting and removal of
                                       redundant calls to c_lasmsg
                                       
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
    Must be run under TAE.

PROJECT: LAS

ALGORITHM DESCRIPTION:

NOTES: 

*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include "las.h"
#include "fhdr.h"
#include "util.h"
#include "fstfmtin.h"

void main () 
{
    struct PARBLK vblk;        /* TAE parameter block     */
    long std_out = 0;          /* standard out            */
    long tmp_long;             /* temp long value         */
    char instr[6];             /* input band number       */
    long outint;               /* output band value       */

    c_inlas (&vblk, &std_out);

    /* Get the variables from the TAE variable block
       ------------------------------------------------*/
    s2igetpar (&vblk, instr);

    if (!strcmp (instr, "P"))
        outint = 9999;
    else
        outint = atol (instr);

    /* Pass the integer back to TAE
       -------------------------------*/
    if (E_SUCC != lng2tae(&vblk,&outint,1,1,"OUTINT",&tmp_long))
    {
        c_lasmsg(TRUE,"fstfmtin-lng2tae","Error outputting OUTINT");
    }

    if (q_out(&vblk) != SUCCESS)
    {
        c_lasmsg(TRUE,"fstfmtin-qout","Error passing variables to TAE");
    }
}
