/*******************************************************************************
FUNCTION:   Calculate_nbands    

PURPOSE:    Calculate number of bands that will fit on a tape.  

ALGORITHM REFERENCES    none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "tapeio.h"
#include "protos.h"

void calculate_nbands
(
    long *unit,                 /* Tape unit number */
    long window[][4],           /* window for image */
    long *odtype,               /* data type of output */
    long totbnd,                /* total bands to be written */
    long *bands_per_tape        /* number of bands to be written to one tape */
)
{
    struct TAPEDESC *drive; /* tapeio descriptor structure */

    long band_size;         /* size of a band */
    long tape_size;         /* size of tape */
    long linsiz;            /* size of each line */
    static long datsize[] = {0,1,2,4,4,8};/* size of each data type */


    linsiz = (window[0][NS] * datsize[*odtype] + 511) & ~0x1ff;

    if (((window[0][NS] * datsize[*odtype]) % 512) == 0)
        band_size= 512 + (linsiz * window[0][NL]);
    else
        band_size = 512 + (linsiz * window[0][NL]) -
            (512 - ((window[0][NS] * datsize[*odtype]) % 512));

    drive = (struct TAPEDESC *) *unit;
    /* .87 seems to work for both 9 track and 3480 when 32 K blocks and 3
       bands are used.  Used .8 for a saftey factor.
       -------------------------------------------------------------------*/
    tape_size = (long)(drive->tape_bpi * drive->tape_len * .8);
    *bands_per_tape = tape_size/band_size;
    if (*bands_per_tape > totbnd)
        *bands_per_tape = totbnd;
    if (totbnd < 1)
        totbnd = 1;
}

