/******************************************************************************
FUNCTION:   DDR2FHDR    

PURPOSE:    Creates a Fast Format Header out of a DDR   

PROJECT:    LAS

ALGORITHM REFERENCES:   none.

******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "labserv.h"
#include "header.h"
#include "fhdr.h"
#include "protos.h"

/* Global variable declarations
-------------------------------*/
struct PARBLK vblock;           /* TAE parameter block                        */

int main
(void)
{
    FILE *fp;
    long flag;                      /* flag to indicate if header file exits  */
    long zero = 0;                  /* Value of zero                          */
    char header[HEADER_SIZE];       /* header buffer                          */
    char hosin[1][CMLEN];           /* Host input file names                  */
    char tempstr[80];

    long std_out;                   /* fortran standard out LUN               */
    struct VARIABLE *val;           /* pointer to a TAE variable              */


    /* Initialize TAE and LAS
       -------------------------*/
    c_inlas(&vblock,&std_out);

    /* Retrieve the input image
       ---------------------------*/
    val = p_find(&vblock,"IN");
    c_cmhost(SVAL(*val,0), hosin[0]);

    /* create header file
       --------------------------*/
    c_lsmknm(hosin[0],"fhdr",tempstr);
    if (c_lsstat(tempstr,&zero) == E_SUCC)
        c_lasmsg(TRUE,"ddr2fhdr-exist","Header file already exists");
    else
    {
        c_lasmsg(FALSE,"informational","FHDR file does not exist on disk");
        c_lasmsg(FALSE,"informational","Creating a template FHDR");
        template_header(header);

        fill_header(header,hosin,"","ddr2fhdr");

        /* create temp file for testing
           -------------------------------*/
        fp = fopen("temp","w");
        fwrite(header,1,HEADER_SIZE,fp);
        fclose(fp);

        /* write the updated header file to disk and to tape
           --------------------------------------------------*/
        flag = IWRITE;
        open_header(header,hosin[0],&flag,&zero,"ddr2fhdr");
    }

    /* Standard completion message
       ------------------------------*/
    c_complt("DDR2FHDR","DDR2FHDR completed successfully",&zero);

    return 0;
}
