/*******************************************************************************
FUNCTION:   update_header   

PURPOSE:    Update the header with the volume specific information. 

ALGORITHM REFERENCES    none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "header.h"
#include "protos.h"

void update_header
(
    char *header,               /* header buffer                        */
    long nl,                    /* number of lines                      */
    long ns,                    /* number of samples                    */
    long start_band,            /* starting band number                 */
    long bands_per_tape,        /* ending band number                   */
    long *blksiz                /* blocking factor                      */
)
{
    long bands;         /* band counter                     */
    long temp;          /* temporary variable               */
    char band[8];       /* array to hold band numbers       */

    /* fill fields in header file that must be filled for each tape
       -------------------------------------------------------------*/
    if (c_fhdrup(header,35,"1/1") == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    temp = 1;
    if (c_fhdrup(header,37,(char *)&temp) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    if (c_fhdrup(header,39,(char *)&nl) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    if (c_fhdrup(header,59,(char *)&ns) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    for (bands = 0; bands < bands_per_tape; start_band++, bands++)
    {
        sprintf(&band[bands],"%d",start_band);
        strncpy(&band[bands + 1],"       ",7-bands);
    }
    if (c_fhdrup(header,95,band) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    if (c_fhdrup(header,97,(char *)blksiz) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    temp = *blksiz * ns;
    if (c_fhdrup(header,99,(char *)&temp) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
    if (c_fhdrup(header,61,(char *)&nl) == E_FAIL)
        c_lasmsg(TRUE,"fstfmtout-update","Error updating header");
}

