#include "gaustran.h"

void comcalc
(
    long num_pixels,			/* number of pixels in the input image*/
    long num_lines,			/* number of lines in the input image */
    long tot_inband,			/* number of input bands              */
    float scalfact[50],			/* scale factors for the result of   */
    float expsf[50],			/* scale factors for the exponent    */
    float offset[50],			/* offset to be subtracted from the  */
    long ipoint[],
    long opoint[]
)

{

/*
*****************************************************************************

NAME:	 COMCALC	

PURPOSE: Computes the gauss transfer function of an image. 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1         18-Sep-84    B. Dealy
   2         16-Oct-89    K. Kunska          conversion to 5.0   
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Inititalize and enable the processing message utility.
   Calculate the gaussian transfer function.
   Calculate the exponential value.
   Assign the newly computed value to the output pixel.

*****************************************************************************
*/

double	expsf_value,			/* power for e                        */
	e_value,			/* result of raising e to expsf_value */
	exponent,			/* exponent for the power function    */
 	pixel;				/* curent pixel                       */

long	band,				/* curent band being processed        */
	i, j,				/* loop counter and array index       */
	line,
	msg_flag=0;			/* flag for the processing message    */					/* utility                            */

/*
Inititalize and enable the processing message utility.
------------------------------------------------------
*/
exponent = 2;
line = 0;
curent = 1;

c_inittm ("GAUSTRAN", "Processed", "line", "bands", "", &num_lines, 
          &tot_inband, &msgtim, &msg_flag);
c_startm ();

for (i = 1; i <= num_lines; i++) 
   {
   curent++;
   line++;
   c_estep (&gdescin);
   c_estep (&gdescout);
   for (j = 0; j < num_pixels; j++) 
      {
      for (band = 0; band < tot_inband; band++)
         {
/*
Calculate the gaussian transfer function.
-----------------------------------------
*/
         pixel = inbuf[ipoint[band]+j] - offset[band];
         expsf_value = -expsf[band] * pow (pixel, exponent);
/*
Calculate the exponential value.
---------------------------------
*/
         e_value = exp(expsf_value);
/*
Assign the newly computed value to the output pixel.
------------------------------------------------------
*/
         outbuf[opoint[band]+j] = (float) (e_value * scalfact[band]);
         }
      }
   } 

c_estep (&gdescin);
c_estep (&gdescout);
c_stoptm ();

}
