#ifndef PROTOS_H
#define PROTOS_H

void comcalc
(
    long num_pixels,			/* number of pixels in the input image*/
    long num_lines,			/* number of lines in the input image */
    long tot_inband,			/* number of input bands              */
    float scalfact[50],			/* scale factors for the result of   */
    float expsf[50],			/* scale factors for the exponent    */
    float offset[50],			/* offset to be subtracted from the  */
    long ipoint[],
    long opoint[]
);

void filspec
(
    char hosin[][CMLEN], 		/* host name for input image          */
    char hosout[], 			/* host name for output image         */
    long num_inimages,			/* total number of input images       */
    long num_img_bands[][MAXBND+1],	/* band numbers for each input image  */
    long out_img_bands[][MAXBND+1],	/* band numbers for each output image */
    long out_bands,			/* number of output image bands       */
    long bands_per_img[],		/* number of bands for each image     */
    long ipoint[],
    long opoint[],
    long window[][4]			/* input image dimensions	      */
);

void getpar
(
    char taein[][CMLEN],		/* tae name of the input image              */
    char hosin[][CMLEN],		/* host name of the input image             */
    char taeout[][CMLEN], 		/* tae name of the output image             */
    char hosout[][CMLEN],		/* host name of the output image            */
    long *dtype,			/* data type of the input image              */
    long *bands_per_img, 	/* number of bands per input imgae           */
    long (*img_flag)[2],		/* specified image/band options              */
    long img_limit,		/* maximum number of images                  */
    long (*num_img_band)[MAXBND+1],	/* band numbers for each input image */
    long *num_inimg,		/* total number of input images              */
    long *same_wnd, 		/* same window size? 1=Y 2=N                 */
    long *tot_inbands,		/* total number of input bands               */
    float scalfact[],		/* scale factors for the result of          */
    float expsf[], 		/* scale factors for the exponent           */
    float offset[],  		/* offset to be subtracted from the input   */
    long window[][4]		/* input image dimensions		     */
);


#endif
