/*************************************************************************
NAME: BIP2BIL

PURPOSE:
     To convert a line from band interleave by pixel to band interleave
     by line.

REFERENCES:
     Obtained from tiff2las module

**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "tiffio.h"
#include "geotiffin.h"

void bip2bil
(
    unsigned char *inbuf,       /* O: Processing buffer for strip geoTIFF 
			              images */
    unsigned char *tempbuf,     /* I: temp buffer for image manipulation -
                                      same size as inbuf */                
    int imagesize,		/* I: size of line in image		   */
    int nbands			/* I: number of bands in the image	   */
)

{
  int i;			/* looping variable			   */
  int j;			/* looping variable			   */
  int pixels_per_band = imagesize/nbands;
  unsigned char *band_ptr;

  for (j = 0; j < nbands; j ++)
  {
     band_ptr = &tempbuf[pixels_per_band * j];

     for (i = 0; i < pixels_per_band; i ++)
       band_ptr[i] = inbuf[i*nbands + j];
  }
  memcpy(inbuf,tempbuf,imagesize * sizeof(char));
}
