/*******************************************************************************
NAME:		CW_GETPAR

PURPOSE:	Get the input parameters for convert_window

PROGRAM HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  --------------------------------------
1.0      08/99  D. Hames          C    Original developement

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under UNIX and TAE

PROJECT: LAS

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "geotiffin.h"

void cw_getpar
(
    struct PARBLK *vblock, 	/* I: TAE parameter block 	    */
    double *window,		/* O: image window                  */
    char coorunits[]		/* O: units of the window           */
)
{

struct VARIABLE *val;	/* pointer to a TAE variable 	             */
 
long index;		/* loop variable			     	*/	


/* Retrieve window area to be copied 
-----------------------------------*/
val = p_find(vblock,"WINDOW");
if(val->v_count != 0)
   for (index = 0; index < 4; index++)
       {
       window[index] = RVAL(*val,index);
       }
else
   for (index = 0; index < 4; index++)
       window[index] = 0.0; 

/* Get UNITS
-----------*/
val = p_find(vblock,"UNITS");
if (val->v_count == 1)
    strcpy(coorunits, SVAL(*val,0));
else
    strcpy(coorunits,"");
}
