/*****************************************************************************
NAME: GET_UTMZONEGEN

PURPOSE:  Returns the LAS UTM zone given the generic geoTIFF code.

PROGRAM HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  --------------------------------------
1.0      08/99  D. Hames          C    Original developement

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under UNIX and TAE

PROJECT: LAS

******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "geotiffio.h"
#include "geotiffin.h"

int get_utmzonegen
(
    short *projgeo,		/* I: generic geoTIFF key number for zone*/
    long *zonenum		/* O: LAS zone number			*/
)

{
char temp[5];			/* temporary string for projgeo		*/
char temp2[2];			/* another temp				*/
char *tmp_ptr;

/* The first 3 numbers (160 and 161) of this key represent UTM.  
Zone is the last 2 digits of the key code. Check for the correct 
reference to UTM and get zone 
------------------------------------------------------------------*/
if (*projgeo != 0)
  {
  sprintf(temp,"%ld",*projgeo);
  /* 160 is UTM (North) and 161 is UTM(South) */
  if (strncmp(temp,"160",3) == 0)  
     {
     strncpy(temp2,(temp+3),3);
     temp2[2] = '\0';
     *zonenum = atol(temp2); 
     }
  else if (strncmp(temp,"161",3) == 0)
     {
     strncpy(temp2,(temp+3),3);
     temp2[2] = '\0';
     *zonenum = atol(temp2); 
     *zonenum = -*zonenum;
     }
  else
    c_lasmsg(FATAL,"geotiffin-zonegen","geoTIFF has an invalid UTM zone code"); 
  }
return(E_SUCC);
}

