/******************************************************************************
FUNCTION:	GETDATE

PURPOSE:	Get the current date and return the values 
		back to the TAE parameter block.

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 5.0       06/92    J. LaVergne		initial development
 6.0       10/98    D. Hames            Add code to to comply
                                        with localtime & y2k
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
		Run under TAE

PROJECT			LAS

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>		/* C standard I/O include file         */
#include <time.h>               /* C standard TIME include file        */
#include "las.h"		/* LAS include			       */

main()
{
long	now;			/* time now		      	  	*/
long    year;                   /* year                                 */
struct tm *curtime,     	/* current time                         */
          *localtime(); 	/* get current time                     */

struct PARBLK   vblock;		/* TAE parameter block			*/

char prog[11];			/* program exit string			*/
char dd[3];                     /* day                                  */
char mm[3];                     /* month                                */
char yy[3];                     /* year                                 */
char hour[3];                   /* hours                                */
char mins[3];                   /* minute                               */
char secs[3];                   /* second                               */
char *sptr[1];                  /* pointer array for updating vblock    */
long one = 1;			/* value of one				*/
long std_out;			/* standard output device 		*/

/*
  Initialize LAS
*/
c_inlas(&vblock,&std_out);

/*
  Get the current date and extract the month, day, and year
*/
now = time(NULL);
curtime = localtime(&now);

/*
   used to retrieve 2 year digits for dates after the year 2000
*/
year = curtime->tm_year;        
year = year%100;         

sprintf(mm,"%02d",curtime->tm_mon + 1);
sprintf(dd,"%02d",curtime->tm_mday);
sprintf(yy,"%02d",year);
sprintf(hour,"%02d",curtime->tm_hour);
sprintf(mins,"%02d",curtime->tm_min);
sprintf(secs,"%02d",curtime->tm_sec);

/*
  Output the values to the variable block
*/
sptr[0] = dd;
q_string(&vblock,"DAY",1,sptr,P_UPDATE);
sptr[0] = mm;
q_string(&vblock,"MONTH",1,sptr,P_UPDATE);
sptr[0] = yy;
q_string(&vblock,"YEAR",1,sptr,P_UPDATE);
sptr[0] = hour;
q_string(&vblock,"HOUR",1,sptr,P_UPDATE);
sptr[0] = mins;
q_string(&vblock,"MIN",1,sptr,P_UPDATE);
sptr[0] = secs;
q_string(&vblock,"SEC",1,sptr,P_UPDATE);
q_out(&vblock);

/*
  Terminate the program without a completion message
*/
strcpy(prog," ");
z_exit(one,prog);
}
