/*******************************************************************************
NAME:    Gethost

PURPOSE: Get the name of the current computer system

PROGRAM HISTORY:

VERSION  AUTHOR           DATE   REASON
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          11/92  Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS/LAS
*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"


int main
(void)
{
struct PARBLK   vblock;    /* TAE parameter block                             */

long fatal    = -1;        /* Fatal error code                                */
long nonfatal =  1;        /* Nonfatal error code                             */
long stdlun;               /* Standard output                                 */

char *ptr[1];              /* Array of pointers to send strings to TAE        */
char host[CMLEN];          /* Name of the current computer                    */


/* Initialize LAS
-----------------*/
c_inlas(&vblock, &stdlun);


/* Get the host name
--------------------*/
gethostname(host, CMLEN);


/* Send the host name back to the TAE variable block
----------------------------------------------------*/
ptr[0] = host;
if (q_string(&vblock, "HOST", 1, ptr, P_UPDATE) != SUCCESS)
   {
   c_errmsg("Error sending host name to TAE", "gethost-send", &nonfatal);
   c_errmsg("Fatal error encountered", "gethost-fatal", &fatal);
   }
if (q_out(&vblock) != SUCCESS)
   {
   c_errmsg("Error sending host name to TAE", "gethost-send", &nonfatal);
   c_errmsg("Fatal error encountered", "gethost-fatal", &fatal);
   }

/* Issue a successful status to TAE
-----------------------------------*/
z_exit(1, "GETHOST completed successfully");

return EXIT_SUCCESS;
}
