#ifndef PROTOS_H
#define PROTOS_H

#include "ltable.h"

struct TAB_INFO
   {
   struct TAB_DEF data;
   struct TAB_DEF desc;
   };

int attck
(
    struct HEADER *hdr,		/* Header information from the GOF. (I)	      */
    char inatt[][ATTIN],		/* Input attribute string. NAME:VALUE
				   NOTE: Any of the MAXATT input attributes
				   that do not have a specified attribute
				   must be assigned a null string. (I)	      */
    char outatt[][ATTVAL],	/* Output attribute VALUES. In the order
				   defined by the header record from the 
				   ARL. (O)				      */
    int index[MAXATT],		/* Indices of attributes for searching. (I)   */
    int *search		/* Flag indicating checking by a search func.
				   (I)					      */
);

int check_attrb
(
    char inatr[][ATTVAL],	/* Attribute values of current GOF record (I) */
    char atrval[][ATTVAL],	/* User specified attribute values (I)	      */
    int  atrindex[],		/* Indices corresponding to attribute names
				   in the GOF header record (I)		      */
    long numatr		/* Number of attributes specified by the user
				   numatr(I)				      */
);

void data_annot_hdr
(
    struct TAB_DEF *tab		/* Labeled table definition structure (I)     */
);

void data_xy_hdr
(
    struct TAB_DEF *tab		/* Labeled table definition structure (I)     */
);

int desc_hdr
(
    struct TAB_DEF *tabl,		/* Labeled table definition structure (I)     */
    union GOF *gofrec,	/* GOF header record (I)		      */
    long *attnmr,	/* Number of attributes defined by the GOF (O)*/
    long attyp[]	/* Data type of each attribute (O)	      */
);

void open_lt
(
    struct TAB_INFO *tab,		/* LT file descriptors (O)                    */
    char *las_gof, 	/* LAS name of input GOF (I) 		      */
    char *host_tab,	/* Host name of output Labeled Table file (I) */
    char *ftype,		/* Input GOF type (I)                         */
    char *desc		/* Labeled Table file description (I)         */
);

void process_annot
(
    char *host_gof,	/* hos name of input GOF (I) 		      */
    char *las_gof,	/* LAS name of input GOF (I) 		      */
    char *host_tab,	/* Host name of output Labeled Table file (I) */
    char *ftype,		/* Input GOF file type (I)                    */
    char inatr[][ATTIN],	/* User specified GOF attributes (I)          */
    long numatr,		/* Number of user specified GOF attributes (I)*/
    char *desc,		/* Labeled Table file description (I)         */
    long msgtim		/* Number of seconds between processing
				   messages (I)				      */
);

void process_point
(
    char *host_gof,	/* host name of input GOF (I) 		      */
    char *las_gof,	/* LAS name of input GOF (I) 		      */
    char *host_tab,	/* Host name of output Labeled Table file (I) */
    char *ftype,		/* Input GOF type (I)                         */
    char inatr[][ATTIN],	/* User specified GOF attributes (I)          */
    long numatr,		/* Number of user specified GOF attributes (I)*/
    char *desc,		/* Labeled Table file description (I)         */
    long msgtim		/* Number of seconds between processing
				   messages (I)				      */
);

void process_poly_line
(
    char *host_gof,	/* LAS name of input GOF (I)		      */
    char *las_gof,	/* LAS name of input GOF (I)		      */
    char *host_tab,	/* Host name of output Labeled Table file (I) */
    char *ftype,		/* File type of the GOF (I) 		      */
    char inatr[][ATTIN],	/* User specified GOF attributes (I)          */
    long numatr,		/* Number of user specified GOF attributes (I)*/
    char *desc,		/* Labeled Table file description (I)         */
    long msgtim		/* Number of seconds between processing 
				   messages (I)				      */
);

#endif
