#ifndef EZIO_H
#define EZIO_H

#include "las.h"
#include "util.h"

/* Define "constants"
  -----------------*/
#define BYTE	 1
#define SHORT	 2
#define LONG	 3
#define FLOAT	 4
#define DOUBLE	 5
#define COMPLEX	 6
#define DCOMPLEX 7

void start
(
    char name[25]          /* Name of LAS function */
);

float get_float
(
    char parm[25]
);

void finish
(
    int reduce_flag  /* flag to indicate the output image was reduced from
                        the input image (1=reduced, 0=enlarged) */
);

void proc_mess
(
    long num_bands
);

void get_line
(
    unsigned char *buf,
    int current_band,
    int in_image_line
);

void put_line
(
    unsigned char *buf,
    int output_band,
    int out_image_line
);

void init_outimg
(
    long nl,
    long ns,
    long nb,
    long odtype
);

unsigned char* init_buf
(
    long length,
    long dtype,
    long nbands

);

void init_inimg
(
    long *nl,
    long *ns,
    long *nb,
    long dtype,
    int bands_to_process[]
);

#endif
