/****************************************************************************
NAME:				derivative

PURPOSE:  Computes the derivative of a polynomial at a given point

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		CODE/CONT   REASON
-------		----	------		---------   ------
  5.0		1/89	D. Steinwand	   CSB      LAS 5.0 Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   must be run under TAE

PROJECT:  LAS

ALGORITHM DESCRIPTION:
	If var_num == 1, differentiate polynomial in x
	   Return evaluated polynomial
	If var_num == 2, differentiate polynomial in y
	   Return evaluated polynomial
*****************************************************************************/
#include "las.h"
#include "local_protos.h"

double derivative
(
    long var_num,		/* =1; derivative in x, =2; derivative in y */
    long degree,	    /* Degree of polynomial */
    double *a,	        /* Polynomial coefficients */
    double x,	        /* Y point coordinate */
    double y 	        /* Y point coordinate */
)
{
if (var_num == 1)
 {
 if (degree == 4) return(a[1]+y*(a[4]+y*(a[8]+y*a[13]))+x*(2*a[3]+x*(3*a[6]+
                         4*a[10]*x)+y*(2*a[7]+3*a[11]*x+2*a[12]*y)));
 if (degree == 3) return(a[1]+y*(a[4]+y*a[8])+x*(2*a[3]+x*3*a[6]+y*2*a[7]));
 if (degree == 2) return(a[1]+y*a[4]+x*2*a[3]);
 return(a[1]);
 }
if (degree == 4) return(a[2]+x*(a[4]+x*(a[7]+x*a[11]))+y*(2*a[5]+y*(3*a[9]+
                        4*a[14]*y)+x*(2*a[8]+3*a[13]*y+2*a[12]*x)));
if (degree == 3) return(a[2]+x*(a[4]+x*a[7])+y*(2*a[5]+y*3*a[9]+x*2*a[8]));
if (degree == 2) return(a[2]+x*a[4]+y*2*a[5]);
return(a[2]);
}
