/****************************************************************************
NAME:				gabort

PURPOSE:  Handles all fatal error conditions & exits gracefully

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		CODE/CONT   REASON
-------		----	------		---------   ------
  5.0		10/88	D. Steinwand	   CSB      New development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   must be run under TAE

PROJECT:  LAS

ALGORITHM DESCRIPTION:
	Determine error condition
	Print error message
	Print final error message and exit

ALGORITHM REFERENCES:
*****************************************************************************/
#include "las.h"
#include "geompak.h"
#include "local_protos.h"

void gabort
(
    long status         /* Error condition flag */
)
{
long pass = 1;			/* Do not abort processing */
long fatal = -1;		/* Abort processing */

switch(status)
   {
   case BAD_DEGREE:
	c_errmsg("Polynomial degree not supported","gridgen-degree",&pass);
	break;
   case NOT_POLY:
	c_errmsg("Model is not a polynomial model","gridgen-not_poly",&pass);
	break;
   case NO_SPACE:
	c_errmsg("Unable to allocate dynamic memory","gridgen-alloc",&pass);
	break;
   case DEGENERATE:
	c_errmsg("Transformation not one-to-one","gridgen-degenerate",&pass);
	break;
   }
c_errmsg("Fatal error encountered","gridgen-fatal",&fatal);
}
