#ifndef LOCAL_PROTOS_H
#define LOCAL_PROTOS_H

#include "geompak.h"  /* GEOGRID structure definition */


double derivative
(
    long var_num,		/* =1; derivative in x, =2; derivative in y */
    long degree,	    /* Degree of polynomial */
    double *a,	        /* Polynomial coefficients */
    double x,	        /* Y point coordinate */
    double y 	        /* Y point coordinate */
);

void gabort
(
    long status         /* Error condition flag */
);

int getpar
(
    char *in_name,			/* Input grid file name */
    char *out_name,			/* Output grid file name */
    int  *window,			/* Mapping grid window (size) */
    double *tolerance,		/* Tolerance for linear approximation */
    long *nglines,          /* Number of lines in each cell */
    long *ngsamps,          /* Number of samples in each cell */
    long *msgtim 			/* Message time variable */
);

int make_grid
(
    struct GEOGRID *grid,		/* Geometric mapping grid */
    int  *wind, 			    /* User specified window */
    int  nl,	    		    /* Number of lines per grid cell */
    int  ns,	    		    /* Number of samples per grid cell */
    double tolerance,           /* Error tolerance (in pixels) for grid 
                                   generation */
    long msgtim		        	/* Processing message timer */
);

#endif
