#include "protos.h"

void dyn_alloc
(
    long totbnd,          /* I: total no. of bands */
    long ncls,            /* I: total no. of classes */
    long *isno[MAXCLS]    /* O: site indices */
)
/*
*********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for large matrices 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/17/88  K. A. Narayanan
  2.0         08/31/88  B. Allam

*********************************************************************
*/
{
long	buf_size,                   /* size of matrices       */
        i, n, m;

long    fatal_err = -1;

/*
allocate storage for covariance matrices 
-----------------------------------------
*/
buf_size = ncls * ncls * sizeof(long);

if ((isno_matrix = (long *) malloc( buf_size)) == NULL) 
    g_errmsg ("Error allocating dynamic memory", "grndspot-alloc", &fatal_err);
/*
set up pointers for covariance matrices 
----------------------------------------
*/
for (i = 0, n = 0, m = 0; i < ncls; i++, n += ncls, m += totbnd)
   isno[i] = &isno_matrix[n];

/*
Allocate storage for polygon matrices
-------------------------------------
*/
buf_size = MAX_POLYGON * 201 * sizeof(long);

if ((x_matrix = (long *) malloc (buf_size)) == NULL ||
    (y_matrix = (long *) malloc (buf_size)) == NULL)
    g_errmsg ("Error allocating dynamic memory", "grndspot-alloc", &fatal_err);

for (i=0, m=0; i < MAX_POLYGON; i++, m+= 201) {
   xaxis[i] = &x_matrix[m];
   yaxis[i] = &y_matrix[m];
}
}
