#include "protos.h"

void getpoly
(
    long ic,              /* I: class index number */
    long is,              /* I: site index number */
    long xaxis[],
    long yaxis[],         /* O: x and y co-ords of site vertices */
    long *nverts,         /* O: number of vertices */
    long xoff,
    long yoff             /* I: x and y offsets */
)
/*
---------------------------------------------------------------------
NAME: GETPOLY

PROGRAM HISTORY:
      Version            date             Author
      -------            ----             ------
         4             5-apr-89          K. Narayanan copied from ZIP
                                                      and made small changes
         3              june-88          B. Allam
         2              feb -87          R. Mckinney
         1              june-84          Y. Sheu
 
FUNCTION:  Get polygon vertices from statistics file for site
-----------------------------------------------------------------------
*/
{
long	xyvert[401];         /* x and y coords for vertices as returned 
                                from statistics file */
long	vshape[9];           /* stats data descriptor for vertices */
long	nv, indx,            /* counter variables */
        stat;                /* status returned */

long    fatal_err = -1;

/*
get polygon from stats file
---------------------------
*/
stat = c_stget((FILE **)&fd_sfin, "POLYGON", &ic, &is, vshape, 
                (unsigned char *)xyvert);
if (stat != E_SUCC)
  g_errmsg ("Error reading polygon", "grndspot_poly", &fatal_err);
if (vshape[2]  >  200)
  g_errmsg ("Maximum # site vertices = 200. Simpify site shapes", 
           "grndspot_nvert", &fatal_err);

*nverts = vshape[2];

/*
get x , y  coordinates
----------------------
*/
indx = 0;
for (nv = 0; nv < *nverts; nv++)
   {
   xaxis[nv] = xyvert[indx] - xoff + 1;
   yaxis[nv] = xyvert[indx + 1] - yoff + 1;
   indx = indx + 2;
   }  /* do */

}
