#include "grndspot.h"
#include "geompak.h"
#include "protos.h"

void gettrmat 
(
   char hostfin[], 	        /* I: transformation matrix host name   */	
   float   tmat[2][MAX_COEFF],  /* O: transformation matrix             */ 
   long    *ncoeff              /* O: no. coefficients                  */
)

/*
***************************************************************************

NAME: GETTRMAT

PURPOSE: Reads transformation matrix from grid file

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          2/15/84   K. A. Narayanan
   2          4/19/89   K. A. Narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM/DESCRIPTION:

   get grid from grid file
   get number of coefficients in transformation polynomial
   get transformation coefficients for X and Y

***************************************************************************
*/
{
struct	GEOGRID	grid;

long	i;
long    fatal_err = -1;


/*
get grid from grid file
-----------------------
*/
if (c_getgrd (hostfin, &grid) != E_SUCC)
   g_errmsg ("Error getting grid from grid file", "grndspot-grid", 
             &fatal_err);

/*
get number of coefficients in transformation polynomial
--------------------------------------------------------
*/
*ncoeff = grid.ncoeff;

/*
read transformation coefficients for y and x
--------------------------------------------
*/
for (i = 0; i < *ncoeff; i++) 
   {
   tmat[0][i] = grid.coeffs[i];
   tmat[1][i] = grid.coeffs[*ncoeff + i];
   }
}

