#include "protos.h"
#include "util.h"

void getwindow
(
    long dtype,           /* I: image data type                       */
    long nbands,          /* I: no. bands                             */
    long wind[4],         /* I: coordinate window                     */
    char intae[][CMLEN],  /* I: input images las names                */
    char comment[],       /* I: user comment to store in output file  */
    char subc[]           /* I: subcommand                            */
)
/*
***************************************************************************

NAME: GETWINDOW

PURPOSE: Gets the greylevels for all pixels in a specified window
         and outputs them to the chosen device. 


PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1             2/87   B. Kovalick
   2          4/19/89   K. A. Narayanan    conversion to 5.0
   3         10/26/89   K. A. Narayanan    corrected window handling

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
{
float	grey[MAXBND];

long	header, iband, isamp, line;
long	num_window_pts;

char	field1[11], field2[11];

field1[0] = field2[0] = '\0' ;
if (print[LP] || print[TERM]) 
   {
   sprintf (buf, "\n GRNDSPOT INPUT IMAGE = %s", intae);
   c_txtout (buf, print, fd);
   sprintf (buf, " INPUT WINDOW = (%4d, %4d, %4d, %4d)\n\n",
            wind[SL], wind[SS], wind[NL], wind[NS]);      
   c_txtout (buf, print, fd);
   }

/*
loop thru image and extract coordinates
print them out for one pixel at a time
---------------------------------------
*/
num_window_pts = 0;
header = TRUE;
for (line = 1; line <= wind[NL]; ++line)
   {
   c_estep ((struct GDESC **)&gdesc);
   for (isamp = 1; isamp <= wind[NS]; isamp++)
      {
      for (iband = 0; iband < nbands; iband++)
         grey[iband] = iobuf[ipoint[iband]+isamp-1];

/*
      ------ write out the greylevels for this point ------    

*/
      num_window_pts++;
      if (num_window_pts > 1) header = FALSE;
      dumpvals (grey, nbands, dtype, (isamp+wind[SS]-1),(line+wind[SL]-1),
		header, comment, field1, field2, subc);
      }  
   }  
c_egclse ((struct GDESC **)&gdesc);
}
