#include "las.h"
#include "protos.h"

void parse
(
    char in[],      /* I: input string                 */
    long *index,    /* I/O: parameter index            */
    char out[],     /* O: output parameter             */
    long *len       /* O: parameter length             */
)
/*
***************************************************************************

NAME: PARSE

PURPOSE: Parses input string and gets next parameter value

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          2/15/84   K. A. Narayanan
   2          4/19/89   K. A. Narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Scan input string and skip leading blanks and/or comma
   Read parameter string till next blank or comma or new line
   Return length of parameter string and index for next parameter

***************************************************************************
*/
{

long	i, start, end;
i = *index;

/*
skip comma and blanks
---------------------
*/
while (i  <  80  &&  (in[i]  ==  ' '  || in[i] ==  ',')) i++;
start = i;
i++;

/*
read parameter value till next blank or comma or newline
--------------------------------------------------------
*/
while (i  <  80  &&  !(in[i] ==  ' '  ||  in[i] ==  ',' || in[i] == '\n')) i++;
end = i-1;

/*
return parameter and its length 
-------------------------------
*/
*len = end-start+1;
strncpy (out, &in[start], *len);
out[*len] = '\0';

/*
and index for next parameter
----------------------------
*/
*index = i+1;

}
