#include <stdio.h>
#include <math.h>

#include "las.h"
#include "protos.h"

void readnext 
(
   FILE    *lun,         /* I: coordinates file desc        */
   char    cname[],      /* O: point names                  */
   float   coord[2],     /* O: coordinates                  */
   long    *flag         /* I/O: EOF flag                   */
)

/*
***************************************************************************

NAME: READNEXT

PURPOSE: Read next record and get point name and coordinates

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          2/15/84   K. A. Narayanan
   2          4/19/89   K. A. Narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Read next record into a buffer
   If end of file set flag to false and return
   Call PARSE to get point name, and the coordinates

***************************************************************************
*/
{
/*double	atof (); */

long	index, len;

char	in[80], ind[80];

/*
read text file
--------------
*/
if (fgets (in, 80, lun) == NULL) 
   {
   *flag = FALSE;      
   return;
   }

index = 0;

/*
get point name
--------------
*/
parse (in, &index, ind, &len);
strcpy (cname, ind);

/*
get the two coordinates
-----------------------
*/
parse (in, &index, ind, &len);
coord[0] =  (float) atof (ind);
parse (in, &index, ind, &len);
coord[1] =  (float) atof (ind);
}

