#include "protos.h"

void verts
(
    long size[4],           /* O: site bounding rectangle   */
    long xaxis[],
    long yaxis[],           /* I: x and y image coordinates */
    long nverts             /* I: no. of vertices           */
)
/*
---------------------------------------------------------------------
NAME: VERTS
 
PROGRAM HISTORY:
      Version            date            Author
      -------            ----            ------
         4             5-apr-89         K. Narayanan copied from ZIP
                                                     and made small changes
         3           24-june-88         B. Allam
         2              feb -87         R. Mckinney
         1              june-84         Y. Sheu

FUNCTION:    VERTS returns site bounding rectangle in terms of input image
             coordinates.

ALGORITHM:

   Calculate the min and max x and y coordinates
   Find bounding rectangle for site
   
--------------------------------------------------------------------------
*/
{
long	minx, miny,             /* minimum coordinates */
        maxx, maxy,             /* maximum coordinates */
        n;                      /* counter value       */

/*
initialize min and max x and y coordinates
------------------------------------------
*/
minx = 999999;
maxx = 0;
miny = 999999;
maxy = 0;

/*
find min. and max. x and y coordinates
--------------------------------------
*/
for (n=0; n < nverts; n++)
   {
   if (xaxis[n]  <  minx) minx = xaxis[n];
   if (xaxis[n]  >  maxx) maxx = xaxis[n];
   if (yaxis[n]  <  miny) miny = yaxis[n];
   if (yaxis[n]  >  maxy) maxy = yaxis[n];
   }  /* do */

/*
find bounding rectangles
------------------------
*/
size[0] = miny; 
size[1] = minx; 
size[2] = maxy;
size[3] = maxx;
}
