/* include files, global parameters, and definitions for HINDU      */

#include <stdio.h>
#include <math.h>
#include "las.h"
#include "statio.h"
#include "util.h"
#include "pixman.h"

#define NR      0			/* number of lines in local window    */
#define NP      1			/* number of pixels in local window   */

#define TERM	0			/* directs output to terminal         */
#define FIL	1			/* directs output to file             */
#define LP	2			/* directs ouput to line printer      */

extern struct	PARBLK	block;		/* TAE parameter block                */
extern struct  DDR	ddr;		/* ddr                                */
extern FILE	*fd1;			/* print file descriptor              */

extern unsigned char	*inbuf;		/* image input buffer                 */
extern unsigned char	*outbuf;	/* image output buffer                */
extern unsigned char	*tempbuf;	/* temporary image buffer             */

extern char    out_files[2][CMLEN]; 	/* output file names                  */
extern char	tmp_files[2][CMLEN];	/* temporary file names               */

extern struct FDESC *  fdescin[MAXIMG+1]; 	/* input file descriptors         */
extern struct FDESC *  fdescout[2];		/* output file descriptor             */
extern struct FDESC *  fdesctmp[2];		/* temporary file descriptor          */

extern struct GDESC *	gdescin;		/* input group descriptor             */
extern struct GDESC *	gdescout;		/* output group descriptor            */
extern struct GDESC *	gdesctmp;		/* temprary group descriptor          */

extern long	ipoint[MAXIMG*MAXBND+1],/* offsets into input image buffer    */
		opoint[MAXBND],		/* offsets into output image buffer   */
		tpoint[MAXBND];		/* offsets into temporary image buffer*/

extern long	min_max;		/* minmax option flag                 */
extern long 	msgtim;			/* message interval                   */
extern long	num_outfiles;		/* number of output files             */
extern long	num_tmpfiles;		/* number of temporary files          */

extern long	curent;			/* current entity                     */
extern long	curcat;			/* current category                   */

extern long	window[MAXIMG][4];    /* input image dimensions (SL SS NL NS) */

extern long	minclus,		/* minimum number of clusters         */
		maxclus,		/* maximum number of clusters         */
		init_grid,		/* initial gray level value for       */
					/* histogram bins                     */
		max_grid,		/* maximum gray level value for       */
					/* histogram bins                     */
		min_grid;		/* minimum gray level value for       */
					/* histogram bins                     */

extern float	*cbuffer;		/* pointer to the centroid array      */

