#include "hindu.h"
#include "protos.h"

void inspec
(
    char hostin[][CMLEN], 		/* host name for input image          */
    long num_inimages,			/* total number of input images       */
    long num_img_bands[][MAXBND+1],	/* band numbers for each input image  */
    long bands_per_img[]		/* number of bands for each image     */
)
/*
*****************************************************************************

NAME: INSPEC

PURPOSE:  Opens the input image file.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         17-Feb-83   C. Gurney/SASC      
   2.0         08-Jul-86   N. Deodhar/STX #212
   3.0         01-Jul-89   K. Kunska/STX	conversion to 5.0
   6.1         24-May-94   D. Eichacker/EDC	Added opt[]

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Open the input image file.
   Allocate buffer space for the input image files.
   Group the input image files.

*****************************************************************************
*/

{

long    one = 1;
char    *prog_name = "HINDU"; /* program name                 */


static 	long	opt[3]={0,0,0};		/* option array for eopens	      */
long	access,				/* access type                        */
	bufsize,			/* buffer size                        */
	n,				/* loop counter and array index       */
	nib,				/* band index                         */
	stat,				/* return status                      */
					/* image bands                        */
	type;				/* data type                          */

long zero = 0;     /*  Constant of zero  */

/*
Open the input image file.
---------------------------
*/
access = IREAD;
type = EBYTE;
for (n = 0, nib = 0; n < num_inimages; n++)
   {
   stat = c_eopens (&fdescin[n], hostin[n], num_img_bands[n], &window[n][SL],
                    &window[n][SS], &window[n][NL], &window[n][NS], 
                    &ipoint[nib], &access, &type, &zero, opt);
   if (stat != E_SUCC)
      c_abort (&block, "Error opening the input image", "hindu-inopen",
               prog_name, out_files, &num_outfiles);
   nib += bands_per_img[n];
   }
fdescin[++n] = 0;

/*
Allocate buffer space for the input image files.
-------------------------------------------------
*/
if ((inbuf = (unsigned char *) c_ealloc (fdescin, &bufsize)) == NULL)
   c_abort (&block, "Error allocating dynamic memory", "hindu-alloc",
            prog_name, hostin, &one);

/*
Group the input image files.
-----------------------------
*/
c_egroup (fdescin, &gdescin, inbuf, &bufsize);

}
