#include "hindu.h"
#include "protos.h"

void sort
(
    float scale[],		/* cluster significance values                */
    long cnums[],		/* bin number of each significant cluster     */
    long signum			/* number of significant clusters             */
)

/*
*****************************************************************************

NAME: SORT

PURPOSE:  Sorts cluster significance values in a descending order.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         17-Feb-85   C. Gurney/SASC      
   2.0         19-May-89   K. Kunska		conversion to 5.0


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   For every significant cluster
      Sort the array scale and array cnums into descending order.

*****************************************************************************
*/

{

float	scl;			/* temporary holder for a significance value  */

long	cnum,			/* bin number of the current significant      */
				/* cluster                                    */
	i,			/* loop counter and array index               */
	low,			/* lower sort index                           */
	sig,			/* current significant cluster                */
	sort_flag,		/* sorting flag                               */
	up;			/* upper sort index                           */

/*
For every significant cluster, sort the array scale and array cnums 
into descending order.
--------------------------------------------------------------------
*/
for (sig = 1; sig <= signum; sig++)
   {
   i = 0;
   up = sig - 1;
   sort_flag = TRUE;
   while (sort_flag == TRUE)
      {
      sort_flag = FALSE;
      low = 0;      
      if (low < up)
         {
         for (i = low; i <= up; i++)
            {
            if (scale[sig] > scale[i])
               {
               scl = scale[sig];
               scale[sig] = scale[i];
               scale[i] = scl;
               cnum = cnums[sig];
               cnums[sig] = cnums[i];
               cnums[i] = cnum;
               sort_flag = TRUE;
               }  /* if */
            }  /* do */
         }  /* if */
      }  /* do */
   }  /* do */

}
