#include "hindu.h"
#include "protos.h"

void tempspec
(
    char hostemp[],			/* host name for temporary image      */
    long tbands				/* bands array for opening temp. img. */
)

/*
*****************************************************************************

NAME: TEMPSPEC

PURPOSE:  Opens the temporary image file for update

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         17-Feb-83   C. Gurney/SASC      
   2.0         08=Jul-86   N. Deodhar/SAR #212
   3.0         19-May-89   K. Kunska/STX	conversion to 5.0
   6.1         24-May-94   D. Eichacker/EDC	added opt[]

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Open the temporary file for update.
   Allocate buffer space for the temporary image file.
   Group the temporay image file.

*****************************************************************************
*/

{

char    *prog_name = "HINDU"; /* program name                 */
long    one = 1;

static	long	opt[3]={0,0,0};		/* option array for eopens            */
long	access,				/* access type                        */
	bufsize,			/* buffer size                        */
	n,				/* loop counter and array index       */
	stat,				/* return status                      */
	tband_array[2],			/* array with the number of temporary */
					/* image bands                        */
	type;				/* data type                          */

long zero = 0;       /* Constant of zero                   */

/*
Open the temporary file for update.
------------------------------------
*/
n = 0;
type = EBYTE;
tband_array[0] = tbands;
tband_array[1] = 0;
access = IUPDATE;
stat = c_eopens (&fdesctmp[n], hostemp, tband_array, &one, &one, 
                 &window[n][NL], &window[n][NS], tpoint, &access, &type, 
                 &zero, opt);
if (stat != E_SUCC)
   c_abort (&block, "Error opening the temporary image", "hindu-tmpopen",
            prog_name, tmp_files, &num_tmpfiles);
fdesctmp[++n] = 0;


/*
Allocate buffer space for the temporary image file.
------------------------------------------------------
*/
if ((tempbuf = (unsigned char *) c_ealloc (fdesctmp, &bufsize)) == NULL)
   c_abort (&block, "Error allocating dynamic memory", "hindu-alloc",
            prog_name, tmp_files, &num_tmpfiles);

/* 
Group the temporay image file.
--------------------------------
*/
c_egroup (fdesctmp, &gdesctmp, tempbuf, &bufsize);

}
