#include "histeq.h"
#include "protos.h"

void filspec
(
    char hosin[][CMLEN],      /* input image host names             */
    long num_inimages,        /* number of input images             */
    long num_image_bands[],   /* number of bands in each input image*/
    long wind[][4]           /* input image windows                */
)
/*
**************************************************************************
NAME: FILSPEC

PURPOSE: Set up file specifications

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1         8-May-89  K. A. Narayanan    

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

**************************************************************************
*/
{
struct	DDR	ddr;

long	access,                      /* file access type                   */
	n, nb, nbands,
	stat,                        /* return status                      */
	one = 1, 
    type;                        /* file type                          */


/*
open input image files for random access
----------------------------------------
*/
c_getddr (hosin[0], &ddr);
if (ddr.dtype != EBYTE)
   c_errmsg ("Input image must be BYTE", "histeq-dtype", &fatal_err);

nb = 0;
access = IREAD;
type = EBYTE;
for (n = 0, nbands = 0; n < num_inimages; n++)
   {
   stat = c_eopenr( &fdesc[n], hosin[n], &nb, &wind[0][SL], 
                   &wind[0][SS], &wind[0][NL], &wind[0][NS], 
                   &access, &type, &zero, &one);
   if (stat != E_SUCC )
      c_errmsg ("Error opening input image", "histeq-open", &fatal_err);
   nbands += num_image_bands[n];
   }  
if ((iobuf = (unsigned char *) malloc (nbands * wind[0][NS]))
                 == NULL)
   c_errmsg ("Error allocating dynamic memory", "histeq-alloc", 
              &fatal_err);
}
