#ifndef PROTOS_H
#define PROTOS_H

#define MAX_DET 50

void filspec
(
    char hosin[][CMLEN],      /* input image host names             */
    long num_inimages,        /* number of input images             */
    long num_image_bands[],   /* number of bands in each input image*/
    long wind[][4]           /* input image windows                */
);

void genhist
(
    long window[],	/* input image window               */
    long *parts, 	/* lut length                       */
    long *jump, 		/* lut entries per detector         */
    long *skip, 		/* skip factor                      */
    long ndetect, 	/* no. detectors                    */
    long image_band_num[][MAXBND + 1],
    long *band,  	/* band being processed             */
    long *num_bands,	/* total number of input image bands*/
    long fhist[], 	/* image histogram                  */
    long maxhist[], 	/* max value for each detector      */
    long accdet[],	/* detectors to use for computing   */
    long nuse 		/* no. detectors to correct         */
);

void genlut
(
    long parts, 		/* lut length                       */
    long jump, 		/* lut entries per detector         */
    long fhist[],	/* image histogram                  */
    long maxhist[],	/* max value for each detector      */
    long ndetect,	/* no. detectors                    */
    long precise,	/* precision                        */
    long detsel[],	/* selected detectors to be corrected */
    long band,		/* band being processed             */
    long num_bands	/* total number of input image bands*/
);

void getpar
(
    char lasin[][CMLEN],      /* input image las name             */
    char hosin[][CMLEN],      /* input image host names           */
    char lasrlut[CMLEN],      /* output image las name            */
    char hosrlut[CMLEN],      /* output image host name           */
    long *num_inimages,       /* number of input images           */
    long num_image_bands[],   /* number of bands in each input image */
    long image_band_num[][MAXBND + 1], /* band numbers in each    */
    long *num_inbands,        /* total number of input image bands   */
    long wind[][4],           /* input image windows              */
    long *ndetect,            /* no. detectors                    */
    long *skip,               /* skip factor                      */
    long *precise,            /* precision                        */
    long detsel[MAX_DET],     /* selected detectors to be corrected */
    long accdet[MAX_DET],     /* detectors to use for computing   */
    long *idet               /* no. detectors to correct         */
);

void lutout
(
    long parts, 		/* lut length                       */
    long jump, 		/* lut entries per detector         */
    char hosin[][CMLEN],	/* input images host names          */
    long image_band_num[][MAXBND + 1], /* band numbers       */
    long *band,		/* band processed                   */
    char hosout[],	/* output RLUT file host name       */
    long window[4],	/* input image window               */
    long *ndetect,	/* no. detectors                    */
    long num_bands	/* total number of input image bands*/
);

#endif
