/*******************************************************************************
FUNCTION:	IMGCMP

PURPOSE:	Compare two images to determine if they are identical.

Programmer      Date   Modification
--------------  -----  ---------------------------------------------------------
J.Fenno		02/95  Development (copied code from diff)

*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"	
#include "util.h"
#include "protos.h"

#define HALFIMG (MAXIMG / 2)

/*
   The following variables must be declared global for image I/O routines
*/
struct FDESC * fdesc1[HALFIMG+1];		/* File descriptors for first group   */
struct FDESC * fdesc2[HALFIMG+1];		/* File descriptors for second group  */
struct GDESC * gdesc1;			/* Group descriptor for first group           */
struct GDESC * gdesc2;			/* Group descriptor for second group          */
long offset1[HALFIMG*MAXBND+1];	/* Offsets into buffer for first group        */
long offset2[HALFIMG*MAXBND+1];	/* Offsets into buffer for second group       */
extern long curent;		/* Current processing line                    */
extern long curcat;		/* Current processing band                    */

int main
(void)
{
struct PARBLK vblock;			/* TAE parameter block                */

static long bands1[HALFIMG][MAXBND+1];	/* Bands to be processed first group  */
static long bands2[HALFIMG][MAXBND+1];	/* Bands to be processed second group */

long msgtim;				/* Elapsed time between processing msg*/
long nbands1[HALFIMG];			/* Number of bands per input image    */
long nbands2[HALFIMG];			/* Number of bands per input image    */
long nmrimg1;				/* Number of input images             */
long nmrimg2;				/* Number of input images             */
long std_out;				/* Standard output                    */
long totbnd;				/* Total number of bands              */
long window1[HALFIMG][4];		/* Window for each input image        */
long window2[HALFIMG][4];		/* Window for each input image        */
long zero		= 0;		/* Value of zero                      */

double tolval;				/* Tolarence value                    */

char hosin1[HALFIMG][CMLEN];		/* Host names of input images         */
char hosin2[HALFIMG][CMLEN];		/* Host names of input images         */


/*
  Initialization
*/
c_inlas(&vblock, &std_out);


/*
  Get parameters
*/
getpar(&vblock, hosin1, &nmrimg1, window1, bands1, nbands1, &totbnd, hosin2,
    &nmrimg2, window2, bands2, nbands2, &msgtim, &tolval);


/*
  Compare the images
*/
process(hosin1, nmrimg1, window1, bands1, nbands1, totbnd, hosin2,
    nmrimg2, window2, bands2, nbands2, msgtim, tolval);


/* 
  Completion message 
*/
c_complt("IMGCMP", hosin1, &zero);

return EXIT_SUCCESS;

}
