#ifndef PROTOS_H
#define PROTOS_H

int getpar
(
    struct PARBLK *vblock,  /* TAE parameter block                        */
    char hosin1[][CMLEN],	/* Host names of images in IN(1)              */
    long *nmrimg1,		/* Number of input images in IN(1)            */
    long window1[][4],		/* Window for each image in IN(1)             */
    long bands1[][MAXBND+1],	/* Band to compare in IN(1)                   */
    long nbands1[],		/* Number of bands for each image in IN(1)    */
    long *totbnd,		/* Total number of bands to be processed      */
    char hosin2[][CMLEN],	/* Host names of images in IN(2)              */
    long *nmrimg2,		/* Number of input images in IN(2)            */
    long window2[][4],		/* Window for each image in IN(2)             */
    long bands2[][MAXBND+1],	/* Band to compare in IN(2)                   */
    long nbands2[],		/* Number of bands for each image in IN(2)    */
    long *msgtim,		/* Elapsed time between processing messages   */
    double *tolval		/* Tolarence value                            */
);

int process
(
    char hosin1[][CMLEN],	/* Host file names for IN(1)                  */
    long nmrimg1,		/* Number of input images in IN(1)            */
    long window1[][4],		/* Windows for all image in IN(1)             */
    long bands1[][MAXBND+1],	/* Bands specified for each image in IN(1)    */
    long *nbands1,		/* Number of bands for each image in IN(1)    */
    long totbnd,		/* Total number of bands to be compared       */
    char hosin2[][CMLEN],	/* Host file names for IN(1)                  */
    long nmrimg2,		/* Number of input images in IN(2)            */
    long window2[][4],		/* Windows for all image in IN(2)             */
    long bands2[][MAXBND+1],	/* Bands specified for each image in IN(2)    */
    long *nbands2,		/* Number of bands for each image in IN(2)    */
    long msgtim,		/* Elapsed time between processing messages   */
    double tolval		/* Tolerance value                            */
);

#endif
