#ifndef IMGCORNER_H
#define IMGCORNER_H

/* These are the prototypes for IMGCORNER.
   las.h MUST be included before this file
------------------------------------------*/

/* cut.c */
int cut
(
  long polybuf[],              /* O: Polynomial corner buffer */
  long nl,                     /* I: Number of lines in image */
  long ns,                     /* I: Number of samples in image */
  long indist,                 /* I: Distance to move corner toward center */
  long sl,                     /* I: Starting line of image */
  long ss,                     /* I: Starting sample of image */
  long value[],                /* I: Fill value range */
  long bands[][MAXBND+1]       /* I: Band array */
);

/* filter2.c */
void filter2
(
  long inbuf[],                /* I: Buffer */
  long ns,                     /* I: Number of samples per line to process */
  long iinline,                /* I: Input line number */
  long *ptcntr,                /* I: Corner number */
  float *sumx,                 /* O: Sum of x's */
  float *sumy,                 /* O: Sum of y's */
  float *sumxx,                /* O: Sum of x * x */
  float *sumxy,                /* O: Sum of x * y */
  float *n,                    /* O: Number of elements */
  long value[]                 /* I: Range of values to ignore */
);

/* getpar.c */
int getpar
(
  char hosin[][CMLEN],         /* O: Input image */
  long *totbnd,                /* O: Total bands */
  long bands[][MAXBND+1],      /* O: Band array */
  long nbands[],               /* O: Number of bands */
  long *nl,                    /* O: Number of lines */
  long *ns,                    /* O: Number of samples */
  long window[][4],            /* O: Input window */
  long *nmrimg,                /* O: Number of images */
  char prtfile[],              /* O: Output print file */
  long print[],                /* O: Print flags */
  long *indist,                /* O: Shift distance for corners */
  long *value,                 /* O: Fill value */
  char method[]                /* O: Method for finding points */
);

/* imgcorner.c */
void main
(
  void
);

/* get_line */
/* This function is found in imgcorner.c
----------------------------------------*/
void get_line
(
  long bndin,                  /* I: Band number to read */
  long ns,                     /* I: Number of samples per line */
  long *buf                    /* O: Input image buffer */
);

/* lse.c */
int lse
(
  FILE *fptr,                  /* I: Output print file */
  long *curimg,                /* I: Current image counter */
  long nbands[MAXIMG],         /* I: Number of bands in each image */
  long *nl,                    /* I: Number of lines in image */
  long *ns,                    /* I: Number of samples/line in image */
  long *bndin,                 /* I: Band number */
  long value[],                /* I: Range of fill values */
  long x[][4],                 /* O: Coords: each corner & band */
  long y[][4],                 /* O: Coords: each corner & band */
  long bands[][MAXBND+1]       /* I: Band array */
);

#endif
