/******************************************************************************
NAME: datecon

PURPOSE: Date conversion routine:  yyyymmdd  to  dd-mmm-yy

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Must be run under TAE.

PROJECT: LAS

ALGORITHM DESCRIPTION:

NO error checking is performed.  The variable 'date' must be
at least 10 characters long.

******************************************************************************/

#include <stdio.h>
#include "las.h"
#include "protos.h"

int datecon
(
    char date[]       /* input  - a date in the form yyyymmdd  (19910101)
		      output - a date in the form dd-mmm-yy (01-jan-91) */
)

{
   char indate[10];
   
   strncpy(indate, date, 9);   /* save input date */
   date[2] = '-';
   date[6] = '-';
   
   date[0] = indate[6];		/* day field */
   date[1] = indate[7];
   
   date[7] = indate[2];		/* year field */
   date[8] = indate[3];
   
   if (indate[4] == '0')		/* month 1 thru 9 */
   {
      switch (indate[5])
      {
       case '1':
	 strncpy(&date[3],"jan",3);
	 break;
       case '2':
	 strncpy(&date[3],"feb",3);
	 break;
       case '3':
	 strncpy(&date[3],"mar",3);
	 break;
       case '4':
	 strncpy(&date[3],"apr",3);
	 break;
       case '5':
	 strncpy(&date[3],"may",3);
	 break;
       case '6':
	 strncpy(&date[3],"jun",3);
	 break;
       case '7':
	 strncpy(&date[3],"jul",3);
	 break;
       case '8':
	 strncpy(&date[3],"aug",3);
	 break;
       case '9':
	 strncpy(&date[3],"sep",3);
	 break;
      }
   }
   else if (indate[4] == '1')		/* month 10 thru 12 */
   {
      switch (indate[5])
      {
       case '0':
	 strncpy(&date[3],"oct",3);
	 break;
       case '1':
	 strncpy(&date[3],"nov",3);
	 break;
       case '2':
	 strncpy(&date[3],"dec",3);
	 break;
      }
   }
   
   date[9] = '\0';	/* string terminator */
   return(E_SUCC);
}
