/******************************************************************************
*
*  NAME:	WRITELT
*
*  FUNCTION:  WRITELT
*
*  PROGRAM HISTORY:
*    Version	Date	Programmer	Code	Request
*    -------	----	----------	----	-------
*      5.0      10/89	D. Etrheim	CSB	LAS 5.0 conversion	
*
*  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
*		Must be run under TAE
*
*  PROJECT:  LAS
*
*  ALGORITHM DESCRIPTION:
*	Write the permutation number, permutation count, and the list of 
*  attributes that make up this permutation to the labeled table.
*
******************************************************************************/
#include "las.h"
#include "ltable.h"
#include "protos.h"

void writelt
(
    struct TAB_DEF *tab,		/* output labeled table descriptor */
    long *maxout,			/* maximum output permutation thus far */
    long *prmcnt,			/* permutation count			*/
    long *oldatt,			/* attribute list			*/
    long *totbnds,			/* total number of bands		*/
    long *addoff			/* offset to be subtracted		*/
)

{

struct VECTOR *ptr;		/* pointer to current vector */
struct MATRIX size;		/* matrix size */

long     i,			/* loop counter 			*/
         temp;			/* temp value				*/

/* Initialize the needed variables
----------------------------------*/
ptr = tab->vector;

size.nrow = 1;
size.ncol = 1;

/* Write each field to the file 
-------------------------------*/
put_matrix(ptr,I4,&size,maxout);
ptr = ptr->next;

put_matrix(ptr,I4,&size,prmcnt);
ptr = ptr->next;

/* Subtract the offset value before writing.  This value is zero on UNIX 
machines and the minimum of (zero,lowest pixel value in input images).
on VMS machines.
-----------------------------------------------------------------------*/
for (i = 0; i < *totbnds; i++)
    {
    temp = oldatt[i] - *addoff;
    put_matrix(ptr,I4,&size,&temp);
    ptr = ptr->next;
    }

/* Write the record to the file
-------------------------------*/
put_record(tab);

return;
} 
