#ifndef PROTOS_H
#define PROTOS_H

void calculate
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin[][CMLEN],		/* host names of input images		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long (*window)[4],		/* window specification of input images      */
    char procopt[][8],           /* arithematical option(s) to calculate      */
    long optnum,			/* number of mask values		     */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    long totbnd,			/* total number of bands to be processed     */
    long odtype,			/* output data type			     */
    long masknum,		/* number of mask values		     */
    float maskval[][2],		/* mask values				     */
    double pixval		        /* pixel value to replace mask values        */
);

double find_median
(
    double *array,
    long npts
);

void getpar
(
    struct PARBLK *vblock,      /* pointer to TAE block	 	      */
    char taein[][CMLEN],	/* TAE file names of input images	    */
    char hosin[][CMLEN],  	/* host file names of input images	    */
    char taeout[][CMLEN],		/* TAE file name of output image	    */
    char hosout[][CMLEN],		/* host file name of output image	    */
    long *nmrimg, 		 /* number of input images		    */
    long (*bands)[MAXBND+1],         /* band specification 		            */
    long *nbands,		 /* number of bands per input image         */
    long (*window)[4],	         /* window specification		    */
    char options[][8], 		 /* arithematical option(s) to calculate    */
    long *optnum,		 /* number of options specified             */
    long *msgtim,		 /* elapsed time between display messages   */
    char *minmax,		 /* min max flag buffer		            */
    long *totbnd,		 /* total number of bands		    */
    long *odtype,		 /* output data type 			    */
    float maskval[][2],		 /* mask values                             */
    long *masknum,		 /* number of masked values                 */
    float *pixval		 /* pixel value to replace mask values      */
);

#endif

