#include <stdio.h>
#include "las.h"
#include "statio.h"
#include "define.h"
/* 
 * For functions requiring parameters passed by address.
 * Required for fortran compatibilitie reasons.
 */
extern long	zero;
extern long	one;
extern long	fatal_err;
extern long	inf_err;

/*
 * Global to all modules.
 */
extern struct PARBLK	vblock;	/* parameter block */

extern struct DDR	 ddr;

extern char    
	host_in[MAXIMG][CMLEN], /* host name of input image file*/
	host_out[CMLEN],	/* host name of output image file */
	stat_host_in[CMLEN],	/* host name of input stats file */
	stat_host_out[CMLEN],	/* host name of output stats file */
	stat_las_in[CMLEN],	/* las name of input image file */
	stat_las_out[CMLEN],	/* las name of output image file */
	las_in[MAXIMG][CMLEN],	/* las name of input image file */
	las_out[CMLEN];		/* las name of output image file */

extern char	
	*srcstat,		/* source for stats ("NONE", "FILE") */
        out[MAXIMG][CMLEN],	/* name of files opened */
        out_las[MAXIMG][CMLEN],	/* name of files opened */
	minmax [4];		/* min/max determiner ("yes", "no") */

extern unsigned char	
	*buffer_in,		/* buffer for input image (pixman) */
	*buffer_out;		/* buffer for output image (pixman) */

extern short		
	do_minmax,		/* boolean - do minmax calculation? */
        chain_list[MAXCLS],
	dtype_in_size,		/* size of input image data */
	krn,			/* param : frequency of screen stats */
	maxcls,			/* param : maximum # clusters */
	maxit,			/* param : maximum # iterations */
	nclust,			/* # of clusters at any one time */
	view;			/* param : iterations between prompts */

extern long		
	clknt [MAXCLS],		/* count of pixels in clusters */
	nbands [MAXIMG], 	/* # bands in each image */
	totbnd,			/* total # bands to input */
	msgtime,		/* interval between processing msgs */
        print[3],		/* print options */
    	nimages,		/* # of input image files */
	window[MAXIMG][4],	/* dimensions of input image window */
        count,   	        /* count of files opened */
        count_las,	        /* count of las output files */
	dtype_in,		/* data type of input images */
	dtype_out,		/* data type of output image */
	fd_in[MAXIMG],		/* file descriptors for input images */
	fd_out[2],	        /* file descriptor for output image */
	gd_in,			/* group descriptor for input image */
	gd_out,			/* group descriptor for output image */
        nmin,			/* param : min pixels in clust */
	offset_in [MAXIMG],	/* in image offset (pixman) */
	offset_out[1];		/* out image offset (pixman) */

extern float		
	chnths,			/* param : for chaining threshold */
       	*clmean[MAXCLS],
	*clmean_matrix,		/* cluster means */
        *clstdv[MAXCLS],
	*clstdv_matrix,		/* cluster std devs */
	dlmin,			/* param : distance to combine at */
	sep,			/* param : split separation value */
	stdmax;			/* param : split determiner */

extern double	*scov_matrix;	/* covariance matrix */

extern double	*clsumx_matrix,
		*clsumsq_matrix;

extern FILE	*print_file;	/* file descriptor of data print file */

extern short    *cluster;	/* cluster each pixel belongs to */

extern long  	npx [MAXCLS],	/* number of samples in each cluster */
          	nlines,		/* # lines in window */
	        nsamples;	/* # samples in window */

