#ifndef PROTOS_H
#define PROTOS_H

void chk_window
(
    long *outspc,   /* I: output image file specifications    */
    long *window    /* I/O: window area of image to be copied */
);

void chk_bands
(
    long *bands,	/* I/O: bands to be processed within image        */
    long *numbands,	/* I: input image file specifications 	          */
    long *totbnd        /* I/O: total number of bands to be copied        */
);

int gethdr
(
    long *unit,			/* I: tape unit number			*/
    long *wrtdsk,         	/* I: ancillary files to read in 	*/
    char hosout[][CMLEN],       /* I: Output host names                	*/
    long *num_out, 		/* I/O: number of output files         	*/
    unsigned char **hdr_buf	/* O: header buffer read from tape   	*/
);

void getpar
(
    struct PARBLK *vblock, 	/* I: TAE parameter block                    */
    long *bands,		/* O: bands to be processed within image     */
    long *msgtim,		/* O: elapsed time between display msg       */
    long *window,		/* O: window of input image                  */
    long *minmax,	        /* O: min max flag                           */
    char hosout[][CMLEN],	/* O: Output host name          	     */
    char taeout[][CMLEN],	/* O: Output TAE name           	     */
    char *comment,		/* O: tape mount message to the operator     */
    long *wrtdsk        	/* O: ancillary files to read in             */
);

int proces
(
    char hosout[][CMLEN],  /* I: output host names  		      	   */
    long *window,	   /* I: window area of image to be copied 	   */
    long *totbnd,	   /* I: total number of bands to be copied	   */
    long *unit,            /* I: tape unit number                          */
    long *wrtdsk,          /* I: ancillary files to read in                */
    long *num_out,         /* I/O: number of output files 		   */
    long *bands,           /* I: bands to be processed within image        */
    unsigned char *hdr_buf,/* I: header buffer read from tape              */
    long *msgtim,	   /* I: elapsed time between display msg  	   */
    long *minmax	   /* I: min max flag                      	   */
);

void mount_tape
(
    long *unit,		/* O: tape unit number                  	      */
    char *comment	/* I: tape mount message to the operator	      */
);

void close_tape
(
    long *unit		/* I: tape unit number                  	      */
);

int update_ddr
(
    char hosout[][CMLEN],	/* I: Host file name			*/
    long *window,		/* I: Input window			*/
    unsigned char *hdr_buf,     /* I: header buffer read from tape      */
    long *totbnd		/* I: Total number of bands to process	*/
);

#endif
