#include <stdio.h>
#include "las.h"
#include "tapeio.h"
#include "protos.h"

/******************************************************************************
FUNCTION:	MOUNT_TAPE

PURPOSE:	Physically mounts a tape.  

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/

void mount_tape
(
    long *unit,		/* O: tape unit number                  	      */
    char *comment	/* I: tape mount message to the operator	      */
)

{
long access = TREAD;	/* open tape for read access         	      */
long fatal = -1;	/* Fatal error code			      */
long mode = HANDLE;	/* tape I/O outputs error messages   	      */
long rewopt = REWIND;	/* rewind option                     	      */
long skip = 0;		/* skip zero files on open           	      */
long status;		/* function return status code       	      */

char density[5];	/* tape density in BPI               	      */
char tapeid[CMLEN]; 	/* tape id			     	      */

strcpy(density,"0");

/* Mount the current tape volume
--------------------------------*/
status = c_tpopen(unit,&skip,&mode,&rewopt,density,&access,comment, tapeid);
if (status != TAPE_SUCC)
    c_errmsg("Fatal error encountered","jscin-fatal",&fatal);

return;
}

/******************************************************************************
FUNCTION:	CLOSE_TAPE

PURPOSE:	Closes the tape device.

ALGORITHM 
  Close the tape

ALGORITHM REFERENCES	none
*******************************************************************************/
void close_tape
(
    long *unit		/* I: tape unit number                  	      */
)

{
long one = 1;		/* value of one                      	      */
long mode = NO_HANDLE;	/* tape I/O outputs error messages   	      */
long rewopt = REWOFFL;	/* rewind option                     	      */
long status;		/* function return status code       	      */

/* Close the tape
-----------------*/
status = c_tpclos(unit,&mode,&rewopt,&one);
if (status != TAPE_SUCC)
    c_errmsg("Nonfatal error encountered","jscin-nonfatal",&one);

return;
}

