/* include files, global parameters, and definitions for KARLOV      */

#include <stdio.h>
#include <math.h>
#include "las.h"
#include "statio.h"
#include "util.h"
#include "pixman.h"
#include "protos.h"

#define TERM 0
#define LP   1
#define FIL 2

#ifdef GLOBALVARS
struct	PARBLK	block;                 /* TAE parameter block     */

FILE	*fd;                           /* output file descriptor  */

double	*cov_matrix;                   /* dynamic storage for     */
float	*eigen_vectors;                /* covariance matrix and   */
                                       /* eigen vectors           */

struct FDESC *	fdesc[MAXIMG];                 /* file descriptors        */
struct GDESC *	gdesc;                         /* group descriptor        */
long	ipoint[MAXIMG * MAXBND + 1];   /* offsets into image i/o  */
long    opoint[MAXBND];                /* for input and output bands */
long	min_max;                       /* minmax option flag      */
long 	msgtim;                        /* message interval        */
long	num_outfiles;                  /* number of output files  */

unsigned char	*iobuf;                /* image i/o buffer        */
char    out_files[2][CMLEN];           /* output file names       */

extern long	curent;                        /* parameters for processing */
extern long	curcat;                        /* message utility         */
#else
extern	struct	PARBLK	block;                 /* TAE parameter block     */

extern	FILE	*fd;                           /* output file descriptor  */

extern	double	*cov_matrix;                   /* dynamic storage for     */
extern	float	*eigen_vectors;                /* covariance matrix and   */
                                               /* eigen vectors           */

extern	struct FDESC *	fdesc[MAXIMG];         /* file descriptors        */
extern	struct GDESC *	gdesc;                 /* group descriptor        */
extern	long	ipoint[MAXIMG * MAXBND + 1];   /* offsets into image i/o  */
extern  long    opoint[MAXBND];                /* for input and output bands */
extern  long	min_max;                       /* minmax option flag      */
extern	long 	msgtim;                        /* message interval        */
extern	long	num_outfiles;                  /* number of output files  */

extern	unsigned char	*iobuf;                /* image i/o buffer        */
extern  char    out_files[2][CMLEN];           /* output file names       */

extern	long	curent;                        /* parameters for processing */
extern	long	curcat;                        /* message utility         */
#endif
