#ifndef PROTOS_H
#define PROTOS_H

void calc_scale
(
    char hosin[][CMLEN],      /* input image host names             */
    long *num_inimages,       /* number of input images             */
    long num_image_bands[],   /* number of bands in each input image*/
    long image_band_num[][MAXBND + 1], /* band numbers in each      */
    long wind[][4],           /* input image windows                 */
    long *num_inbands,        /* total no. of input bands            */
    long *num_outbands,       /* number of output bands              */
    float *eig_vec[],          /* eigen vectors                       */
    long components[],        /* components in out image            */
    long sub,                 /* subtract option                     */
    float smean[],             /* mean vector                         */
    float *scale,              /* factor for sacling output image   */
    float *offset             /* offset for output image scaling   */
);

void dyn_alloc
(
    long num_inbands,       /* number of input image bands    */
    double *cov[],            /* pointers to covariance matrix  */
    float *eig_vec[]        /* pointers to eigen vectors      */
);

void dyn_free
(void);

void eigvec
(
    char imgname[][CMLEN],      /* image name                    */
    long mode,                  /* processing mode               */
    float smean[],               /* mean vector                   */
    double *cov[],                /* covariance matrix             */
    long nbands,                /* number of input image bands   */
    float *eig_vec[],            /* eigen vectors                 */
    char class[],               /* class name                    */
    long print[]               /* print option                  */
);

void filspec
(
    char hosin[][CMLEN],      /* input image host names             */
    char hosout[],            /* output image host name             */
    long *num_inimages,       /* number of input images             */
    long num_image_bands[],   /* number of bands in each input image*/
    long image_band_num[][MAXBND + 1], /* band numbers in each      */
    long *num_outbands,        /* number of output image bands       */
    long wind[][4],           /* input image windows                */
    long out_type             /* output image data type             */
);

void getpar
(
    char lasin[][CMLEN],      /* input image las name             */
    char hosst[],             /* stats file host name             */
    char hosin[][CMLEN],      /* input image host names           */
    char lasout[][CMLEN],            /* output image las name            */
    char hosout[][CMLEN],            /* output image host name           */
    long *mode,               /* processing mode parameter        */
    char class[],             /* class name parameter             */
    long *num_inimages,       /* number of input images           */
    long num_image_bands[],   /* number of bands in each input image */
    long image_band_num[][MAXBND + 1], /* band numbers in each    */
    long *num_inbands,        /* total number of input image bands   */
    long *num_outbands,       /* number of output image bands     */
    long wind[][4],           /* input image windows              */
    long components[],        /* components for output image      */
    long *sub,                /* subtract option flag             */
    long *out_type,           /* output image data type           */
    long *termtran,           /* trans matrix option flag         */
    long print[],             /* print parameter option           */
    char print_file[]        /* output file                        */
);

void getstat
(
    char hosst[],                 /* stas file host name descriptor   */
    long mode,                    /* processing mode                  */
    char class[],                 /* class name                       */
    long num_inbands,             /* number of image bands            */
    float smean[MAXBND],           /* mean vector                      */
    double *cov[]                  /* covariance matrix                */
);

int jacobi
(
    double *a[],
    long n,
    float d[],
    float *v[],
    long *iterations
);

void prcomp
(
    char hosout[],            /* output image host name              */
    long *num_inbands,        /* total no. of input bands            */
    long *num_outbands,       /* total no. of output bands           */
    long components[],        /* components in output image          */
    long wind[][4],           /* input image windows                 */
    float *eig_vec[],          /* eigen vectors                       */
    long sub,                 /* subtract option                     */
    long out_type,            /* output image data type              */
    float smean[],             /* mean vector                         */
    long print[],             /* print option                        */
    float *scale,              /* factor for sacling output image   */
    float *offset             /* offset for output image scaling   */
);

void terminate
(
    char las_out[],              /* output image las name         */
    char hos_out[],              /* output image host name        */
    char hos_in[][CMLEN],        /* input images host names       */
    long *num_inimages,          /* number of input images        */
    long num_outbands,           /* number of output bands        */
    long print[],                /* output destination            */
    char print_file[]           /* output file name              */
);

void uservec
(
    long num_inbands,      /* no. of input image bands     */
    long num_outbands,     /* no. of output image bands    */
    long sub,              /* subtract option flag         */
    float *eigv[],          /* eigen vector matrix          */
    float mean[]           /* mean vector                  */
);

#endif
