#include "karlov.h"

void terminate
(
    char las_out[],              /* output image las name         */
    char hos_out[],              /* output image host name        */
    char hos_in[][CMLEN],        /* input images host names       */
    long *num_inimages,          /* number of input images        */
    long num_outbands,           /* number of output bands        */
    long print[],                /* output destination            */
    char print_file[]           /* output file name              */
)
/*
**************************************************************************
NAME: TERMINATE

PURPOSE: Free storage, copy image history and issue completion message

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          23-NOV-88   K. Narayanan, SAR    

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

**************************************************************************
*/
{
/*
free dynamic storage 
--------------------
*/
dyn_free ();

/*
output image history and completion message
-------------------------------------------
*/
num_outfiles = 0;
if (num_outbands != 0) 
   {
   strcpy (out_files[num_outfiles++], las_out);
   c_hstout( &block, hos_out, hos_in, num_inimages, "KARLOV"); 
   }

if (print[FIL]) strcpy (out_files[num_outfiles++], print_file);

c_complt ("KARLOV", out_files, &num_outfiles);

}
