#include <string.h>
#include "karlov.h"

void uservec
(
    long num_inbands,      /* no. of input image bands     */
    long num_outbands,     /* no. of output image bands    */
    long sub,              /* subtract option flag         */
    float *eigv[],          /* eigen vector matrix          */
    float mean[]           /* mean vector                  */
)
/*
********************************************************************

NAME: USERVEC

PURPOSE: Input user's transformation (eigen vector) matrix and
         mean vector through terminal

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   2.0         15-aug-88   k. a. narayanan    conversion to 5.0
   1.0         17-may-84   s. ross

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:
   Set up the terminal
   Prompt the user for eigen vectors and rearrange them to be
      compatible with the eigen vectors from EIGVEC
   If required prompt user for mean vector

*********************************************************************
*/
{
char	bnum[4];          
char	prompt[35];

long	cols;
long	lines;
long	i, j;
long	type;

/*
 set up the terminal 
 -------------------
*/
t_init (&lines, &cols, &type);
t_clear();
t_write("          Enter Transformation Matrix", T_DOUBLE);
t_pos(4, 1);

/*
prompt user for tranformation matrix values and rearrange them to be
compatible with the vectors from EIGVEC
--------------------------------------------------------------------
*/
for (i = 0; i < num_outbands; i++)
   {
   strcpy (prompt, "\n Enter vector for output band ");
   sprintf (bnum, "%3d", i+1);
   strcat (prompt, bnum);
   strcat (prompt, " > ");
   t_write (prompt, T_STDCC);
   for (j = 0; j < num_inbands; j++) 
      {
      scanf ("%f", &eigv[i][j]);
      }
   }  

/*
 prompt user for mean vector values
 ----------------------------------
*/
if (sub == 1) 
   {
   t_write (" ", T_DOUBLE);
   t_write (" Enter Mean Vector > ", T_PROMPT);
   for (i = 0; i < num_inbands; i++) scanf ("%f", &mean[i]);
   }  
}
