#include "kmeans.h"
#include "util.h"
#include "protos.h"

void terminate
(
    char las_out[],		/* I: output image las name            */
    char hos_out[],		/* I: output image host name           */
    char hos_in[][CMLEN],	/* I: input images host names          */
    long *num_inimages,		/* I: number of input images           */
    char print_file[]		/* I: print file name                  */
)
/*
**************************************************************************
NAME: TERMINATE

PURPOSE: Free dynamic storage, update image history and issue completion message

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1           16-Feb-89  K. Narayanan, SAR    

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

**************************************************************************
*/
{
long	num_files;

char	files[2][CMLEN];        /* program output files    */

/*
free dynamic storage 
--------------------
*/
dyn_free ();

/*
update output image history
---------------------------
*/
c_hstout (&block, hos_out, hos_in, num_inimages, " "); 

/*
issue completion message
------------------------
*/
if (print[FIL])
   {
   strcpy (files[0], las_out);
   strcpy (files[1], print_file);
   num_files = 2;
   c_complt (prog_name, files, &num_files);
   }
else
   c_complt (prog_name, (char (*)[256])las_out, &one);
}
