/****************************************************************************

NAME: get_utm_projparms

PURPOSE: Fill in the necessary 15 projection parameters for the Universal
         Transverse Mercator projection, set to zero.

RETURN VALUE:
Type = void
Value           Description
-----           -----------

PROGRAM HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  -------------------------------------
  1.0    08/00  G.Schmidt        EDC   Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
  Must be run under TAE.

PROJECT: LAS

NOTES:
  This function assumes the UTM zone code is supplied elsewhere in the
  application.  Thus all 15 projection parameters are set to 0.

****************************************************************************/

#include <string.h>
#include "l7hdf2las.h"

void get_utm_projparms
(
  double proj_parms[15]  /* O: 15 projection parameters for GCTP */
)

{
  int i;  /* looping variable for the projection parameters */

  /* Fill in the projection paramters
     --------------------------------*/
  for (i = 0; i < 15; i++)
    proj_parms[i] = 0.0;

  return;
}
