/****************************************************************************

NAME: srch_vol

PURPOSE: Search for the specified _vol filenames and return any filenames
  that match the wildcard name.

RETURN VALUE:
Type = int
Value           Description
-----           -----------
E_SUCC          Successful completion
E_FAIL          An error occurred during processing

PROGRAM HISTORY:
Version  Date   Programmer       Code  Reason
-------  -----  ---------------  ----  -------------------------------------
  1.0    06/00  G.Schmidt        EDC   Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
  Must be run under TAE.

PROJECT: LAS

****************************************************************************/

#include "l7hdf2las.h"
#include "cm.h"   /* c_getfiles definition */

int srch_vol
(
  char srchfile[],    /* I: wildcard filename to search for (Unix format) */
  char vol_files[MAXFILE][CMLEN],
                      /* O: list of filenames that matched the srchfile
                            search (Unix format) */
  int *nvol_files     /* O: number of files in vol_files */
)

{
  /* Get the filenames that match the srchfile string
     ------------------------------------------------*/
  if (c_getfiles (srchfile, vol_files, nvol_files, MAXFILES, 1 /*first call*/,
    0 /*return list of all files found*/) != E_SUCC)
  {
    c_lasmsg (FALSE, "l7hdf2las-getfiles", "Error searching for _vol files");
    return (E_FAIL);
  }

  return (E_SUCC);
}
