#ifndef PROTOS_H
#define PROTOS_H

#include "proj.h"
#include "arcproj.h"
#include "arctables.h"

void checkproj
(
    char *projok,
    struct PROJCOEFMAP **cmptr,
    long *projvers,
    struct DDR (*ddr),
    long *pc
);

int getpar
(
    struct PARBLK *vblk,   /* pointer to initial TAE parameter block      */
    char   hosin[],        /* Host input image name                       */
    char   outgrid[],      /* Output Arc Grid location                    */
    long   window[][4],    /* Image processing window                     */
    long   *msgtim,        /* Message processing time                     */
    long   *ep3flag,       /* Arc 8.3/NO8.3 flag                          */
    long   *delflg,        /* Delete intermediate files flag              */
    long   *nbands,        /* Number of bands to read from input image    */
    double *projtol        /* Projection tolerance                        */
);

int lng2tae
(
    long data[],         /* input  - array of longs to transfer               */
    long skipf,          /* input  - skip factor                              */
    long num_longs,      /* input  - number of elements                       */
    char varname[],      /* input  - tae name of variable                     */
    long *result        /* output - value of parameter                       */
);

void makehdr
(
    char *gridhdr,       /* Name of .hdr file            */
    long nbands,         /* Number of bands              */
    struct DDR ddr,
    long window[1][4],  /* Window specification         */
    double projtol
);

int makeprj
(
    char *gridprj,
    struct PROJCOEFMAP *cmptr,
    long projvers,
    struct DDR *ddr,
    long pc
);

void makestx
(
    char *gridstx,       /* Name of .stx file                        */
    char *hosin,         /* Name of image (BSQ) file                 */
    struct DDR ddr,            /* (used for .nbands .dtype .nl .ns)        */
    long window[1][4]   /* Window specification                     */
);

#endif
