/*************************************************************
NAME: dateconr

PURPOSE: Date conversion routine: dd-mmm-yy to yymmdd

PROGRAM HISTORY:
Version   Date   Programmer       Code  Reason
-------   -----  --------------   ----  -------
  1.0     06/94  K.Lowell           C   NLAPS

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
  None

PROJECT: LAS

******************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "protos.h"

int dateconr
(
    char date[]	/*input - a date in the form dd-mmm-yy (01-jan-91)
                  output - a date in the form yymmdd (910101) */
)

{
    char indate[10];                /* input date          */
    char day[2];                    /* 2 digit day         */
    char mon[3];                    /* 3 letter month      */
    char mono[2];                   /* 2 digit month       */
    char year[2];                   /* 2 digit year        */
    long nonfatal = 1;              /* nonfatal error flag */
    long three = 3;                 /* constant value 3    */

    /* Save input date
       ------------------*/
    strncpy(indate,date,9);

    strncpy(day,date,2);
    mon[0]=date[3];
    mon[1]=date[4];
    mon[2]=date[5];

    year[0]=date[7];
    year[1]=date[8];

    /* Find what month and assign the
       corresponding 2 digit value
       ---------------------------------*/
    c_up2low(mon,&three);
    if (strncmp(mon,"jan",3) == 0)
        strcpy(mono,"01");
    else if (strncmp(mon,"feb",3) == 0)
        strcpy(mono,"02");
    else if (strncmp(mon,"mar",3) == 0)
        strcpy(mono,"03");
    else if (strncmp(mon,"apr",3) == 0)
        strcpy(mono,"04");
    else if (strncmp(mon,"may",3) == 0)
        strcpy(mono,"05");
    else if (strncmp(mon,"jun",3) == 0)
        strcpy(mono,"06");
    else if (strncmp(mon,"jul",3) == 0)
        strcpy(mono,"07");
    else if (strncmp(mon,"aug",3) == 0)
        strcpy(mono,"08");
    else if (strncmp(mon,"sep",3) == 0)
        strcpy(mono,"09");
    else if (strncmp(mon,"oct",3) == 0)
        strcpy(mono,"10");
    else if (strncmp(mon,"nov",3) == 0)
        strcpy(mono,"11");
    else if (strncmp(mon,"dec",3) == 0)
        strcpy(mono,"12");
    else
        c_errmsg("Error determining the month","las2ndf-month",&nonfatal);

    /* Giving the new format for the date
       -------------------------------------*/
    date[0] = mono[0];
    date[1] = mono[1];
    date[2] = day[0];
    date[3] = day[1];
    date[4] = year[0];
    date[5] = year[1];
    date[6] = '\0';

    return(E_SUCC);
}
