/*****************************************************************************
NAME: PDMS2DMS

PURPOSE:  Converts a packed degree-minute-second number to degrees, 
          minutes, and seconds.  Then makes an NDF dms number.

PROGRAM HISTORY:

Version  Date  Programmer       Code  Reason
-------  ----- ----------       ----  ------
 1.0     01/98 T.Ratliff         C    Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS
*****************************************************************************/

#include <stdio.h>
#include "las.h"
#include "protos.h"

void pdms2dms
(
    double pdms,                      /* Packed degrees-minutes-seconds */
    char *ndfdms,
    long news
)
{
    char dirch;                       /* North, South, East, West       */
    long degree = 0;                  /* Degrees                        */
    long minute = 0;                  /* Minutes                        */
    double sec = 0.0;                 /* Seconds                        */
    double temp = 0.0;

    if (pdms < 0)
    {
        pdms *= -1;
        if (news)
            dirch = 'S';
        else
            dirch = 'W';
    }
    else
    {
        if (news)
            dirch = 'N';
        else
            dirch = 'E';
    }

    degree = (long)(pdms/1000000);
    temp = (pdms - (degree * 1000000));
    minute = (long)(temp / 1000);
    sec = temp - (minute * 1000);

    sprintf(ndfdms,"%03ld%02ld%07.4lf%c",degree,minute,sec,dirch);
}
