#ifndef PROTOS_H
#define PROTOS_H

int conv_coord
(
    struct DDR *ddr,                      /* data in recs 1 and 2 of ddr      */
    double nept[],                        /* array of northing/easting points */
    char llpt[][15]                       /* array of lat/long points         */
);

int createddr
(
    struct PARBLK *vblock,                   /* TAE parameter block        */
    char *hosout,                            /* UNIX format input file     */
    char *outddr,                            /* temporary ddr file name    */
    char fnames[][CMLEN],                    /* file names for translas    */
    long *nfiles,                            /* # of files in fnames       */
    char *bform                             /* data format of the files   */
);

int dateconr
(
    char date[]	/*input - a date in the form dd-mmm-yy (01-jan-91)
                  output - a date in the form yymmdd (910101) */
);

int ddr2nhdr
(
    char *hostout,                   /* UNIX format of output name   */
    char *outddr,                    /* name of temp. ddr file       */
    long *nb,                        /* number of bands              */
    char *bform                     /* data format of files         */
);

void dms2met
(
    double tmpdms[],                      /* contains pdms corner points      */
    char llpt[][15],                      /* longitude/latitude corner points */
    double nept[],                        /* northing/easting corner points   */
    struct DDR *ddr                       /* DDR record structure             */
);

int get_semiaxis
(
    double *maj,                      /* semi-major axis value        */
    double *min,                      /* semi-minor axis value        */
    struct DDR *ddr                  /* DDR record structure         */
);

int getpar
(
    struct PARBLK *vblock,       /* pointer to TAE parameter block            */
    char taein[][CMLEN],         /* TAE file names of input images            */
    char hosin[][CMLEN],         /* host file names of input images           */
    char *hosout,                /* host file name of output image            */
    long *nmrimg,                /* number of input images                    */
    long (*window)[4],           /* window specifications for each input image*/
    long (*bands)[MAXBND+1],     /* band specifications for each input image  */
    long *nbands,                /* number of bands per input image           */
    long *totbnd,                /* total number of bands to be processed     */
    char *bform                 /* data format of the files                  */
);

void met2dms
(
    double nept[],                     /* northing/easting corner points   */
    char llpt[][15],                   /* longitude/latitude corner points */
    struct DDR *ddr                    /* DDR record structure             */
);

void pdms2dms
(
    double pdms,                      /* Packed degrees-minutes-seconds */
    char *ndfdms,
    long news
);

#endif
