#!/bin/csh
#
# This script will automatically use the correct C compiler for EDC machines.
# If the benchmark is being performed on an unsupported machine, the
# variable CC may need to be manually set below.
#
switch (`uname -n`)
    case edcsns1:
        cp bckdiffs_sns1 bckdiffs
        breaksw

    case edclx*:
        cp bckdiffs_linux bckdiffs
        breaksw

    default:
        cp bckdiffs_sg1 bckdiffs

endsw

if (-e ~/cm && -d ~/cm) then
	if (-e ~/cm/alias.list) rm ~/cm/alias.list
else
	mkdir ~/cm
endif
	
if (!(-e bck_file_change_done)) then
	echo 'Preparing */bck* files with current path information.'
	foreach bckfile (*/bck*.prt */bck*.txt */bck*.lt* */bck*.his)
		echo 'changing '$bckfile
		./change_bck.pl $bckfile $cwd $home
	end
	echo 'changing bckdiffs'
	./change_bck.pl bckdiffs $cwd $home
endif

echo 'DO NOT ADD THIS FILE TO CVS\!\!\!\!\!\!\!\!\!\!\!' > bck_file_change_done
echo '================================================' >> bck_file_change_done
echo 'This file is used as a flag for change_bck.csh  ' >> bck_file_change_done
