#ifndef PROTOS_H
#define PROTOS_H

void calc_pages
(
    char hosin[][CMLEN],		/* pointer to array of host file names       */
    long *nmrimg,			/* number of input images		     */
    long (*window)[4],		/* window specification	                     */
    long *dtype,			/* data type of images		             */
    long *nbands,	        	/* number of bands in each input image       */
    long *max_pplin,	        /* max number of pixels per line	     */
    long *pages_in_set,		/* number of pages in a set                  */
    long *pages_per_band,	    /* total number of pages for each band       */
    long *pgtot,		        /* total number of output pages              */
    long *lnpr,			/* flag for output to line printer           */
    char *runtype	        	/* current sesson type		  	     */
);

void cleanup
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	      */
    FILE *fp,	 	 /* file pointer for temp print file	      */
    char *name,	 /* temporary print file name		      */
    long *lnpr,	 /* flag for print output to line printer     */
    long *fyle	 /* flag for print output to disk file	      */
);

void getpar
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	      */
    char taein[][CMLEN],		 /* pointer to input TAE file descriptor      */
    char hosin[][CMLEN],  		 /* pointer to input host file descriptor     */
    long *nmrimg, 		 /* pointer to number of input images	      */
    long (*bands)[MAXBND+1],    	 /* band specification 		              */
    long *nbands,        	 /* number of bands for each input image      */
    long *totbnd,		 /* pointer to total number of bands          */
    long (*window)[4],	         /* window specification		      */
    long *term,			 /* flag for output to terminal		      */
    long *fyle,			 /* flag for output to file            	      */
    long *lnpr,			 /* flag for output to line printer           */
    char *filnm,	 	  	 /* output filename for FILE option           */
    char *outfil,        	 /* pointer to output host file name          */
    long *msgtim,		 /* pointer to elapsed time between messages  */
    char *runtype		 /* pointer to session run type flag          */
);

void print_byte
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	      */
    FILE *fp,		      /* pointer to print file 		              */
    char *taein,	              /* pointer to TAE name descriptor 	      */
    long *pages_per_band,     /* total number of pages for each band	      */
    long *pgtot,		      /* total number of output pages		      */
    long *max_pplin,	      /* max number of pixels per line		      */
    long *pages_in_set,	      /* number of pages in a set		      */
    long (*window)[4],	      /* window specification		 	      */
    long *curimg,	              /* index to current image 		      */
    long *bndnum,		      /* current band number		   	      */
    char *filnm	              /* pointer temporary print file name     	      */
);

void print_long
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	      */
    FILE *fp,		      /* pointer to print file 		              */
    char *taein,	   	      /* pointer to TAE name descriptor 	      */
    long *pages_per_band,	  /* total number of pages for each band	      */
    long *pgtot,		      /* total number of output pages		      */
    long *max_pplin,	      /* max number of pixels per line		      */
    long *pages_in_set,	      /* number of pages in a set		      */
    long (*window)[4],	      /* window specification		 	      */
    long *curimg,	              /* index to current image 		      */
    long *bndnum,		      /* current band number		   	      */
    char *filnm	   	      /* pointer temporary print file name            */
);

void print_real
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	      */
    FILE *fp,		      /* pointer to print file 		              */
    char *taein,	      	      /* pointer to TAE name descriptor		      */
    long *pages_per_band,	  /* total number of pages for each band	      */
    long *pgtot,		      /* total number of output pages		      */
    long *max_pplin,	      /* max number of pixels per line		      */
    long *pages_in_set,	      /* number of pages in a set		      */
    long (*window)[4],	      /* window specification		 	      */
    long *curimg,	              /* index to current image 		      */
    long *bndnum,		      /* current band number		   	      */
    char *filnm	      	      /* pointer to temporary print file name	      */
);

void print_word
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	      */
    FILE *fp,		      /* pointer to print file 		              */
    char *taein,	  	      /* pointer to TAE name descriptor		      */
    long *pages_per_band,     /* total number of pages for each band	      */
    long *pgtot,		      /* total number of output pages		      */
    long *max_pplin,	      /* max number of pixels per line		      */
    long *pages_in_set,	      /* number of pages in a set		      */
    long (*window)[4],	      /* window specification		 	      */
    long *curimg,	              /* index to current image 		      */
    long *bndnum,		      /* current band number		   	      */
    char *filnm	  	      /* pointer to temporary print file name  	      */
);

void term_byte
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	    */
    FILE *fp,			/* file pointer to print file		    */
    long (*window)[4],		/* window specification			    */
    long *curimg,			/* index to current image		    */
    long *bndnum,			/* current band number		  	    */
    long *nmrimg,			/* number of images			    */
    long *nbands,			/* number of bands			    */
    long *lnpr,			/* pointer to flag for output to printer    */
    long *fyle,			/* pointer to flag for output to file       */
    char *filnm,	    /* pointer temporary print file name        */
    long *mxln			/* max lines for term screen from t_init    */
);

void term_long
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	    */
    FILE *fp,			/* file pointer to print file		    */
    long (*window)[4],		/* window specification			    */
    long *curimg,			/* index to current image		    */
    long *bndnum,			/* current band number		  	    */
    long *nmrimg,			/* number of images			    */
    long *nbands,			/* number of image bands		    */
    long *lnpr,			/* pointer to flag for output to printer    */
    long *fyle,			/* pointer to flag for output to file       */
    char *filnm,	    /* pointer temporary print file name        */
    long *mxln			/* max lines for term screen from t_init    */
);

void term_real
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	    */
    FILE *fp,			/* file pointer to print file		    */
    long (*window)[4],		/* window specification			    */
    long *curimg,			/* index to current image		    */
    long *bndnum,			/* current band number		  	    */
    long *nmrimg,			/* number of images			    */
    long *nbands,			/* number of image bands		    */
    long *lnpr,			/* pointer to flag for output to printer    */
    long *fyle,			/* pointer to flag for output to file       */
    char *filnm,	    /* pointer temporary print file name        */
    long *mxln			/* max lines for term screen from t_init    */
);

void term_word
(
    struct PARBLK *vblock,       /* pointer to TAE block	 	    */
    FILE *fp,			/* file pointer to print file		    */
    long (*window)[4],		/* window specification			    */
    long *curimg,			/* index to current image		    */
    long *bndnum,			/* current band number		  	    */
    long *nmrimg,			/* number of images			    */
    long *nbands,			/* number of image bands		    */
    long *lnpr,			/* pointer to flag for output to printer    */
    long *fyle,			/* pointer to flag for output to file       */
    char *filnm,	    /* pointer temporary print file name        */
    long *mxln			/* max lines for term screen from t_init    */
);

#endif

