#ifndef PROTOS_H
#define PROTOS_H

int close_output
(
    long *num_images   	/* The number of images in fdesc to close     */
);

void getpar
(
    struct PARBLK *vblock,   /* pointer to TAE block	 	              */
    char *fname,		/* input file name			      */
    char hosin[][CMLEN],  	/* host file names of input images	      */
    char hosout[][CMLEN],		/* host file name of output image	      */
    char *minmax,		/* min max flag buffer		              */
    char taein[][CMLEN],	/* TAE file names of input images	      */
    char taeout[][CMLEN],		/* TAE file name of output image	      */
    long (*bands)[MAXBND+1], /* band specification 		              */
    long *dtype, 	/* data type of input image		      */
    long *maxlfix,		/* maximum number of lines to fix             */
    long *msgtim,		/* elapsed time between display messages      */
    long *nmrimg, 		/* number of input images		      */
    long *nbands,		/* number of bands per input image            */
    long *totbnd,		/* total number of bands		      */
    long (*window)[4],	/* window specification		              */
    short *update	/* True when input image is updated           */
);

void initl
(
    struct PARBLK *vblock,		/* TAE parameter block		      */
    char *fname,			/* Input file name 		      */
    char hosin[][CMLEN],		/* Host names of input images	      */
    char hosout[][CMLEN],		/* Host name of output image	      */
    char *minmax,		/* Min max flag                       */
    double *minval,		/* Min pixel value array              */
    double *maxval,		/* Max pixel value array              */
    long (*bands)[MAXBND+1],	/* Bands to be processed for all 
					   images                             */
    long *dtype,			/* Data type of the input image       */
    long *msgtim,		/* Elapsed time between display 
					   messages                           */
    long *lines,			/* Lines to be fixed		      */
    long *maxlfix,               /* maximum number of lines to fix     */
    long *nbands,		/* Number of bands per input image    */
    long *nblks,			/* Number of blocks to be fixed	      */
    long *nbrln,                 /* Number of lines to be fixed in a 
					   block                              */
    long *nl,			/* Number of image lines              */
    long *nmrimg,		/* Number of input images             */
    long *ns,			/* Number of image samples            */
    long *odtype,		/* Data type of output image          */
    long *size,			/* Number of bytes per pixel 	      */
    long *sl,			/* Starting image line                */
    long *ss,			/* Starting image sample              */
    long *totbnd,		/* Total number of bands to be 
                                           processed                          */
    long (*window)[4],		/* Window specification of input 
                                           images                             */
    short *update		/* True when the input image is to 
					   be updated                         */
);

void proces
(
    struct PARBLK *vblock,	 /* TAE parameter block		      	      */
    char hosout[][CMLEN],	 /* Host name of output image		      */
    long (*bands)[MAXBND+1],
    long *lines,		 /* Lines to be fixed                         */
    long *nbands,	 /* Number of bands per input image           */
    long *maxlfix,	 /* Minimum number of lines to fix            */
    long *nblks,		 /* Blocks to be fixed		              */
    long *nbrln,          /* Number of lines to be fixed in a block    */
    long *nl,             /* Number of image lines                     */
    long *nmrimg,	 /* Number of output images		      */
    long *ns,             /* Number of image samples                   */
    long *odtype,	 /* Output data type			      */
    long *size,           /* Number of bytes per pixel                 */
    long *sl,             /* Starting image line                       */
    long *ss,             /* Starting image sample                     */
    long *totbnd,         /* Total number of bands in the output image */
    long (*window)[4],	 /* Window specification of input images      */
    short *update	 /* True when the input image is to be updated*/
);

int rdfil
(
    char *fname,	/* File containing specifications for blocks to be
			   fixed					     */
    long *lines,        /* Contains list of line numbers that start each of
			   the blocks of lines to be fixed		     */
    long *nblks,    	/* Number of blocks of lines to be fixed	     */
    long *nbrln	/* Contains list of number of lines in each block 
			   to be fixed					     */
);

void terminate
(
    struct PARBLK *vblock,	/* TAE parameter block			     */
    char hosin[][CMLEN],	/* Host names of input images		     */
    char hosout[][CMLEN],	/* Host name of output image		     */
    char *minmax,	/* Min max flag                              */
    char taeout[][CMLEN],	/* LAS name of output image                  */
    double *maxval,  	/* Max pixel value array                     */
    double *minval,  	/* Min pixel value array                     */
    long (*bands)[MAXBND+1],
    long *nbands,	/* Number of bands per input image           */
    long *nmrimg,	/* Number of input images                    */
    long *totbnd,	/* Total number of bands to be processed     */
    long (*window)[4],	/* Window specification of input images      */
    short *update	/* True when the input image is to be updated*/
);

#endif
