
/* include files, global parameters, and definitions for LOWCAL      */

#include <stdio.h>
#include <math.h>
#include "las.h"
#include "statio.h"
#include "protos.h"

#define NR      0			/* number of lines in local window  */
#define NP      1			/* number of pixels in local window */

#define MXLSIZ  15		        /* max number of lines for I/O buffer */
#define MHALF   MXLSIZ/2                /* half of max number of lines        */

extern struct	PARBLK	block;                 /* TAE parameter block     */
extern struct  DDR	ddr;                   /* ddr                     */
extern FILE	*fd;                           /* output file descriptor  */

extern float	*inbuf;                        /* image input buffer      */
extern float	*outbuf;                       /* image output buffer     */
extern char    out_files[2][CMLEN];            /* output file names       */

extern struct FDESC *  fdescin[MAXIMG+1];      /* input file descriptors  */
extern struct FDESC *  fdescout;               /* output file descriptor  */


extern long	min_max;                       /* minmax option flag      */
extern long 	msgtim;                        /* message interval        */
extern long	num_outfiles;                  /* number of output files  */

extern long	curent;                        /* current entity           */
extern long	curcat;                        /* current category         */

extern float	ccol[MXLSIZ]; 	/* column weights for separable convolution   */
extern float	crow[MXLSIZ];	/* row weights for separable convolution      */

extern long	iopt;         	/* option numbers (1 - 13)            */
extern long	inwnd[MAXIMG][4];/* input image dimensions (SL SS NL NS)*/
extern long	iwsize[2];	/* dimensions of local window (NR, NP) */
extern long	jns;           	/* number of neighbors for selective average    */
extern long	kn;           	/* number of neighbors for KNN option           */
extern long	mthre;        	/* treshold value for quantized mode option     */
extern long	nbins;		/* number of bins for quantized mode option     */
extern float	thresh;	       	/* treshold value for selective average option  */

