#include "lowcal.h"

void sort2
(
    float b[], 		/* array of absolute differences to be sorted         */
    float c[],		/* array of corresponding original pixel values       */
    long numbr          /* number values to sort (size of local window)       */
)

/*
*****************************************************************************

NAME:	SORT2

PURPOSE: Sorts numbr elements of array b and c in parallel.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1         31-May-84    J. Bay, SAR
   2         13-Jan-89    K. Kunska          conversion to 5.0    

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE
        Called by KNEAR routine

PROJECT:	LAS

ALGORITHM DESCRIPTION:
   While not sorted
      perform a bubble sort on array b and c

*****************************************************************************
*/

{

float	temp;		/* holds the values being switched                    */

long	k,		/* loop counter and array index                       */
	sorted;		/* sorting flag                                       */

sorted = 0;

while (sorted != 1)
   {
   sorted = 1;
   for (k = 0; k < numbr - 1; k++)
      {
      if (b[k] > b[k+1])
         {
         temp = b[k];
         b[k] = b[k+1];
         b[k+1] = temp;
         temp = c[k];
         c[k] = c[k+1];
         c[k+1] = temp;
         sorted = 0;
         }
      }
   }

}
