/*****************************************************************************
NAME: CALC_PC

PURPOSE: Calculate projection coordinates of given line/sample coordinates

PROGRAM HISTORY
  Version    Programmer      Date          Reason
  -------    ----------      ----          ------
             K. Hoback       6/99          Calculate x, y coordinate values.

*****************************************************************************/
#include "las.h"
#include "ls2pc.h"

int calc_pc
(
  double *cc,             /* I: Rotation coefficents */
  float vline,            /* I: Line vector */
  float vsamp,            /* I: Sample vector */
  double *vy,             /* O: Y vector */
  double *vx              /* O: X vector */
)
{
  *vy = (cc[0]*vline) + (cc[1]*vsamp) + cc[2];
  *vx = (cc[3]*vline) + (cc[4]*vsamp) + cc[5];

  return(E_SUCC);
}
