#ifndef LS2PC_H
#define LS2PC_H 
/*=====================================================================
   This header file is for ls2pc

   note: make sure that the las.h header is included in the program
         before this header file.


       I: indicates input to function.
       O: Output from function.
       I/O: input and output to function.
=====================================================================*/
int calc_coef
(
  struct DDR *ddr,        /* I: DDR structure */
  double *coef            /* O: Rotation coefficents */
);

int calc_pc
(
  double *cc,             /* I: Rotation coefficents */
  float vline,            /* I: Line vector */
  float vsamp,            /* I: Sample vector */
  double *vy,             /* O: Y vector */
  double *vx              /* O: X vector */
);

int getpar
(
  struct PARBLK *vblk,    /* I: TAE parameter block */
  struct DDR *ddr,        /* O: Input image DDR structure */
  long *file,             /* O: PRINT parameter output to a file */
  long *term,             /* O: PRINT parameter output to a terminal */
  long *lnprt,            /* O: PRINT parameter output to a printer */
  long *n_ls,             /* O: Number of line/sample pairs */
  char *outfile,          /* O: Name of the output file */
  char *infile,           /* O: Name of the input file */
  char *tmpfil,           /* O: Name of file for FILEUTIL */
  char *prtfile,          /* O: Name of file for PRINT file option */
  long *numfiles,         /* O: Number of output files produced */
  char *filetype          /* O: Type of file that the user requested */
);

int process
(
  struct PARBLK *vblk,    /* I: TAE parameter block */
  struct DDR *ddr,        /* I: DDR structure */
  long n_ls,              /* I: Number of line/sample pairs */
  double *coef,           /* I: Coefficients used to compute proj coord */
  char *infile,           /* I: File containing line/sample coords */
  char *tmpfil,           /* I: Name of file for PRINT parameter output */
  char *outfile           /* I: User name of output file */
);

int ls2tps
(
  struct PARBLK *vblk,     /* I:  TAE parameter block */
  struct DDR *ddr,         /* I:  DDR Structure */
  long n_ls,               /* I:  Number of line/sample pairs */
  char *infile,            /* I:  File containing the line/sample pairs */
  char *out_file,          /* I:  User name of output file */
  double *coef             /* I:  Coefficients used to compute proj coord */
);

#endif
