/******************************************************************************
FUNCTION:       GET_CEOSID

PURPOSE:        Returns an integer corresponding to the CEOSID string
                parameter entered.

ALGORITHM REFERENCES    none
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "ltwgin.h"

int get_ceosid
(
  char idstring[32]             /* Extracted from image VDF file */
)
{
    if (strstr(idstring, "INTERNALSGS") != NULL)
        return HBK; /* South Africa */
    else if (strstr(idstring, "JAPAN") != NULL)
        return TK1; /* Japan */
    else if (strstr(idstring, "THAILAND") != NULL)
        return THAI;
    else if (strstr(idstring, "SAUDI ARABIA") != NULL)
        return SAUDI;
    else if(strstr(idstring, "FUCINO") != NULL)
        return FUCINO; /* ITA-FUCINO station */
    else if(strstr(idstring, "KIRUNA") != NULL)
        return FUCINO; /* SWE-KIRUNA station - treated same as FUCINO data */
    else if(strstr(idstring, "SWEDEN") != NULL)
        return SWEDEN; /* only SPOT data is known to have "SWEDEN" in
                          generating country string */
    else if(strstr(idstring, "FRANCE") != NULL)
        return SWEDEN; /* only SPOT data is known to have "FRANCE" in
                          generating country string - treated same as SWEDEN */
    else if(strstr(idstring, "RSAT") != NULL)
        return RSAT; /* Radarsat */
    else
    {
        if (strstr(idstring, "CANADA") == NULL)
        {
            c_lasmsg(FALSE,"ltwgin-station",
                    "Station unrecognized - assuming CANADA");
        }
        return CAN;
    }
}
