/*****************************************************************************

FUNCTION:       imgnum

PURPOSE:        Returns the "image number" of an image on CD given its
                pathname, i.e., "/sg2@cd1/scene09/..." would correspond to
                image "09". 

ALGORITHM REFERENCES:   none

*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "ltwgin.h"

int imgnum
(
  char hpath[CMLEN],             /* I: Path to image data */
  char img[3]                    /* O: Image number */
)
{
    char  *pos;             /* Pointer to "scene" substring within hpath    */
    char  *temp;            /* Temporary pointer into hpath                 */

    /* This is, of course, dependent on the fact that LTWG-format images on CD
       will always be stored in a directory beginning with 'scene' .. this may
       very well have to be changed upon the reception of new CD data which
       uses a new "standard" convention. */

    pos = strstr(hpath, "scene");
    if(pos == NULL)
        return(E_FAIL);
    pos += 5;
    temp = pos;
    while ((*temp >= '0') && (*temp <= '9'))
    {
        img[temp-pos] = *temp;
        temp++;
    }
    img[temp-pos] = '\0';
    return (E_SUCC);
}
