C     *************************************************************************
C     NAME:   			CLEANUP 
C
C      
C     PURPOSE:  CLEANUP is used to clean up after a fatal error is 
C  	        encountered during processing.  It deletes the output
C               image file and ddr, prints a fatal error message, and 
C               terminates processing.
C
C     ARGUMENTS:
C     Name             Description
C     ----------	------------
C     fdesc		(from common)file descriptor for output image file
C     rdesc		(from common)file descriptor for image file group
C     hosout		output image name
C     intype		input data type
C     ldesc		file descriptor for output dltf file
C     nfiles		number of files for completion message
C     nmrimg		number of input images
C     otype		output data type
C     dltfout		output dltf file name, if any
C     parblk(XPRDIM)	TAE parameter block
C   
C
C
C     INTERNAL VARIABLES:
C     Name	       	Description
C     ----	       	-----------
C     i	               	loop index
C     names		array of output file names
C     pname		program name
C     status	       	return status of support call
C
C     *************************************************************************

      subroutine cleanup(parblk,intype,otype,hosout,
     +			 nmrimg,ldesc,nfiles,dltfout)
       
	include 'las.fin'

      real*4 thebuf(BSIZE)

      integer*4 eclose
      integer*4 egclse
      integer*4 fdesc(MAXIMG + 1)
      integer*4 fdescin(MAXIMG)
      integer*4 fdescot
      integer*4 i
      integer*4 ib
      integer*4 il
      integer*4 intype
      integer*4 ldesc
      integer*4 nfiles
      integer*4 nmrimg
      integer*4 offin(MAXBND + 1)
      integer*4 offout(MAXBND + 1)
      integer*4 otype
      integer*4 parblk(XPRDIM) 
      integer*4 rdesc
      integer*4 status

      character*1 inbuf(BSIZE)
      character*1 outbuf(BSIZE)

      character*(CMLEN) dltfout
      character*(CMLEN) hosout
      character*(CMLEN) names(2)
      character*(CMLEN) pname

      common/inbuf/inbuf
      common/outbuf/outbuf
      common/thebuf/thebuf
      common/imgio/fdesc,fdescin,fdescot,rdesc,offin,offout
      common/curcat/ib
      common/curent/il
C-----------------------------------------------------------------------
      if ((otype .lt. 3) .and. (intype .lt. 3)) then
         do 60 i = 1,nmrimg
            status = eclose(fdescin(i))
60       continue
         status = eclose(fdescot)
      else
         status = egclse(rdesc)
      end if
C-----------------------------------------------------------------------
      names(1) = hosout
      if (dltfout .ne. ' ') then
	 call cldltf(ldesc,dltfout)
	 names(2) = dltfout
	 nfiles = 2
      end if

      pname = 'MAP'
      call clean(parblk,pname,names,nfiles)
    
      return 
      end
