C     *************************************************************************
C     NAME:   			INITDLTF 
C
C      
C     PURPOSE:    To initialize the arrays necessary for writing record type
C		  one of a dltf.
C      
C
C     ARGUMENTS:
C     Name             Description
C     ----	       -----------
C     ddesc	       dltf file descriptor
C     dltfin	       input dltf file name
C     inasdltf(DBAND)  input dltf array simulating asdltf c structure
C     outasdltf(DBAND) output dltf array simulating asdltf c structure
C     outdescr	       output dltf text
C     outkey	       output dltf key
C     outdtype	       output dltf data type
C     totbnd	       total number of output image bands
C     window(4,MAXIMG) input window specifications
C
C
C     INTERNAL VARIABLES:
C     Name	       Description
C     ----	       -----------
C     i	               loop index
C     status	       return status of support call
C
C     *************************************************************************

      subroutine initdltf(ddesc,outdtype,outkey,inasdltf,outasdltf,
     +			  outdescr,totbnd,window,dltfin)

	include 'las.fin'

	include 'dltf.fin'

      integer*4 ddesc
      integer*4 i
      integer*4 inasdltf(DLTFSZ)
      integer*4 outasdltf(DLTFSZ)
      integer*4 status
      integer*4 totbnd
      integer*4 window(4)
      integer*4 w1dltf

      character*(CMLEN)  dltfin
      character*3        outdtype
      character*81       outdescr
      character*13       outkey

         outasdltf(NUMBND) = totbnd
         do 600 i = 0, (MAXBND - 1)
           outasdltf(DBAND + i) = i + 1
600	 continue
         do 700 i = 0, 3
            outasdltf(DWINDOW + i) = window(i + 1)
700	 continue
	 if (dltfin .eq. ' ') then
            outasdltf(IXZOOM) = 1
            outasdltf(IYZOOM) = 1
            outasdltf(GXZOOM) = 1
            outasdltf(GYZOOM) = 1
            outasdltf(IXSHFT) = 0
            outasdltf(IYSHFT) = 0
            outasdltf(GXSHFT) = 0
            outasdltf(GYSHFT) = 0
	 else
            outasdltf(IXZOOM) = inasdltf(IXZOOM)
            outasdltf(IYZOOM) = inasdltf(IYZOOM)
            outasdltf(GXZOOM) = inasdltf(GXZOOM)
            outasdltf(GYZOOM) = inasdltf(GYZOOM)
            outasdltf(IXSHFT) = inasdltf(IXSHFT)
            outasdltf(IYSHFT) = inasdltf(IYSHFT)
            outasdltf(GXSHFT) = inasdltf(GXSHFT)
            outasdltf(GYSHFT) = inasdltf(GYSHFT)
	 end if
         status = w1dltf(ddesc,outkey,outdescr,outdtype,outasdltf)
	 if (status .ne. ESUCC) then
	   call errmsg('Fatal error encountered','map-fatal',-1)
	 end if

      return
      end
