/*****************************************************************************
FUNCTION:   procctrl

PURPOSE:    compares the percentages of the input file with the input
            percentages in order to calculate the output FROM values.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
                Run under TAE

PROJECT:        LAS

******************************************************************************/

#include <stdio.h>
#include <math.h>
#include "las.h"
#include "protos.h"

int procctrl
(
    long percnt,                  /* # of percentages to be matched      */
    long *pixflg,                 /* flag if there is a pixel value      */
    long numval1,                 /* # of values of INFILE1              */
    float per[],                  /* percentages to be matched           */
    float comper1[],              /* percentages of INFILE1              */
    long value1[],                /* values of INFILE1                   */
    long from[],                 /* values of FROM column of output file */
    long to[],                    /* values of TO column of output file  */
    long pixval                  /* value of parameter PIXVAL           */
)

{
  long valcnt1=0;             /* current value position of INFILE1   */
  long i=0;                   /* counter variable in for loops       */
  long j=0;                   /* counter variable in for loops       */
  long k=0;                   /* counter variable in for loops       */
  long start=0;               /* what percent to start matching at   */
  float next=0.0;             /* result of fabs(per[i] - comperX[valcntX+1]) */
  float curr=0.0;             /* result of fabs(per[i] - comperX[valcntX]) */


/* Use the lowest value if percent = 0 inorder that the low end of the 
   histogram is not ignored.
----------------------------------------------------------------------*/
  if (per[0] == 0)
  {
    from[0] = value1[0];
    valcnt1++;
    start = 1;
  }

/* Compare the input percentages with the percentages from the input file
   use the FROM values that correspond with closest percentage
--------------------------------------------------------------------------*/
  for (i = start; i < percnt; i++)
  {

    for ( j = valcnt1; j < numval1; j++)
    {
      curr = fabs(per[i] - comper1[valcnt1]);
      next = fabs(per[i] - comper1[valcnt1+1]);
      if (curr < next) 
      {
          from[i] = value1[valcnt1];
          break;
      }
      else
        valcnt1++;
    }

  }  /* end for i = start to percnt */


/* Place PIXVAL within the correct postion of the TO and FROM columns.
   If from equals the pixval set the to value to pixval.
----------------------------------------------------------------------*/
  if (pixflg)
  {
    for (i = 0; i < percnt; i++)
    {
      if (from[i] == pixval)
      {
        *pixflg = FALSE;
        break;
      }
      else if (from[i] > pixval)
      {
        for ( k = percnt; k > i; k--)
        {
          from[k] = from[k-1];
          to[k] = to[k-1];
        }

        from[i] = pixval;
        to[i] = pixval;
        break;
      }
    }
  }

  return(E_SUCC);
}
