#include "las.h"
#include "statio.h"
#include "protos.h"

/******************************************************************************

NAME:  initshapes

FUNCTION:  initialize shape vectors for maskstat statistics

PROGRAM HISTORY:
  Version	Date       Author      	     Request
  -------	----	   ------            -------
    1.0        2/12/88   m.mazzella SAR/GSFC  orig. dev.
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	new LAS

ALGORITHM (FLOW):
	put proper values into each shape vector

******************************************************************************/

void initshapes
(
    long nshape[],	/* shape vector for npoints statistic */
    long mshape[],	/* shape vector for mean vector statistic */
    long lshape[],	/* shape vector for name statistic */
    long hshape[],	/* shape vector for histogram statistic */
    long cshape[],	/* shape vector for cov. matrix statistic */
    long bands
)
{

nshape[0] = ELONG;
nshape[1] = 1;
nshape[2] = 1;
nshape[3] = 0;
nshape[4] = 0;
nshape[5] = 0;
nshape[6] = 0;
nshape[7] = 0;
nshape[8] = 0;


mshape[0] = EDOUBLE;
mshape[1] = 1;
mshape[2] = 256;
mshape[3] = 0;
mshape[4] = 0;
mshape[5] = 0;
mshape[6] = 0;
mshape[7] = 0;
mshape[8] = 0;


cshape[0] = EDOUBLE;
cshape[1] = 1;
cshape[2] = bands * bands;
cshape[3] = 0;
cshape[4] = 0;
cshape[5] = 0;
cshape[6] = 0;
cshape[7] = 0;
cshape[8] = 0;


lshape[0] = EBYTE;
lshape[1] = 1;
lshape[2] = 3;
lshape[3] = 0;
lshape[4] = 0;
lshape[5] = 0;
lshape[6] = 0;
lshape[7] = 0;
lshape[8] = 0;


hshape[0] = ELONG;
hshape[1] = 1;
hshape[2] = 256;
hshape[3] = 0;
hshape[4] = 0;
hshape[5] = 0;
hshape[6] = 0;
hshape[7] = 0;
hshape[8] = 0;

return;
}
