#ifndef PROTOS_H
#define PROTOS_H


void dyn_free
(void);

void initshapes
(
    long nshape[],	/* shape vector for npoints statistic */
    long mshape[],	/* shape vector for mean vector statistic */
    long lshape[],	/* shape vector for name statistic */
    long hshape[],	/* shape vector for histogram statistic */
    long cshape[],	/* shape vector for cov. matrix statistic */
    long bands
);

void msfiles
(
    char hosin[][CMLEN],	/* spectral host file name		*/
    long bands[][MAXBND+1],	/* band numbers for spectral image	*/
    long nbands[],		/* number of bands in input images      */
    long nimgs,		/* number of input images               */
    long windin[][4],		/* spectral image window		*/
    long *dtyp,
    char *hoscl,		/* classified host file name 		*/
    long *bandscl,		/* band number for classified image	*/
    long windcl[],		/* classified image window		*/
    char *hostat,	/* stats host file name			*/
    long *nclass		/* number of classes in class. image	*/
);

void msparam
(
    struct PARBLK *vblock,	/* las parameter block			*/
    char hosin[][CMLEN],		/* spectral host file name		*/
    char hoscl[][CMLEN],		/* classified host file name		*/
    char *lastat,	/* stats las file name			*/
    char *hostat,	/* stats host file name			*/
    long windin[][4],	/* spectral image window		*/
    long windcl[][4],	/* classified image window		*/
    long nbands[],	/* number of bands in spectral image	*/
    long *totbnd,	/* total number of bands		*/
    long *nimgs,		/* number of input images		*/
    long bandscl[][MAXBND+1],	/* band number of classified image	*/
    long bands[][MAXBND+1],/* band numbers for spectral image	*/
    long *msgtim,	/* timed processing message delay	*/
    long *dtype		/* data type of spectral image		*/
);

void mstats
(
    long *nb,	/* number of bands for input spectral image	*/
    long nc,	/* number of classes in classified image	*/
    long nl,	/* number of lines in input image		*/
    long np,	/* number of pixels per line			*/
    long msgtim	/* timed processing message delay		*/
);

void zeroarrays
(
    long *maxv[MAXCLS],	/* maximum value array	*/
    long npx[MAXCLS], 		/* number of pixels 	*/
    double *mean[MAXCLS],	/* mean array		*/
    double *scov[MAXCLS],	/* covariance array	*/
    long *hist[MAXCLS], /* histogram array	*/
    double *sum[MAXCLS],	/* sum array		*/
    long bands
);
#endif

