#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block	      */
    long *msgtim,		/* elapsed time between display messages      */
    char taein1[][CMLEN],	/* pointer to first TAE file descriptor       */
    char hosin1[][CMLEN],	/* pointer to first host file descriptor      */
    char taein2[][CMLEN],	/* pointer to second TAE file descriptor      */
    char hosin2[][CMLEN],	/* pointer to second host file descriptor     */
    char taeout[][CMLEN],		/* pointer to output TAE file descriptor      */
    char hosout[][CMLEN],		/* pointer to output host file descriptor     */
    long (*wind1)[4],		/* window specification for first image       */
    long (*wind2)[4],		/* window specification for second image      */
    long nib1[],         	/* number of bands per first image            */
    long nib2[],         	/* number of bands per second image	      */
    long (*bands1)[MAXBND + 1],   /* band specification for first image       */
    long (*bands2)[MAXBND + 1],   /* band specification for second image      */
    long *nim1,			/* number of input images for first image     */
    long *nim2,			/* number of input images for second image    */
    long *totbnd1,		/* total number of bands in first image       */
    long *totbnd2,		/* total number of bands in second image      */
    float *scale1,		/* first scale factor   		      */
    float *scale2,		/* second scale factor			      */
    char *method,		/* mathematical method of use                 */
    char *minmax,		/* min max flag buffer			      */
    float *offst,		/* offset factor			      */
    long *odtype,		/* output data type			      */
    float *pixval		/* pixel value to be used for a zero divide   */
);

void mathadd
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names 		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    float *scale1,		/* scale factor of first input image         */
    float *scale2,		/* scale factor of second input image	     */
    float *offst		/* offset applied to first image             */
);

void mathand
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);

void mathdiv
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    float *scale1,		/* scale factor of first input image         */
    float *offst,	        /* offset applied to first image             */
    double pixval		/* pixel value used when a zero divide       */
);

void mathmax
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);

void mathmin
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);

void mathmul
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image  names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    float *scale1,		/* scale factor of first input image         */
    float *offst	        /* offset applied to first image             */
);

void mathor
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);

void mathsub
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names 		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified in each image   */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    float *scale1,		/* scale factor of first input image         */
    float *scale2,		/* scale factor of second input image	     */
    float *offst	        /* offset applied to first image             */
);

void mathxor
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin1[][CMLEN],	/* host names of input images		     */
    char hosin2[][CMLEN],	/* host names of input images		     */
    char totin[][CMLEN],		/* total input image names		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nim1,			/* number of input images                    */
    long nim2,			/* number of input images                    */
    long (*wind1)[4],		/* window specification of input images      */
    long (*wind2)[4],		/* window specification of input images      */
    long (*bands1)[MAXBND+1],	/* bands to be processed for all images      */
    long (*bands2)[MAXBND+1],	/* bands to be processed for all images      */
    long totbnd1,		/* total number of bands to be processed     */
    long *nbands,		/* number of bands specified for each image  */
    long odtype,			/* data type of output image                 */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);

#endif

