#ifndef PROTOS_H
#define PROTOS_H

void assign
(
    long num_inbands,        /* number of input bands           */
    char metric[],           /* distance type: Euclid/cityblock */
    float *clmean[],          /* class means                     */
    long *nclass,            /* number of classes               */
    long clind[],            /* class numbers                   */
    float weights[],          /* weights for each band           */
    long clcount[],          /* pixels in each class            */
    double *clsumx[],          /* sums of pixel values            */
    double *clsumsq[],         /* sums of squares of pixels       */
    double maxdist,            /* distance parameter              */
    float max_dist[],         /* distance for each class         */
    char hos_out[],          /* output image host name          */
    long wind[][4]          /* image window                    */
);

void class_stats
(
    long nclass,             /* number of classes               */
    long clind[],            /* class numbers                   */
    long clcount[],          /* pixels in each class            */
    int num_inbands,
    double *clsumx[],          /* sums of pixel values            */
    double *clsumsq[],         /* sums of squares of pixels       */
    float *clmean[],          /* class means                     */
    char cname[][CMLEN],     /* class names                     */
    long name_exist         /* names exist in statistics file? */
);

void dyn_alloc
(
    long num_inbands,       /* number of input image bands    */
    float *clmean[],         /* pointers to means              */
    double *clsumx[],         /* pointers to pixel sums         */
    double *clsumsq[]        /* pointers to sums of squares    */
);

void dyn_free
(void);

void filspec
(
    char hosin[][CMLEN],      /* input image host name descriptors  */
    char hosout[],            /* output image host name descriptor  */
    long *num_inimages,       /* number of input images             */
    long num_image_bands[],   /* number of bands in each input image*/
    long image_band_num[][MAXBND + 1], /* band numbers in each      */
    long wind[][4]           /* input image windows                */
);

void getpar
(
    char hos_in[][CMLEN],     /* input images host names          */
    char las_out[][CMLEN],           /* output image las name            */
    char hos_out[][CMLEN],           /* output image host name           */
    char hos_stat[],          /* stats file host name             */
    long *num_inimages,       /* number of input images           */
    long num_image_bands[],   /* number of bands in each input image */
    long image_band_num[][MAXBND + 1], /* band numbers in each    */
    long *num_inbands,        /* total number of input image bands   */
    long wind[][4],           /* input image windows              */
    long *num_classes,        /* number of classes to be used     */
    float weights[],           /* weights for each band            */
    float *maxdist,            /* max distance                     */
    char metric[],            /* distance type                    */
    float *clmean[],           /* class means                      */
    double *clsumx[],           /* sums of pixels                   */
    double *clsumsq[],          /* sums of squares of pixels        */
    char print_file[CMLEN]   /* print file name                 */
);

void read_stats
(
    char hos_stat[],        /* stats file host name              */
    long num_inbands,       /* number of input bands             */
    float *clmean[],         /* class means                       */
    char cname[][CMLEN],    /* class names                       */
    long *name_exist,       /* class names exist in stats file?  */
    long *nclass,           /* number of classes requested/used  */
    long clind[]           /* class numbers used                */
);

void terminate
(
    char las_out[][CMLEN],
    char hos_out[],
    char hos_in[][CMLEN],
    long *num_inimages,
    char print_file[]
);

void thresh
(
    long nclass,
    char cname[][CMLEN],
    float thdist[]
);

#endif

