#include "las.h"
#include "util.h"
#include "protos.h"

#define FIL 2
void terminate
(
    char las_out[][CMLEN],
    char hos_out[],
    char hos_in[][CMLEN],
    long *num_inimages,
    char print_file[]
)
/*
**************************************************************************
NAME: TERMINATE

PURPOSE: Free dynamic storage, update image history and issue completion message

PROGRAM HISTORY:
  Version   Date       Author         Request
  -------   ----       ------             -------
   1           23-Nov-88  K. Narayanan, SAR    

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:  
    Runs under TAE

PROJECT: LAS

**************************************************************************
*/
{
extern struct PARBLK block;
extern long print[3];
extern char *prog_name;
extern long one;

long    num_files;

char    files[2][CMLEN];        /* program output files    */

/*
free dynamic storage
--------------------
*/
dyn_free ();

/*
update output image history
---------------------------
*/
c_hstout (&block, hos_out, hos_in, num_inimages, " ");

/*
issue completion message
------------------------
*/
if (print[FIL])
    {
    strcpy (files[0], las_out[0]);
    strcpy (files[1], print_file);
    num_files = 2;
    c_complt (prog_name, files, &num_files);
    }
else
    c_complt (prog_name, las_out, &one);

}
