
/*******************************************************************************
NAME:     init_luts.c
PURPOSE:  intialize luts used to speed processing of byte images 
*******************************************************************************/

#include "msscolor.h"  /* application header file */ 



FUNCTION void init_luts (outlut)
   struct LUTS *outlut;  /* output:  initialized luts */ 
{
/* declare variables */ 
   long index, lutval;   /* loop indices:  value input to the lut */ 

/* set 1-d lut values */ 
   for (lutval=LUTMIN;  lutval<=LUTMAX;  lutval++)
      {
      outlut->f0_1875 [lutval] = lutval * 0.1875; 
      outlut->f0_25   [lutval] = lutval * 0.25  ; 
      outlut->f0_35   [lutval] = lutval * 0.35  ; 
      outlut->f0_5625 [lutval] = lutval * 0.5625; 
      outlut->f0_75   [lutval] = lutval * 0.75  ; 
      outlut->f1_125  [lutval] = lutval * 1.125 ; 
      outlut->f1_5    [lutval] = lutval * 1.5   ; 
      outlut->f2_0    [lutval] = lutval * 2.0   ; 
      }

/* set values for 2-d ratio lut */ 
   for    (lutval=LUTMIN;  lutval<=LUTMAX;  lutval++)
      for ( index=LUTMIN;   index<=LUTMAX;  index++ )

	 if (index == 0) 
	    outlut->ratlut[lutval][index] = (float)lutval; 
	 else 
	    outlut->ratlut[lutval][index] = (float)lutval / index;
}
