#include "las.h"
#include "geompak.h"
#include "protos.h"

/*****************************************************************************

  NAME: CLRTPL

  FUNCTION: Clear a TPL header record.

  PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    1.0         6/89       D. Etrheim	Initial development

  ALGORITHM DESCRIPTION:
  Zero out or set to NULL all fields

******************************************************************************/
void clrtpl
(
    struct TPLHEAD *head			/* TPL header record */
)

{ /* clrtpl */

long i;					/* loop counter */

for (i = 0; i < 8; i++)
   head->corners[i] = 0.0;
head->pdist[0] = head->pdist[1] = 0.0;
for (i = 0; i < 15; i++)
   head->projprms[i] = 0.0;
head->proj_valid = GEO_NOTVALID;
head->code = head->zone = head->datum = 0;
head->edge_thres = head->min_str = head->max_dis = 0.0;
head->ref_mode[0] = head->units[0] = head->ref_name[0] = (char)NULL;
head->peak_method[0] = head->corr_type[0] = head->sea_name[0] = (char)NULL;

return;
} 
