/****************************************************************************

NAME:	  MTPZIP

PURPOSE:  Combine two mtp files 

PROGRAM HISTORY:
VERSION	 DATE	AUTHOR	   		CHANGE
-------	 ----	------	  		------ 
1.0	 3/97	D. Etrheim		Re-created as source code was lost
					by original developer.

*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "geompak.h"
#include "protos.h"

int main
(void)		
{
struct PARBLK vblk;		/* TAE parameter block */
struct VARIABLE *var;		/* TAE variable pointer */
long msgtim;			/* Message timer */
long std_out;			/* Standard output LUN */
long fatal = -1;		/* Fatal flag for errmsg */
long zero = 0;			/* Constant of 0 */
long one = 1;			/* Constant of 1 */
long acc=IREAD;			/* Access mode of tie point files */
char in_mtp[2][CMLEN];		/* The input merged Tie Point file name */
char out_mtp[1][CMLEN];		/* The output Tie Point Location host name */
long size[2];			/* The output chip size */
long offset[2];			/* The output search offsets */

/* Initialize LAS processing
  -------------------------*/
c_inlas(&vblk, &std_out);

/* Get the input merged tie point file names
  -------------------------------------------*/
if(c_getnam(&vblk, "INMT", &zero, in_mtp[0], "mtp", &acc) != E_SUCC) 
	c_errmsg("Fatal error encountered","mtpzip-fatal",&fatal);
if(c_getnam(&vblk, "INMT", &one, in_mtp[1], "mtp", &acc) != E_SUCC) 
	c_errmsg("Fatal error encountered","mtpzip-fatal",&fatal);

/* Get the output merged tie point file name
  -------------------------------------------*/
acc=IWRITE;
if(c_getnam(&vblk, "OUTMT", &zero, out_mtp[0], "mtp", &acc) != E_SUCC) 
	c_errmsg("Fatal error encountered","mtpzip-fatal",&fatal);

/* Get the SIZE 
  ---------------------*/
var = p_find(&vblk, "REFSIZE");
size[0] = IVAL(*var, 0);
size[1] = IVAL(*var, 1);

/* Get the SIZE 
  ---------------------*/
var = p_find(&vblk, "SRCHOFF");
offset[0] = IVAL(*var, 0);
offset[1] = IVAL(*var, 1);

/* Get the message timer
  ---------------------*/
var = p_find(&vblk, "$msgtim");
msgtim = IVAL(*var, 0);

/* Process the files
   -----------------*/
if (process(&msgtim,in_mtp,out_mtp[0],size,offset) != E_SUCC)
   c_clean(&vblk,"mtpzip",out_mtp,&one);

c_complt("MTPZIP", out_mtp, &one);

return EXIT_SUCCESS;

}
