/*****************************************************************************
NAME: GETPAR

PURPOSE:  To retrieve the parameters from the LAS parameter block

PROGRAM HISTORY:

Version  Date  Programmer       Code  Reason
-------  ----- ----------       ----  ------
 1.0     03/98 T.Ratliff         C    Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS
*****************************************************************************/

#include <stdio.h>
#include "las.h"
#include "protos.h"

void getpar
(
    struct PARBLK *vblk,                      /* TAE parameter block      */
    char *hostout,                            /* output header file name  */
    char *tapetype,                           /* tape media being used    */
    char *tapedens,                           /* tape density             */
    char *bform                              /* Data format of the files */
)

{
  struct VARIABLE *var;                   /* pointer to parameters       */

  /* get the tape type
  --------------------*/
  var = p_find(vblk,"TTYPE");
  strcpy(tapetype,SVAL(*var,0));

  /* get the tape density
  -----------------------*/
  var = p_find(vblk,"TAPEDENS");
  strcpy(tapedens,SVAL(*var,0));

  /* get the name of the NDF header file
  --------------------------------------*/
  var = p_find(vblk,"OUTFILE");
  strcpy(hostout,SVAL(*var,0));

  /* get the data format
  ----------------------*/
  var = p_find(vblk,"BFORM");
  strcpy(bform,SVAL(*var,0));

}
