#ifndef PROTOS_H
#define PROTOS_H

void checktp
(
    char *tapetype,                         /* tape media type             */
    char *bform,                            /* data format of files        */
    char *hostout,                          /* NDF file names in UNIX form */
    char fnames[][CMLEN],                   /* filenames to write to tape  */
    double totsize,                         /* size of all order files     */
    long ns,                                /* number of samples           */
    long bytes_per_sample,                  /* bytes per sample */
    long filesize[300],                     /* size of target files(s)     */
    long bpv[100],                          /* bands per volume            */
    long recdsz[300],                       /* record size of output files */
    long fpv[100],                          /* files per volume            */
    long *nvol,                             /* number of volumes           */
    long *nfiles                           /* number of files found       */
);

void getfiles
(
    char *hostout,                      /* NDF files in UNIX format    */
    char fnames[][CMLEN],               /* file names to write to tape */
    long filesize[300],                 /* size of target file(s)      */
    double *totsize,                    /* size of all order files     */
    long nb,                            /* number of bands             */
    long *nfiles,                       /* number of files found       */
    char *bform                        /* data format of the files    */
);

void getnbdns
(
    char *hostout,                          /* output header file name*/
    long *ns,                               /* number of samples      */
    long *bytes_per_sample,                 /* number of bytes per sample */
    long *nb                               /* number of bands        */
);

void getpar
(
    struct PARBLK *vblk,                      /* TAE parameter block      */
    char *hostout,                            /* output header file name  */
    char *tapetype,                           /* tape media being used    */
    char *tapedens,                           /* tape density             */
    char *bform                              /* Data format of the files */
);

void mknhdr
(
    char *hostout,          /* name of the NDF files        */
    long numnhdr,           /* Number of total volumes      */
    long bpv[]             /* bands per volume             */
);

void taeland
(
    struct PARBLK *vblk,                    /* TAE parameter block        */
    long nvol,                              /* number of volumes          */
    long fpv[100],                          /* number of files per volume */
    long recdsz[300],                       /* record size of each file   */
    long nfiles,                            /* number of files found      */
    char fnames[][CMLEN],                   /* filenames to write to tape */
    char *hostout                          /* NDF file names in UNIX form*/
);

#endif
