#ifndef PROTOS_H
#define PROTOS_H

int getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block	             */
    char taein[][CMLEN],/* pointer to first TAE file descriptor              */
    char hosin[][CMLEN],/* pointer to first host file descriptor             */
    char taeout[][CMLEN],/* pointer to output TAE file descriptor             */
    char hosout[][CMLEN],/* pointer to output host file descriptor            */
    long *nmrimg,	       /* number of input images for image           */
    long bands[][MAXBND + 1],   /* band specification for first image         */
    long *nbands,               /* number of bands per image	             */
    long window[][4],	       /* window specification for image             */
    long *msgtim,	       /* elapsed time between display messages      */
    char *minmax,		       /* min max flag buffer			     */
    long *odtype,	       /* output data type			     */
    long *totbnd,	       /* total number of bands in image             */
    float *scale,		       /* scale factor				     */
    float *offset,		       /* offset to be added to the normd calculation*/
    float *rndval,                 /* Rounding option 			     */
    long *normlim,	       /* normalized difference limit		     */
    long *nmasks                  /* Number of mask values                      */
);

int report
(void);


int proces
(
    void *in,	  /* input array                         		*/
    void *map,	  /* second input array                  		*/
    void *out,	  /* output array                        		*/
    long *ns,      /* number of samples                   		*/
    long *dtype,   /* data type						*/
    float *scale,	  /* scale factor				      	*/
    float *offset,	  /* offset to be added to the normd calculation	*/
    float rndval,     /* rounding option					*/
    long *normlim, /* nomalize difference limit				*/
    long nmasks      /* Number of mask values                              */
);

int bnormd
(
    unsigned char *in,
   unsigned char *map,
   unsigned char *out,
   long ns,
   float scale,
   float offset,
   float rndval,
   long normlim,
   long nmasks
);

int wnormd
(
    short *in,
   short *map,
   short *out,
   long ns,
   float scale,
   float offset,
   float rndval,
   long normlim,
   long nmasks
);

int uwnormd
(
    unsigned short *in,
   unsigned short *map,
   unsigned short *out,
   long ns,
   float scale,
   float offset,
   float rndval,
   long normlim,
   long nmasks
);

int lnormd
(
    long *in,
   long *map,
   long *out,
   long ns,
   float scale,
   float offset,
   float rndval,
   long normlim,
   long nmasks
);

int ulnormd
(
    unsigned long *in,
   unsigned long *map,
   unsigned long *out,
   long ns,
   float scale,
   float offset,
   float rndval,
   long normlim,
   long nmasks
);

int rnormd
(
    float *in,
   float *map,
   float *out,
   long ns,
   float scale,
   float offset,
   long normlim,
   long nmasks
);

#endif

