#include "overlay.h"
#include "util.h"
#include "pixman.h"

void compute
(
    char hos_out[][CMLEN],
    long *num_bands,
    long *nlout,
    long *nsout,
    long *dtype
)
/*
***************************************************************************

NAME: COMPUTE

PURPOSE: Creates an output image based on the logical relationships
         between two input images

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          24-Mar-89  J. Mcguthry STX

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
    -By using thd dynamic tutor the grey ranges, logical
     and/or, and grey value for output are entered 
        -exit dynamic tutor or up to 16 inputs form dynamic tutor
    -The ouput image is produced from the logical values enterd
     from above

***************************************************************************
*/
{

double	out_max[MAXBND], out_min[MAXBND];

long    ncond,
        four,
        nb,
        condition,	
        cond70 = 0,
        loopbreak = 0,
        save,
        type,
        otype,
        g[16][4],
        gor[16],
        iao[16],
	msg_flag,
        bkgrnd,
        ip,il,nc;


long    one = 1;
long    three = 3;



char    ao[5];

struct PARBLK  block;

/*
initialize and start processing message
--------------------------------------- */
type = *dtype;
four = 4;
otype = ELONG;
c_getnum (&vblock,"BACKGRND",&one,&otype,&bkgrnd);
msg_flag = ALLCAT;

/*
initialize min max arrays for all bands
--------------------------------------- */
if ( min_max )
   c_inmnmx (&type, num_bands, out_min, out_max);

ncond=0;
condition = DONTQUIT;
while ( condition == DONTQUIT )
{
   for (nc=0;nc<16;++nc)
   {
      q_init (&block,P_BYTES,P_ABORT);
      q_dynp (&block,"OVRLRNG",M_FULLPDF);
      if ((p_inim (&block,sizeof(struct PARBLK),P_CONT) == SUCCESS))
      {
         c_getnum (&block,"GREYRANG",&four,&otype,g[nc]);
            if (g[nc][1] < g[nc][0])
            {
               save=g[nc][1];
               g[nc][1]=g[nc][0];
               g[nc][0]=save;
            } 
            if (g[nc][3] < g[nc][2])
            {
               save=g[nc][3];
               g[nc][3]=g[nc][2];
               g[nc][2]=save;
            }
         c_getstr (&block,"LOGICOP",&one,&three,ao);
         if ( strcmp(ao,"AND")== 0)iao[nc] = 1;
         else                      iao[nc] = 2;
     	 c_getnum (&block,"GREYOUT",&one,&otype,&gor[nc]);
         ncond++;
      }
      else
        loopbreak = QUIT;
      if ( loopbreak == QUIT ) break; 
   }
/*
if no condition entered inform user and prompt again
____________________________________________________  */
   if (ncond == 0 )
      {
      c_errmsg("No values entered","overlay-none",&one);
      c_clean(&vblock,"overlay",hos_out,&one);
      }
   else 
      condition = QUIT;
}
/*
initialize messages
------------------ */
c_inittm ("OVERLAY", "Processed", "line", "bands", " ", nlout, num_bands, 
          &msgtim, &msg_flag);
curent = 1;
c_startm();
/*
process output file band by band 
_________________________________  */
for ( il=0;il < *nlout;++il,++curent )
{              
   c_estep (&gdesc);
   for ( nb=0;nb < *num_bands;++nb )
   {
/*
process output image pixel by pixel
-----------------------------------  */
      for ( ip=0;ip < *nsout;++ip)
      {
/*
process each pixel for all condition
------------------------------------  */
         for ( nc=0;nc < ncond;++nc)
         { 
            cond70 = DONTQUIT;
            if (iao[nc] == 1)
            {
               if ((buf[ipp[0][nb]+ip] <= g[nc][1] && buf[ipp[0][nb]+ip]
                >= g[nc][0]) && 
               (buf[ipp[1][nb]+ip] <= g[nc][3] && buf[ipp[1][nb]+ip]
                >= g[nc][2]))
               {     
                  buf[op[nb]+ip]= (unsigned char) gor[nc];
                  cond70 = QUIT;
               } 
            }  
            else
            { 
               if ((buf[ipp[0][nb]+ip] <= g[nc][1] && buf[ipp[0][nb]+ip]
                >= g[nc][0]) || 
               (buf[ipp[1][nb]+ip] <= g[nc][3] && buf[ipp[1][nb]+ip]
                >= g[nc][2]))
               { 
                  buf[op[nb]+ip]= (unsigned char) gor[nc];
                  cond70 = QUIT;
               }
            }    
            if ( cond70 == QUIT ) break;
         }  
         if ( cond70 != QUIT ) 
         {
            if      (bkgrnd == -1 )     buf[op[nb]+ip]=buf[ipp[0][nb]+ip];
            else if (bkgrnd == -2)      buf[op[nb]+ip]=buf[ipp[1][nb]+ip];
            else                        buf[op[nb]+ip]= (unsigned char) bkgrnd;
         }
      }  
   } 
/*
update min and max arrays if needed
-----------------------------------*/
   if ( min_max )
      for ( nb=0;nb < *num_bands;++nb )
          c_pxmnmx (&buf[op[nb]], nsout, &out_min[nb], &out_max[nb],
                     &type);
}
/*
update output image ddr min max fields
--------------------------------------*/
if ( min_max )
   c_svmnmx (hos_out[0], num_bands, out_min, out_max, "YES");

c_estep (&gdesc);
c_stoptm();
c_egclse (&gdesc);
}
