#ifndef PROTOS_H
#define PROTOS_H

void fast_proc
(
    struct PARBLK *vblk,	/* I: TAE parameter block		      */
    char *hosin1,		/* I: host name of elevation image            */
    char *hosin2,		/* I: host names of reflectence images	      */
    char *hosout,		/* I: host output name			      */
    long *window1,		/* I: window of elevation image		      */
    long *bands1,		/* I: band specification of first input image */
    long *window2,		/* I: window of reflectance image             */
    long *bands2,		/* I: band specification of second input image*/
    long *totbnd,		/* I: number of bands in second input image   */
    long *out_wind,		/* I: output window specification             */
    float *pixsiz,		/* I: pixel size                              */
    long *viewloc,		/* I: viewer location			      */
    float *viewdir,		/* I/O: viewer direction		      */
    float *foview,		/* I: field of view                           */
    float *vertscl,		/* I: vertical scaling factor                 */
    long *horizn,		/* I: height of horizon 		      */
    long *skyval,		/* I: value of the sky line		      */
    long *odtype,		/* I: output data type			      */
    long *msgtim,		/* I: time between messages		      */
    char *minmax,		/* I: min/max flag			      */
    double *minval,		/* I/O: minimum value of output image	      */
    double *maxval		/* I/O: maximum value of output image	      */
);

void getpar
(
    struct PARBLK *vblk,        /* I: TAE parameter block		      */
    char *hosin1,		/* O: host name of elevation image	      */
    char *hosin2,		/* O: host name of reflectence image	      */
    char *hosout,		/* O: host name of output image		      */
    long *window1,		/* O: window specified for elevation image    */
    long *bands1,		/* O: band specified for elevation image      */
    long *window2,		/* O: window specified for reflectence image  */
    long *bands2,		/* O: bands specified for reflectence image   */
    long *totbnd,    	        /* O: total bands specified for reflectence 
				      image*/
    long *out_wind,		/* O: output window specification	      */
    float *pixsiz,		/* O: pixel size 			      */
    long *viewloc,		/* O: viewer location			      */
    float *viewdir,		/* O: viewing direction			      */
    float *foview,		/* O: field of view parameter		      */
    float *vertscl,		/* O: vertical scaling factor		      */
    long *horizlin,		/* O: Line that will be the start of the hrizn*/
    long *skyval,		/* O: the pixel value of the sky	      */
    long *odtype,		/* O: output data type			      */
    long *msgtim,		/* O: display message interval time	      */
    char *minmax		/* O: minmax flag			      */
);

void proces
(
    struct PARBLK *vblk,	/* I: TAE parameter block		      */
    char *hosin1,		/* I: host name of elevation image	      */
    char *hosin2,		/* I: host names of reflectence images	      */
    char *tempout,		/* I: temporary output name		      */
    long *window1,		/* I: window of elevation image		      */
    long *bands1,		/* I: band specification of first input image */
    long *window2,		/* I: window of reflectance image	      */
    long *bands2,		/* I: band specification of second input image*/
    long *totbnd,		/* I: number of bands in second input image   */
    long *out_wind,		/* I: output window specification	      */
    float *pixsiz,		/* I: pixel size			      */
    long *viewloc,		/* I: viewer location			      */
    float *viewdir,		/* I/O: viewer direction                      */
    float *foview,		/* I: field of view			      */
    float *vertscl,		/* I: vertical scaling factor		      */
    long *horizn,		/* I: height of horizon 		      */
    long *skyval,		/* I: value of the sky line		      */
    long *odtype,		/* I: output data type			      */
    long *msgtim		/* I: time between messages		      */
);

void procesl
(
    struct PARBLK *vblk,	/* I: TAE parameter block		      */
    char *hosin1,		/* I: host name of elevation image	      */
    char *hosin2,		/* I: host names of reflectence images	      */
    char *tempout,		/* I: temporary output name		      */
    long *window1,		/* I: window of elevation image		      */
    long *bands1,		/* I: band specification of first input image */
    long *window2,		/* I: window of reflectance image	      */
    long *bands2,		/* I: band specification of second input image*/
    long *totbnd,		/* I: number of bands in second input image   */
    long *out_wind,		/* I: output window specification	      */
    float *pixsiz,		/* I: pixel size			      */
    long *viewloc,		/* I: viewer location			      */
    float *viewdir,		/* I/O: viewer direction		      */
    float *foview,		/* I: field of view			      */
    float *vertscl,		/* I: vertical scaling factor		      */
    long *horizn,		/* I: height of horizon 		      */
    long *skyval,		/* I: value of the sky line		      */
    long *odtype,		/* I: output data type			      */
    long *msgtim		/* I: time between messages		      */
);

void procesr
(
    struct PARBLK *vblk,	/* I: TAE parameter block		      */
    char *hosin1,		/* I: host name of elevation image	      */
    char *hosin2,		/* I: host names of reflectence images	      */
    char *tempout,		/* I: temporary output name		      */
    long *window1,		/* I: window of elevation image		      */
    long *bands1,		/* I: band specification of first input image */
    long *window2,		/* I: window of reflectance image	      */
    long *bands2,		/* I: band specification of second input image*/
    long *totbnd,		/* I: number of bands in second input image   */
    long *out_wind,		/* I: output window specification	      */
    float *pixsiz,		/* I: pixel size			      */
    long *viewloc,		/* I: viewer location			      */
    float *viewdir,		/* I/O: viewer direction		      */
    float *foview,		/* I: field of view			      */
    float *vertscl,		/* I: vertical scaling factor		      */
    long *horizn,		/* I: height of horizon 		      */
    long *skyval,		/* I: value of the sky line		      */
    long *msgtim		/* I: time between messages		      */
);

void procesw
(
    struct PARBLK *vblk,	/* I: TAE parameter block		      */
    char *hosin1,		/* I: host name of elevation image	      */
    char *hosin2,		/* I: host names of reflectence images	      */
    char *tempout,		/* I: temporary output name		      */
    long *window1,		/* I: window of elevation image		      */
    long *bands1,		/* I: band specification of first input image */
    long *window2,		/* I: window of reflectance image	      */
    long *bands2,		/* I: band specification of second input image*/
    long *totbnd,		/* I: number of bands in second input image   */
    long *out_wind,		/* I: output window specification	      */
    float *pixsiz,		/* I: pixel size			      */
    long *viewloc,		/* I: viewer location			      */
    float *viewdir,		/* I/O: viewer direction		      */
    float *foview,		/* I: field of view			      */
    float *vertscl,		/* I: vertical scaling factor		      */
    long *horizn,		/* I: height of horizon 		      */
    long *skyval,		/* I: value of the sky line		      */
    long *odtype,		/* I: output data type			      */
    long *msgtim		/* I: time between messages		      */
);
#endif
