#ifndef PROTOS_H
#define PROTOS_H

void galpha1
(
    float matrix[][3],        /* 3x3 matrix from input image */
    double alpha,          /* Angle between sun and surface */
    double mask,           /* Mask value for non-inclusive data */
    long method,         /* Method of calculation */
    float a[],            /* Constants to describe sun direction */
    double dirx1,          /* Directional derivative in x-direction */
    double diry1,          /* Directional derivative in y-direction */
    double dirx2,          /* Directional derivative in x-direction */
    double diry2,          /* Directional derivative in y-direction */
    double oexp,           /* Exponent factor for the output scene */
    double tnsity,         /* Output sun intensity factor */
    double ambien,         /* Ambient light factor */
    long odtype,         /* Output data type */
    long pix            /* Current pixel */
);

void galpha2
(
    float matrix[][3],        /* 3x3 matrix from input image */
    long method,         /* Method of calculation */
    double mask,           /* Mask value for non-inclusive data */
    float a[],            /* Constants to describe sun direction */
    float b[],            /* Constants to describe sun direction */
    double dirx1,          /* Directional derivative in x-direction */
    double diry1,          /* Directional derivative in y-direction */
    double dirx2,          /* Directional derivative in x-direction */
    double diry2,          /* Directional derivative in y-direction */
    double oexp,           /* Exponent factor for the output scene */
    double iexp,           /* Exponent factor for input scene */
    double tnsity,         /* Output sun intensity factor */
    double ambien,         /* Ambient light factor */
    long odtype,         /* Output data type */
    long pix,            /* Current sample */
    float *workbuf2      /* Buffer with 2nd image data */
);

void getpar
(
    char subcmd[],       /* Subcommand */
    char lasin[][CMLEN],        /* LAS name for input elevation image */
    char hosin[][CMLEN],        /* Host name for input elevation image */
    char lasin2[][CMLEN],    /* LAS names for input composite image */
    char hosin2[][CMLEN],    /* Host names for input composite images */
    char lasout[][CMLEN],       /* Output image LAS name */
    char hosout[][CMLEN],       /* Output image host name */
    long window[MAXIMG][4],  /* Window specifications for 1st image */
    long window2[MAXIMG][4],     /* Window specifications for 2nd image */
    long *odtype,        /* Output data type */
    float *osunang,       /* Sun angle for the 1st image */
    float *oazmth,        /* Azimuth angle for the 1st image */
    float *oexp,          /* Exponent value for the 1st image */
    float *isunang,       /* Sun angle for the 2nd image */
    float *iazmth,        /* Azimuth angle for the 2nd image */
    float *iexp,          /* Exponent value for the 2nd image */
    float xygrd[2],       /* x and y ground scale factor */
    float *zscale,        /* Input scale factor */
    float *mask,          /* Mask value for non-inclusive data */
    long *method,        /* Method of calculation */
    float *tnsity,        /* Output sun intensity factor */
    float *ambien,        /* Ambient light factor */
    long *mnmx,          /* Min/max value */
    long *msgtim,        /* Time interval for the processing message */
    long *num_inimg,         /* Number of input images from IN(1) */
    long *num_inimg2,        /* Number of input images from IN(2) */
    long *totbnd,        /* Total number of bands in 1st image */
    long *totbnd2       /* Total number of bands in 2nd image */
);

void initio
(
    char hosin[][CMLEN],        /* Host name for the elevation image */
    char hosin2[][CMLEN],    /* Host name for the composite image */
    char hosout[],       /* Host name for the output image */
    long num_inimg,      /* Number of input images from IN(1) */
    long num_inimg2,     /* Number of input images from IN(2) */
    long wind[][4],      /* Window specification for the 1st image */
    long wind2[][4],     /* Window specification for the 2nd image */
    long totbnd,         /* Total number of bands in the 1st image */
    long totbnd2,        /* Total number of bands in the 2nd image */
    long otype,          /* Output data type */
    char subcmd[]       /* Subcommand */
);

void option1
(
    long method,         /* Method of calculation */
    float xygrd[2],       /* x and y ground scale factor */
    double mask,           /* Mask value for non-inclusive data */
    double zscale,         /* Input scale factor */
    long odtype,         /* Output data type */
    double oexp,           /* Exponent factor for the output scene */
    double tnsity,         /* Output sun intensity factor */
    double ambien,         /* Ambient light factor */
    long wind[][4],      /* Window specifications */
    float a[],            /* Constants to describe sun direction */
    long msgtim,         /* Time processing message time interval */
    long bnd,            /* Input image band to be read */
    long img            /* Image number */
);

void option2
(
    long method,         /* Method of calculation */
    float xygrd[2],       /* x and y ground scale factor */
    double mask,           /* Mask value for non-inclusive data */
    double zscale,         /* Input scale factor */
    long odtype,         /* Output data type */
    double tnsity,         /* Output sun intensity factor */
    double oexp,           /* Exponent factor for the output scene */
    double iexp,           /* Exponent factor for the input scene */
    double ambien,         /* Ambient light factor */
    float a[],    /* Constants to describe sun direction for the output scene */
    float b[],    /* Constants to describe sun direction for the input scene */
    long num_lines,      /* Number of lines in the image */
    long num_pixels,     /* Number of samples in the image */
    long *outband,       /* Output band number */
    long img            /* Current image number */
);

void msg_err
(
    char *message,   /* Text of the error message */
    char *key       /* Error key */
);

#endif

