/*****************************************************************************
 *
 * NAME     msg_err
 *
 * PURPOSE  To display an error message and exit PICSHADE if it is fatal.
 *      The first character of the error message determines whether
 *      or not the error is fatal.
 *
 * PROGRAM HISTORY
 *
 *  Programmer      Date        Reason
 *  ----------      ----        ------
 *  Eric Ivancich / SAR 13-Aug-87   C conversion
 *      Bani Allam              8-Aug-88        Retrocode
 *
 * PARAMETERS
 *
 *  Name        Type        I/O Description
 *  ----        ----        --- -----------
 *  *message    char        I   Error message and severity
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *  None
 *
 * RETURN VALUES
 *
 *  None
 *
 *****************************************************************************/
#include "picshade.h"


void msg_err
(
    char *message,   /* Text of the error message */
    char *key       /* Error key */
)

{


switch (*message++)  
   {
   case '?' :   c_lasmsg(FALSE,key,message); break;
   case '!' :   {
        c_lasmsg(FALSE,key,message);
                if (fdescout) c_eclose (&fdescout);
                c_clean (&block, "PICSHADE", out_files, &num_files);
                }
   }
}
