#ifndef PROTOS_H
#define PROTOS_H

int chk_window
(
    long *inspc,    /* I: input image file specifications     */
    long *window    /* I/O: window area of image to be copied */
);

int getpar
(
    struct PARBLK *vblock,	/* I: pointer to TAE parameter block         */
    struct DDR *ddr,            /* I: DDR structure for image file           */
    char *hosin,       	        /* O: host file names of input images        */
    char *taeout,		/* O: TAE file name of output image          */
    char *hosout,		/* O: host file name of output imag          */
    long window[][4],		/* O: window specifications for ea input image*/
    long maxwin[],		/* O: overall window containing parameter
				      windows                                */
    long *totwin,		/* O: total number of windows                */
    long (*bands)[MAXBND+1],	/* O: band specifications for each input image*/
    long *totbnd,		/* O: total number of bands to be processed  */
    long *updatflg,		/* O: Flag to signal update   	             */
    long *inspc,		/* O: Total number lines, samples, and bands */
    float *pixval,		/* O: Specified pixel value   		     */
    long *msgtim,		/* O: elapsed time between display messages  */
    char *minmax		/* O: min max flag buffer                    */
);

void proces
(
    struct PARBLK *vblock,	/* I: TAE parameter block		     */
    struct DDR *ddr,            /* I: DDR structure for image file           */
    char *hosin,		/* I: host names of input image		     */
    char *hosout,		/* I: host name of output image		     */
    long (*window)[4],		/* I: window specification of input images   */
    long *maxwin,		/* I: overall window containing parameter  
                                      windows                                */
    long *totwin,		/* I: total number of windows		     */
    long (*bands)[MAXBND+1],	/* I: bands to be processed for all images   */
    long nbands[],		/* I: number of bands of input image         */
    long totbnd,		/* I: total number of bands to be processed  */
    float *pixval,		/* I: Specified pixel value		     */
    long *updatflg, 		/* I: Flag for update mode                   */
    long msgtim,		/* I: elapsed time between display messages  */
    char *minmax		/* I: min max flag                           */
);
#endif
