/*
***************************************************************************

NAME: CHKINT

PURPOSE: Checks that grey level is in the proper range for image type

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1          1/01/85    Y. Sheu
    2          7/28/89    K. A. Narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
#include "las.h"
#include "typlim.h"
#include "protos.h"

long    chkint 
(
        double  grey,   /* I: grey level                   */
        long    type    /* I: image type                   */
)
{
long	val;

val = FALSE;                                                  

if ((type  ==  EBYTE && (grey  <  MINUTINY  ||  grey  > MAXUTINY)) ||
    (type  ==  EWORD && (grey  <  MINWORD  || grey  > MAXWORD)) ||
    (type  ==  ELONG && (grey  <  MINLONG || grey  > MAXLONG )))
   val = TRUE;

return (val);
}                                                                    
