/*
***************************************************************************

NAME: COPY_IMAGE

PURPOSE: Copies input image to output

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1          1/01/85    Y. Sheu
    2          7/28/89    K. A. Narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
#include "pixsert.h"
#include "util.h"
#include "pixman.h"
#include "protos.h"

void copy_image
(
    char hosin[][CMLEN],      /* I: input images host names            */
    char hosout[],            /* I/O: output image host name           */
    long num_images,          /* I: number of input images             */
    long num_image_bands[],   /* I: number of bands in each image      */
    long image_band_num[][MAXBND + 1], /* I: image band numbers        */
    long *otype,              /* I: output image data type             */
    long wind[][4],           /* I: input image windows                */
    long *num_bands           /* I: no. bands                          */
)

{
extern int *fdesc;
extern int *ipoint;
extern int *opoint;

long    band,                  	/* band counter                 */
        image,                 	/* image loop counter           */
        line,                  	/* line loop counter            */
	msg_flag = ALLCAT,     	/* message flag for c_inittm    */
	size,                  	/* pixel size                   */
	type=0,                	/* file type for filspec        */
	stat,			/* return status 		*/
	n;
long    inf_err = 1;
long    one = 1;

/*
open input and output images
----------------------------*/
filspec (hosin, hosout, num_images, num_image_bands, num_bands,
         image_band_num, wind, *otype, &type);
/*
initialize processing message utility
-------------------------------------*/
c_inittm ("PIXSERT", "Copied", "line", "bands", "", &wind[0][NL], num_bands,
          &msgtim, &msg_flag);
curent = curcat = 1;
c_startm ();
/*
copy input to output
--------------------*/
stat = c_estep ((struct GDESC **)&gdesc); 
if (stat != E_SUCC)
	c_abort(&block, "Error copying image","pixsert-copy",
	        "pixsert",(char (*)[256])hosout, &one);

if (*otype == EBYTE ) size = 1;
  else if (*otype == EWORD) size = sizeof(short);
  else if (*otype == ELONG) size = sizeof(long);
  else size = sizeof (float);

for (line = 0; line < wind[0][NL]; line++, curent++)
 {
  for (image = 0, band = 0; image < num_images; image++)
    for (n = 0; n < num_image_bands[image]; n++, band++)
       c_pxcopy((unsigned char *)iobuf+(*(ipoint+band)*size),
	   (unsigned char *)iobuf+(*(opoint+band)*size), &type, &wind[0][NS]);

     stat = c_estep ((struct GDESC **)&gdesc); 
     if (stat != E_SUCC)
     	c_abort(&block, "Error copying image","pixsert-copy",
	        "pixsert",(char (*)[256])hosout, &one);
   }
/*
stop processing message and close files
---------------------------------------
*/
c_stoptm ();
stat = c_egclse ((struct GDESC **)&gdesc);
if (stat != E_SUCC)
   c_errmsg("Nonfatal error encountered.","pixsert-warn", &inf_err);
}
