/*
***************************************************************************

NAME: FN

PURPOSE: Computes transformation

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1          1/01/85    Y. Sheu
    2          7/28/89    K. A. Narayanan    conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
#include <math.h>
#include "las.h"
#include "protos.h"

float fn 
(
        long    ndeg,   /* I: degree of polynomial         */
        float   cc[],   /* I: polynomial coefficients      */
        float   x,      /* I: x value                      */
        float   y       /* I: Y VALUE                      */
)
{
float	x1,             /* intermediate hold for x to the i power */ 
        y1,             /* intermediate hold for y to the j power */ 
        val;            /* computed transformation                */ 

long	i,              /* exponent to use for the x values       */ 
        ii,             /* array pointer                          */
        j,              /* exponent to use for the y values       */
        jj,             /* loop counter                           */
        kk,             /* loop counter                           */
        nt;             /* loop bound                             */

val = cc[0];

ii= 0;
for (kk= 1; kk <= ndeg; kk++)
   {
   i= kk;
   j= 0;
   nt= kk + 1;

/*
       ----- for terms  x**i, (x**(i-1))y,.. ,y**i
*/
   for (jj = 1; jj <= nt; jj++)
      {
      ii++;
      x1= 1.;
      if (i > 0) x1= pow ((double) x, (double) i);
      y1= 1.;
      if (j > 0) y1= pow ((double) y, (double) j);
      val += cc[ii]*x1*y1;
      i--;
      j++;
      }
   } 
return (val);
}
