/*
***************************************************************************

NAME: GEN_IMAGE

PURPOSE: Generates a constant valued image

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1          1/01/85    Y. Sheu
    2          7/28/89    K. A. Narayanan    conversion to 5.0
    3	       7/29/91	  K. Kimball	     Removed unused variable bktype.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
#include "pixsert.h"
#include "util.h"
#include "pixman.h"
#include "protos.h"

void gen_image
(
    char hosin[][CMLEN],      /* I: input images host names            */
    char hosout[],            /* I: output image host name             */
    long num_images,          /* I: number of input images             */
    long num_image_bands[],   /* I: number of bands in each image      */
    long image_band_num[][MAXBND + 1], /* I: image band numbers        */ 
    long *otype,              /* I: output image data type             */
    long wind[][4],           /* I: input image windows                */
    long *num_bands,          /* I: no. bands                          */
    double *backgrnd          /* I: output image background            */
)

{
extern int *opoint;

long	line,                        /* loop counter for line              */
	msg_flag = ALLCAT,           /* message flag for c_inittm          */
	size,                        /* pixel size                         */ 
	type=0,                      /* file type for filspec              */
	stat,                        /* return status                      */
	n;   
short sbkgd;
long lbkgd;
float fbkgd;
unsigned char *ibkgd;
long five=5;
long    inf_err = 1;
long    one = 1;

ibkgd = (unsigned char *) malloc(sizeof(float));
/*
open image
----------
*/
filspec (hosin, hosout, num_images, num_image_bands, num_bands,
                  image_band_num, wind, *otype, &type);
/*
initialize processing message utility
-------------------------------------
*/
c_inittm ("PIXSERT", "Generated", "line", "bands", "", &wind[0][NL], num_bands,
          &msgtim, &msg_flag);
curent = 1;
c_startm ();
/*
generate the image
------------------
*/
if (*otype == EBYTE) size = 1;
   else if (*otype == EWORD) size = sizeof(short);
   else if (*otype == ELONG) size = sizeof(long);
   else size = sizeof(float);

stat = c_estep ((struct GDESC **)&gdesc); 
if (stat != E_SUCC)
   c_abort(&block,"Error generating image","pixsert-estep",
           "pixsert",(char (*)[256]) hosout, &one);

for (line = 0; line < wind[0][NL]; line++, curent++)
   {
   for (n = 0; n < *num_bands; n++)
   if (*otype == EBYTE)
      {
	stat = c_pxconv(&five, &one,(unsigned char *)backgrnd, ibkgd,&one);
      c_pxfill (((unsigned char *)iobuf+(*(opoint+n)*size)),&type,&wind[0][NS],
                  ibkgd);
      }
   else if (*otype == EWORD)
      {
      sbkgd = (short) *backgrnd;
      c_pxfill (((unsigned char *)iobuf+(*(opoint+n)*size)),&type,&wind[0][NS],
                 (unsigned char *)&sbkgd);
      }
   else if (*otype == ELONG)
      {
      lbkgd = (long) *backgrnd;
      c_pxfill (((unsigned char *)iobuf+(*(opoint+n)*size)),&type,&wind[0][NS],
                 (unsigned char *)&lbkgd);
      }
   else
      {
      fbkgd = (float) *backgrnd;
      c_pxfill (((unsigned char *)iobuf+(*(opoint+n)*size)),&type,&wind[0][NS],
                  (unsigned char *)&fbkgd);
      }

   stat = c_estep ((struct GDESC **)&gdesc); 
   if (stat != E_SUCC)
      c_abort(&block,"Error generating image","pixsert-estep",
              "pixsert", (char (*)[256])hosout, &one);
   }
/*
stop processing message and close image
---------------------------------------
*/
c_stoptm ();
stat = c_egclse ((struct GDESC **)&gdesc);
if (stat != E_SUCC)
   c_errmsg ("Nonfatal Error encountered.","pixsert-warn", &inf_err);
}
