/****************************************************************************

NAME: TERMINATE

PURPOSE: Update output image min/max and history and issue completion message

PROGRAM HISTORY:
  Version       Date       Author             Request
  -------       ----       ------             -------
    ??           ??          ??                ??
    2.0         3/97       B.Olson            Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Runs under TAE

PROJECT:        LAS

****************************************************************************/

#include "pixsert.h"
#include "util.h"
#include "protos.h"

void terminate
(
    char las_out[],         /* I: output image host name               */
    char hos_out[],         /* I: output image host name               */
    char hos_in[][CMLEN],   /* I: input images host names              */
    long *num_inimages,     /* I: number of input images               */
    long *num_bands,        /* I: number of bands                      */
    long wind[][4]          /* I: input image windows                  */
)
{
double	max_val[MAXBND],           /* maximum value array                  */
        min_val[MAXBND];           /* minimum value array                  */

long 	stat;                      /* return status flag                   */

long	i,                         /* loop counter                         */
        band_num[MAXBND+1],        /* band number                          */
        window[4];                 /* sub window                           */

long    inf_err = 1;
long    one = 1;

if (min_max)
   {
   window[SS] = window[SL] = 1;
   window[NS] = wind[0][NS];
   window[NL] = wind[0][NL];

   for ( i = 0; i < *num_bands; i++) band_num[i] = i + 1;
   band_num[i] = 0;

   stat=c_minmax ((char (*)[256])hos_out, &one, (long (*)[4])window, 
                  (long (*)[257])band_num, num_bands, min_val, max_val);
   if (stat != E_SUCC)
      c_errmsg("Nonfatal error encountered","pixsert-warn",&inf_err);
   }
stat = c_hstout (&block, hos_out, hos_in, num_inimages, "");
if (stat != E_SUCC)
   c_errmsg("Nonfatal error encountered","pixsert-warn",&inf_err);
/*
issue completion message
------------------------
*/
c_complt ("PIXSERT", (char (*)[256])las_out, &one);
}
