/*****************************************************************************
*
*  NAME:  MAXOPT
*
*  FUNCTION: Create the translation table and the Labeled Table
*
*	
*  PROGRAM HISTORY:
*  Version	Date	Programmer	Code	Request
*  -------	----	----------	----	-------
*   5.0	       11/89	R.McKinney 	DDPS	LAS 5.0 Conversion
*   5.1         7/91    T.Mittan        LAS     Convert to baseline code
*                                               and improve performance.
*
*  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
* 	Must be run under TAE
*
*  PROJECT:  LAS
*
*  ALOGRITHM DESCRIPTION:
*  Write out the LT file.  The minimum and the maximum have already been
*  calculated.
*
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "ltable.h"
#include "pixstat.h"
#include "protos.h"

int maxopt
(
    struct TAB_DEF *tab,		/* labeled table descriptor	*/
    long *bnd,			/* total number of bands	*/
    struct RECORD *perm,            /* permutation attributes       */
    long *class,                    /* class number                 */
    long *pixval,                   /* pixel values                 */
    long *pxcnt,                    /* number of pixel values       */
    long *pixflg,                   /* TRUE if pixel value option used */
    long *minv                     /* minimum offset values        */
)	

{

long j,	              		/* loop counters		*/
     temp;                      /* temparary holding value      */


struct VECTOR *ptr;		/* pointer to current vector */
struct MATRIX size;		/* matrix size */

/* Initialize the needed variables
----------------------------------*/

size.nrow = 1;
size.ncol = 1;


/* Build the Labeled Table.
-------------------------*/
   /* Read in the next record
   --------------------------*/
if (*pixflg == 0)
   {
   for (j = 0; j < *class; j++)
      {
      if (perm[j].count > 0)
        {
		ptr = tab->vector;
                temp = j + minv[0]; 
	    	put_matrix(ptr,I4,&size,&temp);
    		ptr = ptr->next;
    		put_matrix(ptr,I4,&size,bnd);
    		ptr = ptr->next;
    		put_matrix(ptr,I4,&size,&perm[j].max1);
    		ptr = ptr->next;
    		put_matrix(ptr,I4,&size,&perm[j].min1);
    		put_record(tab);
             }
            }

    }
else
   {
   for (j = 1; j < *pxcnt; j++)
      {
      if (perm[pixval[j]].count > 0)
             {
		ptr = tab->vector;
	    	put_matrix(ptr,I4,&size,&pixval[j]);
    		ptr = ptr->next;
    		put_matrix(ptr,I4,&size,bnd);
    		ptr = ptr->next;
    		put_matrix(ptr,I4,&size,&perm[pixval[j]].max1);
    		ptr = ptr->next;
    		put_matrix(ptr,I4,&size,&perm[pixval[j]].min1);
    		put_record(tab);
             }
            }
}
return(E_SUCC);
}
