#ifndef PROTOS_H
#define PROTOS_H

int allopt
(
    struct TAB_DEF *tab,		/* labeled table descriptor	*/
    long *bnd,			/* total number of bands	*/
    struct RECORD *perm,            /* permutation attributes       */
    long *class,                    /* number of classes            */
    long *range,                    /* range of values              */
    long *minv,                     /* minimum value offset         */
    long *pxvalue,                  /* pixel value                  */
    long *pxcnt,                    /* number of pixel values       */
    long *pxflg                    /* TRUE if pixvalue option used */
);

int getpar
(
    struct PARBLK *vblock,		/* TAE parameter block		*/
    char hosin[][CMLEN],		/* Input host file names	*/
    char *hosout,			/* Output host file image name  */
    char *lthos,			/* Output LT host file name	*/
    long *nbands,			/* number of bands		*/
    long (*wind)[4],		/* window specification	for each image */
    long *maskval,			/* mask values			*/
    long (*bands)[MAXBND+1],	/* band specifications for each input image */
    long *totbnds,			/* total number of bands	*/
    long *pixval,			/* pixel values to be selected  */
    char *statcalc,			/* statistical option		*/
    long *nmrimg,			/* number of images being processed */
    long *mskflg,			/* masking flag			*/
    long *pixflg,			/* pixel flag			*/
    long *imgflg,			/* flag for output image        */
    long *msgtim,			/* message timing 		*/
    long *pixcnt,			/* number of pixel values       */
    long *mskcnt,			/* number of mask values   	*/
    double *minval,                 /* minimum value                */
    double *maxval,                 /* maximum value                */
    long *ltflg                    /* flag for output labeled table */
);

void get_permutation_num
(
    struct RECORD *perm,		/* permutation records			*/
    long *curatt,			/* current attributes			*/
    long *minv                     /* minimum offset                       */
);

void initlt
(
    struct TAB_DEF *tab,		/* Labeled table descriptor */
    char *lthos,			/* labeled table host file name */
    char *statcalc			/* statistical option		*/
);

int maxopt
(
    struct TAB_DEF *tab,		/* labeled table descriptor	*/
    long *bnd,			/* total number of bands	*/
    struct RECORD *perm,            /* permutation attributes       */
    long *class,                    /* class number                 */
    long *pixval,                   /* pixel values                 */
    long *pxcnt,                    /* number of pixel values       */
    long *pixflg,                   /* TRUE if pixel value option used */
    long *minv                     /* minimum offset values        */
);

int medopt
(
    struct TAB_DEF *tab,		/* labeled table descriptor	*/
    long *bnd,			/* total number of bands        */
    struct RECORD *perm,            /* permutation attributes       */
    long *class,                    /* class number                 */
    long *minv,                     /* minimum value offset         */
    long *pixvalue,                 /* pixel value                  */
    long *pxcnt,                    /* number of pixels             */
    long *pixflg,                   /* TRUE if pixvalue option used */
    long *range                    /* Range of values              */
);

int menopt
(
    struct TAB_DEF *tab,		/* labeled table descriptor	*/
    long *bnd,			/* total number of bands	*/
    struct RECORD *perm,           /* permutation count            */
    long *class,                    /* total number of classes      */
    long *pixval,                   /* pixel values (class values)  */
    long *pxcnt,                    /* number of class values       */
    long *pixflg,                   /* true if pixel values specified */
    long *minv                     /* minimum offset               */
);

int modopt
(
    struct TAB_DEF *tab,		/* labeled table descriptor	*/
    long *bnd,			/* total number of bands	*/
    struct RECORD *perm,            /* permutation attributes       */
    long *class,                    /* number  of classes           */
    long *range,                    /* range of values              */
    long *minv,                     /* minimum value offset         */
    long *pixvalue,                 /* pixel values                 */
    long *pxcnt,                    /* number of pixel values       */
    long *pixflg                   /* TRUE if pixel value option used */
);

int opnlas
(
    char hosin[][CMLEN],		/* input host file names	*/
    long (*wind)[4],		/* window specifications for each input image */
    long (*bands)[MAXBND + 1],	/* bands to be processed for all images */
    long *nbands,			/* number of bands for input images*/
    long *nmrimg,			/* number of input images	*/
    long *nl,			/* number of lines		*/
    long *ns,			/* number of samples		*/
    long *sl,			/* starting line in input image window	*/
    long *ss,			/* starting sample in input image window */
    long *bandnum                  /* band number                  */
);

int proces
(
    struct PARBLK *vblock,		/* TAE paramater block		*/
    char hosin[][CMLEN],		/* input host file names	*/
    char hosout[][CMLEN],                  /* listing file name            */
    char *lthos,			/* output LT host file name	*/
    long (*wind)[4],		/* window specifications for each input image */
    long (*bands)[MAXBND + 1],	/* bands to be processed for all images */
    long *nbands,			/* number of bands for input images*/
    long *totbnds,			/* total no. of bands to be processed */
    long *nmrimg,			/* number of input images	*/
    long *maskval,			/* mask values for each band	*/
    long *pixval,			/* pixel values for each band	*/
    char *statcalc,		/* statistical option		*/
    long *mskflg,			/* masking flag			*/
    long *pixflg,			/* masking flag			*/
    long *pixcnt,			/* number of pixel values	*/
    double *minval,                 /* minimum value                */
    double *maxval,                 /* maximum value                */
    long *msgtim,                   /* message timing value         */
    long *imgflg,                   /* output list flag             */
    long *ltflg                    /* labled table flag            */
);

#endif

