/******************************************************************************
FUNCTION:	CLEAN_UP

PURPOSE:	Close the tape, delete the print file and delete the image file

ALGORITHM 
  Close the tape drive
  Clean up any files (image and print files)

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include "las.h"		/* Las include				*/
#include "tapeio.h"		/* Tape I/O include			*/
#include "util.h"
#include "protos.h"

void clean_up
(void)
{
extern struct PARBLK vblock;	/* Variable block			*/
extern char out[][CMLEN];	/* Output files needed to be cleaned up */
extern long outcnt;		/* Output file count			*/
extern long uni;		/* Tape unit number			*/
extern FILE *fp;		/* File pointer to print file		*/
extern long prnt;		/* Print file flag (T = open F = closed)*/
extern long las;		/* Image file flag (T = open F = closed)*/
extern long tape;		/* Tape file flag  (T = open F = closed)*/

long mode = HANDLE;		/* Tape I/O handles errors		*/
long rewopt = REWOFFL;		/* Rewind off line option		*/
long eofopt = 1;		/* Number of output tape marks		*/

/*
  Close the tape
*/
if (tape)
    c_tpclos(&uni,&mode,&rewopt,&eofopt);

/*
  Close the print file
*/
if (prnt)
    fclose(fp);

/*
  Close the image file
*/
if (las)
    close_las();

/*
  Clean up any files
*/
c_clean(&vblock,"plenter",out,&outcnt);

}
