/****************************************************************************
NAME:               pabort

PURPOSE:  Handles all fatal error conditions & exits gracefully

ALGORITHM DESCRIPTION:
    Determine error condition
    Print error message
    Print final error message and exit

ALGORITHM REFERENCES:
*****************************************************************************/
#include "polyfit.h"

void pabort
(
    long status            /* Error condition flag */
)
{

switch(status)
    {
    case NO_SPACE:
        c_lasmsg(FALSE,"polyfit-alloc","Unable to allocate dynamic memory");
        break;
    case NO_FIT_X:
        c_lasmsg(FALSE,"polyfit-nofit","Cannot fit tie points in X");
        break;
    case NO_FIT_Y:
        c_lasmsg(FALSE,"polyfit-nofit","Cannot fit tie points in Y");
        break;
    case NO_FRAME:
        c_lasmsg(FALSE,"polyfit-no_wind",
		"Cannot determine window from framing parameters");
        break;
    case QUIT_IN_MOD:
        c_lasmsg(TRUE,"polyfit-quit",
		"Program terminated by user; output files not created");
    }
c_lasmsg(TRUE,"polyfit-fatal","Fatal error encountered");
}

