/****************************************************************************
NAME:               print_term

PURPOSE:  Prints program output to user's terminal using c_pterm

ALGORITHM DESCRIPTION:
    Call c_pterm with message passed, do not query user
    Return
*****************************************************************************/
#include "polyfit.h"

void print_term
(
    char *mess,     /* Message to be printed to terminal */
    FILE *ptr       /* Pointer to output file -- not used here! */
)
{
long zero = 0;      /* Constant of zero */

c_pterm(mess, &zero);
return;
}



/****************************************************************************
NAME:               print_file

PURPOSE:  Prints program output to file

ALGORITHM DESCRIPTION:
    Use fprintf to print passed message to passed file pointer
    Return
*****************************************************************************/
void print_file
(
    char *mess,     /* Message to be printed to file */
    FILE *ptr       /* Pointer to output file */
)
{
fprintf(ptr, "%s\n",mess);
return;
}



/****************************************************************************
NAME:               print_both

PURPOSE:  Prints program output to user's terminal using c_pterm & to file

ALGORITHM DESCRIPTION:
    Call c_pterm with message passed, do not query user
    Use fprintf to print passed message to passed file pointer
    Return
*****************************************************************************/
void print_both
(
    char *mess,     /* Message to be printed to terminal and to file */
    FILE *ptr      /* Pointer to output file */
)
{
long zero = 0;      /* Constant of zero */

c_pterm(mess, &zero);
fprintf(ptr, "%s\n",mess);
return;
}

