/****************************************************************************
NAME:               swap_tpl

PURPOSE:  Swaps search & reference coordinates in Tie Point Location data
      records when the user specifies a forward transformation

ALGORITHM DESCRIPTION:
    Loop for each tie point record
       Place the reference coordinates in a temporary variables
       Place the search coordinates in the reference coordinate fields
       Place the contents of the temporary variables into the search
        coordinate fields
    Return
*****************************************************************************/
#include "polyfit.h"

void swap_tpl
(
    struct TPLDATA *tie_data,   /* Tie point records */
    long npts          /* Number of tie point records */
)
{
struct TPLDATA *tt; /* Temp pointer to tie point data records */
double tempx, tempy;    /* Temporary variable to hold x & y tie points */
long count;     /* Loop counters */

/* Loop on tie point pairs.  Swap the search and reference coordinates
-------------------------------------------------------------------*/
for(tt = tie_data, count = npts; count--; tt++)
    {
    tempy = tt->ref_coord[0];
    tempx = tt->ref_coord[1];
    tt->ref_coord[0] = tt->sea_coord[0];
    tt->ref_coord[1] = tt->sea_coord[1];
    tt->sea_coord[0] = tempy;
    tt->sea_coord[1] = tempx;
    }

}

