/***************************************************************************
NAME:			INTRINSIC

PURPOSE: 	To determines if a word is a TCL command.

***************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "protos.h"

#define         MAX_TCL_LENGTH  10      /* longest TCL cmnd is 1 less */
#define         TCL_CARD        49      /* cardinality of set of TCL cmnds */
#define         line_sz         101     /* size of line storage */
#define         word_sz         41      /* size of word storage */

        extern  char    tcl_cmnds_ndx[];
	extern  struct  {
			char    command[10];
			char    size;
			char    comment_out;
			}       tcl_cmnds[];
/*
   Function INTRINSIC determines if a word is a TCL command.
*/
int intrinsic
(
    char *word
)
{
	   char    cmnd[word_sz];  	/* command minus subcommand */
	   long    index;      /* index into table of commands */
	   long    same = 0;       /* result of comparing target command
					      with candidate command */
	   short  dash;        /* index of '-' in word */

	   /* Some TCL commands have subcommands so check only "main" cmnd */
	      strncpy(cmnd,word, dash=strcspn(word,"-") );
	   if ( dash < MAX_TCL_LENGTH )
	       {
	       /* Search through table of TCL commands until the size changes,
	          the string is found, or the table is exhausted (only happens
	          on longest command. */
               for( index=tcl_cmnds_ndx[dash];
		    (index<TCL_CARD)
		    && (dash=tcl_cmnds[index].size)
		    && (0!=(same=strncmp(cmnd,tcl_cmnds[index].command,dash)));
		    index++ )
		   ;
	       if ( 0 != same ) { index = TCL_CARD; }      /* not same--not TCL */
	       }
	   else                            /* word too long--not TCL */
	       { index = TCL_CARD; }
	   return index;
}

