#include "randsamp.h"

int findsamp
(
    long inrow, 		/* input image row			*/
    long nsamp, 		/* no. sample blocks			*/
    long sprowin, 	/* no. sample blocks in input row	*/
    long strsamp,	/* start sample block no.		*/
    long *cntsamp	/* no. samples in the row		*/
)

/*
***************************************************************************

NAME: FINDSAMP

PURPOSE: Finds the start sample and count for the random samples
         ocurring in the specified sample row in the input image.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS


***************************************************************************
*/
{
long	i, 			/* loop counter and array index */
	lo_limit, 		/* lower limit finding samples */
	hi_limit;		/* higher limit for finding samples */

*cntsamp = 0;

/*
Determine lower and upper limits for sample indices in this row.
-----------------------------------------------------------------
*/
lo_limit = inrow * sprowin + 1;
hi_limit = lo_limit + sprowin;

/*
Determine start sample and count for the samples in this row.
--------------------------------------------------------------
*/
for (i = strsamp; i < nsamp; i++)
   {
   if (samples[i] > hi_limit) 
      break;
   (*cntsamp)++;
   }  
return (E_SUCC);
}
