#ifndef PROTOS_H
#define PROTOS_H

int bumpout
(
    float **buffer,	/* work buffer */
    long *band, 		/* band number */
    long rowsin, 	/* number of rows in input image */
    long sprowout, 	/* number of samples in output row */
    long *rowsamp,       /* number of blocks copied */
    long sampsize[],     /* sample block size */
    long inrow, 		/* input image row */
    long *lastsamp, 	/* number of fill blocks in last row */
    long *outline, 	/* output image line number */
    char hnameout[][CMLEN]/*output image name*/
);

int copysamp
(
    long *band,		/* band number				*/
    long *nbands, 	/* no. bands in input image		*/
    long nsamp, 		/* no. sample blocks			*/
    long wind[][4],	/* input image windows			*/
    long sampsize[], 	/* sample block size			*/
    long nsout, 		/* no. samples/line in output image	*/
    long *nlout, 	/* no. lines in output image		*/
    char hos_out[][CMLEN]/* output image name                    */
);

int filspec
(
    char hosin[][CMLEN],		/* input image host names */
    char hosout[][CMLEN],		/* output image host name */
    long *num_inimages,		/* number of input images */
    long num_image_bands[],	/* number of bands in each input image */
    long *num_inbands,		/* number of input image bands */
    long image_band_num[][MAXBND + 1], /* band numbers in each input image */
    long wind[][4],		/* input image windows */
    long nsamp,			/* no. sample blocks */
    long *nlout,			/* no. lines in output image */
    long *nsout,			/* no. samples/line in output image */
    long sampsize[],		/* sample block size */
    long band
);

int findsamp
(
    long inrow, 		/* input image row			*/
    long nsamp, 		/* no. sample blocks			*/
    long sprowin, 	/* no. sample blocks in input row	*/
    long strsamp,	/* start sample block no.		*/
    long *cntsamp	/* no. samples in the row		*/
);

float **fmatrix
(
    long nr,
   long nc
);

int free_fmatrix
(
    float **m,
    long nr 	/* no. rows			*/
);

int gensamp
(
    long *nsamp, 	/* no. sample blocks			*/
    long total,		/* total no. sample blocks in image	*/
    long *dseed		/* seed for random no. generator	*/
);

int getpar
(
    char las_in[][CMLEN],     	/* input image las name             	*/
    char hos_in[][CMLEN],     	/* input image host names           	*/
    char las_out[][CMLEN],     	/* output image las name            	*/
    char hos_out[][CMLEN],    	/* output image host name           	*/
    long *num_inimages,       	/* number of input images           	*/
    long *num_inbands,        	/* total number of input image bands	*/
    long num_image_bands[],   	/* number of bands in each input image	*/
    long image_band_num[][MAXBND + 1], /* band numbers in each input image */
    long wind[][4],           	/* input image windows              	*/
    long sampsize[], 	     	/* sample block size	         	*/
    long *percent,               /* sampling percentage                  */
    char duplicate[]	     	/* duplicate samples flag           	*/
);

int sampio
(
    float **buffer,	/* work buffer */
    long band, 		/* band number */
    long strsamp,	/* start sample block */
    long cntsamp, 	/* number sample blocks in the row */
    long inrow, 		/* input row number */
    long sprowin, 	/* number sample blocks in input row */
    long sampsize[2],	/* sample block size */
    long rowsamp, 	/* number of blocks in work buffer */
    long sline		/* work buffer line number */
);

int selsamp
(
    long wind[][4],	/* image windows		*/
    long sampsize[2], 	/* sample block size		*/
    long percent,        /* sampling percentage          */
    char duplicate[],	/* duplication flag		*/
    long *nsamp, 	/* No. sample blocks		*/
    char hos_out[][CMLEN]	/* output image host name	*/
);

#endif

