#include "randsamp.h"

int sampio
(
    float **buffer,	/* work buffer */
    long band, 		/* band number */
    long strsamp,	/* start sample block */
    long cntsamp, 	/* number sample blocks in the row */
    long inrow, 		/* input row number */
    long sprowin, 	/* number sample blocks in input row */
    long sampsize[2],	/* sample block size */
    long rowsamp, 	/* number of blocks in work buffer */
    long sline		/* work buffer line number */
)
/*
***************************************************************************

NAME: SAMPIO

PURPOSE:    Moves samples from the input image lines to the work buffer.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS


***************************************************************************
*/
{

long	from_index, 		/* starting pixel of the sample to be */
				/* transferred */
	i, 			/* loop counter and array index */
	index1,			/* sample number relative to the start of */
				/* the input line */
	index2, 		/* sample number relative to the start of */
    				/* the output line */
	samp, 			/* current sample being processed */
	to_index; 		/* destination pixel of sample to be */
				/* transferred */

/*
For all sample blocks, compute sample number relative to start of the 
input line and the start pixel for the input sample.
-----------------------------------------------------------------------
*/
for (samp = 0; samp < cntsamp; samp++)
   {
   index1 = samples[strsamp + samp] - inrow * sprowin - 1;
   if (index1 < 0) 
      break;
   from_index = index1 * sampsize[1];

/*
Compute sample number relative to start of the output line and the
destination pixel for the ouptut sample.
--------------------------------------------------------------------
*/
   index2 = rowsamp + samp;
   to_index = index2 * sampsize[1];

/*
Copy input image line to work buffer.
---------------------------------------
*/
   for (i = 0; i < sampsize[1]; i++)
      buffer[sline][to_index+i] = inbuf[ipoint[band-1]+from_index+i];
   } 
return(E_SUCC);
}
