
/*******************************************************************************
NAME:     name_image 
PURPOSE:  return a unique name for the intermediate image 
*******************************************************************************/

#include <unistd.h>   /* for call to access() */
#include <string.h>
#include "randsel.h"  /* application header file */ 
#include "protos.h"
#define MAXTRIES 100  /* max n of tries to get a unique file name */ 




void name_image 
(
   char hostname[CMLEN],  /* output:  hostname for the image */ 
   char taename[CMLEN]    /* output:  taename  for the image */ 
)
{

/* declare variables */ 
   long effort,  /* for loop index, effort at getting a unique file name */
	ufound;  /* flag, was a unique name found */ 

/* loop for multiple efforts at finding a unique name */ 
   for (ufound=FALSE, effort=0;  !ufound && effort<MAXTRIES;  effort++)
      {
      /* get a name */ 
	 sprintf (hostname, "randsel_intermediate_%d.img", effort); 

      /* set flag, is this name unique */ 
	 if (access (hostname, 0))   
	    ufound = TRUE; 
      }

/* error check:  no unique name found.  error is too unlikely for fatal error
   section of randsel.pdf */
   if (!ufound)
      errclean ("randsel-fatal", 
	       "A unique name for the intermediate image was not found.  %s", 
	       "Delete images named RANDSEL.INTERMEDIATE.*"); 

/* get tae name */
   strcpy(taename, hostname);
}


