
/* randsel.h:  application header file */ 
#include "las.h"     /* las include file */ 
#include "image.h"   /* for image IO data structures, function prototypes */ 
#define MASKCOUNT 5  /* max count of parm maskval */ 
#define SELPIX    1  /* pixel was selected, value must fit in the byte range
                        and be a logical TRUE value */ 
#define REJPIX    0  /* pixel was rejected, value must fit in the byte range 
                        and be a logical FALSE value */ 






/* data structure for most user parms.  other parms are in image data
   structures */ 
   struct UPARMS 
      {
      float fillval,     /* fill value for last line of output image */ 
            minmask[MASKCOUNT],  /* min part of range for input mask values */ 
            maxmask[MASKCOUNT],  /* max part of range for input mask values */  
	    samperc;     /* sampling percentage, keep this % of input data */  
      long  maskband,    /* input band to check for masked pixels */ 
	    maskcount,   /* count of minmask[] and maxmask[] */ 
	    seedcount,   /* flag, did user specify a value for seedval */ 
	    seedval;     /* value to seed random number generation */ 
      }; 


