
/******************************************************************************
NAME:     seed_rgen
PURP0SE:  seed random number generation with user value or system date
******************************************************************************/


#include <sys/types.h> /* for call to time() */ 
#include <time.h>      /* for call to time() */
#include "randsel.h"   /* application header file */
#include "protos.h"
#define MAXSEED 65535  /* max seed for random number generation */ 




void seed_rgen 
(
   struct UPARMS *uparms   /* input:  user tae parms.  needed for seedcount and
                              seedval */
)
{

/* declare variable */ 
   time_t green_time;      /* Greenwich system time */

/* seed random number generation */ 
   if (uparms->seedcount)  /* use user value for seed */ 
#ifndef sun
      srandom (uparms->seedval);
#else
      srand (uparms->seedval);
#endif
   else /* use a seed based on system date */ 
      {
      if (time (&green_time) == -1)
	 errclean ("randsel-time", "Error getting system time"); 
      /* % MAXSEED limits srandom() input to a max value of MAXSEED */
#ifndef sun
      srandom (green_time % MAXSEED);  
#else
      srand (green_time % MAXSEED);  
#endif
      }
}
