
/* testrand.c by David Zokaites July 1995 to test uniformity of random number
   generation for LAS>RANDSEL, collect data for a user note in randsel.pdf */


#include <math.h>    /* for call to sqrt(), pow() */ 
#include <stdio.h>   /* for file io */ 
#include <stdlib.h>  /* for call to rand() */
#define  NVALUES 4   /* number of values to loop through, array size */ 






void main ()
{
/* declare variables */
   double randmax;         /* max number output from random() */
   float actper,           /* actual selection percentage achieved */ 
         percent[NVALUES], /* selection percentages to test */ 
	 rscalar;          /* scalar for rand(), converts rand() output to % */
   long selected,          /* number of values selected */ 
        tomake[NVALUES],   /* n random numbers to make */ 
	tomake_index,      /* loops through tomake[] */ 
	per_index,         /* loops through percent[] */ 
	rgen;              /* loop index, # random numbers generated */ 
/* initialize variables */ 
   /* selection percentages */ 
      percent[0] = .1;
      percent[1] =  5;  
      percent[2] = 50;  
      percent[3] = 95;  
   /* n random numbers to make */ 
      tomake[0] = 10    * 10   ;  
      tomake[1] = 100   * 100  ;  
      tomake[2] = 1000  * 1000 ;  
      tomake[3] = 10000 * 10000; 
   /* convert random() output to % */ 
      randmax = pow (2., 31.)  -1; 
      rscalar = 100. / randmax;  
/* print randmax */ 
   printf ("randmax is %f \n\n", randmax); 
/* label output table */ 
   printf ("        a test of random number generation          \n");
   printf ("--------------------------------------------------- \n");
   printf ("  desired       actual      delta    sqrt N numbers \n"); 
   printf ("selection %%   selection %%     %%      generated   \n"); 
   printf ("-----------   -----------   ------   -------------- \n");
/* calculate and print results */ 
   for (per_index=0;  per_index<NVALUES;  per_index++)
   {
      for (tomake_index=0;  tomake_index<NVALUES;  tomake_index++)
      {
      /* determine number of values that would be selected */ 
	 selected = 0;  /* initialize count of selected numbers */ 
	 for (rgen=0;  rgen<tomake[tomake_index];  rgen++)
	    if (random() * rscalar < percent[per_index] )
	       selected++;
      /* print results */ 
	 actper = selected * 100. / tomake[tomake_index];
	 printf (" %8.4f  %12.4f  %9.4f %12.0f \n", 
	 percent[per_index], actper, 
	 fabs ( (double) percent[per_index] - actper), 
	 sqrt ( (double) tomake[tomake_index] )) ; 
      }
      printf ("\n");  /* blank line between groups of desired selection % */ 
   }
} 



