#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    char lasin[MAXIMG][CMLEN],	/* O: Input image file LAS name               */
    char hosin[MAXIMG][CMLEN],	/* O: Input image file host name              */
    long bands[][MAXBND+1],	/* O: Band numbers                            */
    long *nimages,              /* O: no. of images                           */
    long nbands[],              /* O: no. of bands in each image              */
    char lasout[CMLEN],		/* O: Output image file LAS name              */
    char hosout[CMLEN],		/* O: Output image file host name             */
    long class[],		/* O: Classes to be weighed                   */
    float weight[],		/* O: Weight given to each class              */
    long nore[],		/* O: Classes not to be smoothed              */
    long *thresh,		/* O: Smoothing threshold value               */
    long wind[][4],		/* O: image window                            */
    long fcellsiz[],		/* O: filter cell size(LAS parameter 'WINDOW')*/
    long *msgtim,		/* O: Processing line message time interval   */
    char minmax[]		/* O: Minmax flag string                      */
);

void process_beginning
(
    long wind[][4],		/* I: Input image window specified            */
    long fcellsiz[],		/* I: Filter cell size specified              */
    long mnmxflag,		/* I: Minmax flag                             */
    double *minval,		/* I/O: Minimum value                         */
    double *maxval		/* I/O: Maximum value                         */
);

void process_bottom
(
    long wind[][4],		/* I: Input image window specified            */
    long fcellsiz[],		/* I: Filter cell size specified              */
    long mnmxflag,		/* I: Minmax flag                             */
    double *minval,		/* I/O: Minimum value                         */
    double *maxval		/* I/O: Maximum value                         */
);

void process_middle
(
    long wind[][4],		/* I: Input image window specified            */
    long fcellsiz[],		/* I: Filter cell size specified              */
    long class[],		/* I: Classes to be weighed                   */
    float weight[],		/* I: Weight given to each class              */
    long nore[],		/* I: Classes not to be smoothed              */
    long thresh,		/* I: Smoothing threshold value               */
    long mnmxflag,		/* I: Minmax flag                             */
    double *minval,		/* I/O: Minimum value                         */
    double *maxval		/* I/O: Maximum value                         */
);

void setup_files
(
    char hosin[][CMLEN],        /* I: Input image file host name              */
    char hosout[CMLEN],         /* I: Output image file host name             */
    long wind[][4],		/* I: Input image window specified            */
    long fcellsiz[],		/* I: Filter cell size specified              */
    long bands[][MAXBND+1]	/* I: Band number specified                   */
);

void iso_err
(
    char *message,	        /* I: error message and severity          */
    char *key			/* I: message key                         */
);

#endif

