#include "reclass.h"
#include "util.h"
#include "protos.h"

/*****************************************************************************
 *
 * NAME		iso_err
 *
 * PURPOSE	To display an error message and exit RECLASS if it is fatal.
 *		The first character of the error message determines whether
 *		or not the error is fatal.
 *
 * PROGRAM HISTORY
 *
 *	Programmer		Date		Reason
 *	----------		----		------
 *	Eric Ivancich / SAR	13-Aug-87	C conversion
 *      Bani Allam              8-Aug-88        Retrocode
 *
 * PARAMETERS
 *
 *	Name		Type		I/O	Description
 *	----		----		---	-----------
 *	*message	char		I	Error message and severity
 *      *key            char            I       Message key
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *	None
 *
 * RETURN VALUES
 *
 *	None
 *
 *****************************************************************************/
void iso_err
(
    char *message,	        /* I: error message and severity          */
    char *key			/* I: message key                         */
)
{
	switch (*message++)  {
		case '?' :
		     	c_errmsg (message, key, &one);
		     	break;
		case '!' : {
   	 		c_errmsg (message, key, &one);
                        c_clean (&vblock, "reclass", out, &numfiles);
                        }
 	}
}
