/*******************************************************************************
NAME:		PARSE_LN	

PURPOSE:    	PARSE_LN parses an image line into runs of contiguous pixels 
			 
PROGRAM HISTORY:
Version	Programmer	Date	Reason
-------	----------      ----	------
5.0	D.VanderZee	9/90	Re-retrocode (All new C version!)
				
PROJECT:	LAS
		
ALGORITHM DESCRIPTION: 	See inline documentation
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "reglabel.h"

void parse_ln
(
  long *inlin,                /* I: Line of image data */
  long ns,                    /* I: Number of pixels in line */
  long *nr,                   /* O: Number of runs in line */
  long runs[]                 /* O: Indexes to beginning of each run */
)
{
long	i;			/* loop counter */


/* Beginning of line always begins a new run
--------------------------------------------*/
runs[0] = 0;
*nr = 1;   

for (i = 1; i < ns; i++)
/* For all pixels in line
-------------------------*/
   {
   if (inlin[runs[*nr-1]] != inlin[i])
      /* New run encountered
      ----------------------*/
      {
      runs[*nr] = i; 
      (*nr)++;
      }
   }
/* End of line ends last run 
----------------------------*/
runs[*nr] = ns;

}
