#ifndef REGLABEL_H
#define REGLABEL_H

/* Contains the function prototypes for REGLABEL.  Make sure
   las.h is included BEFORE this file
------------------------------------------------------------*/

/* getpar.c */
void getpar
(
  struct PARBLK *vblock,        /* I: Pointer to TAE parameter block */
  char hosin[][CMLEN],          /* O: Host file names of input images */ 
  char *taeout,                 /* O: TAE file name of output image */
  char *hosout,                 /* O: Host file name of output image */
  char *regionlt,               /* O: Region description labeled table */
  long *nmrimg,                 /* O: Number of input images */
  long window[][4],             /* O: Window specs for each input image */
  long bands[][MAXBND+1],       /* O: Band specs for each input image */
  long *nbands,                 /* O: Number of bands per input image */
  long *totbnd,                 /* O: Total number of bands to be processed */
  long *eightway,               /* O: Check eight-way connectedness flag */
  long *msgtim,                 /* O: Elapsed time between display messages */
  char *minmax                  /* O: Min/Max flag buffer */
);

/* label.c */
int label
(
  unsigned char	*iobuf,       /* I: I/O buffer for image data */
  long nl,                    /* I: Number of lines to process */
  long ns,                    /* I: Number of samples to process */
  long eightway,              /* I: Eight way connectedness flag */
  long *regcls[],             /* O: Class identifier for each region */
  long *regcnt[],             /* O: Count of pixels in each region */
  long *reglnk[],             /* O: Subregion linkage to contiguous region */
  long *gross_nreg,           /* O: Gross number of regions--before linking */
  long *net_nreg              /* O: Net number of regions after linking */
);

/* link.c */
int link_region
(
  char *regionlt,             /* I: Name of region description lt file */
  char hosin[][CMLEN],        /* I: Name of input image file */
  unsigned char	*iobuf,       /* I/O: Buffer for image data */
  long nl,                    /* I: Number of lines to process */
  long ns,                    /* I: Number of samples to process */
  long *regcls[],             /* I: Class identifier for each region */
  long *regcnt[],             /* I/O: Count of pixels in each region */
  long *reglnk[],             /* I/O: Subregion linkage to contiguous region */
  long *gross_nreg            /* I: Gross number of regions--before linking */
);

/* parse_ln.c */
void parse_ln
(
  long *inlin,                /* I: Line of image data */
  long ns,                    /* I: Number of pixels in line */
  long *nr,                   /* O: Number of runs in line */
  long runs[]                 /* O: Indexes to beginning of each run */
);

/* reglabel.c */
void main
(
  void
);

#endif
