#ifndef PROTOS_H
#define PROTOS_H

int getpar
(
    char in[],			/* The input Tie Point Location file name */
    char out[],			/* The output Tie Point Location file name */
    char host_name[],		/* Name for PRINT parameter 		*/
    long *msgtim,			/* Message timer 			*/
    long *nsamps,			/* Number of samples in scene		*/
    long *nlines,			/* Number of lines in scene		*/
    long *scenewidth,		/* Number of valid image samples	*/
    double *pixsize,		/* Pixel size				*/
    double *datum,			/* datum elevation above sea level	*/
    FILE **fptr,			/* Pointer to output file (report file) */
    char inlt[],			/* Input labeled table file		*/
    long *option			/* Subcommand option			*/
);

int nadirline
(
    char *inlt,		/* name of the image */
    double *slope,			/* slope of nadir */
    double *y_inter			/* y-intercept of nadir */
);

void nadirpix
(
    double sclat,	/* center latitude			*/
    long linenum, 	/* current line number			*/
    long *nadpix,	/* The center pixel (return)		*/
    long *ns,		/* Number of samples in scene		*/
    long *nl,		/* Number of lines in scene		*/
    long *scwidth,	/* Number of valid samples in scene 	*/
    double *pix	/* pixel size				*/
);

double terrain_adjust
(
    double oldsample,	/* Current sample value			*/
    long nadpix,		/* Center pixel				*/
    long elevation,		/* Elevation at current pixel		*/
    double *datum,		/* Reference elevation			*/
    double *pix		/* pixel size				*/
);

#endif
