#ifndef REMAP_H
#define REMAP_H

#include <stdio.h>
#include "las.h"
#include "proj.h"
#include "geompak.h"

#define INPUT_XY	104
#define OUTPUT_XY	105
#define OUTPUT_LS	106
#define INPUT		107
#define MINBOX		108
#define NO_REMAP	-99

/* Misc macros
  -----------*/
#define DMOD(A,B)	(A) - ((long)((A) / (B)) * (B))

/* Structure containing framing parameters & related gridding information.
   These are all user-entered parameters
  -------------------------------------*/
struct FRAME 
   {
   double tol;		/* Tolerance for linear approximation--grid reduce */
   double corners[8];	/* Resulting grid projection corners */
   double o_dist[2];	/* Projection distance in y & x; input space */
   int  window[4];	/* Window parameters for output space */
   int  ngline;		/* Number of geometric mapping grid lines (rows) */
   int  ngsamp;		/* Number of geometric mapping grid samples (cols) */
   int  convert;	/* Boolean--use Projection Xform Package to convert? */
   char name[CMLEN];	/* Name of the Geometric Mapping Grid file */
   FILE *fptr;		/* File pointer to print file */
   };

/* Structure holding projection parameters
  ---------------------------------------*/
struct PROJ
   {
   long proj_code;		/* Projection code number */
   long units;			/* Projection units code number */
   long zone_code;		/* Projection zone code (UTM or State Plane) */
   long datum_code;		/* Projection datum code */
   double proj_coef[15];	/* 15 projection "coefficients" */
   };

#endif
