#include "renumber.h"

/******************************************************************************

NAME:	apply_lut

FUNCTION:
	Applies the lookup table to an image

******************************************************************************/

FUNCTION apply_lut (dtype, totbnd, window, mnmxflag, minval, maxval, update)

long	dtype,			/* Output image type                          */
	mnmxflag,		/* Flag indicating whether to do min/max      */
	totbnd,			/* Total number of input bands                */
	(*window)[4],		/* Input image window                         */
	*update;		/* Update flag				      */
double	maxval[],		/* Array of maximum values                    */
	minval[];		/* Array of minimum values                    */
{
long	band,			/* Counter on bands                           */
	fatal = -1,		/* fatal error flag			      */
	line,			/* Counter on lines                           */
	luttype = EWORD,	/* lookup table type   			      */	
	pix;			/* Counter on pixels                          */

short    *temp;
short	index;			/* The signed lookup table index              */

/*
   Ok, lets go thru the image
   --------------------------
*/
if (c_estep (&gdesc) != E_SUCC)
  {
   if (gdesc) c_egclse(&gdesc);
   c_errmsg("Fatal error encountered", "renumber-fatal",&fatal);
  }

curent = 1;
if (*update == FALSE)
  {
  for (line = 0; line < window[0][NL]; line++)
     {
     for (band = 0; band < totbnd; band++)
        {
        c_pxlkup (&thebuf[inoff[band]], &thebuf[outoff[band]], &window[0][NS],
                &luttype, lookup, &luttype);
  
        if (mnmxflag)
           c_pxmnmx (&thebuf[outoff[band]], &window[0][NS], minval, maxval, 
		     &dtype);
        }
     if (c_estep (&gdesc) != E_SUCC)
       {
        if (gdesc) c_egclse(&gdesc);
        c_errmsg("Fatal error encountered", "renumber-fatal",&fatal);
       }
     curent = line + 1;
     }
  }
else
  {
  temp = (short *) calloc(window[0][NS],sizeof(short));
  for (line = 0; line < window[0][NL]; line++)
     {
     for (band = 0; band < totbnd; band++)
        {
        c_pxlkup (&thebuf1[inoff[band] * dtype], temp, 
		  &window[0][NS], &dtype, lookup, &luttype);

        c_pxconv(&luttype,&dtype,temp,&thebuf1[inoff[band] * dtype],
		 &window[0][NS]);
  
        if (mnmxflag)
           c_pxmnmx (&thebuf[inoff[band] * dtype], &window[0][NS], minval, 
		     maxval, &dtype);
        }
     if (c_estep (&gdesc) != E_SUCC)
       {
        if (gdesc) c_egclse(&gdesc);
        c_errmsg("Fatal error encountered", "renumber-fatal",&fatal);
       }
     curent = line + 1;
     }
  free(temp);
  }
return;
}
