#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,      /* pointer to TAE block	 	      */
    char taein[][CMLEN],	/* TAE file names of input images	      */
    char hosin[][CMLEN],  	/* host file names of input images	      */
    char taeout[][CMLEN],		/* TAE file name of output image	      */
    char hosout[][CMLEN],		/* host file name of output image	      */
    long *nmrimg, 		 /* number of input images		      */
    long (*bands)[MAXBND+1],         /* band specification 		              */
    long *nbands,		 /* number of bands per input image           */
    long (*window)[4],	         /* window specification		      */
    long *msgtim,		 /* elapsed time between display messages     */
    char *minmax,		 /* min max flag buffer		              */
    long *xfact,		 /* factor to enlarge or reduce the x-axis    */
    long *yfact,		 /* factor to enlarge or reduce the y-axis    */
    long *odtype,		 /* data type of input image		      */
    long *totbnd		 /* total number of bands		      */
);

void proces
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosout[][CMLEN],		/* host name of output image		     */
    double minval[MAXBND],	/* min pixel value array		     */
    double maxval[MAXBND],	/* max pixel value array		     */
    long totbnd,			/* total number of bands to be processed     */
    long odtype,			/* data type of output image                 */
    long xfact,			/* reduction factor for the x-axis	     */
    long yfact,			/* reduction factor for the y-axis	     */
    char *minmax,		/* min max flag                              */
    unsigned char *thebuf1,	/* image input buffer                        */
    unsigned char *thebuf2,	/* image output buffer			     */
    long size,			/* number of bytes per pixel 	 	     */
    long nl,			/* number of image lines                     */
    long ns			/* number of image samples                   */
);

void setup_etc
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin[][CMLEN],		/* host names of input images		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*window)[4],		/* window specification of input images      */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long *totbnd,		/* total number of bands to be processed     */
    long odtype,			/* data type of output image                 */
    long xfact,			/* reduction factor for the x-axis	     */
    long yfact,			/* reduction factor for the y-axis	     */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax		/* min max flag                              */
);


#endif

