#ifndef LOCAL_PROTOS_H
#define LOCAL_PROTOS_H

void explicit
(
    double angle,           /* Counter-clockwise rotation angle */
    double scale[4],        /* Pre- & Post- scale factors */
    double pivot[4],        /* Pivot point */
    double coef[6]          /* Mapping coefficients */
);

int make_grid
(
    long nlines,            /* Number of lines in the output grid (image) */
    long nsamps,            /* Number of samples in the output grid (image) */
    double coef[6],         /* Transformation coefficients */
    char *name,             /* Grid file name */
    char *in_image,         /* Input image file name */
    long num_img,           /* Number of images input:  0 or 1 */
    long in_wind[4]         /* Image window specification */
);

void twopoint
(
    double intie1[2],       /* First input location, line/sample */
    double intie2[2],       /* Second input location, line/sample */
    double outtie1[2],      /* First output location, line/sample */
    double outtie2[2],      /* Second output location, line/sample */
    double coef[6]          /* Transformation coefficients */
);

#endif
