#include "scatter.h"
#include "protos.h"

void iprint
(
    char lasin[MAXIMG][CMLEN],	/* Las input file names */
    long nimages,		/* Number of input images */
    long window[][4],		/* Processing window specification */
    long hist[][114], 		/* Histogram bin populations */
    char chars[],		/* Plotting characters */
    float rmin[2],		/* Minimum pixel values for plotting */
    float rmax[2],		/* Maximum pixel values for plotting */
    long kmin, 			/* Minimum pixel count */
    long kmax,			/* Maximum pixel count */
    long nbrplt,			/* Number of plotting characters */
    char option[5],		/* Scaling option */
    long chrfil,			/* Character file option flag */
    long mins[94] 		/* Range begin */
)
{
/*
**********************************************************************
NAME: IPRINT

FUNCTION: Performs printing of the scatter program results. 

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
     1           Sept-83   R. J. Tighe
     2           Sep-87    D. Etrheim/edc   Prf #4228
     3           Apr-90    B. Allam	    Conversion to 5.0
     4        16-Nov-90    K. Kunska        Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM:

   For the two plot pages,
      Set up start and stop row and column indices for a single page.
      Call PAGEOUT to print one page.
   End-for
   Close the output unit

*************************************************************************
*/
float	smax[2], 		/* Maximum pixel values for one page */
	smin[2], 		/* Minimum pixel values for one page */
	ydlt, 			/* Y-axis increment */
	xdlt;			/* X-axis increment */
	
long	page, 			/* Loop page counter */
	row_start, 		/* Starting row */
	row_end;		/* Ending row */

row_start = 114;
row_end = 58;

/*
For the two plot pages,
Set up start and stop row and column indices for a single page.
----------------------------------------------------------------
*/
for (page = 1; page <= 2; page++)
   {
   ydlt = (rmax[0] - rmin[0]) / 113.0;
   xdlt = (rmax[1] - rmin[1]) / 113.0;
   smax[0] = rmax[0] - ((float) page - 1) * ydlt * 57.0;
   smin[0] = smax[0] - ydlt * 56.0;
   smin[1] = rmin[1];
   smax[1] = rmax[1];
   
/*
Call PAGEOUT to print one page.
--------------------------------
*/
   pageout (lasin, nimages, window, hist, row_start, row_end, chars, smin, 
            smax, xdlt, page, kmin, kmax, nbrplt, option, chrfil, mins);
   row_start = 57;
   row_end = 1;
   }  

/*
Close the output unit
----------------------
*/
if ((print[LP]) || (print[FIL]))
   {
   fclose(fp);
   }
}
