#ifndef PROTOS_H
#define PROTOS_H

void accum
(
    long wind[][4],		/* Processing window specification */
    long harray[114][114], 	/* Histogram bin populations */
    float rmin[2],		/* Minimum pixel values */
    float rmax[2],		/* Maximum pixel values */
    long *kmin, 			/* Minimum pixel count */
    long *kmax,			/* Maximum pixel count */
    long msgtim, 		/* Message time interval */
    long dr_count[2]		/* Data range min-max count */
);

void getparm
(
    char lasin[][CMLEN],		/* Las input file names */
    char hostin[][CMLEN],	/* Host input file names */
    long window[MAXIMG][4],	/* Processing window */
    char chars[],		/* Plotting characters */
    float smin[2],		/* Minimum pixel values for plotting */
    float smax[2], 		/* Maximum pixel values for plotting */
    char infile[],		/* Input file with plotter characters */
    long *nbrplt, 		/* Number of plotting characters (or bins)*/
    long *msgtim,		/* Message time interval */
    char option[5],		/* Scaling option */
    long *chrfil,		/* Infile option */
    long mins[],		/* Range begin and end */
    long maxs[],
    long dr_count[2], 		/* Data min-max range count */
    long *nimages 		/* Number of images */
);

void iprint
(
    char lasin[MAXIMG][CMLEN],	/* Las input file names */
    long nimages,		/* Number of input images */
    long window[][4],		/* Processing window specification */
    long hist[][114], 		/* Histogram bin populations */
    char chars[],		/* Plotting characters */
    float rmin[2],		/* Minimum pixel values for plotting */
    float rmax[2],		/* Maximum pixel values for plotting */
    long kmin, 			/* Minimum pixel count */
    long kmax,			/* Maximum pixel count */
    long nbrplt,			/* Number of plotting characters */
    char option[5],		/* Scaling option */
    long chrfil,			/* Character file option flag */
    long mins[94] 		/* Range begin */
);

void pageout
(
    char lasin[][CMLEN],		/* Las input file name */
    long nimages,		/* Number of input images */
    long wind[][4],		/* Processing window specification */
    long hist[][114], 		/* Histogram bin populations */
    long row_start, 		/* Start index for rows */
    long row_end, 		/* Stop index for rows */
    char chars[],		/* Plotting characters */
    float rmin[2], 		/* Minimum pixel values for one plot page */
    float rmax[2], 		/* Maximum pixel values for one plot page */
    double xdlt,			/* X-axis increment */
    long page,			/* Counter for suppressed pages */
    long kmin, 			/* Minimum pixel count */
    long kmax,			/* Maximum pixel count */
    long nbrplt,			/* Number of plotting characters */
    char option[5],		/* Scaling option */
    long chrfil, 		/* Character file option flag */
    long mins[94]  		/* Range begin */
);

void rdfil
(
    char *fname,			/* Input file with plotter characters */
    char chars[],		/* Plotting characters */
    long *rbegin,		/* Range begin values */
    long *rend,			/* Range end values */
    long *npts			/* Number of plotting characters */
);

void setup
(
    char hostin[][CMLEN],	/* Input image host names */
    long wind[][4],		/* Input image window specification */
    long nimages		/* Number of input images */
);

void msg_err
(
    char *message,
    char *key
);

#endif
