#include "scatter.h"
#include "protos.h"

void setup
(
    char hostin[][CMLEN],	/* Input image host names */
    long wind[][4],		/* Input image window specification */
    long nimages		/* Number of input images */
)

/*
**********************************************************************
NAME: SETUP

FUNCTION:   Opens input images

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
     1          Sept-83   R. J. Tighe
     2          Sep-87    D. Etrheim/edc   Prf #4228
     3          Apr-89    B. Allam         Conversion to 5.0
     4       16-Nov-90    K. Kunska        Added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM:

   Open the input images.
   Set up group containing input bands.

***********************************************************************
*/
{
long    zero = 0;

long	stat,                  /* flag for EOPENS procedure */
	access,                /* file specifications       */
	type,                  /* data type                 */
	n, nib,                /* counter variables         */
	bufsiz;                /* image i/o buffer size     */

/*
Open the input images.
-----------------------
*/
access = IREAD;
type = EREAL;
for (n = 0, nib = 0; n < nimages; n++)
   {
   stat = c_eopens(&fdesc[n], hostin[n], bands[n], &wind[n][SL],
                   &wind[n][SS], &wind[n][NL], &wind[n][NS], &ipoint[nib],
                   &access, &type, &zero, &zero);
   if (stat != E_SUCC)
      msg_err("!Error opening input image", "scatter-input");
   nib += nbands[n]; 
   }

/*
Set up group containing input bands.
-------------------------------------
*/
if ((iobuf = (float *) c_ealloc(fdesc, &bufsiz)) == NULL)
   msg_err("!Error allocating dynamic memory", "scatter-alloc");

if (c_egroup(fdesc, &gdesc, iobuf, &bufsiz) != E_SUCC)
   msg_err("!Error grouping image bands", "scatter-group");

}
