#include "scatter.h"
#include "util.h"
#include "protos.h"

void msg_err
(
    char *message,
    char *key
)

/*****************************************************************************
 *
 * NAME		msg_error
 *
 * PURPOSE	To display an error message and exit SCATTER if it is fatal.
 *		The first character of the error message determines whether
 *		or not the error is fatal.
 *
 * PROGRAM HISTORY
 *
 *	Programmer		Date		Reason
 *	----------		----		------
 *	Eric Ivancich / SAR	13-Aug-87	C conversion
 *      Bani Allam              31-Aug-88       Retrocode
 *
 * PARAMETERS
 *
 *	Name		Type		I/O	Description
 *	----		----		---	-----------
 *	*message	char		I	Error message and severity
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *	None
 *
 * RETURN VALUES
 *
 *	None
 *
 *****************************************************************************/
{
    long    one = 1;

	switch (*message++)  {
		case '?' :
		     	c_errmsg (message, key, &one);
		     	break;
		case '!' :
		default : {
   	 		c_errmsg (message, key, &one);
                        if (gdesc > 0) c_egclse(&gdesc);
			if (fp !=  NULL) fclose(fp);
                        c_clean (&block, "SCATTER", out, &count);
                        }
 	}
}


