#include "search.h"
#include "protos.h"

void calcdiv
(
    long minprt,			/* pointer to first class accepted            */
    long maxprt,			/* pointer to last class accepted             */
    float **classtat, 		/* class statistics                           */
    float dv[],			/* pair-wise divergences for all              */
    long nbands 		/* number of input image bands                */
)
				/* classes                                    */
/*
*****************************************************************************

NAME: CALCDIV

PURPOSE:  Calculates divergences between all classes.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         29-Aug-83   R. J. Tighe
   2.0         25-Mar-85   Y. Sheu
   3.0         07-Jul-89   K. Kunska		conversion to 5.0


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   For first class to last class,
      call DIVRG to calculate the divergences.
   End-for

*****************************************************************************
*/

{

long	i, i1,			/* loop counters and array indexes            */
	j,
	l;


/*
For first class to last class,
call DIVRG to calculate the divergences.
---------------------------------------------
*/
for (i = minprt; i <= maxprt; i++)
   {
   i1 = i - 1;
   l = i1 * (i1 - 1) / 2;
   for (j = 1; j <= i1; j++)
      {
      l = l + 1;     
      divrg (classtat[i], classtat[j], nbands, &dv[l]); 
      }
   }
}     

