#include "las.h"
#include "protos.h"
float ***fmat3d
(
    long nx, 	/* x dimension (ex: bands)	*/
    long ny,	/* y dimension (ex: lines)	*/
    long nz	/* z dimension (ex: pixels)     */
)
/*
******************************************************************************

NAME: FMAT3D

PURPOSE: Allocates storage for a three dimensional floating point matrix.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          16-Jun-89   K. Narayanan       
   2          30-Jun-89   K. Kunska	  modifications for 3 dimensions

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
{
long	i, j;
float ***m;

if ((m = (float ***) malloc (nx * sizeof (float **))) == NULL) 
   return (NULL);

for (i = 0; i < nx; i++)
   {
   if ((m[i] = (float **) malloc (ny * sizeof (float *))) == NULL) 
      return (NULL);
   for (j = 0; j < ny; j++)
      if ((m[i][j] = (float *) malloc (nz * sizeof (float))) == NULL) 
         return (NULL);
   }
return(m);
}
