#include "las.h"
#include "protos.h"
void freefmat3d
(
    float ***m,
    long nx, 	/* x dimension (ex: bands)	*/
    long ny 	/* y dimension (ex: lines)	*/
)

/*
******************************************************************************

NAME: FREEFMAT3D

PURPOSE: Frees storage allocated for a three dimensional floation point matrix.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          16-Jun-89   K. Narayanan       
   2          30-Jun-89   K. Kunska	   modifications for three dimensions

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
{
long	i, j;

for (i = 0; i < nx; i++)
   for (j = 0; j < ny; j++)
      free (m[i][j]);

for (i = 0; i < nx; i++) 
   free (m[i]);

free (m);
}
