#include "search.h"
#include "protos.h"
void header
(
    long num_inimg,		/* number of input images                     */
    long bands_per_img[],	/* number of bands in each input image        */
    char taein[][CMLEN], 	/* input image file tae name                  */
    char taeout[]		/* output statistics file tae name            */
)

/*
*****************************************************************************

NAME: 	HEADER

PURPOSE:  Outputs a header page for the statistical summary if the user
          has selected the statistical summary option.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         29-Aug-83   R. J. Tighe
   2.0         01-Oct-84   Y. Sheu
   3.0         07-Jul-89   K. Kunska		conversion to 5.0
   4.0	       09-Sep-89   K. Kunska		fixed file names in header

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Format one page header giving input parameter summary for this run.

*****************************************************************************
*/

{
long	band,			/* current band index                         */
	img;			/* input image index                          */
/*
Format one page header giving input parameter summary for this run.
--------------------------------------------------------------------
*/
fprintf (fd1,"      SEARCH FUNCTION INPUT PARAMETER SUMMARY:   \n\n");
fprintf (fd1,"         I. TAE FILE NAMES FOR INPUT MULTI-IMAGE:\n\n");
for (img = 0; img < num_inimg; img++)
   {
   for (band = 0; band < bands_per_img[img]; band++)
      fprintf (fd1, "               BAND %3d TAE NAME= %s\n", band+1, 
               taein[img]);
   }
fprintf (fd1,"\n\n");

if (block_dist  ==  -1) 
   block_dist = 2;
fprintf (fd1, "        II. SELMETH = %1d", block_dist);
fprintf (fd1, "   WINDOW SIZE AND SEPARABILITY MEASURE:\n");
fprintf (fd1,"                     DEFAULT = 0 = 6*6 USING DIVERGENCE\n");
fprintf (fd1,"                             = 1 = 3*3 USING SCALED DISTANCE\n");
fprintf (fd1,"                             = 2 = 6*6 USING SCALED DISTANCE");
fprintf (fd1,"\n\n\n");

fprintf (fd1, "       III. MERGETHR = %7.3f   ", mthresh);
fprintf (fd1, "MAXIMUM DESIRED SEPARABILITY FOR MERGER\n"); 
fprintf (fd1,"                     DEFAULT = 5.0 IF SELMETH = 0\n");
fprintf (fd1,"                             = 2.4 IF SELMETH = 1 OR 2\n\n\n");

fprintf (fd1, "        IV. STDEVLIM(1) = %7.3f   ", stdevlb);
fprintf (fd1, "STANDARD DEVIATION LOWER BOUND\n");
fprintf (fd1,"                     DEFAULT = 0.01\n\n");
fprintf (fd1, "               STDEVLIM(2) = %7.3f   ", stdevub);
fprintf (fd1, "STANDARD DEVIATION UPPER BOUND\n");
fprintf (fd1,"                     DEFAULT = 3.00\n\n");

fprintf (fd1, "         V. COEFVAR = %7.3f   ", coefvar);
fprintf (fd1, "COEFFICIENT OF VARIATION/100\n");
fprintf (fd1,"                     (I.E., ST. DEV./MEAN)\n");
fprintf (fd1,"                     DEFAULT = 0.055\n\n\n");

if (savestat) 
   {
   fprintf (fd1,"        VI. SAVESTAT = YES   OPTION TO SAVE STATISTICS FILE");
   fprintf (fd1,"\n                     DEFAULT = NO\n\n\n");
   fprintf (fd1,"       VII. TAE FILE NAME FOR OUTPUT STATISTICS FILE:\n");
   fprintf (fd1,"                     TAE NAME = %s", taeout);
   }
else
   {
   fprintf (fd1,"        VI. SAVESTAT = NO    OPTION TO SAVE STATISTICS FILE");
   fprintf (fd1,"\n                     DEFAULT = NO\n\n");
   }
}
