#include "search.h"
#include "protos.h"

void square
(
    float **a,			/* output sqare array                         */
    long nrows,			/* number of rows in the input square matrix  */
    float *b			/* input array containing matrix in symetric  */
)
/*
*****************************************************************************

NAME:  	SQUARE

PURPOSE:  Converts a matrix stored in a symetric storage mode into a 
          square array.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         29-Aug-83   R. J. Tighe
   2.0         07-Jul-89   K. Kunska		conversion to 5.0


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   For all rows, 
      Create a square matrix based on the symetrix matrix.
   End-for.

*****************************************************************************
*/

{

long	k, n,			/* loop counters and array indexes            */
	row;			/* row counter                                */

/*
For all rows, create a square matrix based on the symetrix matrix.
--------------------------------------------------------------------
*/
n = 1;                               
for (row = 1; row <= nrows; row ++)
   {
   for (k = 1; k <= row; k++)
      {
      a[row][k] = b[n];
      a[k][row] = b[n];          
      n++;
      }
   }
}   
