#include "search.h"
#include "pixman.h"
#include "protos.h"

void srchio
(
    long nbands, 		/* number of input image bands                */
    long npix 			/* number of pixels                           */
)
/*
*****************************************************************************

NAME: SRCHIO

PURPOSE:  Reads image lines from the disk and stores them in a intermediate
          work buffer used later by the CSCIO routine.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         29-Aug-83   R. J. Tighe
   2.0         01-Oct-84   Y. Sheu
   3.0         07-Jul-89   K. Kunska		conversion to 5.0


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   For each band, 
      Read 6 image lines from the disk and 
      Store the image data in an intermediate buffer work.
   End-for

*****************************************************************************
*/

{

long	band,			/* current band                               */
	dtype,			/* pixel data type                            */
	line;			/* current line being read                    */

/*
For each band, read 6 image lines from the disk and store the image data 
in am intermediate buffer work.
-------------------------------------------------------------------------
*/
dtype = EREAL;
for (line = 1; line <= 6; line++)
   {
   c_estep (&gdescin);
   for (band = 0; band < nbands; band++)
      c_pxcopy (&inbuf[ipoint[band]], &work[band+1][line][1], &dtype, &npix);
   curent++;
   }
}
