#ifndef PROTOS_H
#define PROTOS_H

void average
(
    struct PARBLK *vblock,	/* I: TAE parameter block		      */
    char hostname[][CMLEN],	/* I: host names of input images	      */
    char *minmax,		/* I: min/max flag                            */
    long bands[][MAXBND+1],	/* I: bands to be processed for all images    */
    long inwind[][NUM_SPECS],   /* I: input window areas to fix               */
    long msgtim,		/* I: elapsed time between display messages   */
    long *nbands,		/* I: number of bands per input image         */
    long nbrwind,		/* I: number of repair windows                */
    long nmrimg,		/* I: number of input images                  */
    long odtype,                /* I: data type of input image(s)             */
    long size,                  /* I: number of bytes required for this odtype*/
    long totbnd,		/* I: total number of bands to be processed   */
    long update,                /* I: flag to modify input images             */
    long window[][NUM_SPECS]	/* I: window specification of input images    */
);

int closefile
(
    long num_images             /* I: The number of images in fdesc to close  */
);

void constant
(
    struct PARBLK *vblock,	/* I: TAE parameter block                     */
    char hostname[][CMLEN],	/* I: host names of input images	      */
    char *minmax,		/* I: min/max flag                            */
    float pixval[],             /* I: pixel values to be used for const option*/
    long bands[][MAXBND+1],	/* I: bands to be processed for all images    */
    long inwind[][NUM_SPECS],   /* I: input window areas to fix               */
    long msgtim,		/* I: elapsed time between display messages   */
    long nbands[],		/* I: number of bands per input image         */
    long nbrwind,		/* I: number of repair windows                */
    long nmrimg,		/* I: number of input images                  */
    long odtype,                /* I: data type of images to be repaired      */
    long size,                  /* I: number of bytes required for this odtype*/
    long totbnd,		/* I: total number of bands to be processed   */
    long update,                /* I: flag to modify input images             */
    long window[][NUM_SPECS]	/* I: window specification of input images    */
);

void getpar
(
    struct PARBLK *vblock,     /* I: pointer to TAE block                    */
    char hostname[][CMLEN],    /* O: host file names of the images           */
    char *minmax,              /* O: min/max flag buffer                     */
    char *option,              /* O: replacement option                      */
    char taename[][CMLEN],     /* O: TAE file names of the images            */
    float pixval[],            /* O: pixel values for insertion              */
    long bands[][MAXBND+1],    /* O: bands being repaired for each image     */
    long inwind[][NUM_SPECS],  /* O: repair window specifications            */
    long *msgtim,              /* O: elapsed time between display messages   */
    long *nbrimg,              /* O: number of input images                  */
    long *nbrwind,             /* O: number of windows specified             */
    long *nbands,              /* O: number of bands per image to be fixed   */
    long *odtype,              /* O: data type of input image                */
    long *size,                /* O: number of bytes for this data type      */
    long *totbnd,              /* O: total number of bands to be fixed       */
    long *update,              /* O: flag indicating update mode             */
    long window[][NUM_SPECS]   /* O: window specifications for images        */
);

void horizontal
(
    struct PARBLK *vblock,	/* I: TAE parameter block		      */
    char hostname[][CMLEN],	/* I: host names of input images	      */
    char *minmax,		/* I: min/max flag                            */
    long bands[][MAXBND+1],	/* I: bands to be processed for all images    */
    long inwind[][NUM_SPECS],   /* I: input window areas to fix               */
    long msgtim,		/* I: elapsed time between display messages   */
    long *nbands,		/* I: number of bands per input image         */
    long nbrwind,		/* I: number of repair windows                */
    long nmrimg,		/* I: number of input images                  */
    long odtype,                /* I: data type of images                     */
    long size,                  /* I: number of bytes required for this odtype*/
    long totbnd,		/* I: total number of bands to be processed   */
    long update,                /* I: flag to modify input images             */
    long window[][NUM_SPECS]	/* I: window specification of input images    */
);

void openfile
(
    struct PARBLK *vblock,  /* I: tae parameter block                        */
    char hostname[][CMLEN], /* I: host names of images                       */
    char *minmax,           /* I: min/max flag                               */
    double *maxval,         /* O: maximum pixel value array                  */
    double *minval,         /* O: minimum pixel value array                  */
    long nbands[MAXIMG],    /* I: number of bands per image                  */
    long nbrimg,            /* I: number of images                           */
    long odtype,            /* I: data type of images                        */
    long totbnd,            /* I: total number of bands to be processed      */
    long update,            /* I: flag indicating if input images are modified*/
    long window[][NUM_SPECS]/* I: window specification of images             */
);

void terminate
(
    struct PARBLK *vblock,       /* I: TAE parameter block                    */
    char hostname[][CMLEN],      /* I: Host names of images                   */
    char *minmax,                /* I: Min max flag                           */
    double maxval[],             /* O: Max pixel value array                  */
    double minval[],             /* O: Min pixel value array                  */
    long bands[MAXIMG][MAXBND+1],/* I: Bands to be processed for all images   */
    long nbands[MAXIMG],         /* I: # of bands per input image             */
    long nmrimg,                 /* I: # of input images                      */
    long update,                 /* I: flag to modify the input images        */
    long window[][NUM_SPECS]     /* I: Window specification of input images   */
);

void vertical
(
    struct PARBLK *vblock,	/* I: TAE parameter block		      */
    char hostname[][CMLEN],	/* I: host names of images to be repaired     */
    char *minmax,		/* I: min/max flag                            */
    long bands[][MAXBND+1],	/* I: bands to be processed for all images    */
    long inwind[][NUM_SPECS],   /* I: input window areas to fix               */
    long msgtim,		/* I: elapsed time between display messages   */
    long nbands[],		/* I: number of bands per input image         */
    long nbrwind,		/* I: number of repair windows                */
    long nmrimg,		/* I: number of input images                  */
    long odtype,                /* I: data type of images to be repaired      */
    long size,                  /* I: number of bytes required for this odtype*/
    long totbnd,		/* I: total number of bands to be processed   */
    long update,                /* I: flag to modify input images             */
    long window[][NUM_SPECS]	/* I: window specification of input images    */
);

#endif
