/*******************************************************************************
NAME:		RANDPICK	

PURPOSE:    	RANDPICK picks a random number between 1 and a specified # 
			 
PROGRAM HISTORY:
Version	Programmer	Date	Reason
-------	----------      ----	------
5.0	D.VanderZee	12/90	New development 
				
PROJECT:	LAS
		
ALGORITHM DESCRIPTION: 	See inline documentation
******************************************************************************/
#include "las.h"
#include "lasmath.h"
#include "protos.h"

/* Function to pick a random value between 1 and the "limit" inclusive
----------------------------------------------------------------------*/
void randpick
(
    long *limit		/* number of values to choose from */
) 

{
long	i;		/* loop index */
static long seed = 1;	/* seed value for random number generator */

double  rand_num; 	/* random number generated */	
double	fraction;	/* reciprocal of limit */

fraction = 1.0 / (double)*limit;

rand_num = c_randnm(&seed);

for (i = 1; i < *limit; i++)
   {
   if (rand_num <= (fraction * i))
      {
      break;
      }
   }

*limit = i;
return;
}
