#ifndef PROTOS_H
#define PROTOS_H

void combine
(
    char las_pat[],          /* pattern image LAS name              */
    char las_in[][CMLEN],    /* Level II images LAS names           */
    char hos_out[],          /* output image host name              */
    long num_samp,           /* number of samples per line          */
    long *num_lines,         /* number of lines in the pattern image*/
    long num_images,         /* number of classified images         */
    long max_in_gl[],        /* max grey level in Level II images   */
    long min_in_gl[],        /* min grey level in Level II images   */
    long min_pat_gl,         /* min grey level in pattern image     */
    long max_pat_gl,         /* max grey level in pattern image     */
    long grey_level[]       /* class grey level values             */
);

void filspec
(
    char hos_patin[][CMLEN],   /* pattern image host name           */
    char hos_in[][CMLEN],      /* input image host name descriptors */
    char hos_out[][CMLEN],     /* output image host name descriptor */
    long *num_images,          /* number of Level II images         */
    long *num_lines_pat,       /* number of lines in pattern image  */
    long *num_samp,            /* number of samples per line        */
    long num_lines[],          /* number of lines in the images     */
    long min_in_gl[],          /* max grey level in pattern image   */
    long max_in_gl[],          /* max grey level in Level II images */
    long *min_pat_gl,          /* min grey level in pattern image   */
    long *max_pat_gl          /* min grey level in Level II images */
);

void getpar
(
    char las_pat[][CMLEN],      /* pattern image LAS name           */
    char hos_pat[][CMLEN],      /* pattern image host name          */
    char las_in[][CMLEN],     /* Level II images LAS names        */
    char hos_in[][CMLEN],     /* Level II images host names       */
    char las_out[][CMLEN],      /* output image LAS name            */
    char hos_out[][CMLEN],      /* output image host name           */
    long *num_images,         /* number of Level II images        */
    long grey_level[],        /* pattern grey level values        */
    long *num_lines_pat,      /* number of lines in pattern image */
    long *num_samp,           /* number of samples per line       */
    long num_lines[],         /* number of lines in images        */
    char print_file[CMLEN]   /* print file name                  */
);

void terminate
(
    char las_out[][CMLEN],    /* input image las name       */
    char hos_out[],           /* output image host name     */
    char hos_pat[],           /* pattern image host name    */
    char hos_in[][CMLEN],     /* input image host names     */
    long num_images          /* number of images           */
);

#endif

