#include "speccomb.h"
#include "util.h"
#include "protos.h"

void terminate
(
    char las_out[][CMLEN],    /* input image las name       */
    char hos_out[],           /* output image host name     */
    char hos_pat[],           /* pattern image host name    */
    char hos_in[][CMLEN],     /* input image host names     */
    long num_images          /* number of images           */
)
/*
**************************************************************************
NAME: TERMINATE

PURPOSE: Update output image history and issue completion message

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1           6-Dec-88  K. Narayanan, SAR    

**************************************************************************
*/
{

long    one = 1;

long	n;
char	out_name[9][CMLEN];

/*
update output image history from all the input images
-----------------------------------------------------
*/
strcpy (out_name[0], hos_pat);
for (n = 1; n <= num_images; n++)
      strcpy (out_name[n], hos_in[n-1]);

c_hstout (&block, hos_out, out_name, &n, " "); 

/*
issue completion message
------------------------
*/
c_complt ("SPECCOMB", las_out, &one);

}
