#ifndef PROTOS_H
#define PROTOS_H

void filspec
(
    char hos_patin[],          /* pattern image host name           */
    char hos_in[][CMLEN],      /* input image host name descriptors */
    char hos_out[][CMLEN],     /* output image host name descriptor */
    long pat_image_band_num[],/* pattern image band number          */
    long *num_inimages,        /* number of input images             */
    long num_image_bands[],   /* number of bands in each input image*/
    long out_num_lines[],     /* no. lines in output images         */
    long *num_bands,          /* no. bands in the image             */
    long class_num,            /* class number processed            */
    long num_classes,         /* no. classes to be processed        */
    long grey_level[],         /* class grey level values           */
    long image_band_num[][MAXBND + 1], /* band numbers in each      */
    long wind[][4],           /* input image windows                */
    long wind_pat[4],         /* pattern image window               */
    long *image_type         /* input/output image data type       */
);

void getpar
(
    char hos_patin[][CMLEN],    /* input pattern image host name    */
    char hos_in[MAXIMG][CMLEN],/* input image host names          */
    char tae_out[8][CMLEN],   /* output images LAS names          */
    char hos_out[8][CMLEN],   /* output images host names         */
    long *num_inimages,       /* number of input images           */
    long num_image_bands[],   /* number of bands in each input image */
    long image_band_num[][MAXBND + 1],
    long *num_inbands,        /* total number of input image bands   */
    long pat_image_band_num[][MAXBND+1],/* pattern image band number        */
    long grey_level[8],       /* pattern grey level values        */
    long *num_classes,        /* number of classes to be used     */
    long wind_pat[][4],         /* input pattern image window       */
    long wind[][4]           /* input image windows              */
);

void sizout
(
    long wind[][4],          /* input image window        */
    long num_classes,        /* no. classes               */
    long grey_level[8],      /* class grey level values   */
    long out_num_lines[]    /* no. lines in output images*/
);

void strat
(
    long wind[][4],          /* input image windows          */
    long num_bands,          /* no. bands in the image       */
    long class_num,          /* class number processed       */
    long *num_classes,       /* no. classes                  */
    long out_num_lines[],    /* no. line in output images    */
    long grey_level[8],      /* class grey level values      */
    char tae_out[][CMLEN],   /* output images TAE names      */
    char hos_out[][CMLEN],   /* output images host names     */
    char hos_in[][CMLEN],    /* input images host names      */
    long *num_inimages,      /* no. input images             */
    long type               /* image data type              */
);

#endif
