#include "spread.h"
#include "protos.h"

void delrun
(
    long run,		    /* I: current run                                 */
    long *point,	    /* I/O: array of pointers to next elements in list*/
    long *nextp 	    /* I/O: pointer to the next record                */
)

/*
*****************************************************************************

NAME: DELRUN

PURPOSE: Deletes a run.

PROGRAM HISTORY:
  Version	Date       Author	           Request
  -------	----	   ------                  -------
   1.0         15-Feb-85   M. Goldberg/GSFC      
   2.0         31-Aug-87   D. Akkerman/EDC
   3.0         29-Mar-89   K. Kunska		conversion to 5.0


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	 Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Delete a run.
   Runs being deleted should not have a pointer set to them.
   Do not delete the prior record.  
   The unused part of the  point array is used as a stack of available records.

*****************************************************************************
*/

{


long	prior = 0;

/*
Delete a run - runs being deleted should not have a pointer set to them.
Do not delete the prior record.  
The unused part of the  point array is used as a stack of available records.
----------------------------------------------------------------------------
*/
if (run  !=  prior) 
   {
   point[run] = *nextp;
   *nextp = run;
   } 

}
