#include "stat2tab.h"
#include "protos.h"

void covar_header
(
    struct TAB_DEF *tab,		/* pointer to the LT file     */
    long nbands			/* */
)
/*
**********************************************************************

NAME: COVAR_HEADER                            

PURPOSE: To write the covariance header information to the LT file.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1.0         11/86      K. Gacke     original development
    1.1          1/87      K. Gacke     new LT file format
    2.0          9/87      K. Gacke	fixed an infinite loop when processing
					covariance matrix and the covariance
					matrix does not exist at the image level
    2.1  	 1/90      J. Marmon    v5.0 conversion 

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
       Write the headers to a covariance LT file.
       A short description is given also.

************************************************************************
*/
{
/*
*   Label vector for the Labeled Table. 
*/
put_vector(tab,"INDEX",I4,"unique index number",1,1,FIELD_SEP2);
put_vector(tab,"LEVEL",C,"image, class, or site level",1,6,FIELD_SEP2);
put_vector(tab,"NBANDS",I4,"number of bands",1,1,FIELD_SEP2);
put_vector(tab,"CLASS",C,"class label",1,STNAME,FIELD_SEP2);
put_vector(tab,"SITE",C,"site label",1,STNAME,FIELD_SEP2);
put_vector(tab,"NPOINTS",I4,"Number of points in polygon area",1,1,FIELD_SEP2);
put_vector(tab,"MEAN",R8,"mean vector",1,nbands,FIELD_SEP2);
put_vector(tab,"COVAR",R8,"covariance matrix",nbands,nbands,RECORD_SEP);
return;
}
