#include "stat2tab.h"
#include "protos.h"

void poly_header
(
    struct TAB_DEF *tab, 	/* Definition structure of LT file	*/
    struct TAB_DEF *subtab 	/* Definition structure of LT file	*/
)

/*
**********************************************************************

NAME: POLY_HEADER                            

PURPOSE:  To write polygon header information to the Label Table file. 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1.0         11/86      K. Gacke     original development
    1.1          1/87      K. Gacke     new LT file format
    2.0          9/87      K. Gacke	fixed an infinite loop when processing
					covariance matrix and the covariance
					matrix does not exist at the image level
    2.1  	 1/90      J. Marmon    v5.0 conversion 

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
      Write Labeled Table header information

************************************************************************
*/
{
/*
*   Label vector for the description Labeled Table. 
*/
put_vector(tab,"REGNUM",I4,"unique region number",1,1,FIELD_SEP2);
put_vector(tab,"CLASS",C,"class label",1,STNAME,FIELD_SEP2);
put_vector(tab,"SITE",C,"site label",1,STNAME,RECORD_SEP);
/*
*   Label vector for the data Labeled Table (subfile). 
*/
put_vector(subtab,"REGNUM",I4,"unique region number",1,1,FIELD_SEP2);
put_vector(subtab,"X",I4,"column number",1,1,FIELD_SEP2);
put_vector(subtab,"Y",I4,"row number",1,1,RECORD_SEP);
return;
}
