#ifndef PROTOS_H
#define PROTOS_H

void covar
(
    struct PARBLK *vblock,	/* TAE parameter block			*/
    struct TAB_DEF *tab, 	/* LT file structure		        */
    char ftype[],		/* STAT file data type			*/
    char outfil[][CMLEN],	/* New LT file name			*/
    long *nfile,		/* number of LT files			*/
    char hstat[],		/* STAT host file name			*/
    long level[],		/* Covariance data level		*/
    char *classval[TAE_VAL+1],	/* Class name				*/
    char *siteval[TAE_VAL+1],	/* Site name				*/
    long *msgtim		/* Time between processing messages	*/
);

void covar_data
(
    struct PARBLK *vblock,	/* TAE parameter block			*/
    FILE *fd,			/* file descriptor			*/
    struct TAB_DEF *tab,	/* LT file structure			*/
    char outfil[][CMLEN],	/* New LT file name			*/
    long *nfile,		/* number of LT files			*/
    long *cur_class,		/* current class in STAT file		*/
    long *cur_site,		/* current site in STAT file		*/
    long level[],		/* level in STAT file 			*/
    char *classval[TAE_VAL+1],	/* class name for STAT file		*/
    char *siteval[TAE_VAL+1],	/* site name for STAT file		*/
    long nitems,		/* number of items associated with data */
    long *total_covar		/* total number of matrix in STAT file  */
);

void covar_header
(
    struct TAB_DEF *tab,		/* pointer to the LT file     */
    long nbands			/* */
);

int get_class_site
(
    struct PARBLK *vblock,		/* TAE parameter block		*/
    FILE *fd,				/* file descriptor		*/
    struct TAB_DEF *tab,		/* LT master file structure	*/
    struct TAB_DEF *subtab,		/* LT subfile structure		*/
    char outfil[][CMLEN],		/* New LT file name(s)		*/
    long *nfile,			/* number of LT files		*/
    char dtype[],			/* data type of STATs file	*/
    long *cur_class,			/* current class 		*/
    long *cur_site,			/* current site			*/
    char *classval[TAE_VAL+1],		/* input class names from param */
    char *siteval[TAE_VAL+1],		/* input site names from param	*/
    char class_name[],			/* class name from STATs file	*/
    char site_name[]			/* site name from STATs file	*/
);

void poly
(
    struct PARBLK *vblock,		/* TAE parameter block		*/
    struct TAB_DEF *tab,		/* LT file structure		*/
    char *ftype,			/* STAT file type		*/
    char *hstat,			/* host stat file name		*/
    char outfil[][CMLEN],		/* new LT file names		*/
    long *nfile,			/* number of LT files		*/
    char *classval[TAE_VAL+1],		/* STAT class names to process  */
    char *siteval[TAE_VAL+1],		/* STAT site names to process	*/
    char *comment,			/* LT comment line		*/
    char *hsubtab,			/* subfile name			*/
    long *msgtim			/* Time between processing msg  */
);

void poly_data
(
    struct PARBLK *vblock,	/* TAE parameter block			    */
    FILE *fd,			/* file descriptor			    */
    struct TAB_DEF *tab,	/* Definition structure of LT file	    */
    struct TAB_DEF *subtab,	/* Definition structure of LT file	    */
    char outfil[][CMLEN],	/* new LT file names			    */
    long *nfile,		/* number of LT files			    */
    char dtype[],		/* STAT file data type			    */
    long *cur_class,		/* current class in STAT file		    */
    long *cur_site,		/* current site in STAT file		    */
    char *classval[TAE_VAL+1],	/* class name in STAT file		    */
    char *siteval[TAE_VAL+1],	/* site name in STAT file		    */
    long npts,			/* number of item associated with the data  */
    long *total_poly		/* total number of polygons in STAT file    */
);

void poly_header
(
    struct TAB_DEF *tab, 	/* Definition structure of LT file	*/
    struct TAB_DEF *subtab 	/* Definition structure of LT file	*/
);

#endif
