#include "stats.h"

void dyn_alloc
(
    double *cov[],		/* O: Covariance matrix                     */  
    long *shist[]		/* O: Site histograms                       */
)
/*
*********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for covariance matrices 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/17/88  K. A. Narayanan
  2.0         08/31/88  B. Allam

*********************************************************************
*/
{
long	buf_size, t_size,	/* size of matrices       */
	i, n, m;
long    fatal_err = -1;

/*
allocate storage for covariance matrices 
-----------------------------------------
*/
t_size = (long)(totbnd * totbnd * sizeof(double));
buf_size = (long)(totbnd * 258 * sizeof(long));

if ((cov_matrix = (double *) malloc( t_size)) == NULL ||
    (shist_matrix = (long *) malloc( buf_size)) == NULL) {
    c_errmsg ("Error allocating dynamic memory", "stats-alloc", &fatal_err);
   }
/*
set up pointers for covariance matrices 
----------------------------------------
*/
for (i = 0, n = 0, m = 0; i < totbnd; i++, n += 258, m += totbnd)
   {
   shist[i] = &shist_matrix[n];
   cov[i] = &cov_matrix[m];
   }
}
