#include "stats.h"

void lnames
(
    long nclass,	/* I: Number of classes in statistics file       */
    char list[]		/* I: Indicates whether site listing is required */
)

/******************************************************************************

NAME:	lnames

FUNCTION:
	lists class names and site names in statistics file

	Exit states-
	   stat i/o error for class. check stats file
	   stat i/o error for site. check stats file
	   stat i/o error for # sites. check stats file

	Restrictions- class and site names less-than or equal-to 80.
	              characters.

*******************************************************************************/

{
char	cname[STNAME],		/* Class name as returned by stat i/o         */
	sname[STNAME],		/* Site name as returned by stat i/o          */
	tname[STNAME];		/* Array to hold term i/o messages            */

long	j,			/* Loop variable                              */
	k,			/* Loop variable                              */
	ns,			/* Number of sites for a class                */
	shape[9];		/* Statistical data descriptor                */
long    fatal_err = -1;
long    inf_err = 1;
long    zero=0;

/* Retrieve class name
   ------------------- */
for (k = 1; k <= nclass; k++)
   {
   if (c_stget ((FILE **)&sdesc,"NAME",&k,&zero,shape,
                 (unsigned char *)cname) != E_SUCC)
      c_errmsg ("Stat i/o error for class. check stats file",
               "stats-i/o", &fatal_err);
/*
   Write class name to terminal
   ----------------------------
*/
   cname[shape[2]] = '\0';
   sprintf (tname, "Class: %s", cname);
   c_errmsg (tname, "stats-info", &inf_err);
/*
   Retrieve the # of sites
   -----------------------
*/
   if (list[0] == 'S')
      {
      c_errmsg ("_Sites", "stats-info", &inf_err);
      if (c_stget ((FILE **)&sdesc, "NSITES", &k, &zero, shape, 
		   (unsigned char *)&ns) != E_SUCC)
         c_errmsg ("Stat i/o error for site. check stats file",
                  "stats-i/o", &inf_err);
/*
   Retrieve each site name and write to terminal
   ---------------------------------------------
*/
      for (j = 1; j <= ns; j++)
         {
         if (c_stget ((FILE **)&sdesc, "NAME", &k, &j, shape,
		       (unsigned char *)sname) != E_SUCC)
            c_errmsg ("Stat i/o error for # sites. check stats file",
                     "stats-i/o", &fatal_err);
         sname[shape[2]] = '\0';
         sprintf (tname, "       %s", sname);
         c_errmsg (tname, "stats-info", &inf_err);
         }
      }
   }
}
