#include "stats.h"

void openfiles
(
    char hosnm[][CMLEN],	/* I: Buffer for input host names             */
    long nmrimg,		/* I: Number of images                        */
    long bands_num[][MAXBND + 1],/*I: Band number for each band               */
    long nbands[],		/* I: Number of bands for each image          */
    long *sl,		     	/* I: Image window to be read                 */
    long *ss,			/* I: Image window to be read                 */
    long *nl,			/* I: Image window to be read                 */
    long *ns			/* I: Image window to be read                 */
)

/******************************************************************************
 
NAME:	openfiles

FUNCTION:
	Establishes a file specification group for input image
	files retrieves x and y offsets from ddr.

*******************************************************************************/

{
long	access,			/* Type of file access                        */
	band,			/* Counter for input image bands              */
	bufsize,		/* Image I/O buffer size                      */
	image,			/* Counter for input images                   */
	intype,			/* Input image I/O data type                  */
	status;			/* Return status                              */
long    fatal_err = -1;
long    zero=0;

/*
   Set up input files -- convert data to r*4
   -----------------------------------------
*/
access = IREAD;                                
intype = EREAL;

for ( image = 0, band = 0; image < nmrimg; image++)
   {
   status = c_eopens ((struct FDESC **)&fdesc[image], hosnm[image],
	              bands_num[image], sl, ss, nl, ns,&offarray[band],
		      &access, &intype, &zero, &zero);
   if (status != E_SUCC)
      {
      c_errmsg ("Error encountered opening input image file",
               "stats-open", &fatal_err);
      }
   band += nbands[image];
   }

fdesc[nmrimg] = 0;      
if ((thebuf = (char *) c_ealloc ((struct FDESC **)fdesc, &bufsize)) == NULL)
   c_errmsg ("Error allocating dynamic memory for imageio", "stats-alloc", 
		&fatal_err);

if (c_egroup ((struct FDESC **)fdesc,(struct GDESC **)&gdesc, 
              (unsigned char *)thebuf, &bufsize) != E_SUCC)
   c_errmsg ("Error grouping input image files", "stats-group", &fatal_err);

}
