/* include files, global parameters, and definitions for STATS */

#include <stdio.h>
#include <math.h>
#include "las.h"
#include "statio.h"
#include "protos.h"

#define MAX_CVSIZ     MAXBND * (MAXBND + 1) / 2

#define MAX_VERTS     401
#define PI            3.1415926

#define isspace(c)    (c == ' ' || c == '\t' || c == '\n')

/* The following structs are converted from the
   FORTRAN common blocks originally used by the program */
                                                        
extern struct 	  	/* Values used to scale histograms to 256 bins        */
      {       
      float  *sca;	/* scales                                     */
      float  *off;	/* offsets                                    */
      } scales;

extern struct 		/* Used for the -CUT subcommand                       */
      {
      float *hival;
      float *loval;
      long  *bands;
      } cut;

extern struct 		/* Stores master scene coordinates                    */
      {
      long yoff;		/* Line offset                                */
      long xoff;		/* Pixel offset                               */
      long imsiz[2];		/* nl, ns                                     */
      } master;

extern long   dsite[MAXCLS][MAXCLS];	/* Indicates sites outside
					 	image bounds       */
extern long   *shist_matrix;
extern double *cov_matrix;
extern double *arr_matrix;
extern long   totbnd;                  /* Total number of bands */
      
/* Image I/O globals
   ----------------- */
extern long   	fdesc[MAXIMG+1]; /* Array of file descritors */
extern long   	gdesc;	/* Group descriptor                           */
extern long offarray[MAXIMG*MAXBND+1];  /* Array of offsets */
extern long   	sdesc;	/* File descriptor of stats file              */
extern struct   PARBLK vblock;	/* TAE parameter block                        */
extern  struct  DDR	ddr;    /* ddr                     */
 
extern char   	*thebuf;	/* Buffer for image i/o                       */

extern	long	curent;                        /* current entity           */
extern	long	curcat;                        /* current category         */

extern  long    in_type;                      /*input data type  */
