#ifndef PROTOS_H
#define PROTOS_H

void filspec
(
    char inhos[][CMLEN],     /* input image host names                        */
    char modhos[],          /* modulating image host name		     */
    char outhos[],           /* output image host name                        */
    long *num_inimages,	    /* number of input images			*/
    long num_image_bands[],       /* number of bands in each input image*/
    long image_band_num[][MAXBND + 1], /* band numbers in each input image   */
    long *num_outbands,	/* number of output bands */
    long wind1[][4],	/* input image window */
    long wind2[4],  	/* modulating image window */
    long modimg_band_num[],   /* band numbers in modulating image   */
    long out_type,	/* output image data type */
    long out_img_bands[][MAXBND+1], /* band numbers for the output image     */
    long *modflg               /*flag to indicate if modulating image exits  */
);

void getpar
(
    char intae[][CMLEN],         /*    input image tae name       */
    char inhos[][CMLEN],         /*    input image host name      */
    char modtae[][CMLEN],           /*    modulating image tae name  */
    char modhos[][CMLEN],           /*    modulating image host name */
    char outtae[][CMLEN], /*    output image tae name      */
    char outhos[][CMLEN], /*    output image host name     */
    long *shift,          /* maximum pixel shift        */
    long *modflg,         /* flag to indicate if modualting image exist */
    long wind1[][4], 		/* input image window		*/
    long *num_inimages,		/* number of input images           */
    long num_image_bands[],	/* number of bands in each input image */
    long image_band_num[][MAXBND+1],  /* band numbers selected for each image
				     	specified */
    long *num_inbands,           /* total number of input image bands   */
    long *num_outbands,		/* number of output image bands     */
    long wind2[][4], 		/* modulating image window 	*/
    long modimg_band_num[][MAXBND+1],   /* band numbers selected for modulating
					 image specified */
    long *out_type           /* output image data type           */
);

void p3dsub
(
    double amax[],		/* maximum pixel value */
    double amin[], 		/* minimum pixel value */
    long shift,     	/* maximum pixel shift   */
    long modflg,         /* flag indicating whether modulating image exist */
    long wind1[][4],	/* input image window   */
    long num_inbands,    /* total number of input bands to be processed   */
    long *num_outbands  /* total number of output bands to be processed  */
);

#endif
