/*****************************************************************************
*
*  NAME: GET_COOR
*
*  FUNCTION: Read the coordinates from the labeled table
*
*  PROGRAM HISTORY:
*  Version      Date    Programmer      Code    Request
*  -------      ----    ----------      ----    -------
*     1       02/01/85  K. LETHCOE      CSB
*     2       04/01/91  Ailts/Etrheim   CSB     LAS 5.0 conversion
*
*  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
*               Must be run under TAE
*
*  PROJECT: LAS
*
*  ALGORITHM DESCRIPTION:
*       See inline comments 
*
******************************************************************************/
#include "las.h"
#include "tab2ras.h"
#include "ltable.h"
#include  "protos.h"

void get_coor
(
    long *tab_ind,              /* I: tab index */
    struct VECTOR *ptr[],       /* I:  */
    double *y,                  /* I/O: y location */
    double *x,                  /* I/O: x location */
    long *id,                   /* I: line id */
    long *seq                   /* I: line sequence number */
)

{ 
    double array[2];    /* temp. array if both Y and X are under one attribute*/

    /* Read the id, sequence, and coordinates from the labeled tables
       -----------------------------------------------------------------*/
    get_matrix(ptr[IDCOOR],I4,(unsigned char *)id);
    if (ptr[SEQN] != NULL)
        get_matrix(ptr[SEQN],I4,(unsigned char *)seq);
    if (tab_ind[COOR2] != -1)
    {
        get_matrix(ptr[COOR1],R8,(unsigned char *)y);
        get_matrix(ptr[COOR2],R8,(unsigned char *)x);
    }
    else
    {
        get_matrix(ptr[COOR1],R8,(unsigned char *)array);
        *y = array[0];
        *x = array[1];
    }

    return;
}
