#ifndef PROTOS_H
#define PROTOS_H

int get_cls_site
(
    long level,			/* STAT level being processed                 */
    struct VECTOR *class,	/* Labeled Table record field for CLASS       */
    struct VECTOR *site,	/* Labeled Table record field for SITE        */
    char *classval[TAE_VAL],	/* User specifed CLASS values                 */
    char *siteval[TAE_VAL],	/* User specifed SITE values                  */
    char class_name[],		/* Class value returned to calling routine    */
    char site_name[],		/* Site value returned to calling routine     */
    long *class_counter	/* Number of class values that have been NULL */
);

int get_cur_lvl
(
    struct VECTOR *stat_level
);

void get_lt_def
(
    struct PARBLK *vblock,	  /* parameter block			   */
    FILE **fd,			  /* file descriptor			   */
    struct TAB_DEF *tab,	  /* master LT file structure */
    char *attrib,	  /* attribute LT file type */
    char *data,	  /* data LT file type */
    struct TAB_DEF **attrib_def,  /* attribute LT structure to be returned */
    struct TAB_DEF **data_def,	  /* data LT structure to be returned */
    char hstat[][CMLEN],		  /* host stat file name		   */
    long *nfile		  /* whether or not a new stat file was made */
);

void get_xy_pts
(
    struct PARBLK *vblock,	/* TAE parameter block                        */
    FILE **fd,			/* File descriptor			      */
    struct TAB_DEF *regxy,	/* Labeled Table description structure        */
    struct VECTOR *ptr_reg,	/* Label column for REGNUM                    */
    struct VECTOR *ptr_x,	/* Label column for X                         */
    struct VECTOR *ptr_y,	/* Label column for Y                         */
    long *xy,			/* Array containing the x points              */
    long *npnts,		/* Number of points in the polygon            */
    long *cur_poly,		/* Current polygon being processed            */
    char hstat[][CMLEN],		/* host stat file name			      */
    long *nfile		/* Whether a new STAT file was created or not */
);

void process_covar
(
    struct PARBLK *vblock,	/* TAE parameter block                        */
    FILE **fd,			/* file descriptor			      */
    struct TAB_DEF *tab,	/* Labeled Table description structure        */
    long level[],		/* STAT levels to be processed                */
    char *lev_atr,		/* Label name to be used as the STAT LEVEL    */
    long f_flag,		/* Boolean flag, is FALSE only if IMAGE is    */
    char *class,		/* Label name to be used as the STAT CLASS    */
    char *site,			/* Label name to be used as the STAT SITE     */
    char *classval[TAE_VAL],	/* Label descriptions to be valid class values*/
    char *siteval[TAE_VAL],	/* Label descriptions to be valid site values */
    long nclass,		/* Total number of classes in the STAT file   */
    long *msgtim,		/* Number of seconds between processing msg   */
    char hstat[][CMLEN],		/* host stat file name			      */
    long *nfile		/* Whether a new STAT file was created or not */
);

void process_poly
(
    struct PARBLK *vblock,	/* TAE parameter block                        */
    FILE **fd,			/* file descriptor			      */
    struct TAB_DEF *tab,	/* Labeled Table description structure        */
    char *class,		/* Label name to be used as the STAT CLASS    */
    char *site,			/* Label name to be used as the STAT SITE     */
    char *classval[TAE_VAL],	/* Label descriptions to be valid class values*/
    char *siteval[TAE_VAL],	/* Label descriptions to be valid site values */
    char *regnm,		/*  */
    char *Xcoor,		/*  */
    char *Ycoor,		/*  */
    long nclass,		/* Total number of classes in the STAT file   */
    long *msgtim,		/* Number of seconds between processing msg   */
    char hstat[][CMLEN],		/* host stat file name			      */
    long *nfile		/* Whether a new STAT file was created or not */
);

void skip_xy_pts
(
    struct TAB_DEF *regxy,	/* Labeled Table description structure        */
    struct VECTOR *ptr_reg,	/* Label column for "REGNUM"                  */
    long *cur_poly		/* Current polygon for which data is skipped  */
);

void stat_class
(
    struct PARBLK *vblock,	/* parameter block		*/
    FILE **fd,			/* file descriptor      	*/
    char data_type[],		/* name of the data item	*/
    char class_name[],		/* STAT class name		*/
    long *nclass,		/* total number of classes in STAT file */
    long *class_index,		/* class name			*/
    long *site_index,		/* site name			*/
    char hstat[][CMLEN],		/* host stat file name		*/
    long *nfile		/* whether or not a new stat file was created*/
);

void stat_covar
(
    struct PARBLK *vblock,	/* TAE parameter block                        */
    FILE **fd,			/* file descriptor		*/
    long cur_level,		/* numeric value of stats type	*/
    char class_name[],		/* STAT class name		*/
    char site_name[],		/* STAT site name		*/
    long *nclass,		/* total # of classes in STAT file	*/
    struct VECTOR *covar_matrix,/* pointer to value of covariance matrix*/
    struct VECTOR *mean_vec,	/* pointer to mean vector in LT 	*/
    struct VECTOR *npoints,	/* pointer to number of points in area  */
    char hstat[][CMLEN],		/* host stat file name			*/
    long *nfile		/* Whether a new STAT file was created or not */
);

void stat_site
(
    struct PARBLK *vblock,	/* TAE parameter block                        */
    FILE **fd,			/* file descriptor			*/
    char data_type[],		/* name of the data item		*/
    char class_name[],		/* CLASS class name			*/
    char site_name[],		/* STAT site name			*/
    long *nclass,		/* total number of classes in STAT file */
    long *class_index,		/* class name				*/
    long *site_index,		/* site name				*/
    char hstat[][CMLEN],		/* host stat file name			*/
    long *nfile		/* Whether a new STAT file was created or not */
);

#endif
