#include "tab2stat.h"
#include "protos.h"

void skip_xy_pts
(
    struct TAB_DEF *regxy,	/* Labeled Table description structure        */
    struct VECTOR *ptr_reg,	/* Label column for "REGNUM"                  */
    long *cur_poly		/* Current polygon for which data is skipped  */
)

/*
**********************************************************************

NAME: Skip_XY_Pts                            

PURPOSE: To skip over the data for the current polygon in the
         Labeled Table. 

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
      Loop until current polygon doesn't equal the polygon being pointed to
	         or there are no more polygons
	 If current polygon not equal to polygon being pointed to then
	   assign current polygon to new ploygon
	   and stop the loop
	 If continue the loop then
	   If there is a next polygon then
	     continue the loop
	
************************************************************************
*/
{
/*struct VECTOR *rec;
*/
long flag;			/* boolean variable      */

for (flag=TRUE; flag; )
   {
/*
 If the polygons do not equal then set the current polygon the new one
 and stop the loop
*/
   if (*cur_poly != *ptr_reg->ptr.i4)
      {
      *cur_poly = *ptr_reg->ptr.i4;
      flag = FALSE;
      }
/*
 If polygons not equal then get the next polygon
   and if there is a next polygon loop again
*/
   if (flag)
      if (get_record(regxy))
         flag = FALSE;
   }
return;
}
