#include <stdio.h>
#include "las.h"
#include "tapeio.h"
#include "util.h"
#include "protos.h"

/******************************************************************************
FUNCTION:       CLEANUP

PURPOSE:        Deletes the image file and prints a fatal error message to
                the standard output.  It is called when a fatal error is
                encountered during processing (it is assumed the host file
                exists).

ALGORITHM 
  Skip to beginning of next file on tape
  Close the tape device
  Display the fatal error message and terminate

ALGORITHM REFERENCES    none
*******************************************************************************/
void cleanup
(
    long *unit                  /* tape unit number                          */
)
{
    extern long outcnt;         /* Number of output files opened              */
    extern char out[2][CMLEN];  /* Output image files opened                  */
    extern struct PARBLK vblock;/* TAE parameter block                        */

    /* Skip to beginning of next file
       ---------------------------------*/
    skip_file(unit,1);

    /* Close the tape device
       ------------------------*/
    close_tape(unit,NOREW);

    /* Clean up and LAS image files opened and terminate the application
       --------------------------------------------------------------------*/
    c_clean(&vblock,"tapein",out,&outcnt);

    return;
}
