#ifndef PROTOS_H
#define PROTOS_H

void chk_window
(
    long *inspc,    /* input image file specifications   */
    long *window   /* window area of image to be copied */
);

short *check_band
(
    long *inspc,
   long *bands
);

void check_ddr
(
    long bands[][MAXBND + 1],
   long *inspc,
   long *m2one,
   long *totbnd,
   struct DDR *ddr
);

short check_tpread
(
    long status,
   long *unit,
   unsigned char *buf,
   long *nbyte,
   long *mode
);

void cleanup
(
    long *unit			/* tape unit number                  	     */
);

int compute_ns
(
    long *unit,         /* tape unit number                           */
    long *idtype,		/* input image data type                      */
    long *blksiz		/* number of lines in block	 	      */
);

void copy_ddr
(
    long bands[][MAXBND + 1],   /* Bands to be read from this image file      */
    long *idtype,               /* Data type of image file on tape            */
    long *inspc,                /* Image file specs (total lines,samps,bands) */
    long *insys,                /* System the image was created on            */
    long *m2one,                /* Flag placing multiple images in one output */
    long *totbnd,               /* Total number of bands to place in output   */
    long *unit,                 /* Tape unit number                           */
    short *found_ddr,           /* Flag indicating DDR was found or not       */
    short *hp_flag,             /* Flag to indicate this is an HP             */
    char *ddrnam,               /* Temporary image file to hold input DDR     */
    long *curfil,	         	/* curent band file			      */
    char *tddrnam               /* temporary ddr name                        */
);

void cp_bil
(
    long *unit,			/* tape unit number                           */
    long *insys,		/* Input system data if from		      */
    long *outsys,		/* Output system data is written to	      */
    char *hosout,		/* output host name           		      */
    long *inspc,		/* input file specifications                  */
    long window[],		/* window area of image to be copied          */
    long *totbnd,		/* total number of bands to be copied         */
    long *idtype,		/* input image data type                      */
    long *blksiz,		/* number of line in input block	      */
    long *linc,			/* line increment for subsample               */
    long *sinc,			/* sample increment for subsample             */
    short *bflag,		/* flag indicating bands to be copied         */
    short *hp_flag,		/* boolean for HP computer system             */
    short *minmax		/* min max flag                               */
);

void cp_bsq
(
    long *unit,			/* tape unit number                           */
    long *insys,		/* Input system data is from		      */
    long *outsys,		/* Output system data written to	      */
    char *hosout,		/* output host name           		      */
    long *inspc,		/* input file specifications                  */
    long *window,		/* window area of image to be copied          */
    long *totbnd,		/* total number of bands to be copied         */
    long *idtype,		/* input image data type                      */
    long *blksiz,		/* number of lines in input block	      */
    long *linc,			/* line increment for subsample               */
    long *sinc,			/* sample increment for subsample             */
    short *bflag,		/* flag indicating bands to be copied         */
    short *hp_flag,		/* boolean for HP computer system             */
    short *minmax,		/* min max flag                               */
    long *curbnd		/* current band to write to		      */
);

int getdata
(
    char *hname,		          /* host image file name 		      */
    struct DDR *ddr	  	  /* ddr structure of record 1 and 2	      */
);

void getpar
(
    long *access,		        /* output image file access		     */
    long bands[][MAXBND+1],	/* bands to be processed within image        */
    long *blksiz,		        /* number of lines within input block	     */
    long *curbnd,		        /* current band to be written to 	     */
    long *idtype,		        /* data type of input image                  */
    long *inhdr,	        	/* number of header records to skip          */
    long *inspc,		        /* Total number lines, samples, and bands    */
    long *insys,	        	/* Input system data is from		     */
    long *linc,			/* line increment for subsample              */
    long *m2one,	        	/* many input files to one output file flag  */
    long *msgtim,		        /* elapsed time between display msg          */
    long *odtype,	        	/* data type of output image	             */
    long *outsys,		        /* Output system data is to be put to	     */
    long *sinc,			/* sample increment for subsample            */
    long *skip,			/* number files to skip prior to copy        */
    long *totbnd,	        	/* total number of bands to process 	     */
    long window[][4],		/* window of input image                     */
    short *ddr_flag,		/* flag to copy ddr info                     */
    short *hp_flag,		        /* flag for HP computer system               */
    short *minmax,	        	/* min max flag                              */
    char *bform,			/* input band format (BSQ or BIL)            */
    char *hosout,	        	/* Output host name          		     */
    char *taeout,		        /* Output TAE name           		     */
    long *compflg,              /* Image compression flag                    */
    char *tddrnam,			/* temporary ddr name			     */
    long *nbands			/* number of bands			     */
);

void process
(
    long *access,         	/* write access to output image      	     */
    long bands[][MAXBND+1],	/* bands to be processed within image	     */
    long *blksiz,		/* number of lines in block	 	     */
    long *curbnd,		/* current band to write to		     */
    long *idtype,		/* data type of input image          	     */
    long *inhdr,		/* number of header records to skip  	     */
    long *inspc,		/* input image file specifications   	     */
    long *insys,		/* Input system data is from		     */
    long *linc,			/* line increment for subsample      	     */
    long *m2one,                /* flag for placing multiple images on one   */
    long *msgtim,		/* elapsed time between display msg  	     */
    long *odtype,		/* data type of output image         	     */
    long *outsys,		/* Output system data is to be put to	     */
    long *sinc,			/* sample increment for subsample    	     */
    long *skip,			/* number files to skip prior to copy	     */
    long *totbnd,		/* total number of bands to be copied	     */
    long window[][4],		/* window area of image to be copied 	     */
    char *bform,		/* input band format (BSQ or BIL)    	     */
    char *hosout,		/* output host names  		      	     */
    short *ddr_flag,		/* DDR flag				     */
    short *hp_flag,		/* HP computer system flag           	     */
    short *minmax,		/* min max flag                      	     */
    long *compflg,		/* image compression flag                    */
    char *tddrnam,		/* temporary ddr name			     */
    long nbands[]		/* Array containing number of bands in output*/
);

void skip_file
(
    long *unit,		/* tape unit number                  		      */
    long skip		/* number of image files to skip     		      */
);

void skip_images
(
    long *unit,			/* tape unit number                           */
    long skip			/* number of image files to skip     	      */
);

short skip_record
(
    long *unit,		/* tape unit number                  		      */
    long skip,		/* number of header records to skip  		      */
    int flag		/* flag to turn off display utility  		      */
);

void mount_tape
(
    long *unit,		/* tape unit number                  		      */
    int flag		/* flag to disable display messages  		      */
);

void reopen_tape
(
    long *unit			/* tape unit number                           */
);

void close_tape
(
    long *unit,		/* tape unit number                  		     */
    long rewopt		/* rewind option                     		     */
);

#endif

