/*******************************************************************************
FUNCTION: BKSP_FILE

PURPOSE:  Back spaces an image file on tape.  This routine is called if the
	  image does not fit on the tape.

ALGORITHM REFERENCES: none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "tapeio.h"
#include "protos.h"

void bksp_file
(
    long *unit			/* tape unit number                  	      */
)
{
extern short ddr_flag;		/* DDR header flag                            */
long four = 4;			/* value of four                      	      */
long three = 3;			/* value of three                     	      */
long nonfatal = 1;		/* Non-fatal error code			      */
long mode = HANDLE;		/* tape I/O outputs error messages   	      */

/* Display an informational message to the user
-----------------------------------------------*/
c_errmsg("Back spacing tape to erase the image file","tapeout-back",&nonfatal);

/* Back space over the DDR and/or just the image file.
   NOTE: the number of files to skip is three more because
	 the tape pointer is placed after the 3 EOF marks placed at EOT.
--------------------------------------------------------*/
if (ddr_flag)
   c_tpbsf(unit,&four,&mode);
else
   c_tpbsf(unit,&three,&mode);

return;
}
