/*******************************************************************************
FUNCTION: C_DATE_TIME

PURPOSE:  Return the current date and time.  The date is returned in the form
	  20000101 where the first 4 digits are the year, the next two are
	  the month, and the last two are the day.  The time is return as HHMM
	  which is a 24 hour time.

PROGRAM HISTORY:

Version  Author           Date   Reason
-------  ---------------  -----  -----------------------------------------------
  1.0    J.Fenno          01/92  Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         None

PROJECT: LAS
*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "las.h"
#include "protos.h"


void c_date_time
(
    char *date_str,         /* The current date as retrieved from the system   */
    char *time_str         /* The current time as retrieved from the system   */
)
{
long now;                  /* Current date and time encoded as a long         */

struct tm *today;          /* Structure containing the current date and time  */

/* Determine current date and time
----------------------------------*/
now   = time(NULL);
today = localtime(&now);
today->tm_mon  += 1;       /* months are zero indexed */
today->tm_year += 1900;    /* years are based on 1900 */

sprintf(date_str, "%4d%02d%02d", today->tm_year, today->tm_mon, today->tm_mday);
sprintf(time_str, "%02d%02d",    today->tm_hour, today->tm_min);
}
