/*******************************************************************************
NAME:    MAKELBL

PURPOSE: Generate the last tape label stored in the file tape_labels.ppf.

PROGRAM HISTORY:

VERSION  PROGRAMMER       DATE   CODE  REASON
-------  ---------------  -----  ----  -----------------------------------------
  1.0    J.Fenno          01/92  EDC   Development
  1.1    J.Fenno          03/92  EDC   Added code to use a unique file name when
				       creating the .ppf file that contains the
				       tape label info.  This file name is then
				       passed back to TAE.  PRF Z0810.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         Must be run under TAE.

PROJECT: LAS		                

NOTE:    This function should just set up LAS and then call the function
	 print_label.  This will allow the function print_label to be copied
	 to any LAS function that needs to generate tape labels.  Currently
	 this includes: tapeout
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "protos.h"

#define NOVAL          0        /* Parameter value was assigned no value     */
#define MAX_VOL       15        /* Maximum number of tape volumes            */
#define MAX_BLKSIZ 32767        /* Maximum block size on tape                */
#define NEXT_VOL     100        /* Flag indicating image did not fit on the  */
                                /* current tape.                             */

struct PARBLK vblock;        /* TAE parameter block                           */

int main
(void)
{
struct VARIABLE *var;        /* Ptr to a parameter                            */

char file_name[CMLEN];       /* Name of the file that contains the label info */

long std_out;                /* Logical unit number for standard output       */


/* Initialize LAS
-----------------*/
c_inlas(&vblock, &std_out);
var = p_find(&vblock, "PARFILE");
strcpy(file_name, SVAL(*var, 0));
print_label(file_name);

return EXIT_SUCCESS;

}
