#ifndef PROTOS_H
#define PROTOS_H

void ascii_ddr
(
    long *unit,		/* tape unit number                  		      */
    char *ddrnam,	/* input host ddr name		     		      */
    long aft_flag,  /* write ASCII DDR after image flag                   */
    char tname[CMLEN]   /* input image tae name                               */
);

void bdr2str
(
    struct BDDR *bddr,	/* source of data	     		      */
    char *string,		/* pointer to output string                   */
    long *len,			/* output string length			      */
    long *band			/* band number                                */
);

void mmval
(
    long input,				/* input validity flag numeric value  */
    char str[]				/* validity flag's character value    */
);

void bksp_file
(
    long *unit			/* tape unit number                  	      */
);

void c_date_time
(
    char *date_str,      /* The current date as retrieved from the system   */
    char *time_str       /* The current time as retrieved from the system   */
);

short check_tpread
(
    long status,        /* status code of tpread call        */
    long *unit,         /* tape unit number                  */
    unsigned char *buf, /* buffer to read data into          */
    long nbyte,         /* number of bytes to read           */
    long mode           /* error mode flag                   */
);

void copy_ddr
(
    long *unit,		/* tape unit number                  		     */
    long *insys,	/* Input system data is from		             */
    long *outsys,   /* Output system data is put to		             */
    char *ddrnam    /* input host ddr name		     	             */
);

void cp_bil
(
    long *unit,			/* tape unit number		             */
    long *insys,			/* Input system			             */
    long *outsys,		/* Output system		             */
    char hosin[][CMLEN],		/* input host file names	     	     */
    long *nmrimg,		/* number of input images	             */
    long window[][4],		/* input window (sl,ss,nl,ns)	             */
    long bands[][MAXBND+1],	/* Input bands			             */
    long nbands[],		/* Number of input bands	             */
    long *totbnd,		/* total number of bands to be copied        */
    long *odtype,		/* output image data type            	     */
    long *blksiz,		/* Number of image lines in an output block  */
    long *linc,			/* line increment for subsample      	     */
    long *sinc,			/* sample increment for subsample    	     */
    long *hp_flag,		/* flag for HP computer system       	     */
    long *ad_flag,		/* flag for ASCII DDR                        */
    long *aft_flag,	    	/* ASCII DDR placement flag 1=after 0=before */
    long *msgtim,		/* elapsed time between messages     	     */
    char taein[][CMLEN] 		/* input tae file names 	     	     */
);

void cp_bsq
(
    long *unit,			/* tape unit number                  	     */
    long *insys,			/* Input system				     */
    long *outsys,			/* Output system			     */
    char hosin[][CMLEN],		/* Input host file names	     	     */
    long *nmrimg,			/* number of input images            	     */
    long window[][4],		/* input window (sl,ss,nl,ns)		     */
    long bands[][MAXBND+1],		/* list of input bands to be copied  	     */
    long nbands[],			/* # bands in each input image               */
    long *totbnd,			/* total number of bands to be copied        */
    long *odtype,			/* output image data type                    */
    long *blksiz,			/* number of image lines in output block     */
    long *linc,			/* line increment for subsample      	     */
    long *sinc,			/* sample increment for subsample            */
    long *hp_flag,			/* ouput computer system flag for HP         */
    long *ad_flag,	        /* flag for ASCII DDR                        */
    long *aft_flag,	        /* ASCII DDR placement flag 1=after 0=before */
    long *msgtim,			/* elapsed time between messages     	     */
    char taein[][CMLEN],		/* Input tae file names 	     	     */
    long qflag[MAXIMG][2]	        /* windowing/banding option flag             */
);

void ddr2str
(
    struct DDR *ddr,		/* pointer to integer data in record 1	      */
    char *string,		        /* pointer to output string                   */
    long *len,			/* output string length			      */
    char *tname                 /* TAE name of image                          */
);

void pntval
(
    long input,				/* input validity flag numeric value  */
    char str[]				/* validity flag's character value    */
);

void getpar
(
    long *insys,			/* Input system				      */
    long *outsys,			/* Output system			      */
    char taein[][CMLEN],		/* Input LAS file names			      */
    char hosin[][CMLEN],		/* Input Host file names		      */
    long window[][4],		/* input window specification		      */
    long bands[][MAXBND+1],		/* list of input bands to be copied	      */
    long nbands[],			/* # bands in each input image		      */
    long *totbnd,			/* total number of bands to be copied	      */
    long *odtype,			/* data type of output image		      */
    long *blksiz,			/* number of lines in output block	      */
    long *linc,			/* line increment for subsample		      */
    long *sinc,			/* sample increment for subsample	      */
    long *nmrimg,			/* number of input images 		      */
    long *skip,			/* # of files to skip prior to copy	      */
    char *bform,			/* band format of output image		      */
    char density[],         /* tape density in BPI               	      */
    long *hp_flag,			/* Flag for HP computer system		      */
    long *ad_flag,			/* Flag for ASCII DDR                         */
    long *aft_flag,			/* Placement Flag for ASCII DDR               */
    long *wrteov_flag,		/* Flag for writing End-of-Volume             */
    long *msgtim,			/* elapsed time between display msg	      */
    long qflag[MAXIMG][2]   /* windowing/banding option flags             */
);

void open_image
(
    char hosin[][CMLEN],	/* input host name				      */
    long *nmrimg,		/* number of input images            		      */
    long window[][4],	/* input window specification        		      */
    long bands[][MAXBND+1],	/* list of input bands to be copied  		      */
    long *nbands,		/* # bands in each input image       		      */
    long *odtype,		/* output image data type            		      */
    char *bform		/* output image band format          		      */
);

int print_label
(
    char parm_file[]     /* Name of the file that contains the label info     */
);

void skip_file
(
    long *unit,		/* tape unit number                  		      */
    long skip		/* number of image files to skip     		      */
);

void skip_images
(
    long *unit,			/* tape unit number                  	      */
    long skip			/* number of image files to skip     	      */
);

void mount_tape
(
    long *unit,                 /* Tape unit number                           */
    long access,                /* Open tape for specified  access            */
    int flag                  /* Flag to disable display messages           */
);

void reopen_tape
(
    long *unit,                 /* tape unit number                           */
    long access                 /* open tape for read access                  */
);

int write_tape
(
    long *unit,         /* tape unit number                                   */
    unsigned char *buf, /* buffer to be written to tape                       */
    long *out_byte,     /* number of bytes to be written                      */
    long *bckrec        /* number of records to back space to get back to the
                           beginning of the bands (BIL only)                  */
);

void close_tape
(
    long *unit,         /* tape unit number                                   */
    long rewopt,        /* rewind option                                      */
    long eofs           /* Number of EOF's to write to tape                   */
);

#endif
