#ifndef PROTOS_H
#define PROTOS_H

void createc
(
    long totbnd,			/* total number of bands to be processed     */
    long brght,			/* flag for generation of brightness band    */
    long grn,			/* flag for generation of greenness band     */
    long wt,			/* flag for generation of wetness band       */
    float *bright,		/* brightness coefficients array             */
    float *green,	        /* greenness coefficients array		     */
    float *wet,	        	/* wetness coefficients array		     */
    float *brsoil,		/* mean bright soil array		     */
    float *dksoil,		/* mean dark soil array  		     */
    float *grnveg,		/* mean green vegetation array		     */
    float *dryveg		/* mean dry vegetation array		     */
);

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block            */
    char taein[][CMLEN], 	/* pointer to input TAE file descriptor      */
    char hosin[][CMLEN], 	/* pointer to input host file descriptor     */
    char taeout[][CMLEN],		/* TAE file name of output image             */
    char hosout[][CMLEN],		/* host file name of output image            */
    long *nmrimg,		/* number of input images                    */
    long (*window)[4],		/* window specifications for each input image*/
    long (*bands)[MAXBND+1],	/* band specifications for each input image  */
    long nbands[],		/* number of bands per input image	     */
    long *totbnd,		/* total number of bands to be processed     */
    long *msgtim,		/* elapsed time between display messages     */
    char *minmax,		/* min max flag buffer			     */
    long *term,			/* flag for output to terminal 		     */
    long *fyle,			/* flag for output to file		     */
    long *lnpr,			/* flag for output to line printer	     */
    char *filnm,			/* output filename for FILE option           */
    char *outfil, 		/* pointer to output host file name          */
    char *sub,   		/* type of processing			     */
    long *brght, 		/* generate brightness band		     */
    long *grn,			/* generate greenness band		     */
    long *wt,			/* generate wetness band		     */
    float bright[],		/* brightness coefficients array	     */
    float green[],		/* greenness coefficients array		     */
    float wet[],			/* wetness coefficients array		     */
    float brsoil[],		/* mean bright soil array		     */
    float dksoil[],		/* mean dark soil array			     */
    float grnveg[],		/* mean green vegatation array  	     */
    float dryveg[],		/* mean dry vegatation array		     */
    long *odtype		/* output data type			     */
);

void tassel
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin[][CMLEN],		/* host names of input images		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long (*window)[4],		/* window specification of input images      */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    long totbnd,			/* total number of bands to be processed     */
    long odtype,			/* output data type			     */
    float *bright,		/* brightness coefficients array             */
    float *green,		/* greenness coefficients array		     */
    float *wet,			/* wetness coefficients array		     */
    long brght,			/* brightness band generation		     */
    long grn,			/* greenness band generation		     */
    long wt			/* wetness band generation		     */
);

#endif

