#ifndef TESTGEN_H
#define TESTGEN_H

/* gausian.c */
void gausian
(
  struct PARBLK *vblock,       /* TAE parameter block */
  char *hosout,                /* Host name of output image */
  long nl,                     /* Number of lines for output image */
  long ns,                     /* Number of samples for output image */
  long bands,                  /* Bands to be processed for all images */
  long odtype,                 /* Data type of output image */
  float meanval,               /* Mean pixel value for gausian image */
  float sigma,                 /* Standard dev. for gausian image */
  long seedval,                /* Seed value for random # generation */
  long msgtim,                 /* Time between display messages */
  char *minmax,                /* Min/Max flag */
  long dflag                   /* DDR update option */
);

/* getpar.c */
void getpar
(
  struct PARBLK *vblock,          /* Pointer to TAE param. block */
  long *msgtim,                   /* Time between display messages */
  char *taeout,                   /* TAE output file name */
  char *hosout,                   /* Host output file name */
  long *nl,                       /* Number of lines in output image */
  long *ns,                       /* Number of samples in output image */
  char *minmax,                   /* Min/Max flag buffer */
  long *dflag,                    /* DDR update option */
  long *bands,                    /* Band spec. for image */
  float pixval[],                 /* Pixel values for uniform image */
  float *maxval,                  /* Maximum pixel value */
  float *minval,                  /* Minimum pixel value */
  long *seedval,                  /* Seed value */
  float *meanval,                 /* Mean value */
  float *stddev,                  /* Standard deviation */
  char *weddir,                   /* Direction of the wedge */
  float *ltgrey,                  /* Left of upper grey value */
  float *rbgrey,                  /* Right or bottom grey value */
  long *nlevels,                  /* Number of levels */
  char *method,                   /* Method of use */
  long *odtype                    /* Output data type */
);

/* randgen.c */
void randgen
(
  struct PARBLK *vblock,        /* TAE parameter block */
  char *hosout,                 /* Host name of output image */
  long nl,                      /* Number of lines for output image */
  long ns,                      /* Number of samples for output image */
  long bands,                   /* Bands to process for all images */
  long odtype,                  /* Data type of output image */
  float maxpix,                 /* Maximum pixel value for random image */
  float minpix,                 /* Minimum pixel value for random image */
  long *seedval,                /* Seed for random image generation */
  long msgtim,                  /* Time between display messages */
  char *minmax,                 /* Min/Max flag */
  long dflag                    /* DDR flag option */
);

/* testgen.c */
void main
(
  void
);

/* uniform.c */
void uniform
(
  struct PARBLK *vblock,           /* TAE parameter block */
  char *hosout,                    /* Host output image name */
  long nl,                         /* Number of lines for output image */
  long ns,                         /* Number of samples for output image */
  long bands,                      /* Bands to be processed for all images */
  long odtype,                     /* Output image data type */
  float (pixval)[256],             /* Array of up to 256 uniform values */
  long msgtim,                     /* Time betweeen display messages */
  char *minmax,                    /* Min/Max flag */
  long dflag                       /* DDR flag option */
);

/* wedge.c */
void wedge
(
  struct PARBLK *vblock,          /* TAE parameter block */
  char *hosout,                   /* Host output image name */
  long nl,                        /* Number of lines for output image */
  long ns,                        /* Number of samples for output image */
  long bands,                     /* Bands to be processed */
  long odtype,                    /* Data type of output image */
  char *direct,                   /* Direction of wedge */
  float ltgrey,                   /* Grey level for left or top of wege */
  float rbgrey,                   /* Grey level for right or bottom of wedge */
  long nlevel,                    /* Number of grey levels in wedge */
  long msgtim,                    /* Time between display messages */
  char *minmax,                   /* Min/Max flag */
  long dflag                      /* DDR flag option */
);

#endif
