#ifndef PROTOS_H
#define PROTOS_H

void filspec
(
    char hosin[][CMLEN],      /* I: input image host names             */
    char hosout[],            /* I: output image host name             */
    long *num_inimages,       /* I: number of input images             */
    long num_image_bands[],   /* I: number of bands in each input image*/
    long image_band_num[][MAXBND + 1], /* I: band numbers in each      */
    long *num_inbands,	      /* I: total number of input image bands  */
    long wind[][4],           /* I: input image windows                */
    long *nlout,	      /* I: output no. lines                   */ 
    long *nsout		      /* I: output no. samples per line        */
);

void getpar
(
    char hosin[][CMLEN],      /* O: input image host names            */
    char lasout[CMLEN],       /* O: output image las name             */
    char hosout[CMLEN],       /* O: output image host name            */
    long *num_inimages,       /* O: number of input images            */
    long num_image_bands[],   /* O: num of bands in each input image  */
    long image_band_num[][MAXBND + 1], /* O: band numbers in each     */
    long *num_inbands,        /* O: total number of input image bands */
    long wind[][4],           /* O: input image windows               */
    long *stepns,             /* O: sample step size		      */
    long *stepnl,             /* O: line step size		      */
    long *angle,              /* O: orientation angle		      */
    long *dist,               /* O: distance between cooccurences     */
    long *wns,                /* O: no. samples/line in kernel	      */
    long *wnl,                /* O: no. lines in kernel 	      */
    long *funct,	      /* O: texture function		      */
    long *nlout,              /* O: output no. lines		      */
    long *nsout,              /* O: output no. samples per line       */
    long print[],             /* O: print option		      */
    char print_file[]         /* O: output print file		      */
);

void inzertion
(
    long buf[], 	/* I/O: input array		*/
    long code, 		/* I: value holder		*/
    long n		/* I: array dimension   	*/
);

void print_stats
(
    long band,			/* I: band number                     */
    long nlout,			/* I: output no. lines		      */
    long nsout,			/* I: output no. samples per line     */
    double z[],			/* I: texture statistics              */
    long nbands,                /* I: number of bands                 */
    long print[],		/* I: print option		      */
    long fnl,			/* I: number of lines in kernel       */
    long fns,			/* I: number of samples/line in kernel*/
    long stepnl,		/* I: line step size		      */
    long stepns,		/* I: sample step size		      */
    long funct,			/* I: texture function		      */
    int angle,			/* I: orientation angle               */
    int distance,		/* I: distance between cooccurences   */
    long lo_reset,		/* I: no. of low corr values          */
    long hi_reset		/* I: no. of highcorr values          */
);

void textsub
(
    char hosin[][CMLEN],   	/* I: input images host names         */
    char lasout[],         	/* I: output image LAS name           */
    char hosout[],         	/* I: output image host name          */
    long *num_images,           /* I: number of input images          */
    long num_image_bands[],	/* I: num of bands in each input image*/
    long image_band_num[][MAXBND + 1],/* I: num of bands in each input image*/
    long *nbands,               /* I: number of bands                 */
    long stepnl,		/* I: line step size		      */
    long stepns,		/* I: sample step size		      */
    long funct,			/* I: texture function		      */
    long angle,			/* I: orientation angle		      */
    long fnl,			/* I: number of lines in kernel       */
    long fns,			/* I: num of samples/line in kernel   */
    long nl,			/* I: num of lines in input image     */
    long ns,			/* I: num of samples/line in input image */
    long *nlout,		/* I: output no. lines		      */
    long nsout,			/* I: output no. samples per line     */
    long distance,		/* I: distance between cooccurences   */
    long print[],		/* I: print option		      */
    char print_file[]		/* I: output print file		      */
);
#endif
