/******************************************************************************
NAME: PTSORT

PURPOSE: PTSORT sorts N elements of three arrays, rearranging based 
         upon the KEYARR using the shell sort.

PROGRAM HISTORY:
VERSION DATE    AUTHOR                REASON
------- ----    ------                ------
1.0     5/86    D. Steinwand          Initial development
2.0     5/90    W. Xia                Conversion to C
******************************************************************************/
#include "las.h"
#include "ticmark.h"

void ptsort
(
    long *n,                   /* I: Number of elements */
    long *keyarr,              /* I/O: Key array to sort on */
    long *arr1,                /* I/O: Array to rearrange */
    long *arr2                 /* I/O: Array to rearrange */
)
{
    long     gap,i,j;       /* shell sort variables and counters */

    /*
       Sort N values in KEYARR.  Also rearrange data in ARR1 and AAR2
       to correspond to the swaps made in KEYARR.  Sorting is done
       using the Shell sort.
     */

    for(gap = *n/2; gap > 0; gap /= 2)
        for(i = gap; i < *n; i++)
            for(j = i-gap; j >= 0 && *(keyarr + j) > *(keyarr+j+gap); j -= gap)
            {
                swap((keyarr + j),(keyarr + j + gap));
                swap((arr1 + j),(arr1 + j + gap));
                swap((arr2 + j),(arr2 + j + gap));
            }
}
