#ifndef PROTOS_H
#define PROTOS_H

int getpar
(
    struct PARBLK *vblk,		/* TAE variable block */
    char *tps_ref,			/* Reference tie point selection file */
    char *tps_search,		/* Search tie point selection file */
    char *outfile,			/* Output file name (host) */
    long *confirm,			/* Confirm flag:  TRUE or FALSE */
    long *mode			/* Processing mode: NOCORR or PRECORR */
);

int merge
(
    char *ref,		/* Reference tie point selection file */
    char *sea,		/* Search tie point selection file */
    char *out,		/* Output tie point file */
    long file_type,		/* Type of output file */
    long confirm		/* Confirm flag:  TRUE or FALSE */
);

int do_merge
(
    struct PTDESC  *sea,			/* Pointer to file descriptor; sea TPS */
    struct PTDESC  *desc,			/* Pointer to file descriptor; output */
    long confirm,			/* Confirm flag (boolean) */
    long *num,			/* Number of tie points merged */
    long *not,			/* Number of tie points not merged */
    struct TPSDATA ref_data[],	/* Search TPS data records */
    int (*routine)(struct TPSDATA *, struct TPSDATA *, struct PTDESC *),		
                        /* Pointer to merge function */
    long maxtie			/* maximum tie points allocated	*/
);

int to_tpl_data
(
    struct TPSDATA *ref,		/* Reference tie point record */
    struct TPSDATA *search,		/* Search tie point record */
    struct PTDESC  *desc    	/* Pointer to file descriptor */
);

int to_mtp_data
(
    struct TPSDATA *ref,		/* Reference tie point record */
    struct TPSDATA *search,		/* Search tie point record */
    struct PTDESC  *desc		/* Pointer to file descriptor */
);

void to_mtp_header
(
    struct TPSHEAD *ref,		/* Reference tie point header record */
    struct TPSHEAD *search,		/* Search tie point header record */
    struct MTPHEAD *merged		/* Merged tie point header record */
);

void to_tpl_header
(
    struct TPSHEAD *ref,		/* Reference tie point header record */
    struct TPSHEAD *search,		/* Search tie point header record */
    struct TPLHEAD *loc		/* Tie point location header record */
);

int find_ref_rec
(
    char *pt_id,		/* Tie point identifier field */
    struct TPSDATA reference[],/* Referrence tie point selection data records */
    long maxtie
);

int get_confirm
(
    char *pt_id		/* Tie point identifier field */
);

void tabort
(
    long status			/* Error condition flag */
);

#endif

