#include <math.h>
#include "tiepts.h"
#include "adrgsup.h"

/*******************************************************************************
Purpose:
    This routine converts an lat/lon to pixel coordinates.
    This conversion process is documented in the ADRG manual.
 
By J. Hemmer, USGS/EROS Data Center, 9/92
 
Algorithm Description:
*******************************************************************************/
void adrg_ll2pix
(
    int *l,
    int *s,                     /* return values                */
    double lat,
    double lon,         /* coordinate of interest       */
    double lat_0,
    double lon_0,               /* image corner coordinates     */
    int bs,
    int asc             /* conversion parameters        */
)
{
   double       rbs, rasc;              /* double precision representations */
 
   rbs = (double)bs;
   rasc = (double)asc;
 
   /* 
    * round (documented in ADRG manual) and add 1 because manual's 
    * row/column coords are 0-relative 
    */
   *l = (int)((lat_0 - lat)*(rbs/360.0)) + 1;
   *s = (int)((lon - lon_0)*(rasc/360.0)) + 1;
}
 

