typedef struct 
   {
   String mode;

/* IM2MAP resources */
   String im2map_entry_mode;
   String digitizer_port;
   String default_map_datum;
   Boolean datum_required;

/* IM2VECT resources */
   String vector_source;
   String vector_location;

/* general resources */
   String zoom_method;
   int    zoom_factor;
   int    order;
   int    fullres_window_size;
   int    zoom_window_size;
   int    refoff;
   int    srchoff;
   Boolean elev_required;
   String cursor_color;
   } TieAppres;


static XtResource resources[] = 
   {
    {"mode","Mode",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,mode),XtRString,""},
    {"im2mapEntryMode","Im2mapEntryMode",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,im2map_entry_mode),XtRString,"Digitizer"},
    {"digitizerPort","DigitizerPort",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,digitizer_port),XtRString,"/dev/tty00"},
    {"defaultMapDatum","DefaultMapDatum",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,default_map_datum),XtRString,""},
    {"datumRequired","DatumRequired",XtRBoolean,sizeof(Boolean),
      XtOffsetOf(TieAppres,datum_required),XtRImmediate,(XtPointer)True},
    {"vectorSource","VectorSource",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,vector_source),XtRString,"DLG"},
    {"vectorLocation","VectorLocation",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,vector_location),XtRString,""},
    {"zoomMethod","ZoomMethod",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,zoom_method),XtRString,"CC"},
    {"zoomFactor","ZoomFactor",XtRInt,sizeof(int),
      XtOffsetOf(TieAppres,zoom_factor),XtRImmediate,(XtPointer)4},
    {"order","Order",XtRInt,sizeof(int),
      XtOffsetOf(TieAppres,order),XtRImmediate,(XtPointer)1},
    {"fullresWindowSize","FullresWindowSize",XtRInt,sizeof(int),
      XtOffsetOf(TieAppres,fullres_window_size),XtRImmediate,(XtPointer)0},
    {"zoomWindowSize","ZoomWindowSize",XtRInt,sizeof(int),
      XtOffsetOf(TieAppres,zoom_window_size),XtRImmediate,(XtPointer)64},
    {"refOffset","RefOffset",XtRInt,sizeof(int),
      XtOffsetOf(TieAppres,refoff),XtRImmediate,(XtPointer)64},
    {"srchOffset","SrchOffset",XtRInt,sizeof(int),
      XtOffsetOf(TieAppres,srchoff),XtRImmediate,(XtPointer)16},
    {"elevRequired","ElevRequired",XtRBoolean,sizeof(Boolean),
      XtOffsetOf(TieAppres,elev_required),XtRImmediate,(XtPointer)False},
    {"cursorColor","CursorColor",XtRString,sizeof(String),
      XtOffsetOf(TieAppres,cursor_color),XtRString,"green"}
   };

