#ifndef CONVERT_H
#define CONVERT_H


int check_ddr
(
    struct DDR *img_ddr              /* Image DDR to check     */
);

void conv_ls
(
  char *ctyp,
  int  idx
);

int degrees2image
(
   double pts[],                /* points to convert                    */
   int    npts,                 /* number of points to convert          */
   int    imgidx                /* REFERENCE or SEARCH                  */
);

int degrees2vect
(
   double pts[],                /* points to convert                    */
   int    npts,                 /* number of points to convert          */
   int    fnum                  /* file number selected (first, second  */
);

void full2over
(
   Widget w,            /* overview widget ID                   */
   int fullx,           /* fullres window x coordinate          */
   int fully,           /* fullres window y coordinate          */
   int *x,              /* overview window x coordinate         */
   int *y               /* overwiew window y coordinate         */
);

void full2zoom
(
    double xsub,                /* X location of input point (subpixel
                                   accuracy) (I)                              */
    double ysub,                /* Y location of input point (subpixel
                                   accuracy) (I)                              */
    int    *xcursor,            /* Zero relative X position in window. (O)    */
    int    *ycursor,            /* Zero relative Y position in window. (O)    */
    int    fsl,                 /* Starting line (file coordinate) of the image
                                   the coordinate is being calculated for (I) */
    int    fss                  /* Starting sample (file coordinate) of the 
                                   image the coordinate is being calculated 
                                   for (I)                                    */
);

void getlinesamp
(
   Widget w,            /* source widget id                     */
   int srcx, 
   int srcy,            /* source x and y coordinates           */
   int *samp,           /* sample                               */
   int *line            /* line                                 */
);

void getxy
(
   Widget w,            /* source widget id                     */
   int samp,            /* source sample                        */
   int line,            /* source line                          */
   int *x,              /* destination x coordinate             */
   int *y               /* destination y coordinate             */
);

void image2proj
(
   int    imgindex,         /* SEARCH or REFERENCE                        */
   double pt[],             /* array for projection values                */
   double x, 
   double y                 /* input line/sample values                   */
);

int image2vect
(
   double pts[],                /* points to convert                    */
   int    npts,                 /* number of points to convert          */
   int    fnum                  /* file number selected (first, second  */
);

int map_proj2degrees
(
   double pts[],                /* points to convert                    */
   int    npts,                 /* number of points to convert          */
   char   *file_key             /* proj file name and projection key    */
);

int proj2degrees
(
   double pts[],            /* points to convert                        */
   int    npts,                 /* number of points to convert          */
   int    imgindex              /* REFERENCE or SEARCH                  */ 
);

void proj2image
(
   int    imgindex,       /* SEARCH or REFERENCE                        */
   double pt[],           /* array for projection values                */
   double x, 
   double y               /* input line/sample values                   */
);

int proj2proj
(
   struct DDR *in_ddr,          /* Reference image DDR (not used if I2M) (I) */ 
   struct DDR *out_ddr,         /* Search image DDR (I) */
   double     pts[],            /* points to convert                    */
   int        npts              /* number of points to convert          */
);

void ref2srch
(
   double   refx,       /* reference coordinates                    */
   double   refy,       /* reference coordinates                    */
   double  *srchx,      /* search coordinates                       */
   double  *srchy       /* search coordinates                       */
);

void vect2full
(
   double vx,           /* vector coordinates (i)               */
   double vy,
   double *fx,          /* fullers window coordinates (o)       */
   double *fy
);

int vect2image
(
   double pts[],                /* points to convert                    */
   int    npts,                 /* number of points to convert          */
   int    fnum                  /* file number selected (first, second  */
);

void vect2zoom
(
   double vx,           /* vector coordinate            */
   double vy,
   double *x,           /* zoom coordinates (output)    */
   double *y
);

int vect2vect
(
   double pts[],                /* points to convert                    */
   int    npts,                 /* number of points to convert          */
   int    fnum                  /* file number selected (first, second  */
);

#endif
