/*
 *  This is the creation routine for the vector attributes.  
 *
 *  Modified by T Rockvam, USGS/EROS Data Center, 3/94.
 *    - Added color & dash parameters to save them if they were previously
 *      changed
 */
#include "tiepts.h"
#include "protos.h"
#include "cr.h"

void Createattrib_form
(
   Widget       attrib_form,            /* form to create               */
   char         *desc,                  /* description of attribute     */
   int          attribnum,              /* index of attribute           */
   long         color,                  /* color of attribute           */
   long         dash                    /* dash pattern of attribute    */
)
{
   Arg          args[512];              /* widget resource arguments    */
   int          argcnt;                 /* widget argument counter      */
   XmString     xmstr[1];               /* Motif compound strings       */
   Widget attribute_desc;               /* attribite description widget */
   Widget attribute_color;              /* attribute color widget       */
   Widget attribute_enable;             /* attribute enabled widget     */
   Widget attribute_line;               /* attribute dash style widget  */

  /*
   *  *** attribute description
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                desc,
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize,    False); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,    XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,            (int)260); argcnt++;
   attribute_desc = XtCreateWidget("desc",
                xmLabelWidgetClass,
                attrib_form,
                args,
                argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(attribute_desc);

  /*
   *  *** attribute color
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Color",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNforeground,
         /* COLOR(Shell_Vector, wk_colors[GREEN_COL])); argcnt++; */
            COLOR(Shell_Vector, wk_colors[color])); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize,    False); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,    XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightOffset,      (int)120); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,            (int)70); argcnt++;
   attribute_color = XtCreateWidget("attribute_color",
                xmPushButtonWidgetClass,
                attrib_form,
                args,
                argcnt);

   XmStringFree( xmstr[0] );
   XtAddCallback(attribute_color, XmNactivateCallback,
              vector_attribute_color, (caddr_t)attribnum);
   XtManageChild(attribute_color);

  /*
   *  *** attribute line style
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNrecomputeSize,    False); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,    XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightOffset,      (int)50); argcnt++;
   XtSetArg(args[argcnt], XmNpushButtonEnabled,True); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,            (int)70); argcnt++;
   attribute_line = XtCreateWidget("attribute_line",
                xmDrawnButtonWidgetClass,
                attrib_form,
                args,
                argcnt);

   XtAddCallback(attribute_line, XmNactivateCallback,
              vector_attribute_line, (caddr_t)attribnum);
   XtAddCallback(attribute_line, XmNexposeCallback,
           /* vector_line_expose, (caddr_t)dash_pattern[0]); */
              vector_line_expose, (caddr_t)dash_pattern[dash]);
   XtManageChild(attribute_line);

  /*
   *  *** attribute toggle
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "On",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize,    False); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,    XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightOffset,      (int)0); argcnt++;
   XtSetArg(args[argcnt], XmNpushButtonEnabled,True); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,            (int)50); argcnt++;
   attribute_enable = XtCreateWidget("attribute_line",
                xmPushButtonWidgetClass,
                attrib_form,
                args,
                argcnt);

   XmStringFree( xmstr[0] );
   XtAddCallback(attribute_enable, XmNactivateCallback,
              vector_attribute_enable, (caddr_t)attribnum);
   XtManageChild(attribute_enable);

}
