/*
 *  This is the creation routine for the parameter panel.  It was generated 
 *  using the ICS builderXcessory (BX).
 *
 *  By Jim Hemmer, USGS/EROS Data Center, 2/92.
 *    - Tie Point Selection, v1.0.
 *  Modified by J LaVergne, USGS/EROS Data Center, 7/93.
 *    - Changed to add a field that allows the user to specify whether or not
 *      the elevation values in the Accept/Reject panel will be required.
 *    - Changed 'Vector Data Source' to 'Vector Data Type' 
 *  Modified by J LaVergne, USGS/EROS Data Center, 10/93.
 *    - Changed the Color button to Cursor, since this button controls only
 *      the color of the cursor.
 *    - Changed 'CD Pathname' to 'Vector Data Path'
 *  Modified by T Rockvam, USGS/EROS Data Center, 3/94.
 *    - Changed sparkmode to an option menu; added datum requirement option
 *  Modified by C. Olsen, USGS/EROS Data Center, 8/98.
 *    - Added radio box for selecting the coordinate type(s) in IM2IM mode.
 *      (SRF #1935)
 *  Modified by C. Olsen, USGS/EROS Data Center, 9/98.
 *    - Added pulldown menu for selecting projection or lat/long in IM2VECT
 *      mode.  (SRF #1958)
 */
#include "tiepts.h"
#include "protos.h"
#include "cr.h"

Widget Createparm_form
(
   Widget parent
)
{
   Arg          args[512];
   int          argcnt;
   Widget       help;
   Widget       retval;
   XmString     xmstr[32];
   Widget       parm_form;
   Widget       parm_cd_label;
   Widget       parm_hseparator;
   Widget       parm_vseparator;
   Widget       parm_zoom_label;
   Widget       parm_ztype_shell;
   Widget       parm_ztype_pulldown;
   Widget       parm_zfact_label;
   Widget       parm_zup;
   Widget       parm_zdown;
   Widget       parm_fullres_shell;
   Widget       parm_fullres_pulldown;
   Widget       parm_fullres_label;
   Widget       parm_order_shell;
   Widget       parm_order_pulldown;
   Widget       parm_order_label;
   Widget       parm_refout_label;
   Widget       parm_srchout_label;
   Widget       parm_srchoff_label;
   Widget       parm_sparkmode_label;
   Widget       parm_refoff_label;
   Widget       parm_refoff_hlabel;
   Widget       parm_srchoff_hlabel;
   Widget       parm_refoff_vlabel;
   Widget       parm_soff_vlabel;
   Widget       parm_vsrc_shell;
   Widget       parm_vsrc_pulldown;
   Widget       parm_vsrc_label;
   Widget       parm_zsize_shell;
   Widget       parm_zsize_pulldown;
   Widget       parm_zsize_label;
   Widget       parm_epoint_shell;
   Widget       parm_epoint_pulldown;
   Widget       parm_epoint_label;
   Widget       parm_datum_shell;
   Widget       parm_datum_pulldown;
   Widget       parm_datum_label;
   Widget       parm_spark_shell;
   Widget       parm_spark_pulldown;
   Widget       parm_radiobox;

   XmRegisterConverters();

  /*
   *  *** Parameter panel bulletinboard
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNx, 0); argcnt++;
   XtSetArg(args[argcnt], XmNy, 0); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,  615); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 420); argcnt++;
   parm_form = XtCreateWidget("parm_form",
                xmFormWidgetClass,
                parent,
                args,
                argcnt);

    retval = parm_form;

   /*
    *  *** Reference Input TPS Button
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)5); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                " Ref Input TPS",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    parm_refin_button = XtCreateWidget("parm_refin_button",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );

    XtAddCallback(parm_refin_button, XmNactivateCallback, 
                  parm_tpsfile, REFERENCE);
    XtManageChild(parm_refin_button);

   /*
    *  *** Reference Input TPS Text 
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNrightPosition,   (short)49); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)35); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, (short)27); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    parm_refin_text = XtCreateWidget("parm_refin_text",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtAddCallback(parm_refin_text, XmNactivateCallback,
                  parm_tps_text, (caddr_t)0);
    XtManageChild(parm_refin_text);

   /*
    *  *** Search Input TPS button
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)72); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                " Search Input TPS",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 144); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    parm_srchin_button = XtCreateWidget("parm_srchin_button",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(parm_srchin_button, XmNactivateCallback, 
                  parm_tpsfile, (XtPointer)SEARCH);
    XtManageChild(parm_srchin_button);

   /*
    *  *** Search Input TPS text 
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNrightPosition,   (short)49); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)102); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, (short)27); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    parm_srchin_text = XtCreateWidget("parm_srchin_text",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtAddCallback(parm_srchin_text, XmNactivateCallback,
                  parm_tps_text, (caddr_t)0);
    XtManageChild(parm_srchin_text);

   /*
    *  *** Reference output TPS label
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition,   (short)51); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,   (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                " Ref Output TPS:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 168); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    parm_refout_label = XtCreateWidget("parm_refout_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(parm_refout_label);

   /*
    *  *** Reference output TPS text  
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition,   (short)51); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)35); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, (short)28); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    parm_refout_text = XtCreateWidget("parm_refout_text",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtAddCallback(parm_refout_text, XmNactivateCallback,
                  parm_tps_text, (caddr_t)0);
    XtManageChild(parm_refout_text);

   /*
    *  *** Search output TPS label 
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition,   (short)51); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)77); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Search Output TPS:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 144); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    parm_srchout_label = XtCreateWidget("parm_outtps_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(parm_srchout_label);

   /*
    *  *** Search output TPS text
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition,   (short)51); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,   (short)102); argcnt++;
    XtSetArg(args[argcnt], XmNcolumns, (short)28); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    parm_srchout_text = XtCreateWidget("parm_srchout_text",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtAddCallback(parm_srchout_text, XmNactivateCallback,
                  parm_tps_text, (caddr_t)0);
    XtManageChild(parm_srchout_text);

   /*
    *  *** vertical separator
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation,      XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,    XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset,     (short)60); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,        (short)10); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment,   XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition,     (short)50); argcnt++;
    XtSetArg(args[argcnt], XmNwidth,            10); argcnt++;
    parm_vseparator = XtCreateWidget("parm_vseparator",
                xmSeparatorWidgetClass,
                parm_form,
                args,
                argcnt);

    XtManageChild(parm_vseparator);

   /*
    *  *** horizontal separator
    */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftAttachment,    XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment,   XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset,        10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset,       10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset,      40); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 574); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 15); argcnt++;
    parm_hseparator = XtCreateWidget("parm_hseparator",
                xmSeparatorWidgetClass,
                parm_form,
                args,
                argcnt);

    XtManageChild(parm_hseparator);

   /*
    *  *** Select Cursor color
    */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Cursor",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNalignment,       XmALIGNMENT_CENTER); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      110); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,       325); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,           (int)100); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_curcolor_button = XtCreateWidget("parm_curcolor_button",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
 
   XmStringFree( xmstr[0] );
   XtAddCallback(parm_curcolor_button, XmNactivateCallback,
                 parm_cursor_color, (caddr_t)NULL);
   XtManageChild(parm_curcolor_button);

  /*
   *  *** least squares order option pulldown
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
   XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
   XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;

   parm_order_shell = XtCreatePopupShell("parm_order_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_order_shell);


   argcnt = 0;
   XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
   parm_order_pulldown = XtCreateWidget("parm_order_pulldown",
                xmRowColumnWidgetClass,
                parm_order_shell,
                args,
                argcnt);


  /*
   *  ***   first order
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "First",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_order_first = XtCreateWidget("parm_order_first",
               xmPushButtonWidgetClass,
               parm_order_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_order_first);

  /*
   *  ***  second order
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Second",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_order_second = XtCreateWidget("parm_order_second",
               xmPushButtonWidgetClass,
               parm_order_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_order_second);

  /*
   *  *** Least squares order option row column
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,  (short)200); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,   (short)320); argcnt++;
   XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNsubMenuId, parm_order_pulldown); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
   parm_order_option = XtCreateWidget("parm_order_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_order_option);
  /*
   *  *** Least Squares fit order label
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Order:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      210); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset,       300); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 80); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_order_label = XtCreateWidget("parm_order_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_order_label);

  /*
   *  *** Zoom factor down arrow
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      215); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       230); argcnt++;
   XtSetArg(args[argcnt], XmNarrowDirection, XmARROW_DOWN); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 25); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
   parm_zdown = XtCreateWidget("parm_zdown",
                xmArrowButtonWidgetClass,
                parm_form,
                args,
                argcnt);

   XtAddCallback(parm_zdown, XmNactivateCallback, parm_zoom_arrow, "DOWN");
   XtManageChild(parm_zdown);

  /*
   *  *** Zoom up arrow
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      215); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       205); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 25); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
   parm_zup = XtCreateWidget("parm_zup",
                xmArrowButtonWidgetClass,
                parm_form,
                args,
                argcnt);

   XtAddCallback(parm_zup, XmNactivateCallback, parm_zoom_arrow, "UP");
   XtManageChild(parm_zup);

  /*
   *  *** Zoom factor text item
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      245); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       210); argcnt++;
   XtSetArg(args[argcnt], XmNcolumns, (short)2); argcnt++;
   XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
   parm_zfactor = XtCreateWidget("parm_zfactor",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_zfactor);

  /*
   *  *** Zoom factor label
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Zoom Factor:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      200); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       180); argcnt++;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 130); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_zfact_label = XtCreateWidget("parm_zfact_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);

   XmStringFree( xmstr[0] );
   XtManageChild(parm_zfact_label);

  /*
   *  *** zoom option shell
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
   XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
   XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;

   parm_ztype_shell = XtCreatePopupShell("parm_ztype_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_ztype_shell);

   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
   parm_ztype_pulldown = XtCreateWidget("parm_ztype_pulldown",
                xmRowColumnWidgetClass,
                parm_ztype_shell,
                args,
                argcnt);
   XmStringFree( xmstr[0] );


  /*
   *  *** Nearest Neighbor zoom option 
   */ 
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Nearest Neighbor",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   parm_ztype_nn = XtCreateWidget("parm_ztype_nn",
                xmPushButtonWidgetClass,
                parm_ztype_pulldown,
                args,
                argcnt);
   XmStringFree( xmstr[0] );
   XtAddCallback(parm_ztype_nn, XmNactivateCallback,
              parm_zoom_type, (caddr_t)"NN");
   XtManageChild(parm_ztype_nn);

  /*
   *  *** Bilinear zoom option
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Bilinear",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   parm_ztype_bilinear = XtCreateWidget("parm_ztype_bilinear",
                xmPushButtonWidgetClass,
                parm_ztype_pulldown,
                args,
                argcnt);

   XmStringFree( xmstr[0] );
   XtAddCallback(parm_ztype_bilinear, XmNactivateCallback,
              parm_zoom_type, (caddr_t)"BI");
   XtManageChild(parm_ztype_bilinear);

  /*
   *  *** Cubic Convolution
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Cubic Convolution",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   parm_ztype_cc = XtCreateWidget("parm_ztype_cc",
                xmPushButtonWidgetClass,
                parm_ztype_pulldown,
                args,
                argcnt);
   XmStringFree( xmstr[0] );
   XtAddCallback(parm_ztype_cc, XmNactivateCallback,
              parm_zoom_type, (caddr_t)"CC");
   XtManageChild(parm_ztype_cc);

  /*
   *  *** Zoom method option row column
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,  (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,   (short)200); argcnt++;
   XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
   XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNsubMenuId, parm_ztype_pulldown); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
   parm_ztype_option = XtCreateWidget("parm_ztype_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_ztype_option);

  /*
   *  *** Zoom Method label
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Zoom Method:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      12); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       180); argcnt++;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_zoom_label = XtCreateWidget("parm_zoom_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);

   XmStringFree( xmstr[0] );
   XtManageChild(parm_zoom_label);

   if (tie.mode == IM2MAP)
      {
     /*----------------------- Mode ------------------------------*/
     /*
      *  *** point entry mode label
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Entry Mode:",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset, (int)235); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition, (int)51); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset, (int)15); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      parm_sparkmode_label = XtCreateWidget("parm_sparkmode_label",
                   xmLabelWidgetClass,
                   parm_form,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_sparkmode_label);
   
     /*
      *  *** Entry mode option menu
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
      XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
      XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;
      parm_spark_shell = XtCreatePopupShell("parm_spark_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);
      XtManageChild(parm_spark_shell);

      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
      parm_spark_pulldown = XtCreateWidget("parm_spark_pulldown",
                xmRowColumnWidgetClass,
                parm_spark_shell,
                args,
                argcnt);
      XmStringFree( xmstr[0] );

     /*
      *  *** digitizer option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Digitizer",
                   XmSTRING_DEFAULT_CHARSET)));           argcnt++;
      parm_spark_digit = XtCreateWidget("parm_spark_digit",
                   xmPushButtonWidgetClass,
                   parm_spark_pulldown,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );
      XtAddCallback(parm_spark_digit, XmNarmCallback, parm_spark_type, 
                       (caddr_t)"DIGIT");
      XtManageChild(parm_spark_digit);
   
     /*
      *  *** manual option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNset,          True);     argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Manual",
                    XmSTRING_DEFAULT_CHARSET))); argcnt++;
      parm_spark_manual = XtCreateWidget("parm_spark_manual",
                   xmPushButtonWidgetClass,
                   parm_spark_pulldown,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );
      XtAddCallback(parm_spark_manual, XmNarmCallback, parm_spark_type, 
                    (caddr_t)"MANUAL");
      XtManageChild(parm_spark_manual);

     /*
      *  *** Entry mode option row column
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,       260);           argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,    51); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset,      10);           argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
      XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNsubMenuId, parm_spark_pulldown); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
      parm_spark_option = XtCreateWidget("parm_spark_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

      XtManageChild(parm_spark_option);

     /*
      *  *** Datum label
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Datum:",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset, (int)235); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition, (int)70); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset, (int)10); argcnt++; 
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      parm_datum_label = XtCreateWidget("parm_datum_label",
                   xmLabelWidgetClass,
                   parm_form,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_datum_label);

     /*
      *  *** Datum required option menu
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
      XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
      XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;
      parm_datum_shell = XtCreatePopupShell("parm_datum_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);
      XtManageChild(parm_datum_shell);

      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
      parm_datum_pulldown = XtCreateWidget("parm_datum_pulldown",
                xmRowColumnWidgetClass,
                parm_datum_shell,
                args,
                argcnt);
      XmStringFree( xmstr[0] );

     /*
      *  ***   Required
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Required", XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      parm_datum_rec = XtCreateWidget("parm_datum_rec",
               xmPushButtonWidgetClass,
               parm_datum_pulldown,
               args,
               argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_datum_rec);

     /*
      *  ***   Not required 
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Not Required", XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      parm_datum_norec = XtCreateWidget("parm_datum_norec",
               xmPushButtonWidgetClass,
               parm_datum_pulldown,
               args,
               argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_datum_norec);

     /*
      *  *** Datum option row column
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,       260);           argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,    70); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
      XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNsubMenuId, parm_datum_pulldown); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
      parm_datum_option = XtCreateWidget("parm_datum_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

      XtManageChild(parm_datum_option);
   
     /*
      *  *** digitizer port text item
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,    51); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,       325); argcnt++;
      XtSetArg(args[argcnt], XmNcolumns, (short)27); argcnt++;
      XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
      parm_port_text = XtCreateWidget("parm_port_text",
                  xmTextWidgetClass,
                  parm_form,
                  args,
                  argcnt);
   
      XtManageChild(parm_port_text);

     /*
      *  *** digitizer portlabel
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Digitizer Port:",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,    51); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,       300); argcnt++;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      parm_port_label = XtCreateWidget("parm_port_label",
                   xmLabelWidgetClass,
                   parm_form,
                   args,
                   argcnt);
   
      XmStringFree( xmstr[0] );
      XtManageChild(parm_port_label);
      }
   else if (tie.mode == IM2VECT)
      {
     /*---------------- Output Coordinates ----------------------------*/
     /*
      *  *** output coordinates option shell
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
      XtSetArg(args[argcnt], XtNvisual, tie.visual_info[0].visual); argcnt++;
      XtSetArg(args[argcnt], XtNcolormap, tie.colormap); argcnt++;

      parm_oc_shell = XtCreatePopupShell("parm_oc_shell",
                   xmMenuShellWidgetClass,
                   parm_form,
                   args,
                   argcnt);

      XtManageChild(parm_oc_shell);

      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++; 
      XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      parm_oc_pulldown = XtCreateWidget("parm_oc_pulldown",
                 xmRowColumnWidgetClass,
                 parm_oc_shell,
                 args,
                 argcnt);
      XmStringFree( xmstr[0] );

     /*
      *  *** Projection option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Projection",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNsensitive,     True); argcnt++;
      parm_oc_proj = XtCreateWidget("parm_oc_proj",
                   xmPushButtonWidgetClass,
                   parm_oc_pulldown,
                   args,
                   argcnt);

      XmStringFree( xmstr[0] );
      XtManageChild(parm_oc_proj);

     /*
      *  *** Latitude/Longitude option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Latitude/Longitude",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      parm_oc_latlong = XtCreateWidget("parm_oc_latlong",
                   xmPushButtonWidgetClass,
                   parm_oc_pulldown,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_oc_latlong);

     /*
      *  *** Output Coordinate option row column
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,  XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNrightOffset,     (int)8); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,      (int)225); argcnt++;
      XtSetArg(args[argcnt], XmNwidth,          50); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,      0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginRight,     0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      XtSetArg(args[argcnt], XmNwidth,          90); argcnt++;
      XtSetArg(args[argcnt], XmNborderWidth,     0); argcnt++;
      XtSetArg(args[argcnt], XmNsubMenuId,      parm_oc_pulldown); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType,  XmMENU_OPTION); argcnt++;
      parm_oc_option = XtCreateWidget("parm_oc_option",
                   xmRowColumnWidgetClass,
                   parm_form,
                   args,
                   argcnt);
   
      XtManageChild(parm_oc_option);

     /*
      *  *** output coordinates label
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Output \nCoordinates:",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,  XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,   (int)53); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,      (int)225); argcnt++;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 180); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 40); argcnt++;
      parm_oc_label = XtCreateWidget("parm_oc_label",
                   xmLabelWidgetClass,
                   parm_form,
                   args,
                   argcnt);
   
      XmStringFree( xmstr[0] );
      XtManageChild(parm_oc_label);

     /*------------------ Data Source ---------------------------------*/
     /*
      *  *** data source option shell
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,   (short)0); argcnt++;
      XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
      XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;
   
      parm_vsrc_shell = XtCreatePopupShell("parm_vsrc_shell",
                   xmMenuShellWidgetClass,
                   parm_form,
                   args,
                   argcnt);
   
      XtManageChild(parm_vsrc_shell);
   
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,   (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER);argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
      parm_vsrc_pulldown = XtCreateWidget("parm_vsrc_pulldown",
                   xmRowColumnWidgetClass,
                   parm_vsrc_shell,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );

     /*
      *  *** DCW option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,   (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Digital Chart of World",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNsensitive,     True); argcnt++;
      parm_vsrc_dcw = XtCreateWidget("parm_vsrc_dcw",
                   xmPushButtonWidgetClass,
                   parm_vsrc_pulldown,
                   args,
                   argcnt);

      XmStringFree( xmstr[0] );
      XtManageChild(parm_vsrc_dcw);

     /*
      *  *** DLG data source option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,   (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Digital Line Graph",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      parm_vsrc_dlg = XtCreateWidget("parm_vsrc_dlg",
                   xmPushButtonWidgetClass,
                   parm_vsrc_pulldown,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_vsrc_dlg);
   
     /*
      *  *** WDB option
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,   (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "World Data Bank",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      parm_vsrc_wdb = XtCreateWidget("parm_vsrc_wdb",
                   xmPushButtonWidgetClass,
                   parm_vsrc_pulldown,
                   args,
                   argcnt);
   
      XmStringFree( xmstr[0] );
      XtManageChild(parm_vsrc_wdb);
   
     /*
      *  *** Data source option row column
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,  XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNrightOffset,    (int)8); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,      (int)270); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,       0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft,      0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginRight,     0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth,     0); argcnt++;
      XtSetArg(args[argcnt], XmNwidth,          90); argcnt++;
      XtSetArg(args[argcnt], XmNborderWidth,     0); argcnt++;
      XtSetArg(args[argcnt], XmNsubMenuId,      parm_vsrc_pulldown); argcnt++;
      XtSetArg(args[argcnt], XmNrowColumnType,  XmMENU_OPTION); argcnt++;
      parm_vsrc_option = XtCreateWidget("parm_vsrc_option",
                   xmRowColumnWidgetClass,
                   parm_form,
                   args,
                   argcnt);
   
      XtManageChild(parm_vsrc_option);

     /*
      *  *** vector data source label
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Vector \nData Type:",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginRight,  (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,  XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,   (int)53); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,      (int)270); argcnt++;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 180); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 40); argcnt++;
      parm_vsrc_label = XtCreateWidget("parm_vsrc_label",
                   xmLabelWidgetClass,
                   parm_form,
                   args,
                   argcnt);
   
      XmStringFree( xmstr[0] );
      XtManageChild(parm_vsrc_label);

     /*
      *  *** digitizer port text item
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,    51); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,       332); argcnt++;
      XtSetArg(args[argcnt], XmNrightAttachment,XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNrightOffset,  (short)10); argcnt++;
      XtSetArg(args[argcnt], XmNcolumns, (short)27); argcnt++;
      XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
      parm_cd_text = XtCreateWidget("parm_cd_text",
                  xmTextWidgetClass,
                  parm_form,
                  args,
                  argcnt);
 
      XtManageChild(parm_cd_text);

     /*
      *  *** data pathname
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Vector Data Path:",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition,    51); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset,  (short)10); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,       311); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 180); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
      parm_cd_label = XtCreateWidget("parm_cd_label",
                   xmLabelWidgetClass,
                   parm_form,
                   args,
                   argcnt);
 
      XmStringFree( xmstr[0] );
      XtManageChild(parm_cd_label);
      }
   else if (tie.mode == IM2IM)
      {
     /*
      *  *** Multiple Reference Images Toggle Button
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Multiple Reference Images",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftOffset,  (short)12); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset,   (short)140); argcnt++;
      XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginWidth, 4); argcnt++;
      XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
      parm_multiref_button = XtCreateWidget("parm_multiref_button",
                   xmToggleButtonWidgetClass,
                   parm_form,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );

      XtAddCallback(parm_multiref_button, XmNvalueChangedCallback, 
          parm_multiref, (caddr_t)0);
      XtManageChild(parm_multiref_button);

     /*------------------ Radio Box ---------------------------------*/
     /*
      *  *** Radio Box
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
      XtSetArg(args[argcnt], XmNradioAlwaysOne, False); argcnt++;  
      XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
      XtSetArg(args[argcnt], XmNshadowThickness, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 114); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 81); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset, 290); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition, (int)62); argcnt++;
      parm_radiobox = XtCreateWidget("parm_radiobox",
                   xmRowColumnWidgetClass,
                   parm_form,
                   args,
                   argcnt);

      XtManageChild(parm_radiobox); 

     /*
      *  *** Line/Sample toggle button
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Line/Sample",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
      XtSetArg(args[argcnt], XmNindicatorType, XmONE_OF_MANY); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset, 255); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition, (int)62); argcnt++; 
      XtSetArg(args[argcnt], XmNmarginRight, (int)46); argcnt++;  
      XtSetArg(args[argcnt], XmNmarginWidth, 6); argcnt++;  
      XtSetArg(args[argcnt], XmNset, True); argcnt++;
      parm_ls_button = XtCreateWidget("parm_ls_button",
                   xmToggleButtonWidgetClass,
                   parm_form,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );

      XtAddCallback(parm_ls_button, XmNvalueChangedCallback, parm_coord_type, 
        (caddr_t)"S");
      XtManageChild(parm_ls_button);

     /*
      *  *** Projection toggle button
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Projection",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNx, 3); argcnt++;
      XtSetArg(args[argcnt], XmNy, 3); argcnt++;
      parm_proj_button = XtCreateWidget("parm_proj_button",
                   xmToggleButtonWidgetClass,
                   parm_radiobox,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );

      XtAddCallback(parm_proj_button, XmNvalueChangedCallback, parm_coord_type, 
        (caddr_t)"P");
      XtManageChild(parm_proj_button);

     /*
      *  *** Latitude/Longitude toggle button
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                   "Latitude/Longitude",
                   XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNx, 3); argcnt++;
      XtSetArg(args[argcnt], XmNy, 29); argcnt++;
      parm_latlong_button = XtCreateWidget("parm_latlong_button",
                   xmToggleButtonWidgetClass,
                   parm_radiobox,
                   args,
                   argcnt);
      XmStringFree( xmstr[0] );

      XtAddCallback(parm_latlong_button, XmNvalueChangedCallback, 
        parm_coord_type, (caddr_t)"L");
      XtManageChild(parm_latlong_button);

     /*
      *  *** Output Coordinates label
      */
      argcnt = 0;
      XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
      XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                  "Output Coordinates:",
                  XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
      XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
      XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
      XtSetArg(args[argcnt], XmNleftPosition, (int)53); argcnt++;
      XtSetArg(args[argcnt], XmNtopOffset, 232); argcnt++;
      XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
      XtSetArg(args[argcnt], XmNwidth,  160); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
      parm_coord_label = XtCreateWidget("parm_coord_label",
                  xmLabelWidgetClass,
                  parm_form,
                  args,
                  argcnt);
      XmStringFree( xmstr[0] );
      XtManageChild(parm_coord_label);
      }

  /* 
   *  *** Cubic Convolution alpha value
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      250); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       265); argcnt++;
   XtSetArg(args[argcnt], XmNsensitive, False); argcnt++;
   XtSetArg(args[argcnt], XmNcolumns, (short)4); argcnt++;
   XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
   parm_alpha = XtCreateWidget("parm_alpha",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_alpha);

  /*
   *  *** zoom size option menu
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
   XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
   XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;

   parm_zsize_shell = XtCreatePopupShell("parm_zsize_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_zsize_shell);


   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
   parm_zsize_pulldown = XtCreateWidget("parm_zsize_pulldown",
                xmRowColumnWidgetClass,
                parm_zsize_shell,
                args,
                argcnt);
   XmStringFree( xmstr[0] );


  /*
   *  ***   64x64
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "64x64",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_zsize_64 = XtCreateWidget("parm_zsize_64",
               xmPushButtonWidgetClass,
               parm_zsize_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_zsize_64);

  /*
   *  ***  128x128 
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "128x128",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_zsize_128 = XtCreateWidget("parm_zsize_128",
               xmPushButtonWidgetClass,
               parm_zsize_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_zsize_128);

  /*
   *  *** Zoom window size option row column
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,  (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       260); argcnt++;
   XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
   XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNsubMenuId, parm_zsize_pulldown); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
   parm_zsize_option = XtCreateWidget("parm_zsize_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_zsize_option);

  /*
   *  *** Zoom window size label
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Zoom Size:",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      12); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       240); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,  80); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_zsize_label = XtCreateWidget("parm_zsize_label",
               xmLabelWidgetClass,
               parm_form,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_zsize_label);

   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Alpha:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      250); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       240); argcnt++;
   XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_alpha_label = XtCreateWidget("parm_alpha_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);

   XmStringFree( xmstr[0] );
   XtManageChild(parm_alpha_label);

  /*
   *  *** Elevation point option menu
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
   XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
   XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;

   parm_epoint_shell = XtCreatePopupShell("parm_epoint_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_epoint_shell);


   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
   parm_epoint_pulldown = XtCreateWidget("parm_epoint_pulldown",
                xmRowColumnWidgetClass,
                parm_epoint_shell,
                args,
                argcnt);
   XmStringFree( xmstr[0] );


  /*
   *  ***   Not required 
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Not Required",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_epoint_norec = XtCreateWidget("parm_epoint_norec",
               xmPushButtonWidgetClass,
               parm_epoint_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_epoint_norec);

  /*
   *  ***   Required
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Required",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_epoint_rec = XtCreateWidget("parm_epoint_rec",
               xmPushButtonWidgetClass,
               parm_epoint_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_epoint_rec);

  /*
   *  *** Elevation point option row column
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,  (short)100); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       260); argcnt++;
   XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 90); argcnt++;
   XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNsubMenuId, parm_epoint_pulldown); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
   parm_epoint_option = XtCreateWidget("parm_epoint_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_epoint_option);

  /*
   *  *** Elevation point label
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Elevations:",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      110); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       240); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_epoint_label = XtCreateWidget("parm_epoint_label",
               xmLabelWidgetClass,
               parm_form,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_epoint_label);

  /*
   *  *** full resolution option pulldown
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
   XtSetArg(args[argcnt],XtNvisual,tie.visual_info[0].visual); argcnt++;
   XtSetArg(args[argcnt],XtNcolormap,tie.colormap); argcnt++;

   parm_fullres_shell = XtCreatePopupShell("parm_fullres_shell",
                xmMenuShellWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_fullres_shell);


   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR("",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNentryAlignment, XmALIGNMENT_CENTER); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 68); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
   parm_fullres_pulldown = XtCreateWidget("parm_fullres_pulldown",
                xmRowColumnWidgetClass,
                parm_fullres_shell,
                args,
                argcnt);
   XmStringFree( xmstr[0] );


  /*
   *  ***   256x256
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "256x256",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_fullres_256 = XtCreateWidget("parm_fullres_256",
               xmPushButtonWidgetClass,
               parm_fullres_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_fullres_256);

  /*
   *  ***  512x512
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNmarginBottom, (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginTop,    (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "512x512",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_fullres_512 = XtCreateWidget("parm_fullres_512",
               xmPushButtonWidgetClass,
               parm_fullres_pulldown,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_fullres_512);

  /*
   *  *** Full resolution option row column
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR( "",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,  (short)0); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,   (short)320); argcnt++;
   XtSetArg(args[argcnt], XmNmarginLeft, 0); argcnt++;
   XtSetArg(args[argcnt], XmNmarginWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
   XtSetArg(args[argcnt], XmNsubMenuId, parm_fullres_pulldown); argcnt++;
   XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
   parm_fullres_option = XtCreateWidget("parm_fullres_option",
                xmRowColumnWidgetClass,
                parm_form,
                args,
                argcnt);

   XtManageChild(parm_fullres_option);

  /*
   *  *** Full resolution window label
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
               "Full Size:",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNtopAttachment,   XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      10); argcnt++;
   XtSetArg(args[argcnt], XmNtopOffset,       300); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   parm_fullres_label = XtCreateWidget("parm_fullres_label",
               xmLabelWidgetClass,
               parm_form,
               args,
               argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_fullres_label);

  /*---------------------------  Offsets  ----------------------------------*/
    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Vert:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)53); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)187); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    parm_refoff_vlabel = XtCreateWidget("parm_refoff_vlabel",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(parm_refoff_vlabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Horiz:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)75); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)160); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    parm_srchoff_hlabel = XtCreateWidget("parm_srchoff_hlabel",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );

    XtManageChild(parm_srchoff_hlabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Horiz:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)53); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)160); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    parm_refoff_hlabel = XtCreateWidget("parm_refoff_hlabel",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );

    XtManageChild(parm_refoff_hlabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Search Offsets",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)75); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)140); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
    parm_srchoff_label = XtCreateWidget("parm_srchoff_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );

    XtManageChild(parm_srchoff_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Ref Size",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)53); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)140); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 118); argcnt++;
    parm_refoff_label = XtCreateWidget("parm_refoff_label",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);
    XmStringFree( xmstr[0] );

    XtManageChild(parm_refoff_label);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNcolumns, (short)4); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 192); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)85); argcnt++;
    XtSetArg(args[argcnt], XmNheight, (int)30); argcnt++;
    parm_srchoff_vert = XtCreateWidget("parm_srchoff_vert",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtManageChild(parm_srchoff_vert);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNcolumns, (short)4); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 160); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)85); argcnt++;
    XtSetArg(args[argcnt], XmNheight, (int)30); argcnt++;
    parm_srchoff_horiz = XtCreateWidget("parm_srchoff_horiz",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtManageChild(parm_srchoff_horiz);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNcolumns, (short)4); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 192); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)62); argcnt++;
    XtSetArg(args[argcnt], XmNheight, (int)30); argcnt++;
    parm_refoff_vert = XtCreateWidget("parm_refoff_vert",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtManageChild(parm_refoff_vert);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNcolumns, (short)4); argcnt++;
    XtSetArg(args[argcnt], XmNrows, (short)1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment,  XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)62); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)160); argcnt++;
    XtSetArg(args[argcnt], XmNheight, (int)30); argcnt++;
    parm_refoff_horiz = XtCreateWidget("parm_refoff_horiz",
                xmTextWidgetClass,
                parm_form,
                args,
                argcnt);

    XtManageChild(parm_refoff_horiz);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNalignment, XmALIGNMENT_BEGINNING); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Vert:",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_POSITION); argcnt++;
    XtSetArg(args[argcnt], XmNleftPosition, (int)75); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, (int)187); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;

    parm_soff_vlabel = XtCreateWidget("parm_soff_vlabel",
                xmLabelWidgetClass,
                parm_form,
                args,
                argcnt);

    XmStringFree( xmstr[0] );
    XtManageChild(parm_soff_vlabel);

  /*------------------------- Bottom Buttons -------------------------------*/

  /*
   *  *** Accept button
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftOffset,      (short)10); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNbottomOffset,      (short)10); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Accept",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,  83); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 29); argcnt++;

   parm_accept = XtCreateWidget("parm_accept",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
   XmStringFree( xmstr[0] );

   XtAddCallback(parm_accept, XmNactivateCallback, 
              parm_destroy, (caddr_t)0);
   XtManageChild(parm_accept);

  /*
   *  *** Apply button
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNbottomAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
   XtSetArg(args[argcnt], XmNleftPosition,  (short)30); argcnt++;
   XtSetArg(args[argcnt], XmNbottomOffset,  (short)10); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Apply",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,  83); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 29); argcnt++;

   parm_apply = XtCreateWidget("parm_apply",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
   XmStringFree( xmstr[0] );

   XtAddCallback(parm_apply, XmNactivateCallback, 
              parm_destroy, (caddr_t)0);
   XtManageChild(parm_apply);

  /*
   *  *** Cancel button
   */
   argcnt = 0;
   XtSetArg(args[argcnt], XmNleftAttachment,  XmATTACH_POSITION); argcnt++;
   XtSetArg(args[argcnt], XmNleftPosition,  (short)60); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment,  XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNbottomOffset,      (short)10); argcnt++;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Cancel",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNwidth,  83); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 29); argcnt++;

   parm_cancel = XtCreateWidget("parm_cancel",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
   XmStringFree( xmstr[0] );
   XtManageChild(parm_cancel);
   XtAddCallback(parm_cancel, XmNactivateCallback, 
              parm_destroy, (caddr_t)0);

   argcnt = 0;
   XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
                "Help",
                XmSTRING_DEFAULT_CHARSET))); argcnt++;
   XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
   XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
   XtSetArg(args[argcnt], XmNrightOffset,   (int)10); argcnt++;
   XtSetArg(args[argcnt], XmNbottomOffset, (int)10); argcnt++;
   XtSetArg(args[argcnt], XmNwidth, 60); argcnt++;
   XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
   help =  XtCreateWidget("edit_help",
                xmPushButtonWidgetClass,
                parm_form,
                args,
                argcnt);
   XmStringFree( xmstr[0] );
 
   XtAddCallback(help, XmNactivateCallback, main_help, (caddr_t)"general.html#PARAMETERS");
   XtManageChild(help);

   return( retval );
}

