#include <stdio.h>
#include <sys/ioctl.h>
#ifdef sun
#include <sys/filio.h>
#endif
#include "tiepts.h"
#include "digsup.h"


#define   PACKET_SIZE   14

/*******************************************************************************
Purpose:
    This waits for input from the digitzer and returns the location and
    button index of the event.

By L. Huewe, USGS/EROS Data Center, 11/92
Modified by T.Rockvam 2/95.  Added a loop to avoid getting stuck in this
  routine if the digitizer gets out of sync.  Also waits for nremain-1
  bytes in order to make this work with a digitizer that sends either 13 or
  14 bytes.  

Algorithm Description:
*******************************************************************************/
void dig_spark
(
    XtPointer client,
    int       *portfd,
    XtInputId *id
)
{
   XEvent       xe;
   int          x;
   int          y;
   int          loop=0;
   int          nbytes;
   int          nremain;
   int          pending=0;
   unsigned     char puckbutton;
   unsigned     char buf[PACKET_SIZE];

  /*
   *   *** block waiting for data
   */
   nbytes = read(*portfd, &puckbutton, sizeof(unsigned char));
   if (nbytes == 0) return;

   pending = 0;
   nremain = PACKET_SIZE - nbytes;

  /*
   *  *** wait for remaining bytes to be queued
   */
   while (pending < (nremain-1))
      {
      ioctl(*portfd, FIONREAD, (char*)&pending);
      loop++;
      if (loop == 10) return;
      }

   read(*portfd, buf, pending);

  /*
   *  *** extract x and y coordinates
   */
   sscanf((char*)buf, "%d %d", &x, &y);

  /*
   *  *** send event as reference window button release
   */
   xe.type = ButtonRelease;
   xe.xbutton.window = XtWindow(ref_image_bulletinboard);
   xe.xbutton.display = tie.display;
   xe.xbutton.x = x;
   xe.xbutton.y = y;
   xe.xbutton.button = 1;
   XSendEvent(tie.display, XtWindow(ref_image_bulletinboard), 
                       True, ButtonReleaseMask, &xe);

}


