#include "tiepts.h"

/*******************************************************************************
Purpose:
    This routine deselects all line type for the given coverage.
    This is a callback routine for the 'None' button.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
void dlg_line_none
(
   Widget       w,
   caddr_t      client,
   caddr_t      call
)
{
   int          i;              /* loop counter                         */

  /*
   *  *** set each flag to false
   */
   i = 0;
   while (dlg_attrib[i].mincode != 0)
      dlg_attrib[i++].present = FALSE;

  /*
   *  *** remove line type selection panel
   */
   XtUnrealizeWidget(Shell_DLGlt);
   XtDestroyWidget(Dlglt_form);
   Dlglt_form = NULL;
   XtSetSensitive(dlg_feature_button, True);
}

/*******************************************************************************
Purpose:
    This identifies the user selected line types.
    This is a callback routine for the 'Accept' button.
 
By J. Hemmer, USGS/EROS Data Center, 2/92
 
Algorithm Description:
*******************************************************************************/
void dlg_line_accept
(
   Widget       w,
   caddr_t      client,
   caddr_t      call
)
{
   int          i,              /* loop counter                         */
                *selected,      /* list of indeces of selected type     */
                count;          /* number of selected type              */

  /*
   *  *** reset all selection flags
   */
   i = 0;
   while (dlg_attrib[i].mincode != 0)
      dlg_attrib[i++].present = FALSE;

  /*
   *  *** get selected types and set corresponding flag
   */
   if (XmListGetSelectedPos(dlg_lt_list, &selected, &count))
      {
      for (i = 0; i < count; i++)
         dlg_attrib[selected[i]-1].present = TRUE;

      XtFree((XtPointer)selected);
      }

  /*
   *  *** remove line type selection panel
   */
   XtUnrealizeWidget(Shell_DLGlt);
   XtDestroyWidget(Dlglt_form);
   Dlglt_form = NULL;
   XtSetSensitive(dlg_feature_button, True);
}

/*******************************************************************************
Purpose:
    This routine selects all line type of the given coverage.
    This is a callback routine for the 'ALL' button.
 
By J. Hemmer, USGS/EROS Data Center, 2/92
 
Algorithm Description:
*******************************************************************************/
void dlg_line_all
(
   Widget       w,
   caddr_t      client,
   caddr_t      call
)
{
   int          i;              /* loop counter                         */

  /*
   *  *** set all flags to TRUE
   */
   i = 0;
   while (dlg_attrib[i].mincode != 0)
      dlg_attrib[i++].present = TRUE;

  /*
   *  *** remove line type selection panel
   */
   XtUnrealizeWidget(Shell_DLGlt);
   XtDestroyWidget(Dlglt_form);
   Dlglt_form = NULL;
   XtSetSensitive(dlg_feature_button, True);
}
