/****************************************************************************
NAME:      map_sec2deg.c

PURPOSE:   Returns total degrees from input second values

PROGRAM HISTORY:

DATE   AUTHOR     REASON
----   ------     ------
05/01  D. Hames   Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
           Must be run under TAE

PROJECT:  LAS

*****************************************************************************/
#include "geompak.h"
#include "tiepts.h"
#include "mapsup.h"

double map_sec2deg
(
    const char *str,        /* I: String containing angle in seconds          */
    char *lat_or_long       /* I: Type of angle, either latitude or longitude */
)
{
    double angle;           /* Angle in total degrees (upon completion)       */

    if (strlen(str) == 0)
        return(0.0);

    angle =  atof(str);

    if (c_decdeg(&angle,"SEC",lat_or_long) != E_SUCC)
        return(0.0);

    return(angle);
}

/****************************************************************************
NAME:      map_min2deg.c

PURPOSE:   Returns total degrees from input minute values

PROGRAM HISTORY:

DATE   AUTHOR     REASON
----   ------     ------
05/01  D. Hames   Original Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
           Must be run under TAE

PROJECT:  LAS

*****************************************************************************/
double map_min2deg
(
    const char *str,        /* I: String containing angle in minutes          */
    char *lat_or_long       /* I: Type of angle, either latitude or longitude */
)
{
    double angle;           /* Angle in total degrees (upon completion)       */

    if (strlen(str) == 0)
        return(0.0);

    angle = atof(str);

    if (c_decdeg(&angle,"MIN",lat_or_long) != E_SUCC) 
        return(0.0);

    return(angle);
}

