#include "tiepts.h"
#include "mapsup.h"

/****************************************************************************
NAME:                           map_dms2deg

PURPOSE:   Returns total degrees from input deg, min, sec values

PROGRAM HISTORY:
VERSION  DATE   AUTHOR     CODE/CONT   REASON
-------  ----   ------     ---------   -----------------------------
  5.0    5/89   D. Steinwand  CSB      LAS 5.0 (original) Development
        10/93   J. LaVergne   CSB      Fixed an error - if input degree
                                       was less than zero, the sign got lost
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:   must be run under TAE

PROJECT:  LAS

ALGORITHM DESCRIPTION:
*****************************************************************************/
double map_dms2deg
(
    char *str
)
{
    int  deg;                   /* Degrees portion of angle */
    int  minute;                /* Minutes portion of angle */
    float sec;                  /* Seconds portion of angle */
    double angle;               /* Angle in total degrees (upon completion) */
    int  sign;                  /* Sign of angle */
    char buffer[100];           /* character buffer */

    if (strlen(str) == 0)
       return(0.0);

    strcpy(buffer, str);
    strcat(buffer, " 0 0 0");    /* make sure each value is defined */
    sscanf(buffer, "%d %d %f", &deg, &minute, &sec);

    sign = 1;
    if (strchr(str, '-') != NULL) sign = -1;
    deg = abs(deg);

    angle = deg + (minute/ 60.0) + (sec / 3600.0);
    angle *= sign;
    return(angle);
}
