#include <math.h>
#include "matsup.h"

void mat_rotate
(
    double matrix[3][3],
    double angle,
    double x,
    double y
)
{
   double       rotate[3][3];

   mat_identity(rotate);

  /*
   *  *** translate to fixed point
   */
   mat_translate(matrix, -x, -y);

   rotate[0][0] = rotate[1][1] = cos(angle);
   rotate[0][1] = sin(angle);
   rotate[1][0] = -sin(angle);

   mat_multiply(matrix, rotate);

  /*
   *  *** translate to original position
   */
   mat_translate(matrix, x, y);
}
