#include "tiepts.h"
#include "protos.h"

/*******************************************************************************
Purpose:
   This function parses the command line arguments.

By J. Hemmer, USGS/EROS Data Center, 2/92

Algorithm Description:
*******************************************************************************/
void parseargs
(
    int argc,
    char *argv[]
)
{
   int  i;

  /*
   *  *** examine each of the command line arguments
   */
   for (i = 1; i < argc; i++) 
      {
      if (argv[i][0] != '-')
         continue;
    
      switch(argv[i][1])
         {
        /*
         *  *** do not display logo flag
         */
         case 'l':
            tie.logo = FALSE;
            break;

        /*
         *  *** operation mode flag
         */
         case 'm':
            if (strncasecmp(argv[i]+2, "im", 2) == 0)
               tie.mode = IM2MAP;
            else if (strncasecmp(argv[i]+2, "ii", 2) == 0)
               tie.mode = IM2IM;
            else if (strncasecmp(argv[i]+2, "iv", 2) == 0)
               tie.mode = IM2VECT;
            else if (strncasecmp(argv[i]+2, "ia", 2) == 0)
               tie.mode = IM2ADRG;
            else if (strncasecmp(argv[i]+2, "search", 6) == 0)
               tie.mode = ONESRCH;
            break;

        /*
         *  *** placement flag 
         */
         case 'u':
            tie.userplace = TRUE;
            break;
  
         default:
            break;
         };
      }
}
