#ifndef PROTOS_H
#define PROTOS_H
#include "tiepts.h"

void cmap_adjust_data(void);

void cmap_component
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void adjust_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cmap_linear
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void adjust_map
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void align_select
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void align_trans_type
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void align_accept
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

int c_invert
(
    double incoef[6],    /* Transformation coefficients--input */
    double coef[6]       /* Inverted transformation coefficients */
);

int caution
(
   Widget parent,
   char *str
);

void response
(
   Widget w,
   int *answer,
   XmAnyCallbackStruct *cbs
);

void cursor_am
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_mark
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void cursor_setcolor
(
    int i
);

void cursor_select
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void cursor_create
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void cursor_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_latlong
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_mo
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_proj
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_unscaled
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_xyz
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void cursor_track
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void cursor_setup(void);

void cursor_expose
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void cursor_pointer
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void cursor_sub
(
    int  zoomidx,       /* Zoom window index.                         */
    int  xcursor,       /* Zero relative X position of crosshair (I). */
    int  ycursor,       /* Zero relative Y position of crosshair (I). */
    double *xsub,       /* X location of input point (subpixel accuracy) (O) */
    double *ysub,       /* Y location of input point (subpixel accuracy) (O) */
    int  skipl,         /* Line subsampling factor (I)                */
    int  skips,         /* Sample subsampling factor (I)              */
    int  fsl,           /* Starting line (file coordinate) of the image
                           the coordinate is being calculated for (I) */
    int  fss            /* Starting sample (file coordinate) of the 
                           image the coordinate is being calculated for (I) */
);

void dcw_line_none
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dcw_line_accept
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dcw_line_all
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dcw_status_none
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dcw_status_accept
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dcw_status_all
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dlg_line_none
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dlg_line_accept
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void dlg_line_all
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void edit_display
(
    int botflag /* flag to scroll to bottom of list           */
);

void edit_disable
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void edit_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void edit_delete
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void edit_reselect
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void edit_showstatus
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void edit_compute(void);

void ForceDialog
(
     Widget w
);

void fullres_create(void);

void fullres_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void fullres_size
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void fullres_update
(
   Widget       w,              /* Widget id of display bulletinboard         */
   int          *num_fullres,   /* number of fullres components               */
   struct TIE_FULLRES *tie_fullres, /* fullres structure for ref/search image */
   int  sl,                     /* Starting line of window to load.           */
   int  ss                      /* Starting sample of window to load.         */
);

void fullres_button
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

int fullres_within
(
    int x,
    int y
);

void fullres_setup(void);

void graphic_init(void);

void display_pt
(
    int  pt
);

void erase_pt
(
    int  pt,
    int  srchwin
);

void graphic_expose
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void graphic_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void graphic_setcolor
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void graphic_toggle
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void graphic_full_expose
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void graphic_zoom_expose
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);


void display_maps(void);

void display_mapoutline(void);

void display_vectoutline(void);

void erase_mapoutline(void);

void erase_vectoutline(void);

void graphic_refresh(void);

void display_zoomoutline
(
    int imgindex
);

void display_fulloutline
(
   Widget    w
);

void erase_fulloutline
(
   Widget    w
);

int layout_allocplanes(void);

void load_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void load_localcancel
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void load_localok
(
   Widget        w,
   XtPointer client_data,
   XtPointer call_data
);

int load_image
(
   Widget   client,     /* ID of image display bulletinboard          */
   char    *filename    /* Input specification.                       */
);

int load_display
(
   int  *rgbmem,        /* Memory planes to be loaded with image data (I). */
   int  *nplanes,       /* Number of planes loaded (I).               */
   Window imgwin,       /* Window ID for main image window (I).       */
   Widget shell,        /* Widget ID of image window shell (I).       */
   Widget win,          /* Widget ID of image window (I).             */
   int  *nl,            /* Number of lines to load (I).               */
   int  *ns,            /* Number of samples to load (I).             */
   int  *maxval,        /* Maximum image data value (I).              */
   unsigned char *rptr, /* Pointer to red image data (I).             */
   unsigned char *gptr, /* Pointer to green image data (I).           */
   unsigned char *bptr, /* Pointer to blue image data (I).            */
   int     cmflg,       /* Indicates whether or not color map should
                           be modified (I).                           */
   Pixmap *pixptr,      /* Pointer to pixmap which is contain the
                           loaded image data (I).                     */
   int  loadflg         /* Indicates whether this is being called from
                           the loadlas routine (I).                   */
);

int loadlas
(
    Widget  shell,          /* Widget ID for image shell                 */
    Widget  bulletinboard,  /* Widget ID for image display window (I).   */
    struct  TIE_MEMLAYOUT *mem, /* Memory layout for this image              */
    int         view,       /* Composite view index                          */
    int         loadflg     /* Indicates whether the image is being
                               loaded into the main image window (I).    */
);


int load_projinfo
(
    int  memory,        /* Memory plane for which projection infor-
                           mation is being read (I).                  */
    char *hostname      /* Host name of the LAS image to read DDR information 
                           from (I).                  */
);

void main_about
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_register
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_maplist
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_stats
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_align
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_vector
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_cursor
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_help
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_select
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void image_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_graphic
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_loop
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_load
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_adjust
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_edit
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_show
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void main_parm
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void help_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void about_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void help_reset(void);

void manual_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void manual_display
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void manual_spark
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void manual_coord
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void manual_traverse
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void manual_datum_show
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void manual_datum_select
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void maplist_init(void);

void maplist_define(void);

void maplist_free(void);

void maplist_name
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void maplist_select
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void maplist_catfile
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void maplist_cattext
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void maplist_mapfile
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void maplist_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

int maplist_info
(
   int  s,
   char *state,
   double *w, 
   double *h, 
   double *vx, 
   double *vy,
   int  *nx, 
   int  *ny
);

void maplist_round
(
   double       *coord
);

void mapfile_ok
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void mapfile_cancel
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void catfile_ok
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void catfile_cancel
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void maplist_setcolor
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void tie_message
(
  Widget parent,             /* Parent shell widget                     */
  char *str                  /* Message string                          */
);

void tie_msgcancel
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void tie_msgraise
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void mode_init
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_init(void);

void parm_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_zoom_type
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_zoom_arrow
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_cursor_color
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_setup(void);

void parm_spark_type
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_tps_text
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_tpsfile
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_tpsupdate
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_coord_type
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parm_multiref
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void parseargs
(
    int argc,
    char *argv[]
);

void QR
(
    double *A,          /* Matrix A (stored by columns) */
    int  m,             /* Number of rows in matrix A */
    int  n,             /* Number of columns in matrix A */
    double *v           /* Vector v */
);

void QR_solve
(
    double *A,          /* Matrix A (stored by columns) */
    int  m,             /* Number of rows in matrix A */
    int  n,             /* Number of columns in matrix A */
    double *v,          /* Vector v */
    double *b,          /* Vector b */
    int  iflag
);

void mapparm_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);


int mapparm_changed
(
    struct TIE_MAPPARMS parms   /* parameters from map file      */
);

void register_init(void);

void register_setup(void);

void register_maptype
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_scale
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_mapfile_button
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_datum_show
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_datum_select
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_mapid_button
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_mapid_ok
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_mapid_cancel
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_mapparm_text
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void get_map_rec
(
    char *mapfile,
   char *mapname,
   char *mapid
);

void register_map(void);

void register_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void register_point
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);


void register_resid
(
    double spark[][2],
    double mappts[][2]
);

void register_guesspt(void);

void init_rt(void);

void rough_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void select_refpt
(
    Widget w,                      /* Widget where action happend    */
    int  x,                        /* X coord of window              */
    int  y                         /* Y coord of window              */
);

void select_srchpt
(
    int  x,
    int  y
);

void show_apply
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void show_create
(
    int  image_idx      /* Plane index for given image                        */
);

void show_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void show_plane_select
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void show_component
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void stats_display
(
    int botflag /* flag to scroll to bottom of list           */
);

void stats_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void exit_tiepts
(
   int  sig
);

void tps_entry
(
    int imgindex                 /* SEARCH or REFERENCE                    */
);

Pixmap XPM_PIXMAP
(
    Widget       w,
    unsigned int width,
    unsigned int height,
    unsigned int ncolors,
    unsigned int cpp,
    char         **colors,
    char         **pixels
);

#ifndef IGNORE_COLOR
unsigned int  COLOR
(
    Widget w,
    char *name
);
#endif

#ifndef IGNORE_FONT
XmFontList FONT_LIST
(
    Widget      w,
    char        *name
);
#endif
#ifndef IGNORE_STRING_TABLE
#include <stdarg.h>

XmString* STRING_TABLE(int num_strings, ...);

void FREE_STRING_TABLE
(
    XmString *table
);

#endif

int parse_rb
(
    char *str,          /* String to be parsed. (I)                           */
    int  **range,       /* Range values specified. (O)                        */
    int  *rcount,       /* Number of range values specified. (O)              */
    int  **bin,         /* Bin values specified. (O)                          */
    int  *bcount        /* Number of bin values specified. (O)                */
);

int substr
(
    char string1[],     /* string for comparison    (I) */
    char string2[],     /* possible substring       (I) */
    int *pos            /* position of string2 in   (O) */
);

void vector_background_button
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_background_setcolor
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_blend(void);

void vector_blend_slider
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_displaypts(void);

void vector_drag
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void vector_expose
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

int vector_fileline
(
    int line
);

void vector_file_button
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_file_cancel
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_file_ok
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_file_all
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dlgbounds(void);

void vector_free(void);

int vector_isloaded
(
   char         *filename
);

void vector_line_expose
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_mark(void);

int vector_nnode
(
   Widget       w,
   int x, 
   int y,
   int *fnum,
   int *line,
   int *node
);

void vector_overlay
(
   Widget       w
);

void vector_redrawall(void);

void vector_redrawplane
(
    int plane
);

void vector_region
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void vector_scaletofit
(
   double       matrix[3][3]
);

void vector_setsource(void);

void vector_unmark(void);

void vector_unzoom
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_wdbattribs(void);

int vector_bounds(void);

void vector_setbounds(void);

void vector_tabover
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_wdbload
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_wdbupdate
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_zexpose
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void vector_zoom(void);

void vector_dlgupdate
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

int load_dlg_file
(
    char *filename          /* I: name of dlg file to load */
);

void update_dlg_display(void);

void vector_freeattrib(void);

void vector_dcwattrib(void);

void vector_dcwlib
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dcwlinestatus
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dcwlinetype
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dlglinetype
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dcwupdate
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dcwwrite
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dlgwrite
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_dlgattribs(void);

void vector_attribute_color
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_attribute_enable
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_attribute_line
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void vector_window
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

void verify_destroy
(
   Widget        w,
   XtPointer client,
   XtPointer call_data
);

void verify_display
(
    double rx,                   /* reference x coordinate                 */
    double ry,                   /* reference y coordinate                 */
    double sx,                   /* search x coordinate                  */
    double sy,                   /* search y coordinate                  */
    double oldx,                 /* old residual x coordinate              */
    double oldy,                 /* old residual u coordinate              */
    double old_rms,              /* old residual magnitude                 */
    double newx,                 /* new residual x coordinate              */
    double newy,                 /* new residual magnitude                 */
    double new_rms               /* new residual magnitude                 */
);

void display_coords
(
    Widget widget,
    char *tmpstr
);

void zoom_clear(void);

void zoom_dotcursor
(
   Widget       w
);

void zoom_findercursor(void);

void zoom_create(void);

void zoom_button
(
   Widget        w,
   XtPointer client,
   XEvent*   event,
   Boolean*  continue_to_dispatch
);

int zoom_init
(
    struct ENLARGE *zoom,    /* Enlargement parameters & buffers (I/O)   */
    int  view                /* image display view                          */
);

void zoom_image
(
    Widget parent,
    Widget w,
    int    dspwin[4]    /* Display window.                            */
);

void zoom_enlarge
(
    struct ENLARGE *zoom        /* Enlargement parameters & buffers (I/O) */
);

void horiz_zoom
(
    struct ENLARGE *zoom        /* Enlargement parameters & buffers (I/O) */
);

void vert_zoom
(
    struct ENLARGE *zoom        /* Enlargement parameters & buffers (I/O) */
);

Boolean TIE_StringToPixel
(
    Display     *dpy,
    XrmValue    *args,
    Cardinal    *num_args,
    XrmValue    *fromVal,
    XrmValue    *toVal,
    XtPointer   *converter_data
);

#endif
