#include "tiepts.h"
#include "cr.h"
#include "tpssup.h"
#include "protos.h"

/*******************************************************************************
NAME: TPS_ENTRY

PURPOSE: This routine displays a TPS output file entry box for definition of
         a search or reference output TPS filename.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            4/92    J.Hemmer        Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
void tps_entry
(
    int imgindex                 /* SEARCH or REFERENCE                    */
)
{
  Arg args[1];                  /* Variable used to set widget resourcees */
  XmString xmstr;               /* Motif string variable                  */
  char buf[256];                /* Pathname variabls                      */
  char ext[20];                 /* Extension string                       */
  char *extptr;                 /* Pointer to file extension              */
  char *image_name;             /* Pointer to image filename              */
  int index=0;                  /* Index of tps filename                  */

  tpsentry_dialog_form = Createfileentry_form(Shell_Main);

  if (imgindex == REFERENCE)
    {
    if (strcmp(tie_parms.outtps[REFERENCE], "") != 0)
      return;

    /* Generate unique TPS output filename
    --------------------------------------*/
    if ((image_name = strrchr(tie_load.image_name, '/')) == NULL)
      image_name = tie_load.image_name;
    else
      image_name++;

    do
      {
      index++;
      strcpy(buf, image_name);
      extptr = strrchr(buf, '.');
      sprintf(ext, "%d_ref.tps", index);

      if (extptr != NULL)
        strcpy(extptr, ext);
      else
        strcat(buf, ext);
      }
    while (!access(buf, 0));

    /* Set input TPS to previous version
    ------------------------------------*/
/***************************************************************************
    if ((index > 1) && (strcmp(tie_parms.intps[REFERENCE], "") == 0))
      {
      strcpy(tie_parms.intps[REFERENCE], image_name+1);
      extptr = strrchr(tie_parms.intps[REFERENCE], '.');
      sprintf(ext, "%d_ref.tps", index-1);
      if (extptr != NULL)
        strcpy(extptr, ext);
      else
        strcat(buf, ext);
      }
***************************************************************************/
   
    XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR(
             "Enter Reference Output TPS Filename:",
             XmSTRING_DEFAULT_CHARSET))); 
    XtSetValues(fileentry_label, args, 1);
    XmStringFree(xmstr);

    if (strcmp(tie_parms.outtps[REFERENCE], "") == 0)
      XmTextSetString(fileentry_text, buf);
    else
      XmTextSetString(fileentry_text, tie_parms.outtps[REFERENCE]);

    XtAddCallback(fileentry_text, XmNactivateCallback, tps_parmset,
                  (caddr_t)"REFOUT");
    XtAddCallback(fileentry_ok, XmNactivateCallback, tps_parmset,
                  (caddr_t)"REFOUT");
    }
  else if (imgindex == SEARCH)
    {
    if (strcmp(tie_parms.outtps[SEARCH], "") != 0)
      return;

    /* Generate unique TPS output filename
    --------------------------------------*/
    if ((image_name = strrchr(tie_load.image_name, '/')) == NULL)
      image_name = tie_load.image_name;
    else
      image_name++;

    do
      {
      index++;
      strcpy(buf, image_name);
      extptr = strrchr(buf, '.');
      sprintf(ext, "%d_srch.tps", index);

      if (extptr != NULL)
        strcpy(extptr, ext);
      else
        strcat(buf, ext);
      }
    while (!access(buf, 0));

    /* Set input TPS to previous version
    ------------------------------------*/
/****************************************************************************
    if ((index > 1) && (strcmp(tie_parms.intps[SEARCH], "") == 0))
      {
      strcpy(tie_parms.intps[SEARCH], image_name+1);
      extptr = strrchr(tie_parms.intps[SEARCH], '.');
      sprintf(ext, "%d_srch.tps", index-1);
      if (extptr != NULL)
        strcpy(extptr, ext);
      else
        strcat(tie_parms.intps[SEARCH], ext);
      }
****************************************************************************/
 
    XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR(
             "Enter Search Output TPS Filename:",
             XmSTRING_DEFAULT_CHARSET))); 
    XtSetValues(fileentry_label, args, 1);
    XmStringFree(xmstr);

    if (strcmp(tie_parms.outtps[SEARCH], "") == 0)
      XmTextSetString(fileentry_text, buf);
    else
      XmTextSetString(fileentry_text, tie_parms.outtps[SEARCH]);

    XtAddCallback(fileentry_text, XmNactivateCallback, tps_parmset,
                  (caddr_t)"SRCHOUT");
    XtAddCallback(fileentry_ok, XmNactivateCallback, tps_parmset,
                  (caddr_t)"SRCHOUT");
    }

  XtManageChild(tpsentry_dialog_form);
}
