#ifndef TPSSUP_H
#define TPSSUP_H

int tps_auto_rt
(
    struct DDR *ref_ddr,        /* Reference image DDR (not used if I2M) (I) */
    struct DDR *sea_ddr,        /* Search image DDR (I)                      */
    int  mode,                  /* Mode--I2I,I2M,I2V (I)                     */
    char *units,                /* Units of output I2M space (I)             */
    double ref_yx[4][2],        /* Reference space coordinates (O)           */
    double sea_yx[4][2]         /* Search image coordinates (O)              */
);

void tps_cancel
(
    Widget w,
    XtPointer client,
    XtPointer call
);

void tps_checkdatum (void);

int tps_checkid
(
    char *id
);

int tps_cpintps
(
    struct PTDESC **indesc,                /* Input TPS file descriptor    */
    char *hdrmode,                         /* Type of coords in file       */
    char *mesg,                            /* Error message(s) to show     */
    int  imgidx                            /* Image index (REF or SEARCH)  */
);

void tps_delete
(
    int pt                       /* Point id to delete           */
);

void tps_dump (void);

int tps_fileopen
(
    struct PTDESC **indesc,                /* Input TPS file descriptor     */
    struct TPSHEAD *hdr,                   /* TPS file header record struct */
    char *filename,                        /* Input file names              */
    char *mesg,                            /* Error message(s) to display   */
    int  imgidx                            /* Image index (REF or SEARCH)   */
);

int tps_loadimage
(
    Widget client,
    int index
);

void tps_mkname
(
    char *hdrname,           /* Name field of the header structure */
    char *filename,          /* Input file names                   */
    int  imgidx              /* Index of REFERENCE or SEARCH image */
);

void tps_ok
(
    Widget w,
    XtPointer client,
    XtPointer call
);

int tps_open
(
    char *units,               /* Projection units (I)                   */
    struct DDR *ref_ddr        /* Reference image's DDR (I)              */
);

void get_ddr
(
    struct TPSHEAD *hdr,                   /* Header structure           */
    struct DDR *ddr                       /* DDR structure              */
);

void geo_header
(
    struct TPSHEAD *hdr                /* Input header structure         */
);

void multi_ref
(
    struct TPSHEAD *hdr                 /* Header structure.            */
);

void tps_parmset
(
    Widget w,
    XtPointer client,
    XtPointer call
);

int tps_Qfit
(
    int  npts,                  /* Number of tie point pairs (I)              */
    double rpts[][2],           /* Reference points to fit                    */
    double spts[][2],           /* Search points to fit                       */
    unsigned char *disabled,    /* Flags denoting disabled points             */
    int  *degree,               /* Degree of poly fit                         */
    double *coef_l,             /* Coefficients mapping line coordinates (O)  */
    double *coef_s             /* Coefficients mapping sample coordinates(O) */
);

void tps_setheader
(
    char *units,
    struct TPSHEAD *hdr
);

void tps_update(void);

void tps_verify
(
    int  rt,               /* Whether selecting points for the rough
                              transformation (I)
                               RT_SEL - Selecting RT points.
                               RT_CAL - RT has been calculated using
                                        selected points.
                               RT_DDR - RT has been calculated using
                              points calculated from DDR information     */
    int  *numtie,          /* Total number of tie points selected (I/O)  */
    int  *seltie,          /* Number of tie points selected by the
                              user (I/O)                                 */
    double rtie[][2],      /* Reference tie points (subpixel accuracy -
                              line,sample) (I)                           */
    double stie[][2]       /* Search tie points (subpixel accuracy -
                              line,sample) (I)                           */
);


#endif
