/*******************************************************************************
NAME: TPS_CHECKID

PURPOSE: This routine checks the id extension of a point label.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            2/92    J.Hemmer        Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
#include "tiepts.h"
#include "tpssup.h"

int tps_checkid
(
    char *id
)
{
  int  i;                            /* Loop control variable      */
  long len;                          /* Length of a string         */
  char *buf;                         /* Holding characters         */

  len = PTIDLEN;
  /*******************
  c_up2low(id, &len);
  *******************/
  buf = rem_blanks(id, &len);

  for (i = 0; i < tie_select.numtie; i++)
    if (strcasecmp(tie_select.pt_id[i], buf) == 0) 
      {
      free(buf);
      return(FALSE);
      }

  free(buf);
  return(TRUE);
}
