/*******************************************************************************
NAME: TPS_DELETE

PURPOSE: This routine removes a point from the list of selected points.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            2/92    J.Hemmer        Initial Development
 2.0            8/98    C.Olsen         Modified to delete the crtie & cstie
                                        variables.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
#include "tiepts.h"
#include "tpssup.h"

void tps_delete
(
    int pt                       /* Point id to delete           */
)
{
  int i;                        /* Loop control variable        */
 
  for (i = pt+1; i < tie_select.numtie; i++)
    {
    tie_select.disabled[i-1] = tie_select.disabled[i];
    tie_select.elev[i-1] = tie_select.elev[i];
    tie_select.rtie[i-1][0] = tie_select.rtie[i][0];
    tie_select.rtie[i-1][1] = tie_select.rtie[i][1];
    tie_select.stie[i-1][0] = tie_select.stie[i][0];
    tie_select.stie[i-1][1] = tie_select.stie[i][1];
    strcpy(tie_select.pt_id[i-1], tie_select.pt_id[i]);
    if (tie.mode == IM2MAP)
      {
      strcpy(tie_select.mapname[i-1], tie_select.mapname[i]);
      strcpy(tie_select.mapid[i-1], tie_select.mapid[i]);
      }
    if (tie.mode == IM2IM)
      {
      tie_select.crtie[i-1][0] = tie_select.crtie[i][0];
      tie_select.crtie[i-1][1] = tie_select.crtie[i][1];
      tie_select.lsrtie[i-1][0] = tie_select.lsrtie[i][0];
      tie_select.lsrtie[i-1][1] = tie_select.lsrtie[i][1];
      }
    }

  tie_select.numtie--;
  tie_select.seltie--;
}
