/*******************************************************************************
NAME: TPS_LOAD

PURPOSE: This routine loads an image from the TPS header record.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            2/92    J.Hemmer        Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
#include "tiepts.h"
#include "alias.h"
#include "protos.h"
#include "tpssup.h"

int tps_loadimage
(
    Widget client,
    int index
)
{
  struct TPSHEAD header;         /* TPS file header record structure       */
  char outparm[CMLEN];           /* Output parm spec without aliases       */

  struct PTDESC *indesc;         /* TPS file descriptor                    */
  long ftype = TPS;              /* Type of tie point file                 */
  long inacc = IREAD;            /* Input file access mode                 */
   

  /* Open file and get filename
  -----------------------------*/
  c_ptopen(&indesc,tie_parms.intps[index],&ftype,&inacc,(long *) &header);
  c_ptclse(&indesc);
  c_getalias(header.name, outparm);

  /* If filename checks out, load it
  ----------------------------------*/
  if (strcmp(outparm, "") == 0)
    return(E_FAIL);
  else if ((index == REFERENCE) && 
           (strcmp(outparm, tie_planes[tie.rview].filename) == 0))
    return(E_SUCC);
  else if ((index == SEARCH) && 
           (strcmp(outparm, tie_planes[tie.sview].filename) == 0))
    return(E_SUCC);
  else
    {
    /* If 8 bit display, only load first band
    -----------------------------------------*/
    if (tie.visual_info[0].visual->class == PseudoColor)
      strcat(outparm, "(:1)");

    return (load_image(client, outparm));
    }
}
