/*******************************************************************************
NAME: TPS_MKNAME

PURPOSE: This routine constructs the filename that will be entered into the
         header record.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            3/99    T.Ratliff       Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
#include "tiepts.h"
#include "tpssup.h"

void tps_mkname
(
    char *hdrname,           /* Name field of the header structure */
    char *filename,          /* Input file names                   */
    int  imgidx              /* Index of REFERENCE or SEARCH image */
)
{
  int i;                  /* Loop counter                       */

  if (imgidx == REFERENCE)
    strcpy(filename,tie_planes[tie.rview].filename);
  else
    strcpy(filename,tie_planes[tie.sview].filename);

  for (i = 1; i < tie.numimgs[imgidx]; i++)
    {
    strncat(filename,"+",CMLEN-1-strlen(hdrname));
    if (imgidx == REFERENCE)
      strncat(filename,tie_planes[tie.rview+i].filename,
              CMLEN-1-strlen(hdrname));
    else
      strncat(filename,tie_planes[tie.sview+i].filename,
              CMLEN-1-strlen(hdrname));
    }
}
