/*******************************************************************************
NAME: TPS_OK

PURPOSE: This routine is the callback for selecting OK from the TPS file
         selector.  The selected file becomes the respectie input TPS file
         parameter value.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            2/92    J.Hemmer        Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
#include <sys/types.h> 
#include <sys/stat.h> 
#include "tiepts.h"
#include "tpssup.h"

void tps_ok
(
    Widget w,
    XtPointer client,
    XtPointer call
)
{
  char *filename;
  struct stat mystat;

  XmFileSelectionBoxCallbackStruct *acs =
             (XmFileSelectionBoxCallbackStruct*)call;

  /* Retrieve the file name selected and parse it.
     This determines its host file name.
  ------------------------------------------------*/
  XmStringGetLtoR(acs->value,XmSTRING_DEFAULT_CHARSET,&filename);

  stat(filename,&mystat);
  if (S_ISDIR(mystat.st_mode))
    {
    XBell(tie.display, 0);
    return;
    }

  if ((Widget)client == parm_refin_button)
    {
    XmTextSetString(parm_refin_text, filename);
    XtSetSensitive(parm_refin_button, True);
    }
  else if ((Widget)client == parm_srchin_button)
    {
    XmTextSetString(parm_srchin_text, filename);
    XtSetSensitive(parm_srchin_button, True);
    }

  XtDestroyWidget(TPS_fileselector);
  XtFree(filename);
}

