/*******************************************************************************
NAME: TPS_PARMSET

PURPOSE: This routine sets a TPS filename parameter.

PROGRAM HISTORY:
VERSION         DATE    AUTHOR          REASON
-------         ----    -----------     ----------
 1.0            4/92    J.Hemmer        Initial Development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        TIEPTS must be run under X Windows.

PROJECT: TIEPTS

ALGORITHM DESCRIPTION:
*******************************************************************************/
#include "tiepts.h"
#include "protos.h"
#include "tpssup.h"

void tps_parmset
(
    Widget w,
    XtPointer client,
    XtPointer call
)
{
  Arg args[2];                /* Variable used to set widget resourcees    */
  char filename[256];         /* Enter filename string                     */
  char *ext;                  /* Pointer to file extension                 */
  XmString xmstr;             /* Motif string variable                     */

  strcpy(filename, XmTextGetString(fileentry_text));

  if (((ext = strrchr(filename, '.')) == NULL) || 
       (strcmp(ext, ".tps") != 0))
    strcat(filename, ".tps");

  /* If output, check existence
  -----------------------------*/
  if (strstr(client, "OUT"))
    {
    if (!access(filename, 0))
      {
      XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR(
               "File Already Exists!!",XmSTRING_DEFAULT_CHARSET)));
      XtSetValues(fileentry_note, args, 1);
      XmStringFree(xmstr);
      XBell(tie.display, 0);
      }
    else if (((strcmp(client, "REFOUT") == 0) && 
              (strcmp(filename, tie_parms.outtps[SEARCH]) == 0) ||
              (strcmp(client, "SRCHOUT") == 0) &&
              (strcmp(filename, tie_parms.outtps[REFERENCE]) == 0)))
      {
      XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR(
               "Output TPS files must be different!!",
               XmSTRING_DEFAULT_CHARSET)));
      XtSetValues(fileentry_note, args, 1);
      XmStringFree(xmstr);

      XBell(tie.display, 0);
      }
    else
      {
      if (strcmp(client, "REFOUT") == 0)
        strcpy(tie_parms.outtps[REFERENCE], filename);
      else if (strcmp(client, "SRCHOUT") == 0)
        strcpy(tie_parms.outtps[SEARCH], filename);

      XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR( "",
               XmSTRING_DEFAULT_CHARSET)));
      XtSetValues(fileentry_note, args, 1);
      XmStringFree(xmstr);

      XtUnmanageChild(tpsentry_dialog_form);
      XtDestroyWidget(tpsentry_dialog_form);
        
      if (((tie.mode == IM2MAP) || (tie.mode == IM2VECT)) &&
           (strcmp(client, "SRCHOUT") == 0))
        tps_entry(REFERENCE);
      }
    }

  /* If input, check existence
  ----------------------------*/
  if (strstr(client, "IN"))
    {
    if (access(filename, 0))
      {
      XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR(
               "File Does Not Exist!!",
               XmSTRING_DEFAULT_CHARSET)));
      XtSetValues(fileentry_note, args, 1);
      XmStringFree(xmstr);

      if (!XtIsManaged(fileentry_note))
        XtManageChild(fileentry_note);
      XBell(tie.display, 0);
      }
    else 
      {
      if (strcmp(client, "REFIN") == 0)
        strcpy(tie_parms.intps[REFERENCE], filename);
      else if (strcmp(client, "SRCHIN") == 0)
        strcpy(tie_parms.intps[SEARCH], filename);

      XtSetArg(args[0], XmNlabelString, (xmstr=XmStringCreateLtoR( "",
               XmSTRING_DEFAULT_CHARSET)));
      XtSetValues(fileentry_note, args, 1);
      XmStringFree(xmstr);

      XtUnmanageChild(tpsentry_dialog_form);
      XtDestroyWidget(tpsentry_dialog_form);
      }
    }
}
