#ifndef WDBSUP_H
#define WDBSUP_H


void c_wdbclose
(
    FILE *fp_seq,               /* file pointer to the WDBII sequential file */
    FILE *fp_rel                /* file pointer to the WDBII relative file   */
);

int c_wdbopen
(
    char        *filenam,               /* file root name to be opened               */
    FILE        **fp_seq,               /* file pointer to the WDBII sequential file */
    FILE        **fp_rel                /* file pointer to the WDBII relative file   */
);

int c_wdbrank
(
    int  ftype,         /* type of feature                      */
    int  fcount,                /* number of features                   */
    int  feature[],     /* feature classifications to process   */
    int  ranks[]        /* sorted rankings desired from WDBII   */
);

int c_wdbrel
(
    FILE *fp_rel,           /* file pointer to the WDBII relative file       */
    int  *total_pts,    /* total number of points in the line segment        */
    int  *num_pts,          /* number of points to process at this time          */
    float pnts[]                /* latitude/Longitude point defining the segments    */
);

int c_wdbseq
(
    FILE *fp_seq,       /* file pointer to the WDBII sequential file         */
    int  ranks[],       /* ranking of interest                               */
    int  crossflg,      /* indicates crossing Internat'l Date Line (180 long)*/
    float *minlat,      /* minimum latitude of area of interest              */
    float *minlon,      /* minimum longitude of area of interest             */
    float *maxlat,      /* maximum latitude of area of interest              */
    float *maxlon,      /* maximum longitude of area of interest             */
    int  *total_pts,    /* total number of points in the line segment        */
    FILE *fp_rel        /* file pointer to the WDBII relative file           */
);

int wdb_filelist
(
   Widget filelist      /* scrollable list of map ids in mapfile  */
);

#endif
