/*******************************************************************************
NAME:           WDBCLOSE

PURPOSE:        Close the WDB2 files.

                The ".SEQ" file serves as look-up table for retrieving
                geographic coordinates from the ".REL" file

PROGRAM HISTORY:
Version      Date    Programmer         Request
-------      ----    ----------         -------
  1.0        10/91   D. Hollaren        Initial development

*******************************************************************************/
#include <stdio.h>
#include "tiepts.h"
#include "wdbsup.h"

void c_wdbclose
(
    FILE *fp_seq,               /* file pointer to the WDBII sequential file */
    FILE *fp_rel                /* file pointer to the WDBII relative file   */
)
{
    /*
      Close the WDBII sequential file
    */
    fclose(fp_seq);

    /*
      Close the WDBII relative file
    */
    fclose(fp_rel);

}
