#include "tiepts.h"
#include "wdbsup.h"

/*******************************************************************************
Purpose:
    This routine generates the list of WDB continents.

By J. Hemmer, USGS/EROS Data Center, 4/92

Algorithm Description:
*******************************************************************************/
int wdb_filelist
(
   Widget filelist      /* scrollable list of map ids in mapfile  */
)
{
   Arg            args[2];      /* resource argument variable                 */
   int            curlen,       /* current string length                  */
                  i;            /* loop counter                           */
   XmString       xmstr;        /* temporary Xm string variable           */


  /*
   *  *** get number of items in list
   */
   XtSetArg(args[0], XmNitemCount, &curlen);
   XtGetValues(filelist, args, 1);

  /*
   *  *** insert into list alphabetically
   */
   i = 0;

   while(wdb_files[i].continent != NULL)
      {
     /*
      *  *** insert in list widget
      */
      xmstr = XmStringCreateLtoR(wdb_files[i].continent, 
                                 XmSTRING_DEFAULT_CHARSET);
 
     /*
      *  *** add to list, this procedure is need because of possible 
      *      bug in DG motif
      */
      if ((i+1) <= curlen)
         XmListReplaceItemsPos(filelist, &xmstr, 1, i+1);
      else
         XmListAddItem(filelist, xmstr, 0);

      XmStringFree(xmstr);
      i++;
      }

  /*
   *  *** remove any remaining members (DG bug)
   */
   if (i < curlen)
      XmListDeleteItemsPos(filelist, curlen-i, i+1);

   return(E_SUCC);
}

