/*
    TIEPTS widget variables.
    Modified by J. LaVergne USGS/EROS Data Center 7/93
      - added verify_dialog_shell widget
    Modified by T. Rockvam USGS/EROS Data Center 3/94
      - added misc widgets & functions for v1.1
    Modified by C. Olsen, USGS/EROS Data Center, 8/98
      - added verify_x, verify_y, parm_radiobox and associated widgets and 
        callback routine, parm_coord_type().  (SRF #1935)
    Modified by C. Olsen, USGS/EROS Data Center, 9/98
      - added parm_oc_pulldown and associated widgets  (SRF #1958)
*/


#ifndef TIEPTS
#define TIEPTS
#endif

#ifndef _tiepts_h
extern Widget      Shell_Main;
extern Widget      Main_shell;

extern Widget      Shell_RefImg;
extern Widget      Shell_SrchImg;

extern Widget      Shell_RefFull;
extern Widget      Shell_SrchFull;
extern Widget      Fullref_scrollwin;
extern Widget      Fullsrch_scrollwin;

extern Widget      Shell_Zoom;
extern Widget      Zoom_scrollwin;

extern Widget      Shell_Edit;
extern Widget      Edit_form;

extern Widget      Shell_Getmap;
extern Widget      Getmap_form;
extern Widget      Catalog_fileselector;

extern Widget      Shell_Load;
extern Widget      Load_fileselector;

extern Widget      Shell_Cursor;
extern Widget      Cursor_bulletinboard;

extern Widget      Shell_Stats;
extern Widget      Stats_form;

extern Widget      Shell_Adjust;
extern Widget      Adjust_bulletinboard;

extern Widget      Shell_Mode;
extern Widget      Mode_form;

extern Widget      Shell_MParm;
extern Widget      Mapparm_form;
extern Widget      Map_fileselector;
extern Widget      Mapid_selector;
extern Widget      Datum_selector;              

extern Widget      Shell_Help;
extern Widget      Createhelp_bulletinboard();

extern Widget      Shell_About;
extern Widget      About_bulletinboard;

extern Widget      Shell_Show;
extern Widget      Show_form;

extern Widget      Shell_Parm;
extern Widget      Parm_bulletinboard;

extern Widget      Shell_Graphic;
extern Widget      Graphic_form;

extern Widget      Shell_Align;
extern Widget      Align_form;

extern Widget      Shell_Vector;
extern Widget      Vector_form;
extern Widget      Vect_fileselector;

extern Widget      Shell_DLGlt;         
extern Widget      Dlglt_form;  

extern Widget      Shell_DCWlt;
extern Widget      Dcwlt_form;

extern Widget      Shell_DCWls;
extern Widget      Dcwls_form;

extern Widget      Color_req;
extern Widget      Line_req;

extern Widget      Shell_Manual;
extern Widget      Manual_form;

extern Widget      process_dialog_shell;
extern Widget      process_widget;

extern Widget      maplist_catalog_button;
extern Widget      maplist_color_button;
extern Widget      maplist_catalog_text;
extern Widget      maplist_file_button;
extern Widget      maplist_file_text;
extern Widget      maplist_name_on;
extern Widget      maplist_name_off;

extern Widget      parm_accept;

extern Widget      verify_dialog_form;
extern Widget      verify_dialog_shell;
extern Widget      verify_accept;
extern Widget      verify_reference;
extern Widget      verify_search;
extern Widget      verify_y;
extern Widget      verify_x;
extern Widget      verify_id;
extern Widget      verify_id_label;
extern Widget      verify_elev;
extern Widget      verify_elev_label;
extern Widget      verify_units_feet;
extern Widget      verify_units_meters;
extern Widget      verify_units_option;
extern Widget      verify_reject;
extern Widget      verify_res_line;
extern Widget      verify_res_samp;
extern Widget      verify_res_mag;

extern Widget      main_form;
extern Widget      main_frame;
extern Widget      frame_bulletinboard;
extern Widget      main_logo;
extern Widget      main_display_info;
extern Widget      main_info_title;
extern Widget      main_info_version;
extern Widget      main_info_visual;
extern Widget      main_info_size;
extern Widget      main_info_separator;
extern Widget      main_command_rowcol;
extern Widget      main_align_button;
extern Widget      main_load_button;
extern Widget      main_cursor_button;
extern Widget      main_parm_button;
extern Widget      main_register_button;
extern Widget      main_map_button;
extern Widget      main_vector_button;
extern Widget      main_adjust_button;
extern Widget      main_graphic_button;
extern Widget      main_edit_button;
extern Widget      main_select_button;
extern Widget      main_show_button;
extern Widget      main_stats_button;
extern Widget      main_exit_button;
extern Widget      main_about_button;
extern Widget      main_help_button;
extern Widget      load_search;

extern Widget      manual_coord_dms;
extern Widget      manual_coord_option;
extern Widget      manual_coord_degrees;
extern Widget      manual_coord_minutes;
extern Widget      manual_coord_seconds;
extern Widget      manual_coord_proj;
extern Widget      man_datum_button;
extern Widget      man_datum_text;  
extern Widget      manual_x;
extern Widget      manual_y;

extern Widget      proj_code_label;
extern Widget      proj_code_value;
extern Widget      proj_parm_label;
extern Widget      proj_parm_number[15];
extern Widget      proj_parms[15];

extern Widget      zone_code_label;
extern Widget      zone_code_value;

extern Widget      search_image_scrollwin;
extern Widget      search_image_bulletinboard;
extern Widget      ref_image_scrollwin;
extern Widget      ref_image_bulletinboard;

extern Widget      reg_coord_geog;
extern Widget      reg_coord_option;
extern Widget      reg_coord_user;
extern Widget      reg_coord_proj;
extern Widget      reg_date_text;
extern Widget      reg_datum_button;
extern Widget      reg_datum_text;
extern Widget      reg_desc_text;
extern Widget      reg_mapfile_button;
extern Widget      reg_mapfile_text;
extern Widget      reg_mapid_button;
extern Widget      reg_mapid_text;
extern Widget      reg_maptype_text;
extern Widget      reg_inc_x;
extern Widget      reg_inc_y;
extern Widget      reg_lr_x;
extern Widget      reg_lr_y;
extern Widget      reg_mapid_list;
extern Widget      reg_npts_x;
extern Widget      reg_npts_y;
extern Widget      reg_scale_text;
extern Widget      reg_ul_x;
extern Widget      reg_ul_y;
extern Widget      reg_verify_x;
extern Widget      reg_verify_y;

extern Widget      message_line1;
extern Widget      message_line2;

extern Widget      parm_alpha_label;
extern Widget      parm_alpha;
extern Widget      parm_apply;
extern Widget      parm_cancel;
extern Widget      parm_cd_text;
extern Widget      parm_curcolor_button;
extern Widget      parm_fullres_256;
extern Widget      parm_fullres_512;
extern Widget      parm_fullres_option;
extern Widget      parm_order_first;
extern Widget      parm_order_second;
extern Widget      parm_order_option;
extern Widget      parm_port_text;
extern Widget      parm_port_label;
extern Widget      parm_prompt_elev;
extern Widget      parm_prompt_id;
extern Widget      parm_refin_button;
extern Widget      parm_refin_text;
extern Widget      parm_refout_text;
extern Widget      parm_refoff_vert;
extern Widget      parm_refoff_horiz;
extern Widget      parm_srchoff_vert;
extern Widget      parm_srchoff_horiz;
extern Widget      parm_srchout_text;
extern Widget      parm_srchin_text;
extern Widget      parm_srchin_button;
extern Widget      parm_vsrc_option;
extern Widget      parm_vsrc_dlg;
extern Widget      parm_vsrc_wdb;
extern Widget      parm_vsrc_dcw;
extern Widget      parm_zfactor;
extern Widget      parm_ztype_nn;
extern Widget      parm_ztype_bilinear;
extern Widget      parm_ztype_cc;
extern Widget      parm_ztype_option;
extern Widget      parm_zsize_64;
extern Widget      parm_zsize_128;
extern Widget      parm_zsize_option;
extern Widget      parm_epoint_norec;
extern Widget      parm_epoint_rec;
extern Widget      parm_epoint_option;
extern Widget      parm_datum_option;
extern Widget      parm_datum_norec;
extern Widget      parm_datum_rec;
extern Widget      parm_spark_option;
extern Widget      parm_spark_digit;
extern Widget      parm_spark_manual;
extern Widget      parm_radiobox;
extern Widget      parm_ls_button;
extern Widget      parm_proj_button;
extern Widget      parm_latlong_button;
extern Widget      parm_coord_label;
extern Widget      parm_oc_shell;
extern Widget      parm_oc_pulldown;
extern Widget      parm_oc_proj;
extern Widget      parm_oc_latlong;
extern Widget      parm_oc_option;
extern Widget      parm_oc_label;
extern Widget      parm_multiref_button;

extern Widget      cursor_mo_radiobox;
extern Widget      cursor_original_button;
extern Widget      cursor_mapped_button;
extern Widget      cursor_xyz_radiobox;
extern Widget      cursor_xy_button;
extern Widget      cursor_z_button;
extern Widget      cursor_am_radiobox;
extern Widget      cursor_auto_button;
extern Widget      cursor_man_button;
extern Widget      cursor_ls_label;
extern Widget      cursor_fc_label;
extern Widget      cursor_ci_label;
extern Widget      cursor_pc_label;
extern Widget      cursor_ll_label;
extern Widget      cursor_un_label;
extern Widget      cursor_frame;
extern Widget      cursor_drawingarea;
extern Widget      cursor_pc_toggle;
extern Widget      cursor_ll_toggle;
extern Widget      cursor_un_toggle;
extern Widget      cursor_ls_text;
extern Widget      cursor_fc_text;
extern Widget      cursor_pc_text;
extern Widget      cursor_ll_text;
extern Widget      cursor_un_text;
extern Widget      cursor_separator;
extern Widget      cursor_dismiss_button;
extern Widget      cursor_scale;

extern Widget      fullref_win_bulletinboard;
extern Widget      fullsrch_win_bulletinboard;

extern Widget      zoom_refwin_bulletinboard;
extern Widget      zoom_srchwin_bulletinboard;

extern Widget      tpsentry_dialog_form; 
extern Widget      fileentry_label;
extern Widget      fileentry_note;
extern Widget      fileentry_text;
extern Widget      fileentry_ok; 
        
extern Widget      adjust_bright_slider;
extern Widget      adjust_contrast_slider;

extern Widget      align_type_translate;
extern Widget      align_type_rotate;
extern Widget      align_type_scale;

extern Widget      about_dismiss_button;
extern Widget      about_frame;
extern Widget      about_frame_bulletinboard;
extern Widget      about_drawingarea;
extern Widget      about_label;

extern Widget      show_plane_list;
extern Widget      show_red_button;
extern Widget      show_green_button;
extern Widget      show_blue_button;
extern Widget      show_bw_button;

extern Widget      stats_list;
extern Widget      stats_line_label;
extern Widget      stats_image_label;
extern Widget      stats_scrollwin;

extern Widget      rough_dialog_form; 
extern Widget      rough_units_option; 
extern Widget      rough_units_meters; 
extern Widget      rough_units_feet; 
extern Widget      rough_elev[4];
extern Widget      rough_id[4];

extern Widget      register_dialog_form;
extern Widget      register_scrollwin;
extern Widget      register_cancel;
extern Widget      register_list;
extern Widget      register_ok;

extern Widget      edit_list; 
extern Widget      edit_reselect_button; 
extern Widget      edit_disable_button; 

extern Widget      vect_blend_slide; 
extern Widget      vect_background_button; 
extern Widget      vect_attrib_rowcol; 
extern Widget      vect_attrib_scroll; 
extern Widget      vect_unzoom_button; 

extern Widget      dcw_library_label; 
extern Widget      dcw_library_pull; 
extern Widget      dcw_feature_pull; 
extern Widget      dcw_feature_label; 
extern Widget      dcw_ls_list; 
extern Widget      dcw_lt_list; 
extern Widget      dlg_feature_button; 
extern Widget      dlg_lt_list; 
extern Widget      dlg_file_button; 
extern Widget      vect_min_lat;
extern Widget      vect_min_lon;
extern Widget      vect_max_lat;
extern Widget      vect_max_lon;
extern Widget      wdb_cont_button; 
extern Widget      wdb_cont_text; 


extern Widget      TPS_fileselector;

#else
Widget      Shell_Main;
Widget      Main_shell;

Widget      Shell_RefImg;
Widget      Shell_SrchImg;

Widget      Shell_RefFull;
Widget      Shell_SrchFull;
Widget      Fullref_scrollwin;
Widget      Fullsrch_scrollwin;

Widget      Shell_Zoom;
Widget      Zoom_scrollwin;

Widget      Shell_Edit;
Widget      Edit_form;

Widget      Shell_Getmap;
Widget      Getmap_form;
Widget      Catalog_fileselector;

Widget      Shell_Load;
Widget      Load_fileselector;

Widget      Shell_Cursor;
Widget      Cursor_bulletinboard;

Widget      Shell_Stats;
Widget      Stats_form;

Widget      Shell_Adjust;
Widget      Adjust_bulletinboard;

Widget      Shell_Mode;
Widget      Mode_form;

Widget      Shell_MParm;
Widget      Mapparm_form;
Widget      Map_fileselector;
Widget      Mapid_selector;
Widget      Datum_selector;     

Widget      Shell_Help;
Widget      Createhelp_bulletinboard();

Widget      Shell_About;
Widget      About_bulletinboard;

Widget      Shell_Show;
Widget      Show_form;

Widget      Shell_Parm;
Widget      Parm_bulletinboard;

Widget      Shell_Graphic;
Widget      Graphic_form;

Widget      Shell_Align;
Widget      Align_form;

Widget      Shell_Vector;
Widget      Vector_form;
Widget      Vect_fileselector;
Widget      Createvector_form();

Widget      Shell_DLGlt;
Widget      Dlglt_form;

Widget      Shell_DCWlt;
Widget      Dcwlt_form;

Widget      Shell_DCWls;
Widget      Dcwls_form;

Widget      Color_req;
Widget      Line_req;

Widget      Shell_Manual;
Widget      Manual_form;

Widget      process_dialog_shell;
Widget      process_widget;

Widget      maplist_catalog_button;
Widget      maplist_color_button;
Widget      maplist_catalog_text;
Widget      maplist_file_button;
Widget      maplist_file_text;
Widget      maplist_name_on;
Widget      maplist_name_off;

Widget      verify_accept;
Widget      verify_dialog_form;
Widget      verify_dialog_shell;
Widget      verify_reference;
Widget      verify_search;
Widget      verify_y;
Widget      verify_x;
Widget      verify_id;
Widget      verify_id_label;
Widget      verify_elev;
Widget      verify_elev_label;
Widget      verify_units_feet;
Widget      verify_units_meters;
Widget      verify_units_option;
Widget      verify_reject;
Widget      verify_res_line;
Widget      verify_res_samp;
Widget      verify_res_mag;

Widget      main_form;
Widget      main_frame;
Widget      frame_bulletinboard;
Widget      main_logo;
Widget      main_display_info;
Widget      main_info_title;
Widget      main_info_version;
Widget      main_info_visual;
Widget      main_info_size;
Widget      main_info_separator;
Widget      main_command_rowcol;
Widget      main_align_button;
Widget      main_load_button;
Widget      main_cursor_button;
Widget      main_parm_button;
Widget      main_graphic_button;
Widget      main_register_button;
Widget      main_map_button;
Widget      main_select_button;
Widget      main_stats_button;
Widget      main_vector_button;
Widget      main_adjust_button;
Widget      main_about_button;
Widget      main_exit_button;
Widget      main_help_button;
Widget      load_search;
Widget      main_edit_button;
Widget      main_show_button;


Widget      manual_coord_dms;
Widget      manual_coord_option;
Widget      manual_coord_degrees;
Widget      manual_coord_minutes;
Widget      manual_coord_seconds;
Widget      manual_coord_proj;
Widget      man_datum_button; 
Widget      man_datum_text; 
Widget      manual_x;
Widget      manual_y;

Widget      proj_code_label;
Widget      proj_code_value;
Widget      proj_parm_label;
Widget      proj_parm_number[15];
Widget      proj_parms[15];

Widget      zone_code_label;
Widget      zone_code_value;

Widget      reg_coord_geog;
Widget      reg_coord_option;
Widget      reg_coord_user;
Widget      reg_coord_proj;
Widget      reg_date_text;
Widget      reg_datum_button;
Widget      reg_datum_text;
Widget      reg_desc_text;
Widget      reg_mapfile_button;
Widget      reg_mapfile_text;
Widget      reg_mapid_button;
Widget      reg_mapid_text;
Widget      reg_maptype_text;
Widget      reg_inc_x;
Widget      reg_inc_y;
Widget      reg_lr_x;
Widget      reg_lr_y;
Widget      reg_mapid_list;
Widget      reg_npts_x;
Widget      reg_npts_y;
Widget      reg_scale_text;
Widget      reg_ul_x;
Widget      reg_ul_y;
Widget      reg_verify_x;
Widget      reg_verify_y;

Widget      message_line1;
Widget      message_line2;

Widget      parm_accept;
Widget      parm_alpha_label;
Widget      parm_alpha;
Widget      parm_apply;
Widget      parm_cancel;
Widget      parm_cd_text;
Widget      parm_curcolor_button;
Widget      parm_fullres_256;
Widget      parm_fullres_512;
Widget      parm_fullres_option;
Widget      parm_order_first;
Widget      parm_order_second;
Widget      parm_order_option;
Widget      parm_port_text;
Widget      parm_port_label;
Widget      parm_prompt_elev;
Widget      parm_prompt_id;
Widget      parm_refin_button;
Widget      parm_refin_text;
Widget      parm_refout_text;
Widget      parm_refoff_vert;
Widget      parm_refoff_horiz;
Widget      parm_srchoff_vert;
Widget      parm_srchoff_horiz;
Widget      parm_srchout_text;
Widget      parm_srchin_text;
Widget      parm_srchin_button;
Widget      parm_vsrc_option;
Widget      parm_vsrc_dlg;
Widget      parm_vsrc_wdb;
Widget      parm_vsrc_dcw;
Widget      parm_zfactor;
Widget      parm_ztype_nn;
Widget      parm_ztype_bilinear;
Widget      parm_ztype_cc;
Widget      parm_ztype_option;
Widget      parm_zsize_64;
Widget      parm_zsize_128;
Widget      parm_zsize_option;
Widget      parm_epoint_norec;
Widget      parm_epoint_rec;
Widget      parm_epoint_option;
Widget      parm_datum_option;
Widget      parm_datum_norec;
Widget      parm_datum_rec;
Widget      parm_spark_option;
Widget      parm_spark_digit;
Widget      parm_spark_manual;
Widget      parm_radiobox;
Widget      parm_ls_button;
Widget      parm_proj_button;
Widget      parm_latlong_button;
Widget      parm_coord_label;
Widget      parm_oc_shell;
Widget      parm_oc_pulldown;
Widget      parm_oc_proj;
Widget      parm_oc_latlong;
Widget      parm_oc_option;
Widget      parm_oc_label;
Widget      parm_multiref_button;

Widget      ref_image_scrollwin;
Widget      ref_image_bulletinboard;
Widget      search_image_scrollwin;
Widget      search_image_bulletinboard;

Widget      cursor_mo_radiobox;
Widget      cursor_original_button;
Widget      cursor_mapped_button;
Widget      cursor_xyz_radiobox;
Widget      cursor_xy_button;
Widget      cursor_z_button;
Widget      cursor_am_radiobox;
Widget      cursor_auto_button;
Widget      cursor_man_button;
Widget      cursor_ls_label;
Widget      cursor_fc_label;
Widget      cursor_ci_label;
Widget      cursor_pc_label;
Widget      cursor_ll_label;
Widget      cursor_un_label;
Widget      cursor_frame;
Widget      cursor_drawingarea;
Widget      cursor_pc_toggle;
Widget      cursor_ll_toggle;
Widget      cursor_un_toggle;
Widget      cursor_ls_text;
Widget      cursor_fc_text;
Widget      cursor_pc_text;
Widget      cursor_ll_text;
Widget      cursor_un_text;
Widget      cursor_separator;
Widget      cursor_dismiss_button;
Widget      cursor_scale;

Widget      zoom_refwin_bulletinboard;
Widget      zoom_srchwin_bulletinboard;

Widget      fullref_win_bulletinboard;
Widget      fullsrch_win_bulletinboard;

Widget      tpsentry_dialog_form; 

Widget      fileentry_note;
Widget      fileentry_label;
Widget      fileentry_ok; 
Widget      fileentry_text;

Widget      adjust_bright_slider;
Widget      adjust_contrast_slider;

Widget      align_type_translate;
Widget      align_type_rotate;
Widget      align_type_scale;

Widget      about_dismiss_button;
Widget      about_frame;
Widget      about_frame_bulletinboard;
Widget      about_drawingarea;
Widget      about_label;

Widget      show_plane_list;
Widget      show_red_button;
Widget      show_green_button;
Widget      show_blue_button;
Widget      show_bw_button;

Widget      stats_list;
Widget      stats_line_label;
Widget      stats_image_label;
Widget      stats_scrollwin;

Widget      rough_dialog_form; 
Widget      rough_units_option; 
Widget      rough_units_meters; 
Widget      rough_units_feet; 
Widget      rough_elev[4];
Widget      rough_id[4];

Widget      register_dialog_form;
Widget      register_mapfile_cancel;
Widget      register_mapfile_ok;
Widget      register_scrollwin;
Widget      register_cancel;
Widget      register_list;
Widget      register_ok;

Widget      edit_list; 
Widget      edit_reselect_button; 
Widget      edit_disable_button; 

Widget      vect_blend_slide; 
Widget      vect_background_button; 
Widget      vect_attrib_rowcol; 
Widget      vect_attrib_scroll; 
Widget      vect_file_selector; 
Widget      vect_unzoom_button; 

Widget      dcw_library_label; 
Widget      dcw_library_pull; 
Widget      dcw_feature_pull; 
Widget      dcw_feature_label; 
Widget      dcw_lib_button; 
Widget      dcw_lib_text; 
Widget      dcw_ls_list; 
Widget      dcw_lt_list; 
Widget      dlg_feature_button;
Widget      dlg_lt_list; 
Widget      dlg_file_button;
Widget      vect_min_lat;
Widget      vect_min_lon;
Widget      vect_max_lat;
Widget      vect_max_lon;
Widget      wdb_cont_button; 
Widget      wdb_cont_text; 

Widget      TPS_fileselector;

#endif
