#ifndef XID_H
#define XID_H


int xid_getmem
(
    int *memory         /* The memory plane ID which is available for
                                   use by the calling function. (O)           */
);

int xid_histcalc
(
    int *hist,          /* Actual histogram values. (I)                 */
    int *minb,          /* Minimum frequency value. (O)                 */
    int *maxb,          /* Maximum frequency value. (O)                 */
    double *mean,               /* Mean frequency value. (O)                    */
    double *stdev               /* Standard deviation of frequency. (O)         */
);

int xid_rgb2lut
(
    int num_images,             /* Number of input images. (I)          */
    unsigned char **red,                /* Red pixel values. (I)                */
    unsigned char **green,      /* Green pixel values. (I)              */
    unsigned char **blue,               /* Blue pixel values. (I)               */
    int *npts,                  /* Total number of input pixels. (I)    */
    int lutlen,                 /* Number of LUT entries to use. (I)    */
    unsigned char **composite,  /* Output composite image. (O)          */
    unsigned char *red_lut,     /* Output red LUT. (O)                  */
    unsigned char *green_lut,   /* Output green LUT. (O)                */
    unsigned char *blue_lut,    /* Output blue LUT. (O)                 */
    int num_reserved,           /* Number of reserved colors in LUT. (I)*/
    unsigned char *reserved_red,        /* Input reserved red LUT values. (I)   */
    unsigned char *reserved_green,/* Input reserved green LUT values. (I)       */
    unsigned char *reserved_blue        /* Input reserved blue LUT values. (I)  */
);

int xid_samp
(
    int inpwdw[],       /* File window image is taken from. (I)         */
    int memwdw[],       /* Pane window image is to be loaded into. (I/O)*/
    int *skipl,         /* Sampling factor in the line direction. (O)   */
    int *skips          /* Sampling factor in the sample direction. (O) */
);

int xid_slpoff
(
    int *indtyp,        /* Input data type. (I)                         */
    double *minpix,     /* Minimum pixel value. (I)                     */
    double *maxpix,     /* Maximum pixel value. (I)                     */
    double *slope,              /* Slope to be computed. (O)                    */
    double *offset      /* Offset to be computed. (O)                   */
);

#endif
