/*
 *  This is the utility which returns the number of the next available memory 
 *  plane to the calling routine.  GETMEM returns TIE_S if an available memory
 *  plane is found and it returns TIE_F if no memory planes are available. 
 *
 *  By D. Akkerman/L.Huewe, USGS/EROS Data Center, 9/91.
 *    - X Image Display, v1.0.
 *
 */
#include "tiepts.h"
#include "xid.h"

int xid_getmem
(
    int *memory         /* The memory plane ID which is available for
                                   use by the calling function. (O)           */
)
{
int     found = FALSE,          /* Indicates whether or not an available memory
                                   plane was found.                           */
         i;                     /* Looping index.                             */

/*
    Set the output memory plane ID based on the current plane number.
*/ 
*memory = ((tie.current_plane + 1) > tie.max_plane) ? 1 : tie.current_plane + 1;

/*
    Loop until a memory plane is found which is not currently locked.
*/
for (i=0; i < tie.max_plane; i++)
    {
    if (tie_planes[*memory - 1].flags & LOCK) 
        *memory = ((*memory + 1) > tie.max_plane) ? 1 : *memory + 1;
    else
        {
        found = TRUE;
        break;
        }
    }
if (found)
    return(TIE_S);
else
    return(TIE_F);
}
