/*****************************************************************************

  NAME:	CLRTPS

  FUNCTION: Clear a TPS header record.

  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

  PROJECT:	LAS

  PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    1.0         6/89       D.Etrheim    initial development

  ALGORITHM DESCRIPTION:
  Zero out or set to NULL all fields

******************************************************************************/
#include "las.h"
#include "geompak.h"

void clrtps
(
  struct TPSHEAD *head        /* TPS header record */
)
{ /* clrtps */

long i;					/* loop counter */

for (i = 0; i < 8; i++)
   head->corners[i] = 0.0;
head->pdist[0] = head->pdist[1] = 0.0;
for (i = 0; i < 15; i++)
   head->projprms[i] = 0.0;
head->proj_valid = GEO_NOTVALID;
head->code = head->zone = head->datum = 0;
head->mode[0] = head->units[0] = head->name[0] = (char)NULL;

} /* clrtps */
