#ifndef PROTOS_H
#define PROTOS_H

int bndchk
(
    long bands[MAXBND+1], 	/* O: Band numbers specified    	*/
    long *inbands,		/* I: Number of bands in transfer file  */
    long *totbnd, 		/* O: Number of bands being converted   */
    struct PRS_LST p_list       /* I: Image list returned from imgprs   */
);

int getpar
(
    struct PARBLK *vblock,	/* I: Parameter block	             */
    char subcmd[],		/* O: Subcommand chosen	      	     */
    long *msgtim,		/* O: Number of seconds between
					   processing messages       */
    char minmax[],		/* O: Min/max flag		     */
    long *dflag,                /* O: DDR update option		     */
    long *nl,			/* O: Number of lines in input image */
    long *ns,			/* O: Number of samples in input image*/
    long *nbands,		/* O: Number of bands in input image */
    long *nheader,		/* O: Number of header bytes	     */
    long *idtype,		/* O: Input data type		     */
    long *odtype,		/* O: Output data type		     */
    char taein[][CMLEN], 	/* O: Image file TAE nam             */
    char hosin[][CMLEN], 	/* O: Image file HOST name    	     */
    char taeout[][CMLEN],	/* O: TAE file name of output image  */
    char hosout[][CMLEN],	/* O: Host file name of output image */
    long *nfiles,		/* O: Number of transfer files       */
    long window[][4], 	        /* O: Window specification	     */
    long bands[][MAXBND+1],     /* O: Band numbers specified	     */
    char ioname[][CMLEN],	/* O: Output host file name(s)       */
    long *totbnd,		/* O: Total number of bands specified*/
    long *nmrout,		/* O: Number of output files         */
    char *bform,		/* O: Band format option	     */
    long *nmrimg,		/* O: number of input images	     */
    long *inbands		/* O: Number of bands in transfer file*/
);
int inbil
(
        struct PARBLK *vblock,          /* I: TAE parameter block             */
        char  hosout[][CMLEN],          /* I: host name of output image       */
        long  ns,                       /* I: number of samples               */
        long  nbands,                   /* I: number of bands in image        */
        long  *window,                  /* I:window area of image to be copied*/
        long  bands[MAXBND+1],          /* I: bands to be processed           */
        long  nheader,                  /* I: number of header bytes          */
        long  nmrout,                   /* I: number of output images         */
        char  ioname[][CMLEN],          /* I: array of input image names      */
        long  idtype,                   /* I: input data type                 */
        long  odtype,                   /* I: output data type                */
        long  msgtim,                   /* I: message time                    */
        char *minmax,                   /* I: min max flag                    */
        long  dflag,                    /* I: ddr flag option                 */
        long  totbnd                    /* I: number of bands to be converted */
); 

long read_in_file
(
        FILE *infd,                     /* I: input file descriptor     */
        char *buf,                      /* I: read buffer               */
        long nbytes                     /* I: number of bytes to read   */
);

int indal
(
        struct PARBLK *vblock,          /* TAE parameter block                */
        char  hosout[][CMLEN],          /* host name of output image          */
        long  nfiles,                   /* number of transfer files           */
        long  nl,                       /* number of lines                    */
        long  ns,                       /* number of samples                  */
        long  nbands,                   /* number of bands                    */
        long  *window,                  /* window area of image to be copied  */
        long  bands[MAXBND+1],          /* bands to be processed              */
        long  nheader,                  /* number of header bytes             */
        long  nmrout,                   /* number of output images            */
        char  ioname[][CMLEN],          /* array of input image names         */
        long  idtype,                   /* input data type                    */
        long  odtype,                   /* output data type                   */
        long  msgtim,                   /* message time                       */
        char  *minmax,                  /* min max flag                       */
        long  dflag,                    /* ddr flag option                    */
        long  totbnd                    /* number of bands to be converted    */
);

long read_input_file
(
        FILE *infd,                     /* I: input file descriptor   */
        char *buf,                      /* I: read buffer             */
        long nbytes                     /* I: number of bytes to read */
);

int outbil
(
        struct PARBLK *vblock,          /* I: TAE parameter block            */
        char  hosin[][CMLEN],           /* I: host name of input image       */
        long  window[][4],              /* I: window specifier               */
        long  bands[][MAXBND+1],        /* I: Band numbers specified         */
        long  *nbands,                  /* I: number of bands                */
        long  odtype,                   /* I: output data type               */
        char  ioname[][CMLEN],          /* I: Output file names              */
        long  msgtim,                   /* I: message time counter           */
        long  nmrimg,                   /* I: number input images            */
        long  totbnd                    /* I: total number of bands          */

);



int outdal
(
        struct PARBLK *vblock,          /* I: TAE parameter block            */
        char  hosin[][CMLEN],           /* I: host name of input image       */
        long  nfiles,                   /* I: number of transfer files       */
        long  window[][4],              /* I: window specifier               */
        long  bands[][MAXBND+1],        /* I: Band numbers specified         */
        long  *nbands,                  /* I: number of bands                */
        long  odtype,                   /* I: output data type               */
        char  ioname[][CMLEN],          /* I: Output file names              */
        long  msgtim,                   /* I: message time counter           */
        long  nmrimg,                   /* I: number of input images         */
        long  totbnd                    /* I: total number of bands          */
);

int wndchk
(
    long window[][4],           /* I: Window specification              */
    long *nl,                   /* I: Number of lines in input image    */
    long *ns,                   /* I: Number of samples in input image  */
    long *nfiles                /* I: Number of transfer files          */
);

#endif
