#ifndef PROTOS_H
#define PROTOS_H

void calctrg
(
   long *func,                   /* Indicates which function is being accesed:
                                    1=arcsin; 2=arccos; 3=arctan     */
   char hosname[][CMLEN],        /* Host name of first input image  */
   char hosname2[][CMLEN],       /* Host name of second input image */
   char hosin[][CMLEN],          /* Host names of input images, (needed in one
                                    array for upddr routine)  */
   char outhost[][CMLEN],                /* Output host file descriptor  */
   long window[][4],             
   long window2[][4],
   long totwin[][4],             /* Total number of windows */ 
   long *nibs1,                  /* Number of bands in input image 1 */
   long *nibs2,                  /* Number of bands in input image 2 */
   long *nibso,                  /* Number of bands in output image  */
   long (*bands1)[MAXBND + 1],   
   long (*bands2)[MAXBND + 1],
   long *totbnd1,                /* Total number of bands in first image */
   long *totbndo,                /* Total number of bands in output      */
   long *nim1,                   /* Number of input images in first "image" */
   long *nim2,                   /* Number of input images in second "image" */
   char *mnmx,                   /* Indicator of desire for min-max value
                                    calculation */
   float *atzero,                /* Value user wishes used if zero occurs in
                                    calculation  */
   long *noimin                  /* Indicates whether one or two images were
                                    input  */
);

void getpar
(
   long *func,                   /* Indicates which trig function was requested:
                                    1=arcsin, 2=arccos, 3=arctan   */
   char hosname[][CMLEN],        
   char hosname2[][CMLEN],
   char las_names[][CMLEN],
   char outfile[][CMLEN],        /* Pointer to output image LAS TAE file 
                                    descriptor  */
   char outhost[][CMLEN],        /* Pointer to output host file descriptor */
   long window[][4],             /* Image window for first input "image" */
   long window2[][4],            /* Image window for second input "image" */
   long *nibs1,                  /* Number of bands(image) in input image 1 */
   long *nibs2,                  /* Number of bands(image) in input image 2 */
   long *nibso,                  /* number of bands in output image  */
   long (*bands1)[MAXBND + 1],   /* Band specification for first image */
   long (*bands2)[MAXBND + 1],   /* Band specification for second image */
   long *totbnd1,                /* Total number of bands to be processed in 
                                    input 1 */
   long *totbnd2,                /* Total number of bands to be processed in 
                                    input 2 */
   long *nmrimg1,                /* Number of images defined for first input */
   long *nmrimg2,                /* Number of images defined for second input */
   char *mnmx,                   /* Min-max indicator */
   float *atzero,                /* Value user wishes used if zero occurs in
                                    calculation */ 
   long *noimin                  /* Indicates whether one or two images were
                                    input */
);

#endif

