#ifndef PROTOS_H
#define PROTOS_H

int calc_scale
(
    float *minpix,	/* Minimum pixel value. (I)			*/
    float *maxpix,	/* Maximum pixel value. (I)			*/
    float scoff[]	/* Slope and offset to be computed by calc_scale. (O)*/
);

void filspec
(
    char inhos[][CMLEN],     /* input image host names                        */
    char outhos[],           /* output image host name                        */
    char fopt[4],            /* math function option */
    long *num_inimages,	    /* number of input images			*/
    long num_image_bands[],       /* number of bands in each input image*/
    long image_band_num[][MAXBND + 1], /* band numbers in each input image   */
    long *num_outbands,	/* number of output bands */
    long wind[][4],	/* input image window */
    long out_img_bands[][MAXBND+1]  /* band numbers for the output image*/
);

void getpar
(
    char intae[][CMLEN],         /*    input image tae name       */
    char inhos[][CMLEN],         /*    input image host name      */
    char outtae[][CMLEN],         	/*    output image tae name      */
    char outhos[][CMLEN],         	/*    output image host name     */
    long wind[][4], 		/* input image window		*/
    long *num_inimages,		/* number of input images           */
    long num_image_bands[],	/* number of bands in each input image */
    long image_band_num[][MAXBND+1],  /* band numbers for each image */
    long *num_inbands,           /* total number of input image bands   */
    long *num_outbands,		/* number of output image bands     */
    char fopt[4],            	/* math function option */
    float *base,               	/* log/exp base */
    float *exsc,               	/* scale for exp input images */
    float scoff[],           	/* scale and offset */
    long *scflg,                     /* scale/no scale flag */
    long *calcscflg,             /* calculate/don't calculate scale flag */
    float *pscale,            	/* scale for sine and cosine  */
    float *phase              	/* offset for sine and cosine */
);

void runopt
(
    char fopt[],         /* math function option */
    long wind[][4],	           /* input image window   */
    float base,           /* log/exp base */
    float exsc,           /* scale for exp input images */
    float scoff[],	/* scale and offset */
    long scflg,                     /* scale/no scale flag */
    float pscale,         /* scale for sine and cosine  */
    float phase,          /* offset for sine and cosine */
    long clipped[],                    /* inclip message flag  */
    long num_inbands,    /* total number of input bands to be processed   */
    long *num_outbands   /* total number of output bands to be processed  */
);

#endif
