#include "unknown.h"
#include "util.h"
#include "pixman.h"
#include "protos.h"

void assign
(
    long wind[][4],           /* window specification */
    long totbnd,              /* total no. of input image bands */
    long itype,               /* data type of input pixels */
    double minval[],            /* min pixel value */
    double maxval[],            /* max pixel value */
    long thrshl[],            /* threshold values */
    short unkgry,              /* key for unknown classification */
    long *pixval,       /* and INT form */
    double npixel[][2]         /* no. of pixels in unknown class */
)

/*
--------------------------------------------------------------------
NAME: ASSIGN

PROGRAM HISTORY:
    Version             date            Author		Reason
    -------             ----            ------		------
       4              10-apr-89        K. Narayanan	corrected indx
       3              07-dec-88        B. Allam  	Retrocode
       2              14-aug-85        F. Irani     
       1              30-june-83       J. Hwang

FUNCTION:  Process each line of image
           If the probabilility of the image pixel is lower than the
           threshold value, then classify image pixel as unknown

--------------------------------------------------------------------
*/
{
long nlin,            /* no. of lines */
     npix,            /* no. of pixels */
     i, j, indx,      /* counter variables */
     msg_flag;        /* message flag */
/*
initialize and enable processing message utility
------------------------------------------------
*/
nlin = wind[0][NL];
npix = wind[0][NS];
msg_flag = 0;
curent = 1;
c_inittm("UNKNOWN", "Processed", "line", "bands", " ", &nlin, &totbnd, &msgtim,
         &msg_flag);
c_startm();

/*
initialize minimum and maximum arrays if needed
-----------------------------------------------
*/
if (min_max)
  c_inmnmx (&itype, &totbnd, minval, maxval);

/*
process one line at a time
--------------------------
*/
for (i=0; i < nlin; i++)
   {
   c_estep (&gdesc);
   c_pxcopy (&iobuf[ipoint[0]], &iobuf[opoint[0]], &itype, &npix); 
   for (j=0; j < npix; j++)
      {
      indx = iobuf[ipoint[0]+j] - 1;
      *pixval = iobuf[ipoint[1]+j];
      if (*pixval < thrshl[indx]) 
         {
         iobuf[opoint[0]+j] = unkgry;
         npixel[indx][0] = npixel[indx][0]+1;
         }  
      }  

/*
update min max for image line 
-----------------------------
*/
   if (min_max)
      c_pxmnmx(&iobuf[opoint[0]], &npix, &minval[0], &maxval[0], &itype);
   curent++;
   }  
c_estep (&gdesc);

c_stoptm();
}
