#include "unknown.h"
#include "protos.h"

void class_stats
(
    long nclass,           /* no. of classes */
    char nambuf[][80],     /* class names */
    long thrshl[],         /* threshold values */
    double npixel[][2]     /* no. of pixels in unknown class */
)

/*
--------------------------------------------------------------
NAME: CLASS_STATS

PROGRAM HISTORY:
    Version             date            Author		Retrocode
    -------             ----            ------		---------
       3              07-dec-88        B. Allam  	Retrocode
       2              14-aug-85        F. Irani     
       1              30-june-83       J. Hwang

FUNCTION: Print class and threshold statistics
--------------------------------------------------------------
*/
{
long  i;      
float percn;   /* percentage value */

/*
print class name and threshold value
------------------------------------
*/
printf("\n");
for (i=0; i < nclass; i++)
   {
   printf("Class : %s Threshold value : %4d\n", nambuf[i], thrshl[i]);
   if (npixel[i][1]  !=  0) 
      {
      percn=100.*npixel[i][0]/npixel[i][1];
      }
   else
      {
      percn=0.0;
      }  /* if */
   printf("Class: %s %8d unknown out of %8d (%6.2f percent)\n", nambuf[i], 
          (int)npixel[i][0], (int)npixel[i][1], percn);
   }  /* do */
}
