#include "unknown.h"
#include "protos.h"

void initio
(
    char hosin[][CMLEN],          /*input image host name descriptors */
    char hosout[],                /*output image host name descriptor */
    long nbands[],                    /*no. of bands in each input    */
    long image_band_num[][MAXBND +1], /*band numbers in each          */
    long itype,                       /* data type of input image     */
    long totbnd,                      /* total no. of bands */
    long wind[][4]                   /*input image windows           */
)
{
/*
------------------------------------------------------------------------

NAME: INITIO                         

FUNCTION: INITIO is called by UNKNOWN to initialize the input file
          action group to set up the next output file.

PROGRAM HISTORY:
    Version             date            Author		Reason
    -------             ----            ------		------
       3              07-dec-88        B. Allam  	Retrocode
       2              14-aug-85        F. Irani     
       1              30-june-83       J. Hwang

ALGORITHM:

    Call C_EOPENS to open input and output images
    Call C_EGROUP to group the image

------------------------------------------------------------------------
*/

   long    stat,                  /* flag for EOPENS procedure */
           access,                /* file specifications       */
           type,                  /* data type                 */
           nib,                   /* counter variables         */
           bufsiz;                /* image i/o buffer size     */

long    zero = 0;
long    one = 1;

static long opt[3]={0,0,0};	/* optional parameter array for EOPENS	*/

/*
 set up input file group
 -----------------------
*/

   access = IREAD;
   type = EBYTE;
   nib = 0;
   stat = c_eopens(&fdesc[0], hosin[0], image_band_num[0], &wind[0][SL],
                   &wind[0][SS], &wind[0][NL], &wind[0][NS], &ipoint[nib],
                   &access, &type, &zero, opt);
   if (stat != E_SUCC)
      iso_err (ifilerr, "unknown_ifilerr");
   nib += nbands[0]; 
   stat = c_eopens(&fdesc[1], hosin[1], image_band_num[1], &wind[1][SL],
                   &wind[1][SS], &wind[1][NL], &wind[1][NS], &ipoint[nib],
                   &access, &type, &zero, opt);
   if (stat != E_SUCC)
      iso_err(ifilerr, "unknown_ifilerr");
/*
 set up output file 
 ------------------
*/

   access = IWRITE;
   stat = c_eopens(&fdesc[2], hosout, &totbnd, &one, &one, &wind[0][NL],
                   &wind[0][NS], &opoint[0], &access, &itype, &zero, opt);
   if (stat != E_SUCC)
     iso_err(ofilerr, "unknown_ofilerr");
   fdesc[3] = 0;
   strcpy(out[count], hosout);
   count = count + 1;
/*
set up group containing input and output bands
----------------------------------------------
*/
   if ((iobuf = (unsigned char *) c_ealloc(fdesc, &bufsiz)) == NULL)
     iso_err("!Error allocating dynamic memory", "unknown_alloc");

   if (c_egroup(fdesc, &gdesc, iobuf, &bufsiz) != E_SUCC)
     iso_err("!Error grouping image bands", "unknown_grp");
 }
