#ifndef PROTOS_H
#define PROTOS_H

void assign
(
    long wind[][4],           /* window specification */
    long totbnd,              /* total no. of input image bands */
    long itype,               /* data type of input pixels */
    double minval[],            /* min pixel value */
    double maxval[],            /* max pixel value */
    long thrshl[],            /* threshold values */
    short unkgry,              /* key for unknown classification */
    long *pixval,       /* and INT form */
    double npixel[][2]         /* no. of pixels in unknown class */
);

void class_stats
(
    long nclass,           /* no. of classes */
    char nambuf[][80],     /* class names */
    long thrshl[],         /* threshold values */
    double npixel[][2]     /* no. of pixels in unknown class */
);

void getparm
(
    char ihos[MAXIMG][CMLEN],    /* input host file name */
    char ohos[][CMLEN],           /* output host file name */
    char hos_stat[CMLEN],        /* stats file host name */
    long *nimages,               /* no. of images in input image */
    long *minimages,             /* no. of images in PMIN image */
    long nbands[MAXIMG],         /* no. of bands in each image */
    long bands[][MAXBND + 1],    /* band nos. of each image */
    long *totbnd,                /* total no. of bands in input image */
    char olas[][CMLEN],           /* output LAS file name */
    long *minbnd,                /* total no. of bands in PMIN image */
    long wind[][4],              /* image parameters */
    float *low,                   /* threshold value */
    long *pixval,         /* and INT form */
    short *unkgry                /* key for unknown classification */
);

void initio
(
    char hosin[][CMLEN],          /*input image host name descriptors */
    char hosout[],                /*output image host name descriptor */
    long nbands[],                    /*no. of bands in each input    */
    long image_band_num[][MAXBND +1], /*band numbers in each          */
    long itype,                       /* data type of input image     */
    long totbnd,                      /* total no. of bands */
    long wind[][4]                   /*input image windows           */
);

void iso_err
(
    char *message,
    char *key
);

void read_stats
(
    char hos_stat[CMLEN],       /* stats host file name */
    long *nclass,               /* no. of classes */
    double npixel[][2],          /* no. of pixels in unknown class */
    char nambuf[][80]          /* class names */
);

void thresh
(
    long nclass,          /* no. of classes */
    char nambuf[][80],    /* class names */
    long thrshl[],        /* threshold values */
    float low             /* threshold value */
);

#endif

