#include "unknown.h"
#include "protos.h"

void read_stats
(
    char hos_stat[CMLEN],       /* stats host file name */
    long *nclass,               /* no. of classes */
    double npixel[][2],          /* no. of pixels in unknown class */
    char nambuf[][80]          /* class names */
)
/*
---------------------------------------------------------------------
NAME: READ_STATS

PROGRAM HISTORY:
    Version             date            Author		Reason
    -------             ----            ------		------
       3              07-dec-88        B. Allam  	Retrocode
       2              14-aug-85        F. Irani     
       1              30-june-83       J. Hwang
      
FUNCTION:  Get histogram and class names from statistics file

---------------------------------------------------------------------
*/
{
long i,
     access,            /* mode of access */
     stat,              /* status flag */
     icno[MAXCLS],      /* class index nos. for each class */
     ic,                /* class index no. */
     hist[256],         /* buffer for histogram */
     shape[9];          /* shape vector for histogram */
long    zero = 0;
long    three = 3;

/*
open stats file
---------------
*/
access = IREAD;
stat = c_stopen(&fd_sfin, hos_stat, &access, nclass);
if (stat != E_OPOLD)
   iso_err("!Error opening stats file", "unknown_opnstfail");
if (*nclass < 1)
   iso_err("!No classes in stats file ", "unknown_unablncls");
/* 
get number of sites
-------------------
*/
stat = c_stget (&fd_sfin, "NSITES", &three, &zero, shape, nclass);
if (stat != E_SUCC) 
   iso_err ("!No sites in stats file", "unknown_nosit"); 
for (i=0; i < *nclass; i++)
   icno[i] = i+1;
/*
get histogram from stats file
-----------------------------
*/
stat = c_stget (&fd_sfin, "HISTOGRAM", &icno[0], &zero, shape, hist);
if (stat != E_SUCC) 
   {
   iso_err (unablhist, "unknown_unablhist"); 
   }  
/*
get class names from stats file
-------------------------------
*/
for (i=0; i < *nclass; i++)
   {
   ic = icno[i];
   npixel[i][1] = hist[i+1];
   stat = c_stget (&fd_sfin, "NAME", &three, &ic, shape, nambuf[i]); 
   if (stat != E_SUCC) 
      {
      iso_err (notablnam, "unknown_notablnam"); 
      }  
   }  
}
