
/* include files, global parameters, and definitions for UNKNOWN */

#include <stdio.h>
#include <stdlib.h>
#include "statio.h"
#include "las.h"
#include "util.h"
#include "unknown.msg"
#include "protos.h"

struct PARBLK block;                   /* TAE parameter block     */
struct DDR ddr;

FILE	*fd;                           /* output file descriptor  */

struct FDESC * fdesc[MAXIMG];                 /* file descriptors        */
struct GDESC * gdesc;                         /* group descriptor        */
FILE * fd_sfin;                       /* stats file descriptor   */
long	ipoint[MAXIMG * MAXBND + 1],   /* offsets into image i/o  */
		opoint[MAXBND+1];              /* for input and output bands */
long	min_max;                       /* minmax option flag      */
long 	msgtim;                        /* message interval        */
 
unsigned char	*iobuf;                /* image i/o buffer        */

long    count;                         /* no. of files opened */
char    out[MAXIMG][CMLEN];            /* names of file opened */

extern	long	curcat;                        /* message utility         */
extern	long	curent;                        /* parameters for processing */

int main
(void) /* unknown */
{
/*
--------------------------------------------------------------

NAME: UNKNOWN

PROGRAM HISTORY:
    Version             date            Author		Reason
    -------             ----            ------		------
       6              21-Sep-92        D. Etrheim	Modifed the global
							include file
       5              21-may-91        D. Etrheim	Moved the definition
							of the union to
							unknown.h
       4              10-apr-89        K. Narayanan	changed assign.c
       3              07-dec-88        B. Allam  	Retrocode and Update
       2              14-aug-85        F. Irani     
       1              30-june-83       J. Hwang
      
FUNCTION:
      THE PURPOSE OF THIS PROGRAM IS TO REASSIGN LOW PROBABILITY 
      PIXELS IN EACH CLASS OF A CLASSIFIED IMAGE TO THE UNKNOWN
      CLASS.

--------------------------------------------------------------
*/
char    ihos[MAXIMG][CMLEN],       /* input host file name */
        olas[1][CMLEN],               /* output LAS file name */
        ohos[1][CMLEN],               /* output host file name */
        hos_stat[CMLEN],           /* stats file host name */
        nambuf[32][80];            /* class names */
short   unkgry;                    /* key for unknown classification */
static long bands[MAXIMG][MAXBND+1];   /* band nos. of each image */
long    nclass,                    /* no. of classes */
        nbands[MAXIMG],            /* no. of bands in each image */
        totbnd,                    /* total no. of bands in input image */
        minbnd,                    /* total no. of bands in PMIN image */
        totimg,                    /* total no. of images */
        nimages,                   /* no. of images in input image */
        minimages,                 /* no. of images in PMIN image */
        window[MAXIMG][4];         /* image parameters */
long	itype,                     /* data type of input pixels */
        thrshl[32];                /* threshold values */
float	low;                       /* threshold value */
double	npixel[32][2],             /* no. of pixels in unknown class */
        y_inc,                     /* line increment */
        x_inc,                     /* sample increment */
        minval[MAXBND],            /* min pixel value */
        maxval[MAXBND];            /* max pixel value */
long pixval;               /* and INT form */
long    zero = 0;
long    one = 1;

count = 0;
/*
get parameters
--------------
*/
getparm(ihos, ohos, hos_stat, &nimages, &minimages, nbands, bands, &totbnd,
        olas, &minbnd, window, &low, &pixval, &unkgry);

/*
read stats file
---------------
*/
read_stats(hos_stat, &nclass, npixel, nambuf);

/*
get input file size
-------------------
*/
c_getddr (ihos[0], &ddr); 
window[0][SL] = 1;
window[0][SS] = 1;
window[0][NL] = ddr.nl;
window[0][NS] = ddr.ns;
itype = ddr.dtype;
c_getddr (ihos[0], &ddr); 
window[1][SL] = 1;
window[1][SS] = 1;
window[1][NL] = ddr.nl;
window[1][NS] = ddr.ns;

/*
set up file specifications
--------------------------
*/
initio(ihos, ohos[0], nbands, bands, itype, totbnd, window);

/*
prompt for threshold values if needed
-------------------------------------
*/
thresh(nclass, nambuf, thrshl, low);

/*
assign pixels to classes
------------------------
*/
assign(window, totbnd, itype, minval, maxval, thrshl, unkgry, &pixval,
       npixel);

/*
print class statistics
----------------------
*/
class_stats(nclass, nambuf, thrshl, npixel);

/*
close files
-----------
*/
c_egclse(&gdesc);
c_stclse(&fd_sfin);

/*
copy history
------------
*/
totimg = nimages + minimages;
c_hstout (&block, ohos[0], ihos, &totimg, " "); 

/*
update label
------------
*/
y_inc = 1;
x_inc = 1;
c_upddr (&block, ihos, ohos[0], &nimages, window, bands, nbands, &y_inc, &x_inc,
         &totbnd, &zero);
if (min_max)
  c_svmnmx (ohos[0], &totbnd, minval, maxval, "YES");


c_complt ("UNKNOWN", olas, &one); 

return EXIT_SUCCESS;

} 
