/************************************************************************

NAME:				QUICKSORT

PURPOSE: Sort a floating point array

************************************************************************/
#include <stdio.h>
#include "verify2.h"

void quicksort
(
    double error[],     /* I/O: Array to be partitioned     */
    long left,          /* I: Left boundary of the array    */
    long right		/* I: Right boundary of the array   */
)
{
long i, j; 
double temp;

if (right - left == 1)
   {
   if (error[right] < error[left])
      {
      temp = error[left]; 
      error[left] = error[right]; 
      error[right] = temp;
      }
   }
else
if (right - left > 1)
   { 
   partition(error, left, right, &i, &j);
   quicksort(error, left, j);
   quicksort(error, i, right);
   }
}

void partition
(
    double error[],     /* I/O: Array to be partitioned       */
    long left,		/* I: Left boundary of the array      */
    long right,		/* I: Right boundary of the array     */
    long *ri,		  
    long *rj		/* O: Partition points to be returned */
)
{
double r, temp;
long i, j;

r = error[(left + right)/2];	/* Middle element */
i = left; j = right;

while (i <= j)
  {
  /* Extend the left partition. Upon loop termination error[i] >= r
  ----------------------------------------------------------------*/
  while (error[i] < r)
      i++;

  /* Extend the right partition. Upon loop termination error[j] <= r
  -----------------------------------------------------------------*/
  while (error[j] > r)
      j--; 

  /* Exchange the elements and update i and j 
  -----------------------------------------*/
  if (i <= j)
    {
    temp = error[i]; error[i] = error[j]; error[j] = temp;
    i++;
    j--;
    }
  }

/* Return the partitioning positions
----------------------------------*/
*ri = i;
*rj = j;
}
