#ifndef VERIFY2_H
#define VERIFY2_H

#include "las.h"
#define MAX_REGIONS 100          /* Maximum number of regions */

struct POINT{
       double x;         /* Line coordinate */
       double y;         /* Sample coordinate */
       char ptnum[21];   /* Point identification number */
       };

struct PTREG{
       char ptnum[21];   /* Point identification number */
       long num;         /* Point number in relation to number of points */
       };


void getpar
(
    struct PARBLK *vblk,/* I: TAE parameter block			*/
    char intpl[],	/* O: The input Tie Point Location file name 	*/
    double *psout,	/* O: Pixel size in output space 		*/
    long *linereg,	/* O: Number of line regions in image 		*/
    long *sampreg,	/* O: Number of sample regions in image 	*/
    long *sl,		/* O: starting line				*/
    long *ss,		/* O: starting sample				*/
    long *lines,	/* O: Total number of lines in the image 	*/
    long *samps,	/* O: Total number of samples in the image 	*/
    long *accnum,	/* O: Number of user specified accuracy levels 	*/
    double pixacc[],	/* O: User input pixel accuracy desired 	*/
    long *log_flag,	/* O: the flag for the 1st output file		*/
    char logfile[],	/* O: The image statistics logfile 		*/
    long *plot_flag,	/* O: the plot flag 				*/
    char plotname[],	/* O: The plot file 				*/
    char prtfile[],    	/* O: print file name                      	*/
    char filename[],	/* O: print file name				*/
    long print[]        /* O: print option                         	*/
);

void quicksort
(
    double error[],     /* I/O: Array to be partitioned     */
    long left,          /* I: Left boundary of the array    */
    long right		/* I: Right boundary of the array   */
);

void partition
(
    double error[],     /* I/O: Array to be partitioned       */
    long left,		/* I: Left boundary of the array      */
    long right,		/* I: Right boundary of the array     */
    long *ri,		  
    long *rj		/* O: Partition points to be returned */
);

void report
(
    char intpl[],		/* I: The input Tie Point Location file name */
    char logfile[],		/* I: The image statistics logfile           */
    char prtfile[],		/* I: print file name                        */
    char plotname[],		/* I: The plot file                          */
    long npts,			/* I: Total number of verification points    */
    double psout, 		/* I: Pixel size in output space             */
    long linereg, 		/* I: Number of line regions in image 	     */
    long sampreg, 		/* I: Number of sample regions in image      */
    double pixacc[],		/* I: User input pixel accuracy desired      */
    struct POINT pointref[], 	/* I: Reference image point array 	     */
    struct POINT pointsrch[],	/* I: Search image point array 		     */
    char units[],		/* I: units				     */
    long sl,             	/* I: starting line                          */
    long ss,             	/* I: starting sample                        */
    long lines, 		/* I: Total number of lines in the image     */
    long samps, 		/* I: Total number of samples in the image   */
    long accnum,		/* I: Number of user specified accuracy levels*/
    long log_flag,		/* I: log flag				     */
    long plot_flag		/* I: plot flag				     */
);
#endif
