/*****************************************************************************

NAME: free_shift_buf.c

PURPOSE: Free the four shift buffers associated with the shift-invariant
         discrete wavelet transform (SIDWT).

PROGRAM HISTORY:
  Version       Date       Author             Comments
  -------       ----       ------             -------
    1           05/00    L. Johnson           Original development.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT: WAVEMERGE

ALGORITHM DESCRIPTION:
     N/A.

REFERENCES:
     None.
*****************************************************************************/

#include<stdlib.h>
#include "wavelet.h"


void free_shift_buf
(
    shift_buf buf           /* I: shift buffer structure to be freed        */
)
{
  if (buf[NONE] != NULL)
  {
      free (buf[NONE]);
      free (buf[RIGHT]);
      free (buf[DOWN]);
      free (buf[DIAGONAL]);
      buf[NONE] = NULL;
      buf[RIGHT] = NULL;
      buf[DOWN] = NULL;
      buf[DIAGONAL] = NULL;
  }
}
