#ifndef WINDOP_H
#define WINDOP_H

/* getpar.c */
void getpar
(
  struct PARBLK *vblock,         /* I: Pointer to TAE block */
  char taein[][CMLEN],           /* O: TAE filenames of input images */
  char hosin[][CMLEN],           /* O: Host filenames of input images */
  char *taeout,                  /* O: TAE filenmae of output image */
  char *hosout,                  /* O: Host filename of output image */
  long *nmrimg,                  /* O: Number of input images */
  long (*bands)[MAXBND+1],       /* O: Band specification */
  long *nbands,                  /* O: Number of bands per input image */
  long (*window)[4],             /* O: Window specification */
  long *msgtim,                  /* O: Time between display messages */
  long *mnmx,                    /* O: Min/Max value */
  long *totbnd,                  /* O: Total number of bands */
  long *kernel,                  /* O: Kernel dimensions (nl,ns) */
  long *skippix,                 /* O: Number of pixels to skip */
  char *typeopt,                 /* O: Type of averaging */
  long *odtype,                  /* O: Output data types */
  float maskval[][2],            /* O: Mask values */
  long *masknum,                 /* O: Number of masked values */
  float *pixval                  /* O: Pixel value to replace mask values */
);

/* proces.c */
void proces
(
  struct PARBLK *vblock,          /* I: TAE parameter block */
  char hosin[][CMLEN],            /* I: Host names of input images */
  char *hosout,                   /* I: Host name of output image */
  long nmrimg,                    /* I: Number of input images */
  long (*bands)[MAXBND+1],        /* I: Band specification */
  long *nbands,                   /* I: Number of bands per input image */
  long (*window)[4],              /* I: Window specs of input images */
  long msgtim,                    /* I: Time between display messages */
  long mnmx,                      /* I: Min/Max values */
  long totbnd,                    /* I: Total number of bands to process */
  long *kernel,                   /* I: Kernel dimensions (nl,ns) */
  long *skippix,                  /* I: Number of pixels to skip */
  char *typeopt,                  /* I: Type of averaging */
  long odtype,                    /* I: Output data type */
  long masknum,                   /* I: Number of mask values */
  float maskval[][2],             /* I: Mask values */
  float pixval                    /* I: Pixel value to replace mask values */
);

/* procmax.c */
int procmax
(
  long nmrimg,                   /* I: Number of input images */
  long *nbands,                  /* I: Number of bands per input image */
  char *hosout,                  /* I: Host name of output image */
  struct PARBLK *vblock,         /* I: TAE parameter block */
  long (*bands)[MAXBND+1],       /* I: Bands to be processed for all images */
  long mnmx,                     /* I: Min/Max values */
  long *kernel,                  /* I: Kernel dimensions (nl,ns) */
  long *skippix,                 /* I: Number of pixels to skip */
  long odtype,                   /* I: Output data type */
  long maxsamp,                  /* I: Number of samples in output image */
  long windl,                    /* I: Maximum line to retrieve */
  long size,                     /* I: Number of bytes per pixel */
  double minval[MAXBND],         /* O: Min pixel value array */
  double maxval[MAXBND],         /* O: Max pixel value array */
  long masknum,                  /* I: Number of mask values */
  float maskval[][2],            /* I: Mask values */
  float pixval,                  /* I: Pixel value to replace mask values */
  long ns                        /* I: Number of samples in input */
);

/* procmin.c */
int procmin
(
  long nmrimg,                   /* I: Number of input images */
  long *nbands,                  /* I: Number of bands per input image */
  char *hosout,                  /* I: Host name of output image */
  struct PARBLK *vblock,         /* I: TAE parameter block */
  long (*bands)[MAXBND+1],       /* I: Bands to be processed for all images */
  long mnmx,                     /* I: Min/Max values */
  long *kernel,                  /* I: Kernel dimensions (nl,ns) */
  long *skippix,                 /* I: Number of pixels to skip */
  long odtype,                   /* I: Output data type */
  long maxsamp,                  /* I: Number of samples in output image */
  long windl,                    /* I: Maximum line to retrieve */
  long size,                     /* I: Number of bytes per pixel */
  double minval[MAXBND],         /* O: Min pixel value array */
  double maxval[MAXBND],         /* O: Max pixel value array */
  long masknum,                  /* I: Number of mask values */
  float maskval[][2],            /* I: Mask values */
  float pixval,                  /* I: Pixel value to replace mask values */
  long ns                        /* I: Number of samples in input */
);

/* promean.c */
int promean
(
  long nmrimg,                   /* I: Number of input images */
  long *nbands,                  /* I: Number of bands per input image */
  char *hosout,                  /* I: Host name of output image */
  struct PARBLK *vblock,         /* I: TAE parameter block */
  long (*bands)[MAXBND+1],       /* I: Bands to be processed for all images */
  long mnmx,                     /* I: Min/Max values */
  long *kernel,                  /* I: Kernel dimensions (nl,ns) */
  long *skippix,                 /* I: Number of pixels to skip */
  long odtype,                   /* I: Output data type */
  long maxsamp,                  /* I: Number of samples in output image */
  long windl,                    /* I: Maximum line to retrieve */
  long size,                     /* I: Number of bytes per pixel */
  double minval[MAXBND],         /* O: Min pixel value array */
  double maxval[MAXBND],         /* O: Max pixel value array */
  long masknum,                  /* I: Number of mask values */
  float maskval[][2],            /* I: Mask values */
  float pixval,                  /* I: Pixel value to replace mask values */
  long ns                        /* I: Number of samples in input */
);

/* windop.c */
void main
(
  void
);

#endif
