#ifndef PROTOS_H
#define PROTOS_H

void apply_xcor
(
    struct PARBLK *vblock,  /* TAE parameter block			  */
    double mnlinlen[],      /* avg raw line length                        */
    long nomlen,            /* nominal line length     		   */
    long msgtim, 	     /* elapsed time between display messages      */
    char minmax[],          /* min max flag				   */
    long bands[][MAXBND+1], /* band specification			   */
    long btot,	             /* total number of output image bands         */
    char method[],          /* resampling method		           */
    char hosin[][CMLEN],	/* pointer to input host file descriptor	*/
    char hosout[][CMLEN],        /* pointer to output host file descriptor	*/
    long bckgnd,            /* background fill value 		  	   */
    float alpha,		     /* tension parameter for parametric cubic
			        convolution resampling 	        */
    long maxlim,            /* maximum interpolation value     	   */
    long minlim,            /* minimum interpolation value		   */
    char *tabhos    	/* pointer to table host file descriptor	*/
);

void get_info
(
    double mnlinlen[],     /* mean actual line length	                */
    long *nomlen,       /* nominal line length      		    	     */
    char *xcorhos      /* pointer to correction file host name descriptor */
);

void getpar
(
    struct PARBLK *vblock,       /* pointer to TAE parameter block            */
    char taein[][CMLEN],        /* pointer to input TAE file descriptor      */
    char hosin[][CMLEN],	/* pointer to input host file descriptor     */
    char taeout[][CMLEN],  /* pointer to output TAE file descriptor     */
    char hosout[][CMLEN],   /* pointer to output host file descriptor    */
    long bands[][MAXBND+1],	/* band specification 			     */
    long *btot,		        /* total number of output image bands	     */
    long *msgtim,		/* elapsed time between display messages     */
    char *minmax,		/* min max flag buffer                       */
    char *method,		/* resampling method		             */
    long *bckgnd,                /* background fill value	             */
    float *alpha,               /* cubic convolution alpha parameter         */
    long *maxlim,               /* maximum interpolation value		     */
    long *minlim,                /* minimum interpolation value		     */
    char *tabhos, 	        /* pointer to user-defined table file desc.  */
    char *xcorhos               /* pointer to corrections file descriptor    */
);

void make_table
(
    float table[],		/* resampling weight table	        */
    long *tabsiz,		        /* size of resampling table	        */
    char method[],		/* method of resampling	                */
    float alpha,			/* tension parameter for parametric cubic
				   convolution resampling 	        */
    char *tabhos  		/* pointer to table file descriptor     */
);

#endif

