#ifndef NOTAE_H
#define NOTAE_H

#include "ddr.h" /* DDR/BDDR structure definitions */
#include "imageio.h" /* MAXBND definition */

int notae_upddr
(
    long ddrvflag,            /* flag to use when DDR not valid      */
    double projtol,           /* Tolerance global                    */
    struct DDR in_ddr[],      /* input ddrs                          */
    struct DDR *out_ddr,      /* output ddr                          */
    struct BDDR in_bddr[],    /* input band dependent ddr records    */
    struct BDDR out_bddr[],   /* output band dependent ddr record    */
    long *nmrimg,             /* Total number of input images        */
    long window[][4],         /* Window specifications for images    */
    long nbands[],            /* number of bands for input images    */
    double *line_inc,         /* increment in the line direction     */
    double *samp_inc,         /* increment in the sample direction   */
    long *out_nbands,         /* number of output bands              */
    long *cflag               /* combination of bands flag           */
);

#endif
