/*
 *  This is the creation routine for the layout panel.  It was generated 
 *  using the ICS builderXcessory (BX).
 *
 *  By L.Huewe, USGS/EROS Data Center, 2/93.
 *    - X Image Display, v1.0.
 *
 *  Modified by L.Huewe, USGS/EROS Data Center, 3/94
 *    - Added the appropriate callbacks to require the user to select the
 *      "apply" button before the colormap change is employed.
 *
 */
#include "xid.h"
#include "pixmaps.h"
#include "xid_func.h"
#include "main.h"

Widget Createpref_form
(
   Widget parent
)
{
    Arg         args[512];
    Cardinal    argcnt;
    Widget      retval;
    XmString    xmstr[32];

    /* Create the "preferences panel" form widget.  */
    XtInitializeWidgetClass(xmFormWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 304); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 176); argcnt++;
    pref_form = XtCreateWidget("pref_form", xmFormWidgetClass, parent, args,
                               argcnt);
    retval = pref_form;

    /* Create the "cursor color" label widget.  */
    XtInitializeWidgetClass(xmLabelWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Cursor Color:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    pref_cursor_label = XtCreateWidget("pref_cursor_label", xmLabelWidgetClass,
                                       pref_form, args, argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(pref_cursor_label);

    /* Create the "number of image colors" label.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Image Colors:", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 35); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    pref_colors_label = XtCreateWidget("pref_colors_label", xmLabelWidgetClass,
                                       pref_form, args, argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(pref_colors_label);

    /* Create the "number of image colors" radio box.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 62); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 81); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, pref_colors_label); argcnt++;
    pref_imagecolors = XtCreateWidget("pref_imagecolors",
                                      xmRowColumnWidgetClass, pref_form, args,
                                      argcnt);
    XtManageChild(pref_imagecolors);

    /* Create the "200 colors" toggle button.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "200", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 56); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 36); argcnt++;
    pref_200 = XtCreateWidget("pref_200", xmToggleButtonWidgetClass,
                              pref_imagecolors, args, argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(pref_200);

    /* Create the "256 colors" toggle button.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "256", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 56); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 36); argcnt++;
    pref_256 = XtCreateWidget("pref_256", xmToggleButtonWidgetClass,
                              pref_imagecolors, args, argcnt);
    XmStringFree( xmstr[0] );
    XtManageChild(pref_256);

    /* Create the "cancel" button widget.  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Cancel", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 137); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 83); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 29); argcnt++;
    pref_cancel_button = XtCreateWidget("pref_cancel_button",
                                        xmPushButtonWidgetClass, pref_form,
                                        args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_cancel_button, XmNactivateCallback, pref_cancel,
                  (caddr_t)0);
    XtManageChild(pref_cancel_button);

    /* Create the "apply" button widget.  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Apply", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 129); argcnt++;
    XtSetArg(args[argcnt], XmNy, 113); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 83); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 29); argcnt++;
    pref_apply_button = XtCreateWidget("pref_apply_button",
                                       xmPushButtonWidgetClass, pref_form,
                                       args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_apply_button, XmNactivateCallback, pref_apply,
                  (caddr_t)0);
    XtManageChild(pref_apply_button);

    /* Create a separator widget.  */
    XtInitializeWidgetClass(xmSeparatorWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNx, 5); argcnt++;
    XtSetArg(args[argcnt], XmNy, 93); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 212); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNbottomWidget, pref_cancel_button); argcnt++;
    pref_separator = XtCreateWidget("pref_separator", xmSeparatorWidgetClass,
                                    pref_form, args, argcnt);
    XtManageChild(pref_separator);

    /* Create the "cursor color" menu shell.  */
    XtInitializeWidgetClass(xmMenuShellWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    XtSetArg(args[argcnt],XtNvisual,xid.visual_info[0].visual); argcnt++;
    XtSetArg(args[argcnt],XtNcolormap,xid.colormap); argcnt++;
    XtSetArg(args[argcnt],XtNdepth,xid.visual_info[0].depth); argcnt++;
    pref_menushell = XtCreatePopupShell("pref_menushell",
                                        xmMenuShellWidgetClass, pref_form,
                                        args, argcnt);

    /* Create the "cursor color" pulldown menu.  */
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 75); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 224); argcnt++;
    pref_cursor_pulldown = XtCreateWidget("pref_cursor_pulldown",
                                          xmRowColumnWidgetClass,
                                          pref_menushell, args, argcnt);

    /* Create the first cursor color button widget (black).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + BLACK_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[0], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    pref_color1_button = XtCreateWidget("pref_color1_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color1_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)0);
    XtManageChild(pref_color1_button);

    /* Create the second cursor color button widget (white).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + WHITE_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[1], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color2_button = XtCreateWidget("pref_color2_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color2_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)1);
    XtManageChild(pref_color2_button);

    /* Create the third cursor color button widget (red).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + RED_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[2], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color3_button = XtCreateWidget("pref_color3_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color3_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)2);
    XtManageChild(pref_color3_button);

    /* Create the fourth cursor color button widget (green).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + GREEN_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[3], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color4_button = XtCreateWidget("pref_color4_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color4_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)3);
    XtManageChild(pref_color4_button);

    /* Create the fifth cursor color button widget (blue).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + BLUE_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[4], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color5_button = XtCreateWidget("pref_color5_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color5_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)4);
    XtManageChild(pref_color5_button);

    /* Create the sixth cursor color button widget (yellow).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + YELLOW_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[5], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color6_button = XtCreateWidget("pref_color6_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color6_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)5);
    XtManageChild(pref_color6_button);

    /* Create the seventh cursor color button widget (magenta).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + MAGENTA_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[6], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color7_button = XtCreateWidget("pref_color7_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color7_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)6);
    XtManageChild(pref_color7_button);

    /* Create the eighth cursor color button widget (cyan).  */
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,
             xid.color_table[RGBBW_IDX + CYAN_COL].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             wk_colors[7], XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    pref_color8_button = XtCreateWidget("pref_color8_button",
                                        xmPushButtonWidgetClass,
                                        pref_cursor_pulldown, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(pref_color8_button, XmNactivateCallback, pref_setcursor,
                  (caddr_t)7);
    XtManageChild(pref_color8_button);

    /* Create the "cursor color" option menu.  */
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 5); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 15); argcnt++;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_OPTION); argcnt++;
    XtSetArg(args[argcnt], XmNx, 15); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 115); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 35); argcnt++;
    XtSetArg(args[argcnt], XmNsubMenuId, pref_cursor_pulldown); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, pref_cursor_label); argcnt++;
    XtSetArg(args[argcnt], XmNmenuHistory, pref_color4_button); argcnt++;
    XtSetArg(args[argcnt], XmNforeground,xid.color_table[RGBBW_IDX + 
             xid.cursor_color].pixel); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    pref_cursor_option = XtCreateWidget("pref_cursor_option",
                                        xmRowColumnWidgetClass, pref_form,
                                        args, argcnt);
    XtManageChild(pref_cursor_option);

    /* Create the "help" button.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, XPM_PIXMAP(parent, helpxbm_width,
             helpxbm_height, helpxbm_ncolors, helpxbm_chars_per_pixel,
             helpxbm_colors, helpxbm_pixels)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 263); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 31); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 31); argcnt++;
    pref_help_button = XtCreateWidget("pref_help_button",
                                      xmPushButtonWidgetClass, pref_form,
                                      args, argcnt);
    XtAddCallback(pref_help_button, XmNactivateCallback, help_update,
                  (caddr_t)"pref.html");
    XtManageChild(pref_help_button);

    /* Set the form attachments.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 30); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, pref_cursor_option); argcnt++;
    XtSetValues(pref_imagecolors, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNleftOffset, 35); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNleftWidget, pref_cursor_label); argcnt++;
    XtSetValues(pref_colors_label, args, argcnt);

    return( retval );
}
