/*
 *  This is the creation routine for the profile panel.  It was generated 
 *  using the ICS builderXcessory (BX).
 *
 *  By D. Akkerman/L.Huewe, USGS/EROS Data Center, 9/91.
 *    - X Image Display, v1.0.
 *
 */
#include "xid.h"
#include "pixmaps.h"
#include "xid_func.h"
#include "main.h"

Widget Createprofile_form
(
   Widget parent
)
{
    Arg         args[512];
    int         argcnt;
    long        clear_bits;    /* Variable used to clear individual bits.    */
    Widget      retval;
    XmString    xmstr[32];
    Dimension   shadow,border,hilight,width,height;

    XmRegisterConverters();
 
    /* Create the main bulletin board.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 600); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 400); argcnt++;
    profile_form = XtCreateWidget("profile_form", xmFormWidgetClass, parent,
                                  args, argcnt);
    retval = profile_form;

    /* Add an event handler for exposure events.  */
    XtAddEventHandler(profile_form,ExposureMask,FALSE,profile_expose_event,
                      NULL);

    /* Set profile flags.  */
    xid_profile.flags = (PROF_X | PROF_AUTO | PROF_CONT);
    clear_bits = ~(PROF_Y | PROF_Z | PROF_MAN | PROF_DIS); 
    xid_profile.flags = xid_profile.flags & clear_bits;

    /* Create the help button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelType, 1); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, XPM_PIXMAP(parent, helpxbm_width,
             helpxbm_height, helpxbm_ncolors, helpxbm_chars_per_pixel,
             helpxbm_colors, helpxbm_pixels)); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 529); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 31); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 31); argcnt++;
    profile_help_button = XtCreateWidget("profile_help_button",
                                         xmPushButtonWidgetClass, profile_form,
                                         args, argcnt);
    XtAddCallback(profile_help_button, XmNactivateCallback, help_update, 
                  (caddr_t)"profile.html");
    XtManageChild(profile_help_button);

    /* Create the dismiss button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNshadowThickness, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginLeft, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginRight, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginTop, 2); argcnt++;
    XtSetArg(args[argcnt], XmNmarginBottom, 2); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Dismiss", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 477); argcnt++;
    XtSetArg(args[argcnt], XmNy, 333); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 83); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 29); argcnt++;
    profile_dismiss_button = XtCreateWidget("profile_dismiss_button",
                                            xmPushButtonWidgetClass,
                                            profile_form, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_dismiss_button, XmNactivateCallback, profile_destroy,
                  (caddr_t)0);
    XtManageChild(profile_dismiss_button);
 
    /* Create the <Continuous><Discrete> radio box.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 67); argcnt++;
    XtSetArg(args[argcnt], XmNx, 381); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 120); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 73); argcnt++;
    profile_cd_radiobox = XtCreateWidget("profile_cd_radiobox",
                                         xmRowColumnWidgetClass, profile_form,
                                         args, argcnt);
    XtManageChild(profile_cd_radiobox);

    /* Create the <Automatic><Manual> radio box.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNshadowThickness, 0); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 0); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 79); argcnt++;
    XtSetArg(args[argcnt], XmNx, 381); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 108); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 73); argcnt++;
    profile_am_radiobox = XtCreateWidget("profile_am_radiobox",
                                         xmRowColumnWidgetClass, profile_form,
                                         args, argcnt);
    XtManageChild(profile_am_radiobox);

    /* Create the <X><Y><Z><User-selected> radio box.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNpacking, XmPACK_COLUMN); argcnt++;
    XtSetArg(args[argcnt], XmNradioAlwaysOne, True); argcnt++;
    XtSetArg(args[argcnt], XmNradioBehavior, True); argcnt++;
    XtSetArg(args[argcnt], XmNborderWidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_NONE); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 51); argcnt++;
    XtSetArg(args[argcnt], XmNx, 379); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 138); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 143); argcnt++;
    profile_dir_radiobox = XtCreateWidget("profile_dir_radiobox",
                                          xmRowColumnWidgetClass, profile_form,
                                          args, argcnt);
    XtManageChild(profile_dir_radiobox);
 
    /* Create the profile data scrolled window.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNscrollingPolicy, XmAUTOMATIC); argcnt++;
    XtSetArg(args[argcnt], XmNscrollBarDisplayPolicy, XmSTATIC); argcnt++;
    XtSetArg(args[argcnt], XmNleftAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNbottomAttachment, XmATTACH_FORM); argcnt++;
    XtSetArg(args[argcnt], XmNleftOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNrightOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNbottomOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 359); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 376); argcnt++;
    XtSetArg(args[argcnt], XmNrightAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNrightWidget, profile_dir_radiobox); argcnt++;
    profile_scrollwin = XtCreateWidget("profile_scrollwin",
                                       xmScrolledWindowWidgetClass,
                                       profile_form, args, argcnt);
    XtSetArg(args[0],XmNhorizontalScrollBar,&profile_hor_scrollbar);
    XtSetArg(args[1],XmNverticalScrollBar,&profile_vert_scrollbar);
    XtGetValues(profile_scrollwin,args,2);
    XtAddCallback(profile_hor_scrollbar, XmNdragCallback, profile_expose, 
                  (caddr_t)0);
    XtAddCallback(profile_hor_scrollbar, XmNvalueChangedCallback, 
                  profile_expose, (caddr_t)0);
    XtAddCallback(profile_vert_scrollbar, XmNdragCallback, profile_expose,
                  (caddr_t)0);
    XtAddCallback(profile_vert_scrollbar, XmNvalueChangedCallback, 
                  profile_expose, (caddr_t)0);
    XtManageChild(profile_scrollwin);
 
    /* Create the bulletinboard within the scrolled window to contain the
       profile data.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNmarginWidth, (short)0); argcnt++;
    XtSetArg(args[argcnt], XmNmarginHeight, (short)0); argcnt++;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_ANY); argcnt++;
    XtSetArg(args[argcnt], XmNnoResize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 0); argcnt++;
    XtSetArg(args[argcnt], XmNy, 0); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 512); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 512); argcnt++;
    profile_scrollwin_bulletinboard =
                              XtCreateWidget("profile_scrollwin_bulletinboard",
                                             xmBulletinBoardWidgetClass,
                                             profile_scrollwin, args, argcnt);
    XtManageChild(profile_scrollwin_bulletinboard);
 
    /* Create the "X" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "X", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    profile_x_button = XtCreateWidget("profile_x_button",
                                      xmToggleButtonWidgetClass,
                                      profile_dir_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_x_button, XmNarmCallback, profile_dir, (caddr_t)"X");
    XtManageChild(profile_x_button);
 
    /* Create the "Y" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Y", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 29); argcnt++;
    profile_y_button = XtCreateWidget("profile_y_button",
                                      xmToggleButtonWidgetClass,
                                      profile_dir_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_y_button, XmNarmCallback, profile_dir, (caddr_t)"Y");
    XtManageChild(profile_y_button);
 
    /* Create the "Z" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Z", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 55); argcnt++;
    profile_z_button = XtCreateWidget("profile_z_button",
                                      xmToggleButtonWidgetClass,
                                      profile_dir_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_z_button, XmNarmCallback, profile_dir, (caddr_t)"Z");
    XtManageChild(profile_z_button);
 
    /* Create the "User-selected" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, False); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "User-selected", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 81); argcnt++;
    profile_user_button = XtCreateWidget("profile_user_button",
                                         xmToggleButtonWidgetClass,
                                         profile_dir_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_user_button, XmNarmCallback, profile_dir,
                  (caddr_t)"US");
    XtManageChild(profile_user_button);
 
    /* Create the "Automatic" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Automatic", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    profile_auto_button = XtCreateWidget("profile_auto_button",
                                         xmToggleButtonWidgetClass,
                                         profile_am_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_auto_button,XmNarmCallback,profile_am,(caddr_t)"A");
    XtManageChild(profile_auto_button);
 
    /* Create the "Manual" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Manual", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 29); argcnt++;
    profile_man_button = XtCreateWidget("profile_man_button",
                                        xmToggleButtonWidgetClass,
                                        profile_am_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_man_button,XmNarmCallback,profile_am,(caddr_t)"M");
    XtManageChild(profile_man_button);

    /* Create the "Continuous" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Continuous", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, True); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 3); argcnt++;
    profile_cont_button = XtCreateWidget("profile_cont_button",
                                         xmToggleButtonWidgetClass,
                                         profile_cd_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_cont_button,XmNarmCallback,profile_cd,(caddr_t)"C");
    XtManageChild(profile_cont_button);
 
    /* Create the "Discrete" toggle button widget.  */
    argcnt = 0;
    XtSetArg(args[argcnt], XmNsensitive, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, (xmstr[0]=XmStringCreateLtoR(
             "Discrete", XmSTRING_DEFAULT_CHARSET))); argcnt++;
    XtSetArg(args[argcnt], XmNx, 3); argcnt++;
    XtSetArg(args[argcnt], XmNy, 29); argcnt++;
    profile_dis_button = XtCreateWidget("profile_dis_button",
                                        xmToggleButtonWidgetClass,
                                        profile_cd_radiobox, args, argcnt);
    XmStringFree( xmstr[0] );
    XtAddCallback(profile_dis_button,XmNarmCallback,profile_cd,(caddr_t)"D");
    XtManageChild(profile_dis_button);

    /* Retrieve the width, shadow thickness, border width, and highlight
       thickness of the vertical scrollbar.  This information is used to
       calculate the appropriate size of the scrolled window.  */
    XtSetArg(args[0],XmNwidth,&width);
    XtSetArg(args[1],XmNshadowThickness,&shadow);
    XtSetArg(args[2],XmNborderWidth,&border);
    XtSetArg(args[3],XmNhighlightThickness,&hilight);
    XtGetValues(profile_vert_scrollbar,args,4);
    xid_profile.view_xoffset = width + border * 2 + shadow * 2 + hilight * 2;

    /* Retrieve the height, shadow thickness, border width, and highlight
       thickness of the horizontal scrollbar.  This information is used to
       calculate the appropriate size of the scrolled window.  */
    XtSetArg(args[0],XmNheight,&height);
    XtSetArg(args[1],XmNshadowThickness,&shadow);
    XtSetArg(args[2],XmNborderWidth,&border);
    XtSetArg(args[3],XmNhighlightThickness,&hilight);
    XtGetValues(profile_hor_scrollbar,args,4);
    xid_profile.view_yoffset = height + border * 2 + shadow * 2 + hilight * 2;

    /* Retrieve the shadow thickness and  border width of the scrolled window.
       This information is used to calculate the appropriate size of the
       scrolled window.  */
    XtSetArg(args[0],XmNshadowThickness,&shadow);
    XtSetArg(args[1],XmNborderWidth,&border);
    XtGetValues(profile_scrollwin,args,2);
    xid_profile.view_xoffset += (shadow * 2 + border * 2);
    xid_profile.view_yoffset += (shadow * 2 + border * 2);

    /* Retrieve the shadow thickness and  border width of the bulletinboard
       contained within the scrolled window.  This information is used to
       calculate the appropriate size of the scrolled window.  */
    XtSetArg(args[0],XmNshadowThickness,&shadow);
    XtSetArg(args[1],XmNborderWidth,&border);
    XtGetValues(profile_scrollwin_bulletinboard,args,2);
    xid_profile.view_xoffset += (shadow * 2 + border * 2);
    xid_profile.view_yoffset += (shadow * 2 + border * 2);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, profile_dir_radiobox); argcnt++;
    XtSetValues(profile_am_radiobox, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNtopOffset, 10); argcnt++;
    XtSetArg(args[argcnt], XmNtopAttachment, XmATTACH_WIDGET); argcnt++;
    XtSetArg(args[argcnt], XmNtopWidget, profile_am_radiobox); argcnt++;
    XtSetValues(profile_cd_radiobox, args, argcnt);

    return( retval );
}
