#ifndef XID_FUNC_H
#define XID_FUNC_H

#include "worgen.h" /* CMLEN definition */
#include "imageio.h" /* MAXBND definition */

void config_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_am
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_create
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void cursor_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_latlong
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_mo
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_proj
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_unscaled
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_xyz
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_zslider
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void cursor_track
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void cursor_expose
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void cursor_pointer
(
   Widget w,
   XtPointer client_data,
   XEvent *call_data,
   Boolean *cont
);

void cursor_sub
(
   long    xcursor,            /* Zero relative X position of crosshair (I). */
   long    ycursor,            /* Zero relative Y position of crosshair (I). */
   double  *xsub,              /* X location of input point (subpixel
                                  accuracy) (O)                              */
   double  *ysub,              /* Y location of input point (subpixel
                                  accuracy) (O)                              */
   long    skipl,              /* Line subsampling factor (I)                */
   long    skips,              /* Sample subsampling factor (I)              */
   long    fsl,                /* Starting line (file coordinate) of the image
                                  the coordinate is being calculated for (I) */
   long    fss                 /* Starting sample (file coordinate) of the 
                                  image the coordinate is being calculated 
                                  for (I)                                    */
);

void fill_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_dest
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_method
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_mode
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_select
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_type
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_unselect
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fill_unselect_all
(void);

void fill_window
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_start
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_accept_combo
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_rate
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_select
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_stop
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_delete
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_step
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_clear
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void flicker_extension
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fullres_create
(void);

void fullres_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fullres_size
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void fullres_button
(
   Widget w,
   caddr_t client,
   caddr_t call
);

void fullres_setup
(void);

void fullres_outline
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int fullres_make_flicker_pixmaps
(void);

void histo_create
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void histo_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void histo_expose
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void histo_ilp
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void histo_mo
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void histo_type
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void histo_update
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void histo_xyz
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int histo_draw
(void);

void histo_pointer
(
   Widget w,
   XtPointer client_data,
   XEvent *call_data,
   Boolean *cont
);

void init_all
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void init_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void init_create
(void);

void init_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void init_rotator
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void init_type
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void init_verify_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void init_verify_ok
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void layout_allocate
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void layout_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void layout_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void layout_reset
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int layout_allocmem
(void);

void load_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void load_localcancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void load_localok
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int load_display
(
   long *rgbmem,        /* Memory planes to be loaded with image data (I).   */
   long *nplanes,       /* Number of planes loaded (I).                      */
   Window imgwin,       /* Window ID for main image window (I).              */
   Widget shell,        /* Widget ID of image window shell (I).              */
   Widget win,          /* Widget ID of image window (I).                    */
   long *nl,            /* Number of lines to load (I).                      */
   long *ns,            /* Number of samples to load (I).                    */
   long *maxval,        /* Maximum image data value (I).                     */
   unsigned char *rptr, /* Pointer to red image data (I).                    */
   unsigned char *gptr, /* Pointer to green image data (I).                  */
   unsigned char *bptr, /* Pointer to blue image data (I).                   */
   long cmflg,          /* Indicates whether or not color map should
                           be modified (I).                                  */
   Pixmap *pixptr,      /* Pointer to pixmap which is to contain the
                           loaded image data (I).                            */
   long loadflg,        /* Indicates whether this is being called from
                           the loadimg routine (I).                          */
   long viewflg,        /* If TRUE, resize viewport to original
                           specification.  If FALSE, base resizing on
                           the current viewport width and height.  (I)       */
   long flickerflg,     /* Indicates whether or not this load is part
                           of the flicker process (I).                       */
   long pixmapflg       /* Indicates if it should just create the pixmap or
                           create and display the pixmap                     */
);

void nonlas_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void nonlas_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void nonlas_next
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void nonlas_dialog
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int loadimg
(
   Window imgwin,    /* Window ID for image window (I).                      */
   long loadflg,     /* Indicates whether the image is being loaded into the
                        main image window (I).                               */
   int flickerflg,   /* Indicates if this is being called from the flicker
                        process                                              */
   int pixmapflg     /* Pass along to load_display. TRUE indicates that we
                        just want the pixmap created and not displayed
                        immediately                                          */
);

void map_component
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void map_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void map_func
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void map_linear
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void map_restore
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void adjust_map
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void adjust_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void psd_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void psd_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void psd_func
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void color_list_select
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void color_slider
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void psd_undo
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pwl_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pwl_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void saveload_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void savemap_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void saveload_file
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void savemap_next
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void loadmap_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pwl_loadfile
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pwl_save
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pwl_file_ext
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pwl_clear
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void mask_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void mask_clear
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void mask_create
(void);

void mask_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void mask_color
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void mask_rotator
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void xid_message
(
    char *str          /* Message string (I).                        */
);

long open_nonlas
(
   int *fd,            /* File descriptor of image file.  (O)                */
   char *image_name,   /* Name of image file to open.  (I)                   */
   long *nbands,       /* Number of bands contained in image file.  (I)      */
   long *sl,           /* Starting line to be processed.  (I)                */
   long *ss,           /* Starting sample to be processed.  (I)              */
   long *nl,           /* Number of lines to be processed.  (I)              */
   long *ns,           /* Number of samples to be processed.  (I)            */
   long *access,       /* Type of access.  (I)
                               0 - Read
                               1 - Write
                               2 - Update                                    */
   long *dtype         /* Data type of image.  (I)                           */
);

long read_nonlas
(
   int *fd,              /* File descriptor of image file.  (I)              */
   long *band,           /* Band number to be read .  (I)                    */
   long *line,           /* Line number to be read (relative to starting
                            line specified in open call).  (I)               */
   unsigned char *buffer,/* User's buffer where data read is to be place.(I) */
   long *nlines          /* Number of lines to be read.  (I)                 */
);

long close_nonlas
(
   int *fd            /* File descriptor of image file.  (I)                */
);

int minmax_nonlas
(
   char name[][CMLEN],        /*  Image names. (I)                           */
   long dtype,                /*  Data type of image. (I)                    */
   long *nimg,                /*  Total number of images. (I)                */
   long window[][4],          /*  Starting line of each image. (I)           */
   long bands[][MAXBND + 1],  /*  Array of band numbers. (I)                 */
   long *nbands,              /*  Number of bands for each image.  (I)       */
   double *minval,            /*  Minimum value array. (O)                   */
   double *maxval             /*  Maximum value array. (O)                   */
);

void power_am
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_cd
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_create
(void);

void power_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_expose
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_expose_event
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void power_dir
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_draw
(
   Widget w,
   XtPointer client_data,
   XEvent *call_data,
   Boolean *cont
);

void power_entropy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_periodogram
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void power_text
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int nearest_power2
(
   long ns
);

void pref_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pref_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void pref_setcursor
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void profile_am
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void profile_cd
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void profile_create
(void);

void profile_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void profile_expose
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void profile_expose_event
(
   Widget w,
   XtPointer client,
   XEvent *call,
   Boolean *cont
);

void profile_dir
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void profile_draw
(
   Widget w,
   XtPointer client_data,
   XEvent *call_data,
   Boolean *cont
);

void profile_move
(
   Widget w,
   XtPointer client_data,
   XtPointer call_data
);

int proj_flush
(
   long proj_code,                  /* Projection code. (I)           */
   long unit,                       /* Unit code.  (I)                */
   long zone,                       /* Zone code.  (I)                */
   long datum,                      /* Datum code.  (I)               */
   double proj_coef[]               /* Projection parameters.  (I)    */
);

void save_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_win
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_frame
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_type
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_imagename
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_tiff_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_verify
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void save_tiff
(
   char outfile[CMLEN]   /* Output TIFF file (O)                           */
);

void show_accept
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_select
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_save_dialog
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_save
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_info
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void info_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_planes
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_save_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void show_delete
(
   Widget w,
   XtPointer client,
   XtPointer call
);

caddr_t CONVERT
(
   Widget w,
   char *from_string,
   char *to_type,
   int to_size,
   Boolean *success
);

XmFontList FONT_LIST
(
   Widget w,
   char *name
);

Pixmap XPM_PIXMAP
(
   Widget w,
   unsigned int width,
   unsigned int height,
   unsigned int ncolors,
   unsigned int cpp,
   char **colors,
   char **pixels
);

void load_clist
(void);

Boolean XID_StringToPixel
(
   Display *dpy,
   XrmValue *args,
   Cardinal *num_args,
   XrmValue *fromVal,
   XrmValue *toVal,
   XtPointer *converter_data
);

int parse_rb
(
   char *str,          /* String to be parsed. (I)                           */
   long **range,       /* Range values specified. (O)                        */
   long *rcount,       /* Number of range values specified. (O)              */
   long **bin,         /* Bin values specified. (O)                          */
   long *bcount,       /* Number of bin values specified. (O)                */
   long minval,        /* Minimum gray level value allowed. (I)              */
   long maxval         /* Maximum gray level value allowed. (I)              */
);

int parse_fromto
(
   char *str,          /* String to be parsed. (I)                           */
   long **breakpts,    /* Break point values specified. (O)                  */
   long *count         /* Number of breakpoints specified. (O)               */
);

int piece
(
   long from[],         /* The input FROM breakpoint values.              (I)*/
   long to[],           /* The input TO breakpoint values.                (I)*/
   long *count,         /* The number of breakpoint values.               (I)*/
   long map[]           /* Resulting piecewise linear mapping values.     (O)*/
);

int renumber
(
   long from[],        /* The input FROM pixel values.                    (I)*/
   long to[],          /* The input TO pixel values.                      (I)*/
   long *count,        /* The number of input values.                     (I)*/
   long map[]          /* Resulting mapping values.                       (O)*/
);

void xid_noop
(void);

void xid_contextadd
(
   long context_num            /* Number of the XID context to add.  (I)
                                    0 - Image context (no manual cursor)  
                                    1 - Image context (manual cursor)
                                    2 - Graphics Select context
                                    3 - Graphics Edit context (line, poly,
                                        rect)
                                    4 - Graphics Move/Delete Edit context
                                    5 - Graphics Add Edit context         
                                    6 - Image/Profile context (manual)
                                    7 - Fill context                     */
);

void xid_contextdel
(
   long context_num            /* Number of the XID context to add.  (I)
                                    0 - Image context (no manual cursor)
                                    1 - Image context (manual cursor)
                                    2 - Graphics Select context
                                    3 - Graphics Edit context (line, poly
                                        rect)
                                    4 - Graphics Move/Delete context
                                    5 - Graphics Add context
                                    6 - Image/Profile context (manual)
                                    7 - Fill context                     */
);

void xid_win2file
(
   long plane_idx,             /* Memory plane index. (I)                    */
   long win,                   /* Window the input coordinates are from. (I)
                                      0 - Main image window
                                      1 - Full resolution window
                                      2 - Zoomed window                      */
   long xwin,                  /* 0 relative X coordinate. (I)               */
   long ywin,                  /* 0 relative Y coordinate. (I)               */
   float *xfil,                /* Calculated X file coordinate. (O)          */
   float *yfil                 /* Calculated Y file coordinate. (O)          */
);

void xid_file2win
(
   long plane_idx,            /* Memory plane index. (I)                     */
   long win,                  /* Window the coordinates are to be converted
                                 to. (I)
                                     0 - Main image window
                                     1 - Full resolution window
                                     2 - Zoomed window                       */
   double xfil,               /* X file coordinate. (I)                      */
   double yfil,               /* Y file coordinate. (I)                      */
   int  *xwin,                /* Calculated 0 relative X coordinate. (0)     */
   int  *ywin                 /* Calculated 0 relative Y coordinate. (0)     */
);

long xid_win2proj
(
   long plane_idx,            /* Memory plane index. (I)                    */
   long win,                  /* Window the input coordinates are from. (I)
                                     0 - Main image window
                                     1 - Full resolution window
                                     2 - Zoomed window                      */
   long xwin,                 /* 0 relative X coordinate. (I)               */
   long ywin,                 /* 0 relative Y coordinate. (I)               */
   double *xproj,             /* Calculated X projection coordinate. (O)    */
   double *yproj              /* Calculated Y projection coordinate. (O)    */
);

int xid_getin
(
   char *fname,            /* Input image name                */
   char tnames[][CMLEN],   /* TAE names of images specified   */
   char hnames[][CMLEN],   /* host names of images specified  */
   long *images,           /* Number of images                */
   long (*window)[4],      /* Image windows (sl ss nl ns)     */
   long (*bands)[MAXBND+1],/* Image bands                     */
   long *nbands,           /* Number of bands per image       */
   long *totbnd,           /* total number of bands specified */
   long *imglimit,         /* Maximum images caller can handle*/
   long *same_window,      /* 1 if all windows the same       */
   long (*qflag)[2]        /* 1 if caller specified the window*/
                           /* and bands                       */
                           /* 0 if default window and bands   */
);

int xid_getmem
(
   long *memory               /* The memory plane ID which is available for
                                 use by the calling function. (O)           */
);

int xid_histcalc
(
   long *hist,          /* Actual histogram values. (I)                      */
   long *minb,          /* Minimum frequency value. (O)                      */
   long *maxb,          /* Maximum frequency value. (O)                      */
   double *mean,        /* Mean frequency value. (O)                         */
   double *stdev        /* Standard deviation of frequency. (O)              */
);

void xid_image_makelist
(
   Widget red_widget,          /* Red list widget.  (I)                      */
   Widget green_widget,        /* Green list widget.  (I)                    */
   Widget blue_widget,         /* Blue list widget.  (I)                     */
   Widget save_widget,         /* Save list widget. (I)                      */
   long current_flg            /* Indicates whether or not to make a special
                                  entry in the save list for the currently
                                  displayed image.  (I)                      */
);

long xid_make_ximage
(void);

void xid_find_composite
(
   char *name,                /* Name of the image composite whose index is
                                 to be found.  (I)                          */
   long *cindex               /* Composite index of input name.  (O)        */
);

void xid_get_composite
(
   long *cindex,               /* Composite index of first free entry.  (O)  */
   long *num_used              /* Number of currently used entries (not
                                  including index returned).  (O)            */
);

void xid_clear_composite
(
   long plane_num             /* Plane number that has been initialized. (I)*/
);

int xid_rgb2lut
(
    long num_images,          /* Number of input images. (I)          */
    unsigned char **red,      /* Red pixel values. (I)                */
    unsigned char **green,    /* Green pixel values. (I)              */
    unsigned char **blue,     /* Blue pixel values. (I)               */
    long *npts,               /* Total number of input pixels. (I)    */
    long lutlen,              /* Number of LUT entries to use. (I)    */
    unsigned char **composite,/* Output composite image. (O)          */
    unsigned char *red_lut,   /* Output red LUT. (O)                  */
    unsigned char *green_lut, /* Output green LUT. (O)                */
    unsigned char *blue_lut,  /* Output blue LUT. (O)                 */
    long num_reserved,        /* Number of reserved colors in LUT. (I)*/
    unsigned char *reserved_red,   /* Input reserved red LUT values. (I)   */
    unsigned char *reserved_green, /* Input reserved green LUT values. (I) */
    unsigned char *reserved_blue   /* Input reserved blue LUT values. (I)  */
);

int xid_samp
(
   int inpwdw[],       /* File window image is taken from. (I)              */
   int memwdw[],       /* Pane window image is to be loaded into. (I/O)     */
   int *skipl,         /* Sampling factor in the line direction. (O)        */
   int *skips         /* Sampling factor in the sample direction. (O)      */
);

int xid_slpoff
(
   long *indtyp,      /* Input data type. (I)                              */
   double *minpix,    /* Minimum pixel value. (I)                          */
   double *maxpix,    /* Maximum pixel value. (I)                          */
   double *slope,     /* Slope to be computed. (O)                         */
   double *offset     /* Offset to be computed. (O)                        */
);

void zoom_arrows
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void zoom_create
(void);

void zoom_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void zoom_entry
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void zoom_mode
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void zoom_type
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void zoom_button
(
   Widget w,
   caddr_t client,
   caddr_t call
);

void zoom_alpha
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void zoom_ok
(
   Widget w,
   XtPointer client,
   XtPointer call
);

#endif
