/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 2.0.
 *
 */
#include <sys/file.h>
#include <math.h>
#include <strings.h> /* bcopy definition */
#include "xid.h" 
#include "xid_graphics.h"
#include "xid_func.h"
#include "../xid_widgets/Context.h"

/* local function prototypes */
void graphics_removevert
(
   long element,
   long vert
);

void graphics_erase_handles
(void);

void graphics_dist
(
   float xy[][2],       /* Points to calculate distances to. (I)             */
   float point[],       /* Selected point. (I)                               */
   double *near         /* Distance to closest point. (O)                    */
);

void graphics_sort
(
   double near[],      /* Distances to selected records. (O)                 */
   int offset[],       /* Indices of selected elements. (I)                  */
   int *num            /* Number of records. (I)                             */
);

void graphics_editclose
(
   Widget w,                   /* Widget ID.  (I)                            */
   long win,                   /* Type of window. (I)
                                    0 - Main image window.
                                    1 - Full resolution window.
                                    2 - Zoomed window.                       */
   long plane_idx              /* Index into memory plane structure of the
                                  currently viewed image.  (I)               */
);

void graphics_change
(
   long win,                   /* Type of window. (I)
                                    0 - Main image window.
                                    1 - Full resolution window.
                                    2 - Zoomed window.                       */
   long plane_idx              /* Index into memory plane structure of the
                                  currently viewed image.  (I)               */
);

void graphics_changes_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
);

void graphics_changes_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
);

int graphics_clip2d
(
   int window[],       /* Window the line segment is to be clipped to. (I)   */
   float *x0,          /* X-coord of first vertex of line segment. (IO)      */
   float *y0,          /* Y-coord of first vertex of line segment. (IO)      */
   float *x1,          /* X-coord of last vertex of line segment. (IO)       */
   float *y1,          /* Y-coord of last vertex of line segment. (IO)       */
   int *lstat          /* Line segment status variable. (O)            
                            1 = Completely outside window
                            2 = Completely inside window
                            3 = Partially inside window                      */
);

int graphics_clipt
(
   int *p,    /* First point to check.  From graphics_clip2d this is the
                 distance from X0 to X1 or from Y0 to Y1 (I).                */
   int *q,    /* Second point to check.  From graphics_clip2d this is the
                 distance from the left or right edge of the clipping window
                 to X0 or or from the top or bottom edge of the clipping
                 window to Y0 (I).                                           */
   float *t0, /* Amount to scale first endpoint (I/O).                       */
   float *t1  /* Amount to scale second endpoint (I/O).                      */
);
/* end prototypes */

char *context_names[] = {"Image","Image_Cursor","Graphics Select",
                         "Graphics Edit","Graphics Mv/Del","Graphics Add",
                         "Profile","Fill"};

void graphics_editmode
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   Adds the appropriate context and sets the appropriate flags based
   on the edit mode selected.
                                                                
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
******************************************************************************/
{
   /* Add the appropriate context for "graphics add" mode and set the
      appropriate flags.  */
   if (*((char *)client) == 'A')
   {
      if (!(XeContextCheckList((XeContextWidget)context_mouse,
          context_names[CON_GRADD])))
      {
         xid_contextadd(CON_GRADD);

         /* Make this context insensitive until the user selects a vertex.  */
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRADD]);
      }
      xid_editgraph.flags &= ~(GR_MOVE | GR_DELETE);
      xid_editgraph.flags |= GR_ADD;
   }

   /* Add the appropriate context for "graphics move" mode and set the
      appropriate flags.  */
   else if (*((char *)client) == 'M')
   {
      if (!(XeContextCheckList((XeContextWidget)context_mouse, 
          context_names[CON_GRMVDEL])))
      {
         xid_contextadd(CON_GRMVDEL);

         /* Make this context insensitive until the user selects a vertex.  */
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRMVDEL]);
      }
      xid_editgraph.flags &= ~(GR_ADD | GR_DELETE);
      xid_editgraph.flags |= GR_MOVE;
   }

   /* Set the appropriate flags.  */
   else if (*((char *)client) == 'D')
   {
      xid_editgraph.flags &= ~(GR_ADD | GR_MOVE);
      xid_editgraph.flags |= GR_DELETE;
   }
}

void graphics_editfind
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
   XmString              xmstr[1];       /* Motif format strings.            */
   struct ANNOT_ELEMENT  *aptr;          /* Ptr to annotation specific info  */
   struct LINE_ELEMENT   *lptr;          /* Ptr to line specific info        */
   struct POLY_ELEMENT   *pptr;          /* Ptr to polygon specific info     */
   XButtonEvent     *event;              /* X Event structure.               */
   Widget           gadget_button;       /* Cascade button gadget of option
                                            menu.                            */
   Boolean          argok;               /* Status indicator.                */
   Pixel            pixelval;            /* Pixel value of selected color.   */
   float            xyfil[2];            /* XY file coordinate.              */
   int              elements[1];         /* Index of element found.          */
   int              nfnd;                /* Number of elements actually found*/
   long             nreq = 1;            /* Number of graphics elements
                                            requested.                       */
   long             plane_idx;           /* Index into memory plane structure
                                            of the currently viewed image.   */
   long             status;              /* Status indicator.                */
   long             tol = 5;             /* Area around specified point to
                                            be searched.                     */
   long             win = 0;             /* Window from which coordinates
                                            are to be calculated.            */
   char             str[15];             /* Line width character string.     */

   event = (XButtonEvent *)call;

   /* Determine which window generated the event.  */
   if (w == main_image_bulletinboard)
      win = 0;
   else if (w == fullres_win_bulletinboard)
      win = 1;
   else if (w == zoom_win_bulletinboard)
      win = 2;

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Convert the window coordinate to an actual file coordinate based on the
      image currently displayed.  */
   xid_win2file(plane_idx,win,event->x,event->y,&xyfil[0],&xyfil[1]);

   /* Find the graphics element closest to the point selected if the right
      mouse button was not selected.  */
   if (event->button != 3)
   {
      graphics_closest(plane_idx,xid_graphics.type,tol,xyfil,nreq,elements,
                       &nfnd);
   }

   /* The user has selected the right mouse button which allows the user to
      move the label of the graphics element.  */
   else
   {
      /* Print an error message of a graphics element has not yet been
         selected.  */
      if (xid_editgraph.current == -1)
      {
         xid_message("No graphics element selected, unable to move the label.");
         return;
      }
      nfnd = 1;
      elements[0] = xid_editgraph.current;

      /* Make sure the appropriate context exists as well as making it
         sensitive and active.  */
      if (!(XeContextCheckList((XeContextWidget)context_mouse, 
          context_names[CON_GRMVDEL])))
      {
         xid_contextadd(CON_GRMVDEL);
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRMVDEL]);
      }
      XeContextSensitize((XeContextWidget)context_mouse,
                         context_names[CON_GRMVDEL]);
      XeContextSetActive((XeContextWidget)context_mouse,
                         context_names[CON_GRMVDEL]);
      XeContextDesensitize((XeContextWidget)context_mouse,
                           context_names[CON_GREDIT]);
   }

   /* If a graphics element was found ...  */
   if (nfnd != 0)
   {
      /* Warn the user if any current modifications have not been saved.  */
      if ((xid_editgraph.current != -1) &&
          (xid_editgraph.current != elements[0]))
      {
         if ((!(xid_editgraph.writeflg)) && (xid_editgraph.flags & GR_MODIFY)
             && (event->button != 3))
         {
            XBell(xid.display,0);
            graphics_editwarn(0,"N");
            return;
         }

         /* Erase the "graphics handles".  */
         graphics_erase_handles();
      }

      /* Warn the user if any current modifications have not been saved.  */
      else if (!(xid_editgraph.writeflg) && (xid_editgraph.flags & GR_REMOVE))
      {
         XBell(xid.display,0);
         graphics_editwarn(0,"N");
         return;
      }
      else
      {
         /* Make appropriate options sensitive.  */
         XtSetSensitive(graphics_edit_apply,True);
         XtSetSensitive(graphics_defatt_button,True);
         XtSetSensitive(graphics_setatt_button,True);
         XtSetSensitive(graphics_label_button,True);
         XtSetSensitive(graphics_width_option,True);
         XtSetSensitive(graphics_color_option,True);
         XtSetSensitive(graphics_fonts_option,True);
      }

      /* Allow the user to modify the label position.  */
      if (event->button == 3)
      {
         /* Set appropriate values.  */
         xid_editgraph.flags |= (GR_EDITLABEL | GR_MODIFY);
         xid_editgraph.current = elements[0];
         xid_editgraph.writeflg = FALSE;

         /* Draw "graphics handles" around the label.  */
         graphics_handles(xid_editgraph.current,-1,NULL,0);

         /* Calculate the label width and height.  */
         graphics_labelcalc(xid_element[xid_editgraph.current].label);

         /* Make the appropriate contexts sensitive and active.  */
         XeContextSensitize((XeContextWidget)context_mouse,
                            context_names[CON_GRMVDEL]);
         XeContextSetActive((XeContextWidget)context_mouse,
                            context_names[CON_GRMVDEL]);
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GREDIT]);
         XtSetSensitive(graphics_edit_undo,False);
         XtSetSensitive(graphics_edit_apply,False);
         return;
      }

      /* Set the current graphics index and the write flag.  */
      xid_editgraph.current = elements[0];
      xid_editgraph.writeflg = FALSE;

      /* If the graphics element is a point or annotation text, set the current
         vertice and its coordinates.  Also, make the appropriate options
         sensitive.  */
      if ((xid_element[xid_editgraph.current].type == POINT) || 
          (xid_element[xid_editgraph.current].type == TEXT))
      {
         xid_editgraph.vert = 0;
         xid_editgraph.xfil = xid_element[xid_editgraph.current].x; 
         xid_editgraph.yfil = xid_element[xid_editgraph.current].y; 
         XtSetSensitive(graphics_edit_undo,False);
         XtSetSensitive(graphics_edit_apply,False);
      }

      /* Set the current vertice to -1 indicating that no vertice has been
         selected.  */
      else
         xid_editgraph.vert = -1;

      /* Draw the "graphics handles".  */
      graphics_handles(elements[0],-1,NULL,0);

      /* Output the label to the graphics panel.  */
      xmstr[0] = XmStringCreateLtoR(xid_element[xid_editgraph.current].label, 
                                    XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(graphics_label_label,XmNlabelString,xmstr[0],NULL);
      XmStringFree(xmstr[0]);

      /* Set the current font, color and line width.  */
      xid_graphics.font = xid_element[xid_editgraph.current].font;
      gadget_button = XmOptionButtonGadget(graphics_fonts_option);
      sprintf(str,"Font Option %ld",xid_graphics.font+1);
      xmstr[0] = XmStringCreateLtoR(str,XmSTRING_ISO8859_1);
      XtVaSetValues(gadget_button,XmNlabelString,xmstr[0],XmNfontList,
                    CONVERT(Shell_Graphics,
                    xid_graphics.fonts[xid_graphics.font], "FontList", 0,
                    &argok),NULL);
      XmStringFree(xmstr[0]);

      xid_graphics.color = xid_element[xid_editgraph.current].color;
      gadget_button = XmOptionButtonGadget(graphics_color_option);
      xmstr[0] = XmStringCreateLtoR(xid_graphics.colors[xid_graphics.color],
                                    XmSTRING_ISO8859_1);
      XtVaSetValues(gadget_button,XmNlabelString,xmstr[0],NULL);
      XmStringFree(xmstr[0]);

      pixelval = (Pixel)CONVERT(Shell_Graphics,
                                xid_graphics.colors[xid_graphics.color],
                                "Pixel", 0, &argok);
      XtVaSetValues(graphics_color_option,XmNforeground,pixelval,NULL);

      if (xid_element[xid_editgraph.current].type == LINE)
      {
         lptr = (struct LINE_ELEMENT *)xid_element[xid_editgraph.current].
                                                                     graph_ptr;
         xid_graphics.line_width = lptr->line_width;
      }
      else if ((xid_element[xid_editgraph.current].type == POLY) ||
               (xid_element[xid_editgraph.current].type == RECT))
      {
         pptr = (struct POLY_ELEMENT *)xid_element[xid_editgraph.current].
                                                                     graph_ptr;
         xid_graphics.line_width = pptr->line_width;
      }
      else
         xid_graphics.line_width = 0;

      if (xid_graphics.line_width != 0)
      {
         gadget_button = XmOptionButtonGadget(graphics_width_option);
         sprintf(str,"%ld",xid_graphics.line_width);
         xmstr[0] = XmStringCreateLtoR(str,XmSTRING_ISO8859_1);
         XtVaSetValues(gadget_button,XmNlabelString,xmstr[0],NULL);
         XmStringFree(xmstr[0]);
      }

      /* Update the attribute values if "Set Attributes" panel is displayed.  */
      if (XtIsRealized(Shell_Setatt))
         graphics_updateatt(xid_editgraph.current);

      /* Calculate the annotation width and height based on the annotation
         string and font.  */
      if (xid_graphics.type == TEXT)
      {
         aptr = (struct ANNOT_ELEMENT *) xid_element[xid_editgraph.current].
                                                                     graph_ptr;

         /* Output the annotation text to the graphics panel.  */
         xmstr[0] = XmStringCreateLtoR(aptr->string, XmSTRING_DEFAULT_CHARSET);
         XtVaSetValues(graphics_label_label,XmNlabelString,xmstr[0],NULL);
         XmStringFree(xmstr[0]);
      }

      /* Make the appropriate context sensitive and active for point or
         annotation data.  */
      if ((xid_graphics.type == POINT) || (xid_graphics.type == TEXT))
      {
         XeContextSensitize((XeContextWidget)context_mouse,
                            context_names[CON_GRMVDEL]);
         XeContextSetActive((XeContextWidget)context_mouse,
                            context_names[CON_GRMVDEL]);
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GREDIT]);
      }

      /* Make a copy of the original element and make a copy for the "undo"
         option.  */
      status = graphics_copy_element(&xid_element[xid_editgraph.current],
                                     &xid_editorig);
      if (status != XID_S)
         return;
      status = graphics_copy_element(&xid_element[xid_editgraph.current],
                                     &xid_editundo);
      if (status != XID_S)
         return;
   }
}

void graphics_vertfind
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine finds the vertex of the currently selected graphics
   element closest to the selected point.
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
   XButtonEvent           *event;      /* X Event structure.                 */
   struct LINE_ELEMENT    *lptr = NULL;/* Ptr to line specific info          */
   struct POLY_ELEMENT    *pptr = NULL;/* Ptr to polygon specific info       */
   double                 closest;     /* Distance from selected point to
                                          closest vertice.                   */
   double                 dist;        /* Distance from selected point to
                                          vertices.                          */
   double                 x2;          /* X squared.                         */
   double                 y2;          /* Y squared.                         */
   float                  xyfil[2];    /* XY file coordinate.                */
   long                   closest_idx = 0;
                                       /* Index of closest vertice.          */
   long                   i;           /* Looping variable.                  */
   long                   next = 0;    /* Next vertice from selected one.    */
   long                   num_vert = 0;/* Number of vertices.                */
   long                   plane_idx;   /* Index into memory plane structure
                                          of the currently viewed image.     */
   long                   prev = 0;    /* Previous vertice from selected one.*/
   long                   status;      /* Status indicator.                  */
   long                   win = 0;     /* Window from which coordinates are
                                          to be calculated.                  */

   event = (XButtonEvent *)call;

   /* A vertex cannot be selected until an edit mode has been selected.  */
   if (!(xid_editgraph.flags & GR_MOVE) && !(xid_editgraph.flags & GR_DELETE)
       && !(xid_editgraph.flags & GR_ADD))
   {
      xid_message("User must choose an edit mode before selecting a vertice");
      return;
   }

   /* There is only one vertex for a point or annotation text.  */
   if ((xid_graphics.type == POINT) || (xid_graphics.type == TEXT))
   {
      xid_editgraph.vert = 0;
      xid_editgraph.xfil = xid_element[xid_editgraph.current].x; 
      xid_editgraph.yfil = xid_element[xid_editgraph.current].y; 
      xid_editgraph.flags |= GR_MODIFY;
      xid_editgraph.writeflg = FALSE;
      return;
   }

   /* Make sure a graphics element has been selected.  */
   if (xid_editgraph.current == -1)
   {
      xid_message("User must select a graphics element before selecting a"
                  " vertice");
      return;
   }

   /* Determine which window generated the event.  */
   if (w == main_image_bulletinboard)
      win = 0;
   else if (w == fullres_win_bulletinboard)
      win = 1;
   else if (w == zoom_win_bulletinboard)
      win = 2;

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Set number of vertices to search and line or polygon pointers.  */
   if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
   {
      pptr = (struct POLY_ELEMENT *)xid_element[xid_editgraph.current].
                                                                     graph_ptr;
      num_vert = pptr->num_vert;
   }
   else if (xid_graphics.type == LINE)
   {
      lptr = (struct LINE_ELEMENT *)xid_element[xid_editgraph.current].
                                                                     graph_ptr;
      num_vert = lptr->num_vert;
   }

   /* Convert the window coordinate to an actual file coordinate based on the
      image currently displayed.  */
   xid_win2file(plane_idx,win,event->x,event->y,&xyfil[0],&xyfil[1]);

   /* Calculate the distance from the selected point to the nearest vertex.  */
   closest = 9999.0;
   if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
   {
      for (i=0; i < num_vert; i++)
      {
         x2 = (double) ((xyfil[0] - pptr->x[i]) * (xyfil[0] - pptr->x[i]));
         y2 = (double) ((xyfil[1] - pptr->y[i]) * (xyfil[1] - pptr->y[i]));
         dist = sqrt(x2 + y2);
         if (dist < closest)
         {
            closest = dist;
            closest_idx = i;
         }
      }
   }
   else
   {
      for (i=0; i < num_vert; i++)
      {
         x2 = (double) ((xyfil[0] - lptr->x[i]) * (xyfil[0] - lptr->x[i]));
         y2 = (double) ((xyfil[1] - lptr->y[i]) * (xyfil[1] - lptr->y[i]));
         dist = sqrt(x2 + y2);
         if (dist < closest)
         {
            closest = dist;
            closest_idx = i;
         }
      }
   }

   /* If a vertex was found ...  */
   if (closest != 9999.0)
   {
      /* Set the selected vertex.  */
      xid_editgraph.vert = closest_idx;

      /* Find the vertices on either side of the selected vertex.  */ 
      if ((xid_editgraph.flags & GR_MOVE) || (xid_editgraph.flags & GR_DELETE))
      {
         prev = closest_idx - 1;
         next = closest_idx + 1;
         if (xid_editgraph.vert == 0)
         {
            if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
               prev = num_vert - 1;
            else
               prev = -1;
         }
         else if (xid_editgraph.vert == (num_vert - 1))
         {
            if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
               next = 0;
            else
               next = -1;
         }
      }
      else if (xid_editgraph.flags & GR_ADD)
      {
         prev = closest_idx;
         next = closest_idx + 1;
         if (xid_editgraph.vert == (num_vert - 1))
         {
            if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
               next = 0;
            else
               next = -1;
         }
      }

      /* Set window and file coordinates of previous and next vertices.  */
      if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
      {
         xid_file2win(plane_idx,win,pptr->x[prev],pptr->y[prev],
                      &xid_editgraph.prevx,&xid_editgraph.prevy);
         xid_file2win(plane_idx,win,pptr->x[next],pptr->y[next],
                      &xid_editgraph.nextx,&xid_editgraph.nexty);
         xid_editgraph.xfil = pptr->x[xid_editgraph.vert];
         xid_editgraph.yfil = pptr->y[xid_editgraph.vert];
         xid_editgraph.fxprev = pptr->x[prev];
         xid_editgraph.fyprev = pptr->y[prev];
         xid_editgraph.fxnext = pptr->x[next];
         xid_editgraph.fynext = pptr->y[next];
         xid_graphics.line_width = pptr->line_width;
      }
      else
      {
         if (prev != -1)
         {
            xid_file2win(plane_idx,win,lptr->x[prev],lptr->y[prev],
                         &xid_editgraph.prevx,&xid_editgraph.prevy);
            xid_editgraph.fxprev = lptr->x[prev];
            xid_editgraph.fyprev = lptr->y[prev];
         }
         else
         {
            xid_editgraph.prevx = xid_editgraph.prevy = -1;
            xid_editgraph.fxprev = xid_editgraph.fyprev = -1;
         }
         if (next != -1)
         {
            xid_file2win(plane_idx,win,lptr->x[next],lptr->y[next],
                         &xid_editgraph.nextx,&xid_editgraph.nexty);
            xid_editgraph.fxnext = lptr->x[next];
            xid_editgraph.fynext = lptr->y[next];
         }
         else
         {
            xid_editgraph.nextx = xid_editgraph.nexty = -1;
            xid_editgraph.fxnext = xid_editgraph.fynext = -1;
         }
         xid_editgraph.xfil = lptr->x[xid_editgraph.vert];
         xid_editgraph.yfil = lptr->y[xid_editgraph.vert];
         xid_graphics.line_width = lptr->line_width;
      }

      /* Make the appropriate context sensitive and active.  */
      if (xid_editgraph.flags & GR_MOVE)
      {
         XeContextSetActive((XeContextWidget)context_mouse,
                            context_names[CON_GRMVDEL]);
         XeContextSensitize((XeContextWidget)context_mouse,
                            context_names[CON_GRMVDEL]);
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GREDIT]);

         /* Set flags.  */
         xid_editgraph.flags |= GR_MODIFY;
         xid_editgraph.writeflg = FALSE;

         /* Set rectangle corners for rubber-banding.  */
         if (xid_graphics.type == RECT)
         {
            xid_editgraph.ulx = pptr->x[0];
            xid_editgraph.uly = pptr->y[0];
            xid_editgraph.new_ulx = xid_editgraph.new_uly = xid_editgraph.width
               = xid_editgraph.height = -1;
         }
         XtSetSensitive(graphics_edit_undo,False);
         XtSetSensitive(graphics_edit_apply,False);
      }

      /* Make the appropriate context sensitive and active.  */
      else if (xid_editgraph.flags & GR_ADD)
      {
         XeContextSensitize((XeContextWidget)context_mouse,
                            context_names[CON_GRADD]);
         XeContextSetActive((XeContextWidget)context_mouse,
                            context_names[CON_GRADD]);
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GREDIT]);

         /* Set appropriate values for rubber-band lines.  */
         if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
         {
            xid_file2win(plane_idx,win,pptr->x[xid_editgraph.vert],
                         pptr->y[xid_editgraph.vert],
                         &xid_graphics.selectx,&xid_graphics.selecty);
         }
         else
         {
            xid_file2win(plane_idx,win,lptr->x[xid_editgraph.vert],
                         lptr->y[xid_editgraph.vert],
                         &xid_graphics.selectx,&xid_graphics.selecty);
         }

         /* Set flags.  */
         xid_editgraph.flags |= GR_MODIFY;
         xid_editgraph.writeflg = FALSE;

         /* Delete the line segment between the selected vertex and the next
            vertex so that vertices may be added in between.  */
         graphics_deletelinerect(w,win,plane_idx,xid_editgraph.fxprev,
                                 xid_editgraph.fyprev,xid_editgraph.fxnext,
                                 xid_editgraph.fynext,FALSE);
         XtSetSensitive(graphics_edit_undo,False);
         XtSetSensitive(graphics_edit_apply,False);
      }
      else if (xid_editgraph.flags & GR_DELETE)
      {
         /* Print an error message if attempting to delete a vertex from a line
            that only contains 2 points or a polygon that only contains 3
            points.  */
         if (xid_graphics.type == LINE)
         {
            if (lptr->num_vert == 2)
            {
               xid_message("A line must contain at least 2 points");
               return;
            }
         }
         else if (xid_graphics.type == POLY)
         {
            if (pptr->num_vert == 3)
            {
               xid_message("A polygon must contain at least 3 points");
               return;
            }
         }

         /* Delete the appropriate line segments (delete from previous vertex
            to selected vertex and from selected vertex to next vertex).  Only
            one line segment needs to be deleted if deleting the first or last
            vertex of a line.  */
         if ((xid_editgraph.fxprev != -1) && (xid_editgraph.fyprev != -1))
         {
            graphics_deletelinerect(w,win,plane_idx,xid_editgraph.fxprev,
                                    xid_editgraph.fyprev,xid_editgraph.xfil,
                                    xid_editgraph.yfil,FALSE);
         }
         if ((xid_editgraph.fxnext != -1) && (xid_editgraph.fynext != -1))
         {
            graphics_deletelinerect(w,win,plane_idx,xid_editgraph.xfil,
                                    xid_editgraph.yfil,xid_editgraph.fxnext,
                                    xid_editgraph.fynext,FALSE);
         }

         /* Draw a new line segment with the selected vertex removed (draw from
            the previous vertex to the next vertex).  A new line segment is not
            drawn if deleting the first or last vertex of a line.  */
         if ((xid_editgraph.fxprev != -1) && (xid_editgraph.fyprev != -1) &&
             (xid_editgraph.fxnext != -1) && (xid_editgraph.fynext != -1))
         {
            xid_graphics.selectx = xid_graphics.prevx = xid_editgraph.prevx;
            xid_graphics.selecty = xid_graphics.prevy = xid_editgraph.prevy;
            graphics_drawlinerect(w,win,xid_editgraph.nextx,
                                  xid_editgraph.nexty,plane_idx,
                                  xid_editgraph.fxnext,xid_editgraph.fynext);
         }

         /* Make a copy of the current graphics element for the "graphics undo"
            function.  */
         status = graphics_copy_element(&xid_element[xid_editgraph.current],
                                        &xid_editundo);
         if (status != XID_S)
            return;

         /* Remove the vertex from the graphics element structure.  */
         graphics_removevert(xid_editgraph.current,xid_editgraph.vert);

         /* Set appropriate flags and variables.  */
         xid_editgraph.flags |= GR_MODIFY;
         xid_editgraph.writeflg = FALSE;
         xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx =
            xid_editgraph.nexty = xid_editgraph.newx = xid_editgraph.newy =
            xid_editgraph.vert = -1;
      }
   }
}

#define OUTSIDE  1      /* Line segment is outside the specified window      */

int graphics_closest
(
   int plane_idx,              /* Index into memory plane structure of the
                                  currently viewed image.                    */
   int type,                   /* Type of graphics elements to search. (I)   */
   int tol,                    /* Tolerance allowed around specified point. 
                                  (I)                                        */
   float point[],              /* XY pair for point chosen. (I)              */
   int nreq,                   /* Number of elements to return. (I)          */
   int elements[],             /* Indices to graphics records found. (O)     */
   int *nfnd                   /* Number of records found. (O)               */
)

/******************************************************************************
Purpose:
   Finds the specified number of records closest to a given point within 
   a specified tolerance.  
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
   struct LINE_ELEMENT  *lptr = NULL;
                                   /* Ptr to line specific info              */
   struct POLY_ELEMENT  *pptr = NULL;
                                   /* Ptr to polygon specific info           */
   double               *near;     /* Distances of records within the
                                      tolerance level from selected point.   */
   float                xy[2][2];   /* Input X and Y coordinates.            */
   int                  count = 0; /* Number of records found.               */
   int                  i,j,num = 0; /* Looping variables.                   */
   int                  lstat;     /* Status from graphics_clip2d.           */
   int                  *offset;   /* Indices of graphics elements within the 
                                      tolerance level.                       */
   long                 status;    /* Status indicator.                      */
   int                  window[4]; /* File window to clip to.                */
   long                 xtol;      /* X tolerance with sampling factored in. */
   long                 ytol;      /* Y tolerance with sampling factored in. */

   /* Factor the subsampling factor into the input tolerance.  */
   xtol = tol * xid_planes[plane_idx].skips;
   ytol = tol * xid_planes[plane_idx].skipl;

   /* Set up the window to clip to.  */
   window[0] =  (long)point[1] - ytol;

   if (window[0] < xid_planes[plane_idx].window[0])
      window[0] = xid_planes[plane_idx].window[0];

   window[1] = (long)point[0] - xtol;

   if (window[1] < xid_planes[plane_idx].window[1])
      window[1] = xid_planes[plane_idx].window[1];

   if (((long)point[1] + ytol) < (xid_planes[plane_idx].window[2] + 
       xid_planes[plane_idx].window[0] - 1)) 
      window[2] = ((long)point[1] + ytol) - window[0] + 1;
   else 
   {
      window[2] = (xid_planes[plane_idx].window[2] + 
         xid_planes[plane_idx].window[0] - 1) - window[0] + 1;
   }

   if (((long)point[0] + xtol) < (xid_planes[plane_idx].window[3] + 
       xid_planes[plane_idx].window[1] - 1))
      window[3] = ((long)point[0] + xtol) - window[1] + 1;
   else 
   {
      window[3] = (xid_planes[plane_idx].window[3] + 
         xid_planes[plane_idx].window[1] - 1) - window[1] + 1;
   }

   /* Allocate the maximum amount of space needed (i.e., every element falls
      within the input tolerance).  */
   near = (double *)malloc(sizeof(double)*xid_graphics.max_element);
   if (near == NULL)
   {
      xid_message("Insufficient amount of memory available");
      return(XID_F);
   }
   offset = (int *)malloc(sizeof(int)*xid_graphics.max_element);
   if (offset == NULL)
   {
      xid_message("Insufficient amount of memory available");
      return(XID_F);
   }

   /* Check each element to determine whether or not it falls within the input
      tolerance.  */
   for (i=0; i < xid_graphics.current; i++)        
   {
      near[count] = 9999.0;

      /* Skip this element if it does not match the input type.  */
      if (xid_element[i].type != type)
         continue;
      switch (type)
      {
         case POINT:

            /* Clip the record to the tolerance window */
            xy[0][0] = xy[1][0] = xid_element[i].x;
            xy[0][1] = xy[1][1] = xid_element[i].y;
            status = graphics_clip2d(window,&xy[0][0],&xy[0][1],
                                     &xy[1][0],&xy[1][1],&lstat);
            if (status != E_SUCC)
               return(status);
            if (lstat != OUTSIDE)
            {
               /* Calculate the distance from the specified point to the
                  clipped line segment */
               graphics_dist(xy,point,&near[count]);
               offset[count] = i; 
               count++;
            }
            break;
        case POLY:
        case LINE:
        case RECT:

            /* First check whether or not the point is within the bounding
               rectangle.  */
            if ((point[0] < xid_element[i].upleft[0] - (float)xtol) ||
                (point[1] < xid_element[i].upleft[1] - (float)ytol) ||
                (point[0] > xid_element[i].loright[0] + (float)xtol) ||
                (point[1] > xid_element[i].loright[1] + (float)ytol))
               continue;

            /* Set appropriate pointers and the number of vertices.  */
            if ((type == POLY) || (type == RECT))
            {
               pptr = (struct POLY_ELEMENT *)xid_element[i].graph_ptr;
               num = pptr->num_vert;
            }
            else if (xid_graphics.type == LINE)
            {
               lptr = (struct LINE_ELEMENT *)xid_element[i].graph_ptr;
               num = lptr->num_vert - 1;
            }

            for (j = 0; j < num; j++)
            {
               /* Clip the record to the tolerance window */
               if ((type == POLY) && (j == num - 1))
               {
                  xy[0][0] = pptr->x[j];
                  xy[0][1] = pptr->y[j];
                  xy[1][0] = pptr->x[0];
                  xy[1][1] = pptr->y[0];
                  status = graphics_clip2d(window,&xy[0][0],&xy[0][1],
                                           &xy[1][0],&xy[1][1],&lstat);
                  if (status != XID_S)
                     return(status);
               }
               else
               {
                  if ((type == POLY) || (type == RECT))
                  {
                     xy[0][0] = pptr->x[j];
                     xy[0][1] = pptr->y[j];
                     xy[1][0] = pptr->x[j+1];
                     xy[1][1] = pptr->y[j+1];
                  }
                  else if (type == LINE)
                  {
                     xy[0][0] = lptr->x[j];
                     xy[0][1] = lptr->y[j];
                     xy[1][0] = lptr->x[j+1];
                     xy[1][1] = lptr->y[j+1];
                  }
                  status = graphics_clip2d(window,&xy[0][0],&xy[0][1],
                                           &xy[1][0],&xy[1][1],&lstat);
                  if (status != XID_S)
                     return(status);
               }

               /* If the clipped value is zero, set it to 1 since file
                  coordinates are 1 relative.  */
               if (xy[0][0] == 0)
                  xy[0][0]++;
               if (xy[0][1] == 0)
                  xy[0][1]++;
               if (xy[1][0] == 0)
                  xy[1][0]++;
               if (xy[1][1] == 0)
                  xy[1][1]++;

               if (lstat != OUTSIDE)
               {
                  /* Calculate the distance from the specified point to the
                     clipped line segment */
                  graphics_dist(xy,point,&near[count]);
               }
            } /* End for */
            if (near[count] != 9999.0)
            {
               /* Store indices.  */
               offset[count] = i; 
               count++;
            }
            break;
        case TEXT:

            /* Clip the record to the tolerance window */
            for (j=0; j < 4; j++)
            {
               if (j == 0)
               {
                  xy[0][0] = xid_element[i].upleft[0];
                  xy[0][1] = xid_element[i].upleft[1];
                  xy[1][0] = xid_element[i].loright[0];
                  xy[1][1] = xid_element[i].upleft[1];
               }
               else if (j == 1)
               {
                  xy[0][0] = xid_element[i].loright[0];
                  xy[0][1] = xid_element[i].upleft[1];
                  xy[1][0] = xid_element[i].loright[0];
                  xy[1][1] = xid_element[i].loright[1];
               }
               else if (j == 2)
               {
                  xy[0][0] = xid_element[i].loright[0];
                  xy[0][1] = xid_element[i].loright[1];
                  xy[1][0] = xid_element[i].upleft[0];
                  xy[1][1] = xid_element[i].loright[1];
               }
               else if (j == 3)
               {
                  xy[0][0] = xid_element[i].upleft[0];
                  xy[0][1] = xid_element[i].loright[1];
                  xy[1][0] = xid_element[i].upleft[0];
                  xy[1][1] = xid_element[i].upleft[1];
               }
               status = graphics_clip2d(window,&xy[0][0],&xy[0][1],
                                        &xy[1][0],&xy[1][1],&lstat);
               if (status != E_SUCC)
                  return(status);
               if (lstat != OUTSIDE)
               {
                  /* Calculate the distance from the specified point to the
                     clipped line segment.  */
                  graphics_dist(xy,point,&near[count]);
                  offset[count] = i; 
                  count++;
               }
            }
            break;
      } 
   } /* End for */

   /* Sort the distance list.  */
   graphics_sort (near,offset,&count);

   /* Set the return parameters.  */
   *nfnd = count;
   if (count < nreq)
   {
      for (i = 0; i < count; i++)
         elements[i] = offset[i];
   }
   else
   {
      for (i = 0; i < nreq; i++)
         elements[i] = offset[i];
   }

   /* Free dynamically allocate space.  */
   free(near);
   free(offset);
   return(XID_S);
}

void graphics_dist
(
   float xy[][2],       /* Points to calculate distances to. (I)             */
   float point[],       /* Selected point. (I)                               */
   double *near         /* Distance to closest point. (O)                    */
)

/******************************************************************************
Purpose:
   Calculates distances to input points.
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
   double  xdiff1;     /* X difference between first endpoint X and input X 
                          point.                                             */
   double  ydiff1;     /* Y difference between first endpoint Y and input Y 
                          point.                                             */
   double  xdiff2;     /* X difference between first endpoint X and second 
                          endpoint X.                                        */
   double  ydiff2;     /* Y difference between first endpoint Y and second 
                          endpoint Y.                                        */
   double  denom;      /* Denominator.                                       */
   double  cnst;       /* Constant.                                          */
   double  xfac;       /* X factor for distance calculation.                 */
   double  yfac;       /* Y factor for distance calculation.                 */
   double  dst;        /* Distance from input point to line segment.         */

   /* Calculate the distance from the selected point to the line segment.  */
   xdiff1 = xy[0][0] - point[0];
   ydiff1 = xy[0][1] - point[1];
   xdiff2 = xy[1][0] - xy[0][0];
   ydiff2 = xy[1][1] - xy[0][1];
   denom  = xdiff2 * xdiff2 + ydiff2 * ydiff2;
   if (denom == 0) /* End points of the segment are the same point */
      dst = hypot (xdiff1,ydiff1); 
   else
   {
      cnst = -(xdiff1 * xdiff2 + ydiff1 * ydiff2) / denom;
      cnst = max (cnst,0.0);
      cnst = min (cnst,1.0);
      xfac = xdiff1 + cnst * xdiff2;
      yfac = ydiff1 + cnst * ydiff2;
      dst = hypot (xfac,yfac);
   }

   /* Set near to the shortest distance.  */
   if (dst < *near)
      *near = dst;

   return;
}

void graphics_sort
(
   double near[],      /* Distances to selected records. (O)                 */
   int offset[],       /* Indices of selected elements. (I)                  */
   int *num            /* Number of records. (I)                             */
)

/******************************************************************************
Purpose:
   Sort the input arrays.
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
int     temp;              /* Temporary storage variable.                    */
int     i;                 /* Looping variable.                              */
int     sorted = FALSE;    /* Is the list sorted?                            */

   /* Sort the input distance list in ascending order and keep the offset list
      in the same order.  */
   while (!sorted)
   {
      sorted = TRUE;
      for (i=1; i < *num; i++)
      {
         if (near[i-1] > near[i])
         { 
            temp = near[i-1];
            near[i-1] = near[i];
            near[i] = temp;
            temp = offset[i-1];
            offset[i-1] = offset[i];
            offset[i] = temp;
            sorted = FALSE;
         }
      }
   }
   return;
}

int graphics_clip2d
(
   int window[],       /* Window the line segment is to be clipped to. (I)   */
   float *x0,          /* X-coord of first vertex of line segment. (IO)      */
   float *y0,          /* Y-coord of first vertex of line segment. (IO)      */
   float *x1,          /* X-coord of last vertex of line segment. (IO)       */
   float *y1,          /* Y-coord of last vertex of line segment. (IO)       */
   int *lstat          /* Line segment status variable. (O)            
                            1 = Completely outside window
                            2 = Completely inside window
                            3 = Partially inside window                      */
)

/****************************************************************************
 *                                                                          *
 *      Purpose: This is an implmentation of the Liang-Barsky 2-d clipping  *
 *               algorithm.                                                 *
 *                                                                          *
 *      By: J.V.R., USGS/EROS Data Center, 5/16/85,                         *
 *      Rewritten by: D. Hollaren, USGS/EROS Data Center, 4/01/86           *
 *      Modified by: D. Akkerman, USGS/EROS Data Center, 5/88               *
 *              DMS v3_0 retrocode.                                         *
 *                                                                          *
 ****************************************************************************/
{
   float   t0;             /* Amount to scale first endpoint.                */
   float   t1;             /* Amount to scale second endpoint.               */
   int     deltax;         /* Distance between X0 and X1.                    */
   int     deltay;         /* Distance between Y0 and Y1.                    */
   int     deltat;         /* Distance from left edge of window to X0.       */
   int     temp;           /* Negative of deltax or deltay.                  */
   int     xleft;          /* Minimum X coordinate.                          */
   int     xright;         /* Maximum X coordinate.                          */
   int     ybottom;        /* Minimum Y coordinate.                          */
   int     ytop;           /* Maximum Y coordinate.                          */
 
   /* Get X and Y bounds of the clipping window.  */
   xleft   =  window[SS];
   xright  =  window[SS] + window[NS] - 1;
   ybottom =  window[SL];
   ytop    =  window[SL] + window[NL] - 1;

   /* Algorithm.  */
   *lstat = 1;
   t0 = 0.0;
   t1 = 1.0;

   /* Distance between X0 and X1.  */
   deltax = (long) (*x1 - *x0);

   /* Distance from left edge of window to X0.  */
   deltat = (long)(*x0 - xleft);
   temp = -deltax;

   /* If the point is accepted, continue.  */
   if (graphics_clipt(&temp,&deltat,&t0,&t1))
   {
      /* Distance from right edge of window to X0.  */
      deltat = (long)(xright - *x0);              

      /* If the point is accepted, continue.  */
      if (graphics_clipt(&deltax,&deltat,&t0,&t1))
      {
         /* Distance between Y0 and Y1.  */
         deltay = (long) (*y1 - *y0);

         /* Distance from bottom edge to Y0.  */
         deltat = (long)(*y0 - ybottom);
         temp = -deltay;

         /* If the point is accepted, continue.  */
         if (graphics_clipt(&temp,&deltat,&t0,&t1))
         {
            /* Distance from bottom edge to Y0.  */
            deltat = (long) (ytop - *y0);

            /* If the point is accepted, continue.  */
            if (graphics_clipt(&deltay,&deltat,&t0,&t1))
            {
               *lstat = 2;

               /* Scale X1 and Y1 if needed.  */
               if (t1 < 1.0)
               {
                  *x1 = *x0 + t1 * deltax;
                  *y1 = *y0 + t1 * deltay;
                  *lstat = 3;
               }

               /* Scale X0 and Y0 if needed.  */
               if (t0 > 0.0)
               {
                  *x0 = *x0 + t0 * deltax;
                  *y0 = *y0 + t0 * deltay;
                  *lstat = 3;
               }
            }
         }
      }
   }
   return(XID_S);
}


int graphics_clipt
(
   int *p,    /* First point to check.  From graphics_clip2d this is the
                 distance from X0 to X1 or from Y0 to Y1 (I).                */
   int *q,    /* Second point to check.  From graphics_clip2d this is the
                 distance from the left or right edge of the clipping window
                 to X0 or or from the top or bottom edge of the clipping
                 window to Y0 (I).                                           */
   float *t0, /* Amount to scale first endpoint (I/O).                       */
   float *t1  /* Amount to scale second endpoint (I/O).                      */
)

/*****************************************************************************
 *                                                                           *
 *      Purpose: This is the clipt function of the Liang-Barsky              *
 *               algorithm.                                                  *
 *                                                                           *
 *      By: J.V.R., USGS/EROS Data Center, 5/16/85                           *
 *      Modified by: D. Hollaren, USGS/EROS Data Center, 4/01/86             *
 *              Convert to C.                                                *
 *      Modified by: D. Akkerman, USGS/EROS Data Center, 5/88                *
 *              DMS v3_0 retrocode.                                          *
 *                                                                           *
 *****************************************************************************/
{
   float   r;
   int     accept;

   /* Algorithm.  */
   accept = TRUE;
   if (*p < 0)
   {
      r = (float) *q / (float) *p;
      if (r > *t1)
         accept = FALSE;
      else
      {
         if (r > *t0)
            *t0 = r;
      }
   }
   else
   {
      if (*p > 0)
      {
         r = (float) *q / (float) *p;
         if (r < *t0)
            accept = FALSE;
         else
         {
            if (r < *t1)
               *t1 = r;
         }
      }
      else
      {
         if (*q < 0)
            accept = FALSE;
      }
   }
   return(accept);
}

void graphics_handles
(
   int element,    /* Index to graphics record. (I)                          */
   int win,        /* Image window to draw handles in. (I)
                            -1 = All existing windows
                             0 = Main image window only
                             1 = Full resolution window only
                             2 = Zoomed window only                          */
   Drawable drawable,   /* Specifies the window or pixmap to draw handles in.
                         This must be specified if WIN is not -1.  If WIN is
                         -1 and drawable is NULL, handles will be drawn in
                         the appropriate window on the display. (I)          */
   int sl          /* Starting line of the drawable relative to the full
                         image. (I)                                          */
)

/******************************************************************************
Purpose:
   This routine draws "graphics handles" over the vertices of the input
   graphics element in the user selected color.
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92
Modified by L. Huewe, USGS/EROS Data Center, 10/93
  - Added the win and drawable parameters.
Modified by L. Huewe, USGS/EROS Data Center, 9/94
  - Added the sl parameter which indicates the starting line of the input
    drawable relative to the entire image.

Algorithm Description:
******************************************************************************/
{
   struct ANNOT_ELEMENT   *aptr = NULL;         /* Ptr to annotation specific
                                                   information.              */
   struct LINE_ELEMENT    *lptr = NULL;         /* Ptr to line specific info */
   struct POLY_ELEMENT    *pptr = NULL;         /* Ptr to polygon specific
                                                   information.              */

   Drawable   save_draw;     /* Original value of drawable parameter.        */
   int        bot_flag = 0,  /* Indicates whether or not to draw the bottom
                                graphics handles on annotation strings.      */
              height,        /* Height of area to clear.                     */
              i,             /* Looping variable.                            */
              num_vert = 0,  /* Number of vertices.                          */
              plane_idx,     /* Index into memory plane structure of the
                                currently viewed image.                      */
              reset,         /* Indicates whether or not the label
                                placement flag needs to be reset.            */
              top_flag = 0,  /* Indicates whether or not to draw the top
                                graphics handles on annotation strings.      */
              width,         /* Width of area to clear.                      */
              x,             /* X coordinate to start clearing.              */
              xwin,          /* X window coordinate.                         */
              y,             /* Y coordinate to start clearing.              */
              ylower = 0,    /* Lower Y coordinate of text string.           */
              yorig,         /* Original Y coordinate.                       */
              ywin;          /* Y window coordinate.                         */

   /* Set values in the graphics GC.  */
   XSetLineAttributes(xid.display,xid_graphics.gc,1,LineSolid,CapButt,
                      JoinMiter);
   XSetFunction(xid.display,xid_graphics.gc,GXcopy);
   XSetForeground(xid.display,xid_graphics.gc,
                  xid.color_table[RGBBW_IDX + (xid_editgraph.color)].pixel);

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Save the input value of the drawable parameter.  */
   save_draw = drawable;

   /* If the graphics element is annotation text or a label is being moved,
      draw handles on the corners of the bounding rectangle of the string.  */
   if ((xid_element[element].type == TEXT) ||
       (xid_editgraph.flags & GR_EDITLABEL))
   {
      /* Find the upper left and lower left corners of the string.  */
      xid_file2win(plane_idx,0,xid_element[element].labelx,
                   xid_element[element].labely,&xwin,&ywin);
      x = xwin - (long)(HANDLE / 2.0);
      yorig = y = ywin - (long)(HANDLE / 2.0);
      width = HANDLE;
      height = HANDLE;

      /* If no drawable was specified, draw in the main image window.  */
      if ((win == -1) && (save_draw == NULL))
         drawable = XtWindow(main_image_bulletinboard);
      if ((win == -1) || (win == 0))
      {
         /* Make the necessary adjustments to the Y coordinate if we are
            processing a block of image data that does not start at the first
            line.  */
         top_flag = FALSE;
         if ((y + height - 1) >= sl)
         {
            if (y < sl)
            {
               y = -1;
               height = height - sl + 1;
            }
            else
               y -= sl;
            XFillRectangle(xid.display, drawable, xid_graphics.gc, x, y, width,
                           height);
            top_flag = TRUE;
         }
         ylower = yorig + xid_graphics.font_info[xid_element[element].font]->
                     max_bounds.ascent;
         bot_flag = FALSE;
         if ((ylower + height - 1) >= sl)
         {
            if (ylower < sl)
            {
               ylower = -1;
               height = height - sl + 1;
            }
            else
               ylower -= sl;
            XFillRectangle(xid.display, drawable, xid_graphics.gc, x, ylower,
                           width, height);
            bot_flag = TRUE;
         }
      }
      xid_graphics.font = xid_element[element].font;

      /* Determine the width and height of the string in order to calculate the
         upper right and lower right corners of the string.  */
      if (xid_element[element].type == TEXT) 
         aptr = (struct ANNOT_ELEMENT *)xid_element[element].graph_ptr;
      if (xid_graphics.flags & GR_LABEL)
         reset = FALSE;
      else
         reset = TRUE;

      /* Calculate the label position if editing the graphics label.  */
      if (xid_editgraph.flags & GR_EDITLABEL)
         graphics_labelcalc(xid_element[element].label);
      else
         graphics_labelcalc(aptr->string);
      if (reset)
         xid_graphics.flags &= ~GR_LABEL;
      if ((win == -1) || (win == 0))
      {
         if (top_flag)
         {
            XFillRectangle(xid.display, drawable, xid_graphics.gc,
                           x + xid_label.width, y, width, height);
         }
         if (bot_flag)
         {
            XFillRectangle(xid.display, drawable, xid_graphics.gc,
                           x + xid_label.width, ylower, width, height);
         }
      }

      /* Draw the handles in the full resolution window.  */
      if (xid_fullres != NULL)
      {
         xid_file2win(plane_idx,1,xid_element[element].labelx,
                      xid_element[element].labely,&xwin,&ywin);
         x = xwin - (long)(HANDLE / 2.0);
         yorig = y = ywin - (long)(HANDLE / 2.0);
         width = HANDLE;
         height = HANDLE;

         /* If no drawable was specified, draw in the full res. window.  */
         if ((win == -1) && (save_draw == NULL))
            drawable = XtWindow(fullres_win_bulletinboard);
         if ((win == -1) || (win == 1))
         {
            /* Make the necessary adjustments to the Y coordinate if we are
               processing a block of image data that does not start at the
               first line.  */
            top_flag = FALSE;
            if ((y + height - 1) >= sl)
            {
               if (y < sl)
               {
                  y = -1;
                  height = height - sl + 1;
               }
               else
                  y -= sl;
               XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                              height);
               top_flag = TRUE;
            }
            ylower = yorig + xid_graphics.font_info[xid_element[element].font]
                        ->max_bounds.ascent;
            bot_flag = FALSE;
            if ((ylower + height - 1) >= sl)
            {
               if (ylower < sl)
               {
                  ylower = -1;
                  height = height - sl + 1;
               }
               else
                  ylower -= sl;
               XFillRectangle(xid.display, drawable, xid_graphics.gc, x, 
                              ylower, width, height);
               bot_flag = TRUE;
            }
         }
         xid_graphics.font = xid_element[element].font;
         if (xid_element[element].type == TEXT) 
            aptr = (struct ANNOT_ELEMENT *)xid_element[element].graph_ptr;
         if (xid_graphics.flags & GR_LABEL)
            reset = FALSE;
         else
            reset = TRUE;

         /* Calculate the label position if editing the graphics label.  */
         if (xid_editgraph.flags & GR_EDITLABEL)
            graphics_labelcalc(xid_element[element].label);
         else
            graphics_labelcalc(aptr->string);
         if (reset)
            xid_graphics.flags &= ~GR_LABEL;
         if ((win == -1) || (win == 1))
         {
            if (top_flag)
            {
               XFillRectangle(xid.display, drawable, xid_graphics.gc,
                              x + xid_label.width, y, width, height);
            }
            if (bot_flag)
            {
               XFillRectangle(xid.display, drawable, xid_graphics.gc,
                              x + xid_label.width, ylower, width, height);
            }
         }
      }

      /* Draw the handles in the zoom window.  */
      if (xid_zoom.flags & ZOOM_ACTIVE)
      {
         xid_file2win(plane_idx,2,xid_element[element].labelx,
                      xid_element[element].labely,&xwin,&ywin);
         x = xwin - (long)(HANDLE / 2.0);
         yorig = y = ywin - (long)(HANDLE / 2.0);
         width = HANDLE;
         height = HANDLE;

         /* If no drawable was specified, draw in the zoom window.  */
         if ((win == -1) && (save_draw == NULL))
            drawable = XtWindow(zoom_win_bulletinboard);
         if ((win == -1) || (win == 2))
         {
            /* Make the necessary adjustments to the Y coordinate if we are
               processing a block of image data that does not start at the
               first line.  */
            top_flag = FALSE;
            if ((y + height - 1) >= sl)
            {
               if (y < sl)
               {
                  y = -1;
                  height = height - sl + 1;
               }
               else
                  y -= sl;
               XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                              height);
               top_flag = TRUE;
            }
            ylower = yorig + xid_graphics.font_info[xid_element[element].font]
                        ->max_bounds.ascent;
            bot_flag = FALSE;
            if ((ylower + height - 1) >= sl)
            {
               if (ylower < sl)
               {
                  ylower = -1;
                  height = height - sl + 1;
               }
               else
                  ylower -= sl;
               XFillRectangle(xid.display, drawable, xid_graphics.gc, x,ylower,
                              width,height);
               bot_flag = TRUE;
            }
         }
         xid_graphics.font = xid_element[element].font;
         if (xid_element[element].type == TEXT) 
            aptr = (struct ANNOT_ELEMENT *)xid_element[element].graph_ptr;
         if (xid_graphics.flags & GR_LABEL)
            reset = FALSE;
         else
            reset = TRUE;

         /* Calculate the label position if editing the graphics label.  */
         if (xid_editgraph.flags & GR_EDITLABEL)
            graphics_labelcalc(xid_element[element].label);
         else
            graphics_labelcalc(aptr->string);
         if (reset)
            xid_graphics.flags &= ~GR_LABEL;
         if ((win == -1) || (win == 2))
         {
            if (top_flag)
            {
               XFillRectangle(xid.display, drawable, xid_graphics.gc,
                              x + xid_label.width, y, width, height);
            }
            if (bot_flag)
            {
               XFillRectangle(xid.display, drawable,xid_graphics.gc,
                              x + xid_label.width, ylower, width, height);
            }
         }
      }
   }

   /* If the graphics element is a point, draw handles on the vertex of the
      point.  */
   else if (xid_element[element].type == POINT)
   {
      /* Calculate the window coordinate of the point vertex.  */
      xid_file2win(plane_idx,0,xid_element[element].x,xid_element[element].y,
                   &xwin,&ywin);
      x = xwin - (long)(HANDLE / 2.0);
      y = ywin - (long)(HANDLE / 2.0);
      width = HANDLE;
      height = HANDLE;

      /* Make the necessary adjustments to the Y coordinate if we are
         processing a block of image data that does not start at the first
         line.  */
      if ((y + height - 1) >= sl)
      {
         if (y < sl)
         {
            y = -1;
            height = height - sl + 1;
         }
         else
            y -= sl;

         /* If no drawable was specified, draw in the main image window.  */
         if ((win == -1) && (save_draw == NULL))
            drawable = XtWindow(main_image_bulletinboard);
         if ((win == -1) || (win == 0))
         {
            XFillRectangle(xid.display, drawable, xid_graphics.gc, x, y, width,
                           height);
         }
      }

      /* Draw the handle in the full resolution window.  */
      if (xid_fullres != NULL)
      {
         xid_file2win(plane_idx,1,xid_element[element].x,
                      xid_element[element].y,&xwin,&ywin);
         x = xwin - (long)(HANDLE / 2.0);
         y = ywin - (long)(HANDLE / 2.0);
         width = HANDLE;
         height = HANDLE;

         /* Make the necessary adjustments to the Y coordinate if we are
            processing a block of image data that does not start at the first
            line.  */
         if ((y + height - 1) >= sl)
         {
            if (y < sl)
            {
               y = -1;
               height = height - sl + 1;
            }
            else
               y -= sl;

            /* If no drawable was specified, draw in the full res. window.  */
            if ((win == -1) && (save_draw == NULL))
               drawable = XtWindow(fullres_win_bulletinboard); 
            if ((win == -1) || (win == 1))
            {
               XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                              height);
            }
         }
      }

      /* Draw the handle in the zoom window.  */
      if (xid_zoom.flags & ZOOM_ACTIVE) 
      {
         xid_file2win(plane_idx,2,xid_element[element].x,
                      xid_element[element].y,&xwin,&ywin);
         x = xwin - (long)(HANDLE / 2.0);
         y = ywin - (long)(HANDLE / 2.0);
         width = HANDLE;
         height = HANDLE;

         /* Make the necessary adjustments to the Y coordinate if we are
            processing a block of image data that does not start at the first
            line.  */
         if ((y + height - 1) >= sl)
         {
            if (y < sl)
            {
               y = -1;
               height = height - sl + 1;
            }
            else
               y -= sl;

            /* If no drawable was specified, draw in the zoom window.  */
            if ((win == -1) && (save_draw == NULL))
               drawable = XtWindow(zoom_win_bulletinboard);
            if ((win == -1) || (win == 2))
            {
               XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                              height);
            }
         }
      }
   }

   /* If the graphics element is a line, polygon or rectangle, draw handles on
      the vertices.  */
   else if ((xid_element[element].type == LINE) ||
            (xid_element[element].type == POLY) ||
            (xid_element[element].type == RECT))
   {
      /* Set the appropriate pointers and the number of vertices.  */
      if ((xid_element[element].type == POLY) ||
          (xid_element[element].type == RECT))
      {
         pptr = (struct POLY_ELEMENT *)xid_element[element].graph_ptr;
         num_vert = pptr->num_vert;
      }
      else if (xid_element[element].type == LINE)
      {
         lptr = (struct LINE_ELEMENT *)xid_element[element].graph_ptr;
         num_vert = lptr->num_vert;
      }
    
      /* Draw a handle over each vertex.  */
      for (i=0; i < num_vert; i++)
      {
         /* Calculate the window coordinate of the vertex and draw the handle*/
         if (xid_element[element].type == LINE)
            xid_file2win(plane_idx,0,lptr->x[i],lptr->y[i],&xwin,&ywin);
         else
            xid_file2win(plane_idx,0,pptr->x[i],pptr->y[i],&xwin,&ywin);
         x = xwin - (long)(HANDLE / 2.0);
         y = ywin - (long)(HANDLE / 2.0);
         width = HANDLE;
         height = HANDLE;

         /* Make the necessary adjustments to the Y coordinate if we are
            processing a block of image data that does not start at the first
            line.  */
         if ((y + height - 1) >= sl)
         {
            if (y < sl)
            {
               y = -1;
               height = height - sl + 1;
            }
            else
               y -= sl;
         }
         else
            height = 0;
         /* If no drawable was specified, draw in the main image window.  */
         if ((win == -1) && (save_draw == NULL))
            drawable = XtWindow(main_image_bulletinboard);
         if (((win == -1) || (win == 0)) && (height != 0))
         {
            XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                           height);
         }

         /* Draw the handle in the full resolution window.  */
         if (xid_fullres != NULL)
         {
            if (xid_element[element].type == LINE)
               xid_file2win(plane_idx,1,lptr->x[i],lptr->y[i],&xwin,&ywin);
            else
               xid_file2win(plane_idx,1,pptr->x[i],pptr->y[i],&xwin,&ywin);

            x = xwin - (long)(HANDLE / 2.0);
            y = ywin - (long)(HANDLE / 2.0);
            width = HANDLE;
            height = HANDLE;

            /* Make the necessary adjustments to the Y coordinate if we are
               processing a block of image data that does not start at the
               first line.  */
            if ((y + height - 1) >= sl)
            {
               if (y < sl)
               {
                  y = -1;
                  height = height - sl + 1;
               }
               else
                  y -= sl;
            }
            else
               height = 0;

            /* If no drawable was specified, draw in the full res. window.  */
            if ((win == -1) && (save_draw == NULL))
               drawable = XtWindow(fullres_win_bulletinboard);
            if (((win == -1) || (win == 1)) && (height != 0))
               XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                              height);
         }

         /* Draw the handle in the zoom window.  */
         if (xid_zoom.flags & ZOOM_ACTIVE) 
         {
            if (xid_element[element].type == LINE)
               xid_file2win(plane_idx,2,lptr->x[i],lptr->y[i],&xwin,&ywin);
            else
               xid_file2win(plane_idx,2,pptr->x[i],pptr->y[i],&xwin,&ywin);

            x = xwin - (long)(HANDLE / 2.0);
            y = ywin - (long)(HANDLE / 2.0);
            width = HANDLE;
            height = HANDLE;

            /* Make the necessary adjustments to the Y coordinate if we are
               processing a block of image data that does not start at the
               first line.  */
            if ((y + height - 1) >= sl)
            {
               if (y < sl)
               {
                  y = -1;
                  height = height - sl + 1;
               }
               else
                  y -= sl;
            }
            else
                height = 0;

            /* If no drawable was specified, draw in the zoom window.  */
            if ((win == -1) && (save_draw == NULL))
               drawable = XtWindow(zoom_win_bulletinboard);
            if (((win == -1) || (win == 2)) && (height != 0))
            {
               XFillRectangle(xid.display,drawable,xid_graphics.gc,x,y,width,
                              height);
            }
         }
      }
   }
}

/* ARGSUSED */
void edit_destroy
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine closes the graphics edit panel. 
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
   XmString  xmstr;                    /* Motif format string.               */
   struct ANNOT_ELEMENT  *aptr;        /* Ptr to annotation specific info    */
   struct LINE_ELEMENT   *lptr;        /* Ptr to line specific info          */
   struct POLY_ELEMENT   *pptr;        /* Ptr to polygon specific info       */

   /* The user must finish modifying the current graphics element before
      exiting.  */
   if ((xid_editgraph.newx != -1) && (xid_editgraph.flags & GR_MOVE))
   {
      xid_message("User must place current point before exiting");
      return;
   }
   if ((xid_editgraph.vert != -1) && (xid_editgraph.flags & GR_ADD))
   {
      xid_message("User must finish adding points before exiting");
      return;
   }
   if (xid_graphics.flags & GR_LABEL)
   {
      xid_message("User must place label/text before exiting");
      return;
   }

   /* Warn the user if the current modifications have not been saved to the
      GOF.  */
   if ((!(xid_editgraph.writeflg)) && (xid_editgraph.flags & GR_MODIFY))
   {
      XBell(xid.display,0);
      graphics_editwarn(0,"E");
      return;
   }

   /* Close the edit graphics panel.  */
   XtPopdown(graphics_edit_popup);

   /* If the "Set Attributes" panel is displayed, close it.  */
   if (XtIsRealized(Shell_Setatt))
      setatt_dismiss(w,client,call);

   /* Clear the label field.  */
   xmstr = XmStringCreateLtoR("", XmSTRING_DEFAULT_CHARSET);
   XtVaSetValues(graphics_label_label,XmNlabelString,xmstr,NULL);
   XmStringFree(xmstr);

   /* Make appropriate options insensitive.  */
   XtSetSensitive(graphics_defatt_button,False);
   XtSetSensitive(graphics_setatt_button,False);
   XtSetSensitive(graphics_label_button,False);
   XtSetSensitive(graphics_width_option,False);
   XtSetSensitive(graphics_color_option,False);
   XtSetSensitive(graphics_fonts_option,False);

   /* Make the "load" and "select" toggles sensitive again.  */
   XtSetSensitive(graphics_load_toggle,True);
   XtSetSensitive(graphics_select_toggle,True);
   XtSetSensitive(graphics_port_load_button,True);
   XtSetSensitive(graphics_port_save_button,True);

   /* Erase any "handles" drawn for selected graphics elements.  */
   if (xid_editgraph.current != -1)
   {
      graphics_erase_handles();
      xid_editgraph.writeflg = FALSE;
   }

   /* Remove the edit graphics contexts.  */
   xid_contextdel(CON_GREDIT);
   if (XeContextCheckList((XeContextWidget)context_mouse,
                          context_names[CON_GRMVDEL]))
      xid_contextdel(CON_GRMVDEL);
   if (XeContextCheckList((XeContextWidget)context_mouse,
                          context_names[CON_GRADD]))
      xid_contextdel(CON_GRADD);

   /* Reset flags.  */
   xid_editgraph.flags = 0;
   xid_graphics.flags &= ~GR_EDIT;

   /* Free the edit graphics structures.  */
   if (xid_editorig.graph_ptr != NULL)
   {
      if (xid_editorig.type == LINE)
      {
         lptr = (struct LINE_ELEMENT *)xid_editorig.graph_ptr;
         if (lptr->x != NULL)
            free(lptr->x);
         if (lptr->y != NULL)
            free(lptr->y);
         free(xid_editorig.graph_ptr);
         xid_editorig.graph_ptr = NULL;
      }
      if ((xid_editorig.type == POLY) || (xid_editorig.type == RECT))
      {
         pptr = (struct POLY_ELEMENT *)xid_editorig.graph_ptr;
         if (pptr->x != NULL)
            free(pptr->x);
         if (pptr->y != NULL)
            free(pptr->y);
         free(xid_editorig.graph_ptr);
         xid_editorig.graph_ptr = NULL;
      }
      if (xid_editorig.type == TEXT)
      {
         aptr = (struct ANNOT_ELEMENT *)xid_editorig.graph_ptr;
         if (aptr->string != NULL)
            free(aptr->string);
         free(xid_editorig.graph_ptr);
         xid_editorig.graph_ptr = NULL;
      }
   }

   if (xid_editundo.graph_ptr != NULL)
   {
      if (xid_editundo.type == LINE)
      {
         lptr = (struct LINE_ELEMENT *)xid_editundo.graph_ptr;
         if (lptr->x != NULL)
            free(lptr->x);
         if (lptr->y != NULL)
            free(lptr->y);
         free(xid_editundo.graph_ptr);
         xid_editundo.graph_ptr = NULL;
      }
      if ((xid_editundo.type == POLY) || (xid_editundo.type == RECT))
      {
         pptr = (struct POLY_ELEMENT *)xid_editundo.graph_ptr;
         if (pptr->x != NULL)
            free(pptr->x);
         if (pptr->y != NULL)
            free(pptr->y);
         free(xid_editundo.graph_ptr);
         xid_editundo.graph_ptr = NULL;
      }
      if (xid_editundo.type == TEXT)
      {
         aptr = (struct ANNOT_ELEMENT *)xid_editundo.graph_ptr;
         if (aptr->string != NULL)
            free(aptr->string);
         free(xid_editundo.graph_ptr);
         xid_editundo.graph_ptr = NULL;
      }
   }
}

/* ARGSUSED */
void graphics_sethandle
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine changes the color of the graphics handles.
                                                                
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
******************************************************************************/
{
   Arg         args[1];        /* Arguments for setting resource values.     */

   /* Set the foreground color of the option menu to reflect the color
      selected.  */
   xid_editgraph.color = (long)client; 
   XtSetArg(args[0], XmNforeground,
            xid.color_table[RGBBW_IDX + xid_editgraph.color].pixel); 
   XtSetValues(graphics_editcol_option, args, 1);

   /* Redraw the graphics handles in the selected color.  */
   if (xid_editgraph.current != -1)
      graphics_handles(xid_editgraph.current,-1,NULL,0);
}

void graphics_editselect
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine performs the appropriate action based on the mouse button
   selected when the user is in edit-move mode.  Selecting the left
   mouse button selects a new position for the selected element/vertex and
   selecting the middle mouse button cancels the current move.
                                                                
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
******************************************************************************/
{
   XButtonEvent         *event;      /* X Event structure.                   */
   struct LINE_ELEMENT  *lptr = NULL;/* Ptr to line specific info            */
   struct POLY_ELEMENT  *pptr = NULL;/* Ptr to polygon specific info         */
   float                loright[2];  /* Lower right bounding coord. to save. */
   float                upleft[2];   /* Upper left bounding coord. to save.  */
   float                xfil;        /* X file coordinate.                   */
   float                yfil;        /* Y file coordinate.                   */
   float                xsave = 0.0; /* Current X file coordinate to save.   */
   float                ysave = 0.0; /* Current Y file coordinate to save.   */
   long                 plane_idx;   /* Index into memory plane structure of
                                        the currently viewed image.          */
   long                 status;      /* Status indicator.                    */
   long                 win = 0;     /* Window from which coordinates are to
                                        be calculated.                       */
   int                  x1win;       /* X window coordinate.                 */
   int                  y1win;       /* Y window coordinate.                 */
   int                  x2win;       /* X window coordinate.                 */
   int                  y2win;       /* Y window coordinate.                 */

   event = (XButtonEvent *)call;

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Determine which window generated the event.  */
   if (w == main_image_bulletinboard)
      win = 0;
   else if (w == fullres_win_bulletinboard)
      win = 1;
   else if (w == zoom_win_bulletinboard)
      win = 2;

   /* Perform the appropriate action based on the mouse button selected.  */
   switch (event->button)
   {
      /* Select a new position for annotation text, label, point or vertex of a
         line, polygon or rectangle.  */
      case 1:

         /* Delete the old string and set appropriate flags.  */
         if ((xid_graphics.type == TEXT) ||
             (xid_editgraph.flags & GR_EDITLABEL))
         {
            graphics_deletestring(plane_idx,xid_editgraph.current);
            xid_editgraph.flags |= GR_MODIFY;
            xid_editgraph.writeflg = FALSE;
         }

         /* Delete the line segments on either side of the selected vertex.  */
         else if ((xid_graphics.type == LINE) || (xid_graphics.type == POLY))
         {
            graphics_deletelinerect(w,win,plane_idx,xid_editgraph.fxprev,
                                    xid_editgraph.fyprev,xid_editgraph.xfil,
                                    xid_editgraph.yfil,FALSE);
            graphics_deletelinerect(w,win,plane_idx,xid_editgraph.xfil,
                                    xid_editgraph.yfil,xid_editgraph.fxnext,
                                    xid_editgraph.fynext,FALSE);
         }

         /* Delete the old rectangle.  */
         else if (xid_graphics.type == RECT)
            graphics_deletelinepoly(win,xid_editgraph.current,plane_idx);

         /* Delete the old point and set the appropriate flags.  */
         else if (xid_graphics.type == POINT)
         {
            graphics_deletepoint(win,xid_editgraph.current,plane_idx);
            xid_editgraph.flags |= GR_MODIFY;
            xid_editgraph.writeflg = FALSE;
         }

         /* Make a copy of the graphics element for the "graphics undo"
            function.  */
         status = graphics_copy_element(&xid_element[xid_editgraph.current],
                                        &xid_editundo);
         if (status != XID_S)
            return;

         /* Draw the element or vertex in its new position.  */
         graphics_editclose(w,win,plane_idx);

         /* Make the appropriate changes to the graphics element structure.  */
         graphics_change(win,plane_idx);

         /* Force an expose event over the affected area.  */
         xid_file2win(plane_idx,win,
                      xid_element[xid_editgraph.current].upleft[0],
                      xid_element[xid_editgraph.current].upleft[1],&x1win,
                      &y1win);
         xid_file2win(plane_idx,win,
                      xid_element[xid_editgraph.current].loright[0],
                      xid_element[xid_editgraph.current].loright[1],&x2win,
                      &y2win);
         XClearArea(xid.display,XtWindow(w),x1win-HANDLE,y1win-HANDLE,
                    (x2win+HANDLE)-(x1win-HANDLE)+1,
                    (y2win+HANDLE)-(y1win-HANDLE)+1,True);

         /* Reset appropriate variables and flags.  */
         xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx = 
            xid_editgraph.nexty = xid_editgraph.newx = xid_editgraph.newy = 
            xid_editgraph.vert =  xid_editgraph.new_ulx = xid_editgraph.new_uly
            = xid_editgraph.width = xid_editgraph.height = -1;
         xid_editgraph.ulx = xid_editgraph.uly = -1.0;
         xid_editgraph.flags &= ~GR_EDITLABEL;

         /* Make appropriate options sensitive.  */
         XtSetSensitive(graphics_edit_undo,True);
         XtSetSensitive(graphics_edit_apply,True);
         break;

      /* Cancel.  */
      case 2:
         if (xid_graphics.type == POINT)
         {
            /* Reset appropriate variables.  */
            xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx = 
               xid_editgraph.nexty = xid_editgraph.newx = xid_editgraph.newy = 
               xid_editgraph.vert = xid_label.x = xid_label.y = -1;

            /* Make the appropriate context sensitive and active.  */
            XeContextSensitize((XeContextWidget)context_mouse,
                               context_names[CON_GREDIT]);
            XeContextSetActive((XeContextWidget)context_mouse,
                               context_names[CON_GREDIT]);
            if ((XeContextCheckList((XeContextWidget)context_mouse, 
                                    context_names[CON_GRMVDEL])))
            {
               XeContextDesensitize((XeContextWidget)context_mouse,
                                    context_names[CON_GRMVDEL]);
            }
            if ((XeContextCheckList((XeContextWidget)context_mouse,
                                    context_names[CON_GRADD])))
            {
               XeContextDesensitize((XeContextWidget)context_mouse,
                                    context_names[CON_GRADD]);
            }

            /* Make the appropriate options sensitive.  */
            XtSetSensitive(graphics_edit_undo,True);
            XtSetSensitive(graphics_edit_apply,True);
            break;
         }

         /* Save the current bounding rectangle.  */
         upleft[0] = xid_element[xid_editgraph.current].upleft[0];
         upleft[1] = xid_element[xid_editgraph.current].upleft[1];
         loright[0] = xid_element[xid_editgraph.current].loright[0];
         loright[1] = xid_element[xid_editgraph.current].loright[1];

         /* Calculate the file coordinate of the current cursor position.  */
         xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,
                      &xfil,&yfil);

         /* Save the current text position and calculate the file coordinate of
            the new position to cancel.  */
         if (xid_graphics.type == TEXT)
         {
            xsave = xid_element[xid_editgraph.current].x;
            ysave = xid_element[xid_editgraph.current].y;
            xid_win2file(plane_idx,win,xid_label.x,xid_label.y,&xfil,&yfil);
            xid_element[xid_editgraph.current].x = xfil;
            xid_element[xid_editgraph.current].y = yfil;
         }

         /* Save the current label position and calculate the file coordinate
            of the new position to cancel.  */
         else if (xid_editgraph.flags & GR_EDITLABEL)
         {
            xsave = xid_element[xid_editgraph.current].labelx;
            ysave = xid_element[xid_editgraph.current].labely;
            xid_win2file(plane_idx,win,xid_label.x,xid_label.y,&xfil,&yfil);
            xid_element[xid_editgraph.current].labelx = xfil;
            xid_element[xid_editgraph.current].labely = yfil;
         }

         /* Save the current vertex position and calculate the file coordinate
            of the new position to cancel.  */
         else if (xid_graphics.type == LINE)
         {
            lptr = (struct LINE_ELEMENT *)xid_element[xid_editgraph.current].
               graph_ptr;
            xsave = lptr->x[xid_editgraph.vert];
            ysave = lptr->y[xid_editgraph.vert];
            xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,
                         &xfil,&yfil);
            lptr->x[xid_editgraph.vert] = xfil;
            lptr->y[xid_editgraph.vert] = yfil;
         }
         else if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
         {
            pptr = (struct POLY_ELEMENT *)xid_element[xid_editgraph.current].
               graph_ptr;
            xsave = pptr->x[xid_editgraph.vert];
            ysave = pptr->y[xid_editgraph.vert];
            xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,
                         &xfil,&yfil);
            pptr->x[xid_editgraph.vert] = xfil;
            pptr->y[xid_editgraph.vert] = yfil;
         }

         /* Calculate the bounding rectangle with the new point incorporated.*/
         graphics_setbounds(xid_editgraph.current);

         /* Clear the area which erases any rubber-band lines and copies the
            graphics pixmaps to the image.  Copying the pixmaps restores the
            graphics element to the state it was in before the "move" command
            was executed.  */
         graphics_expose_area(win,xid_editgraph.current,plane_idx);

         /* Restore saved points.  */
         if (xid_graphics.type == TEXT)
         {
            xid_element[xid_editgraph.current].x = xsave;
            xid_element[xid_editgraph.current].y = ysave;
         }
         else if (xid_editgraph.flags & GR_EDITLABEL)
         {
            xid_element[xid_editgraph.current].labelx = xsave;
            xid_element[xid_editgraph.current].labely = ysave;
         }
         else if (xid_graphics.type == LINE)
         {
            lptr->x[xid_editgraph.vert] = xsave;
            lptr->y[xid_editgraph.vert] = ysave;
         }
         else if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
         {
            pptr->x[xid_editgraph.vert] = xsave;
            pptr->y[xid_editgraph.vert] = ysave;
         }

         /* Restore bounding rectangle.  */
         xid_element[xid_editgraph.current].upleft[0] = upleft[0];
         xid_element[xid_editgraph.current].upleft[1] = upleft[1];
         xid_element[xid_editgraph.current].loright[0] = loright[0];
         xid_element[xid_editgraph.current].loright[1] = loright[1];

         /* Reset flags and variables.  */
         xid_editgraph.flags &= ~GR_EDITLABEL;
         xid_graphics.flags &= ~GR_LABEL;
         xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx = 
            xid_editgraph.nexty = xid_editgraph.newx = xid_editgraph.newy = 
            xid_editgraph.vert = xid_label.x = xid_label.y = -1;
         xid_editgraph.new_ulx = xid_editgraph.new_uly = xid_editgraph.width = 
            xid_editgraph.height = -1;

         /* Make appropriate context sensitive and active.  */
         XeContextSensitize((XeContextWidget)context_mouse,
                            context_names[CON_GREDIT]);
         XeContextSetActive((XeContextWidget)context_mouse,
                            context_names[CON_GREDIT]);
         if ((XeContextCheckList((XeContextWidget)context_mouse, 
                                 context_names[CON_GRMVDEL])))
         {
            XeContextDesensitize((XeContextWidget)context_mouse,
                                 context_names[CON_GRMVDEL]);
         }
         if ((XeContextCheckList((XeContextWidget)context_mouse, 
                                 context_names[CON_GRADD])))
         {
            XeContextDesensitize((XeContextWidget)context_mouse,
                                 context_names[CON_GRADD]);
         }

         /* Make appropriate options sensitive.  */
         XtSetSensitive(graphics_edit_undo,True);
         XtSetSensitive(graphics_edit_apply,True);
         break;
   }
}

void graphics_editclose
(
   Widget w,                   /* Widget ID.  (I)                            */
   long win,                   /* Type of window. (I)
                                    0 - Main image window.
                                    1 - Full resolution window.
                                    2 - Zoomed window.                       */
   long plane_idx              /* Index into memory plane structure of the
                                  currently viewed image.  (I)               */
)
 
/******************************************************************************
Purpose:
   Completes the modification of a graphics element by erasing the
   rubber-band lines and drawing the appropriate point, annotation text, 
   label or line segment.
 
By L. Huewe, USGS/EROS Data Center, 7/92
 
Algorithm Description:
******************************************************************************/
{
   int             xwin,           /* X window coordinate.                   */
                   ywin;           /* Y window coordinate.                   */
   float           xfil,           /* X file coordinate.                     */
                   yfil;           /* Y file coordinate.                     */

   /* Move a point, annotation text, label or vertex of a line, polygon or
      rectangle.  */
   if ((xid_editgraph.flags & GR_MOVE) || (xid_editgraph.flags & GR_EDITLABEL))
   {
      /* Draw the annotation text or label at the new location.  */
      if ((xid_graphics.type == TEXT) || (xid_editgraph.flags & GR_EDITLABEL))
      {
         xid_win2file(plane_idx,win,xid_label.x,xid_label.y,&xfil,&yfil);
         xid_file2win(plane_idx,win,xfil,yfil,&xwin,&ywin);
         xid_editgraph.newx = xwin; 
         xid_editgraph.newy = ywin; 
         graphics_drawstring(w,win,xwin,ywin,plane_idx);
         xid_label.x = xid_label.y = -1;
      }
      else if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
      {
         /* Erase the rubber-band line.  */
         XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
                            JoinMiter);
         XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
         XSetFunction(xid.display,xid_graphics.gc,GXxor);
         if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
             (xid_editgraph.vert != -1))
         {
            XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
                      xid_editgraph.prevx,xid_editgraph.prevy,
                      xid_editgraph.newx,xid_editgraph.newy);

            /* Draw the new line segment.  */
            xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,
                         &xfil,&yfil);
            xid_file2win(plane_idx,win,xfil,yfil,&xwin,&ywin);
            xid_graphics.selectx = xid_editgraph.prevx;
            xid_graphics.selecty = xid_editgraph.prevy;
            xid_graphics.prevx = xid_editgraph.newx;
            xid_graphics.prevy = xid_editgraph.newy;
            graphics_drawlinerect(w,win,xwin,ywin,plane_idx,xfil,yfil);
         }
         if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) && 
             (xid_editgraph.vert != -1))
         {
            /* Erase the rubber-band line.  */
            XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
                      xid_editgraph.nextx,xid_editgraph.nexty,
                      xid_editgraph.newx,xid_editgraph.newy);

            /* Draw the new line segment.  */
            xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,
                         &xfil,&yfil);
            xid_file2win(plane_idx,win,xfil,yfil,&xwin,&ywin);
            xid_graphics.prevx = xid_editgraph.newx;
            xid_graphics.prevy = xid_editgraph.newy;
            xid_graphics.selectx = xid_editgraph.nextx;
            xid_graphics.selecty = xid_editgraph.nexty;
            graphics_drawlinerect(w,win,xwin,ywin,plane_idx,xfil,yfil);
         }
      }
      else if (xid_graphics.type == RECT)
      {
         /* Erase the rubber-band line.  */
         XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
                            JoinMiter);
         XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
         XSetFunction(xid.display,xid_graphics.gc,GXxor);
         if ((xid_editgraph.new_ulx != -1) && (xid_editgraph.new_uly != -1) &&
             (xid_editgraph.width != -1) && (xid_editgraph.height != -1))
         {
            XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
                           xid_editgraph.new_ulx,xid_editgraph.new_uly,
                           xid_editgraph.width,xid_editgraph.height);

            /* Draw the new line segment.  */
            xid_win2file(plane_idx,win,xid_editgraph.new_ulx,
                         xid_editgraph.new_uly,&xfil,&yfil);
            xid_file2win(plane_idx,win,xfil,yfil,&xwin,&ywin);
            xid_graphics.selectx = xid_graphics.prevx = xwin; 
            xid_graphics.selecty = xid_graphics.prevy = ywin; 
            xid_win2file(plane_idx,win,xwin+xid_editgraph.width,
                         ywin + xid_editgraph.height,&xfil,&yfil);
            graphics_drawlinerect(w,win,xwin+xid_editgraph.width,
                                  ywin + xid_editgraph.height,plane_idx,xfil,
                                  yfil);
         }
      }

      /* Draw the point at the new location.  */
      else if (xid_graphics.type == POINT)
      {
         xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,
                      &xfil,&yfil);
         xid_file2win(plane_idx,win,xfil,yfil,&xwin,&ywin);
         graphics_drawpoint(w,win,xwin,ywin,plane_idx,xfil,yfil);
      }

      /* Make the appropriate context sensitive and active.  */
      XeContextSensitize((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      XeContextSetActive((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      if ((XeContextCheckList((XeContextWidget)context_mouse, 
                              context_names[CON_GRMVDEL])))
      {
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRMVDEL]);
      }
      if ((XeContextCheckList((XeContextWidget)context_mouse, 
                              context_names[CON_GRADD])))
      {
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRADD]);
      }
   }

   /* Finish adding the selected points to a line or polygon.  */
   else if (xid_editgraph.flags & GR_ADD)
   {
      if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
      {
         /* Erase the rubber-band lines.  */
         XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
                            JoinMiter);
         XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
         XSetFunction(xid.display,xid_graphics.gc,GXxor);
         if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
             (xid_editgraph.vert != -1))
         {
            XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
                      xid_editgraph.prevx,xid_editgraph.prevy,
                      xid_editgraph.newx,xid_editgraph.newy);
         }
         if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) && 
             (xid_editgraph.vert != -1))
         {
            XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
                      xid_editgraph.nextx,xid_editgraph.nexty,
                      xid_editgraph.newx,xid_editgraph.newy);
         }

         /* Draw the new line segment from the last added vertex to the vertex
            which follows the selected vertex.  */
         if ((xid_editgraph.prevx != -1) && (xid_editgraph.nextx != -1))
         {
            xid_graphics.selectx = xid_editgraph.prevx;
            xid_graphics.selecty = xid_editgraph.prevy;
            xid_graphics.prevx = xid_editgraph.newx;
            xid_graphics.prevy = xid_editgraph.newy;
            graphics_drawlinerect(w,win,xid_editgraph.nextx,
                                  xid_editgraph.nexty,plane_idx,
                                  xid_editgraph.fxnext,xid_editgraph.fynext);
         }
      }

      /* Make the appropriate context sensitive and active.  */
      XeContextSensitize((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      XeContextSetActive((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      if ((XeContextCheckList((XeContextWidget)context_mouse, 
                              context_names[CON_GRMVDEL])))
      {
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRMVDEL]);
      }
      if ((XeContextCheckList((XeContextWidget)context_mouse, 
                              context_names[CON_GRADD])))
      {
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRADD]);
      }
   }
}

void graphics_change
(
   long win,                   /* Type of window. (I)
                                    0 - Main image window.
                                    1 - Full resolution window.
                                    2 - Zoomed window.                       */
   long plane_idx              /* Index into memory plane structure of the
                                  currently viewed image.  (I)               */
)
 
/******************************************************************************
Purpose:
   Updates the graphics element structure of the graphics element the user
   has modified.  New locations of moved vertices are recorded, locations
   of added vertices are added to the structure and the new location of
   annotation text or labels are recorded.
 
By L. Huewe, USGS/EROS Data Center, 7/92
 
Algorithm Description:
******************************************************************************/
{
   struct PT_LIST       *tmp;     /* Temporary pointer to point structure.   */
   struct LINE_ELEMENT  *lptr = NULL;
                                  /* Pointer to line specific information.   */
   struct POLY_ELEMENT  *pptr = NULL;
                                  /* Pointer to polygon specific information.*/
   long                 i,j,      /* Looping indices.                        */
                        new_size; /* Number of bytes needed for the X/Y 
                                   vertices.                                 */
   float                *tmp_ptr, /* Temporary pointer to X/Y vertices.      */
                        xfil,   /* X file coordinate of new point.           */
                        x2fil,  /* X file coordinate of new point.           */
                        yfil,   /* Y file coordinate of new point.           */
                        y2fil;  /* Y file coordinate of new point.           */

   /* Set appropriate pointers.  */
   if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
   {
      pptr = (struct POLY_ELEMENT *)xid_element[xid_editgraph.current].
                graph_ptr;
   }
   else if (xid_graphics.type == LINE)
   {
      lptr = (struct LINE_ELEMENT *)xid_element[xid_editgraph.current].
                graph_ptr;
   }

   /* Calculate the file coordinate of the new cursor location.  */
   xid_win2file(plane_idx,win,xid_editgraph.newx,xid_editgraph.newy,&xfil,
                &yfil);

   /* Modify an existing location of annotation text, label, point or vertex of
      line, polygon or rectangle.  */
   if ((xid_editgraph.flags & GR_MOVE) || (xid_editgraph.flags & GR_EDITLABEL))
   {
      /* Modify the graphics element structure to reflect the new location of
         annotation text or label.  */
      if ((xid_graphics.type == TEXT) || (xid_editgraph.flags & GR_EDITLABEL))
      {
         if (xid_graphics.type == TEXT)
         {
            xid_element[xid_editgraph.current].x = xfil;
            xid_element[xid_editgraph.current].y = yfil;
         }
         xid_element[xid_editgraph.current].labelx = xfil;
         xid_element[xid_editgraph.current].labely = yfil;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }

      /* Modify the graphics element structure to reflect the new location of
         the polygon vertex.  */
      else if (xid_graphics.type == POLY)
      {
         pptr->x[xid_editgraph.vert] = xfil;
         pptr->y[xid_editgraph.vert] = yfil;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }

      /* Modify the graphics element structure to reflect the new locations of
         the rectangle vertices.  Note:  When a rectangle vertex is selected to
         move, the vertices on either side of the selected one are also moved
         in order to preserve the rectangular shape.  */
      else if (xid_graphics.type == RECT)
      {
         xid_win2file(plane_idx,win,xid_editgraph.new_ulx,
                      xid_editgraph.new_uly,&xfil,&yfil);
         xid_win2file(plane_idx,win,xid_editgraph.new_ulx+xid_editgraph.width,
                      xid_editgraph.new_uly+xid_editgraph.height,&x2fil,&y2fil);
         pptr->x[0] = xfil;
         pptr->y[0] = yfil;
         pptr->x[1] = x2fil;
         pptr->y[1] = yfil;
         pptr->x[2] = x2fil;
         pptr->y[2] = y2fil;
         pptr->x[3] = xfil;
         pptr->y[3] = y2fil;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }

      /* Modify the graphics element structure to reflect the new location of
         the line vertex.  */
      else if (xid_graphics.type == LINE)
      {
         lptr->x[xid_editgraph.vert] = xfil;
         lptr->y[xid_editgraph.vert] = yfil;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }

      /* Modify the graphics element structure to reflect the new location of
         the point.  */
      else if (xid_graphics.type == POINT)
      {
         xid_element[xid_editgraph.current].x = xfil;
         xid_element[xid_editgraph.current].y = yfil;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }
   }

   /* If only the label was moved, we are finished.  */
   if (xid_editgraph.flags & GR_EDITLABEL)
      return;

   /* Add the selected points to a line or polygon.  */
   if (xid_editgraph.flags & GR_ADD)
   {
      if (xid_element[xid_editgraph.current].type == POLY) 
      {

         /* Calculate and allocate the amount of space needed for existing
            vertices in addition to the vertices which have been added.  */
         new_size = (long)(pptr->num_vert * sizeof(float) +
                       xid_graphics.temp_num * sizeof(float));
         tmp_ptr = (float *) realloc(pptr->x,new_size);
         if (tmp_ptr == NULL)
         {
            xid_message("Insufficient amount of memory available");
            return;
         }
         pptr->x = tmp_ptr;

         tmp_ptr = (float *) realloc(pptr->y,new_size);
         if (tmp_ptr == NULL)
         {
            xid_message("Insufficient amount of memory available");
            return;
         }
         pptr->y = tmp_ptr;

         /* Move existing vertices to make room to insert the new vertices in
            the proper position.  */
         for (i=pptr->num_vert-1,j=pptr->num_vert+xid_graphics.temp_num-1;
              i > xid_editgraph.vert; i--, j--)
         {
            pptr->x[j] = pptr->x[i];
            pptr->y[j] = pptr->y[i];
         }

         /* Copy the X/Y coordinates from the temporary point structure to the
            polygon structure.  */
         pptr->x[xid_editgraph.vert+1] = xid_graphics.first->x;
         pptr->y[xid_editgraph.vert+1] = xid_graphics.first->y;

         for (i=1, xid_graphics.cur=xid_graphics.first; i <
              xid_graphics.temp_num; i++)
         {
            tmp = xid_graphics.cur;
            xid_graphics.cur = tmp->next;
            pptr->x[xid_editgraph.vert+i+1] = xid_graphics.cur->x;
            pptr->y[xid_editgraph.vert+i+1] = xid_graphics.cur->y;
         }

         /* Assign the number of vertices.  */
         pptr->num_vert += xid_graphics.temp_num;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }
      else if (xid_element[xid_editgraph.current].type == LINE)
      {
         /* Calculate and allocate the amount of space needed for existing
            vertices in addition to the vertices which have been added.  */
         new_size = (long)(lptr->num_vert * sizeof(float) +
                       xid_graphics.temp_num * sizeof(float));
         tmp_ptr = (float *) realloc(lptr->x,new_size);
         if (tmp_ptr == NULL)
         {
            xid_message("Insufficient amount of memory available");
            return;
         }
         lptr->x = tmp_ptr;

         tmp_ptr = (float *) realloc(lptr->y,new_size);
         if (tmp_ptr == NULL)
         {
            xid_message("Insufficient amount of memory available");
            return;
         }
         lptr->y = tmp_ptr;

         /* Move existing vertices to make room to insert the new vertices in
            the proper position.  */
         for (i=lptr->num_vert-1,j=lptr->num_vert+xid_graphics.temp_num-1;
              i > xid_editgraph.vert; i--, j--)
         {
            lptr->x[j] = lptr->x[i];
            lptr->y[j] = lptr->y[i];
         }

         /* Copy the X/Y coordinates from the temporary point structure to the
            line structure.  */
         lptr->x[xid_editgraph.vert+1] = xid_graphics.first->x;
         lptr->y[xid_editgraph.vert+1] = xid_graphics.first->y;

         for (i=1, xid_graphics.cur=xid_graphics.first; i <
              xid_graphics.temp_num; i++)
         {
            tmp = xid_graphics.cur;
            xid_graphics.cur = tmp->next;
            lptr->x[xid_editgraph.vert+i+1] = xid_graphics.cur->x;
            lptr->y[xid_editgraph.vert+i+1] = xid_graphics.cur->y;
         }

         /* Assign the number of vertices.  */
         lptr->num_vert += xid_graphics.temp_num;

         /* Recalculate the bounding rectangle.  */
         graphics_setbounds(xid_editgraph.current);
      }

      /* Free the temporary point structures.  */
      while (xid_graphics.cur->prev != NULL)
      {
         tmp = xid_graphics.cur->prev;
         free(xid_graphics.cur);
         xid_graphics.cur = tmp;
      }
      free(xid_graphics.cur);
      xid_graphics.temp_num = 0;
      xid_graphics.first = (struct PT_LIST *)NULL;
   }
}

void graphics_updategof
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   Write a modified record to the appropriate GOF.
 
By L. Huewe, USGS/EROS Data Center, 11/92
 
Algorithm Description:
******************************************************************************/
{
   union GOF    gofbuf;          /* GOF structure.                           */
   int          addrec = TRUE,   /* Flag indicating records are being added
                                    to the GOF.                              */
                element,         /* Graphics element to write to GOF.  (I)   */
                gtype,           /* GOF type (for c_gofrd).                  */
                nbytes,          /* Number of bytes read.                    */
                next,            /* Number of bytes to next GOF record.      */
                status;          /* Status indicator.                        */

   /* Set appropriate graphics element indices.  */
   if (xid_editgraph.flags & GR_REMOVE)
   {
      element = xid_editgraph.delete_idx;
      xid_editgraph.delete_idx = -1;
   }
   else
      element = xid_editgraph.current;

   /* Determine the type of GOF record.  */
   if (xid_element[element].type == POINT)
      gtype = PNT;
   else if ((xid_element[element].type == LINE) ||
            (xid_element[element].type == POLY) ||
            (xid_element[element].type == RECT))
      gtype = HPOLIN;
   else if (xid_element[element].type == TEXT)
      gtype = ANOT;

   /* Seek to the appropriate location in the GOF.  */
   status = (long)lseek(xid_graphics.fd,xid_element[element].offset,0);
   if (status == -1)
   {
      xid_message("Error seeking in GOF");
      return;
   }

   /* Modifying GOF records consists of marking the original record for
      deletion and writing the modified record to the end of the file.  */

   /* Read the GOF record to be modified.  */
   status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,(struct DDR *)NULL,
                    &gofbuf);
   if ((status != E_SUCC) && (status != E_EOF))
   {
      xid_message("Error reading GOF");
      return;
   }

   /* Mark the record for deletion by setting its label to a predefined
      constant.  */
   if (xid_element[element].type == POINT)
      strcpy(gofbuf.ptrec.label,DELREC);
   else if ((xid_element[element].type == LINE) ||
            (xid_element[element].type == POLY) ||
            (xid_element[element].type == RECT))
      strcpy(gofbuf.plrec.label,DELREC);
   else if (xid_element[element].type == TEXT)
      strcpy(gofbuf.antrec.label,DELREC);

   /* Write the record back to the GOF with the modified label.  */
   status = (long)lseek(xid_graphics.fd,xid_element[element].offset,0);
   if (status == -1)
   {
      xid_message("Error seeking in GOF");
      return;
   }

   status = c_gofwr(&xid_graphics.fd,&next,&gtype,(struct DDR *)NULL,&gofbuf,
                    &addrec);
   if (status != E_SUCC)
   {
      xid_message("Error writing record to GOF");
      return;
   }

   /* If the record is not being removed, write the modified record to the
      GOF.  */
   if (!(xid_editgraph.flags & GR_REMOVE))
   {
      status = graphics_gofwrite(w, client, call);
      if (status != XID_S)
         return;
   }

   /* Reset appropriate flags.  */
   if (xid_graphics.flags & GR_EDIT)
   {
      xid_editgraph.writeflg = TRUE;
      xid_editgraph.flags ^= GR_MODIFY;
      xid_editgraph.flags &= ~GR_REMOVE;
   }
   return;
}

void graphics_editwarn
(
   long flag,                  /* Flag indicating whether to create or
                                  destroy the warning panel.  (I)
                                       0 - Create the panel.
                                       1 - Destroy the panel.                */
   char *client_data           /* Client data to be passed to the okCallback
                                  and the cancelCallback.  (I)
                                       "E" - Continue with edit_destroy.
                                       "G" - Continue with graphics_destroy. 
                                       "N" - Do nothing in addition to 
                                             creating panel.                 */
)

/******************************************************************************
Purpose:
   This routine creates a panel that warns the user that the current 
   modifications have not been saved to the GOF.  The user may then 
   choose to cancel current modifications or apply them.
 
By L. Huewe, USGS/EROS Data Center, 1/93
 
Algorithm Description:
******************************************************************************/
{
   static Widget   graphics_edit_message; /* Widget ID of warning message box*/
   Arg             args[15];              /* Widget resource values.         */
   Cardinal        argcnt;                /* # of resource values to be set. */
   XmString        xmstr[2];              /* Motif format strings.           */

   /* Create a warning dialog informing the user changes have not been saved
      to the GOF.  */
   if (flag == 0)
   {
      argcnt = 0;
      XtSetArg(args[argcnt], XmNdialogStyle, XmDIALOG_FULL_APPLICATION_MODAL);
         argcnt++;
      XtSetArg(args[argcnt], XmNmessageString, (xmstr[0]=XmStringCreateLtoR(
               "Current modifications have not been saved.  Select\n\
               \"Apply\" to save changes and continue or select\n\
               \"Cancel\" to continue without saving changes.",
               XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNokLabelString, (xmstr[1]=XmStringCreateLtoR(
               "Apply", XmSTRING_DEFAULT_CHARSET))); argcnt++;
      XtSetArg(args[argcnt], XmNx, 0); argcnt++;
      XtSetArg(args[argcnt], XmNy, 0); argcnt++;
      XtSetArg(args[argcnt], XmNwidth, 499); argcnt++;
      XtSetArg(args[argcnt], XmNheight, 136); argcnt++;
      XtSetArg(args[argcnt],XtNvisual,xid.visual_info[0].visual); argcnt++;
      XtSetArg(args[argcnt],XtNcolormap,xid.colormap); argcnt++;
      graphics_edit_message = XmCreateWarningDialog(Shell_Graphics,
                                                    "graphics_edit_message",
                                                    args,argcnt);
      XmStringFree( xmstr[0] );
      XmStringFree( xmstr[1] );

      XtAddCallback(graphics_edit_message, XmNcancelCallback,
                    graphics_changes_cancel, (caddr_t)client_data);
      XtAddCallback(graphics_edit_message, XmNokCallback,
                    graphics_changes_apply, (caddr_t)client_data);

      XtManageChild(graphics_edit_message);
   }

   /* Destroy the warning dialog.  */
   else
   {
      XtUnmanageChild(graphics_edit_message);
      XtDestroyWidget(graphics_edit_message);
   }
}

/* ARGSUSED */
void graphics_changes_cancel
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine is called when the user indicates that modifications
   to the current graphics element are not to be saved.
                                                                
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
******************************************************************************/
{
   long  plane_idx;                 /* Index into memory plane structure of
                                       the currently viewed image.           */

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Set the write flag to TRUE, so the user may continue.  The record has not
      really been written to the GOF.  This in effect "cancels" the current
      modifications.  */
   xid_editgraph.writeflg = TRUE;
   xid_editgraph.flags ^= GR_MODIFY;

   /* Erase the current element.  Note that the first parameter to each
      "delete" routine is set to zero.  This parameter represents the window
      which generated the event.  Since this event was generated from a message
      panel, we are not concerned with it.  */
   if (!(xid_editgraph.flags & GR_REMOVE))
   {
      if (xid_element[xid_editgraph.current].type == POINT)
      {
         graphics_deletepoint(0,xid_editgraph.current,plane_idx);
         graphics_deletestring(plane_idx,xid_editgraph.current);
      }
      else if (xid_element[xid_editgraph.current].type == TEXT)
         graphics_deletestring(plane_idx,xid_editgraph.current);
      else
      {
         graphics_deletelinepoly(0,xid_editgraph.current,plane_idx);
         graphics_deletestring(plane_idx,xid_editgraph.current);
      }
   }

   /* If the latest modification was to delete the element, reset the current
      graphics element index to the index of the deleted element.  */
   else
   {
      xid_editgraph.current = xid_editgraph.delete_idx;
      xid_editgraph.delete_idx = -1;
      xid_editgraph.flags ^= GR_REMOVE;
   }

   /* Restore the original graphics element.  */
   graphics_copy_element(&xid_editorig,&xid_element[xid_editgraph.current]);

   /* Redraw the element.  */
   graphics_draw(-1,plane_idx,xid_editgraph.current);

   /* Force an expose event which copies the graphics pixmaps to the image.  */
   graphics_expose_area(-1,xid_editgraph.current,plane_idx);

   /* Close the graphics edit panel.  */
   if (*((char *)client) == 'E')
      edit_destroy(w,client,call);

   /* Close the graphics panel.  */
   else if (*((char *)client) == 'G')
      graphics_destroy(w,client,call);

   /* Erase the graphics edit handles.  */
   else if (*((char *)client) == 'N')
      graphics_erase_handles();
}

/* ARGSUSED */
void graphics_changes_apply
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine is called when the user indicates that modifications
   to the current graphics element are to be saved.
                                                                
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
******************************************************************************/
{
   /* Update the GOF with the current modifications.  */
   graphics_updategof(w,client,call);

   /* Close the graphics edit panel.  */
   if (*((char *)client) == 'E')
      edit_destroy(w,client,call);

   /* Close the graphics panel.  */
   else if (*((char *)client) == 'G')
      graphics_destroy(w,client,call);

   /* Erase the graphics edit handles.  */
   else if (*((char *)client) == 'N')
      graphics_erase_handles();
}

void graphics_erase_handles
(void)

/******************************************************************************
Purpose:
   Erase the graphics edit handles from the currently selected graphics
   element.
 
By L. Huewe, USGS/EROS Data Center, 1/93
 
Algorithm Description:
******************************************************************************/
{
   long    index;                   /* Graphics element index.               */
   long    plane_idx;               /* Index into memory plane structure of
                                       currently viewed image.               */

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* The edit index (xid_editgraph.current) must be reset to -1 temporarily
      otherwise the expose event handler will redraw the graphics handles.  */
   index = xid_editgraph.current;
   xid_editgraph.current = -1;

   /* Force an expose event over the area of the graphics element.  This erases
      the graphics edit handles and since the xid_editgraph.current has been
      set to -1, they are not redrawn.  */
   graphics_expose_area(0,index,plane_idx);

   /* Erase graphics edit handles in full resolution window.  */
   if (xid_fullres != NULL)
      graphics_expose_area(1,index,plane_idx);

   /* Erase graphics edit handles in zoom window.  */
   if (xid_zoom.flags & ZOOM_ACTIVE)
      graphics_expose_area(2,index,plane_idx);
}
void graphics_removevert
(
   long element,
   long vert
)

/******************************************************************************
Purpose:
   Removes a vertex from the graphics element structure of a line or
   polygon.
 
By L. Huewe, USGS/EROS Data Center, 1/93
 
Algorithm Description:
******************************************************************************/
{
   struct LINE_ELEMENT    *lptr;  /* Pointer to line specific information.   */
   struct POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.*/
   float           *tmp_ptr;      /* Temporary pointer to polygon or line 
                                     vertices.                               */
   long            i,j;           /* Looping indices.                        */

   /* Remove the specified vertex from a line.  */
   if (xid_element[element].type == LINE)
   {
      /* Set the line pointer and allocate temporary space for the new array of
         X vertices which does not include the deleted vertex.  */
      lptr = (struct LINE_ELEMENT *)xid_element[element].graph_ptr;
      tmp_ptr = (float *)calloc(lptr->num_vert-1,sizeof(float));
      if (tmp_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return;
      }

      /* Copy all vertices except the one which has been deleted.  */
      for (i=0, j=(-1); i < lptr->num_vert; i++)
      {
         if (i == vert)
            continue;
         else
            j++;
         tmp_ptr[j] = lptr->x[i];
      }

      /* Free the old array of X vertices and reset the pointer in the line
         structure to point to the new array.  */
      free(lptr->x);
      lptr->x = tmp_ptr;

      /* Allocate temporary space for the new array of Y vertices which does
         not include the deleted vertex.  */
      tmp_ptr = (float *)calloc(lptr->num_vert-1,sizeof(float));
      if (tmp_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return;
      }

      /* Copy all vertices except the one which has been deleted.  */
      for (i=0, j = -1; i < lptr->num_vert; i++)
      {
         if (i == vert)
            continue;
         else
            j++;
         tmp_ptr[j] = lptr->y[i];
      }

      /* Free the old array of Y vertices and reset the pointer in the line
         structure to point to the new array.  */
      free(lptr->y);
      lptr->y = tmp_ptr;

      /* Reset the number of vertices.  */
      lptr->num_vert--;
   }
   else if ((xid_element[element].type == POLY) ||
            (xid_element[element].type == RECT))
   {
      /* Set the polygon pointer and allocate temporary space for the new array
         of X vertices which does not include the deleted vertex.  */
      pptr = (struct POLY_ELEMENT *)xid_element[element].graph_ptr;
      tmp_ptr = (float *)calloc(pptr->num_vert-1,sizeof(float));
      if (tmp_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return;
      }

      /* Copy all vertices except the one which has been deleted.  */
      for (i=0, j = -1; i < pptr->num_vert; i++)
      {
         if (i == vert)
            continue;
         else
            j++;
         tmp_ptr[j] = pptr->x[i];
      }

      /* Free the old array of X vertices and reset the pointer in the polygon
         structure to point to the new array.  */
      free(pptr->x);
      pptr->x = tmp_ptr;

      /* Allocate temporary space for the new array of Y vertices which does
         not include the deleted vertex.  */
      tmp_ptr = (float *)calloc(pptr->num_vert-1,sizeof(float));
      if (tmp_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return;
      }

      /* Copy all vertices except the one which has been deleted.  */
      for (i=0, j = -1; i < pptr->num_vert; i++)
      {
         if (i == vert)
            continue;
         else
            j++;
         tmp_ptr[j] = pptr->y[i];
      }

      /* Free the old array of Y vertices and reset the pointer in the polygon
         structure to point to the new array.  */
      free(pptr->y);
      pptr->y = tmp_ptr;

      /* Reset the number of vertices.  */
      pptr->num_vert--;
   }
}

long graphics_copy_element
(
   struct GRAPH *src,   /* Source graphics strucutre. (I)             */
   struct GRAPH *dst    /* Destination graphics structure. (I)        */
)

/******************************************************************************
Purpose:
   This routine copies all information defined by structure type GRAPH
   from the source address to the destination address.  All dynamic 
   allocation for elements such as arrays of vertices are
   done within this routine.
 
By L. Huewe, USGS/EROS Data Center, 1/93
 
Algorithm Description:
******************************************************************************/
{
   struct ANNOT_ELEMENT   *dst_aptr;    /* Ptr to annotation specific info.  */
   struct ANNOT_ELEMENT   *src_aptr;    /* Ptr to annotation specific info.  */
   struct LINE_ELEMENT    *dst_lptr;    /* Ptr to line specific info.        */
   struct LINE_ELEMENT    *src_lptr;    /* Ptr to line specific info.        */
   struct POLY_ELEMENT    *dst_pptr;    /* Ptr to polygon specific info.     */
   struct POLY_ELEMENT    *src_pptr;    /* Ptr to polygon specific info.     */

   /* Determine the graphics element type of the source.  */
   if (src->type == LINE)
   {
      if (dst->graph_ptr != NULL)
      {
         /* Free any previously allocated space.  */
         dst_lptr = (struct LINE_ELEMENT *)dst->graph_ptr;
         if (dst_lptr->x != NULL)
            free(dst_lptr->x);
         if (dst_lptr->y != NULL)
            free(dst_lptr->y);
         free(dst->graph_ptr);
         dst->graph_ptr = NULL;
      }

      /* Copy general info from the source address to the destination.  */
#ifndef sun
      bcopy(src,dst,sizeof(struct GRAPH));
#else
      memcpy(src,dst,sizeof(struct GRAPH));
#endif

      /* Allocate space for line specific information.  */
      dst->graph_ptr = (long *)calloc(1,sizeof(struct LINE_ELEMENT));
      if (dst->graph_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Set source and destination line pointers.  */
      src_lptr = (struct LINE_ELEMENT *)src->graph_ptr;
      dst_lptr = (struct LINE_ELEMENT *)dst->graph_ptr;

      /* Copy number of vertices and line width.  */
      dst_lptr->num_vert = src_lptr->num_vert;
      dst_lptr->line_width = src_lptr->line_width;

      /* Allocate space for X coordinates of the line vertices.  */
      dst_lptr->x = (float *)calloc(src_lptr->num_vert,sizeof(float));
      if (dst_lptr->x == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Copy X coordinates of line vertices from the source to the
         destination.  */
#ifndef sun
      bcopy(src_lptr->x,dst_lptr->x,(src_lptr->num_vert*sizeof(float)));
#else
      memcpy(src_lptr->x,dst_lptr->x,(src_lptr->num_vert*sizeof(float)));
#endif
      /* Allocate space for Y coordinates of the line vertices.  */
      dst_lptr->y = (float *)calloc(src_lptr->num_vert,sizeof(float));
      if (dst_lptr->y == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Copy Y coordinates of line vertices from the source to the
         destination.  */
#ifndef sun
      bcopy(src_lptr->y,dst_lptr->y,(src_lptr->num_vert*sizeof(float)));
#else
      memcpy(src_lptr->y,dst_lptr->y,(src_lptr->num_vert*sizeof(float)));
#endif
   }
   else if ((src->type == POLY) || (src->type == RECT))
   {
      if (dst->graph_ptr != NULL)
      {
         /* Free any previously allocated space.  */
         dst_pptr = (struct POLY_ELEMENT *)dst->graph_ptr;
         if (dst_pptr->x != NULL)
            free(dst_pptr->x);
         if (dst_pptr->y != NULL)
            free(dst_pptr->y);
         free(dst->graph_ptr);
         dst->graph_ptr = NULL;
      }

      /* Copy general info from the source address to the destination.  */
#ifndef sun
      bcopy(src,dst,sizeof(struct GRAPH));
#else
      memcpy(src,dst,sizeof(struct GRAPH));
#endif
      /* Allocate space for polygon specific information.  */
      dst->graph_ptr = (long *)calloc(1,sizeof(struct POLY_ELEMENT));
      if (dst->graph_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Set source and destination polygon pointers.  */
      src_pptr = (struct POLY_ELEMENT *)src->graph_ptr;
      dst_pptr = (struct POLY_ELEMENT *)dst->graph_ptr;

      /* Copy number of vertices, line width and fill flag.  */
      dst_pptr->num_vert = src_pptr->num_vert;
      dst_pptr->line_width = src_pptr->line_width;
      dst_pptr->fill = src_pptr->fill;

      /* Allocate space for X coordinates of the polygon vertices.  */
      dst_pptr->x = (float *)calloc(src_pptr->num_vert,sizeof(float));
      if (dst_pptr->x == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Copy X coordinates of polygon vertices from the source to the
         destination.  */
#ifndef sun
      bcopy(src_pptr->x,dst_pptr->x,(src_pptr->num_vert*sizeof(float)));
#else
      memcpy(src_pptr->x,dst_pptr->x,(src_pptr->num_vert*sizeof(float)));
#endif

      /* Allocate space for Y coordinates of the polygon vertices.  */
      dst_pptr->y = (float *)calloc(src_pptr->num_vert,sizeof(float));
      if (dst_pptr->y == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Copy Y coordinates of polygon vertices from the source to the
         destination.  */
#ifndef sun
      bcopy(src_pptr->y,dst_pptr->y,(src_pptr->num_vert*sizeof(float)));
#else
      memcpy(src_pptr->y,dst_pptr->y,(src_pptr->num_vert*sizeof(float)));
#endif
   }
   else if (src->type == TEXT)
   {
      if (dst->graph_ptr != NULL)
      {
         /* Free any previously allocated space.  */
         dst_aptr = (struct ANNOT_ELEMENT *)dst->graph_ptr;
         if (dst_aptr->string != NULL)
            free(dst_aptr->string);
         free(dst->graph_ptr);
         dst->graph_ptr = NULL;
      }

      /* Copy general info from the source address to the destination.  */
#ifndef sun
      bcopy(src,dst,sizeof(struct GRAPH));
#else
      memcpy(src,dst,sizeof(struct GRAPH));
#endif

      /* Allocate space for annotation specific information.  */
      dst->graph_ptr = (long *)calloc(1,sizeof(struct ANNOT_ELEMENT));
      if (dst->graph_ptr == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Set source and destination annotation pointers.  */
      src_aptr = (struct ANNOT_ELEMENT *)src->graph_ptr;
      dst_aptr = (struct ANNOT_ELEMENT *)dst->graph_ptr;

      /* Allocate space for the annotation string.  */
      dst_aptr->string = malloc(strlen(src_aptr->string) + 1);
      if (dst_aptr->string == NULL)
      {
         xid_message("Insufficient amount of memory available");
         return(XID_F);
      }

      /* Copy the annotation string, size and angle.  */
      strcpy(dst_aptr->string,src_aptr->string);
      dst_aptr->size = src_aptr->size;
      dst_aptr->angle = src_aptr->angle;
   }
   else if (src->type == POINT)
   {
      /* Copy general information from the source address to the
         destination.  */
#ifndef sun
      bcopy(src,dst,sizeof(struct GRAPH));
#else
      memcpy(src,dst,sizeof(struct GRAPH));
#endif
   }
   return(XID_S);
}

/* ARGSUSED */
void graphics_undo
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine restores the current graphics element to the state
   it was in before the latest modification.
                                                                
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
******************************************************************************/
{
   Boolean              argok;          /* Status indicator.                 */
   XmString             xmstr[1];       /* Motif format strings.             */
   Widget               gadget_button;  /* Cascade button gadget of option
                                           menu.                             */
   Pixel                pixelval;       /* Pixel value of selected color.    */
   struct ANNOT_ELEMENT *aptr;          /* Ptr to annotation specific info.  */
   struct LINE_ELEMENT  *lptr;          /* Ptr to line specific info.        */
   struct POLY_ELEMENT  *pptr;          /* Ptr to polygon specific info.     */
   long                 plane_idx;      /* Index into memory plane structure
                                           of the currently viewed image.    */
   char                 str[15];        /* Character string.                 */

   /* Changes can't be undone if the record has already been written to the
      GOF.  */
   if (xid_editgraph.writeflg == TRUE)
   {
      xid_message("Record has already been written to the GOF, can't undo"
                  " changes");
      return;
   }

   /* Changes can't be undone if no graphics element is currently selected.  */
   if ((xid_editgraph.current == -1) && (!(xid_editgraph.flags & GR_REMOVE)))
      return;

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Erase the current element.  Note that the first parameter to each
      "delete" routine is set to zero.  This parameter represents the window
      which generated the event.  Since this event was generated from a message
      panel, we are not concerned with it.  */
   if (!(xid_editgraph.flags & GR_REMOVE))
   {
      if (xid_element[xid_editgraph.current].type == POINT)
      {
         graphics_deletepoint(0,xid_editgraph.current,plane_idx);
         graphics_deletestring(plane_idx,xid_editgraph.current);
      }
      else if (xid_element[xid_editgraph.current].type == TEXT)
         graphics_deletestring(plane_idx,xid_editgraph.current);
      else
      {
         graphics_deletelinepoly(0,xid_editgraph.current,plane_idx);
         graphics_deletestring(plane_idx,xid_editgraph.current);
      }
   }
   else
   {
      /* Reset current element index.  */
      xid_editgraph.current = xid_editgraph.delete_idx;
      xid_editgraph.delete_idx = -1;
      xid_editgraph.flags ^= GR_REMOVE;

      /* Make appropriate options sensitive.  */
      XtSetSensitive(graphics_edit_apply,True);
      XtSetSensitive(graphics_defatt_button,True);
      XtSetSensitive(graphics_setatt_button,True);
      XtSetSensitive(graphics_label_button,True);
      XtSetSensitive(graphics_width_option,True);
      XtSetSensitive(graphics_color_option,True);
      XtSetSensitive(graphics_fonts_option,True);
   }

   /* Copy the information from the "undo" structure to the current element. */
   graphics_copy_element(&xid_editundo,&xid_element[xid_editgraph.current]);

   /* Redraw the element.  */
   graphics_draw(-1,plane_idx,xid_editgraph.current);

   /* Force an expose event to copy the graphics pixmaps to the image.  */
   graphics_expose_area(-1,xid_editgraph.current,plane_idx);

   /* Output the label or annotation text to the graphics panel.  */
   if (xid_element[xid_editgraph.current].type != TEXT)
   {
      xmstr[0] = XmStringCreateLtoR(xid_element[xid_editgraph.current].label, 
                                    XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(graphics_label_label,XmNlabelString,xmstr[0],NULL);
      XmStringFree(xmstr[0]);
   }
   else
   {
      aptr = (struct ANNOT_ELEMENT *)xid_element[xid_editgraph.current].
                graph_ptr;
      xmstr[0] = XmStringCreateLtoR(aptr->string, XmSTRING_DEFAULT_CHARSET);
      XtVaSetValues(graphics_label_label,XmNlabelString,xmstr[0],NULL);
      XmStringFree(xmstr[0]);
   }

   /* Set the current font, color and line width.  */
   xid_graphics.font = xid_element[xid_editgraph.current].font;
   gadget_button = XmOptionButtonGadget(graphics_fonts_option);
   sprintf(str,"Font Option %ld",xid_graphics.font+1);
   xmstr[0] = XmStringCreateLtoR(str,XmSTRING_ISO8859_1);
   XtVaSetValues(gadget_button,XmNlabelString,xmstr[0],XmNfontList,
                 CONVERT(Shell_Graphics, xid_graphics.fonts[xid_graphics.font],
                 "FontList", 0, &argok),NULL);
   XmStringFree(xmstr[0]);

   xid_graphics.color = xid_element[xid_editgraph.current].color;
   gadget_button = XmOptionButtonGadget(graphics_color_option);
   xmstr[0] = XmStringCreateLtoR(xid_graphics.colors[xid_graphics.color],
                                 XmSTRING_ISO8859_1);
   XtVaSetValues(gadget_button,XmNlabelString,xmstr[0],NULL);
   XmStringFree(xmstr[0]);

   pixelval = (Pixel)CONVERT(Shell_Graphics,
                             xid_graphics.colors[xid_graphics.color], "Pixel",
                             0, &argok);
   XtVaSetValues(graphics_color_option,XmNforeground,pixelval,NULL);

   if (xid_element[xid_editgraph.current].type == LINE)
   {
      lptr = (struct LINE_ELEMENT *)xid_element[xid_editgraph.current].
                graph_ptr;
      xid_graphics.line_width = lptr->line_width;
   }
   else if ((xid_element[xid_editgraph.current].type == POLY) ||
            (xid_element[xid_editgraph.current].type == RECT))
   {
      pptr = (struct POLY_ELEMENT *)xid_element[xid_editgraph.current].
                graph_ptr;
      xid_graphics.line_width = pptr->line_width;
   }
   else
      xid_graphics.line_width = 0;

   if (xid_graphics.line_width != 0)
   {
      gadget_button = XmOptionButtonGadget(graphics_width_option);
      sprintf(str,"%ld",xid_graphics.line_width);
      xmstr[0] = XmStringCreateLtoR(str,XmSTRING_ISO8859_1);
      XtVaSetValues(gadget_button,XmNlabelString,xmstr[0],NULL);
      XmStringFree(xmstr[0]);
   }
}

void graphics_deleteelement
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine deletes the current graphics element from the display
   screen.
 
By L. Huewe, USGS/EROS Data Center, 1/93
 
Algorithm Description:
******************************************************************************/
{
   long  element;                 /* Graphics element to write to GOF.       */
   long  plane_idx;               /* Index into memory plane structure of the
                                     currently viewed image.                 */
   long  status;                  /* Status indicator.                       */
   long  win=0;                   /* Which window generated the event.  This
                                     is assigned to 0 because this routine is 
                                     called when the user presses a button on
                                     the "graphics edit" panel (i.e., there is
                                     no associated image window).            */

   /* A graphics element must be selected to delete.  */
   if (xid_editgraph.current == -1)
   {
      xid_message("User must select a graphics element to delete");
      return;
   }

   /* The user must finish modifying the current element before it can be
      deleted.  */
   if ((xid_editgraph.newx != -1) && (xid_editgraph.flags & GR_MOVE))
   {
      xid_message("User must place current point before deleting element");
      return;
   }
   if ((xid_editgraph.vert != -1) && (xid_editgraph.flags & GR_ADD))
   {
      xid_message("User must finish adding points before deleting element");
      return;
   }
   if (xid_graphics.flags & GR_LABEL)
   {
      xid_message("User must place label/text before deleting element");
      return;
   }

   /* Assign the graphics element to be deleted.  */
   element = xid_editgraph.current;

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Delete a point and its associated label and make the appropriate context
      active.  */
   if (xid_element[element].type == POINT)
   {
      graphics_deletepoint(win,element,plane_idx);
      if (strcmp(xid_element[element].label,"") != 0)
         graphics_deletestring(plane_idx,element);
      XeContextSetActive((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      XtSetSensitive(graphics_edit_apply,True);
      XtSetSensitive(graphics_edit_undo,True);
   }

   /* Delete a line, rectangle or polygon and its associated label.  */
   else if ((xid_element[element].type == LINE) ||
            (xid_element[element].type == POLY) ||
            (xid_element[element].type == RECT))
   {
      graphics_deletelinepoly(win,element,plane_idx);
      if (strcmp(xid_element[element].label,"") != 0)
         graphics_deletestring(plane_idx,element);
   }

   /* Delete annotation text.  */
   else if (xid_element[element].type == TEXT)
      graphics_deletestring(plane_idx,element);

   /* Make a copy of the graphics element in case the "undo" option is
      selected.  */
   status = graphics_copy_element(&xid_element[xid_editgraph.current],
                                  &xid_editundo);
   if (status != XID_S)
      return;

   /* Save the index of the deleted element in case the "undo" option is
      selected.  */
   xid_editgraph.delete_idx = xid_editgraph.current;

   /* Erase the graphics handles.  */
   graphics_erase_handles();

   /* Set the appropriate flags.  */
   xid_editgraph.flags |= (GR_MODIFY | GR_REMOVE);
   xid_editgraph.writeflg = FALSE;

   /* Make appropriate options insensitive.  */
   XtSetSensitive(graphics_defatt_button,False);
   XtSetSensitive(graphics_setatt_button,False);
   XtSetSensitive(graphics_label_button,False);
   XtSetSensitive(graphics_width_option,False);
   XtSetSensitive(graphics_color_option,False);
   XtSetSensitive(graphics_fonts_option,False);

   return;
}

void graphics_editadd
(
   Widget w,
   XtPointer client,
   XtPointer call
)

/******************************************************************************
Purpose:
   This routine performs the appropriate action based on the mouse button
   selected when the user is adding points to an existing graphics
   element.  The user may choose to cancel the current modification,
   select a new point, delete the last point selected or end the addition
   of points.
                                                                
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
******************************************************************************/
{
   XButtonEvent    *event;     /* X Event structure.                         */
   struct PT_LIST  *tmp;       /* Temporary pointer to point structure.      */
   float           xfil,       /* X file coordinate.                         */
                   xmax,       /* Maximum X value.                           */
                   xmin,       /* Minimum X value.                           */
                   yfil,       /* Y file coordinate.                         */
                   ymax,       /* Maximum Y value.                           */
                   ymin;       /* Minimum Y value.                           */
   int             xtmp,ytmp;  /* Temporary X and Y window coordinates.      */
   int             i,          /* Looping index.                             */
                   plane_idx,  /* Index into memory plane structure of the
                                  currently viewed image.                    */
                   status,     /* Status indicator.                          */
                   win = 0,    /* Window from which coordinates are to be
                                  calculated.                                */
                   x1win,      /* X window coordinate.                       */
                   y1win,      /* Y window coordinate.                       */
                   x2win,      /* X window coordinate.                       */
                   y2win;      /* Y window coordinate.                       */

   event = (XButtonEvent *)call;

   /* Find the memory plane index of the first band of the displayed image.  */
   plane_idx = xid_view.rgbplanes[RED] - 1;

   /* Determine which window generated the event.  */
   if (w == main_image_bulletinboard)
      win = 0;
   else if (w == fullres_win_bulletinboard)
      win = 1;
   else if (w == zoom_win_bulletinboard)
      win = 2;

   /* Cancel current modifications.  */
   if (client == (XtPointer)4)
   {
      /* Delete any currently selected line segments.  */
      if (xid_graphics.temp_num > 0)
      {
         graphics_deletelinerect(w,win,plane_idx,xid_editgraph.xfil,
                                 xid_editgraph.yfil,xid_graphics.first->x,
                                 xid_graphics.first->y,FALSE);
      }

      /* Assign the bounding rectangle taking into account the newly selected
         vertices.  */
      xmin = xid_element[xid_editgraph.current].upleft[0];
      ymin = xid_element[xid_editgraph.current].upleft[1];
      xmax = xid_element[xid_editgraph.current].loright[0];
      ymax = xid_element[xid_editgraph.current].loright[1];

      if (xid_graphics.first->x < xmin) 
         xmin = xid_graphics.first->x;
      if (xid_graphics.first->y < ymin) 
         ymin = xid_graphics.first->y;
      if (xid_graphics.first->x > xmax) 
         xmax = xid_graphics.first->x;
      if (xid_graphics.first->y > ymax) 
         ymax = xid_graphics.first->y;

      for (i=1, xid_graphics.cur=xid_graphics.first; i < xid_graphics.temp_num; 
           i++)
      {
         xfil = xid_graphics.cur->x;
         yfil = xid_graphics.cur->y;

         if (xfil < xmin) 
            xmin = xfil; 
         if (yfil < ymin) 
            ymin = yfil; 
         if (xfil > xmax) 
            xmax = xfil; 
         if (yfil > ymax) 
            ymax = yfil; 

         tmp = xid_graphics.cur;
         xid_graphics.cur = tmp->next;
         graphics_deletelinerect(w,win,plane_idx,xfil,yfil,
                                 xid_graphics.cur->x,xid_graphics.cur->y,
                                 FALSE);
      }

      /* Force an expose event over the affected area (taking into account the
         newly selected points which are being erased).  */
      xid_file2win(plane_idx,win,xmin,ymin,&x1win,&y1win);
      xid_file2win(plane_idx,win,xmax,ymax,&x2win,&y2win);
      XClearArea(xid.display,XtWindow(w),x1win-HANDLE,y1win-HANDLE,
                 (x2win+HANDLE)-(x1win-HANDLE)+1,
                 (y2win+HANDLE)-(y1win-HANDLE)+1,True);

      /* Draw the original element (without newly selected vertices).  */
      graphics_draw(-1,plane_idx,xid_editgraph.current);

      /* Force an expose event over the affected area so that the graphics
         pixmaps are copied to the image.  */
      graphics_expose_area(-1,xid_editgraph.current,plane_idx);

      /* Reset appropriate variables.  */
      xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx = 
         xid_editgraph.nexty = xid_editgraph.newx = xid_editgraph.newy = 
         xid_editgraph.vert = xid_label.x = xid_label.y = -1;

      /* Free the temporary point structures.  */
      if (xid_graphics.temp_num >0)
      {
         while (xid_graphics.cur->prev != NULL)
         {
            tmp = xid_graphics.cur->prev;
            free(xid_graphics.cur);
            xid_graphics.cur = tmp;
         }
         free(xid_graphics.cur);
         xid_graphics.temp_num = 0;
         xid_graphics.first = (struct PT_LIST *)NULL;
      }

      /* Make sure the appropriate context is sensitive and active.  */
      XeContextSensitize((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      XeContextSetActive((XeContextWidget)context_mouse,
                         context_names[CON_GREDIT]);
      if ((XeContextCheckList((XeContextWidget)context_mouse, 
                              context_names[CON_GRMVDEL])))
      {
         XeContextDesensitize((XeContextWidget)context_mouse,
                               context_names[CON_GRMVDEL]);
      }
      if ((XeContextCheckList((XeContextWidget)context_mouse, 
                              context_names[CON_GRADD])))
      {
         XeContextDesensitize((XeContextWidget)context_mouse,
                              context_names[CON_GRADD]);
      }
      XtSetSensitive(graphics_edit_undo,True);
      XtSetSensitive(graphics_edit_apply,True);
      return;
    }

   switch (event->button)
   {
      case 1:

         /* Allocate a structure element for the new point and set the
            appropriate pointers to the next and previous points.  */
         if (xid_graphics.first == NULL)
         {
            xid_graphics.first = xid_graphics.cur = (struct PT_LIST *)calloc(1,
                                                       sizeof(struct PT_LIST));
            if (xid_graphics.first == NULL)
            {
               xid_message("Insufficient amount of memory available");
               return;
            }
            xid_graphics.first->prev = (struct PT_LIST *)NULL;
            xid_graphics.first->next = (struct PT_LIST *)NULL;
         }
         else
         {
            tmp = (struct PT_LIST *)calloc(1,sizeof(struct PT_LIST));
            if (tmp == NULL)
            {
               xid_message("Insufficient amount of memory available");
               return;
            }
            tmp->prev = xid_graphics.cur;
            tmp->next = (struct PT_LIST *)NULL;
            xid_graphics.cur->next = tmp;
            xid_graphics.cur = tmp;
         }

         /* Convert the window coordinate to an actual file coordinate based on
            the image currently displayed.  */
         xid_win2file(plane_idx,win,event->x,event->y,&xfil,&yfil);
         xid_graphics.cur->x = xfil;
         xid_graphics.cur->y = yfil;
         xid_graphics.temp_num++;

         /* Convert the file coordinate back to a window coordinate.  This is
            done because in the zoom window, several window coordinates map to
            the same file coordinate.  By converting back to a window
            coordinate and drawing the line using that coordinate, it can be
            assured that the same line can be recreated.  */
         xid_file2win(plane_idx,win,xfil,yfil,&xtmp,&ytmp);

         /* Draw the new line segement.  */
         status = graphics_drawlinerect(w,win,xtmp,ytmp,plane_idx,xfil,yfil);
         if (status != XID_S)
            return;

         /* Set the currently selected point (in window coordinates).  */
         xid_graphics.selectx = xid_editgraph.prevx = xtmp;
         xid_graphics.selecty = xid_editgraph.prevy = ytmp;
         xid_editgraph.fxprev = xfil;
         xid_editgraph.fyprev = yfil;
         break;
      case 2:

         /* Return if there are no points selected.  */
         if (xid_graphics.temp_num == 0)
            return;

         /* Erase the line segment.  */
         if (xid_graphics.temp_num > 1)
         {
            tmp = xid_graphics.cur->prev;
            graphics_deletelinerect(w,win,plane_idx,tmp->x,tmp->y,
                                    xid_graphics.cur->x,xid_graphics.cur->y,
                                    TRUE);
         }
         else
         {
            graphics_deletelinerect(w,win,plane_idx,xid_graphics.cur->x,
                                    xid_graphics.cur->y,xid_editgraph.xfil,
                                    xid_editgraph.yfil,TRUE);
         }

         /* Reduce the number of points selected and reset the previous point
            values.  */
         xid_graphics.temp_num--;
         xid_editgraph.newx = xid_editgraph.newy = -1;
         if (xid_graphics.temp_num > 0)
         {
            xid_file2win(plane_idx,win,xid_graphics.cur->x,xid_graphics.cur->y,
                         &xtmp,&ytmp);
            xid_graphics.selectx = xid_editgraph.prevx = xtmp;
            xid_graphics.selecty = xid_editgraph.prevy = ytmp;
            xid_editgraph.fxprev = xid_graphics.cur->x; 
            xid_editgraph.fyprev = xid_graphics.cur->y;
         }
         else
         {
            xid_file2win(plane_idx,win,xid_editgraph.xfil,xid_editgraph.yfil,
                         &xtmp,&ytmp);
            xid_graphics.selectx = xid_editgraph.prevx = xtmp;
            xid_graphics.selecty = xid_editgraph.prevy = ytmp;
            xid_editgraph.fxprev = xid_editgraph.xfil; 
            xid_editgraph.fyprev = xid_editgraph.yfil; 
         }
         break;

      case 3:
         if (xid_graphics.temp_num != 0)
         {
            /* Make a copy of the current graphics element for the "undo"
               function.  */
            status = graphics_copy_element(&xid_element[xid_editgraph.current],
                                           &xid_editundo);
            if (status != XID_S)
               return;

            /* Close the graphics element.  This routine connects the newly
               selected points with the current points.  */
            graphics_editclose(w,win,plane_idx);

            /* Add the newly selected points to the graphics element
               structure.  */
            graphics_change(win,plane_idx);

            /* Redraw the graphics handles so that the newly selected vertices
               have handles over them.  */
            graphics_handles(xid_editgraph.current,-1,NULL,0);

            /* Make the appropriate options sensitive.  */
            XtSetSensitive(graphics_edit_undo,True);
            XtSetSensitive(graphics_edit_apply,True);
         }
         else
         {
            if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
            {
               /* Erase the rubber-band lines.  */
               XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,
                                  CapButt,JoinMiter);
               XSetForeground(xid.display,xid_graphics.gc,
                              xid_graphics.rb_fore);
               XSetFunction(xid.display,xid_graphics.gc,GXxor);
               if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
                   (xid_editgraph.vert != -1))
               {
                  XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
                            xid_editgraph.prevx,xid_editgraph.prevy,
                            xid_editgraph.newx,xid_editgraph.newy);
               }
               if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) &&
                   (xid_editgraph.vert != -1))
               {
                  XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
                            xid_editgraph.nextx,xid_editgraph.nexty,
                            xid_editgraph.newx,xid_editgraph.newy);
               }
            }

            /* Make the appropriate context sensitive and active.  */
            XeContextSensitize((XeContextWidget)context_mouse,
                               context_names[CON_GREDIT]);
            XeContextSetActive((XeContextWidget)context_mouse,
                               context_names[CON_GREDIT]);
            if ((XeContextCheckList((XeContextWidget)context_mouse, 
                                    context_names[CON_GRMVDEL])))
            {
               XeContextDesensitize((XeContextWidget)context_mouse,
                                    context_names[CON_GRMVDEL]);
            }
            if ((XeContextCheckList((XeContextWidget)context_mouse, 
                                    context_names[CON_GRADD])))
            {
               XeContextDesensitize((XeContextWidget)context_mouse,
                                     context_names[CON_GRADD]);
            }

            /* Redraw the element.  */
            graphics_draw(-1,plane_idx,xid_editgraph.current);

            /* Force an expose event to copy the graphics pixmaps to the
               image.  */
            graphics_expose_area(-1,xid_editgraph.current,plane_idx);
         }

         /* Rest appropriate variables.  */
         xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx = 
            xid_editgraph.nexty = xid_editgraph.newx = xid_editgraph.newy = 
            xid_editgraph.vert = -1;
         break;
   }
}
