/*
 *   ContextI.h
 */

/*
 *  Private implementation file for Context.c
 */
 
#ifndef _XeContextI_h
#define _XeContextI_h
 
/*
 * Copyright (c) 1992 U.S. Geological Survey (USGS)
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of USGS not be used in advertising or
 * publicity pertaining to distribution of the software without specific,
 * written prior permission.  USGS makes no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * USGS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL USGS
 * BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */
 
/*
 *  Change log:
 *
 *      D. Akkerman, USGS/EROS Data Center, 7/92
 *       - inception.
 *
 */

/* Mouse button pixmaps.  */

#define pix_format          1
#define pix_width           50
#define pix_height          50
#define pix_ncolors         2
#define pix_chars_per_pixel 1
static char * pix_colors[] = {
" " , "#AFAFAFAFAFAF",
"." , "#000000000000"
} ;

/* Mouse button1 pixmap.  */

static char *pix1_pixels[] = {
"                                                  ",
"                                                  ",
"                                                  ",
"                                                  ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                                                  ",
"                       ..                         ",
"                      .                           ",
"                     .                            ",
"                     .                            ",
"                    .                             ",
"                     .                            ",
"                      .                           ",
"                       .                          ",
"                                                  ",
"                                                  ",
"                   ...........                    ",
"                 ..           ..                  ",
"                .               .                 ",
"               .                 .                ",
"               .  .     .     .  .                ",
"              .  ...   . .   . .  .               ",
"              .  ...   . .   . .  .               ",
"              .  ...   . .   . .  .               ",
"              .  ...   . .   . .  .               ",
"              .  ...   . .   . .  .               ",
"              .  ...   . .   . .  .               ",
"              .   .     .     .   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"               .                 .                ",
"               .                 .                ",
"                .               .                 ",
"                 ..           ..                  ",
"                   ...........                    ",
"                                                  ",
"                                                  ",
"                                                  ",
"                                                  ",
} ;

/* Mouse button2 pixmap.  */

static char *pix2_pixels[] = {
"                                                  ",
"                                                  ",
"                                                  ",
"                                                  ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                                                  ",
"                       ..                         ",
"                      .                           ",
"                     .                            ",
"                     .                            ",
"                    .                             ",
"                     .                            ",
"                      .                           ",
"                       .                          ",
"                                                  ",
"                                                  ",
"                   ...........                    ",
"                 ..           ..                  ",
"                .               .                 ",
"               .                 .                ",
"               .  .     .     .  .                ",
"              .  . .   ...   . .  .               ",
"              .  . .   ...   . .  .               ",
"              .  . .   ...   . .  .               ",
"              .  . .   ...   . .  .               ",
"              .  . .   ...   . .  .               ",
"              .  . .   ...   . .  .               ",
"              .   .     .     .   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"               .                 .                ",
"               .                 .                ",
"                .               .                 ",
"                 ..           ..                  ",
"                   ...........                    ",
"                                                  ",
"                                                  ",
"                                                  ",
"                                                  ",
} ;

/* Mouse button3 pixmap.  */

static char *pix3_pixels[] = {
"                                                  ",
"                                                  ",
"                                                  ",
"                                                  ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                         .                        ",
"                                                  ",
"                       ..                         ",
"                      .                           ",
"                     .                            ",
"                     .                            ",
"                    .                             ",
"                     .                            ",
"                      .                           ",
"                       .                          ",
"                                                  ",
"                                                  ",
"                   ...........                    ",
"                 ..           ..                  ",
"                .               .                 ",
"               .                 .                ",
"               .  .     .     .  .                ",
"              .  . .   . .   ...  .               ",
"              .  . .   . .   ...  .               ",
"              .  . .   . .   ...  .               ",
"              .  . .   . .   ...  .               ",
"              .  . .   . .   ...  .               ",
"              .  . .   . .   ...  .               ",
"              .   .     .     .   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"              .                   .               ",
"               .                 .                ",
"               .                 .                ",
"                .               .                 ",
"                 ..           ..                  ",
"                   ...........                    ",
"                                                  ",
"                                                  ",
"                                                  ",
"                                                  ",
} ;

static char **pix_pix[] =
{
   pix1_pixels,
   pix2_pixels,
   pix3_pixels
};

#endif  /* _XeContextI_h */



