#include "zip.h"
#include "pixman.h"

void applylut
(
    short lut[],          /* I: look up table */
    long type,            /* I: indicates data type of image  */
    long sp,              /* I: starting pixel in the image line in site */
    long np,              /* I: number of pixels in each image line in site */
    long ibands           /* I: total no. of bands */
)
/*
-------------------------------------------------------------------------
NAME: APPLYLUT

PROGRAM HISTORY:
      Version              date              Author
      -------              ----              ------
         3                jul -88           B. Allam
         2                feb -87           R. Mckinney
         1                june-84           J. Bay
         3.1              Apr-89            D. Hollaren

FUNCTION:      Applies a look up table to the pixels inside
               the polygonal sites.

------------------------------------------------------------------------
*/

{
long	n, i,                      /* counter variables */
        itemp;                     /* temporary hold value */
long    fromtype,                  /* type of array to be converted */
        totyp;                     /* type to which array is converted */

/*
     loop thru multiple input images
     -------------------------------
*/
for (n=0; n < ibands; n++)
   {

   fromtype = EREAL;
   totyp = EWORD;
   c_pxconv(&fromtype, &totyp, (unsigned char *)&iobuf[ipoint[n]+sp-1], 
		(unsigned char *)temp1,&np);
   if (type == 1) 
      c_pxlkup((long *)temp1, (long *)temp2, &np, &totyp, (long *)lut, &type);
   else
      {
      for (i=0; i < np; i++)
         {
         itemp=temp1[i];
         temp2[i]=lut[itemp];
         }  /* do */
      }  /* if */
   c_pxconv(&totyp, &fromtype, (unsigned char *)temp2, 
		(unsigned char *)&iobuf[opoint[n]+sp-1], &np);

   }  /* do */

}
