#include "zip.h"

void classtat
(
    long ibands,                /* I: total no. of bands */
    double smean[],             /* I: site mean */
    long npts,                  /* I: no. of points in site */
    double cmean[],             /* I/O: class mean */
    long *cpts                  /* I: current # of points for class */
)
/*
------------------------------------------------------------------
NAME: CLASSTAT

PROGRAM HISTORY:
      Version           date           Author
      -------           ----           ------
         3             july-88        B. Allam
         2             feb -87        R. Mckinney
         1             june-84        Y. Sheu

FUNCTION:    Calculate statistics for requested classes from site
             statistics.

--------------------------------------------------------------------
*/
{
long	pcpts,             /* last # of points for class */
        ib;                /* counter variable */

/*
 update class mean with site mean
---------------------------------
*/
pcpts = *cpts;
*cpts = *cpts +npts;
if (*cpts  !=  0) 
   {
   for (ib = 0; ib < ibands; ib++)
      {
      cmean[ib] = cmean[ib] * ((float)pcpts / (float)*cpts)
                  + npts * smean[ib] / *cpts;
      }  /* do */
   }  /* if */

}
