#include "zip.h"

void dostats
(
    unsigned char *mask,          /* I/O: indicates which pixels ar inside */
    long np,                      /* I: no. of pixels in line for a site */
    long iband,                   /* I: no. of bands of data */
    double smean[MAXBND],         /* O: current mean */
    double sum[MAXBND],           /* O: current sum of pixel values */
    long *k,                      /* O: current no. of points */
    float *buf[]                  /* I: buffer containing pixels */
)

/*
-----------------------------------------------------------------
NAME: DOSTATS

PROGRAM HISTORY:
      Version          date           Author
      -------          ----           ------
         3            july-88         B. Allam
         2            feb -87         R. Mckinney
         1            june-84         Y. Sheu

FUNCTION:    updates values for means and number points as a site is
             accessed.

------------------------------------------------------------------------
*/
{

long	i, nb;               /* counter variables */
long    zero = 0;
float	val;                 /* value of pixel */


for (i = 0; i < np; i++)
   {
   if (mask[i]  !=  zero) 
     {
     *k = *k + 1;

/*
 update mean  for each band
---------------------------
*/
     if (*k  >  0) 
      {
      for (nb=0; nb < iband; nb++)
         {
         val = buf[nb][i];
         sum[nb] = sum[nb] + val;
         smean[nb] = sum[nb] / *k;
         }  /* do */
      }  /* if */
     } /* if */
   }

}
