#include "zip.h"

void dyn_alloc
(
    long totbnd,          	/* I: total no. of bands */
    long maxcls,          	/* I: total no. of classes */
    double *cmean[MAXCLS],  	/* O: class means */
    long *isno[MAXCLS],   	/* O: site indices */
    short **lut,		/* O: look up table for mapping */
    float **minp,
    float **maxp,     		/* O: min and max pixel values */
    float **pairmin,            /* O: scaling ratios for pixels */
    long window[][4]		/* I: window parameters */
)


/*
*********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for large matrices 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         08/17/88  K. A. Narayanan
  2.0         08/31/88  B. Allam
  3.0         02/05/91  D. Etrheim            (EDC) Allocate ipoint dynamicly


*********************************************************************
*/
{
long	buf_size, c_size, /* size of matrices       */
        i, n, m;

/*
allocate storage for covariance matrices 
-----------------------------------------
*/
buf_size = (long)(maxcls * maxcls * sizeof(long));
c_size = (long)(maxcls * totbnd * sizeof (double));

if ((cmean_matrix = (double *) malloc( c_size)) == NULL ||
    (isno_matrix = (long *) malloc( buf_size)) == NULL) {
    zip_err ("!Error allocating dynamic memory", "zip-alloc");
   }
/*
set up pointers for covariance matrices 
----------------------------------------
*/
for (i = 0, n = 0, m = 0; i < maxcls; i++, n += maxcls, m += totbnd)
   {
   cmean[i] = &cmean_matrix[m];
   isno[i] = &isno_matrix[n];
   }

/* Allocate space */
ipoint = (long *) malloc((MAXIMG * MAXBND + 1) * sizeof(long));
if (ipoint == NULL)
   zip_err ("!Error allocating storage", "zip-alloc");

*lut = (short *) malloc(4000 * sizeof(short));
if (*lut == NULL)
   zip_err ("!Error allocating storage", "zip-alloc");

*minp = (float *) malloc(MAXBND * sizeof(float));
if (*minp == NULL)
   zip_err ("!Error allocating storage", "zip-alloc");
*maxp = (float *) malloc(MAXBND * sizeof(float));
if (*maxp == NULL)
   zip_err ("!Error allocating storage", "zip-alloc");
*pairmin = (float *) malloc(MAXBND * sizeof(float));
if (*pairmin == NULL)
   zip_err ("!Error allocating storage", "zip-alloc");


/* allocate temp space for processing in applylut 
-------------------------------------------------*/
if ((temp1 = (short *) malloc (window[0][NS] * sizeof(short))) == NULL)
    zip_err ("!Error allocating dynamic memory", "zip-alloc");
if ((temp2 = (short *) malloc (window[0][NS] * sizeof(short))) == NULL)
    zip_err ("!Error allocating dynamic memory", "zip-alloc");
}
