#include "zip.h"

void getpoly
(
    long ic,                    /* I: class index number */
    long is,                    /* I: site index number */
    long xaxis[],
    long yaxis[], 		/* O: x and y co-ords of site vertices */
    long *nverts,               /* O: number of vertices */
    long xoff,
    long yoff                   /* I: x and y offsets */
)
/*
---------------------------------------------------------------------
NAME: GETPOLY

PROGRAM HISTORY:
      Version            date             Author
      -------            ----             ------
         3              june-88          B. Allam
         2              feb -87          R. Mckinney
         1              june-84          Y. Sheu
 
FUNCTION:  Get polygon vertices from statistics file for site
-----------------------------------------------------------------------
*/
{
static long	xyvert[401]; /* x and y coords for vertices as returned 
                                from statistics file */
long	vshape[9];           /* stats data descriptor for vertices */
long	nv, indx,            /* counter variables */
        stat;                /* status returned */
/*
get polygon from stats file
---------------------------
*/
stat = c_stget((FILE **)&fd_sfin, "POLYGON", &ic, &is, vshape, 
		(unsigned char *)xyvert);
if (stat != E_SUCC)
  zip_err ("!Error reading polygon", "zip-poly");
if (vshape[2]  >  200)
  zip_err ("!MAXIMUM # SITE VERTICES = 200. SIMPIFY SITE SHAPES", 
           "zip-nvert");

*nverts = vshape[2];

/*
get x , y  coordinates
----------------------
*/
indx = 0;
for (nv = 0; nv < *nverts; nv++)
   {
   xaxis[nv] = xyvert[indx] - xoff + 1;
   yaxis[nv] = xyvert[indx + 1] - yoff + 1;
   indx = indx + 2;
   }  /* do */

}
