#include "zip.h"

void pwlin
(
    long ibands,           /* I: no. of images */
    long sp,               /* I: starting pixel */
    long np,               /* I: ending pixel */
    float scale[],         /* I: ratios of from ranges and to ranges */
    float minp[],          /* I: min and max pixel values */
    float pairmin[],       /* I: min value of mapping array */
    float pairmax[],       /* I: max value of mapping array */
    long npairs,           /* I: no. of mapping pairs */
    float from[],
    float to[]             /* I: mapping pairs */
)

/*
-----------------------------------------------------------------
FUNCTION: PWLIN

PROGRAM HISTORY:
      Version             date             Author
      -------             ----             ------
         3              JULY - 88        B. ALLAM
         2              FEB  - 87        R. MCKINNEY
         1              JUNE - 84        Y. SHEU

FUNCTION -     INTERPOLATES PIXEL VALUES ACCORDING TO THE 
               FROM & TO ARRAYS SUPPLIED BY USER FOR PIECEWISE
               LINEAR MAPPING

----------------------------------------------------------------------
*/
 
{
      float  new;            /* mapped pixel value */
      long   flag;
      long   j, n, i;        /* counter variables */
      float  gray;           /* pixel value to be mapped */


       flag = 0;
       for (j = sp; j <=np; j++)
       {
        for (n=0; n < ibands; n++)
          {
           gray = iobuf[ipoint[n]+j -1];
           if (gray < from[0]) 
           {
             new = minp[n] + pairmin[n] * (gray - minp[n]);
             flag = 1;
           }

           if (!flag && gray > from[npairs-1])
             {
             new = to[npairs-1]+ pairmax[n] * (gray-from[npairs-1]);
             flag = 1;
             }

           for (i=0; (i < npairs-1 && !flag); i++)
             {
              if (gray >= from[i])
              {
                new = to[i] + scale[i] * (gray-from[i]);
                flag = 1;
              }
             }

           iobuf[opoint[n]+j-1] = new;
          }
        }
        
}
