#include "zip.h"

void range
(
    double cval,          /* I: value to be checked */
    long itype,           /* I: data type of input image */
    long *abo             /* I/O: constant type */
)
/*
---------------------------------------------------------------
NAME: RANGE

PROGRAM HISTORY:
      Version           date           Author
      -------           ----           ------
         3            nov-88          B. Allam
         2            feb -87         R. Mckinney
         1            july-84         Y. Sheu

FUNCTION:  Checks validity of data type of value
--------------------------------------------------------------------
*/
{
char    done = 0;              /* flag */
long	icval;                 /* input value as an integer */
static float   minr[4] ={MINUTINY, MINWORD, MINLONG, MINREAL};
static float   maxr[4] ={MINUTINY, MAXWORD, MAXLONG, MAXREAL};

/*
--------------------------------------
 check i/o validity for each data type
--------------------------------------
*/
if (itype != 4) 
   {
   if (cval <= maxr[2]  &&  cval >= minr[2]) 
      {
      icval = (int)cval;
      if (cval != (float)icval) 
         {
         if (*abo == 1) 
            zip_err ("!SPECIFIED CONSTANT IS INCOMPATIBLE WITH INPUT/OUTPUT DATATYPE", 
                       "zip-const");
         else
            {
            *abo = 1;
            printf("***** INVALID CONSTANT TYPE *****\n");      
            done = 1;
            }  
         }  
      }
   else
      {
      *abo = 1;
      printf("***** VALUE IS OUTSIDE VALID RANGE FOR DATA *****\n");
      done = 1;
      }  
   }  

if (!done)
{
if (cval < minr[itype-1]  ||  cval > maxr[itype-1])
   {
   if (*abo == 1) 
      zip_err ("!CONSTANT IS INCOMPATIBLE WITH INPUT/OUTPUT DATA TYPE",
                  "zip-const");
   else
      {
      *abo = 1;
      printf("VALUE IS OUTSIDE VALID RANGE FOR DATA *****\n");
      }  
   }  
}
}
