#include "zip.h"

void sect
(
    long xverts[],
    long yverts[],        	/* I/O: x and y vertices */
    long nverts,                /* I: no. of vertices */
    long line,                  /* I: line no. to be checked */
    long sects[],               /* O: x coords of intersections */
    long *nsect                 /* O: no. of intersections */
)

/*
----------------------------------------------------------------------
NAME: SECT

PROGRAM HISTORY:
      Version          date              Author
      -------          ----              ------
         3            july-88           B. Allam
         2            feb -87           R. Mckinney
         1            june-84           Y. Sheu

FUNCTION:    Calculates intersections of a line with the boundaries of
             a polygon.

-----------------------------------------------------------------
*/
{
long	x1, x2, y1, y2;
long	sorted;
long	i, itemp;

*nsect = 0;
xverts[nverts] = xverts[0];
yverts[nverts] = yverts[0];
/*
find intersections of line polygon boundary
-------------------------------------------
*/
for (i = 1; i <= nverts; i++)
  {
   y1 = yverts[i-1];
   y2 = yverts[i];
   if ( y1  !=  y2 ) 
     {
      if ( line >=  min(y1, y2) && line <= max(y1, y2)) 
        {
         x1 = xverts[i-1];
         x2 = xverts[i];
         sects[*nsect] = .5 + (float)x1 + (float)(x2-x1) * (float)(line-y1) 
                         / (float)(y2-y1);
         *nsect = *nsect + 1;
        } /* if */
     }/*---if---*/
  }
/*
sort intersections in ascending order
-------------------------------------
*/
sorted = FALSE;

if (*nsect != 0 && *nsect != 1)
{
while (!sorted)
  {
   for (i = 1; i < *nsect; i++)
     {
      if ( sects[i-1] > sects[i] )
        {
         itemp = sects[i-1];
         sects[i-1] = sects[i];
         sects[i] = itemp;
         sorted = FALSE;
        }
      else sorted = TRUE;
     }
  }
} /* if */
}
