#include "zip.h"

void setfgin
(
    char hosin[][CMLEN],          /*I: input image host name descriptors */
    long nimages,                 /*I: no. of input images           */
    long wind[][4]                /*I: input image windows           */
)
{
/*
------------------------------------------------------------------------

NAME: SETFGIN

FUNCTION: SETFGIN is called by STATS to initialize the input file
          action group for random access.

PROGRAM HISTORY:
    Version             date            Author
    -------             ----            ------
       4              15-apr-88        b.allam/sar  scn#20-140
       3              28-feb-84        s.ross/sar   scn#20-181
       1              12-dec-83        s.ross/sasc  scn#20-105

ALGORITHM:

    Call C_EOPENS to open input and output images

------------------------------------------------------------------------
*/

   long    stat,                  /* flag for EOPENS procedure */
           access,                /* file specifications       */
           type,                  /* data type                 */
           n, nib;                /* counter variables         */
long	zero = 0;
long    one = 1;

/*
 set up input file group
 -----------------------
*/

   access = IREAD;
   type = EREAL;
   for (n = 0, nib = 0; n < nimages ; n++)
   {
     stat = c_eopenr((struct FDESC **)&fdesc[n],hosin[n],&nbands[n],
		     &wind[n][SL], &wind[n][SS], &wind[n][NL], &wind[n][NS], 
		     &access, &type, &zero, &one);
     if (stat != E_SUCC)
       zip_err("!Error opening input image", "zip-input");
     nib += nbands[n]; 
    }
    fdesc[++n]=0;
}
