#include "zip.h"

void statchk
(
    char hostat[],		/* I: stats file host name */
    long nclass, 		/* I: no. of classes */
    long *ncproc		/* O: no. of classes processed */
)
{
/*
**********************************************************************
NAME: STATCHK

PROGRAM HISTORY:
      Version            date             Author
      -------            ----             ------
         3              nov -88          B. Allam
         2              feb -87          R. Mckinney
         1              june-84          Y. Sheu
 
FUNCTION: Opens statistics file; checks number of classes in file
          against user's request.

COMMENTS:       If user requests more classes than exist he will be 
		prompted for action (continue using all classes or
		abort).if he chooses to abort prog will exit with
		an msg_classes

**********************************************************************
*/
/*
----------------------------------------------------
 statchk  opens stats file & checks for # of classes
----------------------------------------------------
*/
long    access,			/* mode of access */
        stat,			/* status returned */
        nclass_stats;		/* no. of classes in stats file */
char    ch,
        buf[100];		/* temporary buffer */
/*
----------------
 open stats file
----------------
*/
access = IREAD;
stat = c_stopen ((FILE **)&fd_sfin, hostat, &access, &nclass_stats); 
if (stat != E_OPOLD)
   {
   zip_err ("!UNABLE TO OPEN STATS FILE. RESTART", "zip-stat");
   }  
/*
---------------------------------------
 check # classes against user's request
---------------------------------------
*/
if (nclass > nclass_stats)
   {
   zip_err("!Number of classes specified exceed number in file.", "zip-nclass");
/*
----------------------------
 user must respond yes or no
----------------------------
*/
   printf("$_Do you wish to proceed using all classes? (Y/N):");
 
   ch = getchar();
   if (ch == 'y' || ch == 'Y')       /* all classes */
      nclass = 0;
   else if (ch == 'n' || (ch) == 'N')   /* abort */
      zip_err("!TOO MANY CLASSES REQUESTED. RESTART", "zip-class");
  }
/*
--------------------------------------
 establish actual # classes to be used
--------------------------------------
*/
*ncproc = nclass;
if (nclass == 0) 
  {
  *ncproc = nclass_stats;
  sprintf(buf, "?Number of classes to be used is now reset to: %3d", *ncproc);
  zip_err(buf, "zip-reset");
  }

}
