#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,      /* pointer to TAE block	 	      */
    char taein[][CMLEN],	/* TAE file names of input images	      */
    char hosin[][CMLEN],  	/* host file names of input images	      */
    char taeout[][CMLEN],		/* TAE file name of output image	      */
    char hosout[][CMLEN],		/* host file name of output image	      */
    long *nmrimg, 		 /* number of input images		      */
    long (*bands)[MAXBND+1],         /* band specification 		              */
    long *nbands,		 /* number of bands per input image           */
    long (*window)[4],	         /* window specification		      */
    long *msgtim,		 /* elapsed time between display messages     */
    char *minmax,		 /* min max flag buffer		              */
    char *subnam,		 /* subcommand specified		      */
    long *xfact,		 /* factor to enlarge or reduce the x-axis    */
    long *yfact,		 /* factor to enlarge or reduce the y-axis    */
    long *nol,			 /* number of image output lines              */
    long *nos,			 /* number of image output samples	      */
    long *odtype,		 /* data type of input image		      */
    long *totbnd		 /* total number of bands		      */
);

void zmexpand
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin[][CMLEN],		/* host names of input images		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*window)[4],		/* window specification of input images      */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long totbnd,			/* total number of bands to be processed     */
    long odtype,			/* data type of output image                 */
    long xfact,			/* expansion factor for the x-axis	     */
    long yfact,			/* expansion factor for the y-axis	     */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    long nol,			/* number of image output lines              */
    long nos			/* number of image output samples            */
);

void zmreduce
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin[][CMLEN],		/* host names of input images		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*window)[4],		/* window specification of input images      */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long totbnd,			/* total number of bands to be processed     */
    long odtype,			/* data type of output image                 */
    long xfact,			/* reduction factor for the x-axis	     */
    long yfact,			/* reduction factor for the y-axis	     */
    long msgtim,			/* elapsed time between display messages     */
    char *minmax,		/* min max flag                              */
    long nol,			/* number of image output lines		     */
    long nos			/* number of image output samples            */
);

#endif
