/******************************************************************************
FUNCTION:	PROC_ERROR

PURPOSE:	Process error conditions.  It saves the old DITTO device
		attributes, updates the attributes to current processing
		point, and calls ditto_error to output the error message
		and to determine if processing should continue.  If control
		is returned from ditto_error, the old attributes are
		reassigned.

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>			/* C standard I/O include file       */
#include "las.h"			/* LAS include file 		     */
#include "tapeio.h"			/* tape I/O include file 	     */
#include "ditto.h"			/* ditto include file                */
#include "protos.h"

void proc_error
(
    char *device,			/* device type (tape or disk)        */
    long currec,			/* current record being processed    */
    long error_code			/* DITTO error code                  */
)
{
extern struct DISK_FD disk;
extern struct TAPE_FD tape;
long   old_in;
long   *inrec;

if (strcmp(device,"DISK") == 0)
   inrec = &disk.cur_rec;
else
   inrec = &tape.cur_rec;

old_in = *inrec;
if (*inrec != NOVAL)
   *inrec += currec + 1;

ditto_error(" ",error_code,ERROR_VERIFY,UPDATE_FD);
*inrec = old_in;

return;
}
