#ifndef PROTOS_H
#define PROTOS_H

void close_device
(
    char *which,			/* which device (input or output)    */
    char *device,			/* type of device (tape or disk)     */
    long currec,			/* Current record		     */
    long bytes_read			/* # bytes read on last read         */
);

void getpar
(
    char *which,
   char *device,
   long *nrecords,
   long *ebc_fmt,
   long *hex_fmt,
   char *tapeid
);

void lp_char
(
   FILE *lp_fp,
   unsigned char *buf,
   long nbyte,
   long currec
);

void lp_hex
(
   FILE *lp_fp,
   unsigned char *buf,
   long nbyte,
   long currec
);

unsigned char *open_device
(
    char *which,
   char *device,
   char *header,
   char *tapeid
);

void proc_error
(
    char *device,			/* device type (tape or disk)        */
    long currec,			/* current record being processed    */
    long error_code			/* DITTO error code                  */
);

int read_device
(
    char *device,		/* device type (tape or disk)        */
    int currec,
    unsigned char *buf	/* buffer to read record into        */
);

void term_char
(
    unsigned char *buf,	/* buffer containing physical record */
    long nbyte,		/* number of bytes in physical record*/
    long currec			/* current record being dumped       */
);

void term_hex
(
    unsigned char *buf,	/* buffer containing physical record */
    long nbyte,		/* number of bytes in physical record*/
    long currec			/* current record being dumped       */
);

#endif

