/******************************************************************************
FUNCTION:	PROC_ERR

PURPOSE: 	Processes error conditions.  It saves the old DITTO
		input/output attributes, update the attributes to
		current processing point, and calls ditto_error to
		output the error message and to determine if processing
		should continue.  If control is returned from ditto_error,
		the old attributes are reassigned.

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>			/* C standard I/O include file       */
#include "las.h"			/* LAS include file 		     */
#include "tapeio.h"			/* tape I/O include file	     */
#include "ditto.h"			/* ditto include file                */
#include "protos.h"

void proc_error
(
    char *device,			/* device type (tape or disk)        */
    long currec,			/* current record being processed    */
    long error_code			/* error code encountered            */
)
{
extern struct DISK_FD disk;		/* disk file descriptor              */
extern struct TAPE_FD tape;		/* tape descriptor                   */
long   old;				/* old current record                */
long   *rec;				/* pointer to current record         */

if (strcmp(device,"DISK") == 0)
   rec = &disk.cur_rec;
else
   rec = &tape.cur_rec;

old = *rec;
if (*rec != NOVAL)
   *rec += currec + 1;

ditto_error(" ",error_code,ERROR_VERIFY,UPDATE_FD);
*rec = old;

return;
}
