#ifndef PROTOS_H
#define PROTOS_H

void close_device
(
    char *which,			/* which device (input or output)    */
    char *device,			/* device type  (tape or disk)       */
    int currec,
    long bytes_read			/* bytes read on last read           */
);

unsigned char *compute_scan
(
    long *scan_length
);

unsigned char *open_device
(
    char *which,
   char *device,
   char *header,
   char *tapeid
);

void proc_error
(
    char *device,			/* device type (tape or disk)        */
    long currec,			/* current record being processed    */
    long error_code			/* error code encountered            */
);

int read_device
(
    char *device,			/* device type (tape or disk)        */
    int currec,
    unsigned char *buf			/* buffer to read record into        */
);

void getpar
(
    char *which,			/* which device (input or output)    */
    char *device,			/* device type  (tape or disk)       */
    long *start,			/* starting offset within record     */
    long *nrecords,			/* number of records to be processed */
    char *tapeid
);

int scanbuf
(
    unsigned char *buf,	/* buffer containing the record      */
    long start,		/* starting offset to begin scan     */
    long recsiz,		/* number of bytes in record         */
    long currec,		/* current record being processed    */
    unsigned char *scan_string, /* scan string to be searched for  */
    long scan_length,	/* number of bytes in scan string    */
    long *print			/* print destination (term,lp,both)  */
);

#endif

