/******************************************************************************
FUNCTION:	PRT_TERM

PURPOSE:	Outputs one line of text to the terminal screen

ALGORITHM 
  Clear the screen the first time
  Increment the line counter
  Write the message out to the specifie line

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>			/* C standard I/O include file       */
#include "las.h"			/* LAS include file 		     */
#include "ditto.h"			/* ditto include file                */
#include "protos.h"

#define TERM	0			/* index for terminal		     */
#define FIL	1			/* index for file		     */
#define LP	2			/* index for line printer	     */

void prt_term
(
    char *msg,				/* message to be outputted           */
    long *line			/* terminal line number              */
)
{
extern long print[3];			/* Flag for term, lp, or file output */
extern FILE      *lp_fp;		/* file pointer to line printer file */

/*
  Clear the screen the first time
*/
if (print[TERM] && (*line == 0))
   t_clear();

/*
  Increment the line counter
*/
++(*line);

/*
  Write the message out to the specified line
*/
if (print[TERM])
    {
    t_output(*line,5,msg);
    }
else
   fprintf(lp_fp,"%s\n",msg);

return;
}
