#ifndef PROTOS_H
#define PROTOS_H

void close_device
(
    struct VERIFY_DEV *indev,		/* input DITTO device descriptor     */
    struct VERIFY_DEV *outdev		/* output DITTO device descriptor    */
);

void file_verify
(
    char *idevice,			/* input device (tape or disk)       */
    char *odevice			/* output device (tape or disk)      */
);

int file_open
(
    char *idevice,		/* input DITTO device (tape or disk) */
    char *odevice,		/* output DITTO device (tape or disk)*/
    struct VERIFY_DEV *indev,	/* input device descriptor           */
    struct VERIFY_DEV *outdev	/* output device descriptor          */
);

void file_close
(
    struct VERIFY_DEV *indev,	/* input DITTO device                */
    struct VERIFY_DEV *outdev	/* output DITTO device               */
);

void open_device
(
    char *idevice,			/* input device (tape or disk)       */
    char *odevice,			/* output device (tape or disk)      */
    struct VERIFY_DEV *indev,		/* input device descriptor           */
    struct VERIFY_DEV *outdev		/* output device descriptor          */
);

void proc_error
(
    struct VERIFY_DEV *indev,		/* input device descriptor           */
    struct VERIFY_DEV *outdev,		/* output device descriptor          */
    char *which,			/* which device (input or output)    */
    long error_code			/* DITTO error code encountered      */
);

int read_device
(
    struct VERIFY_DEV *indev,		/* Input device			*/
    struct VERIFY_DEV *outdev		/* Output device to verify	*/
);

void record_verify
(
    char *idevice,			/* Pointer to input device	*/
    char *odevice			/* Pointer to output device	*/
);

void verify_buf
(
    struct VERIFY_DEV *indev,		/* Input device			*/
    struct VERIFY_DEV *outdev,		/* Output device		*/
    long nbyte		/* Number of bytes to verify	*/
);

int verify_proc
(
    struct VERIFY_DEV *indev,		/* Input device			*/
    struct VERIFY_DEV *outdev,		/* Output device		*/
    long nrecords,			/* Number of records		*/
    long msgtim			/* Message time			*/
);

#endif

