/******************************************************************************
FUNCTION:	VERIFY_BUF

PURPOSE:	Does a byte by byte compare of the input and output records.
		If a difference is found an error message is written.

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>			/* C standard I/O include file       */
#include "las.h"			/* LAS include file                  */
#include "util.h"
#include "tapeio.h"			/* tape I/O include file             */
#include "ditto.h"			/* ditto include file                */
#include "verify.h"
#include "protos.h"

#define currec curent

void verify_buf
(
    struct VERIFY_DEV *indev,		/* Input device			*/
    struct VERIFY_DEV *outdev,		/* Output device		*/
    long nbyte		/* Number of bytes to verify	*/
)
{
extern long currec;			/* Current record		*/
long    old_nbyte;		/* temp to hold number of bytes	*/
unsigned char  *inbuf;		/* Input buffer			*/
unsigned char  *outbuf;	/* Output buffer to verify	*/
char	    msg[ERRLEN];		/* Error message buffer		*/

inbuf = indev->buf;
outbuf = outdev->buf;
old_nbyte = nbyte;

/*
  Verify the buffers byte by byte
*/
for (; nbyte-- ;inbuf++,outbuf++)
   {
   if (*inbuf != *outbuf)		/* Found a difference		*/
      {
      c_stoptm();
      sprintf(msg,"VERIFY ERROR at record %d byte offset %d",
              currec,old_nbyte - nbyte - 1);
      m_msg(msg,"ditto-verify");

      sprintf(msg,"    input hex value %X NOT EQUAL TO output hex value %X",
	      *inbuf,*outbuf);
      m_msg(msg,"ditto-verify");

      proc_error(indev,outdev," ",DITTO_VERIFY);
      c_startm();
      }
   }

return;
}
