/******************************************************************************
FUNCTION:       BLDALIAS

PURPOSE:        Returns the name of the user's alias file.

PROGRAM HISTORY:

Version    Date     Author           Change Request
-------    -----    -------------    --------------
  1.0      10/86    C. Greenhagen    New Development
  1.1      12/87    B. Ailts         Use raw 'C' types
  5.0      04/88    D. Hollaren      changed include spec to las

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        None.

PROJECT                 LAS

ALGORITHM 
Get user default directory and append the ALIAS LIST file.

ALGORITHM REFERENCES    none
*******************************************************************************/

#include <string.h>
#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/file.h>

#include "las.h"
#include "alias.h"
#include "local_protos.h"

/**
 * bldalias:
 * @aliasfile: O: The name of the user's alias file.
 * 
 * By getting the user default directory and  
 * appending the ALIAS LIST file, bldalias()
 * routine returns the name of the user's
 * alias file.
 * 
 * Note: The use of the bldalias() routine by other
 * applications should be minimized. Only c_getalias()
 * should be used by most applications.    
 *
 * Bldalias() has no return values, other than
 * the name of the user's alias file.
 */

void bldalias
(
    char *aliasfile                     /* name of user's alias file    */
)
{
    char dir[256];                      /* user's default directory     */

    
    getmydef(dir);                      /* build alias file name        */

    strcpy (aliasfile,dir);
    strcat  (aliasfile,"/cm/alias.list");

}
