/******************************************************************************
FUNCTION:       cmtaedir

PURPOSE:

PROGRAM HISTORY:
Version    Date     Author              Change Request
-------    -----    -------------       --------------
  1.0      ??/??    ???                 Original development
  5.0      04/88    D. Hollaren         Put the prolog on
  5.1      07/88    B. Davis            fixed bug using wildcards
  5.2      01/91    D.Etrheim           Standardized error message handling

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        None.

PROJECT                 LAS

ALGORITHM 
Using the input host directory specification attach a dummy host file name
and call c_cmtae to translate it to the TAE directory specification.

ALGORITHM REFERENCES    none
*******************************************************************************/

#include <stdio.h>
#include <string.h>
#include "las.h"
#include "cm.h"

#ifndef NO_OBSOLETE_INTERFACE

/**
 * cmtaedir:
 * @hostdir:  I: Host directory specification.
 * @taedir:   O: TAE directory specification.
 *
 * cmtaedir() is an obsolete function that simply copies the
 * hostdir parameter to taedir and adds a '/' at the end of
 * the name.  This function should no longer be used.
 *
 * Returns:  E_SUCC:  Successful completion of operation,
 *           E_FAIL:  Unsuccessful completion of operation.
 */
int cmtaedir
(
    const char *hostdir,        /* I: Host directory specification */
    char *taedir                /* O: TAE directory specification  */
)
{
    strcpy (taedir, hostdir);

    strcat (taedir, "/");

    return (E_SUCC);
}

#endif /* obsolete interfaces  */
