/*******************************************************************************
Purpose:
    This routine checks if the given line status is requested for the
    given coverage.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS

*******************************************************************************/
#include "las.h"
#include "dcw.h"

int dcw_checkstatus
(
    struct DCW_COVERAGE *coverage,	/* DCW coverage information 	*/
    int status		/* DCW line status		*/
)
   {
   int		i;

  /*
   *  *** if a status of the coverage matches and is selected return TRUE
   */
   for (i = 0; i < coverage->numstatus; i++)
      {
      if (coverage->status[i].attribute == status)
         return(coverage->status[i].selected);
      }
  
   return(FALSE);
   }
 

