/*******************************************************************************
Purpose:
    This routine checks if the given line type is requested and not  
    currently loaded.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS

*******************************************************************************/
#include "las.h"
#include "dcw.h"

int dcw_checktype
(
    struct DCW_COVERAGE *coverage,	/* DCW coverage information	*/
    int type		/* DCW line type		*/
)
   {
   int		i;

   if (type < 0)
      return(FALSE);

  /*
   *  *** if a status of the coverage matches and is selected return TRUE
   */
   for (i = 0; i < coverage->numvdt; i++)
      {
      if (coverage->vdt[i].attribute == type)
         return(coverage->vdt[i].selected && !coverage->vdt[i].loaded);
      }
  
   return(FALSE);
   }
 

