/*******************************************************************************
Purpose:
    This routine frees a given DCW coverage data structure.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
 
Algorithm Description:
*******************************************************************************/
#include <stdlib.h>
#include "las.h"
#include "dcw.h"

int dcw_freecover
(
    struct DCW_COVERAGE *dcw_coverage  /* DCW coverage structure to be freed */
)
   {
   int		i;

   i = 0;
  /*
   *  *** for each defined coverage
   */
   while (dcw_coverage[i].desc != NULL)
      {
     /*
      *  *** free vector description table (vdt)
      */
      if (dcw_coverage[i].numvdt != 0)
         {
         free(dcw_coverage[i].vdt);
         dcw_coverage[i].numvdt = 0;
         }
   
     /*
      *  *** free line status information
      */
      if (dcw_coverage[i].numstatus != 0)
         {
         free(dcw_coverage[i].status);
         dcw_coverage[i].numstatus = 0;
         }

      i++;
      }

   return(E_SUCC);
   }

