/*******************************************************************************
Purpose:
    This routine frees all DCW line data structures.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
#include <stdlib.h>
#include "las.h"
#include "dcw.h"

int dcw_freelines
(
    struct DCW_VECTOR *dcw_vector  /* DCW coverage structure to be freed */
)
   {
   int	i;	/* loop counter */

  /*
   *  *** free points for each line
   */
   for (i = 0; i < dcw_vector->numlines; i++)
      free(dcw_vector->line[i].pts);

  /*
   *  *** free line structures
   */
   free(dcw_vector->line);
   dcw_vector->line = NULL;

   return(E_SUCC);
   }

