/*******************************************************************************
Purpose:
    This routine returns the index of the CD currently mounted at
    the CD pathname given in the tiepts parameters.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
#include <string.h>
#include "las.h"
#include "dcw.h"

int dcw_getcd
(
    char *cdpath,		/* location of cd drive		*/
    int *curlib,		/* current library		*/
    struct DCW_CD *dcw_cd		/* DCW CD information structure */
)
   {
   char		dcwpath[256];		/* full pathname of dcw root 	*/
   char		fullpath[256];		/* full pathname of dcw library */
   int		i;			/* loop counter		        */

  /*
   *  *** get pathname from parameters
   */
   strcpy(dcwpath, cdpath);
   strcat(dcwpath, "/dcw/");

  /*
   *  *** if a library is currently defined, check existance
   */
   if (*curlib >= 0)
      {
      strcpy(fullpath, dcwpath);
      strcat(fullpath, dcw_cd[*curlib].lib);

     /*
      *  *** if that directory exist, return
      */
      if (!access(fullpath, 0))
         return(E_SUCC);
      }
   else
      {
     /*
      *  *** search each possible CD library name for presence
      */
      for (i = 0; i < DCW_NUMCD; i++)
         {
         strcpy(fullpath, dcwpath);
         strcat(fullpath, dcw_cd[i].lib);
   
        /*
         *  *** if that directory exist, return
         */
         if (!access(fullpath, 0))
            {
            *curlib = i;
            return(E_SUCC);
            }
         }
      }

   return(E_FAIL);
   }

