/*******************************************************************************
Purpose:
    This routine returns the longitude of the lower left coordinate for 
    a tile of the Digital Chart of the World.  The tilename is of
    the form "A/B/31"; where A is the 15 degree longitude letter,
    B is the 15 degree latitude letter, 3 is the 5 minute column tile,
    and 1 is the 5 minute row tile.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
#include "dcw.h"

int dcw_getlon
(
    char *tile		/* pathname of tile of interest		*/
)
   {
   int		lon;		/* return value				*/
  
  /*
   *  *** Determine the 15 minute tile from pathname.
   *      Tiles are lettered alphabetically, excluding 'I' and 'O'
   */
   if (tile[0] > 'o')
      lon = (tile[0] - 'o')*15;
   else if (tile[0] > 'i')
      lon = -75 + (tile[0] - 'i')*15;
   else 
      lon = -180 + (tile[0] - 'a')*15;

  /*
   *  *** determine 5 minute tile from pathname
   */
   lon += (tile[4] - '1') * 5;

   return(lon);
   }


