/*******************************************************************************
Purpose:
    This routine returns the character representing the 15 degree 
    latitude tile for the Digital Chart of the World.  Latitude
    tile are lettered from A to M excluding 'I'.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
#include <math.h>
#include "dcw.h"

char dcw_lattile
(
    double lat,		/* latgitude to find DCW directory for	*/
    long minflag	/* flag denoting minimum boundary	*/
)
   {
   char		lattile;	/* return value				*/
  
   /*
    *  ***  if greater than 'I'
    */
   if (lat >= 30.0)
      lattile = 'J' + ((int)(lat - 30.0))/15;
   else
      lattile = 'A' + ((int)(lat + 90.0))/15;

   if (!minflag && (fmod(lat,15.0) == 0.0))
      {
      lattile--;
      if (lattile == 'I') lattile--;
      }

   return(lattile);
   }

