/*******************************************************************************
Purpose:
    This routine returns the character representing the 15 degree
    longitude tile for the Digital Chart of the World.  Longitude
    tile are alphabetized from A to Z excluding I and O.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
#include <math.h>
#include "dcw.h"

char dcw_lontile
(
    double lon,			/* longitude to find DCW directory for	*/
    long minflag	/* denoting minimum boundary	        */
)
{
char		lontile;	/* return value				*/
  
/*
 *  *** if greater than 'O'
 */
if (lon >= 15.0)
    lontile = 'P' + ((int)(lon -  15.0))/15;
/*
 *  *** if greater than 'I'
 */
else if (lon >= -60.0)
    lontile = 'J' + ((int)(lon +  60.0))/15;
else
    lontile = 'A' + ((int)(lon + 180.0))/15;

if ((!minflag) && (fmod(lon,15.0) == 0.0))
    {
    lontile--;
    if (lontile == 'I') lontile--;
    if (lontile == 'O') lontile--;
    }

return(lontile);
}
