/*******************************************************************************
Purpose:
    This routines reads the digital chart of the world data from a file.
    This data is in DOS binary format, so must swap bytes accordingly.
 
PROGRAM HISTORY:
VERSION         DATE    AUTHOR          CODE/CONT   REASON
-------         ----    ------          ---------   ------
  5.1           11/92   J. Hemmer         CSB       Original development
 
PROJECT:  LAS
*******************************************************************************/
#include <stdio.h>
#include "dcw.h"

int dcw_read
(
    unsigned char *ptr,     /* pointer to block of data	*/
    int		size,           /* size of item in block	*/
    int		num,            /* number of items in block	*/
    FILE*	fd              /* file descriptor of CD	*/
)
   {
   int			i;		/* loop counter			*/
   static char		tmp2[2];	/* 2 byte temporary array	*/
   static char		tmp4[4];	/* 4 byte temporary array	*/

  /*
   *  *** if character string, just read normally
   */
   if (size == 1)
      {
      if (fread(ptr, size, num, fd) != num)
         return(0);
      }
   else
      {
      switch (size)
         {
        /*
         *   *** short integer
         */
         case 2:
            for (i = 0; i < num; i++)
               {
               if (fread(tmp2, size, 1, fd) != 1)
                  return(0);
               *(ptr++) = tmp2[1] ;
               *(ptr++) = tmp2[0] ;
               }
            break;
        
        /*
         *   *** long integer or float
         */
         case 4:
            for (i = 0; i < num; i++)
               {
               if (fread(tmp4, size, 1, fd) != 1)
                  return(0);
               *(ptr++) = tmp4[3] ;
               *(ptr++) = tmp4[2] ;
               *(ptr++) = tmp4[1] ;
               *(ptr++) = tmp4[0] ;
               }
            break;

         default:
            printf("[dcw_read-dtype] Unknown data type encountered\n");
            return(0);
         };
      }

   return(num);
   }


