#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "desc.h"

int minmax_
(
    char   hname[][CMLEN],
    int    *nimg,
    int    window[][4],
    int    bands[][MAXBND + 1],
    int    *nbands,
    double *minval,
    double *maxval,
    int    h_len 
)
{
    int  i;
    int  status;

    char *hname_ptr;
    char *temp_ptr;

    hname_ptr = (char *)malloc(CMLEN * *nimg);
    if (hname_ptr == NULL)
    {
        c_lasmsg (FALSE, "minmax-alloc",
                 "Error allocating dynamic memory");
        return(E_FAIL);
    }

    for (i= 0; i < *nimg; i++)
    {
        temp_ptr = squeeze (hname[i],h_len);
        if (temp_ptr == NULL)
        {
            c_lasmsg (FALSE, "minmax-alloc",
                      "Error allocating dynamic memory");
            free (hname_ptr);
            return (E_FAIL);
        }
        strcpy (hname_ptr + (i* CMLEN), temp_ptr);
        free (temp_ptr);
    }

    status = las_minmax (hname_ptr,*nimg,window,bands,*nbands,minval,maxval);

    free (hname_ptr);

    return(status);
}
