#include <string.h>
#include "las.h"
#include "desc.h"

int upddr_
(

    struct PARBLK *parblk,
    char   host_in[][CMLEN],
    char   *host_out,
    int    *nmrimg,
    int    window[][4],
    int    bands[][MAXBND +1],
    int    nbands[],
    double *line_inc,
    double *samp_inc,
    int    *out_nbands,
    int    *cflag,
    int    host_out_len
)
{
    int  i;
    int  status;

    char *hout_ptr;
    char *hin_ptr;
    char *temp_ptr;

    hin_ptr = (char *)malloc(CMLEN * (*nmrimg));
    if (hin_ptr == 0)
    {
        c_lasmsg (FALSE, "upddr-alloc",  
                 "Error allocating dynamic memory");
        return (E_FAIL);
    }

    for (i = 0;i < *nmrimg; i++)
    {
        temp_ptr = squeeze (host_in[i], CMLEN);
        if (temp_ptr == NULL)
        {
            c_lasmsg (FALSE, "upddr-alloc",
                      "Error allocating dynamic memory");
            free (hin_ptr);
            return (E_FAIL);
        }

        strcpy (hin_ptr + (i * CMLEN), temp_ptr);
        free (temp_ptr);
    }

    hout_ptr = squeeze (host_out,host_out_len);
    if (hout_ptr == NULL)
    { 
        c_lasmsg (FALSE, "upddr-alloc", "Error allocating dynamic memory");
        free (hin_ptr);
        return (E_FAIL);
    }
    status = las_upddr (parblk,hin_ptr,hout_ptr,*nmrimg,window,bands,nbands,
                        *line_inc,*samp_inc,*out_nbands,*cflag);

    free (hout_ptr);

    free (hin_ptr);

    return(status);
}  /* upddr  */
