/*******************************************************************************
NAME                           C_INTBDR

PURPOSE      Initialize data for a band dependent record of a DDR file

PROGRAM HISTORY
PROGRAMMER              DATE            REASON
----------              ----            ------
K. Zanter             Feb. 1988         original development
B. Ailts              Apr. 1988         Replaced newlas.h with las.h
                                        Changed the calling sequence -- now 
                                        only uses on structure - BDDR

PROJECT      LAS

ALGORITHM 
   Initialize the band record data with zeros if numeric values or blanks 
    if charcter strings.

ALGORITHM REFERENCES    none
*******************************************************************************/
#include <string.h>
#include "las.h"

/**
 * c_intbdr:
 * @bddr: I/O: A BDDR structure.  It contains the fields of the band 
 * record of the DDR.
 *
 * The c_intbdr() call is used to initialize the values for a 
 * band-dependent record of the DDR to zeroes (0) or blanks.
 */
void c_intbdr
(
    struct BDDR *bddr  /* I/O: bddr data                                    */
)

{
    memset(bddr,0,sizeof(*bddr));
    bddr->minval = 0.0;
    bddr->maxval = 0.0;
    bddr->bandno = 0;
    bddr->valid = 0;
    strcpy(bddr->source," ");
    strcpy(bddr->instrument," ");
    strcpy(bddr->direction," ");
    strcpy(bddr->date," ");
    strcpy(bddr->time," ");

}  /*  c_intbdr  */
