/******************************************************************************
FUNCTION:	HEX2BYT

PURPOSE:	Converts a character string in hexidecimal format into
		a byte value.

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
  1.0      12/85    K. Gacke		initial development
  5.0      10/88    D. Hollaren		LAS 5.0 conversion

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	None.

PROJECT			LAS

ALGORITHM 
	Each character of the hex string is read and formatted into a byte
	value.  A byte value requires that the hex string be a maximum of
	two characters.  The hex string may contain digits 0 - 9, and letters
	a - f and A - F for values 10 - 15.

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>			/* C standard I/O include file       */
#include "las.h"			/* LAS include file 		     */
#include "ditto.h"			/* DITTO include file                */

void hex2byt
(
    char *string,			/* character string of hex digits    */
    unsigned char *byte_val		/* hex string converted to byte value*/
)
{
unsigned char index;			/* loop index                        */
unsigned char nmr_digit;		/* number of digits                  */
unsigned char val;			/* decimal value                     */

*byte_val = 0;
nmr_digit = strlen(string);
if (nmr_digit > 2)
   {
   ditto_error(" ",DITTO_HEXDIG,ERROR_WARN,UPDATE_FD);
   nmr_digit = 2;
   }

for (index=0;index<nmr_digit;index++)
   {
   switch(string[index])
      {
      case '0':  val =  0; break;
      case '1':  val =  1; break;
      case '2':  val =  2; break;
      case '3':  val =  3; break;
      case '4':  val =  4; break;
      case '5':  val =  5; break;
      case '6':  val =  6; break;
      case '7':  val =  7; break;
      case '8':  val =  8; break;
      case '9':  val =  9; break;
      case 'a':  val = 10; break;
      case 'A':  val = 10; break;
      case 'b':  val = 11; break;
      case 'B':  val = 11; break;
      case 'c':  val = 12; break;
      case 'C':  val = 12; break;
      case 'd':  val = 13; break;
      case 'D':  val = 13; break;
      case 'e':  val = 14; break;
      case 'E':  val = 14; break;
      case 'f':  val = 15; break;
      case 'F':  val = 15; break;
      default :  ditto_error(" ",DITTO_HEXINV,ERROR_WARN,UPDATE_FD);
		 val =  0;
		 break;
      }

   *byte_val = (*byte_val * 16) + val;
   }

}
