/******************************************************************************
FUNCTION:	OUTMSG

PURPOSE:	Prints a line to the file that is to be routed to the line
		printer, or the terminal.  

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>			/* C standard I/O include file       */
#include "las.h"			/* LAS include file 		     */
#include "util.h"           /* c_pterm prototype */
#include "ditto.h"			/* ditto include file                */

#define TERM	0			/* index for terminal		     */
#define FIL	1			/* index for file		     */
#define LP	2			/* index for line printer	     */
#define RWIDTH  80			/* Width of the report		     */

void outmsg
(
    char *msg,				/* message to be printed             */
    long *print,			/* destination of the message        */
    FILE *lp_fp 			/* file pointer to line printer      */
)
{
char	tmp[81];			/* Temporary message		     */
long	flag = 0;			/* flag to function c_pterm          */
long	back;

/*
  Print message to the line printer, specified file or user's terminal
*/
if ((print[LP]) || (print[FIL]))
    {
    if (strlen(msg) > RWIDTH-2)
	{
	back = RWIDTH - 2;
	strncpy(tmp,msg,back);
	tmp[back] = '\0';
	fprintf(lp_fp,"%s\n",tmp);
	outmsg(msg+back,print,lp_fp);
	}
    else
	fprintf(lp_fp,"%s\n",msg);
    }

if (print[TERM])
    c_pterm(msg,&flag);

return;
}
