#include "tae.h"
#include "worgen.h"
#include "desc.h"
#include "dltf.h"

#ifdef unix
/* Fortran bridge routine for the sun		*/
#ifdef _IBMR2
#define w2dltf_ w2dltf
#endif
int w2dltf_
(
    long *fd,
    char *type,
    char *key,
    double *slope,
    double *offset,
    long *startpt,
    long *endpt,
    long *lutnum,
    unsigned char *lutdata,
    long type_len,
    long key_len
)
{
long status;
char *keyptr;
char *typeptr;

keyptr  = squeeze(key,key_len);
typeptr = squeeze(type,type_len);

status = c_w2dltf(fd,typeptr,keyptr,slope,offset,startpt,endpt,
		   lutnum,lutdata);

return(status);
}
#endif

#ifdef vms
/* Fortran bridge routine for the VAX		*/
int w2dltf
(
    long *fd,
    struct DESC *type,
    struct DESC *key,
    double *slope,
    double *offset,
    long *startpt,
    long *endpt,
    long *lutnum,
    unsigned char *lutdata
)
{
long status;
char *keyptr;
char *typeptr;

keyptr  = squeeze(key->addr,key->length);
typeptr = squeeze(type->addr,type->length);

status = c_w2dltf(fd,typeptr,keyptr,slope,offset,startpt,endpt,
		   lutnum,lutdata);

return(status);
}
#endif
