/****************************************************************************
NAME:		C_CLDLTF

PURPOSE:	Closes a DLTF file.

PROGRAM HISTORY:
	By D. Akkerman, USGS/EROS Data Center, 9/88
	Modified by B. Davis, USGS/EROS Data Center, 1/91
	    - Standardized errmsg and status returns according to EDC
	       support guidelines.

PROJECT:	LAS 5.0

ALGORITHM:
	Assign the file access for a normal close.
	Close the DLTF and return.

*****************************************************************************/

#include "tae.h"
#include "worgen.h"
#include "labserv.h"
#include "dltf.h"

int c_cldltf
(
    long *fd,		/* File descriptor for the DLTF. (I)		*/
    char *host		/* Host file name of the DLTF. (I)		*/
)

{
long	one = 1,	/* Specifies a nonfatal error.			*/
	status,		/* Return status indicator.			*/
	access;		/* File access mode.				*/

/* Assign the file access for a normal close.				*/

access = 0;

/* Close the DLTF and return.						*/

status = c_lsclos(fd,host,&access);

if (status != E_SUCC)
  {
	c_errmsg("Error closing DLTF","cldltf-close",&one);
	c_errmsg("Error returned from lsclos","cldltf-call",&one);
	return(E_FAIL);
  }

return(E_SUCC);
}
