#! /usr/local/bin/perl
#
# This script parses the listing of directories under the current GDAL
# source code retrieved for synchronization with. It then makes each of those
# directories under the try for the LAS GDAL source code. If the directory
# already exists, it will still attempt to create it, but this isn't a
# problem.
###########################################################################

my $RemotDirsRef = get_dir_list("../remot_cur_gdal/");

foreach my $cur_dir (keys %$RemotDirsRef)
{
    if ($RemotDirsRef->{$cur_dir} eq "true")
    {
        open(MKDIR, "mkdir -p $cur_dir|");
        if (<MKDIR> != 0)
        {
            die "Error creating new subdirectory in LAS GDAL ".
                "structure: $cur_dir\n";
        }
        close MKDIR;
        system("cvs add $cur_dir");
    }
}

exit 0;

sub get_dir_list
{
    my $root_dir = $_[0];
    my %dirs = {};
    my $dir_path = ".";

    open(LS, "ls -pmR $root_dir|") || die "Error listing $root_dir\n";
    foreach my $ls_line (<LS>)
    {
        chomp $ls_line;
        if ($ls_line =~ /$root_dir([\w\/\.]+):$/)
        {
            $dir_path = $1;
        }
        else
        {
            my @ls_entries = split ",", $ls_line;
            foreach (@ls_entries)
            {
                $_ =~ s/\s//g;
                if ($_ =~ /\/$/)
                {
                    my $file = $dir_path . "/" . $_;
                    $dirs{$file} = "true"
                }
            }
        }
    }
    close LS;
    return \%dirs;
}
