#! /usr/local/bin/perl
#
# This script parses the directory listing file, locating those that are
# of 0 size and removing them. It also executes the "cvs rm" command to
# schedule them for removal from the repository.
###########################################################################

if ($#ARGV != 0)
{
    die "Incorrect number of params supplied to rm_zero_lngth_files.pl\n";
}

# Parse the directory listing file, removing those files that have 0 size
open (LS_FILE, "<$ARGV[0]") || die "Could not open directory listing file\n";
my $cur_dir = ".";
while (<LS_FILE>)
{
    chomp;
    my $cur_line = $_;
    if (/^$/)
    {
        # Blank line. Skip
        next;
    }
    elsif (/^total/)
    {
        # This line tells the total count of blocks(??) in the directory.
        # We are not interested in this information
        next;
    }
    elsif (/^\.\/([\w\/\.]+)\:/)
    {
        # This line is the name of the directory the next set of files
        # belong to. Save it.
        $cur_dir = $1;
    }
    else
    {
        # This line list a particular file's information. Split it up into
        # its separate components
        $_ = $cur_line;
        my ($permissions, $num_refs, $owner, $group, $size, $mon, $day, $time, $file) = split /\s+/;
        if (($size == 0) && ($cur_dir !~ /CVS/) && ($file ne "$ARGV[0]"))
        {
            my $sys_cmd = "rm $cur_dir/$file";
            system ($sys_cmd);
            my $sys_cmd = "cvs rm $cur_dir/$file";
            system ($sys_cmd);
        }
    }
}

close LS_FILE;
exit 0;
