#include <stdlib.h>
#include "tae.h"
#include "worgen.h"
#include "desc.h"
#include "geompak.h"

#ifdef unix
/*  Fortran bridge routine for the sun  */
#ifdef _IBMR2
#define decdeg_ decdeg
#endif
int decdeg_
(
    double *angle,
    char *coform,
    char *type,
    long coform_len,
    long type_len
)
{
char *coform_ptr;
char *type_ptr;
long status;

coform_ptr = squeeze(coform,coform_len);
type_ptr = squeeze(type,type_len);

status = c_decdeg(angle,coform_ptr,type_ptr);

free(coform_ptr);
free(type_ptr);

return(status);
}
#endif
#ifdef vms
/*  Fortran bridge routine for the VAX */
int decdeg
(
    double *angle,
    struct DESC *coform,
    struct DESC *type
)

{
char *coform_ptr;
char *type_ptr;
long one = 1;
long status;

coform_ptr = squeeze(coform->addr,coform->length);
type_ptr = squeeze(type->addr,type->length);

status = c_decdeg(angle,coform_ptr,type_ptr);

if (free(coform_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","decdeg-free",&one);
if (free(type_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","decdeg-free",&one);

return(status);
}
#endif
