#include <stdlib.h>
#include "tae.h"
#include "worgen.h"
#include "desc.h"
#include "geompak.h"

#ifdef unix
/*  Fortran bridge routine for sun  */
#ifdef _IBMR2
#define degdms degdms
#endif
int degdms
(
    double *deg,
    double *dms,
    char *code,
    char *check,
    long code_len,
    long check_len
)
{
char *code_ptr;
char *check_ptr;
long status;

code_ptr = squeeze(code,code_len);
check_ptr = squeeze(check,check_len);

status = c_degdms(deg,dms,code_ptr,check_ptr);

free(code_ptr);
free(check_ptr);

return(status);
}
#endif

#ifdef vms
/*  Fortran bridge routine for VAX  */
degdms(deg,dms,code,check)
double *deg;
double *dms;
struct DESC *code;
struct DESC *check;

{
char *code_ptr;
char *check_ptr;
long one = 1;
long status;

code_ptr = squeeze(code->addr,code->length);
check_ptr = squeeze(check->addr,check->length);

status = c_degdms(deg,dms,code_ptr,check_ptr);

if (free(code_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","degdms-free",&one);
if (free(check_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","degdms-free",&one);

return(status);
}
#endif
