/******************************************************************************
FUNCTION:			c_ptclse

PURPOSE:  Closes a tie point file

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
  5.0	   11/88    D. Steinwand	Original development
  5.1      07/90    D. Etrheim		Standardized error message handling

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Has to be run under TAE

PROJECT	  LAS

ALGORITHM 
	Close file
	If not successful, return an error
	Return

ALGORITHM REFERENCES	LAS 5.0 imageio routines	
*******************************************************************************/

#include "tae.h"
#include "worgen.h"
#include "ptio.h"
#include "labserv.h"
#include "geompak.h"

int c_ptclse
(
    struct PTDESC **ptdesc		/* File descriptor array */
)
{
register struct PTDESC *fd;
long action = 0;		/* Normal close */
long pass = 1;			/* Constant of 1; nonfatal error message */

fd = *ptdesc;	
if (c_lsclos(&(fd->fptr), fd->name, &action) != E_SUCC)
   {
   c_errmsg("Error closing tie point file","ptclse-close",&pass);
   free(*ptdesc);
   return(E_FAIL);
   }
free(*ptdesc);
return(E_SUCC);
}
