#!/bin/csh -f

# descend into all the directories
foreach dir (*)
    if (-d $dir) then
        # skip the CVS directory
        if ($dir == "CVS") then
            continue
        endif

        # change to the next directory
        cd $dir
        echo "Testing $dir"

        # remove the output cmp and temp files from any previous tests
        if (-e tempfile) then
            rm -f cmp* temp*
        endif

        # look for all the files that start with "parm"
        foreach parmfile (*)
            if (-f $parmfile) then
                if ("$parmfile" =~ parm*) then
                    # run the current test
                    $CMPGCTP/testproj <$parmfile >>testfile
                    if ($status) then
                       echo "ERROR in ${dir}: testproj executable returned error"
                    endif

                    # get the output file name
                    set cmpfile = `echo $parmfile | sed s/^parm/cmp/`

                    # check for errors
                    if (! -e $cmpfile) then
                        echo "ERROR in ${dir}: $cmpfile not created"
                    else if (`cat $cmpfile | wc -l` != "0") then
                        echo "Error in ${dir}: $cmpfile has failures"
                    endif
                endif
            endif
        end

        # return to the previous directory
        cd ..
    endif
end
