/****************************************************************************
NAME:           c_gofcls

PURPOSE: Close the specified graphics overlay file.

PROGRAM HISTORY:
Version         Date    Contrib         Change
-------         ----    -------         ------
 1.0            3/86    L. Huewe        Intial code
 2.0            5/92    L. Huewe        Modified to be a more generic
                                        WORLD support routine.
PROJECT: LAS

****************************************************************************/

#include <unistd.h>
#include "tae.h"
#include "worgen.h"
#include "gof.h"

int c_gofcls
(
    int *fd             /* File descriptor of the file to be closed. (I) */
)

{
    long    one;            /* Indicates a nonfatal error. */

    /* Close the specified file. */

    if (close (*fd) != 0)
    {
        c_errmsg ("Error closing GOF","gofcls-close",&one);
        return (E_FAIL);
    }
    *fd = -1;
    return(E_SUCC);
}
