/***************************************************************************
NAME:				C_EDIPS_TRL

PURPOSE:  Reads EDIPS Trailer record and puts information in ANSII file

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		DESCRIPTION
-------		----	------		-----------
  1.0		12/92	S. Nelson	Original development

***************************************************************************/
#include <stdio.h>
#include "las.h"
#include "labserv.h"
#include "edips.h"
#include "header.h"

/* Routine to read MSS EDIPS TRAILER FILE
  --------------------------------------*/
int c_edips_trl
(
    char *outh,
    struct EDIPST *trl
)

{
FILE *fptr;	/* file pointer				*/

long status;		/* return status			*/
long  mode = 0;         /* flag value for lsstat                */
long nonfatal = 1;

char finame[CMLEN];		/* Host file name			*/

unsigned char buf[3596];

/* Open trailer file
*  -----------------*/
c_lsmknm(outh,"edips_trail",finame);
  status = c_lsstat(finame,&mode);    /* make sure header file exists     */
  if (status != E_SUCC)
     {
     c_errmsg("TRL file does not exist on disk","edips_trl-stat",&nonfatal);
     return(E_FAIL);
     }

fptr=fopen(finame,"r");
if(!fptr)
   {
   c_errmsg("Error opening Trailer file","edips_trl-open",&nonfatal);
   return(E_FAIL);
   }
fread(buf,1,3596,fptr);
fclose(fptr);

/*  read binary record
   -------------------*/
trl->record_number = (long)buf[3];
trl->record_type = (long)buf[5];
trl->last_scene_data_acqu = (long)buf[6];
trl->last_scene_hdt = (long)buf[7];
trl->destriped_image = (long)buf[3589];
strncpy(trl->contrast_stretch,(char *)&buf[3590],1);
trl->contrast_stretch[1] = '\0';
trl->minimum_contrast_enh = (long)buf[3591];
trl->maximum_contrast_enh = (long)buf[3592];
trl->radiance_value_scatter = (long)buf[3593];
trl->edge_enh_kernal_size_x = (long)buf[3594];
trl->edge_enh_kernal_size_y = (long)buf[3595];

return(E_SUCC);
}		/* end of c_edips_trl */
