/***************************************************************************
NAME:				C_LTWG_FPR

PURPOSE:  Read LTWG file pointer record from a file that is passed
	  in aready opened, and put it into a structure. 

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		DESCRIPTION
-------		----	------		-----------
  6.0		 3/94   D. Bridges	Orginal Development

***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "ltwg.h"
#include "header.h"
#include "local_protos.h"

/* Routine to read LTWG FILE POINTER RECORD 
-------------------------------------------*/
int c_ltwg_fpr
(
    struct LTWGFPR *fpr,    /* OUTPUT - LTWG volume descriptor rec structure*/
    FILE *fin               /* INPUT - File pointer			*/
)
{
char buf[361];      /* buffer for LTWG tape information	*/
char tmpbuf[50]; 	/* temporary buffer storage		*/
char temp[4];
int k;

fread(buf,1,360,fin);

/*  read LTWG file pointer record
    -----------------------------*/
for(k=0; k<4; k++)
   temp[k]=buf[k];
fpr->rec_number = get_long(temp);

fpr->frst_rec_code = (long)buf[4];

fpr->rec_code = (long)buf[5];

fpr->scnd_rec_code = (long)buf[6];

fpr->thrd_rec_code = (long)buf[7];

fpr->rec_length = (long)buf[10]*256 + (long)buf[11];

strncpy(fpr->a_e_flag,&buf[12],2);
fpr->a_e_flag[2] = '\0';

strncpy(tmpbuf,&buf[16],4);
tmpbuf[4] = '\0';
fpr->num = atol(tmpbuf); 

strncpy(fpr->name,&buf[20],16);
fpr->name[16] = '\0';

strncpy(fpr->class,&buf[36],28);
fpr->class[28] = '\0';

strncpy(fpr->cl_code,&buf[64],4);
fpr->cl_code[4] = '\0';

strncpy(fpr->datatyp,&buf[68],28);
fpr->datatyp[28] = '\0';

strncpy(fpr->dt_code,&buf[96],4);
fpr->dt_code[4] = '\0';

strncpy(tmpbuf,&buf[100],8);
tmpbuf[8] = '\0';
fpr->num_rec = atol(tmpbuf);

strncpy(tmpbuf,&buf[108],8);
tmpbuf[8] = '\0';
fpr->des_rec_lth = atol(tmpbuf);

strncpy(tmpbuf,&buf[116],8);
tmpbuf[8] = '\0';
fpr->max_lth = atol(tmpbuf);

strncpy(fpr->rec_lth_typ,&buf[124],12);
fpr->rec_lth_typ[12] = '\0';

strncpy(fpr->rec_lth_code,&buf[136],4);
fpr->rec_lth_code[4] = '\0';

strncpy(tmpbuf,&buf[140],2);
tmpbuf[2] = '\0';
fpr->vol_num_start = atol(tmpbuf);

strncpy(tmpbuf,&buf[142],2);
tmpbuf[2] = '\0';
fpr->vol_num_end = atol(tmpbuf);

strncpy(tmpbuf,&buf[144],8);
tmpbuf[8] = '\0';
fpr->file_por_frst = atol(tmpbuf);

strncpy(tmpbuf,&buf[152],8);
tmpbuf[8] = '\0';
fpr->file_por_last = atol(tmpbuf);

return(E_SUCC);
}                   /* end of c_ltwg_fpr */
