/***************************************************************************
NAME:				C_LTWG_SFD

PURPOSE:  Read LTWG supplemental file descriptor record from a file that  
	  is passed in already opened, and put it into a stucture.	 

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		DESCRIPTION
-------		----	------		-----------
  6.0		 3/94   D. Bridges	Orginal Development

***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "ltwg.h"
#include "header.h"
#include "local_protos.h"

/* Routine to read LTWG SUPPLEMENTAL FILE DESCRIPTOR RECORD 
-----------------------------------------------------------*/
int c_ltwg_sfd
(
    struct LTWGSFD *sfd,    /* OUTPUT - LTWG supplemental file descriptor    */
    FILE *fin               /* INPUT - File pointer				*/
)
{

char buf[541]; /* buffer for LTWG tape information	*/
char tmpbuf[50];	/* temporary buffer storage		*/
char temp[4];
long k;

fread(buf,1,540,fin);

/*  read LTWG supplemental file descriptor record
    ---------------------------------------------*/
for(k=0;k<4;k++)
   temp[k]=buf[k];
sfd->rec_number = get_long(temp);

sfd->frst_rec_code = (long)buf[4];

sfd->rec_code = (long)buf[5];

sfd->scnd_rec_code = (long)buf[6];

sfd->thrd_rec_code = (long)buf[7];

sfd->rec_length = (long)buf[10]*256 + (long)buf[11];

strncpy(sfd->a_e_flag,&buf[12],2);
sfd->a_e_flag[2] = '\0';

strncpy(sfd->control_doc_num,&buf[16],12);
sfd->control_doc_num[12] ='\0';

strncpy(sfd->control_doc_rev,&buf[28],2);
sfd->control_doc_rev[2] ='\0';

strncpy(sfd->file_des_rev,&buf[30],2);
sfd->file_des_rev[2] ='\0';

strncpy(sfd->rel_num,&buf[32],12);
sfd->rel_num[12] ='\0';

strncpy(tmpbuf,&buf[44],4);
tmpbuf[4] = '\0';
sfd->file_num = atol(tmpbuf);

strncpy(sfd->file_name,&buf[48],15);
sfd->file_name[15] ='\0';

strncpy(sfd->record_seq,&buf[64],4);
sfd->record_seq[4] ='\0';

strncpy(tmpbuf,&buf[68],8);
tmpbuf[8] = '\0';
sfd->seq_num_loc = atol(tmpbuf);

strncpy(tmpbuf,&buf[76],4);
tmpbuf[4] = '\0';
sfd->seq_num_lgt = atol(tmpbuf);

strncpy(sfd->rec_loc_flg,&buf[80],4);
sfd->rec_loc_flg[4] ='\0';

strncpy(tmpbuf,&buf[84],8);
tmpbuf[8] = '\0';
sfd->rec_loc = atol(tmpbuf);

strncpy(tmpbuf,&buf[92],4);
tmpbuf[4] = '\0';
sfd->rec_lth = atol(tmpbuf);

strncpy(sfd->rec_lth_flg,&buf[96],4);
sfd->rec_lth_flg[4] ='\0';

strncpy(tmpbuf,&buf[100],8);
tmpbuf[8] = '\0';
sfd->rec_lth_loc = atol(tmpbuf);

strncpy(tmpbuf,&buf[108],4);
tmpbuf[4] = '\0';
sfd->rec_fld_lth = atol(tmpbuf);

strncpy(sfd->data_interp_des,&buf[112],1); 
sfd->data_interp_des[1]='\0';

strncpy(sfd->data_interp_oth,&buf[113],1);
sfd->data_interp_oth[1]='\0';

strncpy(sfd->data_disp_des,&buf[114],1); 
sfd->data_disp_des[1]='\0';

strncpy(sfd->data_disp_oth,&buf[115],1);
sfd->data_disp_oth[1]='\0';

strncpy(tmpbuf,&buf[180],6);
tmpbuf[6] = '\0';
sfd->num_header_rec = atol(tmpbuf);

strncpy(tmpbuf,&buf[186],6);
tmpbuf[6] = '\0';
sfd->lth_header_rec = atol(tmpbuf);

strncpy(tmpbuf,&buf[192],6);
tmpbuf[6] = '\0';
sfd->num_tm_house = atol(tmpbuf);

strncpy(tmpbuf,&buf[198],6);
tmpbuf[6] = '\0';
sfd->lth_tm_house = atol(tmpbuf);

strncpy(tmpbuf,&buf[204],6);
tmpbuf[6] = '\0';
sfd->num_ephemeris = atol(tmpbuf);

strncpy(tmpbuf,&buf[210],6);
tmpbuf[6] = '\0';
sfd->lth_ephemeris = atol(tmpbuf);

strncpy(tmpbuf,&buf[216],6);
tmpbuf[6] = '\0';
sfd->num_scene_def = atol(tmpbuf);

strncpy(tmpbuf,&buf[222],6);
tmpbuf[6] = '\0';
sfd->lth_scene_def = atol(tmpbuf);

strncpy(tmpbuf,&buf[228],6);
tmpbuf[6] = '\0';
sfd->num_scene_qual = atol(tmpbuf);

strncpy(tmpbuf,&buf[234],6);
tmpbuf[6] = '\0';
sfd->lth_scene_qual = atol(tmpbuf);

strncpy(tmpbuf,&buf[240],6);
tmpbuf[6] = '\0';
sfd->num_geometric_mod = atol(tmpbuf);

strncpy(tmpbuf,&buf[246],6);
tmpbuf[6] = '\0';
sfd->lth_geometric_mod = atol(tmpbuf);

strncpy(tmpbuf,&buf[252],6);
tmpbuf[6] = '\0';
sfd->num_sparse_matrix = atol(tmpbuf);

strncpy(tmpbuf,&buf[258],6);
tmpbuf[6] = '\0';
sfd->lth_sparse_matrix = atol(tmpbuf);

strncpy(tmpbuf,&buf[264],6);
tmpbuf[6] = '\0';
sfd->num_gcd_start_time = atol(tmpbuf);

strncpy(tmpbuf,&buf[270],6);
tmpbuf[6] = '\0';
sfd->lth_gcd_start_time = atol(tmpbuf);

strncpy(tmpbuf,&buf[276],6);
tmpbuf[6] = '\0';
sfd->num_across_scan = atol(tmpbuf);

strncpy(tmpbuf,&buf[282],6);
tmpbuf[6] = '\0';
sfd->lth_across_scan = atol(tmpbuf);

strncpy(tmpbuf,&buf[288],6);
tmpbuf[6] = '\0';
sfd->num_cross_scan = atol(tmpbuf);

strncpy(tmpbuf,&buf[294],6);
tmpbuf[6] = '\0';
sfd->lth_cross_scan = atol(tmpbuf);

strncpy(tmpbuf,&buf[312],6);
tmpbuf[6] = '\0';
sfd->num_mission_rec = atol(tmpbuf);

strncpy(tmpbuf,&buf[318],6);
tmpbuf[6] = '\0';
sfd->lth_mission_rec = atol(tmpbuf);

strncpy(tmpbuf,&buf[324],6);
tmpbuf[6] = '\0';
sfd->num_grnd_cont_rec = atol(tmpbuf);

strncpy(tmpbuf,&buf[330],6);
tmpbuf[6] = '\0';
sfd->lth_grnd_cont_rec = atol(tmpbuf);

strncpy(sfd->start_time_loc,&buf[336],16);
sfd->start_time_loc[16] = '\0';

strncpy(sfd->stop_time_loc,&buf[352],16);
sfd->stop_time_loc[16] = '\0';

strncpy(sfd->orbit_fld_loc,&buf[368],16);
sfd->orbit_fld_loc[16] = '\0';

return(E_SUCC);
}                   /* end of c_ltwg_lfd */
