/***************************************************************************
NAME:				C_LTWG_STR

PURPOSE:  Reads LTWG supplemental text record from a file that is passed
          in already opened, and put it into a structure.

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		DESCRIPTION
-------		----	------		-----------
  6.0		 3/94   D. Bridges	Orginal Development

***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "ltwg.h"
#include "header.h"
#include "local_protos.h"

/* Routine to read LTWG SUPPLEMENTAL TEXT RECORD 
------------------------------------------------*/
int c_ltwg_str
(
    struct LTWGSTR *str,    /* OUTPUT - LTWG supplemental text rec structure */
    FILE *fin               /* INPUT - File pointer				*/
)
{

char buf[361]; /* buffer for LTWG tape information	*/
char temp[4];
long k;


fread(buf,1,360,fin);

/*  read LTWG supplemental text record
    ----------------------------------*/
for(k=0;k<4;k++)
   temp[k]=buf[k];
str->rec_number = get_long(temp);

str->frst_rec_code = (long)buf[4];

str->rec_code = (long)buf[5];

str->scnd_rec_code = (long)buf[6];

str->thrd_rec_code = (long)buf[7];

str->rec_length = (long)buf[10]*256 + (long)buf[11];

strncpy(str->a_e_flag,&buf[12],2);
str->a_e_flag[2] = '\0';

strncpy(str->continuation_flg,&buf[14],2);
str->continuation_flg[2] = '\0';

strncpy(str->supp_file_descr,&buf[16],40);
str->supp_file_descr[40] = '\0';

strncpy(str->location_time,&buf[66],58);
str->location_time[58] = '\0';

strncpy(str->orbit_id,&buf[124],49);
str->orbit_id[49] = '\0';

strncpy(str->tape_id,&buf[173],43);
str->tape_id[43] = '\0';

return(E_SUCC);
}                   /* end of c_ltwg_str */
