/***************************************************************************
NAME:				C_LTWG_TFD

PURPOSE:  Reads LTWG trailer file descripter record from a file that is passed
          in already opened, and put it into a structure.

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		DESCRIPTION
-------		----	------		-----------
  6.0		 3/94   D. Bridges	Orginal Development

***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "ltwg.h"
#include "header.h"
#include "local_protos.h"

/* Routine to read LTWG TRAILER FILE DESCRIPTOR RECORD 
------------------------------------------------------*/
int c_ltwg_tfd
(
    struct LTWGTFD *tfd,    /* OUTPUT - LTWG trailer file des rec structure	*/
    FILE *fin               /* INPUT - File pointer				*/
)
{

char buf[4321];     /* buffer for LTWG tape information	*/
char tmpbuf[50];	/* temporary buffer storage		*/
char temp[4];
long k;

fread(buf,1,4320,fin);

/*  read LTWG trailer file descriptor record
    ----------------------------------------*/
for(k=0;k<4;k++)
   temp[k]=buf[k];
tfd->rec_number = get_long(temp);

tfd->frst_rec_code = (long)buf[4];

tfd->rec_code = (long)buf[5];

tfd->scnd_rec_code = (long)buf[6];

tfd->thrd_rec_code = (long)buf[7];

tfd->rec_length = (long)buf[10]*256 + (long)buf[11];

strncpy(tfd->a_e_flag,&buf[12],2);
tfd->a_e_flag[2] = '\0';

strncpy(tfd->control_doc_num,&buf[16],12);
tfd->control_doc_num[12] ='\0';

strncpy(tfd->control_doc_rev,&buf[28],2);
tfd->control_doc_rev[2] ='\0';

strncpy(tfd->file_des_rev,&buf[30],2);
tfd->file_des_rev[2] ='\0';

strncpy(tfd->rel_num,&buf[32],12);
tfd->rel_num[12] ='\0';

strncpy(tmpbuf,&buf[44],4);
tmpbuf[4] = '\0';
tfd->file_num = atol(tmpbuf);

strncpy(tfd->file_name,&buf[48],15);
tfd->file_name[15] ='\0';

strncpy(tfd->record_seq,&buf[64],4);
tfd->record_seq[4] ='\0';

strncpy(tmpbuf,&buf[68],8);
tmpbuf[8] = '\0';
tfd->seq_num_loc = atol(tmpbuf);

strncpy(tmpbuf,&buf[76],4);
tmpbuf[4] = '\0';
tfd->seq_num_lgt = atol(tmpbuf);

strncpy(tfd->rec_loc_flg,&buf[80],4);
tfd->rec_loc_flg[4] ='\0';

strncpy(tmpbuf,&buf[84],8);
tmpbuf[8] = '\0';
tfd->rec_loc = atol(tmpbuf);

strncpy(tmpbuf,&buf[92],4);
tmpbuf[4] = '\0';
tfd->rec_lth = atol(tmpbuf);

strncpy(tfd->rec_lth_flg,&buf[96],4);
tfd->rec_lth_flg[4] ='\0';

strncpy(tmpbuf,&buf[100],8);
tmpbuf[8] = '\0';
tfd->rec_lth_loc = atol(tmpbuf);

strncpy(tmpbuf,&buf[108],4);
tmpbuf[4] = '\0';
tfd->rec_fld_lth = atol(tmpbuf);

strncpy(tfd->data_interp_des,&buf[112],1);
tfd->data_interp_des[1]='\0';

strncpy(tfd->data_interp_oth,&buf[113],1);
tfd->data_interp_oth[1]='\0';

strncpy(tfd->data_disp_des,&buf[114],1);
tfd->data_disp_des[1]='\0';

strncpy(tfd->data_disp_oth,&buf[115],1);
tfd->data_disp_oth[1]='\0';

strncpy(tmpbuf,&buf[181],6);
tmpbuf[6] = '\0';
tfd->num_trailer = atol(tmpbuf);

strncpy(tmpbuf,&buf[187],6);
tmpbuf[6] = '\0';
tfd->lth_trailer = atol(tmpbuf);

strncpy(tfd->parity_count_loc,&buf[216],16);
tfd->parity_count_loc[16] = '\0';

strncpy(tfd->quality_code_loc,&buf[232],16);
tfd->quality_code_loc[16] = '\0';

return(E_SUCC);
}                   /* end of c_ltwg_tfd */
