/***************************************************************************
NAME:				C_LTWG_TRIV

PURPOSE:  Read LTWG text record - imagery volume from a file that is passed
	  in already opened, and put it into a stucture.	 

PROGRAM HISTORY:
VERSION		DATE	AUTHOR		DESCRIPTION
-------		----	------		-----------
  6.0		 3/94   D. Bridges	Orginal Development

***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "ltwg.h"
#include "header.h"
#include "local_protos.h"

/* Routine to read LTWG TEXT RECORD - IMAGERY VOLUME
----------------------------------------------------*/
int c_ltwg_triv
(
    struct LTWGTRIV *triv, /* OUTPUT - LTWG volume descriptor rec structure */
    FILE *fin              /* INPUT - File pointer				*/
)
{

char buf[361];      /* buffer for LTWG tape information	*/
char temp[4];
long k;

fread(buf,1,360,fin);

/*  read LTWG text record - imagery volume
    --------------------------------------*/
for(k=0;k<4;k++)
   temp[k]=buf[k];
triv->rec_number = get_long(temp);

triv->frst_rec_code = (long)buf[4];

triv->rec_code = (long)buf[5];

triv->scnd_rec_code = (long)buf[6];

triv->thrd_rec_code = (long)buf[7];

triv->rec_length = (long)buf[10]*256 + (long)buf[11];

strncpy(triv->a_e_flag,&buf[12],2);
triv->a_e_flag[2] = '\0';

strncpy(triv->cont_flag,&buf[14],2);
triv->cont_flag[2] = '\0';

strncpy(triv->product_type,&buf[16],50);
triv->product_type[50] = '\0';

strncpy(triv->loc_and_date,&buf[66],58);
triv->loc_and_date[58] = '\0';

strncpy(triv->in_scene_id,&buf[124],49);
triv->in_scene_id[49] = '\0';

strncpy(triv->tape_id,&buf[173],43);
triv->tape_id[43] = '\0';

strncpy(triv->wrs_id,&buf[216],28);
triv->wrs_id[28] = '\0';

strncpy(triv->level_cor,&buf[244],23);
triv->level_cor[23] = '\0';

return(E_SUCC);
}                   /* end of c_ltwg_triv */
