/************************************
*  Common includes and definitions  *
************************************/
#include <stdio.h>
#include "tae.h"
#include "worgen.h"
#include "labserv.h"
#include "fhdr.h"
#include "header.h"

/*******************************************************************************
FUNCTION:	c_open_header	

PURPOSE: 	To read or write the header file if it exits.	

HISTORY:

VERSION  PROGRAMMER       DATE   CODE  REASON
-------  ---------------  -----  ----  -----------------------------------------
1.0	 T. Mittan	 11/92	 LAs	Original development.

ALGORITHM REFERENCES	none
*******************************************************************************/
int c_open_header
(
    char *buf,                  /* header buffer                        */
    char *name,			/* image name				*/
    long *flag			/* flag to determine read or write acc	*/
)
{
   FILE *fp;			/* file pointer				*/
   
   long status;			/* return status			*/
   char hostheader[CMLEN];	/* header name				*/
   long mode = 0;		/* flag value for lsstat		*/
   long one = 1;		/* constant value of one		*/
   
   if (*flag == IREAD)
   {
      c_lsmknm(name,"fhdr",hostheader);  /* make associated header file name */
      status = c_lsstat(hostheader,&mode);/* make sure header file exists    */
      if (status != E_SUCC)
      {
	 c_errmsg("FHDR file does not exist on disk","informational",&one);
	 c_errmsg("Creating a template FHDR","informational",&one);
	 template_header(buf);
	 return(E_SUCC);
      }
      
      fp = (fopen(hostheader,"r"));
      status = (long)fread(buf,1,HEADER_SIZE,fp);
      fclose(fp);
      if (status != HEADER_SIZE)
      {
	 c_errmsg("Error reading header","open_header-read",&one);
	 return(E_FAIL);
      }
   }
   else if (*flag == IWRITE)
   {
      c_lsmknm(name,"fhdr",hostheader);/* make associated header file name */
      fp = (fopen(hostheader,"w"));
      status = (long)fwrite(buf,1,HEADER_SIZE,fp);
      fclose(fp);
      if (status != HEADER_SIZE)
      {
	 c_errmsg("Error writing header","open_header-write",&one);
	 return(E_FAIL);
      }
   }
   return(E_SUCC);
}
