/************************************
*  Common includes and definitions  *
************************************/
#include <stdio.h>
#include "las.h"
#include "tipsp.h"
#include "labserv.h"
#include "header.h"

#define  HEADER_SIZE 4320 

/*******************************************************************************
FUNCTION:	c_read_trail	

PURPOSE: 	To read the trailer file and fill the TIPSP structure.	

HISTORY:

VERSION  PROGRAMMER       DATE   CODE  REASON
-------  ---------------  -----  ----  -----------------------------------------
1.0	 T. Mittan	 12/92	 LAS	Original development.

ALGORITHM REFERENCES	none
*******************************************************************************/
int c_read_trail
(
    struct TIPSP *tipsp,		/* TIPSP sturcture declaration		*/
    char *name          		/* image name				*/
)
{
   FILE *fp;			/* file pointer				*/

   long  status;		/* return status			*/
   long  mode = 0;		/* flag value for lsstat		*/
   long  one = 1;		/* constant value of one		*/

   char  buf[HEADER_SIZE];      /* header buffer                        */
   char  hostheader[CMLEN];	/* header name				*/

  c_lsmknm(name,"tipsp_trail",hostheader);/* make associated header file name */
  status = c_lsstat(hostheader,&mode);    /* make sure header file exists     */
  if (status != E_SUCC)
     {
     c_errmsg("TRA file does not exist on disk","read_trail-stat",&one);
     return(E_FAIL);
     }
  /* use data from trailer data record
  ---------------------------------------*/
  fp = (fopen(hostheader,"r"));
  if(!fp)
   {
   c_errmsg("Error opening Trailer file","read_trail-open",&one);
   return(E_FAIL);
   }

  fread(buf,1,HEADER_SIZE,fp);

  strncpy(tipsp->trail_number_scan_lines,&buf[4120],4);
  tipsp->trail_number_scan_lines[4] = '\0';
  strncpy(tipsp->trail_quality_indicator_summary,&buf[4124],20);
  tipsp->trail_quality_indicator_summary[20] = '\0';
  strncpy(tipsp->trail_number_major_sync_losses,&buf[4144],4);
  tipsp->trail_number_major_sync_losses[4] = '\0';
  strncpy(tipsp->trail_number_minor_sync_losses,&buf[4148],4);
  tipsp->trail_number_minor_sync_losses[4] = '\0';
  strncpy(tipsp->trail_number_minor_sync_errors,&buf[4152],4);
  tipsp->trail_number_minor_sync_errors[4] = '\0';
  strncpy(tipsp->trail_number_bit_slips,&buf[4156],4);
  tipsp->trail_number_bit_slips[4] = '\0';
  strncpy(tipsp->trail_number_time_code_substitutions,&buf[4160],4);
  tipsp->trail_number_time_code_substitutions[4] = '\0';
  strncpy(tipsp->trail_quality_summary,&buf[4164],156);
  tipsp->trail_quality_summary[156] = '\0';

return(E_SUCC);
}
