/*******************************************************************************
FUNCTION:       get_tick

PURPOSE:        To convert 2 binary bits into line or sample location.

HISTORY:

VERSION  PROGRAMMER       DATE   CODE  REASON
-------  ---------------  -----  ----  -----------------------------------------
1.0      T. Mittan       12/92   LAS    Original development.

ALGORITHM REFERENCES    none
*******************************************************************************/
#include "las.h"

float get_tick
(
    char *var,			/* input array				*/
    long nbytes			/* number of bytes in array		*/
)
{
long number_of_bits;		/* number of bits			*/
long bit;			/* bit value				*/
long i;				/* array value				*/
long j;				/* array value				*/
long input_data;		/* input of data			*/
long sign;			/* sign bit1				*/

float power_of_two;		/* power of two to the i		*/
float temp = 0.0;		/* temporary floating variable		*/


i = 1;
number_of_bits = nbytes * 8;
input_data = 0;
input_data  |= ((unsigned long) var[0]);
input_data  &= 65535;
bit = (input_data >> (15));
if (bit == 1)
   {
   sign = -1;
   i = 2;
   }
else
   sign = 1;
input_data <<= 1;
input_data  &= 65535;
temp = 0;

for (; i <=number_of_bits; i++)
    {
    bit = (input_data >> (15));
    input_data <<= 1;
    input_data  &= 65535;
    if (bit == 1)
       {
       power_of_two = 1;
       for (j = 0; j < i; j++)
           power_of_two = power_of_two * .5;
       temp += power_of_two;
       }
    }

temp *= (float) sign;


return (temp);
}

