/************************************
*  Common includes and definitions  *
************************************/
#include <stdio.h>
#include <string.h>
#include "worgen.h"
#include "fhdr.h"

/******************************************************************************
FUNCTION:	template	

PURPOSE: 	Creates a template header file to be placed on disk.

HISTORY:

VERSION  PROGRAMMER       DATE   CODE  REASON
-------  ---------------  -----  ----  ----------------------------------------
1.0	 T. Mittan	  11/92	 LAS	Original development

ALGORITHM REFERENCES	none
******************************************************************************/
void template_header
(
    char *buf                  /* header buffer                        */
)
{
   
   long i;	             /* counter in for loop                  */
   
   /* fill in header file with headings
      ----------------------------------*/
   for (i = 0; i < HEADER_SIZE; i++)
     buf[i] = ' ';
   
   strncpy(buf,"PRODUCT =",9);
   strncpy(&buf[20]," WRS =",6);
   strncpy(&buf[35]," ACQUISITION DATE =",19); 
   strncpy(&buf[62]," SATELLITE =",12);
   strncpy(&buf[76]," INSTRUMENT =",13);
   strncpy(&buf[93]," PRODUCT TYPE =",15);
   strncpy(&buf[122]," PRODUCT SIZE =",15);
   strncpy(&buf[225]," TYPE OF GEODETIC PROCESSING =",30);
   strncpy(&buf[265]," RESAMPLING =",13);
   strncpy(&buf[280]," RAD GAINS/BIASES = ",20);
   strncpy(&buf[418]," TAPE SPANNING FLAG=",20);
   strncpy(&buf[441]," START LINE #=",14);
   strncpy(&buf[460]," LINES PER VOL=",15);
   strncpy(&buf[480]," ORIENTATION =",14);
   strncpy(&buf[500]," PROJECTION =",13);
   strncpy(&buf[517]," USGS PROJECTION # =",20); 
   strncpy(&buf[543]," USGS MAP ZONE =",16);
   strncpy(&buf[565]," USGS PROJECTION PARAMETERS =",29);
   strncpy(&buf[954]," EARTH ELLIPSOID =",18);
   strncpy(&buf[992]," SEMI-MAJOR AXIS =",18);
   strncpy(&buf[1021]," SEMI-MINOR AXIS =",18);
   strncpy(&buf[1050]," PIXEL SIZE =",13);
   strncpy(&buf[1068]," PIXELS PER LINE=",17);
   strncpy(&buf[1090]," LINES PER IMAGE=",17);
   strncpy(&buf[1112]," UL ",4);
   strncpy(&buf[1170]," UR ",4);
   strncpy(&buf[1228]," LR ",4);
   strncpy(&buf[1286]," LL ",4);
   strncpy(&buf[1344]," BANDS PRESENT =",16);
   strncpy(&buf[1367]," BLOCKING FACTOR =",18);
   strncpy(&buf[1389]," RECORD LENGTH =",16);
   strncpy(&buf[1410]," SUN ELEVATION =",16);
   strncpy(&buf[1428]," SUN AZIMUTH =",14);
   strncpy(&buf[1445]," CENTER ",8);
   strncpy(&buf[1519]," OFFSET=",8);
   strncpy(&buf[1531]," REV",4);
   strncpy(&buf[1535],"B",1);	/* revision type */
   
}
