#include "las.h"
#include "fdesc.h"

#ifdef unix
/* Fortran bridge routine for the UNIX  */
#ifdef _IBMR2
#define eopenr_ eopenr
#endif
int eopenr_(fdesc,fname,bands,sl,ss,nl,ns,acc,dtype,opt,maxline,fname_len)

        struct FDESC **fdesc;
        char *fname;
        long bands[];
        long *nl,*ns,*sl,*ss;
        long *acc,*dtype;
        long opt[];
        long *maxline;
        long fname_len;
{
long status;
char *fname_ptr;

fname_ptr = squeeze(fname,fname_len);

status = c_eopenr(fdesc,fname_ptr,bands,sl,ss,nl,ns,acc,dtype,opt,maxline);

free(fname_ptr);

return(status);
}
#endif

#ifdef vms
/* Fortran bridge routine for the VAX  */
int eopenr(fdesc,fname,bands,sl,ss,nl,ns,acc,dtype,opt,maxline)

        struct FDESC **fdesc;
        struct DESC *fname;
        long bands[];
        long *nl,*ns,*sl,*ss;
        long *acc,*dtype;
        long opt[];
        long *maxline;
{
long nonfatal = 1;
long status;
char *fname_ptr;

fname_ptr = squeeze(fname->addr,fname->length);

status = c_eopenr(fdesc,fname_ptr,bands,sl,ss,nl,ns,acc,dtype,opt,maxline);

if (free(fname_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","eopenr-free",&nonfatal);

return(status);
}
#endif
