#include "las.h"
#include "desc.h"

#ifdef unix
/*  Fortran bridge routine for the UNIX  */
#ifdef _IBMR2
#define eopens_ eopens
#endif
int eopens_(fdesc,fname,bands,sl,ss,nl,ns,offset,acc,dtype,nbuf,opt
                ,fname_len)

        struct FDESC **fdesc;
        char *fname;
        long bands[];
        long *nl,*ns,*sl,*ss;
        long offset[];
        long *acc,*dtype,*nbuf;
        long opt[];
        long fname_len;
{
        long status;
        char *fname_ptr;

        fname_ptr = squeeze(fname,fname_len);

        status = c_eopens(fdesc,fname_ptr,bands,sl,ss,nl,ns,offset,acc,
                        dtype,nbuf,opt);

        free(fname_ptr);

        return(status);
}
#endif

#ifdef vms
/*  Fortran bridge routine for the VAX  */
int eopens(fdesc,fname,bands,sl,ss,nl,ns,offset,acc,dtype,nbuf,opt)

        struct FDESC **fdesc;
        struct DESC *fname;
        long bands[];
        long *nl,*ns,*sl,*ss;
        long offset[];
        long *acc,*dtype,*nbuf;
        long opt[];
{
        long nonfatal = 1;
        long status;
        char *fname_ptr;

        fname_ptr = squeeze(fname->addr,fname->length);

        status = c_eopens(fdesc,fname_ptr,bands,sl,ss,nl,ns,offset,acc,
                        dtype,nbuf,opt);

        if (free(fname_ptr) == -1)
           c_errmsg("Error freeing dynamic memory","eopens-free",&nonfatal);

        return(status);
}
#endif
