#ifndef LOCAL_PROTOS_H
#define LOCAL_PROTOS_H

#include "fdesc.h" 

int allocate_buffer
(
    struct FDESC *fd,  /* I/O: a file descriptor (see fdesc.h) */
    struct GDESC *gd   /* I/O: a group descriptor (see fdesc.h) */
);

int check_window
(
    struct FDESC *fd,  /* I: file descriptor */
    struct DDR *ddr    /* I: ddr structure */
);

void encode_76
(
   unsigned char  *inpt,  /* I: input buffer */
   unsigned char  *outpt, /* O: output buffer */
   long ns,               /* I: number of samples */
   long *point,           /* O: array pointer */
   long width             /* I: data type width of each sample */
);

void decode_76
(
   unsigned char  *inpt,  /* I: input buffer */
   unsigned char  *outpt, /* O: output buffer */
   long ns,               /* I: number of samples */
   long width             /* I: number of bytes per sample */
);

int process_it
(
    struct FDESC *fd,  /*  I/O: file descriptor */
    long cline,        /*  I: current line */
    long cband,        /*  I: current band */
    struct GDESC *gd   /*  I: group descrptor */
);

int do_open
(
    struct FDESC *fd /* I/O: file descriptor */
);

int open_img
(
    struct FDESC **fdesc,
    char    host[],
    long    openflg,
    long    *bands,
    long    ssrw,
    long    nlrw,
    long    nsrw,
    long    nlbuf,
    long    access,
    long    *dtype,
    long    wtype
);

#endif
