#include "las.h"
#include "desc.h"
#include "labserv.h"

#ifdef unix
/*  Fortran bridge routine for unix  */
#ifdef _IBMR2
#define lsmknm_ lsmknm
#endif
void lsmknm_
(
        char    *inname,
        char    *ext,
        char    *outname,
        long    in_len,
        long    ext_len,
        long    out_len
)
{

char *in_ptr;
char *ext_ptr;

in_ptr = squeeze(inname,in_len);
ext_ptr = squeeze(ext,ext_len);

c_lsmknm(in_ptr,ext_ptr,outname);

free(in_ptr);
free(ext_ptr);

}
#endif

#ifdef vms
/*  Fortran bridge routine for VAX  */
void lsmknm
(
    struct DESC *inname,
    struct DESC *ext,
    struct DESC *outname
)
{

char *in_ptr;
char *ext_ptr;
long nonfatal = 1;

in_ptr = squeeze(inname->addr,inname->length);
ext_ptr = squeeze(ext->addr,ext->length);

c_lsmknm(in_ptr,ext_ptr,outname->addr);

if (free(in_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","lsmknm-free",&nonfatal);

if (free(ext_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","lsmknm-free",&nonfatal);

}
#endif
