#include "tae.h"
#include "worgen.h"
#include "desc.h"
#include "labserv.h"

#ifdef unix
/* Fortran bridge routine for unix  */
#ifdef _IBMR2
#define lsstat_ lsstat
#endif
int lsstat_
(
   char         *hostname,
   long         *mode,
   long         hostname_len
)
{
char *hname_ptr;
long status;

hname_ptr = squeeze(hostname,hostname_len);

status = c_lsstat(hname_ptr,mode);

free(hname_ptr);

return(status);
}
#endif

#ifdef vms
/* Fortran bridge routine for VAX  */
int lsstat
(
    struct DESC *hostname,
    long *mode
)
{
char *hname_ptr;
long nonfatal = 1;
long status;

hname_ptr = squeeze(hostname->addr,hostname->length);

status = c_lsstat(hname_ptr,mode);

if (free(hname_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","lsstat-free",&nonfatal);

return(status);
}
#endif
