/******************************************************************************
NAME:   

FUNCTION:       Bridge routines for the LT calls

PROGRAM HISTORY:
  Version  Date   Author       Request
  -------  ----   ------       -------
    1      12/86  K. Gacke      original development
    2       4/87  K. Gacke      called squeeze routine for the file type and 
                                file description in the foptab routine when 
                                opening for write access.
    3       5/87  K. Gacke      added bridge routines for Unix
    4       7/87  K. Gacke      changed the calls malloc and free to xalloc and 
                                xree for the sel.  These routines are the C run 
                                time routines renamed and put into the las.a
                                library to avoid linking the malloc and free in 
                                the fortran libraries.
    5       8/87  K. Gacke      added the DATE and TIME data types.  Created the
                                routines fgdate, fgtime, fpdate, and fptime.
    6       9/87  K. Gacke      removed mod for "version 4" after installing
                                new OS (UTX 2.0)
    7      12/87  B. Ailts      Change include file directory specifications
    8      05/88  B. Ailts      Places brigde routines in a seperate file
                                Replaced las.h with worgen.h
                                Standardized err messages

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:  none.

PROJECT:        LAS

NAME:   

FUNCTION:       Bridge routines for the LT calls

PROGRAM HISTORY:
  Version  Date   Author       Request
  -------  ----   ------       -------
    1      12/86  K. Gacke      original development
    2       4/87  K. Gacke      called squeeze routine for the file type and 
                                file description in the foptab routine when 
                                opening for write access.
    3       5/87  K. Gacke      added bridge routines for Unix
    4       7/87  K. Gacke      changed the calls malloc and free to xalloc and 
                                xree for the sel.  These routines are the C run 
                                time routines renamed and put into the las.a
                                library to avoid linking the malloc and free in 
                                the fortran libraries.
    5       8/87  K. Gacke      added the DATE and TIME data types.  Created the
                                routines fgdate, fgtime, fpdate, and fptime.
    6       9/87  K. Gacke      removed mod for "version 4" after installing
                                new OS (UTX 2.0)
    7      12/87  B. Ailts      Change include file directory specifications
    8      05/88  B. Ailts      Places brigde routines in a seperate file
                                Replaced las.h with worgen.h
                                Standardized err messages

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:  none.

PROJECT:        LAS

******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "worgen.h"
#include "desc.h"
#include "ltable.h"
#include "local_protos.h"

void fgvec
(
    struct TAB_DEF **fd,
    int *max_field,
    int *ncol,
    struct DESC *label,
    int dtype[],
    struct DESC *desc,
    int size[][2],
    struct VECTOR *rec[]
)
{
    struct TAB_DEF *tab;
    struct VECTOR *vec;
    int nfield;
    char *label_ptr, *desc_ptr;

    tab = (struct TAB_DEF *) *fd;
    get_vector(tab);
    *ncol = tab->ncol;
    vec = tab->vector;
    if (*ncol > *max_field)
    {
        tab_error(tab,TAB_FORTRAN_MAXFLD,FATAL,"","fgvec");
        return;
    }

    label_ptr = label->addr;
    desc_ptr = desc->addr;

    for (nfield=0; vec!=NULL; vec=vec->next,nfield++)
    {
        rec[nfield] = vec;
        strcpy(label_ptr,vec->label);
        dtype[nfield] = vec->dtype;
        strcpy(desc_ptr,vec->desc);
        size[nfield][0] = vec->lt_size.nrow;
        size[nfield][1] = vec->lt_size.ncol;
        label_ptr += label->length;
        desc_ptr += desc->length;
    }

}

void fgvec_
(
    struct TAB_DEF **fd,
    int *max_field,
    int *ncol,
    char *label,
    int dtype[],
    char *desc,
    int size[][2],
    struct VECTOR *rec[],
    int label_len,
    int desc_len
)
{
    struct DESC dlabel,ddesc;

    dlabel.addr = label;
    dlabel.length = label_len;
    ddesc.addr = desc;
    ddesc.length = desc_len;
    fgvec(fd,max_field,ncol,&dlabel,dtype,&ddesc,size,rec);
}
