#include <string.h>
#include "tae.h"
#include "worgen.h"
#include "ltable.h"

/******************************************************************************
NAME:	

FUNCTION:	Bridge routines for the LT calls

PROGRAM HISTORY:
  Version  Date   Author       Request
  -------  ----	  ------       -------
    1      12/86  K. Gacke     	original development
    2       4/87  K. Gacke     	called squeeze routine for the file type and 
				file description in the foptab routine when 
				opening for write access.
    3       5/87  K. Gacke     	added bridge routines for Unix
    4	    7/87  K. Gacke	changed the calls malloc and free to xalloc and 
				xree for the sel.  These routines are the C run 
				time routines renamed and put into the las.a
				library to avoid linking the malloc and free in 
				the fortran libraries.
    5	    8/87  K. Gacke	added the DATE and TIME data types.  Created the
				routines fgdate, fgtime, fpdate, and fptime.
    6       9/87  K. Gacke	removed mod for "version 4" after installing
				new OS (UTX 2.0)
    7      12/87  B. Ailts      Change include file directory specifications
    8      05/88  B. Ailts	Places brigde routines in a seperate file
				Replaced las.h with worgen.h
				Standardized err messages

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	none.

PROJECT:	LAS

******************************************************************************/
void fmklt
(
    struct DESC *innam,
    struct DESC *outnam,
    int *nmr
)
{
    char *in_name;
    char *out_name;

    in_name = squeeze(innam->addr,innam->length);
    out_name = make_lt_name(in_name,*nmr);
    strcpy(outnam->addr,out_name);
    free(in_name);
    free(out_name);
}

void fmklt_
(
    char *innam,
    char *outnam,
    int *nmr,
    int innam_len,
    int outnam_len
)
{
    struct DESC dinnam;
    struct DESC doutnam;

    dinnam.addr = innam;
    dinnam.length = innam_len;
    doutnam.addr = outnam;
    doutnam.length = outnam_len;
    fmklt(&dinnam,&doutnam,nmr);
}
