/******************************************************************************
NAME:   

FUNCTION:       Bridge routines for the LT calls

PROGRAM HISTORY:
  Version  Date   Author       Request
  -------  ----   ------       -------
    1      12/86  K. Gacke      original development
    2       4/87  K. Gacke      called squeeze routine for the file type and 
                                file description in the foptab routine when 
                                opening for write access.
    3       5/87  K. Gacke      added bridge routines for Unix
    4       7/87  K. Gacke      changed the calls malloc and free to xalloc and 
                                xree for the sel.  These routines are the C run 
                                time routines renamed and put into the las.a
                                library to avoid linking the malloc and free in 
                                the fortran libraries.
    5       8/87  K. Gacke      added the DATE and TIME data types.  Created the
                                routines fgdate, fgtime, fpdate, and fptime.
    6       9/87  K. Gacke      removed mod for "version 4" after installing
                                new OS (UTX 2.0)
    7      12/87  B. Ailts      Change include file directory specifications
    8      05/88  B. Ailts      Places brigde routines in a seperate file
                                Replaced las.h with worgen.h
                                Standardized err messages

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:  none.

PROJECT:        LAS

******************************************************************************/
#include <stdio.h>
#include "tae.h"
#include "worgen.h"
#include "ltable.h"
#include "desc.h"

void fpvec
(
    struct TAB_DEF **fd,
    int *ncol,
    struct DESC *label,
    int dtype[],
    struct DESC *desc,
    int size[][2],
    struct VECTOR *rec[]
)
{
    struct TAB_DEF *tab;
    struct VECTOR *vec;
    int index;
    char *desc_ptr;
    char *desc_val;
    char *label_ptr;
    char *label_val;
    char sep;

    tab = (struct TAB_DEF *) *fd;
    label_ptr = label->addr;
    desc_ptr = desc->addr;
    for (index=0; index<*ncol; index++)
    {
        if (index + 1 == *ncol)
            sep = RECORD_SEP;
        else
            sep = FIELD_SEP2;
        label_val = squeeze(label_ptr,label->length);
       desc_val = squeeze(desc_ptr,desc->length);
       put_vector(tab,label_val,dtype[index],desc_val,size[index][0],
                  size[index][1],sep);
       label_ptr += label->length;
       desc_ptr += desc->length;
    }
    for (index=0,vec=tab->vector; vec!=NULL; index++,vec=vec->next)
        rec[index] = vec;
}

void fpvec_
(
    struct TAB_DEF **fd,
    int *ncol,
    char *label,
    int dtype[],
    char *desc,
    int size[][2],
    struct VECTOR *rec[],
    int label_len,
    int desc_len
)
{
    struct DESC dlabel,ddesc;

    dlabel.addr = label;
    dlabel.length = label_len;
    ddesc.addr = desc;
    ddesc.length = desc_len;
    fpvec(fd,ncol,&dlabel,dtype,&ddesc,size,rec);
}
