#ifndef LOCAL_PROTOS_H
#define LOCAL_PROTOS_H


#define TAB_LT_OPEN             -1
#define TAB_LT_ACCESS           -2
#define TAB_LT_READ             -3
#define TAB_LT_WRITE            -4
#define TAB_LT_CLOSE            -5
#define TAB_LT_MATRIX_SIZE      -6
#define TAB_LT_FORMAT           -7
#define TAB_LT_DTYPE            -8
#define TAB_LT_EOR              -9
#define TAB_LT_NOEOR            -10
#define TAB_FORTRAN_MAXFLD      -11
#define TAB_ALLOC               -12

#define TAB_LT_SEEK             -13
#define TAB_LT_FTYPE            -14
#define TAB_LT_SUBFIL           -15
#define TAB_LT_PUTVEC           -16
#define TAB_LT_GETDATE          -17
#define TAB_LT_GETTIME          -18



#define FSEP1   0              /* Field separator 1 for FORTRAN programs   */
#define FSEP2   1              /* Field separator 2 for FORTRAN programs   */


void tab_error
(
    const struct TAB_DEF *tab,
    int err_code,
    long severity,
    char msg[],
    char key[]
);

void read_tab
(
    struct TAB_DEF *tab        /*I/O: Struct defining LT file to process   */
);
 
void put_lt_date
(
    struct VECTOR *vec,        /* I/O: Structure defining field            */
    const struct LT_DATE *date /* I: Date to be written to the LT          */
);
 
void put_lt_time
(
    struct VECTOR *vec,        /* I/O: Structure defining  field           */
    const struct LT_TIME *tim  /* I: Time to be written to the LT file     */
);


void get_i4_field
(
    struct TAB_DEF *tab,       /* I/O: LT to be processed                  */
    int *val,                  /* O: Int value read from LT I/O buffer     */
    int *null,                 /* O: Null flag:                            */
    int *eor                   /* O: End of record flag                    */
                               /*    TRUE: field terminated by record sep  */
                               /*    FALSE: field terminated by field sep  */
);

char *get_string_field
(
    struct TAB_DEF *tab,       /* I/O:: Defines the LT structure           */
    int *eor                   /* O: End of record flag                    */
                               /*    True: field terminated by record sep  */ 
);                             /*    False: field terminated by field sep  */

#endif

