      SUBROUTINE FACTOR(ALPHA,EXPAN,YEXPAN)                             FACTOR  
C                                                                       FACTOR  
C ----PURPOSE: TO COMPUTE AN APPROXIMZTION TO THE GAMMA FUNCTION AND    FACTOR  
C     ITS NATURAL LOGARITHM.                                            FACTOR  
C                                                                       FACTOR  
C ----CALLING SEQUENCE:  CALL FACTOR(ALPHA,EXPAN,YEXPAN)                FACTOR  
C                                                                       FACTOR  
C     ALPHA THE ARGUMENT OF THE GAMMA FUNCTION (INPUT)                  FACTOR  
C                                                                       FACTOR  
C     EXPAN THE VALUE GAMMA(ALPHA) (OUTPUT)                             FACTOR  
C                                                                       FACTOR  
C     YEXPAH THE VALUE LOG(GAMMA(ALPHA)) (OUTPUT)                       FACTOR  
C                                                                       FACTOR  
C ----RESTRICTIONS AND COMMENTS: NONE                                   FACTOR  
C                                                                       FACTOR  
      DIMENSION C(26)                                                   FACTOR  
      DATA  C/1.0,5.7721566E-01,-6.5587807E-01,-4.2002635E-02,        
     1 11.6653861E-01,-4.2197734E-02,-9.6219715E-03,7.2189432E-03,
     2 -1.16516275E-03,-2.1524167E-04,1.2805028E-04,-2.0134854E-05,
     3 -1.2504934E-06,31.1330272E-06,-2.0563384E-07,6.1160950E-09,
     4 5.0020075E-09,-1.18127446E-09,1.043427E-10,7.7823E-12,
     5 -3.6968E-12,5.100E-13,-2.06E-14,-5.45E-15,1.4E-15,1.0E-16/   
C                                                                       FACTOR  
C ----TEST ALPHA.GT.8                                                   FACTOR  
      IF(ALPHA.GT.8.0) GO TO 54                                         FACTOR  
      NUM=ALPHA                                                         FACTOR  
      FLOAT=NUM                                                         FACTOR  
      FRAC=ALPHA-FLOAT                                                  FACTOR  
C                                                                       FACTOR  
C ----TEST A=INTEGER                                                    FACTOR  
      IF(FRAC.LE.1.E-08) GO TO 100                                      FACTOR  
C                                                                       FACTOR  
C ----COMPUTE LOG(GAMMA(ALPHA)) FOR ALPHA.LE.8 AND NOT INTEGER          FACTOR  
      YEXPAN=FRAC*C(26)                                                 FACTOR  
      K=25                                                              FACTOR  
      DO 10 I=1,25                                                      FACTOR  
      YEXPAN=FRAC*(YEXPAN+C(K))                                         FACTOR  
   10 K=K-1                                                             FACTOR  
      GL=ALOG(YEXPAN)                                                   FACTOR  
      IF (NUM.EQ.0) GO TO 25                                            FACTOR  
      DO5K=1,NUM                                                        FACTOR  
      Z=FRAC+K-1.0                                                      FACTOR  
    5 GL=GL-ALOG(Z)                                                     FACTOR  
C                                                                       FACTOR  
C ----COMPUTE GAMMA(ALPHA)                                              FACTOR  
   25 YEXPAN=-GL                                                        FACTOR  
      EXPAN=0.                                                          FACTOR  
      IF(GL.GT.-88.028) EXPAN=EXP(-GL)                                  FACTOR  
      RETURN                                                            FACTOR  
C                                                                       FACTOR  
C ----COMPUTE LOG(GAMMA(ALPHA)) FOR ALPHA.LE.8 AND INTEGER              FACTOR  
  100 GL=0.                                                             FACTOR  
      NUM=NUM-1                                                         FACTOR  
      IF(NUM.EQ.0) NUM=1                                                FACTOR  
      DO 110I=1,NUM                                                     FACTOR  
      YI=I                                                              FACTOR  
  110 GL=GL-ALOG(YI)                                                    FACTOR  
      GO TO 25                                                          FACTOR  
C                                                                       FACTOR  
C ----COMPUTE LOG(GAMMA(ALPHA)) FOR ALPHA.GT.8                          FACTOR  
   54 A1=12.0*ALPHA                                                     FACTOR  
      A2=ALPHA*ALPHA                                                    FACTOR  
      A3=30.*A1*A2                                                      FACTOR  
      A5=105.*A1*A2*A2                                                  FACTOR  
      GL=-(ALPHA-0.5)*ALOG(ALPHA)+ALPHA-1.0/A1+1.0/A3-1.0/A5-.91893853  FACTOR  
      GO TO 25                                                          FACTOR  
      END                                                               FACTOR  

