#include "worgen.h"
#include "lasmath.h"

/*
************************************************************************
                                                                       
     Computes the inverse value of a modification of students
     T-distribution 
                                                                       
     p     Input probability in the exclusive range (0,1). 
           (Sum of the (equal) areas in both the tails of
           the T-distribution)

     N     Degrees of freedom

     x     Output, Output value such that the probability
           of the absolute value of T being greater than
           x is p.
                                                                       
     Calls STUDIN in MATHPAC
        - needs STUDIS, PHINV, FACTOR, ERFF from MATHPAC
K. A. Narayanan
November 1988

************************************************************************
*/

void mdsti
(
    float *q,
    long *f,
    float *x
)
{
#ifdef vms
float studin ();
float v;

v = (*q)/2.0;
*x = -(studin (f, &v));
#endif

#ifdef unix
#ifdef _IBMR2
#define studin_ studin
#endif
float studin_ ();
float v;

v = (*q)/2.0;
*x = -(studin_ (f, &v));
#endif

#ifdef ultrix
{
float studin_ ();
float v;

v = (*q)/2.0;
*x = -(studin_ (f, &v));
}
#endif

}
