	subroutine mulfs (a, b, l, m, ja, c, jc)

	real a(ja, 1), b(1), c(jc, 1)
	integer ja, jc, l, m
c
c	real	a,   /* matrix a                     */
c		b,   /* symmetric matrix b stored in */
c                    /* symmetric storage mode       */
c		c    /* product matrix c             */
c
c	integer ja,   /* row dimension of a          */
c		jc,   /* row dimension of c          */
c		l,    /* no. rows in a               */
c		m     /* no. columns in a            */
c********************************************************************
c
cPURPOSE: performs matrix multiplication c = ab where a is a full matrix
c         and b is a symmetric matrix stored in symmetric storage mode
c
c         Note: c should not occupy the same locations as a or b
c
cPROGRAM HISTORY:
c   Author           Date
c   ------           ----
c   K. A. Narayanan  Sept. 29, 1988
c
c*******************************************************************
	integer	row, col, ind, p
c
	do 100 row = 1, l
	   do 100 col = 1, m
	      c(row, col) = 0
	      do 100 ind = 1, m
	         if (ind .ge. col) then
		    p =  (ind-1)*ind/2 + col
		 else
		    p =  (col-1)*col/2 + ind
		 end if
	         c(row, col) = c(row, col) + a(row, ind) * b(p)
100	continue
	return
	end

