	subroutine mulsf (a, n, b, m, jb, c, jc)

	real a(1), b(jb, 1), c(jc, 1)
	integer jb, jc, m, n
c
c	real	a,   /* matrix a                     */
c		b,   /* symmetric matrix b stored in */
c                    /* symmetric storage mode       */
c		c    /* product matrix c             */
c
c	integer jb,   /* row dimension of b          */
c		jc,   /* row dimension of c          */
c		n,    /* order of a and no. rows in b*/
c		m     /* no. columns in b            */
c********************************************************************
c
cPURPOSE: performs matrix multiplication c = ab where a is a full matrix
c         and b is a symmetric matrix stored in symmetric storage mode
c
c         Note: c should not occupy the same locations as a or b
c
cPROGRAM HISTORY:
c   Author           Date
c   ------           ----
c   K. A. Narayanan  Sept. 29, 1988
c   K. A. Narayanan  July  18, 1989    Corrected indexing for ind
c
c*******************************************************************
	integer	row, col, ind, p
c
	do 100 row = 1, n
	   do 100 col = 1, m
	      c(row, col) = 0
	      do 100 ind = 1, n
	         if (ind .ge. row) then
		    p =  (ind-1)*ind/2 + row
		 else
		    p =  (row-1)*row/2 + ind
		 end if
	         c(row, col) = c(row, col) + a(p) * b(ind, col)
100	continue
	return
	end

