      FUNCTION PHINV( PP )                                              PHINV   
C******CHANGES     - K. A. NARAYANAN   NOVEMBER 1988
C******ARGUMENT (P) IS BEING CHANGED BY PROGRAM AND SO A NEW
C******VARIABLE PP IS USED.
C******ON ERROR PHINV WAS ASSIGNED (1.0E+20)**2 WHICH GAVE ARITHMETIC
C******FAULT. CHANGED TO 1.7E+38
C                                                                       PHINV   
C ----PURPOSE:  TO COMPUTE THE INVERSE OF THE STANDARD NORMAL CUMULATIVEPHINV   
C     DISTRIBUTION FUNCTION (MEAN 0, VARIANCE 1)                        PHINV   
C                                                                       PHINV   
C ----CALLING SEQUENCE:  VARIABLE=PHINV(P)                              PHINV   
C     P     THE PROBABILITY FOR WHICH THE INVERSE                       PHINV   
C           IS TO BE CALCULATED (INPUT)                                 PHINV   
C                                                                       PHINV   
C -----RESTRICTIONS AND COMMENTS:  THE SUBPROGRAM ERFF(PHI)             PHINV   
C     IS REQUIRED                                                       PHINV   
C                                                                       PHINV   
      p = pp
C ----TEST P                                                            PHINV   
      IF (P.GT.0.0. AND.P.LT.1.0) GO TO 5                               PHINV   
      IF (P.EQ.1.0) PHINV=1.0E+38                                       PHINV   
      IF(P.EQ.0.0) PHINV=-1.0E+38                                       PHINV   
C                                                                       PHINV   
C ----ERROR IF P NOT BETWEEN ZERO AND ONE                               PHINV   
      IF(P.LT.0.0.OR.P.GT.1.0) PHINV=1.7E38                             PHINV   
      RETURN                                                            PHINV   
C                                                                       PHINV   
C ----SET FLAG:  X POSITIVE                                             PHINV   
C     WHEN K=1, NEGATIVE                                                PHINV   
C     WHEN K=2.                                                         PHINV   
    5 K = 1                                                             PHINV   
      IF(P .GT. 0.5)GO TO 47                                            PHINV   
C                                                                       PHINV   
C ----COMPUTE FIRST APPROXIMATION, EQUATION 26.2.23, PAGE 933,          PHINV   
C     ABRAMOWITZ AND STEGUN                                             PHINV   
    8 T3=SQRT(-2.0*ALOG(P))                                             PHINV   
      T4P=2.515517+.802853*T3+.010328*T3*T3                             PHINV   
      T5P=1.0+1.432788*T3+.189269*T3*T3+.001308*T3*T3*T3                PHINV   
      XT=T3-T4P/T5P                                                     PHINV   
      XT=-XT                                                            PHINV   
C                                                                       PHINV   
C ----NEWTON RHAPSON                                                    PHINV   
C     ITERATION                                                         PHINV   
   13 DO 53 I=1,100                                                     PHINV   
      PHP = EXP(-0.5*XT*XT)                                             PHINV   
      PT = PHI (XT)                                                     PHINV   
      IF(ABS(P-PT) .LT. P*4.0E-8)GO TO 99                               PHINV   
      Z = (P-PT)*2.50662827 / PHP                                       PHINV   
      XT = XT + Z                                                       PHINV   
   53 CONTINUE                                                          PHINV   
      GO TO 99                                                          PHINV   
   47  P = 1.0 - P                                                      PHINV   
      K = 2                                                             PHINV   
      GO TO 8                                                           PHINV   
C                                                                       PHINV   
C ----ASSIGN SIGN                                                       PHINV   
C     + OR - TO X.                                                      PHINV   
   99 GO TO (26,27),K                                                   PHINV   
   26 PHINV = XT                                                        PHINV   
      RETURN                                                            PHINV   
   27 PHINV = -XT                                                       PHINV   
      P = 1.0 - P                                                       PHINV   
      RETURN                                                            PHINV   
      END                                                               PHINV   

