#include "lasmath.h"

/*
************************************************************************
Sorts a long array ra[1...n] in ascending order.
   - Note: Pass the address of ra[-1] if values are in ra[0...n-1].

Copied from Numerical Recipes
K. A. Narayanan
November 1989
************************************************************************
*/

void sort
(
    int n,
    long ra[]
)
{
int	l, j, ir, i;
long	rra;

l=(n >> 1)+1;
ir=n;

for (;;)
   {
   if (l > 1)
      rra = ra[--l];
   else
      {
      rra = ra[ir];
      ra[ir] = ra[1];
      if (--ir == 1)
         {
         ra[1] = rra;
         return;
         }
      }
   i = l;
   j = l << 1;
   while (j <= ir)
      {
      if (j < ir && ra[j] < ra[j+1]) ++j;
      if (rra < ra[j])
         {
         ra[i] = ra[j];
         j += (i=j);
         }
      else j = ir+1;
      }
   ra[i] = rra;
   }
}
