      FUNCTION STUDIN(N,P)                                              STUDIN  
C                                                                       STUDIN  
C ----PURPOSE:  TO COMPUTE THE INVERSE VALUE OF STUDENTS                STUDIN  
C     T-DISTRIBUTION GIVEN THE DEGREES OF FREEDOM AND                   STUDIN  
C     THE LEVEL OF SIGNIFICANCE.                                        STUDIN  
C                                                                       STUDIN  
C ----CALLING SEQUENCE:  VARIABLE=STUDIN(N,P)                           STUDIN  
C                                                                       STUDIN  
C     N     THE DEGREES OF FREEDOM                                      STUDIN  
C                                                                       STUDIN  
C     P     THE LEVEL OF SIGNIFICANCE                                   STUDIN  
C                                                                       STUDIN  
C ----RESTRICTIONS AND COMMENTS:  THE SUBPROGRAMS PHINV, FACTOR, AND    STUDIN  
C     STUDIS ARE REQUIRED.  STUDIN COMPUTES T TO THREE DIGIT            STUDIN  
C     ACCURACY.                                                         STUDIN  
C                                                                       STUDIN  
C ----INITIALIZATION                                                    STUDIN  
      EPS=1.0E-4                                                        STUDIN  
      XN=N                                                              STUDIN  
C                                                                       STUDIN  
C ----COMPUTE COEFFICIENT                                               STUDIN  
      ALF=(XN+1.0)/2                                                    STUDIN  
      CALL FACTOR(ALF,XPAN,VOID)                                        STUDIN  
      YALF=XN/2.0                                                       STUDIN  
      CALL FACTOR(YALF,YEXPAN,VOID)                                     STUDIN  
      YPAN=1.0/YEXPAN                                                   STUDIN  
      FAC=SQRT(XN*3.141592 )                                            STUDIN  
      COEF=XPAN*YPAN/FAC                                                STUDIN  
C                                                                       STUDIN  
C ----FIRST APPROXIMATION                                               STUDIN  
      T=PHINV(P)                                                        STUDIN  
C                                                                       STUDIN  
C ----NEWTON-RHAPSON ITERATIONS                                         STUDIN  
      DO 26 I=1,25                                                      STUDIN  
      BASE=(1.0+T*T/XN)**(-ALF)                                         STUDIN  
      VARI=COEF*BASE                                                    STUDIN  
      VAR=STUDIS(N,T)                                                   STUDIN  
      DELTA=(P-VAR)/VARI                                                STUDIN  
      T=T+DELTA                                                         STUDIN  
      IF(ABS(DELTA)-EPS)16,16,26                                        STUDIN  
   26 CONTINUE                                                          STUDIN  
   16 STUDIN=T                                                          STUDIN  
      RETURN                                                            STUDIN  
      END                                                               STUDIN  

