       FUNCTION STUDIS(N,T)                                             STUDIS  
C                                                                       STUIDS  
C ----PURPOSE: TO COMPUTE AN APPROXIMATION TO THE CUMMULATIVE DISTRIBU- STUDIS  
C     TION FUNCTION OF STUDENT'S T-DISTRIBUTION                         STUDIS  
C                                                                       STUDIS  
C ----CALLING SEQUENCE: VAR=STUDIS(N,T)                                 STUDIS  
C                                                                       STUDIS  
C     N     THE DEGREES OF FREEDOM,N.GE.1  (INPUT)                      STUDIS  
C                                                                       STUDIS  
C     T     THE VALUE AT WHICH THE CUMULATIVE PROBABILITY IS DESIRED    STUDIS  
C           (INPUT)                                                     STUDIS  
C                                                                       STUDIS  
C    STUDIS THE VALUE OF THE FUNCTION (OUTPUT)                          STUDIS  
C                                                                       STUDIS  
C ----RESTRICTIONS AND COMMENTS;  FOR LARGE N USE NORMAL APPROX-        STUDIS  
C     MATIONS                                                           STUDIS  
C                                                                       STUDIS  
C ----INITIALIZATION                                                    STUDIS  
C                                                                       STUDIS  
       AN=N                                                             STUDIS  
       TH=ATAN(T/SQRT(AN))                                              STUDIS  
C                                                                       STUDIS  
C ----TESTN = 1                                                         STUDIS  
C                                                                       STUDIS  
       W=COS(TH)                                                        STUDIS  
       A=W*W                                                            STUDIS  
      IF(N.EQ.1) GOTO 60                                                STUDIS  
      J=N-2                                                             STUDIS  
C                                                                       STUDIS  
C ----TEST N EVEN                                                       STUDIS  
C                                                                       STUDIS  
      IF (MOD(N,2).EQ.0) GOTO13                                         SUTDIS  
C                                                                       STUDIS  
C ----COMPUTE EXPAN FOR N ODD AND N.GE.3                                STUDIS  
C                                                                       STUDIS  
       SU=W                                                             STUDIS  
      IF (N.EQ.3) GOTO 11                                               STUDIS  
       R=0.                                                             STUDIS  
       V=1.                                                             STUDIS  
       DO 10 I=3,J,2                                                    STUDIS  
       R=R+2.0                                                          STUDIS  
       V=V+2.0                                                          STUDIS  
       W=W*(R/V)*A                                                      STUDIS  
       SU=SU+W                                                          STUDIS  
   10 CONTINUE                                                          STUDIS  
   11 A=2./3.1415927*(TH+SIN(TH)*SU)                                    STUDIS  
       GOTO 50                                                          STUDIS  
C                                                                       STUDIS  
C ----COMPUTE STUDIS FOR EVEN                                           STUDIS  
C                                                                       STUDIS  
   13  W=1.                                                             STUDIS  
       SU=1.                                                            STUDIS  
      IF (N.EQ.2) GOTO 40                                               STUDIS  
       R=-1.                                                            STUDIS  
       V=0.                                                             STUDIS  
       DO 20 I=2,J,2                                                    STUDIS  
       R=R+2.                                                           STUDIS  
       V=V+2.                                                           STUDIS  
       W=W*R/V*A                                                        STUDIS  
       SU=W+SU                                                          STUDIS  
   20  CONTINUE                                                         STUDIS  
   40  A=SIN(TH)*SU                                                     STUDIS  
       GOTO 50                                                          STUDIS  
   60 A=2./3.1415927*TH                                                 STUDIS  
C                                                                       STUDIS  
C ----CHANGE FROM PR(ABS(X).LE.T) TO PR(X.LE.T)                         STUDIS  
C                                                                       STUDIS  
   50  CONTINUE                                                         STUDIS  
      A=0.5*A+0.5                                                       STUDIS  
      STUDIS=A                                                          STUDIS  
       RETURN                                                           STUDIS  
       END                                                              STUDIS  

