#include <math.h>
#include "lasmath.h"

/*
********************************************************************

PURPOSE: computes maximum absolute value of the elements of a vector
         or a subset of the vector


PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Nov. 4, 1988

*******************************************************************
*/

void vabmxf
(
    float v[],             /* input,  vector                          */
    long *length,         /* input, length of the subset vector      */
    long *inc,            /* input, increment between successive     */
    long *index,          /* output, index of the element having the */
    float *vmax           /* output,maximum abs value                */
)
{
float	val;
register long i, j;

*vmax = 0.0;
*index = 0;
for (i = 0, j = 0; i < *length; i++, j += *inc)
   if ((val = fabs ((double) v[j])) > *vmax)
      {
      *vmax = val;
      *index = j;
      }
(*index)++;
}
