#include <math.h>
#include "lasmath.h"

/*
********************************************************************

PURPOSE: computes the sum of the absolute value of the elements of a 
         vector or a subset of the vector


PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Nov. 4, 1988

*******************************************************************
*/

void vabsmf
(
    float v[],             /* input,  vector                          */
    long *length,         /* input, length of the subset vector      */
    long *inc,            /* input, increment between successive     */
    float *vsum           /* output, sum of abs values               */
)
{
register long i, j;

*vsum = 0.0;
for (i = 0, j = 0; i < *length; i++, j += *inc)
   *vsum += fabs ((double) v[j]);
}
