#include "lasmath.h"

/*
********************************************************************

PURPOSE: computes inner product c = x . y

         c = x[0]y[0] + x[ix]y[iy] + .... + x[n*ix]y[n*iy]

PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Sept. 29, 1988

*******************************************************************
*/

void viprff
(
    float x[],   /* vector a                        */
    float y[],   /* vector y                        */
    long *n,    /* no. of elements in x or y       */
    long *ix,   /* increment between elements of x */
    long *iy,   /* increment between elements of y */
    float *c    /* inner product c                 */
)
{
register long	i, j, k;

for (i = 0, j = 0, k = 0, *c = 0.0; i < *n; i++)
   {
   *c += x[j] * y[k];
   j += *ix; k += *iy;
   }
}
