#include "worgen.h"
#include "lasmath.h"

/*
********************************************************************
                                              T
PURPOSE: performs matrix multiplication c = ab

         Note: c should not occupy the same locations as a or b.
               Matrices must be stored Fortran way, i.e., in
               coulmn major order; they have to be transposed
               when calling from C programs.

PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Sept. 29, 1988

*******************************************************************
*/

void vmulfp
(
    float a[],   /* matrix a                     */
    float b[],   /* matrix b                     */
    long *l,    /* no. rows in a                */
    long *m,    /* no. columns in a             */
    long *n,    /* no. columns in b             */
    long *ja,   /* row dimension of a           */
    long *jb,   /* row dimension of b           */
    float c[],   /* product matrix c             */
    long *jc   /* row dimension of c           */
)
{
/*
Call the corresponding Fortran routine
*/
#ifdef unix
#ifdef _IBMR2
#define mulfp_ mulfp
#endif
mulfp_ (a, b, l, m, n, ja, jb, c, jc);
#endif

#ifdef ultrix
mulfp_ (a, b, l, m, n, ja, jb, c, jc);
#endif

#ifdef vms
mulfp (a, b, l, m, n, ja, jb, c, jc);
#endif

}
