#include "worgen.h"
#include "lasmath.h"

/*
********************************************************************

PURPOSE: performs matrix multiplication c = ab where a is a full matrix
         and b is a symmetric matrix stored in symmetric storage mode

         Note: c should not occupy the same locations as a or b

PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Sept. 29, 1988

*******************************************************************
*/

void vmulfs
(
    float a[],   /* matrix a                     */
    float b[],   /* symmetric matrix b stored in */
    long *l,    /* no. rows in a                */
    long *m,    /* no. columns in a             */
    long *ja,   /* row dimension of a           */
    float c[],   /* product matrix c             */
    long *jc   /* row dimension of c           */
)
{
/*
Call the corresponding Fortran routine
*/
#ifdef unix
#ifdef _IBMR2
#define mulfs_ mulfs
#endif
mulfs_ (a, b, l, m, ja, c, jc);
#endif

#ifdef ultrix
mulfs_ (a, b, l, m, ja, c, jc);
#endif

#ifdef vms
mulfs (a, b, l, m, ja, c, jc);
#endif

}
