#include "worgen.h"
#include "lasmath.h"

/*
********************************************************************

PURPOSE: performs matrix multiplication c = ab where a is a symmetric 
         matrix stored in symmetric storage mode and b is a full matrix

         Note: c should not occupy the same locations as a or b

PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Jan. 13, 1989

*******************************************************************
*/

void vmulsf
(
    float a[],   /* symmetric matrix a stored in */
    long *n,    /* order of a and no. rows in b */
    float b[],   /* matrix b                     */
    long *m,    /* no. columns in b             */
    long *jb,   /* row dimension of b           */
    float c[],   /* product matrix c             */
    long *jc   /* row dimension of c           */
)
{
/*
Call the corresponding Fortran routine
*/
#ifdef unix
#ifdef _IBMR2
#define mulsf_ mulsf
#endif
mulsf_ (a, n, b, m, jb, c, jc);
#endif

#ifdef ultrix
mulsf_ (a, n, b, m, jb, c, jc);
#endif

#ifdef vms
mulsf (a, n, b, m, jb, c, jc);
#endif

}
