#include "worgen.h"
#include "lasmath.h"

/*
********************************************************************

PURPOSE: performs matrix multiplication c = ab where a
         and b are symmetric matrices stored in symmetric storage mode

         Note: c should not occupy the same locations as a or b

PROGRAM HISTORY:
   Author           Date
   ------           ----
   K. A. Narayanan  Jan. 12, 1989

*******************************************************************
*/

void vmulss
(
    float a[],   /* matrix a in symmetric storage mode */
    float b[],   /* matrix b in symmetric storage mode */
    long *n,    /* order of a and b             */
    float c[],   /* product matrix c             */
    long *jc   /* row dimension of c           */
)
{
/*
Call the corresponding Fortran routine
*/
#ifdef unix
#ifdef _IBMR2
#define mulss_ mulss
#endif
mulss_ (a, b, n, c, jc);
#endif

#ifdef ultrix
mulss_ (a, b, n, c, jc);
#endif

#ifdef vms
mulss (a, b, n, c, jc);
#endif
}
