/*****************************************************************************
FUNCTION:	C_GETSVAL

PURPOSE:	Search a list of parameter specifications for a parameter
		name and return the values in a string.

Version  Date	Programmer	Modifications
-------  -----	---------------	---------------------------------------------
  1.0    02/98	D.Lloyd		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under unix

PROJECT:	ADAPS
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "notae.h"
#include "worgen.h" /* E_SUCC/E_FAIL definition */


int c_getsval
(
    char *name,		/* parameter name to search for		*/
    char list[][CMLEN],	/* list of parameter specifications	*/
    char *value		/* parameter value(s)			*/
)

{
char	*ptr;		/* pointer to beginning of value string	*/

long	i = 0;		/* index of parameter in list		*/
unsigned int len;		/* length of parameter name		*/

len = strlen( name );
while ( list[i][0] != NULL )
    {
    if ( strncmp( name, list[i], len ) == NULL )
	{
	ptr = list[i] + len + 1;
	if ( strncmp( ptr, "--", 2 ) == 0 )
	    value[0] = 0;
	else
	    strcpy( value, ptr );
	return E_SUCC;
	}
    i++;
    }

return E_FAIL;
}
