/*****************************************************************************
FUNCTION:	CKECK_NAME

PURPOSE:	Check that a string matches one of the names in a list.
		Partial matches, as long as they are unique, are also counted.
		The full matching name is returned.


Version  Date	Programmer	Modifications
-------  -----	---------------	---------------------------------------------
  1.0    02/98	D.Lloyd		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under TAE

PROJECT:	ADAPS
*****************************************************************************/
#include <string.h>
#include <ctype.h>
#include "notae.h"
#include "worgen.h" /* E_SUCC/E_FAIL definition */



int check_name
(
    char *str,		/* IN: string to test for match		*/
    char *list[],	/* IN: list of strings for comparison	*/
    long numlist,	/* IN: number of strings in list	*/
    char *name		/* OUT: full matching name from list	*/
)

{
long	iname;		/* index of matching list name		*/
long	i;		/* loop index variable			*/
unsigned int len;		/* length of string to test for a match	*/
long	match = 0;	/* count of matching names in list	*/

/*
  Get the length of the test string and convert to lower case
*/
len = strlen( str );
for ( i = 0; i < len; i++ )
    str[i] = tolower( str[i] );

/*
  Look for matches in the list
*/
for ( i = 0; i < numlist; i++ )
    if ( strncmp( list[i], str, len ) == 0 )
	{
	match++;
	iname = i;
	}  /* END if */

/*
  Only one match is allowed
*/
if ( match != 1 )
    return E_FAIL;

/*
  Copy the full matching name
*/
else
    strcpy( name, list[iname] );

return E_SUCC;

}  /* END check_name */

