/*****************************************************************************
FUNCTION:	CHECK_TYPE

PURPOSE:	Check that parameter values in list[][] match the allowed
		type for the parameter.

Version  Date	Programmer	Modifications
-------  -----	---------------	---------------------------------------------
  1.0    02/98	D.Lloyd		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Run under unix

PROJECT:	ADAPS
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "tae.h"
#include "notae.h"
#include "getargv.h"
#include "worgen.h" /* E_SUCC/E_FAIL definition */


int check_type
(
    struct PARAMETER *parms,	/* IN: parameter structure		*/
    char list[][CMLEN],		/* IN: list of parsed parameters	*/
    long numparm		/* number of parameters			*/
)

{
char	*err;			/* pointer to indicate bad long value	*/
char	msg[CMLEN];		/* error message string			*/
char	*ptr;			/* string pointer			*/

float	floatval;		/* floating point value			*/

long	i,j;			/* loop indes variables			*/
long	len;			/* length of parameter name		*/
long	numlist;		/* number of parameter specifications	*/


numlist = 0;
while ( list[numlist++][0] != NULL );
numlist--;


for ( i = 1; i < numlist; i++ )
    {
    /* determine length of parameter name */
    len = 0;
    while ( list[i][len++] != '=' );
    len--;

    /* find matching name in parms */
    j = 0;
    while ( strncmp( list[i], parms->plist[j++], len ));
    j--;

    /* find parameter value */
    ptr = strchr( list[i], '=' );
    ptr++;

    /* check that the parameter value matches parameter type */
    switch ( parms->ptype[j] )
	{
	case  INTEGER :
	    strtol( ptr, &err, 10 );
	    if ( err == ptr )
		{
		sprintf(msg,"Invalid type for parameter: %s",parms->plist[j]);
		c_lasmsg(FALSE,"check_type-invalid",msg);
		return E_FAIL;
		}
	    break;

	case  FLOAT :
	    if ( sscanf( ptr, "%f", &floatval ) == 0 )
		{
		sprintf(msg,"Invalid type for parameter: %s",parms->plist[j]);
		c_lasmsg(FALSE,"check_type-invalid",msg);
		return E_FAIL;
		}
	    break;
	    
	}

    }

return E_SUCC;
}


