#include <stdio.h>
#include <math.h>
#include "las.h"
#include "statio.h"

/*
**************************************************************************

NAME: EGVORDER

FUNCTION: Arranges eigenvalues and eigenvectors in descending order

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  2.0         01/11/88  K. A. Narayanan
  1.0         06/15/85  S. Kondal

**************************************************************************
*/

void egvorder
(
    float d[],
    float *z[],
    long m,
    long n
)
{

float	p;
long	i, ii, j, k;

for (ii = 1; ii < m; ii++)
   {
   i = ii - 1;
   k = i;
   p = d[i];

   for (j = ii; j < m; j++)
      {
      if (d[j] > p)
         {
          k = j;
          p = d[j];
          }
      }

/*
   interchange eigen values i and k and corresponding eigen vectors
   ----------------------------------------------------------------
*/
   if (k !=  i) 
      {
      d[k] = d[i];
      d[i] = p;

      for (j = 0; j < n; j++)
         {
         p = z[j][i];
         z[j][i] = z[j][k];
         z[j][k] = p;
         }
      }
   }
}
