#include <stdio.h>
#include <math.h>
#include "las.h"
#include "statio.h"


/*
**************************************************************************

NAME: MATMUL

FUNCTION: Multiplies two matrices 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         06/15/85  S. Kondal
  2.0         01/11/88  K. A. Narayanan
   2.1	    	07/90	   D. VanderZee		Standardized error handling


**************************************************************************
*/

void matmul
(
    float *a[],
    float *b[],
    float *c[],
    long m,
    long n
)
{
float	*w;
float	temp;

long fatal_err = -1;
long i, j, k;

if ((w = (float *) malloc (m*n*sizeof (float))) == NULL)
   c_errmsg ("Error allocating dynamic memory", "matmul-alloc", &fatal_err);

for (i = 0; i < m; i++)
   {
   for (k = 0; k < n; k++)
      {
      temp = 0.0;
      for (j =0; j < n; j++)
         {
         temp += a[i][j] * b[j][k];
         }
      w[i*n+k] = temp;
      }
   }

for (i = 0; i < m; i++)
   for (j = 0; j < n; j++)
      c[i][j] = w[i*n+j];

free (w);
}
