#include <math.h>
#include "las.h"
#include "statio.h"


/*
**************************************************************************

NAME: MATRANS

FUNCTION: Transposes  a matrix 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
  1.0         06/15/85  S. Kondal
  2.0         01/11/88  K. A. Narayanan
   2.1	    	07/90	   D. VanderZee		Standardized error handling


**************************************************************************
*/

void matrans
(
    float *a[],
    float *b[],
    long m,
    long n
)
{
float	*ta, *tap;

long fatal_err = -1;
long i, j;

if ((ta = (float *) malloc (m*n*sizeof(float))) == NULL)
   c_errmsg ("Error allocating dynamic memory", "matrans-alloc", &fatal_err);

tap = ta;

for (i = 0; i < m; i++)
   for (j = 0; j < n; j++)
      *(tap++) = a[j][i];

tap = ta;
for (i = 0; i < m ; i++)
   for (j = 0; j < n; j++)
      b[i][j] = *(tap++);

free (ta);
}
