#include <stdlib.h>

#ifdef linux
#include "worgen.h"
#else
#include "las.h"
#endif

#include "tapeio.h"
#include "desc.h"

#ifdef unix
/*  Fortran bridge routine for the UNIX  */
int tpreop_
(
	long *unit,
	long *skip,
	long *mode,
	long *opt1,
	char *dens,
	long *inout,
	char *tapename,
	long denlen,
	long hidlen
)
{
long status;
char *tname_ptr;

tname_ptr = squeeze(tapename,hidlen);

status = c_tpreop(unit, skip, mode, opt1, dens, inout,tname_ptr);
	
free(tname_ptr);

return(status);
}
#endif
#ifdef vms
/*  Fortran bridge routine for the VAX  */
int tpreop
(
    long *unit,
    long *skip,
    long *mode,
    long *opt1,
    struct DESC *dens,
    long *inout,
    struct DESC *tapename
)
{
long one = 1;
long status;
char *tname_ptr;

tname_ptr = squeeze(tapename->addr,tapename->length);

status = c_tpreop(unit, skip, mode, opt1, dens->addr, inout,tname_ptr);
	
if (free(tname_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","tapeio-free",&one);

return(status);
}
#endif
