/**************************************************************************
*    Function:	canwrit
*
*	Purpose:	See if a specified tape drive is mounted for write. 
*			(Write ring on tape.)  
*
*
   Program History:
   version	Date	Contrib		Change
   -------	----	-------		------
    1.0                                 Original development
    2.0         12/87   F. Irani/SAR    Add qiow call to sense tape mode on
                                        unsuccessful read.  If status = EOT 
					return (TAPE_EOT)
    2.1         12/87   B. Ailts        Change include directory specifications
                                        Placed bridge routines in a seperate 
					file. Added 'c_' to function name
    2.2         6/89    K.Gacke         Port to SUN 4
    2.3         7/90    K.Gacke         output system error code on error condition
    3.0		1/91	K.Gacke		tape config file
    3.1		3/91	K.Gacke		Add Silicon Graphics
*
*	COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
*		none
*
*	PROJECT: LAS
*
*	ALGORITHM DESCRIPTION:
* 	Call SYS$GETDVI to determine whether a specified tape drive 
*       is hardware write locked.  Return TRUE (mounted for write).
*       or FALSE (no write ring).  This routine is VMS specific.
*	New TAPEIO function created for the LAS V4.0 release.  
*	(Modified version of istape.c)
*
*	ALGORITHM REFERENCES:
*
******************************************************************************/
#ifdef vms
#include <stdio.h>
#include <dvidef.h>
#include <dcdef.h>
#include <ssdef.h>

#include "worgen.h"
#include "desc.h"
#include "tapeio.h"

int canwrit
(
    char devnam_buf[]		/* Device name to check                       */
)
{
globalvalue	MT$M_HWL;       /* External constant for writelock check      
                                   from mtdef.mar			      */
long		wlocked,	/* Hardware write-lock status		      */
		istat,		/* System service status                      */
	        ret_length;	/* Length of system service returned data     */
struct  DESC	devnam;		/* String structure for device name           */
struct  ITMLST			/* Item list for system service request       */
   {
        short	bufl,
		itmcode;
        long	*badr,
		*rlenadr,
		null;
   } itmlst;

/* Set up string descriptor.
----------------------------*/
devnam.addr   = devnam_buf;
devnam.type   = TYPE_STRING ;
devnam.class  = CLASS_ARRAY ;
devnam.length = strlen (devnam_buf);

/* Set up item list.
-----------------*/
wlocked = 0;
itmlst.bufl    = 4;
itmlst.itmcode = DVI$_DEVDEPEND;
itmlst.badr    = &wlocked;
itmlst.rlenadr = &ret_length;
itmlst.null    = 0;

/* Call system service routine to check device class.
-----------------------------------------------------*/
istat = sys$getdviw (0, 0, &devnam, &itmlst, 0, 0, 0, 0);

/* Return tape drive write capability status: TRUE or FALSE.
------------------------------------------------------------*/
return (!(wlocked & MT$M_HWL));
}
#endif
