/**************************************************************************
*    Function:	getlogical
*
*    Purpose:	
*
   Program History:
   version	Date	Contrib		Change
   -------	----	-------		------
    1.0                                 Original development
    2.0         12/87   F. Irani/SAR    Add qiow call to sense tape mode on
                                        unsuccessful read.  If status = EOT 
					return (TAPE_EOT)
    2.1         12/87   B. Ailts        Change include directory specifications
                                        Placed bridge routines in a seperate 
					file. Added 'c_' to function name
    2.2         6/89    K.Gacke         Port to SUN 4
    2.3         7/90    K.Gacke         output system error code on error condition
    3.0		1/91	K.Gacke		tape config file
    3.1		3/91	K.Gacke		Add Silicon Graphics
*
*	COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
*		none
*
*	PROJECT: LAS
*
*	ALGORITHM DESCRIPTION:
*	Set up the logical arguments
*	Retreive the logical value
*
*	ALGORITHM REFERENCES:
*
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef vms
#include <iodef.h>
#include <lnmdef.h>
#include <ssdef.h>

#include "worgen.h"
#include "desc.h"
#include "tapeio.h"

#define BUFSZ 512

int get_logical
(
    char *lognam,		/*  logical name			*/
    char *logval		/*  logical value			*/
)
{
struct DESC lname;
struct DESC tname;
struct
   {
   short buflen;
   short code;
   char  *addr;
   short *len;
   long  end;
   } itmlist;
long attr;
long status;
short return_len;
char  val[256];

attr = LNM$M_CASE_BLIND;
tname.class = lname.class = CLASS_ARRAY;
tname.type = lname.type = TYPE_STRING;
tname.addr = "LNM$PROCESS_TABLE";
tname.length = strlen(tname.addr);
lname.addr = lognam;
lname.length = strlen(lname.addr);
itmlist.code = LNM$_STRING;
itmlist.buflen = 256;
itmlist.addr = val;
itmlist.len = &return_len;
itmlist.end = 0;
status = sys$trnlnm(&attr,&tname,&lname,0,&itmlist);
if (status == SS$_NOLOGNAM)	/* not found, check system table */
    {
    attr = LNM$M_CASE_BLIND;
    tname.class = lname.class = CLASS_ARRAY;
    tname.type = lname.type = TYPE_STRING;
    tname.addr = "LNM$SYSTEM_TABLE";
    tname.length = strlen(tname.addr);
    lname.addr = lognam;
    lname.length = strlen(lname.addr);
    itmlist.code = LNM$_STRING;
    itmlist.buflen = 256;
    itmlist.addr = val;
    itmlist.len = &return_len;
    itmlist.end = 0;
    status = sys$trnlnm(&attr,&tname,&lname,0,&itmlist);
    }
if (status != SS$_NORMAL)
   return(-1);
*(val + return_len) = '\0';
strcpy(logval,val);
return(0);
}
#else

#include "worgen.h"
#include "tapeio.h"
#include "local_protos.h"

int get_logical
(
    char *lognam,		/*  logical name			*/
    char *logval		/*  logical value			*/
)
{
char *cptr;

cptr = getenv(lognam);
if (cptr == NULL)
    return(-1);
strcpy(logval,cptr);
return(0);
}
#endif
