/*
 *	validpid -- check to see if the process ID passed as the first
 *	parameter is valid.
 *
 *	SUMMARY:
 *		int validpid(pid)
 *		int pid;
 *
 *	RETURN VALUE:
 *		0	for valid pid
 *		-1	for invalid pid
 *
 */

#include <errno.h>
#include <sys/types.h>
#include <signal.h>


int validpid
(
    int pid
)
{

	if (kill(pid,0) < 0)
		if (errno == EPERM)
			return(0);
		else
			return(-1);
	else
		return(0);
}

#ifdef TEST
/*
 *	Test routine.  Example:
 *		% a.out 1 2314 3795 23426
 *		bad pid: 2314
 *		bad pid: 23426
 *		%
 *	indicates that 1 and 3795 are valid pids and the other two
 *	are not.
 */
int main
(
    int argc,
    char **argv
)
	{
	for (argc--,argv++; argc>0; argc--,argv++)
		if (validpid(atoi(*argv)) < 0)
			printf("bad pid: %s\n",*argv);
	}
#endif

