#include <stdlib.h>

#ifdef linux
#include "worgen.h"
#else
#include "las.h"
#endif

#include "tapeio.h"
#include "desc.h"

#ifdef unix
/*  Fortran bridge routine for sun  */
int tplswr_
(
   long	 *fd, 
   char	*key, 
   long *clen, 
   long *dlen,
   char *cbuf, 
   char *dbuf,
   char *dtype,
   long	key_len, 
   long cbuf_len, 
   long dtype_len
)
{
char *key_ptr;
char *cbuf_ptr;
char *dtype_ptr;
long status;

key_ptr = squeeze(key,key_len);
cbuf_ptr = squeeze(cbuf,cbuf_len);
dtype_ptr = squeeze(dtype,dtype_len);

status = c_tplswr(fd,key_ptr,clen,dlen,cbuf_ptr,dbuf,dtype_ptr);

free(key_ptr);
free(cbuf_ptr);
free(dtype_ptr);

return(status);
}
#endif
#ifdef vms
/*  Fortran bridge routine for VAX  */
int tplswr
(
    long *fd,
    struct DESC *key,
    long *clen,
    long *dlen,
    struct DESC *cbuf,
    char *dbuf,
    struct DESC *dtype
)
{
char *key_ptr;
char *cbuf_ptr;
char *dtype_ptr;
long nonfatal = 1;
long status;

key_ptr = squeeze(key->addr,key->length);
cbuf_ptr = squeeze(cbuf->addr,cbuf->length);
dtype_ptr = squeeze(dtype->addr,dtype->length);

status = c_tplswr(fd,key_ptr,clen,dlen,cbuf_ptr,dbuf,dtype_ptr);

if (free(key_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","lswrit-free",&nonfatal);
if (free(cbuf_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","lswrit-free",&nonfatal);
if (free(dtype_ptr) == -1)
   c_errmsg("Error freeing dynamic memory","lswrit-free",&nonfatal);

return(status);
}
#endif
