/**************************************************************************
*	
*	NAME: getprc
*
*	PURPOSE:  Get running process name for error log file.
*
   Program History:
   version	Date	Contrib		Change
   -------	----	-------		------
    2.3         7/90    K.Gacke         output system error code on error condition
    3.0		1/91	K.Gacke		tape config file
    3.1		3/91	K.Gacke		Add Silicon Graphics
*
*	COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
*		vax 
*
*	PROJECT: LAS
*
*	ALGORITHM DESCRIPTION:
*	VAX
*	   Call system subroutine sys$getjpi
*	Other systems
*	   Assign ???? to the process name
*	ALGORITHM REFERENCES:
*
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "worgen.h"
#include "local_protos.h"

#ifdef vms
#include ssdef
#include jpidef

void getprc
(
    char *prcnam
)
{
struct
    {                       /* item list for SYS$GETJPI */
    short   il_buflen;              /* buffer length */
    short   il_code;                /* item description code */
    char    *il_bufaddr;            /* buffer address */
    char    *il_lenaddr;            /* addr of returned length */
    long    il_zero;                /* list terminator */
    }       itemlist;
long i;
long status;
char buf[CMLEN];
char *strchr();
char *ptr;

/*
*  Call getjpi to get the account number
*/
itemlist.il_buflen = CMLEN;
itemlist.il_code = JPI$_IMAGNAME;
itemlist.il_bufaddr = buf;
itemlist.il_lenaddr = (char *)0;
itemlist.il_zero = 0;
status = sys$getjpi(0,0,0,&itemlist,0,0,0);
if (status != SS$_NORMAL)
    {
    printf("getprc: error getting process name, status = 0x%x\n",status);
    *prcnam = '\0';
    return;
    }
for (i=CMLEN-1; i>=0; i--)
    {
    if (buf[i] == ' ')
        buf[i] = '\0';
    else
        break;
    }
ptr = strchr(buf,']');		/* strip off directory spec */
if (ptr == NULL)
    strcpy(prcnam,buf);
else
    strcpy(prcnam,ptr+1);
ptr = strchr(prcnam,'.');	/* strip off extension */
if (ptr != NULL)
    *ptr = '\0';
return;
}
#else

void getprc
(
    char *prcnam
)
{
strcpy(prcnam,"??????");
}
#endif
