#ifndef LOCAL_PROTOS_H
#define LOCAL_PROTOS_H

#include "tapeio.h"
#include "desc.h"

#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

int tpbsf
(
    long *tapefd,
    long *count,
    long *mode
);

int tpbsr
(
    long *tapefd,
    long *count,
    long *mode
);

int tpclos
(
    long *tapefd,
    long *mode,
    long *opt1,
    long *opt2
);

int tpfsf
(
    long *tapefd,
    long *count,
    long *mode
);

int tpfsr
(
    long *tapefd,
    long *count,
    long *mode
);

int tplsrd
(
    long *fd,
    struct DESC *key,
    long *clen,
    long *dlen,
    struct DESC *cbuf,
    unsigned char *dbuf,
    struct DESC *dtype
);

int tplswr
(
    long *fd,
    struct DESC *key,
    long *clen,
    long *dlen,
    struct DESC *cbuf,
    unsigned char *dbuf,
    struct DESC *dtype
);

int tpopen
(
    long *unit,
    long *skip,
    long *mode,
    long *opt1,
    struct DESC *dens,
    long *inout,
    struct DESC *message,
    struct DESC *tapeid
);

int tpread
(
    long *tapefd,
    unsigned char *buffer,
    long *bufsz,
    long *mode
);

int tpreop
(
    long *unit,
    long *skip,
    long *mode,
    long *opt1,
    struct DESC *dens,
    long *inout,
    struct DESC *tapename
);

int tprew
(
    long *tapefd,
    long *mode,
    long *opt1
);

int tpweof
(
    long *tapefd,
    long *count,
    long *mode
);

int tpwrit
(
    long *tapefd,
    unsigned char *buffer,
    long *bufsz,
    long *mode
);

int canwrit
(
    char devnam_buf[]       /* Device name to check                       */
);

int chktap
(
    int tpnum,
    int instr,
    unsigned short statv[],
    int code
);

int get_logical
(
    char *lognam,           /*  logical name                        */
    char *logval            /*  logical value                       */
);

int get_logical
(
    char *lognam,           /*  logical name                        */
    char *logval            /*  logical value                       */
);

void getprc
(
    char *prcnam
);

int get_tape_nam
(
    char *tapenam,
        char *tapeid,
        long *tapelen,
    char *msg
);

int istape
(
    char devnam_buf[]       /* Device name to check       */
);

int open_tape
(
    struct TAPEDESC *drv,   /*  tape descriptor             */
    long opnflg
);

int testeot
(
    struct TAPEDESC *drive
);

int testbot
(
    struct TAPEDESC *drive
);

int testeof
(
    struct TAPEDESC *drive	/* tape descriptor */
);

int tlbsr
(
    long *tapefd,           /*  tape file descriptor                */
    long *mode,             /*  error mode                          */
    long *tpstatus          /*  tape status EOV or EOF */
);

int tpchk
(
    long *tapefd        /*  tape unit number            */
);

int tperror
(
    struct TAPEDESC *tp,
    long code,
    long mode
);

void tplen
(
    struct TAPEDESC *drive
);

void tp_setlen
(
    struct TAPEDESC *drive,
    int status
);

int add_tpmnt
(
        struct TAPEDESC *drive,
        long opnflg             /* TOPEN or TREOPEN */
);

int del_tpmnt
(
        struct TAPEDESC *drive
);

void tpmsg
(
    char *msg           /*  message to write to the operator    */
);

int tprdconf
(
    struct TAPEDESC *drive,
    char *tapenam,
    char *density,
    long inout
);

void init_tprec
(
    struct TPREC *tprec
);

void get_density
(
    char *cmd,
    struct TPREC *tprec
);

int tpconfig_assden
(
    struct TAPEDESC *drive,
    struct TPREC *tprec
);

void get_tpflag
(
    char *cmd,
    struct TPREC *tprec
);

int tpconfig_assdrv
(
    struct TAPEDESC *drive
);

int tpgetconf
(
    char *tpconfig
);

void tpsig_blk
(
        int *mask
);

void tpsig_unblk
(
        int *mask
);

void tpunit
(
    long *tapefd,           /*  tape file descriptor                */
    int *lun                /*  logical unit number                 */
);

int validpid
(
    int pid
);

int tpconfig_getfield
(
	FILE *fp,
	char *buf
);

void tp_errmsg
	(
	char	*message,
	char	*key,
	long	*vrity
	);

#endif
