/**************************************************************************
*    Function:	tpunit
*
*    Purpose:	To retrieve the logical unit number
*
   Program History:
   version	Date	Contrib		Change
   -------	----	-------		------
    1.0                                 Original development
    2.0         12/87   F. Irani/SAR    Add qiow call to sense tape mode on
                                        unsuccessful read.  If status = EOT 
					return (TAPE_EOT)
    2.1         12/87   B. Ailts        Change include directory specifications
                                        Placed bridge routines in a seperate 
					file. Added 'c_' to function name
    2.2         6/89    K.Gacke         Port to SUN 4
    2.3         7/90    K.Gacke         output system error code on error condition
    3.0		1/91	K.Gacke		tape config file
    3.1		3/91	K.Gacke		Add Silicon Graphics
*
*	COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
*		none
*
*	PROJECT: LAS
*
*	ALGORITHM DESCRIPTION:
*
*	ALGORITHM REFERENCES:
*
******************************************************************************/
#include <stdio.h>

#ifdef vms
#include <iodef.h>
#include <ssdef.h>
#endif

#include "worgen.h"
#include "tapeio.h"
#include "local_protos.h"

void tpunit
(
    long *tapefd,		/*  tape file descriptor		*/
    int *lun		/*  logical unit number			*/
)
{
	struct TAPEDESC *drive;

	drive = (struct TAPEDESC *) *tapefd;
	*lun = drive->fd;
}  /*  tpunit  */
