/******************************************************************************
FUNCTION:	HOMZON

PURPOSE:	Calculates the HOM zone from the WRS row

PROGRAM HISTORY:
VERSION		DATE		PROGRAMMER	DESCRIPTION
-------		----		----------	-----------
  5.0		4/89		D. Hollaren	Conversion to 5.0
  5.1		5/93		T. Mittan	Modified zone incrementing

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/

#include "tm.h"


void homzon
(
    long *row,		/* WRS row 			*/
    long *zone		/* HOM zone			*/
)
{
static long zrows[] = { 1, 25, 44, 76, 94, 122, 150, 168, 200, 218, 248 };

for(*zone = 1; *zone <= 10; *zone +=1)
    {
    if ((*row >= zrows[*zone - 1]) && (*row <= zrows[*zone]))
	break;
    }
}
