/******************************************************************************
FUNCTION:	UTMZON

PURPOSE:	Calculates the UTM zone from the WRS row

PROGRAM HISTORY:
VERSION		DATE		PROGRAMMER	DESCRIPTION
-------		----		----------	-----------
  5.0		4/89		D. Hollaren	Conversion to 5.0
  5.1		10/92		D. Etrheim	Change the method for 
					calculating the zone code.  The calling
					routine must check if the latitude is 
					negative and set the zone to a negative
					value also. 
						

ALGORITHM 

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <math.h>
#include "las.h"
#include "tm.h"

void utmzon
(
    double *wrslon,		/* WRS center longitude			*/
    long *zone		/* UTM zone				*/
)
{

/*
  Calculate the UTM zone
*/
*zone = (long)(abs((-180.0 - *wrslon) / 6.0)) + 1;

}
