#include "las.h"
#include "desc.h"
#include "util.h"

int gettyp_
(
    char    hosin[][CMLEN], /* input host file names                     */
    int     *nmrimg,        /* number of input images                    */
    int     *odtype,        /* output data type -- data type of input img*/
    int     hosin_length    /* length of host names                      */
)
{
    char *hname_ptr;
    char *temp_ptr;
    int  status;
    int  i;

    hname_ptr = (char *)malloc(CMLEN * *nmrimg);
    if (hname_ptr == 0)
    {
        c_lasmsg (FALSE, "gettyp-alloc", "Error allocating dynamic memory");
        return (E_FAIL);
    }

    for (i= 0; i < *nmrimg; i++)
    {
        temp_ptr = squeeze (hosin[i], hosin_length);
        if (temp_ptr == NULL)
        {
            free (hname_ptr);
            return (E_FAIL);
        }
        strcpy (hname_ptr + (i * CMLEN),temp_ptr);
        free (temp_ptr);
    }

    status = las_gettyp (hname_ptr,*nmrimg,odtype);

    free (hname_ptr);

    return (status);
}
