#include "las.h"
#include "desc.h"
#include "util.h"

int hstout_
(
    struct PARBLK *vblock, /* tae parameter block                          */
    char   *hosout,        /* output image                                 */
    char   hosin[][CMLEN], /* input image(s)                               */
    int    *numin,         /* number of input images                       */
    char   *histext,       /* history text                                 */
    int    hosout_len,     /* length of "hosout"                           */
    int    hosin_len,      /* length of "hosin"                            */
    int    htext_len       /* length of "histxt"                           */
)
{
    char *hin_ptr;
    char *hout_ptr;
    char *temp_ptr;
    char *text_ptr;
    int  i;
    int  status;           /* return status code                           */

#ifdef sgi
    if (*numin != 0)
    {
        hin_ptr = (char *)malloc (CMLEN * (*numin));
        if (hin_ptr == 0)
        {
            c_lasmsg (FALSE, "hstout-alloc", "Error allocating dynamic memory");
            return (E_FAIL);
        }
    }
    else
    {
        hin_ptr = (char *)malloc (CMLEN);
        if (hin_ptr == 0)
        {
            c_lasmsg (FALSE, "hstout-alloc", "Error allocating dynamic memory");
            return (E_FAIL);
        }
    }
#else
    hin_ptr = (char *)malloc (CMLEN * (*numin));
    if (hin_ptr == 0)
    {
        c_lasmsg (FALSE, "hstout-alloc", "Error allocating dynamic memory");
        return (E_FAIL);
    }
#endif

    hout_ptr = squeeze (hosout,hosout_len);
    if (hout_ptr == NULL)
    {
        free (hin_ptr);
        return (E_FAIL);
    }

    text_ptr = squeeze (histext,htext_len);
    if (text_ptr == NULL)
    {
        free (hin_ptr);
        free (hout_ptr);
        return (E_FAIL);
    }

    for (i= 0; i < *numin; i++)
    {
        temp_ptr = squeeze (hosin[i], hosin_len);
        if (temp_ptr == NULL)
        {
            free (hin_ptr);
            free (hout_ptr);
            free (text_ptr);
            return (E_FAIL);
        }

        strcpy (hin_ptr + (i * CMLEN),temp_ptr);
        free (temp_ptr);
    }

    status = las_hstout (vblock,hout_ptr,hin_ptr,*numin,text_ptr);

    free (hout_ptr);
    free (text_ptr);
    free (hin_ptr);

    return (status);
}
