/*******************************************************************************
NAME         CREAT_NAME

PURPOSE      Creates a name based upon the a time stamp

PROGRAM HISTORY
PROGRAMMER              DATE            REASON
----------              ----            ------
B. Ailts              Sep. 1990         original development

PROJECT       LAS

ALGORITHM 
    Calculate the lenght of the input string
    Set pointer to the end of the input name
    Calculate the hour and add to the end of the name
    Calculate the minutes and add to the end of the name
    Calculate the seconds and add to the end of the name
    Add the "." to the end of the name
    Add the extension to the end of the name
    Return

ALGORITHM REFERENCES    none
******************************************************************************/
#include <time.h>
#include <string.h>
#include "las.h"
#include "util.h"


/**
 * c_creat_name:
 * @temp_file: I/O: Temporary file for name created.
 * @ext: I: Default extension.
 *
 * The c_creat_name() routine creates a name based on the time stamp.
 */
void c_creat_name
(
    char *temp_file,        /* I/O: Temp file for name created              */
    const char *ext         /* I: Default extension                         */
)
{ 
    struct tm *tm_ptr;      /* temporary pointer in time struct             */
    time_t my_time;         /* current time                                 */

    char *file_ptr;         /*  file pointer to temporary image name        */


    /* Calculate and format the time and append it to the temporary file name*/
    my_time = time(0);
    tm_ptr = localtime (&my_time);

    file_ptr = temp_file + strlen(temp_file);
    sprintf (file_ptr,"%2d",tm_ptr->tm_hour);
    if (tm_ptr->tm_hour < 10)
        *file_ptr = '0';
    file_ptr += 2;

    sprintf (file_ptr,"%2d",tm_ptr->tm_min);
    if (tm_ptr->tm_min < 10)
        *file_ptr = '0';
    file_ptr += 2;

    sprintf (file_ptr,"%2d",tm_ptr->tm_sec);
    if (tm_ptr->tm_sec < 10)
        *file_ptr = '0';
    file_ptr += 2;

    strcpy(file_ptr,".");
    file_ptr += 1;
    strcpy(file_ptr,ext);
}
