#include "tae.h"
#include "worgen.h"
#include "desc.h"
#include "util.h"

void inittm_ 
(
    char  *subject,
    char  *verb,
    char  *entity,
    char  *cat,
    char  *text,
    int   *max_entity,
    int   *max_cat,
    int   *seconds,
    int   *flag,
    int    subject_len,
    int    verb_len,
    int    entity_len,
    int    cat_len,
    int    text_len 
)
{
    char *subj_ptr;
    char *verb_ptr;
    char *ent_ptr;
    char *cat_ptr;
    char *text_ptr;

    subj_ptr = squeeze(subject,subject_len);
    if (subj_ptr == NULL)
        return;

    verb_ptr = squeeze(verb,verb_len);
    if (verb_ptr == NULL)
    {
        free (subj_ptr);
        return;
    }

    ent_ptr = squeeze(entity,entity_len);
    if (ent_ptr == NULL)
    {
        free (subj_ptr);
        free (verb_ptr);
        return;
    }

    cat_ptr = squeeze(cat,cat_len);
    if (cat_ptr == NULL)
    {
        free (subj_ptr);
        free (verb_ptr);
        free (ent_ptr);
        return;
    }

    text_ptr = squeeze(text,text_len);
    if (text_ptr == NULL)
    {
        free (subj_ptr);
        free (verb_ptr);
        free (ent_ptr);
        free (cat_ptr);
        return;
    }

    las_inittm(subj_ptr, verb_ptr, ent_ptr, cat_ptr, text_ptr,
               *max_entity, *max_cat, *seconds, *flag);

/* NOTE: due to the implementation of the message display code, these strings
         can not be free'd.  The message display code expects the calling
         routine to keep the strings available.  This is a flaw in the 
         design, but fixing it now would potentially impact a lot of 
         applications.  So, for now, we will live with a small memory leak.
    free (subj_ptr);
    free (verb_ptr);
    free (ent_ptr);
    free (cat_ptr);
    free (text_ptr);
*/
}

void startm_()
{
    c_startm();

}

void stoptm_()
{
    c_stoptm();

}
