
/****************************************************************************
NAME:           C_4DIGITDT

PURPOSE:        Convert a date in the format YYJJJ to YYYYJJJ where
                  YY = 2 digit year
                YYYY = 4 digit year
                 JJJ = Julian day

                NOTE:  If a format YYYYJJJ is passed in, YYYYJJJ will be
                       returned.

PROGRAM HISTORY:
VERSION  AUTHOR        DATE     REASON
-------  ------        -----    -----------------------------
 1.0    T. Baltzer    07/98     Original Development

ALGORITHM REFERENCES:

*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"

/**
 * c_4digitdt:
 * @date: I: Date in format YYJJJ to be converted.
 *
 * The c_4digitdt() routine converts a date in the format YYJJJ to YYYYJJJ
 * where:
 *      YY   = 2 digit year,
 *      YYYY = 4 digit year,
 *      JJJ  = Julian day. 
 * Note: If a format YYYYJJJ is passed in, YYYYJJJ will be returned.
 *
 * Returns:   A date in the format YYYYJJJ.
 */
int  c_4digitdt
(
    int  date       /* I: Date in format YYJJJ to be converted          */
)

{

    return (c_4digityr(date / 1000) * 1000 + (date % 1000));
}

