/************************************************************************
NAME:           C_ISLEAP

PURPOSE:        Test if year given is a leap year.

PROGRAM HISTORY:

VERSION         PROGRAMMER           DATE              COMMENTS
-------         ----------           ----              --------
 2.0            D. Hollaren          2/91              Conversion to C


ALGORITHM DESCRIPTION:

ALGORITHM REFERENCES:

**************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"

/**
 * las_isleap:
 * @year: I: Year to test if it is a leap year.
 *
 * las_isleap() tests if year given is a leap year.
 *
 * Returns:  TRUE:  Year given is a leap year, 
 *           FALSE: Year give is not a leap year.
 */
int las_isleap
(
    int  year             /* I:  Year to test                               */
)

{

    int    leap;          /* Leap year flag                                 */
    int    lyear;

/****************************************************************
DLLOYD Y2K
  make a local copy of year and convert to 4-digit for the check
*****************************************************************/
    lyear = c_4digityr(year);

    if (((lyear % 4) != 0) || (((lyear % 100) == 0) && ((lyear % 400) != 0)))
        leap = FALSE;
    else
        leap = TRUE;

    return(leap);
}
  
#ifndef NO_OBSOLETE_INTERFACE

/**
 * c_isleap:
 * @year: I: Year to test if it is a leap year.
 *
 * c_isleap() tests if year given is a leap year.
 *
 * Deprecated.  Use las_isleap() instead.
 *
 * Returns:  TRUE:  Year given is a leap year, 
 *           FALSE: Year give is not a leap year.
 */
int c_isleap
(
    const long *year      /* I: Year to test                                */
)

{
    int status;

    status = las_isleap (*year);

    return (status);

}

#endif /* obsolete interfaces   */


