
/*----------------------------------------------------------------------------
MODIFICATION                            DATE            PROGRAMMER
------------                            ----            ----------
Call the new version of PTERM.          1/12/88         F.Irani/STX
---------------------------------------------------------------------------- */
#include <stdio.h>
#include "las.h"
#include "desc.h"
#include "util.h"
#define TERM 0
#define LP   1
#define FIL  2

/**
 * c_txtout:
 * @buf: I: Text to be written into buffer.
 * @print: I: Array of three integers that indicate whether output should
 *            go to the printer ('LP' index in array), a file ('FIL' index
 *            into the print array), and/or the terminal ('TERM' index in
 *            the array).
 * @fp: I: File descriptor for print FILE or LP.
 *         If fp == 0, no file is open.
 *
 * The c_txtout() routine takes the text to output and the print array
 * and sends the output to the correct output location.
 */
void c_txtout 
(
   char  buf[],       /* I:  Text to be written out                     */
   const int print[], /* I:  Print options (FILE, LP, TERM)             */
   FILE  *fp          /* I:  File descriptor for print FILE or LP       */
                      /*     if fp == 0 then no file open               */
)
{
    int  zero = 0;       /* zero to be passed to be passed to c_pterm   */

    if (((print[LP]) || (print[FIL])) && fp != NULL)
        fprintf (fp, "%s\n", buf);
    if (print[TERM])
    {
        las_pterm (buf, zero);
    }
}
