/*******************************************************************************
NAME:     GETUSERN

PURPOSE:  Getusern gets the user name of the user running
          this program.

PROGRAM HISTORY:
        T. Butzer       3/22/86         Original Implementation
  5.0   D. Hollaren     04/88           added las include
                                        changed errhrt to c_errmsg
                                        return E_SUCC/E_FAIL
  5.1   B. Ailts        07/88           Fixed the call to squeeze
        D. VanderZee    07/90   Standardized error handling



PROJECT                 LAS

ALGORITHM 

ALGORITHM REFERENCES    none
*******************************************************************************/
#include <unistd.h>
#include <pwd.h>
#include "las.h"
#include "util.h"
#include "util2.h"


/**
 * getusern()
 * @username: O: User name of user running program.
 * 
 * The getusern() routine gets the user name of the user running
 * this program.
 *
 * Returns:  E_SUCC:  Successful completion of operation,
 *           E_FAIL:  Unsuccessful completion of operation.
 */
int getusern
(
    char *username    /* O: User name of user running program     */  
)
{
    int uid;
    struct passwd *pwptr;   

    uid = getuid();
    pwptr = getpwuid(uid);

    strcpy(username, pwptr->pw_name);

    return(E_SUCC);
}
