
/******************************************************************************
NAME:     newname()
PURPOSE:  return the name of a file that does not exist on disk
          name will be lowercase and of the form INBASE_#####.INEND
******************************************************************************/
#include <ctype.h>   /* for calling tolower() */ 
#include <unistd.h>  /* for calling getpid(), access() */ 
#include "cwheel.h"  /* application header file */ 



FUNCTION void newname (inbase, inend, outname)
   char inbase[CMLEN];  /* input:  base for file name */ 
   char inend[CMLEN];   /* input:  extension for file name */ 
   char outname[CMLEN]; /* output: name of a new file */ 
{

/* declare variables */ 
   char *charp;  /* a character pointer */ 
   long effort,  /* loop index:  effort at finding a file name */ 
	exist;   /* flag, does file already exist on disk */ 

/* seed random number generation with process id */ 
#ifndef sun
   srandom (getpid() ); 
#else
   srand (getpid() ); 
#endif

/* loop for several efforts, 1 try will almost always suffice */ 
   for (exist=TRUE, effort=0;  exist && effort<100;  effort++)
      {
      /* make a new name and convert it to lower case */ 
#ifndef sun
	 sprintf (outname, "%s_%05ld%s", inbase, random()/100000, inend); 
#else
	 sprintf (outname, "%s_%05d%s", inbase, rand()/100000, inend); 
#endif
	 for (charp=outname;  *charp!='\0';  charp++)
	    *charp = tolower (*charp); 

      /* check file existence */ 
	 if (access (outname, 0))
	    exist = FALSE;
      }

/* error check:  no file made */ 
   if (exist)
      errclean ("cwheel-fatal", 
      "Unable to create a unique host file name of the form %s_#####%s", 
      inbase, inend); 
} 


