#include "convolve.h"
#include "protos.h"
/*****************************************************************************
PROGRAM:  cirfil

PURPOSE: Fill circular convolution buffer

PROGRAM HISTORY:
VERSION   DATE      AUTHOR       CODE/CONTR.   CHANGE REQUEST
1	06/01/92  K. Sheffield	  STX		First version

PDL:

	Begin cirfil
		move pointer in circular buffer to first pixel
		foreach sample
                   copy the current sample in the input buffer
			to the pointer location in the circular buffer
		   increment the pointer by the kernal row size.
	End cirfil
****************************************************************************
*/

void cirfil
(
    float *in_buf,	/* Pointer to the input buffer			*/
    float *circ_buf,/* Pointer to the circular buffer		*/
    long column,	/* Column in the circular buffer to fill 	*/
    long ns,	/* Number of samples to copy			*/
    long krows	/* Number of rows in the kernal 		*/
)

{

float *cptr;		/* pointer to the current pixel in the circ. buffer */
long i;			/* loop counter			*/


	cptr = circ_buf + column;	/* offset to the correct column */

	for (i=0;i<ns;i++,cptr += krows)
		*cptr = *(in_buf++);
}
