#ifndef PROTOS_H
#define PROTOS_H

void cirfil
(
    float *in_buf,	/* Pointer to the input buffer			*/
    float *circ_buf,/* Pointer to the circular buffer		*/
    long column,	/* Column in the circular buffer to fill 	*/
    long ns,	/* Number of samples to copy			*/
    long krows	/* Number of rows in the kernal 		*/
);

void compute
(
    char hosout[][CMLEN],         		/* output image host name       */
    long images,				/* Number of input images	*/
    long num_bands,			/* Total number input bands	*/
    long image_band_num[][MAXBND+1],	/* band numbers/image 		*/
    long num_image_bands[],		/* number of bands per image    */
    long *dtype,				/* Input data type		*/
    long row,				/* matrix row number		*/
    long col,				/* matrix col number		*/
    float wght[],				/* Input weight file		*/
    long wind[][4]			/* Input windows		*/
);

void convmf
(
    char hosout[][CMLEN],         /* output image host name       	*/
    float wgtfct[],         /* Weight array 			*/
    long nbr,               /* Number of rows in wgtfct 		*/
    long nbc,               /* Number of colums in wgtfct 		*/
    long image,             /* Input image number			*/
    long band_num,          /* Band number 				*/
    long nl,		/* Number of samples in image		*/
    long ns,		/* Number of samples in image		*/
    long intype            /* Input band type 			*/
);

void mir_data
(
    float *buf,
    long k,
    long ns
);

void circ_cpy
(
    float *buffer,
    long from,
    long to,
    long num,
    long rows
);

void convzf
(
    char hosout[][CMLEN],         /* output image host name       	*/
    float wgtfct[],         /* Weight array 			*/
    long nbr,               /* Number of rows in wgtfct 		*/
    long nbc,               /* Number of colums in wgtfct 		*/
    long image,             /* Input image number			*/
    long band_num,          /* Band number 				*/
    long nl,		/* Number of samples in image		*/
    long ns,		/* Number of samples in image		*/
    long intype            /* Input band type 			*/
);

void filspec
(
    char hosin[][CMLEN],		/* input image host names		*/
    char hosout[][CMLEN],		/* Output image host name		*/
    long *images,		/* Number of input images specified	*/
    long num_bands,		/* total number of input bands		*/
    long num_image_bands[],	/* number of bands in each image    	*/
    long image_band_num[][MAXBND+1],	/* band numbers/image 		*/
    long wind[][4],		/* input image windows              	*/
    long *dtype			/* Input data type			*/
);

void getpar
(
    char hos_in[][CMLEN],		/* input image name     	*/
    char las_out[][CMLEN],		/* input las name		*/
    char hos_out[][CMLEN],     	/* output image name    	*/
    long *images,          	/* number of imput images  	*/
    long *num_bands,           	/* total number of input bands  */
    long num_image_bands[],	/* number of bands per image    */
    long image_band_num[][MAXBND+1], /* band numbers/image 	*/
    long wind[][4],		/* window specifications 	*/
    float wgt[],			/* Input weight file		*/
    float *norm,			/* Average/weight matrix	*/
    float *bias,			/* Offset for weight matrix	*/
    long *row,                	/* number of rows in weights    */
    long *col,                	/* number of colums in weights  */
    float *wmax,			/* weight mamximum		*/
    float *wmin			/* weight minimum		*/
);

void getwts
(
    long *row,	/* Row Pointer					*/
    long *col,	/* Column Pointer				*/
    double *norm,	/* Mean						*/
    double *bias,	/* offset					*/
    double wgt[],	/* Weight matrix				*/
    char filein[]	/* Input weight file name			*/
);

void shiftk
(
    float *kernal,	/* Pointer to the convolution kernal		*/
    long nc,	/* Number of columns in the kernal 		*/
    long nr	/* Number of rows in the kernal 		*/
);

#endif
