#include "convolve.h"
#include "protos.h"
/*****************************************************************************
PROGRAM:  shiftk

PURPOSE: Shift convolution kernal by one column.

PROGRAM HISTORY:
VERSION   DATE      AUTHOR       CODE/CONTR.   CHANGE REQUEST
1	06/01/92  K. Sheffield	  STX		First version

PDL:

	Begin shiftk
		for each row
                   copy the first coefficient in the kernal to a temp variable
		   move the rest of the coeffients over by one.
		   copy the contents of the temp variable to the last position
			in the row.	
	End shiftk
****************************************************************************
*/

void shiftk
(
    float *kernal,	/* Pointer to the convolution kernal		*/
    long nc,	/* Number of columns in the kernal 		*/
    long nr	/* Number of rows in the kernal 		*/
)

{

long i,j;	/* index counters				*/
float temp;	/* temporary space 				*/
float *cptr;	/* pointer to coeffients in the kernal 	*/

	if ( nr < 1) return;
	if ( nc < 1) return;

	i = 0;
	cptr = kernal + 1;
	do 
		{
		j = 1;
		temp = *kernal;
		do 
			{
			*(kernal++) = *(cptr++);
			j++;
		} while (j < nc);
		*(kernal++) = temp;
		cptr++;
		i++;
	} while ( i < nr);
}
