/******************************************************************************

SUBROUTINE:	rparm

PURPOSE: 
	Subroutine rparm will receive the parameter values from the V-block,
	and return the values in a record format in the global variable "rec".

ARGUMENTS:
  Name		Type	  I/O	Description
  ----		----	  ---	-----------
  *blkptr	PARBLK	   I	pointer to record format for parameter values

PROGRAM HISTORY:
  Version	Date	    Author	Change Request
  -------	----	    ------	--------------

COMPUTER:	VAX-11/780   VMS   Version 3.7

LANGUAGE	C

PDL:
    BEGIN
	call the function of p_find for each parameter in the v-block that is
		to be read.  The function will return a pointer pointing to 
		the value of the parameter.
	using the c macro of IVAL to access an integer value, and the c
		macro of SVAL to access a string value, assign the parameter
		values to the corresponding fields in the record to be written
		into the custom request file
    END

******************************************************************************/
#include <stdio.h>
#include <ctype.h>
#include "las.h"
#include "util.h"
#include "protos.h"

void rparm
(
    struct PARBLK *blkptr,
    long *term,
    long *fyle,
    long *lnpr,
    char *filnm,
    char *outfil2,
    char *priority,
    char *request,
    long *extnbr,
    char *call,
    char *operator,
    char *system,
    char *queue,
    char *jobnbr,
    char *jobname,
    char *otapetyp,
    char indesc[][51],
    char inloc[][13],
    char outdesc[][51],
    char outloc[][13],
    char *coloropt,
    char *edipsopt,
    char *calcoopt,
    char *comment,
    long *intapes,
    long *outtapes
)

{
struct VARIABLE	*var;
int		i,j;

/* call the function of p_find for each parameter value that is to be read from
*  the V-block.  The function will return a pointer of type VARIABLE which
*  points to the value of the parameter.				     */
var = p_find(blkptr,"PRIORITY");
  strcpy(priority,SVAL(*var,0));
var = p_find(blkptr,"REQUEST");
  strcpy(request,SVAL(*var,0));
var = p_find(blkptr,"EXTNBR");
  *extnbr = IVAL(*var,0);
var = p_find(blkptr,"CALL");
  strcpy(call,SVAL(*var,0));
var = p_find(blkptr,"OPERATOR");
  strcpy(operator,SVAL(*var,0));
var = p_find(blkptr,"SYSTEM");
  strcpy(system,SVAL(*var,0));
var = p_find(blkptr,"QUEUE");
  strcpy(queue,SVAL(*var,0));
var = p_find(blkptr,"JOBNBR");
  strcpy(jobnbr,SVAL(*var,0));
var = p_find(blkptr,"JOBNAME");
  strcpy(jobname,SVAL(*var,0));
var = p_find(blkptr,"OTAPETYP");
  strcpy(otapetyp,SVAL(*var,0));
  i = strlen(otapetyp);
  for (j=0; j<i; j++)
    otapetyp[j] = toupper(otapetyp[j]);
var = p_find(blkptr,"INDESC");
i = (*var).v_count;
*intapes = i;
  for (j=0; j < i; j++)
	strcpy(indesc[j],SVAL(*var,j));
var = p_find(blkptr,"INLOC");
i = (*var).v_count;
if (i > *intapes)
   *intapes = i;
  for (j=0; j < i; j++)
	strcpy(inloc[j],SVAL(*var,j));
var = p_find(blkptr,"OUTDESC");
i = (*var).v_count;
   *outtapes = i;
  for (j=0; j < i; j++)
	strcpy(outdesc[j],SVAL(*var,j));
var = p_find(blkptr,"OUTLOC");
i = (*var).v_count;
if (i > *outtapes)
   *outtapes = i;
  for (j=0; j < i; j++)
	strcpy(outloc[j],SVAL(*var,j));
var = p_find(blkptr,"COLOROPT");
  strcpy(coloropt,SVAL(*var,0));
var = p_find(blkptr,"EDIPSOPT");
  strcpy(edipsopt,SVAL(*var,0));
var = p_find(blkptr,"CALCOOPT");
  strcpy(calcoopt,SVAL(*var,0));
var = p_find(blkptr,"COMMENT");
  strcpy(comment,SVAL(*var,0));
var = p_find(blkptr,"PRINT");

strcpy(filnm,"custom");
c_setprt(blkptr,term,fyle,lnpr,filnm,outfil2);
}	/*  END of the RPARM subroutine  */
