#include "cwtgen.h"
#include "util.h"
#include "protos.h"

void cwtdim
(
/*************************************************************************
    FUNCTION cwtdim

     purpose:
       obtain dimensions of weight function and validate them.

     program history:
     version   date     author         code/contr.   change request
        1      5/12/82  r. wenger         csd   
        2      2/7/84   s. brodd          sar        scn 20-154     
        3      7/10/84  s. brodd          sar        scn 20-265
        4      6/21/89  J. McGuthry       STX        conversion to C
        5      9/10/90  F. Irani 	  STX        Inline doc cleanup

     pdl:

     begin
         call c_getnumg to get dimensions of weight function
     end

***********************************************************************/
    long *row,		/* Row dimension 			*/
    long *col		/* Column dimension			*/
)

{

long    two = 2;            /* constant     */

long	dim[2];		/* Kernal dimensions buffer 		*/
long    type;		/* TAE vblock parameter type		*/
     
type = ELONG;

/*
Get dimensions of weight function from TAE block.
-------------------------------------------------		*/
c_getnum ( &vblock,"KERNDIM",&two,&type,dim);

/*
Set row and column dimensions to user specification.
----------------------------------------------------		*/
*row = dim[0];
*col = dim[1];

return;
}
