#ifndef PROTOS_H
#define PROTOS_H

void cwtbox
(
   long *row,     /*  Number of rows in weight function */
   long *col,     /*  Number of cols in weight function */
   double *norm,  /*  Norm for weight function */
   double wgt[]   /*  Weight function */
);

void cwtcub
(
    long *row,    /*  Number of rows of weight function */
   long *col,     /*  Number of cols of weight function */
   double *norm,  /*  Normalization constant            */
   double wgt[],  /*  Weight function */
   char label[]   /*  Output string buffer */
);

void cwtdif
(
    long *row,    /*  Number of rows of weight function */
   long *col,     /*  Number of cols of weight function */
   double *norm,  /*  Norm for weight function */
   double wgt[]   /*  Weight function */
);

void cwtdim
(
    long *row,    /*  Row dimension */
   long *col      /*  Column dimension */
);

void cwtgau
(
    long *row,    /* Number of rows of weight function */
   long *col,     /* Number of cols of weight function */
   double *norm,  /* Normalization constant */
   double wgt[],  /* Weight function */
   char label[]   /* Descriptor Label  */
);

void func
(
    long i,       /* Col Number */
   long j,        /* Row Number */
   double horz,   /* HORTVAL specification */
   double vert,   /* VERTVAL specification */
   double con,    /* Weight coeffiient     */
   double *value  /* Weight value  */
);

void cwtlap
(
    long *row,    /* Number of rows of weight function */
   long *col,     /* Number of cols of weight function */
   double *norm,  /* Norm for weight function */
   double wgt[]   /* Weight function */
);

void cwtman
(
    long *row,    /* Number of rows of weight function */
   long *col,     /* Number of cols of weight function */
   double *norm,  /* Norm */
   double wgt[],  /* Weights */
   long *manstat, /* Return Status */
   long *input    /* Flag for input weight file */
);

void getwts
(
    long *row,    /* Matrix row dimension */
   long *col,     /* Matrix column dimentsion */
   double *norm,  /* Input specification for norm */
   double *bias,  /* Input specification for norm */
   double wgt[],  /* Input specification for norm */
   char filein[]  /* Input specification file */
);


#endif
