/*
*************************************************************************
NAME: INITIO 

PURPOSE: opens an input image for random access.

	note that the input image is converted to the specified
	data type.  this data type is integer*2 for median filters,
	and real*4 for all the other filters.


PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
    1           11/84   J. LaVergne  
    2            1/87	K. Zanter     conversion to unix	 
    3            3/89   K. Narayanan  conversion to c and 5.0 standards

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
	Must be run under TAE.

PROJECT: LAS

*****************************************************************

	arguments:
	name		description
	----		-----------
	host		host name of input image
	intype		data type that image data should be converted 
		        to on input 
	window		current window specification

	internal variables:
	name		description
	----		-----------
	access		access type for eopenr call
	bands		band specification for eopenr call
	status		function return status code
************************************************************************
*/
#include "despike.h"
#include "protos.h"

void initio
(
    char host[],
    long window[],
    long *intype
)
{
long	access;
long	bands;
long	status;
static  long    fatal_err = -1;
static  long    zero = 0;
static  long    one = 1;

bands = 0;
access = IREAD;
status = c_eopenr (&infd, host, &bands, &window[SL], &window[SS], &window[NL],
                   &window[NS], &access, intype, &zero, &one);
if (status  !=  E_SUCC) 
   c_errmsg ("Fatal error encountered", "despike-fatal", &fatal_err);

}
