#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
   char hosin[][CMLEN],		/* O: host names of input images             */
   char taeout[],		/* O: tae name of output image               */
   char hosout[],		/* O: host name of output image              */	
   long *totbnd,	        /* O: total number of output bands           */
   long bands[][MAXBND+1],      /* O: band specification                     */
   long nbands[],   		/* O: number of bands in each image          */
   long *nl,                    /* O: number of lines to be processed        */
   long *ns,                    /* O: num of samples per line to be processed*/
   long window[][4], 		/* O: window specification	             */
   long *nmrimg, 		/* O: number of input images	             */
   char subcmd[], 		/* O: specified subcommand	             */
   long *ksamps, 	        /* O: number of samples per line in kernel   */
   long *klines, 		/* O: number of lines in kernel		     */
   float *low, 			/* O: low end of valid data range            */
   float *high, 		/* O: high end of valid data range           */
   long *otype, 		/* O: output data type                       */
   long *invld,			/* O: option to use for invalid samples      */
   float *nstd,			/* O: number of standard deviations          */ 
   float *tol			/* O: tolerance value                        */
);

void hilo
(
   char hosout[],		/* I: out image host name		     */
   long nl,			/* I: number of lines to be processed	     */
   long *ns,			/* I: num of samples per line to be processed*/
   long otype,			/* I: output data type			     */
   long *bndin,			/* I: current input band number              */
   long *bndout,	        /* I: output band number                     */ 
   long xhalf,			/* I: half of the num of samples in the kernel*/
   long yhalf,			/* I: half of the num of lines in the kernel */
   long ksamps,			/* I: number of samples per line in kernel   */
   double high,			/* I: high end of valid data range	     */
   double low,			/* I: low end of valid data range	     */
   float *varsum,		/* I/O: sum of squared data in kernel        */
   float *kersum,		/* I/O: data sum of the kernel		     */
   long *valsum,		/* I/0: the valid number of samples which 
				      contributed to the kernel sum          */ 
   long invld,			/* I: option to use for invalid samples      */
   double minval[],		/* I: minimum values for each band	     */
   double maxval[],		/* I: maximum values for each band	     */
   double nstd,			/* I: number of standard deviations          */
   double tol			/* I: tolerance value                        */
);

void initio
(
   char host[],			/* I/O: host name of input image	     */
   long window[],		/* I: current window specification           */
   long *intype			/* I: data type that image data should be
                                      converted to on input		     */

);

void median
(
   char hosout[],		/* I: output image host name		     */
   long nl,			/* I: number of lines to be processed        */ 
   long *ns,			/* I: num of samples per line to be processed*/
   long *bndin,			/* I: current input band number		     */
   long *bndout,		/* I: output band number                     */
   long xhalf,			/* I: half of the num of samples in the kernel*/
   long yhalf,			/* I: half of the num of lines in the kernel */
   double totpix,		/* I: total number of pixels in the kernel   */
   long *ksamps,		/* I: number of samples per line in kernel   */
   long dtype,			/* I: data type of input image		     */
   double minval[],		/* I: minimum values for each band           */
   double maxval[]		/* I: maximum values for each band           */
);

void prehl
(
   char hosout[],		/* I: out image host name		     */
   long xhalf,			/* I: half of the num of samples in the kernel*/
   long yhalf,			/* I: half of the numb of lines in the kernel*/
   long *ns,			/* I: num of samples per line to be processed*/
   long *curbnd,		/* I: current input band number		     */
   double high,			/* I: high end of valid data range	     */
   double low,			/* I: low end of valid data range            */
   float *varsum,		/* O: sum of squared data in kernel          */
   float *kersum,		/* O: sum of data in the kernel              */
   long *valsum			/* O: the valid number of samples which         
				      contributed to the kernel sum          */   
);

void premed
(
   char hosout[],       	/* I: output image host name                 */
   long xhalf,          	/* I: half kernel x dim                      */
   long yhalf,          	/* I: half kernel y dim                      */
   long klines,         	/* I: no. lines in kernel                    */
   long *ksamps,        	/* I: no. samples/line in kernel             */
   long *ns,            	/* I: no. samples/line in image              */
   long *curbnd        		/* I: current input band number              */
);

void set
(
   long k,			/* I: input buffer position		     */
   long *l,			/* O: output buffer position		     */
   long ns			/* I: num of samples per line to be processed*/
);
#endif
