/****************************************************************************
SUBPROGRAM:			GETPAR

PURPOSE:	Retrieve the user specified parameters.

PROGRAM HISTORY:
VERSION	     DATE	PROGRAMMER   CODE/CONT	REQUEST
-------      ----  	----------   ---------	-------

ALGORITHM:

*****************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "worgen.h"
#include "statio.h"
#include "protos.h"

int getpar
(
    struct PARBLK *vblock,
    char *dltfnam,
    char outfile[CMLEN],
    char hostnm[CMLEN]
)

{
struct VARIABLE *var;   /* Pointer to a variable in the parameter block.*/

long	fatal = -1;	/* Fatal error flag				*/
long	status;		/* Return status indicator.			*/
long	std_out;	/* Standard output.				*/
long	access;		/* Specifiy write access for mknam routine.	*/
long	zero = 0;	/* Specifies no files were created.		*/

/* Initialize TAE and LAS processing.
  ----------------------------------*/
c_inlas(vblock,&std_out);

/* Get the input file name 
  -----------------------*/
access = IREAD;
status = c_getnam(vblock,"INFILE",&zero,hostnm,"dltf",&access);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered","dltf2pal-fatal",&fatal);

/* Get the output file name 
  -----------------------*/
access = IWRITE;
status = c_getnam(vblock,"OUTFILE",&zero,outfile,"pal",&access);
if (status != E_SUCC)
   c_errmsg("Fatal error encountered","dltf2pal-fatal",&fatal);

/* Get the DLTF entry name (if specified).
  ---------------------------------------*/
var = p_find(vblock,"DLTFENTR");
strcpy(dltfnam,SVAL(*var,0));

return(E_SUCC);
}
