#include <string.h>
#include "drophist.h"
#include "util.h"
#include "protos.h"

void getpar
(
    char taein[CMLEN],		/* tae name of the input image                */
    char hosin[CMLEN],		/* host name of the input image               */
    long *confirm		/* set to true when confirm option is        */
)
				/* selected, set to false otherwise          */

/*
*****************************************************************************

NAME:	 GETPAR	

PURPOSE: Retrieves the user supplied parameters. 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          03-Nov-83    J. Hwang           STX 
   2          26-Nov-85    K. Narayanan	      STX 
   3          01-Mar-90    K. Kunska          Conversion to 5.0   
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Retrieve tae parameter block.
   Get the name of the file for which history records should be retrieved.
   Get the flag that confirms deletion of history records.

*****************************************************************************
*/
{

long    zero = 0;

char	conflg[4];		/* option to confirm or not confirm deletions */

long	access,			/* access type for getnam                    */
	clen,			/* length of confirm flag string             */
	std_out;		/* logical unit for standard output          */

struct VARIABLE  *var;	/* pointer to a variable in the tae block     */

/*
Retrieve tae parameter block.
------------------------------
*/
c_inlas (&block, &std_out); 

/*
Get the name of the file for which history records should be retrieved.
-----------------------------------------------------------------------
*/
access = IREAD;
c_getnam (&block, "IN", &zero, hosin, "img", &access);
strcpy(taein, hosin);
printf ("\nPROCESSING LABEL OF : "); 
printf ("\nTAE= %s ", taein);
printf ("\nHOS= %s\n", hosin);

/* 
Get the flag that confirms deletion of history records.
--------------------------------------------------------
*/
/* p_find (block, "ACTION", 1, action, alen, cnt, ir); */
var = p_find(&block, "CONFLG");
strcpy (conflg, SVAL(*var, 0));
clen = (long) (strlen(conflg));
c_low2up (conflg, &clen);

*confirm = FALSE;
if (strncmp (conflg, "YES", clen) == 0)  
   *confirm = TRUE;

}
