/******************************************************************************
NAME: HISTCLOSE

FUNCTION:    Closes a label service file.

PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
    1         xx-xxx-xx   Unknown      originally c_hsclos.c
    2         15-Mar-90   K. Kunska    modified to accept action parameter
                                       specifying that records marked for
                                       deletion should be deleted
PROJECT:	LAS

ALGORITHM:

   Make a label services file name.
   Delete records marked for deletion.

******************************************************************************/
#include "drophist.h"
#include "labserv.h"
#include "protos.h"

int histclose
(
    long *fd,		/* file descriptor of input images's history */
    char hosin[],	/* host file name of the label service file  */
    long action		/* action flag:                              */
)
				/* 1 - normal close                          */
				/* 2 - remove records marked for deletion    */
				/* 3 - delete file while closing             */
{
/* long	action = 0; */
char    inhist[CMLEN];          /* buffer for input history host file name   */

/* 
Make a label services file name.
--------------------------------
*/
c_lsmknm (hosin, "his", inhist);

/* 
Delete records marked for deletion.
-----------------------------------
*/
return (c_lsclos (fd, inhist, &action));
}

