#include "drophist.h"
#include "protos.h"

#ifdef vms
#include <file.h>
#else
#include <sys/types.h>
#include <sys/file.h>
#include <fcntl.h> 
#endif

#define	LENL	13
#define	TYPL	3
#define	KEYL	16
#define	HDRL	(LENL + TYPL + KEYL)

int repos
(
    long *fd,			/* File descriptor		(input)	      */
    long *clen			/* number of char bytes to read	(in/out)      */
)

/******************************************************************************

NAME:	REPOS

FUNCTION:   Repositions the file pointer to the beginnin of a label
            services record header.

PROGRAM HISTORY:
  Version	Date       Author       Request
  -------	----	   ------       -------
     1       15-Mar-90    K. Kunska    required for conversion of DROPHIST
     2.0     29-Nov-90    D. Akkerman  corrected return values
 
PROJECT:	LAS

ALGORITHM:

   Reposition the file pointer to the beginning of the header so that 
   it can be marked for deletion.

******************************************************************************/
{

long    inf_err = 1;           /* info error return status  */

long	offset;

/*
Reposition the file pointer to the beginning of the header so that it can be
marked for deletion.
-----------------------------------------------------------------------------
*/
offset = -(*clen + HDRL);
if (lseek(*fd,offset,1) == -1)
    {
    c_errmsg("Error seeking in label services file","labserv-seek",
             &inf_err);
    return(E_FAIL);
    }
return(E_SUCC);
}
