#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block            */
    char taein[][CMLEN],         /* TAE file names of input images  	     */
    char hosin[][CMLEN],         /* host file names of input images 	     */
    long *nmrimg,		/* number of input images                    */
    long (*window)[4],		/* window specifications for each input image*/
    long (*bands)[MAXBND+1],	/* band specifications for each input image  */
    long *nbands,		/* number of bands per input image           */
    long *totbnd,		/* total number of bands to be processed     */
    long *odtype,                /* data type of the image                    */
    long *msgtim,		/* elapsed time between display messages     */
    char *minmax,		/* min max flag buffer                       */
    long *from,                  /* from value to be mapped                   */
    long *to                    /* to value to be inserted                   */
);

void proces
(
    struct PARBLK *vblock,	/*  TAE parameter block			     */
    char hosin[][CMLEN],		/* host names of input images		     */
    char hosout[][CMLEN],		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*window)[4],		/* window specification of input images      */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long *nbands,		/* number of bands per input image           */
    long totbnd,			/* total number of bands to be processed     */
    long odtype,                 /* data type of the image                    */
    long msgtim,			/* elapsed time between display messages     */
    long from,                   /* data value to be mapped                   */
    long to                     /* value to be inserted                      */
);

#endif

