#include <math.h>
#include "fft.h"

double exp10
(
    double x
);   


int nearest_power2
(
    long ns
)
{
long pow2;
long exp;

for (pow2 = 1, exp = 0;; exp++, pow2 = pow2 << 1)
   if (pow2 >= ns) break;
return(pow2);
}


void pad_to_pow2
(
    unsigned char *in,
    long in_ns,
    float *out,
    long out_ns
)
{
register long i;
register unsigned char *in_ptr;
register float *out_ptr;

for(in_ptr=in,out_ptr=out,i=in_ns;i--;*out_ptr++=(float)*in_ptr++,*out_ptr++=0.0);
for (i = out_ns - in_ns; i--; *out_ptr++ = 0.0, *out_ptr++ = 0.0);
return;
}

void pad_back
(
    float *out,
    long out_ns,
    unsigned char *in,
    long in_ns
)
{
register float temp;
register long i;
register unsigned char *in_ptr;
register float *out_ptr;

/*for (in_ptr=in,out_ptr=out,i=in_ns;i--;*in_ptr++=*out_ptr++/out_ns,out_ptr++);*/
for (in_ptr = in, out_ptr = out, i = in_ns; i--; out_ptr++)
   {
   temp = *out_ptr++/(float) out_ns;
   temp = (temp > 255.0) ? 255.0 : temp;
   *in_ptr++ = (temp < 0.0) ? 0 : (unsigned char)temp;
   }
return;
}


void calc_mag_phase
(
    float *freq,
    long dim,
    unsigned char *outbuf
)
{
static long n;
static long first = 1;
static float dc;
static float slope;
static float offset;
static float min;
static float scale;
float minexp = 6.0;
double temp;
long i;
long real;
long imag;
static long nhalf;

if (first)
   {
   scale = 255.0 / TWOPI;
   n = dim + 2;
   nhalf = n / 2;
   dc = sqrt(freq[0] * freq[0] + freq[1] * freq[1]) + 1.0;
   if (dc == 1)
      {
      slope = 1.0;
      offset = 0.0;
      }
   else
      {
      min = dc * exp10(-(minexp));
      slope = 255.0 /  log10(dc/min);
      offset = -255.0 * log10(min) / log10(dc/min) + 0.5;
      }
   first = 0;
   }

for (i = 0, real = 0, imag = 1; i < nhalf; i++, real+=2, imag+=2)
   {
   temp = (freq[real] * freq[real]) + (freq[imag] * freq[imag]);
   temp = sqrt(temp);
   if (temp == 0.0) temp = offset;
   else temp = slope * log10(temp) + offset;
   outbuf[i] = (temp > 255.0) ? 255 : (unsigned char) temp;
   if (freq[real] == 0.0) outbuf[i+nhalf] = 0.0;
   else
     outbuf[i+nhalf]=(unsigned char)(scale*atan2(freq[imag],freq[real])+128.0);
   }
return;
}

double exp10
(
    double x
)
{
return(pow(10.0,x));
}

