/***********************************************************************
NAME: BLOB2

PURPOSE: Applies the look-up table to output image for merging classes

PROGRAM HISTORY:
Version	Date    Author             Request
-------	----    ------             -------
1       01/85   Y. Sheu            Initial development
2       09/89   K. Narayanan       Conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS
***********************************************************************/
#include "getblob.h"
#include "pixman.h"

void blob2
(
  long lcntrs[],            /* I: Class counters for each line */
  long wind[],              /* I: Image window */
  short lut[]               /* O: Look-up table for merging regions */
)
{

  long    zero = 0;
  char    *prog_name = "GETBLOB"; /* program name            */

  long line = GEN2;
  long msg_flag = GEN2;
  long np = EWORD;
  long type = EWORD;

  printf ("\nPass 2 - compressing output image pixel values ...\n\n");

  /* Initialize and enable processing message utility
  ---------------------------------------------------*/
  c_inittm(prog_name,"Processed","line",""," ",&wind[NL],&zero,&msgtim,
           &msg_flag);
  curent = 1;
  c_startm();

  np = wind[NS];
  for (line = 0; line < wind[NL]; line++, curent++)
  {
    c_estep(&gdesc_out);
    if (lcntrs[line]  !=  0)  
      c_pxlkup(&outbuf[opoint],&outbuf[opoint],&np,&type,lut,&type);
  }

  c_estep(&gdesc_out);
  c_stoptm();
  c_egclse(&gdesc_out);
}
