#ifndef GETBLOB_H
#define GETBLOB_H

/* include files, global parameters, and definitions for GETBLOB   */

#include <stdio.h>
#include "las.h"
#include "util.h"

extern struct PARBLK block;                   /* TAE parameter block     */

extern struct FDESC *fdesc[2];                     /* file descriptors        */
extern struct GDESC *gdesc_in;                     /* group descriptor        */
extern struct GDESC *gdesc_out;                    /* group descriptor        */
extern long	*inbuf;                	       /* image i/o buffer        */
extern long	ipoint,                        /* offsets into image i/o  */
		opoint;                        /* for input and output bands */
extern long	min_max;                       /* minmax option flag      */
extern long 	msgtim;                        /* message interval        */
extern long	num_outfiles;                  /* number of output files  */
 
extern short	*outbuf;                       /* image i/o buffer        */

extern long	curcat;                /* parameters for processing */
extern long	curent;                /* message utility         */

extern char    out_files[1][CMLEN];              /* output file names       */


/* Function prototypes for GETBLOB.  las.h MUST
   be included before this file
-----------------------------------------------*/

/* blob2.c */
void blob2
(
  long lcntrs[],            /* I: Class counters for each line */
  long wind[],              /* I: Image window */
  short	lut[]               /* O: Look-up table for merging regions */
);

/* doblob.c */
void doblob
(
  long wind[],              /* I: Input image window */
  long *classnum,           /* O: Class to be searched */
  long lcntrs[],            /* O: No. classes in each line */
  short	table[],            /* O: Table for merge */
  long *iter,               /* O: Flag for second pass */
  long *next                /* O: Last assigned class number */
);

/* filspec.c */
void filspec
(
  long iter,
  char hos_in[][CMLEN],            /* I: Input image host name */
  char hos_out[],                  /* I: Output image host name */
  long image_band_num[][MAXBND+1], /* I: Band numbers */
  long wind[][4]                   /* I: Input image window */
);

/* getpar.c */
void getpar
(
  char hos_in[][CMLEN],                /* O: Input images host name */
  char las_out[][CMLEN],               /* O: Output image LAS name */
  char hos_out[][CMLEN],               /* O: Output image host name */
  long image_band_num[1][MAXBND +1],   /* O: Band numbers */
  long wind[][4],                      /* O: Input image window */
  long *class_num                      /* O: Class to be searched */
);

/* merge.c */
void merge
(
  short	table[],          /* I/O: Sequential look-up table for pass 2 */
  short	lut[],            /* O: Look-up table for merging regions */
  long class,             /* I: Last class number assigned */
  double *maxval,         /* O: Maximum pixel value */
  double *minval          /* O: Minimum pixel value */
);

/* strata.c */
void strata
(
  long *np,
  long classnum, 
  long buffer[400], 
  long cntrs[]
);

#endif
