/****************************************************************************
NAME: GETPAR

FUNCTION: Gets parameters 

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
     1          Jan-85   Y. Sheu
     2       18-Sep-89   K. Narayanan      conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

***********************************************************************/
#include "getblob.h"

void getpar
(
  char hos_in[][CMLEN],                /* O: Input images host name */
  char las_out[][CMLEN],               /* O: Output image LAS name */
  char hos_out[][CMLEN],               /* O: Output image host name */
  long image_band_num[1][MAXBND +1],   /* O: Band numbers */
  long wind[][4],                      /* O: Input image window */
  long *class_num                      /* O: Class to be searched */
)
{

long    fatal_err = -1;
long    zero = 0;
long    one = 1;

struct	DDR	ddr;		    /* image ddr			  */
struct VARIABLE *var;               /* pointer to a variable in las block */

char    mnmx[4];      		/* minimum and maximum option */

double	maxval,	                    /* max and min values                 */
	minval;

long flag[1][2],                    /* flag for subwindows                */
	imglimit = 1,               /* maximum number of images           */
	itype,
	num_image_bands,	    
	num_inbands,
	num_inimages,
	same_window,                /* flag indicating if images have     */
                                    /* same window                        */
	std_out;                    /* logical unit for standard output   */

char	las_in[1][CMLEN];	            /* input images las names             */

/*
initialize program 
------------------
*/
c_inlas (&block, &std_out);

/*
get and validate input image parameters
---------------------------------------
*/
c_getin (&block, "IN", &zero, las_in, hos_in, &num_inimages, wind, 
         image_band_num, &num_image_bands, &num_inbands, &imglimit, 
         &same_window, flag);

if (num_inbands  >  1) 
   c_errmsg ("Input image must be single band", "getblob-in", &fatal_err); 

c_getddr (hos_in[0], &ddr);
if (ddr.dtype == EREAL) 
   c_errmsg ("Input image cannot be real data type", "getblob-dtype",
             &fatal_err);
/*
get and validate output image parameters
----------------------------------------
*/
if (c_getout (&block, "OUT", las_out, hos_out) != E_SUCC)
   c_errmsg ("Error getting output image name", "mindist-out", &fatal_err);

/*
get class number to be searched
-------------------------------
*/
itype = ELONG;
c_getnum (&block, "CLASSNUM", &one, &itype, class_num); 

/*
check validity of specified class number
----------------------------------------
*/
c_minmax (hos_in, &one, wind, image_band_num, &one, &minval, &maxval);

if (*class_num  >  maxval  || *class_num  <  minval) 
   c_errmsg ("Specified class number beyond range of input image data",
             "getblob-class", &fatal_err);

/*
Get las globals
---------------
*/
var = p_find( &block, "$msgtim");
msgtim = IVAL( *var, 0);

var = p_find( &block, "$MINMAX");
strcpy( mnmx, SVAL( *var, 0));

if (mnmx[0] == 'Y') 
	min_max = TRUE;
else 
	min_max = FALSE;

}
