/***************************************************************************
NAME: MERGE

PURPOSE: Restructures the look-up table for the classes requiring multiple 
         steps of merging

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1            Jan-85   Y. Sheu
   2         18-Sep-89   K. Narayanan       Conversion to 5.0

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

***************************************************************************/
#include "getblob.h"

void merge
(
  short table[],          /* I/O: Sequential look-up table for pass 2 */
  short lut[],            /* O: Look-up table for merging regions */
  long class,             /* I: Last class number assigned */
  double *maxval,         /* O: Maximum pixel value */
  double *minval          /* O: Minimum pixel value */
)
{

long    fatal_err = -1;

long	i, 
	icount, 
	new, 
	bufsiz,
	old;

short   *seq;        /*  [32767]; */

icount = 1;
lut[0] = 0;
*minval = table[0];

/* allocate array 
-----------------
*/
if ((seq = (short *) c_ealloc(fdesc, &bufsiz)) == NULL)
	c_errmsg("Error allocating dynamic memory","getblob-alloc",&fatal_err);
/*
  generate the sequential look-up table
---------------------------------------
*/
for (i = 2; i <= class; i++)
   {
   if (table[i-1]  ==  i) 
      {
      icount++;
      seq[i-1] = (short) icount;
      }  
   }
*maxval = icount;

/*
 merge the numbers on the output image
--------------------------------------
*/
for (i = 2; i <= class; i++)
   {
   old = i;
   new = table[i-1];
   while (TRUE)
      {
      table[i-1] = table[old-1];
      if (new  ==  old) break;
      old = new;
      new = table[new-1];
      }
   lut[i] = seq[table[i-1]-1];
   }
}
