#include "grid.h"

FUNCTION dcheck (type, gtext)

long	type;			/* data type requested for output image */
float   gtext;			/* grid value */
/*
NAME: DCHECK

FUNCTION:
  Checks gtext to see if it is in the dtype data range

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    4.0       14-JUN-90   B. ALLAM, STX     Fixes
    3.0       30-MAR-90   J. MCGUTHRY	    Conversion
    2.0       20-APR-87   B. KOVALICK
    1.0       01-OCT-84   B. DEALY
*/
{
long    ipval;

ipval = (int)gtext;
if ( (float)ipval  !=  gtext) 
  if (type != EREAL)
    c_errmsg("Grid value may not be real if input image is byte or integer",
             "grid-type",&fatal_err);

if (type  ==  EBYTE) 
  if (gtext  <  0  ||  gtext  >  255) 
    c_errmsg("Grid pixel value not in range of input image",
             "grid-type",&fatal_err);

if (type  ==  EWORD) 
  if (gtext  <  MINWORD || gtext >  MAXWORD) 
    c_errmsg("Grid pixel value not in range of input image",
             "grid-type",&fatal_err);

if (type  ==  ELONG) 
  if (gtext < MINLONG || gtext > MAXLONG)
    c_errmsg("Grid pixel value not in range of input image",
             "grid-type",&fatal_err);

}
