#include "grid.h"

FUNCTION filspec (hos_in, wind, nmring, totbnd, dtype, hos_out,
bands,out_img_bands)
                   
long          out_img_bands[][MAXBND+1];		/* band numbers */
long          nmring,                  /* no. of input images */
	      bands[][MAXBND+1],       /* band numbers */
              totbnd,		       /* total no. of bands */
 	      dtype,		       /* data type of image */
              wind[][4];               /* input image windows */
char          hos_in[][CMLEN],          /* input image host name descriptors */
	      hos_out[][CMLEN];           /* output image host name descriptor */
{
/*
**********************************************************************
NAME: FILSPEC

PROGRAM HISTORY:
  Version	Date       Author      	    Request
  -------	----	   ------           -------
    5.0       29-NOV-90   W. Xia, STX       Fixes
    4.0       14-JUN-90   B. ALLAM, STX     Fixes
    3.0       30-MAR-90   J. MCGUTHRY	    Conversion
    2.0       20-APR-87   B. KOVALICK
    1.0       01-OCT-84   B. DEALY

FUNCTION: sets up the image i/o interface

ALGORITHM:
     Open each input image 
     Open output image same size as input image
     Group input images
     Group output images
     Update output DDR
***********************************************************************
*/
   char	   *c_ealloc();

   long    stat,                  	/* flag for EOPENS procedure */
           type, access,                /* file specifications       */
    	   opt[2],			/* conversion option */
           img, nib,        		/* counter variables         */
           comb_flag = NOCOMB,		/* Combination flag for bands */
           obufsiz, bufsiz;      	/* image i/o buffer size     */
   double  line_inc, samp_inc;    	/* line and sample increments*/
   long    i;

/*
 set up input image
 ------------------
*/
access=IREAD;
/*  type = EREAL; */
for (img=0, nib=0;img<nmring;++img)
  {
  stat = c_eopens (&fdesc[img], hos_in[img], bands[img], &wind[img][SL],
                   &wind[img][SS], &wind[img][NL], &wind[img][NS], &in[img],
                   &access, &dtype, &zero, &zero);
  if (stat != E_SUCC )
    c_errmsg ("Error opening input image", "grid-inopen", &fatal_err);
  nib += nbands[img];   
  }
fdesc[++img] = 0;       

/*
set up output image
-------------------*/
access = IWRITE;
/* opt[0] = dtype;
  opt[1] = 0;
*/
stat = c_eopens(&fdescout[0],hos_out,&totbnd,&one,&one,
          &wind[0][NL],&wind[0][NS],out,&access,&dtype,&zero,&zero);
if (stat != E_SUCC )
  c_errmsg ("Error opening output image", "grid-outopen", &fatal_err);
fdescout[1] = 0;

/*
set up group containing input and output bands
---------------------------------------------- */
if ((buf = (unsigned char *) c_ealloc(fdesc, &bufsiz)) == NULL)
  c_abort (&vblock, "Error allocating dynamic memory", "grid-alloc");
if ((outbuf = (unsigned char *) c_ealloc(fdescout, &obufsiz)) == NULL)
  c_abort(&vblock, "Error allocating dynamic memory", "grid_alloc");


if (c_egroup (fdesc, &gdesc, buf, &bufsiz) != E_SUCC)
  c_abort(&vblock, "Error grouping image bands", "grid_group");
if (c_egroup(fdescout, &gdescout, outbuf, &obufsiz) != E_SUCC)
  c_abort(&vblock, "Error grouping image bands", "grid_group");
                      
for (i = 0; i < totbnd;  i++)                    
   out_img_bands[0][i] = i + 1;

/*
update DDR
----------
*/
line_inc = 1;
samp_inc = 1;
c_upddr (&vblock, hos_in, hos_out, &nmring, wind, bands, nbands, 
         &line_inc, &samp_inc, &totbnd, &comb_flag);

}
