/*****************************************************************************
NAME				 GRIDFIT 

*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "geompak.h"
#include "protos.h"

int main
(void)
{
struct GEOGRID grid;		/* Geometric mapping grid */
struct PARBLK  vblk;		/* TAE variable block */
long  std_out;			/* Standard output LUN for inlas */
long  mode = IREAD;		/* IREAD flag for getnam routine */
long  fatal = -1;		/* Fatal error flag for c_errmsg */
long  zero = 0;			/* Constant of zero */
char  fname[CMLEN];		/* Host name of geometric mapping grid file */
char  tmpstr[1][CMLEN];

c_inlas(&vblk, &std_out);
if(c_getnam(&vblk, "INGRID", &zero, fname, "grid", &mode) != E_SUCC)
  c_errmsg("Fatal error encountered","gridfit-fatal",&fatal);
if(c_getgrd(fname, &grid) != E_SUCC)
  c_errmsg("Fatal error encountered","gridfit-fatal",&fatal);
fit(&grid);

strcpy(tmpstr[0], "\0");
c_complt("GRIDFIT", tmpstr, &zero);

return EXIT_SUCCESS;

}
