c*******
c******* This program reads the transfer function (tf) generated
c******* by "system", modifies it if sampling was chosen in 
c******* "SYSTEM", finds the inverse transfer function or the
c******* wiener filter, then finds the restoration line spread
c******* function (lsf) with or without windowing.
c*******
c******* This program is the result of merging modify.for, 
c******* invtf.for and invlsf.for
c******* version 1.2  lynnette wood, robert schowengerdt
c*******
c*******
c******* modified from RESTORE 8/21/87 by djm to eliminate questions
c******* which are not necessary for an end user to answer
c*******
c******* Converted to SUN 4 8/30/89 by D. Steinwand
c*******    Used f77cvt, then f77
c*******    This function is driven by KERNEL.PDF
c*******    
      program urestore3
c*******
c      implicit undefined (a-z)
      complex tf(2048)
      real re, im, frqinc, sum1, sum2, var
c*******
c******* define files:
c*******
c******* file1 = input file: system transfer function  
c******* file2 = output file: reciprocal transfer function
c******* file3 = output file: wiener filter
c******* file4 = output file: restoration line spread function
c*******
      integer max, i, ii, iii, j, nfreq, nhalf, norder, npts, power2, 
     &file1, file2, file3, file4, file5, kern, ianswer, rlun
c     write(unit=*, fmt=*) ' >>>>>>>> begin URESTORE'
      file2 = 29
      file3 = 28
      file4 = 27
      file5 = 13
      rlun = 99
c*******
c******* if sampling was chosen in "system", then the resulting tf 
c******* is modified: it is set to zero for frequencies greater 
c******* than one-half cycle per pixel.
c*******

      frqinc = .03125
c*******
      max = ifix(0.5 / frqinc)
c     write(unit=*, fmt='(a)') '$track (1) or scan (2) mode? '
      open (unit=file5)
      rewind (unit=file5)
      read(unit=file5, fmt=*) ianswer
      if (ianswer .eq. 1) then
      file1 = 16
c     write(unit=rlun, fmt=*) ' (URESTORE) mode is along TRACK'
      else if (ianswer .eq. 2) then
      file1 = 12
c     write(unit=rlun, fmt=*) ' (URESTORE) mode is along SCAN'
      else
c     write(unit=rlun, fmt=*) 
c    &' (URESTORE) illegal scan mode, defaulting to SCAN'
      file1 = 12
c*******
      end if
      open (unit=file1)
      rewind (unit=file1)
c     write(unit=rlun, fmt=*) ' (URESTORE) mode is along TRACK'
c     write(unit=*, fmt='(a)') '$enter variance: '
      read(unit=file5, fmt=*) var
c     write(unit=*, fmt='(a)') '$enter kernel size in pixels:'
c*******
c******* input of data from "system"
c*******
      read(unit=file5, fmt=*) kern
      i = 0
c     write(unit=*,fmt=*)'max=',max,'kern=',kern
 10   i = i + 1
      read(unit=file1, fmt=*, end=30) j, re, im
      tf(i) = cmplx(re,im)
      if (i .gt. max) tf(i) = cmplx(0.0,0.0)
c     write(unit=*,fmt=*)'i=',i,'j=',j,'re=',re,'im=',im
      go to 10
c*******
c******* do a wiener
c*******
   30 continue
      nfreq = i - 1
      nhalf = nfreq - 2
      norder = nfreq - 1
      npts = 2 * (nfreq - 1)
      call power(npts, power2)
c     write(unit=*, fmt=*) '>>>>>> nfreq = ', nfreq, ' powerof2 = ', 
c    &power2
c*******
c******* the restoration line spread function (lsf) corresponding to
c******* the preceding choice of restoring transfer function is now foun
cd;
c******* fft of reciprocal transfer function or wiener filter;
c******* generate other half of data in frequency domain; set imag (last
c******* point) to zero.
c*******
      call wiener(tf, nfreq, frqinc, var, file3)
      do 20 i = 1, nhalf
      ii = nfreq + i
      iii = nfreq - i
      tf(ii) = conjg(tf(iii))
 20   continue
      tf(nfreq) = cmplx(real(tf(nfreq)),0.0)
c*******
c******* reorder the data in spatial domain, compute window center and a
cpply
c******* a hanning window
c*******
      call ifft(tf, power2)
      do  40 i = 1, norder
      ii = norder + i
      save = tf(ii)
      tf(ii) = tf(i)
      tf(i) = save
c*******
 40   continue
      sum1 = 0.0
      do 50 i = 1, npts
      sum1 = sum1 + tf(i)
 50   continue
      i = 0
      sum2 = 0.0
 200  if (sum2 .le. (sum1 / 2.)) then
      i = i + 1
      sum2 = sum2 + tf(i)
      go to 200
      else
      go to 210
      endif
 210  continue
c*******
      if (sum2 .gt. (sum1 / 2.)) i = i - 1
      call hanning(tf, norder, i, frqinc, kern)
c*******
c******* exit
c*******
      call znorm(norder * 2, tf, file4)
c     write(unit=*, fmt=*) ' >>>>>>>> exiting URESTORE'
      end
c*******
c******* subroutine for output of complex one-dimensional arrays
c*******
      subroutine cwrite(i, data, ifile)
c*******
c      implicit undefined (a-z)
      complex data
      real mod, phase, pi, r, a
c*******
      integer i, ifile
      pi = acos(-1.0)
      r = real(data)
      a = aimag(data)
      mod = sqrt((r ** 2) + (a ** 2))
      if ((r .eq. 0.0) .and. (a .eq. 0.0)) then
      phase = 0.0
      else
      phase = atan2(a,r)
      if (phase .gt. (pi / 2.)) phase = phase - pi
c*******
      end if
c     write(unit=ifile, fmt=2000) i, real(data), aimag(data), mod, phase
 2000 format(1x,i5,1p4e17.9)
      return 
      end
c*******
c******* performs a wiener filter in the frequency domain
c*******
      subroutine wiener(tf, nfreq, frqinc, var, nfile)
c*******
c      implicit undefined (a-z)
      complex tf(2048)
      integer nfreq, nfile, i
c*******
      real var, corr, corwdth, pi, cmod, freq, frqinc, signal
c     write(unit=*, fmt=*) 'Entering WIENER'
c     write(unit=99, fmt=*) ' (URESTORE/WIENER) variance = ', var
      corwdth = 5.
      corr = 1. / corwdth
c*******
      pi = acos(-1.)
      do 50 i = 1, nfreq
      cmod = sqrt((real(tf(i)) ** 2.) + (aimag(tf(i)) ** 2.))
      if (cmod .eq. 0.0) then
      tf(i) = cmplx(0.0,0.0)
      else
      freq = float(i - 1) * frqinc
      signal = ((2. * var) * corr) / ((corr ** 2) + (((2. * pi) * freq)
     & ** 2.))
      tf(i) = ((cmod ** 2) / tf(i)) / ((cmod ** 2) + (1. / signal))
      end if
      call cwrite(i, tf(i), nfile)
c*******
 50   continue
      return 
      end
c*******
c******* finds the power of two associated with the number npts, where
c******* npts = 2*(nfreq-1)      nfreq = 2**(power2-1) + 1
c*******
      subroutine power(npts, power2)
c*******
c      implicit undefined (a-z)
c*******
      integer power2, n, npts
      power2 = 0
      n = npts
 300  if (n .ge. 2) then
      power2 = power2 + 1
      n = n / 2
      go to 300
      else
      go to 310
c*******
      endif
 310  continue
      return 
      end
c*******    
c******* utility to calculate 1-d inverse fft
c******* ref: gonzalez and wintz, "digital image processing"
c*******
      subroutine ifft(f, ln)
c*******
c      implicit undefined (a-z)
      complex f(2048), u, w, t, cmplx
      real pi
c*******
c******* initialize
c*******
      integer i, j, k, l, ln, le, le1, n, nv2, nm1, ip
c     write(unit=*, fmt=*) 'Entering IFFT'
      pi = 3.141593
      n = 2 ** ln
      nv2 = n / 2
c*******
c******* do this
c*******
      nm1 = n - 1
      j = 1
      do 70 i = 1, nm1
      if (i .lt. j) then
      t = f(j)
      f(j) = f(i)
      f(i) = t
      end if
      k = nv2
 400  if (k .lt. j) then
      j = j - k
      k = k / 2
      go to 400
      else
      go to 410
      endif
 410  continue
      j = j + k
c*******
c******* next do this
c*******
 70   continue
      do 80 l = 1, ln
      le = 2 ** l
      le1 = le / 2
      u = (1.0,0.0)
      w = cmplx(cos(pi / le1),sin(pi / le1))
      do 90 j = 1, le1
      do 100 i = j, n, le
      ip = i + le1
      t = f(ip) * u
      f(ip) = f(i) - t
      f(i) = f(i) + t
 100  continue
      u = u * w
 90   continue
c*******
c******* then do this
c*******
 80   continue
      do 110 i = 1, n
      f(i) = f(i) / float(n)
 110  continue
      return 
      end
c*******
c******* subroutine for output of real one-dimensional arrays
c*******
      subroutine rwrite(i, data, ifile)
c*******
c      implicit undefined (a-z)
      real data
c*******
      integer i, ifile
      write(unit=ifile, fmt=2000) i, data
c*******
 2000 format(1x,i5,1p4e17.9)
      return 
      end
c*******
c******* normalize the windowed kernel
c*******
      subroutine znorm(max, tf, nfile)
c*******
c      implicit undefined (a-z)
      complex tf(2048)
      real sum, sum2
c*******
c*******
c*******
      integer i, max, nfile
c     write(unit=*, fmt=*) 'Entering ZNORM'
      sum = 0.0
      do 120 i = 1, max
      sum = sum + real(tf(i))
c*******
 120  continue
      sum2 = 0.0
      do 130 i = 1, max
      call rwrite(i, real(tf(i)), nfile)
      sum2 = sum2 + (real(tf(i)) / sum)
 130  continue
c*******
c     write(unit=99, fmt=*) 
c    &' (URESTORE/ZNORM) the sum of the elements is ', sum2
      return 
      end
c*******
c******* multiplies the deconvolution lsf by a user-specified "hanning" 
cwindow
c*******
      subroutine hanning(lsf, nhalf, m, frqinc, kern)
c*******
c      implicit undefined (a-z)
      complex lsf(2048)
      real tau, pi, frqinc
c*******
c*******
c*******
      integer i, kern, nhalf, m
c     write(unit=*, fmt=*) 'Entering HANNING'
      if ((kern .gt. 16) .or. (kern .lt. 2)) then
c     write(unit=99, fmt=*) 
c    &' (URESTORE/HANNING) illegal kernel size, defaulting to 7'
      kern = 7
      end if
c*******
c     write(unit=99, fmt=*) ' (URESTORE/HANNING) kernel size = ', kern
      tau = float(kern - 1) / (2. * frqinc)
      pi = acos(-1.0)
      do 140 i = 1, nhalf * 2
      lsf(i) = (lsf(i) * (1. + cos((pi * float((i - m) + 1)) / tau))) / 
     &2.
      if ((i .lt. (m - tau)) .or. (i .gt. (m + tau))) lsf(i) = 0.0
c*******
 140  continue
      return 
      end
