	SUBROUTINE RDFIL(IFCB,UNIT,ha1,CLEN,ncol,status)
C  rdfil opens an IBIS tabular file and returns the number of columns
C  and the number of records in the file
C--------------------------------------------------------------------
C  10-9-86 B. AILTS changed parameter 'nofile' to 'status' to help
C  trap open and read errors.
C
C  12-29-86 K. Zanter  added check that input file does not have more
C 		       then 32767 rows and 35 columns.
C--------------------------------------------------------------------

	include 'las.fin'

	integer*4 buf(128)
	integer*4 clen
	integer*4 ifcb(XIFDIM)
	integer*4 ncol
	integer*4 nrcol
	integer*4 status
	integer*4 unit
	character*(132) ha1

C  10-8-86 by B.Ailts - replaced STATCH with errmsg + return to help
C  trap errors in application programs
C--------------------------------------------------------------------
	CALL XIOPIN(IFCB,UNIT,HA1,XINOUT,STATUS)
	if (status .ne. XSUCC) then
		call errmsg('Error opening input file','RDFIL-open',1)
		status = EFAIL
		return
	end if
	CALL XIREAD(IFCB,BUF,1,1,1,STATUS)
	if (status .ne. XSUCC) then
		call errmsg('Error reading input file','RDFIL-read',1)
		status = EFAIL
		return
	end if
	CALL XIWAIT(IFCB,STATUS)
	if (status .ne. XSUCC) then
		call errmsg('Error reading input file','RDFIL-read',1)
		status = EFAIL
		return
	end if

	CLEN = BUF(1)
	if (clen .gt. 32767) then
	   call errmsg('Input file has more than 32767 rows',
     +		       'RDFIL-maxrows',1)
	   status = EFAIL
	   return
        endif

	NRCOL = (CLEN+127)/128

	NCOL = (IFCB(XLINES)-1)/NRCOL
        if (ncol .gt. 35) then
 	   call errmsg('Input file has more than 35 columns',
     +	 	       'RDFIL-maxcol',1)
	   status = EFAIL
	   return
        endif

	status = ESUCC
	RETURN
	END
