/*****************************************************************************
NAME: GET_LINEAR_UNITS

PURPOSE:  Returns the geoTIFF code for the LAS projection units.

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS
*****************************************************************************/

#include "las.h"
#include "geompak.h"
#include "cproj.h"
#include "protos.h"

unsigned short get_linear_units
(
    const char *unitstr      /* I: Units used (in English)                */
)

{
    unsigned short unit;       /* geoTIFF unit code number                  */
    int out_unit;              /* Output projection unit code               */

    out_unit = c_string2unit(unitstr);

    if (out_unit == METER)
        unit = 9001;
    else if (out_unit == FEET)
        unit = 9003;
    else 
    {
        c_lasmsg(FALSE, "las2geotiff-warn", 
                "GeoTIFF does not recognize the DDR projection units %s "
                 "as valid", unitstr);
        c_lasmsg(FALSE, "las2geotiff-warn","Setting linear units to undefined");
        unit = 0;   /* 0 = undefined */
    }
    return (unit); 
}
