
/******************************************************************************
NAME:     lasshell.c 
PURPOSE:  program main()

PROGRAM HISTORY
-------------------------------------------------------------------------------
Date      Programmer       Changes
--------  ---------------  ----------------------------------------------------
Apr 1995  David Zokaites   Original development. 
Jun 1995  David Zokaites   TAE parm command is now string instead of (string 80)
Oct 1995  David Zokaites   Deleted local copy of c_lasmsg.c (now a support); 
			   updated users guide;  released application to 
			   $LASCONTRIB 
Jun 1996  David Zokaites   Added parameter MESSAGES;  called c_errmsg() instead 
			   of c_lasmsg() in shell.c to avoid a rare memory 
			   error;  wrote function print_out()
******************************************************************************/
 
#include <stdlib.h>   /* for call to free() */ 
#include "lasshell.h" /* proc header file */ 
#include "util.h"
#include "protos.h"





int main
(void)
{
/* declare variables */ 
   char outlist[1][CMLEN]; /* list of out files, c_complt() expects 2-d array */
   long parmval,           /* for loop index, parameter values */ 
        std_out,           /* standard output */ 
	zero = 0;          /* number of output files */ 
   long status;            /* status code, return code from q_out() */ 
   struct PARBLK pblock;   /* tae parameter block */ 
   struct UPARMS uparms;   /* user parameters */ 
/* initialize las and tae */ 
   c_inlas (&pblock, &std_out); 
/* get user parameters */ 
   init_parms (&uparms); 
   getpar (&pblock, &uparms);
/* execute shell command and get values for OUT */ 
   run_shell (&uparms);
/* return data to tae */ 
   /* "OUT" is uppercase for better TAE error messages */ 
   if ((uparms.outtype == INTEGER && q_intg   (&pblock, "OUT", uparms.actcount, 
		         uparms.outint,  P_UPDATE)  != SUCCESS)
   ||  (uparms.outtype == REAL    && q_real   (&pblock, "OUT", uparms.actcount, 
		         uparms.outreal, P_UPDATE)  != SUCCESS)
   ||  (uparms.outtype == STRING  && q_string (&pblock, "OUT", uparms.actcount, 
		         uparms.outstr,  P_UPDATE)  != SUCCESS)
   )
      c_lasmsg (TRUE, "lasshell-fatal", 
      "Fatal error encountered:  unable to copy OUT to TAE variable block"); 
   if ((status = q_out (&pblock)) != SUCCESS)
      c_lasmsg (TRUE, "lasshell-tae", 
      "Unable to return OUT to TAE, host error code is %d", status); 
/* free memory that was allocated in get_out() */
   for (parmval=0; parmval<uparms.actcount; parmval++)   
      free (uparms.outstr[parmval] ); 
/* complete */ 
   c_complt ("LASSHELL", outlist, &zero);

   return EXIT_SUCCESS;
   
}

