
/* lasshell.h:  proc header file */ 
 
#include "las.h"     /* las header file */ 
 
#define COMCOUNT 50  /* max count for parameter COMMAND */ 
#define PCOUNT   10  /* max count for parameters SCRIPT, INFILE */ 
 
/* TAE variable types allowed for output parameter OUT */ 
   enum parmtype 
   {
      INTEGER, REAL, STRING  
   }; 





/* data structure for user parameters, grouped by tae parm */ 
   struct UPARMS 
   {
   /* parameter command */ 
      char *command[COMCOUNT];    /* shell commands */ 
      long  comcount;             /* count of command[] */ 
   /* script */ 
      char  shost[PCOUNT][CMLEN]; /* host name of shell scripts to execute */ 
      long  scount;               /* number of scripts */ 
   /* infile */ 
      char  ihost[PCOUNT][CMLEN]; /* host name of input files to process */ 
      long  icount;               /* number of files */ 
   /* outtype */ 
      char typestr[30];           /* output type for user messages */ 
      enum parmtype outtype;      /* output parm type */ 
      long outlen;                /* length of output string parm */ 
   /* outcount */ 
      char countstr[20];          /* outut count for user messages */
      long actcount,              /* actual      count of output var */ 
	   mincount,              /* min allowed count of output var */ 
	   maxcount;              /* max allowed count of output var */ 
   /* out */ 
      int    outint [MAXVAL];     /* output integer var, must be int for tae */
      double outreal[MAXVAL];     /* output real    var, must be double */
      char  *outstr [MAXVAL];     /* output string  var, must be char*  */ 
   /* fieldsep */
      long  fscount;              /* n values specified for fieldsep */ 
      char *fieldsep;             /* character used to separate strings */ 
   /* messages */ 
      struct 
      {
	 long 
	      outtype,  /* flag, write type of OUT */ 
	      outval,   /* flag, write value of OUT */  
	      shellcmd, /* flag, write shell command */ 
	      stanout;  /* flag, write standard output of shell command */ 
      } messages;
   };

