#ifndef PROTOS_H
#define PROTOS_H

void file_names
(
    char *parmname,            /* input:  name of the parm being processed, used
					 only for error messages */
    long parmcount,           /* input:  number of values in inlist */
    char *inlist[PCOUNT],      /* input:  user values of file names */
    long execute,             /* input:  if (execute) this file must have 
					 execute access, else it must have read
					 access. */
    char ohost[PCOUNT][CMLEN] /* output:  host name of input files */
);

void parse_tilde
(
    char *inname,   /* input:   filename with a '~' optionally imbedded */
    char *outname  /* output:  expanded filename, with no '~' */
);

void init_parms
(
    struct UPARMS *uparms   /* output:  data structure of user parms that has
                                        been set to zero */
);

void getpar
(
    struct PARBLK *pblock,  /* input:   tae parameter block */
    struct UPARMS *uparms  /* output:  user parameter values */
);

void get_type
(
    char *outtype1,         /* input:   1st user value of outtype */
    char *outtype2,         /* input:   2nd user value of outtype, may be NULL */
    struct UPARMS *uparms  /* output:  parsed outtype */
);

void get_count
(
    char *outcount0,        /* input:   user value of outcount */
    struct UPARMS *uparms  /* output:  parsed outtype */
);

void tolow
(
    char *string  /*  input as mixed case string, 
                     output as lower case string */
);

void run_shell
(
    struct UPARMS *uparms  /* input:  user parameters for shell command,
			      output:  data to return to user via OUT */
);

void print_out
(
    struct UPARMS *uparms  /* input:  user parameters */
);

void get_out
(
    FILE *comout,          /* input:   pipe to close on fatal error */
    char *stanout,         /* input:   command's standard output */
    struct UPARMS *uparms /* output:  data to return to user via parm OUT */
);

#endif

