
/******************************************************************************
NAME:     getname()
PURPOSE:  c_dkcre() creates a symbolic link as well as a data file.
          get name of data file created by c_dkcre(), delete this file, 
	  and return its name 
******************************************************************************/



// include files
#include <errno.h>  // for use of errno 
#include <stdio.h>  // for call to popen() 
#include <string.h> // for call to strerror()
extern "C" 
{
#include "las.h"    // standard LAS header file
}



FUNCTION char * getname (
   const char *linkfile)  // input:  name of symbolic link created by c_dkcre()
{

// declare variables 
   static char datafile[CMLEN]; // output:  name of data file 
   char syscmd[CMLEN];   // an operating system command 
   FILE *comout;         // used to open a pipe to a unix command 

// open pipe to system command to execute ls -l 
   sprintf (syscmd, "ls -l %s | awk '{ print $NF }'", linkfile); 
   comout = popen (syscmd, "r");
   if (comout == NULL)
      c_lasmsg (TRUE, "makelink-popen", "Error opening pipe via popen()");

// read pipe 
   if (fgets (datafile, CMLEN, comout) == NULL)
   {
      pclose (comout);
      c_lasmsg (TRUE, "makelink-pout", "Error reading pipe output");
   }
   pclose (comout); 

// delete trailing newline character from pipe output
   char *newline = datafile + strlen (datafile) -1;
   *newline = '\0';

// delete data file
   if (remove (datafile))
   {
      c_lasmsg (TRUE, "makelink-del", 
      "System error '%s' deleting temporary file %s",
      strerror(errno), datafile); 
   }

// return file name
   return (datafile); 
}





