#include "neighbor.h"
#include "util.h"
#include "protos.h"

/*

NAME: NEILBL
 
Purpose:
Write min and max values for output image
update history in the output image label
PDL:
Begin neilbl
        If $MINMAX is "YES"
                Write min and max values for output image to ddr.
                Call hstout to update history in the output image label 
                when $HISTRY = "YES"
End neilbl
----------------------------------------------------------------------- */
void neilbl
(
    char hosin[][CMLEN],        /* I: host output image name       */
    char hosout[],              /* I: host input image name        */
    double ominp,               /* I: min pixel                    */
    double omaxp,               /* I: max pixel                    */
    char minmax[]               /* I: min/max option               */
)
{
    long one = 1;

    if (strcmp(minmax, "YES") == 0)
    {
        /* 
           Write min and max values for output image.
           ------------------------------------------*/
        c_svmnmx (hosout, &one, &ominp, &omaxp, minmax);
    }

    /*
       Update history in the output image label.
       -----------------------------------------*/
    c_hstout (&block, hosout, (char (*)[256])hosin[0], &one, " ");

}

