#ifndef PROTOS_H
#define PROTOS_H

void files
(
    char hosin[][CMLEN],                /* I: host input image name     */
    char hosout[],                      /* I: host output image names   */
    long window[][4],                   /* I: processing window         */
    long nimages                        /* I: no. of images             */
);

void parms
(
    char lasin[][CMLEN],                /* O: las i/o image names       */
    char hosin[][CMLEN],                /* O: host i/o image names      */
    char lasout[],                      /* O: las i/o image names       */
    char hosout[],                      /* O: host i/o image names      */
    long wind[][4],                     /* O: processing window         */
    long *msgtim,                       /* O: message interval          */
    char minmax[4],                     /* O: min/max option            */
    long *radius,                       /* O: search radius             */
    long *option,                       /* O: type of search            */
    long *value,                        /* O: pixel value               */
    long *nimages                       /* O: no. of images             */
);

void neilbl
(
    char hosin[][CMLEN],        /* I: host output image name       */
    char hosout[],              /* I: host input image name        */
    double ominp,               /* I: min pixel                    */
    double omaxp,               /* I: max pixel                    */
    char minmax[]               /* I: min/max option               */
);

void neisub
(
    long adim,                  /* I: size of spread                    */
    long wrksiz,                /* I: size of work area                 */
    long *work[],               /* I: work buffer                       */
    long wind[][4],             /* I: processing window                 */
    long xoff[],                /* I: spiral search offsets             */
    long yoff[],                /* I: spiral search offsets             */
    long rad,                   /* I: search radius                     */
    long option,                /* I: search option                     */
    long val,                   /* I: pixel value                       */
    long msgtim,                /* I: message interval                  */
    double *minp,               /* O: min pixels                        */
    double *maxp                /* O: max pixels                        */
);

void setdis
(
    long xoff[861],                     /* O: spiral search offsets     */
    long yoff[861],                     /* O: search offsets            */
    long dist[861],                     /* O: search distances          */
    long rad                            /* I: search radius             */
);

void msg_err
(
    char *message,                      /* I: Error message and severity */
    char *key                           /* I: Message key                */
);

#endif
