#include "neighbor.h"
#include "util.h"
#include "protos.h"

/*****************************************************************************
 *
 * NAME         msg_error
 *
 * PURPOSE      To display an error message and exit NEIGHBOR if it is fatal.
 *              The first character of the error message determines whether
 *              or not the error is fatal.
 *
 * PARAMETERS
 *
 *      Name            Type            I/O     Description
 *      ----            ----            ---     -----------
 *      *message        char            I       Error message and severity
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *      None
 *
 * RETURN VALUES
 *
 *      None
 *
 *****************************************************************************/
void msg_err
(
    char *message,                      /* I: Error message and severity */
    char *key                           /* I: Message key                */
)
{
    long one = 1;

    switch (*message++)  
    {
        case '?' :
            c_errmsg (message, key, &one);
            break;
        case '!' :
        default : 
            c_errmsg (message, key, &one);
            if (gdescin > 0) c_egclse(&gdescin);
            if (gdescout > 0) c_egclse(&gdescout);
            c_clean (&block, "NEIGHBOR", out, &count);
            break;
    }
}


