      program wrtpdf
C******************************************************************************
C     This program is part of the PDFOFF TAE utility.  It reads the
C     time file created by TIMEON, reads the session log, and reformats
C     the log into a procedure pdf file.  The name of this file is an input 
C     parameter.
C******************************************************************************

	include 'las.fin'

      integer count
      integer i
      integer length
      integer lun
      integer parblk(XPRDIM)
      integer status

      character*80 insess
      character*80 pdfnam
      character*20 start

C     initialization
C     --------------
      call xzinit(parblk,XPRDIM,lun,XABORT,status)

C     get name of output procedure pdf
C     --------------------------------
      call xrstr(parblk,'PDFNAME',1,pdfnam,length,count,status)

C     open the temporary time file
C     ----------------------------
      open(unit=4,file='time.lst',status='old',err=550)
      rewind(unit=4)

C     open the TAE session log file
C     -----------------------------
      open(unit=3,file='session.tsl',status='old',err=525)
      rewind(unit=3)
   
C     open the output procedure pdf file
C     ----------------------------------
      open(unit=2,file=pdfnam,status='new',err=500)

C     get the start time
C     ------------------
      read(unit=4,fmt='(A)') start

C     write the beginning of output pdf 
C     ---------------------------------
      write(unit=2,fmt='(A)') 'PROCEDURE'
      write(unit=2,fmt='(A)') 'refgbl ($msgtim)'
      write(unit=2,fmt='(A)') 'BODY'

C     while (time stamp in session log < start time)
C       read record from session log file
C     ----------------------------------------------
1     read(3,110,end=200)insess
      if (insess(1:3) .ne. 'TS:') go to 1
      if (insess(5:24) .lt. start(1:20)) go to 1

C     search for proc activation
C     --------------------------
3     read(3,110,end=200) insess

      if (insess(1:3) .eq. 'PA:') then
         do 10 i=1,80
            if ((insess(i:i+9) .eq. 'pdfoff.pdf') .or.
     .          (insess(i:i+9) .eq. 'PDFOFF.PDF')) goto 200
10       continue
         write(2,115) insess(5:80)
      endif
      go to 3

C  IF SCRIPTOFF.PDF IS THE ACTIVATED PROC THEN THE SCRIPT FILE
C  IS COMPLETED.
C
C  IF THERE IS A DYNAMIC TUTOR THEN WRITE THE PARAMETERS AND
C  THEIR VALUES AS SEPARATE RECORDS TO THE SCRIPT FILE.
C
C	ELSE IF(INSESS(1:3) .EQ. 'DP:') THEN
C	   ISTART = 5
C	   DO 112 J=5,80
C		IF (INSESS(J:J) .EQ. ',') THEN
C	         WRITE(2,115)INSESS(ISTART:J-1)
C	         ISTART=J+1
C		END IF
C112	   END DO
C	   WRITE(2,115) INSESS(ISTART:80) 
C	   WRITE(2,116)
C116   format(1X,'RUN') 
C           GOTO 3
C	END IF

C     close files
C     -----------
200   write (unit=2,fmt='(A)') 'END-PROC'
      close (unit=2)
      close (unit=3)
      close (unit=4)
      go to 250

C     error messages
C     --------------
500   call xmput('Unable to write script file.','UTL-OPNFILE',-1)
      go to 250
525   call xmput('Unable to access SESSION.TSL','UTL-ACCSESS',-1)
      go to 250
550   call xmput('Unable to access time file created by PDFON',
     +           'UTL-ACCTIM',-1)
      go to 250

C     format statements
C     -----------------
110   format(80A)
115   format(1X,76A)  

250   continue
      end
