#include "power.h"
#include "util.h"
#include "protos.h"
         
void getpar
(
    char intae[][CMLEN],         /*    input image tae name       */
    char inhos[][CMLEN],         /*    input image host name      */
    char outtae[][CMLEN],         /*    output image tae name      */
    char outhos[][CMLEN],         /*    output image host name     */
    long *num_inimages,		/* number of input images           */
    long num_image_bands[],	/* number of bands in each input image */
    long image_band_num[][MAXBND+1],  /* band numbers for each image */
    long *num_inbands,           /* total number of input image bands   */
    long *num_outbands,    	/* number of output image bands     */
    float *expo		  /* input parameter               */
)

/*
******************************************************************
NAME: GETPAR

PURPOSE:
	getpar is used to receive the paramter block from tm,
	initialize the catalog manager, and to get the parameters
	from the parameter block.

PROGRAM HISTORY:
  Version   Date       Author                       Request
  -------   ----       ------                       -------
                          
  1.0     30-Mar-90    W. Xia			conversion to 5.0
                 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS
     
ALGORITHM DESCRIPTION:
                      
   Call c_inlas to initialize TAE.
   Get the input image file name.
   Get the output image file name.
   Get the data type of input images.
   Get the LAS global parameters: $MAXTIM, $MINMAX.

*************************************************************************
*/
{

long    fatal_err = -1;            /* fatal error return status */
long    zero = 0;
long    one = 1;

/*  local variables */
struct  VARIABLE *var;               /* pointer to a variable in TAE block */
long
	dtype,
	imglimit=MAXIMG, 	/* maximum number of image allowed */
 	inimg_flag[MAXIMG][2],	/* flag for subwindow */             
	same_wnd,	/* flag indication if images have same window */
	stat,                       /* return status                      */
  	std_out;     	       	/* standard output device  */ 
           
char    mnmx[4];        /* minimum and maximum option */
/*
initialize a Las program
_________________________
*/
c_inlas(&block,&std_out);
dtype = EREAL;
  
/*
get the input image name                       
------------------------
*/                                            
stat=c_getin (&block, "IN", &zero, intae, inhos, num_inimages, wind,
	 image_band_num, num_image_bands, num_inbands, &imglimit, &same_wnd,
	 inimg_flag);    

                                              
*num_outbands = *num_inbands;            

if (stat != E_SUCC)
   c_errmsg ("Cannot access input file names", "power-getin",
              &fatal_err);
if (same_wnd == 0)                                  
   c_errmsg ("Image windows differ in size", "power-window", &fatal_err);

/*                      
Get the output image file name.
-------------------------------
*/
stat = c_getout (&block, "OUT", outtae, outhos);  

if (stat != E_SUCC)
   c_errmsg ("Cannot access output file name", "power-getout", &fatal_err);

/*
get tae parameters
 ------------------------
*/
c_getnum (&block, "EXP", &one, &dtype, expo);   

/*
Get las global parameters
-------------------------         
*/
var = p_find( &block, "$MSGTIM");
msgtim = IVAL( *var, 0);

var = p_find( &block, "$MINMAX");
strcpy( mnmx, SVAL( *var, 0));
if (mnmx[0] == 'Y') min_max = TRUE;
else min_max = FALSE;

}
