#include "redist.h"
#include "protos.h"

/*
**********************************************************************

   FUNCTION inimg()
 
   name- inimg

   language- C

   version- 1.0    date- Oct-84         programmer- Y.Sheu
   version- 2.0    date- Sep-90		programmer- F.Irani:V5.0 Conversion
 
   function- establishes a file specification group and file action group
             for input image in order to compute histogram

  PDL:
	Begin inimg
		Open input image files.
		Set up group for input bands only.
	end inimg
*******************************************************************

*/

void inimg
(void)

{

long    fatal_err = -1;
long    zero = 0;

long	access,                 /* read/write file access type	*/
	hsiz,			/* input buffer size		*/
	image,			/* Loop counter # images	*/
	nib;			/* band number loop index	*/
	
/*
Open input image files.
-----------------------						*/
access = IREAD;
for (image = 0, nib = 0; image < images; image++)
{
	if ( c_eopens( &fdh[image], hosin[image],
	     bandnums[image], &windows[0][SL], &windows[0][SS], 
	     &windows[0][NL], &windows[0][NS], &hpoint[nib], 
	     &access, &itype, &zero, &zero) != E_SUCC )
		c_errmsg("Error opening input image", "redist-open", 
			 &fatal_err);

	nib+= bands[image];
}  

fdh[++image] = 0;

/*
Set up group for input bands only.
----------------------------------					*/
if ((hbuf = (unsigned char *) c_ealloc(fdh, &hsiz)) == NULL)
	c_errmsg("Error allocating dynamic memory", "redist-ealloc", 
		 &fatal_err);

c_egroup (fdh, &gdh, hbuf, &hsiz);

return;

}
