#ifndef PROTOS_H
#define PROTOS_H

void doglobal
(
    char clip_flg[],		/* Clip flag */
    char cltyphi[],		/* Clipping type for high end data */
    char cltyplo[],		/* Clipping type for low end data */
    float cliphi,			/* User-requested high end clip value */
    float cliplo,			/* User-requested low end clip value */
    char scaltyp[],		/* Type of scaling to be performed */
    double amin[],			/* Minimum pixel values */
    double amax[],			/* Maximum pixel values */
    float fmaxval,		/* Maximum pixel value for the output image */
    float fminval,		/* Minimum pixel value for the output image */
    long real_flg,		/* Flag for input data of type real */
    long bands_per_img[MAXIMG], 	/* Number of bands in each image */
    long dtype,			/* Data type of input image */
    long num_img_band[MAXIMG][MAXBND+1], /* Band numbers for each input image */
    long num_inimg,		/* Number of input images */
    long tot_inband		/* Total number of input image bands */
);

void dolocal
(
    char clip_flg[],		/* Clip flag */
    char cltyphi[],		/* Clipping type for high end data */
    char cltyplo[],		/* Clipping type for low end data */
    float cliphi,			/* User-requested high end clip value */
    float cliplo,			/* User-requested low end clip value */
    char scaltyp[],		/* Type of scaling to be performed */
    double amin[],			/* Minimum pixel values */
    double amax[],			/* Maximum pixel values */
    float fmaxval,		/* Maximum pixel value for the output image */
    float fminval,		/* Minimum pixel value for the output image */
    long real_flg,		/* Flag for input data of type real */
    long bands_per_img[],  	/* Number of bands in each image */
    long dtype,			/* Data type of input image */
    long num_img_band[][MAXBND+1], /* Band numbers for each input image */
    long num_inimg,		/* Number of input images */
    long tot_inband		/* Total number of input image bands */
);

void filspec
(
    char hosin[][CMLEN],			/* Input image host name */
    char hosout[],			/* Output image host name */
    long bands_per_img[],		/* Number of bands for each image */
    long num_img_bands[][MAXBND+1],	/* Band numbers for each input image  */
    long num_inimages,			/* Total number of input images */
    long out_bands,			/* Number of output image bands */
    long out_img_bands[][MAXBND+1],	/* Band numbers for each output image */
    long outtype			/* Data type of the output image */
);

void getpar
(
    char hosin[][CMLEN], 	/* Input image host names */
    char hosout[][CMLEN],		/* Output image host names */
    char taein[][CMLEN], 	/* Input image tae names */
    char taeout[][CMLEN],		/* Output image tae names */
    char scaltyp[],		/* Type of scaling to be performed */
    long *bands_per_img, 	/* Number of bands per input image */
    long num_img_band[][MAXBND+1], /* Band numbers for each input image */
    long *num_inimg,		/* number of input images */
    float *fmaxval,		/* Maximum pixel value for the output image */
    float *fminval,		/* Minimum pixel value for the output image */
    char clip_flg[],		/* Clipping flag */
    float *cliphi,		/* User-requested high end clip value */
    float *cliplo,		/* User-requested low end clip value */
    char cltyphi[],		/* Clipping type for the high end of data */
    char cltyplo[],		/* Clipping type for the low end of data */
    long *tot_inband,            /* Total number of bands to be processed */
    long *dtype,			/* Data type of the input image */
    long *outtype,		/* Data type of the output image */
    long *real_flg		/* Real data type flag */
);

void percen2
(
    long histo[],		/* Histogram array */
    double zmin,			/* Minimum pixel value for the current band */
    double zmax,			/* Maximum pixel value for the current band */
    char cltyphi[],		/* Clipping type for high end data */
    char cltyplo[],		/* Clipping type for low end data */
    float *clipval_hi, 		/* Final (computed) high end clip value */
    float *clipval_lo,		/* Final (computed) low end clip value */
    float cliphi,			/* User-requested high end clip value */
    float cliplo			/* User-requested low end clip value */
);

void percen4
(
    long histo[], 		/* Histogram array */
    float hscale,			/* Histogram scaling factor */
    float hoffset,		/* Histogram offset */
    long nbins,			/* Number of histogram bins */
    char cltyphi[],		/* Clipping type for high end data */
    char cltyplo[],		/* Clipping type for low end data */
    float *clipval_hi, 		/* Final (computed) high end clip value */
    float *clipval_lo,		/* Final (computed) low end clip value */
    float cliphi,			/* User-requested high end clip value */
    float cliplo			/* User-requested low end clip value */
);

void prolas
(
    char clip_flg[4],	/* Clip flag */
    float clipval_hi, 	/* Final (computed) high end clip value */
    float clipval_lo,	/* Final (computed) low end clip value */
    float fmaxval,	/* Maximum pixel value for the output image */
    float fminval,	/* Minimum pixel value for the output image */
    float slope,		/* Scaling factor for calculting output image values */
    float offset,		/* Offset for calculating output image values*/
    long img,		/* Current input image */
    long inband,		/* Input image band being read */
    long outband,	/* Output image band being written */
    long dtype		/* Input image data type */
);

void sett2
(
    long hist[],			/* Histogram array */
    double *zmin,			/* Minimum pixel value for the current band */
    double *zmax,			/* Maximum pixel value for the current band */
    char scaltyp[],		/* Type of scaling to be performed */
    long img,			/* Current image being processed */
    long inband			/* Current band being processed */
);

void sett4
(
    long hist[],			/* Histogram array */
    float hscale,			/* Histogram scaling factor */
    float hoffset,		/* Histogram offset */
    long img,			/* Current image being processed */
    long inband,			/* Current band being processed */
    long dtype			/* Input image data type */
);

#endif
