#ifndef PROTOS_H
#define PROTOS_H

void stadapt
(
    long lut_type		/* data type of look up table */
);

void stapplylut
(
    char hosnam[][CMLEN],	/* Input image host name */
    char hosout[][CMLEN],		/* Output image host name */
    long totbnd,			/* Total number of bands */
    long window[][4],		/* Processing window */
    long nimages,		/* Number of images */
    long otype 			/* Output image data type */
);

void statistic
(
    char hosnam[],		/* Host name of input image */
    long window[][4],		/* Processing image window */
    long inc[2],			/* Step size: inc[0] = x direction */
    float *img_min,		/* Minimum pixel value in the input image */
    float *img_max,		/* Maximum pixel value in the input image */
    float *mean, 			/* Mean value of the input image */
    float *stdv			/* Standard deviation of the input image */
);

void stclip
(
    long lut_type		/* data type of look up table */
);

void stcontour
(
    long lut_type
);

void stcuberoot
(
    long lut_type		/* data type of LUT */
);

void stdisklut
(
    long lut_type		/* Data type of look up table */
);

void stdist
(
    long lut_type,		/* LUT type */
    char hosnam[][CMLEN],	/* Input image host name */
    long window[][4] 		/* Processing window */
);

void stflip
(
    long lut_type		/* LUT data type */
);

void stlinear
(
    long lut_type			/* LUT data type */
);

void stmakelut
(
    long *totbnd, 		/* Total number of bands */
    long *nimages, 		/* Number of images */
    char hosnam[][CMLEN], 	/* Input image host name */
    char hosout[][CMLEN],		/* Output image host name */
    long *img_type, 		/* Image and/or wLUT data type */
    long *otype,			/* Output image data type */
    char source[],		/* Input Display and Look-Up Table File */
    char dltfentry[],		/* Entry in input DPF */
    long window[][4] 		/* Processing window */
);

void stpower
(
    long lut_type		/* data type of LUT */
);

void stpthresh
(
    long lut_type,		/* Data type of look up table */
    char hosnam[][CMLEN],	/* Input image host name */
    char hosout[],		/* Output image host name */
    long nimages,		/* Number of images */
    long wind[][4],		/* Processing window */
    long totbnd 		/* Total number of bands */
);

void stputlut
(
    char dltfentry[],		/* DLTF entry name */
    long window[][4]		/* Processing window */
);

void stpwlin
(
    long lut_type, 		/* LUT data type */
    long otype			/* Output image data type */
);

void stsetio
(
    char hosnam[][CMLEN], 	/* Input image host file name */
    char hosout[],		/* Output image host file name */
    long wind[][4],		/* Processing window */
    long *otype,			/* Output image data type */
    long nimages,		/* Number of images */
    long totbnd, 		/* Total number of bands */
    long (*out_img_bands)[MAXBND+1]  /* Band numbers for the output image    */
);

void stthresh
(
    long maxt,		/* Maximum threshold value */
    long mint,		/* Minimum threshold value */
    long maxlut, 	/* Maximum LUT range value */
    long minlut 	/* Minimum LUT range value */
);

void stvthresh
(
    long lut_type		/* Data type of LUT */
);

void msg_err
(
    char *message,	/* Error message text */
    char *key		/* Error message key */
);

#endif

