#include "stretch.h"
#include "protos.h"

void stflip
(
    long lut_type		/* LUT data type */
)
{
/*
--------------------------------------------------------------------------
NAME: STFLIP

FUNCTION:   Reverses the order of entries in a look up table.

PROGRAM HISTORY:
      Version          Date        Author            Request
      -------          ----      ------     	     -------
        1      	     28-Jan-82   J. Hagedorn       
	2     	     24-Dec-86   R. Mckinney         prf 3034         
        3	      7-Jul-89   B. Allam            conversion
        4            22-Mar-91   K. Donaldson        added comments

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
		Run under TAE

PROJECT:	LAS

ALGORITHM:

   If look-up table data type is BYTE, 
      Exchange the look-up table entries at the current position and a 
      position that is equal to (255 - current position).
   If look-up table data type is I*2, 
      Exchange the look-up table entries at the current position and a 
      position that is equal to (32767 - current position).

----------------------------------------------------------------------------
*/
long	i,			/* Loop counter and array index */
	temp_val;		/* Temporary value */

/*
If look-up table data type is BYTE, exchange the look-up table entries at the
current position and a position that is equal to (255 - current position).
------------------------------------------------------------------------------
*/
if (lut_type == 1) 
   {
   for (i = 0; i <= 127; i++)
      {
      temp_val = lut[i];
      lut[i] = lut[255 - i];
      lut[255 - i] = (short) temp_val;
      }
   }
/*
If look-up table data type is I*2, exchange the look-up table entries at the
current position and a position that is equal to (32767 - current position).
------------------------------------------------------------------------------
*/
else
   {
   for (i = -32768; i <= -1; i++)
      {
      temp_val = lut[i];
      lut[i] = lut[-1 - i];
      lut[-1 - i] = (short) temp_val;
      }
   }  

}
