#include "stretch.h"
#include "util.h"
#include "protos.h"

void msg_err
(
    char *message,	/* Error message text */
    char *key		/* Error message key */
)

/*****************************************************************************
 *
 * NAME		msg_error
 *
 * PURPOSE	To display an error message and exit STRETCH if it is fatal.
 *		The first character of the error message determines whether
 *		or not the error is fatal.
 *
 * PROGRAM HISTORY
 *
 *	Programmer		Date		Reason
 *	----------		----		------
 *	Eric Ivancich / SAR	13-Aug-87	C conversion
 *      Bani Allam              31-Aug-88       Retrocode
 *
 * PARAMETERS
 *
 *	Name		Type		I/O	Description
 *	----		----		---	-----------
 *	*message	char		I	Error message and severity
 *
 * EXTERNAL VARIABLES REFERENCED
 *
 *	None
 *
 * RETURN VALUES
 *
 *	None
 *
 *****************************************************************************/
{

    long    one = 1;

	switch (*message++)  {
		case '?' :
		     	c_errmsg (message, key, &one);
		     	break;
		case '!' :
		default : {
   	 		c_errmsg (message, key, &one);
                        if (gdescin > 0) c_egclse(&gdescin);
                        if (gdescout > 0) c_egclse(&gdescout);
                        if (fd) c_cldltf (&fd, out[1]);
                        c_clean (&block, "STRETCH", out, &count);
                        }
 	}
}


