/*************************************************************************
NAME: BIP2BIL

PURPOSE:
     To convert a line from band interleave by pixel to band interleave
     by line.
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "tiffio.h"
#include "protos.h"

extern struct PARBLK vblk;     /* TAE parameter block          */

void bip2bil
(
    unsigned char *inbuf,       /* O: Processing buffer for strip tiff images */
    unsigned char *tempbuf,     /* I: temp buffer for image manipulation - 
                                      same size as inbuf */
    int imagesize,              /* I: size of line in image                */
    int nbands                  /* I: number of bands in the image         */
)

{
  int i,j;
  int pixels_per_band = imagesize/nbands;
  unsigned char *band_ptr;

  for (j = 0; j < nbands; j ++)
  {
    band_ptr = &tempbuf[pixels_per_band * j];
    
    for (i = 0; i < pixels_per_band; i ++)
      band_ptr[i] = inbuf[i*nbands + j];
  }
  memcpy(inbuf,tempbuf,imagesize * sizeof(char));
}
