/******************************************************************************
FUNCTION:	GETPAR

PURPOSE:	Get the input parameters

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "util.h"
#include "protos.h"

int getpar
(
    struct PARBLK *vblock, 	/* I: TAE parameter block              */
    char infile[],		/* O: Input tiff file                  */
    char outfile[]	        /* O: Output host name 		    */
)
{
struct VARIABLE *p_find();/* function to find a TAE variable         */
 
long access;            /* File access                               */
long element=0;         /* Element of TAE parameter to retrieve      */   
long status;		/* Process status			     */ 

/* Retrieve input tiff file name
---------------------------------*/
access = IREAD;
status = c_getnam(vblock,"INFILE",&element,infile,"tif",&access);
  if (status != E_SUCC) return(E_FAIL);
 
/* Retrieve output image name
-----------------------------*/
access = IWRITE;
status = c_getnam(vblock,"OUTFILE",&element,outfile,"bil",&access);
  if (status != E_SUCC) return(E_FAIL);

return (E_SUCC);
}
