#ifndef PROTOS_H
#define PROTOS_H
#include "tiffio.h"

void bip2bil
(
    unsigned char *inbuf,       /* O: Processing buffer for strip tiff images */
    unsigned char *tempbuf,     /* I: temp buffer for image manipulation - 
                                      same size as inbuf */
    int imagesize,              /* I: size of line in image                */
    int nbands                  /* I: number of bands in the image         */
);

int getpar
(
    struct PARBLK *vblock, 	/* I: TAE parameter block              */
    char infile[],		/* O: Input tiff file                  */
    char outfile[]	        /* O: Output host name 		    */
);

int lng2tae
(
    long data[],         /* I: array of longs to transfer              */
    long skipf,          /* I: skip factor                             */
    long num_longs,      /* I: number of elements                      */
    char varname[],      /* I: tae name of variable                    */
    long *result         /* O: value of parameter                      */
);

void getcolor
(
   unsigned char *inbuf,     /* I: Buffer that holds the current line   */
   int image_width,          /* I: Number of pixels in the row          */
   uint16 *rmap,             /* I: Red palette values                   */
   uint16 *gmap,             /* I: Green palette values                 */
   uint16 *bmap,             /* I: Blue palette values                  */
   unsigned char *buf_ptr    /* O: Buffer to store the color values     */
);
#endif
