#include "tsclass.h"

FUNCTION classfy (wind, nclass_used, polygon, num_inbands,
clsind, nverts, lmin, lmax, maxmin, weight, maxdist, metric, area)
                  
float	
        weight[], 
	maxdist;

long    area[][4]; /* area containing site bounding rectangle */
long	clsind[],            /* set of class indices */
	lmin,                 /* minimum line # for all site boundings   */
	lmax,                 /* maximum line # for all site boundings   */
 	maxmin,
        metric,
	nclass_used,	        	/* number of classes in process */
        *polygon,			/* number of polygons           */
	num_inbands,			/* number of input bands        */
 	nverts[],                       /* # of vertices */
 	wind[][4];                /* window parameters     */

/*
************************************************************
NAME: CLASSFY
 
PURPOSE:   Do CLASSIFICATIONS TO THE POLYGONAL SITES

PROGRAM HISTORY:
  Version   Date       Author                       Request
  -------   ----       ------                       -------
                          
  1.0        Aug-84    Y. Sheu                      vision 1.0
  2.0        May-90    W. Xia(stx)                conversion to 5.0
                  
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE
**************************************************************
*/
{
/* local variables */
long    inside;

long	iline,                            /* line loop index */
        nl,ns,nls,nlk,npk,i,inp,
	n, icount, ii,		        /* loop index */
       	number,  
        itype=ELONG,
     	dtype=EREAL;
                
long	sxs[MAX_VERT],     /* x coordinates of intersections */
        nxs,              /* # of intersections  */            
  	dsref, odsref;

long	ss, sl, begpix, endpix, 
        stat; 

long    fatal_err = -1;                /* fatal error return status */
long    inf_err = 1;                   /* info error return status  */
long    zero = 0;
float   fzero = 0.0;

/*
 initialize class numbers with zero
-----------------------------------
*/
number =(nclass_used+1) * (*polygon);
c_pxfill (sclass, &itype, &number, &zero);

nlk=wind[0][NL];   
npk=wind[0][NS];                          
                      
/* Set up processing line message
 --------------------------------
*/
curent = 1;                                                         
c_inittm("TSCLASS", "Processed", "line", "bands", " ", &nlk, &num_inbands,
            &msgtim, &zero);                                                 
c_startm ();

for (iline = 0; iline < nlk; iline++, curent++)
{                                       /* start of line loop */

  stat=c_estep(&gdesc);
    
   if (stat != E_SUCC )
      {
      c_errmsg ("Error in estep", "classfy-estep",&fatal_err);
      }

/*
 fill current line with zero
----------------------------
*/
c_pxfill ((float *) &iobuf[opoint * sizeof (float)], &dtype, &npk, &fzero);

   if (iline  >=  lmin  &&  iline < lmax)
   {                /* start of if loop for lmin, lmax */  
     for (icount=0; icount < *polygon; icount++)
     {              /* start of for loop for polygon  */
/*
 get bounding  rectangles of site.
---------------------------------
*/                    
      ss = area[icount][SS];      
      sl = area[icount][SL];  
      ns = area[icount][NS];  
      nl = area[icount][NL];
/*
 skip this site if line is not in the range
-------------------------------------------
*/
      nls=sl+nl-1;
      if (iline >=  sl  &&  iline <= nls)
       {                 /* start of if  for line range */
/*
 for the line in site--find the number of intersections with
 polygon boundary
------------------------------------------------------------         
*/
      sect (xaxis[icount], yaxis[icount], nverts[icount], iline, sxs, &nxs);
 
/*
 find interior points in polygon. 
--------------------------------
*/                              
      for (ii = 1; ii < nxs; ii++)      
         {                                      
         if(insde(xaxis[icount], yaxis[icount], nverts[icount], 
               sxs[ii-1], sxs[ii], iline));
/*
 classify interior points and update statistics            
------------------------------------------------
*/         
	    { 
            begpix=sxs[ii-1];
            endpix=sxs[ii];  
            inp=endpix-begpix+1;
            doclasfy (num_inbands, begpix, inp, icount, nclass_used, 
 	    clsind, maxmin, weight, maxdist, metric);
            }
         }  			 /* end of ii loop */

       }          /* end of if loop for line in range */

      }  	 /* end of polygon loop */                    

     }           /* end of loop for lmin, lmax */

 } 		 /* end of line loop */

stat=c_estep(&gdesc);

if (stat!= E_SUCC )
   {
   c_errmsg ("Error in estep", "stereo-estep",&fatal_err);
   }

c_stoptm ();

free (( char *) iobuf);
             
free (x_matrix);                                               
free (y_matrix);

}
