#include "tsclass.h"
     
FUNCTION classtat (nclass_used, nsites, tclass, tsum)

long	
	nclass_used,      		/* # of classes */
	nsites[],                      /* # of sites   */    
	tclass[MAXCLS],                 /* total pixel # for each class # */
	*tsum;                           /* total pixel #'x for all sites */
/*                                                           
************************************************************
NAME:  CLASSTAT
 
PURPOSE: UPDATES CLASS NUMBER COUNTS FOR EACH CLASS

PROGRAM HISTORY:
  Version   Date       Author                       Request
  -------   ----       ------                       -------
                          
  1.0        Aug-84    Y. Sheu                      vision 1.0
  2.0        May-90    W. Xia(stx)               conversion to 5.0
                  
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE
**************************************************
*/

{
/* local variables */

long	l,k,is,i,		 /* loop index */ 
        icount,
        itype=ELONG,
        nclass,    
        number;
long    zero = 0;

/*
initialize parameters with zero
------------------------------
*/
nclass=MAXCLS;          
for (i=0; i < nclass; i++)
  {
  c_pxfill (cclass[i], &itype, &nclass, &zero);
  }
c_pxfill (tclass, &itype, &nclass_used, &zero);
*tsum=0;
    
/*
 accumulate class numbers and pixel counts for classes
 ------------------------------------------------------
*/                                   
for (l=0; l < nclass_used; l++)                
   {
   icount=0;
   for (k=0; k < nclass_used; k++)              /*  loop for classes */
      {
/*
 accumulate class number for each class
------------------------------------------ 
*/
      for (is=0; is < nsites[k]; is++)
         {  
         cclass[k][l] += sclass[icount][l];
         ++icount;
         }  					/*  end of site loop */
/*
 accumulate counts for each class number        
---------------------------------------
*/
      tclass[l] += cclass[k][l];       
      }  					/*  end of class loop */
   *tsum += tclass[l];
   }
return;
}

