#include "tsclass.h"

FUNCTION doclasfy (num_inbands, begpix, np, icount, nclass_used,
                   clsind, maxmin, weight, maxdist, metric)
long	
	num_inbands,
	begpix,		   /* beginning pixel */
	np,		   /* number of pixels */
	icount,            /* current count of polygons  */    
	nclass_used,	   /* number of classes */
        clsind[],	           /* class indices     */
	maxmin,	           /* classifier indicator 
	                      =1: BAYES MAXIMUM LIKELIHOOD
                              =2: minimum distance   */   
        metric;	           /* minimum distance method indicator
			       	=1:EUCLID                  
				=2:CITYBLK             */
float
	weight[],	  /* weighting factors for minimum distance */
	maxdist;	  /* parameter of minimum distance */

/*
************************************************************
NAME: DOCLASFY
 
PURPOSE: DO CLASSIFICATIONS TO THE POLYGONAL SITES

PROGRAM HISTORY:
  Version   Date       Author                       Request
  -------   ----       ------                       -------
                          
  1.0        Aug-84    Y. Sheu                      vision 1.0
  2.0      1-Jan-85    Y. Sheu                      revision
  3.0        May-90    W. Xia(stx)                conversion to 5.0
                  
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE
**************************************************************
*/

{
/* local variables  */

long	
	 ttype=EBYTE,
	 dtype=EREAL,
       	 num_rows = MAX_SEGP,	/* Number to pass by reference                */
         m,i, n, nstep, nnp, index, 
         t_size,
	 t;

float   *xl_matrix,
	*x[MAXBND];	        /* Temporary work space                       */

float   class[MAX_SEGP];

m=MAX_SEGP;
nstep=(np-1)/m + 1;
nnp=np;        
index=begpix-1;
nnp=min(nnp, MAX_SEGP);

/* 
allocate storage for work buffer
--------------------------------
*/
t_size = num_inbands * nnp * sizeof (float);
xl_matrix = (float *) malloc (t_size);

for (i=0, n=0; i < num_inbands; i++, n+=nnp)
      {                                   
       x[i] = &xl_matrix[n];         
      }                    
/*
 process the line segment in nstep steps
 in each step, nnp pixels are processed
 nnp has a maximum of max_segp 
-------------------------------
*/
for (n=0; n < nstep; n++)                  
   {   
/*
 obtain  input data to form a nnp by num_inbands data matrix 
 ------------------------------------------------------------       
*/                         

  for (i=0; i < num_inbands; i++) 
      {                           
       c_pxcopy (((float *) &iobuf[(ipoint[i] + index) * sizeof (float)]),
                 x[i], &dtype, &nnp);  
      }
                                 
   if (maxmin == 1 ) 
      {   
      byclasfy (x, num_inbands, nnp, icount, nclass_used,
		clsind, class);
      }
   else 
      {
       if (maxmin == 2) 
        {	
/*
 do minimum distance calssification
 -----------------------------------
*/
         minclasfy (x, num_inbands, icount, nclass_used, nnp,
         clsind, maxdist, weight, metric, class);
        } 
       }

/*
 copy the class number to output image buffer
---------------------------------------------
*/    

    c_pxcopy (class, (float *) &iobuf[(opoint+index) * sizeof (float)], 
              &dtype, &nnp);
    index += nnp;
    nnp=np-nnp;

   }                   /*  end of nstep loop       */

/* Free temporary buffers
-------------------------*/
free (xl_matrix);
}
