#include "tsclass.h"

FUNCTION dyn_alloc (num_inbands, nclass_used)
         
long	num_inbands,      /* number of input image bands    */
        nclass_used;   /* number of classes in processs */
/*
*********************************************************************
NAME: DYN_ALLOC

PURPOSE: Allocate storage for means, sums, and sum squares

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1.0         May-90      W. Xia          convention to C

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT: LAS

*********************************************************************
*/
{
long    t_size,	buf_size, c_size;                  /* size of storage    */
long    i,m, n;
long    fatal_err = -1;                /* fatal error return status */

/*
allocate storage for means, sums, and sum squares
-------------------------------------------------
*/
t_size = (num_inbands *(num_inbands+1) /2);
buf_size = nclass_used * t_size * sizeof(float);
c_size = nclass_used * num_inbands * sizeof (float);

if ((covinv_matrix = (float *) malloc( buf_size)) == NULL ||
    (mean_matrix = (float *) malloc( c_size)) == NULL) 
    {                            
    c_errmsg ("Error allocating dynamic memory", "tsclass-alloc",&fatal_err);
    }

/*  
set up pointers for mean and covariance matrices
-------------------------------------------------
*/
for (i = 0, n = 0, m=0; i < nclass_used; i++, n+= t_size, m+= num_inbands)
   {                                                                
   sstat.mean[i] = &mean_matrix[m];                                 
   sstat.covinv[i] = &covinv_matrix[n]; 
   }

/*
Allocate storage for polygon matrices
-------------------------------------
*/
buf_size = MAX_POLYGON * 201 * sizeof(long);

if ((x_matrix = (long *) malloc (buf_size)) == NULL ||
    (y_matrix = (long *) malloc (buf_size)) == NULL)
    c_errmsg ("Error allocating dynamic memory", "tsclass-alloc", &fatal_err);

for (i=0, m=0; i < MAX_POLYGON; i++, m+= 201)
 {         
   xaxis[i] = &x_matrix[m];
   yaxis[i] = &y_matrix[m];                              
 }

}
