#include "tsclass.h"

FUNCTION filspec (inhos, outhos, num_inimages, num_image_bands, wind, out_type)

long
	*num_inimages,	           /* number of input images	*/
   	num_image_bands[],         /* number of bands in each input image*/
	out_type,	           /* output image data type */
	wind[][4];                 /* input image window */

char	inhos[][CMLEN],            /* input image host names  */
	outhos[];           /* output image host name  */
/*
************************************************************
NAME: CLASSFY
 
PURPOSE: SETS UP FILE SPECIFICATION AND ACTION GROUPS FOR INPUT
            AND OUTPUT IMAGES

PROGRAM HISTORY:
  Version   Date       Author                       Request
  -------   ----       ------                       -------
                          
  1.0        Aug-84    Y. Sheu                      vision 1.0
  2.0        May-90    W. Xia                       conversion to 5.0
                  
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT:	LAS

ALGORITHM DESCRIPTION:

   Open input image files.
   Open the output image file.                                               
   Update the ddr file.
   allocate dynamic array for input/output image
   Group all the images files into a group file

**************************************************************
*/
                                                        
{
/* local variables */

double	line_inc = 1.0,		/* line and sample increments for          */
	samp_inc = 1.0;		/* output image ddr                        */

long	access,			/* file access type                        */
	bufsiz,			/* image i/o buffer size                   */
	comb_flag=1,		/* image combination flag 		   */
        n, nib,			/* loop index */
        opt[2],			/* optional parameter array for output file */
	stat,			/* return status                           */
	type;			/* file type                               */
long    fatal_err = -1;                /* fatal error return status */
long    zero = 0;
long    one = 1;
 
/*
Open input image files.                       
-------------------------                      
*/
access = IREAD;
type = EREAL;     
for (n = 0, nib = 0; n < *num_inimages; n++)
{
   stat = c_eopens( &fdescin[n], inhos[n], image_band_num[n], &wind[0][SL], 
                   &wind[0][SS], &wind[0][NL], &wind[0][NS], 
		   &ipoint[nib], &access, &type, &zero, &zero);

   if (stat != E_SUCC )
      {
      c_errmsg ("Error opening input image", "tsclass-eopens",&fatal_err);
      }

   nib += num_image_bands[n];
}  

/*
Open the output image file.
--------------------------
*/
access = IWRITE;
type = EREAL;  

opt[0]=out_type;
opt[1]=0;
 
stat = c_eopens (&fdescin[n], outhos, &one, &one, &one,
&wind[0][NL], &wind[0][NS], &opoint, &access, &type, &zero, opt);
 
if (stat != E_SUCC )       
   {
   c_errmsg ("Error opening output image", "tsclass-eopens", &fatal_err);
   }
        
fdescin[n+1]=0;
          
/*
Update the ddr file.
--------------------
*/                                      
c_upddr (&block, inhos, outhos, num_inimages, wind, image_band_num, 
         num_image_bands, &line_inc, &samp_inc, &one, &comb_flag);    

strcpy (out_files[num_outfiles], outhos);
num_outfiles++;
                              
/*                                        
set up group containing input and output bands
-----------------------------------------------------------
*/
if ((iobuf = ( unsigned char *) c_ealloc(fdescin, &bufsiz)) == NULL)
   {
   c_errmsg ("Error allocating dynamic memory", "tsclass-ealloc",&fatal_err);
   }
c_egroup (fdescin, &gdesc, iobuf, &bufsiz);
  
}
