#include "tsclass.h"
#include "util.h"
         
FUNCTION getpar (intae, inhos, statae, stahos, outtae, outhos, wind,
num_inimages, num_image_bands, nclass_asked, num_inbands,
out_type, maxmin, aprior, maxdist, metric, weight, cflag, print_filename)

long
        *metric,                                               
        *maxmin,
    	*num_inimages,		/* number of input images           */
        num_image_bands[],	/* number of bands in each input image */
        *nclass_asked,           /* number of classes to be classified     */
       	*num_inbands,           /* total number of input image bands   */
 	*out_type,           /* output image data type           */
       	wind[][4]; 		/* input image window		*/ 
char                                                              
        aprior[],     
	cflag[],           /* flag for 2nd contingency table option */
        inhos[][CMLEN],         /*    input image host name      */  
        intae[][CMLEN],         /*    input image tae name       */
        stahos[],         /*    input image host name      */  
        statae[],         /*    input image tae name       */
        outhos[],         /*    output image host name     */
        outtae[];         /*    output image tae name      */
char	print_filename[];    /* printoutput file name           */
                                              
float	*maxdist,
        weight[];
/*
********************************************************************

NAME: getpar.c 

PURPOSE: RECEIVES PARAMETERS FROM TAE PROCESS DEFINITION FILE 

PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/
{
/* local variables */

struct	VARIABLE *var;               /* pointer to a variable in TAE block */
long	
	access,                   /* access type for getnam             */
        count, i,
	itype=ELONG,
	dtype=EREAL,
        ilen,
	imglimit=MAXIMG, 	/* maximum number of image allowed */
 	inimg_flag[MAXIMG][2],	/* flag for subwindow */
	same_wnd,	/* flag indication if images have same window */
	stat,                       /* return status                      */
  	std_out;     	       	/* standard output device  */ 

char    dist[7],
	mnmx[4],        /* minimum and maximum option */
        subcmd[20],
	fileutil_filename[CMLEN];   /* temp file for fileutil             */

long    fatal_err = -1;                /* fatal error return status */
long    zero = 0;
long    one = 1;

/*
initialize a Las program
_________________________
*/
c_inlas(&block,&std_out);

/*
get the input image name                       
------------------------
*/                                            
stat=c_getin (&block, "IN", &zero, intae, inhos, num_inimages, wind,
	 image_band_num, num_image_bands, num_inbands, &imglimit, &same_wnd,
	 inimg_flag);                                  
                                              
if (stat != E_SUCC)  
   c_errmsg ("Cannot access input file names", "getpar-getin",
              &fatal_err);
                 
if (*num_inbands < 2 || *num_inbands > MAXBND)
   c_errmsg ("# of bands in input image must be between 2 and MAXBND",
	     "getpar-bands", &fatal_err);                               
         
if (same_wnd == 0)                                  
   c_errmsg ("Image windows differ in size", "getpar-window", &fatal_err);

/*                      
Get the output image file name.
-------------------------------
*/
stat = c_getout (&block, "OUT", outtae, outhos);  

if (stat != E_SUCC)
   c_errmsg ("Cannot access output file name", "getpar-getout", &fatal_err);
         
/*
get the data type of input image
--------------------------------
*/
c_getddr (inhos[0], &ddr);  
*out_type = ddr.dtype;

/*                           
get stats file name
------------------
*/
access = IREAD;
stat = c_getnam (&block, "INSTAT", &zero, stahos, "stat", &access);
strcpy(statae, stahos);
                                                                            
/*                           
Retrieve the 2ND contingency table option
-----------------------------------------
*/
var = p_find(&block,"CF2FLG");
strcpy(cflag, SVAL(*var,0));

var = p_find( &block, "$MINMAX");
strcpy( mnmx, SVAL( *var, 0));

/*      
Get print option and open printfile if necessary
-------------------------------------------------
*/

strcpy (fileutil_filename, "TSCLASS"); 
c_setprt (&block, &print[TERM], &print[FIL], &print[LP], fileutil_filename,
          print_filename);

if (print[LP] || print[FIL]) 
{
	fd = fopen (fileutil_filename, "w");
	strcpy (cf_files[0], fileutil_filename);
        num_cfiles=1;
/*       

        if (strcmp(cflag,"YES") == 0)
	{   
	  fd = fopen (fileutil_filename, "w");
	  strcpy (cf_files[1], fileutil_filename);
          num_cfiles=2;
  	}
*/
}
else
{
		num_outfiles = 0;        
		fd = NULL;                        
}
/*
get number of class
-------------------
*/                              
if (c_getnum (&block, "NCLASS", &one, &itype, (void *)nclass_asked) == 0)
      *nclass_asked = 0;
      
/*
get subcommand for classification method
----------------------------------------
*/
ilen=20;
c_getstr (&block, "_SUBCMD", &one, &ilen, subcmd);

/*
maximum likelihood                        
------------------                                        
*/
if ((strcmp(subcmd,"BAYES") == 0) || (strcmp(subcmd,"bayes") == 0))
   {                  
   *maxmin=1;
   var = p_find (&block, "APRIOR");
   strcpy (aprior, SVAL (*var, 0));
   }                                                 
else
   {
/*
minimum distance 
----------------  
*/
   *maxmin=2;
   c_getnum(&block, "MAXDIST", &one, &dtype, (void *)&maxdist);
   
count = c_getnum (&block, "WEIGHTS", num_inbands, &dtype, (void *)weight);
if (count  == 0)
   for (i = 0; i < *num_inbands; i++) weight[i] = 1.0;
else if (count < *num_inbands)           
   c_errmsg ("Weights not specified for some bands", "tsclass-noweights", 
             &fatal_err);

   var = p_find (&block, "CALCDIST");
   strcpy (dist, SVAL (*var, 0));

   if (strcmp(dist,"EUC") == 0)
      {                                 /* Euclidean distance */
      *metric=1;
      if (*maxdist  >  0.0 ) 
         {
         *maxdist = (*maxdist) * (*maxdist);
         }  /* if */
      }
   else                                  /* city-block distance  */
      {                                               
      *metric=2;
      }  /* if */

   }  /* if */

/*
Get las global parameters
-------------------------         
*/
var = p_find( &block, "$MSGTIM");
msgtim = IVAL( *var, 0);

if (mnmx[0] == 'Y') min_max = TRUE;
else min_max = FALSE;

}
