#include "tsclass.h"

FUNCTION getpoly (ic, is, xaxis, yaxis, nverts, wind)

long	xaxis[], yaxis[],      /* x and y co-ords of site vertices */
        wind[][4];           /* input image windows */
long    ic,      
        is,                    /* site index number */
        *nverts;               /* number of vertices */
/*
---------------------------------------------------------------------
NAME: GETPOLY

FUNCTION:  Get polygon vertices from statistics file for site

PROGRAM HISTORY:
      Version            date             Author
      -------            ----             ------
         1             may-90           W. Xia(STX)
-----------------------------------------------------------------------
*/
{
long	xyvert[401];         /* x and y coords for vertices as returned 
                                from statistics file */
long	vshape[9];           /* stats data descriptor for vertices */
long	nv, indx,            /* counter variables */
        j,
        stat;                /* status returned */
long    fatal_err = -1;                /* fatal error return status */
long    inf_err = 1;                   /* info error return status  */

/*
 get site vertices from statistics file 
---------------------------------------
*/
      stat = c_stget(&sdesc[0], "POLYGON", &ic, &is, vshape, xyvert);
      if (stat != E_SUCC)
      c_errmsg ("Error reading polygon name", "tsclass-pname", &fatal_err);
    if ( vshape[2] >= 201)
        {
	c_errmsg ("max # site vertices = 200. simplify site shapes",
		  "tsclass-setarea", &inf_err);
        }
*nverts = vshape[2];

      indx=0;
      for (nv=0; nv < *nverts; nv++)
        {
/*                                                           
 get x , y  coordinates
------------------------
*/
         xaxis[nv] = xyvert[indx] - wind[0][SS] + 1;  
	 yaxis[nv] = xyvert[indx+1] - wind[0][SL] + 1;
         indx=indx+2;
        } 
}
