#include "tsclass.h"

FUNCTION lnames (ncx, clsind, nsites, fopt, index, list)

char	
        fopt[];       /* class or site indicator     */

long	clsind[],      /* class indice  */ 
   	index[],        /* index for class names */                          
	list[],         /* index for site names */
        ncx,	 	/* # of class in stats file */
	nsites[];      /* # of sites */          
/*
********************************************************************

NAME: LNAMES 
 
PURPOSE: OBTAIN CLASS NAMES AND SITE NAMES IN STATISTICS FILE TO 
         WRITE TO CONTINGENCY FILES

PROGRAM HISTORY:        
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0   10-Jan-85      Y. Sheu                      revision 1.0
    3.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/
{
/* local variables */

long	ierr,
	shape[9],        /* statistical data descriptor  */
	ns;              /* # of sites for a class */

long    k, icount, ic, is;
long    icl, isl, stat;

char	cname[STNAME], 
        sname[STNAME];
        
char	outbuf[ERRLEN],
	*tbuf;
long    fatal_err = -1;                /* fatal error return status */
long    zero = 0;

/*
 retrieve class name
--------------------
*/                                                     
if ((strcmp(fopt,"class") == 0) || (strcmp(fopt,"CLASS") == 0))
   {
/*
   strcpy(tbuf,"LIST OF SPECIFIED CLASSES ");  
   c_txtout(tbuf, print, fd);          
*/
   tbuf="LIST OF SPECIFIED CLASSES ";  
   c_txtout(tbuf, print, fd);          
   }       
else  
   {
   tbuf ="LIST OF SPECIFIED CLASSES AND SITES ";
   c_txtout(tbuf, print, fd);                     
/*
   strcpy(tbuf,"LIST OF SPECIFIED CLASSES AND SITES ");
   c_txtout(tbuf, print, fd);                     
   c_txtout("LIST OF SPECIFIED CLASSES AND SITES ",print,fd);
*/
   }  /* if */

icount=0;
for (k=0; k < ncx; k++)    
   {         
   ic=clsind[k]; 
   stat = c_stget(&sdesc[0], "NAME", &ic, &zero, shape, cname);
   if (stat != E_SUCC)
      {
      sprintf(outbuf,"check stat file, no class name for class # %3d : %s",
              ic,cname);
      c_errmsg (outbuf, "tsclass-lname",&fatal_err);
      } 
   icl=shape[2];
   cname[icl] = '\0';

   sprintf(outbuf,"Class # %3d: %s",ic,cname);
   c_txtout(outbuf,print,fd);   
/*
 retrieve each site names
-------------------------
*/
    if ((strcmp(fopt,"SITE") == 0) || (strcmp(fopt,"site") == 0))
      {
      ns=nsites[k];
      for (is=1; is <= ns; is++)
         {
         stat = c_stget(&sdesc[0], "NAME", &ic, &is, shape, sname);
         if (stat != E_SUCC)
            {   
 	    sprintf(outbuf,"check stats file, no site name in class # %3d",ic);
            c_errmsg(outbuf,"tsclass-lname",&fatal_err);                      
            sprintf(outbuf,"for site # %3d",is);            
            c_errmsg(outbuf,"tsclass-lname",&fatal_err);                      
            }  /* if */
         isl = shape[2];
         sname[isl] = '\0';                          

         sprintf(outbuf,"            SITE # %3d : %s",is,sname);
         c_txtout(outbuf, print, fd);
         index[icount]=ic;
         list[icount]=is;
         icount=icount+1;
         }     
      }
   else
      {
      index[k]=ic;
      } 
   }              /* end of for loop */
  
return;
}
