#include "tsclass.h"

FUNCTION minclasfy (x, num_inbands, icount, ncx, np, 
	 	    clsind, maxdist, weight, metric, class)
long
	num_inbands,            /* i   number of input bands                 */
	ncx,			/* i   number of classes                     */
	np,			/* i   number of pixels to be classified     */
        icount,                 /* polygon number    */         
	clsind[],		/* i   class indices                          */
	metric;

float	maxdist,
	weight[];
float   class[];  		/* o   class assignments                      */

float	*x[MAXBND];		/* i   image data                             */
/*
********************************************************************

NAME: minclasfy.c

PURPOSE:  DO minmum distance  CLASSIFICATION

PROGRAM HISTORY:

  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0   10-Jan-85      Y. Sheu                      revision 1.0
    3.0      May-90      W. Xia(stx)                conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/
{
/* local variables */
long
	dtype=EREAL,
        c_size, 
	k,j, imin, ic, i, m;  
  
static float
	dist[MAXCLS][MAX_SEGP];
float        scale1,
        scale2,
        mindist;

float	*temp[MAXBND],	        /* Temporary work buffer                      */
	*temp1[MAXBND],	        /* Temporary work buffer                      */
        *temp_matrix,
        *temp1_matrix;
/*
  Allocate storage for temporary buffers
  --------------------------------------
*/
c_size = num_inbands * MAX_SEGP * sizeof (float);
temp_matrix = (float *) malloc (c_size);
temp1_matrix = (float *) malloc (c_size);
for (i=0, m=0; i < num_inbands;i++, m+= MAX_SEGP)
{
    temp[i] = &temp_matrix[m];
    temp1[i] = &temp1_matrix[m];
}

for (k = 0; k < ncx; k++)
   {
/*
   Get difference vectors
   Subtract class mean values, mean values have been multiplied
   by -1.0 in subroutine do_stats
   ------------------------------------------------------------
*/
   for (j = 0; j < num_inbands; j++)
      {
      scale1 = 1.0;
      c_pxline (x[j], temp[j], &np, &dtype, &scale1, &sstat.mean[k][j]);
/*
 difference vectors multiplied by weighting factors
---------------------------------------------------
*/
      scale2=0.0;          
      c_pxline(temp[j], temp1[j], &np, &dtype, &weight[j], &scale2);
                                                                    
/*
 multiplied by difference vectors themselves for euclidean distance
--------------------------------------------------------------------
*/
      if (metric  ==  1)                                 
         {
         c_pxmul (&np, temp[j], temp1[j], temp1[j], &scale1, &scale2, &dtype);
         } 	  /* if */               
      }   	 /* end of num_inbands loop */

/*
 compute sum of absolute values
--------------------------------         
*/
   
   for (j=0; j < np; j++)               
      {                                   
      dist[k][j]=0.0;
      for (i=0; i < num_inbands; i++)
         {
         dist[k][j] += abs(temp1[i][j]);
         }
      }
  }         	/* end of ncx loop  */   
                                                     
/* Free temporary buffers
-------------------------*/
free (temp_matrix);
free (temp1_matrix);

/*
 find the class with minimum value
 ----------------------------------  
*/
for (j=0; j < np; j++)
   {    
   mindist=999999;
   imin=999999;

   for (k=0; k < ncx; k++)
      {
      if (dist[k][j] < mindist) 
         {
         mindist=dist[k][j];     
         imin=k;
         }  /* if */
      }   		  /* end of ncx loop */
   class[j]= (float) clsind[imin];

   if (maxdist  >  0.0 ) 
      {
      if (mindist  >  maxdist) 
         {
         imin=0;
         class[j]=0.0;
         }  	/* if mindist */
      }  	/* if maxdist */     

/*
 update class number counts for site
---------------------------------------
*/    
  ++sclass[icount][imin];
  }                     /* end of np loop */
}
