#include "tsclass.h"      

FUNCTION sect ( xverts, yverts, nverts, line, sects, nsect )

long	
        line,               /* line # */
        *nsect,              /* # of intersections  */            
        nverts,             /* number of vertices */ 
        sects[],           /* x coordinates of intersections */
    	xverts[],          /* x coordinate of vertices */
    	yverts[];          /* y coordinate of vertices */
                                                             
/*
*******************************************************************

NAME:  sect.c 

PURPOSE:     CALCULATES INTERSECTIONS OF A LINE WITH THE BOUNDARIES OF
             A POLYGON.

PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      Jun-84      Y. SHEU                      version 1.0
    2.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/
{                      
long	
	i,
	itemp,
        imin, imax,
	x1, x2, y1, y2,
        sorted;               /* indicates sorting of sects into 
                                 ascending order             */
*nsect = 0;
xverts[nverts] = xverts[0];
yverts[nverts] = yverts[0];
/*                     
 find intersections of line polygon boundary
---------------------------------------------
*/
for (i=1; i <= nverts; i++)
   {
   y1 = yverts[i-1];
   y2 = yverts[i]; 
   if ( y1  !=  y2 )      
     {
      if ( line >=  min(y1, y2) && line <= max(y1, y2)) 
        {
         x1 = xverts[i-1];
         x2 = xverts[i];
         sects[*nsect] = .5 + (float)x1 + (float)(x2-x1) * (float)(line-y1) 
                         / (float)(y2-y1);
         *nsect = *nsect + 1;
        } /* if */
     }/*---if---*/
  }
/*
sort intersections in ascending order
-------------------------------------
*/
sorted = FALSE;

if (*nsect != 0 && *nsect != 1)
{
while (!sorted)
  {
   for (i = 1; i < *nsect; i++)
     {
      if ( sects[i-1] > sects[i] )
        {
         itemp = sects[i-1];
         sects[i-1] = sects[i];
         sects[i] = itemp;
         sorted = FALSE;
        }
      else sorted = TRUE;
     }
  }
} /* if */
}
