#include "tsclass.h"
                  
FUNCTION setarea (nclass_used, clsind, nsites, polygon,  nverts,
	     	  lmin, lmax, wind, area)

long   area[1024][4];        /* array containing site bounding
                                        rectangle */
long	
	clsind[1],            /* set of class indices */
	*lmin,                 /* minimum line # for all site boundings   */
	*lmax,                 /* maximum line # for all site boundings   */
 	nverts[],             /* # of vertices */
	nclass_used,                  /* # of class to be analysed  */
   	nsites[1],            /* # of sites for each class  */
	*polygon,              /* # of polygonal sites       */
 	wind[MAXIMG][4];            /* window parameters     */

/*
********************************************************************

NAME:  setarea.c
 
PURPOSE:   TO ESTABLISH WHICH SITES NEED TO ACCESS IMAGE DATA AND
           ENTER BOUNDING RECTANGLES OF THESE SITES INTO AN ARRAY.

PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0      May-90      W. Xia(stx)                 conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

*************************************************************************
*/

{
/* local variables    */
    
long
        k,i,j,nv, indx,
	ic,              /* class index number */   
        is,              /* site index number  */
        ierr,            /* status of call to statistics file */
        lbot,            /* line # of bottom site bounding    */
        size[4],         /* size bouning rectangles  */
        stat;
long    fatal_err = -1;                /* fatal error return status */
long    inf_err = 1;                   /* info error return status  */

/*
 loop through classes.
---------------------
*/

*lmin = 99999;
*lmax = 0;
k=0;

for (i=0; i< nclass_used; i++)
   {
   ic = clsind[i];
/*
 loop through sites.
--------------------
*/
   for (j=0; j < nsites[i]; j++)
      {         
      is= j+1;
/*    
get site vertices from statistics file 
---------------------------------------
*/
       getpoly (ic, is, xaxis[k], yaxis[k], &nverts[k], wind);

/*
 get boounding retangles of site
---------------------------------
*/
      verts (size, xaxis[k], yaxis[k], nverts[k]);

/*
check if outside the window or not
----------------------------------
*/
      if (size[0] > wind[0][2]  ||  size[1] > wind[0][3] || 
      size[2] < 1  ||  size[3]  <  1) 
         {
         c_errmsg ("Polygon vertex outside image for class and site", 
                   "tsclass-poly", &inf_err);    
         }
/*
find intersections of site rectangles and windows
-------------------------------------------------
*/
      else
         {
         area[k][0] = max(size[0], 1);
         area[k][1] = max(size[1], 1);
         area[k][2] = min(size[2], wind[0][2]) - area[k][0]+1;
         area[k][3] = min(size[3], wind[0][3]) - area[k][1]+1;

/*
 find bounding lines for all sites
----------------------------------
*/                              
       if (area[k][0]  < *lmin)    *lmin = area[k][0];
       lbot=area[k][0]+area[k][2]-1;
       if (lbot  > *lmax)          *lmax=lbot;
       k = k + 1;                                                     
       if (k  >  1023)
       c_errmsg ("Total # selected sites  >1023,restart",
                 "tsckass-setarea", &fatal_err);                           
       } /* end of if */
    }  	           /* end of nsites loop */                
   } 		   /* end of nclass_used loop */
*polygon = k;
}
