#include "tsclass.h"

FUNCTION statchk ( stahos, nclass_asked, nclass_used)

char    stahos[];		/* stats file host name */
long	nclass_asked, 		/* no. of classes */
        *nclass_used;		/* no. of classes processed */
/*
********************************************************************

NAME: statchk.c 

PURPOSE:     OPENS STATISTICS FILE; CHECKS NUMBER OF CLASSES IN FILE
            AGAINST USER'S REQUEST.

PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/

{
/* local variables  */
long    access,			/* mode of access */
        stat,			/* status returned */
        nclass_in_file;		/* no. of classes in stats file */
char    ch,
        buf[100];		/* temporary buffer */
long    fatal_err = -1;                /* fatal error return status */
long    inf_err = 1;                   /* info error return status  */

/*
 statchk  opens stats file & checks for # of classes
----------------------------------------------------
*/
access = IUPDATE;
stat = c_stopen (&sdesc[0], stahos, &access, &nclass_in_file); 
if (stat != E_OPOLD)
   c_errmsg ("Unable to open stats file. Restart", "tsclass-stat", &fatal_err);

/*
 check # files against user's request
-------------------------------------
*/
if (nclass_asked > nclass_in_file)
   {
   c_errmsg("Number of classes specified exceed number in file.", 
            "tsclass-nclass", &inf_err);
/*
----------------------------
 user must respond yes or no
----------------------------
*/
   printf("$_Do you wish to proceed using all classes? (Y/N):");

   ch = getchar();
   if (ch == 'y' || ch == 'Y')       /* all classes */
      nclass_asked = 0;
   else if (ch == 'n' || (ch) == 'N')   /* abort */
      c_errmsg ("Too many classes requested. Restart", "tsclass-class", 
                &fatal_err);
  }
/*
 establish actual # classes to be used
--------------------------------------
*/
*nclass_used=nclass_asked;
if (nclass_asked == 0)
  {
  *nclass_used = nclass_in_file;
  sprintf(buf, "Number of classes to be used is now reset to: %3d",
          *nclass_used);
  c_errmsg(buf, "tsclass-reset", &inf_err);                                     
  }
}
