#include "tsclass.h"
   
FUNCTION table(intae, num_images, maxmin, ncx, 
icount, clsind, nsites, tclass, tsum, fopt)  
                                           
long    icount;		      /* number of rows        */
long    ncx,                  /* number of class              */
	num_images;          /* # of total input image bands */
                    
long	maxmin,                 /* classification indicator
                                 =1: Bayesian Classification
                                 =2: Minimum Distance Classification  */
       	tclass[MAXCLS],        /* total count for each class number      */
        *tsum;                  /* total number of pixels in all sites    */

long	clsind[],              /* class indices  */
        nsites[];              /* # of sites in classes    */

char	fopt[5],             /*  option  */
 	intae[][CMLEN];      /* input images intae names  */

/*
********************************************************************

NAME: table.c 

PURPOSE: OUTPUTS FIRST CONTINGENCY TABLE TO FILE

PROGRAM HISTORY:

  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0   10-Jan-85      Y. Sheu                      revision 1.0
    3.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/
{
#define term_width 72
#define lp_width 112

/* local variables */
long    ninx,
        index[MAX_POLYGON],
	list[MAX_POLYGON],
        cssum[MAX_POLYGON];                 /* ROW SUM   */
long	sssum[MAX_POLYGON];        
 
long    itype=ELONG;  
long	first;
long	ibeg, icols,  istart;
long	ncols, npc, icnt;
long	nindex;
long	i, in, ind, j, k, n;
long	off;

char	buf[ERRLEN] ; 
char	line[MAX_WIDTH];
char	*tbuf;

float	pcts[10],   /* % OF CLASS NUMBER COUNTS TO ROW SUM */
        tpcts[10];  /* % OF CLASS NUMBER COUNTS TO COLUMN SUM */
        
long    zero = 0;

/*
Write class and site names
--------------------------
*/    
lnames (ncx, clsind, nsites, fopt, index, list);

/*
set values for table outline
----------------------------
*/
icnt = 0;
off = 20;                               
strcpy (line, "                          + ");          
for (k = off+4; k < lp_width+off; k += 2)
   {
   line[k] = '-'; 
   line[k+1] = ' ';
   icnt++;
   if (icnt == 5)
      {
      line[k] = '+';
      icnt=0;
      }  
   }  

/*
set start values for printing - if only LP is requested set max no. of
columns and width; otherwise set them all equal to max terminal limits
----------------------------------------------------------------------
*/
if (print[LP] && !print[TERM] && !print[FIL])
   {                                          /*  to line printer */
   ncols = 11;
   npc = lp_width;
   }
else                          
   {
   ncols = 6;
   npc = term_width;
   }
istart=0;
icols = ncols + istart - 1;

/*
compute raw sum
---------------
*/
c_pxfill(cssum, &itype, &icount, &zero);
c_pxfill(sssum, &itype, &icount, &zero);
         
for (i=0; i < icount; i++)
  {
  for (j=istart; j < ncx; j++)
    {
     cssum[i] += cclass[i][j];
    }
  }

for (i=0; i < icount; i++)
  {
  for (j=istart; j < ncx; j++)
    {
     sssum[i] += sclass[i][j];
    }
  }

/*
write out set of columns in table
---------------------------------
*/                                     
while (istart  <=  ncx)
   {
   tbuf = "\f***Contingency table produced by TSCLASS***"; 
   c_txtout (tbuf, print, fd);

   tbuf = "\n Input image  ";
   c_txtout (tbuf, print, fd);
   
   for (i=0; i < num_images; i++)
      {
      sprintf (buf, "          %s\n", intae[i]); 
      c_txtout (buf, print, fd);
      }
                            
   tbuf = "...First number in table = pixels in each class assignment";
   c_txtout (tbuf, print, fd);

   sprintf (buf, "...Second number = percentage of pixels in the %s", fopt);
   c_txtout (buf, print, fd);

   tbuf = "...Third number = percentage of pixels in the class assignment.\n\n";
   c_txtout (tbuf, print, fd);

   if (icols > ncx)
      {
      icols = ncx;
      ncols = ncx - istart+1;
      }  
   nindex = ncols * 10;
   line[nindex+off+1] = '\0';

   if ((strcmp(fopt,"SITE") == 0) || (strcmp(fopt,"site") == 0))
    {              
      tbuf = " Actual class                          Output Image";
      c_txtout(tbuf, print, fd);                                 

      tbuf = " Identity (by sites)                   Class Assignments\n\n"; 
      c_txtout(tbuf, print, fd);

      sprintf(buf, "                     ");
      for (ninx=istart; ninx < icols; ninx++)             
           {                                               
           sprintf (&buf[strlen(buf)], "%8d  ", clsind[ninx]); 
           }                      
      if( icols == ncx) sprintf(&buf[strlen(buf)],"  Rowsum");
      c_txtout( buf, print, fd);      
    }
   else
    {
      tbuf = " Actual class                          Output Image";
      c_txtout(tbuf, print, fd);                                 

      tbuf = " Identity                          Class Assignments\n\n";
      c_txtout(tbuf, print, fd);

      sprintf(buf, "                     ");              
      for (ninx=istart; ninx < icols; ninx++)
             {                                                 
             sprintf (&buf[strlen(buf)], "%8d  ", clsind[ninx]); 
             }                      
      if( icols == ncx) sprintf(&buf[strlen(buf)],"  Rowsum");
      c_txtout( buf, print, fd);                  
    }

   c_txtout(line, print, fd); 
                                          
for (k=0; k < icount; k++) 
      {                    
      j=index[k];
      if (icols  ==  ncx) 
       {
         if ((strcmp(fopt,"SITE") == 0) || (strcmp(fopt,"site") == 0))
            {
 	    sprintf(buf,"Class # %2d  Site # %2d !", j, list[k]);
            for (n=istart; n < icols; n++)              
              {                                 
              sprintf (&buf[strlen(buf)],"%8d !",sclass[k][n]);
              }
            if(icols==ncx) sprintf(&buf[strlen(buf)],"%8d",sssum[k]); 
            c_txtout(buf, print, fd);
            }                               
         else
            {
 	    sprintf(buf,"Class # %2d            !", j);
            for (n=istart; n < icols; n++)              
              {                                 
              sprintf (&buf[strlen(buf)],"%8d !", cclass[k][n]);
              }
            if(icols==ncx) sprintf(&buf[strlen(buf)],"%8d",cssum[k]); 
            c_txtout(buf, print, fd);
            }
       }
      else                
       {
         if ((strcmp(fopt,"SITE") == 0) || (strcmp(fopt,"site") == 0))
            {
 	    sprintf(buf,"Class # %2d  Site # %2d !", j, list[k]);
            for (n=istart; n < icols; n++)              
              {                                 
              sprintf (&buf[strlen(buf)],"%8d !", sclass[k][n]);
              }
              c_txtout(buf, print, fd);
            }                           
         else                                             
            {
 	    sprintf(buf,"Class # %2d            !", j);
            for (n=istart; n < icols; n++)              
              {                                   
              sprintf (&buf[strlen(buf)],"%8d !", cclass[k][n]);
              }
            c_txtout(buf, print, fd);
            }   /* if */
        }  /* if */

/*
 calculate percentages for each class number
--------------------------------------------                     
*/   
      if ((strcmp(fopt,"SITE") == 0) || (strcmp(fopt,"site") == 0))
        { 
        tablecal (ncx, istart, icount, sclass[k], &sssum[k], tclass, 
                pcts, tpcts);
        }
      else
        {
        tablecal (ncx, istart, ncx, cclass[k], &cssum[k], tclass, 
                pcts, tpcts);
        }
      sprintf(buf, "                      !"); 
      for (n=0; n < ncx; n++)               
         {
         sprintf(&buf[strlen(buf)],"%8.1f !",pcts[n]);
 	 }             
      c_txtout(buf, print, fd);    
      sprintf(buf, "                      !");
      for (n=0; n < ncx; n++)
         {                                    
         sprintf(&buf[strlen(buf)],"%8.1f !",tpcts[n]);
 	 }
      c_txtout(buf, print, fd);

    c_txtout(line, print, fd);   
 
    }  /* end of for loop */

/*
write out the total in each column  
----------------------------------
*/
   if (icols  ==  ncx) 
      {
      sprintf(buf, "               Total ");
      for (k=istart; k< icols; k++)       
         {
         sprintf(&buf[strlen(buf)],"%8d  ",tclass[k]);
 	 }
      if(icols==ncx) sprintf(&buf[strlen(buf)],"%8d\n",*tsum); 
      c_txtout(buf, print, fd);
      }
   else
      {
      sprintf(buf, "                Total ");
      for (k=istart; k< icols; k++)        
         {
         sprintf(&buf[strlen(buf)],"%8d  ",tclass[k]);
 	 }
      c_txtout(buf, print, fd);      
      }  

/*
find next set of columns
------------------------
*/
   istart=icols+1;
   icols=icols+ncols;
   }  /* do */

}
