#include "tsclass.h"
 
FUNCTION tablecal ( ncx, istart, icount, number, sum, 
total, pcts, tpcts)

long	icount,			  /* # of columns for computation */
	istart,                   /* starting class number    */
	ncx,                      /* # of classes */    
	number[MAXCLS],         /* class # counts in class/site */
 	*sum,                  /* row sum   */                 
 	total[MAXCLS];        /* colum sum */

float	pcts[10],	      /* % of class number counts to row sum  */
        tpcts[10];            /* % of class number counts to column sum */

/*
********************************************************************

NAME: TABLECAL

PURPOSE: COMPUTES THE PERCENTAGES FOR CONTINGENCY TABLES

PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      AUG-84      Y. SHEU                      version 1.0
    2.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/
{

/* local variables   */
 
long
	dtype=EREAL,
   	i,
        l;
float   fzero = 0.0;
/*
 initialize percentage values
-------------------------------
*/
c_pxfill ( pcts, &dtype, &icount, &fzero); 
c_pxfill ( tpcts, &dtype, &icount, &fzero); 
for (i=0; i < icount; i++)
   { 
   l=istart+i;
   if (*sum  >  0) 
      {
/*
 obtain percentage counts
----------------------------
*/
      pcts[i]=100.* (float)(number[l])/(float)(*sum);     
      }  /* if */

   if (total[l]  >  0)                           
      {                                           
      tpcts[i]=100.* (float)(number[l])/(float)(total[l]);
      }  /* if */                            

   }           /* for */           
return;
}

