#include <stdio.h>
#include <math.h>
#include "statio.h"
#include "las.h"

#define TERM 0
#define LP   1
#define FIL  2
 
                               
#define MAX_VERT       201  /* maximum vertices allowed by polysit2 plus 1 */
#define MAX_XYVERTS 401  
#define MAX_POLYGON    1023
#define MAX_AREA       MAX_POLYGON+1
#define MAX_SEGP       256
#define MAX_ELEMENT    MAXBND*(MAXBND+1)/2
#define MAXW           MAX_SEGP*MAXBND
#define MAX_WIDTH      132          
struct	PARBLK	block;                 /* TAE parameter block     */
struct  DDR	ddr;                   /* ddr                     */
FILE	*fd;			       /* temp file descriptor    */

unsigned char *iobuf;   	/* image i/o buffer        */
long	fdescin[MAXIMG+3];             /*  file descriptors  */
long	gdesc;                       /*  group descriptor  */
long	sdesc[2];		/* File descriptors of stats files */
long	*ipoint;   /* offsets into image i/o  */
long	opoint;                /* for input and output bands */
long	image_band_num[MAXIMG][MAXBND+1];  /* band numbers selected
                                                for each image specified */
long   	out_img_bands[2][2];
                                      /* bands numbers for output image */
long	cclass[MAXCLS][MAXCLS];        /* class number counts for 
                                                  class/site */  

long	min_max;                       /* minmax option flag      */
long 	msgtim;                        /* message interval        */
long 	num_outfiles;                  /* number of output files  */
long 	num_cfiles;                  /* number of output files  */
char    out[2][CMLEN];             /* output file names       */
long	print[3];                      /* print options           */
FILE	*print_file;	/* file descriptor of data print file */
char    out_files[3][CMLEN];             /* output file names       */
char    cf_files[3][CMLEN];      /* contingency output file names   */
                                                                
long    *x_matrix, *y_matrix;          /* polygon matrices */
long    *xaxis[MAX_POLYGON],
                *yaxis[MAX_POLYGON];
                 
IMPORT	long	curent;                        /* current entity           */
IMPORT	long	curcat;                        /* current category         */

struct	{        
		float	*mean[MAXCLS];
		float   *covinv[MAXCLS];
		} sstat;

float   *mean_matrix;
float   *covinv_matrix;

float	cconst[MAXCLS];  	/* Class constants                  */
long    sclass[MAX_POLYGON][MAXCLS];    

unsigned char	*ealloc();

main ()
{
long
        lmax,     /* maximum line number for all site boundings */
	lmin,     /* minimum line number for all site boundings */
        maxmin,
        metric,
	nclass_asked,            /*  # classes asked for stat input  */
	nclass_in_file,          /*  # classes in sfin               */
	nclass_used,             /*  actual # of classes used        */
	num_image_bands[MAXIMG], /* number of bands in each input image  */
	num_inbands,             /* total number of input image bands  */
	num_inimages,            /* number of input images           */
	out_type,                /* output image data type           */
        wind[MAXIMG][4];		/* input image window		*/
                
char    
 	aprior[6],	             /* User option for prior probabilities  */
  	cflag[4],	             /* 2nd contingency table option flag    */
        inhos[MAXIMG][CMLEN],         /*    input image host name      */  
        intae[MAXIMG][CMLEN],         /*    input image tae name       */
        outhos[CMLEN],         /*    output image host name     */
        outtae[CMLEN],        /*    output image tae name      */  
        outbuf[ERRLEN],       /* message buffer */         
        stahos[CMLEN],        /* Stats file host name          */
        statae[CMLEN];        /* Stats file tae name          */

char	print_filename[CMLEN];   /* output file name                 */

double
	amax[MAXBND],		  /*    maximum pixel value        */
        amin[MAXBND];              /*    minimum pixel value        */  

float	maxdist,
      	weight[MAXBND];

long
	dsref, odsref,
	clind[MAXCLS],	        /* Class indices for input stats file    */
	clsind[MAXCLS],                       
 	nverts[MAX_POLYGON],    /*  # of vertices for each polygon */
	nsites[MAXCLS],         /*  # of sites for each class      */
        polygon,                /*  # of polygon                   */
	tclass[MAXCLS],         
	tsum;
char    fopt[5];
       
static long  area[1024][4];        /* bounding rectangles   */
long    one = 1;

/*
********************************************************************

NAME: tsclass 

PURPOSE: MAIN DRIVER FOR BAYESIAN  OR MINIMUM DISTANCE CLASSIFIER 
         FOR SELECTED SITES

PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      Aug-84      Y. SHEU/scn                 version 1.0
    2.0   10-Jan-85      Y. Sheu/scn                 revision 1.0
    3.0      May-90      W. Xia/stx                  conversion to c
    3.1	     Jan-91      D. Etrheim/EDC              Changes to compile on 9080
    3.2      Sep-92      D. Etrheim/EDC              Modify global include file

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 
call GETPAR to get user specified parameters
call FILSPEC to set up images
call STATCHK to check number of classes to be processed
call INDICES to reives user specified class and site names 
call GETSTAT to get statistics
call SETAREA to get site polygons and set up site rectangles for iscds
call CLASSFY to do the classification                 
call CLASSTAT to accumulate class number counts  for each class 
call TABLE to  produce first contigency table
if the 2nd contingency table is required, then call TABLE to write it
call MINMAX and SVMNMX
call c_hstout to generate the history file
call c_complt to print the completion message.

*************************************************************************
*/

/*
get tae  parameters
------------------
*/    
getpar (intae, inhos, statae, stahos, outtae, outhos,  wind, &num_inimages, 
        num_image_bands, &nclass_asked, &num_inbands,
        &out_type, &maxmin, aprior, &maxdist, &metric, weight,
        cflag, print_filename);
ipoint =   (long *) malloc((MAXIMG*MAXBND+1) * sizeof(long));
  
/*
 set up image files                                       
-------------------
*/
filspec (inhos, outhos, &num_inimages, num_image_bands, wind, out_type);

/* 
check number of classes to be processed
---------------------------------------
*/
statchk (stahos, nclass_asked, &nclass_used);

/*
Receives user specified class and site names 
---------------------------------------------
*/
indices (nclass_asked, nclass_used, clsind, nsites);

/*               
get statistics for classifier and select classes
------------------------------------------------
*/        
getstat (stahos, &nclass_used, aprior, num_inbands, 
	 clsind, maxmin);

/*
get site polygons and set up site rectangles for iscds
------------------------------------------------------
*/
setarea (nclass_used, clsind, nsites, &polygon, 
	  nverts, &lmin, &lmax, wind, area);

/*
 do classificaion to images within polygonal rectangles
 and accumulate class number counts for each site
--------------------------------------------------------
*/
classfy (wind, nclass_used, &polygon, num_inbands,    
	 clsind, nverts, lmin, lmax, maxmin, 
	 weight, maxdist, metric, area);

/*
 accumulate class number counts  for each class 
------------------------------------------------
*/
classtat (nclass_used, nsites, tclass, &tsum);

/*
 produce first contigency table
-------------------------------
*/
/*                                   
table (intae, num_inbands, maxmin, nclass_used, 
       nclass_used, clsind, nsites, tclass, &tsum, "class");
*/
strcpy(fopt,"class");
table (intae, num_inbands, maxmin, nclass_used, 
       nclass_used, clsind, nsites, tclass, &tsum, fopt);
                             
/*                            
 produce second contigency table
---------------------------------
*/

if (strcmp(cflag,"YES") == 0)
   {                         
/*   table (intae, num_inbands, maxmin,  nclass_used,
          polygon, clsind, nsites, tclass, &tsum, "site");   
*/
   strcpy(fopt,"site");
   table (intae, num_inbands, maxmin,  nclass_used,
          polygon, clsind, nsites, tclass, &tsum, fopt);   
   } 

/*
close output file
-----------------
*/
if (fd) fclose (fd);

/*
close image files  and statistics file
-------------------------------------
*/
c_stclse(&sdesc[0]);
c_egclse(&gdesc); 

out_img_bands[0][0]=1;
/*
calculate the minimum and maximum pixel values for the output image
-------------------------------------------------------------------
*/
if(min_max)
{  
    wind[0][SS] = wind[0][SL]=1;
    c_minmax (outhos, &one, wind, image_band_num, out_img_bands, amin, amax);
    c_svmnmx (outhos, &one, amin, amax, "YES");
}

/* dyn_free(); */
  
/*
Generate the history file and print the completion message.
------------------------------------------------------------
*/
c_hstout (&block, outhos, inhos, &num_inimages, " ");
c_complt ("TSCLASS", out_files, &num_outfiles);

}
