#include "tsclass.h"

FUNCTION verts (size,  xaxis, yaxis, nverts)
                                          
long   	 xaxis[],    /* x image coordinate */
        yaxis[],    /* y image coordinate */
        nverts,                    /* no. of vertices           */
        size[4];                   /* site bounding rectangle   */
/*
********************************************************************

NAME:   VERTS
             
PURPOSE: RETURNS SITE BOUNDING RECTANGLE IN TERMS OF INPUT IMAGE
            COORDINATES.
         
PROGRAM HISTORY:
  Version    Date        Author                       Request
  -------   ----         ------                       -------
    1.0      JUN-84      Y. SHEU                      version 1.0
    2.0      May-90      W. Xia                       conversion to c

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
         runs under TAE

PROJECT: LAS

ALGORITHM DESCRIPTION:
 

*************************************************************************
*/

{
/* local variables */
long	minx, miny,             /* minimum coordinates */
        maxx, maxy,             /* maximum coordinates */
        n;                      /* counter value       */

/*
initialize min and max x and y coordinates
------------------------------------------
*/
minx = 999999;
maxx = 0;
miny = 999999;
maxy = 0;

/*
 find min. and max. x and y coordinates.
 -------------------------------------- 
*/

for (n=0; n < nverts; n++)
   {      
   if ( xaxis[n]  <  minx) minx =  xaxis[n];
   if ( xaxis[n]  >  maxx) maxx =  xaxis[n];
   if (yaxis[n]  <  miny) miny = yaxis[n];
   if (yaxis[n]  >  maxy) maxy = yaxis[n];
   } 
/*
 find bounding rectangles
-------------------------
*/
size[0] = miny;   
size[1] = minx; 
size[2] = maxy;
size[3] = maxx;
}      
