#include "las.h"
#include "protos.h"

float ***fmat3d
(
    long nx, 				/* x dimension (ex: bands)	*/
    long ny,				/* y dimension (ex: lines)	*/
    long nz				/* z dimension (ex: pixels)     */
)
/*
******************************************************************************

NAME: FMAT3D

PURPOSE: Allocates storage for a three dimensional floating point matrix.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          16-Jun-89   K. Narayanan       
   2          30-Jun-89   K. Kunska	  modifications for 3 dimensions
   3          12-Dec-89   K. Kunska       copied from SEARCH to be used
                                          by UHIST
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
{
float ***m;			/* pointer to 3-dimensional space             */

long	i, j;			/* loop counters and array index              */

if ((m = (float ***) malloc (nx * sizeof (float **))) == NULL) 
   return (NULL);

for (i = 0; i < nx; i++)
   {
   if ((m[i] = (float **) malloc (ny * sizeof (float *))) == NULL) 
      return (NULL);
   for (j = 0; j < ny; j++)
      if ((m[i][j] = (float *) malloc (nz * sizeof (float))) == NULL) 
         return (NULL);
   }
return(m);
}
