#include "las.h"
#include "protos.h"

void freefmat3d
(
    float ***m,		/* pointer to 3-dimensional space */
    long nx, 		/* x dimension (ex: bands)	*/
    long ny 		/* y dimension (ex: lines)	*/
)
/*
******************************************************************************

NAME: FREEFMAT3D

PURPOSE: Frees storage allocated for a three dimensional floation point matrix.

PROGRAM HISTORY:
  Version	Date       Author	      Request
  -------	----	   ------             -------
   1          16-Jun-89   K. Narayanan       
   2          30-Jun-89   K. Kunska	   modifications for three dimensions
   3          12-Dec-89   K. Kunska        copied from SEARCH to be used by
                                           UHIST
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:	
	Runs under TAE

PROJECT:	LAS

***************************************************************************
*/
{
long	i, j;		/* loop counters and array indices */

for (i = 0; i < nx; i++)
   for (j = 0; j < ny; j++)
      free (m[i][j]);

for (i = 0; i < nx; i++) 
   free (m[i]);

free (m);
}
