#ifndef PROTOS_H
#define PROTOS_H

void defaults
(
    char hosin[][CMLEN],			/* input image host name             */
    long nbands,				/* total number of input image bands */
    long num_inimg,			/* number of input images            */
    long num_img_bands[][MAXBND+1],	/* band numbers for each input image */
    long bands_per_img[],		/* number of bands in each image     */
    double amin[],				/* minimim pixel values              */
    double amax[],	 			/* maximum pixel values              */
    float *scale				/* scaling factor for gradient       */
);

void filspec
(
    char hostin[][CMLEN], 		/* host name for input image          */
    char hostout[], 			/* host name for output image         */
    long num_inimages,			/* total number of input images       */
    long num_img_bands[][MAXBND+1],	/* band numbers for each input image  */
    long out_img_bands[MAXBND+1],	/* band numbers for each output image */
    long out_bands,			/* number of output image bands       */
    long bands_per_img[],		/* number of bands for each image     */
    long *dtype				/* input image data type	      */
);

float ***fmat3d
(
    long nx,
   long ny,
   long nz
);

void freefmat3d
(
    float ***m,		/* pointer to 3-dimensional space */
    long nx, 		/* x dimension (ex: bands)	*/
    long ny 		/* y dimension (ex: lines)	*/
);

void getpar
(
    char taein[][CMLEN],		/* tae name of the input image              */
    char hosin[][CMLEN],		/* host name of the input image             */
    char taeout[][CMLEN], 		/* tae name of the output image             */
    char hosout[][CMLEN],		/* host name of the output image            */
    float *scale,			/* scaling factor                           */
    long *bands_per_img, 	/* number of bands per input imgae           */
    long *dtype,			/* data type of the input image              */
    long *num_inimg,		/* total number of input images              */
    long (*num_img_band)[MAXBND+1],	/* band numbers for each input image */
    long img_limit,		/* maximum number of images                  */
    long (*img_flag)[2],		/* specified image/band options              */
    long *same_wnd, 		/* same window size? 1=Y 2=N                 */
    long *tot_inbands		/* total number of input bands               */
);

void gradient
(
    long nbands,			/* total number of bands                      */
    long num_lines,		/* number of lines in the input image         */
    long num_pixels,		/* number of pixels in the input image        */
    float scale,			/* scale factor for gradient calculations     */
    float *minpix, 		/* minimum pixel value                        */
    float *maxpix, 		/* maximum pixel value                        */
    long dtype			/* Input image data type		      */
);

#endif
