	program unilut
c     **************************************************************************
c     program  unilut
c
c     purpose: to create and/or edit a lookup table (lut) for the  
c	plotting software
c
c     file references: 
c
c	logical unit number 5 = input from the terminal
c	logical unit number 8 = vms file for lut
c	logical unit number 9 = vms file for lut which is opened on the (w)rite
c				command.
c
c     common block references:
c	name	field	type	i/o	description
c	----	-----	----	---	-----------
c	out     stdout  i*4     n/a     lun for output to terminal
c					(returned from inlas)
c
c     subroutines called:
c        name          description
c        ----          -----------
c	setup	       sets up part of initial screen
c	screen	       sets up values on initial screen
c	command	       gives initial command line and calls the subroutines
c		       used for the rest of processing
c
c       (catalog manager routines)
c	xbinit		initialize xt and xr routines
c     
c	(las programmer's routines)
c	complt		write a completion message to the user
c       inlas	 	initialization
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1     7/25/84  b. wilsey         csb
c	2      7/1986  k. zanter         csb       prf #3027 and
c						   update for standards
c	3      12/1987 r. mckinney       csb       update for uniras
c
c     language:   fortran-77
c*
c**   pdl:
c     begin
c	call inlas for initialization
c	initialize lin array
c	call xbinit to initialize the catalog manager
c	call xrstr to get vms lut file name
c	  inquire to see if file exists
c         if (file does not exist)
c		read description from user
c 	  else
c		open file
c		read description from file
c		read values from file
c		close file
c	  endif
c	call setup to set up initial screen
c	call screen to set up initial screen values
c	call command to continue processing
c
c**   end
c

c
	include 'las.fin'

c
	character 
     .		lfile*80
     .,		descr*80
     .,		dash*30
     .,		labl*30
        character*3 subcmd
   	integer*4 vblk(xprdim)
     .,		stat
     .,		stdout
     .,		one
     .,		count
     .,		pix
     .,         option
	character*8 field1, field2, field3
	integer*4 max1, max2, max3
 	integer*4 yel(256),mag(256),cyn(256)
	integer*4 scr(256),col(256),lin(256)
	integer*4 i,k,j
        integer*4 len,itype,ilines,icols,iterm
c
        logical ex
c	
c	common/out/stdout

	data one/1/
	data yel,mag,cyn/768*0/
	data scr/90*1,90*2,76*3/
	data col/18*4,18*19,18*34,18*49,18*64,
     .		18*4,18*19,18*34,18*49,18*64,
     .		18*4,18*19,18*34,18*49,4*64/

c
	call inlas(vblk,stdout)

	do 10 i=1,252,18
		j = 3
		do 20 k=i,i+17
			lin(k) = j
			j = j + 1
  20		continue
  10	continue
	j = 3
	do 30 i=253,256
		lin(i) = j
		j = j + 1
  30	continue

	cyn(256) = 16

c	call xzinit(vblk,xprdim,stdout,xabort,stat)
        call xtinit(itype,ilines,icols)
	call xrstr(vblk,'outlut',one,lfile,len,count,stat)
        call up2low(lfile,len)
	call xrstr(vblk,'_subcmd',one,subcmd,len,count,stat)
        if ((subcmd.eq.'ymc').or.(subcmd.eq.'YMC'))
     .  call xrintg(vblk,'option',one,option,count,stat)
        if ((subcmd.eq.'ymc').or.(subcmd.eq.'YMC')) then
        field1 = 'yellow: '
        field2 = 'magenta:'
        field3 = 'cyan:   '
  	   if (option.eq.1.) then
	   max1 = 4
	   max2 = 4
	   max3 = 4
	   else if (option.eq.2) then
	   max1 = 16
	   max2 = 16
	   max3 = 16
	   else if (option.eq.3) then
	   max1 = 64
	   max2 = 64
  	   max3 = 64
	   else if (option.eq.4) then
	   max1 = 256
	   max2 = 256
	   max3 = 356
	   end if
	 else if ((subcmd.eq.'gen').or.(subcmd.eq.'GEN')) then
	   field1 = 'color1: '
	   field2 = 'color2: '
           field3 = 'color3: '
	   max1 = 999
	   max2 = 999
	   max3 = 999
         else if ((subcmd.eq.'rgb').or.(subcmd.eq.'RGB')) then
	   field1 = 'red:    '
	   field2 = 'green:  '
  	   field3 = 'blue:   '
	   max1 = 255
	   max2 = 255
 	   max3 = 255
         else if ((subcmd.eq.'his').or.(subcmd.eq.'HIS')) then
           field1 = 'hue:    '
           field2 = 'intens: '
           field3 = 'satur:  '
	   max1 = 360
	   max2 = 100
	   max3 = 100
	 else if ((subcmd.eq.'bw ').or.(subcmd.eq.'BW ')) then
	   field1 = 'value:  '
	   field2 = '        '
	   field3 = '        '
	   max1 = 100
	   max2 = 0
	   max3 = 0
         end if
c	
	  inquire(file=lfile,exist=ex)
	    if(.not.ex)then
C		write(stdout,1)
C  1		format(//,30('-'),/,' * enter description for lut.',/
C     ., 8x,'(80 char. limit)')
C		read(5,'(a80)') descr
            dash(1:30)='------------------------------'
            call xtclr
            call xtout(21,1,dash)
            labl(1:30)=' * enter description for lut. '
            call xtout(22,1,labl)
            labl(1:30)='      (80 char. limit)        '
            call xtout(23,1,labl)
	    call xtin(24,1,descr,len,iterm)
            else
		open(unit=8,file=lfile,status='old')
		read(8,'(a80)') descr
		do 11 i=1,256
			read(8,'(1x,i3,3(1x,i3))') pix,yel(i),mag(i)
     .,			cyn(i)
			if( pix.ne.(i-1) )pause
11		continue
		close(unit=8)
	    endif
c
	call setup(descr,subcmd)
	call screen(1,yel,mag,cyn,scr,col,lin)
	call command(descr,lfile,yel,mag,cyn,scr,col,lin,
     .	max1,max2,max3,field1,field2,field3,subcmd)
	end

	subroutine command(descr,lfile,yel,mag,cyn,scr,col,lin,
     .   max1,max2,max3,field1,field2,field3,subcmd)
c
c
c     subroutine command
c
c
c     purpose:  displays command line and calls subroutines to continue
c		processing
c
c
c     calling sequence:   call command (descr,lfile,yel,mag,cyn,scr,col,lin,
c                         max1,max2,max3,field1,field2,field3,subcmd)
c
c     arguments:   
c
c	descr	char*80	in	description for lut
c	lfile	char*80 in	lut to update
c	yel  integer*4 array i  yellow values
c	mag  integer*4 array i  magenta values
c	cyn  integer*4 array i  cyan values
c	scr  integer*4 array i  screen positions for each pix value (1,2,3)
c	col  integer*4 array i  column positions for each pix value
c	lin  integer*4 array i  line   positions for each pix value
c
c     file references: none
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c	point		process the (p)oint command
c	screen		process the (s)creen command
c	range		process the (r)ange command
c	line		process the (l)ine command
c	update 		process the (u)pdate command
c	wrt		process the (w)rite command
c	quit		process the (q)uit command
c	help		process the (h)elp command
c
c       (tae routines)
c	xtout		write a string to the screen
c	xtin		read a string from the screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions:
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey	csb	
c
c     language:   fortran-77
c*
c**   pdl:
c	(do until (q)uit command chosen:)
c	write command line
c	read command
c	call xtout to write escape line
c	call corresponding routine for command
c     begin
c
c
c**   end
c
c
c
	include 'las.fin'

c
	character lfile*80
     .,		descr*80
     .,		com*1
     .,		bcl*80
     .,		esclin*80
     .,		dash*80
	character*3 subcmd
        character*8 field1, field2, field3
        integer*4 max1, max2, max3
c
	integer*4 len,iterm
c
	integer*4 scr,col,lin
     .,		yel(256),mag(256),cyn(256)
     .,		cs
        integer*4 option
c
	logical toggle
c
	data cs/1/
	data toggle/.false./
c

	dash(1:40)='----------------------------------------'
	dash(41:80)=dash(1:40)
	bcl=' '
	esclin(1:40)='------------------- press <esc> key to r'
	esclin(41:80)='eturn to command line-------------------'
c
  11	continue
	call xtout(21,1,dash)
	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
	call xtout(23,3,'enter:  (s)creen (p)oint (r)ange (l)ine ')
	call xtout(23,43,'(u)pdate (w)rite (q)uit or (h)elp: ')
	call xtin(23,78,com,len,iterm)
c
	if((com.eq.'p').or.(com.eq.'P'))then
		toggle = .true.
		call xtout(21,1,esclin)
		call point(cs,yel,mag,cyn,scr,col,lin,
     .		max1,max2,max3,field1,field2,field3)
	elseif((com.eq.'s').or.(com.eq.'S'))then
		if((cs.eq.1).or.(cs.eq.2))then
			cs = cs + 1
		else
			cs = 1
		endif
		call screen (cs,yel,mag,cyn,scr,col,lin)
	elseif((com.eq.'r').or.(com.eq.'R'))then
		toggle = .true.
		call xtout(21,1,esclin)
		call range(cs,yel,mag,cyn,scr,col,lin,
     .		max1,max2,max3,field1,field2,field3)
	elseif((com.eq.'l').or.(com.eq.'L'))then
		toggle = .true.
		call xtout(21,1,esclin)
		call line(cs,yel,mag,cyn,scr,col,lin,
     .		max1,max2,max3,field1,field2,field3)
	elseif((com.eq.'u').or.(com.eq.'U'))then
		toggle = .false.
		call update(descr,lfile,yel,mag,cyn)
	elseif((com.eq.'w').or.(com.eq.'W'))then
		toggle = .false.
		call xtout(21,1,esclin)
		call wrt(descr,yel,mag,cyn)
	elseif((com.eq.'h').or.(com.eq.'H'))then
		call help(cs,descr,yel,mag,cyn,scr,col,lin,subcmd,option)
	elseif((com.eq.'q').or.(com.eq.'Q'))then
		call quit(toggle)
	else
		call xtbell
	endif
c
	go to 11
	end

	subroutine help(cs,descr,yel,mag,cyn,scr,col,lin,subcmd,option)
c
c     subroutine help
c
c
c     purpose: to display help screen for any of 6 commands used in this 
c		program.
c
c
c     calling sequence:   call help(cs,descr,yel,mag,cyn,scr,col,lin,
c                          subcmd,option) 
c
c     arguments:  
c	cs   integer*4   in     current number for screen display
c	descr char*80 in   description for file to update
c	yel   integer*4 array i yellow values
c	mag   integer*4 array i magenta values
c	cyn   integer*4 array i cyan values
c	scr   integer*4 array i screen positions for each pix value (1,2,3)
c	col   integer*4 array i column positions for each pix value
c	lin   integer*4 array i line   positions for each pix value
c       subcmd char*8   in      subcommand entered
c       option integer*4 in     input option for ymc subcommand
c
c     file references: none
c
c     common block references:
c	name	field	type	i/o	description
c	----	-----	----	---	-----------
c	out     stdout  i*4     n/a     lun for output to terminal
c					(returned from inlas)
c
c     subroutines called:
c        name          description
c        ----          -----------
c	setup		sets up part of the screen after help has been 
c			terminated
c	screen		prints color values to the screen
c
c       (tae routines)
c	xtout		writes a string to the screen
c	xtin		reads a string from the screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions:  none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey	csb          
c
c     language:   fortran-77
c*
c**   pdl:
c	call xtout to write command line to the screen
c	call xtin to get which command want help screen for
c	call xtclr to clear screen
c	display corresponding help screen
c	call xtin to read a termination for screen display
c	call setup and screen to refresh screen
c     begin
c
c
c**   end
c
c
	include 'las.fin'

c
 	integer*4 stdout, option
	integer*4 iterm,len
	integer*4 cs,yel,mag,cyn,scr,col,lin
	character bcl*80
     .,		com*1
     .,		ans*1
     .,		descr*80
        character*3 subcmd
c
c	common/out/stdout
c
C        stdout = 6
	bcl=' '
c
20	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
	call xtout(22,3,'help--- for help on a command enter command ')
        call xtout(22,47,'abbreviation: ')
	call xtout(23,3,'(s)creen (p)oint (r)ange (l)ine (u)pdate')
	call xtout(23,44,' (w)rite (q)uit or (h)elp: ')
	call xtin(23,71,com,len,iterm)
	if(iterm.eq.xesc)return
	call xtclr
	call xtout(3,5,'help')
	call xtpos(5,1)
c
	if((com.eq.'p').or.(com.eq.'P')) then
	  write(stdout,1)
1	  format(4x,'(p)oint changes subtractive color codes of one'
     .,   ' pixel value',/,12x,'in the lookup table.',//,12x,'you will'
     .,   ' be prompted for pixel value to change, first,',/,12x
     .,   'second, and third color values to assign to that pixel.')
	  write(stdout,100)
100	  format(//,12x,'all inputs should be in integer format.',/
     .,   12x,'valid values for pixels are between 0-255.',/
     .,   12x,'valid values for color codes are subcommand dependant.')
c
	elseif((com.eq.'r').or.(com.eq.'R')) then
	  write(stdout,2)
2	  format(4x,'(r)ange changes subtractive color values of a'
     .,   ' range of pixel values',/,12x,'in the lookup table.',//
     .,   12x,'you will be prompted for beginning and ending pixel'
     .,   ' values',/,12x,'for the range, plus first, second, and'
     .,' third color values to assign',/,12x,'to pixels in that range.')
	  write(stdout,100)
c  
	elseif((com.eq.'l').or.(com.eq.'L')) then
	  write(stdout,3)
3	  format(4x,'(l)ine  creates a linear stretch between two'
     .,   ' pixel values.',//,12x,'you will be prompted for beginning'
     .,' pixel value, the first,',/,12x,'second, and third color values'
     .,	  ' for the beginning pixel value, the',/,12x,'ending pixel'
     .,	  ' value, first, second, and third color values for the ',/,12x
     .,   'ending pixel value.  see user guide for the algorithm '
     .,	  'performed ',/,12x,'on the range of pixel values.')
	  write(stdout,100)
c
	elseif((com.eq.'u').or.(com.eq.'U')) then
	  write(stdout,4)
4	  format(4x,'(u)pdate  writes the current values to the file'
     .,   ' named by the input ',/,14x,'parameter "outlut".',//
     .,14x,'see user guide for the format of this file.')
c
	elseif((com.eq.'w').or.(com.eq.'W')) then
	  write(stdout,5)
5	  format(4x,'(w)rite writes the current pixel values and'
     .,   ' their color codes to a ',/,12x,'specified file.',//,12x
     .,   'you will be given the option to write a different descrip'
     .,   'tion.',/,12x,'this description can be up to 80 characters'
     .,   ' and will be',/,12x,'written on the first line of the file.'
     .,   '  you will be prompted',/,12x,'for the file name.  the'
     .,   ' file is a vms file.')
c
	elseif((com.eq.'q').or.(com.eq.'Q')) then
	  write(stdout,6)
6	  format(4x,'(q)uit  ends processing.',//,12x
     .,   'note that nothing will be recorded using the quit command.',/
     .,   12x,'update or write should be called for this run to have',/
     .,   12x,'any effect on the lut files.')
	elseif((com.eq.'s').or.(com.eq.'S')) then
	   write(stdout,7)
7	   format(4x,'(s)creen 	rotates the screen between 3 sets of'
     .,   ' pixel values.',//,14x,'since one screen display holds'
     .,   ' only 90 pixel values,',/,14x,'three screens are needed'
     .,   ' to display the entire 256.  the first',/,14x
     .,   'displays pixels 0-89, the second 90-179, the last 180-255.',/
     .,   14x,'(s)creen advances the display by one screen, looping'
     .,   ' back to',/,14x,'screen 1 if currently on screen 3.')
	else
		call xtbell
		go to 20
	endif
	call xtout(23,21,'press <ret> to return to command line')
	call xtin(23,62,ans,len,iterm)
	call xtclr
	call setup(descr,subcmd)
	call screen(cs,yel,mag,cyn,scr,col,lin)
	return
	end

	subroutine line(cs,yel,mag,cyn,scr,col,lin,
     .        max1,max2,max3,field1,field2,field3)
c
c
c     subroutine line
c
c     purpose:  creates a piece-wise linear stretch for a line between
c		two user-provided points
c
c     calling sequence:   call line (cs,yel,mag,cyn,scr,col,lin,
c                         max1,max2,max3,field1,field2,field3)
c
c     arguments:   
c	cs	integer*4	in	current display screen (1,2,3)
c	yel   integer*4 array i  yellow values
c	mag   integer*4 array i  magenta values
c	cyn   integer*4 array i  cyan values
c	scr   integer*4 array i  screen positions for each pix value (1,2,3)
c	col   integer*4 array i  column positions for each pix value
c	lin   integer*4 array i  line   positions for each pix value
c
c
c     file references: none
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c	screen		displays a screen of color values
c	gdint		validate the integer read in
c
c       (tae routines)
c	xtout		writes a string to the screen
c	xtin		reads a string from the screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions:
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey	csb	
c       1.1   08/27/86 j. lavergne      csb        corrected div. by zero
c                                                  error when begpix and 
c                                                  endpix are equal
c
c     language:   fortran-77
c*
c**   pdl:
c
c     begin
c	for each variable: 
c	    begpix beginning pixel
c	    yb 	   beginning yellow value
c	    mb     beginning magenta value
c	    cb     beginning cyan value
c	    endpix ending pixel
c	    ye     ending yellow value
c	    me     ending magenta value
c	    ce     ending cyan value
c	call xtout to display prompt
c	call xtin to get value
c	check if ended with <esc> to terminate command
c	read from the input string the value
c	figure slopes for yellow, magenta and cyan
c	do for i= beginning pixel to ending pixel:
c		set yellow, magenta, and cyan values
c		if current screen does not hold this value
c			call screen to display correct screen
c		endif
c		display new value
c	end do
c	return           	
c**   end
c
c
	include 'las.fin'

	real*8 my,mm,mc,y,m,c,diff
	integer*4 len,iterm,iy,im,ic
	integer*4 begpix,endpix,max1,max2,max3
	integer*4 yb,ye,mb,me,cb,ce
	integer*4 yel(256),mag(256),cyn(256)
	integer*4 scr(256),col(256),lin(256)
	integer*4 cs,ibeg,iend,i,ipix
	character str*15,bcl*80,inp*3
        character*8 field1, field2, field3
	logical gdint,enderr
c
	bcl=' '
c
	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
	call xtout(22,3,'line---  starting pix: ')
70	call xtin(22,25,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,begpix,0,255,22,25,'    ') ) goto 70
	call xtout(22,30,field1)
71	call xtin(22,40,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,yb,0,max1,22,40,'   ') ) goto 71
	call xtout(22,45,field2)
72	call xtin(22,55,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,mb,0,max2,22,55,'   ') ) goto 72
	call xtout(22,60,field3)
73	call xtin(22,70,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,cb,0,max3,22,70,'   ') ) goto 73
c
	call xtout(23,12,'ending pix: ')
74	call xtin(23,25,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,endpix,0,255,23,25,'    ') ) goto 74
        if (enderr) 
     .    call xtout(24,12,'                                        ')
	if(endpix.eq.begpix) then
	  call xtbell
          call xtout(24,12,'ending pix must differ from starting pix')
          enderr = .true.
          goto 74
        end if
	call xtout(23,30,field1)
75	call xtin(23,40,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,ye,0,max1,23,40,'   ') ) goto 75
	call xtout(23,45,field2)
76	call xtin(23,55,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,me,0,max2,23,55,'   ') ) goto 76
	call xtout(23,60,field3)
77	call xtin(23,70,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,ce,0,max3,23,70,'   ') ) goto 77
c
	ibeg = begpix + 1
	iend = endpix + 1
c
	diff = float(endpix - begpix)
	my = float(ye-yb)/diff
	mm = float(me-mb)/diff
	mc = float(ce-cb)/diff
c
	do 10 i=ibeg,iend
		ipix = i - 1
		y = float(yb) + my*float(ipix - begpix)
		m = float(mb) + mm*float(ipix - begpix)
		c = float(cb) + mc*float(ipix - begpix)
		if(scr(i).ne.cs) then
			cs = scr(i)
			call screen(cs,yel,mag,cyn,scr,col,lin)
		endif
		iy = y
		if((y-iy).ge.(0.5))iy = iy + 1
		im = m
		if((m-im).ge.(0.5))im = im + 1
		ic = c
		if((c-ic).ge.(0.5))ic = ic + 1
		yel(i) = iy
		mag(i) = im
		cyn(i) = ic
		write(str,'(1x,i3,3(i3),2x)') ipix,iy,im,ic
		call xtout(lin(i),col(i),str)
 10	continue
	return
	end

	subroutine point(cs,yel,mag,cyn,scr,col,lin,
     .			max1,max2,max3,field1,field2,field3)
c
c     subroutine point
c
c     purpose: to change color values for points in the lut and display 
c		these changes on the screen
c
c     calling sequence: call point(cs,yel,mag,cyn,scr,col,lin,
c		max1,max2,max3,field1,field2,field3)
c
c     arguments: 
c	cs 	integer*4	in/out	current screen displayed (1,2,3)
c	yel   integer*4 array i  yellow values
c	mag   integer*4 array i  magenta values
c	cyn   integer*4 array i  cyan values
c	scr   integer*4 array i  screen positions for each pix value (1,2,3)
c	col   integer*4 array i  column positions for each pix value
c	lin   integer*4 array i  line   positions for each pix value
c
c
c     file references: none
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c	screen		displays a screen of pixel values and their color
c			values
c	gdint		validate the integer read in
c
c       (tae routines)
c	xtin	   	reads in a string from a particular line and column
c			on the screen
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c     language:   fortran-77
c*
c**   pdl:
c
c     begin
c
c	for each of inputs:
c	
c		inpix 	pixel to change
c		yel	value to change yellow value of inpix to
c		mag     value to change magenta value of inpix to
c		cyn	value to change cyan value of inpix to
c		
c	   call xtout to print prompt
c	   call xtin to read input
c	   check if <esc> key was pressed to exit command
c	   read the value from the input string
c
c	change corresponding value in arrays
c	call xtout to change corresponding values on screen
c	go to get next point
c	
c**   end
c
c
c
c
	include 'las.fin'

	integer*4 inpix,indx,tmphld
	integer*4 scr(256),col(256),lin(256)
	integer*4 yel(256),mag(256),cyn(256)
	integer*4 cs,len,iterm
	character inp*3,str*15,blanks*15,bcl*80
	character*8 field1, field2, field3 
	integer*4 max1, max2, max3
	logical gdint
c
	bcl=' '
	blanks =' '
c
	call xtout(22,1,bcl)
	call xtout(22,3,'point---')
c
 10	continue
	call xtout(23,1,bcl)
	call xtout(23,3,'pix:')
71	call xtin(23,7,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,inpix,0,255,23,7,'    ') ) goto 71
c
	indx = inpix + 1
	if(scr(indx).ne.cs) then
		cs = scr(indx)
		call screen (cs,yel,mag,cyn,scr,col,lin)
	endif
	call xtout(23,11,field1)
72	call xtin(23,21,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,tmphld,0,max1,23,21,'   ') ) goto 72
	yel(indx) = tmphld
c
	call xtout(23,31,field2)
73	call xtin(23,41,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,tmphld,0,max2,23,41,'   ') ) goto 73
	mag(indx) = tmphld
c
	call xtout(23,51,field3)
74	call xtin(23,61,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,tmphld,0,max3,23,61,'   ') ) goto 74
	cyn(indx) = tmphld
	write(str,'(1x,i3,3(i3),2x)') inpix,yel(indx),mag(indx)
     .,   	cyn(indx)
	call xtout (lin(indx),col(indx),str)
	go to 10
	end

	logical function gdint(	str,strlen,nchars,intval,lowlim,hilim
     .,				lin,linspc,blanks)
c
c     logical function gdint
c
c     purpose:  to validate that the character string received from
c		the terminal via xtin represents a valid integer in
c		the appropriate range.  if not valid, reprompts.
c
c     calling sequence:	gdint(str,strlen,nchars,intval,lowlim,hilim,
c			      lin,linspc,blanks)
c
c     arguments:
c	str	char*(*)   i	string read from terminal
c	strlen	int*4	   i	length of str
c	nchars	int*4	   i	maximum number of characters to interpret
c	intval	int*4	   o	integer value interpreted from str
c	lowlim	int*4	   i	lower limit of valid value range
c	hilim	int*4	   i	upper limit of valid value range
c	lin	int*4	   i	line from which the value was read
c	linspc	int*4	   i	column from which the value was read
c	blanks	char*(*)   i	string of characters to blank out field
c
c     file references:  none
c
c     common block references:  none
c
c     subroutines called:  none
c
c     non-fatal error conditions:  none
c
c     fatal error conditions:  none
c
c     program history:
c
c     version	  date		author		change request
c	1	05/31/85	p. mumford	detect non-integer characters
c						before trying to interpret
c						them as integers
c     language:  fortran-77
c
c     pdl:
c
c     begin
c	determine the minimun number of characters to interpret
c	if the characters are all blank, integer is 0, return true
c	if any character after any prefix of blanks is not a numeral,
c		return false
c	else
c		read the non-blank characters as an integer
c		if the integer is outside of the valid range
c			return false
c		else
c			return true
c	if the integer was not valid, clear the field and return
c     end
c
	logical		good
	character	str*(*),blanks*(*)
	integer*4	strlen,nchars,linspc,i,start,min
     .,			lin
	integer*4	intval,lowlim,hilim
	common /force/i,start,min

	good = .true.
	i = 1
	min = min0(strlen,nchars)
  100	continue
	if( i .gt. min ) goto 200
	if( str(i:i) .ne. ' ' ) goto 200
		i = i + 1
		goto 100
  200	continue
	if( i .gt. min ) then
		intval = 0
	else
		start = i
		do 300 i=start,min
			if( (str(i:i).lt.'0') .or. (str(i:i).gt.'9') )
     .				good = .false.
  300		continue
		if( good ) then

* construct the format in a character constant while processing.

		    read( str(start:min),
     .		    '(i'//char(ichar('0')+1+min-start)//')' ) intval
		    if( (intval.lt.lowlim) .or. (intval.gt.hilim) )
     .			good = .false.
		end if
	end if

* if the string was not numeric or the integer was out of range, ring
* the bell and clear the string entered by the user.  it is assumed
* that the caller will reprompt.

	if( .not. good ) then
		call xtbell
		call xtout(lin,linspc,blanks)
	end if
	gdint = good
	return
	end

	subroutine quit(toggle)
c
c     subroutine quit
c
c     purpose:  displays a warning and asks for verify, then halts program
c
c     calling sequence:   call quit
c
c     arguments: none
c
c     file references: none
c
c     common block references: none
c
c     subroutines called:
c        name          description
c        ----          -----------
c       (tae routines)
c	xtclr		clears display screen
c	xtin	   	reads in a string from a particular line and column
c			on the screen
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c*
c**   pdl:
c
c     begin
c	if changes have been made since last update:
c		call xtout to display warning message
c		call xtout to prompt verify
c		call xtin to check verify
c		if verify is "no"
c			return
c		endif
c	call xtclr to restore screen
c	call complt to give successful completion message
c
c**   end
c
	include 'las.fin'

        integer*4 len,iterm
	character bcl*80,ans*1
	logical toggle
c
	bcl=' '
c
	if (toggle) then
	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
        call xtout(22,3,'quit---warning: you have not specified')
	call xtout(22,41,' (w)rite or (u)pdate since changes')
	call xtout(23,11,'have been made to the lut.')
	call xtout(23,37,'  quit verify? (y or n): ')
	call xtin(23,62,ans,len,iterm)
	if((iterm.eq.xesc).or.(ans.eq.'n').or.(ans.eq.'N'))return
	endif
	call xtclr
        
        call complt('UNILUT',' ',0)

	end

	subroutine range(cs,yel,mag,cyn,scr,col,lin,
     .		max1,max2,max3,field1,field2,field3)
c
c
c     subroutine range
c
c
c     purpose:  changes a range of pixel values to the values specified
c
c     calling sequence:   call range(cs,yel,mag,cyn,scr,col,lin,
c			 max1,max2,max3,field1,field2,field3)
c
c     arguments: 
c	cs	integer*4	in	current screen display (1,2,3)
c	yel   integer*4 array i  yellow values
c	mag   integer*4 array i  magenta values
c	cyn   integer*4 array i  cyan values
c	scr   integer*4 array i  screen positions for each pix value (1,2,3)
c	col   integer*4 array i  column positions for each pix value
c	lin   integer*4 array i  line   positions for each pix value
c
c
c     file references: none
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c	screen		displays a screen of pixel values and their respective
c			color codes
c	gdint		validate the integer read in
c
c       (tae routines)
c	xtin	   	reads in a string from a particular line and column
c			on the screen
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c*
c**   pdl:
c
c     begin
c	for each of inputs:
c	
c		begpix 	first pixel to change
c		endpix  last pixel to change
c		y	value to change yellow value to
c		m       value to change magenta value to
c		c	value to change cyan value to
c		
c	   call xtout to print prompt
c	   call xtin to read input
c	   check if <esc> key was pressed to exit command
c	   read the value from the input string
c	do from begpix to endpix:
c		if pixel not displayed on current screen:
c			change to pixel's screen
c		endif
c		change corresponding value in arrays
c		call xtout to change corresponding values on screen
c**   end
c
c
c
	include 'las.fin'

	character str*15,bcl*80,inp*3
        character*8 field1, field2, field3
	integer*4 max1, max2, max3
	integer*4 len,iterm
        integer*4 ibeg,iend,jkl
	integer*4 begpix,endpix,ipix
	integer*4 y,m,c,cs
	integer*4 scr(256),col(256),lin(256)
	integer*4 yel(256),mag(256),cyn(256)
	logical gdint
c
	bcl=' '
c	
	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
	call xtout(22,3,'range--- starting pix:')
71	call xtin(22,25,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,begpix,0,255,22,25,'    ' ) ) goto 71
c
	call xtout(22,30,'ending pix:')
72	call xtin(22,41,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,endpix,0,255,22,41,'    ' ) ) goto 72
c
	call xtout(23,3,field1)
73	call xtin(23,13,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,y,0,max1,23,13,'   ' ) ) goto 73
c
	call xtout(23,20,field2)
74	call xtin(23,30,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,m,0,max2,23,30,'   ' ) ) goto 74
c
	call xtout(23,37,field3)
75	call xtin(23,47,inp,len,iterm)
	if(iterm.eq.xesc)return
	if( .not. gdint(inp,len,3,c,0,max3,23,47,'   ' ) ) goto 75
c
	ibeg = begpix + 1
	iend = endpix + 1
c
c
	do 10 jkl = ibeg,iend
		if(scr(jkl).ne.cs) then
			cs = scr(jkl)
			call screen(cs,yel,mag,cyn,scr,col,lin)
		endif
		ipix = jkl - 1
		yel(jkl) = y
		mag(jkl) = m
		cyn(jkl) = c
		write(str,'(1x,i3,3(i3),2x)') ipix,y,m,c
		call xtout(lin(jkl),col(jkl),str)
 10 	continue
	return
	end

	subroutine screen (scrnum,yel,mag,cyn,scr,col,lin)

c
c     subroutine screen
c
c     purpose:  display pixels and their color codes to the screen
c
c     calling sequence:   call screen (scrnum,yel,mag,cyn,scr,col,lin)
c
c     arguments: 
c	scrnum  byte  in   screen number of pixels to display (1,2,3)
c	yel   integer*4 array i  yellow values
c	mag   integer*4 array i  magenta values
c	cyn   integer*4 array i  cyan values
c	scr   integer*4 array i  screen positions for each pix value (1,2,3)
c	col   integer*4 array i  column positions for each pix value
c	lin   integer*4 array i  line   positions for each pix value
c
c
c     file references: none
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c       (tae routine)
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c     language:   fortran-77
c*
c**   pdl:
c
c     begin
c	set corresponding starts and ends for the screen:
c		screen 1:  istart=1	iend=90
c		screen 2:  istart=91    iend=180
c		screen 3:  istart=181	iend=256
c	do from istart to iend:
c		write to string the pixel value, and each of the
c		    three color codes for yellow, magenta, and cyan
c		call xtout to write the values to the screen
c		if screen number is three, call xtout to write blanks 
c		    to the rest of the screen.
c
c**   end
c
c
c
	include 'las.fin'

	character str*15,blanks*15
	integer*4 ipix,scrnum,istart,iend,i,line
	integer*4 scr(256),col(256),lin(256)
	integer*4 yel(256),mag(256),cyn(256)
c
	blanks='               '
c
	if(scrnum.eq.1)then
		istart = 1
		iend = 90
	elseif(scrnum.eq.2)then
		istart = 91
		iend = 180
	else
		istart = 181
		iend = 256
	endif
c
	do 10 i = istart,iend
		ipix = i - 1
		write(str,'(1x,i3,3(i3),2x)') ipix,yel(i),mag(i)
     .,			cyn(i)	
		call xtout(lin(i),col(i),str)
 10	continue
	if(scrnum.eq.3) then
	 	do 20 line = 7,20
			call xtout(line,64,blanks)
 20		continue
	endif
	return
	end

	subroutine setup(descr,subcmd)
c
c
c
c     subroutine setup
c
c
c     purpose: displays description, dash line, and lable line
c
c     calling sequence:   call setup(descr,subcmd)
c
c     arguments: 
c	descr	char*80	 in  description for the file, which is displayed
c		      	     on the top line
c
c     file references: none
c
c     common block references: none
c
c     subroutines called:
c        name          description
c        ----          -----------
c 	(tae routine)
c	xtclr		clears display screen
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c     language:   fortran-77
c*
c**   pdl:
c	call xtclr to clear screen
c	call xtout to write line 1--the description
c	call xtout to write line 2--dashes
c	call xtout to write line 3--the labels
c	call xtout to write line 22--dashes
c	return
c     begin
c
c
c**   end
c
c
	include 'las.fin'

	character descr*80,dash*80,labl*80
	character*3 subcmd
	if ((subcmd.eq.'ymc').or.(subcmd.eq.'YMC')) then
	labl(1:40)= '    pix yl mg cy   pix yl mg cy   pix yl'
	labl(41:80)=' mg cy   pix yl mg cy   pix yl mg cy    '
	else if ((subcmd.eq.'gen').or.(subcmd.eq.'GEN')) then
	labl(1:40)= '    pix c1 c2 c3   pix c1 c2 c3   pix c1'
        labl(41:80)=' c2 c3   pix c1 c2 c3   pix c1 c2 c3    '
	else if ((subcmd.eq.'rgb').or.(subcmd.eq.'RGB')) then
        labl(1:40)= '    pix r1 g1 g1   pix r1 g1 b1   pix r1'
        labl(41:80)=' g1 b1   pix r1 g1 b1   pix r1 g1 b1    '
	else if ((subcmd.eq.'his').or.(subcmd.eq.'HIS')) then
        labl(1:40)= '    pix h1 i1 s1   pix h1 i1 s1   pix h1'
        labl(41:80)=' i1 s1   pix h1 i1 s1   pix h1 i1 s1    '
	else if ((subcmd.eq.'bw ').or.(subcmd.eq.'BW ')) then
	labl(1:40)= '    pix b&w        pix b&w        pix b&'
        labl(41:80)='w        pix b&w        pix b&w         '
	end if
  	dash(1:40)= '----------------------------------------'
	dash(41:80)=dash(1:40)
c
	call xtclr
	call xtout(1,1,descr)
	call xtout(2,1,labl)
	call xtout(21,1,dash)
	return
	end

	subroutine update(descr,lfile,yel,mag,cyn)
c
c     subroutine update
c
c
c     purpose:  to write the lut to the file specified in lfile parm
c
c     calling sequence:   call update(descr,lfile,yel,mag,cyn)
c
c     arguments: 
c	descr	char*80	in	description to be printed to the file
c	lfile	char*80 in	vms file name for the lut
c	yel   integer*4 array i    yellow values
c	mag   integer*4 array i    magenta values
c	cyn   integer*4 array i    cyan values
c
c     file references:
c	logical unit number 8 = the lut file to update
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c       (tae routines)
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c     language:   fortran-77
c*
c**   pdl:
c
c     begin
c
c	call xtout 4 times to notify user that the file is being updated
c	open the file
c	write the description to the file
c	do from 1 to 256:
c	 	write the pixel value and each of the three color codes to
c		the file
c	end do
c	close the file
c	return
c**   end
c
c
c
	include 'las.fin'

	character descr*80,lfile*80,bcl*80
	integer*4 yel(256),mag(256),cyn(256)
        integer*4 i,ipix
c
	bcl=' '
c
	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
	call xtout(22,3,'update---')
	call xtout(23,3,'updating file: ')
	call xtout(23,18,lfile(1:61))
c
	open(unit=8,file=lfile,status='unknown')
c
	write(8,'(1x,a80)')descr
	do 10 i=1,256
		ipix = i - 1
		write(8,'(1x,i3,3(1x,i3))') ipix,yel(i),mag(i),cyn(i)
 10	continue
	close(unit=8)
	return
	end

	subroutine wrt(descr,yel,mag,cyn)
c
c
c     subroutine wrt
c
c     purpose:  write the lut to a file other than the one to update
c
c     calling sequence:   call wrt(descr,yel,mag,cyn)
c
c     arguments: 
c	descr	char*80	in	description 
c	yel   integer*4 array i    yellow values
c	mag   integer*4 array i    magenta values
c	cyn   integer*4 array i    cyan values
c
c     file references: none
c	logical unit number 9 = file to write lut to
c
c     common block references:
c
c     subroutines called:
c        name          description
c        ----          -----------
c       (tae routines)
c	xtin	   	reads in a string from a particular line and column
c			on the screen
c	xtout		writes a string to a particular line and column on the
c			screen
c
c     non-fatal error conditions: none
c
c     fatal error conditions: none
c
c     program history:
c     
c     version   date   author        code/contr.   change request
c	1      7/25/84 b. wilsey        csb
c
c     language:   fortran-77
c*
c**   pdl:
c
c     begin
c
c	call xtout to prompt if they want to change description
c	if answer is 'y'
c		call xtout to prompt for new description
c		call xtin to get new description
c	endif
c	call xtout to prompt for vms file name to write lut to
c	call xtin to get file name
c	open file
c	write the description to the file
c	do from 1 to 256:
c	 	write the pixel value and each of the three color codes to
c		the file
c	end do
c	close the file
c	return
c
c**   end
c
c
c
c
	include 'las.fin'

	integer*4 iterm,len
	character*80 descr,lfile,bcl,newdes
	character*1 ans
	integer*4 yel(256),mag(256),cyn(256)
        integer*4 i,ipix
c
	bcl=' '
c
	call xtout(22,1,bcl)
	call xtout(23,1,bcl)
	call xtout(22,3,'write---   change description? (y or n)?')
	call xtin(22,48,ans,len,iterm)
	if(iterm.eq.xesc)return
	if( (ans.eq.'y').or.(ans.eq.'Y') )then
		call xtout(23,1,bcl)
		call xtout(22,1,bcl)
		call xtout(22,3,'write--- new descr: ')
		call xtin(22,23,newdes,len,iterm)
		if(iterm.eq.xesc)return
		call xtout(23,1,bcl)
	endif
	call xtout(23,3,'write to file: ')
	call xtin(23,18,lfile,len,iterm)
	if(iterm.eq.xesc)return
        if ((ans.ne.'y').and.(ans.ne.'Y')) then
	   newdes = descr
        endif
	open(unit=9,file=lfile,status='unknown')
	write(9,'(1x,a80)') newdes
	do 10 i=1,256
		ipix = i - 1
		write(9,'(1x,i3,3(1x,i3))') ipix,yel(i),mag(i),cyn(i)
 10	continue
	close(unit=9)
	return
	end
