


   /* calculate the geodetic latitude and the height of a point above the
      ellipse, given the geocentric latitude and the radius  
      ref.  escobal, methods of orbit determination page 398 */

#include <math.h>
#include "ellipsoid.h"

void centh2det(latc,rc,latd,h)

double latc,
       rc,
       *latd,
       *h;

   {
    double rc2,
           h2,
           hold,
           phi,
           phis,
           phip,
           dphip,
           dphis;

   long i;
       

   phip = latc;

   for (i = 1 ; i <= 20 ; i++)
      {
      rc2 = REQUA * sqrt(Q / (1.0 - EE * cos(phip) * cos(phip)));
      phi = atan(1.0 / Q * tan(phip));
      dphis = phi - phip;
      h2 = sqrt(rc * rc - rc2 * rc2 * sin(dphis) * sin(dphis)) - rc2 * cos(dphis);
      if (fabs(h2 - hold) <= 0.0001) break;
      hold = h2;
      dphip = asin(h2 / rc * sin(dphis));
      phip = latc - dphip; /* phip - dphip; */
      }
   *latd = phi;
   *h = h2;
   return;
   }





