#!/bin/csh -f
#
# Reduce path and environment variables to a more or less pristine state,
# similar to what a system might see when first installing LAS.
#
# Ensure that the path includes the directories containing the compilers for
# C, C++, and Fortran as well as the commands ar and cpp.  The path is the
# only statement that may need modification.
#
# Determine the platform type.
#
set tmp = `uname -a | awk '{print $1}' | tr "[A-Z]" "[a-z]"`
switch ($tmp)
    case irix*:
        set path = (. /usr/local/bin /usr/etc /bin /lib /usr/bin /usr/bin/X11 \
                    /usr/bsd /usr/local /usr/sbin /etc /usr/local/gnu/bin)
        breaksw

    case sunos:
        set path = (. /lib /usr/local/bin /opt/SUNWspro/bin /usr/openwin/bin \
                    /usr/local /usr/ccs/bin /usr/ccs/lib /bin /usr/bin \
                    /usr/bin/X11 /usr/local/gnu/bin)

        breaksw

    case linux:
        set path = (. /usr/local/bin /bin /usr/bin /usr/X11R6/bin /usr/sbin)
        breaksw

    default:
        set path = (/usr/local/bin /bin /usr/bin /usr/X11/bin /usr/sbin)
endsw

#
#--------------------------------------------------------------
# NO USER CHANGES REQUIRED BELOW THIS POINT.
#--------------------------------------------------------------
#

unsetenv CCMD

unset response

#----
# TAE
#----
unsetenv TAE
unsetenv TAEADA
unsetenv TAEADALIB
unsetenv TAEBIN
unsetenv TAEBITMAPS
unsetenv TAECXXLIB
unsetenv TAEDEMO
unsetenv TAEDEMOADA
unsetenv TAEDEMOBIN
unsetenv TAEDEMOCLASSIC
unsetenv TAEDEMOHELP
unsetenv TAEDEMOPS
unsetenv TAEDEMORES
unsetenv TAEDEMORFG
unsetenv TAEDEMOSRC
unsetenv TAEHELP
unsetenv TAEHELPINX
unsetenv TAEHELPMSG
unsetenv TAEHELPTM
unsetenv TAEHELPWB
unsetenv TAEINC
unsetenv TAEINCXM
unsetenv TAELIB
unsetenv TAELOG
unsetenv TAEMAN
unsetenv TAEMENU
unsetenv TAEPDF
unsetenv TAEPERLLIB
unsetenv TAEPLAT
unsetenv TAERES
unsetenv TAEXTAELIB
unsetenv ULIB

#-------------------------------------------------------------------
# root directory for CVS controlled source code
#-------------------------------------------------------------------
unsetenv EDCSOFT
unsetenv LASSYS

#------------------------
# ADAPS Environment Paths
#------------------------
unsetenv ADAPSTABLES

#-----------------------
# ADAPS Executable Paths
#-----------------------
unsetenv ADAPSBASE
unsetenv ADAPSCONTRIB
unsetenv ADAPSDOC
unsetenv ADAPSLOCAL

unsetenv ADAPSACQ
unsetenv ADAPSARC
unsetenv ADAPSBRW
unsetenv ADAPSDB
unsetenv ADAPSDBTMP
unsetenv ADAPSERR
unsetenv ADAPSFAX
unsetenv ADAPSIMG
unsetenv ADAPSING
unsetenv ADAPSLOG
unsetenv ADAPSMIC
unsetenv ADAPSORB
unsetenv ADAPSPROD
unsetenv WDBII
unsetenv AIRTABLES
unsetenv AIRLOG

#--------------------------
# AIRCRAFT Executable Paths
#--------------------------
unsetenv AIRBASE

unsetenv AIRDOC

#----------------------
# LAS Environment Paths
#----------------------
unsetenv APPLOG
unsetenv LASASSIGN
unsetenv LASTABLES
unsetenv WORCONFIG

#---------------------
# LAS Executable Paths
#---------------------
unsetenv LASBASE
unsetenv LASCONTRIB
unsetenv LASDITTY
unsetenv LASDITTO
unsetenv LASDOC
unsetenv LASLOCAL
unsetenv LASBIN
unsetenv LASDDP
unsetenv LASTOOLS

#------------------------------------------
# Environmet variable for drainage software
#------------------------------------------
unsetenv LASDRAIN

#----------------------------
# stuff from pgmassign
#----------------------------
unsetenv ADAPSINCLUDE
unsetenv ADAPSLIB
unsetenv LASINCLUDE
unsetenv LASLIB
unsetenv AIRINCLUDE
unsetenv AIRLIB
unsetenv CONTRIBINCLUDE
unsetenv CONTRIBLIB

unsetenv SYSDEF

unsetenv LASNETWORK
unsetenv LAS_RESP
#
unsetenv TPLIB
unsetenv TRLIB
unsetenv PDSLIB
unsetenv PDSINCLUDE
unsetenv CAGIS
unsetenv CAGISBASE
#
unsetenv CC
unsetenv FC
unsetenv FLINKS
unsetenv CFLAGS
unsetenv FFLAGS
unsetenv AR
unsetenv ARFLAGS
unsetenv CPP
unsetenv CPPFLAGS
