#!/bin/csh -f
#
# This script automates the TAE/LAS/ADAPS source build and installation
# process.
#
# Set the user defined variables below.
#
# You may want to step through this script, especially if you need to edit
# the install files for TAE and LAS.  These files are listed below,
# accompanied by the statement "USER INTERACTION POSSIBLY REQUIRED."
#
#----------------------------------------------------------------------------
#
# User defined variables.

# Set the name of the directory (relative to present location) in which to
# install.
setenv INSDIR las74

# Set the value of LASBUILD to be EDC if building with EDC-specific routines.
# Otherwise set LASBUILD to "" (empty) if building on an external machine
# without access to the EDC-specific routines.
setenv LASBUILD

# Set the C compiler command.
#setenv CCMD gcc

# The response should be "las74" for general, non-development usage and
# "las74d" if development by a programmer is required.
set resp=las74

#     The following files may need modifications:
# o tae/installtae
#      system preferences at top of file
# o tae/config/TAEmake.tmpl
#      UseGnu variable:
#           UseGnu = YES tells system to use GNU C (gcc) and Fortran (g77)
#           compilers.  UseGnu = NO will use cc and f77.
# o src/adaps/base/app/xplot,
# o src/las/base/app/tiepts,
# o src/las/base/app/xid
#      May need to override choices made by imake.  Try the build process
#      first without making these changes.  If the build fails on any of
#      these apps (xplot, tiepts, xid), consider changing the following
#      values as found in the Imakefiles.  Make sure to make the same
#      changes in all Imakefiles, including those in the subdirectories.
#           CC = gcc
#           CXX = $(CPP)
#           CCOPTIONS = -O, -Wl,-woff,85
#           MOTIFLIBDIR = /usr/Motif-1.2/lib32
# o src/las/env/install/Build.las
#      system preferences at top of file

# NO CHANGES REQUIRED BELOW THIS POINT. If this is a first-time install, you
#############################################################################

# Set environment variables.
#---------------------------
setenv EDCSOFT $PWD
setenv TAE $EDCSOFT/tae

# Set up TAE.
#------------------
cd $TAE
# Build TAE source (if required).
./installtae |& tee build.log

##############
# You may want to review build.log at this point to ensure that no
# errors were encountered.
##############

cd $EDCSOFT

# Build LAS/ADAPS source.
#----------------------
cp src/las/env/install/mkdir.csh .
./mkdir.csh
cd $EDCSOFT/src
cp las/env/install/Build.las .
set response=las74d
./Build.las $LASBUILD |& tee build.log

##############
# You may want to review build.log at this point to ensure that no
# errors were encountered.
##############

cd $EDCSOFT
set response=$resp
source env/las/assign/lasinit
