/* Copied from AVHRRDB.C, uses only selected fields  -  J. LaVergne  */

#include <stdio.h>
#include <time.h>
#include "tae.h"
#define DBTMP   "adapsdbtemp:" /* define directory to write the data base
                                          information to */
main()
{
	char filnam[100];	/* OUTPUT FILE NAME */
	char sceneid[17];	/* Scene id */
	char tapeid[7];		/* Tape id  */
	float lat[4];		/* Latitude */
	float lon[5];		/* Longitude */
	char tbuf[17];		/* TEMP BUFFER FOR PARSING */
	char curr_date[9];	/* Current date (mm/dd/yy) */
	char scode[5];		/* Station code		*/
	char mgrcode[3];	/* Management code based on type of data */
	long cnt;		/* Loop counter */
	struct VARIABLE *buf; 	   /* Input buffer from pdf */
	struct VARIABLE *p_find(); /* Tae parameter call */
	struct PARBLK vblock;	   /* Block with pdf variables */
	struct tm *lctm;	   /* Local time structurE */
	int  time_val;		/* Time variable */
        long year;             /* year */

	FILE *fp1,*fopen(),*f,*z_init();

	/*
	  Initialization
	*/
	f = z_init(&vblock,P_ABORT);

	/*
	  Get the scene id
	*/
	buf = p_find(&vblock,"SCENEID");
	strcpy(sceneid,SVAL(*buf,0));
	if (strlen(sceneid) != 16)
	    printf("[avhrrdb] Sceneid must be 16 characters long");

	/*
	  Upcase the sceneid
	*/
	for (cnt = 0; cnt < 16; cnt++)
	    sceneid[cnt] = toupper(sceneid[cnt]);

	sprintf(filnam,"%s%s.db",DBTMP,sceneid);
/*	printf("filnam:  %s\n",filnam); */

	for(cnt = 1; cnt < 4; ++cnt)
	    {
	    fp1 = fopen(filnam,"w");
	    if (fp1 == NULL)
		sleep(3);
	    else
		break;
	    }

	if (fp1 == NULL)
	    {
	    printf("[avhrrdb] Error opening the database file\n");
	    exit(2);
	    }

	/*
	  Read in each TAE parameter value and print it to the output file
	*/
	fprintf(fp1,"%s|",sceneid);
/* 	printf("SCENEID:  %s\n",sceneid); */

	/*
	  Get the current date.  Have to add one to month because it's zero
	  relative.
	*/
	time(&time_val);
	lctm = localtime(&time_val);

        /*
          used to retrieve 2 year digits for dates after the year 2000
        */
	year = lctm->tm_year;
	year = year%100;

	sprintf(curr_date,"%02d/%02d/%02d",lctm->tm_mon+1,lctm->tm_mday,
		year);

	/*
	  Date entered 
	*/
	fprintf(fp1,"%s|",curr_date);
/* 	printf("DATE:  %s\n",curr_date); */

	/*
	  Number of lines in the image
	*/
	buf = p_find(&vblock,"NLINES");
	sprintf(tbuf,"%5d",IVAL(*buf,0));
	fprintf(fp1,"%s|",tbuf);
/* 	printf("NLINES:  %s\n",tbuf); */

	/*
	  Number of samples in the image
	*/
	buf = p_find(&vblock,"NSAMPS");
	sprintf(tbuf,"%5d",IVAL(*buf,0));
	fprintf(fp1,"%s|",tbuf);
/* 	printf("NSAMPS:  %s\n",tbuf); */

	/*
	  Band number in the input image
	*/
	buf = p_find(&vblock,"BANDS");
	sprintf(tbuf,"%-9s",SVAL(*buf,0));
	fprintf(fp1,"%s|",tbuf);
/*	printf("BANDS:  %s\n",tbuf); */

	/*
	  Fill the record out to 80 characters.  Fixed length records are
	  needed for tape transfer
	*/
	fprintf(fp1,"   |\n");

	/*
	  START THE AVHRR DATABASE GEO-LOCATION RECORDS
	*/
	buf = p_find(&vblock,"NWLAT");
	sprintf(lat,"%3.0f",RVAL(*buf,0));
/*	printf("NWLAT:  %s\n",lat); */

	buf = p_find(&vblock,"NWLONG");
	sprintf(lon,"%3.0f",RVAL(*buf,0));
/*	printf("NWLONG:  %s\n",lon); */

	fprintf(fp1,"%s|NW|%s|%s|%s|%s|",sceneid,curr_date,curr_date,lat,lon);
	fprintf(fp1,"                                 |\n");

	buf = p_find(&vblock,"SELAT");
	sprintf(lat,"%3.0f",RVAL(*buf,0));

/*	printf("SELAT:  %s\n",lat); */

	buf = p_find(&vblock,"SELONG");
	sprintf(lon,"%3.0f",RVAL(*buf,0));
/*	printf("SELONG:  %s\n",lon); */

	fprintf(fp1,"%s|SE|%s|%s|%s|%s|",sceneid,curr_date,curr_date,lat,lon);
	fprintf(fp1,"                                 |\n");

	/*
	  Close the file and exit
	*/
	fclose(fp1);

	z_exit(1,"successful completion ");
}
