#ifndef PROTOS_H
#define PROTOS_H

void getpar
(
    struct PARBLK *vblock,      /* pointer to TAE block	 	      */
    char taein[][CMLEN],	/* TAE file names of input images	      */
    char hosin[][CMLEN],  	/* host file names of input images	      */
    char taeout[][CMLEN],		/* TAE file name of output image	      */
    char hosout[][CMLEN],		/* host file name of output image	      */
    long *nmrimg, 		 /* number of input images		      */
    long (*bands)[MAXBND+1],     /* band specification 		              */
    long *nbands,		 /* number of bands per input image           */
    long (*window)[4],	         /* window specification		      */
    long (*window1)[4],	         /* window specification		      */
    long *msgtim,		 /* elapsed time between display messages     */
    char *minmax,		 /* min max flag buffer		              */
    long *totbnd,		 /* total number of bands		      */
    char *option,		/* replacement option		              */
    long *pixval,		 /* pixel values for insertion		      */
    long *sline,
    long *ssample,
    long (*bands2)[MAXBND+1]    /* band specification 		              */
);

void leave
(
    char hosin[][CMLEN],		/* host names of input images		     */
    char *hosout,		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long (*window)[4],		/* window specification of input images      */
    long msgtim,			/* elapsed time between display messages     */
    long totbnd,			/* total number of bands to be processed     */
    long pixval,                 /* background value                          */
    long sline,
    long ssample,
    long (*bands2)[MAXBND+1]	/* bands to be processed for all images      */
);

void maxpix
(
    char hosin[][CMLEN],		/* host names of input images		     */
    char *hosout,		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long (*window)[4],		/* window specification of input images      */
    long msgtim,			/* elapsed time between display messages     */
    long totbnd,			/* total number of bands to be processed     */
    long sline,
    long ssample,
    long (*bands2)[MAXBND+1]	/* bands to be processed for all images      */
);

void minpix
(
    char hosin[][CMLEN],		/* host names of input images		     */
    char *hosout,		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long (*window)[4],		/* window specification of input images      */
    long msgtim,			/* elapsed time between display messages     */
    long totbnd,			/* total number of bands to be processed     */
    long sline,
    long ssample,
    long (*bands2)[MAXBND+1]	/* bands to be processed for all images      */
);

void replace
(
    char hosin[][CMLEN],		/* host names of input images		     */
    char *hosout,		/* host name of output image		     */
    long nmrimg,			/* number of input images                    */
    long (*bands)[MAXBND+1],	/* bands to be processed for all images      */
    long (*window)[4],		/* window specification of input images      */
    long msgtim,			/* elapsed time between display messages     */
    long totbnd,			/* total number of bands to be processed     */
    long pixval,                 /* background value                          */
    long sline,
    long ssample,
    long (*bands2)[MAXBND+1]	/* bands to be processed for all images      */
);

#endif

