/************************************************************************
NaME: GETDATA 

PURPOSE: Extract data from an AVHRR DB file.

PROGRAM HISTORY:
  Version       Date        Author          Reason
  --------      ----        -----------     ----------
     1.0        04/96       K. Lowell       Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Runs under TAE/UNIX

PROJECT:  LAS

ALGORITHM DESCRIPTION: See inline comments

***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "las.h"
#include "util.h"
#include "protos.h"

int main
(void)
{
struct PARBLK vblk;           /* TAE parameter block                  */
char hostname[CMLEN];		/* AVHRR scene db file			*/
char sceneid[20];		/* AVHRR sceneid			*/
FILE *fp;                       /* file pointer                         */
char dnflag[3];			/* D/N flag	*/
char adflag[3];			/* A/D flag	*/
char orbnum[8];			/* Orbit number	*/
char adapsdb[CMLEN];		/* avhrr db location		*/
char hdrstrng[CMLEN];
long std_out=0;                 /* standard out           */
long hlen=80;
long fatal = -1;
char *temp[30];

/* Initialize TAE parameter block
----------------------------------*/
c_inlas(&vblk,&std_out);

/* Get LAS parameters 
---------------------------------*/
if ((getpar(&vblk,sceneid)) != E_SUCC)
   {
   c_errmsg("Fatal error encountered","getdata-fatal",&fatal);
   }

strcpy(adapsdb,getenv("ADAPSDB"));
sprintf(hostname,"%s%s%s%s",adapsdb,"/",sceneid,".db");


/* Open the avhrrdb file and read in the first line to a working string
-----------------------------------------------------------------------*/
if ((fp=fopen(hostname,"r"))==NULL) 
   {
   fclose(fp);
   c_errmsg("fatal error encountered","getdata-fatal",&fatal);
   }
fgets(hdrstrng,hlen,fp);
fclose(fp);

strncpy(dnflag,&hdrstrng[42],1);
dnflag[1]='\0';
strncpy(adflag,&hdrstrng[44],1);
adflag[1]='\0';
strncpy(orbnum,&hdrstrng[56],5);
orbnum[5]='\0';
temp[0]=&dnflag[0];
q_string(&vblk,"DNFLAG",1,temp,P_UPDATE);
temp[0]=&adflag[0];
q_string(&vblk,"ADFLAG",1,temp,P_UPDATE);
temp[0]=&orbnum[0];
q_string(&vblk,"ORBNUM",1,temp,P_UPDATE);
q_out(&vblk);
return EXIT_SUCCESS;
}
