#ifndef PROTOS_H
#define PROTOS_H

int get_tp
(
    struct PRO *pro,	/* Input and output projection parameters */
    struct TPSDATA *data 	/* One Tie Point Selection data record (user input) */
);

int getpar
(
    struct PARBLK *vblk,	/* TAE variable block */
    long *option,		/* Contains flags for subcommand chosen */
    char *tps_name,		/* Input tie point selection file name */
    char *out_tps,		/* Output tie point selection file name */
    struct PRO *pro,	/* Parameters for the PROJ & GRID subcommands */
    struct FRAME *frame,	/* Output framing parameters for GRID subcommand */
    struct FIT *poly,	/* Polynomial coefficients & misc data for POLY subcmd*/
    struct PRINT *print,	/* Print/report parameters */
    long *msgtim		/* Message timer */
);

int get_proj_prm
(
    char *proj_name,	/* Projection parameter file name */
    char *inkey,		/* Input projection parameter key */
    char *outkey,		/* Output projection parameter key */
    long in_def,
    long out_def,	/* Boolean flags--default given by user? */
    struct PRO *pro	/* Input & output projection parameters */
);

int use_ddr_info
(
    struct PARBLK *vblk,	/* TAE parameter block */
    struct PRO *pro,	/* Structure containing projection parameters */
    struct FRAME *frame	/* Structure containing framing parameters */
);

int map_grid
(
    struct PRO *pro,		/* Input & output projection parameters */
    struct FRAME *frame,		/* Framing parameters */
    struct PRINT *print,		/* PRINT destination parameters */
    char *in,			/* Input Tie Point Selection file name */
    char *out,			/* Output Tie Point Selection file name */
    long msgtim			/* Message timer */
);

int map_poly
(
    struct FIT *poly,		/* Polynomial fit parameters */
    struct PRINT *print,		/* Print parameters */
    char *in,			/* Input TPS file name (optional) */
    char *out,			/* Output TPS file name (optional) */
    long msgtim			/* Message timer */
);

int map_proj
(
    struct PRO *pro,		/* Input & output projection parameters */
    struct PRINT *print,		/* PRINT destination parameters */
    char *in,			/* Input Tie Point Selection file name */
    char *out,			/* Output Tie Point Selection file name */
    long msgtim			/* Message timer */
);

int subset
(
    struct FIT *poly,		/* Polynomial fit parameters */
    struct PRINT *print,		/* Print parameters */
    char *in,			/* Input TPS file name (optional) */
    char *out,			/* Output TPS file name (optional) */
    long msgtim			/* Message timer */
);

#endif

