      SUBROUTINE SETNUM(X0,X1,Y0,Y1,H,NUMREF,HH,MAXREF,DELTA)
C
C SETS THE NUMBER OF REFINEMENTS OF THE GRID RESOLUTION.
C
      INTEGER          NUMREF,MAXREF
      REAL             DELTA
      DOUBLE PRECISION X0,X1,Y0,Y1,H,HH(MAXREF)
C
C---LOCAL VARIABLES---
      INTEGER          I,M,N
      REAL             ONE5,RATIO
      DOUBLE PRECISION H1
C
      DATA             ONE5,RATIO/1.5, 2.0/
C
C---GET COARSEST GRID---
      H1=H
      DO 40 I=1,MAXREF
      H1=H1*RATIO
      M=(X1 - X0)/H1 + ONE5 + DELTA
      N=(Y1 - Y0)/H1 + ONE5 + DELTA
      IF (M.LT.10 .OR. N.LT.10) GOTO 50
  40  CONTINUE
      I=MAXREF
C
C---STORE GRID RESOLUTIONS IN HH---
  50  NUMREF=I
      H1=H
      DO 60 I=NUMREF,1,-1
      HH(I)=H1
      H1=H1*RATIO
  60  CONTINUE
      RETURN
      END
      SUBROUTINE INGRID(U,M0,N0,V,M1,N1)
C
C INTERPOLATES FROM THE GRID STORED IN U TO THE GRID STORED
C IN V, AT HALF THE SPACING OF THAT OF U, USING BILINEAR 
C INTERPOLATION.  U AND V NORMALLY HAVE THE SAME STARTING 
C ADDRESS, SO U IS FIRST INSERTED INTO V FROM THE BOTTOM TO 
C PREVENT OVERWRITING.
C
      INTEGER   M0,N0,M1,N1
      REAL      U(M0,N0),V(M1,N1)
C
C---LOCAL VARIABLES---
      INTEGER   IS,JS,I1,I2,J1,J2,I,J,II,JJ,M,N
      REAL      A,B,Z1,Z2,ZERO,ONE
C
      DATA      ZERO,ONE/0.0, 1.0/
C
C---INITIALISE---
      IF (M0.GE.M1 .OR. N0.GE.N1) RETURN
      IS=2
      JS=2
      M=IS*(M0 - 1) + 1
      N=JS*(N0 - 1) + 1
      write(6,999) m,n,m1,n1,m0,n0,is,js
 999  format(' m,n',2i6,'  m1,n1,m0,n0',4i6,5x,2i4)
C
C---INSERT U IN V FROM BOTTOM---
      JJ=N + JS
      DO 20 J=N0,1,-1
      JJ=JJ - JS
      II=M + IS
      DO 10 I=M0,1,-1
      II=II - IS
      V(II,JJ)=U(I,J)
  10  CONTINUE
  20  CONTINUE
C
C---COMPLETE GRID USING BILINEAR INTERPOLATION---
      DO 40 J=1,N1
      J1=((J - 1)/JS)*JS + 1
      J2=MIN0(J1 + JS, N)
      B=ONE
      IF (J1.LT.J2) B=FLOAT(J2-J)/FLOAT(J2-J1)
      DO 30 I=1,M1
      I1=((I - 1)/IS)*IS + 1
      I2=MIN0(I1 + IS, M)
      A=ONE
      IF (I1.LT.I2) A=FLOAT(I2-I)/FLOAT(I2-I1)
      Z1=A*V(I1,J1) + (ONE - A)*V(I2,J1)
      Z2=A*V(I1,J2) + (ONE - A)*V(I2,J2)
      V(I,J)=B*Z1 + (ONE - B)*Z2
  30  CONTINUE
  40  CONTINUE
  70  RETURN
      END
