      SUBROUTINE RDATA(NFIL,OUTFIL,DATFIL,DATNAM,DATFMT,SAVFIL,
     +                IW,MAXW,M,N,X0,X1,Y0,Y1,H,Z0,Z1,ND,NZ,ZMN)
C
C READS X,Y,Z DATA FROM DATFIL IN THE FORMAT GIVEN BY DATFMT AND
C WRITES SELECTED POINTS TO SAVFIL.  NO MORE THAN MAXW DATA POINTS
C ARE ACCEPTED FOR EACH GRID NODE AND POINTS LYING OUTSIDE THE
C POLYGON, AS DETERMINED BY THE ASSOCIATED INTEGER ARRAY IW, ARE
C REJECTED.  THE NUMBER OF POINTS ACCEPTED FOR EACH GRID NODE
C IS RECORDED IN THE ARRAY IW.  THE NUMBER OF POINTS
C READ, THE NUMBER WITHIN LIMITS, THE NUMBER WITHIN THE POLYGON
C AND THE NUMBER ACTUALLY ACCEPTED ARE WRITTEN TO OUTFIL.
C
C THE PROGRAM SETS THE DATA FILE NAME BLANK IF NO POINTS ARE ACCEPTED
C FROM THE DATA FILE SO THAT SUCH DATA FILES ARE NOT REFERENCED AGAIN.
C
C THE NUMBER OF DATA POINTS ACCEPTED AND THEIR TOTAL HEIGHT ARE STORED
C IN NZ AND ZMN RESPECTIVELY FOR LATER USE BY SUBROUTINE PLNGRD IN
C DETERMINING AN INITIAL MEAN VALUE PLANE FIT TO THE DATA.
C
      INTEGER          NFIL,OUTFIL,DATFIL,SAVFIL,M,N,ND,NZ
      REAL             Z0,Z1
      DOUBLE PRECISION X0,X1,Y0,Y1,H,ZMN
      CHARACTER*40     DATNAM,DATFMT
      INTEGER*2        IW(0:M+1,0:N+1),MAXW
C
C---LOCAL VARIABLES---
      INTEGER          I,J,KD1,KD2,KD3,KD4,K
      REAL             ZZ,ONE,ONE5
      DOUBLE PRECISION ZERO,XX,YY
C
      DATA             ZERO,ONE,ONE5/0.0D0, 1.0, 1.5/
C
C---INITIALIZE---
      WRITE(OUTFIL,10) NFIL,DATNAM
  10  FORMAT(/' DATA FILE',I3,': ',A40)
      OPEN(DATFIL,FILE=DATNAM,STATUS='OLD')
      REWIND DATFIL
c      write(outfil,11)
c 11   format(/' I got here')
C
      KD1=0
      KD2=0
      KD3=0
      KD4=0
C
C---LOOP THROUGH DATA POINTS---
  20  DO 30 K=1,1000
      READ(DATFIL,DATFMT,END=40) XX,YY,ZZ
c      READ(DATFIL,12,END=40) XX,YY,ZZ
 12   format(3D11.0)
c      write(outfil,13)XX,YY,ZZ
c 13   format(' ',' xx= ',i11,' yy= ',i11,' zz= ',i11)
      KD1=KD1 + 1
C
C---REMOVE POINTS OUTSIDE LIMITS---
      IF (XX.LT.X0 .OR. XX.GT.X1 .OR. YY.LT.Y0 .OR. YY.GT.Y1
     +    .OR. ZZ.LT.Z0 .OR. ZZ.GT.Z1) GOTO 30
C
C---CALCULATE GRID POSITION---
      KD2=KD2 + 1
      XX=DMAX1(XX-X0, ZERO)
      YY=DMAX1(YY-Y0, ZERO)
      I=XX/H + ONE5
      J=YY/H + ONE5
C
C---CHECK FOR POLYGON---
      IF (IW(I,J).LT.0) GOTO 30
      KD3=KD3 + 1
C
C---CHECK FOR NUMBER OF POINTS IN GRID CELL---
      IF (IW(I,J).GE.MAXW) GOTO 30
      IW(I,J)=IW(I,J) + 1
      KD4=KD4 + 1
      WRITE(SAVFIL) XX,YY,ZZ
C
C---UPDATE TOTAL Z VALUE---
      NZ=NZ + 1
      ZMN=ZMN + ZZ
  30  CONTINUE
      GOTO 20
C
C---WRITE DETAILS TO OUTPUT---
  40  ND=ND + KD4
      WRITE(OUTFIL,50) KD1,KD2,KD3,KD4
  50  FORMAT(' NUMBER OF DATA POINTS           =',I7/
     +       ' NUMBER OF POINTS WITHIN LIMITS  =',I7/
     +       ' NUMBER OF POINTS WITHIN POLYGON =',I7/
     +       ' NUMBER OF POINTS ACCEPTED       =',I7)
      CLOSE(DATFIL)
C
C---EXIT---
      IF (KD4.LE.0) DATNAM=' '
      RETURN
      END
      SUBROUTINE PLNGRD(U,M,N,Z0,Z1,NZ,ZMN)
C
C INITIALISE THE GRID U TO THE MEAN Z VALUE DETERMINED BY NZ,ZMN.
C
      INTEGER M,N,NZ
      REAL    U(M,N),Z0,Z1
      DOUBLE PRECISION ZMN
C
C---LOCAL VARIABLES---
      INTEGER I,J
C
C---INITIALISE---
      IF (NZ.GT.0) THEN
         ZMN=ZMN/NZ
      ELSE
         ZMN=0.5*(Z0 + Z1)
      ENDIF
C
C---CALCULATE GRID VALUES---
      DO 10 J=1,N
      DO 10 I=1,M
      U(I,J)=ZMN
  10  CONTINUE
      RETURN
      END
      SUBROUTINE SELDAT(OUTFIL,SAVFIL,ND,U,IW,MAXW,M,N,H)
C
C SELECTS POINTS, FOR A GIVEN GRID RESOLUTION H, FROM THE UNFORMATTED
C FILE SAVFIL AND INSERTS SELECTED POINTS ONTO THE GRID U.  NO MORE
C THAN MAXW DATA POINTS ARE ACCEPTED FOR EACH GRID POINT.
C
      INTEGER          OUTFIL,SAVFIL,ND,M,N
      REAL             U(M,N)
      DOUBLE PRECISION H
      INTEGER*2        IW(0:M+1,0:N+1),MAXW
C
C---LOCAL VARIABLES---
      INTEGER          I,J,K
      REAL             Z,ZERO,ONE5
      DOUBLE PRECISION X,Y
C
      DATA             ZERO,ONE5/0.0, 1.5/
C
C---READ DATA POINTS FROM SAVFIL---
      REWIND SAVFIL
      DO 20 K=1,ND
      READ(SAVFIL) X,Y,Z
      I=X/H + ONE5
      J=Y/H + ONE5
      IF (IW(I,J).LT.0 .OR. IW(I,J).GE.MAXW) GOTO 20
      U(I,J)=(IW(I,J)*U(I,J) + Z)/(IW(I,J) + 1)
      IW(I,J)=IW(I,J) + 1
  20  CONTINUE
      RETURN
      END
      SUBROUTINE SRTDAT(U,IW,M,N,Z,MAXD,ND)
C
C COUNTS DATA POINTS THAT HAVE BEEN INSERTED INTO THE GRID U
C AND SAVES THEIR VALUES IN THE ARRAY Z.
C
      INTEGER   M,N,MAXD,ND
      REAL      U(M,N),Z(MAXD)
      INTEGER*2 IW(0:M+1,0:N+1)
C
C---LOCAL VARIABLES---
      INTEGER   I,J
C
      ND=0
      DO 10 J=1,N
      DO 10 I=1,M
      IF (IW(I,J).NE.1 .AND. IW(I,J).NE.5) GOTO 10
      ND=ND + 1
      IF (ND.GT.MAXD) GOTO 20
      Z(ND)=U(I,J)
  10  CONTINUE
      RETURN
C
C---ERROR CONDITION---
  20  STOP 'SRTDAT - TOO MANY DATA POINTS'
      END
