      SUBROUTINE PROLIN(OUTFIL,U,IW,IV,IC,MAXC,NC,M,N,H,IP,JP,DP,
     +                  TOL,RMAX)
C
C FINDS NEW STREAM LINES AND RIDGE LINES FROM CONTOUR DATA POINTS
C WITH MAXIMUM CURVATURE.  POINTERS FOR EXISTING STREAM LINES AND
C RIDGE LINES ARE THEN REMOVED TO ALLOW THEIR POSITIONS TO BE
C UPDATED BY FIXLIN.  THE LINES ARE FINALLY SORTED ACCORDING TO
C DECREASING LENGTH.
C
      INTEGER   OUTFIL,MAXC,IC(6,MAXC),NC,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8),TOL(4)
      DOUBLE PRECISION H,RMAX
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   I,J,K,K0,IL,JL,NL,NL1,KOP
      REAL      DX,DY,AS1,AS2
      EXTERNAL  STRM,RDGE
C
      DATA AS1,AS2/0.5, -0.5/
C
C---FIND NEW LINES---
      IF (NC.LE.0) RETURN
	write(outfil,1) nc
   1	format(/' prolin called  nc =',i5)
	iii=0
      KOP=1
      DO 10 K=1,NC
      I=IC(1,K)
      J=IC(2,K)
      K0=IC(3,K)
      IL=I + IP(K0)
      JL=J + JP(K0)
      IF (IC(6,K).LE.0) THEN
         IF (U(IL,JL).NE.U(I,J)) THEN
            IF (U(IL,JL).LT.U(I,J)) THEN
               CALL INTFLO(AS1,U,IW,M,N,I,J,K0,IP,JP,KOP)
               CALL GETLIN(OUTFIL,STRM,I,J,K0,IL,JL,NL,NL1,U,IW,IV,M,N,
     +                     IP,JP,DP,TOL)
            ELSE
               CALL INTFLO(AS2,U,IW,M,N,I,J,K0,IP,JP,KOP)
               CALL GETLIN(OUTFIL,RDGE,I,J,K0,IL,JL,NL,NL1,U,IW,IV,M,N,
     +                     IP,JP,DP,TOL)
               DX=I - IL
               DY=J - JL
               IF (SQRT(DX*DX + DY*DY)*H .GT. RMAX) THEN
                   IL=I
                   JL=J
                   NL=0
                   NL1=0
               ENDIF
            ENDIF
            IC(4,K)=IL
            IC(5,K)=JL
            IC(6,K)=-NL1
		if (nl1.ne.0) iii=iii + 1
         ELSE
            IC(6,K)=0
         ENDIF
      ENDIF
  10  CONTINUE
	write(outfil,11) iii
  11	format(' no of new lines =',i4)
C
C---REMOVE POINTERS FROM OLD LINES---
	iii=0
      DO 20 K=1,NC
      I=IC(1,K)
      J=IC(2,K)
      IL=IC(4,K)
      JL=IC(5,K)
      NL=IC(6,K)
      IF (NL.GT.0) THEN
         IF (U(IL,JL).LT.U(I,J)) THEN
            CALL DELPTR(IV,M,N,I,J,IL,JL,NL,IP,JP)
	iii=iii + 1
         ELSE
            IF (U(IL,JL).GT.U(I,J)) THEN
               CALL DELPTR(IV,M,N,IL,JL,I,J,NL,IP,JP)
	iii=iii + 1
            ELSE
               write(outfil,19) (ic(i,k),i=1,6)
  19	format(' prolin warning ic(*,k) =',6i4)
            ENDIF
         ENDIF
      ENDIF
  20  CONTINUE
	write(outfil,21) iii
  21	format(' no of old lines =',i4)
C
C---SORT CRITICAL POINTS BY LENGTH OF CHAIN---
      CALL CHSORT(NC,IC)
      RETURN
      END
      SUBROUTINE GETLIN(OUTFIL,DIRN,I,J,K0,IL,JL,NL,NL1,U,IW,IV,M,N,
     +                  IP,JP,DP,TOL)
C
C ATTEMPTS TO FIND THE NEXT DATA POINT OR EDGE BELOW (OR ABOVE)
C THE POINT AT POSITION I,J IN THE DIRECTION K0.
C NL IS SET TO THE NUMBER OF STEPS TRAVERSED IF THE POINT IS FOUND
C AND AN ELEVATION DIFFERENCE OF AT LEAST TOL(1) HAS BEEN TRAVERSED,
C OR IF NO SUCH POINT IS FOUND BUT AN ELEVATION DIFFERENCE OF AT LEAST
C TOL(2)/2 IS TRAVERSED.  WHEN A SUITABLE POINT IS FOUND THE NUMBER OF
C STEPS TO THE FIRST ORDERED CHAIN POINT IS RETURNED IN NL1 AND THE
C POSITION OF FIRST ORDERED CHAIN POINT IS RETURNED IN IL,JL.
C IF NO SUITABLE POINT IS FOUND BOTH NL AND NL1 ARE SET TO 0.
C
      INTEGER   OUTFIL,I,J,K0,IL,JL,NL,NL1,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
      EXTERNAL  DIRN
C
C---LOCAL VARIABLES---
      INTEGER   MN,KL,KL1,IL1,JL1,IL2,JL2
      LOGICAL   FLAG
C
C---INITIALISE---
      MN=M + N
      IL=I
      JL=J
      NL=0
      IF (K0.LE.0) GOTO 40
      KL=K0
      IL1=IL + IP(KL)
      JL1=JL + JP(KL)
      KL1=KL
      NL1=0
      FLAG=U(IL1,JL1).GT.U(IL,JL)
C
C---STEP DOWN (OR UP)---
      DO 10 NL=1,MN
      CALL GETNXT(DIRN,KL,IL,JL,KL1,IL1,JL1,U,IV,M,N,IP,JP,DP)
      IF (NL1.EQ.0) THEN
         IF (FLAG) THEN
            IF (KL1.GT.0) THEN
               IF (IV(IL1,JL1).GT.0) THEN
                  NL1=NL
                  IL2=IL
                  JL2=JL
               ENDIF
            ENDIF
         ELSE
            IF (IV(IL,JL).GT.0) THEN
               NL1=NL
               IL2=IL
               JL2=JL
            ENDIF
         ENDIF
      ENDIF
      IF (IW(IL,JL).NE.0) GOTO 20
      IF (KL1.LT.0) GOTO 40
      IF (KL1.EQ.0) GOTO 20
      IF (U(IL1,JL1).EQ.U(IL,JL)) GOTO 20
      IF (ABS(U(IL1,JL1)-U(I,J)).GT.TOL(2) .AND. IW(IL1,JL1).EQ.0)
     +    GOTO 40
      IF (MOD(KL1,2).EQ.1) THEN
         IF (IW(IL,JL1).GT.0 .OR. IW(IL1,JL).GT.0) GOTO 30
      ENDIF
  10  CONTINUE
      CALL WRGRDS(OUTFIL,U,IW,IV,M,N,IL,JL,6)
      STOP 'GETLIN ERROR'
C
C---DATA POINT OR EDGE FOUND---
  20  IF (IW(IL,JL).GT.0) THEN
         IF (ABS(U(IL,JL)-U(I,J)).LT.TOL(1)) GOTO 50
      ELSE
         IF (ABS(U(IL,JL)-U(I,J)).LT.0.5*TOL(2)) GOTO 50
      ENDIF
      GOTO 40
C
C---CONTOUR FOUND---
  30  IF (ABS(U(IL,JL)-U(I,J)).LT.TOL(1)) GOTO 50
C
C---FINISH UP---
  40  IF (NL1.EQ.0) THEN
         NL1=NL
      ELSE
         IL=IL2
         JL=JL2
      ENDIF
      RETURN
C
C---NO SUITABLE POINT FOUND---
  50  NL=0
      NL1=0
      IL=I
      JL=J
      RETURN
      END
      SUBROUTINE DELPTR(IV,M,N,I,J,IL,JL,NL,IP,JP)
C
C REMOVES NL POINTERS IN THE ARRAY IV FROM POSITION I,J DOWN
C TO POSITION IL,JL.
C
      INTEGER   M,N,I,J,IL,JL,NL,IP(8),JP(8)
      INTEGER*2 IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   I1,J1,K1,K
C
C---STEP DOWN ORDERED CHAIN---
      I1=I
      J1=J
      K1=IV(I1,J1)
      DO 10 K=1,NL
      IF (K1.LE.0) GOTO 20
      IV(I1,J1)=0
      I1=I1 + IP(K1)
      J1=J1 + JP(K1)
      K1=IV(I1,J1)
  10  CONTINUE
  20  IF (I1.NE.IL .OR. J1.NE.JL) THEN
      ENDIF
      RETURN
      END
      SUBROUTINE CHSORT(NC,IC)
C
C SORTS CONTOUR CRITICAL POINTS INTO DECREASING ASSOCIATED ORDERED
C CHAIN LENGTH AS FOUND BY SUBROUTINE GETLIN.  THE INSERTION SORT
C ALGORITHM IS USED.
C
      INTEGER   NC,IC(6,NC)
C
C---LOCAL VARIABLES---
      INTEGER   I,J,ITMP(6),IX,IY,LEN
C
      DO 30 I=2,NC
      ITMP(1)=IC(1,I)
      ITMP(2)=IC(2,I)
      ITMP(3)=IC(3,I)
      ITMP(4)=IC(4,I)
      ITMP(5)=IC(5,I)
      ITMP(6)=IC(6,I)
      IX=ITMP(1) - ITMP(4)
      IY=ITMP(2) - ITMP(5)
      LEN=IX*IX + IY*IY
C
      DO 10 J=I,2,-1
      IX=IC(1,J-1) - IC(4,J-1)
      IY=IC(2,J-1) - IC(5,J-1)
      IF (LEN .LE. IX*IX + IY*IY) GOTO 20
      IC(1,J)=IC(1,J-1)
      IC(2,J)=IC(2,J-1)
      IC(3,J)=IC(3,J-1)
      IC(4,J)=IC(4,J-1)
      IC(5,J)=IC(5,J-1)
      IC(6,J)=IC(6,J-1)
  10  CONTINUE
      J=1
C
  20  IC(1,J)=ITMP(1)
      IC(2,J)=ITMP(2)
      IC(3,J)=ITMP(3)
      IC(4,J)=ITMP(4)
      IC(5,J)=ITMP(5)
      IC(6,J)=ITMP(6)
  30  CONTINUE
      RETURN
      END
      SUBROUTINE FIXLIN(OUTFIL,U,IW,IV,IC,MAXC,NC,M,N,IP,JP,DP,TOL)
C
C INSERTS ORDERED CHAIN LINES DOWN VALLEYS AND UP RIDGES FROM
C CONTOUR DATA POINTS WITH MAXIMUM CURVATURE.  LINES WHICH HAVE
C DESTINATION SIGNIFICANTLY DIFFERENT FROM THAT FOUND BY PROLIN
C ARE NOT SET.  LINEARLY INTERPOLATED HEIGHTS ARE SET BY SETCHN
C FOR NEW LINES ONLY.
C
      INTEGER   OUTFIL,MAXC,IC(6,MAXC),NC,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   ICOP,I,J,K,K0,IL,JL,IL1,JL1,NL,NL1,NR,KOP
      REAL      AS1,AS2
      LOGICAL   NFLG
      EXTERNAL  STRM,RDGE
C
      DATA AS1,AS2/0.5, -0.5/
C
C---LOOP THROUGH CRITICAL POINTS---
      ICOP=1
      KOP=1
	if (nc.gt.0) write(outfil,11) nc
  11	format(/' fixlin called  nc =',i6)
	ii1=0
	ii2=0
	jj1=0
	jj2=0
	jj3=0
	kk1=0
	kk2=0
      DO 10 K=1,NC
      NL=IC(6,K)
      IF (NL.EQ.0) GOTO 10
C
C---SET NEW CHAIN FLAG AND GET DESTINATION FOUND BY PROLIN---
      NFLG=NL.LT.0
      LEN=IABS(NL)
      I=IC(1,K)
      J=IC(2,K)
      K0=IC(3,K)
      IL1=IC(4,K)
      JL1=IC(5,K)
C
C---SET STREAM LINE---
      IF (U(IL1,JL1).LT.U(I,J)) THEN
         CALL INTFLO(AS1,U,IW,M,N,I,J,K0,IP,JP,KOP)
         CALL GETLIN(OUTFIL,STRM,I,J,K0,IL,JL,NL,NL1,U,IW,IV,M,N,
     +               IP,JP,DP,TOL)
         IC(6,K)=0
         IF (NL1.LE.0) GOTO 10
		if ((il-il1)**2 + (jl-jl1)**2.gt.3) jj3=jj3 + 1
         IF (NFLG .AND. (IL-IL1)**2 + (JL-JL1)**2.GT.3) THEN
            GOTO 10
         ENDIF
	if (il.eq.il1 .and. jl.eq.jl1) then
		jj1=jj1 + 1
	else
		jj2=jj2 + 1
	endif
         IC(4,K)=IL
         IC(5,K)=JL
         IC(6,K)=NL1
         K0=IC(3,K)
         CALL INTFLO(AS1,U,IW,M,N,I,J,K0,IP,JP,KOP)
         CALL FILLDO(STRM,I,J,K0,IL,JL,NL,U,IW,IV,M,N,IP,JP,DP,
     +               TOL(2),ICOP)
         NR=0
         IF (NFLG) THEN 
            CALL SETCHN(I,J,IL,JL,NR,NL,U,IV,M,N,IP,JP)
		kk1=kk1 + 1
         ENDIF
	ii1=ii1 + 1
C
C---SET RIDGE LINE---
      ELSE
         IF (U(IL1,JL1).GT.U(I,J)) THEN
            CALL INTFLO(AS2,U,IW,M,N,I,J,K0,IP,JP,KOP)
            CALL GETLIN(OUTFIL,RDGE,I,J,K0,IL,JL,NR,NL1,U,IW,IV,M,N,
     +                  IP,JP,DP,TOL)
            IC(6,K)=0
            IF (NL1.LE.0) GOTO 10
		if ((il-il1)**2 + (jl-jl1)**2.gt.3) jj3=jj3 + 1
            IF (NFLG .AND. (IL-IL1)**2 + (JL-JL1)**2.GT.3) THEN
               GOTO 10
            ENDIF
	if (il.eq.il1 .and. jl.eq.jl1) then
		jj1=jj1 + 1
	else
		jj2=jj2 + 1
	endif
            K0=IC(3,K)
            CALL INTFLO(AS2,U,IW,M,N,I,J,K0,IP,JP,KOP)
            CALL FILLUP(RDGE,I,J,K0,IL,JL,NR,U,IW,IV,M,N,IP,JP,DP,
     +                  TOL(2),ICOP)
            IC(4,K)=IL
            IC(5,K)=JL
            IC(6,K)=NR
            NL=0
            IF (NFLG) THEN
               CALL SETCHN(IL,JL,I,J,NR,NL,U,IV,M,N,IP,JP)
		kk2=kk2 + 1
            ENDIF
	ii2=ii2 + 1
         ENDIF
      ENDIF
  10  CONTINUE
	write(outfil,31) ii1,ii2,kk1,kk2,jj1,jj2,jj3
  31	format(' exit fixlin  str =',i4,'  rdg =',i4,'  new s,r =',
     +		2i5/'       jj1,jj2,jj3 =',3i5)
      RETURN
      END
      SUBROUTINE STRM(KR,I,J,KL,IL,JL,U,IV,M,N,IP,JP,DP)
C
C FINDS THE POINT IL,JL BESIDE THE DIRECTION KR WHICH IS ADJACENT
C TO I,J AND IN THE STEEPEST DIRECTION BELOW THE POINT I,J.
C THE DIRECTION OF THE POINT FOUND IS RETURNED IN KL.
C KL IS SET TO 0 IF NO LOWER POINT IS FOUND OR IF THE POINT
C DOES NOT LIE ON A STREAM.
C KL IS SET TO -1 IF THE POINT I,J LIES ON AN EDGE.
C
      INTEGER   KR,I,J,KL,IL,JL,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8)
      INTEGER*2 IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   K,KK,IK,JK,KOP
      REAL      UIJ,VK,VL,AS1,ZERO
C
      COMMON/SFLOW/II,JJ,IS,X,Y
C
      DATA      AS1,ZERO/0.5, 0.0/
C
C---INITIALISE---
      KL=-1
      IF (I.LE.1 .OR. I.GE.M .OR. J.LE.1 .OR. J.GE.N) RETURN
C
C---LOOK FOR STRICTLY DESCENDING CHAIN---
      KOP=0
      UIJ=U(I,J)
      KL=IV(I,J)
      IF (KL.GT.0) THEN
         IL=I + IP(KL)
         JL=J + JP(KL)
         IF (U(IL,JL).LT.UIJ) THEN
            IF (IV(IL,JL).LE.0) THEN
               CALL INTFLO(AS1,U,IW,M,N,IL,JL,KL,IP,JP,KOP)
            ENDIF
         ELSE
            KL=0
         ENDIF
      ELSE
C
C---LOOK FOR FLOW LINE---
         CALL FLOW(AS1,U,M,N,II,JJ,IS,X,Y,KL,IL,JL)
C
C---FIND NEXT LOWEST NEIGHBOUR---
         IF (KL.LE.0) THEN
            VL=ZERO
            K=KR
            DO 20 KK=1,5
            K=MOD(K,8) + 1
            IK=I + IP(K)
            JK=J + JP(K)
            IF (U(IK,JK).GE.UIJ) GOTO 20
            VK=(U(IK,JK) - UIJ)*DP(K)
            IF (VK.GT.VL) GOTO 20
            IF (VK.LT.VL) GOTO 10
            IF (KL.GT.0) GOTO 20
  10        VL=VK
            KL=K
            IL=IK
            JL=JK
  20        CONTINUE
            IF (KL.GT.0) THEN
               CALL INTFLO(AS1,U,IW,M,N,IL,JL,KL,IP,JP,KOP)
            ENDIF
         ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE RDGE(KL,I,J,KR,IR,JR,U,IV,M,N,IP,JP,DP)
C
C FINDS THE POINT IR,JR BESIDE THE DIRECTION KL WHICH IS ADJACENT
C TO I,J AND IN THE STEEPEST DIRECTION ABOVE THE POINT I,J.
C THE DIRECTION OF THE POINT FOUND IS RETURNED IN KR.
C KR IS SET TO 0 IF NO HIGHER POINT IS FOUND OR IF THE POINT
C DOES NOT LIE ON A RIDGE LINE.
C KR IS SET TO -1 IF THE POINT I,J LIES ON AN EDGE.
C
      INTEGER   KL,I,J,KR,IR,JR,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8)
      INTEGER*2 IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   K,KK,IK,JK,KOP
      REAL      UIJ,VK,VR,AS2,ZERO
C
      COMMON/SFLOW/II,JJ,IS,X,Y
C
      DATA      AS2,ZERO/-0.5, 0.0/
C
C---INITIALISE---
      KR=-1
      IF (I.LE.1 .OR. I.GE.M .OR. J.LE.1 .OR. J.GE.N) RETURN
C
C---LOOK FOR FLOW LINE---
      KOP=0
      UIJ=U(I,J)
      CALL FLOW(AS2,U,M,N,II,JJ,IS,X,Y,KR,IR,JR)
C
C---FIND NEXT HIGHEST NEIGHBOUR---
      IF (KR.LE.0) THEN
         KR=0
         VR=ZERO
         K=KL
         DO 20 KK=1,5
         K=MOD(K,8) + 1
         IK=I + IP(K)
         JK=J + JP(K)
         IF (U(IK,JK).LE.UIJ) GOTO 20
         VK=(U(IK,JK) - UIJ)*DP(K)
         IF (VK.LT.VR) GOTO 20
         IF (VK.GT.VR) GOTO 10
         IF (KR.GT.0) GOTO 20
  10     VR=VK
         KR=K
         IR=IK
         JR=JK
  20     CONTINUE
         IF (KR.GT.0) THEN
            CALL INTFLO(AS2,U,IW,M,N,IR,JR,KR,IP,JP,KOP)
         ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE INTFLO(AS,U,IW,M,N,I,J,KL,IP,JP,KOP)
C
C DETERMINES SLOPE OF CELL I,J AND INITIALISES VARIABLES IN
C COMMON BLOCK /SFLOW/.  IF KOP=1 THEN THE NEXT STEP IS
C CALCULATED BY FLOW PROVIDED NO DATA POINTS ARE ENCOUNTERED.
C IF A DATA POINT IS ENCOUNTERED THE ORIGINAL POINTER KL IS USED.
C
      INTEGER   M,N,I,J,KL,IP(8),JP(8),KOP
      REAL      AS,U(M,N)
      INTEGER*2 IW(0:M+1,0:N+1)
C
C---COMMON VARIABLES---
      INTEGER II,JJ,KK,IS,IDX(4),IDY(4),I0,J0,K0
      REAL    X,Y
C
      COMMON/SFLOW/II,JJ,IS,X,Y
C
      DATA IDX/ 0, 1, 0,-1/
      DATA IDY/-1, 0, 1, 0/
C
C---INITIALISE---
      II=I
      JJ=J
      KK=KOP
C
C---CALCULATE /SFLOW/ PARAMETERS---
  10  X=0.0
      Y=0.0
      IF (KL.LE.3) THEN
         IF (KL.EQ.1) THEN
            II=II + IDX(4)
            X=X - IDX(4)
         ENDIF
         IS=1
      ELSE
         IS=(KL + 1)/2
      ENDIF
      IF (IS.EQ.2 .OR. IS.EQ.3) THEN
         II=II - IDX(IS)
         JJ=JJ - IDY(IS)
         X=X + IDX(IS)
         Y=Y + IDY(IS)
      ENDIF
C
C---OPTIONALLY CALCULATE NEXT STEP---
      IF (KK.EQ.1) THEN
        CALL FLOW(AS,U,M,N,II,JJ,IS,X,Y,K0,I0,J0)
         IF (K0.GT.0 .AND. IW(I0,J0).EQ.0) THEN
            KL=K0
         ELSE
            II=I + IP(KL)
            JJ=J + JP(KL)
            KK=0
            GOTO 10
         ENDIF
      ENDIF
      RETURN
      END
      SUBROUTINE FLOW(AS,U,M,N,I,J,IS,X,Y,KL,I0,J0)
C
C CONTINUES FLOW IN THE STEEPEST DIRECTION DOWN (UP) THE
C PIECEWISE BILINEAR SURFACE DETERMINED BY THE GRID U UNTIL
C THE NEXT GRID COORDINATE I0,J0 IS REACHED. THE DIRECTION
C IS RETURNED IN KL.  KL IS SET TO ZERO IF NO SUITABLE
C POINT CAN BE FOUND.
C 
      INTEGER   M,N,I,J,IS,KL,I0,J0
      REAL      AS,U(M,N),X,Y
C
C---LOCAL VARIABLES---
      INTEGER   IX(4),IY(4),IDX(4),IDY(4),IC,I1,J1,KLS(-1:1,-1:1)
      REAL      X0,Y0,A0,B0,A,B,D1,S1,ZERO
C
      DATA IDX/ 0, 1, 0,-1/
      DATA IDY/-1, 0, 1, 0/
      DATA IX / 1, 1, 0, 0/
      DATA IY / 0, 1, 1, 0/
      DATA KLS/1,2,3,8,0,4,7,6,5/
      DATA ZERO/0.0/
C
C---INITIALISE---
      IC=0
      X0=X
      Y0=Y
      I0=I + X0 + 0.5
      J0=J + Y0 + 0.5
      KL=0
      IF (I.LT.1 .OR. I.GT.M-1 .OR. J.LT.1 .OR. J.GT.N-1) RETURN
      A0=(U(I+1,J) - U(I,J) + U(I+1,J+1) - U(I,J+1))*AS
      B0=(U(I,J+1) - U(I,J) + U(I+1,J+1) - U(I+1,J))*AS
C
C---UPDATE ARRAY INDICES---
  10  I1=IDX(IS)
      J1=IDY(IS)
      IS=MOD(IS+1,4) + 1
      I=I + I1
      J=J + J1
      X0=X - I1
      Y0=Y - J1
      IF (I.LT.1 .OR. I.GT.M-1 .OR. J.LT.1 .OR. J.GT.N-1) RETURN
C
C---CALCULATE PARTIAL DERIVATIVES OF ELEVATION---
      DX1=U(I+1,J) - U(I,J)
      DX2=U(I+1,J+1) - U(I,J+1)
      DY1=U(I,J+1) - U(I,J)
      DY2=U(I+1,J+1) - U(I+1,J)
C
C---CHECK FOR HEIGHTS CONSISTENT WITH BILINEAR INTERPOLATION---
      IF (DX1*DX2.LE.ZERO .AND. DY1*DY2.LE.ZERO) RETURN
      A=(DX1 + DX2)*AS
      B=(DY1 + DY2)*AS
  20  S1=I1*A + J1*B
      IF (S1.LT.ZERO) GOTO 60
C
C---OPPOSING SLOPES ACROSS CELL BOUNDARY---
      IF (S1.GT.-(I1*A0 + J1*B0)) GOTO 50
      D1=A*J1 - B*I1
      IF (D1.LT.ZERO) GOTO 40
      IF (D1.GT.ZERO) GOTO 30
      IF (A0*J1 - B0*I1.LE.ZERO) GOTO 40
  30  IS=MOD(IS+2,4) + 1
      X=FLOAT(IX(IS))
      Y=FLOAT(IY(IS))
      GOTO 150
  40  X=FLOAT(IX(IS))
      Y=FLOAT(IY(IS))
      IS=MOD(IS,4) + 1
      GOTO 150
C
C---NEW SLOPE DOMINATES PREVIOUS SLOPE---
  50  X=X0
      Y=Y0
      GOTO 150
C
C---NON-OPPOSING SLOPES ACROSS CELL BOUNDARY---
  60  C=A*Y0 - B*X0
      C2=A*IY(IS) - B*IX(IS) - C
      DO 70 K=1,3
      C1=C2
      IS=MOD(IS,4) + 1
      C2=A*IY(IS) - B*IX(IS) - C
      IF (C1*C2.GT.ZERO .OR. C1.EQ.C2) GOTO 70
      IF (IDX(IS)*A + IDY(IS)*B .LT. ZERO) GOTO 80
  70  CONTINUE
C	return
      STOP 'FLOW1 - SEARCH ERROR'
C
C---DETERMINE EXIT POSITION---
  80  GOTO (81,82,83,84),IS
  81  Y=ZERO
      X=(A*Y - C)/B
      GOTO 150
C
  82  X=1.0
      Y=(C + B*X)/A
      GOTO 150
C
  83  Y=1.0
      X=(A*Y - C)/B
      GOTO 150
C
  84  X=ZERO
      Y=(C + B*X)/A
C
C---CHECK FOR SINK---
 150  A0=A
      B0=B
      IF (X.NE.X0 .OR. Y.NE.Y0) GOTO 160
      IC=IC + 1
      IF (IC.LT.4) GOTO 170
      RETURN
C
C---UPDATE SINK COUNTER---
 160  IC=0
C
C---CHECK FOR SIGNIFICANT MOVEMENT---
 170  II0=I + X + 0.5
      JJ0=J + Y + 0.5
      IF (II0.EQ.I0 .AND. JJ0.EQ.J0) GOTO 10
      IF (IABS(II0-I0).GT.1 .OR. IABS(JJ0-J0).GT.1) THEN
         KL=0
      ELSE
         IF (AS*(U(II0,JJ0) - U(I0,J0)).LT.ZERO) THEN
            KL=KLS(II0-I0,JJ0-J0)
         ELSE
            KL=0
         ENDIF
      ENDIF
      I0=II0
      J0=JJ0
      RETURN
      END
