      SUBROUTINE PROSNK(OUTFIL,SINK,MAXNS,NS,U,IW,IV,M,N,IP,JP,DP,
     +                  Z,ND,IDOPT,TOL,ICOP)
C
C ATTEMPTS TO REMOVE EACH SINK BY INSERTING AN ORDERED CHAIN
C WHICH LEADS TO A LOWER DATA POINT, SINK OR EDGE VIA
C THE LOWEST INTERVENING SADDLE.
C STREAM POINTS IMMEDIATELY ADJACENT TO SINKS ARE ALSO TREATED
C AS SADDLES.
C IF ICOP = 0 THEN THE DATA ARE ASSUMED TO CONSIST MAINLY OF POINT
C ELEVATIONS AND THERE IS NO CHECKING FOR CROSSING OF CONTOURS.
C IF ICOP > 1 THEN THE DATA ARE ASSUMED TO CONSIST MAINLY OF CONTOURS
C AND SPECIAL ACTION IS TAKEN TO PREVENT ORDERED CHAINS CROSSING
C CONTOUR LINES.
C
      INTEGER   OUTFIL,MAXNS,SINK(8,MAXNS),NS,M,N,IP(8),JP(8),ND,
     +          IDOPT,ICOP
      REAL      U(M,N),DP(8),Z(*),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   IOPT,IS,ISS,I,J,IJ
C
C---FIND SINKS---
      IOPT=0
      CALL FNDSNK(OUTFIL,SINK,MAXNS,NS,U,IW,IV,M,N,IP,JP,Z,ND,
     +            IOPT,IDOPT,TOL(1))
      IF (NS.LE.0) RETURN
C
C---FIRST CLEAR SINKS ADJACENT TO STREAMS---
      CALL INSORT(NS,SINK,U,M,N)
	write(outfil,21) ns
  21	format(/' getnst called  ns =',i5)
      CALL GETNST(U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
      CALL CLRSNK(OUTFIL,U,IW,IV,M,N,IP,JP,DP,Z,ND,SINK,NS,IDOPT,
     +            TOL,ICOP)
C
C---REMOVE CLEARED SINKS---
      ISS=0
      DO 20 IS=1,NS
      I=SINK(1,IS)
      J=SINK(2,IS)
      IJ=IW(I,J)
      IF (IJ.LT.2) GOTO 20
      ISS=ISS + 1
      SINK(1,ISS)=SINK(1,IS)
      SINK(2,ISS)=SINK(2,IS)
      SINK(3,ISS)=SINK(3,IS)
      SINK(4,ISS)=SINK(4,IS)
      SINK(5,ISS)=SINK(5,IS)
      SINK(6,ISS)=SINK(6,IS)
      SINK(7,ISS)=SINK(7,IS)
      SINK(8,ISS)=SINK(8,IS)
  20  CONTINUE
      NS=ISS
      IF (NS.LE.0) RETURN
C
C---GET LOWEST SADDLE FOR EACH SINK---
	write(outfil,23) ns
  23	format(' getsad called  ns =',i5)
      CALL GETSAD(U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
C
C---CLEAR SINKS WHERE POSSIBLE---
      CALL CLRSNK(OUTFIL,U,IW,IV,M,N,IP,JP,DP,Z,ND,SINK,NS,IDOPT,
     +            TOL,ICOP)
C
C---REMOVE CLEARED SINKS AND SINK MARKERS---
      ISS=0
      DO 30 IS=1,NS
      I=SINK(1,IS)
      J=SINK(2,IS)
      IJ=IW(I,J)
      IF (IJ.LT.2) GOTO 30
      IW(I,J)=MOD(IJ,2)
      ISS=ISS + 1
  30  CONTINUE
      NS=ISS
	write(outfil,37) ns
  37	format(' no of remaining sinks =',i5)
      RETURN
      END
      SUBROUTINE FNDSNK(OUTFIL,SINK,MAXNS,NS,U,IW,IV,M,N,IP,JP,Z,ND,
     +                  IOPT,IDOPT,TOL)
C
C FINDS ALL SINKS IN THE ARRAY U AND, IF IDOPT IS GREATER
C THAN 0, RECORDS THEIR POSITION IN THE ARRAYS SINK AND IW.
C IF IOPT IS GREATER THAN 0 THEN SUMMARY INFORMATION IS
C WRITTEN TO OUTFIL.
C
      INTEGER   OUTFIL,MAXNS,SINK(8,MAXNS),NS,M,N,IP(8),JP(8),ND,
     +          IOPT,IDOPT
      REAL      U(M,N),Z(*),TOL
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   I,J,J1,K1,N1,K,IK,JK
      REAL      UL
C
C---FIND SINKS---
      NS=0
      N1=0
      DO 30 J=2,N-1
      K1=J - 1
      J1=J + 1
      DO 30 I=2,M-1
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 30
C
C---REMOVE DOWNSTREAM DATA POINT BARRIERS---
      K=IV(I,J)
      IF (K.GT.0) THEN
         IK=I + IP(K)
         JK=J + JP(K)
         IF (U(IK,JK).GT.U(I,J) .AND. IW(I,J).EQ.1) THEN
            IF (IDOPT.GT.0) THEN
               CALL CLRLOW(OUTFIL,U,IW,IV,M,N,I,J,IP,JP,Z,ND,IDOPT,TOL)
            ENDIF
         ENDIF
      ENDIF
C
C---LOOK FOR EXIT---
      UL=AMIN1(U(I-1,K1),U(I,K1),U(I+1,K1),U(I-1,J),U(I+1,J),
     +         U(I-1,J1),U(I,J1),U(I+1,J1))
      IF (U(I,J).GT.UL) GOTO 30
      IF (IEXIT(I,J,UL,U,IW,M,N,IP,JP).EQ.1) GOTO 30
      IF (IW(I,J).EQ.1) N1=N1 + 1
      IF (NS.GE.MAXNS .AND. IDOPT.GT.0) GOTO 50
      NS=NS + 1
C
C---UPDATE IW AND SINK ARRAYS---
      IW(I,J)=IW(I,J) + 2
      IF (IDOPT.LE.0) GOTO 30
      SINK(1,NS)=I
      SINK(2,NS)=J
      SINK(3,NS)=0
      SINK(4,NS)=0
  30  CONTINUE
C
C---OPTIONALLY WRITE SUMMARY SINK STATISTICS TO OUTFIL---
      IF (IOPT.GT.0) WRITE(OUTFIL,40) N1,NS-N1,NS
  40  FORMAT(' NUMBER OF DATA POINT SINKS      =',I7/
     +       ' NUMBER OF NON-DATA POINT SINKS  =',I7/
     +       ' TOTAL NUMBER OF SINKS           =',I7)
      RETURN
C
C---ERROR CONDITION---
  50  WRITE(OUTFIL,60) I,J
  60  FORMAT(/' NUMBER OF SINKS EXCEEDS MAXIMUM AT POSITION  I =',
     +        I5,' J =',I5)
      STOP 'FNDSNK - TOO MANY SINKS'
      END
      SUBROUTINE CLRLOW(OUTFIL,U,IW,IV,M,N,I0,J0,IP,JP,Z,ND,IDOPT,TOL)
C
C CLEARS HEIGHT CONFLICT BETWEEN DATA POINT AT POSITION I0,J0 AND 
C THE FIRST DATA POINT DOWN THE ORDERED CHAIN STARTING AT I0,J0.
C
      INTEGER   OUTFIL,M,N,I0,J0,IP(8),JP(8),ND,IDOPT
      REAL      U(M,N),Z(*),TOL
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   MN,I,J,K,KL,IWS
C
C---INITIALISE---
      I=I0
      J=J0
      K0=IV(I0,J0)
      IF (K0.LE.0) RETURN
      NR=0
      NL=0
      MN=M + N
C
C---STEP DOWN CHAIN---
      DO 10 K=1,MN
      KL=IV(I,J)
      IF (KL.LE.0) GOTO 20
      NL=NL + 1
      I=I + IP(KL)
      J=J + JP(KL)
      IWS=IW(I,J)
      IWS=MAX0(IWS,0)
      IWS=MOD(IWS,2)
      IF (IWS.EQ.1) GOTO 20
  10  CONTINUE
C
C---DATA POINT OR END OF CHAIN FOUND---
  20  IF (IDOPT.GE.3) CALL WRGRDS(OUTFIL,U,IW,IV,M,N,I,J,6)
      IF (U(I,J).LE.U(I0,J0)+TOL) THEN
         IF (IWS.EQ.1) CALL DELPNT(IW,M,N,I,J,Z,ND)
         IF (IDOPT.GE.3) WRITE(OUTFIL,30) I,J,U(I,J)
  30     FORMAT(' DOWNSTREAM DATA POINT',2I5,F10.3,' CLEARED')
         IF (U(I,J).GT.U(I0,J0)) THEN
            U(I,J)=U(I0,J0) - (U(I,J)-U(I0,J0))/NL
         ENDIF
         CALL SETCHN(I0,J0,I,J,NR,NL,U,IV,M,N,IP,JP)
C
C---REMOVE CHAIN---
      ELSE
         IF (IDOPT.GE.3) WRITE(OUTFIL,40) I,J,U(I,J)
  40     FORMAT(' DOWNSTREAM DATA POINT',2I5,F10.3,' NOT CLEARED')
         I=I0
         J=J0
         DO 50 K=1,NL
         KL=IV(I,J)
         IV(I,J)=0
         IF (KL.LE.0) GOTO 60
         I=I + IP(KL)
         J=J + JP(KL)
  50     CONTINUE
      ENDIF
  60  RETURN
      END
      SUBROUTINE DELPNT(IW,M,N,IK,JK,Z,ND)
C
C REMOVES DATA POINT AT POSITION IK,JK IN THE GRID FROM THE
C ARRAY Z.
C
      INTEGER   M,N,IK,JK,ND
      REAL      Z(*)
      INTEGER*2 IW(0:M+1,0:N+1)
C
C---LOCAL VARIABLES---
      INTEGER   KD,I,J,IWS,K
C
C---FIND Z ARRAY POSITION---
      KD=0
      DO 10 J=1,N
      DO 10 I=1,M
      IWS=IW(I,J)
      IWS=MAX0(IWS,0)
      IWS=MOD(IWS,2)
      IF (IWS.NE.1) GOTO 10
      KD=KD + 1
      IF (I.EQ.IK .AND. J.EQ.JK) GOTO 20
  10  CONTINUE
      STOP 'DELPNT - ERROR'
C
C---REMOVE POINT---
  20  IW(I,J)=IW(I,J) - 1
      DO 30 K=KD,ND-1
      Z(K)=Z(K+1)
  30  CONTINUE
      ND=ND - 1
      RETURN
      END
      SUBROUTINE INSORT(NS,SINK,U,M,N)
C
C SORTS NEWLY IDENTIFIED SINKS INTO ASCENDING ELEVATION USING
C THE INSERTION SORT ALGORITHM.  WHEN SINKS HAVE THE SAME ELEVATION
C THE NATURAL I,J ORDER IS MAINTAINED TO FACILITATE SEARCHING IN
C SUBROUTINE ADJSNK.
C
      INTEGER   NS,SINK(8,NS),M,N
      REAL      U(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   I,J,ITEMP(2)
      REAL      TEMP
C
      DO 30 I=2,NS
      TEMP=U(SINK(1,I),SINK(2,I))
      ITEMP(1)=SINK(1,I)
      ITEMP(2)=SINK(2,I)
C
      DO 10 J=I,2,-1
      IF (TEMP.GE.U(SINK(1,J-1),SINK(2,J-1))) GOTO 20
      SINK(1,J)=SINK(1,J-1)
      SINK(2,J)=SINK(2,J-1)
  10  CONTINUE
      J=1
C
  20  SINK(1,J)=ITEMP(1)
      SINK(2,J)=ITEMP(2)
  30  CONTINUE
      RETURN
      END
      INTEGER FUNCTION IEXIT(I,J,UL,U,IW,M,N,IP,JP)
C
C ATTEMPTS TO FIND LOWER EXIT FROM POTENTIAL SINK POINT I,J WITH 
C MIN VALUE OF ITS IMMEDIATE NEIGHBOURS UL AND THEN SET IEXIT TO 1.
C IF NO LOWER EXIT IS FOUND, IEXIT IS SET TO 0.
C
      INTEGER   I,J,M,N,IP(8),JP(8)
      REAL      UL,U(M,N)
      INTEGER*2 IW(0:M+1,0:N+1)
C
C---LOCAL VARIABLES---
      INTEGER   MN,K,KL,KR,IK,JK
      REAL      UIJ,UK1,UK2
C
C---INITIALISE---
      MN=M + N
      UIJ=U(I,J)
      IF (UIJ.LT.UL) GOTO 70
C
C---FIND STARTING SEARCH DIRECTION---
      KR=1
      IK=I + IP(KR)
      JK=J + JP(KR)
      UK1=U(IK,JK)
      KR=MOD(KR,8) + 1
      IK=I + IP(KR)
      JK=J + JP(KR)
      UK2=U(IK,JK)
      DO 15 K=1,8
      KR=MOD(KR,8) + 1
      IK=I + IP(KR)
      JK=J + JP(KR)
      IF (U(IK,JK).GT.UIJ .AND. UK2.GT.UIJ .AND. UK1.LE.UIJ) GOTO 20
      UK1=UK2
      UK2=U(IK,JK)
  15  CONTINUE
      GOTO 50
C
C---LOOK FOR EXIT---
  20  KL0=0
      IK=I
      JK=J
      DO 40 K=1,MN
      CALL GETLOW(KR,IK,JK,KL,U,M,N,IP,JP)
      IF (KL.EQ.0) GOTO 50
      KR=MOD(KL+3,8) + 1
      IK=IK + IP(KL)
      JK=JK + JP(KL)
      IF (U(IK,JK).LT.UIJ) GOTO 50
      IF (IW(IK,JK).GT.1 .OR. IW(IK,JK).LT.0) GOTO 50
      IF (IK.NE.I .OR. JK.NE.J) GOTO 40
      IF (KL.EQ.KL0) GOTO 70
      IF (KL0.EQ.0) KL0=KL
  40  CONTINUE
C
C---EXIT FOUND---
  50  IEXIT=1
      RETURN
C
C---NO EXIT FOUND---
  70  IEXIT=0
      RETURN
      END
      SUBROUTINE GETSAD(U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
C
C FINDS ALL SADDLES IN THE GRID U AND ASSOCIATES THEM WITH THEIR
C DOWNSTREAM SINKS AS FOUND BY SUBROUTINE GETSNK.
C
      INTEGER   M,N,IP(8),JP(8),NS,SINK(8,NS),ICOP
      REAL      U(M,N),DP(8),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   I,J,KL,KR,K,KK,II,IVL,L,KLS(4)
      REAL      UIJ,UL,UK
      LOGICAL   FLAG
C
C---BOTTOM EDGE---
      J=1
      KL=0
      DO 10 I=2,M-1
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 10
      IF (U(I,J).GT.AMIN1(U(I-1,J),U(I+1,J))) GOTO 10
      IF (U(I,J).LE.U(I,J+1)) GOTO 4
      KR=6
      GOTO 8
   4  IF (U(I,J).LE.U(I-1,J+1)) GOTO 6
      KR=7
      GOTO 8
   6  IF (U(I,J).LE.U(I+1,J+1)) GOTO 10
      KR=5
   8  CALL GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
  10  CONTINUE
C
C---LEFT EDGE---
      DO 70 J=2,N-1
      I=1
      KL=0
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 20
      IF (U(I,J).GT.AMIN1(U(I,J-1),U(I,J+1))) GOTO 20
      IF (U(I,J).LE.U(I+1,J)) GOTO 14
      KR=4
      GOTO 18
  14  IF (U(I,J).LE.U(I+1,J-1)) GOTO 16
      KR=3
      GOTO 18
  16  IF (U(I,J).LE.U(I+1,J+1)) GOTO 20
      KR=5
  18  CALL GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
C
C---AWAY FROM EDGES---
  20  DO 60 I=2,M-1
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 60
      UIJ=U(I,J)
      IK=I + IP(8)
      JK=J + JP(8)
      UK=U(IK,JK)
      L=0
      DO 25 K=1,8
      IK=I + IP(K)
      JK=J + JP(K)
      IF (U(IK,JK).LT.UIJ .AND. UK.GE.UIJ) L=L + 1
      UK=U(IK,JK)
  25  CONTINUE
C
C---SADDLE FOUND---
      IF (L.LE.1) GOTO 60
      K=8
      IVL=IV(I,J)
      DO 50 II=1,L
      IK=I + IP(K)
      JK=J + JP(K)
      UK=U(IK,JK)
      DO 30 KK=1,8
      K=MOD(K,8) + 1
      IK=I + IP(K)
      JK=J + JP(K)
      IF (U(IK,JK).LT.UIJ .AND. UK.GE.UIJ) GOTO 35
      UK=U(IK,JK)
  30  CONTINUE
  35  UL=(U(IK,JK) - UIJ)*DP(K)
      KL=K
      FLAG=K.EQ.IVL .OR. IW(IK,JK).GT.1
C
C---FIND EACH LOWEST EXIT---
      DO 40 KK=1,8
      K=MOD(K,8) + 1
      IK=I + IP(K)
      JK=J + JP(K)
      IF (U(IK,JK).GE.UIJ) GOTO 45
      IF (FLAG) GOTO 40
      UK=(U(IK,JK) - UIJ)*DP(K)
      FLAG=K.EQ.IVL .OR. IW(IK,JK).GT.1
      IF (UK.GE.UL .AND. .NOT.FLAG) GOTO 40
      KL=K
      UL=UK
  40  CONTINUE
  45  KLS(II)=KL
  50  CONTINUE
C
C---GET SINK OR EDGE FOR EACH PAIR OF EXITS---
      DO 55 KK=2,L
      KL=KLS(KK)
      DO 55 II=1,KK-1
      KR=KLS(II)
      CALL GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
  55  CONTINUE
  60  CONTINUE
C
C---RIGHT EDGE---
      I=M
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 70
      IF (U(I,J).GT.AMIN1(U(I,J-1),U(I,J+1))) GOTO 70
      KL=0
      IF (U(I,J).LE.U(I-1,J)) GOTO 62
      KR=8
      GOTO 68
  62  IF (U(I,J).LE.U(I-1,J-1)) GOTO 64
      KR=1
      GOTO 68
  64  IF (U(I,J).LE.U(I-1,J+1)) GOTO 70
      KR=7
  68  CALL GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
  70  CONTINUE
C
C---TOP EDGE---
      J=N
      KL=0
      DO 80 I=2,M-1
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 80
      IF (U(I,J).GT.AMIN1(U(I-1,J),U(I+1,J))) GOTO 80
      IF (U(I,J).LE.U(I,J-1)) GOTO 74
      KR=2
      GOTO 78
  74  IF (U(I,J).LE.U(I-1,J-1)) GOTO 76
      KR=1
      GOTO 78
  76  IF (U(I,J).LE.U(I+1,J-1)) GOTO 80
      KR=3
  78  CALL GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
  80  CONTINUE
      RETURN
      END
      SUBROUTINE GETNST(U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
C
C FINDS ALL STREAMLINE POINTS IMMEDIATELY ADJACENT TO SINK POINTS
C AND TREATS THEM AS SADDLES AS IN SUBROUTINE GETSAD.
C
      INTEGER   M,N,IP(8),JP(8),NS,SINK(8,NS),ICOP
      REAL      U(M,N),DP(8),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   IL,JL,I,J,IS,KL,KR
C
C---LOOP THROUGH SINKS---
      DO 20 IS=1,NS
      IL=SINK(1,IS)
      JL=SINK(2,IS)
      IF (IV(IL,JL).GT.0) GOTO 20
C
C---LOOK FOR NEIGHBOURING STREAMLINE POINT---
      DO 10 KL=1,8
      I=IL - IP(KL)
      J=JL - JP(KL)
      KR=IV(I,J)
      IF (KR.LE.0) GOTO 10
      IF (KL.EQ.KR) GOTO 10
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 10
      CALL GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,TOL,ICOP)
  10  CONTINUE
  20  CONTINUE
      RETURN
      END
      SUBROUTINE GETSNK(I,J,KL,KR,U,IW,IV,M,N,IP,JP,DP,SINK,NS,
     +                  TOL,ICOP)
C
C GETS NEIGHBOURING SINK OR EDGE ON EACH SIDE OF SADDLE I,J IN THE
C DIRECTIONS GIVEN BY KL AND KR AND UPDATES THE ENTRIES IN SINK.
C A ZERO VALUE FOR KL OR KR INDICATES TO SUBROUTINE FINDLO THAT
C THE SADDLE IS ON AN EDGE.
C
      INTEGER   I,J,KL,KR,M,N,IP(8),JP(8),NS,SINK(8,NS),ICOP
      REAL      U(M,N),DP(8),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   IL,JL,IR,JR,ISL,JSL,ISR,JSR
C
C---GET SINK OR EDGE FOR EACH SIDE OF SADDLE---
      CALL FINDLO(I,J,KL,IL,JL,ISL,JSL,U,IW,IV,M,N,IP,JP,DP,
     +            TOL(2),ICOP)
      CALL FINDLO(I,J,KR,IR,JR,ISR,JSR,U,IW,IV,M,N,IP,JP,DP,
     +            TOL(2),ICOP)
      IF (ISL.EQ.ISR .AND. JSL.EQ.JSR) RETURN
      IF (IL.EQ.IR .AND. JL.EQ.JR) RETURN
C
C---ADJUST SINK ON EACH SIDE OF SADDLE---
      CALL ADJSNK(I,J,KL,KR,IL,JL,IR,JR,ISR,JSR,U,IW,IV,
     +            M,N,SINK,NS,TOL)
      CALL ADJSNK(I,J,KR,KL,IR,JR,IL,JL,ISL,JSL,U,IW,IV,
     +            M,N,SINK,NS,TOL)
      RETURN
      END
      SUBROUTINE ADJSNK(I,J,KL,KR,IL,JL,IR,JR,ISR,JSR,
     +                  U,IW,IV,M,N,SINK,NS,TOL)
C
C UPDATES THE ENTRIES IN THE ARRAY SINK FOR SINK ISR,JSR (AT OR BELOW
C THE DATA POINT IR,JR) WHICH LEADS VIA SADDLE I,J TO THE POINT IL,JL.
C
      INTEGER   I,J,KL,KR,IL,JL,IR,JR,ISR,JSR,M,N,SINK(8,NS)
      REAL      U(M,N),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   IWL,IWR,IWS,IWSR,IS,IS1,IS2,II,JJ,IIL,JJL,KKL,KKR,IVS
      REAL      U1,U2
C
C---INITIALISE---
      IWS=IW(I,J)
      IWL=IW(IL,JL)
      IWL=MOD(MAX0(IWL,0),2)
      IWR=IW(IR,JR)
      IWR=MOD(MAX0(IWR,0),2)
      IWSR=IW(ISR,JSR)
C
C---IGNORE IMPOSSIBLE SADDLES---
      IF (U(I,J).GT.U(ISR,JSR)+2.0*TOL(3)) GOTO 80
      IF (IWSR.LT.2 .OR. IWSR.GT.3) GOTO 80
      IF (IWL.EQ.1) THEN
         IF (IWSR.EQ.3 .AND. U(IL,JL).GT.U(ISR,JSR)+TOL(2)) GOTO 80
         IF (IWR.EQ.1 .AND. U(IL,JL).GT.U(IR,JR)+TOL(2)) GOTO 80
      ENDIF
      IF (IWS.EQ.1) THEN
         IF (IWSR.EQ.3 .AND. U(I,J).GT.U(ISR,JSR)+TOL(2)) GOTO 80
         IF (IWR.EQ.1 .AND. U(I,J).GT.U(IR,JR)+TOL(2)) GOTO 80
      ENDIF
C
C---FLAG POINTER CONFLICTS---
      KKL=IV(I,J)
      IF (KKL.GT.0 .AND. KKL.NE.KL) THEN
         KKL=-KL
      ELSE
         KKL=KL
      ENDIF
C
C---FLAG SINKS BELOW DATA POINTS---
      IF (IR.NE.ISR .OR. JR.NE.JSR) THEN
         KKR=-KR
      ELSE
         KKR=KR
      ENDIF
C
C---FIND SINK IN SORTED SINK ARRAY BY REPEATED BISECTION---
      IS1=1
      IS2=NS
  10  IF (IS1+2.GE.IS2) GOTO 40
      IS=(IS1 + IS2)/2
      II=SINK(1,IS)
      JJ=SINK(2,IS)
      IF (U(II,JJ).GT.U(ISR,JSR)) GOTO 20
      IF (U(II,JJ).LT.U(ISR,JSR)) GOTO 30
      IF (JJ.GT.JSR) GOTO 20
      IF (JJ.LT.JSR) GOTO 30
      IF (II.GT.ISR) GOTO 20
      IF (II.LT.ISR) GOTO 30
      GOTO 60
  20  IS2=IS
      GOTO 10
  30  IS1=IS
      GOTO 10
C
  40  DO 50 IS=IS1,IS2
      IF (ISR.EQ.SINK(1,IS) .AND. JSR.EQ.SINK(2,IS)) GOTO 60
  50  CONTINUE
      STOP 'ADJSNK ERROR - SINK ARRAY NOT PROPERLY SORTED'
C
C---ADJUST ENTRY IN SINK ARRAY---
  60  IF (SINK(3,IS).EQ.0 .AND. SINK(4,IS).EQ.0) GOTO 70
      II=SINK(5,IS)
      JJ=SINK(6,IS)
      IIL=SINK(7,IS)
      JJL=SINK(8,IS)
      IF (U(IIL,JJL).GE.U(I,J)) GOTO 70
      IF (U(IL,JL).GE.U(II,JJ)) GOTO 80
C
C---OPTIONALLY ADD TOLERANCE TO SADDLES---
      U1=U(I,J)
      U2=U(II,JJ)
C
C---AT LEAST ONE DATA POINT SADDLE---
      IF (IW(I,J).EQ.1 .OR. IW(II,JJ).EQ.1) THEN
         IF (IABS(I-II).GT.1 .OR. IABS(JJ-J).GT.1 .OR. IL.NE.IIL
     +           .OR. JL.NE.JJL) THEN
            IF (IW(I,J).EQ.1) U1=U1 + TOL(1)
            IF (IW(II,JJ).EQ.1) U2=U2 + TOL(1)
         ELSE
C
C---LOOK FOR EXISTING COMPATIBLE POINTERS---
            IF (IW(I,J).EQ.0) THEN
               IVS=IV(I,J)
               IF (IVS.EQ.KKL) THEN
                  U2=U2 + TOL(1)/2.0
               ENDIF
            ENDIF
            IF (IW(II,JJ).EQ.0) THEN
               IVS=IV(II,JJ)
               IF (IVS.EQ.SINK(3,IS)) THEN
                  U1=U1 + TOL(1)/2.0
               ENDIF
            ENDIF
         ENDIF
      ELSE
C
C---ELSE AT LEAST ONE DESTINATION NOT MUCH LOWER THAN SINK---
         IF (U(IL,JL)+TOL(1)/2.0.GE.U(ISR,JSR) .OR.
     +            U(IIL,JJL)+TOL(1)/2.0.GE.U(ISR,JSR)) THEN
            IF (U(IL,JL)+TOL(1)/2.0.GE.U(ISR,JSR)) THEN
               IF (IW(IL,JL).EQ.1) U1=U1 + TOL(1)
               IF (IW(IL,JL)/2.EQ.1) U1=U1 + 2.0*TOL(1)
            ENDIF
            IF (U(IIL,JJL)+TOL(1)/2.0.GE.U(ISR,JSR)) THEN
               IF (IW(IIL,JJL).EQ.1) U2=U2 + TOL(1)
               IF (IW(IIL,JJL)/2.EQ.1) U2=U2 + 2.0*TOL(1)
            ENDIF
         ELSE
C
C---ELSE CHECK FOR SIGNIFICANTLY LOWER DESTINATION---
            IF (IW(IR,JR).EQ.2) THEN
               IF (U(IL,JL)+0.8*TOL(2).LT.U(ISR,JSR)) THEN
                  IF (U(IIL,JJL)+0.5*TOL(1).GT.U(ISR,JSR)) THEN
                     U2=U2 + TOL(1)
                  ENDIF
               ENDIF
               IF (U(IIL,JJL)+0.8*TOL(2).LT.U(ISR,JSR)) THEN
                  IF (U(IL,JL)+0.5*TOL(1).GT.U(ISR,JSR)) THEN
                     U1=U1 + TOL(1)
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
      ENDIF
C
C---CHOOSE LOWER ADJUSTED SADDLE---
      IF (U1.GT.U2) GOTO 80
      IF (U1.LT.U2) GOTO 70
      IF (KKL.LT.0) GOTO 80
      IF (KKL.GE.0 .AND. SINK(3,IS).LT.0) GOTO 70
      IF (IW(IL,JL)/2.EQ.1 .AND. IW(IIL,JJL)/2.NE.1) GOTO 80
      IF (IW(IL,JL)/2.NE.1 .AND. IW(IIL,JJL)/2.EQ.1) GOTO 70
      IF (KKR.LT.0) GOTO 80
      IF (KKR.GE.0 .AND. SINK(4,IS).LT.0) GOTO 70
      IF (U(IL,JL).LE.U(IIL,JJL) .AND. U(IIL,JJL).LE.U(IR,JR)) GOTO 80
  70  SINK(3,IS)=KKL
      SINK(4,IS)=KKR
      SINK(5,IS)=I
      SINK(6,IS)=J
      SINK(7,IS)=IL
      SINK(8,IS)=JL
C
C---EXIT---
  80  RETURN
      END
      SUBROUTINE CLRSNK(OUTFIL,U,IW,IV,M,N,IP,JP,DP,Z,ND,SINK,NS,
     +                  IDOPT,TOL,ICOP)
C
C CLEARS SINKS VIA LOWEST NEIGHBOURING SADDLES WHERE POSSIBLE.
C SADDLE POINTERS IN THE SINK ARRAY ARE CLEARED AND SINKS WHICH ARE
C CLEARED ARE REMOVED SO THAT THE SINK ARRAY CAN BE USED AGAIN.
C
      INTEGER   OUTFIL,M,N,IP(8),JP(8),ND,NS,SINK(8,NS),IDOPT,ICOP
      REAL      U(M,N),DP(8),Z(*),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   IS,KL,KR,KKL,I,J,IL,JL,ISL,JSL,IR,JR,ISR,JSR,
     +          NL,NR,IWL,IWR,IWSR,ISET
      REAL      UR
      LOGICAL   KFLAG
      EXTERNAL  LOW
C
C---LOOP THROUGH SINKS---
      ISET=1
      NL=0
      NR=0
      DO 60 IS=1,NS
      ISR=SINK(1,IS)
      JSR=SINK(2,IS)
      IWSR=IW(ISR,JSR)
C
C---CHECK THAT SADDLE IS OK AND CLEAR SADDLE POINTERS---
      IF (IV(ISR,JSR).GT.0) GOTO 60
      KL=SINK(3,IS)
      SINK(3,IS)=0
      KR=SINK(4,IS)
      SINK(4,IS)=0
      I=SINK(5,IS)
      J=SINK(6,IS)
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 60
      KKL=IV(I,J)
      IF (KKL.GT.0 .AND. KL.GT.0 .AND. KKL.NE.KL) GOTO 60
      KFLAG=KL.LT.0
      KL=IABS(KL)
      KR=IABS(KR)
      IF (KL.LE.0 .OR. KR.LE.0) GOTO 60
      IL=I + IP(KL)
      JL=J + JP(KL)
      IF (U(IL,JL).GT.U(I,J)) GOTO 60
      IR=I + IP(KR)
      JR=J + JP(KR)
      IF (U(IR,JR).GT.U(I,J)) GOTO 60
      IF (ICOP.GT.0 .AND. IW(I,J).EQ.0) THEN
         IF (MOD(KL,2).EQ.1) THEN
            IF (IW(I,JL).GT.0 .AND. IW(IL,J).GT.0) GOTO 60
         ENDIF
         IF (MOD(KR,2).EQ.1) THEN
            IF (IW(I,JR).GT.0 .AND. IW(IR,J).GT.0) GOTO 60
         ENDIF
      ENDIF
C
C---CHECK THAT DESTINATION POINTS HAVE NOT CHANGED---
      CALL FINDLO(I,J,KL,IL,JL,ISL,JSL,U,IW,IV,M,N,IP,JP,DP,
     +            TOL(2),ICOP)
      IF (IL.NE.SINK(7,IS) .OR. JL.NE.SINK(8,IS)) GOTO 60
      IF (IW(IL,JL)/2.EQ.1 .AND. IV(IL,JL).GT.0) GOTO 60
      CALL FINDLO(I,J,KR,IR,JR,ISR,JSR,U,IW,IV,M,N,IP,JP,DP,
     +            TOL(2),ICOP)
      IF (ISR.NE.SINK(1,IS) .OR. JSR.NE.SINK(2,IS)) GOTO 60
      IF (IV(IR,JR).GT.0) GOTO 60
C
C---ATTEMPT TO CLEAR SINK---
      IWL=IW(IL,JL)
      IWR=IW(IR,JR)
C
C---DATA POINT SINK---
      IF (IWR.NE.2) THEN
         IF (IWSR.EQ.3) THEN
            IF (U(IR,JR).GT.U(ISR,JSR)+TOL(1)) GOTO 60
            IF (U(IL,JL).GT.U(ISR,JSR)+TOL(1)) GOTO 60
            IF (IWL.EQ.4) THEN
               IF (U(IL,JL).GT.U(ISR,JSR)+0.5*TOL(1)) GOTO 60
            ELSE
               IF (U(ISL,JSL)+TOL(4).GE.U(ISR,JSR)) GOTO 60
            ENDIF
         ELSE
            IF (U(IL,JL).GT.U(IR,JR)+TOL(1)) GOTO 60
            IF (IABS(IR-ISR).LE.1 .AND. IABS(JR-JSR).LE.1) THEN
               IF (U(ISL,JSL)+TOL(4).GT.U(IR,JR)) GOTO 60
            ELSE
               IF (U(ISL,JSL)+TOL(1).GT.U(IR,JR)) GOTO 60
            ENDIF
         ENDIF
C
C---REMOVE DATA POINT SADDLE---
         IF (IW(I,J).EQ.1) THEN
            IF (IWSR.EQ.3) THEN
               IF (U(I,J).GT.U(ISR,JSR)+TOL(1)) GOTO 60
            ELSE
               IF (U(I,J).GT.U(IR,JR)+TOL(1)) GOTO 60
            ENDIF
            IF (IDOPT.GE.3) THEN
               CALL WRGRDS(OUTFIL,U,IW,IV,M,N,I,J,6)
               WRITE(OUTFIL,10) I,J,U(I,J)
  10           FORMAT(' DATA POINT SADDLE',2I5,F10.3,' CLEARED')
            ENDIF
            CALL DELPNT(IW,M,N,I,J,Z,ND)
         ENDIF
C
C---CLEAR DATA POINT SINK---
         UR=U(IR,JR)
         IF (KFLAG .AND. IWL.EQ.2) GOTO 60
         IF (U(IL,JL).LT.U(IR,JR) .OR. IWL.EQ.4) GOTO 40
C
C---DESTINATION APPROXIMATELY SAME ELEVATION AS SINK---
         IF (KFLAG .OR. IWL.NE.1) GOTO 60
  20     CALL DELPNT(IW,M,N,IL,JL,Z,ND)
         CALL FILLDO(LOW,I,J,KL,IL,JL,NL,U,IW,IV,M,N,IP,JP,DP,
     +               TOL(2),ICOP)
         KL=IV(I,J)
         IF (IW(IL,JL).EQ.1 .AND. U(IL,JL).GE.U(IR,JR)) GOTO 20
         GOTO 50
C
C---NON-DATA POINT SINK---
      ELSE
         IF (IW(I,J).EQ.0) THEN
            IF (U(IL,JL).LT.U(IR,JR)) THEN
               UR=U(IR,JR)
               IF (IWL.NE.2 .OR. KKL.EQ.KL) GOTO 40
               IF (U(IL,JL)+0.8*TOL(2).LE.U(IR,JR)) GOTO 40
               GOTO 60
C
C---RAISE SINK ABOVE LOWER DATA POINT---
            ELSE
               UR=GETUP(U,IV,M,N,IR,JR,IP,JP)
               IF (IWL.NE.2 .AND. .NOT.KFLAG) THEN
                   IF (UR.GT.U(IL,JL)) GOTO 40
               ENDIF
               GOTO 60
            ENDIF
C
C---RAISE SINK ABOVE SADDLE---
         ELSE
            UR=GETUP(U,IV,M,N,IR,JR,IP,JP) + TOL(1)/2.0
            IF (IWL.NE.2 .AND. .NOT.KFLAG) THEN
               IF (UR.GT.U(I,J) .AND. ICOP.EQ.0) THEN
                  CALL FILLDO(LOW,I,J,KL,IL,JL,NL,U,IW,IV,M,N,IP,JP,DP,
     +                        TOL(2),ICOP)
                  CALL SETCHN(I,J,IL,JL,0,NL,U,IV,M,N,IP,JP)
                  NL=0
                  IL=I
                  JL=J
                  GOTO 50
               ENDIF
            ENDIF
            GOTO 60
         ENDIF
      ENDIF
C
C---SET ORDERED CHAIN FOR PERMISSIBLE SADDLE---
  40  CALL FILLDO(LOW,I,J,KL,IL,JL,NL,U,IW,IV,M,N,IP,JP,DP,TOL(2),ICOP)
  50  CALL FILLUP(LOW,I,J,KR,IR,JR,NR,U,IW,IV,M,N,IP,JP,DP,TOL(2),ICOP)
      U(IR,JR)=AMIN1(AMAX1(U(IR,JR),UR),U(I,J))
      U(IL,JL)=AMIN1(U(IL,JL),U(IR,JR))
      CALL SETCHN(IR,JR,IL,JL,NR,NL,U,IV,M,N,IP,JP)
C
C---EXTEND CHAIN TO NEXT ORDERED CHAIN OR EGDE OF GRID---
      IF (ICOP.EQ.0 .AND. IW(IL,JL).EQ.1 .AND. IV(IL,JL).EQ.0) THEN
         CALL EXTCHN(IL,JL,U,IW,IV,M,N,IP,JP,DP,TOL,ICOP,ISET)
      ENDIF
      IW(ISR,JSR)=MOD(IWSR,2)
  60  CONTINUE
      RETURN
      END
      REAL FUNCTION GETUP(U,IV,M,N,I,J,IP,JP)
C
C DETERMINES THE HEIGHT OF THE LOWEST POINT IMMEDIATELY UPSTREAM
C OF THE POINT I,J.  IF THERE IS NO UPSTREAM POINT, THE MAXIMUM OF
C U(I,J) AND ITS 8 IMMEDIATE NEIGHBOURS IS RETURNED.
C
      INTEGER   M,N,I,J,IP(8),JP(8)
      REAL      U(M,N)
      INTEGER*2 IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   K,IK,JK,IVK,KHL
      REAL      UK,UH,UHL
C
C---INITIALISE---
      KHL=0
      UH=U(I,J)
      UHL=UH
C
C---INPSECT NEIGHBOURING POINTS---
      DO 20 K=1,8
      IK=I - IP(K)
      JK=J - JP(K)
      IVK=IV(IK,JK)
      UK=U(IK,JK)
      IF (IVK.EQ.K) THEN
         IF (KHL.EQ.0 .OR. UK.LT.UHL) THEN
            KHL=K
            UHL=UK
         ENDIF
      ELSE
         UH=AMAX1(UH,UK)
      ENDIF
  20  CONTINUE
C
C---FINISH UP---
      IF (KHL.NE.0) THEN
         GETUP=UHL
      ELSE
         GETUP=UH
      ENDIF
      RETURN
      END
      SUBROUTINE EXTCHN(I,J,U,IW,IV,M,N,IP,JP,DP,TOL,ICOP,ISET)
C
C EXTENDS THE ORDERED CHAIN ENDING AT DATA POINT I,J DOWN TO A
C LOWER ORDERED CHAIN OR AN EDGE OF THE GRID.  IF ISET IS NOT
C ZERO THEN HEIGHTS ARE LINEARLY INTERPOLATED BETWEEN DATA
C POINTS DOWN THE EXTENDED CHAIN.
C
      INTEGER   I,J,M,N,IP(8),JP(8),ICOP,ISET
      REAL      U(M,N),DP(8),TOL(4)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
      EXTERNAL  LOW
C
C---LOCAL VARIABLES---
      INTEGER   MN,K,IL,JL,KR,KL
C
      MN=M + N
      DO 10 K=1,MN
      IF (IW(I,J).NE.1 .OR. IV(I,J).NE.0) GOTO 20
      KR=0
      CALL LOW(KR,I,J,KL,IL,JL,U,IV,M,N,IP,JP,DP)
      IF (KL.LE.0) GOTO 20
      IF (U(IL,JL).GE.U(I,J)) GOTO 20
      CALL FILLDO(LOW,I,J,KL,IL,JL,NL,U,IW,IV,M,N,IP,JP,DP,TOL(2),ICOP)
      IF (ISET.NE.0) CALL SETCHN(I,J,IL,JL,0,NL,U,IV,M,N,IP,JP)
      I=IL
      J=JL
  10  CONTINUE
      STOP 'EXTCHN ERROR'
C
C---EXIT---
  20  RETURN
      END
      SUBROUTINE FILLUP(DIRN,I,J,KR,IR,JR,NR,U,IW,IV,M,N,IP,JP,DP,
     +                  TOL,ICOP)
C
C SETS POINTERS IN REVERSE DIRECTION FROM POINT I,J TO
C POINT IR,JR STARTING IN THE DIRECTION KR.
C THE NUMBER OF STEPS IN THE CHAIN IS RETURNED IN NR.
C
      INTEGER   I,J,KR,IR,JR,NR,M,N,IP(8),JP(8),ICOP
      REAL      U(M,N),DP(8),TOL
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
      EXTERNAL  DIRN
C
C---LOCAL VARIABLES---
      INTEGER   MN,KR1,IR1,JR1,KL
      LOGICAL   FLAG
C
C---INITIALISE---
      FLAG=ICOP.GT.0
      MN=M + N
      IR=I
      JR=J
      NR=0
      IF (KR.LE.0) RETURN
      IR1=IR + IP(KR)
      JR1=JR + JP(KR)
      KR1=KR
C
C---GO TO FIRST DATA POINT, SINK OR EDGE---
      DO 10 NR=1,MN
      CALL GETNXT(DIRN,KR,IR,JR,KR1,IR1,JR1,U,IV,M,N,IP,JP,DP)
      KL=MOD(KR+3,8) + 1
      IV(IR,JR)=KL
      IF (IW(IR,JR).NE.0) GOTO 20
      IF (KR1.LE.0) GOTO 20
      IF (U(IR1,JR1).EQ.U(IR,JR)) GOTO 20
      IF (FLAG) THEN
         IF (ABS(U(IR1,JR1)-U(I,J)).GT.TOL .AND. IW(IR1,JR1).EQ.0)
     +       GOTO 20
         IF (IV(IR1,JR1).GT.0 .AND. U(IR1,JR1).GT.U(IR,JR)) GOTO 20
         IF (MOD(KR1,2).EQ.1) THEN
            IF (IW(IR,JR1).GT.0 .OR. IW(IR1,JR).GT.0) GOTO 20
         ENDIF
      ENDIF
  10  CONTINUE
      STOP 'FILLUP - ERROR'
C
C---EXIT---
  20  RETURN
      END
      SUBROUTINE FILLDO(DIRN,I,J,KL,IL,JL,NL,U,IW,IV,M,N,IP,JP,DP,
     +                  TOL,ICOP)
C
C SETS POINTERS IN FORWARD DIRECTION FROM POINT I,J TO
C POINT IL,JL STARTING IN THE DIRECTION KL.
C THE NUMBER OF STEPS IN THE CHAIN IS RETURNED IN NL.
C
      INTEGER   I,J,KL,IL,JL,NL,M,N,IP(8),JP(8),ICOP
      REAL      U(M,N),DP(8),TOL
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
      EXTERNAL  DIRN
C
C---LOCAL VARIABLES---
      INTEGER   MN,IL1,JL1,KL2,IL2,JL2
      LOGICAL   FLAG
C
C---INITIALISE---
      FLAG=ICOP.GT.0
      MN=M + N
      IL=I
      JL=J
      NL=0
      IF (KL.LE.0) RETURN
      IL1=IL
      JL1=JL
      IL2=IL1 + IP(KL)
      JL2=JL1 + JP(KL)
      KL2=KL
C
C---GO TO FIRST DATA POINT, SINK OR EDGE---
      DO 10 NL=1,MN
      CALL GETNXT(DIRN,KL,IL1,JL1,KL2,IL2,JL2,U,IV,M,N,IP,JP,DP)
      IV(IL,JL)=KL
      IL=IL1
      JL=JL1
      IF (IW(IL1,JL1).NE.0) GOTO 20
      IF (KL2.LE.0) GOTO 20
      IF (U(IL2,JL2).EQ.U(IL1,JL1)) GOTO 20
      IF (FLAG) THEN
         IF (ABS(U(IL2,JL2)-U(I,J)).GT.TOL .AND. IW(IL2,JL2).EQ.0)
     +       GOTO 20
         IF (MOD(KL2,2).EQ.1) THEN
            IF (IW(IL1,JL2).GT.0 .OR. IW(IL2,JL1).GT.0) GOTO 20
         ENDIF
      ENDIF
  10  CONTINUE
      STOP 'FILLDO - ERROR'
C
C---EXIT---
  20  RETURN
      END
      SUBROUTINE FINDLO(I,J,K0,IL,JL,ISL,JSL,U,IW,IV,M,N,
     +                  IP,JP,DP,TOL,ICOP)
C
C FINDS NEXT SINK OR EDGE BELOW THE SADDLE I,J IN THE DIRECTION KO
C AND RETURNS THIS POSITION IN ISL,JSL.  IF A DATA POINT IS ENCOUNTERED
C THE POSITION OF THE FIRST DATA POINT ENCOUNTERED IS RETURNED IN
C IL,JL.  OTHERWISE IL,JL COINCIDES WITH ISL,JSL.
C
      INTEGER   I,J,K0,IL,JL,ISL,JSL,M,N,IP(8),JP(8),ICOP
      REAL      U(M,N),DP(8),TOL
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   MN,K,KL,KL1,ISL1,JSL1
      REAL      UL
      LOGICAL   FLAG
      EXTERNAL  LOW
C
C---INITIALISE---
      FLAG=ICOP.GT.0
      MN=M + N
      ISL=I
      JSL=J
      UL=U(ISL,JSL)
      IL=0
      IF (K0.LE.0) GOTO 30
      KL=K0
      ISL1=ISL + IP(KL)
      JSL1=JSL + JP(KL)
      KL1=KL
C
C---STEP DOWN---
      DO 20 K=1,MN
      CALL GETNXT(LOW,KL,ISL,JSL,KL1,ISL1,JSL1,U,IV,M,N,IP,JP,DP)
      IF (IW(ISL,JSL).LT.0 .OR. IW(ISL,JSL).GT.1) GOTO 30
      IF (IW(ISL,JSL).EQ.0) GOTO 10
      IF (IL.GT.0) THEN
         IF (U(ISL,JSL)+TOL.LT.U(IL,JL)) GOTO 30
         IF (ISL.EQ.IL .AND. JSL.EQ.JL) GOTO 30
      ELSE
         IL=ISL
         JL=JSL
      ENDIF
  10  IF (KL1.LE.0) GOTO 30
      IF (FLAG) THEN
         IF (U(ISL1,JSL1)+TOL.LT.U(I,J) .AND. IW(ISL1,JSL1).LE.0)
     +       GOTO 30
         IF (MOD(KL1,2).EQ.1) THEN
            IF (IW(ISL,JSL1).GT.0 .OR. IW(ISL1,JSL).GT.0) GOTO 30
         ENDIF
      ENDIF
      IF (MOD(K,20).NE.0) GOTO 20
      IF (U(ISL,JSL).GE.UL) GOTO 30
      UL=U(ISL,JSL)
  20  CONTINUE
C
C---SINK OR EDGE FOUND---
  30  IF (IL.GT.0) GOTO 40
      IL=ISL
      JL=JSL
  40  RETURN
      END
      SUBROUTINE GETNXT(DIRN,K1,I1,J1,K2,I2,J2,U,IV,M,N,IP,JP,DP)
C
C GETS THE NEXT POINT I2,J2 BELOW (OR ABOVE) I1,J1 BY LOOKING AHEAD
C TO THE POINT I3,J3 USING SUBROUTINE DIRN AND GENERALISING THE LINE
C WHEN POSSIBLE.
C
      INTEGER   K1,I1,J1,K2,I2,J2,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8)
      INTEGER*2 IV(M,N)
      EXTERNAL  DIRN
C
C---LOCAL VARIABLES---
      INTEGER   KR,K3,I3,J3
C
C---INITIALISE---
      IF (K2.LE.0) RETURN
  10  KR=MOD(K2+4,8) + 1
      CALL DIRN(KR,I2,J2,K3,I3,J3,U,IV,M,N,IP,JP,DP)
      IF (K3.LE.0) GOTO 40
      IF (U(I3,J3).EQ.U(I2,J2)) GOTO 40
      IF (IABS(I3-I1).GT.1 .OR. IABS(J3-J1).GT.1) GOTO 40
C
C---GENERALISE LINE---
      DO 20 K2=1,8
      IF (I3-I1.EQ.IP(K2) .AND. J3-J1.EQ.JP(K2)) GOTO 30
  20  CONTINUE
      K2=0
      K3=0
      GOTO 40
  30  I2=I3
      J2=J3
      GOTO 10
C
C---UPDATE POSTIONS---
  40  I1=I2
      I2=I3
      J1=J2
      J2=J3
      K1=K2
      K2=K3
      RETURN
      END
      SUBROUTINE LOW(KR,I,J,KL,IL,JL,U,IV,M,N,IP,JP,DP)
C
C FINDS THE POINT IL,JL BESIDE THE DIRECTION KR WHICH IS
C ADJACENT TO AND IN THE STEEPEST DIRECTION BELOW THE POINT I,J.
C THE DIRECTION OF THE POINT FOUND IS RETURNED IN KL.
C KL IS SET TO 0 IF NO LOWER POINT IS FOUND.
C KL IS SET TO -1 IF THE POINT I,J LIES ON AN EDGE.
C
      INTEGER   KR,I,J,KL,IL,JL,M,N,IP(8),JP(8)
      REAL      U(M,N),DP(8)
      INTEGER*2 IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   K,KK,IK,JK
      REAL      UIJ,VK,VL,ZERO
C
      DATA      ZERO/0.0/
C
C---INITIALISE---
      KL=-1
      IF (I.LE.1 .OR. I.GE.M .OR. J.LE.1 .OR. J.GE.N) RETURN
C
C---LOOK FOR STRICTLY DESCENDING CHAIN---
      KL=IV(I,J)
      UIJ=U(I,J)
      IF (KL.GT.0) THEN
         IL=I + IP(KL)
         JL=J + JP(KL)
         IF (U(IL,JL).LT.UIJ) RETURN
      ENDIF
C
C---FIND NEXT LOWEST NEIGHBOUR---
      KL=0
      VL=ZERO
      K=KR
      DO 20 KK=1,8
      K=MOD(K,8) + 1
      IK=I + IP(K)
      JK=J + JP(K)
      VK=(U(IK,JK) - UIJ)*DP(K)
      IF (VK.GT.VL) GOTO 20
      IF (VK.LT.VL) GOTO 10
      IF (KL.GT.0) GOTO 20
  10  VL=VK
      KL=K
      IL=IK
      JL=JK
  20  CONTINUE
      RETURN
      END
      SUBROUTINE GETLOW(KR,I,J,KL,U,M,N,IP,JP)
C
C FINDS THE NEXT POINT, BESIDE THE DIRECTION KR, WHICH IS NOT GREATER
C THAN U(I,J).  THE DIRECTION OF THIS POINT IS RETURNED IN KL.
C KL IS SET TO 0 IF THE POINT I,J LIES ON AN EDGE OR NO LOWER POINT
C IS FOUND.
C
      INTEGER   KR,KL,I,J,M,N,IP(8),JP(8)
      REAL      U(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   K,IK,JK
      REAL      UIJ
C
C---INITIALISE---
      KL=0
      IF (I.LE.1 .OR. I.GE.M .OR. J.LE.1 .OR. J.GE.N) RETURN
C
C---FIND NEXT LOWER NEIGHBOUR---
      UIJ=U(I,J)
      KL=KR
      DO 10 K=1,8
      KL=MOD(KL,8) + 1
      IK=I + IP(KL)
      JK=J + JP(KL)
      IF (U(IK,JK).LE.UIJ) GOTO 20
  10  CONTINUE
      KL=0
C
C---NEXT POINT FOUND---
  20  RETURN
      END
      SUBROUTINE SETCHN(IR,JR,IL,JL,NR,NL,U,IV,M,N,IP,JP)
C
C SETS ELEMENTS OF AN ORDERED CHAIN GOING DOWN FROM POSITION IR,JR
C TO POSITION IL,JL.  INTERMEDIATE VALUES OF THE CHAIN ARE
C DETERMINED BY LINEAR INTERPOLATION PROVIDED THEY DO NOT EXCEED
C THE EXISTING CHAIN VALUES.
C
      INTEGER   IR,JR,IL,JL,NR,NL,M,N,IP(8),JP(8)
      REAL      U(M,N)
      INTEGER*2 IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   NUM,IK,JK,KL,K
      REAL      UR,DU
C
C---INITIALISE---
      NUM=NL + NR
      IF (NUM.LE.1) RETURN
      UR=U(IR,JR)
      DU=(UR - U(IL,JL))/NUM
      IK=IR
      JK=JR
C
C---STEP DOWN CHAIN TO SADDLE---
      DO 10 K=1,NR
      KL=IV(IK,JK)
      IF (KL.LE.0) GOTO 30
      IK=IK + IP(KL)
      JK=JK + JP(KL)
      U(IK,JK)=UR - K*DU
  10  CONTINUE
C
C---STEP DOWN BEYOND SADDLE---
      DO 20 K=NR+1,NUM-1
      KL=IV(IK,JK)
      IF (KL.LE.0) GOTO 30
      IK=IK + IP(KL)
      JK=JK + JP(KL)
      U(IK,JK)=AMIN1(U(IK,JK), UR - K*DU)
  20  CONTINUE
      RETURN
C
C---ERROR CONDITION---
  30  STOP 'SETCHN - ERROR'
      END
