      SUBROUTINE RDSINK(NFIL,OUTFIL,DATFIL,DATNAM,DATFMT,SNKFIL,
     +                  IW,M,N,X0,X1,Y0,Y1,H,NSNK)
C
C READS SINK POINTS FROM DATFIL IN THE FORMAT GIVEN BY DATFMT AND
C WRITES SELECTED POINTS TO SNKFIL.  POINTS LYING OUTSIDE THE
C POLYGON, AS DETERMINED BY THE ASSOCIATED INTEGER ARRAY IW, ARE
C REJECTED.
C
C THE NUMBER OF ACCEPTED SINK POINTS IS ADDED TO NSNK.
C
      INTEGER          NFIL,OUTFIL,DATFIL,SNKFIL,M,N,NSNK
      DOUBLE PRECISION X0,X1,Y0,Y1,H
      CHARACTER*40     DATNAM,DATFMT
      INTEGER*2        IW(0:M+1,0:N+1)
C
C---LOCAL VARIABLES---
      INTEGER          I,J,N1,N2
      REAL             ZZ,ONE,ONE5
      DOUBLE PRECISION ZERO,XX,YY
C
      DATA             ZERO,ONE,ONE5/0.0D0, 1.0, 1.5/
C
C---INITIALIZE---
      WRITE(OUTFIL,10) NFIL,DATNAM
  10  FORMAT(/' SINK DATA FILE',I3,': ',A40)
      OPEN(DATFIL,FILE=DATNAM,STATUS='OLD')
      REWIND DATFIL
      N1=0
      N2=0
C
C---LOOP THROUGH SINK POINTS---
  20  DO 30 K=1,1000
      READ(DATFIL,DATFMT,END=40) XX,YY,ZZ
      N1=N1 + 1
C
C---REMOVE POINTS OUTSIDE LIMITS---
      IF (XX.LT.X0 .OR. XX.GT.X1 .OR. YY.LT.Y0 .OR. YY.GT.Y1)
     +   GOTO 30
C
C---CALCULATE GRID POSITION---
      XX=DMAX1(XX-X0, ZERO)
      YY=DMAX1(YY-Y0, ZERO)
      I=XX/H + ONE5
      J=YY/H + ONE5
C
C---CHECK FOR POLYGON---
      IF (IW(I,J).LT.0) GOTO 30
      N2=N2 + 1
      WRITE(SNKFIL) XX,YY,ZZ
  30  CONTINUE
      GOTO 20
C
C---WRITE DETAILS TO OUTPUT---
  40  WRITE(OUTFIL,50) N1,N2
  50  FORMAT(' NUMBER OF SINK POINTS READ      =',I7/
     +       ' NUMBER OF SINK POINTS ACCEPTED  =',I7)
      CLOSE(DATFIL)
C
C---FINISH UP---
      NSNK=NSNK + N2
      RETURN
      END
      SUBROUTINE SELSNK(OUTFIL,SNKFIL,NSNK,U,IW,IV,M,N,H,Z0,Z1,IP,JP)
C
C SELECTS SINK POINTS, FOR A GIVEN GRID RESOLUTION H, FROM THE
C UNFORMATTED FILE SNKFIL.  SINK POINTS WHICH HAVE VALID HEIGHT ARE
C INSERTED INTO THE GRID WITH APPROPRIATE DESCENDING CHAIN CONDITIONS.
C SINKS WHICH LIE ON EXISTING ORDERED CHAINS ARE IGNORED.
C
      INTEGER          OUTFIL,NSNK,SNKFIL,M,N,IP(8),JP(8)
      REAL             U(M,N),Z0,Z1
      DOUBLE PRECISION H
      INTEGER*2        IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER          I,J,K,KL
      REAL             Z,ONE5
      DOUBLE PRECISION X,Y
C
      DATA             ONE5/1.5/
C
C---READ DATA POINTS FROM SAVFIL---
      REWIND SNKFIL
      DO 30 K=1,NSNK
      READ(SNKFIL) X,Y,Z
      I=X/H + ONE5
      J=Y/H + ONE5
      IF (IW(I,J).LT.0 .OR. IW(I,J).GT.1) GOTO 30
      IF (IV(I,J).GT.0) GOTO 30
      IW(I,J)=IW(I,J) + 4
C
C---LOAD HEIGHT OF SINK ONTO GRID WHEN AVAILABLE---
      IF (Z.LT.Z0 .OR. Z.GT.Z1) GOTO 20
      IW(I,J)=5
      U(I,J)=Z
C
C---SET POINTERS FOR SINK AND SURROUNDING GRID POINTS---
  20  IV(I,J)=0
      DO 10 KL=1,8
      IK=I - IP(KL)
      JK=J - JP(KL)
      IF (IW(IK,JK).LT.0 .OR. IW(IK,JK).GT.1) GOTO 10
      IF (IV(IK,JK).GT.0) GOTO 10
      IV(IK,JK)=KL
  10  CONTINUE
  30  CONTINUE
      RETURN
      END
