      SUBROUTINE USDEM(GRDNAM,GRDFIL,U,IW,M,N,X0,X1,Y0,Y1,H,
     +                 Z0,Z1,SPVAL)
C
C WRITES THE GRID U TO GRDFIL IN STANDARD USGS DEM FORMAT AS USED
C BY ARC/INFO.
C
C SPECIAL VALUES ARE INSERTED OUTSIDE THE SUBSET OF THE GRID
C SPECIFIED BY IW.
C
      INTEGER          GRDFIL,M,N
      REAL             U(M,N),Z0,Z1,SPVAL
      DOUBLE PRECISION X0,X1,Y0,Y1,H
      INTEGER*2        IW(0:M+1,0:N+1)
      CHARACTER*40     GRDNAM
C
C---LOCAL VARIABLES---
      INTEGER          I,J,IDEM,IPTN,IREF,IZONE,IPLAN,IELEV,IPOL,
     +                 IACC,IROW,ICOL,IDX,IDY
      REAL             ZMIN,ZMAX
      DOUBLE PRECISION X,MPARS(15),ANGLE,DZ,ZBASE
C
      DATA MPARS/15*0.0D0/
C
C---SET SPECIAL VALUES AND GET MIN AND MAX GRID VALUES---
      ZMIN=Z1
      ZMAX=Z0
      DO 20 J=1,N
      DO 10 I=1,M
      IF (IW(I,J).LT.0) THEN
         U(I,J)=SPVAL
      ELSE
         ZMIN=AMIN1(ZMIN,U(I,J))
         ZMAX=AMAX1(ZMAX,U(I,J))
      ENDIF
  10  CONTINUE
  20  CONTINUE
C
C---WRITE LOGICAL RECORD TYPE A---
      IDEM=-99
      IPTN=1
      IREF=1
      IZONE=-99
      IPLAN=2
      IELEV=2
      IPOL=4
      ANGLE=0.0D0
      IACC=0
      DZ=1.0D0
      IROW=1
      ICOL=M
      WRITE(GRDFIL,30) GRDNAM,IDEM,IPTN,IREF,IZONE,MPARS,IPLAN,IELEV,
     +                 IPOL,X0,Y0,X0,Y1,X1,Y1,X1,Y0,ZMIN,ZMAX,ANGLE,
     +                 IACC,H,H,DZ,IROW,ICOL
  30  FORMAT(4X,A40,100X,4I6,15D24.15,3I6,8D24.15,2D24.15,D24.15,
     +       I6,3E12.6,2I6)
C
C---WRITE LOGICAL RECORDS TYPE B---
      IDY=1
      ZBASE=0.0D0
      ZMIN=Z1
      ZMAX=Z0
      DO 80 I=1,M
      IDX=I
      X=X0 + (I-1)*H
C
C---MIN AND MAX FOR PROFILE---
      DO 40 J=1,N
      ZMIN=AMIN1(ZMIN,U(I,J))
      ZMAX=AMAX1(ZMAX,U(I,J))
  40  CONTINUE
      NN=MIN0(N,146)
      WRITE(GRDFIL,50) IDY,IDX,N,1,X,Y0,ZBASE,ZMIN,ZMAX,(U(I,J),J=1,NN)
  50  FORMAT(4I6,5D24.15,146F7.2)
      IF (N.LE.NN) GOTO 80
      WRITE(GRDFIL,60) (U(I,J),J=NN+1,N)
  60  FORMAT(170F7.2)
  80  CONTINUE
      RETURN
      END
