      SUBROUTINE SNKDIG(OUTFIL,U,IW,IV,M,N)
C
C USES SUBROUTINE WRGRDS TO WRITE TO OUTFIL PORTIONS OF THE
C GRIDS U, IW AND IV AROUND EACH SINK FOR PROBLEM DIAGNOSIS.
C
      INTEGER   OUTFIL,M,N
      REAL      U(M,N)
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
      INTEGER   I,J
C
C---LOOP THROUGH SINKS---
      DO 10 J=1,N
      DO 10 I=1,M
      IF (IW(I,J).GT.1) CALL WRGRDS(OUTFIL,U,IW,IV,M,N,I,J,6)
  10  CONTINUE
      RETURN
      END
      SUBROUTINE WRGRDS(OUTFIL,U,IW,IV,M,N,IK,JK,KK)
C
C WRITES PORTIONS OF GRIDS U, IW AND IV TO OUTFIL FOR
C PROBLEM DIAGNOSIS.
C
      INTEGER          OUTFIL,M,N,IK,JK,KK
      REAL             U(M,N)
      DOUBLE PRECISION X0,Y0,X1,Y1,H
      INTEGER*2        IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER          I,J,K,I1,J1,I2,J2
      DOUBLE PRECISION X,Y
C
      COMMON/LIMIT2H/X0,Y0,X1,Y1,H
C
      X=X0 + (IK - 1)*H
      Y=Y0 + (JK - 1)*H
      IF (X.LT.X0 .OR. X.GT.X1 .OR. Y.LT.Y0 .OR. Y.GT.Y1) RETURN
      IF (KK.GE.6) WRITE(OUTFIL,10)
  10  FORMAT('1')
      WRITE(OUTFIL,20) IK,JK,X,Y
  20  FORMAT(' WRGRDS CALLED    I,J =',2I5,'    X,Y =',2F14.3/)
      K=MIN0(KK,6)
      I1=MAX0(IK-K,1)
      I2=MIN0(IK+K,M)
      J1=MAX0(JK-K,1)
      J2=MIN0(JK+K,N)
      WRITE(OUTFIL,40) (I,I=I1,I2)
      WRITE(OUTFIL,25)
  25  FORMAT(' ')
      DO 50 J=J2,J1,-1
      WRITE(OUTFIL,30) J,(U(I,J),I=I1,I2)
  30  FORMAT(I9,13F9.3)
      WRITE(OUTFIL,40) (IW(I,J),I=I1,I2)
      WRITE(OUTFIL,40) (IV(I,J),I=I1,I2)
  40  FORMAT(9X,13I9)
  50  CONTINUE
      RETURN
      END
      SUBROUTINE WRSTRM(OUTFIL,DIGFIL,U,IW,IV,M,N,X0,Y0,H,IP,JP,NW,NM)
C
C WRITES ORDERED CHAIN INFORMATION AS HELD BY THE GRID IV
C TO DIGFIL.  THE DIRECTION OF THE CHAINS IS OPTIMISED FOR
C PLOTTING.
C
      INTEGER          OUTFIL,DIGFIL,M,N,IP(8),JP(8),NW,NM
      REAL             U(M,N)
      DOUBLE PRECISION X0,Y0,H
      INTEGER*2        IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER          I,J,K,M1,M2,M3
      DOUBLE PRECISION A1,B1,A2,B2
      CHARACTER*40     SFMT
C
C---SET UP OUTPUT FORMAT---
      WRITE(SFMT,10) NW,NM
  10  FORMAT('(4F',I2,'.',I1,')')
C
C---WRITE STREAM POINTERS---
      DO 30 J=1,N
      IF (MOD(J,2).EQ.1) THEN
         M1=1
         M2=M
         M3=1
      ELSE
         M1=M
         M2=1
         M3=-1
      ENDIF
      DO 30 I=M1,M2,M3
      K=IV(I,J)
      IF (K.LE.0) GOTO 30
      WRITE(DIGFIL,20) 2
  20  FORMAT(10X,I10)
      A1=X0 + (I-1)*H
      B1=Y0 + (J-1)*H
      A2=A1 + IP(K)*H
      B2=B1 + JP(K)*H
      IF (IP(K).NE.0) THEN
         IF (IP(K)*M3.LT.0) THEN
            WRITE(DIGFIL,SFMT,ERR=50) A2,B2,A1,B1
         ELSE
            WRITE(DIGFIL,SFMT,ERR=50) A1,B1,A2,B2
         ENDIF
      ELSE
         IF (JP(K).LT.0) THEN
            WRITE(DIGFIL,SFMT,ERR=50) A2,B2,A1,B1
         ELSE
            WRITE(DIGFIL,SFMT,ERR=50) A1,B1,A2,B2
         ENDIF
      ENDIF
  30  CONTINUE
      RETURN
C
C---ERROR CONDITION---
  50  WRITE(OUTFIL,55) SFMT
  55  FORMAT(/' WRSTRM - ERROR WRITING STREAM DIAGNOSTICS'/
     +        ' RUN TIME FORMAT = ',A40)
      STOP
      END
      SUBROUTINE WRIWIV(IWFIL,IVFIL,IW,IV,M,N)
C
C WRITES INDICATOR GRIDS IW AND IV TO UNITS IWFIL AND IVFIL.
C
      INTEGER   IWFIL,IVFIL,M,N
      INTEGER*2 IW(0:M+1,0:N+1),IV(M,N)
C
C---LOCAL VARIABLES---
      INTEGER   I,J
C
C---WRITE IW---
      DO 10 J=0,N+1
      WRITE(IWFIL) (IW(I,J),I=0,M+1)
  10  CONTINUE
C
C---WRITE IV---
      DO 20 J=1,N
      WRITE(IVFIL) (IV(I,J),I=1,M)
  20  CONTINUE
      RETURN
      END
