/**************************************************************************
NAME: DOQUNITREE
 Looks for doq files with extension of .3 in the /sg1/doq/unitree
 directory, gzips the files and writes them out to unitree.   
 Files that have problems
 will be moved to the /sg1/doq/unitree/error directory.
***************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include "las.h"

main(argc, argv)
  int   argc;
  char *argv[];
{

long 	status=0;               /* Status indicator       	*/

char	callstr[256];		/* system call string		*/
char  	infile[64];		/* input file to process	*/
char	logfile[CMLEN];		/* processing logfile		*/

char dir[256];   	/* Directory portion of the file specification  */
char ext[256];    	/* Extension portion of the file specification  */
char filename[256];	/* User supplied file specification             */
char root[256];  	/* Root portion of the file specification       */


/* Grab the input doq file name
-----------------------------------*/
sscanf(argv[1],"%s",infile);
strcpy(logfile,"/sg1/doq/unitree/logfile.doq");

/* break up the input file name to strip root
----------------------------------------------*/
c_splitname(infile,dir,root,ext);
printf("doqunitree: Infile=%s \n",infile);

/* Move the files out to the unitree
------------------------------------*/
sprintf(callstr,"mv /sg1/doq/unitree/%s.%s /sg1/doq/unitree/%s",root,ext,root);
system(callstr);
/*sprintf(callstr,"gzip /sg1/doq/unitree/%s",root);
system(callstr);*/ 
sprintf(callstr,"umput -d /doqq/incoming -f9 -vp /sg1/doq/unitree/%s >> %s",
		root,logfile);
status = system(callstr);
if (status != 0)
  {
  sprintf(callstr,"mv /sg1/doq/unitree/%s /sg1/doq/unitree/error",root);
  status = system(callstr);
  }
else
  {
  /*sprintf(callstr,"gunzip /sg1/doq/unitree/%s.gz",root);
  status = system(callstr);*/
  sprintf(callstr,"mv /sg1/doq/unitree/%s /sg1/doq/dlt/%s.4",root,root);
  status = system(callstr);
  }
}
