/*
   pgm2ppm.c
   Program to convert 3 PGM files to a PPM file
   Input files have a pgm structure 
*/

#include <stdio.h>

main(argc, argv)
	int             argc;
	char            *argv[];
{	
	FILE		*pgm1;	
	FILE		*pgm2;	
	FILE		*pgm3;
	FILE		*ppm;
        int             i, j;
        int             prec;
        int             w1, w2, w3, h1, h2, h3;
	int             nl;
	int             ns;
        char            c;

	unsigned char   val ;

       if (argc != 5)
          { printf("Usage: pgm2ppm <File 1> <File 2> <File 3>  <Out PPM>\n");
           exit(-1); }

    /* open files */
      if ((pgm1 = fopen(argv[1], "rb")) == NULL) 
	 { printf("Can't open %s as first pgm file \n", argv[1]); exit(-1);}
      if ((pgm2 = fopen(argv[2], "rb")) == NULL) 
	 { printf("Can't open %s as second pgm file \n", argv[1]); exit(-1);}
      if ((pgm3 = fopen(argv[3], "rb")) == NULL) 
	 { printf("Can't open %s as third pgm file \n", argv[1]); exit(-1);}
      if ((ppm = fopen(argv[4], "wb")) == NULL) 
	 { printf("Can't open %s resultant ppm file \n", argv[3]); exit(-1);}

      printf("PGM2PPM with %s + %s + %s => %s\n",
               argv[1],argv[2],argv[3],argv[4]);
/* Checkout First file   */

      if (getc(pgm1) != 'P') 
         { printf("First file not a PPM file");  exit(-1); }
      c = getc(pgm1);
         switch (c) {
            case '5':			/* it's a PGM file */
               break;
            default:
               printf("First file not a PGM file");
               exit(-1);
         }
      if (fscanf(pgm1, "\n%d %d\n%d\n", &w1, &h1, &prec) != 3) {
          printf("ns %d  nl %d  prec %d \n",w1 ,h1 ,prec);
          printf("First file not a PGM file\n");
          exit(-1);
      }
      if (w1 <= 0 || h1 <= 0 || prec != 255) {
         printf("ns %d  nl %d  prec %d \n",w1,h1,prec);
         printf("First file not a PGM file");
         exit(-1);
      }
      ns = w1;
      nl = h1;

/* Checkout Second file   */

      if (getc(pgm2) != 'P') 
         { printf("Second file not a PPM file");  exit(-1); }
      c = getc(pgm2);
      switch (c) {
           case '5':			/* it's a PGM file */
             break;
           default:
             printf("Second file not a PGM file");
             exit(-1);
           }
      if (fscanf(pgm2, "\n%d %d\n%d\n", &w2, &h2, &prec) != 3) {
          printf("ns %d  nl %d  prec %d \n",w2 ,h2 ,prec);
          printf("Second file not a PGM file\n");
          exit(-1);
      }
      if (w2 <= 0 || h2 <= 0 || prec != 255) {
         printf("ns %d  nl %d  prec %d \n",w2,h2,prec);
         printf("Second file not a PGM file");
         exit(-1);
      }
      if (w2 != ns || h1 != nl) {
         printf("Different nl or ns \n");
         printf("First  file ns %d  nl %d  prec %d \n",w1,h1,prec);
         printf("Second file ns %d  nl %d  prec %d \n",w2,h2,prec);
         exit(-1);
      }

/* Checkout Third file   */

      if (getc(pgm3) != 'P') 
         { printf("Third file not a PPM file");  exit(-1); }
      c = getc(pgm3);
      switch (c) {
           case '5':			/* it's a PGM file */
             break;
           default:
             printf("Third file not a PGM file");
             exit(-1);
         }
      if (fscanf(pgm3, "\n%d %d\n%d\n", &w3, &h3, &prec) != 3) {
          printf("ns %d  nl %d  prec %d \n",w3 ,h3 ,prec);
          printf("Third file not a PGM file\n");
          exit(-1);
      }
      if (w3 <= 0 || h3 <= 0 || prec != 255) {
         printf("ns %d  nl %d  prec %d \n",w3,h3,prec);
         printf("Third file not a PGM file");
         exit(-1);
      }
      if (w3 != ns || h3 != nl) {
         printf("Different nl or ns \n");
         printf("First  file ns %d  nl %d \n",w1,h1);
         printf("Second file ns %d  nl %d \n",w2,h2);
         printf("Third  file ns %d  nl %d \n",w3,h3);
         exit(-1);
      }

/*  Initialize Output file  */

      fprintf(ppm,"P6\n%d %d\n%d\n", ns, nl, 255);

      for (i=1;i<=nl;i++) {
         for (j=1;j<=ns;j++) {
            val = getc(pgm1);
            putc(val,ppm);
            val = getc(pgm2);
            putc(val,ppm);
            val = getc(pgm3);
            putc(val,ppm);
        }
        if ((i%200)==0) printf("Line %d\n",i);
     }

     fclose(pgm1);
     fclose(pgm2);
     fclose(pgm3);
     fclose(ppm);
     exit(0);
}
