#include <stdio.h>
#include <malloc.h>
#include <math.h>

#define half(n) ((n)%2==0?(n)/2:(n+1)/2)
float sm[] = {
0.34150635094610,
0.59150635094611,
0.15849364905389,
-0.0915063509461
};


main(argc,argv)
int argc; char *argv[];
{
  register int nrows, ncols, r, c;
  int i, j, cnt, level;
  int nl, ns, prec;
  int hf, maxlevel, size;
  int even_row_flag, even_col_flag;
  unsigned char *buf, *bufptr;
  float *op, *np;
  float *tmp, *tp;
  float fpix, *fbuf, *fbufptr;
  char pix;
  void byte_row_convolve();
  void row_convolve();
  void col_convolve();
  void fast_col_convolve();
  char truncate();
  void putpic();

  if (getc(stdin) != 'P')
      fprintf(stderr,"Not a PGM file");
   c = getc(stdin);
   switch (c) {
      case '5':			/* it's a PGM file */
         break;
      default:
         fprintf(stderr,"Not a PGM file");
         break;
    }
  if (fscanf(stdin, "\n%d %d\n%d\n", &ns, &nl, &prec) != 3) {
    fprintf(stderr,"ns %d  nl %d  prec %d \n",ns ,nl ,prec);
    fprintf(stderr,"Not a PGM file\n");
  }
  if (ns <= 0 || nl <= 0 || prec != 255) {
    fprintf(stderr,"ns %d  nl %d  prec %d \n",ns,nl,prec);
    fprintf(stderr,"Not a PGM file");
  }
  fprintf(stderr,"Wave Input ns=%d  nl=%d\n",ns,nl);
  nrows = nl;
  ncols = ns;
  
  maxlevel = atoi(argv[1]);
  even_row_flag = (nrows%2?0:1);
  even_col_flag = (ncols%2?0:1);

  ns = (ncols-1)/pow(2,maxlevel) + 1;
  nl = (nrows-1)/pow(2,maxlevel) + 1;
  fprintf(stdout,"P5\n%d %d\n%d\n",ns, nl, 255);
  fprintf(stderr,"Wave Output ns=%d nl=%d maxlevel=%d\n", ns, nl, maxlevel);

  cnt = 0;
   /* malloc space for one row of image */
  buf = (unsigned char *) malloc(ncols*sizeof(char));
  fbuf = (float *) malloc(ncols*sizeof(float));

   /* malloc temp space for convolved rows */
  tmp = (float *) malloc(nrows*half(ncols)*sizeof(float));

  /* malloc space for first level */
  op = (float *) malloc((half(ncols)+2)*(half(nrows)+2)*sizeof(float));
  hf = half(ncols);
  
  /* read in image one row at a time and transform rows */
    while(fread(buf, sizeof(char), ncols, stdin) != 0)
    {
      for(i=ncols,bufptr=buf,fbufptr=fbuf;i>0;i--)
	*(fbufptr++) = *(bufptr++);
      row_convolve(tmp + cnt, fbuf, ncols, even_row_flag);
      cnt+=hf;
    }

  fast_col_convolve(op, tmp, nrows, hf, even_col_flag);

  /* do rest of decomposition */
   for(level=1; level<maxlevel; level++) 
     {  
       nrows = half(nrows); 
       ncols = half(ncols);
       even_row_flag = (nrows%2?0:1);
       even_col_flag = (ncols%2?0:1);
       hf = half(ncols);
       size = nrows*ncols;
       for(r=0,i=0; i<size; r+=hf,i+=ncols)
	 row_convolve(tmp + r, op + i, ncols, even_row_flag);
       fast_col_convolve(op, tmp, nrows, hf, even_col_flag);

     }

  nrows = half(nrows); 
  ncols = half(ncols);
  
  putpic(op, nrows, ncols); 
}

void fast_col_convolve(targ, src, rows, cols, flag)
float *src, *targ;
int rows, cols, flag;
{
  int i, j, r, c;
  int shift;
  float *srcptr, *targptr, *smptr;
  void replace_row();
  void add_to_row();
  
  for(shift=0, srcptr=src, targptr = targ;
      shift<rows-4;
      shift+=2, srcptr-=(2*cols), targptr += cols)
    {
      /* replace first row */
      smptr = sm;
      replace_row(targptr, srcptr, *(smptr++), cols);
      /* add in remaining rows */
      for(i=1,srcptr+=cols;i<4;i++,srcptr+=cols)
	{
	  add_to_row(targptr, srcptr, *(smptr++), cols);
	}
    }

  if(flag==1) 
   {
     /* even number of cols */
     smptr = sm;
     replace_row(targptr, srcptr, *(smptr++), cols);

     /* add in remaining rows */
      for(i=1,srcptr+=cols,targptr+=cols;i<4;i++,srcptr+=cols)
	add_to_row(targptr, srcptr, *(smptr++), cols);

     srcptr -= 2*cols;
     targptr += cols;
     
     /* replace first row */
     smptr = sm;
     replace_row(targptr, srcptr, *(smptr++), cols);

     /* add in next row */
     srcptr+=cols;
     add_to_row(targptr, srcptr, *(smptr++), cols);

     /* next two rows wrap around */
     for(i=2, srcptr=src;i<4;i++, srcptr+=cols)
       add_to_row(targptr, srcptr, *(smptr++), cols);
   }
 else
   {
     /* odd number of columns */
     /* replace first row */
     smptr = sm;
     replace_row(targptr, srcptr, *(smptr++), cols);

     /* add in next two rows */
     for(i=1,srcptr+=cols,targptr+=cols;i<3;i++,srcptr+=cols)
       add_to_row(targptr, srcptr, *(smptr++), cols);
         
     /* wrap last row around */
     add_to_row(targptr, src, *(smptr), cols);

     srcptr -= cols;
     targptr += cols;
     
     /* replace first row */
     smptr = sm;
     replace_row(targptr, srcptr, *(smptr++), cols);

     /* wrap around next three rows */
     for(i=2,srcptr=src;i<4;i++,srcptr+=cols)
       add_to_row(targptr, src, *(smptr++), cols);
   }
}

void replace_row(targptr, srcptr, smcoeff, cols)
float *targptr, *srcptr, smcoeff;
int cols;
{
  int c;
  float *t, *s;
  for(c=0,t=targptr,s=srcptr;c<cols;c++,t++,s++)
    *(t) = smcoeff* *(s);
}

void add_to_row(targptr, srcptr, smcoeff, cols)
float *targptr, *srcptr, smcoeff;
int cols;
{
  int c;
  float *t, *s;
  for(c=0,t=targptr,s=srcptr;c<cols;c++,t++,s++)
    *(t) += smcoeff* *(s);
}


void putpic(imptr, rows, cols)
float *imptr;
int rows, cols;
{
  int i,j;
  float fpix;
  char truncate();
  for(i=0; i<rows; i++)
    for(j=0; j<cols; j++)
      {
	fpix =  (*(imptr + i*cols +j));
	if(fpix<0)
	  putchar(0);
	else
	  {
	    if(fpix>255)
	      putchar(255);
	    else
	      putchar(truncate(fpix));
	  }
      }
}



void col_convolve(targ, src, nrows, ncols, flag)
float *targ, *src;
int nrows, ncols, flag;
{
  register int i, shift, cnt;
  float *srcptr, *targptr;
  float *smptr, t;
  for(shift=0, targptr=targ; shift<nrows-4; shift+=2, targptr+=ncols)
    {
      for(i=0,t=0.0, smptr=sm, srcptr=src+shift*ncols; i<4; 
	  i++, srcptr+=ncols, smptr++)
	t += *(smptr) * *(srcptr);
      *(targptr) = t;
    }


  if(flag==1) /* even number of columns */
    {
      *(targptr) =    sm[0]* *(src + shift*ncols) +
                      sm[1]* *(src + (shift+1)*ncols) +
		      sm[2]* *(src + (shift+2)*ncols) +
	              sm[3]* *(src + (shift+3)*ncols);
  
      shift += 2;
      *(targptr + ncols) = sm[0]* *(src + shift*ncols) +
                           sm[1]* *(src + (shift+1)*ncols) +
     			   sm[2]* *(src) +
			   sm[3]* *(src + ncols);
    }
  else /* odd number of columns */
    {
      *(targptr) =    sm[0]* *(src + shift*ncols) +
                      sm[1]* *(src + (shift+1)*ncols) +
		      sm[2]* *(src + (shift+2)*ncols) +
	              sm[3]* *(src);
  
      shift += 2;
      *(targptr + ncols) = sm[0]* *(src + shift*ncols) +
                           sm[1]* *(src) +
     			   sm[2]* *(src + ncols) +
			   sm[3]* *(src + 2*ncols);
    }

}


void row_convolve(targ, src, ncols, flag)
float *targ, *src;
int ncols, flag;
{
  register int i, shift, cnt;
  float t,*srcptr,*targptr;
  float *smptr;

  for(shift=0, targptr=targ ; shift<ncols-4; shift+=2, targptr++)
    {
      for(i=0,t=0.0, smptr=sm, srcptr=src+shift; i<4; i++, srcptr++, smptr++)
	t += *(smptr) * *(srcptr);
      *(targptr) = t;
    }

 if(flag==1) /* even number of rows */
    {
      *(targptr++) =      sm[0]* *(src+ shift) +
	                  sm[1]* *(src+ shift+1) +
	                  sm[2]* *(src+ shift+2) +
		          sm[3]* *(src+ shift+3);

      shift += 2;
      *(targptr) = sm[0]* *(src+ shift) +
                   sm[1]* *(src+ shift+1) +
		   sm[2]* *(src) +
		   sm[3]* *(src + 1);
    }
  else
    {
      *(targptr++) =      sm[0]* *(src+ shift) +
	                  sm[1]* *(src+ shift+1) +
	                  sm[2]* *(src+ shift+2) +
		          sm[3]* *(src);

      shift += 2;
      *(targptr) = sm[0]* *(src+ shift) +
                   sm[1]* *(src) +
		   sm[2]* *(src + 1) +
		   sm[3]* *(src + 2);
    }

  
}

char truncate(pix)
     float pix;
{
  return (char) floor(pix+.5);
}
  
