/*******************************************************************************
NAME:                           FF123B

PURPOSE:      Read an fast format header file return the block size. 

PROGRAM HISTORY:
PROGRAMMER              DATE            REASON
----------              ----            ------
D. Etrheim              10/93          Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS

*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "header.h"
#include "fhdr.h"

int main
(void)
{
struct PARBLK parblk;           /* TAE parameter block */

char hname[CMLEN];              /* Host name of input file */
char header[HEADER_SIZE];       /* buffer containing the header file */
char tstr[80];                  /* temp buffer for return values */

long blksiz;            /* block size */
long mode = IREAD;      /* file access */
long std_out;           /* standard out */
long zero = 0;          /* value of zero */

/* Initialization */
c_inlas(&parblk,&std_out);    

/* Get the input file name */
if (c_getnam(&parblk,"INFILE",&zero,hname,"fhdr",&mode) != E_SUCC)
    c_lasmsg(TRUE,"ff123-fatal","Fatal error encountered");

/* Open and read header file */
mode = IREAD;
if (c_open_header(header,hname,&mode) != E_SUCC)
    c_lasmsg(TRUE,"ff123-fatal","Fatal error encountered");

/* Only worry about version B for now */
c_fhdrrd(header,117,tstr);
if ((strncmp(tstr,"B",1) == 0) || (strncmp(tstr,"C",1) == 0))
    {
    /* Get blocking size */
    c_fhdrrd(header,99, &blksiz);
    }
else
    c_lasmsg(TRUE,"ff123-format","Unexpected format");

/* Return value to TAE */
if (q_intg(&parblk,"BLKSIZ",1, &blksiz, P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE,"ff123-pass","Error passing variables to TAE");

if (q_out(&parblk) != SUCCESS)
    c_lasmsg(TRUE,"ff123-pass","Error passing variables to TAE");

/* Done */
z_exit(1," ");

return EXIT_SUCCESS;

}
