/*******************************************************************************
NAME:                           FF123H

PURPOSE:      Read an fast format header file create a new header with
              proper band available field. 

PROGRAM HISTORY:
PROGRAMMER              DATE            REASON
----------              ----            ------
D. Etrheim              10/93          Initial development
D. Etrheim		 3/97          Update the tape spanning flag

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

PROJECT:        LAS

*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "header.h"
#include "fhdr.h"

int main
(void)
{
struct PARBLK parblk;           /* TAE parameter block */
struct VARIABLE *val;           /* pointer to a TAE variable within v-block  */

char hname[CMLEN];              /* Host name of input file */
char header[HEADER_SIZE];       /* buffer containing the header file */
char oname[CMLEN];              /* Host name of output file */
char tstr[80];                  /* temp buffer for return values */

long mode = IREAD;      /* file access */
long seq;               /* output sequence number */
long std_out;           /* standard out */
long zero = 0;          /* value of zero */

/* Initialization */
c_inlas(&parblk,&std_out);    

/* Get the input file name */
if (c_getnam(&parblk,"INFILE",&zero,hname,"fhdr",&mode) != E_SUCC)
    c_lasmsg(TRUE,"ff123-fatal","Fatal error encountered");

/* Get the output file name */
mode = IWRITE;
if (c_getnam(&parblk,"OUTFILE",&zero,oname,"fhdr",&mode) != E_SUCC)
    c_lasmsg(TRUE,"ff123-fatal","Fatal error encountered");

/* Get the sequence number */
val = p_find(&parblk,"seq");
seq = IVAL(*val,0);

/* Open and read header file */
mode = IREAD;
if (c_open_header(header,hname,&mode) != E_SUCC)
    c_lasmsg(TRUE,"ff123-fatal","Fatal error encountered");

/* Only worry about version B for now */
c_fhdrrd(header,117,tstr);
if ((strncmp(tstr,"B",1) != 0) && (strncmp(tstr,"C",1) != 0))
    c_lasmsg(TRUE,"ff123-format","Unexpected format");

/* We need to create a new header file for the output tape that
contains the actual bands on it */
if (seq == 1)
    {
    strcpy(tstr,"123");
    c_fhdrup(header,95,tstr);
    strcpy(tstr,"1/3");
    c_fhdrup(header,35,tstr);
    }
else if (seq == 2)
    {
    strcpy(tstr,"456");
    c_fhdrup(header,95,tstr);
    strcpy(tstr,"2/3");
    c_fhdrup(header,35,tstr);
    }
else
    {
    strcpy(tstr,"7");
    c_fhdrup(header,95,tstr);
    strcpy(tstr,"3/3");
    c_fhdrup(header,35,tstr);
    }

/* Open and write header file */
mode = IWRITE;
if (c_open_header(header,oname,&mode) != E_SUCC)
    c_lasmsg(TRUE,"ff123-fatal","Fatal error encountered");

/* Done */
z_exit(1," ");

return EXIT_SUCCESS;

}
