      SUBROUTINE CALPAR(CALCOR,PARMS,LOGFIL)
***********************************************************************
*
*     NAME- CALPAR                         EXPIRES- 12/31/99
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     This subroutine is a driver for computing an 8-parameter
*     transformation from the calculated coordinates defined by CALCOR
*     to a best fit of the observed map coordinates defined by OBSCOR
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
      DOUBLE PRECISION  EQN(8,9)
     .,                 PARMS(8)
     .,                 ZERO
     .,                 UT1(8)
     .,                 UT2(8)
      INTEGER           I
     .,                 J
     .,                 X
     .,                 Y
     .,                 CALCOR(2,8)
     .,                 IRES(2,8)
     .,                 RMSEX
     .,                 RMSEY
C      REAL		XX
C     .,			YY
      CHARACTER         ANAMES(8)*2
      CHARACTER         LOGFIL*100 
      PARAMETER        (ZERO = 0.D0)
      DATA              ANAMES /'NW','N1','N2','NE','SE','S1','S2','SW'/
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     zero the linear equations array
*
      DO 200 I = 1,8
         DO 100 J = 1,9
            EQN(I,J) = ZERO
  100    CONTINUE
  200 CONTINUE
*
*     compute values for the transformation parameters
*
      DO 300 I = 1,8
        CALL CMPMTX(CALCOR(1,I),CALCOR(2,I),CALCOR(1,I),CALCOR(2,I),EQN)
  300 CONTINUE
*
*     find the inverse of the EQN matrix
*
      CALL INVRT(EQN,8,UT1,UT2,8)
*
*     multiply the EQN matrix by column 9 to find solution
*
      DO 500 I = 1,8
         PARMS(I) = 0.0D0
         DO 400 J = 1,8
            PARMS(I) = PARMS(I) + EQN(I,J) * EQN(J,9)
  400    CONTINUE
  500 CONTINUE
*
*     compute the residuals and the Root-Mean-Square errors of the
*     transformation
*
      RMSEX = 0
      RMSEY = 0
      DO 600 I=1,8
         CALL TRANS(CALCOR(1,I),CALCOR(2,I),PARMS,X,Y)
         IRES(1,I) = CALCOR(1,I) - X
         RMSEX = RMSEX + IRES(1,I)**2
         IRES(2,I) = CALCOR(2,I) - Y
         RMSEY = RMSEY + IRES(2,I)**2
  600 CONTINUE
      RMSEX = NINT(SQRT(REAL(RMSEX)/8.0))
      RMSEY = NINT(SQRT(REAL(RMSEY)/8.0))

*  list  manuscript/file scale factor
*
      XX=(CALCOR(1,5)-CALCOR(1,1))/1000.0
      YY=(CALCOR(2,1)-CALCOR(2,5))/1000.0
******
*     open the log file
******
      OPEN(UNIT = 8
     .,    FILE = LOGFIL 
     .,    STATUS = 'NEW'
     .,    FORM = 'FORMATTED')

      WRITE(8,'(//'' XLEN:= '',F8.4,'' YLEN:= '',F8.4)')XX,YY

      CLOSE(UNIT = 8)

      RETURN
      END
