      SUBROUTINE CIRCL1(XLOC,YLOC,RAD,NPTS)
***********************************************************************
*
*     NAME- CIRCL1                         EXPIRES- 12/31/99
*
*     LANGUAGE- FORTRAN     TYPE- SUBROUTINE
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     This subroutine plots a polygonal approximation of a circle with
*     the specified diameter and number of points on the CalComp
*     plotter.
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
      REAL      PI
     .,         RAD
     .,         XLOC
     .,         YLOC
     .,         SEGARC
     .,         ARC
      INTEGER   I
     .,         NPTS
      PARAMETER(PI   = 3.1415926)
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     set current arc length to pi/2 (top of circle)
*
      ARC = PI/2.0
*
*     calculate radian arc of segment between plot points
*
      SEGARC = 2.0 * PI / NPTS
*
*     set initial pen position and move pen
*
      CALL PLOT(XLOC,YLOC + RAD,3)
*
*     plot each segment
*
      DO 100 I=1,NPTS
         ARC = ARC + SEGARC
         CALL PLOT(XLOC + COS(ARC) * RAD,YLOC + SIN(ARC) * RAD,2)
  100 CONTINUE
      RETURN
      END
