      SUBROUTINE CMPMTX(CALX,CALY,OBSX,OBSY,EQN)
***********************************************************************
*
*     NAME- CMPMTX                         EXPIRES- 12/31/99
*
*     LANGUAGE- FORTRAN     TYPE- SUBROUTINE
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     This subroutine evaluates the contribution of one point to the
*     8 by 9 matrix of normal equations for computations of 
*     values of the 8 parameter film shrinkage transformation.
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
      DOUBLE PRECISION EQN(8,9)
     .,                AM(2,8)
     .,                ZERO
     .,                ONE
     .,                DPCALX
     .,                DPCALY
     .,                DPOBSX
     .,                DPOBSY
      INTEGER          I
     .,                J
     .,                CALX
     .,                CALY
     .,                OBSX
     .,                OBSY
      PARAMETER       (ZERO = 0.D0
     .,                ONE  = 1.D0)
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
      DPCALX = DBLE(CALX)
      DPCALY = DBLE(CALY)
      DPOBSX = DBLE(OBSX)
      DPOBSY = DBLE(OBSY)
      AM(1,1) = DPCALX
      AM(1,2) = DPCALY
      AM(1,3) = ONE
      AM(1,4) =-DPOBSX * DPCALX
      AM(1,5) =-DPOBSX * DPCALY
      AM(1,6) = ZERO
      AM(1,7) = ZERO
      AM(1,8) = ZERO
      AM(2,1) = ZERO
      AM(2,2) = ZERO
      AM(2,3) = ZERO
      AM(2,4) =-DPCALX * DPOBSY
      AM(2,5) =-DPCALY * DPOBSY
      AM(2,6) = DPCALX
      AM(2,7) = DPCALY
      AM(2,8) = ONE
      DO 200 I = 1,8
         DO 100 J = 1,8
            EQN(I,J) = EQN(I,J) + AM(1,I)*AM(1,J) + AM(2,I)*AM(2,J)
  100    CONTINUE
         EQN(I,9) = EQN(I,9) + AM(1,I)*DPOBSX + AM(2,I)*DPOBSY
  200 CONTINUE
      RETURN
      END
