      PROGRAM FLIGHTLN
*
*     PURPOSE:
*        To produce flight line files to be plotted on a map by the
*     CalComp flatbed plotter.
*
*     FILE REFERENCES:  logical unit 7 - CalComp plot file output
*
*     PROGRAM HISTORY:
*     Version     Date   	Author	   Code/Contr.	Change Request
*     -------	  ----		------	   -----------	--------------
*        1      07/01/87        J.R. Allen EDC          PRF 4076
*	 2	05/15/92	T. Mittan  EDC		Conversion to 5.0
*
*
*     PROJECT:  TAE
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
	include 'las.fin'

      DOUBLE PRECISION
     .          TRNPAR(8)
     .,         INPAR(15)
     .,         PRJPAR(15)
      REAL      MAPSPC(4)
     .,         WINDOW(4)
     .,         pltcr(2)
      INTEGER   SCALE
     .,		LEN
      CHARACTER MAPNAM*30
     .,		FILARR(2)*256
     .,		LOGFIL(1)*100
      DATA      INPAR/15*0.D0/
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     read parameters
*
      CALL GETPAR(MAPSPC,WINDOW,SCALE,FILARR,LOGFIL(1),MAPNAM,LEN)
*
*     initialize the plot file and logical UNIT number  = 9
*

      CALL PLOTS(0,0,7)
*
*     move to origin and select pen
*
      CALL PLOT(0,0,3)
      CALL NEWPEN(1)
*
*     determine transformation and projection parameters
*

  100 CALL FNDPAR(MAPSPC,SCALE,TRNPAR,PRJPAR,LOGFIL)
*
*     plot corners and labels
*
      CALL CORNER(MAPSPC,SCALE,TRNPAR,PRJPAR,pltcr)
*
*     plot flight line label
*
  200 CALL HORSCL(WINDOW,SCALE,TRNPAR,PRJPAR)
*
*     plot lines
*
      CALL LINES(WINDOW,SCALE,TRNPAR,PRJPAR)
*
*     see if more flight lines are to be plotted on this map
*
      CALL MORLNS(MAPSPC,WINDOW)
*
      IF (WINDOW(1) .NE. 0.0) THEN
*
*        do more flight lines
*
         GOTO 200
      END IF
*
*     close files and end
*
      CALL PLOT(0.0,0.0,999)
      CLOSE(UNIT = 7)
      CALL COMPLT('FLIGHTLN',FILARR,2)
      END
