      SUBROUTINE FNDPAR(MAPSPC,SCALE,TRNPAR,PRJPAR,LOGFIL)
************************************************************************
*
*     NAME- FNDPAR                         EXPIRES- 12/31/99
*
*     LANGUAGE- FORTRAN     TYPE- SUBROUTINE
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     Finds transformation parameters and Transverse Mercator
*     projection parameters of map.
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
      DOUBLE PRECISION
     .          CORDIN(2,8)
     .,         COORDI(2)
     .,         COORDO(2)
     .,         INPAR(15)
     .,         PRJPAR(15)
     .,         TRNPAR(8)
      REAL      MAPSPC(4)
     .,         MINUTE
     .,         MAPCNT
      INTEGER   ERRFLG
     .,         INTYPE
     .,         INZONE
     .,         INUNIT
     .,         INSPH
     .,         IPR
     .,         JPR
     .,         IOTYPE
     .,         IOZONE
     .,         IOUNIT
     .,         IOSPH
     .,         CALCOR(2,8)
     .,         I
     .,         SCALE
     .,         MININT
      CHARACTER ERRSTR*80
      CHARACTER LOGFIL*100
      CHARACTER efile*100
      CHARACTER pfile*100
      CHARACTER fn27*100
      CHARACTER fn83*100
      DATA      INPAR/15*0.D0/
     .,         INTYPE/0/
     .,         INZONE/62/
     .,         INUNIT/4/
     .,         INSPH/0/
     .,         IPR/3/
     .,         JPR/3/
     .,         IOTYPE/9/
     .,         IOZONE/62/
     .,         IOUNIT/1/
     .,         IOSPH/0/
      SAVE      IOZONE
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     find projection and transformation parameters
*
      PRJPAR(3) = .9996
*
*     compute central latitude in PAKDMS format
*
      MAPCNT = MAPSPC(1) + (MAPSPC(3)/2)
      MINUTE = (MAPCNT - INT(MAPCNT)) * 60
      MININT = INT(MINUTE)
      PRJPAR(6) = INT(MAPCNT)       * 1000000.D0 +
     .            MININT            * 1000.D0    +
     .            (MINUTE - MININT) * 60.D0
*
*     compute central longitude in PAKDMS format
*
      MAPCNT = -(MAPSPC(2) + (MAPSPC(4)/2))
      MINUTE = (MAPCNT - INT(MAPCNT)) * 60
      MININT = INT(MINUTE)
      PRJPAR(5) = -(INT(MAPCNT)       * 1000000.D0 +
     .              MININT            * 1000.D0    +
     .              (MINUTE - MININT) * 60.D0)
*
*     set array of geographic transformation control points
*     Northwest
*
      CORDIN(1,1) = MAPSPC(2)
      CORDIN(2,1) = MAPSPC(1) + MAPSPC(3)
*
*     Northwest internal
*
      CORDIN(1,2) = MAPSPC(2) + (.25D0 * MAPSPC(4))
      CORDIN(2,2) = CORDIN(2,1)
*
*     Northeast internal
*
      CORDIN(1,3) = MAPSPC(2) + (.75D0 * MAPSPC(4))
      CORDIN(2,3) = CORDIN(2,1)
*
*     Northeast
*
      CORDIN(1,4) = MAPSPC(2) + MAPSPC(4)
      CORDIN(2,4) = CORDIN(2,1)
*
*     Southeast
*
      CORDIN(1,5) = CORDIN(1,4)
      CORDIN(2,5) = MAPSPC(1)
*
*     Southeast internal
*
      CORDIN(1,6) = CORDIN(1,3)
      CORDIN(2,6) = CORDIN(2,5)
*
*     Southwest internal
*
      CORDIN(1,7) = CORDIN(1,2)
      CORDIN(2,7) = CORDIN(2,5)
*
*     Southwest
*
      CORDIN(1,8) = CORDIN(1,1)
      CORDIN(2,8) = CORDIN(2,5)
*
*     calculate Transverse Mercator coordinates of control points
*
      DO 100 I = 1,8
*
*        convert geographic coordinate pair to TM feet
*
         COORDI(1) = CORDIN(1,I)
         COORDI(2) = CORDIN(2,I)
         CALL gctp (coordi,intype,inzone,inpar,inunit,insph,
     .              ipr,efile,jpr,pfile,coordo,iotype,iozone,
     .              prjpar, iounit,iosph,fn27,fn83,errflg)

         IF (ERRFLG .NE. 0) THEN
            CALL PLOT(0.0,0.0,999)
            CLOSE(UNIT = 7)
            ERRSTR = 'Coordinate conversion error.'//
     .               '  coordinates:'
            WRITE(ERRSTR(43:),'(F9.4,2X,F9.4)')COORDI(1),COORDI(2)
            CALL ERRMSG(ERRSTR,'flightln-conv',-1)
         END IF
*
*        convert feet to mils
*
         CALCOR(1,I) = IDNINT(COORDO(1)*(12000.0/REAL(SCALE)))
         CALCOR(2,I) = IDNINT(COORDO(2)*(12000.0/REAL(SCALE)))
  100 CONTINUE
*
*     calculate transformation parameters using calculated projection
*     coordinates and observed map coordinates
*
      CALL CALPAR(CALCOR,TRNPAR,LOGFIL)
*
*     toggle zone to reinitialize projection for each new map
*
      IF (IOZONE .EQ. 62) THEN
         IOZONE = 63
      ELSE
         IOZONE = 62
      END IF
      RETURN
      END
