      SUBROUTINE GETPAR(MAPSPC,WINDOW,SCALE,PLTFIL,LOGFIL,MAPNAM,LEN)
************************************************************************
*
*     NAME- GETPAR                         EXPIRES- 12/31/99
*
*     LANGUAGE- FORTRAN     TYPE- SUBROUTINE
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     To retrieve parameters for flight line plotting from the TAE
*     parameter block.
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
	include 'las.fin'

      REAL      MAPSPC(4)
     .,         WINDOW(4)

      integer*4 BLOCK(XPRDIM)

      INTEGER    STDOUT
     .,         LENGTH
     .,		LEN
     .,         COUNT
     .,         STATUS
     .,         SCALE
     .,         I
     .,         INDEX
      CHARACTER PLTFIL(2)*256
      CHARACTER LOGFIL*100
     .,		MAPNAM*30
     .,         ERRSTR*80
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     obtain input block from TAE
*
      CALL INLAS(BLOCK,STDOUT)
*
*     read map spec and check values
*
      CALL XRREAL(BLOCK,'MAPSPC',4,MAPSPC,COUNT,STATUS)
      MAPSPC(2) = -MAPSPC(2)
*
*     read flight window and check values
*
      CALL XRREAL(BLOCK,'WINDOW',4,WINDOW,COUNT,STATUS)
      WINDOW(2) = -WINDOW(2)
*
*     make sure flight window is within map bounds
*
      IF ((WINDOW(1) .LT. MAPSPC(1)) .OR.
     .   ((MAPSPC(1) + MAPSPC(3)) .LT. (WINDOW(1) + WINDOW(3)))) THEN
         CALL PLOT(0.0,0.0,999)
         CLOSE(UNIT = 7,STATUS='DELETE')
         ERRSTR = 'Flight line latitude exceeds map boundaries.'
         CALL ERRMSG(ERRSTR,'flightln-lat',-1)
      ELSE IF ((WINDOW(2) .LT. MAPSPC(2)) .OR.
     .   ((MAPSPC(2) + MAPSPC(4)) .LT. (WINDOW(2) + WINDOW(4)))) THEN
         CALL PLOT(0.0,0.0,999)
         CLOSE(UNIT = 7,STATUS='DELETE')
         ERRSTR = 'Flight line longitude exceeds map boundaries.'
         CALL ERRMSG(ERRSTR,'flightln-lon',-1)
      END IF
*
*     read map scale
*
      CALL XRINTG(BLOCK,'SCALE',1,SCALE,COUNT,STATUS)
*
*     read map name
*
      CALL XRSTR(BLOCK,'MAPNAME',1,MAPNAM,LENGTH,COUNT,STATUS)
*
*
*     determine length of output file name
*
      I = 2
  100 IF (MAPNAM(I:I) .EQ. ' ') THEN
         INDEX = I - 1
      ELSE IF (I .NE. 30) THEN
         I = I + 1
         GOTO 100
      ELSE
         INDEX = 30
      END IF
*
*     create plot file name
*
      LEN = INDEX + 4
      PLTFIL(1) = MAPNAM(1:INDEX)//'.plt'
      PLTFIL(2) = MAPNAM(1:INDEX)//'.log'
      LOGFIL = MAPNAM(1:INDEX)//'.log'
      RETURN
      END
