      SUBROUTINE HORSCL(MAPSPC,SCALE,TRNPAR,PRJPAR)
***********************************************************************
*
*     NAME- HORSCL                         EXPIRES- 12/31/99
*
*     LANGUAGE- FORTRAN     TYPE- SUBROUTINE
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     Plots horizontal labels at the top of a flight line map.
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
      DOUBLE PRECISION
     .          STLON
     .,         DEGCOR(2)
     .,         TRNPAR(8)
     .,         PRJPAR(15)
      REAL      PLTCOR(2)
     .,         MAPSPC(4)
     .,         INC
      INTEGER   I
     .,         DEGREE
     .,         TXTINT(2)
     .,         NCHAR
     .,         SCALE
     .,         HORINC
      CHARACTER LABEL(16)*4
     .,         TXTBUF*8
      PARAMETER(INC = .0625)
      EQUIVALENCE(TXTINT(1),TXTBUF)
      DATA      LABEL/'-8-W','-8-E','-7-W','-7-E','-6-W','-6-E','-5-W',
     .                '-5-E','-4-W','-4-E','-3-W','-3-E','-2-W','-2-E',
     .                '-1-W','-1-E'/
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     number of horizontal labels = latitude extent/increment between
*     labels
*
      HORINC = INT(MAPSPC(4)/INC)
*
*     start longitude = West longitude - 1/2 of the increment between
*     labels
*
      STLON = MAPSPC(2) - (INC/2.0)
*
*     latitude for coordinate transformations = South latitude +
*     latitude extent
*
      DEGCOR(2) = MAPSPC(1) + MAPSPC(3)
      DO 100 I = 1,HORINC
*
*        longitude for coodinate transformations = start longitude +
*        3 3/4' * I
*
         DEGCOR(1) = STLON + INC * I
         CALL DEGPLT(DEGCOR,SCALE,TRNPAR,PRJPAR,PLTCOR)
*
*        build the string
*
         DEGREE = -INT(DEGCOR(1))
         IF (DEGREE .GE. 100) THEN
            WRITE(TXTBUF,'(I3,A4)') DEGREE,
     .         LABEL(INT(((DEGREE + 1.03125) + DEGCOR(1)) * 16))
            NCHAR = 7
         ELSE IF (DEGREE .GE. O) then
            WRITE(TXTBUF,'(I2,A4)') DEGREE,
     .         LABEL(INT(((DEGREE + 1.03125) + DEGCOR(1)) * 16))
            NCHAR = 6
         ELSE IF (DEGREE .LE. -100) THEN
            WRITE(TXTBUF,'(I4,A4)') DEGREE,
     .         LABEL(INT((REAL(DEGREE) + DEGCOR(1) + 1.03125) * 16))
            NCHAR = 8
         ELSE
            WRITE(TXTBUF,'(I3,A4)') DEGREE,
     .         LABEL(INT((REAL(DEGREE) + DEGCOR(1) + 1.03125) * 16))
            NCHAR = 7
         END IF
*
*        plot the string
*
         CALL SYMBOL(PLTCOR(1)-NCHAR*.05,PLTCOR(2)+.5
     .              ,.1,TXTBUF,0,0,8)
  100 CONTINUE

      RETURN
      END
