      SUBROUTINE MORLNS(MAPSPC,WINDOW)
************************************************************************
*
*     NAME- MORLNS                         EXPIRES- 12/31/99
*
*     LANGUAGE- FORTRAN     TYPE- SUBROUTINE
*
*     VERSION- 1.0    DATE- 01-JUL-87 PROGRAMMER- John R. Allen (EDC)
*	       2	    15-MAY-92		  Tom Mittan
*
*     FUNCTION- 
*     To retrieve a flight line window for flight line plotting from
*     the TAE parameter block.
*
************************************************************************
*                                                                      *
*     DECLARATION SECTION                                              *
*                                                                      *
************************************************************************
	include 'las.fin'

      REAL      MAPSPC(4)
     .,         WINDOW(4)
     .,         CLRBLK(4)

      integer*4 BLOCK(XPRDIM)

      INTEGER    COUNT
     .,         STATUS
      CHARACTER ERRSTR*80
      DATA      CLRBLK/4*0.0/
************************************************************************
*                                                                      *
*     CODE SECTION                                                     *
*                                                                      *
************************************************************************
*
*     initialize TAE input block
*
      CALL XQINI(BLOCK,XPRDIM,XABORT)
*
*     set variables to be read
*
      CALL XQREAL(BLOCK,'WINDOW',4,CLRBLK,XADD,STATUS)
*
*     obtain values from user
*
      CALL XQDYNP(' ',BLOCK,XSUBPD,STATUS)
*
*     put values into block
*
      CALL XRINIM(BLOCK,XPRDIM,XABORT,STATUS)
*
*     read window coordinates
*
      CALL XRREAL(BLOCK,'WINDOW',4,WINDOW,COUNT,STATUS)
      window(2) = -window(2)
      IF (WINDOW(1) .NE. 0.0) THEN
         IF ((WINDOW(1) .LT. MAPSPC(1)) .OR.
     .      ((MAPSPC(1) + MAPSPC(3)) .LT. (WINDOW(1) + WINDOW(3)))) THEN
            CALL PLOT(0.0,0.0,999)
            CLOSE(UNIT = 7)
            ERRSTR = 'Flight line latitude exceeds map boundaries.'
            CALL ERRMSG(ERRSTR,'flightln-lat',-1)
         ELSE IF ((WINDOW(2) .LT. MAPSPC(2)) .OR.
     .      ((ABS(MAPSPC(2)) + MAPSPC(4)) .LT. (WINDOW(2) + 
     .      WINDOW(4)))) THEN
            CALL PLOT(0.0,0.0,999)
            CLOSE(UNIT = 7)
            ERRSTR = 'Flight line longitude exceeds map boundaries.'
            CALL ERRMSG(ERRSTR,'flightln-lon',-1)
         END IF
      END IF
      RETURN
      END
