
/******************************************************************************
NAME:		COMPARE_EM

PURPOSE:	Compare the information from the mapper file and header file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    02/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "glcts.h"
#include "protos_vnv.h"


int compare_em
(
    long nfiles,				/* Number of files in filesiz	*/
    long filesiz[],			/* File sizes found in header */
    long nmfiles,			/* Number of files found in mapper */
    long mfilesize[],			/* File sizes found in mapper */
    char tapeid[]			/* Tape ID */
)

{

long i;				/* Counter */


/*
  If the number of files does not agree, there is a discrepancy
*/
if (nmfiles != nfiles)
    {
    c_lasmsg(1,"glcts_vnv-dis","Discrepancy found in mapper for tape %s",
	     tapeid);
    return(E_FAIL);
    }


/*
  If the size of any one file does not agree, there is a discrepancy
*/
for (i = 0; i < nfiles; i++)
    {
    if (mfilesize[i] != filesiz[i])
	{
	c_lasmsg(1,"glcts_vnv-dis","Discrepancy found in mapper for tape %s",
		 tapeid);
	return(E_FAIL);
	}
    }

return(E_SUCC);
}

