
/******************************************************************************
NAME:		GETINFO_MAP

PURPOSE:	Get the information from the mapper file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    02/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "glcts.h"
#include "protos_vnv.h"


int getinfo_map
(
    char mapfile[TOTLMP][TOTSAM],	/* Total saved lines in header	*/
    long nmapf,				/* Number of entries in mapfile*/
    long *nmfiles,			/* Number of files found in mapper */
    long mfilesize[]			/* File sizes found in mapper */
)

{

long i;				/* Counter */
long totsize;			/* Total size of one file in mapper */
long nrec;			/* Number of records */
long nbyt;			/* Number of bytes */

char RECORDS[CMLEN];		/* Key string */
char BYTESS[CMLEN];		/* Key string */
char LONGS[CMLEN];		/* Key string */


/* Look for lines that look like:
   "650 RECORDS  56364 BYTES LONG"
   and maintain a cumulative summation until a line:
   "END OF FILE #5 >>>> 2560 TOTAL RECORDS"
   marks the end of this file
*/

totsize = 0;
*nmfiles = 0;
for (i = 0; i < nmapf; i++)
    {
    strcpy(RECORDS,"");
    strcpy(BYTESS,"");
    strcpy(LONGS,"");
    sscanf(mapfile[i],"%d %s %d%s %s",&nrec,RECORDS,&nbyt,BYTESS,LONGS);
    if ((strcmp(RECORDS,"RECORDS") == 0) &&
	(strcmp(BYTESS,"BYTES") == 0) &&
	(strcmp(LONGS,"LONG") == 0))
	{
	totsize += (nrec * nbyt);
	}

    if (strncmp(mapfile[i],"END OF FILE #",13) == 0)
	{
	mfilesize[*nmfiles] = totsize;
	(*nmfiles)++;
	totsize = 0;
	}

    }

return(E_SUCC);
}

