
/******************************************************************************
NAME:		GETINFO_MSS

PURPOSE:	Get the information from the MSS header file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    01/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "glcts.h"
#include "protos_mss.h"


int getinfo_mss
(
    char headfile[TOTLMS][TOTSAM],	/* Total lines in header file	*/
    int *nscenes,			/* Number of scenes		*/
    char dates[4][7]			/* Acquisition dates		*/
)

{

long i;				/* Counter */

char tmpdate[7];		/* Temporary date */


/*
Initialize the number of scenes in the header to zero
*/
*nscenes = 0;


/*
Try to find scene # 1 in the header file
*/
for (i = 0; i < TOTLMS; i++)
    {
    if (strncmp("File 2:",headfile[i],7) == 0)
	{
	strncpy(&tmpdate[0],&headfile[i][8],2);		/* Month */
	strncpy(&tmpdate[2],&headfile[i][11],2);	/* Day */
	strncpy(&tmpdate[4],&headfile[i][16],2);	/* Year */
	tmpdate[6] = '\0';
	strcpy(dates[*nscenes],tmpdate);
	(*nscenes)++;
	break;
	}
    }


/*
Try to find scene # 2 in the header file
*/
for (     ; i < TOTLMS; i++)
    {
    if (strncmp("File 6:",headfile[i],7) == 0)
	{
	strncpy(&tmpdate[0],&headfile[i][8],2);		/* Month */
	strncpy(&tmpdate[2],&headfile[i][11],2);	/* Day */
	strncpy(&tmpdate[4],&headfile[i][16],2);	/* Year */
	tmpdate[6] = '\0';
	strcpy(dates[*nscenes],tmpdate);
	(*nscenes)++;
	break;
	}
    }


/*
Try to find scene # 3 in the header file
*/
for (     ; i < TOTLMS; i++)
    {
    if (strncmp("File 10:",headfile[i],8) == 0)
	{
	strncpy(&tmpdate[0],&headfile[i][9],2);		/* Month */
	strncpy(&tmpdate[2],&headfile[i][12],2);	/* Day */
	strncpy(&tmpdate[4],&headfile[i][17],2);	/* Year */
	tmpdate[6] = '\0';
	strcpy(dates[*nscenes],tmpdate);
	(*nscenes)++;
	break;
	}
    }


/*
Try to find scene # 4 in the header file
*/
for (     ; i < TOTLMS; i++)
    {
    if (strncmp("File 14:",headfile[i],8) == 0)
	{
	strncpy(&tmpdate[0],&headfile[i][9],2);		/* Month */
	strncpy(&tmpdate[2],&headfile[i][12],2);	/* Day */
	strncpy(&tmpdate[4],&headfile[i][17],2);	/* Year */
	tmpdate[6] = '\0';
	strcpy(dates[*nscenes],tmpdate);
	(*nscenes)++;
	break;
	}
    }

return(E_SUCC);
}
