
/******************************************************************************
NAME:		GETINFO_VNV

PURPOSE:	Get the information from the header file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    02/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "glcts.h"
#include "protos_vnv.h"


int getinfo_vnv
(
    char headfile[TOTLSV][TOTSAM],	/* Total saved lines in header	*/
    long nheadf,				/* Number of entries in headfile*/
    long start,				/* Starting file number 	*/
    long maxfiles,			/* Maxium number of files to get*/
    long *nfiles,			/* Number of files in filesiz	*/
    long filesiz[]			/* File sizes 			*/
)

{

long i, j;			/* Counter */
long totalsize = 0;		/* Cumulative file size */


/*
Initialize the number of scenes to zero.
*/
*nfiles = 0;


/*
Get the size of each file in the header starting at the START file.
Never get more than MAXFILES files.
Never exceed the total size defined by MAX_TAPE_SIZE.
*/
for (i = start - 1, j = 0; i < nheadf; i++)
    {
    if (getsize(headfile[i],&filesiz[j++]) != E_SUCC)
	return(E_FAIL);
    (*nfiles)++;
    if (j >= maxfiles)  break;
    totalsize += filesiz[j-1];
    if (totalsize >= MAX_TAPE_SIZE)
	{
	if (totalsize == MAX_TAPE_SIZE)
	    break;
	else
	    {
	    (*nfiles)--;
	    break;
	    }
	}
    }


return(E_SUCC);
}
