/*******************************************************************************
NAME:                           GETPAR_VNV

PURPOSE:      Retrieve the parameters from TAE

PROGRAM HISTORY:
PROGRAMMER              DATE            REASON
----------              ----            ------
T. Baltzer		02/96		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

*******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "glcts.h"
#include "protos_vnv.h"

void getpar_vnv
(
    struct PARBLK *parblk,		/* TAE parameter block */
    char hname[],		    	/* HOST name of input file */
    long *start,			/* Starting file number */
    long *maxfiles,			/* Maximum files to get */
    char tapeid[],			/* Tape ID */
    char mhfile[]			/* Mapper host file name */
)

{

struct VARIABLE *val;         /* pointer to a TAE variable within v-block */


long mode = IREAD;	/* File access */
char root[CMLEN];	/* File name root */
char ext[CMLEN];	/* File extension */
char srcdir[CMLEN];	/* Source directory */


val = p_find(parblk,"HEADFLAS");
if (c_mknam(SVAL(*val,0),hname,"hdr",&mode) != E_SUCC)
    c_lasmsg(1,"glcts_vnv-fatal","Fatal error encountered");


val = p_find(parblk,"START");
*start = IVAL(*val,0);


val = p_find(parblk,"MAXFILES");
*maxfiles = IVAL(*val,0);


val = p_find(parblk,"TAPEID");
strcpy(tapeid,SVAL(*val,0));

c_splitname(hname, srcdir, root, ext);
strcpy(mhfile,srcdir);
strcat(mhfile,"mapper/");
strcat(mhfile,tapeid);
strcat(mhfile,".prt");

return;
}
