
/******************************************************************************
NAME:		GETSIZE

PURPOSE:	Get the file size from a line of header data.

EX:	input string   = "File 2: Ancillary data (ascii format), 26680 bytes"
	output integer = 26680

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    01/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"


int getsize
(
    char strbuf[],		/* Line buffer of header file data	*/
    long *fsize			/* File size extracted from strbuf	*/
)

{

long i;				/* Counter */


/*
  Initialize the file size to zero
*/
*fsize = 0;


/*
  Decrement past the first blank space from the right
*/
for (i = (long) strlen(strbuf) - 1; i >= 0; i--)
    {
    if (strbuf[i] == ' ')
	{
	i--;
	break;
	}
    }


/*
  Find the size element within the string
*/
for ( ; i >= 0; i--)
    {
    if (strbuf[i] == ' ')
	{
	sscanf(&strbuf[i+1],"%d %*s",fsize);
	break;
	}
    }


if (*fsize == 0)
    {
    c_lasmsg(1,"glcts_avh-nosc","Error finding file size in header");
    return(E_FAIL);
    }


return(E_SUCC);
}
