/*******************************************************************************
NAME:                           GLCTS_MSS

PURPOSE:      Read an MSS header file and return appropriate information.

PROGRAM HISTORY:
PROGRAMMER              DATE            REASON
----------              ----            ------
T. Baltzer		01/96		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "glcts.h"
#include "protos_mss.h"


int main
(void)
{
   struct PARBLK parblk;		/* TAE parameter block */

   char hname[CMLEN];			/* Header file name */
   char headfile[TOTLMS][TOTSAM];	/* Buffer containing the header file */
   char dates[4][7];			/* Acquisition dates of scenes */

   long std_out;			/* Standard out */
   long status;				/* Return status */
   int  nscenes;			/* Number of scenes in header file */


/* Initialize LAS */
c_inlas(&parblk,&std_out);     


/* Get the user input parameters */
getpar_mss(&parblk,hname);


/* Load the header file info into memory */
status = load_mss(hname,headfile);
if (status != E_SUCC)
    c_lasmsg(1,"glcts_mss-fatal","Fatal error encountered");


/* Get the information from the header file */
getinfo_mss(headfile,&nscenes,dates);


/* Return the information to TAE */
status = taeland_mss(&parblk,&nscenes,dates);
if (status != E_SUCC)
    c_lasmsg(1,"glcts_mss-fatal","Fatal error encountered");


z_exit(1," ");

return EXIT_SUCCESS;

}
