/*******************************************************************************
NAME:                           GLCTS_TM

PURPOSE:      Read a TM header file and return appropriate information.

PROGRAM HISTORY:
PROGRAMMER              DATE            REASON
----------              ----            ------
T. Baltzer		01/96		Initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   Must be run under TAE.

*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"
#include "util.h"
#include "glcts.h"
#include "protos_tm.h"


int main
(void)
{
   struct PARBLK parblk;		/* TAE parameter block */

   char hname[CMLEN];			/* Header file name */
   char headfile[TOTLTM][TOTSAM];	/* Buffer containing the header file */
   char date[7];			/* Acquisition date of scene */

   long std_out;			/* Standard out */
   long status;				/* Return status */


/* Initialize LAS */
c_inlas(&parblk,&std_out);     


/* Get the user input parameters */
getpar_tm(&parblk,hname);


/* Load the header file info into memory */
status = load_tm(hname,headfile);
if (status != E_SUCC)
    c_lasmsg(1,"glcts_tm-fatal","Fatal error encountered");


/* Get the information from the header file */
getinfo_tm(headfile,date);


/* Return the information to TAE */
status = taeland_tm(&parblk,date);
if (status != E_SUCC)
    c_lasmsg(1,"glcts_tm-fatal","Fatal error encountered");


z_exit(1," ");

return EXIT_SUCCESS;

}
