
/******************************************************************************
NAME:		LOAD_AVH

PURPOSE:	Get information from the AVHRR header file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    01/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "glcts.h"


int load_avh
(
    char *hname,				/* Host file name (input) */
    char headfile[TOTLSV][TOTSAM],	/* Header file buffer */
    long *nheadf			/* Number in header file */
)

{
FILE    *fp;

long i;				/* Counter */

char tmpbuf[TOTSAM];		/* Temporary buffer */


/*
  Open the file
*/
fp = fopen(hname,"r");
if (fp == NULL)
    {
    c_lasmsg(0,"glcts_avh-opn","Error opening the header file");
    return(E_FAIL);
    }


/*
  Load the file into memory, read until EOF or error, hard to tell which
*/
for (i = 0, *nheadf = 0; ; i++)
    {
    if (fgets(tmpbuf,TOTSAM,fp) == NULL)
	break;
    if (strncmp(&tmpbuf[0],"File ",5) == 0)
	strcpy(headfile[(*nheadf)++],tmpbuf);
    }


/*
  Close the file
*/
fclose(fp);

return(E_SUCC);
}
