
/******************************************************************************
NAME:		LOAD_MAP

PURPOSE:	Load the mapper header file into memory.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    01/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "glcts.h"
#include "protos_vnv.h"


int load_map
(
    char *mhfile,			/* Host file name (input) */
    char mapfile[TOTLMP][TOTSAM],	/* Mapper file buffer */
    long *nmapf				/* Number in mapper file */
)

{
FILE    *fp;

long i;				/* Counter */

char tmpbuf[TOTSAM];		/* Temporary buffer */


/*
  Open the file
*/
fp = fopen(mhfile,"r");
if (fp == NULL)
    {
    c_lasmsg(0,"glcts_map-opn","Error opening the mapper file");
    return(E_FAIL);
    }


/*
  Load the file into memory, read until EOF or error, hard to tell which
*/
for (i = 0, *nmapf = 0; ; i++)
    {
    if (fgets(tmpbuf,TOTSAM,fp) == NULL)
	break;
    strcpy(mapfile[(*nmapf)++],tmpbuf);
    }


/*
  Close the file
*/
fclose(fp);

return(E_SUCC);
}
