
/******************************************************************************
NAME:		LOAD_MSS

PURPOSE:	Get information from the MSS header file.

PROGRAM HISTORY:
VERSION	 AUTHOR	       DATE	REASON
-------	 ------	       -----	-----------------------------
  1.0	 T. Baltzer    01/96	Original development


COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:

PROJECT:  ADAPS

ALGORITHM REFERENCES:
******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "glcts.h"
#include "protos_mss.h"


int load_mss
(
    char *hname,				/* Host file name (input) */
    char headfile[TOTLMS][TOTSAM]	/* Header file buffer */
)

{
FILE    *fp;

long i;				/* Counter */

/*
  Open the file
*/
fp = fopen(hname,"r");
if (fp == NULL)
    {
    c_lasmsg(0,"glcts_mss-opn","Error opening the header file");
    return(E_FAIL);
    }


/*
  Load the file into memory, read until EOF or error, hard to tell which
*/
for (i = 0; i < TOTLMS; i++)
    {
    if (fgets(headfile[i],TOTSAM,fp) == NULL)
	break;
    }


/*
  Close the file
*/
fclose(fp);

return(E_SUCC);
}
