#ifndef PROTOS_VNV_H
#define PROTOS_VNV_H

int compare_em
(
    long nfiles,				/* Number of files in filesiz	*/
    long filesiz[],			/* File sizes found in header */
    long nmfiles,			/* Number of files found in mapper */
    long mfilesize[],			/* File sizes found in mapper */
    char tapeid[]			/* Tape ID */
);

int getinfo_map
(
    char mapfile[TOTLMP][TOTSAM],	/* Total saved lines in header	*/
    long nmapf,				/* Number of entries in mapfile*/
    long *nmfiles,			/* Number of files found in mapper */
    long mfilesize[]			/* File sizes found in mapper */
);

int getinfo_vnv
(
    char headfile[TOTLSV][TOTSAM],	/* Total saved lines in header	*/
    long nheadf,				/* Number of entries in headfile*/
    long start,				/* Starting file number 	*/
    long maxfiles,			/* Maxium number of files to get*/
    long *nfiles,			/* Number of files in filesiz	*/
    long filesiz[]			/* File sizes 			*/
);

void getpar_vnv
(
    struct PARBLK *parblk,		/* TAE parameter block */
    char hname[],		    	/* HOST name of input file */
    long *start,			/* Starting file number */
    long *maxfiles,			/* Maximum files to get */
    char tapeid[],			/* Tape ID */
    char mhfile[]			/* Mapper host file name */
);

int getsize
(
    char strbuf[],		/* Line buffer of header file data	*/
    long *fsize			/* File size extracted from strbuf	*/
);

int load_avh
(
    char *hname,				/* Host file name (input) */
    char headfile[TOTLSV][TOTSAM],	/* Header file buffer */
    long *nheadf			/* Number in header file */
);

int load_map
(
    char *mhfile,			/* Host file name (input) */
    char mapfile[TOTLMP][TOTSAM],	/* Mapper file buffer */
    long *nmapf				/* Number in mapper file */
);

#endif

