/******************************************************************************
FUNCTION:	TAELAND_AVH

PURPOSE:	Send data back to TAE land.

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 1.0       01/96    T. Baltzer		initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
		Run under TAE

PROJECT			ADAPS

ALGORITHM REFERENCES	none
*******************************************************************************/
#include "las.h"		/* LAS include			       */
#include "glcts.h"
#include "protos_avh.h"


int taeland_avh
(
    struct PARBLK *parblk,	/* TAE parameter block			*/
    int *nscenes,		/* Number of scenes			*/
    char sceneid[MAXSC][17]	/* Scene ID's				*/
)

{

char *sptr[MAXSC];		/* Pointer array for updating parblk    */

long i;				/* Counter */

/*
  Return the number of scenes in the header file
*/
if (q_intg(parblk,"NSCENES",1, nscenes,P_UPDATE) != SUCCESS)
   {
   c_lasmsg(1,"glcts_avh-rparm","Error returning parameter to TAE");
   return(E_FAIL);
   }


/*
  Return the scene id of each of the scenes
*/
if (*nscenes > 0)
    {
    for (i = 0; i < *nscenes; i++)
	sptr[i] = sceneid[i];
    if (q_string(parblk,"SCENEID",*nscenes,sptr,P_UPDATE) != SUCCESS)
	{
	c_lasmsg(1,"glcts_avh-rparm","Error returning parameter to TAE");
	return(E_FAIL);
	}
    }


if (q_out(parblk) != SUCCESS)
   {
   c_lasmsg(1,"glcts_avh-rparm","Error returning parameter to TAE");
   return(E_FAIL);
   }


return(E_SUCC);
}
