/******************************************************************************
FUNCTION:	TAELAND_TM

PURPOSE:	Send data back to TAE land.

PROGRAM HISTORY:
Version    Date     Author       	Change Request
-------    -----    -------------	--------------
 1.0       01/96    T. Baltzer		initial development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
		Run under TAE

PROJECT			ADAPS

ALGORITHM REFERENCES	none
*******************************************************************************/
#include "las.h"		/* LAS include			       */
#include "glcts.h"
#include "protos_tm.h"


int taeland_tm
(
    struct PARBLK *parblk,	/* TAE parameter block			*/
    char date[7]		/* Acquisition date			*/
)

{

char *sptr[1];			/* Pointer array for updating parblk    */


/*
  Return the acquisition date of the scene
*/
sptr[0] = date;
if (q_string(parblk,"DATE",1,sptr,P_UPDATE) != SUCCESS)
    {
    c_lasmsg(1,"glcts_tm-rparm","Error returning parameter to TAE");
    return(E_FAIL);
    }


if (q_out(parblk) != SUCCESS)
   {
   c_lasmsg(1,"glcts_tm-rparm","Error returning parameter to TAE");
   return(E_FAIL);
   }


return(E_SUCC);
}
