#ifndef GEOMZ_H
#define GEOMZ_H

void closelas (
  struct FDESC *fdesc1,    /* I: input file descriptor                  */
  struct GDESC *gdesc);    /* I: group descriptor for OUT               */

void getpar (
  struct PARBLK *vblock,  /* O: TAE parameter block                        */
  char taein[CMLEN],      /* O: TAE input filenames of images specified    */
  char hosin[CMLEN],      /* O: host input filenames of images specified   */
  char taeout[CMLEN],     /* O: TAE output filename                        */
  char hosout[CMLEN],     /* O: host output filename                       */
  long window[4],         /* O: window of the input file                   */
  long bands[2],          /* O: image bands of the input file              */
  long *fixval,           /* O: PIXVAL value                               */
  long *scale,            /* O: input scaling factor                       */
  long *offs,             /* O: OFFSET value                               */
  long *mincnt,           /* O: number of values entered for MINVAL        */
  long *maxcnt,           /* O: number of values entered for MAXVAL        */
  float *imin,            /* O: MINVAL value                               */
  float *imax,            /* O: MAXVAL value                               */
  char ha1[CMLEN],        /* O: INGRID value                               */
  long *msgtim,           /* O: time between display messages              */
  char minmax[]);         /* O: minmax flag                                */

void rdfinr (
  char fname[],      /* I: host filename of radiometric mapping grid file  */
  double **line,     /* O: address of line pointer to store the grid line
                           values at the grid intersections (space is
                           allocated for this) stored top to bottom        */
  double **sample,   /* O: address of sample pointer to store the grid
                           sample values at the grid intersections (space
                           is allocated for this) stored left to right     */
  double **z_value,  /* O: address of z_value pointer to store the grid
                           z_values at all the grid intersections (space
                           is allocated for this) stored left to right,
                           top to bottom                                   */
  long *nr,          /* O: number of rows in the grid                      */
  long *nc,          /* O: number of columns in the grid                   */
  long *nl,          /* O: number of lines in the output image             */
  long *ns);         /* O: number of samples in the output image           */

#endif
