/*****************************************************************************
   NAME:                          INCARC

   FUNCTION:
     Calculates the number of incoming arcs for the indver vertice.

   PROGRAM HISTORY:
      Version    Date    Author          Code/contr  Request
      -------    ----    ------          ----------  -------
        7.2      9/99    G.Schmidt          CSB      FORTRAN to C conversion
*****************************************************************************/
#include "las.h"
#include "pmask.h"

long incarc
(
  long indver,       /* I: index for the current vertice       */
  long listin[],     /* I: list of input vertices (0-based)    */
  long listout[],    /* I: list of output vertices (0-based)   */
  long npoly         /* I: number of values in listin/listout  */
)
{
    long i;            /* looping variable                       */
    long t_incarc;     /* temporary storage for the return value */

    t_incarc = indver - 1;
    for (i = 0; i < npoly; i++)
    {
        if (indver == listout[i])
            t_incarc = listin[i];
    }

    return (t_incarc);
}
