/*****************************************************************************
   NAME:                          NOSE

   FUNCTION:
     Calculates the number of nose vertices for the indarc arc.

   PROGRAM HISTORY:
      Version    Date    Author          Code/contr  Request
      -------    ----    ------          ----------  -------
        7.2      9/99    G.Schmidt          CSB      FORTRAN to C conversion
*****************************************************************************/
#include "las.h"
#include "pmask.h"

long nose
(
  long indarc,       /* I: index of the current arc            */
  long listin[],     /* I: list of input vertices              */
  long listout[],    /* I: list of output vertices             */
  long npoly         /* I: number of values in listin/listout  */
)
{
    long i;            /* looping variable                       */
    long t_nose;       /* temporary storage for the return value */

    t_nose = indarc + 1;
    for (i = 0; i < npoly; i++)
    {
        if (indarc == listin[i])
            t_nose = listout[i];
    }

    return (t_nose);
}
