#ifndef PMASK_H
#define PMASK_H

void black
(
  long yline,           /* I: line to be blackened Y = yline         */
  long intarc[],        /* I: arc intersections (needs to be zero based) */
  long nedges,          /* I: number of edges in xvert and yvert     */
  int clokws,           /* I: flag to specify a clockwise direction  */
  float inset,          /* I: fill value for the pxfill call         */
  float xvert[],        /* I: x vertices                             */
  float yvert[],        /* I: y vertices                             */
  float slope[],        /* I: slope of the lines                     */
  long nspic,           /* I: number of samples in the image         */
  long window[][4],     /* I: window of the input images             */
  long ib,              /* I: index for band offset                  */
  long offset[],        /* I: band offset array                      */
  float bufout[]        /* O: output buffer                          */
);

void closelas
(
  struct FDESC *fdesc1[],  /* I: input file descriptors                 */
  long images,             /* I: number of images input from TAE        */
  struct GDESC *gdesc      /* I: group descriptor for OUT               */
);

void direct
(
  long yline,        /* I: line value for Y = YLINE                   */
  long intarc[],     /* I: arc intersections (needs to be zero based) */
  long nedges,       /* I: number of edges in xvert and yvert         */
  int *clokws,       /* O: flag to specify a clockwise direction      */
  float xvert[],     /* I: x vertices                                 */
  float yvert[],     /* I: y vertices                                 */
  float slope[],     /* I: slope of the lines                         */
  long listin[],     /* I: list of input vertices (needs to be 0-based) */
  long listout[],    /* I: list of output vertices (needs to be 0-based) */
  long npoly,        /* I: number of values in listin/listout         */
  int *flag          /* I/O: boolean flag                             */
);

void edges
(
  long intarc[],     /* O: arc intersections (needs to be zero based) */
  long iptr[],       /* I: array of indices for listin and listout
                           (zero-based)   */
  long iswath,       /* I: current swath being processed (zero-based) */
  long *nedges,      /* I/O: number of edges                          */
  long listin[],     /* I: list of input vertices (needs to be 0-based) */
  long listout[],    /* I: list of output vertices (needs to be 0-based) */
  long npoly         /* I: number of values in listin/listout         */
);

void getpar
(
  struct PARBLK *vblock,  /* O: TAE parameter block                        */
  char tname[][CMLEN],    /* O: TAE input filenames of images specified    */
  char hosin[][CMLEN],    /* O: host input filenames of images specified   */
  char taeout[][CMLEN],   /* O: TAE output filename                        */
  char hosout[][CMLEN],   /* O: host output filename                       */
  char infile[CMLEN],     /* O: TAE INFILE filename                        */
  long *images,           /* O: number of images input from TAE            */
  long window[][4],       /* O: window of the input files                  */
  long bands[][MAXBND+1], /* O: image bands of the input files             */
  long numbnd[],          /* O: number of bands per image                  */
  long *totbnds,          /* O: total number of bands specified            */
  long *ndata,            /* O: number of elements in datarr               */
  float datarr[],         /* O: LSCOORS values                             */
  long *mask,             /* O: input mask value                           */
  long *scale,            /* O: input scaling factor                       */
  char cutarea[],         /* O: input cutarea value (IN, OUT, TBD)         */
  long *msgtim,           /* O: time between display messages              */
  char minmax[]           /* O: minmax flag                                */
);

void i4sort
(
  long data[],      /* I/O: input array of data (output is sorted)         */
  long pointr[],    /* I/O: input array of pointers (output corresponds to
                            the data array                                 */
  long len          /* I: length of the arrays                             */
);

long incarc
(
  long indver,       /* I: index for the current vertice       */
  long listin[],     /* I: list of input vertices              */
  long listout[],    /* I: list of output vertices             */
  long npoly         /* I: number of values in listin/listout  */
);

long nose
(
  long indarc,       /* I: index of the current arc            */
  long listin[],     /* I: list of input vertices              */
  long listout[],    /* I: list of output vertices             */
  long npoly         /* I: number of values in listin/listout  */
);

void polyin
(
  long npairs,        /* I: number of points available for the polygon
                            (minimum of 4 points needed)                */
  int *newpol,        /* I/O: flag specifying if this is the first call
                              to polyin                                 */
  long *ivert,        /* I/O: current vertex (needs to be 0-based)      */
  long scale,         /* I: scaling factor                              */
  float grbuf[],      /* I: buffer of data from infile or PARAM stmt    */
  float xvert[],      /* I/O: x vertices                                */
  float yvert[],      /* I/O: y vertices                                */
  long listin[],      /* O: list of input vertices                      */
  long listout[],     /* I/O: list of output vertices                   */
  long *npoly         /* I/O: number of values in listin/listout        */
);

void r4sort
(
  float data[],     /* I/O: input array of data (output is sorted)         */
  long pointr[],    /* I/O: input array of pointers (output corresponds to
                            the data array                                 */
  long len          /* I: length of the arrays                             */
);

#endif
