/****************************************************************************
   NAME:                          R4SORT

   FUNCTION:
      R4SORT sorts the input data along with the pointer to the data.

   PROGRAM HISTORY:
      Version    Date    Author          Code/contr  Request
      -------    ----    ------          ----------  -------
        7.2      10/99   G. Schmidt        CSB       Converted FORTRAN to C.
****************************************************************************/
#include "las.h"
#include "pmask.h"

void r4sort
(
  float data[],     /* I/O: input array of data (output is sorted)         */
  long pointr[],    /* I/O: input array of pointers (output corresponds to
                            the data array                                 */
  long len          /* I: length of the arrays                             */
)
{
    long i, j;          /* looping variables                */
    long itemp;         /* temp storage for the swap value  */
    float temp;         /* temp storage for the swap value  */

    for (i = 0; i < len-1; i++)
    {
        for (j = 0; j < len-i-1; j++)
        {
            if (data[j] > data[j+1])
            {
                temp = data[j];
                data[j] = data[j+1];
                data[j+1] = temp;
                itemp = pointr[j];
                pointr[j] = pointr[j+1];
                pointr[j+1] = itemp;
            }
        }
    }
}
