#ifndef PROTOS_H
#define PROTOS_H

int map_poly
(
    double *yx,		/* y,x pairs (y1,x1,y2,x2,...,yN,xN) */
    long N,			/* Number of y,x pairs */
    long inv,		/* Boolean--FALSE in->out; TRUE out->in */
    long outside,		/* Boolean--FALSE don't map; TRUE closest cell */
    struct GEOGRID *grid	/* Geometric Mapping Grid */
);

void find_top
(
    double x1,
    double x2,
    double y1,
    double y2
);

void find_rit
(
    double x1,
    double x2,
    double y1,
    double y2
);

void find_bot
(
    double x1,
    double x2,
    double y1,
    double y2
);

void find_lft
(
    double x1,
    double x2,
    double y1,
    double y2
);

void find_cr1
(
    double x1,
    double x2,
    double y1,
    double y2
);

void find_cr2
(
    double x1,
    double x2,
    double y1,
    double y2
);

double top
(
    double x
);

double rit
(
    double x
);

double bot
(
    double x
);

double lft
(
    double x
);

void QR
(
    double *A,	/* Matrix A (stored by columns) */
    long m,         /* Number of rows in matrix A */
    long n,         /* Number of columns in matrix A */
    double *v       /* Vector v */
);

void QR_solve
(
    double *A,       /* Matrix A (stored by columns) */
    long m,         /* Number of rows in matrix A */
    long n,         /* Number of columns in matrix A */
    double *v,       /* Vector v */
    double *b,	/* Vector b */
    long iflag
);

void house
(
    long n,		/* Input--dimension of vectors x and v */
    double *x,	/* Input--vector x */
    double *v,	/* Output--vector v */
    double *vtv,	/* Output--Product of vector v transpose and v */
    double *Px	/* Output--Product of Householder matrix P and vector x */
);

void row_house
(
    double *A,	/* Matrix A (stored by columns) */
    long m,		/* Number of rows in matrix A */
    long n,		/* Number of columns in matrix A */
    long mdim,	/* Row dimension */
    double *v,	/* Vector v */
    double vtv	/* Product of vector v transpose and vector v */
);

double norm_2
(
    double *x, 
    long n
);

int sign
(
    double val
);

void getpar
(
    struct PARBLK *parb,
    long *invers,
    long *insect,
    long *skip,
    long *interval,
    long *msgtim
);

#endif

