/*-
*	FUNCTION:	cnvgeo.c
*
*	VERSION:	%I%
*
*	DATE:		%D%
*
*	PROGRAMMER:	%Q%
*
*	PURPOSE:	The purpose of this routine is to convert the
*			integer passed in to decimal degree format.
*			The int_type will indicate what type of
*			coordinate format was used.
*
*	DATABASE:	None.
*
*	EXTERNAL FUNCTIONS:
*			faterr		fatal error handling function.
*
*	ARGUMENTS:	coord		coordinate in integer format.
*			int_type	type of integer coordinate.
*
*	RETURNS:	coordcnv	coordinate in decimal degree format.
-*/
#include "las.h"
#include "fldtypes.h"
#include "exbrows.h"
#include "protos.h"

void faterr();

double cnvgeo
(
    long coord,
    int int_type
)
{
    double coordcnv = 0;
    int min = 0;
    int sec = 0;

    switch (int_type)
	{
    case LAT_DD:
    case LONG_DDD:
	coordcnv = coord;
	return (coordcnv);

    case LAT_DDMM:
    case LONG_DDDMM:
	min = coord % 100;
	coord /= 100;
	coordcnv = min * 60;
	coordcnv /= 3600;
	coordcnv += coord;
	return (coordcnv);

    case LAT_DDMMSS:
    case LONG_DDDMMSS:
	sec = coord % 100;
	coord /= 100;
	min = coord % 100;
	coord /= 100;
	coordcnv = (min * 60 + sec);
	coordcnv /= 3600;
	coordcnv += coord;
	return (coordcnv);

    default:
/*
	faterr (stdscr, "cnvgeo", "switch", int_type, "field type");
*/
	break;
	}
    return (coordcnv);
}

