/*-
*	FUNCTION:	cnvlong.c
*
*	VERSION:	%I%
*
*	DATE:		%D%
*
*	PROGRAMMER:	%Q%
*
*	PURPOSE:	The purpose of this routine is to convert the
*			decimal degree coordinate passed in to an integer 
*			format.  The int_type will indicate what type of 
*			precision is needed.
*
*	DATABASE:	None.
*
*	EXTERNAL FUNCTIONS:
*			faterr		fatal error handling function.
*
*	ARGUMENTS:	dd		coordinate in decimal degree format.
*			int_type	type of integer coordinate.
*
*	RETURNS:	rtn		coordinate in integer format.
-*/
#include <math.h>
#include "las.h"
#include "fldtypes.h"
#include "exbrows.h"
#include "protos.h"

void faterr();

long cnvlong
(
    double dd,
    int int_type
)
{
    long deg;
    long min;
    long sec;
    long rtn = 0;

    switch (int_type)
	{
    case LAT_DD:
    case LONG_DDD:
	rtn = (long) dd;
	break;

    case LAT_DDMM:
    case LONG_DDDMM:
        deg = (long) fabs(dd);
        min = (long) ((fabs(dd) - deg) * 60 + 0.5);
        rtn = deg * 100 + min;
        if(dd < 0)
           rtn = -rtn;
        break;

    case LAT_DDMMSS:
    case LONG_DDDMMSS:
        deg = (long) fabs(dd);
        sec = (long) ((fabs(dd) - deg) * 3600 + 0.5);
        min = sec / 60;
        sec = sec % 60;
        rtn = deg * 10000 + min * 100 + sec;
        if(dd < 0)
           rtn = -rtn;
        break;

    default:
/*
	faterr (stdscr, "cnvlong", "switch", int_type, "field type");
*/
	break;
	}
    return (rtn);
}

