/*
*	INCLUDE:	conv.h
*
*	PURPOSE:	The purpose of the include conv.h is to define
*			conversion functions that are used in the data 
*			conversion.
*
*/

#define BACK_FILL 1		/* field is back blank filled */
#define FRONT_FILL 2		/* field is front blank filled */
#define GEO_TYPE 3		/* field is a geographic corrd. type ind */
#define GEO_LAT 4		/* field is a latitude geographic field */
#define GEO_LONG 5		/* field is a longitude geographic field */
#define ZERO_FILL 6		/* field is front zero filled */
#define CAL_CORNERS 7		/* Field to trigger calculating corner pts */
#define STORE_SAT 8		/* Field stores the sat num */

/*
 * Globals used in the calculation of corner points
 */

#define REQ 6378.135		/* Radius of the earth at the equator */
#define E .006694541854858764	/* Eccentricity of the earth */
#define PI 3.14159265358979	/* Ratio of circumference to diameter */
#define TWOPI 6.28318530717958
#define RAD 57.295779505601047	/* (Circumference / 2) / PI */
#define WE 0.00007292115642	/* Rotation of the earth */
#define DEG2RAD .017453292519943     /* number of radians in a degree */
#define MIN2RAD (DEG2RAD / 60)

/*
 * Sequence of geographic fields
 */

#define NW_LAT_FLD 0
#define NW_LONG_FLD 1
#define NE_LAT_FLD 2
#define NE_LONG_FLD 3
#define SE_LAT_FLD 4
#define SE_LONG_FLD 5
#define SW_LAT_FLD 6
#define SW_LONG_FLD 7
#define CN_LAT_FLD 8
#define CN_LONG_FLD 9

#define NBR_GEO_FLDS 10
