/*******************************************************************************
FUNCTION:	RAD2MIN

PURPOSE:	Convert a latitude or longitude in radians to total minutes

Version  Date   Programmer       Modifications
-------  -----  ---------------  -----------------------------------------------
  1.0    08/90  D.Hollaren       Modified version of VMSOUT
  5.0    03/92  E.Cihak/         LAS-5.0 version for ADAPS
                T.Rockvam

PROJECT:	ADAPS
*******************************************************************************/
#include <stdio.h>
#include <math.h>
#include "las.h"
#include "exbrows.h"
#include "protos.h"

void deg2min
(
    double latlon,			/* lat or long value to convert (degrees)*/
    long *totmin 		/* total minutes 			*/
)
{
long	deg,			/* degrees 				*/
	mins;    		/* minutes 				*/

double	left;			/* fractional part of latlon		*/

/*
  Extract the degrees
*/
deg = (long)latlon;

/*
  Take the amount left and extract the minutes
*/
left = latlon - (double)deg;
mins = (long)(fabs(left) * 60);

/*
  Convert degrees and minutes to total minutes
*/
if (latlon < 0)
   *totmin = deg * 60 - mins;
else
   *totmin = deg * 60 + mins;

return;
}
