/*******************************************************************************
NAME:				EXBROWS

PURPOSE:   Extracts browse images from files.  

PROGRAM HISTORY:
VERSION	   PROGRAMMER	   DATE		CODE/CONT	REASON
-------	   ----------      ----		---------	------
1.0	   D. Etrheim/T.Mittan 9/94	CSB		Original development

COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
   EXBROWS must be run under TAE.

PROJECT:			LAS

ALGORITHM DESCRIPTION:

ALGORITHM REFERENCES:		none
******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "las.h"	
#include "util.h"
#include "exbrows.h"	
#include "protos.h"

int main
(void)
{
struct PARBLK vblock;		/* TAE parameter block               */

long	std_out;		/* LUN to standard output    	     */
long    fatal = -1;
long    zero = 0;

char	hosin[CMLEN];		/* host names of input images        */
char	taeout[1][CMLEN];		/* TAE name of output image	     */
char	tapeid[CMLEN];		/* tapeid			     */
char    ptype[4];		/* product type                      */

struct LINE  brw_line;        	/* header record for output file     */


/* Initialization
-----------------*/
c_inlas(&vblock,&std_out);

/* Get parameters and globals
-----------------------------*/
getpar(&vblock,hosin,ptype,tapeid);

/* Process image -- round input data if needed
----------------------------------------------*/
if (strcmp(ptype,"MSX") == 0)
   {
   if (procesx(hosin,ptype,&brw_line,tapeid) != E_SUCC)
      c_errmsg("Fatal error encountered","exbrows-fatal",&fatal);
   }   
else
   {
   if (proces(hosin,ptype,&brw_line,tapeid) != E_SUCC)
      c_errmsg("Fatal error encountered","exbrows-fatal",&fatal);
   }

/* Output completion message 
----------------------------*/
c_complt("EXBROWS",taeout,&zero);

return EXIT_SUCCESS;

}
