/*
*	INCLUDE:	fldtypes.h
*
*	PURPOSE:	The purpose of the include fldtypes.h is to define
*			field types that are used in the custom research 
*			module (glis).
*
*/

#define STRING 1		/* field is a string */
#define INTEGER 2		/* field is an integer */
#define DATE 3			/* field is a date */
#define TIME 4			/* field is a time */
#define AMOUNT 5		/* field is an amount */
#define FLOAT 6			/* field is a float */
#define GEO_COVERAGE 20		/* field represents geographic coverage */
#define LAT_DD 21		/* field is an latitude in degrees */
#define LONG_DDD 22		/* field is an longitude in degrees */
#define NEW_PASSWD 23		/* field is a New Password field */
#define OLD_PASSWD 24		/* field is a Old Password field */
#define LAT_DDMM 25		/* field is an latitude in ddmm */
#define LONG_DDDMM 26		/* field is an longitude in dddmm */
#define LAT_DDMMSS 27		/* field is an latitude in ddmmss */
#define LONG_DDDMMSS 28		/* field is an longitude in dddmmss */
#define PATH_ROW_COV 29		/* field represents path row coverage */
#define DATE_RANGES 30		/* field is a date range combination */
#define DATE_SEASONS 31		/* field is a seasonal date combination */
#define DATE_YEAR 32		/* field is a year */
#define SIMPLE_STRING 33	/* field is simple string */
