
#include <stdlib.h>
#include <string.h>
#include "las.h"
#include "util.h"
#include "exbrows.h"
#include "protos.h"

void getdata
(
    FILE *fp,
    char outname[][CMLEN],
    long sllist[],
    char *hosin,
    char infiles[][CMLEN],
    long *nscenes,
    char *ptype,
    long complete[],
    char scene[][17],
    long block_add[]
)
{
long loop,loop2;
char  record[60][707];
char  wbuf[10];               /* working buffer */
char  direc[CMLEN],root[CMLEN],ext[CMLEN];
long  temp;
char  ctemp[CMLEN];
long  count;

/*
  Generate the list of input file names
*/
c_splitname(hosin,direc,root,ext);

if (strcmp(ptype,"MSP") == 0)
   {
   strcpy(infiles[0],direc);
   strcat(infiles[0],root);
   strcat(infiles[0],".mp1");
   strcpy(infiles[1],direc);
   strcat(infiles[1],root);
   strcat(infiles[1],".mp2");
   strcpy(infiles[2],direc);
   strcat(infiles[2],root);
   strcat(infiles[2],".mp4");
   }
else if (strcmp(ptype,"MSA") == 0)
   {
   strcpy(infiles[0],direc);
   strcat(infiles[0],root);
   strcat(infiles[0],".ma1");
   strcpy(infiles[1],direc);
   strcat(infiles[1],root);
   strcat(infiles[1],".ma2");
   strcpy(infiles[2],direc);
   strcat(infiles[2],root);
   strcat(infiles[2],".ma4");
   }
else if (strcmp(ptype,"TMR") == 0)
   {
   strcpy(infiles[0],direc);
   strcat(infiles[0],root);
   strcat(infiles[0],".tr3");
   strcpy(infiles[1],direc);
   strcat(infiles[1],root);
   strcat(infiles[1],".tr4");
   strcpy(infiles[2],direc);
   strcat(infiles[2],root);
   strcat(infiles[2],".tr5");
   }
else	/* TMA */
   {
   strcpy(infiles[0],direc);
   strcat(infiles[0],root);
   strcat(infiles[0],".ta3");
   strcpy(infiles[1],direc);
   strcat(infiles[1],root);
   strcat(infiles[1],".ta4");
   strcpy(infiles[2],direc);
   strcat(infiles[2],root);
   strcat(infiles[2],".ta5");
   }

/*
  Get the scene ids and the starting lines for each scene
*/
for (loop = 0; loop < *nscenes; loop++)
    {
    fgets(record[loop],706,fp);

    strncpy(wbuf,&record[loop][618],6);
    wbuf[6] = '\0';
    sllist[loop] = atol(wbuf);
    }

/*
  Sort based on starting line
*/
for (loop = 0; loop < *nscenes - 1; loop++)
    {
    for (loop2 = 0; loop2 < ((*nscenes - 1) - loop); loop2++)
        {
        if (sllist[loop2] > sllist[loop2+1])
           {
           temp = sllist[loop2];
           sllist[loop2] =  sllist[loop2+1];
           sllist[loop2+1] = temp;
           
           strcpy(ctemp,record[loop2]);
           strcpy(record[loop2],record[loop2+1]);
           strcpy(record[loop2+1],ctemp);
           }
        }
    }

/*
  Extract other information that is needed
*/
for (loop = 0; loop < *nscenes; loop++)
    {
    /*
      Get block address
    */
    if (strcmp(ptype,"TMR") == 0)
	strncpy(ctemp,&record[loop][195],8);
    else
	strncpy(ctemp,&record[loop][200],8);

    ctemp[8] = '\0';
    block_add[loop] = atol(ctemp);

    /*
      Get the scene id
    */
    strncpy(scene[loop],&record[loop][10],16);
    scene[loop][16] = '\0';

    /*
      Generate an output file name based on the scene id
    */
    if (strncmp(ptype,"TM",2) == 0)
       sprintf(outname[loop],"LT%s",scene[loop]);
    else
       sprintf(outname[loop],"LM%s",scene[loop]);
    outname[loop][18] = '\0';

    /*
      Get the complete or partial scene flag
    */
    strncpy(wbuf,&record[loop][80],1);
    wbuf[1] = '\0';
    complete[loop] = atol(wbuf);
    }

/* The table file for some TMA browse tapes seems to have duplicate
   metadata records.  Let's get rid of them.*/
if (strcmp(ptype,"TMA") == 0)
    {
    sllist[*nscenes] = 0; /* Just to be sure */
    count = 0;
    for (loop = 0; loop < *nscenes; loop++)
        {
        if (sllist[loop] != sllist[loop+1])
           {
           sllist[count] = sllist[loop];
           block_add[count] = block_add[loop];
           strcpy(scene[count],scene[loop]);
           strcpy(outname[count],outname[loop]);
           complete[count] = block_add[loop];
           count++;
           }
       } 
/*    printf("nscenes = %d count = %d\n",*nscenes,count);*/
    *nscenes = count;
    }
}
