#ifndef PROTOS_H
#define PROTOS_H

void calcorn
(
    long clat_l,
    long clon_l,
    int rectec,
    double *rtnlat,
    double *rtnlon,
    int sat
);

double cnvgeo
(
    long coord,
    int int_type
);

long cnvlong
(
    double dd,
    int int_type
);

void deg2min
(
    double latlon,			/* lat or long value to convert (degrees)*/
    long *totmin 		/* total minutes 			*/
);

void getdata
(
    FILE *fp,
    char outname[][CMLEN],
    long sllist[],
    char *hosin,
    char infiles[][CMLEN],
    long *nscenes,
    char *ptype,
    long complete[],
    char scene[][17],
    long block_add[]
);

void getname
(
    char *scene,			/* scene id to be checked		*/
    char *tapeid,			/* tapeid passed in			*/
    long sl,			/* starting line number			*/
    long *use_flag,			/* flag to determine to complete scene or
				   to check for validity -- returns
				   TRUE to process and FALSE to skip	*/
    long *position,			/* position in the db file to seek to   */
    char *ptype,                 	/* product type                         */
    FILE **fp1,			/* File pointer into db file		*/
    long block_add,			/* block address			*/
    long *rectec,			/* Recording type			*/
    long *satnum,			/* Satellite number			*/
    double center[2]		/* Center latitude/logitude (degrees)	*/
);

void getpar
(
    struct PARBLK *vblock,	/* pointer to TAE parameter block            */
    char *hosin,         	/* host file names of input images 	     */
    char *ptype,			/* product type 		             */
    char *tapeid		/* tapeid				     */
);

int proces
(
    char *hosin,			/* host file names of input images      */
    char *ptype,			/* product type                         */
    struct LINE *brw_line,		/* header record for output file     	*/
    char *tapeid			/* tapeid				*/
);

int procesx
(
    char *hosin,			/* host file names of input images      */
    char *ptype,			/* product type                         */
    struct LINE *brw_line,		/* header record for output file     	*/
    char *tapeid			/* tapeid				*/
);

void setup_head
(
    struct LINE *brw_line,	/* header for the output browse file 	*/
    long nbnd,			/* number of bands 			*/
    long outlines,		/* number of output lines		*/
    long outsamps,		/* number of output samples		*/
    char *sceneid,		/* sceneid of the LAS image 		*/
    double center[],		/* Center latitude/longitude of scene	*/
    int rectec,
    int sat,
    long minval,
    long maxval,		/* Min and Max values of image data	*/
    long pnt0,                   /* Value at  0.05 percent of image data */
    long pnt1,                   /* Value at  2.5  percent of image data */
    long pnt2,                   /* Value at 97.5  percent of image data */
    long mean			/* Average value of image data		*/
);

int updb
(
    FILE *fp1,			/* File pointer into db file		*/
    long position,			/* position in the db file to seek to   */
    char *scene,                    /* scene id 				*/
    char *tapeid                   /* tapeid				*/
);

#endif
