/****************************************************************************
NAME:		UPDB	

PURPOSE:   	Updates the database record to indicate that the browse
		was generated.

VERSION	 	DATE		AUTHOR
-------	 	----		------	
1.0		Jun-95		D. Hollaren

*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "las.h"
#include "adapsutil.h"
#include "exbrows.h"
#include "protos.h"

int updb
(
    FILE *fp1,			/* File pointer into db file		*/
    long position,			/* position in the db file to seek to   */
    char *scene,                    /* scene id 				*/
    char *tapeid                   /* tapeid				*/
)
{
long nonfatal = 1;		/* nonfatal error flag			*/

char buffer[100];		/* input buffer				*/
char disk[CMLEN];               /* path of LBTABLES directory           */
char logdir[CMLEN];		/* directory of logfiles		*/
char logkey[16];		/* key to be written to logfile if error*/
char string[CMLEN];		/* string to be written to logfile	*/

/*
  Get log file
*/
strcpy(disk,getenv("LBLOG"));
sprintf(logdir,"%s/reformat.log",disk);
sprintf(logkey,"%s",tapeid);

/*
  Reposition the file pointer to the database record just processed
*/
fseek(fp1,position,0);

/*
  Read the record
*/
if (fgets(buffer,DBREC,fp1) == NULL)
    {
    sprintf(string,"Error reading db record for scene %s",scene);
    c_wrtlog(logdir, logkey, "getname-error", string);
    c_errmsg(string, "getname-rdb",&nonfatal);
    return(E_FAIL);
    }

/*
  Add the processed flag (YES)
*/
strncpy(&buffer[DBREC-5],"YES",3);

/*
  Seek back to the beginning of the record
*/
fseek(fp1,position,0);

/*
  Write the updated buffer
*/
if (fputs(buffer,fp1) < 0)
    {
    sprintf(string,"Error completing db record for scene %s",scene);
    c_wrtlog(logdir, logkey, "getname-error", string);
    c_errmsg(string, "getname-comp",&nonfatal);
    return(E_FAIL);
    }

/*
  Log the completion of the scene browse creation
*/
sprintf(string,"Scene %s is complete", scene);
c_wrtlog(logdir, logkey, "exbrows-comp", string);

return(E_SUCC);
}
