/*******************************************************************************
FUNCTION:	stopreform

PURPOSE:	Stop the REFORMAT function at the next convenient time


Version  Date   Programmer       Reason
-------  -----  ---------------  -----------------------------------------------
  1.0    07/92  J.Fenno          Development
  1.2    01/93  J.Fenno          Modified to put the tape drive semaphores in
				 ADAPSTABLES instead of ADAPSARC.  This will
				 provide a common location for systems running
				 AUTOSTACK under ADAPS and Global 1k.
  1.3	 10/94	T.Mittan	 Stole form STOPAUTO, modified for REFORMAT


PROJECT: ADAPS
*******************************************************************************/
#include <stdio.h>
#include <math.h>
#include "las.h"
#include "stopreform.h"


struct PARBLK vblock;        /* TAE parameter block                           */
long std_out;                /* standard output file                          */


main()
{
char drive[CMLEN];         /* Tape drive being stacked by AUTOSTACK           */
char file_names[1][CMLEN]; /* For call to c_complt                            */
char *ptr;                 /* String pointer                                  */
char string[CMLEN];        /* Temporary string                                */
char tabledir[CMLEN];      /* ADAPSTABLES directory                           */

long fatal    = -1;        /* Fatal error flag                                */
long i;                    /* For call to c_complt                            */
long nonfatal =  1;        /* Nonfatal error flag                             */

struct VARIABLE *p_find(); /* Function to find a TAE variable                 */
struct VARIABLE *parm;     /* Ptr to a TAE variable                           */


/* Initialize LAS
-----------------*/
c_inlas(&vblock, &std_out);


/* Get the environment or logical variable that points to the
   directory containing all of the archive images to be stacked
---------------------------------------------------------------*/
ptr = (char *)getenv("LBTABLES");
if (ptr == NULL)
    {
    c_errmsg("Error retrieving LBTABLES", "stopstack-envron", &nonfatal);
    c_errmsg("Fatal error encountered", "stopstack-fatal", &fatal);
    }
strcpy(tabledir, ptr);
strcat(tabledir, "/");


strcpy(drive,"0");
/* Stop the specified reform function
-----------------------------------*/
if (create_semaphore(tabledir, "reform", drive, "stop") == E_SUCC)
    {
    sprintf(string, "REFORM_LB has been signaled to stop");
    c_errmsg(string, " ", &nonfatal);
    }
else
    {
    sprintf(string, "REFORM_LB is not currently running");
    c_errmsg(string, "stopreform-norun", &nonfatal);
    c_errmsg("Fatal error encountered", "stopreform-fatal", &fatal);
    }

i = 0;
c_complt("stopreform", file_names, &i);
}
