#ifndef LJSUPPORT_H
#define LJSUPPORT_H

int chkbat
(
    struct PARBLK *vblock
);

long crfabort
(
        long fd,
        long seqnum,
        long errmode
);

long crfcl
(
        long fd,                /* (I) file descrip opened to the CRF */
        long errmode            /* (I) errmode, TRUE => do not return */
);

long crfdone(void);

long crfinit
(
    char *prog
);

long crfop
(
        long mode,              /* (I) type of file access, READ, UPDATE */
        long errmode,           /* (I) errmode, TRUE => do not return */
        long abflg,             /* (I) abort flage (IGNORE or ABORT on ^C */
        long *fd,               /* (O) file descrip opened to the CRF */
        long *crflg,            /* (O) create flag, set TRUE if file created */
        long *totrec            /* (O) number of records currently in the CRF */
);

long crfpr
(
        struct LJ_PRINTER printer[],   /* (O) printer configuration */
        long *pcnt,                    /* (O) number of printers defined */
        long errmode                   /* (I) errmode, TRUE => do not return */
);

long crfrd
(
        long fd,                /* (I) file descrip opened to the CRF */
        long errmode,           /* (I) errmode, TRUE => do not return */
        long recnmr,            /* (I) record number to be read */
        struct recfmt *rec      /* (O) structure to read record into */
);

long crfrdhdr
(
        long fd,                /* (I) file descrip opened to the CRF */
        long errmode,           /* (I) errmode, TRUE => do not return */
        struct hdrfmt *hdr      /* (O) structure to read header into */
);

long crfwr
(
        long fd,                /* (I) file descrip opened to the CRF */
        long errmode,           /* (I) errmode, TRUE => do not return */
        long recnmr,            /* (I) record number to be written */
        struct recfmt *rec      /* (I) structure to write record from */
);

long crfwrhdr
(
        long fd,                /* (I) file descrip opened to the CRF */
        long errmode,           /* (I) errmode, TRUE => do not return */
        struct hdrfmt *hdr      /* (I) header structure to be written to CRF */
);

long crferr
(
        char *msg,
        long errmode
);

void crfx
(
        long sig
);

long crfchk
(
        long fix_flag
);

int delreq
(
    struct LJ_PRINTER printer[],
    long pcnt,
    long fd,
    long nrec,
    long *seqptr,
    int count
);

int getuser
(
    char *user
);

long lj_chkuser
(
    struct LJ_PRINTER printer[],
    long pcnt,
    struct recfmt *rec
);

int print_crf
(
        struct LJ_PRINTER printer[],
        long pcnt,
	char *prtfile,
	long seqnum[],
	char *status_flag[],
	char *media_flag[],
	char *outform
);

int rparm
(
    struct PARBLK *blkptr,
    struct recfmt *rec,
    struct LJ_PRINTER printer[],/* printer definition block */
    long pcnt,                  /* number of printers defined */
    long prog                   /* calling program: PADD, PMOD, or REPORT   */
);

long setlad(void);

#endif
