/*
PROGRAM HISTORY:
  Version       Date        Author      Change Request
  -------       ----        ------      --------------
   1.0           8/93       K. Gacke    initial development -- copied from QLP

PROJECT:        Unix Color FIRE

*/


#include <stdio.h>
#include "las.h"
#include "lj.h"
#include "local_protos.h"

int cplut
(
	struct recfmt *rec,
	struct lut *tlut,
	long which
)
{
long i,j;
long nonfatal = 1;
char emsg[CMLEN];

switch (which)
    {
    case FR_REC:
	for (i=0; i<NLUT; i++)
    	    {
	    if (rec->enhlut[i].ne > MAXPT)
		{
		sprintf(emsg,"Request consists of %d enh map pts, max is %d\n",
			rec->enhlut[i].ne,MAXPT);
		c_errmsg(emsg," ",&nonfatal);
		c_errmsg("User is required to modify enhancement map points",
			" ",&nonfatal);
		rec->enhlut[i].ne = MAXPT;
	  	}
    	    for (j=0; j<rec->enhlut[i].ne; j++)
		{
		tlut[i].in[j] = rec->enhlut[i].in[j];
		tlut[i].out[j] = rec->enhlut[i].out[j];
		}
	    tlut[i].ne = rec->enhlut[i].ne;
	    strcpy(tlut[i].desc,rec->enhlut[i].desc);
	    }
	break; 
    case TO_REC:
	for (i=0; i<NLUT; i++)
    	    {
	    if (tlut[i].ne > MAXPT)
		{
		sprintf(emsg,"Request consists of %d enh map pts, max is %d\n",
			tlut[i].ne,MAXPT);
		c_errmsg(emsg," ",&nonfatal);
		c_errmsg("User is required to modify enhancement map points",
			" ",&nonfatal);
		tlut[i].ne = MAXPT;
	  	}
    	    for (j=0; j<tlut[i].ne; j++)
		{
		rec->enhlut[i].in[j] = tlut[i].in[j];
		rec->enhlut[i].out[j] = tlut[i].out[j];
		}
	    rec->enhlut[i].ne = tlut[i].ne;
	    strcpy(rec->enhlut[i].desc,tlut[i].desc);
	    }
	break;
    }
return(1);
}
