#ifndef LOCAL_PROTOS_H
#define LOCAL_PROTOS_H

#include "struct.h"

long lj_assign_calcon
(
        struct recfmt *rec,
        long *calnmr,
        long *connmr
);

long lj_format_annot
(
    struct recfmt *rec,
    struct IMGOPT *imgopt
);

int lj_setopt
(
    struct LJ_PRINTER printer[],
    struct recfmt *rec,
    struct IMGOPT *imgopt,
    long prtflg
);

unsigned short lj_byteswap(unsigned short n);

int lj_logmess
(
    long level,		/* verbose level of msg */
    char *frmid,	/* current frame id */
    char *message	/* character string to be written to log file*/
);

int assign_format
(
	struct LJ_PRINTER printer[],
	struct recfmt *rec,
	struct IMGOPT *imgopt,
	long nannot_line
);

int br_enhance
(
    int  *in,
    float *out,
    long *ne,
    float *lut
);

int br_calbrt
(
    int  *in,
    float *out,
    long *ne,
    float *lut
);

int br_contrl
(
    int  *in,
    float *out,
    long *ne,
    float *lut
);

int br_punt
(
    float *cal,
    float *con,
    float *enh,
    short *lut
);

int cplut
(
    struct recfmt *rec,
    struct lut *tlut,
    long which
);

int getchrg
(
    char *chrg
);

int reqown
(
    struct LJ_PRINTER printer[],
    long pcnt,
    struct recfmt *rec
);

int rddltf
(
    char *colorord,		/* color order (RGB, CMY, CMYK, BW) */
    char *fname,			/* file name specification of DLTF file */
    char *dltf,			/* dltf entry name */
    struct lut lut[]		/* the enh map points to be returned */
);

int rdlut
(
    char *colorord,	/* (I) color order (RGB, CMY, CMYK, or BW) */
    int fnmr,		/* (I) number of LUT to be opened */
    char *fname,		/* (I) name of LUT to be opened (if fnmr=NULLVAL) */
    char ftype[],	/* (I) LUT file type (ENH, CAL, or CON) */
    struct lut lut[]	/* (O) structure to contain LUT map points */
);

int setenh
(
    char *colorord,
    int fnmr,
    char *fname,
    struct lut enhlut[],
    long enhflg
);

#endif
