/******************************************************************************
FUNCTION:	GETPAR

PURPOSE:	Get the input parameters

ALGORITHM REFERENCES	none
******************************************************************************/

#include <stdio.h>
#include "las.h"

FUNCTION getpar(vblock, hpath, path, row, date)

struct PARBLK *vblock;	/* TAE parameter block  			*/
char   hpath[CMLEN];	/* drive (disk) where CD was mounted		*/
long   *path;		/* WRS path number				*/ 
long   *row;		/* WRS row number				*/
char   date[9];		/* Acquisition date				*/

{
struct VARIABLE *p_find(); /* function to find a TAE variable		*/
struct VARIABLE *val;	/* pointer to a TAE variable			*/

long std_out;		/* standard output 				*/

/* Initialize LAS
-----------------*/
c_inlas(vblock, &std_out);

/* Retrieve CD path
-------------------*/
val = p_find(vblock, "$TAPEDRV");
strcpy(hpath, SVAL(*val, 0));

/* Retrieve WRS path number 
---------------------------*/
val = p_find(vblock, "WRSPATHN");
*path = IVAL(*val, 0);

/* Retrieve WRS row number
--------------------------*/
val = p_find(vblock, "WRSROWN");
*row = IVAL(*val, 0);

/* Retrieve acquisition date
----------------------------*/
date[0] = '\0';
val = p_find(vblock, "DATE");
if (val->v_count == 1)
    strcpy(date, SVAL(*val, 0));
}
