/******************************************************************************
FUNCTION:	LTWGCD

PURPOSE:	Mounts a CD and then scans its directory structure to locate
		an image based on its WRS path and row entries and its
		acquisition date

Date   Author		Change Request
-----  --------------   -----------------------------------------------
6/95   C. Engebretson	Original development

******************************************************************************/

#include <stdio.h>
#include <string.h>
#include "las.h"
#include "util.h"

main()
{
struct PARBLK vblock;	/* TAE parameter block 				*/
long   path;		/* WRS path number				*/
long   row;		/* WRS row number				*/
char   date[9];		/* Acquisition date				*/
char   hpath[CMLEN];	/* Directory name				*/
char   foundpath[CMLEN];/* Image location				*/
char   *str_array[1];	/* Array for sending results to q_string	*/
long   zero = 0;	/* Zero constant				*/

foundpath[0] = '\0';

/* Retrieve the input parameters
--------------------------------*/
getpar(&vblock, hpath, &path, &row, date);

/* Build qualified directory path to mounted CD 
-----------------------------------------------*/
makepath(hpath);

/* Recurse through the CD's directory structure looking for image
-----------------------------------------------------------------*/
process_dir(hpath, path, row, date, foundpath);

/* Check to see if image was actually found
-------------------------------------------*/
if (strlen(foundpath) == 0)
    c_lasmsg(TRUE, "ltwgcd-image", "Image was not found on CD");

/* Write the pathname to the IMGLOC parameter
-------------------------------------------*/
str_array[0] = foundpath;
if (q_string(&vblock, "IMGLOC", 1, str_array, P_UPDATE) != SUCCESS)
    c_lasmsg(TRUE, "ltwgcd-qstring", "Error writing host name to vblock");

/* Send the parameter block to TAE
----------------------------------*/
if (q_out(&vblock) != SUCCESS)
    c_lasmsg(TRUE, "ltwgcd-vblock", "Error returning host file name");

/* Issue the completion message
-------------------------------*/
c_complt("LTWGCD", foundpath, &zero);
} 
