#ifndef PROTOS_H
#define PROTOS_H

int mknhdr
(
    char ordnum[],          /* PDS Order Number             */
    char ordid[],           /* Order id                     */
    int  *nvol,             /* Number of volumes total      */
    int  bpv[]              /* bands per volume             */
);

int getpar
(
    struct PARBLK *vblk,    /* pointer to initial TAE parameter block */
    char ordnmbr[9],        /* PDS product name                       */
    char mtype[5],          /* PDS media type                       */
    long *nunit,            /* unit Number of this order              */
    long *untnmbr,          /* Number of units                        */
    long *density,          /* Output media density                 */
    char filenames[25][100],/* Disk filenames                         */
    long *bil_bsq,          /* Value for order type                   */
    long *bands,            /* Number of bands                        */
    long *no_files,         /* # of files are in filenames array      */
    char demflg[2],         /* DEM flag (Y/N)                         */
    char rec_length[80],    /* Record length for bands file           */
    char tstamp[100],       /* Time stamp                             */
    int  *ndf_version         /* NDF format version */
);

int getpar2 
(
    struct PARBLK *vblk,        /* pointer to initial TAE parameter block   */
    char prod_nbr[80],          /* PDS product name		                */
    char ordnmbr[80],           /* PDS order number                         */
    char rad_calib[80],         /* Rad Calibration field from Work file     */
    char prod_code[80],         /* Product Code from Work file              */
    char user_ori[80],          /* User Orientation from Work file          */
    char rad_enha[80],          /* Rad Enhancement from Work file           */
    char dem_line[80],          /* DEM file existance from Work file        */
    char rms_error[80],         /* Rms Error from Work file                 */
    char project[80],           /* Value for project field                  */
    char scene_id[80],          /* Value for Scene_id                       */
    char sequence[10][80],      /* Tape Location values                     */
    long *no_seq,               /* How many tapes are written               */
    char filename[100],         /* Name of the Header file                  */
    char nbr_scenes[10],        /* Number of Scenes from Work file          */
    char spec_band[80],         /* Spectra Band from Work file              */
    char code[80],              /* Project Source                           */
    char mtype[80]              /* Output media type			*/
);

#endif
