/**************************************************************************
NAME: PARMMETA_OUT
 
PURPOSE: Gets the user-specified parameters for NLDC321_METAOUT
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    03/98 M.Lundblad        C   Initial Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char ingestdir[CMLEN],     /* Ingest directory                          */
    char datadir[CMLEN],       /* Data directory                            */
    char sceneid[17],          /* Scene Identifier                          */
    char oldtapeid[10][7],     /* Array of old tape Id's                    */
    char newtapeid[7],         /* New storage Location                      */
    long *tape_count           /* Number of Old Tape Id's                   */
)

{
struct VARIABLE *var;       /* ptr to a variable in the vblk          */
 
long ii=0;


/* Get ingest directory from parameter block
---------------------------------------------*/
var = p_find(vblk,"INGESTDIR");
strcpy(ingestdir,SVAL(*var,0));

/* Get data directory from parameter block
-------------------------------------------*/
var = p_find(vblk,"DATADIR");
strcpy(datadir,SVAL(*var,0));

/* Get SceneId from parameter block
------------------------------------*/
var = p_find(vblk,"SCENEID");
strcpy(sceneid,SVAL(*var,0));

/* Get OldTapeID's from parameter block
----------------------------------------*/
var = p_find(vblk,"OLDTAPEID");
for (ii=0; ii < var->v_count; ii++)
  {
  strcpy(oldtapeid[ii],SVAL(*var,ii));
  }

*tape_count = var->v_count;

/* Get NewTapeID from parameter block
--------------------------------------*/
var = p_find(vblk,"NEWTAPEID");
strcpy(newtapeid,SVAL(*var,0));

return(E_SUCC);
}

