/**************************************************************************
NAME: PARM_READMETA
 
PURPOSE: Gets the user-specified parameters for NLDC321_READMETA
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    03/98 M.Lundblad        C   Initial Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char directory[CMLEN],     /* Working directory                      */
    char format[13],           /* Scene Identifier                       */
    char tapeid[10][7],        /* Array of tape ids                      */
    long *tape_count          /* Count of tape ids                      */
)

{
struct VARIABLE *var;      /* ptr to a variable in the vblk          */
 
long ii=0;

/* Get the directory path
-----------------------------*/
var = p_find(vblk,"DIRECTORY");
strcpy (directory, SVAL(*var,0));

/* Get Format from parameter block
-----------------------------------*/
var = p_find(vblk,"FORMAT");
strcpy(format,SVAL(*var,0));

/* Get Tape Ids from parameter block
-------------------------------------*/
var = p_find(vblk,"TAPEID");
for (ii=0; ii < var->v_count; ii++)
   strcpy(tapeid[ii],SVAL(*var,ii));

*tape_count = var->v_count;

return(E_SUCC);
}

