/**************************************************************************
NAME: PARMFAHDR_MERGE
 
PURPOSE: Gets the user-specified parameters for FAHDR_MERGE
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    04/98 M.Lundblad        C   Initial development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE and UNIX.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char directory[CMLEN],
    long *total_hdr,
    char infile[CMLEN]
)

{
struct VARIABLE *var;       /* ptr to a variable in the vblk  */
 
/* Get the directory path
-------------------------*/
var = p_find(vblk,"DIRECTORY");
strcpy (directory, SVAL(*var,0));

/* Get total Headers      
------------------------*/
var = p_find(vblk,"TOTAL_HDR");
*total_hdr = IVAL(*var,0);


/* Get the input file names
-----------------------------*/
var = p_find(vblk,"INFILE");
strcpy (infile, SVAL(*var,0));

return(E_SUCC);
}

