/**************************************************************************
NAME: PARMFAST_READ
 
PURPOSE: Gets the user-specified parameters for NLDCFAST_READ
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    04/98 M.Lundblad        C   Initial development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char directory[CMLEN],
    long *tape_count,
    char infile[CMLEN],
    long file_per_tape[295]
)

{
struct VARIABLE *var;       /* ptr to a variable in the vblk          */
 
long ii=0;


/* Get the directory path
--------------------------*/
var = p_find(vblk,"DIRECTORY");
strcpy (directory, SVAL(*var,0));


/* Get parameter for total # of input tapes
--------------------------------------------*/
var = p_find(vblk,"TAPE_COUNT");
*tape_count = IVAL(*var,0);


/* Get the input file names
----------------------------*/
var = p_find(vblk,"INFILE");
strcpy (infile, SVAL(*var,0));

/* Get the files per tape array
--------------------------------*/
var = p_find(vblk,"FILE_PER_TAPE");
for (ii=0; ii < var->v_count; ii++)
   file_per_tape[ii] = IVAL(*var,ii);

return(E_SUCC);
}

