/**************************************************************************
NAME: PARMNDF_MERGE
 
PURPOSE: Gets the user-specified parameters for NLDCNDF_MERGE
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    05/98 M.Lundblad        C   Initial development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE and UNIX.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char directory[CMLEN],
    char infile[CMLEN],
    long *nhdr,
    long *nbands,
    long *firsttape
)

{
struct VARIABLE *var;       /* ptr to a variable in the vblk  */
 
/* Get the directory path
--------------------------*/
var = p_find(vblk,"DIRECTORY");
strcpy (directory, SVAL(*var,0));

/* Get the input file names
----------------------------*/
var = p_find(vblk,"INFILE");
strcpy (infile, SVAL(*var,0));

/* Get number of headers      
-------------------------*/
var = p_find(vblk,"NHDR");
*nhdr = IVAL(*var,0);

/* Get number of bands
-----------------------*/
var = p_find(vblk,"NBANDS");
*nbands = IVAL(*var,0);

/* Get number of bands on first tape
-------------------------------------*/
var = p_find(vblk,"FIRSTTAPE");
*firsttape = IVAL(*var,0);

return(E_SUCC);
}

