/**************************************************************************
NAME: PARMNDF_READ
 
PURPOSE: Gets the user-specified parameters for NLDCNDF_READ
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    10/97 M.Lundblad        C   Initial development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char directory[CMLEN],
    long *tape_count,
    long *lone_dem,
    char infile[CMLEN]
)

{
struct VARIABLE *var;       /* ptr to a variable in the vblk          */
 
/* Get the directory path
------------------------------------------*/
var = p_find(vblk,"DIRECTORY");
strcpy (directory, SVAL(*var,0));


/* Get parameter for total # of input tapes
-----------------------------------------*/
var = p_find(vblk,"TAPE_COUNT");
*tape_count = IVAL(*var,0);


/* # of files in the last tape              
-----------------------------------------*/
var = p_find(vblk,"LONE_DEM");
*lone_dem = IVAL(*var,0);

/* Get the input file name base
------------------------------------------*/
var = p_find(vblk,"INFILE");
strcpy (infile, SVAL(*var,0));

return(E_SUCC);
}

