/**************************************************************************
NAME: PARMTRAN_READ
 
PURPOSE: Gets the user-specified parameters for NLDC321
 
PROGRAM HISTORY:
 
Version  Date  Programmer      Code  Reason
-------  ----- ----------      ----  ------
  1.0    10/97 M.Lundblad        C   Initial Development
 
COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
        Must be run under TAE.
PROJECT:  LAS
***************************************************************************/
 
#include <stdio.h>
#include <math.h>
#include <string.h>
#include "las.h"
 
int getpar
(
    struct PARBLK *vblk,
    char directory[CMLEN],
    long *tape_count,
    long tape_file[295],
    char infile[CMLEN]
)

{
struct VARIABLE *var;       /* ptr to a variable in the vblk          */
 
long ii=0;


/* Get the directory path
------------------------------------------*/
var = p_find(vblk,"DIRECTORY");
strcpy (directory, SVAL(*var,0));


/* Get parameter for total # of input tapes
-----------------------------------------*/
var = p_find(vblk,"TAPE_COUNT");
*tape_count = IVAL(*var,0);


/* Get files per volume
-----------------------*/
var = p_find(vblk,"TAPE_FILE");
for (ii=0; ii < var->v_count; ii++)
     tape_file[ii] = IVAL(*var,ii);


/* Get input file name base
------------------------------------------*/
var = p_find(vblk,"INFILE");
strcpy (infile, SVAL(*var,0));

return(E_SUCC);
}

