#define NMRIMG  3 			/* max # images */
#define MAX_DSIZE sizeof(float)		/* max # bytes per pixel */

#define SL	0
#define SS	1
#define NL	2
#define NS	3

struct NET_IMG
{
	unsigned char nl[4];		/* # lines */
	unsigned char ns[4];		/* # samples */
	unsigned char nbands[4];	/* # nbands */
	unsigned char idtype[4];	/* input image data type */
	unsigned char odtype[4];	/* output image data type */
	unsigned char outnl[4];		/* output image # lines */
	unsigned char outns[4];		/* output image # samples */
	unsigned char nmrimg[4];	/* number of images */
	unsigned char nmrlab[4];	/* number of label service files */
	char imgflg;			/* Flag to transfer image file */
	char minmax;			/* Flag to compute min max values */
	char histry;			/* Flag to copy input history records */
	char scaleflg;			/* Flag to apply scale/offset to image*/
	char insys[12];			/* input computer system */
	char outsys[12];		/* output computer system */
	char inspec[100];		/* input image specification */
	char outspec[100];		/* output image specification */
	char labspec[20][10];		/* label service file extensions */
	char errtext[100];		/* error buffer */
	char err;			/* error flag */
};


struct IMG_INFO
{
	double minval[MAXBND];		/* Minimum pixel values */
	double maxval[MAXBND];		/* Maximum pixel values */
	double scale;			/* Scale factor to be applied to image*/
	double offset;			/* Offset to be applied to image */
	long bands[NMRIMG][MAXBND+1];	/* Input image band specification */
	long idtype[NMRIMG];		/* Input image data type */
	long line_inc;			/* Line increment */
	long nbands[NMRIMG];		/* Input image band specification */
	long nmrimg;			/* Number of input images */
	long nmrlab;			/* Number of label service files */
	long odtype;			/* Output image data type */
	long samp_inc;			/* sample increment */
	long totbnd;			/* Total number of bands */
	long window[NMRIMG][4];		/* Input image window specification */
	long outwind[4];		/* Output image window size */
	char histry;			/* Flag to copy input history records */
	char imgflg;			/* Flag to transfer image file */
	char minmax;			/* Flag to compute min max values */
	char scaleflg;			/* Flag to apply scale/offset to image*/
	char sending;			/* flag to send or receive */
	char in[NMRIMG][CMLEN];		/* Array of input image host names */
	char innet[12];			/* Network system name of input image */
	char inspec[CMLEN];		/* Input image specification */
	char insys[12];			/* LAS system name of input image */
	char labspec[20][10];		/* List of Label Service file ext */
	char out[CMLEN];		/* Output image host name */
	char outnet[12];		/* Network system name of output image*/
	char outspec[CMLEN];		/* Output image specification */
	char outsys[12];		/* LAS system name of output image */
	char remote[40];		/* remote computer system name */
	char tin[NMRIMG][CMLEN];	/* Array of input image TAE names */
};

struct DSPIMG
	{
	unsigned char sl[4];
	unsigned char ss[4];
	unsigned char nl[4];
	unsigned char ns[4];
	unsigned char minval[4];
	unsigned char maxval[4];
	char tin[NMRIMG][CMLEN];	/* Array of input image TAE names */
	};

struct NET_DDR
{
	unsigned char sl[4];
	unsigned char ss[4];
	unsigned char nl[4];
	unsigned char ns[4];
	unsigned char nbands[4];
	unsigned char bands[NMRIMG][MAXBND+1][4];
	char err;
	char errtext[100];
};
