/* include file for ncp */

#ifdef EGNET
#define BUFFSZ 16384            /* logical buffer size */
#define PBUFFSZ 16384           /* physical blocksize for transfers */
#endif

#ifdef TCP
#define BUFFSZ 1048576            /* logical buffer size */
#if defined(unix) || defined(MULTINET)
#define PBUFFSZ 16384           /* physical blocksize for UNIX transfers */
#endif
#ifdef prime
#define PBUFFSZ 2048
#endif
#ifdef CMUTCP
#define PBUFFSZ 512            /* physical blocksize for VMS CMU transfers */
#endif
#ifdef MSDOS
#define PBUFFSZ 512             /* physical blocksize for MSDOS transfers */
#endif
#endif


#define BLKSZ 512

/*
 *      Ncp request structure.  This structure is exchanged between
 *      cooperating ncp's at startup to determine what is going on.
 *      As this structure is being transmitted across the network, we
 *      must be very careful about things like byte ordering.
 */
#define NET_DTYPE   0
#define NET_SENDING 1
#define NET_SYSTYPE 2
#define NET_ERROR   0
#define NET_REQUEST 1
struct NCPREQ
{
	K_TINY  netflg[4];		/* network flags: data_type, sending, */
					/*    and system type */
        K_TEXT your_pathname[PATHNAMESZ];/* receiver's filename */
        K_TEXT my_pathname[PATHNAMESZ]; /* originator's filename */
        K_UTINY blksz[4];               /* 32-bit blocksize (lsb first) */
        K_UTINY recsz[4];               /* 32-bit recordsize for FIXED type */
};

/*
 *      NCPACK is the response to an NCPREQ.  It contains the negotiated
 *      blocksize, the data type (in case it was left to default), and
 *      the system type of the slave side.
 */
struct NCPACK
{
	K_TINY netflg[4];		/* network flags: data_type, sending, */
					/*    and system type */
        K_UTINY blksz[4];               /* 32-bit negotiated blocksize */
};

struct SNDREQ
{
        K_TINY netflg[4];		/* network flags: error, request type */
        K_UTINY prot[4];
        K_TEXT from_pathname[PATHNAMESZ];
        K_TEXT to_pathname[PATHNAMESZ];
        K_TEXT errtext[ERSIZE];
};

struct SNDACK
{
        K_TINY netflg[4];		/* network flags: error */
        K_TEXT aerrtext[ERSIZE];
};

struct SYSREQ				/* source & destination systems */
{
	unsigned char insys[4];
	unsigned char outsys[4];
	unsigned char dtype[4];
};

/* request types */

#define IS_A_DIR 1
#define I_AM_DONE 2

/*
 *      data types
 *
 *      Alas, on Unix systems none of this is necessary.  However, for
 *      systems which insist upon imposing structure on files, the
 *      structure must be preserved in order to maintain usability of the
 *      data.  Note that the BINARY type is only appropriate between systems
 *      of the same type (e.g. VMS systems exchange RABs and FABs for BINARY
 *      files, thus allowing any VMS file type to be sent).
 */

#define DT_DEFAULT      0       /* use default (depending upon system type) */
#define DT_CHARACTER    1       /* variable length, LF terminated, ASCII */
#define DT_BINARY       2       /* host dependent binary format */
#define DT_TAE          3       /* TAE image file */
#define DT_FIXED        4       /* fixed length records with arbitrary data */
#define DT_DFILE        5       /* binary data file */

#ifdef unix
#define DIR_SYM '/'
#endif
#ifdef vms
#define DIR_SYM ']'
#endif
#ifdef prime
#define DIR_SYM '>'
#endif
#ifdef MSDOS
#define DIR_SYM '\\'
#endif

#define UTHOST "edcsgs3"	/* UniTree Host */

#ifdef vax
#define time_t long
#endif
