/* header file for the process server and those programs */
/* wishing to utilize process server    */

#ifndef TADDRSZ
#define TADDRSZ 16
#endif

#define PATHNAMESZ 256
#define MAXFILES 100

#define USERCODESZ 40   /* maximum size of user name */
#define TASKNAMESZ 40   /* maximum size of task name */
#define PWSIZE 32       /* maximum size of password */
#define ERSIZE 80       /* maximum size of error message */
#define CHGSIZE 8       /* maximum size of charge code */

/*
 *      Level of informative/error/debug messages.
 */
#define VERBOSE 1       /* keep the user informed as to what's going on */
#define ERRBIT  2       /* log error messages */
#define TRACE   4       /* full debugging -- beaucoup messages */

struct PSREQ            /* this structure represents the protocol*/
{                       /* between the process server and the remote user */
        char user_addr[16];             /* transport address */
        char fill[4];			/* fill */
        char e_user_code[USERCODESZ];   /* user name */
        char passwd[PWSIZE];            /* password for e_user_code */
        char taskname[TASKNAMESZ];      /* name of task to run */
        long err;                       /* true if an error occurred */
        char errtext[ERSIZE];           /* text of error message */
        char chgcode[CHGSIZE];          /* charge code */
        char system[32];
};

#ifdef TCP
#define PSERVER_PORT 2048
#ifdef CMUTCP			/* CMU definitions -- info is stored in */
#include <iodef.h>		/* sys$library:network.req */

#define TCP$OPEN        IO$_CREATE
#define TCP$CLOSE       IO$_DELETE
#define TCP$SEND        IO$_WRITEVBLK
#define TCP$RECEIVE     IO$_READVBLK
#define TCP$ABORT       IO$_DEACCESS
#define TCP$STATUS      IO$_ACPCONTROL
#define TCP$INFO        IO$_MODIFY
#define TCP$GTHST	IO$_SKIPFILE

#define ACTIVE          1
#define PASSIVE         0
#define ASYNCH          1
#define SYNCH           2

#define OPF$MODE        1
#define OPF$NOWAIT      2
#define OPF$ADDRFLAG    4

#define TCP_PROTOCOL    0
#define UDP_PROTOCOL    1

#define GTH_LCLHST 	0
#define GTH_NAMADR	1	/* name to internet address translation */
#define GTH_ADRNAM	1	/* internet address to name translation */

struct hostent 
	{
	char *h_name;
	char **h_aliases;
	long h_addrtype;
	long h_length;
	char **h_addr_list;
	};
#endif
#endif
