#ifndef QLPSUPPORT_H
#define QLPSUPPORT_H

int getuser
(
    char *user
);

int qlp_dnprinter
(
    char *pname,
    struct QLP_PRINTER printer[],
    long pcnt
);

/*
*  Check status of specified printer.  If not busy return TRUE; otherwise 
*  return FALSE.  Note the configuration file specifies if "lp" or "lpr"
*  is used to access the printer.
*/
int qlp_chkprinter
(
    struct QLP_PRINTER *printer
);

/*
*   Check to see if user is an owner, privilged, or normal privileges
*   of the specified printer within the "rec" structure.  If printer 
*   is not specified, search for appropraite printer type (in this case, 
*   return the lowest set of privileges common to all printers within
*   the specified printer type).
*/
int qlp_chkuser
(
    struct QLP_PRINTER printer[],
    long pcnt,
    struct recfmt *rec
);

int qlp_getprinter
(
    struct QLP_PRINTER printer[],
    long *pcnt			/* number of printers defined */
);

int qlp_putprinter
(
	char *pr,
	char *pstat
);

int qlp_logit
(
    struct recfmt *rec,
    struct IMGOPT *imgopt
);

int qlp_setopt
(
    struct QLP_PRINTER *printer,
    struct recfmt *rec,
    struct IMGOPT *imgopt
);

int qlp_getpid
(
    struct QLPPID *qlppid
);

int qlp_putpid
(
    struct QLPPID *qlppid
);

int qlp_dmpimg_ps
(
    struct QLP_PRINTER *printer,
    struct recfmt *rec,
    struct IMGOPT *imgopt,
    char *calfile,
    char *confile,
    long band
);

int rparm
(
    int argc,           /* argument count */
    char *argv[],       /* argument vector */
    long tae,           /* TAE flag, TRUE=>valid param block */
    struct PARBLK *blkptr,  /* TAE param block */
    struct QLP_PRINTER printer[],/* printer definition block */
    long pcnt,              /* number of printers defined */
    struct recfmt *rec,     /* QLP record block */
    long prog               /* calling program: PADD, PMOD, or REPORT   */
);

long setlad(void);

int chkbat
(
    long tae,
    struct PARBLK *vblock
);

void delreq
(
    struct QLP_PRINTER printer[MAX_QLP_PRINTER],
    long pcnt,
    long fd,
    long nrec,
    int *seqptr,
    int count
);

int font2
(
    char text[],
    int curlin,
    int bg,
    int fg,
    int sf,
    unsigned char buf[]
);

int qlp_usage
(
    int prog
);

#endif
