#ifndef I_SLINTFACE
#define I_SLINTFACE
/*
**...The session layer well known attach mailbox name
*/
#define SLATCHSIZE 8
#define SLATCHNAME "SLATTACH"
/*
**...The integer code returned from request, responce and general
**...indication calls are all defined tokens which begin with SS (for
**...Session Status).
*/
/*BEGINSS - used by MKSLERR program, do not remove*/
#define SS_NOVALUE    (0)     /*no value*/
#define SS_SUCCESS    (1)     /*success*/
#define SS_REQUIREX   (2)     /*invalid requirements parameter*/
#define SS_REQUESTX   (3)     /*invalid request*/
#define SS_TOKENX     (4)     /*invalid token parameter*/
#define SS_CLABORT    (5)     /*client requested abort*/
#define SS_PROTERROR  (6)     /*protocol error*/
#define SS_NOREASON   (7)     /*no reason determined for abort*/
#define SS_TOOLONG    (8)     /*data too long*/
#define SS_SLNAMEX    (9)     /*invalid session name*/
#define SS_CNTBAD     (10)    /*'SCNT_xxx' value invalid*/
#define SS_NOACTIVITY (11)    /*activity turned off*/
#define SS_CLNOTFOUND (12)    /*peer client not found by SL*/
#define SS_NOKMEMORY  (13)    /*kernel ran out of memory*/
#define SS_RESULTX    (14)    /*invalid connect result value*/
#define SS_BADID      (15)    /*kernel buffer or mailbox id invalid*/
#define SS_TLDISC     (16)    /*transport disc., node down or unknown*/
#define SS_SLDOWN     (17)    /*SL not executing*/
#define SS_BUGCHECK   (18)    /*oh,oh-contact designer of SL*/
#define SS_CLRESERVED (19)    /*client name reserved via installation*/
#define SS_CLATTACHED (20)    /*client with same name attached*/
#define SS_NOMESSAGE  (21)    /*mailbox did not contain message*/
#define SS_ACTIVATEX  (22)    /*client could not be activated*/
#define SS_CLNOEXE    (23)    /*no client executable located*/
#define SS_DETACH     (24)    /*client detached with ongoing sessions*/
#define SS_CLNOPARSE  (25)    /*failure to parse client executable file*/
/*ENDSS - used by MKSLERR program, do not remove*/
/*
**...All structure fields which are arrays have a maximum length.  All
**...such defines begin with 'SMAX'.  To exceed these maximum lengths
**...is to court an access violation!
*/
#define SMAX_CLIENTNAME     (16)  /*client name*/
#define SMAX_SLNAME         (40)  /*session layer address*/

#define SMAX_CNDATA      (64)     /*connection data*/
#define SMAX_DTDATA      (32765)  /*data request*/
#define SMAX_DTPEEKABOO  (2)      /*first bytes from data buffer*/
#define SMAX_ABDATA      (3)      /*abort data*/
#define SMAX_RLDATA      (32)     /*release data*/
#define SMAX_AEDATA      (6)      /*activity end data*/
#define SMAX_ASDATA      (64)     /*activity start data*/
#define SMAX_PTDATA      (1)      /*please token data*/

#define SMAX_ACTID       (3)      /*activity identifier*/
/*
**...All token defines begin with 'STKN'. Use them for assigning
**...tokens during connection establishment and to pass tokens around.
*/
#define STKN_INITIATOR (00)      /*token initiators side*/
#define STKN_ACCEPTOR  (01)      /*token acceptors side*/
#define STKN_CHOICE    (02)      /*token acceptors choice*/
#define STKN_RESERVED  (03)      /*token not avaliable*/
#define STKN_AVALIABLE    (01)   /*token present on this side*/
#define STKN_NOTAVALIABLE (00)   /*token not avaliable on this side*/
#define STKN_GIVE      (01)      /*give token to peer*/
#define STKN_NOGIVE    (00)      /*do not give token to peer*/
/*
**...Indications received from the SL begin with 'SIND'.  Below are
**...the types of indications a client may receive.  (Note the numbers
**...are unique from 'SCON...' tokens.
*/
#define SIND_CONNECT     (1)   /*connection*/
#define SIND_ABORT       (2)   /*oh,oh: bad news abort*/
#define SIND_DATA        (3)   /*good old data transmition*/
#define SIND_RELEASE     (4)   /*session release*/
#define SIND_STARTACT    (6)   /*activity begin*/
#define SIND_ENDACT      (7)   /*activity end*/
#define SIND_PLZTKN      (11)  /*please (give me) tokens*/
#define SIND_GIVETKN     (12)  /*give tokens*/
/*
**...Confirmations received from the SL begin with 'SCON'.  Below are
**...the types of confirmations a client may receive.  (Note the
**...numbers are unique from 'SIND...' tokens.
*/
#define SCON_REFUSE      (5)   /*peer refused the connection*/
#define SCON_CONNECT     (8)   /*connection*/
#define SCON_RELEASE     (9)   /*session release*/
#define SCON_ENDACT      (10)  /*activity end*/
/*
**...Connect defines begin with 'SCNT' and are placed within the
**...connect structure result member by an acceptor client to either
**...accept or refuse the connection attempt.
*/
#define SCNT_ACCEPT  (1)       /*accept a connection*/
#define SCNT_REFUSE  (2)       /*refuse a connection*/
/*
**...If a connection if refused (ind->type = SCON_REFUSE) then the
**...connection result member contains one of the following refusal
**...tokens, which all begin with 'SREF'.
*/
#define SREF_NOTREFUSED (-1)    /*no refusal*/
#define SREF_NOREASON   (0)     /*no reason*/
#define SREF_PVERSIONX  (1)     /*unknown protocol version*/
#define SREF_SUBSETX    (2)     /*unsupported subset*/
#define SREF_CNPARMX    (3)     /*connect parameter invalid*/
#define SREF_ACCADRX    (4)     /*acceptor address invalid*/
#define SREF_REJECT     (5)     /*client rejected connection*/
#define SREF_ACCEPTORX  (6)     /*acceptor unknown or not found*/
/*
**...Default value defines for SL version 0.5
*/
#define SRQR_DEFAULT    (0x220)   /*version 0.5 requirements*/
/*
**...Bit field defines
*/
#define ON  (1)                  /*a bit turned on*/
#define OFF (0)                  /*a bit turned off*/
/*
**...Defines for all structures
*/
#define SREQUIRE      union  srequire
#define STOKEN        union  stoken

#define SLCONNECT      struct slconnect
#define SLABORT        struct slabort
#define SLACTIVITY     struct slactivity
#define SLDATA         struct sldata
#define SLRELEASE      struct slrelease
#define SLTOKEN        struct sltoken
#define SLSTRUCT       union  slstruct
#define SLINDICATION   struct slindication
/*
**...During connection establishment, the client may specifiy what is
**...required of the session layer to get the client's job done.
**...The client may either set the individualy bits (ON or OFF) or may
**...use the SRQR_DEFAULT define to set the value.
**...For version 0.5 these requirements are defaulted (use the
**...SRQR_DEFAULT token to set this field in the connect structure).
*/
SREQUIRE
    {
    K_BITS vshort;                 /*total 16-bit value*/
    struct                       /*individual bit fields*/
        {
        K_FIELD slexp:1;             /*send exp data*/
        K_FIELD tlexp:1;             /*use the transport exp data*/
        K_FIELD minorsync:1;         /*sets minor sync points*/
        K_FIELD majorsync:1;         /*sets major sync points*/
        K_FIELD resync:1;            /*resync avaliable*/
        K_FIELD actman:1;            /*uses activity management*/
        K_FIELD negrel:1;            /*uses negociated release*/
        K_FIELD capdata:1;           /*sends data out of activites*/
        K_FIELD halfdup:1;           /*uses half duplex line*/
        K_FIELD duplex:1;            /*uses full duplex line*/
        K_FIELD excepr:1;            /*reports protocol exceptions*/
        K_FIELD excepd:1;            /*receives exceptions*/
   		K_FIELD fill0:1;             /*reserved field*/ 
   		K_FIELD fill1:1;             /*reserved field*/ 
   		K_FIELD fill2:1;             /*reserved field*/ 
   		K_FIELD fill3:1;             /*reserved field*/ 
        }b;
    };
/*
**...During connect establishment the client must provide token
**...assignments by using the 'STKN' defines to set the fields in
**...the token structure field found in the connect sturcture.
*/
STOKEN
    {
    K_TBITS vchar;               /*8-bit token value*/
    struct                       /*individual bit fields*/
        {
#ifdef sun                 /*bits are reversed*/
        K_FIELD data    :2;      /*data token*/
        K_FIELD minor   :2;      /*minor sync. token*/
        K_FIELD activity:2;      /*activity token*/
        K_FIELD release :2;      /*release token*/
#else
        K_FIELD release :2;      /*release token*/
        K_FIELD activity:2;      /*activity token*/
        K_FIELD minor   :2;      /*minor sync. token*/
        K_FIELD data    :2;      /*data token*/
#endif
        }b;
    };
/*
**...Connect requests, indications, responces and confirmations all
**...use the following structure.
*/
SLCONNECT
    {
    K_COUNT   length;                    /*length of data*/
    SREQUIRE  require;                   /*client requirements of SL*/
    STOKEN    token;                     /*token assignments*/
    K_UTINY   result;                    /*result of connect request ISO*/
    K_UTINY   ssresult;                  /*session layer result*/
    K_TEXT    prclient[SMAX_CLIENTNAME]; /*peer client logical name*/
    K_TEXT    slacc[SMAX_SLNAME];        /*acceptor's SL address*/
    K_TEXT    slini[SMAX_SLNAME];        /*initiator's SL address*/
    K_UTINY   data[SMAX_CNDATA];         /*data to/from peer*/
    };
/*
**...Bad news abort.
*/
SLABORT
    {
    K_COUNT length;
    K_UTINY data[SMAX_ABDATA];
    K_TINY  reason;
    };
/*
**...Activity start request, start indication, end request, end
**...indication, end responce, and end confirmation.
*/
SLACTIVITY
    {
    K_COUNT length;
    K_UTINY data[SMAX_ASDATA];
    K_UTINY actid[SMAX_ACTID];
    };
/*
**...Data.
*/
SLDATA
    {
    K_COUNT length;                     /*octets in buffer*/
    K_UTINY peek[SMAX_DTPEEKABOO];      /*first few bytes in buffer*/
    ID    buffer;                     /*buffer of peer data*/
    };
/*
**...Release requests, indications, responces and confirmations.
*/
SLRELEASE
    {
    K_COUNT  length;
    K_UTINY  data[SMAX_RLDATA];
    };
/*
**...Token give and please indications
*/
SLTOKEN
    {
    K_COUNT  length;
    K_UTINY  data[SMAX_PTDATA];
    STOKEN token;
    };
/*
**...Union of all request/indication structures used by indication
*/
SLSTRUCT
    {
    SLCONNECT   slconnect;
    SLABORT     slabort;
    SLACTIVITY  slactivity;
    SLRELEASE   slrelease;
    SLDATA      sldata;
    SLTOKEN     sltoken;
    };
/*
**...General indication & confirmation structure contains the union
**...of all 'SLxxx' structures.
*/
SLINDICATION
    {
    K_UCOUNT type;                       /*which indication*/
    SLSTRUCT slstruct;                   /*the structure itself*/
    };
#endif
