
/***   #define DEBUG   ****/

#ifdef _IBMR2
#define unix
#endif

#include "edc_types.h" 
#include "pserver.h"
#include "ncp.h"

#define TPUSER          "netsrv"
#define TPPWD           "at4mc5"

#define TPMNT_FIL	"/usr/local/gblfiles/tpmnt_fil.req_v1" 
#define TPMNT_LOG	"/usr/local/gblfiles/tpmnt_log"
#define TPMNT_MAX	50

#define TPMNT_SLEEP	30

#ifndef NULLVAL
#define NULLVAL		-1		/* null value */
#endif

#define NTOPEN           1              /* open network connection */
#define NTCLOSE          2              /* close network connection */
#define NT_ADDMNT	 3		/* add tape mount */
#define NT_DELMNT	 4		/* delete tape mount */
#define NT_LSTMNT	 5		/* list tape mounts */
#define NT_TPSTAT	 6		/* list available tape drives */

struct NTSYS
	{
	char local[100];		/* local computer system name */
	char remote[100];		/* remote computer system name */
	char srcsys[20];		/* source file LAS 5 system name */
	char dstsys[20];		/* destination file LAS 5 system name */
	char cparm[CMLEN];		/* character parameter */
	unsigned char iparm[4];		/* integer parameter */
	unsigned char cmd[4];		/* command option */
	struct SNDACK ack;		/* acknowledge structure (ncp.h) */
	};

#define TPMNT_WAIT	1		/* waiting for drive to be assigned */
#define TPMNT_BUSY	2		/* operator in process of assigning */
#define TPMNT_ASSIGN	3		/* tape drive has be assigned */

struct NT_MTREQ
    {
    long args[2];			/* tape mount arguments */
    long cmd;				/* tape mount command */
    long errflg;			/* network error status flag */
    long pid;				/* process id */
    long status;			/* tape mount status */
    long stime;				/* start time */
    long utime;				/* update time */
    char carg[32];			/* character argument */
    char drive[128];			/* tape drive assigned */
    char errtext[128];			/* error text */
    char mntmsg[1024];			/* mount message */
    char system[128];			/* system name */
    char tapeid[32];			/* tape id assigned */
    char user[32];			/* user name */
    char tapelen[32]; 			/* tape length */
    };
