/*
 * Header file for users of the transport library.
 */

#define TADDRSZ 16              /* max size of a transport address */
struct  taddr
        {
        K_TEXT  name[TADDRSZ];
        };
typedef struct taddr TADDR;     /* transport address */
typedef K_LONG  TERROR;         /* error type */

/*
 *      TERROR types.
 */
#define TSUCCESS         0      /* test for < TSUCCESS to determine error */
#define TERRNONET       -1      /* no transport to connect to */
#define TERRMBX         -2      /* some sort of mailbox error */
#define TERRNOMEM       -3      /* unable to allocate memory for conn */
#define TERRSTATE       -4      /* invalid state */
#define TERRTIMO        -5      /* timeout */
#define TERRSIZ         -6      /* too much data */
#define TERRMANY        -7      /* attempted to do too many tlatch()'s */
#define TERRUNK         -8      /* unknown connection */
#define TERREMPTY       -9      /* no indications queued for this connection */

/*
 *      Command types
 */
#define CMD_CONNECT_REQ         1
#define CMD_CONNECT_IND         2
#define CMD_CONNECT_CON         3
#define CMD_CONNECT_RES         4
#define CMD_DISCONNECT_REQ      5
#define CMD_DISCONNECT_IND      6
#define CMD_DATA_REQ            7
#define CMD_DATA_IND            8
#define CMD_EXPEDITED_REQ       9
#define CMD_EXPEDITED_IND       10
#define CMD_MAKECON_REQ         11
#define CMD_MAKECON_RES         12
#define CMD_QUITCON_REQ         13
#define CMD_GETNAME             17
#define CMD_GET_BLKSZ           18      /* get optimum blocksize */
/*
 *      Operator commands.
 */
#define CMD_OP_QUIT             14      /* shut down transport promptly */
#define CMD_OP_STATUS           15      /* return connection status */
#define CMD_OP_TRACE            16      /* turn tracing on or off */

/*
 *      Command reasons
 */
#define PROTOCOL_ERROR                  0
#define LOSS_OF_NETWORK_CONNECTION      1
#define TIMEOUT                         2
#define NORMAL                          3
#define NET_FAIL                        4
#define USER_REJECT                     5
#define NETWORK_RESET                   6
#define CR_DATA_TOO_BIG                 7
#define PROVIDER_INITIATED              8
#define USER_INITIATED                  9
#define NEGOTIATION_FAILED              10

/*
 *      Declarations of tranlib routines.
 */
K_FUNCTION TERROR tlatch();
K_FUNCTION TERROR tldtch();
K_FUNCTION TERROR tconreq();
K_FUNCTION TERROR tconind();
K_FUNCTION TERROR tconres();
K_FUNCTION TERROR tdisreq();
K_FUNCTION TERROR tdatreq();
K_FUNCTION TERROR texpreq();
K_FUNCTION TERROR tcmdind();
