#include <stdio.h>
#include "las.h"
#include "ntqlp.h"
#include "qlp.h"
#include "local_protos.h"

#ifdef vms
#include ssdef
#include jpidef
/*
 *      getchrg returns a pointer to a null terminated character
 *      string containing the charge code.  SYS$GETJPI is called
 *      to get the account number (which is the charge code).  If
 *      an error occurs, a pointer to "00000" is returned.
 *
 *      This module is VAX/VMS specific; it is not portable.
 */
#define CHGSIZE 8               /* size of account number field */
int getchrg
(
    char *chrg
)
        {
        struct
                {                       /* item list for SYS$GETJPI */
                short   il_buflen;              /* buffer length */
                short   il_code;                /* item description code */
                char    *il_bufaddr;            /* buffer address */
                char    *il_lenaddr;            /* addr of returned length */
                long    il_zero;                /* list terminator */
                }       itemlist;
        int             i;                      /* index */

        /*
         *      Call getjpi to get the account number
         */
        itemlist.il_buflen = CHGSIZE;
        itemlist.il_code = JPI$_ACCOUNT;
        itemlist.il_bufaddr = chrg;
        itemlist.il_lenaddr = (char *)0;
        itemlist.il_zero = 0;
        if (sys$getjpi(0,0,0,&itemlist,0,0,0) != SS$_NORMAL)
                strcpy(chrg,"00000");
        else
                {
                /*
                 *      Strip off the trailing blanks.
                 */
                for (i = CHGSIZE-1; i >= 0; i--)
                        if (chrg[i] == ' ')
                                chrg[i] = '\0';
                        else
                                break;
                }
        return;
        }
#endif

#ifdef unix
/*
 *      getchrg returns a pointer to a null terminated character
 *      string containing the charge code.  If the group id of the
 *      process does not correspond to a valid charge code a pointer
 *      to the string "00000" is returned.
 *
 *      This module is Unix specific; it is not portable.
 */
#include <grp.h>
#include <ctype.h>

/******************************************************************************
	FORTRAN BRIDGE ROUTINE
*******************************************************************************/
int getchrg_
(
    char *chrg,
    int  chrg_len
)
{
long i;

getchrg(chrg);
for (i=(long)strlen(chrg); i<chrg_len; i++)
    chrg[i] = ' ';
return(1);
}

int getchrg
(
    char *chrg
)
{
        struct group *g;                /* entry from /etc/group */
        int     gid;                    /* group id */

        /*
         *      Grab the group id.
         */
        gid = getgid();

        /*
         *      Search through the /etc/group file looking for an
         *      entry with a matching group ID and a numeric group
         *      name.  (We can't just use getgrgid() because we want
         *      the numeric chargecode, not an alias.)
         */
        setgrent();
        for (g = getgrent();g != (struct group *)0;g = getgrent())
                if ((g->gr_gid == gid) && isdigit(g->gr_name[0]))
                        {
                        strcpy(chrg,g->gr_name);
                        break;
                        }
        endgrent();

        /*
         *      Return the pointer to the name.
         */
        return(1);
}
#endif
