C***************************************************************************
      INTEGER*4 FUNCTION ENHANCE(INVAL,OTVAL,NE2,Y3)
C	IMPLICIT NONE
	INTEGER INVAL(*),NE2
	REAL	OTVAL(*),Y3(256)
C                                                                      
C  ENHANCE DERIVES A PEICEWISE LINEAR CONTRAST STRETCH FROM THE VALUES
C  STORED IN INVAL AND OTVAL AND STORES THE RESULTANT LUT IN Y3
C
      REAL    XINVAL(256)       
      INTEGER I,STATUS                             
C
      CALL SORTC(INVAL,OTVAL,NE2)                                     
C  MOVE DN TO REAL ARRAY                                               
      DO 16 I=1,NE2                                                    
         XINVAL(I)=INVAL(I)                               
  16  CONTINUE
C  SET UP FULL TABLE FOR FILLER                                        
C
      CALL PIECE(XINVAL,OTVAL,NE2,Y3,STATUS)
C                                                                      
      ENHANCE = STATUS
      RETURN
      END                                                              
C
C
C
C
C

      SUBROUTINE CALBRT(DIGN,DNSITY,NE,Y1)
C	IMPLICIT NONE
	INTEGER DIGN(*),NE
	REAL	DNSITY(*),Y1(*)
C                                                                      
      INTEGER I,J,II,NOY1
      REAL Z1(512),XDIGN(256)                        
C
      CALL SORTC(DIGN,DNSITY,NE)                                       
C  COMPUTE & PRINT EXTENDED CALIBRATION DATA                           
      DO 16 I=1,256                                                    
         Z1(I)=I-1                                                        
  16  CONTINUE
      DO 17 I=1,NE                                                     
         XDIGN(I)=DIGN(I)                                                 
  17  CONTINUE
C                                                                      
      CALL FILLER(XDIGN,DNSITY,Z1,NE,256,Y1)                           

C  CALCULATE # OF TABLE ENTRIES FOR TAPE PREPARATION                   
C  FIRST FIND LARGEST DIGITAL VALUE                                    
      II=DIGN(1)                                                       
      DO 18 J=2,NE                                                     
         IF(DIGN(J).GT.II) II=DIGN(J)                                     
  18  CONTINUE                                                         
      NOY1 = II                                                        
      DO 19 I=1,II                                                     
         Z1(I)=I-1                                                        
  19  CONTINUE
C                                                                      
      CALL FILLER (XDIGN,DNSITY,Z1,NE,II,Y1)
C                                                                      
C  Y1 HAS DENSITY VALUES CORRESPONDING TO DIGITAL VALUES IN XDIGN.     
      RETURN                                                           
      END                                                              
C
C
C
C
C
C
      SUBROUTINE CONTRL(DIGN2,DNSTY2,NE2,Y2)
C	IMPLICIT NONE
	INTEGER DIGN2(*),NE2
	REAL	DNSTY2(*),Y2(*)
C                                                                      
      INTEGER I
      REAL Z2(256),XDIGN(256)       
C
      CALL SORTC(DIGN2,DNSTY2,NE2)                                     
C  MOVE DN TO REAL ARRAY                                               
      DO 16 I=1,NE2                                                    
         XDIGN(I)=DIGN2(I)                                                
  16  CONTINUE
C  SET UP FULL TABLE FOR FILLER                                        
      DO 17 I=1,256                                                    
         Z2(I)=I-1                                                        
  17  CONTINUE
C                                                                      
      CALL FILLER(XDIGN,DNSTY2,Z2,NE2,256,Y2)                          
      RETURN                                                           
      END                                                              
C
C
C
C
C
C
      SUBROUTINE PUNT(Y1,Y2,Y3,FLUT)
C	IMPLICIT NONE
      INTEGER*2 FLUT(256)
      REAL	Y1(512),Y2(256),Y3(256)
C                                                                      
C  *PUNT* EXPECTS TO FIND A 256 ELEMENT ARRAY, "Y2", IN NAMED COMMON   
C  /CONY/ WITH DESIRED FILM DENSITIES FOR INPUT DN: 0..255.  "Y1" IN   
C  /CALY/  CONTAINS REAL DENSITIES CORRESPONDING TO INTEGERS IN RANGE  
C  0-MAX. DV (0-255 FOR COLOR FIRE).  "NOY1" IS           
C  THE # OF ENTRIES IN "Y1".                                           
C                                                                      
      INTEGER LUT(256),J1,I,IDUM
      REAL    DIFF,TEMP,DORO
C
      DO 20 J1=1,256
         DIFF=100.
         DO 10 I=1,256
         TEMP = ABS(Y2(J1)-Y1(I))
            IF (DIFF.GT.TEMP) THEN
               DIFF = TEMP
               LUT(J1)=I-1
            END IF
 10      CONTINUE
 20   CONTINUE
      DORO=1
C NOW COMBINE ENHANCEMENT
      DO 30 I=1,256
         IDUM=Y3(I)+.5
         FLUT(I)=LUT(IDUM+1)
 30   CONTINUE
      RETURN                                                           
      END                                                              
C
C
C
C
C
C
C
      SUBROUTINE SORTC(IN,OUT,NE)
C	IMPLICIT NONE
      INTEGER IN(*),NE
      REAL    OUT(*)
C
      INTEGER I,J,TEMPIN
      REAL    TEMPOUT
C
      DO 20 I = 1, NE-1
         DO 10 J = I+1, NE
            IF (IN(I) .GT. IN(J)) THEN
	       TEMPIN = IN(I)
	       IN(I) = IN(J)
	       IN(J) = TEMPIN
	       TEMPOUT = OUT(I)
	       OUT(I) = OUT(J)
	       OUT(J) = TEMPOUT
	    END IF
 10	 CONTINUE
 20   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C
C
C
C
C
C****************************************************************************
      SUBROUTINE PIECE (X,Y,N,YINT,ISTATUS)                             
C	IMPLICIT NONE
	REAL X(*),Y(*),YINT(*)
	INTEGER N,ISTATUS
C  **PIECE** FILLS IN A TABLE OF VALUES.  INPUT IS IN PAIRS OF        
C  VALUES IN X(I) & Y(I) WITH MAXIMUM I = 256.  Z(MAX) IS A TABLE OF    
C  INDEPENDENT VARIABLE (X(I)'S), USUALLY AT EQUAL INTERVALS & NOT OUT-
C  SIDE RANGE OF X(I)'S.  "N" IS NUMBER OF PAIRS OF X(I), Y(I).  MAX IS
C  NUMBER OF VALUES IN Z(J).  YINT(J) CONTAINS THE MAX # OF VALUES OF  
C  DEPENDENT VARIABLE, Y(I), CORRESPONDING TO VALUES OF X(I) IN Z.     
      INTEGER NO,I,J,ICNT
      REAL XX,LOWX,HIGHX,LOWY,HIGHY
C  ARRAY "X" MUST BE SINGLE VALUED & MONOTONICALLY INCREASING.  MAKE   
C  CHECK FOR MONOTONICALLY DECREASING:  IF SO SWAP "X" & "Y" END-      
C  FOR-END SO "X" IS NOW INCREASING.                                   
      IF(X(1).GT.X(N)) THEN
         NO=N/2                                                           
         DO 10 I=1,NO                                                      
            J=N-I+1                                                          
            XX=X(I)                                                          
            X(I)=X(J)                                                        
            X(J)=XX                                                          
            XX=Y(I)                                                          
            Y(I)=-Y(J)                                                        
            Y(J)=XX                                                          
 10      CONTINUE
      END IF
      ICNT=1
      LOWX=X(ICNT)
      HIGHX=X(ICNT+1)
      LOWY=Y(ICNT)
      HIGHY=Y(ICNT+1)
      DO 20 I=1,256
         IF (I-1.GT.HIGHX) THEN
             ICNT=ICNT+1
             LOWX=X(ICNT)
             HIGHX=X(ICNT+1)
             LOWY=Y(ICNT)
             HIGHY=Y(ICNT+1)
         END IF
         IF (I-1.GE.LOWX) THEN
C  ALGORITHM TO FIND APPROPRIATE DELTA Y BASED ON DELTA X
          YINT(I)=(LOWY+((HIGHY-LOWY)*((I-LOWX-1.)/(HIGHX-LOWX))))
         ELSE
          YINT(I)=LOWY
         END IF
 20   CONTINUE
      ISTATUS = 0
      RETURN                                                           
      END                                                              
C
C
C
C
C
C
C
      SUBROUTINE FILLER (X,Y,Z,N,MAX,YINT)                             
C	IMPLICIT NONE
C  **FILLER** FILLS IN A TABLE OF VALUES.  INPUT IS IN PAIRS OF        
C  VALUES IN X(I) & Y(I) WITH MAXIMUM I = 256.  Z(MAX) IS A TABLE OF    
C  INDEPENDENT VARIABLE (X(I)'S), USUALLY AT EQUAL INTERVALS & NOT OUT-
C  SIDE RANGE OF X(I)'S.  "N" IS NUMBER OF PAIRS OF X(I), Y(I).  MAX IS
C  NUMBER OF VALUES IN Z(J).  YINT(J) CONTAINS THE MAX # OF VALUES OF  
C  DEPENDENT VARIABLE, Y(I), CORRESPONDING TO VALUES OF X(I) IN Z.     
      INTEGER I,J,K,N,NO,MAX
      REAL XX
      REAL X(*),Y(*),Z(*),YINT(*),S(256),G(256)           
      REAL A(256),B(256)                                          
      REAL C(256),W(256),SB(256),EM(256),SUM(256),F(256)          
C  ARRAY "X" MUST BE SINGLE VALUED & MONOTONICALLY INCREASING.  MAKE   
C  CHECK FOR MONOTONICALLY DECREASING:  IF SO SWAP "X" & "Y" END-      
C  FOR-END SO "X" IS NOW INCREASING.                                   
      IF(X(1).LT.X(N)) GO TO 17                                        
      NO=N/2                                                           
      DO 1 I=1,NO                                                      
      J=N-I+1                                                          
      XX=X(I)                                                          
      X(I)=X(J)                                                        
      X(J)=XX                                                          
      XX=Y(I)                                                          
      Y(I)=Y(J)                                                        
   1  Y(J)=XX                                                          
  17  DO 2 J=2,N                                                       
   2  S(J)=X(J) - X(J-1)                                               
      NO = N-1                                                         
      IF(NO-2) 3,4,4                                                   
   4  DO 5 J=2,NO                                                      
      A(J)=S(J)/6.0                                                    
      B(J) = (S(J)+S(J+1))/3.0                                         
      C(J) = S(J+1)/6.0                                                
   5  F(J) = (Y(J+1)-Y(J))/S(J+1)-(Y(J)-Y(J-1))/S(J)                   
   3  A(N) = -0.5                                                      
      B(1) =  1.0                                                      
      B(N) =  1.0                                                      
      C(1) = -0.5                                                      
      F(1) =  0.0                                                      
      F(N) =  0.0                                                      
      W(1) = B(1)                                                      
      SB(1)= C(1)/W(1)                                                 
      G(1) =  0.0                                                      
      DO 6 J=2,N                                                       
      W(J) = B(J)-A(J)*SB(J-1)                                         
      SB(J) = C(J)/W(J)                                                
      B(J) = (F(J)-A(J)*G(J-1))/W(J)                                   
      G(J)=(F(J)-A(J)*G(J-1))/W(J)                                     
   6  CONTINUE                                                         
      EM(N) = G(N)                                                     
      DO 7 J = 2,N                                                     
      K=N+1-J                                                          
   7  EM(K) = G(K) - SB(K)*EM(K+1)                                     
      SUM(1) = 0.0                                                     
      DO 8 J=2,N                                                       
   8  SUM(J)=SUM(J-1)+S(J)*(Y(J)+Y(J-1))/2.-S(J)**3*(EM(J)+EM(J-1))/124
      IF(MAX-1) 10,9,9                                                 
   9  DO 11 J=1,MAX                                                    
      K=2                                                              
C  NEXT 2 MAYBE SHOULD BE "X(J)" & "Y(J)"                              
      IF(Z(J)-X(1)) 11,12,13                                           
  12  YINT(J) = Y(1)                                                   
      GO TO 11                                                         
  13  IF(Z(J)-X(K)) 14,15,16                                           
  15  YINT(J) = Y(K)                                                   
      GO TO 11                                                         
  16  K=K+1                                                            
      IF(K-N) 13,13,11                                                 
  14  YINT(J)=EM(K-1)*(X(K)-Z(J))**3/6./S(K)+EM(K)*(Z(J)-X(K-1))**3/6  
     1./S(K)+(Y(K)/S(K)-EM(K)*S(K)/6.)*(Z(J)-X(K-1))+(Y(K-1)/S(K)-EM   
     2(K-1)*S(K)/6.)*(X(K)-Z(J))                                       
  11  CONTINUE                                                         
  10  RETURN
      END                                                              
