/******************************************************************************
FUNCTION:	SCANBUF

PURPOSE:	Scans the record for matches.  If a match is found the
		starting index of the record is returned.  Multiple 
		matches within the same record are not found.

ALGORITHM 
  Determine the number of bytes to be scaned
     Look for specified scan string in the buffer
     if match found
	return(index)
     else
	return(-1)

ALGORITHM REFERENCES	none
*******************************************************************************/
#include <stdio.h>
#include "las.h"
#include "ntqlp.h"
#include "qlp.h"
#include "local_protos.h"

int scanbuf
(
    char *buf,              /* buffer containing the record      */
    char *scan_string       /* scan string to be searched for  */
)
{
long   count;				/* byte offset of a match            */
long   match;				/* number of bytes that have matched */
long   nbytes;				/* actual # of bytes to be scanned   */
long   recsiz;				/* size of record */
long   scan_length;			/* number of bytes in scan string    */
long   start;				/* starting offset to begin scan     */

start = 0;
scan_length = (long)strlen(scan_string);
recsiz = (long)strlen(buf);
nbytes = recsiz - scan_length + 1;
for (buf += start,count = start; count < nbytes; buf++,count++)
   {
   if (*buf == *scan_string)
      {
      for (match = 1;
	   (match < scan_length) && (*(buf + match) == *(scan_string + match));
 	   match++)
		;
      if (match == scan_length)
         {
	 return(count);
         }
      }
   }
return(-1);
}
