/***************************************************************************
*
*  NAME: GETPAR
*  FUNCTION: Get the input parameters
*
*  COMPUTER HARDWARE AND/OR SOFTWARE LIMITATIONS:
*               Must be run under TAE
*
*  PROJECT: LAS
*
*  ALGORITHM DESCRIPTION:
*       See inline comments
*
******************************************************************************/
#include "las.h"
#include "util.h"
#include "protos.h"
 
int getpar
(
    struct PARBLK *parblk,
    char *orcuid,                   /* Oracle user ID */
    char *orcpwd,                   /* Oracle user password */
    char *orctab,                   /* Oracle table */
    char *orcfldin,                 /* Oracle field name */
    char *orcfldout                /* Oracle output column value */
)
{
 
 
struct VARIABLE *var;
 
char outfile[1][CMLEN];                   /* output image name */
char tmpfile[1][CMLEN];                   /* junk string */
 
/* Receive parameter naming the output image and check
   for existence
------------------------------------------------------*/
if (c_getout(parblk,"OUT",outfile,tmpfile) 
   != E_SUCC)
   {
   return(E_FAIL);
   }

/* Receive parameter naming the user's Oracle ID
------------------------------------------------*/
var = p_find(parblk,"ORCUID");
strcpy(orcuid,SVAL(*var,0));

/* Receive parameter naming the user's Oracle pasword
------------------------------------------------------*/
var = p_find(parblk,"ORCPWD");
strcpy(orcpwd,SVAL(*var,0));

/* Receive parameter naming the Oracle table 
---------------------------------------------*/
var = p_find(parblk,"ORCTAB");
strcpy(orctab,SVAL(*var,0));

/* Receive parameter naming the Oracle field names
--------------------------------------------------*/
var = p_find(parblk,"ORCFLDIN");
strcpy(orcfldin,SVAL(*var,0));

var = p_find(parblk,"ORCFLDOUT");
strcpy(orcfldout,SVAL(*var,0));


return(E_SUCC);
}

