/*
C  10-16-86 B. AILTS added parameter 'status' to catch errors within the
C  application code.
C  09-28-88 B. Ailts Updated to LAS 5.0
C-----------------------------------------------------------------------
*/
#include <string.h>
#include "las.h"
#include "labserv.h"
#include "lams.h"
#include "vll.h"

int c_gropen
(
    struct MFDESC **fdesc,
    char *hostin,
    long *reclen,
    long *nrec,
    long *acc
)
{  /*  gropen  */

struct MFDESC *mfd;

float *ddbuf;

long clen;
long dlen;
long hdbuf[2];
long i;
long nonfatal = 1;
long status;
long temp_acc;
long zero = 0;		/*  value of zero				*/

char cbuf[6];
char dtype[TYPL];
char key[KEYL];

mfd = *fdesc = (struct MFDESC *)malloc(sizeof(struct MFDESC));
mfd->acc = temp_acc = 3;

status = c_lsopen(&(mfd->fd),hostin,acc);
if (status == E_FAIL)
   {
   c_errmsg("Error opening file","lamsutil-open",&nonfatal);
   return(E_FAIL);
   }

if (*acc == IWRITE)
   {
   mfd->reclen = *reclen;
   mfd->numrec = *nrec;
   strcpy(key,"HEADER");
   clen = 5;
   strcpy(cbuf,"GRAPH");
   dlen = 8;
   hdbuf[0] = *reclen;
   hdbuf[1] = *nrec;
   strcpy(dtype,"I4");
   status = c_lswrit(&(mfd->fd),key,&clen,&dlen,cbuf,hdbuf,dtype);
   if (status == E_FAIL)
      {
      c_errmsg("Error writing output file","lamsutil-write",&nonfatal);
      return(E_FAIL);
      }

   ddbuf = (float *)malloc(*reclen * 4);
   clen = 0;
   dlen = *reclen * 4;
   strcpy(dtype,"R4");
   for (i = 0; i < *reclen; i++)
      *(ddbuf + i) = 0.0;

   for (i = 1; i <= *nrec; i++)
      {
      sprintf(key,"REC%ld",i);
      status = c_lswrit(&(mfd->fd),key,&clen,&dlen,cbuf,ddbuf,dtype);
      if (status == E_FAIL)
         {
         c_errmsg("Error writing output file","lamsutil-write",&nonfatal);
         return(E_FAIL);
         }
      }  

   free(ddbuf);

   acc = 0;
   status = c_lsclos(&(mfd->fd),hostin,&zero);
   if (status == E_FAIL)
      {
      c_errmsg("Error closing output file","lamsutil-close",&nonfatal);
      return(E_FAIL);
      }

   status = c_lsopen(&(mfd->fd),hostin,&temp_acc);
   if (status == E_FAIL)
      {
      c_errmsg("Error opening file","lamsutil-open",&nonfatal);
      return(E_FAIL);
      }

   }  /*  if acc == IWRITE  */
else
   {  /*  else if acc = IREAD  */
   strcpy(key,"HEADER");
   clen = 5 + 1;
   dlen = 8;
   status = c_lsread(&(mfd->fd),key,&clen,&dlen,cbuf,hdbuf,dtype);
   if (status == E_FAIL)
      {
      c_errmsg("Error reading input file","lamsutil-read",&nonfatal);
      return(E_FAIL);
      }
   if (strcmp(cbuf,"GRAPH") != 0)
      {
      c_errmsg("File is not of type graphics","lamsutil-ftype",&nonfatal);
      return(E_FAIL);
      }
   mfd->reclen = *reclen = hdbuf[0];
   mfd->numrec = *nrec = hdbuf[1];

   }  /*  else if acc == IREAD  */

return(E_SUCC);
} /*  gropen  */
