/*
C  10-16-86 B. AILTS added parameter 'status' to catch errors within the
C  application code.
C  09-28-88 B. Ailts Updated to LAS 5.0 -- now uses label services file format
C-----------------------------------------------------------------------------
*/
#include <string.h>
#include "las.h"
#include "labserv.h"
#include "lams.h"
#include "vll.h"


int c_tbopen
(
    struct MFDESC **fdesc,
    char *hostin,
    long *nrow,
    long *ncol,
    long *acc
)
{  /*  tbopen  */

struct MFDESC *mfd;

float *ddbuf;

long clen;
long dlen;
long hdbuf[2];
long i;
long nonfatal = 1;
long status;
long temp_acc;
long zero = 0;		/*  value of zero				*/

char cbuf[4];
char dtype[TYPL];
char key[KEYL];

mfd = *fdesc = (struct MFDESC *)malloc(sizeof(struct MFDESC));
mfd->acc = temp_acc = 3;

status = c_lsopen(&(mfd->fd),hostin,acc);
if (status == E_FAIL)
   {
   c_errmsg("Error writing output file","lamsutil-write",&nonfatal);
   return(E_FAIL);
   }

if (*acc == 1)
   {
   mfd->reclen = *nrow;
   mfd->numrec = *ncol;
   strcpy(key,"HEADER");
   clen = 4;
   strcpy(cbuf,"TAB");
   dlen = 8;
   hdbuf[0] = *nrow;
   hdbuf[1] = *ncol;
   strcpy(dtype,"I4");
   status = c_lswrit(&(mfd->fd),key,&clen,&dlen,cbuf,hdbuf,dtype);
   if (status == E_FAIL)
      {
      c_errmsg("Error writing output file","lamsutil-write",&nonfatal);
      return(E_FAIL);
      }

   ddbuf = (float *)malloc(*nrow * 4);
   clen = 0;
   dlen = *nrow * 4;
   strcpy(dtype,"R4");
   for (i = 0; i < *nrow; i++)
      *(ddbuf + i) = 0.0;

   for (i = 1; i <= *ncol; i++)
      {
      sprintf(key,"COL%ld",i);
      status = c_lswrit(&(mfd->fd),key,&clen,&dlen,cbuf,ddbuf,dtype);
      if (status == E_FAIL)
         {
         c_errmsg("Error writing output file","lamsutil-write",&nonfatal);
         return(E_FAIL);
         }
      }  

   free(ddbuf);

   status = c_lsclos(&(mfd->fd),hostin,&zero);
   if (status == E_FAIL)
      {
      c_errmsg("Error closing output file","lamsutil-close",&nonfatal);
      return(E_FAIL);
      }

   status = c_lsopen(&(mfd->fd),hostin,&temp_acc);
   if (status == E_FAIL)
      {
      c_errmsg("Error writing output file","lamsutil-write",&nonfatal);
      return(E_FAIL);
      }

   }  /*  if acc == IWRITE  */
else
   {  /*  else if acc = IREAD  */
   strcpy(key,"HEADER");
   clen = 4 + 1;
   dlen = 8;
   status = c_lsread(&(mfd->fd),key,&clen,&dlen,cbuf,hdbuf,dtype);
   if (status == E_FAIL)
      {
      c_errmsg("Error reading input file","lamsutil-read",&nonfatal);
      return(E_FAIL);
      }
   if (strcmp(cbuf,"TAB") != 0)
      {
      c_errmsg("File is not of type tabular","lamsutil-ftype",&nonfatal);
      return(E_FAIL);
      }
   mfd->reclen = *nrow = hdbuf[0];
   mfd->numrec = *ncol = hdbuf[1];

   }  /*  else if acc == IREAD  */

return(E_SUCC);
} /*  tbopen  */
