/*
C DOCUMENT
C  12-29-86  added 'status' argument to help trap write errors
C  	     K. Zanter
C  09-28-88  Updated for LAS 5.0 -- B. Ailts
C-------------------------------------------------------------
*/
#include "las.h"
#include "labserv.h"
#include "lams.h"
#include "vll.h"


int c_tbwcol
(
    struct MFDESC **fdesc,
    long *col,
    float *buffer
)
{  /*  c_tbwcol  */

struct MFDESC *mfd;

float *buf_ptr;
float *temp_ptr;

long clen;
long dlen;
long nonfatal = 1;
long row;
long status;

char dtype[TYPL];
char key[KEYL];
char cbuf;

mfd = *fdesc;

clen = 1;
dlen = mfd->reclen * 4;
temp_ptr = buf_ptr = (float *)malloc(mfd->reclen * 4);

sprintf(key,"COL%ld",*col);
status = c_lsread(&(mfd->fd),key,&clen,&dlen,&cbuf,buf_ptr,dtype);
if (status == E_EOF)
   {
   status = c_lsrew(&(mfd->fd));
   if (status != E_SUCC)
      {
      c_errmsg("Error rewinding to output file","lamsutil-rewind",&nonfatal);
      return(E_FAIL);
      }

   status = c_lsread(&(mfd->fd),key,&clen,&dlen,&cbuf,buf_ptr,dtype);
   if (status != E_SUCC)
      {
      c_errmsg("Error reading the output file","lamsutil-read",&nonfatal);
      return(E_FAIL);
      }
   }
else if (status != E_SUCC)
   {
   c_errmsg("Error reading the output file","lamsutil-read",&nonfatal);
   return(E_FAIL);
   }

for (row = 0; row < mfd->reclen; row++,temp_ptr++)
   *temp_ptr = buffer[row];

clen = 0;
status = c_lsrepl(&(mfd->fd),key,&clen,&dlen,&cbuf,buf_ptr,dtype);
if (status != E_SUCC)
   {
   c_errmsg("Error writing to output file","lamsutil-write",&nonfatal);
   return(E_FAIL);
   }

free(buf_ptr);
return(E_SUCC);
}  /*  c_tbwcol  */
