/*
C DOCUMENT
C  12-29-86  added 'status' argument to help trap write errors
C  	     K. Zanter
C  09-28-88  Updated for LAS 5.0 -- B. Ailts
C  12-20-88  Read ibis tabular file directly in order to increase speed
C-----------------------------------------------------------------------
*/
#include "las.h"
#include "lams.h"
#include "vll.h"


int c_tbwrow
(
    struct MFDESC **fdesc,
    long *col,
    long *ncol,
    long *row,
    float *buffer
)
{  /*  c_tbwrow  */

struct MFDESC *mfd;

float *buf_ptr;

long cur_col;
long dlen;
long nonfatal = 1;
long obyte;
long offset;
long pre_col;		/* previous column				*/


mfd = *fdesc;
buf_ptr = buffer;
dlen = mfd->reclen * 4;

/* Skip over the first record of file and header of first second record
-----------------------------------------------------------------------*/
offset = ((*row - 1) * 4) + HDRL + (12 + HDRL);
if (lseek(mfd->fd,offset,0) == -1)
   {
   c_errmsg("Error seeking on input file","lamsutil-lseek",&nonfatal);
   return(E_FAIL);
   }

obyte = 0;
pre_col = 1;
for (cur_col = 0; cur_col < *ncol; cur_col++)
   {
   offset = (*(col + cur_col) - pre_col) * (dlen + HDRL) - obyte;
   if (lseek(mfd->fd,offset,1) == -1)
      {
      c_errmsg("Error seeking on input file","lamsutil-lseek",&nonfatal);
      return(E_FAIL);
      }

   obyte = write(mfd->fd, buf_ptr, 4);
   if (obyte != 4)
      {
      c_errmsg("Error reading input file","lamsutil-read",&nonfatal);
      return(E_FAIL);
      }

   buf_ptr ++;
   pre_col = *(col + cur_col);
   }  /*  for cur_col < *ncol  */

return(E_SUCC);
}  /*  c_tbwrow  */
