C****************************************************************************
C
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C
C	USER PARAMETERS
C	npts - the number of points read in
C	nlret - number of sides of triangles
C	reject - the radius in which points are considered duplicate
C	numrej - total number of rejected points
C	rejpt - locations of dupicate points
C	abendl - 0 = DO NOT abort if there are duplicate points
C		 1 = abort if there are duplicate points
C****************************************************************************
C
      SUBROUTINE MANAKR(NPTS,NLRET,REJECT,numrej,rejpt,ABENDL)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
	integer*4 numrej,hsize,j,k,ir,jmin,mcount(5)
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900)
	real*4 REJECT
      REAL*8 DX,DY,DXSET,DYSET
C	real*8 tadist,tdist
	real*8 rejpt(500)
	real*8 dmin,dist,dfloor,l
	integer*4 rej,i,iu,npts
	integer*4 nbcnt(900)
	integer*4 avail,jl,iset,jset,nlret
      LOGICAL QTEST,FLTEST,FAST,ABENDL

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE
	common /com5/nbcnt

      data mcount/0,0,0,0,0/,fast/.true./

	numrej = 0
	rej = 1
      IU = NPTS*6
      DO 1 I=1,IU
 1    LINK(I) = I+1
      AVAIL = 1
      DO 2 I=1,NPTS
      NBCNT(I) = 0
 2    LPTR(I) = 0

      IU = NPTS-1
      HSIZE = 0
      DO 10 I=1,IU
      dmin = 1.e35
      JL = I+1
      DO 9 J=JL,NPTS
      DX = PTX(J)-PTX(I)
      DY = PTY(J)-PTY(I)
      DIST = DX*DX+DY*DY
      IF (DIST.GE.DMIN) GO TO 9
      IF (DIST.GT.REJECT) GO TO 8
	rejpt(rej) = ptx(j)
	rejpt(rej + 1) = pty(j)
	rej = rej + 2
	numrej = numrej + 1
      NBCNT(J) = 10000
       IF (ABENDL) return
      GO TO 9
 8    JMIN = J
      DMIN = DIST
 9    CONTINUE
      IF (DMIN.GE.1.E35) GO TO 10
      HSIZE = HSIZE+1
      CALL HEAP(HSIZE,HSIZE,I,JMIN,DMIN)

 10   CONTINUE
      DO 11 I=1,HSIZE
      IR = HSIZE-I+1
      J = HEAPF(IR)
      K = HEAPT(IR)
      DIST = HEAPL(IR)
      CALL HEAP(IR,HSIZE,J,K,DIST)
 11   CONTINUE

  400 ISET = HEAPF(1)
      JSET = HEAPT(1)
      DXSET = PTX(JSET)-PTX(ISET)
      DYSET = PTY(JSET)-PTY(ISET)
      IF (NBCNT(ISET).GE.10000) GO TO 600
      IF (NBCNT(JSET).GE.10000) GO TO 600
      MCOUNT(3) = MCOUNT(3)+1
      IF (QTEST(ISET,JSET,.NOT.FAST)) GO TO 600
      IF (QTEST(JSET,ISET,.NOT.FAST)) GO TO 600
      MCOUNT(4) = MCOUNT(4)+1
 30   IF (FLTEST(ISET,JSET,NPTS)) GO TO 600

500	continue
 	CALL TADD(ISET,JSET,AVAIL)
      CALL TADD(JSET,ISET,AVAIL)
      MCOUNT(5) = MCOUNT(5)+1
      CALL REDUCE(ISET,JSET)

 600  IF (NBCNT(ISET).GE.10000) GO TO 50
      DFLOOR = DXSET*DXSET+DYSET*DYSET
      JL = ISET+1
 40   DMIN = 1.E35
      JMIN = 0
      DO 43 J=JL,NPTS
      IF (NBCNT(J).GE.10000) GO TO 43
      DX = PTX(J)-PTX(ISET)
      DY = PTY(J)-PTY(ISET)
      DIST = DX*DX+DY*DY
c      IF (DIST-DFLOOR) 43,42,41
      if ((dist-dfloor).lt.0.0)go to 43
      if ((dist-dfloor).eq.0.0)go to 42
      if ((dist-dfloor).gt.0.0)go to 41
 42   IF (J.LE.JSET) GO TO 43
 41   IF (DIST.GE.DMIN) GO TO 43
      JMIN = J
      DMIN = DIST
 43   CONTINUE
      IF (JMIN.EQ.0) GO TO 50
      DFLOOR = DMIN
      JSET = JMIN
      MCOUNT(1) = MCOUNT(1)+1
      IF (QTEST(ISET,JSET,FAST)) GO TO 40
      IF (QTEST(JSET,ISET,FAST)) GO TO 40
      MCOUNT(2) = MCOUNT(2)+1
      CALL HEAP(1,HSIZE,ISET,JSET,DMIN)
      GO TO 400
 50   IF (HSIZE.EQ.1) GO TO 900
      I = HEAPF(HSIZE)
      J = HEAPT(HSIZE)
	l = heapl(hsize)
      CALL HEAP(1,HSIZE-1,I,J,L)
      HSIZE = HSIZE-1
      GO TO 400

 900  NLRET = MCOUNT(5)

      RETURN
      END
C*****************************************************************************
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C****************************************************************************
      SUBROUTINE TADD(ISET,JSET,AVAIL)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900),dATAN2
      REAL*8 TANGLE,DX,DY
	integer*4 nbcnt(900)
	integer*4 iset,jset,avail,p,ptr,optr,j

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE

	common /com5/nbcnt

      NBCNT(ISET) = NBCNT(ISET)+1
      DX = PTX(JSET)-PTX(ISET)
      DY = PTY(JSET)-PTY(ISET)
      TANGLE = dATAN2(DY,DX)
      P = AVAIL
      AVAIL = LINK(P)
      LNBR(P) = JSET
      PTR = LPTR(ISET)
      IF (PTR.EQ.0) GO TO 3
 1    J = LNBR(PTR)
      DX = PTX(J)-PTX(ISET)
      DY = PTY(J)-PTY(ISET)
      IF (dATAN2(DY,DX).GE.TANGLE) GO TO 2
      OPTR = PTR
      PTR = LINK(PTR)
      IF (PTR.NE.0) GO TO 1
 2    IF (PTR.EQ.LPTR(ISET)) GO TO 3
      LINK(P) = PTR
      LINK(OPTR) = P
      RETURN
 3    LINK(P) = PTR
      LPTR(ISET) = P

      RETURN
      END
C*****************************************************************************
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C****************************************************************************
      SUBROUTINE REDUCE(IQ,JQ)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900)
	integer*4 iq,jq,ptr,j,p,kz,ko,k
	integer*4 nbcnt(900)
      LOGICAL NOCONN,CCWISE

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE
	common /com5/nbcnt

      PTR = LPTR(IQ)
 100  J = LNBR(PTR)
      IF (NBCNT(J).LE.2) GO TO 500
      IF (NBCNT(J).GE.10000) GO TO 500
      IF (NOCONN(J,JQ)) GO TO 500
      P = LPTR(J)
      KZ = LNBR(P)
      KO = KZ
      P = LINK(P)
 200  K = LNBR(P)
      IF (NOCONN(K,KO)) GO TO 500
      IF (CCWISE(J,KO,K)) GO TO 500
      KO = K
      P = LINK(P)
      IF (P.NE.0) GO TO 200
      IF (NOCONN(K,KZ)) GO TO 500
      IF (CCWISE(J,K,KZ)) GO TO 500
      NBCNT(J) = NBCNT(J)+10000
 500  PTR = LINK(PTR)
      IF (PTR.NE.0) GO TO 100

      RETURN
      END
C******************************************************************************
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C****************************************************************************
      LOGICAL FUNCTION CCWISE(J,K,L)

      real*8 ptx(900),pty(900),heapl(900),angle(900)
      integer*4 lptr(900),lnbr(5400),link(5400),heapf(900),heapt(900)
	integer*4 dangle(900)
	integer*4 j,k,l

      COMMON /COM2/PTX,PTY,lptr,lnbr,
     .             link,heapf,heapt,heapl,
     .             angle,dangle

      CCWISE = ((PTX(J)-PTX(K))*(PTY(L)-PTY(K))
     . -(PTY(J)-PTY(K))*(PTX(L)-PTX(K))).GT. 0.0

       RETURN
      END
C*****************************************************************************
C HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C  12/6/90	B.Ailts		increased the precision of two checks to 
C				see if sides of a triangle intersected
C				sides that already existed
C*****************************************************************************
      LOGICAL FUNCTION QTEST(IQ,JQ,FAST)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900),dATAN2,dSIN,dABS
      REAL*8 TANGLE,DX,DY
	real*8 Dmod,tpi
	integer*4 nbcnt(900)
	integer*4 iq,jq,ptr,nangle,iu,j,j1,j2,il
      LOGICAL FAST,NOCONN

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE
	common /com5/nbcnt

      DATA TPI/6.2831853/

	qtest = .false.
      IF (NBCNT(IQ).LE.1) RETURN
      PTR = LPTR(IQ)
      DX = PTX(JQ)-PTX(IQ)
      DY = PTY(JQ)-PTY(IQ)
      TANGLE = dATAN2(DY,DX)
      NANGLE = 0
      IU = 0
 1    J = LNBR(PTR)
      NANGLE = NANGLE+1
      DANGLE(NANGLE) = J
      IF (IU*LINK(PTR).NE.0) GO TO 2
      DX = PTX(J)-PTX(IQ)
      DY = PTY(J)-PTY(IQ)
      ANGLE(NANGLE) = dATAN2(DY,DX)
      IF (TANGLE.LE.ANGLE(NANGLE).AND.IU.EQ.0) IU = NANGLE
      IF (FAST) GO TO 2

C     B. Ailts decreased the tolerance by changing .0001 to .00000001
C     ---------------------------------------------------------------
      IF (dABS(dSIN((TANGLE-ANGLE(NANGLE))/2.)).GE. .00000001) 
     .   GO TO 2
      QTEST = .TRUE.
      RETURN

 2    PTR = LINK(PTR)
      IF (PTR.NE.0) GO TO 1
      IF (IU.EQ.0) IU = 1
      IL = IU-1
      IF (IL.EQ.0) IL = NANGLE
      J1 = DANGLE(IL)
      J2 = DANGLE(IU)
      IF (NOCONN(J1,J2)) RETURN
      QTEST = DMOD(ANGLE(IU)-ANGLE(IL)+TPI,TPI).LE.3.14000

      RETURN
      END
C*****************************************************************************
C HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C  12/6/90	B.Ailts		increased the precision of two checks to 
C				see if sides of a triangle intersected
C				sides that already existed
C*****************************************************************************
      LOGICAL FUNCTION FLTEST(IQ,JQ,NPTS)

	real*8 ptx(900),pty(900),heapl(900),angle(900)
	real*8 dy1,dx1,dx2,dy2,theta1,st,ct,b1,z3,w3,x3,y3
	real*8 z4,w4,x4,y4,b2,eps,t1,t2
      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
	integer*4 ptr
	integer*4 j
	integer*4 i,iq,jq,npts

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE

      FLTEST = .FALSE.
      DX1 = PTX(JQ)-PTX(IQ)
      DY1 = PTY(JQ)-PTY(IQ)
      THETA1 = dATAN2(DY1,DX1)
      ST = dSIN(THETA1)
      CT = dCOS(THETA1)
      B1 = dSQRT(DX1*DX1+DY1*DY1)
      DO 10 I=1,NPTS
      IF (I.EQ.IQ.OR.I.EQ.JQ) GO TO 10
      Z3 = PTX(I)-PTX(IQ)
      W3 = PTY(I)-PTY(IQ)
      X3 = Z3*CT+W3*ST
      Y3 = -Z3*ST+W3*CT
      PTR = LPTR(I)
 1    IF (PTR.EQ.0) GO TO 10
      J = LNBR(PTR)
      IF (J.LE.I) GO TO 2
      IF (J.EQ.IQ.OR.J.EQ.JQ) GO TO 2
      Z4 = PTX(J)-PTX(IQ)
      W4 = PTY(J)-PTY(IQ)
      X4 = Z4*CT+W4*ST
      Y4 = -Z4*ST+W4*CT
      DX2 = X4-X3
      DY2 = Y4-Y3
      B2 = dSQRT(DX2*DX2+DY2*DY2)

C     B. Ailts decreased the tolerance by changing .0001 to .00000001
C     ---------------------------------------------------------------
      EPS = .00000001*(B1+B2)
      IF (dABS(DY2) .GE. EPS) GO TO 3
      IF (dABS(Y3) .GE. EPS .AND. dABS(Y4) .GE. EPS) GO TO 2
      IF (X3 .GT. B1 .AND. X4 .GT. B1) GO TO 2
      IF (X3 .LT. 0. .AND. X4 .LT. 0.) GO TO 2
      FLTEST = .TRUE.
      RETURN

 3    T1 = -Y3/DY2
      IF (T1.LT.0..OR.T1.GT.1.) GO TO 2
      T2 = (DX2*T1+X3)/B1
      IF (T2.LT.0..OR.T2.GT.1.) GO TO 2
      FLTEST = .TRUE.
      RETURN

 2    PTR = LINK(PTR)
      GO TO 1
 10   CONTINUE

      RETURN
      END
C*****************************************************************************
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C****************************************************************************
      LOGICAL FUNCTION NOCONN(IQ,JQ)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900)
	integer*4 ptr,jq,iq

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE

      NOCONN = .FALSE.
      PTR = LPTR(IQ)
 1    IF (PTR.EQ.0) GO TO 2
      IF (LNBR(PTR).EQ.JQ) RETURN
      PTR = LINK(PTR)
      GO TO 1
 2    NOCONN = .TRUE.

      RETURN
      END
C******************************************************************************
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C****************************************************************************
      SUBROUTINE HEAP(P,N,I,J,K)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
	integer*4 p,n,i,j,q,m
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900)
      REAL*8 K

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE

      Q = 2*P
 10   IF (Q-N) 1,2,20
1	continue
      IF (HEAPL(Q).GT.HEAPL(Q+1)) Q = Q+1
 2    M = Q/2
      IF (K.GT.HEAPL(Q)) GO TO 3
      HEAPF(M) = I
      HEAPT(M) = J
      HEAPL(M) = K
      RETURN

3	continue
      HEAPF(M) = HEAPF(Q)
      HEAPT(M) = HEAPT(Q)
      HEAPL(M) = HEAPL(Q)
      Q = 2*Q
      GO TO 10
 20   M = Q/2
      HEAPF(M) = I
      HEAPT(M) = J
      HEAPL(M) = K

      RETURN
      END
C****************************************************************************
C PROGRAM HISTORY
C  Date		Programmer	Change
C  ----		----------	------
C		B. Ailts	LAS 5.0 conversion
C****************************************************************************
      SUBROUTINE TRIANG(NPTS,NLRET,NTRI)

      INTEGER*4 LPTR(900),LNBR(5400),LINK(5400),HEAPF(900),HEAPT(900)
	integer*4 DANGLE(900)
      INTEGER*2 CON1(1800),CON2(1800),CON3(1800)
      REAL*8 PTX(900),PTY(900),HEAPL(900),ANGLE(900),dATAN2
      REAL*8 DX,DY
	real*8 XCENT(1800)
	integer*4 icent(1800)
	integer*4 maxpts,tp,iu,i,nangle,ptr,j,k,kp
	integer*4 j1,j2,ntri,nlret,npts

      COMMON /COM2/PTX,PTY,LPTR,LNBR,LINK,
     .HEAPF,HEAPT,HEAPL,ANGLE,DANGLE
      COMMON /COM3/CON1,CON2,CON3

      EQUIVALENCE (XCENT,HEAPL),(ICENT,LINK)

      DATA MAXPTS/900/
  

      TP = 0
      IU = NPTS-1
      DO 100 I=1,IU
      NANGLE = 0
      PTR = LPTR(I)
      IF (PTR.EQ.0) GO TO 100
 20   J = LNBR(PTR)
      DX = PTX(J)-PTX(I)
      DY = PTY(J)-PTY(I)
      NANGLE = NANGLE+1
      ANGLE(NANGLE) = dATAN2(DY,DX)
      DANGLE(NANGLE) = J
      PTR = LINK(PTR)
      IF (PTR.NE.0) GO TO 20
      CALL R8SORT(ANGLE,DANGLE,NANGLE)
      DO 50 K=1,NANGLE
      KP = MOD(K,NANGLE)+1
      J1 = DANGLE(K)
      J2 = DANGLE(KP)
      IF (J1.LE.I.OR.J2.LE.I) GO TO 50
      PTR = LPTR(J1)
 40   IF (LNBR(PTR).EQ.J2) GO TO 41
      PTR = LINK(PTR)
      IF (PTR) 40,50,40
 41   TP = TP+1
      CON1(TP) = I
      CON2(TP) = J1
      CON3(TP) = J2
 50   CONTINUE
 100  CONTINUE

      DO 60 I=1,TP
      ICENT(I) = I
      XCENT(I) = (PTX(CON1(I))+PTX(CON2(I))+PTX(CON3(I)))/3.
60	continue
      CALL R8SORT(XCENT,ICENT,TP)
      IU = MAXPTS*6
      DO 61 I=1,IU
 61   LNBR(I) = CON1(I)
      DO 62 I=1,TP
      J = ICENT(I)
      CON1(I) = LNBR(J)
      CON2(I) = LNBR(J+MAXPTS*2)
 62   CON3(I) = LNBR(J+MAXPTS*4)
      NTRI = TP

      RETURN
      END
