C  NAME:  SUBROUTINE PREC6
C  
C  FUNCTION:
C	To limit the precision of a real*4 array to 6 or 7 digits -- the number
C	of significan digits on the PN9050 and VAX respectively.  The output 
C	is placed in a double precision array in order to be able the truely 
C	represent the number in binary form.
C
C  PROGRAM HISTORY:
C  Version	Date	Author		Code/Cont	Request
C  -------	----	------		---------	-------
C    1.0	12/86	B.AILTS		   CSB		
C    2.0	09/88   B.Ailts		   CSB		Updated to LAS 5.0
C
C  PROJECT:	LAMS
C
C  LANGUAGE:	FORTRAN 77
C
C-------------------------------------------------------------------------------

	subroutine prec6(in,nnum,out)

	integer*4 i,nnum
	real*4 in(1)
	real*8 out(1),temp

	do 10 i=1,nnum
	 if (abs(in(i)) .lt. 1) then
		temp = dble(nint(in(i) * 1000000))
		out(i) = temp/1000000
	 else if ((abs(in(i)) .ge. 1) .and. (abs(in(i)) .lt. 10)) then
		temp = dble(nint(in(i) * 100000))
		out(i) = temp/100000
	 else if ((abs(in(i)) .ge. 10) .and. (abs(in(i)) .lt. 100)) then
		temp = dble(nint(in(i) * 10000))
		out(i) = temp/10000
	 else if ((abs(in(i)) .ge. 100) .and. (abs(in(i)).lt.1000)) then
		temp = dble(nint(in(i) * 1000))
		out(i) = temp/1000
	 else if ((abs(in(i)).ge.1000) .and. (abs(in(i)).lt.10000)) then
		temp = dble(nint(in(i) * 100))
		out(i) = temp/100
	 else if ((abs(in(i)).ge.10000).and.(abs(in(i)).lt.100000)) then
		temp = dble(nint(in(i) * 10))
		out(i) = temp/10
	 else
		out(i) = dble(in(i))
	 end if
10	continue

	return
	end
