/****************************************************************************
 *      Copyright (c) 1993, 1994
 *      Century Computing, Inc.
 *      ALL RIGHTS RESERVED
 *
 *      The software (programs, data bases and/or documentation) on or in
 *      any media can not be reproduced, disclosed, or used except under
 *      the terms of the TAE Plus Software License Agreement.
 *
 ***************************************************************************/



/*****************************************************************************
 *
 *    Function prototypes for supported VM and CO functions.  This file is
 * only used by C (whatever flavor) and not C++.  The C++ declarations and
 * use of some of these functions is different enough that trying to use
 * this file for C and C++ at this time.  symbol.h has many of these
 * declarations (in a slightly different form).  When you need to add
 * a declaration for a C function for use with C++, modify symbol.h
 * 
 * Change Log:
 * 07-jul-93 Initial...rt
 * 07-sep-95 Changed declarations of Vm_Copy and several Co_ modules to
 *	     match arguments in actual function definitions...raw
 *
 *****************************************************************************/

        /* Make multiple includes of this file safe. */
#ifndef _TAE_VmCoProto_h
#define _TAE_VmCoProto_h

#ifndef __cplusplus    /* These declarations only work with C for now */
#include "vminc.inc"

/* Supported VM functions */
    VOID Vm_Call (Id vmid);
    struct VM_STRUCT;
    VOID Vm_Copy (struct VM_STRUCT *target,
			      struct VM_STRUCT *source);
    CODE Vm_DynTutor (Id vmid, TEXT pdfname[], FUNINT pdfset);
    struct VARIABLE * Vm_Find (Id vmid, TEXT name[]);
    struct VARIABLE * Vm_FindVar (Id vmid, TEXT *name);
    CODE Vm_ForEach (Id vmid, CODE (*aFunction)(),
                     GENPTR contextArg);
    CODE Vm_FormatVar (Id vmid, TEXT line[], COUNT length);
    VOID Vm_Free (Id vmid);
    CODE Vm_GetAttribute (Id vmid, TEXT name[], CODE *type,
                          COUNT *n, BOOL *dflt, CODE *access);
    VOID Vm_GetHostError (Id vmid, CODE *vmcode);
    CODE Vm_GetValidIntg (Id vmid, TEXT name[], FUNINT *count,
                          TAEINT **ilow, TAEINT **ihigh);
    CODE Vm_GetValidReal (Id vmid, TEXT name[], FUNINT *count,
                          TAEFLOAT **rlow, TAEFLOAT **rhigh);
    CODE Vm_GetValidString (Id vmid, TEXT name[], FUNINT *count,
                            TEXT ***vector);
    VOID Vm_InitFormat (Id vmid);
    Id Vm_New (FUNINT mode);
    FILE * Vm_OpenStdout (Id vmid);
    CODE Vm_ReadFromDisk (Id vmid, TEXT spec[]);
    CODE Vm_ReadFromTM (Id vmid);
    CODE Vm_SetIntg (Id vmid, TEXT name[], FUNINT count,
                     TAEINT intg[], FUNINT mode);
    CODE Vm_SetMax (Id vmid, TEXT name[], FUNINT count);
    CODE Vm_SetMin (Id vmid, TEXT name[], FUNINT count);
    CODE Vm_SetNextMenu (Id vmid, TEXT name[]);
    CODE Vm_SetParmPage (Id vmid, TEXT name[], BOOL flag);
    CODE Vm_SetReal (Id, TEXT name[], FUNINT count,
                     TAEFLOAT *real, FUNINT mode);
    CODE Vm_SetString (Id, TEXT name[], FUNINT count,
                       TEXT *vector[], FUNINT mode);
    CODE Vm_SetStringLength (Id vmid, TEXT name[], FUNINT strlen);
    CODE Vm_SetTCLVar (Id vmid);
    CODE Vm_SetValidIntg (Id vmid, TEXT name[], FUNINT count,
                          TAEINT *ilo, TAEINT *ihi);
    CODE Vm_SetValidReal (Id vmid, TEXT name[], FUNINT count,
                          TAEFLOAT rlow[], TAEFLOAT rhigh[]);
    CODE Vm_SetValidString (Id vmid, TEXT name[], FUNINT count,
                            TEXT *vector[]);
    CODE Vm_WriteToDisk (Id vmid, TEXT spec[]);


/* Supported CO functions */

    struct COLLECTION;
    VOID Co_Add (struct COLLECTION *aCollection,
			     Id anObject, TEXT memName[], CODE type);
    Id Co_Find (struct COLLECTION *aCollection,
			    TEXT memName[]);
    CODE Co_ForEach (struct COLLECTION *aCollection,
				 CODE (*aFunction)(),
				 GENPTR contextArg);
    VOID Co_Free (struct COLLECTION *aCollection,
			      VOID (*freeFunction)() );
    Id Co_New (CODE flags);
    CODE Co_ReadFile (Id aCollection, TEXT fileSpec[],
				  CODE mode);
    Id Co_Remove (struct COLLECTION *aCollection,
			      TEXT memName[]);
    CODE Co_WriteFile (Id aCollection, TEXT filespec[]);

#endif /* __cplusplus */

/* DO NOT ADD ANYTHING AFTER THIS endif */
#endif 	/* _TAE_VmCoProto_h */
