/****************************************************************************
 *      Copyright (c) 1993, 1994
 *      Century Computing, Inc.
 *      ALL RIGHTS RESERVED
 *
 *      The software (programs, data bases and/or documentation) on or in
 *      any media can not be reproduced, disclosed, or used except under
 *      the terms of the TAE Plus Software License Agreement.
 *
 ***************************************************************************/



/* old Parameter block include file.
 *
 * CHANGE LOG
 * 01-may-92 Created...tpl
 */

#ifndef I_OLDPARBLK		/* prevent double include		*/
#define I_OLDPARBLK	0

#include	"parblk.inc"	/* TM symbol table			*/
#include	"symtab.inc"	/* TM symbol table			*/


/*	Macro to generate a OLDPARBLK definition given pool size		*/

#define DEF_OLDPARBLK(STRUCT, POOL_SIZE)    struct STRUCT\
	{\
	CODE		msgtyp;	  /* message type - MSGDEF include file */\
	BIT_FIELD_ALIGN\
	unsigned	last : 1; /* 1 = last block of symbol table	*/\
	BIT_FIELD_ALIGN\
	COMPACT_UCOUNT	blksiz;	  /* block size in bytes		*/\
	COMPACT_UCOUNT	numvar;   /* not used 				*/\
	CODE		actmod;	  /* activation mode			*/\
	COMPACT_COUNT	vers;	  /* stuff version here			*/\
	struct SYMTAB	symtab;	  /* symbol table for all variables	*/\
	CODE		extra1;	  /* this & next for local use		*/\
	CODE		extra2;   \
	CODE		hostcode;  /* host code				*/\
	CODE		mode;	   /* used outboard for current mode	*/\
	GENPTR		ctxptr;	   /* used outboard for context ptr	*/\
	TEXT		spare[25]; /* reserved for future		*/\
    	ALIGN		pool[1+(POOL_SIZE-1)/sizeof(ALIGN)];\
	}

#define	OLD_P_BYTES		5300	/* size of storage pool         */
#define OLD_LARGE_P_BYTES	MAX_COMPACT_UCOUNT /* size of a large storage pool		*/

DEF_OLDPARBLK(OLDPARBLK, OLD_P_BYTES);		/* TAE-standard PARBLK 		*/
DEF_OLDPARBLK(OLD_LARGE_PARBLK, OLD_LARGE_P_BYTES);/* very large PARBLK		*/
DEF_OLDPARBLK(OLD_NP_PARBLK, 1);		/* "No Pool" PARBLK		*/

#define P_NAMESIZ	NAMESIZ		/* maximum number of chars in a parm	*/

    struct OLDPARHDR 
	{
	TEXT	sentinel[P_SENTSIZ+1];	/* sentinel string		*/
	COMPACT_UCOUNT	recsize;	/* bytes in next record		*/
	TEXT	datetime[P_TIMESIZ+1];	/* date/time of file creation	*/
	TEXT	filename[FNAMESIZ+1];	/* original file name component	*/
	TEXT	spare[80];		/* reserved for future		*/
	};
#endif
