/****************************************************************************
 *      Copyright (c) 1993, 1994
 *      Century Computing, Inc.
 *      ALL RIGHTS RESERVED
 *
 *      The software (programs, data bases and/or documentation) on or in
 *      any media can not be reproduced, disclosed, or used except under
 *      the terms of the TAE Plus Software License Agreement.
 *
 ***************************************************************************/



/* CHANGE LOG:
 * 01-may-92 Createed...tpl
 */

#include	"taeconf.inp"
#include	"tminc.inc"
#include	"oldresinc.inc"		/* inc for restricted allocation*/
#include	"oldparblk.inc"		/* parameter block structure    */


/*
 *	makeabs. Converts all pointers in a symbol table to absolute so
 *	that the table can be easily manipulated.  We assume that the
 *	symbol table was previously made "all pointers relative".
 *
 *	If a bad link is found, we stop the makesabs process to avoid
 *	crashing.   Such can only happen for blocks from the outside
 *	world (disk or subproces) and, for such blocks, the chk_parblk
 *	function will catch the error.
 *
 *	Handles the special pointers.
 *
 *	TAE versions 1.2 and earlier did use parameter qualifier symbol
 *	tables, nor parameters with type=NAME.  If the v_pv12 bit of 
 *	the variable structure is TRUE, the variable was created by a TAE
 *	version post V 1.2.
 */

    FUNCTION VOID oldmakeabs(symtab, s)

	struct SYMTAB	*symtab;		/* input/output: symbol table*/
	ALIGN		*s;			/* input: pooled storage area*/
	
	{
	struct VARIABLE	*v;			/* working VARIABLE pointer  */
	COUNT		i;
    	GENPTR		pool1;
	GENPTR		vgen;
	TEXT 	   	**vc;			/* ptr to string ptr vector  */
	GENPTR		oldr_setabs();		/* ref'ed by SET_ABS macro   */
	GENPTR		cvp;
	GENPTR		gen;
	struct S_VALID  *svalid;
	BOOL		deref_default;		/* TRUE if deref'd PARM...	*/
						/* DEFAULT -- compiled PDFs only*/
        
	pool1 = (GENPTR)s ;			/* lower limit of block	     */
	OLD_SET_ABS((*symtab).link, s, struct VARIABLE *); /* set initial link   */
	for (v=(*symtab).link; v != NULL; v=(*v).v_link)
	    {
	    vgen = (GENPTR) v;			/* generic form of v for...  */
	    if (vgen < pool1)
		break;				/* stop here to avoid crash  */
	    OLD_SET_ABS((*v).v_link, s, struct VARIABLE *);
	    deref_default = ((*v).v_class == V_PARM  &&  (*v).v_deref);
	    if ((*v).v_class == V_GLOBAL)	/* fix reqd on defin PDF ptr?*/
		{
		OLD_SET_ABS((*v).v_pdf, s, struct DEFPDF *);
		gen = (GENPTR) (*v).v_pdf;
		if (gen != NULL && (gen < pool1 ))
		    break;		
		}
	    if ((*v).v_type == V_NAME)		/* NAME parms only from compiled*/
		{
		if (!(*v).v_pv12)		/* no NAME parms from old TAE vers*/
		    break;
		OLD_SET_ABS((*v).v_nref, s, TEXT *);
		gen = (GENPTR) (*v).v_nref;
		if (gen != NULL && (gen < pool1))
		    break;		
		}
	    else				/* not NAME parm		*/
		{
		OLD_SET_ABS((*v).v_valid, s, GENPTR);
		gen = (*v).v_valid;
		if (gen != NULL && (gen < pool1 ))
		    break;		
#ifdef POINTER_VALIDS
		if ((*v).v_type == V_STRING && (*v).v_valid)
		    {
	 	    svalid = (struct S_VALID *) (*v).v_valid;	
		    for (i=0; i < (*svalid).count; i++)
			{
			OLD_SET_ABS((*svalid).slist[i].string, s, TEXT *);
			gen = (*svalid).slist[i].string;
			if (gen < pool1)
			    break;
			}
		    }
#endif
		OLD_SET_ABS((*v).v_cvp, s, GENPTR);	/* now the current value     */
		cvp = (*v).v_cvp;
		if (cvp != NULL && (cvp < pool1 ))
		    break;			/* stop here to avoid crash  */
		if ((*v).v_type == V_STRING  &&  !deref_default)
		    {
		    vc = (TEXT **) cvp;		/* ptr to current string ptr */
		    for (i=0; i < (*v).v_count; i++)
			{
			OLD_SET_ABS(vc[i], s, TEXT *);
			if ((GENPTR) vc[i] < pool1 )
			    break;		
			}
		    }
		OLD_SET_ABS((*v).v_dvp, s, GENPTR);	/* now the default value     */
		cvp = (*v).v_dvp;
		if (cvp != NULL && (cvp < pool1 ))
		    break;			/* stop here to avoid crash  */
		if ((*v).v_type == V_STRING  &&  !deref_default)
		    {
		    vc = (TEXT **) cvp;		/* ptr to current string ptr */
		    for (i=0; i < (*v).v_dcount; i++)
			{
			OLD_SET_ABS(vc[i], s, TEXT *);
			if ((GENPTR) vc[i] < pool1 )
			    break;		
			}
		    }
		}
	    if ((*v).v_pv12 && (*v).v_qualst.link != NULL)
		oldmakeabs(&(*v).v_qualst, s);	/* recursive - parm qual sym tab*/
	    }
        return;
	}		
