/****************************************************************************
 *      Copyright (c) 1993, 1994
 *      Century Computing, Inc.
 *      ALL RIGHTS RESERVED
 *
 *      The software (programs, data bases and/or documentation) on or in
 *      any media can not be reproduced, disclosed, or used except under
 *      the terms of the TAE Plus Software License Agreement.
 *
 ***************************************************************************/
#if defined (sun)
#include <sys/vnode.h>
#endif
#include "stdh.inp"
#include "taeconf.inp"
#include "expinc.inc"            /* expression evaluation support        */
#include "symtab.inc"            /* symbol table definitions             */
#include "syninc.inc"            /* syntax support                       */
#include "inttaelib.h"
    
/*
 *  CHANGE LOG:
 *
 *      11/15/82        add s_s2dr...nhe
 *      12/10/82        add s_string...palm
 *      16-Dec-82       New include strategy...palm
 *      14-Dec-82       s_dr2s new....palm
 *      20-Feb-83       use tae_alloc, tae_dealloc...palm
 *      28-Feb-83       change s_s2dr function to use getprim...nhe
 *                      update s_s2i, add s_s2i1
 *      07-Mar-83       Correct s_s2i, s_s2dr to handle signs...nhe
 *      15-mar-83       New s_bcopy...palm
 *      31-mar-83       s_dr2s --> s_r2ws, s_r2s outputs g format...peb
 *      31-mar-83       Eliminate s_s2r, s_s2dr --> s_s2r...peb
 *      02-apr-83       Fix comment in s_s2i1...peb
 *      04-apr-83       Fix zero display in s_r2s...peb
 *      11-may-83       Remove conversion functions to a different module...dm
 *      06-feb-84       Remove definition of UPPER...dm
 *      06-feb-84       Remove functions which are standardly in C;
 *                      Write bytmov and zero_block in C...palm
 *      25-jun-84       Conditional compilation of source ...dm
 *      01-apr-88       Merged nooptstr.c and optstr.c...ljn
 */

/*      TAE string package for C callers.      */

/*
 *      s_bcopy.    Bounded copy.
 *
 *      Returns length of output string.  Output string is never
 *      longer than 'siz' characters (not including EOS).
 *      (Typically, you pass a SIZ constant like STRINGSIZ.)
 */
FUNCTION COUNT s_bcopy
(
    const char *instr,      /* in: input string             */
    TEXT   outstr[],        /* out: output string           */
    FUNINT siz              /* in: max size of outstr       */
)
{
    COUNT       i;
    
    for (i=0; i < siz; i++)
    {
        if ((outstr[i] = instr[i]) == EOS)
             return (i);
    }
    outstr[siz] = EOS;                  /* clip at max siz      */
    return (siz);
}    
