/****************************************************************************
 *      Copyright (c) 1993, 1994
 *      Century Computing, Inc.
 *      ALL RIGHTS RESERVED
 *
 *      The software (programs, data bases and/or documentation) on or in
 *      any media can not be reproduced, disclosed, or used except under
 *      the terms of the TAE Plus Software License Agreement.
 *
 ***************************************************************************/

/*      stdfunc. Functions related to standard output, needed by FORTRAN
 *               programs.
 *
 *      CHANGE LOG:
 *
 *      22-aug-84       Change function names, update for UNIX...dm
 *      03-apr-88       Apollo conversion: FOR_NAME macro...ljn
 *
 */
#include      <vmcoproto.h> //DK
#include "taeconf.inp"
#include "forstr.inp"
#include "local_protos.h"

#ifdef UNIX
#define GETLUN  FOR_NAME(getlun)
#define SETLUN  FOR_NAME(setlun)
#define GETSTD  FOR_NAME(getstd)
#define SETSTD  FOR_NAME(setstd)
#else                   /* for VMS      */      
#define GETLUN  getlun
#define SETLUN  setlun
#define GETSTD  getstd
#define SETSTD  setstd
#endif

static struct 
{
    long   lun;
    long   termstd;
} xzsavl = { -1, -1 };

/*
 *      getlun. Get the lun number assigned to standard output
 */

FUNCTION VOID GETLUN
(
    long *lun               /* in: lun number               */      
) 
{
    *lun = xzsavl.lun;          /* -1 means not assigned        */
}
    
/*
 *      setlun. Set the lun number assigned to standard output
 */

FUNCTION VOID SETLUN
(
    long *lun               /* out: lun number              */
) 
{
    xzsavl.lun = *lun;          /* -1 means not assigned        */
}

/*
 *      setstd. Set standard output type
 *      TRUE means stdout=terminal
 */
 
FUNCTION VOID SETSTD
(
    FUNINT *term            /* in: TRUE if terminal         */
)
{
    xzsavl.termstd = *term;
}

/*
 *      getstd. Find if terminal is the standard output         *
 */

FUNCTION VOID GETSTD
(
    FUNINT *term            /* out: TRUE if terminal        */
)
{
    *term = xzsavl.termstd;
}
