/****************************************************************************
 *      Copyright (c) 1993, 1994
 *      Century Computing, Inc.
 *      ALL RIGHTS RESERVED
 *
 *      The software (programs, data bases and/or documentation) on or in
 *      any media can not be reproduced, disclosed, or used except under
 *      the terms of the TAE Plus Software License Agreement.
 *
 ***************************************************************************/

/* Written in C, functions in this package should be called 
 * by application programs to retrieve parameters from
 * a no-pool parameter block initialized as discussed below.
 *
 * A caller supplied parameter block is initialized either with
 *
 *      Vm_ReadFromTm - receives parameters from the terminal monitor (TM), or
 *      Vm_ReadFromDisk - reads parameters from a specially formatted disk file.
 *
 * Note that the above two functions are in other source files.
 *
 * CHANGE LOG:
 *
 *            27-APR-87 Created...tpl
 *            22-Jul-92 PR1519: Label Vm_Find as FUNCTION...kbs
 */

#include "taeconf.inp"
#include "symtab.inc"
#include "parblk.inc"
#include "vminc.inc"
#include "local_protos.h"

/*      Vm_FindVar - find variable in parameter block.  Return VARIABLE pointer.
 */

FUNCTION struct VARIABLE *Vm_FindVar 
(
    GENPTR     h,           /* in:  no-pool parblk handle */
    TEXT name[]             /* in:  parameter name        */
)
{
    struct VM_STRUCT    *vm;
    struct PARBLK       *p;

    vm = (struct VM_STRUCT *)h;
    p = (struct PARBLK *)&(*vm).npblk;
    return( p_fvar ( p, name ) );      /* only parms have qualifiers  */
}
