/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 2.0.
 *
 */
#include <sys/file.h>
#include "typlim.h"
#include "xid.h" 
#include "../xid_widgets/Context.h"

void
setatt_apply(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine copies the currently set attribute values into the appropriate
    graphics element structure.  The "Set Attributes" panel is then closed.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long    current_idx,		/* Index of current graphics element.	      */
	i;			/* Looping index.			      */

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Copy the attribute values specified by the user into the current graphics
    element structure.
*/
for (i=0; i < MAXATT; i++)
    if (xid_graphics.attr_values[i][0] != '\0')
	strcpy(xid_element[current_idx].attributes[i],xid_graphics.
	    attr_values[i]);

/*
    Close the "Set Attributes" panel.
*/
setatt_dismiss(w, client, call);

/*
    Set a flag indicating the graphics element has been modified.
*/
if (xid_graphics.flags & GR_EDIT)
    xid_editgraph.flags |= GR_MODIFY;
}

void
setatt_enter(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine retrieves the user specified attribute values and makes
    sure the value is valid based on the data type specified.  The value
    is then copied into the graphics structure.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long    	current_idx,	/* Index of current graphics element.	      */
		i,		/* Looping index.			      */
		status;		/* Status indicator.			      */

char		mesg[80],	/* Error message text.		      	      */
		*ptr,		/* String pointer.			      */
		*value;		/* Text string value.			      */

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Retrieve the user specified attribute value.
*/
value = XmTextGetString(w);
if (strlen(value) > (ATTVAL - 1))
    {
    XtFree(value);
    sprintf(mesg,"Attribute value may only contain %d characters",ATTVAL-1);
    xid_message (mesg);
    return;
    }

/*
    Set the current graphics type (if it has not already been set) and
    initialize the appropriate fields.
*/
if (xid_element[current_idx].type == NO_TYPE)
    {
    xid_element[current_idx].type = xid_graphics.type;
    xid_element[current_idx].graph_ptr = (long *)NULL;
    xid_element[current_idx].color = -1; 
    xid_element[current_idx].font = -1; 
    xid_element[current_idx].writeflg = FALSE; 
    }

/*
    Find the attribute index.
*/
for (i=0; i < MAXATT; i++)
    if (w == setatt_att_text[i])
	break;

/*
    Verify the value is valid based on the data type of the attribute.
*/
if (strcmp(xid_graphics.attr_types[i],"CHA") != 0)
    {
    for (ptr = value; *ptr != '\0'; ptr++)
	{
	status = isdigit(*ptr);
	if ((status == 0) && (*ptr != '-') && (*ptr != '+') && (*ptr != '.'))
	    {
	    sprintf(mesg,"Invalid attribute value -- must be %s",
		xid_graphics.attr_types[i]);
	    xid_message(mesg);
	    return;
	    }
	else if ((status == 0) && (*ptr == '.') && 
	    (*xid_graphics.attr_types[i] == 'I'))
	    {
	    sprintf(mesg,"Invalid attribute value -- must be %s",
		xid_graphics.attr_types[i]);
	    xid_message(mesg);
	    return;
	    }
	}
    }

/*
    Set the attribute value.
*/
strcpy(xid_graphics.attr_values[i],value);

/*
    Move to the next attribute.
*/
XmProcessTraversal(w,XmTRAVERSE_DOWN);
}

void
setatt_popup(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine pops up the "Set Attributes" panel. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
/*
    Create and pop up the "Set Attributes" panel.
*/
Setatt_form = Createsetatt_form(Shell_Setatt);
if (Setatt_form == NULL)
    return;
XtManageChild(Setatt_form);
XtPopup(Shell_Setatt, XtGrabNone);

/*
    Set both the "Set Attributes" and "Define Attributes" buttons on the 
    graphics panel to insensitive.
*/
XtSetSensitive(graphics_setatt_button,False);
XtSetSensitive(graphics_defatt_button,False);
}

/* ARGSUSED */
void
defatt_popup(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine pops up the "Define Attributes" panel. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
/*
    Create and pop up the "Define Attributes" panel.
*/
Defatt_form = Createdefatt_form(Shell_Defatt);
XtManageChild(Defatt_form);
XtPopup(Shell_Defatt, XtGrabNone);

/*
    Set both the "Define Attributes" and "Set Attributes" buttons on the 
    graphics panel to insensitive.
*/
XtSetSensitive(graphics_defatt_button,False);
XtSetSensitive(graphics_setatt_button,False);
}

void
graphics_cancel(w,plane_idx)
Widget	w;			/* Widget ID.  (I)			      */

long	plane_idx;		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */

/*******************************************************************************
Purpose:
    This routine cancels the graphics element currently being selected.  Any
    rubber-band lines are erased, any currently selected line segments are
    erased and the current point structures are freed.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
struct  PT_LIST         *tmp;	/* Temporary pointer to point strucutre.      */

long    height,         	/* Height of area to clear or rectangle
				   height.                                    */
	maxx = MINLONG,		/* Maximum X coordinate of area to clear.     */
	maxy = MINLONG,		/* Maximum Y coordinate of area to clear.     */
	minx = MAXLONG,		/* Minimum X coordinate of area to clear.     */
	miny = MAXLONG,		/* Minimum Y coordinate of area to clear.     */
	width,          	/* Width of area to clear or rectangle width. */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

/*
    Erase the rubber-band line.
*/
XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,
    CapButt,JoinMiter);
XSetForeground(xid.display,xid_graphics.gc,xid_graphics.
    rb_fore);
XSetFunction(xid.display,xid_graphics.gc,GXxor);

if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
    {
    if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
	    selectx,xid_graphics.selecty,xid_graphics.prevx,
	    xid_graphics.prevy);
    }
/*
    Erase the rubber-band rectangle.
*/
if (xid_graphics.type == RECT)
    {
    if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	{
	width = xid_graphics.prevx - xid_graphics.selectx;
	height = xid_graphics.prevy - xid_graphics.selecty;
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		xid_graphics.selectx,xid_graphics.selecty,width,height);
	}
    }
/*
    If the number of points selected is greater than 1, erase the line
    segments from the bitmap.  XClearArea is called to clear the affected
    rectangle which forces an expose event.
*/
if (xid_graphics.temp_num > 1)
    {
    while (xid_graphics.cur->prev != NULL)
	{
/*
    Convert the file coordinates to the main image window coordinates.
*/
        tmp = xid_graphics.cur->prev;
        xid_file2win(plane_idx,0,(float)tmp->x,(float)tmp->y,&xwin,&ywin);
        xid_file2win(plane_idx,0,xid_graphics.cur->x,xid_graphics.cur->y,
	    &x1win,&y1win);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
/*
    Calculate the bounding rectangle (used for call to XClearArea).
*/
	if (xwin < minx)
	    minx = xwin;
	if (x1win < minx)
	    minx = x1win;
	if (xwin > maxx)
	    maxx = xwin;
	if (x1win > maxx)
	    maxx = x1win;
	if (ywin < miny)
	    miny = ywin;
	if (y1win < miny)
	    miny = x1win;
	if (ywin > maxy)
	    maxy = ywin;
	if (y1win > maxy)
	    maxy = y1win;
/*
    Erase the line from the full resolution image window.
*/
	if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	    tmp = xid_graphics.cur->prev;
	    xid_file2win(plane_idx,1,(float)tmp->x,(float)tmp->y,&xwin,&ywin);
	    xid_file2win(plane_idx,1,xid_graphics.cur->x,xid_graphics.cur->y,
		&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
		line_width,LineSolid,CapButt,JoinMiter);
	    XSetBackground(xid.display,xid_graphics.rb_gc,0);
	    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.color],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    XSetBackground(xid.display,xid_graphics.rb_gc,1);
	    XSetForeground(xid.display,xid_graphics.rb_gc,1);
	    }
/*
    Erase the line from the zoomed window.
*/
	if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to zoom window coordinates.
*/
	    tmp = xid_graphics.cur->prev;
	    xid_file2win(plane_idx,2,(float)tmp->x,(float)tmp->y,&xwin,&ywin);
	    xid_file2win(plane_idx,2,xid_graphics.cur->x,xid_graphics.cur->y,
		&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
		line_width,LineSolid,CapButt,JoinMiter);
	    XSetBackground(xid.display,xid_graphics.rb_gc,0);
	    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    XSetBackground(xid.display,xid_graphics.rb_gc,1);
	    XSetForeground(xid.display,xid_graphics.rb_gc,1);
	    }
/*
    Free the current point structure.
*/
	free(xid_graphics.cur);
	xid_graphics.cur = tmp;
	xid_graphics.cur->next = (struct PT_LIST *)NULL;
	}
/*
    Calculate the width and height of the bounding rectangle.
*/
    width = maxx - minx + 1;
    height = maxy - miny + 1;
/*
    Clear the bounding rectangle of the line segment erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line segment has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
    XClearArea(xid.display,XtWindow(main_image_bulletinboard),minx,
	miny,width,height,True);
/*
    Clear the entire full resolution window.  This causes an expose event 
    which in turn copies the graphics bitmaps to the window.  The line segment 
    has been deleted from the bitmap so it no longer is displayed after the 
    expose event.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
        XClearArea(xid.display,XtWindow(fullres_win_bulletinboard),0,
	    0,0,0,True);
/*
    Clear the entire zoom window.  This causes an expose event which in turn 
    copies the graphics bitmaps to the window.  The line segment has been 
    deleted from the bitmap so it no longer is displayed after the expose event.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	XClearArea(xid.display,XtWindow(zoom_win_bulletinboard),0,
	    0,xid_zoom.parms.factor * xid_zoom.parms.in_samps,
	    xid_zoom.parms.factor * xid_zoom.parms.in_lines,True);
    }
/*
    If deleting the last point, simply free the point structure.
*/
else if (xid_graphics.temp_num == 1)
    {
    free(xid_graphics.cur);
    xid_graphics.cur = (struct PT_LIST *)NULL;
    xid_graphics.first = (struct PT_LIST *)NULL;
    }
return;
}

long
graphics_cancel2(w,plane_idx)
Widget	w;			/* Widget ID.  (I)			      */

long	plane_idx;		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */

/*******************************************************************************
Purpose:
    This routine cancels the current graphics element.  If the label has not 
    been placed, the rubber-band rectangle is erased, the current point, 
    line, polygon or annotation text is erased and if the label has been 
    placed, it is also erased.  The difference between this routine and 
    graphics_cancel is that graphics_cancel cancels graphics elements which
    are still in the process of being selected.  Graphics_cancel2 cancels
    graphics elements which have been "closed" and therefore stored in the
    xid_element graphics structure (the graphics element label may or may
    not have already been placed).
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
void    graphics_expose_area(); /* Function to trigger an expose event of the
                                   area around a given graphics element.      */

struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

float	x1,			/* First X coordinate of line segment.	      */
	x2,			/* Second X coordinate of line segment.	      */
	y1,			/* First Y coordinate of line segment.	      */
	y2;			/* Second Y coordinate of line segment.	      */

long    erase = FALSE,		/* Indicates whether or not there is text
				   (annotation or label) to erase.	      */
	i,			/* Looping index.			      */
	num_vert,		/* Number of vertices.			      */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

char	*string;		/* Label or annotation string.		      */

if (xid_graphics.flags & GR_LABEL)
    {
/*
    Erase the rubber-band rectangle outlining the label.
*/
    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	JoinMiter);
    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
    XSetFunction(xid.display,xid_graphics.gc,GXxor);
    if ((xid_label.x != -1) && (xid_label.y != -1))
	XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,xid_label.x,
	    xid_label.y,xid_label.width,xid_label.height);
    xid_label.x = xid_label.y = -1;
    xid_graphics.flags &= ~GR_LABEL;
    }

if (xid_graphics.type == POINT)
    {
    xid_file2win(plane_idx,0,xid_element[xid_graphics.current].x,xid_element[
	xid_graphics.current].y,&xwin,&ywin);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the point.
*/
    XDrawPoint(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin); 

    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);

/*
    Erase the point from the full resolution image window.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	xid_file2win(plane_idx,1,xid_element[xid_graphics.current].x,
	    xid_element[xid_graphics.current].y,&xwin,&ywin);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the point.
*/
	XDrawPoint(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin); 
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	}
/*
    Erase the point from the zoomed window.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
/*
    Convert the file coordinates to zoom window coordinates.
*/
	xid_file2win(plane_idx,2,xid_element[xid_graphics.current].x,
	    xid_element[xid_graphics.current].y,&xwin,&ywin);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the point.
*/
	XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin); 
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	}
    }

if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT) ||
   (xid_graphics.type == LINE))
   {
/*
    Erase the line, polygon or rectangle from the bitmap.  Graphics_expose_area
    is called to clear the affected rectangle which forces an expose event.
*/
    if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
	{
	pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.current].
	    graph_ptr;
	num_vert = pptr->num_vert;
	}
    else if (xid_graphics.type == LINE)
	{
	lptr = (struct LINE_ELEMENT *)xid_element[xid_graphics.current].
	    graph_ptr;
	num_vert = lptr->num_vert - 1;
	}

    for (i=0; i < num_vert; i++)
	{
/*
    Convert the file coordinates to the main image window coordinates.
*/
	if (((xid_graphics.type == POLY) || (xid_graphics.type == RECT)) && 
	    (i == num_vert - 1))
	    {
	    x1 = pptr->x[0];
	    y1 = pptr->y[0];
	    x2 = pptr->x[i];
	    y2 = pptr->y[i];
	    }
	else if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
	    {
	    x1 = pptr->x[i];
	    y1 = pptr->y[i];
	    x2 = pptr->x[i+1];
	    y2 = pptr->y[i+1];
	    }
	else if (xid_graphics.type == LINE)
	    {
	    x1 = lptr->x[i];
	    y1 = lptr->y[i];
	    x2 = lptr->x[i+1];
	    y2 = lptr->y[i+1];
	    }

	xid_file2win(plane_idx,0,x1,y1,&xwin,&ywin);
	xid_file2win(plane_idx,0,x2,y2,&x1win,&y1win);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);

/*
    Erase the line from the full resolution image window.
*/
	if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	    xid_file2win(plane_idx,1,x1,y1,&xwin,&ywin);
	    xid_file2win(plane_idx,1,x2,y2,&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
		line_width,LineSolid,CapButt,JoinMiter);
	    XSetBackground(xid.display,xid_graphics.rb_gc,0);
	    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.color],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    XSetBackground(xid.display,xid_graphics.rb_gc,1);
	    XSetForeground(xid.display,xid_graphics.rb_gc,1);
	    }
/*
    Erase the line from the zoomed window.
*/
	if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to zoom window coordinates.
*/
	    xid_file2win(plane_idx,2,x1,y1,&xwin,&ywin);
	    xid_file2win(plane_idx,2,x2,y2,&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
		line_width,LineSolid,CapButt,JoinMiter);
	    XSetBackground(xid.display,xid_graphics.rb_gc,0);
	    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    XSetBackground(xid.display,xid_graphics.rb_gc,1);
	    XSetForeground(xid.display,xid_graphics.rb_gc,1);
	    }
	}

    }

/*
    Determine the string to be erased (annotation or label).
*/
if ((xid_element[xid_graphics.current].labelx != -1) && (xid_graphics.type == 
    TEXT))
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[xid_graphics.current].graph_ptr;
    string = malloc(strlen(aptr->string) + 1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,aptr->string);
    erase = TRUE;
    }
else if (xid_element[xid_graphics.current].labelx != -1)
    {
    string = malloc(strlen(xid_element[xid_graphics.current].label)+1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,xid_element[xid_graphics.current].label);
    erase = TRUE;
    }

if (erase)
    {
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the annotation text or label from the main window.
*/
    xid_file2win(plane_idx,0,xid_element[xid_graphics.current].labelx,
	xid_element[xid_graphics.current].labely,&x1win,&y1win);
    XDrawString(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,strlen(string));

/*
    Erase the annotation text/label from the full resolution window.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
	xid_file2win(plane_idx,1,xid_element[xid_graphics.current].labelx,
	    xid_element[xid_graphics.current].labely,&x1win,&y1win);
	XDrawString(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    xid_graphics.font]->max_bounds.ascent,string,strlen(string));
	}

/*
    Erase the annotation text/label from the zoom window.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
	xid_file2win(plane_idx,2,xid_element[xid_graphics.current].labelx,
	    xid_element[xid_graphics.current].labely,&x1win,&y1win);
	XDrawString(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    xid_graphics.font]->max_bounds.ascent,string,strlen(string));
	}

    free(string);

    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);
    }

/*
    Force an expose event over the area of the graphics element in the main
    image window.
*/
graphics_expose_area(0,xid_graphics.current,plane_idx);

/*
    Force an expose event which in turn copies the graphics bitmaps to the 
    window.  The graphics element has been deleted from the bitmap so it no 
    longer is displayed after the expose event.
*/
if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
    graphics_expose_area(1,xid_graphics.current,plane_idx);

/*
    Force an expose event which in turn copies the graphics bitmaps to the 
    window.  The graphics element has been deleted from the bitmap so it no 
    longer is displayed after the expose event.
*/
if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
    graphics_expose_area(2,xid_graphics.current,plane_idx);

return(XID_S);
}

/* ARGSUSED */
void
graphics_create(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine is called each time the graphics panel is mapped.  It
    initializes the appropriate variables, creates any GCs needed, creates
    any pixmaps needed and adds and removes the appropriate event handlers.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
XGCValues
	values;                 /* Values array for the GC.                   */

long	create = FALSE,		/* Indicates whether or not graphics pixmaps
				   were created.			      */
	i;			/* Looping index.			      */

unsigned long
	valuemask = 0;          /* Specify no values.                         */

/*SUPPRESS 594*/XEvent *acs=(XEvent*)call;

if (acs->type == MapNotify)
    {
/*
    Initialize graphics variables.
*/
    xid_graphics.flags &= ~GR_LOAD;
    xid_graphics.flags |= GR_ACTIVE;
    xid_graphics.window = (Widget)NULL;
    xid_graphics.color = 0;
    xid_graphics.line_width = 1;
    xid_graphics.type = NO_TYPE;
    xid_graphics.flags &= ~(GR_LABEL);
    xid_editgraph.color = 0;
    strcpy(xid_graphics.lname_gof,"");
    xid_label.x = xid_label.y = -1;

    if (xid.visual_info[0].depth == 24)
	xid_graphics.rb_fore = 0xffffff;
    else
	xid_graphics.rb_fore = 0xff;

/*
    Create the graphics GC.
*/
    if (xid_graphics.gc == NULL)
	xid_graphics.gc = XCreateGC(xid.display,XtWindow(
	    main_image_bulletinboard),valuemask,&values);

/*
    Create the graphics pixmaps.
*/
    if (xid_graphics.pixmap[0] == NULL)
	{
	for (i=0; i < USER_GRCOLORS; i++)
	    xid_graphics.pixmap[i] = XCreatePixmap(xid.display,XtWindow(
		main_image_bulletinboard),xid_mem.mem_width,xid_mem.mem_height,
		1);
	create = TRUE;
	}

/*
    Create GC for drawing to pixmaps.
*/
    xid_graphics.rb_gc = XCreateGC(xid.display,xid_graphics.pixmap[0],valuemask,
	&values);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);

    if (create) 
	{
	for (i=0; i < USER_GRCOLORS; i++)
	    XFillRectangle(xid.display,xid_graphics.pixmap[i],xid_graphics.
		rb_gc,0,0,xid_mem.mem_width,xid_mem.mem_height);
	}

/*
    Create the full resolution graphics pixmaps.
*/
    if (xid_fullres != NULL)
	{
	create = FALSE;
        if ((xid_graphics.full_pix[0] == NULL) && (xid_fullres[0].image_data
	    != NULL))
	    {
	    for (i=0; i < USER_GRCOLORS; i++)
		xid_graphics.full_pix[i] = XCreatePixmap(xid.display,XtWindow(
		    fullres_win_bulletinboard),xid_fullres[0].width,
		    xid_fullres[0].height,1);
	    create = TRUE;
	    }

	if (create) 
	    {
	    for (i=0; i < USER_GRCOLORS; i++)
		XFillRectangle(xid.display,xid_graphics.full_pix[i],
		    xid_graphics.rb_gc,0,0,xid_fullres[0].width,
		    xid_fullres[0].height);
	    }
	}


/*
    Create the zoom graphics pixmaps.
*/ 
    if (xid_zoom.flags & ZOOM_ACTIVE) 
	{
	create = FALSE;
	if ((xid_graphics.zoom_pix[0] == NULL) && (xid_zoom.image_data != NULL))
	    {
	    for (i=0; i < USER_GRCOLORS; i++) 
		xid_graphics.zoom_pix[i] = XCreatePixmap(xid.display,XtWindow(
		    zoom_win_bulletinboard),xid_zoom.parms.factor * 
		    xid_zoom.parms.in_samps,xid_zoom.parms.factor * 
		    xid_zoom.parms.in_lines,1); 
	    create = TRUE;
	    }

	if (create) 
	    {
	    for (i=0; i < USER_GRCOLORS; i++)
		XFillRectangle(xid.display,xid_graphics.zoom_pix[i],
		    xid_graphics.rb_gc,0,0,xid_zoom.parms.factor * 
		    xid_zoom.parms.in_samps,xid_zoom.parms.factor * 
		    xid_zoom.parms.in_lines);
	    }
	}

    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);

/*
    Add the appropriate event handlers.
*/
    XtAddEventHandler(fullres_win_bulletinboard,LeaveWindowMask|
	EnterWindowMask,FALSE,graphics_focus,NULL);
    XtAddEventHandler(zoom_win_bulletinboard,LeaveWindowMask|
	EnterWindowMask,FALSE,graphics_focus,NULL);
    XtAddEventHandler(main_image_bulletinboard,LeaveWindowMask|EnterWindowMask,
	FALSE,graphics_focus,NULL);
    }
}

void
graphics_deletelinerect(w,win,plane_idx,x1fil,y1fil,x2fil,y2fil,flag)
Widget	w;			/* Widget ID.  (I)			      */

float   x1fil,                  /* X file coordinate of first endpoint.  (I)  */
        x2fil,                  /* X file coordinate of second endpoint.  (I) */
        y1fil,                  /* Y file coordinate of first endpoint.  (I)  */
        y2fil;                  /* Y file coordinate of second endpoint.  (I) */

long	flag,			/* Flag indicating whether or not the temporary
				   point structure is to be freed.  (I)       */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine erases a line segment from the graphics element currently 
    being selected.  Any rubber-band lines or rectangles are erased, the
    newest line segment is erased and the current point structure is freed.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long    current_idx,		/* Index of current graphics element.	      */
	eraseflg,		/* Flag indicating whether or not to draw a
				   line segment or rectangle.	              */
	height,         	/* Height of area to clear or rectangle
				   height.                                    */
	width,          	/* Width of area to clear or rectangle width. */
	xclear,			/* Starting X coordinate to clear.	      */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
	yclear,			/* Starting Y coordinate to clear.	      */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

/*
    If currently selecting graphics elements ... 
*/
if (xid_graphics.flags & GR_SELECT)
    {
/*
    Erase the rubber-band line.
*/
    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,
	CapButt,JoinMiter);
    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.
	rb_fore);
    XSetFunction(xid.display,xid_graphics.gc,GXxor);

    if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	{
	if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		selectx,xid_graphics.selecty,xid_graphics.prevx,
		xid_graphics.prevy);
	}
/*
    Erase the rubber-band rectangle.
*/
    if (xid_graphics.type == RECT)
	{
	if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	    {
	    width = xid_graphics.prevx - xid_graphics.selectx;
	    height = xid_graphics.prevy - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
		XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		    xid_graphics.selectx,xid_graphics.selecty,width,height);
	    }
	}
    }
/*
    If adding points to a currently selected graphics element ...
*/
else if ((xid_graphics.flags & GR_EDIT) && (xid_editgraph.flags & GR_ADD))
    {
/*
    Erase the rubber-band lines.
*/
    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,
	CapButt,JoinMiter);
    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.
	rb_fore);
    XSetFunction(xid.display,xid_graphics.gc,GXxor);

    if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
	(xid_editgraph.vert != -1))
	XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
	    prevx,xid_editgraph.prevy,xid_editgraph.newx,xid_editgraph.
	    newy);
   if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) &&
	(xid_editgraph.vert != -1))
	XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
	    nextx,xid_editgraph.nexty,xid_editgraph.newx,xid_editgraph.
	    newy);
    }

/*
   Set appropriate flags and indices based on current graphics mode.
*/
if (xid_graphics.flags & GR_SELECT)
    {
    if (xid_graphics.temp_num > 1)
        eraseflg = TRUE;
    else 
	eraseflg = FALSE;
    current_idx = xid_graphics.current;
    }
else if (xid_graphics.flags & GR_EDIT)
    {
    eraseflg = TRUE;
    current_idx = xid_editgraph.current;
    }
xid_graphics.color = xid_element[current_idx].color;

/*
    Erase the line segment from the bitmap.  XClearArea is called to clear the 
    affected rectangle which forces an expose event.
*/
if (eraseflg)
    {
/*
    Convert the file coordinates to the main image window coordinates.
*/
    xid_file2win(plane_idx,0,x1fil,y1fil,&xwin,&ywin);
    xid_file2win(plane_idx,0,x2fil,y2fil,&x1win,&y1win);
    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the line segment.
*/
    XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);
/*
    Calculate the bounding rectangle (used for call to XClearArea).
*/
    if (xwin < x1win)
	{
	xclear = xwin;
	width = x1win - xclear + 1;
	}
    else 
	{
	xclear = x1win;
	width = xwin - xclear + 1;
	}
    if (ywin < y1win)
	{
	yclear = ywin;
	height = y1win - yclear + 1;
	}
    else
	{
	yclear = y1win;
	height = ywin - yclear + 1;
	}
/*
    Clear the bounding rectangle of the line segment erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line segment has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
    if (xid_graphics.flags & GR_EDIT)
	{
	xclear -= HANDLE;
	yclear -= HANDLE;
	width += HANDLE; 
	height += HANDLE;
	}
    XClearArea(xid.display,XtWindow(main_image_bulletinboard),xclear,
	yclear,width,height,True);
/*
    Reset the currently selected point (window coordinates).
*/
    if (win == 0)
	{
	xid_graphics.selectx = xwin;
	xid_graphics.selecty = ywin;
	}
/*
    Erase the line from the full resolution image window.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
        {
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	xid_file2win(plane_idx,1,x1fil,y1fil,&xwin,&ywin);
	xid_file2win(plane_idx,1,x2fil,y2fil,&x1win,&y1win);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
/*
    Calculate the bounding rectangle (used for call to XClearArea).
*/
	if (xwin < x1win)
	    {
	    xclear = xwin;
	    width = x1win - xclear + 1;
	    }
	else 
	    {
	    xclear = x1win;
	    width = xwin - xclear + 1;
	    }
	if (ywin < y1win)
	    {
	    yclear = ywin;
	    height = y1win - yclear + 1;
	    }
	else
	    {
	    yclear = y1win;
	    height = ywin - yclear + 1;
	    }
/*
    Clear the bounding rectangle of the line segment erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line segment has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
	if (xid_graphics.flags & GR_EDIT)
	    {
	    xclear -= HANDLE;
	    yclear -= HANDLE;
	    width += HANDLE; 
	    height += HANDLE; 
	    }
	XClearArea(xid.display,XtWindow(fullres_win_bulletinboard),xclear,
	    yclear,width,height,True);
/*
    Reset the currently selected point (window coordinates).
*/
	if (win == 1)
	    {
	    xid_graphics.selectx = xwin;
	    xid_graphics.selecty = ywin;
	    }
        }
/*
    Erase the line from the zoomed window.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
        {
/*
    Convert the file coordinates to zoom window coordinates.
*/
	xid_file2win(plane_idx,2,x1fil,y1fil,&xwin,&ywin);
	xid_file2win(plane_idx,2,x2fil,y2fil,&x1win,&y1win);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
/*
    Calculate the bounding rectangle (used for call to XClearArea).
*/
	if (xwin < x1win)
	    {
	    xclear = xwin;
	    width = x1win - xclear + 1;
	    }
	else 
	    {
	    xclear = x1win;
	    width = xwin - xclear + 1;
	    }
	if (ywin < y1win)
	    {
	    yclear = ywin;
	    height = y1win - yclear + 1;
	    }
	else
	    {
	    yclear = y1win;
	    height = ywin - yclear + 1;
	    }
/*
    Clear the bounding rectangle of the line segment erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line segment has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
	if (xid_graphics.flags & GR_EDIT)
	    {
	    xclear -= HANDLE;
	    yclear -= HANDLE;
	    width += HANDLE; 
	    height += HANDLE; 
	    }
	XClearArea(xid.display,XtWindow(zoom_win_bulletinboard),xclear,
	    yclear,width,height,True);
/*
    Reset the currently selected point (window coordinates).
*/
	if (win == 2)
	    {
	    xid_graphics.selectx = xwin;
	    xid_graphics.selecty = ywin;
	    }
        }
/*
    Free the current point structure.
*/
    if ((flag) && (xid_graphics.temp_num > 1))
    	{
	free(xid_graphics.cur);
	xid_graphics.cur = xid_graphics.cur->prev;
	xid_graphics.cur->next = (struct PT_LIST *)NULL;
	}
    else if (flag)
	{
	free(xid_graphics.cur);
	xid_graphics.cur = (struct PT_LIST *)NULL;
	xid_graphics.first = (struct PT_LIST *)NULL;
	xid_graphics.selectx = xid_graphics.selecty = -1;
	}
    }
/*
    If deleting the last point, simply free the point structure.
*/
else if ((xid_graphics.temp_num == 1) && flag)
    {
    free(xid_graphics.cur);
    xid_graphics.cur = (struct PT_LIST *)NULL;
    xid_graphics.first = (struct PT_LIST *)NULL;
    xid_graphics.selectx = xid_graphics.selecty = -1;
    }
return;
}

long
graphics_draw(win,plane_idx,element)
long	win,			/* Window to draw into. (I)
				       -1 - All windows
					0 - Main image window
					1 - Full resolution window
					2 - Zoom window 		      */
	element,		/* Graphics element to draw.  (I)	      */
	plane_idx;		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */

/*******************************************************************************
Purpose:
    This routine draws the specified graphics element in the appropriate window. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

float	x1,			/* First X coordinate of line segment.	      */
	x2,			/* Second X coordinate of line segment.	      */
	y1,			/* First Y coordinate of line segment.	      */
	y2;			/* Second Y coordinate of line segment.	      */

long    draw = FALSE,		/* Indicates whether or not there is text
				   (annotation or label) to draw.	      */
	i,			/* Looping index.			      */
	line_width,		/* Line width.				      */
	num_vert,		/* Number of vertices.			      */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

char	*string;		/* Label or annotation string.		      */

/*
    Make sure the background and foreground values are set properly in the GC.
*/
XSetBackground(xid.display,xid_graphics.rb_gc,1);
XSetForeground(xid.display,xid_graphics.rb_gc,1);

if (xid_element[element].type == POINT)
    {
    if ((win == 0) || (win ==  -1))
	{
	xid_file2win(plane_idx,0,xid_element[element].x,xid_element[element].y,
	    &xwin,&ywin);
/*
    Draw the point.
*/
	XDrawPoint(xid.display,xid_graphics.pixmap[xid_element[element].color],
	    xid_graphics.rb_gc,xwin,ywin); 
	}
/*
    Draw the point into the full resolution image window.
*/
    if ((win == 1) || (win == -1))
	{
	if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	    xid_file2win(plane_idx,1,xid_element[element].x,xid_element
		[element].y,&xwin,&ywin);
/*
    Draw the point.
*/
	    XDrawPoint(xid.display,xid_graphics.full_pix[xid_element[element].
		color],xid_graphics.rb_gc,xwin,ywin); 
	    }
	}
/*
    Draw the point into the zoomed window.
*/
    if ((win == 2) || (win == -1))
	{
	if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to zoom window coordinates.
*/
	    xid_file2win(plane_idx,2,xid_element[element].x,xid_element
		[element].y, &xwin,&ywin);
/*
    Draw the point.
*/
	    XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_element[element].
		color],xid_graphics.rb_gc,xwin,ywin); 
	    }
	}
    }

/*
    Draw a polygon, line or rectangle.
*/
if ((xid_element[element].type == POLY) || (xid_element[element].type == RECT) 
    || (xid_element[element].type == LINE))
    {
/*
    Determine how many vertices the graphics element has.
*/
    if ((xid_element[element].type == POLY) || (xid_element[element].type == 
	RECT))
	{
	pptr = (struct POLY_ELEMENT *)xid_element[element].graph_ptr;
	num_vert = pptr->num_vert;
	line_width = pptr->line_width;
	}
    else if (xid_element[element].type == LINE)
	{
	lptr = (struct LINE_ELEMENT *)xid_element[element].graph_ptr;
	num_vert = lptr->num_vert - 1;
	line_width = lptr->line_width;
	}

    for (i=0; i < num_vert; i++)
	{
/*
    Convert the file coordinates to the main image window coordinates.
*/
	if (((xid_element[element].type == POLY) || (xid_element[element].type 
	    == RECT)) && (i == num_vert - 1))
	    {
	    x1 = pptr->x[0];
	    y1 = pptr->y[0];
	    x2 = pptr->x[i];
	    y2 = pptr->y[i];
	    }
	else if ((xid_element[element].type == POLY) || (xid_element[element].
	    type == RECT))
	    {
	    x1 = pptr->x[i];
	    y1 = pptr->y[i];
	    x2 = pptr->x[i+1];
	    y2 = pptr->y[i+1];
	    }
	else if (xid_element[element].type == LINE)
	    {
	    x1 = lptr->x[i];
	    y1 = lptr->y[i];
	    x2 = lptr->x[i+1];
	    y2 = lptr->y[i+1];
	    }

	if ((win == 0) || (win == -1))
	    {
	    xid_file2win(plane_idx,0,x1,y1,&xwin,&ywin);
	    xid_file2win(plane_idx,0,x2,y2,&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,line_width,
		LineSolid,CapButt,JoinMiter);
/*
    Draw the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.pixmap[xid_element[element].
		color],xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    }
/*
    Draw the line into the full resolution image window.
*/
	if ((win == 1) || (win == -1))
	    {
	    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
		{
/*
    Convert the file coordinates to full resolution window coordinates.
*/
		xid_file2win(plane_idx,1,x1,y1,&xwin,&ywin);
		xid_file2win(plane_idx,1,x2,y2,&x1win,&y1win);
		XSetLineAttributes(xid.display,xid_graphics.rb_gc,line_width,
		    LineSolid,CapButt,JoinMiter);
/*
    Draw the line segment.
*/
		XDrawLine(xid.display,xid_graphics.full_pix[xid_element
		    [element].color],xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
		}
	    }
/*
    Draw the line into the zoomed window.
*/
	if ((win == 2) || (win == -1))
	    {
	    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != 
		NULL))
		{
/*
    Convert the file coordinates to zoom window coordinates.
*/
		xid_file2win(plane_idx,2,x1,y1,&xwin,&ywin);
		xid_file2win(plane_idx,2,x2,y2,&x1win,&y1win);
		XSetLineAttributes(xid.display,xid_graphics.rb_gc,line_width,
		    LineSolid,CapButt,JoinMiter);
/*
    Draw the line segment.
*/
		XDrawLine(xid.display,xid_graphics.zoom_pix[xid_element
		    [element].color],xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
		}
	    }
	}

    }

/*
    Draw the annotation text or label.
*/
if (xid_element[element].type == TEXT)
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[element].graph_ptr;
    string = malloc(strlen(aptr->string) + 1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,aptr->string);
    draw = TRUE;
    }
else if (xid_element[element].labelx != -1)
    {
    string = malloc(strlen(xid_element[element].label)+1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,xid_element[element].label);
    draw = TRUE;
    }

if (draw)
    {
/*
    Convert the file coordinates to the main image window coordinates and
    draw the string.
*/
    if ((win == 0) || (win == -1))
	{
	xid_file2win(plane_idx,0,xid_element[element].labelx,
	    xid_element[element].labely,&x1win,&y1win);
	XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	    xid_element[element].font]->fid);
	XDrawString(xid.display,xid_graphics.pixmap[xid_element[element].color],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    xid_element[element].font]->max_bounds.ascent,string,
	    strlen(string));
	}

/*
    Convert the file coordinates to full resolution window coordinates and
    draw the string.
*/
    if ((win == 1) || (win == -1))
	{
	if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	    {
	    xid_file2win(plane_idx,1,xid_element[element].labelx,
		xid_element[element].labely,&x1win,&y1win);
	    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
		xid_element[element].font]->fid);
	    XDrawString(xid.display,xid_graphics.full_pix[xid_element[element].
		color],xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
		xid_element[element].font]->max_bounds.ascent,string,
		strlen(string));
	    }
	}

/*
    Convert the file coordinates to zoom window coordinates and draw the string.
*/
    if ((win == 2) || (win == -1))
	{
	if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	    {
	    xid_file2win(plane_idx,2,xid_element[element].labelx,
		xid_element[element].labely,&x1win,&y1win);
	    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
		xid_element[element].font]->fid);
	    XDrawString(xid.display,xid_graphics.zoom_pix[xid_element[element].
		color],xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
		xid_element[element].font]->max_bounds.ascent,string,
		strlen(string));
	    }
	}

    free(string);
    }
return(XID_S);
}

long
graphics_drawlinerect(w,win,event_x,event_y,plane_idx,xfil,yfil)
Widget	w;			/* Widget ID.  (I)			      */

float 	xfil,           	/* X file coordinate. (I)                     */
	yfil;           	/* Y file coordinate. (I)                     */

int	event_x,		/* X coordinate of mouse. (I)		      */
	event_y;		/* Y coordinate of mouse. (I)		      */

long	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine draws the line segment into the appropriate window and
    pixmap in the specified color.

By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
Pixel   pixelval;       	/* Pixel value of selected color.             */

Boolean argok;          	/* Status indicator.                          */

struct  PT_LIST         *tmp;	/* Temporary pointer to the point structure.  */

float	xfile,			/* X file coordinate.			      */
	yfile;			/* Y file coordinate.			      */

long    current_idx,		/* Index of current graphics element.	      */
	drawflg,		/* Flag indicating whether or not to draw a
				   line segment or rectangle.	              */
	height,         	/* Height of area to clear or rectangle
				   height.                                    */
	width,          	/* Width of area to clear or rectangle width. */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

/*
    If currently selecting graphics elements ...
*/
if (xid_graphics.flags & GR_SELECT)
    {
/*
    Erase the rubber-band line.
*/
    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,
	CapButt,JoinMiter);
    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.
	rb_fore);
    XSetFunction(xid.display,xid_graphics.gc,GXxor);

    if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	{
	if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		selectx,xid_graphics.selecty,xid_graphics.prevx,
		xid_graphics.prevy);
	}
/*
    Erase the rubber-band rectangle.
*/
    if (xid_graphics.type == RECT)
	{
	if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	    {
	    width = xid_graphics.prevx - xid_graphics.selectx;
	    height = xid_graphics.prevy - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
		XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		    xid_graphics.selectx,xid_graphics.selecty,width,height);
	    }
	}
    }

/*
    Set the appropriate flags and indices based on the current graphics mode.
*/
if (xid_graphics.flags & GR_SELECT)
    {
    if (xid_graphics.temp_num > 1)
        drawflg = TRUE;
    else 
	drawflg = FALSE;
    current_idx = xid_graphics.current;
    }
else if (xid_graphics.flags & GR_EDIT)
    {
    drawflg = TRUE;
    current_idx = xid_editgraph.current;
    }
xid_graphics.color = xid_element[current_idx].color;

/*
    Draw the line in the color selected.
*/
if ((drawflg) && ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1)))
    {
/*
    Set the appropriate color and line attributes in the GC.
*/
    pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[xid_element[
	current_idx].color], "Pixel", 0, &argok);
    XSetForeground(xid.display,xid_graphics.gc, pixelval);
    XSetFunction(xid.display,xid_graphics.gc,GXcopy);
    XSetLineAttributes(xid.display,xid_graphics.gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
/*
    Draw the line or rectangle directly to the window.
*/
    if (xid_graphics.type == RECT)
	{
	width = event_x - xid_graphics.selectx;
	height = event_y - xid_graphics.selecty;
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		xid_graphics.selectx,xid_graphics.selecty,width,height);
	}
    else
	XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
	    selectx,xid_graphics.selecty,event_x,event_y);

/*
    Draw the line or rectangle into the appropriate bitmap.
*/
    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
/*
    Main image bitmap.
*/
    if (win == 0)
	{
	if (xid_graphics.type == RECT)
	    {
	    width = event_x - xid_graphics.selectx;
	    height = event_y - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
		XDrawRectangle(xid.display,xid_graphics.pixmap[
		    xid_graphics.color],xid_graphics.rb_gc,xid_graphics.
		    selectx,xid_graphics.selecty,width,height);
	    }
	else
	    XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.
		color],xid_graphics.rb_gc,xid_graphics.selectx,
		xid_graphics.selecty,event_x,event_y);
	}
/*
    Full resolution bitmap.
*/
    else if (win == 1)
	{
	if (xid_graphics.type == RECT)
	    {
	    width = event_x - xid_graphics.selectx;
	    height = event_y - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
		XDrawRectangle(xid.display,xid_graphics.full_pix[
		    xid_graphics.color],xid_graphics.rb_gc,xid_graphics.
		    selectx,xid_graphics.selecty,width,height);
	    }
	else
	    XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.
		color],xid_graphics.rb_gc,xid_graphics.selectx,
		xid_graphics.selecty,event_x,event_y);
	}
/*
    Zoomed bitmap.
*/
    else if (win == 2)
	{
	if (xid_graphics.type == RECT)
	    {
	    width = event_x - xid_graphics.selectx;
	    height = event_y - xid_graphics.selecty;
	    if ((width > 0) && (height > 0))
		XDrawRectangle(xid.display,xid_graphics.zoom_pix[
		    xid_graphics.color],xid_graphics.rb_gc,xid_graphics.
		    selectx,xid_graphics.selecty,width,height);
	    }
	else
	    XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.
		color],xid_graphics.rb_gc,xid_graphics.selectx,
		xid_graphics.selecty,event_x,event_y);
	}
    }

/*
    Draw the line into the main image window if the current point was selected 
    from another window.
*/
pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[
    xid_element[current_idx].color], "Pixel", 0, &argok);
XSetForeground(xid.display,xid_graphics.gc, pixelval);
XSetFunction(xid.display,xid_graphics.gc,GXcopy);
XSetLineAttributes(xid.display,xid_graphics.gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);
if (xid_graphics.flags & GR_SELECT)
    {
    tmp = xid_graphics.cur->prev;
    if (tmp != NULL)
	{
	xfile = (float)tmp->x;
	yfile = (float)tmp->y;
	}
    }
else if (xid_graphics.flags & GR_EDIT)
    xid_win2file(plane_idx,win,xid_graphics.selectx,xid_graphics.selecty,
	&xfile,&yfile);

XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);

if ((win != 0) && (drawflg))
    {
/*
    Convert the file coordinate to a main image window coordinate.
*/
    xid_file2win(plane_idx,0,xfile,yfile,&xwin,&ywin);
    xid_file2win(plane_idx,0,xfil,yfil,&x1win,&y1win);
    if (xid_graphics.type == RECT)
	{
	width = x1win - xwin; 
	height = y1win - ywin; 
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,XtWindow(
		main_image_bulletinboard),xid_graphics.gc,
		xwin,ywin,width,height);
	}
    else
	XDrawLine(xid.display,XtWindow(main_image_bulletinboard),
	    xid_graphics.gc,xwin,ywin,x1win,y1win);
/*
    Draw the line into the appropriate bitmap.
*/
    if (xid_graphics.type == RECT)
	{
	width = x1win - xwin; 
	height = y1win - ywin; 
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,xid_graphics.pixmap[
		xid_graphics.color],xid_graphics.rb_gc,
		xwin,ywin,width,height);
	}
    else
	XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win);
    }

/*
    Draw the line into the full resolution image window if it exists and if 
    the current point was selected from another window.
*/
if ((win != 1) && (xid_fullres != NULL) && (drawflg) && (xid_fullres[0].
    image_pixmap != NULL))
    {
/*
    Convert the file coordinate to a full resolution window coordinate.
*/
    xid_file2win(plane_idx,1,xfile,yfile,&xwin,&ywin);
    xid_file2win(plane_idx,1,xfil,yfil,&x1win,&y1win);
    if (xid_graphics.type == RECT)
	{
	width = x1win - xwin; 
	height = y1win - ywin; 
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,XtWindow(
		fullres_win_bulletinboard),xid_graphics.gc,
		xwin,ywin,width,height);
	}
    else
	XDrawLine(xid.display,XtWindow(fullres_win_bulletinboard),
	    xid_graphics.gc,xwin,ywin,x1win,y1win);
/*
    Draw the line into the appropriate bitmap.
*/
    if (xid_graphics.type == RECT)
	{
	width = x1win - xwin; 
	height = y1win - ywin; 
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,xid_graphics.full_pix[
		xid_graphics.color],xid_graphics.rb_gc,
		xwin,ywin,width,height);
	}
    else
	XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win);
    }
/*
    Draw the line into the zoomed window if it exists and if the current point 
    was selected from another window.
*/
if ((win != 2) && (xid_zoom.flags & ZOOM_ACTIVE) && (drawflg) && (xid_zoom.
    image_pixmap != NULL))
    {
/*
    Convert the file coordinate to a zoomed window coordinate.
*/
    xid_file2win(plane_idx,2,xfile,yfile,&xwin,&ywin);
    xid_file2win(plane_idx,2,xfil,yfil,&x1win,&y1win);
    if (xid_graphics.type == RECT)
	{
	width = x1win - xwin; 
	height = y1win - ywin; 
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,XtWindow(
		zoom_win_bulletinboard),xid_graphics.gc,
		xwin,ywin,width,height);
	}
    else
	XDrawLine(xid.display,XtWindow(zoom_win_bulletinboard),
	    xid_graphics.gc,xwin,ywin,x1win,y1win);
/*
    Draw the line into the appropriate bitmap.
*/
    if (xid_graphics.type == RECT)
	{
	width = x1win - xwin; 
	height = y1win - ywin; 
	if ((width > 0) && (height > 0))
	    XDrawRectangle(xid.display,xid_graphics.zoom_pix[
		xid_graphics.color],xid_graphics.rb_gc,
		xwin,ywin,width,height);
	}
    else
	XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win);
    }
return(XID_S);
}

long
graphics_close(w,win,plane_idx)
Widget	w;			/* Widget ID.  (I)			      */

long	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine is called to "close" or complete the selection of a graphics
    element.  If the current type is point, the actual point is drawn and
    if the current type is polygon, it is closed.  If the current type is
    line, the rubber-band line is erased.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
Pixel   pixelval;       	/* Pixel value of selected color.             */

Boolean argok;          	/* Status indicator.                          */

long    height,         	/* Height of area to clear or rectangle
				   height.                                    */
	width,          	/* Width of area to clear or rectangle width. */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

/*
    Erase the rubber-band line.
*/
XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,
    CapButt,JoinMiter);
XSetForeground(xid.display,xid_graphics.gc,xid_graphics.
    rb_fore);
XSetFunction(xid.display,xid_graphics.gc,GXxor);

if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
    {
    if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	{
	XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,
	    xid_graphics.selectx,xid_graphics.selecty,xid_graphics.
	    prevx,xid_graphics.prevy);
	xid_graphics.prevx = xid_graphics.prevy = -1;
	}
    }
/*
    Erase the rubber-band rectangle.
*/
if (xid_graphics.type == RECT)
    {
    if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1))
	{
	width = xid_graphics.prevx - xid_graphics.selectx;
	height = xid_graphics.prevy - xid_graphics.selecty;
	if ((width > 0) && (height > 0))
	    {
	    XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		xid_graphics.selectx,xid_graphics.selecty,width,
		height);
	    xid_graphics.prevx = xid_graphics.prevy = -1;
	    }
	}
    }
/*
    Set the appropriate color and line attributes in the GC.
*/
pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[xid_element[
    xid_graphics.current].color], "Pixel", 0, &argok);
XSetForeground(xid.display,xid_graphics.gc, pixelval);
XSetFunction(xid.display,xid_graphics.gc,GXcopy);
XSetLineAttributes(xid.display,xid_graphics.gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);

XSetLineAttributes(xid.display,xid_graphics.rb_gc,
    xid_graphics.line_width,LineSolid,CapButt,JoinMiter);

if (xid_element[xid_graphics.current].type == POINT)
    {
/*
    Draw the point into the main window.
*/
    xid_file2win(plane_idx,0,xid_graphics.first->x,xid_graphics.
	first->y,&xwin,&ywin);
    XDrawPoint(xid.display,XtWindow(main_image_bulletinboard),
	xid_graphics.gc,xwin,ywin);

/*
    Draw the point into the appropriate bitmap.
*/
    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
    XDrawPoint(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin);
/*
    Draw the point in the full resolution window.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
	xid_file2win(plane_idx,1,xid_graphics.first->x,
	    xid_graphics.first->y,&xwin,&ywin);
	XDrawPoint(xid.display,XtWindow(fullres_win_bulletinboard),
	    xid_graphics.gc,xwin,ywin);
/*
    Draw the point into the appropriate bitmap.
*/
	XDrawPoint(xid.display,xid_graphics.full_pix[xid_graphics.
	    color],xid_graphics.rb_gc,xwin,ywin);
	}
/*
    Draw the point in the zoom window.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
	xid_file2win(plane_idx,2,xid_graphics.first->x,
	    xid_graphics.first->y,&xwin,&ywin);
	XDrawPoint(xid.display,XtWindow(zoom_win_bulletinboard),
	    xid_graphics.gc,xwin,ywin);
/*
    Draw the point into the appropriate bitmap.
*/
	XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_graphics.
	    color],xid_graphics.rb_gc,xwin,ywin);
	}
    }
else if (xid_element[xid_graphics.current].type == POLY)
    {
/*
    Print an error message if fewer than 3 points have been selected for a 
    polygon.
*/
    if (xid_graphics.temp_num < 3)
	{
	xid_message("A polygon must contain at least 3 points");
	return(XID_F);
	}
/*
    Close the polygon in the main window.
*/
    xid_file2win(plane_idx,0,xid_graphics.first->x,xid_graphics.
	first->y,&xwin,&ywin);
    xid_file2win(plane_idx,0,xid_graphics.cur->x,
	xid_graphics.cur->y,&x1win,&y1win);
    XDrawLine(xid.display,XtWindow(main_image_bulletinboard),
	xid_graphics.gc,xwin,ywin,x1win,y1win);

/*
    Draw the line into the appropriate bitmap.
*/
    XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin,x1win,y1win);
/*
    Close the polygon in the full resolution window.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
	xid_file2win(plane_idx,1,xid_graphics.first->x,
	    xid_graphics.first->y,&xwin,&ywin);
	xid_file2win(plane_idx,1,xid_graphics.cur->x,
	    xid_graphics.cur->y,&x1win,&y1win);
	XDrawLine(xid.display,XtWindow(fullres_win_bulletinboard),
	    xid_graphics.gc,xwin,ywin,x1win,y1win);
/*
    Draw the line into the appropriate bitmap.
*/
	XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.
	    color],xid_graphics.rb_gc,xwin,ywin,x1win,y1win);
	}
/*
    Close the polygon in the zoom window.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
	xid_file2win(plane_idx,2,xid_graphics.first->x,
	    xid_graphics.first->y,&xwin,&ywin);
	xid_file2win(plane_idx,2,xid_graphics.cur->x,
	    xid_graphics.cur->y,&x1win,&y1win);
	XDrawLine(xid.display,XtWindow(zoom_win_bulletinboard),
	    xid_graphics.gc,xwin,ywin,x1win,y1win);
/*
    Draw the line into the appropriate bitmap.
*/
	XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.
	    color],xid_graphics.rb_gc,xwin,ywin,x1win,y1win);
	}
    }
return(XID_S);
}

long
graphics_drawstring(w,win,event_x,event_y,plane_idx)
Widget	w;			/* Widget ID.  (I)			      */

int	event_x,		/* X coordinate of mouse. (I)		      */
    	event_y;		/* Y coordinate of mouse. (I)		      */

long	plane_idx,		/* Index into memory plane structure of the 
			           currently viewed image.  (I)		      */
    	win;			/* Type of window. (I)
				 0 - Main image window.
				 1 - Full resolution window.
				 2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine is called to draw a string into the appropriate window and
    pixmap.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
Pixel   pixelval;       	/* Pixel value of selected color.             */

struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

Boolean argok;          	/* Status indicator.                          */

float 	xfil,           	/* X file coordinate.                         */
    	yfil;           	/* Y file coordinate.                         */

long	current_idx,		/* Current graphics element index.	      */
	xwin,           	/* Window X coordinate.                       */
    	ywin;           	/* Window Y coordinate.                       */

char	*string;		/* Label or annotation string.		      */

/*
    Set the graphics element index.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Erase the rubber-band rectangle.
*/
XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
    JoinMiter);
XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
XSetFunction(xid.display,xid_graphics.gc,GXxor);
if ((xid_label.x != -1) && (xid_label.y != -1))
    XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
        xid_label.x,xid_label.y,xid_label.width,xid_label.height);
if (!(xid_graphics.flags & GR_EDIT))
    xid_label.x = xid_label.y = -1;
else if ((xid_graphics.flags & GR_EDIT) && !(xid_graphics.flags & GR_MOVE))
    xid_label.x = xid_label.y = -1;

/*
    Set the GC color, function and font.
*/
pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[xid_element[
    current_idx].color], "Pixel", 0, &argok);
XSetForeground(xid.display,xid_graphics.gc, pixelval);
XSetFunction(xid.display,xid_graphics.gc,GXcopy);
XSetFont(xid.display,xid_graphics.gc,xid_graphics.font_info[xid_graphics.
    font]->fid);

/*
    Determine what string is to be drawn.
*/
if (xid_graphics.type != TEXT)
    {
    string = malloc(strlen(xid_element[current_idx].label)+1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,xid_element[current_idx].label);
    }
else
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    string = malloc(strlen(aptr->string) + 1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,aptr->string);
    }

XDrawString(xid.display,XtWindow(w),xid_graphics.gc,event_x,event_y +
    xid_graphics.font_info[xid_graphics.font]->max_bounds.ascent,string,
    strlen(string));

/*
    Draw the string into main image window pixmap.
*/
if (win == 0)
    {
    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);
    XDrawString(xid.display,xid_graphics.pixmap[xid_graphics.
	color],xid_graphics.rb_gc,event_x,event_y+
	xid_graphics.font_info[xid_graphics.font]->max_bounds.
	ascent,string,strlen(string));
    }
/*
    Draw the string into full resolution window pixmap.
*/
else if (win == 1)
    {
    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);
    XDrawString(xid.display,xid_graphics.full_pix[xid_graphics.
	color],xid_graphics.rb_gc,event_x,event_y+
	xid_graphics.font_info[xid_graphics.font]->max_bounds.
	ascent,string,strlen(string));
    }
/*
    Draw the string into zoom window pixmap.
*/
else if (win == 2)
    {
    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);
    XDrawString(xid.display,xid_graphics.zoom_pix[xid_graphics.
	color],xid_graphics.rb_gc,event_x,event_y+
	xid_graphics.font_info[xid_graphics.font]->max_bounds.
	ascent,string,strlen(string));
    }
xid_graphics.flags &= ~(GR_LABEL);

/*
    Draw the string into the main image window and pixmap.
*/
if (win != 0)
    {
    xid_win2file(plane_idx,win,event_x,event_y,&xfil,&yfil);
    xid_file2win(plane_idx,0,xfil,yfil,&xwin,&ywin);
    XDrawString(xid.display,XtWindow(main_image_bulletinboard),
	xid_graphics.gc,xwin,ywin+xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,
	strlen(string));

    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);
    XDrawString(xid.display,xid_graphics.pixmap[xid_graphics.
	color],xid_graphics.rb_gc,xwin,ywin+xid_graphics.
	font_info[xid_graphics.font]->max_bounds.ascent,
	string,strlen(string)); 
    }

/*
    Draw the string into the full resolution window and pixmap.
*/
if ((win != 1) && (xid_fullres != NULL) && (xid_fullres[0].image_pixmap != 
    NULL))
    {
    xid_win2file(plane_idx,win,event_x,event_y,&xfil,&yfil);
    xid_file2win(plane_idx,1,xfil,yfil,&xwin,&ywin);
    XDrawString(xid.display,XtWindow(fullres_win_bulletinboard),
	xid_graphics.gc,xwin,ywin+xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,
	strlen(string));

    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);
    XDrawString(xid.display,xid_graphics.full_pix[xid_graphics.
	color],xid_graphics.rb_gc,xwin,ywin+xid_graphics.
	font_info[xid_graphics.font]->max_bounds.ascent,
	string,strlen(string)); 
    }

/*
    Draw the string into the zoom window and pixmap.
*/
if ((win != 2) && (xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != 
    NULL))
    {
    xid_win2file(plane_idx,win,event_x,event_y,&xfil,&yfil);
    xid_file2win(plane_idx,2,xfil,yfil,&xwin,&ywin);
    XDrawString(xid.display,XtWindow(zoom_win_bulletinboard),
	xid_graphics.gc,xwin,ywin+xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,
	strlen(string)); 

    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);
    XDrawString(xid.display,xid_graphics.zoom_pix[xid_graphics.
	color],xid_graphics.rb_gc,xwin,ywin+xid_graphics.
	font_info[xid_graphics.font]->max_bounds.ascent,
	string,strlen(string)); 
    }
free(string);
return(XID_S);
}

/* ARGSUSED */
void
graphics_expose(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine is called to update the graphics information when an expose 
    event is generated for the main image window, the full resolution window 
    or the zoom window.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
GC		graphics_gc;	/* Graphics context for copying graphics data
				   from a pixmap to the image windows.	      */

long		height,		/* Height of rectangle.			      */
		i, 		/* Looping index.			      */
		plane_idx,	/* Index into memory plane structure of the 
				   currently viewed image.		      */
		width,		/* Width of rectangle.			      */
		xwin,		/* X window coordinate.			      */
		ywin;		/* Y window coordinate.			      */

Boolean		argok;		/* Status indicator.			      */

/*SUPPRESS 594*/XExposeEvent *acs=(XExposeEvent*)call;

/*
    Create the graphics context.
*/
graphics_gc = XCreateGC(xid.display, XtWindow(Shell_MainMenu), NULL, NULL);

/*
    Don't try to redraw graphics if there is no image displayed.
*/
if (xid.view == -1)
    return;

/*
    Draw an outline of the full resolution window in the main image window.
*/
if ((w == main_image_bulletinboard) && (xid_fullres != NULL))
    {
    if ((xid_fullres[0].window[SS] > 0) && (xid_fullres[0].flags & 
	FULLRES_SHOW))
	{
/*
    Find the memory plane index of the first band of the displayed image.
*/
	plane_idx = xid_view.rgbplanes[RED] - 1;

	XSetForeground(xid.display,xid_fullres[0].gc,xid.color_table[RGBBW_IDX
	    + xid.cursor_color].pixel);
	XSetFunction(xid.display,xid_fullres[0].gc,GXcopy);
	xid_file2win(plane_idx,0,(float)xid_fullres[0].window[SS],
	    (float)xid_fullres[0].window[SL],&xwin,&ywin);
	width = xid_fullres[0].width / (float)xid_planes[plane_idx].skips;
	height = xid_fullres[0].height / (float)xid_planes[plane_idx].skipl;
	XDrawRectangle(xid.display,XtWindow(main_image_bulletinboard),
	    xid_fullres[0].gc,xwin,ywin,width,height);
	XSetForeground(xid.display,xid_fullres[0].gc,xid_fullres[0].rb_fore);
	XSetFunction(xid.display,xid_fullres[0].gc,GXxor);
	}
    }

/*
    Copy graphics information from the pixmap to the main image window.
*/
if ((w == main_image_bulletinboard) && (xid_graphics.pixmap[0] != NULL))
    {
    for (i=0; i < USER_GRCOLORS; i++)
	{
        XSetForeground(xid.display,graphics_gc,(unsigned long)CONVERT(
	    Shell_Graphics, xid_graphics.colors[i],"Pixel", 0, &argok));
        XSetClipMask(xid.display,graphics_gc,xid_graphics.pixmap[i]);
        XCopyPlane(xid.display,xid_graphics.pixmap[i],
	    XtWindow(main_image_bulletinboard),graphics_gc,acs->x,acs->y,
	    acs->width,acs->height,acs->x,acs->y,1);
	}
/*
    Draw the graphics "edit handles".
*/
    if (xid_graphics.flags & GR_EDIT)
	if (xid_editgraph.current != -1)
	    graphics_handles(xid_editgraph.current,-1,NULL,0);
    }

/*
    Copy graphics information from the pixmap to the full resolution window.
*/
else if ((w == fullres_win_bulletinboard) && (xid_graphics.full_pix[0] != NULL))
    {
    for (i=0; i < USER_GRCOLORS; i++)
	{
        XSetForeground(xid.display, graphics_gc, (unsigned long)CONVERT(
	    Shell_Graphics, xid_graphics.colors[i],"Pixel", 0, &argok));
        XSetClipMask(xid.display,graphics_gc,xid_graphics.full_pix[i]);
        XCopyPlane(xid.display,xid_graphics.full_pix[i],
	    XtWindow(fullres_win_bulletinboard),graphics_gc,acs->x,acs->y,
	    acs->width,acs->height,acs->x,acs->y,1);
	}
/*
    Draw the graphics "edit handles".
*/
    if (xid_graphics.flags & GR_EDIT)
	if (xid_editgraph.current != -1)
	    graphics_handles(xid_editgraph.current,-1,NULL,0);
    }

/*
    Copy graphics information from the pixmap to the zoom window.
*/
else if ((w == zoom_win_bulletinboard) && (xid_graphics.zoom_pix[0] != NULL))
    {
    for (i=0; i < USER_GRCOLORS; i++)
	{
        XSetForeground(xid.display, graphics_gc, (unsigned long)CONVERT(
	    Shell_Graphics, xid_graphics.colors[i],"Pixel", 0, &argok));
        XSetClipMask(xid.display,graphics_gc,xid_graphics.zoom_pix[i]);
        XCopyPlane(xid.display,xid_graphics.zoom_pix[i],
	    XtWindow(zoom_win_bulletinboard),graphics_gc,acs->x,acs->y,
	    acs->width,acs->height,acs->x,acs->y,1);
	}
/*
    Draw the graphics "edit handles".
*/
    if (xid_graphics.flags & GR_EDIT)
	if (xid_editgraph.current != -1)
	    graphics_handles(xid_editgraph.current,-1,NULL,0);
    }
/*
    Free the graphics context.
*/
XFreeGC(xid.display, graphics_gc);
}

/* ARGSUSED */
void
graphics_gofname(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine retrieves the GOF name specified by the user and opens
    the GOF with the appropriate access based on whether the user is in
    "select" or "load" mode. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long    access,        		/* File open access mode.                     */
	cflag,                  /* Indicates whether or not a GOF was created.*/
        lasflg = FALSE,         /* Indicates whether the file name specified is
				   a LAS name or a host file name.            */
	length,			/* String length.			      */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.		      */
	status;			/* Status indicator.			      */

char	ext[11],                /* File extension for dfgtaso   */
	*gof_name,             	/* User specified GOF name.                   */
	goftyp[6],              /* Type of GOF.                               */
	hname[CMLEN],           /* Host file name of displayed image (first
				   band).                                     */
	hostnam[CMLEN];         /* Host name of the GOF         */


/*
    Get the GOF name specified by the user.
*/
gof_name = XmTextGetString(graphics_gof_text);
if (*gof_name == '\0')
    {
    xid_message("A null GOF name is not valid");
    return;
    }

/*
    Find the memory plane index of the first band of the displayed image.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;

/*
    Determine whether the input name is a LAS name or a host name.
    - If the name contains a slash (/) it is assumed to be a host file
      name, all other names are assumed to be LAS names.
*/
if (strcspn(gof_name,"/") != strlen(gof_name))
    lasflg = FALSE;
else
    lasflg = TRUE;

/*
    Get the host file name of the specified LAS name.
*/
if (lasflg)
    {
    status = c_cmhost(gof_name,hname);
    if (status != E_SUCC)
	{
	xid_message("Error retrieving host file name");
	return;
	}
    }
else
    strcpy(hname,gof_name);

/*
    Determine the type of GOF to be opened.
*/
switch (xid_graphics.type)
    {
    case POINT:
	 strcpy(goftyp,"POINT");
	 break;
    case LINE:
	 strcpy(goftyp,"LINE");
	 break;
    case POLY:
	 strcpy(goftyp,"POLY");
	 break;
    case RECT:
	 strcpy(goftyp,"POLY");
	 break;
    case TEXT:
	 strcpy(goftyp,"ANNOT");
	 break;
    }

/*
    Open the GOF only if the user has selected "select", "load" or "edit"
    mode.
*/
if ((xid_graphics.flags & GR_SELECT) || (xid_graphics.flags & GR_LOAD) ||
    (xid_graphics.flags & GR_EDIT))
    {
/*
    Close any currently opened GOF.
*/
    if ((xid_graphics.type != NO_TYPE) && (xid_graphics.fd != -1))
	c_gofcls(&xid_graphics.fd);
/*
    Assign the appropriate access mode.
*/
    if ((xid_graphics.flags & GR_SELECT) || (xid_graphics.flags & GR_EDIT))
	access = APPEND;
    else
	access = READ;

/*
    Open the GOF.
*/
    status = c_gofopn(&xid_graphics.fd,hname,xid_graphics.lname_gof,goftyp,
	&access,&cflag);
    if (status != E_SUCC)
	{
	xid_message("Error opening GOF");
	xid_graphics.fd = -1;
	}
    if (xid_planes[plane_idx].image_type != LAS)
	strcpy(xid_graphics.lname_gof,hname);
    }
else
    {
/*
   Set up the GOF extension based on the type specified.
*/
    sprintf(ext,"GOF%c%s",GOF_SEP,goftyp);
    length = strlen(ext);
    c_up2low(ext,&length);

/*
   Get the associated file name.
*/
    c_lsmknm(hname,ext,hostnam);
    if (xid_planes[plane_idx].image_type == LAS)
        c_cmtae(hostnam,xid_graphics.lname_gof);
    else
	strcpy(xid_graphics.lname_gof,hostnam);
    }

/*
    Set the text field to the GOF name generated (based on the user specified
    name as well as the GOF type).
*/
XmTextSetString(graphics_gof_text,xid_graphics.lname_gof);
}

/* ARGSUSED */
void
graphics_labelcalc(string)
char	*string;		/* Character string for which calculations are
				   to be done.				      */

/*******************************************************************************
Purpose:
    This routine calculates the width and height of a text string based on
    the input string and the current font specification.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
/*
    Calculate the label width.
*/
xid_label.width = XTextWidth(xid_graphics.font_info[xid_graphics.font],string,
    strlen(string));

/*
    Calculate the label height.
*/
xid_label.height = xid_graphics.font_info[xid_graphics.font]->max_bounds.ascent
    + xid_graphics.font_info[xid_graphics.font]->max_bounds.descent;

/*
    Set a flag indicating a label is being placed.
*/
xid_graphics.flags |= GR_LABEL;
}

long
graphics_redraw(oldcolor,oldfont,oldwidth,oldstring)
long	oldcolor,		/* Color index of previous color.	      */
	oldfont,		/* Font index of previous font.	      	      */
	oldwidth;		/* Previous width.	      		      */

char	*oldstring;		/* Previous label or annotation string.	      */

/*******************************************************************************
Purpose:
    This routine is used to erase and redraw graphics elements in a new color,
    font or line width or to erase an old text string and redraw a new one.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
void    graphics_expose_area(); /* Function to trigger an expose event of the
                                   area around a given graphics element.      */

struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

float	loright[2],		/* Lower right corner of bounding rectangle.  */
	x1,			/* First X coordinate of line segment.	      */
	x2,			/* Second X coordinate of line segment.	      */
	y1,			/* First Y coordinate of line segment.	      */
	y2;			/* Second Y coordinate of line segment.	      */

long    current_idx,		/* Current graphics element index.   	      */
	erase = FALSE,		/* Indicates whether or not there is text
				   (annotation or label) to erase.	      */
	height,			/* Rectangle height.			      */
	i,			/* Looping index.			      */
	num_vert,		/* Number of vertices.			      */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.		      */
	reset,			/* Indicates whether or not the label
				   placement flag needs to be reset.	      */
	savefont,		/* Saved font index.			      */
	width,			/* Rectangle width.			      */
	xwin,           	/* Window X coordinate.                       */
	x1win,          	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
	y1win;          	/* Window Y coordinate.                       */

char	*string;		/* Label or annotation string.		      */

/*
    Find the memory plane index of the first band of the displayed image.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;

/*
    Determine the graphics element index.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else
    current_idx = xid_editgraph.current;

/*
    Erase an old point and redraw it.
*/
if (xid_graphics.type == POINT)
    {
/*
    Convert the file coordinate to a main image window coordinate.
*/
    xid_file2win(plane_idx,0,xid_element[current_idx].x,xid_element[
	current_idx].y,&xwin,&ywin);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the point.
*/
    XDrawPoint(xid.display,xid_graphics.pixmap[oldcolor],xid_graphics.rb_gc,
	xwin,ywin); 

    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);

/*
    Draw the point.
*/
    XDrawPoint(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin); 

/*
    Erase the point from the full resolution image window.
*/
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	xid_file2win(plane_idx,1,xid_element[current_idx].x,xid_element[
	    current_idx].y,&xwin,&ywin);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the point.
*/
	XDrawPoint(xid.display,xid_graphics.full_pix[oldcolor],
	    xid_graphics.rb_gc,xwin,ywin); 

/*
    Draw the point.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);

	XDrawPoint(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin); 
	}
/*
    Erase the point from the zoomed window.
*/
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
/*
    Convert the file coordinates to zoom window coordinates.
*/
	xid_file2win(plane_idx,2,xid_element[current_idx].x,xid_element[
	    current_idx].y,&xwin,&ywin);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the point.
*/
	XDrawPoint(xid.display,xid_graphics.zoom_pix[oldcolor],
	    xid_graphics.rb_gc,xwin,ywin); 

/*
    Draw the point.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin); 
	}
    }

/*
    Erase an old rectangle and redraw it.
*/
if (xid_graphics.type == RECT)
    {
/*
    Erase the rectangle from the bitmap.
*/
    pptr = (struct POLY_ELEMENT *)xid_element[current_idx].graph_ptr;
/*
    Convert the file coordinates to the main image window coordinates.
*/
    x1 = pptr->x[0];
    y1 = pptr->y[0];
    x2 = pptr->x[2];
    y2 = pptr->y[2];

    xid_file2win(plane_idx,0,x1,y1,&xwin,&ywin);
    xid_file2win(plane_idx,0,x2,y2,&x1win,&y1win);

    width = x1win - xwin;
    height = y1win - ywin;

    XSetLineAttributes(xid.display,xid_graphics.rb_gc,oldwidth,LineSolid,
	CapButt,JoinMiter);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the rectangle.
*/
    XDrawRectangle(xid.display,xid_graphics.pixmap[oldcolor],
	xid_graphics.rb_gc,xwin,ywin,width,height);

/*
    Draw the rectangle.
*/
    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);
    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
    XDrawRectangle(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin,width,height); 

    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	xid_file2win(plane_idx,1,x1,y1,&xwin,&ywin);
	xid_file2win(plane_idx,1,x2,y2,&x1win,&y1win);

	width = x1win - xwin;
	height = y1win - ywin;

	XSetLineAttributes(xid.display,xid_graphics.rb_gc,oldwidth,
	    LineSolid,CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the rectangle.
*/
	XDrawRectangle(xid.display,xid_graphics.full_pix[oldcolor],
	    xid_graphics.rb_gc,xwin,ywin,width,height); 
/*
    Draw the rectangle.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XDrawRectangle(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,width,height); 
	}

    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
/*
    Convert the file coordinates to zoom window coordinates.
*/
	xid_file2win(plane_idx,2,x1,y1,&xwin,&ywin);
	xid_file2win(plane_idx,2,x2,y2,&x1win,&y1win);

	width = x1win - xwin;
	height = y1win - ywin;

	XSetLineAttributes(xid.display,xid_graphics.rb_gc,oldwidth,
	    LineSolid,CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the rectangle.
*/
	XDrawRectangle(xid.display,xid_graphics.zoom_pix[oldcolor],
	    xid_graphics.rb_gc,xwin,ywin,width,height); 

/*
    Draw the rectangle.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XDrawRectangle(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,width,height); 
	}
    }

/*
    Erase an old polygon or line and redraw it.
*/
if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
   {
/*
    Erase the line segments from the bitmap.
*/
    if (xid_graphics.type == POLY) 
	{
	pptr = (struct POLY_ELEMENT *)xid_element[current_idx].graph_ptr;
	num_vert = pptr->num_vert;
	}
    else if (xid_graphics.type == LINE)
	{
	lptr = (struct LINE_ELEMENT *)xid_element[current_idx].graph_ptr;
	num_vert = lptr->num_vert - 1;
	}

    for (i=0; i < num_vert; i++)
	{
/*
    Convert the file coordinates to main image window coordinates.
*/
	if ((xid_graphics.type == POLY) && (i == num_vert - 1))
	    {
	    x1 = pptr->x[0];
	    y1 = pptr->y[0];
	    x2 = pptr->x[i];
	    y2 = pptr->y[i];
	    }
	else if (xid_graphics.type == POLY)
	    {
	    x1 = pptr->x[i];
	    y1 = pptr->y[i];
	    x2 = pptr->x[i+1];
	    y2 = pptr->y[i+1];
	    }
	else if (xid_graphics.type == LINE)
	    {
	    x1 = lptr->x[i];
	    y1 = lptr->y[i];
	    x2 = lptr->x[i+1];
	    y2 = lptr->y[i+1];
	    }

	xid_file2win(plane_idx,0,x1,y1,&xwin,&ywin);
	xid_file2win(plane_idx,0,x2,y2,&x1win,&y1win);
	XSetLineAttributes(xid.display,xid_graphics.rb_gc,oldwidth,LineSolid,
	    CapButt,JoinMiter);
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.pixmap[oldcolor],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 

/*
    Draw the line segment.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
        XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	    line_width,LineSolid,CapButt,JoinMiter);
	XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 

	if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	    xid_file2win(plane_idx,1,x1,y1,&xwin,&ywin);
	    xid_file2win(plane_idx,1,x2,y2,&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,oldwidth,
		LineSolid,CapButt,JoinMiter);
	    XSetBackground(xid.display,xid_graphics.rb_gc,0);
	    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.full_pix[oldcolor],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
/*
    Draw the line segment.
*/
	    XSetBackground(xid.display,xid_graphics.rb_gc,1);
	    XSetForeground(xid.display,xid_graphics.rb_gc,1);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
		line_width,LineSolid,CapButt,JoinMiter);
	    XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.color],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    }

	if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	    {
/*
    Convert the file coordinates to zoom window coordinates.
*/
	    xid_file2win(plane_idx,2,x1,y1,&xwin,&ywin);
	    xid_file2win(plane_idx,2,x2,y2,&x1win,&y1win);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,oldwidth,
		LineSolid,CapButt,JoinMiter);
	    XSetBackground(xid.display,xid_graphics.rb_gc,0);
	    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the line segment.
*/
	    XDrawLine(xid.display,xid_graphics.zoom_pix[oldcolor],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 

/*
    Draw the line segment.
*/
	    XSetBackground(xid.display,xid_graphics.rb_gc,1);
	    XSetForeground(xid.display,xid_graphics.rb_gc,1);
	    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
		line_width,LineSolid,CapButt,JoinMiter);
	    XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
		xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	    }
	}
    }

/*
    Determine whether or not a character string needs to be redrawn (either
    an annotation text string or a label).
*/
if ((xid_element[current_idx].labelx != -1) && (xid_graphics.type == TEXT))
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    string = malloc(strlen(aptr->string) + 1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,aptr->string);
    erase = TRUE;
    }
else if (xid_element[current_idx].labelx != -1)
    {
    string = malloc(strlen(xid_element[current_idx].label)+1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,xid_element[current_idx].label);
    erase = TRUE;
    }
else if (((xid_graphics.type != TEXT) && (xid_graphics.flags & GR_EDIT) &&
    (xid_element[current_idx].labelx == -1)) || ((xid_graphics.flags &
    GR_SELECT) && (xid_element[current_idx].labelx == -1)))
    {
    if (xid_graphics.type == POLY)
	{
	xid_element[current_idx].labelx = pptr->x[0] + 5;
	xid_element[current_idx].labely = pptr->y[0] + 5;
	}
    else if (xid_graphics.type == LINE)
	{
	xid_element[current_idx].labelx = lptr->x[0] + 5;
	xid_element[current_idx].labely = lptr->y[0] + 5;
	}
    else
	{
	xid_element[current_idx].labelx = xid_element[current_idx].x + 5; 
	xid_element[current_idx].labely = xid_element[current_idx].y + 5;
	}
    string = malloc(strlen(xid_element[current_idx].label)+1);
    if (string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return(XID_F);
	}
    strcpy(string,xid_element[current_idx].label);
    erase = TRUE;
    }

if (erase)
    {
/*
    Erase the old character string.
*/
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);
    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[oldfont]->
	fid);

/*
    Calculate width and height of old character string.
*/
    savefont = xid_graphics.font;
    xid_graphics.font = oldfont;
    if (xid_graphics.flags & GR_LABEL)
	reset = FALSE;
    else
	reset = TRUE;
    graphics_labelcalc(oldstring);
    if (reset)
        xid_graphics.flags &= ~GR_LABEL;

/*
    Reset bouding rectangle.
*/
    loright[0] = xid_element[current_idx].loright[0];
    loright[1] = xid_element[current_idx].loright[1];
    if (xid_element[current_idx].type == TEXT)
	{
	xid_element[current_idx].loright[0] = xid_element[current_idx].x + 
	    (xid_label.width * xid_planes[plane_idx].skips);
	xid_element[current_idx].loright[1] = xid_element[current_idx].y + 
	    (xid_label.height * xid_planes[plane_idx].skipl);
	}
    else
	{
	xid_element[current_idx].loright[0] = xid_element[current_idx].labelx + 
	    (xid_label.width * xid_planes[plane_idx].skips);
	xid_element[current_idx].loright[1] = xid_element[current_idx].labely + 
	    (xid_label.height * xid_planes[plane_idx].skipl);
	}
/*
    Convert the file coordinate to main image window coordinates.
*/
    xid_file2win(plane_idx,0,xid_element[current_idx].labelx,
	xid_element[current_idx].labely,&x1win,&y1win);
    XDrawString(xid.display,xid_graphics.pixmap[oldcolor],
	xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[oldfont]->
	max_bounds.ascent,oldstring,strlen(oldstring));

/*
    Force an expose event over affected area.
*/
    graphics_expose_area(0,current_idx,plane_idx);
    xid_element[current_idx].loright[0] = loright[0];
    xid_element[current_idx].loright[1] = loright[1];

/*
    Draw the string.
*/
    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);
    xid_graphics.font = savefont;
    XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	xid_graphics.font]->fid);

/*
    Calculate width and height of new character string.
*/
    if (xid_graphics.flags & GR_LABEL)
	reset = FALSE;
    else
	reset = TRUE;
    graphics_labelcalc(string);
    if (reset)
        xid_graphics.flags &= ~GR_LABEL;

/*
    Draw the string.
*/
    XDrawString(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,strlen(string));

    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	{
/* 
    Erase the character string from the full resolution window.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
	XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[oldfont]
	    ->fid);
/*
    Calculate the width and height of the old character string.
*/
	savefont = xid_graphics.font;
	xid_graphics.font = oldfont;
	if (xid_graphics.flags & GR_LABEL)
	    reset = FALSE;
	else
	    reset = TRUE;
	graphics_labelcalc(oldstring);
	if (reset)
	    xid_graphics.flags &= ~GR_LABEL;
/*
    Reset the bounding rectangle.
*/
	loright[0] = xid_element[current_idx].loright[0];
	loright[1] = xid_element[current_idx].loright[1];
	if (xid_element[current_idx].type == TEXT)
	    {
	    xid_element[current_idx].loright[0] = xid_element[current_idx].x + 
		(xid_label.width * xid_planes[plane_idx].skips);
	    xid_element[current_idx].loright[1] = xid_element[current_idx].y + 
		(xid_label.height * xid_planes[plane_idx].skipl);
	    }
	else
	    {
	    xid_element[current_idx].loright[0] = xid_element[current_idx].
		labelx + (xid_label.width * xid_planes[plane_idx].skips);
	    xid_element[current_idx].loright[1] = xid_element[current_idx].
		labely + (xid_label.height * xid_planes[plane_idx].skipl);
	    }
/*
    Convert the file coordinates to full resolution window coordinates.
*/
	xid_file2win(plane_idx,1,xid_element[current_idx].labelx,
	    xid_element[current_idx].labely,&x1win,&y1win);
	XDrawString(xid.display,xid_graphics.full_pix[oldcolor],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    oldfont]->max_bounds.ascent,oldstring,strlen(oldstring));
/*
    Force an expose event over the affected area.
*/
	graphics_expose_area(1,current_idx,plane_idx);
	xid_element[current_idx].loright[0] = loright[0];
	xid_element[current_idx].loright[1] = loright[1];
/*
    Draw the character string.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	xid_graphics.font = savefont;
	XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	    xid_graphics.font]->fid);

/*
    Calculate the width and height of the new character string.
*/
	if (xid_graphics.flags & GR_LABEL)
	    reset = FALSE;
	else
	    reset = TRUE;
	graphics_labelcalc(string);
	if (reset)
	    xid_graphics.flags &= ~GR_LABEL;
/*
    Draw the string.
*/
	XDrawString(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    xid_graphics.font]->max_bounds.ascent,string,strlen(string));

	}

    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	{
/*
    Erase the character string from the zoom window.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,0);
	XSetForeground(xid.display,xid_graphics.rb_gc,0);
	XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[oldfont]
	    ->fid);
/*
    Calculate the width and height of the old character string.
*/
	savefont = xid_graphics.font;
	xid_graphics.font = oldfont;
	if (xid_graphics.flags & GR_LABEL)
	    reset = FALSE;
	else
	    reset = TRUE;
	graphics_labelcalc(oldstring);
	if (reset)
	    xid_graphics.flags &= ~GR_LABEL;
/*
    Reset the bounding rectangle.
*/
	loright[0] = xid_element[current_idx].loright[0];
	loright[1] = xid_element[current_idx].loright[1];
	if (xid_element[current_idx].type == TEXT)
	    {
	    xid_element[current_idx].loright[0] = xid_element[current_idx].x + 
		(xid_label.width * xid_planes[plane_idx].skips);
	    xid_element[current_idx].loright[1] = xid_element[current_idx].y + 
		(xid_label.height * xid_planes[plane_idx].skipl);
	    }
	else
	    {
	    xid_element[current_idx].loright[0] = xid_element[current_idx].
		labelx + (xid_label.width * xid_planes[plane_idx].skips);
	    xid_element[current_idx].loright[1] = xid_element[current_idx].
		labely + (xid_label.height * xid_planes[plane_idx].skipl);
	    }
/*
    Convert the file coordinates to zoom window coordinates.
*/
	xid_file2win(plane_idx,2,xid_element[current_idx].labelx,
	    xid_element[current_idx].labely,&x1win,&y1win);
	XDrawString(xid.display,xid_graphics.zoom_pix[oldcolor],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    oldfont]->max_bounds.ascent,oldstring,strlen(oldstring));
/*
    Force an expose event over the affected area.
*/
	graphics_expose_area(2,current_idx,plane_idx);
	xid_element[current_idx].loright[0] = loright[0];
	xid_element[current_idx].loright[1] = loright[1];
/*
    Draw the character string.
*/
	XSetBackground(xid.display,xid_graphics.rb_gc,1);
	XSetForeground(xid.display,xid_graphics.rb_gc,1);
	xid_graphics.font = savefont;
	XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[
	    xid_graphics.font]->fid);

/*
    Calculate the width and height of the new character string.
*/
	if (xid_graphics.flags & GR_LABEL)
	    reset = FALSE;
	else
	    reset = TRUE;
	graphics_labelcalc(string);
	if (reset)
	    xid_graphics.flags &= ~GR_LABEL;
/*
    Draw the string.
*/
	XDrawString(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,x1win,y1win + xid_graphics.font_info[
	    xid_graphics.font]->max_bounds.ascent,string,strlen(string));

	}

    free(string);

    }

/*
    Force an expose event over the area of the graphics element in all
    windows.  The expose event causes the graphics bitmaps to be copied
    to the window.
*/
graphics_expose_area(-1,current_idx,plane_idx);

return(XID_S);
}

/* ARGSUSED */
long
graphics_gofread()

/*******************************************************************************
Purpose:
    This routine reads an existing GOF and assigns elements to an internal
    XID graphics element structure.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
union   GOF     gofbuf;         /* GOF structure.                             */

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

struct  ANNOT_ELEMENT   *aptr;  /* Pointer to polygon specific information.   */

long	color_idx,		/* Index for color attribute.		      */
	font_idx,		/* Index for font attribute.		      */
	found,			/* Indicates whether or not the attribute
				   was found.				      */
	graphics_duplicate(),	/* Routine to detect duplicate GOF records.   */
	gtype,			/* GOF type (for c_gofrd).		      */
	labx_idx,		/* Index for X label location attribute.      */
	laby_idx,		/* Index for Y label location attribute.      */
	lw_idx,			/* Index for line width attribute.	      */
	i,			/* Looping index.			      */
	nbytes,			/* Number of bytes read.		      */
	next,			/* Number of bytes to next GOF record.	      */
	offset = HDRLEN,	/* Offset to record from the beginning of the
				   file.				      */
	status,			/* Status indicator.			      */
	xynbytes,		/* Number of bytes read.		      */
	xynext;			/* Number of bytes of next GOF record.	      */

/*
    Increment the current graphics element index if necessary.
*/
if ((xid_element[xid_graphics.current].type != NO_TYPE) &&
    (!(xid_graphics.flags & GR_CANCEL)))
    {
    xid_graphics.current++;
    if (xid_graphics.current >= xid_graphics.max_element)
	{
	status = graphics_realloc();
	if (status != XID_S)
	    return(XID_F);
	}
    }

/*
    Reset the file pointer to the beginning of the file.
*/
lseek (xid_graphics.fd,0,0);

/*
    Read the header record from the GOF.
*/
gtype = HDR;
status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,&gofbuf);
if (status != E_SUCC)
    {
    xid_message("Error reading GOF");
    return(XID_F);
    }

/*
    Find the attribute name created by XID for color.
*/
for (i=0, found=FALSE; i < MAXATT; i++)
    {
    if (gofbuf.hdrec.mask[i] != 0) 
	{
	if (strcmp(gofbuf.hdrec.attrb[i],xid_atnames[XID_COL]) == 0)
	    {
	    found = TRUE;
	    break;
	    }
	}
    }

if (found)
    color_idx = i;
else
    {
    xid_message("Unable to find color attribute -- using default color");
    color_idx = -1;
    }

/*
    Find the attribute name created by XID for font.
*/
for (i=0, found=FALSE; i < MAXATT; i++)
    {
    if (gofbuf.hdrec.mask[i] != 0) 
	{
	if (strcmp(gofbuf.hdrec.attrb[i],xid_atnames[XID_FONT]) == 0)
	    {
	    found = TRUE;
	    break;
	    }
	}
    }

if (found)
    font_idx = i;
else
    {
    xid_message("Unable to find font attribute -- using default font");
    font_idx = -1;
    }

if (xid_graphics.type != TEXT)
    {
/*
    Find attribute name created by XID for label location.
*/
    for (i=0, found=FALSE; i < MAXATT; i++)
	{
	if (gofbuf.hdrec.mask[i] != 0) 
	    {
	    if (strcmp(gofbuf.hdrec.attrb[i],xid_atnames[XID_LABX]) == 0)
		{
		found = TRUE;
		break;
		}
	    }
	}

    if (found)
	labx_idx = i;
    else
	{
	xid_message(
	    "Unable to find X label location attribute -- using default");
	labx_idx = -1;
	}

    for (i=0, found=FALSE; i < MAXATT; i++)
	{
	if (gofbuf.hdrec.mask[i] != 0) 
	    {
	    if (strcmp(gofbuf.hdrec.attrb[i],xid_atnames[XID_LABY]) == 0)
		{
		found = TRUE;
		break;
		}
	    }
	}

    if (found)
	laby_idx = i;
    else
	{
	xid_message(
	    "Unable to find Y label location attribute -- using default");
	laby_idx = -1;
	}
    }

if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE) || 
    (xid_graphics.type == RECT))
    {
/*
    Find attribute name created by XID for line width.
*/
    for (i=0, found=FALSE; i < MAXATT; i++)
	{
	if (gofbuf.hdrec.mask[i] != 0) 
	    {
	    if (strcmp(gofbuf.hdrec.attrb[i],xid_atnames[XID_LW]) == 0)
		{
		found = TRUE;
		break;
		}
	    }
	}

    if (found)
	lw_idx = i;
    else
	{
	xid_message(
	    "Unable to find line width location attribute -- using default line width");
	lw_idx = -1;
	}
    }

/*
    Determine GOF type.
*/
if (xid_graphics.type == POINT)
    gtype = PNT;
else if ((xid_graphics.type == LINE) || (xid_graphics.type == POLY) || 
    (xid_graphics.type == RECT))
    gtype = HPOLIN;
else if (xid_graphics.type == TEXT)
    gtype = ANOT;

/*
    Read a GOF record.
*/
status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,&gofbuf);
if ((status != E_SUCC) && (status != E_EOF))
    {
    xid_message("Error reading GOF");
    return(XID_F);
    }

/*
    Continue reading until end of file is reached.
*/
while (status !=  E_EOF)
    {
/*
    Assign point information to the structure.
*/
    if (xid_graphics.type == POINT)
	{
/*
    Determine whether or not current record is a deleted record or if it
    has already been loaded.
*/
	if ((strcmp(gofbuf.ptrec.label,DELREC) == 0) || (graphics_duplicate(
	    offset,xid_graphics.type)))
	    {
/*
    Read next record.
*/
	    offset += (nbytes + next);
	    status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,&gofbuf);
	    if ((status != E_SUCC) && (status != E_EOF))
		{
		xid_message("Error reading GOF");
		return(XID_F);
		}
	    continue;
	    }
/*
    Assign the type, X and Y location, and label.
*/
	xid_element[xid_graphics.current].type = POINT; 
	xid_element[xid_graphics.current].offset = offset;
	xid_element[xid_graphics.current].x = gofbuf.ptrec.x;
	xid_element[xid_graphics.current].y = gofbuf.ptrec.y;
	strcpy(xid_element[xid_graphics.current].label,gofbuf.ptrec.label);
/*
    Assign attribute values.
*/
	for (i=0; i < MAXATT; i++)
	    strcpy(xid_element[xid_graphics.current].attributes[i],
		gofbuf.ptrec.attrb[i]);
/*
    Assign color.
*/
	if (color_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[color_idx],"%d",
	        &xid_element[xid_graphics.current].color);
	else
	    xid_element[xid_graphics.current].color = 0;
/*
    Assign font.
*/
	if (font_idx != -1)
	    {
	    sscanf(xid_element[xid_graphics.current].attributes[font_idx],"%d",
	        &xid_element[xid_graphics.current].font);
	    if (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
		== NULL)
		{
		xid_graphics.font_info[xid_element[xid_graphics.current].font]
		    = XLoadQueryFont(xid.display,xid_graphics.fonts[
		    xid_element[xid_graphics.current].font]);
		if (xid_graphics.font_info[xid_element[xid_graphics.current].
		    font] == NULL)
		    xid_message("Specified font not available -- Using next available font");
		}
	    }
	else
	    xid_element[xid_graphics.current].font = 0;

/*
    Make sure specified font or default font is available.
*/
	if (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
	    == NULL)
	    xid_graphics.font_info[xid_element[xid_graphics.current].font]
		= XLoadQueryFont(xid.display,xid_graphics.fonts[
		xid_element[xid_graphics.current].font]);
  	while (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
	    == NULL)
	    {
	    xid_element[xid_graphics.current].font++;
	    if (xid_element[xid_graphics.current].font > USER_GRFONTS)
		xid_element[xid_graphics.current].font = 0;
	    xid_graphics.font_info[xid_element[xid_graphics.current].font]
		= XLoadQueryFont(xid.display,xid_graphics.fonts[
		xid_element[xid_graphics.current].font]);
	    }
/*
    Assign label location.
*/
	if (labx_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[labx_idx],"%f",
	        &xid_element[xid_graphics.current].labelx);
	else if (strcmp(xid_element[xid_graphics.current].label,"") == 0)
	    xid_element[xid_graphics.current].labelx = -1;
	else
	    xid_element[xid_graphics.current].labelx = 
		xid_element[xid_graphics.current].x + 5; 
	if (laby_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[laby_idx],"%f",
	        &xid_element[xid_graphics.current].labely);
	else if (strcmp(xid_element[xid_graphics.current].label,"") == 0)
	    xid_element[xid_graphics.current].labely = -1;
	else
	    xid_element[xid_graphics.current].labely = 
		xid_element[xid_graphics.current].y + 5;
/*
    Calculate bounding rectangle.
*/
	graphics_setbounds(xid_graphics.current);
	}
/*
    Assign line or polygon information to the structure.
*/
    else if ((xid_graphics.type == LINE) || (xid_graphics.type == POLY) ||
	(xid_graphics.type == RECT))
	{
/*
    Determine whether or not current record is a deleted record or if it
    has already been loaded.
*/
	if ((strcmp(gofbuf.plrec.label,DELREC) == 0) || (graphics_duplicate(
	    offset,xid_graphics.type)))
	    {
/*
    Read next record.
*/
	    offset += (nbytes + next);
            lseek (xid_graphics.fd,next,1);
	    status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,&gofbuf);
	    if ((status != E_SUCC) && (status != E_EOF))
		{
		xid_message("Error reading GOF");
		return(XID_F);
		}
	    continue;
	    }
/*
    Assign type, label and attribute values.
*/
	if (xid_graphics.type == RECT)
	    xid_element[xid_graphics.current].type = POLY; 
	else
	    xid_element[xid_graphics.current].type = xid_graphics.type; 
	xid_element[xid_graphics.current].offset = offset; 
	strcpy(xid_element[xid_graphics.current].label,gofbuf.plrec.label);
	for (i=0; i < MAXATT; i++)
	    strcpy(xid_element[xid_graphics.current].attributes[i],
		gofbuf.plrec.attrb[i]);
/*
    Assign color.
*/
	if (color_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[color_idx],"%d",
	        &xid_element[xid_graphics.current].color);
	else
	    xid_element[xid_graphics.current].color = 0;
/*
    Assign font.
*/ 
	if (font_idx != -1) 
	    { 
	    sscanf(xid_element[xid_graphics.current].attributes[font_idx],"%d",
	        &xid_element[xid_graphics.current].font);
	    if (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
		== NULL)
		{
		xid_graphics.font_info[xid_element[xid_graphics.current].font]
		    = XLoadQueryFont(xid.display,xid_graphics.fonts[
		    xid_element[xid_graphics.current].font]);
		if (xid_graphics.font_info[xid_element[xid_graphics.current].
		    font] == NULL)
		    xid_message("Specified font not available -- Using next available font");
		}
	    }
	else
	    xid_element[xid_graphics.current].font = 0;
/*
    Make sure specified font or default font is available.
*/
	if (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
	    == NULL)
	    xid_graphics.font_info[xid_element[xid_graphics.current].font]
		= XLoadQueryFont(xid.display,xid_graphics.fonts[
		xid_element[xid_graphics.current].font]);
  	while (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
	    == NULL)
	    {
	    xid_element[xid_graphics.current].font++;
	    if (xid_element[xid_graphics.current].font > USER_GRFONTS)
		xid_element[xid_graphics.current].font = 0;
	    xid_graphics.font_info[xid_element[xid_graphics.current].font]
		= XLoadQueryFont(xid.display,xid_graphics.fonts[
		xid_element[xid_graphics.current].font]);
	    }
	if (labx_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[labx_idx],"%f",
	        &xid_element[xid_graphics.current].labelx);
	else
	    xid_element[xid_graphics.current].labelx =  -1;
/*
    Assign label location.
*/
	if (laby_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[laby_idx],"%f",
	        &xid_element[xid_graphics.current].labely);
	else
	    xid_element[xid_graphics.current].labely = -1; 

	xid_element[xid_graphics.current].graph_ptr = 
	    (long *)calloc(1,sizeof(struct POLY_ELEMENT));
	if (xid_element[xid_graphics.current].graph_ptr == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return(XID_F);
	    }
/*
    Assign line width. 
*/
	if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
	    {
	    pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.current].
		graph_ptr;
	    if (lw_idx != -1)
		sscanf(xid_element[xid_graphics.current].attributes[lw_idx],"%d",
		    &pptr->line_width);
	    else
		pptr->line_width = 1;
	    }
	else
	    {
	    lptr = (struct LINE_ELEMENT *)xid_element[xid_graphics.current].
		graph_ptr;
	    if (lw_idx != -1)
		sscanf(xid_element[xid_graphics.current].attributes[lw_idx],
		    "%d",&lptr->line_width);
	    else
		lptr->line_width = 1;
	    }
/*
    Read the X/Y vertice pairs.
*/
	gtype = XYPAIRS; 
	status = c_gofrd(&xid_graphics.fd,&xynbytes,&xynext,&gtype,&gofbuf);
	if ((status != E_SUCC) && (status != E_EOF))
	    {
	    xid_message("Error reading GOF");
	    return(XID_F);
	    }
	gtype = HPOLIN;
	if ((xid_element[xid_graphics.current].labelx == -1) && (strcmp(
	    xid_element[xid_graphics.current].label,"") != 0))
	    xid_element[xid_graphics.current].labelx = gofbuf.plrec.x[0] + 5;
	if ((xid_element[xid_graphics.current].labely == -1) && (strcmp(
	    xid_element[xid_graphics.current].label,"") != 0))
	    xid_element[xid_graphics.current].labely = gofbuf.plrec.y[0] + 5;
/*
    Assign the X/Y vertice pairs.
*/
	xid_element[xid_graphics.current].x = gofbuf.plrec.x[0];
	xid_element[xid_graphics.current].y = gofbuf.plrec.y[0];

	if (xid_graphics.type == LINE)
	    {
	    lptr->num_vert = gofbuf.plrec.numpts;
	    lptr->x = gofbuf.plrec.x;
	    lptr->y = gofbuf.plrec.y;
	    }
	else if ((xid_graphics.type == POLY) || (xid_graphics.type == RECT))
	    {
	    pptr->num_vert = gofbuf.plrec.numpts;
	    pptr->x = gofbuf.plrec.x;
	    pptr->y = gofbuf.plrec.y;
/*
    Determine whether or not the current polygon is a rectangle.
*/
	    if (pptr->num_vert == 4)
		{
		if ((pptr->x[0] == pptr->x[3]) && (pptr->x[1] == pptr->x[2])
		    && (pptr->y[0] == pptr->y[1]) && (pptr->y[2] == pptr->y[3]))
		    xid_element[xid_graphics.current].type = RECT;
		}
	    }
/*
    Calculate bounding rectangle.
*/
	graphics_setbounds(xid_graphics.current);
	}
/*
    Assign annotation information to the structure.
*/
    else if (xid_graphics.type == TEXT)
	{
/*
    Determine whether or not current record is a deleted record or if it
    has already been loaded.
*/
	if ((strcmp(gofbuf.antrec.label,DELREC) == 0) || (graphics_duplicate(
	    offset,xid_graphics.type)))
	    {
/*
    Read next record.
*/
	    offset += (nbytes + next);
	    status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,&gofbuf);
	    if ((status != E_SUCC) && (status != E_EOF))
		{
		xid_message("Error reading GOF");
		return(XID_F);
		}
	    continue;
	    }
/*
    Assign type, text position, upper left corner of bounding rectangle
    and annotation label.
*/
	xid_element[xid_graphics.current].type = TEXT; 
	xid_element[xid_graphics.current].offset = offset; 
	xid_element[xid_graphics.current].labelx = xid_element[xid_graphics.
	    current].x = gofbuf.antrec.x;
	xid_element[xid_graphics.current].labely = xid_element[xid_graphics.
	    current].y = gofbuf.antrec.y;
	xid_element[xid_graphics.current].upleft[0] = gofbuf.antrec.x;
	xid_element[xid_graphics.current].upleft[1] = gofbuf.antrec.y;
	strcpy(xid_element[xid_graphics.current].label,gofbuf.antrec.label);
/*
    Assign attribute values.
*/
	for (i=0; i < MAXATT; i++)
	    strcpy(xid_element[xid_graphics.current].attributes[i],
		gofbuf.antrec.attrb[i]);
/*
    Assign color.
*/
	if (color_idx != -1)
	    sscanf(xid_element[xid_graphics.current].attributes[color_idx],"%d",
	        &xid_element[xid_graphics.current].color);
	else
	    xid_element[xid_graphics.current].color = 0;
/*
    Assign font.
*/
	if (font_idx != -1)
	    {
	    sscanf(xid_element[xid_graphics.current].attributes[font_idx],"%d",
	        &xid_element[xid_graphics.current].font);
	    if (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
		== NULL)
		{
		xid_graphics.font_info[xid_element[xid_graphics.current].font]
		    = XLoadQueryFont(xid.display,xid_graphics.fonts[
		    xid_element[xid_graphics.current].font]);
		if (xid_graphics.font_info[xid_element[xid_graphics.current].
		    font] == NULL)
		    xid_message("Specified font not available -- Using next available font");
		}
	    }
	else
	    xid_element[xid_graphics.current].font = 0;
/*
    Make sure specified font or default font is available.
*/
  	while (xid_graphics.font_info[xid_element[xid_graphics.current].font] 
	    == NULL)
	    {
	    xid_graphics.font_info[xid_element[xid_graphics.current].font]
		= XLoadQueryFont(xid.display,xid_graphics.fonts[
		xid_element[xid_graphics.current].font]);
	    xid_element[xid_graphics.current].font++;
	    if (xid_element[xid_graphics.current].font > USER_GRFONTS)
		xid_element[xid_graphics.current].font = 0;
	    }
/*
    Assign annotation text.
*/
	xid_element[xid_graphics.current].graph_ptr = 
	    (long *)calloc(1,sizeof(struct ANNOT_ELEMENT));
	if (xid_element[xid_graphics.current].graph_ptr == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return(XID_F);
	    }
	aptr = (struct ANNOT_ELEMENT *)xid_element[xid_graphics.current].
	    graph_ptr;
	aptr->string = malloc(strlen(gofbuf.antrec.antext));
	if (aptr->string == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return(XID_F);
	    }
	strcpy(aptr->string,gofbuf.antrec.antext);
/*
    Calculate bounding rectangle.
*/
	graphics_setbounds(xid_graphics.current);
	}
/*
    Read next record.
*/
    offset += (nbytes + next);
    status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&gtype,&gofbuf);
    if ((status != E_SUCC) && (status != E_EOF))
	{
	xid_message("Error reading GOF");
	return(XID_F);
	}
/*
    Increment current graphics element index.
*/
    xid_graphics.current++;
    if (xid_graphics.current >= xid_graphics.max_element)
	{
	status = graphics_realloc();
	if (status != XID_S)
	    return(XID_F);
	}
    }
return(XID_S);
}

/* ARGSUSED */
long
graphics_gofwrite()

/*******************************************************************************
Purpose:
    This routine writes the current graphics element to a GOF. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
union   GOF     gofbuf;         /* GOF structure.                             */

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

struct  ANNOT_ELEMENT   *aptr;  /* Pointer to polygon specific information.   */

long	addrec = TRUE,		/* Flag indicating records are being added to
				   the GOF.				      */
	current_idx,		/* Current graphics element index.	      */
	defatt_write(),		/* Routine to write a graphics attribute
				   to a GOF.				      */
	error = FALSE,		/* Indicates whether or not an error occurred.*/
	gtype,			/* GOF type (for c_gofwr).		      */
	i,			/* Looping index.			      */
	index,			/* Attribute index.			      */
	next,                   /* Number of bytes to next GOF record.        */
	status;			/* Status indicator.			      */

char    mesg[100];		/* Error message text.			      */

/*
    Set the current graphics element index.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else
    current_idx = xid_editgraph.current;

/*
    Define and set attributes for saving color, font, line width and label
    location.
*/
strcpy(mesg,"Error saving attribute(s) ");

/*
    Define color attribute.
*/
status = defatt_write(xid_atnames[XID_COL],xid_attypes[XID_COL],&index,FALSE);
if (status != XID_S)
    {
    strcat(mesg," ");
    strcat(mesg,xid_atnames[XID_COL]);
    error = TRUE;
    }
else
    sprintf(xid_element[current_idx].attributes[index],"%d",
	xid_element[current_idx].color);
/*
    Define font attribute.
*/
status = defatt_write(xid_atnames[XID_FONT],xid_attypes[XID_FONT],&index,FALSE);
if (status != XID_S)
    {
    strcat(mesg," ");
    strcat(mesg,xid_atnames[XID_FONT]);
    error = TRUE;
    }
else
    sprintf(xid_element[current_idx].attributes[index],"%d",
	xid_element[current_idx].font);

if (xid_element[current_idx].type != TEXT)
    {
/*
    Define X label position attribute.
*/
    status = defatt_write(xid_atnames[XID_LABX],xid_attypes[XID_LABX],&index,
	FALSE);
    if (status != XID_S)
	{
        strcat(mesg," ");
        strcat(mesg,xid_atnames[XID_LABX]);
	error = TRUE;
	}
    else
	sprintf(xid_element[current_idx].attributes[index],"%f",
	    xid_element[current_idx].labelx);
/*
    Define Y label position attribute.
*/
    status = defatt_write(xid_atnames[XID_LABY],xid_attypes[XID_LABY],&index,
	FALSE);
    if (status != XID_S)
	{
        strcat(mesg," ");
        strcat(mesg,xid_atnames[XID_LABY]);
	error = TRUE;
	}
    else
	sprintf(xid_element[current_idx].attributes[index],"%f",
	    xid_element[current_idx].labely);
    }

if ((xid_element[current_idx].type == LINE) || (xid_element[
    current_idx].type == POLY) || (xid_element[current_idx].
    type == RECT))
    {
/*
    Define line width attribute.
*/
    status = defatt_write(xid_atnames[XID_LW],xid_attypes[XID_LW],&index,FALSE);
    if (status != XID_S)
	{
        strcat(mesg," ");
        strcat(mesg,xid_atnames[XID_LW]);
	error = TRUE;
	}
    else
	{
	if (xid_element[current_idx].type == LINE)
	    {
	    lptr = (struct LINE_ELEMENT *)xid_element[current_idx].graph_ptr;
	    sprintf(xid_element[current_idx].attributes[index],"%d",
		lptr->line_width);
	    }
	else
	    {
	    pptr = (struct POLY_ELEMENT *)xid_element[current_idx].graph_ptr;
	    sprintf(xid_element[current_idx].attributes[index],"%d",
		pptr->line_width);
	    }
	}
    }

/*
    Print any error messages.
*/
if (error)
    {
    strcat(mesg," -- GOF record saved");
    xid_message(mesg);
    }

/*
    Write a point record. 
*/
if (xid_element[current_idx].type == POINT)
    {
/*
    Assign type, X and Y location and label to GOF structure.
*/
    gtype = PNT;
    gofbuf.ptrec.x = xid_element[current_idx].x;
    gofbuf.ptrec.y = xid_element[current_idx].y;
    strcpy(gofbuf.ptrec.label,xid_element[current_idx].label);

/*
    Assign attribute values.
*/
    for (i=0; i < MAXATT; i++)
	strcpy(gofbuf.ptrec.attrb[i],xid_element[current_idx].attributes[i]);
/*
    Append record to the end of the file.
*/
    xid_element[current_idx].offset = lseek(xid_graphics.fd,0,2);
    status = c_gofwr(&xid_graphics.fd,&next,&gtype,&gofbuf,&addrec);
    if (status != E_SUCC)
	{
	xid_message("Error writing record to GOF");
	return(XID_F);
	}
    }

/*
    Write a line record.
*/
else if (xid_element[current_idx].type == LINE)
    {
/*
    Assign type, X and Y vertices, number of vertices and label to GOF 
    structure.
*/
    gtype = FPOLIN;
    lptr = (struct LINE_ELEMENT *)xid_element[current_idx].graph_ptr;
    gofbuf.plrec.x = lptr->x;
    gofbuf.plrec.y = lptr->y;
    gofbuf.plrec.numpts = lptr->num_vert;
    strcpy(gofbuf.plrec.label,xid_element[current_idx].label);

/*
    Assign attribute values.
*/
    for (i=0; i < MAXATT; i++)
	strcpy(gofbuf.plrec.attrb[i],xid_element[current_idx].attributes[i]);

/*
    Append the record to the end of the file.
*/
    xid_element[current_idx].offset = lseek(xid_graphics.fd,0,2);
    status = c_gofwr(&xid_graphics.fd,&next,&gtype,&gofbuf,&addrec);
    if (status != E_SUCC)
	{
	xid_message("Error writing record to GOF");
	return(XID_F);
	}
    }

/*
    Write a polygon record.
*/
else if ((xid_element[current_idx].type == POLY) || (xid_element[current_idx].
    type == RECT))
    {
/*
    Assign type, X and Y vertices, number of vertices and label to GOF 
    structure.
*/
    gtype = FPOLIN;
    pptr = (struct POLY_ELEMENT *)xid_element[current_idx].graph_ptr;
    gofbuf.plrec.x = pptr->x;
    gofbuf.plrec.y = pptr->y;
    gofbuf.plrec.numpts = pptr->num_vert;
    strcpy(gofbuf.plrec.label,xid_element[current_idx].label);

/*
    Assign attribute values.
*/
    for (i=0; i < MAXATT; i++)
	strcpy(gofbuf.plrec.attrb[i],xid_element[current_idx].attributes[i]);
/*
    Append record to the end of the file.
*/
    xid_element[current_idx].offset = lseek(xid_graphics.fd,0,2);
    status = c_gofwr(&xid_graphics.fd,&next,&gtype,&gofbuf,&addrec);
    if (status != E_SUCC)
	{
	xid_message("Error writing record to GOF");
	return(XID_F);
	}
    }

/*
    Write an annotation record.
*/
else if (xid_element[current_idx].type == TEXT)
    {
/*
    Assign type, annotation location, label and annotation text to GOF
    structure.
*/
    gtype = ANOT;
    if (xid_element[current_idx].graph_ptr == NULL)
	{
	xid_message("User must specify annotation text");
	return(XID_F);
	}
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    if (aptr->string == NULL)
	{
	xid_message("User must specify annotation text");
	return(XID_F);
	}
    gofbuf.antrec.x = xid_element[current_idx].x;
    gofbuf.antrec.y = xid_element[current_idx].y;
    strcpy(gofbuf.antrec.label,"");
    strcpy(gofbuf.antrec.antext,aptr->string);
/*
    For now, hard code size and angle.
*/
    gofbuf.antrec.angle = 0.0;
    gofbuf.antrec.size = 0;

/*
    Assign attribute values.
*/
    for (i=0; i < MAXATT; i++)
	strcpy(gofbuf.antrec.attrb[i],xid_element[current_idx].attributes[i]);
/*
    Append record to the end of the file.
*/
    xid_element[current_idx].offset = lseek(xid_graphics.fd,0,2);
    status = c_gofwr(&xid_graphics.fd,&next,&gtype,&gofbuf,&addrec);
    if (status != E_SUCC)
	{
	xid_message("Error writing record to GOF");
	return(XID_F);
	}
    }
return(XID_S);
}

/* ARGSUSED */
void
graphics_mode(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine is called when the user selects "select" mode, "load" mode or
    "edit" mode.  In any case, the appropriate GOF is opened with the
    proper access and the appropriate options on the graphics panel are made
    sensitive.  In "load" mode, the GOF is read and the graphics elements
    displayed.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
Position
        popx,           	/* X position of pop-up panel.                */
        popy;           	/* Y position of pop-up panel.                */

long    access,        		/* File open access mode.                     */
	cflag,                  /* Indicates whether or not a GOF was created.*/
	i,			/* Looping index.			      */
	plane_idx,      	/* Index into memory plane structure of the
				   currently viewed image.                    */
	status;			/* Status indicator.		      	      */

char	goftyp[6],		/* GOF type.			      	      */
	hname[CMLEN],		/* Host name.			      	      */
	lname[CMLEN];		/* LAS name.			      	      */

/*
    Find the memory plane index of the first band of the displayed image.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;

/*
    The user has chosen "select" mode.
*/
if (*((char *)client) == 'S')
    {
/*
    Make appropriate options sensitive.
*/
    XtSetSensitive(graphics_defatt_button,True);
    XtSetSensitive(graphics_setatt_button,True);
    XtSetSensitive(graphics_label_text,True);
    XtSetSensitive(graphics_width_option,True);
    XtSetSensitive(graphics_color_option,True);
    XtSetSensitive(graphics_fonts_option,True);

/*
    If the user has selected a graphics type ...
*/
    if (xid_graphics.type != NO_TYPE)
	{
/*
    Open the GOF with APPEND access.
*/
	access = APPEND;
	if (xid_graphics.type == POINT)
	    strcpy(goftyp,"POINT");
	else if (xid_graphics.type == LINE)
	    strcpy(goftyp,"LINE");
	else if ((xid_graphics.type == RECT) || (xid_graphics.type == POLY))
	    strcpy(goftyp,"POLY");
	else if (xid_graphics.type == TEXT)
	    strcpy(goftyp,"ANNOT");

	if (xid_planes[plane_idx].image_type == LAS)
	    {
	    status = c_cmhost(xid_graphics.lname_gof,hname);
	    if (status != E_SUCC)
		{
		xid_message("Error retrieving host file name");
		return;
		}
	    }
	else
	    strcpy(hname,xid_graphics.lname_gof);
/*
    Open the GOF.
*/
	status = c_gofopn(&xid_graphics.fd,hname,lname,goftyp,&access,&cflag);
	if (status != E_SUCC)
	    {
	    xid_message("Error opening GOF");
	    xid_graphics.fd = -1;
	    }
	if (xid_planes[plane_idx].image_type == LAS)
	    strcpy(xid_graphics.lname_gof,lname);
	else
	    strcpy(xid_graphics.lname_gof,hname);
	}

/*
    Set appropriate globals and flags.
*/
    xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx = 
        xid_graphics.prevy = -1;
    xid_graphics.flags &= ~(GR_LOAD | GR_EDIT); 
    xid_graphics.flags |= GR_SELECT;

/*
    Add the "Graphics Select" context and make it active.
*/
    xid_contextadd(CON_GRSEL);
    XeContextSetActive((XeContextWidget)context_mouse,context_names[CON_GRSEL]);
    }

/*
    The user has chosen "load" mode.
*/
else if (*((char *)client) == 'L')
    {
/*
    If previously in "select" mode, determine whether or not the current
    record needs to be written to the GOF.
*/
    if (xid_graphics.flags & GR_SELECT)
	{
/*
    Cannot switch modes if in the middle of selecting a graphics element.
*/
        if ((xid_graphics.temp_num != 0) || (xid_graphics.flags & GR_LABEL))
            {
	    xid_message("User must cancel or finish selection of current element before switching modes");
	    return;
	    }
/*
    Remove the "Graphics Select" context.
*/
	xid_contextdel(CON_GRSEL);
/*
    Write the current record and close the current GOF.
*/
	if (xid_graphics.type != NO_TYPE)
	    {
	    if ((!(xid_element[xid_graphics.current].writeflg)) && 
		(xid_graphics.flags & GR_CLOSE))
		{
		status = graphics_gofwrite();
		if (status != XID_S)
		    return;
		xid_element[xid_graphics.current].writeflg = TRUE;
		}
    	    if (xid_graphics.fd != -1)
        	c_gofcls(&xid_graphics.fd);
	    }
/*
    Clear the label field.
*/
        XmTextFieldSetString(graphics_label_text,"");
	}
/*
    Make appropriate options insensitive.
*/
    XtSetSensitive(graphics_defatt_button,False);
    XtSetSensitive(graphics_setatt_button,False);
    XtSetSensitive(graphics_label_text,False);
    XtSetSensitive(graphics_width_option,False);
    XtSetSensitive(graphics_color_option,False);
    XtSetSensitive(graphics_fonts_option,False);

/*
    Open the GOF with the proper access.
*/
    if (xid_graphics.type != NO_TYPE)
	{
	access = READ;
	if (xid_graphics.type == POINT)
	    strcpy(goftyp,"POINT");
	else if (xid_graphics.type == LINE)
	    strcpy(goftyp,"LINE");
	else if ((xid_graphics.type == RECT) || (xid_graphics.type == POLY))
	    strcpy(goftyp,"POLY");
	else if (xid_graphics.type == TEXT)
	    strcpy(goftyp,"ANNOT");

	if (xid_planes[plane_idx].image_type == LAS)
	    {
	    status = c_cmhost(xid_graphics.lname_gof,hname);
	    if (status != E_SUCC)
		{
		xid_message("Error retrieving host file name");
		return;
		}
	    }
	else
	    strcpy(hname,xid_graphics.lname_gof);
/*
    Open the GOF.
*/
	status = c_gofopn(&xid_graphics.fd,hname,lname,goftyp,&access,&cflag);
	if (status != E_SUCC)
	    {
	    xid_message("Error opening GOF");
	    xid_graphics.fd = -1;
	    }
	if (xid_planes[plane_idx].image_type == LAS)
	    strcpy(xid_graphics.lname_gof,lname);
	else
	    strcpy(xid_graphics.lname_gof,hname);
	}
/*
    Set flags.
*/
    xid_graphics.flags &= ~(GR_SELECT | GR_EDIT);
    xid_graphics.flags |= GR_LOAD;
    xid_graphics.flags &= ~GR_CLOSE;
/*
    Read the GOF into an XID internal structure.
*/
    status = graphics_gofread();
    if (status != XID_S)
	return;
/*
    Draw graphics elements in the appropriate windows.
*/
    for (i=0; i < xid_graphics.current; i++)
	{
	status = graphics_draw(0,plane_idx,i);
	if (status != XID_S)
	    break;
	if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
	    {
	    status = graphics_draw(1,plane_idx,i);
	    if (status != XID_S)
		break;
	    }
        if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	    {
	    status = graphics_draw(2,plane_idx,i);
	    if (status != XID_S)
		break;
	    }
	}
/*
    Clear the windows to cause expose events which in turn updates the
    graphics information.
*/
    XClearArea(xid.display,XtWindow(main_image_bulletinboard),0,0,0,0,True);
    if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
        XClearArea(xid.display,XtWindow(fullres_win_bulletinboard),0,0,0,0,
	    True);
    if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
	XClearArea(xid.display,XtWindow(zoom_win_bulletinboard),0,0,0,0,True);
    }
/*
    The user has chosen "edit" mode.
*/
else if (*((char *)client) == 'E')
    {
/*
    If previously in "select" mode, determine whether or not the current
    record needs to be written to the GOF.
*/
    if (xid_graphics.flags & GR_SELECT)
	{
/*
    Cannot switch modes if in the middle of selecting a graphics element.
*/
        if ((xid_graphics.temp_num != 0) || (xid_graphics.flags & GR_LABEL))
            {
	    xid_message("User must cancel or finish selection of current element before switching modes");
	    return;
	    }
/*
    Remove the "Graphics Select" context.
*/
	xid_contextdel(CON_GRSEL);
/*
    Write the current record and close the current GOF.
*/
	if (xid_graphics.type != NO_TYPE)
	    {
	    if ((!(xid_element[xid_graphics.current].writeflg)) && 
		(xid_graphics.flags & GR_CLOSE))
		{
		status = graphics_gofwrite();
		if (status != XID_S)
		    return;
		xid_element[xid_graphics.current].writeflg = TRUE;
		}
    	    if (xid_graphics.fd != -1)
        	c_gofcls(&xid_graphics.fd);
	    xid_graphics.current++;
	    if (xid_graphics.current >= xid_graphics.max_element)
		graphics_realloc();
	    }
/*
    Clear the label field.
*/
        XmTextFieldSetString(graphics_label_text,"");
	}

/*
    Make appropriate options insensitive.
*/
    XtSetSensitive(graphics_defatt_button,False);
    XtSetSensitive(graphics_setatt_button,False);
    XtSetSensitive(graphics_label_text,False);
    XtSetSensitive(graphics_width_option,False);
    XtSetSensitive(graphics_color_option,False);
    XtSetSensitive(graphics_fonts_option,False);

/*
    Translate the X/Y position relative to the graphics panel to an X/Y position
    relative to the screen.
*/
    XtTranslateCoords(graphics_form,(Position)0,(Position)0,&popx,&popy);
 
/*
    Position the pop-up panel.
*/
    XtMoveWidget(graphics_edit_popup,popx-145,popy-25);
 
/*
    Pop up the "Edit Graphics" panel.
*/
    XtPopup(graphics_edit_popup, XtGrabNone);
    XtSetSensitive(graphics_edit_apply,False);

/*
    Make the "load" and "select" toggles insensitive.
*/
    XtSetSensitive(graphics_load_toggle,False);
    XtSetSensitive(graphics_select_toggle,False);
 
/*
    If the user has selected a graphics type ...
*/
    if (xid_graphics.type != NO_TYPE)
	{
/*
    Open the GOF with APPEND access.
*/
	access = APPEND;
	if (xid_graphics.type == POINT)
	    strcpy(goftyp,"POINT");
	else if (xid_graphics.type == LINE)
	    strcpy(goftyp,"LINE");
	else if ((xid_graphics.type == RECT) || (xid_graphics.type == POLY))
	    strcpy(goftyp,"POLY");
	else if (xid_graphics.type == TEXT)
	    strcpy(goftyp,"ANNOT");

	if (xid_planes[plane_idx].image_type == LAS)
	    {
	    status = c_cmhost(xid_graphics.lname_gof,hname);
	    if (status != E_SUCC)
		{
		xid_message("Error retrieving host file name");
		return;
		}
	    }
	else
	    strcpy(hname,xid_graphics.lname_gof);
/*
    Open the GOF.
*/
	status = c_gofopn(&xid_graphics.fd,hname,lname,goftyp,&access,&cflag);
	if (status != E_SUCC)
	    {
	    xid_message("Error opening GOF");
	    xid_graphics.fd = -1;
	    }
	if (xid_planes[plane_idx].image_type == LAS)
	    strcpy(xid_graphics.lname_gof,lname);
	else
	    strcpy(xid_graphics.lname_gof,hname);
	}

/*
    Add the "Graphics Edit" context and make it active.
*/
    xid_contextadd(CON_GREDIT);
    XeContextSetActive((XeContextWidget)context_mouse,
	context_names[CON_GREDIT]);
/*
    Set appropriate globals and flags.
*/
    xid_editgraph.vert = -1;
    xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx =
	xid_editgraph.nexty = -1;
    xid_editgraph.newx = xid_editgraph.newy = -1;
    xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx = 
        xid_graphics.prevy = -1;
    xid_graphics.flags &= ~(GR_LOAD | GR_SELECT);
    xid_graphics.flags |= GR_EDIT;
    xid_graphics.flags &= ~GR_CLOSE;
    xid_editgraph.flags = 0;
    xid_editgraph.current = -1;
    xid_editgraph.writeflg = FALSE;
/*
    Make sure none of the "graphics edit mode" toggles are set.
*/
    XmToggleButtonSetState(graphics_move_toggle,False,False);
    XmToggleButtonSetState(graphics_delete_toggle,False,False);
    XmToggleButtonSetState(graphics_add_toggle,False,False);

/*
    Only "move" is valid for points and annotation text.
*/
    if ((xid_graphics.type == POINT) || (xid_graphics.type == TEXT))
	{
	XtSetSensitive(graphics_add_toggle,False);
	XtSetSensitive(graphics_delete_toggle,False);
	XmToggleButtonSetState(graphics_move_toggle,True,False);
	graphics_editmode(graphics_move_toggle, "M", call);
	}
/*
    Only "move" is valid for rectangles. 
*/
    else if (xid_graphics.type == RECT)
	{
	XtSetSensitive(graphics_add_toggle,False);
	XtSetSensitive(graphics_delete_toggle,False);
	XmToggleButtonSetState(graphics_move_toggle,True,False);
	graphics_editmode(graphics_move_toggle, "M", call);
	}
    else
	{
	XtSetSensitive(graphics_add_toggle,True);
	XtSetSensitive(graphics_delete_toggle,True);
	}
    }
}

/* ARGSUSED */
void
graphics_refresh(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine is called to clear the graphics information from any
    currently displayed windows and to redraw that information.
 								
By L. Huewe, USGS/EROS Data Center, 10/92

Algorithm Description:
*******************************************************************************/
{
void	graphics_update();	/* Draw current graphics data.		      */

long	i,			/* Looping index.			      */
	plane_idx;		/* Index into memory plane structure of the 
				   currently viewed image.		      */

/*
    Clear the graphics pixmaps.
*/
XSetForeground(xid.display,xid_graphics.rb_gc,0);
for (i=0; i < USER_GRCOLORS; i++)
    {
    if (xid_graphics.pixmap[i] != NULL)
	XFillRectangle(xid.display,xid_graphics.pixmap[i],xid_graphics.
	    rb_gc,0,0,xid_mem.mem_width,xid_mem.mem_height);
    if ((xid_graphics.full_pix[i] != NULL) && (xid_fullres != NULL))
	XFillRectangle(xid.display,xid_graphics.full_pix[i],
	    xid_graphics.rb_gc,0,0,xid_fullres[0].width,
	    xid_fullres[0].height);
    if ((xid_graphics.zoom_pix[i] != NULL) && (xid_zoom.flags &
	ZOOM_ACTIVE))
	XFillRectangle(xid.display,xid_graphics.zoom_pix[i],
	    xid_graphics.rb_gc,0,0,xid_zoom.parms.factor *
	    xid_zoom.parms.in_samps,xid_zoom.parms.factor *
	    xid_zoom.parms.in_lines);
    }

/*
    Find the memory plane index of the first band of the displayed image.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;

/*
    Redraw currently selected/loaded graphics elements.
*/
graphics_update(0,plane_idx);
if ((xid_graphics.full_pix[i] != NULL) && (xid_fullres != NULL))
    graphics_update(1,plane_idx);
if ((xid_graphics.zoom_pix[i] != NULL) && (xid_zoom.flags &
    ZOOM_ACTIVE))
    graphics_update(2,plane_idx);
}

/* ARGSUSED */
void
graphics_select(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine determines which mouse button was selected by the user and 
    performs the appropriate action.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long		xtmp,ytmp;	/* Temporary X and Y window coordinates.      */

XButtonEvent    *event;         /* X Event structure.                         */

Pixel		pixelval;	/* Pixel value of selected color.	      */

Boolean		argok;		/* Status indicator.			      */

struct	LINE_ELEMENT	*lptr;	/* Pointer to line specific information.      */

struct	POLY_ELEMENT	*pptr;	/* Pointer to polygon specific information.   */

struct	ANNOT_ELEMENT	*aptr;	/* Pointer to annotation specific information.*/

struct  PT_LIST	*tmp;   	/* Temporary pointer to point structure.      */

float		xfil,		/* X file coordinate.			      */
		yfil;		/* Y file coordinate.			      */

long		i,		/* Looping index.			      */
		plane_idx,	/* Index into memory plane structure of the 
				   currently viewed image.		      */
		status,		/* Status indicator.			      */
		win;		/* Window from which coordinates are to be
				   calculated.				      */

event = (XButtonEvent *)call;

/*
    Determine which window generated the event.
*/
if (w == main_image_bulletinboard)
    win = 0;
else if (w == fullres_win_bulletinboard)
    win = 1;
else if (w == zoom_win_bulletinboard)
    win = 2;

/*
    Find the memory plane index of the first band of the displayed image.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;

if (xid_graphics.flags & GR_SELECT)
    {
/*
    Set the current graphics type if it has not already been set.
*/
    if (xid_element[xid_graphics.current].type == NO_TYPE)
	{
	xid_element[xid_graphics.current].type = xid_graphics.type;
	xid_element[xid_graphics.current].graph_ptr = (long *)NULL;
	xid_element[xid_graphics.current].color = -1; 
	xid_element[xid_graphics.current].font = -1; 
	xid_element[xid_graphics.current].writeflg = FALSE; 
	}

    if (xid_element[xid_graphics.current].color == -1)
	{
/*
    Set the foreground color in the graphics GC and the graphics element
    structure.
*/
	pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[
	    xid_graphics.color],"Pixel", 0, &argok);
	XSetForeground(xid.display,xid_graphics.gc,pixelval);
/*
    Set the graphics element color.
*/
	xid_element[xid_graphics.current].color = xid_graphics.color;
	}
/*
    Set the font index in the graphics element structure.
*/
    if (xid_element[xid_graphics.current].font == -1)
	{
	xid_element[xid_graphics.current].font = xid_graphics.font;
/*
    Load the specified font.
*/
	if (xid_graphics.font_info[xid_graphics.font] == NULL)
	    xid_graphics.font_info[xid_graphics.font] = XLoadQueryFont(xid.
		display,xid_graphics.fonts[xid_graphics.font]);
	}
/*
    Set the appropriate flags.
*/
    if (xid_graphics.flags & GR_CANCEL)
	xid_graphics.flags &= ~(GR_CANCEL | GR_CLOSE);
    }

/*
    Cancel element currently selecting.
*/
if (client == (XtPointer)4)
    {
/*
    Make the "load" and "edit" toggles sensitive again.
*/
    XtSetSensitive(graphics_load_toggle,True);
    XtSetSensitive(graphics_edit_toggle,True);
/*
    Cancel only makes sense if currently in "select" mode.
*/
    if (xid_graphics.flags & GR_SELECT)
	{
/*
    Erase current element and reset appropriate variables and flags.
*/
	if (xid_graphics.temp_num > 0)
	    {
	    graphics_cancel(w,plane_idx);
	    xid_graphics.temp_num = 0;
	    xid_graphics.first = (struct PT_LIST *)NULL;
	    xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx =
		xid_graphics.prevy = -1;
	    }
	else if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.type == TEXT))
	    {
	    status = graphics_cancel2(w,plane_idx);
	    if (status != XID_S)
		return;
	    xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx =
		xid_graphics.prevy = -1;
	    xid_element[xid_graphics.current].labelx = xid_element[xid_graphics.
		current].labely = -1;
	    xid_element[xid_graphics.current].x = xid_element[xid_graphics.
		current].y = -1;
	    xid_element[xid_graphics.current].color = xid_element[xid_graphics.
		current].font = -1;
	    xid_element[xid_graphics.current].type = NO_TYPE;
	    }
/*
    This is done so that if a new type is selected, the cancelled record does
    not get written to the GOF.
*/
	xid_element[xid_graphics.current].writeflg = TRUE;
	xid_graphics.flags |= GR_CANCEL;
	xid_graphics.flags &= ~GR_CLOSE;
/*
    Clear the label or annotation text.
*/
        XmTextFieldSetString(graphics_label_text,"");
/*
    Reset attribute values.
*/
    for (i=0; i < MAXATT; i++)
        strcpy(xid_element[xid_graphics.current].attributes[i],"");
/*
    Update the attribute values if "Set Attributes" panel is displayed.
*/
    if (XtIsRealized(Shell_Setatt))
        graphics_updateatt(xid_graphics.current);
/*
    Free dynamically allocated memory associated with the cancelled element.
*/
	if (xid_graphics.type == POLY)
	    {
	    if (xid_element[xid_graphics.current].graph_ptr != NULL)
		{
		pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.current].
		    graph_ptr;
		if (pptr->x != NULL)
		    {
		    free(pptr->x);
		    pptr->x = NULL;
		    }
		if (pptr->y != NULL)
		    {
		    free(pptr->y);
		    pptr->x = NULL;
		    }
		free(xid_element[xid_graphics.current].graph_ptr);
		xid_element[xid_graphics.current].graph_ptr = NULL;
		}
	    }
	if (xid_graphics.type == LINE)
	    {
	    if (xid_element[xid_graphics.current].graph_ptr != NULL)
		{
		lptr = (struct LINE_ELEMENT *)xid_element[xid_graphics.current].
		    graph_ptr;
		if (lptr->x != NULL)
		    {
		    free(lptr->x);
		    lptr->x = NULL;
		    }
		if (lptr->y != NULL)
		    {
		    free(lptr->y);
		    lptr->y = NULL;
		    }
		free(xid_element[xid_graphics.current].graph_ptr);
		xid_element[xid_graphics.current].graph_ptr = NULL;
		}
	    }
	if (xid_graphics.type == TEXT)
	    {
	    if (xid_element[xid_graphics.current].graph_ptr != NULL)
		{
		aptr = (struct ANNOT_ELEMENT *)xid_element[xid_graphics.
		    current].graph_ptr;
		if (aptr->string != NULL)
		    {
		    free(aptr->string);
		    aptr->string = NULL;
		    }
		free(xid_element[xid_graphics.current].graph_ptr);
		xid_element[xid_graphics.current].graph_ptr = NULL;
		}
	    }
        }
    return;
    }
/*
    The other mouse button selections apply only to "select" mode.  If not
    in "select" mode, return.
*/
if (!(xid_graphics.flags & GR_SELECT))
    return;

/*
    Perform the appropriate action based on the button selected.
*/
switch (event->button)
    {
/*
    Select a point.
*/
    case 1:
/*
    If placing a label, draw the label in the appropriate location.
*/
	if (xid_graphics.flags & GR_LABEL)
	    {
/*
    Once the label has been placed, allow access to the "load" and "edit"
    toggles again.
*/
	    XtSetSensitive(graphics_load_toggle,True);
	    XtSetSensitive(graphics_edit_toggle,True);
/*
    Convert the window coordinate to an actual file coordinate based on the
    image currently displayed.
*/
	    xid_win2file(plane_idx,win,event->x,event->y,&xid_element[
		xid_graphics.current].labelx,&xid_element[xid_graphics.
		current].labely);
/*
    Convert back to a window coordinate and use it to draw with because if in 
    the zoom window, conversion to a file coordinate and back to a window 
    coordinate may not result in the original window coordinate.  This is
    due to the fact that 1 file coordinate maps to several zoom window
    coordinates.
*/
	    xid_file2win(plane_idx,win,xid_element[xid_graphics.current].
		labelx,xid_element[xid_graphics.current].labely,&xtmp,&ytmp);
/*
    Draw the label.
*/
	    status = graphics_drawstring(w,win,xtmp,ytmp,plane_idx);
	    if (status != XID_S)
		return;
/*
    Determine whether the label placement affects the bounding rectangle.
*/
	    graphics_setbounds(xid_graphics.current);
	    if (xid_graphics.type != TEXT)
	        break;
	    }
	else
/*
    Once the user has started selecting points, don't allow access to the
    "load" and "edit" toggles until he/she has finished selecting or cancels 
    the current graphics element.
*/
	    {
	    XtSetSensitive(graphics_load_toggle,False);
	    XtSetSensitive(graphics_edit_toggle,False);
	    }
/*
    If the current graphics element has been closed, the user must select a
    type before more points may be selected.
*/
	if (xid_graphics.flags & GR_CLOSE)
	    {
	    xid_message("User must choose a graphics type before more points are selected");

/*
    This is done so that when a type is selected, the GOF record is not
    written out again.
*/
	    xid_graphics.type = NO_TYPE;
	    return;
	    }
/*
    Allocate a structure element for the new point and set the appropriate
    pointers to the next and previous points.
*/
	if (xid_graphics.first == NULL)
	    {
	    xid_graphics.first = xid_graphics.cur = (struct PT_LIST *)calloc(1,
		sizeof(struct PT_LIST));
	    if (xid_graphics.first == NULL)
		{
		xid_message("Insufficient amount of memory available");
		return;
		}
	    xid_graphics.first->prev = (struct PT_LIST *)NULL;
	    xid_graphics.first->next = (struct PT_LIST *)NULL;
	    }
	else
	    {
	    tmp = (struct PT_LIST *)calloc(1,sizeof(struct PT_LIST));
	    if (tmp == NULL)
		{
		xid_message("Insufficient amount of memory available");
		return;
		}
	    tmp->prev = xid_graphics.cur;
	    tmp->next = (struct PT_LIST *)NULL;
	    xid_graphics.cur->next = tmp;
	    xid_graphics.cur = tmp;
	    }
/*
    Convert the window coordinate to an actual file coordinate based on the
    image currently displayed.
*/
	xid_win2file(plane_idx,win,event->x,event->y,&xfil,&yfil);
	xid_graphics.cur->x = xfil;
	xid_graphics.cur->y = yfil;
	xid_graphics.temp_num++;

	xid_file2win(plane_idx,win,xfil,yfil,&xtmp,&ytmp);
/*
    Draw the line segement or rectangle.
*/
	if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE) ||
	    (xid_graphics.type == RECT))
	    {
	    status = graphics_drawlinerect(w,win,xtmp,ytmp,plane_idx,xfil,yfil);
	    if (status != XID_S)
		return;
	    }
/*
    Set the currently selected point (in window coordinates).
*/
	xid_graphics.selectx = xtmp; 
	xid_graphics.selecty = ytmp; 
/*
    Only one point is required for points and annotation text so force a 
    "close" event.
*/
	if ((xid_element[xid_graphics.current].type == POINT) || 
	    (xid_element[xid_graphics.current].type == TEXT))
	    {
	    event->button = 3;
	    client = (XtPointer)123;
	    graphics_select(w,client,call);
	    }
/*
    Only two points are required for a rectangle so force a "close" event.
*/
	if ((xid_element[xid_graphics.current].type == RECT) &&
	    (xid_graphics.temp_num == 2))
	    {
	    event->button = 3;
	    client = (XtPointer)123;
	    graphics_select(w,client,call);
	    }
	break;
/*
    Delete the last line segment.
*/
  case 2:
/*
    Return if there are no points selected.
*/
    if (xid_graphics.temp_num == 0)
	return;
/*
    Erase the line segment.
*/
	if (xid_graphics.temp_num > 1)
	    {
	    tmp = xid_graphics.cur->prev;
	    graphics_deletelinerect(w,win,plane_idx,tmp->x,tmp->y,xid_graphics.
		cur->x,xid_graphics.cur->y,TRUE);
	    }
	else
	    graphics_deletelinerect(w,win,plane_idx,xid_graphics.cur->x,
		xid_graphics.cur->y,xid_graphics. cur->x,xid_graphics.cur->y,
		TRUE);
/*
    Reduce the number of points selected and reset the previous point values.
*/
	xid_graphics.temp_num--;
	xid_graphics.prevx = xid_graphics.prevy = -1;
	break;
/*
    Close the polygon, end selection of line or end selection of rectangle.
*/
    case 3:
/*
    If no points have been selected, there is nothing to do.
*/
	if (xid_graphics.temp_num != 0)
	    {
/*
    Close the graphics element.
*/
	    status = graphics_close(w,win,plane_idx);
	    if (status != XID_S)
		return;
/*
    Set the X/Y coordinate of the point or annotation text or the first
    vertice of a line or polygon.
*/
	    xid_element[xid_graphics.current].x = xid_graphics.first->x;
	    xid_element[xid_graphics.current].y = xid_graphics.first->y;
/*
    Assign polygon information to graphics element structure.
*/
	    if (xid_element[xid_graphics.current].type == POLY)
		{
/*
    Allocate buffer space for polygon specific information.
*/
		if (xid_element[xid_graphics.current].graph_ptr == NULL)
		    {
		    xid_element[xid_graphics.current].graph_ptr = 
			(long *)calloc(1,sizeof(struct POLY_ELEMENT));
		    if (xid_element[xid_graphics.current].graph_ptr == NULL)
			{
			xid_message("Insufficient amount of memory available");
			return;
			}
		    pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.
			current].graph_ptr;
		    pptr->line_width = xid_graphics.line_width;
		    }
/*
    Allocate buffer space for X and Y vertice coordinates.
*/
		pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.current].
		    graph_ptr;
		pptr->x = (float *)calloc(xid_graphics.temp_num,sizeof(float));
		if (pptr->x == NULL)
		    {
		    xid_message("Insufficient amount of memory available");
		    return;
		    }
		pptr->y = (float *)calloc(xid_graphics.temp_num,sizeof(float));
		if (pptr->y == NULL)
		    {
		    xid_message("Insufficient amount of memory available");
		    return;
		    }
/*
    Copy the X/Y coordinates from the temporary point structure to the
    polygon structure.
*/
		pptr->x[0] = xid_graphics.first->x;
		pptr->y[0] = xid_graphics.first->y;

		for (i=1, xid_graphics.cur=xid_graphics.first; i < 
		    xid_graphics.temp_num; i++)
		    {
		    tmp = xid_graphics.cur;
		    xid_graphics.cur = tmp->next;
		    pptr->x[i] = xid_graphics.cur->x;
		    pptr->y[i] = xid_graphics.cur->y;
		    }
/*
    Assign the number of vertices.
*/
		pptr->num_vert = xid_graphics.temp_num;
/*
    Calculate the bounding rectangle.
*/
		graphics_setbounds(xid_graphics.current);
		}
/*
    Assign rectangle (polygon) information to graphics element structure.
*/
	    else if (xid_element[xid_graphics.current].type == RECT)
		{
/*
    Print an error message if fewer than 2 points have been selected for a 
    rectangle.
*/
		if (xid_graphics.temp_num != 2)
		    {
		    xid_message(
			"A rectangle must contain 2 (and only 2 points)");
		    return;
		    }
/*
    Allocate buffer space for polygon specific information.
*/
		if (xid_element[xid_graphics.current].graph_ptr == NULL)
		    {
		    xid_element[xid_graphics.current].graph_ptr = 
			(long *)calloc(1,sizeof(struct POLY_ELEMENT));
		    if (xid_element[xid_graphics.current].graph_ptr == NULL)
			{
			xid_message("Insufficient amount of memory available");
			return;
			}
		    pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.
			current].graph_ptr;
		    pptr->line_width = xid_graphics.line_width;
		    }
/*
    Allocate buffer space for X and Y vertice coordinates.
*/
		pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.current].
		    graph_ptr;
		pptr->x = (float *)calloc(4,sizeof(float));
		if (pptr->x == NULL)
		    {
		    xid_message("Insufficient amount of memory available");
		    return;
		    }
		pptr->y = (float *)calloc(4,sizeof(float));
		if (pptr->y == NULL)
		    {
		    xid_message("Insufficient amount of memory available");
		    return;
		    }
/*
    Copy the X/Y coordinates from the temporary point strucutre to the
    polygon structure.
*/
		pptr->x[0] = xid_graphics.first->x;
		pptr->y[0] = xid_graphics.first->y;
		xid_graphics.cur = xid_graphics.first->next;
		pptr->x[1] = xid_graphics.cur->x;
		pptr->y[1] = xid_graphics.first->y;
		pptr->x[2] = xid_graphics.cur->x;
		pptr->y[2] = xid_graphics.cur->y;
		pptr->x[3] = xid_graphics.first->x;
		pptr->y[3] = xid_graphics.cur->y;
/*
    Assign the number of vertices.
*/
		pptr->num_vert = 4; 
/*
    Calculate bounding rectangles.
*/
		graphics_setbounds(xid_graphics.current);
		}
/*
    Assign line information to graphics element structure.
*/
	    else if (xid_element[xid_graphics.current].type == LINE)
		{
/*
    Print an error message if fewer than 2 points have been selected for a
    line.
*/
		if (xid_graphics.temp_num < 2)
		    {
		    xid_message("A line must contain at least 2 points");
		    return;
		    }
/*
    Allocate buffer space for line information.
*/
		if (xid_element[xid_graphics.current].graph_ptr == NULL)
		    {
		    xid_element[xid_graphics.current].graph_ptr = (long *)
			calloc(1,sizeof(struct LINE_ELEMENT));
		    if (xid_element[xid_graphics.current].graph_ptr == NULL)
			{
			xid_message("Insufficient amount of memory available");
			return;
			}
		    lptr = (struct LINE_ELEMENT *)xid_element[xid_graphics.
			current].graph_ptr;
		    lptr->line_width = xid_graphics.line_width;
		    }
/*
    Allocate buffer space for X and Y vertice coordinates.
*/
		lptr = (struct LINE_ELEMENT *)xid_element[xid_graphics.current].
		    graph_ptr;
		lptr->x = (float *)calloc(xid_graphics.temp_num,sizeof(float));
		if (lptr->x == NULL)
		    {
		    xid_message("Insufficient amount of memory available");
		    return;
		    }
		lptr->y = (float *)calloc(xid_graphics.temp_num,sizeof(float));
		if (lptr->y == NULL)
		    {
		    xid_message("Insufficient amount of memory available");
		    return;
		    }
/*
    Copy the X/Y coordinates from the temporary point structure to the
    line structure.
*/
		lptr->x[0] = xid_graphics.first->x;
		lptr->y[0] = xid_graphics.first->y;

		for (i=1, xid_graphics.cur=xid_graphics.first; i < 
		    xid_graphics.temp_num; i++)
		    {
		    tmp = xid_graphics.cur;
		    xid_graphics.cur = tmp->next;
		    lptr->x[i] = xid_graphics.cur->x;
		    lptr->y[i] = xid_graphics.cur->y;
		    }
/*
    Assign the number of vertices.
*/
		lptr->num_vert = xid_graphics.temp_num;
/*
    Calculate the bounding rectangle.
*/
		graphics_setbounds(xid_graphics.current);
		}
/*
    Assign text information to graphics element structure.
*/
	    else if (xid_element[xid_graphics.current].type == TEXT)
		{
/*
    If no buffer space has been allocated for annotation information, then the
    user has not specified an annotation text string.
*/
		if (xid_element[xid_graphics.current].graph_ptr == NULL)
		    {
		    xid_graphics.selectx = xid_graphics.selecty = 
			xid_graphics.prevx = xid_graphics.prevy = -1;
		    xid_message("User must specify an annotation text string");
		    return;
		    }
/*
    Calculate the bounding rectangle.
*/
		graphics_setbounds(xid_graphics.current);
		}
	    else if (xid_element[xid_graphics.current].type == POINT)
/*
    Calculate the bounding rectangle for a point.
*/
		graphics_setbounds(xid_graphics.current);
/*
    Free the temporary point structures.
*/
	    while (xid_graphics.cur->prev != NULL)
		{
		tmp = xid_graphics.cur->prev;
		free(xid_graphics.cur);
		xid_graphics.cur = tmp;
		}
	    free(xid_graphics.cur);
	    xid_graphics.temp_num = 0;
	    xid_graphics.first = (struct PT_LIST *)NULL;
	    xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx =
		xid_graphics.prevy = -1;
	    xid_graphics.flags |= GR_CLOSE;
/*
    Place the label (if one has been specified).
*/
	    if ((strcmp(xid_element[xid_graphics.current].label,"") != 0) &&
		(xid_graphics.type != TEXT))
		graphics_labelcalc(xid_element[xid_graphics.current].label);
	    else
/*
    If no label was specified, allow access to the "load" and "edit" toggles.
*/
		XtSetSensitive(graphics_load_toggle,True);
		XtSetSensitive(graphics_edit_toggle,True);
/*
    Set a flag indicating the record has not yet been written to the GOF.
*/
	    xid_element[xid_graphics.current].writeflg = FALSE;
	    }
	break;
    }
}

/* ARGSUSED */
void
graphics_setlabel(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine retrieves the user specified label or annotation text string. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
struct	ANNOT_ELEMENT	*aptr;	/* Pointer to annotation specific information.*/

long		reset,		/* Indicates whether or not the label
				   placement flag needs to be reset.	      */
		status;		/* Status indicator.			      */

char		current_idx,	/* Current graphics element index.	      */
		mesg[80],	/* Error message text.		       	      */
		*oldstring,	/* Previous label or annotation string.	      */
		*value;		/* Label value.				      */

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Set the current graphics type if it has not already been set.
*/
if ((xid_graphics.flags & GR_SELECT) && (xid_element[current_idx].type == 
    NO_TYPE))
    {
    xid_element[xid_graphics.current].type = xid_graphics.type;
    xid_element[xid_graphics.current].graph_ptr = (long *)NULL;
    xid_element[xid_graphics.current].color = -1; 
    xid_element[xid_graphics.current].font = -1; 
    xid_element[xid_graphics.current].writeflg = FALSE; 
    }

/*
    Get the user specified label or annotation text string.
*/
value = XmTextGetString(w);
if (xid_graphics.type != TEXT)
    {
/*
    Verify that the label does not contain too many characters.
*/
    if (strlen(value) > (KEYL - 1))
	{
	XtFree(value);
	sprintf(mesg,"Label may only contain %d characters",ATTVAL-1);
	xid_message (mesg);
	return;
	}
/*
    If the graphics element is already "closed" (i.e., the user has finished
    selecting it) or the user is in edit mode, the user must be changing an 
    existing label.
*/
    if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
	{
/*
    Store the value of the old label.
*/
	oldstring = malloc(strlen(xid_element[current_idx].label)+1);
	if (oldstring == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return;
	    }
	strcpy(oldstring,xid_element[current_idx].label);
	if (xid_graphics.flags & GR_EDIT)
	    {
/*
    Save the old label for the "graphics undo" function.
*/
	    status = graphics_copy_element(&xid_element[current_idx],
		&xid_editundo);
	    if (status != XID_S)
		return;
	    }
	}
/*
    Set and load the font if it has not already been done.
*/
    if (xid_element[current_idx].font == -1)
        {
        xid_element[current_idx].font = xid_graphics.font;
        if (xid_graphics.font_info[xid_graphics.font] == NULL)
	    xid_graphics.font_info[xid_graphics.font] = XLoadQueryFont(
		xid.display,xid_graphics.fonts[xid_graphics.font]);
        }
/*
    Assign the new label to the graphics element structure.
*/
    strcpy(xid_element[current_idx].label,value);
/*
    Calculate the label width and height based on the label and font.
*/
    if (xid_graphics.flags & GR_LABEL)
	reset = FALSE;
    else
	reset = TRUE;
    graphics_labelcalc(xid_element[current_idx].label);

    if (reset)
/*
    Reset flag indicating we are currently placing a label.
*/
        xid_graphics.flags &= ~GR_LABEL;
    }
else
    {
/*
    Verify that the annotation text string  does not contain too many 
    characters.
*/
    if (strlen(value) > (ANTLEN - 1))
	{
	XtFree(value);
	sprintf(mesg,"Annotation text may only contain %d characters",ANTLEN-1);
	xid_message (mesg);
	return;
	}
/*
    Allocate buffer space for annotation specific information. 
*/
    if (xid_element[current_idx].graph_ptr == NULL)
	{
	xid_element[current_idx].graph_ptr = (long *)calloc(1,
	    sizeof(struct ANNOT_ELEMENT));
	if (xid_element[current_idx].graph_ptr == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return;
	    }
        aptr = (struct ANNOT_ELEMENT *) xid_element[current_idx].graph_ptr;
	aptr->string = NULL;
	}
    aptr = (struct ANNOT_ELEMENT *) xid_element[current_idx].graph_ptr;

    if (aptr->string != NULL)
	{
/*
    If the graphics element is already "closed" (i.e., the user has finished
    selecting it) or the user is in edit mode, the user must be changing an 
    existing annotation string.
*/
	if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
	    {
/*
    Store the value of the old annotation string.
*/
	    oldstring = malloc(strlen(aptr->string)+1);
	    if (oldstring == NULL)
		{
		xid_message("Insufficient memory available");
		return;
		}
	    strcpy(oldstring,aptr->string);
	    }
	free(aptr->string);
	}
/*
    Allocate buffer space for annotation text string.
*/
    aptr->string = malloc(strlen(value) + 1);
    if (aptr->string == NULL)
	{
	xid_message("Insufficient amount of memory available");
	return;
	}
/*
    Set and load the font if it has not already been done.
*/
    if (xid_element[current_idx].font == -1)
        {
        xid_element[current_idx].font = xid_graphics.font;

        if (xid_graphics.font_info[xid_graphics.font] == NULL)
	    xid_graphics.font_info[xid_graphics.font] = XLoadQueryFont(
		xid.display,xid_graphics.fonts[xid_graphics.font]);
        }
/*
    Assign the new annotation string to the graphics element structure.
*/
    strcpy(aptr->string,value);

    if ((xid_graphics.flags & GR_LABEL) || ((xid_graphics.flags & GR_SELECT) 
	&& (xid_graphics.type == TEXT)))
	reset = FALSE;
    else
	reset = TRUE;
/*
    Calculate the annotation width and height based on the annotation string 
    and font.
*/
    graphics_labelcalc(aptr->string);
/*
    Reset flag indicating we are currently placing a label if we have already
    placed it.
*/
    if (reset)
	xid_graphics.flags &= ~GR_LABEL;
/*
    Do not allow the user access to the "load" and "edit" toggles until 
    finished placing annotation text.
*/
    else
	{
	XtSetSensitive(graphics_load_toggle,False);
	XtSetSensitive(graphics_edit_toggle,False);
	}
    }

/*
    Free dynamically allocated memory.
*/
XtFree(value);

/*
    Reset cancel flag.
*/
xid_graphics.flags &= ~GR_CANCEL;

/*
    If already finished selecting the graphics element, redraw it with the
    new label or annotation text.
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    {
/*
    Calculate the bounding rectangle.
*/
    graphics_setbounds(current_idx);
/*
    Redraw the graphics element with the new label or annotation text.
*/
    graphics_redraw(xid_graphics.color,xid_graphics.font,
	xid_graphics.line_width,oldstring);
    free (oldstring);
    }
/*
    Set "graphics modify" flag.
*/
if (xid_graphics.flags & GR_EDIT)
    xid_editgraph.flags |= GR_MODIFY;
}

/* ARGSUSED */
void
graphics_setcolor(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine determines the user selected color and redraws any graphics
    elements in the new color if necessary.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

Arg    		args[1];	/* Arguments for setting resource values.     */

Boolean   	argok;		/* Status indicator.			      */

Pixel		pixelval;	/* Pixel value of selected color.	      */

long		current_idx,	/* Index of current graphics element.	      */
		i,		/* Looping index.			      */
		oldcolor,	/* Color index of previous color.	      */
		status;		/* Status indicator.			      */

/*
    Set the foreground color of the option menu to reflect the color selected.
*/
pixelval = (Pixel)CONVERT(Shell_Graphics, client, "Pixel", 0, &argok);
XtSetArg(args[0], XmNforeground,pixelval); 
XtSetValues(graphics_color_option, args, 1);

/*
    Set the foreground color in the graphics GC.
*/
XSetForeground(xid.display,xid_graphics.gc,pixelval);

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Set the current graphics type if it has not already been set.
*/
if ((xid_graphics.flags & GR_SELECT) && (xid_element[xid_graphics.current].
    type == NO_TYPE))
    {
    xid_element[xid_graphics.current].type = xid_graphics.type;
    xid_element[xid_graphics.current].graph_ptr = (long *)NULL;
    xid_element[xid_graphics.current].color = -1;
    xid_element[xid_graphics.current].font = -1;
    xid_element[xid_graphics.current].writeflg = FALSE;
    }

/*
    If the graphics element is already "closed" (i.e., the user has finished
    selecting it) or the user is in edit mode, the user must be changing the 
    color of an existing element. 
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    {
/*
    Save the old color.
*/
    oldcolor = xid_element[current_idx].color;
    if (xid_graphics.flags & GR_EDIT)
	{
/*
    Save the graphics element with the old color for the "graphics undo" 
    function.
*/
	status = graphics_copy_element(&xid_element[current_idx],&xid_editundo);
	if (status != XID_S)
	    return;
	}
    }
/*
    Find the index of the selected color and store it in the graphics element
    structure.
*/
for (i=0; i < USER_GRCOLORS; i++)
    if (strcmp(xid_graphics.colors[i],client) == 0)
	break;
xid_element[current_idx].color = xid_graphics.color = i;

if ((xid_graphics.flags & GR_CANCEL) && (xid_graphics.type == TEXT) &&
    (xid_element[xid_graphics.current].graph_ptr != NULL))
    {
/*
    Calculate annotation text width and height.
*/
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    graphics_labelcalc(aptr->string);
    }
  
/*
    Reset cancel flag.
*/
xid_graphics.flags &= ~GR_CANCEL;

/*
    If finished selecting the current element or in edit mode, redraw it in 
    the new color.
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    {
    if (xid_graphics.type == TEXT)
	{
	aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
	graphics_redraw(oldcolor,xid_element[current_idx].font,
	    xid_graphics.line_width,aptr->string);
	}
    else 
	graphics_redraw(oldcolor,xid_element[current_idx].font,
	    xid_graphics.line_width,xid_element[current_idx].label);
    }
/*
    Set "graphics modify" flag.
*/
if (xid_graphics.flags & GR_EDIT)
    xid_editgraph.flags |= GR_MODIFY;
}

/* ARGSUSED */
void
graphics_setfont(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine determines the user selected font and redraws any graphics
    elements in the new font if necessary.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

Arg    		args[1];	/* Arguments for setting resource values.     */

Boolean   	argok;		/* Status indicator.			      */

Widget		cascadegadget;  /* Widget ID.				      */

long		current_idx,	/* Index of current graphics element.	      */
		i,		/* Looping index.			      */
		oldfont,	/* Previous font index.			      */
		reset,		/* Flag indicating whether label placement
				   flag needs to be reset.		      */
		status;		/* Status indicator.			      */

/*
    Get the widget ID of the CascadeButtonGadget of the fonts option menu. 
    This is used to set the font so that the selected option is displayed
    in the selected font.
*/
cascadegadget = XmOptionButtonGadget(graphics_fonts_option);
XtSetArg(args[0], XmNfontList, 
	CONVERT(Shell_Graphics, client, "FontList", 0, &argok)); 
XtSetValues(cascadegadget, args, 1);

/*
    Set the current graphics type if it has not already been set.
*/
if ((xid_graphics.flags & GR_SELECT) && (xid_element[xid_graphics.current].
    type == NO_TYPE))
    {
    xid_element[xid_graphics.current].type = xid_graphics.type;
    xid_element[xid_graphics.current].graph_ptr = (long *)NULL;
    xid_element[xid_graphics.current].color = -1; 
    xid_element[xid_graphics.current].font = -1; 
    xid_element[xid_graphics.current].writeflg = FALSE; 
    }

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    If the graphics element is already "closed" (i.e., the user has finished
    selecting it) or the user is in edit mode, the user must be changing the 
    font of an existing element. 
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    {
/*
    Save the old font.
*/
    oldfont = xid_element[current_idx].font;
    if (xid_graphics.flags & GR_EDIT)
	{
/*
    Save the graphics element with the old font for the "graphics undo" 
    function.
*/
	status = graphics_copy_element(&xid_element[current_idx],&xid_editundo);
	if (status != XID_S)
	    return;
	}
    }

/*
    Find the index of the selected font and store it in the graphics element
    structure.
*/
for (i=0; i < USER_GRFONTS; i++)
    if (strcmp(xid_graphics.fonts[i],client) == 0)
	break;
xid_element[current_idx].font = xid_graphics.font = i;

/*
    Load the new font if it has not already been loaded.
*/
if (xid_graphics.font_info[xid_graphics.font] == NULL)
    xid_graphics.font_info[xid_graphics.font] = XLoadQueryFont(xid.display,
	xid_graphics.fonts[xid_graphics.font]);
/*
    Calculate the annotation width and height.
*/
if ((xid_graphics.flags & GR_EDIT) || (xid_graphics.flags & GR_CLOSE))
    {
    if (xid_graphics.flags & GR_LABEL)
	reset = FALSE;
    else
	reset = TRUE;
    }
else
    reset = FALSE;

if ((xid_graphics.flags & GR_CANCEL) && (xid_graphics.type == TEXT) &&
    (xid_element[xid_graphics.current].graph_ptr != NULL))
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    graphics_labelcalc(aptr->string);
    if (reset)
	xid_graphics.flags &= ~GR_LABEL;
    }
else if (xid_graphics.type == TEXT)
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    if (aptr != NULL)
	{
    	graphics_labelcalc(aptr->string);
        if (reset)
    	    xid_graphics.flags &= ~GR_LABEL;
	}
    }
/*
    Reset bounding rectangle.
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    graphics_setbounds(current_idx);

/*
    Reset the cancel flags.
*/
xid_graphics.flags &= ~GR_CANCEL;

/*
    If finished selecting the current element or in edit mode, redraw it in 
    the new font.
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT)) 
    {
    if (xid_graphics.type == TEXT)
	graphics_redraw(xid_element[current_idx].color,oldfont,
	    xid_graphics.line_width,aptr->string);
    else
	graphics_redraw(xid_element[current_idx].color,oldfont,
	    xid_graphics.line_width,xid_element[current_idx].label);
    }
/*
    Set "graphics modify" flag.
*/
if (xid_graphics.flags & GR_EDIT)
    xid_editgraph.flags |= GR_MODIFY;
}

/* ARGSUSED */
void
graphics_setwidth(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine determines the user selected line width and redraws any 
    graphics elements in the new line width if necessary.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

struct	LINE_ELEMENT	*lptr;	/* Pointer to line specific information.      */

struct	POLY_ELEMENT	*pptr;	/* Pointer to polygon specific information.   */

	long		current_idx,
				/* Current graphics element index.	      */
			oldwidth,
				/* Previous line width.			      */
			status;	/* Status indicator.			      */

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Set the current graphics type if it has not already been set.
*/
if ((xid_graphics.flags & GR_SELECT) && (xid_element[xid_graphics.current].
    type == NO_TYPE))
    {
    xid_element[xid_graphics.current].type = xid_graphics.type;
    xid_element[xid_graphics.current].graph_ptr = (long *)NULL;
    xid_element[xid_graphics.current].color = -1; 
    xid_element[xid_graphics.current].font = -1; 
    xid_element[xid_graphics.current].writeflg = FALSE; 
    }

/*
    If the graphics element is already "closed" (i.e., the user has finished
    selecting it) or the user is in edit mode, the user must be changing the 
    line width of an existing element. 
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    {
/*
    Save the old line width.
*/
    oldwidth = xid_graphics.line_width;
    if (xid_graphics.flags & GR_EDIT)
       {
/*
    Save the graphics element with the old line width for the "graphics undo" 
    function.
*/
	status = graphics_copy_element(&xid_element[current_idx],&xid_editundo);
	if (status != XID_S)
	    return;
       }
    }

if (xid_element[current_idx].type == POLY)
    {
/*
    Allocate space for polygon specific information.
*/
    if (xid_element[current_idx].graph_ptr == NULL)
	{
	xid_element[current_idx].graph_ptr = (long *)
	    calloc(1,sizeof(struct POLY_ELEMENT));
	if (xid_element[current_idx].graph_ptr == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return;
	    }
        pptr = (struct POLY_ELEMENT *) xid_element[current_idx].graph_ptr;
        pptr->x = pptr->y = (float *)NULL;
	}
    pptr = (struct POLY_ELEMENT *) xid_element[current_idx].graph_ptr;
/*
    Assign specified line width.
*/
    pptr->line_width = (long)client;
    }
else if (xid_element[current_idx].type == LINE)
    {
/*
    Allocate space for line specific information.
*/
    if (xid_element[current_idx].graph_ptr == NULL)
	{
	xid_element[current_idx].graph_ptr = (long *)
	    calloc(1,sizeof(struct LINE_ELEMENT));
	if (xid_element[current_idx].graph_ptr == NULL)
	    {
	    xid_message("Insufficient amount of memory available");
	    return;
	    }
        lptr = (struct LINE_ELEMENT *) xid_element[current_idx].graph_ptr;
        lptr->x = lptr->y = (float *)NULL;
	}
    lptr = (struct LINE_ELEMENT *) xid_element[current_idx].graph_ptr;
/*
    Assign specified line width.
*/
    lptr->line_width = (long)client;
    }
/*
    Assign specified line width.
*/
xid_graphics.line_width = (long)client;

if ((xid_graphics.flags & GR_CANCEL) && (xid_graphics.type == TEXT))
    {
/*
    Calculate annotation string width and height.
*/
    aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
    graphics_labelcalc(aptr->string);
    }
  
/*
    Reset cancel flag.
*/
xid_graphics.flags &= ~GR_CANCEL;

/*
    If finished selecting the current element or in edit mode, redraw using 
    the new line width.
*/
if ((xid_graphics.flags & GR_CLOSE) || (xid_graphics.flags & GR_EDIT))
    {
    if (xid_graphics.type == TEXT)
	{
	aptr = (struct ANNOT_ELEMENT *)xid_element[current_idx].graph_ptr;
	graphics_redraw(xid_graphics.color,xid_graphics.font,oldwidth,
	    aptr->string);
	}
    else
	graphics_redraw(xid_graphics.color,xid_graphics.font,oldwidth,
	    xid_element[current_idx].label);
    }
/*
    Set "graphics modify" flag.
*/
if (xid_graphics.flags & GR_EDIT)
    xid_editgraph.flags |= GR_MODIFY;
}

void
graphics_type(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine determines the graphics type selected by the user.  If in
    "load" mode, the proper GOF is loaded and displayed.  If in "select"
    mode, the current graphics element (if one exists) is written to the GOF
    and the appropriate GOF for the new type is then opened.  If in "edit"
    mode, the proper GOF is opened.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Modified by L. Huewe, USGS/EROS Data Center, 3/94
    - Modified to make sure a graphics element was actually selected before
      attempting to write the record to the GOF.

Algorithm Description:
*******************************************************************************/
{
struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

XmString
	xmstr;			/* Compound string variable.		      */

long	access,			/* File open access mode.		      */
	cflag,			/* Indicates whether or not a GOF was created.*/
	length,			/* String length.			      */
	plane_idx,              /* Index into memory plane structure.         */
	status,			/* Status indicator.			      */
	write_rec = FALSE;	/* Flag indicating whether or not to write
				   the current record out to the GOF.	      */

char	ext[11],                /* File extension.			      */
	goftyp[6],		/* Type of GOF.				      */
	hname[CMLEN],           /* Host file name of displayed image (first
				   band).                                     */
	hostnam[CMLEN],         /* Host name of the GOF.         	      */
	lasname[CMLEN];         /* LAS name of the GOF.         	      */

/*
    Print a warning and return if no image data is currently displayed.
*/
if (xid.view == -1)
    {
    xid_message("No image data currently being viewed");
    return;
    }
/*
    Once a type has been selected, make the appropriate options sensitive.
*/
if (xid_graphics.flags & GR_CREATE)
    {
    XtSetSensitive(graphics_gof_text,True);
    XtSetSensitive(graphics_mode_radiobox,True);
    XtSetSensitive(graphics_select_toggle,True);
    XtSetSensitive(graphics_load_toggle,True);
    XtSetSensitive(graphics_edit_toggle,True);
    xid_graphics.flags &= ~GR_CREATE; 
    }

/*
    Print an error message if the user has not either cancelled or finished
    selecting the current element.
*/
if ((xid_graphics.temp_num != 0) || (xid_graphics.flags & GR_LABEL))
    {
    xid_message("User must cancel or finish selection of current type before selecting new type");
    return;
    }

/*
    Print an error message if the user has not either cancelled or finished
    editting the current element.
*/
if (xid_graphics.flags & GR_EDIT)
    {
    xid_message("User must cancel or finish modifying current element before selecting new type");
    return;
    }

/*
    Write the current record and close the current GOF.
*/

if ((xid_graphics.type != NO_TYPE) && (xid_graphics.flags & GR_SELECT))
    {
/*
    Make sure the record has not already been written and that the user has
    actually selected a graphics element.
*/
    if (!(xid_element[xid_graphics.current].writeflg))
	{
	if (((xid_graphics.type == POLY) || (xid_graphics.type == RECT)) &&
	    (xid_element[xid_graphics.current].graph_ptr != NULL))
	    {
	    pptr = (struct POLY_ELEMENT *)xid_element[xid_graphics.current].
		graph_ptr;
	    if (pptr->num_vert > 0)
		write_rec = TRUE;
	    }
	else if ((xid_graphics.type == LINE) && (xid_element[xid_graphics.
	    current].graph_ptr != NULL))
	    {
	    lptr = (struct LINE_ELEMENT *)xid_element[xid_graphics.current].
		graph_ptr;
	    if (lptr->num_vert > 0)
		write_rec = TRUE;
	    }
	else if (((xid_graphics.type == TEXT) || (xid_graphics.type == POINT))
	    && (xid_element[xid_graphics.current].x > 0))
	    write_rec = TRUE;

	if (write_rec)
	    {
	    status = graphics_gofwrite();
	    if (status != XID_S)
		return;
	    xid_element[xid_graphics.current].writeflg = TRUE;
	    }
	}
    if (xid_graphics.fd != -1)
        c_gofcls(&xid_graphics.fd);
    }

/*
    Set the current graphics type.
*/
if (strcmp(client,"point") == 0)
    {
    xid_graphics.type = POINT;
    strcpy(goftyp,"POINT");
    xmstr = XmStringCreateLtoR("Label:", XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(graphics_label,XmNlabelString,xmstr,NULL);
    XmStringFree(xmstr);
    XmTextFieldSetString(graphics_label_text,"");
    }
else if (strcmp(client,"line") == 0)
    {
    xid_graphics.type = LINE;
    strcpy(goftyp,"LINE");
    xmstr = XmStringCreateLtoR("Label:", XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(graphics_label,XmNlabelString,xmstr,NULL);
    XmStringFree(xmstr);
    XmTextFieldSetString(graphics_label_text,"");
    }
else if (strcmp(client,"rect") == 0)
    {
    xid_graphics.type = RECT;
    strcpy(goftyp,"POLY");
    xmstr = XmStringCreateLtoR("Label:", XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(graphics_label,XmNlabelString,xmstr,NULL);
    XmStringFree(xmstr);
    XmTextFieldSetString(graphics_label_text,"");
    }
else if (strcmp(client,"poly") == 0)
    {
    xid_graphics.type = POLY;
    strcpy(goftyp,"POLY");
    xmstr = XmStringCreateLtoR("Label:", XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(graphics_label,XmNlabelString,xmstr,NULL);
    XmStringFree(xmstr);
    XmTextFieldSetString(graphics_label_text,"");
    }
else if (strcmp(client,"text") == 0)
    {
    xid_graphics.type = TEXT;
    strcpy(goftyp,"ANNOT");
    xmstr = XmStringCreateLtoR("Text:", XmSTRING_DEFAULT_CHARSET);
    XtVaSetValues(graphics_label,XmNlabelString,xmstr,NULL);
    XmStringFree(xmstr);
    XmTextFieldSetString(graphics_label_text,"");
    }

/*
    Determine the default name for the GOF based on the first band of the
    displayed image, if a GOF name has not already been specified.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;
if (strcmp(xid_graphics.lname_gof,"") == 0)
    {
    if (xid_planes[plane_idx].image_type == LAS)
	{
	status = c_cmhost(xid_planes[plane_idx].filename,hname);
	if (status != E_SUCC)
	    {
	    xid_message("Error retrieving host file name");
	    return;
	    }
	}
    else
	strcpy(hname,xid_planes[plane_idx].filename);
    }
else
    {
    if (xid_planes[plane_idx].image_type == LAS)
	{
	status = c_cmhost(xid_graphics.lname_gof,hname);
	if (status != E_SUCC)
	    {
	    xid_message("Error retrieving host file name");
	    return;
	    }
	}
    else
	strcpy(hname,xid_graphics.lname_gof);
    }

if ((xid_graphics.flags & GR_SELECT) || (xid_graphics.flags & GR_LOAD) || 
    (xid_graphics.flags & GR_EDIT))
    {
/*
    Open the GOF with the proper access mode.
*/
    if ((xid_graphics.flags & GR_SELECT) || (xid_graphics.flags & GR_EDIT))
	access = APPEND;
    else
	access = READ;
    status = c_gofopn(&xid_graphics.fd,hname,lasname,goftyp,&access,&cflag);
    if (status != E_SUCC)
	{
	xid_message("Error opening GOF");
	xid_graphics.fd = -1;
	}
    if (xid_planes[plane_idx].image_type == LAS)
	strcpy(xid_graphics.lname_gof,lasname);
    else
	strcpy(xid_graphics.lname_gof,hname);
    }
/*
   Set up the GOF extension based on the type specified.
*/
else
    {
    sprintf(ext,"GOF%c%s",GOF_SEP,goftyp);
    length = strlen(ext);
    c_up2low(ext,&length);

/*
   Get the associated file name.
*/
    c_lsmknm(hname,ext,hostnam);
    if (xid_planes[plane_idx].image_type == LAS)
        c_cmtae(hostnam,xid_graphics.lname_gof);
    else
	strcpy(xid_graphics.lname_gof,hostnam);
    }
/*
    Set the GOF name on the graphics panel.
*/
XmTextSetString(graphics_gof_text,xid_graphics.lname_gof);

if (xid_graphics.flags & GR_SELECT)
    {
/*
    Increment the current graphics element index if a current element exists
    and it has not been cancelled.
*/
    if ((xid_element[xid_graphics.current].type != NO_TYPE) && 
	(!(xid_graphics.flags & GR_CANCEL))) 
	{
	xid_graphics.current++;
	if (xid_graphics.current >= xid_graphics.max_element)
	    {
	    status = graphics_realloc();
	    if (status != XID_S)
		return;
	    }
	}
    else if (xid_graphics.flags & GR_CANCEL)
	{
/*
    Reset the type and label of a cancelled element.
*/
	xid_element[xid_graphics.current].type = xid_graphics.type;
	strcpy(xid_element[xid_graphics.current].label,"");
	}
/*
    Reset variables.
*/
    xid_graphics.temp_num = 0;
    xid_graphics.first = (struct PT_LIST *)NULL;
    xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx = 
	xid_graphics.prevy = -1;
    }
else if (xid_graphics.flags & GR_LOAD)
/*
    Load and display specified GOF.
*/
    graphics_mode(w, "L", call);

/*
    Reset the close flag.
*/
xid_graphics.flags &= ~GR_CLOSE;
}

void
graphics_update(win,plane_idx)
long	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image. (I)		      */
	win;			/* Window to draw into. (I)
					0 - Main image window
					1 - Full resolution window
					2 - Zoom window 		      */

/*******************************************************************************
Purpose:
	This routine redraws and currently displayed graphics data in the
	specified windows.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long	i,			/* Looping index.			      */
	maxx,			/* Maximum X coordinate.		      */
	maxy,			/* Maximum Y coordinate.		      */
	minx,			/* Minimum X coordinate.		      */
	miny,			/* Minimum Y coordinate.		      */
	num_elements;		/* Number of graphics elements to draw.	      */

/*
    Set the minimum and maximum X and Y values for clipping the graphics data.
*/
if (win == 0)
    {
    minx = xid_planes[plane_idx].window[SS];
    miny = xid_planes[plane_idx].window[SL];
    maxx = xid_planes[plane_idx].window[SS] + xid_planes[plane_idx].window[NS]
	- 1;
    maxy = xid_planes[plane_idx].window[SL] + xid_planes[plane_idx].window[NL]
	- 1;
    }
else if (win == 1)
    {
    minx = xid_fullres[0].window[SS];
    miny = xid_fullres[0].window[SL];
    maxx = xid_fullres[0].window[SS] + xid_fullres[0].window[NS] - 1;
    maxy = xid_fullres[0].window[SL] + xid_fullres[0].window[NL] - 1;
    }
else if (win == 2)
    {
    minx = xid_zoom.window[SS]; 
    miny = xid_zoom.window[SL]; 
    maxx = xid_zoom.window[SS] + xid_zoom.window[NS] - 1; 
    maxy = xid_zoom.window[SL] + xid_zoom.window[NL] - 1; 
    }

/*
    Determine the number of elements to be drawn.
*/
if (xid_graphics.flags & GR_CLOSE)
    num_elements = xid_graphics.current + 1;
else
    num_elements = xid_graphics.current;

/*
    Draw each graphics element that falls within the bounds of the specified
    window.
*/
for (i=0; i < num_elements; i++)
    {
    if ((xid_element[i].upleft[0] < maxx) || (xid_element[i].loright[0] > minx)
	|| (xid_element[i].upleft[1] < maxy) || (xid_element[i].loright[1]
	> miny))
	    graphics_draw(win,plane_idx,i);
    }

/*
    Clear the specified window to force an expose event.
*/
if (win == 0)
    XClearArea(xid.display,XtWindow(main_image_bulletinboard),0,0,
	xid_planes[plane_idx].window[NS],xid_planes[plane_idx].window[NL],True);
else if (win == 1)
    XClearArea(xid.display,XtWindow(fullres_win_bulletinboard),0,
	0,xid_fullres[0].window[NS],xid_fullres[0].window[NL],True);
else if (win == 2)
    XClearArea(xid.display,XtWindow(zoom_win_bulletinboard),0,
	0,xid_zoom.parms.factor * xid_zoom.parms.in_samps,
	xid_zoom.parms.factor * xid_zoom.parms.in_lines,True);
}

/* ARGSUSED */
void
setatt_dismiss(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine closes the "set attributes" panel. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long		i;		/* Looping index.			      */

/*
    Set all attribute values to NULL in the general graphics structure.
*/
for (i=0; i < MAXATT; i++)
    strcpy(xid_graphics.attr_values[i],"");

/*
    Close the panel.
*/
XtSetSensitive(graphics_setatt_button,True);
XtSetSensitive(graphics_defatt_button,True);
XtUnmanageChild(Setatt_form);
XtDestroyWidget(Setatt_form);
XtPopdown(Shell_Setatt);
XtUnrealizeWidget(Shell_Setatt);
}

/* ARGSUSED */
void
defatt_dismiss(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine closes the "define attributes" panel. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
/*
    Close the panel.
*/
XtSetSensitive(graphics_defatt_button,True);
XtSetSensitive(graphics_setatt_button,True);
XtUnmanageChild(Defatt_form);
XtDestroyWidget(Defatt_form);
XtPopdown(Shell_Defatt);
XtUnrealizeWidget(Shell_Defatt);
}

/* ARGSUSED */
void
defatt_ok(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine retrieves the user specified attribute name and data type
    and writes it to the current GOF.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long	defatt_write(),		/* Routine to write a graphics attribute
				   to a GOF.				      */
	index,			/* Attribute index.			      */
	length,			/* Character string length.		      */
	state,			/* Current toggle button state.		      */
	status;			/* Status indicator.			      */

char    *attrbnam, 		/* User defined attribute name.    	      */
	dtype[4],		/* Data type of specified attribute.	      */
	mesg[80];               /* Error message text.                        */


/*
    Get the user specified attribute name and verify its length. 
*/
attrbnam = XmTextGetString(defatt_name_text);
if (strlen(attrbnam) > (ATTNAM - 1))
    {
    XtFree(attrbnam);
    sprintf(mesg,"Attribute name may not consist of more than %d characters",
	ATTNAM-1);
    xid_message(mesg);
    return;
    }

/*
    Make sure a name was entered.
*/
if (strlen(attrbnam) == 0)
    {
    xid_message("Enter an attribute name before pressing OK");
    return;
    }

/*
    Convert attribute name to upper case.
*/
length = strlen(attrbnam);
c_low2up(attrbnam,&length);

/*
    Get the user specified attribute data type.
*/
state = XmToggleButtonGetState(defatt_ascii_toggle);
if (state)
    strcpy(dtype,"CHA");
else
    {
    state = XmToggleButtonGetState(defatt_int_toggle);
    if (state)
        strcpy(dtype,"INT");
    else
	{
        state = XmToggleButtonGetState(defatt_real_toggle);
        if (state)
            strcpy(dtype,"REA");
	}
    }

/*
    Write the new attribute to the GOF.
*/
status = defatt_write(attrbnam,dtype,&index,TRUE);
if (status != XID_S)
    {
    XtFree(attrbnam);
    return;
    }

/*
    Free the attribute name string.
*/
XtFree(attrbnam);
}

/* ARGSUSED */
long
defatt_write(attrbnam,dtype,index,flag)
char	*attrbnam,		/* Attribute name. (I)			      */
	*dtype;			/* Attribute data type. (I)		      */

long	*index,			/* Attribute index. (O)			      */
	flag;			/* Indicates whether or not duplicate attribute
				   names are an error. (I)		      */

/*******************************************************************************
Purpose:
    This routine writes the input attribute name to the current GOF.  An
    error occurs if the attribute already exists in the GOF or if there are
    no more free attributes.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
union   GOF     header;         /* Header record structure.         	      */

long	addrec = FALSE,         /* Add record flag.                 	      */
        free_idx,               /* Index of the first free attribute.	      */
	i,			/* Looping index.			      */
	nbytes,                 /* Number of bytes actually read.   	      */
	next,			/* Number of bytes to next record.	      */
	status,			/* Status indicator.			      */
	type = HDR;		/* Type of GOF record to read.         	      */

char    mesg[80];               /* Error message text.                        */


/*
    Reset the file pointer to the beginning of the file.
*/
lseek (xid_graphics.fd,0,0);

/*
    Read the header record from the GOF.
*/
status = c_gofrd(&xid_graphics.fd,&nbytes,&next,&type,&header);
if (status != E_SUCC)
    {
    xid_message("Error reading GOF");
    return(XID_F);
    }
/*
    Make sure specified attribute name is not the same as any previously
    defined attribute names and that there are enough free attributes.
*/
for (i=0,free_idx = -1; i < MAXATT; i++)
    {
    if (header.hdrec.mask[i] != 0) 
	{
	if (header.hdrec.mask[i] == strlen(attrbnam))
	    if (strcmp(header.hdrec.attrb[i],attrbnam) == 0)
		{
		if (flag)
		    {
		    sprintf (mesg,"Attribute %s is not unique",attrbnam);
		    xid_message(mesg);
		    return(XID_F);
		    }
		else
		    {
		    *index = i;
		    return(XID_S);
		    }
		}
	}
    else
	if (free_idx < 0) *index = free_idx = i;
    }
if (free_idx < 0)
    {
    if (flag)
	{
	sprintf (mesg,"Maximum number of attributes exceeded");
	xid_message("Maximum number of attributes exceeded");
	}
    return(XID_F);
    }
else
    {
    header.hdrec.mask[free_idx] = strlen(attrbnam);
    strcpy (header.hdrec.attrb[free_idx],attrbnam);
    strcpy (header.hdrec.attyp[free_idx],dtype);
    }

/*
   Write the record to the graphics overlay file 
*/
lseek (xid_graphics.fd,0,0);
status = c_gofwr(&xid_graphics.fd,&next,&type,&header,&addrec);
if (status != E_SUCC)
    {
    xid_message("Error writing to GOF");
    return(XID_F);
    }
return(XID_S);
}

/* ARGSUSED */
void
graphics_destroy(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine closes the graphics panel. 
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
void   graphics_editwarn();
                        /* Function to warn the user changes have not been 
			   saved to GOF.                         	      */

int	status;		/* Status indicator.				      */

/*
    The graphics panel cannot be closed if the user is currently editting a
    graphics element.
*/
if (xid_graphics.flags & GR_EDIT)
    {
    if ((xid_editgraph.newx != -1) && (xid_editgraph.flags & GR_MOVE))
	{
	xid_message("User must place current point before exiting");
	return;
	}
    if (xid_graphics.flags & GR_LABEL)
	{
	xid_message("User must place label/text before exiting");
	return;
	}
    }

/*
    Warn the user if current modifications have not been saved to the GOF.
*/
if ((xid_graphics.flags & GR_EDIT) && (!(xid_editgraph.writeflg)) &&
    (xid_editgraph.flags & GR_MODIFY))
    {
    XBell(xid.display,0);
    graphics_editwarn(0,"G");
    return;
    }

/*
    The graphics panel cannot be closed if the user is currently selecting a
    graphics element.
*/
if ((xid_graphics.type != NO_TYPE) && (xid_graphics.flags & GR_SELECT))
    {
    if ((xid_graphics.temp_num != 0) || (xid_graphics.flags & GR_LABEL))
        {
        xid_message("User must cancel or finish selection of current element before exiting");
        return;
        }
/*
    Save the current element to the GOF and close the GOF.
*/
    if ((xid_element[xid_graphics.current].type == POINT) && (!(xid_element[
	xid_graphics.current].writeflg)) && (xid_element[xid_graphics.current]
	.x != -1))
	{
	graphics_gofwrite();
	xid_element[xid_graphics.current].writeflg = TRUE;
	xid_graphics.current++;
	if (xid_graphics.current >= xid_graphics.max_element)
	    {
	    status = graphics_realloc();
	    if (status != XID_S)
		return;
	    }
	}
    if ((!(xid_element[xid_graphics.current].writeflg)) && (xid_element[
	xid_graphics.current].graph_ptr != NULL))
	{
	graphics_gofwrite();
	xid_element[xid_graphics.current].writeflg = TRUE;
	xid_graphics.current++;
	if (xid_graphics.current >= xid_graphics.max_element)
	    {
	    status = graphics_realloc();
	    if (status != XID_S)
		return;
	    }
	}
    if (xid_graphics.fd != -1)
        c_gofcls(&xid_graphics.fd);
    }

/*
    Close the "graphics edit" panel.
*/
if (xid_graphics.flags & GR_EDIT)
    edit_destroy(w,client,call);

/*
    Remove the "graphics select" context.
*/
if (xid_graphics.flags & GR_SELECT)
    xid_contextdel(CON_GRSEL);

/*
    Reset globals and flags and remove any event handlers no longer needed.
*/
xid_graphics.flags = xid_graphics.flags ^ GR_ACTIVE;
xid_editgraph.flags |= ~(GR_SELECT | GR_ADD | GR_MOVE | GR_DELETE);
xid_editgraph.current = -1;
xid_editgraph.current = FALSE;

XtRemoveEventHandler(main_image_bulletinboard,LeaveWindowMask|EnterWindowMask,
    FALSE,graphics_focus,NULL);
XtRemoveEventHandler(fullres_win_bulletinboard,LeaveWindowMask| 
    EnterWindowMask,FALSE,graphics_focus,NULL);
XtRemoveEventHandler(zoom_win_bulletinboard,LeaveWindowMask|EnterWindowMask,
    FALSE,graphics_focus,NULL);

/*
    Close the "set attributes" panel.
*/
if (XtIsRealized(Shell_Setatt))
    {
    XtUnmanageChild(Setatt_form);
    XtDestroyWidget(Setatt_form);
    XtPopdown(Shell_Setatt);
    XtUnrealizeWidget(Shell_Setatt);
    }

/*
    Close the "define attributes" panel.
*/
if (XtIsRealized(Shell_Defatt))
    {
    XtUnmanageChild(Defatt_form);
    XtDestroyWidget(Defatt_form);
    XtPopdown(Shell_Defatt);
    XtUnrealizeWidget(Shell_Defatt);
    }

/*
    Close the "graphics" panel.
*/
XtUnmanageChild(graphics_form);
XtDestroyWidget(graphics_form);
XtDestroyWidget(graphics_edit_popup);
XtPopdown(Shell_Graphics);
XtSetSensitive(main_graphics_button,True);
}

/* ARGSUSED */
void
graphics_focus(w, client, call)
Widget w;
XtPointer client;
XtPointer call;

/*******************************************************************************
Purpose:
    This routine is called any time an image window is given focus or loses 
    focus. When an image window loses focus, any correctly displayed rubber-
    band lines or rectangles are erased.  When an image window is given focus,
    the appropriate variables are set such that any rubber-band lines or 
    rectangles are redrawn.
 								
By L. Huewe, USGS/EROS Data Center, 7/92

Algorithm Description:
*******************************************************************************/
{
long	height,			/* Rectangle height.			      */
	width;			/* Rectangle width.			      */

/*SUPPRESS 594*/XCrossingEvent *acs=(XCrossingEvent *)call;

if (acs->type == LeaveNotify)
    {
/*
    Set appropriate values in the GC.
*/
    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
	JoinMiter);
    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
    XSetFunction(xid.display,xid_graphics.gc,GXxor);
/*
    Erase any rubber-band lines or rectangles.
*/
    if ((xid_graphics.selectx != -1) && (xid_graphics.prevx != -1) && 
	(xid_graphics.flags & GR_SELECT))
	{
	if (xid_graphics.type == RECT)
	    {
	    width = xid_graphics.prevx - xid_graphics.selectx;
	    height = xid_graphics.prevy - xid_graphics.selecty;
	    XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		selectx,xid_graphics.selecty,width,height);
	    }
	else
	    XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_graphics.
		selectx,xid_graphics.selecty,xid_graphics.prevx,xid_graphics.
		prevy);
	xid_graphics.prevx = xid_graphics.prevy = -1;
	}
/*
    Erase the label or annotation text rectangle.
*/
    if ((xid_label.x != -1) && (xid_label.y != -1))
	{
	XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,xid_label.x,
	    xid_label.y,xid_label.width,xid_label.height);
	xid_label.x = xid_label.y = -1;
	}
    if (xid_editgraph.flags & GR_MOVE)
	{
	if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	    {
    /*
	Erase the rubber-band lines.
    */
	    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
		JoinMiter);
	    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	    XSetFunction(xid.display,xid_graphics.gc,GXxor);
	    if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
		(xid_editgraph.vert != -1))
		XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
		    prevx,xid_editgraph.prevy,xid_editgraph.newx,xid_editgraph.
		    newy);
	    if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) &&
		(xid_editgraph.vert != -1))
		XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
		    nextx,xid_editgraph.nexty,xid_editgraph.newx,xid_editgraph.
		    newy);
	    xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx
		= xid_editgraph.nexty = -1;
	    }
/*
    Erase rubber-band rectangle.
*/
	else if (xid_graphics.type == RECT)
	    {
	    if ((xid_editgraph.new_ulx != -1) && (xid_editgraph.new_uly != -1)
		&& (xid_editgraph.width != -1) && (xid_editgraph.height != -1))
		XDrawRectangle(xid.display,XtWindow(w),xid_graphics.gc,
		    xid_editgraph.new_ulx,xid_editgraph.new_uly,xid_editgraph.
		    width,xid_editgraph.height);
	    xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx
		= xid_editgraph.nexty = xid_editgraph.new_ulx = xid_editgraph.
		new_uly = xid_editgraph.width = xid_editgraph.height = -1;
	    }
	}
    if (xid_editgraph.flags & GR_ADD)
	{
	if ((xid_graphics.type == POLY) || (xid_graphics.type == LINE))
	    {
    /*
	Erase the rubber-band lines.
    */
	    XSetLineAttributes(xid.display,xid_graphics.gc,2,LineSolid,CapButt,
		JoinMiter);
	    XSetForeground(xid.display,xid_graphics.gc,xid_graphics.rb_fore);
	    XSetFunction(xid.display,xid_graphics.gc,GXxor);
	    if ((xid_editgraph.newx != -1) && (xid_editgraph.prevx != -1) &&
		(xid_editgraph.vert != -1))
		{
		XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
		    prevx,xid_editgraph.prevy,xid_editgraph.newx,xid_editgraph.
		    newy);
		xid_editgraph.prevx = xid_editgraph.prevy = -1;
		}
	    if ((xid_editgraph.newx != -1) && (xid_editgraph.nextx != -1) &&
		(xid_editgraph.vert != -1))
		{
		XDrawLine(xid.display,XtWindow(w),xid_graphics.gc,xid_editgraph.
		    nextx,xid_editgraph.nexty,xid_editgraph.newx,xid_editgraph.
		    newy);
		xid_editgraph.nextx = xid_editgraph.nexty = -1;
		}
	    }
	}
    }
else if (acs->type == EnterNotify)
    {
    if (w != xid_graphics.window)
	{
	xid_graphics.window = w;
	xid_graphics.selectx = xid_graphics.selecty = xid_graphics.prevx = 
	    xid_graphics.prevy = -1;
	xid_editgraph.prevx = xid_editgraph.prevy = xid_editgraph.nextx =
	    xid_editgraph.nexty = -1;
        }
    }
}

/* ARGSUSED */
long
graphics_duplicate(offset,type)
long	offset,			/* Offset to be checked.  (I)		      */
	type;			/* Graphics type to check.  (I)		      */

/*******************************************************************************
Purpose:
	This routine determines whether or not the input offset matches that
	of any previously loaded graphics element.
 								
By L. Huewe, USGS/EROS Data Center

Algorithm Description:

Known Bugs:
    The only information that is stored for each graphics element is the 
    offset into the file; the file name is not stored.  Therefore, this 
    routine will return TRUE if the offsets match even if the elements are 
    from different files.
*******************************************************************************/
{
long	i;			/* Looping variable.		              */

/*
    Look for a matching offset.
*/
for (i=0; i < xid_graphics.current; i++)
    {
    if ((xid_element[i].type == type) && (xid_element[i].offset == offset))
	return(TRUE);
    }
return(FALSE);
}

long
graphics_drawpoint(w,win,event_x,event_y,plane_idx,xfil,yfil)
Widget	w;			/* Widget ID.  (I)			      */

float 	xfil,           	/* X file coordinate. (I)                     */
	yfil;           	/* Y file coordinate. (I)                     */

int	event_x,		/* X coordinate of mouse. (I)		      */
	event_y;		/* Y coordinate of mouse. (I)		      */

long	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine draws the point into the appropriate window and
    pixmap in the specified color.

By L. Huewe, USGS/EROS Data Center, 11/92

Algorithm Description:
*******************************************************************************/
{
Pixel   pixelval;       	/* Pixel value of selected color.             */

Boolean argok;          	/* Status indicator.                          */

long    current_idx,		/* Index of current graphics element.	      */
	xwin,           	/* Window X coordinate.                       */
        ywin;           	/* Window Y coordinate.                       */

/*
    Set the appropriate graphics index based on the mode.
*/
if (xid_graphics.flags & GR_SELECT)
    current_idx = xid_graphics.current;
else if (xid_graphics.flags & GR_EDIT)
    current_idx = xid_editgraph.current;

/*
    Set the current graphics color.
*/
xid_graphics.color = xid_element[current_idx].color;

/*
    Draw the point in the color selected.
*/

/*
    Set the appropriate color and line attributes in the GC.
*/
pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[xid_element
    [current_idx].color], "Pixel", 0, &argok);
XSetForeground(xid.display,xid_graphics.gc, pixelval);
XSetFunction(xid.display,xid_graphics.gc,GXcopy);
XSetLineAttributes(xid.display,xid_graphics.gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);

/*
    Draw the point directly to the window.
*/
XDrawPoint(xid.display,XtWindow(w),xid_graphics.gc,event_x,event_y);

/*
    Draw the point into the appropriate bitmap.
*/
XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);
if (win == 0)
    XDrawPoint(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,event_x,event_y);
else if (win == 1)
    XDrawPoint(xid.display,xid_graphics.full_pix[xid_graphics.color],
	xid_graphics.rb_gc,event_x,event_y);
else if (win == 2)
    XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	xid_graphics.rb_gc,event_x,event_y);

/*
    Draw the point into the main image window if the current point was selected 
    from another window.
*/
pixelval = (Pixel)CONVERT(Shell_Graphics, xid_graphics.colors[xid_element
    [current_idx].color], "Pixel", 0, &argok);
XSetForeground(xid.display,xid_graphics.gc, pixelval);
XSetFunction(xid.display,xid_graphics.gc,GXcopy);
XSetLineAttributes(xid.display,xid_graphics.gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);
XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);

if (win != 0)
    {
/*
    Convert the file coordinate to a main image window coordinate.
*/
    xid_file2win(plane_idx,0,xfil,yfil,&xwin,&ywin);
    XDrawPoint(xid.display,XtWindow(main_image_bulletinboard),xid_graphics.gc,
	xwin,ywin);
/*
    Draw the point into the appropriate bitmap.
*/
    XDrawPoint(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin);
    }

/*
    Draw the point into the full resolution image window if it exists and if 
    the current point was selected from another window.
*/
if ((win != 1) && (xid_fullres != NULL) && (xid_fullres[0].image_pixmap != 
    NULL))
    {
/*
    Convert the file coordinate to a full resolution window coordinate.
*/
    xid_file2win(plane_idx,1,xfil,yfil,&xwin,&ywin);
    XDrawPoint(xid.display,XtWindow(fullres_win_bulletinboard),xid_graphics.gc,
	xwin,ywin);
/*
    Draw the point into the appropriate bitmap.
*/
    XDrawPoint(xid.display,xid_graphics.full_pix[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin);
    }
/*
    Draw the point into the zoomed window if it exists and if the current point 
    was selected from another window.
*/
if ((win != 2) && (xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != 
    NULL))
    {
/*
    Convert the file coordinate to a zoomed window coordinate.
*/
    xid_file2win(plane_idx,2,xfil,yfil,&xwin,&ywin);
    XDrawPoint(xid.display,XtWindow(zoom_win_bulletinboard),xid_graphics.gc,
	xwin,ywin);
/*
    Draw the point into the appropriate bitmap.
*/
    XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin);
    }
return(XID_S);
}

void
graphics_deletepoint(win,element,plane_idx)
long	element,		/* Index of point to erase. (I)		      */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine erases a point from the appropriate windows and pixmaps. 
 								
By L. Huewe, USGS/EROS Data Center, 11/92

Algorithm Description:
*******************************************************************************/
{
void    graphics_expose_area(); /* Function to trigger an expose event of the
                                   area around a given graphics element.      */

long    xwin,           	/* Window X coordinate.                       */
        ywin;           	/* Window Y coordinate.                       */

/*
    Set the current graphics color.
*/
xid_graphics.color = xid_element[element].color;

/*
    Erase the point from the bitmap.  graphics_expose_area is called to clear 
    the affected rectangle which forces an expose event.
*/

/*
    Convert the file coordinates to the main image window coordinates.
*/
xid_file2win(plane_idx,0,xid_element[element].x,xid_element[element].y,
    &xwin,&ywin);
XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);
XSetBackground(xid.display,xid_graphics.rb_gc,0);
XSetForeground(xid.display,xid_graphics.rb_gc,0);

/*
    Erase the point.
*/
XDrawPoint(xid.display,xid_graphics.pixmap[xid_graphics.color],
    xid_graphics.rb_gc,xwin,ywin); 
XSetBackground(xid.display,xid_graphics.rb_gc,1);
XSetForeground(xid.display,xid_graphics.rb_gc,1);

/*
    Clear the bounding rectangle of the point erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The point has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
graphics_expose_area(0,element,plane_idx);

/*
    Reset the currently selected point (window coordinates).
*/
if (win == 0)
    {
    xid_graphics.selectx = xwin;
    xid_graphics.selecty = ywin;
    }

/*
    Erase the point from the full resolution image window.
*/
if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
    {
/*
    Convert the file coordinates to full resolution window coordinates.
*/
    xid_file2win(plane_idx,1,xid_element[element].x,xid_element[element].y,
	&xwin,&ywin);
    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the point.
*/
    XDrawPoint(xid.display,xid_graphics.full_pix[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin); 
    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);
/*
    Clear the bounding rectangle of the point erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The point has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
graphics_expose_area(1,element,plane_idx);

/*
    Reset the currently selected point (window coordinates).
*/
    if (win == 1)
	{
	xid_graphics.selectx = xwin;
	xid_graphics.selecty = ywin;
	}
    }
/*
    Erase the point from the zoomed window.
*/
if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
    {
/*
    Convert the file coordinates to zoom window coordinates.
*/
    xid_file2win(plane_idx,2,xid_element[element].x,xid_element[element].y,
	&xwin,&ywin);
    XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
	line_width,LineSolid,CapButt,JoinMiter);
    XSetBackground(xid.display,xid_graphics.rb_gc,0);
    XSetForeground(xid.display,xid_graphics.rb_gc,0);
/*
    Erase the point.
*/
    XDrawPoint(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin); 
    XSetBackground(xid.display,xid_graphics.rb_gc,1);
    XSetForeground(xid.display,xid_graphics.rb_gc,1);
/*
    Clear the bounding rectangle of the point erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The point has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
graphics_expose_area(2,element,plane_idx);

/*
    Reset the currently selected point (window coordinates).
*/
    if (win == 2)
	{
	xid_graphics.selectx = xwin;
	xid_graphics.selecty = ywin;
	}
    }
return;
}

void
graphics_deletestring(win,plane_idx,element)
long	element,		/* Graphics element index of text string to
				   delete.  (I)				      */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine erases a text string from the appropriate windows and pixmaps. 
 								
By L. Huewe, USGS/EROS Data Center, 11/92

Algorithm Description:
*******************************************************************************/
{
void    graphics_expose_area(); /* Function to trigger an expose event of the
                                   area around a given graphics element.      */

struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

long	xwin,                   /* Window X coordinate.                       */
        ywin;                   /* Window Y coordinate.                       */

char    *string;                /* Label or annotation string.                */
 
/*
    Get the annotation text or label.
*/
if (xid_element[element].type == TEXT)
    {
    aptr = (struct ANNOT_ELEMENT *)xid_element[element].graph_ptr;
    string = malloc(strlen(aptr->string) + 1);
    if (string == NULL)
        {
        xid_message("Insufficient amount of memory available");
        return;
        }
    strcpy(string,aptr->string);
    }
else
    {
    string = malloc(strlen(xid_element[element].label)+1);
    if (string == NULL)
        {
        xid_message("Insufficient amount of memory available");
        return;
        }
    strcpy(string,xid_element[element].label);
    }

/*
    Set the appropriate values in the GC.
*/
XSetBackground(xid.display,xid_graphics.rb_gc,0);
XSetForeground(xid.display,xid_graphics.rb_gc,0);
XSetFont(xid.display,xid_graphics.rb_gc,xid_graphics.font_info[xid_element[
    element].font]->fid);

/*
    Erase the annotation text or label from the main window.
*/
xid_file2win(plane_idx,0,xid_element[element].labelx,
    xid_element[element].labely,&xwin,&ywin);
XDrawString(xid.display,xid_graphics.pixmap[xid_graphics.color],
    xid_graphics.rb_gc,xwin,ywin + xid_graphics.font_info[
    xid_graphics.font]->max_bounds.ascent,string,strlen(string));

/*
    Erase the annotation text or label from the full resolution window.
*/
if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
    {
    xid_file2win(plane_idx,1,xid_element[element].labelx,
	xid_element[element].labely,&xwin,&ywin);
    XDrawString(xid.display,xid_graphics.full_pix[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin + xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,strlen(string));
    }

/*
    Erase the annotation text or label from the zoom window.
*/
if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
    {
    xid_file2win(plane_idx,2,xid_element[element].labelx,
	xid_element[element].labely,&xwin,&ywin);
    XDrawString(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin + xid_graphics.font_info[
	xid_graphics.font]->max_bounds.ascent,string,strlen(string));
    }

/*
    Reset GC foreground and background values.
*/
XSetBackground(xid.display,xid_graphics.rb_gc,1);
XSetForeground(xid.display,xid_graphics.rb_gc,1);

/*
    Clear the bounding rectangle of the graphics element erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The text has been deleted from the bitmap so it no longer is displayed 
    after the expose event.
*/
graphics_expose_area(0,element,plane_idx);

/*
    Clear the bounding rectangle of the graphics element erased.  This causes 
    an expose event which in turn copies the graphics bitmaps to the window.  
    The line segment has been deleted from the bitmap so it no longer is 
    displayed after the expose event.
*/
if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
    graphics_expose_area(1,element,plane_idx);

/*
    Clear the bounding rectangle of the graphics element erased.  This causes 
    an expose event which in turn copies the graphics bitmaps to the 
    window.  The line segment has been deleted from the bitmap so it no longer 
    is displayed after the expose event.
*/
if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
    graphics_expose_area(2,element,plane_idx);
}

void
graphics_deletelinepoly(win,element,plane_idx)
long	element,		/* Index of point to erase. (I)		      */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine erases a line or polygon from the appropriate windows and 
    pixmaps. 
 								
By L. Huewe, USGS/EROS Data Center, 11/92

Algorithm Description:
*******************************************************************************/
{
void    graphics_expose_area(); /* Function to trigger an expose event of the
                                   area around a given graphics element.      */

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

float	*xcoords,		/* Pointer to X coordinates.		      */
	*ycoords;		/* Pointer to Y coordinates.		      */

long    i,			/* Looping index.			      */
	num_vert,		/* Number of vertices.			      */
	xwin,           	/* Window X coordinate.                       */
	x1win,           	/* Window X coordinate.                       */
        ywin,           	/* Window Y coordinate.                       */
        y1win;           	/* Window Y coordinate.                       */

/*
    Set the current graphics color.
*/
xid_graphics.color = xid_element[element].color;

/*
    Erase the line or polygon from the bitmap.  graphics_expose_area is called 
    to clear the affected rectangle which forces an expose event.
*/
if ((xid_element[element].type == POLY) || (xid_element[element].type == RECT))
    {
    pptr = (struct POLY_ELEMENT *)xid_element[element].graph_ptr;
    num_vert = pptr->num_vert;
    xcoords = pptr->x;
    ycoords = pptr->y;
    }
else if (xid_element[element].type == LINE)
    {
    lptr = (struct LINE_ELEMENT *)xid_element[element].graph_ptr;
    num_vert = lptr->num_vert;
    xcoords = lptr->x;
    ycoords = lptr->y;
    }

/*
    Set the appropriate values in the GC.
*/
XSetLineAttributes(xid.display,xid_graphics.rb_gc,xid_graphics.
    line_width,LineSolid,CapButt,JoinMiter);
XSetBackground(xid.display,xid_graphics.rb_gc,0);
XSetForeground(xid.display,xid_graphics.rb_gc,0);

for (i=0; i < num_vert; i++)
    {
/*
    Convert the file coordinates to the main image window coordinates.
*/
    xid_file2win(plane_idx,0,xcoords[i],ycoords[i],&xwin,&ywin);
    if ((i == num_vert-1) && ((xid_element[element].type == POLY) || 
	(xid_element[element].type == RECT)))
        xid_file2win(plane_idx,0,xcoords[0],ycoords[0],&x1win,&y1win);
    else if ((i == num_vert-1) && (xid_element[element].type == LINE))
	break;
    else
        xid_file2win(plane_idx,0,xcoords[i+1],ycoords[i+1],&x1win,&y1win);
/*
    Erase the line segment.
*/
    XDrawLine(xid.display,xid_graphics.pixmap[xid_graphics.color],
	xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
    }

xid_file2win(plane_idx,0,xid_element[element].upleft[0],xid_element[element].
    upleft[1],&xwin,&ywin);
/*
    Clear the bounding rectangle of the element erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line or polygon has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
graphics_expose_area(0,element,plane_idx);

/*
    Reset the currently selected point (window coordinates).
*/
if (win == 0)
    {
    xid_graphics.selectx = xwin;
    xid_graphics.selecty = ywin;
    }

/*
    Erase the line or polygon from the full resolution image window.
*/
if ((xid_fullres != NULL) && (xid_fullres[0].image_pixmap != NULL))
    {
    for (i=0; i < num_vert; i++)
	{
/*
    Convert the file coordinates to the full resolution image window 
    coordinates.
*/
	xid_file2win(plane_idx,1,xcoords[i],ycoords[i],&xwin,&ywin);
	if ((i == num_vert-1) && ((xid_element[element].type == POLY) ||
	    (xid_element[element].type == RECT)))
	    xid_file2win(plane_idx,1,xcoords[0],ycoords[0],&x1win,&y1win);
	else if ((i == num_vert-1) && (xid_element[element].type == LINE))
	    break;
	else
	    xid_file2win(plane_idx,1,xcoords[i+1],ycoords[i+1],&x1win,&y1win);
/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.full_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	}
    xid_file2win(plane_idx,1,xid_element[element].upleft[0],
	xid_element[element].upleft[1],&xwin,&ywin);
/*
    Clear the bounding rectangle of the element erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line or polygon has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
    graphics_expose_area(1,element,plane_idx);

/*
    Reset the currently selected point (window coordinates).
*/
    if (win == 1)
	{
	xid_graphics.selectx = xwin;
	xid_graphics.selecty = ywin;
	}
    }
/*
    Erase the point from the zoomed window.
*/
if ((xid_zoom.flags & ZOOM_ACTIVE) && (xid_zoom.image_pixmap != NULL))
    {
    for (i=0; i < num_vert; i++)
	{
/*
    Convert the file coordinates to the zoomed image window coordinates.
*/
	xid_file2win(plane_idx,2,xcoords[i],ycoords[i],&xwin,&ywin);
	if ((i == num_vert-1) && ((xid_element[element].type == POLY) ||
	    (xid_element[element].type == RECT)))
	    xid_file2win(plane_idx,2,xcoords[0],ycoords[0],&x1win,&y1win);
	else if ((i == num_vert-1) && (xid_element[element].type == LINE))
	    break;
	else
	    xid_file2win(plane_idx,2,xcoords[i+1],ycoords[i+1],&x1win,&y1win);
/*
    Erase the line segment.
*/
	XDrawLine(xid.display,xid_graphics.zoom_pix[xid_graphics.color],
	    xid_graphics.rb_gc,xwin,ywin,x1win,y1win); 
	}
    xid_file2win(plane_idx,2,xid_element[element].upleft[0],
	xid_element[element].upleft[1],&xwin,&ywin);
/*
    Clear the bounding rectangle of the element erased.  This causes
    an expose event which in turn copies the graphics bitmaps to the window.
    The line or polygon has been deleted from the bitmap so it no longer is
    displayed after the expose event.
*/
    graphics_expose_area(2,element,plane_idx);

/*
    Reset the currently selected point (window coordinates).
*/
    if (win == 2)
	{
	xid_graphics.selectx = xwin;
	xid_graphics.selecty = ywin;
	}
    }

/*
    Reset the foreground and background values in the GC.
*/
XSetBackground(xid.display,xid_graphics.rb_gc,1);
XSetForeground(xid.display,xid_graphics.rb_gc,1);
return;
}

void
graphics_expose_area(win,element,plane_idx)
long	element,		/* Index of graphics element defining the
				   area to expose. (I)			      */
	plane_idx,		/* Index into memory plane structure of the 
				   currently viewed image.  (I)		      */
	win;			/* Type of window. (I)
				    -1 - All displayed windows.
				     0 - Main image window.
				     1 - Full resolution window.
				     2 - Zoomed window.			      */

/*******************************************************************************
Purpose:
    This routine forces an expose event over an area defined by the graphics
    element specified thereby updating the graphics information within that 
    area.
 								
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
*******************************************************************************/
{
long	height,			/* Height of area to clear.		      */
	maxx,			/* Maximum X value.			      */
	maxy,			/* Maximum Y value.			      */
	minx,			/* Minimum X value.			      */
	miny,			/* Minimum Y value.			      */
	width;			/* Width of area to clear.		      */

/*
    Force expose event in the main image window.
*/
if ((win == 0) || (win == -1))
    {
/*
    Calculate the main image window coordinates of the bounding rectangle.
*/
    xid_file2win(plane_idx,0,xid_element[element].upleft[0],
	xid_element[element].upleft[1],&minx,&miny);
    xid_file2win(plane_idx,0,xid_element[element].loright[0],
	xid_element[element].loright[1],&maxx,&maxy);
/*
    Factor the line width and possibly the width and height of the "graphics
    handles" into the minimum and maximum values.
*/
    if ((xid_element[element].type == LINE) || (xid_element[element].type == 
	POLY) || (xid_element[element].type == RECT))
	{
        if (xid_graphics.flags & GR_EDIT)
	    {
	    minx -= (xid_graphics.line_width + HANDLE);
	    miny -= (xid_graphics.line_width + HANDLE);
	    maxx += (xid_graphics.line_width + HANDLE);
	    maxy += (xid_graphics.line_width + HANDLE);
	    }
	else
	    {
	    minx -= xid_graphics.line_width;
	    miny -= xid_graphics.line_width;
	    maxx += xid_graphics.line_width;
	    maxy += xid_graphics.line_width;
	    }
	}
    if (((xid_element[element].type == TEXT) || (xid_element[element].type ==
	POINT)) && (xid_graphics.flags & GR_EDIT))
	{
	minx -= HANDLE;
	miny -= HANDLE;
	maxx += HANDLE;
	maxy += HANDLE;
	}
/*
    Clear the appropriate rectangle.
*/
    width = maxx - minx + 1;
    height = maxy - miny + 1;
    XClearArea(xid.display,XtWindow(main_image_bulletinboard),minx,miny,
 	width,height,TRUE);
    }

/*
    Force expose event in the full resolution image window.
*/
if (((win == 1) || (win == -1)) && (xid_fullres != NULL) && (xid_fullres[0].
    image_pixmap != NULL))
    {
/*
    Calculate the full resolution image window coordinates of the bounding 
    rectangle.
*/
    xid_file2win(plane_idx,1,xid_element[element].upleft[0],
	xid_element[element].upleft[1],&minx,&miny);
    xid_file2win(plane_idx,1,xid_element[element].loright[0],
	xid_element[element].loright[1],&maxx,&maxy);
/*
    Factor the line width and possibly the width and height of the "graphics
    handles" into the minimum and maximum values.
*/
    if ((xid_element[element].type == LINE) || (xid_element[element].type == 
	POLY) || (xid_element[element].type == RECT))
	{
        if (xid_graphics.flags & GR_EDIT)
	    {
	    minx -= (xid_graphics.line_width + HANDLE);
	    miny -= (xid_graphics.line_width + HANDLE);
	    maxx += (xid_graphics.line_width + HANDLE);
	    maxy += (xid_graphics.line_width + HANDLE);
	    }
	else
	    {
	    minx -= xid_graphics.line_width;
	    miny -= xid_graphics.line_width;
	    maxx += xid_graphics.line_width;
	    maxy += xid_graphics.line_width;
	    }
	}
    if (((xid_element[element].type == TEXT) || (xid_element[element].type ==
	POINT)) && (xid_graphics.flags & GR_EDIT))
	{
	minx -= HANDLE;
	miny -= HANDLE;
	maxx += HANDLE;
	maxy += HANDLE;
	}
/*
    Clear the appropriate rectangle.
*/
    width = maxx - minx + 1;
    height = maxy - miny + 1;
    XClearArea(xid.display,XtWindow(fullres_win_bulletinboard),minx,miny,
 	width,height,TRUE);
    }

/*
    Force expose event in the zoomed image window.
*/
if (((win == 2) || (win == -1)) && (xid_zoom.flags & ZOOM_ACTIVE) && 
    (xid_zoom.image_pixmap != NULL))
    {
/*
    Calculate the zoomed image window coordinates of the bounding 
    rectangle.
*/
    xid_file2win(plane_idx,2,xid_element[element].upleft[0],
	xid_element[element].upleft[1],&minx,&miny);
    xid_file2win(plane_idx,2,xid_element[element].loright[0],
	xid_element[element].loright[1],&maxx,&maxy);
/*
    Factor the line width and possibly the width and height of the "graphics
    handles" into the minimum and maximum values.
*/
    if ((xid_element[element].type == LINE) || (xid_element[element].type == 
	POLY) || (xid_element[element].type == RECT))
	{
        if (xid_graphics.flags & GR_EDIT)
	    {
	    minx -= (xid_graphics.line_width + HANDLE);
	    miny -= (xid_graphics.line_width + HANDLE);
	    maxx += (xid_graphics.line_width + HANDLE);
	    maxy += (xid_graphics.line_width + HANDLE);
	    }
	else
	    {
	    minx -= xid_graphics.line_width;
	    miny -= xid_graphics.line_width;
	    maxx += xid_graphics.line_width;
	    maxy += xid_graphics.line_width;
	    }
	}
    if (((xid_element[element].type == TEXT) || (xid_element[element].type ==
	POINT)) && (xid_graphics.flags & GR_EDIT))
	{
	minx -= HANDLE;
	miny -= HANDLE;
	maxx += HANDLE;
	maxy += HANDLE;
	}
/*
    Clear the appropriate rectangle.
*/
    width = maxx - minx + 1;
    height = maxy - miny + 1;
    XClearArea(xid.display,XtWindow(zoom_win_bulletinboard),minx,miny,
 	width,height,TRUE);
    }
}

graphics_setbounds(element)
long	element;		/* Graphics element index. (I)		      */

/*******************************************************************************
Purpose:
	Calculate the bounding rectangle of the specified graphics element.
 								
By L. Huewe, USGS/EROS Data Center, 1/93

Algorithm Description:
*******************************************************************************/
{
struct  ANNOT_ELEMENT   *aptr;  /* Pointer to annotation specific information.*/

struct  LINE_ELEMENT    *lptr;  /* Pointer to line specific information.      */

struct  POLY_ELEMENT    *pptr;  /* Pointer to polygon specific information.   */

	long		i,	/* Looping index.			      */
			plane_idx,
				/* Index into memory plane structure of the 
				   currently viewed image.		      */
			reset,	/* Indicates whether or not the label
				   placement flag needs to be reset.	      */
			save_font;
				/* Current font index.			      */
/*
    Find the memory plane index of the first band of the displayed image.
*/
plane_idx = xid_view.rgbplanes[RED] - 1;

/*
    Set bounding rectangle of a point. 
*/
if (xid_element[element].type == POINT)
    {
    xid_element[element].upleft[0] = xid_element[element].loright[0] = 
 	xid_element[element].x;	
    xid_element[element].upleft[1] = xid_element[element].loright[1] = 
 	xid_element[element].y;	
    }
/*
    Calculate the bounding rectangle of a polygon or rectangle.
*/
else if ((xid_element[element].type == POLY) || (xid_element[element].type == 
    RECT))
    {
    pptr = (struct POLY_ELEMENT *)xid_element[element].graph_ptr;
    xid_element[element].upleft[0] = xid_element[element].upleft[1] = MAXREAL;
    xid_element[element].loright[0] = xid_element[element].loright[1] = MINREAL;
    for (i=0; i < pptr->num_vert; i++)
	{
	if (pptr->x[i] < xid_element[element].upleft[0])
	    xid_element[element].upleft[0] = pptr->x[i];
	if (pptr->y[i] < xid_element[element].upleft[1])
	    xid_element[element].upleft[1] = pptr->y[i];
	if (pptr->x[i] > xid_element[element].loright[0])
	    xid_element[element].loright[0] = pptr->x[i];
	if (pptr->y[i] > xid_element[element].loright[1])
	    xid_element[element].loright[1] = pptr->y[i];
	}
    }
/*
    Calculate the bounding rectangle of a line.
*/
else if (xid_element[element].type == LINE)
    {
    lptr = (struct LINE_ELEMENT *)xid_element[element].graph_ptr;
    xid_element[element].upleft[0] = xid_element[element].upleft[1] = MAXREAL;
    xid_element[element].loright[0] = xid_element[element].loright[1] = MINREAL;
    for (i=0; i < lptr->num_vert; i++)
	{
	if (lptr->x[i] < xid_element[element].upleft[0])
	    xid_element[element].upleft[0] = lptr->x[i];
	if (lptr->y[i] < xid_element[element].upleft[1])
	    xid_element[element].upleft[1] = lptr->y[i];
	if (lptr->x[i] > xid_element[element].loright[0])
	    xid_element[element].loright[0] = lptr->x[i];
	if (lptr->y[i] > xid_element[element].loright[1])
	    xid_element[element].loright[1] = lptr->y[i];
	}
    }
/*
    Calculate the bounding rectangle of annotation text.
*/
else if (xid_element[element].type == TEXT)
    {
    save_font = xid_graphics.font;
    xid_graphics.font = xid_element[element].font; 
    aptr = (struct ANNOT_ELEMENT *)xid_element[element].graph_ptr;
    xid_element[element].upleft[0] = xid_element[element].x;
    xid_element[element].upleft[1] = xid_element[element].y;
    if (xid_graphics.flags & GR_LABEL)
	reset = FALSE;
    else
	reset = TRUE;
    graphics_labelcalc(aptr->string);
    if (reset)
        xid_graphics.flags &= ~GR_LABEL;
    xid_graphics.font = save_font;
    xid_element[element].loright[0] = xid_element[element].x + xid_label.
	width * xid_planes[plane_idx].skips; 
    xid_element[element].loright[1] = xid_element[element].y + xid_label.
	height * xid_planes[plane_idx].skipl;
    }

/*
    Factor the label length and position into the bounding rectangle.
*/
if ((xid_element[element].type != TEXT) && (strcmp(xid_element[element].label,
    "") != 0))
    {
    save_font = xid_graphics.font;
    xid_graphics.font = xid_element[element].font; 
    if (xid_graphics.flags & GR_LABEL)
	reset = FALSE;
    else
	reset = TRUE;
    graphics_labelcalc(xid_element[element].label);
    if (reset)
        xid_graphics.flags &= ~GR_LABEL;
    xid_graphics.font = save_font;
    if (xid_element[element].labelx < xid_element[element].upleft[0])
	xid_element[element].upleft[0] = xid_element[element].labelx;
    if (xid_element[element].labely < xid_element[element].upleft[1])
	xid_element[element].upleft[1] = xid_element[element].labely;
    if ((xid_element[element].labelx + xid_label.width * xid_planes[plane_idx].
	skips) > (xid_element[element].loright[0]))
	xid_element[element].loright[0] = xid_element[element].labelx + 
	    xid_label.width * xid_planes[plane_idx].skips;
    if ((xid_element[element].labely + xid_label.height * xid_planes[
	plane_idx].skipl) > (xid_element[element].loright[1]))
	xid_element[element].loright[1] = xid_element[element].labely + 
	    xid_label.height * xid_planes[plane_idx].skipl;
    }
}
