
      SUBROUTINE COLRGN (ITYPE,CLR1,CLR2,CLR3,ICLR,ISIZE)               CGEN0001
C. COLRGN FORTRAN 58X5                                   VER03 ZUPEI000 CGEN0002
C                                                                       CGEN0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       CGEN0005
C  LIBRARY FUNCTIONS USED (INT,MIN0)                                    CGEN0006
C  GRAPHICS ROUTINES USED (COLRMD,GENPAT,HLSRGB,HSVRGB,RGBYMC,YIQRGB)   CGEN0007
C                                                                       CGEN0008
C  INPUT: ITYPE (1-5)                                                   CGEN0009
C         CLR1  WHEN ITYPE=3,4 (0.0-360.0) OTHERWISE (0.0-1.0)          CGEN0010
C         CLR2  (0.0-1.0)                                               CGEN0011
C         CLR3  (0.0-1.0)                                               CGEN0012
C         ICLR  (1-1024)                                                CGEN0013
C         ISIZE (2,4,8,16)                                              CGEN0014
C                                                                       CGEN0015
C  MXPEN IS THE MAXIMUM NUMBER OF PENS; VALID RANGE 1 - 32767           CGEN0016
C  CURRENTLY SUPPORTED MAXIMUM NUMBER OF PENS IS 1024                   CGEN0017
      DATA MXPEN/1024/                                                  CGEN0018
C                                                                       CGEN0019
C  CHECK THAT PARAMETERS ARE IN THE CORRECT RANGE                       CGEN0020
      IF (ITYPE.LT.1) GO TO 70                                          CGEN0021
      IF (ITYPE.GT.5) GO TO 70                                          CGEN0022
      KSMAL0=0                                                          CGEN0023
      LARGE1=1                                                          CGEN0024
      LARGE2=1                                                          CGEN0025
      IF (ITYPE.EQ.3) LARGE1=360                                        CGEN0026
      IF (ITYPE.EQ.4) LARGE1=360                                        CGEN0027
      IF (ITYPE.EQ.5) KSMAL0=-1                                         CGEN0028
      IF (INT(CLR1).LT.KSMAL0) GO TO 70                                 CGEN0029
      IF (INT(CLR1).GT.LARGE1) GO TO 70                                 CGEN0030
      IF (INT(CLR2).LT.KSMAL0) GO TO 70                                 CGEN0031
      IF (INT(CLR2).GT.LARGE2) GO TO 70                                 CGEN0032
      IF (INT(CLR3).LT.KSMAL0) GO TO 70                                 CGEN0033
      IF (INT(CLR3).GT.LARGE2) GO TO 70                                 CGEN0034
      IF (ICLR.LT.0) GO TO 70                                           CGEN0035
      IF (ICLR.GT.MXPEN) GO TO 70                                       CGEN0036
      KSIZE=2                                                           CGEN0037
      IF (ISIZE.GE.4) KSIZE=4                                           CGEN0038
      IF (ISIZE.GE.8) KSIZE=8                                           CGEN0039
      IF (ISIZE.GE.16) KSIZE=16                                         CGEN0040
      GO TO (10,20,30,40,50), ITYPE                                     CGEN0041
C                                                                       CGEN0042
C  YMC (YELLOW,MAGENTA,CYAN)                                            CGEN0043
   10 CONTINUE                                                          CGEN0044
      CLRY=CLR1                                                         CGEN0045
      CLRM=CLR2                                                         CGEN0046
      CLRC=CLR3                                                         CGEN0047
      GO TO 60                                                          CGEN0048
C                                                                       CGEN0049
C  CONVERT RGB (RED,GREEN,BLUE) TO YMC (YELLOW,MAGENTA,CYAN)            CGEN0050
   20 CONTINUE                                                          CGEN0051
      CALL RGBYMC (CLR1,CLR2,CLR3,CLRY,CLRM,CLRC)                       CGEN0052
      GO TO 60                                                          CGEN0053
C                                                                       CGEN0054
C  CONVERT HLS (HUE,LIGHTNESS,SATURATION) TO YMC (YELLOW,MAGENTA,CYAN)  CGEN0055
   30 CONTINUE                                                          CGEN0056
      CALL HLSRGB (CLR1,CLR2,CLR3,RED,GREEN,BLUE)                       CGEN0057
      CALL RGBYMC (RED,GREEN,BLUE,CLRY,CLRM,CLRC)                       CGEN0058
      GO TO 60                                                          CGEN0059
C                                                                       CGEN0060
C  CONVERT HSV (HUE,SATURATION,VALUE) TO YMC (YELLOW,MAGENTA,CYAN)      CGEN0061
   40 CONTINUE                                                          CGEN0062
      CALL HSVRGB (CLR1,CLR2,CLR3,RED,GREEN,BLUE)                       CGEN0063
      CALL RGBYMC (RED,GREEN,BLUE,CLRY,CLRM,CLRC)                       CGEN0064
      GO TO 60                                                          CGEN0065
C                                                                       CGEN0066
C  CONVERT YIQ (LUMINOUS,INPHASE,QUADRATURE) TO YMC(YELLOW,MAGENTA,CYAN)CGEN0067
   50 CONTINUE                                                          CGEN0068
      CALL YIQRGB (CLR1,CLR2,CLR3,RED,GREEN,BLUE)                       CGEN0069
      CALL RGBYMC (RED,GREEN,BLUE,CLRY,CLRM,CLRC)                       CGEN0070
      GO TO 60                                                          CGEN0071
C                                                                       CGEN0072
   60 CONTINUE                                                          CGEN0073
      IF (KSIZE.GE.8) GO TO 62                                          CGEN0074
C  ROUND-OFF THE FRACTIONAL PARTS AND CREATE PERCENTAGE                 CGEN0075
C   USE LINEAR EVALUATION FOR 2*2 AND 4*4 CELL SIZES                    CGEN0076
      ICLRY=INT(CLRY*100.0+0.5)                                         CGEN0077
      ICLRM=INT(CLRM*100.0+0.5)                                         CGEN0078
      ICLRC=INT(CLRC*100.0+0.5)                                         CGEN0079
      GO TO 63                                                          CGEN0080
C  ROUND-OFF THE FRACTIONAL PARTS AND CREATE PERCENTAGE                 CGEN0081
C   USE QUADRATIC EVALUATION FOR 8*8 AND 16*16 CELL SIZES               CGEN0082
   62 CONTINUE                                                          CGEN0083
      ICLRY=INT((CLRY*CLRY)*100.0+0.5)                                  CGEN0084
      ICLRM=INT((CLRM*CLRM)*100.0+0.5)                                  CGEN0085
      ICLRC=INT((CLRC*CLRC)*100.0+0.5)                                  CGEN0086
C  FIND SMALLEST COLOR PORTION THUS MINIMIZE COLOR AND MAXIMIZE BLACK   CGEN0087
   63 CONTINUE                                                          CGEN0088
      ICLRB=MIN0(ICLRY,ICLRM)                                           CGEN0089
      ICLRB=MIN0(ICLRB,ICLRC)                                           CGEN0090
      ICLRY=ICLRY-ICLRB                                                 CGEN0091
      ICLRM=ICLRM-ICLRB                                                 CGEN0092
      ICLRC=ICLRC-ICLRB                                                 CGEN0093
C                                                                       CGEN0094
      CALL GENPAT (ICLRB,KSIZE,IPATB)                                   CGEN0095
      CALL GENPAT (ICLRY,KSIZE,IPATY)                                   CGEN0096
      CALL GENPAT (ICLRM,KSIZE,IPATM)                                   CGEN0097
      CALL GENPAT (ICLRC,KSIZE,IPATC)                                   CGEN0098
C  SEND PATTERN NUMBER TO CONTROLLER FOR CORRECT COLOR                  CGEN0099
      CALL COLRMD (IPATB,IPATY,IPATM,IPATC,ICLR)                        CGEN0100
   70 CONTINUE                                                          CGEN0101
      RETURN                                                            CGEN0102
      END                                                               CGEN0103
      SUBROUTINE HLSRGB (HUE,RLITE,SATUR,RED,GREEN,BLUE)                HLSR0001
C. HLSRGB FORTRAN 58X5                                   VER01 ZUPEJ000 HLSR0002
C                                                                       HLSR0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       HLSR0005
C  LIBRARY FUNCTIONS USED - NONE                                        HLSR0006
C  GRAPHICS ROUTINES USED - NONE                                        HLSR0007
C                                                                       HLSR0008
C  INPUT:  HUE   (0.0-360.0, UNDEFINED WHEN SATUR=0.0)                  HLSR0009
C          RLITE (0.0-1.0)                                              HLSR0010
C          SATUR (0.0-1.0)                                              HLSR0011
C  OUTPUT: RED   (0.0-1.0)                                              HLSR0012
C          GREEN (0.0-1.0)                                              HLSR0013
C          BLUE  (0.0-1.0)                                              HLSR0014
C  DOCUMENTATION: FOLEY J.D.,VAN DAM A.,'FUNDAMENTALS OF INTERACTIVE    HLSR0015
C          COMPUTER GRAPHICS',ADDISON WESLEY,JULY 1984.                 HLSR0016
C                                                                       HLSR0017
      IF (SATUR.NE.0.0) GO TO 10                                        HLSR0018
C  THIS IS THE ACHROMATIC CASE: THERE IS NO HUE.                        HLSR0019
      RED=RLITE                                                         HLSR0020
      GREEN=RLITE                                                       HLSR0021
      BLUE=RLITE                                                        HLSR0022
      GO TO 20                                                          HLSR0023
C                                                                       HLSR0024
   10 CONTINUE                                                          HLSR0025
C  THIS IS THE CHROMATIC CASE: THERE IS A HUE.                          HLSR0026
      P2=(RLITE+SATUR)-RLITE*SATUR                                      HLSR0027
      IF (RLITE.LE.0.5) P2=RLITE+RLITE*SATUR                            HLSR0028
      P1=(RLITE+RLITE)-P2                                               HLSR0029
C                                                                       HLSR0030
      RED=HLSVAL(P1,P2,HUE+120.0)                                       HLSR0031
      GREEN=HLSVAL(P1,P2,HUE)                                           HLSR0032
      BLUE=HLSVAL(P1,P2,HUE-120.0)                                      HLSR0033
C                                                                       HLSR0034
   20 CONTINUE                                                          HLSR0035
      RETURN                                                            HLSR0036
      END                                                               HLSR0037
      REAL FUNCTION HLSVAL (P1,P2,HUE)                                  HVAL0038
C. HLSVAL  FORTRAN 58X5                                  VER02 ZUPEJ000 HVAL0039
C                                                                       HVAL0040
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       HVAL0042
C  LIBRARY FUNCTIONS USED (INT)                                         HVAL0043
C  GRAPHICS ROUTINES USED - NONE                                        HVAL0044
C                                                                       HVAL0045
C  INPUT:  P1    (0.0-1.0)                                              HVAL0046
C          P2    (0.0-1.0)                                              HVAL0047
C          HUE   (0.0-360.0)                                            HVAL0048
C  OUTPUT: HLSVAL (0.0-1.0)                                             HVAL0049
C                                                                       HVAL0050
      RHUE=HUE                                                          HVAL0051
      IF (RHUE.GT.360.0) RHUE=RHUE-360.0                                HVAL0052
      IF (RHUE.LT.0.0) RHUE=RHUE+360.0                                  HVAL0053
C                                                                       HVAL0054
      IHUE=INT(RHUE/60.0)                                               HVAL0055
      JHUE=IHUE+1                                                       HVAL0056
      GO TO (10,20,20,30,40,40,40), JHUE                                HVAL0057
C                                                                       HVAL0058
   10 CONTINUE                                                          HVAL0059
      HLSVAL=P1+(P2-P1)*(RHUE/60.0)                                     HVAL0060
      GO TO 50                                                          HVAL0061
C                                                                       HVAL0062
   20 CONTINUE                                                          HVAL0063
      HLSVAL=P2                                                         HVAL0064
      GO TO 50                                                          HVAL0065
C                                                                       HVAL0066
   30 CONTINUE                                                          HVAL0067
      HLSVAL=P1+(P2-P1)*((240.0-RHUE)/60.0)                             HVAL0068
      GO TO 50                                                          HVAL0069
C                                                                       HVAL0070
   40 CONTINUE                                                          HVAL0071
      HLSVAL=P1                                                         HVAL0072
      GO TO 50                                                          HVAL0073
C                                                                       HVAL0074
   50 CONTINUE                                                          HVAL0075
      RETURN                                                            HVAL0076
      END                                                               HVAL0077
      SUBROUTINE HSVRGB (HUE,SATUR,VALUE,RED,GREEN,BLUE)                HSVR0001
C. HSVRGB FORTRAN 58X5                                   VER02 ZUPEK000 HSVR0002
C                                                                       HSVR0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       HSVR0005
C  LIBRARY FUNCTIONS USED (FLOAT,INT)                                   HSVR0006
C  GRAPHICS ROUTINES USED - NONE                                        HSVR0007
C                                                                       HSVR0008
C  INPUT:  HUE   (0.0-360.0, UNDEFINED WHEN SATUR=0.0)                  HSVR0009
C          SATUR (0.0-1.0)                                              HSVR0010
C          VALUE (0.0-1.0)                                              HSVR0011
C  OUTPUT: RED   (0.0-1.0)                                              HSVR0012
C          GREEN (0.0-1.0)                                              HSVR0013
C          BLUE  (0.0-1.0)                                              HSVR0014
C  DOCUMENTATION: FOLEY J.D.,VAN DAM A.,'FUNDAMENTALS OF INTERACTIVE    HSVR0015
C          COMPUTER GRAPHICS',ADDISON WESLEY,JULY 1984.                 HSVR0016
C                                                                       HSVR0017
      RHUE=HUE                                                          HSVR0018
      IF (SATUR.NE.0.0) GO TO 10                                        HSVR0019
C  THIS IS THE ACHROMATIC CASE: THERE IS NO HUE.                        HSVR0020
      RED=VALUE                                                         HSVR0021
      GREEN=VALUE                                                       HSVR0022
      BLUE=VALUE                                                        HSVR0023
      GO TO 80                                                          HSVR0024
C                                                                       HSVR0025
   10 CONTINUE                                                          HSVR0026
C  THIS IS THE CHROMATIC CASE: THERE IS A HUE.                          HSVR0027
      IF (INT(RHUE).EQ.360) RHUE=0.0                                    HSVR0028
      RHUE=RHUE/60.0                                                    HSVR0029
      IHUE=INT(RHUE)                                                    HSVR0030
      FHUE=RHUE-FLOAT(IHUE)                                             HSVR0031
      RTMP1=VALUE*SATUR                                                 HSVR0032
      RTMP2=RTMP1*FHUE                                                  HSVR0033
      PTEMP=VALUE-RTMP1                                                 HSVR0034
      QTEMP=VALUE-RTMP2                                                 HSVR0035
      TTEMP=PTEMP+RTMP2                                                 HSVR0036
C                                                                       HSVR0037
      JHUE=IHUE+1                                                       HSVR0038
      GO TO (20,30,40,50,60,70), JHUE                                   HSVR0039
C                                                                       HSVR0040
   20 CONTINUE                                                          HSVR0041
      RED=VALUE                                                         HSVR0042
      GREEN=TTEMP                                                       HSVR0043
      BLUE=PTEMP                                                        HSVR0044
      GO TO 80                                                          HSVR0045
C                                                                       HSVR0046
   30 CONTINUE                                                          HSVR0047
      RED=QTEMP                                                         HSVR0048
      GREEN=VALUE                                                       HSVR0049
      BLUE=PTEMP                                                        HSVR0050
      GO TO 80                                                          HSVR0051
C                                                                       HSVR0052
   40 CONTINUE                                                          HSVR0053
      RED=PTEMP                                                         HSVR0054
      GREEN=VALUE                                                       HSVR0055
      BLUE=TTEMP                                                        HSVR0056
      GO TO 80                                                          HSVR0057
C                                                                       HSVR0058
   50 CONTINUE                                                          HSVR0059
      RED=PTEMP                                                         HSVR0060
      GREEN=QTEMP                                                       HSVR0061
      BLUE=VALUE                                                        HSVR0062
      GO TO 80                                                          HSVR0063
C                                                                       HSVR0064
   60 CONTINUE                                                          HSVR0065
      RED=TTEMP                                                         HSVR0066
      GREEN=PTEMP                                                       HSVR0067
      BLUE=VALUE                                                        HSVR0068
      GO TO 80                                                          HSVR0069
C                                                                       HSVR0070
   70 CONTINUE                                                          HSVR0071
      RED=VALUE                                                         HSVR0072
      GREEN=PTEMP                                                       HSVR0073
      BLUE=QTEMP                                                        HSVR0074
      GO TO 80                                                          HSVR0075
C                                                                       HSVR0076
   80 CONTINUE                                                          HSVR0077
      RETURN                                                            HSVR0078
      END                                                               HSVR0079
      SUBROUTINE YIQRGB (YLUMIN,RINPHS,QUADRT,RED,GREEN,BLUE)           YIQR0001
C. YIQRGB FORTRAN 58X5                                   VER01 ZUPEL000 YIQR0002
C                                                                       YIQR0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       YIQR0005
C  LIBRARY FUNCTIONS USED - NONE                                        YIQR0006
C  GRAPHICS ROUTINES USED - NONE                                        YIQR0007
C                                                                       YIQR0008
C  INPUT:  YLUMIN (-1.0-+1.0)                                           YIQR0009
C          RINPHS (-1.0-+1.0)                                           YIQR0010
C          QUADRT (-1.0-+1.0)                                           YIQR0011
C  OUTPUT: RED    (-1.0-+1.0)                                           YIQR0012
C          GREEN  (-1.0-+1.0)                                           YIQR0013
C          BLUE   (-1.0-+1.0)                                           YIQR0014
C  DOCUMENTATION: FOLEY J.D.,VAN DAM A.,'FUNDAMENTALS OF INTERACTIVE    YIQR0015
C          COMPUTER GRAPHICS',ADDISON WESLEY,JULY 1984.                 YIQR0016
C                 CHUANG R.,'RENDERING FOR TELEVISION',TUTORIAL NOTES   YIQR0017
C          FOR SIGGRAPH 85:',PACIFIC DATA IMAGES INC.,1985.             YIQR0018
C                                                                       YIQR0019
C  (Y)   (0.30    0.59     0.11  )   (R)                                YIQR0020
C  (I) = (0.599  -0.2773  -0.3217) * (G)                                YIQR0021
C  (Q)   (0.213  -0.5251   0.3121)   (B)                                YIQR0022
C                                                                       YIQR0023
C  (R)   (  43.3/43.3      41./43.3       27./43.3  )   (Y)             YIQR0024
C  (G) = (2554.7/2554.7  -702./2554.7  -1624./2554.7) * (I)             YIQR0025
C  (B)   (  43.3/43.3    - 48./43.3       74./43.3  )   (Q)             YIQR0026
C                                                                       YIQR0027
      RED=YLUMIN+(41.0*RINPHS+27.0*QUADRT)/43.3                         YIQR0028
      GREEN=YLUMIN+(-702.0*RINPHS-1624.0*QUADRT)/2554.7                 YIQR0029
      BLUE=YLUMIN+(-48.0*RINPHS+74.0*QUADRT)/43.3                       YIQR0030
C                                                                       YIQR0031
      RETURN                                                            YIQR0032
      END                                                               YIQR0033
      SUBROUTINE RGBYMC (RED,GREEN,BLUE,YELLOW,RMGENT,CYAN)             RGBY0001
C. RGBYMC FORTRAN 58X5                                   VER01 ZUPEM000 RGBY0002
C                                                                       RGBY0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       RGBY0005
C  LIBRARY FUNCTIONS USED - NONE                                        RGBY0006
C  GRAPHICS ROUTINES USED - NONE                                        RGBY0007
C                                                                       RGBY0008
C  INPUT:  RED    (0.0-1.0)                                             RGBY0009
C          GREEN  (0.0-1.0)                                             RGBY0010
C          BLUE   (0.0-1.0)                                             RGBY0011
C  OUTPUT: YELLOW (0.0-1.0)                                             RGBY0012
C          RMGENT (0.0-1.0)                                             RGBY0013
C          CYAN   (0.0-1.0)                                             RGBY0014
C  DOCUMENTATION: FOLEY J.D.,VAN DAM A.,'FUNDAMENTALS OF INTERACTIVE    RGBY0015
C          COMPUTER GRAPHICS',ADDISON WESLEY,JULY 1984.                 RGBY0016
C                                                                       RGBY0017
C  (C)   (1.0)   (R)                                                    RGBY0018
C  (M) = (1.0) - (G)                                                    RGBY0019
C  (Y)   (1.0)   (B)                                                    RGBY0020
C                                                                       RGBY0021
      CYAN=1.0-RED                                                      RGBY0022
      RMGENT=1.0-GREEN                                                  RGBY0023
      YELLOW=1.0-BLUE                                                   RGBY0024
C                                                                       RGBY0025
      RETURN                                                            RGBY0026
      END                                                               RGBY0027
      SUBROUTINE GENPAT (ICLR,KSIZE,IPAT)                               GENP0001
C. GENPAT FORTRAN 58X5                                   VER01 ZUPEN000 GENP0002
C                                                                       GENP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       GENP0005
C  LIBRARY FUNCTIONS USED (FLOAT,INT,SQRT)                              GENP0006
C  GRAPHICS ROUTINES USED (GETP16,GETPT8,SETPAT)                        GENP0007
C                                                                       GENP0008
C  INPUT  ICLR  (0-100)                                                 GENP0009
C         KSIZE (2,4,8,16)                                              GENP0010
C  OUTPUT IPAT  (75-239)                                                GENP0011
C                                                                       GENP0012
      DIMENSION KPAT(128), ICELL1(4), ICELL2(4)                         GENP0013
      DIMENSION LPTRN2(4), LPTRN8(64), LPTR16(100)                      GENP0014
C                                                                       GENP0015
C***LOC313 SAVE VARIABLE VALUE WHEN REENTERING CODE                     GENP0016
      DATA NXPAT/240/                                                   GENP0017
      DATA LPTRN2/-1,-1,-1,255/                                         GENP0018
      DATA LPTRN8/63*-1,255/                                            GENP0019
      DATA LPTR16/99*-1,255/                                            GENP0020
C***LOC313 END.                                                         GENP0021
C                                                                       GENP0022
      DATA MNPAT/75/                                                    GENP0023
C  THE OVERLAPING OF DOTS CAUSES UNUSUAL PERCENTAGE OF COVERAGE.        GENP0024
      DATA LPCT1,LPCT2,LPCT3,LPCT4/28,68,87,100/                        GENP0025
C  THE ONLY VALID 8-BIT PATTERNS ARE 0,85,170,255.                      GENP0026
      DATA ICELL1(1),ICELL1(2),ICELL1(3),ICELL1(4)/170,170,170,255/     GENP0027
      DATA ICELL2(1),ICELL2(2),ICELL2(3),ICELL2(4)/  0,170, 85,255/     GENP0028
C                                                                       GENP0029
      IPAT=0                                                            GENP0030
      IF (ICLR.LE.0) GO TO 100                                          GENP0031
C  CALCULATE NUMBER OF DOTS TO BE SELECTED.                             GENP0032
      NDOT=(ICLR*(KSIZE*KSIZE))/100                                     GENP0033
      IF (NDOT.EQ.0) GO TO 100                                          GENP0034
C  APPROXIMATE THE ANTILOG BASE 2 OF KSIZE.                             GENP0035
      JSIZE=INT(SQRT(FLOAT(KSIZE))+0.5)                                 GENP0036
      GO TO (10,50,60,80), JSIZE                                        GENP0037
C                                                                       GENP0038
   10 CONTINUE                                                          GENP0039
      MPTR=0                                                            GENP0040
C  LOOK UP IN TABLE THE CORRECT PERCENTAGE TO USE THE CORRECT POINTER.  GENP0041
      IF (ICLR.GE.LPCT1) MPTR=1                                         GENP0042
      IF (ICLR.GE.LPCT2) MPTR=2                                         GENP0043
      IF (ICLR.GE.LPCT3) MPTR=3                                         GENP0044
      IF (ICLR.GE.LPCT4) MPTR=4                                         GENP0045
      IF (MPTR.EQ.0) GO TO 100                                          GENP0046
C  CHECK TO SEE IF PATTERN HAS ALREADY BEEN DEFINED                     GENP0047
      IF (LPTRN2(MPTR).LT.0) GO TO 20                                   GENP0048
C  USE OLD PATTERN DEFINITION                                           GENP0049
      IPAT=LPTRN2(MPTR)                                                 GENP0050
      GO TO 100                                                         GENP0051
   20 CONTINUE                                                          GENP0052
C  CREATE NEW PATTERN DEFINITION AND PATTERN NUMBER                     GENP0053
      IF (NXPAT.LT.MNPAT) GO TO 100                                     GENP0054
      NXPAT=NXPAT-1                                                     GENP0055
C  CREATE 2X2 PATTERN AS REQUESTED                                      GENP0056
C  COMPLETE 32X32 RASTER IMAGE                                          GENP0057
      DO 40 I=1,16                                                      GENP0058
         DO 30 J=1,4                                                    GENP0059
C  COMPUTE POINTER AND PLACE VALUES IN KPAT                             GENP0060
            KPTR=(J+8*I)-8                                              GENP0061
            KPAT(KPTR)=ICELL1(MPTR)                                     GENP0062
            KPAT(KPTR+4)=ICELL2(MPTR)                                   GENP0063
   30    CONTINUE                                                       GENP0064
   40 CONTINUE                                                          GENP0065
C                                                                       GENP0066
C  SEND PATTERN TO CONTROLLER USING THE CONVENTIONAL MANNER             GENP0067
      CALL SETPAT (KPAT,32,NXPAT)                                       GENP0068
C  SAVE PATTERN NUMBER TO MINIMIZE NUMBER OF PATTERN BEING CREATED      GENP0069
      LPTRN2(MPTR)=NXPAT                                                GENP0070
      IPAT=NXPAT                                                        GENP0071
      GO TO 100                                                         GENP0072
C                                                                       GENP0073
   50 CONTINUE                                                          GENP0074
C  USE 4X4 PREDEFINED PATTERN AS REQUESTED                              GENP0075
      IPAT=NDOT+239                                                     GENP0076
      GO TO 100                                                         GENP0077
C                                                                       GENP0078
   60 CONTINUE                                                          GENP0079
C  CHECK TO SEE IF PATTERN HAS ALREADY BEEN DEFINED                     GENP0080
      IF (LPTRN8(NDOT).LT.0) GO TO 70                                   GENP0081
C  USE OLD PATTERN DEFINITION                                           GENP0082
      IPAT=LPTRN8(NDOT)                                                 GENP0083
      GO TO 100                                                         GENP0084
   70 CONTINUE                                                          GENP0085
C  CREATE NEW PATTERN DEFINITION AND PATTERN NUMBER                     GENP0086
      IF (NXPAT.LT.MNPAT) GO TO 100                                     GENP0087
      NXPAT=NXPAT-1                                                     GENP0088
C  CREATE 8X8 PATTERN AS REQUESTED                                      GENP0089
      CALL GETPT8 (ICLR,KSIZE,KPAT)                                     GENP0090
C  SEND PATTERN TO CONTROLLER USING THE CONVENTIONAL MANNER             GENP0091
      CALL SETPAT (KPAT,32,NXPAT)                                       GENP0092
C  SAVE PATTERN NUMBER TO MINIMIZE NUMBER OF PATTERN BEING CREATED      GENP0093
      LPTRN8(NDOT)=NXPAT                                                GENP0094
      IPAT=NXPAT                                                        GENP0095
      GO TO 100                                                         GENP0096
C                                                                       GENP0097
   80 CONTINUE                                                          GENP0098
C  CHECK TO SEE IF PATTERN HAS ALREADY BEEN DEFINED                     GENP0099
      IF (LPTR16(ICLR).LT.0) GO TO 90                                   GENP0100
C  USE OLD PATTERN DEFINITION                                           GENP0101
      IPAT=LPTR16(ICLR)                                                 GENP0102
      GO TO 100                                                         GENP0103
   90 CONTINUE                                                          GENP0104
C  CREATE NEW PATTERN DEFINITION AND PATTERN NUMBER                     GENP0105
      IF (NXPAT.LT.MNPAT) GO TO 100                                     GENP0106
      NXPAT=NXPAT-1                                                     GENP0107
C  CREATE 16X16 PATTERN AS REQUESTED                                    GENP0108
      CALL GETP16 (ICLR,KSIZE,KPAT)                                     GENP0109
C  SEND PATTERN TO CONTROLLER USING THE CONVENTIONAL MANNER             GENP0110
      CALL SETPAT (KPAT,32,NXPAT)                                       GENP0111
C  SAVE PATTERN NUMBER TO MINIMIZE NUMBER OF PATTERN BEING CREATED      GENP0112
      LPTR16(ICLR)=NXPAT                                                GENP0113
      IPAT=NXPAT                                                        GENP0114
      GO TO 100                                                         GENP0115
C                                                                       GENP0116
  100 CONTINUE                                                          GENP0117
      RETURN                                                            GENP0118
      END                                                               GENP0119
      SUBROUTINE GETPT8 (ICLR,KSIZE,KPAT)                               GET80001
C. GETPAT FORTRAN 58X5                                   VER01 ZUPEP000 GET80002
C                                                                       GET80003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       GET80005
C  LIBRARY FUNCTIONS USED - NONE                                        GET80006
C  GRAPHICS ROUTINES USED - NONE                                        GET80007
C                                                                       GET80008
C  INPUT  ICLR  (0-100)                                                 GET80009
C         KSIZE (8)                                                     GET80010
C  OUTPUT KPAT                                                          GET80011
C                                                                       GET80012
      DIMENSION KPAT(128)                                               GET80013
      DIMENSION KDOT(8,8), ICELL(8)                                     GET80014
C                                                                       GET80015
      DATA KDOT/64,55,47,43,40,52,57,62,                                GET80016
     1          59,33,24,29,20,27,36,54,                                GET80017
     2          45,31,16, 9, 5,13,22,50,                                GET80018
     3          37,18,12, 4, 1, 7,25,42,                                GET80019
     4          41,21, 8, 2, 3,11,17,38,                                GET80020
     5          49,26,14, 6,10,15,32,46,                                GET80021
     6          53,35,28,19,30,23,34,60,                                GET80022
     7          61,58,51,39,44,48,56,63/                                GET80023
C                                                                       GET80024
C  COMPUTE NUMBER OF DOTS TO BE TURNED ON IN 8X8 CELL                   GET80025
      ITDOT=(ICLR*(KSIZE*KSIZE))/100                                    GET80026
C  INITIALIZE 8-BIT RASTER IMAGE                                        GET80027
      DO 10 I=1,8                                                       GET80028
         ICELL(I)=0                                                     GET80029
   10 CONTINUE                                                          GET80030
C  COMPUTE 8-BIT RASTER IMAGE                                           GET80031
      DO 30 I=1,8                                                       GET80032
         DO 20 J=1,8                                                    GET80033
            IF (KDOT(I,J).GT.ITDOT) GO TO 20                            GET80034
            ITMP=2**(J-1)                                               GET80035
            ICELL(I)=ICELL(I)+ITMP                                      GET80036
   20    CONTINUE                                                       GET80037
   30 CONTINUE                                                          GET80038
C  COMPLETE 32X32 RASTER IMAGE                                          GET80039
      DO 50 I=1,8                                                       GET80040
         DO 40 J=1,4                                                    GET80041
C  COMPUTE POINTER AND PLACE VALUES IN KPAT                             GET80042
            KPTR=(32*J+4*I)-35                                          GET80043
            KPAT(KPTR)=ICELL(I)                                         GET80044
            KPAT(KPTR+1)=ICELL(I)                                       GET80045
            KPAT(KPTR+2)=ICELL(I)                                       GET80046
            KPAT(KPTR+3)=ICELL(I)                                       GET80047
   40    CONTINUE                                                       GET80048
   50 CONTINUE                                                          GET80049
C                                                                       GET80050
      RETURN                                                            GET80051
      END                                                               GET80052
      SUBROUTINE GETP16 (ICLR,KSIZE,KPAT)                               GT160001
C. GETPAT FORTRAN 58X5                                   VER01 ZUPEQ000 GT160002
C                                                                       GT160003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       GT160005
C  LIBRARY FUNCTIONS USED (MOD)                                         GT160006
C  GRAPHICS ROUTINES USED - NONE                                        GT160007
C                                                                       GT160008
C  INPUT  ICLR  (0-100)                                                 GT160009
C         KSIZE (16)                                                    GT160010
C  OUTPUT KPAT                                                          GT160011
C                                                                       GT160012
      DIMENSION KPAT(128)                                               GT160013
      DIMENSION KDOT(8,8), ICELL(32), LDOTS(4)                          GT160014
C                                                                       GT160015
      DATA KDOT/64,55,47,43,40,52,57,62,                                GT160016
     1          59,33,24,29,20,27,36,54,                                GT160017
     2          45,31,16, 9, 5,13,22,50,                                GT160018
     3          37,18,12, 4, 1, 7,25,42,                                GT160019
     4          41,21, 8, 2, 3,11,17,38,                                GT160020
     5          49,26,14, 6,10,15,32,46,                                GT160021
     6          53,35,28,19,30,23,34,60,                                GT160022
     7          61,58,51,39,44,48,56,63/                                GT160023
C                                                                       GT160024
C  COMPUTE NUMBER OF DOTS TO BE TURNED ON IN 16X16 CELL                 GT160025
      ITDOT=(ICLR*(KSIZE*KSIZE))/100                                    GT160026
C  COMPUTE MINIMUM NUMBER OF DOTS TO BE TURNED ON IN EACH 8X8 CELL      GT160027
      LDOT=ITDOT/4                                                      GT160028
C  COMPUTE REMAINING NUMBER OF DOTS                                     GT160029
      LRDOT=MOD(ITDOT,4)                                                GT160030
C                                                                       GT160031
      DO 10 K=1,4                                                       GT160032
         LDOTS(K)=LDOT                                                  GT160033
         IF (LRDOT.LE.0) GO TO 10                                       GT160034
C  INCREASE MINIMUM NUMBER OF DOTS TO BE TURNED ON IN A CELL            GT160035
         LDOTS(K)=LDOTS(K)+1                                            GT160036
C  DECREASE REMAINING NUMBER OF DOTS                                    GT160037
         LRDOT=LRDOT-1                                                  GT160038
   10 CONTINUE                                                          GT160039
C                                                                       GT160040
C  INITIALIZE 8-BIT RASTER IMAGE                                        GT160041
      DO 20 I=1,32                                                      GT160042
         ICELL(I)=0                                                     GT160043
   20 CONTINUE                                                          GT160044
C  COMPUTE FOUR 8-BIT RASTER IMAGES                                     GT160045
      DO 50 K=1,4                                                       GT160046
         KPTR=8*(K-1)                                                   GT160047
         LDOT=LDOTS(K)                                                  GT160048
C  COMPUTE ONE 8-BIT RASTER IMAGE                                       GT160049
         DO 40 I=1,8                                                    GT160050
            IPTR=KPTR+I                                                 GT160051
            DO 30 J=1,8                                                 GT160052
               IF (KDOT(I,J).GT.LDOT) GO TO 30                          GT160053
               ITMP=2**(J-1)                                            GT160054
               ICELL(IPTR)=ICELL(IPTR)+ITMP                             GT160055
   30       CONTINUE                                                    GT160056
   40    CONTINUE                                                       GT160057
   50 CONTINUE                                                          GT160058
C  COMPLETE 32X32 RASTER IMAGE                                          GT160059
      DO 70 I=1,16                                                      GT160060
         DO 60 J=1,2                                                    GT160061
C  COMPUTE POINTER AND PLACE VALUES IN KPAT                             GT160062
            KPTR=(64*J+4*I)-67                                          GT160063
            ITMP=I+16                                                   GT160064
            KPAT(KPTR)=ICELL(I)                                         GT160065
            KPAT(KPTR+1)=ICELL(ITMP)                                    GT160066
            KPAT(KPTR+2)=ICELL(I)                                       GT160067
            KPAT(KPTR+3)=ICELL(ITMP)                                    GT160068
   60    CONTINUE                                                       GT160069
   70 CONTINUE                                                          GT160070
C                                                                       GT160071
      RETURN                                                            GT160072
      END                                                               GT160073
      SUBROUTINE COLRMD (IBLK,IYEL,IMAG,ICYAN,ICLR)                     CMOD0001
C. COLRMD F77     58X5 O/L                               VER01 ZUPER500 CMOD0002
C                                                                       CMOD0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       CMOD0005
C  LIBRARY FUNCTIONS USED - NONE                                        CMOD0006
C  GRAPHICS ROUTINES USED (BUFF)                                        CMOD0007
C                                                                       CMOD0008
      CHARACTER*1 CDUM                                                  CMOD0009
C  THIS ROUTINE ALLOWS MODIFICATIONS OF THE COLOR PALETTE               CMOD0010
C                                                                       CMOD0011
C  MXCLR IS THE MAXIMUM NUMBER OF COLORS; VALID RANGE 1 - 32767         CMOD0012
C  CURRENTLY SUPPORTED MAXIMUM NUMBER OF COLORS IS 1024                 CMOD0013
      DATA MXCLR/1024/                                                  CMOD0014
C  MXPAT IS THE MAXIMUM NUMBER OF PATTERNS AVAILABLE                    CMOD0015
      DATA MXPAT/255/                                                   CMOD0016
C                                                                       CMOD0017
      IF (ICLR.LT.1) GO TO 10                                           CMOD0018
      IF (ICLR.GT.MXCLR) GO TO 10                                       CMOD0019
      IF (IBLK.LT.0) GO TO 10                                           CMOD0020
      IF (IBLK.GT.MXPAT) GO TO 10                                       CMOD0021
      IF (IYEL.LT.0) GO TO 10                                           CMOD0022
      IF (IYEL.GT.MXPAT) GO TO 10                                       CMOD0023
      IF (IMAG.LT.0) GO TO 10                                           CMOD0024
      IF (IMAG.GT.MXPAT) GO TO 10                                       CMOD0025
      IF (ICYAN.LT.0) GO TO 10                                          CMOD0026
      IF (ICYAN.GT.MXPAT) GO TO 10                                      CMOD0027
      CALL BUFF (13,0,6,CDUM)                                           CMOD0028
      CALL BUFF (14,1,0,CDUM)                                           CMOD0029
      CALL BUFF (35,1,0,CDUM)                                           CMOD0030
      CALL BUFF (ICLR,3,7,CDUM)                                         CMOD0031
      CALL BUFF (IYEL,2,7,CDUM)                                         CMOD0032
      CALL BUFF (IMAG,2,7,CDUM)                                         CMOD0033
      CALL BUFF (ICYAN,2,7,CDUM)                                        CMOD0034
      CALL BUFF (IBLK,2,7,CDUM)                                         CMOD0035
   10 CONTINUE                                                          CMOD0036
      RETURN                                                            CMOD0037
      END                                                               CMOD0038
      SUBROUTINE COLRSQ (ISEQ)                                          CSEQ0001
C. COLRSQ F77     58X5 O/L                               VER01 ZUPES500 CSEQ0002
C                                                                       CSEQ0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       CSEQ0005
C  LIBRARY FUNCTIONS USED - NONE                                        CSEQ0006
C  GRAPHICS ROUTINES USED (BUFF)                                        CSEQ0007
C                                                                       CSEQ0008
      CHARACTER*1 CDUM                                                  CSEQ0009
      IF (ISEQ.LT.1) GO TO 10                                           CSEQ0010
      IF (ISEQ.GT.10) GO TO 10                                          CSEQ0011
      CALL BUFF (3,0,6,CDUM)                                            CSEQ0012
      CALL BUFF (14,1,0,CDUM)                                           CSEQ0013
      CALL BUFF (36,1,0,CDUM)                                           CSEQ0014
      CALL BUFF (ISEQ,1,0,CDUM)                                         CSEQ0015
   10 CONTINUE                                                          CSEQ0016
      RETURN                                                            CSEQ0017
      END                                                               CSEQ0018
      SUBROUTINE XSETPN (LINEWD,ICLR,ISTRT,LINEON,LINELN,INPN)          XSPN0001
C. XSETPN F77     58X5 O/L                               VER01 ZUPET500 XSPN0002
C                                                                       XSPN0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       XSPN0005
C  LIBRARY FUNCTIONS USED - NONE                                        XSPN0006
C  GRAPHICS ROUTINES USED (BUFF)                                        XSPN0007
C                                                                       XSPN0008
      CHARACTER*1 CDUM                                                  XSPN0009
      DIMENSION ISTRT(4), LINEON(4), LINELN(4)                          XSPN0010
C                                                                       XSPN0011
C  MXPEN IS THE MAXIMUM NUMBER OF PENS; VALID RANGE 1 - 32767           XSPN0012
C  CURRENTLY SUPPORTED MAXIMUM NUMBER OF PENS IS 1024                   XSPN0013
      DATA MXPEN/1024/                                                  XSPN0014
C                                                                       XSPN0015
      IF (LINEWD.LT.1) GO TO 20                                         XSPN0016
      IF (LINEWD.GT.16) GO TO 20                                        XSPN0017
      IF (INPN.LT.1) GO TO 20                                           XSPN0018
      IF (INPN.GT.MXPEN) GO TO 20                                       XSPN0019
C  LINE DEFINITION BY SEGMENT APPEARANCE USING LINEON, LINELN, ISTRT    XSPN0020
      DO 10 I=1,4                                                       XSPN0021
         IF (ISTRT(I).LT.0) GO TO 20                                    XSPN0022
         IF (ISTRT(I).GT.16) GO TO 20                                   XSPN0023
         IF (LINEON(I).LT.0) GO TO 20                                   XSPN0024
         IF (LINEON(I).GT.16) GO TO 20                                  XSPN0025
         IF (LINELN(I).LT.0) GO TO 20                                   XSPN0026
         IF (LINELN(I).GT.16) GO TO 20                                  XSPN0027
         IF (LINEON(I).GT.LINELN(I)) GO TO 20                           XSPN0028
         IF (ISTRT(I).GT.LINELN(I)) GO TO 20                            XSPN0029
   10 CONTINUE                                                          XSPN0030
      CALL BUFF (19,0,6,CDUM)                                           XSPN0031
      CALL BUFF (14,1,0,CDUM)                                           XSPN0032
      CALL BUFF (40,1,0,CDUM)                                           XSPN0033
      CALL BUFF (0,1,0,CDUM)                                            XSPN0034
      CALL BUFF (INPN,3,7,CDUM)                                         XSPN0035
      CALL BUFF (LINEWD,1,0,CDUM)                                       XSPN0036
      CALL BUFF (LINEON(2),1,0,CDUM)                                    XSPN0037
      CALL BUFF (LINEON(3),1,0,CDUM)                                    XSPN0038
      CALL BUFF (LINEON(4),1,0,CDUM)                                    XSPN0039
      CALL BUFF (LINEON(1),1,0,CDUM)                                    XSPN0040
      CALL BUFF (LINELN(2),1,0,CDUM)                                    XSPN0041
      CALL BUFF (LINELN(3),1,0,CDUM)                                    XSPN0042
      CALL BUFF (LINELN(4),1,0,CDUM)                                    XSPN0043
      CALL BUFF (LINELN(1),1,0,CDUM)                                    XSPN0044
      CALL BUFF (ISTRT(2),1,0,CDUM)                                     XSPN0045
      CALL BUFF (ISTRT(3),1,0,CDUM)                                     XSPN0046
      CALL BUFF (ISTRT(4),1,0,CDUM)                                     XSPN0047
      CALL BUFF (ISTRT(1),1,0,CDUM)                                     XSPN0048
   20 CONTINUE                                                          XSPN0049
      RETURN                                                            XSPN0050
      END                                                               XSPN0051
      SUBROUTINE NEWLVL (LEVEL)                                         NLVL0001
C. NEWLVL F77     58X5 O/L                               VER01 ZUPEU500 NLVL0002
C                                                                       NLVL0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       NLVL0005
C  LIBRARY FUNCTIONS USED - NONE                                        NLVL0006
C  GRAPHICS ROUTINES USED (BUFF)                                        NLVL0007
C                                                                       NLVL0008
      CHARACTER*1 CDUM                                                  NLVL0009
C                                                                       NLVL0010
C  MXLVL IS THE MAXIMUM NUMBER OF LEVELS AVAILABLE                      NLVL0011
      DATA MXLVL/255/                                                   NLVL0012
      IF (LEVEL.LT.0) GO TO 10                                          NLVL0013
      IF (LEVEL.GT.MXLVL) GO TO 10                                      NLVL0014
      CALL BUFF (4,0,6,CDUM)                                            NLVL0015
      CALL BUFF (14,1,0,CDUM)                                           NLVL0016
      CALL BUFF (38,1,0,CDUM)                                           NLVL0017
      CALL BUFF (LEVEL,2,7,CDUM)                                        NLVL0018
   10 CONTINUE                                                          NLVL0019
      RETURN                                                            NLVL0020
      END                                                               NLVL0021
      SUBROUTINE SETLVL (LEVEL,LVLTYP)                                  SLVL0001
C. SETLVL F77     58X5 O/L                               VER02 ZUPEV500 SLVL0002
C                                                                       SLVL0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       SLVL0005
C  LIBRARY FUNCTIONS USED - NONE                                        SLVL0006
C  GRAPHICS ROUTINES USED (BUFF)                                        SLVL0007
C                                                                       SLVL0008
      CHARACTER*1 CDUM                                                  SLVL0009
C  MXLVL IS THE MAXIMUM NUMBER OF LEVELS AVAILABLE                      SLVL0010
      DATA MXLVL/255/                                                   SLVL0011
C                                                                       SLVL0012
      IF (LEVEL.LT.1) GO TO 10                                          SLVL0013
      IF (LEVEL.GT.MXLVL) GO TO 10                                      SLVL0014
      IF (LVLTYP.LT.0) GO TO 10                                         SLVL0015
      IF (LVLTYP.GT.3) GO TO 10                                         SLVL0016
      CALL BUFF (5,0,6,CDUM)                                            SLVL0017
      CALL BUFF (14,1,0,CDUM)                                           SLVL0018
      CALL BUFF (41,1,0,CDUM)                                           SLVL0019
      CALL BUFF (LEVEL,2,7,CDUM)                                        SLVL0020
      CALL BUFF (LVLTYP,1,0,CDUM)                                       SLVL0021
   10 CONTINUE                                                          SLVL0022
      RETURN                                                            SLVL0023
      END                                                               SLVL0024
      SUBROUTINE DISKIO (IUSER,IOPER,ITABLE)                            DSKI0001
C. DISKIO F77     58X5 O/L                               VER01 ZUPEW500 DSKI0002
C                                                                       DSKI0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       DSKI0005
C  LIBRARY FUNCTIONS USED - NONE                                        DSKI0006
C  GRAPHICS ROUTINES USED (BUFF)                                        DSKI0007
C                                                                       DSKI0008
      CHARACTER*1 CDUM                                                  DSKI0009
      IF (IUSER.LT.0) GO TO 10                                          DSKI0010
      IF (IUSER.GT.9) GO TO 10                                          DSKI0011
      IF (IOPER.LT.1) GO TO 10                                          DSKI0012
      IF (IOPER.GT.2) GO TO 10                                          DSKI0013
      IF (ITABLE.LT.1) GO TO 10                                         DSKI0014
      IF (ITABLE.GT.7) GO TO 10                                         DSKI0015
      CALL BUFF (5,0,6,CDUM)                                            DSKI0016
      CALL BUFF (14,1,0,CDUM)                                           DSKI0017
      CALL BUFF (37,1,0,CDUM)                                           DSKI0018
      CALL BUFF (IUSER,1,0,CDUM)                                        DSKI0019
      CALL BUFF (IOPER,1,0,CDUM)                                        DSKI0020
      CALL BUFF (ITABLE,1,0,CDUM)                                       DSKI0021
   10 CONTINUE                                                          DSKI0022
      RETURN                                                            DSKI0023
      END                                                               DSKI0024
      SUBROUTINE PSTAT                                                  PSTA0001
C. PSTAT  F77     58X5 O/L                               VER01 ZUPEX500 PSTA0002
C                                                                       PSTA0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PSTA0005
C  LIBRARY FUNCTIONS USED - NONE                                        PSTA0006
C  GRAPHICS ROUTINES USED (BUFF)                                        PSTA0007
C                                                                       PSTA0008
      CHARACTER*1 CDUM                                                  PSTA0009
      CALL BUFF (2,0,6,CDUM)                                            PSTA0010
      CALL BUFF (14,1,0,CDUM)                                           PSTA0011
      CALL BUFF (39,1,0,CDUM)                                           PSTA0012
      RETURN                                                            PSTA0013
      END                                                               PSTA0014
      SUBROUTINE AREAFL (ICLR)                                          ARFL0001
C. AREAFL F77     58X5 O/L                               VER01 ZUPEY500 ARFL0002
C                                                                       ARFL0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       ARFL0005
C  LIBRARY FUNCTIONS USED - NONE                                        ARFL0006
C  GRAPHICS ROUTINES USED (BUFF)                                        ARFL0007
C                                                                       ARFL0008
      CHARACTER*1 CDUM                                                  ARFL0009
C                                                                       ARFL0010
C  MXCLR IS THE MAXIMUM NUMBER OF COLORS; VALID RANGE 1 - 32767         ARFL0011
C  CURRENTLY SUPPORTED MAXIMUM NUMBER OF COLORS IS 1024                 ARFL0012
      DATA MXCLR/1024/                                                  ARFL0013
C                                                                       ARFL0014
      IF (ICLR.LT.0) GO TO 10                                           ARFL0015
      IF (ICLR.GT.MXCLR) GO TO 10                                       ARFL0016
      CALL BUFF (5,0,6,CDUM)                                            ARFL0017
      CALL BUFF (14,1,0,CDUM)                                           ARFL0018
      CALL BUFF (44,1,0,CDUM)                                           ARFL0019
      CALL BUFF (ICLR,3,7,CDUM)                                         ARFL0020
   10 CONTINUE                                                          ARFL0021
      RETURN                                                            ARFL0022
      END                                                               ARFL0023
      SUBROUTINE RASFIL (HPIX,WPIX,IMAGH,IMAGW,IARRAY)                  RAFL0001
C. RASFIL F77     58X5 O/L                               VER03 ZUPEZ500 RAFL0002
C                                                                       RAFL0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       RAFL0005
C  LIBRARY FUNCTIONS USED (FLOAT,INT,MIN0,MAX0)                         RAFL0006
C  GRAPHICS ROUTINES USED (BUFF,PLOT)                                   RAFL0007
C                                                                       RAFL0008
C  INPUT: HPIX   X-SIZE (HEIGHT) OF EACH PIXEL IN INCHES OR CENTIMETERS RAFL0009
C         WPIX   Y-SIZE (WIDTH) OF EACH PIXEL IN INCHES OR CENTIMETERS  RAFL0010
C         IMAGH  NUMBER OF LINES IN X DIRECTION                         RAFL0011
C         IMAGW  NUMBER OF PIXELS IN EACH LINE                          RAFL0012
C         IARRAY ONE DIMENSIONAL ARRAY CONTAINING COLOR NUMBERS         RAFL0013
C                                                                       RAFL0014
      CHARACTER*1 CDUM                                                  RAFL0015
      DIMENSION IARRAY(1)                                               RAFL0016
C                                                                       RAFL0017
C  SET THE LIMIT FOR REPEATED ELEMENTS                                  RAFL0018
      DATA ILIM/5/                                                      RAFL0019
      DATA MXCLR/1024/                                                  RAFL0020
      DATA MXREP/32767/                                                 RAFL0021
      DATA ISXBIT/32767/                                                RAFL0022
      DATA ITWBIT/4095/                                                 RAFL0023
      DATA TWBIT/4096.0/                                                RAFL0024
C                                                                       RAFL0025
C  GET STEPSIZE FROM PLOT, CALCULATE INTEGER PORTION OF X, Y PIXEL SIZE RAFL0026
      CALL PLOT (STEP,RDUM,1005)                                        RAFL0027
      XSTEP=HPIX*STEP                                                   RAFL0028
      YSTEP=WPIX*STEP                                                   RAFL0029
      INTX=INT(XSTEP)                                                   RAFL0030
      INTY=INT(YSTEP)                                                   RAFL0031
C  CHECK FOR RANGE OF INPUT PARAMETERS                                  RAFL0032
      IF (INTX.LT.1) GO TO 120                                          RAFL0033
      IF (INTX.GT.ITWBIT) XSTEP=FLOAT(ITWBIT)                           RAFL0034
      IF (INTX.GT.ITWBIT) INTX=ITWBIT                                   RAFL0035
      IF (INTY.LT.1) GO TO 120                                          RAFL0036
      IF (INTY.GT.ITWBIT) YSTEP=FLOAT(ITWBIT)                           RAFL0037
      IF (INTY.GT.ITWBIT) INTY=ITWBIT                                   RAFL0038
      IF (IMAGW.LT.1) GO TO 120                                         RAFL0039
      IF (IMAGW.GT.ISXBIT) GO TO 120                                    RAFL0040
      IF (IMAGH.LT.1) GO TO 120                                         RAFL0041
      IF (IMAGH.GT.ISXBIT) GO TO 120                                    RAFL0042
C  GENERATE 12 BIT FRACTION PORTION FOR X, Y PIXEL SIZE                 RAFL0043
      XTEMP=XSTEP*TWBIT                                                 RAFL0044
      FRAX=XTEMP-FLOAT(INTX)*TWBIT                                      RAFL0045
      IFRAX=INT(FRAX)                                                   RAFL0046
      YTEMP=YSTEP*TWBIT                                                 RAFL0047
      FRAY=YTEMP-FLOAT(INTY)*TWBIT                                      RAFL0048
      IFRAY=INT(FRAY)                                                   RAFL0049
C  GET THE RADIX AND BUFFER SIZE FROM SUBROUTINE BUFF                   RAFL0050
      CALL BUFF (NRAD,NBYTE,12,CDUM)                                    RAFL0051
      IRAD=NRAD                                                         RAFL0052
      IRADSQ=IRAD*IRAD                                                  RAFL0053
      MXBYT=MIN0(NBYTE,IRAD)                                            RAFL0054
      MXARR=IMAGW*IMAGH                                                 RAFL0055
C                                                                       RAFL0056
C  IPIXV IS 1, WHEN DATA IN IARRAY  < RADIX                             RAFL0057
C  IPIXV IS 2, WHEN DATA IN IARRAY  < RADIX * RADIX                     RAFL0058
C  IPIXV IS 3, WHEN DATA IN IARRAY >= RADIX * RADIX                     RAFL0059
      KMAX=IARRAY(1)                                                    RAFL0060
      KMIN=IARRAY(1)                                                    RAFL0061
      DO 10 K=2,MXARR                                                   RAFL0062
         KMAX=MAX0(IARRAY(K),KMAX)                                      RAFL0063
         KMIN=MIN0(IARRAY(K),KMIN)                                      RAFL0064
   10 CONTINUE                                                          RAFL0065
      IPIXV=1                                                           RAFL0066
      IF (KMAX.GE.IRAD) IPIXV=2                                         RAFL0067
      IF (KMAX.GE.IRADSQ) IPIXV=3                                       RAFL0068
      IF (KMAX.GT.MXCLR) GO TO 120                                      RAFL0069
      IF (KMIN.LT.0) GO TO 120                                          RAFL0070
C                                                                       RAFL0071
      CALL BUFF (20,0,6,CDUM)                                           RAFL0072
      CALL BUFF (14,1,0,CDUM)                                           RAFL0073
      CALL BUFF (42,1,0,CDUM)                                           RAFL0074
      CALL BUFF (INTX,INTY,2,CDUM)                                      RAFL0075
      IF (IFRAX.EQ.0.AND.IFRAY.EQ.0) CALL BUFF (38,1,0,CDUM)            RAFL0076
      IF (IFRAX.EQ.0.AND.IFRAY.EQ.0) CALL BUFF (0,1,0,CDUM)             RAFL0077
      CALL BUFF (IFRAX,IFRAY,2,CDUM)                                    RAFL0078
      CALL BUFF (IPIXV,1,0,CDUM)                                        RAFL0079
      CALL BUFF (IMAGH,IMAGW,2,CDUM)                                    RAFL0080
C                                                                       RAFL0081
      IBEG=1                                                            RAFL0082
      IEND=0                                                            RAFL0083
      KPTR=1                                                            RAFL0084
      IREP=1                                                            RAFL0085
      IEOF=0                                                            RAFL0086
   20 CONTINUE                                                          RAFL0087
      IVAL=IARRAY(KPTR)                                                 RAFL0088
C                                                                       RAFL0089
C  CHECK NEXT ELEMENT IN THE ARRAY                                      RAFL0090
   30 CONTINUE                                                          RAFL0091
      KPTR=KPTR+1                                                       RAFL0092
      IF (KPTR.LE.MXARR) GO TO 40                                       RAFL0093
      KPTR=MXARR                                                        RAFL0094
      IF (IREP.EQ.1) IEND=MXARR                                         RAFL0095
      IEOF=1                                                            RAFL0096
      GO TO 60                                                          RAFL0097
   40 CONTINUE                                                          RAFL0098
      IF (IREP.GT.ILIM) GO TO 50                                        RAFL0099
      ITEMP=((KPTR-IBEG)+1)*IPIXV+4                                     RAFL0100
      IF (ITEMP.LT.MXBYT) GO TO 50                                      RAFL0101
C  OUTPUT BUFFER FULL                                                   RAFL0102
      IREP=1                                                            RAFL0103
      IEND=KPTR-1                                                       RAFL0104
      GO TO 60                                                          RAFL0105
C                                                                       RAFL0106
   50 CONTINUE                                                          RAFL0107
      ITEMP=IARRAY(KPTR)                                                RAFL0108
      IF (IVAL.EQ.ITEMP) GO TO 90                                       RAFL0109
      IF (IREP.GT.1) GO TO 100                                          RAFL0110
      IEND=KPTR-1                                                       RAFL0111
      GO TO 20                                                          RAFL0112
C                                                                       RAFL0113
C  OUTPUT NON-COMPRESSED DATA                                           RAFL0114
   60 CONTINUE                                                          RAFL0115
      IF (IBEG.GT.IEND) GO TO 110                                       RAFL0116
      KOUNT=((IEND-IBEG)+1)*IPIXV+1                                     RAFL0117
      CALL BUFF (KOUNT+3,0,6,CDUM)                                      RAFL0118
      CALL BUFF (14,1,0,CDUM)                                           RAFL0119
      CALL BUFF (43,1,0,CDUM)                                           RAFL0120
      CALL BUFF (KOUNT,1,0,CDUM)                                        RAFL0121
      CALL BUFF (0,1,0,CDUM)                                            RAFL0122
C                                                                       RAFL0123
      DO 70 I=IBEG,IEND                                                 RAFL0124
         ITEMP=IARRAY(I)                                                RAFL0125
         CALL BUFF (ITEMP,IPIXV,7,CDUM)                                 RAFL0126
   70 CONTINUE                                                          RAFL0127
      IBEG=IEND+1                                                       RAFL0128
C  CHECK FOR END OF DATA, OUTPUT 'REPEATED' ELEMENTS IF NECESSARY       RAFL0129
      IF (IEOF.NE.1) GO TO 80                                           RAFL0130
      IF (IREP.GT.1) GO TO 110                                          RAFL0131
      GO TO 120                                                         RAFL0132
   80 CONTINUE                                                          RAFL0133
      IF (IREP.GT.1) GO TO 30                                           RAFL0134
      GO TO 20                                                          RAFL0135
C                                                                       RAFL0136
C  PROCESS 'REPEAT' ELEMENTS                                            RAFL0137
   90 CONTINUE                                                          RAFL0138
      IF (IREP.GE.MXREP) GO TO 110                                      RAFL0139
      IREP=IREP+1                                                       RAFL0140
      IF (IBEG.GT.IEND) GO TO 30                                        RAFL0141
      IF (IREP.EQ.ILIM) GO TO 60                                        RAFL0142
      GO TO 30                                                          RAFL0143
C                                                                       RAFL0144
C  IF THERE ARE MORE THAN 5 'REPEATED' ELEMENTS, OUTPUT DATA            RAFL0145
  100 CONTINUE                                                          RAFL0146
      IF (IREP.GE.ILIM) GO TO 110                                       RAFL0147
      IREP=1                                                            RAFL0148
      IEND=KPTR-1                                                       RAFL0149
      GO TO 20                                                          RAFL0150
C                                                                       RAFL0151
C  OUTPUT COMPRESSED DATA                                               RAFL0152
  110 CONTINUE                                                          RAFL0153
      NBYTE=1                                                           RAFL0154
      IF (IREP.GE.IRAD) NBYTE=2                                         RAFL0155
      IF (IREP.GE.IRADSQ) NBYTE=3                                       RAFL0156
      KOUNT=(IPIXV+NBYTE)+1                                             RAFL0157
C                                                                       RAFL0158
      CALL BUFF (KOUNT+3,0,6,CDUM)                                      RAFL0159
      CALL BUFF (14,1,0,CDUM)                                           RAFL0160
      CALL BUFF (43,1,0,CDUM)                                           RAFL0161
      CALL BUFF (KOUNT,1,0,CDUM)                                        RAFL0162
      CALL BUFF (NBYTE,1,0,CDUM)                                        RAFL0163
      CALL BUFF (IREP,NBYTE,7,CDUM)                                     RAFL0164
      CALL BUFF (IVAL,IPIXV,7,CDUM)                                     RAFL0165
      IBEG=KPTR                                                         RAFL0166
      IEND=KPTR-1                                                       RAFL0167
      IREP=1                                                            RAFL0168
      IF (IEOF.EQ.1) GO TO 120                                          RAFL0169
      GO TO 20                                                          RAFL0170
C                                                                       RAFL0171
  120 CONTINUE                                                          RAFL0172
      RETURN                                                            RAFL0173
      END                                                               RAFL0174
      SUBROUTINE SETCHR (CHRHGT,ASPRTO,SLANG,CHRANG,SETMDE)             SETC0001
C. SETCHR FORTRAN IPE                                    VER02 ZUPDA000 SETC0002
C                                                                       SETC0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       SETC0005
C  LIBRARY FUNCTIONS USED (ABS,COS,INT,SIGN,SIN)                        SETC0006
C  GRAPHICS ROUTINES NONE USED                                          SETC0007
C  CHRHGT HEIGHT OF CHARACTER                                           SETC0008
C  ASPECT RATIO                                                         SETC0009
C  SLANG SLANT ANGLE RELATIVE TO CHARACTER STRING ROTATION              SETC0010
C  CHRANG  CHARACTER ANGLE IN RELATION TO CHARACTER PATH ANGLE OF       SETC0011
C          ROTATION. 90 DEGREES NORMAL                                  SETC0012
C  SETMDE SET CHARACTER ALTERATION MODE                                 SETC0013
C     0.0 RE-INITIALIZE TO DEFAULT PARAMETERS                           SETC0014
C    99.0 RETURNS CURRENT VALUE OF SET MODE                             SETC0015
C  -999.0 MODICATION TO PARAMETERS                                      SETC0016
C                                                                       SETC0017
C***LOC312 SAVE VARIABLE VALUE WHEN REENTERING CODE                     SETC0018
C   CURRENT VALUES OF (ASPECT RATIO,HEIGHT,ROTATE,SLANT,SET MODE)       SETC0019
      DATA ASPECK,HTVAL,CRANL,TALICK,SMODE/16.0,0.0,0.0,0.0,0.0/        SETC0020
      DATA ANGTMP,ASPTMP,HTTEMP,SLTEMP/0.0,0.0,0.0,0.0/                 SETC0021
C***LOC312 END.                                                         SETC0022
C   DEFAULT VALUES OF (ASPECT RATIO,HEIGHT,ROTATE,SLANT,SET MODE)       SETC0023
      DATA ASPINT,HTINT,ROTINT,SLAINT,STMINT/16.0,0.0,0.0,0.0,0.0/      SETC0024
C  INITIALIZE CIRCULAR TRANSCENDENTAL NUMBER                            SETC0025
      DATA PI/3.14159/                                                  SETC0026
C                                                                       SETC0027
C  SAVE INPUT VALUES                                                    SETC0028
      IF (INT(SETMDE).NE.99) GO TO 10                                   SETC0029
      SETMDE=SMODE                                                      SETC0030
      GO TO 150                                                         SETC0031
   10 HTTEMP=CHRHGT                                                     SETC0032
      ASPTMP=ASPRTO                                                     SETC0033
      SLTEMP=SLANG                                                      SETC0034
      ANGTMP=CHRANG                                                     SETC0035
      IF (INT(SETMDE).EQ.1000) GO TO 20                                 SETC0036
      SMODE=SETMDE                                                      SETC0037
   20 CONTINUE                                                          SETC0038
C  CHECK FOR MODE                                                       SETC0039
      IF (SETMDE) 30,140,130                                            SETC0040
C  SET MODE FLAG                                                        SETC0041
   30 CONTINUE                                                          SETC0042
      IF (HTTEMP) 40,150,50                                             SETC0043
   40 HTVAL=HTVAL*ABS(HTTEMP)                                           SETC0044
      GO TO 60                                                          SETC0045
   50 CONTINUE                                                          SETC0046
      IF (HTTEMP.NE.999.0) HTVAL=HTTEMP                                 SETC0047
   60 CONTINUE                                                          SETC0048
      IF (ASPTMP.EQ.999.0) GO TO 70                                     SETC0049
      IF (ASPTMP.EQ.0.0) ASPTMP=1.0                                     SETC0050
      ASPECK=ASPTMP*16.0                                                SETC0051
      ASPECK=ASPECK+SIGN(0.005,ASPECK)                                  SETC0052
   70 CONTINUE                                                          SETC0053
      IF (SLTEMP.EQ.999.0) GO TO 120                                    SETC0054
      IF (SLTEMP.EQ.0.0) GO TO 100                                      SETC0055
C  CALCULATE SLANT RATIO                                                SETC0056
C  CALCULATE CHARACTER WIDTH                                            SETC0057
C  CHECK FOR ANGLE LESS THAN +/- 45 DEGREES.                            SETC0058
      IF (ABS(SLTEMP).LT.44.5) GO TO 90                                 SETC0059
C  SET MAXIMUM ANGLE                                                    SETC0060
      IF (SLTEMP.GE.0.0) GO TO 80                                       SETC0061
      SLTEMP=-44.5                                                      SETC0062
      GO TO 90                                                          SETC0063
   80 SLTEMP=44.5                                                       SETC0064
   90 ANGR=SLTEMP*(PI/180.0)                                            SETC0065
      TALICK=SIN(ANGR)/COS(ANGR)                                        SETC0066
      GO TO 110                                                         SETC0067
  100 TALICK=0.0                                                        SETC0068
C  SAVE ASPECT RATIO AND ITALIC RATIO                                   SETC0069
  110 TALICK=TALICK*128.0                                               SETC0070
C  SAVE  CHARACTER ANGLE                                                SETC0071
  120 CONTINUE                                                          SETC0072
      IF (ANGTMP.NE.999.0) CRANL=ANGTMP                                 SETC0073
      GO TO 150                                                         SETC0074
C  VARIABLES TO BE USED BY SYMBOL                                       SETC0075
  130 CHRHGT=HTVAL                                                      SETC0076
      ASPRTO=ASPECK                                                     SETC0077
      SLANG=TALICK                                                      SETC0078
      CHRANG=CRANL                                                      SETC0079
      GO TO 150                                                         SETC0080
C  RE-INITIALIZE PARAMETERS                                             SETC0081
C  SAVE MODE FLAG                                                       SETC0082
  140 CONTINUE                                                          SETC0083
      HTVAL=HTINT                                                       SETC0084
      ASPECK=ASPINT                                                     SETC0085
      TALICK=SLAINT                                                     SETC0086
      CRANL=ROTINT                                                      SETC0087
      SMODE=STMINT                                                      SETC0088
  150 CONTINUE                                                          SETC0089
      RETURN                                                            SETC0090
      END                                                               SETC0091
      SUBROUTINE FONT (CHFNT)                                           FONT0001
C. FONT   F77     907, 951                               VER01 ZUPDB500 FONT0002
C. IPE ONLY                                                             FONT0003
C                                                                       FONT0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       FONT0006
C  LIBRARY FUNCTIONS USED (INT)                                         FONT0007
C  GRAPHICS ROUTINES USED (BUFF)                                        FONT0008
C                                                                       FONT0009
C  0-9   SELECTS 9X5 FONTS                                              FONT0010
C  99.   RETURNS CURRENT VALUE OF CHARACTER SET                         FONT0011
C  -999. DEFAULTS TO 907 CHARACTER SET                                  FONT0012
C                                                                       FONT0013
      CHARACTER*1 CDUM                                                  FONT0014
C     COMMON /CFNT/ FNT                                                 FONT0015
C                                                                       FONT0016
C***LOC306 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          FONT0017
      DATA FNT/-999.0/                                                  FONT0018
C***LOC306 END.                                                         FONT0019
C                                                                       FONT0020
      IF (CHFNT.LT.0.0) GO TO 20                                        FONT0021
      IF (CHFNT.GT.10.0) GO TO 10                                       FONT0022
      CALL BUFF (6,0,6,CDUM)                                            FONT0023
      CALL BUFF (11,1,0,CDUM)                                           FONT0024
      CALL BUFF (0,1,0,CDUM)                                            FONT0025
      CALL BUFF (9,1,0,CDUM)                                            FONT0026
      CALL BUFF (11,1,0,CDUM)                                           FONT0027
      CALL BUFF (7,1,0,CDUM)                                            FONT0028
      IFONT=INT(CHFNT)                                                  FONT0029
      CALL BUFF (IFONT,1,0,CDUM)                                        FONT0030
      FNT=CHFNT                                                         FONT0031
      GO TO 30                                                          FONT0032
   10 CHFNT=FNT                                                         FONT0033
      GO TO 30                                                          FONT0034
   20 CONTINUE                                                          FONT0035
      CALL BUFF (2,0,6,CDUM)                                            FONT0036
      CALL BUFF (14,1,0,CDUM)                                           FONT0037
      CALL BUFF (8,1,0,CDUM)                                            FONT0038
      FNT=CHFNT                                                         FONT0039
   30 CONTINUE                                                          FONT0040
      RETURN                                                            FONT0041
      END                                                               FONT0042
      SUBROUTINE TLRNCE (LVARCS,LVCHAR)                                 TLRN0001
C. TLRNCE F77     907, 951                               VER01 ZUPDC500 TLRN0002
C. IPE ONLY                                                             TLRN0003
C                                                                       TLRN0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       TLRN0006
C  LIBRARY FUNCTIONS USED - NONE                                        TLRN0007
C  GRAPHICS ROUTINES USED (BUFF)                                        TLRN0008
C                                                                       TLRN0009
C  DEFAULT TOLERANCE LEVEL FOR ARCS AND CIRCLES: 1 DEGREE (LEVEL 7)     TLRN0010
C  DEFAULT TOLERANCE LEVEL FOR CHARACTERS: 30 DEGREE (LEVEL 2)          TLRN0011
C  BOTH LEVELS MUST BE SENT EVEN IF ONLY ONE LEVEL IS BEING CHANGED     TLRN0012
C  CHECK FOR SPACE IN BUFFER                                            TLRN0013
C                                                                       TLRN0014
      CHARACTER*1 CDUM                                                  TLRN0015
C     COMMON /CTLR/ LARC,LCHR                                           TLRN0016
C                                                                       TLRN0017
C***LOC307 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          TLRN0018
      DATA LARC,LCHR/7,2/                                               TLRN0019
C***LOC307 END.                                                         TLRN0020
C                                                                       TLRN0021
      IF (LVARCS.NE.99) GO TO 10                                        TLRN0022
      LVARCS=LARC                                                       TLRN0023
      LVCHAR=LCHR                                                       TLRN0024
      GO TO 99                                                          TLRN0025
   10 CONTINUE                                                          TLRN0026
      IF (LVARCS.EQ.999) GO TO 20                                       TLRN0027
      LARC=LVARCS                                                       TLRN0028
   20 CONTINUE                                                          TLRN0029
      IF (LVCHAR.EQ.999) GO TO 30                                       TLRN0030
      LCHR=LVCHAR                                                       TLRN0031
   30 CONTINUE                                                          TLRN0032
      CALL BUFF (6,0,6,CDUM)                                            TLRN0033
      CALL BUFF (11,1,0,CDUM)                                           TLRN0034
      CALL BUFF (0,1,0,CDUM)                                            TLRN0035
      CALL BUFF (8,1,0,CDUM)                                            TLRN0036
      CALL BUFF (11,1,0,CDUM)                                           TLRN0037
      CALL BUFF (LARC,1,0,CDUM)                                         TLRN0038
      CALL BUFF (LCHR,1,0,CDUM)                                         TLRN0039
   99 CONTINUE                                                          TLRN0040
      RETURN                                                            TLRN0041
      END                                                               TLRN0042
      SUBROUTINE NEWPLT                                                 NPLT0001
C. NEWPLT F77     907, 951                               VER02 ZUPDS500 NPLT0002
C. IPE ONLY                                                             NPLT0003
C                                                                       NPLT0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       NPLT0006
C  LIBRARY FUNCTIONS USED - NONE                                        NPLT0007
C  GRAPHICS ROUTINES USED (BUFF)                                        NPLT0008
C                                                                       NPLT0009
      CHARACTER*1 CDUM                                                  NPLT0010
C                                                                       NPLT0011
      CALL BUFF (3,0,6,CDUM)                                            NPLT0012
      CALL BUFF (11,1,0,CDUM)                                           NPLT0013
      CALL BUFF (0,1,0,CDUM)                                            NPLT0014
      CALL BUFF (6,1,0,CDUM)                                            NPLT0015
      RETURN                                                            NPLT0016
      END                                                               NPLT0017
      SUBROUTINE SETPEN (IDENS,IWID,IPEN)                               SETP0001
C. SETPEN F77     58X5 O/L                               VER02 ZUPCU520 SETP0002
C                                                                       SETP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       SETP0005
C  LIBRARY FUNCTIONS USED - NONE                                        SETP0006
C  GRAPHICS ROUTINES USED (BUFF)                                        SETP0007
C                                                                       SETP0008
      CHARACTER*1 CDUM                                                  SETP0009
C                                                                       SETP0010
C  GET RADIX FROM SUBROUTINE BUFF, MAX PEN NO. DEPENDS ON RADIX         SETP0011
      CALL BUFF (IRAD,IDUM,12,CDUM)                                     SETP0012
      MXPEN=IRAD                                                        SETP0013
      IF (IPEN.GE.MXPEN) GO TO 99                                       SETP0014
      IF (IPEN.LT.1) GO TO 99                                           SETP0015
      IF (IDENS.GT.16) GO TO 99                                         SETP0016
      IF (IDENS.LT.1) GO TO 99                                          SETP0017
      IF (IWID.GT.16) GO TO 99                                          SETP0018
      IF (IWID.LT.1) GO TO 99                                           SETP0019
      CALL BUFF (5,0,6,CDUM)                                            SETP0020
      CALL BUFF (14,1,0,CDUM)                                           SETP0021
      CALL BUFF (18,1,0,CDUM)                                           SETP0022
      CALL BUFF (IDENS,1,0,CDUM)                                        SETP0023
      CALL BUFF (IWID,1,0,CDUM)                                         SETP0024
      CALL BUFF (IPEN,1,0,CDUM)                                         SETP0025
   99 CONTINUE                                                          SETP0026
      RETURN                                                            SETP0027
      END                                                               SETP0028
      SUBROUTINE SETPAT (KPAT,NLINES,IPAT)                              SETP0001
C. SETPAT F77     58X5 O/L                               VER02 ZUPCV520 SETP0002
C                                                                       SETP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       SETP0005
C  LIBRARY FUNCTIONS USED (IABS, MOD)                                   SETP0006
C  GRAPHICS ROUTINES USED (BUFF)                                        SETP0007
C                                                                       SETP0008
      CHARACTER*1 CDUM                                                  SETP0009
      DIMENSION KPAT(128)                                               SETP0010
C     COMMON /CSET/ IRAD,MNPAT,MXPAT                                    SETP0011
C  VALID USER DEFINED PATTERNS 16(MNPAT) - 239(MXPAT)                   SETP0012
      DATA MNPAT,MXPAT/16,239/                                          SETP0013
C                                                                       SETP0014
C  NLINES IS NEEDED TO MAINTAIN COMPATIBILITY WITH PLOT 5000 SOFTWARE   SETP0015
      NLINET=NLINES                                                     SETP0016
C  GET THE RADIX FROM SUBROUTINE BUFF                                   SETP0017
      CALL BUFF (NRAD,IDUM,12,CDUM)                                     SETP0018
      IRAD=NRAD                                                         SETP0019
      IF (IPAT.LT.MNPAT) GO TO 50                                       SETP0020
      IF (IPAT.GT.MXPAT) GO TO 50                                       SETP0021
      K=1                                                               SETP0022
      LINE=0                                                            SETP0023
      IPATN=IPAT-15                                                     SETP0024
      DO 40 J=1,32                                                      SETP0025
         IF (IPATN.GE.IRAD) GO TO 10                                    SETP0026
         CALL BUFF (12,0,6,CDUM)                                        SETP0027
         CALL BUFF (14,1,0,CDUM)                                        SETP0028
         CALL BUFF (22,1,0,CDUM)                                        SETP0029
         CALL BUFF (IPATN,1,0,CDUM)                                     SETP0030
         GO TO 20                                                       SETP0031
C  CODE FOR EXTENDED PATTERN MODE                                       SETP0032
   10    CONTINUE                                                       SETP0033
         CALL BUFF (13,0,6,CDUM)                                        SETP0034
         CALL BUFF (14,1,0,CDUM)                                        SETP0035
         CALL BUFF (34,1,0,CDUM)                                        SETP0036
         CALL BUFF (IPATN,2,7,CDUM)                                     SETP0037
   20    CONTINUE                                                       SETP0038
         CALL BUFF (LINE,1,0,CDUM)                                      SETP0039
         DO 30 I=1,4                                                    SETP0040
            IELM=IABS(KPAT(K))                                          SETP0041
            LOWB=MOD(IELM,16)                                           SETP0042
            IHIGHB=IELM/16                                              SETP0043
            CALL BUFF (IHIGHB,1,0,CDUM)                                 SETP0044
            CALL BUFF (LOWB,1,0,CDUM)                                   SETP0045
            K=K+1                                                       SETP0046
   30    CONTINUE                                                       SETP0047
         LINE=LINE+1                                                    SETP0048
   40 CONTINUE                                                          SETP0049
   50 CONTINUE                                                          SETP0050
      RETURN                                                            SETP0051
      END                                                               SETP0052
      SUBROUTINE PATTRN (IPAT)                                          PATT0001
C. PATTRN FORTRAN 58X5                                   VER01 ZUPCT020 PATT0002
C                                                                       PATT0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PATT0005
C  GRAPHICS ROUTINES USED (HATCH)                                       PATT0006
      DIMENSION XP(1), YP(1), NE(1)                                     PATT0007
C                                                                       PATT0008
C  MXPAT IS THE MAXIMUM NUMBER OF PATTERNS AVALIABLE                    PATT0009
      DATA MXPAT/1024/                                                  PATT0010
C                                                                       PATT0011
      IF (IPAT.LT.0) GO TO 10                                           PATT0012
      IF (IPAT.GT.MXPAT) GO TO 10                                       PATT0013
      NE(1)=-IPAT                                                       PATT0014
      CALL HATCH (XP(1),YP(1),NE(1),ANG,DIST,NUM)                       PATT0015
   10 CONTINUE                                                          PATT0016
      RETURN                                                            PATT0017
      END                                                               PATT0018
      SUBROUTINE HATCH (XP,YP,NE,ANG,DISTP,NUM)                         HATC0001
C. HATCH  F77     951, 58X5 O/L                          VER05 ZUPCZ500 HATC0002
C                                                                       HATC0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       HATC0005
C  LIBRARY FUNCTIONS USED (ABS, COS, IABS, INT, MOD, SIGN, SIN, SQRT)   HATC0006
C  GRAPHICS ROUTINES USED (BUFF, PLOT)                                  HATC0007
C                                                                       HATC0008
C  XP,YP - ARRAYS CONTAINING THE COORDINATES OF THE VERTICES            HATC0009
C          THE POLYGON AREAS                                            HATC0010
C  NE    - ONE-DIMENSIONAL ARRAY CONTAINING THE NUMBER OF VERTICES      HATC0011
C          OF EACH POLYGON AREA                                         HATC0012
C  ANG   - ANGLE OF HATCH LINES RELATIVE TO HORIZONTAL.  WHEN           HATC0013
C          FILLING WITH PATTERN,  ANG = 0.                              HATC0014
C  DISTP - DISTANCE BETWEEN HATCH LINE OR PATTERNS                      HATC0015
C  NUM   - NUMBER OF POLYGONAL AREAS.                                   HATC0016
C                                                                       HATC0017
      CHARACTER*1 CDUM                                                  HATC0018
      DIMENSION XP(1), YP(1), XI(40), YI(40)                            HATC0019
      DIMENSION LNK(40), NE(1)                                          HATC0020
C                                                                       HATC0021
C     COMMON /CHAT/IPAT,LARRY,EPS,PI                                    HATC0022
C                                                                       HATC0023
C***LOC304 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          HATC0024
      DATA IPAT/0/                                                      HATC0025
C***LOC304 END.                                                         HATC0026
C                                                                       HATC0027
      DATA LARRY/40/                                                    HATC0028
      DATA EPS/0.0001/                                                  HATC0029
      DATA PI/3.14159/                                                  HATC0030
      DATA DPX1/32767.0/                                                HATC0031
C                                                                       HATC0032
C  LOOP THROUGH THE POLYGON COORDINATE ARRAYS TO DETERMINE              HATC0033
C  MIN-MAX VALUES (LIMITING THE RANGE OF THE HATCH PATTERN              HATC0034
C  AND TO OUTLINE POLYGON AREAS                                         HATC0035
C                                                                       HATC0036
C  CHECK IF CALLED FROM PATTRN                                          HATC0037
      DIST=DISTP                                                        HATC0038
      NOC=NUM                                                           HATC0039
      IF (NE(1).GT.0) GO TO 10                                          HATC0040
      IPAT=IABS(NE(1))                                                  HATC0041
      GO TO 999                                                         HATC0042
   10 CONTINUE                                                          HATC0043
      IF (NOC.GE.0) GO TO 20                                            HATC0044
      IPEN=2                                                            HATC0045
      GO TO 30                                                          HATC0046
   20 IPEN=3                                                            HATC0047
   30 CONTINUE                                                          HATC0048
      NOC=IABS(NOC)                                                     HATC0049
      IF (IPAT.LE.0) GO TO 60                                           HATC0050
      IST=1                                                             HATC0051
C  IF THE COLOR NO. IS LESS THAN OR EQUAL TO 47, USE 951 NORMAL COMMAND HATC0052
      IRAD=48                                                           HATC0053
      IF (IPAT.LT.IRAD) GO TO 32                                        HATC0054
C  CALL BUFF TO GET THE RADIX                                           HATC0055
      CALL BUFF (NRAD,IDUM,12,CDUM)                                     HATC0056
      IRAD=NRAD                                                         HATC0057
   32 CONTINUE                                                          HATC0058
      DO 50 I=1,NOC                                                     HATC0059
         XTMP1=XP(IST)                                                  HATC0060
         YTMP1=YP(IST)                                                  HATC0061
         CALL PLOT (XTMP1,YTMP1,3)                                      HATC0062
         IF (IPAT.GE.IRAD) GO TO 35                                     HATC0063
C  CODE FOR NORMAL 951 PATTERN COMMAND                                  HATC0064
         CALL BUFF (5,0,6,CDUM)                                         HATC0065
         CALL BUFF (14,1,0,CDUM)                                        HATC0066
         CALL BUFF (21,1,0,CDUM)                                        HATC0067
         CALL BUFF (IPAT,1,0,CDUM)                                      HATC0068
         GO TO 38                                                       HATC0069
C  CODE FOR EXTENDED COLOR PALETTE MODE (58X5)                          HATC0070
   35    CONTINUE                                                       HATC0071
         CALL BUFF (7,0,6,CDUM)                                         HATC0072
         CALL BUFF (14,1,0,CDUM)                                        HATC0073
         CALL BUFF (33,1,0,CDUM)                                        HATC0074
         CALL BUFF (IPAT,3,7,CDUM)                                      HATC0075
   38    CONTINUE                                                       HATC0076
         CALL PLOT (XINC,RDUM,1005)                                     HATC0077
         NVERT=IABS(NE(I))                                              HATC0078
         II=IABS(NE(I))+IST-1                                           HATC0079
      DO 45 K=IST,II                                                    HATC0080
         K1=K                                                           HATC0081
         IF(II-K1) 41,43,41                                             HATC0082
 41      XDELTA=XP(K)-XP(K+1)                                           HATC0083
         YDELTA=YP(K)-YP(K+1)                                           HATC0084
C TEST FOR IDENTICAL COORDINATES                                        HATC0085
      PDIST=((XP(K)-XP(K+1))*XINC)*((XP(K)-XP(K+1))*XINC)+              HATC0086
     *      ((YP(K)-YP(K+1))*XINC)*((YP(K)-YP(K+1))*XINC)               HATC0087
         IF(PDIST.LE.1.0) NVERT=NVERT-1                                 HATC0088
         GO TO 44                                                       HATC0089
 43      XDELTA=XP(K)-XTMP1                                             HATC0090
         YDELTA=YP(K)-YTMP1                                             HATC0091
C TEST FOR IDENTICAL COORDINATES                                        HATC0092
      PDIST=((XP(K)-XTMP1)*XINC)*((XP(K)-XTMP1)*XINC)+                  HATC0093
     *      ((YP(K)-YTMP1)*XINC)*((YP(K)-YTMP1)*XINC)                   HATC0094
         IF(PDIST.LE.1.0) NVERT=NVERT-1                                 HATC0095
 44      XDELTA=ABS(XDELTA)                                             HATC0096
         YDELTA=ABS(YDELTA)                                             HATC0097
         IXXTRA=(XDELTA*XINC)/DPX1                                      HATC0098
         KYXTRA=(YDELTA*XINC)/DPX1                                      HATC0099
         NVERT=NVERT+MAX0(IXXTRA,KYXTRA)                                HATC0100
 45      CONTINUE                                                       HATC0101
         IHIGHB=NVERT/64                                                HATC0102
         LOWB=MOD(NVERT,64)                                             HATC0103
         CALL BUFF (IHIGHB,1,0,JDUM)                                    HATC0104
         CALL BUFF (LOWB,1,0,JDUM)                                      HATC0105
         KST=IST+1                                                      HATC0106
         DO 47 J=KST,II                                                 HATC0107
C TEST FOR NO DELTA MOVES;  EXIT IF POINTS IDENTICAL                    HATC0108
      PDIST=((XP(J-1)-XP(J))*XINC)*((XP(J-1)-XP(J))*XINC)+              HATC0109
     *      ((YP(J-1)-YP(J))*XINC)*((YP(J-1)-YP(J))*XINC)               HATC0110
         IF(PDIST.LE.1.0) GO TO 47                                      HATC0111
            XTMP2=XP(J)                                                 HATC0112
            YTMP2=YP(J)                                                 HATC0113
            CALL PLOT (XTMP2,YTMP2,IPEN)                                HATC0114
   47    CONTINUE                                                       HATC0115
         CALL PLOT (XTMP1,YTMP1,IPEN)                                   HATC0116
         IST=II+1                                                       HATC0117
   50 CONTINUE                                                          HATC0118
      GO TO 999                                                         HATC0119
   60 CONTINUE                                                          HATC0120
      IF (DIST.LT.EPS) DIST=0.1                                         HATC0121
      DO 70 I=1,NOC                                                     HATC0122
         IF (NE(I).LE.0) GO TO 999                                      HATC0123
   70 CONTINUE                                                          HATC0124
C                                                                       HATC0125
      IST=1                                                             HATC0126
      XMIN=XP(IST)                                                      HATC0127
      YMIN=YP(IST)                                                      HATC0128
      XMAX=XP(IST)                                                      HATC0129
      YMAX=YP(IST)                                                      HATC0130
      DO 90 II=1,NOC                                                    HATC0131
         XTMP1=XP(IST)                                                  HATC0132
         YTMP1=YP(IST)                                                  HATC0133
         CALL PLOT (XTMP1,YTMP1,3)                                      HATC0134
         NPTS=NE(II)+IST-1                                              HATC0135
         DO 80 I=IST,NPTS                                               HATC0136
            IF (XP(I).LT.XMIN) XMIN=XP(I)                               HATC0137
            IF (YP(I).LT.YMIN) YMIN=YP(I)                               HATC0138
            IF (XP(I).GT.XMAX) XMAX=XP(I)                               HATC0139
            IF (YP(I).GT.YMAX) YMAX=YP(I)                               HATC0140
            XTMP2=XP(I)                                                 HATC0141
            YTMP2=YP(I)                                                 HATC0142
            IF (IPEN.EQ.2) CALL PLOT (XTMP2,YTMP2,IPEN)                 HATC0143
   80    CONTINUE                                                       HATC0144
         IF (IPEN.EQ.2) CALL PLOT (XTMP1,YTMP1,IPEN)                    HATC0145
         IST=NPTS+1                                                     HATC0146
   90 CONTINUE                                                          HATC0147
C  SINE AND COSINE OF THE HATCH VECTOR ARE:                             HATC0148
      ANGR=ANG*(PI/180.0)                                               HATC0149
      HSIN=SIN(ANGR)                                                    HATC0150
      HCOS=COS(ANGR)                                                    HATC0151
C  HATCH VECTOR STARTPOINT IS:                                          HATC0152
      HXS=XMIN                                                          HATC0153
      HYS=YMAX                                                          HATC0154
      IF (HSIN.LT.0.0) HXS=XMAX                                         HATC0155
      IF (HCOS.LT.0.0) HYS=YMIN                                         HATC0156
C                                                                       HATC0157
C  DETERMINE THE NUMBER OF HATCH LINES REQUIRED TO                      HATC0158
C  COVER THE MIN-MAX AREA.                                              HATC0159
C                                                                       HATC0160
      RTMP1=(XMIN+XMAX-2.*HXS)*HSIN                                     HATC0161
      RTMP2=(RTMP1-(YMIN+YMAX-2.*HYS)*HCOS)/DIST                        HATC0162
      NHTCH=INT(RTMP2)+1                                                HATC0163
C  THE COMPONENTS OF THE NORMAL DISPLACEMENT BETWEEN HATCH LINES        HATC0164
      DDX=DIST*HSIN                                                     HATC0165
      DDY=-DIST*HCOS                                                    HATC0166
      HXS=HXS-DDX                                                       HATC0167
      HYS=HYS-DDY                                                       HATC0168
C                                                                       HATC0169
C  BEGIN THE CROSSHATCH LOOP                                            HATC0170
C                                                                       HATC0171
      KXY=INT(1.8+SIGN(0.5,ABS(HSIN)-ABS(HCOS)))                        HATC0172
      DO 200 J=1,NHTCH                                                  HATC0173
C                                                                       HATC0174
         HXS=HXS+DDX                                                    HATC0175
         HYS=HYS+DDY                                                    HATC0176
         NTPNT=0                                                        HATC0177
C                                                                       HATC0178
C  BEGIN ACCESSING THE POLYGON VECTORS. NOTE: EACH                      HATC0179
C  AREA IS TREATED INDEPENDENTLY OF THE OTHERS                          HATC0180
C                                                                       HATC0181
         IST=1                                                          HATC0182
         DO 130 II=1,NOC                                                HATC0183
            IFIN=IST+NE(II)-1                                           HATC0184
            XS=XP(IFIN)                                                 HATC0185
            YS=YP(IFIN)                                                 HATC0186
            LRBEG=INT(SIGN(1.0,HCOS*(YS-HYS)-HSIN*(XS-HXS)))            HATC0187
            DO 120 I=IST,IFIN                                           HATC0188
               XE=XP(I)                                                 HATC0189
               YE=YP(I)                                                 HATC0190
C                                                                       HATC0191
C  DOES THE POLYGON VECTOR CROSS THE HATCH VECTOR?                      HATC0192
C  IF NOT, JUST IGNORE IT AND GO ON TO NEXT ONE.                        HATC0193
C                                                                       HATC0194
               LREND=INT(SIGN(1.0,HCOS*(YE-HYS)-HSIN*(XE-HXS)))         HATC0195
               IF (LRBEG.EQ.LREND) GO TO 110                            HATC0196
C                                                                       HATC0197
C  IF IT DOES, COMPUTE THE INTERSECTION COORDINATES.                    HATC0198
               IF (NTPNT.EQ.LARRY) GO TO 100                            HATC0199
               NTPNT=NTPNT+1                                            HATC0200
C                                                                       HATC0201
               VDX=XE-XS                                                HATC0202
               VDY=YE-YS                                                HATC0203
               HYP=SQRT(VDX*VDX+VDY*VDY)                                HATC0204
               VSIN=VDY/HYP                                             HATC0205
               VCOS=VDX/HYP                                             HATC0206
               CON=((XS-HXS)*VSIN-(YS-HYS)*VCOS)/(HCOS*VSIN-HSIN*VCOS)  HATC0207
               XI(NTPNT)=HXS+CON*HCOS                                   HATC0208
               YI(NTPNT)=HYS+CON*HSIN                                   HATC0209
C  PROCEED TO DO THE NEXT VECTOR                                        HATC0210
  100          LRBEG=LREND                                              HATC0211
  110          XS=XE                                                    HATC0212
               YS=YE                                                    HATC0213
  120       CONTINUE                                                    HATC0214
            IST=IFIN+1                                                  HATC0215
  130    CONTINUE                                                       HATC0216
C                                                                       HATC0217
C  THE ENTIRE POLYGON HAS NOW BEEN SCANNED FOR VALID INTERSECTION       HATC0218
C  POINTS WITH THE CURRENT HATCH LINE.  THESE POINTS ARE IN RA          HATC0219
C  RANDOM SEQUENCE IN THE FIRST 'NTPNT' ELEMENTS OF THE XI,YI           HATC0220
C  ARRAYS.  THESE POINTS MUST BE ORCERED AND THEN OUTPUT TO THE         HATC0221
C  GRAPHING DEVICE USING ALTERNATE PEN-UP AND PEN-DOWN MOVES.           HATC0222
C                                                                       HATC0223
         INLNK=NTPNT+1                                                  HATC0224
         LNK(INLNK)=0                                                   HATC0225
         IF (NTPNT.LE.0) GO TO 200                                      HATC0226
         DO 180 KNT=1,NTPNT                                             HATC0227
            IND=INLNK                                                   HATC0228
  140       NXT=LNK(IND)                                                HATC0229
            IF (NXT.EQ.0) GO TO 170                                     HATC0230
            TEMP1=XI(KNT)                                               HATC0231
            TEMP2=XI(NXT)                                               HATC0232
            IF (KXY.EQ.1) GO TO 145                                     HATC0233
            TEMP1=YI(KNT)                                               HATC0234
            TEMP2=YI(NXT)                                               HATC0235
  145       CONTINUE                                                    HATC0236
            IF (TEMP1-TEMP2) 150,160,170                                HATC0237
  150       IND=NXT                                                     HATC0238
            GO TO 140                                                   HATC0239
  160       LNK(IND)=LNK(NXT)                                           HATC0240
            GO TO 180                                                   HATC0241
  170       LNK(IND)=KNT                                                HATC0242
            LNK(KNT)=NXT                                                HATC0243
  180    CONTINUE                                                       HATC0244
C                                                                       HATC0245
         NXT=LNK(INLNK)                                                 HATC0246
  190    CONTINUE                                                       HATC0247
         IF (NXT.EQ.0) GO TO 200                                        HATC0248
C                                                                       HATC0249
C  HATCH LINES                                                          HATC0250
         XTMP1=XI(NXT)                                                  HATC0251
         YTMP1=YI(NXT)                                                  HATC0252
         CALL PLOT (XTMP1,YTMP1,3)                                      HATC0253
         NXT=LNK(NXT)                                                   HATC0254
         XTMP1=XI(NXT)                                                  HATC0255
         YTMP1=YI(NXT)                                                  HATC0256
         CALL PLOT (XTMP1,YTMP1,2)                                      HATC0257
         NXT=LNK(NXT)                                                   HATC0258
         GO TO 190                                                      HATC0259
C                                                                       HATC0260
  200 CONTINUE                                                          HATC0261
  999 CONTINUE                                                          HATC0262
      RETURN                                                            HATC0263
      END                                                               HATC0264
      SUBROUTINE PSYMBL (IBCD,NCHAR)                                    PSYM0001
C. PSYMBL F77     951                                    VER01 ZUPDO500 PSYM0002
C                                                                       PSYM0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PSYM0005
C  LIBRARY FUNCTIONS USED - NONE                                        PSYM0006
C  GRAPHICS ROUTINES USED (BUFF)                                        PSYM0007
C                                                                       PSYM0008
C  GENERATE (06,18,00,00,NC,STRING)                                     PSYM0009
      CHARACTER*1 IBCD                                                  PSYM0010
      CHARACTER*1 CDUM                                                  PSYM0011
C                                                                       PSYM0012
C  GENERATE SYMBOL CALL WITH XAX=YAY=0 FOR RASTER PRINT                 PSYM0013
      NC=NCHAR                                                          PSYM0014
      CALL BUFF (NC+4,0,6,CDUM)                                         PSYM0015
      CALL BUFF (6,1,0,CDUM)                                            PSYM0016
      CALL BUFF (24,1,0,CDUM)                                           PSYM0017
      CALL BUFF (0,1,0,CDUM)                                            PSYM0018
      CALL BUFF (0,1,0,CDUM)                                            PSYM0019
      CALL BUFF (0,NC,11,IBCD)                                          PSYM0020
      RETURN                                                            PSYM0021
      END                                                               PSYM0022
      SUBROUTINE TOF                                                    TOF 0001
C. TOF    F77     951                                    VER01 ZUPDP500 TOF 0002
C                                                                       TOF 0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       TOF 0005
C  LIBRARY FUNCTIONS USED - NONE                                        TOF 0006
C  GRAPHICS ROUTINES USED (BUFF)                                        TOF 0007
C                                                                       TOF 0008
      CHARACTER*1 CDUM                                                  TOF 0009
C                                                                       TOF 0010
C  GENERATE (0E 13 01)                                                  TOF 0011
      CALL BUFF (3,0,6,CDUM)                                            TOF 0012
      CALL BUFF (14,1,0,CDUM)                                           TOF 0013
      CALL BUFF (19,1,0,CDUM)                                           TOF 0014
      CALL BUFF (1,1,0,CDUM)                                            TOF 0015
      RETURN                                                            TOF 0016
      END                                                               TOF 0017
      SUBROUTINE CUT                                                    CUT 0001
C. CUT    F77     951                                    VER01 ZUPDM500 CUT 0002
C                                                                       CUT 0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       CUT 0005
C  LIBRARY FUNCTIONS USED - NONE                                        CUT 0006
C  GRAPHICS ROUTINES USED (BUFF)                                        CUT 0007
C                                                                       CUT 0008
C  GENERATE (0E 13 00)                                                  CUT 0009
      CHARACTER*1 CDUM                                                  CUT 0010
C                                                                       CUT 0011
      CALL BUFF (3,0,6,CDUM)                                            CUT 0012
      CALL BUFF (14,1,0,CDUM)                                           CUT 0013
      CALL BUFF (19,1,0,CDUM)                                           CUT 0014
      CALL BUFF (0,1,0,CDUM)                                            CUT 0015
      RETURN                                                            CUT 0016
      END                                                               CUT 0017
      SUBROUTINE NEGATE (NGFLG)                                         NEGA0001
C. NEGATE F77     951                                    VER01 ZUPCR500 NEGA0002
C                                                                       NEGA0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       NEGA0005
C  LIBRARY FUNCTIONS USED - NONE                                        NEGA0006
C  GRAPHICS ROUTINES USED (BUFF)                                        NEGA0007
C                                                                       NEGA0008
      CHARACTER*1 CDUM                                                  NEGA0009
C                                                                       NEGA0010
      IF (NGFLG.LT.0) GO TO 99                                          NEGA0011
      IF (NGFLG.GT.1) GO TO 99                                          NEGA0012
      CALL BUFF (3,0,6,CDUM)                                            NEGA0013
      CALL BUFF (14,1,0,CDUM)                                           NEGA0014
      CALL BUFF (17,1,0,CDUM)                                           NEGA0015
      CALL BUFF (NGFLG,1,0,CDUM)                                        NEGA0016
   99 CONTINUE                                                          NEGA0017
      RETURN                                                            NEGA0018
      END                                                               NEGA0019
      SUBROUTINE PCOPY (NCOPY)                                          PCOP0001
C. PCOPY  F77     951                                    VER01 ZUPCQ500 PCOP0002
C                                                                       PCOP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PCOP0005
C  LIBRARY FUNCTIONS USED - NONE                                        PCOP0006
C  GRAPHICS ROUTINES USED (BUFF)                                        PCOP0007
C                                                                       PCOP0008
      CHARACTER*1 CDUM                                                  PCOP0009
      DATA MXCPY/63/                                                    PCOP0011
C                                                                       PCOP0012
      ICOPY=NCOPY                                                       PCOP0013
      IF (ICOPY.LT.1) ICOPY=1                                           PCOP0014
      IF (ICOPY.GT.MXCPY) ICOPY=1                                       PCOP0015
      CALL BUFF (3,0,6,CDUM)                                            PCOP0016
      CALL BUFF (14,1,0,CDUM)                                           PCOP0017
      CALL BUFF (27,1,0,CDUM)                                           PCOP0018
      CALL BUFF (ICOPY,1,0,CDUM)                                        PCOP0019
      RETURN                                                            PCOP0020
      END                                                               PCOP0021
      SUBROUTINE PTYPE (ICHANL)                                         PTYP0001
C. PTYPE  F77     951                                    VER01 ZUPCW500 PTYP0002
C                                                                       PTYP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PTYP0005
C  LIBRARY FUNCTIONS USED - NONE                                        PTYP0006
C  GRAPHICS ROUTINES USED (BUFF)                                        PTYP0007
C                                                                       PTYP0008
C  THE FOLLOWING CODE CHECKS IF PTYPE HAS BEEN CALLED ONCE.             PTYP0009
C  IF SO, RETURNS; OTHERWISE SETS FLAG AND DUMPS CODE .                 PTYP0010
C                                                                       PTYP0011
      CHARACTER*1 CDUM                                                  PTYP0012
C                                                                       PTYP0013
      CALL BUFF (IDUM,IPFLG,10,CDUM)                                    PTYP0014
      IF (IPFLG.NE.0) GO TO 99                                          PTYP0015
      CALL BUFF (IDUM,1,9,CDUM)                                         PTYP0016
      ICHAN=ICHANL                                                      PTYP0017
      IF (ICHAN.LT.0) ICHAN=0                                           PTYP0018
      IF (ICHAN.GT.8) ICHAN=8                                           PTYP0019
      CALL BUFF (3,0,6,CDUM)                                            PTYP0020
      CALL BUFF (14,1,0,CDUM)                                           PTYP0021
      CALL BUFF (26,1,0,CDUM)                                           PTYP0022
      CALL BUFF (ICHAN,1,0,CDUM)                                        PTYP0023
   99 CONTINUE                                                          PTYP0024
      RETURN                                                            PTYP0025
      END                                                               PTYP0026
      SUBROUTINE FCEPLT                                                 FCEP0001
C. FCEPLT F77     951                                    VER01 ZUPCS500 FCEP0002
C                                                                       FCEP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       FCEP0005
C  LIBRARY FUNCTIONS USED - NONE                                        FCEP0006
C  GRAPHICS ROUTINES USED (BUFF)                                        FCEP0007
C                                                                       FCEP0008
      CHARACTER*1 CDUM                                                  FCEP0009
C                                                                       FCEP0010
      CALL BUFF (4,0,6,CDUM)                                            FCEP0011
      CALL BUFF (14,1,0,CDUM)                                           FCEP0012
      CALL BUFF (25,1,0,CDUM)                                           FCEP0013
      CALL BUFF (14,1,0,CDUM)                                           FCEP0014
      CALL BUFF (24,1,0,CDUM)                                           FCEP0015
      RETURN                                                            FCEP0016
      END                                                               FCEP0017
      SUBROUTINE ROTATE (IROTAT)                                        ROTA0001
C. ROTATE F77     951, 907IPE                            VER01 ZUPCP500 ROTA0002
C                                                                       ROTA0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       ROTA0005
C  LIBRARY FUNCTIONS USED (MOD)                                         ROTA0006
C  GRAPHICS ROUTINES USED (BUFF)                                        ROTA0007
C                                                                       ROTA0008
      CHARACTER*1 CDUM                                                  ROTA0009
C     COMMON /CROT/IOLDR                                                ROTA0010
C                                                                       ROTA0011
C***LOC301 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          ROTA0012
      DATA IOLDR/0/                                                     ROTA0013
C***LOC301 END.                                                         ROTA0014
C                                                                       ROTA0015
      IROT=MOD(IROTAT,360)                                              ROTA0016
      IF (IROT.EQ.IOLDR) GO TO 99                                       ROTA0017
      CALL BUFF (4,0,6,CDUM)                                            ROTA0018
      CALL BUFF (14,1,0,CDUM)                                           ROTA0019
      CALL BUFF (31,1,0,CDUM)                                           ROTA0020
      JROT=IROT/16                                                      ROTA0021
      CALL BUFF (JROT,1,0,CDUM)                                         ROTA0022
      JROT=MOD(IROT,16)                                                 ROTA0023
      CALL BUFF (JROT,1,0,CDUM)                                         ROTA0024
      IOLDR=IROT                                                        ROTA0025
   99 CONTINUE                                                          ROTA0026
      RETURN                                                            ROTA0027
      END                                                               ROTA0028
      SUBROUTINE MIRROR (IMIR)                                          MIRR0001
C. MIRROR F77     951, 907IPE                            VER01 ZUPCX500 MIRR0002
C                                                                       MIRR0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       MIRR0005
C  LIBRARY FUNCTIONS USED - NONE                                        MIRR0006
C  GRAPHICS ROUTINES USED (BUFF)                                        MIRR0007
C                                                                       MIRR0008
      CHARACTER*1 CDUM                                                  MIRR0009
C                                                                       MIRR0010
      IF (IMIR.LT.0) GO TO 99                                           MIRR0011
      IF (IMIR.GT.3) GO TO 99                                           MIRR0012
      CALL BUFF (3,0,6,CDUM)                                            MIRR0013
      CALL BUFF (14,1,0,CDUM)                                           MIRR0014
      CALL BUFF (29,1,0,CDUM)                                           MIRR0015
      CALL BUFF (IMIR,1,0,CDUM)                                         MIRR0016
   99 CONTINUE                                                          MIRR0017
      RETURN                                                            MIRR0018
      END                                                               MIRR0019
      SUBROUTINE WINDOW (INEX,XMIN,YMIN,XMAX,YMAX)                      WIND0001
C. WINDOW F77     951, 907IPE                            VER01 ZUPCY500 WIND0002
C                                                                       WIND0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       WIND0005
C  LIBRARY FUNCTIONS USED - NONE                                        WIND0006
C  GRAPHICS ROUTINES USED (BUFF, PLOT, WHERE)                           WIND0007
C                                                                       WIND0008
      CHARACTER*1 CDUM                                                  WIND0009
C     COMMON /CWIN/XORG,YORG                                            WIND0010
      DATA XORG,YORG/2*0.0/                                             WIND0011
C                                                                       WIND0012
      IF (INEX.LT.0) GO TO 99                                           WIND0013
      IF (INEX.GT.1) GO TO 99                                           WIND0014
      XMINI=XMIN                                                        WIND0015
      YMINI=YMIN                                                        WIND0016
      XMAXI=XMAX                                                        WIND0017
      YMAXI=YMAX                                                        WIND0018
      CALL WHERE (XORG,YORG,FACT)                                       WIND0019
      CALL PLOT (XMINI,YMINI,3)                                         WIND0020
      CALL BUFF (4,0,6,CDUM)                                            WIND0021
      CALL BUFF (14,1,0,CDUM)                                           WIND0022
      CALL BUFF (30,1,0,CDUM)                                           WIND0023
      CALL BUFF (INEX,1,0,CDUM)                                         WIND0024
      CALL BUFF (0,1,0,CDUM)                                            WIND0025
C                                                                       WIND0026
      CALL PLOT (XMAXI,YMAXI,3)                                         WIND0027
      CALL BUFF (4,0,6,CDUM)                                            WIND0028
      CALL BUFF (14,1,0,CDUM)                                           WIND0029
      CALL BUFF (30,1,0,CDUM)                                           WIND0030
      CALL BUFF (INEX,1,0,CDUM)                                         WIND0031
      CALL BUFF (1,1,0,CDUM)                                            WIND0032
      CALL PLOT (XORG,YORG,3)                                           WIND0033
   99 CONTINUE                                                          WIND0034
      RETURN                                                            WIND0035
      END                                                               WIND0036
      SUBROUTINE USRSYM (ISYMB,IARRAY,ICNT)                             USRS0001
C. USRSYM F77     907, 951                               VER01 ZUPCL500 USRS0002
C                                                                       USRS0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       USRS0005
C  LIBRARY FUNCTIONS USED - MOD, IABS                                   USRS0006
C  GRAPHICS ROUTINES USED (BUFF)                                        USRS0007
C                                                                       USRS0008
C  ISYMB  -- INTEGER CODE FOR SYMBOL TO BE DEFINED.  SAME AS IN         USRS0009
C            SYMBOL ROUTINE -1 CALL.  MUST BE IN RANGE 288-479.         USRS0010
C  IARRAY -- INTEGER ARRAY OF OFFSETS, X*100+Y                          USRS0011
C  ICNT   -- COUNT OF OFFSETS DEFINING THIS SYMBOL IN IARRAY.           USRS0012
C            IF ICNT = -1001, ERASE USER SET 1 (CHARS 288-383)          USRS0013
C            IF ICNT = -1002, ERASE USER SET 2 (CHARS 384-479)          USRS0014
C                                                                       USRS0015
      CHARACTER*1 CDUM                                                  USRS0016
      DIMENSION IARRAY(1)                                               USRS0017
      DATA ICMAX/60/                                                    USRS0019
C                                                                       USRS0020
      IF (ICNT.LT.0) GO TO 80                                           USRS0021
      IF (ICNT.GT.ICMAX) GO TO 110                                      USRS0022
      IF (ISYMB.LT.288) GO TO 110                                       USRS0023
      IF (ISYMB.GT.479) GO TO 110                                       USRS0024
C  ISYMB AND ICNT ARE OK, SELECT SYMBOL SET                             USRS0025
      ISET=ISYMB/96+8                                                   USRS0026
      CALL BUFF (2,0,6,CDUM)                                            USRS0027
      CALL BUFF (14,1,0,CDUM)                                           USRS0028
      CALL BUFF (ISET,1,0,CDUM)                                         USRS0029
C  SEND DEFINITION                                                      USRS0030
      I=5+2*(ICNT+3)                                                    USRS0031
      CALL BUFF (I,0,6,CDUM)                                            USRS0032
      CALL BUFF (14,1,0,CDUM)                                           USRS0033
      CALL BUFF (13,1,0,CDUM)                                           USRS0034
      I=MOD(ISYMB,96)/16                                                USRS0035
      CALL BUFF (I,1,0,CDUM)                                            USRS0036
      I=MOD(ISYMB,16)                                                   USRS0037
      CALL BUFF (I,1,0,CDUM)                                            USRS0038
      IF (ICNT.GT.0) GO TO 10                                           USRS0039
      CALL BUFF (ICNT,1,0,CDUM)                                         USRS0040
      GO TO 110                                                         USRS0041
   10 CONTINUE                                                          USRS0042
      CALL BUFF (ICNT+3,1,0,CDUM)                                       USRS0043
C                                                                       USRS0044
      IFFLAG=0                                                          USRS0045
      DO 40 I=1,ICNT                                                    USRS0046
         IX=MOD(IARRAY(I)/100,16)                                       USRS0047
         IY=MOD(MOD(IARRAY(I),100),16)                                  USRS0048
C  TEST FOR IX=15 (SPECIAL OFFSET); IY=0 (PEN UP OFFSET)                USRS0049
         IF (IX.NE.15) GO TO 30                                         USRS0050
         IF (IY.LE.0) GO TO 30                                          USRS0051
         IFFLAG=1                                                       USRS0052
C  TEST FOR IY=15 SPECIAL REORIGIN OFFSET                               USRS0053
C  CHECK THAT REORIGIN OFSET IS FIRST IN THE ARRAY                      USRS0054
         IF (IY.NE.15) GO TO 40                                         USRS0055
         IF (I.NE.1) GO TO 40                                           USRS0056
C  REPLACE ABOVE WITH FOLLOWING IF                                      USRS0057
C  OTHER OFFSET VALUES ARE ALLOWED                                      USRS0058
   30    CONTINUE                                                       USRS0059
         CALL BUFF (IX,1,0,CDUM)                                        USRS0060
         CALL BUFF (IY,1,0,CDUM)                                        USRS0061
   40 CONTINUE                                                          USRS0062
      IF (IFFLAG-1) 50,70,110                                           USRS0063
   50 CONTINUE                                                          USRS0064
      CALL BUFF (15,1,0,CDUM)                                           USRS0065
      CALL BUFF (0,1,0,CDUM)                                            USRS0066
      CALL BUFF (0,1,0,CDUM)                                            USRS0067
      CALL BUFF (0,1,0,CDUM)                                            USRS0068
   60 CONTINUE                                                          USRS0069
      CALL BUFF (15,1,0,CDUM)                                           USRS0070
      CALL BUFF (15,1,0,CDUM)                                           USRS0071
      GO TO 110                                                         USRS0072
   70 CONTINUE                                                          USRS0073
      CALL BUFF (15,1,0,CDUM)                                           USRS0074
      CALL BUFF (0,1,0,CDUM)                                            USRS0075
      CALL BUFF (7,1,0,CDUM)                                            USRS0076
      CALL BUFF (7,1,0,CDUM)                                            USRS0077
      GO TO 60                                                          USRS0078
C                                                                       USRS0079
C  ERASE USER SYMBOL SET                                                USRS0080
   80 CONTINUE                                                          USRS0081
      IF (ICNT.EQ.-1001) GO TO 100                                      USRS0082
      IF (ICNT.EQ.-1002) GO TO 100                                      USRS0083
      GO TO 110                                                         USRS0084
C  SEND ERASE COMMAND                                                   USRS0085
  100 CONTINUE                                                          USRS0086
      CALL BUFF (4,0,6,CDUM)                                            USRS0087
      CALL BUFF (14,1,0,CDUM)                                           USRS0088
      II=IABS(ICNT)-990                                                 USRS0089
      CALL BUFF (II,1,0,CDUM)                                           USRS0090
      CALL BUFF (14,1,0,CDUM)                                           USRS0091
      CALL BUFF (14,1,0,CDUM)                                           USRS0092
C  RETURN TO SYMBOL SET 0, RETURN                                       USRS0093
  110 CONTINUE                                                          USRS0094
      CALL BUFF (2,0,6,CDUM)                                            USRS0095
      CALL BUFF (14,1,0,CDUM)                                           USRS0096
      CALL BUFF (8,1,0,CDUM)                                            USRS0097
      RETURN                                                            USRS0098
      END                                                               USRS0099
      SUBROUTINE OPMES (MODE,IBCD,NCHAR)                                OPME0001
C. OPMES  F77     907, 951                               VER02 ZUPCK500 OPME0002
C                                                                       OPME0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       OPME0005
C  LIBRARY FUNCTIONS USED (IABS)                                        OPME0006
C  GRAPHICS ROUTINES USED (BUFF)                                        OPME0007
C                                                                       OPME0008
      CHARACTER*1 IBCD                                                  OPME0009
      CHARACTER*1 CDUM                                                  OPME0010
      DATA MXCHR/62/                                                    OPME0012
C                                                                       OPME0013
      IF (MODE.LT.0) GO TO 99                                           OPME0014
      ICNT=IABS(NCHAR)                                                  OPME0015
      IF (ICNT.GT.MXCHR) ICNT=MXCHR                                     OPME0016
      JCNT=ICNT+3                                                       OPME0017
      CALL BUFF (JCNT,0,6,CDUM)                                         OPME0018
      IF (ICNT.EQ.0) GO TO 20                                           OPME0019
      IF (MODE.EQ.0) GO TO 10                                           OPME0020
C  PAUSE PLOTTER AND WRITE MESSAGE                                      OPME0021
      CALL BUFF (14,1,0,CDUM)                                           OPME0022
      CALL BUFF (7,1,0,CDUM)                                            OPME0023
      CALL BUFF (IDUM,ICNT,8,IBCD)                                      OPME0024
      GO TO 99                                                          OPME0025
C  WRITE MESSAGE ONLY                                                   OPME0026
   10 CALL BUFF (14,1,0,CDUM)                                           OPME0027
      CALL BUFF (6,1,0,CDUM)                                            OPME0028
      CALL BUFF (IDUM,ICNT,8,IBCD)                                      OPME0029
      GO TO 99                                                          OPME0030
C  PAUSE PLOTTER ONLY                                                   OPME0031
   20 CALL BUFF (10,1,0,CDUM)                                           OPME0032
   99 CONTINUE                                                          OPME0033
      RETURN                                                            OPME0034
      END                                                               OPME0035
      SUBROUTINE CIRCLE (P1,P2,P3,P4,P5,MODE)                           CIRC0001
C. CIRCLE F77     907, 951                               VER04 ZUPCN500 CIRC0002
C. IPE                                                                  CIRC0003
C                                                                       CIRC0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       CIRC0006
C  LIBRARY FUNCTIONS USED (ABS,AINT,AMOD,COS,FLOAT,IABS,INT,SIN,SQRT)   CIRC0007
C  GRAPHICS ROUTINES USED (BUFF,PLOT)                                   CIRC0008
C                                                                       CIRC0009
C  THIS SUBROUTINE WILL DRAW CIRCLES OR CIRCULAR ARCS                   CIRC0010
C                                                                       CIRC0011
C  THE MEANINGS OF PARAMETERS P1 - P4 WILL VARY DEPENDING ON            CIRC0012
C  THE VALUE OF MODE                                                    CIRC0013
C                                                                       CIRC0014
      CHARACTER*1 CDUM                                                  CIRC0015
C                                                                       CIRC0017
C***LOC212 FOR NON-IPE, IPEFL=0 AND DMAX1=32767.0                       CIRC0018
      DATA IPEFL/1/,DMAX1/8388607.0/                                    CIRC0020
C***LOC212 END.                                                         CIRC0021
C                                                                       CIRC0022
      DATA DMAX/32767.0/                                                CIRC0023
      DATA PI/3.14159/                                                  CIRC0024
      DATA SHFT/4096.0/                                                 CIRC0025
C                                                                       CIRC0026
      CALL PLOT (STEPS,YDUM,1005)                                       CIRC0027
      AS=0.0                                                            CIRC0028
      AE=0.0                                                            CIRC0029
      ARCANG=0.0                                                        CIRC0030
C  SET FLAG FOR 16 BIT PRECISION (IBIT=0 OR 99)                         CIRC0031
      IBIT=0                                                            CIRC0032
      IMODE=IABS(MODE)                                                  CIRC0033
C  1 <= IMODE <= 7                                                      CIRC0034
      IF (IMODE.LE.0) GO TO 530                                         CIRC0035
      IF (IMODE.GT.7) GO TO 530                                         CIRC0036
      GO TO (10,20,20,30,40,50,60), IMODE                               CIRC0037
C                                                                       CIRC0038
   10 XS=P1                                                             CIRC0039
      YS=P2                                                             CIRC0040
      XC=P3                                                             CIRC0041
      YC=P4                                                             CIRC0042
      GO TO 70                                                          CIRC0043
C                                                                       CIRC0044
   20 XS=P1                                                             CIRC0045
      YS=P2                                                             CIRC0046
      XE=P3                                                             CIRC0047
      YE=P4                                                             CIRC0048
      GO TO 70                                                          CIRC0049
C                                                                       CIRC0050
   30 XS=P1                                                             CIRC0051
      YS=P2                                                             CIRC0052
      AS=P3                                                             CIRC0053
      GO TO 70                                                          CIRC0054
C                                                                       CIRC0055
   40 XS=P1                                                             CIRC0056
      YS=P2                                                             CIRC0057
      AS=P3                                                             CIRC0058
      AE=P4                                                             CIRC0059
      GO TO 70                                                          CIRC0060
C                                                                       CIRC0061
   50 XC=P1                                                             CIRC0062
      YC=P2                                                             CIRC0063
      AS=P3                                                             CIRC0064
      GO TO 70                                                          CIRC0065
C                                                                       CIRC0066
   60 XC=P1                                                             CIRC0067
      YC=P2                                                             CIRC0068
      AS=P3                                                             CIRC0069
      AE=P4                                                             CIRC0070
C                                                                       CIRC0071
   70 CONTINUE                                                          CIRC0072
      GO TO (120,120,120,100,80,100,80), IMODE                          CIRC0073
C  REDUCE ANGLES TO +/- 180 DEGREES                                     CIRC0074
   80 I=INT(AE/360.0)                                                   CIRC0075
      RAE=AE-FLOAT(I*360)                                               CIRC0076
      IF (RAE.LE.180.0) GO TO 90                                        CIRC0077
      RAE=RAE-360.0                                                     CIRC0078
   90 RAE=RAE*(PI/180.0)                                                CIRC0079
  100 I=INT(AS/360.0)                                                   CIRC0080
      RAS=AS-FLOAT(I*360)                                               CIRC0081
      IF (RAS.LE.180.0) GO TO 110                                       CIRC0082
      RAS=RAS-360.0                                                     CIRC0083
C  CONVERT ANGLES TO RADIANS                                            CIRC0084
  110 RAS=RAS*(PI/180.0)                                                CIRC0085
C                                                                       CIRC0086
  120 CONTINUE                                                          CIRC0087
      GO TO (140,130,130,130,130,130,130), IMODE                        CIRC0088
C  CHECK IF RADIUS IS TOO LARGE                                         CIRC0089
  130 R=P5                                                              CIRC0090
      R2=R*STEPS                                                        CIRC0091
      IF (R2.LE.DMAX) GO TO 140                                         CIRC0092
      IBIT=99                                                           CIRC0093
      IF (R2.LE.DMAX1) GO TO 140                                        CIRC0094
      R=DMAX1/STEPS                                                     CIRC0095
C                                                                       CIRC0096
  140 CONTINUE                                                          CIRC0097
      GO TO (160,170,170,150,150,150,150), IMODE                        CIRC0098
C  COMPUTE DISTANCE FROM CENTER TO START                                CIRC0099
  150 DXC=R*COS(RAS)                                                    CIRC0100
      DYC=R*SIN(RAS)                                                    CIRC0101
      GO TO 310                                                         CIRC0102
  160 DXC=XS-XC                                                         CIRC0103
      DYC=YS-YC                                                         CIRC0104
C  CHECK IF RADIUS IS TOO LARGE                                         CIRC0105
      R=SQRT(DXC*DXC+DYC*DYC)                                           CIRC0106
      R2=R*STEPS                                                        CIRC0107
      IF (R2.LE.DMAX) GO TO 310                                         CIRC0108
      IBIT=99                                                           CIRC0109
      IF (R2.LE.DMAX1) GO TO 310                                        CIRC0110
      RMAX=DMAX1/STEPS                                                  CIRC0111
      DXC=DXC*(RMAX/R)                                                  CIRC0112
      DYC=DYC*(RMAX/R)                                                  CIRC0113
      GO TO 310                                                         CIRC0114
C  FIND MIDPOINT OF CHORD                                               CIRC0115
  170 CONTINUE                                                          CIRC0116
      XM=(XS+XE)/2.0                                                    CIRC0117
      YM=(YS+YE)/2.0                                                    CIRC0118
      SDIST=(XS-XM)*(XS-XM)+(YS-YM)*(YS-YM)                             CIRC0119
C  LENGTH OF PERPENDICULAR TO CHORD                                     CIRC0120
      PDIST=R*R-SDIST                                                   CIRC0121
      SLOPE=0.0                                                         CIRC0122
      IF (YS.EQ.YE) GO TO 180                                           CIRC0123
C  FIND SLOPE OF PERPENDICULAR TO CHORD                                 CIRC0124
      SLOPE=-(XS-XE)/(YS-YE)                                            CIRC0125
C  CHECK IF RADIUS IS TOO SHORT                                         CIRC0126
  180 CONTINUE                                                          CIRC0127
      IF (PDIST.GE.0.0) GO TO 190                                       CIRC0128
      R=SQRT(SDIST)                                                     CIRC0129
      XC=XM                                                             CIRC0130
      YC=YM                                                             CIRC0131
      GO TO 300                                                         CIRC0132
C                                                                       CIRC0133
  190 CONTINUE                                                          CIRC0134
      SQ=SQRT(PDIST/(SLOPE*SLOPE+1.0))                                  CIRC0135
      IF (YS-YE) 200,250,210                                            CIRC0136
  200 CONTINUE                                                          CIRC0137
      IF (MODE.EQ.-2) GO TO 220                                         CIRC0138
      IF (MODE.EQ.3) GO TO 220                                          CIRC0139
      GO TO 230                                                         CIRC0140
  210 CONTINUE                                                          CIRC0141
      IF (MODE.EQ.2) GO TO 220                                          CIRC0142
      IF (MODE.NE.-3) GO TO 230                                         CIRC0143
  220 XC=XM+SQ                                                          CIRC0144
      GO TO 240                                                         CIRC0145
  230 XC=XM-SQ                                                          CIRC0146
  240 YC=(XC-XM)*SLOPE+YM                                               CIRC0147
      GO TO 300                                                         CIRC0148
C  SPECIAL CASE WHERE CHORD IS HORIZONTAL                               CIRC0149
C  (SLOPE OF PERPENDICULAR IS UNDEFINED)                                CIRC0150
  250 XC=XM                                                             CIRC0151
      IF (XS-XE) 260,530,270                                            CIRC0152
  260 CONTINUE                                                          CIRC0153
      IF (MODE.EQ.-2) GO TO 280                                         CIRC0154
      IF (MODE.EQ.3) GO TO 280                                          CIRC0155
      GO TO 290                                                         CIRC0156
  270 CONTINUE                                                          CIRC0157
      IF (MODE.EQ.2) GO TO 280                                          CIRC0158
      IF (MODE.NE.-3) GO TO 290                                         CIRC0159
  280 YC=YM-SQ                                                          CIRC0160
      GO TO 300                                                         CIRC0161
  290 YC=YM+SQ                                                          CIRC0162
C                                                                       CIRC0163
  300 DXC=XS-XC                                                         CIRC0164
      DYC=YS-YC                                                         CIRC0165
      DXE=XE-XC                                                         CIRC0166
      DYE=YE-YC                                                         CIRC0167
C                                                                       CIRC0168
  310 CONTINUE                                                          CIRC0169
      GO TO (320,320,320,320,320,330,330), IMODE                        CIRC0170
C  MOVE TO START POSITION WITH PEN UP                                   CIRC0171
  320 CONTINUE                                                          CIRC0172
      CALL PLOT (XS,YS,3)                                               CIRC0173
      GO TO 340                                                         CIRC0174
  330 XTMP=XC+DXC                                                       CIRC0175
      YTMP=YC+DYC                                                       CIRC0176
      CALL PLOT (XTMP,YTMP,3)                                           CIRC0177
C                                                                       CIRC0178
  340 CONTINUE                                                          CIRC0179
C  COMPUTE NO. OF STEPS FROM START TO CENTER                            CIRC0180
      DXC=-DXC*STEPS                                                    CIRC0181
      DYC=-DYC*STEPS                                                    CIRC0182
C                                                                       CIRC0183
C**IS RADIUS GREATER THAN 1 PLOTTER STEP? (STAR 3509) 12/84             CIRC0184
      IF (ABS(DXC).GE.1.0) GO TO 350                                    CIRC0185
      IF (ABS(DYC).LT.1.0) GO TO 530                                    CIRC0186
C                                                                       CIRC0187
  350 CONTINUE                                                          CIRC0188
      GO TO (420,370,370,420,360,420,360), IMODE                        CIRC0189
C  COMPUTE INCLUDED ANGLE OF REQUESTED ARC                              CIRC0190
  360 ARCANG=AE-AS                                                      CIRC0191
      ABSARC=ABS(ARCANG)                                                CIRC0192
      IF (ABSARC.GE.360.0) GO TO 420                                    CIRC0193
C  FIND DELTA TO END OF ARC                                             CIRC0194
      DXE=R*COS(RAE)                                                    CIRC0195
      DYE=R*SIN(RAE)                                                    CIRC0196
C                                                                       CIRC0197
  370 DXE=DXE*STEPS                                                     CIRC0198
      DYE=DYE*STEPS                                                     CIRC0199
      DXX=AINT(DXC)+AINT(DXE)                                           CIRC0200
      DYY=AINT(DYC)+AINT(DYE)                                           CIRC0201
      IF (ARCANG.GE.180.0) GO TO 380                                    CIRC0202
C                                                                       CIRC0203
C**IS ARC LENGTH GREATER THAN 1 PLOTTER STEP? (STAR 3509) 12/84         CIRC0204
      IF (ABS(DXX).GE.1.0) GO TO 380                                    CIRC0205
      IF (ABS(DYY).LT.1.0) GO TO 530                                    CIRC0206
C  GENERATE ARC COMMAND SEQUENCE                                        CIRC0207
  380 CONTINUE                                                          CIRC0208
      IF (IBIT.EQ.99) GO TO 450                                         CIRC0209
      KMD=0                                                             CIRC0210
      IF (MODE) 410,530,390                                             CIRC0211
  390 CONTINUE                                                          CIRC0212
      IF (MODE.LE.3) GO TO 400                                          CIRC0213
      IF (ARCANG.LE.0.0) GO TO 410                                      CIRC0214
  400 KMD=1                                                             CIRC0215
C  CALL BUFF TO STUFF CIRCLE COMMAND                                    CIRC0216
  410 IDXC=INT(DXC)                                                     CIRC0217
      IDYC=INT(DYC)                                                     CIRC0218
      IDXE=INT(DXE)                                                     CIRC0219
      IDYE=INT(DYE)                                                     CIRC0220
      CALL BUFF (16,0,6,CDUM)                                           CIRC0221
      CALL BUFF (12,1,0,CDUM)                                           CIRC0222
      CALL BUFF (KMD,1,0,CDUM)                                          CIRC0223
      CALL BUFF (IDXC,IDYC,2,CDUM)                                      CIRC0224
      CALL BUFF (IDXE,IDYE,2,CDUM)                                      CIRC0225
C  ADJUST PEN POSITION TO FINAL                                         CIRC0226
      CALL PLOT (DXX,DYY,1006)                                          CIRC0227
      GO TO 530                                                         CIRC0228
C  GENERATE FULL CIRCLE COMMAND                                         CIRC0229
  420 CONTINUE                                                          CIRC0230
      IF (IBIT.EQ.99) GO TO 500                                         CIRC0231
      KMD=4                                                             CIRC0232
      IF (MODE) 440,530,430                                             CIRC0233
  430 KMD=5                                                             CIRC0234
C  CALL BUFF TO STUFF CIRCLE COMMAND                                    CIRC0235
  440 IDXC=INT(DXC)                                                     CIRC0236
      IDYC=INT(DYC)                                                     CIRC0237
      CALL BUFF (9,0,6,CDUM)                                            CIRC0238
      CALL BUFF (12,1,0,CDUM)                                           CIRC0239
      CALL BUFF (KMD,1,0,CDUM)                                          CIRC0240
      CALL BUFF (IDXC,IDYC,2,CDUM)                                      CIRC0241
C  (PEN RETURNS TO START POINT)                                         CIRC0242
      GO TO 530                                                         CIRC0243
C                                                                       CIRC0244
  450 CONTINUE                                                          CIRC0245
      IF (IPEFL.EQ.0) GO TO 530                                         CIRC0246
C                                                                       CIRC0247
C  ******************* I P E *** B E G I N **************************   CIRC0248
      CALL BUFF (NRAD,NMAX,12,CDUM)                                     CIRC0249
      IBYCNT=2                                                          CIRC0250
      LCMD=20                                                           CIRC0251
      IF (FLOAT(NRAD*NRAD).GE.SHFT) GO TO 460                           CIRC0252
      IBYCNT=3                                                          CIRC0253
      LCMD=16                                                           CIRC0254
  460 CONTINUE                                                          CIRC0255
      KMD=8                                                             CIRC0256
      IF (MODE) 490,530,470                                             CIRC0257
  470 CONTINUE                                                          CIRC0258
      IF (MODE.LE.3) GO TO 480                                          CIRC0259
      IF (ARCANG.LE.0.0) GO TO 490                                      CIRC0260
  480 KMD=9                                                             CIRC0261
C  CALL BUFF TO STUFF CIRCLE COMMAND                                    CIRC0262
  490 CONTINUE                                                          CIRC0263
      DXC0=ABS(DXC)                                                     CIRC0264
      IDXC1=INT(DXC0/SHFT)                                              CIRC0265
      IDXC2=INT(AMOD(DXC0,SHFT))                                        CIRC0266
      DYC0=ABS(DYC)                                                     CIRC0267
      IDYC1=INT(DYC0/SHFT)                                              CIRC0268
      IDYC2=INT(AMOD(DYC0,SHFT))                                        CIRC0269
      DXE0=ABS(DXE)                                                     CIRC0270
      IDXE1=INT(DXE0/SHFT)                                              CIRC0271
      IDXE2=INT(AMOD(DXE0,SHFT))                                        CIRC0272
      DYE0=ABS(DYE)                                                     CIRC0273
      IDYE1=INT(DYE0/SHFT)                                              CIRC0274
      IDYE2=INT(AMOD(DYE0,SHFT))                                        CIRC0275
      ITMP=IBYCNT*8+6                                                   CIRC0276
      CALL BUFF (ITMP,0,6,CDUM)                                         CIRC0277
      CALL BUFF (12,1,0,CDUM)                                           CIRC0278
      CALL BUFF (KMD,1,0,CDUM)                                          CIRC0279
      ICMD=LCMD                                                         CIRC0280
      IF (DXC.LT.0.0) ICMD=ICMD+1                                       CIRC0281
      IF (DYC.LT.0.0) ICMD=ICMD+2                                       CIRC0282
      CALL BUFF (ICMD,1,0,CDUM)                                         CIRC0283
      CALL BUFF (IDXC1,IBYCNT,7,CDUM)                                   CIRC0284
      CALL BUFF (IDYC1,IBYCNT,7,CDUM)                                   CIRC0285
      CALL BUFF (ICMD,1,0,CDUM)                                         CIRC0286
      CALL BUFF (IDXC2,IBYCNT,7,CDUM)                                   CIRC0287
      CALL BUFF (IDYC2,IBYCNT,7,CDUM)                                   CIRC0288
      ICMD=LCMD                                                         CIRC0289
      IF (DXE.LT.0.0) ICMD=ICMD+1                                       CIRC0290
      IF (DYE.LT.0.0) ICMD=ICMD+2                                       CIRC0291
      CALL BUFF (ICMD,1,0,CDUM)                                         CIRC0292
      CALL BUFF (IDXE1,IBYCNT,7,CDUM)                                   CIRC0293
      CALL BUFF (IDYE1,IBYCNT,7,CDUM)                                   CIRC0294
      CALL BUFF (ICMD,1,0,CDUM)                                         CIRC0295
      CALL BUFF (IDXE2,IBYCNT,7,CDUM)                                   CIRC0296
      CALL BUFF (IDYE2,IBYCNT,7,CDUM)                                   CIRC0297
C  ADJUST PEN POSITION TO FINAL                                         CIRC0298
      CALL PLOT (DXX,DYY,1006)                                          CIRC0299
      GO TO 530                                                         CIRC0300
C  GENERATE FULL CIRCLE COMMAND                                         CIRC0301
  500 KMD=12                                                            CIRC0302
      IF (MODE) 520,530,510                                             CIRC0303
  510 KMD=13                                                            CIRC0304
C  CALL BUFF TO STUFF CIRCLE COMMAND                                    CIRC0305
  520 CONTINUE                                                          CIRC0306
      DXC0=ABS(DXC)                                                     CIRC0307
      IDXC1=INT(DXC0/SHFT)                                              CIRC0308
      IDXC2=INT(AMOD(DXC0,SHFT))                                        CIRC0309
      DYC0=ABS(DYC)                                                     CIRC0310
      IDYC1=INT(DYC0/SHFT)                                              CIRC0311
      IDYC2=INT(AMOD(DYC0,SHFT))                                        CIRC0312
      ITMP=IBYCNT*4+4                                                   CIRC0313
      CALL BUFF (ITMP,0,6,CDUM)                                         CIRC0314
      CALL BUFF (12,1,0,CDUM)                                           CIRC0315
      CALL BUFF (KMD,1,0,CDUM)                                          CIRC0316
      ICMD=LCMD                                                         CIRC0317
      IF (DXC.LT.0.0) ICMD=ICMD+1                                       CIRC0318
      IF (DYC.LT.0.0) ICMD=ICMD+2                                       CIRC0319
      CALL BUFF (ICMD,1,0,CDUM)                                         CIRC0320
      CALL BUFF (IDXC1,IBYCNT,7,CDUM)                                   CIRC0321
      CALL BUFF (IDYC1,IBYCNT,7,CDUM)                                   CIRC0322
      CALL BUFF (ICMD,1,0,CDUM)                                         CIRC0323
      CALL BUFF (IDXC2,IBYCNT,7,CDUM)                                   CIRC0324
      CALL BUFF (IDYC2,IBYCNT,7,CDUM)                                   CIRC0325
C  (PEN RETURNS TO START POINT)                                         CIRC0326
C  ******************* I P E *** E N D ******************************   CIRC0327
C                                                                       CIRC0328
  530 CONTINUE                                                          CIRC0329
      RETURN                                                            CIRC0330
      END                                                               CIRC0331
      SUBROUTINE DASHS (ARRAY,ICTR)                                     DASH0001
C. DASHS  F77     907,951,IPE                            VER01 ZUPCM500 DASH0002
C. PLOTTER DEPENDENT - IPE                                              DASH0003
C                                                                       DASH0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       DASH0006
C  LIBRARY FUNCTIONS USED (ABS,FLOAT,IABS,INT,SIGN)                     DASH0007
C  GRAPHICS ROUTINES USED (BUFF,PLOT)                                   DASH0008
C                                                                       DASH0009
C  ARRAY - ARRAY OF FLOATING POINT VALUES WHICH DEFINE THE              DASH0010
C          PATTERN FOR THE DASHLINE                                     DASH0011
C                                                                       DASH0012
C  ICTR  - ?  -998    SPECIAL CALL FROM PLOT TO SET STEP SIZE           DASH0013
C          ?  -999    SPECIAL CALL FROM PLOT TO RE-XMIT ARRAY           DASH0014
C          +2 TO +16  COUNT OF ELEMENTS IN ARRAY                        DASH0015
C          -2 TO -16  RETURN LAST ELEMENTS STORED                       DASH0016
C              0      TURN OFF DASHLINE MODE                            DASH0017
C             +1      RETURN TO DASHLINE MODE                           DASH0018
C                                                                       DASH0019
C             1000    TURN OFF DASHLINE MODE                            DASH0020
C             1001    TURN ON DASHLINE MODE                             DASH0021
C             1003    TURN ON ADAPTIVE MODE                             DASH0022
C             1005    TURN ON FIXED DOT MODE                            DASH0023
C             1007    TURN ON ADAPTIVE DOT MODE                         DASH0024
C                                                                       DASH0025
      CHARACTER*1 CDUM                                                  DASH0026
      DIMENSION ARRAY(1), SARRAY(16)                                    DASH0027
C     COMMON /CDASH/ IPEFL,DPX,LSTCNT,NMODE,SARRAY                      DASH0028
C                                                                       DASH0029
C***LOC213 IPE FLAG: IPEFL=1 FOR IPE;  IPEFL=0 FOR NON-IPE              DASH0030
      DATA IPEFL/1/,DPX/32767.0/                                        DASH0032
C***LOC213 END.                                                         DASH0033
C                                                                       DASH0034
C***LOC305 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          DASH0035
      DATA LSTCNT/2/,NMODE/0/                                           DASH0036
      DATA SARRAY/-0.1,0.1,14*0.0/                                      DASH0037
C***LOC305 END.                                                         DASH0038
C                                                                       DASH0039
C  SAVE INPUT ICTR                                                      DASH0040
      ICNT=ICTR                                                         DASH0041
      IF (ICNT) 150,20,30                                               DASH0042
C  TURN OFF DASHLINE MODE                                               DASH0043
   20 CONTINUE                                                          DASH0044
      CALL BUFF (2,0,6,CDUM)                                            DASH0045
      CALL BUFF (13,1,0,CDUM)                                           DASH0046
      CALL BUFF (1,1,0,CDUM)                                            DASH0047
      GO TO 200                                                         DASH0048
C                                                                       DASH0049
   30 CONTINUE                                                          DASH0050
      IF (ICNT-1) 200,40,50                                             DASH0051
C  RETURN TO DASHLINE MODE                                              DASH0052
   40 CONTINUE                                                          DASH0053
      CALL BUFF (2,0,6,CDUM)                                            DASH0054
      CALL BUFF (13,1,0,CDUM)                                           DASH0055
      CALL BUFF (0,1,0,CDUM)                                            DASH0056
      GO TO 200                                                         DASH0057
   50 CONTINUE                                                          DASH0058
C                                                                       DASH0059
      IF (IPEFL.EQ.0) GO TO 60                                          DASH0060
C                                                                       DASH0061
C  ******************* I P E *** B E G I N **************************   DASH0062
      IF (ICNT.LE.16) GO TO 60                                          DASH0063
      NMODE=ICNT-1000                                                   DASH0064
      CALL BUFF (3,0,6,CDUM)                                            DASH0065
      CALL BUFF (11,1,0,CDUM)                                           DASH0066
      CALL BUFF (8,1,0,CDUM)                                            DASH0067
      CALL BUFF (NMODE,1,0,CDUM)                                        DASH0068
      GO TO 200                                                         DASH0069
C  ******************* I P E *** E N D ******************************   DASH0070
C                                                                       DASH0071
C  DEFINE DASHLINE PATTERN                                              DASH0072
   60 CONTINUE                                                          DASH0073
      IF (ICNT.GT.16) GO TO 200                                         DASH0074
      ILIM=2+7*((ICNT+1)/2)                                             DASH0075
      CALL BUFF (ILIM,0,6,CDUM)                                         DASH0076
      CALL BUFF (13,1,0,CDUM)                                           DASH0077
      CALL BUFF (ICNT,1,0,CDUM)                                         DASH0078
      CALL PLOT (STEPS,SCL,1005)                                        DASH0079
      IF (SCL.GE.1.0) GO TO 70                                          DASH0080
      SCL=1.0                                                           DASH0081
C  SAVE ARRAY AND ICNT                                                  DASH0082
   70 LSTCNT=ICNT                                                       DASH0083
      DO 80 I=1,ICNT                                                    DASH0084
         SARRAY(I)=ARRAY(I)                                             DASH0085
   80 CONTINUE                                                          DASH0086
      JCNT=ICNT+1                                                       DASH0087
      IF (JCNT.GT.16) GO TO 100                                         DASH0088
      DO 90 I=JCNT,16                                                   DASH0089
         SARRAY(I)=0.0                                                  DASH0090
   90 CONTINUE                                                          DASH0091
C  THE SEGMENT DELTAS ARE IN THE STANDARD 906 DELTA FORMAT              DASH0092
  100 CONTINUE                                                          DASH0093
      DO 140 I=1,ICNT,2                                                 DASH0094
         DX=ARRAY(I)*(STEPS*SCL)                                        DASH0095
         IF (ABS(DX).LE.DPX) GO TO 110                                  DASH0096
         DX=SIGN(DPX,DX)                                                DASH0097
         SARRAY(I)=DX/(STEPS*SCL)                                       DASH0098
  110    CONTINUE                                                       DASH0099
         IF (I.LT.ICNT) GO TO 120                                       DASH0100
         DY=0.0                                                         DASH0101
         GO TO 130                                                      DASH0102
  120    DY=ARRAY(I+1)*(STEPS*SCL)                                      DASH0103
         IF (ABS(DY).LE.DPX) GO TO 130                                  DASH0104
         DY=SIGN(DPX,DY)                                                DASH0105
         SARRAY(I+1)=DY/(STEPS*SCL)                                     DASH0106
C+ UPDATE FOR S/W BULLETIN 84-005 AND 84-007                            DASH0107
  130    CONTINUE                                                       DASH0108
         IDX=INT(DX/SCL+SIGN(0.5,DX))                                   DASH0109
         IDY=INT(DY/SCL+SIGN(0.5,DY))                                   DASH0110
         IF (IDX.EQ.0) IDX=INT(SIGN(1.0,DX))                            DASH0111
         IF (I.EQ.ICNT) GO TO 135                                       DASH0112
         IF (IDY.EQ.0) IDY=INT(SIGN(1.0,DY))                            DASH0113
  135    CONTINUE                                                       DASH0114
         CALL BUFF (IDX,IDY,2,CDUM)                                     DASH0115
  140 CONTINUE                                                          DASH0116
      GO TO 200                                                         DASH0117
C  RETURN THE VALUES IN ARRAY TO THE USER                               DASH0118
  150 CONTINUE                                                          DASH0119
      JCNT=IABS(ICNT)                                                   DASH0120
      IF (JCNT.LE.1) GO TO 200                                          DASH0121
      IF (JCNT.LE.16) GO TO 160                                         DASH0122
      JCNT=16                                                           DASH0123
  160 CONTINUE                                                          DASH0124
      DO 170 I=1,JCNT                                                   DASH0125
         ARRAY(I)=SARRAY(I)                                             DASH0126
  170 CONTINUE                                                          DASH0127
      JCNT=JCNT+1                                                       DASH0128
      IF (JCNT.GT.16) GO TO 190                                         DASH0129
      DO 180 I=JCNT,16                                                  DASH0130
         ARRAY(I)=0.0                                                   DASH0131
  180 CONTINUE                                                          DASH0132
  190 ARRAY(JCNT)=FLOAT(LSTCNT)                                         DASH0133
  200 CONTINUE                                                          DASH0134
      RETURN                                                            DASH0135
      END                                                               DASH0136
      SUBROUTINE SYMBOL (XPAGE,YPAGE,SSPACE,IBCD,INTEQ,ANGLE,NCHAR)     SYMB0001
C. SYMBOL F77     907, 951                               VER03 ZUPCE500 SYMB0002
C. IPE                                                                  SYMB0003
C                                                                       SYMB0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       SYMB0006
C  LIBRARY FUNCTIONS USED (ABS, COS, FLOAT, INT, MOD, SIGN, SIN)        SYMB0007
C  GRAPHICS ROUTINES USED (BUFF, FONT, PLOT, SETCHR)                    SYMB0008
C                                                                       SYMB0009
      CHARACTER*1 CDUM                                                  SYMB0010
      CHARACTER*1 IBCD                                                  SYMB0011
C     COMMON /CSYMB/ IPEFL,IASCII,ICENT,ICTRSY,IMIN,                    SYMB0012
C    1        ICHRSP,IPFL,IOXA,IOYA,IOXA1,IOYA1,NCX,                    SYMB0013
C    2        FCTMX,PI,XMAXI,XMAXJ,STEPS,XP,YP,                         SYMB0014
C    3        ASPECT,CHRSPC,COSTH,SINTH,CRANG,HEIGH,OLDANG,SETMD,TALICS,SYMB0015
C    4        YFONT                                                     SYMB0016
C                                                                       SYMB0017
C***LOC221 IPE FLAG:  IPEFL=0 FOR NON IPE; IPEFL=1 FOR IPE              SYMB0018
      DATA IPEFL/1/                                                     SYMB0020
C                                                                       SYMB0021
C***LOC624 SET THE RADIX FOR PLOT DATA - SEE LOC605 IN BUFF             SYMB0022
      DATA IASCII/95/                                                   SYMB0023
C***LOC624 END.                                                         SYMB0024
C                                                                       SYMB0025
      DATA ICENT/16/                                                    SYMB0026
      DATA ICTRSY/288/,IMIN/1000/                                       SYMB0027
C  INITIALIZE REAL CONSTANTS                                            SYMB0028
      DATA FCTMX/16383.0/                                               SYMB0029
      DATA PI/3.14159/                                                  SYMB0030
      DATA XMAXI/32767.0/                                               SYMB0031
      DATA XMAXJ/32768.0/                                               SYMB0032
      DATA STEPS/0.0/                                                   SYMB0033
      DATA XP,YP/2*0.0/                                                 SYMB0034
C                                                                       SYMB0035
C***LOC310 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          SYMB0036
C  INITIALIZE INTEGER VARIABLES                                         SYMB0037
      DATA ICHRSP/16/,IPFL/0/                                           SYMB0038
      DATA IOXA,IOYA/2*0/                                               SYMB0039
      DATA IOXA1,IOYA1/2*0/                                             SYMB0040
      DATA NCX/0/                                                       SYMB0041
C  INITIALIZE REAL VARIABLES                                            SYMB0042
      DATA ASPECT/1.0/                                                  SYMB0043
      DATA CHRSPC/1.0/                                                  SYMB0044
      DATA COSTH,SINTH/2*0.0/                                           SYMB0045
      DATA CRANG/0.0/                                                   SYMB0046
      DATA HEIGH/0.0/                                                   SYMB0047
      DATA OLDANG/0.0/                                                  SYMB0048
      DATA SETMD/0.0/                                                   SYMB0049
      DATA TALICS/0.0/                                                  SYMB0050
      DATA YFONT/-999.0/                                                SYMB0051
C***LOC310 END.                                                         SYMB0052
C                                                                       SYMB0053
      IF (IPEFL.EQ.0) GO TO 30                                          SYMB0054
C                                                                       SYMB0055
C  ******************* I P E *** B E G I N **************************   SYMB0056
C  GET MODE FLAG                                                        SYMB0057
      FNTFG=99.0                                                        SYMB0058
C                                                                       SYMB0059
C***LOC215 FOR NON-IPE, COMMENT OUT 1 CALL TO FONT & 2 CALLS TO SETCHR  SYMB0060
      CALL FONT (FNTFG)                                                 SYMB0061
      YFONT=FNTFG                                                       SYMB0062
      SETFLG=99.0                                                       SYMB0063
      CALL SETCHR (HGT,ASP,TAL,ANG,SETFLG)                              SYMB0064
C  SAVE FLAG                                                            SYMB0065
      SETMD=SETFLG                                                      SYMB0066
      IF (YFONT.EQ.-999.0) GO TO 30                                     SYMB0067
      IF (SETMD.NE.-999.0) GO TO 30                                     SYMB0068
C  GET SET CHARACTER PARAMETERS                                         SYMB0069
      CALL SETCHR (HGT,ASP,TAL,ANG,1000.0)                              SYMB0070
C***LOC215 END.                                                         SYMB0071
C                                                                       SYMB0072
C  CHECK FOR WHETHER TO SEND PARAMETERS AGAIN                           SYMB0073
      IF (OLDANG.NE.ANGLE) GO TO 20                                     SYMB0074
      IF (SSPACE.NE.CHRSPC) GO TO 20                                    SYMB0075
      IF (HGT.NE.HEIGH) GO TO 20                                        SYMB0076
      IF (ASP.NE.ASPECT) GO TO 20                                       SYMB0077
      IF (TAL.NE.TALICS) GO TO 20                                       SYMB0078
      IF (ANG.NE.CRANG) GO TO 20                                        SYMB0079
C  ALL PARAMETERS ARE THE SAME                                          SYMB0080
      IPFL=1                                                            SYMB0081
      GO TO 40                                                          SYMB0082
C  HEIGH ARGUMENT IN SYMBOL BECOMES CHARACTER SPACE VARIABLE            SYMB0083
   20 CHRSPC=SSPACE                                                     SYMB0084
      HEIGH=HGT                                                         SYMB0085
      ASPECT=ASP                                                        SYMB0086
      TALICS=TAL                                                        SYMB0087
      CRANG=ANG                                                         SYMB0088
      OLDANG=ANGLE                                                      SYMB0089
      GO TO 40                                                          SYMB0090
C  ******************* I P E *** E N D ******************************   SYMB0091
C                                                                       SYMB0092
   30 CONTINUE                                                          SYMB0093
      HEIGH=SSPACE                                                      SYMB0094
   40 CONTINUE                                                          SYMB0095
      IF (HEIGH.EQ.0.0) GO TO 440                                       SYMB0096
      IPEN=3                                                            SYMB0097
      NT=NCHAR                                                          SYMB0098
      NC=1                                                              SYMB0099
      XO=XPAGE                                                          SYMB0100
      IF (ABS(XO-999.0).GE.0.1) GO TO 50                                SYMB0101
      XO=XP                                                             SYMB0102
   50 YO=YPAGE                                                          SYMB0103
      IF (ABS(YO-999.0).GE.0.1) GO TO 60                                SYMB0104
      YO=YP                                                             SYMB0105
   60 TH=ANGLE*(PI/180.0)                                               SYMB0106
      SINTH=SIN(TH)                                                     SYMB0107
      COSTH=COS(TH)                                                     SYMB0108
C  GET CHARACTER MODE                                                   SYMB0109
      IF (YFONT.EQ.-999.0) GO TO 100                                    SYMB0110
C                                                                       SYMB0111
C  ******************* I P E *** B E G I N **************************   SYMB0112
      IF (SETMD.NE.-999.0) GO TO 100                                    SYMB0113
      IF (IPFL.EQ.0) GO TO 70                                           SYMB0114
      IPFL=0                                                            SYMB0115
      GO TO 160                                                         SYMB0116
C  GET STEPSIZE FOR PLOTTER                                             SYMB0117
   70 CONTINUE                                                          SYMB0118
      CALL PLOT (STEPS,SCL,1005)                                        SYMB0119
C  CALCULATE HEIGHT AND ANGLE                                           SYMB0120
      CHRHT=HEIGH*STEPS                                                 SYMB0121
      ICHRHT=INT(CHRHT)                                                 SYMB0122
      XANGLE=COSTH*XMAXI                                                SYMB0123
      IXANG=INT(XANGLE)                                                 SYMB0124
      YANGLE=SINTH*XMAXI                                                SYMB0125
      IYANG=INT(YANGLE)                                                 SYMB0126
      IASPEC=INT(ASPECT+SIGN(0.5,ASPECT))                               SYMB0127
      ITALIC=INT(TALICS+SIGN(0.5,TALICS))                               SYMB0128
      CHRSP=CHRSPC*16.                                                  SYMB0129
      ICHRSP=INT(CHRSP+SIGN(0.5,CHRSP))                                 SYMB0130
      ICHANG=MOD(INT(CRANG),360)                                        SYMB0131
C+ UPDATE FOR NEGATIVE ANGLES - DEC, 1983                               SYMB0132
      IF (ICHANG.LT.0) ICHANG=360+ICHANG                                SYMB0133
      IF (ITALIC.NE.0) GO TO 80                                         SYMB0134
      IF (ICHRSP.NE.0) GO TO 80                                         SYMB0135
      NOFDEL=0                                                          SYMB0136
      NCX=999                                                           SYMB0137
      GO TO 90                                                          SYMB0138
   80 NOFDEL=1                                                          SYMB0139
      NCX=0                                                             SYMB0140
   90 CONTINUE                                                          SYMB0141
      CALL BUFF (31,0,6,CDUM)                                           SYMB0142
      CALL BUFF (11,1,0,CDUM)                                           SYMB0143
      CALL BUFF (5,1,0,CDUM)                                            SYMB0144
C  OUTPUT PARAMETERS, HEIGHT, ANGLE AND ASPECT RATIO                    SYMB0145
      ITEMP=14+NOFDEL                                                   SYMB0146
      CALL BUFF (ITEMP,1,0,CDUM)                                        SYMB0147
      CALL BUFF (0,ICHRHT,2,CDUM)                                       SYMB0148
      CALL BUFF (IXANG,IYANG,2,CDUM)                                    SYMB0149
      CALL BUFF (ICHANG,IASPEC,2,CDUM)                                  SYMB0150
      IF (NOFDEL.EQ.0) GO TO 160                                        SYMB0151
C  OUTPUT ITALICS AND INTER CHARACTER SPACING                           SYMB0152
      CALL BUFF (ITALIC,ICHRSP,2,CDUM)                                  SYMB0153
C  CHECK FOR WHICH FONT TO USE                                          SYMB0154
      GO TO 160                                                         SYMB0155
C  ******************* I P E *** E N D ******************************   SYMB0156
C                                                                       SYMB0157
C  OUTPUT FOR CODE FOR 907 SYMBOL                                       SYMB0158
  100 CONTINUE                                                          SYMB0159
      IF (NT) 110,170,160                                               SYMB0160
  110 CONTINUE                                                          SYMB0161
C  SPECIAL (-1) SYMBOL CALL                                             SYMB0162
      IF (NT.EQ.-1) GO TO 120                                           SYMB0163
      IPEN=2                                                            SYMB0164
C+ UPDATE FOR SOFTWARE BULLETIN 83-001                                  SYMB0165
  120 CONTINUE                                                          SYMB0166
      IF (YFONT.EQ.-999.0) GO TO 130                                    SYMB0167
C                                                                       SYMB0168
C  ******************* I P E *** B E G I N **************************   SYMB0169
      K=INTEQ                                                           SYMB0170
      XNC=1.0                                                           SYMB0171
      GO TO 180                                                         SYMB0172
C  ******************* I P E *** E N D ******************************   SYMB0173
C                                                                       SYMB0174
  130 CONTINUE                                                          SYMB0175
C  F77 AND FIV DIFFERNCES - FIV USES IBCD(1); F77 USES INTEQ            SYMB0176
      K=INTEQ-ICENT                                                     SYMB0177
      XNC=1.0                                                           SYMB0178
      IF (K) 150,180,140                                                SYMB0179
  140 CONTINUE                                                          SYMB0180
      IF (K-ICTRSY+ICENT.LT.0) GO TO 180                                SYMB0181
C  USER-DEFINED SYMBOLS ARE CENTERED SYMBOLS                            SYMB0182
      K=K+ICENT                                                         SYMB0183
      XNC=0.0                                                           SYMB0184
      GO TO 180                                                         SYMB0185
  150 K=K+ICTRSY                                                        SYMB0186
      XNC=0.0                                                           SYMB0187
      GO TO 180                                                         SYMB0188
  160 NC=MOD(NT,1000)                                                   SYMB0189
      IF (NCX.NE.999) GO TO 170                                         SYMB0190
C                                                                       SYMB0191
C  ******************* I P E *** B E G I N **************************   SYMB0192
      XNC=1.                                                            SYMB0193
      GO TO 180                                                         SYMB0194
C  ******************* I P E *** E N D ******************************   SYMB0195
C                                                                       SYMB0196
  170 CONTINUE                                                          SYMB0197
      XNC=FLOAT(NC)                                                     SYMB0198
C                                                                       SYMB0199
  180 CONTINUE                                                          SYMB0200
      CALL PLOT (XO,YO,IPEN)                                            SYMB0201
      CALL PLOT (STEPS,SCL,1005)                                        SYMB0202
      IF (SCL.LT.1.0) SCL=1.0                                           SYMB0203
      ISCL=INT(SCL)                                                     SYMB0204
      FCT=HEIGH*STEPS                                                   SYMB0205
      FCTMXX=FLOAT(INT(FCTMX/SCL))                                      SYMB0206
      IF (FCT.LE.FCTMXX) GO TO 190                                      SYMB0207
      FCT=FCTMXX                                                        SYMB0208
  190 CONTINUE                                                          SYMB0209
      IF (YFONT.EQ.-999.0) GO TO 200                                    SYMB0210
C                                                                       SYMB0211
C  ******************* I P E *** B E G I N **************************   SYMB0212
      IF (SETMD.EQ.0.0) GO TO 200                                       SYMB0213
      ISIN=INT(SINTH*XMAXI)                                             SYMB0214
      ICOS=INT(COSTH*XMAXI)                                             SYMB0215
      IFCT=INT(FCT)                                                     SYMB0216
      IHT=INT(FLOAT(IFCT)*FLOAT(ICHRSP)/16.0)                           SYMB0217
      IXA=INT(FLOAT(ICOS)*FLOAT(IHT)/XMAXJ)                             SYMB0218
      IYA=INT(FLOAT(ISIN)*FLOAT(IHT)/XMAXJ)                             SYMB0219
      GO TO 270                                                         SYMB0220
C  ******************* I P E *** E N D ******************************   SYMB0221
C                                                                       SYMB0222
  200 CONTINUE                                                          SYMB0223
      XA=FCT*COSTH                                                      SYMB0224
      YA=FCT*SINTH                                                      SYMB0225
      IXA=INT(XA+SIGN(0.5,XA))                                          SYMB0226
      IYA=INT(YA+SIGN(0.5,YA))                                          SYMB0227
      IF (YFONT.EQ.-999.0) GO TO 220                                    SYMB0228
C                                                                       SYMB0229
C  ******************* I P E *** B E G I N **************************   SYMB0230
      IF (IXA.NE.IOXA1) GO TO 210                                       SYMB0231
      IF (IYA.EQ.IOYA1) GO TO 270                                       SYMB0232
  210 CONTINUE                                                          SYMB0233
      CALL BUFF (10,0,6,CDUM)                                           SYMB0234
      CALL BUFF (11,1,0,CDUM)                                           SYMB0235
      CALL BUFF (7,1,0,CDUM)                                            SYMB0236
      IOXA1=IXA                                                         SYMB0237
      IOYA1=IYA                                                         SYMB0238
      GO TO 260                                                         SYMB0239
C  ******************* I P E *** E N D ******************************   SYMB0240
C                                                                       SYMB0241
C  907 CHARACTER SET SELECTED                                           SYMB0242
  220 CONTINUE                                                          SYMB0243
      IADD=0                                                            SYMB0244
      IF (IXA.GT.0) IADD=14                                             SYMB0245
      IXA=IXA+(IXA+IADD)/15                                             SYMB0246
      IADD=0                                                            SYMB0247
      IF (IYA.GT.0) IADD=14                                             SYMB0248
      IYA=IYA+(IYA+IADD)/15                                             SYMB0249
C  CHECK IF NEED TO SEND SIZE INFORMATION                               SYMB0250
      IF (IXA.NE.IOXA) GO TO 230                                        SYMB0251
      IF (IYA.EQ.IOYA) GO TO 240                                        SYMB0252
  230 CONTINUE                                                          SYMB0253
      IF (IPEFL.EQ.0) GO TO 240                                         SYMB0254
C                                                                       SYMB0255
C  ******************* I P E *** B E G I N **************************   SYMB0256
      CALL BUFF (10,0,6,CDUM)                                           SYMB0257
      CALL BUFF (14,1,0,CDUM)                                           SYMB0258
      CALL BUFF (8,1,0,CDUM)                                            SYMB0259
      GO TO 250                                                         SYMB0260
C  ******************* I P E *** E N D ******************************   SYMB0261
C                                                                       SYMB0262
  240 CONTINUE                                                          SYMB0263
      CALL BUFF (8,0,6,CDUM)                                            SYMB0264
  250 IOXA=IXA                                                          SYMB0265
      IOYA=IYA                                                          SYMB0266
C  FONT SELECTED NO CHARACTER MODIFICATIONS                             SYMB0267
C  OUTPUT SCALING PARAMETER                                             SYMB0268
  260 CONTINUE                                                          SYMB0269
      CALL BUFF (6,1,0,CDUM)                                            SYMB0270
      CALL BUFF (IXA,IYA,2,CDUM)                                        SYMB0271
      IF (YFONT.EQ.-999.0) GO TO 300                                    SYMB0272
C                                                                       SYMB0273
C  ******************* I P E *** B E G I N **************************   SYMB0274
C+ UPDATE FOR SOFTWARE BULLETIN 83-001                                  SYMB0275
  270 CONTINUE                                                          SYMB0276
      IF (NT.GT.0) GO TO 330                                            SYMB0277
  280 CONTINUE                                                          SYMB0278
      IF (INTEQ.LE.31) GO TO 290                                        SYMB0279
      K=K-32                                                            SYMB0280
      GO TO 320                                                         SYMB0281
  290 CONTINUE                                                          SYMB0282
      CALL BUFF (3,0,6,CDUM)                                            SYMB0283
      CALL BUFF (14,1,0,CDUM)                                           SYMB0284
      K2=INTEQ                                                          SYMB0285
      KH2=K2/16                                                         SYMB0286
      CALL BUFF (KH2,1,0,CDUM)                                          SYMB0287
      KL2=MOD(K2,16)                                                    SYMB0288
      CALL BUFF (KL2,1,0,CDUM)                                          SYMB0289
      GO TO 360                                                         SYMB0290
C  ******************* I P E *** E N D ******************************   SYMB0291
C                                                                       SYMB0292
C  IF NT=-VE,USE K(INTEQ); IF NT>0,USE IBCD;NT=0 IS NOT ALLOWED IN F77  SYMB0293
  300 CONTINUE                                                          SYMB0294
      IF (NT.GT.0) GO TO 330                                            SYMB0295
C  SPECIAL SYMBOL CALL - DECIDE HOW TO CALL IT                          SYMB0296
      IF (K.LT.IASCII) GO TO 320                                        SYMB0297
C  OUTPUT SPECIAL EXTENDED SYMBOL CALL                                  SYMB0298
      CALL BUFF (4,0,6,CDUM)                                            SYMB0299
      CALL BUFF (14,1,0,CDUM)                                           SYMB0300
      CALL BUFF (15,1,0,CDUM)                                           SYMB0301
      K1=K/16                                                           SYMB0302
      CALL BUFF (K1,1,0,CDUM)                                           SYMB0303
      K1=MOD(K,16)                                                      SYMB0304
      CALL BUFF (K1,1,0,CDUM)                                           SYMB0305
      GO TO 360                                                         SYMB0306
  320 ITEMP=K+IMIN                                                      SYMB0307
      CALL BUFF (ITEMP,1,4,CDUM)                                        SYMB0308
      GO TO 360                                                         SYMB0309
  330 CONTINUE                                                          SYMB0310
      CALL BUFF (IDUM,NC,3,IBCD)                                        SYMB0311
C  ADJUST FINAL POSITION                                                SYMB0312
  360 CONTINUE                                                          SYMB0313
      IF (YFONT.EQ.-999.0) GO TO 370                                    SYMB0314
C                                                                       SYMB0315
C  ******************* I P E *** B E G I N **************************   SYMB0316
      PX=XNC*FLOAT(IXA)                                                 SYMB0317
      PY=XNC*FLOAT(IYA)                                                 SYMB0318
      GO TO 430                                                         SYMB0319
C  ******************* I P E *** E N D ******************************   SYMB0320
C                                                                       SYMB0321
  370 CONTINUE                                                          SYMB0322
      PX=0.0                                                            SYMB0323
      PY=0.0                                                            SYMB0324
      XADD=0.0                                                          SYMB0325
      IF (IXA) 380,400,390                                              SYMB0326
  380 XADD=-15.0                                                        SYMB0327
  390 PX=XNC*FLOAT(INT((XADD+15.0*FLOAT(IXA))/16.0))                    SYMB0328
  400 XADD=0.0                                                          SYMB0329
      IF (IYA) 410,430,420                                              SYMB0330
  410 XADD=-15.0                                                        SYMB0331
  420 PY=XNC*FLOAT(INT((XADD+15.0*FLOAT(IYA))/16.0))                    SYMB0332
  430 CONTINUE                                                          SYMB0333
C  UPDATES OLDX & OLDY IN PLOT ROUTINE                                  SYMB0334
      CALL PLOT (PX,PY,1006)                                            SYMB0335
C  GETS THE OLDX & OLDY VALUE FROM PLOT ROUTINE.                        SYMB0336
      CALL PLOT (XP,YP,1002)                                            SYMB0337
  440 CONTINUE                                                          SYMB0338
      RETURN                                                            SYMB0339
      END                                                               SYMB0340
      SUBROUTINE LINE (XARRAY,YARRAY,NPTS,INC,LINTYP,INTEQ)             LINE0001
C. LINE   F77 907,925,951,953                            VER01 ZUPCC900 LINE0002
C. UNITS DEPENDENT                                                      LINE0003
C. IPE DEPENDENT                                                        LINE0004
C                                                                       LINE0005
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       LINE0007
C  XARRAY  NAME OF ARRAY CONTAINING ABSCISSA OR X VALUES.               LINE0008
C  YARRAY  NAME OF ARRAY CONTAINING ORDINATE OR Y VALUES.               LINE0009
C  NPTS    NUMBER OF POINTS TO BE PLOTTED.                              LINE0010
C  INC     INCREMENT OF LOCATION OF SUCCESSIVE POINTS.                  LINE0011
C  LINTYP  CONTROL TYPE OF LINE--SYMBOLS, LINE, OR COMBINATION.         LINE0012
C  INTEQ   INTEGER EQUIVALENT OF SYMBOL TO BE USED, IF ANY.             LINE0013
C                                                                       LINE0014
C  LIBRARY FUNCTIONS USED (ABS,AMAX1,IABS,INT)                          LINE0015
C  GRAPHICS ROUTINES USED (FONT,PLOT,SYMBOL,WHERE)                      LINE0016
      CHARACTER*1 CDUM                                                  LINE0017
      DIMENSION XARRAY(1), YARRAY(1)                                    LINE0018
C                                                                       LINE0019
C***LOC110 UNITS CONVERSION INCH(1.00) TO METRIC(2.54)                  LINE0020
      DATA FCMI/1.00/                                                   LINE0021
C***LOC110 END.                                                         LINE0023
C                                                                       LINE0024
      LMIN=NPTS*INC+1                                                   LINE0025
      LDX=LMIN+INC                                                      LINE0026
      NL=LMIN-INC                                                       LINE0027
      FIRSTX=XARRAY(LMIN)                                               LINE0028
      DELTAX=XARRAY(LDX)                                                LINE0029
      FIRSTY=YARRAY(LMIN)                                               LINE0030
      DELTAY=YARRAY(LDX)                                                LINE0031
      CALL WHERE (XN,YN,DF)                                             LINE0032
      DF=AMAX1(ABS((XARRAY(1)-FIRSTX)/DELTAX-XN),ABS((YARRAY(1)-FIRSTY)/LINE0033
     1  DELTAY-YN))                                                     LINE0034
      DL=AMAX1(ABS((XARRAY(NL)-FIRSTX)/DELTAX-XN),ABS((YARRAY(NL)-      LINE0035
     1  FIRSTY)/DELTAY-YN))                                             LINE0036
      IPEN=3                                                            LINE0037
      ICODE=-1                                                          LINE0038
      NT=IABS(LINTYP)                                                   LINE0039
      IF (LINTYP.EQ.0) NT=1                                             LINE0040
      NF=1                                                              LINE0041
      NA=NT                                                             LINE0042
      KK=INC                                                            LINE0043
      IF (DF.LE.DL) GO TO 10                                            LINE0044
      NF=NL                                                             LINE0045
      NA=(((NPTS-1)/NT)*NT+NT)-(NPTS-1)                                 LINE0046
      KK=-INC                                                           LINE0047
   10 CONTINUE                                                          LINE0048
      IF (LINTYP) 20,30,40                                              LINE0049
   20 IPENA=3                                                           LINE0050
      ICODEA=-1                                                         LINE0051
      LSW=1                                                             LINE0052
      GO TO 50                                                          LINE0053
   30 NA=LDX                                                            LINE0054
   40 IPENA=2                                                           LINE0055
      ICODEA=-2                                                         LINE0056
      LSW=0                                                             LINE0057
   50 HEIG1=0.08*FCMI                                                   LINE0058
C***LOC214 NONIPE/IPE PLOTTER CONVERSION                                LINE0059
C  SELECT CORRECT CHARACTER FONT FOR SYMBOL                             LINE0060
      FNTFL=99.0                                                        LINE0061
      CALL FONT (FNTFL)                                                 LINE0062
      IF (INT(FNTFL).EQ.-999) GO TO 60                                  LINE0063
      CALL FONT (-999.0)                                                LINE0064
   60 CONTINUE                                                          LINE0065
C***LOC214 END.                                                         LINE0066
      DO 120 I=1,NPTS                                                   LINE0067
         XN=(XARRAY(NF)-FIRSTX)/DELTAX                                  LINE0068
         YN=(YARRAY(NF)-FIRSTY)/DELTAY                                  LINE0069
         IF (NA-NT) 70,80,90                                            LINE0070
   70    CONTINUE                                                       LINE0071
         IF (LSW.EQ.0) GO TO 90                                         LINE0072
         GO TO 100                                                      LINE0073
   80    CONTINUE                                                       LINE0074
         CALL SYMBOL (XN,YN,HEIG1,CDUM,INTEQ,0.0,ICODE)                 LINE0075
         NA=1                                                           LINE0076
         GO TO 110                                                      LINE0077
   90    CALL PLOT (XN,YN,IPEN)                                         LINE0078
  100    NA=NA+1                                                        LINE0079
  110    NF=NF+KK                                                       LINE0080
         ICODE=ICODEA                                                   LINE0081
         IPEN=IPENA                                                     LINE0082
  120 CONTINUE                                                          LINE0083
C***LOC223 NONIPE/IPE PLOTTER CONVERSION                                LINE0084
C  RESELECT CORRECT CHARACTER FONT FOR SYMBOL                           LINE0085
      IF (INT(FNTFL).EQ.-999) GO TO 130                                 LINE0086
      CALL FONT (FNTFL)                                                 LINE0087
  130 CONTINUE                                                          LINE0088
C***LOC223 END.                                                         LINE0089
      RETURN                                                            LINE0090
      END                                                               LINE0091
      SUBROUTINE FACTOR (FACT)                                          FACT0001
C. FACTOR FORTRAN 907,925,951,953,IPF,955                VER01 ZUPCH000 FACT0002
C                                                                       FACT0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       FACT0005
C  GRAPHICS ROUTINES USED (PLOT)                                        FACT0006
      X=FACT                                                            FACT0007
      Y=FACT                                                            FACT0008
      CALL PLOT (X,Y,1001)                                              FACT0009
      RETURN                                                            FACT0010
      END                                                               FACT0011
      SUBROUTINE WHERE (XPAGE,YPAGE,RFACT)                              WHER0001
C. WHERE  FORTRAN 907,925,951,953,IPF,955                VER01 ZUPCI000 WHER0002
C                                                                       WHER0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       WHER0005
C  GRAPHICS ROUTINES USED (PLOT)                                        WHER0006
      CALL PLOT (X,Y,1002)                                              WHER0007
      XPAGE=X                                                           WHER0008
      YPAGE=Y                                                           WHER0009
      CALL PLOT (X,RDUM,1003)                                           WHER0010
      RFACT=X                                                           WHER0011
      RETURN                                                            WHER0012
      END                                                               WHER0013
      SUBROUTINE NEWPEN (IPEN)                                          NEWP0001
C. NEWPEN F77     58X5 O/L                               VER02 ZUPCJ520 NEWP0002
C                                                                       NEWP0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       NEWP0005
C  LIBRARY FUNCTIONS USED (FLOAT, MOD, IABS)                            NEWP0006
C  GRAPHICS ROUTINES USED (BUFF, PLOT)                                  NEWP0007
C                                                                       NEWP0008
      CHARACTER*1 CDUM                                                  NEWP0009
C     COMMON /CNEW/IOLDPN,IRAD,MXPEN                                    NEWP0010
C                                                                       NEWP0011
C***LOC300 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          NEWP0012
      DATA IOLDPN/0/                                                    NEWP0013
C***LOC300 END.                                                         NEWP0014
C                                                                       NEWP0015
C  MXPEN IS THE MAXIMUM NUMBER OF PENS; VALID RANGE 1 - 32767           NEWP0016
C  CURRENTLY SUPPORTED MAXIMUM PEN NUMBER IS 1024                       NEWP0017
      DATA MXPEN/1024/                                                  NEWP0018
C                                                                       NEWP0019
      IP=MOD(IABS(IPEN),MXPEN+1)                                        NEWP0020
      IF (IP.EQ.0) GO TO 40                                             NEWP0021
      IF (IP.EQ.IOLDPN) GO TO 40                                        NEWP0022
      IOLDPN=IP                                                         NEWP0023
      IF (IP.LE.16) GO TO 10                                            NEWP0024
C  GET THE RADIX FROM SUBROUTINE BUFF                                   NEWP0025
      CALL BUFF (NRAD,IDUM,12,CDUM)                                     NEWP0026
      IRAD=NRAD                                                         NEWP0027
      IF (IP.GE.IRAD) GO TO 20                                          NEWP0028
   10 CONTINUE                                                          NEWP0029
      CALL BUFF (2,0,6,CDUM)                                            NEWP0030
      CALL BUFF (4,1,0,CDUM)                                            NEWP0031
      CALL BUFF (IP,1,0,CDUM)                                           NEWP0032
      GO TO 30                                                          NEWP0033
   20 CONTINUE                                                          NEWP0034
C  CODE FOR EXTENDED PEN PALETTE MODE                                   NEWP0035
      CALL BUFF (5,0,6,CDUM)                                            NEWP0036
      CALL BUFF (14,1,0,CDUM)                                           NEWP0037
      CALL BUFF (32,1,0,CDUM)                                           NEWP0038
      CALL BUFF (IP,3,7,CDUM)                                           NEWP0039
   30 CONTINUE                                                          NEWP0040
      RPEN=FLOAT(IP)                                                    NEWP0041
      CALL PLOT (RPEN,RDUM,1004)                                        NEWP0042
   40 CONTINUE                                                          NEWP0043
      RETURN                                                            NEWP0044
      END                                                               NEWP0045
      SUBROUTINE AXIS (XPAGE,YPAGE,IBCD,NCHAR,AXLEN,ANGLE,FIRSTV,DELTAV)AXIS0001
C. AXIS   F77 907,925,951,953,IPF                        VER01 ZUPCB900 AXIS0002
C. UNITS DEPENDENT                                                      AXIS0003
C                                                                       AXIS0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       AXIS0006
C  XPAGE,YPAGE  COORDINATES OF STARTING POINT OF AXIS, IN UNITS         AXIS0007
C  IBCD         AXIS TITLE.                                             AXIS0008
C  NCHAR        NUMBER OF CHARACTERS IN TITLE. + FOR C.C-W SIDE.        AXIS0009
C  AXLEN        FLOATING POINT AXIS LENGTH IN UNITS.                    AXIS0010
C  ANGLE        ANGLE OF AXIS FROM THE X-DIRECTION, IN DEGREES.         AXIS0011
C  FIRSTV       SCALE VALUE AT THE FIRST TIC MARK.                      AXIS0012
C  DELTAV       CHANGE IN SCALE BETWEEN TIC MARKS ONE UNIT APART        AXIS0013
C                                                                       AXIS0014
C  LIBRARY FUNCTIONS USED (ABS,COS,FLOAT,IABS,INT,SIN)                  AXIS0015
C  GRAPHICS ROUTINES USED (NUMBER,PLOT,SYMBOL)                          AXIS0016
      CHARACTER*1 IBCD                                                  AXIS0017
      CHARACTER*3 NBCD                                                  AXIS0018
C                                                                       AXIS0019
C***LOC109 UNITS CONVERSION INCH(1.00) TO METRIC(2.54)                  AXIS0020
      DATA FCMI/1.00/                                                   AXIS0021
C***LOC109 END.                                                         AXIS0023
C  INITIALIZE CIRCULAR TRANSCENDENTAL NUMBER                            AXIS0024
      DATA PI/3.14159/                                                  AXIS0025
      DATA NBCD/'*10'/                                                  AXIS0026
C                                                                       AXIS0027
      RCMI=FLOAT(INT(FCMI))                                             AXIS0028
      HEIGH=0.14*FCMI                                                   AXIS0029
      HEIG1=0.105*RCMI                                                  AXIS0030
      HEIG2=0.07*FCMI                                                   AXIS0031
      A=1.0                                                             AXIS0032
      IF (NCHAR.LT.0) A=-1.0                                            AXIS0033
      KN=IABS(NCHAR)                                                    AXIS0034
      IEX=0                                                             AXIS0035
      ADX=ABS(DELTAV)                                                   AXIS0036
      IF (ADX.EQ.0.0) GO TO 40                                          AXIS0037
   10 CONTINUE                                                          AXIS0038
      IF (ADX.LT.99.0) GO TO 30                                         AXIS0039
      ADX=ADX/10.0                                                      AXIS0040
      IEX=IEX+1                                                         AXIS0041
      GO TO 10                                                          AXIS0042
   20 ADX=ADX*10.0                                                      AXIS0043
      IEX=IEX-1                                                         AXIS0044
   30 CONTINUE                                                          AXIS0045
      IF (ADX.LT.0.01) GO TO 20                                         AXIS0046
   40 RTMP=10.0**(-IEX)                                                 AXIS0047
      XVAL=FIRSTV*RTMP                                                  AXIS0048
      ADX=RCMI*(DELTAV*RTMP)                                            AXIS0049
      ANGR=ANGLE*(PI/180.0)                                             AXIS0050
      CTH=COS(ANGR)                                                     AXIS0051
      STH=SIN(ANGR)                                                     AXIS0052
      DXB=-(0.1*FCMI)                                                   AXIS0053
      DYB=A*(0.15*FCMI)-(0.05*FCMI)                                     AXIS0054
      XN=XPAGE+(DXB*CTH-DYB*STH)                                        AXIS0055
      YN=YPAGE+(DYB*CTH+DXB*STH)                                        AXIS0056
      EX=FLOAT(IEX)                                                     AXIS0057
      NTIC=INT(AXLEN+1.0)                                               AXIS0058
      NTC=NTIC                                                          AXIS0059
      IF (INT(FCMI).EQ.2) NTC=(NTIC+1)/2                                AXIS0060
      NT=NTC/2                                                          AXIS0061
      DO 70 I=1,NTC                                                     AXIS0062
         CALL NUMBER (XN,YN,HEIG1,XVAL,ANGLE,2)                         AXIS0063
         IF (INT(FCMI).EQ.1) GO TO 50                                   AXIS0064
         IF (I.GT.1) GO TO 50                                           AXIS0065
         XN=XPAGE+(2.0*(DXB*CTH)-(DYB*STH))                             AXIS0066
         YN=YPAGE+(2.0*(DXB*STH)+(DYB*CTH))                             AXIS0067
   50    XVAL=XVAL+ADX                                                  AXIS0068
         XN=XN+CTH*RCMI                                                 AXIS0069
         YN=YN+STH*RCMI                                                 AXIS0070
         IF (NT.NE.0) GO TO 60                                          AXIS0071
         Z=FLOAT(KN)                                                    AXIS0072
         IF (IEX.NE.0) Z=Z+7.0                                          AXIS0073
         DXB=-(0.07*FCMI)*Z+AXLEN*0.5                                   AXIS0074
         DYB=(0.325*FCMI)*A-(0.075*FCMI)                                AXIS0075
         XT=XPAGE+(DXB*CTH-DYB*STH)                                     AXIS0076
         YT=YPAGE+(DYB*CTH+DXB*STH)                                     AXIS0077
         CALL SYMBOL (XT,YT,HEIGH,IBCD,IDUM,ANGLE,KN)                   AXIS0078
         IF (IEX.EQ.0) GO TO 60                                         AXIS0079
         Z=FLOAT(KN+2)                                                  AXIS0080
         XT=XT+(Z*CTH)*HEIGH                                            AXIS0081
         YT=YT+(Z*STH)*HEIGH                                            AXIS0082
         CALL SYMBOL (XT,YT,HEIGH,NBCD,IDUM,ANGLE,3)                    AXIS0083
         XT=XT+(3.0*CTH-0.8*STH)*HEIGH                                  AXIS0084
         YT=YT+(3.0*STH+0.8*CTH)*HEIGH                                  AXIS0085
         CALL NUMBER (XT,YT,HEIG2,EX,ANGLE,-1)                          AXIS0086
   60    NT=NT-1                                                        AXIS0087
   70 CONTINUE                                                          AXIS0088
      CALL PLOT (XPAGE+AXLEN*CTH,YPAGE+AXLEN*STH,3)                     AXIS0089
      DXB=-(0.07*FCMI)*(A*STH)                                          AXIS0090
      DYB=+(0.07*FCMI)*(A*CTH)                                          AXIS0091
      A=FLOAT(NTIC-1)                                                   AXIS0092
      XN=XPAGE+A*CTH                                                    AXIS0093
      YN=YPAGE+A*STH                                                    AXIS0094
      DO 80 I=1,NTIC                                                    AXIS0095
         CALL PLOT (XN,YN,2)                                            AXIS0096
         CALL PLOT (XN+DXB,YN+DYB,2)                                    AXIS0097
         CALL PLOT (XN,YN,2)                                            AXIS0098
         XN=XN-CTH                                                      AXIS0099
         YN=YN-STH                                                      AXIS0100
   80 CONTINUE                                                          AXIS0101
      RETURN                                                            AXIS0102
      END                                                               AXIS0103
      SUBROUTINE SCALE (ARRAY,AXLEN,NPTS,INC)                           SCAL0001
C. SCALE  FORTRAN 907,925,951,953,IPF                    VER01 ZUPCA000 SCAL0002
C                                                                       SCAL0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       SCAL0005
C  ARRAY   NAME OF ARRAY CONTAINING VALUES TO BE SCALED.                SCAL0006
C  AXLEN   LENGTH IN UNITS  OVER WHICH ARRAY IS TO BE SCALED.           SCAL0007
C  NPTS    NUMBER OF POINTS TO BE SCALED.                               SCAL0008
C  INC     INCREMENT OF LOCATION OF SUCCESSIVE POINTS.                  SCAL0009
C                                                                       SCAL0010
C  LIBRARY FUNCTIONS USED (ABS,AINT,ALOG10,AMAX1,AMIN1,IABS,INT)        SCAL0011
C  GRAPHICS ROUTINES NONE USED                                          SCAL0012
      DIMENSION ARRAY(1)                                                SCAL0013
      DIMENSION ASAVE(7)                                                SCAL0014
C                                                                       SCAL0015
      DATA ASAVE(1),ASAVE(2),ASAVE(3),ASAVE(4),ASAVE(5),ASAVE(6),       SCAL0016
     1 ASAVE(7)/1.0,2.0,4.0,5.0,8.0,10.0,20.0/                          SCAL0017
C                                                                       SCAL0018
      FAD=0.01                                                          SCAL0019
      K=IABS(INC)                                                       SCAL0020
      N=NPTS*K                                                          SCAL0021
C  FIND MININUM AND MAXIMUM WITHIN THE SUBSET OF THE DATA               SCAL0022
      Y0=ARRAY(1)                                                       SCAL0023
      YN=Y0                                                             SCAL0024
      DO 10 I=1,N,K                                                     SCAL0025
         YS=ARRAY(I)                                                    SCAL0026
         Y0=AMIN1(Y0,YS)                                                SCAL0027
         YN=AMAX1(YN,YS)                                                SCAL0028
   10 CONTINUE                                                          SCAL0029
      FIRSTV=Y0                                                         SCAL0030
      IF (Y0.LT.0.0) FAD=FAD-1.0                                        SCAL0031
      DELTAV=(YN-FIRSTV)/AXLEN                                          SCAL0032
      IF (DELTAV.GT.0.0) GO TO 20                                       SCAL0033
      DELTAV=ABS((2.0*FIRSTV)/AXLEN)+1.0                                SCAL0034
   20 I=INT(ALOG10(DELTAV)+1000.0)                                      SCAL0035
      P=10.0**(I-1000)                                                  SCAL0036
      DELTAV=DELTAV/P-0.01                                              SCAL0037
      DO 30 I=1,6                                                       SCAL0038
         IS=I                                                           SCAL0039
         IF (ASAVE(I).GE.DELTAV) GO TO 40                               SCAL0040
   30 CONTINUE                                                          SCAL0041
   40 DELTAV=ASAVE(IS)*P                                                SCAL0042
      FIRSTV=DELTAV*AINT(Y0/DELTAV+FAD)                                 SCAL0043
      T=FIRSTV+(AXLEN+0.01)*DELTAV                                      SCAL0044
      IF (T.GE.YN) GO TO 50                                             SCAL0045
      FIRSTV=P*AINT(Y0/P+FAD)                                           SCAL0046
      T=FIRSTV+(AXLEN+0.01)*DELTAV                                      SCAL0047
      IF (T.GE.YN) GO TO 50                                             SCAL0048
      IS=IS+1                                                           SCAL0049
      GO TO 40                                                          SCAL0050
   50 FIRSTV=FIRSTV-AINT((AXLEN+(FIRSTV-YN)/DELTAV)/2.0)*DELTAV         SCAL0051
      IF (Y0*FIRSTV.LE.0.0) FIRSTV=0.0                                  SCAL0052
      IF (INC.GT.0) GO TO 60                                            SCAL0053
      FIRSTV=FIRSTV+AINT(AXLEN+0.5)*DELTAV                              SCAL0054
      DELTAV=-DELTAV                                                    SCAL0055
   60 N=N+1                                                             SCAL0056
      ARRAY(N)=FIRSTV                                                   SCAL0057
      N=N+K                                                             SCAL0058
      ARRAY(N)=DELTAV                                                   SCAL0059
      RETURN                                                            SCAL0060
      END                                                               SCAL0061
      SUBROUTINE NUMBER (XPAGE,YPAGE,HEIGH,FPN,ANGLE,NDEC)              NUMB0001
C. NUMBER F77 907,925,951,953,IPF                        VER01 ZUPCD900 NUMB0002
C                                                                       NUMB0003
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       NUMB0005
C  XPAGE,YPAGE COORDINATES OF LOWER LEFT CORNER OF NUMBER.              NUMB0006
C  HEIGH    HEIGHT OF PLOTTED NUMBER.                                   NUMB0007
C  FPN      FLOATING POINT NUMBER TO BE PLOTTED.                        NUMB0008
C  ANGLE    ANGLE AT WHICH NUMBER IS PLOTTED, IN DEGREES.               NUMB0009
C  NDEC     NUMBER OF DECIMAL PLACES TO BE DRAWN.                       NUMB0010
C   THIS VERSION OF NUMBER REQUIRES THE SYMBOL VERSION WITH             NUMB0011
C   999.0 X, Y FEATURE, AND  NC = 0 FEATURE.                            NUMB0012
C                                                                       NUMB0013
C  LIBRARY FUNCTIONS USED (ABS,ALOG10,FLOAT,INT)                        NUMB0014
C  GRAPHICS ROUTINES USED (SYMBOL)                                      NUMB0015
      CHARACTER*20 NUM                                                  NUMB0016
      CHARACTER*1 MINUS,IZERO,IPOINT                                    NUMB0017
      CHARACTER*10 NUMS                                                 NUMB0018
C                                                                       NUMB0019
      DATA MINUS/'-'/,IZERO/'0'/,IPOINT/'.'/                            NUMB0020
      DATA NUMS/'0123456789'/                                           NUMB0021
      DATA MAXN/9/                                                      NUMB0022
C                                                                       NUMB0023
      II=0                                                              NUMB0024
      FPV=FPN                                                           NUMB0025
      N=NDEC                                                            NUMB0026
      IF (N.GT.MAXN) N=MAXN                                             NUMB0027
      IF (N.LT.-MAXN) N=-MAXN                                           NUMB0028
      IF (FPV.GE.0.0) GO TO 10                                          NUMB0029
      II=II+1                                                           NUMB0030
      NUM(II:II)=MINUS                                                  NUMB0031
   10 MN=-N                                                             NUMB0032
      IF (N.LT.0) MN=MN-1                                               NUMB0033
      RTMP=10.0**MN                                                     NUMB0034
      FPV=ABS(FPV)+(0.5*RTMP)                                           NUMB0035
      I=INT(ALOG10(FPV)+1.0)                                            NUMB0036
      ILP=I                                                             NUMB0037
      IF (N.LT.-1) ILP=ILP+(N+1)                                        NUMB0038
      IF (ILP.GT.0) GO TO 20                                            NUMB0039
      II=II+1                                                           NUMB0040
      NUM(II:II)=IZERO                                                  NUMB0041
      GO TO 50                                                          NUMB0042
   20 CONTINUE                                                          NUMB0043
      IF (ILP+N.LE.18) GO TO 30                                         NUMB0044
      N=-1                                                              NUMB0045
      IF (ILP.GT.19) ILP=19                                             NUMB0046
   30 CONTINUE                                                          NUMB0047
      DO 40 J=1,ILP                                                     NUMB0048
         RTMP=10.0**(J-I)                                               NUMB0049
         K=INT(FPV*RTMP)                                                NUMB0050
         IF (K.GT.MAXN) K=MAXN                                          NUMB0051
         II=II+1                                                        NUMB0052
         NUM(II:II)=NUMS(K+1:K+1)                                       NUMB0053
         FPV=FPV-(FLOAT(K)/RTMP)                                        NUMB0054
   40 CONTINUE                                                          NUMB0055
   50 CONTINUE                                                          NUMB0056
      IF (N.LT.0) GO TO 70                                              NUMB0057
      II=II+1                                                           NUMB0058
      NUM(II:II)=IPOINT                                                 NUMB0059
      IF (N.LE.0) GO TO 70                                              NUMB0060
      DO 60 J=1,N                                                       NUMB0061
         K=INT(FPV*10.0)                                                NUMB0062
         IF (K.GT.MAXN) K=MAXN                                          NUMB0063
         II=II+1                                                        NUMB0064
         NUM(II:II)=NUMS(K+1:K+1)                                       NUMB0065
         FPV=FPV*10.0-FLOAT(K)                                          NUMB0066
   60 CONTINUE                                                          NUMB0067
   70 CALL SYMBOL (XPAGE,YPAGE,HEIGH,NUM,IDUM,ANGLE,II)                 NUMB0068
      RETURN                                                            NUMB0069
      END                                                               NUMB0070
C. ONLINE  UHCBS FORTRAN 77  58X5   INCH                 VER01 PN200902         
      SUBROUTINE PLOTS(ISF,INDX,LDEV)                                   PLTS0001
C. PLOTS  F77     907, 951                               VER01 ZUPCG500 PLTS0002
C. IPE                                                                  PLTS0003
C                                                                       PLTS0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PLTS0006
C  LIBRARY FUNCTIONS USED (FLOAT)                                       PLTS0007
C  GRAPHICS ROUTINES USED (BUFF, DASHS, FONT, PLOT, TLRNCE)             PLTS0008
C                                                                       PLTS0009
      CHARACTER*1 CDUM                                                  PLTS0010
      DIMENSION ARRAY(2)                                                PLTS0011
      DATA ARRAY /-0.1,0.1/                                             PLTS0013
C                                                                       PLTS0014
C  CALL BUFF WITH "SET-UP" PARAMETERS                                   PLTS0015
      CALL BUFF (LDEV,0,1,CDUM)                                         PLTS0016
      RTMP1=FLOAT(-ISF)                                                 PLTS0017
      RTMP2=FLOAT(-INDX)                                                PLTS0018
      CALL PLOT (RTMP1,RTMP2,1007)                                      PLTS0019
C                                                                       PLTS0020
C  DEFINE DEFAULT DASHLINE LENGTH                                       PLTS0021
      CALL DASHS (ARRAY,2)                                              PLTS0022
      CALL DASHS (ARRAY,0)                                              PLTS0023
C                                                                       PLTS0024
C***LOC216 THE FOLLOWING 2 STATEMENTS FOR IPE ONLY                      PLTS0025
      CALL TLRNCE (7,2)                                                 PLTS0026
      CALL FONT (-999.0)                                                PLTS0027
C***LOC216 END.                                                         PLTS0028
C                                                                       PLTS0029
      RETURN                                                            PLTS0030
      END                                                               PLTS0031
      SUBROUTINE PLOT (XPAG,YPAG,IPEN)                                  PLOT0001
C. PLOT   F77     907, 951, 58X5 O/L                     VER04 ZUPCF500 PLOT0002
C. CONTROLLER DEPENDENT                                                 PLOT0003
C                                                                       PLOT0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PLOT0006
C  LIBRARY FUNCTIONS USED (ABS, FLOAT, IABS, INT, SIGN)                 PLOT0007
C  GRAPHICS ROUTINES USED (BUFF, FCEPLT)                                PLOT0008
C                                                                       PLOT0009
      CHARACTER*1 CDUM                                                  PLOT0010
C                                                                       PLOT0013
C***LOC308 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          PLOT0014
      DATA INDEX,IOP,IPFG,ISA/0,3,0,2/                                  PLOT0015
      DATA IPFLG/0/                                                     PLOT0016
      DATA N/1/,NP/1/                                                   PLOT0017
      DATA DPX/32767.0/                                                 PLOT0018
      DATA XOX,YOY/0.0,0.0/                                             PLOT0019
C                                                                       PLOT0020
C***LOC111 METRIC/INCH CONVERSION: INCH (USUALLY 2032.0), METRIC (800.0)PLOT0021
C     NO OF STEPS PER UNIT (INCH OR CENTIMETER)                         PLOT0022
      DATA XSTP,YSTP,STEPS/2032.0,2032.0,2032.0/                        PLOT0024
C***LOC111 END.                                                         PLOT0025
C                                                                       PLOT0026
C***LOC308 END.                                                         PLOT0027
C                                                                       PLOT0028
      IP=IPEN                                                           PLOT0029
C  CHECK FOR SPECIAL ENTRANCE: 99 (FCEPLT); >1000 (SPECIAL)             PLOT0030
      IF (IABS(IP)-99) 40,20,30                                         PLOT0031
   20 CONTINUE                                                          PLOT0032
C                                                                       PLOT0033
C***LOC202 CONTROLLER DEPENDENT: COMMENT OUT 'CALL FCEPLT' FOR 907/PCI  PLOT0034
      CALL FCEPLT                                                       PLOT0035
C                                                                       PLOT0036
C  AFTER CALLING FCEPLT, RE-ORIGIN AND BEGIN A NEW SEARCH ADDRESS       PLOT0037
      IP=-3                                                             PLOT0038
   30 CONTINUE                                                          PLOT0039
      IF (IABS(IP)-999) 40,60,250                                       PLOT0040
   40 IPFG=0                                                            PLOT0041
C  CHECK FOR VARIOUS IPEN FUNCTIONS                                     PLOT0042
      IF (IP.GE.0) GO TO 50                                             PLOT0043
C  IF IPEN IS NEGATIVE - REORIGIN                                       PLOT0044
      IP=-IP                                                            PLOT0045
      IPFG=-10                                                          PLOT0046
C  CHECK FOR IPEN BETWEEN 30 AND 39                                     PLOT0047
   50 CONTINUE                                                          PLOT0048
      IF (IP.LT.30) GO TO 70                                            PLOT0049
      IF (IP.GE.40) GO TO 70                                            PLOT0050
      IP=IP-30                                                          PLOT0051
      IPFG=IPFG-1                                                       PLOT0052
      GO TO 70                                                          PLOT0053
C  IPEN IS 999                                                          PLOT0054
   60 IP=3                                                              PLOT0055
      IPFG=-99                                                          PLOT0056
      ISA=999                                                           PLOT0057
C  CHECK FOR PEN CHANGE                                                 PLOT0058
   70 CONTINUE                                                          PLOT0059
      IF (IP.EQ.IOP) GO TO 100                                          PLOT0060
      IF (IP-2) 100,80,90                                               PLOT0061
C  PEN DOWN                                                             PLOT0062
   80 IOP=2                                                             PLOT0063
      CALL BUFF (2,1,0,CDUM)                                            PLOT0064
      GO TO 100                                                         PLOT0065
C  PEN UP                                                               PLOT0066
   90 IOP=3                                                             PLOT0067
      CALL BUFF (3,1,0,CDUM)                                            PLOT0068
  100 XP=XPAG*XSTP                                                      PLOT0069
      YP=YPAG*YSTP                                                      PLOT0070
  110 XDX=XP-XOX                                                        PLOT0071
      YDY=YP-YOY                                                        PLOT0072
      XDX=XDX+SIGN(0.5,XDX)                                             PLOT0073
      YDY=YDY+SIGN(0.5,YDY)                                             PLOT0074
      ADX=ABS(XDX)                                                      PLOT0075
      ADY=ABS(YDY)                                                      PLOT0076
      IF (ADX.LE.DPX) GO TO 150                                         PLOT0077
      IF (ADX.GT.ADY) GO TO 130                                         PLOT0078
  120 DIV=ADY/DPX                                                       PLOT0079
      GO TO 140                                                         PLOT0080
  130 DIV=ADX/DPX                                                       PLOT0081
  140 IDX=INT(XDX/DIV)                                                  PLOT0082
      IDY=INT(YDY/DIV)                                                  PLOT0083
C  SEND OUT PART OF THE REQUESTED MOVE                                  PLOT0084
      CALL BUFF (IDX,IDY,2,CDUM)                                        PLOT0085
      XOX=XOX+FLOAT(IDX)                                                PLOT0086
      YOY=YOY+FLOAT(IDY)                                                PLOT0087
      GO TO 110                                                         PLOT0088
C  SEND OUT LAST PART OF LINE                                           PLOT0089
  150 CONTINUE                                                          PLOT0090
      IF (ADY.GT.DPX) GO TO 120                                         PLOT0091
      IDX=INT(XDX)                                                      PLOT0092
      IDY=INT(YDY)                                                      PLOT0093
      CALL BUFF (IDX,IDY,2,CDUM)                                        PLOT0094
      XOX=XOX+FLOAT(IDX)                                                PLOT0095
      YOY=YOY+FLOAT(IDY)                                                PLOT0096
C                                                                       PLOT0097
C  SET PTYPE FLAG SO NO FURTHER CALLS TO PTYPE WILL BE ACCEPTED         PLOT0098
C  (SET IPFLG IN BUFF ROUTINE) - USEFUL FOR 951 OR 58X5 CONTROLLER ONLY PLOT0099
      IF (IPFLG.GT.0) GO TO 160                                         PLOT0100
      CALL BUFF (IDUM,1,9,CDUM)                                         PLOT0101
      IPFLG=1                                                           PLOT0102
C                                                                       PLOT0103
C  CHECK AT END FOR VARIOUS IPEN FUNCTIONS                              PLOT0104
  160 CONTINUE                                                          PLOT0105
      IF (IPFG+1) 170,180,999                                           PLOT0106
C  REORIGN, DUMP BUFFER, AND OUTPUT SEARCH ADDRESS                      PLOT0107
  170 XOX=0.0                                                           PLOT0108
      YOY=0.0                                                           PLOT0109
C  CHECK FOR OUTPUT OF INDEX COMMAND                                    PLOT0110
      IF (INDEX-1) 200,190,180                                          PLOT0111
  180 CONTINUE                                                          PLOT0112
      IF (IPFG+99.NE.0) GO TO 200                                       PLOT0113
C  OUTPUT INDEX COMMAND                                                 PLOT0114
  190 CONTINUE                                                          PLOT0115
      CALL BUFF (3,0,6,CDUM)                                            PLOT0116
      CALL BUFF (11,1,0,CDUM)                                           PLOT0117
      CALL BUFF (0,1,0,CDUM)                                            PLOT0118
      CALL BUFF (6,1,0,CDUM)                                            PLOT0119
C  DUMP BUFFER AND WRITE NEXT S.A.                                      PLOT0120
  200 CONTINUE                                                          PLOT0121
      CALL BUFF (0,0,5,CDUM)                                            PLOT0122
      CALL BUFF (1,1,0,CDUM)                                            PLOT0123
      CALL BUFF (ISA,3,7,CDUM)                                          PLOT0124
C                                                                       PLOT0125
C  RESET PTYPE FLAG IN BUFF                                             PLOT0126
C  RESET SEARCH ADDRESS VARIABLE 'ISA'                                  PLOT0127
      IF (ISA.NE.999) GO TO 210                                         PLOT0128
      ISA=1                                                             PLOT0129
      IPFLG=0                                                           PLOT0130
      CALL BUFF (IDUM,0,9,CDUM)                                         PLOT0131
C  SEND OLD PEN NUMBER AGAIN                                            PLOT0132
  210 CONTINUE                                                          PLOT0133
      IF (NP.LE.16) GO TO 220                                           PLOT0134
C  CALL SUBROUTINE BUFF TO GET THE RADIX IF PEN NO. IS LARGER THAN 16   PLOT0135
      CALL BUFF (NRAD,IDUM,12,CDUM)                                     PLOT0136
      IRAD=NRAD                                                         PLOT0137
      IF (NP.GE.IRAD) GO TO 230                                         PLOT0138
  220 CONTINUE                                                          PLOT0139
      CALL BUFF (2,0,6,CDUM)                                            PLOT0140
      CALL BUFF (4,1,0,CDUM)                                            PLOT0141
      CALL BUFF (NP,1,0,CDUM)                                           PLOT0142
      GO TO 240                                                         PLOT0143
C  CODE FOR EXTENDED PEN PALETTE MODE (58X5)                            PLOT0144
  230 CONTINUE                                                          PLOT0145
      CALL BUFF (5,0,6,CDUM)                                            PLOT0146
      CALL BUFF (14,1,0,CDUM)                                           PLOT0147
      CALL BUFF (32,1,0,CDUM)                                           PLOT0148
      CALL BUFF (NP,3,7,CDUM)                                           PLOT0149
  240 CONTINUE                                                          PLOT0150
C  THE ABOVE CODE IS USEFUL FOR 951 & 58X5 CONTROLLERS ONLY (FCEPLT)    PLOT0151
C                                                                       PLOT0152
      ISA=ISA+1                                                         PLOT0153
C  CHECK FOR IPEN = 999                                                 PLOT0154
      IF (IPFG+99.NE.0) GO TO 999                                       PLOT0155
      CALL BUFF (-1,0,1,CDUM)                                           PLOT0156
C                                                                       PLOT0157
C  RESET THE FLAGS                                                      PLOT0158
      IOP=3                                                             PLOT0159
      ISA=2                                                             PLOT0160
      IPFG=0                                                            PLOT0161
      INDEX=0                                                           PLOT0162
      XOX=0.0                                                           PLOT0163
      YOY=0.0                                                           PLOT0164
      N=1                                                               PLOT0165
      GO TO 999                                                         PLOT0166
C                                                                       PLOT0167
C  CHECK FOR SPECIAL PLOT CALLS  (1001 TO 1007)                         PLOT0168
  250 IP=IP-1000                                                        PLOT0169
      IF (IP.GT.7) GO TO 999                                            PLOT0170
C                                                                       PLOT0171
      GO TO (310,320,330,340,350,360,370), IP                           PLOT0172
  310 XSTP=XPAG*STEPS                                                   PLOT0175
      YSTP=YPAG*STEPS                                                   PLOT0176
      GO TO 999                                                         PLOT0177
  320 XPAG=XOX/XSTP                                                     PLOT0179
      YPAG=YOY/YSTP                                                     PLOT0180
      GO TO 999                                                         PLOT0181
C  (RX, RY, 1003)    FIND CURRENT FACTOR                                PLOT0182
  330 XPAG=XSTP/STEPS                                                   PLOT0183
      YPAG=YSTP/STEPS                                                   PLOT0184
      GO TO 999                                                         PLOT0185
C  (SX,   , 1004)    NEWPEN                                             PLOT0186
  340 IOP=3                                                             PLOT0187
      NP=INT(XPAG)                                                      PLOT0188
      GO TO 999                                                         PLOT0189
C  (RX, RY, 1005)    SYMBOL: FIND STEP SIZE, INTEGER SCALE              PLOT0190
  350 XPAG=XSTP                                                         PLOT0191
      YPAG=FLOAT(N)                                                     PLOT0192
      GO TO 999                                                         PLOT0193
C  (SX, SY, 1006)    SYMBOL: ADVANCE CURRENT PEN POSITION               PLOT0194
  360 XOX=XOX+XPAG                                                      PLOT0195
      YOY=YOY+YPAG                                                      PLOT0196
      IOP=3                                                             PLOT0197
      GO TO 999                                                         PLOT0198
C  (SX, SY, 1007)    PLOTS: INTEGER SCALE AND INDEX                     PLOT0199
  370 CONTINUE                                                          PLOT0200
      IF (XPAG.LE.0.0) GO TO 375                                        PLOT0201
      N=INT(XPAG)                                                       PLOT0202
      IF (N.GT.32) N=32                                                 PLOT0203
      STEPS=STEPS/FLOAT(N)                                              PLOT0204
      XSTP=STEPS                                                        PLOT0205
      YSTP=STEPS                                                        PLOT0206
      DPX=DPX/FLOAT(N)                                                  PLOT0207
      CALL BUFF (2,0,6,CDUM)                                            PLOT0208
      CALL BUFF (9,1,0,CDUM)                                            PLOT0209
      CALL BUFF (N,1,0,CDUM)                                            PLOT0210
  375 CONTINUE                                                          PLOT0211
      IF (YPAG.LE.0.0) GO TO 999                                        PLOT0212
      INDEX=INT(YPAG)                                                   PLOT0213
      GO TO 190                                                         PLOT0214
  999 CONTINUE                                                          PLOT0215
      RETURN                                                            PLOT0216
      END                                                               PLOT0217
      SUBROUTINE BUFF (IDX,IDY,MODE,IDXX)                               BUFF0001
C. BUFF   F77     907, 951, 58X5 O/L                     VER02 ZUPFA500 BUFF0002
C. COMPUTER DEPENDENT                                                   BUFF0003
C. SITE DEPENDENT                                                       BUFF0004
C                                                                       BUFF0005
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       BUFF0007
C  LIBRARY FUNCTIONS USED (ICHAR, MOD)                                  BUFF0008
C  GRAPHICS ROUTINES USED (PDMP)                                        BUFF0009
C                                                                       BUFF0010
C  10/28/85 VER02 - ADD MODE 12 FOR 58X5 O/L PRODUCT                    BUFF0011
C  MODE=0     IDX=DIRECT CODE   ; IDY=REPEAT COUNT                      BUFF0012
C  MODE=1     IDX=LDEV FOR SETUP, =0 FOR RESET;  IDY=DUMMY              BUFF0013
C  MODE=2     IDX=MULTI-PREC. DX; IDY=MULTI-PREC. DY                    BUFF0014
C  MODE=3    IDXX(1)=SYMB STRING; IDY=NO.OF CHARS LEFT-JUSTIFIED        BUFF0015
C  MODE=4     IDX=SYMBOL (INTEQ); IDY=1                                 BUFF0016
C  MODE=5     IDX=IDY=DUMMY       SPECIAL CALL TO FORCE DUMP            BUFF0017
C  MODE=6     IDX=# OF CODES NEEDED IN BUFFER; IDY=DUMMY                BUFF0018
C  MODE=7     IDX=MULTI-PREC NUM; IDY=# OF CHARS TO OUTPUT              BUFF0019
C  MODE=8    IDXX(1)=SYMB STRING; IDY=COUNT(NO STRING CMD SENT)         BUFF0020
C  MODE=9     IDX=DUMMY         ; IDY=STORE FLAG                        BUFF0021
C  MODE=10    IDX=DUMMY         ; IDY=RETURN FLAG                       BUFF0022
C  MODE=11   IDXX(1)=SYMB STRING; IDY=COUNT                             BUFF0023
C  MODE=12    IDX=RETURN RADIX  ; IDY=RETURN JMAX                       BUFF0024
      CHARACTER*1 IDXX                                                  BUFF0025
C*    CHARACTER * (*) IDXX                                              BUFF0026
C                                                                       BUFF0027
C***LOC600THE MAXIMUM NO. OF CHARACTERS (E.G. 125) IN IBUF (BUFFER)     BUFF0028
C  MAY NEED TO BE CHANGED TO 70 (OR OTHER VALUES)                       BUFF0029
ccc JAH  10/29/91
      DIMENSION IBUF(124)                                               BUFF0031
C                                                                       BUFF0032
      DIMENSION IRESET(8)                                               BUFF0033
C                                                                       BUFF0034
C***LOC601 THE DIM. OF ISETUP DEPENDS ON THE LENGTH OF THE HEADER RECORDBUFF0035
      DIMENSION ISETUP(37)                                              BUFF0036
C                                                                       BUFF0038
      DIMENSION JTMP(1)                                                 BUFF0039
      DIMENSION IXX(3)                                                  BUFF0040
      DIMENSION IYY(3)                                                  BUFF0041
C     COMMON /CBUF/IBUF,IPFLG,IRCNT,ISCNT,IRESET,ISETUP,J,JMAX,N1,N2    BUFF0042
C                                                                       BUFF0043
C***LOC309 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          BUFF0044
ccc   JAH  10/29/91
      DATA IBUF/124*0/                                                  BUFF0046
      DATA IPFLG/0/                                                     BUFF0047
      DATA J/0/                                                         BUFF0048
C***LOC309 END.                                                         BUFF0049
C                                                                       BUFF0050
C  IRCNT = THE DIMENSION OF IRESET + 1                                  BUFF0051
      DATA IRCNT/9/                                                     BUFF0052
C                                                                       BUFF0053
C***LOC602 ISCNT = THE DIMENSION OF ISETUP + 1                          BUFF0054
      DATA ISCNT/38/                                                    BUFF0055
C                                                                       BUFF0057
C  RESET 907 OR 951 -- SELECT PEN 1; DISABLE DOUBLE BUFFERRING          BUFF0058
      DATA IRESET/1001,0,0,0,1004,1001,1008,1000/                       BUFF0059
C                                                                       BUFF0060
C***LOC603 INITIALIZE THE HEADER RECORD (DATA = ASCII CHAR + 1000)      BUFF0061
C    1A  --  SEARCH ADDRESS 1                                           BUFF0062
C    1B  --  SET RADIX (SET THE RADIX TO THE VARIABLE N1 IN THE CODE)   BUFF0063
C    2A  --  16 '128 CHAR' BUFFER (TOTAL OF 2K BUFFER IN CONTROLLER F/W)BUFF0064
C    2B  --  SUPPRESS 5 ECHO CHARACTER (SUCH AS CR, LF, ETC)            BUFF0065
C               * FOR IBM MAINFRAME: USE 40 ECHO CHARACTER              BUFF0066
C               * OTHER CHOICE: 3, 4, 6, 9, 20, 40 ECHO CHARACTER ETC   BUFF0067
C    3   --  DELAY 0 MILLI-SECONDS (20 MS INTERVAL)                     BUFF0068
C               * OTHER CHOICE: 1(20 MS), 10(200 MS), 20(400 MS), ETC   BUFF0069
C    4   --  SET OK RESPONSE  = ('0', 'CR') (2,  3  0, 0 13)            BUFF0070
C               * OTHER CHOICE: ('0') (1,  3  0)                        BUFF0071
C    5   --  SET BAD RESPONSE = ('1', 'CR') (2,  3  1, 0 13)            BUFF0072
C               * OTHER CHOICE: ('1') (1,  3  1)                        BUFF0073
C    6   --  SET RESPONSE TRIGGER (PROMT CHARACTER) FOR                 BUFF0074
C               VAX, PDP10, PDP11, HONLEV6, MODCOMP4, HP2100            BUFF0075
C                 = '>' (1,  3  14)  (DEFAULT)                          BUFF0076
C               IBM 370, GA 16                                          BUFF0077
C                 = (BEL) (1,  0  7)                                    BUFF0078
C               BURROUGH, GASPC16, PE16, PRIME(NO TERM), SEL32, WEST2500BUFF0079
C                 = '?' (1,  3  15)                                     BUFF0080
C               PRIME (WITH TERMINAL), UNIVAC FIELDATA                  BUFF0081
C                 = (LF) (1,  0  10)                                    BUFF0082
C               HON6000, HP3000 =    (DC1)     (1,  1  1)               BUFF0083
C               CDC             =  ('?', ' ')  (2,  3 15, 2 0)          BUFF0084
C               UNIVAC ASCII    = ('>', 'ETX') (2,  3 14, 0 3)          BUFF0085
C               DG MV8000 & NOVA=  (?,CR,LF)   (3,  3 15, 0 13, 0 10)   BUFF0086
C    7A  --  SELECT PEN 1                                               BUFF0087
C    7B  --  SET SCALING 1 TO 1                                         BUFF0088
      DATA ISETUP/                                                      BUFF0089
     1  1001,1000,1000,1001,  1007,0,                                   BUFF0090
     2  1008,1010,  1008,1002,1005,                                     BUFF0091
     3  1008,1003,1000,                                                 BUFF0092
     4  1008,1004,1002,1003,1000,1000,1013,                             BUFF0093
     5  1008,1005,1002,1003,1001,1000,1013,                             BUFF0094
     6  1008,1006,1001,1003,1014,                                       BUFF0095
     7  1004,1001,  1009,1001/                                          BUFF0096
C***LOC603 END.                                                         BUFF0097
C                                                                       BUFF0098
C***LOC604  JMAX = THE DIMENSION OF IBUF                                BUFF0099
ccc   JAH  10/29/91
      DATA JMAX/124/                                                    BUFF0101
C                                                                       BUFF0102
C***LOC605 SET RADIX AND RADIX SQUARE                                   BUFF0103
C  (USUALLY SET TO NO. OF CHAR. AVAILABLE IN THE COMPUTER - 1)          BUFF0104
C  (FOR IBM EBCDIC COMPUTER, RADIX CAN BE SET TO 59 INSTEAD OF 95)      BUFF0105
C*    DATA N1,N2/32,1024/                                               BUFF0106
C*    DATA N1,N2/59,3481/                                               BUFF0107
C*    DATA N1,N2/63,3969/                                               BUFF0108
      DATA N1,N2/95,9025/                                               BUFF0109
C                                                                       BUFF0110
      IX=IDX                                                            BUFF0111
      IY=IDY                                                            BUFF0112
      IF (MODE.EQ.1) GO TO 40                                           BUFF0113
      IF (J.LE.0) GO TO 990                                             BUFF0114
      IF (MODE) 990,10,30                                               BUFF0115
C  STUFF CODE INTO BUFFER WITH OFFSET FLAG (+1000)                      BUFF0116
   10 IBUF(J)=IX+1000                                                   BUFF0117
      IY=IY-1                                                           BUFF0118
      J=J+1                                                             BUFF0119
      IF (J.LE.JMAX) GO TO 20                                           BUFF0120
      CALL PDMP (IBUF,J)                                                BUFF0121
      J=1                                                               BUFF0122
   20 CONTINUE                                                          BUFF0123
      IF (IY.GT.0) GO TO 10                                             BUFF0124
      GO TO 999                                                         BUFF0125
C                                                                       BUFF0126
   30 CONTINUE                                                          BUFF0127
      GO TO ( 40, 60,340,340,440,460,470,500,520,530,540,620), MODE     BUFF0128
C  MODE  =    1   2   3   4   5   6   7   8   9   10  11  12            BUFF0129
C                                                                       BUFF0130
C  MODE = 1 ; CALL TO SET UP RADIX FOR DELTAS                           BUFF0131
C  AND ALLOW OTHER CALLS BY SETTING 'J' TO A VALID VALUE (+1)           BUFF0132
C  CALLED BY PLOTS UPON INITIALIZATION                                  BUFF0133
   40 CONTINUE                                                          BUFF0134
      IF (IX.LE.0) GO TO 50                                             BUFF0135
C  SETUP - CALL PDMP WITH LDEV                                          BUFF0136
      J=1                                                               BUFF0137
      JTMP(1)=IX                                                        BUFF0138
      CALL PDMP (JTMP,-1)                                               BUFF0139
C  NOW SET UP RADIX IN INITIALIZATION STREAM (HEADER RECORD)            BUFF0140
      ISETUP(6)=N1-1+1000                                               BUFF0141
      CALL PDMP (ISETUP,ISCNT)                                          BUFF0142
      GO TO 999                                                         BUFF0143
C  RESET - CALL PDMP, RESET I/O PARAMETERS                              BUFF0144
   50 J=0                                                               BUFF0145
      IRESET(2)=9999/N2+1000                                            BUFF0146
      IRESET(3)=MOD(9999/N1,N1)+1000                                    BUFF0147
      IRESET(4)=MOD(9999,N1)+1000                                       BUFF0148
      CALL PDMP (IRESET,IRCNT)                                          BUFF0149
C  WAIT TILL ALL SHUT DOWN                                              BUFF0150
      JTMP(1)=0                                                         BUFF0151
      CALL PDMP (JTMP,0)                                                BUFF0152
      GO TO 999                                                         BUFF0153
C                                                                       BUFF0154
C  MODE = 2; MULTI-PRECISION DELTA MODE                                 BUFF0155
   60 KMD=16                                                            BUFF0156
      IXC=3                                                             BUFF0157
      IYC=3                                                             BUFF0158
C  CHECK SIGN OF X-DELTA                                                BUFF0159
      IF (IX) 80,70,90                                                  BUFF0160
   70 CONTINUE                                                          BUFF0161
      IF (IY) 100,999,110                                               BUFF0162
   80 IX=-IX                                                            BUFF0163
      KMD=17                                                            BUFF0164
C  CHECK SIGN OF Y-DELTA                                                BUFF0165
   90 CONTINUE                                                          BUFF0166
      IF (IY.GE.0) GO TO 110                                            BUFF0167
  100 IY=-IY                                                            BUFF0168
      KMD=KMD+2                                                         BUFF0169
C  SET UP DELTA PARTS USING CURRENT RADIX                               BUFF0170
  110 IXX(1)=IX/N2                                                      BUFF0171
      IXX(2)=MOD((IX/N1),N1)                                            BUFF0172
      IXX(3)=MOD(IX,N1)                                                 BUFF0173
      IYY(1)=IY/N2                                                      BUFF0174
      IYY(2)=MOD((IY/N1),N1)                                            BUFF0175
      IYY(3)=MOD(IY,N1)                                                 BUFF0176
C                                                                       BUFF0177
C  NOW CHECK FOR 1, 2 OR 3 CHARACTER DELTA                              BUFF0178
C+ UPDATED FOR RADIX(N1) FROM 20 TO 63                                  BUFF0179
      ITMP1=IXX(1)+IYY(1)                                               BUFF0180
      IF (N1.LT.24) GO TO 260                                           BUFF0181
      IF (N1.LT.28.AND.ITMP1.NE.0) GO TO 260                            BUFF0182
      IF (N1.LT.28.AND.ITMP1.EQ.0) GO TO 115                            BUFF0183
      IF (ITMP1.NE.0) GO TO 130                                         BUFF0184
      IF (IXX(2)+IYY(2).EQ.0) GO TO 120                                 BUFF0185
  115 CONTINUE                                                          BUFF0186
      KMD=KMD+4                                                         BUFF0187
      IXC=2                                                             BUFF0188
      IYC=2                                                             BUFF0189
      IF (N1.LT.36) GO TO 260                                           BUFF0190
      GO TO 130                                                         BUFF0191
  120 KMD=KMD+8                                                         BUFF0192
      IXC=1                                                             BUFF0193
      IYC=1                                                             BUFF0194
      IF (N1.LT.40) GO TO 260                                           BUFF0195
C  NOW CHECK FOR ZERO COMPONENT OF DELTA                                BUFF0196
  130 CONTINUE                                                          BUFF0197
      IF (N1.LT.32) GO TO 260                                           BUFF0198
      IF (IX.NE.0) GO TO 140                                            BUFF0199
      ITMP=MOD(KMD,4)/2                                                 BUFF0200
      KMD=KMD+12+ITMP                                                   BUFF0201
      IXC=0                                                             BUFF0202
      GO TO 260                                                         BUFF0203
  140 CONTINUE                                                          BUFF0204
      IF (N1.LT.44.AND.IY.NE.0) GO TO 260                               BUFF0205
      IF (IY.NE.0) GO TO 150                                            BUFF0206
      ITMP=MOD(KMD,4)*2                                                 BUFF0207
      KMD=KMD+14-ITMP                                                   BUFF0208
      IYC=0                                                             BUFF0209
      GO TO 260                                                         BUFF0210
C  NOW CHECK FOR DIFFERENT LENGTH DELTAS                                BUFF0211
  150 CONTINUE                                                          BUFF0212
      IF (N1.LT.60.AND.IXC.LE.2) GO TO 260                              BUFF0213
      IF (IXC-2) 260,230,160                                            BUFF0214
  160 CONTINUE                                                          BUFF0215
      IF (N1.LT.52.AND.IXX(1).NE.0) GO TO 260                           BUFF0216
      IF (N1.LT.48.AND.IXX(1).EQ.0) GO TO 190                           BUFF0217
      IF (IXX(1).EQ.0) GO TO 170                                        BUFF0218
      IF (N1.LT.56.AND.IYY(1).NE.0) GO TO 260                           BUFF0219
      IF (N1.LT.56.AND.IYY(1).EQ.0) GO TO 210                           BUFF0220
      IF (IYY(1).EQ.0) GO TO 180                                        BUFF0221
      GO TO 260                                                         BUFF0222
  170 CONTINUE                                                          BUFF0223
      IF (IXX(2).EQ.0) GO TO 200                                        BUFF0224
      GO TO 190                                                         BUFF0225
  180 CONTINUE                                                          BUFF0226
      IF (IYY(2).EQ.0) GO TO 220                                        BUFF0227
      GO TO 210                                                         BUFF0228
  190 IXC=2                                                             BUFF0229
      KMD=KMD+24                                                        BUFF0230
      GO TO 260                                                         BUFF0231
  200 IXC=1                                                             BUFF0232
      KMD=KMD+28                                                        BUFF0233
      GO TO 260                                                         BUFF0234
  210 IYC=2                                                             BUFF0235
      KMD=KMD+32                                                        BUFF0236
      GO TO 260                                                         BUFF0237
  220 IYC=1                                                             BUFF0238
      KMD=KMD+36                                                        BUFF0239
      GO TO 260                                                         BUFF0240
  230 CONTINUE                                                          BUFF0241
      IF (N1.LT.64.AND.IXX(2).NE.0) GO TO 260                           BUFF0242
      IF (IXX(2).EQ.0) GO TO 240                                        BUFF0243
      IF (IYY(2).EQ.0) GO TO 250                                        BUFF0244
      GO TO 260                                                         BUFF0245
  240 IXC=1                                                             BUFF0246
      KMD=KMD+36                                                        BUFF0247
      GO TO 260                                                         BUFF0248
  250 IYC=1                                                             BUFF0249
      KMD=KMD+40                                                        BUFF0250
C                                                                       BUFF0251
C  STUFF THE PROPER NUMBER OF CHARACTERS INTO 'IBUF'                    BUFF0252
C  MAKE SURE THE ENTIRE DELTA WILL FIT IN THIS BUFFER                   BUFF0253
  260 CONTINUE                                                          BUFF0254
      IF (J+1+IXC+IYC.LE.JMAX) GO TO 270                                BUFF0255
      CALL PDMP (IBUF,J)                                                BUFF0256
      J=1                                                               BUFF0257
  270 IBUF(J)=KMD+1000                                                  BUFF0258
      J=J+1                                                             BUFF0259
C  NOW STUFF X-DELTA, MOST SIGNIFICANT FIRST                            BUFF0260
      IF (IXC) 990,300,280                                              BUFF0261
  280 K1=4-IXC                                                          BUFF0262
      DO 290 K=K1,3                                                     BUFF0263
         IBUF(J)=IXX(K)+1000                                            BUFF0264
         J=J+1                                                          BUFF0265
  290 CONTINUE                                                          BUFF0266
C  NOW STUFF Y-DELTA, MOST SIGNIFICANT FIRST                            BUFF0267
  300 CONTINUE                                                          BUFF0268
      IF (IYC) 990,999,310                                              BUFF0269
  310 K1=4-IYC                                                          BUFF0270
      DO 320 K=K1,3                                                     BUFF0271
         IBUF(J)=IYY(K)+1000                                            BUFF0272
         J=J+1                                                          BUFF0273
  320 CONTINUE                                                          BUFF0274
C  DONE FOR MODE 2                                                      BUFF0275
      GO TO 999                                                         BUFF0276
C                                                                       BUFF0277
C  MODE = 3 OR MODE = 4; SYMBOL MODE                                    BUFF0278
  340 CONTINUE                                                          BUFF0279
      K=IY                                                              BUFF0280
      K1=1                                                              BUFF0281
C  MAKE SURE THERE IS ROOM FOR COMMAND CODE,                            BUFF0282
C  THE CHARACTER COUNT, AND THE FIRST CHARACTER IN THE BUFFER           BUFF0283
  360 CONTINUE                                                          BUFF0284
      IF (J+2.LE.JMAX) GO TO 370                                        BUFF0285
C  FLUSH THE BUFFER TO MAKE ROOM                                        BUFF0286
      CALL PDMP (IBUF,J)                                                BUFF0287
      J=1                                                               BUFF0288
  370 CONTINUE                                                          BUFF0289
      IF (K.LE.(N1-1)) GO TO 380                                        BUFF0290
      K=N1-1                                                            BUFF0291
  380 CONTINUE                                                          BUFF0292
      IF (J+K+1.LE.JMAX) GO TO 390                                      BUFF0293
      K=JMAX-J-1                                                        BUFF0294
C  NOW STUFF COMMAND CODE AND CHARACTER COUNT                           BUFF0295
  390 IBUF(J)=5+1000                                                    BUFF0296
      J=J+1                                                             BUFF0297
  400 IBUF(J)=K+1000                                                    BUFF0298
      J=J+1                                                             BUFF0299
      K2=K+K1-1                                                         BUFF0300
C  NOW STUFF CHARACTERS IN A LOOP                                       BUFF0301
      DO 430 I=K1,K2                                                    BUFF0302
         IF (MODE.EQ.4) GO TO 410                                       BUFF0303
         IBUF(J)=ICHAR(IDXX(I:I))                                       BUFF0304
         GO TO 420                                                      BUFF0305
  410    IBUF(J)=IDX                                                    BUFF0306
  420    J=J+1                                                          BUFF0307
         IF (J.LE.JMAX) GO TO 430                                       BUFF0308
C  IF BUFFER FULL, DUMP IT                                              BUFF0309
         CALL PDMP (IBUF,J)                                             BUFF0310
         J=1                                                            BUFF0311
  430 CONTINUE                                                          BUFF0312
      IF (K2.GE.IY) GO TO 999                                           BUFF0313
      K1=K2+1                                                           BUFF0314
      K=IY-K2                                                           BUFF0315
      GO TO 360                                                         BUFF0316
C                                                                       BUFF0317
C  MODE = 5; FLUSH BUFFER                                               BUFF0318
  440 CONTINUE                                                          BUFF0319
      IF (J.LE.1) GO TO 999                                             BUFF0320
  450 CONTINUE                                                          BUFF0321
      CALL PDMP (IBUF,J)                                                BUFF0322
      J=1                                                               BUFF0323
      GO TO 999                                                         BUFF0324
C                                                                       BUFF0325
C  MODE = 6; TEST FOR ENOUGH ROOM IN THE BUFFER                         BUFF0326
  460 CONTINUE                                                          BUFF0327
      IF (J+IX.GT.JMAX) GO TO 450                                       BUFF0328
      GO TO 999                                                         BUFF0329
C                                                                       BUFF0330
C  MODE = 7; STORE IX IN IY WORDS OF BUFFER                             BUFF0331
  470 IXX(1)=IX/N2                                                      BUFF0332
      IXX(2)=MOD((IX/N1),N1)                                            BUFF0333
      IXX(3)=MOD(IX,N1)                                                 BUFF0334
      IF (J+IY.LE.JMAX) GO TO 480                                       BUFF0335
      CALL PDMP (IBUF,J)                                                BUFF0336
      J=1                                                               BUFF0337
  480 K=4-IY                                                            BUFF0338
      DO 490 I=K,3                                                      BUFF0339
         IBUF(J)=1000+IXX(I)                                            BUFF0340
         J=J+1                                                          BUFF0341
  490 CONTINUE                                                          BUFF0342
      GO TO 999                                                         BUFF0343
C                                                                       BUFF0344
C  MODE = 8; HANDLE OPERATOR MESSAGE                                    BUFF0345
  500 K=IY                                                              BUFF0346
C  FORCE LENGTH OF MESSAGE <= RADIX                                     BUFF0347
      IF (K.LE.N1) GO TO 510                                            BUFF0348
      K=N1                                                              BUFF0349
  510 K1=1                                                              BUFF0350
      GO TO 400                                                         BUFF0351
C                                                                       BUFF0352
C  MODE = 9; SET IPFLG                                                  BUFF0353
  520 IPFLG=IDY                                                         BUFF0354
      GO TO 999                                                         BUFF0355
C  MODE = 10; RETURN IPFLG                                              BUFF0356
  530 IDY=IPFLG                                                         BUFF0357
      GO TO 999                                                         BUFF0358
C                                                                       BUFF0359
C  MODE = 11; RASTER PRINT MODE --- FOR 951 CONTROLLER ONLY             BUFF0360
C             CALL FROM SUBROUTINE 'PSYMBL'                             BUFF0361
  540 K=IY                                                              BUFF0362
      K1=1                                                              BUFF0363
  550 CONTINUE                                                          BUFF0364
      IF (J+3.LE.JMAX) GO TO 560                                        BUFF0365
      CALL PDMP (IBUF,J)                                                BUFF0366
      J=1                                                               BUFF0367
  560 CONTINUE                                                          BUFF0368
      IF (K.LT.N1) GO TO 570                                            BUFF0369
      K=N1-1                                                            BUFF0370
  570 CONTINUE                                                          BUFF0371
      IF (K+2+J.LE.JMAX) GO TO 580                                      BUFF0372
      CALL PDMP (IBUF,J)                                                BUFF0373
      J=1                                                               BUFF0374
  580 IBUF(J)=1005                                                      BUFF0375
      IBUF(J+1)=K+1000                                                  BUFF0376
      J=J+2                                                             BUFF0377
      IF (K1.EQ.1) GO TO 590                                            BUFF0378
C  CONCATENATION CODE IS 3.                                             BUFF0379
C  SET IBUF(J) TO HEX 'F3' (DECIMAL '243')                              BUFF0380
      IBUF(J)=243                                                       BUFF0381
      K=K-1                                                             BUFF0382
      J=J+1                                                             BUFF0383
  590 K2=K+K1-1                                                         BUFF0384
      DO 600 I=K1,K2                                                    BUFF0385
         IBUF(J)=ICHAR(IDXX(I:I))                                       BUFF0386
         J=J+1                                                          BUFF0387
  600 CONTINUE                                                          BUFF0388
      IF (J.LE.JMAX) GO TO 610                                          BUFF0389
      CALL PDMP (IBUF,J)                                                BUFF0390
      J=1                                                               BUFF0391
  610 CONTINUE                                                          BUFF0392
      IF (K2.GE.IY) GO TO 999                                           BUFF0393
      K1=K2+1                                                           BUFF0394
      K=IY-K2+1                                                         BUFF0395
      GO TO 550                                                         BUFF0396
C                                                                       BUFF0397
C  MODE = 12; RETURN RADIX AND JMAX                                     BUFF0398
  620 CONTINUE                                                          BUFF0399
      IDX=N1                                                            BUFF0400
      IDY=JMAX                                                          BUFF0401
      GO TO 999                                                         BUFF0402
C                                                                       BUFF0403
C  THIS EXIT SHOULD NOT BE TAKEN (AN ERROR MAY HAVE OCURRED)            BUFF0404
  990 CONTINUE                                                          BUFF0405
C  STANDARD EXIT                                                        BUFF0406
  999 CONTINUE                                                          BUFF0407
      RETURN                                                            BUFF0408
      END                                                               BUFF0409
      SUBROUTINE PDMP (IBUF,JCNT)                                       PDMP0001
C. PDMP   FORTRAN 907, 951                               VER02 ZUPGA100 PDMP0002
C. DATA TYPE (EBCDIC, ASCII, ...)                                       PDMP0003
C. COMPUTER DEPENDENT                                                   PDMP0004
C. SITE DEPENDENT                                                       PDMP0005
C                                                                       PDMP0006
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       PDMP0008
C  LIBRARY FUNCTIONS USED (MOD)                                         PDMP0009
C  GRAPHICS ROUTINES USED - NONE                                        PDMP0010
C                                                                       PDMP0011
C  IF JCNT<0  --  IBUF(1) CONTAINS 'LDEV' (LOGICAL DEVICE) FOR 907      PDMP0012
C  IF JCNT=0  --  CHECK LAST TRANSMISSION AND FINISH                    PDMP0013
C  IF JCNT>1  --  SEND IBUF ARRAY TO 907 AFTER TRANSLATION              PDMP0014
C        JCNT-1 IS NUMBER OF ELEMENTS TO TRANSMIT                       PDMP0015
C                                                                       PDMP0016
C***LOC503 DIMENSION IASC(64) FOR CDC, HONEYWELL 6000 NON-ASCII AND     PDMP0017
C  UNIVAC FIELDATA                                                      PDMP0018
      DIMENSION IASC(128)                                               PDMP0020
C***LOC503 END.                                                         PDMP0021
C                                                                       PDMP0022
C     JAH  10/31/91
      character*1 BYTEBUFF (124)
      character*1 BYTESYNC(1), BYTEBIAS, BYTECSUM, BYTEEOB, 
     .BYTEBLANK
      DIMENSION IBUF(1)                                                 PDMP0023
C                                                                       PDMP0024
C***LOC606 DIMENSION FOR ICOD                                           PDMP0025
C  DIMENSION ICOD(36) FOR CDC;                                          PDMP0026
C  DIMENSION ICOD(64) FOR HONEYWELL BCD, UNIVAC FD AND UNIVAC V72;      PDMP0027
      DIMENSION ICOD(96)                                                PDMP0030
C***LOC606 END.                                                         PDMP0031
C                                                                       PDMP0032
C***LOC607 DIMENSION FOR IOBUFF, SAME AS IBUF IN BUFF SUBROUTINE        PDMP0033
ccc  JAH  10/29/91
      DIMENSION IOBUFF(124)                                             PDMP0035
C                                                                       PDMP0036
C     COMMON /CPDMP/ISYNC,IBIAS,IOBUFF,IEOB,ICNT,ITS,LDEVI,LDEVO,ISTAT, PDMP0037
C    1         ICOD,IASC,MBIAS,MEOB,MD                                  PDMP0038
C                                                                       PDMP0039
C***LOC608 SYNC CODE, BIAS AND END OF BLOCK CODE                        PDMP0040
C  ISYNC, IBIAS AND IEOB ARE SITE DEPENDENT                             PDMP0041
C  ISYNC = SYNC CODE; ISYNC = 2 OR 'STX' FOR ASCII AND EBCDIC COMPUTERS PDMP0042
C  SOME COMPUTERS NEED DOUBLE SYNC CODES                                PDMP0043
C  CDC: ISYNC=62,62; HONEYWELL: ISYNC=32,32; UNIVAC: ISYNC=38,38        PDMP0044
      DIMENSION ISYNC(1)                                                PDMP0045
      DATA ISYNC/ 2/                                                    PDMP0046
C                                                                       PDMP0047
C  IBIAS = BIAS CODE, USUALLY SET TO SPACE                              PDMP0054
C  ASCII COMPUTER: SPACE IS 32; EBCDIC COMPUTER: SPACE IS 64 (IBM, BUR) PDMP0055
C  IOBUFF = DATA (INITIALIZE TO SPACE) 125*N OR 70*N                    PDMP0056
C  IBIAS= 58 FOR CDC; 16 FOR HONEYWELL; 5 FOR UNIVAC FIELDATA           PDMP0057
C                                                                       PDMP0058
ccc  JAH  10/29/91
      DATA IBIAS/32/,IOBUFF/124*0/                                      PDMP0059
      DATA BYTEBUFF/124*'0'/
C                                                                       PDMP0065
C  IEOB = END OF  BLOCK; IEOB= 3 OR 'STX' FOR ASCII AND EBCDIC COMPUTER PDMP0066
C  IEOB = 60 FOR UNIVAC; NO IEOB IS REQUIRED FOR CDC AND HONEYWELL      PDMP0067
      DATA IEOB/ 3/                                                     PDMP0068
C***LOC608 END.                                                         PDMP0070
C                                                                       PDMP0071
C***LOC311 SAVE VARIABLE VALUE WHEN REENTERING THIS SUBROUTINE          PDMP0072
C  VARIABLE ISYNC(1) OR ISYNC(2) NEED TO BE SAVED ALSO (SEE LOC608)     PDMP0073
      DATA ICNT,ITS,LDEVI,LDEVO,ISTAT,MBIAS,MEOB,MD/1,0,1,1,0,0,0,0/    PDMP0074
C***LOC311 END.                                                         PDMP0075
C                                                                       PDMP0076
C***LOC504 ICOD TABLE                                                   PDMP0077
C                                                                       PDMP0078
C  DATA TRANSLATION TABLE FOR DELTAS (> 1000)                           PDMP0079
C 1A  THE FOLLOWING TABLE IS FOR EBCDIC COMPUTERS                       PDMP0080
C     (E.G. IBM 360, BURROUGH, XDSS7)                                   PDMP0081
C*    DATA ICOD/                                                        PDMP0082
C*   1  64, 90,127,123, 91,108, 80,125, 77, 93, 92, 78,107, 96, 75, 97, PDMP0083
C*   2 240,241,242,243,244,245,246,247,248,249,122, 94, 76,126,110,111, PDMP0084
C*   3 124,193,194,195,196,197,198,199,200,201,209,210,211,212,213,214, PDMP0085
C*   4 215,216,217,226,227,228,229,230,231,232,233, 74, 95,189, 79,109, PDMP0086
C*   5 121,129,130,131,132,133,134,135,136,137,145,146,147,148,149,150, PDMP0087
C*   6 151,152,153,162,163,164,165,166,167,168,169,139,106,155,161, 64/ PDMP0088
C                                                                       PDMP0089
C 1B  THE FOLLOWING TABLE IS FOR SOME SPECIAL IBM COMPUTERS             PDMP0090
C     (E.G. IBM 370 IN CALCOMP)                                         PDMP0091
C*    DATA ICOD/                                                        PDMP0092
C*   1  64, 90,127,123, 91,108, 80,125, 77, 93, 92, 78,107, 96, 75, 97, PDMP0093
C*   2 240,241,242,243,244,245,246,247,248,249,122, 94, 76,126,110,111, PDMP0094
C*   3 124,193,194,195,196,197,198,199,200,201,209,210,211,212,213,214, PDMP0095
C*   4 215,216,217,226,227,228,229,230,231,232,233,121,207, 73,176,109, PDMP0096
C*   5 191,129,130,131,132,133,134,135,136,137,145,146,147,148,149,150, PDMP0097
C*   6 151,152,153,162,163,164,165,166,167,168,169,139, 79,155, 95, 64/ PDMP0098
C                                                                       PDMP0099
C 2   THE FOLLOWING TABLE IS FOR ASCII COMPUTERS                        PDMP0100
      DATA ICOD/                                                        PDMP0101
     1  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, PDMP0102
     2  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, PDMP0103
     3  64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, PDMP0104
     4  80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, PDMP0105
     5  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111, PDMP0106
     6 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127/ PDMP0107
C                                                                       PDMP0108
C 3   FOR CDC COMPUTER - USE DIMENSION ICOD(36)                         PDMP0109
C*    DATA ICOD/                                                        PDMP0110
C*   1  58, 44, 59, 57, 60,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, PDMP0111
C*   2  12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 49, PDMP0112
C*   3  61, 50, 62, 53/                                                 PDMP0113
C                                                                       PDMP0114
C 4   FOR HONEYWELL 6000 COMPUTER - USE DIMENSION ICOD(64)              PDMP0115
C*    DATA ICOD/                                                        PDMP0116
C*   1  16, 63, 62, 11, 43, 60, 26, 47, 29, 45, 44, 48, 59, 42, 27, 49, PDMP0117
C*   2   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 13, 46, 30, 61, 14, 15, PDMP0118
C*   3  12, 17, 18, 19, 20, 21, 22, 23, 24, 25, 33, 34, 35, 36, 37, 38, PDMP0119
C*   4  39, 40, 41, 50, 51, 52, 53, 54, 55, 56, 57, 10, 31, 28, 32, 58/ PDMP0120
C                                                                       PDMP0121
C 5   FOR UNIVAC 1100 SERIES COMPUTER - USE DIMENSION ICOD(64)          PDMP0122
C*    DATA ICOD/                                                        PDMP0123
C*   1   5, 45, 62,  3, 39, 42, 38, 58, 41, 32, 40, 34, 46, 33, 61, 60, PDMP0124
C*   2  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 43, 59, 35, 36, 37, 44, PDMP0125
C*   3   0,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, PDMP0126
C*   4  21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,  1, 47,  2,  4,  5/ PDMP0127
C                                                                       PDMP0128
C 6   FOR UNIVAC V72 COMPUTER - USE DIMENSION ICOD(64)                  PDMP0129
C*    DATA ICOD/                                                        PDMP0130
C*   1 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175, PDMP0131
C*   2 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191, PDMP0132
C*   3 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207, PDMP0133
C*   4 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223/ PDMP0134
C                                                                       PDMP0135
C***LOC504 END.                                                         PDMP0136
C                                                                       PDMP0137
C***LOC505 IASC TABLE                                                   PDMP0138
C        SYMBOL TRANSLATION TABLE FOR SYMBOL STRINGS                    PDMP0139
C 1A  THE FOLLOWING TABLE IS FOR IBM 360, BURROUGHS OR XDSS7 (EBCDIC)   PDMP0140
      DATA IASC/                                                        PDMP0141
     1  64,129,130,131,132,133,134,135,136,137, 64,139, 64, 64, 64, 64, PDMP0142
     2  64,145,146,147,148,149,150,151,152,153, 64,155, 64, 64, 64, 64, PDMP0143
     3  64, 64,162,163,164,165,166,167,168,169, 64, 64, 64,173, 64, 64, PDMP0144
     4  64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,189, 64, 64, PDMP0145
     5  64,193,194,195,196,197,198,199,200,201, 74, 75, 76, 77, 78, 79, PDMP0146
     6  80,209,210,211,212,213,214,215,216,217, 90, 91, 92, 93, 94, 95, PDMP0147
     7  96, 97,226,227,228,229,230,231,232,233,106,107,108,109,110,111, PDMP0148
     8 240,241,242,243,244,245,246,247,248,249,122,123,124,125,126,127/ PDMP0149
C                                                                       PDMP0150
C 1B  THE FOLLOWING TABLE IS FOR SOME SPECIAL IBM COMPUTERS             PDMP0151
C     (E.G. IBM 370 IN CALCOMP)                                         PDMP0152
C*    DATA IASC/                                                        PDMP0153
C*   1  64,129,130,131,132,133,134,135,136,137, 64,139, 64, 64, 64, 64, PDMP0154
C*   2  64,145,146,147,148,149,150,151,152,153, 64,155, 64, 64, 64, 64, PDMP0155
C*   3  64, 64,162,163,164,165,166,167,168,169, 64, 64, 64,173, 64, 64, PDMP0156
C*   4  64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, PDMP0157
C*   5  64,193,194,195,196,197,198,199,200,201, 64, 75, 76, 77, 78,176, PDMP0158
C*   6  80,209,210,211,212,213,214,215,216,217, 90, 91, 92, 93, 94,207, PDMP0159
C*   7  96, 97,226,227,228,229,230,231,232,233, 64,107,108,109,110,111, PDMP0160
C*   8 240,241,242,243,244,245,246,247,248,249,122,123,124,125,126,127/ PDMP0161
C                                                                       PDMP0162
C 2   ASCII COMPUTERS DO NOT NEED IASC TABLE                            PDMP0163
C                                                                       PDMP0164
C 3   THE FOLLOWING TABLE IS FOR HONEYWELL 6000 COMPUTERS (NON-ASCII),  PDMP0165
C     FOR CDC: REPLACE 1ST NUMBER '0' WITH '45',                        PDMP0166
C     FOR UNIVAC FIELDDATA: REPLACE LAST NUMBER '63' WITH '5'.          PDMP0167
C     USE DIMENSION IASC(64)                                            PDMP0168
C*    DATA IASC/                                                        PDMP0169
C*   1   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, PDMP0170
C*   2  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, PDMP0171
C*   3  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, PDMP0172
C*   4  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63/ PDMP0173
C                                                                       PDMP0174
C***LOC505 END.                                                         PDMP0175
C                                                                       PDMP0176
      IF (JCNT.GE.0) GO TO 10                                           PDMP0177
C                                                                       PDMP0178
C  SET LDEVI (INPUT) AND LDEVO (OUTPUT) FOR FUTURE OPERATIONS           PDMP0179
C  IF LDEVI AND LDEVO MUST BE DIFFERENT, THEN TRY LDEVI=LDEVO-1         PDMP0180
       LDEVO=IBUF(1)                                                    PDMP0181
ccc JAH  10/29/91
      OPEN (UNIT=LDEVO, STATUS='NEW', FILE='calcomp',
     &      ACCESS='SEQUENTIAL', FORM='UNFORMATTED')
C                                                                       PDMP0183
      ITEMP=MSHFT(ISYNC(1))                                             PDMP0184
C                                                                       PDMP0185
C***LOC610 SYNC CODE                                                    PDMP0186
      ISYNC(1)=ITEMP                                                    PDMP0187
C                                                                       PDMP0189
      MBIAS=MSHFT(IBIAS)                                                PDMP0190
      MD=MBIAS                                                          PDMP0191
      MEOB=MSHFT(IEOB)                                                  PDMP0192
      GO TO 99                                                          PDMP0193
C                                                                       PDMP0194
   10 CONTINUE                                                          PDMP0195
      IF (ITS.LE.0) GO TO 30                                            PDMP0196
   20 ITS=-1                                                            PDMP0197
C                                                                       PDMP0198
C  CHECK STATUS CODE: (ISTAT=0 GOOD; ISTAT=1 BAD, RE-TRANSMIT)          PDMP0206
C                                                                       PDMP0207
C***LOC623 DIRECT CONTROL MODE OR XON/XOFF, COMMENT OUT THE READ STAT.  PDMP0208
ccc JAH  10/28/91
      ISTAT = 0
      IF (ISTAT.EQ.0) GO TO 30                                          PDMP0210
      BYTESYNC(1) = CHAR(ISYNC(1))
      BYTEBIAS = char(MBIAS)
      BYTECSUM = char(MCSUM)
      BYTEEOB  = char(MEOB)
      BYTEBLANK = char(32)
      DO 97 I = 1,124
           BYTEBUFF(I) = char(IOBUFF(I))
   97 CONTINUE
      WRITE (LDEVO) BYTEBLANK, BYTESYNC(1), BYTEBIAS,
     &                  (BYTEBUFF(I),I=1,ICNT),
     &                  BYTEEOB
      DO 96 I = 1,124
           IOBUFF(I) = 0
           BYTEBUFF(I) = char(0)
   96 CONTINUE
C                                                                       PDMP0222
      GO TO 20                                                          PDMP0223
C                                                                       PDMP0224
C  STUFF THE BUFFER, TRANSLATING MARKED CHARS.                          PDMP0225
C                                                                       PDMP0226
   30 CONTINUE                                                          PDMP0227
      IF (JCNT.LE.1) GO TO 99                                           PDMP0228
      ICNT=JCNT-1                                                       PDMP0229
      ICSUM=0                                                           PDMP0230
      DO 60 I=1,ICNT                                                    PDMP0231
         NCD=IBUF(I)                                                    PDMP0232
         IF (NCD.LE.999) GO TO 40                                       PDMP0233
C                                                                       PDMP0234
C  OFFSET TO CHARACTER PARTITION (USE ICOD TABLE)                       PDMP0235
C                                                                       PDMP0236
         ITEMP=MOD(NCD-1000,96)                                         PDMP0237
         NCD=ICOD(ITEMP+1)                                              PDMP0238
         GO TO 50                                                       PDMP0239
   40    CONTINUE                                                       PDMP0240
C                                                                       PDMP0241
C                                                                       PDMP0246
   50    CONTINUE                                                       PDMP0247
         ICSUM=ICSUM+NCD                                                PDMP0248
         IOBUFF(I)=MSHFT(NCD)                                           PDMP0249
   60 CONTINUE                                                          PDMP0250
      ITEMP=96-MOD(ICSUM,32)                                            PDMP0251
      MCSUM=MSHFT(ITEMP)                                                PDMP0252
C                                                                       PDMP0253
      BYTESYNC(1) = char(ISYNC(1))
      BYTEBIAS = char(MBIAS)
      BYTECSUM = char(MCSUM)
      BYTEEOB  = char(MEOB)
      BYTEBLANK = char(32)
      DO 98 I = 1,124
           BYTEBUFF(I) = char(IOBUFF(I))
   98 CONTINUE
      WRITE (LDEVO) BYTEBLANK, BYTESYNC(1), BYTEBIAS,
     &                  (BYTEBUFF(I),I=1,ICNT),
     &                  BYTEEOB
      DO 95 I = 1,124
           IOBUFF(I) = 0
           BYTEBUFF(I) = char(0)
   95 CONTINUE
C                                                                       PDMP0264
      IF (ITS) 80,70,99                                                 PDMP0265
C                                                                       PDMP0266
C  WRITE START PLOT MESSAGE TO TERMINAL                                 PDMP0267
C                                                                       PDMP0268
ccc JAH  10/28/91
   70 CONTINUE
   80 ITS=1                                                             PDMP0270
C                                                                       PDMP0271
  100 FORMAT (I1)                                                       PDMP0272
C                                                                       PDMP0273
ccc JAH  10/29/91
  110 FORMAT (' ',128A1)
   99 CONTINUE                                                          PDMP0283
      RETURN                                                            PDMP0284
      END                                                               PDMP0285
      FUNCTION MSHFT (INCD)                                             MSHF0001
C. MSHFT  FIV     907, 951                               VER01 ZUPGB100 MSHF0002
C. COMPUTER DEPENDENT                                                   MSHF0003
C                                                                       MSHF0004
C THIS SOFTWARE  IS THE PROPRIETARY PROPERTY OF  CALCOMP INC.  AND IS    COPYR01
C LICENSED  FOR USE  ON THE DESIGNATED EQUIPMENT  ON WHICH  IT WAS       COPYR02
C ORIGINALLY INSTALLED AND CANNOT BE MODIFIED, DUPLICATED OR COPIED IN   COPYR03
C ANY FORM WITHOUT PRIOR WRITTEN CONSENT OF CALCOMP INC..  IF SUPPLIED   COPYR04
C UNDER A GOVERNMENT CONTRACT,THE FOLLOWING APPLIES: 'RESTRICTED RIGHTS  COPYR05
C LEGEND' USE, DUPLICATION OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT    COPYR06
C TO RESTRICTIONS AS SET FORTH IN PARAGRAPH (B)(3)(B) OF THE RIGHTS IN   COPYR07
C TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE IN DAR 7-104.9(A).         COPYR08
C CALCOMP INC., 2411 WEST LA PALMA AVENUE, ANAHEIM, CALIFORNIA 92803.    COPYR09
C                                                                       MSHF0006
C  LIBRARY FUNCTIONS USED - NONE                                        MSHF0007
C  GRAPHICS ROUTINES USED - NONE                                        MSHF0008
C                                                                       MSHF0009
C***LOC615 (RELATED TO CODE IN SUBROUTINE PDMP) SHIFT TO HIGHER BYTE    MSHF0010
ccc JAH  10/31/91
      DATA ISBIT / 0/, IBITS /        1/                                MSHF0012
C                                                                       MSHF0015
      MSHFT=INCD*IBITS                                                  MSHF0016
      RETURN                                                            MSHF0029
      END                                                               MSHF0030
